// Copyright 2012-2018 The Rust Project Developers. See the COPYRIGHT
// file at the top-level directory of this distribution and at
// http://rust-lang.org/COPYRIGHT.
//
// Licensed under the Apache License, Version 2.0 <LICENSE-APACHE or
// http://www.apache.org/licenses/LICENSE-2.0> or the MIT license
// <LICENSE-MIT or http://opensource.org/licenses/MIT>, at your
// option. This file may not be copied, modified, or distributed
// except according to those terms.

// NOTE: The following code was generated by "scripts/unicode.py", do not edit directly

#![allow(missing_docs)]
#[derive(Debug)]
pub struct NormalizationTest {
    pub source: &'static str,
    pub nfc: &'static str,
    pub nfd: &'static str,
    pub nfkc: &'static str,
    pub nfkd: &'static str,
}

pub const NORMALIZATION_TESTS: &[NormalizationTest] = &[
    NormalizationTest {
        source: "\u{1E0A}",
        nfc: "\u{1E0A}",
        nfd: "\u{0044}\u{0307}",
        nfkc: "\u{1E0A}",
        nfkd: "\u{0044}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E0C}",
        nfc: "\u{1E0C}",
        nfd: "\u{0044}\u{0323}",
        nfkc: "\u{1E0C}",
        nfkd: "\u{0044}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E0A}\u{0323}",
        nfc: "\u{1E0C}\u{0307}",
        nfd: "\u{0044}\u{0323}\u{0307}",
        nfkc: "\u{1E0C}\u{0307}",
        nfkd: "\u{0044}\u{0323}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E0C}\u{0307}",
        nfc: "\u{1E0C}\u{0307}",
        nfd: "\u{0044}\u{0323}\u{0307}",
        nfkc: "\u{1E0C}\u{0307}",
        nfkd: "\u{0044}\u{0323}\u{0307}",
    },
    NormalizationTest {
        source: "\u{0044}\u{0307}\u{0323}",
        nfc: "\u{1E0C}\u{0307}",
        nfd: "\u{0044}\u{0323}\u{0307}",
        nfkc: "\u{1E0C}\u{0307}",
        nfkd: "\u{0044}\u{0323}\u{0307}",
    },
    NormalizationTest {
        source: "\u{0044}\u{0323}\u{0307}",
        nfc: "\u{1E0C}\u{0307}",
        nfd: "\u{0044}\u{0323}\u{0307}",
        nfkc: "\u{1E0C}\u{0307}",
        nfkd: "\u{0044}\u{0323}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E0A}\u{031B}",
        nfc: "\u{1E0A}\u{031B}",
        nfd: "\u{0044}\u{031B}\u{0307}",
        nfkc: "\u{1E0A}\u{031B}",
        nfkd: "\u{0044}\u{031B}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E0C}\u{031B}",
        nfc: "\u{1E0C}\u{031B}",
        nfd: "\u{0044}\u{031B}\u{0323}",
        nfkc: "\u{1E0C}\u{031B}",
        nfkd: "\u{0044}\u{031B}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E0A}\u{031B}\u{0323}",
        nfc: "\u{1E0C}\u{031B}\u{0307}",
        nfd: "\u{0044}\u{031B}\u{0323}\u{0307}",
        nfkc: "\u{1E0C}\u{031B}\u{0307}",
        nfkd: "\u{0044}\u{031B}\u{0323}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E0C}\u{031B}\u{0307}",
        nfc: "\u{1E0C}\u{031B}\u{0307}",
        nfd: "\u{0044}\u{031B}\u{0323}\u{0307}",
        nfkc: "\u{1E0C}\u{031B}\u{0307}",
        nfkd: "\u{0044}\u{031B}\u{0323}\u{0307}",
    },
    NormalizationTest {
        source: "\u{0044}\u{031B}\u{0307}\u{0323}",
        nfc: "\u{1E0C}\u{031B}\u{0307}",
        nfd: "\u{0044}\u{031B}\u{0323}\u{0307}",
        nfkc: "\u{1E0C}\u{031B}\u{0307}",
        nfkd: "\u{0044}\u{031B}\u{0323}\u{0307}",
    },
    NormalizationTest {
        source: "\u{0044}\u{031B}\u{0323}\u{0307}",
        nfc: "\u{1E0C}\u{031B}\u{0307}",
        nfd: "\u{0044}\u{031B}\u{0323}\u{0307}",
        nfkc: "\u{1E0C}\u{031B}\u{0307}",
        nfkd: "\u{0044}\u{031B}\u{0323}\u{0307}",
    },
    NormalizationTest {
        source: "\u{00C8}",
        nfc: "\u{00C8}",
        nfd: "\u{0045}\u{0300}",
        nfkc: "\u{00C8}",
        nfkd: "\u{0045}\u{0300}",
    },
    NormalizationTest {
        source: "\u{0112}",
        nfc: "\u{0112}",
        nfd: "\u{0045}\u{0304}",
        nfkc: "\u{0112}",
        nfkd: "\u{0045}\u{0304}",
    },
    NormalizationTest {
        source: "\u{0045}\u{0300}",
        nfc: "\u{00C8}",
        nfd: "\u{0045}\u{0300}",
        nfkc: "\u{00C8}",
        nfkd: "\u{0045}\u{0300}",
    },
    NormalizationTest {
        source: "\u{0045}\u{0304}",
        nfc: "\u{0112}",
        nfd: "\u{0045}\u{0304}",
        nfkc: "\u{0112}",
        nfkd: "\u{0045}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1E14}",
        nfc: "\u{1E14}",
        nfd: "\u{0045}\u{0304}\u{0300}",
        nfkc: "\u{1E14}",
        nfkd: "\u{0045}\u{0304}\u{0300}",
    },
    NormalizationTest {
        source: "\u{0112}\u{0300}",
        nfc: "\u{1E14}",
        nfd: "\u{0045}\u{0304}\u{0300}",
        nfkc: "\u{1E14}",
        nfkd: "\u{0045}\u{0304}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1E14}\u{0304}",
        nfc: "\u{1E14}\u{0304}",
        nfd: "\u{0045}\u{0304}\u{0300}\u{0304}",
        nfkc: "\u{1E14}\u{0304}",
        nfkd: "\u{0045}\u{0304}\u{0300}\u{0304}",
    },
    NormalizationTest {
        source: "\u{0045}\u{0304}\u{0300}",
        nfc: "\u{1E14}",
        nfd: "\u{0045}\u{0304}\u{0300}",
        nfkc: "\u{1E14}",
        nfkd: "\u{0045}\u{0304}\u{0300}",
    },
    NormalizationTest {
        source: "\u{0045}\u{0300}\u{0304}",
        nfc: "\u{00C8}\u{0304}",
        nfd: "\u{0045}\u{0300}\u{0304}",
        nfkc: "\u{00C8}\u{0304}",
        nfkd: "\u{0045}\u{0300}\u{0304}",
    },
    NormalizationTest {
        source: "\u{05B8}\u{05B9}\u{05B1}\u{0591}\u{05C3}\u{05B0}\u{05AC}\u{059F}",
        nfc: "\u{05B1}\u{05B8}\u{05B9}\u{0591}\u{05C3}\u{05B0}\u{05AC}\u{059F}",
        nfd: "\u{05B1}\u{05B8}\u{05B9}\u{0591}\u{05C3}\u{05B0}\u{05AC}\u{059F}",
        nfkc: "\u{05B1}\u{05B8}\u{05B9}\u{0591}\u{05C3}\u{05B0}\u{05AC}\u{059F}",
        nfkd: "\u{05B1}\u{05B8}\u{05B9}\u{0591}\u{05C3}\u{05B0}\u{05AC}\u{059F}",
    },
    NormalizationTest {
        source: "\u{0592}\u{05B7}\u{05BC}\u{05A5}\u{05B0}\u{05C0}\u{05C4}\u{05AD}",
        nfc: "\u{05B0}\u{05B7}\u{05BC}\u{05A5}\u{0592}\u{05C0}\u{05AD}\u{05C4}",
        nfd: "\u{05B0}\u{05B7}\u{05BC}\u{05A5}\u{0592}\u{05C0}\u{05AD}\u{05C4}",
        nfkc: "\u{05B0}\u{05B7}\u{05BC}\u{05A5}\u{0592}\u{05C0}\u{05AD}\u{05C4}",
        nfkd: "\u{05B0}\u{05B7}\u{05BC}\u{05A5}\u{0592}\u{05C0}\u{05AD}\u{05C4}",
    },
    NormalizationTest {
        source: "\u{1100}\u{AC00}\u{11A8}",
        nfc: "\u{1100}\u{AC01}",
        nfd: "\u{1100}\u{1100}\u{1161}\u{11A8}",
        nfkc: "\u{1100}\u{AC01}",
        nfkd: "\u{1100}\u{1100}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{1100}\u{AC00}\u{11A8}\u{11A8}",
        nfc: "\u{1100}\u{AC01}\u{11A8}",
        nfd: "\u{1100}\u{1100}\u{1161}\u{11A8}\u{11A8}",
        nfkc: "\u{1100}\u{AC01}\u{11A8}",
        nfkd: "\u{1100}\u{1100}\u{1161}\u{11A8}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{00A0}",
        nfc: "\u{00A0}",
        nfd: "\u{00A0}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{00A8}",
        nfc: "\u{00A8}",
        nfd: "\u{00A8}",
        nfkc: "\u{0020}\u{0308}",
        nfkd: "\u{0020}\u{0308}",
    },
    NormalizationTest {
        source: "\u{00AA}",
        nfc: "\u{00AA}",
        nfd: "\u{00AA}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{00AF}",
        nfc: "\u{00AF}",
        nfd: "\u{00AF}",
        nfkc: "\u{0020}\u{0304}",
        nfkd: "\u{0020}\u{0304}",
    },
    NormalizationTest {
        source: "\u{00B2}",
        nfc: "\u{00B2}",
        nfd: "\u{00B2}",
        nfkc: "\u{0032}",
        nfkd: "\u{0032}",
    },
    NormalizationTest {
        source: "\u{00B3}",
        nfc: "\u{00B3}",
        nfd: "\u{00B3}",
        nfkc: "\u{0033}",
        nfkd: "\u{0033}",
    },
    NormalizationTest {
        source: "\u{00B4}",
        nfc: "\u{00B4}",
        nfd: "\u{00B4}",
        nfkc: "\u{0020}\u{0301}",
        nfkd: "\u{0020}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00B5}",
        nfc: "\u{00B5}",
        nfd: "\u{00B5}",
        nfkc: "\u{03BC}",
        nfkd: "\u{03BC}",
    },
    NormalizationTest {
        source: "\u{00B8}",
        nfc: "\u{00B8}",
        nfd: "\u{00B8}",
        nfkc: "\u{0020}\u{0327}",
        nfkd: "\u{0020}\u{0327}",
    },
    NormalizationTest {
        source: "\u{00B9}",
        nfc: "\u{00B9}",
        nfd: "\u{00B9}",
        nfkc: "\u{0031}",
        nfkd: "\u{0031}",
    },
    NormalizationTest {
        source: "\u{00BA}",
        nfc: "\u{00BA}",
        nfd: "\u{00BA}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{00BC}",
        nfc: "\u{00BC}",
        nfd: "\u{00BC}",
        nfkc: "\u{0031}\u{2044}\u{0034}",
        nfkd: "\u{0031}\u{2044}\u{0034}",
    },
    NormalizationTest {
        source: "\u{00BD}",
        nfc: "\u{00BD}",
        nfd: "\u{00BD}",
        nfkc: "\u{0031}\u{2044}\u{0032}",
        nfkd: "\u{0031}\u{2044}\u{0032}",
    },
    NormalizationTest {
        source: "\u{00BE}",
        nfc: "\u{00BE}",
        nfd: "\u{00BE}",
        nfkc: "\u{0033}\u{2044}\u{0034}",
        nfkd: "\u{0033}\u{2044}\u{0034}",
    },
    NormalizationTest {
        source: "\u{00C0}",
        nfc: "\u{00C0}",
        nfd: "\u{0041}\u{0300}",
        nfkc: "\u{00C0}",
        nfkd: "\u{0041}\u{0300}",
    },
    NormalizationTest {
        source: "\u{00C1}",
        nfc: "\u{00C1}",
        nfd: "\u{0041}\u{0301}",
        nfkc: "\u{00C1}",
        nfkd: "\u{0041}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00C2}",
        nfc: "\u{00C2}",
        nfd: "\u{0041}\u{0302}",
        nfkc: "\u{00C2}",
        nfkd: "\u{0041}\u{0302}",
    },
    NormalizationTest {
        source: "\u{00C3}",
        nfc: "\u{00C3}",
        nfd: "\u{0041}\u{0303}",
        nfkc: "\u{00C3}",
        nfkd: "\u{0041}\u{0303}",
    },
    NormalizationTest {
        source: "\u{00C4}",
        nfc: "\u{00C4}",
        nfd: "\u{0041}\u{0308}",
        nfkc: "\u{00C4}",
        nfkd: "\u{0041}\u{0308}",
    },
    NormalizationTest {
        source: "\u{00C5}",
        nfc: "\u{00C5}",
        nfd: "\u{0041}\u{030A}",
        nfkc: "\u{00C5}",
        nfkd: "\u{0041}\u{030A}",
    },
    NormalizationTest {
        source: "\u{00C7}",
        nfc: "\u{00C7}",
        nfd: "\u{0043}\u{0327}",
        nfkc: "\u{00C7}",
        nfkd: "\u{0043}\u{0327}",
    },
    NormalizationTest {
        source: "\u{00C8}",
        nfc: "\u{00C8}",
        nfd: "\u{0045}\u{0300}",
        nfkc: "\u{00C8}",
        nfkd: "\u{0045}\u{0300}",
    },
    NormalizationTest {
        source: "\u{00C9}",
        nfc: "\u{00C9}",
        nfd: "\u{0045}\u{0301}",
        nfkc: "\u{00C9}",
        nfkd: "\u{0045}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00CA}",
        nfc: "\u{00CA}",
        nfd: "\u{0045}\u{0302}",
        nfkc: "\u{00CA}",
        nfkd: "\u{0045}\u{0302}",
    },
    NormalizationTest {
        source: "\u{00CB}",
        nfc: "\u{00CB}",
        nfd: "\u{0045}\u{0308}",
        nfkc: "\u{00CB}",
        nfkd: "\u{0045}\u{0308}",
    },
    NormalizationTest {
        source: "\u{00CC}",
        nfc: "\u{00CC}",
        nfd: "\u{0049}\u{0300}",
        nfkc: "\u{00CC}",
        nfkd: "\u{0049}\u{0300}",
    },
    NormalizationTest {
        source: "\u{00CD}",
        nfc: "\u{00CD}",
        nfd: "\u{0049}\u{0301}",
        nfkc: "\u{00CD}",
        nfkd: "\u{0049}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00CE}",
        nfc: "\u{00CE}",
        nfd: "\u{0049}\u{0302}",
        nfkc: "\u{00CE}",
        nfkd: "\u{0049}\u{0302}",
    },
    NormalizationTest {
        source: "\u{00CF}",
        nfc: "\u{00CF}",
        nfd: "\u{0049}\u{0308}",
        nfkc: "\u{00CF}",
        nfkd: "\u{0049}\u{0308}",
    },
    NormalizationTest {
        source: "\u{00D1}",
        nfc: "\u{00D1}",
        nfd: "\u{004E}\u{0303}",
        nfkc: "\u{00D1}",
        nfkd: "\u{004E}\u{0303}",
    },
    NormalizationTest {
        source: "\u{00D2}",
        nfc: "\u{00D2}",
        nfd: "\u{004F}\u{0300}",
        nfkc: "\u{00D2}",
        nfkd: "\u{004F}\u{0300}",
    },
    NormalizationTest {
        source: "\u{00D3}",
        nfc: "\u{00D3}",
        nfd: "\u{004F}\u{0301}",
        nfkc: "\u{00D3}",
        nfkd: "\u{004F}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00D4}",
        nfc: "\u{00D4}",
        nfd: "\u{004F}\u{0302}",
        nfkc: "\u{00D4}",
        nfkd: "\u{004F}\u{0302}",
    },
    NormalizationTest {
        source: "\u{00D5}",
        nfc: "\u{00D5}",
        nfd: "\u{004F}\u{0303}",
        nfkc: "\u{00D5}",
        nfkd: "\u{004F}\u{0303}",
    },
    NormalizationTest {
        source: "\u{00D6}",
        nfc: "\u{00D6}",
        nfd: "\u{004F}\u{0308}",
        nfkc: "\u{00D6}",
        nfkd: "\u{004F}\u{0308}",
    },
    NormalizationTest {
        source: "\u{00D9}",
        nfc: "\u{00D9}",
        nfd: "\u{0055}\u{0300}",
        nfkc: "\u{00D9}",
        nfkd: "\u{0055}\u{0300}",
    },
    NormalizationTest {
        source: "\u{00DA}",
        nfc: "\u{00DA}",
        nfd: "\u{0055}\u{0301}",
        nfkc: "\u{00DA}",
        nfkd: "\u{0055}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00DB}",
        nfc: "\u{00DB}",
        nfd: "\u{0055}\u{0302}",
        nfkc: "\u{00DB}",
        nfkd: "\u{0055}\u{0302}",
    },
    NormalizationTest {
        source: "\u{00DC}",
        nfc: "\u{00DC}",
        nfd: "\u{0055}\u{0308}",
        nfkc: "\u{00DC}",
        nfkd: "\u{0055}\u{0308}",
    },
    NormalizationTest {
        source: "\u{00DD}",
        nfc: "\u{00DD}",
        nfd: "\u{0059}\u{0301}",
        nfkc: "\u{00DD}",
        nfkd: "\u{0059}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00E0}",
        nfc: "\u{00E0}",
        nfd: "\u{0061}\u{0300}",
        nfkc: "\u{00E0}",
        nfkd: "\u{0061}\u{0300}",
    },
    NormalizationTest {
        source: "\u{00E1}",
        nfc: "\u{00E1}",
        nfd: "\u{0061}\u{0301}",
        nfkc: "\u{00E1}",
        nfkd: "\u{0061}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00E2}",
        nfc: "\u{00E2}",
        nfd: "\u{0061}\u{0302}",
        nfkc: "\u{00E2}",
        nfkd: "\u{0061}\u{0302}",
    },
    NormalizationTest {
        source: "\u{00E3}",
        nfc: "\u{00E3}",
        nfd: "\u{0061}\u{0303}",
        nfkc: "\u{00E3}",
        nfkd: "\u{0061}\u{0303}",
    },
    NormalizationTest {
        source: "\u{00E4}",
        nfc: "\u{00E4}",
        nfd: "\u{0061}\u{0308}",
        nfkc: "\u{00E4}",
        nfkd: "\u{0061}\u{0308}",
    },
    NormalizationTest {
        source: "\u{00E5}",
        nfc: "\u{00E5}",
        nfd: "\u{0061}\u{030A}",
        nfkc: "\u{00E5}",
        nfkd: "\u{0061}\u{030A}",
    },
    NormalizationTest {
        source: "\u{00E7}",
        nfc: "\u{00E7}",
        nfd: "\u{0063}\u{0327}",
        nfkc: "\u{00E7}",
        nfkd: "\u{0063}\u{0327}",
    },
    NormalizationTest {
        source: "\u{00E8}",
        nfc: "\u{00E8}",
        nfd: "\u{0065}\u{0300}",
        nfkc: "\u{00E8}",
        nfkd: "\u{0065}\u{0300}",
    },
    NormalizationTest {
        source: "\u{00E9}",
        nfc: "\u{00E9}",
        nfd: "\u{0065}\u{0301}",
        nfkc: "\u{00E9}",
        nfkd: "\u{0065}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00EA}",
        nfc: "\u{00EA}",
        nfd: "\u{0065}\u{0302}",
        nfkc: "\u{00EA}",
        nfkd: "\u{0065}\u{0302}",
    },
    NormalizationTest {
        source: "\u{00EB}",
        nfc: "\u{00EB}",
        nfd: "\u{0065}\u{0308}",
        nfkc: "\u{00EB}",
        nfkd: "\u{0065}\u{0308}",
    },
    NormalizationTest {
        source: "\u{00EC}",
        nfc: "\u{00EC}",
        nfd: "\u{0069}\u{0300}",
        nfkc: "\u{00EC}",
        nfkd: "\u{0069}\u{0300}",
    },
    NormalizationTest {
        source: "\u{00ED}",
        nfc: "\u{00ED}",
        nfd: "\u{0069}\u{0301}",
        nfkc: "\u{00ED}",
        nfkd: "\u{0069}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00EE}",
        nfc: "\u{00EE}",
        nfd: "\u{0069}\u{0302}",
        nfkc: "\u{00EE}",
        nfkd: "\u{0069}\u{0302}",
    },
    NormalizationTest {
        source: "\u{00EF}",
        nfc: "\u{00EF}",
        nfd: "\u{0069}\u{0308}",
        nfkc: "\u{00EF}",
        nfkd: "\u{0069}\u{0308}",
    },
    NormalizationTest {
        source: "\u{00F1}",
        nfc: "\u{00F1}",
        nfd: "\u{006E}\u{0303}",
        nfkc: "\u{00F1}",
        nfkd: "\u{006E}\u{0303}",
    },
    NormalizationTest {
        source: "\u{00F2}",
        nfc: "\u{00F2}",
        nfd: "\u{006F}\u{0300}",
        nfkc: "\u{00F2}",
        nfkd: "\u{006F}\u{0300}",
    },
    NormalizationTest {
        source: "\u{00F3}",
        nfc: "\u{00F3}",
        nfd: "\u{006F}\u{0301}",
        nfkc: "\u{00F3}",
        nfkd: "\u{006F}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00F4}",
        nfc: "\u{00F4}",
        nfd: "\u{006F}\u{0302}",
        nfkc: "\u{00F4}",
        nfkd: "\u{006F}\u{0302}",
    },
    NormalizationTest {
        source: "\u{00F5}",
        nfc: "\u{00F5}",
        nfd: "\u{006F}\u{0303}",
        nfkc: "\u{00F5}",
        nfkd: "\u{006F}\u{0303}",
    },
    NormalizationTest {
        source: "\u{00F6}",
        nfc: "\u{00F6}",
        nfd: "\u{006F}\u{0308}",
        nfkc: "\u{00F6}",
        nfkd: "\u{006F}\u{0308}",
    },
    NormalizationTest {
        source: "\u{00F9}",
        nfc: "\u{00F9}",
        nfd: "\u{0075}\u{0300}",
        nfkc: "\u{00F9}",
        nfkd: "\u{0075}\u{0300}",
    },
    NormalizationTest {
        source: "\u{00FA}",
        nfc: "\u{00FA}",
        nfd: "\u{0075}\u{0301}",
        nfkc: "\u{00FA}",
        nfkd: "\u{0075}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00FB}",
        nfc: "\u{00FB}",
        nfd: "\u{0075}\u{0302}",
        nfkc: "\u{00FB}",
        nfkd: "\u{0075}\u{0302}",
    },
    NormalizationTest {
        source: "\u{00FC}",
        nfc: "\u{00FC}",
        nfd: "\u{0075}\u{0308}",
        nfkc: "\u{00FC}",
        nfkd: "\u{0075}\u{0308}",
    },
    NormalizationTest {
        source: "\u{00FD}",
        nfc: "\u{00FD}",
        nfd: "\u{0079}\u{0301}",
        nfkc: "\u{00FD}",
        nfkd: "\u{0079}\u{0301}",
    },
    NormalizationTest {
        source: "\u{00FF}",
        nfc: "\u{00FF}",
        nfd: "\u{0079}\u{0308}",
        nfkc: "\u{00FF}",
        nfkd: "\u{0079}\u{0308}",
    },
    NormalizationTest {
        source: "\u{0100}",
        nfc: "\u{0100}",
        nfd: "\u{0041}\u{0304}",
        nfkc: "\u{0100}",
        nfkd: "\u{0041}\u{0304}",
    },
    NormalizationTest {
        source: "\u{0101}",
        nfc: "\u{0101}",
        nfd: "\u{0061}\u{0304}",
        nfkc: "\u{0101}",
        nfkd: "\u{0061}\u{0304}",
    },
    NormalizationTest {
        source: "\u{0102}",
        nfc: "\u{0102}",
        nfd: "\u{0041}\u{0306}",
        nfkc: "\u{0102}",
        nfkd: "\u{0041}\u{0306}",
    },
    NormalizationTest {
        source: "\u{0103}",
        nfc: "\u{0103}",
        nfd: "\u{0061}\u{0306}",
        nfkc: "\u{0103}",
        nfkd: "\u{0061}\u{0306}",
    },
    NormalizationTest {
        source: "\u{0104}",
        nfc: "\u{0104}",
        nfd: "\u{0041}\u{0328}",
        nfkc: "\u{0104}",
        nfkd: "\u{0041}\u{0328}",
    },
    NormalizationTest {
        source: "\u{0105}",
        nfc: "\u{0105}",
        nfd: "\u{0061}\u{0328}",
        nfkc: "\u{0105}",
        nfkd: "\u{0061}\u{0328}",
    },
    NormalizationTest {
        source: "\u{0106}",
        nfc: "\u{0106}",
        nfd: "\u{0043}\u{0301}",
        nfkc: "\u{0106}",
        nfkd: "\u{0043}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0107}",
        nfc: "\u{0107}",
        nfd: "\u{0063}\u{0301}",
        nfkc: "\u{0107}",
        nfkd: "\u{0063}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0108}",
        nfc: "\u{0108}",
        nfd: "\u{0043}\u{0302}",
        nfkc: "\u{0108}",
        nfkd: "\u{0043}\u{0302}",
    },
    NormalizationTest {
        source: "\u{0109}",
        nfc: "\u{0109}",
        nfd: "\u{0063}\u{0302}",
        nfkc: "\u{0109}",
        nfkd: "\u{0063}\u{0302}",
    },
    NormalizationTest {
        source: "\u{010A}",
        nfc: "\u{010A}",
        nfd: "\u{0043}\u{0307}",
        nfkc: "\u{010A}",
        nfkd: "\u{0043}\u{0307}",
    },
    NormalizationTest {
        source: "\u{010B}",
        nfc: "\u{010B}",
        nfd: "\u{0063}\u{0307}",
        nfkc: "\u{010B}",
        nfkd: "\u{0063}\u{0307}",
    },
    NormalizationTest {
        source: "\u{010C}",
        nfc: "\u{010C}",
        nfd: "\u{0043}\u{030C}",
        nfkc: "\u{010C}",
        nfkd: "\u{0043}\u{030C}",
    },
    NormalizationTest {
        source: "\u{010D}",
        nfc: "\u{010D}",
        nfd: "\u{0063}\u{030C}",
        nfkc: "\u{010D}",
        nfkd: "\u{0063}\u{030C}",
    },
    NormalizationTest {
        source: "\u{010E}",
        nfc: "\u{010E}",
        nfd: "\u{0044}\u{030C}",
        nfkc: "\u{010E}",
        nfkd: "\u{0044}\u{030C}",
    },
    NormalizationTest {
        source: "\u{010F}",
        nfc: "\u{010F}",
        nfd: "\u{0064}\u{030C}",
        nfkc: "\u{010F}",
        nfkd: "\u{0064}\u{030C}",
    },
    NormalizationTest {
        source: "\u{0112}",
        nfc: "\u{0112}",
        nfd: "\u{0045}\u{0304}",
        nfkc: "\u{0112}",
        nfkd: "\u{0045}\u{0304}",
    },
    NormalizationTest {
        source: "\u{0113}",
        nfc: "\u{0113}",
        nfd: "\u{0065}\u{0304}",
        nfkc: "\u{0113}",
        nfkd: "\u{0065}\u{0304}",
    },
    NormalizationTest {
        source: "\u{0114}",
        nfc: "\u{0114}",
        nfd: "\u{0045}\u{0306}",
        nfkc: "\u{0114}",
        nfkd: "\u{0045}\u{0306}",
    },
    NormalizationTest {
        source: "\u{0115}",
        nfc: "\u{0115}",
        nfd: "\u{0065}\u{0306}",
        nfkc: "\u{0115}",
        nfkd: "\u{0065}\u{0306}",
    },
    NormalizationTest {
        source: "\u{0116}",
        nfc: "\u{0116}",
        nfd: "\u{0045}\u{0307}",
        nfkc: "\u{0116}",
        nfkd: "\u{0045}\u{0307}",
    },
    NormalizationTest {
        source: "\u{0117}",
        nfc: "\u{0117}",
        nfd: "\u{0065}\u{0307}",
        nfkc: "\u{0117}",
        nfkd: "\u{0065}\u{0307}",
    },
    NormalizationTest {
        source: "\u{0118}",
        nfc: "\u{0118}",
        nfd: "\u{0045}\u{0328}",
        nfkc: "\u{0118}",
        nfkd: "\u{0045}\u{0328}",
    },
    NormalizationTest {
        source: "\u{0119}",
        nfc: "\u{0119}",
        nfd: "\u{0065}\u{0328}",
        nfkc: "\u{0119}",
        nfkd: "\u{0065}\u{0328}",
    },
    NormalizationTest {
        source: "\u{011A}",
        nfc: "\u{011A}",
        nfd: "\u{0045}\u{030C}",
        nfkc: "\u{011A}",
        nfkd: "\u{0045}\u{030C}",
    },
    NormalizationTest {
        source: "\u{011B}",
        nfc: "\u{011B}",
        nfd: "\u{0065}\u{030C}",
        nfkc: "\u{011B}",
        nfkd: "\u{0065}\u{030C}",
    },
    NormalizationTest {
        source: "\u{011C}",
        nfc: "\u{011C}",
        nfd: "\u{0047}\u{0302}",
        nfkc: "\u{011C}",
        nfkd: "\u{0047}\u{0302}",
    },
    NormalizationTest {
        source: "\u{011D}",
        nfc: "\u{011D}",
        nfd: "\u{0067}\u{0302}",
        nfkc: "\u{011D}",
        nfkd: "\u{0067}\u{0302}",
    },
    NormalizationTest {
        source: "\u{011E}",
        nfc: "\u{011E}",
        nfd: "\u{0047}\u{0306}",
        nfkc: "\u{011E}",
        nfkd: "\u{0047}\u{0306}",
    },
    NormalizationTest {
        source: "\u{011F}",
        nfc: "\u{011F}",
        nfd: "\u{0067}\u{0306}",
        nfkc: "\u{011F}",
        nfkd: "\u{0067}\u{0306}",
    },
    NormalizationTest {
        source: "\u{0120}",
        nfc: "\u{0120}",
        nfd: "\u{0047}\u{0307}",
        nfkc: "\u{0120}",
        nfkd: "\u{0047}\u{0307}",
    },
    NormalizationTest {
        source: "\u{0121}",
        nfc: "\u{0121}",
        nfd: "\u{0067}\u{0307}",
        nfkc: "\u{0121}",
        nfkd: "\u{0067}\u{0307}",
    },
    NormalizationTest {
        source: "\u{0122}",
        nfc: "\u{0122}",
        nfd: "\u{0047}\u{0327}",
        nfkc: "\u{0122}",
        nfkd: "\u{0047}\u{0327}",
    },
    NormalizationTest {
        source: "\u{0123}",
        nfc: "\u{0123}",
        nfd: "\u{0067}\u{0327}",
        nfkc: "\u{0123}",
        nfkd: "\u{0067}\u{0327}",
    },
    NormalizationTest {
        source: "\u{0124}",
        nfc: "\u{0124}",
        nfd: "\u{0048}\u{0302}",
        nfkc: "\u{0124}",
        nfkd: "\u{0048}\u{0302}",
    },
    NormalizationTest {
        source: "\u{0125}",
        nfc: "\u{0125}",
        nfd: "\u{0068}\u{0302}",
        nfkc: "\u{0125}",
        nfkd: "\u{0068}\u{0302}",
    },
    NormalizationTest {
        source: "\u{0128}",
        nfc: "\u{0128}",
        nfd: "\u{0049}\u{0303}",
        nfkc: "\u{0128}",
        nfkd: "\u{0049}\u{0303}",
    },
    NormalizationTest {
        source: "\u{0129}",
        nfc: "\u{0129}",
        nfd: "\u{0069}\u{0303}",
        nfkc: "\u{0129}",
        nfkd: "\u{0069}\u{0303}",
    },
    NormalizationTest {
        source: "\u{012A}",
        nfc: "\u{012A}",
        nfd: "\u{0049}\u{0304}",
        nfkc: "\u{012A}",
        nfkd: "\u{0049}\u{0304}",
    },
    NormalizationTest {
        source: "\u{012B}",
        nfc: "\u{012B}",
        nfd: "\u{0069}\u{0304}",
        nfkc: "\u{012B}",
        nfkd: "\u{0069}\u{0304}",
    },
    NormalizationTest {
        source: "\u{012C}",
        nfc: "\u{012C}",
        nfd: "\u{0049}\u{0306}",
        nfkc: "\u{012C}",
        nfkd: "\u{0049}\u{0306}",
    },
    NormalizationTest {
        source: "\u{012D}",
        nfc: "\u{012D}",
        nfd: "\u{0069}\u{0306}",
        nfkc: "\u{012D}",
        nfkd: "\u{0069}\u{0306}",
    },
    NormalizationTest {
        source: "\u{012E}",
        nfc: "\u{012E}",
        nfd: "\u{0049}\u{0328}",
        nfkc: "\u{012E}",
        nfkd: "\u{0049}\u{0328}",
    },
    NormalizationTest {
        source: "\u{012F}",
        nfc: "\u{012F}",
        nfd: "\u{0069}\u{0328}",
        nfkc: "\u{012F}",
        nfkd: "\u{0069}\u{0328}",
    },
    NormalizationTest {
        source: "\u{0130}",
        nfc: "\u{0130}",
        nfd: "\u{0049}\u{0307}",
        nfkc: "\u{0130}",
        nfkd: "\u{0049}\u{0307}",
    },
    NormalizationTest {
        source: "\u{0132}",
        nfc: "\u{0132}",
        nfd: "\u{0132}",
        nfkc: "\u{0049}\u{004A}",
        nfkd: "\u{0049}\u{004A}",
    },
    NormalizationTest {
        source: "\u{0133}",
        nfc: "\u{0133}",
        nfd: "\u{0133}",
        nfkc: "\u{0069}\u{006A}",
        nfkd: "\u{0069}\u{006A}",
    },
    NormalizationTest {
        source: "\u{0134}",
        nfc: "\u{0134}",
        nfd: "\u{004A}\u{0302}",
        nfkc: "\u{0134}",
        nfkd: "\u{004A}\u{0302}",
    },
    NormalizationTest {
        source: "\u{0135}",
        nfc: "\u{0135}",
        nfd: "\u{006A}\u{0302}",
        nfkc: "\u{0135}",
        nfkd: "\u{006A}\u{0302}",
    },
    NormalizationTest {
        source: "\u{0136}",
        nfc: "\u{0136}",
        nfd: "\u{004B}\u{0327}",
        nfkc: "\u{0136}",
        nfkd: "\u{004B}\u{0327}",
    },
    NormalizationTest {
        source: "\u{0137}",
        nfc: "\u{0137}",
        nfd: "\u{006B}\u{0327}",
        nfkc: "\u{0137}",
        nfkd: "\u{006B}\u{0327}",
    },
    NormalizationTest {
        source: "\u{0139}",
        nfc: "\u{0139}",
        nfd: "\u{004C}\u{0301}",
        nfkc: "\u{0139}",
        nfkd: "\u{004C}\u{0301}",
    },
    NormalizationTest {
        source: "\u{013A}",
        nfc: "\u{013A}",
        nfd: "\u{006C}\u{0301}",
        nfkc: "\u{013A}",
        nfkd: "\u{006C}\u{0301}",
    },
    NormalizationTest {
        source: "\u{013B}",
        nfc: "\u{013B}",
        nfd: "\u{004C}\u{0327}",
        nfkc: "\u{013B}",
        nfkd: "\u{004C}\u{0327}",
    },
    NormalizationTest {
        source: "\u{013C}",
        nfc: "\u{013C}",
        nfd: "\u{006C}\u{0327}",
        nfkc: "\u{013C}",
        nfkd: "\u{006C}\u{0327}",
    },
    NormalizationTest {
        source: "\u{013D}",
        nfc: "\u{013D}",
        nfd: "\u{004C}\u{030C}",
        nfkc: "\u{013D}",
        nfkd: "\u{004C}\u{030C}",
    },
    NormalizationTest {
        source: "\u{013E}",
        nfc: "\u{013E}",
        nfd: "\u{006C}\u{030C}",
        nfkc: "\u{013E}",
        nfkd: "\u{006C}\u{030C}",
    },
    NormalizationTest {
        source: "\u{013F}",
        nfc: "\u{013F}",
        nfd: "\u{013F}",
        nfkc: "\u{004C}\u{00B7}",
        nfkd: "\u{004C}\u{00B7}",
    },
    NormalizationTest {
        source: "\u{0140}",
        nfc: "\u{0140}",
        nfd: "\u{0140}",
        nfkc: "\u{006C}\u{00B7}",
        nfkd: "\u{006C}\u{00B7}",
    },
    NormalizationTest {
        source: "\u{0143}",
        nfc: "\u{0143}",
        nfd: "\u{004E}\u{0301}",
        nfkc: "\u{0143}",
        nfkd: "\u{004E}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0144}",
        nfc: "\u{0144}",
        nfd: "\u{006E}\u{0301}",
        nfkc: "\u{0144}",
        nfkd: "\u{006E}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0145}",
        nfc: "\u{0145}",
        nfd: "\u{004E}\u{0327}",
        nfkc: "\u{0145}",
        nfkd: "\u{004E}\u{0327}",
    },
    NormalizationTest {
        source: "\u{0146}",
        nfc: "\u{0146}",
        nfd: "\u{006E}\u{0327}",
        nfkc: "\u{0146}",
        nfkd: "\u{006E}\u{0327}",
    },
    NormalizationTest {
        source: "\u{0147}",
        nfc: "\u{0147}",
        nfd: "\u{004E}\u{030C}",
        nfkc: "\u{0147}",
        nfkd: "\u{004E}\u{030C}",
    },
    NormalizationTest {
        source: "\u{0148}",
        nfc: "\u{0148}",
        nfd: "\u{006E}\u{030C}",
        nfkc: "\u{0148}",
        nfkd: "\u{006E}\u{030C}",
    },
    NormalizationTest {
        source: "\u{0149}",
        nfc: "\u{0149}",
        nfd: "\u{0149}",
        nfkc: "\u{02BC}\u{006E}",
        nfkd: "\u{02BC}\u{006E}",
    },
    NormalizationTest {
        source: "\u{014C}",
        nfc: "\u{014C}",
        nfd: "\u{004F}\u{0304}",
        nfkc: "\u{014C}",
        nfkd: "\u{004F}\u{0304}",
    },
    NormalizationTest {
        source: "\u{014D}",
        nfc: "\u{014D}",
        nfd: "\u{006F}\u{0304}",
        nfkc: "\u{014D}",
        nfkd: "\u{006F}\u{0304}",
    },
    NormalizationTest {
        source: "\u{014E}",
        nfc: "\u{014E}",
        nfd: "\u{004F}\u{0306}",
        nfkc: "\u{014E}",
        nfkd: "\u{004F}\u{0306}",
    },
    NormalizationTest {
        source: "\u{014F}",
        nfc: "\u{014F}",
        nfd: "\u{006F}\u{0306}",
        nfkc: "\u{014F}",
        nfkd: "\u{006F}\u{0306}",
    },
    NormalizationTest {
        source: "\u{0150}",
        nfc: "\u{0150}",
        nfd: "\u{004F}\u{030B}",
        nfkc: "\u{0150}",
        nfkd: "\u{004F}\u{030B}",
    },
    NormalizationTest {
        source: "\u{0151}",
        nfc: "\u{0151}",
        nfd: "\u{006F}\u{030B}",
        nfkc: "\u{0151}",
        nfkd: "\u{006F}\u{030B}",
    },
    NormalizationTest {
        source: "\u{0154}",
        nfc: "\u{0154}",
        nfd: "\u{0052}\u{0301}",
        nfkc: "\u{0154}",
        nfkd: "\u{0052}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0155}",
        nfc: "\u{0155}",
        nfd: "\u{0072}\u{0301}",
        nfkc: "\u{0155}",
        nfkd: "\u{0072}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0156}",
        nfc: "\u{0156}",
        nfd: "\u{0052}\u{0327}",
        nfkc: "\u{0156}",
        nfkd: "\u{0052}\u{0327}",
    },
    NormalizationTest {
        source: "\u{0157}",
        nfc: "\u{0157}",
        nfd: "\u{0072}\u{0327}",
        nfkc: "\u{0157}",
        nfkd: "\u{0072}\u{0327}",
    },
    NormalizationTest {
        source: "\u{0158}",
        nfc: "\u{0158}",
        nfd: "\u{0052}\u{030C}",
        nfkc: "\u{0158}",
        nfkd: "\u{0052}\u{030C}",
    },
    NormalizationTest {
        source: "\u{0159}",
        nfc: "\u{0159}",
        nfd: "\u{0072}\u{030C}",
        nfkc: "\u{0159}",
        nfkd: "\u{0072}\u{030C}",
    },
    NormalizationTest {
        source: "\u{015A}",
        nfc: "\u{015A}",
        nfd: "\u{0053}\u{0301}",
        nfkc: "\u{015A}",
        nfkd: "\u{0053}\u{0301}",
    },
    NormalizationTest {
        source: "\u{015B}",
        nfc: "\u{015B}",
        nfd: "\u{0073}\u{0301}",
        nfkc: "\u{015B}",
        nfkd: "\u{0073}\u{0301}",
    },
    NormalizationTest {
        source: "\u{015C}",
        nfc: "\u{015C}",
        nfd: "\u{0053}\u{0302}",
        nfkc: "\u{015C}",
        nfkd: "\u{0053}\u{0302}",
    },
    NormalizationTest {
        source: "\u{015D}",
        nfc: "\u{015D}",
        nfd: "\u{0073}\u{0302}",
        nfkc: "\u{015D}",
        nfkd: "\u{0073}\u{0302}",
    },
    NormalizationTest {
        source: "\u{015E}",
        nfc: "\u{015E}",
        nfd: "\u{0053}\u{0327}",
        nfkc: "\u{015E}",
        nfkd: "\u{0053}\u{0327}",
    },
    NormalizationTest {
        source: "\u{015F}",
        nfc: "\u{015F}",
        nfd: "\u{0073}\u{0327}",
        nfkc: "\u{015F}",
        nfkd: "\u{0073}\u{0327}",
    },
    NormalizationTest {
        source: "\u{0160}",
        nfc: "\u{0160}",
        nfd: "\u{0053}\u{030C}",
        nfkc: "\u{0160}",
        nfkd: "\u{0053}\u{030C}",
    },
    NormalizationTest {
        source: "\u{0161}",
        nfc: "\u{0161}",
        nfd: "\u{0073}\u{030C}",
        nfkc: "\u{0161}",
        nfkd: "\u{0073}\u{030C}",
    },
    NormalizationTest {
        source: "\u{0162}",
        nfc: "\u{0162}",
        nfd: "\u{0054}\u{0327}",
        nfkc: "\u{0162}",
        nfkd: "\u{0054}\u{0327}",
    },
    NormalizationTest {
        source: "\u{0163}",
        nfc: "\u{0163}",
        nfd: "\u{0074}\u{0327}",
        nfkc: "\u{0163}",
        nfkd: "\u{0074}\u{0327}",
    },
    NormalizationTest {
        source: "\u{0164}",
        nfc: "\u{0164}",
        nfd: "\u{0054}\u{030C}",
        nfkc: "\u{0164}",
        nfkd: "\u{0054}\u{030C}",
    },
    NormalizationTest {
        source: "\u{0165}",
        nfc: "\u{0165}",
        nfd: "\u{0074}\u{030C}",
        nfkc: "\u{0165}",
        nfkd: "\u{0074}\u{030C}",
    },
    NormalizationTest {
        source: "\u{0168}",
        nfc: "\u{0168}",
        nfd: "\u{0055}\u{0303}",
        nfkc: "\u{0168}",
        nfkd: "\u{0055}\u{0303}",
    },
    NormalizationTest {
        source: "\u{0169}",
        nfc: "\u{0169}",
        nfd: "\u{0075}\u{0303}",
        nfkc: "\u{0169}",
        nfkd: "\u{0075}\u{0303}",
    },
    NormalizationTest {
        source: "\u{016A}",
        nfc: "\u{016A}",
        nfd: "\u{0055}\u{0304}",
        nfkc: "\u{016A}",
        nfkd: "\u{0055}\u{0304}",
    },
    NormalizationTest {
        source: "\u{016B}",
        nfc: "\u{016B}",
        nfd: "\u{0075}\u{0304}",
        nfkc: "\u{016B}",
        nfkd: "\u{0075}\u{0304}",
    },
    NormalizationTest {
        source: "\u{016C}",
        nfc: "\u{016C}",
        nfd: "\u{0055}\u{0306}",
        nfkc: "\u{016C}",
        nfkd: "\u{0055}\u{0306}",
    },
    NormalizationTest {
        source: "\u{016D}",
        nfc: "\u{016D}",
        nfd: "\u{0075}\u{0306}",
        nfkc: "\u{016D}",
        nfkd: "\u{0075}\u{0306}",
    },
    NormalizationTest {
        source: "\u{016E}",
        nfc: "\u{016E}",
        nfd: "\u{0055}\u{030A}",
        nfkc: "\u{016E}",
        nfkd: "\u{0055}\u{030A}",
    },
    NormalizationTest {
        source: "\u{016F}",
        nfc: "\u{016F}",
        nfd: "\u{0075}\u{030A}",
        nfkc: "\u{016F}",
        nfkd: "\u{0075}\u{030A}",
    },
    NormalizationTest {
        source: "\u{0170}",
        nfc: "\u{0170}",
        nfd: "\u{0055}\u{030B}",
        nfkc: "\u{0170}",
        nfkd: "\u{0055}\u{030B}",
    },
    NormalizationTest {
        source: "\u{0171}",
        nfc: "\u{0171}",
        nfd: "\u{0075}\u{030B}",
        nfkc: "\u{0171}",
        nfkd: "\u{0075}\u{030B}",
    },
    NormalizationTest {
        source: "\u{0172}",
        nfc: "\u{0172}",
        nfd: "\u{0055}\u{0328}",
        nfkc: "\u{0172}",
        nfkd: "\u{0055}\u{0328}",
    },
    NormalizationTest {
        source: "\u{0173}",
        nfc: "\u{0173}",
        nfd: "\u{0075}\u{0328}",
        nfkc: "\u{0173}",
        nfkd: "\u{0075}\u{0328}",
    },
    NormalizationTest {
        source: "\u{0174}",
        nfc: "\u{0174}",
        nfd: "\u{0057}\u{0302}",
        nfkc: "\u{0174}",
        nfkd: "\u{0057}\u{0302}",
    },
    NormalizationTest {
        source: "\u{0175}",
        nfc: "\u{0175}",
        nfd: "\u{0077}\u{0302}",
        nfkc: "\u{0175}",
        nfkd: "\u{0077}\u{0302}",
    },
    NormalizationTest {
        source: "\u{0176}",
        nfc: "\u{0176}",
        nfd: "\u{0059}\u{0302}",
        nfkc: "\u{0176}",
        nfkd: "\u{0059}\u{0302}",
    },
    NormalizationTest {
        source: "\u{0177}",
        nfc: "\u{0177}",
        nfd: "\u{0079}\u{0302}",
        nfkc: "\u{0177}",
        nfkd: "\u{0079}\u{0302}",
    },
    NormalizationTest {
        source: "\u{0178}",
        nfc: "\u{0178}",
        nfd: "\u{0059}\u{0308}",
        nfkc: "\u{0178}",
        nfkd: "\u{0059}\u{0308}",
    },
    NormalizationTest {
        source: "\u{0179}",
        nfc: "\u{0179}",
        nfd: "\u{005A}\u{0301}",
        nfkc: "\u{0179}",
        nfkd: "\u{005A}\u{0301}",
    },
    NormalizationTest {
        source: "\u{017A}",
        nfc: "\u{017A}",
        nfd: "\u{007A}\u{0301}",
        nfkc: "\u{017A}",
        nfkd: "\u{007A}\u{0301}",
    },
    NormalizationTest {
        source: "\u{017B}",
        nfc: "\u{017B}",
        nfd: "\u{005A}\u{0307}",
        nfkc: "\u{017B}",
        nfkd: "\u{005A}\u{0307}",
    },
    NormalizationTest {
        source: "\u{017C}",
        nfc: "\u{017C}",
        nfd: "\u{007A}\u{0307}",
        nfkc: "\u{017C}",
        nfkd: "\u{007A}\u{0307}",
    },
    NormalizationTest {
        source: "\u{017D}",
        nfc: "\u{017D}",
        nfd: "\u{005A}\u{030C}",
        nfkc: "\u{017D}",
        nfkd: "\u{005A}\u{030C}",
    },
    NormalizationTest {
        source: "\u{017E}",
        nfc: "\u{017E}",
        nfd: "\u{007A}\u{030C}",
        nfkc: "\u{017E}",
        nfkd: "\u{007A}\u{030C}",
    },
    NormalizationTest {
        source: "\u{017F}",
        nfc: "\u{017F}",
        nfd: "\u{017F}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{01A0}",
        nfc: "\u{01A0}",
        nfd: "\u{004F}\u{031B}",
        nfkc: "\u{01A0}",
        nfkd: "\u{004F}\u{031B}",
    },
    NormalizationTest {
        source: "\u{01A1}",
        nfc: "\u{01A1}",
        nfd: "\u{006F}\u{031B}",
        nfkc: "\u{01A1}",
        nfkd: "\u{006F}\u{031B}",
    },
    NormalizationTest {
        source: "\u{01AF}",
        nfc: "\u{01AF}",
        nfd: "\u{0055}\u{031B}",
        nfkc: "\u{01AF}",
        nfkd: "\u{0055}\u{031B}",
    },
    NormalizationTest {
        source: "\u{01B0}",
        nfc: "\u{01B0}",
        nfd: "\u{0075}\u{031B}",
        nfkc: "\u{01B0}",
        nfkd: "\u{0075}\u{031B}",
    },
    NormalizationTest {
        source: "\u{01C4}",
        nfc: "\u{01C4}",
        nfd: "\u{01C4}",
        nfkc: "\u{0044}\u{017D}",
        nfkd: "\u{0044}\u{005A}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01C5}",
        nfc: "\u{01C5}",
        nfd: "\u{01C5}",
        nfkc: "\u{0044}\u{017E}",
        nfkd: "\u{0044}\u{007A}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01C6}",
        nfc: "\u{01C6}",
        nfd: "\u{01C6}",
        nfkc: "\u{0064}\u{017E}",
        nfkd: "\u{0064}\u{007A}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01C7}",
        nfc: "\u{01C7}",
        nfd: "\u{01C7}",
        nfkc: "\u{004C}\u{004A}",
        nfkd: "\u{004C}\u{004A}",
    },
    NormalizationTest {
        source: "\u{01C8}",
        nfc: "\u{01C8}",
        nfd: "\u{01C8}",
        nfkc: "\u{004C}\u{006A}",
        nfkd: "\u{004C}\u{006A}",
    },
    NormalizationTest {
        source: "\u{01C9}",
        nfc: "\u{01C9}",
        nfd: "\u{01C9}",
        nfkc: "\u{006C}\u{006A}",
        nfkd: "\u{006C}\u{006A}",
    },
    NormalizationTest {
        source: "\u{01CA}",
        nfc: "\u{01CA}",
        nfd: "\u{01CA}",
        nfkc: "\u{004E}\u{004A}",
        nfkd: "\u{004E}\u{004A}",
    },
    NormalizationTest {
        source: "\u{01CB}",
        nfc: "\u{01CB}",
        nfd: "\u{01CB}",
        nfkc: "\u{004E}\u{006A}",
        nfkd: "\u{004E}\u{006A}",
    },
    NormalizationTest {
        source: "\u{01CC}",
        nfc: "\u{01CC}",
        nfd: "\u{01CC}",
        nfkc: "\u{006E}\u{006A}",
        nfkd: "\u{006E}\u{006A}",
    },
    NormalizationTest {
        source: "\u{01CD}",
        nfc: "\u{01CD}",
        nfd: "\u{0041}\u{030C}",
        nfkc: "\u{01CD}",
        nfkd: "\u{0041}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01CE}",
        nfc: "\u{01CE}",
        nfd: "\u{0061}\u{030C}",
        nfkc: "\u{01CE}",
        nfkd: "\u{0061}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01CF}",
        nfc: "\u{01CF}",
        nfd: "\u{0049}\u{030C}",
        nfkc: "\u{01CF}",
        nfkd: "\u{0049}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01D0}",
        nfc: "\u{01D0}",
        nfd: "\u{0069}\u{030C}",
        nfkc: "\u{01D0}",
        nfkd: "\u{0069}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01D1}",
        nfc: "\u{01D1}",
        nfd: "\u{004F}\u{030C}",
        nfkc: "\u{01D1}",
        nfkd: "\u{004F}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01D2}",
        nfc: "\u{01D2}",
        nfd: "\u{006F}\u{030C}",
        nfkc: "\u{01D2}",
        nfkd: "\u{006F}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01D3}",
        nfc: "\u{01D3}",
        nfd: "\u{0055}\u{030C}",
        nfkc: "\u{01D3}",
        nfkd: "\u{0055}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01D4}",
        nfc: "\u{01D4}",
        nfd: "\u{0075}\u{030C}",
        nfkc: "\u{01D4}",
        nfkd: "\u{0075}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01D5}",
        nfc: "\u{01D5}",
        nfd: "\u{0055}\u{0308}\u{0304}",
        nfkc: "\u{01D5}",
        nfkd: "\u{0055}\u{0308}\u{0304}",
    },
    NormalizationTest {
        source: "\u{01D6}",
        nfc: "\u{01D6}",
        nfd: "\u{0075}\u{0308}\u{0304}",
        nfkc: "\u{01D6}",
        nfkd: "\u{0075}\u{0308}\u{0304}",
    },
    NormalizationTest {
        source: "\u{01D7}",
        nfc: "\u{01D7}",
        nfd: "\u{0055}\u{0308}\u{0301}",
        nfkc: "\u{01D7}",
        nfkd: "\u{0055}\u{0308}\u{0301}",
    },
    NormalizationTest {
        source: "\u{01D8}",
        nfc: "\u{01D8}",
        nfd: "\u{0075}\u{0308}\u{0301}",
        nfkc: "\u{01D8}",
        nfkd: "\u{0075}\u{0308}\u{0301}",
    },
    NormalizationTest {
        source: "\u{01D9}",
        nfc: "\u{01D9}",
        nfd: "\u{0055}\u{0308}\u{030C}",
        nfkc: "\u{01D9}",
        nfkd: "\u{0055}\u{0308}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01DA}",
        nfc: "\u{01DA}",
        nfd: "\u{0075}\u{0308}\u{030C}",
        nfkc: "\u{01DA}",
        nfkd: "\u{0075}\u{0308}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01DB}",
        nfc: "\u{01DB}",
        nfd: "\u{0055}\u{0308}\u{0300}",
        nfkc: "\u{01DB}",
        nfkd: "\u{0055}\u{0308}\u{0300}",
    },
    NormalizationTest {
        source: "\u{01DC}",
        nfc: "\u{01DC}",
        nfd: "\u{0075}\u{0308}\u{0300}",
        nfkc: "\u{01DC}",
        nfkd: "\u{0075}\u{0308}\u{0300}",
    },
    NormalizationTest {
        source: "\u{01DE}",
        nfc: "\u{01DE}",
        nfd: "\u{0041}\u{0308}\u{0304}",
        nfkc: "\u{01DE}",
        nfkd: "\u{0041}\u{0308}\u{0304}",
    },
    NormalizationTest {
        source: "\u{01DF}",
        nfc: "\u{01DF}",
        nfd: "\u{0061}\u{0308}\u{0304}",
        nfkc: "\u{01DF}",
        nfkd: "\u{0061}\u{0308}\u{0304}",
    },
    NormalizationTest {
        source: "\u{01E0}",
        nfc: "\u{01E0}",
        nfd: "\u{0041}\u{0307}\u{0304}",
        nfkc: "\u{01E0}",
        nfkd: "\u{0041}\u{0307}\u{0304}",
    },
    NormalizationTest {
        source: "\u{01E1}",
        nfc: "\u{01E1}",
        nfd: "\u{0061}\u{0307}\u{0304}",
        nfkc: "\u{01E1}",
        nfkd: "\u{0061}\u{0307}\u{0304}",
    },
    NormalizationTest {
        source: "\u{01E2}",
        nfc: "\u{01E2}",
        nfd: "\u{00C6}\u{0304}",
        nfkc: "\u{01E2}",
        nfkd: "\u{00C6}\u{0304}",
    },
    NormalizationTest {
        source: "\u{01E3}",
        nfc: "\u{01E3}",
        nfd: "\u{00E6}\u{0304}",
        nfkc: "\u{01E3}",
        nfkd: "\u{00E6}\u{0304}",
    },
    NormalizationTest {
        source: "\u{01E6}",
        nfc: "\u{01E6}",
        nfd: "\u{0047}\u{030C}",
        nfkc: "\u{01E6}",
        nfkd: "\u{0047}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01E7}",
        nfc: "\u{01E7}",
        nfd: "\u{0067}\u{030C}",
        nfkc: "\u{01E7}",
        nfkd: "\u{0067}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01E8}",
        nfc: "\u{01E8}",
        nfd: "\u{004B}\u{030C}",
        nfkc: "\u{01E8}",
        nfkd: "\u{004B}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01E9}",
        nfc: "\u{01E9}",
        nfd: "\u{006B}\u{030C}",
        nfkc: "\u{01E9}",
        nfkd: "\u{006B}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01EA}",
        nfc: "\u{01EA}",
        nfd: "\u{004F}\u{0328}",
        nfkc: "\u{01EA}",
        nfkd: "\u{004F}\u{0328}",
    },
    NormalizationTest {
        source: "\u{01EB}",
        nfc: "\u{01EB}",
        nfd: "\u{006F}\u{0328}",
        nfkc: "\u{01EB}",
        nfkd: "\u{006F}\u{0328}",
    },
    NormalizationTest {
        source: "\u{01EC}",
        nfc: "\u{01EC}",
        nfd: "\u{004F}\u{0328}\u{0304}",
        nfkc: "\u{01EC}",
        nfkd: "\u{004F}\u{0328}\u{0304}",
    },
    NormalizationTest {
        source: "\u{01ED}",
        nfc: "\u{01ED}",
        nfd: "\u{006F}\u{0328}\u{0304}",
        nfkc: "\u{01ED}",
        nfkd: "\u{006F}\u{0328}\u{0304}",
    },
    NormalizationTest {
        source: "\u{01EE}",
        nfc: "\u{01EE}",
        nfd: "\u{01B7}\u{030C}",
        nfkc: "\u{01EE}",
        nfkd: "\u{01B7}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01EF}",
        nfc: "\u{01EF}",
        nfd: "\u{0292}\u{030C}",
        nfkc: "\u{01EF}",
        nfkd: "\u{0292}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01F0}",
        nfc: "\u{01F0}",
        nfd: "\u{006A}\u{030C}",
        nfkc: "\u{01F0}",
        nfkd: "\u{006A}\u{030C}",
    },
    NormalizationTest {
        source: "\u{01F1}",
        nfc: "\u{01F1}",
        nfd: "\u{01F1}",
        nfkc: "\u{0044}\u{005A}",
        nfkd: "\u{0044}\u{005A}",
    },
    NormalizationTest {
        source: "\u{01F2}",
        nfc: "\u{01F2}",
        nfd: "\u{01F2}",
        nfkc: "\u{0044}\u{007A}",
        nfkd: "\u{0044}\u{007A}",
    },
    NormalizationTest {
        source: "\u{01F3}",
        nfc: "\u{01F3}",
        nfd: "\u{01F3}",
        nfkc: "\u{0064}\u{007A}",
        nfkd: "\u{0064}\u{007A}",
    },
    NormalizationTest {
        source: "\u{01F4}",
        nfc: "\u{01F4}",
        nfd: "\u{0047}\u{0301}",
        nfkc: "\u{01F4}",
        nfkd: "\u{0047}\u{0301}",
    },
    NormalizationTest {
        source: "\u{01F5}",
        nfc: "\u{01F5}",
        nfd: "\u{0067}\u{0301}",
        nfkc: "\u{01F5}",
        nfkd: "\u{0067}\u{0301}",
    },
    NormalizationTest {
        source: "\u{01F8}",
        nfc: "\u{01F8}",
        nfd: "\u{004E}\u{0300}",
        nfkc: "\u{01F8}",
        nfkd: "\u{004E}\u{0300}",
    },
    NormalizationTest {
        source: "\u{01F9}",
        nfc: "\u{01F9}",
        nfd: "\u{006E}\u{0300}",
        nfkc: "\u{01F9}",
        nfkd: "\u{006E}\u{0300}",
    },
    NormalizationTest {
        source: "\u{01FA}",
        nfc: "\u{01FA}",
        nfd: "\u{0041}\u{030A}\u{0301}",
        nfkc: "\u{01FA}",
        nfkd: "\u{0041}\u{030A}\u{0301}",
    },
    NormalizationTest {
        source: "\u{01FB}",
        nfc: "\u{01FB}",
        nfd: "\u{0061}\u{030A}\u{0301}",
        nfkc: "\u{01FB}",
        nfkd: "\u{0061}\u{030A}\u{0301}",
    },
    NormalizationTest {
        source: "\u{01FC}",
        nfc: "\u{01FC}",
        nfd: "\u{00C6}\u{0301}",
        nfkc: "\u{01FC}",
        nfkd: "\u{00C6}\u{0301}",
    },
    NormalizationTest {
        source: "\u{01FD}",
        nfc: "\u{01FD}",
        nfd: "\u{00E6}\u{0301}",
        nfkc: "\u{01FD}",
        nfkd: "\u{00E6}\u{0301}",
    },
    NormalizationTest {
        source: "\u{01FE}",
        nfc: "\u{01FE}",
        nfd: "\u{00D8}\u{0301}",
        nfkc: "\u{01FE}",
        nfkd: "\u{00D8}\u{0301}",
    },
    NormalizationTest {
        source: "\u{01FF}",
        nfc: "\u{01FF}",
        nfd: "\u{00F8}\u{0301}",
        nfkc: "\u{01FF}",
        nfkd: "\u{00F8}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0200}",
        nfc: "\u{0200}",
        nfd: "\u{0041}\u{030F}",
        nfkc: "\u{0200}",
        nfkd: "\u{0041}\u{030F}",
    },
    NormalizationTest {
        source: "\u{0201}",
        nfc: "\u{0201}",
        nfd: "\u{0061}\u{030F}",
        nfkc: "\u{0201}",
        nfkd: "\u{0061}\u{030F}",
    },
    NormalizationTest {
        source: "\u{0202}",
        nfc: "\u{0202}",
        nfd: "\u{0041}\u{0311}",
        nfkc: "\u{0202}",
        nfkd: "\u{0041}\u{0311}",
    },
    NormalizationTest {
        source: "\u{0203}",
        nfc: "\u{0203}",
        nfd: "\u{0061}\u{0311}",
        nfkc: "\u{0203}",
        nfkd: "\u{0061}\u{0311}",
    },
    NormalizationTest {
        source: "\u{0204}",
        nfc: "\u{0204}",
        nfd: "\u{0045}\u{030F}",
        nfkc: "\u{0204}",
        nfkd: "\u{0045}\u{030F}",
    },
    NormalizationTest {
        source: "\u{0205}",
        nfc: "\u{0205}",
        nfd: "\u{0065}\u{030F}",
        nfkc: "\u{0205}",
        nfkd: "\u{0065}\u{030F}",
    },
    NormalizationTest {
        source: "\u{0206}",
        nfc: "\u{0206}",
        nfd: "\u{0045}\u{0311}",
        nfkc: "\u{0206}",
        nfkd: "\u{0045}\u{0311}",
    },
    NormalizationTest {
        source: "\u{0207}",
        nfc: "\u{0207}",
        nfd: "\u{0065}\u{0311}",
        nfkc: "\u{0207}",
        nfkd: "\u{0065}\u{0311}",
    },
    NormalizationTest {
        source: "\u{0208}",
        nfc: "\u{0208}",
        nfd: "\u{0049}\u{030F}",
        nfkc: "\u{0208}",
        nfkd: "\u{0049}\u{030F}",
    },
    NormalizationTest {
        source: "\u{0209}",
        nfc: "\u{0209}",
        nfd: "\u{0069}\u{030F}",
        nfkc: "\u{0209}",
        nfkd: "\u{0069}\u{030F}",
    },
    NormalizationTest {
        source: "\u{020A}",
        nfc: "\u{020A}",
        nfd: "\u{0049}\u{0311}",
        nfkc: "\u{020A}",
        nfkd: "\u{0049}\u{0311}",
    },
    NormalizationTest {
        source: "\u{020B}",
        nfc: "\u{020B}",
        nfd: "\u{0069}\u{0311}",
        nfkc: "\u{020B}",
        nfkd: "\u{0069}\u{0311}",
    },
    NormalizationTest {
        source: "\u{020C}",
        nfc: "\u{020C}",
        nfd: "\u{004F}\u{030F}",
        nfkc: "\u{020C}",
        nfkd: "\u{004F}\u{030F}",
    },
    NormalizationTest {
        source: "\u{020D}",
        nfc: "\u{020D}",
        nfd: "\u{006F}\u{030F}",
        nfkc: "\u{020D}",
        nfkd: "\u{006F}\u{030F}",
    },
    NormalizationTest {
        source: "\u{020E}",
        nfc: "\u{020E}",
        nfd: "\u{004F}\u{0311}",
        nfkc: "\u{020E}",
        nfkd: "\u{004F}\u{0311}",
    },
    NormalizationTest {
        source: "\u{020F}",
        nfc: "\u{020F}",
        nfd: "\u{006F}\u{0311}",
        nfkc: "\u{020F}",
        nfkd: "\u{006F}\u{0311}",
    },
    NormalizationTest {
        source: "\u{0210}",
        nfc: "\u{0210}",
        nfd: "\u{0052}\u{030F}",
        nfkc: "\u{0210}",
        nfkd: "\u{0052}\u{030F}",
    },
    NormalizationTest {
        source: "\u{0211}",
        nfc: "\u{0211}",
        nfd: "\u{0072}\u{030F}",
        nfkc: "\u{0211}",
        nfkd: "\u{0072}\u{030F}",
    },
    NormalizationTest {
        source: "\u{0212}",
        nfc: "\u{0212}",
        nfd: "\u{0052}\u{0311}",
        nfkc: "\u{0212}",
        nfkd: "\u{0052}\u{0311}",
    },
    NormalizationTest {
        source: "\u{0213}",
        nfc: "\u{0213}",
        nfd: "\u{0072}\u{0311}",
        nfkc: "\u{0213}",
        nfkd: "\u{0072}\u{0311}",
    },
    NormalizationTest {
        source: "\u{0214}",
        nfc: "\u{0214}",
        nfd: "\u{0055}\u{030F}",
        nfkc: "\u{0214}",
        nfkd: "\u{0055}\u{030F}",
    },
    NormalizationTest {
        source: "\u{0215}",
        nfc: "\u{0215}",
        nfd: "\u{0075}\u{030F}",
        nfkc: "\u{0215}",
        nfkd: "\u{0075}\u{030F}",
    },
    NormalizationTest {
        source: "\u{0216}",
        nfc: "\u{0216}",
        nfd: "\u{0055}\u{0311}",
        nfkc: "\u{0216}",
        nfkd: "\u{0055}\u{0311}",
    },
    NormalizationTest {
        source: "\u{0217}",
        nfc: "\u{0217}",
        nfd: "\u{0075}\u{0311}",
        nfkc: "\u{0217}",
        nfkd: "\u{0075}\u{0311}",
    },
    NormalizationTest {
        source: "\u{0218}",
        nfc: "\u{0218}",
        nfd: "\u{0053}\u{0326}",
        nfkc: "\u{0218}",
        nfkd: "\u{0053}\u{0326}",
    },
    NormalizationTest {
        source: "\u{0219}",
        nfc: "\u{0219}",
        nfd: "\u{0073}\u{0326}",
        nfkc: "\u{0219}",
        nfkd: "\u{0073}\u{0326}",
    },
    NormalizationTest {
        source: "\u{021A}",
        nfc: "\u{021A}",
        nfd: "\u{0054}\u{0326}",
        nfkc: "\u{021A}",
        nfkd: "\u{0054}\u{0326}",
    },
    NormalizationTest {
        source: "\u{021B}",
        nfc: "\u{021B}",
        nfd: "\u{0074}\u{0326}",
        nfkc: "\u{021B}",
        nfkd: "\u{0074}\u{0326}",
    },
    NormalizationTest {
        source: "\u{021E}",
        nfc: "\u{021E}",
        nfd: "\u{0048}\u{030C}",
        nfkc: "\u{021E}",
        nfkd: "\u{0048}\u{030C}",
    },
    NormalizationTest {
        source: "\u{021F}",
        nfc: "\u{021F}",
        nfd: "\u{0068}\u{030C}",
        nfkc: "\u{021F}",
        nfkd: "\u{0068}\u{030C}",
    },
    NormalizationTest {
        source: "\u{0226}",
        nfc: "\u{0226}",
        nfd: "\u{0041}\u{0307}",
        nfkc: "\u{0226}",
        nfkd: "\u{0041}\u{0307}",
    },
    NormalizationTest {
        source: "\u{0227}",
        nfc: "\u{0227}",
        nfd: "\u{0061}\u{0307}",
        nfkc: "\u{0227}",
        nfkd: "\u{0061}\u{0307}",
    },
    NormalizationTest {
        source: "\u{0228}",
        nfc: "\u{0228}",
        nfd: "\u{0045}\u{0327}",
        nfkc: "\u{0228}",
        nfkd: "\u{0045}\u{0327}",
    },
    NormalizationTest {
        source: "\u{0229}",
        nfc: "\u{0229}",
        nfd: "\u{0065}\u{0327}",
        nfkc: "\u{0229}",
        nfkd: "\u{0065}\u{0327}",
    },
    NormalizationTest {
        source: "\u{022A}",
        nfc: "\u{022A}",
        nfd: "\u{004F}\u{0308}\u{0304}",
        nfkc: "\u{022A}",
        nfkd: "\u{004F}\u{0308}\u{0304}",
    },
    NormalizationTest {
        source: "\u{022B}",
        nfc: "\u{022B}",
        nfd: "\u{006F}\u{0308}\u{0304}",
        nfkc: "\u{022B}",
        nfkd: "\u{006F}\u{0308}\u{0304}",
    },
    NormalizationTest {
        source: "\u{022C}",
        nfc: "\u{022C}",
        nfd: "\u{004F}\u{0303}\u{0304}",
        nfkc: "\u{022C}",
        nfkd: "\u{004F}\u{0303}\u{0304}",
    },
    NormalizationTest {
        source: "\u{022D}",
        nfc: "\u{022D}",
        nfd: "\u{006F}\u{0303}\u{0304}",
        nfkc: "\u{022D}",
        nfkd: "\u{006F}\u{0303}\u{0304}",
    },
    NormalizationTest {
        source: "\u{022E}",
        nfc: "\u{022E}",
        nfd: "\u{004F}\u{0307}",
        nfkc: "\u{022E}",
        nfkd: "\u{004F}\u{0307}",
    },
    NormalizationTest {
        source: "\u{022F}",
        nfc: "\u{022F}",
        nfd: "\u{006F}\u{0307}",
        nfkc: "\u{022F}",
        nfkd: "\u{006F}\u{0307}",
    },
    NormalizationTest {
        source: "\u{0230}",
        nfc: "\u{0230}",
        nfd: "\u{004F}\u{0307}\u{0304}",
        nfkc: "\u{0230}",
        nfkd: "\u{004F}\u{0307}\u{0304}",
    },
    NormalizationTest {
        source: "\u{0231}",
        nfc: "\u{0231}",
        nfd: "\u{006F}\u{0307}\u{0304}",
        nfkc: "\u{0231}",
        nfkd: "\u{006F}\u{0307}\u{0304}",
    },
    NormalizationTest {
        source: "\u{0232}",
        nfc: "\u{0232}",
        nfd: "\u{0059}\u{0304}",
        nfkc: "\u{0232}",
        nfkd: "\u{0059}\u{0304}",
    },
    NormalizationTest {
        source: "\u{0233}",
        nfc: "\u{0233}",
        nfd: "\u{0079}\u{0304}",
        nfkc: "\u{0233}",
        nfkd: "\u{0079}\u{0304}",
    },
    NormalizationTest {
        source: "\u{02B0}",
        nfc: "\u{02B0}",
        nfd: "\u{02B0}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{02B1}",
        nfc: "\u{02B1}",
        nfd: "\u{02B1}",
        nfkc: "\u{0266}",
        nfkd: "\u{0266}",
    },
    NormalizationTest {
        source: "\u{02B2}",
        nfc: "\u{02B2}",
        nfd: "\u{02B2}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{02B3}",
        nfc: "\u{02B3}",
        nfd: "\u{02B3}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{02B4}",
        nfc: "\u{02B4}",
        nfd: "\u{02B4}",
        nfkc: "\u{0279}",
        nfkd: "\u{0279}",
    },
    NormalizationTest {
        source: "\u{02B5}",
        nfc: "\u{02B5}",
        nfd: "\u{02B5}",
        nfkc: "\u{027B}",
        nfkd: "\u{027B}",
    },
    NormalizationTest {
        source: "\u{02B6}",
        nfc: "\u{02B6}",
        nfd: "\u{02B6}",
        nfkc: "\u{0281}",
        nfkd: "\u{0281}",
    },
    NormalizationTest {
        source: "\u{02B7}",
        nfc: "\u{02B7}",
        nfd: "\u{02B7}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{02B8}",
        nfc: "\u{02B8}",
        nfd: "\u{02B8}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{02D8}",
        nfc: "\u{02D8}",
        nfd: "\u{02D8}",
        nfkc: "\u{0020}\u{0306}",
        nfkd: "\u{0020}\u{0306}",
    },
    NormalizationTest {
        source: "\u{02D9}",
        nfc: "\u{02D9}",
        nfd: "\u{02D9}",
        nfkc: "\u{0020}\u{0307}",
        nfkd: "\u{0020}\u{0307}",
    },
    NormalizationTest {
        source: "\u{02DA}",
        nfc: "\u{02DA}",
        nfd: "\u{02DA}",
        nfkc: "\u{0020}\u{030A}",
        nfkd: "\u{0020}\u{030A}",
    },
    NormalizationTest {
        source: "\u{02DB}",
        nfc: "\u{02DB}",
        nfd: "\u{02DB}",
        nfkc: "\u{0020}\u{0328}",
        nfkd: "\u{0020}\u{0328}",
    },
    NormalizationTest {
        source: "\u{02DC}",
        nfc: "\u{02DC}",
        nfd: "\u{02DC}",
        nfkc: "\u{0020}\u{0303}",
        nfkd: "\u{0020}\u{0303}",
    },
    NormalizationTest {
        source: "\u{02DD}",
        nfc: "\u{02DD}",
        nfd: "\u{02DD}",
        nfkc: "\u{0020}\u{030B}",
        nfkd: "\u{0020}\u{030B}",
    },
    NormalizationTest {
        source: "\u{02E0}",
        nfc: "\u{02E0}",
        nfd: "\u{02E0}",
        nfkc: "\u{0263}",
        nfkd: "\u{0263}",
    },
    NormalizationTest {
        source: "\u{02E1}",
        nfc: "\u{02E1}",
        nfd: "\u{02E1}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{02E2}",
        nfc: "\u{02E2}",
        nfd: "\u{02E2}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{02E3}",
        nfc: "\u{02E3}",
        nfd: "\u{02E3}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{02E4}",
        nfc: "\u{02E4}",
        nfd: "\u{02E4}",
        nfkc: "\u{0295}",
        nfkd: "\u{0295}",
    },
    NormalizationTest {
        source: "\u{0340}",
        nfc: "\u{0300}",
        nfd: "\u{0300}",
        nfkc: "\u{0300}",
        nfkd: "\u{0300}",
    },
    NormalizationTest {
        source: "\u{0341}",
        nfc: "\u{0301}",
        nfd: "\u{0301}",
        nfkc: "\u{0301}",
        nfkd: "\u{0301}",
    },
    NormalizationTest {
        source: "\u{0343}",
        nfc: "\u{0313}",
        nfd: "\u{0313}",
        nfkc: "\u{0313}",
        nfkd: "\u{0313}",
    },
    NormalizationTest {
        source: "\u{0344}",
        nfc: "\u{0308}\u{0301}",
        nfd: "\u{0308}\u{0301}",
        nfkc: "\u{0308}\u{0301}",
        nfkd: "\u{0308}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0374}",
        nfc: "\u{02B9}",
        nfd: "\u{02B9}",
        nfkc: "\u{02B9}",
        nfkd: "\u{02B9}",
    },
    NormalizationTest {
        source: "\u{037A}",
        nfc: "\u{037A}",
        nfd: "\u{037A}",
        nfkc: "\u{0020}\u{0345}",
        nfkd: "\u{0020}\u{0345}",
    },
    NormalizationTest {
        source: "\u{037E}",
        nfc: "\u{003B}",
        nfd: "\u{003B}",
        nfkc: "\u{003B}",
        nfkd: "\u{003B}",
    },
    NormalizationTest {
        source: "\u{0384}",
        nfc: "\u{0384}",
        nfd: "\u{0384}",
        nfkc: "\u{0020}\u{0301}",
        nfkd: "\u{0020}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0385}",
        nfc: "\u{0385}",
        nfd: "\u{00A8}\u{0301}",
        nfkc: "\u{0020}\u{0308}\u{0301}",
        nfkd: "\u{0020}\u{0308}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0386}",
        nfc: "\u{0386}",
        nfd: "\u{0391}\u{0301}",
        nfkc: "\u{0386}",
        nfkd: "\u{0391}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0387}",
        nfc: "\u{00B7}",
        nfd: "\u{00B7}",
        nfkc: "\u{00B7}",
        nfkd: "\u{00B7}",
    },
    NormalizationTest {
        source: "\u{0388}",
        nfc: "\u{0388}",
        nfd: "\u{0395}\u{0301}",
        nfkc: "\u{0388}",
        nfkd: "\u{0395}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0389}",
        nfc: "\u{0389}",
        nfd: "\u{0397}\u{0301}",
        nfkc: "\u{0389}",
        nfkd: "\u{0397}\u{0301}",
    },
    NormalizationTest {
        source: "\u{038A}",
        nfc: "\u{038A}",
        nfd: "\u{0399}\u{0301}",
        nfkc: "\u{038A}",
        nfkd: "\u{0399}\u{0301}",
    },
    NormalizationTest {
        source: "\u{038C}",
        nfc: "\u{038C}",
        nfd: "\u{039F}\u{0301}",
        nfkc: "\u{038C}",
        nfkd: "\u{039F}\u{0301}",
    },
    NormalizationTest {
        source: "\u{038E}",
        nfc: "\u{038E}",
        nfd: "\u{03A5}\u{0301}",
        nfkc: "\u{038E}",
        nfkd: "\u{03A5}\u{0301}",
    },
    NormalizationTest {
        source: "\u{038F}",
        nfc: "\u{038F}",
        nfd: "\u{03A9}\u{0301}",
        nfkc: "\u{038F}",
        nfkd: "\u{03A9}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0390}",
        nfc: "\u{0390}",
        nfd: "\u{03B9}\u{0308}\u{0301}",
        nfkc: "\u{0390}",
        nfkd: "\u{03B9}\u{0308}\u{0301}",
    },
    NormalizationTest {
        source: "\u{03AA}",
        nfc: "\u{03AA}",
        nfd: "\u{0399}\u{0308}",
        nfkc: "\u{03AA}",
        nfkd: "\u{0399}\u{0308}",
    },
    NormalizationTest {
        source: "\u{03AB}",
        nfc: "\u{03AB}",
        nfd: "\u{03A5}\u{0308}",
        nfkc: "\u{03AB}",
        nfkd: "\u{03A5}\u{0308}",
    },
    NormalizationTest {
        source: "\u{03AC}",
        nfc: "\u{03AC}",
        nfd: "\u{03B1}\u{0301}",
        nfkc: "\u{03AC}",
        nfkd: "\u{03B1}\u{0301}",
    },
    NormalizationTest {
        source: "\u{03AD}",
        nfc: "\u{03AD}",
        nfd: "\u{03B5}\u{0301}",
        nfkc: "\u{03AD}",
        nfkd: "\u{03B5}\u{0301}",
    },
    NormalizationTest {
        source: "\u{03AE}",
        nfc: "\u{03AE}",
        nfd: "\u{03B7}\u{0301}",
        nfkc: "\u{03AE}",
        nfkd: "\u{03B7}\u{0301}",
    },
    NormalizationTest {
        source: "\u{03AF}",
        nfc: "\u{03AF}",
        nfd: "\u{03B9}\u{0301}",
        nfkc: "\u{03AF}",
        nfkd: "\u{03B9}\u{0301}",
    },
    NormalizationTest {
        source: "\u{03B0}",
        nfc: "\u{03B0}",
        nfd: "\u{03C5}\u{0308}\u{0301}",
        nfkc: "\u{03B0}",
        nfkd: "\u{03C5}\u{0308}\u{0301}",
    },
    NormalizationTest {
        source: "\u{03CA}",
        nfc: "\u{03CA}",
        nfd: "\u{03B9}\u{0308}",
        nfkc: "\u{03CA}",
        nfkd: "\u{03B9}\u{0308}",
    },
    NormalizationTest {
        source: "\u{03CB}",
        nfc: "\u{03CB}",
        nfd: "\u{03C5}\u{0308}",
        nfkc: "\u{03CB}",
        nfkd: "\u{03C5}\u{0308}",
    },
    NormalizationTest {
        source: "\u{03CC}",
        nfc: "\u{03CC}",
        nfd: "\u{03BF}\u{0301}",
        nfkc: "\u{03CC}",
        nfkd: "\u{03BF}\u{0301}",
    },
    NormalizationTest {
        source: "\u{03CD}",
        nfc: "\u{03CD}",
        nfd: "\u{03C5}\u{0301}",
        nfkc: "\u{03CD}",
        nfkd: "\u{03C5}\u{0301}",
    },
    NormalizationTest {
        source: "\u{03CE}",
        nfc: "\u{03CE}",
        nfd: "\u{03C9}\u{0301}",
        nfkc: "\u{03CE}",
        nfkd: "\u{03C9}\u{0301}",
    },
    NormalizationTest {
        source: "\u{03D0}",
        nfc: "\u{03D0}",
        nfd: "\u{03D0}",
        nfkc: "\u{03B2}",
        nfkd: "\u{03B2}",
    },
    NormalizationTest {
        source: "\u{03D1}",
        nfc: "\u{03D1}",
        nfd: "\u{03D1}",
        nfkc: "\u{03B8}",
        nfkd: "\u{03B8}",
    },
    NormalizationTest {
        source: "\u{03D2}",
        nfc: "\u{03D2}",
        nfd: "\u{03D2}",
        nfkc: "\u{03A5}",
        nfkd: "\u{03A5}",
    },
    NormalizationTest {
        source: "\u{03D3}",
        nfc: "\u{03D3}",
        nfd: "\u{03D2}\u{0301}",
        nfkc: "\u{038E}",
        nfkd: "\u{03A5}\u{0301}",
    },
    NormalizationTest {
        source: "\u{03D4}",
        nfc: "\u{03D4}",
        nfd: "\u{03D2}\u{0308}",
        nfkc: "\u{03AB}",
        nfkd: "\u{03A5}\u{0308}",
    },
    NormalizationTest {
        source: "\u{03D5}",
        nfc: "\u{03D5}",
        nfd: "\u{03D5}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{03D6}",
        nfc: "\u{03D6}",
        nfd: "\u{03D6}",
        nfkc: "\u{03C0}",
        nfkd: "\u{03C0}",
    },
    NormalizationTest {
        source: "\u{03F0}",
        nfc: "\u{03F0}",
        nfd: "\u{03F0}",
        nfkc: "\u{03BA}",
        nfkd: "\u{03BA}",
    },
    NormalizationTest {
        source: "\u{03F1}",
        nfc: "\u{03F1}",
        nfd: "\u{03F1}",
        nfkc: "\u{03C1}",
        nfkd: "\u{03C1}",
    },
    NormalizationTest {
        source: "\u{03F2}",
        nfc: "\u{03F2}",
        nfd: "\u{03F2}",
        nfkc: "\u{03C2}",
        nfkd: "\u{03C2}",
    },
    NormalizationTest {
        source: "\u{03F4}",
        nfc: "\u{03F4}",
        nfd: "\u{03F4}",
        nfkc: "\u{0398}",
        nfkd: "\u{0398}",
    },
    NormalizationTest {
        source: "\u{03F5}",
        nfc: "\u{03F5}",
        nfd: "\u{03F5}",
        nfkc: "\u{03B5}",
        nfkd: "\u{03B5}",
    },
    NormalizationTest {
        source: "\u{03F9}",
        nfc: "\u{03F9}",
        nfd: "\u{03F9}",
        nfkc: "\u{03A3}",
        nfkd: "\u{03A3}",
    },
    NormalizationTest {
        source: "\u{0400}",
        nfc: "\u{0400}",
        nfd: "\u{0415}\u{0300}",
        nfkc: "\u{0400}",
        nfkd: "\u{0415}\u{0300}",
    },
    NormalizationTest {
        source: "\u{0401}",
        nfc: "\u{0401}",
        nfd: "\u{0415}\u{0308}",
        nfkc: "\u{0401}",
        nfkd: "\u{0415}\u{0308}",
    },
    NormalizationTest {
        source: "\u{0403}",
        nfc: "\u{0403}",
        nfd: "\u{0413}\u{0301}",
        nfkc: "\u{0403}",
        nfkd: "\u{0413}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0407}",
        nfc: "\u{0407}",
        nfd: "\u{0406}\u{0308}",
        nfkc: "\u{0407}",
        nfkd: "\u{0406}\u{0308}",
    },
    NormalizationTest {
        source: "\u{040C}",
        nfc: "\u{040C}",
        nfd: "\u{041A}\u{0301}",
        nfkc: "\u{040C}",
        nfkd: "\u{041A}\u{0301}",
    },
    NormalizationTest {
        source: "\u{040D}",
        nfc: "\u{040D}",
        nfd: "\u{0418}\u{0300}",
        nfkc: "\u{040D}",
        nfkd: "\u{0418}\u{0300}",
    },
    NormalizationTest {
        source: "\u{040E}",
        nfc: "\u{040E}",
        nfd: "\u{0423}\u{0306}",
        nfkc: "\u{040E}",
        nfkd: "\u{0423}\u{0306}",
    },
    NormalizationTest {
        source: "\u{0419}",
        nfc: "\u{0419}",
        nfd: "\u{0418}\u{0306}",
        nfkc: "\u{0419}",
        nfkd: "\u{0418}\u{0306}",
    },
    NormalizationTest {
        source: "\u{0439}",
        nfc: "\u{0439}",
        nfd: "\u{0438}\u{0306}",
        nfkc: "\u{0439}",
        nfkd: "\u{0438}\u{0306}",
    },
    NormalizationTest {
        source: "\u{0450}",
        nfc: "\u{0450}",
        nfd: "\u{0435}\u{0300}",
        nfkc: "\u{0450}",
        nfkd: "\u{0435}\u{0300}",
    },
    NormalizationTest {
        source: "\u{0451}",
        nfc: "\u{0451}",
        nfd: "\u{0435}\u{0308}",
        nfkc: "\u{0451}",
        nfkd: "\u{0435}\u{0308}",
    },
    NormalizationTest {
        source: "\u{0453}",
        nfc: "\u{0453}",
        nfd: "\u{0433}\u{0301}",
        nfkc: "\u{0453}",
        nfkd: "\u{0433}\u{0301}",
    },
    NormalizationTest {
        source: "\u{0457}",
        nfc: "\u{0457}",
        nfd: "\u{0456}\u{0308}",
        nfkc: "\u{0457}",
        nfkd: "\u{0456}\u{0308}",
    },
    NormalizationTest {
        source: "\u{045C}",
        nfc: "\u{045C}",
        nfd: "\u{043A}\u{0301}",
        nfkc: "\u{045C}",
        nfkd: "\u{043A}\u{0301}",
    },
    NormalizationTest {
        source: "\u{045D}",
        nfc: "\u{045D}",
        nfd: "\u{0438}\u{0300}",
        nfkc: "\u{045D}",
        nfkd: "\u{0438}\u{0300}",
    },
    NormalizationTest {
        source: "\u{045E}",
        nfc: "\u{045E}",
        nfd: "\u{0443}\u{0306}",
        nfkc: "\u{045E}",
        nfkd: "\u{0443}\u{0306}",
    },
    NormalizationTest {
        source: "\u{0476}",
        nfc: "\u{0476}",
        nfd: "\u{0474}\u{030F}",
        nfkc: "\u{0476}",
        nfkd: "\u{0474}\u{030F}",
    },
    NormalizationTest {
        source: "\u{0477}",
        nfc: "\u{0477}",
        nfd: "\u{0475}\u{030F}",
        nfkc: "\u{0477}",
        nfkd: "\u{0475}\u{030F}",
    },
    NormalizationTest {
        source: "\u{04C1}",
        nfc: "\u{04C1}",
        nfd: "\u{0416}\u{0306}",
        nfkc: "\u{04C1}",
        nfkd: "\u{0416}\u{0306}",
    },
    NormalizationTest {
        source: "\u{04C2}",
        nfc: "\u{04C2}",
        nfd: "\u{0436}\u{0306}",
        nfkc: "\u{04C2}",
        nfkd: "\u{0436}\u{0306}",
    },
    NormalizationTest {
        source: "\u{04D0}",
        nfc: "\u{04D0}",
        nfd: "\u{0410}\u{0306}",
        nfkc: "\u{04D0}",
        nfkd: "\u{0410}\u{0306}",
    },
    NormalizationTest {
        source: "\u{04D1}",
        nfc: "\u{04D1}",
        nfd: "\u{0430}\u{0306}",
        nfkc: "\u{04D1}",
        nfkd: "\u{0430}\u{0306}",
    },
    NormalizationTest {
        source: "\u{04D2}",
        nfc: "\u{04D2}",
        nfd: "\u{0410}\u{0308}",
        nfkc: "\u{04D2}",
        nfkd: "\u{0410}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04D3}",
        nfc: "\u{04D3}",
        nfd: "\u{0430}\u{0308}",
        nfkc: "\u{04D3}",
        nfkd: "\u{0430}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04D6}",
        nfc: "\u{04D6}",
        nfd: "\u{0415}\u{0306}",
        nfkc: "\u{04D6}",
        nfkd: "\u{0415}\u{0306}",
    },
    NormalizationTest {
        source: "\u{04D7}",
        nfc: "\u{04D7}",
        nfd: "\u{0435}\u{0306}",
        nfkc: "\u{04D7}",
        nfkd: "\u{0435}\u{0306}",
    },
    NormalizationTest {
        source: "\u{04DA}",
        nfc: "\u{04DA}",
        nfd: "\u{04D8}\u{0308}",
        nfkc: "\u{04DA}",
        nfkd: "\u{04D8}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04DB}",
        nfc: "\u{04DB}",
        nfd: "\u{04D9}\u{0308}",
        nfkc: "\u{04DB}",
        nfkd: "\u{04D9}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04DC}",
        nfc: "\u{04DC}",
        nfd: "\u{0416}\u{0308}",
        nfkc: "\u{04DC}",
        nfkd: "\u{0416}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04DD}",
        nfc: "\u{04DD}",
        nfd: "\u{0436}\u{0308}",
        nfkc: "\u{04DD}",
        nfkd: "\u{0436}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04DE}",
        nfc: "\u{04DE}",
        nfd: "\u{0417}\u{0308}",
        nfkc: "\u{04DE}",
        nfkd: "\u{0417}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04DF}",
        nfc: "\u{04DF}",
        nfd: "\u{0437}\u{0308}",
        nfkc: "\u{04DF}",
        nfkd: "\u{0437}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04E2}",
        nfc: "\u{04E2}",
        nfd: "\u{0418}\u{0304}",
        nfkc: "\u{04E2}",
        nfkd: "\u{0418}\u{0304}",
    },
    NormalizationTest {
        source: "\u{04E3}",
        nfc: "\u{04E3}",
        nfd: "\u{0438}\u{0304}",
        nfkc: "\u{04E3}",
        nfkd: "\u{0438}\u{0304}",
    },
    NormalizationTest {
        source: "\u{04E4}",
        nfc: "\u{04E4}",
        nfd: "\u{0418}\u{0308}",
        nfkc: "\u{04E4}",
        nfkd: "\u{0418}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04E5}",
        nfc: "\u{04E5}",
        nfd: "\u{0438}\u{0308}",
        nfkc: "\u{04E5}",
        nfkd: "\u{0438}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04E6}",
        nfc: "\u{04E6}",
        nfd: "\u{041E}\u{0308}",
        nfkc: "\u{04E6}",
        nfkd: "\u{041E}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04E7}",
        nfc: "\u{04E7}",
        nfd: "\u{043E}\u{0308}",
        nfkc: "\u{04E7}",
        nfkd: "\u{043E}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04EA}",
        nfc: "\u{04EA}",
        nfd: "\u{04E8}\u{0308}",
        nfkc: "\u{04EA}",
        nfkd: "\u{04E8}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04EB}",
        nfc: "\u{04EB}",
        nfd: "\u{04E9}\u{0308}",
        nfkc: "\u{04EB}",
        nfkd: "\u{04E9}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04EC}",
        nfc: "\u{04EC}",
        nfd: "\u{042D}\u{0308}",
        nfkc: "\u{04EC}",
        nfkd: "\u{042D}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04ED}",
        nfc: "\u{04ED}",
        nfd: "\u{044D}\u{0308}",
        nfkc: "\u{04ED}",
        nfkd: "\u{044D}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04EE}",
        nfc: "\u{04EE}",
        nfd: "\u{0423}\u{0304}",
        nfkc: "\u{04EE}",
        nfkd: "\u{0423}\u{0304}",
    },
    NormalizationTest {
        source: "\u{04EF}",
        nfc: "\u{04EF}",
        nfd: "\u{0443}\u{0304}",
        nfkc: "\u{04EF}",
        nfkd: "\u{0443}\u{0304}",
    },
    NormalizationTest {
        source: "\u{04F0}",
        nfc: "\u{04F0}",
        nfd: "\u{0423}\u{0308}",
        nfkc: "\u{04F0}",
        nfkd: "\u{0423}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04F1}",
        nfc: "\u{04F1}",
        nfd: "\u{0443}\u{0308}",
        nfkc: "\u{04F1}",
        nfkd: "\u{0443}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04F2}",
        nfc: "\u{04F2}",
        nfd: "\u{0423}\u{030B}",
        nfkc: "\u{04F2}",
        nfkd: "\u{0423}\u{030B}",
    },
    NormalizationTest {
        source: "\u{04F3}",
        nfc: "\u{04F3}",
        nfd: "\u{0443}\u{030B}",
        nfkc: "\u{04F3}",
        nfkd: "\u{0443}\u{030B}",
    },
    NormalizationTest {
        source: "\u{04F4}",
        nfc: "\u{04F4}",
        nfd: "\u{0427}\u{0308}",
        nfkc: "\u{04F4}",
        nfkd: "\u{0427}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04F5}",
        nfc: "\u{04F5}",
        nfd: "\u{0447}\u{0308}",
        nfkc: "\u{04F5}",
        nfkd: "\u{0447}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04F8}",
        nfc: "\u{04F8}",
        nfd: "\u{042B}\u{0308}",
        nfkc: "\u{04F8}",
        nfkd: "\u{042B}\u{0308}",
    },
    NormalizationTest {
        source: "\u{04F9}",
        nfc: "\u{04F9}",
        nfd: "\u{044B}\u{0308}",
        nfkc: "\u{04F9}",
        nfkd: "\u{044B}\u{0308}",
    },
    NormalizationTest {
        source: "\u{0587}",
        nfc: "\u{0587}",
        nfd: "\u{0587}",
        nfkc: "\u{0565}\u{0582}",
        nfkd: "\u{0565}\u{0582}",
    },
    NormalizationTest {
        source: "\u{0622}",
        nfc: "\u{0622}",
        nfd: "\u{0627}\u{0653}",
        nfkc: "\u{0622}",
        nfkd: "\u{0627}\u{0653}",
    },
    NormalizationTest {
        source: "\u{0623}",
        nfc: "\u{0623}",
        nfd: "\u{0627}\u{0654}",
        nfkc: "\u{0623}",
        nfkd: "\u{0627}\u{0654}",
    },
    NormalizationTest {
        source: "\u{0624}",
        nfc: "\u{0624}",
        nfd: "\u{0648}\u{0654}",
        nfkc: "\u{0624}",
        nfkd: "\u{0648}\u{0654}",
    },
    NormalizationTest {
        source: "\u{0625}",
        nfc: "\u{0625}",
        nfd: "\u{0627}\u{0655}",
        nfkc: "\u{0625}",
        nfkd: "\u{0627}\u{0655}",
    },
    NormalizationTest {
        source: "\u{0626}",
        nfc: "\u{0626}",
        nfd: "\u{064A}\u{0654}",
        nfkc: "\u{0626}",
        nfkd: "\u{064A}\u{0654}",
    },
    NormalizationTest {
        source: "\u{0675}",
        nfc: "\u{0675}",
        nfd: "\u{0675}",
        nfkc: "\u{0627}\u{0674}",
        nfkd: "\u{0627}\u{0674}",
    },
    NormalizationTest {
        source: "\u{0676}",
        nfc: "\u{0676}",
        nfd: "\u{0676}",
        nfkc: "\u{0648}\u{0674}",
        nfkd: "\u{0648}\u{0674}",
    },
    NormalizationTest {
        source: "\u{0677}",
        nfc: "\u{0677}",
        nfd: "\u{0677}",
        nfkc: "\u{06C7}\u{0674}",
        nfkd: "\u{06C7}\u{0674}",
    },
    NormalizationTest {
        source: "\u{0678}",
        nfc: "\u{0678}",
        nfd: "\u{0678}",
        nfkc: "\u{064A}\u{0674}",
        nfkd: "\u{064A}\u{0674}",
    },
    NormalizationTest {
        source: "\u{06C0}",
        nfc: "\u{06C0}",
        nfd: "\u{06D5}\u{0654}",
        nfkc: "\u{06C0}",
        nfkd: "\u{06D5}\u{0654}",
    },
    NormalizationTest {
        source: "\u{06C2}",
        nfc: "\u{06C2}",
        nfd: "\u{06C1}\u{0654}",
        nfkc: "\u{06C2}",
        nfkd: "\u{06C1}\u{0654}",
    },
    NormalizationTest {
        source: "\u{06D3}",
        nfc: "\u{06D3}",
        nfd: "\u{06D2}\u{0654}",
        nfkc: "\u{06D3}",
        nfkd: "\u{06D2}\u{0654}",
    },
    NormalizationTest {
        source: "\u{0929}",
        nfc: "\u{0929}",
        nfd: "\u{0928}\u{093C}",
        nfkc: "\u{0929}",
        nfkd: "\u{0928}\u{093C}",
    },
    NormalizationTest {
        source: "\u{0931}",
        nfc: "\u{0931}",
        nfd: "\u{0930}\u{093C}",
        nfkc: "\u{0931}",
        nfkd: "\u{0930}\u{093C}",
    },
    NormalizationTest {
        source: "\u{0934}",
        nfc: "\u{0934}",
        nfd: "\u{0933}\u{093C}",
        nfkc: "\u{0934}",
        nfkd: "\u{0933}\u{093C}",
    },
    NormalizationTest {
        source: "\u{0958}",
        nfc: "\u{0915}\u{093C}",
        nfd: "\u{0915}\u{093C}",
        nfkc: "\u{0915}\u{093C}",
        nfkd: "\u{0915}\u{093C}",
    },
    NormalizationTest {
        source: "\u{0959}",
        nfc: "\u{0916}\u{093C}",
        nfd: "\u{0916}\u{093C}",
        nfkc: "\u{0916}\u{093C}",
        nfkd: "\u{0916}\u{093C}",
    },
    NormalizationTest {
        source: "\u{095A}",
        nfc: "\u{0917}\u{093C}",
        nfd: "\u{0917}\u{093C}",
        nfkc: "\u{0917}\u{093C}",
        nfkd: "\u{0917}\u{093C}",
    },
    NormalizationTest {
        source: "\u{095B}",
        nfc: "\u{091C}\u{093C}",
        nfd: "\u{091C}\u{093C}",
        nfkc: "\u{091C}\u{093C}",
        nfkd: "\u{091C}\u{093C}",
    },
    NormalizationTest {
        source: "\u{095C}",
        nfc: "\u{0921}\u{093C}",
        nfd: "\u{0921}\u{093C}",
        nfkc: "\u{0921}\u{093C}",
        nfkd: "\u{0921}\u{093C}",
    },
    NormalizationTest {
        source: "\u{095D}",
        nfc: "\u{0922}\u{093C}",
        nfd: "\u{0922}\u{093C}",
        nfkc: "\u{0922}\u{093C}",
        nfkd: "\u{0922}\u{093C}",
    },
    NormalizationTest {
        source: "\u{095E}",
        nfc: "\u{092B}\u{093C}",
        nfd: "\u{092B}\u{093C}",
        nfkc: "\u{092B}\u{093C}",
        nfkd: "\u{092B}\u{093C}",
    },
    NormalizationTest {
        source: "\u{095F}",
        nfc: "\u{092F}\u{093C}",
        nfd: "\u{092F}\u{093C}",
        nfkc: "\u{092F}\u{093C}",
        nfkd: "\u{092F}\u{093C}",
    },
    NormalizationTest {
        source: "\u{09CB}",
        nfc: "\u{09CB}",
        nfd: "\u{09C7}\u{09BE}",
        nfkc: "\u{09CB}",
        nfkd: "\u{09C7}\u{09BE}",
    },
    NormalizationTest {
        source: "\u{09CC}",
        nfc: "\u{09CC}",
        nfd: "\u{09C7}\u{09D7}",
        nfkc: "\u{09CC}",
        nfkd: "\u{09C7}\u{09D7}",
    },
    NormalizationTest {
        source: "\u{09DC}",
        nfc: "\u{09A1}\u{09BC}",
        nfd: "\u{09A1}\u{09BC}",
        nfkc: "\u{09A1}\u{09BC}",
        nfkd: "\u{09A1}\u{09BC}",
    },
    NormalizationTest {
        source: "\u{09DD}",
        nfc: "\u{09A2}\u{09BC}",
        nfd: "\u{09A2}\u{09BC}",
        nfkc: "\u{09A2}\u{09BC}",
        nfkd: "\u{09A2}\u{09BC}",
    },
    NormalizationTest {
        source: "\u{09DF}",
        nfc: "\u{09AF}\u{09BC}",
        nfd: "\u{09AF}\u{09BC}",
        nfkc: "\u{09AF}\u{09BC}",
        nfkd: "\u{09AF}\u{09BC}",
    },
    NormalizationTest {
        source: "\u{0A33}",
        nfc: "\u{0A32}\u{0A3C}",
        nfd: "\u{0A32}\u{0A3C}",
        nfkc: "\u{0A32}\u{0A3C}",
        nfkd: "\u{0A32}\u{0A3C}",
    },
    NormalizationTest {
        source: "\u{0A36}",
        nfc: "\u{0A38}\u{0A3C}",
        nfd: "\u{0A38}\u{0A3C}",
        nfkc: "\u{0A38}\u{0A3C}",
        nfkd: "\u{0A38}\u{0A3C}",
    },
    NormalizationTest {
        source: "\u{0A59}",
        nfc: "\u{0A16}\u{0A3C}",
        nfd: "\u{0A16}\u{0A3C}",
        nfkc: "\u{0A16}\u{0A3C}",
        nfkd: "\u{0A16}\u{0A3C}",
    },
    NormalizationTest {
        source: "\u{0A5A}",
        nfc: "\u{0A17}\u{0A3C}",
        nfd: "\u{0A17}\u{0A3C}",
        nfkc: "\u{0A17}\u{0A3C}",
        nfkd: "\u{0A17}\u{0A3C}",
    },
    NormalizationTest {
        source: "\u{0A5B}",
        nfc: "\u{0A1C}\u{0A3C}",
        nfd: "\u{0A1C}\u{0A3C}",
        nfkc: "\u{0A1C}\u{0A3C}",
        nfkd: "\u{0A1C}\u{0A3C}",
    },
    NormalizationTest {
        source: "\u{0A5E}",
        nfc: "\u{0A2B}\u{0A3C}",
        nfd: "\u{0A2B}\u{0A3C}",
        nfkc: "\u{0A2B}\u{0A3C}",
        nfkd: "\u{0A2B}\u{0A3C}",
    },
    NormalizationTest {
        source: "\u{0B48}",
        nfc: "\u{0B48}",
        nfd: "\u{0B47}\u{0B56}",
        nfkc: "\u{0B48}",
        nfkd: "\u{0B47}\u{0B56}",
    },
    NormalizationTest {
        source: "\u{0B4B}",
        nfc: "\u{0B4B}",
        nfd: "\u{0B47}\u{0B3E}",
        nfkc: "\u{0B4B}",
        nfkd: "\u{0B47}\u{0B3E}",
    },
    NormalizationTest {
        source: "\u{0B4C}",
        nfc: "\u{0B4C}",
        nfd: "\u{0B47}\u{0B57}",
        nfkc: "\u{0B4C}",
        nfkd: "\u{0B47}\u{0B57}",
    },
    NormalizationTest {
        source: "\u{0B5C}",
        nfc: "\u{0B21}\u{0B3C}",
        nfd: "\u{0B21}\u{0B3C}",
        nfkc: "\u{0B21}\u{0B3C}",
        nfkd: "\u{0B21}\u{0B3C}",
    },
    NormalizationTest {
        source: "\u{0B5D}",
        nfc: "\u{0B22}\u{0B3C}",
        nfd: "\u{0B22}\u{0B3C}",
        nfkc: "\u{0B22}\u{0B3C}",
        nfkd: "\u{0B22}\u{0B3C}",
    },
    NormalizationTest {
        source: "\u{0B94}",
        nfc: "\u{0B94}",
        nfd: "\u{0B92}\u{0BD7}",
        nfkc: "\u{0B94}",
        nfkd: "\u{0B92}\u{0BD7}",
    },
    NormalizationTest {
        source: "\u{0BCA}",
        nfc: "\u{0BCA}",
        nfd: "\u{0BC6}\u{0BBE}",
        nfkc: "\u{0BCA}",
        nfkd: "\u{0BC6}\u{0BBE}",
    },
    NormalizationTest {
        source: "\u{0BCB}",
        nfc: "\u{0BCB}",
        nfd: "\u{0BC7}\u{0BBE}",
        nfkc: "\u{0BCB}",
        nfkd: "\u{0BC7}\u{0BBE}",
    },
    NormalizationTest {
        source: "\u{0BCC}",
        nfc: "\u{0BCC}",
        nfd: "\u{0BC6}\u{0BD7}",
        nfkc: "\u{0BCC}",
        nfkd: "\u{0BC6}\u{0BD7}",
    },
    NormalizationTest {
        source: "\u{0C48}",
        nfc: "\u{0C48}",
        nfd: "\u{0C46}\u{0C56}",
        nfkc: "\u{0C48}",
        nfkd: "\u{0C46}\u{0C56}",
    },
    NormalizationTest {
        source: "\u{0CC0}",
        nfc: "\u{0CC0}",
        nfd: "\u{0CBF}\u{0CD5}",
        nfkc: "\u{0CC0}",
        nfkd: "\u{0CBF}\u{0CD5}",
    },
    NormalizationTest {
        source: "\u{0CC7}",
        nfc: "\u{0CC7}",
        nfd: "\u{0CC6}\u{0CD5}",
        nfkc: "\u{0CC7}",
        nfkd: "\u{0CC6}\u{0CD5}",
    },
    NormalizationTest {
        source: "\u{0CC8}",
        nfc: "\u{0CC8}",
        nfd: "\u{0CC6}\u{0CD6}",
        nfkc: "\u{0CC8}",
        nfkd: "\u{0CC6}\u{0CD6}",
    },
    NormalizationTest {
        source: "\u{0CCA}",
        nfc: "\u{0CCA}",
        nfd: "\u{0CC6}\u{0CC2}",
        nfkc: "\u{0CCA}",
        nfkd: "\u{0CC6}\u{0CC2}",
    },
    NormalizationTest {
        source: "\u{0CCB}",
        nfc: "\u{0CCB}",
        nfd: "\u{0CC6}\u{0CC2}\u{0CD5}",
        nfkc: "\u{0CCB}",
        nfkd: "\u{0CC6}\u{0CC2}\u{0CD5}",
    },
    NormalizationTest {
        source: "\u{0D4A}",
        nfc: "\u{0D4A}",
        nfd: "\u{0D46}\u{0D3E}",
        nfkc: "\u{0D4A}",
        nfkd: "\u{0D46}\u{0D3E}",
    },
    NormalizationTest {
        source: "\u{0D4B}",
        nfc: "\u{0D4B}",
        nfd: "\u{0D47}\u{0D3E}",
        nfkc: "\u{0D4B}",
        nfkd: "\u{0D47}\u{0D3E}",
    },
    NormalizationTest {
        source: "\u{0D4C}",
        nfc: "\u{0D4C}",
        nfd: "\u{0D46}\u{0D57}",
        nfkc: "\u{0D4C}",
        nfkd: "\u{0D46}\u{0D57}",
    },
    NormalizationTest {
        source: "\u{0DDA}",
        nfc: "\u{0DDA}",
        nfd: "\u{0DD9}\u{0DCA}",
        nfkc: "\u{0DDA}",
        nfkd: "\u{0DD9}\u{0DCA}",
    },
    NormalizationTest {
        source: "\u{0DDC}",
        nfc: "\u{0DDC}",
        nfd: "\u{0DD9}\u{0DCF}",
        nfkc: "\u{0DDC}",
        nfkd: "\u{0DD9}\u{0DCF}",
    },
    NormalizationTest {
        source: "\u{0DDD}",
        nfc: "\u{0DDD}",
        nfd: "\u{0DD9}\u{0DCF}\u{0DCA}",
        nfkc: "\u{0DDD}",
        nfkd: "\u{0DD9}\u{0DCF}\u{0DCA}",
    },
    NormalizationTest {
        source: "\u{0DDE}",
        nfc: "\u{0DDE}",
        nfd: "\u{0DD9}\u{0DDF}",
        nfkc: "\u{0DDE}",
        nfkd: "\u{0DD9}\u{0DDF}",
    },
    NormalizationTest {
        source: "\u{0E33}",
        nfc: "\u{0E33}",
        nfd: "\u{0E33}",
        nfkc: "\u{0E4D}\u{0E32}",
        nfkd: "\u{0E4D}\u{0E32}",
    },
    NormalizationTest {
        source: "\u{0EB3}",
        nfc: "\u{0EB3}",
        nfd: "\u{0EB3}",
        nfkc: "\u{0ECD}\u{0EB2}",
        nfkd: "\u{0ECD}\u{0EB2}",
    },
    NormalizationTest {
        source: "\u{0EDC}",
        nfc: "\u{0EDC}",
        nfd: "\u{0EDC}",
        nfkc: "\u{0EAB}\u{0E99}",
        nfkd: "\u{0EAB}\u{0E99}",
    },
    NormalizationTest {
        source: "\u{0EDD}",
        nfc: "\u{0EDD}",
        nfd: "\u{0EDD}",
        nfkc: "\u{0EAB}\u{0EA1}",
        nfkd: "\u{0EAB}\u{0EA1}",
    },
    NormalizationTest {
        source: "\u{0F0C}",
        nfc: "\u{0F0C}",
        nfd: "\u{0F0C}",
        nfkc: "\u{0F0B}",
        nfkd: "\u{0F0B}",
    },
    NormalizationTest {
        source: "\u{0F43}",
        nfc: "\u{0F42}\u{0FB7}",
        nfd: "\u{0F42}\u{0FB7}",
        nfkc: "\u{0F42}\u{0FB7}",
        nfkd: "\u{0F42}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0F4D}",
        nfc: "\u{0F4C}\u{0FB7}",
        nfd: "\u{0F4C}\u{0FB7}",
        nfkc: "\u{0F4C}\u{0FB7}",
        nfkd: "\u{0F4C}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0F52}",
        nfc: "\u{0F51}\u{0FB7}",
        nfd: "\u{0F51}\u{0FB7}",
        nfkc: "\u{0F51}\u{0FB7}",
        nfkd: "\u{0F51}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0F57}",
        nfc: "\u{0F56}\u{0FB7}",
        nfd: "\u{0F56}\u{0FB7}",
        nfkc: "\u{0F56}\u{0FB7}",
        nfkd: "\u{0F56}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0F5C}",
        nfc: "\u{0F5B}\u{0FB7}",
        nfd: "\u{0F5B}\u{0FB7}",
        nfkc: "\u{0F5B}\u{0FB7}",
        nfkd: "\u{0F5B}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0F69}",
        nfc: "\u{0F40}\u{0FB5}",
        nfd: "\u{0F40}\u{0FB5}",
        nfkc: "\u{0F40}\u{0FB5}",
        nfkd: "\u{0F40}\u{0FB5}",
    },
    NormalizationTest {
        source: "\u{0F73}",
        nfc: "\u{0F71}\u{0F72}",
        nfd: "\u{0F71}\u{0F72}",
        nfkc: "\u{0F71}\u{0F72}",
        nfkd: "\u{0F71}\u{0F72}",
    },
    NormalizationTest {
        source: "\u{0F75}",
        nfc: "\u{0F71}\u{0F74}",
        nfd: "\u{0F71}\u{0F74}",
        nfkc: "\u{0F71}\u{0F74}",
        nfkd: "\u{0F71}\u{0F74}",
    },
    NormalizationTest {
        source: "\u{0F76}",
        nfc: "\u{0FB2}\u{0F80}",
        nfd: "\u{0FB2}\u{0F80}",
        nfkc: "\u{0FB2}\u{0F80}",
        nfkd: "\u{0FB2}\u{0F80}",
    },
    NormalizationTest {
        source: "\u{0F77}",
        nfc: "\u{0F77}",
        nfd: "\u{0F77}",
        nfkc: "\u{0FB2}\u{0F71}\u{0F80}",
        nfkd: "\u{0FB2}\u{0F71}\u{0F80}",
    },
    NormalizationTest {
        source: "\u{0F78}",
        nfc: "\u{0FB3}\u{0F80}",
        nfd: "\u{0FB3}\u{0F80}",
        nfkc: "\u{0FB3}\u{0F80}",
        nfkd: "\u{0FB3}\u{0F80}",
    },
    NormalizationTest {
        source: "\u{0F79}",
        nfc: "\u{0F79}",
        nfd: "\u{0F79}",
        nfkc: "\u{0FB3}\u{0F71}\u{0F80}",
        nfkd: "\u{0FB3}\u{0F71}\u{0F80}",
    },
    NormalizationTest {
        source: "\u{0F81}",
        nfc: "\u{0F71}\u{0F80}",
        nfd: "\u{0F71}\u{0F80}",
        nfkc: "\u{0F71}\u{0F80}",
        nfkd: "\u{0F71}\u{0F80}",
    },
    NormalizationTest {
        source: "\u{0F93}",
        nfc: "\u{0F92}\u{0FB7}",
        nfd: "\u{0F92}\u{0FB7}",
        nfkc: "\u{0F92}\u{0FB7}",
        nfkd: "\u{0F92}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0F9D}",
        nfc: "\u{0F9C}\u{0FB7}",
        nfd: "\u{0F9C}\u{0FB7}",
        nfkc: "\u{0F9C}\u{0FB7}",
        nfkd: "\u{0F9C}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0FA2}",
        nfc: "\u{0FA1}\u{0FB7}",
        nfd: "\u{0FA1}\u{0FB7}",
        nfkc: "\u{0FA1}\u{0FB7}",
        nfkd: "\u{0FA1}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0FA7}",
        nfc: "\u{0FA6}\u{0FB7}",
        nfd: "\u{0FA6}\u{0FB7}",
        nfkc: "\u{0FA6}\u{0FB7}",
        nfkd: "\u{0FA6}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0FAC}",
        nfc: "\u{0FAB}\u{0FB7}",
        nfd: "\u{0FAB}\u{0FB7}",
        nfkc: "\u{0FAB}\u{0FB7}",
        nfkd: "\u{0FAB}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0FB9}",
        nfc: "\u{0F90}\u{0FB5}",
        nfd: "\u{0F90}\u{0FB5}",
        nfkc: "\u{0F90}\u{0FB5}",
        nfkd: "\u{0F90}\u{0FB5}",
    },
    NormalizationTest {
        source: "\u{1026}",
        nfc: "\u{1026}",
        nfd: "\u{1025}\u{102E}",
        nfkc: "\u{1026}",
        nfkd: "\u{1025}\u{102E}",
    },
    NormalizationTest {
        source: "\u{10FC}",
        nfc: "\u{10FC}",
        nfd: "\u{10FC}",
        nfkc: "\u{10DC}",
        nfkd: "\u{10DC}",
    },
    NormalizationTest {
        source: "\u{1B06}",
        nfc: "\u{1B06}",
        nfd: "\u{1B05}\u{1B35}",
        nfkc: "\u{1B06}",
        nfkd: "\u{1B05}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B08}",
        nfc: "\u{1B08}",
        nfd: "\u{1B07}\u{1B35}",
        nfkc: "\u{1B08}",
        nfkd: "\u{1B07}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B0A}",
        nfc: "\u{1B0A}",
        nfd: "\u{1B09}\u{1B35}",
        nfkc: "\u{1B0A}",
        nfkd: "\u{1B09}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B0C}",
        nfc: "\u{1B0C}",
        nfd: "\u{1B0B}\u{1B35}",
        nfkc: "\u{1B0C}",
        nfkd: "\u{1B0B}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B0E}",
        nfc: "\u{1B0E}",
        nfd: "\u{1B0D}\u{1B35}",
        nfkc: "\u{1B0E}",
        nfkd: "\u{1B0D}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B12}",
        nfc: "\u{1B12}",
        nfd: "\u{1B11}\u{1B35}",
        nfkc: "\u{1B12}",
        nfkd: "\u{1B11}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B3B}",
        nfc: "\u{1B3B}",
        nfd: "\u{1B3A}\u{1B35}",
        nfkc: "\u{1B3B}",
        nfkd: "\u{1B3A}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B3D}",
        nfc: "\u{1B3D}",
        nfd: "\u{1B3C}\u{1B35}",
        nfkc: "\u{1B3D}",
        nfkd: "\u{1B3C}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B40}",
        nfc: "\u{1B40}",
        nfd: "\u{1B3E}\u{1B35}",
        nfkc: "\u{1B40}",
        nfkd: "\u{1B3E}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B41}",
        nfc: "\u{1B41}",
        nfd: "\u{1B3F}\u{1B35}",
        nfkc: "\u{1B41}",
        nfkd: "\u{1B3F}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B43}",
        nfc: "\u{1B43}",
        nfd: "\u{1B42}\u{1B35}",
        nfkc: "\u{1B43}",
        nfkd: "\u{1B42}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1D2C}",
        nfc: "\u{1D2C}",
        nfd: "\u{1D2C}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D2D}",
        nfc: "\u{1D2D}",
        nfd: "\u{1D2D}",
        nfkc: "\u{00C6}",
        nfkd: "\u{00C6}",
    },
    NormalizationTest {
        source: "\u{1D2E}",
        nfc: "\u{1D2E}",
        nfd: "\u{1D2E}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D30}",
        nfc: "\u{1D30}",
        nfd: "\u{1D30}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D31}",
        nfc: "\u{1D31}",
        nfd: "\u{1D31}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D32}",
        nfc: "\u{1D32}",
        nfd: "\u{1D32}",
        nfkc: "\u{018E}",
        nfkd: "\u{018E}",
    },
    NormalizationTest {
        source: "\u{1D33}",
        nfc: "\u{1D33}",
        nfd: "\u{1D33}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D34}",
        nfc: "\u{1D34}",
        nfd: "\u{1D34}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{1D35}",
        nfc: "\u{1D35}",
        nfd: "\u{1D35}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1D36}",
        nfc: "\u{1D36}",
        nfd: "\u{1D36}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D37}",
        nfc: "\u{1D37}",
        nfd: "\u{1D37}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D38}",
        nfc: "\u{1D38}",
        nfd: "\u{1D38}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D39}",
        nfc: "\u{1D39}",
        nfd: "\u{1D39}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D3A}",
        nfc: "\u{1D3A}",
        nfd: "\u{1D3A}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D3C}",
        nfc: "\u{1D3C}",
        nfd: "\u{1D3C}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D3D}",
        nfc: "\u{1D3D}",
        nfd: "\u{1D3D}",
        nfkc: "\u{0222}",
        nfkd: "\u{0222}",
    },
    NormalizationTest {
        source: "\u{1D3E}",
        nfc: "\u{1D3E}",
        nfd: "\u{1D3E}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D3F}",
        nfc: "\u{1D3F}",
        nfd: "\u{1D3F}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1D40}",
        nfc: "\u{1D40}",
        nfd: "\u{1D40}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D41}",
        nfc: "\u{1D41}",
        nfd: "\u{1D41}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D42}",
        nfc: "\u{1D42}",
        nfd: "\u{1D42}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D43}",
        nfc: "\u{1D43}",
        nfd: "\u{1D43}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D44}",
        nfc: "\u{1D44}",
        nfd: "\u{1D44}",
        nfkc: "\u{0250}",
        nfkd: "\u{0250}",
    },
    NormalizationTest {
        source: "\u{1D45}",
        nfc: "\u{1D45}",
        nfd: "\u{1D45}",
        nfkc: "\u{0251}",
        nfkd: "\u{0251}",
    },
    NormalizationTest {
        source: "\u{1D46}",
        nfc: "\u{1D46}",
        nfd: "\u{1D46}",
        nfkc: "\u{1D02}",
        nfkd: "\u{1D02}",
    },
    NormalizationTest {
        source: "\u{1D47}",
        nfc: "\u{1D47}",
        nfd: "\u{1D47}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D48}",
        nfc: "\u{1D48}",
        nfd: "\u{1D48}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D49}",
        nfc: "\u{1D49}",
        nfd: "\u{1D49}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D4A}",
        nfc: "\u{1D4A}",
        nfd: "\u{1D4A}",
        nfkc: "\u{0259}",
        nfkd: "\u{0259}",
    },
    NormalizationTest {
        source: "\u{1D4B}",
        nfc: "\u{1D4B}",
        nfd: "\u{1D4B}",
        nfkc: "\u{025B}",
        nfkd: "\u{025B}",
    },
    NormalizationTest {
        source: "\u{1D4C}",
        nfc: "\u{1D4C}",
        nfd: "\u{1D4C}",
        nfkc: "\u{025C}",
        nfkd: "\u{025C}",
    },
    NormalizationTest {
        source: "\u{1D4D}",
        nfc: "\u{1D4D}",
        nfd: "\u{1D4D}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D4F}",
        nfc: "\u{1D4F}",
        nfd: "\u{1D4F}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D50}",
        nfc: "\u{1D50}",
        nfd: "\u{1D50}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D51}",
        nfc: "\u{1D51}",
        nfd: "\u{1D51}",
        nfkc: "\u{014B}",
        nfkd: "\u{014B}",
    },
    NormalizationTest {
        source: "\u{1D52}",
        nfc: "\u{1D52}",
        nfd: "\u{1D52}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D53}",
        nfc: "\u{1D53}",
        nfd: "\u{1D53}",
        nfkc: "\u{0254}",
        nfkd: "\u{0254}",
    },
    NormalizationTest {
        source: "\u{1D54}",
        nfc: "\u{1D54}",
        nfd: "\u{1D54}",
        nfkc: "\u{1D16}",
        nfkd: "\u{1D16}",
    },
    NormalizationTest {
        source: "\u{1D55}",
        nfc: "\u{1D55}",
        nfd: "\u{1D55}",
        nfkc: "\u{1D17}",
        nfkd: "\u{1D17}",
    },
    NormalizationTest {
        source: "\u{1D56}",
        nfc: "\u{1D56}",
        nfd: "\u{1D56}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D57}",
        nfc: "\u{1D57}",
        nfd: "\u{1D57}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D58}",
        nfc: "\u{1D58}",
        nfd: "\u{1D58}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D59}",
        nfc: "\u{1D59}",
        nfd: "\u{1D59}",
        nfkc: "\u{1D1D}",
        nfkd: "\u{1D1D}",
    },
    NormalizationTest {
        source: "\u{1D5A}",
        nfc: "\u{1D5A}",
        nfd: "\u{1D5A}",
        nfkc: "\u{026F}",
        nfkd: "\u{026F}",
    },
    NormalizationTest {
        source: "\u{1D5B}",
        nfc: "\u{1D5B}",
        nfd: "\u{1D5B}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D5C}",
        nfc: "\u{1D5C}",
        nfd: "\u{1D5C}",
        nfkc: "\u{1D25}",
        nfkd: "\u{1D25}",
    },
    NormalizationTest {
        source: "\u{1D5D}",
        nfc: "\u{1D5D}",
        nfd: "\u{1D5D}",
        nfkc: "\u{03B2}",
        nfkd: "\u{03B2}",
    },
    NormalizationTest {
        source: "\u{1D5E}",
        nfc: "\u{1D5E}",
        nfd: "\u{1D5E}",
        nfkc: "\u{03B3}",
        nfkd: "\u{03B3}",
    },
    NormalizationTest {
        source: "\u{1D5F}",
        nfc: "\u{1D5F}",
        nfd: "\u{1D5F}",
        nfkc: "\u{03B4}",
        nfkd: "\u{03B4}",
    },
    NormalizationTest {
        source: "\u{1D60}",
        nfc: "\u{1D60}",
        nfd: "\u{1D60}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{1D61}",
        nfc: "\u{1D61}",
        nfd: "\u{1D61}",
        nfkc: "\u{03C7}",
        nfkd: "\u{03C7}",
    },
    NormalizationTest {
        source: "\u{1D62}",
        nfc: "\u{1D62}",
        nfd: "\u{1D62}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D63}",
        nfc: "\u{1D63}",
        nfd: "\u{1D63}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D64}",
        nfc: "\u{1D64}",
        nfd: "\u{1D64}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D65}",
        nfc: "\u{1D65}",
        nfd: "\u{1D65}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D66}",
        nfc: "\u{1D66}",
        nfd: "\u{1D66}",
        nfkc: "\u{03B2}",
        nfkd: "\u{03B2}",
    },
    NormalizationTest {
        source: "\u{1D67}",
        nfc: "\u{1D67}",
        nfd: "\u{1D67}",
        nfkc: "\u{03B3}",
        nfkd: "\u{03B3}",
    },
    NormalizationTest {
        source: "\u{1D68}",
        nfc: "\u{1D68}",
        nfd: "\u{1D68}",
        nfkc: "\u{03C1}",
        nfkd: "\u{03C1}",
    },
    NormalizationTest {
        source: "\u{1D69}",
        nfc: "\u{1D69}",
        nfd: "\u{1D69}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{1D6A}",
        nfc: "\u{1D6A}",
        nfd: "\u{1D6A}",
        nfkc: "\u{03C7}",
        nfkd: "\u{03C7}",
    },
    NormalizationTest {
        source: "\u{1D78}",
        nfc: "\u{1D78}",
        nfd: "\u{1D78}",
        nfkc: "\u{043D}",
        nfkd: "\u{043D}",
    },
    NormalizationTest {
        source: "\u{1D9B}",
        nfc: "\u{1D9B}",
        nfd: "\u{1D9B}",
        nfkc: "\u{0252}",
        nfkd: "\u{0252}",
    },
    NormalizationTest {
        source: "\u{1D9C}",
        nfc: "\u{1D9C}",
        nfd: "\u{1D9C}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D9D}",
        nfc: "\u{1D9D}",
        nfd: "\u{1D9D}",
        nfkc: "\u{0255}",
        nfkd: "\u{0255}",
    },
    NormalizationTest {
        source: "\u{1D9E}",
        nfc: "\u{1D9E}",
        nfd: "\u{1D9E}",
        nfkc: "\u{00F0}",
        nfkd: "\u{00F0}",
    },
    NormalizationTest {
        source: "\u{1D9F}",
        nfc: "\u{1D9F}",
        nfd: "\u{1D9F}",
        nfkc: "\u{025C}",
        nfkd: "\u{025C}",
    },
    NormalizationTest {
        source: "\u{1DA0}",
        nfc: "\u{1DA0}",
        nfd: "\u{1DA0}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1DA1}",
        nfc: "\u{1DA1}",
        nfd: "\u{1DA1}",
        nfkc: "\u{025F}",
        nfkd: "\u{025F}",
    },
    NormalizationTest {
        source: "\u{1DA2}",
        nfc: "\u{1DA2}",
        nfd: "\u{1DA2}",
        nfkc: "\u{0261}",
        nfkd: "\u{0261}",
    },
    NormalizationTest {
        source: "\u{1DA3}",
        nfc: "\u{1DA3}",
        nfd: "\u{1DA3}",
        nfkc: "\u{0265}",
        nfkd: "\u{0265}",
    },
    NormalizationTest {
        source: "\u{1DA4}",
        nfc: "\u{1DA4}",
        nfd: "\u{1DA4}",
        nfkc: "\u{0268}",
        nfkd: "\u{0268}",
    },
    NormalizationTest {
        source: "\u{1DA5}",
        nfc: "\u{1DA5}",
        nfd: "\u{1DA5}",
        nfkc: "\u{0269}",
        nfkd: "\u{0269}",
    },
    NormalizationTest {
        source: "\u{1DA6}",
        nfc: "\u{1DA6}",
        nfd: "\u{1DA6}",
        nfkc: "\u{026A}",
        nfkd: "\u{026A}",
    },
    NormalizationTest {
        source: "\u{1DA7}",
        nfc: "\u{1DA7}",
        nfd: "\u{1DA7}",
        nfkc: "\u{1D7B}",
        nfkd: "\u{1D7B}",
    },
    NormalizationTest {
        source: "\u{1DA8}",
        nfc: "\u{1DA8}",
        nfd: "\u{1DA8}",
        nfkc: "\u{029D}",
        nfkd: "\u{029D}",
    },
    NormalizationTest {
        source: "\u{1DA9}",
        nfc: "\u{1DA9}",
        nfd: "\u{1DA9}",
        nfkc: "\u{026D}",
        nfkd: "\u{026D}",
    },
    NormalizationTest {
        source: "\u{1DAA}",
        nfc: "\u{1DAA}",
        nfd: "\u{1DAA}",
        nfkc: "\u{1D85}",
        nfkd: "\u{1D85}",
    },
    NormalizationTest {
        source: "\u{1DAB}",
        nfc: "\u{1DAB}",
        nfd: "\u{1DAB}",
        nfkc: "\u{029F}",
        nfkd: "\u{029F}",
    },
    NormalizationTest {
        source: "\u{1DAC}",
        nfc: "\u{1DAC}",
        nfd: "\u{1DAC}",
        nfkc: "\u{0271}",
        nfkd: "\u{0271}",
    },
    NormalizationTest {
        source: "\u{1DAD}",
        nfc: "\u{1DAD}",
        nfd: "\u{1DAD}",
        nfkc: "\u{0270}",
        nfkd: "\u{0270}",
    },
    NormalizationTest {
        source: "\u{1DAE}",
        nfc: "\u{1DAE}",
        nfd: "\u{1DAE}",
        nfkc: "\u{0272}",
        nfkd: "\u{0272}",
    },
    NormalizationTest {
        source: "\u{1DAF}",
        nfc: "\u{1DAF}",
        nfd: "\u{1DAF}",
        nfkc: "\u{0273}",
        nfkd: "\u{0273}",
    },
    NormalizationTest {
        source: "\u{1DB0}",
        nfc: "\u{1DB0}",
        nfd: "\u{1DB0}",
        nfkc: "\u{0274}",
        nfkd: "\u{0274}",
    },
    NormalizationTest {
        source: "\u{1DB1}",
        nfc: "\u{1DB1}",
        nfd: "\u{1DB1}",
        nfkc: "\u{0275}",
        nfkd: "\u{0275}",
    },
    NormalizationTest {
        source: "\u{1DB2}",
        nfc: "\u{1DB2}",
        nfd: "\u{1DB2}",
        nfkc: "\u{0278}",
        nfkd: "\u{0278}",
    },
    NormalizationTest {
        source: "\u{1DB3}",
        nfc: "\u{1DB3}",
        nfd: "\u{1DB3}",
        nfkc: "\u{0282}",
        nfkd: "\u{0282}",
    },
    NormalizationTest {
        source: "\u{1DB4}",
        nfc: "\u{1DB4}",
        nfd: "\u{1DB4}",
        nfkc: "\u{0283}",
        nfkd: "\u{0283}",
    },
    NormalizationTest {
        source: "\u{1DB5}",
        nfc: "\u{1DB5}",
        nfd: "\u{1DB5}",
        nfkc: "\u{01AB}",
        nfkd: "\u{01AB}",
    },
    NormalizationTest {
        source: "\u{1DB6}",
        nfc: "\u{1DB6}",
        nfd: "\u{1DB6}",
        nfkc: "\u{0289}",
        nfkd: "\u{0289}",
    },
    NormalizationTest {
        source: "\u{1DB7}",
        nfc: "\u{1DB7}",
        nfd: "\u{1DB7}",
        nfkc: "\u{028A}",
        nfkd: "\u{028A}",
    },
    NormalizationTest {
        source: "\u{1DB8}",
        nfc: "\u{1DB8}",
        nfd: "\u{1DB8}",
        nfkc: "\u{1D1C}",
        nfkd: "\u{1D1C}",
    },
    NormalizationTest {
        source: "\u{1DB9}",
        nfc: "\u{1DB9}",
        nfd: "\u{1DB9}",
        nfkc: "\u{028B}",
        nfkd: "\u{028B}",
    },
    NormalizationTest {
        source: "\u{1DBA}",
        nfc: "\u{1DBA}",
        nfd: "\u{1DBA}",
        nfkc: "\u{028C}",
        nfkd: "\u{028C}",
    },
    NormalizationTest {
        source: "\u{1DBB}",
        nfc: "\u{1DBB}",
        nfd: "\u{1DBB}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1DBC}",
        nfc: "\u{1DBC}",
        nfd: "\u{1DBC}",
        nfkc: "\u{0290}",
        nfkd: "\u{0290}",
    },
    NormalizationTest {
        source: "\u{1DBD}",
        nfc: "\u{1DBD}",
        nfd: "\u{1DBD}",
        nfkc: "\u{0291}",
        nfkd: "\u{0291}",
    },
    NormalizationTest {
        source: "\u{1DBE}",
        nfc: "\u{1DBE}",
        nfd: "\u{1DBE}",
        nfkc: "\u{0292}",
        nfkd: "\u{0292}",
    },
    NormalizationTest {
        source: "\u{1DBF}",
        nfc: "\u{1DBF}",
        nfd: "\u{1DBF}",
        nfkc: "\u{03B8}",
        nfkd: "\u{03B8}",
    },
    NormalizationTest {
        source: "\u{1E00}",
        nfc: "\u{1E00}",
        nfd: "\u{0041}\u{0325}",
        nfkc: "\u{1E00}",
        nfkd: "\u{0041}\u{0325}",
    },
    NormalizationTest {
        source: "\u{1E01}",
        nfc: "\u{1E01}",
        nfd: "\u{0061}\u{0325}",
        nfkc: "\u{1E01}",
        nfkd: "\u{0061}\u{0325}",
    },
    NormalizationTest {
        source: "\u{1E02}",
        nfc: "\u{1E02}",
        nfd: "\u{0042}\u{0307}",
        nfkc: "\u{1E02}",
        nfkd: "\u{0042}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E03}",
        nfc: "\u{1E03}",
        nfd: "\u{0062}\u{0307}",
        nfkc: "\u{1E03}",
        nfkd: "\u{0062}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E04}",
        nfc: "\u{1E04}",
        nfd: "\u{0042}\u{0323}",
        nfkc: "\u{1E04}",
        nfkd: "\u{0042}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E05}",
        nfc: "\u{1E05}",
        nfd: "\u{0062}\u{0323}",
        nfkc: "\u{1E05}",
        nfkd: "\u{0062}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E06}",
        nfc: "\u{1E06}",
        nfd: "\u{0042}\u{0331}",
        nfkc: "\u{1E06}",
        nfkd: "\u{0042}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E07}",
        nfc: "\u{1E07}",
        nfd: "\u{0062}\u{0331}",
        nfkc: "\u{1E07}",
        nfkd: "\u{0062}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E08}",
        nfc: "\u{1E08}",
        nfd: "\u{0043}\u{0327}\u{0301}",
        nfkc: "\u{1E08}",
        nfkd: "\u{0043}\u{0327}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E09}",
        nfc: "\u{1E09}",
        nfd: "\u{0063}\u{0327}\u{0301}",
        nfkc: "\u{1E09}",
        nfkd: "\u{0063}\u{0327}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E0A}",
        nfc: "\u{1E0A}",
        nfd: "\u{0044}\u{0307}",
        nfkc: "\u{1E0A}",
        nfkd: "\u{0044}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E0B}",
        nfc: "\u{1E0B}",
        nfd: "\u{0064}\u{0307}",
        nfkc: "\u{1E0B}",
        nfkd: "\u{0064}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E0C}",
        nfc: "\u{1E0C}",
        nfd: "\u{0044}\u{0323}",
        nfkc: "\u{1E0C}",
        nfkd: "\u{0044}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E0D}",
        nfc: "\u{1E0D}",
        nfd: "\u{0064}\u{0323}",
        nfkc: "\u{1E0D}",
        nfkd: "\u{0064}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E0E}",
        nfc: "\u{1E0E}",
        nfd: "\u{0044}\u{0331}",
        nfkc: "\u{1E0E}",
        nfkd: "\u{0044}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E0F}",
        nfc: "\u{1E0F}",
        nfd: "\u{0064}\u{0331}",
        nfkc: "\u{1E0F}",
        nfkd: "\u{0064}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E10}",
        nfc: "\u{1E10}",
        nfd: "\u{0044}\u{0327}",
        nfkc: "\u{1E10}",
        nfkd: "\u{0044}\u{0327}",
    },
    NormalizationTest {
        source: "\u{1E11}",
        nfc: "\u{1E11}",
        nfd: "\u{0064}\u{0327}",
        nfkc: "\u{1E11}",
        nfkd: "\u{0064}\u{0327}",
    },
    NormalizationTest {
        source: "\u{1E12}",
        nfc: "\u{1E12}",
        nfd: "\u{0044}\u{032D}",
        nfkc: "\u{1E12}",
        nfkd: "\u{0044}\u{032D}",
    },
    NormalizationTest {
        source: "\u{1E13}",
        nfc: "\u{1E13}",
        nfd: "\u{0064}\u{032D}",
        nfkc: "\u{1E13}",
        nfkd: "\u{0064}\u{032D}",
    },
    NormalizationTest {
        source: "\u{1E14}",
        nfc: "\u{1E14}",
        nfd: "\u{0045}\u{0304}\u{0300}",
        nfkc: "\u{1E14}",
        nfkd: "\u{0045}\u{0304}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1E15}",
        nfc: "\u{1E15}",
        nfd: "\u{0065}\u{0304}\u{0300}",
        nfkc: "\u{1E15}",
        nfkd: "\u{0065}\u{0304}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1E16}",
        nfc: "\u{1E16}",
        nfd: "\u{0045}\u{0304}\u{0301}",
        nfkc: "\u{1E16}",
        nfkd: "\u{0045}\u{0304}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E17}",
        nfc: "\u{1E17}",
        nfd: "\u{0065}\u{0304}\u{0301}",
        nfkc: "\u{1E17}",
        nfkd: "\u{0065}\u{0304}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E18}",
        nfc: "\u{1E18}",
        nfd: "\u{0045}\u{032D}",
        nfkc: "\u{1E18}",
        nfkd: "\u{0045}\u{032D}",
    },
    NormalizationTest {
        source: "\u{1E19}",
        nfc: "\u{1E19}",
        nfd: "\u{0065}\u{032D}",
        nfkc: "\u{1E19}",
        nfkd: "\u{0065}\u{032D}",
    },
    NormalizationTest {
        source: "\u{1E1A}",
        nfc: "\u{1E1A}",
        nfd: "\u{0045}\u{0330}",
        nfkc: "\u{1E1A}",
        nfkd: "\u{0045}\u{0330}",
    },
    NormalizationTest {
        source: "\u{1E1B}",
        nfc: "\u{1E1B}",
        nfd: "\u{0065}\u{0330}",
        nfkc: "\u{1E1B}",
        nfkd: "\u{0065}\u{0330}",
    },
    NormalizationTest {
        source: "\u{1E1C}",
        nfc: "\u{1E1C}",
        nfd: "\u{0045}\u{0327}\u{0306}",
        nfkc: "\u{1E1C}",
        nfkd: "\u{0045}\u{0327}\u{0306}",
    },
    NormalizationTest {
        source: "\u{1E1D}",
        nfc: "\u{1E1D}",
        nfd: "\u{0065}\u{0327}\u{0306}",
        nfkc: "\u{1E1D}",
        nfkd: "\u{0065}\u{0327}\u{0306}",
    },
    NormalizationTest {
        source: "\u{1E1E}",
        nfc: "\u{1E1E}",
        nfd: "\u{0046}\u{0307}",
        nfkc: "\u{1E1E}",
        nfkd: "\u{0046}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E1F}",
        nfc: "\u{1E1F}",
        nfd: "\u{0066}\u{0307}",
        nfkc: "\u{1E1F}",
        nfkd: "\u{0066}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E20}",
        nfc: "\u{1E20}",
        nfd: "\u{0047}\u{0304}",
        nfkc: "\u{1E20}",
        nfkd: "\u{0047}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1E21}",
        nfc: "\u{1E21}",
        nfd: "\u{0067}\u{0304}",
        nfkc: "\u{1E21}",
        nfkd: "\u{0067}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1E22}",
        nfc: "\u{1E22}",
        nfd: "\u{0048}\u{0307}",
        nfkc: "\u{1E22}",
        nfkd: "\u{0048}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E23}",
        nfc: "\u{1E23}",
        nfd: "\u{0068}\u{0307}",
        nfkc: "\u{1E23}",
        nfkd: "\u{0068}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E24}",
        nfc: "\u{1E24}",
        nfd: "\u{0048}\u{0323}",
        nfkc: "\u{1E24}",
        nfkd: "\u{0048}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E25}",
        nfc: "\u{1E25}",
        nfd: "\u{0068}\u{0323}",
        nfkc: "\u{1E25}",
        nfkd: "\u{0068}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E26}",
        nfc: "\u{1E26}",
        nfd: "\u{0048}\u{0308}",
        nfkc: "\u{1E26}",
        nfkd: "\u{0048}\u{0308}",
    },
    NormalizationTest {
        source: "\u{1E27}",
        nfc: "\u{1E27}",
        nfd: "\u{0068}\u{0308}",
        nfkc: "\u{1E27}",
        nfkd: "\u{0068}\u{0308}",
    },
    NormalizationTest {
        source: "\u{1E28}",
        nfc: "\u{1E28}",
        nfd: "\u{0048}\u{0327}",
        nfkc: "\u{1E28}",
        nfkd: "\u{0048}\u{0327}",
    },
    NormalizationTest {
        source: "\u{1E29}",
        nfc: "\u{1E29}",
        nfd: "\u{0068}\u{0327}",
        nfkc: "\u{1E29}",
        nfkd: "\u{0068}\u{0327}",
    },
    NormalizationTest {
        source: "\u{1E2A}",
        nfc: "\u{1E2A}",
        nfd: "\u{0048}\u{032E}",
        nfkc: "\u{1E2A}",
        nfkd: "\u{0048}\u{032E}",
    },
    NormalizationTest {
        source: "\u{1E2B}",
        nfc: "\u{1E2B}",
        nfd: "\u{0068}\u{032E}",
        nfkc: "\u{1E2B}",
        nfkd: "\u{0068}\u{032E}",
    },
    NormalizationTest {
        source: "\u{1E2C}",
        nfc: "\u{1E2C}",
        nfd: "\u{0049}\u{0330}",
        nfkc: "\u{1E2C}",
        nfkd: "\u{0049}\u{0330}",
    },
    NormalizationTest {
        source: "\u{1E2D}",
        nfc: "\u{1E2D}",
        nfd: "\u{0069}\u{0330}",
        nfkc: "\u{1E2D}",
        nfkd: "\u{0069}\u{0330}",
    },
    NormalizationTest {
        source: "\u{1E2E}",
        nfc: "\u{1E2E}",
        nfd: "\u{0049}\u{0308}\u{0301}",
        nfkc: "\u{1E2E}",
        nfkd: "\u{0049}\u{0308}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E2F}",
        nfc: "\u{1E2F}",
        nfd: "\u{0069}\u{0308}\u{0301}",
        nfkc: "\u{1E2F}",
        nfkd: "\u{0069}\u{0308}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E30}",
        nfc: "\u{1E30}",
        nfd: "\u{004B}\u{0301}",
        nfkc: "\u{1E30}",
        nfkd: "\u{004B}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E31}",
        nfc: "\u{1E31}",
        nfd: "\u{006B}\u{0301}",
        nfkc: "\u{1E31}",
        nfkd: "\u{006B}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E32}",
        nfc: "\u{1E32}",
        nfd: "\u{004B}\u{0323}",
        nfkc: "\u{1E32}",
        nfkd: "\u{004B}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E33}",
        nfc: "\u{1E33}",
        nfd: "\u{006B}\u{0323}",
        nfkc: "\u{1E33}",
        nfkd: "\u{006B}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E34}",
        nfc: "\u{1E34}",
        nfd: "\u{004B}\u{0331}",
        nfkc: "\u{1E34}",
        nfkd: "\u{004B}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E35}",
        nfc: "\u{1E35}",
        nfd: "\u{006B}\u{0331}",
        nfkc: "\u{1E35}",
        nfkd: "\u{006B}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E36}",
        nfc: "\u{1E36}",
        nfd: "\u{004C}\u{0323}",
        nfkc: "\u{1E36}",
        nfkd: "\u{004C}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E37}",
        nfc: "\u{1E37}",
        nfd: "\u{006C}\u{0323}",
        nfkc: "\u{1E37}",
        nfkd: "\u{006C}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E38}",
        nfc: "\u{1E38}",
        nfd: "\u{004C}\u{0323}\u{0304}",
        nfkc: "\u{1E38}",
        nfkd: "\u{004C}\u{0323}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1E39}",
        nfc: "\u{1E39}",
        nfd: "\u{006C}\u{0323}\u{0304}",
        nfkc: "\u{1E39}",
        nfkd: "\u{006C}\u{0323}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1E3A}",
        nfc: "\u{1E3A}",
        nfd: "\u{004C}\u{0331}",
        nfkc: "\u{1E3A}",
        nfkd: "\u{004C}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E3B}",
        nfc: "\u{1E3B}",
        nfd: "\u{006C}\u{0331}",
        nfkc: "\u{1E3B}",
        nfkd: "\u{006C}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E3C}",
        nfc: "\u{1E3C}",
        nfd: "\u{004C}\u{032D}",
        nfkc: "\u{1E3C}",
        nfkd: "\u{004C}\u{032D}",
    },
    NormalizationTest {
        source: "\u{1E3D}",
        nfc: "\u{1E3D}",
        nfd: "\u{006C}\u{032D}",
        nfkc: "\u{1E3D}",
        nfkd: "\u{006C}\u{032D}",
    },
    NormalizationTest {
        source: "\u{1E3E}",
        nfc: "\u{1E3E}",
        nfd: "\u{004D}\u{0301}",
        nfkc: "\u{1E3E}",
        nfkd: "\u{004D}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E3F}",
        nfc: "\u{1E3F}",
        nfd: "\u{006D}\u{0301}",
        nfkc: "\u{1E3F}",
        nfkd: "\u{006D}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E40}",
        nfc: "\u{1E40}",
        nfd: "\u{004D}\u{0307}",
        nfkc: "\u{1E40}",
        nfkd: "\u{004D}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E41}",
        nfc: "\u{1E41}",
        nfd: "\u{006D}\u{0307}",
        nfkc: "\u{1E41}",
        nfkd: "\u{006D}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E42}",
        nfc: "\u{1E42}",
        nfd: "\u{004D}\u{0323}",
        nfkc: "\u{1E42}",
        nfkd: "\u{004D}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E43}",
        nfc: "\u{1E43}",
        nfd: "\u{006D}\u{0323}",
        nfkc: "\u{1E43}",
        nfkd: "\u{006D}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E44}",
        nfc: "\u{1E44}",
        nfd: "\u{004E}\u{0307}",
        nfkc: "\u{1E44}",
        nfkd: "\u{004E}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E45}",
        nfc: "\u{1E45}",
        nfd: "\u{006E}\u{0307}",
        nfkc: "\u{1E45}",
        nfkd: "\u{006E}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E46}",
        nfc: "\u{1E46}",
        nfd: "\u{004E}\u{0323}",
        nfkc: "\u{1E46}",
        nfkd: "\u{004E}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E47}",
        nfc: "\u{1E47}",
        nfd: "\u{006E}\u{0323}",
        nfkc: "\u{1E47}",
        nfkd: "\u{006E}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E48}",
        nfc: "\u{1E48}",
        nfd: "\u{004E}\u{0331}",
        nfkc: "\u{1E48}",
        nfkd: "\u{004E}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E49}",
        nfc: "\u{1E49}",
        nfd: "\u{006E}\u{0331}",
        nfkc: "\u{1E49}",
        nfkd: "\u{006E}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E4A}",
        nfc: "\u{1E4A}",
        nfd: "\u{004E}\u{032D}",
        nfkc: "\u{1E4A}",
        nfkd: "\u{004E}\u{032D}",
    },
    NormalizationTest {
        source: "\u{1E4B}",
        nfc: "\u{1E4B}",
        nfd: "\u{006E}\u{032D}",
        nfkc: "\u{1E4B}",
        nfkd: "\u{006E}\u{032D}",
    },
    NormalizationTest {
        source: "\u{1E4C}",
        nfc: "\u{1E4C}",
        nfd: "\u{004F}\u{0303}\u{0301}",
        nfkc: "\u{1E4C}",
        nfkd: "\u{004F}\u{0303}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E4D}",
        nfc: "\u{1E4D}",
        nfd: "\u{006F}\u{0303}\u{0301}",
        nfkc: "\u{1E4D}",
        nfkd: "\u{006F}\u{0303}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E4E}",
        nfc: "\u{1E4E}",
        nfd: "\u{004F}\u{0303}\u{0308}",
        nfkc: "\u{1E4E}",
        nfkd: "\u{004F}\u{0303}\u{0308}",
    },
    NormalizationTest {
        source: "\u{1E4F}",
        nfc: "\u{1E4F}",
        nfd: "\u{006F}\u{0303}\u{0308}",
        nfkc: "\u{1E4F}",
        nfkd: "\u{006F}\u{0303}\u{0308}",
    },
    NormalizationTest {
        source: "\u{1E50}",
        nfc: "\u{1E50}",
        nfd: "\u{004F}\u{0304}\u{0300}",
        nfkc: "\u{1E50}",
        nfkd: "\u{004F}\u{0304}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1E51}",
        nfc: "\u{1E51}",
        nfd: "\u{006F}\u{0304}\u{0300}",
        nfkc: "\u{1E51}",
        nfkd: "\u{006F}\u{0304}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1E52}",
        nfc: "\u{1E52}",
        nfd: "\u{004F}\u{0304}\u{0301}",
        nfkc: "\u{1E52}",
        nfkd: "\u{004F}\u{0304}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E53}",
        nfc: "\u{1E53}",
        nfd: "\u{006F}\u{0304}\u{0301}",
        nfkc: "\u{1E53}",
        nfkd: "\u{006F}\u{0304}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E54}",
        nfc: "\u{1E54}",
        nfd: "\u{0050}\u{0301}",
        nfkc: "\u{1E54}",
        nfkd: "\u{0050}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E55}",
        nfc: "\u{1E55}",
        nfd: "\u{0070}\u{0301}",
        nfkc: "\u{1E55}",
        nfkd: "\u{0070}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E56}",
        nfc: "\u{1E56}",
        nfd: "\u{0050}\u{0307}",
        nfkc: "\u{1E56}",
        nfkd: "\u{0050}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E57}",
        nfc: "\u{1E57}",
        nfd: "\u{0070}\u{0307}",
        nfkc: "\u{1E57}",
        nfkd: "\u{0070}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E58}",
        nfc: "\u{1E58}",
        nfd: "\u{0052}\u{0307}",
        nfkc: "\u{1E58}",
        nfkd: "\u{0052}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E59}",
        nfc: "\u{1E59}",
        nfd: "\u{0072}\u{0307}",
        nfkc: "\u{1E59}",
        nfkd: "\u{0072}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E5A}",
        nfc: "\u{1E5A}",
        nfd: "\u{0052}\u{0323}",
        nfkc: "\u{1E5A}",
        nfkd: "\u{0052}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E5B}",
        nfc: "\u{1E5B}",
        nfd: "\u{0072}\u{0323}",
        nfkc: "\u{1E5B}",
        nfkd: "\u{0072}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E5C}",
        nfc: "\u{1E5C}",
        nfd: "\u{0052}\u{0323}\u{0304}",
        nfkc: "\u{1E5C}",
        nfkd: "\u{0052}\u{0323}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1E5D}",
        nfc: "\u{1E5D}",
        nfd: "\u{0072}\u{0323}\u{0304}",
        nfkc: "\u{1E5D}",
        nfkd: "\u{0072}\u{0323}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1E5E}",
        nfc: "\u{1E5E}",
        nfd: "\u{0052}\u{0331}",
        nfkc: "\u{1E5E}",
        nfkd: "\u{0052}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E5F}",
        nfc: "\u{1E5F}",
        nfd: "\u{0072}\u{0331}",
        nfkc: "\u{1E5F}",
        nfkd: "\u{0072}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E60}",
        nfc: "\u{1E60}",
        nfd: "\u{0053}\u{0307}",
        nfkc: "\u{1E60}",
        nfkd: "\u{0053}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E61}",
        nfc: "\u{1E61}",
        nfd: "\u{0073}\u{0307}",
        nfkc: "\u{1E61}",
        nfkd: "\u{0073}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E62}",
        nfc: "\u{1E62}",
        nfd: "\u{0053}\u{0323}",
        nfkc: "\u{1E62}",
        nfkd: "\u{0053}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E63}",
        nfc: "\u{1E63}",
        nfd: "\u{0073}\u{0323}",
        nfkc: "\u{1E63}",
        nfkd: "\u{0073}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E64}",
        nfc: "\u{1E64}",
        nfd: "\u{0053}\u{0301}\u{0307}",
        nfkc: "\u{1E64}",
        nfkd: "\u{0053}\u{0301}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E65}",
        nfc: "\u{1E65}",
        nfd: "\u{0073}\u{0301}\u{0307}",
        nfkc: "\u{1E65}",
        nfkd: "\u{0073}\u{0301}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E66}",
        nfc: "\u{1E66}",
        nfd: "\u{0053}\u{030C}\u{0307}",
        nfkc: "\u{1E66}",
        nfkd: "\u{0053}\u{030C}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E67}",
        nfc: "\u{1E67}",
        nfd: "\u{0073}\u{030C}\u{0307}",
        nfkc: "\u{1E67}",
        nfkd: "\u{0073}\u{030C}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E68}",
        nfc: "\u{1E68}",
        nfd: "\u{0053}\u{0323}\u{0307}",
        nfkc: "\u{1E68}",
        nfkd: "\u{0053}\u{0323}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E69}",
        nfc: "\u{1E69}",
        nfd: "\u{0073}\u{0323}\u{0307}",
        nfkc: "\u{1E69}",
        nfkd: "\u{0073}\u{0323}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E6A}",
        nfc: "\u{1E6A}",
        nfd: "\u{0054}\u{0307}",
        nfkc: "\u{1E6A}",
        nfkd: "\u{0054}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E6B}",
        nfc: "\u{1E6B}",
        nfd: "\u{0074}\u{0307}",
        nfkc: "\u{1E6B}",
        nfkd: "\u{0074}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E6C}",
        nfc: "\u{1E6C}",
        nfd: "\u{0054}\u{0323}",
        nfkc: "\u{1E6C}",
        nfkd: "\u{0054}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E6D}",
        nfc: "\u{1E6D}",
        nfd: "\u{0074}\u{0323}",
        nfkc: "\u{1E6D}",
        nfkd: "\u{0074}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E6E}",
        nfc: "\u{1E6E}",
        nfd: "\u{0054}\u{0331}",
        nfkc: "\u{1E6E}",
        nfkd: "\u{0054}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E6F}",
        nfc: "\u{1E6F}",
        nfd: "\u{0074}\u{0331}",
        nfkc: "\u{1E6F}",
        nfkd: "\u{0074}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E70}",
        nfc: "\u{1E70}",
        nfd: "\u{0054}\u{032D}",
        nfkc: "\u{1E70}",
        nfkd: "\u{0054}\u{032D}",
    },
    NormalizationTest {
        source: "\u{1E71}",
        nfc: "\u{1E71}",
        nfd: "\u{0074}\u{032D}",
        nfkc: "\u{1E71}",
        nfkd: "\u{0074}\u{032D}",
    },
    NormalizationTest {
        source: "\u{1E72}",
        nfc: "\u{1E72}",
        nfd: "\u{0055}\u{0324}",
        nfkc: "\u{1E72}",
        nfkd: "\u{0055}\u{0324}",
    },
    NormalizationTest {
        source: "\u{1E73}",
        nfc: "\u{1E73}",
        nfd: "\u{0075}\u{0324}",
        nfkc: "\u{1E73}",
        nfkd: "\u{0075}\u{0324}",
    },
    NormalizationTest {
        source: "\u{1E74}",
        nfc: "\u{1E74}",
        nfd: "\u{0055}\u{0330}",
        nfkc: "\u{1E74}",
        nfkd: "\u{0055}\u{0330}",
    },
    NormalizationTest {
        source: "\u{1E75}",
        nfc: "\u{1E75}",
        nfd: "\u{0075}\u{0330}",
        nfkc: "\u{1E75}",
        nfkd: "\u{0075}\u{0330}",
    },
    NormalizationTest {
        source: "\u{1E76}",
        nfc: "\u{1E76}",
        nfd: "\u{0055}\u{032D}",
        nfkc: "\u{1E76}",
        nfkd: "\u{0055}\u{032D}",
    },
    NormalizationTest {
        source: "\u{1E77}",
        nfc: "\u{1E77}",
        nfd: "\u{0075}\u{032D}",
        nfkc: "\u{1E77}",
        nfkd: "\u{0075}\u{032D}",
    },
    NormalizationTest {
        source: "\u{1E78}",
        nfc: "\u{1E78}",
        nfd: "\u{0055}\u{0303}\u{0301}",
        nfkc: "\u{1E78}",
        nfkd: "\u{0055}\u{0303}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E79}",
        nfc: "\u{1E79}",
        nfd: "\u{0075}\u{0303}\u{0301}",
        nfkc: "\u{1E79}",
        nfkd: "\u{0075}\u{0303}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E7A}",
        nfc: "\u{1E7A}",
        nfd: "\u{0055}\u{0304}\u{0308}",
        nfkc: "\u{1E7A}",
        nfkd: "\u{0055}\u{0304}\u{0308}",
    },
    NormalizationTest {
        source: "\u{1E7B}",
        nfc: "\u{1E7B}",
        nfd: "\u{0075}\u{0304}\u{0308}",
        nfkc: "\u{1E7B}",
        nfkd: "\u{0075}\u{0304}\u{0308}",
    },
    NormalizationTest {
        source: "\u{1E7C}",
        nfc: "\u{1E7C}",
        nfd: "\u{0056}\u{0303}",
        nfkc: "\u{1E7C}",
        nfkd: "\u{0056}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1E7D}",
        nfc: "\u{1E7D}",
        nfd: "\u{0076}\u{0303}",
        nfkc: "\u{1E7D}",
        nfkd: "\u{0076}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1E7E}",
        nfc: "\u{1E7E}",
        nfd: "\u{0056}\u{0323}",
        nfkc: "\u{1E7E}",
        nfkd: "\u{0056}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E7F}",
        nfc: "\u{1E7F}",
        nfd: "\u{0076}\u{0323}",
        nfkc: "\u{1E7F}",
        nfkd: "\u{0076}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E80}",
        nfc: "\u{1E80}",
        nfd: "\u{0057}\u{0300}",
        nfkc: "\u{1E80}",
        nfkd: "\u{0057}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1E81}",
        nfc: "\u{1E81}",
        nfd: "\u{0077}\u{0300}",
        nfkc: "\u{1E81}",
        nfkd: "\u{0077}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1E82}",
        nfc: "\u{1E82}",
        nfd: "\u{0057}\u{0301}",
        nfkc: "\u{1E82}",
        nfkd: "\u{0057}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E83}",
        nfc: "\u{1E83}",
        nfd: "\u{0077}\u{0301}",
        nfkc: "\u{1E83}",
        nfkd: "\u{0077}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1E84}",
        nfc: "\u{1E84}",
        nfd: "\u{0057}\u{0308}",
        nfkc: "\u{1E84}",
        nfkd: "\u{0057}\u{0308}",
    },
    NormalizationTest {
        source: "\u{1E85}",
        nfc: "\u{1E85}",
        nfd: "\u{0077}\u{0308}",
        nfkc: "\u{1E85}",
        nfkd: "\u{0077}\u{0308}",
    },
    NormalizationTest {
        source: "\u{1E86}",
        nfc: "\u{1E86}",
        nfd: "\u{0057}\u{0307}",
        nfkc: "\u{1E86}",
        nfkd: "\u{0057}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E87}",
        nfc: "\u{1E87}",
        nfd: "\u{0077}\u{0307}",
        nfkc: "\u{1E87}",
        nfkd: "\u{0077}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E88}",
        nfc: "\u{1E88}",
        nfd: "\u{0057}\u{0323}",
        nfkc: "\u{1E88}",
        nfkd: "\u{0057}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E89}",
        nfc: "\u{1E89}",
        nfd: "\u{0077}\u{0323}",
        nfkc: "\u{1E89}",
        nfkd: "\u{0077}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E8A}",
        nfc: "\u{1E8A}",
        nfd: "\u{0058}\u{0307}",
        nfkc: "\u{1E8A}",
        nfkd: "\u{0058}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E8B}",
        nfc: "\u{1E8B}",
        nfd: "\u{0078}\u{0307}",
        nfkc: "\u{1E8B}",
        nfkd: "\u{0078}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E8C}",
        nfc: "\u{1E8C}",
        nfd: "\u{0058}\u{0308}",
        nfkc: "\u{1E8C}",
        nfkd: "\u{0058}\u{0308}",
    },
    NormalizationTest {
        source: "\u{1E8D}",
        nfc: "\u{1E8D}",
        nfd: "\u{0078}\u{0308}",
        nfkc: "\u{1E8D}",
        nfkd: "\u{0078}\u{0308}",
    },
    NormalizationTest {
        source: "\u{1E8E}",
        nfc: "\u{1E8E}",
        nfd: "\u{0059}\u{0307}",
        nfkc: "\u{1E8E}",
        nfkd: "\u{0059}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E8F}",
        nfc: "\u{1E8F}",
        nfd: "\u{0079}\u{0307}",
        nfkc: "\u{1E8F}",
        nfkd: "\u{0079}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1E90}",
        nfc: "\u{1E90}",
        nfd: "\u{005A}\u{0302}",
        nfkc: "\u{1E90}",
        nfkd: "\u{005A}\u{0302}",
    },
    NormalizationTest {
        source: "\u{1E91}",
        nfc: "\u{1E91}",
        nfd: "\u{007A}\u{0302}",
        nfkc: "\u{1E91}",
        nfkd: "\u{007A}\u{0302}",
    },
    NormalizationTest {
        source: "\u{1E92}",
        nfc: "\u{1E92}",
        nfd: "\u{005A}\u{0323}",
        nfkc: "\u{1E92}",
        nfkd: "\u{005A}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E93}",
        nfc: "\u{1E93}",
        nfd: "\u{007A}\u{0323}",
        nfkc: "\u{1E93}",
        nfkd: "\u{007A}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1E94}",
        nfc: "\u{1E94}",
        nfd: "\u{005A}\u{0331}",
        nfkc: "\u{1E94}",
        nfkd: "\u{005A}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E95}",
        nfc: "\u{1E95}",
        nfd: "\u{007A}\u{0331}",
        nfkc: "\u{1E95}",
        nfkd: "\u{007A}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E96}",
        nfc: "\u{1E96}",
        nfd: "\u{0068}\u{0331}",
        nfkc: "\u{1E96}",
        nfkd: "\u{0068}\u{0331}",
    },
    NormalizationTest {
        source: "\u{1E97}",
        nfc: "\u{1E97}",
        nfd: "\u{0074}\u{0308}",
        nfkc: "\u{1E97}",
        nfkd: "\u{0074}\u{0308}",
    },
    NormalizationTest {
        source: "\u{1E98}",
        nfc: "\u{1E98}",
        nfd: "\u{0077}\u{030A}",
        nfkc: "\u{1E98}",
        nfkd: "\u{0077}\u{030A}",
    },
    NormalizationTest {
        source: "\u{1E99}",
        nfc: "\u{1E99}",
        nfd: "\u{0079}\u{030A}",
        nfkc: "\u{1E99}",
        nfkd: "\u{0079}\u{030A}",
    },
    NormalizationTest {
        source: "\u{1E9A}",
        nfc: "\u{1E9A}",
        nfd: "\u{1E9A}",
        nfkc: "\u{0061}\u{02BE}",
        nfkd: "\u{0061}\u{02BE}",
    },
    NormalizationTest {
        source: "\u{1E9B}",
        nfc: "\u{1E9B}",
        nfd: "\u{017F}\u{0307}",
        nfkc: "\u{1E61}",
        nfkd: "\u{0073}\u{0307}",
    },
    NormalizationTest {
        source: "\u{1EA0}",
        nfc: "\u{1EA0}",
        nfd: "\u{0041}\u{0323}",
        nfkc: "\u{1EA0}",
        nfkd: "\u{0041}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1EA1}",
        nfc: "\u{1EA1}",
        nfd: "\u{0061}\u{0323}",
        nfkc: "\u{1EA1}",
        nfkd: "\u{0061}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1EA2}",
        nfc: "\u{1EA2}",
        nfd: "\u{0041}\u{0309}",
        nfkc: "\u{1EA2}",
        nfkd: "\u{0041}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EA3}",
        nfc: "\u{1EA3}",
        nfd: "\u{0061}\u{0309}",
        nfkc: "\u{1EA3}",
        nfkd: "\u{0061}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EA4}",
        nfc: "\u{1EA4}",
        nfd: "\u{0041}\u{0302}\u{0301}",
        nfkc: "\u{1EA4}",
        nfkd: "\u{0041}\u{0302}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1EA5}",
        nfc: "\u{1EA5}",
        nfd: "\u{0061}\u{0302}\u{0301}",
        nfkc: "\u{1EA5}",
        nfkd: "\u{0061}\u{0302}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1EA6}",
        nfc: "\u{1EA6}",
        nfd: "\u{0041}\u{0302}\u{0300}",
        nfkc: "\u{1EA6}",
        nfkd: "\u{0041}\u{0302}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1EA7}",
        nfc: "\u{1EA7}",
        nfd: "\u{0061}\u{0302}\u{0300}",
        nfkc: "\u{1EA7}",
        nfkd: "\u{0061}\u{0302}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1EA8}",
        nfc: "\u{1EA8}",
        nfd: "\u{0041}\u{0302}\u{0309}",
        nfkc: "\u{1EA8}",
        nfkd: "\u{0041}\u{0302}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EA9}",
        nfc: "\u{1EA9}",
        nfd: "\u{0061}\u{0302}\u{0309}",
        nfkc: "\u{1EA9}",
        nfkd: "\u{0061}\u{0302}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EAA}",
        nfc: "\u{1EAA}",
        nfd: "\u{0041}\u{0302}\u{0303}",
        nfkc: "\u{1EAA}",
        nfkd: "\u{0041}\u{0302}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EAB}",
        nfc: "\u{1EAB}",
        nfd: "\u{0061}\u{0302}\u{0303}",
        nfkc: "\u{1EAB}",
        nfkd: "\u{0061}\u{0302}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EAC}",
        nfc: "\u{1EAC}",
        nfd: "\u{0041}\u{0323}\u{0302}",
        nfkc: "\u{1EAC}",
        nfkd: "\u{0041}\u{0323}\u{0302}",
    },
    NormalizationTest {
        source: "\u{1EAD}",
        nfc: "\u{1EAD}",
        nfd: "\u{0061}\u{0323}\u{0302}",
        nfkc: "\u{1EAD}",
        nfkd: "\u{0061}\u{0323}\u{0302}",
    },
    NormalizationTest {
        source: "\u{1EAE}",
        nfc: "\u{1EAE}",
        nfd: "\u{0041}\u{0306}\u{0301}",
        nfkc: "\u{1EAE}",
        nfkd: "\u{0041}\u{0306}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1EAF}",
        nfc: "\u{1EAF}",
        nfd: "\u{0061}\u{0306}\u{0301}",
        nfkc: "\u{1EAF}",
        nfkd: "\u{0061}\u{0306}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1EB0}",
        nfc: "\u{1EB0}",
        nfd: "\u{0041}\u{0306}\u{0300}",
        nfkc: "\u{1EB0}",
        nfkd: "\u{0041}\u{0306}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1EB1}",
        nfc: "\u{1EB1}",
        nfd: "\u{0061}\u{0306}\u{0300}",
        nfkc: "\u{1EB1}",
        nfkd: "\u{0061}\u{0306}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1EB2}",
        nfc: "\u{1EB2}",
        nfd: "\u{0041}\u{0306}\u{0309}",
        nfkc: "\u{1EB2}",
        nfkd: "\u{0041}\u{0306}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EB3}",
        nfc: "\u{1EB3}",
        nfd: "\u{0061}\u{0306}\u{0309}",
        nfkc: "\u{1EB3}",
        nfkd: "\u{0061}\u{0306}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EB4}",
        nfc: "\u{1EB4}",
        nfd: "\u{0041}\u{0306}\u{0303}",
        nfkc: "\u{1EB4}",
        nfkd: "\u{0041}\u{0306}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EB5}",
        nfc: "\u{1EB5}",
        nfd: "\u{0061}\u{0306}\u{0303}",
        nfkc: "\u{1EB5}",
        nfkd: "\u{0061}\u{0306}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EB6}",
        nfc: "\u{1EB6}",
        nfd: "\u{0041}\u{0323}\u{0306}",
        nfkc: "\u{1EB6}",
        nfkd: "\u{0041}\u{0323}\u{0306}",
    },
    NormalizationTest {
        source: "\u{1EB7}",
        nfc: "\u{1EB7}",
        nfd: "\u{0061}\u{0323}\u{0306}",
        nfkc: "\u{1EB7}",
        nfkd: "\u{0061}\u{0323}\u{0306}",
    },
    NormalizationTest {
        source: "\u{1EB8}",
        nfc: "\u{1EB8}",
        nfd: "\u{0045}\u{0323}",
        nfkc: "\u{1EB8}",
        nfkd: "\u{0045}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1EB9}",
        nfc: "\u{1EB9}",
        nfd: "\u{0065}\u{0323}",
        nfkc: "\u{1EB9}",
        nfkd: "\u{0065}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1EBA}",
        nfc: "\u{1EBA}",
        nfd: "\u{0045}\u{0309}",
        nfkc: "\u{1EBA}",
        nfkd: "\u{0045}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EBB}",
        nfc: "\u{1EBB}",
        nfd: "\u{0065}\u{0309}",
        nfkc: "\u{1EBB}",
        nfkd: "\u{0065}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EBC}",
        nfc: "\u{1EBC}",
        nfd: "\u{0045}\u{0303}",
        nfkc: "\u{1EBC}",
        nfkd: "\u{0045}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EBD}",
        nfc: "\u{1EBD}",
        nfd: "\u{0065}\u{0303}",
        nfkc: "\u{1EBD}",
        nfkd: "\u{0065}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EBE}",
        nfc: "\u{1EBE}",
        nfd: "\u{0045}\u{0302}\u{0301}",
        nfkc: "\u{1EBE}",
        nfkd: "\u{0045}\u{0302}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1EBF}",
        nfc: "\u{1EBF}",
        nfd: "\u{0065}\u{0302}\u{0301}",
        nfkc: "\u{1EBF}",
        nfkd: "\u{0065}\u{0302}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1EC0}",
        nfc: "\u{1EC0}",
        nfd: "\u{0045}\u{0302}\u{0300}",
        nfkc: "\u{1EC0}",
        nfkd: "\u{0045}\u{0302}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1EC1}",
        nfc: "\u{1EC1}",
        nfd: "\u{0065}\u{0302}\u{0300}",
        nfkc: "\u{1EC1}",
        nfkd: "\u{0065}\u{0302}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1EC2}",
        nfc: "\u{1EC2}",
        nfd: "\u{0045}\u{0302}\u{0309}",
        nfkc: "\u{1EC2}",
        nfkd: "\u{0045}\u{0302}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EC3}",
        nfc: "\u{1EC3}",
        nfd: "\u{0065}\u{0302}\u{0309}",
        nfkc: "\u{1EC3}",
        nfkd: "\u{0065}\u{0302}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EC4}",
        nfc: "\u{1EC4}",
        nfd: "\u{0045}\u{0302}\u{0303}",
        nfkc: "\u{1EC4}",
        nfkd: "\u{0045}\u{0302}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EC5}",
        nfc: "\u{1EC5}",
        nfd: "\u{0065}\u{0302}\u{0303}",
        nfkc: "\u{1EC5}",
        nfkd: "\u{0065}\u{0302}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EC6}",
        nfc: "\u{1EC6}",
        nfd: "\u{0045}\u{0323}\u{0302}",
        nfkc: "\u{1EC6}",
        nfkd: "\u{0045}\u{0323}\u{0302}",
    },
    NormalizationTest {
        source: "\u{1EC7}",
        nfc: "\u{1EC7}",
        nfd: "\u{0065}\u{0323}\u{0302}",
        nfkc: "\u{1EC7}",
        nfkd: "\u{0065}\u{0323}\u{0302}",
    },
    NormalizationTest {
        source: "\u{1EC8}",
        nfc: "\u{1EC8}",
        nfd: "\u{0049}\u{0309}",
        nfkc: "\u{1EC8}",
        nfkd: "\u{0049}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EC9}",
        nfc: "\u{1EC9}",
        nfd: "\u{0069}\u{0309}",
        nfkc: "\u{1EC9}",
        nfkd: "\u{0069}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1ECA}",
        nfc: "\u{1ECA}",
        nfd: "\u{0049}\u{0323}",
        nfkc: "\u{1ECA}",
        nfkd: "\u{0049}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1ECB}",
        nfc: "\u{1ECB}",
        nfd: "\u{0069}\u{0323}",
        nfkc: "\u{1ECB}",
        nfkd: "\u{0069}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1ECC}",
        nfc: "\u{1ECC}",
        nfd: "\u{004F}\u{0323}",
        nfkc: "\u{1ECC}",
        nfkd: "\u{004F}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1ECD}",
        nfc: "\u{1ECD}",
        nfd: "\u{006F}\u{0323}",
        nfkc: "\u{1ECD}",
        nfkd: "\u{006F}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1ECE}",
        nfc: "\u{1ECE}",
        nfd: "\u{004F}\u{0309}",
        nfkc: "\u{1ECE}",
        nfkd: "\u{004F}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1ECF}",
        nfc: "\u{1ECF}",
        nfd: "\u{006F}\u{0309}",
        nfkc: "\u{1ECF}",
        nfkd: "\u{006F}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1ED0}",
        nfc: "\u{1ED0}",
        nfd: "\u{004F}\u{0302}\u{0301}",
        nfkc: "\u{1ED0}",
        nfkd: "\u{004F}\u{0302}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1ED1}",
        nfc: "\u{1ED1}",
        nfd: "\u{006F}\u{0302}\u{0301}",
        nfkc: "\u{1ED1}",
        nfkd: "\u{006F}\u{0302}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1ED2}",
        nfc: "\u{1ED2}",
        nfd: "\u{004F}\u{0302}\u{0300}",
        nfkc: "\u{1ED2}",
        nfkd: "\u{004F}\u{0302}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1ED3}",
        nfc: "\u{1ED3}",
        nfd: "\u{006F}\u{0302}\u{0300}",
        nfkc: "\u{1ED3}",
        nfkd: "\u{006F}\u{0302}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1ED4}",
        nfc: "\u{1ED4}",
        nfd: "\u{004F}\u{0302}\u{0309}",
        nfkc: "\u{1ED4}",
        nfkd: "\u{004F}\u{0302}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1ED5}",
        nfc: "\u{1ED5}",
        nfd: "\u{006F}\u{0302}\u{0309}",
        nfkc: "\u{1ED5}",
        nfkd: "\u{006F}\u{0302}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1ED6}",
        nfc: "\u{1ED6}",
        nfd: "\u{004F}\u{0302}\u{0303}",
        nfkc: "\u{1ED6}",
        nfkd: "\u{004F}\u{0302}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1ED7}",
        nfc: "\u{1ED7}",
        nfd: "\u{006F}\u{0302}\u{0303}",
        nfkc: "\u{1ED7}",
        nfkd: "\u{006F}\u{0302}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1ED8}",
        nfc: "\u{1ED8}",
        nfd: "\u{004F}\u{0323}\u{0302}",
        nfkc: "\u{1ED8}",
        nfkd: "\u{004F}\u{0323}\u{0302}",
    },
    NormalizationTest {
        source: "\u{1ED9}",
        nfc: "\u{1ED9}",
        nfd: "\u{006F}\u{0323}\u{0302}",
        nfkc: "\u{1ED9}",
        nfkd: "\u{006F}\u{0323}\u{0302}",
    },
    NormalizationTest {
        source: "\u{1EDA}",
        nfc: "\u{1EDA}",
        nfd: "\u{004F}\u{031B}\u{0301}",
        nfkc: "\u{1EDA}",
        nfkd: "\u{004F}\u{031B}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1EDB}",
        nfc: "\u{1EDB}",
        nfd: "\u{006F}\u{031B}\u{0301}",
        nfkc: "\u{1EDB}",
        nfkd: "\u{006F}\u{031B}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1EDC}",
        nfc: "\u{1EDC}",
        nfd: "\u{004F}\u{031B}\u{0300}",
        nfkc: "\u{1EDC}",
        nfkd: "\u{004F}\u{031B}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1EDD}",
        nfc: "\u{1EDD}",
        nfd: "\u{006F}\u{031B}\u{0300}",
        nfkc: "\u{1EDD}",
        nfkd: "\u{006F}\u{031B}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1EDE}",
        nfc: "\u{1EDE}",
        nfd: "\u{004F}\u{031B}\u{0309}",
        nfkc: "\u{1EDE}",
        nfkd: "\u{004F}\u{031B}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EDF}",
        nfc: "\u{1EDF}",
        nfd: "\u{006F}\u{031B}\u{0309}",
        nfkc: "\u{1EDF}",
        nfkd: "\u{006F}\u{031B}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EE0}",
        nfc: "\u{1EE0}",
        nfd: "\u{004F}\u{031B}\u{0303}",
        nfkc: "\u{1EE0}",
        nfkd: "\u{004F}\u{031B}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EE1}",
        nfc: "\u{1EE1}",
        nfd: "\u{006F}\u{031B}\u{0303}",
        nfkc: "\u{1EE1}",
        nfkd: "\u{006F}\u{031B}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EE2}",
        nfc: "\u{1EE2}",
        nfd: "\u{004F}\u{031B}\u{0323}",
        nfkc: "\u{1EE2}",
        nfkd: "\u{004F}\u{031B}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1EE3}",
        nfc: "\u{1EE3}",
        nfd: "\u{006F}\u{031B}\u{0323}",
        nfkc: "\u{1EE3}",
        nfkd: "\u{006F}\u{031B}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1EE4}",
        nfc: "\u{1EE4}",
        nfd: "\u{0055}\u{0323}",
        nfkc: "\u{1EE4}",
        nfkd: "\u{0055}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1EE5}",
        nfc: "\u{1EE5}",
        nfd: "\u{0075}\u{0323}",
        nfkc: "\u{1EE5}",
        nfkd: "\u{0075}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1EE6}",
        nfc: "\u{1EE6}",
        nfd: "\u{0055}\u{0309}",
        nfkc: "\u{1EE6}",
        nfkd: "\u{0055}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EE7}",
        nfc: "\u{1EE7}",
        nfd: "\u{0075}\u{0309}",
        nfkc: "\u{1EE7}",
        nfkd: "\u{0075}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EE8}",
        nfc: "\u{1EE8}",
        nfd: "\u{0055}\u{031B}\u{0301}",
        nfkc: "\u{1EE8}",
        nfkd: "\u{0055}\u{031B}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1EE9}",
        nfc: "\u{1EE9}",
        nfd: "\u{0075}\u{031B}\u{0301}",
        nfkc: "\u{1EE9}",
        nfkd: "\u{0075}\u{031B}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1EEA}",
        nfc: "\u{1EEA}",
        nfd: "\u{0055}\u{031B}\u{0300}",
        nfkc: "\u{1EEA}",
        nfkd: "\u{0055}\u{031B}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1EEB}",
        nfc: "\u{1EEB}",
        nfd: "\u{0075}\u{031B}\u{0300}",
        nfkc: "\u{1EEB}",
        nfkd: "\u{0075}\u{031B}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1EEC}",
        nfc: "\u{1EEC}",
        nfd: "\u{0055}\u{031B}\u{0309}",
        nfkc: "\u{1EEC}",
        nfkd: "\u{0055}\u{031B}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EED}",
        nfc: "\u{1EED}",
        nfd: "\u{0075}\u{031B}\u{0309}",
        nfkc: "\u{1EED}",
        nfkd: "\u{0075}\u{031B}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EEE}",
        nfc: "\u{1EEE}",
        nfd: "\u{0055}\u{031B}\u{0303}",
        nfkc: "\u{1EEE}",
        nfkd: "\u{0055}\u{031B}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EEF}",
        nfc: "\u{1EEF}",
        nfd: "\u{0075}\u{031B}\u{0303}",
        nfkc: "\u{1EEF}",
        nfkd: "\u{0075}\u{031B}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EF0}",
        nfc: "\u{1EF0}",
        nfd: "\u{0055}\u{031B}\u{0323}",
        nfkc: "\u{1EF0}",
        nfkd: "\u{0055}\u{031B}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1EF1}",
        nfc: "\u{1EF1}",
        nfd: "\u{0075}\u{031B}\u{0323}",
        nfkc: "\u{1EF1}",
        nfkd: "\u{0075}\u{031B}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1EF2}",
        nfc: "\u{1EF2}",
        nfd: "\u{0059}\u{0300}",
        nfkc: "\u{1EF2}",
        nfkd: "\u{0059}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1EF3}",
        nfc: "\u{1EF3}",
        nfd: "\u{0079}\u{0300}",
        nfkc: "\u{1EF3}",
        nfkd: "\u{0079}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1EF4}",
        nfc: "\u{1EF4}",
        nfd: "\u{0059}\u{0323}",
        nfkc: "\u{1EF4}",
        nfkd: "\u{0059}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1EF5}",
        nfc: "\u{1EF5}",
        nfd: "\u{0079}\u{0323}",
        nfkc: "\u{1EF5}",
        nfkd: "\u{0079}\u{0323}",
    },
    NormalizationTest {
        source: "\u{1EF6}",
        nfc: "\u{1EF6}",
        nfd: "\u{0059}\u{0309}",
        nfkc: "\u{1EF6}",
        nfkd: "\u{0059}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EF7}",
        nfc: "\u{1EF7}",
        nfd: "\u{0079}\u{0309}",
        nfkc: "\u{1EF7}",
        nfkd: "\u{0079}\u{0309}",
    },
    NormalizationTest {
        source: "\u{1EF8}",
        nfc: "\u{1EF8}",
        nfd: "\u{0059}\u{0303}",
        nfkc: "\u{1EF8}",
        nfkd: "\u{0059}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1EF9}",
        nfc: "\u{1EF9}",
        nfd: "\u{0079}\u{0303}",
        nfkc: "\u{1EF9}",
        nfkd: "\u{0079}\u{0303}",
    },
    NormalizationTest {
        source: "\u{1F00}",
        nfc: "\u{1F00}",
        nfd: "\u{03B1}\u{0313}",
        nfkc: "\u{1F00}",
        nfkd: "\u{03B1}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F01}",
        nfc: "\u{1F01}",
        nfd: "\u{03B1}\u{0314}",
        nfkc: "\u{1F01}",
        nfkd: "\u{03B1}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F02}",
        nfc: "\u{1F02}",
        nfd: "\u{03B1}\u{0313}\u{0300}",
        nfkc: "\u{1F02}",
        nfkd: "\u{03B1}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F03}",
        nfc: "\u{1F03}",
        nfd: "\u{03B1}\u{0314}\u{0300}",
        nfkc: "\u{1F03}",
        nfkd: "\u{03B1}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F04}",
        nfc: "\u{1F04}",
        nfd: "\u{03B1}\u{0313}\u{0301}",
        nfkc: "\u{1F04}",
        nfkd: "\u{03B1}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F05}",
        nfc: "\u{1F05}",
        nfd: "\u{03B1}\u{0314}\u{0301}",
        nfkc: "\u{1F05}",
        nfkd: "\u{03B1}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F06}",
        nfc: "\u{1F06}",
        nfd: "\u{03B1}\u{0313}\u{0342}",
        nfkc: "\u{1F06}",
        nfkd: "\u{03B1}\u{0313}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F07}",
        nfc: "\u{1F07}",
        nfd: "\u{03B1}\u{0314}\u{0342}",
        nfkc: "\u{1F07}",
        nfkd: "\u{03B1}\u{0314}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F08}",
        nfc: "\u{1F08}",
        nfd: "\u{0391}\u{0313}",
        nfkc: "\u{1F08}",
        nfkd: "\u{0391}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F09}",
        nfc: "\u{1F09}",
        nfd: "\u{0391}\u{0314}",
        nfkc: "\u{1F09}",
        nfkd: "\u{0391}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F0A}",
        nfc: "\u{1F0A}",
        nfd: "\u{0391}\u{0313}\u{0300}",
        nfkc: "\u{1F0A}",
        nfkd: "\u{0391}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F0B}",
        nfc: "\u{1F0B}",
        nfd: "\u{0391}\u{0314}\u{0300}",
        nfkc: "\u{1F0B}",
        nfkd: "\u{0391}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F0C}",
        nfc: "\u{1F0C}",
        nfd: "\u{0391}\u{0313}\u{0301}",
        nfkc: "\u{1F0C}",
        nfkd: "\u{0391}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F0D}",
        nfc: "\u{1F0D}",
        nfd: "\u{0391}\u{0314}\u{0301}",
        nfkc: "\u{1F0D}",
        nfkd: "\u{0391}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F0E}",
        nfc: "\u{1F0E}",
        nfd: "\u{0391}\u{0313}\u{0342}",
        nfkc: "\u{1F0E}",
        nfkd: "\u{0391}\u{0313}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F0F}",
        nfc: "\u{1F0F}",
        nfd: "\u{0391}\u{0314}\u{0342}",
        nfkc: "\u{1F0F}",
        nfkd: "\u{0391}\u{0314}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F10}",
        nfc: "\u{1F10}",
        nfd: "\u{03B5}\u{0313}",
        nfkc: "\u{1F10}",
        nfkd: "\u{03B5}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F11}",
        nfc: "\u{1F11}",
        nfd: "\u{03B5}\u{0314}",
        nfkc: "\u{1F11}",
        nfkd: "\u{03B5}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F12}",
        nfc: "\u{1F12}",
        nfd: "\u{03B5}\u{0313}\u{0300}",
        nfkc: "\u{1F12}",
        nfkd: "\u{03B5}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F13}",
        nfc: "\u{1F13}",
        nfd: "\u{03B5}\u{0314}\u{0300}",
        nfkc: "\u{1F13}",
        nfkd: "\u{03B5}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F14}",
        nfc: "\u{1F14}",
        nfd: "\u{03B5}\u{0313}\u{0301}",
        nfkc: "\u{1F14}",
        nfkd: "\u{03B5}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F15}",
        nfc: "\u{1F15}",
        nfd: "\u{03B5}\u{0314}\u{0301}",
        nfkc: "\u{1F15}",
        nfkd: "\u{03B5}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F18}",
        nfc: "\u{1F18}",
        nfd: "\u{0395}\u{0313}",
        nfkc: "\u{1F18}",
        nfkd: "\u{0395}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F19}",
        nfc: "\u{1F19}",
        nfd: "\u{0395}\u{0314}",
        nfkc: "\u{1F19}",
        nfkd: "\u{0395}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F1A}",
        nfc: "\u{1F1A}",
        nfd: "\u{0395}\u{0313}\u{0300}",
        nfkc: "\u{1F1A}",
        nfkd: "\u{0395}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F1B}",
        nfc: "\u{1F1B}",
        nfd: "\u{0395}\u{0314}\u{0300}",
        nfkc: "\u{1F1B}",
        nfkd: "\u{0395}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F1C}",
        nfc: "\u{1F1C}",
        nfd: "\u{0395}\u{0313}\u{0301}",
        nfkc: "\u{1F1C}",
        nfkd: "\u{0395}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F1D}",
        nfc: "\u{1F1D}",
        nfd: "\u{0395}\u{0314}\u{0301}",
        nfkc: "\u{1F1D}",
        nfkd: "\u{0395}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F20}",
        nfc: "\u{1F20}",
        nfd: "\u{03B7}\u{0313}",
        nfkc: "\u{1F20}",
        nfkd: "\u{03B7}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F21}",
        nfc: "\u{1F21}",
        nfd: "\u{03B7}\u{0314}",
        nfkc: "\u{1F21}",
        nfkd: "\u{03B7}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F22}",
        nfc: "\u{1F22}",
        nfd: "\u{03B7}\u{0313}\u{0300}",
        nfkc: "\u{1F22}",
        nfkd: "\u{03B7}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F23}",
        nfc: "\u{1F23}",
        nfd: "\u{03B7}\u{0314}\u{0300}",
        nfkc: "\u{1F23}",
        nfkd: "\u{03B7}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F24}",
        nfc: "\u{1F24}",
        nfd: "\u{03B7}\u{0313}\u{0301}",
        nfkc: "\u{1F24}",
        nfkd: "\u{03B7}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F25}",
        nfc: "\u{1F25}",
        nfd: "\u{03B7}\u{0314}\u{0301}",
        nfkc: "\u{1F25}",
        nfkd: "\u{03B7}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F26}",
        nfc: "\u{1F26}",
        nfd: "\u{03B7}\u{0313}\u{0342}",
        nfkc: "\u{1F26}",
        nfkd: "\u{03B7}\u{0313}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F27}",
        nfc: "\u{1F27}",
        nfd: "\u{03B7}\u{0314}\u{0342}",
        nfkc: "\u{1F27}",
        nfkd: "\u{03B7}\u{0314}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F28}",
        nfc: "\u{1F28}",
        nfd: "\u{0397}\u{0313}",
        nfkc: "\u{1F28}",
        nfkd: "\u{0397}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F29}",
        nfc: "\u{1F29}",
        nfd: "\u{0397}\u{0314}",
        nfkc: "\u{1F29}",
        nfkd: "\u{0397}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F2A}",
        nfc: "\u{1F2A}",
        nfd: "\u{0397}\u{0313}\u{0300}",
        nfkc: "\u{1F2A}",
        nfkd: "\u{0397}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F2B}",
        nfc: "\u{1F2B}",
        nfd: "\u{0397}\u{0314}\u{0300}",
        nfkc: "\u{1F2B}",
        nfkd: "\u{0397}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F2C}",
        nfc: "\u{1F2C}",
        nfd: "\u{0397}\u{0313}\u{0301}",
        nfkc: "\u{1F2C}",
        nfkd: "\u{0397}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F2D}",
        nfc: "\u{1F2D}",
        nfd: "\u{0397}\u{0314}\u{0301}",
        nfkc: "\u{1F2D}",
        nfkd: "\u{0397}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F2E}",
        nfc: "\u{1F2E}",
        nfd: "\u{0397}\u{0313}\u{0342}",
        nfkc: "\u{1F2E}",
        nfkd: "\u{0397}\u{0313}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F2F}",
        nfc: "\u{1F2F}",
        nfd: "\u{0397}\u{0314}\u{0342}",
        nfkc: "\u{1F2F}",
        nfkd: "\u{0397}\u{0314}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F30}",
        nfc: "\u{1F30}",
        nfd: "\u{03B9}\u{0313}",
        nfkc: "\u{1F30}",
        nfkd: "\u{03B9}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F31}",
        nfc: "\u{1F31}",
        nfd: "\u{03B9}\u{0314}",
        nfkc: "\u{1F31}",
        nfkd: "\u{03B9}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F32}",
        nfc: "\u{1F32}",
        nfd: "\u{03B9}\u{0313}\u{0300}",
        nfkc: "\u{1F32}",
        nfkd: "\u{03B9}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F33}",
        nfc: "\u{1F33}",
        nfd: "\u{03B9}\u{0314}\u{0300}",
        nfkc: "\u{1F33}",
        nfkd: "\u{03B9}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F34}",
        nfc: "\u{1F34}",
        nfd: "\u{03B9}\u{0313}\u{0301}",
        nfkc: "\u{1F34}",
        nfkd: "\u{03B9}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F35}",
        nfc: "\u{1F35}",
        nfd: "\u{03B9}\u{0314}\u{0301}",
        nfkc: "\u{1F35}",
        nfkd: "\u{03B9}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F36}",
        nfc: "\u{1F36}",
        nfd: "\u{03B9}\u{0313}\u{0342}",
        nfkc: "\u{1F36}",
        nfkd: "\u{03B9}\u{0313}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F37}",
        nfc: "\u{1F37}",
        nfd: "\u{03B9}\u{0314}\u{0342}",
        nfkc: "\u{1F37}",
        nfkd: "\u{03B9}\u{0314}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F38}",
        nfc: "\u{1F38}",
        nfd: "\u{0399}\u{0313}",
        nfkc: "\u{1F38}",
        nfkd: "\u{0399}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F39}",
        nfc: "\u{1F39}",
        nfd: "\u{0399}\u{0314}",
        nfkc: "\u{1F39}",
        nfkd: "\u{0399}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F3A}",
        nfc: "\u{1F3A}",
        nfd: "\u{0399}\u{0313}\u{0300}",
        nfkc: "\u{1F3A}",
        nfkd: "\u{0399}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F3B}",
        nfc: "\u{1F3B}",
        nfd: "\u{0399}\u{0314}\u{0300}",
        nfkc: "\u{1F3B}",
        nfkd: "\u{0399}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F3C}",
        nfc: "\u{1F3C}",
        nfd: "\u{0399}\u{0313}\u{0301}",
        nfkc: "\u{1F3C}",
        nfkd: "\u{0399}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F3D}",
        nfc: "\u{1F3D}",
        nfd: "\u{0399}\u{0314}\u{0301}",
        nfkc: "\u{1F3D}",
        nfkd: "\u{0399}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F3E}",
        nfc: "\u{1F3E}",
        nfd: "\u{0399}\u{0313}\u{0342}",
        nfkc: "\u{1F3E}",
        nfkd: "\u{0399}\u{0313}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F3F}",
        nfc: "\u{1F3F}",
        nfd: "\u{0399}\u{0314}\u{0342}",
        nfkc: "\u{1F3F}",
        nfkd: "\u{0399}\u{0314}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F40}",
        nfc: "\u{1F40}",
        nfd: "\u{03BF}\u{0313}",
        nfkc: "\u{1F40}",
        nfkd: "\u{03BF}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F41}",
        nfc: "\u{1F41}",
        nfd: "\u{03BF}\u{0314}",
        nfkc: "\u{1F41}",
        nfkd: "\u{03BF}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F42}",
        nfc: "\u{1F42}",
        nfd: "\u{03BF}\u{0313}\u{0300}",
        nfkc: "\u{1F42}",
        nfkd: "\u{03BF}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F43}",
        nfc: "\u{1F43}",
        nfd: "\u{03BF}\u{0314}\u{0300}",
        nfkc: "\u{1F43}",
        nfkd: "\u{03BF}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F44}",
        nfc: "\u{1F44}",
        nfd: "\u{03BF}\u{0313}\u{0301}",
        nfkc: "\u{1F44}",
        nfkd: "\u{03BF}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F45}",
        nfc: "\u{1F45}",
        nfd: "\u{03BF}\u{0314}\u{0301}",
        nfkc: "\u{1F45}",
        nfkd: "\u{03BF}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F48}",
        nfc: "\u{1F48}",
        nfd: "\u{039F}\u{0313}",
        nfkc: "\u{1F48}",
        nfkd: "\u{039F}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F49}",
        nfc: "\u{1F49}",
        nfd: "\u{039F}\u{0314}",
        nfkc: "\u{1F49}",
        nfkd: "\u{039F}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F4A}",
        nfc: "\u{1F4A}",
        nfd: "\u{039F}\u{0313}\u{0300}",
        nfkc: "\u{1F4A}",
        nfkd: "\u{039F}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F4B}",
        nfc: "\u{1F4B}",
        nfd: "\u{039F}\u{0314}\u{0300}",
        nfkc: "\u{1F4B}",
        nfkd: "\u{039F}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F4C}",
        nfc: "\u{1F4C}",
        nfd: "\u{039F}\u{0313}\u{0301}",
        nfkc: "\u{1F4C}",
        nfkd: "\u{039F}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F4D}",
        nfc: "\u{1F4D}",
        nfd: "\u{039F}\u{0314}\u{0301}",
        nfkc: "\u{1F4D}",
        nfkd: "\u{039F}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F50}",
        nfc: "\u{1F50}",
        nfd: "\u{03C5}\u{0313}",
        nfkc: "\u{1F50}",
        nfkd: "\u{03C5}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F51}",
        nfc: "\u{1F51}",
        nfd: "\u{03C5}\u{0314}",
        nfkc: "\u{1F51}",
        nfkd: "\u{03C5}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F52}",
        nfc: "\u{1F52}",
        nfd: "\u{03C5}\u{0313}\u{0300}",
        nfkc: "\u{1F52}",
        nfkd: "\u{03C5}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F53}",
        nfc: "\u{1F53}",
        nfd: "\u{03C5}\u{0314}\u{0300}",
        nfkc: "\u{1F53}",
        nfkd: "\u{03C5}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F54}",
        nfc: "\u{1F54}",
        nfd: "\u{03C5}\u{0313}\u{0301}",
        nfkc: "\u{1F54}",
        nfkd: "\u{03C5}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F55}",
        nfc: "\u{1F55}",
        nfd: "\u{03C5}\u{0314}\u{0301}",
        nfkc: "\u{1F55}",
        nfkd: "\u{03C5}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F56}",
        nfc: "\u{1F56}",
        nfd: "\u{03C5}\u{0313}\u{0342}",
        nfkc: "\u{1F56}",
        nfkd: "\u{03C5}\u{0313}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F57}",
        nfc: "\u{1F57}",
        nfd: "\u{03C5}\u{0314}\u{0342}",
        nfkc: "\u{1F57}",
        nfkd: "\u{03C5}\u{0314}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F59}",
        nfc: "\u{1F59}",
        nfd: "\u{03A5}\u{0314}",
        nfkc: "\u{1F59}",
        nfkd: "\u{03A5}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F5B}",
        nfc: "\u{1F5B}",
        nfd: "\u{03A5}\u{0314}\u{0300}",
        nfkc: "\u{1F5B}",
        nfkd: "\u{03A5}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F5D}",
        nfc: "\u{1F5D}",
        nfd: "\u{03A5}\u{0314}\u{0301}",
        nfkc: "\u{1F5D}",
        nfkd: "\u{03A5}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F5F}",
        nfc: "\u{1F5F}",
        nfd: "\u{03A5}\u{0314}\u{0342}",
        nfkc: "\u{1F5F}",
        nfkd: "\u{03A5}\u{0314}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F60}",
        nfc: "\u{1F60}",
        nfd: "\u{03C9}\u{0313}",
        nfkc: "\u{1F60}",
        nfkd: "\u{03C9}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F61}",
        nfc: "\u{1F61}",
        nfd: "\u{03C9}\u{0314}",
        nfkc: "\u{1F61}",
        nfkd: "\u{03C9}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F62}",
        nfc: "\u{1F62}",
        nfd: "\u{03C9}\u{0313}\u{0300}",
        nfkc: "\u{1F62}",
        nfkd: "\u{03C9}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F63}",
        nfc: "\u{1F63}",
        nfd: "\u{03C9}\u{0314}\u{0300}",
        nfkc: "\u{1F63}",
        nfkd: "\u{03C9}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F64}",
        nfc: "\u{1F64}",
        nfd: "\u{03C9}\u{0313}\u{0301}",
        nfkc: "\u{1F64}",
        nfkd: "\u{03C9}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F65}",
        nfc: "\u{1F65}",
        nfd: "\u{03C9}\u{0314}\u{0301}",
        nfkc: "\u{1F65}",
        nfkd: "\u{03C9}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F66}",
        nfc: "\u{1F66}",
        nfd: "\u{03C9}\u{0313}\u{0342}",
        nfkc: "\u{1F66}",
        nfkd: "\u{03C9}\u{0313}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F67}",
        nfc: "\u{1F67}",
        nfd: "\u{03C9}\u{0314}\u{0342}",
        nfkc: "\u{1F67}",
        nfkd: "\u{03C9}\u{0314}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F68}",
        nfc: "\u{1F68}",
        nfd: "\u{03A9}\u{0313}",
        nfkc: "\u{1F68}",
        nfkd: "\u{03A9}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1F69}",
        nfc: "\u{1F69}",
        nfd: "\u{03A9}\u{0314}",
        nfkc: "\u{1F69}",
        nfkd: "\u{03A9}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1F6A}",
        nfc: "\u{1F6A}",
        nfd: "\u{03A9}\u{0313}\u{0300}",
        nfkc: "\u{1F6A}",
        nfkd: "\u{03A9}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F6B}",
        nfc: "\u{1F6B}",
        nfd: "\u{03A9}\u{0314}\u{0300}",
        nfkc: "\u{1F6B}",
        nfkd: "\u{03A9}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F6C}",
        nfc: "\u{1F6C}",
        nfd: "\u{03A9}\u{0313}\u{0301}",
        nfkc: "\u{1F6C}",
        nfkd: "\u{03A9}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F6D}",
        nfc: "\u{1F6D}",
        nfd: "\u{03A9}\u{0314}\u{0301}",
        nfkc: "\u{1F6D}",
        nfkd: "\u{03A9}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F6E}",
        nfc: "\u{1F6E}",
        nfd: "\u{03A9}\u{0313}\u{0342}",
        nfkc: "\u{1F6E}",
        nfkd: "\u{03A9}\u{0313}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F6F}",
        nfc: "\u{1F6F}",
        nfd: "\u{03A9}\u{0314}\u{0342}",
        nfkc: "\u{1F6F}",
        nfkd: "\u{03A9}\u{0314}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1F70}",
        nfc: "\u{1F70}",
        nfd: "\u{03B1}\u{0300}",
        nfkc: "\u{1F70}",
        nfkd: "\u{03B1}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F71}",
        nfc: "\u{03AC}",
        nfd: "\u{03B1}\u{0301}",
        nfkc: "\u{03AC}",
        nfkd: "\u{03B1}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F72}",
        nfc: "\u{1F72}",
        nfd: "\u{03B5}\u{0300}",
        nfkc: "\u{1F72}",
        nfkd: "\u{03B5}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F73}",
        nfc: "\u{03AD}",
        nfd: "\u{03B5}\u{0301}",
        nfkc: "\u{03AD}",
        nfkd: "\u{03B5}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F74}",
        nfc: "\u{1F74}",
        nfd: "\u{03B7}\u{0300}",
        nfkc: "\u{1F74}",
        nfkd: "\u{03B7}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F75}",
        nfc: "\u{03AE}",
        nfd: "\u{03B7}\u{0301}",
        nfkc: "\u{03AE}",
        nfkd: "\u{03B7}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F76}",
        nfc: "\u{1F76}",
        nfd: "\u{03B9}\u{0300}",
        nfkc: "\u{1F76}",
        nfkd: "\u{03B9}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F77}",
        nfc: "\u{03AF}",
        nfd: "\u{03B9}\u{0301}",
        nfkc: "\u{03AF}",
        nfkd: "\u{03B9}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F78}",
        nfc: "\u{1F78}",
        nfd: "\u{03BF}\u{0300}",
        nfkc: "\u{1F78}",
        nfkd: "\u{03BF}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F79}",
        nfc: "\u{03CC}",
        nfd: "\u{03BF}\u{0301}",
        nfkc: "\u{03CC}",
        nfkd: "\u{03BF}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F7A}",
        nfc: "\u{1F7A}",
        nfd: "\u{03C5}\u{0300}",
        nfkc: "\u{1F7A}",
        nfkd: "\u{03C5}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F7B}",
        nfc: "\u{03CD}",
        nfd: "\u{03C5}\u{0301}",
        nfkc: "\u{03CD}",
        nfkd: "\u{03C5}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F7C}",
        nfc: "\u{1F7C}",
        nfd: "\u{03C9}\u{0300}",
        nfkc: "\u{1F7C}",
        nfkd: "\u{03C9}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1F7D}",
        nfc: "\u{03CE}",
        nfd: "\u{03C9}\u{0301}",
        nfkc: "\u{03CE}",
        nfkd: "\u{03C9}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1F80}",
        nfc: "\u{1F80}",
        nfd: "\u{03B1}\u{0313}\u{0345}",
        nfkc: "\u{1F80}",
        nfkd: "\u{03B1}\u{0313}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F81}",
        nfc: "\u{1F81}",
        nfd: "\u{03B1}\u{0314}\u{0345}",
        nfkc: "\u{1F81}",
        nfkd: "\u{03B1}\u{0314}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F82}",
        nfc: "\u{1F82}",
        nfd: "\u{03B1}\u{0313}\u{0300}\u{0345}",
        nfkc: "\u{1F82}",
        nfkd: "\u{03B1}\u{0313}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F83}",
        nfc: "\u{1F83}",
        nfd: "\u{03B1}\u{0314}\u{0300}\u{0345}",
        nfkc: "\u{1F83}",
        nfkd: "\u{03B1}\u{0314}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F84}",
        nfc: "\u{1F84}",
        nfd: "\u{03B1}\u{0313}\u{0301}\u{0345}",
        nfkc: "\u{1F84}",
        nfkd: "\u{03B1}\u{0313}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F85}",
        nfc: "\u{1F85}",
        nfd: "\u{03B1}\u{0314}\u{0301}\u{0345}",
        nfkc: "\u{1F85}",
        nfkd: "\u{03B1}\u{0314}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F86}",
        nfc: "\u{1F86}",
        nfd: "\u{03B1}\u{0313}\u{0342}\u{0345}",
        nfkc: "\u{1F86}",
        nfkd: "\u{03B1}\u{0313}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F87}",
        nfc: "\u{1F87}",
        nfd: "\u{03B1}\u{0314}\u{0342}\u{0345}",
        nfkc: "\u{1F87}",
        nfkd: "\u{03B1}\u{0314}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F88}",
        nfc: "\u{1F88}",
        nfd: "\u{0391}\u{0313}\u{0345}",
        nfkc: "\u{1F88}",
        nfkd: "\u{0391}\u{0313}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F89}",
        nfc: "\u{1F89}",
        nfd: "\u{0391}\u{0314}\u{0345}",
        nfkc: "\u{1F89}",
        nfkd: "\u{0391}\u{0314}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F8A}",
        nfc: "\u{1F8A}",
        nfd: "\u{0391}\u{0313}\u{0300}\u{0345}",
        nfkc: "\u{1F8A}",
        nfkd: "\u{0391}\u{0313}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F8B}",
        nfc: "\u{1F8B}",
        nfd: "\u{0391}\u{0314}\u{0300}\u{0345}",
        nfkc: "\u{1F8B}",
        nfkd: "\u{0391}\u{0314}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F8C}",
        nfc: "\u{1F8C}",
        nfd: "\u{0391}\u{0313}\u{0301}\u{0345}",
        nfkc: "\u{1F8C}",
        nfkd: "\u{0391}\u{0313}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F8D}",
        nfc: "\u{1F8D}",
        nfd: "\u{0391}\u{0314}\u{0301}\u{0345}",
        nfkc: "\u{1F8D}",
        nfkd: "\u{0391}\u{0314}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F8E}",
        nfc: "\u{1F8E}",
        nfd: "\u{0391}\u{0313}\u{0342}\u{0345}",
        nfkc: "\u{1F8E}",
        nfkd: "\u{0391}\u{0313}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F8F}",
        nfc: "\u{1F8F}",
        nfd: "\u{0391}\u{0314}\u{0342}\u{0345}",
        nfkc: "\u{1F8F}",
        nfkd: "\u{0391}\u{0314}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F90}",
        nfc: "\u{1F90}",
        nfd: "\u{03B7}\u{0313}\u{0345}",
        nfkc: "\u{1F90}",
        nfkd: "\u{03B7}\u{0313}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F91}",
        nfc: "\u{1F91}",
        nfd: "\u{03B7}\u{0314}\u{0345}",
        nfkc: "\u{1F91}",
        nfkd: "\u{03B7}\u{0314}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F92}",
        nfc: "\u{1F92}",
        nfd: "\u{03B7}\u{0313}\u{0300}\u{0345}",
        nfkc: "\u{1F92}",
        nfkd: "\u{03B7}\u{0313}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F93}",
        nfc: "\u{1F93}",
        nfd: "\u{03B7}\u{0314}\u{0300}\u{0345}",
        nfkc: "\u{1F93}",
        nfkd: "\u{03B7}\u{0314}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F94}",
        nfc: "\u{1F94}",
        nfd: "\u{03B7}\u{0313}\u{0301}\u{0345}",
        nfkc: "\u{1F94}",
        nfkd: "\u{03B7}\u{0313}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F95}",
        nfc: "\u{1F95}",
        nfd: "\u{03B7}\u{0314}\u{0301}\u{0345}",
        nfkc: "\u{1F95}",
        nfkd: "\u{03B7}\u{0314}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F96}",
        nfc: "\u{1F96}",
        nfd: "\u{03B7}\u{0313}\u{0342}\u{0345}",
        nfkc: "\u{1F96}",
        nfkd: "\u{03B7}\u{0313}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F97}",
        nfc: "\u{1F97}",
        nfd: "\u{03B7}\u{0314}\u{0342}\u{0345}",
        nfkc: "\u{1F97}",
        nfkd: "\u{03B7}\u{0314}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F98}",
        nfc: "\u{1F98}",
        nfd: "\u{0397}\u{0313}\u{0345}",
        nfkc: "\u{1F98}",
        nfkd: "\u{0397}\u{0313}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F99}",
        nfc: "\u{1F99}",
        nfd: "\u{0397}\u{0314}\u{0345}",
        nfkc: "\u{1F99}",
        nfkd: "\u{0397}\u{0314}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F9A}",
        nfc: "\u{1F9A}",
        nfd: "\u{0397}\u{0313}\u{0300}\u{0345}",
        nfkc: "\u{1F9A}",
        nfkd: "\u{0397}\u{0313}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F9B}",
        nfc: "\u{1F9B}",
        nfd: "\u{0397}\u{0314}\u{0300}\u{0345}",
        nfkc: "\u{1F9B}",
        nfkd: "\u{0397}\u{0314}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F9C}",
        nfc: "\u{1F9C}",
        nfd: "\u{0397}\u{0313}\u{0301}\u{0345}",
        nfkc: "\u{1F9C}",
        nfkd: "\u{0397}\u{0313}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F9D}",
        nfc: "\u{1F9D}",
        nfd: "\u{0397}\u{0314}\u{0301}\u{0345}",
        nfkc: "\u{1F9D}",
        nfkd: "\u{0397}\u{0314}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F9E}",
        nfc: "\u{1F9E}",
        nfd: "\u{0397}\u{0313}\u{0342}\u{0345}",
        nfkc: "\u{1F9E}",
        nfkd: "\u{0397}\u{0313}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1F9F}",
        nfc: "\u{1F9F}",
        nfd: "\u{0397}\u{0314}\u{0342}\u{0345}",
        nfkc: "\u{1F9F}",
        nfkd: "\u{0397}\u{0314}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FA0}",
        nfc: "\u{1FA0}",
        nfd: "\u{03C9}\u{0313}\u{0345}",
        nfkc: "\u{1FA0}",
        nfkd: "\u{03C9}\u{0313}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FA1}",
        nfc: "\u{1FA1}",
        nfd: "\u{03C9}\u{0314}\u{0345}",
        nfkc: "\u{1FA1}",
        nfkd: "\u{03C9}\u{0314}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FA2}",
        nfc: "\u{1FA2}",
        nfd: "\u{03C9}\u{0313}\u{0300}\u{0345}",
        nfkc: "\u{1FA2}",
        nfkd: "\u{03C9}\u{0313}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FA3}",
        nfc: "\u{1FA3}",
        nfd: "\u{03C9}\u{0314}\u{0300}\u{0345}",
        nfkc: "\u{1FA3}",
        nfkd: "\u{03C9}\u{0314}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FA4}",
        nfc: "\u{1FA4}",
        nfd: "\u{03C9}\u{0313}\u{0301}\u{0345}",
        nfkc: "\u{1FA4}",
        nfkd: "\u{03C9}\u{0313}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FA5}",
        nfc: "\u{1FA5}",
        nfd: "\u{03C9}\u{0314}\u{0301}\u{0345}",
        nfkc: "\u{1FA5}",
        nfkd: "\u{03C9}\u{0314}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FA6}",
        nfc: "\u{1FA6}",
        nfd: "\u{03C9}\u{0313}\u{0342}\u{0345}",
        nfkc: "\u{1FA6}",
        nfkd: "\u{03C9}\u{0313}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FA7}",
        nfc: "\u{1FA7}",
        nfd: "\u{03C9}\u{0314}\u{0342}\u{0345}",
        nfkc: "\u{1FA7}",
        nfkd: "\u{03C9}\u{0314}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FA8}",
        nfc: "\u{1FA8}",
        nfd: "\u{03A9}\u{0313}\u{0345}",
        nfkc: "\u{1FA8}",
        nfkd: "\u{03A9}\u{0313}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FA9}",
        nfc: "\u{1FA9}",
        nfd: "\u{03A9}\u{0314}\u{0345}",
        nfkc: "\u{1FA9}",
        nfkd: "\u{03A9}\u{0314}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FAA}",
        nfc: "\u{1FAA}",
        nfd: "\u{03A9}\u{0313}\u{0300}\u{0345}",
        nfkc: "\u{1FAA}",
        nfkd: "\u{03A9}\u{0313}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FAB}",
        nfc: "\u{1FAB}",
        nfd: "\u{03A9}\u{0314}\u{0300}\u{0345}",
        nfkc: "\u{1FAB}",
        nfkd: "\u{03A9}\u{0314}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FAC}",
        nfc: "\u{1FAC}",
        nfd: "\u{03A9}\u{0313}\u{0301}\u{0345}",
        nfkc: "\u{1FAC}",
        nfkd: "\u{03A9}\u{0313}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FAD}",
        nfc: "\u{1FAD}",
        nfd: "\u{03A9}\u{0314}\u{0301}\u{0345}",
        nfkc: "\u{1FAD}",
        nfkd: "\u{03A9}\u{0314}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FAE}",
        nfc: "\u{1FAE}",
        nfd: "\u{03A9}\u{0313}\u{0342}\u{0345}",
        nfkc: "\u{1FAE}",
        nfkd: "\u{03A9}\u{0313}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FAF}",
        nfc: "\u{1FAF}",
        nfd: "\u{03A9}\u{0314}\u{0342}\u{0345}",
        nfkc: "\u{1FAF}",
        nfkd: "\u{03A9}\u{0314}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FB0}",
        nfc: "\u{1FB0}",
        nfd: "\u{03B1}\u{0306}",
        nfkc: "\u{1FB0}",
        nfkd: "\u{03B1}\u{0306}",
    },
    NormalizationTest {
        source: "\u{1FB1}",
        nfc: "\u{1FB1}",
        nfd: "\u{03B1}\u{0304}",
        nfkc: "\u{1FB1}",
        nfkd: "\u{03B1}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1FB2}",
        nfc: "\u{1FB2}",
        nfd: "\u{03B1}\u{0300}\u{0345}",
        nfkc: "\u{1FB2}",
        nfkd: "\u{03B1}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FB3}",
        nfc: "\u{1FB3}",
        nfd: "\u{03B1}\u{0345}",
        nfkc: "\u{1FB3}",
        nfkd: "\u{03B1}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FB4}",
        nfc: "\u{1FB4}",
        nfd: "\u{03B1}\u{0301}\u{0345}",
        nfkc: "\u{1FB4}",
        nfkd: "\u{03B1}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FB6}",
        nfc: "\u{1FB6}",
        nfd: "\u{03B1}\u{0342}",
        nfkc: "\u{1FB6}",
        nfkd: "\u{03B1}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1FB7}",
        nfc: "\u{1FB7}",
        nfd: "\u{03B1}\u{0342}\u{0345}",
        nfkc: "\u{1FB7}",
        nfkd: "\u{03B1}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FB8}",
        nfc: "\u{1FB8}",
        nfd: "\u{0391}\u{0306}",
        nfkc: "\u{1FB8}",
        nfkd: "\u{0391}\u{0306}",
    },
    NormalizationTest {
        source: "\u{1FB9}",
        nfc: "\u{1FB9}",
        nfd: "\u{0391}\u{0304}",
        nfkc: "\u{1FB9}",
        nfkd: "\u{0391}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1FBA}",
        nfc: "\u{1FBA}",
        nfd: "\u{0391}\u{0300}",
        nfkc: "\u{1FBA}",
        nfkd: "\u{0391}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1FBB}",
        nfc: "\u{0386}",
        nfd: "\u{0391}\u{0301}",
        nfkc: "\u{0386}",
        nfkd: "\u{0391}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FBC}",
        nfc: "\u{1FBC}",
        nfd: "\u{0391}\u{0345}",
        nfkc: "\u{1FBC}",
        nfkd: "\u{0391}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FBD}",
        nfc: "\u{1FBD}",
        nfd: "\u{1FBD}",
        nfkc: "\u{0020}\u{0313}",
        nfkd: "\u{0020}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1FBE}",
        nfc: "\u{03B9}",
        nfd: "\u{03B9}",
        nfkc: "\u{03B9}",
        nfkd: "\u{03B9}",
    },
    NormalizationTest {
        source: "\u{1FBF}",
        nfc: "\u{1FBF}",
        nfd: "\u{1FBF}",
        nfkc: "\u{0020}\u{0313}",
        nfkd: "\u{0020}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1FC0}",
        nfc: "\u{1FC0}",
        nfd: "\u{1FC0}",
        nfkc: "\u{0020}\u{0342}",
        nfkd: "\u{0020}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1FC1}",
        nfc: "\u{1FC1}",
        nfd: "\u{00A8}\u{0342}",
        nfkc: "\u{0020}\u{0308}\u{0342}",
        nfkd: "\u{0020}\u{0308}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1FC2}",
        nfc: "\u{1FC2}",
        nfd: "\u{03B7}\u{0300}\u{0345}",
        nfkc: "\u{1FC2}",
        nfkd: "\u{03B7}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FC3}",
        nfc: "\u{1FC3}",
        nfd: "\u{03B7}\u{0345}",
        nfkc: "\u{1FC3}",
        nfkd: "\u{03B7}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FC4}",
        nfc: "\u{1FC4}",
        nfd: "\u{03B7}\u{0301}\u{0345}",
        nfkc: "\u{1FC4}",
        nfkd: "\u{03B7}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FC6}",
        nfc: "\u{1FC6}",
        nfd: "\u{03B7}\u{0342}",
        nfkc: "\u{1FC6}",
        nfkd: "\u{03B7}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1FC7}",
        nfc: "\u{1FC7}",
        nfd: "\u{03B7}\u{0342}\u{0345}",
        nfkc: "\u{1FC7}",
        nfkd: "\u{03B7}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FC8}",
        nfc: "\u{1FC8}",
        nfd: "\u{0395}\u{0300}",
        nfkc: "\u{1FC8}",
        nfkd: "\u{0395}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1FC9}",
        nfc: "\u{0388}",
        nfd: "\u{0395}\u{0301}",
        nfkc: "\u{0388}",
        nfkd: "\u{0395}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FCA}",
        nfc: "\u{1FCA}",
        nfd: "\u{0397}\u{0300}",
        nfkc: "\u{1FCA}",
        nfkd: "\u{0397}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1FCB}",
        nfc: "\u{0389}",
        nfd: "\u{0397}\u{0301}",
        nfkc: "\u{0389}",
        nfkd: "\u{0397}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FCC}",
        nfc: "\u{1FCC}",
        nfd: "\u{0397}\u{0345}",
        nfkc: "\u{1FCC}",
        nfkd: "\u{0397}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FCD}",
        nfc: "\u{1FCD}",
        nfd: "\u{1FBF}\u{0300}",
        nfkc: "\u{0020}\u{0313}\u{0300}",
        nfkd: "\u{0020}\u{0313}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1FCE}",
        nfc: "\u{1FCE}",
        nfd: "\u{1FBF}\u{0301}",
        nfkc: "\u{0020}\u{0313}\u{0301}",
        nfkd: "\u{0020}\u{0313}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FCF}",
        nfc: "\u{1FCF}",
        nfd: "\u{1FBF}\u{0342}",
        nfkc: "\u{0020}\u{0313}\u{0342}",
        nfkd: "\u{0020}\u{0313}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1FD0}",
        nfc: "\u{1FD0}",
        nfd: "\u{03B9}\u{0306}",
        nfkc: "\u{1FD0}",
        nfkd: "\u{03B9}\u{0306}",
    },
    NormalizationTest {
        source: "\u{1FD1}",
        nfc: "\u{1FD1}",
        nfd: "\u{03B9}\u{0304}",
        nfkc: "\u{1FD1}",
        nfkd: "\u{03B9}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1FD2}",
        nfc: "\u{1FD2}",
        nfd: "\u{03B9}\u{0308}\u{0300}",
        nfkc: "\u{1FD2}",
        nfkd: "\u{03B9}\u{0308}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1FD3}",
        nfc: "\u{0390}",
        nfd: "\u{03B9}\u{0308}\u{0301}",
        nfkc: "\u{0390}",
        nfkd: "\u{03B9}\u{0308}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FD6}",
        nfc: "\u{1FD6}",
        nfd: "\u{03B9}\u{0342}",
        nfkc: "\u{1FD6}",
        nfkd: "\u{03B9}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1FD7}",
        nfc: "\u{1FD7}",
        nfd: "\u{03B9}\u{0308}\u{0342}",
        nfkc: "\u{1FD7}",
        nfkd: "\u{03B9}\u{0308}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1FD8}",
        nfc: "\u{1FD8}",
        nfd: "\u{0399}\u{0306}",
        nfkc: "\u{1FD8}",
        nfkd: "\u{0399}\u{0306}",
    },
    NormalizationTest {
        source: "\u{1FD9}",
        nfc: "\u{1FD9}",
        nfd: "\u{0399}\u{0304}",
        nfkc: "\u{1FD9}",
        nfkd: "\u{0399}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1FDA}",
        nfc: "\u{1FDA}",
        nfd: "\u{0399}\u{0300}",
        nfkc: "\u{1FDA}",
        nfkd: "\u{0399}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1FDB}",
        nfc: "\u{038A}",
        nfd: "\u{0399}\u{0301}",
        nfkc: "\u{038A}",
        nfkd: "\u{0399}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FDD}",
        nfc: "\u{1FDD}",
        nfd: "\u{1FFE}\u{0300}",
        nfkc: "\u{0020}\u{0314}\u{0300}",
        nfkd: "\u{0020}\u{0314}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1FDE}",
        nfc: "\u{1FDE}",
        nfd: "\u{1FFE}\u{0301}",
        nfkc: "\u{0020}\u{0314}\u{0301}",
        nfkd: "\u{0020}\u{0314}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FDF}",
        nfc: "\u{1FDF}",
        nfd: "\u{1FFE}\u{0342}",
        nfkc: "\u{0020}\u{0314}\u{0342}",
        nfkd: "\u{0020}\u{0314}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1FE0}",
        nfc: "\u{1FE0}",
        nfd: "\u{03C5}\u{0306}",
        nfkc: "\u{1FE0}",
        nfkd: "\u{03C5}\u{0306}",
    },
    NormalizationTest {
        source: "\u{1FE1}",
        nfc: "\u{1FE1}",
        nfd: "\u{03C5}\u{0304}",
        nfkc: "\u{1FE1}",
        nfkd: "\u{03C5}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1FE2}",
        nfc: "\u{1FE2}",
        nfd: "\u{03C5}\u{0308}\u{0300}",
        nfkc: "\u{1FE2}",
        nfkd: "\u{03C5}\u{0308}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1FE3}",
        nfc: "\u{03B0}",
        nfd: "\u{03C5}\u{0308}\u{0301}",
        nfkc: "\u{03B0}",
        nfkd: "\u{03C5}\u{0308}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FE4}",
        nfc: "\u{1FE4}",
        nfd: "\u{03C1}\u{0313}",
        nfkc: "\u{1FE4}",
        nfkd: "\u{03C1}\u{0313}",
    },
    NormalizationTest {
        source: "\u{1FE5}",
        nfc: "\u{1FE5}",
        nfd: "\u{03C1}\u{0314}",
        nfkc: "\u{1FE5}",
        nfkd: "\u{03C1}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1FE6}",
        nfc: "\u{1FE6}",
        nfd: "\u{03C5}\u{0342}",
        nfkc: "\u{1FE6}",
        nfkd: "\u{03C5}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1FE7}",
        nfc: "\u{1FE7}",
        nfd: "\u{03C5}\u{0308}\u{0342}",
        nfkc: "\u{1FE7}",
        nfkd: "\u{03C5}\u{0308}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1FE8}",
        nfc: "\u{1FE8}",
        nfd: "\u{03A5}\u{0306}",
        nfkc: "\u{1FE8}",
        nfkd: "\u{03A5}\u{0306}",
    },
    NormalizationTest {
        source: "\u{1FE9}",
        nfc: "\u{1FE9}",
        nfd: "\u{03A5}\u{0304}",
        nfkc: "\u{1FE9}",
        nfkd: "\u{03A5}\u{0304}",
    },
    NormalizationTest {
        source: "\u{1FEA}",
        nfc: "\u{1FEA}",
        nfd: "\u{03A5}\u{0300}",
        nfkc: "\u{1FEA}",
        nfkd: "\u{03A5}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1FEB}",
        nfc: "\u{038E}",
        nfd: "\u{03A5}\u{0301}",
        nfkc: "\u{038E}",
        nfkd: "\u{03A5}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FEC}",
        nfc: "\u{1FEC}",
        nfd: "\u{03A1}\u{0314}",
        nfkc: "\u{1FEC}",
        nfkd: "\u{03A1}\u{0314}",
    },
    NormalizationTest {
        source: "\u{1FED}",
        nfc: "\u{1FED}",
        nfd: "\u{00A8}\u{0300}",
        nfkc: "\u{0020}\u{0308}\u{0300}",
        nfkd: "\u{0020}\u{0308}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1FEE}",
        nfc: "\u{0385}",
        nfd: "\u{00A8}\u{0301}",
        nfkc: "\u{0020}\u{0308}\u{0301}",
        nfkd: "\u{0020}\u{0308}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FEF}",
        nfc: "\u{0060}",
        nfd: "\u{0060}",
        nfkc: "\u{0060}",
        nfkd: "\u{0060}",
    },
    NormalizationTest {
        source: "\u{1FF2}",
        nfc: "\u{1FF2}",
        nfd: "\u{03C9}\u{0300}\u{0345}",
        nfkc: "\u{1FF2}",
        nfkd: "\u{03C9}\u{0300}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FF3}",
        nfc: "\u{1FF3}",
        nfd: "\u{03C9}\u{0345}",
        nfkc: "\u{1FF3}",
        nfkd: "\u{03C9}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FF4}",
        nfc: "\u{1FF4}",
        nfd: "\u{03C9}\u{0301}\u{0345}",
        nfkc: "\u{1FF4}",
        nfkd: "\u{03C9}\u{0301}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FF6}",
        nfc: "\u{1FF6}",
        nfd: "\u{03C9}\u{0342}",
        nfkc: "\u{1FF6}",
        nfkd: "\u{03C9}\u{0342}",
    },
    NormalizationTest {
        source: "\u{1FF7}",
        nfc: "\u{1FF7}",
        nfd: "\u{03C9}\u{0342}\u{0345}",
        nfkc: "\u{1FF7}",
        nfkd: "\u{03C9}\u{0342}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FF8}",
        nfc: "\u{1FF8}",
        nfd: "\u{039F}\u{0300}",
        nfkc: "\u{1FF8}",
        nfkd: "\u{039F}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1FF9}",
        nfc: "\u{038C}",
        nfd: "\u{039F}\u{0301}",
        nfkc: "\u{038C}",
        nfkd: "\u{039F}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FFA}",
        nfc: "\u{1FFA}",
        nfd: "\u{03A9}\u{0300}",
        nfkc: "\u{1FFA}",
        nfkd: "\u{03A9}\u{0300}",
    },
    NormalizationTest {
        source: "\u{1FFB}",
        nfc: "\u{038F}",
        nfd: "\u{03A9}\u{0301}",
        nfkc: "\u{038F}",
        nfkd: "\u{03A9}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FFC}",
        nfc: "\u{1FFC}",
        nfd: "\u{03A9}\u{0345}",
        nfkc: "\u{1FFC}",
        nfkd: "\u{03A9}\u{0345}",
    },
    NormalizationTest {
        source: "\u{1FFD}",
        nfc: "\u{00B4}",
        nfd: "\u{00B4}",
        nfkc: "\u{0020}\u{0301}",
        nfkd: "\u{0020}\u{0301}",
    },
    NormalizationTest {
        source: "\u{1FFE}",
        nfc: "\u{1FFE}",
        nfd: "\u{1FFE}",
        nfkc: "\u{0020}\u{0314}",
        nfkd: "\u{0020}\u{0314}",
    },
    NormalizationTest {
        source: "\u{2000}",
        nfc: "\u{2002}",
        nfd: "\u{2002}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{2001}",
        nfc: "\u{2003}",
        nfd: "\u{2003}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{2002}",
        nfc: "\u{2002}",
        nfd: "\u{2002}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{2003}",
        nfc: "\u{2003}",
        nfd: "\u{2003}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{2004}",
        nfc: "\u{2004}",
        nfd: "\u{2004}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{2005}",
        nfc: "\u{2005}",
        nfd: "\u{2005}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{2006}",
        nfc: "\u{2006}",
        nfd: "\u{2006}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{2007}",
        nfc: "\u{2007}",
        nfd: "\u{2007}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{2008}",
        nfc: "\u{2008}",
        nfd: "\u{2008}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{2009}",
        nfc: "\u{2009}",
        nfd: "\u{2009}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{200A}",
        nfc: "\u{200A}",
        nfd: "\u{200A}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{2011}",
        nfc: "\u{2011}",
        nfd: "\u{2011}",
        nfkc: "\u{2010}",
        nfkd: "\u{2010}",
    },
    NormalizationTest {
        source: "\u{2017}",
        nfc: "\u{2017}",
        nfd: "\u{2017}",
        nfkc: "\u{0020}\u{0333}",
        nfkd: "\u{0020}\u{0333}",
    },
    NormalizationTest {
        source: "\u{2024}",
        nfc: "\u{2024}",
        nfd: "\u{2024}",
        nfkc: "\u{002E}",
        nfkd: "\u{002E}",
    },
    NormalizationTest {
        source: "\u{2025}",
        nfc: "\u{2025}",
        nfd: "\u{2025}",
        nfkc: "\u{002E}\u{002E}",
        nfkd: "\u{002E}\u{002E}",
    },
    NormalizationTest {
        source: "\u{2026}",
        nfc: "\u{2026}",
        nfd: "\u{2026}",
        nfkc: "\u{002E}\u{002E}\u{002E}",
        nfkd: "\u{002E}\u{002E}\u{002E}",
    },
    NormalizationTest {
        source: "\u{202F}",
        nfc: "\u{202F}",
        nfd: "\u{202F}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{2033}",
        nfc: "\u{2033}",
        nfd: "\u{2033}",
        nfkc: "\u{2032}\u{2032}",
        nfkd: "\u{2032}\u{2032}",
    },
    NormalizationTest {
        source: "\u{2034}",
        nfc: "\u{2034}",
        nfd: "\u{2034}",
        nfkc: "\u{2032}\u{2032}\u{2032}",
        nfkd: "\u{2032}\u{2032}\u{2032}",
    },
    NormalizationTest {
        source: "\u{2036}",
        nfc: "\u{2036}",
        nfd: "\u{2036}",
        nfkc: "\u{2035}\u{2035}",
        nfkd: "\u{2035}\u{2035}",
    },
    NormalizationTest {
        source: "\u{2037}",
        nfc: "\u{2037}",
        nfd: "\u{2037}",
        nfkc: "\u{2035}\u{2035}\u{2035}",
        nfkd: "\u{2035}\u{2035}\u{2035}",
    },
    NormalizationTest {
        source: "\u{203C}",
        nfc: "\u{203C}",
        nfd: "\u{203C}",
        nfkc: "\u{0021}\u{0021}",
        nfkd: "\u{0021}\u{0021}",
    },
    NormalizationTest {
        source: "\u{203E}",
        nfc: "\u{203E}",
        nfd: "\u{203E}",
        nfkc: "\u{0020}\u{0305}",
        nfkd: "\u{0020}\u{0305}",
    },
    NormalizationTest {
        source: "\u{2047}",
        nfc: "\u{2047}",
        nfd: "\u{2047}",
        nfkc: "\u{003F}\u{003F}",
        nfkd: "\u{003F}\u{003F}",
    },
    NormalizationTest {
        source: "\u{2048}",
        nfc: "\u{2048}",
        nfd: "\u{2048}",
        nfkc: "\u{003F}\u{0021}",
        nfkd: "\u{003F}\u{0021}",
    },
    NormalizationTest {
        source: "\u{2049}",
        nfc: "\u{2049}",
        nfd: "\u{2049}",
        nfkc: "\u{0021}\u{003F}",
        nfkd: "\u{0021}\u{003F}",
    },
    NormalizationTest {
        source: "\u{2057}",
        nfc: "\u{2057}",
        nfd: "\u{2057}",
        nfkc: "\u{2032}\u{2032}\u{2032}\u{2032}",
        nfkd: "\u{2032}\u{2032}\u{2032}\u{2032}",
    },
    NormalizationTest {
        source: "\u{205F}",
        nfc: "\u{205F}",
        nfd: "\u{205F}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{2070}",
        nfc: "\u{2070}",
        nfd: "\u{2070}",
        nfkc: "\u{0030}",
        nfkd: "\u{0030}",
    },
    NormalizationTest {
        source: "\u{2071}",
        nfc: "\u{2071}",
        nfd: "\u{2071}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{2074}",
        nfc: "\u{2074}",
        nfd: "\u{2074}",
        nfkc: "\u{0034}",
        nfkd: "\u{0034}",
    },
    NormalizationTest {
        source: "\u{2075}",
        nfc: "\u{2075}",
        nfd: "\u{2075}",
        nfkc: "\u{0035}",
        nfkd: "\u{0035}",
    },
    NormalizationTest {
        source: "\u{2076}",
        nfc: "\u{2076}",
        nfd: "\u{2076}",
        nfkc: "\u{0036}",
        nfkd: "\u{0036}",
    },
    NormalizationTest {
        source: "\u{2077}",
        nfc: "\u{2077}",
        nfd: "\u{2077}",
        nfkc: "\u{0037}",
        nfkd: "\u{0037}",
    },
    NormalizationTest {
        source: "\u{2078}",
        nfc: "\u{2078}",
        nfd: "\u{2078}",
        nfkc: "\u{0038}",
        nfkd: "\u{0038}",
    },
    NormalizationTest {
        source: "\u{2079}",
        nfc: "\u{2079}",
        nfd: "\u{2079}",
        nfkc: "\u{0039}",
        nfkd: "\u{0039}",
    },
    NormalizationTest {
        source: "\u{207A}",
        nfc: "\u{207A}",
        nfd: "\u{207A}",
        nfkc: "\u{002B}",
        nfkd: "\u{002B}",
    },
    NormalizationTest {
        source: "\u{207B}",
        nfc: "\u{207B}",
        nfd: "\u{207B}",
        nfkc: "\u{2212}",
        nfkd: "\u{2212}",
    },
    NormalizationTest {
        source: "\u{207C}",
        nfc: "\u{207C}",
        nfd: "\u{207C}",
        nfkc: "\u{003D}",
        nfkd: "\u{003D}",
    },
    NormalizationTest {
        source: "\u{207D}",
        nfc: "\u{207D}",
        nfd: "\u{207D}",
        nfkc: "\u{0028}",
        nfkd: "\u{0028}",
    },
    NormalizationTest {
        source: "\u{207E}",
        nfc: "\u{207E}",
        nfd: "\u{207E}",
        nfkc: "\u{0029}",
        nfkd: "\u{0029}",
    },
    NormalizationTest {
        source: "\u{207F}",
        nfc: "\u{207F}",
        nfd: "\u{207F}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{2080}",
        nfc: "\u{2080}",
        nfd: "\u{2080}",
        nfkc: "\u{0030}",
        nfkd: "\u{0030}",
    },
    NormalizationTest {
        source: "\u{2081}",
        nfc: "\u{2081}",
        nfd: "\u{2081}",
        nfkc: "\u{0031}",
        nfkd: "\u{0031}",
    },
    NormalizationTest {
        source: "\u{2082}",
        nfc: "\u{2082}",
        nfd: "\u{2082}",
        nfkc: "\u{0032}",
        nfkd: "\u{0032}",
    },
    NormalizationTest {
        source: "\u{2083}",
        nfc: "\u{2083}",
        nfd: "\u{2083}",
        nfkc: "\u{0033}",
        nfkd: "\u{0033}",
    },
    NormalizationTest {
        source: "\u{2084}",
        nfc: "\u{2084}",
        nfd: "\u{2084}",
        nfkc: "\u{0034}",
        nfkd: "\u{0034}",
    },
    NormalizationTest {
        source: "\u{2085}",
        nfc: "\u{2085}",
        nfd: "\u{2085}",
        nfkc: "\u{0035}",
        nfkd: "\u{0035}",
    },
    NormalizationTest {
        source: "\u{2086}",
        nfc: "\u{2086}",
        nfd: "\u{2086}",
        nfkc: "\u{0036}",
        nfkd: "\u{0036}",
    },
    NormalizationTest {
        source: "\u{2087}",
        nfc: "\u{2087}",
        nfd: "\u{2087}",
        nfkc: "\u{0037}",
        nfkd: "\u{0037}",
    },
    NormalizationTest {
        source: "\u{2088}",
        nfc: "\u{2088}",
        nfd: "\u{2088}",
        nfkc: "\u{0038}",
        nfkd: "\u{0038}",
    },
    NormalizationTest {
        source: "\u{2089}",
        nfc: "\u{2089}",
        nfd: "\u{2089}",
        nfkc: "\u{0039}",
        nfkd: "\u{0039}",
    },
    NormalizationTest {
        source: "\u{208A}",
        nfc: "\u{208A}",
        nfd: "\u{208A}",
        nfkc: "\u{002B}",
        nfkd: "\u{002B}",
    },
    NormalizationTest {
        source: "\u{208B}",
        nfc: "\u{208B}",
        nfd: "\u{208B}",
        nfkc: "\u{2212}",
        nfkd: "\u{2212}",
    },
    NormalizationTest {
        source: "\u{208C}",
        nfc: "\u{208C}",
        nfd: "\u{208C}",
        nfkc: "\u{003D}",
        nfkd: "\u{003D}",
    },
    NormalizationTest {
        source: "\u{208D}",
        nfc: "\u{208D}",
        nfd: "\u{208D}",
        nfkc: "\u{0028}",
        nfkd: "\u{0028}",
    },
    NormalizationTest {
        source: "\u{208E}",
        nfc: "\u{208E}",
        nfd: "\u{208E}",
        nfkc: "\u{0029}",
        nfkd: "\u{0029}",
    },
    NormalizationTest {
        source: "\u{2090}",
        nfc: "\u{2090}",
        nfd: "\u{2090}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{2091}",
        nfc: "\u{2091}",
        nfd: "\u{2091}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{2092}",
        nfc: "\u{2092}",
        nfd: "\u{2092}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{2093}",
        nfc: "\u{2093}",
        nfd: "\u{2093}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{2094}",
        nfc: "\u{2094}",
        nfd: "\u{2094}",
        nfkc: "\u{0259}",
        nfkd: "\u{0259}",
    },
    NormalizationTest {
        source: "\u{2095}",
        nfc: "\u{2095}",
        nfd: "\u{2095}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{2096}",
        nfc: "\u{2096}",
        nfd: "\u{2096}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{2097}",
        nfc: "\u{2097}",
        nfd: "\u{2097}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{2098}",
        nfc: "\u{2098}",
        nfd: "\u{2098}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{2099}",
        nfc: "\u{2099}",
        nfd: "\u{2099}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{209A}",
        nfc: "\u{209A}",
        nfd: "\u{209A}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{209B}",
        nfc: "\u{209B}",
        nfd: "\u{209B}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{209C}",
        nfc: "\u{209C}",
        nfd: "\u{209C}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{20A8}",
        nfc: "\u{20A8}",
        nfd: "\u{20A8}",
        nfkc: "\u{0052}\u{0073}",
        nfkd: "\u{0052}\u{0073}",
    },
    NormalizationTest {
        source: "\u{2100}",
        nfc: "\u{2100}",
        nfd: "\u{2100}",
        nfkc: "\u{0061}\u{002F}\u{0063}",
        nfkd: "\u{0061}\u{002F}\u{0063}",
    },
    NormalizationTest {
        source: "\u{2101}",
        nfc: "\u{2101}",
        nfd: "\u{2101}",
        nfkc: "\u{0061}\u{002F}\u{0073}",
        nfkd: "\u{0061}\u{002F}\u{0073}",
    },
    NormalizationTest {
        source: "\u{2102}",
        nfc: "\u{2102}",
        nfd: "\u{2102}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{2103}",
        nfc: "\u{2103}",
        nfd: "\u{2103}",
        nfkc: "\u{00B0}\u{0043}",
        nfkd: "\u{00B0}\u{0043}",
    },
    NormalizationTest {
        source: "\u{2105}",
        nfc: "\u{2105}",
        nfd: "\u{2105}",
        nfkc: "\u{0063}\u{002F}\u{006F}",
        nfkd: "\u{0063}\u{002F}\u{006F}",
    },
    NormalizationTest {
        source: "\u{2106}",
        nfc: "\u{2106}",
        nfd: "\u{2106}",
        nfkc: "\u{0063}\u{002F}\u{0075}",
        nfkd: "\u{0063}\u{002F}\u{0075}",
    },
    NormalizationTest {
        source: "\u{2107}",
        nfc: "\u{2107}",
        nfd: "\u{2107}",
        nfkc: "\u{0190}",
        nfkd: "\u{0190}",
    },
    NormalizationTest {
        source: "\u{2109}",
        nfc: "\u{2109}",
        nfd: "\u{2109}",
        nfkc: "\u{00B0}\u{0046}",
        nfkd: "\u{00B0}\u{0046}",
    },
    NormalizationTest {
        source: "\u{210A}",
        nfc: "\u{210A}",
        nfd: "\u{210A}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{210B}",
        nfc: "\u{210B}",
        nfd: "\u{210B}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{210C}",
        nfc: "\u{210C}",
        nfd: "\u{210C}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{210D}",
        nfc: "\u{210D}",
        nfd: "\u{210D}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{210E}",
        nfc: "\u{210E}",
        nfd: "\u{210E}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{210F}",
        nfc: "\u{210F}",
        nfd: "\u{210F}",
        nfkc: "\u{0127}",
        nfkd: "\u{0127}",
    },
    NormalizationTest {
        source: "\u{2110}",
        nfc: "\u{2110}",
        nfd: "\u{2110}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{2111}",
        nfc: "\u{2111}",
        nfd: "\u{2111}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{2112}",
        nfc: "\u{2112}",
        nfd: "\u{2112}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{2113}",
        nfc: "\u{2113}",
        nfd: "\u{2113}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{2115}",
        nfc: "\u{2115}",
        nfd: "\u{2115}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{2116}",
        nfc: "\u{2116}",
        nfd: "\u{2116}",
        nfkc: "\u{004E}\u{006F}",
        nfkd: "\u{004E}\u{006F}",
    },
    NormalizationTest {
        source: "\u{2119}",
        nfc: "\u{2119}",
        nfd: "\u{2119}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{211A}",
        nfc: "\u{211A}",
        nfd: "\u{211A}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{211B}",
        nfc: "\u{211B}",
        nfd: "\u{211B}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{211C}",
        nfc: "\u{211C}",
        nfd: "\u{211C}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{211D}",
        nfc: "\u{211D}",
        nfd: "\u{211D}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{2120}",
        nfc: "\u{2120}",
        nfd: "\u{2120}",
        nfkc: "\u{0053}\u{004D}",
        nfkd: "\u{0053}\u{004D}",
    },
    NormalizationTest {
        source: "\u{2121}",
        nfc: "\u{2121}",
        nfd: "\u{2121}",
        nfkc: "\u{0054}\u{0045}\u{004C}",
        nfkd: "\u{0054}\u{0045}\u{004C}",
    },
    NormalizationTest {
        source: "\u{2122}",
        nfc: "\u{2122}",
        nfd: "\u{2122}",
        nfkc: "\u{0054}\u{004D}",
        nfkd: "\u{0054}\u{004D}",
    },
    NormalizationTest {
        source: "\u{2124}",
        nfc: "\u{2124}",
        nfd: "\u{2124}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{2126}",
        nfc: "\u{03A9}",
        nfd: "\u{03A9}",
        nfkc: "\u{03A9}",
        nfkd: "\u{03A9}",
    },
    NormalizationTest {
        source: "\u{2128}",
        nfc: "\u{2128}",
        nfd: "\u{2128}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{212A}",
        nfc: "\u{004B}",
        nfd: "\u{004B}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{212B}",
        nfc: "\u{00C5}",
        nfd: "\u{0041}\u{030A}",
        nfkc: "\u{00C5}",
        nfkd: "\u{0041}\u{030A}",
    },
    NormalizationTest {
        source: "\u{212C}",
        nfc: "\u{212C}",
        nfd: "\u{212C}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{212D}",
        nfc: "\u{212D}",
        nfd: "\u{212D}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{212F}",
        nfc: "\u{212F}",
        nfd: "\u{212F}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{2130}",
        nfc: "\u{2130}",
        nfd: "\u{2130}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{2131}",
        nfc: "\u{2131}",
        nfd: "\u{2131}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{2133}",
        nfc: "\u{2133}",
        nfd: "\u{2133}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{2134}",
        nfc: "\u{2134}",
        nfd: "\u{2134}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{2135}",
        nfc: "\u{2135}",
        nfd: "\u{2135}",
        nfkc: "\u{05D0}",
        nfkd: "\u{05D0}",
    },
    NormalizationTest {
        source: "\u{2136}",
        nfc: "\u{2136}",
        nfd: "\u{2136}",
        nfkc: "\u{05D1}",
        nfkd: "\u{05D1}",
    },
    NormalizationTest {
        source: "\u{2137}",
        nfc: "\u{2137}",
        nfd: "\u{2137}",
        nfkc: "\u{05D2}",
        nfkd: "\u{05D2}",
    },
    NormalizationTest {
        source: "\u{2138}",
        nfc: "\u{2138}",
        nfd: "\u{2138}",
        nfkc: "\u{05D3}",
        nfkd: "\u{05D3}",
    },
    NormalizationTest {
        source: "\u{2139}",
        nfc: "\u{2139}",
        nfd: "\u{2139}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{213B}",
        nfc: "\u{213B}",
        nfd: "\u{213B}",
        nfkc: "\u{0046}\u{0041}\u{0058}",
        nfkd: "\u{0046}\u{0041}\u{0058}",
    },
    NormalizationTest {
        source: "\u{213C}",
        nfc: "\u{213C}",
        nfd: "\u{213C}",
        nfkc: "\u{03C0}",
        nfkd: "\u{03C0}",
    },
    NormalizationTest {
        source: "\u{213D}",
        nfc: "\u{213D}",
        nfd: "\u{213D}",
        nfkc: "\u{03B3}",
        nfkd: "\u{03B3}",
    },
    NormalizationTest {
        source: "\u{213E}",
        nfc: "\u{213E}",
        nfd: "\u{213E}",
        nfkc: "\u{0393}",
        nfkd: "\u{0393}",
    },
    NormalizationTest {
        source: "\u{213F}",
        nfc: "\u{213F}",
        nfd: "\u{213F}",
        nfkc: "\u{03A0}",
        nfkd: "\u{03A0}",
    },
    NormalizationTest {
        source: "\u{2140}",
        nfc: "\u{2140}",
        nfd: "\u{2140}",
        nfkc: "\u{2211}",
        nfkd: "\u{2211}",
    },
    NormalizationTest {
        source: "\u{2145}",
        nfc: "\u{2145}",
        nfd: "\u{2145}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{2146}",
        nfc: "\u{2146}",
        nfd: "\u{2146}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{2147}",
        nfc: "\u{2147}",
        nfd: "\u{2147}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{2148}",
        nfc: "\u{2148}",
        nfd: "\u{2148}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{2149}",
        nfc: "\u{2149}",
        nfd: "\u{2149}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{2150}",
        nfc: "\u{2150}",
        nfd: "\u{2150}",
        nfkc: "\u{0031}\u{2044}\u{0037}",
        nfkd: "\u{0031}\u{2044}\u{0037}",
    },
    NormalizationTest {
        source: "\u{2151}",
        nfc: "\u{2151}",
        nfd: "\u{2151}",
        nfkc: "\u{0031}\u{2044}\u{0039}",
        nfkd: "\u{0031}\u{2044}\u{0039}",
    },
    NormalizationTest {
        source: "\u{2152}",
        nfc: "\u{2152}",
        nfd: "\u{2152}",
        nfkc: "\u{0031}\u{2044}\u{0031}\u{0030}",
        nfkd: "\u{0031}\u{2044}\u{0031}\u{0030}",
    },
    NormalizationTest {
        source: "\u{2153}",
        nfc: "\u{2153}",
        nfd: "\u{2153}",
        nfkc: "\u{0031}\u{2044}\u{0033}",
        nfkd: "\u{0031}\u{2044}\u{0033}",
    },
    NormalizationTest {
        source: "\u{2154}",
        nfc: "\u{2154}",
        nfd: "\u{2154}",
        nfkc: "\u{0032}\u{2044}\u{0033}",
        nfkd: "\u{0032}\u{2044}\u{0033}",
    },
    NormalizationTest {
        source: "\u{2155}",
        nfc: "\u{2155}",
        nfd: "\u{2155}",
        nfkc: "\u{0031}\u{2044}\u{0035}",
        nfkd: "\u{0031}\u{2044}\u{0035}",
    },
    NormalizationTest {
        source: "\u{2156}",
        nfc: "\u{2156}",
        nfd: "\u{2156}",
        nfkc: "\u{0032}\u{2044}\u{0035}",
        nfkd: "\u{0032}\u{2044}\u{0035}",
    },
    NormalizationTest {
        source: "\u{2157}",
        nfc: "\u{2157}",
        nfd: "\u{2157}",
        nfkc: "\u{0033}\u{2044}\u{0035}",
        nfkd: "\u{0033}\u{2044}\u{0035}",
    },
    NormalizationTest {
        source: "\u{2158}",
        nfc: "\u{2158}",
        nfd: "\u{2158}",
        nfkc: "\u{0034}\u{2044}\u{0035}",
        nfkd: "\u{0034}\u{2044}\u{0035}",
    },
    NormalizationTest {
        source: "\u{2159}",
        nfc: "\u{2159}",
        nfd: "\u{2159}",
        nfkc: "\u{0031}\u{2044}\u{0036}",
        nfkd: "\u{0031}\u{2044}\u{0036}",
    },
    NormalizationTest {
        source: "\u{215A}",
        nfc: "\u{215A}",
        nfd: "\u{215A}",
        nfkc: "\u{0035}\u{2044}\u{0036}",
        nfkd: "\u{0035}\u{2044}\u{0036}",
    },
    NormalizationTest {
        source: "\u{215B}",
        nfc: "\u{215B}",
        nfd: "\u{215B}",
        nfkc: "\u{0031}\u{2044}\u{0038}",
        nfkd: "\u{0031}\u{2044}\u{0038}",
    },
    NormalizationTest {
        source: "\u{215C}",
        nfc: "\u{215C}",
        nfd: "\u{215C}",
        nfkc: "\u{0033}\u{2044}\u{0038}",
        nfkd: "\u{0033}\u{2044}\u{0038}",
    },
    NormalizationTest {
        source: "\u{215D}",
        nfc: "\u{215D}",
        nfd: "\u{215D}",
        nfkc: "\u{0035}\u{2044}\u{0038}",
        nfkd: "\u{0035}\u{2044}\u{0038}",
    },
    NormalizationTest {
        source: "\u{215E}",
        nfc: "\u{215E}",
        nfd: "\u{215E}",
        nfkc: "\u{0037}\u{2044}\u{0038}",
        nfkd: "\u{0037}\u{2044}\u{0038}",
    },
    NormalizationTest {
        source: "\u{215F}",
        nfc: "\u{215F}",
        nfd: "\u{215F}",
        nfkc: "\u{0031}\u{2044}",
        nfkd: "\u{0031}\u{2044}",
    },
    NormalizationTest {
        source: "\u{2160}",
        nfc: "\u{2160}",
        nfd: "\u{2160}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{2161}",
        nfc: "\u{2161}",
        nfd: "\u{2161}",
        nfkc: "\u{0049}\u{0049}",
        nfkd: "\u{0049}\u{0049}",
    },
    NormalizationTest {
        source: "\u{2162}",
        nfc: "\u{2162}",
        nfd: "\u{2162}",
        nfkc: "\u{0049}\u{0049}\u{0049}",
        nfkd: "\u{0049}\u{0049}\u{0049}",
    },
    NormalizationTest {
        source: "\u{2163}",
        nfc: "\u{2163}",
        nfd: "\u{2163}",
        nfkc: "\u{0049}\u{0056}",
        nfkd: "\u{0049}\u{0056}",
    },
    NormalizationTest {
        source: "\u{2164}",
        nfc: "\u{2164}",
        nfd: "\u{2164}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{2165}",
        nfc: "\u{2165}",
        nfd: "\u{2165}",
        nfkc: "\u{0056}\u{0049}",
        nfkd: "\u{0056}\u{0049}",
    },
    NormalizationTest {
        source: "\u{2166}",
        nfc: "\u{2166}",
        nfd: "\u{2166}",
        nfkc: "\u{0056}\u{0049}\u{0049}",
        nfkd: "\u{0056}\u{0049}\u{0049}",
    },
    NormalizationTest {
        source: "\u{2167}",
        nfc: "\u{2167}",
        nfd: "\u{2167}",
        nfkc: "\u{0056}\u{0049}\u{0049}\u{0049}",
        nfkd: "\u{0056}\u{0049}\u{0049}\u{0049}",
    },
    NormalizationTest {
        source: "\u{2168}",
        nfc: "\u{2168}",
        nfd: "\u{2168}",
        nfkc: "\u{0049}\u{0058}",
        nfkd: "\u{0049}\u{0058}",
    },
    NormalizationTest {
        source: "\u{2169}",
        nfc: "\u{2169}",
        nfd: "\u{2169}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{216A}",
        nfc: "\u{216A}",
        nfd: "\u{216A}",
        nfkc: "\u{0058}\u{0049}",
        nfkd: "\u{0058}\u{0049}",
    },
    NormalizationTest {
        source: "\u{216B}",
        nfc: "\u{216B}",
        nfd: "\u{216B}",
        nfkc: "\u{0058}\u{0049}\u{0049}",
        nfkd: "\u{0058}\u{0049}\u{0049}",
    },
    NormalizationTest {
        source: "\u{216C}",
        nfc: "\u{216C}",
        nfd: "\u{216C}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{216D}",
        nfc: "\u{216D}",
        nfd: "\u{216D}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{216E}",
        nfc: "\u{216E}",
        nfd: "\u{216E}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{216F}",
        nfc: "\u{216F}",
        nfd: "\u{216F}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{2170}",
        nfc: "\u{2170}",
        nfd: "\u{2170}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{2171}",
        nfc: "\u{2171}",
        nfd: "\u{2171}",
        nfkc: "\u{0069}\u{0069}",
        nfkd: "\u{0069}\u{0069}",
    },
    NormalizationTest {
        source: "\u{2172}",
        nfc: "\u{2172}",
        nfd: "\u{2172}",
        nfkc: "\u{0069}\u{0069}\u{0069}",
        nfkd: "\u{0069}\u{0069}\u{0069}",
    },
    NormalizationTest {
        source: "\u{2173}",
        nfc: "\u{2173}",
        nfd: "\u{2173}",
        nfkc: "\u{0069}\u{0076}",
        nfkd: "\u{0069}\u{0076}",
    },
    NormalizationTest {
        source: "\u{2174}",
        nfc: "\u{2174}",
        nfd: "\u{2174}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{2175}",
        nfc: "\u{2175}",
        nfd: "\u{2175}",
        nfkc: "\u{0076}\u{0069}",
        nfkd: "\u{0076}\u{0069}",
    },
    NormalizationTest {
        source: "\u{2176}",
        nfc: "\u{2176}",
        nfd: "\u{2176}",
        nfkc: "\u{0076}\u{0069}\u{0069}",
        nfkd: "\u{0076}\u{0069}\u{0069}",
    },
    NormalizationTest {
        source: "\u{2177}",
        nfc: "\u{2177}",
        nfd: "\u{2177}",
        nfkc: "\u{0076}\u{0069}\u{0069}\u{0069}",
        nfkd: "\u{0076}\u{0069}\u{0069}\u{0069}",
    },
    NormalizationTest {
        source: "\u{2178}",
        nfc: "\u{2178}",
        nfd: "\u{2178}",
        nfkc: "\u{0069}\u{0078}",
        nfkd: "\u{0069}\u{0078}",
    },
    NormalizationTest {
        source: "\u{2179}",
        nfc: "\u{2179}",
        nfd: "\u{2179}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{217A}",
        nfc: "\u{217A}",
        nfd: "\u{217A}",
        nfkc: "\u{0078}\u{0069}",
        nfkd: "\u{0078}\u{0069}",
    },
    NormalizationTest {
        source: "\u{217B}",
        nfc: "\u{217B}",
        nfd: "\u{217B}",
        nfkc: "\u{0078}\u{0069}\u{0069}",
        nfkd: "\u{0078}\u{0069}\u{0069}",
    },
    NormalizationTest {
        source: "\u{217C}",
        nfc: "\u{217C}",
        nfd: "\u{217C}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{217D}",
        nfc: "\u{217D}",
        nfd: "\u{217D}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{217E}",
        nfc: "\u{217E}",
        nfd: "\u{217E}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{217F}",
        nfc: "\u{217F}",
        nfd: "\u{217F}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{2189}",
        nfc: "\u{2189}",
        nfd: "\u{2189}",
        nfkc: "\u{0030}\u{2044}\u{0033}",
        nfkd: "\u{0030}\u{2044}\u{0033}",
    },
    NormalizationTest {
        source: "\u{219A}",
        nfc: "\u{219A}",
        nfd: "\u{2190}\u{0338}",
        nfkc: "\u{219A}",
        nfkd: "\u{2190}\u{0338}",
    },
    NormalizationTest {
        source: "\u{219B}",
        nfc: "\u{219B}",
        nfd: "\u{2192}\u{0338}",
        nfkc: "\u{219B}",
        nfkd: "\u{2192}\u{0338}",
    },
    NormalizationTest {
        source: "\u{21AE}",
        nfc: "\u{21AE}",
        nfd: "\u{2194}\u{0338}",
        nfkc: "\u{21AE}",
        nfkd: "\u{2194}\u{0338}",
    },
    NormalizationTest {
        source: "\u{21CD}",
        nfc: "\u{21CD}",
        nfd: "\u{21D0}\u{0338}",
        nfkc: "\u{21CD}",
        nfkd: "\u{21D0}\u{0338}",
    },
    NormalizationTest {
        source: "\u{21CE}",
        nfc: "\u{21CE}",
        nfd: "\u{21D4}\u{0338}",
        nfkc: "\u{21CE}",
        nfkd: "\u{21D4}\u{0338}",
    },
    NormalizationTest {
        source: "\u{21CF}",
        nfc: "\u{21CF}",
        nfd: "\u{21D2}\u{0338}",
        nfkc: "\u{21CF}",
        nfkd: "\u{21D2}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2204}",
        nfc: "\u{2204}",
        nfd: "\u{2203}\u{0338}",
        nfkc: "\u{2204}",
        nfkd: "\u{2203}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2209}",
        nfc: "\u{2209}",
        nfd: "\u{2208}\u{0338}",
        nfkc: "\u{2209}",
        nfkd: "\u{2208}\u{0338}",
    },
    NormalizationTest {
        source: "\u{220C}",
        nfc: "\u{220C}",
        nfd: "\u{220B}\u{0338}",
        nfkc: "\u{220C}",
        nfkd: "\u{220B}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2224}",
        nfc: "\u{2224}",
        nfd: "\u{2223}\u{0338}",
        nfkc: "\u{2224}",
        nfkd: "\u{2223}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2226}",
        nfc: "\u{2226}",
        nfd: "\u{2225}\u{0338}",
        nfkc: "\u{2226}",
        nfkd: "\u{2225}\u{0338}",
    },
    NormalizationTest {
        source: "\u{222C}",
        nfc: "\u{222C}",
        nfd: "\u{222C}",
        nfkc: "\u{222B}\u{222B}",
        nfkd: "\u{222B}\u{222B}",
    },
    NormalizationTest {
        source: "\u{222D}",
        nfc: "\u{222D}",
        nfd: "\u{222D}",
        nfkc: "\u{222B}\u{222B}\u{222B}",
        nfkd: "\u{222B}\u{222B}\u{222B}",
    },
    NormalizationTest {
        source: "\u{222F}",
        nfc: "\u{222F}",
        nfd: "\u{222F}",
        nfkc: "\u{222E}\u{222E}",
        nfkd: "\u{222E}\u{222E}",
    },
    NormalizationTest {
        source: "\u{2230}",
        nfc: "\u{2230}",
        nfd: "\u{2230}",
        nfkc: "\u{222E}\u{222E}\u{222E}",
        nfkd: "\u{222E}\u{222E}\u{222E}",
    },
    NormalizationTest {
        source: "\u{2241}",
        nfc: "\u{2241}",
        nfd: "\u{223C}\u{0338}",
        nfkc: "\u{2241}",
        nfkd: "\u{223C}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2244}",
        nfc: "\u{2244}",
        nfd: "\u{2243}\u{0338}",
        nfkc: "\u{2244}",
        nfkd: "\u{2243}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2247}",
        nfc: "\u{2247}",
        nfd: "\u{2245}\u{0338}",
        nfkc: "\u{2247}",
        nfkd: "\u{2245}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2249}",
        nfc: "\u{2249}",
        nfd: "\u{2248}\u{0338}",
        nfkc: "\u{2249}",
        nfkd: "\u{2248}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2260}",
        nfc: "\u{2260}",
        nfd: "\u{003D}\u{0338}",
        nfkc: "\u{2260}",
        nfkd: "\u{003D}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2262}",
        nfc: "\u{2262}",
        nfd: "\u{2261}\u{0338}",
        nfkc: "\u{2262}",
        nfkd: "\u{2261}\u{0338}",
    },
    NormalizationTest {
        source: "\u{226D}",
        nfc: "\u{226D}",
        nfd: "\u{224D}\u{0338}",
        nfkc: "\u{226D}",
        nfkd: "\u{224D}\u{0338}",
    },
    NormalizationTest {
        source: "\u{226E}",
        nfc: "\u{226E}",
        nfd: "\u{003C}\u{0338}",
        nfkc: "\u{226E}",
        nfkd: "\u{003C}\u{0338}",
    },
    NormalizationTest {
        source: "\u{226F}",
        nfc: "\u{226F}",
        nfd: "\u{003E}\u{0338}",
        nfkc: "\u{226F}",
        nfkd: "\u{003E}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2270}",
        nfc: "\u{2270}",
        nfd: "\u{2264}\u{0338}",
        nfkc: "\u{2270}",
        nfkd: "\u{2264}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2271}",
        nfc: "\u{2271}",
        nfd: "\u{2265}\u{0338}",
        nfkc: "\u{2271}",
        nfkd: "\u{2265}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2274}",
        nfc: "\u{2274}",
        nfd: "\u{2272}\u{0338}",
        nfkc: "\u{2274}",
        nfkd: "\u{2272}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2275}",
        nfc: "\u{2275}",
        nfd: "\u{2273}\u{0338}",
        nfkc: "\u{2275}",
        nfkd: "\u{2273}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2278}",
        nfc: "\u{2278}",
        nfd: "\u{2276}\u{0338}",
        nfkc: "\u{2278}",
        nfkd: "\u{2276}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2279}",
        nfc: "\u{2279}",
        nfd: "\u{2277}\u{0338}",
        nfkc: "\u{2279}",
        nfkd: "\u{2277}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2280}",
        nfc: "\u{2280}",
        nfd: "\u{227A}\u{0338}",
        nfkc: "\u{2280}",
        nfkd: "\u{227A}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2281}",
        nfc: "\u{2281}",
        nfd: "\u{227B}\u{0338}",
        nfkc: "\u{2281}",
        nfkd: "\u{227B}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2284}",
        nfc: "\u{2284}",
        nfd: "\u{2282}\u{0338}",
        nfkc: "\u{2284}",
        nfkd: "\u{2282}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2285}",
        nfc: "\u{2285}",
        nfd: "\u{2283}\u{0338}",
        nfkc: "\u{2285}",
        nfkd: "\u{2283}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2288}",
        nfc: "\u{2288}",
        nfd: "\u{2286}\u{0338}",
        nfkc: "\u{2288}",
        nfkd: "\u{2286}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2289}",
        nfc: "\u{2289}",
        nfd: "\u{2287}\u{0338}",
        nfkc: "\u{2289}",
        nfkd: "\u{2287}\u{0338}",
    },
    NormalizationTest {
        source: "\u{22AC}",
        nfc: "\u{22AC}",
        nfd: "\u{22A2}\u{0338}",
        nfkc: "\u{22AC}",
        nfkd: "\u{22A2}\u{0338}",
    },
    NormalizationTest {
        source: "\u{22AD}",
        nfc: "\u{22AD}",
        nfd: "\u{22A8}\u{0338}",
        nfkc: "\u{22AD}",
        nfkd: "\u{22A8}\u{0338}",
    },
    NormalizationTest {
        source: "\u{22AE}",
        nfc: "\u{22AE}",
        nfd: "\u{22A9}\u{0338}",
        nfkc: "\u{22AE}",
        nfkd: "\u{22A9}\u{0338}",
    },
    NormalizationTest {
        source: "\u{22AF}",
        nfc: "\u{22AF}",
        nfd: "\u{22AB}\u{0338}",
        nfkc: "\u{22AF}",
        nfkd: "\u{22AB}\u{0338}",
    },
    NormalizationTest {
        source: "\u{22E0}",
        nfc: "\u{22E0}",
        nfd: "\u{227C}\u{0338}",
        nfkc: "\u{22E0}",
        nfkd: "\u{227C}\u{0338}",
    },
    NormalizationTest {
        source: "\u{22E1}",
        nfc: "\u{22E1}",
        nfd: "\u{227D}\u{0338}",
        nfkc: "\u{22E1}",
        nfkd: "\u{227D}\u{0338}",
    },
    NormalizationTest {
        source: "\u{22E2}",
        nfc: "\u{22E2}",
        nfd: "\u{2291}\u{0338}",
        nfkc: "\u{22E2}",
        nfkd: "\u{2291}\u{0338}",
    },
    NormalizationTest {
        source: "\u{22E3}",
        nfc: "\u{22E3}",
        nfd: "\u{2292}\u{0338}",
        nfkc: "\u{22E3}",
        nfkd: "\u{2292}\u{0338}",
    },
    NormalizationTest {
        source: "\u{22EA}",
        nfc: "\u{22EA}",
        nfd: "\u{22B2}\u{0338}",
        nfkc: "\u{22EA}",
        nfkd: "\u{22B2}\u{0338}",
    },
    NormalizationTest {
        source: "\u{22EB}",
        nfc: "\u{22EB}",
        nfd: "\u{22B3}\u{0338}",
        nfkc: "\u{22EB}",
        nfkd: "\u{22B3}\u{0338}",
    },
    NormalizationTest {
        source: "\u{22EC}",
        nfc: "\u{22EC}",
        nfd: "\u{22B4}\u{0338}",
        nfkc: "\u{22EC}",
        nfkd: "\u{22B4}\u{0338}",
    },
    NormalizationTest {
        source: "\u{22ED}",
        nfc: "\u{22ED}",
        nfd: "\u{22B5}\u{0338}",
        nfkc: "\u{22ED}",
        nfkd: "\u{22B5}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2329}",
        nfc: "\u{3008}",
        nfd: "\u{3008}",
        nfkc: "\u{3008}",
        nfkd: "\u{3008}",
    },
    NormalizationTest {
        source: "\u{232A}",
        nfc: "\u{3009}",
        nfd: "\u{3009}",
        nfkc: "\u{3009}",
        nfkd: "\u{3009}",
    },
    NormalizationTest {
        source: "\u{2460}",
        nfc: "\u{2460}",
        nfd: "\u{2460}",
        nfkc: "\u{0031}",
        nfkd: "\u{0031}",
    },
    NormalizationTest {
        source: "\u{2461}",
        nfc: "\u{2461}",
        nfd: "\u{2461}",
        nfkc: "\u{0032}",
        nfkd: "\u{0032}",
    },
    NormalizationTest {
        source: "\u{2462}",
        nfc: "\u{2462}",
        nfd: "\u{2462}",
        nfkc: "\u{0033}",
        nfkd: "\u{0033}",
    },
    NormalizationTest {
        source: "\u{2463}",
        nfc: "\u{2463}",
        nfd: "\u{2463}",
        nfkc: "\u{0034}",
        nfkd: "\u{0034}",
    },
    NormalizationTest {
        source: "\u{2464}",
        nfc: "\u{2464}",
        nfd: "\u{2464}",
        nfkc: "\u{0035}",
        nfkd: "\u{0035}",
    },
    NormalizationTest {
        source: "\u{2465}",
        nfc: "\u{2465}",
        nfd: "\u{2465}",
        nfkc: "\u{0036}",
        nfkd: "\u{0036}",
    },
    NormalizationTest {
        source: "\u{2466}",
        nfc: "\u{2466}",
        nfd: "\u{2466}",
        nfkc: "\u{0037}",
        nfkd: "\u{0037}",
    },
    NormalizationTest {
        source: "\u{2467}",
        nfc: "\u{2467}",
        nfd: "\u{2467}",
        nfkc: "\u{0038}",
        nfkd: "\u{0038}",
    },
    NormalizationTest {
        source: "\u{2468}",
        nfc: "\u{2468}",
        nfd: "\u{2468}",
        nfkc: "\u{0039}",
        nfkd: "\u{0039}",
    },
    NormalizationTest {
        source: "\u{2469}",
        nfc: "\u{2469}",
        nfd: "\u{2469}",
        nfkc: "\u{0031}\u{0030}",
        nfkd: "\u{0031}\u{0030}",
    },
    NormalizationTest {
        source: "\u{246A}",
        nfc: "\u{246A}",
        nfd: "\u{246A}",
        nfkc: "\u{0031}\u{0031}",
        nfkd: "\u{0031}\u{0031}",
    },
    NormalizationTest {
        source: "\u{246B}",
        nfc: "\u{246B}",
        nfd: "\u{246B}",
        nfkc: "\u{0031}\u{0032}",
        nfkd: "\u{0031}\u{0032}",
    },
    NormalizationTest {
        source: "\u{246C}",
        nfc: "\u{246C}",
        nfd: "\u{246C}",
        nfkc: "\u{0031}\u{0033}",
        nfkd: "\u{0031}\u{0033}",
    },
    NormalizationTest {
        source: "\u{246D}",
        nfc: "\u{246D}",
        nfd: "\u{246D}",
        nfkc: "\u{0031}\u{0034}",
        nfkd: "\u{0031}\u{0034}",
    },
    NormalizationTest {
        source: "\u{246E}",
        nfc: "\u{246E}",
        nfd: "\u{246E}",
        nfkc: "\u{0031}\u{0035}",
        nfkd: "\u{0031}\u{0035}",
    },
    NormalizationTest {
        source: "\u{246F}",
        nfc: "\u{246F}",
        nfd: "\u{246F}",
        nfkc: "\u{0031}\u{0036}",
        nfkd: "\u{0031}\u{0036}",
    },
    NormalizationTest {
        source: "\u{2470}",
        nfc: "\u{2470}",
        nfd: "\u{2470}",
        nfkc: "\u{0031}\u{0037}",
        nfkd: "\u{0031}\u{0037}",
    },
    NormalizationTest {
        source: "\u{2471}",
        nfc: "\u{2471}",
        nfd: "\u{2471}",
        nfkc: "\u{0031}\u{0038}",
        nfkd: "\u{0031}\u{0038}",
    },
    NormalizationTest {
        source: "\u{2472}",
        nfc: "\u{2472}",
        nfd: "\u{2472}",
        nfkc: "\u{0031}\u{0039}",
        nfkd: "\u{0031}\u{0039}",
    },
    NormalizationTest {
        source: "\u{2473}",
        nfc: "\u{2473}",
        nfd: "\u{2473}",
        nfkc: "\u{0032}\u{0030}",
        nfkd: "\u{0032}\u{0030}",
    },
    NormalizationTest {
        source: "\u{2474}",
        nfc: "\u{2474}",
        nfd: "\u{2474}",
        nfkc: "\u{0028}\u{0031}\u{0029}",
        nfkd: "\u{0028}\u{0031}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2475}",
        nfc: "\u{2475}",
        nfd: "\u{2475}",
        nfkc: "\u{0028}\u{0032}\u{0029}",
        nfkd: "\u{0028}\u{0032}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2476}",
        nfc: "\u{2476}",
        nfd: "\u{2476}",
        nfkc: "\u{0028}\u{0033}\u{0029}",
        nfkd: "\u{0028}\u{0033}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2477}",
        nfc: "\u{2477}",
        nfd: "\u{2477}",
        nfkc: "\u{0028}\u{0034}\u{0029}",
        nfkd: "\u{0028}\u{0034}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2478}",
        nfc: "\u{2478}",
        nfd: "\u{2478}",
        nfkc: "\u{0028}\u{0035}\u{0029}",
        nfkd: "\u{0028}\u{0035}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2479}",
        nfc: "\u{2479}",
        nfd: "\u{2479}",
        nfkc: "\u{0028}\u{0036}\u{0029}",
        nfkd: "\u{0028}\u{0036}\u{0029}",
    },
    NormalizationTest {
        source: "\u{247A}",
        nfc: "\u{247A}",
        nfd: "\u{247A}",
        nfkc: "\u{0028}\u{0037}\u{0029}",
        nfkd: "\u{0028}\u{0037}\u{0029}",
    },
    NormalizationTest {
        source: "\u{247B}",
        nfc: "\u{247B}",
        nfd: "\u{247B}",
        nfkc: "\u{0028}\u{0038}\u{0029}",
        nfkd: "\u{0028}\u{0038}\u{0029}",
    },
    NormalizationTest {
        source: "\u{247C}",
        nfc: "\u{247C}",
        nfd: "\u{247C}",
        nfkc: "\u{0028}\u{0039}\u{0029}",
        nfkd: "\u{0028}\u{0039}\u{0029}",
    },
    NormalizationTest {
        source: "\u{247D}",
        nfc: "\u{247D}",
        nfd: "\u{247D}",
        nfkc: "\u{0028}\u{0031}\u{0030}\u{0029}",
        nfkd: "\u{0028}\u{0031}\u{0030}\u{0029}",
    },
    NormalizationTest {
        source: "\u{247E}",
        nfc: "\u{247E}",
        nfd: "\u{247E}",
        nfkc: "\u{0028}\u{0031}\u{0031}\u{0029}",
        nfkd: "\u{0028}\u{0031}\u{0031}\u{0029}",
    },
    NormalizationTest {
        source: "\u{247F}",
        nfc: "\u{247F}",
        nfd: "\u{247F}",
        nfkc: "\u{0028}\u{0031}\u{0032}\u{0029}",
        nfkd: "\u{0028}\u{0031}\u{0032}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2480}",
        nfc: "\u{2480}",
        nfd: "\u{2480}",
        nfkc: "\u{0028}\u{0031}\u{0033}\u{0029}",
        nfkd: "\u{0028}\u{0031}\u{0033}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2481}",
        nfc: "\u{2481}",
        nfd: "\u{2481}",
        nfkc: "\u{0028}\u{0031}\u{0034}\u{0029}",
        nfkd: "\u{0028}\u{0031}\u{0034}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2482}",
        nfc: "\u{2482}",
        nfd: "\u{2482}",
        nfkc: "\u{0028}\u{0031}\u{0035}\u{0029}",
        nfkd: "\u{0028}\u{0031}\u{0035}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2483}",
        nfc: "\u{2483}",
        nfd: "\u{2483}",
        nfkc: "\u{0028}\u{0031}\u{0036}\u{0029}",
        nfkd: "\u{0028}\u{0031}\u{0036}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2484}",
        nfc: "\u{2484}",
        nfd: "\u{2484}",
        nfkc: "\u{0028}\u{0031}\u{0037}\u{0029}",
        nfkd: "\u{0028}\u{0031}\u{0037}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2485}",
        nfc: "\u{2485}",
        nfd: "\u{2485}",
        nfkc: "\u{0028}\u{0031}\u{0038}\u{0029}",
        nfkd: "\u{0028}\u{0031}\u{0038}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2486}",
        nfc: "\u{2486}",
        nfd: "\u{2486}",
        nfkc: "\u{0028}\u{0031}\u{0039}\u{0029}",
        nfkd: "\u{0028}\u{0031}\u{0039}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2487}",
        nfc: "\u{2487}",
        nfd: "\u{2487}",
        nfkc: "\u{0028}\u{0032}\u{0030}\u{0029}",
        nfkd: "\u{0028}\u{0032}\u{0030}\u{0029}",
    },
    NormalizationTest {
        source: "\u{2488}",
        nfc: "\u{2488}",
        nfd: "\u{2488}",
        nfkc: "\u{0031}\u{002E}",
        nfkd: "\u{0031}\u{002E}",
    },
    NormalizationTest {
        source: "\u{2489}",
        nfc: "\u{2489}",
        nfd: "\u{2489}",
        nfkc: "\u{0032}\u{002E}",
        nfkd: "\u{0032}\u{002E}",
    },
    NormalizationTest {
        source: "\u{248A}",
        nfc: "\u{248A}",
        nfd: "\u{248A}",
        nfkc: "\u{0033}\u{002E}",
        nfkd: "\u{0033}\u{002E}",
    },
    NormalizationTest {
        source: "\u{248B}",
        nfc: "\u{248B}",
        nfd: "\u{248B}",
        nfkc: "\u{0034}\u{002E}",
        nfkd: "\u{0034}\u{002E}",
    },
    NormalizationTest {
        source: "\u{248C}",
        nfc: "\u{248C}",
        nfd: "\u{248C}",
        nfkc: "\u{0035}\u{002E}",
        nfkd: "\u{0035}\u{002E}",
    },
    NormalizationTest {
        source: "\u{248D}",
        nfc: "\u{248D}",
        nfd: "\u{248D}",
        nfkc: "\u{0036}\u{002E}",
        nfkd: "\u{0036}\u{002E}",
    },
    NormalizationTest {
        source: "\u{248E}",
        nfc: "\u{248E}",
        nfd: "\u{248E}",
        nfkc: "\u{0037}\u{002E}",
        nfkd: "\u{0037}\u{002E}",
    },
    NormalizationTest {
        source: "\u{248F}",
        nfc: "\u{248F}",
        nfd: "\u{248F}",
        nfkc: "\u{0038}\u{002E}",
        nfkd: "\u{0038}\u{002E}",
    },
    NormalizationTest {
        source: "\u{2490}",
        nfc: "\u{2490}",
        nfd: "\u{2490}",
        nfkc: "\u{0039}\u{002E}",
        nfkd: "\u{0039}\u{002E}",
    },
    NormalizationTest {
        source: "\u{2491}",
        nfc: "\u{2491}",
        nfd: "\u{2491}",
        nfkc: "\u{0031}\u{0030}\u{002E}",
        nfkd: "\u{0031}\u{0030}\u{002E}",
    },
    NormalizationTest {
        source: "\u{2492}",
        nfc: "\u{2492}",
        nfd: "\u{2492}",
        nfkc: "\u{0031}\u{0031}\u{002E}",
        nfkd: "\u{0031}\u{0031}\u{002E}",
    },
    NormalizationTest {
        source: "\u{2493}",
        nfc: "\u{2493}",
        nfd: "\u{2493}",
        nfkc: "\u{0031}\u{0032}\u{002E}",
        nfkd: "\u{0031}\u{0032}\u{002E}",
    },
    NormalizationTest {
        source: "\u{2494}",
        nfc: "\u{2494}",
        nfd: "\u{2494}",
        nfkc: "\u{0031}\u{0033}\u{002E}",
        nfkd: "\u{0031}\u{0033}\u{002E}",
    },
    NormalizationTest {
        source: "\u{2495}",
        nfc: "\u{2495}",
        nfd: "\u{2495}",
        nfkc: "\u{0031}\u{0034}\u{002E}",
        nfkd: "\u{0031}\u{0034}\u{002E}",
    },
    NormalizationTest {
        source: "\u{2496}",
        nfc: "\u{2496}",
        nfd: "\u{2496}",
        nfkc: "\u{0031}\u{0035}\u{002E}",
        nfkd: "\u{0031}\u{0035}\u{002E}",
    },
    NormalizationTest {
        source: "\u{2497}",
        nfc: "\u{2497}",
        nfd: "\u{2497}",
        nfkc: "\u{0031}\u{0036}\u{002E}",
        nfkd: "\u{0031}\u{0036}\u{002E}",
    },
    NormalizationTest {
        source: "\u{2498}",
        nfc: "\u{2498}",
        nfd: "\u{2498}",
        nfkc: "\u{0031}\u{0037}\u{002E}",
        nfkd: "\u{0031}\u{0037}\u{002E}",
    },
    NormalizationTest {
        source: "\u{2499}",
        nfc: "\u{2499}",
        nfd: "\u{2499}",
        nfkc: "\u{0031}\u{0038}\u{002E}",
        nfkd: "\u{0031}\u{0038}\u{002E}",
    },
    NormalizationTest {
        source: "\u{249A}",
        nfc: "\u{249A}",
        nfd: "\u{249A}",
        nfkc: "\u{0031}\u{0039}\u{002E}",
        nfkd: "\u{0031}\u{0039}\u{002E}",
    },
    NormalizationTest {
        source: "\u{249B}",
        nfc: "\u{249B}",
        nfd: "\u{249B}",
        nfkc: "\u{0032}\u{0030}\u{002E}",
        nfkd: "\u{0032}\u{0030}\u{002E}",
    },
    NormalizationTest {
        source: "\u{249C}",
        nfc: "\u{249C}",
        nfd: "\u{249C}",
        nfkc: "\u{0028}\u{0061}\u{0029}",
        nfkd: "\u{0028}\u{0061}\u{0029}",
    },
    NormalizationTest {
        source: "\u{249D}",
        nfc: "\u{249D}",
        nfd: "\u{249D}",
        nfkc: "\u{0028}\u{0062}\u{0029}",
        nfkd: "\u{0028}\u{0062}\u{0029}",
    },
    NormalizationTest {
        source: "\u{249E}",
        nfc: "\u{249E}",
        nfd: "\u{249E}",
        nfkc: "\u{0028}\u{0063}\u{0029}",
        nfkd: "\u{0028}\u{0063}\u{0029}",
    },
    NormalizationTest {
        source: "\u{249F}",
        nfc: "\u{249F}",
        nfd: "\u{249F}",
        nfkc: "\u{0028}\u{0064}\u{0029}",
        nfkd: "\u{0028}\u{0064}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24A0}",
        nfc: "\u{24A0}",
        nfd: "\u{24A0}",
        nfkc: "\u{0028}\u{0065}\u{0029}",
        nfkd: "\u{0028}\u{0065}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24A1}",
        nfc: "\u{24A1}",
        nfd: "\u{24A1}",
        nfkc: "\u{0028}\u{0066}\u{0029}",
        nfkd: "\u{0028}\u{0066}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24A2}",
        nfc: "\u{24A2}",
        nfd: "\u{24A2}",
        nfkc: "\u{0028}\u{0067}\u{0029}",
        nfkd: "\u{0028}\u{0067}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24A3}",
        nfc: "\u{24A3}",
        nfd: "\u{24A3}",
        nfkc: "\u{0028}\u{0068}\u{0029}",
        nfkd: "\u{0028}\u{0068}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24A4}",
        nfc: "\u{24A4}",
        nfd: "\u{24A4}",
        nfkc: "\u{0028}\u{0069}\u{0029}",
        nfkd: "\u{0028}\u{0069}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24A5}",
        nfc: "\u{24A5}",
        nfd: "\u{24A5}",
        nfkc: "\u{0028}\u{006A}\u{0029}",
        nfkd: "\u{0028}\u{006A}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24A6}",
        nfc: "\u{24A6}",
        nfd: "\u{24A6}",
        nfkc: "\u{0028}\u{006B}\u{0029}",
        nfkd: "\u{0028}\u{006B}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24A7}",
        nfc: "\u{24A7}",
        nfd: "\u{24A7}",
        nfkc: "\u{0028}\u{006C}\u{0029}",
        nfkd: "\u{0028}\u{006C}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24A8}",
        nfc: "\u{24A8}",
        nfd: "\u{24A8}",
        nfkc: "\u{0028}\u{006D}\u{0029}",
        nfkd: "\u{0028}\u{006D}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24A9}",
        nfc: "\u{24A9}",
        nfd: "\u{24A9}",
        nfkc: "\u{0028}\u{006E}\u{0029}",
        nfkd: "\u{0028}\u{006E}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24AA}",
        nfc: "\u{24AA}",
        nfd: "\u{24AA}",
        nfkc: "\u{0028}\u{006F}\u{0029}",
        nfkd: "\u{0028}\u{006F}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24AB}",
        nfc: "\u{24AB}",
        nfd: "\u{24AB}",
        nfkc: "\u{0028}\u{0070}\u{0029}",
        nfkd: "\u{0028}\u{0070}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24AC}",
        nfc: "\u{24AC}",
        nfd: "\u{24AC}",
        nfkc: "\u{0028}\u{0071}\u{0029}",
        nfkd: "\u{0028}\u{0071}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24AD}",
        nfc: "\u{24AD}",
        nfd: "\u{24AD}",
        nfkc: "\u{0028}\u{0072}\u{0029}",
        nfkd: "\u{0028}\u{0072}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24AE}",
        nfc: "\u{24AE}",
        nfd: "\u{24AE}",
        nfkc: "\u{0028}\u{0073}\u{0029}",
        nfkd: "\u{0028}\u{0073}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24AF}",
        nfc: "\u{24AF}",
        nfd: "\u{24AF}",
        nfkc: "\u{0028}\u{0074}\u{0029}",
        nfkd: "\u{0028}\u{0074}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24B0}",
        nfc: "\u{24B0}",
        nfd: "\u{24B0}",
        nfkc: "\u{0028}\u{0075}\u{0029}",
        nfkd: "\u{0028}\u{0075}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24B1}",
        nfc: "\u{24B1}",
        nfd: "\u{24B1}",
        nfkc: "\u{0028}\u{0076}\u{0029}",
        nfkd: "\u{0028}\u{0076}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24B2}",
        nfc: "\u{24B2}",
        nfd: "\u{24B2}",
        nfkc: "\u{0028}\u{0077}\u{0029}",
        nfkd: "\u{0028}\u{0077}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24B3}",
        nfc: "\u{24B3}",
        nfd: "\u{24B3}",
        nfkc: "\u{0028}\u{0078}\u{0029}",
        nfkd: "\u{0028}\u{0078}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24B4}",
        nfc: "\u{24B4}",
        nfd: "\u{24B4}",
        nfkc: "\u{0028}\u{0079}\u{0029}",
        nfkd: "\u{0028}\u{0079}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24B5}",
        nfc: "\u{24B5}",
        nfd: "\u{24B5}",
        nfkc: "\u{0028}\u{007A}\u{0029}",
        nfkd: "\u{0028}\u{007A}\u{0029}",
    },
    NormalizationTest {
        source: "\u{24B6}",
        nfc: "\u{24B6}",
        nfd: "\u{24B6}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{24B7}",
        nfc: "\u{24B7}",
        nfd: "\u{24B7}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{24B8}",
        nfc: "\u{24B8}",
        nfd: "\u{24B8}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{24B9}",
        nfc: "\u{24B9}",
        nfd: "\u{24B9}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{24BA}",
        nfc: "\u{24BA}",
        nfd: "\u{24BA}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{24BB}",
        nfc: "\u{24BB}",
        nfd: "\u{24BB}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{24BC}",
        nfc: "\u{24BC}",
        nfd: "\u{24BC}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{24BD}",
        nfc: "\u{24BD}",
        nfd: "\u{24BD}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{24BE}",
        nfc: "\u{24BE}",
        nfd: "\u{24BE}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{24BF}",
        nfc: "\u{24BF}",
        nfd: "\u{24BF}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{24C0}",
        nfc: "\u{24C0}",
        nfd: "\u{24C0}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{24C1}",
        nfc: "\u{24C1}",
        nfd: "\u{24C1}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{24C2}",
        nfc: "\u{24C2}",
        nfd: "\u{24C2}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{24C3}",
        nfc: "\u{24C3}",
        nfd: "\u{24C3}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{24C4}",
        nfc: "\u{24C4}",
        nfd: "\u{24C4}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{24C5}",
        nfc: "\u{24C5}",
        nfd: "\u{24C5}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{24C6}",
        nfc: "\u{24C6}",
        nfd: "\u{24C6}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{24C7}",
        nfc: "\u{24C7}",
        nfd: "\u{24C7}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{24C8}",
        nfc: "\u{24C8}",
        nfd: "\u{24C8}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{24C9}",
        nfc: "\u{24C9}",
        nfd: "\u{24C9}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{24CA}",
        nfc: "\u{24CA}",
        nfd: "\u{24CA}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{24CB}",
        nfc: "\u{24CB}",
        nfd: "\u{24CB}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{24CC}",
        nfc: "\u{24CC}",
        nfd: "\u{24CC}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{24CD}",
        nfc: "\u{24CD}",
        nfd: "\u{24CD}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{24CE}",
        nfc: "\u{24CE}",
        nfd: "\u{24CE}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{24CF}",
        nfc: "\u{24CF}",
        nfd: "\u{24CF}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{24D0}",
        nfc: "\u{24D0}",
        nfd: "\u{24D0}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{24D1}",
        nfc: "\u{24D1}",
        nfd: "\u{24D1}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{24D2}",
        nfc: "\u{24D2}",
        nfd: "\u{24D2}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{24D3}",
        nfc: "\u{24D3}",
        nfd: "\u{24D3}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{24D4}",
        nfc: "\u{24D4}",
        nfd: "\u{24D4}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{24D5}",
        nfc: "\u{24D5}",
        nfd: "\u{24D5}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{24D6}",
        nfc: "\u{24D6}",
        nfd: "\u{24D6}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{24D7}",
        nfc: "\u{24D7}",
        nfd: "\u{24D7}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{24D8}",
        nfc: "\u{24D8}",
        nfd: "\u{24D8}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{24D9}",
        nfc: "\u{24D9}",
        nfd: "\u{24D9}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{24DA}",
        nfc: "\u{24DA}",
        nfd: "\u{24DA}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{24DB}",
        nfc: "\u{24DB}",
        nfd: "\u{24DB}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{24DC}",
        nfc: "\u{24DC}",
        nfd: "\u{24DC}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{24DD}",
        nfc: "\u{24DD}",
        nfd: "\u{24DD}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{24DE}",
        nfc: "\u{24DE}",
        nfd: "\u{24DE}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{24DF}",
        nfc: "\u{24DF}",
        nfd: "\u{24DF}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{24E0}",
        nfc: "\u{24E0}",
        nfd: "\u{24E0}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{24E1}",
        nfc: "\u{24E1}",
        nfd: "\u{24E1}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{24E2}",
        nfc: "\u{24E2}",
        nfd: "\u{24E2}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{24E3}",
        nfc: "\u{24E3}",
        nfd: "\u{24E3}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{24E4}",
        nfc: "\u{24E4}",
        nfd: "\u{24E4}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{24E5}",
        nfc: "\u{24E5}",
        nfd: "\u{24E5}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{24E6}",
        nfc: "\u{24E6}",
        nfd: "\u{24E6}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{24E7}",
        nfc: "\u{24E7}",
        nfd: "\u{24E7}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{24E8}",
        nfc: "\u{24E8}",
        nfd: "\u{24E8}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{24E9}",
        nfc: "\u{24E9}",
        nfd: "\u{24E9}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{24EA}",
        nfc: "\u{24EA}",
        nfd: "\u{24EA}",
        nfkc: "\u{0030}",
        nfkd: "\u{0030}",
    },
    NormalizationTest {
        source: "\u{2A0C}",
        nfc: "\u{2A0C}",
        nfd: "\u{2A0C}",
        nfkc: "\u{222B}\u{222B}\u{222B}\u{222B}",
        nfkd: "\u{222B}\u{222B}\u{222B}\u{222B}",
    },
    NormalizationTest {
        source: "\u{2A74}",
        nfc: "\u{2A74}",
        nfd: "\u{2A74}",
        nfkc: "\u{003A}\u{003A}\u{003D}",
        nfkd: "\u{003A}\u{003A}\u{003D}",
    },
    NormalizationTest {
        source: "\u{2A75}",
        nfc: "\u{2A75}",
        nfd: "\u{2A75}",
        nfkc: "\u{003D}\u{003D}",
        nfkd: "\u{003D}\u{003D}",
    },
    NormalizationTest {
        source: "\u{2A76}",
        nfc: "\u{2A76}",
        nfd: "\u{2A76}",
        nfkc: "\u{003D}\u{003D}\u{003D}",
        nfkd: "\u{003D}\u{003D}\u{003D}",
    },
    NormalizationTest {
        source: "\u{2ADC}",
        nfc: "\u{2ADD}\u{0338}",
        nfd: "\u{2ADD}\u{0338}",
        nfkc: "\u{2ADD}\u{0338}",
        nfkd: "\u{2ADD}\u{0338}",
    },
    NormalizationTest {
        source: "\u{2C7C}",
        nfc: "\u{2C7C}",
        nfd: "\u{2C7C}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{2C7D}",
        nfc: "\u{2C7D}",
        nfd: "\u{2C7D}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{2D6F}",
        nfc: "\u{2D6F}",
        nfd: "\u{2D6F}",
        nfkc: "\u{2D61}",
        nfkd: "\u{2D61}",
    },
    NormalizationTest {
        source: "\u{2E9F}",
        nfc: "\u{2E9F}",
        nfd: "\u{2E9F}",
        nfkc: "\u{6BCD}",
        nfkd: "\u{6BCD}",
    },
    NormalizationTest {
        source: "\u{2EF3}",
        nfc: "\u{2EF3}",
        nfd: "\u{2EF3}",
        nfkc: "\u{9F9F}",
        nfkd: "\u{9F9F}",
    },
    NormalizationTest {
        source: "\u{2F00}",
        nfc: "\u{2F00}",
        nfd: "\u{2F00}",
        nfkc: "\u{4E00}",
        nfkd: "\u{4E00}",
    },
    NormalizationTest {
        source: "\u{2F01}",
        nfc: "\u{2F01}",
        nfd: "\u{2F01}",
        nfkc: "\u{4E28}",
        nfkd: "\u{4E28}",
    },
    NormalizationTest {
        source: "\u{2F02}",
        nfc: "\u{2F02}",
        nfd: "\u{2F02}",
        nfkc: "\u{4E36}",
        nfkd: "\u{4E36}",
    },
    NormalizationTest {
        source: "\u{2F03}",
        nfc: "\u{2F03}",
        nfd: "\u{2F03}",
        nfkc: "\u{4E3F}",
        nfkd: "\u{4E3F}",
    },
    NormalizationTest {
        source: "\u{2F04}",
        nfc: "\u{2F04}",
        nfd: "\u{2F04}",
        nfkc: "\u{4E59}",
        nfkd: "\u{4E59}",
    },
    NormalizationTest {
        source: "\u{2F05}",
        nfc: "\u{2F05}",
        nfd: "\u{2F05}",
        nfkc: "\u{4E85}",
        nfkd: "\u{4E85}",
    },
    NormalizationTest {
        source: "\u{2F06}",
        nfc: "\u{2F06}",
        nfd: "\u{2F06}",
        nfkc: "\u{4E8C}",
        nfkd: "\u{4E8C}",
    },
    NormalizationTest {
        source: "\u{2F07}",
        nfc: "\u{2F07}",
        nfd: "\u{2F07}",
        nfkc: "\u{4EA0}",
        nfkd: "\u{4EA0}",
    },
    NormalizationTest {
        source: "\u{2F08}",
        nfc: "\u{2F08}",
        nfd: "\u{2F08}",
        nfkc: "\u{4EBA}",
        nfkd: "\u{4EBA}",
    },
    NormalizationTest {
        source: "\u{2F09}",
        nfc: "\u{2F09}",
        nfd: "\u{2F09}",
        nfkc: "\u{513F}",
        nfkd: "\u{513F}",
    },
    NormalizationTest {
        source: "\u{2F0A}",
        nfc: "\u{2F0A}",
        nfd: "\u{2F0A}",
        nfkc: "\u{5165}",
        nfkd: "\u{5165}",
    },
    NormalizationTest {
        source: "\u{2F0B}",
        nfc: "\u{2F0B}",
        nfd: "\u{2F0B}",
        nfkc: "\u{516B}",
        nfkd: "\u{516B}",
    },
    NormalizationTest {
        source: "\u{2F0C}",
        nfc: "\u{2F0C}",
        nfd: "\u{2F0C}",
        nfkc: "\u{5182}",
        nfkd: "\u{5182}",
    },
    NormalizationTest {
        source: "\u{2F0D}",
        nfc: "\u{2F0D}",
        nfd: "\u{2F0D}",
        nfkc: "\u{5196}",
        nfkd: "\u{5196}",
    },
    NormalizationTest {
        source: "\u{2F0E}",
        nfc: "\u{2F0E}",
        nfd: "\u{2F0E}",
        nfkc: "\u{51AB}",
        nfkd: "\u{51AB}",
    },
    NormalizationTest {
        source: "\u{2F0F}",
        nfc: "\u{2F0F}",
        nfd: "\u{2F0F}",
        nfkc: "\u{51E0}",
        nfkd: "\u{51E0}",
    },
    NormalizationTest {
        source: "\u{2F10}",
        nfc: "\u{2F10}",
        nfd: "\u{2F10}",
        nfkc: "\u{51F5}",
        nfkd: "\u{51F5}",
    },
    NormalizationTest {
        source: "\u{2F11}",
        nfc: "\u{2F11}",
        nfd: "\u{2F11}",
        nfkc: "\u{5200}",
        nfkd: "\u{5200}",
    },
    NormalizationTest {
        source: "\u{2F12}",
        nfc: "\u{2F12}",
        nfd: "\u{2F12}",
        nfkc: "\u{529B}",
        nfkd: "\u{529B}",
    },
    NormalizationTest {
        source: "\u{2F13}",
        nfc: "\u{2F13}",
        nfd: "\u{2F13}",
        nfkc: "\u{52F9}",
        nfkd: "\u{52F9}",
    },
    NormalizationTest {
        source: "\u{2F14}",
        nfc: "\u{2F14}",
        nfd: "\u{2F14}",
        nfkc: "\u{5315}",
        nfkd: "\u{5315}",
    },
    NormalizationTest {
        source: "\u{2F15}",
        nfc: "\u{2F15}",
        nfd: "\u{2F15}",
        nfkc: "\u{531A}",
        nfkd: "\u{531A}",
    },
    NormalizationTest {
        source: "\u{2F16}",
        nfc: "\u{2F16}",
        nfd: "\u{2F16}",
        nfkc: "\u{5338}",
        nfkd: "\u{5338}",
    },
    NormalizationTest {
        source: "\u{2F17}",
        nfc: "\u{2F17}",
        nfd: "\u{2F17}",
        nfkc: "\u{5341}",
        nfkd: "\u{5341}",
    },
    NormalizationTest {
        source: "\u{2F18}",
        nfc: "\u{2F18}",
        nfd: "\u{2F18}",
        nfkc: "\u{535C}",
        nfkd: "\u{535C}",
    },
    NormalizationTest {
        source: "\u{2F19}",
        nfc: "\u{2F19}",
        nfd: "\u{2F19}",
        nfkc: "\u{5369}",
        nfkd: "\u{5369}",
    },
    NormalizationTest {
        source: "\u{2F1A}",
        nfc: "\u{2F1A}",
        nfd: "\u{2F1A}",
        nfkc: "\u{5382}",
        nfkd: "\u{5382}",
    },
    NormalizationTest {
        source: "\u{2F1B}",
        nfc: "\u{2F1B}",
        nfd: "\u{2F1B}",
        nfkc: "\u{53B6}",
        nfkd: "\u{53B6}",
    },
    NormalizationTest {
        source: "\u{2F1C}",
        nfc: "\u{2F1C}",
        nfd: "\u{2F1C}",
        nfkc: "\u{53C8}",
        nfkd: "\u{53C8}",
    },
    NormalizationTest {
        source: "\u{2F1D}",
        nfc: "\u{2F1D}",
        nfd: "\u{2F1D}",
        nfkc: "\u{53E3}",
        nfkd: "\u{53E3}",
    },
    NormalizationTest {
        source: "\u{2F1E}",
        nfc: "\u{2F1E}",
        nfd: "\u{2F1E}",
        nfkc: "\u{56D7}",
        nfkd: "\u{56D7}",
    },
    NormalizationTest {
        source: "\u{2F1F}",
        nfc: "\u{2F1F}",
        nfd: "\u{2F1F}",
        nfkc: "\u{571F}",
        nfkd: "\u{571F}",
    },
    NormalizationTest {
        source: "\u{2F20}",
        nfc: "\u{2F20}",
        nfd: "\u{2F20}",
        nfkc: "\u{58EB}",
        nfkd: "\u{58EB}",
    },
    NormalizationTest {
        source: "\u{2F21}",
        nfc: "\u{2F21}",
        nfd: "\u{2F21}",
        nfkc: "\u{5902}",
        nfkd: "\u{5902}",
    },
    NormalizationTest {
        source: "\u{2F22}",
        nfc: "\u{2F22}",
        nfd: "\u{2F22}",
        nfkc: "\u{590A}",
        nfkd: "\u{590A}",
    },
    NormalizationTest {
        source: "\u{2F23}",
        nfc: "\u{2F23}",
        nfd: "\u{2F23}",
        nfkc: "\u{5915}",
        nfkd: "\u{5915}",
    },
    NormalizationTest {
        source: "\u{2F24}",
        nfc: "\u{2F24}",
        nfd: "\u{2F24}",
        nfkc: "\u{5927}",
        nfkd: "\u{5927}",
    },
    NormalizationTest {
        source: "\u{2F25}",
        nfc: "\u{2F25}",
        nfd: "\u{2F25}",
        nfkc: "\u{5973}",
        nfkd: "\u{5973}",
    },
    NormalizationTest {
        source: "\u{2F26}",
        nfc: "\u{2F26}",
        nfd: "\u{2F26}",
        nfkc: "\u{5B50}",
        nfkd: "\u{5B50}",
    },
    NormalizationTest {
        source: "\u{2F27}",
        nfc: "\u{2F27}",
        nfd: "\u{2F27}",
        nfkc: "\u{5B80}",
        nfkd: "\u{5B80}",
    },
    NormalizationTest {
        source: "\u{2F28}",
        nfc: "\u{2F28}",
        nfd: "\u{2F28}",
        nfkc: "\u{5BF8}",
        nfkd: "\u{5BF8}",
    },
    NormalizationTest {
        source: "\u{2F29}",
        nfc: "\u{2F29}",
        nfd: "\u{2F29}",
        nfkc: "\u{5C0F}",
        nfkd: "\u{5C0F}",
    },
    NormalizationTest {
        source: "\u{2F2A}",
        nfc: "\u{2F2A}",
        nfd: "\u{2F2A}",
        nfkc: "\u{5C22}",
        nfkd: "\u{5C22}",
    },
    NormalizationTest {
        source: "\u{2F2B}",
        nfc: "\u{2F2B}",
        nfd: "\u{2F2B}",
        nfkc: "\u{5C38}",
        nfkd: "\u{5C38}",
    },
    NormalizationTest {
        source: "\u{2F2C}",
        nfc: "\u{2F2C}",
        nfd: "\u{2F2C}",
        nfkc: "\u{5C6E}",
        nfkd: "\u{5C6E}",
    },
    NormalizationTest {
        source: "\u{2F2D}",
        nfc: "\u{2F2D}",
        nfd: "\u{2F2D}",
        nfkc: "\u{5C71}",
        nfkd: "\u{5C71}",
    },
    NormalizationTest {
        source: "\u{2F2E}",
        nfc: "\u{2F2E}",
        nfd: "\u{2F2E}",
        nfkc: "\u{5DDB}",
        nfkd: "\u{5DDB}",
    },
    NormalizationTest {
        source: "\u{2F2F}",
        nfc: "\u{2F2F}",
        nfd: "\u{2F2F}",
        nfkc: "\u{5DE5}",
        nfkd: "\u{5DE5}",
    },
    NormalizationTest {
        source: "\u{2F30}",
        nfc: "\u{2F30}",
        nfd: "\u{2F30}",
        nfkc: "\u{5DF1}",
        nfkd: "\u{5DF1}",
    },
    NormalizationTest {
        source: "\u{2F31}",
        nfc: "\u{2F31}",
        nfd: "\u{2F31}",
        nfkc: "\u{5DFE}",
        nfkd: "\u{5DFE}",
    },
    NormalizationTest {
        source: "\u{2F32}",
        nfc: "\u{2F32}",
        nfd: "\u{2F32}",
        nfkc: "\u{5E72}",
        nfkd: "\u{5E72}",
    },
    NormalizationTest {
        source: "\u{2F33}",
        nfc: "\u{2F33}",
        nfd: "\u{2F33}",
        nfkc: "\u{5E7A}",
        nfkd: "\u{5E7A}",
    },
    NormalizationTest {
        source: "\u{2F34}",
        nfc: "\u{2F34}",
        nfd: "\u{2F34}",
        nfkc: "\u{5E7F}",
        nfkd: "\u{5E7F}",
    },
    NormalizationTest {
        source: "\u{2F35}",
        nfc: "\u{2F35}",
        nfd: "\u{2F35}",
        nfkc: "\u{5EF4}",
        nfkd: "\u{5EF4}",
    },
    NormalizationTest {
        source: "\u{2F36}",
        nfc: "\u{2F36}",
        nfd: "\u{2F36}",
        nfkc: "\u{5EFE}",
        nfkd: "\u{5EFE}",
    },
    NormalizationTest {
        source: "\u{2F37}",
        nfc: "\u{2F37}",
        nfd: "\u{2F37}",
        nfkc: "\u{5F0B}",
        nfkd: "\u{5F0B}",
    },
    NormalizationTest {
        source: "\u{2F38}",
        nfc: "\u{2F38}",
        nfd: "\u{2F38}",
        nfkc: "\u{5F13}",
        nfkd: "\u{5F13}",
    },
    NormalizationTest {
        source: "\u{2F39}",
        nfc: "\u{2F39}",
        nfd: "\u{2F39}",
        nfkc: "\u{5F50}",
        nfkd: "\u{5F50}",
    },
    NormalizationTest {
        source: "\u{2F3A}",
        nfc: "\u{2F3A}",
        nfd: "\u{2F3A}",
        nfkc: "\u{5F61}",
        nfkd: "\u{5F61}",
    },
    NormalizationTest {
        source: "\u{2F3B}",
        nfc: "\u{2F3B}",
        nfd: "\u{2F3B}",
        nfkc: "\u{5F73}",
        nfkd: "\u{5F73}",
    },
    NormalizationTest {
        source: "\u{2F3C}",
        nfc: "\u{2F3C}",
        nfd: "\u{2F3C}",
        nfkc: "\u{5FC3}",
        nfkd: "\u{5FC3}",
    },
    NormalizationTest {
        source: "\u{2F3D}",
        nfc: "\u{2F3D}",
        nfd: "\u{2F3D}",
        nfkc: "\u{6208}",
        nfkd: "\u{6208}",
    },
    NormalizationTest {
        source: "\u{2F3E}",
        nfc: "\u{2F3E}",
        nfd: "\u{2F3E}",
        nfkc: "\u{6236}",
        nfkd: "\u{6236}",
    },
    NormalizationTest {
        source: "\u{2F3F}",
        nfc: "\u{2F3F}",
        nfd: "\u{2F3F}",
        nfkc: "\u{624B}",
        nfkd: "\u{624B}",
    },
    NormalizationTest {
        source: "\u{2F40}",
        nfc: "\u{2F40}",
        nfd: "\u{2F40}",
        nfkc: "\u{652F}",
        nfkd: "\u{652F}",
    },
    NormalizationTest {
        source: "\u{2F41}",
        nfc: "\u{2F41}",
        nfd: "\u{2F41}",
        nfkc: "\u{6534}",
        nfkd: "\u{6534}",
    },
    NormalizationTest {
        source: "\u{2F42}",
        nfc: "\u{2F42}",
        nfd: "\u{2F42}",
        nfkc: "\u{6587}",
        nfkd: "\u{6587}",
    },
    NormalizationTest {
        source: "\u{2F43}",
        nfc: "\u{2F43}",
        nfd: "\u{2F43}",
        nfkc: "\u{6597}",
        nfkd: "\u{6597}",
    },
    NormalizationTest {
        source: "\u{2F44}",
        nfc: "\u{2F44}",
        nfd: "\u{2F44}",
        nfkc: "\u{65A4}",
        nfkd: "\u{65A4}",
    },
    NormalizationTest {
        source: "\u{2F45}",
        nfc: "\u{2F45}",
        nfd: "\u{2F45}",
        nfkc: "\u{65B9}",
        nfkd: "\u{65B9}",
    },
    NormalizationTest {
        source: "\u{2F46}",
        nfc: "\u{2F46}",
        nfd: "\u{2F46}",
        nfkc: "\u{65E0}",
        nfkd: "\u{65E0}",
    },
    NormalizationTest {
        source: "\u{2F47}",
        nfc: "\u{2F47}",
        nfd: "\u{2F47}",
        nfkc: "\u{65E5}",
        nfkd: "\u{65E5}",
    },
    NormalizationTest {
        source: "\u{2F48}",
        nfc: "\u{2F48}",
        nfd: "\u{2F48}",
        nfkc: "\u{66F0}",
        nfkd: "\u{66F0}",
    },
    NormalizationTest {
        source: "\u{2F49}",
        nfc: "\u{2F49}",
        nfd: "\u{2F49}",
        nfkc: "\u{6708}",
        nfkd: "\u{6708}",
    },
    NormalizationTest {
        source: "\u{2F4A}",
        nfc: "\u{2F4A}",
        nfd: "\u{2F4A}",
        nfkc: "\u{6728}",
        nfkd: "\u{6728}",
    },
    NormalizationTest {
        source: "\u{2F4B}",
        nfc: "\u{2F4B}",
        nfd: "\u{2F4B}",
        nfkc: "\u{6B20}",
        nfkd: "\u{6B20}",
    },
    NormalizationTest {
        source: "\u{2F4C}",
        nfc: "\u{2F4C}",
        nfd: "\u{2F4C}",
        nfkc: "\u{6B62}",
        nfkd: "\u{6B62}",
    },
    NormalizationTest {
        source: "\u{2F4D}",
        nfc: "\u{2F4D}",
        nfd: "\u{2F4D}",
        nfkc: "\u{6B79}",
        nfkd: "\u{6B79}",
    },
    NormalizationTest {
        source: "\u{2F4E}",
        nfc: "\u{2F4E}",
        nfd: "\u{2F4E}",
        nfkc: "\u{6BB3}",
        nfkd: "\u{6BB3}",
    },
    NormalizationTest {
        source: "\u{2F4F}",
        nfc: "\u{2F4F}",
        nfd: "\u{2F4F}",
        nfkc: "\u{6BCB}",
        nfkd: "\u{6BCB}",
    },
    NormalizationTest {
        source: "\u{2F50}",
        nfc: "\u{2F50}",
        nfd: "\u{2F50}",
        nfkc: "\u{6BD4}",
        nfkd: "\u{6BD4}",
    },
    NormalizationTest {
        source: "\u{2F51}",
        nfc: "\u{2F51}",
        nfd: "\u{2F51}",
        nfkc: "\u{6BDB}",
        nfkd: "\u{6BDB}",
    },
    NormalizationTest {
        source: "\u{2F52}",
        nfc: "\u{2F52}",
        nfd: "\u{2F52}",
        nfkc: "\u{6C0F}",
        nfkd: "\u{6C0F}",
    },
    NormalizationTest {
        source: "\u{2F53}",
        nfc: "\u{2F53}",
        nfd: "\u{2F53}",
        nfkc: "\u{6C14}",
        nfkd: "\u{6C14}",
    },
    NormalizationTest {
        source: "\u{2F54}",
        nfc: "\u{2F54}",
        nfd: "\u{2F54}",
        nfkc: "\u{6C34}",
        nfkd: "\u{6C34}",
    },
    NormalizationTest {
        source: "\u{2F55}",
        nfc: "\u{2F55}",
        nfd: "\u{2F55}",
        nfkc: "\u{706B}",
        nfkd: "\u{706B}",
    },
    NormalizationTest {
        source: "\u{2F56}",
        nfc: "\u{2F56}",
        nfd: "\u{2F56}",
        nfkc: "\u{722A}",
        nfkd: "\u{722A}",
    },
    NormalizationTest {
        source: "\u{2F57}",
        nfc: "\u{2F57}",
        nfd: "\u{2F57}",
        nfkc: "\u{7236}",
        nfkd: "\u{7236}",
    },
    NormalizationTest {
        source: "\u{2F58}",
        nfc: "\u{2F58}",
        nfd: "\u{2F58}",
        nfkc: "\u{723B}",
        nfkd: "\u{723B}",
    },
    NormalizationTest {
        source: "\u{2F59}",
        nfc: "\u{2F59}",
        nfd: "\u{2F59}",
        nfkc: "\u{723F}",
        nfkd: "\u{723F}",
    },
    NormalizationTest {
        source: "\u{2F5A}",
        nfc: "\u{2F5A}",
        nfd: "\u{2F5A}",
        nfkc: "\u{7247}",
        nfkd: "\u{7247}",
    },
    NormalizationTest {
        source: "\u{2F5B}",
        nfc: "\u{2F5B}",
        nfd: "\u{2F5B}",
        nfkc: "\u{7259}",
        nfkd: "\u{7259}",
    },
    NormalizationTest {
        source: "\u{2F5C}",
        nfc: "\u{2F5C}",
        nfd: "\u{2F5C}",
        nfkc: "\u{725B}",
        nfkd: "\u{725B}",
    },
    NormalizationTest {
        source: "\u{2F5D}",
        nfc: "\u{2F5D}",
        nfd: "\u{2F5D}",
        nfkc: "\u{72AC}",
        nfkd: "\u{72AC}",
    },
    NormalizationTest {
        source: "\u{2F5E}",
        nfc: "\u{2F5E}",
        nfd: "\u{2F5E}",
        nfkc: "\u{7384}",
        nfkd: "\u{7384}",
    },
    NormalizationTest {
        source: "\u{2F5F}",
        nfc: "\u{2F5F}",
        nfd: "\u{2F5F}",
        nfkc: "\u{7389}",
        nfkd: "\u{7389}",
    },
    NormalizationTest {
        source: "\u{2F60}",
        nfc: "\u{2F60}",
        nfd: "\u{2F60}",
        nfkc: "\u{74DC}",
        nfkd: "\u{74DC}",
    },
    NormalizationTest {
        source: "\u{2F61}",
        nfc: "\u{2F61}",
        nfd: "\u{2F61}",
        nfkc: "\u{74E6}",
        nfkd: "\u{74E6}",
    },
    NormalizationTest {
        source: "\u{2F62}",
        nfc: "\u{2F62}",
        nfd: "\u{2F62}",
        nfkc: "\u{7518}",
        nfkd: "\u{7518}",
    },
    NormalizationTest {
        source: "\u{2F63}",
        nfc: "\u{2F63}",
        nfd: "\u{2F63}",
        nfkc: "\u{751F}",
        nfkd: "\u{751F}",
    },
    NormalizationTest {
        source: "\u{2F64}",
        nfc: "\u{2F64}",
        nfd: "\u{2F64}",
        nfkc: "\u{7528}",
        nfkd: "\u{7528}",
    },
    NormalizationTest {
        source: "\u{2F65}",
        nfc: "\u{2F65}",
        nfd: "\u{2F65}",
        nfkc: "\u{7530}",
        nfkd: "\u{7530}",
    },
    NormalizationTest {
        source: "\u{2F66}",
        nfc: "\u{2F66}",
        nfd: "\u{2F66}",
        nfkc: "\u{758B}",
        nfkd: "\u{758B}",
    },
    NormalizationTest {
        source: "\u{2F67}",
        nfc: "\u{2F67}",
        nfd: "\u{2F67}",
        nfkc: "\u{7592}",
        nfkd: "\u{7592}",
    },
    NormalizationTest {
        source: "\u{2F68}",
        nfc: "\u{2F68}",
        nfd: "\u{2F68}",
        nfkc: "\u{7676}",
        nfkd: "\u{7676}",
    },
    NormalizationTest {
        source: "\u{2F69}",
        nfc: "\u{2F69}",
        nfd: "\u{2F69}",
        nfkc: "\u{767D}",
        nfkd: "\u{767D}",
    },
    NormalizationTest {
        source: "\u{2F6A}",
        nfc: "\u{2F6A}",
        nfd: "\u{2F6A}",
        nfkc: "\u{76AE}",
        nfkd: "\u{76AE}",
    },
    NormalizationTest {
        source: "\u{2F6B}",
        nfc: "\u{2F6B}",
        nfd: "\u{2F6B}",
        nfkc: "\u{76BF}",
        nfkd: "\u{76BF}",
    },
    NormalizationTest {
        source: "\u{2F6C}",
        nfc: "\u{2F6C}",
        nfd: "\u{2F6C}",
        nfkc: "\u{76EE}",
        nfkd: "\u{76EE}",
    },
    NormalizationTest {
        source: "\u{2F6D}",
        nfc: "\u{2F6D}",
        nfd: "\u{2F6D}",
        nfkc: "\u{77DB}",
        nfkd: "\u{77DB}",
    },
    NormalizationTest {
        source: "\u{2F6E}",
        nfc: "\u{2F6E}",
        nfd: "\u{2F6E}",
        nfkc: "\u{77E2}",
        nfkd: "\u{77E2}",
    },
    NormalizationTest {
        source: "\u{2F6F}",
        nfc: "\u{2F6F}",
        nfd: "\u{2F6F}",
        nfkc: "\u{77F3}",
        nfkd: "\u{77F3}",
    },
    NormalizationTest {
        source: "\u{2F70}",
        nfc: "\u{2F70}",
        nfd: "\u{2F70}",
        nfkc: "\u{793A}",
        nfkd: "\u{793A}",
    },
    NormalizationTest {
        source: "\u{2F71}",
        nfc: "\u{2F71}",
        nfd: "\u{2F71}",
        nfkc: "\u{79B8}",
        nfkd: "\u{79B8}",
    },
    NormalizationTest {
        source: "\u{2F72}",
        nfc: "\u{2F72}",
        nfd: "\u{2F72}",
        nfkc: "\u{79BE}",
        nfkd: "\u{79BE}",
    },
    NormalizationTest {
        source: "\u{2F73}",
        nfc: "\u{2F73}",
        nfd: "\u{2F73}",
        nfkc: "\u{7A74}",
        nfkd: "\u{7A74}",
    },
    NormalizationTest {
        source: "\u{2F74}",
        nfc: "\u{2F74}",
        nfd: "\u{2F74}",
        nfkc: "\u{7ACB}",
        nfkd: "\u{7ACB}",
    },
    NormalizationTest {
        source: "\u{2F75}",
        nfc: "\u{2F75}",
        nfd: "\u{2F75}",
        nfkc: "\u{7AF9}",
        nfkd: "\u{7AF9}",
    },
    NormalizationTest {
        source: "\u{2F76}",
        nfc: "\u{2F76}",
        nfd: "\u{2F76}",
        nfkc: "\u{7C73}",
        nfkd: "\u{7C73}",
    },
    NormalizationTest {
        source: "\u{2F77}",
        nfc: "\u{2F77}",
        nfd: "\u{2F77}",
        nfkc: "\u{7CF8}",
        nfkd: "\u{7CF8}",
    },
    NormalizationTest {
        source: "\u{2F78}",
        nfc: "\u{2F78}",
        nfd: "\u{2F78}",
        nfkc: "\u{7F36}",
        nfkd: "\u{7F36}",
    },
    NormalizationTest {
        source: "\u{2F79}",
        nfc: "\u{2F79}",
        nfd: "\u{2F79}",
        nfkc: "\u{7F51}",
        nfkd: "\u{7F51}",
    },
    NormalizationTest {
        source: "\u{2F7A}",
        nfc: "\u{2F7A}",
        nfd: "\u{2F7A}",
        nfkc: "\u{7F8A}",
        nfkd: "\u{7F8A}",
    },
    NormalizationTest {
        source: "\u{2F7B}",
        nfc: "\u{2F7B}",
        nfd: "\u{2F7B}",
        nfkc: "\u{7FBD}",
        nfkd: "\u{7FBD}",
    },
    NormalizationTest {
        source: "\u{2F7C}",
        nfc: "\u{2F7C}",
        nfd: "\u{2F7C}",
        nfkc: "\u{8001}",
        nfkd: "\u{8001}",
    },
    NormalizationTest {
        source: "\u{2F7D}",
        nfc: "\u{2F7D}",
        nfd: "\u{2F7D}",
        nfkc: "\u{800C}",
        nfkd: "\u{800C}",
    },
    NormalizationTest {
        source: "\u{2F7E}",
        nfc: "\u{2F7E}",
        nfd: "\u{2F7E}",
        nfkc: "\u{8012}",
        nfkd: "\u{8012}",
    },
    NormalizationTest {
        source: "\u{2F7F}",
        nfc: "\u{2F7F}",
        nfd: "\u{2F7F}",
        nfkc: "\u{8033}",
        nfkd: "\u{8033}",
    },
    NormalizationTest {
        source: "\u{2F80}",
        nfc: "\u{2F80}",
        nfd: "\u{2F80}",
        nfkc: "\u{807F}",
        nfkd: "\u{807F}",
    },
    NormalizationTest {
        source: "\u{2F81}",
        nfc: "\u{2F81}",
        nfd: "\u{2F81}",
        nfkc: "\u{8089}",
        nfkd: "\u{8089}",
    },
    NormalizationTest {
        source: "\u{2F82}",
        nfc: "\u{2F82}",
        nfd: "\u{2F82}",
        nfkc: "\u{81E3}",
        nfkd: "\u{81E3}",
    },
    NormalizationTest {
        source: "\u{2F83}",
        nfc: "\u{2F83}",
        nfd: "\u{2F83}",
        nfkc: "\u{81EA}",
        nfkd: "\u{81EA}",
    },
    NormalizationTest {
        source: "\u{2F84}",
        nfc: "\u{2F84}",
        nfd: "\u{2F84}",
        nfkc: "\u{81F3}",
        nfkd: "\u{81F3}",
    },
    NormalizationTest {
        source: "\u{2F85}",
        nfc: "\u{2F85}",
        nfd: "\u{2F85}",
        nfkc: "\u{81FC}",
        nfkd: "\u{81FC}",
    },
    NormalizationTest {
        source: "\u{2F86}",
        nfc: "\u{2F86}",
        nfd: "\u{2F86}",
        nfkc: "\u{820C}",
        nfkd: "\u{820C}",
    },
    NormalizationTest {
        source: "\u{2F87}",
        nfc: "\u{2F87}",
        nfd: "\u{2F87}",
        nfkc: "\u{821B}",
        nfkd: "\u{821B}",
    },
    NormalizationTest {
        source: "\u{2F88}",
        nfc: "\u{2F88}",
        nfd: "\u{2F88}",
        nfkc: "\u{821F}",
        nfkd: "\u{821F}",
    },
    NormalizationTest {
        source: "\u{2F89}",
        nfc: "\u{2F89}",
        nfd: "\u{2F89}",
        nfkc: "\u{826E}",
        nfkd: "\u{826E}",
    },
    NormalizationTest {
        source: "\u{2F8A}",
        nfc: "\u{2F8A}",
        nfd: "\u{2F8A}",
        nfkc: "\u{8272}",
        nfkd: "\u{8272}",
    },
    NormalizationTest {
        source: "\u{2F8B}",
        nfc: "\u{2F8B}",
        nfd: "\u{2F8B}",
        nfkc: "\u{8278}",
        nfkd: "\u{8278}",
    },
    NormalizationTest {
        source: "\u{2F8C}",
        nfc: "\u{2F8C}",
        nfd: "\u{2F8C}",
        nfkc: "\u{864D}",
        nfkd: "\u{864D}",
    },
    NormalizationTest {
        source: "\u{2F8D}",
        nfc: "\u{2F8D}",
        nfd: "\u{2F8D}",
        nfkc: "\u{866B}",
        nfkd: "\u{866B}",
    },
    NormalizationTest {
        source: "\u{2F8E}",
        nfc: "\u{2F8E}",
        nfd: "\u{2F8E}",
        nfkc: "\u{8840}",
        nfkd: "\u{8840}",
    },
    NormalizationTest {
        source: "\u{2F8F}",
        nfc: "\u{2F8F}",
        nfd: "\u{2F8F}",
        nfkc: "\u{884C}",
        nfkd: "\u{884C}",
    },
    NormalizationTest {
        source: "\u{2F90}",
        nfc: "\u{2F90}",
        nfd: "\u{2F90}",
        nfkc: "\u{8863}",
        nfkd: "\u{8863}",
    },
    NormalizationTest {
        source: "\u{2F91}",
        nfc: "\u{2F91}",
        nfd: "\u{2F91}",
        nfkc: "\u{897E}",
        nfkd: "\u{897E}",
    },
    NormalizationTest {
        source: "\u{2F92}",
        nfc: "\u{2F92}",
        nfd: "\u{2F92}",
        nfkc: "\u{898B}",
        nfkd: "\u{898B}",
    },
    NormalizationTest {
        source: "\u{2F93}",
        nfc: "\u{2F93}",
        nfd: "\u{2F93}",
        nfkc: "\u{89D2}",
        nfkd: "\u{89D2}",
    },
    NormalizationTest {
        source: "\u{2F94}",
        nfc: "\u{2F94}",
        nfd: "\u{2F94}",
        nfkc: "\u{8A00}",
        nfkd: "\u{8A00}",
    },
    NormalizationTest {
        source: "\u{2F95}",
        nfc: "\u{2F95}",
        nfd: "\u{2F95}",
        nfkc: "\u{8C37}",
        nfkd: "\u{8C37}",
    },
    NormalizationTest {
        source: "\u{2F96}",
        nfc: "\u{2F96}",
        nfd: "\u{2F96}",
        nfkc: "\u{8C46}",
        nfkd: "\u{8C46}",
    },
    NormalizationTest {
        source: "\u{2F97}",
        nfc: "\u{2F97}",
        nfd: "\u{2F97}",
        nfkc: "\u{8C55}",
        nfkd: "\u{8C55}",
    },
    NormalizationTest {
        source: "\u{2F98}",
        nfc: "\u{2F98}",
        nfd: "\u{2F98}",
        nfkc: "\u{8C78}",
        nfkd: "\u{8C78}",
    },
    NormalizationTest {
        source: "\u{2F99}",
        nfc: "\u{2F99}",
        nfd: "\u{2F99}",
        nfkc: "\u{8C9D}",
        nfkd: "\u{8C9D}",
    },
    NormalizationTest {
        source: "\u{2F9A}",
        nfc: "\u{2F9A}",
        nfd: "\u{2F9A}",
        nfkc: "\u{8D64}",
        nfkd: "\u{8D64}",
    },
    NormalizationTest {
        source: "\u{2F9B}",
        nfc: "\u{2F9B}",
        nfd: "\u{2F9B}",
        nfkc: "\u{8D70}",
        nfkd: "\u{8D70}",
    },
    NormalizationTest {
        source: "\u{2F9C}",
        nfc: "\u{2F9C}",
        nfd: "\u{2F9C}",
        nfkc: "\u{8DB3}",
        nfkd: "\u{8DB3}",
    },
    NormalizationTest {
        source: "\u{2F9D}",
        nfc: "\u{2F9D}",
        nfd: "\u{2F9D}",
        nfkc: "\u{8EAB}",
        nfkd: "\u{8EAB}",
    },
    NormalizationTest {
        source: "\u{2F9E}",
        nfc: "\u{2F9E}",
        nfd: "\u{2F9E}",
        nfkc: "\u{8ECA}",
        nfkd: "\u{8ECA}",
    },
    NormalizationTest {
        source: "\u{2F9F}",
        nfc: "\u{2F9F}",
        nfd: "\u{2F9F}",
        nfkc: "\u{8F9B}",
        nfkd: "\u{8F9B}",
    },
    NormalizationTest {
        source: "\u{2FA0}",
        nfc: "\u{2FA0}",
        nfd: "\u{2FA0}",
        nfkc: "\u{8FB0}",
        nfkd: "\u{8FB0}",
    },
    NormalizationTest {
        source: "\u{2FA1}",
        nfc: "\u{2FA1}",
        nfd: "\u{2FA1}",
        nfkc: "\u{8FB5}",
        nfkd: "\u{8FB5}",
    },
    NormalizationTest {
        source: "\u{2FA2}",
        nfc: "\u{2FA2}",
        nfd: "\u{2FA2}",
        nfkc: "\u{9091}",
        nfkd: "\u{9091}",
    },
    NormalizationTest {
        source: "\u{2FA3}",
        nfc: "\u{2FA3}",
        nfd: "\u{2FA3}",
        nfkc: "\u{9149}",
        nfkd: "\u{9149}",
    },
    NormalizationTest {
        source: "\u{2FA4}",
        nfc: "\u{2FA4}",
        nfd: "\u{2FA4}",
        nfkc: "\u{91C6}",
        nfkd: "\u{91C6}",
    },
    NormalizationTest {
        source: "\u{2FA5}",
        nfc: "\u{2FA5}",
        nfd: "\u{2FA5}",
        nfkc: "\u{91CC}",
        nfkd: "\u{91CC}",
    },
    NormalizationTest {
        source: "\u{2FA6}",
        nfc: "\u{2FA6}",
        nfd: "\u{2FA6}",
        nfkc: "\u{91D1}",
        nfkd: "\u{91D1}",
    },
    NormalizationTest {
        source: "\u{2FA7}",
        nfc: "\u{2FA7}",
        nfd: "\u{2FA7}",
        nfkc: "\u{9577}",
        nfkd: "\u{9577}",
    },
    NormalizationTest {
        source: "\u{2FA8}",
        nfc: "\u{2FA8}",
        nfd: "\u{2FA8}",
        nfkc: "\u{9580}",
        nfkd: "\u{9580}",
    },
    NormalizationTest {
        source: "\u{2FA9}",
        nfc: "\u{2FA9}",
        nfd: "\u{2FA9}",
        nfkc: "\u{961C}",
        nfkd: "\u{961C}",
    },
    NormalizationTest {
        source: "\u{2FAA}",
        nfc: "\u{2FAA}",
        nfd: "\u{2FAA}",
        nfkc: "\u{96B6}",
        nfkd: "\u{96B6}",
    },
    NormalizationTest {
        source: "\u{2FAB}",
        nfc: "\u{2FAB}",
        nfd: "\u{2FAB}",
        nfkc: "\u{96B9}",
        nfkd: "\u{96B9}",
    },
    NormalizationTest {
        source: "\u{2FAC}",
        nfc: "\u{2FAC}",
        nfd: "\u{2FAC}",
        nfkc: "\u{96E8}",
        nfkd: "\u{96E8}",
    },
    NormalizationTest {
        source: "\u{2FAD}",
        nfc: "\u{2FAD}",
        nfd: "\u{2FAD}",
        nfkc: "\u{9751}",
        nfkd: "\u{9751}",
    },
    NormalizationTest {
        source: "\u{2FAE}",
        nfc: "\u{2FAE}",
        nfd: "\u{2FAE}",
        nfkc: "\u{975E}",
        nfkd: "\u{975E}",
    },
    NormalizationTest {
        source: "\u{2FAF}",
        nfc: "\u{2FAF}",
        nfd: "\u{2FAF}",
        nfkc: "\u{9762}",
        nfkd: "\u{9762}",
    },
    NormalizationTest {
        source: "\u{2FB0}",
        nfc: "\u{2FB0}",
        nfd: "\u{2FB0}",
        nfkc: "\u{9769}",
        nfkd: "\u{9769}",
    },
    NormalizationTest {
        source: "\u{2FB1}",
        nfc: "\u{2FB1}",
        nfd: "\u{2FB1}",
        nfkc: "\u{97CB}",
        nfkd: "\u{97CB}",
    },
    NormalizationTest {
        source: "\u{2FB2}",
        nfc: "\u{2FB2}",
        nfd: "\u{2FB2}",
        nfkc: "\u{97ED}",
        nfkd: "\u{97ED}",
    },
    NormalizationTest {
        source: "\u{2FB3}",
        nfc: "\u{2FB3}",
        nfd: "\u{2FB3}",
        nfkc: "\u{97F3}",
        nfkd: "\u{97F3}",
    },
    NormalizationTest {
        source: "\u{2FB4}",
        nfc: "\u{2FB4}",
        nfd: "\u{2FB4}",
        nfkc: "\u{9801}",
        nfkd: "\u{9801}",
    },
    NormalizationTest {
        source: "\u{2FB5}",
        nfc: "\u{2FB5}",
        nfd: "\u{2FB5}",
        nfkc: "\u{98A8}",
        nfkd: "\u{98A8}",
    },
    NormalizationTest {
        source: "\u{2FB6}",
        nfc: "\u{2FB6}",
        nfd: "\u{2FB6}",
        nfkc: "\u{98DB}",
        nfkd: "\u{98DB}",
    },
    NormalizationTest {
        source: "\u{2FB7}",
        nfc: "\u{2FB7}",
        nfd: "\u{2FB7}",
        nfkc: "\u{98DF}",
        nfkd: "\u{98DF}",
    },
    NormalizationTest {
        source: "\u{2FB8}",
        nfc: "\u{2FB8}",
        nfd: "\u{2FB8}",
        nfkc: "\u{9996}",
        nfkd: "\u{9996}",
    },
    NormalizationTest {
        source: "\u{2FB9}",
        nfc: "\u{2FB9}",
        nfd: "\u{2FB9}",
        nfkc: "\u{9999}",
        nfkd: "\u{9999}",
    },
    NormalizationTest {
        source: "\u{2FBA}",
        nfc: "\u{2FBA}",
        nfd: "\u{2FBA}",
        nfkc: "\u{99AC}",
        nfkd: "\u{99AC}",
    },
    NormalizationTest {
        source: "\u{2FBB}",
        nfc: "\u{2FBB}",
        nfd: "\u{2FBB}",
        nfkc: "\u{9AA8}",
        nfkd: "\u{9AA8}",
    },
    NormalizationTest {
        source: "\u{2FBC}",
        nfc: "\u{2FBC}",
        nfd: "\u{2FBC}",
        nfkc: "\u{9AD8}",
        nfkd: "\u{9AD8}",
    },
    NormalizationTest {
        source: "\u{2FBD}",
        nfc: "\u{2FBD}",
        nfd: "\u{2FBD}",
        nfkc: "\u{9ADF}",
        nfkd: "\u{9ADF}",
    },
    NormalizationTest {
        source: "\u{2FBE}",
        nfc: "\u{2FBE}",
        nfd: "\u{2FBE}",
        nfkc: "\u{9B25}",
        nfkd: "\u{9B25}",
    },
    NormalizationTest {
        source: "\u{2FBF}",
        nfc: "\u{2FBF}",
        nfd: "\u{2FBF}",
        nfkc: "\u{9B2F}",
        nfkd: "\u{9B2F}",
    },
    NormalizationTest {
        source: "\u{2FC0}",
        nfc: "\u{2FC0}",
        nfd: "\u{2FC0}",
        nfkc: "\u{9B32}",
        nfkd: "\u{9B32}",
    },
    NormalizationTest {
        source: "\u{2FC1}",
        nfc: "\u{2FC1}",
        nfd: "\u{2FC1}",
        nfkc: "\u{9B3C}",
        nfkd: "\u{9B3C}",
    },
    NormalizationTest {
        source: "\u{2FC2}",
        nfc: "\u{2FC2}",
        nfd: "\u{2FC2}",
        nfkc: "\u{9B5A}",
        nfkd: "\u{9B5A}",
    },
    NormalizationTest {
        source: "\u{2FC3}",
        nfc: "\u{2FC3}",
        nfd: "\u{2FC3}",
        nfkc: "\u{9CE5}",
        nfkd: "\u{9CE5}",
    },
    NormalizationTest {
        source: "\u{2FC4}",
        nfc: "\u{2FC4}",
        nfd: "\u{2FC4}",
        nfkc: "\u{9E75}",
        nfkd: "\u{9E75}",
    },
    NormalizationTest {
        source: "\u{2FC5}",
        nfc: "\u{2FC5}",
        nfd: "\u{2FC5}",
        nfkc: "\u{9E7F}",
        nfkd: "\u{9E7F}",
    },
    NormalizationTest {
        source: "\u{2FC6}",
        nfc: "\u{2FC6}",
        nfd: "\u{2FC6}",
        nfkc: "\u{9EA5}",
        nfkd: "\u{9EA5}",
    },
    NormalizationTest {
        source: "\u{2FC7}",
        nfc: "\u{2FC7}",
        nfd: "\u{2FC7}",
        nfkc: "\u{9EBB}",
        nfkd: "\u{9EBB}",
    },
    NormalizationTest {
        source: "\u{2FC8}",
        nfc: "\u{2FC8}",
        nfd: "\u{2FC8}",
        nfkc: "\u{9EC3}",
        nfkd: "\u{9EC3}",
    },
    NormalizationTest {
        source: "\u{2FC9}",
        nfc: "\u{2FC9}",
        nfd: "\u{2FC9}",
        nfkc: "\u{9ECD}",
        nfkd: "\u{9ECD}",
    },
    NormalizationTest {
        source: "\u{2FCA}",
        nfc: "\u{2FCA}",
        nfd: "\u{2FCA}",
        nfkc: "\u{9ED1}",
        nfkd: "\u{9ED1}",
    },
    NormalizationTest {
        source: "\u{2FCB}",
        nfc: "\u{2FCB}",
        nfd: "\u{2FCB}",
        nfkc: "\u{9EF9}",
        nfkd: "\u{9EF9}",
    },
    NormalizationTest {
        source: "\u{2FCC}",
        nfc: "\u{2FCC}",
        nfd: "\u{2FCC}",
        nfkc: "\u{9EFD}",
        nfkd: "\u{9EFD}",
    },
    NormalizationTest {
        source: "\u{2FCD}",
        nfc: "\u{2FCD}",
        nfd: "\u{2FCD}",
        nfkc: "\u{9F0E}",
        nfkd: "\u{9F0E}",
    },
    NormalizationTest {
        source: "\u{2FCE}",
        nfc: "\u{2FCE}",
        nfd: "\u{2FCE}",
        nfkc: "\u{9F13}",
        nfkd: "\u{9F13}",
    },
    NormalizationTest {
        source: "\u{2FCF}",
        nfc: "\u{2FCF}",
        nfd: "\u{2FCF}",
        nfkc: "\u{9F20}",
        nfkd: "\u{9F20}",
    },
    NormalizationTest {
        source: "\u{2FD0}",
        nfc: "\u{2FD0}",
        nfd: "\u{2FD0}",
        nfkc: "\u{9F3B}",
        nfkd: "\u{9F3B}",
    },
    NormalizationTest {
        source: "\u{2FD1}",
        nfc: "\u{2FD1}",
        nfd: "\u{2FD1}",
        nfkc: "\u{9F4A}",
        nfkd: "\u{9F4A}",
    },
    NormalizationTest {
        source: "\u{2FD2}",
        nfc: "\u{2FD2}",
        nfd: "\u{2FD2}",
        nfkc: "\u{9F52}",
        nfkd: "\u{9F52}",
    },
    NormalizationTest {
        source: "\u{2FD3}",
        nfc: "\u{2FD3}",
        nfd: "\u{2FD3}",
        nfkc: "\u{9F8D}",
        nfkd: "\u{9F8D}",
    },
    NormalizationTest {
        source: "\u{2FD4}",
        nfc: "\u{2FD4}",
        nfd: "\u{2FD4}",
        nfkc: "\u{9F9C}",
        nfkd: "\u{9F9C}",
    },
    NormalizationTest {
        source: "\u{2FD5}",
        nfc: "\u{2FD5}",
        nfd: "\u{2FD5}",
        nfkc: "\u{9FA0}",
        nfkd: "\u{9FA0}",
    },
    NormalizationTest {
        source: "\u{3000}",
        nfc: "\u{3000}",
        nfd: "\u{3000}",
        nfkc: "\u{0020}",
        nfkd: "\u{0020}",
    },
    NormalizationTest {
        source: "\u{3036}",
        nfc: "\u{3036}",
        nfd: "\u{3036}",
        nfkc: "\u{3012}",
        nfkd: "\u{3012}",
    },
    NormalizationTest {
        source: "\u{3038}",
        nfc: "\u{3038}",
        nfd: "\u{3038}",
        nfkc: "\u{5341}",
        nfkd: "\u{5341}",
    },
    NormalizationTest {
        source: "\u{3039}",
        nfc: "\u{3039}",
        nfd: "\u{3039}",
        nfkc: "\u{5344}",
        nfkd: "\u{5344}",
    },
    NormalizationTest {
        source: "\u{303A}",
        nfc: "\u{303A}",
        nfd: "\u{303A}",
        nfkc: "\u{5345}",
        nfkd: "\u{5345}",
    },
    NormalizationTest {
        source: "\u{304C}",
        nfc: "\u{304C}",
        nfd: "\u{304B}\u{3099}",
        nfkc: "\u{304C}",
        nfkd: "\u{304B}\u{3099}",
    },
    NormalizationTest {
        source: "\u{304E}",
        nfc: "\u{304E}",
        nfd: "\u{304D}\u{3099}",
        nfkc: "\u{304E}",
        nfkd: "\u{304D}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3050}",
        nfc: "\u{3050}",
        nfd: "\u{304F}\u{3099}",
        nfkc: "\u{3050}",
        nfkd: "\u{304F}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3052}",
        nfc: "\u{3052}",
        nfd: "\u{3051}\u{3099}",
        nfkc: "\u{3052}",
        nfkd: "\u{3051}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3054}",
        nfc: "\u{3054}",
        nfd: "\u{3053}\u{3099}",
        nfkc: "\u{3054}",
        nfkd: "\u{3053}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3056}",
        nfc: "\u{3056}",
        nfd: "\u{3055}\u{3099}",
        nfkc: "\u{3056}",
        nfkd: "\u{3055}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3058}",
        nfc: "\u{3058}",
        nfd: "\u{3057}\u{3099}",
        nfkc: "\u{3058}",
        nfkd: "\u{3057}\u{3099}",
    },
    NormalizationTest {
        source: "\u{305A}",
        nfc: "\u{305A}",
        nfd: "\u{3059}\u{3099}",
        nfkc: "\u{305A}",
        nfkd: "\u{3059}\u{3099}",
    },
    NormalizationTest {
        source: "\u{305C}",
        nfc: "\u{305C}",
        nfd: "\u{305B}\u{3099}",
        nfkc: "\u{305C}",
        nfkd: "\u{305B}\u{3099}",
    },
    NormalizationTest {
        source: "\u{305E}",
        nfc: "\u{305E}",
        nfd: "\u{305D}\u{3099}",
        nfkc: "\u{305E}",
        nfkd: "\u{305D}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3060}",
        nfc: "\u{3060}",
        nfd: "\u{305F}\u{3099}",
        nfkc: "\u{3060}",
        nfkd: "\u{305F}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3062}",
        nfc: "\u{3062}",
        nfd: "\u{3061}\u{3099}",
        nfkc: "\u{3062}",
        nfkd: "\u{3061}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3065}",
        nfc: "\u{3065}",
        nfd: "\u{3064}\u{3099}",
        nfkc: "\u{3065}",
        nfkd: "\u{3064}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3067}",
        nfc: "\u{3067}",
        nfd: "\u{3066}\u{3099}",
        nfkc: "\u{3067}",
        nfkd: "\u{3066}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3069}",
        nfc: "\u{3069}",
        nfd: "\u{3068}\u{3099}",
        nfkc: "\u{3069}",
        nfkd: "\u{3068}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3070}",
        nfc: "\u{3070}",
        nfd: "\u{306F}\u{3099}",
        nfkc: "\u{3070}",
        nfkd: "\u{306F}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3071}",
        nfc: "\u{3071}",
        nfd: "\u{306F}\u{309A}",
        nfkc: "\u{3071}",
        nfkd: "\u{306F}\u{309A}",
    },
    NormalizationTest {
        source: "\u{3073}",
        nfc: "\u{3073}",
        nfd: "\u{3072}\u{3099}",
        nfkc: "\u{3073}",
        nfkd: "\u{3072}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3074}",
        nfc: "\u{3074}",
        nfd: "\u{3072}\u{309A}",
        nfkc: "\u{3074}",
        nfkd: "\u{3072}\u{309A}",
    },
    NormalizationTest {
        source: "\u{3076}",
        nfc: "\u{3076}",
        nfd: "\u{3075}\u{3099}",
        nfkc: "\u{3076}",
        nfkd: "\u{3075}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3077}",
        nfc: "\u{3077}",
        nfd: "\u{3075}\u{309A}",
        nfkc: "\u{3077}",
        nfkd: "\u{3075}\u{309A}",
    },
    NormalizationTest {
        source: "\u{3079}",
        nfc: "\u{3079}",
        nfd: "\u{3078}\u{3099}",
        nfkc: "\u{3079}",
        nfkd: "\u{3078}\u{3099}",
    },
    NormalizationTest {
        source: "\u{307A}",
        nfc: "\u{307A}",
        nfd: "\u{3078}\u{309A}",
        nfkc: "\u{307A}",
        nfkd: "\u{3078}\u{309A}",
    },
    NormalizationTest {
        source: "\u{307C}",
        nfc: "\u{307C}",
        nfd: "\u{307B}\u{3099}",
        nfkc: "\u{307C}",
        nfkd: "\u{307B}\u{3099}",
    },
    NormalizationTest {
        source: "\u{307D}",
        nfc: "\u{307D}",
        nfd: "\u{307B}\u{309A}",
        nfkc: "\u{307D}",
        nfkd: "\u{307B}\u{309A}",
    },
    NormalizationTest {
        source: "\u{3094}",
        nfc: "\u{3094}",
        nfd: "\u{3046}\u{3099}",
        nfkc: "\u{3094}",
        nfkd: "\u{3046}\u{3099}",
    },
    NormalizationTest {
        source: "\u{309B}",
        nfc: "\u{309B}",
        nfd: "\u{309B}",
        nfkc: "\u{0020}\u{3099}",
        nfkd: "\u{0020}\u{3099}",
    },
    NormalizationTest {
        source: "\u{309C}",
        nfc: "\u{309C}",
        nfd: "\u{309C}",
        nfkc: "\u{0020}\u{309A}",
        nfkd: "\u{0020}\u{309A}",
    },
    NormalizationTest {
        source: "\u{309E}",
        nfc: "\u{309E}",
        nfd: "\u{309D}\u{3099}",
        nfkc: "\u{309E}",
        nfkd: "\u{309D}\u{3099}",
    },
    NormalizationTest {
        source: "\u{309F}",
        nfc: "\u{309F}",
        nfd: "\u{309F}",
        nfkc: "\u{3088}\u{308A}",
        nfkd: "\u{3088}\u{308A}",
    },
    NormalizationTest {
        source: "\u{30AC}",
        nfc: "\u{30AC}",
        nfd: "\u{30AB}\u{3099}",
        nfkc: "\u{30AC}",
        nfkd: "\u{30AB}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30AE}",
        nfc: "\u{30AE}",
        nfd: "\u{30AD}\u{3099}",
        nfkc: "\u{30AE}",
        nfkd: "\u{30AD}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30B0}",
        nfc: "\u{30B0}",
        nfd: "\u{30AF}\u{3099}",
        nfkc: "\u{30B0}",
        nfkd: "\u{30AF}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30B2}",
        nfc: "\u{30B2}",
        nfd: "\u{30B1}\u{3099}",
        nfkc: "\u{30B2}",
        nfkd: "\u{30B1}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30B4}",
        nfc: "\u{30B4}",
        nfd: "\u{30B3}\u{3099}",
        nfkc: "\u{30B4}",
        nfkd: "\u{30B3}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30B6}",
        nfc: "\u{30B6}",
        nfd: "\u{30B5}\u{3099}",
        nfkc: "\u{30B6}",
        nfkd: "\u{30B5}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30B8}",
        nfc: "\u{30B8}",
        nfd: "\u{30B7}\u{3099}",
        nfkc: "\u{30B8}",
        nfkd: "\u{30B7}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30BA}",
        nfc: "\u{30BA}",
        nfd: "\u{30B9}\u{3099}",
        nfkc: "\u{30BA}",
        nfkd: "\u{30B9}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30BC}",
        nfc: "\u{30BC}",
        nfd: "\u{30BB}\u{3099}",
        nfkc: "\u{30BC}",
        nfkd: "\u{30BB}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30BE}",
        nfc: "\u{30BE}",
        nfd: "\u{30BD}\u{3099}",
        nfkc: "\u{30BE}",
        nfkd: "\u{30BD}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30C0}",
        nfc: "\u{30C0}",
        nfd: "\u{30BF}\u{3099}",
        nfkc: "\u{30C0}",
        nfkd: "\u{30BF}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30C2}",
        nfc: "\u{30C2}",
        nfd: "\u{30C1}\u{3099}",
        nfkc: "\u{30C2}",
        nfkd: "\u{30C1}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30C5}",
        nfc: "\u{30C5}",
        nfd: "\u{30C4}\u{3099}",
        nfkc: "\u{30C5}",
        nfkd: "\u{30C4}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30C7}",
        nfc: "\u{30C7}",
        nfd: "\u{30C6}\u{3099}",
        nfkc: "\u{30C7}",
        nfkd: "\u{30C6}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30C9}",
        nfc: "\u{30C9}",
        nfd: "\u{30C8}\u{3099}",
        nfkc: "\u{30C9}",
        nfkd: "\u{30C8}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30D0}",
        nfc: "\u{30D0}",
        nfd: "\u{30CF}\u{3099}",
        nfkc: "\u{30D0}",
        nfkd: "\u{30CF}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30D1}",
        nfc: "\u{30D1}",
        nfd: "\u{30CF}\u{309A}",
        nfkc: "\u{30D1}",
        nfkd: "\u{30CF}\u{309A}",
    },
    NormalizationTest {
        source: "\u{30D3}",
        nfc: "\u{30D3}",
        nfd: "\u{30D2}\u{3099}",
        nfkc: "\u{30D3}",
        nfkd: "\u{30D2}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30D4}",
        nfc: "\u{30D4}",
        nfd: "\u{30D2}\u{309A}",
        nfkc: "\u{30D4}",
        nfkd: "\u{30D2}\u{309A}",
    },
    NormalizationTest {
        source: "\u{30D6}",
        nfc: "\u{30D6}",
        nfd: "\u{30D5}\u{3099}",
        nfkc: "\u{30D6}",
        nfkd: "\u{30D5}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30D7}",
        nfc: "\u{30D7}",
        nfd: "\u{30D5}\u{309A}",
        nfkc: "\u{30D7}",
        nfkd: "\u{30D5}\u{309A}",
    },
    NormalizationTest {
        source: "\u{30D9}",
        nfc: "\u{30D9}",
        nfd: "\u{30D8}\u{3099}",
        nfkc: "\u{30D9}",
        nfkd: "\u{30D8}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30DA}",
        nfc: "\u{30DA}",
        nfd: "\u{30D8}\u{309A}",
        nfkc: "\u{30DA}",
        nfkd: "\u{30D8}\u{309A}",
    },
    NormalizationTest {
        source: "\u{30DC}",
        nfc: "\u{30DC}",
        nfd: "\u{30DB}\u{3099}",
        nfkc: "\u{30DC}",
        nfkd: "\u{30DB}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30DD}",
        nfc: "\u{30DD}",
        nfd: "\u{30DB}\u{309A}",
        nfkc: "\u{30DD}",
        nfkd: "\u{30DB}\u{309A}",
    },
    NormalizationTest {
        source: "\u{30F4}",
        nfc: "\u{30F4}",
        nfd: "\u{30A6}\u{3099}",
        nfkc: "\u{30F4}",
        nfkd: "\u{30A6}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30F7}",
        nfc: "\u{30F7}",
        nfd: "\u{30EF}\u{3099}",
        nfkc: "\u{30F7}",
        nfkd: "\u{30EF}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30F8}",
        nfc: "\u{30F8}",
        nfd: "\u{30F0}\u{3099}",
        nfkc: "\u{30F8}",
        nfkd: "\u{30F0}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30F9}",
        nfc: "\u{30F9}",
        nfd: "\u{30F1}\u{3099}",
        nfkc: "\u{30F9}",
        nfkd: "\u{30F1}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30FA}",
        nfc: "\u{30FA}",
        nfd: "\u{30F2}\u{3099}",
        nfkc: "\u{30FA}",
        nfkd: "\u{30F2}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30FE}",
        nfc: "\u{30FE}",
        nfd: "\u{30FD}\u{3099}",
        nfkc: "\u{30FE}",
        nfkd: "\u{30FD}\u{3099}",
    },
    NormalizationTest {
        source: "\u{30FF}",
        nfc: "\u{30FF}",
        nfd: "\u{30FF}",
        nfkc: "\u{30B3}\u{30C8}",
        nfkd: "\u{30B3}\u{30C8}",
    },
    NormalizationTest {
        source: "\u{3131}",
        nfc: "\u{3131}",
        nfd: "\u{3131}",
        nfkc: "\u{1100}",
        nfkd: "\u{1100}",
    },
    NormalizationTest {
        source: "\u{3132}",
        nfc: "\u{3132}",
        nfd: "\u{3132}",
        nfkc: "\u{1101}",
        nfkd: "\u{1101}",
    },
    NormalizationTest {
        source: "\u{3133}",
        nfc: "\u{3133}",
        nfd: "\u{3133}",
        nfkc: "\u{11AA}",
        nfkd: "\u{11AA}",
    },
    NormalizationTest {
        source: "\u{3134}",
        nfc: "\u{3134}",
        nfd: "\u{3134}",
        nfkc: "\u{1102}",
        nfkd: "\u{1102}",
    },
    NormalizationTest {
        source: "\u{3135}",
        nfc: "\u{3135}",
        nfd: "\u{3135}",
        nfkc: "\u{11AC}",
        nfkd: "\u{11AC}",
    },
    NormalizationTest {
        source: "\u{3136}",
        nfc: "\u{3136}",
        nfd: "\u{3136}",
        nfkc: "\u{11AD}",
        nfkd: "\u{11AD}",
    },
    NormalizationTest {
        source: "\u{3137}",
        nfc: "\u{3137}",
        nfd: "\u{3137}",
        nfkc: "\u{1103}",
        nfkd: "\u{1103}",
    },
    NormalizationTest {
        source: "\u{3138}",
        nfc: "\u{3138}",
        nfd: "\u{3138}",
        nfkc: "\u{1104}",
        nfkd: "\u{1104}",
    },
    NormalizationTest {
        source: "\u{3139}",
        nfc: "\u{3139}",
        nfd: "\u{3139}",
        nfkc: "\u{1105}",
        nfkd: "\u{1105}",
    },
    NormalizationTest {
        source: "\u{313A}",
        nfc: "\u{313A}",
        nfd: "\u{313A}",
        nfkc: "\u{11B0}",
        nfkd: "\u{11B0}",
    },
    NormalizationTest {
        source: "\u{313B}",
        nfc: "\u{313B}",
        nfd: "\u{313B}",
        nfkc: "\u{11B1}",
        nfkd: "\u{11B1}",
    },
    NormalizationTest {
        source: "\u{313C}",
        nfc: "\u{313C}",
        nfd: "\u{313C}",
        nfkc: "\u{11B2}",
        nfkd: "\u{11B2}",
    },
    NormalizationTest {
        source: "\u{313D}",
        nfc: "\u{313D}",
        nfd: "\u{313D}",
        nfkc: "\u{11B3}",
        nfkd: "\u{11B3}",
    },
    NormalizationTest {
        source: "\u{313E}",
        nfc: "\u{313E}",
        nfd: "\u{313E}",
        nfkc: "\u{11B4}",
        nfkd: "\u{11B4}",
    },
    NormalizationTest {
        source: "\u{313F}",
        nfc: "\u{313F}",
        nfd: "\u{313F}",
        nfkc: "\u{11B5}",
        nfkd: "\u{11B5}",
    },
    NormalizationTest {
        source: "\u{3140}",
        nfc: "\u{3140}",
        nfd: "\u{3140}",
        nfkc: "\u{111A}",
        nfkd: "\u{111A}",
    },
    NormalizationTest {
        source: "\u{3141}",
        nfc: "\u{3141}",
        nfd: "\u{3141}",
        nfkc: "\u{1106}",
        nfkd: "\u{1106}",
    },
    NormalizationTest {
        source: "\u{3142}",
        nfc: "\u{3142}",
        nfd: "\u{3142}",
        nfkc: "\u{1107}",
        nfkd: "\u{1107}",
    },
    NormalizationTest {
        source: "\u{3143}",
        nfc: "\u{3143}",
        nfd: "\u{3143}",
        nfkc: "\u{1108}",
        nfkd: "\u{1108}",
    },
    NormalizationTest {
        source: "\u{3144}",
        nfc: "\u{3144}",
        nfd: "\u{3144}",
        nfkc: "\u{1121}",
        nfkd: "\u{1121}",
    },
    NormalizationTest {
        source: "\u{3145}",
        nfc: "\u{3145}",
        nfd: "\u{3145}",
        nfkc: "\u{1109}",
        nfkd: "\u{1109}",
    },
    NormalizationTest {
        source: "\u{3146}",
        nfc: "\u{3146}",
        nfd: "\u{3146}",
        nfkc: "\u{110A}",
        nfkd: "\u{110A}",
    },
    NormalizationTest {
        source: "\u{3147}",
        nfc: "\u{3147}",
        nfd: "\u{3147}",
        nfkc: "\u{110B}",
        nfkd: "\u{110B}",
    },
    NormalizationTest {
        source: "\u{3148}",
        nfc: "\u{3148}",
        nfd: "\u{3148}",
        nfkc: "\u{110C}",
        nfkd: "\u{110C}",
    },
    NormalizationTest {
        source: "\u{3149}",
        nfc: "\u{3149}",
        nfd: "\u{3149}",
        nfkc: "\u{110D}",
        nfkd: "\u{110D}",
    },
    NormalizationTest {
        source: "\u{314A}",
        nfc: "\u{314A}",
        nfd: "\u{314A}",
        nfkc: "\u{110E}",
        nfkd: "\u{110E}",
    },
    NormalizationTest {
        source: "\u{314B}",
        nfc: "\u{314B}",
        nfd: "\u{314B}",
        nfkc: "\u{110F}",
        nfkd: "\u{110F}",
    },
    NormalizationTest {
        source: "\u{314C}",
        nfc: "\u{314C}",
        nfd: "\u{314C}",
        nfkc: "\u{1110}",
        nfkd: "\u{1110}",
    },
    NormalizationTest {
        source: "\u{314D}",
        nfc: "\u{314D}",
        nfd: "\u{314D}",
        nfkc: "\u{1111}",
        nfkd: "\u{1111}",
    },
    NormalizationTest {
        source: "\u{314E}",
        nfc: "\u{314E}",
        nfd: "\u{314E}",
        nfkc: "\u{1112}",
        nfkd: "\u{1112}",
    },
    NormalizationTest {
        source: "\u{314F}",
        nfc: "\u{314F}",
        nfd: "\u{314F}",
        nfkc: "\u{1161}",
        nfkd: "\u{1161}",
    },
    NormalizationTest {
        source: "\u{3150}",
        nfc: "\u{3150}",
        nfd: "\u{3150}",
        nfkc: "\u{1162}",
        nfkd: "\u{1162}",
    },
    NormalizationTest {
        source: "\u{3151}",
        nfc: "\u{3151}",
        nfd: "\u{3151}",
        nfkc: "\u{1163}",
        nfkd: "\u{1163}",
    },
    NormalizationTest {
        source: "\u{3152}",
        nfc: "\u{3152}",
        nfd: "\u{3152}",
        nfkc: "\u{1164}",
        nfkd: "\u{1164}",
    },
    NormalizationTest {
        source: "\u{3153}",
        nfc: "\u{3153}",
        nfd: "\u{3153}",
        nfkc: "\u{1165}",
        nfkd: "\u{1165}",
    },
    NormalizationTest {
        source: "\u{3154}",
        nfc: "\u{3154}",
        nfd: "\u{3154}",
        nfkc: "\u{1166}",
        nfkd: "\u{1166}",
    },
    NormalizationTest {
        source: "\u{3155}",
        nfc: "\u{3155}",
        nfd: "\u{3155}",
        nfkc: "\u{1167}",
        nfkd: "\u{1167}",
    },
    NormalizationTest {
        source: "\u{3156}",
        nfc: "\u{3156}",
        nfd: "\u{3156}",
        nfkc: "\u{1168}",
        nfkd: "\u{1168}",
    },
    NormalizationTest {
        source: "\u{3157}",
        nfc: "\u{3157}",
        nfd: "\u{3157}",
        nfkc: "\u{1169}",
        nfkd: "\u{1169}",
    },
    NormalizationTest {
        source: "\u{3158}",
        nfc: "\u{3158}",
        nfd: "\u{3158}",
        nfkc: "\u{116A}",
        nfkd: "\u{116A}",
    },
    NormalizationTest {
        source: "\u{3159}",
        nfc: "\u{3159}",
        nfd: "\u{3159}",
        nfkc: "\u{116B}",
        nfkd: "\u{116B}",
    },
    NormalizationTest {
        source: "\u{315A}",
        nfc: "\u{315A}",
        nfd: "\u{315A}",
        nfkc: "\u{116C}",
        nfkd: "\u{116C}",
    },
    NormalizationTest {
        source: "\u{315B}",
        nfc: "\u{315B}",
        nfd: "\u{315B}",
        nfkc: "\u{116D}",
        nfkd: "\u{116D}",
    },
    NormalizationTest {
        source: "\u{315C}",
        nfc: "\u{315C}",
        nfd: "\u{315C}",
        nfkc: "\u{116E}",
        nfkd: "\u{116E}",
    },
    NormalizationTest {
        source: "\u{315D}",
        nfc: "\u{315D}",
        nfd: "\u{315D}",
        nfkc: "\u{116F}",
        nfkd: "\u{116F}",
    },
    NormalizationTest {
        source: "\u{315E}",
        nfc: "\u{315E}",
        nfd: "\u{315E}",
        nfkc: "\u{1170}",
        nfkd: "\u{1170}",
    },
    NormalizationTest {
        source: "\u{315F}",
        nfc: "\u{315F}",
        nfd: "\u{315F}",
        nfkc: "\u{1171}",
        nfkd: "\u{1171}",
    },
    NormalizationTest {
        source: "\u{3160}",
        nfc: "\u{3160}",
        nfd: "\u{3160}",
        nfkc: "\u{1172}",
        nfkd: "\u{1172}",
    },
    NormalizationTest {
        source: "\u{3161}",
        nfc: "\u{3161}",
        nfd: "\u{3161}",
        nfkc: "\u{1173}",
        nfkd: "\u{1173}",
    },
    NormalizationTest {
        source: "\u{3162}",
        nfc: "\u{3162}",
        nfd: "\u{3162}",
        nfkc: "\u{1174}",
        nfkd: "\u{1174}",
    },
    NormalizationTest {
        source: "\u{3163}",
        nfc: "\u{3163}",
        nfd: "\u{3163}",
        nfkc: "\u{1175}",
        nfkd: "\u{1175}",
    },
    NormalizationTest {
        source: "\u{3164}",
        nfc: "\u{3164}",
        nfd: "\u{3164}",
        nfkc: "\u{1160}",
        nfkd: "\u{1160}",
    },
    NormalizationTest {
        source: "\u{3165}",
        nfc: "\u{3165}",
        nfd: "\u{3165}",
        nfkc: "\u{1114}",
        nfkd: "\u{1114}",
    },
    NormalizationTest {
        source: "\u{3166}",
        nfc: "\u{3166}",
        nfd: "\u{3166}",
        nfkc: "\u{1115}",
        nfkd: "\u{1115}",
    },
    NormalizationTest {
        source: "\u{3167}",
        nfc: "\u{3167}",
        nfd: "\u{3167}",
        nfkc: "\u{11C7}",
        nfkd: "\u{11C7}",
    },
    NormalizationTest {
        source: "\u{3168}",
        nfc: "\u{3168}",
        nfd: "\u{3168}",
        nfkc: "\u{11C8}",
        nfkd: "\u{11C8}",
    },
    NormalizationTest {
        source: "\u{3169}",
        nfc: "\u{3169}",
        nfd: "\u{3169}",
        nfkc: "\u{11CC}",
        nfkd: "\u{11CC}",
    },
    NormalizationTest {
        source: "\u{316A}",
        nfc: "\u{316A}",
        nfd: "\u{316A}",
        nfkc: "\u{11CE}",
        nfkd: "\u{11CE}",
    },
    NormalizationTest {
        source: "\u{316B}",
        nfc: "\u{316B}",
        nfd: "\u{316B}",
        nfkc: "\u{11D3}",
        nfkd: "\u{11D3}",
    },
    NormalizationTest {
        source: "\u{316C}",
        nfc: "\u{316C}",
        nfd: "\u{316C}",
        nfkc: "\u{11D7}",
        nfkd: "\u{11D7}",
    },
    NormalizationTest {
        source: "\u{316D}",
        nfc: "\u{316D}",
        nfd: "\u{316D}",
        nfkc: "\u{11D9}",
        nfkd: "\u{11D9}",
    },
    NormalizationTest {
        source: "\u{316E}",
        nfc: "\u{316E}",
        nfd: "\u{316E}",
        nfkc: "\u{111C}",
        nfkd: "\u{111C}",
    },
    NormalizationTest {
        source: "\u{316F}",
        nfc: "\u{316F}",
        nfd: "\u{316F}",
        nfkc: "\u{11DD}",
        nfkd: "\u{11DD}",
    },
    NormalizationTest {
        source: "\u{3170}",
        nfc: "\u{3170}",
        nfd: "\u{3170}",
        nfkc: "\u{11DF}",
        nfkd: "\u{11DF}",
    },
    NormalizationTest {
        source: "\u{3171}",
        nfc: "\u{3171}",
        nfd: "\u{3171}",
        nfkc: "\u{111D}",
        nfkd: "\u{111D}",
    },
    NormalizationTest {
        source: "\u{3172}",
        nfc: "\u{3172}",
        nfd: "\u{3172}",
        nfkc: "\u{111E}",
        nfkd: "\u{111E}",
    },
    NormalizationTest {
        source: "\u{3173}",
        nfc: "\u{3173}",
        nfd: "\u{3173}",
        nfkc: "\u{1120}",
        nfkd: "\u{1120}",
    },
    NormalizationTest {
        source: "\u{3174}",
        nfc: "\u{3174}",
        nfd: "\u{3174}",
        nfkc: "\u{1122}",
        nfkd: "\u{1122}",
    },
    NormalizationTest {
        source: "\u{3175}",
        nfc: "\u{3175}",
        nfd: "\u{3175}",
        nfkc: "\u{1123}",
        nfkd: "\u{1123}",
    },
    NormalizationTest {
        source: "\u{3176}",
        nfc: "\u{3176}",
        nfd: "\u{3176}",
        nfkc: "\u{1127}",
        nfkd: "\u{1127}",
    },
    NormalizationTest {
        source: "\u{3177}",
        nfc: "\u{3177}",
        nfd: "\u{3177}",
        nfkc: "\u{1129}",
        nfkd: "\u{1129}",
    },
    NormalizationTest {
        source: "\u{3178}",
        nfc: "\u{3178}",
        nfd: "\u{3178}",
        nfkc: "\u{112B}",
        nfkd: "\u{112B}",
    },
    NormalizationTest {
        source: "\u{3179}",
        nfc: "\u{3179}",
        nfd: "\u{3179}",
        nfkc: "\u{112C}",
        nfkd: "\u{112C}",
    },
    NormalizationTest {
        source: "\u{317A}",
        nfc: "\u{317A}",
        nfd: "\u{317A}",
        nfkc: "\u{112D}",
        nfkd: "\u{112D}",
    },
    NormalizationTest {
        source: "\u{317B}",
        nfc: "\u{317B}",
        nfd: "\u{317B}",
        nfkc: "\u{112E}",
        nfkd: "\u{112E}",
    },
    NormalizationTest {
        source: "\u{317C}",
        nfc: "\u{317C}",
        nfd: "\u{317C}",
        nfkc: "\u{112F}",
        nfkd: "\u{112F}",
    },
    NormalizationTest {
        source: "\u{317D}",
        nfc: "\u{317D}",
        nfd: "\u{317D}",
        nfkc: "\u{1132}",
        nfkd: "\u{1132}",
    },
    NormalizationTest {
        source: "\u{317E}",
        nfc: "\u{317E}",
        nfd: "\u{317E}",
        nfkc: "\u{1136}",
        nfkd: "\u{1136}",
    },
    NormalizationTest {
        source: "\u{317F}",
        nfc: "\u{317F}",
        nfd: "\u{317F}",
        nfkc: "\u{1140}",
        nfkd: "\u{1140}",
    },
    NormalizationTest {
        source: "\u{3180}",
        nfc: "\u{3180}",
        nfd: "\u{3180}",
        nfkc: "\u{1147}",
        nfkd: "\u{1147}",
    },
    NormalizationTest {
        source: "\u{3181}",
        nfc: "\u{3181}",
        nfd: "\u{3181}",
        nfkc: "\u{114C}",
        nfkd: "\u{114C}",
    },
    NormalizationTest {
        source: "\u{3182}",
        nfc: "\u{3182}",
        nfd: "\u{3182}",
        nfkc: "\u{11F1}",
        nfkd: "\u{11F1}",
    },
    NormalizationTest {
        source: "\u{3183}",
        nfc: "\u{3183}",
        nfd: "\u{3183}",
        nfkc: "\u{11F2}",
        nfkd: "\u{11F2}",
    },
    NormalizationTest {
        source: "\u{3184}",
        nfc: "\u{3184}",
        nfd: "\u{3184}",
        nfkc: "\u{1157}",
        nfkd: "\u{1157}",
    },
    NormalizationTest {
        source: "\u{3185}",
        nfc: "\u{3185}",
        nfd: "\u{3185}",
        nfkc: "\u{1158}",
        nfkd: "\u{1158}",
    },
    NormalizationTest {
        source: "\u{3186}",
        nfc: "\u{3186}",
        nfd: "\u{3186}",
        nfkc: "\u{1159}",
        nfkd: "\u{1159}",
    },
    NormalizationTest {
        source: "\u{3187}",
        nfc: "\u{3187}",
        nfd: "\u{3187}",
        nfkc: "\u{1184}",
        nfkd: "\u{1184}",
    },
    NormalizationTest {
        source: "\u{3188}",
        nfc: "\u{3188}",
        nfd: "\u{3188}",
        nfkc: "\u{1185}",
        nfkd: "\u{1185}",
    },
    NormalizationTest {
        source: "\u{3189}",
        nfc: "\u{3189}",
        nfd: "\u{3189}",
        nfkc: "\u{1188}",
        nfkd: "\u{1188}",
    },
    NormalizationTest {
        source: "\u{318A}",
        nfc: "\u{318A}",
        nfd: "\u{318A}",
        nfkc: "\u{1191}",
        nfkd: "\u{1191}",
    },
    NormalizationTest {
        source: "\u{318B}",
        nfc: "\u{318B}",
        nfd: "\u{318B}",
        nfkc: "\u{1192}",
        nfkd: "\u{1192}",
    },
    NormalizationTest {
        source: "\u{318C}",
        nfc: "\u{318C}",
        nfd: "\u{318C}",
        nfkc: "\u{1194}",
        nfkd: "\u{1194}",
    },
    NormalizationTest {
        source: "\u{318D}",
        nfc: "\u{318D}",
        nfd: "\u{318D}",
        nfkc: "\u{119E}",
        nfkd: "\u{119E}",
    },
    NormalizationTest {
        source: "\u{318E}",
        nfc: "\u{318E}",
        nfd: "\u{318E}",
        nfkc: "\u{11A1}",
        nfkd: "\u{11A1}",
    },
    NormalizationTest {
        source: "\u{3192}",
        nfc: "\u{3192}",
        nfd: "\u{3192}",
        nfkc: "\u{4E00}",
        nfkd: "\u{4E00}",
    },
    NormalizationTest {
        source: "\u{3193}",
        nfc: "\u{3193}",
        nfd: "\u{3193}",
        nfkc: "\u{4E8C}",
        nfkd: "\u{4E8C}",
    },
    NormalizationTest {
        source: "\u{3194}",
        nfc: "\u{3194}",
        nfd: "\u{3194}",
        nfkc: "\u{4E09}",
        nfkd: "\u{4E09}",
    },
    NormalizationTest {
        source: "\u{3195}",
        nfc: "\u{3195}",
        nfd: "\u{3195}",
        nfkc: "\u{56DB}",
        nfkd: "\u{56DB}",
    },
    NormalizationTest {
        source: "\u{3196}",
        nfc: "\u{3196}",
        nfd: "\u{3196}",
        nfkc: "\u{4E0A}",
        nfkd: "\u{4E0A}",
    },
    NormalizationTest {
        source: "\u{3197}",
        nfc: "\u{3197}",
        nfd: "\u{3197}",
        nfkc: "\u{4E2D}",
        nfkd: "\u{4E2D}",
    },
    NormalizationTest {
        source: "\u{3198}",
        nfc: "\u{3198}",
        nfd: "\u{3198}",
        nfkc: "\u{4E0B}",
        nfkd: "\u{4E0B}",
    },
    NormalizationTest {
        source: "\u{3199}",
        nfc: "\u{3199}",
        nfd: "\u{3199}",
        nfkc: "\u{7532}",
        nfkd: "\u{7532}",
    },
    NormalizationTest {
        source: "\u{319A}",
        nfc: "\u{319A}",
        nfd: "\u{319A}",
        nfkc: "\u{4E59}",
        nfkd: "\u{4E59}",
    },
    NormalizationTest {
        source: "\u{319B}",
        nfc: "\u{319B}",
        nfd: "\u{319B}",
        nfkc: "\u{4E19}",
        nfkd: "\u{4E19}",
    },
    NormalizationTest {
        source: "\u{319C}",
        nfc: "\u{319C}",
        nfd: "\u{319C}",
        nfkc: "\u{4E01}",
        nfkd: "\u{4E01}",
    },
    NormalizationTest {
        source: "\u{319D}",
        nfc: "\u{319D}",
        nfd: "\u{319D}",
        nfkc: "\u{5929}",
        nfkd: "\u{5929}",
    },
    NormalizationTest {
        source: "\u{319E}",
        nfc: "\u{319E}",
        nfd: "\u{319E}",
        nfkc: "\u{5730}",
        nfkd: "\u{5730}",
    },
    NormalizationTest {
        source: "\u{319F}",
        nfc: "\u{319F}",
        nfd: "\u{319F}",
        nfkc: "\u{4EBA}",
        nfkd: "\u{4EBA}",
    },
    NormalizationTest {
        source: "\u{3200}",
        nfc: "\u{3200}",
        nfd: "\u{3200}",
        nfkc: "\u{0028}\u{1100}\u{0029}",
        nfkd: "\u{0028}\u{1100}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3201}",
        nfc: "\u{3201}",
        nfd: "\u{3201}",
        nfkc: "\u{0028}\u{1102}\u{0029}",
        nfkd: "\u{0028}\u{1102}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3202}",
        nfc: "\u{3202}",
        nfd: "\u{3202}",
        nfkc: "\u{0028}\u{1103}\u{0029}",
        nfkd: "\u{0028}\u{1103}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3203}",
        nfc: "\u{3203}",
        nfd: "\u{3203}",
        nfkc: "\u{0028}\u{1105}\u{0029}",
        nfkd: "\u{0028}\u{1105}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3204}",
        nfc: "\u{3204}",
        nfd: "\u{3204}",
        nfkc: "\u{0028}\u{1106}\u{0029}",
        nfkd: "\u{0028}\u{1106}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3205}",
        nfc: "\u{3205}",
        nfd: "\u{3205}",
        nfkc: "\u{0028}\u{1107}\u{0029}",
        nfkd: "\u{0028}\u{1107}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3206}",
        nfc: "\u{3206}",
        nfd: "\u{3206}",
        nfkc: "\u{0028}\u{1109}\u{0029}",
        nfkd: "\u{0028}\u{1109}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3207}",
        nfc: "\u{3207}",
        nfd: "\u{3207}",
        nfkc: "\u{0028}\u{110B}\u{0029}",
        nfkd: "\u{0028}\u{110B}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3208}",
        nfc: "\u{3208}",
        nfd: "\u{3208}",
        nfkc: "\u{0028}\u{110C}\u{0029}",
        nfkd: "\u{0028}\u{110C}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3209}",
        nfc: "\u{3209}",
        nfd: "\u{3209}",
        nfkc: "\u{0028}\u{110E}\u{0029}",
        nfkd: "\u{0028}\u{110E}\u{0029}",
    },
    NormalizationTest {
        source: "\u{320A}",
        nfc: "\u{320A}",
        nfd: "\u{320A}",
        nfkc: "\u{0028}\u{110F}\u{0029}",
        nfkd: "\u{0028}\u{110F}\u{0029}",
    },
    NormalizationTest {
        source: "\u{320B}",
        nfc: "\u{320B}",
        nfd: "\u{320B}",
        nfkc: "\u{0028}\u{1110}\u{0029}",
        nfkd: "\u{0028}\u{1110}\u{0029}",
    },
    NormalizationTest {
        source: "\u{320C}",
        nfc: "\u{320C}",
        nfd: "\u{320C}",
        nfkc: "\u{0028}\u{1111}\u{0029}",
        nfkd: "\u{0028}\u{1111}\u{0029}",
    },
    NormalizationTest {
        source: "\u{320D}",
        nfc: "\u{320D}",
        nfd: "\u{320D}",
        nfkc: "\u{0028}\u{1112}\u{0029}",
        nfkd: "\u{0028}\u{1112}\u{0029}",
    },
    NormalizationTest {
        source: "\u{320E}",
        nfc: "\u{320E}",
        nfd: "\u{320E}",
        nfkc: "\u{0028}\u{AC00}\u{0029}",
        nfkd: "\u{0028}\u{1100}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{320F}",
        nfc: "\u{320F}",
        nfd: "\u{320F}",
        nfkc: "\u{0028}\u{B098}\u{0029}",
        nfkd: "\u{0028}\u{1102}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3210}",
        nfc: "\u{3210}",
        nfd: "\u{3210}",
        nfkc: "\u{0028}\u{B2E4}\u{0029}",
        nfkd: "\u{0028}\u{1103}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3211}",
        nfc: "\u{3211}",
        nfd: "\u{3211}",
        nfkc: "\u{0028}\u{B77C}\u{0029}",
        nfkd: "\u{0028}\u{1105}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3212}",
        nfc: "\u{3212}",
        nfd: "\u{3212}",
        nfkc: "\u{0028}\u{B9C8}\u{0029}",
        nfkd: "\u{0028}\u{1106}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3213}",
        nfc: "\u{3213}",
        nfd: "\u{3213}",
        nfkc: "\u{0028}\u{BC14}\u{0029}",
        nfkd: "\u{0028}\u{1107}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3214}",
        nfc: "\u{3214}",
        nfd: "\u{3214}",
        nfkc: "\u{0028}\u{C0AC}\u{0029}",
        nfkd: "\u{0028}\u{1109}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3215}",
        nfc: "\u{3215}",
        nfd: "\u{3215}",
        nfkc: "\u{0028}\u{C544}\u{0029}",
        nfkd: "\u{0028}\u{110B}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3216}",
        nfc: "\u{3216}",
        nfd: "\u{3216}",
        nfkc: "\u{0028}\u{C790}\u{0029}",
        nfkd: "\u{0028}\u{110C}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3217}",
        nfc: "\u{3217}",
        nfd: "\u{3217}",
        nfkc: "\u{0028}\u{CC28}\u{0029}",
        nfkd: "\u{0028}\u{110E}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3218}",
        nfc: "\u{3218}",
        nfd: "\u{3218}",
        nfkc: "\u{0028}\u{CE74}\u{0029}",
        nfkd: "\u{0028}\u{110F}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3219}",
        nfc: "\u{3219}",
        nfd: "\u{3219}",
        nfkc: "\u{0028}\u{D0C0}\u{0029}",
        nfkd: "\u{0028}\u{1110}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{321A}",
        nfc: "\u{321A}",
        nfd: "\u{321A}",
        nfkc: "\u{0028}\u{D30C}\u{0029}",
        nfkd: "\u{0028}\u{1111}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{321B}",
        nfc: "\u{321B}",
        nfd: "\u{321B}",
        nfkc: "\u{0028}\u{D558}\u{0029}",
        nfkd: "\u{0028}\u{1112}\u{1161}\u{0029}",
    },
    NormalizationTest {
        source: "\u{321C}",
        nfc: "\u{321C}",
        nfd: "\u{321C}",
        nfkc: "\u{0028}\u{C8FC}\u{0029}",
        nfkd: "\u{0028}\u{110C}\u{116E}\u{0029}",
    },
    NormalizationTest {
        source: "\u{321D}",
        nfc: "\u{321D}",
        nfd: "\u{321D}",
        nfkc: "\u{0028}\u{C624}\u{C804}\u{0029}",
        nfkd: "\u{0028}\u{110B}\u{1169}\u{110C}\u{1165}\u{11AB}\u{0029}",
    },
    NormalizationTest {
        source: "\u{321E}",
        nfc: "\u{321E}",
        nfd: "\u{321E}",
        nfkc: "\u{0028}\u{C624}\u{D6C4}\u{0029}",
        nfkd: "\u{0028}\u{110B}\u{1169}\u{1112}\u{116E}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3220}",
        nfc: "\u{3220}",
        nfd: "\u{3220}",
        nfkc: "\u{0028}\u{4E00}\u{0029}",
        nfkd: "\u{0028}\u{4E00}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3221}",
        nfc: "\u{3221}",
        nfd: "\u{3221}",
        nfkc: "\u{0028}\u{4E8C}\u{0029}",
        nfkd: "\u{0028}\u{4E8C}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3222}",
        nfc: "\u{3222}",
        nfd: "\u{3222}",
        nfkc: "\u{0028}\u{4E09}\u{0029}",
        nfkd: "\u{0028}\u{4E09}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3223}",
        nfc: "\u{3223}",
        nfd: "\u{3223}",
        nfkc: "\u{0028}\u{56DB}\u{0029}",
        nfkd: "\u{0028}\u{56DB}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3224}",
        nfc: "\u{3224}",
        nfd: "\u{3224}",
        nfkc: "\u{0028}\u{4E94}\u{0029}",
        nfkd: "\u{0028}\u{4E94}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3225}",
        nfc: "\u{3225}",
        nfd: "\u{3225}",
        nfkc: "\u{0028}\u{516D}\u{0029}",
        nfkd: "\u{0028}\u{516D}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3226}",
        nfc: "\u{3226}",
        nfd: "\u{3226}",
        nfkc: "\u{0028}\u{4E03}\u{0029}",
        nfkd: "\u{0028}\u{4E03}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3227}",
        nfc: "\u{3227}",
        nfd: "\u{3227}",
        nfkc: "\u{0028}\u{516B}\u{0029}",
        nfkd: "\u{0028}\u{516B}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3228}",
        nfc: "\u{3228}",
        nfd: "\u{3228}",
        nfkc: "\u{0028}\u{4E5D}\u{0029}",
        nfkd: "\u{0028}\u{4E5D}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3229}",
        nfc: "\u{3229}",
        nfd: "\u{3229}",
        nfkc: "\u{0028}\u{5341}\u{0029}",
        nfkd: "\u{0028}\u{5341}\u{0029}",
    },
    NormalizationTest {
        source: "\u{322A}",
        nfc: "\u{322A}",
        nfd: "\u{322A}",
        nfkc: "\u{0028}\u{6708}\u{0029}",
        nfkd: "\u{0028}\u{6708}\u{0029}",
    },
    NormalizationTest {
        source: "\u{322B}",
        nfc: "\u{322B}",
        nfd: "\u{322B}",
        nfkc: "\u{0028}\u{706B}\u{0029}",
        nfkd: "\u{0028}\u{706B}\u{0029}",
    },
    NormalizationTest {
        source: "\u{322C}",
        nfc: "\u{322C}",
        nfd: "\u{322C}",
        nfkc: "\u{0028}\u{6C34}\u{0029}",
        nfkd: "\u{0028}\u{6C34}\u{0029}",
    },
    NormalizationTest {
        source: "\u{322D}",
        nfc: "\u{322D}",
        nfd: "\u{322D}",
        nfkc: "\u{0028}\u{6728}\u{0029}",
        nfkd: "\u{0028}\u{6728}\u{0029}",
    },
    NormalizationTest {
        source: "\u{322E}",
        nfc: "\u{322E}",
        nfd: "\u{322E}",
        nfkc: "\u{0028}\u{91D1}\u{0029}",
        nfkd: "\u{0028}\u{91D1}\u{0029}",
    },
    NormalizationTest {
        source: "\u{322F}",
        nfc: "\u{322F}",
        nfd: "\u{322F}",
        nfkc: "\u{0028}\u{571F}\u{0029}",
        nfkd: "\u{0028}\u{571F}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3230}",
        nfc: "\u{3230}",
        nfd: "\u{3230}",
        nfkc: "\u{0028}\u{65E5}\u{0029}",
        nfkd: "\u{0028}\u{65E5}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3231}",
        nfc: "\u{3231}",
        nfd: "\u{3231}",
        nfkc: "\u{0028}\u{682A}\u{0029}",
        nfkd: "\u{0028}\u{682A}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3232}",
        nfc: "\u{3232}",
        nfd: "\u{3232}",
        nfkc: "\u{0028}\u{6709}\u{0029}",
        nfkd: "\u{0028}\u{6709}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3233}",
        nfc: "\u{3233}",
        nfd: "\u{3233}",
        nfkc: "\u{0028}\u{793E}\u{0029}",
        nfkd: "\u{0028}\u{793E}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3234}",
        nfc: "\u{3234}",
        nfd: "\u{3234}",
        nfkc: "\u{0028}\u{540D}\u{0029}",
        nfkd: "\u{0028}\u{540D}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3235}",
        nfc: "\u{3235}",
        nfd: "\u{3235}",
        nfkc: "\u{0028}\u{7279}\u{0029}",
        nfkd: "\u{0028}\u{7279}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3236}",
        nfc: "\u{3236}",
        nfd: "\u{3236}",
        nfkc: "\u{0028}\u{8CA1}\u{0029}",
        nfkd: "\u{0028}\u{8CA1}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3237}",
        nfc: "\u{3237}",
        nfd: "\u{3237}",
        nfkc: "\u{0028}\u{795D}\u{0029}",
        nfkd: "\u{0028}\u{795D}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3238}",
        nfc: "\u{3238}",
        nfd: "\u{3238}",
        nfkc: "\u{0028}\u{52B4}\u{0029}",
        nfkd: "\u{0028}\u{52B4}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3239}",
        nfc: "\u{3239}",
        nfd: "\u{3239}",
        nfkc: "\u{0028}\u{4EE3}\u{0029}",
        nfkd: "\u{0028}\u{4EE3}\u{0029}",
    },
    NormalizationTest {
        source: "\u{323A}",
        nfc: "\u{323A}",
        nfd: "\u{323A}",
        nfkc: "\u{0028}\u{547C}\u{0029}",
        nfkd: "\u{0028}\u{547C}\u{0029}",
    },
    NormalizationTest {
        source: "\u{323B}",
        nfc: "\u{323B}",
        nfd: "\u{323B}",
        nfkc: "\u{0028}\u{5B66}\u{0029}",
        nfkd: "\u{0028}\u{5B66}\u{0029}",
    },
    NormalizationTest {
        source: "\u{323C}",
        nfc: "\u{323C}",
        nfd: "\u{323C}",
        nfkc: "\u{0028}\u{76E3}\u{0029}",
        nfkd: "\u{0028}\u{76E3}\u{0029}",
    },
    NormalizationTest {
        source: "\u{323D}",
        nfc: "\u{323D}",
        nfd: "\u{323D}",
        nfkc: "\u{0028}\u{4F01}\u{0029}",
        nfkd: "\u{0028}\u{4F01}\u{0029}",
    },
    NormalizationTest {
        source: "\u{323E}",
        nfc: "\u{323E}",
        nfd: "\u{323E}",
        nfkc: "\u{0028}\u{8CC7}\u{0029}",
        nfkd: "\u{0028}\u{8CC7}\u{0029}",
    },
    NormalizationTest {
        source: "\u{323F}",
        nfc: "\u{323F}",
        nfd: "\u{323F}",
        nfkc: "\u{0028}\u{5354}\u{0029}",
        nfkd: "\u{0028}\u{5354}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3240}",
        nfc: "\u{3240}",
        nfd: "\u{3240}",
        nfkc: "\u{0028}\u{796D}\u{0029}",
        nfkd: "\u{0028}\u{796D}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3241}",
        nfc: "\u{3241}",
        nfd: "\u{3241}",
        nfkc: "\u{0028}\u{4F11}\u{0029}",
        nfkd: "\u{0028}\u{4F11}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3242}",
        nfc: "\u{3242}",
        nfd: "\u{3242}",
        nfkc: "\u{0028}\u{81EA}\u{0029}",
        nfkd: "\u{0028}\u{81EA}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3243}",
        nfc: "\u{3243}",
        nfd: "\u{3243}",
        nfkc: "\u{0028}\u{81F3}\u{0029}",
        nfkd: "\u{0028}\u{81F3}\u{0029}",
    },
    NormalizationTest {
        source: "\u{3244}",
        nfc: "\u{3244}",
        nfd: "\u{3244}",
        nfkc: "\u{554F}",
        nfkd: "\u{554F}",
    },
    NormalizationTest {
        source: "\u{3245}",
        nfc: "\u{3245}",
        nfd: "\u{3245}",
        nfkc: "\u{5E7C}",
        nfkd: "\u{5E7C}",
    },
    NormalizationTest {
        source: "\u{3246}",
        nfc: "\u{3246}",
        nfd: "\u{3246}",
        nfkc: "\u{6587}",
        nfkd: "\u{6587}",
    },
    NormalizationTest {
        source: "\u{3247}",
        nfc: "\u{3247}",
        nfd: "\u{3247}",
        nfkc: "\u{7B8F}",
        nfkd: "\u{7B8F}",
    },
    NormalizationTest {
        source: "\u{3250}",
        nfc: "\u{3250}",
        nfd: "\u{3250}",
        nfkc: "\u{0050}\u{0054}\u{0045}",
        nfkd: "\u{0050}\u{0054}\u{0045}",
    },
    NormalizationTest {
        source: "\u{3251}",
        nfc: "\u{3251}",
        nfd: "\u{3251}",
        nfkc: "\u{0032}\u{0031}",
        nfkd: "\u{0032}\u{0031}",
    },
    NormalizationTest {
        source: "\u{3252}",
        nfc: "\u{3252}",
        nfd: "\u{3252}",
        nfkc: "\u{0032}\u{0032}",
        nfkd: "\u{0032}\u{0032}",
    },
    NormalizationTest {
        source: "\u{3253}",
        nfc: "\u{3253}",
        nfd: "\u{3253}",
        nfkc: "\u{0032}\u{0033}",
        nfkd: "\u{0032}\u{0033}",
    },
    NormalizationTest {
        source: "\u{3254}",
        nfc: "\u{3254}",
        nfd: "\u{3254}",
        nfkc: "\u{0032}\u{0034}",
        nfkd: "\u{0032}\u{0034}",
    },
    NormalizationTest {
        source: "\u{3255}",
        nfc: "\u{3255}",
        nfd: "\u{3255}",
        nfkc: "\u{0032}\u{0035}",
        nfkd: "\u{0032}\u{0035}",
    },
    NormalizationTest {
        source: "\u{3256}",
        nfc: "\u{3256}",
        nfd: "\u{3256}",
        nfkc: "\u{0032}\u{0036}",
        nfkd: "\u{0032}\u{0036}",
    },
    NormalizationTest {
        source: "\u{3257}",
        nfc: "\u{3257}",
        nfd: "\u{3257}",
        nfkc: "\u{0032}\u{0037}",
        nfkd: "\u{0032}\u{0037}",
    },
    NormalizationTest {
        source: "\u{3258}",
        nfc: "\u{3258}",
        nfd: "\u{3258}",
        nfkc: "\u{0032}\u{0038}",
        nfkd: "\u{0032}\u{0038}",
    },
    NormalizationTest {
        source: "\u{3259}",
        nfc: "\u{3259}",
        nfd: "\u{3259}",
        nfkc: "\u{0032}\u{0039}",
        nfkd: "\u{0032}\u{0039}",
    },
    NormalizationTest {
        source: "\u{325A}",
        nfc: "\u{325A}",
        nfd: "\u{325A}",
        nfkc: "\u{0033}\u{0030}",
        nfkd: "\u{0033}\u{0030}",
    },
    NormalizationTest {
        source: "\u{325B}",
        nfc: "\u{325B}",
        nfd: "\u{325B}",
        nfkc: "\u{0033}\u{0031}",
        nfkd: "\u{0033}\u{0031}",
    },
    NormalizationTest {
        source: "\u{325C}",
        nfc: "\u{325C}",
        nfd: "\u{325C}",
        nfkc: "\u{0033}\u{0032}",
        nfkd: "\u{0033}\u{0032}",
    },
    NormalizationTest {
        source: "\u{325D}",
        nfc: "\u{325D}",
        nfd: "\u{325D}",
        nfkc: "\u{0033}\u{0033}",
        nfkd: "\u{0033}\u{0033}",
    },
    NormalizationTest {
        source: "\u{325E}",
        nfc: "\u{325E}",
        nfd: "\u{325E}",
        nfkc: "\u{0033}\u{0034}",
        nfkd: "\u{0033}\u{0034}",
    },
    NormalizationTest {
        source: "\u{325F}",
        nfc: "\u{325F}",
        nfd: "\u{325F}",
        nfkc: "\u{0033}\u{0035}",
        nfkd: "\u{0033}\u{0035}",
    },
    NormalizationTest {
        source: "\u{3260}",
        nfc: "\u{3260}",
        nfd: "\u{3260}",
        nfkc: "\u{1100}",
        nfkd: "\u{1100}",
    },
    NormalizationTest {
        source: "\u{3261}",
        nfc: "\u{3261}",
        nfd: "\u{3261}",
        nfkc: "\u{1102}",
        nfkd: "\u{1102}",
    },
    NormalizationTest {
        source: "\u{3262}",
        nfc: "\u{3262}",
        nfd: "\u{3262}",
        nfkc: "\u{1103}",
        nfkd: "\u{1103}",
    },
    NormalizationTest {
        source: "\u{3263}",
        nfc: "\u{3263}",
        nfd: "\u{3263}",
        nfkc: "\u{1105}",
        nfkd: "\u{1105}",
    },
    NormalizationTest {
        source: "\u{3264}",
        nfc: "\u{3264}",
        nfd: "\u{3264}",
        nfkc: "\u{1106}",
        nfkd: "\u{1106}",
    },
    NormalizationTest {
        source: "\u{3265}",
        nfc: "\u{3265}",
        nfd: "\u{3265}",
        nfkc: "\u{1107}",
        nfkd: "\u{1107}",
    },
    NormalizationTest {
        source: "\u{3266}",
        nfc: "\u{3266}",
        nfd: "\u{3266}",
        nfkc: "\u{1109}",
        nfkd: "\u{1109}",
    },
    NormalizationTest {
        source: "\u{3267}",
        nfc: "\u{3267}",
        nfd: "\u{3267}",
        nfkc: "\u{110B}",
        nfkd: "\u{110B}",
    },
    NormalizationTest {
        source: "\u{3268}",
        nfc: "\u{3268}",
        nfd: "\u{3268}",
        nfkc: "\u{110C}",
        nfkd: "\u{110C}",
    },
    NormalizationTest {
        source: "\u{3269}",
        nfc: "\u{3269}",
        nfd: "\u{3269}",
        nfkc: "\u{110E}",
        nfkd: "\u{110E}",
    },
    NormalizationTest {
        source: "\u{326A}",
        nfc: "\u{326A}",
        nfd: "\u{326A}",
        nfkc: "\u{110F}",
        nfkd: "\u{110F}",
    },
    NormalizationTest {
        source: "\u{326B}",
        nfc: "\u{326B}",
        nfd: "\u{326B}",
        nfkc: "\u{1110}",
        nfkd: "\u{1110}",
    },
    NormalizationTest {
        source: "\u{326C}",
        nfc: "\u{326C}",
        nfd: "\u{326C}",
        nfkc: "\u{1111}",
        nfkd: "\u{1111}",
    },
    NormalizationTest {
        source: "\u{326D}",
        nfc: "\u{326D}",
        nfd: "\u{326D}",
        nfkc: "\u{1112}",
        nfkd: "\u{1112}",
    },
    NormalizationTest {
        source: "\u{326E}",
        nfc: "\u{326E}",
        nfd: "\u{326E}",
        nfkc: "\u{AC00}",
        nfkd: "\u{1100}\u{1161}",
    },
    NormalizationTest {
        source: "\u{326F}",
        nfc: "\u{326F}",
        nfd: "\u{326F}",
        nfkc: "\u{B098}",
        nfkd: "\u{1102}\u{1161}",
    },
    NormalizationTest {
        source: "\u{3270}",
        nfc: "\u{3270}",
        nfd: "\u{3270}",
        nfkc: "\u{B2E4}",
        nfkd: "\u{1103}\u{1161}",
    },
    NormalizationTest {
        source: "\u{3271}",
        nfc: "\u{3271}",
        nfd: "\u{3271}",
        nfkc: "\u{B77C}",
        nfkd: "\u{1105}\u{1161}",
    },
    NormalizationTest {
        source: "\u{3272}",
        nfc: "\u{3272}",
        nfd: "\u{3272}",
        nfkc: "\u{B9C8}",
        nfkd: "\u{1106}\u{1161}",
    },
    NormalizationTest {
        source: "\u{3273}",
        nfc: "\u{3273}",
        nfd: "\u{3273}",
        nfkc: "\u{BC14}",
        nfkd: "\u{1107}\u{1161}",
    },
    NormalizationTest {
        source: "\u{3274}",
        nfc: "\u{3274}",
        nfd: "\u{3274}",
        nfkc: "\u{C0AC}",
        nfkd: "\u{1109}\u{1161}",
    },
    NormalizationTest {
        source: "\u{3275}",
        nfc: "\u{3275}",
        nfd: "\u{3275}",
        nfkc: "\u{C544}",
        nfkd: "\u{110B}\u{1161}",
    },
    NormalizationTest {
        source: "\u{3276}",
        nfc: "\u{3276}",
        nfd: "\u{3276}",
        nfkc: "\u{C790}",
        nfkd: "\u{110C}\u{1161}",
    },
    NormalizationTest {
        source: "\u{3277}",
        nfc: "\u{3277}",
        nfd: "\u{3277}",
        nfkc: "\u{CC28}",
        nfkd: "\u{110E}\u{1161}",
    },
    NormalizationTest {
        source: "\u{3278}",
        nfc: "\u{3278}",
        nfd: "\u{3278}",
        nfkc: "\u{CE74}",
        nfkd: "\u{110F}\u{1161}",
    },
    NormalizationTest {
        source: "\u{3279}",
        nfc: "\u{3279}",
        nfd: "\u{3279}",
        nfkc: "\u{D0C0}",
        nfkd: "\u{1110}\u{1161}",
    },
    NormalizationTest {
        source: "\u{327A}",
        nfc: "\u{327A}",
        nfd: "\u{327A}",
        nfkc: "\u{D30C}",
        nfkd: "\u{1111}\u{1161}",
    },
    NormalizationTest {
        source: "\u{327B}",
        nfc: "\u{327B}",
        nfd: "\u{327B}",
        nfkc: "\u{D558}",
        nfkd: "\u{1112}\u{1161}",
    },
    NormalizationTest {
        source: "\u{327C}",
        nfc: "\u{327C}",
        nfd: "\u{327C}",
        nfkc: "\u{CC38}\u{ACE0}",
        nfkd: "\u{110E}\u{1161}\u{11B7}\u{1100}\u{1169}",
    },
    NormalizationTest {
        source: "\u{327D}",
        nfc: "\u{327D}",
        nfd: "\u{327D}",
        nfkc: "\u{C8FC}\u{C758}",
        nfkd: "\u{110C}\u{116E}\u{110B}\u{1174}",
    },
    NormalizationTest {
        source: "\u{327E}",
        nfc: "\u{327E}",
        nfd: "\u{327E}",
        nfkc: "\u{C6B0}",
        nfkd: "\u{110B}\u{116E}",
    },
    NormalizationTest {
        source: "\u{3280}",
        nfc: "\u{3280}",
        nfd: "\u{3280}",
        nfkc: "\u{4E00}",
        nfkd: "\u{4E00}",
    },
    NormalizationTest {
        source: "\u{3281}",
        nfc: "\u{3281}",
        nfd: "\u{3281}",
        nfkc: "\u{4E8C}",
        nfkd: "\u{4E8C}",
    },
    NormalizationTest {
        source: "\u{3282}",
        nfc: "\u{3282}",
        nfd: "\u{3282}",
        nfkc: "\u{4E09}",
        nfkd: "\u{4E09}",
    },
    NormalizationTest {
        source: "\u{3283}",
        nfc: "\u{3283}",
        nfd: "\u{3283}",
        nfkc: "\u{56DB}",
        nfkd: "\u{56DB}",
    },
    NormalizationTest {
        source: "\u{3284}",
        nfc: "\u{3284}",
        nfd: "\u{3284}",
        nfkc: "\u{4E94}",
        nfkd: "\u{4E94}",
    },
    NormalizationTest {
        source: "\u{3285}",
        nfc: "\u{3285}",
        nfd: "\u{3285}",
        nfkc: "\u{516D}",
        nfkd: "\u{516D}",
    },
    NormalizationTest {
        source: "\u{3286}",
        nfc: "\u{3286}",
        nfd: "\u{3286}",
        nfkc: "\u{4E03}",
        nfkd: "\u{4E03}",
    },
    NormalizationTest {
        source: "\u{3287}",
        nfc: "\u{3287}",
        nfd: "\u{3287}",
        nfkc: "\u{516B}",
        nfkd: "\u{516B}",
    },
    NormalizationTest {
        source: "\u{3288}",
        nfc: "\u{3288}",
        nfd: "\u{3288}",
        nfkc: "\u{4E5D}",
        nfkd: "\u{4E5D}",
    },
    NormalizationTest {
        source: "\u{3289}",
        nfc: "\u{3289}",
        nfd: "\u{3289}",
        nfkc: "\u{5341}",
        nfkd: "\u{5341}",
    },
    NormalizationTest {
        source: "\u{328A}",
        nfc: "\u{328A}",
        nfd: "\u{328A}",
        nfkc: "\u{6708}",
        nfkd: "\u{6708}",
    },
    NormalizationTest {
        source: "\u{328B}",
        nfc: "\u{328B}",
        nfd: "\u{328B}",
        nfkc: "\u{706B}",
        nfkd: "\u{706B}",
    },
    NormalizationTest {
        source: "\u{328C}",
        nfc: "\u{328C}",
        nfd: "\u{328C}",
        nfkc: "\u{6C34}",
        nfkd: "\u{6C34}",
    },
    NormalizationTest {
        source: "\u{328D}",
        nfc: "\u{328D}",
        nfd: "\u{328D}",
        nfkc: "\u{6728}",
        nfkd: "\u{6728}",
    },
    NormalizationTest {
        source: "\u{328E}",
        nfc: "\u{328E}",
        nfd: "\u{328E}",
        nfkc: "\u{91D1}",
        nfkd: "\u{91D1}",
    },
    NormalizationTest {
        source: "\u{328F}",
        nfc: "\u{328F}",
        nfd: "\u{328F}",
        nfkc: "\u{571F}",
        nfkd: "\u{571F}",
    },
    NormalizationTest {
        source: "\u{3290}",
        nfc: "\u{3290}",
        nfd: "\u{3290}",
        nfkc: "\u{65E5}",
        nfkd: "\u{65E5}",
    },
    NormalizationTest {
        source: "\u{3291}",
        nfc: "\u{3291}",
        nfd: "\u{3291}",
        nfkc: "\u{682A}",
        nfkd: "\u{682A}",
    },
    NormalizationTest {
        source: "\u{3292}",
        nfc: "\u{3292}",
        nfd: "\u{3292}",
        nfkc: "\u{6709}",
        nfkd: "\u{6709}",
    },
    NormalizationTest {
        source: "\u{3293}",
        nfc: "\u{3293}",
        nfd: "\u{3293}",
        nfkc: "\u{793E}",
        nfkd: "\u{793E}",
    },
    NormalizationTest {
        source: "\u{3294}",
        nfc: "\u{3294}",
        nfd: "\u{3294}",
        nfkc: "\u{540D}",
        nfkd: "\u{540D}",
    },
    NormalizationTest {
        source: "\u{3295}",
        nfc: "\u{3295}",
        nfd: "\u{3295}",
        nfkc: "\u{7279}",
        nfkd: "\u{7279}",
    },
    NormalizationTest {
        source: "\u{3296}",
        nfc: "\u{3296}",
        nfd: "\u{3296}",
        nfkc: "\u{8CA1}",
        nfkd: "\u{8CA1}",
    },
    NormalizationTest {
        source: "\u{3297}",
        nfc: "\u{3297}",
        nfd: "\u{3297}",
        nfkc: "\u{795D}",
        nfkd: "\u{795D}",
    },
    NormalizationTest {
        source: "\u{3298}",
        nfc: "\u{3298}",
        nfd: "\u{3298}",
        nfkc: "\u{52B4}",
        nfkd: "\u{52B4}",
    },
    NormalizationTest {
        source: "\u{3299}",
        nfc: "\u{3299}",
        nfd: "\u{3299}",
        nfkc: "\u{79D8}",
        nfkd: "\u{79D8}",
    },
    NormalizationTest {
        source: "\u{329A}",
        nfc: "\u{329A}",
        nfd: "\u{329A}",
        nfkc: "\u{7537}",
        nfkd: "\u{7537}",
    },
    NormalizationTest {
        source: "\u{329B}",
        nfc: "\u{329B}",
        nfd: "\u{329B}",
        nfkc: "\u{5973}",
        nfkd: "\u{5973}",
    },
    NormalizationTest {
        source: "\u{329C}",
        nfc: "\u{329C}",
        nfd: "\u{329C}",
        nfkc: "\u{9069}",
        nfkd: "\u{9069}",
    },
    NormalizationTest {
        source: "\u{329D}",
        nfc: "\u{329D}",
        nfd: "\u{329D}",
        nfkc: "\u{512A}",
        nfkd: "\u{512A}",
    },
    NormalizationTest {
        source: "\u{329E}",
        nfc: "\u{329E}",
        nfd: "\u{329E}",
        nfkc: "\u{5370}",
        nfkd: "\u{5370}",
    },
    NormalizationTest {
        source: "\u{329F}",
        nfc: "\u{329F}",
        nfd: "\u{329F}",
        nfkc: "\u{6CE8}",
        nfkd: "\u{6CE8}",
    },
    NormalizationTest {
        source: "\u{32A0}",
        nfc: "\u{32A0}",
        nfd: "\u{32A0}",
        nfkc: "\u{9805}",
        nfkd: "\u{9805}",
    },
    NormalizationTest {
        source: "\u{32A1}",
        nfc: "\u{32A1}",
        nfd: "\u{32A1}",
        nfkc: "\u{4F11}",
        nfkd: "\u{4F11}",
    },
    NormalizationTest {
        source: "\u{32A2}",
        nfc: "\u{32A2}",
        nfd: "\u{32A2}",
        nfkc: "\u{5199}",
        nfkd: "\u{5199}",
    },
    NormalizationTest {
        source: "\u{32A3}",
        nfc: "\u{32A3}",
        nfd: "\u{32A3}",
        nfkc: "\u{6B63}",
        nfkd: "\u{6B63}",
    },
    NormalizationTest {
        source: "\u{32A4}",
        nfc: "\u{32A4}",
        nfd: "\u{32A4}",
        nfkc: "\u{4E0A}",
        nfkd: "\u{4E0A}",
    },
    NormalizationTest {
        source: "\u{32A5}",
        nfc: "\u{32A5}",
        nfd: "\u{32A5}",
        nfkc: "\u{4E2D}",
        nfkd: "\u{4E2D}",
    },
    NormalizationTest {
        source: "\u{32A6}",
        nfc: "\u{32A6}",
        nfd: "\u{32A6}",
        nfkc: "\u{4E0B}",
        nfkd: "\u{4E0B}",
    },
    NormalizationTest {
        source: "\u{32A7}",
        nfc: "\u{32A7}",
        nfd: "\u{32A7}",
        nfkc: "\u{5DE6}",
        nfkd: "\u{5DE6}",
    },
    NormalizationTest {
        source: "\u{32A8}",
        nfc: "\u{32A8}",
        nfd: "\u{32A8}",
        nfkc: "\u{53F3}",
        nfkd: "\u{53F3}",
    },
    NormalizationTest {
        source: "\u{32A9}",
        nfc: "\u{32A9}",
        nfd: "\u{32A9}",
        nfkc: "\u{533B}",
        nfkd: "\u{533B}",
    },
    NormalizationTest {
        source: "\u{32AA}",
        nfc: "\u{32AA}",
        nfd: "\u{32AA}",
        nfkc: "\u{5B97}",
        nfkd: "\u{5B97}",
    },
    NormalizationTest {
        source: "\u{32AB}",
        nfc: "\u{32AB}",
        nfd: "\u{32AB}",
        nfkc: "\u{5B66}",
        nfkd: "\u{5B66}",
    },
    NormalizationTest {
        source: "\u{32AC}",
        nfc: "\u{32AC}",
        nfd: "\u{32AC}",
        nfkc: "\u{76E3}",
        nfkd: "\u{76E3}",
    },
    NormalizationTest {
        source: "\u{32AD}",
        nfc: "\u{32AD}",
        nfd: "\u{32AD}",
        nfkc: "\u{4F01}",
        nfkd: "\u{4F01}",
    },
    NormalizationTest {
        source: "\u{32AE}",
        nfc: "\u{32AE}",
        nfd: "\u{32AE}",
        nfkc: "\u{8CC7}",
        nfkd: "\u{8CC7}",
    },
    NormalizationTest {
        source: "\u{32AF}",
        nfc: "\u{32AF}",
        nfd: "\u{32AF}",
        nfkc: "\u{5354}",
        nfkd: "\u{5354}",
    },
    NormalizationTest {
        source: "\u{32B0}",
        nfc: "\u{32B0}",
        nfd: "\u{32B0}",
        nfkc: "\u{591C}",
        nfkd: "\u{591C}",
    },
    NormalizationTest {
        source: "\u{32B1}",
        nfc: "\u{32B1}",
        nfd: "\u{32B1}",
        nfkc: "\u{0033}\u{0036}",
        nfkd: "\u{0033}\u{0036}",
    },
    NormalizationTest {
        source: "\u{32B2}",
        nfc: "\u{32B2}",
        nfd: "\u{32B2}",
        nfkc: "\u{0033}\u{0037}",
        nfkd: "\u{0033}\u{0037}",
    },
    NormalizationTest {
        source: "\u{32B3}",
        nfc: "\u{32B3}",
        nfd: "\u{32B3}",
        nfkc: "\u{0033}\u{0038}",
        nfkd: "\u{0033}\u{0038}",
    },
    NormalizationTest {
        source: "\u{32B4}",
        nfc: "\u{32B4}",
        nfd: "\u{32B4}",
        nfkc: "\u{0033}\u{0039}",
        nfkd: "\u{0033}\u{0039}",
    },
    NormalizationTest {
        source: "\u{32B5}",
        nfc: "\u{32B5}",
        nfd: "\u{32B5}",
        nfkc: "\u{0034}\u{0030}",
        nfkd: "\u{0034}\u{0030}",
    },
    NormalizationTest {
        source: "\u{32B6}",
        nfc: "\u{32B6}",
        nfd: "\u{32B6}",
        nfkc: "\u{0034}\u{0031}",
        nfkd: "\u{0034}\u{0031}",
    },
    NormalizationTest {
        source: "\u{32B7}",
        nfc: "\u{32B7}",
        nfd: "\u{32B7}",
        nfkc: "\u{0034}\u{0032}",
        nfkd: "\u{0034}\u{0032}",
    },
    NormalizationTest {
        source: "\u{32B8}",
        nfc: "\u{32B8}",
        nfd: "\u{32B8}",
        nfkc: "\u{0034}\u{0033}",
        nfkd: "\u{0034}\u{0033}",
    },
    NormalizationTest {
        source: "\u{32B9}",
        nfc: "\u{32B9}",
        nfd: "\u{32B9}",
        nfkc: "\u{0034}\u{0034}",
        nfkd: "\u{0034}\u{0034}",
    },
    NormalizationTest {
        source: "\u{32BA}",
        nfc: "\u{32BA}",
        nfd: "\u{32BA}",
        nfkc: "\u{0034}\u{0035}",
        nfkd: "\u{0034}\u{0035}",
    },
    NormalizationTest {
        source: "\u{32BB}",
        nfc: "\u{32BB}",
        nfd: "\u{32BB}",
        nfkc: "\u{0034}\u{0036}",
        nfkd: "\u{0034}\u{0036}",
    },
    NormalizationTest {
        source: "\u{32BC}",
        nfc: "\u{32BC}",
        nfd: "\u{32BC}",
        nfkc: "\u{0034}\u{0037}",
        nfkd: "\u{0034}\u{0037}",
    },
    NormalizationTest {
        source: "\u{32BD}",
        nfc: "\u{32BD}",
        nfd: "\u{32BD}",
        nfkc: "\u{0034}\u{0038}",
        nfkd: "\u{0034}\u{0038}",
    },
    NormalizationTest {
        source: "\u{32BE}",
        nfc: "\u{32BE}",
        nfd: "\u{32BE}",
        nfkc: "\u{0034}\u{0039}",
        nfkd: "\u{0034}\u{0039}",
    },
    NormalizationTest {
        source: "\u{32BF}",
        nfc: "\u{32BF}",
        nfd: "\u{32BF}",
        nfkc: "\u{0035}\u{0030}",
        nfkd: "\u{0035}\u{0030}",
    },
    NormalizationTest {
        source: "\u{32C0}",
        nfc: "\u{32C0}",
        nfd: "\u{32C0}",
        nfkc: "\u{0031}\u{6708}",
        nfkd: "\u{0031}\u{6708}",
    },
    NormalizationTest {
        source: "\u{32C1}",
        nfc: "\u{32C1}",
        nfd: "\u{32C1}",
        nfkc: "\u{0032}\u{6708}",
        nfkd: "\u{0032}\u{6708}",
    },
    NormalizationTest {
        source: "\u{32C2}",
        nfc: "\u{32C2}",
        nfd: "\u{32C2}",
        nfkc: "\u{0033}\u{6708}",
        nfkd: "\u{0033}\u{6708}",
    },
    NormalizationTest {
        source: "\u{32C3}",
        nfc: "\u{32C3}",
        nfd: "\u{32C3}",
        nfkc: "\u{0034}\u{6708}",
        nfkd: "\u{0034}\u{6708}",
    },
    NormalizationTest {
        source: "\u{32C4}",
        nfc: "\u{32C4}",
        nfd: "\u{32C4}",
        nfkc: "\u{0035}\u{6708}",
        nfkd: "\u{0035}\u{6708}",
    },
    NormalizationTest {
        source: "\u{32C5}",
        nfc: "\u{32C5}",
        nfd: "\u{32C5}",
        nfkc: "\u{0036}\u{6708}",
        nfkd: "\u{0036}\u{6708}",
    },
    NormalizationTest {
        source: "\u{32C6}",
        nfc: "\u{32C6}",
        nfd: "\u{32C6}",
        nfkc: "\u{0037}\u{6708}",
        nfkd: "\u{0037}\u{6708}",
    },
    NormalizationTest {
        source: "\u{32C7}",
        nfc: "\u{32C7}",
        nfd: "\u{32C7}",
        nfkc: "\u{0038}\u{6708}",
        nfkd: "\u{0038}\u{6708}",
    },
    NormalizationTest {
        source: "\u{32C8}",
        nfc: "\u{32C8}",
        nfd: "\u{32C8}",
        nfkc: "\u{0039}\u{6708}",
        nfkd: "\u{0039}\u{6708}",
    },
    NormalizationTest {
        source: "\u{32C9}",
        nfc: "\u{32C9}",
        nfd: "\u{32C9}",
        nfkc: "\u{0031}\u{0030}\u{6708}",
        nfkd: "\u{0031}\u{0030}\u{6708}",
    },
    NormalizationTest {
        source: "\u{32CA}",
        nfc: "\u{32CA}",
        nfd: "\u{32CA}",
        nfkc: "\u{0031}\u{0031}\u{6708}",
        nfkd: "\u{0031}\u{0031}\u{6708}",
    },
    NormalizationTest {
        source: "\u{32CB}",
        nfc: "\u{32CB}",
        nfd: "\u{32CB}",
        nfkc: "\u{0031}\u{0032}\u{6708}",
        nfkd: "\u{0031}\u{0032}\u{6708}",
    },
    NormalizationTest {
        source: "\u{32CC}",
        nfc: "\u{32CC}",
        nfd: "\u{32CC}",
        nfkc: "\u{0048}\u{0067}",
        nfkd: "\u{0048}\u{0067}",
    },
    NormalizationTest {
        source: "\u{32CD}",
        nfc: "\u{32CD}",
        nfd: "\u{32CD}",
        nfkc: "\u{0065}\u{0072}\u{0067}",
        nfkd: "\u{0065}\u{0072}\u{0067}",
    },
    NormalizationTest {
        source: "\u{32CE}",
        nfc: "\u{32CE}",
        nfd: "\u{32CE}",
        nfkc: "\u{0065}\u{0056}",
        nfkd: "\u{0065}\u{0056}",
    },
    NormalizationTest {
        source: "\u{32CF}",
        nfc: "\u{32CF}",
        nfd: "\u{32CF}",
        nfkc: "\u{004C}\u{0054}\u{0044}",
        nfkd: "\u{004C}\u{0054}\u{0044}",
    },
    NormalizationTest {
        source: "\u{32D0}",
        nfc: "\u{32D0}",
        nfd: "\u{32D0}",
        nfkc: "\u{30A2}",
        nfkd: "\u{30A2}",
    },
    NormalizationTest {
        source: "\u{32D1}",
        nfc: "\u{32D1}",
        nfd: "\u{32D1}",
        nfkc: "\u{30A4}",
        nfkd: "\u{30A4}",
    },
    NormalizationTest {
        source: "\u{32D2}",
        nfc: "\u{32D2}",
        nfd: "\u{32D2}",
        nfkc: "\u{30A6}",
        nfkd: "\u{30A6}",
    },
    NormalizationTest {
        source: "\u{32D3}",
        nfc: "\u{32D3}",
        nfd: "\u{32D3}",
        nfkc: "\u{30A8}",
        nfkd: "\u{30A8}",
    },
    NormalizationTest {
        source: "\u{32D4}",
        nfc: "\u{32D4}",
        nfd: "\u{32D4}",
        nfkc: "\u{30AA}",
        nfkd: "\u{30AA}",
    },
    NormalizationTest {
        source: "\u{32D5}",
        nfc: "\u{32D5}",
        nfd: "\u{32D5}",
        nfkc: "\u{30AB}",
        nfkd: "\u{30AB}",
    },
    NormalizationTest {
        source: "\u{32D6}",
        nfc: "\u{32D6}",
        nfd: "\u{32D6}",
        nfkc: "\u{30AD}",
        nfkd: "\u{30AD}",
    },
    NormalizationTest {
        source: "\u{32D7}",
        nfc: "\u{32D7}",
        nfd: "\u{32D7}",
        nfkc: "\u{30AF}",
        nfkd: "\u{30AF}",
    },
    NormalizationTest {
        source: "\u{32D8}",
        nfc: "\u{32D8}",
        nfd: "\u{32D8}",
        nfkc: "\u{30B1}",
        nfkd: "\u{30B1}",
    },
    NormalizationTest {
        source: "\u{32D9}",
        nfc: "\u{32D9}",
        nfd: "\u{32D9}",
        nfkc: "\u{30B3}",
        nfkd: "\u{30B3}",
    },
    NormalizationTest {
        source: "\u{32DA}",
        nfc: "\u{32DA}",
        nfd: "\u{32DA}",
        nfkc: "\u{30B5}",
        nfkd: "\u{30B5}",
    },
    NormalizationTest {
        source: "\u{32DB}",
        nfc: "\u{32DB}",
        nfd: "\u{32DB}",
        nfkc: "\u{30B7}",
        nfkd: "\u{30B7}",
    },
    NormalizationTest {
        source: "\u{32DC}",
        nfc: "\u{32DC}",
        nfd: "\u{32DC}",
        nfkc: "\u{30B9}",
        nfkd: "\u{30B9}",
    },
    NormalizationTest {
        source: "\u{32DD}",
        nfc: "\u{32DD}",
        nfd: "\u{32DD}",
        nfkc: "\u{30BB}",
        nfkd: "\u{30BB}",
    },
    NormalizationTest {
        source: "\u{32DE}",
        nfc: "\u{32DE}",
        nfd: "\u{32DE}",
        nfkc: "\u{30BD}",
        nfkd: "\u{30BD}",
    },
    NormalizationTest {
        source: "\u{32DF}",
        nfc: "\u{32DF}",
        nfd: "\u{32DF}",
        nfkc: "\u{30BF}",
        nfkd: "\u{30BF}",
    },
    NormalizationTest {
        source: "\u{32E0}",
        nfc: "\u{32E0}",
        nfd: "\u{32E0}",
        nfkc: "\u{30C1}",
        nfkd: "\u{30C1}",
    },
    NormalizationTest {
        source: "\u{32E1}",
        nfc: "\u{32E1}",
        nfd: "\u{32E1}",
        nfkc: "\u{30C4}",
        nfkd: "\u{30C4}",
    },
    NormalizationTest {
        source: "\u{32E2}",
        nfc: "\u{32E2}",
        nfd: "\u{32E2}",
        nfkc: "\u{30C6}",
        nfkd: "\u{30C6}",
    },
    NormalizationTest {
        source: "\u{32E3}",
        nfc: "\u{32E3}",
        nfd: "\u{32E3}",
        nfkc: "\u{30C8}",
        nfkd: "\u{30C8}",
    },
    NormalizationTest {
        source: "\u{32E4}",
        nfc: "\u{32E4}",
        nfd: "\u{32E4}",
        nfkc: "\u{30CA}",
        nfkd: "\u{30CA}",
    },
    NormalizationTest {
        source: "\u{32E5}",
        nfc: "\u{32E5}",
        nfd: "\u{32E5}",
        nfkc: "\u{30CB}",
        nfkd: "\u{30CB}",
    },
    NormalizationTest {
        source: "\u{32E6}",
        nfc: "\u{32E6}",
        nfd: "\u{32E6}",
        nfkc: "\u{30CC}",
        nfkd: "\u{30CC}",
    },
    NormalizationTest {
        source: "\u{32E7}",
        nfc: "\u{32E7}",
        nfd: "\u{32E7}",
        nfkc: "\u{30CD}",
        nfkd: "\u{30CD}",
    },
    NormalizationTest {
        source: "\u{32E8}",
        nfc: "\u{32E8}",
        nfd: "\u{32E8}",
        nfkc: "\u{30CE}",
        nfkd: "\u{30CE}",
    },
    NormalizationTest {
        source: "\u{32E9}",
        nfc: "\u{32E9}",
        nfd: "\u{32E9}",
        nfkc: "\u{30CF}",
        nfkd: "\u{30CF}",
    },
    NormalizationTest {
        source: "\u{32EA}",
        nfc: "\u{32EA}",
        nfd: "\u{32EA}",
        nfkc: "\u{30D2}",
        nfkd: "\u{30D2}",
    },
    NormalizationTest {
        source: "\u{32EB}",
        nfc: "\u{32EB}",
        nfd: "\u{32EB}",
        nfkc: "\u{30D5}",
        nfkd: "\u{30D5}",
    },
    NormalizationTest {
        source: "\u{32EC}",
        nfc: "\u{32EC}",
        nfd: "\u{32EC}",
        nfkc: "\u{30D8}",
        nfkd: "\u{30D8}",
    },
    NormalizationTest {
        source: "\u{32ED}",
        nfc: "\u{32ED}",
        nfd: "\u{32ED}",
        nfkc: "\u{30DB}",
        nfkd: "\u{30DB}",
    },
    NormalizationTest {
        source: "\u{32EE}",
        nfc: "\u{32EE}",
        nfd: "\u{32EE}",
        nfkc: "\u{30DE}",
        nfkd: "\u{30DE}",
    },
    NormalizationTest {
        source: "\u{32EF}",
        nfc: "\u{32EF}",
        nfd: "\u{32EF}",
        nfkc: "\u{30DF}",
        nfkd: "\u{30DF}",
    },
    NormalizationTest {
        source: "\u{32F0}",
        nfc: "\u{32F0}",
        nfd: "\u{32F0}",
        nfkc: "\u{30E0}",
        nfkd: "\u{30E0}",
    },
    NormalizationTest {
        source: "\u{32F1}",
        nfc: "\u{32F1}",
        nfd: "\u{32F1}",
        nfkc: "\u{30E1}",
        nfkd: "\u{30E1}",
    },
    NormalizationTest {
        source: "\u{32F2}",
        nfc: "\u{32F2}",
        nfd: "\u{32F2}",
        nfkc: "\u{30E2}",
        nfkd: "\u{30E2}",
    },
    NormalizationTest {
        source: "\u{32F3}",
        nfc: "\u{32F3}",
        nfd: "\u{32F3}",
        nfkc: "\u{30E4}",
        nfkd: "\u{30E4}",
    },
    NormalizationTest {
        source: "\u{32F4}",
        nfc: "\u{32F4}",
        nfd: "\u{32F4}",
        nfkc: "\u{30E6}",
        nfkd: "\u{30E6}",
    },
    NormalizationTest {
        source: "\u{32F5}",
        nfc: "\u{32F5}",
        nfd: "\u{32F5}",
        nfkc: "\u{30E8}",
        nfkd: "\u{30E8}",
    },
    NormalizationTest {
        source: "\u{32F6}",
        nfc: "\u{32F6}",
        nfd: "\u{32F6}",
        nfkc: "\u{30E9}",
        nfkd: "\u{30E9}",
    },
    NormalizationTest {
        source: "\u{32F7}",
        nfc: "\u{32F7}",
        nfd: "\u{32F7}",
        nfkc: "\u{30EA}",
        nfkd: "\u{30EA}",
    },
    NormalizationTest {
        source: "\u{32F8}",
        nfc: "\u{32F8}",
        nfd: "\u{32F8}",
        nfkc: "\u{30EB}",
        nfkd: "\u{30EB}",
    },
    NormalizationTest {
        source: "\u{32F9}",
        nfc: "\u{32F9}",
        nfd: "\u{32F9}",
        nfkc: "\u{30EC}",
        nfkd: "\u{30EC}",
    },
    NormalizationTest {
        source: "\u{32FA}",
        nfc: "\u{32FA}",
        nfd: "\u{32FA}",
        nfkc: "\u{30ED}",
        nfkd: "\u{30ED}",
    },
    NormalizationTest {
        source: "\u{32FB}",
        nfc: "\u{32FB}",
        nfd: "\u{32FB}",
        nfkc: "\u{30EF}",
        nfkd: "\u{30EF}",
    },
    NormalizationTest {
        source: "\u{32FC}",
        nfc: "\u{32FC}",
        nfd: "\u{32FC}",
        nfkc: "\u{30F0}",
        nfkd: "\u{30F0}",
    },
    NormalizationTest {
        source: "\u{32FD}",
        nfc: "\u{32FD}",
        nfd: "\u{32FD}",
        nfkc: "\u{30F1}",
        nfkd: "\u{30F1}",
    },
    NormalizationTest {
        source: "\u{32FE}",
        nfc: "\u{32FE}",
        nfd: "\u{32FE}",
        nfkc: "\u{30F2}",
        nfkd: "\u{30F2}",
    },
    NormalizationTest {
        source: "\u{3300}",
        nfc: "\u{3300}",
        nfd: "\u{3300}",
        nfkc: "\u{30A2}\u{30D1}\u{30FC}\u{30C8}",
        nfkd: "\u{30A2}\u{30CF}\u{309A}\u{30FC}\u{30C8}",
    },
    NormalizationTest {
        source: "\u{3301}",
        nfc: "\u{3301}",
        nfd: "\u{3301}",
        nfkc: "\u{30A2}\u{30EB}\u{30D5}\u{30A1}",
        nfkd: "\u{30A2}\u{30EB}\u{30D5}\u{30A1}",
    },
    NormalizationTest {
        source: "\u{3302}",
        nfc: "\u{3302}",
        nfd: "\u{3302}",
        nfkc: "\u{30A2}\u{30F3}\u{30DA}\u{30A2}",
        nfkd: "\u{30A2}\u{30F3}\u{30D8}\u{309A}\u{30A2}",
    },
    NormalizationTest {
        source: "\u{3303}",
        nfc: "\u{3303}",
        nfd: "\u{3303}",
        nfkc: "\u{30A2}\u{30FC}\u{30EB}",
        nfkd: "\u{30A2}\u{30FC}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3304}",
        nfc: "\u{3304}",
        nfd: "\u{3304}",
        nfkc: "\u{30A4}\u{30CB}\u{30F3}\u{30B0}",
        nfkd: "\u{30A4}\u{30CB}\u{30F3}\u{30AF}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3305}",
        nfc: "\u{3305}",
        nfd: "\u{3305}",
        nfkc: "\u{30A4}\u{30F3}\u{30C1}",
        nfkd: "\u{30A4}\u{30F3}\u{30C1}",
    },
    NormalizationTest {
        source: "\u{3306}",
        nfc: "\u{3306}",
        nfd: "\u{3306}",
        nfkc: "\u{30A6}\u{30A9}\u{30F3}",
        nfkd: "\u{30A6}\u{30A9}\u{30F3}",
    },
    NormalizationTest {
        source: "\u{3307}",
        nfc: "\u{3307}",
        nfd: "\u{3307}",
        nfkc: "\u{30A8}\u{30B9}\u{30AF}\u{30FC}\u{30C9}",
        nfkd: "\u{30A8}\u{30B9}\u{30AF}\u{30FC}\u{30C8}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3308}",
        nfc: "\u{3308}",
        nfd: "\u{3308}",
        nfkc: "\u{30A8}\u{30FC}\u{30AB}\u{30FC}",
        nfkd: "\u{30A8}\u{30FC}\u{30AB}\u{30FC}",
    },
    NormalizationTest {
        source: "\u{3309}",
        nfc: "\u{3309}",
        nfd: "\u{3309}",
        nfkc: "\u{30AA}\u{30F3}\u{30B9}",
        nfkd: "\u{30AA}\u{30F3}\u{30B9}",
    },
    NormalizationTest {
        source: "\u{330A}",
        nfc: "\u{330A}",
        nfd: "\u{330A}",
        nfkc: "\u{30AA}\u{30FC}\u{30E0}",
        nfkd: "\u{30AA}\u{30FC}\u{30E0}",
    },
    NormalizationTest {
        source: "\u{330B}",
        nfc: "\u{330B}",
        nfd: "\u{330B}",
        nfkc: "\u{30AB}\u{30A4}\u{30EA}",
        nfkd: "\u{30AB}\u{30A4}\u{30EA}",
    },
    NormalizationTest {
        source: "\u{330C}",
        nfc: "\u{330C}",
        nfd: "\u{330C}",
        nfkc: "\u{30AB}\u{30E9}\u{30C3}\u{30C8}",
        nfkd: "\u{30AB}\u{30E9}\u{30C3}\u{30C8}",
    },
    NormalizationTest {
        source: "\u{330D}",
        nfc: "\u{330D}",
        nfd: "\u{330D}",
        nfkc: "\u{30AB}\u{30ED}\u{30EA}\u{30FC}",
        nfkd: "\u{30AB}\u{30ED}\u{30EA}\u{30FC}",
    },
    NormalizationTest {
        source: "\u{330E}",
        nfc: "\u{330E}",
        nfd: "\u{330E}",
        nfkc: "\u{30AC}\u{30ED}\u{30F3}",
        nfkd: "\u{30AB}\u{3099}\u{30ED}\u{30F3}",
    },
    NormalizationTest {
        source: "\u{330F}",
        nfc: "\u{330F}",
        nfd: "\u{330F}",
        nfkc: "\u{30AC}\u{30F3}\u{30DE}",
        nfkd: "\u{30AB}\u{3099}\u{30F3}\u{30DE}",
    },
    NormalizationTest {
        source: "\u{3310}",
        nfc: "\u{3310}",
        nfd: "\u{3310}",
        nfkc: "\u{30AE}\u{30AC}",
        nfkd: "\u{30AD}\u{3099}\u{30AB}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3311}",
        nfc: "\u{3311}",
        nfd: "\u{3311}",
        nfkc: "\u{30AE}\u{30CB}\u{30FC}",
        nfkd: "\u{30AD}\u{3099}\u{30CB}\u{30FC}",
    },
    NormalizationTest {
        source: "\u{3312}",
        nfc: "\u{3312}",
        nfd: "\u{3312}",
        nfkc: "\u{30AD}\u{30E5}\u{30EA}\u{30FC}",
        nfkd: "\u{30AD}\u{30E5}\u{30EA}\u{30FC}",
    },
    NormalizationTest {
        source: "\u{3313}",
        nfc: "\u{3313}",
        nfd: "\u{3313}",
        nfkc: "\u{30AE}\u{30EB}\u{30C0}\u{30FC}",
        nfkd: "\u{30AD}\u{3099}\u{30EB}\u{30BF}\u{3099}\u{30FC}",
    },
    NormalizationTest {
        source: "\u{3314}",
        nfc: "\u{3314}",
        nfd: "\u{3314}",
        nfkc: "\u{30AD}\u{30ED}",
        nfkd: "\u{30AD}\u{30ED}",
    },
    NormalizationTest {
        source: "\u{3315}",
        nfc: "\u{3315}",
        nfd: "\u{3315}",
        nfkc: "\u{30AD}\u{30ED}\u{30B0}\u{30E9}\u{30E0}",
        nfkd: "\u{30AD}\u{30ED}\u{30AF}\u{3099}\u{30E9}\u{30E0}",
    },
    NormalizationTest {
        source: "\u{3316}",
        nfc: "\u{3316}",
        nfd: "\u{3316}",
        nfkc: "\u{30AD}\u{30ED}\u{30E1}\u{30FC}\u{30C8}\u{30EB}",
        nfkd: "\u{30AD}\u{30ED}\u{30E1}\u{30FC}\u{30C8}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3317}",
        nfc: "\u{3317}",
        nfd: "\u{3317}",
        nfkc: "\u{30AD}\u{30ED}\u{30EF}\u{30C3}\u{30C8}",
        nfkd: "\u{30AD}\u{30ED}\u{30EF}\u{30C3}\u{30C8}",
    },
    NormalizationTest {
        source: "\u{3318}",
        nfc: "\u{3318}",
        nfd: "\u{3318}",
        nfkc: "\u{30B0}\u{30E9}\u{30E0}",
        nfkd: "\u{30AF}\u{3099}\u{30E9}\u{30E0}",
    },
    NormalizationTest {
        source: "\u{3319}",
        nfc: "\u{3319}",
        nfd: "\u{3319}",
        nfkc: "\u{30B0}\u{30E9}\u{30E0}\u{30C8}\u{30F3}",
        nfkd: "\u{30AF}\u{3099}\u{30E9}\u{30E0}\u{30C8}\u{30F3}",
    },
    NormalizationTest {
        source: "\u{331A}",
        nfc: "\u{331A}",
        nfd: "\u{331A}",
        nfkc: "\u{30AF}\u{30EB}\u{30BC}\u{30A4}\u{30ED}",
        nfkd: "\u{30AF}\u{30EB}\u{30BB}\u{3099}\u{30A4}\u{30ED}",
    },
    NormalizationTest {
        source: "\u{331B}",
        nfc: "\u{331B}",
        nfd: "\u{331B}",
        nfkc: "\u{30AF}\u{30ED}\u{30FC}\u{30CD}",
        nfkd: "\u{30AF}\u{30ED}\u{30FC}\u{30CD}",
    },
    NormalizationTest {
        source: "\u{331C}",
        nfc: "\u{331C}",
        nfd: "\u{331C}",
        nfkc: "\u{30B1}\u{30FC}\u{30B9}",
        nfkd: "\u{30B1}\u{30FC}\u{30B9}",
    },
    NormalizationTest {
        source: "\u{331D}",
        nfc: "\u{331D}",
        nfd: "\u{331D}",
        nfkc: "\u{30B3}\u{30EB}\u{30CA}",
        nfkd: "\u{30B3}\u{30EB}\u{30CA}",
    },
    NormalizationTest {
        source: "\u{331E}",
        nfc: "\u{331E}",
        nfd: "\u{331E}",
        nfkc: "\u{30B3}\u{30FC}\u{30DD}",
        nfkd: "\u{30B3}\u{30FC}\u{30DB}\u{309A}",
    },
    NormalizationTest {
        source: "\u{331F}",
        nfc: "\u{331F}",
        nfd: "\u{331F}",
        nfkc: "\u{30B5}\u{30A4}\u{30AF}\u{30EB}",
        nfkd: "\u{30B5}\u{30A4}\u{30AF}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3320}",
        nfc: "\u{3320}",
        nfd: "\u{3320}",
        nfkc: "\u{30B5}\u{30F3}\u{30C1}\u{30FC}\u{30E0}",
        nfkd: "\u{30B5}\u{30F3}\u{30C1}\u{30FC}\u{30E0}",
    },
    NormalizationTest {
        source: "\u{3321}",
        nfc: "\u{3321}",
        nfd: "\u{3321}",
        nfkc: "\u{30B7}\u{30EA}\u{30F3}\u{30B0}",
        nfkd: "\u{30B7}\u{30EA}\u{30F3}\u{30AF}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3322}",
        nfc: "\u{3322}",
        nfd: "\u{3322}",
        nfkc: "\u{30BB}\u{30F3}\u{30C1}",
        nfkd: "\u{30BB}\u{30F3}\u{30C1}",
    },
    NormalizationTest {
        source: "\u{3323}",
        nfc: "\u{3323}",
        nfd: "\u{3323}",
        nfkc: "\u{30BB}\u{30F3}\u{30C8}",
        nfkd: "\u{30BB}\u{30F3}\u{30C8}",
    },
    NormalizationTest {
        source: "\u{3324}",
        nfc: "\u{3324}",
        nfd: "\u{3324}",
        nfkc: "\u{30C0}\u{30FC}\u{30B9}",
        nfkd: "\u{30BF}\u{3099}\u{30FC}\u{30B9}",
    },
    NormalizationTest {
        source: "\u{3325}",
        nfc: "\u{3325}",
        nfd: "\u{3325}",
        nfkc: "\u{30C7}\u{30B7}",
        nfkd: "\u{30C6}\u{3099}\u{30B7}",
    },
    NormalizationTest {
        source: "\u{3326}",
        nfc: "\u{3326}",
        nfd: "\u{3326}",
        nfkc: "\u{30C9}\u{30EB}",
        nfkd: "\u{30C8}\u{3099}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3327}",
        nfc: "\u{3327}",
        nfd: "\u{3327}",
        nfkc: "\u{30C8}\u{30F3}",
        nfkd: "\u{30C8}\u{30F3}",
    },
    NormalizationTest {
        source: "\u{3328}",
        nfc: "\u{3328}",
        nfd: "\u{3328}",
        nfkc: "\u{30CA}\u{30CE}",
        nfkd: "\u{30CA}\u{30CE}",
    },
    NormalizationTest {
        source: "\u{3329}",
        nfc: "\u{3329}",
        nfd: "\u{3329}",
        nfkc: "\u{30CE}\u{30C3}\u{30C8}",
        nfkd: "\u{30CE}\u{30C3}\u{30C8}",
    },
    NormalizationTest {
        source: "\u{332A}",
        nfc: "\u{332A}",
        nfd: "\u{332A}",
        nfkc: "\u{30CF}\u{30A4}\u{30C4}",
        nfkd: "\u{30CF}\u{30A4}\u{30C4}",
    },
    NormalizationTest {
        source: "\u{332B}",
        nfc: "\u{332B}",
        nfd: "\u{332B}",
        nfkc: "\u{30D1}\u{30FC}\u{30BB}\u{30F3}\u{30C8}",
        nfkd: "\u{30CF}\u{309A}\u{30FC}\u{30BB}\u{30F3}\u{30C8}",
    },
    NormalizationTest {
        source: "\u{332C}",
        nfc: "\u{332C}",
        nfd: "\u{332C}",
        nfkc: "\u{30D1}\u{30FC}\u{30C4}",
        nfkd: "\u{30CF}\u{309A}\u{30FC}\u{30C4}",
    },
    NormalizationTest {
        source: "\u{332D}",
        nfc: "\u{332D}",
        nfd: "\u{332D}",
        nfkc: "\u{30D0}\u{30FC}\u{30EC}\u{30EB}",
        nfkd: "\u{30CF}\u{3099}\u{30FC}\u{30EC}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{332E}",
        nfc: "\u{332E}",
        nfd: "\u{332E}",
        nfkc: "\u{30D4}\u{30A2}\u{30B9}\u{30C8}\u{30EB}",
        nfkd: "\u{30D2}\u{309A}\u{30A2}\u{30B9}\u{30C8}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{332F}",
        nfc: "\u{332F}",
        nfd: "\u{332F}",
        nfkc: "\u{30D4}\u{30AF}\u{30EB}",
        nfkd: "\u{30D2}\u{309A}\u{30AF}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3330}",
        nfc: "\u{3330}",
        nfd: "\u{3330}",
        nfkc: "\u{30D4}\u{30B3}",
        nfkd: "\u{30D2}\u{309A}\u{30B3}",
    },
    NormalizationTest {
        source: "\u{3331}",
        nfc: "\u{3331}",
        nfd: "\u{3331}",
        nfkc: "\u{30D3}\u{30EB}",
        nfkd: "\u{30D2}\u{3099}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3332}",
        nfc: "\u{3332}",
        nfd: "\u{3332}",
        nfkc: "\u{30D5}\u{30A1}\u{30E9}\u{30C3}\u{30C9}",
        nfkd: "\u{30D5}\u{30A1}\u{30E9}\u{30C3}\u{30C8}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3333}",
        nfc: "\u{3333}",
        nfd: "\u{3333}",
        nfkc: "\u{30D5}\u{30A3}\u{30FC}\u{30C8}",
        nfkd: "\u{30D5}\u{30A3}\u{30FC}\u{30C8}",
    },
    NormalizationTest {
        source: "\u{3334}",
        nfc: "\u{3334}",
        nfd: "\u{3334}",
        nfkc: "\u{30D6}\u{30C3}\u{30B7}\u{30A7}\u{30EB}",
        nfkd: "\u{30D5}\u{3099}\u{30C3}\u{30B7}\u{30A7}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3335}",
        nfc: "\u{3335}",
        nfd: "\u{3335}",
        nfkc: "\u{30D5}\u{30E9}\u{30F3}",
        nfkd: "\u{30D5}\u{30E9}\u{30F3}",
    },
    NormalizationTest {
        source: "\u{3336}",
        nfc: "\u{3336}",
        nfd: "\u{3336}",
        nfkc: "\u{30D8}\u{30AF}\u{30BF}\u{30FC}\u{30EB}",
        nfkd: "\u{30D8}\u{30AF}\u{30BF}\u{30FC}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3337}",
        nfc: "\u{3337}",
        nfd: "\u{3337}",
        nfkc: "\u{30DA}\u{30BD}",
        nfkd: "\u{30D8}\u{309A}\u{30BD}",
    },
    NormalizationTest {
        source: "\u{3338}",
        nfc: "\u{3338}",
        nfd: "\u{3338}",
        nfkc: "\u{30DA}\u{30CB}\u{30D2}",
        nfkd: "\u{30D8}\u{309A}\u{30CB}\u{30D2}",
    },
    NormalizationTest {
        source: "\u{3339}",
        nfc: "\u{3339}",
        nfd: "\u{3339}",
        nfkc: "\u{30D8}\u{30EB}\u{30C4}",
        nfkd: "\u{30D8}\u{30EB}\u{30C4}",
    },
    NormalizationTest {
        source: "\u{333A}",
        nfc: "\u{333A}",
        nfd: "\u{333A}",
        nfkc: "\u{30DA}\u{30F3}\u{30B9}",
        nfkd: "\u{30D8}\u{309A}\u{30F3}\u{30B9}",
    },
    NormalizationTest {
        source: "\u{333B}",
        nfc: "\u{333B}",
        nfd: "\u{333B}",
        nfkc: "\u{30DA}\u{30FC}\u{30B8}",
        nfkd: "\u{30D8}\u{309A}\u{30FC}\u{30B7}\u{3099}",
    },
    NormalizationTest {
        source: "\u{333C}",
        nfc: "\u{333C}",
        nfd: "\u{333C}",
        nfkc: "\u{30D9}\u{30FC}\u{30BF}",
        nfkd: "\u{30D8}\u{3099}\u{30FC}\u{30BF}",
    },
    NormalizationTest {
        source: "\u{333D}",
        nfc: "\u{333D}",
        nfd: "\u{333D}",
        nfkc: "\u{30DD}\u{30A4}\u{30F3}\u{30C8}",
        nfkd: "\u{30DB}\u{309A}\u{30A4}\u{30F3}\u{30C8}",
    },
    NormalizationTest {
        source: "\u{333E}",
        nfc: "\u{333E}",
        nfd: "\u{333E}",
        nfkc: "\u{30DC}\u{30EB}\u{30C8}",
        nfkd: "\u{30DB}\u{3099}\u{30EB}\u{30C8}",
    },
    NormalizationTest {
        source: "\u{333F}",
        nfc: "\u{333F}",
        nfd: "\u{333F}",
        nfkc: "\u{30DB}\u{30F3}",
        nfkd: "\u{30DB}\u{30F3}",
    },
    NormalizationTest {
        source: "\u{3340}",
        nfc: "\u{3340}",
        nfd: "\u{3340}",
        nfkc: "\u{30DD}\u{30F3}\u{30C9}",
        nfkd: "\u{30DB}\u{309A}\u{30F3}\u{30C8}\u{3099}",
    },
    NormalizationTest {
        source: "\u{3341}",
        nfc: "\u{3341}",
        nfd: "\u{3341}",
        nfkc: "\u{30DB}\u{30FC}\u{30EB}",
        nfkd: "\u{30DB}\u{30FC}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3342}",
        nfc: "\u{3342}",
        nfd: "\u{3342}",
        nfkc: "\u{30DB}\u{30FC}\u{30F3}",
        nfkd: "\u{30DB}\u{30FC}\u{30F3}",
    },
    NormalizationTest {
        source: "\u{3343}",
        nfc: "\u{3343}",
        nfd: "\u{3343}",
        nfkc: "\u{30DE}\u{30A4}\u{30AF}\u{30ED}",
        nfkd: "\u{30DE}\u{30A4}\u{30AF}\u{30ED}",
    },
    NormalizationTest {
        source: "\u{3344}",
        nfc: "\u{3344}",
        nfd: "\u{3344}",
        nfkc: "\u{30DE}\u{30A4}\u{30EB}",
        nfkd: "\u{30DE}\u{30A4}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3345}",
        nfc: "\u{3345}",
        nfd: "\u{3345}",
        nfkc: "\u{30DE}\u{30C3}\u{30CF}",
        nfkd: "\u{30DE}\u{30C3}\u{30CF}",
    },
    NormalizationTest {
        source: "\u{3346}",
        nfc: "\u{3346}",
        nfd: "\u{3346}",
        nfkc: "\u{30DE}\u{30EB}\u{30AF}",
        nfkd: "\u{30DE}\u{30EB}\u{30AF}",
    },
    NormalizationTest {
        source: "\u{3347}",
        nfc: "\u{3347}",
        nfd: "\u{3347}",
        nfkc: "\u{30DE}\u{30F3}\u{30B7}\u{30E7}\u{30F3}",
        nfkd: "\u{30DE}\u{30F3}\u{30B7}\u{30E7}\u{30F3}",
    },
    NormalizationTest {
        source: "\u{3348}",
        nfc: "\u{3348}",
        nfd: "\u{3348}",
        nfkc: "\u{30DF}\u{30AF}\u{30ED}\u{30F3}",
        nfkd: "\u{30DF}\u{30AF}\u{30ED}\u{30F3}",
    },
    NormalizationTest {
        source: "\u{3349}",
        nfc: "\u{3349}",
        nfd: "\u{3349}",
        nfkc: "\u{30DF}\u{30EA}",
        nfkd: "\u{30DF}\u{30EA}",
    },
    NormalizationTest {
        source: "\u{334A}",
        nfc: "\u{334A}",
        nfd: "\u{334A}",
        nfkc: "\u{30DF}\u{30EA}\u{30D0}\u{30FC}\u{30EB}",
        nfkd: "\u{30DF}\u{30EA}\u{30CF}\u{3099}\u{30FC}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{334B}",
        nfc: "\u{334B}",
        nfd: "\u{334B}",
        nfkc: "\u{30E1}\u{30AC}",
        nfkd: "\u{30E1}\u{30AB}\u{3099}",
    },
    NormalizationTest {
        source: "\u{334C}",
        nfc: "\u{334C}",
        nfd: "\u{334C}",
        nfkc: "\u{30E1}\u{30AC}\u{30C8}\u{30F3}",
        nfkd: "\u{30E1}\u{30AB}\u{3099}\u{30C8}\u{30F3}",
    },
    NormalizationTest {
        source: "\u{334D}",
        nfc: "\u{334D}",
        nfd: "\u{334D}",
        nfkc: "\u{30E1}\u{30FC}\u{30C8}\u{30EB}",
        nfkd: "\u{30E1}\u{30FC}\u{30C8}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{334E}",
        nfc: "\u{334E}",
        nfd: "\u{334E}",
        nfkc: "\u{30E4}\u{30FC}\u{30C9}",
        nfkd: "\u{30E4}\u{30FC}\u{30C8}\u{3099}",
    },
    NormalizationTest {
        source: "\u{334F}",
        nfc: "\u{334F}",
        nfd: "\u{334F}",
        nfkc: "\u{30E4}\u{30FC}\u{30EB}",
        nfkd: "\u{30E4}\u{30FC}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3350}",
        nfc: "\u{3350}",
        nfd: "\u{3350}",
        nfkc: "\u{30E6}\u{30A2}\u{30F3}",
        nfkd: "\u{30E6}\u{30A2}\u{30F3}",
    },
    NormalizationTest {
        source: "\u{3351}",
        nfc: "\u{3351}",
        nfd: "\u{3351}",
        nfkc: "\u{30EA}\u{30C3}\u{30C8}\u{30EB}",
        nfkd: "\u{30EA}\u{30C3}\u{30C8}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3352}",
        nfc: "\u{3352}",
        nfd: "\u{3352}",
        nfkc: "\u{30EA}\u{30E9}",
        nfkd: "\u{30EA}\u{30E9}",
    },
    NormalizationTest {
        source: "\u{3353}",
        nfc: "\u{3353}",
        nfd: "\u{3353}",
        nfkc: "\u{30EB}\u{30D4}\u{30FC}",
        nfkd: "\u{30EB}\u{30D2}\u{309A}\u{30FC}",
    },
    NormalizationTest {
        source: "\u{3354}",
        nfc: "\u{3354}",
        nfd: "\u{3354}",
        nfkc: "\u{30EB}\u{30FC}\u{30D6}\u{30EB}",
        nfkd: "\u{30EB}\u{30FC}\u{30D5}\u{3099}\u{30EB}",
    },
    NormalizationTest {
        source: "\u{3355}",
        nfc: "\u{3355}",
        nfd: "\u{3355}",
        nfkc: "\u{30EC}\u{30E0}",
        nfkd: "\u{30EC}\u{30E0}",
    },
    NormalizationTest {
        source: "\u{3356}",
        nfc: "\u{3356}",
        nfd: "\u{3356}",
        nfkc: "\u{30EC}\u{30F3}\u{30C8}\u{30B2}\u{30F3}",
        nfkd: "\u{30EC}\u{30F3}\u{30C8}\u{30B1}\u{3099}\u{30F3}",
    },
    NormalizationTest {
        source: "\u{3357}",
        nfc: "\u{3357}",
        nfd: "\u{3357}",
        nfkc: "\u{30EF}\u{30C3}\u{30C8}",
        nfkd: "\u{30EF}\u{30C3}\u{30C8}",
    },
    NormalizationTest {
        source: "\u{3358}",
        nfc: "\u{3358}",
        nfd: "\u{3358}",
        nfkc: "\u{0030}\u{70B9}",
        nfkd: "\u{0030}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3359}",
        nfc: "\u{3359}",
        nfd: "\u{3359}",
        nfkc: "\u{0031}\u{70B9}",
        nfkd: "\u{0031}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{335A}",
        nfc: "\u{335A}",
        nfd: "\u{335A}",
        nfkc: "\u{0032}\u{70B9}",
        nfkd: "\u{0032}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{335B}",
        nfc: "\u{335B}",
        nfd: "\u{335B}",
        nfkc: "\u{0033}\u{70B9}",
        nfkd: "\u{0033}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{335C}",
        nfc: "\u{335C}",
        nfd: "\u{335C}",
        nfkc: "\u{0034}\u{70B9}",
        nfkd: "\u{0034}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{335D}",
        nfc: "\u{335D}",
        nfd: "\u{335D}",
        nfkc: "\u{0035}\u{70B9}",
        nfkd: "\u{0035}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{335E}",
        nfc: "\u{335E}",
        nfd: "\u{335E}",
        nfkc: "\u{0036}\u{70B9}",
        nfkd: "\u{0036}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{335F}",
        nfc: "\u{335F}",
        nfd: "\u{335F}",
        nfkc: "\u{0037}\u{70B9}",
        nfkd: "\u{0037}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3360}",
        nfc: "\u{3360}",
        nfd: "\u{3360}",
        nfkc: "\u{0038}\u{70B9}",
        nfkd: "\u{0038}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3361}",
        nfc: "\u{3361}",
        nfd: "\u{3361}",
        nfkc: "\u{0039}\u{70B9}",
        nfkd: "\u{0039}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3362}",
        nfc: "\u{3362}",
        nfd: "\u{3362}",
        nfkc: "\u{0031}\u{0030}\u{70B9}",
        nfkd: "\u{0031}\u{0030}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3363}",
        nfc: "\u{3363}",
        nfd: "\u{3363}",
        nfkc: "\u{0031}\u{0031}\u{70B9}",
        nfkd: "\u{0031}\u{0031}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3364}",
        nfc: "\u{3364}",
        nfd: "\u{3364}",
        nfkc: "\u{0031}\u{0032}\u{70B9}",
        nfkd: "\u{0031}\u{0032}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3365}",
        nfc: "\u{3365}",
        nfd: "\u{3365}",
        nfkc: "\u{0031}\u{0033}\u{70B9}",
        nfkd: "\u{0031}\u{0033}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3366}",
        nfc: "\u{3366}",
        nfd: "\u{3366}",
        nfkc: "\u{0031}\u{0034}\u{70B9}",
        nfkd: "\u{0031}\u{0034}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3367}",
        nfc: "\u{3367}",
        nfd: "\u{3367}",
        nfkc: "\u{0031}\u{0035}\u{70B9}",
        nfkd: "\u{0031}\u{0035}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3368}",
        nfc: "\u{3368}",
        nfd: "\u{3368}",
        nfkc: "\u{0031}\u{0036}\u{70B9}",
        nfkd: "\u{0031}\u{0036}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3369}",
        nfc: "\u{3369}",
        nfd: "\u{3369}",
        nfkc: "\u{0031}\u{0037}\u{70B9}",
        nfkd: "\u{0031}\u{0037}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{336A}",
        nfc: "\u{336A}",
        nfd: "\u{336A}",
        nfkc: "\u{0031}\u{0038}\u{70B9}",
        nfkd: "\u{0031}\u{0038}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{336B}",
        nfc: "\u{336B}",
        nfd: "\u{336B}",
        nfkc: "\u{0031}\u{0039}\u{70B9}",
        nfkd: "\u{0031}\u{0039}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{336C}",
        nfc: "\u{336C}",
        nfd: "\u{336C}",
        nfkc: "\u{0032}\u{0030}\u{70B9}",
        nfkd: "\u{0032}\u{0030}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{336D}",
        nfc: "\u{336D}",
        nfd: "\u{336D}",
        nfkc: "\u{0032}\u{0031}\u{70B9}",
        nfkd: "\u{0032}\u{0031}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{336E}",
        nfc: "\u{336E}",
        nfd: "\u{336E}",
        nfkc: "\u{0032}\u{0032}\u{70B9}",
        nfkd: "\u{0032}\u{0032}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{336F}",
        nfc: "\u{336F}",
        nfd: "\u{336F}",
        nfkc: "\u{0032}\u{0033}\u{70B9}",
        nfkd: "\u{0032}\u{0033}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3370}",
        nfc: "\u{3370}",
        nfd: "\u{3370}",
        nfkc: "\u{0032}\u{0034}\u{70B9}",
        nfkd: "\u{0032}\u{0034}\u{70B9}",
    },
    NormalizationTest {
        source: "\u{3371}",
        nfc: "\u{3371}",
        nfd: "\u{3371}",
        nfkc: "\u{0068}\u{0050}\u{0061}",
        nfkd: "\u{0068}\u{0050}\u{0061}",
    },
    NormalizationTest {
        source: "\u{3372}",
        nfc: "\u{3372}",
        nfd: "\u{3372}",
        nfkc: "\u{0064}\u{0061}",
        nfkd: "\u{0064}\u{0061}",
    },
    NormalizationTest {
        source: "\u{3373}",
        nfc: "\u{3373}",
        nfd: "\u{3373}",
        nfkc: "\u{0041}\u{0055}",
        nfkd: "\u{0041}\u{0055}",
    },
    NormalizationTest {
        source: "\u{3374}",
        nfc: "\u{3374}",
        nfd: "\u{3374}",
        nfkc: "\u{0062}\u{0061}\u{0072}",
        nfkd: "\u{0062}\u{0061}\u{0072}",
    },
    NormalizationTest {
        source: "\u{3375}",
        nfc: "\u{3375}",
        nfd: "\u{3375}",
        nfkc: "\u{006F}\u{0056}",
        nfkd: "\u{006F}\u{0056}",
    },
    NormalizationTest {
        source: "\u{3376}",
        nfc: "\u{3376}",
        nfd: "\u{3376}",
        nfkc: "\u{0070}\u{0063}",
        nfkd: "\u{0070}\u{0063}",
    },
    NormalizationTest {
        source: "\u{3377}",
        nfc: "\u{3377}",
        nfd: "\u{3377}",
        nfkc: "\u{0064}\u{006D}",
        nfkd: "\u{0064}\u{006D}",
    },
    NormalizationTest {
        source: "\u{3378}",
        nfc: "\u{3378}",
        nfd: "\u{3378}",
        nfkc: "\u{0064}\u{006D}\u{0032}",
        nfkd: "\u{0064}\u{006D}\u{0032}",
    },
    NormalizationTest {
        source: "\u{3379}",
        nfc: "\u{3379}",
        nfd: "\u{3379}",
        nfkc: "\u{0064}\u{006D}\u{0033}",
        nfkd: "\u{0064}\u{006D}\u{0033}",
    },
    NormalizationTest {
        source: "\u{337A}",
        nfc: "\u{337A}",
        nfd: "\u{337A}",
        nfkc: "\u{0049}\u{0055}",
        nfkd: "\u{0049}\u{0055}",
    },
    NormalizationTest {
        source: "\u{337B}",
        nfc: "\u{337B}",
        nfd: "\u{337B}",
        nfkc: "\u{5E73}\u{6210}",
        nfkd: "\u{5E73}\u{6210}",
    },
    NormalizationTest {
        source: "\u{337C}",
        nfc: "\u{337C}",
        nfd: "\u{337C}",
        nfkc: "\u{662D}\u{548C}",
        nfkd: "\u{662D}\u{548C}",
    },
    NormalizationTest {
        source: "\u{337D}",
        nfc: "\u{337D}",
        nfd: "\u{337D}",
        nfkc: "\u{5927}\u{6B63}",
        nfkd: "\u{5927}\u{6B63}",
    },
    NormalizationTest {
        source: "\u{337E}",
        nfc: "\u{337E}",
        nfd: "\u{337E}",
        nfkc: "\u{660E}\u{6CBB}",
        nfkd: "\u{660E}\u{6CBB}",
    },
    NormalizationTest {
        source: "\u{337F}",
        nfc: "\u{337F}",
        nfd: "\u{337F}",
        nfkc: "\u{682A}\u{5F0F}\u{4F1A}\u{793E}",
        nfkd: "\u{682A}\u{5F0F}\u{4F1A}\u{793E}",
    },
    NormalizationTest {
        source: "\u{3380}",
        nfc: "\u{3380}",
        nfd: "\u{3380}",
        nfkc: "\u{0070}\u{0041}",
        nfkd: "\u{0070}\u{0041}",
    },
    NormalizationTest {
        source: "\u{3381}",
        nfc: "\u{3381}",
        nfd: "\u{3381}",
        nfkc: "\u{006E}\u{0041}",
        nfkd: "\u{006E}\u{0041}",
    },
    NormalizationTest {
        source: "\u{3382}",
        nfc: "\u{3382}",
        nfd: "\u{3382}",
        nfkc: "\u{03BC}\u{0041}",
        nfkd: "\u{03BC}\u{0041}",
    },
    NormalizationTest {
        source: "\u{3383}",
        nfc: "\u{3383}",
        nfd: "\u{3383}",
        nfkc: "\u{006D}\u{0041}",
        nfkd: "\u{006D}\u{0041}",
    },
    NormalizationTest {
        source: "\u{3384}",
        nfc: "\u{3384}",
        nfd: "\u{3384}",
        nfkc: "\u{006B}\u{0041}",
        nfkd: "\u{006B}\u{0041}",
    },
    NormalizationTest {
        source: "\u{3385}",
        nfc: "\u{3385}",
        nfd: "\u{3385}",
        nfkc: "\u{004B}\u{0042}",
        nfkd: "\u{004B}\u{0042}",
    },
    NormalizationTest {
        source: "\u{3386}",
        nfc: "\u{3386}",
        nfd: "\u{3386}",
        nfkc: "\u{004D}\u{0042}",
        nfkd: "\u{004D}\u{0042}",
    },
    NormalizationTest {
        source: "\u{3387}",
        nfc: "\u{3387}",
        nfd: "\u{3387}",
        nfkc: "\u{0047}\u{0042}",
        nfkd: "\u{0047}\u{0042}",
    },
    NormalizationTest {
        source: "\u{3388}",
        nfc: "\u{3388}",
        nfd: "\u{3388}",
        nfkc: "\u{0063}\u{0061}\u{006C}",
        nfkd: "\u{0063}\u{0061}\u{006C}",
    },
    NormalizationTest {
        source: "\u{3389}",
        nfc: "\u{3389}",
        nfd: "\u{3389}",
        nfkc: "\u{006B}\u{0063}\u{0061}\u{006C}",
        nfkd: "\u{006B}\u{0063}\u{0061}\u{006C}",
    },
    NormalizationTest {
        source: "\u{338A}",
        nfc: "\u{338A}",
        nfd: "\u{338A}",
        nfkc: "\u{0070}\u{0046}",
        nfkd: "\u{0070}\u{0046}",
    },
    NormalizationTest {
        source: "\u{338B}",
        nfc: "\u{338B}",
        nfd: "\u{338B}",
        nfkc: "\u{006E}\u{0046}",
        nfkd: "\u{006E}\u{0046}",
    },
    NormalizationTest {
        source: "\u{338C}",
        nfc: "\u{338C}",
        nfd: "\u{338C}",
        nfkc: "\u{03BC}\u{0046}",
        nfkd: "\u{03BC}\u{0046}",
    },
    NormalizationTest {
        source: "\u{338D}",
        nfc: "\u{338D}",
        nfd: "\u{338D}",
        nfkc: "\u{03BC}\u{0067}",
        nfkd: "\u{03BC}\u{0067}",
    },
    NormalizationTest {
        source: "\u{338E}",
        nfc: "\u{338E}",
        nfd: "\u{338E}",
        nfkc: "\u{006D}\u{0067}",
        nfkd: "\u{006D}\u{0067}",
    },
    NormalizationTest {
        source: "\u{338F}",
        nfc: "\u{338F}",
        nfd: "\u{338F}",
        nfkc: "\u{006B}\u{0067}",
        nfkd: "\u{006B}\u{0067}",
    },
    NormalizationTest {
        source: "\u{3390}",
        nfc: "\u{3390}",
        nfd: "\u{3390}",
        nfkc: "\u{0048}\u{007A}",
        nfkd: "\u{0048}\u{007A}",
    },
    NormalizationTest {
        source: "\u{3391}",
        nfc: "\u{3391}",
        nfd: "\u{3391}",
        nfkc: "\u{006B}\u{0048}\u{007A}",
        nfkd: "\u{006B}\u{0048}\u{007A}",
    },
    NormalizationTest {
        source: "\u{3392}",
        nfc: "\u{3392}",
        nfd: "\u{3392}",
        nfkc: "\u{004D}\u{0048}\u{007A}",
        nfkd: "\u{004D}\u{0048}\u{007A}",
    },
    NormalizationTest {
        source: "\u{3393}",
        nfc: "\u{3393}",
        nfd: "\u{3393}",
        nfkc: "\u{0047}\u{0048}\u{007A}",
        nfkd: "\u{0047}\u{0048}\u{007A}",
    },
    NormalizationTest {
        source: "\u{3394}",
        nfc: "\u{3394}",
        nfd: "\u{3394}",
        nfkc: "\u{0054}\u{0048}\u{007A}",
        nfkd: "\u{0054}\u{0048}\u{007A}",
    },
    NormalizationTest {
        source: "\u{3395}",
        nfc: "\u{3395}",
        nfd: "\u{3395}",
        nfkc: "\u{03BC}\u{006C}",
        nfkd: "\u{03BC}\u{006C}",
    },
    NormalizationTest {
        source: "\u{3396}",
        nfc: "\u{3396}",
        nfd: "\u{3396}",
        nfkc: "\u{006D}\u{006C}",
        nfkd: "\u{006D}\u{006C}",
    },
    NormalizationTest {
        source: "\u{3397}",
        nfc: "\u{3397}",
        nfd: "\u{3397}",
        nfkc: "\u{0064}\u{006C}",
        nfkd: "\u{0064}\u{006C}",
    },
    NormalizationTest {
        source: "\u{3398}",
        nfc: "\u{3398}",
        nfd: "\u{3398}",
        nfkc: "\u{006B}\u{006C}",
        nfkd: "\u{006B}\u{006C}",
    },
    NormalizationTest {
        source: "\u{3399}",
        nfc: "\u{3399}",
        nfd: "\u{3399}",
        nfkc: "\u{0066}\u{006D}",
        nfkd: "\u{0066}\u{006D}",
    },
    NormalizationTest {
        source: "\u{339A}",
        nfc: "\u{339A}",
        nfd: "\u{339A}",
        nfkc: "\u{006E}\u{006D}",
        nfkd: "\u{006E}\u{006D}",
    },
    NormalizationTest {
        source: "\u{339B}",
        nfc: "\u{339B}",
        nfd: "\u{339B}",
        nfkc: "\u{03BC}\u{006D}",
        nfkd: "\u{03BC}\u{006D}",
    },
    NormalizationTest {
        source: "\u{339C}",
        nfc: "\u{339C}",
        nfd: "\u{339C}",
        nfkc: "\u{006D}\u{006D}",
        nfkd: "\u{006D}\u{006D}",
    },
    NormalizationTest {
        source: "\u{339D}",
        nfc: "\u{339D}",
        nfd: "\u{339D}",
        nfkc: "\u{0063}\u{006D}",
        nfkd: "\u{0063}\u{006D}",
    },
    NormalizationTest {
        source: "\u{339E}",
        nfc: "\u{339E}",
        nfd: "\u{339E}",
        nfkc: "\u{006B}\u{006D}",
        nfkd: "\u{006B}\u{006D}",
    },
    NormalizationTest {
        source: "\u{339F}",
        nfc: "\u{339F}",
        nfd: "\u{339F}",
        nfkc: "\u{006D}\u{006D}\u{0032}",
        nfkd: "\u{006D}\u{006D}\u{0032}",
    },
    NormalizationTest {
        source: "\u{33A0}",
        nfc: "\u{33A0}",
        nfd: "\u{33A0}",
        nfkc: "\u{0063}\u{006D}\u{0032}",
        nfkd: "\u{0063}\u{006D}\u{0032}",
    },
    NormalizationTest {
        source: "\u{33A1}",
        nfc: "\u{33A1}",
        nfd: "\u{33A1}",
        nfkc: "\u{006D}\u{0032}",
        nfkd: "\u{006D}\u{0032}",
    },
    NormalizationTest {
        source: "\u{33A2}",
        nfc: "\u{33A2}",
        nfd: "\u{33A2}",
        nfkc: "\u{006B}\u{006D}\u{0032}",
        nfkd: "\u{006B}\u{006D}\u{0032}",
    },
    NormalizationTest {
        source: "\u{33A3}",
        nfc: "\u{33A3}",
        nfd: "\u{33A3}",
        nfkc: "\u{006D}\u{006D}\u{0033}",
        nfkd: "\u{006D}\u{006D}\u{0033}",
    },
    NormalizationTest {
        source: "\u{33A4}",
        nfc: "\u{33A4}",
        nfd: "\u{33A4}",
        nfkc: "\u{0063}\u{006D}\u{0033}",
        nfkd: "\u{0063}\u{006D}\u{0033}",
    },
    NormalizationTest {
        source: "\u{33A5}",
        nfc: "\u{33A5}",
        nfd: "\u{33A5}",
        nfkc: "\u{006D}\u{0033}",
        nfkd: "\u{006D}\u{0033}",
    },
    NormalizationTest {
        source: "\u{33A6}",
        nfc: "\u{33A6}",
        nfd: "\u{33A6}",
        nfkc: "\u{006B}\u{006D}\u{0033}",
        nfkd: "\u{006B}\u{006D}\u{0033}",
    },
    NormalizationTest {
        source: "\u{33A7}",
        nfc: "\u{33A7}",
        nfd: "\u{33A7}",
        nfkc: "\u{006D}\u{2215}\u{0073}",
        nfkd: "\u{006D}\u{2215}\u{0073}",
    },
    NormalizationTest {
        source: "\u{33A8}",
        nfc: "\u{33A8}",
        nfd: "\u{33A8}",
        nfkc: "\u{006D}\u{2215}\u{0073}\u{0032}",
        nfkd: "\u{006D}\u{2215}\u{0073}\u{0032}",
    },
    NormalizationTest {
        source: "\u{33A9}",
        nfc: "\u{33A9}",
        nfd: "\u{33A9}",
        nfkc: "\u{0050}\u{0061}",
        nfkd: "\u{0050}\u{0061}",
    },
    NormalizationTest {
        source: "\u{33AA}",
        nfc: "\u{33AA}",
        nfd: "\u{33AA}",
        nfkc: "\u{006B}\u{0050}\u{0061}",
        nfkd: "\u{006B}\u{0050}\u{0061}",
    },
    NormalizationTest {
        source: "\u{33AB}",
        nfc: "\u{33AB}",
        nfd: "\u{33AB}",
        nfkc: "\u{004D}\u{0050}\u{0061}",
        nfkd: "\u{004D}\u{0050}\u{0061}",
    },
    NormalizationTest {
        source: "\u{33AC}",
        nfc: "\u{33AC}",
        nfd: "\u{33AC}",
        nfkc: "\u{0047}\u{0050}\u{0061}",
        nfkd: "\u{0047}\u{0050}\u{0061}",
    },
    NormalizationTest {
        source: "\u{33AD}",
        nfc: "\u{33AD}",
        nfd: "\u{33AD}",
        nfkc: "\u{0072}\u{0061}\u{0064}",
        nfkd: "\u{0072}\u{0061}\u{0064}",
    },
    NormalizationTest {
        source: "\u{33AE}",
        nfc: "\u{33AE}",
        nfd: "\u{33AE}",
        nfkc: "\u{0072}\u{0061}\u{0064}\u{2215}\u{0073}",
        nfkd: "\u{0072}\u{0061}\u{0064}\u{2215}\u{0073}",
    },
    NormalizationTest {
        source: "\u{33AF}",
        nfc: "\u{33AF}",
        nfd: "\u{33AF}",
        nfkc: "\u{0072}\u{0061}\u{0064}\u{2215}\u{0073}\u{0032}",
        nfkd: "\u{0072}\u{0061}\u{0064}\u{2215}\u{0073}\u{0032}",
    },
    NormalizationTest {
        source: "\u{33B0}",
        nfc: "\u{33B0}",
        nfd: "\u{33B0}",
        nfkc: "\u{0070}\u{0073}",
        nfkd: "\u{0070}\u{0073}",
    },
    NormalizationTest {
        source: "\u{33B1}",
        nfc: "\u{33B1}",
        nfd: "\u{33B1}",
        nfkc: "\u{006E}\u{0073}",
        nfkd: "\u{006E}\u{0073}",
    },
    NormalizationTest {
        source: "\u{33B2}",
        nfc: "\u{33B2}",
        nfd: "\u{33B2}",
        nfkc: "\u{03BC}\u{0073}",
        nfkd: "\u{03BC}\u{0073}",
    },
    NormalizationTest {
        source: "\u{33B3}",
        nfc: "\u{33B3}",
        nfd: "\u{33B3}",
        nfkc: "\u{006D}\u{0073}",
        nfkd: "\u{006D}\u{0073}",
    },
    NormalizationTest {
        source: "\u{33B4}",
        nfc: "\u{33B4}",
        nfd: "\u{33B4}",
        nfkc: "\u{0070}\u{0056}",
        nfkd: "\u{0070}\u{0056}",
    },
    NormalizationTest {
        source: "\u{33B5}",
        nfc: "\u{33B5}",
        nfd: "\u{33B5}",
        nfkc: "\u{006E}\u{0056}",
        nfkd: "\u{006E}\u{0056}",
    },
    NormalizationTest {
        source: "\u{33B6}",
        nfc: "\u{33B6}",
        nfd: "\u{33B6}",
        nfkc: "\u{03BC}\u{0056}",
        nfkd: "\u{03BC}\u{0056}",
    },
    NormalizationTest {
        source: "\u{33B7}",
        nfc: "\u{33B7}",
        nfd: "\u{33B7}",
        nfkc: "\u{006D}\u{0056}",
        nfkd: "\u{006D}\u{0056}",
    },
    NormalizationTest {
        source: "\u{33B8}",
        nfc: "\u{33B8}",
        nfd: "\u{33B8}",
        nfkc: "\u{006B}\u{0056}",
        nfkd: "\u{006B}\u{0056}",
    },
    NormalizationTest {
        source: "\u{33B9}",
        nfc: "\u{33B9}",
        nfd: "\u{33B9}",
        nfkc: "\u{004D}\u{0056}",
        nfkd: "\u{004D}\u{0056}",
    },
    NormalizationTest {
        source: "\u{33BA}",
        nfc: "\u{33BA}",
        nfd: "\u{33BA}",
        nfkc: "\u{0070}\u{0057}",
        nfkd: "\u{0070}\u{0057}",
    },
    NormalizationTest {
        source: "\u{33BB}",
        nfc: "\u{33BB}",
        nfd: "\u{33BB}",
        nfkc: "\u{006E}\u{0057}",
        nfkd: "\u{006E}\u{0057}",
    },
    NormalizationTest {
        source: "\u{33BC}",
        nfc: "\u{33BC}",
        nfd: "\u{33BC}",
        nfkc: "\u{03BC}\u{0057}",
        nfkd: "\u{03BC}\u{0057}",
    },
    NormalizationTest {
        source: "\u{33BD}",
        nfc: "\u{33BD}",
        nfd: "\u{33BD}",
        nfkc: "\u{006D}\u{0057}",
        nfkd: "\u{006D}\u{0057}",
    },
    NormalizationTest {
        source: "\u{33BE}",
        nfc: "\u{33BE}",
        nfd: "\u{33BE}",
        nfkc: "\u{006B}\u{0057}",
        nfkd: "\u{006B}\u{0057}",
    },
    NormalizationTest {
        source: "\u{33BF}",
        nfc: "\u{33BF}",
        nfd: "\u{33BF}",
        nfkc: "\u{004D}\u{0057}",
        nfkd: "\u{004D}\u{0057}",
    },
    NormalizationTest {
        source: "\u{33C0}",
        nfc: "\u{33C0}",
        nfd: "\u{33C0}",
        nfkc: "\u{006B}\u{03A9}",
        nfkd: "\u{006B}\u{03A9}",
    },
    NormalizationTest {
        source: "\u{33C1}",
        nfc: "\u{33C1}",
        nfd: "\u{33C1}",
        nfkc: "\u{004D}\u{03A9}",
        nfkd: "\u{004D}\u{03A9}",
    },
    NormalizationTest {
        source: "\u{33C2}",
        nfc: "\u{33C2}",
        nfd: "\u{33C2}",
        nfkc: "\u{0061}\u{002E}\u{006D}\u{002E}",
        nfkd: "\u{0061}\u{002E}\u{006D}\u{002E}",
    },
    NormalizationTest {
        source: "\u{33C3}",
        nfc: "\u{33C3}",
        nfd: "\u{33C3}",
        nfkc: "\u{0042}\u{0071}",
        nfkd: "\u{0042}\u{0071}",
    },
    NormalizationTest {
        source: "\u{33C4}",
        nfc: "\u{33C4}",
        nfd: "\u{33C4}",
        nfkc: "\u{0063}\u{0063}",
        nfkd: "\u{0063}\u{0063}",
    },
    NormalizationTest {
        source: "\u{33C5}",
        nfc: "\u{33C5}",
        nfd: "\u{33C5}",
        nfkc: "\u{0063}\u{0064}",
        nfkd: "\u{0063}\u{0064}",
    },
    NormalizationTest {
        source: "\u{33C6}",
        nfc: "\u{33C6}",
        nfd: "\u{33C6}",
        nfkc: "\u{0043}\u{2215}\u{006B}\u{0067}",
        nfkd: "\u{0043}\u{2215}\u{006B}\u{0067}",
    },
    NormalizationTest {
        source: "\u{33C7}",
        nfc: "\u{33C7}",
        nfd: "\u{33C7}",
        nfkc: "\u{0043}\u{006F}\u{002E}",
        nfkd: "\u{0043}\u{006F}\u{002E}",
    },
    NormalizationTest {
        source: "\u{33C8}",
        nfc: "\u{33C8}",
        nfd: "\u{33C8}",
        nfkc: "\u{0064}\u{0042}",
        nfkd: "\u{0064}\u{0042}",
    },
    NormalizationTest {
        source: "\u{33C9}",
        nfc: "\u{33C9}",
        nfd: "\u{33C9}",
        nfkc: "\u{0047}\u{0079}",
        nfkd: "\u{0047}\u{0079}",
    },
    NormalizationTest {
        source: "\u{33CA}",
        nfc: "\u{33CA}",
        nfd: "\u{33CA}",
        nfkc: "\u{0068}\u{0061}",
        nfkd: "\u{0068}\u{0061}",
    },
    NormalizationTest {
        source: "\u{33CB}",
        nfc: "\u{33CB}",
        nfd: "\u{33CB}",
        nfkc: "\u{0048}\u{0050}",
        nfkd: "\u{0048}\u{0050}",
    },
    NormalizationTest {
        source: "\u{33CC}",
        nfc: "\u{33CC}",
        nfd: "\u{33CC}",
        nfkc: "\u{0069}\u{006E}",
        nfkd: "\u{0069}\u{006E}",
    },
    NormalizationTest {
        source: "\u{33CD}",
        nfc: "\u{33CD}",
        nfd: "\u{33CD}",
        nfkc: "\u{004B}\u{004B}",
        nfkd: "\u{004B}\u{004B}",
    },
    NormalizationTest {
        source: "\u{33CE}",
        nfc: "\u{33CE}",
        nfd: "\u{33CE}",
        nfkc: "\u{004B}\u{004D}",
        nfkd: "\u{004B}\u{004D}",
    },
    NormalizationTest {
        source: "\u{33CF}",
        nfc: "\u{33CF}",
        nfd: "\u{33CF}",
        nfkc: "\u{006B}\u{0074}",
        nfkd: "\u{006B}\u{0074}",
    },
    NormalizationTest {
        source: "\u{33D0}",
        nfc: "\u{33D0}",
        nfd: "\u{33D0}",
        nfkc: "\u{006C}\u{006D}",
        nfkd: "\u{006C}\u{006D}",
    },
    NormalizationTest {
        source: "\u{33D1}",
        nfc: "\u{33D1}",
        nfd: "\u{33D1}",
        nfkc: "\u{006C}\u{006E}",
        nfkd: "\u{006C}\u{006E}",
    },
    NormalizationTest {
        source: "\u{33D2}",
        nfc: "\u{33D2}",
        nfd: "\u{33D2}",
        nfkc: "\u{006C}\u{006F}\u{0067}",
        nfkd: "\u{006C}\u{006F}\u{0067}",
    },
    NormalizationTest {
        source: "\u{33D3}",
        nfc: "\u{33D3}",
        nfd: "\u{33D3}",
        nfkc: "\u{006C}\u{0078}",
        nfkd: "\u{006C}\u{0078}",
    },
    NormalizationTest {
        source: "\u{33D4}",
        nfc: "\u{33D4}",
        nfd: "\u{33D4}",
        nfkc: "\u{006D}\u{0062}",
        nfkd: "\u{006D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{33D5}",
        nfc: "\u{33D5}",
        nfd: "\u{33D5}",
        nfkc: "\u{006D}\u{0069}\u{006C}",
        nfkd: "\u{006D}\u{0069}\u{006C}",
    },
    NormalizationTest {
        source: "\u{33D6}",
        nfc: "\u{33D6}",
        nfd: "\u{33D6}",
        nfkc: "\u{006D}\u{006F}\u{006C}",
        nfkd: "\u{006D}\u{006F}\u{006C}",
    },
    NormalizationTest {
        source: "\u{33D7}",
        nfc: "\u{33D7}",
        nfd: "\u{33D7}",
        nfkc: "\u{0050}\u{0048}",
        nfkd: "\u{0050}\u{0048}",
    },
    NormalizationTest {
        source: "\u{33D8}",
        nfc: "\u{33D8}",
        nfd: "\u{33D8}",
        nfkc: "\u{0070}\u{002E}\u{006D}\u{002E}",
        nfkd: "\u{0070}\u{002E}\u{006D}\u{002E}",
    },
    NormalizationTest {
        source: "\u{33D9}",
        nfc: "\u{33D9}",
        nfd: "\u{33D9}",
        nfkc: "\u{0050}\u{0050}\u{004D}",
        nfkd: "\u{0050}\u{0050}\u{004D}",
    },
    NormalizationTest {
        source: "\u{33DA}",
        nfc: "\u{33DA}",
        nfd: "\u{33DA}",
        nfkc: "\u{0050}\u{0052}",
        nfkd: "\u{0050}\u{0052}",
    },
    NormalizationTest {
        source: "\u{33DB}",
        nfc: "\u{33DB}",
        nfd: "\u{33DB}",
        nfkc: "\u{0073}\u{0072}",
        nfkd: "\u{0073}\u{0072}",
    },
    NormalizationTest {
        source: "\u{33DC}",
        nfc: "\u{33DC}",
        nfd: "\u{33DC}",
        nfkc: "\u{0053}\u{0076}",
        nfkd: "\u{0053}\u{0076}",
    },
    NormalizationTest {
        source: "\u{33DD}",
        nfc: "\u{33DD}",
        nfd: "\u{33DD}",
        nfkc: "\u{0057}\u{0062}",
        nfkd: "\u{0057}\u{0062}",
    },
    NormalizationTest {
        source: "\u{33DE}",
        nfc: "\u{33DE}",
        nfd: "\u{33DE}",
        nfkc: "\u{0056}\u{2215}\u{006D}",
        nfkd: "\u{0056}\u{2215}\u{006D}",
    },
    NormalizationTest {
        source: "\u{33DF}",
        nfc: "\u{33DF}",
        nfd: "\u{33DF}",
        nfkc: "\u{0041}\u{2215}\u{006D}",
        nfkd: "\u{0041}\u{2215}\u{006D}",
    },
    NormalizationTest {
        source: "\u{33E0}",
        nfc: "\u{33E0}",
        nfd: "\u{33E0}",
        nfkc: "\u{0031}\u{65E5}",
        nfkd: "\u{0031}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33E1}",
        nfc: "\u{33E1}",
        nfd: "\u{33E1}",
        nfkc: "\u{0032}\u{65E5}",
        nfkd: "\u{0032}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33E2}",
        nfc: "\u{33E2}",
        nfd: "\u{33E2}",
        nfkc: "\u{0033}\u{65E5}",
        nfkd: "\u{0033}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33E3}",
        nfc: "\u{33E3}",
        nfd: "\u{33E3}",
        nfkc: "\u{0034}\u{65E5}",
        nfkd: "\u{0034}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33E4}",
        nfc: "\u{33E4}",
        nfd: "\u{33E4}",
        nfkc: "\u{0035}\u{65E5}",
        nfkd: "\u{0035}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33E5}",
        nfc: "\u{33E5}",
        nfd: "\u{33E5}",
        nfkc: "\u{0036}\u{65E5}",
        nfkd: "\u{0036}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33E6}",
        nfc: "\u{33E6}",
        nfd: "\u{33E6}",
        nfkc: "\u{0037}\u{65E5}",
        nfkd: "\u{0037}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33E7}",
        nfc: "\u{33E7}",
        nfd: "\u{33E7}",
        nfkc: "\u{0038}\u{65E5}",
        nfkd: "\u{0038}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33E8}",
        nfc: "\u{33E8}",
        nfd: "\u{33E8}",
        nfkc: "\u{0039}\u{65E5}",
        nfkd: "\u{0039}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33E9}",
        nfc: "\u{33E9}",
        nfd: "\u{33E9}",
        nfkc: "\u{0031}\u{0030}\u{65E5}",
        nfkd: "\u{0031}\u{0030}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33EA}",
        nfc: "\u{33EA}",
        nfd: "\u{33EA}",
        nfkc: "\u{0031}\u{0031}\u{65E5}",
        nfkd: "\u{0031}\u{0031}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33EB}",
        nfc: "\u{33EB}",
        nfd: "\u{33EB}",
        nfkc: "\u{0031}\u{0032}\u{65E5}",
        nfkd: "\u{0031}\u{0032}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33EC}",
        nfc: "\u{33EC}",
        nfd: "\u{33EC}",
        nfkc: "\u{0031}\u{0033}\u{65E5}",
        nfkd: "\u{0031}\u{0033}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33ED}",
        nfc: "\u{33ED}",
        nfd: "\u{33ED}",
        nfkc: "\u{0031}\u{0034}\u{65E5}",
        nfkd: "\u{0031}\u{0034}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33EE}",
        nfc: "\u{33EE}",
        nfd: "\u{33EE}",
        nfkc: "\u{0031}\u{0035}\u{65E5}",
        nfkd: "\u{0031}\u{0035}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33EF}",
        nfc: "\u{33EF}",
        nfd: "\u{33EF}",
        nfkc: "\u{0031}\u{0036}\u{65E5}",
        nfkd: "\u{0031}\u{0036}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33F0}",
        nfc: "\u{33F0}",
        nfd: "\u{33F0}",
        nfkc: "\u{0031}\u{0037}\u{65E5}",
        nfkd: "\u{0031}\u{0037}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33F1}",
        nfc: "\u{33F1}",
        nfd: "\u{33F1}",
        nfkc: "\u{0031}\u{0038}\u{65E5}",
        nfkd: "\u{0031}\u{0038}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33F2}",
        nfc: "\u{33F2}",
        nfd: "\u{33F2}",
        nfkc: "\u{0031}\u{0039}\u{65E5}",
        nfkd: "\u{0031}\u{0039}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33F3}",
        nfc: "\u{33F3}",
        nfd: "\u{33F3}",
        nfkc: "\u{0032}\u{0030}\u{65E5}",
        nfkd: "\u{0032}\u{0030}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33F4}",
        nfc: "\u{33F4}",
        nfd: "\u{33F4}",
        nfkc: "\u{0032}\u{0031}\u{65E5}",
        nfkd: "\u{0032}\u{0031}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33F5}",
        nfc: "\u{33F5}",
        nfd: "\u{33F5}",
        nfkc: "\u{0032}\u{0032}\u{65E5}",
        nfkd: "\u{0032}\u{0032}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33F6}",
        nfc: "\u{33F6}",
        nfd: "\u{33F6}",
        nfkc: "\u{0032}\u{0033}\u{65E5}",
        nfkd: "\u{0032}\u{0033}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33F7}",
        nfc: "\u{33F7}",
        nfd: "\u{33F7}",
        nfkc: "\u{0032}\u{0034}\u{65E5}",
        nfkd: "\u{0032}\u{0034}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33F8}",
        nfc: "\u{33F8}",
        nfd: "\u{33F8}",
        nfkc: "\u{0032}\u{0035}\u{65E5}",
        nfkd: "\u{0032}\u{0035}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33F9}",
        nfc: "\u{33F9}",
        nfd: "\u{33F9}",
        nfkc: "\u{0032}\u{0036}\u{65E5}",
        nfkd: "\u{0032}\u{0036}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33FA}",
        nfc: "\u{33FA}",
        nfd: "\u{33FA}",
        nfkc: "\u{0032}\u{0037}\u{65E5}",
        nfkd: "\u{0032}\u{0037}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33FB}",
        nfc: "\u{33FB}",
        nfd: "\u{33FB}",
        nfkc: "\u{0032}\u{0038}\u{65E5}",
        nfkd: "\u{0032}\u{0038}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33FC}",
        nfc: "\u{33FC}",
        nfd: "\u{33FC}",
        nfkc: "\u{0032}\u{0039}\u{65E5}",
        nfkd: "\u{0032}\u{0039}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33FD}",
        nfc: "\u{33FD}",
        nfd: "\u{33FD}",
        nfkc: "\u{0033}\u{0030}\u{65E5}",
        nfkd: "\u{0033}\u{0030}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33FE}",
        nfc: "\u{33FE}",
        nfd: "\u{33FE}",
        nfkc: "\u{0033}\u{0031}\u{65E5}",
        nfkd: "\u{0033}\u{0031}\u{65E5}",
    },
    NormalizationTest {
        source: "\u{33FF}",
        nfc: "\u{33FF}",
        nfd: "\u{33FF}",
        nfkc: "\u{0067}\u{0061}\u{006C}",
        nfkd: "\u{0067}\u{0061}\u{006C}",
    },
    NormalizationTest {
        source: "\u{A69C}",
        nfc: "\u{A69C}",
        nfd: "\u{A69C}",
        nfkc: "\u{044A}",
        nfkd: "\u{044A}",
    },
    NormalizationTest {
        source: "\u{A69D}",
        nfc: "\u{A69D}",
        nfd: "\u{A69D}",
        nfkc: "\u{044C}",
        nfkd: "\u{044C}",
    },
    NormalizationTest {
        source: "\u{A770}",
        nfc: "\u{A770}",
        nfd: "\u{A770}",
        nfkc: "\u{A76F}",
        nfkd: "\u{A76F}",
    },
    NormalizationTest {
        source: "\u{A7F8}",
        nfc: "\u{A7F8}",
        nfd: "\u{A7F8}",
        nfkc: "\u{0126}",
        nfkd: "\u{0126}",
    },
    NormalizationTest {
        source: "\u{A7F9}",
        nfc: "\u{A7F9}",
        nfd: "\u{A7F9}",
        nfkc: "\u{0153}",
        nfkd: "\u{0153}",
    },
    NormalizationTest {
        source: "\u{AB5C}",
        nfc: "\u{AB5C}",
        nfd: "\u{AB5C}",
        nfkc: "\u{A727}",
        nfkd: "\u{A727}",
    },
    NormalizationTest {
        source: "\u{AB5D}",
        nfc: "\u{AB5D}",
        nfd: "\u{AB5D}",
        nfkc: "\u{AB37}",
        nfkd: "\u{AB37}",
    },
    NormalizationTest {
        source: "\u{AB5E}",
        nfc: "\u{AB5E}",
        nfd: "\u{AB5E}",
        nfkc: "\u{026B}",
        nfkd: "\u{026B}",
    },
    NormalizationTest {
        source: "\u{AB5F}",
        nfc: "\u{AB5F}",
        nfd: "\u{AB5F}",
        nfkc: "\u{AB52}",
        nfkd: "\u{AB52}",
    },
    NormalizationTest {
        source: "\u{AC00}",
        nfc: "\u{AC00}",
        nfd: "\u{1100}\u{1161}",
        nfkc: "\u{AC00}",
        nfkd: "\u{1100}\u{1161}",
    },
    NormalizationTest {
        source: "\u{AC01}",
        nfc: "\u{AC01}",
        nfd: "\u{1100}\u{1161}\u{11A8}",
        nfkc: "\u{AC01}",
        nfkd: "\u{1100}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AC02}",
        nfc: "\u{AC02}",
        nfd: "\u{1100}\u{1161}\u{11A9}",
        nfkc: "\u{AC02}",
        nfkd: "\u{1100}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AC03}",
        nfc: "\u{AC03}",
        nfd: "\u{1100}\u{1161}\u{11AA}",
        nfkc: "\u{AC03}",
        nfkd: "\u{1100}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AC04}",
        nfc: "\u{AC04}",
        nfd: "\u{1100}\u{1161}\u{11AB}",
        nfkc: "\u{AC04}",
        nfkd: "\u{1100}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AC05}",
        nfc: "\u{AC05}",
        nfd: "\u{1100}\u{1161}\u{11AC}",
        nfkc: "\u{AC05}",
        nfkd: "\u{1100}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AC06}",
        nfc: "\u{AC06}",
        nfd: "\u{1100}\u{1161}\u{11AD}",
        nfkc: "\u{AC06}",
        nfkd: "\u{1100}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AC07}",
        nfc: "\u{AC07}",
        nfd: "\u{1100}\u{1161}\u{11AE}",
        nfkc: "\u{AC07}",
        nfkd: "\u{1100}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AC08}",
        nfc: "\u{AC08}",
        nfd: "\u{1100}\u{1161}\u{11AF}",
        nfkc: "\u{AC08}",
        nfkd: "\u{1100}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AC09}",
        nfc: "\u{AC09}",
        nfd: "\u{1100}\u{1161}\u{11B0}",
        nfkc: "\u{AC09}",
        nfkd: "\u{1100}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AC0A}",
        nfc: "\u{AC0A}",
        nfd: "\u{1100}\u{1161}\u{11B1}",
        nfkc: "\u{AC0A}",
        nfkd: "\u{1100}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AC0B}",
        nfc: "\u{AC0B}",
        nfd: "\u{1100}\u{1161}\u{11B2}",
        nfkc: "\u{AC0B}",
        nfkd: "\u{1100}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AC0C}",
        nfc: "\u{AC0C}",
        nfd: "\u{1100}\u{1161}\u{11B3}",
        nfkc: "\u{AC0C}",
        nfkd: "\u{1100}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AC0D}",
        nfc: "\u{AC0D}",
        nfd: "\u{1100}\u{1161}\u{11B4}",
        nfkc: "\u{AC0D}",
        nfkd: "\u{1100}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AC0E}",
        nfc: "\u{AC0E}",
        nfd: "\u{1100}\u{1161}\u{11B5}",
        nfkc: "\u{AC0E}",
        nfkd: "\u{1100}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AC0F}",
        nfc: "\u{AC0F}",
        nfd: "\u{1100}\u{1161}\u{11B6}",
        nfkc: "\u{AC0F}",
        nfkd: "\u{1100}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AC10}",
        nfc: "\u{AC10}",
        nfd: "\u{1100}\u{1161}\u{11B7}",
        nfkc: "\u{AC10}",
        nfkd: "\u{1100}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AC11}",
        nfc: "\u{AC11}",
        nfd: "\u{1100}\u{1161}\u{11B8}",
        nfkc: "\u{AC11}",
        nfkd: "\u{1100}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AC12}",
        nfc: "\u{AC12}",
        nfd: "\u{1100}\u{1161}\u{11B9}",
        nfkc: "\u{AC12}",
        nfkd: "\u{1100}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AC13}",
        nfc: "\u{AC13}",
        nfd: "\u{1100}\u{1161}\u{11BA}",
        nfkc: "\u{AC13}",
        nfkd: "\u{1100}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AC14}",
        nfc: "\u{AC14}",
        nfd: "\u{1100}\u{1161}\u{11BB}",
        nfkc: "\u{AC14}",
        nfkd: "\u{1100}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AC15}",
        nfc: "\u{AC15}",
        nfd: "\u{1100}\u{1161}\u{11BC}",
        nfkc: "\u{AC15}",
        nfkd: "\u{1100}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AC16}",
        nfc: "\u{AC16}",
        nfd: "\u{1100}\u{1161}\u{11BD}",
        nfkc: "\u{AC16}",
        nfkd: "\u{1100}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AC17}",
        nfc: "\u{AC17}",
        nfd: "\u{1100}\u{1161}\u{11BE}",
        nfkc: "\u{AC17}",
        nfkd: "\u{1100}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AC18}",
        nfc: "\u{AC18}",
        nfd: "\u{1100}\u{1161}\u{11BF}",
        nfkc: "\u{AC18}",
        nfkd: "\u{1100}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AC19}",
        nfc: "\u{AC19}",
        nfd: "\u{1100}\u{1161}\u{11C0}",
        nfkc: "\u{AC19}",
        nfkd: "\u{1100}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AC1A}",
        nfc: "\u{AC1A}",
        nfd: "\u{1100}\u{1161}\u{11C1}",
        nfkc: "\u{AC1A}",
        nfkd: "\u{1100}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AC1B}",
        nfc: "\u{AC1B}",
        nfd: "\u{1100}\u{1161}\u{11C2}",
        nfkc: "\u{AC1B}",
        nfkd: "\u{1100}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AC1C}",
        nfc: "\u{AC1C}",
        nfd: "\u{1100}\u{1162}",
        nfkc: "\u{AC1C}",
        nfkd: "\u{1100}\u{1162}",
    },
    NormalizationTest {
        source: "\u{AC1D}",
        nfc: "\u{AC1D}",
        nfd: "\u{1100}\u{1162}\u{11A8}",
        nfkc: "\u{AC1D}",
        nfkd: "\u{1100}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AC1E}",
        nfc: "\u{AC1E}",
        nfd: "\u{1100}\u{1162}\u{11A9}",
        nfkc: "\u{AC1E}",
        nfkd: "\u{1100}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AC1F}",
        nfc: "\u{AC1F}",
        nfd: "\u{1100}\u{1162}\u{11AA}",
        nfkc: "\u{AC1F}",
        nfkd: "\u{1100}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AC20}",
        nfc: "\u{AC20}",
        nfd: "\u{1100}\u{1162}\u{11AB}",
        nfkc: "\u{AC20}",
        nfkd: "\u{1100}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AC21}",
        nfc: "\u{AC21}",
        nfd: "\u{1100}\u{1162}\u{11AC}",
        nfkc: "\u{AC21}",
        nfkd: "\u{1100}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AC22}",
        nfc: "\u{AC22}",
        nfd: "\u{1100}\u{1162}\u{11AD}",
        nfkc: "\u{AC22}",
        nfkd: "\u{1100}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AC23}",
        nfc: "\u{AC23}",
        nfd: "\u{1100}\u{1162}\u{11AE}",
        nfkc: "\u{AC23}",
        nfkd: "\u{1100}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AC24}",
        nfc: "\u{AC24}",
        nfd: "\u{1100}\u{1162}\u{11AF}",
        nfkc: "\u{AC24}",
        nfkd: "\u{1100}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AC25}",
        nfc: "\u{AC25}",
        nfd: "\u{1100}\u{1162}\u{11B0}",
        nfkc: "\u{AC25}",
        nfkd: "\u{1100}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AC26}",
        nfc: "\u{AC26}",
        nfd: "\u{1100}\u{1162}\u{11B1}",
        nfkc: "\u{AC26}",
        nfkd: "\u{1100}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AC27}",
        nfc: "\u{AC27}",
        nfd: "\u{1100}\u{1162}\u{11B2}",
        nfkc: "\u{AC27}",
        nfkd: "\u{1100}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AC28}",
        nfc: "\u{AC28}",
        nfd: "\u{1100}\u{1162}\u{11B3}",
        nfkc: "\u{AC28}",
        nfkd: "\u{1100}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AC29}",
        nfc: "\u{AC29}",
        nfd: "\u{1100}\u{1162}\u{11B4}",
        nfkc: "\u{AC29}",
        nfkd: "\u{1100}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AC2A}",
        nfc: "\u{AC2A}",
        nfd: "\u{1100}\u{1162}\u{11B5}",
        nfkc: "\u{AC2A}",
        nfkd: "\u{1100}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AC2B}",
        nfc: "\u{AC2B}",
        nfd: "\u{1100}\u{1162}\u{11B6}",
        nfkc: "\u{AC2B}",
        nfkd: "\u{1100}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AC2C}",
        nfc: "\u{AC2C}",
        nfd: "\u{1100}\u{1162}\u{11B7}",
        nfkc: "\u{AC2C}",
        nfkd: "\u{1100}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AC2D}",
        nfc: "\u{AC2D}",
        nfd: "\u{1100}\u{1162}\u{11B8}",
        nfkc: "\u{AC2D}",
        nfkd: "\u{1100}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AC2E}",
        nfc: "\u{AC2E}",
        nfd: "\u{1100}\u{1162}\u{11B9}",
        nfkc: "\u{AC2E}",
        nfkd: "\u{1100}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AC2F}",
        nfc: "\u{AC2F}",
        nfd: "\u{1100}\u{1162}\u{11BA}",
        nfkc: "\u{AC2F}",
        nfkd: "\u{1100}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AC30}",
        nfc: "\u{AC30}",
        nfd: "\u{1100}\u{1162}\u{11BB}",
        nfkc: "\u{AC30}",
        nfkd: "\u{1100}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AC31}",
        nfc: "\u{AC31}",
        nfd: "\u{1100}\u{1162}\u{11BC}",
        nfkc: "\u{AC31}",
        nfkd: "\u{1100}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AC32}",
        nfc: "\u{AC32}",
        nfd: "\u{1100}\u{1162}\u{11BD}",
        nfkc: "\u{AC32}",
        nfkd: "\u{1100}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AC33}",
        nfc: "\u{AC33}",
        nfd: "\u{1100}\u{1162}\u{11BE}",
        nfkc: "\u{AC33}",
        nfkd: "\u{1100}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AC34}",
        nfc: "\u{AC34}",
        nfd: "\u{1100}\u{1162}\u{11BF}",
        nfkc: "\u{AC34}",
        nfkd: "\u{1100}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AC35}",
        nfc: "\u{AC35}",
        nfd: "\u{1100}\u{1162}\u{11C0}",
        nfkc: "\u{AC35}",
        nfkd: "\u{1100}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AC36}",
        nfc: "\u{AC36}",
        nfd: "\u{1100}\u{1162}\u{11C1}",
        nfkc: "\u{AC36}",
        nfkd: "\u{1100}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AC37}",
        nfc: "\u{AC37}",
        nfd: "\u{1100}\u{1162}\u{11C2}",
        nfkc: "\u{AC37}",
        nfkd: "\u{1100}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AC38}",
        nfc: "\u{AC38}",
        nfd: "\u{1100}\u{1163}",
        nfkc: "\u{AC38}",
        nfkd: "\u{1100}\u{1163}",
    },
    NormalizationTest {
        source: "\u{AC39}",
        nfc: "\u{AC39}",
        nfd: "\u{1100}\u{1163}\u{11A8}",
        nfkc: "\u{AC39}",
        nfkd: "\u{1100}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AC3A}",
        nfc: "\u{AC3A}",
        nfd: "\u{1100}\u{1163}\u{11A9}",
        nfkc: "\u{AC3A}",
        nfkd: "\u{1100}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AC3B}",
        nfc: "\u{AC3B}",
        nfd: "\u{1100}\u{1163}\u{11AA}",
        nfkc: "\u{AC3B}",
        nfkd: "\u{1100}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AC3C}",
        nfc: "\u{AC3C}",
        nfd: "\u{1100}\u{1163}\u{11AB}",
        nfkc: "\u{AC3C}",
        nfkd: "\u{1100}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AC3D}",
        nfc: "\u{AC3D}",
        nfd: "\u{1100}\u{1163}\u{11AC}",
        nfkc: "\u{AC3D}",
        nfkd: "\u{1100}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AC3E}",
        nfc: "\u{AC3E}",
        nfd: "\u{1100}\u{1163}\u{11AD}",
        nfkc: "\u{AC3E}",
        nfkd: "\u{1100}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AC3F}",
        nfc: "\u{AC3F}",
        nfd: "\u{1100}\u{1163}\u{11AE}",
        nfkc: "\u{AC3F}",
        nfkd: "\u{1100}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AC40}",
        nfc: "\u{AC40}",
        nfd: "\u{1100}\u{1163}\u{11AF}",
        nfkc: "\u{AC40}",
        nfkd: "\u{1100}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AC41}",
        nfc: "\u{AC41}",
        nfd: "\u{1100}\u{1163}\u{11B0}",
        nfkc: "\u{AC41}",
        nfkd: "\u{1100}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AC42}",
        nfc: "\u{AC42}",
        nfd: "\u{1100}\u{1163}\u{11B1}",
        nfkc: "\u{AC42}",
        nfkd: "\u{1100}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AC43}",
        nfc: "\u{AC43}",
        nfd: "\u{1100}\u{1163}\u{11B2}",
        nfkc: "\u{AC43}",
        nfkd: "\u{1100}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AC44}",
        nfc: "\u{AC44}",
        nfd: "\u{1100}\u{1163}\u{11B3}",
        nfkc: "\u{AC44}",
        nfkd: "\u{1100}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AC45}",
        nfc: "\u{AC45}",
        nfd: "\u{1100}\u{1163}\u{11B4}",
        nfkc: "\u{AC45}",
        nfkd: "\u{1100}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AC46}",
        nfc: "\u{AC46}",
        nfd: "\u{1100}\u{1163}\u{11B5}",
        nfkc: "\u{AC46}",
        nfkd: "\u{1100}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AC47}",
        nfc: "\u{AC47}",
        nfd: "\u{1100}\u{1163}\u{11B6}",
        nfkc: "\u{AC47}",
        nfkd: "\u{1100}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AC48}",
        nfc: "\u{AC48}",
        nfd: "\u{1100}\u{1163}\u{11B7}",
        nfkc: "\u{AC48}",
        nfkd: "\u{1100}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AC49}",
        nfc: "\u{AC49}",
        nfd: "\u{1100}\u{1163}\u{11B8}",
        nfkc: "\u{AC49}",
        nfkd: "\u{1100}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AC4A}",
        nfc: "\u{AC4A}",
        nfd: "\u{1100}\u{1163}\u{11B9}",
        nfkc: "\u{AC4A}",
        nfkd: "\u{1100}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AC4B}",
        nfc: "\u{AC4B}",
        nfd: "\u{1100}\u{1163}\u{11BA}",
        nfkc: "\u{AC4B}",
        nfkd: "\u{1100}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AC4C}",
        nfc: "\u{AC4C}",
        nfd: "\u{1100}\u{1163}\u{11BB}",
        nfkc: "\u{AC4C}",
        nfkd: "\u{1100}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AC4D}",
        nfc: "\u{AC4D}",
        nfd: "\u{1100}\u{1163}\u{11BC}",
        nfkc: "\u{AC4D}",
        nfkd: "\u{1100}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AC4E}",
        nfc: "\u{AC4E}",
        nfd: "\u{1100}\u{1163}\u{11BD}",
        nfkc: "\u{AC4E}",
        nfkd: "\u{1100}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AC4F}",
        nfc: "\u{AC4F}",
        nfd: "\u{1100}\u{1163}\u{11BE}",
        nfkc: "\u{AC4F}",
        nfkd: "\u{1100}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AC50}",
        nfc: "\u{AC50}",
        nfd: "\u{1100}\u{1163}\u{11BF}",
        nfkc: "\u{AC50}",
        nfkd: "\u{1100}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AC51}",
        nfc: "\u{AC51}",
        nfd: "\u{1100}\u{1163}\u{11C0}",
        nfkc: "\u{AC51}",
        nfkd: "\u{1100}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AC52}",
        nfc: "\u{AC52}",
        nfd: "\u{1100}\u{1163}\u{11C1}",
        nfkc: "\u{AC52}",
        nfkd: "\u{1100}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AC53}",
        nfc: "\u{AC53}",
        nfd: "\u{1100}\u{1163}\u{11C2}",
        nfkc: "\u{AC53}",
        nfkd: "\u{1100}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AC54}",
        nfc: "\u{AC54}",
        nfd: "\u{1100}\u{1164}",
        nfkc: "\u{AC54}",
        nfkd: "\u{1100}\u{1164}",
    },
    NormalizationTest {
        source: "\u{AC55}",
        nfc: "\u{AC55}",
        nfd: "\u{1100}\u{1164}\u{11A8}",
        nfkc: "\u{AC55}",
        nfkd: "\u{1100}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AC56}",
        nfc: "\u{AC56}",
        nfd: "\u{1100}\u{1164}\u{11A9}",
        nfkc: "\u{AC56}",
        nfkd: "\u{1100}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AC57}",
        nfc: "\u{AC57}",
        nfd: "\u{1100}\u{1164}\u{11AA}",
        nfkc: "\u{AC57}",
        nfkd: "\u{1100}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AC58}",
        nfc: "\u{AC58}",
        nfd: "\u{1100}\u{1164}\u{11AB}",
        nfkc: "\u{AC58}",
        nfkd: "\u{1100}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AC59}",
        nfc: "\u{AC59}",
        nfd: "\u{1100}\u{1164}\u{11AC}",
        nfkc: "\u{AC59}",
        nfkd: "\u{1100}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AC5A}",
        nfc: "\u{AC5A}",
        nfd: "\u{1100}\u{1164}\u{11AD}",
        nfkc: "\u{AC5A}",
        nfkd: "\u{1100}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AC5B}",
        nfc: "\u{AC5B}",
        nfd: "\u{1100}\u{1164}\u{11AE}",
        nfkc: "\u{AC5B}",
        nfkd: "\u{1100}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AC5C}",
        nfc: "\u{AC5C}",
        nfd: "\u{1100}\u{1164}\u{11AF}",
        nfkc: "\u{AC5C}",
        nfkd: "\u{1100}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AC5D}",
        nfc: "\u{AC5D}",
        nfd: "\u{1100}\u{1164}\u{11B0}",
        nfkc: "\u{AC5D}",
        nfkd: "\u{1100}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AC5E}",
        nfc: "\u{AC5E}",
        nfd: "\u{1100}\u{1164}\u{11B1}",
        nfkc: "\u{AC5E}",
        nfkd: "\u{1100}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AC5F}",
        nfc: "\u{AC5F}",
        nfd: "\u{1100}\u{1164}\u{11B2}",
        nfkc: "\u{AC5F}",
        nfkd: "\u{1100}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AC60}",
        nfc: "\u{AC60}",
        nfd: "\u{1100}\u{1164}\u{11B3}",
        nfkc: "\u{AC60}",
        nfkd: "\u{1100}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AC61}",
        nfc: "\u{AC61}",
        nfd: "\u{1100}\u{1164}\u{11B4}",
        nfkc: "\u{AC61}",
        nfkd: "\u{1100}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AC62}",
        nfc: "\u{AC62}",
        nfd: "\u{1100}\u{1164}\u{11B5}",
        nfkc: "\u{AC62}",
        nfkd: "\u{1100}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AC63}",
        nfc: "\u{AC63}",
        nfd: "\u{1100}\u{1164}\u{11B6}",
        nfkc: "\u{AC63}",
        nfkd: "\u{1100}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AC64}",
        nfc: "\u{AC64}",
        nfd: "\u{1100}\u{1164}\u{11B7}",
        nfkc: "\u{AC64}",
        nfkd: "\u{1100}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AC65}",
        nfc: "\u{AC65}",
        nfd: "\u{1100}\u{1164}\u{11B8}",
        nfkc: "\u{AC65}",
        nfkd: "\u{1100}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AC66}",
        nfc: "\u{AC66}",
        nfd: "\u{1100}\u{1164}\u{11B9}",
        nfkc: "\u{AC66}",
        nfkd: "\u{1100}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AC67}",
        nfc: "\u{AC67}",
        nfd: "\u{1100}\u{1164}\u{11BA}",
        nfkc: "\u{AC67}",
        nfkd: "\u{1100}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AC68}",
        nfc: "\u{AC68}",
        nfd: "\u{1100}\u{1164}\u{11BB}",
        nfkc: "\u{AC68}",
        nfkd: "\u{1100}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AC69}",
        nfc: "\u{AC69}",
        nfd: "\u{1100}\u{1164}\u{11BC}",
        nfkc: "\u{AC69}",
        nfkd: "\u{1100}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AC6A}",
        nfc: "\u{AC6A}",
        nfd: "\u{1100}\u{1164}\u{11BD}",
        nfkc: "\u{AC6A}",
        nfkd: "\u{1100}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AC6B}",
        nfc: "\u{AC6B}",
        nfd: "\u{1100}\u{1164}\u{11BE}",
        nfkc: "\u{AC6B}",
        nfkd: "\u{1100}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AC6C}",
        nfc: "\u{AC6C}",
        nfd: "\u{1100}\u{1164}\u{11BF}",
        nfkc: "\u{AC6C}",
        nfkd: "\u{1100}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AC6D}",
        nfc: "\u{AC6D}",
        nfd: "\u{1100}\u{1164}\u{11C0}",
        nfkc: "\u{AC6D}",
        nfkd: "\u{1100}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AC6E}",
        nfc: "\u{AC6E}",
        nfd: "\u{1100}\u{1164}\u{11C1}",
        nfkc: "\u{AC6E}",
        nfkd: "\u{1100}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AC6F}",
        nfc: "\u{AC6F}",
        nfd: "\u{1100}\u{1164}\u{11C2}",
        nfkc: "\u{AC6F}",
        nfkd: "\u{1100}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AC70}",
        nfc: "\u{AC70}",
        nfd: "\u{1100}\u{1165}",
        nfkc: "\u{AC70}",
        nfkd: "\u{1100}\u{1165}",
    },
    NormalizationTest {
        source: "\u{AC71}",
        nfc: "\u{AC71}",
        nfd: "\u{1100}\u{1165}\u{11A8}",
        nfkc: "\u{AC71}",
        nfkd: "\u{1100}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AC72}",
        nfc: "\u{AC72}",
        nfd: "\u{1100}\u{1165}\u{11A9}",
        nfkc: "\u{AC72}",
        nfkd: "\u{1100}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AC73}",
        nfc: "\u{AC73}",
        nfd: "\u{1100}\u{1165}\u{11AA}",
        nfkc: "\u{AC73}",
        nfkd: "\u{1100}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AC74}",
        nfc: "\u{AC74}",
        nfd: "\u{1100}\u{1165}\u{11AB}",
        nfkc: "\u{AC74}",
        nfkd: "\u{1100}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AC75}",
        nfc: "\u{AC75}",
        nfd: "\u{1100}\u{1165}\u{11AC}",
        nfkc: "\u{AC75}",
        nfkd: "\u{1100}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AC76}",
        nfc: "\u{AC76}",
        nfd: "\u{1100}\u{1165}\u{11AD}",
        nfkc: "\u{AC76}",
        nfkd: "\u{1100}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AC77}",
        nfc: "\u{AC77}",
        nfd: "\u{1100}\u{1165}\u{11AE}",
        nfkc: "\u{AC77}",
        nfkd: "\u{1100}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AC78}",
        nfc: "\u{AC78}",
        nfd: "\u{1100}\u{1165}\u{11AF}",
        nfkc: "\u{AC78}",
        nfkd: "\u{1100}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AC79}",
        nfc: "\u{AC79}",
        nfd: "\u{1100}\u{1165}\u{11B0}",
        nfkc: "\u{AC79}",
        nfkd: "\u{1100}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AC7A}",
        nfc: "\u{AC7A}",
        nfd: "\u{1100}\u{1165}\u{11B1}",
        nfkc: "\u{AC7A}",
        nfkd: "\u{1100}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AC7B}",
        nfc: "\u{AC7B}",
        nfd: "\u{1100}\u{1165}\u{11B2}",
        nfkc: "\u{AC7B}",
        nfkd: "\u{1100}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AC7C}",
        nfc: "\u{AC7C}",
        nfd: "\u{1100}\u{1165}\u{11B3}",
        nfkc: "\u{AC7C}",
        nfkd: "\u{1100}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AC7D}",
        nfc: "\u{AC7D}",
        nfd: "\u{1100}\u{1165}\u{11B4}",
        nfkc: "\u{AC7D}",
        nfkd: "\u{1100}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AC7E}",
        nfc: "\u{AC7E}",
        nfd: "\u{1100}\u{1165}\u{11B5}",
        nfkc: "\u{AC7E}",
        nfkd: "\u{1100}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AC7F}",
        nfc: "\u{AC7F}",
        nfd: "\u{1100}\u{1165}\u{11B6}",
        nfkc: "\u{AC7F}",
        nfkd: "\u{1100}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AC80}",
        nfc: "\u{AC80}",
        nfd: "\u{1100}\u{1165}\u{11B7}",
        nfkc: "\u{AC80}",
        nfkd: "\u{1100}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AC81}",
        nfc: "\u{AC81}",
        nfd: "\u{1100}\u{1165}\u{11B8}",
        nfkc: "\u{AC81}",
        nfkd: "\u{1100}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AC82}",
        nfc: "\u{AC82}",
        nfd: "\u{1100}\u{1165}\u{11B9}",
        nfkc: "\u{AC82}",
        nfkd: "\u{1100}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AC83}",
        nfc: "\u{AC83}",
        nfd: "\u{1100}\u{1165}\u{11BA}",
        nfkc: "\u{AC83}",
        nfkd: "\u{1100}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AC84}",
        nfc: "\u{AC84}",
        nfd: "\u{1100}\u{1165}\u{11BB}",
        nfkc: "\u{AC84}",
        nfkd: "\u{1100}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AC85}",
        nfc: "\u{AC85}",
        nfd: "\u{1100}\u{1165}\u{11BC}",
        nfkc: "\u{AC85}",
        nfkd: "\u{1100}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AC86}",
        nfc: "\u{AC86}",
        nfd: "\u{1100}\u{1165}\u{11BD}",
        nfkc: "\u{AC86}",
        nfkd: "\u{1100}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AC87}",
        nfc: "\u{AC87}",
        nfd: "\u{1100}\u{1165}\u{11BE}",
        nfkc: "\u{AC87}",
        nfkd: "\u{1100}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AC88}",
        nfc: "\u{AC88}",
        nfd: "\u{1100}\u{1165}\u{11BF}",
        nfkc: "\u{AC88}",
        nfkd: "\u{1100}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AC89}",
        nfc: "\u{AC89}",
        nfd: "\u{1100}\u{1165}\u{11C0}",
        nfkc: "\u{AC89}",
        nfkd: "\u{1100}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AC8A}",
        nfc: "\u{AC8A}",
        nfd: "\u{1100}\u{1165}\u{11C1}",
        nfkc: "\u{AC8A}",
        nfkd: "\u{1100}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AC8B}",
        nfc: "\u{AC8B}",
        nfd: "\u{1100}\u{1165}\u{11C2}",
        nfkc: "\u{AC8B}",
        nfkd: "\u{1100}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AC8C}",
        nfc: "\u{AC8C}",
        nfd: "\u{1100}\u{1166}",
        nfkc: "\u{AC8C}",
        nfkd: "\u{1100}\u{1166}",
    },
    NormalizationTest {
        source: "\u{AC8D}",
        nfc: "\u{AC8D}",
        nfd: "\u{1100}\u{1166}\u{11A8}",
        nfkc: "\u{AC8D}",
        nfkd: "\u{1100}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AC8E}",
        nfc: "\u{AC8E}",
        nfd: "\u{1100}\u{1166}\u{11A9}",
        nfkc: "\u{AC8E}",
        nfkd: "\u{1100}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AC8F}",
        nfc: "\u{AC8F}",
        nfd: "\u{1100}\u{1166}\u{11AA}",
        nfkc: "\u{AC8F}",
        nfkd: "\u{1100}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AC90}",
        nfc: "\u{AC90}",
        nfd: "\u{1100}\u{1166}\u{11AB}",
        nfkc: "\u{AC90}",
        nfkd: "\u{1100}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AC91}",
        nfc: "\u{AC91}",
        nfd: "\u{1100}\u{1166}\u{11AC}",
        nfkc: "\u{AC91}",
        nfkd: "\u{1100}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AC92}",
        nfc: "\u{AC92}",
        nfd: "\u{1100}\u{1166}\u{11AD}",
        nfkc: "\u{AC92}",
        nfkd: "\u{1100}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AC93}",
        nfc: "\u{AC93}",
        nfd: "\u{1100}\u{1166}\u{11AE}",
        nfkc: "\u{AC93}",
        nfkd: "\u{1100}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AC94}",
        nfc: "\u{AC94}",
        nfd: "\u{1100}\u{1166}\u{11AF}",
        nfkc: "\u{AC94}",
        nfkd: "\u{1100}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AC95}",
        nfc: "\u{AC95}",
        nfd: "\u{1100}\u{1166}\u{11B0}",
        nfkc: "\u{AC95}",
        nfkd: "\u{1100}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AC96}",
        nfc: "\u{AC96}",
        nfd: "\u{1100}\u{1166}\u{11B1}",
        nfkc: "\u{AC96}",
        nfkd: "\u{1100}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AC97}",
        nfc: "\u{AC97}",
        nfd: "\u{1100}\u{1166}\u{11B2}",
        nfkc: "\u{AC97}",
        nfkd: "\u{1100}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AC98}",
        nfc: "\u{AC98}",
        nfd: "\u{1100}\u{1166}\u{11B3}",
        nfkc: "\u{AC98}",
        nfkd: "\u{1100}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AC99}",
        nfc: "\u{AC99}",
        nfd: "\u{1100}\u{1166}\u{11B4}",
        nfkc: "\u{AC99}",
        nfkd: "\u{1100}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AC9A}",
        nfc: "\u{AC9A}",
        nfd: "\u{1100}\u{1166}\u{11B5}",
        nfkc: "\u{AC9A}",
        nfkd: "\u{1100}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AC9B}",
        nfc: "\u{AC9B}",
        nfd: "\u{1100}\u{1166}\u{11B6}",
        nfkc: "\u{AC9B}",
        nfkd: "\u{1100}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AC9C}",
        nfc: "\u{AC9C}",
        nfd: "\u{1100}\u{1166}\u{11B7}",
        nfkc: "\u{AC9C}",
        nfkd: "\u{1100}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AC9D}",
        nfc: "\u{AC9D}",
        nfd: "\u{1100}\u{1166}\u{11B8}",
        nfkc: "\u{AC9D}",
        nfkd: "\u{1100}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AC9E}",
        nfc: "\u{AC9E}",
        nfd: "\u{1100}\u{1166}\u{11B9}",
        nfkc: "\u{AC9E}",
        nfkd: "\u{1100}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AC9F}",
        nfc: "\u{AC9F}",
        nfd: "\u{1100}\u{1166}\u{11BA}",
        nfkc: "\u{AC9F}",
        nfkd: "\u{1100}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{ACA0}",
        nfc: "\u{ACA0}",
        nfd: "\u{1100}\u{1166}\u{11BB}",
        nfkc: "\u{ACA0}",
        nfkd: "\u{1100}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{ACA1}",
        nfc: "\u{ACA1}",
        nfd: "\u{1100}\u{1166}\u{11BC}",
        nfkc: "\u{ACA1}",
        nfkd: "\u{1100}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{ACA2}",
        nfc: "\u{ACA2}",
        nfd: "\u{1100}\u{1166}\u{11BD}",
        nfkc: "\u{ACA2}",
        nfkd: "\u{1100}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{ACA3}",
        nfc: "\u{ACA3}",
        nfd: "\u{1100}\u{1166}\u{11BE}",
        nfkc: "\u{ACA3}",
        nfkd: "\u{1100}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{ACA4}",
        nfc: "\u{ACA4}",
        nfd: "\u{1100}\u{1166}\u{11BF}",
        nfkc: "\u{ACA4}",
        nfkd: "\u{1100}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{ACA5}",
        nfc: "\u{ACA5}",
        nfd: "\u{1100}\u{1166}\u{11C0}",
        nfkc: "\u{ACA5}",
        nfkd: "\u{1100}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{ACA6}",
        nfc: "\u{ACA6}",
        nfd: "\u{1100}\u{1166}\u{11C1}",
        nfkc: "\u{ACA6}",
        nfkd: "\u{1100}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{ACA7}",
        nfc: "\u{ACA7}",
        nfd: "\u{1100}\u{1166}\u{11C2}",
        nfkc: "\u{ACA7}",
        nfkd: "\u{1100}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{ACA8}",
        nfc: "\u{ACA8}",
        nfd: "\u{1100}\u{1167}",
        nfkc: "\u{ACA8}",
        nfkd: "\u{1100}\u{1167}",
    },
    NormalizationTest {
        source: "\u{ACA9}",
        nfc: "\u{ACA9}",
        nfd: "\u{1100}\u{1167}\u{11A8}",
        nfkc: "\u{ACA9}",
        nfkd: "\u{1100}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{ACAA}",
        nfc: "\u{ACAA}",
        nfd: "\u{1100}\u{1167}\u{11A9}",
        nfkc: "\u{ACAA}",
        nfkd: "\u{1100}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{ACAB}",
        nfc: "\u{ACAB}",
        nfd: "\u{1100}\u{1167}\u{11AA}",
        nfkc: "\u{ACAB}",
        nfkd: "\u{1100}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{ACAC}",
        nfc: "\u{ACAC}",
        nfd: "\u{1100}\u{1167}\u{11AB}",
        nfkc: "\u{ACAC}",
        nfkd: "\u{1100}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{ACAD}",
        nfc: "\u{ACAD}",
        nfd: "\u{1100}\u{1167}\u{11AC}",
        nfkc: "\u{ACAD}",
        nfkd: "\u{1100}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{ACAE}",
        nfc: "\u{ACAE}",
        nfd: "\u{1100}\u{1167}\u{11AD}",
        nfkc: "\u{ACAE}",
        nfkd: "\u{1100}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{ACAF}",
        nfc: "\u{ACAF}",
        nfd: "\u{1100}\u{1167}\u{11AE}",
        nfkc: "\u{ACAF}",
        nfkd: "\u{1100}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{ACB0}",
        nfc: "\u{ACB0}",
        nfd: "\u{1100}\u{1167}\u{11AF}",
        nfkc: "\u{ACB0}",
        nfkd: "\u{1100}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{ACB1}",
        nfc: "\u{ACB1}",
        nfd: "\u{1100}\u{1167}\u{11B0}",
        nfkc: "\u{ACB1}",
        nfkd: "\u{1100}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{ACB2}",
        nfc: "\u{ACB2}",
        nfd: "\u{1100}\u{1167}\u{11B1}",
        nfkc: "\u{ACB2}",
        nfkd: "\u{1100}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{ACB3}",
        nfc: "\u{ACB3}",
        nfd: "\u{1100}\u{1167}\u{11B2}",
        nfkc: "\u{ACB3}",
        nfkd: "\u{1100}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{ACB4}",
        nfc: "\u{ACB4}",
        nfd: "\u{1100}\u{1167}\u{11B3}",
        nfkc: "\u{ACB4}",
        nfkd: "\u{1100}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{ACB5}",
        nfc: "\u{ACB5}",
        nfd: "\u{1100}\u{1167}\u{11B4}",
        nfkc: "\u{ACB5}",
        nfkd: "\u{1100}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{ACB6}",
        nfc: "\u{ACB6}",
        nfd: "\u{1100}\u{1167}\u{11B5}",
        nfkc: "\u{ACB6}",
        nfkd: "\u{1100}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{ACB7}",
        nfc: "\u{ACB7}",
        nfd: "\u{1100}\u{1167}\u{11B6}",
        nfkc: "\u{ACB7}",
        nfkd: "\u{1100}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{ACB8}",
        nfc: "\u{ACB8}",
        nfd: "\u{1100}\u{1167}\u{11B7}",
        nfkc: "\u{ACB8}",
        nfkd: "\u{1100}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{ACB9}",
        nfc: "\u{ACB9}",
        nfd: "\u{1100}\u{1167}\u{11B8}",
        nfkc: "\u{ACB9}",
        nfkd: "\u{1100}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{ACBA}",
        nfc: "\u{ACBA}",
        nfd: "\u{1100}\u{1167}\u{11B9}",
        nfkc: "\u{ACBA}",
        nfkd: "\u{1100}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{ACBB}",
        nfc: "\u{ACBB}",
        nfd: "\u{1100}\u{1167}\u{11BA}",
        nfkc: "\u{ACBB}",
        nfkd: "\u{1100}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{ACBC}",
        nfc: "\u{ACBC}",
        nfd: "\u{1100}\u{1167}\u{11BB}",
        nfkc: "\u{ACBC}",
        nfkd: "\u{1100}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{ACBD}",
        nfc: "\u{ACBD}",
        nfd: "\u{1100}\u{1167}\u{11BC}",
        nfkc: "\u{ACBD}",
        nfkd: "\u{1100}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{ACBE}",
        nfc: "\u{ACBE}",
        nfd: "\u{1100}\u{1167}\u{11BD}",
        nfkc: "\u{ACBE}",
        nfkd: "\u{1100}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{ACBF}",
        nfc: "\u{ACBF}",
        nfd: "\u{1100}\u{1167}\u{11BE}",
        nfkc: "\u{ACBF}",
        nfkd: "\u{1100}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{ACC0}",
        nfc: "\u{ACC0}",
        nfd: "\u{1100}\u{1167}\u{11BF}",
        nfkc: "\u{ACC0}",
        nfkd: "\u{1100}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{ACC1}",
        nfc: "\u{ACC1}",
        nfd: "\u{1100}\u{1167}\u{11C0}",
        nfkc: "\u{ACC1}",
        nfkd: "\u{1100}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{ACC2}",
        nfc: "\u{ACC2}",
        nfd: "\u{1100}\u{1167}\u{11C1}",
        nfkc: "\u{ACC2}",
        nfkd: "\u{1100}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{ACC3}",
        nfc: "\u{ACC3}",
        nfd: "\u{1100}\u{1167}\u{11C2}",
        nfkc: "\u{ACC3}",
        nfkd: "\u{1100}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{ACC4}",
        nfc: "\u{ACC4}",
        nfd: "\u{1100}\u{1168}",
        nfkc: "\u{ACC4}",
        nfkd: "\u{1100}\u{1168}",
    },
    NormalizationTest {
        source: "\u{ACC5}",
        nfc: "\u{ACC5}",
        nfd: "\u{1100}\u{1168}\u{11A8}",
        nfkc: "\u{ACC5}",
        nfkd: "\u{1100}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{ACC6}",
        nfc: "\u{ACC6}",
        nfd: "\u{1100}\u{1168}\u{11A9}",
        nfkc: "\u{ACC6}",
        nfkd: "\u{1100}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{ACC7}",
        nfc: "\u{ACC7}",
        nfd: "\u{1100}\u{1168}\u{11AA}",
        nfkc: "\u{ACC7}",
        nfkd: "\u{1100}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{ACC8}",
        nfc: "\u{ACC8}",
        nfd: "\u{1100}\u{1168}\u{11AB}",
        nfkc: "\u{ACC8}",
        nfkd: "\u{1100}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{ACC9}",
        nfc: "\u{ACC9}",
        nfd: "\u{1100}\u{1168}\u{11AC}",
        nfkc: "\u{ACC9}",
        nfkd: "\u{1100}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{ACCA}",
        nfc: "\u{ACCA}",
        nfd: "\u{1100}\u{1168}\u{11AD}",
        nfkc: "\u{ACCA}",
        nfkd: "\u{1100}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{ACCB}",
        nfc: "\u{ACCB}",
        nfd: "\u{1100}\u{1168}\u{11AE}",
        nfkc: "\u{ACCB}",
        nfkd: "\u{1100}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{ACCC}",
        nfc: "\u{ACCC}",
        nfd: "\u{1100}\u{1168}\u{11AF}",
        nfkc: "\u{ACCC}",
        nfkd: "\u{1100}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{ACCD}",
        nfc: "\u{ACCD}",
        nfd: "\u{1100}\u{1168}\u{11B0}",
        nfkc: "\u{ACCD}",
        nfkd: "\u{1100}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{ACCE}",
        nfc: "\u{ACCE}",
        nfd: "\u{1100}\u{1168}\u{11B1}",
        nfkc: "\u{ACCE}",
        nfkd: "\u{1100}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{ACCF}",
        nfc: "\u{ACCF}",
        nfd: "\u{1100}\u{1168}\u{11B2}",
        nfkc: "\u{ACCF}",
        nfkd: "\u{1100}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{ACD0}",
        nfc: "\u{ACD0}",
        nfd: "\u{1100}\u{1168}\u{11B3}",
        nfkc: "\u{ACD0}",
        nfkd: "\u{1100}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{ACD1}",
        nfc: "\u{ACD1}",
        nfd: "\u{1100}\u{1168}\u{11B4}",
        nfkc: "\u{ACD1}",
        nfkd: "\u{1100}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{ACD2}",
        nfc: "\u{ACD2}",
        nfd: "\u{1100}\u{1168}\u{11B5}",
        nfkc: "\u{ACD2}",
        nfkd: "\u{1100}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{ACD3}",
        nfc: "\u{ACD3}",
        nfd: "\u{1100}\u{1168}\u{11B6}",
        nfkc: "\u{ACD3}",
        nfkd: "\u{1100}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{ACD4}",
        nfc: "\u{ACD4}",
        nfd: "\u{1100}\u{1168}\u{11B7}",
        nfkc: "\u{ACD4}",
        nfkd: "\u{1100}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{ACD5}",
        nfc: "\u{ACD5}",
        nfd: "\u{1100}\u{1168}\u{11B8}",
        nfkc: "\u{ACD5}",
        nfkd: "\u{1100}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{ACD6}",
        nfc: "\u{ACD6}",
        nfd: "\u{1100}\u{1168}\u{11B9}",
        nfkc: "\u{ACD6}",
        nfkd: "\u{1100}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{ACD7}",
        nfc: "\u{ACD7}",
        nfd: "\u{1100}\u{1168}\u{11BA}",
        nfkc: "\u{ACD7}",
        nfkd: "\u{1100}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{ACD8}",
        nfc: "\u{ACD8}",
        nfd: "\u{1100}\u{1168}\u{11BB}",
        nfkc: "\u{ACD8}",
        nfkd: "\u{1100}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{ACD9}",
        nfc: "\u{ACD9}",
        nfd: "\u{1100}\u{1168}\u{11BC}",
        nfkc: "\u{ACD9}",
        nfkd: "\u{1100}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{ACDA}",
        nfc: "\u{ACDA}",
        nfd: "\u{1100}\u{1168}\u{11BD}",
        nfkc: "\u{ACDA}",
        nfkd: "\u{1100}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{ACDB}",
        nfc: "\u{ACDB}",
        nfd: "\u{1100}\u{1168}\u{11BE}",
        nfkc: "\u{ACDB}",
        nfkd: "\u{1100}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{ACDC}",
        nfc: "\u{ACDC}",
        nfd: "\u{1100}\u{1168}\u{11BF}",
        nfkc: "\u{ACDC}",
        nfkd: "\u{1100}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{ACDD}",
        nfc: "\u{ACDD}",
        nfd: "\u{1100}\u{1168}\u{11C0}",
        nfkc: "\u{ACDD}",
        nfkd: "\u{1100}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{ACDE}",
        nfc: "\u{ACDE}",
        nfd: "\u{1100}\u{1168}\u{11C1}",
        nfkc: "\u{ACDE}",
        nfkd: "\u{1100}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{ACDF}",
        nfc: "\u{ACDF}",
        nfd: "\u{1100}\u{1168}\u{11C2}",
        nfkc: "\u{ACDF}",
        nfkd: "\u{1100}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{ACE0}",
        nfc: "\u{ACE0}",
        nfd: "\u{1100}\u{1169}",
        nfkc: "\u{ACE0}",
        nfkd: "\u{1100}\u{1169}",
    },
    NormalizationTest {
        source: "\u{ACE1}",
        nfc: "\u{ACE1}",
        nfd: "\u{1100}\u{1169}\u{11A8}",
        nfkc: "\u{ACE1}",
        nfkd: "\u{1100}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{ACE2}",
        nfc: "\u{ACE2}",
        nfd: "\u{1100}\u{1169}\u{11A9}",
        nfkc: "\u{ACE2}",
        nfkd: "\u{1100}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{ACE3}",
        nfc: "\u{ACE3}",
        nfd: "\u{1100}\u{1169}\u{11AA}",
        nfkc: "\u{ACE3}",
        nfkd: "\u{1100}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{ACE4}",
        nfc: "\u{ACE4}",
        nfd: "\u{1100}\u{1169}\u{11AB}",
        nfkc: "\u{ACE4}",
        nfkd: "\u{1100}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{ACE5}",
        nfc: "\u{ACE5}",
        nfd: "\u{1100}\u{1169}\u{11AC}",
        nfkc: "\u{ACE5}",
        nfkd: "\u{1100}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{ACE6}",
        nfc: "\u{ACE6}",
        nfd: "\u{1100}\u{1169}\u{11AD}",
        nfkc: "\u{ACE6}",
        nfkd: "\u{1100}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{ACE7}",
        nfc: "\u{ACE7}",
        nfd: "\u{1100}\u{1169}\u{11AE}",
        nfkc: "\u{ACE7}",
        nfkd: "\u{1100}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{ACE8}",
        nfc: "\u{ACE8}",
        nfd: "\u{1100}\u{1169}\u{11AF}",
        nfkc: "\u{ACE8}",
        nfkd: "\u{1100}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{ACE9}",
        nfc: "\u{ACE9}",
        nfd: "\u{1100}\u{1169}\u{11B0}",
        nfkc: "\u{ACE9}",
        nfkd: "\u{1100}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{ACEA}",
        nfc: "\u{ACEA}",
        nfd: "\u{1100}\u{1169}\u{11B1}",
        nfkc: "\u{ACEA}",
        nfkd: "\u{1100}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{ACEB}",
        nfc: "\u{ACEB}",
        nfd: "\u{1100}\u{1169}\u{11B2}",
        nfkc: "\u{ACEB}",
        nfkd: "\u{1100}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{ACEC}",
        nfc: "\u{ACEC}",
        nfd: "\u{1100}\u{1169}\u{11B3}",
        nfkc: "\u{ACEC}",
        nfkd: "\u{1100}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{ACED}",
        nfc: "\u{ACED}",
        nfd: "\u{1100}\u{1169}\u{11B4}",
        nfkc: "\u{ACED}",
        nfkd: "\u{1100}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{ACEE}",
        nfc: "\u{ACEE}",
        nfd: "\u{1100}\u{1169}\u{11B5}",
        nfkc: "\u{ACEE}",
        nfkd: "\u{1100}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{ACEF}",
        nfc: "\u{ACEF}",
        nfd: "\u{1100}\u{1169}\u{11B6}",
        nfkc: "\u{ACEF}",
        nfkd: "\u{1100}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{ACF0}",
        nfc: "\u{ACF0}",
        nfd: "\u{1100}\u{1169}\u{11B7}",
        nfkc: "\u{ACF0}",
        nfkd: "\u{1100}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{ACF1}",
        nfc: "\u{ACF1}",
        nfd: "\u{1100}\u{1169}\u{11B8}",
        nfkc: "\u{ACF1}",
        nfkd: "\u{1100}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{ACF2}",
        nfc: "\u{ACF2}",
        nfd: "\u{1100}\u{1169}\u{11B9}",
        nfkc: "\u{ACF2}",
        nfkd: "\u{1100}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{ACF3}",
        nfc: "\u{ACF3}",
        nfd: "\u{1100}\u{1169}\u{11BA}",
        nfkc: "\u{ACF3}",
        nfkd: "\u{1100}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{ACF4}",
        nfc: "\u{ACF4}",
        nfd: "\u{1100}\u{1169}\u{11BB}",
        nfkc: "\u{ACF4}",
        nfkd: "\u{1100}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{ACF5}",
        nfc: "\u{ACF5}",
        nfd: "\u{1100}\u{1169}\u{11BC}",
        nfkc: "\u{ACF5}",
        nfkd: "\u{1100}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{ACF6}",
        nfc: "\u{ACF6}",
        nfd: "\u{1100}\u{1169}\u{11BD}",
        nfkc: "\u{ACF6}",
        nfkd: "\u{1100}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{ACF7}",
        nfc: "\u{ACF7}",
        nfd: "\u{1100}\u{1169}\u{11BE}",
        nfkc: "\u{ACF7}",
        nfkd: "\u{1100}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{ACF8}",
        nfc: "\u{ACF8}",
        nfd: "\u{1100}\u{1169}\u{11BF}",
        nfkc: "\u{ACF8}",
        nfkd: "\u{1100}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{ACF9}",
        nfc: "\u{ACF9}",
        nfd: "\u{1100}\u{1169}\u{11C0}",
        nfkc: "\u{ACF9}",
        nfkd: "\u{1100}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{ACFA}",
        nfc: "\u{ACFA}",
        nfd: "\u{1100}\u{1169}\u{11C1}",
        nfkc: "\u{ACFA}",
        nfkd: "\u{1100}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{ACFB}",
        nfc: "\u{ACFB}",
        nfd: "\u{1100}\u{1169}\u{11C2}",
        nfkc: "\u{ACFB}",
        nfkd: "\u{1100}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{ACFC}",
        nfc: "\u{ACFC}",
        nfd: "\u{1100}\u{116A}",
        nfkc: "\u{ACFC}",
        nfkd: "\u{1100}\u{116A}",
    },
    NormalizationTest {
        source: "\u{ACFD}",
        nfc: "\u{ACFD}",
        nfd: "\u{1100}\u{116A}\u{11A8}",
        nfkc: "\u{ACFD}",
        nfkd: "\u{1100}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{ACFE}",
        nfc: "\u{ACFE}",
        nfd: "\u{1100}\u{116A}\u{11A9}",
        nfkc: "\u{ACFE}",
        nfkd: "\u{1100}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{ACFF}",
        nfc: "\u{ACFF}",
        nfd: "\u{1100}\u{116A}\u{11AA}",
        nfkc: "\u{ACFF}",
        nfkd: "\u{1100}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AD00}",
        nfc: "\u{AD00}",
        nfd: "\u{1100}\u{116A}\u{11AB}",
        nfkc: "\u{AD00}",
        nfkd: "\u{1100}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AD01}",
        nfc: "\u{AD01}",
        nfd: "\u{1100}\u{116A}\u{11AC}",
        nfkc: "\u{AD01}",
        nfkd: "\u{1100}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AD02}",
        nfc: "\u{AD02}",
        nfd: "\u{1100}\u{116A}\u{11AD}",
        nfkc: "\u{AD02}",
        nfkd: "\u{1100}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AD03}",
        nfc: "\u{AD03}",
        nfd: "\u{1100}\u{116A}\u{11AE}",
        nfkc: "\u{AD03}",
        nfkd: "\u{1100}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AD04}",
        nfc: "\u{AD04}",
        nfd: "\u{1100}\u{116A}\u{11AF}",
        nfkc: "\u{AD04}",
        nfkd: "\u{1100}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AD05}",
        nfc: "\u{AD05}",
        nfd: "\u{1100}\u{116A}\u{11B0}",
        nfkc: "\u{AD05}",
        nfkd: "\u{1100}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AD06}",
        nfc: "\u{AD06}",
        nfd: "\u{1100}\u{116A}\u{11B1}",
        nfkc: "\u{AD06}",
        nfkd: "\u{1100}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AD07}",
        nfc: "\u{AD07}",
        nfd: "\u{1100}\u{116A}\u{11B2}",
        nfkc: "\u{AD07}",
        nfkd: "\u{1100}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AD08}",
        nfc: "\u{AD08}",
        nfd: "\u{1100}\u{116A}\u{11B3}",
        nfkc: "\u{AD08}",
        nfkd: "\u{1100}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AD09}",
        nfc: "\u{AD09}",
        nfd: "\u{1100}\u{116A}\u{11B4}",
        nfkc: "\u{AD09}",
        nfkd: "\u{1100}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AD0A}",
        nfc: "\u{AD0A}",
        nfd: "\u{1100}\u{116A}\u{11B5}",
        nfkc: "\u{AD0A}",
        nfkd: "\u{1100}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AD0B}",
        nfc: "\u{AD0B}",
        nfd: "\u{1100}\u{116A}\u{11B6}",
        nfkc: "\u{AD0B}",
        nfkd: "\u{1100}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AD0C}",
        nfc: "\u{AD0C}",
        nfd: "\u{1100}\u{116A}\u{11B7}",
        nfkc: "\u{AD0C}",
        nfkd: "\u{1100}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AD0D}",
        nfc: "\u{AD0D}",
        nfd: "\u{1100}\u{116A}\u{11B8}",
        nfkc: "\u{AD0D}",
        nfkd: "\u{1100}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AD0E}",
        nfc: "\u{AD0E}",
        nfd: "\u{1100}\u{116A}\u{11B9}",
        nfkc: "\u{AD0E}",
        nfkd: "\u{1100}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AD0F}",
        nfc: "\u{AD0F}",
        nfd: "\u{1100}\u{116A}\u{11BA}",
        nfkc: "\u{AD0F}",
        nfkd: "\u{1100}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AD10}",
        nfc: "\u{AD10}",
        nfd: "\u{1100}\u{116A}\u{11BB}",
        nfkc: "\u{AD10}",
        nfkd: "\u{1100}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AD11}",
        nfc: "\u{AD11}",
        nfd: "\u{1100}\u{116A}\u{11BC}",
        nfkc: "\u{AD11}",
        nfkd: "\u{1100}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AD12}",
        nfc: "\u{AD12}",
        nfd: "\u{1100}\u{116A}\u{11BD}",
        nfkc: "\u{AD12}",
        nfkd: "\u{1100}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AD13}",
        nfc: "\u{AD13}",
        nfd: "\u{1100}\u{116A}\u{11BE}",
        nfkc: "\u{AD13}",
        nfkd: "\u{1100}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AD14}",
        nfc: "\u{AD14}",
        nfd: "\u{1100}\u{116A}\u{11BF}",
        nfkc: "\u{AD14}",
        nfkd: "\u{1100}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AD15}",
        nfc: "\u{AD15}",
        nfd: "\u{1100}\u{116A}\u{11C0}",
        nfkc: "\u{AD15}",
        nfkd: "\u{1100}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AD16}",
        nfc: "\u{AD16}",
        nfd: "\u{1100}\u{116A}\u{11C1}",
        nfkc: "\u{AD16}",
        nfkd: "\u{1100}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AD17}",
        nfc: "\u{AD17}",
        nfd: "\u{1100}\u{116A}\u{11C2}",
        nfkc: "\u{AD17}",
        nfkd: "\u{1100}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AD18}",
        nfc: "\u{AD18}",
        nfd: "\u{1100}\u{116B}",
        nfkc: "\u{AD18}",
        nfkd: "\u{1100}\u{116B}",
    },
    NormalizationTest {
        source: "\u{AD19}",
        nfc: "\u{AD19}",
        nfd: "\u{1100}\u{116B}\u{11A8}",
        nfkc: "\u{AD19}",
        nfkd: "\u{1100}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AD1A}",
        nfc: "\u{AD1A}",
        nfd: "\u{1100}\u{116B}\u{11A9}",
        nfkc: "\u{AD1A}",
        nfkd: "\u{1100}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AD1B}",
        nfc: "\u{AD1B}",
        nfd: "\u{1100}\u{116B}\u{11AA}",
        nfkc: "\u{AD1B}",
        nfkd: "\u{1100}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AD1C}",
        nfc: "\u{AD1C}",
        nfd: "\u{1100}\u{116B}\u{11AB}",
        nfkc: "\u{AD1C}",
        nfkd: "\u{1100}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AD1D}",
        nfc: "\u{AD1D}",
        nfd: "\u{1100}\u{116B}\u{11AC}",
        nfkc: "\u{AD1D}",
        nfkd: "\u{1100}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AD1E}",
        nfc: "\u{AD1E}",
        nfd: "\u{1100}\u{116B}\u{11AD}",
        nfkc: "\u{AD1E}",
        nfkd: "\u{1100}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AD1F}",
        nfc: "\u{AD1F}",
        nfd: "\u{1100}\u{116B}\u{11AE}",
        nfkc: "\u{AD1F}",
        nfkd: "\u{1100}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AD20}",
        nfc: "\u{AD20}",
        nfd: "\u{1100}\u{116B}\u{11AF}",
        nfkc: "\u{AD20}",
        nfkd: "\u{1100}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AD21}",
        nfc: "\u{AD21}",
        nfd: "\u{1100}\u{116B}\u{11B0}",
        nfkc: "\u{AD21}",
        nfkd: "\u{1100}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AD22}",
        nfc: "\u{AD22}",
        nfd: "\u{1100}\u{116B}\u{11B1}",
        nfkc: "\u{AD22}",
        nfkd: "\u{1100}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AD23}",
        nfc: "\u{AD23}",
        nfd: "\u{1100}\u{116B}\u{11B2}",
        nfkc: "\u{AD23}",
        nfkd: "\u{1100}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AD24}",
        nfc: "\u{AD24}",
        nfd: "\u{1100}\u{116B}\u{11B3}",
        nfkc: "\u{AD24}",
        nfkd: "\u{1100}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AD25}",
        nfc: "\u{AD25}",
        nfd: "\u{1100}\u{116B}\u{11B4}",
        nfkc: "\u{AD25}",
        nfkd: "\u{1100}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AD26}",
        nfc: "\u{AD26}",
        nfd: "\u{1100}\u{116B}\u{11B5}",
        nfkc: "\u{AD26}",
        nfkd: "\u{1100}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AD27}",
        nfc: "\u{AD27}",
        nfd: "\u{1100}\u{116B}\u{11B6}",
        nfkc: "\u{AD27}",
        nfkd: "\u{1100}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AD28}",
        nfc: "\u{AD28}",
        nfd: "\u{1100}\u{116B}\u{11B7}",
        nfkc: "\u{AD28}",
        nfkd: "\u{1100}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AD29}",
        nfc: "\u{AD29}",
        nfd: "\u{1100}\u{116B}\u{11B8}",
        nfkc: "\u{AD29}",
        nfkd: "\u{1100}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AD2A}",
        nfc: "\u{AD2A}",
        nfd: "\u{1100}\u{116B}\u{11B9}",
        nfkc: "\u{AD2A}",
        nfkd: "\u{1100}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AD2B}",
        nfc: "\u{AD2B}",
        nfd: "\u{1100}\u{116B}\u{11BA}",
        nfkc: "\u{AD2B}",
        nfkd: "\u{1100}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AD2C}",
        nfc: "\u{AD2C}",
        nfd: "\u{1100}\u{116B}\u{11BB}",
        nfkc: "\u{AD2C}",
        nfkd: "\u{1100}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AD2D}",
        nfc: "\u{AD2D}",
        nfd: "\u{1100}\u{116B}\u{11BC}",
        nfkc: "\u{AD2D}",
        nfkd: "\u{1100}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AD2E}",
        nfc: "\u{AD2E}",
        nfd: "\u{1100}\u{116B}\u{11BD}",
        nfkc: "\u{AD2E}",
        nfkd: "\u{1100}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AD2F}",
        nfc: "\u{AD2F}",
        nfd: "\u{1100}\u{116B}\u{11BE}",
        nfkc: "\u{AD2F}",
        nfkd: "\u{1100}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AD30}",
        nfc: "\u{AD30}",
        nfd: "\u{1100}\u{116B}\u{11BF}",
        nfkc: "\u{AD30}",
        nfkd: "\u{1100}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AD31}",
        nfc: "\u{AD31}",
        nfd: "\u{1100}\u{116B}\u{11C0}",
        nfkc: "\u{AD31}",
        nfkd: "\u{1100}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AD32}",
        nfc: "\u{AD32}",
        nfd: "\u{1100}\u{116B}\u{11C1}",
        nfkc: "\u{AD32}",
        nfkd: "\u{1100}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AD33}",
        nfc: "\u{AD33}",
        nfd: "\u{1100}\u{116B}\u{11C2}",
        nfkc: "\u{AD33}",
        nfkd: "\u{1100}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AD34}",
        nfc: "\u{AD34}",
        nfd: "\u{1100}\u{116C}",
        nfkc: "\u{AD34}",
        nfkd: "\u{1100}\u{116C}",
    },
    NormalizationTest {
        source: "\u{AD35}",
        nfc: "\u{AD35}",
        nfd: "\u{1100}\u{116C}\u{11A8}",
        nfkc: "\u{AD35}",
        nfkd: "\u{1100}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AD36}",
        nfc: "\u{AD36}",
        nfd: "\u{1100}\u{116C}\u{11A9}",
        nfkc: "\u{AD36}",
        nfkd: "\u{1100}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AD37}",
        nfc: "\u{AD37}",
        nfd: "\u{1100}\u{116C}\u{11AA}",
        nfkc: "\u{AD37}",
        nfkd: "\u{1100}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AD38}",
        nfc: "\u{AD38}",
        nfd: "\u{1100}\u{116C}\u{11AB}",
        nfkc: "\u{AD38}",
        nfkd: "\u{1100}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AD39}",
        nfc: "\u{AD39}",
        nfd: "\u{1100}\u{116C}\u{11AC}",
        nfkc: "\u{AD39}",
        nfkd: "\u{1100}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AD3A}",
        nfc: "\u{AD3A}",
        nfd: "\u{1100}\u{116C}\u{11AD}",
        nfkc: "\u{AD3A}",
        nfkd: "\u{1100}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AD3B}",
        nfc: "\u{AD3B}",
        nfd: "\u{1100}\u{116C}\u{11AE}",
        nfkc: "\u{AD3B}",
        nfkd: "\u{1100}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AD3C}",
        nfc: "\u{AD3C}",
        nfd: "\u{1100}\u{116C}\u{11AF}",
        nfkc: "\u{AD3C}",
        nfkd: "\u{1100}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AD3D}",
        nfc: "\u{AD3D}",
        nfd: "\u{1100}\u{116C}\u{11B0}",
        nfkc: "\u{AD3D}",
        nfkd: "\u{1100}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AD3E}",
        nfc: "\u{AD3E}",
        nfd: "\u{1100}\u{116C}\u{11B1}",
        nfkc: "\u{AD3E}",
        nfkd: "\u{1100}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AD3F}",
        nfc: "\u{AD3F}",
        nfd: "\u{1100}\u{116C}\u{11B2}",
        nfkc: "\u{AD3F}",
        nfkd: "\u{1100}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AD40}",
        nfc: "\u{AD40}",
        nfd: "\u{1100}\u{116C}\u{11B3}",
        nfkc: "\u{AD40}",
        nfkd: "\u{1100}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AD41}",
        nfc: "\u{AD41}",
        nfd: "\u{1100}\u{116C}\u{11B4}",
        nfkc: "\u{AD41}",
        nfkd: "\u{1100}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AD42}",
        nfc: "\u{AD42}",
        nfd: "\u{1100}\u{116C}\u{11B5}",
        nfkc: "\u{AD42}",
        nfkd: "\u{1100}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AD43}",
        nfc: "\u{AD43}",
        nfd: "\u{1100}\u{116C}\u{11B6}",
        nfkc: "\u{AD43}",
        nfkd: "\u{1100}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AD44}",
        nfc: "\u{AD44}",
        nfd: "\u{1100}\u{116C}\u{11B7}",
        nfkc: "\u{AD44}",
        nfkd: "\u{1100}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AD45}",
        nfc: "\u{AD45}",
        nfd: "\u{1100}\u{116C}\u{11B8}",
        nfkc: "\u{AD45}",
        nfkd: "\u{1100}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AD46}",
        nfc: "\u{AD46}",
        nfd: "\u{1100}\u{116C}\u{11B9}",
        nfkc: "\u{AD46}",
        nfkd: "\u{1100}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AD47}",
        nfc: "\u{AD47}",
        nfd: "\u{1100}\u{116C}\u{11BA}",
        nfkc: "\u{AD47}",
        nfkd: "\u{1100}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AD48}",
        nfc: "\u{AD48}",
        nfd: "\u{1100}\u{116C}\u{11BB}",
        nfkc: "\u{AD48}",
        nfkd: "\u{1100}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AD49}",
        nfc: "\u{AD49}",
        nfd: "\u{1100}\u{116C}\u{11BC}",
        nfkc: "\u{AD49}",
        nfkd: "\u{1100}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AD4A}",
        nfc: "\u{AD4A}",
        nfd: "\u{1100}\u{116C}\u{11BD}",
        nfkc: "\u{AD4A}",
        nfkd: "\u{1100}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AD4B}",
        nfc: "\u{AD4B}",
        nfd: "\u{1100}\u{116C}\u{11BE}",
        nfkc: "\u{AD4B}",
        nfkd: "\u{1100}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AD4C}",
        nfc: "\u{AD4C}",
        nfd: "\u{1100}\u{116C}\u{11BF}",
        nfkc: "\u{AD4C}",
        nfkd: "\u{1100}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AD4D}",
        nfc: "\u{AD4D}",
        nfd: "\u{1100}\u{116C}\u{11C0}",
        nfkc: "\u{AD4D}",
        nfkd: "\u{1100}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AD4E}",
        nfc: "\u{AD4E}",
        nfd: "\u{1100}\u{116C}\u{11C1}",
        nfkc: "\u{AD4E}",
        nfkd: "\u{1100}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AD4F}",
        nfc: "\u{AD4F}",
        nfd: "\u{1100}\u{116C}\u{11C2}",
        nfkc: "\u{AD4F}",
        nfkd: "\u{1100}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AD50}",
        nfc: "\u{AD50}",
        nfd: "\u{1100}\u{116D}",
        nfkc: "\u{AD50}",
        nfkd: "\u{1100}\u{116D}",
    },
    NormalizationTest {
        source: "\u{AD51}",
        nfc: "\u{AD51}",
        nfd: "\u{1100}\u{116D}\u{11A8}",
        nfkc: "\u{AD51}",
        nfkd: "\u{1100}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AD52}",
        nfc: "\u{AD52}",
        nfd: "\u{1100}\u{116D}\u{11A9}",
        nfkc: "\u{AD52}",
        nfkd: "\u{1100}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AD53}",
        nfc: "\u{AD53}",
        nfd: "\u{1100}\u{116D}\u{11AA}",
        nfkc: "\u{AD53}",
        nfkd: "\u{1100}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AD54}",
        nfc: "\u{AD54}",
        nfd: "\u{1100}\u{116D}\u{11AB}",
        nfkc: "\u{AD54}",
        nfkd: "\u{1100}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AD55}",
        nfc: "\u{AD55}",
        nfd: "\u{1100}\u{116D}\u{11AC}",
        nfkc: "\u{AD55}",
        nfkd: "\u{1100}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AD56}",
        nfc: "\u{AD56}",
        nfd: "\u{1100}\u{116D}\u{11AD}",
        nfkc: "\u{AD56}",
        nfkd: "\u{1100}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AD57}",
        nfc: "\u{AD57}",
        nfd: "\u{1100}\u{116D}\u{11AE}",
        nfkc: "\u{AD57}",
        nfkd: "\u{1100}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AD58}",
        nfc: "\u{AD58}",
        nfd: "\u{1100}\u{116D}\u{11AF}",
        nfkc: "\u{AD58}",
        nfkd: "\u{1100}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AD59}",
        nfc: "\u{AD59}",
        nfd: "\u{1100}\u{116D}\u{11B0}",
        nfkc: "\u{AD59}",
        nfkd: "\u{1100}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AD5A}",
        nfc: "\u{AD5A}",
        nfd: "\u{1100}\u{116D}\u{11B1}",
        nfkc: "\u{AD5A}",
        nfkd: "\u{1100}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AD5B}",
        nfc: "\u{AD5B}",
        nfd: "\u{1100}\u{116D}\u{11B2}",
        nfkc: "\u{AD5B}",
        nfkd: "\u{1100}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AD5C}",
        nfc: "\u{AD5C}",
        nfd: "\u{1100}\u{116D}\u{11B3}",
        nfkc: "\u{AD5C}",
        nfkd: "\u{1100}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AD5D}",
        nfc: "\u{AD5D}",
        nfd: "\u{1100}\u{116D}\u{11B4}",
        nfkc: "\u{AD5D}",
        nfkd: "\u{1100}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AD5E}",
        nfc: "\u{AD5E}",
        nfd: "\u{1100}\u{116D}\u{11B5}",
        nfkc: "\u{AD5E}",
        nfkd: "\u{1100}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AD5F}",
        nfc: "\u{AD5F}",
        nfd: "\u{1100}\u{116D}\u{11B6}",
        nfkc: "\u{AD5F}",
        nfkd: "\u{1100}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AD60}",
        nfc: "\u{AD60}",
        nfd: "\u{1100}\u{116D}\u{11B7}",
        nfkc: "\u{AD60}",
        nfkd: "\u{1100}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AD61}",
        nfc: "\u{AD61}",
        nfd: "\u{1100}\u{116D}\u{11B8}",
        nfkc: "\u{AD61}",
        nfkd: "\u{1100}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AD62}",
        nfc: "\u{AD62}",
        nfd: "\u{1100}\u{116D}\u{11B9}",
        nfkc: "\u{AD62}",
        nfkd: "\u{1100}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AD63}",
        nfc: "\u{AD63}",
        nfd: "\u{1100}\u{116D}\u{11BA}",
        nfkc: "\u{AD63}",
        nfkd: "\u{1100}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AD64}",
        nfc: "\u{AD64}",
        nfd: "\u{1100}\u{116D}\u{11BB}",
        nfkc: "\u{AD64}",
        nfkd: "\u{1100}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AD65}",
        nfc: "\u{AD65}",
        nfd: "\u{1100}\u{116D}\u{11BC}",
        nfkc: "\u{AD65}",
        nfkd: "\u{1100}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AD66}",
        nfc: "\u{AD66}",
        nfd: "\u{1100}\u{116D}\u{11BD}",
        nfkc: "\u{AD66}",
        nfkd: "\u{1100}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AD67}",
        nfc: "\u{AD67}",
        nfd: "\u{1100}\u{116D}\u{11BE}",
        nfkc: "\u{AD67}",
        nfkd: "\u{1100}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AD68}",
        nfc: "\u{AD68}",
        nfd: "\u{1100}\u{116D}\u{11BF}",
        nfkc: "\u{AD68}",
        nfkd: "\u{1100}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AD69}",
        nfc: "\u{AD69}",
        nfd: "\u{1100}\u{116D}\u{11C0}",
        nfkc: "\u{AD69}",
        nfkd: "\u{1100}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AD6A}",
        nfc: "\u{AD6A}",
        nfd: "\u{1100}\u{116D}\u{11C1}",
        nfkc: "\u{AD6A}",
        nfkd: "\u{1100}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AD6B}",
        nfc: "\u{AD6B}",
        nfd: "\u{1100}\u{116D}\u{11C2}",
        nfkc: "\u{AD6B}",
        nfkd: "\u{1100}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AD6C}",
        nfc: "\u{AD6C}",
        nfd: "\u{1100}\u{116E}",
        nfkc: "\u{AD6C}",
        nfkd: "\u{1100}\u{116E}",
    },
    NormalizationTest {
        source: "\u{AD6D}",
        nfc: "\u{AD6D}",
        nfd: "\u{1100}\u{116E}\u{11A8}",
        nfkc: "\u{AD6D}",
        nfkd: "\u{1100}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AD6E}",
        nfc: "\u{AD6E}",
        nfd: "\u{1100}\u{116E}\u{11A9}",
        nfkc: "\u{AD6E}",
        nfkd: "\u{1100}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AD6F}",
        nfc: "\u{AD6F}",
        nfd: "\u{1100}\u{116E}\u{11AA}",
        nfkc: "\u{AD6F}",
        nfkd: "\u{1100}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AD70}",
        nfc: "\u{AD70}",
        nfd: "\u{1100}\u{116E}\u{11AB}",
        nfkc: "\u{AD70}",
        nfkd: "\u{1100}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AD71}",
        nfc: "\u{AD71}",
        nfd: "\u{1100}\u{116E}\u{11AC}",
        nfkc: "\u{AD71}",
        nfkd: "\u{1100}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AD72}",
        nfc: "\u{AD72}",
        nfd: "\u{1100}\u{116E}\u{11AD}",
        nfkc: "\u{AD72}",
        nfkd: "\u{1100}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AD73}",
        nfc: "\u{AD73}",
        nfd: "\u{1100}\u{116E}\u{11AE}",
        nfkc: "\u{AD73}",
        nfkd: "\u{1100}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AD74}",
        nfc: "\u{AD74}",
        nfd: "\u{1100}\u{116E}\u{11AF}",
        nfkc: "\u{AD74}",
        nfkd: "\u{1100}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AD75}",
        nfc: "\u{AD75}",
        nfd: "\u{1100}\u{116E}\u{11B0}",
        nfkc: "\u{AD75}",
        nfkd: "\u{1100}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AD76}",
        nfc: "\u{AD76}",
        nfd: "\u{1100}\u{116E}\u{11B1}",
        nfkc: "\u{AD76}",
        nfkd: "\u{1100}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AD77}",
        nfc: "\u{AD77}",
        nfd: "\u{1100}\u{116E}\u{11B2}",
        nfkc: "\u{AD77}",
        nfkd: "\u{1100}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AD78}",
        nfc: "\u{AD78}",
        nfd: "\u{1100}\u{116E}\u{11B3}",
        nfkc: "\u{AD78}",
        nfkd: "\u{1100}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AD79}",
        nfc: "\u{AD79}",
        nfd: "\u{1100}\u{116E}\u{11B4}",
        nfkc: "\u{AD79}",
        nfkd: "\u{1100}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AD7A}",
        nfc: "\u{AD7A}",
        nfd: "\u{1100}\u{116E}\u{11B5}",
        nfkc: "\u{AD7A}",
        nfkd: "\u{1100}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AD7B}",
        nfc: "\u{AD7B}",
        nfd: "\u{1100}\u{116E}\u{11B6}",
        nfkc: "\u{AD7B}",
        nfkd: "\u{1100}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AD7C}",
        nfc: "\u{AD7C}",
        nfd: "\u{1100}\u{116E}\u{11B7}",
        nfkc: "\u{AD7C}",
        nfkd: "\u{1100}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AD7D}",
        nfc: "\u{AD7D}",
        nfd: "\u{1100}\u{116E}\u{11B8}",
        nfkc: "\u{AD7D}",
        nfkd: "\u{1100}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AD7E}",
        nfc: "\u{AD7E}",
        nfd: "\u{1100}\u{116E}\u{11B9}",
        nfkc: "\u{AD7E}",
        nfkd: "\u{1100}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AD7F}",
        nfc: "\u{AD7F}",
        nfd: "\u{1100}\u{116E}\u{11BA}",
        nfkc: "\u{AD7F}",
        nfkd: "\u{1100}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AD80}",
        nfc: "\u{AD80}",
        nfd: "\u{1100}\u{116E}\u{11BB}",
        nfkc: "\u{AD80}",
        nfkd: "\u{1100}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AD81}",
        nfc: "\u{AD81}",
        nfd: "\u{1100}\u{116E}\u{11BC}",
        nfkc: "\u{AD81}",
        nfkd: "\u{1100}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AD82}",
        nfc: "\u{AD82}",
        nfd: "\u{1100}\u{116E}\u{11BD}",
        nfkc: "\u{AD82}",
        nfkd: "\u{1100}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AD83}",
        nfc: "\u{AD83}",
        nfd: "\u{1100}\u{116E}\u{11BE}",
        nfkc: "\u{AD83}",
        nfkd: "\u{1100}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AD84}",
        nfc: "\u{AD84}",
        nfd: "\u{1100}\u{116E}\u{11BF}",
        nfkc: "\u{AD84}",
        nfkd: "\u{1100}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AD85}",
        nfc: "\u{AD85}",
        nfd: "\u{1100}\u{116E}\u{11C0}",
        nfkc: "\u{AD85}",
        nfkd: "\u{1100}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AD86}",
        nfc: "\u{AD86}",
        nfd: "\u{1100}\u{116E}\u{11C1}",
        nfkc: "\u{AD86}",
        nfkd: "\u{1100}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AD87}",
        nfc: "\u{AD87}",
        nfd: "\u{1100}\u{116E}\u{11C2}",
        nfkc: "\u{AD87}",
        nfkd: "\u{1100}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AD88}",
        nfc: "\u{AD88}",
        nfd: "\u{1100}\u{116F}",
        nfkc: "\u{AD88}",
        nfkd: "\u{1100}\u{116F}",
    },
    NormalizationTest {
        source: "\u{AD89}",
        nfc: "\u{AD89}",
        nfd: "\u{1100}\u{116F}\u{11A8}",
        nfkc: "\u{AD89}",
        nfkd: "\u{1100}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AD8A}",
        nfc: "\u{AD8A}",
        nfd: "\u{1100}\u{116F}\u{11A9}",
        nfkc: "\u{AD8A}",
        nfkd: "\u{1100}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AD8B}",
        nfc: "\u{AD8B}",
        nfd: "\u{1100}\u{116F}\u{11AA}",
        nfkc: "\u{AD8B}",
        nfkd: "\u{1100}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AD8C}",
        nfc: "\u{AD8C}",
        nfd: "\u{1100}\u{116F}\u{11AB}",
        nfkc: "\u{AD8C}",
        nfkd: "\u{1100}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AD8D}",
        nfc: "\u{AD8D}",
        nfd: "\u{1100}\u{116F}\u{11AC}",
        nfkc: "\u{AD8D}",
        nfkd: "\u{1100}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AD8E}",
        nfc: "\u{AD8E}",
        nfd: "\u{1100}\u{116F}\u{11AD}",
        nfkc: "\u{AD8E}",
        nfkd: "\u{1100}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AD8F}",
        nfc: "\u{AD8F}",
        nfd: "\u{1100}\u{116F}\u{11AE}",
        nfkc: "\u{AD8F}",
        nfkd: "\u{1100}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AD90}",
        nfc: "\u{AD90}",
        nfd: "\u{1100}\u{116F}\u{11AF}",
        nfkc: "\u{AD90}",
        nfkd: "\u{1100}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AD91}",
        nfc: "\u{AD91}",
        nfd: "\u{1100}\u{116F}\u{11B0}",
        nfkc: "\u{AD91}",
        nfkd: "\u{1100}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AD92}",
        nfc: "\u{AD92}",
        nfd: "\u{1100}\u{116F}\u{11B1}",
        nfkc: "\u{AD92}",
        nfkd: "\u{1100}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AD93}",
        nfc: "\u{AD93}",
        nfd: "\u{1100}\u{116F}\u{11B2}",
        nfkc: "\u{AD93}",
        nfkd: "\u{1100}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AD94}",
        nfc: "\u{AD94}",
        nfd: "\u{1100}\u{116F}\u{11B3}",
        nfkc: "\u{AD94}",
        nfkd: "\u{1100}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AD95}",
        nfc: "\u{AD95}",
        nfd: "\u{1100}\u{116F}\u{11B4}",
        nfkc: "\u{AD95}",
        nfkd: "\u{1100}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AD96}",
        nfc: "\u{AD96}",
        nfd: "\u{1100}\u{116F}\u{11B5}",
        nfkc: "\u{AD96}",
        nfkd: "\u{1100}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AD97}",
        nfc: "\u{AD97}",
        nfd: "\u{1100}\u{116F}\u{11B6}",
        nfkc: "\u{AD97}",
        nfkd: "\u{1100}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AD98}",
        nfc: "\u{AD98}",
        nfd: "\u{1100}\u{116F}\u{11B7}",
        nfkc: "\u{AD98}",
        nfkd: "\u{1100}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AD99}",
        nfc: "\u{AD99}",
        nfd: "\u{1100}\u{116F}\u{11B8}",
        nfkc: "\u{AD99}",
        nfkd: "\u{1100}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AD9A}",
        nfc: "\u{AD9A}",
        nfd: "\u{1100}\u{116F}\u{11B9}",
        nfkc: "\u{AD9A}",
        nfkd: "\u{1100}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AD9B}",
        nfc: "\u{AD9B}",
        nfd: "\u{1100}\u{116F}\u{11BA}",
        nfkc: "\u{AD9B}",
        nfkd: "\u{1100}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AD9C}",
        nfc: "\u{AD9C}",
        nfd: "\u{1100}\u{116F}\u{11BB}",
        nfkc: "\u{AD9C}",
        nfkd: "\u{1100}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AD9D}",
        nfc: "\u{AD9D}",
        nfd: "\u{1100}\u{116F}\u{11BC}",
        nfkc: "\u{AD9D}",
        nfkd: "\u{1100}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AD9E}",
        nfc: "\u{AD9E}",
        nfd: "\u{1100}\u{116F}\u{11BD}",
        nfkc: "\u{AD9E}",
        nfkd: "\u{1100}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AD9F}",
        nfc: "\u{AD9F}",
        nfd: "\u{1100}\u{116F}\u{11BE}",
        nfkc: "\u{AD9F}",
        nfkd: "\u{1100}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{ADA0}",
        nfc: "\u{ADA0}",
        nfd: "\u{1100}\u{116F}\u{11BF}",
        nfkc: "\u{ADA0}",
        nfkd: "\u{1100}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{ADA1}",
        nfc: "\u{ADA1}",
        nfd: "\u{1100}\u{116F}\u{11C0}",
        nfkc: "\u{ADA1}",
        nfkd: "\u{1100}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{ADA2}",
        nfc: "\u{ADA2}",
        nfd: "\u{1100}\u{116F}\u{11C1}",
        nfkc: "\u{ADA2}",
        nfkd: "\u{1100}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{ADA3}",
        nfc: "\u{ADA3}",
        nfd: "\u{1100}\u{116F}\u{11C2}",
        nfkc: "\u{ADA3}",
        nfkd: "\u{1100}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{ADA4}",
        nfc: "\u{ADA4}",
        nfd: "\u{1100}\u{1170}",
        nfkc: "\u{ADA4}",
        nfkd: "\u{1100}\u{1170}",
    },
    NormalizationTest {
        source: "\u{ADA5}",
        nfc: "\u{ADA5}",
        nfd: "\u{1100}\u{1170}\u{11A8}",
        nfkc: "\u{ADA5}",
        nfkd: "\u{1100}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{ADA6}",
        nfc: "\u{ADA6}",
        nfd: "\u{1100}\u{1170}\u{11A9}",
        nfkc: "\u{ADA6}",
        nfkd: "\u{1100}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{ADA7}",
        nfc: "\u{ADA7}",
        nfd: "\u{1100}\u{1170}\u{11AA}",
        nfkc: "\u{ADA7}",
        nfkd: "\u{1100}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{ADA8}",
        nfc: "\u{ADA8}",
        nfd: "\u{1100}\u{1170}\u{11AB}",
        nfkc: "\u{ADA8}",
        nfkd: "\u{1100}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{ADA9}",
        nfc: "\u{ADA9}",
        nfd: "\u{1100}\u{1170}\u{11AC}",
        nfkc: "\u{ADA9}",
        nfkd: "\u{1100}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{ADAA}",
        nfc: "\u{ADAA}",
        nfd: "\u{1100}\u{1170}\u{11AD}",
        nfkc: "\u{ADAA}",
        nfkd: "\u{1100}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{ADAB}",
        nfc: "\u{ADAB}",
        nfd: "\u{1100}\u{1170}\u{11AE}",
        nfkc: "\u{ADAB}",
        nfkd: "\u{1100}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{ADAC}",
        nfc: "\u{ADAC}",
        nfd: "\u{1100}\u{1170}\u{11AF}",
        nfkc: "\u{ADAC}",
        nfkd: "\u{1100}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{ADAD}",
        nfc: "\u{ADAD}",
        nfd: "\u{1100}\u{1170}\u{11B0}",
        nfkc: "\u{ADAD}",
        nfkd: "\u{1100}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{ADAE}",
        nfc: "\u{ADAE}",
        nfd: "\u{1100}\u{1170}\u{11B1}",
        nfkc: "\u{ADAE}",
        nfkd: "\u{1100}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{ADAF}",
        nfc: "\u{ADAF}",
        nfd: "\u{1100}\u{1170}\u{11B2}",
        nfkc: "\u{ADAF}",
        nfkd: "\u{1100}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{ADB0}",
        nfc: "\u{ADB0}",
        nfd: "\u{1100}\u{1170}\u{11B3}",
        nfkc: "\u{ADB0}",
        nfkd: "\u{1100}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{ADB1}",
        nfc: "\u{ADB1}",
        nfd: "\u{1100}\u{1170}\u{11B4}",
        nfkc: "\u{ADB1}",
        nfkd: "\u{1100}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{ADB2}",
        nfc: "\u{ADB2}",
        nfd: "\u{1100}\u{1170}\u{11B5}",
        nfkc: "\u{ADB2}",
        nfkd: "\u{1100}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{ADB3}",
        nfc: "\u{ADB3}",
        nfd: "\u{1100}\u{1170}\u{11B6}",
        nfkc: "\u{ADB3}",
        nfkd: "\u{1100}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{ADB4}",
        nfc: "\u{ADB4}",
        nfd: "\u{1100}\u{1170}\u{11B7}",
        nfkc: "\u{ADB4}",
        nfkd: "\u{1100}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{ADB5}",
        nfc: "\u{ADB5}",
        nfd: "\u{1100}\u{1170}\u{11B8}",
        nfkc: "\u{ADB5}",
        nfkd: "\u{1100}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{ADB6}",
        nfc: "\u{ADB6}",
        nfd: "\u{1100}\u{1170}\u{11B9}",
        nfkc: "\u{ADB6}",
        nfkd: "\u{1100}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{ADB7}",
        nfc: "\u{ADB7}",
        nfd: "\u{1100}\u{1170}\u{11BA}",
        nfkc: "\u{ADB7}",
        nfkd: "\u{1100}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{ADB8}",
        nfc: "\u{ADB8}",
        nfd: "\u{1100}\u{1170}\u{11BB}",
        nfkc: "\u{ADB8}",
        nfkd: "\u{1100}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{ADB9}",
        nfc: "\u{ADB9}",
        nfd: "\u{1100}\u{1170}\u{11BC}",
        nfkc: "\u{ADB9}",
        nfkd: "\u{1100}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{ADBA}",
        nfc: "\u{ADBA}",
        nfd: "\u{1100}\u{1170}\u{11BD}",
        nfkc: "\u{ADBA}",
        nfkd: "\u{1100}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{ADBB}",
        nfc: "\u{ADBB}",
        nfd: "\u{1100}\u{1170}\u{11BE}",
        nfkc: "\u{ADBB}",
        nfkd: "\u{1100}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{ADBC}",
        nfc: "\u{ADBC}",
        nfd: "\u{1100}\u{1170}\u{11BF}",
        nfkc: "\u{ADBC}",
        nfkd: "\u{1100}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{ADBD}",
        nfc: "\u{ADBD}",
        nfd: "\u{1100}\u{1170}\u{11C0}",
        nfkc: "\u{ADBD}",
        nfkd: "\u{1100}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{ADBE}",
        nfc: "\u{ADBE}",
        nfd: "\u{1100}\u{1170}\u{11C1}",
        nfkc: "\u{ADBE}",
        nfkd: "\u{1100}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{ADBF}",
        nfc: "\u{ADBF}",
        nfd: "\u{1100}\u{1170}\u{11C2}",
        nfkc: "\u{ADBF}",
        nfkd: "\u{1100}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{ADC0}",
        nfc: "\u{ADC0}",
        nfd: "\u{1100}\u{1171}",
        nfkc: "\u{ADC0}",
        nfkd: "\u{1100}\u{1171}",
    },
    NormalizationTest {
        source: "\u{ADC1}",
        nfc: "\u{ADC1}",
        nfd: "\u{1100}\u{1171}\u{11A8}",
        nfkc: "\u{ADC1}",
        nfkd: "\u{1100}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{ADC2}",
        nfc: "\u{ADC2}",
        nfd: "\u{1100}\u{1171}\u{11A9}",
        nfkc: "\u{ADC2}",
        nfkd: "\u{1100}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{ADC3}",
        nfc: "\u{ADC3}",
        nfd: "\u{1100}\u{1171}\u{11AA}",
        nfkc: "\u{ADC3}",
        nfkd: "\u{1100}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{ADC4}",
        nfc: "\u{ADC4}",
        nfd: "\u{1100}\u{1171}\u{11AB}",
        nfkc: "\u{ADC4}",
        nfkd: "\u{1100}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{ADC5}",
        nfc: "\u{ADC5}",
        nfd: "\u{1100}\u{1171}\u{11AC}",
        nfkc: "\u{ADC5}",
        nfkd: "\u{1100}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{ADC6}",
        nfc: "\u{ADC6}",
        nfd: "\u{1100}\u{1171}\u{11AD}",
        nfkc: "\u{ADC6}",
        nfkd: "\u{1100}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{ADC7}",
        nfc: "\u{ADC7}",
        nfd: "\u{1100}\u{1171}\u{11AE}",
        nfkc: "\u{ADC7}",
        nfkd: "\u{1100}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{ADC8}",
        nfc: "\u{ADC8}",
        nfd: "\u{1100}\u{1171}\u{11AF}",
        nfkc: "\u{ADC8}",
        nfkd: "\u{1100}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{ADC9}",
        nfc: "\u{ADC9}",
        nfd: "\u{1100}\u{1171}\u{11B0}",
        nfkc: "\u{ADC9}",
        nfkd: "\u{1100}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{ADCA}",
        nfc: "\u{ADCA}",
        nfd: "\u{1100}\u{1171}\u{11B1}",
        nfkc: "\u{ADCA}",
        nfkd: "\u{1100}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{ADCB}",
        nfc: "\u{ADCB}",
        nfd: "\u{1100}\u{1171}\u{11B2}",
        nfkc: "\u{ADCB}",
        nfkd: "\u{1100}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{ADCC}",
        nfc: "\u{ADCC}",
        nfd: "\u{1100}\u{1171}\u{11B3}",
        nfkc: "\u{ADCC}",
        nfkd: "\u{1100}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{ADCD}",
        nfc: "\u{ADCD}",
        nfd: "\u{1100}\u{1171}\u{11B4}",
        nfkc: "\u{ADCD}",
        nfkd: "\u{1100}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{ADCE}",
        nfc: "\u{ADCE}",
        nfd: "\u{1100}\u{1171}\u{11B5}",
        nfkc: "\u{ADCE}",
        nfkd: "\u{1100}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{ADCF}",
        nfc: "\u{ADCF}",
        nfd: "\u{1100}\u{1171}\u{11B6}",
        nfkc: "\u{ADCF}",
        nfkd: "\u{1100}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{ADD0}",
        nfc: "\u{ADD0}",
        nfd: "\u{1100}\u{1171}\u{11B7}",
        nfkc: "\u{ADD0}",
        nfkd: "\u{1100}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{ADD1}",
        nfc: "\u{ADD1}",
        nfd: "\u{1100}\u{1171}\u{11B8}",
        nfkc: "\u{ADD1}",
        nfkd: "\u{1100}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{ADD2}",
        nfc: "\u{ADD2}",
        nfd: "\u{1100}\u{1171}\u{11B9}",
        nfkc: "\u{ADD2}",
        nfkd: "\u{1100}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{ADD3}",
        nfc: "\u{ADD3}",
        nfd: "\u{1100}\u{1171}\u{11BA}",
        nfkc: "\u{ADD3}",
        nfkd: "\u{1100}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{ADD4}",
        nfc: "\u{ADD4}",
        nfd: "\u{1100}\u{1171}\u{11BB}",
        nfkc: "\u{ADD4}",
        nfkd: "\u{1100}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{ADD5}",
        nfc: "\u{ADD5}",
        nfd: "\u{1100}\u{1171}\u{11BC}",
        nfkc: "\u{ADD5}",
        nfkd: "\u{1100}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{ADD6}",
        nfc: "\u{ADD6}",
        nfd: "\u{1100}\u{1171}\u{11BD}",
        nfkc: "\u{ADD6}",
        nfkd: "\u{1100}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{ADD7}",
        nfc: "\u{ADD7}",
        nfd: "\u{1100}\u{1171}\u{11BE}",
        nfkc: "\u{ADD7}",
        nfkd: "\u{1100}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{ADD8}",
        nfc: "\u{ADD8}",
        nfd: "\u{1100}\u{1171}\u{11BF}",
        nfkc: "\u{ADD8}",
        nfkd: "\u{1100}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{ADD9}",
        nfc: "\u{ADD9}",
        nfd: "\u{1100}\u{1171}\u{11C0}",
        nfkc: "\u{ADD9}",
        nfkd: "\u{1100}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{ADDA}",
        nfc: "\u{ADDA}",
        nfd: "\u{1100}\u{1171}\u{11C1}",
        nfkc: "\u{ADDA}",
        nfkd: "\u{1100}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{ADDB}",
        nfc: "\u{ADDB}",
        nfd: "\u{1100}\u{1171}\u{11C2}",
        nfkc: "\u{ADDB}",
        nfkd: "\u{1100}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{ADDC}",
        nfc: "\u{ADDC}",
        nfd: "\u{1100}\u{1172}",
        nfkc: "\u{ADDC}",
        nfkd: "\u{1100}\u{1172}",
    },
    NormalizationTest {
        source: "\u{ADDD}",
        nfc: "\u{ADDD}",
        nfd: "\u{1100}\u{1172}\u{11A8}",
        nfkc: "\u{ADDD}",
        nfkd: "\u{1100}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{ADDE}",
        nfc: "\u{ADDE}",
        nfd: "\u{1100}\u{1172}\u{11A9}",
        nfkc: "\u{ADDE}",
        nfkd: "\u{1100}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{ADDF}",
        nfc: "\u{ADDF}",
        nfd: "\u{1100}\u{1172}\u{11AA}",
        nfkc: "\u{ADDF}",
        nfkd: "\u{1100}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{ADE0}",
        nfc: "\u{ADE0}",
        nfd: "\u{1100}\u{1172}\u{11AB}",
        nfkc: "\u{ADE0}",
        nfkd: "\u{1100}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{ADE1}",
        nfc: "\u{ADE1}",
        nfd: "\u{1100}\u{1172}\u{11AC}",
        nfkc: "\u{ADE1}",
        nfkd: "\u{1100}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{ADE2}",
        nfc: "\u{ADE2}",
        nfd: "\u{1100}\u{1172}\u{11AD}",
        nfkc: "\u{ADE2}",
        nfkd: "\u{1100}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{ADE3}",
        nfc: "\u{ADE3}",
        nfd: "\u{1100}\u{1172}\u{11AE}",
        nfkc: "\u{ADE3}",
        nfkd: "\u{1100}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{ADE4}",
        nfc: "\u{ADE4}",
        nfd: "\u{1100}\u{1172}\u{11AF}",
        nfkc: "\u{ADE4}",
        nfkd: "\u{1100}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{ADE5}",
        nfc: "\u{ADE5}",
        nfd: "\u{1100}\u{1172}\u{11B0}",
        nfkc: "\u{ADE5}",
        nfkd: "\u{1100}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{ADE6}",
        nfc: "\u{ADE6}",
        nfd: "\u{1100}\u{1172}\u{11B1}",
        nfkc: "\u{ADE6}",
        nfkd: "\u{1100}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{ADE7}",
        nfc: "\u{ADE7}",
        nfd: "\u{1100}\u{1172}\u{11B2}",
        nfkc: "\u{ADE7}",
        nfkd: "\u{1100}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{ADE8}",
        nfc: "\u{ADE8}",
        nfd: "\u{1100}\u{1172}\u{11B3}",
        nfkc: "\u{ADE8}",
        nfkd: "\u{1100}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{ADE9}",
        nfc: "\u{ADE9}",
        nfd: "\u{1100}\u{1172}\u{11B4}",
        nfkc: "\u{ADE9}",
        nfkd: "\u{1100}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{ADEA}",
        nfc: "\u{ADEA}",
        nfd: "\u{1100}\u{1172}\u{11B5}",
        nfkc: "\u{ADEA}",
        nfkd: "\u{1100}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{ADEB}",
        nfc: "\u{ADEB}",
        nfd: "\u{1100}\u{1172}\u{11B6}",
        nfkc: "\u{ADEB}",
        nfkd: "\u{1100}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{ADEC}",
        nfc: "\u{ADEC}",
        nfd: "\u{1100}\u{1172}\u{11B7}",
        nfkc: "\u{ADEC}",
        nfkd: "\u{1100}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{ADED}",
        nfc: "\u{ADED}",
        nfd: "\u{1100}\u{1172}\u{11B8}",
        nfkc: "\u{ADED}",
        nfkd: "\u{1100}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{ADEE}",
        nfc: "\u{ADEE}",
        nfd: "\u{1100}\u{1172}\u{11B9}",
        nfkc: "\u{ADEE}",
        nfkd: "\u{1100}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{ADEF}",
        nfc: "\u{ADEF}",
        nfd: "\u{1100}\u{1172}\u{11BA}",
        nfkc: "\u{ADEF}",
        nfkd: "\u{1100}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{ADF0}",
        nfc: "\u{ADF0}",
        nfd: "\u{1100}\u{1172}\u{11BB}",
        nfkc: "\u{ADF0}",
        nfkd: "\u{1100}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{ADF1}",
        nfc: "\u{ADF1}",
        nfd: "\u{1100}\u{1172}\u{11BC}",
        nfkc: "\u{ADF1}",
        nfkd: "\u{1100}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{ADF2}",
        nfc: "\u{ADF2}",
        nfd: "\u{1100}\u{1172}\u{11BD}",
        nfkc: "\u{ADF2}",
        nfkd: "\u{1100}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{ADF3}",
        nfc: "\u{ADF3}",
        nfd: "\u{1100}\u{1172}\u{11BE}",
        nfkc: "\u{ADF3}",
        nfkd: "\u{1100}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{ADF4}",
        nfc: "\u{ADF4}",
        nfd: "\u{1100}\u{1172}\u{11BF}",
        nfkc: "\u{ADF4}",
        nfkd: "\u{1100}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{ADF5}",
        nfc: "\u{ADF5}",
        nfd: "\u{1100}\u{1172}\u{11C0}",
        nfkc: "\u{ADF5}",
        nfkd: "\u{1100}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{ADF6}",
        nfc: "\u{ADF6}",
        nfd: "\u{1100}\u{1172}\u{11C1}",
        nfkc: "\u{ADF6}",
        nfkd: "\u{1100}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{ADF7}",
        nfc: "\u{ADF7}",
        nfd: "\u{1100}\u{1172}\u{11C2}",
        nfkc: "\u{ADF7}",
        nfkd: "\u{1100}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{ADF8}",
        nfc: "\u{ADF8}",
        nfd: "\u{1100}\u{1173}",
        nfkc: "\u{ADF8}",
        nfkd: "\u{1100}\u{1173}",
    },
    NormalizationTest {
        source: "\u{ADF9}",
        nfc: "\u{ADF9}",
        nfd: "\u{1100}\u{1173}\u{11A8}",
        nfkc: "\u{ADF9}",
        nfkd: "\u{1100}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{ADFA}",
        nfc: "\u{ADFA}",
        nfd: "\u{1100}\u{1173}\u{11A9}",
        nfkc: "\u{ADFA}",
        nfkd: "\u{1100}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{ADFB}",
        nfc: "\u{ADFB}",
        nfd: "\u{1100}\u{1173}\u{11AA}",
        nfkc: "\u{ADFB}",
        nfkd: "\u{1100}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{ADFC}",
        nfc: "\u{ADFC}",
        nfd: "\u{1100}\u{1173}\u{11AB}",
        nfkc: "\u{ADFC}",
        nfkd: "\u{1100}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{ADFD}",
        nfc: "\u{ADFD}",
        nfd: "\u{1100}\u{1173}\u{11AC}",
        nfkc: "\u{ADFD}",
        nfkd: "\u{1100}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{ADFE}",
        nfc: "\u{ADFE}",
        nfd: "\u{1100}\u{1173}\u{11AD}",
        nfkc: "\u{ADFE}",
        nfkd: "\u{1100}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{ADFF}",
        nfc: "\u{ADFF}",
        nfd: "\u{1100}\u{1173}\u{11AE}",
        nfkc: "\u{ADFF}",
        nfkd: "\u{1100}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AE00}",
        nfc: "\u{AE00}",
        nfd: "\u{1100}\u{1173}\u{11AF}",
        nfkc: "\u{AE00}",
        nfkd: "\u{1100}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AE01}",
        nfc: "\u{AE01}",
        nfd: "\u{1100}\u{1173}\u{11B0}",
        nfkc: "\u{AE01}",
        nfkd: "\u{1100}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AE02}",
        nfc: "\u{AE02}",
        nfd: "\u{1100}\u{1173}\u{11B1}",
        nfkc: "\u{AE02}",
        nfkd: "\u{1100}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AE03}",
        nfc: "\u{AE03}",
        nfd: "\u{1100}\u{1173}\u{11B2}",
        nfkc: "\u{AE03}",
        nfkd: "\u{1100}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AE04}",
        nfc: "\u{AE04}",
        nfd: "\u{1100}\u{1173}\u{11B3}",
        nfkc: "\u{AE04}",
        nfkd: "\u{1100}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AE05}",
        nfc: "\u{AE05}",
        nfd: "\u{1100}\u{1173}\u{11B4}",
        nfkc: "\u{AE05}",
        nfkd: "\u{1100}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AE06}",
        nfc: "\u{AE06}",
        nfd: "\u{1100}\u{1173}\u{11B5}",
        nfkc: "\u{AE06}",
        nfkd: "\u{1100}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AE07}",
        nfc: "\u{AE07}",
        nfd: "\u{1100}\u{1173}\u{11B6}",
        nfkc: "\u{AE07}",
        nfkd: "\u{1100}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AE08}",
        nfc: "\u{AE08}",
        nfd: "\u{1100}\u{1173}\u{11B7}",
        nfkc: "\u{AE08}",
        nfkd: "\u{1100}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AE09}",
        nfc: "\u{AE09}",
        nfd: "\u{1100}\u{1173}\u{11B8}",
        nfkc: "\u{AE09}",
        nfkd: "\u{1100}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AE0A}",
        nfc: "\u{AE0A}",
        nfd: "\u{1100}\u{1173}\u{11B9}",
        nfkc: "\u{AE0A}",
        nfkd: "\u{1100}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AE0B}",
        nfc: "\u{AE0B}",
        nfd: "\u{1100}\u{1173}\u{11BA}",
        nfkc: "\u{AE0B}",
        nfkd: "\u{1100}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AE0C}",
        nfc: "\u{AE0C}",
        nfd: "\u{1100}\u{1173}\u{11BB}",
        nfkc: "\u{AE0C}",
        nfkd: "\u{1100}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AE0D}",
        nfc: "\u{AE0D}",
        nfd: "\u{1100}\u{1173}\u{11BC}",
        nfkc: "\u{AE0D}",
        nfkd: "\u{1100}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AE0E}",
        nfc: "\u{AE0E}",
        nfd: "\u{1100}\u{1173}\u{11BD}",
        nfkc: "\u{AE0E}",
        nfkd: "\u{1100}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AE0F}",
        nfc: "\u{AE0F}",
        nfd: "\u{1100}\u{1173}\u{11BE}",
        nfkc: "\u{AE0F}",
        nfkd: "\u{1100}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AE10}",
        nfc: "\u{AE10}",
        nfd: "\u{1100}\u{1173}\u{11BF}",
        nfkc: "\u{AE10}",
        nfkd: "\u{1100}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AE11}",
        nfc: "\u{AE11}",
        nfd: "\u{1100}\u{1173}\u{11C0}",
        nfkc: "\u{AE11}",
        nfkd: "\u{1100}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AE12}",
        nfc: "\u{AE12}",
        nfd: "\u{1100}\u{1173}\u{11C1}",
        nfkc: "\u{AE12}",
        nfkd: "\u{1100}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AE13}",
        nfc: "\u{AE13}",
        nfd: "\u{1100}\u{1173}\u{11C2}",
        nfkc: "\u{AE13}",
        nfkd: "\u{1100}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AE14}",
        nfc: "\u{AE14}",
        nfd: "\u{1100}\u{1174}",
        nfkc: "\u{AE14}",
        nfkd: "\u{1100}\u{1174}",
    },
    NormalizationTest {
        source: "\u{AE15}",
        nfc: "\u{AE15}",
        nfd: "\u{1100}\u{1174}\u{11A8}",
        nfkc: "\u{AE15}",
        nfkd: "\u{1100}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AE16}",
        nfc: "\u{AE16}",
        nfd: "\u{1100}\u{1174}\u{11A9}",
        nfkc: "\u{AE16}",
        nfkd: "\u{1100}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AE17}",
        nfc: "\u{AE17}",
        nfd: "\u{1100}\u{1174}\u{11AA}",
        nfkc: "\u{AE17}",
        nfkd: "\u{1100}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AE18}",
        nfc: "\u{AE18}",
        nfd: "\u{1100}\u{1174}\u{11AB}",
        nfkc: "\u{AE18}",
        nfkd: "\u{1100}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AE19}",
        nfc: "\u{AE19}",
        nfd: "\u{1100}\u{1174}\u{11AC}",
        nfkc: "\u{AE19}",
        nfkd: "\u{1100}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AE1A}",
        nfc: "\u{AE1A}",
        nfd: "\u{1100}\u{1174}\u{11AD}",
        nfkc: "\u{AE1A}",
        nfkd: "\u{1100}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AE1B}",
        nfc: "\u{AE1B}",
        nfd: "\u{1100}\u{1174}\u{11AE}",
        nfkc: "\u{AE1B}",
        nfkd: "\u{1100}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AE1C}",
        nfc: "\u{AE1C}",
        nfd: "\u{1100}\u{1174}\u{11AF}",
        nfkc: "\u{AE1C}",
        nfkd: "\u{1100}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AE1D}",
        nfc: "\u{AE1D}",
        nfd: "\u{1100}\u{1174}\u{11B0}",
        nfkc: "\u{AE1D}",
        nfkd: "\u{1100}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AE1E}",
        nfc: "\u{AE1E}",
        nfd: "\u{1100}\u{1174}\u{11B1}",
        nfkc: "\u{AE1E}",
        nfkd: "\u{1100}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AE1F}",
        nfc: "\u{AE1F}",
        nfd: "\u{1100}\u{1174}\u{11B2}",
        nfkc: "\u{AE1F}",
        nfkd: "\u{1100}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AE20}",
        nfc: "\u{AE20}",
        nfd: "\u{1100}\u{1174}\u{11B3}",
        nfkc: "\u{AE20}",
        nfkd: "\u{1100}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AE21}",
        nfc: "\u{AE21}",
        nfd: "\u{1100}\u{1174}\u{11B4}",
        nfkc: "\u{AE21}",
        nfkd: "\u{1100}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AE22}",
        nfc: "\u{AE22}",
        nfd: "\u{1100}\u{1174}\u{11B5}",
        nfkc: "\u{AE22}",
        nfkd: "\u{1100}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AE23}",
        nfc: "\u{AE23}",
        nfd: "\u{1100}\u{1174}\u{11B6}",
        nfkc: "\u{AE23}",
        nfkd: "\u{1100}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AE24}",
        nfc: "\u{AE24}",
        nfd: "\u{1100}\u{1174}\u{11B7}",
        nfkc: "\u{AE24}",
        nfkd: "\u{1100}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AE25}",
        nfc: "\u{AE25}",
        nfd: "\u{1100}\u{1174}\u{11B8}",
        nfkc: "\u{AE25}",
        nfkd: "\u{1100}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AE26}",
        nfc: "\u{AE26}",
        nfd: "\u{1100}\u{1174}\u{11B9}",
        nfkc: "\u{AE26}",
        nfkd: "\u{1100}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AE27}",
        nfc: "\u{AE27}",
        nfd: "\u{1100}\u{1174}\u{11BA}",
        nfkc: "\u{AE27}",
        nfkd: "\u{1100}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AE28}",
        nfc: "\u{AE28}",
        nfd: "\u{1100}\u{1174}\u{11BB}",
        nfkc: "\u{AE28}",
        nfkd: "\u{1100}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AE29}",
        nfc: "\u{AE29}",
        nfd: "\u{1100}\u{1174}\u{11BC}",
        nfkc: "\u{AE29}",
        nfkd: "\u{1100}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AE2A}",
        nfc: "\u{AE2A}",
        nfd: "\u{1100}\u{1174}\u{11BD}",
        nfkc: "\u{AE2A}",
        nfkd: "\u{1100}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AE2B}",
        nfc: "\u{AE2B}",
        nfd: "\u{1100}\u{1174}\u{11BE}",
        nfkc: "\u{AE2B}",
        nfkd: "\u{1100}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AE2C}",
        nfc: "\u{AE2C}",
        nfd: "\u{1100}\u{1174}\u{11BF}",
        nfkc: "\u{AE2C}",
        nfkd: "\u{1100}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AE2D}",
        nfc: "\u{AE2D}",
        nfd: "\u{1100}\u{1174}\u{11C0}",
        nfkc: "\u{AE2D}",
        nfkd: "\u{1100}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AE2E}",
        nfc: "\u{AE2E}",
        nfd: "\u{1100}\u{1174}\u{11C1}",
        nfkc: "\u{AE2E}",
        nfkd: "\u{1100}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AE2F}",
        nfc: "\u{AE2F}",
        nfd: "\u{1100}\u{1174}\u{11C2}",
        nfkc: "\u{AE2F}",
        nfkd: "\u{1100}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AE30}",
        nfc: "\u{AE30}",
        nfd: "\u{1100}\u{1175}",
        nfkc: "\u{AE30}",
        nfkd: "\u{1100}\u{1175}",
    },
    NormalizationTest {
        source: "\u{AE31}",
        nfc: "\u{AE31}",
        nfd: "\u{1100}\u{1175}\u{11A8}",
        nfkc: "\u{AE31}",
        nfkd: "\u{1100}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AE32}",
        nfc: "\u{AE32}",
        nfd: "\u{1100}\u{1175}\u{11A9}",
        nfkc: "\u{AE32}",
        nfkd: "\u{1100}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AE33}",
        nfc: "\u{AE33}",
        nfd: "\u{1100}\u{1175}\u{11AA}",
        nfkc: "\u{AE33}",
        nfkd: "\u{1100}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AE34}",
        nfc: "\u{AE34}",
        nfd: "\u{1100}\u{1175}\u{11AB}",
        nfkc: "\u{AE34}",
        nfkd: "\u{1100}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AE35}",
        nfc: "\u{AE35}",
        nfd: "\u{1100}\u{1175}\u{11AC}",
        nfkc: "\u{AE35}",
        nfkd: "\u{1100}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AE36}",
        nfc: "\u{AE36}",
        nfd: "\u{1100}\u{1175}\u{11AD}",
        nfkc: "\u{AE36}",
        nfkd: "\u{1100}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AE37}",
        nfc: "\u{AE37}",
        nfd: "\u{1100}\u{1175}\u{11AE}",
        nfkc: "\u{AE37}",
        nfkd: "\u{1100}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AE38}",
        nfc: "\u{AE38}",
        nfd: "\u{1100}\u{1175}\u{11AF}",
        nfkc: "\u{AE38}",
        nfkd: "\u{1100}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AE39}",
        nfc: "\u{AE39}",
        nfd: "\u{1100}\u{1175}\u{11B0}",
        nfkc: "\u{AE39}",
        nfkd: "\u{1100}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AE3A}",
        nfc: "\u{AE3A}",
        nfd: "\u{1100}\u{1175}\u{11B1}",
        nfkc: "\u{AE3A}",
        nfkd: "\u{1100}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AE3B}",
        nfc: "\u{AE3B}",
        nfd: "\u{1100}\u{1175}\u{11B2}",
        nfkc: "\u{AE3B}",
        nfkd: "\u{1100}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AE3C}",
        nfc: "\u{AE3C}",
        nfd: "\u{1100}\u{1175}\u{11B3}",
        nfkc: "\u{AE3C}",
        nfkd: "\u{1100}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AE3D}",
        nfc: "\u{AE3D}",
        nfd: "\u{1100}\u{1175}\u{11B4}",
        nfkc: "\u{AE3D}",
        nfkd: "\u{1100}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AE3E}",
        nfc: "\u{AE3E}",
        nfd: "\u{1100}\u{1175}\u{11B5}",
        nfkc: "\u{AE3E}",
        nfkd: "\u{1100}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AE3F}",
        nfc: "\u{AE3F}",
        nfd: "\u{1100}\u{1175}\u{11B6}",
        nfkc: "\u{AE3F}",
        nfkd: "\u{1100}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AE40}",
        nfc: "\u{AE40}",
        nfd: "\u{1100}\u{1175}\u{11B7}",
        nfkc: "\u{AE40}",
        nfkd: "\u{1100}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AE41}",
        nfc: "\u{AE41}",
        nfd: "\u{1100}\u{1175}\u{11B8}",
        nfkc: "\u{AE41}",
        nfkd: "\u{1100}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AE42}",
        nfc: "\u{AE42}",
        nfd: "\u{1100}\u{1175}\u{11B9}",
        nfkc: "\u{AE42}",
        nfkd: "\u{1100}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AE43}",
        nfc: "\u{AE43}",
        nfd: "\u{1100}\u{1175}\u{11BA}",
        nfkc: "\u{AE43}",
        nfkd: "\u{1100}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AE44}",
        nfc: "\u{AE44}",
        nfd: "\u{1100}\u{1175}\u{11BB}",
        nfkc: "\u{AE44}",
        nfkd: "\u{1100}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AE45}",
        nfc: "\u{AE45}",
        nfd: "\u{1100}\u{1175}\u{11BC}",
        nfkc: "\u{AE45}",
        nfkd: "\u{1100}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AE46}",
        nfc: "\u{AE46}",
        nfd: "\u{1100}\u{1175}\u{11BD}",
        nfkc: "\u{AE46}",
        nfkd: "\u{1100}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AE47}",
        nfc: "\u{AE47}",
        nfd: "\u{1100}\u{1175}\u{11BE}",
        nfkc: "\u{AE47}",
        nfkd: "\u{1100}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AE48}",
        nfc: "\u{AE48}",
        nfd: "\u{1100}\u{1175}\u{11BF}",
        nfkc: "\u{AE48}",
        nfkd: "\u{1100}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AE49}",
        nfc: "\u{AE49}",
        nfd: "\u{1100}\u{1175}\u{11C0}",
        nfkc: "\u{AE49}",
        nfkd: "\u{1100}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AE4A}",
        nfc: "\u{AE4A}",
        nfd: "\u{1100}\u{1175}\u{11C1}",
        nfkc: "\u{AE4A}",
        nfkd: "\u{1100}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AE4B}",
        nfc: "\u{AE4B}",
        nfd: "\u{1100}\u{1175}\u{11C2}",
        nfkc: "\u{AE4B}",
        nfkd: "\u{1100}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AE4C}",
        nfc: "\u{AE4C}",
        nfd: "\u{1101}\u{1161}",
        nfkc: "\u{AE4C}",
        nfkd: "\u{1101}\u{1161}",
    },
    NormalizationTest {
        source: "\u{AE4D}",
        nfc: "\u{AE4D}",
        nfd: "\u{1101}\u{1161}\u{11A8}",
        nfkc: "\u{AE4D}",
        nfkd: "\u{1101}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AE4E}",
        nfc: "\u{AE4E}",
        nfd: "\u{1101}\u{1161}\u{11A9}",
        nfkc: "\u{AE4E}",
        nfkd: "\u{1101}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AE4F}",
        nfc: "\u{AE4F}",
        nfd: "\u{1101}\u{1161}\u{11AA}",
        nfkc: "\u{AE4F}",
        nfkd: "\u{1101}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AE50}",
        nfc: "\u{AE50}",
        nfd: "\u{1101}\u{1161}\u{11AB}",
        nfkc: "\u{AE50}",
        nfkd: "\u{1101}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AE51}",
        nfc: "\u{AE51}",
        nfd: "\u{1101}\u{1161}\u{11AC}",
        nfkc: "\u{AE51}",
        nfkd: "\u{1101}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AE52}",
        nfc: "\u{AE52}",
        nfd: "\u{1101}\u{1161}\u{11AD}",
        nfkc: "\u{AE52}",
        nfkd: "\u{1101}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AE53}",
        nfc: "\u{AE53}",
        nfd: "\u{1101}\u{1161}\u{11AE}",
        nfkc: "\u{AE53}",
        nfkd: "\u{1101}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AE54}",
        nfc: "\u{AE54}",
        nfd: "\u{1101}\u{1161}\u{11AF}",
        nfkc: "\u{AE54}",
        nfkd: "\u{1101}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AE55}",
        nfc: "\u{AE55}",
        nfd: "\u{1101}\u{1161}\u{11B0}",
        nfkc: "\u{AE55}",
        nfkd: "\u{1101}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AE56}",
        nfc: "\u{AE56}",
        nfd: "\u{1101}\u{1161}\u{11B1}",
        nfkc: "\u{AE56}",
        nfkd: "\u{1101}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AE57}",
        nfc: "\u{AE57}",
        nfd: "\u{1101}\u{1161}\u{11B2}",
        nfkc: "\u{AE57}",
        nfkd: "\u{1101}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AE58}",
        nfc: "\u{AE58}",
        nfd: "\u{1101}\u{1161}\u{11B3}",
        nfkc: "\u{AE58}",
        nfkd: "\u{1101}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AE59}",
        nfc: "\u{AE59}",
        nfd: "\u{1101}\u{1161}\u{11B4}",
        nfkc: "\u{AE59}",
        nfkd: "\u{1101}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AE5A}",
        nfc: "\u{AE5A}",
        nfd: "\u{1101}\u{1161}\u{11B5}",
        nfkc: "\u{AE5A}",
        nfkd: "\u{1101}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AE5B}",
        nfc: "\u{AE5B}",
        nfd: "\u{1101}\u{1161}\u{11B6}",
        nfkc: "\u{AE5B}",
        nfkd: "\u{1101}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AE5C}",
        nfc: "\u{AE5C}",
        nfd: "\u{1101}\u{1161}\u{11B7}",
        nfkc: "\u{AE5C}",
        nfkd: "\u{1101}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AE5D}",
        nfc: "\u{AE5D}",
        nfd: "\u{1101}\u{1161}\u{11B8}",
        nfkc: "\u{AE5D}",
        nfkd: "\u{1101}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AE5E}",
        nfc: "\u{AE5E}",
        nfd: "\u{1101}\u{1161}\u{11B9}",
        nfkc: "\u{AE5E}",
        nfkd: "\u{1101}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AE5F}",
        nfc: "\u{AE5F}",
        nfd: "\u{1101}\u{1161}\u{11BA}",
        nfkc: "\u{AE5F}",
        nfkd: "\u{1101}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AE60}",
        nfc: "\u{AE60}",
        nfd: "\u{1101}\u{1161}\u{11BB}",
        nfkc: "\u{AE60}",
        nfkd: "\u{1101}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AE61}",
        nfc: "\u{AE61}",
        nfd: "\u{1101}\u{1161}\u{11BC}",
        nfkc: "\u{AE61}",
        nfkd: "\u{1101}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AE62}",
        nfc: "\u{AE62}",
        nfd: "\u{1101}\u{1161}\u{11BD}",
        nfkc: "\u{AE62}",
        nfkd: "\u{1101}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AE63}",
        nfc: "\u{AE63}",
        nfd: "\u{1101}\u{1161}\u{11BE}",
        nfkc: "\u{AE63}",
        nfkd: "\u{1101}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AE64}",
        nfc: "\u{AE64}",
        nfd: "\u{1101}\u{1161}\u{11BF}",
        nfkc: "\u{AE64}",
        nfkd: "\u{1101}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AE65}",
        nfc: "\u{AE65}",
        nfd: "\u{1101}\u{1161}\u{11C0}",
        nfkc: "\u{AE65}",
        nfkd: "\u{1101}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AE66}",
        nfc: "\u{AE66}",
        nfd: "\u{1101}\u{1161}\u{11C1}",
        nfkc: "\u{AE66}",
        nfkd: "\u{1101}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AE67}",
        nfc: "\u{AE67}",
        nfd: "\u{1101}\u{1161}\u{11C2}",
        nfkc: "\u{AE67}",
        nfkd: "\u{1101}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AE68}",
        nfc: "\u{AE68}",
        nfd: "\u{1101}\u{1162}",
        nfkc: "\u{AE68}",
        nfkd: "\u{1101}\u{1162}",
    },
    NormalizationTest {
        source: "\u{AE69}",
        nfc: "\u{AE69}",
        nfd: "\u{1101}\u{1162}\u{11A8}",
        nfkc: "\u{AE69}",
        nfkd: "\u{1101}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AE6A}",
        nfc: "\u{AE6A}",
        nfd: "\u{1101}\u{1162}\u{11A9}",
        nfkc: "\u{AE6A}",
        nfkd: "\u{1101}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AE6B}",
        nfc: "\u{AE6B}",
        nfd: "\u{1101}\u{1162}\u{11AA}",
        nfkc: "\u{AE6B}",
        nfkd: "\u{1101}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AE6C}",
        nfc: "\u{AE6C}",
        nfd: "\u{1101}\u{1162}\u{11AB}",
        nfkc: "\u{AE6C}",
        nfkd: "\u{1101}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AE6D}",
        nfc: "\u{AE6D}",
        nfd: "\u{1101}\u{1162}\u{11AC}",
        nfkc: "\u{AE6D}",
        nfkd: "\u{1101}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AE6E}",
        nfc: "\u{AE6E}",
        nfd: "\u{1101}\u{1162}\u{11AD}",
        nfkc: "\u{AE6E}",
        nfkd: "\u{1101}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AE6F}",
        nfc: "\u{AE6F}",
        nfd: "\u{1101}\u{1162}\u{11AE}",
        nfkc: "\u{AE6F}",
        nfkd: "\u{1101}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AE70}",
        nfc: "\u{AE70}",
        nfd: "\u{1101}\u{1162}\u{11AF}",
        nfkc: "\u{AE70}",
        nfkd: "\u{1101}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AE71}",
        nfc: "\u{AE71}",
        nfd: "\u{1101}\u{1162}\u{11B0}",
        nfkc: "\u{AE71}",
        nfkd: "\u{1101}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AE72}",
        nfc: "\u{AE72}",
        nfd: "\u{1101}\u{1162}\u{11B1}",
        nfkc: "\u{AE72}",
        nfkd: "\u{1101}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AE73}",
        nfc: "\u{AE73}",
        nfd: "\u{1101}\u{1162}\u{11B2}",
        nfkc: "\u{AE73}",
        nfkd: "\u{1101}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AE74}",
        nfc: "\u{AE74}",
        nfd: "\u{1101}\u{1162}\u{11B3}",
        nfkc: "\u{AE74}",
        nfkd: "\u{1101}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AE75}",
        nfc: "\u{AE75}",
        nfd: "\u{1101}\u{1162}\u{11B4}",
        nfkc: "\u{AE75}",
        nfkd: "\u{1101}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AE76}",
        nfc: "\u{AE76}",
        nfd: "\u{1101}\u{1162}\u{11B5}",
        nfkc: "\u{AE76}",
        nfkd: "\u{1101}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AE77}",
        nfc: "\u{AE77}",
        nfd: "\u{1101}\u{1162}\u{11B6}",
        nfkc: "\u{AE77}",
        nfkd: "\u{1101}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AE78}",
        nfc: "\u{AE78}",
        nfd: "\u{1101}\u{1162}\u{11B7}",
        nfkc: "\u{AE78}",
        nfkd: "\u{1101}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AE79}",
        nfc: "\u{AE79}",
        nfd: "\u{1101}\u{1162}\u{11B8}",
        nfkc: "\u{AE79}",
        nfkd: "\u{1101}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AE7A}",
        nfc: "\u{AE7A}",
        nfd: "\u{1101}\u{1162}\u{11B9}",
        nfkc: "\u{AE7A}",
        nfkd: "\u{1101}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AE7B}",
        nfc: "\u{AE7B}",
        nfd: "\u{1101}\u{1162}\u{11BA}",
        nfkc: "\u{AE7B}",
        nfkd: "\u{1101}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AE7C}",
        nfc: "\u{AE7C}",
        nfd: "\u{1101}\u{1162}\u{11BB}",
        nfkc: "\u{AE7C}",
        nfkd: "\u{1101}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AE7D}",
        nfc: "\u{AE7D}",
        nfd: "\u{1101}\u{1162}\u{11BC}",
        nfkc: "\u{AE7D}",
        nfkd: "\u{1101}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AE7E}",
        nfc: "\u{AE7E}",
        nfd: "\u{1101}\u{1162}\u{11BD}",
        nfkc: "\u{AE7E}",
        nfkd: "\u{1101}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AE7F}",
        nfc: "\u{AE7F}",
        nfd: "\u{1101}\u{1162}\u{11BE}",
        nfkc: "\u{AE7F}",
        nfkd: "\u{1101}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AE80}",
        nfc: "\u{AE80}",
        nfd: "\u{1101}\u{1162}\u{11BF}",
        nfkc: "\u{AE80}",
        nfkd: "\u{1101}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AE81}",
        nfc: "\u{AE81}",
        nfd: "\u{1101}\u{1162}\u{11C0}",
        nfkc: "\u{AE81}",
        nfkd: "\u{1101}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AE82}",
        nfc: "\u{AE82}",
        nfd: "\u{1101}\u{1162}\u{11C1}",
        nfkc: "\u{AE82}",
        nfkd: "\u{1101}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AE83}",
        nfc: "\u{AE83}",
        nfd: "\u{1101}\u{1162}\u{11C2}",
        nfkc: "\u{AE83}",
        nfkd: "\u{1101}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AE84}",
        nfc: "\u{AE84}",
        nfd: "\u{1101}\u{1163}",
        nfkc: "\u{AE84}",
        nfkd: "\u{1101}\u{1163}",
    },
    NormalizationTest {
        source: "\u{AE85}",
        nfc: "\u{AE85}",
        nfd: "\u{1101}\u{1163}\u{11A8}",
        nfkc: "\u{AE85}",
        nfkd: "\u{1101}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AE86}",
        nfc: "\u{AE86}",
        nfd: "\u{1101}\u{1163}\u{11A9}",
        nfkc: "\u{AE86}",
        nfkd: "\u{1101}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AE87}",
        nfc: "\u{AE87}",
        nfd: "\u{1101}\u{1163}\u{11AA}",
        nfkc: "\u{AE87}",
        nfkd: "\u{1101}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AE88}",
        nfc: "\u{AE88}",
        nfd: "\u{1101}\u{1163}\u{11AB}",
        nfkc: "\u{AE88}",
        nfkd: "\u{1101}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AE89}",
        nfc: "\u{AE89}",
        nfd: "\u{1101}\u{1163}\u{11AC}",
        nfkc: "\u{AE89}",
        nfkd: "\u{1101}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AE8A}",
        nfc: "\u{AE8A}",
        nfd: "\u{1101}\u{1163}\u{11AD}",
        nfkc: "\u{AE8A}",
        nfkd: "\u{1101}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AE8B}",
        nfc: "\u{AE8B}",
        nfd: "\u{1101}\u{1163}\u{11AE}",
        nfkc: "\u{AE8B}",
        nfkd: "\u{1101}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AE8C}",
        nfc: "\u{AE8C}",
        nfd: "\u{1101}\u{1163}\u{11AF}",
        nfkc: "\u{AE8C}",
        nfkd: "\u{1101}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AE8D}",
        nfc: "\u{AE8D}",
        nfd: "\u{1101}\u{1163}\u{11B0}",
        nfkc: "\u{AE8D}",
        nfkd: "\u{1101}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AE8E}",
        nfc: "\u{AE8E}",
        nfd: "\u{1101}\u{1163}\u{11B1}",
        nfkc: "\u{AE8E}",
        nfkd: "\u{1101}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AE8F}",
        nfc: "\u{AE8F}",
        nfd: "\u{1101}\u{1163}\u{11B2}",
        nfkc: "\u{AE8F}",
        nfkd: "\u{1101}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AE90}",
        nfc: "\u{AE90}",
        nfd: "\u{1101}\u{1163}\u{11B3}",
        nfkc: "\u{AE90}",
        nfkd: "\u{1101}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AE91}",
        nfc: "\u{AE91}",
        nfd: "\u{1101}\u{1163}\u{11B4}",
        nfkc: "\u{AE91}",
        nfkd: "\u{1101}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AE92}",
        nfc: "\u{AE92}",
        nfd: "\u{1101}\u{1163}\u{11B5}",
        nfkc: "\u{AE92}",
        nfkd: "\u{1101}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AE93}",
        nfc: "\u{AE93}",
        nfd: "\u{1101}\u{1163}\u{11B6}",
        nfkc: "\u{AE93}",
        nfkd: "\u{1101}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AE94}",
        nfc: "\u{AE94}",
        nfd: "\u{1101}\u{1163}\u{11B7}",
        nfkc: "\u{AE94}",
        nfkd: "\u{1101}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AE95}",
        nfc: "\u{AE95}",
        nfd: "\u{1101}\u{1163}\u{11B8}",
        nfkc: "\u{AE95}",
        nfkd: "\u{1101}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AE96}",
        nfc: "\u{AE96}",
        nfd: "\u{1101}\u{1163}\u{11B9}",
        nfkc: "\u{AE96}",
        nfkd: "\u{1101}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AE97}",
        nfc: "\u{AE97}",
        nfd: "\u{1101}\u{1163}\u{11BA}",
        nfkc: "\u{AE97}",
        nfkd: "\u{1101}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AE98}",
        nfc: "\u{AE98}",
        nfd: "\u{1101}\u{1163}\u{11BB}",
        nfkc: "\u{AE98}",
        nfkd: "\u{1101}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AE99}",
        nfc: "\u{AE99}",
        nfd: "\u{1101}\u{1163}\u{11BC}",
        nfkc: "\u{AE99}",
        nfkd: "\u{1101}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AE9A}",
        nfc: "\u{AE9A}",
        nfd: "\u{1101}\u{1163}\u{11BD}",
        nfkc: "\u{AE9A}",
        nfkd: "\u{1101}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AE9B}",
        nfc: "\u{AE9B}",
        nfd: "\u{1101}\u{1163}\u{11BE}",
        nfkc: "\u{AE9B}",
        nfkd: "\u{1101}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AE9C}",
        nfc: "\u{AE9C}",
        nfd: "\u{1101}\u{1163}\u{11BF}",
        nfkc: "\u{AE9C}",
        nfkd: "\u{1101}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AE9D}",
        nfc: "\u{AE9D}",
        nfd: "\u{1101}\u{1163}\u{11C0}",
        nfkc: "\u{AE9D}",
        nfkd: "\u{1101}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AE9E}",
        nfc: "\u{AE9E}",
        nfd: "\u{1101}\u{1163}\u{11C1}",
        nfkc: "\u{AE9E}",
        nfkd: "\u{1101}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AE9F}",
        nfc: "\u{AE9F}",
        nfd: "\u{1101}\u{1163}\u{11C2}",
        nfkc: "\u{AE9F}",
        nfkd: "\u{1101}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AEA0}",
        nfc: "\u{AEA0}",
        nfd: "\u{1101}\u{1164}",
        nfkc: "\u{AEA0}",
        nfkd: "\u{1101}\u{1164}",
    },
    NormalizationTest {
        source: "\u{AEA1}",
        nfc: "\u{AEA1}",
        nfd: "\u{1101}\u{1164}\u{11A8}",
        nfkc: "\u{AEA1}",
        nfkd: "\u{1101}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AEA2}",
        nfc: "\u{AEA2}",
        nfd: "\u{1101}\u{1164}\u{11A9}",
        nfkc: "\u{AEA2}",
        nfkd: "\u{1101}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AEA3}",
        nfc: "\u{AEA3}",
        nfd: "\u{1101}\u{1164}\u{11AA}",
        nfkc: "\u{AEA3}",
        nfkd: "\u{1101}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AEA4}",
        nfc: "\u{AEA4}",
        nfd: "\u{1101}\u{1164}\u{11AB}",
        nfkc: "\u{AEA4}",
        nfkd: "\u{1101}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AEA5}",
        nfc: "\u{AEA5}",
        nfd: "\u{1101}\u{1164}\u{11AC}",
        nfkc: "\u{AEA5}",
        nfkd: "\u{1101}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AEA6}",
        nfc: "\u{AEA6}",
        nfd: "\u{1101}\u{1164}\u{11AD}",
        nfkc: "\u{AEA6}",
        nfkd: "\u{1101}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AEA7}",
        nfc: "\u{AEA7}",
        nfd: "\u{1101}\u{1164}\u{11AE}",
        nfkc: "\u{AEA7}",
        nfkd: "\u{1101}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AEA8}",
        nfc: "\u{AEA8}",
        nfd: "\u{1101}\u{1164}\u{11AF}",
        nfkc: "\u{AEA8}",
        nfkd: "\u{1101}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AEA9}",
        nfc: "\u{AEA9}",
        nfd: "\u{1101}\u{1164}\u{11B0}",
        nfkc: "\u{AEA9}",
        nfkd: "\u{1101}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AEAA}",
        nfc: "\u{AEAA}",
        nfd: "\u{1101}\u{1164}\u{11B1}",
        nfkc: "\u{AEAA}",
        nfkd: "\u{1101}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AEAB}",
        nfc: "\u{AEAB}",
        nfd: "\u{1101}\u{1164}\u{11B2}",
        nfkc: "\u{AEAB}",
        nfkd: "\u{1101}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AEAC}",
        nfc: "\u{AEAC}",
        nfd: "\u{1101}\u{1164}\u{11B3}",
        nfkc: "\u{AEAC}",
        nfkd: "\u{1101}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AEAD}",
        nfc: "\u{AEAD}",
        nfd: "\u{1101}\u{1164}\u{11B4}",
        nfkc: "\u{AEAD}",
        nfkd: "\u{1101}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AEAE}",
        nfc: "\u{AEAE}",
        nfd: "\u{1101}\u{1164}\u{11B5}",
        nfkc: "\u{AEAE}",
        nfkd: "\u{1101}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AEAF}",
        nfc: "\u{AEAF}",
        nfd: "\u{1101}\u{1164}\u{11B6}",
        nfkc: "\u{AEAF}",
        nfkd: "\u{1101}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AEB0}",
        nfc: "\u{AEB0}",
        nfd: "\u{1101}\u{1164}\u{11B7}",
        nfkc: "\u{AEB0}",
        nfkd: "\u{1101}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AEB1}",
        nfc: "\u{AEB1}",
        nfd: "\u{1101}\u{1164}\u{11B8}",
        nfkc: "\u{AEB1}",
        nfkd: "\u{1101}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AEB2}",
        nfc: "\u{AEB2}",
        nfd: "\u{1101}\u{1164}\u{11B9}",
        nfkc: "\u{AEB2}",
        nfkd: "\u{1101}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AEB3}",
        nfc: "\u{AEB3}",
        nfd: "\u{1101}\u{1164}\u{11BA}",
        nfkc: "\u{AEB3}",
        nfkd: "\u{1101}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AEB4}",
        nfc: "\u{AEB4}",
        nfd: "\u{1101}\u{1164}\u{11BB}",
        nfkc: "\u{AEB4}",
        nfkd: "\u{1101}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AEB5}",
        nfc: "\u{AEB5}",
        nfd: "\u{1101}\u{1164}\u{11BC}",
        nfkc: "\u{AEB5}",
        nfkd: "\u{1101}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AEB6}",
        nfc: "\u{AEB6}",
        nfd: "\u{1101}\u{1164}\u{11BD}",
        nfkc: "\u{AEB6}",
        nfkd: "\u{1101}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AEB7}",
        nfc: "\u{AEB7}",
        nfd: "\u{1101}\u{1164}\u{11BE}",
        nfkc: "\u{AEB7}",
        nfkd: "\u{1101}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AEB8}",
        nfc: "\u{AEB8}",
        nfd: "\u{1101}\u{1164}\u{11BF}",
        nfkc: "\u{AEB8}",
        nfkd: "\u{1101}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AEB9}",
        nfc: "\u{AEB9}",
        nfd: "\u{1101}\u{1164}\u{11C0}",
        nfkc: "\u{AEB9}",
        nfkd: "\u{1101}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AEBA}",
        nfc: "\u{AEBA}",
        nfd: "\u{1101}\u{1164}\u{11C1}",
        nfkc: "\u{AEBA}",
        nfkd: "\u{1101}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AEBB}",
        nfc: "\u{AEBB}",
        nfd: "\u{1101}\u{1164}\u{11C2}",
        nfkc: "\u{AEBB}",
        nfkd: "\u{1101}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AEBC}",
        nfc: "\u{AEBC}",
        nfd: "\u{1101}\u{1165}",
        nfkc: "\u{AEBC}",
        nfkd: "\u{1101}\u{1165}",
    },
    NormalizationTest {
        source: "\u{AEBD}",
        nfc: "\u{AEBD}",
        nfd: "\u{1101}\u{1165}\u{11A8}",
        nfkc: "\u{AEBD}",
        nfkd: "\u{1101}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AEBE}",
        nfc: "\u{AEBE}",
        nfd: "\u{1101}\u{1165}\u{11A9}",
        nfkc: "\u{AEBE}",
        nfkd: "\u{1101}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AEBF}",
        nfc: "\u{AEBF}",
        nfd: "\u{1101}\u{1165}\u{11AA}",
        nfkc: "\u{AEBF}",
        nfkd: "\u{1101}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AEC0}",
        nfc: "\u{AEC0}",
        nfd: "\u{1101}\u{1165}\u{11AB}",
        nfkc: "\u{AEC0}",
        nfkd: "\u{1101}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AEC1}",
        nfc: "\u{AEC1}",
        nfd: "\u{1101}\u{1165}\u{11AC}",
        nfkc: "\u{AEC1}",
        nfkd: "\u{1101}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AEC2}",
        nfc: "\u{AEC2}",
        nfd: "\u{1101}\u{1165}\u{11AD}",
        nfkc: "\u{AEC2}",
        nfkd: "\u{1101}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AEC3}",
        nfc: "\u{AEC3}",
        nfd: "\u{1101}\u{1165}\u{11AE}",
        nfkc: "\u{AEC3}",
        nfkd: "\u{1101}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AEC4}",
        nfc: "\u{AEC4}",
        nfd: "\u{1101}\u{1165}\u{11AF}",
        nfkc: "\u{AEC4}",
        nfkd: "\u{1101}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AEC5}",
        nfc: "\u{AEC5}",
        nfd: "\u{1101}\u{1165}\u{11B0}",
        nfkc: "\u{AEC5}",
        nfkd: "\u{1101}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AEC6}",
        nfc: "\u{AEC6}",
        nfd: "\u{1101}\u{1165}\u{11B1}",
        nfkc: "\u{AEC6}",
        nfkd: "\u{1101}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AEC7}",
        nfc: "\u{AEC7}",
        nfd: "\u{1101}\u{1165}\u{11B2}",
        nfkc: "\u{AEC7}",
        nfkd: "\u{1101}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AEC8}",
        nfc: "\u{AEC8}",
        nfd: "\u{1101}\u{1165}\u{11B3}",
        nfkc: "\u{AEC8}",
        nfkd: "\u{1101}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AEC9}",
        nfc: "\u{AEC9}",
        nfd: "\u{1101}\u{1165}\u{11B4}",
        nfkc: "\u{AEC9}",
        nfkd: "\u{1101}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AECA}",
        nfc: "\u{AECA}",
        nfd: "\u{1101}\u{1165}\u{11B5}",
        nfkc: "\u{AECA}",
        nfkd: "\u{1101}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AECB}",
        nfc: "\u{AECB}",
        nfd: "\u{1101}\u{1165}\u{11B6}",
        nfkc: "\u{AECB}",
        nfkd: "\u{1101}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AECC}",
        nfc: "\u{AECC}",
        nfd: "\u{1101}\u{1165}\u{11B7}",
        nfkc: "\u{AECC}",
        nfkd: "\u{1101}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AECD}",
        nfc: "\u{AECD}",
        nfd: "\u{1101}\u{1165}\u{11B8}",
        nfkc: "\u{AECD}",
        nfkd: "\u{1101}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AECE}",
        nfc: "\u{AECE}",
        nfd: "\u{1101}\u{1165}\u{11B9}",
        nfkc: "\u{AECE}",
        nfkd: "\u{1101}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AECF}",
        nfc: "\u{AECF}",
        nfd: "\u{1101}\u{1165}\u{11BA}",
        nfkc: "\u{AECF}",
        nfkd: "\u{1101}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AED0}",
        nfc: "\u{AED0}",
        nfd: "\u{1101}\u{1165}\u{11BB}",
        nfkc: "\u{AED0}",
        nfkd: "\u{1101}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AED1}",
        nfc: "\u{AED1}",
        nfd: "\u{1101}\u{1165}\u{11BC}",
        nfkc: "\u{AED1}",
        nfkd: "\u{1101}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AED2}",
        nfc: "\u{AED2}",
        nfd: "\u{1101}\u{1165}\u{11BD}",
        nfkc: "\u{AED2}",
        nfkd: "\u{1101}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AED3}",
        nfc: "\u{AED3}",
        nfd: "\u{1101}\u{1165}\u{11BE}",
        nfkc: "\u{AED3}",
        nfkd: "\u{1101}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AED4}",
        nfc: "\u{AED4}",
        nfd: "\u{1101}\u{1165}\u{11BF}",
        nfkc: "\u{AED4}",
        nfkd: "\u{1101}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AED5}",
        nfc: "\u{AED5}",
        nfd: "\u{1101}\u{1165}\u{11C0}",
        nfkc: "\u{AED5}",
        nfkd: "\u{1101}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AED6}",
        nfc: "\u{AED6}",
        nfd: "\u{1101}\u{1165}\u{11C1}",
        nfkc: "\u{AED6}",
        nfkd: "\u{1101}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AED7}",
        nfc: "\u{AED7}",
        nfd: "\u{1101}\u{1165}\u{11C2}",
        nfkc: "\u{AED7}",
        nfkd: "\u{1101}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AED8}",
        nfc: "\u{AED8}",
        nfd: "\u{1101}\u{1166}",
        nfkc: "\u{AED8}",
        nfkd: "\u{1101}\u{1166}",
    },
    NormalizationTest {
        source: "\u{AED9}",
        nfc: "\u{AED9}",
        nfd: "\u{1101}\u{1166}\u{11A8}",
        nfkc: "\u{AED9}",
        nfkd: "\u{1101}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AEDA}",
        nfc: "\u{AEDA}",
        nfd: "\u{1101}\u{1166}\u{11A9}",
        nfkc: "\u{AEDA}",
        nfkd: "\u{1101}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AEDB}",
        nfc: "\u{AEDB}",
        nfd: "\u{1101}\u{1166}\u{11AA}",
        nfkc: "\u{AEDB}",
        nfkd: "\u{1101}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AEDC}",
        nfc: "\u{AEDC}",
        nfd: "\u{1101}\u{1166}\u{11AB}",
        nfkc: "\u{AEDC}",
        nfkd: "\u{1101}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AEDD}",
        nfc: "\u{AEDD}",
        nfd: "\u{1101}\u{1166}\u{11AC}",
        nfkc: "\u{AEDD}",
        nfkd: "\u{1101}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AEDE}",
        nfc: "\u{AEDE}",
        nfd: "\u{1101}\u{1166}\u{11AD}",
        nfkc: "\u{AEDE}",
        nfkd: "\u{1101}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AEDF}",
        nfc: "\u{AEDF}",
        nfd: "\u{1101}\u{1166}\u{11AE}",
        nfkc: "\u{AEDF}",
        nfkd: "\u{1101}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AEE0}",
        nfc: "\u{AEE0}",
        nfd: "\u{1101}\u{1166}\u{11AF}",
        nfkc: "\u{AEE0}",
        nfkd: "\u{1101}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AEE1}",
        nfc: "\u{AEE1}",
        nfd: "\u{1101}\u{1166}\u{11B0}",
        nfkc: "\u{AEE1}",
        nfkd: "\u{1101}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AEE2}",
        nfc: "\u{AEE2}",
        nfd: "\u{1101}\u{1166}\u{11B1}",
        nfkc: "\u{AEE2}",
        nfkd: "\u{1101}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AEE3}",
        nfc: "\u{AEE3}",
        nfd: "\u{1101}\u{1166}\u{11B2}",
        nfkc: "\u{AEE3}",
        nfkd: "\u{1101}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AEE4}",
        nfc: "\u{AEE4}",
        nfd: "\u{1101}\u{1166}\u{11B3}",
        nfkc: "\u{AEE4}",
        nfkd: "\u{1101}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AEE5}",
        nfc: "\u{AEE5}",
        nfd: "\u{1101}\u{1166}\u{11B4}",
        nfkc: "\u{AEE5}",
        nfkd: "\u{1101}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AEE6}",
        nfc: "\u{AEE6}",
        nfd: "\u{1101}\u{1166}\u{11B5}",
        nfkc: "\u{AEE6}",
        nfkd: "\u{1101}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AEE7}",
        nfc: "\u{AEE7}",
        nfd: "\u{1101}\u{1166}\u{11B6}",
        nfkc: "\u{AEE7}",
        nfkd: "\u{1101}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AEE8}",
        nfc: "\u{AEE8}",
        nfd: "\u{1101}\u{1166}\u{11B7}",
        nfkc: "\u{AEE8}",
        nfkd: "\u{1101}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AEE9}",
        nfc: "\u{AEE9}",
        nfd: "\u{1101}\u{1166}\u{11B8}",
        nfkc: "\u{AEE9}",
        nfkd: "\u{1101}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AEEA}",
        nfc: "\u{AEEA}",
        nfd: "\u{1101}\u{1166}\u{11B9}",
        nfkc: "\u{AEEA}",
        nfkd: "\u{1101}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AEEB}",
        nfc: "\u{AEEB}",
        nfd: "\u{1101}\u{1166}\u{11BA}",
        nfkc: "\u{AEEB}",
        nfkd: "\u{1101}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AEEC}",
        nfc: "\u{AEEC}",
        nfd: "\u{1101}\u{1166}\u{11BB}",
        nfkc: "\u{AEEC}",
        nfkd: "\u{1101}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AEED}",
        nfc: "\u{AEED}",
        nfd: "\u{1101}\u{1166}\u{11BC}",
        nfkc: "\u{AEED}",
        nfkd: "\u{1101}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AEEE}",
        nfc: "\u{AEEE}",
        nfd: "\u{1101}\u{1166}\u{11BD}",
        nfkc: "\u{AEEE}",
        nfkd: "\u{1101}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AEEF}",
        nfc: "\u{AEEF}",
        nfd: "\u{1101}\u{1166}\u{11BE}",
        nfkc: "\u{AEEF}",
        nfkd: "\u{1101}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AEF0}",
        nfc: "\u{AEF0}",
        nfd: "\u{1101}\u{1166}\u{11BF}",
        nfkc: "\u{AEF0}",
        nfkd: "\u{1101}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AEF1}",
        nfc: "\u{AEF1}",
        nfd: "\u{1101}\u{1166}\u{11C0}",
        nfkc: "\u{AEF1}",
        nfkd: "\u{1101}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AEF2}",
        nfc: "\u{AEF2}",
        nfd: "\u{1101}\u{1166}\u{11C1}",
        nfkc: "\u{AEF2}",
        nfkd: "\u{1101}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AEF3}",
        nfc: "\u{AEF3}",
        nfd: "\u{1101}\u{1166}\u{11C2}",
        nfkc: "\u{AEF3}",
        nfkd: "\u{1101}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AEF4}",
        nfc: "\u{AEF4}",
        nfd: "\u{1101}\u{1167}",
        nfkc: "\u{AEF4}",
        nfkd: "\u{1101}\u{1167}",
    },
    NormalizationTest {
        source: "\u{AEF5}",
        nfc: "\u{AEF5}",
        nfd: "\u{1101}\u{1167}\u{11A8}",
        nfkc: "\u{AEF5}",
        nfkd: "\u{1101}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AEF6}",
        nfc: "\u{AEF6}",
        nfd: "\u{1101}\u{1167}\u{11A9}",
        nfkc: "\u{AEF6}",
        nfkd: "\u{1101}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AEF7}",
        nfc: "\u{AEF7}",
        nfd: "\u{1101}\u{1167}\u{11AA}",
        nfkc: "\u{AEF7}",
        nfkd: "\u{1101}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AEF8}",
        nfc: "\u{AEF8}",
        nfd: "\u{1101}\u{1167}\u{11AB}",
        nfkc: "\u{AEF8}",
        nfkd: "\u{1101}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AEF9}",
        nfc: "\u{AEF9}",
        nfd: "\u{1101}\u{1167}\u{11AC}",
        nfkc: "\u{AEF9}",
        nfkd: "\u{1101}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AEFA}",
        nfc: "\u{AEFA}",
        nfd: "\u{1101}\u{1167}\u{11AD}",
        nfkc: "\u{AEFA}",
        nfkd: "\u{1101}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AEFB}",
        nfc: "\u{AEFB}",
        nfd: "\u{1101}\u{1167}\u{11AE}",
        nfkc: "\u{AEFB}",
        nfkd: "\u{1101}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AEFC}",
        nfc: "\u{AEFC}",
        nfd: "\u{1101}\u{1167}\u{11AF}",
        nfkc: "\u{AEFC}",
        nfkd: "\u{1101}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AEFD}",
        nfc: "\u{AEFD}",
        nfd: "\u{1101}\u{1167}\u{11B0}",
        nfkc: "\u{AEFD}",
        nfkd: "\u{1101}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AEFE}",
        nfc: "\u{AEFE}",
        nfd: "\u{1101}\u{1167}\u{11B1}",
        nfkc: "\u{AEFE}",
        nfkd: "\u{1101}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AEFF}",
        nfc: "\u{AEFF}",
        nfd: "\u{1101}\u{1167}\u{11B2}",
        nfkc: "\u{AEFF}",
        nfkd: "\u{1101}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AF00}",
        nfc: "\u{AF00}",
        nfd: "\u{1101}\u{1167}\u{11B3}",
        nfkc: "\u{AF00}",
        nfkd: "\u{1101}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AF01}",
        nfc: "\u{AF01}",
        nfd: "\u{1101}\u{1167}\u{11B4}",
        nfkc: "\u{AF01}",
        nfkd: "\u{1101}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AF02}",
        nfc: "\u{AF02}",
        nfd: "\u{1101}\u{1167}\u{11B5}",
        nfkc: "\u{AF02}",
        nfkd: "\u{1101}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AF03}",
        nfc: "\u{AF03}",
        nfd: "\u{1101}\u{1167}\u{11B6}",
        nfkc: "\u{AF03}",
        nfkd: "\u{1101}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AF04}",
        nfc: "\u{AF04}",
        nfd: "\u{1101}\u{1167}\u{11B7}",
        nfkc: "\u{AF04}",
        nfkd: "\u{1101}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AF05}",
        nfc: "\u{AF05}",
        nfd: "\u{1101}\u{1167}\u{11B8}",
        nfkc: "\u{AF05}",
        nfkd: "\u{1101}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AF06}",
        nfc: "\u{AF06}",
        nfd: "\u{1101}\u{1167}\u{11B9}",
        nfkc: "\u{AF06}",
        nfkd: "\u{1101}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AF07}",
        nfc: "\u{AF07}",
        nfd: "\u{1101}\u{1167}\u{11BA}",
        nfkc: "\u{AF07}",
        nfkd: "\u{1101}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AF08}",
        nfc: "\u{AF08}",
        nfd: "\u{1101}\u{1167}\u{11BB}",
        nfkc: "\u{AF08}",
        nfkd: "\u{1101}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AF09}",
        nfc: "\u{AF09}",
        nfd: "\u{1101}\u{1167}\u{11BC}",
        nfkc: "\u{AF09}",
        nfkd: "\u{1101}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AF0A}",
        nfc: "\u{AF0A}",
        nfd: "\u{1101}\u{1167}\u{11BD}",
        nfkc: "\u{AF0A}",
        nfkd: "\u{1101}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AF0B}",
        nfc: "\u{AF0B}",
        nfd: "\u{1101}\u{1167}\u{11BE}",
        nfkc: "\u{AF0B}",
        nfkd: "\u{1101}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AF0C}",
        nfc: "\u{AF0C}",
        nfd: "\u{1101}\u{1167}\u{11BF}",
        nfkc: "\u{AF0C}",
        nfkd: "\u{1101}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AF0D}",
        nfc: "\u{AF0D}",
        nfd: "\u{1101}\u{1167}\u{11C0}",
        nfkc: "\u{AF0D}",
        nfkd: "\u{1101}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AF0E}",
        nfc: "\u{AF0E}",
        nfd: "\u{1101}\u{1167}\u{11C1}",
        nfkc: "\u{AF0E}",
        nfkd: "\u{1101}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AF0F}",
        nfc: "\u{AF0F}",
        nfd: "\u{1101}\u{1167}\u{11C2}",
        nfkc: "\u{AF0F}",
        nfkd: "\u{1101}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AF10}",
        nfc: "\u{AF10}",
        nfd: "\u{1101}\u{1168}",
        nfkc: "\u{AF10}",
        nfkd: "\u{1101}\u{1168}",
    },
    NormalizationTest {
        source: "\u{AF11}",
        nfc: "\u{AF11}",
        nfd: "\u{1101}\u{1168}\u{11A8}",
        nfkc: "\u{AF11}",
        nfkd: "\u{1101}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AF12}",
        nfc: "\u{AF12}",
        nfd: "\u{1101}\u{1168}\u{11A9}",
        nfkc: "\u{AF12}",
        nfkd: "\u{1101}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AF13}",
        nfc: "\u{AF13}",
        nfd: "\u{1101}\u{1168}\u{11AA}",
        nfkc: "\u{AF13}",
        nfkd: "\u{1101}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AF14}",
        nfc: "\u{AF14}",
        nfd: "\u{1101}\u{1168}\u{11AB}",
        nfkc: "\u{AF14}",
        nfkd: "\u{1101}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AF15}",
        nfc: "\u{AF15}",
        nfd: "\u{1101}\u{1168}\u{11AC}",
        nfkc: "\u{AF15}",
        nfkd: "\u{1101}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AF16}",
        nfc: "\u{AF16}",
        nfd: "\u{1101}\u{1168}\u{11AD}",
        nfkc: "\u{AF16}",
        nfkd: "\u{1101}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AF17}",
        nfc: "\u{AF17}",
        nfd: "\u{1101}\u{1168}\u{11AE}",
        nfkc: "\u{AF17}",
        nfkd: "\u{1101}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AF18}",
        nfc: "\u{AF18}",
        nfd: "\u{1101}\u{1168}\u{11AF}",
        nfkc: "\u{AF18}",
        nfkd: "\u{1101}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AF19}",
        nfc: "\u{AF19}",
        nfd: "\u{1101}\u{1168}\u{11B0}",
        nfkc: "\u{AF19}",
        nfkd: "\u{1101}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AF1A}",
        nfc: "\u{AF1A}",
        nfd: "\u{1101}\u{1168}\u{11B1}",
        nfkc: "\u{AF1A}",
        nfkd: "\u{1101}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AF1B}",
        nfc: "\u{AF1B}",
        nfd: "\u{1101}\u{1168}\u{11B2}",
        nfkc: "\u{AF1B}",
        nfkd: "\u{1101}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AF1C}",
        nfc: "\u{AF1C}",
        nfd: "\u{1101}\u{1168}\u{11B3}",
        nfkc: "\u{AF1C}",
        nfkd: "\u{1101}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AF1D}",
        nfc: "\u{AF1D}",
        nfd: "\u{1101}\u{1168}\u{11B4}",
        nfkc: "\u{AF1D}",
        nfkd: "\u{1101}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AF1E}",
        nfc: "\u{AF1E}",
        nfd: "\u{1101}\u{1168}\u{11B5}",
        nfkc: "\u{AF1E}",
        nfkd: "\u{1101}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AF1F}",
        nfc: "\u{AF1F}",
        nfd: "\u{1101}\u{1168}\u{11B6}",
        nfkc: "\u{AF1F}",
        nfkd: "\u{1101}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AF20}",
        nfc: "\u{AF20}",
        nfd: "\u{1101}\u{1168}\u{11B7}",
        nfkc: "\u{AF20}",
        nfkd: "\u{1101}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AF21}",
        nfc: "\u{AF21}",
        nfd: "\u{1101}\u{1168}\u{11B8}",
        nfkc: "\u{AF21}",
        nfkd: "\u{1101}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AF22}",
        nfc: "\u{AF22}",
        nfd: "\u{1101}\u{1168}\u{11B9}",
        nfkc: "\u{AF22}",
        nfkd: "\u{1101}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AF23}",
        nfc: "\u{AF23}",
        nfd: "\u{1101}\u{1168}\u{11BA}",
        nfkc: "\u{AF23}",
        nfkd: "\u{1101}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AF24}",
        nfc: "\u{AF24}",
        nfd: "\u{1101}\u{1168}\u{11BB}",
        nfkc: "\u{AF24}",
        nfkd: "\u{1101}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AF25}",
        nfc: "\u{AF25}",
        nfd: "\u{1101}\u{1168}\u{11BC}",
        nfkc: "\u{AF25}",
        nfkd: "\u{1101}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AF26}",
        nfc: "\u{AF26}",
        nfd: "\u{1101}\u{1168}\u{11BD}",
        nfkc: "\u{AF26}",
        nfkd: "\u{1101}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AF27}",
        nfc: "\u{AF27}",
        nfd: "\u{1101}\u{1168}\u{11BE}",
        nfkc: "\u{AF27}",
        nfkd: "\u{1101}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AF28}",
        nfc: "\u{AF28}",
        nfd: "\u{1101}\u{1168}\u{11BF}",
        nfkc: "\u{AF28}",
        nfkd: "\u{1101}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AF29}",
        nfc: "\u{AF29}",
        nfd: "\u{1101}\u{1168}\u{11C0}",
        nfkc: "\u{AF29}",
        nfkd: "\u{1101}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AF2A}",
        nfc: "\u{AF2A}",
        nfd: "\u{1101}\u{1168}\u{11C1}",
        nfkc: "\u{AF2A}",
        nfkd: "\u{1101}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AF2B}",
        nfc: "\u{AF2B}",
        nfd: "\u{1101}\u{1168}\u{11C2}",
        nfkc: "\u{AF2B}",
        nfkd: "\u{1101}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AF2C}",
        nfc: "\u{AF2C}",
        nfd: "\u{1101}\u{1169}",
        nfkc: "\u{AF2C}",
        nfkd: "\u{1101}\u{1169}",
    },
    NormalizationTest {
        source: "\u{AF2D}",
        nfc: "\u{AF2D}",
        nfd: "\u{1101}\u{1169}\u{11A8}",
        nfkc: "\u{AF2D}",
        nfkd: "\u{1101}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AF2E}",
        nfc: "\u{AF2E}",
        nfd: "\u{1101}\u{1169}\u{11A9}",
        nfkc: "\u{AF2E}",
        nfkd: "\u{1101}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AF2F}",
        nfc: "\u{AF2F}",
        nfd: "\u{1101}\u{1169}\u{11AA}",
        nfkc: "\u{AF2F}",
        nfkd: "\u{1101}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AF30}",
        nfc: "\u{AF30}",
        nfd: "\u{1101}\u{1169}\u{11AB}",
        nfkc: "\u{AF30}",
        nfkd: "\u{1101}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AF31}",
        nfc: "\u{AF31}",
        nfd: "\u{1101}\u{1169}\u{11AC}",
        nfkc: "\u{AF31}",
        nfkd: "\u{1101}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AF32}",
        nfc: "\u{AF32}",
        nfd: "\u{1101}\u{1169}\u{11AD}",
        nfkc: "\u{AF32}",
        nfkd: "\u{1101}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AF33}",
        nfc: "\u{AF33}",
        nfd: "\u{1101}\u{1169}\u{11AE}",
        nfkc: "\u{AF33}",
        nfkd: "\u{1101}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AF34}",
        nfc: "\u{AF34}",
        nfd: "\u{1101}\u{1169}\u{11AF}",
        nfkc: "\u{AF34}",
        nfkd: "\u{1101}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AF35}",
        nfc: "\u{AF35}",
        nfd: "\u{1101}\u{1169}\u{11B0}",
        nfkc: "\u{AF35}",
        nfkd: "\u{1101}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AF36}",
        nfc: "\u{AF36}",
        nfd: "\u{1101}\u{1169}\u{11B1}",
        nfkc: "\u{AF36}",
        nfkd: "\u{1101}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AF37}",
        nfc: "\u{AF37}",
        nfd: "\u{1101}\u{1169}\u{11B2}",
        nfkc: "\u{AF37}",
        nfkd: "\u{1101}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AF38}",
        nfc: "\u{AF38}",
        nfd: "\u{1101}\u{1169}\u{11B3}",
        nfkc: "\u{AF38}",
        nfkd: "\u{1101}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AF39}",
        nfc: "\u{AF39}",
        nfd: "\u{1101}\u{1169}\u{11B4}",
        nfkc: "\u{AF39}",
        nfkd: "\u{1101}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AF3A}",
        nfc: "\u{AF3A}",
        nfd: "\u{1101}\u{1169}\u{11B5}",
        nfkc: "\u{AF3A}",
        nfkd: "\u{1101}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AF3B}",
        nfc: "\u{AF3B}",
        nfd: "\u{1101}\u{1169}\u{11B6}",
        nfkc: "\u{AF3B}",
        nfkd: "\u{1101}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AF3C}",
        nfc: "\u{AF3C}",
        nfd: "\u{1101}\u{1169}\u{11B7}",
        nfkc: "\u{AF3C}",
        nfkd: "\u{1101}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AF3D}",
        nfc: "\u{AF3D}",
        nfd: "\u{1101}\u{1169}\u{11B8}",
        nfkc: "\u{AF3D}",
        nfkd: "\u{1101}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AF3E}",
        nfc: "\u{AF3E}",
        nfd: "\u{1101}\u{1169}\u{11B9}",
        nfkc: "\u{AF3E}",
        nfkd: "\u{1101}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AF3F}",
        nfc: "\u{AF3F}",
        nfd: "\u{1101}\u{1169}\u{11BA}",
        nfkc: "\u{AF3F}",
        nfkd: "\u{1101}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AF40}",
        nfc: "\u{AF40}",
        nfd: "\u{1101}\u{1169}\u{11BB}",
        nfkc: "\u{AF40}",
        nfkd: "\u{1101}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AF41}",
        nfc: "\u{AF41}",
        nfd: "\u{1101}\u{1169}\u{11BC}",
        nfkc: "\u{AF41}",
        nfkd: "\u{1101}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AF42}",
        nfc: "\u{AF42}",
        nfd: "\u{1101}\u{1169}\u{11BD}",
        nfkc: "\u{AF42}",
        nfkd: "\u{1101}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AF43}",
        nfc: "\u{AF43}",
        nfd: "\u{1101}\u{1169}\u{11BE}",
        nfkc: "\u{AF43}",
        nfkd: "\u{1101}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AF44}",
        nfc: "\u{AF44}",
        nfd: "\u{1101}\u{1169}\u{11BF}",
        nfkc: "\u{AF44}",
        nfkd: "\u{1101}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AF45}",
        nfc: "\u{AF45}",
        nfd: "\u{1101}\u{1169}\u{11C0}",
        nfkc: "\u{AF45}",
        nfkd: "\u{1101}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AF46}",
        nfc: "\u{AF46}",
        nfd: "\u{1101}\u{1169}\u{11C1}",
        nfkc: "\u{AF46}",
        nfkd: "\u{1101}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AF47}",
        nfc: "\u{AF47}",
        nfd: "\u{1101}\u{1169}\u{11C2}",
        nfkc: "\u{AF47}",
        nfkd: "\u{1101}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AF48}",
        nfc: "\u{AF48}",
        nfd: "\u{1101}\u{116A}",
        nfkc: "\u{AF48}",
        nfkd: "\u{1101}\u{116A}",
    },
    NormalizationTest {
        source: "\u{AF49}",
        nfc: "\u{AF49}",
        nfd: "\u{1101}\u{116A}\u{11A8}",
        nfkc: "\u{AF49}",
        nfkd: "\u{1101}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AF4A}",
        nfc: "\u{AF4A}",
        nfd: "\u{1101}\u{116A}\u{11A9}",
        nfkc: "\u{AF4A}",
        nfkd: "\u{1101}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AF4B}",
        nfc: "\u{AF4B}",
        nfd: "\u{1101}\u{116A}\u{11AA}",
        nfkc: "\u{AF4B}",
        nfkd: "\u{1101}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AF4C}",
        nfc: "\u{AF4C}",
        nfd: "\u{1101}\u{116A}\u{11AB}",
        nfkc: "\u{AF4C}",
        nfkd: "\u{1101}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AF4D}",
        nfc: "\u{AF4D}",
        nfd: "\u{1101}\u{116A}\u{11AC}",
        nfkc: "\u{AF4D}",
        nfkd: "\u{1101}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AF4E}",
        nfc: "\u{AF4E}",
        nfd: "\u{1101}\u{116A}\u{11AD}",
        nfkc: "\u{AF4E}",
        nfkd: "\u{1101}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AF4F}",
        nfc: "\u{AF4F}",
        nfd: "\u{1101}\u{116A}\u{11AE}",
        nfkc: "\u{AF4F}",
        nfkd: "\u{1101}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AF50}",
        nfc: "\u{AF50}",
        nfd: "\u{1101}\u{116A}\u{11AF}",
        nfkc: "\u{AF50}",
        nfkd: "\u{1101}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AF51}",
        nfc: "\u{AF51}",
        nfd: "\u{1101}\u{116A}\u{11B0}",
        nfkc: "\u{AF51}",
        nfkd: "\u{1101}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AF52}",
        nfc: "\u{AF52}",
        nfd: "\u{1101}\u{116A}\u{11B1}",
        nfkc: "\u{AF52}",
        nfkd: "\u{1101}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AF53}",
        nfc: "\u{AF53}",
        nfd: "\u{1101}\u{116A}\u{11B2}",
        nfkc: "\u{AF53}",
        nfkd: "\u{1101}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AF54}",
        nfc: "\u{AF54}",
        nfd: "\u{1101}\u{116A}\u{11B3}",
        nfkc: "\u{AF54}",
        nfkd: "\u{1101}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AF55}",
        nfc: "\u{AF55}",
        nfd: "\u{1101}\u{116A}\u{11B4}",
        nfkc: "\u{AF55}",
        nfkd: "\u{1101}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AF56}",
        nfc: "\u{AF56}",
        nfd: "\u{1101}\u{116A}\u{11B5}",
        nfkc: "\u{AF56}",
        nfkd: "\u{1101}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AF57}",
        nfc: "\u{AF57}",
        nfd: "\u{1101}\u{116A}\u{11B6}",
        nfkc: "\u{AF57}",
        nfkd: "\u{1101}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AF58}",
        nfc: "\u{AF58}",
        nfd: "\u{1101}\u{116A}\u{11B7}",
        nfkc: "\u{AF58}",
        nfkd: "\u{1101}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AF59}",
        nfc: "\u{AF59}",
        nfd: "\u{1101}\u{116A}\u{11B8}",
        nfkc: "\u{AF59}",
        nfkd: "\u{1101}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AF5A}",
        nfc: "\u{AF5A}",
        nfd: "\u{1101}\u{116A}\u{11B9}",
        nfkc: "\u{AF5A}",
        nfkd: "\u{1101}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AF5B}",
        nfc: "\u{AF5B}",
        nfd: "\u{1101}\u{116A}\u{11BA}",
        nfkc: "\u{AF5B}",
        nfkd: "\u{1101}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AF5C}",
        nfc: "\u{AF5C}",
        nfd: "\u{1101}\u{116A}\u{11BB}",
        nfkc: "\u{AF5C}",
        nfkd: "\u{1101}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AF5D}",
        nfc: "\u{AF5D}",
        nfd: "\u{1101}\u{116A}\u{11BC}",
        nfkc: "\u{AF5D}",
        nfkd: "\u{1101}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AF5E}",
        nfc: "\u{AF5E}",
        nfd: "\u{1101}\u{116A}\u{11BD}",
        nfkc: "\u{AF5E}",
        nfkd: "\u{1101}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AF5F}",
        nfc: "\u{AF5F}",
        nfd: "\u{1101}\u{116A}\u{11BE}",
        nfkc: "\u{AF5F}",
        nfkd: "\u{1101}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AF60}",
        nfc: "\u{AF60}",
        nfd: "\u{1101}\u{116A}\u{11BF}",
        nfkc: "\u{AF60}",
        nfkd: "\u{1101}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AF61}",
        nfc: "\u{AF61}",
        nfd: "\u{1101}\u{116A}\u{11C0}",
        nfkc: "\u{AF61}",
        nfkd: "\u{1101}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AF62}",
        nfc: "\u{AF62}",
        nfd: "\u{1101}\u{116A}\u{11C1}",
        nfkc: "\u{AF62}",
        nfkd: "\u{1101}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AF63}",
        nfc: "\u{AF63}",
        nfd: "\u{1101}\u{116A}\u{11C2}",
        nfkc: "\u{AF63}",
        nfkd: "\u{1101}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AF64}",
        nfc: "\u{AF64}",
        nfd: "\u{1101}\u{116B}",
        nfkc: "\u{AF64}",
        nfkd: "\u{1101}\u{116B}",
    },
    NormalizationTest {
        source: "\u{AF65}",
        nfc: "\u{AF65}",
        nfd: "\u{1101}\u{116B}\u{11A8}",
        nfkc: "\u{AF65}",
        nfkd: "\u{1101}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AF66}",
        nfc: "\u{AF66}",
        nfd: "\u{1101}\u{116B}\u{11A9}",
        nfkc: "\u{AF66}",
        nfkd: "\u{1101}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AF67}",
        nfc: "\u{AF67}",
        nfd: "\u{1101}\u{116B}\u{11AA}",
        nfkc: "\u{AF67}",
        nfkd: "\u{1101}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AF68}",
        nfc: "\u{AF68}",
        nfd: "\u{1101}\u{116B}\u{11AB}",
        nfkc: "\u{AF68}",
        nfkd: "\u{1101}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AF69}",
        nfc: "\u{AF69}",
        nfd: "\u{1101}\u{116B}\u{11AC}",
        nfkc: "\u{AF69}",
        nfkd: "\u{1101}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AF6A}",
        nfc: "\u{AF6A}",
        nfd: "\u{1101}\u{116B}\u{11AD}",
        nfkc: "\u{AF6A}",
        nfkd: "\u{1101}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AF6B}",
        nfc: "\u{AF6B}",
        nfd: "\u{1101}\u{116B}\u{11AE}",
        nfkc: "\u{AF6B}",
        nfkd: "\u{1101}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AF6C}",
        nfc: "\u{AF6C}",
        nfd: "\u{1101}\u{116B}\u{11AF}",
        nfkc: "\u{AF6C}",
        nfkd: "\u{1101}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AF6D}",
        nfc: "\u{AF6D}",
        nfd: "\u{1101}\u{116B}\u{11B0}",
        nfkc: "\u{AF6D}",
        nfkd: "\u{1101}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AF6E}",
        nfc: "\u{AF6E}",
        nfd: "\u{1101}\u{116B}\u{11B1}",
        nfkc: "\u{AF6E}",
        nfkd: "\u{1101}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AF6F}",
        nfc: "\u{AF6F}",
        nfd: "\u{1101}\u{116B}\u{11B2}",
        nfkc: "\u{AF6F}",
        nfkd: "\u{1101}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AF70}",
        nfc: "\u{AF70}",
        nfd: "\u{1101}\u{116B}\u{11B3}",
        nfkc: "\u{AF70}",
        nfkd: "\u{1101}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AF71}",
        nfc: "\u{AF71}",
        nfd: "\u{1101}\u{116B}\u{11B4}",
        nfkc: "\u{AF71}",
        nfkd: "\u{1101}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AF72}",
        nfc: "\u{AF72}",
        nfd: "\u{1101}\u{116B}\u{11B5}",
        nfkc: "\u{AF72}",
        nfkd: "\u{1101}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AF73}",
        nfc: "\u{AF73}",
        nfd: "\u{1101}\u{116B}\u{11B6}",
        nfkc: "\u{AF73}",
        nfkd: "\u{1101}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AF74}",
        nfc: "\u{AF74}",
        nfd: "\u{1101}\u{116B}\u{11B7}",
        nfkc: "\u{AF74}",
        nfkd: "\u{1101}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AF75}",
        nfc: "\u{AF75}",
        nfd: "\u{1101}\u{116B}\u{11B8}",
        nfkc: "\u{AF75}",
        nfkd: "\u{1101}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AF76}",
        nfc: "\u{AF76}",
        nfd: "\u{1101}\u{116B}\u{11B9}",
        nfkc: "\u{AF76}",
        nfkd: "\u{1101}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AF77}",
        nfc: "\u{AF77}",
        nfd: "\u{1101}\u{116B}\u{11BA}",
        nfkc: "\u{AF77}",
        nfkd: "\u{1101}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AF78}",
        nfc: "\u{AF78}",
        nfd: "\u{1101}\u{116B}\u{11BB}",
        nfkc: "\u{AF78}",
        nfkd: "\u{1101}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AF79}",
        nfc: "\u{AF79}",
        nfd: "\u{1101}\u{116B}\u{11BC}",
        nfkc: "\u{AF79}",
        nfkd: "\u{1101}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AF7A}",
        nfc: "\u{AF7A}",
        nfd: "\u{1101}\u{116B}\u{11BD}",
        nfkc: "\u{AF7A}",
        nfkd: "\u{1101}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AF7B}",
        nfc: "\u{AF7B}",
        nfd: "\u{1101}\u{116B}\u{11BE}",
        nfkc: "\u{AF7B}",
        nfkd: "\u{1101}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AF7C}",
        nfc: "\u{AF7C}",
        nfd: "\u{1101}\u{116B}\u{11BF}",
        nfkc: "\u{AF7C}",
        nfkd: "\u{1101}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AF7D}",
        nfc: "\u{AF7D}",
        nfd: "\u{1101}\u{116B}\u{11C0}",
        nfkc: "\u{AF7D}",
        nfkd: "\u{1101}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AF7E}",
        nfc: "\u{AF7E}",
        nfd: "\u{1101}\u{116B}\u{11C1}",
        nfkc: "\u{AF7E}",
        nfkd: "\u{1101}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AF7F}",
        nfc: "\u{AF7F}",
        nfd: "\u{1101}\u{116B}\u{11C2}",
        nfkc: "\u{AF7F}",
        nfkd: "\u{1101}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AF80}",
        nfc: "\u{AF80}",
        nfd: "\u{1101}\u{116C}",
        nfkc: "\u{AF80}",
        nfkd: "\u{1101}\u{116C}",
    },
    NormalizationTest {
        source: "\u{AF81}",
        nfc: "\u{AF81}",
        nfd: "\u{1101}\u{116C}\u{11A8}",
        nfkc: "\u{AF81}",
        nfkd: "\u{1101}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AF82}",
        nfc: "\u{AF82}",
        nfd: "\u{1101}\u{116C}\u{11A9}",
        nfkc: "\u{AF82}",
        nfkd: "\u{1101}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AF83}",
        nfc: "\u{AF83}",
        nfd: "\u{1101}\u{116C}\u{11AA}",
        nfkc: "\u{AF83}",
        nfkd: "\u{1101}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AF84}",
        nfc: "\u{AF84}",
        nfd: "\u{1101}\u{116C}\u{11AB}",
        nfkc: "\u{AF84}",
        nfkd: "\u{1101}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AF85}",
        nfc: "\u{AF85}",
        nfd: "\u{1101}\u{116C}\u{11AC}",
        nfkc: "\u{AF85}",
        nfkd: "\u{1101}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AF86}",
        nfc: "\u{AF86}",
        nfd: "\u{1101}\u{116C}\u{11AD}",
        nfkc: "\u{AF86}",
        nfkd: "\u{1101}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AF87}",
        nfc: "\u{AF87}",
        nfd: "\u{1101}\u{116C}\u{11AE}",
        nfkc: "\u{AF87}",
        nfkd: "\u{1101}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AF88}",
        nfc: "\u{AF88}",
        nfd: "\u{1101}\u{116C}\u{11AF}",
        nfkc: "\u{AF88}",
        nfkd: "\u{1101}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AF89}",
        nfc: "\u{AF89}",
        nfd: "\u{1101}\u{116C}\u{11B0}",
        nfkc: "\u{AF89}",
        nfkd: "\u{1101}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AF8A}",
        nfc: "\u{AF8A}",
        nfd: "\u{1101}\u{116C}\u{11B1}",
        nfkc: "\u{AF8A}",
        nfkd: "\u{1101}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AF8B}",
        nfc: "\u{AF8B}",
        nfd: "\u{1101}\u{116C}\u{11B2}",
        nfkc: "\u{AF8B}",
        nfkd: "\u{1101}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AF8C}",
        nfc: "\u{AF8C}",
        nfd: "\u{1101}\u{116C}\u{11B3}",
        nfkc: "\u{AF8C}",
        nfkd: "\u{1101}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AF8D}",
        nfc: "\u{AF8D}",
        nfd: "\u{1101}\u{116C}\u{11B4}",
        nfkc: "\u{AF8D}",
        nfkd: "\u{1101}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AF8E}",
        nfc: "\u{AF8E}",
        nfd: "\u{1101}\u{116C}\u{11B5}",
        nfkc: "\u{AF8E}",
        nfkd: "\u{1101}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AF8F}",
        nfc: "\u{AF8F}",
        nfd: "\u{1101}\u{116C}\u{11B6}",
        nfkc: "\u{AF8F}",
        nfkd: "\u{1101}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AF90}",
        nfc: "\u{AF90}",
        nfd: "\u{1101}\u{116C}\u{11B7}",
        nfkc: "\u{AF90}",
        nfkd: "\u{1101}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AF91}",
        nfc: "\u{AF91}",
        nfd: "\u{1101}\u{116C}\u{11B8}",
        nfkc: "\u{AF91}",
        nfkd: "\u{1101}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AF92}",
        nfc: "\u{AF92}",
        nfd: "\u{1101}\u{116C}\u{11B9}",
        nfkc: "\u{AF92}",
        nfkd: "\u{1101}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AF93}",
        nfc: "\u{AF93}",
        nfd: "\u{1101}\u{116C}\u{11BA}",
        nfkc: "\u{AF93}",
        nfkd: "\u{1101}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AF94}",
        nfc: "\u{AF94}",
        nfd: "\u{1101}\u{116C}\u{11BB}",
        nfkc: "\u{AF94}",
        nfkd: "\u{1101}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AF95}",
        nfc: "\u{AF95}",
        nfd: "\u{1101}\u{116C}\u{11BC}",
        nfkc: "\u{AF95}",
        nfkd: "\u{1101}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AF96}",
        nfc: "\u{AF96}",
        nfd: "\u{1101}\u{116C}\u{11BD}",
        nfkc: "\u{AF96}",
        nfkd: "\u{1101}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AF97}",
        nfc: "\u{AF97}",
        nfd: "\u{1101}\u{116C}\u{11BE}",
        nfkc: "\u{AF97}",
        nfkd: "\u{1101}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AF98}",
        nfc: "\u{AF98}",
        nfd: "\u{1101}\u{116C}\u{11BF}",
        nfkc: "\u{AF98}",
        nfkd: "\u{1101}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AF99}",
        nfc: "\u{AF99}",
        nfd: "\u{1101}\u{116C}\u{11C0}",
        nfkc: "\u{AF99}",
        nfkd: "\u{1101}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AF9A}",
        nfc: "\u{AF9A}",
        nfd: "\u{1101}\u{116C}\u{11C1}",
        nfkc: "\u{AF9A}",
        nfkd: "\u{1101}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AF9B}",
        nfc: "\u{AF9B}",
        nfd: "\u{1101}\u{116C}\u{11C2}",
        nfkc: "\u{AF9B}",
        nfkd: "\u{1101}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AF9C}",
        nfc: "\u{AF9C}",
        nfd: "\u{1101}\u{116D}",
        nfkc: "\u{AF9C}",
        nfkd: "\u{1101}\u{116D}",
    },
    NormalizationTest {
        source: "\u{AF9D}",
        nfc: "\u{AF9D}",
        nfd: "\u{1101}\u{116D}\u{11A8}",
        nfkc: "\u{AF9D}",
        nfkd: "\u{1101}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AF9E}",
        nfc: "\u{AF9E}",
        nfd: "\u{1101}\u{116D}\u{11A9}",
        nfkc: "\u{AF9E}",
        nfkd: "\u{1101}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AF9F}",
        nfc: "\u{AF9F}",
        nfd: "\u{1101}\u{116D}\u{11AA}",
        nfkc: "\u{AF9F}",
        nfkd: "\u{1101}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AFA0}",
        nfc: "\u{AFA0}",
        nfd: "\u{1101}\u{116D}\u{11AB}",
        nfkc: "\u{AFA0}",
        nfkd: "\u{1101}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AFA1}",
        nfc: "\u{AFA1}",
        nfd: "\u{1101}\u{116D}\u{11AC}",
        nfkc: "\u{AFA1}",
        nfkd: "\u{1101}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AFA2}",
        nfc: "\u{AFA2}",
        nfd: "\u{1101}\u{116D}\u{11AD}",
        nfkc: "\u{AFA2}",
        nfkd: "\u{1101}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AFA3}",
        nfc: "\u{AFA3}",
        nfd: "\u{1101}\u{116D}\u{11AE}",
        nfkc: "\u{AFA3}",
        nfkd: "\u{1101}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AFA4}",
        nfc: "\u{AFA4}",
        nfd: "\u{1101}\u{116D}\u{11AF}",
        nfkc: "\u{AFA4}",
        nfkd: "\u{1101}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AFA5}",
        nfc: "\u{AFA5}",
        nfd: "\u{1101}\u{116D}\u{11B0}",
        nfkc: "\u{AFA5}",
        nfkd: "\u{1101}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AFA6}",
        nfc: "\u{AFA6}",
        nfd: "\u{1101}\u{116D}\u{11B1}",
        nfkc: "\u{AFA6}",
        nfkd: "\u{1101}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AFA7}",
        nfc: "\u{AFA7}",
        nfd: "\u{1101}\u{116D}\u{11B2}",
        nfkc: "\u{AFA7}",
        nfkd: "\u{1101}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AFA8}",
        nfc: "\u{AFA8}",
        nfd: "\u{1101}\u{116D}\u{11B3}",
        nfkc: "\u{AFA8}",
        nfkd: "\u{1101}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AFA9}",
        nfc: "\u{AFA9}",
        nfd: "\u{1101}\u{116D}\u{11B4}",
        nfkc: "\u{AFA9}",
        nfkd: "\u{1101}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AFAA}",
        nfc: "\u{AFAA}",
        nfd: "\u{1101}\u{116D}\u{11B5}",
        nfkc: "\u{AFAA}",
        nfkd: "\u{1101}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AFAB}",
        nfc: "\u{AFAB}",
        nfd: "\u{1101}\u{116D}\u{11B6}",
        nfkc: "\u{AFAB}",
        nfkd: "\u{1101}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AFAC}",
        nfc: "\u{AFAC}",
        nfd: "\u{1101}\u{116D}\u{11B7}",
        nfkc: "\u{AFAC}",
        nfkd: "\u{1101}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AFAD}",
        nfc: "\u{AFAD}",
        nfd: "\u{1101}\u{116D}\u{11B8}",
        nfkc: "\u{AFAD}",
        nfkd: "\u{1101}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AFAE}",
        nfc: "\u{AFAE}",
        nfd: "\u{1101}\u{116D}\u{11B9}",
        nfkc: "\u{AFAE}",
        nfkd: "\u{1101}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AFAF}",
        nfc: "\u{AFAF}",
        nfd: "\u{1101}\u{116D}\u{11BA}",
        nfkc: "\u{AFAF}",
        nfkd: "\u{1101}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AFB0}",
        nfc: "\u{AFB0}",
        nfd: "\u{1101}\u{116D}\u{11BB}",
        nfkc: "\u{AFB0}",
        nfkd: "\u{1101}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AFB1}",
        nfc: "\u{AFB1}",
        nfd: "\u{1101}\u{116D}\u{11BC}",
        nfkc: "\u{AFB1}",
        nfkd: "\u{1101}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AFB2}",
        nfc: "\u{AFB2}",
        nfd: "\u{1101}\u{116D}\u{11BD}",
        nfkc: "\u{AFB2}",
        nfkd: "\u{1101}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AFB3}",
        nfc: "\u{AFB3}",
        nfd: "\u{1101}\u{116D}\u{11BE}",
        nfkc: "\u{AFB3}",
        nfkd: "\u{1101}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AFB4}",
        nfc: "\u{AFB4}",
        nfd: "\u{1101}\u{116D}\u{11BF}",
        nfkc: "\u{AFB4}",
        nfkd: "\u{1101}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AFB5}",
        nfc: "\u{AFB5}",
        nfd: "\u{1101}\u{116D}\u{11C0}",
        nfkc: "\u{AFB5}",
        nfkd: "\u{1101}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AFB6}",
        nfc: "\u{AFB6}",
        nfd: "\u{1101}\u{116D}\u{11C1}",
        nfkc: "\u{AFB6}",
        nfkd: "\u{1101}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AFB7}",
        nfc: "\u{AFB7}",
        nfd: "\u{1101}\u{116D}\u{11C2}",
        nfkc: "\u{AFB7}",
        nfkd: "\u{1101}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AFB8}",
        nfc: "\u{AFB8}",
        nfd: "\u{1101}\u{116E}",
        nfkc: "\u{AFB8}",
        nfkd: "\u{1101}\u{116E}",
    },
    NormalizationTest {
        source: "\u{AFB9}",
        nfc: "\u{AFB9}",
        nfd: "\u{1101}\u{116E}\u{11A8}",
        nfkc: "\u{AFB9}",
        nfkd: "\u{1101}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AFBA}",
        nfc: "\u{AFBA}",
        nfd: "\u{1101}\u{116E}\u{11A9}",
        nfkc: "\u{AFBA}",
        nfkd: "\u{1101}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AFBB}",
        nfc: "\u{AFBB}",
        nfd: "\u{1101}\u{116E}\u{11AA}",
        nfkc: "\u{AFBB}",
        nfkd: "\u{1101}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AFBC}",
        nfc: "\u{AFBC}",
        nfd: "\u{1101}\u{116E}\u{11AB}",
        nfkc: "\u{AFBC}",
        nfkd: "\u{1101}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AFBD}",
        nfc: "\u{AFBD}",
        nfd: "\u{1101}\u{116E}\u{11AC}",
        nfkc: "\u{AFBD}",
        nfkd: "\u{1101}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AFBE}",
        nfc: "\u{AFBE}",
        nfd: "\u{1101}\u{116E}\u{11AD}",
        nfkc: "\u{AFBE}",
        nfkd: "\u{1101}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AFBF}",
        nfc: "\u{AFBF}",
        nfd: "\u{1101}\u{116E}\u{11AE}",
        nfkc: "\u{AFBF}",
        nfkd: "\u{1101}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AFC0}",
        nfc: "\u{AFC0}",
        nfd: "\u{1101}\u{116E}\u{11AF}",
        nfkc: "\u{AFC0}",
        nfkd: "\u{1101}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AFC1}",
        nfc: "\u{AFC1}",
        nfd: "\u{1101}\u{116E}\u{11B0}",
        nfkc: "\u{AFC1}",
        nfkd: "\u{1101}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AFC2}",
        nfc: "\u{AFC2}",
        nfd: "\u{1101}\u{116E}\u{11B1}",
        nfkc: "\u{AFC2}",
        nfkd: "\u{1101}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AFC3}",
        nfc: "\u{AFC3}",
        nfd: "\u{1101}\u{116E}\u{11B2}",
        nfkc: "\u{AFC3}",
        nfkd: "\u{1101}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AFC4}",
        nfc: "\u{AFC4}",
        nfd: "\u{1101}\u{116E}\u{11B3}",
        nfkc: "\u{AFC4}",
        nfkd: "\u{1101}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AFC5}",
        nfc: "\u{AFC5}",
        nfd: "\u{1101}\u{116E}\u{11B4}",
        nfkc: "\u{AFC5}",
        nfkd: "\u{1101}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AFC6}",
        nfc: "\u{AFC6}",
        nfd: "\u{1101}\u{116E}\u{11B5}",
        nfkc: "\u{AFC6}",
        nfkd: "\u{1101}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AFC7}",
        nfc: "\u{AFC7}",
        nfd: "\u{1101}\u{116E}\u{11B6}",
        nfkc: "\u{AFC7}",
        nfkd: "\u{1101}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AFC8}",
        nfc: "\u{AFC8}",
        nfd: "\u{1101}\u{116E}\u{11B7}",
        nfkc: "\u{AFC8}",
        nfkd: "\u{1101}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AFC9}",
        nfc: "\u{AFC9}",
        nfd: "\u{1101}\u{116E}\u{11B8}",
        nfkc: "\u{AFC9}",
        nfkd: "\u{1101}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AFCA}",
        nfc: "\u{AFCA}",
        nfd: "\u{1101}\u{116E}\u{11B9}",
        nfkc: "\u{AFCA}",
        nfkd: "\u{1101}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AFCB}",
        nfc: "\u{AFCB}",
        nfd: "\u{1101}\u{116E}\u{11BA}",
        nfkc: "\u{AFCB}",
        nfkd: "\u{1101}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AFCC}",
        nfc: "\u{AFCC}",
        nfd: "\u{1101}\u{116E}\u{11BB}",
        nfkc: "\u{AFCC}",
        nfkd: "\u{1101}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AFCD}",
        nfc: "\u{AFCD}",
        nfd: "\u{1101}\u{116E}\u{11BC}",
        nfkc: "\u{AFCD}",
        nfkd: "\u{1101}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AFCE}",
        nfc: "\u{AFCE}",
        nfd: "\u{1101}\u{116E}\u{11BD}",
        nfkc: "\u{AFCE}",
        nfkd: "\u{1101}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AFCF}",
        nfc: "\u{AFCF}",
        nfd: "\u{1101}\u{116E}\u{11BE}",
        nfkc: "\u{AFCF}",
        nfkd: "\u{1101}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AFD0}",
        nfc: "\u{AFD0}",
        nfd: "\u{1101}\u{116E}\u{11BF}",
        nfkc: "\u{AFD0}",
        nfkd: "\u{1101}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AFD1}",
        nfc: "\u{AFD1}",
        nfd: "\u{1101}\u{116E}\u{11C0}",
        nfkc: "\u{AFD1}",
        nfkd: "\u{1101}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AFD2}",
        nfc: "\u{AFD2}",
        nfd: "\u{1101}\u{116E}\u{11C1}",
        nfkc: "\u{AFD2}",
        nfkd: "\u{1101}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AFD3}",
        nfc: "\u{AFD3}",
        nfd: "\u{1101}\u{116E}\u{11C2}",
        nfkc: "\u{AFD3}",
        nfkd: "\u{1101}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AFD4}",
        nfc: "\u{AFD4}",
        nfd: "\u{1101}\u{116F}",
        nfkc: "\u{AFD4}",
        nfkd: "\u{1101}\u{116F}",
    },
    NormalizationTest {
        source: "\u{AFD5}",
        nfc: "\u{AFD5}",
        nfd: "\u{1101}\u{116F}\u{11A8}",
        nfkc: "\u{AFD5}",
        nfkd: "\u{1101}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AFD6}",
        nfc: "\u{AFD6}",
        nfd: "\u{1101}\u{116F}\u{11A9}",
        nfkc: "\u{AFD6}",
        nfkd: "\u{1101}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AFD7}",
        nfc: "\u{AFD7}",
        nfd: "\u{1101}\u{116F}\u{11AA}",
        nfkc: "\u{AFD7}",
        nfkd: "\u{1101}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AFD8}",
        nfc: "\u{AFD8}",
        nfd: "\u{1101}\u{116F}\u{11AB}",
        nfkc: "\u{AFD8}",
        nfkd: "\u{1101}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AFD9}",
        nfc: "\u{AFD9}",
        nfd: "\u{1101}\u{116F}\u{11AC}",
        nfkc: "\u{AFD9}",
        nfkd: "\u{1101}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AFDA}",
        nfc: "\u{AFDA}",
        nfd: "\u{1101}\u{116F}\u{11AD}",
        nfkc: "\u{AFDA}",
        nfkd: "\u{1101}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AFDB}",
        nfc: "\u{AFDB}",
        nfd: "\u{1101}\u{116F}\u{11AE}",
        nfkc: "\u{AFDB}",
        nfkd: "\u{1101}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AFDC}",
        nfc: "\u{AFDC}",
        nfd: "\u{1101}\u{116F}\u{11AF}",
        nfkc: "\u{AFDC}",
        nfkd: "\u{1101}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AFDD}",
        nfc: "\u{AFDD}",
        nfd: "\u{1101}\u{116F}\u{11B0}",
        nfkc: "\u{AFDD}",
        nfkd: "\u{1101}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AFDE}",
        nfc: "\u{AFDE}",
        nfd: "\u{1101}\u{116F}\u{11B1}",
        nfkc: "\u{AFDE}",
        nfkd: "\u{1101}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AFDF}",
        nfc: "\u{AFDF}",
        nfd: "\u{1101}\u{116F}\u{11B2}",
        nfkc: "\u{AFDF}",
        nfkd: "\u{1101}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AFE0}",
        nfc: "\u{AFE0}",
        nfd: "\u{1101}\u{116F}\u{11B3}",
        nfkc: "\u{AFE0}",
        nfkd: "\u{1101}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AFE1}",
        nfc: "\u{AFE1}",
        nfd: "\u{1101}\u{116F}\u{11B4}",
        nfkc: "\u{AFE1}",
        nfkd: "\u{1101}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AFE2}",
        nfc: "\u{AFE2}",
        nfd: "\u{1101}\u{116F}\u{11B5}",
        nfkc: "\u{AFE2}",
        nfkd: "\u{1101}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AFE3}",
        nfc: "\u{AFE3}",
        nfd: "\u{1101}\u{116F}\u{11B6}",
        nfkc: "\u{AFE3}",
        nfkd: "\u{1101}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{AFE4}",
        nfc: "\u{AFE4}",
        nfd: "\u{1101}\u{116F}\u{11B7}",
        nfkc: "\u{AFE4}",
        nfkd: "\u{1101}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{AFE5}",
        nfc: "\u{AFE5}",
        nfd: "\u{1101}\u{116F}\u{11B8}",
        nfkc: "\u{AFE5}",
        nfkd: "\u{1101}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{AFE6}",
        nfc: "\u{AFE6}",
        nfd: "\u{1101}\u{116F}\u{11B9}",
        nfkc: "\u{AFE6}",
        nfkd: "\u{1101}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{AFE7}",
        nfc: "\u{AFE7}",
        nfd: "\u{1101}\u{116F}\u{11BA}",
        nfkc: "\u{AFE7}",
        nfkd: "\u{1101}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{AFE8}",
        nfc: "\u{AFE8}",
        nfd: "\u{1101}\u{116F}\u{11BB}",
        nfkc: "\u{AFE8}",
        nfkd: "\u{1101}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{AFE9}",
        nfc: "\u{AFE9}",
        nfd: "\u{1101}\u{116F}\u{11BC}",
        nfkc: "\u{AFE9}",
        nfkd: "\u{1101}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AFEA}",
        nfc: "\u{AFEA}",
        nfd: "\u{1101}\u{116F}\u{11BD}",
        nfkc: "\u{AFEA}",
        nfkd: "\u{1101}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{AFEB}",
        nfc: "\u{AFEB}",
        nfd: "\u{1101}\u{116F}\u{11BE}",
        nfkc: "\u{AFEB}",
        nfkd: "\u{1101}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{AFEC}",
        nfc: "\u{AFEC}",
        nfd: "\u{1101}\u{116F}\u{11BF}",
        nfkc: "\u{AFEC}",
        nfkd: "\u{1101}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{AFED}",
        nfc: "\u{AFED}",
        nfd: "\u{1101}\u{116F}\u{11C0}",
        nfkc: "\u{AFED}",
        nfkd: "\u{1101}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{AFEE}",
        nfc: "\u{AFEE}",
        nfd: "\u{1101}\u{116F}\u{11C1}",
        nfkc: "\u{AFEE}",
        nfkd: "\u{1101}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{AFEF}",
        nfc: "\u{AFEF}",
        nfd: "\u{1101}\u{116F}\u{11C2}",
        nfkc: "\u{AFEF}",
        nfkd: "\u{1101}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{AFF0}",
        nfc: "\u{AFF0}",
        nfd: "\u{1101}\u{1170}",
        nfkc: "\u{AFF0}",
        nfkd: "\u{1101}\u{1170}",
    },
    NormalizationTest {
        source: "\u{AFF1}",
        nfc: "\u{AFF1}",
        nfd: "\u{1101}\u{1170}\u{11A8}",
        nfkc: "\u{AFF1}",
        nfkd: "\u{1101}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{AFF2}",
        nfc: "\u{AFF2}",
        nfd: "\u{1101}\u{1170}\u{11A9}",
        nfkc: "\u{AFF2}",
        nfkd: "\u{1101}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{AFF3}",
        nfc: "\u{AFF3}",
        nfd: "\u{1101}\u{1170}\u{11AA}",
        nfkc: "\u{AFF3}",
        nfkd: "\u{1101}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{AFF4}",
        nfc: "\u{AFF4}",
        nfd: "\u{1101}\u{1170}\u{11AB}",
        nfkc: "\u{AFF4}",
        nfkd: "\u{1101}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{AFF5}",
        nfc: "\u{AFF5}",
        nfd: "\u{1101}\u{1170}\u{11AC}",
        nfkc: "\u{AFF5}",
        nfkd: "\u{1101}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{AFF6}",
        nfc: "\u{AFF6}",
        nfd: "\u{1101}\u{1170}\u{11AD}",
        nfkc: "\u{AFF6}",
        nfkd: "\u{1101}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{AFF7}",
        nfc: "\u{AFF7}",
        nfd: "\u{1101}\u{1170}\u{11AE}",
        nfkc: "\u{AFF7}",
        nfkd: "\u{1101}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AFF8}",
        nfc: "\u{AFF8}",
        nfd: "\u{1101}\u{1170}\u{11AF}",
        nfkc: "\u{AFF8}",
        nfkd: "\u{1101}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{AFF9}",
        nfc: "\u{AFF9}",
        nfd: "\u{1101}\u{1170}\u{11B0}",
        nfkc: "\u{AFF9}",
        nfkd: "\u{1101}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{AFFA}",
        nfc: "\u{AFFA}",
        nfd: "\u{1101}\u{1170}\u{11B1}",
        nfkc: "\u{AFFA}",
        nfkd: "\u{1101}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{AFFB}",
        nfc: "\u{AFFB}",
        nfd: "\u{1101}\u{1170}\u{11B2}",
        nfkc: "\u{AFFB}",
        nfkd: "\u{1101}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{AFFC}",
        nfc: "\u{AFFC}",
        nfd: "\u{1101}\u{1170}\u{11B3}",
        nfkc: "\u{AFFC}",
        nfkd: "\u{1101}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{AFFD}",
        nfc: "\u{AFFD}",
        nfd: "\u{1101}\u{1170}\u{11B4}",
        nfkc: "\u{AFFD}",
        nfkd: "\u{1101}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{AFFE}",
        nfc: "\u{AFFE}",
        nfd: "\u{1101}\u{1170}\u{11B5}",
        nfkc: "\u{AFFE}",
        nfkd: "\u{1101}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AFFF}",
        nfc: "\u{AFFF}",
        nfd: "\u{1101}\u{1170}\u{11B6}",
        nfkc: "\u{AFFF}",
        nfkd: "\u{1101}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B000}",
        nfc: "\u{B000}",
        nfd: "\u{1101}\u{1170}\u{11B7}",
        nfkc: "\u{B000}",
        nfkd: "\u{1101}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B001}",
        nfc: "\u{B001}",
        nfd: "\u{1101}\u{1170}\u{11B8}",
        nfkc: "\u{B001}",
        nfkd: "\u{1101}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B002}",
        nfc: "\u{B002}",
        nfd: "\u{1101}\u{1170}\u{11B9}",
        nfkc: "\u{B002}",
        nfkd: "\u{1101}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B003}",
        nfc: "\u{B003}",
        nfd: "\u{1101}\u{1170}\u{11BA}",
        nfkc: "\u{B003}",
        nfkd: "\u{1101}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B004}",
        nfc: "\u{B004}",
        nfd: "\u{1101}\u{1170}\u{11BB}",
        nfkc: "\u{B004}",
        nfkd: "\u{1101}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B005}",
        nfc: "\u{B005}",
        nfd: "\u{1101}\u{1170}\u{11BC}",
        nfkc: "\u{B005}",
        nfkd: "\u{1101}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B006}",
        nfc: "\u{B006}",
        nfd: "\u{1101}\u{1170}\u{11BD}",
        nfkc: "\u{B006}",
        nfkd: "\u{1101}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B007}",
        nfc: "\u{B007}",
        nfd: "\u{1101}\u{1170}\u{11BE}",
        nfkc: "\u{B007}",
        nfkd: "\u{1101}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B008}",
        nfc: "\u{B008}",
        nfd: "\u{1101}\u{1170}\u{11BF}",
        nfkc: "\u{B008}",
        nfkd: "\u{1101}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B009}",
        nfc: "\u{B009}",
        nfd: "\u{1101}\u{1170}\u{11C0}",
        nfkc: "\u{B009}",
        nfkd: "\u{1101}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B00A}",
        nfc: "\u{B00A}",
        nfd: "\u{1101}\u{1170}\u{11C1}",
        nfkc: "\u{B00A}",
        nfkd: "\u{1101}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B00B}",
        nfc: "\u{B00B}",
        nfd: "\u{1101}\u{1170}\u{11C2}",
        nfkc: "\u{B00B}",
        nfkd: "\u{1101}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B00C}",
        nfc: "\u{B00C}",
        nfd: "\u{1101}\u{1171}",
        nfkc: "\u{B00C}",
        nfkd: "\u{1101}\u{1171}",
    },
    NormalizationTest {
        source: "\u{B00D}",
        nfc: "\u{B00D}",
        nfd: "\u{1101}\u{1171}\u{11A8}",
        nfkc: "\u{B00D}",
        nfkd: "\u{1101}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B00E}",
        nfc: "\u{B00E}",
        nfd: "\u{1101}\u{1171}\u{11A9}",
        nfkc: "\u{B00E}",
        nfkd: "\u{1101}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B00F}",
        nfc: "\u{B00F}",
        nfd: "\u{1101}\u{1171}\u{11AA}",
        nfkc: "\u{B00F}",
        nfkd: "\u{1101}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B010}",
        nfc: "\u{B010}",
        nfd: "\u{1101}\u{1171}\u{11AB}",
        nfkc: "\u{B010}",
        nfkd: "\u{1101}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B011}",
        nfc: "\u{B011}",
        nfd: "\u{1101}\u{1171}\u{11AC}",
        nfkc: "\u{B011}",
        nfkd: "\u{1101}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B012}",
        nfc: "\u{B012}",
        nfd: "\u{1101}\u{1171}\u{11AD}",
        nfkc: "\u{B012}",
        nfkd: "\u{1101}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B013}",
        nfc: "\u{B013}",
        nfd: "\u{1101}\u{1171}\u{11AE}",
        nfkc: "\u{B013}",
        nfkd: "\u{1101}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B014}",
        nfc: "\u{B014}",
        nfd: "\u{1101}\u{1171}\u{11AF}",
        nfkc: "\u{B014}",
        nfkd: "\u{1101}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B015}",
        nfc: "\u{B015}",
        nfd: "\u{1101}\u{1171}\u{11B0}",
        nfkc: "\u{B015}",
        nfkd: "\u{1101}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B016}",
        nfc: "\u{B016}",
        nfd: "\u{1101}\u{1171}\u{11B1}",
        nfkc: "\u{B016}",
        nfkd: "\u{1101}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B017}",
        nfc: "\u{B017}",
        nfd: "\u{1101}\u{1171}\u{11B2}",
        nfkc: "\u{B017}",
        nfkd: "\u{1101}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B018}",
        nfc: "\u{B018}",
        nfd: "\u{1101}\u{1171}\u{11B3}",
        nfkc: "\u{B018}",
        nfkd: "\u{1101}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B019}",
        nfc: "\u{B019}",
        nfd: "\u{1101}\u{1171}\u{11B4}",
        nfkc: "\u{B019}",
        nfkd: "\u{1101}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B01A}",
        nfc: "\u{B01A}",
        nfd: "\u{1101}\u{1171}\u{11B5}",
        nfkc: "\u{B01A}",
        nfkd: "\u{1101}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B01B}",
        nfc: "\u{B01B}",
        nfd: "\u{1101}\u{1171}\u{11B6}",
        nfkc: "\u{B01B}",
        nfkd: "\u{1101}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B01C}",
        nfc: "\u{B01C}",
        nfd: "\u{1101}\u{1171}\u{11B7}",
        nfkc: "\u{B01C}",
        nfkd: "\u{1101}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B01D}",
        nfc: "\u{B01D}",
        nfd: "\u{1101}\u{1171}\u{11B8}",
        nfkc: "\u{B01D}",
        nfkd: "\u{1101}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B01E}",
        nfc: "\u{B01E}",
        nfd: "\u{1101}\u{1171}\u{11B9}",
        nfkc: "\u{B01E}",
        nfkd: "\u{1101}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B01F}",
        nfc: "\u{B01F}",
        nfd: "\u{1101}\u{1171}\u{11BA}",
        nfkc: "\u{B01F}",
        nfkd: "\u{1101}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B020}",
        nfc: "\u{B020}",
        nfd: "\u{1101}\u{1171}\u{11BB}",
        nfkc: "\u{B020}",
        nfkd: "\u{1101}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B021}",
        nfc: "\u{B021}",
        nfd: "\u{1101}\u{1171}\u{11BC}",
        nfkc: "\u{B021}",
        nfkd: "\u{1101}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B022}",
        nfc: "\u{B022}",
        nfd: "\u{1101}\u{1171}\u{11BD}",
        nfkc: "\u{B022}",
        nfkd: "\u{1101}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B023}",
        nfc: "\u{B023}",
        nfd: "\u{1101}\u{1171}\u{11BE}",
        nfkc: "\u{B023}",
        nfkd: "\u{1101}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B024}",
        nfc: "\u{B024}",
        nfd: "\u{1101}\u{1171}\u{11BF}",
        nfkc: "\u{B024}",
        nfkd: "\u{1101}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B025}",
        nfc: "\u{B025}",
        nfd: "\u{1101}\u{1171}\u{11C0}",
        nfkc: "\u{B025}",
        nfkd: "\u{1101}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B026}",
        nfc: "\u{B026}",
        nfd: "\u{1101}\u{1171}\u{11C1}",
        nfkc: "\u{B026}",
        nfkd: "\u{1101}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B027}",
        nfc: "\u{B027}",
        nfd: "\u{1101}\u{1171}\u{11C2}",
        nfkc: "\u{B027}",
        nfkd: "\u{1101}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B028}",
        nfc: "\u{B028}",
        nfd: "\u{1101}\u{1172}",
        nfkc: "\u{B028}",
        nfkd: "\u{1101}\u{1172}",
    },
    NormalizationTest {
        source: "\u{B029}",
        nfc: "\u{B029}",
        nfd: "\u{1101}\u{1172}\u{11A8}",
        nfkc: "\u{B029}",
        nfkd: "\u{1101}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B02A}",
        nfc: "\u{B02A}",
        nfd: "\u{1101}\u{1172}\u{11A9}",
        nfkc: "\u{B02A}",
        nfkd: "\u{1101}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B02B}",
        nfc: "\u{B02B}",
        nfd: "\u{1101}\u{1172}\u{11AA}",
        nfkc: "\u{B02B}",
        nfkd: "\u{1101}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B02C}",
        nfc: "\u{B02C}",
        nfd: "\u{1101}\u{1172}\u{11AB}",
        nfkc: "\u{B02C}",
        nfkd: "\u{1101}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B02D}",
        nfc: "\u{B02D}",
        nfd: "\u{1101}\u{1172}\u{11AC}",
        nfkc: "\u{B02D}",
        nfkd: "\u{1101}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B02E}",
        nfc: "\u{B02E}",
        nfd: "\u{1101}\u{1172}\u{11AD}",
        nfkc: "\u{B02E}",
        nfkd: "\u{1101}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B02F}",
        nfc: "\u{B02F}",
        nfd: "\u{1101}\u{1172}\u{11AE}",
        nfkc: "\u{B02F}",
        nfkd: "\u{1101}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B030}",
        nfc: "\u{B030}",
        nfd: "\u{1101}\u{1172}\u{11AF}",
        nfkc: "\u{B030}",
        nfkd: "\u{1101}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B031}",
        nfc: "\u{B031}",
        nfd: "\u{1101}\u{1172}\u{11B0}",
        nfkc: "\u{B031}",
        nfkd: "\u{1101}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B032}",
        nfc: "\u{B032}",
        nfd: "\u{1101}\u{1172}\u{11B1}",
        nfkc: "\u{B032}",
        nfkd: "\u{1101}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B033}",
        nfc: "\u{B033}",
        nfd: "\u{1101}\u{1172}\u{11B2}",
        nfkc: "\u{B033}",
        nfkd: "\u{1101}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B034}",
        nfc: "\u{B034}",
        nfd: "\u{1101}\u{1172}\u{11B3}",
        nfkc: "\u{B034}",
        nfkd: "\u{1101}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B035}",
        nfc: "\u{B035}",
        nfd: "\u{1101}\u{1172}\u{11B4}",
        nfkc: "\u{B035}",
        nfkd: "\u{1101}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B036}",
        nfc: "\u{B036}",
        nfd: "\u{1101}\u{1172}\u{11B5}",
        nfkc: "\u{B036}",
        nfkd: "\u{1101}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B037}",
        nfc: "\u{B037}",
        nfd: "\u{1101}\u{1172}\u{11B6}",
        nfkc: "\u{B037}",
        nfkd: "\u{1101}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B038}",
        nfc: "\u{B038}",
        nfd: "\u{1101}\u{1172}\u{11B7}",
        nfkc: "\u{B038}",
        nfkd: "\u{1101}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B039}",
        nfc: "\u{B039}",
        nfd: "\u{1101}\u{1172}\u{11B8}",
        nfkc: "\u{B039}",
        nfkd: "\u{1101}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B03A}",
        nfc: "\u{B03A}",
        nfd: "\u{1101}\u{1172}\u{11B9}",
        nfkc: "\u{B03A}",
        nfkd: "\u{1101}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B03B}",
        nfc: "\u{B03B}",
        nfd: "\u{1101}\u{1172}\u{11BA}",
        nfkc: "\u{B03B}",
        nfkd: "\u{1101}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B03C}",
        nfc: "\u{B03C}",
        nfd: "\u{1101}\u{1172}\u{11BB}",
        nfkc: "\u{B03C}",
        nfkd: "\u{1101}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B03D}",
        nfc: "\u{B03D}",
        nfd: "\u{1101}\u{1172}\u{11BC}",
        nfkc: "\u{B03D}",
        nfkd: "\u{1101}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B03E}",
        nfc: "\u{B03E}",
        nfd: "\u{1101}\u{1172}\u{11BD}",
        nfkc: "\u{B03E}",
        nfkd: "\u{1101}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B03F}",
        nfc: "\u{B03F}",
        nfd: "\u{1101}\u{1172}\u{11BE}",
        nfkc: "\u{B03F}",
        nfkd: "\u{1101}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B040}",
        nfc: "\u{B040}",
        nfd: "\u{1101}\u{1172}\u{11BF}",
        nfkc: "\u{B040}",
        nfkd: "\u{1101}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B041}",
        nfc: "\u{B041}",
        nfd: "\u{1101}\u{1172}\u{11C0}",
        nfkc: "\u{B041}",
        nfkd: "\u{1101}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B042}",
        nfc: "\u{B042}",
        nfd: "\u{1101}\u{1172}\u{11C1}",
        nfkc: "\u{B042}",
        nfkd: "\u{1101}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B043}",
        nfc: "\u{B043}",
        nfd: "\u{1101}\u{1172}\u{11C2}",
        nfkc: "\u{B043}",
        nfkd: "\u{1101}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B044}",
        nfc: "\u{B044}",
        nfd: "\u{1101}\u{1173}",
        nfkc: "\u{B044}",
        nfkd: "\u{1101}\u{1173}",
    },
    NormalizationTest {
        source: "\u{B045}",
        nfc: "\u{B045}",
        nfd: "\u{1101}\u{1173}\u{11A8}",
        nfkc: "\u{B045}",
        nfkd: "\u{1101}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B046}",
        nfc: "\u{B046}",
        nfd: "\u{1101}\u{1173}\u{11A9}",
        nfkc: "\u{B046}",
        nfkd: "\u{1101}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B047}",
        nfc: "\u{B047}",
        nfd: "\u{1101}\u{1173}\u{11AA}",
        nfkc: "\u{B047}",
        nfkd: "\u{1101}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B048}",
        nfc: "\u{B048}",
        nfd: "\u{1101}\u{1173}\u{11AB}",
        nfkc: "\u{B048}",
        nfkd: "\u{1101}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B049}",
        nfc: "\u{B049}",
        nfd: "\u{1101}\u{1173}\u{11AC}",
        nfkc: "\u{B049}",
        nfkd: "\u{1101}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B04A}",
        nfc: "\u{B04A}",
        nfd: "\u{1101}\u{1173}\u{11AD}",
        nfkc: "\u{B04A}",
        nfkd: "\u{1101}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B04B}",
        nfc: "\u{B04B}",
        nfd: "\u{1101}\u{1173}\u{11AE}",
        nfkc: "\u{B04B}",
        nfkd: "\u{1101}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B04C}",
        nfc: "\u{B04C}",
        nfd: "\u{1101}\u{1173}\u{11AF}",
        nfkc: "\u{B04C}",
        nfkd: "\u{1101}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B04D}",
        nfc: "\u{B04D}",
        nfd: "\u{1101}\u{1173}\u{11B0}",
        nfkc: "\u{B04D}",
        nfkd: "\u{1101}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B04E}",
        nfc: "\u{B04E}",
        nfd: "\u{1101}\u{1173}\u{11B1}",
        nfkc: "\u{B04E}",
        nfkd: "\u{1101}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B04F}",
        nfc: "\u{B04F}",
        nfd: "\u{1101}\u{1173}\u{11B2}",
        nfkc: "\u{B04F}",
        nfkd: "\u{1101}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B050}",
        nfc: "\u{B050}",
        nfd: "\u{1101}\u{1173}\u{11B3}",
        nfkc: "\u{B050}",
        nfkd: "\u{1101}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B051}",
        nfc: "\u{B051}",
        nfd: "\u{1101}\u{1173}\u{11B4}",
        nfkc: "\u{B051}",
        nfkd: "\u{1101}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B052}",
        nfc: "\u{B052}",
        nfd: "\u{1101}\u{1173}\u{11B5}",
        nfkc: "\u{B052}",
        nfkd: "\u{1101}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B053}",
        nfc: "\u{B053}",
        nfd: "\u{1101}\u{1173}\u{11B6}",
        nfkc: "\u{B053}",
        nfkd: "\u{1101}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B054}",
        nfc: "\u{B054}",
        nfd: "\u{1101}\u{1173}\u{11B7}",
        nfkc: "\u{B054}",
        nfkd: "\u{1101}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B055}",
        nfc: "\u{B055}",
        nfd: "\u{1101}\u{1173}\u{11B8}",
        nfkc: "\u{B055}",
        nfkd: "\u{1101}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B056}",
        nfc: "\u{B056}",
        nfd: "\u{1101}\u{1173}\u{11B9}",
        nfkc: "\u{B056}",
        nfkd: "\u{1101}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B057}",
        nfc: "\u{B057}",
        nfd: "\u{1101}\u{1173}\u{11BA}",
        nfkc: "\u{B057}",
        nfkd: "\u{1101}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B058}",
        nfc: "\u{B058}",
        nfd: "\u{1101}\u{1173}\u{11BB}",
        nfkc: "\u{B058}",
        nfkd: "\u{1101}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B059}",
        nfc: "\u{B059}",
        nfd: "\u{1101}\u{1173}\u{11BC}",
        nfkc: "\u{B059}",
        nfkd: "\u{1101}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B05A}",
        nfc: "\u{B05A}",
        nfd: "\u{1101}\u{1173}\u{11BD}",
        nfkc: "\u{B05A}",
        nfkd: "\u{1101}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B05B}",
        nfc: "\u{B05B}",
        nfd: "\u{1101}\u{1173}\u{11BE}",
        nfkc: "\u{B05B}",
        nfkd: "\u{1101}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B05C}",
        nfc: "\u{B05C}",
        nfd: "\u{1101}\u{1173}\u{11BF}",
        nfkc: "\u{B05C}",
        nfkd: "\u{1101}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B05D}",
        nfc: "\u{B05D}",
        nfd: "\u{1101}\u{1173}\u{11C0}",
        nfkc: "\u{B05D}",
        nfkd: "\u{1101}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B05E}",
        nfc: "\u{B05E}",
        nfd: "\u{1101}\u{1173}\u{11C1}",
        nfkc: "\u{B05E}",
        nfkd: "\u{1101}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B05F}",
        nfc: "\u{B05F}",
        nfd: "\u{1101}\u{1173}\u{11C2}",
        nfkc: "\u{B05F}",
        nfkd: "\u{1101}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B060}",
        nfc: "\u{B060}",
        nfd: "\u{1101}\u{1174}",
        nfkc: "\u{B060}",
        nfkd: "\u{1101}\u{1174}",
    },
    NormalizationTest {
        source: "\u{B061}",
        nfc: "\u{B061}",
        nfd: "\u{1101}\u{1174}\u{11A8}",
        nfkc: "\u{B061}",
        nfkd: "\u{1101}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B062}",
        nfc: "\u{B062}",
        nfd: "\u{1101}\u{1174}\u{11A9}",
        nfkc: "\u{B062}",
        nfkd: "\u{1101}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B063}",
        nfc: "\u{B063}",
        nfd: "\u{1101}\u{1174}\u{11AA}",
        nfkc: "\u{B063}",
        nfkd: "\u{1101}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B064}",
        nfc: "\u{B064}",
        nfd: "\u{1101}\u{1174}\u{11AB}",
        nfkc: "\u{B064}",
        nfkd: "\u{1101}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B065}",
        nfc: "\u{B065}",
        nfd: "\u{1101}\u{1174}\u{11AC}",
        nfkc: "\u{B065}",
        nfkd: "\u{1101}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B066}",
        nfc: "\u{B066}",
        nfd: "\u{1101}\u{1174}\u{11AD}",
        nfkc: "\u{B066}",
        nfkd: "\u{1101}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B067}",
        nfc: "\u{B067}",
        nfd: "\u{1101}\u{1174}\u{11AE}",
        nfkc: "\u{B067}",
        nfkd: "\u{1101}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B068}",
        nfc: "\u{B068}",
        nfd: "\u{1101}\u{1174}\u{11AF}",
        nfkc: "\u{B068}",
        nfkd: "\u{1101}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B069}",
        nfc: "\u{B069}",
        nfd: "\u{1101}\u{1174}\u{11B0}",
        nfkc: "\u{B069}",
        nfkd: "\u{1101}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B06A}",
        nfc: "\u{B06A}",
        nfd: "\u{1101}\u{1174}\u{11B1}",
        nfkc: "\u{B06A}",
        nfkd: "\u{1101}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B06B}",
        nfc: "\u{B06B}",
        nfd: "\u{1101}\u{1174}\u{11B2}",
        nfkc: "\u{B06B}",
        nfkd: "\u{1101}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B06C}",
        nfc: "\u{B06C}",
        nfd: "\u{1101}\u{1174}\u{11B3}",
        nfkc: "\u{B06C}",
        nfkd: "\u{1101}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B06D}",
        nfc: "\u{B06D}",
        nfd: "\u{1101}\u{1174}\u{11B4}",
        nfkc: "\u{B06D}",
        nfkd: "\u{1101}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B06E}",
        nfc: "\u{B06E}",
        nfd: "\u{1101}\u{1174}\u{11B5}",
        nfkc: "\u{B06E}",
        nfkd: "\u{1101}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B06F}",
        nfc: "\u{B06F}",
        nfd: "\u{1101}\u{1174}\u{11B6}",
        nfkc: "\u{B06F}",
        nfkd: "\u{1101}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B070}",
        nfc: "\u{B070}",
        nfd: "\u{1101}\u{1174}\u{11B7}",
        nfkc: "\u{B070}",
        nfkd: "\u{1101}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B071}",
        nfc: "\u{B071}",
        nfd: "\u{1101}\u{1174}\u{11B8}",
        nfkc: "\u{B071}",
        nfkd: "\u{1101}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B072}",
        nfc: "\u{B072}",
        nfd: "\u{1101}\u{1174}\u{11B9}",
        nfkc: "\u{B072}",
        nfkd: "\u{1101}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B073}",
        nfc: "\u{B073}",
        nfd: "\u{1101}\u{1174}\u{11BA}",
        nfkc: "\u{B073}",
        nfkd: "\u{1101}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B074}",
        nfc: "\u{B074}",
        nfd: "\u{1101}\u{1174}\u{11BB}",
        nfkc: "\u{B074}",
        nfkd: "\u{1101}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B075}",
        nfc: "\u{B075}",
        nfd: "\u{1101}\u{1174}\u{11BC}",
        nfkc: "\u{B075}",
        nfkd: "\u{1101}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B076}",
        nfc: "\u{B076}",
        nfd: "\u{1101}\u{1174}\u{11BD}",
        nfkc: "\u{B076}",
        nfkd: "\u{1101}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B077}",
        nfc: "\u{B077}",
        nfd: "\u{1101}\u{1174}\u{11BE}",
        nfkc: "\u{B077}",
        nfkd: "\u{1101}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B078}",
        nfc: "\u{B078}",
        nfd: "\u{1101}\u{1174}\u{11BF}",
        nfkc: "\u{B078}",
        nfkd: "\u{1101}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B079}",
        nfc: "\u{B079}",
        nfd: "\u{1101}\u{1174}\u{11C0}",
        nfkc: "\u{B079}",
        nfkd: "\u{1101}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B07A}",
        nfc: "\u{B07A}",
        nfd: "\u{1101}\u{1174}\u{11C1}",
        nfkc: "\u{B07A}",
        nfkd: "\u{1101}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B07B}",
        nfc: "\u{B07B}",
        nfd: "\u{1101}\u{1174}\u{11C2}",
        nfkc: "\u{B07B}",
        nfkd: "\u{1101}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B07C}",
        nfc: "\u{B07C}",
        nfd: "\u{1101}\u{1175}",
        nfkc: "\u{B07C}",
        nfkd: "\u{1101}\u{1175}",
    },
    NormalizationTest {
        source: "\u{B07D}",
        nfc: "\u{B07D}",
        nfd: "\u{1101}\u{1175}\u{11A8}",
        nfkc: "\u{B07D}",
        nfkd: "\u{1101}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B07E}",
        nfc: "\u{B07E}",
        nfd: "\u{1101}\u{1175}\u{11A9}",
        nfkc: "\u{B07E}",
        nfkd: "\u{1101}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B07F}",
        nfc: "\u{B07F}",
        nfd: "\u{1101}\u{1175}\u{11AA}",
        nfkc: "\u{B07F}",
        nfkd: "\u{1101}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B080}",
        nfc: "\u{B080}",
        nfd: "\u{1101}\u{1175}\u{11AB}",
        nfkc: "\u{B080}",
        nfkd: "\u{1101}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B081}",
        nfc: "\u{B081}",
        nfd: "\u{1101}\u{1175}\u{11AC}",
        nfkc: "\u{B081}",
        nfkd: "\u{1101}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B082}",
        nfc: "\u{B082}",
        nfd: "\u{1101}\u{1175}\u{11AD}",
        nfkc: "\u{B082}",
        nfkd: "\u{1101}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B083}",
        nfc: "\u{B083}",
        nfd: "\u{1101}\u{1175}\u{11AE}",
        nfkc: "\u{B083}",
        nfkd: "\u{1101}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B084}",
        nfc: "\u{B084}",
        nfd: "\u{1101}\u{1175}\u{11AF}",
        nfkc: "\u{B084}",
        nfkd: "\u{1101}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B085}",
        nfc: "\u{B085}",
        nfd: "\u{1101}\u{1175}\u{11B0}",
        nfkc: "\u{B085}",
        nfkd: "\u{1101}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B086}",
        nfc: "\u{B086}",
        nfd: "\u{1101}\u{1175}\u{11B1}",
        nfkc: "\u{B086}",
        nfkd: "\u{1101}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B087}",
        nfc: "\u{B087}",
        nfd: "\u{1101}\u{1175}\u{11B2}",
        nfkc: "\u{B087}",
        nfkd: "\u{1101}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B088}",
        nfc: "\u{B088}",
        nfd: "\u{1101}\u{1175}\u{11B3}",
        nfkc: "\u{B088}",
        nfkd: "\u{1101}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B089}",
        nfc: "\u{B089}",
        nfd: "\u{1101}\u{1175}\u{11B4}",
        nfkc: "\u{B089}",
        nfkd: "\u{1101}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B08A}",
        nfc: "\u{B08A}",
        nfd: "\u{1101}\u{1175}\u{11B5}",
        nfkc: "\u{B08A}",
        nfkd: "\u{1101}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B08B}",
        nfc: "\u{B08B}",
        nfd: "\u{1101}\u{1175}\u{11B6}",
        nfkc: "\u{B08B}",
        nfkd: "\u{1101}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B08C}",
        nfc: "\u{B08C}",
        nfd: "\u{1101}\u{1175}\u{11B7}",
        nfkc: "\u{B08C}",
        nfkd: "\u{1101}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B08D}",
        nfc: "\u{B08D}",
        nfd: "\u{1101}\u{1175}\u{11B8}",
        nfkc: "\u{B08D}",
        nfkd: "\u{1101}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B08E}",
        nfc: "\u{B08E}",
        nfd: "\u{1101}\u{1175}\u{11B9}",
        nfkc: "\u{B08E}",
        nfkd: "\u{1101}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B08F}",
        nfc: "\u{B08F}",
        nfd: "\u{1101}\u{1175}\u{11BA}",
        nfkc: "\u{B08F}",
        nfkd: "\u{1101}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B090}",
        nfc: "\u{B090}",
        nfd: "\u{1101}\u{1175}\u{11BB}",
        nfkc: "\u{B090}",
        nfkd: "\u{1101}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B091}",
        nfc: "\u{B091}",
        nfd: "\u{1101}\u{1175}\u{11BC}",
        nfkc: "\u{B091}",
        nfkd: "\u{1101}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B092}",
        nfc: "\u{B092}",
        nfd: "\u{1101}\u{1175}\u{11BD}",
        nfkc: "\u{B092}",
        nfkd: "\u{1101}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B093}",
        nfc: "\u{B093}",
        nfd: "\u{1101}\u{1175}\u{11BE}",
        nfkc: "\u{B093}",
        nfkd: "\u{1101}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B094}",
        nfc: "\u{B094}",
        nfd: "\u{1101}\u{1175}\u{11BF}",
        nfkc: "\u{B094}",
        nfkd: "\u{1101}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B095}",
        nfc: "\u{B095}",
        nfd: "\u{1101}\u{1175}\u{11C0}",
        nfkc: "\u{B095}",
        nfkd: "\u{1101}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B096}",
        nfc: "\u{B096}",
        nfd: "\u{1101}\u{1175}\u{11C1}",
        nfkc: "\u{B096}",
        nfkd: "\u{1101}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B097}",
        nfc: "\u{B097}",
        nfd: "\u{1101}\u{1175}\u{11C2}",
        nfkc: "\u{B097}",
        nfkd: "\u{1101}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B098}",
        nfc: "\u{B098}",
        nfd: "\u{1102}\u{1161}",
        nfkc: "\u{B098}",
        nfkd: "\u{1102}\u{1161}",
    },
    NormalizationTest {
        source: "\u{B099}",
        nfc: "\u{B099}",
        nfd: "\u{1102}\u{1161}\u{11A8}",
        nfkc: "\u{B099}",
        nfkd: "\u{1102}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B09A}",
        nfc: "\u{B09A}",
        nfd: "\u{1102}\u{1161}\u{11A9}",
        nfkc: "\u{B09A}",
        nfkd: "\u{1102}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B09B}",
        nfc: "\u{B09B}",
        nfd: "\u{1102}\u{1161}\u{11AA}",
        nfkc: "\u{B09B}",
        nfkd: "\u{1102}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B09C}",
        nfc: "\u{B09C}",
        nfd: "\u{1102}\u{1161}\u{11AB}",
        nfkc: "\u{B09C}",
        nfkd: "\u{1102}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B09D}",
        nfc: "\u{B09D}",
        nfd: "\u{1102}\u{1161}\u{11AC}",
        nfkc: "\u{B09D}",
        nfkd: "\u{1102}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B09E}",
        nfc: "\u{B09E}",
        nfd: "\u{1102}\u{1161}\u{11AD}",
        nfkc: "\u{B09E}",
        nfkd: "\u{1102}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B09F}",
        nfc: "\u{B09F}",
        nfd: "\u{1102}\u{1161}\u{11AE}",
        nfkc: "\u{B09F}",
        nfkd: "\u{1102}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B0A0}",
        nfc: "\u{B0A0}",
        nfd: "\u{1102}\u{1161}\u{11AF}",
        nfkc: "\u{B0A0}",
        nfkd: "\u{1102}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B0A1}",
        nfc: "\u{B0A1}",
        nfd: "\u{1102}\u{1161}\u{11B0}",
        nfkc: "\u{B0A1}",
        nfkd: "\u{1102}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B0A2}",
        nfc: "\u{B0A2}",
        nfd: "\u{1102}\u{1161}\u{11B1}",
        nfkc: "\u{B0A2}",
        nfkd: "\u{1102}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B0A3}",
        nfc: "\u{B0A3}",
        nfd: "\u{1102}\u{1161}\u{11B2}",
        nfkc: "\u{B0A3}",
        nfkd: "\u{1102}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B0A4}",
        nfc: "\u{B0A4}",
        nfd: "\u{1102}\u{1161}\u{11B3}",
        nfkc: "\u{B0A4}",
        nfkd: "\u{1102}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B0A5}",
        nfc: "\u{B0A5}",
        nfd: "\u{1102}\u{1161}\u{11B4}",
        nfkc: "\u{B0A5}",
        nfkd: "\u{1102}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B0A6}",
        nfc: "\u{B0A6}",
        nfd: "\u{1102}\u{1161}\u{11B5}",
        nfkc: "\u{B0A6}",
        nfkd: "\u{1102}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B0A7}",
        nfc: "\u{B0A7}",
        nfd: "\u{1102}\u{1161}\u{11B6}",
        nfkc: "\u{B0A7}",
        nfkd: "\u{1102}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B0A8}",
        nfc: "\u{B0A8}",
        nfd: "\u{1102}\u{1161}\u{11B7}",
        nfkc: "\u{B0A8}",
        nfkd: "\u{1102}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B0A9}",
        nfc: "\u{B0A9}",
        nfd: "\u{1102}\u{1161}\u{11B8}",
        nfkc: "\u{B0A9}",
        nfkd: "\u{1102}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B0AA}",
        nfc: "\u{B0AA}",
        nfd: "\u{1102}\u{1161}\u{11B9}",
        nfkc: "\u{B0AA}",
        nfkd: "\u{1102}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B0AB}",
        nfc: "\u{B0AB}",
        nfd: "\u{1102}\u{1161}\u{11BA}",
        nfkc: "\u{B0AB}",
        nfkd: "\u{1102}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B0AC}",
        nfc: "\u{B0AC}",
        nfd: "\u{1102}\u{1161}\u{11BB}",
        nfkc: "\u{B0AC}",
        nfkd: "\u{1102}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B0AD}",
        nfc: "\u{B0AD}",
        nfd: "\u{1102}\u{1161}\u{11BC}",
        nfkc: "\u{B0AD}",
        nfkd: "\u{1102}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B0AE}",
        nfc: "\u{B0AE}",
        nfd: "\u{1102}\u{1161}\u{11BD}",
        nfkc: "\u{B0AE}",
        nfkd: "\u{1102}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B0AF}",
        nfc: "\u{B0AF}",
        nfd: "\u{1102}\u{1161}\u{11BE}",
        nfkc: "\u{B0AF}",
        nfkd: "\u{1102}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B0B0}",
        nfc: "\u{B0B0}",
        nfd: "\u{1102}\u{1161}\u{11BF}",
        nfkc: "\u{B0B0}",
        nfkd: "\u{1102}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B0B1}",
        nfc: "\u{B0B1}",
        nfd: "\u{1102}\u{1161}\u{11C0}",
        nfkc: "\u{B0B1}",
        nfkd: "\u{1102}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B0B2}",
        nfc: "\u{B0B2}",
        nfd: "\u{1102}\u{1161}\u{11C1}",
        nfkc: "\u{B0B2}",
        nfkd: "\u{1102}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B0B3}",
        nfc: "\u{B0B3}",
        nfd: "\u{1102}\u{1161}\u{11C2}",
        nfkc: "\u{B0B3}",
        nfkd: "\u{1102}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B0B4}",
        nfc: "\u{B0B4}",
        nfd: "\u{1102}\u{1162}",
        nfkc: "\u{B0B4}",
        nfkd: "\u{1102}\u{1162}",
    },
    NormalizationTest {
        source: "\u{B0B5}",
        nfc: "\u{B0B5}",
        nfd: "\u{1102}\u{1162}\u{11A8}",
        nfkc: "\u{B0B5}",
        nfkd: "\u{1102}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B0B6}",
        nfc: "\u{B0B6}",
        nfd: "\u{1102}\u{1162}\u{11A9}",
        nfkc: "\u{B0B6}",
        nfkd: "\u{1102}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B0B7}",
        nfc: "\u{B0B7}",
        nfd: "\u{1102}\u{1162}\u{11AA}",
        nfkc: "\u{B0B7}",
        nfkd: "\u{1102}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B0B8}",
        nfc: "\u{B0B8}",
        nfd: "\u{1102}\u{1162}\u{11AB}",
        nfkc: "\u{B0B8}",
        nfkd: "\u{1102}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B0B9}",
        nfc: "\u{B0B9}",
        nfd: "\u{1102}\u{1162}\u{11AC}",
        nfkc: "\u{B0B9}",
        nfkd: "\u{1102}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B0BA}",
        nfc: "\u{B0BA}",
        nfd: "\u{1102}\u{1162}\u{11AD}",
        nfkc: "\u{B0BA}",
        nfkd: "\u{1102}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B0BB}",
        nfc: "\u{B0BB}",
        nfd: "\u{1102}\u{1162}\u{11AE}",
        nfkc: "\u{B0BB}",
        nfkd: "\u{1102}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B0BC}",
        nfc: "\u{B0BC}",
        nfd: "\u{1102}\u{1162}\u{11AF}",
        nfkc: "\u{B0BC}",
        nfkd: "\u{1102}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B0BD}",
        nfc: "\u{B0BD}",
        nfd: "\u{1102}\u{1162}\u{11B0}",
        nfkc: "\u{B0BD}",
        nfkd: "\u{1102}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B0BE}",
        nfc: "\u{B0BE}",
        nfd: "\u{1102}\u{1162}\u{11B1}",
        nfkc: "\u{B0BE}",
        nfkd: "\u{1102}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B0BF}",
        nfc: "\u{B0BF}",
        nfd: "\u{1102}\u{1162}\u{11B2}",
        nfkc: "\u{B0BF}",
        nfkd: "\u{1102}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B0C0}",
        nfc: "\u{B0C0}",
        nfd: "\u{1102}\u{1162}\u{11B3}",
        nfkc: "\u{B0C0}",
        nfkd: "\u{1102}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B0C1}",
        nfc: "\u{B0C1}",
        nfd: "\u{1102}\u{1162}\u{11B4}",
        nfkc: "\u{B0C1}",
        nfkd: "\u{1102}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B0C2}",
        nfc: "\u{B0C2}",
        nfd: "\u{1102}\u{1162}\u{11B5}",
        nfkc: "\u{B0C2}",
        nfkd: "\u{1102}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B0C3}",
        nfc: "\u{B0C3}",
        nfd: "\u{1102}\u{1162}\u{11B6}",
        nfkc: "\u{B0C3}",
        nfkd: "\u{1102}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B0C4}",
        nfc: "\u{B0C4}",
        nfd: "\u{1102}\u{1162}\u{11B7}",
        nfkc: "\u{B0C4}",
        nfkd: "\u{1102}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B0C5}",
        nfc: "\u{B0C5}",
        nfd: "\u{1102}\u{1162}\u{11B8}",
        nfkc: "\u{B0C5}",
        nfkd: "\u{1102}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B0C6}",
        nfc: "\u{B0C6}",
        nfd: "\u{1102}\u{1162}\u{11B9}",
        nfkc: "\u{B0C6}",
        nfkd: "\u{1102}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B0C7}",
        nfc: "\u{B0C7}",
        nfd: "\u{1102}\u{1162}\u{11BA}",
        nfkc: "\u{B0C7}",
        nfkd: "\u{1102}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B0C8}",
        nfc: "\u{B0C8}",
        nfd: "\u{1102}\u{1162}\u{11BB}",
        nfkc: "\u{B0C8}",
        nfkd: "\u{1102}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B0C9}",
        nfc: "\u{B0C9}",
        nfd: "\u{1102}\u{1162}\u{11BC}",
        nfkc: "\u{B0C9}",
        nfkd: "\u{1102}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B0CA}",
        nfc: "\u{B0CA}",
        nfd: "\u{1102}\u{1162}\u{11BD}",
        nfkc: "\u{B0CA}",
        nfkd: "\u{1102}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B0CB}",
        nfc: "\u{B0CB}",
        nfd: "\u{1102}\u{1162}\u{11BE}",
        nfkc: "\u{B0CB}",
        nfkd: "\u{1102}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B0CC}",
        nfc: "\u{B0CC}",
        nfd: "\u{1102}\u{1162}\u{11BF}",
        nfkc: "\u{B0CC}",
        nfkd: "\u{1102}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B0CD}",
        nfc: "\u{B0CD}",
        nfd: "\u{1102}\u{1162}\u{11C0}",
        nfkc: "\u{B0CD}",
        nfkd: "\u{1102}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B0CE}",
        nfc: "\u{B0CE}",
        nfd: "\u{1102}\u{1162}\u{11C1}",
        nfkc: "\u{B0CE}",
        nfkd: "\u{1102}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B0CF}",
        nfc: "\u{B0CF}",
        nfd: "\u{1102}\u{1162}\u{11C2}",
        nfkc: "\u{B0CF}",
        nfkd: "\u{1102}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B0D0}",
        nfc: "\u{B0D0}",
        nfd: "\u{1102}\u{1163}",
        nfkc: "\u{B0D0}",
        nfkd: "\u{1102}\u{1163}",
    },
    NormalizationTest {
        source: "\u{B0D1}",
        nfc: "\u{B0D1}",
        nfd: "\u{1102}\u{1163}\u{11A8}",
        nfkc: "\u{B0D1}",
        nfkd: "\u{1102}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B0D2}",
        nfc: "\u{B0D2}",
        nfd: "\u{1102}\u{1163}\u{11A9}",
        nfkc: "\u{B0D2}",
        nfkd: "\u{1102}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B0D3}",
        nfc: "\u{B0D3}",
        nfd: "\u{1102}\u{1163}\u{11AA}",
        nfkc: "\u{B0D3}",
        nfkd: "\u{1102}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B0D4}",
        nfc: "\u{B0D4}",
        nfd: "\u{1102}\u{1163}\u{11AB}",
        nfkc: "\u{B0D4}",
        nfkd: "\u{1102}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B0D5}",
        nfc: "\u{B0D5}",
        nfd: "\u{1102}\u{1163}\u{11AC}",
        nfkc: "\u{B0D5}",
        nfkd: "\u{1102}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B0D6}",
        nfc: "\u{B0D6}",
        nfd: "\u{1102}\u{1163}\u{11AD}",
        nfkc: "\u{B0D6}",
        nfkd: "\u{1102}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B0D7}",
        nfc: "\u{B0D7}",
        nfd: "\u{1102}\u{1163}\u{11AE}",
        nfkc: "\u{B0D7}",
        nfkd: "\u{1102}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B0D8}",
        nfc: "\u{B0D8}",
        nfd: "\u{1102}\u{1163}\u{11AF}",
        nfkc: "\u{B0D8}",
        nfkd: "\u{1102}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B0D9}",
        nfc: "\u{B0D9}",
        nfd: "\u{1102}\u{1163}\u{11B0}",
        nfkc: "\u{B0D9}",
        nfkd: "\u{1102}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B0DA}",
        nfc: "\u{B0DA}",
        nfd: "\u{1102}\u{1163}\u{11B1}",
        nfkc: "\u{B0DA}",
        nfkd: "\u{1102}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B0DB}",
        nfc: "\u{B0DB}",
        nfd: "\u{1102}\u{1163}\u{11B2}",
        nfkc: "\u{B0DB}",
        nfkd: "\u{1102}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B0DC}",
        nfc: "\u{B0DC}",
        nfd: "\u{1102}\u{1163}\u{11B3}",
        nfkc: "\u{B0DC}",
        nfkd: "\u{1102}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B0DD}",
        nfc: "\u{B0DD}",
        nfd: "\u{1102}\u{1163}\u{11B4}",
        nfkc: "\u{B0DD}",
        nfkd: "\u{1102}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B0DE}",
        nfc: "\u{B0DE}",
        nfd: "\u{1102}\u{1163}\u{11B5}",
        nfkc: "\u{B0DE}",
        nfkd: "\u{1102}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B0DF}",
        nfc: "\u{B0DF}",
        nfd: "\u{1102}\u{1163}\u{11B6}",
        nfkc: "\u{B0DF}",
        nfkd: "\u{1102}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B0E0}",
        nfc: "\u{B0E0}",
        nfd: "\u{1102}\u{1163}\u{11B7}",
        nfkc: "\u{B0E0}",
        nfkd: "\u{1102}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B0E1}",
        nfc: "\u{B0E1}",
        nfd: "\u{1102}\u{1163}\u{11B8}",
        nfkc: "\u{B0E1}",
        nfkd: "\u{1102}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B0E2}",
        nfc: "\u{B0E2}",
        nfd: "\u{1102}\u{1163}\u{11B9}",
        nfkc: "\u{B0E2}",
        nfkd: "\u{1102}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B0E3}",
        nfc: "\u{B0E3}",
        nfd: "\u{1102}\u{1163}\u{11BA}",
        nfkc: "\u{B0E3}",
        nfkd: "\u{1102}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B0E4}",
        nfc: "\u{B0E4}",
        nfd: "\u{1102}\u{1163}\u{11BB}",
        nfkc: "\u{B0E4}",
        nfkd: "\u{1102}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B0E5}",
        nfc: "\u{B0E5}",
        nfd: "\u{1102}\u{1163}\u{11BC}",
        nfkc: "\u{B0E5}",
        nfkd: "\u{1102}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B0E6}",
        nfc: "\u{B0E6}",
        nfd: "\u{1102}\u{1163}\u{11BD}",
        nfkc: "\u{B0E6}",
        nfkd: "\u{1102}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B0E7}",
        nfc: "\u{B0E7}",
        nfd: "\u{1102}\u{1163}\u{11BE}",
        nfkc: "\u{B0E7}",
        nfkd: "\u{1102}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B0E8}",
        nfc: "\u{B0E8}",
        nfd: "\u{1102}\u{1163}\u{11BF}",
        nfkc: "\u{B0E8}",
        nfkd: "\u{1102}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B0E9}",
        nfc: "\u{B0E9}",
        nfd: "\u{1102}\u{1163}\u{11C0}",
        nfkc: "\u{B0E9}",
        nfkd: "\u{1102}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B0EA}",
        nfc: "\u{B0EA}",
        nfd: "\u{1102}\u{1163}\u{11C1}",
        nfkc: "\u{B0EA}",
        nfkd: "\u{1102}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B0EB}",
        nfc: "\u{B0EB}",
        nfd: "\u{1102}\u{1163}\u{11C2}",
        nfkc: "\u{B0EB}",
        nfkd: "\u{1102}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B0EC}",
        nfc: "\u{B0EC}",
        nfd: "\u{1102}\u{1164}",
        nfkc: "\u{B0EC}",
        nfkd: "\u{1102}\u{1164}",
    },
    NormalizationTest {
        source: "\u{B0ED}",
        nfc: "\u{B0ED}",
        nfd: "\u{1102}\u{1164}\u{11A8}",
        nfkc: "\u{B0ED}",
        nfkd: "\u{1102}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B0EE}",
        nfc: "\u{B0EE}",
        nfd: "\u{1102}\u{1164}\u{11A9}",
        nfkc: "\u{B0EE}",
        nfkd: "\u{1102}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B0EF}",
        nfc: "\u{B0EF}",
        nfd: "\u{1102}\u{1164}\u{11AA}",
        nfkc: "\u{B0EF}",
        nfkd: "\u{1102}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B0F0}",
        nfc: "\u{B0F0}",
        nfd: "\u{1102}\u{1164}\u{11AB}",
        nfkc: "\u{B0F0}",
        nfkd: "\u{1102}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B0F1}",
        nfc: "\u{B0F1}",
        nfd: "\u{1102}\u{1164}\u{11AC}",
        nfkc: "\u{B0F1}",
        nfkd: "\u{1102}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B0F2}",
        nfc: "\u{B0F2}",
        nfd: "\u{1102}\u{1164}\u{11AD}",
        nfkc: "\u{B0F2}",
        nfkd: "\u{1102}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B0F3}",
        nfc: "\u{B0F3}",
        nfd: "\u{1102}\u{1164}\u{11AE}",
        nfkc: "\u{B0F3}",
        nfkd: "\u{1102}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B0F4}",
        nfc: "\u{B0F4}",
        nfd: "\u{1102}\u{1164}\u{11AF}",
        nfkc: "\u{B0F4}",
        nfkd: "\u{1102}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B0F5}",
        nfc: "\u{B0F5}",
        nfd: "\u{1102}\u{1164}\u{11B0}",
        nfkc: "\u{B0F5}",
        nfkd: "\u{1102}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B0F6}",
        nfc: "\u{B0F6}",
        nfd: "\u{1102}\u{1164}\u{11B1}",
        nfkc: "\u{B0F6}",
        nfkd: "\u{1102}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B0F7}",
        nfc: "\u{B0F7}",
        nfd: "\u{1102}\u{1164}\u{11B2}",
        nfkc: "\u{B0F7}",
        nfkd: "\u{1102}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B0F8}",
        nfc: "\u{B0F8}",
        nfd: "\u{1102}\u{1164}\u{11B3}",
        nfkc: "\u{B0F8}",
        nfkd: "\u{1102}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B0F9}",
        nfc: "\u{B0F9}",
        nfd: "\u{1102}\u{1164}\u{11B4}",
        nfkc: "\u{B0F9}",
        nfkd: "\u{1102}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B0FA}",
        nfc: "\u{B0FA}",
        nfd: "\u{1102}\u{1164}\u{11B5}",
        nfkc: "\u{B0FA}",
        nfkd: "\u{1102}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B0FB}",
        nfc: "\u{B0FB}",
        nfd: "\u{1102}\u{1164}\u{11B6}",
        nfkc: "\u{B0FB}",
        nfkd: "\u{1102}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B0FC}",
        nfc: "\u{B0FC}",
        nfd: "\u{1102}\u{1164}\u{11B7}",
        nfkc: "\u{B0FC}",
        nfkd: "\u{1102}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B0FD}",
        nfc: "\u{B0FD}",
        nfd: "\u{1102}\u{1164}\u{11B8}",
        nfkc: "\u{B0FD}",
        nfkd: "\u{1102}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B0FE}",
        nfc: "\u{B0FE}",
        nfd: "\u{1102}\u{1164}\u{11B9}",
        nfkc: "\u{B0FE}",
        nfkd: "\u{1102}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B0FF}",
        nfc: "\u{B0FF}",
        nfd: "\u{1102}\u{1164}\u{11BA}",
        nfkc: "\u{B0FF}",
        nfkd: "\u{1102}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B100}",
        nfc: "\u{B100}",
        nfd: "\u{1102}\u{1164}\u{11BB}",
        nfkc: "\u{B100}",
        nfkd: "\u{1102}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B101}",
        nfc: "\u{B101}",
        nfd: "\u{1102}\u{1164}\u{11BC}",
        nfkc: "\u{B101}",
        nfkd: "\u{1102}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B102}",
        nfc: "\u{B102}",
        nfd: "\u{1102}\u{1164}\u{11BD}",
        nfkc: "\u{B102}",
        nfkd: "\u{1102}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B103}",
        nfc: "\u{B103}",
        nfd: "\u{1102}\u{1164}\u{11BE}",
        nfkc: "\u{B103}",
        nfkd: "\u{1102}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B104}",
        nfc: "\u{B104}",
        nfd: "\u{1102}\u{1164}\u{11BF}",
        nfkc: "\u{B104}",
        nfkd: "\u{1102}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B105}",
        nfc: "\u{B105}",
        nfd: "\u{1102}\u{1164}\u{11C0}",
        nfkc: "\u{B105}",
        nfkd: "\u{1102}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B106}",
        nfc: "\u{B106}",
        nfd: "\u{1102}\u{1164}\u{11C1}",
        nfkc: "\u{B106}",
        nfkd: "\u{1102}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B107}",
        nfc: "\u{B107}",
        nfd: "\u{1102}\u{1164}\u{11C2}",
        nfkc: "\u{B107}",
        nfkd: "\u{1102}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B108}",
        nfc: "\u{B108}",
        nfd: "\u{1102}\u{1165}",
        nfkc: "\u{B108}",
        nfkd: "\u{1102}\u{1165}",
    },
    NormalizationTest {
        source: "\u{B109}",
        nfc: "\u{B109}",
        nfd: "\u{1102}\u{1165}\u{11A8}",
        nfkc: "\u{B109}",
        nfkd: "\u{1102}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B10A}",
        nfc: "\u{B10A}",
        nfd: "\u{1102}\u{1165}\u{11A9}",
        nfkc: "\u{B10A}",
        nfkd: "\u{1102}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B10B}",
        nfc: "\u{B10B}",
        nfd: "\u{1102}\u{1165}\u{11AA}",
        nfkc: "\u{B10B}",
        nfkd: "\u{1102}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B10C}",
        nfc: "\u{B10C}",
        nfd: "\u{1102}\u{1165}\u{11AB}",
        nfkc: "\u{B10C}",
        nfkd: "\u{1102}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B10D}",
        nfc: "\u{B10D}",
        nfd: "\u{1102}\u{1165}\u{11AC}",
        nfkc: "\u{B10D}",
        nfkd: "\u{1102}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B10E}",
        nfc: "\u{B10E}",
        nfd: "\u{1102}\u{1165}\u{11AD}",
        nfkc: "\u{B10E}",
        nfkd: "\u{1102}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B10F}",
        nfc: "\u{B10F}",
        nfd: "\u{1102}\u{1165}\u{11AE}",
        nfkc: "\u{B10F}",
        nfkd: "\u{1102}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B110}",
        nfc: "\u{B110}",
        nfd: "\u{1102}\u{1165}\u{11AF}",
        nfkc: "\u{B110}",
        nfkd: "\u{1102}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B111}",
        nfc: "\u{B111}",
        nfd: "\u{1102}\u{1165}\u{11B0}",
        nfkc: "\u{B111}",
        nfkd: "\u{1102}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B112}",
        nfc: "\u{B112}",
        nfd: "\u{1102}\u{1165}\u{11B1}",
        nfkc: "\u{B112}",
        nfkd: "\u{1102}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B113}",
        nfc: "\u{B113}",
        nfd: "\u{1102}\u{1165}\u{11B2}",
        nfkc: "\u{B113}",
        nfkd: "\u{1102}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B114}",
        nfc: "\u{B114}",
        nfd: "\u{1102}\u{1165}\u{11B3}",
        nfkc: "\u{B114}",
        nfkd: "\u{1102}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B115}",
        nfc: "\u{B115}",
        nfd: "\u{1102}\u{1165}\u{11B4}",
        nfkc: "\u{B115}",
        nfkd: "\u{1102}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B116}",
        nfc: "\u{B116}",
        nfd: "\u{1102}\u{1165}\u{11B5}",
        nfkc: "\u{B116}",
        nfkd: "\u{1102}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B117}",
        nfc: "\u{B117}",
        nfd: "\u{1102}\u{1165}\u{11B6}",
        nfkc: "\u{B117}",
        nfkd: "\u{1102}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B118}",
        nfc: "\u{B118}",
        nfd: "\u{1102}\u{1165}\u{11B7}",
        nfkc: "\u{B118}",
        nfkd: "\u{1102}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B119}",
        nfc: "\u{B119}",
        nfd: "\u{1102}\u{1165}\u{11B8}",
        nfkc: "\u{B119}",
        nfkd: "\u{1102}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B11A}",
        nfc: "\u{B11A}",
        nfd: "\u{1102}\u{1165}\u{11B9}",
        nfkc: "\u{B11A}",
        nfkd: "\u{1102}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B11B}",
        nfc: "\u{B11B}",
        nfd: "\u{1102}\u{1165}\u{11BA}",
        nfkc: "\u{B11B}",
        nfkd: "\u{1102}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B11C}",
        nfc: "\u{B11C}",
        nfd: "\u{1102}\u{1165}\u{11BB}",
        nfkc: "\u{B11C}",
        nfkd: "\u{1102}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B11D}",
        nfc: "\u{B11D}",
        nfd: "\u{1102}\u{1165}\u{11BC}",
        nfkc: "\u{B11D}",
        nfkd: "\u{1102}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B11E}",
        nfc: "\u{B11E}",
        nfd: "\u{1102}\u{1165}\u{11BD}",
        nfkc: "\u{B11E}",
        nfkd: "\u{1102}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B11F}",
        nfc: "\u{B11F}",
        nfd: "\u{1102}\u{1165}\u{11BE}",
        nfkc: "\u{B11F}",
        nfkd: "\u{1102}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B120}",
        nfc: "\u{B120}",
        nfd: "\u{1102}\u{1165}\u{11BF}",
        nfkc: "\u{B120}",
        nfkd: "\u{1102}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B121}",
        nfc: "\u{B121}",
        nfd: "\u{1102}\u{1165}\u{11C0}",
        nfkc: "\u{B121}",
        nfkd: "\u{1102}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B122}",
        nfc: "\u{B122}",
        nfd: "\u{1102}\u{1165}\u{11C1}",
        nfkc: "\u{B122}",
        nfkd: "\u{1102}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B123}",
        nfc: "\u{B123}",
        nfd: "\u{1102}\u{1165}\u{11C2}",
        nfkc: "\u{B123}",
        nfkd: "\u{1102}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B124}",
        nfc: "\u{B124}",
        nfd: "\u{1102}\u{1166}",
        nfkc: "\u{B124}",
        nfkd: "\u{1102}\u{1166}",
    },
    NormalizationTest {
        source: "\u{B125}",
        nfc: "\u{B125}",
        nfd: "\u{1102}\u{1166}\u{11A8}",
        nfkc: "\u{B125}",
        nfkd: "\u{1102}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B126}",
        nfc: "\u{B126}",
        nfd: "\u{1102}\u{1166}\u{11A9}",
        nfkc: "\u{B126}",
        nfkd: "\u{1102}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B127}",
        nfc: "\u{B127}",
        nfd: "\u{1102}\u{1166}\u{11AA}",
        nfkc: "\u{B127}",
        nfkd: "\u{1102}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B128}",
        nfc: "\u{B128}",
        nfd: "\u{1102}\u{1166}\u{11AB}",
        nfkc: "\u{B128}",
        nfkd: "\u{1102}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B129}",
        nfc: "\u{B129}",
        nfd: "\u{1102}\u{1166}\u{11AC}",
        nfkc: "\u{B129}",
        nfkd: "\u{1102}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B12A}",
        nfc: "\u{B12A}",
        nfd: "\u{1102}\u{1166}\u{11AD}",
        nfkc: "\u{B12A}",
        nfkd: "\u{1102}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B12B}",
        nfc: "\u{B12B}",
        nfd: "\u{1102}\u{1166}\u{11AE}",
        nfkc: "\u{B12B}",
        nfkd: "\u{1102}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B12C}",
        nfc: "\u{B12C}",
        nfd: "\u{1102}\u{1166}\u{11AF}",
        nfkc: "\u{B12C}",
        nfkd: "\u{1102}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B12D}",
        nfc: "\u{B12D}",
        nfd: "\u{1102}\u{1166}\u{11B0}",
        nfkc: "\u{B12D}",
        nfkd: "\u{1102}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B12E}",
        nfc: "\u{B12E}",
        nfd: "\u{1102}\u{1166}\u{11B1}",
        nfkc: "\u{B12E}",
        nfkd: "\u{1102}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B12F}",
        nfc: "\u{B12F}",
        nfd: "\u{1102}\u{1166}\u{11B2}",
        nfkc: "\u{B12F}",
        nfkd: "\u{1102}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B130}",
        nfc: "\u{B130}",
        nfd: "\u{1102}\u{1166}\u{11B3}",
        nfkc: "\u{B130}",
        nfkd: "\u{1102}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B131}",
        nfc: "\u{B131}",
        nfd: "\u{1102}\u{1166}\u{11B4}",
        nfkc: "\u{B131}",
        nfkd: "\u{1102}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B132}",
        nfc: "\u{B132}",
        nfd: "\u{1102}\u{1166}\u{11B5}",
        nfkc: "\u{B132}",
        nfkd: "\u{1102}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B133}",
        nfc: "\u{B133}",
        nfd: "\u{1102}\u{1166}\u{11B6}",
        nfkc: "\u{B133}",
        nfkd: "\u{1102}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B134}",
        nfc: "\u{B134}",
        nfd: "\u{1102}\u{1166}\u{11B7}",
        nfkc: "\u{B134}",
        nfkd: "\u{1102}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B135}",
        nfc: "\u{B135}",
        nfd: "\u{1102}\u{1166}\u{11B8}",
        nfkc: "\u{B135}",
        nfkd: "\u{1102}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B136}",
        nfc: "\u{B136}",
        nfd: "\u{1102}\u{1166}\u{11B9}",
        nfkc: "\u{B136}",
        nfkd: "\u{1102}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B137}",
        nfc: "\u{B137}",
        nfd: "\u{1102}\u{1166}\u{11BA}",
        nfkc: "\u{B137}",
        nfkd: "\u{1102}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B138}",
        nfc: "\u{B138}",
        nfd: "\u{1102}\u{1166}\u{11BB}",
        nfkc: "\u{B138}",
        nfkd: "\u{1102}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B139}",
        nfc: "\u{B139}",
        nfd: "\u{1102}\u{1166}\u{11BC}",
        nfkc: "\u{B139}",
        nfkd: "\u{1102}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B13A}",
        nfc: "\u{B13A}",
        nfd: "\u{1102}\u{1166}\u{11BD}",
        nfkc: "\u{B13A}",
        nfkd: "\u{1102}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B13B}",
        nfc: "\u{B13B}",
        nfd: "\u{1102}\u{1166}\u{11BE}",
        nfkc: "\u{B13B}",
        nfkd: "\u{1102}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B13C}",
        nfc: "\u{B13C}",
        nfd: "\u{1102}\u{1166}\u{11BF}",
        nfkc: "\u{B13C}",
        nfkd: "\u{1102}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B13D}",
        nfc: "\u{B13D}",
        nfd: "\u{1102}\u{1166}\u{11C0}",
        nfkc: "\u{B13D}",
        nfkd: "\u{1102}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B13E}",
        nfc: "\u{B13E}",
        nfd: "\u{1102}\u{1166}\u{11C1}",
        nfkc: "\u{B13E}",
        nfkd: "\u{1102}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B13F}",
        nfc: "\u{B13F}",
        nfd: "\u{1102}\u{1166}\u{11C2}",
        nfkc: "\u{B13F}",
        nfkd: "\u{1102}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B140}",
        nfc: "\u{B140}",
        nfd: "\u{1102}\u{1167}",
        nfkc: "\u{B140}",
        nfkd: "\u{1102}\u{1167}",
    },
    NormalizationTest {
        source: "\u{B141}",
        nfc: "\u{B141}",
        nfd: "\u{1102}\u{1167}\u{11A8}",
        nfkc: "\u{B141}",
        nfkd: "\u{1102}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B142}",
        nfc: "\u{B142}",
        nfd: "\u{1102}\u{1167}\u{11A9}",
        nfkc: "\u{B142}",
        nfkd: "\u{1102}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B143}",
        nfc: "\u{B143}",
        nfd: "\u{1102}\u{1167}\u{11AA}",
        nfkc: "\u{B143}",
        nfkd: "\u{1102}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B144}",
        nfc: "\u{B144}",
        nfd: "\u{1102}\u{1167}\u{11AB}",
        nfkc: "\u{B144}",
        nfkd: "\u{1102}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B145}",
        nfc: "\u{B145}",
        nfd: "\u{1102}\u{1167}\u{11AC}",
        nfkc: "\u{B145}",
        nfkd: "\u{1102}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B146}",
        nfc: "\u{B146}",
        nfd: "\u{1102}\u{1167}\u{11AD}",
        nfkc: "\u{B146}",
        nfkd: "\u{1102}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B147}",
        nfc: "\u{B147}",
        nfd: "\u{1102}\u{1167}\u{11AE}",
        nfkc: "\u{B147}",
        nfkd: "\u{1102}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B148}",
        nfc: "\u{B148}",
        nfd: "\u{1102}\u{1167}\u{11AF}",
        nfkc: "\u{B148}",
        nfkd: "\u{1102}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B149}",
        nfc: "\u{B149}",
        nfd: "\u{1102}\u{1167}\u{11B0}",
        nfkc: "\u{B149}",
        nfkd: "\u{1102}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B14A}",
        nfc: "\u{B14A}",
        nfd: "\u{1102}\u{1167}\u{11B1}",
        nfkc: "\u{B14A}",
        nfkd: "\u{1102}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B14B}",
        nfc: "\u{B14B}",
        nfd: "\u{1102}\u{1167}\u{11B2}",
        nfkc: "\u{B14B}",
        nfkd: "\u{1102}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B14C}",
        nfc: "\u{B14C}",
        nfd: "\u{1102}\u{1167}\u{11B3}",
        nfkc: "\u{B14C}",
        nfkd: "\u{1102}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B14D}",
        nfc: "\u{B14D}",
        nfd: "\u{1102}\u{1167}\u{11B4}",
        nfkc: "\u{B14D}",
        nfkd: "\u{1102}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B14E}",
        nfc: "\u{B14E}",
        nfd: "\u{1102}\u{1167}\u{11B5}",
        nfkc: "\u{B14E}",
        nfkd: "\u{1102}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B14F}",
        nfc: "\u{B14F}",
        nfd: "\u{1102}\u{1167}\u{11B6}",
        nfkc: "\u{B14F}",
        nfkd: "\u{1102}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B150}",
        nfc: "\u{B150}",
        nfd: "\u{1102}\u{1167}\u{11B7}",
        nfkc: "\u{B150}",
        nfkd: "\u{1102}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B151}",
        nfc: "\u{B151}",
        nfd: "\u{1102}\u{1167}\u{11B8}",
        nfkc: "\u{B151}",
        nfkd: "\u{1102}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B152}",
        nfc: "\u{B152}",
        nfd: "\u{1102}\u{1167}\u{11B9}",
        nfkc: "\u{B152}",
        nfkd: "\u{1102}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B153}",
        nfc: "\u{B153}",
        nfd: "\u{1102}\u{1167}\u{11BA}",
        nfkc: "\u{B153}",
        nfkd: "\u{1102}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B154}",
        nfc: "\u{B154}",
        nfd: "\u{1102}\u{1167}\u{11BB}",
        nfkc: "\u{B154}",
        nfkd: "\u{1102}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B155}",
        nfc: "\u{B155}",
        nfd: "\u{1102}\u{1167}\u{11BC}",
        nfkc: "\u{B155}",
        nfkd: "\u{1102}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B156}",
        nfc: "\u{B156}",
        nfd: "\u{1102}\u{1167}\u{11BD}",
        nfkc: "\u{B156}",
        nfkd: "\u{1102}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B157}",
        nfc: "\u{B157}",
        nfd: "\u{1102}\u{1167}\u{11BE}",
        nfkc: "\u{B157}",
        nfkd: "\u{1102}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B158}",
        nfc: "\u{B158}",
        nfd: "\u{1102}\u{1167}\u{11BF}",
        nfkc: "\u{B158}",
        nfkd: "\u{1102}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B159}",
        nfc: "\u{B159}",
        nfd: "\u{1102}\u{1167}\u{11C0}",
        nfkc: "\u{B159}",
        nfkd: "\u{1102}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B15A}",
        nfc: "\u{B15A}",
        nfd: "\u{1102}\u{1167}\u{11C1}",
        nfkc: "\u{B15A}",
        nfkd: "\u{1102}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B15B}",
        nfc: "\u{B15B}",
        nfd: "\u{1102}\u{1167}\u{11C2}",
        nfkc: "\u{B15B}",
        nfkd: "\u{1102}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B15C}",
        nfc: "\u{B15C}",
        nfd: "\u{1102}\u{1168}",
        nfkc: "\u{B15C}",
        nfkd: "\u{1102}\u{1168}",
    },
    NormalizationTest {
        source: "\u{B15D}",
        nfc: "\u{B15D}",
        nfd: "\u{1102}\u{1168}\u{11A8}",
        nfkc: "\u{B15D}",
        nfkd: "\u{1102}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B15E}",
        nfc: "\u{B15E}",
        nfd: "\u{1102}\u{1168}\u{11A9}",
        nfkc: "\u{B15E}",
        nfkd: "\u{1102}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B15F}",
        nfc: "\u{B15F}",
        nfd: "\u{1102}\u{1168}\u{11AA}",
        nfkc: "\u{B15F}",
        nfkd: "\u{1102}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B160}",
        nfc: "\u{B160}",
        nfd: "\u{1102}\u{1168}\u{11AB}",
        nfkc: "\u{B160}",
        nfkd: "\u{1102}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B161}",
        nfc: "\u{B161}",
        nfd: "\u{1102}\u{1168}\u{11AC}",
        nfkc: "\u{B161}",
        nfkd: "\u{1102}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B162}",
        nfc: "\u{B162}",
        nfd: "\u{1102}\u{1168}\u{11AD}",
        nfkc: "\u{B162}",
        nfkd: "\u{1102}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B163}",
        nfc: "\u{B163}",
        nfd: "\u{1102}\u{1168}\u{11AE}",
        nfkc: "\u{B163}",
        nfkd: "\u{1102}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B164}",
        nfc: "\u{B164}",
        nfd: "\u{1102}\u{1168}\u{11AF}",
        nfkc: "\u{B164}",
        nfkd: "\u{1102}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B165}",
        nfc: "\u{B165}",
        nfd: "\u{1102}\u{1168}\u{11B0}",
        nfkc: "\u{B165}",
        nfkd: "\u{1102}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B166}",
        nfc: "\u{B166}",
        nfd: "\u{1102}\u{1168}\u{11B1}",
        nfkc: "\u{B166}",
        nfkd: "\u{1102}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B167}",
        nfc: "\u{B167}",
        nfd: "\u{1102}\u{1168}\u{11B2}",
        nfkc: "\u{B167}",
        nfkd: "\u{1102}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B168}",
        nfc: "\u{B168}",
        nfd: "\u{1102}\u{1168}\u{11B3}",
        nfkc: "\u{B168}",
        nfkd: "\u{1102}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B169}",
        nfc: "\u{B169}",
        nfd: "\u{1102}\u{1168}\u{11B4}",
        nfkc: "\u{B169}",
        nfkd: "\u{1102}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B16A}",
        nfc: "\u{B16A}",
        nfd: "\u{1102}\u{1168}\u{11B5}",
        nfkc: "\u{B16A}",
        nfkd: "\u{1102}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B16B}",
        nfc: "\u{B16B}",
        nfd: "\u{1102}\u{1168}\u{11B6}",
        nfkc: "\u{B16B}",
        nfkd: "\u{1102}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B16C}",
        nfc: "\u{B16C}",
        nfd: "\u{1102}\u{1168}\u{11B7}",
        nfkc: "\u{B16C}",
        nfkd: "\u{1102}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B16D}",
        nfc: "\u{B16D}",
        nfd: "\u{1102}\u{1168}\u{11B8}",
        nfkc: "\u{B16D}",
        nfkd: "\u{1102}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B16E}",
        nfc: "\u{B16E}",
        nfd: "\u{1102}\u{1168}\u{11B9}",
        nfkc: "\u{B16E}",
        nfkd: "\u{1102}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B16F}",
        nfc: "\u{B16F}",
        nfd: "\u{1102}\u{1168}\u{11BA}",
        nfkc: "\u{B16F}",
        nfkd: "\u{1102}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B170}",
        nfc: "\u{B170}",
        nfd: "\u{1102}\u{1168}\u{11BB}",
        nfkc: "\u{B170}",
        nfkd: "\u{1102}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B171}",
        nfc: "\u{B171}",
        nfd: "\u{1102}\u{1168}\u{11BC}",
        nfkc: "\u{B171}",
        nfkd: "\u{1102}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B172}",
        nfc: "\u{B172}",
        nfd: "\u{1102}\u{1168}\u{11BD}",
        nfkc: "\u{B172}",
        nfkd: "\u{1102}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B173}",
        nfc: "\u{B173}",
        nfd: "\u{1102}\u{1168}\u{11BE}",
        nfkc: "\u{B173}",
        nfkd: "\u{1102}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B174}",
        nfc: "\u{B174}",
        nfd: "\u{1102}\u{1168}\u{11BF}",
        nfkc: "\u{B174}",
        nfkd: "\u{1102}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B175}",
        nfc: "\u{B175}",
        nfd: "\u{1102}\u{1168}\u{11C0}",
        nfkc: "\u{B175}",
        nfkd: "\u{1102}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B176}",
        nfc: "\u{B176}",
        nfd: "\u{1102}\u{1168}\u{11C1}",
        nfkc: "\u{B176}",
        nfkd: "\u{1102}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B177}",
        nfc: "\u{B177}",
        nfd: "\u{1102}\u{1168}\u{11C2}",
        nfkc: "\u{B177}",
        nfkd: "\u{1102}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B178}",
        nfc: "\u{B178}",
        nfd: "\u{1102}\u{1169}",
        nfkc: "\u{B178}",
        nfkd: "\u{1102}\u{1169}",
    },
    NormalizationTest {
        source: "\u{B179}",
        nfc: "\u{B179}",
        nfd: "\u{1102}\u{1169}\u{11A8}",
        nfkc: "\u{B179}",
        nfkd: "\u{1102}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B17A}",
        nfc: "\u{B17A}",
        nfd: "\u{1102}\u{1169}\u{11A9}",
        nfkc: "\u{B17A}",
        nfkd: "\u{1102}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B17B}",
        nfc: "\u{B17B}",
        nfd: "\u{1102}\u{1169}\u{11AA}",
        nfkc: "\u{B17B}",
        nfkd: "\u{1102}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B17C}",
        nfc: "\u{B17C}",
        nfd: "\u{1102}\u{1169}\u{11AB}",
        nfkc: "\u{B17C}",
        nfkd: "\u{1102}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B17D}",
        nfc: "\u{B17D}",
        nfd: "\u{1102}\u{1169}\u{11AC}",
        nfkc: "\u{B17D}",
        nfkd: "\u{1102}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B17E}",
        nfc: "\u{B17E}",
        nfd: "\u{1102}\u{1169}\u{11AD}",
        nfkc: "\u{B17E}",
        nfkd: "\u{1102}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B17F}",
        nfc: "\u{B17F}",
        nfd: "\u{1102}\u{1169}\u{11AE}",
        nfkc: "\u{B17F}",
        nfkd: "\u{1102}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B180}",
        nfc: "\u{B180}",
        nfd: "\u{1102}\u{1169}\u{11AF}",
        nfkc: "\u{B180}",
        nfkd: "\u{1102}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B181}",
        nfc: "\u{B181}",
        nfd: "\u{1102}\u{1169}\u{11B0}",
        nfkc: "\u{B181}",
        nfkd: "\u{1102}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B182}",
        nfc: "\u{B182}",
        nfd: "\u{1102}\u{1169}\u{11B1}",
        nfkc: "\u{B182}",
        nfkd: "\u{1102}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B183}",
        nfc: "\u{B183}",
        nfd: "\u{1102}\u{1169}\u{11B2}",
        nfkc: "\u{B183}",
        nfkd: "\u{1102}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B184}",
        nfc: "\u{B184}",
        nfd: "\u{1102}\u{1169}\u{11B3}",
        nfkc: "\u{B184}",
        nfkd: "\u{1102}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B185}",
        nfc: "\u{B185}",
        nfd: "\u{1102}\u{1169}\u{11B4}",
        nfkc: "\u{B185}",
        nfkd: "\u{1102}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B186}",
        nfc: "\u{B186}",
        nfd: "\u{1102}\u{1169}\u{11B5}",
        nfkc: "\u{B186}",
        nfkd: "\u{1102}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B187}",
        nfc: "\u{B187}",
        nfd: "\u{1102}\u{1169}\u{11B6}",
        nfkc: "\u{B187}",
        nfkd: "\u{1102}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B188}",
        nfc: "\u{B188}",
        nfd: "\u{1102}\u{1169}\u{11B7}",
        nfkc: "\u{B188}",
        nfkd: "\u{1102}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B189}",
        nfc: "\u{B189}",
        nfd: "\u{1102}\u{1169}\u{11B8}",
        nfkc: "\u{B189}",
        nfkd: "\u{1102}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B18A}",
        nfc: "\u{B18A}",
        nfd: "\u{1102}\u{1169}\u{11B9}",
        nfkc: "\u{B18A}",
        nfkd: "\u{1102}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B18B}",
        nfc: "\u{B18B}",
        nfd: "\u{1102}\u{1169}\u{11BA}",
        nfkc: "\u{B18B}",
        nfkd: "\u{1102}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B18C}",
        nfc: "\u{B18C}",
        nfd: "\u{1102}\u{1169}\u{11BB}",
        nfkc: "\u{B18C}",
        nfkd: "\u{1102}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B18D}",
        nfc: "\u{B18D}",
        nfd: "\u{1102}\u{1169}\u{11BC}",
        nfkc: "\u{B18D}",
        nfkd: "\u{1102}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B18E}",
        nfc: "\u{B18E}",
        nfd: "\u{1102}\u{1169}\u{11BD}",
        nfkc: "\u{B18E}",
        nfkd: "\u{1102}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B18F}",
        nfc: "\u{B18F}",
        nfd: "\u{1102}\u{1169}\u{11BE}",
        nfkc: "\u{B18F}",
        nfkd: "\u{1102}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B190}",
        nfc: "\u{B190}",
        nfd: "\u{1102}\u{1169}\u{11BF}",
        nfkc: "\u{B190}",
        nfkd: "\u{1102}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B191}",
        nfc: "\u{B191}",
        nfd: "\u{1102}\u{1169}\u{11C0}",
        nfkc: "\u{B191}",
        nfkd: "\u{1102}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B192}",
        nfc: "\u{B192}",
        nfd: "\u{1102}\u{1169}\u{11C1}",
        nfkc: "\u{B192}",
        nfkd: "\u{1102}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B193}",
        nfc: "\u{B193}",
        nfd: "\u{1102}\u{1169}\u{11C2}",
        nfkc: "\u{B193}",
        nfkd: "\u{1102}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B194}",
        nfc: "\u{B194}",
        nfd: "\u{1102}\u{116A}",
        nfkc: "\u{B194}",
        nfkd: "\u{1102}\u{116A}",
    },
    NormalizationTest {
        source: "\u{B195}",
        nfc: "\u{B195}",
        nfd: "\u{1102}\u{116A}\u{11A8}",
        nfkc: "\u{B195}",
        nfkd: "\u{1102}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B196}",
        nfc: "\u{B196}",
        nfd: "\u{1102}\u{116A}\u{11A9}",
        nfkc: "\u{B196}",
        nfkd: "\u{1102}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B197}",
        nfc: "\u{B197}",
        nfd: "\u{1102}\u{116A}\u{11AA}",
        nfkc: "\u{B197}",
        nfkd: "\u{1102}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B198}",
        nfc: "\u{B198}",
        nfd: "\u{1102}\u{116A}\u{11AB}",
        nfkc: "\u{B198}",
        nfkd: "\u{1102}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B199}",
        nfc: "\u{B199}",
        nfd: "\u{1102}\u{116A}\u{11AC}",
        nfkc: "\u{B199}",
        nfkd: "\u{1102}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B19A}",
        nfc: "\u{B19A}",
        nfd: "\u{1102}\u{116A}\u{11AD}",
        nfkc: "\u{B19A}",
        nfkd: "\u{1102}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B19B}",
        nfc: "\u{B19B}",
        nfd: "\u{1102}\u{116A}\u{11AE}",
        nfkc: "\u{B19B}",
        nfkd: "\u{1102}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B19C}",
        nfc: "\u{B19C}",
        nfd: "\u{1102}\u{116A}\u{11AF}",
        nfkc: "\u{B19C}",
        nfkd: "\u{1102}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B19D}",
        nfc: "\u{B19D}",
        nfd: "\u{1102}\u{116A}\u{11B0}",
        nfkc: "\u{B19D}",
        nfkd: "\u{1102}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B19E}",
        nfc: "\u{B19E}",
        nfd: "\u{1102}\u{116A}\u{11B1}",
        nfkc: "\u{B19E}",
        nfkd: "\u{1102}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B19F}",
        nfc: "\u{B19F}",
        nfd: "\u{1102}\u{116A}\u{11B2}",
        nfkc: "\u{B19F}",
        nfkd: "\u{1102}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B1A0}",
        nfc: "\u{B1A0}",
        nfd: "\u{1102}\u{116A}\u{11B3}",
        nfkc: "\u{B1A0}",
        nfkd: "\u{1102}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B1A1}",
        nfc: "\u{B1A1}",
        nfd: "\u{1102}\u{116A}\u{11B4}",
        nfkc: "\u{B1A1}",
        nfkd: "\u{1102}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B1A2}",
        nfc: "\u{B1A2}",
        nfd: "\u{1102}\u{116A}\u{11B5}",
        nfkc: "\u{B1A2}",
        nfkd: "\u{1102}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B1A3}",
        nfc: "\u{B1A3}",
        nfd: "\u{1102}\u{116A}\u{11B6}",
        nfkc: "\u{B1A3}",
        nfkd: "\u{1102}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B1A4}",
        nfc: "\u{B1A4}",
        nfd: "\u{1102}\u{116A}\u{11B7}",
        nfkc: "\u{B1A4}",
        nfkd: "\u{1102}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B1A5}",
        nfc: "\u{B1A5}",
        nfd: "\u{1102}\u{116A}\u{11B8}",
        nfkc: "\u{B1A5}",
        nfkd: "\u{1102}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B1A6}",
        nfc: "\u{B1A6}",
        nfd: "\u{1102}\u{116A}\u{11B9}",
        nfkc: "\u{B1A6}",
        nfkd: "\u{1102}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B1A7}",
        nfc: "\u{B1A7}",
        nfd: "\u{1102}\u{116A}\u{11BA}",
        nfkc: "\u{B1A7}",
        nfkd: "\u{1102}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B1A8}",
        nfc: "\u{B1A8}",
        nfd: "\u{1102}\u{116A}\u{11BB}",
        nfkc: "\u{B1A8}",
        nfkd: "\u{1102}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B1A9}",
        nfc: "\u{B1A9}",
        nfd: "\u{1102}\u{116A}\u{11BC}",
        nfkc: "\u{B1A9}",
        nfkd: "\u{1102}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B1AA}",
        nfc: "\u{B1AA}",
        nfd: "\u{1102}\u{116A}\u{11BD}",
        nfkc: "\u{B1AA}",
        nfkd: "\u{1102}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B1AB}",
        nfc: "\u{B1AB}",
        nfd: "\u{1102}\u{116A}\u{11BE}",
        nfkc: "\u{B1AB}",
        nfkd: "\u{1102}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B1AC}",
        nfc: "\u{B1AC}",
        nfd: "\u{1102}\u{116A}\u{11BF}",
        nfkc: "\u{B1AC}",
        nfkd: "\u{1102}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B1AD}",
        nfc: "\u{B1AD}",
        nfd: "\u{1102}\u{116A}\u{11C0}",
        nfkc: "\u{B1AD}",
        nfkd: "\u{1102}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B1AE}",
        nfc: "\u{B1AE}",
        nfd: "\u{1102}\u{116A}\u{11C1}",
        nfkc: "\u{B1AE}",
        nfkd: "\u{1102}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B1AF}",
        nfc: "\u{B1AF}",
        nfd: "\u{1102}\u{116A}\u{11C2}",
        nfkc: "\u{B1AF}",
        nfkd: "\u{1102}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B1B0}",
        nfc: "\u{B1B0}",
        nfd: "\u{1102}\u{116B}",
        nfkc: "\u{B1B0}",
        nfkd: "\u{1102}\u{116B}",
    },
    NormalizationTest {
        source: "\u{B1B1}",
        nfc: "\u{B1B1}",
        nfd: "\u{1102}\u{116B}\u{11A8}",
        nfkc: "\u{B1B1}",
        nfkd: "\u{1102}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B1B2}",
        nfc: "\u{B1B2}",
        nfd: "\u{1102}\u{116B}\u{11A9}",
        nfkc: "\u{B1B2}",
        nfkd: "\u{1102}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B1B3}",
        nfc: "\u{B1B3}",
        nfd: "\u{1102}\u{116B}\u{11AA}",
        nfkc: "\u{B1B3}",
        nfkd: "\u{1102}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B1B4}",
        nfc: "\u{B1B4}",
        nfd: "\u{1102}\u{116B}\u{11AB}",
        nfkc: "\u{B1B4}",
        nfkd: "\u{1102}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B1B5}",
        nfc: "\u{B1B5}",
        nfd: "\u{1102}\u{116B}\u{11AC}",
        nfkc: "\u{B1B5}",
        nfkd: "\u{1102}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B1B6}",
        nfc: "\u{B1B6}",
        nfd: "\u{1102}\u{116B}\u{11AD}",
        nfkc: "\u{B1B6}",
        nfkd: "\u{1102}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B1B7}",
        nfc: "\u{B1B7}",
        nfd: "\u{1102}\u{116B}\u{11AE}",
        nfkc: "\u{B1B7}",
        nfkd: "\u{1102}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B1B8}",
        nfc: "\u{B1B8}",
        nfd: "\u{1102}\u{116B}\u{11AF}",
        nfkc: "\u{B1B8}",
        nfkd: "\u{1102}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B1B9}",
        nfc: "\u{B1B9}",
        nfd: "\u{1102}\u{116B}\u{11B0}",
        nfkc: "\u{B1B9}",
        nfkd: "\u{1102}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B1BA}",
        nfc: "\u{B1BA}",
        nfd: "\u{1102}\u{116B}\u{11B1}",
        nfkc: "\u{B1BA}",
        nfkd: "\u{1102}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B1BB}",
        nfc: "\u{B1BB}",
        nfd: "\u{1102}\u{116B}\u{11B2}",
        nfkc: "\u{B1BB}",
        nfkd: "\u{1102}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B1BC}",
        nfc: "\u{B1BC}",
        nfd: "\u{1102}\u{116B}\u{11B3}",
        nfkc: "\u{B1BC}",
        nfkd: "\u{1102}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B1BD}",
        nfc: "\u{B1BD}",
        nfd: "\u{1102}\u{116B}\u{11B4}",
        nfkc: "\u{B1BD}",
        nfkd: "\u{1102}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B1BE}",
        nfc: "\u{B1BE}",
        nfd: "\u{1102}\u{116B}\u{11B5}",
        nfkc: "\u{B1BE}",
        nfkd: "\u{1102}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B1BF}",
        nfc: "\u{B1BF}",
        nfd: "\u{1102}\u{116B}\u{11B6}",
        nfkc: "\u{B1BF}",
        nfkd: "\u{1102}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B1C0}",
        nfc: "\u{B1C0}",
        nfd: "\u{1102}\u{116B}\u{11B7}",
        nfkc: "\u{B1C0}",
        nfkd: "\u{1102}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B1C1}",
        nfc: "\u{B1C1}",
        nfd: "\u{1102}\u{116B}\u{11B8}",
        nfkc: "\u{B1C1}",
        nfkd: "\u{1102}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B1C2}",
        nfc: "\u{B1C2}",
        nfd: "\u{1102}\u{116B}\u{11B9}",
        nfkc: "\u{B1C2}",
        nfkd: "\u{1102}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B1C3}",
        nfc: "\u{B1C3}",
        nfd: "\u{1102}\u{116B}\u{11BA}",
        nfkc: "\u{B1C3}",
        nfkd: "\u{1102}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B1C4}",
        nfc: "\u{B1C4}",
        nfd: "\u{1102}\u{116B}\u{11BB}",
        nfkc: "\u{B1C4}",
        nfkd: "\u{1102}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B1C5}",
        nfc: "\u{B1C5}",
        nfd: "\u{1102}\u{116B}\u{11BC}",
        nfkc: "\u{B1C5}",
        nfkd: "\u{1102}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B1C6}",
        nfc: "\u{B1C6}",
        nfd: "\u{1102}\u{116B}\u{11BD}",
        nfkc: "\u{B1C6}",
        nfkd: "\u{1102}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B1C7}",
        nfc: "\u{B1C7}",
        nfd: "\u{1102}\u{116B}\u{11BE}",
        nfkc: "\u{B1C7}",
        nfkd: "\u{1102}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B1C8}",
        nfc: "\u{B1C8}",
        nfd: "\u{1102}\u{116B}\u{11BF}",
        nfkc: "\u{B1C8}",
        nfkd: "\u{1102}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B1C9}",
        nfc: "\u{B1C9}",
        nfd: "\u{1102}\u{116B}\u{11C0}",
        nfkc: "\u{B1C9}",
        nfkd: "\u{1102}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B1CA}",
        nfc: "\u{B1CA}",
        nfd: "\u{1102}\u{116B}\u{11C1}",
        nfkc: "\u{B1CA}",
        nfkd: "\u{1102}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B1CB}",
        nfc: "\u{B1CB}",
        nfd: "\u{1102}\u{116B}\u{11C2}",
        nfkc: "\u{B1CB}",
        nfkd: "\u{1102}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B1CC}",
        nfc: "\u{B1CC}",
        nfd: "\u{1102}\u{116C}",
        nfkc: "\u{B1CC}",
        nfkd: "\u{1102}\u{116C}",
    },
    NormalizationTest {
        source: "\u{B1CD}",
        nfc: "\u{B1CD}",
        nfd: "\u{1102}\u{116C}\u{11A8}",
        nfkc: "\u{B1CD}",
        nfkd: "\u{1102}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B1CE}",
        nfc: "\u{B1CE}",
        nfd: "\u{1102}\u{116C}\u{11A9}",
        nfkc: "\u{B1CE}",
        nfkd: "\u{1102}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B1CF}",
        nfc: "\u{B1CF}",
        nfd: "\u{1102}\u{116C}\u{11AA}",
        nfkc: "\u{B1CF}",
        nfkd: "\u{1102}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B1D0}",
        nfc: "\u{B1D0}",
        nfd: "\u{1102}\u{116C}\u{11AB}",
        nfkc: "\u{B1D0}",
        nfkd: "\u{1102}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B1D1}",
        nfc: "\u{B1D1}",
        nfd: "\u{1102}\u{116C}\u{11AC}",
        nfkc: "\u{B1D1}",
        nfkd: "\u{1102}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B1D2}",
        nfc: "\u{B1D2}",
        nfd: "\u{1102}\u{116C}\u{11AD}",
        nfkc: "\u{B1D2}",
        nfkd: "\u{1102}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B1D3}",
        nfc: "\u{B1D3}",
        nfd: "\u{1102}\u{116C}\u{11AE}",
        nfkc: "\u{B1D3}",
        nfkd: "\u{1102}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B1D4}",
        nfc: "\u{B1D4}",
        nfd: "\u{1102}\u{116C}\u{11AF}",
        nfkc: "\u{B1D4}",
        nfkd: "\u{1102}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B1D5}",
        nfc: "\u{B1D5}",
        nfd: "\u{1102}\u{116C}\u{11B0}",
        nfkc: "\u{B1D5}",
        nfkd: "\u{1102}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B1D6}",
        nfc: "\u{B1D6}",
        nfd: "\u{1102}\u{116C}\u{11B1}",
        nfkc: "\u{B1D6}",
        nfkd: "\u{1102}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B1D7}",
        nfc: "\u{B1D7}",
        nfd: "\u{1102}\u{116C}\u{11B2}",
        nfkc: "\u{B1D7}",
        nfkd: "\u{1102}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B1D8}",
        nfc: "\u{B1D8}",
        nfd: "\u{1102}\u{116C}\u{11B3}",
        nfkc: "\u{B1D8}",
        nfkd: "\u{1102}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B1D9}",
        nfc: "\u{B1D9}",
        nfd: "\u{1102}\u{116C}\u{11B4}",
        nfkc: "\u{B1D9}",
        nfkd: "\u{1102}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B1DA}",
        nfc: "\u{B1DA}",
        nfd: "\u{1102}\u{116C}\u{11B5}",
        nfkc: "\u{B1DA}",
        nfkd: "\u{1102}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B1DB}",
        nfc: "\u{B1DB}",
        nfd: "\u{1102}\u{116C}\u{11B6}",
        nfkc: "\u{B1DB}",
        nfkd: "\u{1102}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B1DC}",
        nfc: "\u{B1DC}",
        nfd: "\u{1102}\u{116C}\u{11B7}",
        nfkc: "\u{B1DC}",
        nfkd: "\u{1102}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B1DD}",
        nfc: "\u{B1DD}",
        nfd: "\u{1102}\u{116C}\u{11B8}",
        nfkc: "\u{B1DD}",
        nfkd: "\u{1102}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B1DE}",
        nfc: "\u{B1DE}",
        nfd: "\u{1102}\u{116C}\u{11B9}",
        nfkc: "\u{B1DE}",
        nfkd: "\u{1102}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B1DF}",
        nfc: "\u{B1DF}",
        nfd: "\u{1102}\u{116C}\u{11BA}",
        nfkc: "\u{B1DF}",
        nfkd: "\u{1102}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B1E0}",
        nfc: "\u{B1E0}",
        nfd: "\u{1102}\u{116C}\u{11BB}",
        nfkc: "\u{B1E0}",
        nfkd: "\u{1102}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B1E1}",
        nfc: "\u{B1E1}",
        nfd: "\u{1102}\u{116C}\u{11BC}",
        nfkc: "\u{B1E1}",
        nfkd: "\u{1102}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B1E2}",
        nfc: "\u{B1E2}",
        nfd: "\u{1102}\u{116C}\u{11BD}",
        nfkc: "\u{B1E2}",
        nfkd: "\u{1102}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B1E3}",
        nfc: "\u{B1E3}",
        nfd: "\u{1102}\u{116C}\u{11BE}",
        nfkc: "\u{B1E3}",
        nfkd: "\u{1102}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B1E4}",
        nfc: "\u{B1E4}",
        nfd: "\u{1102}\u{116C}\u{11BF}",
        nfkc: "\u{B1E4}",
        nfkd: "\u{1102}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B1E5}",
        nfc: "\u{B1E5}",
        nfd: "\u{1102}\u{116C}\u{11C0}",
        nfkc: "\u{B1E5}",
        nfkd: "\u{1102}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B1E6}",
        nfc: "\u{B1E6}",
        nfd: "\u{1102}\u{116C}\u{11C1}",
        nfkc: "\u{B1E6}",
        nfkd: "\u{1102}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B1E7}",
        nfc: "\u{B1E7}",
        nfd: "\u{1102}\u{116C}\u{11C2}",
        nfkc: "\u{B1E7}",
        nfkd: "\u{1102}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B1E8}",
        nfc: "\u{B1E8}",
        nfd: "\u{1102}\u{116D}",
        nfkc: "\u{B1E8}",
        nfkd: "\u{1102}\u{116D}",
    },
    NormalizationTest {
        source: "\u{B1E9}",
        nfc: "\u{B1E9}",
        nfd: "\u{1102}\u{116D}\u{11A8}",
        nfkc: "\u{B1E9}",
        nfkd: "\u{1102}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B1EA}",
        nfc: "\u{B1EA}",
        nfd: "\u{1102}\u{116D}\u{11A9}",
        nfkc: "\u{B1EA}",
        nfkd: "\u{1102}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B1EB}",
        nfc: "\u{B1EB}",
        nfd: "\u{1102}\u{116D}\u{11AA}",
        nfkc: "\u{B1EB}",
        nfkd: "\u{1102}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B1EC}",
        nfc: "\u{B1EC}",
        nfd: "\u{1102}\u{116D}\u{11AB}",
        nfkc: "\u{B1EC}",
        nfkd: "\u{1102}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B1ED}",
        nfc: "\u{B1ED}",
        nfd: "\u{1102}\u{116D}\u{11AC}",
        nfkc: "\u{B1ED}",
        nfkd: "\u{1102}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B1EE}",
        nfc: "\u{B1EE}",
        nfd: "\u{1102}\u{116D}\u{11AD}",
        nfkc: "\u{B1EE}",
        nfkd: "\u{1102}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B1EF}",
        nfc: "\u{B1EF}",
        nfd: "\u{1102}\u{116D}\u{11AE}",
        nfkc: "\u{B1EF}",
        nfkd: "\u{1102}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B1F0}",
        nfc: "\u{B1F0}",
        nfd: "\u{1102}\u{116D}\u{11AF}",
        nfkc: "\u{B1F0}",
        nfkd: "\u{1102}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B1F1}",
        nfc: "\u{B1F1}",
        nfd: "\u{1102}\u{116D}\u{11B0}",
        nfkc: "\u{B1F1}",
        nfkd: "\u{1102}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B1F2}",
        nfc: "\u{B1F2}",
        nfd: "\u{1102}\u{116D}\u{11B1}",
        nfkc: "\u{B1F2}",
        nfkd: "\u{1102}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B1F3}",
        nfc: "\u{B1F3}",
        nfd: "\u{1102}\u{116D}\u{11B2}",
        nfkc: "\u{B1F3}",
        nfkd: "\u{1102}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B1F4}",
        nfc: "\u{B1F4}",
        nfd: "\u{1102}\u{116D}\u{11B3}",
        nfkc: "\u{B1F4}",
        nfkd: "\u{1102}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B1F5}",
        nfc: "\u{B1F5}",
        nfd: "\u{1102}\u{116D}\u{11B4}",
        nfkc: "\u{B1F5}",
        nfkd: "\u{1102}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B1F6}",
        nfc: "\u{B1F6}",
        nfd: "\u{1102}\u{116D}\u{11B5}",
        nfkc: "\u{B1F6}",
        nfkd: "\u{1102}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B1F7}",
        nfc: "\u{B1F7}",
        nfd: "\u{1102}\u{116D}\u{11B6}",
        nfkc: "\u{B1F7}",
        nfkd: "\u{1102}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B1F8}",
        nfc: "\u{B1F8}",
        nfd: "\u{1102}\u{116D}\u{11B7}",
        nfkc: "\u{B1F8}",
        nfkd: "\u{1102}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B1F9}",
        nfc: "\u{B1F9}",
        nfd: "\u{1102}\u{116D}\u{11B8}",
        nfkc: "\u{B1F9}",
        nfkd: "\u{1102}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B1FA}",
        nfc: "\u{B1FA}",
        nfd: "\u{1102}\u{116D}\u{11B9}",
        nfkc: "\u{B1FA}",
        nfkd: "\u{1102}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B1FB}",
        nfc: "\u{B1FB}",
        nfd: "\u{1102}\u{116D}\u{11BA}",
        nfkc: "\u{B1FB}",
        nfkd: "\u{1102}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B1FC}",
        nfc: "\u{B1FC}",
        nfd: "\u{1102}\u{116D}\u{11BB}",
        nfkc: "\u{B1FC}",
        nfkd: "\u{1102}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B1FD}",
        nfc: "\u{B1FD}",
        nfd: "\u{1102}\u{116D}\u{11BC}",
        nfkc: "\u{B1FD}",
        nfkd: "\u{1102}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B1FE}",
        nfc: "\u{B1FE}",
        nfd: "\u{1102}\u{116D}\u{11BD}",
        nfkc: "\u{B1FE}",
        nfkd: "\u{1102}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B1FF}",
        nfc: "\u{B1FF}",
        nfd: "\u{1102}\u{116D}\u{11BE}",
        nfkc: "\u{B1FF}",
        nfkd: "\u{1102}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B200}",
        nfc: "\u{B200}",
        nfd: "\u{1102}\u{116D}\u{11BF}",
        nfkc: "\u{B200}",
        nfkd: "\u{1102}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B201}",
        nfc: "\u{B201}",
        nfd: "\u{1102}\u{116D}\u{11C0}",
        nfkc: "\u{B201}",
        nfkd: "\u{1102}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B202}",
        nfc: "\u{B202}",
        nfd: "\u{1102}\u{116D}\u{11C1}",
        nfkc: "\u{B202}",
        nfkd: "\u{1102}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B203}",
        nfc: "\u{B203}",
        nfd: "\u{1102}\u{116D}\u{11C2}",
        nfkc: "\u{B203}",
        nfkd: "\u{1102}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B204}",
        nfc: "\u{B204}",
        nfd: "\u{1102}\u{116E}",
        nfkc: "\u{B204}",
        nfkd: "\u{1102}\u{116E}",
    },
    NormalizationTest {
        source: "\u{B205}",
        nfc: "\u{B205}",
        nfd: "\u{1102}\u{116E}\u{11A8}",
        nfkc: "\u{B205}",
        nfkd: "\u{1102}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B206}",
        nfc: "\u{B206}",
        nfd: "\u{1102}\u{116E}\u{11A9}",
        nfkc: "\u{B206}",
        nfkd: "\u{1102}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B207}",
        nfc: "\u{B207}",
        nfd: "\u{1102}\u{116E}\u{11AA}",
        nfkc: "\u{B207}",
        nfkd: "\u{1102}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B208}",
        nfc: "\u{B208}",
        nfd: "\u{1102}\u{116E}\u{11AB}",
        nfkc: "\u{B208}",
        nfkd: "\u{1102}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B209}",
        nfc: "\u{B209}",
        nfd: "\u{1102}\u{116E}\u{11AC}",
        nfkc: "\u{B209}",
        nfkd: "\u{1102}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B20A}",
        nfc: "\u{B20A}",
        nfd: "\u{1102}\u{116E}\u{11AD}",
        nfkc: "\u{B20A}",
        nfkd: "\u{1102}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B20B}",
        nfc: "\u{B20B}",
        nfd: "\u{1102}\u{116E}\u{11AE}",
        nfkc: "\u{B20B}",
        nfkd: "\u{1102}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B20C}",
        nfc: "\u{B20C}",
        nfd: "\u{1102}\u{116E}\u{11AF}",
        nfkc: "\u{B20C}",
        nfkd: "\u{1102}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B20D}",
        nfc: "\u{B20D}",
        nfd: "\u{1102}\u{116E}\u{11B0}",
        nfkc: "\u{B20D}",
        nfkd: "\u{1102}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B20E}",
        nfc: "\u{B20E}",
        nfd: "\u{1102}\u{116E}\u{11B1}",
        nfkc: "\u{B20E}",
        nfkd: "\u{1102}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B20F}",
        nfc: "\u{B20F}",
        nfd: "\u{1102}\u{116E}\u{11B2}",
        nfkc: "\u{B20F}",
        nfkd: "\u{1102}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B210}",
        nfc: "\u{B210}",
        nfd: "\u{1102}\u{116E}\u{11B3}",
        nfkc: "\u{B210}",
        nfkd: "\u{1102}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B211}",
        nfc: "\u{B211}",
        nfd: "\u{1102}\u{116E}\u{11B4}",
        nfkc: "\u{B211}",
        nfkd: "\u{1102}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B212}",
        nfc: "\u{B212}",
        nfd: "\u{1102}\u{116E}\u{11B5}",
        nfkc: "\u{B212}",
        nfkd: "\u{1102}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B213}",
        nfc: "\u{B213}",
        nfd: "\u{1102}\u{116E}\u{11B6}",
        nfkc: "\u{B213}",
        nfkd: "\u{1102}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B214}",
        nfc: "\u{B214}",
        nfd: "\u{1102}\u{116E}\u{11B7}",
        nfkc: "\u{B214}",
        nfkd: "\u{1102}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B215}",
        nfc: "\u{B215}",
        nfd: "\u{1102}\u{116E}\u{11B8}",
        nfkc: "\u{B215}",
        nfkd: "\u{1102}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B216}",
        nfc: "\u{B216}",
        nfd: "\u{1102}\u{116E}\u{11B9}",
        nfkc: "\u{B216}",
        nfkd: "\u{1102}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B217}",
        nfc: "\u{B217}",
        nfd: "\u{1102}\u{116E}\u{11BA}",
        nfkc: "\u{B217}",
        nfkd: "\u{1102}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B218}",
        nfc: "\u{B218}",
        nfd: "\u{1102}\u{116E}\u{11BB}",
        nfkc: "\u{B218}",
        nfkd: "\u{1102}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B219}",
        nfc: "\u{B219}",
        nfd: "\u{1102}\u{116E}\u{11BC}",
        nfkc: "\u{B219}",
        nfkd: "\u{1102}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B21A}",
        nfc: "\u{B21A}",
        nfd: "\u{1102}\u{116E}\u{11BD}",
        nfkc: "\u{B21A}",
        nfkd: "\u{1102}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B21B}",
        nfc: "\u{B21B}",
        nfd: "\u{1102}\u{116E}\u{11BE}",
        nfkc: "\u{B21B}",
        nfkd: "\u{1102}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B21C}",
        nfc: "\u{B21C}",
        nfd: "\u{1102}\u{116E}\u{11BF}",
        nfkc: "\u{B21C}",
        nfkd: "\u{1102}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B21D}",
        nfc: "\u{B21D}",
        nfd: "\u{1102}\u{116E}\u{11C0}",
        nfkc: "\u{B21D}",
        nfkd: "\u{1102}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B21E}",
        nfc: "\u{B21E}",
        nfd: "\u{1102}\u{116E}\u{11C1}",
        nfkc: "\u{B21E}",
        nfkd: "\u{1102}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B21F}",
        nfc: "\u{B21F}",
        nfd: "\u{1102}\u{116E}\u{11C2}",
        nfkc: "\u{B21F}",
        nfkd: "\u{1102}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B220}",
        nfc: "\u{B220}",
        nfd: "\u{1102}\u{116F}",
        nfkc: "\u{B220}",
        nfkd: "\u{1102}\u{116F}",
    },
    NormalizationTest {
        source: "\u{B221}",
        nfc: "\u{B221}",
        nfd: "\u{1102}\u{116F}\u{11A8}",
        nfkc: "\u{B221}",
        nfkd: "\u{1102}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B222}",
        nfc: "\u{B222}",
        nfd: "\u{1102}\u{116F}\u{11A9}",
        nfkc: "\u{B222}",
        nfkd: "\u{1102}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B223}",
        nfc: "\u{B223}",
        nfd: "\u{1102}\u{116F}\u{11AA}",
        nfkc: "\u{B223}",
        nfkd: "\u{1102}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B224}",
        nfc: "\u{B224}",
        nfd: "\u{1102}\u{116F}\u{11AB}",
        nfkc: "\u{B224}",
        nfkd: "\u{1102}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B225}",
        nfc: "\u{B225}",
        nfd: "\u{1102}\u{116F}\u{11AC}",
        nfkc: "\u{B225}",
        nfkd: "\u{1102}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B226}",
        nfc: "\u{B226}",
        nfd: "\u{1102}\u{116F}\u{11AD}",
        nfkc: "\u{B226}",
        nfkd: "\u{1102}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B227}",
        nfc: "\u{B227}",
        nfd: "\u{1102}\u{116F}\u{11AE}",
        nfkc: "\u{B227}",
        nfkd: "\u{1102}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B228}",
        nfc: "\u{B228}",
        nfd: "\u{1102}\u{116F}\u{11AF}",
        nfkc: "\u{B228}",
        nfkd: "\u{1102}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B229}",
        nfc: "\u{B229}",
        nfd: "\u{1102}\u{116F}\u{11B0}",
        nfkc: "\u{B229}",
        nfkd: "\u{1102}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B22A}",
        nfc: "\u{B22A}",
        nfd: "\u{1102}\u{116F}\u{11B1}",
        nfkc: "\u{B22A}",
        nfkd: "\u{1102}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B22B}",
        nfc: "\u{B22B}",
        nfd: "\u{1102}\u{116F}\u{11B2}",
        nfkc: "\u{B22B}",
        nfkd: "\u{1102}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B22C}",
        nfc: "\u{B22C}",
        nfd: "\u{1102}\u{116F}\u{11B3}",
        nfkc: "\u{B22C}",
        nfkd: "\u{1102}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B22D}",
        nfc: "\u{B22D}",
        nfd: "\u{1102}\u{116F}\u{11B4}",
        nfkc: "\u{B22D}",
        nfkd: "\u{1102}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B22E}",
        nfc: "\u{B22E}",
        nfd: "\u{1102}\u{116F}\u{11B5}",
        nfkc: "\u{B22E}",
        nfkd: "\u{1102}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B22F}",
        nfc: "\u{B22F}",
        nfd: "\u{1102}\u{116F}\u{11B6}",
        nfkc: "\u{B22F}",
        nfkd: "\u{1102}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B230}",
        nfc: "\u{B230}",
        nfd: "\u{1102}\u{116F}\u{11B7}",
        nfkc: "\u{B230}",
        nfkd: "\u{1102}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B231}",
        nfc: "\u{B231}",
        nfd: "\u{1102}\u{116F}\u{11B8}",
        nfkc: "\u{B231}",
        nfkd: "\u{1102}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B232}",
        nfc: "\u{B232}",
        nfd: "\u{1102}\u{116F}\u{11B9}",
        nfkc: "\u{B232}",
        nfkd: "\u{1102}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B233}",
        nfc: "\u{B233}",
        nfd: "\u{1102}\u{116F}\u{11BA}",
        nfkc: "\u{B233}",
        nfkd: "\u{1102}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B234}",
        nfc: "\u{B234}",
        nfd: "\u{1102}\u{116F}\u{11BB}",
        nfkc: "\u{B234}",
        nfkd: "\u{1102}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B235}",
        nfc: "\u{B235}",
        nfd: "\u{1102}\u{116F}\u{11BC}",
        nfkc: "\u{B235}",
        nfkd: "\u{1102}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B236}",
        nfc: "\u{B236}",
        nfd: "\u{1102}\u{116F}\u{11BD}",
        nfkc: "\u{B236}",
        nfkd: "\u{1102}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B237}",
        nfc: "\u{B237}",
        nfd: "\u{1102}\u{116F}\u{11BE}",
        nfkc: "\u{B237}",
        nfkd: "\u{1102}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B238}",
        nfc: "\u{B238}",
        nfd: "\u{1102}\u{116F}\u{11BF}",
        nfkc: "\u{B238}",
        nfkd: "\u{1102}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B239}",
        nfc: "\u{B239}",
        nfd: "\u{1102}\u{116F}\u{11C0}",
        nfkc: "\u{B239}",
        nfkd: "\u{1102}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B23A}",
        nfc: "\u{B23A}",
        nfd: "\u{1102}\u{116F}\u{11C1}",
        nfkc: "\u{B23A}",
        nfkd: "\u{1102}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B23B}",
        nfc: "\u{B23B}",
        nfd: "\u{1102}\u{116F}\u{11C2}",
        nfkc: "\u{B23B}",
        nfkd: "\u{1102}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B23C}",
        nfc: "\u{B23C}",
        nfd: "\u{1102}\u{1170}",
        nfkc: "\u{B23C}",
        nfkd: "\u{1102}\u{1170}",
    },
    NormalizationTest {
        source: "\u{B23D}",
        nfc: "\u{B23D}",
        nfd: "\u{1102}\u{1170}\u{11A8}",
        nfkc: "\u{B23D}",
        nfkd: "\u{1102}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B23E}",
        nfc: "\u{B23E}",
        nfd: "\u{1102}\u{1170}\u{11A9}",
        nfkc: "\u{B23E}",
        nfkd: "\u{1102}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B23F}",
        nfc: "\u{B23F}",
        nfd: "\u{1102}\u{1170}\u{11AA}",
        nfkc: "\u{B23F}",
        nfkd: "\u{1102}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B240}",
        nfc: "\u{B240}",
        nfd: "\u{1102}\u{1170}\u{11AB}",
        nfkc: "\u{B240}",
        nfkd: "\u{1102}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B241}",
        nfc: "\u{B241}",
        nfd: "\u{1102}\u{1170}\u{11AC}",
        nfkc: "\u{B241}",
        nfkd: "\u{1102}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B242}",
        nfc: "\u{B242}",
        nfd: "\u{1102}\u{1170}\u{11AD}",
        nfkc: "\u{B242}",
        nfkd: "\u{1102}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B243}",
        nfc: "\u{B243}",
        nfd: "\u{1102}\u{1170}\u{11AE}",
        nfkc: "\u{B243}",
        nfkd: "\u{1102}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B244}",
        nfc: "\u{B244}",
        nfd: "\u{1102}\u{1170}\u{11AF}",
        nfkc: "\u{B244}",
        nfkd: "\u{1102}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B245}",
        nfc: "\u{B245}",
        nfd: "\u{1102}\u{1170}\u{11B0}",
        nfkc: "\u{B245}",
        nfkd: "\u{1102}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B246}",
        nfc: "\u{B246}",
        nfd: "\u{1102}\u{1170}\u{11B1}",
        nfkc: "\u{B246}",
        nfkd: "\u{1102}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B247}",
        nfc: "\u{B247}",
        nfd: "\u{1102}\u{1170}\u{11B2}",
        nfkc: "\u{B247}",
        nfkd: "\u{1102}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B248}",
        nfc: "\u{B248}",
        nfd: "\u{1102}\u{1170}\u{11B3}",
        nfkc: "\u{B248}",
        nfkd: "\u{1102}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B249}",
        nfc: "\u{B249}",
        nfd: "\u{1102}\u{1170}\u{11B4}",
        nfkc: "\u{B249}",
        nfkd: "\u{1102}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B24A}",
        nfc: "\u{B24A}",
        nfd: "\u{1102}\u{1170}\u{11B5}",
        nfkc: "\u{B24A}",
        nfkd: "\u{1102}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B24B}",
        nfc: "\u{B24B}",
        nfd: "\u{1102}\u{1170}\u{11B6}",
        nfkc: "\u{B24B}",
        nfkd: "\u{1102}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B24C}",
        nfc: "\u{B24C}",
        nfd: "\u{1102}\u{1170}\u{11B7}",
        nfkc: "\u{B24C}",
        nfkd: "\u{1102}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B24D}",
        nfc: "\u{B24D}",
        nfd: "\u{1102}\u{1170}\u{11B8}",
        nfkc: "\u{B24D}",
        nfkd: "\u{1102}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B24E}",
        nfc: "\u{B24E}",
        nfd: "\u{1102}\u{1170}\u{11B9}",
        nfkc: "\u{B24E}",
        nfkd: "\u{1102}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B24F}",
        nfc: "\u{B24F}",
        nfd: "\u{1102}\u{1170}\u{11BA}",
        nfkc: "\u{B24F}",
        nfkd: "\u{1102}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B250}",
        nfc: "\u{B250}",
        nfd: "\u{1102}\u{1170}\u{11BB}",
        nfkc: "\u{B250}",
        nfkd: "\u{1102}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B251}",
        nfc: "\u{B251}",
        nfd: "\u{1102}\u{1170}\u{11BC}",
        nfkc: "\u{B251}",
        nfkd: "\u{1102}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B252}",
        nfc: "\u{B252}",
        nfd: "\u{1102}\u{1170}\u{11BD}",
        nfkc: "\u{B252}",
        nfkd: "\u{1102}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B253}",
        nfc: "\u{B253}",
        nfd: "\u{1102}\u{1170}\u{11BE}",
        nfkc: "\u{B253}",
        nfkd: "\u{1102}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B254}",
        nfc: "\u{B254}",
        nfd: "\u{1102}\u{1170}\u{11BF}",
        nfkc: "\u{B254}",
        nfkd: "\u{1102}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B255}",
        nfc: "\u{B255}",
        nfd: "\u{1102}\u{1170}\u{11C0}",
        nfkc: "\u{B255}",
        nfkd: "\u{1102}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B256}",
        nfc: "\u{B256}",
        nfd: "\u{1102}\u{1170}\u{11C1}",
        nfkc: "\u{B256}",
        nfkd: "\u{1102}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B257}",
        nfc: "\u{B257}",
        nfd: "\u{1102}\u{1170}\u{11C2}",
        nfkc: "\u{B257}",
        nfkd: "\u{1102}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B258}",
        nfc: "\u{B258}",
        nfd: "\u{1102}\u{1171}",
        nfkc: "\u{B258}",
        nfkd: "\u{1102}\u{1171}",
    },
    NormalizationTest {
        source: "\u{B259}",
        nfc: "\u{B259}",
        nfd: "\u{1102}\u{1171}\u{11A8}",
        nfkc: "\u{B259}",
        nfkd: "\u{1102}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B25A}",
        nfc: "\u{B25A}",
        nfd: "\u{1102}\u{1171}\u{11A9}",
        nfkc: "\u{B25A}",
        nfkd: "\u{1102}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B25B}",
        nfc: "\u{B25B}",
        nfd: "\u{1102}\u{1171}\u{11AA}",
        nfkc: "\u{B25B}",
        nfkd: "\u{1102}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B25C}",
        nfc: "\u{B25C}",
        nfd: "\u{1102}\u{1171}\u{11AB}",
        nfkc: "\u{B25C}",
        nfkd: "\u{1102}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B25D}",
        nfc: "\u{B25D}",
        nfd: "\u{1102}\u{1171}\u{11AC}",
        nfkc: "\u{B25D}",
        nfkd: "\u{1102}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B25E}",
        nfc: "\u{B25E}",
        nfd: "\u{1102}\u{1171}\u{11AD}",
        nfkc: "\u{B25E}",
        nfkd: "\u{1102}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B25F}",
        nfc: "\u{B25F}",
        nfd: "\u{1102}\u{1171}\u{11AE}",
        nfkc: "\u{B25F}",
        nfkd: "\u{1102}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B260}",
        nfc: "\u{B260}",
        nfd: "\u{1102}\u{1171}\u{11AF}",
        nfkc: "\u{B260}",
        nfkd: "\u{1102}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B261}",
        nfc: "\u{B261}",
        nfd: "\u{1102}\u{1171}\u{11B0}",
        nfkc: "\u{B261}",
        nfkd: "\u{1102}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B262}",
        nfc: "\u{B262}",
        nfd: "\u{1102}\u{1171}\u{11B1}",
        nfkc: "\u{B262}",
        nfkd: "\u{1102}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B263}",
        nfc: "\u{B263}",
        nfd: "\u{1102}\u{1171}\u{11B2}",
        nfkc: "\u{B263}",
        nfkd: "\u{1102}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B264}",
        nfc: "\u{B264}",
        nfd: "\u{1102}\u{1171}\u{11B3}",
        nfkc: "\u{B264}",
        nfkd: "\u{1102}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B265}",
        nfc: "\u{B265}",
        nfd: "\u{1102}\u{1171}\u{11B4}",
        nfkc: "\u{B265}",
        nfkd: "\u{1102}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B266}",
        nfc: "\u{B266}",
        nfd: "\u{1102}\u{1171}\u{11B5}",
        nfkc: "\u{B266}",
        nfkd: "\u{1102}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B267}",
        nfc: "\u{B267}",
        nfd: "\u{1102}\u{1171}\u{11B6}",
        nfkc: "\u{B267}",
        nfkd: "\u{1102}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B268}",
        nfc: "\u{B268}",
        nfd: "\u{1102}\u{1171}\u{11B7}",
        nfkc: "\u{B268}",
        nfkd: "\u{1102}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B269}",
        nfc: "\u{B269}",
        nfd: "\u{1102}\u{1171}\u{11B8}",
        nfkc: "\u{B269}",
        nfkd: "\u{1102}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B26A}",
        nfc: "\u{B26A}",
        nfd: "\u{1102}\u{1171}\u{11B9}",
        nfkc: "\u{B26A}",
        nfkd: "\u{1102}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B26B}",
        nfc: "\u{B26B}",
        nfd: "\u{1102}\u{1171}\u{11BA}",
        nfkc: "\u{B26B}",
        nfkd: "\u{1102}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B26C}",
        nfc: "\u{B26C}",
        nfd: "\u{1102}\u{1171}\u{11BB}",
        nfkc: "\u{B26C}",
        nfkd: "\u{1102}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B26D}",
        nfc: "\u{B26D}",
        nfd: "\u{1102}\u{1171}\u{11BC}",
        nfkc: "\u{B26D}",
        nfkd: "\u{1102}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B26E}",
        nfc: "\u{B26E}",
        nfd: "\u{1102}\u{1171}\u{11BD}",
        nfkc: "\u{B26E}",
        nfkd: "\u{1102}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B26F}",
        nfc: "\u{B26F}",
        nfd: "\u{1102}\u{1171}\u{11BE}",
        nfkc: "\u{B26F}",
        nfkd: "\u{1102}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B270}",
        nfc: "\u{B270}",
        nfd: "\u{1102}\u{1171}\u{11BF}",
        nfkc: "\u{B270}",
        nfkd: "\u{1102}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B271}",
        nfc: "\u{B271}",
        nfd: "\u{1102}\u{1171}\u{11C0}",
        nfkc: "\u{B271}",
        nfkd: "\u{1102}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B272}",
        nfc: "\u{B272}",
        nfd: "\u{1102}\u{1171}\u{11C1}",
        nfkc: "\u{B272}",
        nfkd: "\u{1102}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B273}",
        nfc: "\u{B273}",
        nfd: "\u{1102}\u{1171}\u{11C2}",
        nfkc: "\u{B273}",
        nfkd: "\u{1102}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B274}",
        nfc: "\u{B274}",
        nfd: "\u{1102}\u{1172}",
        nfkc: "\u{B274}",
        nfkd: "\u{1102}\u{1172}",
    },
    NormalizationTest {
        source: "\u{B275}",
        nfc: "\u{B275}",
        nfd: "\u{1102}\u{1172}\u{11A8}",
        nfkc: "\u{B275}",
        nfkd: "\u{1102}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B276}",
        nfc: "\u{B276}",
        nfd: "\u{1102}\u{1172}\u{11A9}",
        nfkc: "\u{B276}",
        nfkd: "\u{1102}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B277}",
        nfc: "\u{B277}",
        nfd: "\u{1102}\u{1172}\u{11AA}",
        nfkc: "\u{B277}",
        nfkd: "\u{1102}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B278}",
        nfc: "\u{B278}",
        nfd: "\u{1102}\u{1172}\u{11AB}",
        nfkc: "\u{B278}",
        nfkd: "\u{1102}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B279}",
        nfc: "\u{B279}",
        nfd: "\u{1102}\u{1172}\u{11AC}",
        nfkc: "\u{B279}",
        nfkd: "\u{1102}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B27A}",
        nfc: "\u{B27A}",
        nfd: "\u{1102}\u{1172}\u{11AD}",
        nfkc: "\u{B27A}",
        nfkd: "\u{1102}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B27B}",
        nfc: "\u{B27B}",
        nfd: "\u{1102}\u{1172}\u{11AE}",
        nfkc: "\u{B27B}",
        nfkd: "\u{1102}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B27C}",
        nfc: "\u{B27C}",
        nfd: "\u{1102}\u{1172}\u{11AF}",
        nfkc: "\u{B27C}",
        nfkd: "\u{1102}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B27D}",
        nfc: "\u{B27D}",
        nfd: "\u{1102}\u{1172}\u{11B0}",
        nfkc: "\u{B27D}",
        nfkd: "\u{1102}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B27E}",
        nfc: "\u{B27E}",
        nfd: "\u{1102}\u{1172}\u{11B1}",
        nfkc: "\u{B27E}",
        nfkd: "\u{1102}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B27F}",
        nfc: "\u{B27F}",
        nfd: "\u{1102}\u{1172}\u{11B2}",
        nfkc: "\u{B27F}",
        nfkd: "\u{1102}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B280}",
        nfc: "\u{B280}",
        nfd: "\u{1102}\u{1172}\u{11B3}",
        nfkc: "\u{B280}",
        nfkd: "\u{1102}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B281}",
        nfc: "\u{B281}",
        nfd: "\u{1102}\u{1172}\u{11B4}",
        nfkc: "\u{B281}",
        nfkd: "\u{1102}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B282}",
        nfc: "\u{B282}",
        nfd: "\u{1102}\u{1172}\u{11B5}",
        nfkc: "\u{B282}",
        nfkd: "\u{1102}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B283}",
        nfc: "\u{B283}",
        nfd: "\u{1102}\u{1172}\u{11B6}",
        nfkc: "\u{B283}",
        nfkd: "\u{1102}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B284}",
        nfc: "\u{B284}",
        nfd: "\u{1102}\u{1172}\u{11B7}",
        nfkc: "\u{B284}",
        nfkd: "\u{1102}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B285}",
        nfc: "\u{B285}",
        nfd: "\u{1102}\u{1172}\u{11B8}",
        nfkc: "\u{B285}",
        nfkd: "\u{1102}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B286}",
        nfc: "\u{B286}",
        nfd: "\u{1102}\u{1172}\u{11B9}",
        nfkc: "\u{B286}",
        nfkd: "\u{1102}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B287}",
        nfc: "\u{B287}",
        nfd: "\u{1102}\u{1172}\u{11BA}",
        nfkc: "\u{B287}",
        nfkd: "\u{1102}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B288}",
        nfc: "\u{B288}",
        nfd: "\u{1102}\u{1172}\u{11BB}",
        nfkc: "\u{B288}",
        nfkd: "\u{1102}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B289}",
        nfc: "\u{B289}",
        nfd: "\u{1102}\u{1172}\u{11BC}",
        nfkc: "\u{B289}",
        nfkd: "\u{1102}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B28A}",
        nfc: "\u{B28A}",
        nfd: "\u{1102}\u{1172}\u{11BD}",
        nfkc: "\u{B28A}",
        nfkd: "\u{1102}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B28B}",
        nfc: "\u{B28B}",
        nfd: "\u{1102}\u{1172}\u{11BE}",
        nfkc: "\u{B28B}",
        nfkd: "\u{1102}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B28C}",
        nfc: "\u{B28C}",
        nfd: "\u{1102}\u{1172}\u{11BF}",
        nfkc: "\u{B28C}",
        nfkd: "\u{1102}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B28D}",
        nfc: "\u{B28D}",
        nfd: "\u{1102}\u{1172}\u{11C0}",
        nfkc: "\u{B28D}",
        nfkd: "\u{1102}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B28E}",
        nfc: "\u{B28E}",
        nfd: "\u{1102}\u{1172}\u{11C1}",
        nfkc: "\u{B28E}",
        nfkd: "\u{1102}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B28F}",
        nfc: "\u{B28F}",
        nfd: "\u{1102}\u{1172}\u{11C2}",
        nfkc: "\u{B28F}",
        nfkd: "\u{1102}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B290}",
        nfc: "\u{B290}",
        nfd: "\u{1102}\u{1173}",
        nfkc: "\u{B290}",
        nfkd: "\u{1102}\u{1173}",
    },
    NormalizationTest {
        source: "\u{B291}",
        nfc: "\u{B291}",
        nfd: "\u{1102}\u{1173}\u{11A8}",
        nfkc: "\u{B291}",
        nfkd: "\u{1102}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B292}",
        nfc: "\u{B292}",
        nfd: "\u{1102}\u{1173}\u{11A9}",
        nfkc: "\u{B292}",
        nfkd: "\u{1102}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B293}",
        nfc: "\u{B293}",
        nfd: "\u{1102}\u{1173}\u{11AA}",
        nfkc: "\u{B293}",
        nfkd: "\u{1102}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B294}",
        nfc: "\u{B294}",
        nfd: "\u{1102}\u{1173}\u{11AB}",
        nfkc: "\u{B294}",
        nfkd: "\u{1102}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B295}",
        nfc: "\u{B295}",
        nfd: "\u{1102}\u{1173}\u{11AC}",
        nfkc: "\u{B295}",
        nfkd: "\u{1102}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B296}",
        nfc: "\u{B296}",
        nfd: "\u{1102}\u{1173}\u{11AD}",
        nfkc: "\u{B296}",
        nfkd: "\u{1102}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B297}",
        nfc: "\u{B297}",
        nfd: "\u{1102}\u{1173}\u{11AE}",
        nfkc: "\u{B297}",
        nfkd: "\u{1102}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B298}",
        nfc: "\u{B298}",
        nfd: "\u{1102}\u{1173}\u{11AF}",
        nfkc: "\u{B298}",
        nfkd: "\u{1102}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B299}",
        nfc: "\u{B299}",
        nfd: "\u{1102}\u{1173}\u{11B0}",
        nfkc: "\u{B299}",
        nfkd: "\u{1102}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B29A}",
        nfc: "\u{B29A}",
        nfd: "\u{1102}\u{1173}\u{11B1}",
        nfkc: "\u{B29A}",
        nfkd: "\u{1102}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B29B}",
        nfc: "\u{B29B}",
        nfd: "\u{1102}\u{1173}\u{11B2}",
        nfkc: "\u{B29B}",
        nfkd: "\u{1102}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B29C}",
        nfc: "\u{B29C}",
        nfd: "\u{1102}\u{1173}\u{11B3}",
        nfkc: "\u{B29C}",
        nfkd: "\u{1102}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B29D}",
        nfc: "\u{B29D}",
        nfd: "\u{1102}\u{1173}\u{11B4}",
        nfkc: "\u{B29D}",
        nfkd: "\u{1102}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B29E}",
        nfc: "\u{B29E}",
        nfd: "\u{1102}\u{1173}\u{11B5}",
        nfkc: "\u{B29E}",
        nfkd: "\u{1102}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B29F}",
        nfc: "\u{B29F}",
        nfd: "\u{1102}\u{1173}\u{11B6}",
        nfkc: "\u{B29F}",
        nfkd: "\u{1102}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B2A0}",
        nfc: "\u{B2A0}",
        nfd: "\u{1102}\u{1173}\u{11B7}",
        nfkc: "\u{B2A0}",
        nfkd: "\u{1102}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B2A1}",
        nfc: "\u{B2A1}",
        nfd: "\u{1102}\u{1173}\u{11B8}",
        nfkc: "\u{B2A1}",
        nfkd: "\u{1102}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B2A2}",
        nfc: "\u{B2A2}",
        nfd: "\u{1102}\u{1173}\u{11B9}",
        nfkc: "\u{B2A2}",
        nfkd: "\u{1102}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B2A3}",
        nfc: "\u{B2A3}",
        nfd: "\u{1102}\u{1173}\u{11BA}",
        nfkc: "\u{B2A3}",
        nfkd: "\u{1102}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B2A4}",
        nfc: "\u{B2A4}",
        nfd: "\u{1102}\u{1173}\u{11BB}",
        nfkc: "\u{B2A4}",
        nfkd: "\u{1102}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B2A5}",
        nfc: "\u{B2A5}",
        nfd: "\u{1102}\u{1173}\u{11BC}",
        nfkc: "\u{B2A5}",
        nfkd: "\u{1102}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B2A6}",
        nfc: "\u{B2A6}",
        nfd: "\u{1102}\u{1173}\u{11BD}",
        nfkc: "\u{B2A6}",
        nfkd: "\u{1102}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B2A7}",
        nfc: "\u{B2A7}",
        nfd: "\u{1102}\u{1173}\u{11BE}",
        nfkc: "\u{B2A7}",
        nfkd: "\u{1102}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B2A8}",
        nfc: "\u{B2A8}",
        nfd: "\u{1102}\u{1173}\u{11BF}",
        nfkc: "\u{B2A8}",
        nfkd: "\u{1102}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B2A9}",
        nfc: "\u{B2A9}",
        nfd: "\u{1102}\u{1173}\u{11C0}",
        nfkc: "\u{B2A9}",
        nfkd: "\u{1102}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B2AA}",
        nfc: "\u{B2AA}",
        nfd: "\u{1102}\u{1173}\u{11C1}",
        nfkc: "\u{B2AA}",
        nfkd: "\u{1102}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B2AB}",
        nfc: "\u{B2AB}",
        nfd: "\u{1102}\u{1173}\u{11C2}",
        nfkc: "\u{B2AB}",
        nfkd: "\u{1102}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B2AC}",
        nfc: "\u{B2AC}",
        nfd: "\u{1102}\u{1174}",
        nfkc: "\u{B2AC}",
        nfkd: "\u{1102}\u{1174}",
    },
    NormalizationTest {
        source: "\u{B2AD}",
        nfc: "\u{B2AD}",
        nfd: "\u{1102}\u{1174}\u{11A8}",
        nfkc: "\u{B2AD}",
        nfkd: "\u{1102}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B2AE}",
        nfc: "\u{B2AE}",
        nfd: "\u{1102}\u{1174}\u{11A9}",
        nfkc: "\u{B2AE}",
        nfkd: "\u{1102}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B2AF}",
        nfc: "\u{B2AF}",
        nfd: "\u{1102}\u{1174}\u{11AA}",
        nfkc: "\u{B2AF}",
        nfkd: "\u{1102}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B2B0}",
        nfc: "\u{B2B0}",
        nfd: "\u{1102}\u{1174}\u{11AB}",
        nfkc: "\u{B2B0}",
        nfkd: "\u{1102}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B2B1}",
        nfc: "\u{B2B1}",
        nfd: "\u{1102}\u{1174}\u{11AC}",
        nfkc: "\u{B2B1}",
        nfkd: "\u{1102}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B2B2}",
        nfc: "\u{B2B2}",
        nfd: "\u{1102}\u{1174}\u{11AD}",
        nfkc: "\u{B2B2}",
        nfkd: "\u{1102}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B2B3}",
        nfc: "\u{B2B3}",
        nfd: "\u{1102}\u{1174}\u{11AE}",
        nfkc: "\u{B2B3}",
        nfkd: "\u{1102}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B2B4}",
        nfc: "\u{B2B4}",
        nfd: "\u{1102}\u{1174}\u{11AF}",
        nfkc: "\u{B2B4}",
        nfkd: "\u{1102}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B2B5}",
        nfc: "\u{B2B5}",
        nfd: "\u{1102}\u{1174}\u{11B0}",
        nfkc: "\u{B2B5}",
        nfkd: "\u{1102}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B2B6}",
        nfc: "\u{B2B6}",
        nfd: "\u{1102}\u{1174}\u{11B1}",
        nfkc: "\u{B2B6}",
        nfkd: "\u{1102}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B2B7}",
        nfc: "\u{B2B7}",
        nfd: "\u{1102}\u{1174}\u{11B2}",
        nfkc: "\u{B2B7}",
        nfkd: "\u{1102}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B2B8}",
        nfc: "\u{B2B8}",
        nfd: "\u{1102}\u{1174}\u{11B3}",
        nfkc: "\u{B2B8}",
        nfkd: "\u{1102}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B2B9}",
        nfc: "\u{B2B9}",
        nfd: "\u{1102}\u{1174}\u{11B4}",
        nfkc: "\u{B2B9}",
        nfkd: "\u{1102}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B2BA}",
        nfc: "\u{B2BA}",
        nfd: "\u{1102}\u{1174}\u{11B5}",
        nfkc: "\u{B2BA}",
        nfkd: "\u{1102}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B2BB}",
        nfc: "\u{B2BB}",
        nfd: "\u{1102}\u{1174}\u{11B6}",
        nfkc: "\u{B2BB}",
        nfkd: "\u{1102}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B2BC}",
        nfc: "\u{B2BC}",
        nfd: "\u{1102}\u{1174}\u{11B7}",
        nfkc: "\u{B2BC}",
        nfkd: "\u{1102}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B2BD}",
        nfc: "\u{B2BD}",
        nfd: "\u{1102}\u{1174}\u{11B8}",
        nfkc: "\u{B2BD}",
        nfkd: "\u{1102}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B2BE}",
        nfc: "\u{B2BE}",
        nfd: "\u{1102}\u{1174}\u{11B9}",
        nfkc: "\u{B2BE}",
        nfkd: "\u{1102}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B2BF}",
        nfc: "\u{B2BF}",
        nfd: "\u{1102}\u{1174}\u{11BA}",
        nfkc: "\u{B2BF}",
        nfkd: "\u{1102}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B2C0}",
        nfc: "\u{B2C0}",
        nfd: "\u{1102}\u{1174}\u{11BB}",
        nfkc: "\u{B2C0}",
        nfkd: "\u{1102}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B2C1}",
        nfc: "\u{B2C1}",
        nfd: "\u{1102}\u{1174}\u{11BC}",
        nfkc: "\u{B2C1}",
        nfkd: "\u{1102}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B2C2}",
        nfc: "\u{B2C2}",
        nfd: "\u{1102}\u{1174}\u{11BD}",
        nfkc: "\u{B2C2}",
        nfkd: "\u{1102}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B2C3}",
        nfc: "\u{B2C3}",
        nfd: "\u{1102}\u{1174}\u{11BE}",
        nfkc: "\u{B2C3}",
        nfkd: "\u{1102}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B2C4}",
        nfc: "\u{B2C4}",
        nfd: "\u{1102}\u{1174}\u{11BF}",
        nfkc: "\u{B2C4}",
        nfkd: "\u{1102}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B2C5}",
        nfc: "\u{B2C5}",
        nfd: "\u{1102}\u{1174}\u{11C0}",
        nfkc: "\u{B2C5}",
        nfkd: "\u{1102}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B2C6}",
        nfc: "\u{B2C6}",
        nfd: "\u{1102}\u{1174}\u{11C1}",
        nfkc: "\u{B2C6}",
        nfkd: "\u{1102}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B2C7}",
        nfc: "\u{B2C7}",
        nfd: "\u{1102}\u{1174}\u{11C2}",
        nfkc: "\u{B2C7}",
        nfkd: "\u{1102}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B2C8}",
        nfc: "\u{B2C8}",
        nfd: "\u{1102}\u{1175}",
        nfkc: "\u{B2C8}",
        nfkd: "\u{1102}\u{1175}",
    },
    NormalizationTest {
        source: "\u{B2C9}",
        nfc: "\u{B2C9}",
        nfd: "\u{1102}\u{1175}\u{11A8}",
        nfkc: "\u{B2C9}",
        nfkd: "\u{1102}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B2CA}",
        nfc: "\u{B2CA}",
        nfd: "\u{1102}\u{1175}\u{11A9}",
        nfkc: "\u{B2CA}",
        nfkd: "\u{1102}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B2CB}",
        nfc: "\u{B2CB}",
        nfd: "\u{1102}\u{1175}\u{11AA}",
        nfkc: "\u{B2CB}",
        nfkd: "\u{1102}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B2CC}",
        nfc: "\u{B2CC}",
        nfd: "\u{1102}\u{1175}\u{11AB}",
        nfkc: "\u{B2CC}",
        nfkd: "\u{1102}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B2CD}",
        nfc: "\u{B2CD}",
        nfd: "\u{1102}\u{1175}\u{11AC}",
        nfkc: "\u{B2CD}",
        nfkd: "\u{1102}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B2CE}",
        nfc: "\u{B2CE}",
        nfd: "\u{1102}\u{1175}\u{11AD}",
        nfkc: "\u{B2CE}",
        nfkd: "\u{1102}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B2CF}",
        nfc: "\u{B2CF}",
        nfd: "\u{1102}\u{1175}\u{11AE}",
        nfkc: "\u{B2CF}",
        nfkd: "\u{1102}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B2D0}",
        nfc: "\u{B2D0}",
        nfd: "\u{1102}\u{1175}\u{11AF}",
        nfkc: "\u{B2D0}",
        nfkd: "\u{1102}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B2D1}",
        nfc: "\u{B2D1}",
        nfd: "\u{1102}\u{1175}\u{11B0}",
        nfkc: "\u{B2D1}",
        nfkd: "\u{1102}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B2D2}",
        nfc: "\u{B2D2}",
        nfd: "\u{1102}\u{1175}\u{11B1}",
        nfkc: "\u{B2D2}",
        nfkd: "\u{1102}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B2D3}",
        nfc: "\u{B2D3}",
        nfd: "\u{1102}\u{1175}\u{11B2}",
        nfkc: "\u{B2D3}",
        nfkd: "\u{1102}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B2D4}",
        nfc: "\u{B2D4}",
        nfd: "\u{1102}\u{1175}\u{11B3}",
        nfkc: "\u{B2D4}",
        nfkd: "\u{1102}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B2D5}",
        nfc: "\u{B2D5}",
        nfd: "\u{1102}\u{1175}\u{11B4}",
        nfkc: "\u{B2D5}",
        nfkd: "\u{1102}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B2D6}",
        nfc: "\u{B2D6}",
        nfd: "\u{1102}\u{1175}\u{11B5}",
        nfkc: "\u{B2D6}",
        nfkd: "\u{1102}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B2D7}",
        nfc: "\u{B2D7}",
        nfd: "\u{1102}\u{1175}\u{11B6}",
        nfkc: "\u{B2D7}",
        nfkd: "\u{1102}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B2D8}",
        nfc: "\u{B2D8}",
        nfd: "\u{1102}\u{1175}\u{11B7}",
        nfkc: "\u{B2D8}",
        nfkd: "\u{1102}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B2D9}",
        nfc: "\u{B2D9}",
        nfd: "\u{1102}\u{1175}\u{11B8}",
        nfkc: "\u{B2D9}",
        nfkd: "\u{1102}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B2DA}",
        nfc: "\u{B2DA}",
        nfd: "\u{1102}\u{1175}\u{11B9}",
        nfkc: "\u{B2DA}",
        nfkd: "\u{1102}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B2DB}",
        nfc: "\u{B2DB}",
        nfd: "\u{1102}\u{1175}\u{11BA}",
        nfkc: "\u{B2DB}",
        nfkd: "\u{1102}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B2DC}",
        nfc: "\u{B2DC}",
        nfd: "\u{1102}\u{1175}\u{11BB}",
        nfkc: "\u{B2DC}",
        nfkd: "\u{1102}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B2DD}",
        nfc: "\u{B2DD}",
        nfd: "\u{1102}\u{1175}\u{11BC}",
        nfkc: "\u{B2DD}",
        nfkd: "\u{1102}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B2DE}",
        nfc: "\u{B2DE}",
        nfd: "\u{1102}\u{1175}\u{11BD}",
        nfkc: "\u{B2DE}",
        nfkd: "\u{1102}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B2DF}",
        nfc: "\u{B2DF}",
        nfd: "\u{1102}\u{1175}\u{11BE}",
        nfkc: "\u{B2DF}",
        nfkd: "\u{1102}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B2E0}",
        nfc: "\u{B2E0}",
        nfd: "\u{1102}\u{1175}\u{11BF}",
        nfkc: "\u{B2E0}",
        nfkd: "\u{1102}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B2E1}",
        nfc: "\u{B2E1}",
        nfd: "\u{1102}\u{1175}\u{11C0}",
        nfkc: "\u{B2E1}",
        nfkd: "\u{1102}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B2E2}",
        nfc: "\u{B2E2}",
        nfd: "\u{1102}\u{1175}\u{11C1}",
        nfkc: "\u{B2E2}",
        nfkd: "\u{1102}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B2E3}",
        nfc: "\u{B2E3}",
        nfd: "\u{1102}\u{1175}\u{11C2}",
        nfkc: "\u{B2E3}",
        nfkd: "\u{1102}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B2E4}",
        nfc: "\u{B2E4}",
        nfd: "\u{1103}\u{1161}",
        nfkc: "\u{B2E4}",
        nfkd: "\u{1103}\u{1161}",
    },
    NormalizationTest {
        source: "\u{B2E5}",
        nfc: "\u{B2E5}",
        nfd: "\u{1103}\u{1161}\u{11A8}",
        nfkc: "\u{B2E5}",
        nfkd: "\u{1103}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B2E6}",
        nfc: "\u{B2E6}",
        nfd: "\u{1103}\u{1161}\u{11A9}",
        nfkc: "\u{B2E6}",
        nfkd: "\u{1103}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B2E7}",
        nfc: "\u{B2E7}",
        nfd: "\u{1103}\u{1161}\u{11AA}",
        nfkc: "\u{B2E7}",
        nfkd: "\u{1103}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B2E8}",
        nfc: "\u{B2E8}",
        nfd: "\u{1103}\u{1161}\u{11AB}",
        nfkc: "\u{B2E8}",
        nfkd: "\u{1103}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B2E9}",
        nfc: "\u{B2E9}",
        nfd: "\u{1103}\u{1161}\u{11AC}",
        nfkc: "\u{B2E9}",
        nfkd: "\u{1103}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B2EA}",
        nfc: "\u{B2EA}",
        nfd: "\u{1103}\u{1161}\u{11AD}",
        nfkc: "\u{B2EA}",
        nfkd: "\u{1103}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B2EB}",
        nfc: "\u{B2EB}",
        nfd: "\u{1103}\u{1161}\u{11AE}",
        nfkc: "\u{B2EB}",
        nfkd: "\u{1103}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B2EC}",
        nfc: "\u{B2EC}",
        nfd: "\u{1103}\u{1161}\u{11AF}",
        nfkc: "\u{B2EC}",
        nfkd: "\u{1103}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B2ED}",
        nfc: "\u{B2ED}",
        nfd: "\u{1103}\u{1161}\u{11B0}",
        nfkc: "\u{B2ED}",
        nfkd: "\u{1103}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B2EE}",
        nfc: "\u{B2EE}",
        nfd: "\u{1103}\u{1161}\u{11B1}",
        nfkc: "\u{B2EE}",
        nfkd: "\u{1103}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B2EF}",
        nfc: "\u{B2EF}",
        nfd: "\u{1103}\u{1161}\u{11B2}",
        nfkc: "\u{B2EF}",
        nfkd: "\u{1103}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B2F0}",
        nfc: "\u{B2F0}",
        nfd: "\u{1103}\u{1161}\u{11B3}",
        nfkc: "\u{B2F0}",
        nfkd: "\u{1103}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B2F1}",
        nfc: "\u{B2F1}",
        nfd: "\u{1103}\u{1161}\u{11B4}",
        nfkc: "\u{B2F1}",
        nfkd: "\u{1103}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B2F2}",
        nfc: "\u{B2F2}",
        nfd: "\u{1103}\u{1161}\u{11B5}",
        nfkc: "\u{B2F2}",
        nfkd: "\u{1103}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B2F3}",
        nfc: "\u{B2F3}",
        nfd: "\u{1103}\u{1161}\u{11B6}",
        nfkc: "\u{B2F3}",
        nfkd: "\u{1103}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B2F4}",
        nfc: "\u{B2F4}",
        nfd: "\u{1103}\u{1161}\u{11B7}",
        nfkc: "\u{B2F4}",
        nfkd: "\u{1103}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B2F5}",
        nfc: "\u{B2F5}",
        nfd: "\u{1103}\u{1161}\u{11B8}",
        nfkc: "\u{B2F5}",
        nfkd: "\u{1103}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B2F6}",
        nfc: "\u{B2F6}",
        nfd: "\u{1103}\u{1161}\u{11B9}",
        nfkc: "\u{B2F6}",
        nfkd: "\u{1103}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B2F7}",
        nfc: "\u{B2F7}",
        nfd: "\u{1103}\u{1161}\u{11BA}",
        nfkc: "\u{B2F7}",
        nfkd: "\u{1103}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B2F8}",
        nfc: "\u{B2F8}",
        nfd: "\u{1103}\u{1161}\u{11BB}",
        nfkc: "\u{B2F8}",
        nfkd: "\u{1103}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B2F9}",
        nfc: "\u{B2F9}",
        nfd: "\u{1103}\u{1161}\u{11BC}",
        nfkc: "\u{B2F9}",
        nfkd: "\u{1103}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B2FA}",
        nfc: "\u{B2FA}",
        nfd: "\u{1103}\u{1161}\u{11BD}",
        nfkc: "\u{B2FA}",
        nfkd: "\u{1103}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B2FB}",
        nfc: "\u{B2FB}",
        nfd: "\u{1103}\u{1161}\u{11BE}",
        nfkc: "\u{B2FB}",
        nfkd: "\u{1103}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B2FC}",
        nfc: "\u{B2FC}",
        nfd: "\u{1103}\u{1161}\u{11BF}",
        nfkc: "\u{B2FC}",
        nfkd: "\u{1103}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B2FD}",
        nfc: "\u{B2FD}",
        nfd: "\u{1103}\u{1161}\u{11C0}",
        nfkc: "\u{B2FD}",
        nfkd: "\u{1103}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B2FE}",
        nfc: "\u{B2FE}",
        nfd: "\u{1103}\u{1161}\u{11C1}",
        nfkc: "\u{B2FE}",
        nfkd: "\u{1103}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B2FF}",
        nfc: "\u{B2FF}",
        nfd: "\u{1103}\u{1161}\u{11C2}",
        nfkc: "\u{B2FF}",
        nfkd: "\u{1103}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B300}",
        nfc: "\u{B300}",
        nfd: "\u{1103}\u{1162}",
        nfkc: "\u{B300}",
        nfkd: "\u{1103}\u{1162}",
    },
    NormalizationTest {
        source: "\u{B301}",
        nfc: "\u{B301}",
        nfd: "\u{1103}\u{1162}\u{11A8}",
        nfkc: "\u{B301}",
        nfkd: "\u{1103}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B302}",
        nfc: "\u{B302}",
        nfd: "\u{1103}\u{1162}\u{11A9}",
        nfkc: "\u{B302}",
        nfkd: "\u{1103}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B303}",
        nfc: "\u{B303}",
        nfd: "\u{1103}\u{1162}\u{11AA}",
        nfkc: "\u{B303}",
        nfkd: "\u{1103}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B304}",
        nfc: "\u{B304}",
        nfd: "\u{1103}\u{1162}\u{11AB}",
        nfkc: "\u{B304}",
        nfkd: "\u{1103}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B305}",
        nfc: "\u{B305}",
        nfd: "\u{1103}\u{1162}\u{11AC}",
        nfkc: "\u{B305}",
        nfkd: "\u{1103}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B306}",
        nfc: "\u{B306}",
        nfd: "\u{1103}\u{1162}\u{11AD}",
        nfkc: "\u{B306}",
        nfkd: "\u{1103}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B307}",
        nfc: "\u{B307}",
        nfd: "\u{1103}\u{1162}\u{11AE}",
        nfkc: "\u{B307}",
        nfkd: "\u{1103}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B308}",
        nfc: "\u{B308}",
        nfd: "\u{1103}\u{1162}\u{11AF}",
        nfkc: "\u{B308}",
        nfkd: "\u{1103}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B309}",
        nfc: "\u{B309}",
        nfd: "\u{1103}\u{1162}\u{11B0}",
        nfkc: "\u{B309}",
        nfkd: "\u{1103}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B30A}",
        nfc: "\u{B30A}",
        nfd: "\u{1103}\u{1162}\u{11B1}",
        nfkc: "\u{B30A}",
        nfkd: "\u{1103}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B30B}",
        nfc: "\u{B30B}",
        nfd: "\u{1103}\u{1162}\u{11B2}",
        nfkc: "\u{B30B}",
        nfkd: "\u{1103}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B30C}",
        nfc: "\u{B30C}",
        nfd: "\u{1103}\u{1162}\u{11B3}",
        nfkc: "\u{B30C}",
        nfkd: "\u{1103}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B30D}",
        nfc: "\u{B30D}",
        nfd: "\u{1103}\u{1162}\u{11B4}",
        nfkc: "\u{B30D}",
        nfkd: "\u{1103}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B30E}",
        nfc: "\u{B30E}",
        nfd: "\u{1103}\u{1162}\u{11B5}",
        nfkc: "\u{B30E}",
        nfkd: "\u{1103}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B30F}",
        nfc: "\u{B30F}",
        nfd: "\u{1103}\u{1162}\u{11B6}",
        nfkc: "\u{B30F}",
        nfkd: "\u{1103}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B310}",
        nfc: "\u{B310}",
        nfd: "\u{1103}\u{1162}\u{11B7}",
        nfkc: "\u{B310}",
        nfkd: "\u{1103}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B311}",
        nfc: "\u{B311}",
        nfd: "\u{1103}\u{1162}\u{11B8}",
        nfkc: "\u{B311}",
        nfkd: "\u{1103}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B312}",
        nfc: "\u{B312}",
        nfd: "\u{1103}\u{1162}\u{11B9}",
        nfkc: "\u{B312}",
        nfkd: "\u{1103}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B313}",
        nfc: "\u{B313}",
        nfd: "\u{1103}\u{1162}\u{11BA}",
        nfkc: "\u{B313}",
        nfkd: "\u{1103}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B314}",
        nfc: "\u{B314}",
        nfd: "\u{1103}\u{1162}\u{11BB}",
        nfkc: "\u{B314}",
        nfkd: "\u{1103}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B315}",
        nfc: "\u{B315}",
        nfd: "\u{1103}\u{1162}\u{11BC}",
        nfkc: "\u{B315}",
        nfkd: "\u{1103}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B316}",
        nfc: "\u{B316}",
        nfd: "\u{1103}\u{1162}\u{11BD}",
        nfkc: "\u{B316}",
        nfkd: "\u{1103}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B317}",
        nfc: "\u{B317}",
        nfd: "\u{1103}\u{1162}\u{11BE}",
        nfkc: "\u{B317}",
        nfkd: "\u{1103}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B318}",
        nfc: "\u{B318}",
        nfd: "\u{1103}\u{1162}\u{11BF}",
        nfkc: "\u{B318}",
        nfkd: "\u{1103}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B319}",
        nfc: "\u{B319}",
        nfd: "\u{1103}\u{1162}\u{11C0}",
        nfkc: "\u{B319}",
        nfkd: "\u{1103}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B31A}",
        nfc: "\u{B31A}",
        nfd: "\u{1103}\u{1162}\u{11C1}",
        nfkc: "\u{B31A}",
        nfkd: "\u{1103}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B31B}",
        nfc: "\u{B31B}",
        nfd: "\u{1103}\u{1162}\u{11C2}",
        nfkc: "\u{B31B}",
        nfkd: "\u{1103}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B31C}",
        nfc: "\u{B31C}",
        nfd: "\u{1103}\u{1163}",
        nfkc: "\u{B31C}",
        nfkd: "\u{1103}\u{1163}",
    },
    NormalizationTest {
        source: "\u{B31D}",
        nfc: "\u{B31D}",
        nfd: "\u{1103}\u{1163}\u{11A8}",
        nfkc: "\u{B31D}",
        nfkd: "\u{1103}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B31E}",
        nfc: "\u{B31E}",
        nfd: "\u{1103}\u{1163}\u{11A9}",
        nfkc: "\u{B31E}",
        nfkd: "\u{1103}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B31F}",
        nfc: "\u{B31F}",
        nfd: "\u{1103}\u{1163}\u{11AA}",
        nfkc: "\u{B31F}",
        nfkd: "\u{1103}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B320}",
        nfc: "\u{B320}",
        nfd: "\u{1103}\u{1163}\u{11AB}",
        nfkc: "\u{B320}",
        nfkd: "\u{1103}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B321}",
        nfc: "\u{B321}",
        nfd: "\u{1103}\u{1163}\u{11AC}",
        nfkc: "\u{B321}",
        nfkd: "\u{1103}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B322}",
        nfc: "\u{B322}",
        nfd: "\u{1103}\u{1163}\u{11AD}",
        nfkc: "\u{B322}",
        nfkd: "\u{1103}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B323}",
        nfc: "\u{B323}",
        nfd: "\u{1103}\u{1163}\u{11AE}",
        nfkc: "\u{B323}",
        nfkd: "\u{1103}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B324}",
        nfc: "\u{B324}",
        nfd: "\u{1103}\u{1163}\u{11AF}",
        nfkc: "\u{B324}",
        nfkd: "\u{1103}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B325}",
        nfc: "\u{B325}",
        nfd: "\u{1103}\u{1163}\u{11B0}",
        nfkc: "\u{B325}",
        nfkd: "\u{1103}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B326}",
        nfc: "\u{B326}",
        nfd: "\u{1103}\u{1163}\u{11B1}",
        nfkc: "\u{B326}",
        nfkd: "\u{1103}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B327}",
        nfc: "\u{B327}",
        nfd: "\u{1103}\u{1163}\u{11B2}",
        nfkc: "\u{B327}",
        nfkd: "\u{1103}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B328}",
        nfc: "\u{B328}",
        nfd: "\u{1103}\u{1163}\u{11B3}",
        nfkc: "\u{B328}",
        nfkd: "\u{1103}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B329}",
        nfc: "\u{B329}",
        nfd: "\u{1103}\u{1163}\u{11B4}",
        nfkc: "\u{B329}",
        nfkd: "\u{1103}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B32A}",
        nfc: "\u{B32A}",
        nfd: "\u{1103}\u{1163}\u{11B5}",
        nfkc: "\u{B32A}",
        nfkd: "\u{1103}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B32B}",
        nfc: "\u{B32B}",
        nfd: "\u{1103}\u{1163}\u{11B6}",
        nfkc: "\u{B32B}",
        nfkd: "\u{1103}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B32C}",
        nfc: "\u{B32C}",
        nfd: "\u{1103}\u{1163}\u{11B7}",
        nfkc: "\u{B32C}",
        nfkd: "\u{1103}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B32D}",
        nfc: "\u{B32D}",
        nfd: "\u{1103}\u{1163}\u{11B8}",
        nfkc: "\u{B32D}",
        nfkd: "\u{1103}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B32E}",
        nfc: "\u{B32E}",
        nfd: "\u{1103}\u{1163}\u{11B9}",
        nfkc: "\u{B32E}",
        nfkd: "\u{1103}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B32F}",
        nfc: "\u{B32F}",
        nfd: "\u{1103}\u{1163}\u{11BA}",
        nfkc: "\u{B32F}",
        nfkd: "\u{1103}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B330}",
        nfc: "\u{B330}",
        nfd: "\u{1103}\u{1163}\u{11BB}",
        nfkc: "\u{B330}",
        nfkd: "\u{1103}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B331}",
        nfc: "\u{B331}",
        nfd: "\u{1103}\u{1163}\u{11BC}",
        nfkc: "\u{B331}",
        nfkd: "\u{1103}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B332}",
        nfc: "\u{B332}",
        nfd: "\u{1103}\u{1163}\u{11BD}",
        nfkc: "\u{B332}",
        nfkd: "\u{1103}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B333}",
        nfc: "\u{B333}",
        nfd: "\u{1103}\u{1163}\u{11BE}",
        nfkc: "\u{B333}",
        nfkd: "\u{1103}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B334}",
        nfc: "\u{B334}",
        nfd: "\u{1103}\u{1163}\u{11BF}",
        nfkc: "\u{B334}",
        nfkd: "\u{1103}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B335}",
        nfc: "\u{B335}",
        nfd: "\u{1103}\u{1163}\u{11C0}",
        nfkc: "\u{B335}",
        nfkd: "\u{1103}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B336}",
        nfc: "\u{B336}",
        nfd: "\u{1103}\u{1163}\u{11C1}",
        nfkc: "\u{B336}",
        nfkd: "\u{1103}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B337}",
        nfc: "\u{B337}",
        nfd: "\u{1103}\u{1163}\u{11C2}",
        nfkc: "\u{B337}",
        nfkd: "\u{1103}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B338}",
        nfc: "\u{B338}",
        nfd: "\u{1103}\u{1164}",
        nfkc: "\u{B338}",
        nfkd: "\u{1103}\u{1164}",
    },
    NormalizationTest {
        source: "\u{B339}",
        nfc: "\u{B339}",
        nfd: "\u{1103}\u{1164}\u{11A8}",
        nfkc: "\u{B339}",
        nfkd: "\u{1103}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B33A}",
        nfc: "\u{B33A}",
        nfd: "\u{1103}\u{1164}\u{11A9}",
        nfkc: "\u{B33A}",
        nfkd: "\u{1103}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B33B}",
        nfc: "\u{B33B}",
        nfd: "\u{1103}\u{1164}\u{11AA}",
        nfkc: "\u{B33B}",
        nfkd: "\u{1103}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B33C}",
        nfc: "\u{B33C}",
        nfd: "\u{1103}\u{1164}\u{11AB}",
        nfkc: "\u{B33C}",
        nfkd: "\u{1103}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B33D}",
        nfc: "\u{B33D}",
        nfd: "\u{1103}\u{1164}\u{11AC}",
        nfkc: "\u{B33D}",
        nfkd: "\u{1103}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B33E}",
        nfc: "\u{B33E}",
        nfd: "\u{1103}\u{1164}\u{11AD}",
        nfkc: "\u{B33E}",
        nfkd: "\u{1103}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B33F}",
        nfc: "\u{B33F}",
        nfd: "\u{1103}\u{1164}\u{11AE}",
        nfkc: "\u{B33F}",
        nfkd: "\u{1103}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B340}",
        nfc: "\u{B340}",
        nfd: "\u{1103}\u{1164}\u{11AF}",
        nfkc: "\u{B340}",
        nfkd: "\u{1103}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B341}",
        nfc: "\u{B341}",
        nfd: "\u{1103}\u{1164}\u{11B0}",
        nfkc: "\u{B341}",
        nfkd: "\u{1103}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B342}",
        nfc: "\u{B342}",
        nfd: "\u{1103}\u{1164}\u{11B1}",
        nfkc: "\u{B342}",
        nfkd: "\u{1103}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B343}",
        nfc: "\u{B343}",
        nfd: "\u{1103}\u{1164}\u{11B2}",
        nfkc: "\u{B343}",
        nfkd: "\u{1103}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B344}",
        nfc: "\u{B344}",
        nfd: "\u{1103}\u{1164}\u{11B3}",
        nfkc: "\u{B344}",
        nfkd: "\u{1103}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B345}",
        nfc: "\u{B345}",
        nfd: "\u{1103}\u{1164}\u{11B4}",
        nfkc: "\u{B345}",
        nfkd: "\u{1103}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B346}",
        nfc: "\u{B346}",
        nfd: "\u{1103}\u{1164}\u{11B5}",
        nfkc: "\u{B346}",
        nfkd: "\u{1103}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B347}",
        nfc: "\u{B347}",
        nfd: "\u{1103}\u{1164}\u{11B6}",
        nfkc: "\u{B347}",
        nfkd: "\u{1103}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B348}",
        nfc: "\u{B348}",
        nfd: "\u{1103}\u{1164}\u{11B7}",
        nfkc: "\u{B348}",
        nfkd: "\u{1103}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B349}",
        nfc: "\u{B349}",
        nfd: "\u{1103}\u{1164}\u{11B8}",
        nfkc: "\u{B349}",
        nfkd: "\u{1103}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B34A}",
        nfc: "\u{B34A}",
        nfd: "\u{1103}\u{1164}\u{11B9}",
        nfkc: "\u{B34A}",
        nfkd: "\u{1103}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B34B}",
        nfc: "\u{B34B}",
        nfd: "\u{1103}\u{1164}\u{11BA}",
        nfkc: "\u{B34B}",
        nfkd: "\u{1103}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B34C}",
        nfc: "\u{B34C}",
        nfd: "\u{1103}\u{1164}\u{11BB}",
        nfkc: "\u{B34C}",
        nfkd: "\u{1103}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B34D}",
        nfc: "\u{B34D}",
        nfd: "\u{1103}\u{1164}\u{11BC}",
        nfkc: "\u{B34D}",
        nfkd: "\u{1103}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B34E}",
        nfc: "\u{B34E}",
        nfd: "\u{1103}\u{1164}\u{11BD}",
        nfkc: "\u{B34E}",
        nfkd: "\u{1103}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B34F}",
        nfc: "\u{B34F}",
        nfd: "\u{1103}\u{1164}\u{11BE}",
        nfkc: "\u{B34F}",
        nfkd: "\u{1103}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B350}",
        nfc: "\u{B350}",
        nfd: "\u{1103}\u{1164}\u{11BF}",
        nfkc: "\u{B350}",
        nfkd: "\u{1103}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B351}",
        nfc: "\u{B351}",
        nfd: "\u{1103}\u{1164}\u{11C0}",
        nfkc: "\u{B351}",
        nfkd: "\u{1103}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B352}",
        nfc: "\u{B352}",
        nfd: "\u{1103}\u{1164}\u{11C1}",
        nfkc: "\u{B352}",
        nfkd: "\u{1103}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B353}",
        nfc: "\u{B353}",
        nfd: "\u{1103}\u{1164}\u{11C2}",
        nfkc: "\u{B353}",
        nfkd: "\u{1103}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B354}",
        nfc: "\u{B354}",
        nfd: "\u{1103}\u{1165}",
        nfkc: "\u{B354}",
        nfkd: "\u{1103}\u{1165}",
    },
    NormalizationTest {
        source: "\u{B355}",
        nfc: "\u{B355}",
        nfd: "\u{1103}\u{1165}\u{11A8}",
        nfkc: "\u{B355}",
        nfkd: "\u{1103}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B356}",
        nfc: "\u{B356}",
        nfd: "\u{1103}\u{1165}\u{11A9}",
        nfkc: "\u{B356}",
        nfkd: "\u{1103}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B357}",
        nfc: "\u{B357}",
        nfd: "\u{1103}\u{1165}\u{11AA}",
        nfkc: "\u{B357}",
        nfkd: "\u{1103}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B358}",
        nfc: "\u{B358}",
        nfd: "\u{1103}\u{1165}\u{11AB}",
        nfkc: "\u{B358}",
        nfkd: "\u{1103}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B359}",
        nfc: "\u{B359}",
        nfd: "\u{1103}\u{1165}\u{11AC}",
        nfkc: "\u{B359}",
        nfkd: "\u{1103}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B35A}",
        nfc: "\u{B35A}",
        nfd: "\u{1103}\u{1165}\u{11AD}",
        nfkc: "\u{B35A}",
        nfkd: "\u{1103}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B35B}",
        nfc: "\u{B35B}",
        nfd: "\u{1103}\u{1165}\u{11AE}",
        nfkc: "\u{B35B}",
        nfkd: "\u{1103}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B35C}",
        nfc: "\u{B35C}",
        nfd: "\u{1103}\u{1165}\u{11AF}",
        nfkc: "\u{B35C}",
        nfkd: "\u{1103}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B35D}",
        nfc: "\u{B35D}",
        nfd: "\u{1103}\u{1165}\u{11B0}",
        nfkc: "\u{B35D}",
        nfkd: "\u{1103}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B35E}",
        nfc: "\u{B35E}",
        nfd: "\u{1103}\u{1165}\u{11B1}",
        nfkc: "\u{B35E}",
        nfkd: "\u{1103}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B35F}",
        nfc: "\u{B35F}",
        nfd: "\u{1103}\u{1165}\u{11B2}",
        nfkc: "\u{B35F}",
        nfkd: "\u{1103}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B360}",
        nfc: "\u{B360}",
        nfd: "\u{1103}\u{1165}\u{11B3}",
        nfkc: "\u{B360}",
        nfkd: "\u{1103}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B361}",
        nfc: "\u{B361}",
        nfd: "\u{1103}\u{1165}\u{11B4}",
        nfkc: "\u{B361}",
        nfkd: "\u{1103}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B362}",
        nfc: "\u{B362}",
        nfd: "\u{1103}\u{1165}\u{11B5}",
        nfkc: "\u{B362}",
        nfkd: "\u{1103}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B363}",
        nfc: "\u{B363}",
        nfd: "\u{1103}\u{1165}\u{11B6}",
        nfkc: "\u{B363}",
        nfkd: "\u{1103}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B364}",
        nfc: "\u{B364}",
        nfd: "\u{1103}\u{1165}\u{11B7}",
        nfkc: "\u{B364}",
        nfkd: "\u{1103}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B365}",
        nfc: "\u{B365}",
        nfd: "\u{1103}\u{1165}\u{11B8}",
        nfkc: "\u{B365}",
        nfkd: "\u{1103}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B366}",
        nfc: "\u{B366}",
        nfd: "\u{1103}\u{1165}\u{11B9}",
        nfkc: "\u{B366}",
        nfkd: "\u{1103}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B367}",
        nfc: "\u{B367}",
        nfd: "\u{1103}\u{1165}\u{11BA}",
        nfkc: "\u{B367}",
        nfkd: "\u{1103}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B368}",
        nfc: "\u{B368}",
        nfd: "\u{1103}\u{1165}\u{11BB}",
        nfkc: "\u{B368}",
        nfkd: "\u{1103}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B369}",
        nfc: "\u{B369}",
        nfd: "\u{1103}\u{1165}\u{11BC}",
        nfkc: "\u{B369}",
        nfkd: "\u{1103}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B36A}",
        nfc: "\u{B36A}",
        nfd: "\u{1103}\u{1165}\u{11BD}",
        nfkc: "\u{B36A}",
        nfkd: "\u{1103}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B36B}",
        nfc: "\u{B36B}",
        nfd: "\u{1103}\u{1165}\u{11BE}",
        nfkc: "\u{B36B}",
        nfkd: "\u{1103}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B36C}",
        nfc: "\u{B36C}",
        nfd: "\u{1103}\u{1165}\u{11BF}",
        nfkc: "\u{B36C}",
        nfkd: "\u{1103}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B36D}",
        nfc: "\u{B36D}",
        nfd: "\u{1103}\u{1165}\u{11C0}",
        nfkc: "\u{B36D}",
        nfkd: "\u{1103}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B36E}",
        nfc: "\u{B36E}",
        nfd: "\u{1103}\u{1165}\u{11C1}",
        nfkc: "\u{B36E}",
        nfkd: "\u{1103}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B36F}",
        nfc: "\u{B36F}",
        nfd: "\u{1103}\u{1165}\u{11C2}",
        nfkc: "\u{B36F}",
        nfkd: "\u{1103}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B370}",
        nfc: "\u{B370}",
        nfd: "\u{1103}\u{1166}",
        nfkc: "\u{B370}",
        nfkd: "\u{1103}\u{1166}",
    },
    NormalizationTest {
        source: "\u{B371}",
        nfc: "\u{B371}",
        nfd: "\u{1103}\u{1166}\u{11A8}",
        nfkc: "\u{B371}",
        nfkd: "\u{1103}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B372}",
        nfc: "\u{B372}",
        nfd: "\u{1103}\u{1166}\u{11A9}",
        nfkc: "\u{B372}",
        nfkd: "\u{1103}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B373}",
        nfc: "\u{B373}",
        nfd: "\u{1103}\u{1166}\u{11AA}",
        nfkc: "\u{B373}",
        nfkd: "\u{1103}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B374}",
        nfc: "\u{B374}",
        nfd: "\u{1103}\u{1166}\u{11AB}",
        nfkc: "\u{B374}",
        nfkd: "\u{1103}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B375}",
        nfc: "\u{B375}",
        nfd: "\u{1103}\u{1166}\u{11AC}",
        nfkc: "\u{B375}",
        nfkd: "\u{1103}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B376}",
        nfc: "\u{B376}",
        nfd: "\u{1103}\u{1166}\u{11AD}",
        nfkc: "\u{B376}",
        nfkd: "\u{1103}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B377}",
        nfc: "\u{B377}",
        nfd: "\u{1103}\u{1166}\u{11AE}",
        nfkc: "\u{B377}",
        nfkd: "\u{1103}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B378}",
        nfc: "\u{B378}",
        nfd: "\u{1103}\u{1166}\u{11AF}",
        nfkc: "\u{B378}",
        nfkd: "\u{1103}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B379}",
        nfc: "\u{B379}",
        nfd: "\u{1103}\u{1166}\u{11B0}",
        nfkc: "\u{B379}",
        nfkd: "\u{1103}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B37A}",
        nfc: "\u{B37A}",
        nfd: "\u{1103}\u{1166}\u{11B1}",
        nfkc: "\u{B37A}",
        nfkd: "\u{1103}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B37B}",
        nfc: "\u{B37B}",
        nfd: "\u{1103}\u{1166}\u{11B2}",
        nfkc: "\u{B37B}",
        nfkd: "\u{1103}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B37C}",
        nfc: "\u{B37C}",
        nfd: "\u{1103}\u{1166}\u{11B3}",
        nfkc: "\u{B37C}",
        nfkd: "\u{1103}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B37D}",
        nfc: "\u{B37D}",
        nfd: "\u{1103}\u{1166}\u{11B4}",
        nfkc: "\u{B37D}",
        nfkd: "\u{1103}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B37E}",
        nfc: "\u{B37E}",
        nfd: "\u{1103}\u{1166}\u{11B5}",
        nfkc: "\u{B37E}",
        nfkd: "\u{1103}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B37F}",
        nfc: "\u{B37F}",
        nfd: "\u{1103}\u{1166}\u{11B6}",
        nfkc: "\u{B37F}",
        nfkd: "\u{1103}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B380}",
        nfc: "\u{B380}",
        nfd: "\u{1103}\u{1166}\u{11B7}",
        nfkc: "\u{B380}",
        nfkd: "\u{1103}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B381}",
        nfc: "\u{B381}",
        nfd: "\u{1103}\u{1166}\u{11B8}",
        nfkc: "\u{B381}",
        nfkd: "\u{1103}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B382}",
        nfc: "\u{B382}",
        nfd: "\u{1103}\u{1166}\u{11B9}",
        nfkc: "\u{B382}",
        nfkd: "\u{1103}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B383}",
        nfc: "\u{B383}",
        nfd: "\u{1103}\u{1166}\u{11BA}",
        nfkc: "\u{B383}",
        nfkd: "\u{1103}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B384}",
        nfc: "\u{B384}",
        nfd: "\u{1103}\u{1166}\u{11BB}",
        nfkc: "\u{B384}",
        nfkd: "\u{1103}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B385}",
        nfc: "\u{B385}",
        nfd: "\u{1103}\u{1166}\u{11BC}",
        nfkc: "\u{B385}",
        nfkd: "\u{1103}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B386}",
        nfc: "\u{B386}",
        nfd: "\u{1103}\u{1166}\u{11BD}",
        nfkc: "\u{B386}",
        nfkd: "\u{1103}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B387}",
        nfc: "\u{B387}",
        nfd: "\u{1103}\u{1166}\u{11BE}",
        nfkc: "\u{B387}",
        nfkd: "\u{1103}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B388}",
        nfc: "\u{B388}",
        nfd: "\u{1103}\u{1166}\u{11BF}",
        nfkc: "\u{B388}",
        nfkd: "\u{1103}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B389}",
        nfc: "\u{B389}",
        nfd: "\u{1103}\u{1166}\u{11C0}",
        nfkc: "\u{B389}",
        nfkd: "\u{1103}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B38A}",
        nfc: "\u{B38A}",
        nfd: "\u{1103}\u{1166}\u{11C1}",
        nfkc: "\u{B38A}",
        nfkd: "\u{1103}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B38B}",
        nfc: "\u{B38B}",
        nfd: "\u{1103}\u{1166}\u{11C2}",
        nfkc: "\u{B38B}",
        nfkd: "\u{1103}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B38C}",
        nfc: "\u{B38C}",
        nfd: "\u{1103}\u{1167}",
        nfkc: "\u{B38C}",
        nfkd: "\u{1103}\u{1167}",
    },
    NormalizationTest {
        source: "\u{B38D}",
        nfc: "\u{B38D}",
        nfd: "\u{1103}\u{1167}\u{11A8}",
        nfkc: "\u{B38D}",
        nfkd: "\u{1103}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B38E}",
        nfc: "\u{B38E}",
        nfd: "\u{1103}\u{1167}\u{11A9}",
        nfkc: "\u{B38E}",
        nfkd: "\u{1103}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B38F}",
        nfc: "\u{B38F}",
        nfd: "\u{1103}\u{1167}\u{11AA}",
        nfkc: "\u{B38F}",
        nfkd: "\u{1103}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B390}",
        nfc: "\u{B390}",
        nfd: "\u{1103}\u{1167}\u{11AB}",
        nfkc: "\u{B390}",
        nfkd: "\u{1103}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B391}",
        nfc: "\u{B391}",
        nfd: "\u{1103}\u{1167}\u{11AC}",
        nfkc: "\u{B391}",
        nfkd: "\u{1103}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B392}",
        nfc: "\u{B392}",
        nfd: "\u{1103}\u{1167}\u{11AD}",
        nfkc: "\u{B392}",
        nfkd: "\u{1103}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B393}",
        nfc: "\u{B393}",
        nfd: "\u{1103}\u{1167}\u{11AE}",
        nfkc: "\u{B393}",
        nfkd: "\u{1103}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B394}",
        nfc: "\u{B394}",
        nfd: "\u{1103}\u{1167}\u{11AF}",
        nfkc: "\u{B394}",
        nfkd: "\u{1103}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B395}",
        nfc: "\u{B395}",
        nfd: "\u{1103}\u{1167}\u{11B0}",
        nfkc: "\u{B395}",
        nfkd: "\u{1103}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B396}",
        nfc: "\u{B396}",
        nfd: "\u{1103}\u{1167}\u{11B1}",
        nfkc: "\u{B396}",
        nfkd: "\u{1103}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B397}",
        nfc: "\u{B397}",
        nfd: "\u{1103}\u{1167}\u{11B2}",
        nfkc: "\u{B397}",
        nfkd: "\u{1103}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B398}",
        nfc: "\u{B398}",
        nfd: "\u{1103}\u{1167}\u{11B3}",
        nfkc: "\u{B398}",
        nfkd: "\u{1103}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B399}",
        nfc: "\u{B399}",
        nfd: "\u{1103}\u{1167}\u{11B4}",
        nfkc: "\u{B399}",
        nfkd: "\u{1103}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B39A}",
        nfc: "\u{B39A}",
        nfd: "\u{1103}\u{1167}\u{11B5}",
        nfkc: "\u{B39A}",
        nfkd: "\u{1103}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B39B}",
        nfc: "\u{B39B}",
        nfd: "\u{1103}\u{1167}\u{11B6}",
        nfkc: "\u{B39B}",
        nfkd: "\u{1103}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B39C}",
        nfc: "\u{B39C}",
        nfd: "\u{1103}\u{1167}\u{11B7}",
        nfkc: "\u{B39C}",
        nfkd: "\u{1103}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B39D}",
        nfc: "\u{B39D}",
        nfd: "\u{1103}\u{1167}\u{11B8}",
        nfkc: "\u{B39D}",
        nfkd: "\u{1103}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B39E}",
        nfc: "\u{B39E}",
        nfd: "\u{1103}\u{1167}\u{11B9}",
        nfkc: "\u{B39E}",
        nfkd: "\u{1103}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B39F}",
        nfc: "\u{B39F}",
        nfd: "\u{1103}\u{1167}\u{11BA}",
        nfkc: "\u{B39F}",
        nfkd: "\u{1103}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B3A0}",
        nfc: "\u{B3A0}",
        nfd: "\u{1103}\u{1167}\u{11BB}",
        nfkc: "\u{B3A0}",
        nfkd: "\u{1103}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B3A1}",
        nfc: "\u{B3A1}",
        nfd: "\u{1103}\u{1167}\u{11BC}",
        nfkc: "\u{B3A1}",
        nfkd: "\u{1103}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B3A2}",
        nfc: "\u{B3A2}",
        nfd: "\u{1103}\u{1167}\u{11BD}",
        nfkc: "\u{B3A2}",
        nfkd: "\u{1103}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B3A3}",
        nfc: "\u{B3A3}",
        nfd: "\u{1103}\u{1167}\u{11BE}",
        nfkc: "\u{B3A3}",
        nfkd: "\u{1103}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B3A4}",
        nfc: "\u{B3A4}",
        nfd: "\u{1103}\u{1167}\u{11BF}",
        nfkc: "\u{B3A4}",
        nfkd: "\u{1103}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B3A5}",
        nfc: "\u{B3A5}",
        nfd: "\u{1103}\u{1167}\u{11C0}",
        nfkc: "\u{B3A5}",
        nfkd: "\u{1103}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B3A6}",
        nfc: "\u{B3A6}",
        nfd: "\u{1103}\u{1167}\u{11C1}",
        nfkc: "\u{B3A6}",
        nfkd: "\u{1103}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B3A7}",
        nfc: "\u{B3A7}",
        nfd: "\u{1103}\u{1167}\u{11C2}",
        nfkc: "\u{B3A7}",
        nfkd: "\u{1103}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B3A8}",
        nfc: "\u{B3A8}",
        nfd: "\u{1103}\u{1168}",
        nfkc: "\u{B3A8}",
        nfkd: "\u{1103}\u{1168}",
    },
    NormalizationTest {
        source: "\u{B3A9}",
        nfc: "\u{B3A9}",
        nfd: "\u{1103}\u{1168}\u{11A8}",
        nfkc: "\u{B3A9}",
        nfkd: "\u{1103}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B3AA}",
        nfc: "\u{B3AA}",
        nfd: "\u{1103}\u{1168}\u{11A9}",
        nfkc: "\u{B3AA}",
        nfkd: "\u{1103}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B3AB}",
        nfc: "\u{B3AB}",
        nfd: "\u{1103}\u{1168}\u{11AA}",
        nfkc: "\u{B3AB}",
        nfkd: "\u{1103}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B3AC}",
        nfc: "\u{B3AC}",
        nfd: "\u{1103}\u{1168}\u{11AB}",
        nfkc: "\u{B3AC}",
        nfkd: "\u{1103}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B3AD}",
        nfc: "\u{B3AD}",
        nfd: "\u{1103}\u{1168}\u{11AC}",
        nfkc: "\u{B3AD}",
        nfkd: "\u{1103}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B3AE}",
        nfc: "\u{B3AE}",
        nfd: "\u{1103}\u{1168}\u{11AD}",
        nfkc: "\u{B3AE}",
        nfkd: "\u{1103}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B3AF}",
        nfc: "\u{B3AF}",
        nfd: "\u{1103}\u{1168}\u{11AE}",
        nfkc: "\u{B3AF}",
        nfkd: "\u{1103}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B3B0}",
        nfc: "\u{B3B0}",
        nfd: "\u{1103}\u{1168}\u{11AF}",
        nfkc: "\u{B3B0}",
        nfkd: "\u{1103}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B3B1}",
        nfc: "\u{B3B1}",
        nfd: "\u{1103}\u{1168}\u{11B0}",
        nfkc: "\u{B3B1}",
        nfkd: "\u{1103}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B3B2}",
        nfc: "\u{B3B2}",
        nfd: "\u{1103}\u{1168}\u{11B1}",
        nfkc: "\u{B3B2}",
        nfkd: "\u{1103}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B3B3}",
        nfc: "\u{B3B3}",
        nfd: "\u{1103}\u{1168}\u{11B2}",
        nfkc: "\u{B3B3}",
        nfkd: "\u{1103}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B3B4}",
        nfc: "\u{B3B4}",
        nfd: "\u{1103}\u{1168}\u{11B3}",
        nfkc: "\u{B3B4}",
        nfkd: "\u{1103}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B3B5}",
        nfc: "\u{B3B5}",
        nfd: "\u{1103}\u{1168}\u{11B4}",
        nfkc: "\u{B3B5}",
        nfkd: "\u{1103}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B3B6}",
        nfc: "\u{B3B6}",
        nfd: "\u{1103}\u{1168}\u{11B5}",
        nfkc: "\u{B3B6}",
        nfkd: "\u{1103}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B3B7}",
        nfc: "\u{B3B7}",
        nfd: "\u{1103}\u{1168}\u{11B6}",
        nfkc: "\u{B3B7}",
        nfkd: "\u{1103}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B3B8}",
        nfc: "\u{B3B8}",
        nfd: "\u{1103}\u{1168}\u{11B7}",
        nfkc: "\u{B3B8}",
        nfkd: "\u{1103}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B3B9}",
        nfc: "\u{B3B9}",
        nfd: "\u{1103}\u{1168}\u{11B8}",
        nfkc: "\u{B3B9}",
        nfkd: "\u{1103}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B3BA}",
        nfc: "\u{B3BA}",
        nfd: "\u{1103}\u{1168}\u{11B9}",
        nfkc: "\u{B3BA}",
        nfkd: "\u{1103}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B3BB}",
        nfc: "\u{B3BB}",
        nfd: "\u{1103}\u{1168}\u{11BA}",
        nfkc: "\u{B3BB}",
        nfkd: "\u{1103}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B3BC}",
        nfc: "\u{B3BC}",
        nfd: "\u{1103}\u{1168}\u{11BB}",
        nfkc: "\u{B3BC}",
        nfkd: "\u{1103}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B3BD}",
        nfc: "\u{B3BD}",
        nfd: "\u{1103}\u{1168}\u{11BC}",
        nfkc: "\u{B3BD}",
        nfkd: "\u{1103}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B3BE}",
        nfc: "\u{B3BE}",
        nfd: "\u{1103}\u{1168}\u{11BD}",
        nfkc: "\u{B3BE}",
        nfkd: "\u{1103}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B3BF}",
        nfc: "\u{B3BF}",
        nfd: "\u{1103}\u{1168}\u{11BE}",
        nfkc: "\u{B3BF}",
        nfkd: "\u{1103}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B3C0}",
        nfc: "\u{B3C0}",
        nfd: "\u{1103}\u{1168}\u{11BF}",
        nfkc: "\u{B3C0}",
        nfkd: "\u{1103}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B3C1}",
        nfc: "\u{B3C1}",
        nfd: "\u{1103}\u{1168}\u{11C0}",
        nfkc: "\u{B3C1}",
        nfkd: "\u{1103}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B3C2}",
        nfc: "\u{B3C2}",
        nfd: "\u{1103}\u{1168}\u{11C1}",
        nfkc: "\u{B3C2}",
        nfkd: "\u{1103}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B3C3}",
        nfc: "\u{B3C3}",
        nfd: "\u{1103}\u{1168}\u{11C2}",
        nfkc: "\u{B3C3}",
        nfkd: "\u{1103}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B3C4}",
        nfc: "\u{B3C4}",
        nfd: "\u{1103}\u{1169}",
        nfkc: "\u{B3C4}",
        nfkd: "\u{1103}\u{1169}",
    },
    NormalizationTest {
        source: "\u{B3C5}",
        nfc: "\u{B3C5}",
        nfd: "\u{1103}\u{1169}\u{11A8}",
        nfkc: "\u{B3C5}",
        nfkd: "\u{1103}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B3C6}",
        nfc: "\u{B3C6}",
        nfd: "\u{1103}\u{1169}\u{11A9}",
        nfkc: "\u{B3C6}",
        nfkd: "\u{1103}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B3C7}",
        nfc: "\u{B3C7}",
        nfd: "\u{1103}\u{1169}\u{11AA}",
        nfkc: "\u{B3C7}",
        nfkd: "\u{1103}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B3C8}",
        nfc: "\u{B3C8}",
        nfd: "\u{1103}\u{1169}\u{11AB}",
        nfkc: "\u{B3C8}",
        nfkd: "\u{1103}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B3C9}",
        nfc: "\u{B3C9}",
        nfd: "\u{1103}\u{1169}\u{11AC}",
        nfkc: "\u{B3C9}",
        nfkd: "\u{1103}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B3CA}",
        nfc: "\u{B3CA}",
        nfd: "\u{1103}\u{1169}\u{11AD}",
        nfkc: "\u{B3CA}",
        nfkd: "\u{1103}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B3CB}",
        nfc: "\u{B3CB}",
        nfd: "\u{1103}\u{1169}\u{11AE}",
        nfkc: "\u{B3CB}",
        nfkd: "\u{1103}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B3CC}",
        nfc: "\u{B3CC}",
        nfd: "\u{1103}\u{1169}\u{11AF}",
        nfkc: "\u{B3CC}",
        nfkd: "\u{1103}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B3CD}",
        nfc: "\u{B3CD}",
        nfd: "\u{1103}\u{1169}\u{11B0}",
        nfkc: "\u{B3CD}",
        nfkd: "\u{1103}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B3CE}",
        nfc: "\u{B3CE}",
        nfd: "\u{1103}\u{1169}\u{11B1}",
        nfkc: "\u{B3CE}",
        nfkd: "\u{1103}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B3CF}",
        nfc: "\u{B3CF}",
        nfd: "\u{1103}\u{1169}\u{11B2}",
        nfkc: "\u{B3CF}",
        nfkd: "\u{1103}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B3D0}",
        nfc: "\u{B3D0}",
        nfd: "\u{1103}\u{1169}\u{11B3}",
        nfkc: "\u{B3D0}",
        nfkd: "\u{1103}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B3D1}",
        nfc: "\u{B3D1}",
        nfd: "\u{1103}\u{1169}\u{11B4}",
        nfkc: "\u{B3D1}",
        nfkd: "\u{1103}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B3D2}",
        nfc: "\u{B3D2}",
        nfd: "\u{1103}\u{1169}\u{11B5}",
        nfkc: "\u{B3D2}",
        nfkd: "\u{1103}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B3D3}",
        nfc: "\u{B3D3}",
        nfd: "\u{1103}\u{1169}\u{11B6}",
        nfkc: "\u{B3D3}",
        nfkd: "\u{1103}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B3D4}",
        nfc: "\u{B3D4}",
        nfd: "\u{1103}\u{1169}\u{11B7}",
        nfkc: "\u{B3D4}",
        nfkd: "\u{1103}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B3D5}",
        nfc: "\u{B3D5}",
        nfd: "\u{1103}\u{1169}\u{11B8}",
        nfkc: "\u{B3D5}",
        nfkd: "\u{1103}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B3D6}",
        nfc: "\u{B3D6}",
        nfd: "\u{1103}\u{1169}\u{11B9}",
        nfkc: "\u{B3D6}",
        nfkd: "\u{1103}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B3D7}",
        nfc: "\u{B3D7}",
        nfd: "\u{1103}\u{1169}\u{11BA}",
        nfkc: "\u{B3D7}",
        nfkd: "\u{1103}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B3D8}",
        nfc: "\u{B3D8}",
        nfd: "\u{1103}\u{1169}\u{11BB}",
        nfkc: "\u{B3D8}",
        nfkd: "\u{1103}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B3D9}",
        nfc: "\u{B3D9}",
        nfd: "\u{1103}\u{1169}\u{11BC}",
        nfkc: "\u{B3D9}",
        nfkd: "\u{1103}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B3DA}",
        nfc: "\u{B3DA}",
        nfd: "\u{1103}\u{1169}\u{11BD}",
        nfkc: "\u{B3DA}",
        nfkd: "\u{1103}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B3DB}",
        nfc: "\u{B3DB}",
        nfd: "\u{1103}\u{1169}\u{11BE}",
        nfkc: "\u{B3DB}",
        nfkd: "\u{1103}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B3DC}",
        nfc: "\u{B3DC}",
        nfd: "\u{1103}\u{1169}\u{11BF}",
        nfkc: "\u{B3DC}",
        nfkd: "\u{1103}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B3DD}",
        nfc: "\u{B3DD}",
        nfd: "\u{1103}\u{1169}\u{11C0}",
        nfkc: "\u{B3DD}",
        nfkd: "\u{1103}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B3DE}",
        nfc: "\u{B3DE}",
        nfd: "\u{1103}\u{1169}\u{11C1}",
        nfkc: "\u{B3DE}",
        nfkd: "\u{1103}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B3DF}",
        nfc: "\u{B3DF}",
        nfd: "\u{1103}\u{1169}\u{11C2}",
        nfkc: "\u{B3DF}",
        nfkd: "\u{1103}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B3E0}",
        nfc: "\u{B3E0}",
        nfd: "\u{1103}\u{116A}",
        nfkc: "\u{B3E0}",
        nfkd: "\u{1103}\u{116A}",
    },
    NormalizationTest {
        source: "\u{B3E1}",
        nfc: "\u{B3E1}",
        nfd: "\u{1103}\u{116A}\u{11A8}",
        nfkc: "\u{B3E1}",
        nfkd: "\u{1103}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B3E2}",
        nfc: "\u{B3E2}",
        nfd: "\u{1103}\u{116A}\u{11A9}",
        nfkc: "\u{B3E2}",
        nfkd: "\u{1103}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B3E3}",
        nfc: "\u{B3E3}",
        nfd: "\u{1103}\u{116A}\u{11AA}",
        nfkc: "\u{B3E3}",
        nfkd: "\u{1103}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B3E4}",
        nfc: "\u{B3E4}",
        nfd: "\u{1103}\u{116A}\u{11AB}",
        nfkc: "\u{B3E4}",
        nfkd: "\u{1103}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B3E5}",
        nfc: "\u{B3E5}",
        nfd: "\u{1103}\u{116A}\u{11AC}",
        nfkc: "\u{B3E5}",
        nfkd: "\u{1103}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B3E6}",
        nfc: "\u{B3E6}",
        nfd: "\u{1103}\u{116A}\u{11AD}",
        nfkc: "\u{B3E6}",
        nfkd: "\u{1103}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B3E7}",
        nfc: "\u{B3E7}",
        nfd: "\u{1103}\u{116A}\u{11AE}",
        nfkc: "\u{B3E7}",
        nfkd: "\u{1103}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B3E8}",
        nfc: "\u{B3E8}",
        nfd: "\u{1103}\u{116A}\u{11AF}",
        nfkc: "\u{B3E8}",
        nfkd: "\u{1103}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B3E9}",
        nfc: "\u{B3E9}",
        nfd: "\u{1103}\u{116A}\u{11B0}",
        nfkc: "\u{B3E9}",
        nfkd: "\u{1103}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B3EA}",
        nfc: "\u{B3EA}",
        nfd: "\u{1103}\u{116A}\u{11B1}",
        nfkc: "\u{B3EA}",
        nfkd: "\u{1103}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B3EB}",
        nfc: "\u{B3EB}",
        nfd: "\u{1103}\u{116A}\u{11B2}",
        nfkc: "\u{B3EB}",
        nfkd: "\u{1103}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B3EC}",
        nfc: "\u{B3EC}",
        nfd: "\u{1103}\u{116A}\u{11B3}",
        nfkc: "\u{B3EC}",
        nfkd: "\u{1103}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B3ED}",
        nfc: "\u{B3ED}",
        nfd: "\u{1103}\u{116A}\u{11B4}",
        nfkc: "\u{B3ED}",
        nfkd: "\u{1103}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B3EE}",
        nfc: "\u{B3EE}",
        nfd: "\u{1103}\u{116A}\u{11B5}",
        nfkc: "\u{B3EE}",
        nfkd: "\u{1103}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B3EF}",
        nfc: "\u{B3EF}",
        nfd: "\u{1103}\u{116A}\u{11B6}",
        nfkc: "\u{B3EF}",
        nfkd: "\u{1103}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B3F0}",
        nfc: "\u{B3F0}",
        nfd: "\u{1103}\u{116A}\u{11B7}",
        nfkc: "\u{B3F0}",
        nfkd: "\u{1103}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B3F1}",
        nfc: "\u{B3F1}",
        nfd: "\u{1103}\u{116A}\u{11B8}",
        nfkc: "\u{B3F1}",
        nfkd: "\u{1103}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B3F2}",
        nfc: "\u{B3F2}",
        nfd: "\u{1103}\u{116A}\u{11B9}",
        nfkc: "\u{B3F2}",
        nfkd: "\u{1103}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B3F3}",
        nfc: "\u{B3F3}",
        nfd: "\u{1103}\u{116A}\u{11BA}",
        nfkc: "\u{B3F3}",
        nfkd: "\u{1103}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B3F4}",
        nfc: "\u{B3F4}",
        nfd: "\u{1103}\u{116A}\u{11BB}",
        nfkc: "\u{B3F4}",
        nfkd: "\u{1103}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B3F5}",
        nfc: "\u{B3F5}",
        nfd: "\u{1103}\u{116A}\u{11BC}",
        nfkc: "\u{B3F5}",
        nfkd: "\u{1103}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B3F6}",
        nfc: "\u{B3F6}",
        nfd: "\u{1103}\u{116A}\u{11BD}",
        nfkc: "\u{B3F6}",
        nfkd: "\u{1103}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B3F7}",
        nfc: "\u{B3F7}",
        nfd: "\u{1103}\u{116A}\u{11BE}",
        nfkc: "\u{B3F7}",
        nfkd: "\u{1103}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B3F8}",
        nfc: "\u{B3F8}",
        nfd: "\u{1103}\u{116A}\u{11BF}",
        nfkc: "\u{B3F8}",
        nfkd: "\u{1103}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B3F9}",
        nfc: "\u{B3F9}",
        nfd: "\u{1103}\u{116A}\u{11C0}",
        nfkc: "\u{B3F9}",
        nfkd: "\u{1103}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B3FA}",
        nfc: "\u{B3FA}",
        nfd: "\u{1103}\u{116A}\u{11C1}",
        nfkc: "\u{B3FA}",
        nfkd: "\u{1103}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B3FB}",
        nfc: "\u{B3FB}",
        nfd: "\u{1103}\u{116A}\u{11C2}",
        nfkc: "\u{B3FB}",
        nfkd: "\u{1103}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B3FC}",
        nfc: "\u{B3FC}",
        nfd: "\u{1103}\u{116B}",
        nfkc: "\u{B3FC}",
        nfkd: "\u{1103}\u{116B}",
    },
    NormalizationTest {
        source: "\u{B3FD}",
        nfc: "\u{B3FD}",
        nfd: "\u{1103}\u{116B}\u{11A8}",
        nfkc: "\u{B3FD}",
        nfkd: "\u{1103}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B3FE}",
        nfc: "\u{B3FE}",
        nfd: "\u{1103}\u{116B}\u{11A9}",
        nfkc: "\u{B3FE}",
        nfkd: "\u{1103}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B3FF}",
        nfc: "\u{B3FF}",
        nfd: "\u{1103}\u{116B}\u{11AA}",
        nfkc: "\u{B3FF}",
        nfkd: "\u{1103}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B400}",
        nfc: "\u{B400}",
        nfd: "\u{1103}\u{116B}\u{11AB}",
        nfkc: "\u{B400}",
        nfkd: "\u{1103}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B401}",
        nfc: "\u{B401}",
        nfd: "\u{1103}\u{116B}\u{11AC}",
        nfkc: "\u{B401}",
        nfkd: "\u{1103}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B402}",
        nfc: "\u{B402}",
        nfd: "\u{1103}\u{116B}\u{11AD}",
        nfkc: "\u{B402}",
        nfkd: "\u{1103}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B403}",
        nfc: "\u{B403}",
        nfd: "\u{1103}\u{116B}\u{11AE}",
        nfkc: "\u{B403}",
        nfkd: "\u{1103}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B404}",
        nfc: "\u{B404}",
        nfd: "\u{1103}\u{116B}\u{11AF}",
        nfkc: "\u{B404}",
        nfkd: "\u{1103}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B405}",
        nfc: "\u{B405}",
        nfd: "\u{1103}\u{116B}\u{11B0}",
        nfkc: "\u{B405}",
        nfkd: "\u{1103}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B406}",
        nfc: "\u{B406}",
        nfd: "\u{1103}\u{116B}\u{11B1}",
        nfkc: "\u{B406}",
        nfkd: "\u{1103}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B407}",
        nfc: "\u{B407}",
        nfd: "\u{1103}\u{116B}\u{11B2}",
        nfkc: "\u{B407}",
        nfkd: "\u{1103}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B408}",
        nfc: "\u{B408}",
        nfd: "\u{1103}\u{116B}\u{11B3}",
        nfkc: "\u{B408}",
        nfkd: "\u{1103}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B409}",
        nfc: "\u{B409}",
        nfd: "\u{1103}\u{116B}\u{11B4}",
        nfkc: "\u{B409}",
        nfkd: "\u{1103}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B40A}",
        nfc: "\u{B40A}",
        nfd: "\u{1103}\u{116B}\u{11B5}",
        nfkc: "\u{B40A}",
        nfkd: "\u{1103}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B40B}",
        nfc: "\u{B40B}",
        nfd: "\u{1103}\u{116B}\u{11B6}",
        nfkc: "\u{B40B}",
        nfkd: "\u{1103}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B40C}",
        nfc: "\u{B40C}",
        nfd: "\u{1103}\u{116B}\u{11B7}",
        nfkc: "\u{B40C}",
        nfkd: "\u{1103}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B40D}",
        nfc: "\u{B40D}",
        nfd: "\u{1103}\u{116B}\u{11B8}",
        nfkc: "\u{B40D}",
        nfkd: "\u{1103}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B40E}",
        nfc: "\u{B40E}",
        nfd: "\u{1103}\u{116B}\u{11B9}",
        nfkc: "\u{B40E}",
        nfkd: "\u{1103}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B40F}",
        nfc: "\u{B40F}",
        nfd: "\u{1103}\u{116B}\u{11BA}",
        nfkc: "\u{B40F}",
        nfkd: "\u{1103}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B410}",
        nfc: "\u{B410}",
        nfd: "\u{1103}\u{116B}\u{11BB}",
        nfkc: "\u{B410}",
        nfkd: "\u{1103}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B411}",
        nfc: "\u{B411}",
        nfd: "\u{1103}\u{116B}\u{11BC}",
        nfkc: "\u{B411}",
        nfkd: "\u{1103}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B412}",
        nfc: "\u{B412}",
        nfd: "\u{1103}\u{116B}\u{11BD}",
        nfkc: "\u{B412}",
        nfkd: "\u{1103}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B413}",
        nfc: "\u{B413}",
        nfd: "\u{1103}\u{116B}\u{11BE}",
        nfkc: "\u{B413}",
        nfkd: "\u{1103}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B414}",
        nfc: "\u{B414}",
        nfd: "\u{1103}\u{116B}\u{11BF}",
        nfkc: "\u{B414}",
        nfkd: "\u{1103}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B415}",
        nfc: "\u{B415}",
        nfd: "\u{1103}\u{116B}\u{11C0}",
        nfkc: "\u{B415}",
        nfkd: "\u{1103}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B416}",
        nfc: "\u{B416}",
        nfd: "\u{1103}\u{116B}\u{11C1}",
        nfkc: "\u{B416}",
        nfkd: "\u{1103}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B417}",
        nfc: "\u{B417}",
        nfd: "\u{1103}\u{116B}\u{11C2}",
        nfkc: "\u{B417}",
        nfkd: "\u{1103}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B418}",
        nfc: "\u{B418}",
        nfd: "\u{1103}\u{116C}",
        nfkc: "\u{B418}",
        nfkd: "\u{1103}\u{116C}",
    },
    NormalizationTest {
        source: "\u{B419}",
        nfc: "\u{B419}",
        nfd: "\u{1103}\u{116C}\u{11A8}",
        nfkc: "\u{B419}",
        nfkd: "\u{1103}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B41A}",
        nfc: "\u{B41A}",
        nfd: "\u{1103}\u{116C}\u{11A9}",
        nfkc: "\u{B41A}",
        nfkd: "\u{1103}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B41B}",
        nfc: "\u{B41B}",
        nfd: "\u{1103}\u{116C}\u{11AA}",
        nfkc: "\u{B41B}",
        nfkd: "\u{1103}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B41C}",
        nfc: "\u{B41C}",
        nfd: "\u{1103}\u{116C}\u{11AB}",
        nfkc: "\u{B41C}",
        nfkd: "\u{1103}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B41D}",
        nfc: "\u{B41D}",
        nfd: "\u{1103}\u{116C}\u{11AC}",
        nfkc: "\u{B41D}",
        nfkd: "\u{1103}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B41E}",
        nfc: "\u{B41E}",
        nfd: "\u{1103}\u{116C}\u{11AD}",
        nfkc: "\u{B41E}",
        nfkd: "\u{1103}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B41F}",
        nfc: "\u{B41F}",
        nfd: "\u{1103}\u{116C}\u{11AE}",
        nfkc: "\u{B41F}",
        nfkd: "\u{1103}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B420}",
        nfc: "\u{B420}",
        nfd: "\u{1103}\u{116C}\u{11AF}",
        nfkc: "\u{B420}",
        nfkd: "\u{1103}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B421}",
        nfc: "\u{B421}",
        nfd: "\u{1103}\u{116C}\u{11B0}",
        nfkc: "\u{B421}",
        nfkd: "\u{1103}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B422}",
        nfc: "\u{B422}",
        nfd: "\u{1103}\u{116C}\u{11B1}",
        nfkc: "\u{B422}",
        nfkd: "\u{1103}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B423}",
        nfc: "\u{B423}",
        nfd: "\u{1103}\u{116C}\u{11B2}",
        nfkc: "\u{B423}",
        nfkd: "\u{1103}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B424}",
        nfc: "\u{B424}",
        nfd: "\u{1103}\u{116C}\u{11B3}",
        nfkc: "\u{B424}",
        nfkd: "\u{1103}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B425}",
        nfc: "\u{B425}",
        nfd: "\u{1103}\u{116C}\u{11B4}",
        nfkc: "\u{B425}",
        nfkd: "\u{1103}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B426}",
        nfc: "\u{B426}",
        nfd: "\u{1103}\u{116C}\u{11B5}",
        nfkc: "\u{B426}",
        nfkd: "\u{1103}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B427}",
        nfc: "\u{B427}",
        nfd: "\u{1103}\u{116C}\u{11B6}",
        nfkc: "\u{B427}",
        nfkd: "\u{1103}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B428}",
        nfc: "\u{B428}",
        nfd: "\u{1103}\u{116C}\u{11B7}",
        nfkc: "\u{B428}",
        nfkd: "\u{1103}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B429}",
        nfc: "\u{B429}",
        nfd: "\u{1103}\u{116C}\u{11B8}",
        nfkc: "\u{B429}",
        nfkd: "\u{1103}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B42A}",
        nfc: "\u{B42A}",
        nfd: "\u{1103}\u{116C}\u{11B9}",
        nfkc: "\u{B42A}",
        nfkd: "\u{1103}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B42B}",
        nfc: "\u{B42B}",
        nfd: "\u{1103}\u{116C}\u{11BA}",
        nfkc: "\u{B42B}",
        nfkd: "\u{1103}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B42C}",
        nfc: "\u{B42C}",
        nfd: "\u{1103}\u{116C}\u{11BB}",
        nfkc: "\u{B42C}",
        nfkd: "\u{1103}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B42D}",
        nfc: "\u{B42D}",
        nfd: "\u{1103}\u{116C}\u{11BC}",
        nfkc: "\u{B42D}",
        nfkd: "\u{1103}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B42E}",
        nfc: "\u{B42E}",
        nfd: "\u{1103}\u{116C}\u{11BD}",
        nfkc: "\u{B42E}",
        nfkd: "\u{1103}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B42F}",
        nfc: "\u{B42F}",
        nfd: "\u{1103}\u{116C}\u{11BE}",
        nfkc: "\u{B42F}",
        nfkd: "\u{1103}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B430}",
        nfc: "\u{B430}",
        nfd: "\u{1103}\u{116C}\u{11BF}",
        nfkc: "\u{B430}",
        nfkd: "\u{1103}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B431}",
        nfc: "\u{B431}",
        nfd: "\u{1103}\u{116C}\u{11C0}",
        nfkc: "\u{B431}",
        nfkd: "\u{1103}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B432}",
        nfc: "\u{B432}",
        nfd: "\u{1103}\u{116C}\u{11C1}",
        nfkc: "\u{B432}",
        nfkd: "\u{1103}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B433}",
        nfc: "\u{B433}",
        nfd: "\u{1103}\u{116C}\u{11C2}",
        nfkc: "\u{B433}",
        nfkd: "\u{1103}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B434}",
        nfc: "\u{B434}",
        nfd: "\u{1103}\u{116D}",
        nfkc: "\u{B434}",
        nfkd: "\u{1103}\u{116D}",
    },
    NormalizationTest {
        source: "\u{B435}",
        nfc: "\u{B435}",
        nfd: "\u{1103}\u{116D}\u{11A8}",
        nfkc: "\u{B435}",
        nfkd: "\u{1103}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B436}",
        nfc: "\u{B436}",
        nfd: "\u{1103}\u{116D}\u{11A9}",
        nfkc: "\u{B436}",
        nfkd: "\u{1103}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B437}",
        nfc: "\u{B437}",
        nfd: "\u{1103}\u{116D}\u{11AA}",
        nfkc: "\u{B437}",
        nfkd: "\u{1103}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B438}",
        nfc: "\u{B438}",
        nfd: "\u{1103}\u{116D}\u{11AB}",
        nfkc: "\u{B438}",
        nfkd: "\u{1103}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B439}",
        nfc: "\u{B439}",
        nfd: "\u{1103}\u{116D}\u{11AC}",
        nfkc: "\u{B439}",
        nfkd: "\u{1103}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B43A}",
        nfc: "\u{B43A}",
        nfd: "\u{1103}\u{116D}\u{11AD}",
        nfkc: "\u{B43A}",
        nfkd: "\u{1103}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B43B}",
        nfc: "\u{B43B}",
        nfd: "\u{1103}\u{116D}\u{11AE}",
        nfkc: "\u{B43B}",
        nfkd: "\u{1103}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B43C}",
        nfc: "\u{B43C}",
        nfd: "\u{1103}\u{116D}\u{11AF}",
        nfkc: "\u{B43C}",
        nfkd: "\u{1103}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B43D}",
        nfc: "\u{B43D}",
        nfd: "\u{1103}\u{116D}\u{11B0}",
        nfkc: "\u{B43D}",
        nfkd: "\u{1103}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B43E}",
        nfc: "\u{B43E}",
        nfd: "\u{1103}\u{116D}\u{11B1}",
        nfkc: "\u{B43E}",
        nfkd: "\u{1103}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B43F}",
        nfc: "\u{B43F}",
        nfd: "\u{1103}\u{116D}\u{11B2}",
        nfkc: "\u{B43F}",
        nfkd: "\u{1103}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B440}",
        nfc: "\u{B440}",
        nfd: "\u{1103}\u{116D}\u{11B3}",
        nfkc: "\u{B440}",
        nfkd: "\u{1103}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B441}",
        nfc: "\u{B441}",
        nfd: "\u{1103}\u{116D}\u{11B4}",
        nfkc: "\u{B441}",
        nfkd: "\u{1103}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B442}",
        nfc: "\u{B442}",
        nfd: "\u{1103}\u{116D}\u{11B5}",
        nfkc: "\u{B442}",
        nfkd: "\u{1103}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B443}",
        nfc: "\u{B443}",
        nfd: "\u{1103}\u{116D}\u{11B6}",
        nfkc: "\u{B443}",
        nfkd: "\u{1103}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B444}",
        nfc: "\u{B444}",
        nfd: "\u{1103}\u{116D}\u{11B7}",
        nfkc: "\u{B444}",
        nfkd: "\u{1103}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B445}",
        nfc: "\u{B445}",
        nfd: "\u{1103}\u{116D}\u{11B8}",
        nfkc: "\u{B445}",
        nfkd: "\u{1103}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B446}",
        nfc: "\u{B446}",
        nfd: "\u{1103}\u{116D}\u{11B9}",
        nfkc: "\u{B446}",
        nfkd: "\u{1103}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B447}",
        nfc: "\u{B447}",
        nfd: "\u{1103}\u{116D}\u{11BA}",
        nfkc: "\u{B447}",
        nfkd: "\u{1103}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B448}",
        nfc: "\u{B448}",
        nfd: "\u{1103}\u{116D}\u{11BB}",
        nfkc: "\u{B448}",
        nfkd: "\u{1103}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B449}",
        nfc: "\u{B449}",
        nfd: "\u{1103}\u{116D}\u{11BC}",
        nfkc: "\u{B449}",
        nfkd: "\u{1103}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B44A}",
        nfc: "\u{B44A}",
        nfd: "\u{1103}\u{116D}\u{11BD}",
        nfkc: "\u{B44A}",
        nfkd: "\u{1103}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B44B}",
        nfc: "\u{B44B}",
        nfd: "\u{1103}\u{116D}\u{11BE}",
        nfkc: "\u{B44B}",
        nfkd: "\u{1103}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B44C}",
        nfc: "\u{B44C}",
        nfd: "\u{1103}\u{116D}\u{11BF}",
        nfkc: "\u{B44C}",
        nfkd: "\u{1103}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B44D}",
        nfc: "\u{B44D}",
        nfd: "\u{1103}\u{116D}\u{11C0}",
        nfkc: "\u{B44D}",
        nfkd: "\u{1103}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B44E}",
        nfc: "\u{B44E}",
        nfd: "\u{1103}\u{116D}\u{11C1}",
        nfkc: "\u{B44E}",
        nfkd: "\u{1103}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B44F}",
        nfc: "\u{B44F}",
        nfd: "\u{1103}\u{116D}\u{11C2}",
        nfkc: "\u{B44F}",
        nfkd: "\u{1103}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B450}",
        nfc: "\u{B450}",
        nfd: "\u{1103}\u{116E}",
        nfkc: "\u{B450}",
        nfkd: "\u{1103}\u{116E}",
    },
    NormalizationTest {
        source: "\u{B451}",
        nfc: "\u{B451}",
        nfd: "\u{1103}\u{116E}\u{11A8}",
        nfkc: "\u{B451}",
        nfkd: "\u{1103}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B452}",
        nfc: "\u{B452}",
        nfd: "\u{1103}\u{116E}\u{11A9}",
        nfkc: "\u{B452}",
        nfkd: "\u{1103}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B453}",
        nfc: "\u{B453}",
        nfd: "\u{1103}\u{116E}\u{11AA}",
        nfkc: "\u{B453}",
        nfkd: "\u{1103}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B454}",
        nfc: "\u{B454}",
        nfd: "\u{1103}\u{116E}\u{11AB}",
        nfkc: "\u{B454}",
        nfkd: "\u{1103}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B455}",
        nfc: "\u{B455}",
        nfd: "\u{1103}\u{116E}\u{11AC}",
        nfkc: "\u{B455}",
        nfkd: "\u{1103}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B456}",
        nfc: "\u{B456}",
        nfd: "\u{1103}\u{116E}\u{11AD}",
        nfkc: "\u{B456}",
        nfkd: "\u{1103}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B457}",
        nfc: "\u{B457}",
        nfd: "\u{1103}\u{116E}\u{11AE}",
        nfkc: "\u{B457}",
        nfkd: "\u{1103}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B458}",
        nfc: "\u{B458}",
        nfd: "\u{1103}\u{116E}\u{11AF}",
        nfkc: "\u{B458}",
        nfkd: "\u{1103}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B459}",
        nfc: "\u{B459}",
        nfd: "\u{1103}\u{116E}\u{11B0}",
        nfkc: "\u{B459}",
        nfkd: "\u{1103}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B45A}",
        nfc: "\u{B45A}",
        nfd: "\u{1103}\u{116E}\u{11B1}",
        nfkc: "\u{B45A}",
        nfkd: "\u{1103}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B45B}",
        nfc: "\u{B45B}",
        nfd: "\u{1103}\u{116E}\u{11B2}",
        nfkc: "\u{B45B}",
        nfkd: "\u{1103}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B45C}",
        nfc: "\u{B45C}",
        nfd: "\u{1103}\u{116E}\u{11B3}",
        nfkc: "\u{B45C}",
        nfkd: "\u{1103}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B45D}",
        nfc: "\u{B45D}",
        nfd: "\u{1103}\u{116E}\u{11B4}",
        nfkc: "\u{B45D}",
        nfkd: "\u{1103}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B45E}",
        nfc: "\u{B45E}",
        nfd: "\u{1103}\u{116E}\u{11B5}",
        nfkc: "\u{B45E}",
        nfkd: "\u{1103}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B45F}",
        nfc: "\u{B45F}",
        nfd: "\u{1103}\u{116E}\u{11B6}",
        nfkc: "\u{B45F}",
        nfkd: "\u{1103}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B460}",
        nfc: "\u{B460}",
        nfd: "\u{1103}\u{116E}\u{11B7}",
        nfkc: "\u{B460}",
        nfkd: "\u{1103}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B461}",
        nfc: "\u{B461}",
        nfd: "\u{1103}\u{116E}\u{11B8}",
        nfkc: "\u{B461}",
        nfkd: "\u{1103}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B462}",
        nfc: "\u{B462}",
        nfd: "\u{1103}\u{116E}\u{11B9}",
        nfkc: "\u{B462}",
        nfkd: "\u{1103}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B463}",
        nfc: "\u{B463}",
        nfd: "\u{1103}\u{116E}\u{11BA}",
        nfkc: "\u{B463}",
        nfkd: "\u{1103}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B464}",
        nfc: "\u{B464}",
        nfd: "\u{1103}\u{116E}\u{11BB}",
        nfkc: "\u{B464}",
        nfkd: "\u{1103}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B465}",
        nfc: "\u{B465}",
        nfd: "\u{1103}\u{116E}\u{11BC}",
        nfkc: "\u{B465}",
        nfkd: "\u{1103}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B466}",
        nfc: "\u{B466}",
        nfd: "\u{1103}\u{116E}\u{11BD}",
        nfkc: "\u{B466}",
        nfkd: "\u{1103}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B467}",
        nfc: "\u{B467}",
        nfd: "\u{1103}\u{116E}\u{11BE}",
        nfkc: "\u{B467}",
        nfkd: "\u{1103}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B468}",
        nfc: "\u{B468}",
        nfd: "\u{1103}\u{116E}\u{11BF}",
        nfkc: "\u{B468}",
        nfkd: "\u{1103}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B469}",
        nfc: "\u{B469}",
        nfd: "\u{1103}\u{116E}\u{11C0}",
        nfkc: "\u{B469}",
        nfkd: "\u{1103}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B46A}",
        nfc: "\u{B46A}",
        nfd: "\u{1103}\u{116E}\u{11C1}",
        nfkc: "\u{B46A}",
        nfkd: "\u{1103}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B46B}",
        nfc: "\u{B46B}",
        nfd: "\u{1103}\u{116E}\u{11C2}",
        nfkc: "\u{B46B}",
        nfkd: "\u{1103}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B46C}",
        nfc: "\u{B46C}",
        nfd: "\u{1103}\u{116F}",
        nfkc: "\u{B46C}",
        nfkd: "\u{1103}\u{116F}",
    },
    NormalizationTest {
        source: "\u{B46D}",
        nfc: "\u{B46D}",
        nfd: "\u{1103}\u{116F}\u{11A8}",
        nfkc: "\u{B46D}",
        nfkd: "\u{1103}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B46E}",
        nfc: "\u{B46E}",
        nfd: "\u{1103}\u{116F}\u{11A9}",
        nfkc: "\u{B46E}",
        nfkd: "\u{1103}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B46F}",
        nfc: "\u{B46F}",
        nfd: "\u{1103}\u{116F}\u{11AA}",
        nfkc: "\u{B46F}",
        nfkd: "\u{1103}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B470}",
        nfc: "\u{B470}",
        nfd: "\u{1103}\u{116F}\u{11AB}",
        nfkc: "\u{B470}",
        nfkd: "\u{1103}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B471}",
        nfc: "\u{B471}",
        nfd: "\u{1103}\u{116F}\u{11AC}",
        nfkc: "\u{B471}",
        nfkd: "\u{1103}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B472}",
        nfc: "\u{B472}",
        nfd: "\u{1103}\u{116F}\u{11AD}",
        nfkc: "\u{B472}",
        nfkd: "\u{1103}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B473}",
        nfc: "\u{B473}",
        nfd: "\u{1103}\u{116F}\u{11AE}",
        nfkc: "\u{B473}",
        nfkd: "\u{1103}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B474}",
        nfc: "\u{B474}",
        nfd: "\u{1103}\u{116F}\u{11AF}",
        nfkc: "\u{B474}",
        nfkd: "\u{1103}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B475}",
        nfc: "\u{B475}",
        nfd: "\u{1103}\u{116F}\u{11B0}",
        nfkc: "\u{B475}",
        nfkd: "\u{1103}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B476}",
        nfc: "\u{B476}",
        nfd: "\u{1103}\u{116F}\u{11B1}",
        nfkc: "\u{B476}",
        nfkd: "\u{1103}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B477}",
        nfc: "\u{B477}",
        nfd: "\u{1103}\u{116F}\u{11B2}",
        nfkc: "\u{B477}",
        nfkd: "\u{1103}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B478}",
        nfc: "\u{B478}",
        nfd: "\u{1103}\u{116F}\u{11B3}",
        nfkc: "\u{B478}",
        nfkd: "\u{1103}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B479}",
        nfc: "\u{B479}",
        nfd: "\u{1103}\u{116F}\u{11B4}",
        nfkc: "\u{B479}",
        nfkd: "\u{1103}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B47A}",
        nfc: "\u{B47A}",
        nfd: "\u{1103}\u{116F}\u{11B5}",
        nfkc: "\u{B47A}",
        nfkd: "\u{1103}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B47B}",
        nfc: "\u{B47B}",
        nfd: "\u{1103}\u{116F}\u{11B6}",
        nfkc: "\u{B47B}",
        nfkd: "\u{1103}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B47C}",
        nfc: "\u{B47C}",
        nfd: "\u{1103}\u{116F}\u{11B7}",
        nfkc: "\u{B47C}",
        nfkd: "\u{1103}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B47D}",
        nfc: "\u{B47D}",
        nfd: "\u{1103}\u{116F}\u{11B8}",
        nfkc: "\u{B47D}",
        nfkd: "\u{1103}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B47E}",
        nfc: "\u{B47E}",
        nfd: "\u{1103}\u{116F}\u{11B9}",
        nfkc: "\u{B47E}",
        nfkd: "\u{1103}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B47F}",
        nfc: "\u{B47F}",
        nfd: "\u{1103}\u{116F}\u{11BA}",
        nfkc: "\u{B47F}",
        nfkd: "\u{1103}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B480}",
        nfc: "\u{B480}",
        nfd: "\u{1103}\u{116F}\u{11BB}",
        nfkc: "\u{B480}",
        nfkd: "\u{1103}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B481}",
        nfc: "\u{B481}",
        nfd: "\u{1103}\u{116F}\u{11BC}",
        nfkc: "\u{B481}",
        nfkd: "\u{1103}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B482}",
        nfc: "\u{B482}",
        nfd: "\u{1103}\u{116F}\u{11BD}",
        nfkc: "\u{B482}",
        nfkd: "\u{1103}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B483}",
        nfc: "\u{B483}",
        nfd: "\u{1103}\u{116F}\u{11BE}",
        nfkc: "\u{B483}",
        nfkd: "\u{1103}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B484}",
        nfc: "\u{B484}",
        nfd: "\u{1103}\u{116F}\u{11BF}",
        nfkc: "\u{B484}",
        nfkd: "\u{1103}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B485}",
        nfc: "\u{B485}",
        nfd: "\u{1103}\u{116F}\u{11C0}",
        nfkc: "\u{B485}",
        nfkd: "\u{1103}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B486}",
        nfc: "\u{B486}",
        nfd: "\u{1103}\u{116F}\u{11C1}",
        nfkc: "\u{B486}",
        nfkd: "\u{1103}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B487}",
        nfc: "\u{B487}",
        nfd: "\u{1103}\u{116F}\u{11C2}",
        nfkc: "\u{B487}",
        nfkd: "\u{1103}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B488}",
        nfc: "\u{B488}",
        nfd: "\u{1103}\u{1170}",
        nfkc: "\u{B488}",
        nfkd: "\u{1103}\u{1170}",
    },
    NormalizationTest {
        source: "\u{B489}",
        nfc: "\u{B489}",
        nfd: "\u{1103}\u{1170}\u{11A8}",
        nfkc: "\u{B489}",
        nfkd: "\u{1103}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B48A}",
        nfc: "\u{B48A}",
        nfd: "\u{1103}\u{1170}\u{11A9}",
        nfkc: "\u{B48A}",
        nfkd: "\u{1103}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B48B}",
        nfc: "\u{B48B}",
        nfd: "\u{1103}\u{1170}\u{11AA}",
        nfkc: "\u{B48B}",
        nfkd: "\u{1103}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B48C}",
        nfc: "\u{B48C}",
        nfd: "\u{1103}\u{1170}\u{11AB}",
        nfkc: "\u{B48C}",
        nfkd: "\u{1103}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B48D}",
        nfc: "\u{B48D}",
        nfd: "\u{1103}\u{1170}\u{11AC}",
        nfkc: "\u{B48D}",
        nfkd: "\u{1103}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B48E}",
        nfc: "\u{B48E}",
        nfd: "\u{1103}\u{1170}\u{11AD}",
        nfkc: "\u{B48E}",
        nfkd: "\u{1103}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B48F}",
        nfc: "\u{B48F}",
        nfd: "\u{1103}\u{1170}\u{11AE}",
        nfkc: "\u{B48F}",
        nfkd: "\u{1103}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B490}",
        nfc: "\u{B490}",
        nfd: "\u{1103}\u{1170}\u{11AF}",
        nfkc: "\u{B490}",
        nfkd: "\u{1103}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B491}",
        nfc: "\u{B491}",
        nfd: "\u{1103}\u{1170}\u{11B0}",
        nfkc: "\u{B491}",
        nfkd: "\u{1103}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B492}",
        nfc: "\u{B492}",
        nfd: "\u{1103}\u{1170}\u{11B1}",
        nfkc: "\u{B492}",
        nfkd: "\u{1103}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B493}",
        nfc: "\u{B493}",
        nfd: "\u{1103}\u{1170}\u{11B2}",
        nfkc: "\u{B493}",
        nfkd: "\u{1103}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B494}",
        nfc: "\u{B494}",
        nfd: "\u{1103}\u{1170}\u{11B3}",
        nfkc: "\u{B494}",
        nfkd: "\u{1103}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B495}",
        nfc: "\u{B495}",
        nfd: "\u{1103}\u{1170}\u{11B4}",
        nfkc: "\u{B495}",
        nfkd: "\u{1103}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B496}",
        nfc: "\u{B496}",
        nfd: "\u{1103}\u{1170}\u{11B5}",
        nfkc: "\u{B496}",
        nfkd: "\u{1103}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B497}",
        nfc: "\u{B497}",
        nfd: "\u{1103}\u{1170}\u{11B6}",
        nfkc: "\u{B497}",
        nfkd: "\u{1103}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B498}",
        nfc: "\u{B498}",
        nfd: "\u{1103}\u{1170}\u{11B7}",
        nfkc: "\u{B498}",
        nfkd: "\u{1103}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B499}",
        nfc: "\u{B499}",
        nfd: "\u{1103}\u{1170}\u{11B8}",
        nfkc: "\u{B499}",
        nfkd: "\u{1103}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B49A}",
        nfc: "\u{B49A}",
        nfd: "\u{1103}\u{1170}\u{11B9}",
        nfkc: "\u{B49A}",
        nfkd: "\u{1103}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B49B}",
        nfc: "\u{B49B}",
        nfd: "\u{1103}\u{1170}\u{11BA}",
        nfkc: "\u{B49B}",
        nfkd: "\u{1103}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B49C}",
        nfc: "\u{B49C}",
        nfd: "\u{1103}\u{1170}\u{11BB}",
        nfkc: "\u{B49C}",
        nfkd: "\u{1103}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B49D}",
        nfc: "\u{B49D}",
        nfd: "\u{1103}\u{1170}\u{11BC}",
        nfkc: "\u{B49D}",
        nfkd: "\u{1103}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B49E}",
        nfc: "\u{B49E}",
        nfd: "\u{1103}\u{1170}\u{11BD}",
        nfkc: "\u{B49E}",
        nfkd: "\u{1103}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B49F}",
        nfc: "\u{B49F}",
        nfd: "\u{1103}\u{1170}\u{11BE}",
        nfkc: "\u{B49F}",
        nfkd: "\u{1103}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B4A0}",
        nfc: "\u{B4A0}",
        nfd: "\u{1103}\u{1170}\u{11BF}",
        nfkc: "\u{B4A0}",
        nfkd: "\u{1103}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B4A1}",
        nfc: "\u{B4A1}",
        nfd: "\u{1103}\u{1170}\u{11C0}",
        nfkc: "\u{B4A1}",
        nfkd: "\u{1103}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B4A2}",
        nfc: "\u{B4A2}",
        nfd: "\u{1103}\u{1170}\u{11C1}",
        nfkc: "\u{B4A2}",
        nfkd: "\u{1103}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B4A3}",
        nfc: "\u{B4A3}",
        nfd: "\u{1103}\u{1170}\u{11C2}",
        nfkc: "\u{B4A3}",
        nfkd: "\u{1103}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B4A4}",
        nfc: "\u{B4A4}",
        nfd: "\u{1103}\u{1171}",
        nfkc: "\u{B4A4}",
        nfkd: "\u{1103}\u{1171}",
    },
    NormalizationTest {
        source: "\u{B4A5}",
        nfc: "\u{B4A5}",
        nfd: "\u{1103}\u{1171}\u{11A8}",
        nfkc: "\u{B4A5}",
        nfkd: "\u{1103}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B4A6}",
        nfc: "\u{B4A6}",
        nfd: "\u{1103}\u{1171}\u{11A9}",
        nfkc: "\u{B4A6}",
        nfkd: "\u{1103}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B4A7}",
        nfc: "\u{B4A7}",
        nfd: "\u{1103}\u{1171}\u{11AA}",
        nfkc: "\u{B4A7}",
        nfkd: "\u{1103}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B4A8}",
        nfc: "\u{B4A8}",
        nfd: "\u{1103}\u{1171}\u{11AB}",
        nfkc: "\u{B4A8}",
        nfkd: "\u{1103}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B4A9}",
        nfc: "\u{B4A9}",
        nfd: "\u{1103}\u{1171}\u{11AC}",
        nfkc: "\u{B4A9}",
        nfkd: "\u{1103}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B4AA}",
        nfc: "\u{B4AA}",
        nfd: "\u{1103}\u{1171}\u{11AD}",
        nfkc: "\u{B4AA}",
        nfkd: "\u{1103}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B4AB}",
        nfc: "\u{B4AB}",
        nfd: "\u{1103}\u{1171}\u{11AE}",
        nfkc: "\u{B4AB}",
        nfkd: "\u{1103}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B4AC}",
        nfc: "\u{B4AC}",
        nfd: "\u{1103}\u{1171}\u{11AF}",
        nfkc: "\u{B4AC}",
        nfkd: "\u{1103}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B4AD}",
        nfc: "\u{B4AD}",
        nfd: "\u{1103}\u{1171}\u{11B0}",
        nfkc: "\u{B4AD}",
        nfkd: "\u{1103}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B4AE}",
        nfc: "\u{B4AE}",
        nfd: "\u{1103}\u{1171}\u{11B1}",
        nfkc: "\u{B4AE}",
        nfkd: "\u{1103}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B4AF}",
        nfc: "\u{B4AF}",
        nfd: "\u{1103}\u{1171}\u{11B2}",
        nfkc: "\u{B4AF}",
        nfkd: "\u{1103}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B4B0}",
        nfc: "\u{B4B0}",
        nfd: "\u{1103}\u{1171}\u{11B3}",
        nfkc: "\u{B4B0}",
        nfkd: "\u{1103}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B4B1}",
        nfc: "\u{B4B1}",
        nfd: "\u{1103}\u{1171}\u{11B4}",
        nfkc: "\u{B4B1}",
        nfkd: "\u{1103}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B4B2}",
        nfc: "\u{B4B2}",
        nfd: "\u{1103}\u{1171}\u{11B5}",
        nfkc: "\u{B4B2}",
        nfkd: "\u{1103}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B4B3}",
        nfc: "\u{B4B3}",
        nfd: "\u{1103}\u{1171}\u{11B6}",
        nfkc: "\u{B4B3}",
        nfkd: "\u{1103}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B4B4}",
        nfc: "\u{B4B4}",
        nfd: "\u{1103}\u{1171}\u{11B7}",
        nfkc: "\u{B4B4}",
        nfkd: "\u{1103}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B4B5}",
        nfc: "\u{B4B5}",
        nfd: "\u{1103}\u{1171}\u{11B8}",
        nfkc: "\u{B4B5}",
        nfkd: "\u{1103}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B4B6}",
        nfc: "\u{B4B6}",
        nfd: "\u{1103}\u{1171}\u{11B9}",
        nfkc: "\u{B4B6}",
        nfkd: "\u{1103}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B4B7}",
        nfc: "\u{B4B7}",
        nfd: "\u{1103}\u{1171}\u{11BA}",
        nfkc: "\u{B4B7}",
        nfkd: "\u{1103}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B4B8}",
        nfc: "\u{B4B8}",
        nfd: "\u{1103}\u{1171}\u{11BB}",
        nfkc: "\u{B4B8}",
        nfkd: "\u{1103}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B4B9}",
        nfc: "\u{B4B9}",
        nfd: "\u{1103}\u{1171}\u{11BC}",
        nfkc: "\u{B4B9}",
        nfkd: "\u{1103}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B4BA}",
        nfc: "\u{B4BA}",
        nfd: "\u{1103}\u{1171}\u{11BD}",
        nfkc: "\u{B4BA}",
        nfkd: "\u{1103}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B4BB}",
        nfc: "\u{B4BB}",
        nfd: "\u{1103}\u{1171}\u{11BE}",
        nfkc: "\u{B4BB}",
        nfkd: "\u{1103}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B4BC}",
        nfc: "\u{B4BC}",
        nfd: "\u{1103}\u{1171}\u{11BF}",
        nfkc: "\u{B4BC}",
        nfkd: "\u{1103}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B4BD}",
        nfc: "\u{B4BD}",
        nfd: "\u{1103}\u{1171}\u{11C0}",
        nfkc: "\u{B4BD}",
        nfkd: "\u{1103}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B4BE}",
        nfc: "\u{B4BE}",
        nfd: "\u{1103}\u{1171}\u{11C1}",
        nfkc: "\u{B4BE}",
        nfkd: "\u{1103}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B4BF}",
        nfc: "\u{B4BF}",
        nfd: "\u{1103}\u{1171}\u{11C2}",
        nfkc: "\u{B4BF}",
        nfkd: "\u{1103}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B4C0}",
        nfc: "\u{B4C0}",
        nfd: "\u{1103}\u{1172}",
        nfkc: "\u{B4C0}",
        nfkd: "\u{1103}\u{1172}",
    },
    NormalizationTest {
        source: "\u{B4C1}",
        nfc: "\u{B4C1}",
        nfd: "\u{1103}\u{1172}\u{11A8}",
        nfkc: "\u{B4C1}",
        nfkd: "\u{1103}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B4C2}",
        nfc: "\u{B4C2}",
        nfd: "\u{1103}\u{1172}\u{11A9}",
        nfkc: "\u{B4C2}",
        nfkd: "\u{1103}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B4C3}",
        nfc: "\u{B4C3}",
        nfd: "\u{1103}\u{1172}\u{11AA}",
        nfkc: "\u{B4C3}",
        nfkd: "\u{1103}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B4C4}",
        nfc: "\u{B4C4}",
        nfd: "\u{1103}\u{1172}\u{11AB}",
        nfkc: "\u{B4C4}",
        nfkd: "\u{1103}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B4C5}",
        nfc: "\u{B4C5}",
        nfd: "\u{1103}\u{1172}\u{11AC}",
        nfkc: "\u{B4C5}",
        nfkd: "\u{1103}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B4C6}",
        nfc: "\u{B4C6}",
        nfd: "\u{1103}\u{1172}\u{11AD}",
        nfkc: "\u{B4C6}",
        nfkd: "\u{1103}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B4C7}",
        nfc: "\u{B4C7}",
        nfd: "\u{1103}\u{1172}\u{11AE}",
        nfkc: "\u{B4C7}",
        nfkd: "\u{1103}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B4C8}",
        nfc: "\u{B4C8}",
        nfd: "\u{1103}\u{1172}\u{11AF}",
        nfkc: "\u{B4C8}",
        nfkd: "\u{1103}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B4C9}",
        nfc: "\u{B4C9}",
        nfd: "\u{1103}\u{1172}\u{11B0}",
        nfkc: "\u{B4C9}",
        nfkd: "\u{1103}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B4CA}",
        nfc: "\u{B4CA}",
        nfd: "\u{1103}\u{1172}\u{11B1}",
        nfkc: "\u{B4CA}",
        nfkd: "\u{1103}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B4CB}",
        nfc: "\u{B4CB}",
        nfd: "\u{1103}\u{1172}\u{11B2}",
        nfkc: "\u{B4CB}",
        nfkd: "\u{1103}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B4CC}",
        nfc: "\u{B4CC}",
        nfd: "\u{1103}\u{1172}\u{11B3}",
        nfkc: "\u{B4CC}",
        nfkd: "\u{1103}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B4CD}",
        nfc: "\u{B4CD}",
        nfd: "\u{1103}\u{1172}\u{11B4}",
        nfkc: "\u{B4CD}",
        nfkd: "\u{1103}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B4CE}",
        nfc: "\u{B4CE}",
        nfd: "\u{1103}\u{1172}\u{11B5}",
        nfkc: "\u{B4CE}",
        nfkd: "\u{1103}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B4CF}",
        nfc: "\u{B4CF}",
        nfd: "\u{1103}\u{1172}\u{11B6}",
        nfkc: "\u{B4CF}",
        nfkd: "\u{1103}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B4D0}",
        nfc: "\u{B4D0}",
        nfd: "\u{1103}\u{1172}\u{11B7}",
        nfkc: "\u{B4D0}",
        nfkd: "\u{1103}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B4D1}",
        nfc: "\u{B4D1}",
        nfd: "\u{1103}\u{1172}\u{11B8}",
        nfkc: "\u{B4D1}",
        nfkd: "\u{1103}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B4D2}",
        nfc: "\u{B4D2}",
        nfd: "\u{1103}\u{1172}\u{11B9}",
        nfkc: "\u{B4D2}",
        nfkd: "\u{1103}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B4D3}",
        nfc: "\u{B4D3}",
        nfd: "\u{1103}\u{1172}\u{11BA}",
        nfkc: "\u{B4D3}",
        nfkd: "\u{1103}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B4D4}",
        nfc: "\u{B4D4}",
        nfd: "\u{1103}\u{1172}\u{11BB}",
        nfkc: "\u{B4D4}",
        nfkd: "\u{1103}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B4D5}",
        nfc: "\u{B4D5}",
        nfd: "\u{1103}\u{1172}\u{11BC}",
        nfkc: "\u{B4D5}",
        nfkd: "\u{1103}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B4D6}",
        nfc: "\u{B4D6}",
        nfd: "\u{1103}\u{1172}\u{11BD}",
        nfkc: "\u{B4D6}",
        nfkd: "\u{1103}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B4D7}",
        nfc: "\u{B4D7}",
        nfd: "\u{1103}\u{1172}\u{11BE}",
        nfkc: "\u{B4D7}",
        nfkd: "\u{1103}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B4D8}",
        nfc: "\u{B4D8}",
        nfd: "\u{1103}\u{1172}\u{11BF}",
        nfkc: "\u{B4D8}",
        nfkd: "\u{1103}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B4D9}",
        nfc: "\u{B4D9}",
        nfd: "\u{1103}\u{1172}\u{11C0}",
        nfkc: "\u{B4D9}",
        nfkd: "\u{1103}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B4DA}",
        nfc: "\u{B4DA}",
        nfd: "\u{1103}\u{1172}\u{11C1}",
        nfkc: "\u{B4DA}",
        nfkd: "\u{1103}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B4DB}",
        nfc: "\u{B4DB}",
        nfd: "\u{1103}\u{1172}\u{11C2}",
        nfkc: "\u{B4DB}",
        nfkd: "\u{1103}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B4DC}",
        nfc: "\u{B4DC}",
        nfd: "\u{1103}\u{1173}",
        nfkc: "\u{B4DC}",
        nfkd: "\u{1103}\u{1173}",
    },
    NormalizationTest {
        source: "\u{B4DD}",
        nfc: "\u{B4DD}",
        nfd: "\u{1103}\u{1173}\u{11A8}",
        nfkc: "\u{B4DD}",
        nfkd: "\u{1103}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B4DE}",
        nfc: "\u{B4DE}",
        nfd: "\u{1103}\u{1173}\u{11A9}",
        nfkc: "\u{B4DE}",
        nfkd: "\u{1103}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B4DF}",
        nfc: "\u{B4DF}",
        nfd: "\u{1103}\u{1173}\u{11AA}",
        nfkc: "\u{B4DF}",
        nfkd: "\u{1103}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B4E0}",
        nfc: "\u{B4E0}",
        nfd: "\u{1103}\u{1173}\u{11AB}",
        nfkc: "\u{B4E0}",
        nfkd: "\u{1103}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B4E1}",
        nfc: "\u{B4E1}",
        nfd: "\u{1103}\u{1173}\u{11AC}",
        nfkc: "\u{B4E1}",
        nfkd: "\u{1103}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B4E2}",
        nfc: "\u{B4E2}",
        nfd: "\u{1103}\u{1173}\u{11AD}",
        nfkc: "\u{B4E2}",
        nfkd: "\u{1103}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B4E3}",
        nfc: "\u{B4E3}",
        nfd: "\u{1103}\u{1173}\u{11AE}",
        nfkc: "\u{B4E3}",
        nfkd: "\u{1103}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B4E4}",
        nfc: "\u{B4E4}",
        nfd: "\u{1103}\u{1173}\u{11AF}",
        nfkc: "\u{B4E4}",
        nfkd: "\u{1103}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B4E5}",
        nfc: "\u{B4E5}",
        nfd: "\u{1103}\u{1173}\u{11B0}",
        nfkc: "\u{B4E5}",
        nfkd: "\u{1103}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B4E6}",
        nfc: "\u{B4E6}",
        nfd: "\u{1103}\u{1173}\u{11B1}",
        nfkc: "\u{B4E6}",
        nfkd: "\u{1103}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B4E7}",
        nfc: "\u{B4E7}",
        nfd: "\u{1103}\u{1173}\u{11B2}",
        nfkc: "\u{B4E7}",
        nfkd: "\u{1103}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B4E8}",
        nfc: "\u{B4E8}",
        nfd: "\u{1103}\u{1173}\u{11B3}",
        nfkc: "\u{B4E8}",
        nfkd: "\u{1103}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B4E9}",
        nfc: "\u{B4E9}",
        nfd: "\u{1103}\u{1173}\u{11B4}",
        nfkc: "\u{B4E9}",
        nfkd: "\u{1103}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B4EA}",
        nfc: "\u{B4EA}",
        nfd: "\u{1103}\u{1173}\u{11B5}",
        nfkc: "\u{B4EA}",
        nfkd: "\u{1103}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B4EB}",
        nfc: "\u{B4EB}",
        nfd: "\u{1103}\u{1173}\u{11B6}",
        nfkc: "\u{B4EB}",
        nfkd: "\u{1103}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B4EC}",
        nfc: "\u{B4EC}",
        nfd: "\u{1103}\u{1173}\u{11B7}",
        nfkc: "\u{B4EC}",
        nfkd: "\u{1103}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B4ED}",
        nfc: "\u{B4ED}",
        nfd: "\u{1103}\u{1173}\u{11B8}",
        nfkc: "\u{B4ED}",
        nfkd: "\u{1103}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B4EE}",
        nfc: "\u{B4EE}",
        nfd: "\u{1103}\u{1173}\u{11B9}",
        nfkc: "\u{B4EE}",
        nfkd: "\u{1103}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B4EF}",
        nfc: "\u{B4EF}",
        nfd: "\u{1103}\u{1173}\u{11BA}",
        nfkc: "\u{B4EF}",
        nfkd: "\u{1103}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B4F0}",
        nfc: "\u{B4F0}",
        nfd: "\u{1103}\u{1173}\u{11BB}",
        nfkc: "\u{B4F0}",
        nfkd: "\u{1103}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B4F1}",
        nfc: "\u{B4F1}",
        nfd: "\u{1103}\u{1173}\u{11BC}",
        nfkc: "\u{B4F1}",
        nfkd: "\u{1103}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B4F2}",
        nfc: "\u{B4F2}",
        nfd: "\u{1103}\u{1173}\u{11BD}",
        nfkc: "\u{B4F2}",
        nfkd: "\u{1103}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B4F3}",
        nfc: "\u{B4F3}",
        nfd: "\u{1103}\u{1173}\u{11BE}",
        nfkc: "\u{B4F3}",
        nfkd: "\u{1103}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B4F4}",
        nfc: "\u{B4F4}",
        nfd: "\u{1103}\u{1173}\u{11BF}",
        nfkc: "\u{B4F4}",
        nfkd: "\u{1103}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B4F5}",
        nfc: "\u{B4F5}",
        nfd: "\u{1103}\u{1173}\u{11C0}",
        nfkc: "\u{B4F5}",
        nfkd: "\u{1103}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B4F6}",
        nfc: "\u{B4F6}",
        nfd: "\u{1103}\u{1173}\u{11C1}",
        nfkc: "\u{B4F6}",
        nfkd: "\u{1103}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B4F7}",
        nfc: "\u{B4F7}",
        nfd: "\u{1103}\u{1173}\u{11C2}",
        nfkc: "\u{B4F7}",
        nfkd: "\u{1103}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B4F8}",
        nfc: "\u{B4F8}",
        nfd: "\u{1103}\u{1174}",
        nfkc: "\u{B4F8}",
        nfkd: "\u{1103}\u{1174}",
    },
    NormalizationTest {
        source: "\u{B4F9}",
        nfc: "\u{B4F9}",
        nfd: "\u{1103}\u{1174}\u{11A8}",
        nfkc: "\u{B4F9}",
        nfkd: "\u{1103}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B4FA}",
        nfc: "\u{B4FA}",
        nfd: "\u{1103}\u{1174}\u{11A9}",
        nfkc: "\u{B4FA}",
        nfkd: "\u{1103}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B4FB}",
        nfc: "\u{B4FB}",
        nfd: "\u{1103}\u{1174}\u{11AA}",
        nfkc: "\u{B4FB}",
        nfkd: "\u{1103}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B4FC}",
        nfc: "\u{B4FC}",
        nfd: "\u{1103}\u{1174}\u{11AB}",
        nfkc: "\u{B4FC}",
        nfkd: "\u{1103}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B4FD}",
        nfc: "\u{B4FD}",
        nfd: "\u{1103}\u{1174}\u{11AC}",
        nfkc: "\u{B4FD}",
        nfkd: "\u{1103}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B4FE}",
        nfc: "\u{B4FE}",
        nfd: "\u{1103}\u{1174}\u{11AD}",
        nfkc: "\u{B4FE}",
        nfkd: "\u{1103}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B4FF}",
        nfc: "\u{B4FF}",
        nfd: "\u{1103}\u{1174}\u{11AE}",
        nfkc: "\u{B4FF}",
        nfkd: "\u{1103}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B500}",
        nfc: "\u{B500}",
        nfd: "\u{1103}\u{1174}\u{11AF}",
        nfkc: "\u{B500}",
        nfkd: "\u{1103}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B501}",
        nfc: "\u{B501}",
        nfd: "\u{1103}\u{1174}\u{11B0}",
        nfkc: "\u{B501}",
        nfkd: "\u{1103}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B502}",
        nfc: "\u{B502}",
        nfd: "\u{1103}\u{1174}\u{11B1}",
        nfkc: "\u{B502}",
        nfkd: "\u{1103}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B503}",
        nfc: "\u{B503}",
        nfd: "\u{1103}\u{1174}\u{11B2}",
        nfkc: "\u{B503}",
        nfkd: "\u{1103}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B504}",
        nfc: "\u{B504}",
        nfd: "\u{1103}\u{1174}\u{11B3}",
        nfkc: "\u{B504}",
        nfkd: "\u{1103}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B505}",
        nfc: "\u{B505}",
        nfd: "\u{1103}\u{1174}\u{11B4}",
        nfkc: "\u{B505}",
        nfkd: "\u{1103}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B506}",
        nfc: "\u{B506}",
        nfd: "\u{1103}\u{1174}\u{11B5}",
        nfkc: "\u{B506}",
        nfkd: "\u{1103}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B507}",
        nfc: "\u{B507}",
        nfd: "\u{1103}\u{1174}\u{11B6}",
        nfkc: "\u{B507}",
        nfkd: "\u{1103}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B508}",
        nfc: "\u{B508}",
        nfd: "\u{1103}\u{1174}\u{11B7}",
        nfkc: "\u{B508}",
        nfkd: "\u{1103}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B509}",
        nfc: "\u{B509}",
        nfd: "\u{1103}\u{1174}\u{11B8}",
        nfkc: "\u{B509}",
        nfkd: "\u{1103}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B50A}",
        nfc: "\u{B50A}",
        nfd: "\u{1103}\u{1174}\u{11B9}",
        nfkc: "\u{B50A}",
        nfkd: "\u{1103}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B50B}",
        nfc: "\u{B50B}",
        nfd: "\u{1103}\u{1174}\u{11BA}",
        nfkc: "\u{B50B}",
        nfkd: "\u{1103}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B50C}",
        nfc: "\u{B50C}",
        nfd: "\u{1103}\u{1174}\u{11BB}",
        nfkc: "\u{B50C}",
        nfkd: "\u{1103}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B50D}",
        nfc: "\u{B50D}",
        nfd: "\u{1103}\u{1174}\u{11BC}",
        nfkc: "\u{B50D}",
        nfkd: "\u{1103}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B50E}",
        nfc: "\u{B50E}",
        nfd: "\u{1103}\u{1174}\u{11BD}",
        nfkc: "\u{B50E}",
        nfkd: "\u{1103}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B50F}",
        nfc: "\u{B50F}",
        nfd: "\u{1103}\u{1174}\u{11BE}",
        nfkc: "\u{B50F}",
        nfkd: "\u{1103}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B510}",
        nfc: "\u{B510}",
        nfd: "\u{1103}\u{1174}\u{11BF}",
        nfkc: "\u{B510}",
        nfkd: "\u{1103}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B511}",
        nfc: "\u{B511}",
        nfd: "\u{1103}\u{1174}\u{11C0}",
        nfkc: "\u{B511}",
        nfkd: "\u{1103}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B512}",
        nfc: "\u{B512}",
        nfd: "\u{1103}\u{1174}\u{11C1}",
        nfkc: "\u{B512}",
        nfkd: "\u{1103}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B513}",
        nfc: "\u{B513}",
        nfd: "\u{1103}\u{1174}\u{11C2}",
        nfkc: "\u{B513}",
        nfkd: "\u{1103}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B514}",
        nfc: "\u{B514}",
        nfd: "\u{1103}\u{1175}",
        nfkc: "\u{B514}",
        nfkd: "\u{1103}\u{1175}",
    },
    NormalizationTest {
        source: "\u{B515}",
        nfc: "\u{B515}",
        nfd: "\u{1103}\u{1175}\u{11A8}",
        nfkc: "\u{B515}",
        nfkd: "\u{1103}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B516}",
        nfc: "\u{B516}",
        nfd: "\u{1103}\u{1175}\u{11A9}",
        nfkc: "\u{B516}",
        nfkd: "\u{1103}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B517}",
        nfc: "\u{B517}",
        nfd: "\u{1103}\u{1175}\u{11AA}",
        nfkc: "\u{B517}",
        nfkd: "\u{1103}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B518}",
        nfc: "\u{B518}",
        nfd: "\u{1103}\u{1175}\u{11AB}",
        nfkc: "\u{B518}",
        nfkd: "\u{1103}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B519}",
        nfc: "\u{B519}",
        nfd: "\u{1103}\u{1175}\u{11AC}",
        nfkc: "\u{B519}",
        nfkd: "\u{1103}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B51A}",
        nfc: "\u{B51A}",
        nfd: "\u{1103}\u{1175}\u{11AD}",
        nfkc: "\u{B51A}",
        nfkd: "\u{1103}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B51B}",
        nfc: "\u{B51B}",
        nfd: "\u{1103}\u{1175}\u{11AE}",
        nfkc: "\u{B51B}",
        nfkd: "\u{1103}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B51C}",
        nfc: "\u{B51C}",
        nfd: "\u{1103}\u{1175}\u{11AF}",
        nfkc: "\u{B51C}",
        nfkd: "\u{1103}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B51D}",
        nfc: "\u{B51D}",
        nfd: "\u{1103}\u{1175}\u{11B0}",
        nfkc: "\u{B51D}",
        nfkd: "\u{1103}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B51E}",
        nfc: "\u{B51E}",
        nfd: "\u{1103}\u{1175}\u{11B1}",
        nfkc: "\u{B51E}",
        nfkd: "\u{1103}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B51F}",
        nfc: "\u{B51F}",
        nfd: "\u{1103}\u{1175}\u{11B2}",
        nfkc: "\u{B51F}",
        nfkd: "\u{1103}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B520}",
        nfc: "\u{B520}",
        nfd: "\u{1103}\u{1175}\u{11B3}",
        nfkc: "\u{B520}",
        nfkd: "\u{1103}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B521}",
        nfc: "\u{B521}",
        nfd: "\u{1103}\u{1175}\u{11B4}",
        nfkc: "\u{B521}",
        nfkd: "\u{1103}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B522}",
        nfc: "\u{B522}",
        nfd: "\u{1103}\u{1175}\u{11B5}",
        nfkc: "\u{B522}",
        nfkd: "\u{1103}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B523}",
        nfc: "\u{B523}",
        nfd: "\u{1103}\u{1175}\u{11B6}",
        nfkc: "\u{B523}",
        nfkd: "\u{1103}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B524}",
        nfc: "\u{B524}",
        nfd: "\u{1103}\u{1175}\u{11B7}",
        nfkc: "\u{B524}",
        nfkd: "\u{1103}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B525}",
        nfc: "\u{B525}",
        nfd: "\u{1103}\u{1175}\u{11B8}",
        nfkc: "\u{B525}",
        nfkd: "\u{1103}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B526}",
        nfc: "\u{B526}",
        nfd: "\u{1103}\u{1175}\u{11B9}",
        nfkc: "\u{B526}",
        nfkd: "\u{1103}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B527}",
        nfc: "\u{B527}",
        nfd: "\u{1103}\u{1175}\u{11BA}",
        nfkc: "\u{B527}",
        nfkd: "\u{1103}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B528}",
        nfc: "\u{B528}",
        nfd: "\u{1103}\u{1175}\u{11BB}",
        nfkc: "\u{B528}",
        nfkd: "\u{1103}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B529}",
        nfc: "\u{B529}",
        nfd: "\u{1103}\u{1175}\u{11BC}",
        nfkc: "\u{B529}",
        nfkd: "\u{1103}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B52A}",
        nfc: "\u{B52A}",
        nfd: "\u{1103}\u{1175}\u{11BD}",
        nfkc: "\u{B52A}",
        nfkd: "\u{1103}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B52B}",
        nfc: "\u{B52B}",
        nfd: "\u{1103}\u{1175}\u{11BE}",
        nfkc: "\u{B52B}",
        nfkd: "\u{1103}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B52C}",
        nfc: "\u{B52C}",
        nfd: "\u{1103}\u{1175}\u{11BF}",
        nfkc: "\u{B52C}",
        nfkd: "\u{1103}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B52D}",
        nfc: "\u{B52D}",
        nfd: "\u{1103}\u{1175}\u{11C0}",
        nfkc: "\u{B52D}",
        nfkd: "\u{1103}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B52E}",
        nfc: "\u{B52E}",
        nfd: "\u{1103}\u{1175}\u{11C1}",
        nfkc: "\u{B52E}",
        nfkd: "\u{1103}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B52F}",
        nfc: "\u{B52F}",
        nfd: "\u{1103}\u{1175}\u{11C2}",
        nfkc: "\u{B52F}",
        nfkd: "\u{1103}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B530}",
        nfc: "\u{B530}",
        nfd: "\u{1104}\u{1161}",
        nfkc: "\u{B530}",
        nfkd: "\u{1104}\u{1161}",
    },
    NormalizationTest {
        source: "\u{B531}",
        nfc: "\u{B531}",
        nfd: "\u{1104}\u{1161}\u{11A8}",
        nfkc: "\u{B531}",
        nfkd: "\u{1104}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B532}",
        nfc: "\u{B532}",
        nfd: "\u{1104}\u{1161}\u{11A9}",
        nfkc: "\u{B532}",
        nfkd: "\u{1104}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B533}",
        nfc: "\u{B533}",
        nfd: "\u{1104}\u{1161}\u{11AA}",
        nfkc: "\u{B533}",
        nfkd: "\u{1104}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B534}",
        nfc: "\u{B534}",
        nfd: "\u{1104}\u{1161}\u{11AB}",
        nfkc: "\u{B534}",
        nfkd: "\u{1104}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B535}",
        nfc: "\u{B535}",
        nfd: "\u{1104}\u{1161}\u{11AC}",
        nfkc: "\u{B535}",
        nfkd: "\u{1104}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B536}",
        nfc: "\u{B536}",
        nfd: "\u{1104}\u{1161}\u{11AD}",
        nfkc: "\u{B536}",
        nfkd: "\u{1104}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B537}",
        nfc: "\u{B537}",
        nfd: "\u{1104}\u{1161}\u{11AE}",
        nfkc: "\u{B537}",
        nfkd: "\u{1104}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B538}",
        nfc: "\u{B538}",
        nfd: "\u{1104}\u{1161}\u{11AF}",
        nfkc: "\u{B538}",
        nfkd: "\u{1104}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B539}",
        nfc: "\u{B539}",
        nfd: "\u{1104}\u{1161}\u{11B0}",
        nfkc: "\u{B539}",
        nfkd: "\u{1104}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B53A}",
        nfc: "\u{B53A}",
        nfd: "\u{1104}\u{1161}\u{11B1}",
        nfkc: "\u{B53A}",
        nfkd: "\u{1104}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B53B}",
        nfc: "\u{B53B}",
        nfd: "\u{1104}\u{1161}\u{11B2}",
        nfkc: "\u{B53B}",
        nfkd: "\u{1104}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B53C}",
        nfc: "\u{B53C}",
        nfd: "\u{1104}\u{1161}\u{11B3}",
        nfkc: "\u{B53C}",
        nfkd: "\u{1104}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B53D}",
        nfc: "\u{B53D}",
        nfd: "\u{1104}\u{1161}\u{11B4}",
        nfkc: "\u{B53D}",
        nfkd: "\u{1104}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B53E}",
        nfc: "\u{B53E}",
        nfd: "\u{1104}\u{1161}\u{11B5}",
        nfkc: "\u{B53E}",
        nfkd: "\u{1104}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B53F}",
        nfc: "\u{B53F}",
        nfd: "\u{1104}\u{1161}\u{11B6}",
        nfkc: "\u{B53F}",
        nfkd: "\u{1104}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B540}",
        nfc: "\u{B540}",
        nfd: "\u{1104}\u{1161}\u{11B7}",
        nfkc: "\u{B540}",
        nfkd: "\u{1104}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B541}",
        nfc: "\u{B541}",
        nfd: "\u{1104}\u{1161}\u{11B8}",
        nfkc: "\u{B541}",
        nfkd: "\u{1104}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B542}",
        nfc: "\u{B542}",
        nfd: "\u{1104}\u{1161}\u{11B9}",
        nfkc: "\u{B542}",
        nfkd: "\u{1104}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B543}",
        nfc: "\u{B543}",
        nfd: "\u{1104}\u{1161}\u{11BA}",
        nfkc: "\u{B543}",
        nfkd: "\u{1104}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B544}",
        nfc: "\u{B544}",
        nfd: "\u{1104}\u{1161}\u{11BB}",
        nfkc: "\u{B544}",
        nfkd: "\u{1104}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B545}",
        nfc: "\u{B545}",
        nfd: "\u{1104}\u{1161}\u{11BC}",
        nfkc: "\u{B545}",
        nfkd: "\u{1104}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B546}",
        nfc: "\u{B546}",
        nfd: "\u{1104}\u{1161}\u{11BD}",
        nfkc: "\u{B546}",
        nfkd: "\u{1104}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B547}",
        nfc: "\u{B547}",
        nfd: "\u{1104}\u{1161}\u{11BE}",
        nfkc: "\u{B547}",
        nfkd: "\u{1104}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B548}",
        nfc: "\u{B548}",
        nfd: "\u{1104}\u{1161}\u{11BF}",
        nfkc: "\u{B548}",
        nfkd: "\u{1104}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B549}",
        nfc: "\u{B549}",
        nfd: "\u{1104}\u{1161}\u{11C0}",
        nfkc: "\u{B549}",
        nfkd: "\u{1104}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B54A}",
        nfc: "\u{B54A}",
        nfd: "\u{1104}\u{1161}\u{11C1}",
        nfkc: "\u{B54A}",
        nfkd: "\u{1104}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B54B}",
        nfc: "\u{B54B}",
        nfd: "\u{1104}\u{1161}\u{11C2}",
        nfkc: "\u{B54B}",
        nfkd: "\u{1104}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B54C}",
        nfc: "\u{B54C}",
        nfd: "\u{1104}\u{1162}",
        nfkc: "\u{B54C}",
        nfkd: "\u{1104}\u{1162}",
    },
    NormalizationTest {
        source: "\u{B54D}",
        nfc: "\u{B54D}",
        nfd: "\u{1104}\u{1162}\u{11A8}",
        nfkc: "\u{B54D}",
        nfkd: "\u{1104}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B54E}",
        nfc: "\u{B54E}",
        nfd: "\u{1104}\u{1162}\u{11A9}",
        nfkc: "\u{B54E}",
        nfkd: "\u{1104}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B54F}",
        nfc: "\u{B54F}",
        nfd: "\u{1104}\u{1162}\u{11AA}",
        nfkc: "\u{B54F}",
        nfkd: "\u{1104}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B550}",
        nfc: "\u{B550}",
        nfd: "\u{1104}\u{1162}\u{11AB}",
        nfkc: "\u{B550}",
        nfkd: "\u{1104}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B551}",
        nfc: "\u{B551}",
        nfd: "\u{1104}\u{1162}\u{11AC}",
        nfkc: "\u{B551}",
        nfkd: "\u{1104}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B552}",
        nfc: "\u{B552}",
        nfd: "\u{1104}\u{1162}\u{11AD}",
        nfkc: "\u{B552}",
        nfkd: "\u{1104}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B553}",
        nfc: "\u{B553}",
        nfd: "\u{1104}\u{1162}\u{11AE}",
        nfkc: "\u{B553}",
        nfkd: "\u{1104}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B554}",
        nfc: "\u{B554}",
        nfd: "\u{1104}\u{1162}\u{11AF}",
        nfkc: "\u{B554}",
        nfkd: "\u{1104}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B555}",
        nfc: "\u{B555}",
        nfd: "\u{1104}\u{1162}\u{11B0}",
        nfkc: "\u{B555}",
        nfkd: "\u{1104}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B556}",
        nfc: "\u{B556}",
        nfd: "\u{1104}\u{1162}\u{11B1}",
        nfkc: "\u{B556}",
        nfkd: "\u{1104}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B557}",
        nfc: "\u{B557}",
        nfd: "\u{1104}\u{1162}\u{11B2}",
        nfkc: "\u{B557}",
        nfkd: "\u{1104}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B558}",
        nfc: "\u{B558}",
        nfd: "\u{1104}\u{1162}\u{11B3}",
        nfkc: "\u{B558}",
        nfkd: "\u{1104}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B559}",
        nfc: "\u{B559}",
        nfd: "\u{1104}\u{1162}\u{11B4}",
        nfkc: "\u{B559}",
        nfkd: "\u{1104}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B55A}",
        nfc: "\u{B55A}",
        nfd: "\u{1104}\u{1162}\u{11B5}",
        nfkc: "\u{B55A}",
        nfkd: "\u{1104}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B55B}",
        nfc: "\u{B55B}",
        nfd: "\u{1104}\u{1162}\u{11B6}",
        nfkc: "\u{B55B}",
        nfkd: "\u{1104}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B55C}",
        nfc: "\u{B55C}",
        nfd: "\u{1104}\u{1162}\u{11B7}",
        nfkc: "\u{B55C}",
        nfkd: "\u{1104}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B55D}",
        nfc: "\u{B55D}",
        nfd: "\u{1104}\u{1162}\u{11B8}",
        nfkc: "\u{B55D}",
        nfkd: "\u{1104}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B55E}",
        nfc: "\u{B55E}",
        nfd: "\u{1104}\u{1162}\u{11B9}",
        nfkc: "\u{B55E}",
        nfkd: "\u{1104}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B55F}",
        nfc: "\u{B55F}",
        nfd: "\u{1104}\u{1162}\u{11BA}",
        nfkc: "\u{B55F}",
        nfkd: "\u{1104}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B560}",
        nfc: "\u{B560}",
        nfd: "\u{1104}\u{1162}\u{11BB}",
        nfkc: "\u{B560}",
        nfkd: "\u{1104}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B561}",
        nfc: "\u{B561}",
        nfd: "\u{1104}\u{1162}\u{11BC}",
        nfkc: "\u{B561}",
        nfkd: "\u{1104}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B562}",
        nfc: "\u{B562}",
        nfd: "\u{1104}\u{1162}\u{11BD}",
        nfkc: "\u{B562}",
        nfkd: "\u{1104}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B563}",
        nfc: "\u{B563}",
        nfd: "\u{1104}\u{1162}\u{11BE}",
        nfkc: "\u{B563}",
        nfkd: "\u{1104}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B564}",
        nfc: "\u{B564}",
        nfd: "\u{1104}\u{1162}\u{11BF}",
        nfkc: "\u{B564}",
        nfkd: "\u{1104}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B565}",
        nfc: "\u{B565}",
        nfd: "\u{1104}\u{1162}\u{11C0}",
        nfkc: "\u{B565}",
        nfkd: "\u{1104}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B566}",
        nfc: "\u{B566}",
        nfd: "\u{1104}\u{1162}\u{11C1}",
        nfkc: "\u{B566}",
        nfkd: "\u{1104}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B567}",
        nfc: "\u{B567}",
        nfd: "\u{1104}\u{1162}\u{11C2}",
        nfkc: "\u{B567}",
        nfkd: "\u{1104}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B568}",
        nfc: "\u{B568}",
        nfd: "\u{1104}\u{1163}",
        nfkc: "\u{B568}",
        nfkd: "\u{1104}\u{1163}",
    },
    NormalizationTest {
        source: "\u{B569}",
        nfc: "\u{B569}",
        nfd: "\u{1104}\u{1163}\u{11A8}",
        nfkc: "\u{B569}",
        nfkd: "\u{1104}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B56A}",
        nfc: "\u{B56A}",
        nfd: "\u{1104}\u{1163}\u{11A9}",
        nfkc: "\u{B56A}",
        nfkd: "\u{1104}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B56B}",
        nfc: "\u{B56B}",
        nfd: "\u{1104}\u{1163}\u{11AA}",
        nfkc: "\u{B56B}",
        nfkd: "\u{1104}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B56C}",
        nfc: "\u{B56C}",
        nfd: "\u{1104}\u{1163}\u{11AB}",
        nfkc: "\u{B56C}",
        nfkd: "\u{1104}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B56D}",
        nfc: "\u{B56D}",
        nfd: "\u{1104}\u{1163}\u{11AC}",
        nfkc: "\u{B56D}",
        nfkd: "\u{1104}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B56E}",
        nfc: "\u{B56E}",
        nfd: "\u{1104}\u{1163}\u{11AD}",
        nfkc: "\u{B56E}",
        nfkd: "\u{1104}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B56F}",
        nfc: "\u{B56F}",
        nfd: "\u{1104}\u{1163}\u{11AE}",
        nfkc: "\u{B56F}",
        nfkd: "\u{1104}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B570}",
        nfc: "\u{B570}",
        nfd: "\u{1104}\u{1163}\u{11AF}",
        nfkc: "\u{B570}",
        nfkd: "\u{1104}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B571}",
        nfc: "\u{B571}",
        nfd: "\u{1104}\u{1163}\u{11B0}",
        nfkc: "\u{B571}",
        nfkd: "\u{1104}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B572}",
        nfc: "\u{B572}",
        nfd: "\u{1104}\u{1163}\u{11B1}",
        nfkc: "\u{B572}",
        nfkd: "\u{1104}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B573}",
        nfc: "\u{B573}",
        nfd: "\u{1104}\u{1163}\u{11B2}",
        nfkc: "\u{B573}",
        nfkd: "\u{1104}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B574}",
        nfc: "\u{B574}",
        nfd: "\u{1104}\u{1163}\u{11B3}",
        nfkc: "\u{B574}",
        nfkd: "\u{1104}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B575}",
        nfc: "\u{B575}",
        nfd: "\u{1104}\u{1163}\u{11B4}",
        nfkc: "\u{B575}",
        nfkd: "\u{1104}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B576}",
        nfc: "\u{B576}",
        nfd: "\u{1104}\u{1163}\u{11B5}",
        nfkc: "\u{B576}",
        nfkd: "\u{1104}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B577}",
        nfc: "\u{B577}",
        nfd: "\u{1104}\u{1163}\u{11B6}",
        nfkc: "\u{B577}",
        nfkd: "\u{1104}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B578}",
        nfc: "\u{B578}",
        nfd: "\u{1104}\u{1163}\u{11B7}",
        nfkc: "\u{B578}",
        nfkd: "\u{1104}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B579}",
        nfc: "\u{B579}",
        nfd: "\u{1104}\u{1163}\u{11B8}",
        nfkc: "\u{B579}",
        nfkd: "\u{1104}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B57A}",
        nfc: "\u{B57A}",
        nfd: "\u{1104}\u{1163}\u{11B9}",
        nfkc: "\u{B57A}",
        nfkd: "\u{1104}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B57B}",
        nfc: "\u{B57B}",
        nfd: "\u{1104}\u{1163}\u{11BA}",
        nfkc: "\u{B57B}",
        nfkd: "\u{1104}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B57C}",
        nfc: "\u{B57C}",
        nfd: "\u{1104}\u{1163}\u{11BB}",
        nfkc: "\u{B57C}",
        nfkd: "\u{1104}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B57D}",
        nfc: "\u{B57D}",
        nfd: "\u{1104}\u{1163}\u{11BC}",
        nfkc: "\u{B57D}",
        nfkd: "\u{1104}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B57E}",
        nfc: "\u{B57E}",
        nfd: "\u{1104}\u{1163}\u{11BD}",
        nfkc: "\u{B57E}",
        nfkd: "\u{1104}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B57F}",
        nfc: "\u{B57F}",
        nfd: "\u{1104}\u{1163}\u{11BE}",
        nfkc: "\u{B57F}",
        nfkd: "\u{1104}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B580}",
        nfc: "\u{B580}",
        nfd: "\u{1104}\u{1163}\u{11BF}",
        nfkc: "\u{B580}",
        nfkd: "\u{1104}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B581}",
        nfc: "\u{B581}",
        nfd: "\u{1104}\u{1163}\u{11C0}",
        nfkc: "\u{B581}",
        nfkd: "\u{1104}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B582}",
        nfc: "\u{B582}",
        nfd: "\u{1104}\u{1163}\u{11C1}",
        nfkc: "\u{B582}",
        nfkd: "\u{1104}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B583}",
        nfc: "\u{B583}",
        nfd: "\u{1104}\u{1163}\u{11C2}",
        nfkc: "\u{B583}",
        nfkd: "\u{1104}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B584}",
        nfc: "\u{B584}",
        nfd: "\u{1104}\u{1164}",
        nfkc: "\u{B584}",
        nfkd: "\u{1104}\u{1164}",
    },
    NormalizationTest {
        source: "\u{B585}",
        nfc: "\u{B585}",
        nfd: "\u{1104}\u{1164}\u{11A8}",
        nfkc: "\u{B585}",
        nfkd: "\u{1104}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B586}",
        nfc: "\u{B586}",
        nfd: "\u{1104}\u{1164}\u{11A9}",
        nfkc: "\u{B586}",
        nfkd: "\u{1104}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B587}",
        nfc: "\u{B587}",
        nfd: "\u{1104}\u{1164}\u{11AA}",
        nfkc: "\u{B587}",
        nfkd: "\u{1104}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B588}",
        nfc: "\u{B588}",
        nfd: "\u{1104}\u{1164}\u{11AB}",
        nfkc: "\u{B588}",
        nfkd: "\u{1104}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B589}",
        nfc: "\u{B589}",
        nfd: "\u{1104}\u{1164}\u{11AC}",
        nfkc: "\u{B589}",
        nfkd: "\u{1104}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B58A}",
        nfc: "\u{B58A}",
        nfd: "\u{1104}\u{1164}\u{11AD}",
        nfkc: "\u{B58A}",
        nfkd: "\u{1104}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B58B}",
        nfc: "\u{B58B}",
        nfd: "\u{1104}\u{1164}\u{11AE}",
        nfkc: "\u{B58B}",
        nfkd: "\u{1104}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B58C}",
        nfc: "\u{B58C}",
        nfd: "\u{1104}\u{1164}\u{11AF}",
        nfkc: "\u{B58C}",
        nfkd: "\u{1104}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B58D}",
        nfc: "\u{B58D}",
        nfd: "\u{1104}\u{1164}\u{11B0}",
        nfkc: "\u{B58D}",
        nfkd: "\u{1104}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B58E}",
        nfc: "\u{B58E}",
        nfd: "\u{1104}\u{1164}\u{11B1}",
        nfkc: "\u{B58E}",
        nfkd: "\u{1104}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B58F}",
        nfc: "\u{B58F}",
        nfd: "\u{1104}\u{1164}\u{11B2}",
        nfkc: "\u{B58F}",
        nfkd: "\u{1104}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B590}",
        nfc: "\u{B590}",
        nfd: "\u{1104}\u{1164}\u{11B3}",
        nfkc: "\u{B590}",
        nfkd: "\u{1104}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B591}",
        nfc: "\u{B591}",
        nfd: "\u{1104}\u{1164}\u{11B4}",
        nfkc: "\u{B591}",
        nfkd: "\u{1104}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B592}",
        nfc: "\u{B592}",
        nfd: "\u{1104}\u{1164}\u{11B5}",
        nfkc: "\u{B592}",
        nfkd: "\u{1104}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B593}",
        nfc: "\u{B593}",
        nfd: "\u{1104}\u{1164}\u{11B6}",
        nfkc: "\u{B593}",
        nfkd: "\u{1104}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B594}",
        nfc: "\u{B594}",
        nfd: "\u{1104}\u{1164}\u{11B7}",
        nfkc: "\u{B594}",
        nfkd: "\u{1104}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B595}",
        nfc: "\u{B595}",
        nfd: "\u{1104}\u{1164}\u{11B8}",
        nfkc: "\u{B595}",
        nfkd: "\u{1104}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B596}",
        nfc: "\u{B596}",
        nfd: "\u{1104}\u{1164}\u{11B9}",
        nfkc: "\u{B596}",
        nfkd: "\u{1104}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B597}",
        nfc: "\u{B597}",
        nfd: "\u{1104}\u{1164}\u{11BA}",
        nfkc: "\u{B597}",
        nfkd: "\u{1104}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B598}",
        nfc: "\u{B598}",
        nfd: "\u{1104}\u{1164}\u{11BB}",
        nfkc: "\u{B598}",
        nfkd: "\u{1104}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B599}",
        nfc: "\u{B599}",
        nfd: "\u{1104}\u{1164}\u{11BC}",
        nfkc: "\u{B599}",
        nfkd: "\u{1104}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B59A}",
        nfc: "\u{B59A}",
        nfd: "\u{1104}\u{1164}\u{11BD}",
        nfkc: "\u{B59A}",
        nfkd: "\u{1104}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B59B}",
        nfc: "\u{B59B}",
        nfd: "\u{1104}\u{1164}\u{11BE}",
        nfkc: "\u{B59B}",
        nfkd: "\u{1104}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B59C}",
        nfc: "\u{B59C}",
        nfd: "\u{1104}\u{1164}\u{11BF}",
        nfkc: "\u{B59C}",
        nfkd: "\u{1104}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B59D}",
        nfc: "\u{B59D}",
        nfd: "\u{1104}\u{1164}\u{11C0}",
        nfkc: "\u{B59D}",
        nfkd: "\u{1104}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B59E}",
        nfc: "\u{B59E}",
        nfd: "\u{1104}\u{1164}\u{11C1}",
        nfkc: "\u{B59E}",
        nfkd: "\u{1104}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B59F}",
        nfc: "\u{B59F}",
        nfd: "\u{1104}\u{1164}\u{11C2}",
        nfkc: "\u{B59F}",
        nfkd: "\u{1104}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B5A0}",
        nfc: "\u{B5A0}",
        nfd: "\u{1104}\u{1165}",
        nfkc: "\u{B5A0}",
        nfkd: "\u{1104}\u{1165}",
    },
    NormalizationTest {
        source: "\u{B5A1}",
        nfc: "\u{B5A1}",
        nfd: "\u{1104}\u{1165}\u{11A8}",
        nfkc: "\u{B5A1}",
        nfkd: "\u{1104}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B5A2}",
        nfc: "\u{B5A2}",
        nfd: "\u{1104}\u{1165}\u{11A9}",
        nfkc: "\u{B5A2}",
        nfkd: "\u{1104}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B5A3}",
        nfc: "\u{B5A3}",
        nfd: "\u{1104}\u{1165}\u{11AA}",
        nfkc: "\u{B5A3}",
        nfkd: "\u{1104}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B5A4}",
        nfc: "\u{B5A4}",
        nfd: "\u{1104}\u{1165}\u{11AB}",
        nfkc: "\u{B5A4}",
        nfkd: "\u{1104}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B5A5}",
        nfc: "\u{B5A5}",
        nfd: "\u{1104}\u{1165}\u{11AC}",
        nfkc: "\u{B5A5}",
        nfkd: "\u{1104}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B5A6}",
        nfc: "\u{B5A6}",
        nfd: "\u{1104}\u{1165}\u{11AD}",
        nfkc: "\u{B5A6}",
        nfkd: "\u{1104}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B5A7}",
        nfc: "\u{B5A7}",
        nfd: "\u{1104}\u{1165}\u{11AE}",
        nfkc: "\u{B5A7}",
        nfkd: "\u{1104}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B5A8}",
        nfc: "\u{B5A8}",
        nfd: "\u{1104}\u{1165}\u{11AF}",
        nfkc: "\u{B5A8}",
        nfkd: "\u{1104}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B5A9}",
        nfc: "\u{B5A9}",
        nfd: "\u{1104}\u{1165}\u{11B0}",
        nfkc: "\u{B5A9}",
        nfkd: "\u{1104}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B5AA}",
        nfc: "\u{B5AA}",
        nfd: "\u{1104}\u{1165}\u{11B1}",
        nfkc: "\u{B5AA}",
        nfkd: "\u{1104}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B5AB}",
        nfc: "\u{B5AB}",
        nfd: "\u{1104}\u{1165}\u{11B2}",
        nfkc: "\u{B5AB}",
        nfkd: "\u{1104}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B5AC}",
        nfc: "\u{B5AC}",
        nfd: "\u{1104}\u{1165}\u{11B3}",
        nfkc: "\u{B5AC}",
        nfkd: "\u{1104}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B5AD}",
        nfc: "\u{B5AD}",
        nfd: "\u{1104}\u{1165}\u{11B4}",
        nfkc: "\u{B5AD}",
        nfkd: "\u{1104}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B5AE}",
        nfc: "\u{B5AE}",
        nfd: "\u{1104}\u{1165}\u{11B5}",
        nfkc: "\u{B5AE}",
        nfkd: "\u{1104}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B5AF}",
        nfc: "\u{B5AF}",
        nfd: "\u{1104}\u{1165}\u{11B6}",
        nfkc: "\u{B5AF}",
        nfkd: "\u{1104}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B5B0}",
        nfc: "\u{B5B0}",
        nfd: "\u{1104}\u{1165}\u{11B7}",
        nfkc: "\u{B5B0}",
        nfkd: "\u{1104}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B5B1}",
        nfc: "\u{B5B1}",
        nfd: "\u{1104}\u{1165}\u{11B8}",
        nfkc: "\u{B5B1}",
        nfkd: "\u{1104}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B5B2}",
        nfc: "\u{B5B2}",
        nfd: "\u{1104}\u{1165}\u{11B9}",
        nfkc: "\u{B5B2}",
        nfkd: "\u{1104}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B5B3}",
        nfc: "\u{B5B3}",
        nfd: "\u{1104}\u{1165}\u{11BA}",
        nfkc: "\u{B5B3}",
        nfkd: "\u{1104}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B5B4}",
        nfc: "\u{B5B4}",
        nfd: "\u{1104}\u{1165}\u{11BB}",
        nfkc: "\u{B5B4}",
        nfkd: "\u{1104}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B5B5}",
        nfc: "\u{B5B5}",
        nfd: "\u{1104}\u{1165}\u{11BC}",
        nfkc: "\u{B5B5}",
        nfkd: "\u{1104}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B5B6}",
        nfc: "\u{B5B6}",
        nfd: "\u{1104}\u{1165}\u{11BD}",
        nfkc: "\u{B5B6}",
        nfkd: "\u{1104}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B5B7}",
        nfc: "\u{B5B7}",
        nfd: "\u{1104}\u{1165}\u{11BE}",
        nfkc: "\u{B5B7}",
        nfkd: "\u{1104}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B5B8}",
        nfc: "\u{B5B8}",
        nfd: "\u{1104}\u{1165}\u{11BF}",
        nfkc: "\u{B5B8}",
        nfkd: "\u{1104}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B5B9}",
        nfc: "\u{B5B9}",
        nfd: "\u{1104}\u{1165}\u{11C0}",
        nfkc: "\u{B5B9}",
        nfkd: "\u{1104}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B5BA}",
        nfc: "\u{B5BA}",
        nfd: "\u{1104}\u{1165}\u{11C1}",
        nfkc: "\u{B5BA}",
        nfkd: "\u{1104}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B5BB}",
        nfc: "\u{B5BB}",
        nfd: "\u{1104}\u{1165}\u{11C2}",
        nfkc: "\u{B5BB}",
        nfkd: "\u{1104}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B5BC}",
        nfc: "\u{B5BC}",
        nfd: "\u{1104}\u{1166}",
        nfkc: "\u{B5BC}",
        nfkd: "\u{1104}\u{1166}",
    },
    NormalizationTest {
        source: "\u{B5BD}",
        nfc: "\u{B5BD}",
        nfd: "\u{1104}\u{1166}\u{11A8}",
        nfkc: "\u{B5BD}",
        nfkd: "\u{1104}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B5BE}",
        nfc: "\u{B5BE}",
        nfd: "\u{1104}\u{1166}\u{11A9}",
        nfkc: "\u{B5BE}",
        nfkd: "\u{1104}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B5BF}",
        nfc: "\u{B5BF}",
        nfd: "\u{1104}\u{1166}\u{11AA}",
        nfkc: "\u{B5BF}",
        nfkd: "\u{1104}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B5C0}",
        nfc: "\u{B5C0}",
        nfd: "\u{1104}\u{1166}\u{11AB}",
        nfkc: "\u{B5C0}",
        nfkd: "\u{1104}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B5C1}",
        nfc: "\u{B5C1}",
        nfd: "\u{1104}\u{1166}\u{11AC}",
        nfkc: "\u{B5C1}",
        nfkd: "\u{1104}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B5C2}",
        nfc: "\u{B5C2}",
        nfd: "\u{1104}\u{1166}\u{11AD}",
        nfkc: "\u{B5C2}",
        nfkd: "\u{1104}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B5C3}",
        nfc: "\u{B5C3}",
        nfd: "\u{1104}\u{1166}\u{11AE}",
        nfkc: "\u{B5C3}",
        nfkd: "\u{1104}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B5C4}",
        nfc: "\u{B5C4}",
        nfd: "\u{1104}\u{1166}\u{11AF}",
        nfkc: "\u{B5C4}",
        nfkd: "\u{1104}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B5C5}",
        nfc: "\u{B5C5}",
        nfd: "\u{1104}\u{1166}\u{11B0}",
        nfkc: "\u{B5C5}",
        nfkd: "\u{1104}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B5C6}",
        nfc: "\u{B5C6}",
        nfd: "\u{1104}\u{1166}\u{11B1}",
        nfkc: "\u{B5C6}",
        nfkd: "\u{1104}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B5C7}",
        nfc: "\u{B5C7}",
        nfd: "\u{1104}\u{1166}\u{11B2}",
        nfkc: "\u{B5C7}",
        nfkd: "\u{1104}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B5C8}",
        nfc: "\u{B5C8}",
        nfd: "\u{1104}\u{1166}\u{11B3}",
        nfkc: "\u{B5C8}",
        nfkd: "\u{1104}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B5C9}",
        nfc: "\u{B5C9}",
        nfd: "\u{1104}\u{1166}\u{11B4}",
        nfkc: "\u{B5C9}",
        nfkd: "\u{1104}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B5CA}",
        nfc: "\u{B5CA}",
        nfd: "\u{1104}\u{1166}\u{11B5}",
        nfkc: "\u{B5CA}",
        nfkd: "\u{1104}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B5CB}",
        nfc: "\u{B5CB}",
        nfd: "\u{1104}\u{1166}\u{11B6}",
        nfkc: "\u{B5CB}",
        nfkd: "\u{1104}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B5CC}",
        nfc: "\u{B5CC}",
        nfd: "\u{1104}\u{1166}\u{11B7}",
        nfkc: "\u{B5CC}",
        nfkd: "\u{1104}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B5CD}",
        nfc: "\u{B5CD}",
        nfd: "\u{1104}\u{1166}\u{11B8}",
        nfkc: "\u{B5CD}",
        nfkd: "\u{1104}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B5CE}",
        nfc: "\u{B5CE}",
        nfd: "\u{1104}\u{1166}\u{11B9}",
        nfkc: "\u{B5CE}",
        nfkd: "\u{1104}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B5CF}",
        nfc: "\u{B5CF}",
        nfd: "\u{1104}\u{1166}\u{11BA}",
        nfkc: "\u{B5CF}",
        nfkd: "\u{1104}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B5D0}",
        nfc: "\u{B5D0}",
        nfd: "\u{1104}\u{1166}\u{11BB}",
        nfkc: "\u{B5D0}",
        nfkd: "\u{1104}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B5D1}",
        nfc: "\u{B5D1}",
        nfd: "\u{1104}\u{1166}\u{11BC}",
        nfkc: "\u{B5D1}",
        nfkd: "\u{1104}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B5D2}",
        nfc: "\u{B5D2}",
        nfd: "\u{1104}\u{1166}\u{11BD}",
        nfkc: "\u{B5D2}",
        nfkd: "\u{1104}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B5D3}",
        nfc: "\u{B5D3}",
        nfd: "\u{1104}\u{1166}\u{11BE}",
        nfkc: "\u{B5D3}",
        nfkd: "\u{1104}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B5D4}",
        nfc: "\u{B5D4}",
        nfd: "\u{1104}\u{1166}\u{11BF}",
        nfkc: "\u{B5D4}",
        nfkd: "\u{1104}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B5D5}",
        nfc: "\u{B5D5}",
        nfd: "\u{1104}\u{1166}\u{11C0}",
        nfkc: "\u{B5D5}",
        nfkd: "\u{1104}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B5D6}",
        nfc: "\u{B5D6}",
        nfd: "\u{1104}\u{1166}\u{11C1}",
        nfkc: "\u{B5D6}",
        nfkd: "\u{1104}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B5D7}",
        nfc: "\u{B5D7}",
        nfd: "\u{1104}\u{1166}\u{11C2}",
        nfkc: "\u{B5D7}",
        nfkd: "\u{1104}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B5D8}",
        nfc: "\u{B5D8}",
        nfd: "\u{1104}\u{1167}",
        nfkc: "\u{B5D8}",
        nfkd: "\u{1104}\u{1167}",
    },
    NormalizationTest {
        source: "\u{B5D9}",
        nfc: "\u{B5D9}",
        nfd: "\u{1104}\u{1167}\u{11A8}",
        nfkc: "\u{B5D9}",
        nfkd: "\u{1104}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B5DA}",
        nfc: "\u{B5DA}",
        nfd: "\u{1104}\u{1167}\u{11A9}",
        nfkc: "\u{B5DA}",
        nfkd: "\u{1104}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B5DB}",
        nfc: "\u{B5DB}",
        nfd: "\u{1104}\u{1167}\u{11AA}",
        nfkc: "\u{B5DB}",
        nfkd: "\u{1104}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B5DC}",
        nfc: "\u{B5DC}",
        nfd: "\u{1104}\u{1167}\u{11AB}",
        nfkc: "\u{B5DC}",
        nfkd: "\u{1104}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B5DD}",
        nfc: "\u{B5DD}",
        nfd: "\u{1104}\u{1167}\u{11AC}",
        nfkc: "\u{B5DD}",
        nfkd: "\u{1104}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B5DE}",
        nfc: "\u{B5DE}",
        nfd: "\u{1104}\u{1167}\u{11AD}",
        nfkc: "\u{B5DE}",
        nfkd: "\u{1104}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B5DF}",
        nfc: "\u{B5DF}",
        nfd: "\u{1104}\u{1167}\u{11AE}",
        nfkc: "\u{B5DF}",
        nfkd: "\u{1104}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B5E0}",
        nfc: "\u{B5E0}",
        nfd: "\u{1104}\u{1167}\u{11AF}",
        nfkc: "\u{B5E0}",
        nfkd: "\u{1104}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B5E1}",
        nfc: "\u{B5E1}",
        nfd: "\u{1104}\u{1167}\u{11B0}",
        nfkc: "\u{B5E1}",
        nfkd: "\u{1104}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B5E2}",
        nfc: "\u{B5E2}",
        nfd: "\u{1104}\u{1167}\u{11B1}",
        nfkc: "\u{B5E2}",
        nfkd: "\u{1104}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B5E3}",
        nfc: "\u{B5E3}",
        nfd: "\u{1104}\u{1167}\u{11B2}",
        nfkc: "\u{B5E3}",
        nfkd: "\u{1104}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B5E4}",
        nfc: "\u{B5E4}",
        nfd: "\u{1104}\u{1167}\u{11B3}",
        nfkc: "\u{B5E4}",
        nfkd: "\u{1104}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B5E5}",
        nfc: "\u{B5E5}",
        nfd: "\u{1104}\u{1167}\u{11B4}",
        nfkc: "\u{B5E5}",
        nfkd: "\u{1104}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B5E6}",
        nfc: "\u{B5E6}",
        nfd: "\u{1104}\u{1167}\u{11B5}",
        nfkc: "\u{B5E6}",
        nfkd: "\u{1104}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B5E7}",
        nfc: "\u{B5E7}",
        nfd: "\u{1104}\u{1167}\u{11B6}",
        nfkc: "\u{B5E7}",
        nfkd: "\u{1104}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B5E8}",
        nfc: "\u{B5E8}",
        nfd: "\u{1104}\u{1167}\u{11B7}",
        nfkc: "\u{B5E8}",
        nfkd: "\u{1104}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B5E9}",
        nfc: "\u{B5E9}",
        nfd: "\u{1104}\u{1167}\u{11B8}",
        nfkc: "\u{B5E9}",
        nfkd: "\u{1104}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B5EA}",
        nfc: "\u{B5EA}",
        nfd: "\u{1104}\u{1167}\u{11B9}",
        nfkc: "\u{B5EA}",
        nfkd: "\u{1104}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B5EB}",
        nfc: "\u{B5EB}",
        nfd: "\u{1104}\u{1167}\u{11BA}",
        nfkc: "\u{B5EB}",
        nfkd: "\u{1104}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B5EC}",
        nfc: "\u{B5EC}",
        nfd: "\u{1104}\u{1167}\u{11BB}",
        nfkc: "\u{B5EC}",
        nfkd: "\u{1104}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B5ED}",
        nfc: "\u{B5ED}",
        nfd: "\u{1104}\u{1167}\u{11BC}",
        nfkc: "\u{B5ED}",
        nfkd: "\u{1104}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B5EE}",
        nfc: "\u{B5EE}",
        nfd: "\u{1104}\u{1167}\u{11BD}",
        nfkc: "\u{B5EE}",
        nfkd: "\u{1104}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B5EF}",
        nfc: "\u{B5EF}",
        nfd: "\u{1104}\u{1167}\u{11BE}",
        nfkc: "\u{B5EF}",
        nfkd: "\u{1104}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B5F0}",
        nfc: "\u{B5F0}",
        nfd: "\u{1104}\u{1167}\u{11BF}",
        nfkc: "\u{B5F0}",
        nfkd: "\u{1104}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B5F1}",
        nfc: "\u{B5F1}",
        nfd: "\u{1104}\u{1167}\u{11C0}",
        nfkc: "\u{B5F1}",
        nfkd: "\u{1104}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B5F2}",
        nfc: "\u{B5F2}",
        nfd: "\u{1104}\u{1167}\u{11C1}",
        nfkc: "\u{B5F2}",
        nfkd: "\u{1104}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B5F3}",
        nfc: "\u{B5F3}",
        nfd: "\u{1104}\u{1167}\u{11C2}",
        nfkc: "\u{B5F3}",
        nfkd: "\u{1104}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B5F4}",
        nfc: "\u{B5F4}",
        nfd: "\u{1104}\u{1168}",
        nfkc: "\u{B5F4}",
        nfkd: "\u{1104}\u{1168}",
    },
    NormalizationTest {
        source: "\u{B5F5}",
        nfc: "\u{B5F5}",
        nfd: "\u{1104}\u{1168}\u{11A8}",
        nfkc: "\u{B5F5}",
        nfkd: "\u{1104}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B5F6}",
        nfc: "\u{B5F6}",
        nfd: "\u{1104}\u{1168}\u{11A9}",
        nfkc: "\u{B5F6}",
        nfkd: "\u{1104}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B5F7}",
        nfc: "\u{B5F7}",
        nfd: "\u{1104}\u{1168}\u{11AA}",
        nfkc: "\u{B5F7}",
        nfkd: "\u{1104}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B5F8}",
        nfc: "\u{B5F8}",
        nfd: "\u{1104}\u{1168}\u{11AB}",
        nfkc: "\u{B5F8}",
        nfkd: "\u{1104}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B5F9}",
        nfc: "\u{B5F9}",
        nfd: "\u{1104}\u{1168}\u{11AC}",
        nfkc: "\u{B5F9}",
        nfkd: "\u{1104}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B5FA}",
        nfc: "\u{B5FA}",
        nfd: "\u{1104}\u{1168}\u{11AD}",
        nfkc: "\u{B5FA}",
        nfkd: "\u{1104}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B5FB}",
        nfc: "\u{B5FB}",
        nfd: "\u{1104}\u{1168}\u{11AE}",
        nfkc: "\u{B5FB}",
        nfkd: "\u{1104}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B5FC}",
        nfc: "\u{B5FC}",
        nfd: "\u{1104}\u{1168}\u{11AF}",
        nfkc: "\u{B5FC}",
        nfkd: "\u{1104}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B5FD}",
        nfc: "\u{B5FD}",
        nfd: "\u{1104}\u{1168}\u{11B0}",
        nfkc: "\u{B5FD}",
        nfkd: "\u{1104}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B5FE}",
        nfc: "\u{B5FE}",
        nfd: "\u{1104}\u{1168}\u{11B1}",
        nfkc: "\u{B5FE}",
        nfkd: "\u{1104}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B5FF}",
        nfc: "\u{B5FF}",
        nfd: "\u{1104}\u{1168}\u{11B2}",
        nfkc: "\u{B5FF}",
        nfkd: "\u{1104}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B600}",
        nfc: "\u{B600}",
        nfd: "\u{1104}\u{1168}\u{11B3}",
        nfkc: "\u{B600}",
        nfkd: "\u{1104}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B601}",
        nfc: "\u{B601}",
        nfd: "\u{1104}\u{1168}\u{11B4}",
        nfkc: "\u{B601}",
        nfkd: "\u{1104}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B602}",
        nfc: "\u{B602}",
        nfd: "\u{1104}\u{1168}\u{11B5}",
        nfkc: "\u{B602}",
        nfkd: "\u{1104}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B603}",
        nfc: "\u{B603}",
        nfd: "\u{1104}\u{1168}\u{11B6}",
        nfkc: "\u{B603}",
        nfkd: "\u{1104}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B604}",
        nfc: "\u{B604}",
        nfd: "\u{1104}\u{1168}\u{11B7}",
        nfkc: "\u{B604}",
        nfkd: "\u{1104}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B605}",
        nfc: "\u{B605}",
        nfd: "\u{1104}\u{1168}\u{11B8}",
        nfkc: "\u{B605}",
        nfkd: "\u{1104}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B606}",
        nfc: "\u{B606}",
        nfd: "\u{1104}\u{1168}\u{11B9}",
        nfkc: "\u{B606}",
        nfkd: "\u{1104}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B607}",
        nfc: "\u{B607}",
        nfd: "\u{1104}\u{1168}\u{11BA}",
        nfkc: "\u{B607}",
        nfkd: "\u{1104}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B608}",
        nfc: "\u{B608}",
        nfd: "\u{1104}\u{1168}\u{11BB}",
        nfkc: "\u{B608}",
        nfkd: "\u{1104}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B609}",
        nfc: "\u{B609}",
        nfd: "\u{1104}\u{1168}\u{11BC}",
        nfkc: "\u{B609}",
        nfkd: "\u{1104}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B60A}",
        nfc: "\u{B60A}",
        nfd: "\u{1104}\u{1168}\u{11BD}",
        nfkc: "\u{B60A}",
        nfkd: "\u{1104}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B60B}",
        nfc: "\u{B60B}",
        nfd: "\u{1104}\u{1168}\u{11BE}",
        nfkc: "\u{B60B}",
        nfkd: "\u{1104}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B60C}",
        nfc: "\u{B60C}",
        nfd: "\u{1104}\u{1168}\u{11BF}",
        nfkc: "\u{B60C}",
        nfkd: "\u{1104}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B60D}",
        nfc: "\u{B60D}",
        nfd: "\u{1104}\u{1168}\u{11C0}",
        nfkc: "\u{B60D}",
        nfkd: "\u{1104}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B60E}",
        nfc: "\u{B60E}",
        nfd: "\u{1104}\u{1168}\u{11C1}",
        nfkc: "\u{B60E}",
        nfkd: "\u{1104}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B60F}",
        nfc: "\u{B60F}",
        nfd: "\u{1104}\u{1168}\u{11C2}",
        nfkc: "\u{B60F}",
        nfkd: "\u{1104}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B610}",
        nfc: "\u{B610}",
        nfd: "\u{1104}\u{1169}",
        nfkc: "\u{B610}",
        nfkd: "\u{1104}\u{1169}",
    },
    NormalizationTest {
        source: "\u{B611}",
        nfc: "\u{B611}",
        nfd: "\u{1104}\u{1169}\u{11A8}",
        nfkc: "\u{B611}",
        nfkd: "\u{1104}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B612}",
        nfc: "\u{B612}",
        nfd: "\u{1104}\u{1169}\u{11A9}",
        nfkc: "\u{B612}",
        nfkd: "\u{1104}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B613}",
        nfc: "\u{B613}",
        nfd: "\u{1104}\u{1169}\u{11AA}",
        nfkc: "\u{B613}",
        nfkd: "\u{1104}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B614}",
        nfc: "\u{B614}",
        nfd: "\u{1104}\u{1169}\u{11AB}",
        nfkc: "\u{B614}",
        nfkd: "\u{1104}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B615}",
        nfc: "\u{B615}",
        nfd: "\u{1104}\u{1169}\u{11AC}",
        nfkc: "\u{B615}",
        nfkd: "\u{1104}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B616}",
        nfc: "\u{B616}",
        nfd: "\u{1104}\u{1169}\u{11AD}",
        nfkc: "\u{B616}",
        nfkd: "\u{1104}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B617}",
        nfc: "\u{B617}",
        nfd: "\u{1104}\u{1169}\u{11AE}",
        nfkc: "\u{B617}",
        nfkd: "\u{1104}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B618}",
        nfc: "\u{B618}",
        nfd: "\u{1104}\u{1169}\u{11AF}",
        nfkc: "\u{B618}",
        nfkd: "\u{1104}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B619}",
        nfc: "\u{B619}",
        nfd: "\u{1104}\u{1169}\u{11B0}",
        nfkc: "\u{B619}",
        nfkd: "\u{1104}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B61A}",
        nfc: "\u{B61A}",
        nfd: "\u{1104}\u{1169}\u{11B1}",
        nfkc: "\u{B61A}",
        nfkd: "\u{1104}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B61B}",
        nfc: "\u{B61B}",
        nfd: "\u{1104}\u{1169}\u{11B2}",
        nfkc: "\u{B61B}",
        nfkd: "\u{1104}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B61C}",
        nfc: "\u{B61C}",
        nfd: "\u{1104}\u{1169}\u{11B3}",
        nfkc: "\u{B61C}",
        nfkd: "\u{1104}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B61D}",
        nfc: "\u{B61D}",
        nfd: "\u{1104}\u{1169}\u{11B4}",
        nfkc: "\u{B61D}",
        nfkd: "\u{1104}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B61E}",
        nfc: "\u{B61E}",
        nfd: "\u{1104}\u{1169}\u{11B5}",
        nfkc: "\u{B61E}",
        nfkd: "\u{1104}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B61F}",
        nfc: "\u{B61F}",
        nfd: "\u{1104}\u{1169}\u{11B6}",
        nfkc: "\u{B61F}",
        nfkd: "\u{1104}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B620}",
        nfc: "\u{B620}",
        nfd: "\u{1104}\u{1169}\u{11B7}",
        nfkc: "\u{B620}",
        nfkd: "\u{1104}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B621}",
        nfc: "\u{B621}",
        nfd: "\u{1104}\u{1169}\u{11B8}",
        nfkc: "\u{B621}",
        nfkd: "\u{1104}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B622}",
        nfc: "\u{B622}",
        nfd: "\u{1104}\u{1169}\u{11B9}",
        nfkc: "\u{B622}",
        nfkd: "\u{1104}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B623}",
        nfc: "\u{B623}",
        nfd: "\u{1104}\u{1169}\u{11BA}",
        nfkc: "\u{B623}",
        nfkd: "\u{1104}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B624}",
        nfc: "\u{B624}",
        nfd: "\u{1104}\u{1169}\u{11BB}",
        nfkc: "\u{B624}",
        nfkd: "\u{1104}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B625}",
        nfc: "\u{B625}",
        nfd: "\u{1104}\u{1169}\u{11BC}",
        nfkc: "\u{B625}",
        nfkd: "\u{1104}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B626}",
        nfc: "\u{B626}",
        nfd: "\u{1104}\u{1169}\u{11BD}",
        nfkc: "\u{B626}",
        nfkd: "\u{1104}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B627}",
        nfc: "\u{B627}",
        nfd: "\u{1104}\u{1169}\u{11BE}",
        nfkc: "\u{B627}",
        nfkd: "\u{1104}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B628}",
        nfc: "\u{B628}",
        nfd: "\u{1104}\u{1169}\u{11BF}",
        nfkc: "\u{B628}",
        nfkd: "\u{1104}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B629}",
        nfc: "\u{B629}",
        nfd: "\u{1104}\u{1169}\u{11C0}",
        nfkc: "\u{B629}",
        nfkd: "\u{1104}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B62A}",
        nfc: "\u{B62A}",
        nfd: "\u{1104}\u{1169}\u{11C1}",
        nfkc: "\u{B62A}",
        nfkd: "\u{1104}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B62B}",
        nfc: "\u{B62B}",
        nfd: "\u{1104}\u{1169}\u{11C2}",
        nfkc: "\u{B62B}",
        nfkd: "\u{1104}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B62C}",
        nfc: "\u{B62C}",
        nfd: "\u{1104}\u{116A}",
        nfkc: "\u{B62C}",
        nfkd: "\u{1104}\u{116A}",
    },
    NormalizationTest {
        source: "\u{B62D}",
        nfc: "\u{B62D}",
        nfd: "\u{1104}\u{116A}\u{11A8}",
        nfkc: "\u{B62D}",
        nfkd: "\u{1104}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B62E}",
        nfc: "\u{B62E}",
        nfd: "\u{1104}\u{116A}\u{11A9}",
        nfkc: "\u{B62E}",
        nfkd: "\u{1104}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B62F}",
        nfc: "\u{B62F}",
        nfd: "\u{1104}\u{116A}\u{11AA}",
        nfkc: "\u{B62F}",
        nfkd: "\u{1104}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B630}",
        nfc: "\u{B630}",
        nfd: "\u{1104}\u{116A}\u{11AB}",
        nfkc: "\u{B630}",
        nfkd: "\u{1104}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B631}",
        nfc: "\u{B631}",
        nfd: "\u{1104}\u{116A}\u{11AC}",
        nfkc: "\u{B631}",
        nfkd: "\u{1104}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B632}",
        nfc: "\u{B632}",
        nfd: "\u{1104}\u{116A}\u{11AD}",
        nfkc: "\u{B632}",
        nfkd: "\u{1104}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B633}",
        nfc: "\u{B633}",
        nfd: "\u{1104}\u{116A}\u{11AE}",
        nfkc: "\u{B633}",
        nfkd: "\u{1104}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B634}",
        nfc: "\u{B634}",
        nfd: "\u{1104}\u{116A}\u{11AF}",
        nfkc: "\u{B634}",
        nfkd: "\u{1104}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B635}",
        nfc: "\u{B635}",
        nfd: "\u{1104}\u{116A}\u{11B0}",
        nfkc: "\u{B635}",
        nfkd: "\u{1104}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B636}",
        nfc: "\u{B636}",
        nfd: "\u{1104}\u{116A}\u{11B1}",
        nfkc: "\u{B636}",
        nfkd: "\u{1104}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B637}",
        nfc: "\u{B637}",
        nfd: "\u{1104}\u{116A}\u{11B2}",
        nfkc: "\u{B637}",
        nfkd: "\u{1104}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B638}",
        nfc: "\u{B638}",
        nfd: "\u{1104}\u{116A}\u{11B3}",
        nfkc: "\u{B638}",
        nfkd: "\u{1104}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B639}",
        nfc: "\u{B639}",
        nfd: "\u{1104}\u{116A}\u{11B4}",
        nfkc: "\u{B639}",
        nfkd: "\u{1104}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B63A}",
        nfc: "\u{B63A}",
        nfd: "\u{1104}\u{116A}\u{11B5}",
        nfkc: "\u{B63A}",
        nfkd: "\u{1104}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B63B}",
        nfc: "\u{B63B}",
        nfd: "\u{1104}\u{116A}\u{11B6}",
        nfkc: "\u{B63B}",
        nfkd: "\u{1104}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B63C}",
        nfc: "\u{B63C}",
        nfd: "\u{1104}\u{116A}\u{11B7}",
        nfkc: "\u{B63C}",
        nfkd: "\u{1104}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B63D}",
        nfc: "\u{B63D}",
        nfd: "\u{1104}\u{116A}\u{11B8}",
        nfkc: "\u{B63D}",
        nfkd: "\u{1104}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B63E}",
        nfc: "\u{B63E}",
        nfd: "\u{1104}\u{116A}\u{11B9}",
        nfkc: "\u{B63E}",
        nfkd: "\u{1104}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B63F}",
        nfc: "\u{B63F}",
        nfd: "\u{1104}\u{116A}\u{11BA}",
        nfkc: "\u{B63F}",
        nfkd: "\u{1104}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B640}",
        nfc: "\u{B640}",
        nfd: "\u{1104}\u{116A}\u{11BB}",
        nfkc: "\u{B640}",
        nfkd: "\u{1104}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B641}",
        nfc: "\u{B641}",
        nfd: "\u{1104}\u{116A}\u{11BC}",
        nfkc: "\u{B641}",
        nfkd: "\u{1104}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B642}",
        nfc: "\u{B642}",
        nfd: "\u{1104}\u{116A}\u{11BD}",
        nfkc: "\u{B642}",
        nfkd: "\u{1104}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B643}",
        nfc: "\u{B643}",
        nfd: "\u{1104}\u{116A}\u{11BE}",
        nfkc: "\u{B643}",
        nfkd: "\u{1104}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B644}",
        nfc: "\u{B644}",
        nfd: "\u{1104}\u{116A}\u{11BF}",
        nfkc: "\u{B644}",
        nfkd: "\u{1104}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B645}",
        nfc: "\u{B645}",
        nfd: "\u{1104}\u{116A}\u{11C0}",
        nfkc: "\u{B645}",
        nfkd: "\u{1104}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B646}",
        nfc: "\u{B646}",
        nfd: "\u{1104}\u{116A}\u{11C1}",
        nfkc: "\u{B646}",
        nfkd: "\u{1104}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B647}",
        nfc: "\u{B647}",
        nfd: "\u{1104}\u{116A}\u{11C2}",
        nfkc: "\u{B647}",
        nfkd: "\u{1104}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B648}",
        nfc: "\u{B648}",
        nfd: "\u{1104}\u{116B}",
        nfkc: "\u{B648}",
        nfkd: "\u{1104}\u{116B}",
    },
    NormalizationTest {
        source: "\u{B649}",
        nfc: "\u{B649}",
        nfd: "\u{1104}\u{116B}\u{11A8}",
        nfkc: "\u{B649}",
        nfkd: "\u{1104}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B64A}",
        nfc: "\u{B64A}",
        nfd: "\u{1104}\u{116B}\u{11A9}",
        nfkc: "\u{B64A}",
        nfkd: "\u{1104}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B64B}",
        nfc: "\u{B64B}",
        nfd: "\u{1104}\u{116B}\u{11AA}",
        nfkc: "\u{B64B}",
        nfkd: "\u{1104}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B64C}",
        nfc: "\u{B64C}",
        nfd: "\u{1104}\u{116B}\u{11AB}",
        nfkc: "\u{B64C}",
        nfkd: "\u{1104}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B64D}",
        nfc: "\u{B64D}",
        nfd: "\u{1104}\u{116B}\u{11AC}",
        nfkc: "\u{B64D}",
        nfkd: "\u{1104}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B64E}",
        nfc: "\u{B64E}",
        nfd: "\u{1104}\u{116B}\u{11AD}",
        nfkc: "\u{B64E}",
        nfkd: "\u{1104}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B64F}",
        nfc: "\u{B64F}",
        nfd: "\u{1104}\u{116B}\u{11AE}",
        nfkc: "\u{B64F}",
        nfkd: "\u{1104}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B650}",
        nfc: "\u{B650}",
        nfd: "\u{1104}\u{116B}\u{11AF}",
        nfkc: "\u{B650}",
        nfkd: "\u{1104}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B651}",
        nfc: "\u{B651}",
        nfd: "\u{1104}\u{116B}\u{11B0}",
        nfkc: "\u{B651}",
        nfkd: "\u{1104}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B652}",
        nfc: "\u{B652}",
        nfd: "\u{1104}\u{116B}\u{11B1}",
        nfkc: "\u{B652}",
        nfkd: "\u{1104}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B653}",
        nfc: "\u{B653}",
        nfd: "\u{1104}\u{116B}\u{11B2}",
        nfkc: "\u{B653}",
        nfkd: "\u{1104}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B654}",
        nfc: "\u{B654}",
        nfd: "\u{1104}\u{116B}\u{11B3}",
        nfkc: "\u{B654}",
        nfkd: "\u{1104}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B655}",
        nfc: "\u{B655}",
        nfd: "\u{1104}\u{116B}\u{11B4}",
        nfkc: "\u{B655}",
        nfkd: "\u{1104}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B656}",
        nfc: "\u{B656}",
        nfd: "\u{1104}\u{116B}\u{11B5}",
        nfkc: "\u{B656}",
        nfkd: "\u{1104}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B657}",
        nfc: "\u{B657}",
        nfd: "\u{1104}\u{116B}\u{11B6}",
        nfkc: "\u{B657}",
        nfkd: "\u{1104}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B658}",
        nfc: "\u{B658}",
        nfd: "\u{1104}\u{116B}\u{11B7}",
        nfkc: "\u{B658}",
        nfkd: "\u{1104}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B659}",
        nfc: "\u{B659}",
        nfd: "\u{1104}\u{116B}\u{11B8}",
        nfkc: "\u{B659}",
        nfkd: "\u{1104}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B65A}",
        nfc: "\u{B65A}",
        nfd: "\u{1104}\u{116B}\u{11B9}",
        nfkc: "\u{B65A}",
        nfkd: "\u{1104}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B65B}",
        nfc: "\u{B65B}",
        nfd: "\u{1104}\u{116B}\u{11BA}",
        nfkc: "\u{B65B}",
        nfkd: "\u{1104}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B65C}",
        nfc: "\u{B65C}",
        nfd: "\u{1104}\u{116B}\u{11BB}",
        nfkc: "\u{B65C}",
        nfkd: "\u{1104}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B65D}",
        nfc: "\u{B65D}",
        nfd: "\u{1104}\u{116B}\u{11BC}",
        nfkc: "\u{B65D}",
        nfkd: "\u{1104}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B65E}",
        nfc: "\u{B65E}",
        nfd: "\u{1104}\u{116B}\u{11BD}",
        nfkc: "\u{B65E}",
        nfkd: "\u{1104}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B65F}",
        nfc: "\u{B65F}",
        nfd: "\u{1104}\u{116B}\u{11BE}",
        nfkc: "\u{B65F}",
        nfkd: "\u{1104}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B660}",
        nfc: "\u{B660}",
        nfd: "\u{1104}\u{116B}\u{11BF}",
        nfkc: "\u{B660}",
        nfkd: "\u{1104}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B661}",
        nfc: "\u{B661}",
        nfd: "\u{1104}\u{116B}\u{11C0}",
        nfkc: "\u{B661}",
        nfkd: "\u{1104}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B662}",
        nfc: "\u{B662}",
        nfd: "\u{1104}\u{116B}\u{11C1}",
        nfkc: "\u{B662}",
        nfkd: "\u{1104}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B663}",
        nfc: "\u{B663}",
        nfd: "\u{1104}\u{116B}\u{11C2}",
        nfkc: "\u{B663}",
        nfkd: "\u{1104}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B664}",
        nfc: "\u{B664}",
        nfd: "\u{1104}\u{116C}",
        nfkc: "\u{B664}",
        nfkd: "\u{1104}\u{116C}",
    },
    NormalizationTest {
        source: "\u{B665}",
        nfc: "\u{B665}",
        nfd: "\u{1104}\u{116C}\u{11A8}",
        nfkc: "\u{B665}",
        nfkd: "\u{1104}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B666}",
        nfc: "\u{B666}",
        nfd: "\u{1104}\u{116C}\u{11A9}",
        nfkc: "\u{B666}",
        nfkd: "\u{1104}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B667}",
        nfc: "\u{B667}",
        nfd: "\u{1104}\u{116C}\u{11AA}",
        nfkc: "\u{B667}",
        nfkd: "\u{1104}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B668}",
        nfc: "\u{B668}",
        nfd: "\u{1104}\u{116C}\u{11AB}",
        nfkc: "\u{B668}",
        nfkd: "\u{1104}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B669}",
        nfc: "\u{B669}",
        nfd: "\u{1104}\u{116C}\u{11AC}",
        nfkc: "\u{B669}",
        nfkd: "\u{1104}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B66A}",
        nfc: "\u{B66A}",
        nfd: "\u{1104}\u{116C}\u{11AD}",
        nfkc: "\u{B66A}",
        nfkd: "\u{1104}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B66B}",
        nfc: "\u{B66B}",
        nfd: "\u{1104}\u{116C}\u{11AE}",
        nfkc: "\u{B66B}",
        nfkd: "\u{1104}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B66C}",
        nfc: "\u{B66C}",
        nfd: "\u{1104}\u{116C}\u{11AF}",
        nfkc: "\u{B66C}",
        nfkd: "\u{1104}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B66D}",
        nfc: "\u{B66D}",
        nfd: "\u{1104}\u{116C}\u{11B0}",
        nfkc: "\u{B66D}",
        nfkd: "\u{1104}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B66E}",
        nfc: "\u{B66E}",
        nfd: "\u{1104}\u{116C}\u{11B1}",
        nfkc: "\u{B66E}",
        nfkd: "\u{1104}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B66F}",
        nfc: "\u{B66F}",
        nfd: "\u{1104}\u{116C}\u{11B2}",
        nfkc: "\u{B66F}",
        nfkd: "\u{1104}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B670}",
        nfc: "\u{B670}",
        nfd: "\u{1104}\u{116C}\u{11B3}",
        nfkc: "\u{B670}",
        nfkd: "\u{1104}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B671}",
        nfc: "\u{B671}",
        nfd: "\u{1104}\u{116C}\u{11B4}",
        nfkc: "\u{B671}",
        nfkd: "\u{1104}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B672}",
        nfc: "\u{B672}",
        nfd: "\u{1104}\u{116C}\u{11B5}",
        nfkc: "\u{B672}",
        nfkd: "\u{1104}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B673}",
        nfc: "\u{B673}",
        nfd: "\u{1104}\u{116C}\u{11B6}",
        nfkc: "\u{B673}",
        nfkd: "\u{1104}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B674}",
        nfc: "\u{B674}",
        nfd: "\u{1104}\u{116C}\u{11B7}",
        nfkc: "\u{B674}",
        nfkd: "\u{1104}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B675}",
        nfc: "\u{B675}",
        nfd: "\u{1104}\u{116C}\u{11B8}",
        nfkc: "\u{B675}",
        nfkd: "\u{1104}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B676}",
        nfc: "\u{B676}",
        nfd: "\u{1104}\u{116C}\u{11B9}",
        nfkc: "\u{B676}",
        nfkd: "\u{1104}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B677}",
        nfc: "\u{B677}",
        nfd: "\u{1104}\u{116C}\u{11BA}",
        nfkc: "\u{B677}",
        nfkd: "\u{1104}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B678}",
        nfc: "\u{B678}",
        nfd: "\u{1104}\u{116C}\u{11BB}",
        nfkc: "\u{B678}",
        nfkd: "\u{1104}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B679}",
        nfc: "\u{B679}",
        nfd: "\u{1104}\u{116C}\u{11BC}",
        nfkc: "\u{B679}",
        nfkd: "\u{1104}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B67A}",
        nfc: "\u{B67A}",
        nfd: "\u{1104}\u{116C}\u{11BD}",
        nfkc: "\u{B67A}",
        nfkd: "\u{1104}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B67B}",
        nfc: "\u{B67B}",
        nfd: "\u{1104}\u{116C}\u{11BE}",
        nfkc: "\u{B67B}",
        nfkd: "\u{1104}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B67C}",
        nfc: "\u{B67C}",
        nfd: "\u{1104}\u{116C}\u{11BF}",
        nfkc: "\u{B67C}",
        nfkd: "\u{1104}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B67D}",
        nfc: "\u{B67D}",
        nfd: "\u{1104}\u{116C}\u{11C0}",
        nfkc: "\u{B67D}",
        nfkd: "\u{1104}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B67E}",
        nfc: "\u{B67E}",
        nfd: "\u{1104}\u{116C}\u{11C1}",
        nfkc: "\u{B67E}",
        nfkd: "\u{1104}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B67F}",
        nfc: "\u{B67F}",
        nfd: "\u{1104}\u{116C}\u{11C2}",
        nfkc: "\u{B67F}",
        nfkd: "\u{1104}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B680}",
        nfc: "\u{B680}",
        nfd: "\u{1104}\u{116D}",
        nfkc: "\u{B680}",
        nfkd: "\u{1104}\u{116D}",
    },
    NormalizationTest {
        source: "\u{B681}",
        nfc: "\u{B681}",
        nfd: "\u{1104}\u{116D}\u{11A8}",
        nfkc: "\u{B681}",
        nfkd: "\u{1104}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B682}",
        nfc: "\u{B682}",
        nfd: "\u{1104}\u{116D}\u{11A9}",
        nfkc: "\u{B682}",
        nfkd: "\u{1104}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B683}",
        nfc: "\u{B683}",
        nfd: "\u{1104}\u{116D}\u{11AA}",
        nfkc: "\u{B683}",
        nfkd: "\u{1104}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B684}",
        nfc: "\u{B684}",
        nfd: "\u{1104}\u{116D}\u{11AB}",
        nfkc: "\u{B684}",
        nfkd: "\u{1104}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B685}",
        nfc: "\u{B685}",
        nfd: "\u{1104}\u{116D}\u{11AC}",
        nfkc: "\u{B685}",
        nfkd: "\u{1104}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B686}",
        nfc: "\u{B686}",
        nfd: "\u{1104}\u{116D}\u{11AD}",
        nfkc: "\u{B686}",
        nfkd: "\u{1104}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B687}",
        nfc: "\u{B687}",
        nfd: "\u{1104}\u{116D}\u{11AE}",
        nfkc: "\u{B687}",
        nfkd: "\u{1104}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B688}",
        nfc: "\u{B688}",
        nfd: "\u{1104}\u{116D}\u{11AF}",
        nfkc: "\u{B688}",
        nfkd: "\u{1104}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B689}",
        nfc: "\u{B689}",
        nfd: "\u{1104}\u{116D}\u{11B0}",
        nfkc: "\u{B689}",
        nfkd: "\u{1104}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B68A}",
        nfc: "\u{B68A}",
        nfd: "\u{1104}\u{116D}\u{11B1}",
        nfkc: "\u{B68A}",
        nfkd: "\u{1104}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B68B}",
        nfc: "\u{B68B}",
        nfd: "\u{1104}\u{116D}\u{11B2}",
        nfkc: "\u{B68B}",
        nfkd: "\u{1104}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B68C}",
        nfc: "\u{B68C}",
        nfd: "\u{1104}\u{116D}\u{11B3}",
        nfkc: "\u{B68C}",
        nfkd: "\u{1104}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B68D}",
        nfc: "\u{B68D}",
        nfd: "\u{1104}\u{116D}\u{11B4}",
        nfkc: "\u{B68D}",
        nfkd: "\u{1104}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B68E}",
        nfc: "\u{B68E}",
        nfd: "\u{1104}\u{116D}\u{11B5}",
        nfkc: "\u{B68E}",
        nfkd: "\u{1104}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B68F}",
        nfc: "\u{B68F}",
        nfd: "\u{1104}\u{116D}\u{11B6}",
        nfkc: "\u{B68F}",
        nfkd: "\u{1104}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B690}",
        nfc: "\u{B690}",
        nfd: "\u{1104}\u{116D}\u{11B7}",
        nfkc: "\u{B690}",
        nfkd: "\u{1104}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B691}",
        nfc: "\u{B691}",
        nfd: "\u{1104}\u{116D}\u{11B8}",
        nfkc: "\u{B691}",
        nfkd: "\u{1104}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B692}",
        nfc: "\u{B692}",
        nfd: "\u{1104}\u{116D}\u{11B9}",
        nfkc: "\u{B692}",
        nfkd: "\u{1104}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B693}",
        nfc: "\u{B693}",
        nfd: "\u{1104}\u{116D}\u{11BA}",
        nfkc: "\u{B693}",
        nfkd: "\u{1104}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B694}",
        nfc: "\u{B694}",
        nfd: "\u{1104}\u{116D}\u{11BB}",
        nfkc: "\u{B694}",
        nfkd: "\u{1104}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B695}",
        nfc: "\u{B695}",
        nfd: "\u{1104}\u{116D}\u{11BC}",
        nfkc: "\u{B695}",
        nfkd: "\u{1104}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B696}",
        nfc: "\u{B696}",
        nfd: "\u{1104}\u{116D}\u{11BD}",
        nfkc: "\u{B696}",
        nfkd: "\u{1104}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B697}",
        nfc: "\u{B697}",
        nfd: "\u{1104}\u{116D}\u{11BE}",
        nfkc: "\u{B697}",
        nfkd: "\u{1104}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B698}",
        nfc: "\u{B698}",
        nfd: "\u{1104}\u{116D}\u{11BF}",
        nfkc: "\u{B698}",
        nfkd: "\u{1104}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B699}",
        nfc: "\u{B699}",
        nfd: "\u{1104}\u{116D}\u{11C0}",
        nfkc: "\u{B699}",
        nfkd: "\u{1104}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B69A}",
        nfc: "\u{B69A}",
        nfd: "\u{1104}\u{116D}\u{11C1}",
        nfkc: "\u{B69A}",
        nfkd: "\u{1104}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B69B}",
        nfc: "\u{B69B}",
        nfd: "\u{1104}\u{116D}\u{11C2}",
        nfkc: "\u{B69B}",
        nfkd: "\u{1104}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B69C}",
        nfc: "\u{B69C}",
        nfd: "\u{1104}\u{116E}",
        nfkc: "\u{B69C}",
        nfkd: "\u{1104}\u{116E}",
    },
    NormalizationTest {
        source: "\u{B69D}",
        nfc: "\u{B69D}",
        nfd: "\u{1104}\u{116E}\u{11A8}",
        nfkc: "\u{B69D}",
        nfkd: "\u{1104}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B69E}",
        nfc: "\u{B69E}",
        nfd: "\u{1104}\u{116E}\u{11A9}",
        nfkc: "\u{B69E}",
        nfkd: "\u{1104}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B69F}",
        nfc: "\u{B69F}",
        nfd: "\u{1104}\u{116E}\u{11AA}",
        nfkc: "\u{B69F}",
        nfkd: "\u{1104}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B6A0}",
        nfc: "\u{B6A0}",
        nfd: "\u{1104}\u{116E}\u{11AB}",
        nfkc: "\u{B6A0}",
        nfkd: "\u{1104}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B6A1}",
        nfc: "\u{B6A1}",
        nfd: "\u{1104}\u{116E}\u{11AC}",
        nfkc: "\u{B6A1}",
        nfkd: "\u{1104}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B6A2}",
        nfc: "\u{B6A2}",
        nfd: "\u{1104}\u{116E}\u{11AD}",
        nfkc: "\u{B6A2}",
        nfkd: "\u{1104}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B6A3}",
        nfc: "\u{B6A3}",
        nfd: "\u{1104}\u{116E}\u{11AE}",
        nfkc: "\u{B6A3}",
        nfkd: "\u{1104}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B6A4}",
        nfc: "\u{B6A4}",
        nfd: "\u{1104}\u{116E}\u{11AF}",
        nfkc: "\u{B6A4}",
        nfkd: "\u{1104}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B6A5}",
        nfc: "\u{B6A5}",
        nfd: "\u{1104}\u{116E}\u{11B0}",
        nfkc: "\u{B6A5}",
        nfkd: "\u{1104}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B6A6}",
        nfc: "\u{B6A6}",
        nfd: "\u{1104}\u{116E}\u{11B1}",
        nfkc: "\u{B6A6}",
        nfkd: "\u{1104}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B6A7}",
        nfc: "\u{B6A7}",
        nfd: "\u{1104}\u{116E}\u{11B2}",
        nfkc: "\u{B6A7}",
        nfkd: "\u{1104}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B6A8}",
        nfc: "\u{B6A8}",
        nfd: "\u{1104}\u{116E}\u{11B3}",
        nfkc: "\u{B6A8}",
        nfkd: "\u{1104}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B6A9}",
        nfc: "\u{B6A9}",
        nfd: "\u{1104}\u{116E}\u{11B4}",
        nfkc: "\u{B6A9}",
        nfkd: "\u{1104}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B6AA}",
        nfc: "\u{B6AA}",
        nfd: "\u{1104}\u{116E}\u{11B5}",
        nfkc: "\u{B6AA}",
        nfkd: "\u{1104}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B6AB}",
        nfc: "\u{B6AB}",
        nfd: "\u{1104}\u{116E}\u{11B6}",
        nfkc: "\u{B6AB}",
        nfkd: "\u{1104}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B6AC}",
        nfc: "\u{B6AC}",
        nfd: "\u{1104}\u{116E}\u{11B7}",
        nfkc: "\u{B6AC}",
        nfkd: "\u{1104}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B6AD}",
        nfc: "\u{B6AD}",
        nfd: "\u{1104}\u{116E}\u{11B8}",
        nfkc: "\u{B6AD}",
        nfkd: "\u{1104}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B6AE}",
        nfc: "\u{B6AE}",
        nfd: "\u{1104}\u{116E}\u{11B9}",
        nfkc: "\u{B6AE}",
        nfkd: "\u{1104}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B6AF}",
        nfc: "\u{B6AF}",
        nfd: "\u{1104}\u{116E}\u{11BA}",
        nfkc: "\u{B6AF}",
        nfkd: "\u{1104}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B6B0}",
        nfc: "\u{B6B0}",
        nfd: "\u{1104}\u{116E}\u{11BB}",
        nfkc: "\u{B6B0}",
        nfkd: "\u{1104}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B6B1}",
        nfc: "\u{B6B1}",
        nfd: "\u{1104}\u{116E}\u{11BC}",
        nfkc: "\u{B6B1}",
        nfkd: "\u{1104}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B6B2}",
        nfc: "\u{B6B2}",
        nfd: "\u{1104}\u{116E}\u{11BD}",
        nfkc: "\u{B6B2}",
        nfkd: "\u{1104}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B6B3}",
        nfc: "\u{B6B3}",
        nfd: "\u{1104}\u{116E}\u{11BE}",
        nfkc: "\u{B6B3}",
        nfkd: "\u{1104}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B6B4}",
        nfc: "\u{B6B4}",
        nfd: "\u{1104}\u{116E}\u{11BF}",
        nfkc: "\u{B6B4}",
        nfkd: "\u{1104}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B6B5}",
        nfc: "\u{B6B5}",
        nfd: "\u{1104}\u{116E}\u{11C0}",
        nfkc: "\u{B6B5}",
        nfkd: "\u{1104}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B6B6}",
        nfc: "\u{B6B6}",
        nfd: "\u{1104}\u{116E}\u{11C1}",
        nfkc: "\u{B6B6}",
        nfkd: "\u{1104}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B6B7}",
        nfc: "\u{B6B7}",
        nfd: "\u{1104}\u{116E}\u{11C2}",
        nfkc: "\u{B6B7}",
        nfkd: "\u{1104}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B6B8}",
        nfc: "\u{B6B8}",
        nfd: "\u{1104}\u{116F}",
        nfkc: "\u{B6B8}",
        nfkd: "\u{1104}\u{116F}",
    },
    NormalizationTest {
        source: "\u{B6B9}",
        nfc: "\u{B6B9}",
        nfd: "\u{1104}\u{116F}\u{11A8}",
        nfkc: "\u{B6B9}",
        nfkd: "\u{1104}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B6BA}",
        nfc: "\u{B6BA}",
        nfd: "\u{1104}\u{116F}\u{11A9}",
        nfkc: "\u{B6BA}",
        nfkd: "\u{1104}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B6BB}",
        nfc: "\u{B6BB}",
        nfd: "\u{1104}\u{116F}\u{11AA}",
        nfkc: "\u{B6BB}",
        nfkd: "\u{1104}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B6BC}",
        nfc: "\u{B6BC}",
        nfd: "\u{1104}\u{116F}\u{11AB}",
        nfkc: "\u{B6BC}",
        nfkd: "\u{1104}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B6BD}",
        nfc: "\u{B6BD}",
        nfd: "\u{1104}\u{116F}\u{11AC}",
        nfkc: "\u{B6BD}",
        nfkd: "\u{1104}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B6BE}",
        nfc: "\u{B6BE}",
        nfd: "\u{1104}\u{116F}\u{11AD}",
        nfkc: "\u{B6BE}",
        nfkd: "\u{1104}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B6BF}",
        nfc: "\u{B6BF}",
        nfd: "\u{1104}\u{116F}\u{11AE}",
        nfkc: "\u{B6BF}",
        nfkd: "\u{1104}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B6C0}",
        nfc: "\u{B6C0}",
        nfd: "\u{1104}\u{116F}\u{11AF}",
        nfkc: "\u{B6C0}",
        nfkd: "\u{1104}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B6C1}",
        nfc: "\u{B6C1}",
        nfd: "\u{1104}\u{116F}\u{11B0}",
        nfkc: "\u{B6C1}",
        nfkd: "\u{1104}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B6C2}",
        nfc: "\u{B6C2}",
        nfd: "\u{1104}\u{116F}\u{11B1}",
        nfkc: "\u{B6C2}",
        nfkd: "\u{1104}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B6C3}",
        nfc: "\u{B6C3}",
        nfd: "\u{1104}\u{116F}\u{11B2}",
        nfkc: "\u{B6C3}",
        nfkd: "\u{1104}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B6C4}",
        nfc: "\u{B6C4}",
        nfd: "\u{1104}\u{116F}\u{11B3}",
        nfkc: "\u{B6C4}",
        nfkd: "\u{1104}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B6C5}",
        nfc: "\u{B6C5}",
        nfd: "\u{1104}\u{116F}\u{11B4}",
        nfkc: "\u{B6C5}",
        nfkd: "\u{1104}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B6C6}",
        nfc: "\u{B6C6}",
        nfd: "\u{1104}\u{116F}\u{11B5}",
        nfkc: "\u{B6C6}",
        nfkd: "\u{1104}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B6C7}",
        nfc: "\u{B6C7}",
        nfd: "\u{1104}\u{116F}\u{11B6}",
        nfkc: "\u{B6C7}",
        nfkd: "\u{1104}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B6C8}",
        nfc: "\u{B6C8}",
        nfd: "\u{1104}\u{116F}\u{11B7}",
        nfkc: "\u{B6C8}",
        nfkd: "\u{1104}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B6C9}",
        nfc: "\u{B6C9}",
        nfd: "\u{1104}\u{116F}\u{11B8}",
        nfkc: "\u{B6C9}",
        nfkd: "\u{1104}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B6CA}",
        nfc: "\u{B6CA}",
        nfd: "\u{1104}\u{116F}\u{11B9}",
        nfkc: "\u{B6CA}",
        nfkd: "\u{1104}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B6CB}",
        nfc: "\u{B6CB}",
        nfd: "\u{1104}\u{116F}\u{11BA}",
        nfkc: "\u{B6CB}",
        nfkd: "\u{1104}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B6CC}",
        nfc: "\u{B6CC}",
        nfd: "\u{1104}\u{116F}\u{11BB}",
        nfkc: "\u{B6CC}",
        nfkd: "\u{1104}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B6CD}",
        nfc: "\u{B6CD}",
        nfd: "\u{1104}\u{116F}\u{11BC}",
        nfkc: "\u{B6CD}",
        nfkd: "\u{1104}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B6CE}",
        nfc: "\u{B6CE}",
        nfd: "\u{1104}\u{116F}\u{11BD}",
        nfkc: "\u{B6CE}",
        nfkd: "\u{1104}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B6CF}",
        nfc: "\u{B6CF}",
        nfd: "\u{1104}\u{116F}\u{11BE}",
        nfkc: "\u{B6CF}",
        nfkd: "\u{1104}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B6D0}",
        nfc: "\u{B6D0}",
        nfd: "\u{1104}\u{116F}\u{11BF}",
        nfkc: "\u{B6D0}",
        nfkd: "\u{1104}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B6D1}",
        nfc: "\u{B6D1}",
        nfd: "\u{1104}\u{116F}\u{11C0}",
        nfkc: "\u{B6D1}",
        nfkd: "\u{1104}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B6D2}",
        nfc: "\u{B6D2}",
        nfd: "\u{1104}\u{116F}\u{11C1}",
        nfkc: "\u{B6D2}",
        nfkd: "\u{1104}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B6D3}",
        nfc: "\u{B6D3}",
        nfd: "\u{1104}\u{116F}\u{11C2}",
        nfkc: "\u{B6D3}",
        nfkd: "\u{1104}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B6D4}",
        nfc: "\u{B6D4}",
        nfd: "\u{1104}\u{1170}",
        nfkc: "\u{B6D4}",
        nfkd: "\u{1104}\u{1170}",
    },
    NormalizationTest {
        source: "\u{B6D5}",
        nfc: "\u{B6D5}",
        nfd: "\u{1104}\u{1170}\u{11A8}",
        nfkc: "\u{B6D5}",
        nfkd: "\u{1104}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B6D6}",
        nfc: "\u{B6D6}",
        nfd: "\u{1104}\u{1170}\u{11A9}",
        nfkc: "\u{B6D6}",
        nfkd: "\u{1104}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B6D7}",
        nfc: "\u{B6D7}",
        nfd: "\u{1104}\u{1170}\u{11AA}",
        nfkc: "\u{B6D7}",
        nfkd: "\u{1104}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B6D8}",
        nfc: "\u{B6D8}",
        nfd: "\u{1104}\u{1170}\u{11AB}",
        nfkc: "\u{B6D8}",
        nfkd: "\u{1104}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B6D9}",
        nfc: "\u{B6D9}",
        nfd: "\u{1104}\u{1170}\u{11AC}",
        nfkc: "\u{B6D9}",
        nfkd: "\u{1104}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B6DA}",
        nfc: "\u{B6DA}",
        nfd: "\u{1104}\u{1170}\u{11AD}",
        nfkc: "\u{B6DA}",
        nfkd: "\u{1104}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B6DB}",
        nfc: "\u{B6DB}",
        nfd: "\u{1104}\u{1170}\u{11AE}",
        nfkc: "\u{B6DB}",
        nfkd: "\u{1104}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B6DC}",
        nfc: "\u{B6DC}",
        nfd: "\u{1104}\u{1170}\u{11AF}",
        nfkc: "\u{B6DC}",
        nfkd: "\u{1104}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B6DD}",
        nfc: "\u{B6DD}",
        nfd: "\u{1104}\u{1170}\u{11B0}",
        nfkc: "\u{B6DD}",
        nfkd: "\u{1104}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B6DE}",
        nfc: "\u{B6DE}",
        nfd: "\u{1104}\u{1170}\u{11B1}",
        nfkc: "\u{B6DE}",
        nfkd: "\u{1104}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B6DF}",
        nfc: "\u{B6DF}",
        nfd: "\u{1104}\u{1170}\u{11B2}",
        nfkc: "\u{B6DF}",
        nfkd: "\u{1104}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B6E0}",
        nfc: "\u{B6E0}",
        nfd: "\u{1104}\u{1170}\u{11B3}",
        nfkc: "\u{B6E0}",
        nfkd: "\u{1104}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B6E1}",
        nfc: "\u{B6E1}",
        nfd: "\u{1104}\u{1170}\u{11B4}",
        nfkc: "\u{B6E1}",
        nfkd: "\u{1104}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B6E2}",
        nfc: "\u{B6E2}",
        nfd: "\u{1104}\u{1170}\u{11B5}",
        nfkc: "\u{B6E2}",
        nfkd: "\u{1104}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B6E3}",
        nfc: "\u{B6E3}",
        nfd: "\u{1104}\u{1170}\u{11B6}",
        nfkc: "\u{B6E3}",
        nfkd: "\u{1104}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B6E4}",
        nfc: "\u{B6E4}",
        nfd: "\u{1104}\u{1170}\u{11B7}",
        nfkc: "\u{B6E4}",
        nfkd: "\u{1104}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B6E5}",
        nfc: "\u{B6E5}",
        nfd: "\u{1104}\u{1170}\u{11B8}",
        nfkc: "\u{B6E5}",
        nfkd: "\u{1104}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B6E6}",
        nfc: "\u{B6E6}",
        nfd: "\u{1104}\u{1170}\u{11B9}",
        nfkc: "\u{B6E6}",
        nfkd: "\u{1104}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B6E7}",
        nfc: "\u{B6E7}",
        nfd: "\u{1104}\u{1170}\u{11BA}",
        nfkc: "\u{B6E7}",
        nfkd: "\u{1104}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B6E8}",
        nfc: "\u{B6E8}",
        nfd: "\u{1104}\u{1170}\u{11BB}",
        nfkc: "\u{B6E8}",
        nfkd: "\u{1104}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B6E9}",
        nfc: "\u{B6E9}",
        nfd: "\u{1104}\u{1170}\u{11BC}",
        nfkc: "\u{B6E9}",
        nfkd: "\u{1104}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B6EA}",
        nfc: "\u{B6EA}",
        nfd: "\u{1104}\u{1170}\u{11BD}",
        nfkc: "\u{B6EA}",
        nfkd: "\u{1104}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B6EB}",
        nfc: "\u{B6EB}",
        nfd: "\u{1104}\u{1170}\u{11BE}",
        nfkc: "\u{B6EB}",
        nfkd: "\u{1104}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B6EC}",
        nfc: "\u{B6EC}",
        nfd: "\u{1104}\u{1170}\u{11BF}",
        nfkc: "\u{B6EC}",
        nfkd: "\u{1104}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B6ED}",
        nfc: "\u{B6ED}",
        nfd: "\u{1104}\u{1170}\u{11C0}",
        nfkc: "\u{B6ED}",
        nfkd: "\u{1104}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B6EE}",
        nfc: "\u{B6EE}",
        nfd: "\u{1104}\u{1170}\u{11C1}",
        nfkc: "\u{B6EE}",
        nfkd: "\u{1104}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B6EF}",
        nfc: "\u{B6EF}",
        nfd: "\u{1104}\u{1170}\u{11C2}",
        nfkc: "\u{B6EF}",
        nfkd: "\u{1104}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B6F0}",
        nfc: "\u{B6F0}",
        nfd: "\u{1104}\u{1171}",
        nfkc: "\u{B6F0}",
        nfkd: "\u{1104}\u{1171}",
    },
    NormalizationTest {
        source: "\u{B6F1}",
        nfc: "\u{B6F1}",
        nfd: "\u{1104}\u{1171}\u{11A8}",
        nfkc: "\u{B6F1}",
        nfkd: "\u{1104}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B6F2}",
        nfc: "\u{B6F2}",
        nfd: "\u{1104}\u{1171}\u{11A9}",
        nfkc: "\u{B6F2}",
        nfkd: "\u{1104}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B6F3}",
        nfc: "\u{B6F3}",
        nfd: "\u{1104}\u{1171}\u{11AA}",
        nfkc: "\u{B6F3}",
        nfkd: "\u{1104}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B6F4}",
        nfc: "\u{B6F4}",
        nfd: "\u{1104}\u{1171}\u{11AB}",
        nfkc: "\u{B6F4}",
        nfkd: "\u{1104}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B6F5}",
        nfc: "\u{B6F5}",
        nfd: "\u{1104}\u{1171}\u{11AC}",
        nfkc: "\u{B6F5}",
        nfkd: "\u{1104}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B6F6}",
        nfc: "\u{B6F6}",
        nfd: "\u{1104}\u{1171}\u{11AD}",
        nfkc: "\u{B6F6}",
        nfkd: "\u{1104}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B6F7}",
        nfc: "\u{B6F7}",
        nfd: "\u{1104}\u{1171}\u{11AE}",
        nfkc: "\u{B6F7}",
        nfkd: "\u{1104}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B6F8}",
        nfc: "\u{B6F8}",
        nfd: "\u{1104}\u{1171}\u{11AF}",
        nfkc: "\u{B6F8}",
        nfkd: "\u{1104}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B6F9}",
        nfc: "\u{B6F9}",
        nfd: "\u{1104}\u{1171}\u{11B0}",
        nfkc: "\u{B6F9}",
        nfkd: "\u{1104}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B6FA}",
        nfc: "\u{B6FA}",
        nfd: "\u{1104}\u{1171}\u{11B1}",
        nfkc: "\u{B6FA}",
        nfkd: "\u{1104}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B6FB}",
        nfc: "\u{B6FB}",
        nfd: "\u{1104}\u{1171}\u{11B2}",
        nfkc: "\u{B6FB}",
        nfkd: "\u{1104}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B6FC}",
        nfc: "\u{B6FC}",
        nfd: "\u{1104}\u{1171}\u{11B3}",
        nfkc: "\u{B6FC}",
        nfkd: "\u{1104}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B6FD}",
        nfc: "\u{B6FD}",
        nfd: "\u{1104}\u{1171}\u{11B4}",
        nfkc: "\u{B6FD}",
        nfkd: "\u{1104}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B6FE}",
        nfc: "\u{B6FE}",
        nfd: "\u{1104}\u{1171}\u{11B5}",
        nfkc: "\u{B6FE}",
        nfkd: "\u{1104}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B6FF}",
        nfc: "\u{B6FF}",
        nfd: "\u{1104}\u{1171}\u{11B6}",
        nfkc: "\u{B6FF}",
        nfkd: "\u{1104}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B700}",
        nfc: "\u{B700}",
        nfd: "\u{1104}\u{1171}\u{11B7}",
        nfkc: "\u{B700}",
        nfkd: "\u{1104}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B701}",
        nfc: "\u{B701}",
        nfd: "\u{1104}\u{1171}\u{11B8}",
        nfkc: "\u{B701}",
        nfkd: "\u{1104}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B702}",
        nfc: "\u{B702}",
        nfd: "\u{1104}\u{1171}\u{11B9}",
        nfkc: "\u{B702}",
        nfkd: "\u{1104}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B703}",
        nfc: "\u{B703}",
        nfd: "\u{1104}\u{1171}\u{11BA}",
        nfkc: "\u{B703}",
        nfkd: "\u{1104}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B704}",
        nfc: "\u{B704}",
        nfd: "\u{1104}\u{1171}\u{11BB}",
        nfkc: "\u{B704}",
        nfkd: "\u{1104}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B705}",
        nfc: "\u{B705}",
        nfd: "\u{1104}\u{1171}\u{11BC}",
        nfkc: "\u{B705}",
        nfkd: "\u{1104}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B706}",
        nfc: "\u{B706}",
        nfd: "\u{1104}\u{1171}\u{11BD}",
        nfkc: "\u{B706}",
        nfkd: "\u{1104}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B707}",
        nfc: "\u{B707}",
        nfd: "\u{1104}\u{1171}\u{11BE}",
        nfkc: "\u{B707}",
        nfkd: "\u{1104}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B708}",
        nfc: "\u{B708}",
        nfd: "\u{1104}\u{1171}\u{11BF}",
        nfkc: "\u{B708}",
        nfkd: "\u{1104}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B709}",
        nfc: "\u{B709}",
        nfd: "\u{1104}\u{1171}\u{11C0}",
        nfkc: "\u{B709}",
        nfkd: "\u{1104}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B70A}",
        nfc: "\u{B70A}",
        nfd: "\u{1104}\u{1171}\u{11C1}",
        nfkc: "\u{B70A}",
        nfkd: "\u{1104}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B70B}",
        nfc: "\u{B70B}",
        nfd: "\u{1104}\u{1171}\u{11C2}",
        nfkc: "\u{B70B}",
        nfkd: "\u{1104}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B70C}",
        nfc: "\u{B70C}",
        nfd: "\u{1104}\u{1172}",
        nfkc: "\u{B70C}",
        nfkd: "\u{1104}\u{1172}",
    },
    NormalizationTest {
        source: "\u{B70D}",
        nfc: "\u{B70D}",
        nfd: "\u{1104}\u{1172}\u{11A8}",
        nfkc: "\u{B70D}",
        nfkd: "\u{1104}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B70E}",
        nfc: "\u{B70E}",
        nfd: "\u{1104}\u{1172}\u{11A9}",
        nfkc: "\u{B70E}",
        nfkd: "\u{1104}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B70F}",
        nfc: "\u{B70F}",
        nfd: "\u{1104}\u{1172}\u{11AA}",
        nfkc: "\u{B70F}",
        nfkd: "\u{1104}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B710}",
        nfc: "\u{B710}",
        nfd: "\u{1104}\u{1172}\u{11AB}",
        nfkc: "\u{B710}",
        nfkd: "\u{1104}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B711}",
        nfc: "\u{B711}",
        nfd: "\u{1104}\u{1172}\u{11AC}",
        nfkc: "\u{B711}",
        nfkd: "\u{1104}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B712}",
        nfc: "\u{B712}",
        nfd: "\u{1104}\u{1172}\u{11AD}",
        nfkc: "\u{B712}",
        nfkd: "\u{1104}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B713}",
        nfc: "\u{B713}",
        nfd: "\u{1104}\u{1172}\u{11AE}",
        nfkc: "\u{B713}",
        nfkd: "\u{1104}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B714}",
        nfc: "\u{B714}",
        nfd: "\u{1104}\u{1172}\u{11AF}",
        nfkc: "\u{B714}",
        nfkd: "\u{1104}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B715}",
        nfc: "\u{B715}",
        nfd: "\u{1104}\u{1172}\u{11B0}",
        nfkc: "\u{B715}",
        nfkd: "\u{1104}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B716}",
        nfc: "\u{B716}",
        nfd: "\u{1104}\u{1172}\u{11B1}",
        nfkc: "\u{B716}",
        nfkd: "\u{1104}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B717}",
        nfc: "\u{B717}",
        nfd: "\u{1104}\u{1172}\u{11B2}",
        nfkc: "\u{B717}",
        nfkd: "\u{1104}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B718}",
        nfc: "\u{B718}",
        nfd: "\u{1104}\u{1172}\u{11B3}",
        nfkc: "\u{B718}",
        nfkd: "\u{1104}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B719}",
        nfc: "\u{B719}",
        nfd: "\u{1104}\u{1172}\u{11B4}",
        nfkc: "\u{B719}",
        nfkd: "\u{1104}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B71A}",
        nfc: "\u{B71A}",
        nfd: "\u{1104}\u{1172}\u{11B5}",
        nfkc: "\u{B71A}",
        nfkd: "\u{1104}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B71B}",
        nfc: "\u{B71B}",
        nfd: "\u{1104}\u{1172}\u{11B6}",
        nfkc: "\u{B71B}",
        nfkd: "\u{1104}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B71C}",
        nfc: "\u{B71C}",
        nfd: "\u{1104}\u{1172}\u{11B7}",
        nfkc: "\u{B71C}",
        nfkd: "\u{1104}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B71D}",
        nfc: "\u{B71D}",
        nfd: "\u{1104}\u{1172}\u{11B8}",
        nfkc: "\u{B71D}",
        nfkd: "\u{1104}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B71E}",
        nfc: "\u{B71E}",
        nfd: "\u{1104}\u{1172}\u{11B9}",
        nfkc: "\u{B71E}",
        nfkd: "\u{1104}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B71F}",
        nfc: "\u{B71F}",
        nfd: "\u{1104}\u{1172}\u{11BA}",
        nfkc: "\u{B71F}",
        nfkd: "\u{1104}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B720}",
        nfc: "\u{B720}",
        nfd: "\u{1104}\u{1172}\u{11BB}",
        nfkc: "\u{B720}",
        nfkd: "\u{1104}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B721}",
        nfc: "\u{B721}",
        nfd: "\u{1104}\u{1172}\u{11BC}",
        nfkc: "\u{B721}",
        nfkd: "\u{1104}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B722}",
        nfc: "\u{B722}",
        nfd: "\u{1104}\u{1172}\u{11BD}",
        nfkc: "\u{B722}",
        nfkd: "\u{1104}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B723}",
        nfc: "\u{B723}",
        nfd: "\u{1104}\u{1172}\u{11BE}",
        nfkc: "\u{B723}",
        nfkd: "\u{1104}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B724}",
        nfc: "\u{B724}",
        nfd: "\u{1104}\u{1172}\u{11BF}",
        nfkc: "\u{B724}",
        nfkd: "\u{1104}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B725}",
        nfc: "\u{B725}",
        nfd: "\u{1104}\u{1172}\u{11C0}",
        nfkc: "\u{B725}",
        nfkd: "\u{1104}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B726}",
        nfc: "\u{B726}",
        nfd: "\u{1104}\u{1172}\u{11C1}",
        nfkc: "\u{B726}",
        nfkd: "\u{1104}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B727}",
        nfc: "\u{B727}",
        nfd: "\u{1104}\u{1172}\u{11C2}",
        nfkc: "\u{B727}",
        nfkd: "\u{1104}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B728}",
        nfc: "\u{B728}",
        nfd: "\u{1104}\u{1173}",
        nfkc: "\u{B728}",
        nfkd: "\u{1104}\u{1173}",
    },
    NormalizationTest {
        source: "\u{B729}",
        nfc: "\u{B729}",
        nfd: "\u{1104}\u{1173}\u{11A8}",
        nfkc: "\u{B729}",
        nfkd: "\u{1104}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B72A}",
        nfc: "\u{B72A}",
        nfd: "\u{1104}\u{1173}\u{11A9}",
        nfkc: "\u{B72A}",
        nfkd: "\u{1104}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B72B}",
        nfc: "\u{B72B}",
        nfd: "\u{1104}\u{1173}\u{11AA}",
        nfkc: "\u{B72B}",
        nfkd: "\u{1104}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B72C}",
        nfc: "\u{B72C}",
        nfd: "\u{1104}\u{1173}\u{11AB}",
        nfkc: "\u{B72C}",
        nfkd: "\u{1104}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B72D}",
        nfc: "\u{B72D}",
        nfd: "\u{1104}\u{1173}\u{11AC}",
        nfkc: "\u{B72D}",
        nfkd: "\u{1104}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B72E}",
        nfc: "\u{B72E}",
        nfd: "\u{1104}\u{1173}\u{11AD}",
        nfkc: "\u{B72E}",
        nfkd: "\u{1104}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B72F}",
        nfc: "\u{B72F}",
        nfd: "\u{1104}\u{1173}\u{11AE}",
        nfkc: "\u{B72F}",
        nfkd: "\u{1104}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B730}",
        nfc: "\u{B730}",
        nfd: "\u{1104}\u{1173}\u{11AF}",
        nfkc: "\u{B730}",
        nfkd: "\u{1104}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B731}",
        nfc: "\u{B731}",
        nfd: "\u{1104}\u{1173}\u{11B0}",
        nfkc: "\u{B731}",
        nfkd: "\u{1104}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B732}",
        nfc: "\u{B732}",
        nfd: "\u{1104}\u{1173}\u{11B1}",
        nfkc: "\u{B732}",
        nfkd: "\u{1104}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B733}",
        nfc: "\u{B733}",
        nfd: "\u{1104}\u{1173}\u{11B2}",
        nfkc: "\u{B733}",
        nfkd: "\u{1104}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B734}",
        nfc: "\u{B734}",
        nfd: "\u{1104}\u{1173}\u{11B3}",
        nfkc: "\u{B734}",
        nfkd: "\u{1104}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B735}",
        nfc: "\u{B735}",
        nfd: "\u{1104}\u{1173}\u{11B4}",
        nfkc: "\u{B735}",
        nfkd: "\u{1104}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B736}",
        nfc: "\u{B736}",
        nfd: "\u{1104}\u{1173}\u{11B5}",
        nfkc: "\u{B736}",
        nfkd: "\u{1104}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B737}",
        nfc: "\u{B737}",
        nfd: "\u{1104}\u{1173}\u{11B6}",
        nfkc: "\u{B737}",
        nfkd: "\u{1104}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B738}",
        nfc: "\u{B738}",
        nfd: "\u{1104}\u{1173}\u{11B7}",
        nfkc: "\u{B738}",
        nfkd: "\u{1104}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B739}",
        nfc: "\u{B739}",
        nfd: "\u{1104}\u{1173}\u{11B8}",
        nfkc: "\u{B739}",
        nfkd: "\u{1104}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B73A}",
        nfc: "\u{B73A}",
        nfd: "\u{1104}\u{1173}\u{11B9}",
        nfkc: "\u{B73A}",
        nfkd: "\u{1104}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B73B}",
        nfc: "\u{B73B}",
        nfd: "\u{1104}\u{1173}\u{11BA}",
        nfkc: "\u{B73B}",
        nfkd: "\u{1104}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B73C}",
        nfc: "\u{B73C}",
        nfd: "\u{1104}\u{1173}\u{11BB}",
        nfkc: "\u{B73C}",
        nfkd: "\u{1104}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B73D}",
        nfc: "\u{B73D}",
        nfd: "\u{1104}\u{1173}\u{11BC}",
        nfkc: "\u{B73D}",
        nfkd: "\u{1104}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B73E}",
        nfc: "\u{B73E}",
        nfd: "\u{1104}\u{1173}\u{11BD}",
        nfkc: "\u{B73E}",
        nfkd: "\u{1104}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B73F}",
        nfc: "\u{B73F}",
        nfd: "\u{1104}\u{1173}\u{11BE}",
        nfkc: "\u{B73F}",
        nfkd: "\u{1104}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B740}",
        nfc: "\u{B740}",
        nfd: "\u{1104}\u{1173}\u{11BF}",
        nfkc: "\u{B740}",
        nfkd: "\u{1104}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B741}",
        nfc: "\u{B741}",
        nfd: "\u{1104}\u{1173}\u{11C0}",
        nfkc: "\u{B741}",
        nfkd: "\u{1104}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B742}",
        nfc: "\u{B742}",
        nfd: "\u{1104}\u{1173}\u{11C1}",
        nfkc: "\u{B742}",
        nfkd: "\u{1104}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B743}",
        nfc: "\u{B743}",
        nfd: "\u{1104}\u{1173}\u{11C2}",
        nfkc: "\u{B743}",
        nfkd: "\u{1104}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B744}",
        nfc: "\u{B744}",
        nfd: "\u{1104}\u{1174}",
        nfkc: "\u{B744}",
        nfkd: "\u{1104}\u{1174}",
    },
    NormalizationTest {
        source: "\u{B745}",
        nfc: "\u{B745}",
        nfd: "\u{1104}\u{1174}\u{11A8}",
        nfkc: "\u{B745}",
        nfkd: "\u{1104}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B746}",
        nfc: "\u{B746}",
        nfd: "\u{1104}\u{1174}\u{11A9}",
        nfkc: "\u{B746}",
        nfkd: "\u{1104}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B747}",
        nfc: "\u{B747}",
        nfd: "\u{1104}\u{1174}\u{11AA}",
        nfkc: "\u{B747}",
        nfkd: "\u{1104}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B748}",
        nfc: "\u{B748}",
        nfd: "\u{1104}\u{1174}\u{11AB}",
        nfkc: "\u{B748}",
        nfkd: "\u{1104}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B749}",
        nfc: "\u{B749}",
        nfd: "\u{1104}\u{1174}\u{11AC}",
        nfkc: "\u{B749}",
        nfkd: "\u{1104}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B74A}",
        nfc: "\u{B74A}",
        nfd: "\u{1104}\u{1174}\u{11AD}",
        nfkc: "\u{B74A}",
        nfkd: "\u{1104}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B74B}",
        nfc: "\u{B74B}",
        nfd: "\u{1104}\u{1174}\u{11AE}",
        nfkc: "\u{B74B}",
        nfkd: "\u{1104}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B74C}",
        nfc: "\u{B74C}",
        nfd: "\u{1104}\u{1174}\u{11AF}",
        nfkc: "\u{B74C}",
        nfkd: "\u{1104}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B74D}",
        nfc: "\u{B74D}",
        nfd: "\u{1104}\u{1174}\u{11B0}",
        nfkc: "\u{B74D}",
        nfkd: "\u{1104}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B74E}",
        nfc: "\u{B74E}",
        nfd: "\u{1104}\u{1174}\u{11B1}",
        nfkc: "\u{B74E}",
        nfkd: "\u{1104}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B74F}",
        nfc: "\u{B74F}",
        nfd: "\u{1104}\u{1174}\u{11B2}",
        nfkc: "\u{B74F}",
        nfkd: "\u{1104}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B750}",
        nfc: "\u{B750}",
        nfd: "\u{1104}\u{1174}\u{11B3}",
        nfkc: "\u{B750}",
        nfkd: "\u{1104}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B751}",
        nfc: "\u{B751}",
        nfd: "\u{1104}\u{1174}\u{11B4}",
        nfkc: "\u{B751}",
        nfkd: "\u{1104}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B752}",
        nfc: "\u{B752}",
        nfd: "\u{1104}\u{1174}\u{11B5}",
        nfkc: "\u{B752}",
        nfkd: "\u{1104}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B753}",
        nfc: "\u{B753}",
        nfd: "\u{1104}\u{1174}\u{11B6}",
        nfkc: "\u{B753}",
        nfkd: "\u{1104}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B754}",
        nfc: "\u{B754}",
        nfd: "\u{1104}\u{1174}\u{11B7}",
        nfkc: "\u{B754}",
        nfkd: "\u{1104}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B755}",
        nfc: "\u{B755}",
        nfd: "\u{1104}\u{1174}\u{11B8}",
        nfkc: "\u{B755}",
        nfkd: "\u{1104}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B756}",
        nfc: "\u{B756}",
        nfd: "\u{1104}\u{1174}\u{11B9}",
        nfkc: "\u{B756}",
        nfkd: "\u{1104}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B757}",
        nfc: "\u{B757}",
        nfd: "\u{1104}\u{1174}\u{11BA}",
        nfkc: "\u{B757}",
        nfkd: "\u{1104}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B758}",
        nfc: "\u{B758}",
        nfd: "\u{1104}\u{1174}\u{11BB}",
        nfkc: "\u{B758}",
        nfkd: "\u{1104}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B759}",
        nfc: "\u{B759}",
        nfd: "\u{1104}\u{1174}\u{11BC}",
        nfkc: "\u{B759}",
        nfkd: "\u{1104}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B75A}",
        nfc: "\u{B75A}",
        nfd: "\u{1104}\u{1174}\u{11BD}",
        nfkc: "\u{B75A}",
        nfkd: "\u{1104}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B75B}",
        nfc: "\u{B75B}",
        nfd: "\u{1104}\u{1174}\u{11BE}",
        nfkc: "\u{B75B}",
        nfkd: "\u{1104}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B75C}",
        nfc: "\u{B75C}",
        nfd: "\u{1104}\u{1174}\u{11BF}",
        nfkc: "\u{B75C}",
        nfkd: "\u{1104}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B75D}",
        nfc: "\u{B75D}",
        nfd: "\u{1104}\u{1174}\u{11C0}",
        nfkc: "\u{B75D}",
        nfkd: "\u{1104}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B75E}",
        nfc: "\u{B75E}",
        nfd: "\u{1104}\u{1174}\u{11C1}",
        nfkc: "\u{B75E}",
        nfkd: "\u{1104}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B75F}",
        nfc: "\u{B75F}",
        nfd: "\u{1104}\u{1174}\u{11C2}",
        nfkc: "\u{B75F}",
        nfkd: "\u{1104}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B760}",
        nfc: "\u{B760}",
        nfd: "\u{1104}\u{1175}",
        nfkc: "\u{B760}",
        nfkd: "\u{1104}\u{1175}",
    },
    NormalizationTest {
        source: "\u{B761}",
        nfc: "\u{B761}",
        nfd: "\u{1104}\u{1175}\u{11A8}",
        nfkc: "\u{B761}",
        nfkd: "\u{1104}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B762}",
        nfc: "\u{B762}",
        nfd: "\u{1104}\u{1175}\u{11A9}",
        nfkc: "\u{B762}",
        nfkd: "\u{1104}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B763}",
        nfc: "\u{B763}",
        nfd: "\u{1104}\u{1175}\u{11AA}",
        nfkc: "\u{B763}",
        nfkd: "\u{1104}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B764}",
        nfc: "\u{B764}",
        nfd: "\u{1104}\u{1175}\u{11AB}",
        nfkc: "\u{B764}",
        nfkd: "\u{1104}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B765}",
        nfc: "\u{B765}",
        nfd: "\u{1104}\u{1175}\u{11AC}",
        nfkc: "\u{B765}",
        nfkd: "\u{1104}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B766}",
        nfc: "\u{B766}",
        nfd: "\u{1104}\u{1175}\u{11AD}",
        nfkc: "\u{B766}",
        nfkd: "\u{1104}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B767}",
        nfc: "\u{B767}",
        nfd: "\u{1104}\u{1175}\u{11AE}",
        nfkc: "\u{B767}",
        nfkd: "\u{1104}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B768}",
        nfc: "\u{B768}",
        nfd: "\u{1104}\u{1175}\u{11AF}",
        nfkc: "\u{B768}",
        nfkd: "\u{1104}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B769}",
        nfc: "\u{B769}",
        nfd: "\u{1104}\u{1175}\u{11B0}",
        nfkc: "\u{B769}",
        nfkd: "\u{1104}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B76A}",
        nfc: "\u{B76A}",
        nfd: "\u{1104}\u{1175}\u{11B1}",
        nfkc: "\u{B76A}",
        nfkd: "\u{1104}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B76B}",
        nfc: "\u{B76B}",
        nfd: "\u{1104}\u{1175}\u{11B2}",
        nfkc: "\u{B76B}",
        nfkd: "\u{1104}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B76C}",
        nfc: "\u{B76C}",
        nfd: "\u{1104}\u{1175}\u{11B3}",
        nfkc: "\u{B76C}",
        nfkd: "\u{1104}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B76D}",
        nfc: "\u{B76D}",
        nfd: "\u{1104}\u{1175}\u{11B4}",
        nfkc: "\u{B76D}",
        nfkd: "\u{1104}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B76E}",
        nfc: "\u{B76E}",
        nfd: "\u{1104}\u{1175}\u{11B5}",
        nfkc: "\u{B76E}",
        nfkd: "\u{1104}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B76F}",
        nfc: "\u{B76F}",
        nfd: "\u{1104}\u{1175}\u{11B6}",
        nfkc: "\u{B76F}",
        nfkd: "\u{1104}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B770}",
        nfc: "\u{B770}",
        nfd: "\u{1104}\u{1175}\u{11B7}",
        nfkc: "\u{B770}",
        nfkd: "\u{1104}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B771}",
        nfc: "\u{B771}",
        nfd: "\u{1104}\u{1175}\u{11B8}",
        nfkc: "\u{B771}",
        nfkd: "\u{1104}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B772}",
        nfc: "\u{B772}",
        nfd: "\u{1104}\u{1175}\u{11B9}",
        nfkc: "\u{B772}",
        nfkd: "\u{1104}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B773}",
        nfc: "\u{B773}",
        nfd: "\u{1104}\u{1175}\u{11BA}",
        nfkc: "\u{B773}",
        nfkd: "\u{1104}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B774}",
        nfc: "\u{B774}",
        nfd: "\u{1104}\u{1175}\u{11BB}",
        nfkc: "\u{B774}",
        nfkd: "\u{1104}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B775}",
        nfc: "\u{B775}",
        nfd: "\u{1104}\u{1175}\u{11BC}",
        nfkc: "\u{B775}",
        nfkd: "\u{1104}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B776}",
        nfc: "\u{B776}",
        nfd: "\u{1104}\u{1175}\u{11BD}",
        nfkc: "\u{B776}",
        nfkd: "\u{1104}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B777}",
        nfc: "\u{B777}",
        nfd: "\u{1104}\u{1175}\u{11BE}",
        nfkc: "\u{B777}",
        nfkd: "\u{1104}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B778}",
        nfc: "\u{B778}",
        nfd: "\u{1104}\u{1175}\u{11BF}",
        nfkc: "\u{B778}",
        nfkd: "\u{1104}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B779}",
        nfc: "\u{B779}",
        nfd: "\u{1104}\u{1175}\u{11C0}",
        nfkc: "\u{B779}",
        nfkd: "\u{1104}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B77A}",
        nfc: "\u{B77A}",
        nfd: "\u{1104}\u{1175}\u{11C1}",
        nfkc: "\u{B77A}",
        nfkd: "\u{1104}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B77B}",
        nfc: "\u{B77B}",
        nfd: "\u{1104}\u{1175}\u{11C2}",
        nfkc: "\u{B77B}",
        nfkd: "\u{1104}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B77C}",
        nfc: "\u{B77C}",
        nfd: "\u{1105}\u{1161}",
        nfkc: "\u{B77C}",
        nfkd: "\u{1105}\u{1161}",
    },
    NormalizationTest {
        source: "\u{B77D}",
        nfc: "\u{B77D}",
        nfd: "\u{1105}\u{1161}\u{11A8}",
        nfkc: "\u{B77D}",
        nfkd: "\u{1105}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B77E}",
        nfc: "\u{B77E}",
        nfd: "\u{1105}\u{1161}\u{11A9}",
        nfkc: "\u{B77E}",
        nfkd: "\u{1105}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B77F}",
        nfc: "\u{B77F}",
        nfd: "\u{1105}\u{1161}\u{11AA}",
        nfkc: "\u{B77F}",
        nfkd: "\u{1105}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B780}",
        nfc: "\u{B780}",
        nfd: "\u{1105}\u{1161}\u{11AB}",
        nfkc: "\u{B780}",
        nfkd: "\u{1105}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B781}",
        nfc: "\u{B781}",
        nfd: "\u{1105}\u{1161}\u{11AC}",
        nfkc: "\u{B781}",
        nfkd: "\u{1105}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B782}",
        nfc: "\u{B782}",
        nfd: "\u{1105}\u{1161}\u{11AD}",
        nfkc: "\u{B782}",
        nfkd: "\u{1105}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B783}",
        nfc: "\u{B783}",
        nfd: "\u{1105}\u{1161}\u{11AE}",
        nfkc: "\u{B783}",
        nfkd: "\u{1105}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B784}",
        nfc: "\u{B784}",
        nfd: "\u{1105}\u{1161}\u{11AF}",
        nfkc: "\u{B784}",
        nfkd: "\u{1105}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B785}",
        nfc: "\u{B785}",
        nfd: "\u{1105}\u{1161}\u{11B0}",
        nfkc: "\u{B785}",
        nfkd: "\u{1105}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B786}",
        nfc: "\u{B786}",
        nfd: "\u{1105}\u{1161}\u{11B1}",
        nfkc: "\u{B786}",
        nfkd: "\u{1105}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B787}",
        nfc: "\u{B787}",
        nfd: "\u{1105}\u{1161}\u{11B2}",
        nfkc: "\u{B787}",
        nfkd: "\u{1105}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B788}",
        nfc: "\u{B788}",
        nfd: "\u{1105}\u{1161}\u{11B3}",
        nfkc: "\u{B788}",
        nfkd: "\u{1105}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B789}",
        nfc: "\u{B789}",
        nfd: "\u{1105}\u{1161}\u{11B4}",
        nfkc: "\u{B789}",
        nfkd: "\u{1105}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B78A}",
        nfc: "\u{B78A}",
        nfd: "\u{1105}\u{1161}\u{11B5}",
        nfkc: "\u{B78A}",
        nfkd: "\u{1105}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B78B}",
        nfc: "\u{B78B}",
        nfd: "\u{1105}\u{1161}\u{11B6}",
        nfkc: "\u{B78B}",
        nfkd: "\u{1105}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B78C}",
        nfc: "\u{B78C}",
        nfd: "\u{1105}\u{1161}\u{11B7}",
        nfkc: "\u{B78C}",
        nfkd: "\u{1105}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B78D}",
        nfc: "\u{B78D}",
        nfd: "\u{1105}\u{1161}\u{11B8}",
        nfkc: "\u{B78D}",
        nfkd: "\u{1105}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B78E}",
        nfc: "\u{B78E}",
        nfd: "\u{1105}\u{1161}\u{11B9}",
        nfkc: "\u{B78E}",
        nfkd: "\u{1105}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B78F}",
        nfc: "\u{B78F}",
        nfd: "\u{1105}\u{1161}\u{11BA}",
        nfkc: "\u{B78F}",
        nfkd: "\u{1105}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B790}",
        nfc: "\u{B790}",
        nfd: "\u{1105}\u{1161}\u{11BB}",
        nfkc: "\u{B790}",
        nfkd: "\u{1105}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B791}",
        nfc: "\u{B791}",
        nfd: "\u{1105}\u{1161}\u{11BC}",
        nfkc: "\u{B791}",
        nfkd: "\u{1105}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B792}",
        nfc: "\u{B792}",
        nfd: "\u{1105}\u{1161}\u{11BD}",
        nfkc: "\u{B792}",
        nfkd: "\u{1105}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B793}",
        nfc: "\u{B793}",
        nfd: "\u{1105}\u{1161}\u{11BE}",
        nfkc: "\u{B793}",
        nfkd: "\u{1105}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B794}",
        nfc: "\u{B794}",
        nfd: "\u{1105}\u{1161}\u{11BF}",
        nfkc: "\u{B794}",
        nfkd: "\u{1105}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B795}",
        nfc: "\u{B795}",
        nfd: "\u{1105}\u{1161}\u{11C0}",
        nfkc: "\u{B795}",
        nfkd: "\u{1105}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B796}",
        nfc: "\u{B796}",
        nfd: "\u{1105}\u{1161}\u{11C1}",
        nfkc: "\u{B796}",
        nfkd: "\u{1105}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B797}",
        nfc: "\u{B797}",
        nfd: "\u{1105}\u{1161}\u{11C2}",
        nfkc: "\u{B797}",
        nfkd: "\u{1105}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B798}",
        nfc: "\u{B798}",
        nfd: "\u{1105}\u{1162}",
        nfkc: "\u{B798}",
        nfkd: "\u{1105}\u{1162}",
    },
    NormalizationTest {
        source: "\u{B799}",
        nfc: "\u{B799}",
        nfd: "\u{1105}\u{1162}\u{11A8}",
        nfkc: "\u{B799}",
        nfkd: "\u{1105}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B79A}",
        nfc: "\u{B79A}",
        nfd: "\u{1105}\u{1162}\u{11A9}",
        nfkc: "\u{B79A}",
        nfkd: "\u{1105}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B79B}",
        nfc: "\u{B79B}",
        nfd: "\u{1105}\u{1162}\u{11AA}",
        nfkc: "\u{B79B}",
        nfkd: "\u{1105}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B79C}",
        nfc: "\u{B79C}",
        nfd: "\u{1105}\u{1162}\u{11AB}",
        nfkc: "\u{B79C}",
        nfkd: "\u{1105}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B79D}",
        nfc: "\u{B79D}",
        nfd: "\u{1105}\u{1162}\u{11AC}",
        nfkc: "\u{B79D}",
        nfkd: "\u{1105}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B79E}",
        nfc: "\u{B79E}",
        nfd: "\u{1105}\u{1162}\u{11AD}",
        nfkc: "\u{B79E}",
        nfkd: "\u{1105}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B79F}",
        nfc: "\u{B79F}",
        nfd: "\u{1105}\u{1162}\u{11AE}",
        nfkc: "\u{B79F}",
        nfkd: "\u{1105}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B7A0}",
        nfc: "\u{B7A0}",
        nfd: "\u{1105}\u{1162}\u{11AF}",
        nfkc: "\u{B7A0}",
        nfkd: "\u{1105}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B7A1}",
        nfc: "\u{B7A1}",
        nfd: "\u{1105}\u{1162}\u{11B0}",
        nfkc: "\u{B7A1}",
        nfkd: "\u{1105}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B7A2}",
        nfc: "\u{B7A2}",
        nfd: "\u{1105}\u{1162}\u{11B1}",
        nfkc: "\u{B7A2}",
        nfkd: "\u{1105}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B7A3}",
        nfc: "\u{B7A3}",
        nfd: "\u{1105}\u{1162}\u{11B2}",
        nfkc: "\u{B7A3}",
        nfkd: "\u{1105}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B7A4}",
        nfc: "\u{B7A4}",
        nfd: "\u{1105}\u{1162}\u{11B3}",
        nfkc: "\u{B7A4}",
        nfkd: "\u{1105}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B7A5}",
        nfc: "\u{B7A5}",
        nfd: "\u{1105}\u{1162}\u{11B4}",
        nfkc: "\u{B7A5}",
        nfkd: "\u{1105}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B7A6}",
        nfc: "\u{B7A6}",
        nfd: "\u{1105}\u{1162}\u{11B5}",
        nfkc: "\u{B7A6}",
        nfkd: "\u{1105}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B7A7}",
        nfc: "\u{B7A7}",
        nfd: "\u{1105}\u{1162}\u{11B6}",
        nfkc: "\u{B7A7}",
        nfkd: "\u{1105}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B7A8}",
        nfc: "\u{B7A8}",
        nfd: "\u{1105}\u{1162}\u{11B7}",
        nfkc: "\u{B7A8}",
        nfkd: "\u{1105}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B7A9}",
        nfc: "\u{B7A9}",
        nfd: "\u{1105}\u{1162}\u{11B8}",
        nfkc: "\u{B7A9}",
        nfkd: "\u{1105}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B7AA}",
        nfc: "\u{B7AA}",
        nfd: "\u{1105}\u{1162}\u{11B9}",
        nfkc: "\u{B7AA}",
        nfkd: "\u{1105}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B7AB}",
        nfc: "\u{B7AB}",
        nfd: "\u{1105}\u{1162}\u{11BA}",
        nfkc: "\u{B7AB}",
        nfkd: "\u{1105}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B7AC}",
        nfc: "\u{B7AC}",
        nfd: "\u{1105}\u{1162}\u{11BB}",
        nfkc: "\u{B7AC}",
        nfkd: "\u{1105}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B7AD}",
        nfc: "\u{B7AD}",
        nfd: "\u{1105}\u{1162}\u{11BC}",
        nfkc: "\u{B7AD}",
        nfkd: "\u{1105}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B7AE}",
        nfc: "\u{B7AE}",
        nfd: "\u{1105}\u{1162}\u{11BD}",
        nfkc: "\u{B7AE}",
        nfkd: "\u{1105}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B7AF}",
        nfc: "\u{B7AF}",
        nfd: "\u{1105}\u{1162}\u{11BE}",
        nfkc: "\u{B7AF}",
        nfkd: "\u{1105}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B7B0}",
        nfc: "\u{B7B0}",
        nfd: "\u{1105}\u{1162}\u{11BF}",
        nfkc: "\u{B7B0}",
        nfkd: "\u{1105}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B7B1}",
        nfc: "\u{B7B1}",
        nfd: "\u{1105}\u{1162}\u{11C0}",
        nfkc: "\u{B7B1}",
        nfkd: "\u{1105}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B7B2}",
        nfc: "\u{B7B2}",
        nfd: "\u{1105}\u{1162}\u{11C1}",
        nfkc: "\u{B7B2}",
        nfkd: "\u{1105}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B7B3}",
        nfc: "\u{B7B3}",
        nfd: "\u{1105}\u{1162}\u{11C2}",
        nfkc: "\u{B7B3}",
        nfkd: "\u{1105}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B7B4}",
        nfc: "\u{B7B4}",
        nfd: "\u{1105}\u{1163}",
        nfkc: "\u{B7B4}",
        nfkd: "\u{1105}\u{1163}",
    },
    NormalizationTest {
        source: "\u{B7B5}",
        nfc: "\u{B7B5}",
        nfd: "\u{1105}\u{1163}\u{11A8}",
        nfkc: "\u{B7B5}",
        nfkd: "\u{1105}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B7B6}",
        nfc: "\u{B7B6}",
        nfd: "\u{1105}\u{1163}\u{11A9}",
        nfkc: "\u{B7B6}",
        nfkd: "\u{1105}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B7B7}",
        nfc: "\u{B7B7}",
        nfd: "\u{1105}\u{1163}\u{11AA}",
        nfkc: "\u{B7B7}",
        nfkd: "\u{1105}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B7B8}",
        nfc: "\u{B7B8}",
        nfd: "\u{1105}\u{1163}\u{11AB}",
        nfkc: "\u{B7B8}",
        nfkd: "\u{1105}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B7B9}",
        nfc: "\u{B7B9}",
        nfd: "\u{1105}\u{1163}\u{11AC}",
        nfkc: "\u{B7B9}",
        nfkd: "\u{1105}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B7BA}",
        nfc: "\u{B7BA}",
        nfd: "\u{1105}\u{1163}\u{11AD}",
        nfkc: "\u{B7BA}",
        nfkd: "\u{1105}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B7BB}",
        nfc: "\u{B7BB}",
        nfd: "\u{1105}\u{1163}\u{11AE}",
        nfkc: "\u{B7BB}",
        nfkd: "\u{1105}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B7BC}",
        nfc: "\u{B7BC}",
        nfd: "\u{1105}\u{1163}\u{11AF}",
        nfkc: "\u{B7BC}",
        nfkd: "\u{1105}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B7BD}",
        nfc: "\u{B7BD}",
        nfd: "\u{1105}\u{1163}\u{11B0}",
        nfkc: "\u{B7BD}",
        nfkd: "\u{1105}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B7BE}",
        nfc: "\u{B7BE}",
        nfd: "\u{1105}\u{1163}\u{11B1}",
        nfkc: "\u{B7BE}",
        nfkd: "\u{1105}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B7BF}",
        nfc: "\u{B7BF}",
        nfd: "\u{1105}\u{1163}\u{11B2}",
        nfkc: "\u{B7BF}",
        nfkd: "\u{1105}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B7C0}",
        nfc: "\u{B7C0}",
        nfd: "\u{1105}\u{1163}\u{11B3}",
        nfkc: "\u{B7C0}",
        nfkd: "\u{1105}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B7C1}",
        nfc: "\u{B7C1}",
        nfd: "\u{1105}\u{1163}\u{11B4}",
        nfkc: "\u{B7C1}",
        nfkd: "\u{1105}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B7C2}",
        nfc: "\u{B7C2}",
        nfd: "\u{1105}\u{1163}\u{11B5}",
        nfkc: "\u{B7C2}",
        nfkd: "\u{1105}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B7C3}",
        nfc: "\u{B7C3}",
        nfd: "\u{1105}\u{1163}\u{11B6}",
        nfkc: "\u{B7C3}",
        nfkd: "\u{1105}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B7C4}",
        nfc: "\u{B7C4}",
        nfd: "\u{1105}\u{1163}\u{11B7}",
        nfkc: "\u{B7C4}",
        nfkd: "\u{1105}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B7C5}",
        nfc: "\u{B7C5}",
        nfd: "\u{1105}\u{1163}\u{11B8}",
        nfkc: "\u{B7C5}",
        nfkd: "\u{1105}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B7C6}",
        nfc: "\u{B7C6}",
        nfd: "\u{1105}\u{1163}\u{11B9}",
        nfkc: "\u{B7C6}",
        nfkd: "\u{1105}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B7C7}",
        nfc: "\u{B7C7}",
        nfd: "\u{1105}\u{1163}\u{11BA}",
        nfkc: "\u{B7C7}",
        nfkd: "\u{1105}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B7C8}",
        nfc: "\u{B7C8}",
        nfd: "\u{1105}\u{1163}\u{11BB}",
        nfkc: "\u{B7C8}",
        nfkd: "\u{1105}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B7C9}",
        nfc: "\u{B7C9}",
        nfd: "\u{1105}\u{1163}\u{11BC}",
        nfkc: "\u{B7C9}",
        nfkd: "\u{1105}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B7CA}",
        nfc: "\u{B7CA}",
        nfd: "\u{1105}\u{1163}\u{11BD}",
        nfkc: "\u{B7CA}",
        nfkd: "\u{1105}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B7CB}",
        nfc: "\u{B7CB}",
        nfd: "\u{1105}\u{1163}\u{11BE}",
        nfkc: "\u{B7CB}",
        nfkd: "\u{1105}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B7CC}",
        nfc: "\u{B7CC}",
        nfd: "\u{1105}\u{1163}\u{11BF}",
        nfkc: "\u{B7CC}",
        nfkd: "\u{1105}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B7CD}",
        nfc: "\u{B7CD}",
        nfd: "\u{1105}\u{1163}\u{11C0}",
        nfkc: "\u{B7CD}",
        nfkd: "\u{1105}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B7CE}",
        nfc: "\u{B7CE}",
        nfd: "\u{1105}\u{1163}\u{11C1}",
        nfkc: "\u{B7CE}",
        nfkd: "\u{1105}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B7CF}",
        nfc: "\u{B7CF}",
        nfd: "\u{1105}\u{1163}\u{11C2}",
        nfkc: "\u{B7CF}",
        nfkd: "\u{1105}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B7D0}",
        nfc: "\u{B7D0}",
        nfd: "\u{1105}\u{1164}",
        nfkc: "\u{B7D0}",
        nfkd: "\u{1105}\u{1164}",
    },
    NormalizationTest {
        source: "\u{B7D1}",
        nfc: "\u{B7D1}",
        nfd: "\u{1105}\u{1164}\u{11A8}",
        nfkc: "\u{B7D1}",
        nfkd: "\u{1105}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B7D2}",
        nfc: "\u{B7D2}",
        nfd: "\u{1105}\u{1164}\u{11A9}",
        nfkc: "\u{B7D2}",
        nfkd: "\u{1105}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B7D3}",
        nfc: "\u{B7D3}",
        nfd: "\u{1105}\u{1164}\u{11AA}",
        nfkc: "\u{B7D3}",
        nfkd: "\u{1105}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B7D4}",
        nfc: "\u{B7D4}",
        nfd: "\u{1105}\u{1164}\u{11AB}",
        nfkc: "\u{B7D4}",
        nfkd: "\u{1105}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B7D5}",
        nfc: "\u{B7D5}",
        nfd: "\u{1105}\u{1164}\u{11AC}",
        nfkc: "\u{B7D5}",
        nfkd: "\u{1105}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B7D6}",
        nfc: "\u{B7D6}",
        nfd: "\u{1105}\u{1164}\u{11AD}",
        nfkc: "\u{B7D6}",
        nfkd: "\u{1105}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B7D7}",
        nfc: "\u{B7D7}",
        nfd: "\u{1105}\u{1164}\u{11AE}",
        nfkc: "\u{B7D7}",
        nfkd: "\u{1105}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B7D8}",
        nfc: "\u{B7D8}",
        nfd: "\u{1105}\u{1164}\u{11AF}",
        nfkc: "\u{B7D8}",
        nfkd: "\u{1105}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B7D9}",
        nfc: "\u{B7D9}",
        nfd: "\u{1105}\u{1164}\u{11B0}",
        nfkc: "\u{B7D9}",
        nfkd: "\u{1105}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B7DA}",
        nfc: "\u{B7DA}",
        nfd: "\u{1105}\u{1164}\u{11B1}",
        nfkc: "\u{B7DA}",
        nfkd: "\u{1105}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B7DB}",
        nfc: "\u{B7DB}",
        nfd: "\u{1105}\u{1164}\u{11B2}",
        nfkc: "\u{B7DB}",
        nfkd: "\u{1105}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B7DC}",
        nfc: "\u{B7DC}",
        nfd: "\u{1105}\u{1164}\u{11B3}",
        nfkc: "\u{B7DC}",
        nfkd: "\u{1105}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B7DD}",
        nfc: "\u{B7DD}",
        nfd: "\u{1105}\u{1164}\u{11B4}",
        nfkc: "\u{B7DD}",
        nfkd: "\u{1105}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B7DE}",
        nfc: "\u{B7DE}",
        nfd: "\u{1105}\u{1164}\u{11B5}",
        nfkc: "\u{B7DE}",
        nfkd: "\u{1105}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B7DF}",
        nfc: "\u{B7DF}",
        nfd: "\u{1105}\u{1164}\u{11B6}",
        nfkc: "\u{B7DF}",
        nfkd: "\u{1105}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B7E0}",
        nfc: "\u{B7E0}",
        nfd: "\u{1105}\u{1164}\u{11B7}",
        nfkc: "\u{B7E0}",
        nfkd: "\u{1105}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B7E1}",
        nfc: "\u{B7E1}",
        nfd: "\u{1105}\u{1164}\u{11B8}",
        nfkc: "\u{B7E1}",
        nfkd: "\u{1105}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B7E2}",
        nfc: "\u{B7E2}",
        nfd: "\u{1105}\u{1164}\u{11B9}",
        nfkc: "\u{B7E2}",
        nfkd: "\u{1105}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B7E3}",
        nfc: "\u{B7E3}",
        nfd: "\u{1105}\u{1164}\u{11BA}",
        nfkc: "\u{B7E3}",
        nfkd: "\u{1105}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B7E4}",
        nfc: "\u{B7E4}",
        nfd: "\u{1105}\u{1164}\u{11BB}",
        nfkc: "\u{B7E4}",
        nfkd: "\u{1105}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B7E5}",
        nfc: "\u{B7E5}",
        nfd: "\u{1105}\u{1164}\u{11BC}",
        nfkc: "\u{B7E5}",
        nfkd: "\u{1105}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B7E6}",
        nfc: "\u{B7E6}",
        nfd: "\u{1105}\u{1164}\u{11BD}",
        nfkc: "\u{B7E6}",
        nfkd: "\u{1105}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B7E7}",
        nfc: "\u{B7E7}",
        nfd: "\u{1105}\u{1164}\u{11BE}",
        nfkc: "\u{B7E7}",
        nfkd: "\u{1105}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B7E8}",
        nfc: "\u{B7E8}",
        nfd: "\u{1105}\u{1164}\u{11BF}",
        nfkc: "\u{B7E8}",
        nfkd: "\u{1105}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B7E9}",
        nfc: "\u{B7E9}",
        nfd: "\u{1105}\u{1164}\u{11C0}",
        nfkc: "\u{B7E9}",
        nfkd: "\u{1105}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B7EA}",
        nfc: "\u{B7EA}",
        nfd: "\u{1105}\u{1164}\u{11C1}",
        nfkc: "\u{B7EA}",
        nfkd: "\u{1105}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B7EB}",
        nfc: "\u{B7EB}",
        nfd: "\u{1105}\u{1164}\u{11C2}",
        nfkc: "\u{B7EB}",
        nfkd: "\u{1105}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B7EC}",
        nfc: "\u{B7EC}",
        nfd: "\u{1105}\u{1165}",
        nfkc: "\u{B7EC}",
        nfkd: "\u{1105}\u{1165}",
    },
    NormalizationTest {
        source: "\u{B7ED}",
        nfc: "\u{B7ED}",
        nfd: "\u{1105}\u{1165}\u{11A8}",
        nfkc: "\u{B7ED}",
        nfkd: "\u{1105}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B7EE}",
        nfc: "\u{B7EE}",
        nfd: "\u{1105}\u{1165}\u{11A9}",
        nfkc: "\u{B7EE}",
        nfkd: "\u{1105}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B7EF}",
        nfc: "\u{B7EF}",
        nfd: "\u{1105}\u{1165}\u{11AA}",
        nfkc: "\u{B7EF}",
        nfkd: "\u{1105}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B7F0}",
        nfc: "\u{B7F0}",
        nfd: "\u{1105}\u{1165}\u{11AB}",
        nfkc: "\u{B7F0}",
        nfkd: "\u{1105}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B7F1}",
        nfc: "\u{B7F1}",
        nfd: "\u{1105}\u{1165}\u{11AC}",
        nfkc: "\u{B7F1}",
        nfkd: "\u{1105}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B7F2}",
        nfc: "\u{B7F2}",
        nfd: "\u{1105}\u{1165}\u{11AD}",
        nfkc: "\u{B7F2}",
        nfkd: "\u{1105}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B7F3}",
        nfc: "\u{B7F3}",
        nfd: "\u{1105}\u{1165}\u{11AE}",
        nfkc: "\u{B7F3}",
        nfkd: "\u{1105}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B7F4}",
        nfc: "\u{B7F4}",
        nfd: "\u{1105}\u{1165}\u{11AF}",
        nfkc: "\u{B7F4}",
        nfkd: "\u{1105}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B7F5}",
        nfc: "\u{B7F5}",
        nfd: "\u{1105}\u{1165}\u{11B0}",
        nfkc: "\u{B7F5}",
        nfkd: "\u{1105}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B7F6}",
        nfc: "\u{B7F6}",
        nfd: "\u{1105}\u{1165}\u{11B1}",
        nfkc: "\u{B7F6}",
        nfkd: "\u{1105}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B7F7}",
        nfc: "\u{B7F7}",
        nfd: "\u{1105}\u{1165}\u{11B2}",
        nfkc: "\u{B7F7}",
        nfkd: "\u{1105}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B7F8}",
        nfc: "\u{B7F8}",
        nfd: "\u{1105}\u{1165}\u{11B3}",
        nfkc: "\u{B7F8}",
        nfkd: "\u{1105}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B7F9}",
        nfc: "\u{B7F9}",
        nfd: "\u{1105}\u{1165}\u{11B4}",
        nfkc: "\u{B7F9}",
        nfkd: "\u{1105}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B7FA}",
        nfc: "\u{B7FA}",
        nfd: "\u{1105}\u{1165}\u{11B5}",
        nfkc: "\u{B7FA}",
        nfkd: "\u{1105}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B7FB}",
        nfc: "\u{B7FB}",
        nfd: "\u{1105}\u{1165}\u{11B6}",
        nfkc: "\u{B7FB}",
        nfkd: "\u{1105}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B7FC}",
        nfc: "\u{B7FC}",
        nfd: "\u{1105}\u{1165}\u{11B7}",
        nfkc: "\u{B7FC}",
        nfkd: "\u{1105}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B7FD}",
        nfc: "\u{B7FD}",
        nfd: "\u{1105}\u{1165}\u{11B8}",
        nfkc: "\u{B7FD}",
        nfkd: "\u{1105}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B7FE}",
        nfc: "\u{B7FE}",
        nfd: "\u{1105}\u{1165}\u{11B9}",
        nfkc: "\u{B7FE}",
        nfkd: "\u{1105}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B7FF}",
        nfc: "\u{B7FF}",
        nfd: "\u{1105}\u{1165}\u{11BA}",
        nfkc: "\u{B7FF}",
        nfkd: "\u{1105}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B800}",
        nfc: "\u{B800}",
        nfd: "\u{1105}\u{1165}\u{11BB}",
        nfkc: "\u{B800}",
        nfkd: "\u{1105}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B801}",
        nfc: "\u{B801}",
        nfd: "\u{1105}\u{1165}\u{11BC}",
        nfkc: "\u{B801}",
        nfkd: "\u{1105}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B802}",
        nfc: "\u{B802}",
        nfd: "\u{1105}\u{1165}\u{11BD}",
        nfkc: "\u{B802}",
        nfkd: "\u{1105}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B803}",
        nfc: "\u{B803}",
        nfd: "\u{1105}\u{1165}\u{11BE}",
        nfkc: "\u{B803}",
        nfkd: "\u{1105}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B804}",
        nfc: "\u{B804}",
        nfd: "\u{1105}\u{1165}\u{11BF}",
        nfkc: "\u{B804}",
        nfkd: "\u{1105}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B805}",
        nfc: "\u{B805}",
        nfd: "\u{1105}\u{1165}\u{11C0}",
        nfkc: "\u{B805}",
        nfkd: "\u{1105}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B806}",
        nfc: "\u{B806}",
        nfd: "\u{1105}\u{1165}\u{11C1}",
        nfkc: "\u{B806}",
        nfkd: "\u{1105}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B807}",
        nfc: "\u{B807}",
        nfd: "\u{1105}\u{1165}\u{11C2}",
        nfkc: "\u{B807}",
        nfkd: "\u{1105}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B808}",
        nfc: "\u{B808}",
        nfd: "\u{1105}\u{1166}",
        nfkc: "\u{B808}",
        nfkd: "\u{1105}\u{1166}",
    },
    NormalizationTest {
        source: "\u{B809}",
        nfc: "\u{B809}",
        nfd: "\u{1105}\u{1166}\u{11A8}",
        nfkc: "\u{B809}",
        nfkd: "\u{1105}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B80A}",
        nfc: "\u{B80A}",
        nfd: "\u{1105}\u{1166}\u{11A9}",
        nfkc: "\u{B80A}",
        nfkd: "\u{1105}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B80B}",
        nfc: "\u{B80B}",
        nfd: "\u{1105}\u{1166}\u{11AA}",
        nfkc: "\u{B80B}",
        nfkd: "\u{1105}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B80C}",
        nfc: "\u{B80C}",
        nfd: "\u{1105}\u{1166}\u{11AB}",
        nfkc: "\u{B80C}",
        nfkd: "\u{1105}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B80D}",
        nfc: "\u{B80D}",
        nfd: "\u{1105}\u{1166}\u{11AC}",
        nfkc: "\u{B80D}",
        nfkd: "\u{1105}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B80E}",
        nfc: "\u{B80E}",
        nfd: "\u{1105}\u{1166}\u{11AD}",
        nfkc: "\u{B80E}",
        nfkd: "\u{1105}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B80F}",
        nfc: "\u{B80F}",
        nfd: "\u{1105}\u{1166}\u{11AE}",
        nfkc: "\u{B80F}",
        nfkd: "\u{1105}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B810}",
        nfc: "\u{B810}",
        nfd: "\u{1105}\u{1166}\u{11AF}",
        nfkc: "\u{B810}",
        nfkd: "\u{1105}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B811}",
        nfc: "\u{B811}",
        nfd: "\u{1105}\u{1166}\u{11B0}",
        nfkc: "\u{B811}",
        nfkd: "\u{1105}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B812}",
        nfc: "\u{B812}",
        nfd: "\u{1105}\u{1166}\u{11B1}",
        nfkc: "\u{B812}",
        nfkd: "\u{1105}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B813}",
        nfc: "\u{B813}",
        nfd: "\u{1105}\u{1166}\u{11B2}",
        nfkc: "\u{B813}",
        nfkd: "\u{1105}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B814}",
        nfc: "\u{B814}",
        nfd: "\u{1105}\u{1166}\u{11B3}",
        nfkc: "\u{B814}",
        nfkd: "\u{1105}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B815}",
        nfc: "\u{B815}",
        nfd: "\u{1105}\u{1166}\u{11B4}",
        nfkc: "\u{B815}",
        nfkd: "\u{1105}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B816}",
        nfc: "\u{B816}",
        nfd: "\u{1105}\u{1166}\u{11B5}",
        nfkc: "\u{B816}",
        nfkd: "\u{1105}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B817}",
        nfc: "\u{B817}",
        nfd: "\u{1105}\u{1166}\u{11B6}",
        nfkc: "\u{B817}",
        nfkd: "\u{1105}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B818}",
        nfc: "\u{B818}",
        nfd: "\u{1105}\u{1166}\u{11B7}",
        nfkc: "\u{B818}",
        nfkd: "\u{1105}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B819}",
        nfc: "\u{B819}",
        nfd: "\u{1105}\u{1166}\u{11B8}",
        nfkc: "\u{B819}",
        nfkd: "\u{1105}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B81A}",
        nfc: "\u{B81A}",
        nfd: "\u{1105}\u{1166}\u{11B9}",
        nfkc: "\u{B81A}",
        nfkd: "\u{1105}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B81B}",
        nfc: "\u{B81B}",
        nfd: "\u{1105}\u{1166}\u{11BA}",
        nfkc: "\u{B81B}",
        nfkd: "\u{1105}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B81C}",
        nfc: "\u{B81C}",
        nfd: "\u{1105}\u{1166}\u{11BB}",
        nfkc: "\u{B81C}",
        nfkd: "\u{1105}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B81D}",
        nfc: "\u{B81D}",
        nfd: "\u{1105}\u{1166}\u{11BC}",
        nfkc: "\u{B81D}",
        nfkd: "\u{1105}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B81E}",
        nfc: "\u{B81E}",
        nfd: "\u{1105}\u{1166}\u{11BD}",
        nfkc: "\u{B81E}",
        nfkd: "\u{1105}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B81F}",
        nfc: "\u{B81F}",
        nfd: "\u{1105}\u{1166}\u{11BE}",
        nfkc: "\u{B81F}",
        nfkd: "\u{1105}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B820}",
        nfc: "\u{B820}",
        nfd: "\u{1105}\u{1166}\u{11BF}",
        nfkc: "\u{B820}",
        nfkd: "\u{1105}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B821}",
        nfc: "\u{B821}",
        nfd: "\u{1105}\u{1166}\u{11C0}",
        nfkc: "\u{B821}",
        nfkd: "\u{1105}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B822}",
        nfc: "\u{B822}",
        nfd: "\u{1105}\u{1166}\u{11C1}",
        nfkc: "\u{B822}",
        nfkd: "\u{1105}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B823}",
        nfc: "\u{B823}",
        nfd: "\u{1105}\u{1166}\u{11C2}",
        nfkc: "\u{B823}",
        nfkd: "\u{1105}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B824}",
        nfc: "\u{B824}",
        nfd: "\u{1105}\u{1167}",
        nfkc: "\u{B824}",
        nfkd: "\u{1105}\u{1167}",
    },
    NormalizationTest {
        source: "\u{B825}",
        nfc: "\u{B825}",
        nfd: "\u{1105}\u{1167}\u{11A8}",
        nfkc: "\u{B825}",
        nfkd: "\u{1105}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B826}",
        nfc: "\u{B826}",
        nfd: "\u{1105}\u{1167}\u{11A9}",
        nfkc: "\u{B826}",
        nfkd: "\u{1105}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B827}",
        nfc: "\u{B827}",
        nfd: "\u{1105}\u{1167}\u{11AA}",
        nfkc: "\u{B827}",
        nfkd: "\u{1105}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B828}",
        nfc: "\u{B828}",
        nfd: "\u{1105}\u{1167}\u{11AB}",
        nfkc: "\u{B828}",
        nfkd: "\u{1105}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B829}",
        nfc: "\u{B829}",
        nfd: "\u{1105}\u{1167}\u{11AC}",
        nfkc: "\u{B829}",
        nfkd: "\u{1105}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B82A}",
        nfc: "\u{B82A}",
        nfd: "\u{1105}\u{1167}\u{11AD}",
        nfkc: "\u{B82A}",
        nfkd: "\u{1105}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B82B}",
        nfc: "\u{B82B}",
        nfd: "\u{1105}\u{1167}\u{11AE}",
        nfkc: "\u{B82B}",
        nfkd: "\u{1105}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B82C}",
        nfc: "\u{B82C}",
        nfd: "\u{1105}\u{1167}\u{11AF}",
        nfkc: "\u{B82C}",
        nfkd: "\u{1105}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B82D}",
        nfc: "\u{B82D}",
        nfd: "\u{1105}\u{1167}\u{11B0}",
        nfkc: "\u{B82D}",
        nfkd: "\u{1105}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B82E}",
        nfc: "\u{B82E}",
        nfd: "\u{1105}\u{1167}\u{11B1}",
        nfkc: "\u{B82E}",
        nfkd: "\u{1105}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B82F}",
        nfc: "\u{B82F}",
        nfd: "\u{1105}\u{1167}\u{11B2}",
        nfkc: "\u{B82F}",
        nfkd: "\u{1105}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B830}",
        nfc: "\u{B830}",
        nfd: "\u{1105}\u{1167}\u{11B3}",
        nfkc: "\u{B830}",
        nfkd: "\u{1105}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B831}",
        nfc: "\u{B831}",
        nfd: "\u{1105}\u{1167}\u{11B4}",
        nfkc: "\u{B831}",
        nfkd: "\u{1105}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B832}",
        nfc: "\u{B832}",
        nfd: "\u{1105}\u{1167}\u{11B5}",
        nfkc: "\u{B832}",
        nfkd: "\u{1105}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B833}",
        nfc: "\u{B833}",
        nfd: "\u{1105}\u{1167}\u{11B6}",
        nfkc: "\u{B833}",
        nfkd: "\u{1105}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B834}",
        nfc: "\u{B834}",
        nfd: "\u{1105}\u{1167}\u{11B7}",
        nfkc: "\u{B834}",
        nfkd: "\u{1105}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B835}",
        nfc: "\u{B835}",
        nfd: "\u{1105}\u{1167}\u{11B8}",
        nfkc: "\u{B835}",
        nfkd: "\u{1105}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B836}",
        nfc: "\u{B836}",
        nfd: "\u{1105}\u{1167}\u{11B9}",
        nfkc: "\u{B836}",
        nfkd: "\u{1105}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B837}",
        nfc: "\u{B837}",
        nfd: "\u{1105}\u{1167}\u{11BA}",
        nfkc: "\u{B837}",
        nfkd: "\u{1105}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B838}",
        nfc: "\u{B838}",
        nfd: "\u{1105}\u{1167}\u{11BB}",
        nfkc: "\u{B838}",
        nfkd: "\u{1105}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B839}",
        nfc: "\u{B839}",
        nfd: "\u{1105}\u{1167}\u{11BC}",
        nfkc: "\u{B839}",
        nfkd: "\u{1105}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B83A}",
        nfc: "\u{B83A}",
        nfd: "\u{1105}\u{1167}\u{11BD}",
        nfkc: "\u{B83A}",
        nfkd: "\u{1105}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B83B}",
        nfc: "\u{B83B}",
        nfd: "\u{1105}\u{1167}\u{11BE}",
        nfkc: "\u{B83B}",
        nfkd: "\u{1105}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B83C}",
        nfc: "\u{B83C}",
        nfd: "\u{1105}\u{1167}\u{11BF}",
        nfkc: "\u{B83C}",
        nfkd: "\u{1105}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B83D}",
        nfc: "\u{B83D}",
        nfd: "\u{1105}\u{1167}\u{11C0}",
        nfkc: "\u{B83D}",
        nfkd: "\u{1105}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B83E}",
        nfc: "\u{B83E}",
        nfd: "\u{1105}\u{1167}\u{11C1}",
        nfkc: "\u{B83E}",
        nfkd: "\u{1105}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B83F}",
        nfc: "\u{B83F}",
        nfd: "\u{1105}\u{1167}\u{11C2}",
        nfkc: "\u{B83F}",
        nfkd: "\u{1105}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B840}",
        nfc: "\u{B840}",
        nfd: "\u{1105}\u{1168}",
        nfkc: "\u{B840}",
        nfkd: "\u{1105}\u{1168}",
    },
    NormalizationTest {
        source: "\u{B841}",
        nfc: "\u{B841}",
        nfd: "\u{1105}\u{1168}\u{11A8}",
        nfkc: "\u{B841}",
        nfkd: "\u{1105}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B842}",
        nfc: "\u{B842}",
        nfd: "\u{1105}\u{1168}\u{11A9}",
        nfkc: "\u{B842}",
        nfkd: "\u{1105}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B843}",
        nfc: "\u{B843}",
        nfd: "\u{1105}\u{1168}\u{11AA}",
        nfkc: "\u{B843}",
        nfkd: "\u{1105}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B844}",
        nfc: "\u{B844}",
        nfd: "\u{1105}\u{1168}\u{11AB}",
        nfkc: "\u{B844}",
        nfkd: "\u{1105}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B845}",
        nfc: "\u{B845}",
        nfd: "\u{1105}\u{1168}\u{11AC}",
        nfkc: "\u{B845}",
        nfkd: "\u{1105}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B846}",
        nfc: "\u{B846}",
        nfd: "\u{1105}\u{1168}\u{11AD}",
        nfkc: "\u{B846}",
        nfkd: "\u{1105}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B847}",
        nfc: "\u{B847}",
        nfd: "\u{1105}\u{1168}\u{11AE}",
        nfkc: "\u{B847}",
        nfkd: "\u{1105}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B848}",
        nfc: "\u{B848}",
        nfd: "\u{1105}\u{1168}\u{11AF}",
        nfkc: "\u{B848}",
        nfkd: "\u{1105}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B849}",
        nfc: "\u{B849}",
        nfd: "\u{1105}\u{1168}\u{11B0}",
        nfkc: "\u{B849}",
        nfkd: "\u{1105}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B84A}",
        nfc: "\u{B84A}",
        nfd: "\u{1105}\u{1168}\u{11B1}",
        nfkc: "\u{B84A}",
        nfkd: "\u{1105}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B84B}",
        nfc: "\u{B84B}",
        nfd: "\u{1105}\u{1168}\u{11B2}",
        nfkc: "\u{B84B}",
        nfkd: "\u{1105}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B84C}",
        nfc: "\u{B84C}",
        nfd: "\u{1105}\u{1168}\u{11B3}",
        nfkc: "\u{B84C}",
        nfkd: "\u{1105}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B84D}",
        nfc: "\u{B84D}",
        nfd: "\u{1105}\u{1168}\u{11B4}",
        nfkc: "\u{B84D}",
        nfkd: "\u{1105}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B84E}",
        nfc: "\u{B84E}",
        nfd: "\u{1105}\u{1168}\u{11B5}",
        nfkc: "\u{B84E}",
        nfkd: "\u{1105}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B84F}",
        nfc: "\u{B84F}",
        nfd: "\u{1105}\u{1168}\u{11B6}",
        nfkc: "\u{B84F}",
        nfkd: "\u{1105}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B850}",
        nfc: "\u{B850}",
        nfd: "\u{1105}\u{1168}\u{11B7}",
        nfkc: "\u{B850}",
        nfkd: "\u{1105}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B851}",
        nfc: "\u{B851}",
        nfd: "\u{1105}\u{1168}\u{11B8}",
        nfkc: "\u{B851}",
        nfkd: "\u{1105}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B852}",
        nfc: "\u{B852}",
        nfd: "\u{1105}\u{1168}\u{11B9}",
        nfkc: "\u{B852}",
        nfkd: "\u{1105}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B853}",
        nfc: "\u{B853}",
        nfd: "\u{1105}\u{1168}\u{11BA}",
        nfkc: "\u{B853}",
        nfkd: "\u{1105}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B854}",
        nfc: "\u{B854}",
        nfd: "\u{1105}\u{1168}\u{11BB}",
        nfkc: "\u{B854}",
        nfkd: "\u{1105}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B855}",
        nfc: "\u{B855}",
        nfd: "\u{1105}\u{1168}\u{11BC}",
        nfkc: "\u{B855}",
        nfkd: "\u{1105}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B856}",
        nfc: "\u{B856}",
        nfd: "\u{1105}\u{1168}\u{11BD}",
        nfkc: "\u{B856}",
        nfkd: "\u{1105}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B857}",
        nfc: "\u{B857}",
        nfd: "\u{1105}\u{1168}\u{11BE}",
        nfkc: "\u{B857}",
        nfkd: "\u{1105}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B858}",
        nfc: "\u{B858}",
        nfd: "\u{1105}\u{1168}\u{11BF}",
        nfkc: "\u{B858}",
        nfkd: "\u{1105}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B859}",
        nfc: "\u{B859}",
        nfd: "\u{1105}\u{1168}\u{11C0}",
        nfkc: "\u{B859}",
        nfkd: "\u{1105}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B85A}",
        nfc: "\u{B85A}",
        nfd: "\u{1105}\u{1168}\u{11C1}",
        nfkc: "\u{B85A}",
        nfkd: "\u{1105}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B85B}",
        nfc: "\u{B85B}",
        nfd: "\u{1105}\u{1168}\u{11C2}",
        nfkc: "\u{B85B}",
        nfkd: "\u{1105}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B85C}",
        nfc: "\u{B85C}",
        nfd: "\u{1105}\u{1169}",
        nfkc: "\u{B85C}",
        nfkd: "\u{1105}\u{1169}",
    },
    NormalizationTest {
        source: "\u{B85D}",
        nfc: "\u{B85D}",
        nfd: "\u{1105}\u{1169}\u{11A8}",
        nfkc: "\u{B85D}",
        nfkd: "\u{1105}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B85E}",
        nfc: "\u{B85E}",
        nfd: "\u{1105}\u{1169}\u{11A9}",
        nfkc: "\u{B85E}",
        nfkd: "\u{1105}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B85F}",
        nfc: "\u{B85F}",
        nfd: "\u{1105}\u{1169}\u{11AA}",
        nfkc: "\u{B85F}",
        nfkd: "\u{1105}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B860}",
        nfc: "\u{B860}",
        nfd: "\u{1105}\u{1169}\u{11AB}",
        nfkc: "\u{B860}",
        nfkd: "\u{1105}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B861}",
        nfc: "\u{B861}",
        nfd: "\u{1105}\u{1169}\u{11AC}",
        nfkc: "\u{B861}",
        nfkd: "\u{1105}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B862}",
        nfc: "\u{B862}",
        nfd: "\u{1105}\u{1169}\u{11AD}",
        nfkc: "\u{B862}",
        nfkd: "\u{1105}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B863}",
        nfc: "\u{B863}",
        nfd: "\u{1105}\u{1169}\u{11AE}",
        nfkc: "\u{B863}",
        nfkd: "\u{1105}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B864}",
        nfc: "\u{B864}",
        nfd: "\u{1105}\u{1169}\u{11AF}",
        nfkc: "\u{B864}",
        nfkd: "\u{1105}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B865}",
        nfc: "\u{B865}",
        nfd: "\u{1105}\u{1169}\u{11B0}",
        nfkc: "\u{B865}",
        nfkd: "\u{1105}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B866}",
        nfc: "\u{B866}",
        nfd: "\u{1105}\u{1169}\u{11B1}",
        nfkc: "\u{B866}",
        nfkd: "\u{1105}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B867}",
        nfc: "\u{B867}",
        nfd: "\u{1105}\u{1169}\u{11B2}",
        nfkc: "\u{B867}",
        nfkd: "\u{1105}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B868}",
        nfc: "\u{B868}",
        nfd: "\u{1105}\u{1169}\u{11B3}",
        nfkc: "\u{B868}",
        nfkd: "\u{1105}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B869}",
        nfc: "\u{B869}",
        nfd: "\u{1105}\u{1169}\u{11B4}",
        nfkc: "\u{B869}",
        nfkd: "\u{1105}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B86A}",
        nfc: "\u{B86A}",
        nfd: "\u{1105}\u{1169}\u{11B5}",
        nfkc: "\u{B86A}",
        nfkd: "\u{1105}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B86B}",
        nfc: "\u{B86B}",
        nfd: "\u{1105}\u{1169}\u{11B6}",
        nfkc: "\u{B86B}",
        nfkd: "\u{1105}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B86C}",
        nfc: "\u{B86C}",
        nfd: "\u{1105}\u{1169}\u{11B7}",
        nfkc: "\u{B86C}",
        nfkd: "\u{1105}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B86D}",
        nfc: "\u{B86D}",
        nfd: "\u{1105}\u{1169}\u{11B8}",
        nfkc: "\u{B86D}",
        nfkd: "\u{1105}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B86E}",
        nfc: "\u{B86E}",
        nfd: "\u{1105}\u{1169}\u{11B9}",
        nfkc: "\u{B86E}",
        nfkd: "\u{1105}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B86F}",
        nfc: "\u{B86F}",
        nfd: "\u{1105}\u{1169}\u{11BA}",
        nfkc: "\u{B86F}",
        nfkd: "\u{1105}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B870}",
        nfc: "\u{B870}",
        nfd: "\u{1105}\u{1169}\u{11BB}",
        nfkc: "\u{B870}",
        nfkd: "\u{1105}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B871}",
        nfc: "\u{B871}",
        nfd: "\u{1105}\u{1169}\u{11BC}",
        nfkc: "\u{B871}",
        nfkd: "\u{1105}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B872}",
        nfc: "\u{B872}",
        nfd: "\u{1105}\u{1169}\u{11BD}",
        nfkc: "\u{B872}",
        nfkd: "\u{1105}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B873}",
        nfc: "\u{B873}",
        nfd: "\u{1105}\u{1169}\u{11BE}",
        nfkc: "\u{B873}",
        nfkd: "\u{1105}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B874}",
        nfc: "\u{B874}",
        nfd: "\u{1105}\u{1169}\u{11BF}",
        nfkc: "\u{B874}",
        nfkd: "\u{1105}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B875}",
        nfc: "\u{B875}",
        nfd: "\u{1105}\u{1169}\u{11C0}",
        nfkc: "\u{B875}",
        nfkd: "\u{1105}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B876}",
        nfc: "\u{B876}",
        nfd: "\u{1105}\u{1169}\u{11C1}",
        nfkc: "\u{B876}",
        nfkd: "\u{1105}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B877}",
        nfc: "\u{B877}",
        nfd: "\u{1105}\u{1169}\u{11C2}",
        nfkc: "\u{B877}",
        nfkd: "\u{1105}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B878}",
        nfc: "\u{B878}",
        nfd: "\u{1105}\u{116A}",
        nfkc: "\u{B878}",
        nfkd: "\u{1105}\u{116A}",
    },
    NormalizationTest {
        source: "\u{B879}",
        nfc: "\u{B879}",
        nfd: "\u{1105}\u{116A}\u{11A8}",
        nfkc: "\u{B879}",
        nfkd: "\u{1105}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B87A}",
        nfc: "\u{B87A}",
        nfd: "\u{1105}\u{116A}\u{11A9}",
        nfkc: "\u{B87A}",
        nfkd: "\u{1105}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B87B}",
        nfc: "\u{B87B}",
        nfd: "\u{1105}\u{116A}\u{11AA}",
        nfkc: "\u{B87B}",
        nfkd: "\u{1105}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B87C}",
        nfc: "\u{B87C}",
        nfd: "\u{1105}\u{116A}\u{11AB}",
        nfkc: "\u{B87C}",
        nfkd: "\u{1105}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B87D}",
        nfc: "\u{B87D}",
        nfd: "\u{1105}\u{116A}\u{11AC}",
        nfkc: "\u{B87D}",
        nfkd: "\u{1105}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B87E}",
        nfc: "\u{B87E}",
        nfd: "\u{1105}\u{116A}\u{11AD}",
        nfkc: "\u{B87E}",
        nfkd: "\u{1105}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B87F}",
        nfc: "\u{B87F}",
        nfd: "\u{1105}\u{116A}\u{11AE}",
        nfkc: "\u{B87F}",
        nfkd: "\u{1105}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B880}",
        nfc: "\u{B880}",
        nfd: "\u{1105}\u{116A}\u{11AF}",
        nfkc: "\u{B880}",
        nfkd: "\u{1105}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B881}",
        nfc: "\u{B881}",
        nfd: "\u{1105}\u{116A}\u{11B0}",
        nfkc: "\u{B881}",
        nfkd: "\u{1105}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B882}",
        nfc: "\u{B882}",
        nfd: "\u{1105}\u{116A}\u{11B1}",
        nfkc: "\u{B882}",
        nfkd: "\u{1105}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B883}",
        nfc: "\u{B883}",
        nfd: "\u{1105}\u{116A}\u{11B2}",
        nfkc: "\u{B883}",
        nfkd: "\u{1105}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B884}",
        nfc: "\u{B884}",
        nfd: "\u{1105}\u{116A}\u{11B3}",
        nfkc: "\u{B884}",
        nfkd: "\u{1105}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B885}",
        nfc: "\u{B885}",
        nfd: "\u{1105}\u{116A}\u{11B4}",
        nfkc: "\u{B885}",
        nfkd: "\u{1105}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B886}",
        nfc: "\u{B886}",
        nfd: "\u{1105}\u{116A}\u{11B5}",
        nfkc: "\u{B886}",
        nfkd: "\u{1105}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B887}",
        nfc: "\u{B887}",
        nfd: "\u{1105}\u{116A}\u{11B6}",
        nfkc: "\u{B887}",
        nfkd: "\u{1105}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B888}",
        nfc: "\u{B888}",
        nfd: "\u{1105}\u{116A}\u{11B7}",
        nfkc: "\u{B888}",
        nfkd: "\u{1105}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B889}",
        nfc: "\u{B889}",
        nfd: "\u{1105}\u{116A}\u{11B8}",
        nfkc: "\u{B889}",
        nfkd: "\u{1105}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B88A}",
        nfc: "\u{B88A}",
        nfd: "\u{1105}\u{116A}\u{11B9}",
        nfkc: "\u{B88A}",
        nfkd: "\u{1105}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B88B}",
        nfc: "\u{B88B}",
        nfd: "\u{1105}\u{116A}\u{11BA}",
        nfkc: "\u{B88B}",
        nfkd: "\u{1105}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B88C}",
        nfc: "\u{B88C}",
        nfd: "\u{1105}\u{116A}\u{11BB}",
        nfkc: "\u{B88C}",
        nfkd: "\u{1105}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B88D}",
        nfc: "\u{B88D}",
        nfd: "\u{1105}\u{116A}\u{11BC}",
        nfkc: "\u{B88D}",
        nfkd: "\u{1105}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B88E}",
        nfc: "\u{B88E}",
        nfd: "\u{1105}\u{116A}\u{11BD}",
        nfkc: "\u{B88E}",
        nfkd: "\u{1105}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B88F}",
        nfc: "\u{B88F}",
        nfd: "\u{1105}\u{116A}\u{11BE}",
        nfkc: "\u{B88F}",
        nfkd: "\u{1105}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B890}",
        nfc: "\u{B890}",
        nfd: "\u{1105}\u{116A}\u{11BF}",
        nfkc: "\u{B890}",
        nfkd: "\u{1105}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B891}",
        nfc: "\u{B891}",
        nfd: "\u{1105}\u{116A}\u{11C0}",
        nfkc: "\u{B891}",
        nfkd: "\u{1105}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B892}",
        nfc: "\u{B892}",
        nfd: "\u{1105}\u{116A}\u{11C1}",
        nfkc: "\u{B892}",
        nfkd: "\u{1105}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B893}",
        nfc: "\u{B893}",
        nfd: "\u{1105}\u{116A}\u{11C2}",
        nfkc: "\u{B893}",
        nfkd: "\u{1105}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B894}",
        nfc: "\u{B894}",
        nfd: "\u{1105}\u{116B}",
        nfkc: "\u{B894}",
        nfkd: "\u{1105}\u{116B}",
    },
    NormalizationTest {
        source: "\u{B895}",
        nfc: "\u{B895}",
        nfd: "\u{1105}\u{116B}\u{11A8}",
        nfkc: "\u{B895}",
        nfkd: "\u{1105}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B896}",
        nfc: "\u{B896}",
        nfd: "\u{1105}\u{116B}\u{11A9}",
        nfkc: "\u{B896}",
        nfkd: "\u{1105}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B897}",
        nfc: "\u{B897}",
        nfd: "\u{1105}\u{116B}\u{11AA}",
        nfkc: "\u{B897}",
        nfkd: "\u{1105}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B898}",
        nfc: "\u{B898}",
        nfd: "\u{1105}\u{116B}\u{11AB}",
        nfkc: "\u{B898}",
        nfkd: "\u{1105}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B899}",
        nfc: "\u{B899}",
        nfd: "\u{1105}\u{116B}\u{11AC}",
        nfkc: "\u{B899}",
        nfkd: "\u{1105}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B89A}",
        nfc: "\u{B89A}",
        nfd: "\u{1105}\u{116B}\u{11AD}",
        nfkc: "\u{B89A}",
        nfkd: "\u{1105}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B89B}",
        nfc: "\u{B89B}",
        nfd: "\u{1105}\u{116B}\u{11AE}",
        nfkc: "\u{B89B}",
        nfkd: "\u{1105}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B89C}",
        nfc: "\u{B89C}",
        nfd: "\u{1105}\u{116B}\u{11AF}",
        nfkc: "\u{B89C}",
        nfkd: "\u{1105}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B89D}",
        nfc: "\u{B89D}",
        nfd: "\u{1105}\u{116B}\u{11B0}",
        nfkc: "\u{B89D}",
        nfkd: "\u{1105}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B89E}",
        nfc: "\u{B89E}",
        nfd: "\u{1105}\u{116B}\u{11B1}",
        nfkc: "\u{B89E}",
        nfkd: "\u{1105}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B89F}",
        nfc: "\u{B89F}",
        nfd: "\u{1105}\u{116B}\u{11B2}",
        nfkc: "\u{B89F}",
        nfkd: "\u{1105}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B8A0}",
        nfc: "\u{B8A0}",
        nfd: "\u{1105}\u{116B}\u{11B3}",
        nfkc: "\u{B8A0}",
        nfkd: "\u{1105}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B8A1}",
        nfc: "\u{B8A1}",
        nfd: "\u{1105}\u{116B}\u{11B4}",
        nfkc: "\u{B8A1}",
        nfkd: "\u{1105}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B8A2}",
        nfc: "\u{B8A2}",
        nfd: "\u{1105}\u{116B}\u{11B5}",
        nfkc: "\u{B8A2}",
        nfkd: "\u{1105}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B8A3}",
        nfc: "\u{B8A3}",
        nfd: "\u{1105}\u{116B}\u{11B6}",
        nfkc: "\u{B8A3}",
        nfkd: "\u{1105}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B8A4}",
        nfc: "\u{B8A4}",
        nfd: "\u{1105}\u{116B}\u{11B7}",
        nfkc: "\u{B8A4}",
        nfkd: "\u{1105}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B8A5}",
        nfc: "\u{B8A5}",
        nfd: "\u{1105}\u{116B}\u{11B8}",
        nfkc: "\u{B8A5}",
        nfkd: "\u{1105}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B8A6}",
        nfc: "\u{B8A6}",
        nfd: "\u{1105}\u{116B}\u{11B9}",
        nfkc: "\u{B8A6}",
        nfkd: "\u{1105}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B8A7}",
        nfc: "\u{B8A7}",
        nfd: "\u{1105}\u{116B}\u{11BA}",
        nfkc: "\u{B8A7}",
        nfkd: "\u{1105}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B8A8}",
        nfc: "\u{B8A8}",
        nfd: "\u{1105}\u{116B}\u{11BB}",
        nfkc: "\u{B8A8}",
        nfkd: "\u{1105}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B8A9}",
        nfc: "\u{B8A9}",
        nfd: "\u{1105}\u{116B}\u{11BC}",
        nfkc: "\u{B8A9}",
        nfkd: "\u{1105}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B8AA}",
        nfc: "\u{B8AA}",
        nfd: "\u{1105}\u{116B}\u{11BD}",
        nfkc: "\u{B8AA}",
        nfkd: "\u{1105}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B8AB}",
        nfc: "\u{B8AB}",
        nfd: "\u{1105}\u{116B}\u{11BE}",
        nfkc: "\u{B8AB}",
        nfkd: "\u{1105}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B8AC}",
        nfc: "\u{B8AC}",
        nfd: "\u{1105}\u{116B}\u{11BF}",
        nfkc: "\u{B8AC}",
        nfkd: "\u{1105}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B8AD}",
        nfc: "\u{B8AD}",
        nfd: "\u{1105}\u{116B}\u{11C0}",
        nfkc: "\u{B8AD}",
        nfkd: "\u{1105}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B8AE}",
        nfc: "\u{B8AE}",
        nfd: "\u{1105}\u{116B}\u{11C1}",
        nfkc: "\u{B8AE}",
        nfkd: "\u{1105}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B8AF}",
        nfc: "\u{B8AF}",
        nfd: "\u{1105}\u{116B}\u{11C2}",
        nfkc: "\u{B8AF}",
        nfkd: "\u{1105}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B8B0}",
        nfc: "\u{B8B0}",
        nfd: "\u{1105}\u{116C}",
        nfkc: "\u{B8B0}",
        nfkd: "\u{1105}\u{116C}",
    },
    NormalizationTest {
        source: "\u{B8B1}",
        nfc: "\u{B8B1}",
        nfd: "\u{1105}\u{116C}\u{11A8}",
        nfkc: "\u{B8B1}",
        nfkd: "\u{1105}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B8B2}",
        nfc: "\u{B8B2}",
        nfd: "\u{1105}\u{116C}\u{11A9}",
        nfkc: "\u{B8B2}",
        nfkd: "\u{1105}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B8B3}",
        nfc: "\u{B8B3}",
        nfd: "\u{1105}\u{116C}\u{11AA}",
        nfkc: "\u{B8B3}",
        nfkd: "\u{1105}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B8B4}",
        nfc: "\u{B8B4}",
        nfd: "\u{1105}\u{116C}\u{11AB}",
        nfkc: "\u{B8B4}",
        nfkd: "\u{1105}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B8B5}",
        nfc: "\u{B8B5}",
        nfd: "\u{1105}\u{116C}\u{11AC}",
        nfkc: "\u{B8B5}",
        nfkd: "\u{1105}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B8B6}",
        nfc: "\u{B8B6}",
        nfd: "\u{1105}\u{116C}\u{11AD}",
        nfkc: "\u{B8B6}",
        nfkd: "\u{1105}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B8B7}",
        nfc: "\u{B8B7}",
        nfd: "\u{1105}\u{116C}\u{11AE}",
        nfkc: "\u{B8B7}",
        nfkd: "\u{1105}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B8B8}",
        nfc: "\u{B8B8}",
        nfd: "\u{1105}\u{116C}\u{11AF}",
        nfkc: "\u{B8B8}",
        nfkd: "\u{1105}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B8B9}",
        nfc: "\u{B8B9}",
        nfd: "\u{1105}\u{116C}\u{11B0}",
        nfkc: "\u{B8B9}",
        nfkd: "\u{1105}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B8BA}",
        nfc: "\u{B8BA}",
        nfd: "\u{1105}\u{116C}\u{11B1}",
        nfkc: "\u{B8BA}",
        nfkd: "\u{1105}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B8BB}",
        nfc: "\u{B8BB}",
        nfd: "\u{1105}\u{116C}\u{11B2}",
        nfkc: "\u{B8BB}",
        nfkd: "\u{1105}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B8BC}",
        nfc: "\u{B8BC}",
        nfd: "\u{1105}\u{116C}\u{11B3}",
        nfkc: "\u{B8BC}",
        nfkd: "\u{1105}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B8BD}",
        nfc: "\u{B8BD}",
        nfd: "\u{1105}\u{116C}\u{11B4}",
        nfkc: "\u{B8BD}",
        nfkd: "\u{1105}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B8BE}",
        nfc: "\u{B8BE}",
        nfd: "\u{1105}\u{116C}\u{11B5}",
        nfkc: "\u{B8BE}",
        nfkd: "\u{1105}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B8BF}",
        nfc: "\u{B8BF}",
        nfd: "\u{1105}\u{116C}\u{11B6}",
        nfkc: "\u{B8BF}",
        nfkd: "\u{1105}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B8C0}",
        nfc: "\u{B8C0}",
        nfd: "\u{1105}\u{116C}\u{11B7}",
        nfkc: "\u{B8C0}",
        nfkd: "\u{1105}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B8C1}",
        nfc: "\u{B8C1}",
        nfd: "\u{1105}\u{116C}\u{11B8}",
        nfkc: "\u{B8C1}",
        nfkd: "\u{1105}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B8C2}",
        nfc: "\u{B8C2}",
        nfd: "\u{1105}\u{116C}\u{11B9}",
        nfkc: "\u{B8C2}",
        nfkd: "\u{1105}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B8C3}",
        nfc: "\u{B8C3}",
        nfd: "\u{1105}\u{116C}\u{11BA}",
        nfkc: "\u{B8C3}",
        nfkd: "\u{1105}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B8C4}",
        nfc: "\u{B8C4}",
        nfd: "\u{1105}\u{116C}\u{11BB}",
        nfkc: "\u{B8C4}",
        nfkd: "\u{1105}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B8C5}",
        nfc: "\u{B8C5}",
        nfd: "\u{1105}\u{116C}\u{11BC}",
        nfkc: "\u{B8C5}",
        nfkd: "\u{1105}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B8C6}",
        nfc: "\u{B8C6}",
        nfd: "\u{1105}\u{116C}\u{11BD}",
        nfkc: "\u{B8C6}",
        nfkd: "\u{1105}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B8C7}",
        nfc: "\u{B8C7}",
        nfd: "\u{1105}\u{116C}\u{11BE}",
        nfkc: "\u{B8C7}",
        nfkd: "\u{1105}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B8C8}",
        nfc: "\u{B8C8}",
        nfd: "\u{1105}\u{116C}\u{11BF}",
        nfkc: "\u{B8C8}",
        nfkd: "\u{1105}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B8C9}",
        nfc: "\u{B8C9}",
        nfd: "\u{1105}\u{116C}\u{11C0}",
        nfkc: "\u{B8C9}",
        nfkd: "\u{1105}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B8CA}",
        nfc: "\u{B8CA}",
        nfd: "\u{1105}\u{116C}\u{11C1}",
        nfkc: "\u{B8CA}",
        nfkd: "\u{1105}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B8CB}",
        nfc: "\u{B8CB}",
        nfd: "\u{1105}\u{116C}\u{11C2}",
        nfkc: "\u{B8CB}",
        nfkd: "\u{1105}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B8CC}",
        nfc: "\u{B8CC}",
        nfd: "\u{1105}\u{116D}",
        nfkc: "\u{B8CC}",
        nfkd: "\u{1105}\u{116D}",
    },
    NormalizationTest {
        source: "\u{B8CD}",
        nfc: "\u{B8CD}",
        nfd: "\u{1105}\u{116D}\u{11A8}",
        nfkc: "\u{B8CD}",
        nfkd: "\u{1105}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B8CE}",
        nfc: "\u{B8CE}",
        nfd: "\u{1105}\u{116D}\u{11A9}",
        nfkc: "\u{B8CE}",
        nfkd: "\u{1105}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B8CF}",
        nfc: "\u{B8CF}",
        nfd: "\u{1105}\u{116D}\u{11AA}",
        nfkc: "\u{B8CF}",
        nfkd: "\u{1105}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B8D0}",
        nfc: "\u{B8D0}",
        nfd: "\u{1105}\u{116D}\u{11AB}",
        nfkc: "\u{B8D0}",
        nfkd: "\u{1105}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B8D1}",
        nfc: "\u{B8D1}",
        nfd: "\u{1105}\u{116D}\u{11AC}",
        nfkc: "\u{B8D1}",
        nfkd: "\u{1105}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B8D2}",
        nfc: "\u{B8D2}",
        nfd: "\u{1105}\u{116D}\u{11AD}",
        nfkc: "\u{B8D2}",
        nfkd: "\u{1105}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B8D3}",
        nfc: "\u{B8D3}",
        nfd: "\u{1105}\u{116D}\u{11AE}",
        nfkc: "\u{B8D3}",
        nfkd: "\u{1105}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B8D4}",
        nfc: "\u{B8D4}",
        nfd: "\u{1105}\u{116D}\u{11AF}",
        nfkc: "\u{B8D4}",
        nfkd: "\u{1105}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B8D5}",
        nfc: "\u{B8D5}",
        nfd: "\u{1105}\u{116D}\u{11B0}",
        nfkc: "\u{B8D5}",
        nfkd: "\u{1105}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B8D6}",
        nfc: "\u{B8D6}",
        nfd: "\u{1105}\u{116D}\u{11B1}",
        nfkc: "\u{B8D6}",
        nfkd: "\u{1105}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B8D7}",
        nfc: "\u{B8D7}",
        nfd: "\u{1105}\u{116D}\u{11B2}",
        nfkc: "\u{B8D7}",
        nfkd: "\u{1105}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B8D8}",
        nfc: "\u{B8D8}",
        nfd: "\u{1105}\u{116D}\u{11B3}",
        nfkc: "\u{B8D8}",
        nfkd: "\u{1105}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B8D9}",
        nfc: "\u{B8D9}",
        nfd: "\u{1105}\u{116D}\u{11B4}",
        nfkc: "\u{B8D9}",
        nfkd: "\u{1105}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B8DA}",
        nfc: "\u{B8DA}",
        nfd: "\u{1105}\u{116D}\u{11B5}",
        nfkc: "\u{B8DA}",
        nfkd: "\u{1105}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B8DB}",
        nfc: "\u{B8DB}",
        nfd: "\u{1105}\u{116D}\u{11B6}",
        nfkc: "\u{B8DB}",
        nfkd: "\u{1105}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B8DC}",
        nfc: "\u{B8DC}",
        nfd: "\u{1105}\u{116D}\u{11B7}",
        nfkc: "\u{B8DC}",
        nfkd: "\u{1105}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B8DD}",
        nfc: "\u{B8DD}",
        nfd: "\u{1105}\u{116D}\u{11B8}",
        nfkc: "\u{B8DD}",
        nfkd: "\u{1105}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B8DE}",
        nfc: "\u{B8DE}",
        nfd: "\u{1105}\u{116D}\u{11B9}",
        nfkc: "\u{B8DE}",
        nfkd: "\u{1105}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B8DF}",
        nfc: "\u{B8DF}",
        nfd: "\u{1105}\u{116D}\u{11BA}",
        nfkc: "\u{B8DF}",
        nfkd: "\u{1105}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B8E0}",
        nfc: "\u{B8E0}",
        nfd: "\u{1105}\u{116D}\u{11BB}",
        nfkc: "\u{B8E0}",
        nfkd: "\u{1105}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B8E1}",
        nfc: "\u{B8E1}",
        nfd: "\u{1105}\u{116D}\u{11BC}",
        nfkc: "\u{B8E1}",
        nfkd: "\u{1105}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B8E2}",
        nfc: "\u{B8E2}",
        nfd: "\u{1105}\u{116D}\u{11BD}",
        nfkc: "\u{B8E2}",
        nfkd: "\u{1105}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B8E3}",
        nfc: "\u{B8E3}",
        nfd: "\u{1105}\u{116D}\u{11BE}",
        nfkc: "\u{B8E3}",
        nfkd: "\u{1105}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B8E4}",
        nfc: "\u{B8E4}",
        nfd: "\u{1105}\u{116D}\u{11BF}",
        nfkc: "\u{B8E4}",
        nfkd: "\u{1105}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B8E5}",
        nfc: "\u{B8E5}",
        nfd: "\u{1105}\u{116D}\u{11C0}",
        nfkc: "\u{B8E5}",
        nfkd: "\u{1105}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B8E6}",
        nfc: "\u{B8E6}",
        nfd: "\u{1105}\u{116D}\u{11C1}",
        nfkc: "\u{B8E6}",
        nfkd: "\u{1105}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B8E7}",
        nfc: "\u{B8E7}",
        nfd: "\u{1105}\u{116D}\u{11C2}",
        nfkc: "\u{B8E7}",
        nfkd: "\u{1105}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B8E8}",
        nfc: "\u{B8E8}",
        nfd: "\u{1105}\u{116E}",
        nfkc: "\u{B8E8}",
        nfkd: "\u{1105}\u{116E}",
    },
    NormalizationTest {
        source: "\u{B8E9}",
        nfc: "\u{B8E9}",
        nfd: "\u{1105}\u{116E}\u{11A8}",
        nfkc: "\u{B8E9}",
        nfkd: "\u{1105}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B8EA}",
        nfc: "\u{B8EA}",
        nfd: "\u{1105}\u{116E}\u{11A9}",
        nfkc: "\u{B8EA}",
        nfkd: "\u{1105}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B8EB}",
        nfc: "\u{B8EB}",
        nfd: "\u{1105}\u{116E}\u{11AA}",
        nfkc: "\u{B8EB}",
        nfkd: "\u{1105}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B8EC}",
        nfc: "\u{B8EC}",
        nfd: "\u{1105}\u{116E}\u{11AB}",
        nfkc: "\u{B8EC}",
        nfkd: "\u{1105}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B8ED}",
        nfc: "\u{B8ED}",
        nfd: "\u{1105}\u{116E}\u{11AC}",
        nfkc: "\u{B8ED}",
        nfkd: "\u{1105}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B8EE}",
        nfc: "\u{B8EE}",
        nfd: "\u{1105}\u{116E}\u{11AD}",
        nfkc: "\u{B8EE}",
        nfkd: "\u{1105}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B8EF}",
        nfc: "\u{B8EF}",
        nfd: "\u{1105}\u{116E}\u{11AE}",
        nfkc: "\u{B8EF}",
        nfkd: "\u{1105}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B8F0}",
        nfc: "\u{B8F0}",
        nfd: "\u{1105}\u{116E}\u{11AF}",
        nfkc: "\u{B8F0}",
        nfkd: "\u{1105}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B8F1}",
        nfc: "\u{B8F1}",
        nfd: "\u{1105}\u{116E}\u{11B0}",
        nfkc: "\u{B8F1}",
        nfkd: "\u{1105}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B8F2}",
        nfc: "\u{B8F2}",
        nfd: "\u{1105}\u{116E}\u{11B1}",
        nfkc: "\u{B8F2}",
        nfkd: "\u{1105}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B8F3}",
        nfc: "\u{B8F3}",
        nfd: "\u{1105}\u{116E}\u{11B2}",
        nfkc: "\u{B8F3}",
        nfkd: "\u{1105}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B8F4}",
        nfc: "\u{B8F4}",
        nfd: "\u{1105}\u{116E}\u{11B3}",
        nfkc: "\u{B8F4}",
        nfkd: "\u{1105}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B8F5}",
        nfc: "\u{B8F5}",
        nfd: "\u{1105}\u{116E}\u{11B4}",
        nfkc: "\u{B8F5}",
        nfkd: "\u{1105}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B8F6}",
        nfc: "\u{B8F6}",
        nfd: "\u{1105}\u{116E}\u{11B5}",
        nfkc: "\u{B8F6}",
        nfkd: "\u{1105}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B8F7}",
        nfc: "\u{B8F7}",
        nfd: "\u{1105}\u{116E}\u{11B6}",
        nfkc: "\u{B8F7}",
        nfkd: "\u{1105}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B8F8}",
        nfc: "\u{B8F8}",
        nfd: "\u{1105}\u{116E}\u{11B7}",
        nfkc: "\u{B8F8}",
        nfkd: "\u{1105}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B8F9}",
        nfc: "\u{B8F9}",
        nfd: "\u{1105}\u{116E}\u{11B8}",
        nfkc: "\u{B8F9}",
        nfkd: "\u{1105}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B8FA}",
        nfc: "\u{B8FA}",
        nfd: "\u{1105}\u{116E}\u{11B9}",
        nfkc: "\u{B8FA}",
        nfkd: "\u{1105}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B8FB}",
        nfc: "\u{B8FB}",
        nfd: "\u{1105}\u{116E}\u{11BA}",
        nfkc: "\u{B8FB}",
        nfkd: "\u{1105}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B8FC}",
        nfc: "\u{B8FC}",
        nfd: "\u{1105}\u{116E}\u{11BB}",
        nfkc: "\u{B8FC}",
        nfkd: "\u{1105}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B8FD}",
        nfc: "\u{B8FD}",
        nfd: "\u{1105}\u{116E}\u{11BC}",
        nfkc: "\u{B8FD}",
        nfkd: "\u{1105}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B8FE}",
        nfc: "\u{B8FE}",
        nfd: "\u{1105}\u{116E}\u{11BD}",
        nfkc: "\u{B8FE}",
        nfkd: "\u{1105}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B8FF}",
        nfc: "\u{B8FF}",
        nfd: "\u{1105}\u{116E}\u{11BE}",
        nfkc: "\u{B8FF}",
        nfkd: "\u{1105}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B900}",
        nfc: "\u{B900}",
        nfd: "\u{1105}\u{116E}\u{11BF}",
        nfkc: "\u{B900}",
        nfkd: "\u{1105}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B901}",
        nfc: "\u{B901}",
        nfd: "\u{1105}\u{116E}\u{11C0}",
        nfkc: "\u{B901}",
        nfkd: "\u{1105}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B902}",
        nfc: "\u{B902}",
        nfd: "\u{1105}\u{116E}\u{11C1}",
        nfkc: "\u{B902}",
        nfkd: "\u{1105}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B903}",
        nfc: "\u{B903}",
        nfd: "\u{1105}\u{116E}\u{11C2}",
        nfkc: "\u{B903}",
        nfkd: "\u{1105}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B904}",
        nfc: "\u{B904}",
        nfd: "\u{1105}\u{116F}",
        nfkc: "\u{B904}",
        nfkd: "\u{1105}\u{116F}",
    },
    NormalizationTest {
        source: "\u{B905}",
        nfc: "\u{B905}",
        nfd: "\u{1105}\u{116F}\u{11A8}",
        nfkc: "\u{B905}",
        nfkd: "\u{1105}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B906}",
        nfc: "\u{B906}",
        nfd: "\u{1105}\u{116F}\u{11A9}",
        nfkc: "\u{B906}",
        nfkd: "\u{1105}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B907}",
        nfc: "\u{B907}",
        nfd: "\u{1105}\u{116F}\u{11AA}",
        nfkc: "\u{B907}",
        nfkd: "\u{1105}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B908}",
        nfc: "\u{B908}",
        nfd: "\u{1105}\u{116F}\u{11AB}",
        nfkc: "\u{B908}",
        nfkd: "\u{1105}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B909}",
        nfc: "\u{B909}",
        nfd: "\u{1105}\u{116F}\u{11AC}",
        nfkc: "\u{B909}",
        nfkd: "\u{1105}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B90A}",
        nfc: "\u{B90A}",
        nfd: "\u{1105}\u{116F}\u{11AD}",
        nfkc: "\u{B90A}",
        nfkd: "\u{1105}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B90B}",
        nfc: "\u{B90B}",
        nfd: "\u{1105}\u{116F}\u{11AE}",
        nfkc: "\u{B90B}",
        nfkd: "\u{1105}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B90C}",
        nfc: "\u{B90C}",
        nfd: "\u{1105}\u{116F}\u{11AF}",
        nfkc: "\u{B90C}",
        nfkd: "\u{1105}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B90D}",
        nfc: "\u{B90D}",
        nfd: "\u{1105}\u{116F}\u{11B0}",
        nfkc: "\u{B90D}",
        nfkd: "\u{1105}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B90E}",
        nfc: "\u{B90E}",
        nfd: "\u{1105}\u{116F}\u{11B1}",
        nfkc: "\u{B90E}",
        nfkd: "\u{1105}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B90F}",
        nfc: "\u{B90F}",
        nfd: "\u{1105}\u{116F}\u{11B2}",
        nfkc: "\u{B90F}",
        nfkd: "\u{1105}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B910}",
        nfc: "\u{B910}",
        nfd: "\u{1105}\u{116F}\u{11B3}",
        nfkc: "\u{B910}",
        nfkd: "\u{1105}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B911}",
        nfc: "\u{B911}",
        nfd: "\u{1105}\u{116F}\u{11B4}",
        nfkc: "\u{B911}",
        nfkd: "\u{1105}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B912}",
        nfc: "\u{B912}",
        nfd: "\u{1105}\u{116F}\u{11B5}",
        nfkc: "\u{B912}",
        nfkd: "\u{1105}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B913}",
        nfc: "\u{B913}",
        nfd: "\u{1105}\u{116F}\u{11B6}",
        nfkc: "\u{B913}",
        nfkd: "\u{1105}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B914}",
        nfc: "\u{B914}",
        nfd: "\u{1105}\u{116F}\u{11B7}",
        nfkc: "\u{B914}",
        nfkd: "\u{1105}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B915}",
        nfc: "\u{B915}",
        nfd: "\u{1105}\u{116F}\u{11B8}",
        nfkc: "\u{B915}",
        nfkd: "\u{1105}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B916}",
        nfc: "\u{B916}",
        nfd: "\u{1105}\u{116F}\u{11B9}",
        nfkc: "\u{B916}",
        nfkd: "\u{1105}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B917}",
        nfc: "\u{B917}",
        nfd: "\u{1105}\u{116F}\u{11BA}",
        nfkc: "\u{B917}",
        nfkd: "\u{1105}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B918}",
        nfc: "\u{B918}",
        nfd: "\u{1105}\u{116F}\u{11BB}",
        nfkc: "\u{B918}",
        nfkd: "\u{1105}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B919}",
        nfc: "\u{B919}",
        nfd: "\u{1105}\u{116F}\u{11BC}",
        nfkc: "\u{B919}",
        nfkd: "\u{1105}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B91A}",
        nfc: "\u{B91A}",
        nfd: "\u{1105}\u{116F}\u{11BD}",
        nfkc: "\u{B91A}",
        nfkd: "\u{1105}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B91B}",
        nfc: "\u{B91B}",
        nfd: "\u{1105}\u{116F}\u{11BE}",
        nfkc: "\u{B91B}",
        nfkd: "\u{1105}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B91C}",
        nfc: "\u{B91C}",
        nfd: "\u{1105}\u{116F}\u{11BF}",
        nfkc: "\u{B91C}",
        nfkd: "\u{1105}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B91D}",
        nfc: "\u{B91D}",
        nfd: "\u{1105}\u{116F}\u{11C0}",
        nfkc: "\u{B91D}",
        nfkd: "\u{1105}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B91E}",
        nfc: "\u{B91E}",
        nfd: "\u{1105}\u{116F}\u{11C1}",
        nfkc: "\u{B91E}",
        nfkd: "\u{1105}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B91F}",
        nfc: "\u{B91F}",
        nfd: "\u{1105}\u{116F}\u{11C2}",
        nfkc: "\u{B91F}",
        nfkd: "\u{1105}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B920}",
        nfc: "\u{B920}",
        nfd: "\u{1105}\u{1170}",
        nfkc: "\u{B920}",
        nfkd: "\u{1105}\u{1170}",
    },
    NormalizationTest {
        source: "\u{B921}",
        nfc: "\u{B921}",
        nfd: "\u{1105}\u{1170}\u{11A8}",
        nfkc: "\u{B921}",
        nfkd: "\u{1105}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B922}",
        nfc: "\u{B922}",
        nfd: "\u{1105}\u{1170}\u{11A9}",
        nfkc: "\u{B922}",
        nfkd: "\u{1105}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B923}",
        nfc: "\u{B923}",
        nfd: "\u{1105}\u{1170}\u{11AA}",
        nfkc: "\u{B923}",
        nfkd: "\u{1105}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B924}",
        nfc: "\u{B924}",
        nfd: "\u{1105}\u{1170}\u{11AB}",
        nfkc: "\u{B924}",
        nfkd: "\u{1105}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B925}",
        nfc: "\u{B925}",
        nfd: "\u{1105}\u{1170}\u{11AC}",
        nfkc: "\u{B925}",
        nfkd: "\u{1105}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B926}",
        nfc: "\u{B926}",
        nfd: "\u{1105}\u{1170}\u{11AD}",
        nfkc: "\u{B926}",
        nfkd: "\u{1105}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B927}",
        nfc: "\u{B927}",
        nfd: "\u{1105}\u{1170}\u{11AE}",
        nfkc: "\u{B927}",
        nfkd: "\u{1105}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B928}",
        nfc: "\u{B928}",
        nfd: "\u{1105}\u{1170}\u{11AF}",
        nfkc: "\u{B928}",
        nfkd: "\u{1105}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B929}",
        nfc: "\u{B929}",
        nfd: "\u{1105}\u{1170}\u{11B0}",
        nfkc: "\u{B929}",
        nfkd: "\u{1105}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B92A}",
        nfc: "\u{B92A}",
        nfd: "\u{1105}\u{1170}\u{11B1}",
        nfkc: "\u{B92A}",
        nfkd: "\u{1105}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B92B}",
        nfc: "\u{B92B}",
        nfd: "\u{1105}\u{1170}\u{11B2}",
        nfkc: "\u{B92B}",
        nfkd: "\u{1105}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B92C}",
        nfc: "\u{B92C}",
        nfd: "\u{1105}\u{1170}\u{11B3}",
        nfkc: "\u{B92C}",
        nfkd: "\u{1105}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B92D}",
        nfc: "\u{B92D}",
        nfd: "\u{1105}\u{1170}\u{11B4}",
        nfkc: "\u{B92D}",
        nfkd: "\u{1105}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B92E}",
        nfc: "\u{B92E}",
        nfd: "\u{1105}\u{1170}\u{11B5}",
        nfkc: "\u{B92E}",
        nfkd: "\u{1105}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B92F}",
        nfc: "\u{B92F}",
        nfd: "\u{1105}\u{1170}\u{11B6}",
        nfkc: "\u{B92F}",
        nfkd: "\u{1105}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B930}",
        nfc: "\u{B930}",
        nfd: "\u{1105}\u{1170}\u{11B7}",
        nfkc: "\u{B930}",
        nfkd: "\u{1105}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B931}",
        nfc: "\u{B931}",
        nfd: "\u{1105}\u{1170}\u{11B8}",
        nfkc: "\u{B931}",
        nfkd: "\u{1105}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B932}",
        nfc: "\u{B932}",
        nfd: "\u{1105}\u{1170}\u{11B9}",
        nfkc: "\u{B932}",
        nfkd: "\u{1105}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B933}",
        nfc: "\u{B933}",
        nfd: "\u{1105}\u{1170}\u{11BA}",
        nfkc: "\u{B933}",
        nfkd: "\u{1105}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B934}",
        nfc: "\u{B934}",
        nfd: "\u{1105}\u{1170}\u{11BB}",
        nfkc: "\u{B934}",
        nfkd: "\u{1105}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B935}",
        nfc: "\u{B935}",
        nfd: "\u{1105}\u{1170}\u{11BC}",
        nfkc: "\u{B935}",
        nfkd: "\u{1105}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B936}",
        nfc: "\u{B936}",
        nfd: "\u{1105}\u{1170}\u{11BD}",
        nfkc: "\u{B936}",
        nfkd: "\u{1105}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B937}",
        nfc: "\u{B937}",
        nfd: "\u{1105}\u{1170}\u{11BE}",
        nfkc: "\u{B937}",
        nfkd: "\u{1105}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B938}",
        nfc: "\u{B938}",
        nfd: "\u{1105}\u{1170}\u{11BF}",
        nfkc: "\u{B938}",
        nfkd: "\u{1105}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B939}",
        nfc: "\u{B939}",
        nfd: "\u{1105}\u{1170}\u{11C0}",
        nfkc: "\u{B939}",
        nfkd: "\u{1105}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B93A}",
        nfc: "\u{B93A}",
        nfd: "\u{1105}\u{1170}\u{11C1}",
        nfkc: "\u{B93A}",
        nfkd: "\u{1105}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B93B}",
        nfc: "\u{B93B}",
        nfd: "\u{1105}\u{1170}\u{11C2}",
        nfkc: "\u{B93B}",
        nfkd: "\u{1105}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B93C}",
        nfc: "\u{B93C}",
        nfd: "\u{1105}\u{1171}",
        nfkc: "\u{B93C}",
        nfkd: "\u{1105}\u{1171}",
    },
    NormalizationTest {
        source: "\u{B93D}",
        nfc: "\u{B93D}",
        nfd: "\u{1105}\u{1171}\u{11A8}",
        nfkc: "\u{B93D}",
        nfkd: "\u{1105}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B93E}",
        nfc: "\u{B93E}",
        nfd: "\u{1105}\u{1171}\u{11A9}",
        nfkc: "\u{B93E}",
        nfkd: "\u{1105}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B93F}",
        nfc: "\u{B93F}",
        nfd: "\u{1105}\u{1171}\u{11AA}",
        nfkc: "\u{B93F}",
        nfkd: "\u{1105}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B940}",
        nfc: "\u{B940}",
        nfd: "\u{1105}\u{1171}\u{11AB}",
        nfkc: "\u{B940}",
        nfkd: "\u{1105}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B941}",
        nfc: "\u{B941}",
        nfd: "\u{1105}\u{1171}\u{11AC}",
        nfkc: "\u{B941}",
        nfkd: "\u{1105}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B942}",
        nfc: "\u{B942}",
        nfd: "\u{1105}\u{1171}\u{11AD}",
        nfkc: "\u{B942}",
        nfkd: "\u{1105}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B943}",
        nfc: "\u{B943}",
        nfd: "\u{1105}\u{1171}\u{11AE}",
        nfkc: "\u{B943}",
        nfkd: "\u{1105}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B944}",
        nfc: "\u{B944}",
        nfd: "\u{1105}\u{1171}\u{11AF}",
        nfkc: "\u{B944}",
        nfkd: "\u{1105}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B945}",
        nfc: "\u{B945}",
        nfd: "\u{1105}\u{1171}\u{11B0}",
        nfkc: "\u{B945}",
        nfkd: "\u{1105}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B946}",
        nfc: "\u{B946}",
        nfd: "\u{1105}\u{1171}\u{11B1}",
        nfkc: "\u{B946}",
        nfkd: "\u{1105}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B947}",
        nfc: "\u{B947}",
        nfd: "\u{1105}\u{1171}\u{11B2}",
        nfkc: "\u{B947}",
        nfkd: "\u{1105}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B948}",
        nfc: "\u{B948}",
        nfd: "\u{1105}\u{1171}\u{11B3}",
        nfkc: "\u{B948}",
        nfkd: "\u{1105}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B949}",
        nfc: "\u{B949}",
        nfd: "\u{1105}\u{1171}\u{11B4}",
        nfkc: "\u{B949}",
        nfkd: "\u{1105}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B94A}",
        nfc: "\u{B94A}",
        nfd: "\u{1105}\u{1171}\u{11B5}",
        nfkc: "\u{B94A}",
        nfkd: "\u{1105}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B94B}",
        nfc: "\u{B94B}",
        nfd: "\u{1105}\u{1171}\u{11B6}",
        nfkc: "\u{B94B}",
        nfkd: "\u{1105}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B94C}",
        nfc: "\u{B94C}",
        nfd: "\u{1105}\u{1171}\u{11B7}",
        nfkc: "\u{B94C}",
        nfkd: "\u{1105}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B94D}",
        nfc: "\u{B94D}",
        nfd: "\u{1105}\u{1171}\u{11B8}",
        nfkc: "\u{B94D}",
        nfkd: "\u{1105}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B94E}",
        nfc: "\u{B94E}",
        nfd: "\u{1105}\u{1171}\u{11B9}",
        nfkc: "\u{B94E}",
        nfkd: "\u{1105}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B94F}",
        nfc: "\u{B94F}",
        nfd: "\u{1105}\u{1171}\u{11BA}",
        nfkc: "\u{B94F}",
        nfkd: "\u{1105}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B950}",
        nfc: "\u{B950}",
        nfd: "\u{1105}\u{1171}\u{11BB}",
        nfkc: "\u{B950}",
        nfkd: "\u{1105}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B951}",
        nfc: "\u{B951}",
        nfd: "\u{1105}\u{1171}\u{11BC}",
        nfkc: "\u{B951}",
        nfkd: "\u{1105}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B952}",
        nfc: "\u{B952}",
        nfd: "\u{1105}\u{1171}\u{11BD}",
        nfkc: "\u{B952}",
        nfkd: "\u{1105}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B953}",
        nfc: "\u{B953}",
        nfd: "\u{1105}\u{1171}\u{11BE}",
        nfkc: "\u{B953}",
        nfkd: "\u{1105}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B954}",
        nfc: "\u{B954}",
        nfd: "\u{1105}\u{1171}\u{11BF}",
        nfkc: "\u{B954}",
        nfkd: "\u{1105}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B955}",
        nfc: "\u{B955}",
        nfd: "\u{1105}\u{1171}\u{11C0}",
        nfkc: "\u{B955}",
        nfkd: "\u{1105}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B956}",
        nfc: "\u{B956}",
        nfd: "\u{1105}\u{1171}\u{11C1}",
        nfkc: "\u{B956}",
        nfkd: "\u{1105}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B957}",
        nfc: "\u{B957}",
        nfd: "\u{1105}\u{1171}\u{11C2}",
        nfkc: "\u{B957}",
        nfkd: "\u{1105}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B958}",
        nfc: "\u{B958}",
        nfd: "\u{1105}\u{1172}",
        nfkc: "\u{B958}",
        nfkd: "\u{1105}\u{1172}",
    },
    NormalizationTest {
        source: "\u{B959}",
        nfc: "\u{B959}",
        nfd: "\u{1105}\u{1172}\u{11A8}",
        nfkc: "\u{B959}",
        nfkd: "\u{1105}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B95A}",
        nfc: "\u{B95A}",
        nfd: "\u{1105}\u{1172}\u{11A9}",
        nfkc: "\u{B95A}",
        nfkd: "\u{1105}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B95B}",
        nfc: "\u{B95B}",
        nfd: "\u{1105}\u{1172}\u{11AA}",
        nfkc: "\u{B95B}",
        nfkd: "\u{1105}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B95C}",
        nfc: "\u{B95C}",
        nfd: "\u{1105}\u{1172}\u{11AB}",
        nfkc: "\u{B95C}",
        nfkd: "\u{1105}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B95D}",
        nfc: "\u{B95D}",
        nfd: "\u{1105}\u{1172}\u{11AC}",
        nfkc: "\u{B95D}",
        nfkd: "\u{1105}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B95E}",
        nfc: "\u{B95E}",
        nfd: "\u{1105}\u{1172}\u{11AD}",
        nfkc: "\u{B95E}",
        nfkd: "\u{1105}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B95F}",
        nfc: "\u{B95F}",
        nfd: "\u{1105}\u{1172}\u{11AE}",
        nfkc: "\u{B95F}",
        nfkd: "\u{1105}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B960}",
        nfc: "\u{B960}",
        nfd: "\u{1105}\u{1172}\u{11AF}",
        nfkc: "\u{B960}",
        nfkd: "\u{1105}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B961}",
        nfc: "\u{B961}",
        nfd: "\u{1105}\u{1172}\u{11B0}",
        nfkc: "\u{B961}",
        nfkd: "\u{1105}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B962}",
        nfc: "\u{B962}",
        nfd: "\u{1105}\u{1172}\u{11B1}",
        nfkc: "\u{B962}",
        nfkd: "\u{1105}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B963}",
        nfc: "\u{B963}",
        nfd: "\u{1105}\u{1172}\u{11B2}",
        nfkc: "\u{B963}",
        nfkd: "\u{1105}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B964}",
        nfc: "\u{B964}",
        nfd: "\u{1105}\u{1172}\u{11B3}",
        nfkc: "\u{B964}",
        nfkd: "\u{1105}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B965}",
        nfc: "\u{B965}",
        nfd: "\u{1105}\u{1172}\u{11B4}",
        nfkc: "\u{B965}",
        nfkd: "\u{1105}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B966}",
        nfc: "\u{B966}",
        nfd: "\u{1105}\u{1172}\u{11B5}",
        nfkc: "\u{B966}",
        nfkd: "\u{1105}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B967}",
        nfc: "\u{B967}",
        nfd: "\u{1105}\u{1172}\u{11B6}",
        nfkc: "\u{B967}",
        nfkd: "\u{1105}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B968}",
        nfc: "\u{B968}",
        nfd: "\u{1105}\u{1172}\u{11B7}",
        nfkc: "\u{B968}",
        nfkd: "\u{1105}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B969}",
        nfc: "\u{B969}",
        nfd: "\u{1105}\u{1172}\u{11B8}",
        nfkc: "\u{B969}",
        nfkd: "\u{1105}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B96A}",
        nfc: "\u{B96A}",
        nfd: "\u{1105}\u{1172}\u{11B9}",
        nfkc: "\u{B96A}",
        nfkd: "\u{1105}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B96B}",
        nfc: "\u{B96B}",
        nfd: "\u{1105}\u{1172}\u{11BA}",
        nfkc: "\u{B96B}",
        nfkd: "\u{1105}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B96C}",
        nfc: "\u{B96C}",
        nfd: "\u{1105}\u{1172}\u{11BB}",
        nfkc: "\u{B96C}",
        nfkd: "\u{1105}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B96D}",
        nfc: "\u{B96D}",
        nfd: "\u{1105}\u{1172}\u{11BC}",
        nfkc: "\u{B96D}",
        nfkd: "\u{1105}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B96E}",
        nfc: "\u{B96E}",
        nfd: "\u{1105}\u{1172}\u{11BD}",
        nfkc: "\u{B96E}",
        nfkd: "\u{1105}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B96F}",
        nfc: "\u{B96F}",
        nfd: "\u{1105}\u{1172}\u{11BE}",
        nfkc: "\u{B96F}",
        nfkd: "\u{1105}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B970}",
        nfc: "\u{B970}",
        nfd: "\u{1105}\u{1172}\u{11BF}",
        nfkc: "\u{B970}",
        nfkd: "\u{1105}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B971}",
        nfc: "\u{B971}",
        nfd: "\u{1105}\u{1172}\u{11C0}",
        nfkc: "\u{B971}",
        nfkd: "\u{1105}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B972}",
        nfc: "\u{B972}",
        nfd: "\u{1105}\u{1172}\u{11C1}",
        nfkc: "\u{B972}",
        nfkd: "\u{1105}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B973}",
        nfc: "\u{B973}",
        nfd: "\u{1105}\u{1172}\u{11C2}",
        nfkc: "\u{B973}",
        nfkd: "\u{1105}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B974}",
        nfc: "\u{B974}",
        nfd: "\u{1105}\u{1173}",
        nfkc: "\u{B974}",
        nfkd: "\u{1105}\u{1173}",
    },
    NormalizationTest {
        source: "\u{B975}",
        nfc: "\u{B975}",
        nfd: "\u{1105}\u{1173}\u{11A8}",
        nfkc: "\u{B975}",
        nfkd: "\u{1105}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B976}",
        nfc: "\u{B976}",
        nfd: "\u{1105}\u{1173}\u{11A9}",
        nfkc: "\u{B976}",
        nfkd: "\u{1105}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B977}",
        nfc: "\u{B977}",
        nfd: "\u{1105}\u{1173}\u{11AA}",
        nfkc: "\u{B977}",
        nfkd: "\u{1105}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B978}",
        nfc: "\u{B978}",
        nfd: "\u{1105}\u{1173}\u{11AB}",
        nfkc: "\u{B978}",
        nfkd: "\u{1105}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B979}",
        nfc: "\u{B979}",
        nfd: "\u{1105}\u{1173}\u{11AC}",
        nfkc: "\u{B979}",
        nfkd: "\u{1105}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B97A}",
        nfc: "\u{B97A}",
        nfd: "\u{1105}\u{1173}\u{11AD}",
        nfkc: "\u{B97A}",
        nfkd: "\u{1105}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B97B}",
        nfc: "\u{B97B}",
        nfd: "\u{1105}\u{1173}\u{11AE}",
        nfkc: "\u{B97B}",
        nfkd: "\u{1105}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B97C}",
        nfc: "\u{B97C}",
        nfd: "\u{1105}\u{1173}\u{11AF}",
        nfkc: "\u{B97C}",
        nfkd: "\u{1105}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B97D}",
        nfc: "\u{B97D}",
        nfd: "\u{1105}\u{1173}\u{11B0}",
        nfkc: "\u{B97D}",
        nfkd: "\u{1105}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B97E}",
        nfc: "\u{B97E}",
        nfd: "\u{1105}\u{1173}\u{11B1}",
        nfkc: "\u{B97E}",
        nfkd: "\u{1105}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B97F}",
        nfc: "\u{B97F}",
        nfd: "\u{1105}\u{1173}\u{11B2}",
        nfkc: "\u{B97F}",
        nfkd: "\u{1105}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B980}",
        nfc: "\u{B980}",
        nfd: "\u{1105}\u{1173}\u{11B3}",
        nfkc: "\u{B980}",
        nfkd: "\u{1105}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B981}",
        nfc: "\u{B981}",
        nfd: "\u{1105}\u{1173}\u{11B4}",
        nfkc: "\u{B981}",
        nfkd: "\u{1105}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B982}",
        nfc: "\u{B982}",
        nfd: "\u{1105}\u{1173}\u{11B5}",
        nfkc: "\u{B982}",
        nfkd: "\u{1105}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B983}",
        nfc: "\u{B983}",
        nfd: "\u{1105}\u{1173}\u{11B6}",
        nfkc: "\u{B983}",
        nfkd: "\u{1105}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B984}",
        nfc: "\u{B984}",
        nfd: "\u{1105}\u{1173}\u{11B7}",
        nfkc: "\u{B984}",
        nfkd: "\u{1105}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B985}",
        nfc: "\u{B985}",
        nfd: "\u{1105}\u{1173}\u{11B8}",
        nfkc: "\u{B985}",
        nfkd: "\u{1105}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B986}",
        nfc: "\u{B986}",
        nfd: "\u{1105}\u{1173}\u{11B9}",
        nfkc: "\u{B986}",
        nfkd: "\u{1105}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B987}",
        nfc: "\u{B987}",
        nfd: "\u{1105}\u{1173}\u{11BA}",
        nfkc: "\u{B987}",
        nfkd: "\u{1105}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B988}",
        nfc: "\u{B988}",
        nfd: "\u{1105}\u{1173}\u{11BB}",
        nfkc: "\u{B988}",
        nfkd: "\u{1105}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B989}",
        nfc: "\u{B989}",
        nfd: "\u{1105}\u{1173}\u{11BC}",
        nfkc: "\u{B989}",
        nfkd: "\u{1105}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B98A}",
        nfc: "\u{B98A}",
        nfd: "\u{1105}\u{1173}\u{11BD}",
        nfkc: "\u{B98A}",
        nfkd: "\u{1105}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B98B}",
        nfc: "\u{B98B}",
        nfd: "\u{1105}\u{1173}\u{11BE}",
        nfkc: "\u{B98B}",
        nfkd: "\u{1105}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B98C}",
        nfc: "\u{B98C}",
        nfd: "\u{1105}\u{1173}\u{11BF}",
        nfkc: "\u{B98C}",
        nfkd: "\u{1105}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B98D}",
        nfc: "\u{B98D}",
        nfd: "\u{1105}\u{1173}\u{11C0}",
        nfkc: "\u{B98D}",
        nfkd: "\u{1105}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B98E}",
        nfc: "\u{B98E}",
        nfd: "\u{1105}\u{1173}\u{11C1}",
        nfkc: "\u{B98E}",
        nfkd: "\u{1105}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B98F}",
        nfc: "\u{B98F}",
        nfd: "\u{1105}\u{1173}\u{11C2}",
        nfkc: "\u{B98F}",
        nfkd: "\u{1105}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B990}",
        nfc: "\u{B990}",
        nfd: "\u{1105}\u{1174}",
        nfkc: "\u{B990}",
        nfkd: "\u{1105}\u{1174}",
    },
    NormalizationTest {
        source: "\u{B991}",
        nfc: "\u{B991}",
        nfd: "\u{1105}\u{1174}\u{11A8}",
        nfkc: "\u{B991}",
        nfkd: "\u{1105}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B992}",
        nfc: "\u{B992}",
        nfd: "\u{1105}\u{1174}\u{11A9}",
        nfkc: "\u{B992}",
        nfkd: "\u{1105}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B993}",
        nfc: "\u{B993}",
        nfd: "\u{1105}\u{1174}\u{11AA}",
        nfkc: "\u{B993}",
        nfkd: "\u{1105}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B994}",
        nfc: "\u{B994}",
        nfd: "\u{1105}\u{1174}\u{11AB}",
        nfkc: "\u{B994}",
        nfkd: "\u{1105}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B995}",
        nfc: "\u{B995}",
        nfd: "\u{1105}\u{1174}\u{11AC}",
        nfkc: "\u{B995}",
        nfkd: "\u{1105}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B996}",
        nfc: "\u{B996}",
        nfd: "\u{1105}\u{1174}\u{11AD}",
        nfkc: "\u{B996}",
        nfkd: "\u{1105}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B997}",
        nfc: "\u{B997}",
        nfd: "\u{1105}\u{1174}\u{11AE}",
        nfkc: "\u{B997}",
        nfkd: "\u{1105}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B998}",
        nfc: "\u{B998}",
        nfd: "\u{1105}\u{1174}\u{11AF}",
        nfkc: "\u{B998}",
        nfkd: "\u{1105}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B999}",
        nfc: "\u{B999}",
        nfd: "\u{1105}\u{1174}\u{11B0}",
        nfkc: "\u{B999}",
        nfkd: "\u{1105}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B99A}",
        nfc: "\u{B99A}",
        nfd: "\u{1105}\u{1174}\u{11B1}",
        nfkc: "\u{B99A}",
        nfkd: "\u{1105}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B99B}",
        nfc: "\u{B99B}",
        nfd: "\u{1105}\u{1174}\u{11B2}",
        nfkc: "\u{B99B}",
        nfkd: "\u{1105}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B99C}",
        nfc: "\u{B99C}",
        nfd: "\u{1105}\u{1174}\u{11B3}",
        nfkc: "\u{B99C}",
        nfkd: "\u{1105}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B99D}",
        nfc: "\u{B99D}",
        nfd: "\u{1105}\u{1174}\u{11B4}",
        nfkc: "\u{B99D}",
        nfkd: "\u{1105}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B99E}",
        nfc: "\u{B99E}",
        nfd: "\u{1105}\u{1174}\u{11B5}",
        nfkc: "\u{B99E}",
        nfkd: "\u{1105}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B99F}",
        nfc: "\u{B99F}",
        nfd: "\u{1105}\u{1174}\u{11B6}",
        nfkc: "\u{B99F}",
        nfkd: "\u{1105}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B9A0}",
        nfc: "\u{B9A0}",
        nfd: "\u{1105}\u{1174}\u{11B7}",
        nfkc: "\u{B9A0}",
        nfkd: "\u{1105}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B9A1}",
        nfc: "\u{B9A1}",
        nfd: "\u{1105}\u{1174}\u{11B8}",
        nfkc: "\u{B9A1}",
        nfkd: "\u{1105}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B9A2}",
        nfc: "\u{B9A2}",
        nfd: "\u{1105}\u{1174}\u{11B9}",
        nfkc: "\u{B9A2}",
        nfkd: "\u{1105}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B9A3}",
        nfc: "\u{B9A3}",
        nfd: "\u{1105}\u{1174}\u{11BA}",
        nfkc: "\u{B9A3}",
        nfkd: "\u{1105}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B9A4}",
        nfc: "\u{B9A4}",
        nfd: "\u{1105}\u{1174}\u{11BB}",
        nfkc: "\u{B9A4}",
        nfkd: "\u{1105}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B9A5}",
        nfc: "\u{B9A5}",
        nfd: "\u{1105}\u{1174}\u{11BC}",
        nfkc: "\u{B9A5}",
        nfkd: "\u{1105}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B9A6}",
        nfc: "\u{B9A6}",
        nfd: "\u{1105}\u{1174}\u{11BD}",
        nfkc: "\u{B9A6}",
        nfkd: "\u{1105}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B9A7}",
        nfc: "\u{B9A7}",
        nfd: "\u{1105}\u{1174}\u{11BE}",
        nfkc: "\u{B9A7}",
        nfkd: "\u{1105}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B9A8}",
        nfc: "\u{B9A8}",
        nfd: "\u{1105}\u{1174}\u{11BF}",
        nfkc: "\u{B9A8}",
        nfkd: "\u{1105}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B9A9}",
        nfc: "\u{B9A9}",
        nfd: "\u{1105}\u{1174}\u{11C0}",
        nfkc: "\u{B9A9}",
        nfkd: "\u{1105}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B9AA}",
        nfc: "\u{B9AA}",
        nfd: "\u{1105}\u{1174}\u{11C1}",
        nfkc: "\u{B9AA}",
        nfkd: "\u{1105}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B9AB}",
        nfc: "\u{B9AB}",
        nfd: "\u{1105}\u{1174}\u{11C2}",
        nfkc: "\u{B9AB}",
        nfkd: "\u{1105}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B9AC}",
        nfc: "\u{B9AC}",
        nfd: "\u{1105}\u{1175}",
        nfkc: "\u{B9AC}",
        nfkd: "\u{1105}\u{1175}",
    },
    NormalizationTest {
        source: "\u{B9AD}",
        nfc: "\u{B9AD}",
        nfd: "\u{1105}\u{1175}\u{11A8}",
        nfkc: "\u{B9AD}",
        nfkd: "\u{1105}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B9AE}",
        nfc: "\u{B9AE}",
        nfd: "\u{1105}\u{1175}\u{11A9}",
        nfkc: "\u{B9AE}",
        nfkd: "\u{1105}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B9AF}",
        nfc: "\u{B9AF}",
        nfd: "\u{1105}\u{1175}\u{11AA}",
        nfkc: "\u{B9AF}",
        nfkd: "\u{1105}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B9B0}",
        nfc: "\u{B9B0}",
        nfd: "\u{1105}\u{1175}\u{11AB}",
        nfkc: "\u{B9B0}",
        nfkd: "\u{1105}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B9B1}",
        nfc: "\u{B9B1}",
        nfd: "\u{1105}\u{1175}\u{11AC}",
        nfkc: "\u{B9B1}",
        nfkd: "\u{1105}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B9B2}",
        nfc: "\u{B9B2}",
        nfd: "\u{1105}\u{1175}\u{11AD}",
        nfkc: "\u{B9B2}",
        nfkd: "\u{1105}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B9B3}",
        nfc: "\u{B9B3}",
        nfd: "\u{1105}\u{1175}\u{11AE}",
        nfkc: "\u{B9B3}",
        nfkd: "\u{1105}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B9B4}",
        nfc: "\u{B9B4}",
        nfd: "\u{1105}\u{1175}\u{11AF}",
        nfkc: "\u{B9B4}",
        nfkd: "\u{1105}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B9B5}",
        nfc: "\u{B9B5}",
        nfd: "\u{1105}\u{1175}\u{11B0}",
        nfkc: "\u{B9B5}",
        nfkd: "\u{1105}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B9B6}",
        nfc: "\u{B9B6}",
        nfd: "\u{1105}\u{1175}\u{11B1}",
        nfkc: "\u{B9B6}",
        nfkd: "\u{1105}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B9B7}",
        nfc: "\u{B9B7}",
        nfd: "\u{1105}\u{1175}\u{11B2}",
        nfkc: "\u{B9B7}",
        nfkd: "\u{1105}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B9B8}",
        nfc: "\u{B9B8}",
        nfd: "\u{1105}\u{1175}\u{11B3}",
        nfkc: "\u{B9B8}",
        nfkd: "\u{1105}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B9B9}",
        nfc: "\u{B9B9}",
        nfd: "\u{1105}\u{1175}\u{11B4}",
        nfkc: "\u{B9B9}",
        nfkd: "\u{1105}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B9BA}",
        nfc: "\u{B9BA}",
        nfd: "\u{1105}\u{1175}\u{11B5}",
        nfkc: "\u{B9BA}",
        nfkd: "\u{1105}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B9BB}",
        nfc: "\u{B9BB}",
        nfd: "\u{1105}\u{1175}\u{11B6}",
        nfkc: "\u{B9BB}",
        nfkd: "\u{1105}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B9BC}",
        nfc: "\u{B9BC}",
        nfd: "\u{1105}\u{1175}\u{11B7}",
        nfkc: "\u{B9BC}",
        nfkd: "\u{1105}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B9BD}",
        nfc: "\u{B9BD}",
        nfd: "\u{1105}\u{1175}\u{11B8}",
        nfkc: "\u{B9BD}",
        nfkd: "\u{1105}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B9BE}",
        nfc: "\u{B9BE}",
        nfd: "\u{1105}\u{1175}\u{11B9}",
        nfkc: "\u{B9BE}",
        nfkd: "\u{1105}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B9BF}",
        nfc: "\u{B9BF}",
        nfd: "\u{1105}\u{1175}\u{11BA}",
        nfkc: "\u{B9BF}",
        nfkd: "\u{1105}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B9C0}",
        nfc: "\u{B9C0}",
        nfd: "\u{1105}\u{1175}\u{11BB}",
        nfkc: "\u{B9C0}",
        nfkd: "\u{1105}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B9C1}",
        nfc: "\u{B9C1}",
        nfd: "\u{1105}\u{1175}\u{11BC}",
        nfkc: "\u{B9C1}",
        nfkd: "\u{1105}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B9C2}",
        nfc: "\u{B9C2}",
        nfd: "\u{1105}\u{1175}\u{11BD}",
        nfkc: "\u{B9C2}",
        nfkd: "\u{1105}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B9C3}",
        nfc: "\u{B9C3}",
        nfd: "\u{1105}\u{1175}\u{11BE}",
        nfkc: "\u{B9C3}",
        nfkd: "\u{1105}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B9C4}",
        nfc: "\u{B9C4}",
        nfd: "\u{1105}\u{1175}\u{11BF}",
        nfkc: "\u{B9C4}",
        nfkd: "\u{1105}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B9C5}",
        nfc: "\u{B9C5}",
        nfd: "\u{1105}\u{1175}\u{11C0}",
        nfkc: "\u{B9C5}",
        nfkd: "\u{1105}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B9C6}",
        nfc: "\u{B9C6}",
        nfd: "\u{1105}\u{1175}\u{11C1}",
        nfkc: "\u{B9C6}",
        nfkd: "\u{1105}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B9C7}",
        nfc: "\u{B9C7}",
        nfd: "\u{1105}\u{1175}\u{11C2}",
        nfkc: "\u{B9C7}",
        nfkd: "\u{1105}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B9C8}",
        nfc: "\u{B9C8}",
        nfd: "\u{1106}\u{1161}",
        nfkc: "\u{B9C8}",
        nfkd: "\u{1106}\u{1161}",
    },
    NormalizationTest {
        source: "\u{B9C9}",
        nfc: "\u{B9C9}",
        nfd: "\u{1106}\u{1161}\u{11A8}",
        nfkc: "\u{B9C9}",
        nfkd: "\u{1106}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B9CA}",
        nfc: "\u{B9CA}",
        nfd: "\u{1106}\u{1161}\u{11A9}",
        nfkc: "\u{B9CA}",
        nfkd: "\u{1106}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B9CB}",
        nfc: "\u{B9CB}",
        nfd: "\u{1106}\u{1161}\u{11AA}",
        nfkc: "\u{B9CB}",
        nfkd: "\u{1106}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B9CC}",
        nfc: "\u{B9CC}",
        nfd: "\u{1106}\u{1161}\u{11AB}",
        nfkc: "\u{B9CC}",
        nfkd: "\u{1106}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B9CD}",
        nfc: "\u{B9CD}",
        nfd: "\u{1106}\u{1161}\u{11AC}",
        nfkc: "\u{B9CD}",
        nfkd: "\u{1106}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B9CE}",
        nfc: "\u{B9CE}",
        nfd: "\u{1106}\u{1161}\u{11AD}",
        nfkc: "\u{B9CE}",
        nfkd: "\u{1106}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B9CF}",
        nfc: "\u{B9CF}",
        nfd: "\u{1106}\u{1161}\u{11AE}",
        nfkc: "\u{B9CF}",
        nfkd: "\u{1106}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B9D0}",
        nfc: "\u{B9D0}",
        nfd: "\u{1106}\u{1161}\u{11AF}",
        nfkc: "\u{B9D0}",
        nfkd: "\u{1106}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B9D1}",
        nfc: "\u{B9D1}",
        nfd: "\u{1106}\u{1161}\u{11B0}",
        nfkc: "\u{B9D1}",
        nfkd: "\u{1106}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B9D2}",
        nfc: "\u{B9D2}",
        nfd: "\u{1106}\u{1161}\u{11B1}",
        nfkc: "\u{B9D2}",
        nfkd: "\u{1106}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B9D3}",
        nfc: "\u{B9D3}",
        nfd: "\u{1106}\u{1161}\u{11B2}",
        nfkc: "\u{B9D3}",
        nfkd: "\u{1106}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B9D4}",
        nfc: "\u{B9D4}",
        nfd: "\u{1106}\u{1161}\u{11B3}",
        nfkc: "\u{B9D4}",
        nfkd: "\u{1106}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B9D5}",
        nfc: "\u{B9D5}",
        nfd: "\u{1106}\u{1161}\u{11B4}",
        nfkc: "\u{B9D5}",
        nfkd: "\u{1106}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B9D6}",
        nfc: "\u{B9D6}",
        nfd: "\u{1106}\u{1161}\u{11B5}",
        nfkc: "\u{B9D6}",
        nfkd: "\u{1106}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B9D7}",
        nfc: "\u{B9D7}",
        nfd: "\u{1106}\u{1161}\u{11B6}",
        nfkc: "\u{B9D7}",
        nfkd: "\u{1106}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B9D8}",
        nfc: "\u{B9D8}",
        nfd: "\u{1106}\u{1161}\u{11B7}",
        nfkc: "\u{B9D8}",
        nfkd: "\u{1106}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B9D9}",
        nfc: "\u{B9D9}",
        nfd: "\u{1106}\u{1161}\u{11B8}",
        nfkc: "\u{B9D9}",
        nfkd: "\u{1106}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B9DA}",
        nfc: "\u{B9DA}",
        nfd: "\u{1106}\u{1161}\u{11B9}",
        nfkc: "\u{B9DA}",
        nfkd: "\u{1106}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B9DB}",
        nfc: "\u{B9DB}",
        nfd: "\u{1106}\u{1161}\u{11BA}",
        nfkc: "\u{B9DB}",
        nfkd: "\u{1106}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B9DC}",
        nfc: "\u{B9DC}",
        nfd: "\u{1106}\u{1161}\u{11BB}",
        nfkc: "\u{B9DC}",
        nfkd: "\u{1106}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B9DD}",
        nfc: "\u{B9DD}",
        nfd: "\u{1106}\u{1161}\u{11BC}",
        nfkc: "\u{B9DD}",
        nfkd: "\u{1106}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B9DE}",
        nfc: "\u{B9DE}",
        nfd: "\u{1106}\u{1161}\u{11BD}",
        nfkc: "\u{B9DE}",
        nfkd: "\u{1106}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B9DF}",
        nfc: "\u{B9DF}",
        nfd: "\u{1106}\u{1161}\u{11BE}",
        nfkc: "\u{B9DF}",
        nfkd: "\u{1106}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B9E0}",
        nfc: "\u{B9E0}",
        nfd: "\u{1106}\u{1161}\u{11BF}",
        nfkc: "\u{B9E0}",
        nfkd: "\u{1106}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B9E1}",
        nfc: "\u{B9E1}",
        nfd: "\u{1106}\u{1161}\u{11C0}",
        nfkc: "\u{B9E1}",
        nfkd: "\u{1106}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B9E2}",
        nfc: "\u{B9E2}",
        nfd: "\u{1106}\u{1161}\u{11C1}",
        nfkc: "\u{B9E2}",
        nfkd: "\u{1106}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B9E3}",
        nfc: "\u{B9E3}",
        nfd: "\u{1106}\u{1161}\u{11C2}",
        nfkc: "\u{B9E3}",
        nfkd: "\u{1106}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{B9E4}",
        nfc: "\u{B9E4}",
        nfd: "\u{1106}\u{1162}",
        nfkc: "\u{B9E4}",
        nfkd: "\u{1106}\u{1162}",
    },
    NormalizationTest {
        source: "\u{B9E5}",
        nfc: "\u{B9E5}",
        nfd: "\u{1106}\u{1162}\u{11A8}",
        nfkc: "\u{B9E5}",
        nfkd: "\u{1106}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{B9E6}",
        nfc: "\u{B9E6}",
        nfd: "\u{1106}\u{1162}\u{11A9}",
        nfkc: "\u{B9E6}",
        nfkd: "\u{1106}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{B9E7}",
        nfc: "\u{B9E7}",
        nfd: "\u{1106}\u{1162}\u{11AA}",
        nfkc: "\u{B9E7}",
        nfkd: "\u{1106}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{B9E8}",
        nfc: "\u{B9E8}",
        nfd: "\u{1106}\u{1162}\u{11AB}",
        nfkc: "\u{B9E8}",
        nfkd: "\u{1106}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{B9E9}",
        nfc: "\u{B9E9}",
        nfd: "\u{1106}\u{1162}\u{11AC}",
        nfkc: "\u{B9E9}",
        nfkd: "\u{1106}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{B9EA}",
        nfc: "\u{B9EA}",
        nfd: "\u{1106}\u{1162}\u{11AD}",
        nfkc: "\u{B9EA}",
        nfkd: "\u{1106}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{B9EB}",
        nfc: "\u{B9EB}",
        nfd: "\u{1106}\u{1162}\u{11AE}",
        nfkc: "\u{B9EB}",
        nfkd: "\u{1106}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B9EC}",
        nfc: "\u{B9EC}",
        nfd: "\u{1106}\u{1162}\u{11AF}",
        nfkc: "\u{B9EC}",
        nfkd: "\u{1106}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{B9ED}",
        nfc: "\u{B9ED}",
        nfd: "\u{1106}\u{1162}\u{11B0}",
        nfkc: "\u{B9ED}",
        nfkd: "\u{1106}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{B9EE}",
        nfc: "\u{B9EE}",
        nfd: "\u{1106}\u{1162}\u{11B1}",
        nfkc: "\u{B9EE}",
        nfkd: "\u{1106}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{B9EF}",
        nfc: "\u{B9EF}",
        nfd: "\u{1106}\u{1162}\u{11B2}",
        nfkc: "\u{B9EF}",
        nfkd: "\u{1106}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{B9F0}",
        nfc: "\u{B9F0}",
        nfd: "\u{1106}\u{1162}\u{11B3}",
        nfkc: "\u{B9F0}",
        nfkd: "\u{1106}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{B9F1}",
        nfc: "\u{B9F1}",
        nfd: "\u{1106}\u{1162}\u{11B4}",
        nfkc: "\u{B9F1}",
        nfkd: "\u{1106}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{B9F2}",
        nfc: "\u{B9F2}",
        nfd: "\u{1106}\u{1162}\u{11B5}",
        nfkc: "\u{B9F2}",
        nfkd: "\u{1106}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B9F3}",
        nfc: "\u{B9F3}",
        nfd: "\u{1106}\u{1162}\u{11B6}",
        nfkc: "\u{B9F3}",
        nfkd: "\u{1106}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{B9F4}",
        nfc: "\u{B9F4}",
        nfd: "\u{1106}\u{1162}\u{11B7}",
        nfkc: "\u{B9F4}",
        nfkd: "\u{1106}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{B9F5}",
        nfc: "\u{B9F5}",
        nfd: "\u{1106}\u{1162}\u{11B8}",
        nfkc: "\u{B9F5}",
        nfkd: "\u{1106}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{B9F6}",
        nfc: "\u{B9F6}",
        nfd: "\u{1106}\u{1162}\u{11B9}",
        nfkc: "\u{B9F6}",
        nfkd: "\u{1106}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{B9F7}",
        nfc: "\u{B9F7}",
        nfd: "\u{1106}\u{1162}\u{11BA}",
        nfkc: "\u{B9F7}",
        nfkd: "\u{1106}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{B9F8}",
        nfc: "\u{B9F8}",
        nfd: "\u{1106}\u{1162}\u{11BB}",
        nfkc: "\u{B9F8}",
        nfkd: "\u{1106}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{B9F9}",
        nfc: "\u{B9F9}",
        nfd: "\u{1106}\u{1162}\u{11BC}",
        nfkc: "\u{B9F9}",
        nfkd: "\u{1106}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B9FA}",
        nfc: "\u{B9FA}",
        nfd: "\u{1106}\u{1162}\u{11BD}",
        nfkc: "\u{B9FA}",
        nfkd: "\u{1106}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{B9FB}",
        nfc: "\u{B9FB}",
        nfd: "\u{1106}\u{1162}\u{11BE}",
        nfkc: "\u{B9FB}",
        nfkd: "\u{1106}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{B9FC}",
        nfc: "\u{B9FC}",
        nfd: "\u{1106}\u{1162}\u{11BF}",
        nfkc: "\u{B9FC}",
        nfkd: "\u{1106}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{B9FD}",
        nfc: "\u{B9FD}",
        nfd: "\u{1106}\u{1162}\u{11C0}",
        nfkc: "\u{B9FD}",
        nfkd: "\u{1106}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{B9FE}",
        nfc: "\u{B9FE}",
        nfd: "\u{1106}\u{1162}\u{11C1}",
        nfkc: "\u{B9FE}",
        nfkd: "\u{1106}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{B9FF}",
        nfc: "\u{B9FF}",
        nfd: "\u{1106}\u{1162}\u{11C2}",
        nfkc: "\u{B9FF}",
        nfkd: "\u{1106}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BA00}",
        nfc: "\u{BA00}",
        nfd: "\u{1106}\u{1163}",
        nfkc: "\u{BA00}",
        nfkd: "\u{1106}\u{1163}",
    },
    NormalizationTest {
        source: "\u{BA01}",
        nfc: "\u{BA01}",
        nfd: "\u{1106}\u{1163}\u{11A8}",
        nfkc: "\u{BA01}",
        nfkd: "\u{1106}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BA02}",
        nfc: "\u{BA02}",
        nfd: "\u{1106}\u{1163}\u{11A9}",
        nfkc: "\u{BA02}",
        nfkd: "\u{1106}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BA03}",
        nfc: "\u{BA03}",
        nfd: "\u{1106}\u{1163}\u{11AA}",
        nfkc: "\u{BA03}",
        nfkd: "\u{1106}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BA04}",
        nfc: "\u{BA04}",
        nfd: "\u{1106}\u{1163}\u{11AB}",
        nfkc: "\u{BA04}",
        nfkd: "\u{1106}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BA05}",
        nfc: "\u{BA05}",
        nfd: "\u{1106}\u{1163}\u{11AC}",
        nfkc: "\u{BA05}",
        nfkd: "\u{1106}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BA06}",
        nfc: "\u{BA06}",
        nfd: "\u{1106}\u{1163}\u{11AD}",
        nfkc: "\u{BA06}",
        nfkd: "\u{1106}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BA07}",
        nfc: "\u{BA07}",
        nfd: "\u{1106}\u{1163}\u{11AE}",
        nfkc: "\u{BA07}",
        nfkd: "\u{1106}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BA08}",
        nfc: "\u{BA08}",
        nfd: "\u{1106}\u{1163}\u{11AF}",
        nfkc: "\u{BA08}",
        nfkd: "\u{1106}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BA09}",
        nfc: "\u{BA09}",
        nfd: "\u{1106}\u{1163}\u{11B0}",
        nfkc: "\u{BA09}",
        nfkd: "\u{1106}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BA0A}",
        nfc: "\u{BA0A}",
        nfd: "\u{1106}\u{1163}\u{11B1}",
        nfkc: "\u{BA0A}",
        nfkd: "\u{1106}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BA0B}",
        nfc: "\u{BA0B}",
        nfd: "\u{1106}\u{1163}\u{11B2}",
        nfkc: "\u{BA0B}",
        nfkd: "\u{1106}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BA0C}",
        nfc: "\u{BA0C}",
        nfd: "\u{1106}\u{1163}\u{11B3}",
        nfkc: "\u{BA0C}",
        nfkd: "\u{1106}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BA0D}",
        nfc: "\u{BA0D}",
        nfd: "\u{1106}\u{1163}\u{11B4}",
        nfkc: "\u{BA0D}",
        nfkd: "\u{1106}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BA0E}",
        nfc: "\u{BA0E}",
        nfd: "\u{1106}\u{1163}\u{11B5}",
        nfkc: "\u{BA0E}",
        nfkd: "\u{1106}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BA0F}",
        nfc: "\u{BA0F}",
        nfd: "\u{1106}\u{1163}\u{11B6}",
        nfkc: "\u{BA0F}",
        nfkd: "\u{1106}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BA10}",
        nfc: "\u{BA10}",
        nfd: "\u{1106}\u{1163}\u{11B7}",
        nfkc: "\u{BA10}",
        nfkd: "\u{1106}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BA11}",
        nfc: "\u{BA11}",
        nfd: "\u{1106}\u{1163}\u{11B8}",
        nfkc: "\u{BA11}",
        nfkd: "\u{1106}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BA12}",
        nfc: "\u{BA12}",
        nfd: "\u{1106}\u{1163}\u{11B9}",
        nfkc: "\u{BA12}",
        nfkd: "\u{1106}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BA13}",
        nfc: "\u{BA13}",
        nfd: "\u{1106}\u{1163}\u{11BA}",
        nfkc: "\u{BA13}",
        nfkd: "\u{1106}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BA14}",
        nfc: "\u{BA14}",
        nfd: "\u{1106}\u{1163}\u{11BB}",
        nfkc: "\u{BA14}",
        nfkd: "\u{1106}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BA15}",
        nfc: "\u{BA15}",
        nfd: "\u{1106}\u{1163}\u{11BC}",
        nfkc: "\u{BA15}",
        nfkd: "\u{1106}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BA16}",
        nfc: "\u{BA16}",
        nfd: "\u{1106}\u{1163}\u{11BD}",
        nfkc: "\u{BA16}",
        nfkd: "\u{1106}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BA17}",
        nfc: "\u{BA17}",
        nfd: "\u{1106}\u{1163}\u{11BE}",
        nfkc: "\u{BA17}",
        nfkd: "\u{1106}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BA18}",
        nfc: "\u{BA18}",
        nfd: "\u{1106}\u{1163}\u{11BF}",
        nfkc: "\u{BA18}",
        nfkd: "\u{1106}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BA19}",
        nfc: "\u{BA19}",
        nfd: "\u{1106}\u{1163}\u{11C0}",
        nfkc: "\u{BA19}",
        nfkd: "\u{1106}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BA1A}",
        nfc: "\u{BA1A}",
        nfd: "\u{1106}\u{1163}\u{11C1}",
        nfkc: "\u{BA1A}",
        nfkd: "\u{1106}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BA1B}",
        nfc: "\u{BA1B}",
        nfd: "\u{1106}\u{1163}\u{11C2}",
        nfkc: "\u{BA1B}",
        nfkd: "\u{1106}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BA1C}",
        nfc: "\u{BA1C}",
        nfd: "\u{1106}\u{1164}",
        nfkc: "\u{BA1C}",
        nfkd: "\u{1106}\u{1164}",
    },
    NormalizationTest {
        source: "\u{BA1D}",
        nfc: "\u{BA1D}",
        nfd: "\u{1106}\u{1164}\u{11A8}",
        nfkc: "\u{BA1D}",
        nfkd: "\u{1106}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BA1E}",
        nfc: "\u{BA1E}",
        nfd: "\u{1106}\u{1164}\u{11A9}",
        nfkc: "\u{BA1E}",
        nfkd: "\u{1106}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BA1F}",
        nfc: "\u{BA1F}",
        nfd: "\u{1106}\u{1164}\u{11AA}",
        nfkc: "\u{BA1F}",
        nfkd: "\u{1106}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BA20}",
        nfc: "\u{BA20}",
        nfd: "\u{1106}\u{1164}\u{11AB}",
        nfkc: "\u{BA20}",
        nfkd: "\u{1106}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BA21}",
        nfc: "\u{BA21}",
        nfd: "\u{1106}\u{1164}\u{11AC}",
        nfkc: "\u{BA21}",
        nfkd: "\u{1106}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BA22}",
        nfc: "\u{BA22}",
        nfd: "\u{1106}\u{1164}\u{11AD}",
        nfkc: "\u{BA22}",
        nfkd: "\u{1106}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BA23}",
        nfc: "\u{BA23}",
        nfd: "\u{1106}\u{1164}\u{11AE}",
        nfkc: "\u{BA23}",
        nfkd: "\u{1106}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BA24}",
        nfc: "\u{BA24}",
        nfd: "\u{1106}\u{1164}\u{11AF}",
        nfkc: "\u{BA24}",
        nfkd: "\u{1106}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BA25}",
        nfc: "\u{BA25}",
        nfd: "\u{1106}\u{1164}\u{11B0}",
        nfkc: "\u{BA25}",
        nfkd: "\u{1106}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BA26}",
        nfc: "\u{BA26}",
        nfd: "\u{1106}\u{1164}\u{11B1}",
        nfkc: "\u{BA26}",
        nfkd: "\u{1106}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BA27}",
        nfc: "\u{BA27}",
        nfd: "\u{1106}\u{1164}\u{11B2}",
        nfkc: "\u{BA27}",
        nfkd: "\u{1106}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BA28}",
        nfc: "\u{BA28}",
        nfd: "\u{1106}\u{1164}\u{11B3}",
        nfkc: "\u{BA28}",
        nfkd: "\u{1106}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BA29}",
        nfc: "\u{BA29}",
        nfd: "\u{1106}\u{1164}\u{11B4}",
        nfkc: "\u{BA29}",
        nfkd: "\u{1106}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BA2A}",
        nfc: "\u{BA2A}",
        nfd: "\u{1106}\u{1164}\u{11B5}",
        nfkc: "\u{BA2A}",
        nfkd: "\u{1106}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BA2B}",
        nfc: "\u{BA2B}",
        nfd: "\u{1106}\u{1164}\u{11B6}",
        nfkc: "\u{BA2B}",
        nfkd: "\u{1106}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BA2C}",
        nfc: "\u{BA2C}",
        nfd: "\u{1106}\u{1164}\u{11B7}",
        nfkc: "\u{BA2C}",
        nfkd: "\u{1106}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BA2D}",
        nfc: "\u{BA2D}",
        nfd: "\u{1106}\u{1164}\u{11B8}",
        nfkc: "\u{BA2D}",
        nfkd: "\u{1106}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BA2E}",
        nfc: "\u{BA2E}",
        nfd: "\u{1106}\u{1164}\u{11B9}",
        nfkc: "\u{BA2E}",
        nfkd: "\u{1106}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BA2F}",
        nfc: "\u{BA2F}",
        nfd: "\u{1106}\u{1164}\u{11BA}",
        nfkc: "\u{BA2F}",
        nfkd: "\u{1106}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BA30}",
        nfc: "\u{BA30}",
        nfd: "\u{1106}\u{1164}\u{11BB}",
        nfkc: "\u{BA30}",
        nfkd: "\u{1106}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BA31}",
        nfc: "\u{BA31}",
        nfd: "\u{1106}\u{1164}\u{11BC}",
        nfkc: "\u{BA31}",
        nfkd: "\u{1106}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BA32}",
        nfc: "\u{BA32}",
        nfd: "\u{1106}\u{1164}\u{11BD}",
        nfkc: "\u{BA32}",
        nfkd: "\u{1106}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BA33}",
        nfc: "\u{BA33}",
        nfd: "\u{1106}\u{1164}\u{11BE}",
        nfkc: "\u{BA33}",
        nfkd: "\u{1106}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BA34}",
        nfc: "\u{BA34}",
        nfd: "\u{1106}\u{1164}\u{11BF}",
        nfkc: "\u{BA34}",
        nfkd: "\u{1106}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BA35}",
        nfc: "\u{BA35}",
        nfd: "\u{1106}\u{1164}\u{11C0}",
        nfkc: "\u{BA35}",
        nfkd: "\u{1106}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BA36}",
        nfc: "\u{BA36}",
        nfd: "\u{1106}\u{1164}\u{11C1}",
        nfkc: "\u{BA36}",
        nfkd: "\u{1106}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BA37}",
        nfc: "\u{BA37}",
        nfd: "\u{1106}\u{1164}\u{11C2}",
        nfkc: "\u{BA37}",
        nfkd: "\u{1106}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BA38}",
        nfc: "\u{BA38}",
        nfd: "\u{1106}\u{1165}",
        nfkc: "\u{BA38}",
        nfkd: "\u{1106}\u{1165}",
    },
    NormalizationTest {
        source: "\u{BA39}",
        nfc: "\u{BA39}",
        nfd: "\u{1106}\u{1165}\u{11A8}",
        nfkc: "\u{BA39}",
        nfkd: "\u{1106}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BA3A}",
        nfc: "\u{BA3A}",
        nfd: "\u{1106}\u{1165}\u{11A9}",
        nfkc: "\u{BA3A}",
        nfkd: "\u{1106}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BA3B}",
        nfc: "\u{BA3B}",
        nfd: "\u{1106}\u{1165}\u{11AA}",
        nfkc: "\u{BA3B}",
        nfkd: "\u{1106}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BA3C}",
        nfc: "\u{BA3C}",
        nfd: "\u{1106}\u{1165}\u{11AB}",
        nfkc: "\u{BA3C}",
        nfkd: "\u{1106}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BA3D}",
        nfc: "\u{BA3D}",
        nfd: "\u{1106}\u{1165}\u{11AC}",
        nfkc: "\u{BA3D}",
        nfkd: "\u{1106}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BA3E}",
        nfc: "\u{BA3E}",
        nfd: "\u{1106}\u{1165}\u{11AD}",
        nfkc: "\u{BA3E}",
        nfkd: "\u{1106}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BA3F}",
        nfc: "\u{BA3F}",
        nfd: "\u{1106}\u{1165}\u{11AE}",
        nfkc: "\u{BA3F}",
        nfkd: "\u{1106}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BA40}",
        nfc: "\u{BA40}",
        nfd: "\u{1106}\u{1165}\u{11AF}",
        nfkc: "\u{BA40}",
        nfkd: "\u{1106}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BA41}",
        nfc: "\u{BA41}",
        nfd: "\u{1106}\u{1165}\u{11B0}",
        nfkc: "\u{BA41}",
        nfkd: "\u{1106}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BA42}",
        nfc: "\u{BA42}",
        nfd: "\u{1106}\u{1165}\u{11B1}",
        nfkc: "\u{BA42}",
        nfkd: "\u{1106}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BA43}",
        nfc: "\u{BA43}",
        nfd: "\u{1106}\u{1165}\u{11B2}",
        nfkc: "\u{BA43}",
        nfkd: "\u{1106}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BA44}",
        nfc: "\u{BA44}",
        nfd: "\u{1106}\u{1165}\u{11B3}",
        nfkc: "\u{BA44}",
        nfkd: "\u{1106}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BA45}",
        nfc: "\u{BA45}",
        nfd: "\u{1106}\u{1165}\u{11B4}",
        nfkc: "\u{BA45}",
        nfkd: "\u{1106}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BA46}",
        nfc: "\u{BA46}",
        nfd: "\u{1106}\u{1165}\u{11B5}",
        nfkc: "\u{BA46}",
        nfkd: "\u{1106}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BA47}",
        nfc: "\u{BA47}",
        nfd: "\u{1106}\u{1165}\u{11B6}",
        nfkc: "\u{BA47}",
        nfkd: "\u{1106}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BA48}",
        nfc: "\u{BA48}",
        nfd: "\u{1106}\u{1165}\u{11B7}",
        nfkc: "\u{BA48}",
        nfkd: "\u{1106}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BA49}",
        nfc: "\u{BA49}",
        nfd: "\u{1106}\u{1165}\u{11B8}",
        nfkc: "\u{BA49}",
        nfkd: "\u{1106}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BA4A}",
        nfc: "\u{BA4A}",
        nfd: "\u{1106}\u{1165}\u{11B9}",
        nfkc: "\u{BA4A}",
        nfkd: "\u{1106}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BA4B}",
        nfc: "\u{BA4B}",
        nfd: "\u{1106}\u{1165}\u{11BA}",
        nfkc: "\u{BA4B}",
        nfkd: "\u{1106}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BA4C}",
        nfc: "\u{BA4C}",
        nfd: "\u{1106}\u{1165}\u{11BB}",
        nfkc: "\u{BA4C}",
        nfkd: "\u{1106}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BA4D}",
        nfc: "\u{BA4D}",
        nfd: "\u{1106}\u{1165}\u{11BC}",
        nfkc: "\u{BA4D}",
        nfkd: "\u{1106}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BA4E}",
        nfc: "\u{BA4E}",
        nfd: "\u{1106}\u{1165}\u{11BD}",
        nfkc: "\u{BA4E}",
        nfkd: "\u{1106}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BA4F}",
        nfc: "\u{BA4F}",
        nfd: "\u{1106}\u{1165}\u{11BE}",
        nfkc: "\u{BA4F}",
        nfkd: "\u{1106}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BA50}",
        nfc: "\u{BA50}",
        nfd: "\u{1106}\u{1165}\u{11BF}",
        nfkc: "\u{BA50}",
        nfkd: "\u{1106}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BA51}",
        nfc: "\u{BA51}",
        nfd: "\u{1106}\u{1165}\u{11C0}",
        nfkc: "\u{BA51}",
        nfkd: "\u{1106}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BA52}",
        nfc: "\u{BA52}",
        nfd: "\u{1106}\u{1165}\u{11C1}",
        nfkc: "\u{BA52}",
        nfkd: "\u{1106}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BA53}",
        nfc: "\u{BA53}",
        nfd: "\u{1106}\u{1165}\u{11C2}",
        nfkc: "\u{BA53}",
        nfkd: "\u{1106}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BA54}",
        nfc: "\u{BA54}",
        nfd: "\u{1106}\u{1166}",
        nfkc: "\u{BA54}",
        nfkd: "\u{1106}\u{1166}",
    },
    NormalizationTest {
        source: "\u{BA55}",
        nfc: "\u{BA55}",
        nfd: "\u{1106}\u{1166}\u{11A8}",
        nfkc: "\u{BA55}",
        nfkd: "\u{1106}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BA56}",
        nfc: "\u{BA56}",
        nfd: "\u{1106}\u{1166}\u{11A9}",
        nfkc: "\u{BA56}",
        nfkd: "\u{1106}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BA57}",
        nfc: "\u{BA57}",
        nfd: "\u{1106}\u{1166}\u{11AA}",
        nfkc: "\u{BA57}",
        nfkd: "\u{1106}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BA58}",
        nfc: "\u{BA58}",
        nfd: "\u{1106}\u{1166}\u{11AB}",
        nfkc: "\u{BA58}",
        nfkd: "\u{1106}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BA59}",
        nfc: "\u{BA59}",
        nfd: "\u{1106}\u{1166}\u{11AC}",
        nfkc: "\u{BA59}",
        nfkd: "\u{1106}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BA5A}",
        nfc: "\u{BA5A}",
        nfd: "\u{1106}\u{1166}\u{11AD}",
        nfkc: "\u{BA5A}",
        nfkd: "\u{1106}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BA5B}",
        nfc: "\u{BA5B}",
        nfd: "\u{1106}\u{1166}\u{11AE}",
        nfkc: "\u{BA5B}",
        nfkd: "\u{1106}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BA5C}",
        nfc: "\u{BA5C}",
        nfd: "\u{1106}\u{1166}\u{11AF}",
        nfkc: "\u{BA5C}",
        nfkd: "\u{1106}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BA5D}",
        nfc: "\u{BA5D}",
        nfd: "\u{1106}\u{1166}\u{11B0}",
        nfkc: "\u{BA5D}",
        nfkd: "\u{1106}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BA5E}",
        nfc: "\u{BA5E}",
        nfd: "\u{1106}\u{1166}\u{11B1}",
        nfkc: "\u{BA5E}",
        nfkd: "\u{1106}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BA5F}",
        nfc: "\u{BA5F}",
        nfd: "\u{1106}\u{1166}\u{11B2}",
        nfkc: "\u{BA5F}",
        nfkd: "\u{1106}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BA60}",
        nfc: "\u{BA60}",
        nfd: "\u{1106}\u{1166}\u{11B3}",
        nfkc: "\u{BA60}",
        nfkd: "\u{1106}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BA61}",
        nfc: "\u{BA61}",
        nfd: "\u{1106}\u{1166}\u{11B4}",
        nfkc: "\u{BA61}",
        nfkd: "\u{1106}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BA62}",
        nfc: "\u{BA62}",
        nfd: "\u{1106}\u{1166}\u{11B5}",
        nfkc: "\u{BA62}",
        nfkd: "\u{1106}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BA63}",
        nfc: "\u{BA63}",
        nfd: "\u{1106}\u{1166}\u{11B6}",
        nfkc: "\u{BA63}",
        nfkd: "\u{1106}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BA64}",
        nfc: "\u{BA64}",
        nfd: "\u{1106}\u{1166}\u{11B7}",
        nfkc: "\u{BA64}",
        nfkd: "\u{1106}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BA65}",
        nfc: "\u{BA65}",
        nfd: "\u{1106}\u{1166}\u{11B8}",
        nfkc: "\u{BA65}",
        nfkd: "\u{1106}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BA66}",
        nfc: "\u{BA66}",
        nfd: "\u{1106}\u{1166}\u{11B9}",
        nfkc: "\u{BA66}",
        nfkd: "\u{1106}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BA67}",
        nfc: "\u{BA67}",
        nfd: "\u{1106}\u{1166}\u{11BA}",
        nfkc: "\u{BA67}",
        nfkd: "\u{1106}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BA68}",
        nfc: "\u{BA68}",
        nfd: "\u{1106}\u{1166}\u{11BB}",
        nfkc: "\u{BA68}",
        nfkd: "\u{1106}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BA69}",
        nfc: "\u{BA69}",
        nfd: "\u{1106}\u{1166}\u{11BC}",
        nfkc: "\u{BA69}",
        nfkd: "\u{1106}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BA6A}",
        nfc: "\u{BA6A}",
        nfd: "\u{1106}\u{1166}\u{11BD}",
        nfkc: "\u{BA6A}",
        nfkd: "\u{1106}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BA6B}",
        nfc: "\u{BA6B}",
        nfd: "\u{1106}\u{1166}\u{11BE}",
        nfkc: "\u{BA6B}",
        nfkd: "\u{1106}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BA6C}",
        nfc: "\u{BA6C}",
        nfd: "\u{1106}\u{1166}\u{11BF}",
        nfkc: "\u{BA6C}",
        nfkd: "\u{1106}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BA6D}",
        nfc: "\u{BA6D}",
        nfd: "\u{1106}\u{1166}\u{11C0}",
        nfkc: "\u{BA6D}",
        nfkd: "\u{1106}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BA6E}",
        nfc: "\u{BA6E}",
        nfd: "\u{1106}\u{1166}\u{11C1}",
        nfkc: "\u{BA6E}",
        nfkd: "\u{1106}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BA6F}",
        nfc: "\u{BA6F}",
        nfd: "\u{1106}\u{1166}\u{11C2}",
        nfkc: "\u{BA6F}",
        nfkd: "\u{1106}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BA70}",
        nfc: "\u{BA70}",
        nfd: "\u{1106}\u{1167}",
        nfkc: "\u{BA70}",
        nfkd: "\u{1106}\u{1167}",
    },
    NormalizationTest {
        source: "\u{BA71}",
        nfc: "\u{BA71}",
        nfd: "\u{1106}\u{1167}\u{11A8}",
        nfkc: "\u{BA71}",
        nfkd: "\u{1106}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BA72}",
        nfc: "\u{BA72}",
        nfd: "\u{1106}\u{1167}\u{11A9}",
        nfkc: "\u{BA72}",
        nfkd: "\u{1106}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BA73}",
        nfc: "\u{BA73}",
        nfd: "\u{1106}\u{1167}\u{11AA}",
        nfkc: "\u{BA73}",
        nfkd: "\u{1106}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BA74}",
        nfc: "\u{BA74}",
        nfd: "\u{1106}\u{1167}\u{11AB}",
        nfkc: "\u{BA74}",
        nfkd: "\u{1106}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BA75}",
        nfc: "\u{BA75}",
        nfd: "\u{1106}\u{1167}\u{11AC}",
        nfkc: "\u{BA75}",
        nfkd: "\u{1106}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BA76}",
        nfc: "\u{BA76}",
        nfd: "\u{1106}\u{1167}\u{11AD}",
        nfkc: "\u{BA76}",
        nfkd: "\u{1106}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BA77}",
        nfc: "\u{BA77}",
        nfd: "\u{1106}\u{1167}\u{11AE}",
        nfkc: "\u{BA77}",
        nfkd: "\u{1106}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BA78}",
        nfc: "\u{BA78}",
        nfd: "\u{1106}\u{1167}\u{11AF}",
        nfkc: "\u{BA78}",
        nfkd: "\u{1106}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BA79}",
        nfc: "\u{BA79}",
        nfd: "\u{1106}\u{1167}\u{11B0}",
        nfkc: "\u{BA79}",
        nfkd: "\u{1106}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BA7A}",
        nfc: "\u{BA7A}",
        nfd: "\u{1106}\u{1167}\u{11B1}",
        nfkc: "\u{BA7A}",
        nfkd: "\u{1106}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BA7B}",
        nfc: "\u{BA7B}",
        nfd: "\u{1106}\u{1167}\u{11B2}",
        nfkc: "\u{BA7B}",
        nfkd: "\u{1106}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BA7C}",
        nfc: "\u{BA7C}",
        nfd: "\u{1106}\u{1167}\u{11B3}",
        nfkc: "\u{BA7C}",
        nfkd: "\u{1106}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BA7D}",
        nfc: "\u{BA7D}",
        nfd: "\u{1106}\u{1167}\u{11B4}",
        nfkc: "\u{BA7D}",
        nfkd: "\u{1106}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BA7E}",
        nfc: "\u{BA7E}",
        nfd: "\u{1106}\u{1167}\u{11B5}",
        nfkc: "\u{BA7E}",
        nfkd: "\u{1106}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BA7F}",
        nfc: "\u{BA7F}",
        nfd: "\u{1106}\u{1167}\u{11B6}",
        nfkc: "\u{BA7F}",
        nfkd: "\u{1106}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BA80}",
        nfc: "\u{BA80}",
        nfd: "\u{1106}\u{1167}\u{11B7}",
        nfkc: "\u{BA80}",
        nfkd: "\u{1106}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BA81}",
        nfc: "\u{BA81}",
        nfd: "\u{1106}\u{1167}\u{11B8}",
        nfkc: "\u{BA81}",
        nfkd: "\u{1106}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BA82}",
        nfc: "\u{BA82}",
        nfd: "\u{1106}\u{1167}\u{11B9}",
        nfkc: "\u{BA82}",
        nfkd: "\u{1106}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BA83}",
        nfc: "\u{BA83}",
        nfd: "\u{1106}\u{1167}\u{11BA}",
        nfkc: "\u{BA83}",
        nfkd: "\u{1106}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BA84}",
        nfc: "\u{BA84}",
        nfd: "\u{1106}\u{1167}\u{11BB}",
        nfkc: "\u{BA84}",
        nfkd: "\u{1106}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BA85}",
        nfc: "\u{BA85}",
        nfd: "\u{1106}\u{1167}\u{11BC}",
        nfkc: "\u{BA85}",
        nfkd: "\u{1106}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BA86}",
        nfc: "\u{BA86}",
        nfd: "\u{1106}\u{1167}\u{11BD}",
        nfkc: "\u{BA86}",
        nfkd: "\u{1106}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BA87}",
        nfc: "\u{BA87}",
        nfd: "\u{1106}\u{1167}\u{11BE}",
        nfkc: "\u{BA87}",
        nfkd: "\u{1106}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BA88}",
        nfc: "\u{BA88}",
        nfd: "\u{1106}\u{1167}\u{11BF}",
        nfkc: "\u{BA88}",
        nfkd: "\u{1106}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BA89}",
        nfc: "\u{BA89}",
        nfd: "\u{1106}\u{1167}\u{11C0}",
        nfkc: "\u{BA89}",
        nfkd: "\u{1106}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BA8A}",
        nfc: "\u{BA8A}",
        nfd: "\u{1106}\u{1167}\u{11C1}",
        nfkc: "\u{BA8A}",
        nfkd: "\u{1106}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BA8B}",
        nfc: "\u{BA8B}",
        nfd: "\u{1106}\u{1167}\u{11C2}",
        nfkc: "\u{BA8B}",
        nfkd: "\u{1106}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BA8C}",
        nfc: "\u{BA8C}",
        nfd: "\u{1106}\u{1168}",
        nfkc: "\u{BA8C}",
        nfkd: "\u{1106}\u{1168}",
    },
    NormalizationTest {
        source: "\u{BA8D}",
        nfc: "\u{BA8D}",
        nfd: "\u{1106}\u{1168}\u{11A8}",
        nfkc: "\u{BA8D}",
        nfkd: "\u{1106}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BA8E}",
        nfc: "\u{BA8E}",
        nfd: "\u{1106}\u{1168}\u{11A9}",
        nfkc: "\u{BA8E}",
        nfkd: "\u{1106}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BA8F}",
        nfc: "\u{BA8F}",
        nfd: "\u{1106}\u{1168}\u{11AA}",
        nfkc: "\u{BA8F}",
        nfkd: "\u{1106}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BA90}",
        nfc: "\u{BA90}",
        nfd: "\u{1106}\u{1168}\u{11AB}",
        nfkc: "\u{BA90}",
        nfkd: "\u{1106}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BA91}",
        nfc: "\u{BA91}",
        nfd: "\u{1106}\u{1168}\u{11AC}",
        nfkc: "\u{BA91}",
        nfkd: "\u{1106}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BA92}",
        nfc: "\u{BA92}",
        nfd: "\u{1106}\u{1168}\u{11AD}",
        nfkc: "\u{BA92}",
        nfkd: "\u{1106}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BA93}",
        nfc: "\u{BA93}",
        nfd: "\u{1106}\u{1168}\u{11AE}",
        nfkc: "\u{BA93}",
        nfkd: "\u{1106}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BA94}",
        nfc: "\u{BA94}",
        nfd: "\u{1106}\u{1168}\u{11AF}",
        nfkc: "\u{BA94}",
        nfkd: "\u{1106}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BA95}",
        nfc: "\u{BA95}",
        nfd: "\u{1106}\u{1168}\u{11B0}",
        nfkc: "\u{BA95}",
        nfkd: "\u{1106}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BA96}",
        nfc: "\u{BA96}",
        nfd: "\u{1106}\u{1168}\u{11B1}",
        nfkc: "\u{BA96}",
        nfkd: "\u{1106}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BA97}",
        nfc: "\u{BA97}",
        nfd: "\u{1106}\u{1168}\u{11B2}",
        nfkc: "\u{BA97}",
        nfkd: "\u{1106}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BA98}",
        nfc: "\u{BA98}",
        nfd: "\u{1106}\u{1168}\u{11B3}",
        nfkc: "\u{BA98}",
        nfkd: "\u{1106}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BA99}",
        nfc: "\u{BA99}",
        nfd: "\u{1106}\u{1168}\u{11B4}",
        nfkc: "\u{BA99}",
        nfkd: "\u{1106}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BA9A}",
        nfc: "\u{BA9A}",
        nfd: "\u{1106}\u{1168}\u{11B5}",
        nfkc: "\u{BA9A}",
        nfkd: "\u{1106}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BA9B}",
        nfc: "\u{BA9B}",
        nfd: "\u{1106}\u{1168}\u{11B6}",
        nfkc: "\u{BA9B}",
        nfkd: "\u{1106}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BA9C}",
        nfc: "\u{BA9C}",
        nfd: "\u{1106}\u{1168}\u{11B7}",
        nfkc: "\u{BA9C}",
        nfkd: "\u{1106}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BA9D}",
        nfc: "\u{BA9D}",
        nfd: "\u{1106}\u{1168}\u{11B8}",
        nfkc: "\u{BA9D}",
        nfkd: "\u{1106}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BA9E}",
        nfc: "\u{BA9E}",
        nfd: "\u{1106}\u{1168}\u{11B9}",
        nfkc: "\u{BA9E}",
        nfkd: "\u{1106}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BA9F}",
        nfc: "\u{BA9F}",
        nfd: "\u{1106}\u{1168}\u{11BA}",
        nfkc: "\u{BA9F}",
        nfkd: "\u{1106}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BAA0}",
        nfc: "\u{BAA0}",
        nfd: "\u{1106}\u{1168}\u{11BB}",
        nfkc: "\u{BAA0}",
        nfkd: "\u{1106}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BAA1}",
        nfc: "\u{BAA1}",
        nfd: "\u{1106}\u{1168}\u{11BC}",
        nfkc: "\u{BAA1}",
        nfkd: "\u{1106}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BAA2}",
        nfc: "\u{BAA2}",
        nfd: "\u{1106}\u{1168}\u{11BD}",
        nfkc: "\u{BAA2}",
        nfkd: "\u{1106}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BAA3}",
        nfc: "\u{BAA3}",
        nfd: "\u{1106}\u{1168}\u{11BE}",
        nfkc: "\u{BAA3}",
        nfkd: "\u{1106}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BAA4}",
        nfc: "\u{BAA4}",
        nfd: "\u{1106}\u{1168}\u{11BF}",
        nfkc: "\u{BAA4}",
        nfkd: "\u{1106}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BAA5}",
        nfc: "\u{BAA5}",
        nfd: "\u{1106}\u{1168}\u{11C0}",
        nfkc: "\u{BAA5}",
        nfkd: "\u{1106}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BAA6}",
        nfc: "\u{BAA6}",
        nfd: "\u{1106}\u{1168}\u{11C1}",
        nfkc: "\u{BAA6}",
        nfkd: "\u{1106}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BAA7}",
        nfc: "\u{BAA7}",
        nfd: "\u{1106}\u{1168}\u{11C2}",
        nfkc: "\u{BAA7}",
        nfkd: "\u{1106}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BAA8}",
        nfc: "\u{BAA8}",
        nfd: "\u{1106}\u{1169}",
        nfkc: "\u{BAA8}",
        nfkd: "\u{1106}\u{1169}",
    },
    NormalizationTest {
        source: "\u{BAA9}",
        nfc: "\u{BAA9}",
        nfd: "\u{1106}\u{1169}\u{11A8}",
        nfkc: "\u{BAA9}",
        nfkd: "\u{1106}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BAAA}",
        nfc: "\u{BAAA}",
        nfd: "\u{1106}\u{1169}\u{11A9}",
        nfkc: "\u{BAAA}",
        nfkd: "\u{1106}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BAAB}",
        nfc: "\u{BAAB}",
        nfd: "\u{1106}\u{1169}\u{11AA}",
        nfkc: "\u{BAAB}",
        nfkd: "\u{1106}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BAAC}",
        nfc: "\u{BAAC}",
        nfd: "\u{1106}\u{1169}\u{11AB}",
        nfkc: "\u{BAAC}",
        nfkd: "\u{1106}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BAAD}",
        nfc: "\u{BAAD}",
        nfd: "\u{1106}\u{1169}\u{11AC}",
        nfkc: "\u{BAAD}",
        nfkd: "\u{1106}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BAAE}",
        nfc: "\u{BAAE}",
        nfd: "\u{1106}\u{1169}\u{11AD}",
        nfkc: "\u{BAAE}",
        nfkd: "\u{1106}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BAAF}",
        nfc: "\u{BAAF}",
        nfd: "\u{1106}\u{1169}\u{11AE}",
        nfkc: "\u{BAAF}",
        nfkd: "\u{1106}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BAB0}",
        nfc: "\u{BAB0}",
        nfd: "\u{1106}\u{1169}\u{11AF}",
        nfkc: "\u{BAB0}",
        nfkd: "\u{1106}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BAB1}",
        nfc: "\u{BAB1}",
        nfd: "\u{1106}\u{1169}\u{11B0}",
        nfkc: "\u{BAB1}",
        nfkd: "\u{1106}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BAB2}",
        nfc: "\u{BAB2}",
        nfd: "\u{1106}\u{1169}\u{11B1}",
        nfkc: "\u{BAB2}",
        nfkd: "\u{1106}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BAB3}",
        nfc: "\u{BAB3}",
        nfd: "\u{1106}\u{1169}\u{11B2}",
        nfkc: "\u{BAB3}",
        nfkd: "\u{1106}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BAB4}",
        nfc: "\u{BAB4}",
        nfd: "\u{1106}\u{1169}\u{11B3}",
        nfkc: "\u{BAB4}",
        nfkd: "\u{1106}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BAB5}",
        nfc: "\u{BAB5}",
        nfd: "\u{1106}\u{1169}\u{11B4}",
        nfkc: "\u{BAB5}",
        nfkd: "\u{1106}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BAB6}",
        nfc: "\u{BAB6}",
        nfd: "\u{1106}\u{1169}\u{11B5}",
        nfkc: "\u{BAB6}",
        nfkd: "\u{1106}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BAB7}",
        nfc: "\u{BAB7}",
        nfd: "\u{1106}\u{1169}\u{11B6}",
        nfkc: "\u{BAB7}",
        nfkd: "\u{1106}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BAB8}",
        nfc: "\u{BAB8}",
        nfd: "\u{1106}\u{1169}\u{11B7}",
        nfkc: "\u{BAB8}",
        nfkd: "\u{1106}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BAB9}",
        nfc: "\u{BAB9}",
        nfd: "\u{1106}\u{1169}\u{11B8}",
        nfkc: "\u{BAB9}",
        nfkd: "\u{1106}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BABA}",
        nfc: "\u{BABA}",
        nfd: "\u{1106}\u{1169}\u{11B9}",
        nfkc: "\u{BABA}",
        nfkd: "\u{1106}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BABB}",
        nfc: "\u{BABB}",
        nfd: "\u{1106}\u{1169}\u{11BA}",
        nfkc: "\u{BABB}",
        nfkd: "\u{1106}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BABC}",
        nfc: "\u{BABC}",
        nfd: "\u{1106}\u{1169}\u{11BB}",
        nfkc: "\u{BABC}",
        nfkd: "\u{1106}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BABD}",
        nfc: "\u{BABD}",
        nfd: "\u{1106}\u{1169}\u{11BC}",
        nfkc: "\u{BABD}",
        nfkd: "\u{1106}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BABE}",
        nfc: "\u{BABE}",
        nfd: "\u{1106}\u{1169}\u{11BD}",
        nfkc: "\u{BABE}",
        nfkd: "\u{1106}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BABF}",
        nfc: "\u{BABF}",
        nfd: "\u{1106}\u{1169}\u{11BE}",
        nfkc: "\u{BABF}",
        nfkd: "\u{1106}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BAC0}",
        nfc: "\u{BAC0}",
        nfd: "\u{1106}\u{1169}\u{11BF}",
        nfkc: "\u{BAC0}",
        nfkd: "\u{1106}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BAC1}",
        nfc: "\u{BAC1}",
        nfd: "\u{1106}\u{1169}\u{11C0}",
        nfkc: "\u{BAC1}",
        nfkd: "\u{1106}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BAC2}",
        nfc: "\u{BAC2}",
        nfd: "\u{1106}\u{1169}\u{11C1}",
        nfkc: "\u{BAC2}",
        nfkd: "\u{1106}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BAC3}",
        nfc: "\u{BAC3}",
        nfd: "\u{1106}\u{1169}\u{11C2}",
        nfkc: "\u{BAC3}",
        nfkd: "\u{1106}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BAC4}",
        nfc: "\u{BAC4}",
        nfd: "\u{1106}\u{116A}",
        nfkc: "\u{BAC4}",
        nfkd: "\u{1106}\u{116A}",
    },
    NormalizationTest {
        source: "\u{BAC5}",
        nfc: "\u{BAC5}",
        nfd: "\u{1106}\u{116A}\u{11A8}",
        nfkc: "\u{BAC5}",
        nfkd: "\u{1106}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BAC6}",
        nfc: "\u{BAC6}",
        nfd: "\u{1106}\u{116A}\u{11A9}",
        nfkc: "\u{BAC6}",
        nfkd: "\u{1106}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BAC7}",
        nfc: "\u{BAC7}",
        nfd: "\u{1106}\u{116A}\u{11AA}",
        nfkc: "\u{BAC7}",
        nfkd: "\u{1106}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BAC8}",
        nfc: "\u{BAC8}",
        nfd: "\u{1106}\u{116A}\u{11AB}",
        nfkc: "\u{BAC8}",
        nfkd: "\u{1106}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BAC9}",
        nfc: "\u{BAC9}",
        nfd: "\u{1106}\u{116A}\u{11AC}",
        nfkc: "\u{BAC9}",
        nfkd: "\u{1106}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BACA}",
        nfc: "\u{BACA}",
        nfd: "\u{1106}\u{116A}\u{11AD}",
        nfkc: "\u{BACA}",
        nfkd: "\u{1106}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BACB}",
        nfc: "\u{BACB}",
        nfd: "\u{1106}\u{116A}\u{11AE}",
        nfkc: "\u{BACB}",
        nfkd: "\u{1106}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BACC}",
        nfc: "\u{BACC}",
        nfd: "\u{1106}\u{116A}\u{11AF}",
        nfkc: "\u{BACC}",
        nfkd: "\u{1106}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BACD}",
        nfc: "\u{BACD}",
        nfd: "\u{1106}\u{116A}\u{11B0}",
        nfkc: "\u{BACD}",
        nfkd: "\u{1106}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BACE}",
        nfc: "\u{BACE}",
        nfd: "\u{1106}\u{116A}\u{11B1}",
        nfkc: "\u{BACE}",
        nfkd: "\u{1106}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BACF}",
        nfc: "\u{BACF}",
        nfd: "\u{1106}\u{116A}\u{11B2}",
        nfkc: "\u{BACF}",
        nfkd: "\u{1106}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BAD0}",
        nfc: "\u{BAD0}",
        nfd: "\u{1106}\u{116A}\u{11B3}",
        nfkc: "\u{BAD0}",
        nfkd: "\u{1106}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BAD1}",
        nfc: "\u{BAD1}",
        nfd: "\u{1106}\u{116A}\u{11B4}",
        nfkc: "\u{BAD1}",
        nfkd: "\u{1106}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BAD2}",
        nfc: "\u{BAD2}",
        nfd: "\u{1106}\u{116A}\u{11B5}",
        nfkc: "\u{BAD2}",
        nfkd: "\u{1106}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BAD3}",
        nfc: "\u{BAD3}",
        nfd: "\u{1106}\u{116A}\u{11B6}",
        nfkc: "\u{BAD3}",
        nfkd: "\u{1106}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BAD4}",
        nfc: "\u{BAD4}",
        nfd: "\u{1106}\u{116A}\u{11B7}",
        nfkc: "\u{BAD4}",
        nfkd: "\u{1106}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BAD5}",
        nfc: "\u{BAD5}",
        nfd: "\u{1106}\u{116A}\u{11B8}",
        nfkc: "\u{BAD5}",
        nfkd: "\u{1106}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BAD6}",
        nfc: "\u{BAD6}",
        nfd: "\u{1106}\u{116A}\u{11B9}",
        nfkc: "\u{BAD6}",
        nfkd: "\u{1106}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BAD7}",
        nfc: "\u{BAD7}",
        nfd: "\u{1106}\u{116A}\u{11BA}",
        nfkc: "\u{BAD7}",
        nfkd: "\u{1106}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BAD8}",
        nfc: "\u{BAD8}",
        nfd: "\u{1106}\u{116A}\u{11BB}",
        nfkc: "\u{BAD8}",
        nfkd: "\u{1106}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BAD9}",
        nfc: "\u{BAD9}",
        nfd: "\u{1106}\u{116A}\u{11BC}",
        nfkc: "\u{BAD9}",
        nfkd: "\u{1106}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BADA}",
        nfc: "\u{BADA}",
        nfd: "\u{1106}\u{116A}\u{11BD}",
        nfkc: "\u{BADA}",
        nfkd: "\u{1106}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BADB}",
        nfc: "\u{BADB}",
        nfd: "\u{1106}\u{116A}\u{11BE}",
        nfkc: "\u{BADB}",
        nfkd: "\u{1106}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BADC}",
        nfc: "\u{BADC}",
        nfd: "\u{1106}\u{116A}\u{11BF}",
        nfkc: "\u{BADC}",
        nfkd: "\u{1106}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BADD}",
        nfc: "\u{BADD}",
        nfd: "\u{1106}\u{116A}\u{11C0}",
        nfkc: "\u{BADD}",
        nfkd: "\u{1106}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BADE}",
        nfc: "\u{BADE}",
        nfd: "\u{1106}\u{116A}\u{11C1}",
        nfkc: "\u{BADE}",
        nfkd: "\u{1106}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BADF}",
        nfc: "\u{BADF}",
        nfd: "\u{1106}\u{116A}\u{11C2}",
        nfkc: "\u{BADF}",
        nfkd: "\u{1106}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BAE0}",
        nfc: "\u{BAE0}",
        nfd: "\u{1106}\u{116B}",
        nfkc: "\u{BAE0}",
        nfkd: "\u{1106}\u{116B}",
    },
    NormalizationTest {
        source: "\u{BAE1}",
        nfc: "\u{BAE1}",
        nfd: "\u{1106}\u{116B}\u{11A8}",
        nfkc: "\u{BAE1}",
        nfkd: "\u{1106}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BAE2}",
        nfc: "\u{BAE2}",
        nfd: "\u{1106}\u{116B}\u{11A9}",
        nfkc: "\u{BAE2}",
        nfkd: "\u{1106}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BAE3}",
        nfc: "\u{BAE3}",
        nfd: "\u{1106}\u{116B}\u{11AA}",
        nfkc: "\u{BAE3}",
        nfkd: "\u{1106}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BAE4}",
        nfc: "\u{BAE4}",
        nfd: "\u{1106}\u{116B}\u{11AB}",
        nfkc: "\u{BAE4}",
        nfkd: "\u{1106}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BAE5}",
        nfc: "\u{BAE5}",
        nfd: "\u{1106}\u{116B}\u{11AC}",
        nfkc: "\u{BAE5}",
        nfkd: "\u{1106}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BAE6}",
        nfc: "\u{BAE6}",
        nfd: "\u{1106}\u{116B}\u{11AD}",
        nfkc: "\u{BAE6}",
        nfkd: "\u{1106}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BAE7}",
        nfc: "\u{BAE7}",
        nfd: "\u{1106}\u{116B}\u{11AE}",
        nfkc: "\u{BAE7}",
        nfkd: "\u{1106}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BAE8}",
        nfc: "\u{BAE8}",
        nfd: "\u{1106}\u{116B}\u{11AF}",
        nfkc: "\u{BAE8}",
        nfkd: "\u{1106}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BAE9}",
        nfc: "\u{BAE9}",
        nfd: "\u{1106}\u{116B}\u{11B0}",
        nfkc: "\u{BAE9}",
        nfkd: "\u{1106}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BAEA}",
        nfc: "\u{BAEA}",
        nfd: "\u{1106}\u{116B}\u{11B1}",
        nfkc: "\u{BAEA}",
        nfkd: "\u{1106}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BAEB}",
        nfc: "\u{BAEB}",
        nfd: "\u{1106}\u{116B}\u{11B2}",
        nfkc: "\u{BAEB}",
        nfkd: "\u{1106}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BAEC}",
        nfc: "\u{BAEC}",
        nfd: "\u{1106}\u{116B}\u{11B3}",
        nfkc: "\u{BAEC}",
        nfkd: "\u{1106}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BAED}",
        nfc: "\u{BAED}",
        nfd: "\u{1106}\u{116B}\u{11B4}",
        nfkc: "\u{BAED}",
        nfkd: "\u{1106}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BAEE}",
        nfc: "\u{BAEE}",
        nfd: "\u{1106}\u{116B}\u{11B5}",
        nfkc: "\u{BAEE}",
        nfkd: "\u{1106}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BAEF}",
        nfc: "\u{BAEF}",
        nfd: "\u{1106}\u{116B}\u{11B6}",
        nfkc: "\u{BAEF}",
        nfkd: "\u{1106}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BAF0}",
        nfc: "\u{BAF0}",
        nfd: "\u{1106}\u{116B}\u{11B7}",
        nfkc: "\u{BAF0}",
        nfkd: "\u{1106}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BAF1}",
        nfc: "\u{BAF1}",
        nfd: "\u{1106}\u{116B}\u{11B8}",
        nfkc: "\u{BAF1}",
        nfkd: "\u{1106}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BAF2}",
        nfc: "\u{BAF2}",
        nfd: "\u{1106}\u{116B}\u{11B9}",
        nfkc: "\u{BAF2}",
        nfkd: "\u{1106}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BAF3}",
        nfc: "\u{BAF3}",
        nfd: "\u{1106}\u{116B}\u{11BA}",
        nfkc: "\u{BAF3}",
        nfkd: "\u{1106}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BAF4}",
        nfc: "\u{BAF4}",
        nfd: "\u{1106}\u{116B}\u{11BB}",
        nfkc: "\u{BAF4}",
        nfkd: "\u{1106}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BAF5}",
        nfc: "\u{BAF5}",
        nfd: "\u{1106}\u{116B}\u{11BC}",
        nfkc: "\u{BAF5}",
        nfkd: "\u{1106}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BAF6}",
        nfc: "\u{BAF6}",
        nfd: "\u{1106}\u{116B}\u{11BD}",
        nfkc: "\u{BAF6}",
        nfkd: "\u{1106}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BAF7}",
        nfc: "\u{BAF7}",
        nfd: "\u{1106}\u{116B}\u{11BE}",
        nfkc: "\u{BAF7}",
        nfkd: "\u{1106}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BAF8}",
        nfc: "\u{BAF8}",
        nfd: "\u{1106}\u{116B}\u{11BF}",
        nfkc: "\u{BAF8}",
        nfkd: "\u{1106}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BAF9}",
        nfc: "\u{BAF9}",
        nfd: "\u{1106}\u{116B}\u{11C0}",
        nfkc: "\u{BAF9}",
        nfkd: "\u{1106}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BAFA}",
        nfc: "\u{BAFA}",
        nfd: "\u{1106}\u{116B}\u{11C1}",
        nfkc: "\u{BAFA}",
        nfkd: "\u{1106}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BAFB}",
        nfc: "\u{BAFB}",
        nfd: "\u{1106}\u{116B}\u{11C2}",
        nfkc: "\u{BAFB}",
        nfkd: "\u{1106}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BAFC}",
        nfc: "\u{BAFC}",
        nfd: "\u{1106}\u{116C}",
        nfkc: "\u{BAFC}",
        nfkd: "\u{1106}\u{116C}",
    },
    NormalizationTest {
        source: "\u{BAFD}",
        nfc: "\u{BAFD}",
        nfd: "\u{1106}\u{116C}\u{11A8}",
        nfkc: "\u{BAFD}",
        nfkd: "\u{1106}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BAFE}",
        nfc: "\u{BAFE}",
        nfd: "\u{1106}\u{116C}\u{11A9}",
        nfkc: "\u{BAFE}",
        nfkd: "\u{1106}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BAFF}",
        nfc: "\u{BAFF}",
        nfd: "\u{1106}\u{116C}\u{11AA}",
        nfkc: "\u{BAFF}",
        nfkd: "\u{1106}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BB00}",
        nfc: "\u{BB00}",
        nfd: "\u{1106}\u{116C}\u{11AB}",
        nfkc: "\u{BB00}",
        nfkd: "\u{1106}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BB01}",
        nfc: "\u{BB01}",
        nfd: "\u{1106}\u{116C}\u{11AC}",
        nfkc: "\u{BB01}",
        nfkd: "\u{1106}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BB02}",
        nfc: "\u{BB02}",
        nfd: "\u{1106}\u{116C}\u{11AD}",
        nfkc: "\u{BB02}",
        nfkd: "\u{1106}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BB03}",
        nfc: "\u{BB03}",
        nfd: "\u{1106}\u{116C}\u{11AE}",
        nfkc: "\u{BB03}",
        nfkd: "\u{1106}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BB04}",
        nfc: "\u{BB04}",
        nfd: "\u{1106}\u{116C}\u{11AF}",
        nfkc: "\u{BB04}",
        nfkd: "\u{1106}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BB05}",
        nfc: "\u{BB05}",
        nfd: "\u{1106}\u{116C}\u{11B0}",
        nfkc: "\u{BB05}",
        nfkd: "\u{1106}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BB06}",
        nfc: "\u{BB06}",
        nfd: "\u{1106}\u{116C}\u{11B1}",
        nfkc: "\u{BB06}",
        nfkd: "\u{1106}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BB07}",
        nfc: "\u{BB07}",
        nfd: "\u{1106}\u{116C}\u{11B2}",
        nfkc: "\u{BB07}",
        nfkd: "\u{1106}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BB08}",
        nfc: "\u{BB08}",
        nfd: "\u{1106}\u{116C}\u{11B3}",
        nfkc: "\u{BB08}",
        nfkd: "\u{1106}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BB09}",
        nfc: "\u{BB09}",
        nfd: "\u{1106}\u{116C}\u{11B4}",
        nfkc: "\u{BB09}",
        nfkd: "\u{1106}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BB0A}",
        nfc: "\u{BB0A}",
        nfd: "\u{1106}\u{116C}\u{11B5}",
        nfkc: "\u{BB0A}",
        nfkd: "\u{1106}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BB0B}",
        nfc: "\u{BB0B}",
        nfd: "\u{1106}\u{116C}\u{11B6}",
        nfkc: "\u{BB0B}",
        nfkd: "\u{1106}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BB0C}",
        nfc: "\u{BB0C}",
        nfd: "\u{1106}\u{116C}\u{11B7}",
        nfkc: "\u{BB0C}",
        nfkd: "\u{1106}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BB0D}",
        nfc: "\u{BB0D}",
        nfd: "\u{1106}\u{116C}\u{11B8}",
        nfkc: "\u{BB0D}",
        nfkd: "\u{1106}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BB0E}",
        nfc: "\u{BB0E}",
        nfd: "\u{1106}\u{116C}\u{11B9}",
        nfkc: "\u{BB0E}",
        nfkd: "\u{1106}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BB0F}",
        nfc: "\u{BB0F}",
        nfd: "\u{1106}\u{116C}\u{11BA}",
        nfkc: "\u{BB0F}",
        nfkd: "\u{1106}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BB10}",
        nfc: "\u{BB10}",
        nfd: "\u{1106}\u{116C}\u{11BB}",
        nfkc: "\u{BB10}",
        nfkd: "\u{1106}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BB11}",
        nfc: "\u{BB11}",
        nfd: "\u{1106}\u{116C}\u{11BC}",
        nfkc: "\u{BB11}",
        nfkd: "\u{1106}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BB12}",
        nfc: "\u{BB12}",
        nfd: "\u{1106}\u{116C}\u{11BD}",
        nfkc: "\u{BB12}",
        nfkd: "\u{1106}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BB13}",
        nfc: "\u{BB13}",
        nfd: "\u{1106}\u{116C}\u{11BE}",
        nfkc: "\u{BB13}",
        nfkd: "\u{1106}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BB14}",
        nfc: "\u{BB14}",
        nfd: "\u{1106}\u{116C}\u{11BF}",
        nfkc: "\u{BB14}",
        nfkd: "\u{1106}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BB15}",
        nfc: "\u{BB15}",
        nfd: "\u{1106}\u{116C}\u{11C0}",
        nfkc: "\u{BB15}",
        nfkd: "\u{1106}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BB16}",
        nfc: "\u{BB16}",
        nfd: "\u{1106}\u{116C}\u{11C1}",
        nfkc: "\u{BB16}",
        nfkd: "\u{1106}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BB17}",
        nfc: "\u{BB17}",
        nfd: "\u{1106}\u{116C}\u{11C2}",
        nfkc: "\u{BB17}",
        nfkd: "\u{1106}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BB18}",
        nfc: "\u{BB18}",
        nfd: "\u{1106}\u{116D}",
        nfkc: "\u{BB18}",
        nfkd: "\u{1106}\u{116D}",
    },
    NormalizationTest {
        source: "\u{BB19}",
        nfc: "\u{BB19}",
        nfd: "\u{1106}\u{116D}\u{11A8}",
        nfkc: "\u{BB19}",
        nfkd: "\u{1106}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BB1A}",
        nfc: "\u{BB1A}",
        nfd: "\u{1106}\u{116D}\u{11A9}",
        nfkc: "\u{BB1A}",
        nfkd: "\u{1106}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BB1B}",
        nfc: "\u{BB1B}",
        nfd: "\u{1106}\u{116D}\u{11AA}",
        nfkc: "\u{BB1B}",
        nfkd: "\u{1106}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BB1C}",
        nfc: "\u{BB1C}",
        nfd: "\u{1106}\u{116D}\u{11AB}",
        nfkc: "\u{BB1C}",
        nfkd: "\u{1106}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BB1D}",
        nfc: "\u{BB1D}",
        nfd: "\u{1106}\u{116D}\u{11AC}",
        nfkc: "\u{BB1D}",
        nfkd: "\u{1106}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BB1E}",
        nfc: "\u{BB1E}",
        nfd: "\u{1106}\u{116D}\u{11AD}",
        nfkc: "\u{BB1E}",
        nfkd: "\u{1106}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BB1F}",
        nfc: "\u{BB1F}",
        nfd: "\u{1106}\u{116D}\u{11AE}",
        nfkc: "\u{BB1F}",
        nfkd: "\u{1106}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BB20}",
        nfc: "\u{BB20}",
        nfd: "\u{1106}\u{116D}\u{11AF}",
        nfkc: "\u{BB20}",
        nfkd: "\u{1106}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BB21}",
        nfc: "\u{BB21}",
        nfd: "\u{1106}\u{116D}\u{11B0}",
        nfkc: "\u{BB21}",
        nfkd: "\u{1106}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BB22}",
        nfc: "\u{BB22}",
        nfd: "\u{1106}\u{116D}\u{11B1}",
        nfkc: "\u{BB22}",
        nfkd: "\u{1106}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BB23}",
        nfc: "\u{BB23}",
        nfd: "\u{1106}\u{116D}\u{11B2}",
        nfkc: "\u{BB23}",
        nfkd: "\u{1106}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BB24}",
        nfc: "\u{BB24}",
        nfd: "\u{1106}\u{116D}\u{11B3}",
        nfkc: "\u{BB24}",
        nfkd: "\u{1106}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BB25}",
        nfc: "\u{BB25}",
        nfd: "\u{1106}\u{116D}\u{11B4}",
        nfkc: "\u{BB25}",
        nfkd: "\u{1106}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BB26}",
        nfc: "\u{BB26}",
        nfd: "\u{1106}\u{116D}\u{11B5}",
        nfkc: "\u{BB26}",
        nfkd: "\u{1106}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BB27}",
        nfc: "\u{BB27}",
        nfd: "\u{1106}\u{116D}\u{11B6}",
        nfkc: "\u{BB27}",
        nfkd: "\u{1106}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BB28}",
        nfc: "\u{BB28}",
        nfd: "\u{1106}\u{116D}\u{11B7}",
        nfkc: "\u{BB28}",
        nfkd: "\u{1106}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BB29}",
        nfc: "\u{BB29}",
        nfd: "\u{1106}\u{116D}\u{11B8}",
        nfkc: "\u{BB29}",
        nfkd: "\u{1106}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BB2A}",
        nfc: "\u{BB2A}",
        nfd: "\u{1106}\u{116D}\u{11B9}",
        nfkc: "\u{BB2A}",
        nfkd: "\u{1106}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BB2B}",
        nfc: "\u{BB2B}",
        nfd: "\u{1106}\u{116D}\u{11BA}",
        nfkc: "\u{BB2B}",
        nfkd: "\u{1106}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BB2C}",
        nfc: "\u{BB2C}",
        nfd: "\u{1106}\u{116D}\u{11BB}",
        nfkc: "\u{BB2C}",
        nfkd: "\u{1106}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BB2D}",
        nfc: "\u{BB2D}",
        nfd: "\u{1106}\u{116D}\u{11BC}",
        nfkc: "\u{BB2D}",
        nfkd: "\u{1106}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BB2E}",
        nfc: "\u{BB2E}",
        nfd: "\u{1106}\u{116D}\u{11BD}",
        nfkc: "\u{BB2E}",
        nfkd: "\u{1106}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BB2F}",
        nfc: "\u{BB2F}",
        nfd: "\u{1106}\u{116D}\u{11BE}",
        nfkc: "\u{BB2F}",
        nfkd: "\u{1106}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BB30}",
        nfc: "\u{BB30}",
        nfd: "\u{1106}\u{116D}\u{11BF}",
        nfkc: "\u{BB30}",
        nfkd: "\u{1106}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BB31}",
        nfc: "\u{BB31}",
        nfd: "\u{1106}\u{116D}\u{11C0}",
        nfkc: "\u{BB31}",
        nfkd: "\u{1106}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BB32}",
        nfc: "\u{BB32}",
        nfd: "\u{1106}\u{116D}\u{11C1}",
        nfkc: "\u{BB32}",
        nfkd: "\u{1106}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BB33}",
        nfc: "\u{BB33}",
        nfd: "\u{1106}\u{116D}\u{11C2}",
        nfkc: "\u{BB33}",
        nfkd: "\u{1106}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BB34}",
        nfc: "\u{BB34}",
        nfd: "\u{1106}\u{116E}",
        nfkc: "\u{BB34}",
        nfkd: "\u{1106}\u{116E}",
    },
    NormalizationTest {
        source: "\u{BB35}",
        nfc: "\u{BB35}",
        nfd: "\u{1106}\u{116E}\u{11A8}",
        nfkc: "\u{BB35}",
        nfkd: "\u{1106}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BB36}",
        nfc: "\u{BB36}",
        nfd: "\u{1106}\u{116E}\u{11A9}",
        nfkc: "\u{BB36}",
        nfkd: "\u{1106}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BB37}",
        nfc: "\u{BB37}",
        nfd: "\u{1106}\u{116E}\u{11AA}",
        nfkc: "\u{BB37}",
        nfkd: "\u{1106}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BB38}",
        nfc: "\u{BB38}",
        nfd: "\u{1106}\u{116E}\u{11AB}",
        nfkc: "\u{BB38}",
        nfkd: "\u{1106}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BB39}",
        nfc: "\u{BB39}",
        nfd: "\u{1106}\u{116E}\u{11AC}",
        nfkc: "\u{BB39}",
        nfkd: "\u{1106}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BB3A}",
        nfc: "\u{BB3A}",
        nfd: "\u{1106}\u{116E}\u{11AD}",
        nfkc: "\u{BB3A}",
        nfkd: "\u{1106}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BB3B}",
        nfc: "\u{BB3B}",
        nfd: "\u{1106}\u{116E}\u{11AE}",
        nfkc: "\u{BB3B}",
        nfkd: "\u{1106}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BB3C}",
        nfc: "\u{BB3C}",
        nfd: "\u{1106}\u{116E}\u{11AF}",
        nfkc: "\u{BB3C}",
        nfkd: "\u{1106}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BB3D}",
        nfc: "\u{BB3D}",
        nfd: "\u{1106}\u{116E}\u{11B0}",
        nfkc: "\u{BB3D}",
        nfkd: "\u{1106}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BB3E}",
        nfc: "\u{BB3E}",
        nfd: "\u{1106}\u{116E}\u{11B1}",
        nfkc: "\u{BB3E}",
        nfkd: "\u{1106}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BB3F}",
        nfc: "\u{BB3F}",
        nfd: "\u{1106}\u{116E}\u{11B2}",
        nfkc: "\u{BB3F}",
        nfkd: "\u{1106}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BB40}",
        nfc: "\u{BB40}",
        nfd: "\u{1106}\u{116E}\u{11B3}",
        nfkc: "\u{BB40}",
        nfkd: "\u{1106}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BB41}",
        nfc: "\u{BB41}",
        nfd: "\u{1106}\u{116E}\u{11B4}",
        nfkc: "\u{BB41}",
        nfkd: "\u{1106}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BB42}",
        nfc: "\u{BB42}",
        nfd: "\u{1106}\u{116E}\u{11B5}",
        nfkc: "\u{BB42}",
        nfkd: "\u{1106}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BB43}",
        nfc: "\u{BB43}",
        nfd: "\u{1106}\u{116E}\u{11B6}",
        nfkc: "\u{BB43}",
        nfkd: "\u{1106}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BB44}",
        nfc: "\u{BB44}",
        nfd: "\u{1106}\u{116E}\u{11B7}",
        nfkc: "\u{BB44}",
        nfkd: "\u{1106}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BB45}",
        nfc: "\u{BB45}",
        nfd: "\u{1106}\u{116E}\u{11B8}",
        nfkc: "\u{BB45}",
        nfkd: "\u{1106}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BB46}",
        nfc: "\u{BB46}",
        nfd: "\u{1106}\u{116E}\u{11B9}",
        nfkc: "\u{BB46}",
        nfkd: "\u{1106}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BB47}",
        nfc: "\u{BB47}",
        nfd: "\u{1106}\u{116E}\u{11BA}",
        nfkc: "\u{BB47}",
        nfkd: "\u{1106}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BB48}",
        nfc: "\u{BB48}",
        nfd: "\u{1106}\u{116E}\u{11BB}",
        nfkc: "\u{BB48}",
        nfkd: "\u{1106}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BB49}",
        nfc: "\u{BB49}",
        nfd: "\u{1106}\u{116E}\u{11BC}",
        nfkc: "\u{BB49}",
        nfkd: "\u{1106}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BB4A}",
        nfc: "\u{BB4A}",
        nfd: "\u{1106}\u{116E}\u{11BD}",
        nfkc: "\u{BB4A}",
        nfkd: "\u{1106}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BB4B}",
        nfc: "\u{BB4B}",
        nfd: "\u{1106}\u{116E}\u{11BE}",
        nfkc: "\u{BB4B}",
        nfkd: "\u{1106}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BB4C}",
        nfc: "\u{BB4C}",
        nfd: "\u{1106}\u{116E}\u{11BF}",
        nfkc: "\u{BB4C}",
        nfkd: "\u{1106}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BB4D}",
        nfc: "\u{BB4D}",
        nfd: "\u{1106}\u{116E}\u{11C0}",
        nfkc: "\u{BB4D}",
        nfkd: "\u{1106}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BB4E}",
        nfc: "\u{BB4E}",
        nfd: "\u{1106}\u{116E}\u{11C1}",
        nfkc: "\u{BB4E}",
        nfkd: "\u{1106}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BB4F}",
        nfc: "\u{BB4F}",
        nfd: "\u{1106}\u{116E}\u{11C2}",
        nfkc: "\u{BB4F}",
        nfkd: "\u{1106}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BB50}",
        nfc: "\u{BB50}",
        nfd: "\u{1106}\u{116F}",
        nfkc: "\u{BB50}",
        nfkd: "\u{1106}\u{116F}",
    },
    NormalizationTest {
        source: "\u{BB51}",
        nfc: "\u{BB51}",
        nfd: "\u{1106}\u{116F}\u{11A8}",
        nfkc: "\u{BB51}",
        nfkd: "\u{1106}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BB52}",
        nfc: "\u{BB52}",
        nfd: "\u{1106}\u{116F}\u{11A9}",
        nfkc: "\u{BB52}",
        nfkd: "\u{1106}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BB53}",
        nfc: "\u{BB53}",
        nfd: "\u{1106}\u{116F}\u{11AA}",
        nfkc: "\u{BB53}",
        nfkd: "\u{1106}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BB54}",
        nfc: "\u{BB54}",
        nfd: "\u{1106}\u{116F}\u{11AB}",
        nfkc: "\u{BB54}",
        nfkd: "\u{1106}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BB55}",
        nfc: "\u{BB55}",
        nfd: "\u{1106}\u{116F}\u{11AC}",
        nfkc: "\u{BB55}",
        nfkd: "\u{1106}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BB56}",
        nfc: "\u{BB56}",
        nfd: "\u{1106}\u{116F}\u{11AD}",
        nfkc: "\u{BB56}",
        nfkd: "\u{1106}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BB57}",
        nfc: "\u{BB57}",
        nfd: "\u{1106}\u{116F}\u{11AE}",
        nfkc: "\u{BB57}",
        nfkd: "\u{1106}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BB58}",
        nfc: "\u{BB58}",
        nfd: "\u{1106}\u{116F}\u{11AF}",
        nfkc: "\u{BB58}",
        nfkd: "\u{1106}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BB59}",
        nfc: "\u{BB59}",
        nfd: "\u{1106}\u{116F}\u{11B0}",
        nfkc: "\u{BB59}",
        nfkd: "\u{1106}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BB5A}",
        nfc: "\u{BB5A}",
        nfd: "\u{1106}\u{116F}\u{11B1}",
        nfkc: "\u{BB5A}",
        nfkd: "\u{1106}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BB5B}",
        nfc: "\u{BB5B}",
        nfd: "\u{1106}\u{116F}\u{11B2}",
        nfkc: "\u{BB5B}",
        nfkd: "\u{1106}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BB5C}",
        nfc: "\u{BB5C}",
        nfd: "\u{1106}\u{116F}\u{11B3}",
        nfkc: "\u{BB5C}",
        nfkd: "\u{1106}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BB5D}",
        nfc: "\u{BB5D}",
        nfd: "\u{1106}\u{116F}\u{11B4}",
        nfkc: "\u{BB5D}",
        nfkd: "\u{1106}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BB5E}",
        nfc: "\u{BB5E}",
        nfd: "\u{1106}\u{116F}\u{11B5}",
        nfkc: "\u{BB5E}",
        nfkd: "\u{1106}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BB5F}",
        nfc: "\u{BB5F}",
        nfd: "\u{1106}\u{116F}\u{11B6}",
        nfkc: "\u{BB5F}",
        nfkd: "\u{1106}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BB60}",
        nfc: "\u{BB60}",
        nfd: "\u{1106}\u{116F}\u{11B7}",
        nfkc: "\u{BB60}",
        nfkd: "\u{1106}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BB61}",
        nfc: "\u{BB61}",
        nfd: "\u{1106}\u{116F}\u{11B8}",
        nfkc: "\u{BB61}",
        nfkd: "\u{1106}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BB62}",
        nfc: "\u{BB62}",
        nfd: "\u{1106}\u{116F}\u{11B9}",
        nfkc: "\u{BB62}",
        nfkd: "\u{1106}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BB63}",
        nfc: "\u{BB63}",
        nfd: "\u{1106}\u{116F}\u{11BA}",
        nfkc: "\u{BB63}",
        nfkd: "\u{1106}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BB64}",
        nfc: "\u{BB64}",
        nfd: "\u{1106}\u{116F}\u{11BB}",
        nfkc: "\u{BB64}",
        nfkd: "\u{1106}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BB65}",
        nfc: "\u{BB65}",
        nfd: "\u{1106}\u{116F}\u{11BC}",
        nfkc: "\u{BB65}",
        nfkd: "\u{1106}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BB66}",
        nfc: "\u{BB66}",
        nfd: "\u{1106}\u{116F}\u{11BD}",
        nfkc: "\u{BB66}",
        nfkd: "\u{1106}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BB67}",
        nfc: "\u{BB67}",
        nfd: "\u{1106}\u{116F}\u{11BE}",
        nfkc: "\u{BB67}",
        nfkd: "\u{1106}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BB68}",
        nfc: "\u{BB68}",
        nfd: "\u{1106}\u{116F}\u{11BF}",
        nfkc: "\u{BB68}",
        nfkd: "\u{1106}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BB69}",
        nfc: "\u{BB69}",
        nfd: "\u{1106}\u{116F}\u{11C0}",
        nfkc: "\u{BB69}",
        nfkd: "\u{1106}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BB6A}",
        nfc: "\u{BB6A}",
        nfd: "\u{1106}\u{116F}\u{11C1}",
        nfkc: "\u{BB6A}",
        nfkd: "\u{1106}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BB6B}",
        nfc: "\u{BB6B}",
        nfd: "\u{1106}\u{116F}\u{11C2}",
        nfkc: "\u{BB6B}",
        nfkd: "\u{1106}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BB6C}",
        nfc: "\u{BB6C}",
        nfd: "\u{1106}\u{1170}",
        nfkc: "\u{BB6C}",
        nfkd: "\u{1106}\u{1170}",
    },
    NormalizationTest {
        source: "\u{BB6D}",
        nfc: "\u{BB6D}",
        nfd: "\u{1106}\u{1170}\u{11A8}",
        nfkc: "\u{BB6D}",
        nfkd: "\u{1106}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BB6E}",
        nfc: "\u{BB6E}",
        nfd: "\u{1106}\u{1170}\u{11A9}",
        nfkc: "\u{BB6E}",
        nfkd: "\u{1106}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BB6F}",
        nfc: "\u{BB6F}",
        nfd: "\u{1106}\u{1170}\u{11AA}",
        nfkc: "\u{BB6F}",
        nfkd: "\u{1106}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BB70}",
        nfc: "\u{BB70}",
        nfd: "\u{1106}\u{1170}\u{11AB}",
        nfkc: "\u{BB70}",
        nfkd: "\u{1106}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BB71}",
        nfc: "\u{BB71}",
        nfd: "\u{1106}\u{1170}\u{11AC}",
        nfkc: "\u{BB71}",
        nfkd: "\u{1106}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BB72}",
        nfc: "\u{BB72}",
        nfd: "\u{1106}\u{1170}\u{11AD}",
        nfkc: "\u{BB72}",
        nfkd: "\u{1106}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BB73}",
        nfc: "\u{BB73}",
        nfd: "\u{1106}\u{1170}\u{11AE}",
        nfkc: "\u{BB73}",
        nfkd: "\u{1106}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BB74}",
        nfc: "\u{BB74}",
        nfd: "\u{1106}\u{1170}\u{11AF}",
        nfkc: "\u{BB74}",
        nfkd: "\u{1106}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BB75}",
        nfc: "\u{BB75}",
        nfd: "\u{1106}\u{1170}\u{11B0}",
        nfkc: "\u{BB75}",
        nfkd: "\u{1106}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BB76}",
        nfc: "\u{BB76}",
        nfd: "\u{1106}\u{1170}\u{11B1}",
        nfkc: "\u{BB76}",
        nfkd: "\u{1106}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BB77}",
        nfc: "\u{BB77}",
        nfd: "\u{1106}\u{1170}\u{11B2}",
        nfkc: "\u{BB77}",
        nfkd: "\u{1106}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BB78}",
        nfc: "\u{BB78}",
        nfd: "\u{1106}\u{1170}\u{11B3}",
        nfkc: "\u{BB78}",
        nfkd: "\u{1106}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BB79}",
        nfc: "\u{BB79}",
        nfd: "\u{1106}\u{1170}\u{11B4}",
        nfkc: "\u{BB79}",
        nfkd: "\u{1106}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BB7A}",
        nfc: "\u{BB7A}",
        nfd: "\u{1106}\u{1170}\u{11B5}",
        nfkc: "\u{BB7A}",
        nfkd: "\u{1106}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BB7B}",
        nfc: "\u{BB7B}",
        nfd: "\u{1106}\u{1170}\u{11B6}",
        nfkc: "\u{BB7B}",
        nfkd: "\u{1106}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BB7C}",
        nfc: "\u{BB7C}",
        nfd: "\u{1106}\u{1170}\u{11B7}",
        nfkc: "\u{BB7C}",
        nfkd: "\u{1106}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BB7D}",
        nfc: "\u{BB7D}",
        nfd: "\u{1106}\u{1170}\u{11B8}",
        nfkc: "\u{BB7D}",
        nfkd: "\u{1106}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BB7E}",
        nfc: "\u{BB7E}",
        nfd: "\u{1106}\u{1170}\u{11B9}",
        nfkc: "\u{BB7E}",
        nfkd: "\u{1106}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BB7F}",
        nfc: "\u{BB7F}",
        nfd: "\u{1106}\u{1170}\u{11BA}",
        nfkc: "\u{BB7F}",
        nfkd: "\u{1106}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BB80}",
        nfc: "\u{BB80}",
        nfd: "\u{1106}\u{1170}\u{11BB}",
        nfkc: "\u{BB80}",
        nfkd: "\u{1106}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BB81}",
        nfc: "\u{BB81}",
        nfd: "\u{1106}\u{1170}\u{11BC}",
        nfkc: "\u{BB81}",
        nfkd: "\u{1106}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BB82}",
        nfc: "\u{BB82}",
        nfd: "\u{1106}\u{1170}\u{11BD}",
        nfkc: "\u{BB82}",
        nfkd: "\u{1106}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BB83}",
        nfc: "\u{BB83}",
        nfd: "\u{1106}\u{1170}\u{11BE}",
        nfkc: "\u{BB83}",
        nfkd: "\u{1106}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BB84}",
        nfc: "\u{BB84}",
        nfd: "\u{1106}\u{1170}\u{11BF}",
        nfkc: "\u{BB84}",
        nfkd: "\u{1106}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BB85}",
        nfc: "\u{BB85}",
        nfd: "\u{1106}\u{1170}\u{11C0}",
        nfkc: "\u{BB85}",
        nfkd: "\u{1106}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BB86}",
        nfc: "\u{BB86}",
        nfd: "\u{1106}\u{1170}\u{11C1}",
        nfkc: "\u{BB86}",
        nfkd: "\u{1106}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BB87}",
        nfc: "\u{BB87}",
        nfd: "\u{1106}\u{1170}\u{11C2}",
        nfkc: "\u{BB87}",
        nfkd: "\u{1106}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BB88}",
        nfc: "\u{BB88}",
        nfd: "\u{1106}\u{1171}",
        nfkc: "\u{BB88}",
        nfkd: "\u{1106}\u{1171}",
    },
    NormalizationTest {
        source: "\u{BB89}",
        nfc: "\u{BB89}",
        nfd: "\u{1106}\u{1171}\u{11A8}",
        nfkc: "\u{BB89}",
        nfkd: "\u{1106}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BB8A}",
        nfc: "\u{BB8A}",
        nfd: "\u{1106}\u{1171}\u{11A9}",
        nfkc: "\u{BB8A}",
        nfkd: "\u{1106}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BB8B}",
        nfc: "\u{BB8B}",
        nfd: "\u{1106}\u{1171}\u{11AA}",
        nfkc: "\u{BB8B}",
        nfkd: "\u{1106}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BB8C}",
        nfc: "\u{BB8C}",
        nfd: "\u{1106}\u{1171}\u{11AB}",
        nfkc: "\u{BB8C}",
        nfkd: "\u{1106}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BB8D}",
        nfc: "\u{BB8D}",
        nfd: "\u{1106}\u{1171}\u{11AC}",
        nfkc: "\u{BB8D}",
        nfkd: "\u{1106}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BB8E}",
        nfc: "\u{BB8E}",
        nfd: "\u{1106}\u{1171}\u{11AD}",
        nfkc: "\u{BB8E}",
        nfkd: "\u{1106}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BB8F}",
        nfc: "\u{BB8F}",
        nfd: "\u{1106}\u{1171}\u{11AE}",
        nfkc: "\u{BB8F}",
        nfkd: "\u{1106}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BB90}",
        nfc: "\u{BB90}",
        nfd: "\u{1106}\u{1171}\u{11AF}",
        nfkc: "\u{BB90}",
        nfkd: "\u{1106}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BB91}",
        nfc: "\u{BB91}",
        nfd: "\u{1106}\u{1171}\u{11B0}",
        nfkc: "\u{BB91}",
        nfkd: "\u{1106}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BB92}",
        nfc: "\u{BB92}",
        nfd: "\u{1106}\u{1171}\u{11B1}",
        nfkc: "\u{BB92}",
        nfkd: "\u{1106}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BB93}",
        nfc: "\u{BB93}",
        nfd: "\u{1106}\u{1171}\u{11B2}",
        nfkc: "\u{BB93}",
        nfkd: "\u{1106}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BB94}",
        nfc: "\u{BB94}",
        nfd: "\u{1106}\u{1171}\u{11B3}",
        nfkc: "\u{BB94}",
        nfkd: "\u{1106}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BB95}",
        nfc: "\u{BB95}",
        nfd: "\u{1106}\u{1171}\u{11B4}",
        nfkc: "\u{BB95}",
        nfkd: "\u{1106}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BB96}",
        nfc: "\u{BB96}",
        nfd: "\u{1106}\u{1171}\u{11B5}",
        nfkc: "\u{BB96}",
        nfkd: "\u{1106}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BB97}",
        nfc: "\u{BB97}",
        nfd: "\u{1106}\u{1171}\u{11B6}",
        nfkc: "\u{BB97}",
        nfkd: "\u{1106}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BB98}",
        nfc: "\u{BB98}",
        nfd: "\u{1106}\u{1171}\u{11B7}",
        nfkc: "\u{BB98}",
        nfkd: "\u{1106}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BB99}",
        nfc: "\u{BB99}",
        nfd: "\u{1106}\u{1171}\u{11B8}",
        nfkc: "\u{BB99}",
        nfkd: "\u{1106}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BB9A}",
        nfc: "\u{BB9A}",
        nfd: "\u{1106}\u{1171}\u{11B9}",
        nfkc: "\u{BB9A}",
        nfkd: "\u{1106}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BB9B}",
        nfc: "\u{BB9B}",
        nfd: "\u{1106}\u{1171}\u{11BA}",
        nfkc: "\u{BB9B}",
        nfkd: "\u{1106}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BB9C}",
        nfc: "\u{BB9C}",
        nfd: "\u{1106}\u{1171}\u{11BB}",
        nfkc: "\u{BB9C}",
        nfkd: "\u{1106}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BB9D}",
        nfc: "\u{BB9D}",
        nfd: "\u{1106}\u{1171}\u{11BC}",
        nfkc: "\u{BB9D}",
        nfkd: "\u{1106}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BB9E}",
        nfc: "\u{BB9E}",
        nfd: "\u{1106}\u{1171}\u{11BD}",
        nfkc: "\u{BB9E}",
        nfkd: "\u{1106}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BB9F}",
        nfc: "\u{BB9F}",
        nfd: "\u{1106}\u{1171}\u{11BE}",
        nfkc: "\u{BB9F}",
        nfkd: "\u{1106}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BBA0}",
        nfc: "\u{BBA0}",
        nfd: "\u{1106}\u{1171}\u{11BF}",
        nfkc: "\u{BBA0}",
        nfkd: "\u{1106}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BBA1}",
        nfc: "\u{BBA1}",
        nfd: "\u{1106}\u{1171}\u{11C0}",
        nfkc: "\u{BBA1}",
        nfkd: "\u{1106}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BBA2}",
        nfc: "\u{BBA2}",
        nfd: "\u{1106}\u{1171}\u{11C1}",
        nfkc: "\u{BBA2}",
        nfkd: "\u{1106}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BBA3}",
        nfc: "\u{BBA3}",
        nfd: "\u{1106}\u{1171}\u{11C2}",
        nfkc: "\u{BBA3}",
        nfkd: "\u{1106}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BBA4}",
        nfc: "\u{BBA4}",
        nfd: "\u{1106}\u{1172}",
        nfkc: "\u{BBA4}",
        nfkd: "\u{1106}\u{1172}",
    },
    NormalizationTest {
        source: "\u{BBA5}",
        nfc: "\u{BBA5}",
        nfd: "\u{1106}\u{1172}\u{11A8}",
        nfkc: "\u{BBA5}",
        nfkd: "\u{1106}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BBA6}",
        nfc: "\u{BBA6}",
        nfd: "\u{1106}\u{1172}\u{11A9}",
        nfkc: "\u{BBA6}",
        nfkd: "\u{1106}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BBA7}",
        nfc: "\u{BBA7}",
        nfd: "\u{1106}\u{1172}\u{11AA}",
        nfkc: "\u{BBA7}",
        nfkd: "\u{1106}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BBA8}",
        nfc: "\u{BBA8}",
        nfd: "\u{1106}\u{1172}\u{11AB}",
        nfkc: "\u{BBA8}",
        nfkd: "\u{1106}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BBA9}",
        nfc: "\u{BBA9}",
        nfd: "\u{1106}\u{1172}\u{11AC}",
        nfkc: "\u{BBA9}",
        nfkd: "\u{1106}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BBAA}",
        nfc: "\u{BBAA}",
        nfd: "\u{1106}\u{1172}\u{11AD}",
        nfkc: "\u{BBAA}",
        nfkd: "\u{1106}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BBAB}",
        nfc: "\u{BBAB}",
        nfd: "\u{1106}\u{1172}\u{11AE}",
        nfkc: "\u{BBAB}",
        nfkd: "\u{1106}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BBAC}",
        nfc: "\u{BBAC}",
        nfd: "\u{1106}\u{1172}\u{11AF}",
        nfkc: "\u{BBAC}",
        nfkd: "\u{1106}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BBAD}",
        nfc: "\u{BBAD}",
        nfd: "\u{1106}\u{1172}\u{11B0}",
        nfkc: "\u{BBAD}",
        nfkd: "\u{1106}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BBAE}",
        nfc: "\u{BBAE}",
        nfd: "\u{1106}\u{1172}\u{11B1}",
        nfkc: "\u{BBAE}",
        nfkd: "\u{1106}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BBAF}",
        nfc: "\u{BBAF}",
        nfd: "\u{1106}\u{1172}\u{11B2}",
        nfkc: "\u{BBAF}",
        nfkd: "\u{1106}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BBB0}",
        nfc: "\u{BBB0}",
        nfd: "\u{1106}\u{1172}\u{11B3}",
        nfkc: "\u{BBB0}",
        nfkd: "\u{1106}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BBB1}",
        nfc: "\u{BBB1}",
        nfd: "\u{1106}\u{1172}\u{11B4}",
        nfkc: "\u{BBB1}",
        nfkd: "\u{1106}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BBB2}",
        nfc: "\u{BBB2}",
        nfd: "\u{1106}\u{1172}\u{11B5}",
        nfkc: "\u{BBB2}",
        nfkd: "\u{1106}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BBB3}",
        nfc: "\u{BBB3}",
        nfd: "\u{1106}\u{1172}\u{11B6}",
        nfkc: "\u{BBB3}",
        nfkd: "\u{1106}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BBB4}",
        nfc: "\u{BBB4}",
        nfd: "\u{1106}\u{1172}\u{11B7}",
        nfkc: "\u{BBB4}",
        nfkd: "\u{1106}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BBB5}",
        nfc: "\u{BBB5}",
        nfd: "\u{1106}\u{1172}\u{11B8}",
        nfkc: "\u{BBB5}",
        nfkd: "\u{1106}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BBB6}",
        nfc: "\u{BBB6}",
        nfd: "\u{1106}\u{1172}\u{11B9}",
        nfkc: "\u{BBB6}",
        nfkd: "\u{1106}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BBB7}",
        nfc: "\u{BBB7}",
        nfd: "\u{1106}\u{1172}\u{11BA}",
        nfkc: "\u{BBB7}",
        nfkd: "\u{1106}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BBB8}",
        nfc: "\u{BBB8}",
        nfd: "\u{1106}\u{1172}\u{11BB}",
        nfkc: "\u{BBB8}",
        nfkd: "\u{1106}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BBB9}",
        nfc: "\u{BBB9}",
        nfd: "\u{1106}\u{1172}\u{11BC}",
        nfkc: "\u{BBB9}",
        nfkd: "\u{1106}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BBBA}",
        nfc: "\u{BBBA}",
        nfd: "\u{1106}\u{1172}\u{11BD}",
        nfkc: "\u{BBBA}",
        nfkd: "\u{1106}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BBBB}",
        nfc: "\u{BBBB}",
        nfd: "\u{1106}\u{1172}\u{11BE}",
        nfkc: "\u{BBBB}",
        nfkd: "\u{1106}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BBBC}",
        nfc: "\u{BBBC}",
        nfd: "\u{1106}\u{1172}\u{11BF}",
        nfkc: "\u{BBBC}",
        nfkd: "\u{1106}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BBBD}",
        nfc: "\u{BBBD}",
        nfd: "\u{1106}\u{1172}\u{11C0}",
        nfkc: "\u{BBBD}",
        nfkd: "\u{1106}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BBBE}",
        nfc: "\u{BBBE}",
        nfd: "\u{1106}\u{1172}\u{11C1}",
        nfkc: "\u{BBBE}",
        nfkd: "\u{1106}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BBBF}",
        nfc: "\u{BBBF}",
        nfd: "\u{1106}\u{1172}\u{11C2}",
        nfkc: "\u{BBBF}",
        nfkd: "\u{1106}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BBC0}",
        nfc: "\u{BBC0}",
        nfd: "\u{1106}\u{1173}",
        nfkc: "\u{BBC0}",
        nfkd: "\u{1106}\u{1173}",
    },
    NormalizationTest {
        source: "\u{BBC1}",
        nfc: "\u{BBC1}",
        nfd: "\u{1106}\u{1173}\u{11A8}",
        nfkc: "\u{BBC1}",
        nfkd: "\u{1106}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BBC2}",
        nfc: "\u{BBC2}",
        nfd: "\u{1106}\u{1173}\u{11A9}",
        nfkc: "\u{BBC2}",
        nfkd: "\u{1106}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BBC3}",
        nfc: "\u{BBC3}",
        nfd: "\u{1106}\u{1173}\u{11AA}",
        nfkc: "\u{BBC3}",
        nfkd: "\u{1106}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BBC4}",
        nfc: "\u{BBC4}",
        nfd: "\u{1106}\u{1173}\u{11AB}",
        nfkc: "\u{BBC4}",
        nfkd: "\u{1106}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BBC5}",
        nfc: "\u{BBC5}",
        nfd: "\u{1106}\u{1173}\u{11AC}",
        nfkc: "\u{BBC5}",
        nfkd: "\u{1106}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BBC6}",
        nfc: "\u{BBC6}",
        nfd: "\u{1106}\u{1173}\u{11AD}",
        nfkc: "\u{BBC6}",
        nfkd: "\u{1106}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BBC7}",
        nfc: "\u{BBC7}",
        nfd: "\u{1106}\u{1173}\u{11AE}",
        nfkc: "\u{BBC7}",
        nfkd: "\u{1106}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BBC8}",
        nfc: "\u{BBC8}",
        nfd: "\u{1106}\u{1173}\u{11AF}",
        nfkc: "\u{BBC8}",
        nfkd: "\u{1106}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BBC9}",
        nfc: "\u{BBC9}",
        nfd: "\u{1106}\u{1173}\u{11B0}",
        nfkc: "\u{BBC9}",
        nfkd: "\u{1106}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BBCA}",
        nfc: "\u{BBCA}",
        nfd: "\u{1106}\u{1173}\u{11B1}",
        nfkc: "\u{BBCA}",
        nfkd: "\u{1106}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BBCB}",
        nfc: "\u{BBCB}",
        nfd: "\u{1106}\u{1173}\u{11B2}",
        nfkc: "\u{BBCB}",
        nfkd: "\u{1106}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BBCC}",
        nfc: "\u{BBCC}",
        nfd: "\u{1106}\u{1173}\u{11B3}",
        nfkc: "\u{BBCC}",
        nfkd: "\u{1106}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BBCD}",
        nfc: "\u{BBCD}",
        nfd: "\u{1106}\u{1173}\u{11B4}",
        nfkc: "\u{BBCD}",
        nfkd: "\u{1106}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BBCE}",
        nfc: "\u{BBCE}",
        nfd: "\u{1106}\u{1173}\u{11B5}",
        nfkc: "\u{BBCE}",
        nfkd: "\u{1106}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BBCF}",
        nfc: "\u{BBCF}",
        nfd: "\u{1106}\u{1173}\u{11B6}",
        nfkc: "\u{BBCF}",
        nfkd: "\u{1106}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BBD0}",
        nfc: "\u{BBD0}",
        nfd: "\u{1106}\u{1173}\u{11B7}",
        nfkc: "\u{BBD0}",
        nfkd: "\u{1106}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BBD1}",
        nfc: "\u{BBD1}",
        nfd: "\u{1106}\u{1173}\u{11B8}",
        nfkc: "\u{BBD1}",
        nfkd: "\u{1106}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BBD2}",
        nfc: "\u{BBD2}",
        nfd: "\u{1106}\u{1173}\u{11B9}",
        nfkc: "\u{BBD2}",
        nfkd: "\u{1106}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BBD3}",
        nfc: "\u{BBD3}",
        nfd: "\u{1106}\u{1173}\u{11BA}",
        nfkc: "\u{BBD3}",
        nfkd: "\u{1106}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BBD4}",
        nfc: "\u{BBD4}",
        nfd: "\u{1106}\u{1173}\u{11BB}",
        nfkc: "\u{BBD4}",
        nfkd: "\u{1106}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BBD5}",
        nfc: "\u{BBD5}",
        nfd: "\u{1106}\u{1173}\u{11BC}",
        nfkc: "\u{BBD5}",
        nfkd: "\u{1106}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BBD6}",
        nfc: "\u{BBD6}",
        nfd: "\u{1106}\u{1173}\u{11BD}",
        nfkc: "\u{BBD6}",
        nfkd: "\u{1106}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BBD7}",
        nfc: "\u{BBD7}",
        nfd: "\u{1106}\u{1173}\u{11BE}",
        nfkc: "\u{BBD7}",
        nfkd: "\u{1106}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BBD8}",
        nfc: "\u{BBD8}",
        nfd: "\u{1106}\u{1173}\u{11BF}",
        nfkc: "\u{BBD8}",
        nfkd: "\u{1106}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BBD9}",
        nfc: "\u{BBD9}",
        nfd: "\u{1106}\u{1173}\u{11C0}",
        nfkc: "\u{BBD9}",
        nfkd: "\u{1106}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BBDA}",
        nfc: "\u{BBDA}",
        nfd: "\u{1106}\u{1173}\u{11C1}",
        nfkc: "\u{BBDA}",
        nfkd: "\u{1106}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BBDB}",
        nfc: "\u{BBDB}",
        nfd: "\u{1106}\u{1173}\u{11C2}",
        nfkc: "\u{BBDB}",
        nfkd: "\u{1106}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BBDC}",
        nfc: "\u{BBDC}",
        nfd: "\u{1106}\u{1174}",
        nfkc: "\u{BBDC}",
        nfkd: "\u{1106}\u{1174}",
    },
    NormalizationTest {
        source: "\u{BBDD}",
        nfc: "\u{BBDD}",
        nfd: "\u{1106}\u{1174}\u{11A8}",
        nfkc: "\u{BBDD}",
        nfkd: "\u{1106}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BBDE}",
        nfc: "\u{BBDE}",
        nfd: "\u{1106}\u{1174}\u{11A9}",
        nfkc: "\u{BBDE}",
        nfkd: "\u{1106}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BBDF}",
        nfc: "\u{BBDF}",
        nfd: "\u{1106}\u{1174}\u{11AA}",
        nfkc: "\u{BBDF}",
        nfkd: "\u{1106}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BBE0}",
        nfc: "\u{BBE0}",
        nfd: "\u{1106}\u{1174}\u{11AB}",
        nfkc: "\u{BBE0}",
        nfkd: "\u{1106}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BBE1}",
        nfc: "\u{BBE1}",
        nfd: "\u{1106}\u{1174}\u{11AC}",
        nfkc: "\u{BBE1}",
        nfkd: "\u{1106}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BBE2}",
        nfc: "\u{BBE2}",
        nfd: "\u{1106}\u{1174}\u{11AD}",
        nfkc: "\u{BBE2}",
        nfkd: "\u{1106}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BBE3}",
        nfc: "\u{BBE3}",
        nfd: "\u{1106}\u{1174}\u{11AE}",
        nfkc: "\u{BBE3}",
        nfkd: "\u{1106}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BBE4}",
        nfc: "\u{BBE4}",
        nfd: "\u{1106}\u{1174}\u{11AF}",
        nfkc: "\u{BBE4}",
        nfkd: "\u{1106}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BBE5}",
        nfc: "\u{BBE5}",
        nfd: "\u{1106}\u{1174}\u{11B0}",
        nfkc: "\u{BBE5}",
        nfkd: "\u{1106}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BBE6}",
        nfc: "\u{BBE6}",
        nfd: "\u{1106}\u{1174}\u{11B1}",
        nfkc: "\u{BBE6}",
        nfkd: "\u{1106}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BBE7}",
        nfc: "\u{BBE7}",
        nfd: "\u{1106}\u{1174}\u{11B2}",
        nfkc: "\u{BBE7}",
        nfkd: "\u{1106}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BBE8}",
        nfc: "\u{BBE8}",
        nfd: "\u{1106}\u{1174}\u{11B3}",
        nfkc: "\u{BBE8}",
        nfkd: "\u{1106}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BBE9}",
        nfc: "\u{BBE9}",
        nfd: "\u{1106}\u{1174}\u{11B4}",
        nfkc: "\u{BBE9}",
        nfkd: "\u{1106}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BBEA}",
        nfc: "\u{BBEA}",
        nfd: "\u{1106}\u{1174}\u{11B5}",
        nfkc: "\u{BBEA}",
        nfkd: "\u{1106}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BBEB}",
        nfc: "\u{BBEB}",
        nfd: "\u{1106}\u{1174}\u{11B6}",
        nfkc: "\u{BBEB}",
        nfkd: "\u{1106}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BBEC}",
        nfc: "\u{BBEC}",
        nfd: "\u{1106}\u{1174}\u{11B7}",
        nfkc: "\u{BBEC}",
        nfkd: "\u{1106}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BBED}",
        nfc: "\u{BBED}",
        nfd: "\u{1106}\u{1174}\u{11B8}",
        nfkc: "\u{BBED}",
        nfkd: "\u{1106}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BBEE}",
        nfc: "\u{BBEE}",
        nfd: "\u{1106}\u{1174}\u{11B9}",
        nfkc: "\u{BBEE}",
        nfkd: "\u{1106}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BBEF}",
        nfc: "\u{BBEF}",
        nfd: "\u{1106}\u{1174}\u{11BA}",
        nfkc: "\u{BBEF}",
        nfkd: "\u{1106}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BBF0}",
        nfc: "\u{BBF0}",
        nfd: "\u{1106}\u{1174}\u{11BB}",
        nfkc: "\u{BBF0}",
        nfkd: "\u{1106}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BBF1}",
        nfc: "\u{BBF1}",
        nfd: "\u{1106}\u{1174}\u{11BC}",
        nfkc: "\u{BBF1}",
        nfkd: "\u{1106}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BBF2}",
        nfc: "\u{BBF2}",
        nfd: "\u{1106}\u{1174}\u{11BD}",
        nfkc: "\u{BBF2}",
        nfkd: "\u{1106}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BBF3}",
        nfc: "\u{BBF3}",
        nfd: "\u{1106}\u{1174}\u{11BE}",
        nfkc: "\u{BBF3}",
        nfkd: "\u{1106}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BBF4}",
        nfc: "\u{BBF4}",
        nfd: "\u{1106}\u{1174}\u{11BF}",
        nfkc: "\u{BBF4}",
        nfkd: "\u{1106}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BBF5}",
        nfc: "\u{BBF5}",
        nfd: "\u{1106}\u{1174}\u{11C0}",
        nfkc: "\u{BBF5}",
        nfkd: "\u{1106}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BBF6}",
        nfc: "\u{BBF6}",
        nfd: "\u{1106}\u{1174}\u{11C1}",
        nfkc: "\u{BBF6}",
        nfkd: "\u{1106}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BBF7}",
        nfc: "\u{BBF7}",
        nfd: "\u{1106}\u{1174}\u{11C2}",
        nfkc: "\u{BBF7}",
        nfkd: "\u{1106}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BBF8}",
        nfc: "\u{BBF8}",
        nfd: "\u{1106}\u{1175}",
        nfkc: "\u{BBF8}",
        nfkd: "\u{1106}\u{1175}",
    },
    NormalizationTest {
        source: "\u{BBF9}",
        nfc: "\u{BBF9}",
        nfd: "\u{1106}\u{1175}\u{11A8}",
        nfkc: "\u{BBF9}",
        nfkd: "\u{1106}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BBFA}",
        nfc: "\u{BBFA}",
        nfd: "\u{1106}\u{1175}\u{11A9}",
        nfkc: "\u{BBFA}",
        nfkd: "\u{1106}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BBFB}",
        nfc: "\u{BBFB}",
        nfd: "\u{1106}\u{1175}\u{11AA}",
        nfkc: "\u{BBFB}",
        nfkd: "\u{1106}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BBFC}",
        nfc: "\u{BBFC}",
        nfd: "\u{1106}\u{1175}\u{11AB}",
        nfkc: "\u{BBFC}",
        nfkd: "\u{1106}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BBFD}",
        nfc: "\u{BBFD}",
        nfd: "\u{1106}\u{1175}\u{11AC}",
        nfkc: "\u{BBFD}",
        nfkd: "\u{1106}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BBFE}",
        nfc: "\u{BBFE}",
        nfd: "\u{1106}\u{1175}\u{11AD}",
        nfkc: "\u{BBFE}",
        nfkd: "\u{1106}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BBFF}",
        nfc: "\u{BBFF}",
        nfd: "\u{1106}\u{1175}\u{11AE}",
        nfkc: "\u{BBFF}",
        nfkd: "\u{1106}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BC00}",
        nfc: "\u{BC00}",
        nfd: "\u{1106}\u{1175}\u{11AF}",
        nfkc: "\u{BC00}",
        nfkd: "\u{1106}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BC01}",
        nfc: "\u{BC01}",
        nfd: "\u{1106}\u{1175}\u{11B0}",
        nfkc: "\u{BC01}",
        nfkd: "\u{1106}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BC02}",
        nfc: "\u{BC02}",
        nfd: "\u{1106}\u{1175}\u{11B1}",
        nfkc: "\u{BC02}",
        nfkd: "\u{1106}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BC03}",
        nfc: "\u{BC03}",
        nfd: "\u{1106}\u{1175}\u{11B2}",
        nfkc: "\u{BC03}",
        nfkd: "\u{1106}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BC04}",
        nfc: "\u{BC04}",
        nfd: "\u{1106}\u{1175}\u{11B3}",
        nfkc: "\u{BC04}",
        nfkd: "\u{1106}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BC05}",
        nfc: "\u{BC05}",
        nfd: "\u{1106}\u{1175}\u{11B4}",
        nfkc: "\u{BC05}",
        nfkd: "\u{1106}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BC06}",
        nfc: "\u{BC06}",
        nfd: "\u{1106}\u{1175}\u{11B5}",
        nfkc: "\u{BC06}",
        nfkd: "\u{1106}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BC07}",
        nfc: "\u{BC07}",
        nfd: "\u{1106}\u{1175}\u{11B6}",
        nfkc: "\u{BC07}",
        nfkd: "\u{1106}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BC08}",
        nfc: "\u{BC08}",
        nfd: "\u{1106}\u{1175}\u{11B7}",
        nfkc: "\u{BC08}",
        nfkd: "\u{1106}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BC09}",
        nfc: "\u{BC09}",
        nfd: "\u{1106}\u{1175}\u{11B8}",
        nfkc: "\u{BC09}",
        nfkd: "\u{1106}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BC0A}",
        nfc: "\u{BC0A}",
        nfd: "\u{1106}\u{1175}\u{11B9}",
        nfkc: "\u{BC0A}",
        nfkd: "\u{1106}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BC0B}",
        nfc: "\u{BC0B}",
        nfd: "\u{1106}\u{1175}\u{11BA}",
        nfkc: "\u{BC0B}",
        nfkd: "\u{1106}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BC0C}",
        nfc: "\u{BC0C}",
        nfd: "\u{1106}\u{1175}\u{11BB}",
        nfkc: "\u{BC0C}",
        nfkd: "\u{1106}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BC0D}",
        nfc: "\u{BC0D}",
        nfd: "\u{1106}\u{1175}\u{11BC}",
        nfkc: "\u{BC0D}",
        nfkd: "\u{1106}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BC0E}",
        nfc: "\u{BC0E}",
        nfd: "\u{1106}\u{1175}\u{11BD}",
        nfkc: "\u{BC0E}",
        nfkd: "\u{1106}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BC0F}",
        nfc: "\u{BC0F}",
        nfd: "\u{1106}\u{1175}\u{11BE}",
        nfkc: "\u{BC0F}",
        nfkd: "\u{1106}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BC10}",
        nfc: "\u{BC10}",
        nfd: "\u{1106}\u{1175}\u{11BF}",
        nfkc: "\u{BC10}",
        nfkd: "\u{1106}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BC11}",
        nfc: "\u{BC11}",
        nfd: "\u{1106}\u{1175}\u{11C0}",
        nfkc: "\u{BC11}",
        nfkd: "\u{1106}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BC12}",
        nfc: "\u{BC12}",
        nfd: "\u{1106}\u{1175}\u{11C1}",
        nfkc: "\u{BC12}",
        nfkd: "\u{1106}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BC13}",
        nfc: "\u{BC13}",
        nfd: "\u{1106}\u{1175}\u{11C2}",
        nfkc: "\u{BC13}",
        nfkd: "\u{1106}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BC14}",
        nfc: "\u{BC14}",
        nfd: "\u{1107}\u{1161}",
        nfkc: "\u{BC14}",
        nfkd: "\u{1107}\u{1161}",
    },
    NormalizationTest {
        source: "\u{BC15}",
        nfc: "\u{BC15}",
        nfd: "\u{1107}\u{1161}\u{11A8}",
        nfkc: "\u{BC15}",
        nfkd: "\u{1107}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BC16}",
        nfc: "\u{BC16}",
        nfd: "\u{1107}\u{1161}\u{11A9}",
        nfkc: "\u{BC16}",
        nfkd: "\u{1107}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BC17}",
        nfc: "\u{BC17}",
        nfd: "\u{1107}\u{1161}\u{11AA}",
        nfkc: "\u{BC17}",
        nfkd: "\u{1107}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BC18}",
        nfc: "\u{BC18}",
        nfd: "\u{1107}\u{1161}\u{11AB}",
        nfkc: "\u{BC18}",
        nfkd: "\u{1107}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BC19}",
        nfc: "\u{BC19}",
        nfd: "\u{1107}\u{1161}\u{11AC}",
        nfkc: "\u{BC19}",
        nfkd: "\u{1107}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BC1A}",
        nfc: "\u{BC1A}",
        nfd: "\u{1107}\u{1161}\u{11AD}",
        nfkc: "\u{BC1A}",
        nfkd: "\u{1107}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BC1B}",
        nfc: "\u{BC1B}",
        nfd: "\u{1107}\u{1161}\u{11AE}",
        nfkc: "\u{BC1B}",
        nfkd: "\u{1107}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BC1C}",
        nfc: "\u{BC1C}",
        nfd: "\u{1107}\u{1161}\u{11AF}",
        nfkc: "\u{BC1C}",
        nfkd: "\u{1107}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BC1D}",
        nfc: "\u{BC1D}",
        nfd: "\u{1107}\u{1161}\u{11B0}",
        nfkc: "\u{BC1D}",
        nfkd: "\u{1107}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BC1E}",
        nfc: "\u{BC1E}",
        nfd: "\u{1107}\u{1161}\u{11B1}",
        nfkc: "\u{BC1E}",
        nfkd: "\u{1107}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BC1F}",
        nfc: "\u{BC1F}",
        nfd: "\u{1107}\u{1161}\u{11B2}",
        nfkc: "\u{BC1F}",
        nfkd: "\u{1107}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BC20}",
        nfc: "\u{BC20}",
        nfd: "\u{1107}\u{1161}\u{11B3}",
        nfkc: "\u{BC20}",
        nfkd: "\u{1107}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BC21}",
        nfc: "\u{BC21}",
        nfd: "\u{1107}\u{1161}\u{11B4}",
        nfkc: "\u{BC21}",
        nfkd: "\u{1107}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BC22}",
        nfc: "\u{BC22}",
        nfd: "\u{1107}\u{1161}\u{11B5}",
        nfkc: "\u{BC22}",
        nfkd: "\u{1107}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BC23}",
        nfc: "\u{BC23}",
        nfd: "\u{1107}\u{1161}\u{11B6}",
        nfkc: "\u{BC23}",
        nfkd: "\u{1107}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BC24}",
        nfc: "\u{BC24}",
        nfd: "\u{1107}\u{1161}\u{11B7}",
        nfkc: "\u{BC24}",
        nfkd: "\u{1107}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BC25}",
        nfc: "\u{BC25}",
        nfd: "\u{1107}\u{1161}\u{11B8}",
        nfkc: "\u{BC25}",
        nfkd: "\u{1107}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BC26}",
        nfc: "\u{BC26}",
        nfd: "\u{1107}\u{1161}\u{11B9}",
        nfkc: "\u{BC26}",
        nfkd: "\u{1107}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BC27}",
        nfc: "\u{BC27}",
        nfd: "\u{1107}\u{1161}\u{11BA}",
        nfkc: "\u{BC27}",
        nfkd: "\u{1107}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BC28}",
        nfc: "\u{BC28}",
        nfd: "\u{1107}\u{1161}\u{11BB}",
        nfkc: "\u{BC28}",
        nfkd: "\u{1107}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BC29}",
        nfc: "\u{BC29}",
        nfd: "\u{1107}\u{1161}\u{11BC}",
        nfkc: "\u{BC29}",
        nfkd: "\u{1107}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BC2A}",
        nfc: "\u{BC2A}",
        nfd: "\u{1107}\u{1161}\u{11BD}",
        nfkc: "\u{BC2A}",
        nfkd: "\u{1107}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BC2B}",
        nfc: "\u{BC2B}",
        nfd: "\u{1107}\u{1161}\u{11BE}",
        nfkc: "\u{BC2B}",
        nfkd: "\u{1107}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BC2C}",
        nfc: "\u{BC2C}",
        nfd: "\u{1107}\u{1161}\u{11BF}",
        nfkc: "\u{BC2C}",
        nfkd: "\u{1107}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BC2D}",
        nfc: "\u{BC2D}",
        nfd: "\u{1107}\u{1161}\u{11C0}",
        nfkc: "\u{BC2D}",
        nfkd: "\u{1107}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BC2E}",
        nfc: "\u{BC2E}",
        nfd: "\u{1107}\u{1161}\u{11C1}",
        nfkc: "\u{BC2E}",
        nfkd: "\u{1107}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BC2F}",
        nfc: "\u{BC2F}",
        nfd: "\u{1107}\u{1161}\u{11C2}",
        nfkc: "\u{BC2F}",
        nfkd: "\u{1107}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BC30}",
        nfc: "\u{BC30}",
        nfd: "\u{1107}\u{1162}",
        nfkc: "\u{BC30}",
        nfkd: "\u{1107}\u{1162}",
    },
    NormalizationTest {
        source: "\u{BC31}",
        nfc: "\u{BC31}",
        nfd: "\u{1107}\u{1162}\u{11A8}",
        nfkc: "\u{BC31}",
        nfkd: "\u{1107}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BC32}",
        nfc: "\u{BC32}",
        nfd: "\u{1107}\u{1162}\u{11A9}",
        nfkc: "\u{BC32}",
        nfkd: "\u{1107}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BC33}",
        nfc: "\u{BC33}",
        nfd: "\u{1107}\u{1162}\u{11AA}",
        nfkc: "\u{BC33}",
        nfkd: "\u{1107}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BC34}",
        nfc: "\u{BC34}",
        nfd: "\u{1107}\u{1162}\u{11AB}",
        nfkc: "\u{BC34}",
        nfkd: "\u{1107}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BC35}",
        nfc: "\u{BC35}",
        nfd: "\u{1107}\u{1162}\u{11AC}",
        nfkc: "\u{BC35}",
        nfkd: "\u{1107}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BC36}",
        nfc: "\u{BC36}",
        nfd: "\u{1107}\u{1162}\u{11AD}",
        nfkc: "\u{BC36}",
        nfkd: "\u{1107}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BC37}",
        nfc: "\u{BC37}",
        nfd: "\u{1107}\u{1162}\u{11AE}",
        nfkc: "\u{BC37}",
        nfkd: "\u{1107}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BC38}",
        nfc: "\u{BC38}",
        nfd: "\u{1107}\u{1162}\u{11AF}",
        nfkc: "\u{BC38}",
        nfkd: "\u{1107}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BC39}",
        nfc: "\u{BC39}",
        nfd: "\u{1107}\u{1162}\u{11B0}",
        nfkc: "\u{BC39}",
        nfkd: "\u{1107}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BC3A}",
        nfc: "\u{BC3A}",
        nfd: "\u{1107}\u{1162}\u{11B1}",
        nfkc: "\u{BC3A}",
        nfkd: "\u{1107}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BC3B}",
        nfc: "\u{BC3B}",
        nfd: "\u{1107}\u{1162}\u{11B2}",
        nfkc: "\u{BC3B}",
        nfkd: "\u{1107}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BC3C}",
        nfc: "\u{BC3C}",
        nfd: "\u{1107}\u{1162}\u{11B3}",
        nfkc: "\u{BC3C}",
        nfkd: "\u{1107}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BC3D}",
        nfc: "\u{BC3D}",
        nfd: "\u{1107}\u{1162}\u{11B4}",
        nfkc: "\u{BC3D}",
        nfkd: "\u{1107}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BC3E}",
        nfc: "\u{BC3E}",
        nfd: "\u{1107}\u{1162}\u{11B5}",
        nfkc: "\u{BC3E}",
        nfkd: "\u{1107}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BC3F}",
        nfc: "\u{BC3F}",
        nfd: "\u{1107}\u{1162}\u{11B6}",
        nfkc: "\u{BC3F}",
        nfkd: "\u{1107}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BC40}",
        nfc: "\u{BC40}",
        nfd: "\u{1107}\u{1162}\u{11B7}",
        nfkc: "\u{BC40}",
        nfkd: "\u{1107}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BC41}",
        nfc: "\u{BC41}",
        nfd: "\u{1107}\u{1162}\u{11B8}",
        nfkc: "\u{BC41}",
        nfkd: "\u{1107}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BC42}",
        nfc: "\u{BC42}",
        nfd: "\u{1107}\u{1162}\u{11B9}",
        nfkc: "\u{BC42}",
        nfkd: "\u{1107}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BC43}",
        nfc: "\u{BC43}",
        nfd: "\u{1107}\u{1162}\u{11BA}",
        nfkc: "\u{BC43}",
        nfkd: "\u{1107}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BC44}",
        nfc: "\u{BC44}",
        nfd: "\u{1107}\u{1162}\u{11BB}",
        nfkc: "\u{BC44}",
        nfkd: "\u{1107}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BC45}",
        nfc: "\u{BC45}",
        nfd: "\u{1107}\u{1162}\u{11BC}",
        nfkc: "\u{BC45}",
        nfkd: "\u{1107}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BC46}",
        nfc: "\u{BC46}",
        nfd: "\u{1107}\u{1162}\u{11BD}",
        nfkc: "\u{BC46}",
        nfkd: "\u{1107}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BC47}",
        nfc: "\u{BC47}",
        nfd: "\u{1107}\u{1162}\u{11BE}",
        nfkc: "\u{BC47}",
        nfkd: "\u{1107}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BC48}",
        nfc: "\u{BC48}",
        nfd: "\u{1107}\u{1162}\u{11BF}",
        nfkc: "\u{BC48}",
        nfkd: "\u{1107}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BC49}",
        nfc: "\u{BC49}",
        nfd: "\u{1107}\u{1162}\u{11C0}",
        nfkc: "\u{BC49}",
        nfkd: "\u{1107}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BC4A}",
        nfc: "\u{BC4A}",
        nfd: "\u{1107}\u{1162}\u{11C1}",
        nfkc: "\u{BC4A}",
        nfkd: "\u{1107}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BC4B}",
        nfc: "\u{BC4B}",
        nfd: "\u{1107}\u{1162}\u{11C2}",
        nfkc: "\u{BC4B}",
        nfkd: "\u{1107}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BC4C}",
        nfc: "\u{BC4C}",
        nfd: "\u{1107}\u{1163}",
        nfkc: "\u{BC4C}",
        nfkd: "\u{1107}\u{1163}",
    },
    NormalizationTest {
        source: "\u{BC4D}",
        nfc: "\u{BC4D}",
        nfd: "\u{1107}\u{1163}\u{11A8}",
        nfkc: "\u{BC4D}",
        nfkd: "\u{1107}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BC4E}",
        nfc: "\u{BC4E}",
        nfd: "\u{1107}\u{1163}\u{11A9}",
        nfkc: "\u{BC4E}",
        nfkd: "\u{1107}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BC4F}",
        nfc: "\u{BC4F}",
        nfd: "\u{1107}\u{1163}\u{11AA}",
        nfkc: "\u{BC4F}",
        nfkd: "\u{1107}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BC50}",
        nfc: "\u{BC50}",
        nfd: "\u{1107}\u{1163}\u{11AB}",
        nfkc: "\u{BC50}",
        nfkd: "\u{1107}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BC51}",
        nfc: "\u{BC51}",
        nfd: "\u{1107}\u{1163}\u{11AC}",
        nfkc: "\u{BC51}",
        nfkd: "\u{1107}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BC52}",
        nfc: "\u{BC52}",
        nfd: "\u{1107}\u{1163}\u{11AD}",
        nfkc: "\u{BC52}",
        nfkd: "\u{1107}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BC53}",
        nfc: "\u{BC53}",
        nfd: "\u{1107}\u{1163}\u{11AE}",
        nfkc: "\u{BC53}",
        nfkd: "\u{1107}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BC54}",
        nfc: "\u{BC54}",
        nfd: "\u{1107}\u{1163}\u{11AF}",
        nfkc: "\u{BC54}",
        nfkd: "\u{1107}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BC55}",
        nfc: "\u{BC55}",
        nfd: "\u{1107}\u{1163}\u{11B0}",
        nfkc: "\u{BC55}",
        nfkd: "\u{1107}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BC56}",
        nfc: "\u{BC56}",
        nfd: "\u{1107}\u{1163}\u{11B1}",
        nfkc: "\u{BC56}",
        nfkd: "\u{1107}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BC57}",
        nfc: "\u{BC57}",
        nfd: "\u{1107}\u{1163}\u{11B2}",
        nfkc: "\u{BC57}",
        nfkd: "\u{1107}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BC58}",
        nfc: "\u{BC58}",
        nfd: "\u{1107}\u{1163}\u{11B3}",
        nfkc: "\u{BC58}",
        nfkd: "\u{1107}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BC59}",
        nfc: "\u{BC59}",
        nfd: "\u{1107}\u{1163}\u{11B4}",
        nfkc: "\u{BC59}",
        nfkd: "\u{1107}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BC5A}",
        nfc: "\u{BC5A}",
        nfd: "\u{1107}\u{1163}\u{11B5}",
        nfkc: "\u{BC5A}",
        nfkd: "\u{1107}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BC5B}",
        nfc: "\u{BC5B}",
        nfd: "\u{1107}\u{1163}\u{11B6}",
        nfkc: "\u{BC5B}",
        nfkd: "\u{1107}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BC5C}",
        nfc: "\u{BC5C}",
        nfd: "\u{1107}\u{1163}\u{11B7}",
        nfkc: "\u{BC5C}",
        nfkd: "\u{1107}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BC5D}",
        nfc: "\u{BC5D}",
        nfd: "\u{1107}\u{1163}\u{11B8}",
        nfkc: "\u{BC5D}",
        nfkd: "\u{1107}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BC5E}",
        nfc: "\u{BC5E}",
        nfd: "\u{1107}\u{1163}\u{11B9}",
        nfkc: "\u{BC5E}",
        nfkd: "\u{1107}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BC5F}",
        nfc: "\u{BC5F}",
        nfd: "\u{1107}\u{1163}\u{11BA}",
        nfkc: "\u{BC5F}",
        nfkd: "\u{1107}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BC60}",
        nfc: "\u{BC60}",
        nfd: "\u{1107}\u{1163}\u{11BB}",
        nfkc: "\u{BC60}",
        nfkd: "\u{1107}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BC61}",
        nfc: "\u{BC61}",
        nfd: "\u{1107}\u{1163}\u{11BC}",
        nfkc: "\u{BC61}",
        nfkd: "\u{1107}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BC62}",
        nfc: "\u{BC62}",
        nfd: "\u{1107}\u{1163}\u{11BD}",
        nfkc: "\u{BC62}",
        nfkd: "\u{1107}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BC63}",
        nfc: "\u{BC63}",
        nfd: "\u{1107}\u{1163}\u{11BE}",
        nfkc: "\u{BC63}",
        nfkd: "\u{1107}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BC64}",
        nfc: "\u{BC64}",
        nfd: "\u{1107}\u{1163}\u{11BF}",
        nfkc: "\u{BC64}",
        nfkd: "\u{1107}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BC65}",
        nfc: "\u{BC65}",
        nfd: "\u{1107}\u{1163}\u{11C0}",
        nfkc: "\u{BC65}",
        nfkd: "\u{1107}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BC66}",
        nfc: "\u{BC66}",
        nfd: "\u{1107}\u{1163}\u{11C1}",
        nfkc: "\u{BC66}",
        nfkd: "\u{1107}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BC67}",
        nfc: "\u{BC67}",
        nfd: "\u{1107}\u{1163}\u{11C2}",
        nfkc: "\u{BC67}",
        nfkd: "\u{1107}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BC68}",
        nfc: "\u{BC68}",
        nfd: "\u{1107}\u{1164}",
        nfkc: "\u{BC68}",
        nfkd: "\u{1107}\u{1164}",
    },
    NormalizationTest {
        source: "\u{BC69}",
        nfc: "\u{BC69}",
        nfd: "\u{1107}\u{1164}\u{11A8}",
        nfkc: "\u{BC69}",
        nfkd: "\u{1107}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BC6A}",
        nfc: "\u{BC6A}",
        nfd: "\u{1107}\u{1164}\u{11A9}",
        nfkc: "\u{BC6A}",
        nfkd: "\u{1107}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BC6B}",
        nfc: "\u{BC6B}",
        nfd: "\u{1107}\u{1164}\u{11AA}",
        nfkc: "\u{BC6B}",
        nfkd: "\u{1107}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BC6C}",
        nfc: "\u{BC6C}",
        nfd: "\u{1107}\u{1164}\u{11AB}",
        nfkc: "\u{BC6C}",
        nfkd: "\u{1107}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BC6D}",
        nfc: "\u{BC6D}",
        nfd: "\u{1107}\u{1164}\u{11AC}",
        nfkc: "\u{BC6D}",
        nfkd: "\u{1107}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BC6E}",
        nfc: "\u{BC6E}",
        nfd: "\u{1107}\u{1164}\u{11AD}",
        nfkc: "\u{BC6E}",
        nfkd: "\u{1107}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BC6F}",
        nfc: "\u{BC6F}",
        nfd: "\u{1107}\u{1164}\u{11AE}",
        nfkc: "\u{BC6F}",
        nfkd: "\u{1107}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BC70}",
        nfc: "\u{BC70}",
        nfd: "\u{1107}\u{1164}\u{11AF}",
        nfkc: "\u{BC70}",
        nfkd: "\u{1107}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BC71}",
        nfc: "\u{BC71}",
        nfd: "\u{1107}\u{1164}\u{11B0}",
        nfkc: "\u{BC71}",
        nfkd: "\u{1107}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BC72}",
        nfc: "\u{BC72}",
        nfd: "\u{1107}\u{1164}\u{11B1}",
        nfkc: "\u{BC72}",
        nfkd: "\u{1107}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BC73}",
        nfc: "\u{BC73}",
        nfd: "\u{1107}\u{1164}\u{11B2}",
        nfkc: "\u{BC73}",
        nfkd: "\u{1107}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BC74}",
        nfc: "\u{BC74}",
        nfd: "\u{1107}\u{1164}\u{11B3}",
        nfkc: "\u{BC74}",
        nfkd: "\u{1107}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BC75}",
        nfc: "\u{BC75}",
        nfd: "\u{1107}\u{1164}\u{11B4}",
        nfkc: "\u{BC75}",
        nfkd: "\u{1107}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BC76}",
        nfc: "\u{BC76}",
        nfd: "\u{1107}\u{1164}\u{11B5}",
        nfkc: "\u{BC76}",
        nfkd: "\u{1107}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BC77}",
        nfc: "\u{BC77}",
        nfd: "\u{1107}\u{1164}\u{11B6}",
        nfkc: "\u{BC77}",
        nfkd: "\u{1107}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BC78}",
        nfc: "\u{BC78}",
        nfd: "\u{1107}\u{1164}\u{11B7}",
        nfkc: "\u{BC78}",
        nfkd: "\u{1107}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BC79}",
        nfc: "\u{BC79}",
        nfd: "\u{1107}\u{1164}\u{11B8}",
        nfkc: "\u{BC79}",
        nfkd: "\u{1107}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BC7A}",
        nfc: "\u{BC7A}",
        nfd: "\u{1107}\u{1164}\u{11B9}",
        nfkc: "\u{BC7A}",
        nfkd: "\u{1107}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BC7B}",
        nfc: "\u{BC7B}",
        nfd: "\u{1107}\u{1164}\u{11BA}",
        nfkc: "\u{BC7B}",
        nfkd: "\u{1107}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BC7C}",
        nfc: "\u{BC7C}",
        nfd: "\u{1107}\u{1164}\u{11BB}",
        nfkc: "\u{BC7C}",
        nfkd: "\u{1107}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BC7D}",
        nfc: "\u{BC7D}",
        nfd: "\u{1107}\u{1164}\u{11BC}",
        nfkc: "\u{BC7D}",
        nfkd: "\u{1107}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BC7E}",
        nfc: "\u{BC7E}",
        nfd: "\u{1107}\u{1164}\u{11BD}",
        nfkc: "\u{BC7E}",
        nfkd: "\u{1107}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BC7F}",
        nfc: "\u{BC7F}",
        nfd: "\u{1107}\u{1164}\u{11BE}",
        nfkc: "\u{BC7F}",
        nfkd: "\u{1107}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BC80}",
        nfc: "\u{BC80}",
        nfd: "\u{1107}\u{1164}\u{11BF}",
        nfkc: "\u{BC80}",
        nfkd: "\u{1107}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BC81}",
        nfc: "\u{BC81}",
        nfd: "\u{1107}\u{1164}\u{11C0}",
        nfkc: "\u{BC81}",
        nfkd: "\u{1107}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BC82}",
        nfc: "\u{BC82}",
        nfd: "\u{1107}\u{1164}\u{11C1}",
        nfkc: "\u{BC82}",
        nfkd: "\u{1107}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BC83}",
        nfc: "\u{BC83}",
        nfd: "\u{1107}\u{1164}\u{11C2}",
        nfkc: "\u{BC83}",
        nfkd: "\u{1107}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BC84}",
        nfc: "\u{BC84}",
        nfd: "\u{1107}\u{1165}",
        nfkc: "\u{BC84}",
        nfkd: "\u{1107}\u{1165}",
    },
    NormalizationTest {
        source: "\u{BC85}",
        nfc: "\u{BC85}",
        nfd: "\u{1107}\u{1165}\u{11A8}",
        nfkc: "\u{BC85}",
        nfkd: "\u{1107}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BC86}",
        nfc: "\u{BC86}",
        nfd: "\u{1107}\u{1165}\u{11A9}",
        nfkc: "\u{BC86}",
        nfkd: "\u{1107}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BC87}",
        nfc: "\u{BC87}",
        nfd: "\u{1107}\u{1165}\u{11AA}",
        nfkc: "\u{BC87}",
        nfkd: "\u{1107}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BC88}",
        nfc: "\u{BC88}",
        nfd: "\u{1107}\u{1165}\u{11AB}",
        nfkc: "\u{BC88}",
        nfkd: "\u{1107}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BC89}",
        nfc: "\u{BC89}",
        nfd: "\u{1107}\u{1165}\u{11AC}",
        nfkc: "\u{BC89}",
        nfkd: "\u{1107}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BC8A}",
        nfc: "\u{BC8A}",
        nfd: "\u{1107}\u{1165}\u{11AD}",
        nfkc: "\u{BC8A}",
        nfkd: "\u{1107}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BC8B}",
        nfc: "\u{BC8B}",
        nfd: "\u{1107}\u{1165}\u{11AE}",
        nfkc: "\u{BC8B}",
        nfkd: "\u{1107}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BC8C}",
        nfc: "\u{BC8C}",
        nfd: "\u{1107}\u{1165}\u{11AF}",
        nfkc: "\u{BC8C}",
        nfkd: "\u{1107}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BC8D}",
        nfc: "\u{BC8D}",
        nfd: "\u{1107}\u{1165}\u{11B0}",
        nfkc: "\u{BC8D}",
        nfkd: "\u{1107}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BC8E}",
        nfc: "\u{BC8E}",
        nfd: "\u{1107}\u{1165}\u{11B1}",
        nfkc: "\u{BC8E}",
        nfkd: "\u{1107}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BC8F}",
        nfc: "\u{BC8F}",
        nfd: "\u{1107}\u{1165}\u{11B2}",
        nfkc: "\u{BC8F}",
        nfkd: "\u{1107}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BC90}",
        nfc: "\u{BC90}",
        nfd: "\u{1107}\u{1165}\u{11B3}",
        nfkc: "\u{BC90}",
        nfkd: "\u{1107}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BC91}",
        nfc: "\u{BC91}",
        nfd: "\u{1107}\u{1165}\u{11B4}",
        nfkc: "\u{BC91}",
        nfkd: "\u{1107}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BC92}",
        nfc: "\u{BC92}",
        nfd: "\u{1107}\u{1165}\u{11B5}",
        nfkc: "\u{BC92}",
        nfkd: "\u{1107}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BC93}",
        nfc: "\u{BC93}",
        nfd: "\u{1107}\u{1165}\u{11B6}",
        nfkc: "\u{BC93}",
        nfkd: "\u{1107}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BC94}",
        nfc: "\u{BC94}",
        nfd: "\u{1107}\u{1165}\u{11B7}",
        nfkc: "\u{BC94}",
        nfkd: "\u{1107}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BC95}",
        nfc: "\u{BC95}",
        nfd: "\u{1107}\u{1165}\u{11B8}",
        nfkc: "\u{BC95}",
        nfkd: "\u{1107}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BC96}",
        nfc: "\u{BC96}",
        nfd: "\u{1107}\u{1165}\u{11B9}",
        nfkc: "\u{BC96}",
        nfkd: "\u{1107}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BC97}",
        nfc: "\u{BC97}",
        nfd: "\u{1107}\u{1165}\u{11BA}",
        nfkc: "\u{BC97}",
        nfkd: "\u{1107}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BC98}",
        nfc: "\u{BC98}",
        nfd: "\u{1107}\u{1165}\u{11BB}",
        nfkc: "\u{BC98}",
        nfkd: "\u{1107}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BC99}",
        nfc: "\u{BC99}",
        nfd: "\u{1107}\u{1165}\u{11BC}",
        nfkc: "\u{BC99}",
        nfkd: "\u{1107}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BC9A}",
        nfc: "\u{BC9A}",
        nfd: "\u{1107}\u{1165}\u{11BD}",
        nfkc: "\u{BC9A}",
        nfkd: "\u{1107}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BC9B}",
        nfc: "\u{BC9B}",
        nfd: "\u{1107}\u{1165}\u{11BE}",
        nfkc: "\u{BC9B}",
        nfkd: "\u{1107}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BC9C}",
        nfc: "\u{BC9C}",
        nfd: "\u{1107}\u{1165}\u{11BF}",
        nfkc: "\u{BC9C}",
        nfkd: "\u{1107}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BC9D}",
        nfc: "\u{BC9D}",
        nfd: "\u{1107}\u{1165}\u{11C0}",
        nfkc: "\u{BC9D}",
        nfkd: "\u{1107}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BC9E}",
        nfc: "\u{BC9E}",
        nfd: "\u{1107}\u{1165}\u{11C1}",
        nfkc: "\u{BC9E}",
        nfkd: "\u{1107}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BC9F}",
        nfc: "\u{BC9F}",
        nfd: "\u{1107}\u{1165}\u{11C2}",
        nfkc: "\u{BC9F}",
        nfkd: "\u{1107}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BCA0}",
        nfc: "\u{BCA0}",
        nfd: "\u{1107}\u{1166}",
        nfkc: "\u{BCA0}",
        nfkd: "\u{1107}\u{1166}",
    },
    NormalizationTest {
        source: "\u{BCA1}",
        nfc: "\u{BCA1}",
        nfd: "\u{1107}\u{1166}\u{11A8}",
        nfkc: "\u{BCA1}",
        nfkd: "\u{1107}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BCA2}",
        nfc: "\u{BCA2}",
        nfd: "\u{1107}\u{1166}\u{11A9}",
        nfkc: "\u{BCA2}",
        nfkd: "\u{1107}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BCA3}",
        nfc: "\u{BCA3}",
        nfd: "\u{1107}\u{1166}\u{11AA}",
        nfkc: "\u{BCA3}",
        nfkd: "\u{1107}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BCA4}",
        nfc: "\u{BCA4}",
        nfd: "\u{1107}\u{1166}\u{11AB}",
        nfkc: "\u{BCA4}",
        nfkd: "\u{1107}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BCA5}",
        nfc: "\u{BCA5}",
        nfd: "\u{1107}\u{1166}\u{11AC}",
        nfkc: "\u{BCA5}",
        nfkd: "\u{1107}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BCA6}",
        nfc: "\u{BCA6}",
        nfd: "\u{1107}\u{1166}\u{11AD}",
        nfkc: "\u{BCA6}",
        nfkd: "\u{1107}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BCA7}",
        nfc: "\u{BCA7}",
        nfd: "\u{1107}\u{1166}\u{11AE}",
        nfkc: "\u{BCA7}",
        nfkd: "\u{1107}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BCA8}",
        nfc: "\u{BCA8}",
        nfd: "\u{1107}\u{1166}\u{11AF}",
        nfkc: "\u{BCA8}",
        nfkd: "\u{1107}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BCA9}",
        nfc: "\u{BCA9}",
        nfd: "\u{1107}\u{1166}\u{11B0}",
        nfkc: "\u{BCA9}",
        nfkd: "\u{1107}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BCAA}",
        nfc: "\u{BCAA}",
        nfd: "\u{1107}\u{1166}\u{11B1}",
        nfkc: "\u{BCAA}",
        nfkd: "\u{1107}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BCAB}",
        nfc: "\u{BCAB}",
        nfd: "\u{1107}\u{1166}\u{11B2}",
        nfkc: "\u{BCAB}",
        nfkd: "\u{1107}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BCAC}",
        nfc: "\u{BCAC}",
        nfd: "\u{1107}\u{1166}\u{11B3}",
        nfkc: "\u{BCAC}",
        nfkd: "\u{1107}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BCAD}",
        nfc: "\u{BCAD}",
        nfd: "\u{1107}\u{1166}\u{11B4}",
        nfkc: "\u{BCAD}",
        nfkd: "\u{1107}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BCAE}",
        nfc: "\u{BCAE}",
        nfd: "\u{1107}\u{1166}\u{11B5}",
        nfkc: "\u{BCAE}",
        nfkd: "\u{1107}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BCAF}",
        nfc: "\u{BCAF}",
        nfd: "\u{1107}\u{1166}\u{11B6}",
        nfkc: "\u{BCAF}",
        nfkd: "\u{1107}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BCB0}",
        nfc: "\u{BCB0}",
        nfd: "\u{1107}\u{1166}\u{11B7}",
        nfkc: "\u{BCB0}",
        nfkd: "\u{1107}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BCB1}",
        nfc: "\u{BCB1}",
        nfd: "\u{1107}\u{1166}\u{11B8}",
        nfkc: "\u{BCB1}",
        nfkd: "\u{1107}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BCB2}",
        nfc: "\u{BCB2}",
        nfd: "\u{1107}\u{1166}\u{11B9}",
        nfkc: "\u{BCB2}",
        nfkd: "\u{1107}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BCB3}",
        nfc: "\u{BCB3}",
        nfd: "\u{1107}\u{1166}\u{11BA}",
        nfkc: "\u{BCB3}",
        nfkd: "\u{1107}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BCB4}",
        nfc: "\u{BCB4}",
        nfd: "\u{1107}\u{1166}\u{11BB}",
        nfkc: "\u{BCB4}",
        nfkd: "\u{1107}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BCB5}",
        nfc: "\u{BCB5}",
        nfd: "\u{1107}\u{1166}\u{11BC}",
        nfkc: "\u{BCB5}",
        nfkd: "\u{1107}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BCB6}",
        nfc: "\u{BCB6}",
        nfd: "\u{1107}\u{1166}\u{11BD}",
        nfkc: "\u{BCB6}",
        nfkd: "\u{1107}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BCB7}",
        nfc: "\u{BCB7}",
        nfd: "\u{1107}\u{1166}\u{11BE}",
        nfkc: "\u{BCB7}",
        nfkd: "\u{1107}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BCB8}",
        nfc: "\u{BCB8}",
        nfd: "\u{1107}\u{1166}\u{11BF}",
        nfkc: "\u{BCB8}",
        nfkd: "\u{1107}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BCB9}",
        nfc: "\u{BCB9}",
        nfd: "\u{1107}\u{1166}\u{11C0}",
        nfkc: "\u{BCB9}",
        nfkd: "\u{1107}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BCBA}",
        nfc: "\u{BCBA}",
        nfd: "\u{1107}\u{1166}\u{11C1}",
        nfkc: "\u{BCBA}",
        nfkd: "\u{1107}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BCBB}",
        nfc: "\u{BCBB}",
        nfd: "\u{1107}\u{1166}\u{11C2}",
        nfkc: "\u{BCBB}",
        nfkd: "\u{1107}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BCBC}",
        nfc: "\u{BCBC}",
        nfd: "\u{1107}\u{1167}",
        nfkc: "\u{BCBC}",
        nfkd: "\u{1107}\u{1167}",
    },
    NormalizationTest {
        source: "\u{BCBD}",
        nfc: "\u{BCBD}",
        nfd: "\u{1107}\u{1167}\u{11A8}",
        nfkc: "\u{BCBD}",
        nfkd: "\u{1107}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BCBE}",
        nfc: "\u{BCBE}",
        nfd: "\u{1107}\u{1167}\u{11A9}",
        nfkc: "\u{BCBE}",
        nfkd: "\u{1107}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BCBF}",
        nfc: "\u{BCBF}",
        nfd: "\u{1107}\u{1167}\u{11AA}",
        nfkc: "\u{BCBF}",
        nfkd: "\u{1107}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BCC0}",
        nfc: "\u{BCC0}",
        nfd: "\u{1107}\u{1167}\u{11AB}",
        nfkc: "\u{BCC0}",
        nfkd: "\u{1107}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BCC1}",
        nfc: "\u{BCC1}",
        nfd: "\u{1107}\u{1167}\u{11AC}",
        nfkc: "\u{BCC1}",
        nfkd: "\u{1107}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BCC2}",
        nfc: "\u{BCC2}",
        nfd: "\u{1107}\u{1167}\u{11AD}",
        nfkc: "\u{BCC2}",
        nfkd: "\u{1107}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BCC3}",
        nfc: "\u{BCC3}",
        nfd: "\u{1107}\u{1167}\u{11AE}",
        nfkc: "\u{BCC3}",
        nfkd: "\u{1107}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BCC4}",
        nfc: "\u{BCC4}",
        nfd: "\u{1107}\u{1167}\u{11AF}",
        nfkc: "\u{BCC4}",
        nfkd: "\u{1107}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BCC5}",
        nfc: "\u{BCC5}",
        nfd: "\u{1107}\u{1167}\u{11B0}",
        nfkc: "\u{BCC5}",
        nfkd: "\u{1107}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BCC6}",
        nfc: "\u{BCC6}",
        nfd: "\u{1107}\u{1167}\u{11B1}",
        nfkc: "\u{BCC6}",
        nfkd: "\u{1107}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BCC7}",
        nfc: "\u{BCC7}",
        nfd: "\u{1107}\u{1167}\u{11B2}",
        nfkc: "\u{BCC7}",
        nfkd: "\u{1107}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BCC8}",
        nfc: "\u{BCC8}",
        nfd: "\u{1107}\u{1167}\u{11B3}",
        nfkc: "\u{BCC8}",
        nfkd: "\u{1107}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BCC9}",
        nfc: "\u{BCC9}",
        nfd: "\u{1107}\u{1167}\u{11B4}",
        nfkc: "\u{BCC9}",
        nfkd: "\u{1107}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BCCA}",
        nfc: "\u{BCCA}",
        nfd: "\u{1107}\u{1167}\u{11B5}",
        nfkc: "\u{BCCA}",
        nfkd: "\u{1107}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BCCB}",
        nfc: "\u{BCCB}",
        nfd: "\u{1107}\u{1167}\u{11B6}",
        nfkc: "\u{BCCB}",
        nfkd: "\u{1107}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BCCC}",
        nfc: "\u{BCCC}",
        nfd: "\u{1107}\u{1167}\u{11B7}",
        nfkc: "\u{BCCC}",
        nfkd: "\u{1107}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BCCD}",
        nfc: "\u{BCCD}",
        nfd: "\u{1107}\u{1167}\u{11B8}",
        nfkc: "\u{BCCD}",
        nfkd: "\u{1107}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BCCE}",
        nfc: "\u{BCCE}",
        nfd: "\u{1107}\u{1167}\u{11B9}",
        nfkc: "\u{BCCE}",
        nfkd: "\u{1107}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BCCF}",
        nfc: "\u{BCCF}",
        nfd: "\u{1107}\u{1167}\u{11BA}",
        nfkc: "\u{BCCF}",
        nfkd: "\u{1107}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BCD0}",
        nfc: "\u{BCD0}",
        nfd: "\u{1107}\u{1167}\u{11BB}",
        nfkc: "\u{BCD0}",
        nfkd: "\u{1107}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BCD1}",
        nfc: "\u{BCD1}",
        nfd: "\u{1107}\u{1167}\u{11BC}",
        nfkc: "\u{BCD1}",
        nfkd: "\u{1107}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BCD2}",
        nfc: "\u{BCD2}",
        nfd: "\u{1107}\u{1167}\u{11BD}",
        nfkc: "\u{BCD2}",
        nfkd: "\u{1107}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BCD3}",
        nfc: "\u{BCD3}",
        nfd: "\u{1107}\u{1167}\u{11BE}",
        nfkc: "\u{BCD3}",
        nfkd: "\u{1107}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BCD4}",
        nfc: "\u{BCD4}",
        nfd: "\u{1107}\u{1167}\u{11BF}",
        nfkc: "\u{BCD4}",
        nfkd: "\u{1107}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BCD5}",
        nfc: "\u{BCD5}",
        nfd: "\u{1107}\u{1167}\u{11C0}",
        nfkc: "\u{BCD5}",
        nfkd: "\u{1107}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BCD6}",
        nfc: "\u{BCD6}",
        nfd: "\u{1107}\u{1167}\u{11C1}",
        nfkc: "\u{BCD6}",
        nfkd: "\u{1107}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BCD7}",
        nfc: "\u{BCD7}",
        nfd: "\u{1107}\u{1167}\u{11C2}",
        nfkc: "\u{BCD7}",
        nfkd: "\u{1107}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BCD8}",
        nfc: "\u{BCD8}",
        nfd: "\u{1107}\u{1168}",
        nfkc: "\u{BCD8}",
        nfkd: "\u{1107}\u{1168}",
    },
    NormalizationTest {
        source: "\u{BCD9}",
        nfc: "\u{BCD9}",
        nfd: "\u{1107}\u{1168}\u{11A8}",
        nfkc: "\u{BCD9}",
        nfkd: "\u{1107}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BCDA}",
        nfc: "\u{BCDA}",
        nfd: "\u{1107}\u{1168}\u{11A9}",
        nfkc: "\u{BCDA}",
        nfkd: "\u{1107}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BCDB}",
        nfc: "\u{BCDB}",
        nfd: "\u{1107}\u{1168}\u{11AA}",
        nfkc: "\u{BCDB}",
        nfkd: "\u{1107}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BCDC}",
        nfc: "\u{BCDC}",
        nfd: "\u{1107}\u{1168}\u{11AB}",
        nfkc: "\u{BCDC}",
        nfkd: "\u{1107}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BCDD}",
        nfc: "\u{BCDD}",
        nfd: "\u{1107}\u{1168}\u{11AC}",
        nfkc: "\u{BCDD}",
        nfkd: "\u{1107}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BCDE}",
        nfc: "\u{BCDE}",
        nfd: "\u{1107}\u{1168}\u{11AD}",
        nfkc: "\u{BCDE}",
        nfkd: "\u{1107}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BCDF}",
        nfc: "\u{BCDF}",
        nfd: "\u{1107}\u{1168}\u{11AE}",
        nfkc: "\u{BCDF}",
        nfkd: "\u{1107}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BCE0}",
        nfc: "\u{BCE0}",
        nfd: "\u{1107}\u{1168}\u{11AF}",
        nfkc: "\u{BCE0}",
        nfkd: "\u{1107}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BCE1}",
        nfc: "\u{BCE1}",
        nfd: "\u{1107}\u{1168}\u{11B0}",
        nfkc: "\u{BCE1}",
        nfkd: "\u{1107}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BCE2}",
        nfc: "\u{BCE2}",
        nfd: "\u{1107}\u{1168}\u{11B1}",
        nfkc: "\u{BCE2}",
        nfkd: "\u{1107}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BCE3}",
        nfc: "\u{BCE3}",
        nfd: "\u{1107}\u{1168}\u{11B2}",
        nfkc: "\u{BCE3}",
        nfkd: "\u{1107}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BCE4}",
        nfc: "\u{BCE4}",
        nfd: "\u{1107}\u{1168}\u{11B3}",
        nfkc: "\u{BCE4}",
        nfkd: "\u{1107}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BCE5}",
        nfc: "\u{BCE5}",
        nfd: "\u{1107}\u{1168}\u{11B4}",
        nfkc: "\u{BCE5}",
        nfkd: "\u{1107}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BCE6}",
        nfc: "\u{BCE6}",
        nfd: "\u{1107}\u{1168}\u{11B5}",
        nfkc: "\u{BCE6}",
        nfkd: "\u{1107}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BCE7}",
        nfc: "\u{BCE7}",
        nfd: "\u{1107}\u{1168}\u{11B6}",
        nfkc: "\u{BCE7}",
        nfkd: "\u{1107}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BCE8}",
        nfc: "\u{BCE8}",
        nfd: "\u{1107}\u{1168}\u{11B7}",
        nfkc: "\u{BCE8}",
        nfkd: "\u{1107}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BCE9}",
        nfc: "\u{BCE9}",
        nfd: "\u{1107}\u{1168}\u{11B8}",
        nfkc: "\u{BCE9}",
        nfkd: "\u{1107}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BCEA}",
        nfc: "\u{BCEA}",
        nfd: "\u{1107}\u{1168}\u{11B9}",
        nfkc: "\u{BCEA}",
        nfkd: "\u{1107}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BCEB}",
        nfc: "\u{BCEB}",
        nfd: "\u{1107}\u{1168}\u{11BA}",
        nfkc: "\u{BCEB}",
        nfkd: "\u{1107}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BCEC}",
        nfc: "\u{BCEC}",
        nfd: "\u{1107}\u{1168}\u{11BB}",
        nfkc: "\u{BCEC}",
        nfkd: "\u{1107}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BCED}",
        nfc: "\u{BCED}",
        nfd: "\u{1107}\u{1168}\u{11BC}",
        nfkc: "\u{BCED}",
        nfkd: "\u{1107}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BCEE}",
        nfc: "\u{BCEE}",
        nfd: "\u{1107}\u{1168}\u{11BD}",
        nfkc: "\u{BCEE}",
        nfkd: "\u{1107}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BCEF}",
        nfc: "\u{BCEF}",
        nfd: "\u{1107}\u{1168}\u{11BE}",
        nfkc: "\u{BCEF}",
        nfkd: "\u{1107}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BCF0}",
        nfc: "\u{BCF0}",
        nfd: "\u{1107}\u{1168}\u{11BF}",
        nfkc: "\u{BCF0}",
        nfkd: "\u{1107}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BCF1}",
        nfc: "\u{BCF1}",
        nfd: "\u{1107}\u{1168}\u{11C0}",
        nfkc: "\u{BCF1}",
        nfkd: "\u{1107}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BCF2}",
        nfc: "\u{BCF2}",
        nfd: "\u{1107}\u{1168}\u{11C1}",
        nfkc: "\u{BCF2}",
        nfkd: "\u{1107}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BCF3}",
        nfc: "\u{BCF3}",
        nfd: "\u{1107}\u{1168}\u{11C2}",
        nfkc: "\u{BCF3}",
        nfkd: "\u{1107}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BCF4}",
        nfc: "\u{BCF4}",
        nfd: "\u{1107}\u{1169}",
        nfkc: "\u{BCF4}",
        nfkd: "\u{1107}\u{1169}",
    },
    NormalizationTest {
        source: "\u{BCF5}",
        nfc: "\u{BCF5}",
        nfd: "\u{1107}\u{1169}\u{11A8}",
        nfkc: "\u{BCF5}",
        nfkd: "\u{1107}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BCF6}",
        nfc: "\u{BCF6}",
        nfd: "\u{1107}\u{1169}\u{11A9}",
        nfkc: "\u{BCF6}",
        nfkd: "\u{1107}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BCF7}",
        nfc: "\u{BCF7}",
        nfd: "\u{1107}\u{1169}\u{11AA}",
        nfkc: "\u{BCF7}",
        nfkd: "\u{1107}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BCF8}",
        nfc: "\u{BCF8}",
        nfd: "\u{1107}\u{1169}\u{11AB}",
        nfkc: "\u{BCF8}",
        nfkd: "\u{1107}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BCF9}",
        nfc: "\u{BCF9}",
        nfd: "\u{1107}\u{1169}\u{11AC}",
        nfkc: "\u{BCF9}",
        nfkd: "\u{1107}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BCFA}",
        nfc: "\u{BCFA}",
        nfd: "\u{1107}\u{1169}\u{11AD}",
        nfkc: "\u{BCFA}",
        nfkd: "\u{1107}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BCFB}",
        nfc: "\u{BCFB}",
        nfd: "\u{1107}\u{1169}\u{11AE}",
        nfkc: "\u{BCFB}",
        nfkd: "\u{1107}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BCFC}",
        nfc: "\u{BCFC}",
        nfd: "\u{1107}\u{1169}\u{11AF}",
        nfkc: "\u{BCFC}",
        nfkd: "\u{1107}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BCFD}",
        nfc: "\u{BCFD}",
        nfd: "\u{1107}\u{1169}\u{11B0}",
        nfkc: "\u{BCFD}",
        nfkd: "\u{1107}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BCFE}",
        nfc: "\u{BCFE}",
        nfd: "\u{1107}\u{1169}\u{11B1}",
        nfkc: "\u{BCFE}",
        nfkd: "\u{1107}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BCFF}",
        nfc: "\u{BCFF}",
        nfd: "\u{1107}\u{1169}\u{11B2}",
        nfkc: "\u{BCFF}",
        nfkd: "\u{1107}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BD00}",
        nfc: "\u{BD00}",
        nfd: "\u{1107}\u{1169}\u{11B3}",
        nfkc: "\u{BD00}",
        nfkd: "\u{1107}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BD01}",
        nfc: "\u{BD01}",
        nfd: "\u{1107}\u{1169}\u{11B4}",
        nfkc: "\u{BD01}",
        nfkd: "\u{1107}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BD02}",
        nfc: "\u{BD02}",
        nfd: "\u{1107}\u{1169}\u{11B5}",
        nfkc: "\u{BD02}",
        nfkd: "\u{1107}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BD03}",
        nfc: "\u{BD03}",
        nfd: "\u{1107}\u{1169}\u{11B6}",
        nfkc: "\u{BD03}",
        nfkd: "\u{1107}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BD04}",
        nfc: "\u{BD04}",
        nfd: "\u{1107}\u{1169}\u{11B7}",
        nfkc: "\u{BD04}",
        nfkd: "\u{1107}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BD05}",
        nfc: "\u{BD05}",
        nfd: "\u{1107}\u{1169}\u{11B8}",
        nfkc: "\u{BD05}",
        nfkd: "\u{1107}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BD06}",
        nfc: "\u{BD06}",
        nfd: "\u{1107}\u{1169}\u{11B9}",
        nfkc: "\u{BD06}",
        nfkd: "\u{1107}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BD07}",
        nfc: "\u{BD07}",
        nfd: "\u{1107}\u{1169}\u{11BA}",
        nfkc: "\u{BD07}",
        nfkd: "\u{1107}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BD08}",
        nfc: "\u{BD08}",
        nfd: "\u{1107}\u{1169}\u{11BB}",
        nfkc: "\u{BD08}",
        nfkd: "\u{1107}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BD09}",
        nfc: "\u{BD09}",
        nfd: "\u{1107}\u{1169}\u{11BC}",
        nfkc: "\u{BD09}",
        nfkd: "\u{1107}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BD0A}",
        nfc: "\u{BD0A}",
        nfd: "\u{1107}\u{1169}\u{11BD}",
        nfkc: "\u{BD0A}",
        nfkd: "\u{1107}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BD0B}",
        nfc: "\u{BD0B}",
        nfd: "\u{1107}\u{1169}\u{11BE}",
        nfkc: "\u{BD0B}",
        nfkd: "\u{1107}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BD0C}",
        nfc: "\u{BD0C}",
        nfd: "\u{1107}\u{1169}\u{11BF}",
        nfkc: "\u{BD0C}",
        nfkd: "\u{1107}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BD0D}",
        nfc: "\u{BD0D}",
        nfd: "\u{1107}\u{1169}\u{11C0}",
        nfkc: "\u{BD0D}",
        nfkd: "\u{1107}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BD0E}",
        nfc: "\u{BD0E}",
        nfd: "\u{1107}\u{1169}\u{11C1}",
        nfkc: "\u{BD0E}",
        nfkd: "\u{1107}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BD0F}",
        nfc: "\u{BD0F}",
        nfd: "\u{1107}\u{1169}\u{11C2}",
        nfkc: "\u{BD0F}",
        nfkd: "\u{1107}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BD10}",
        nfc: "\u{BD10}",
        nfd: "\u{1107}\u{116A}",
        nfkc: "\u{BD10}",
        nfkd: "\u{1107}\u{116A}",
    },
    NormalizationTest {
        source: "\u{BD11}",
        nfc: "\u{BD11}",
        nfd: "\u{1107}\u{116A}\u{11A8}",
        nfkc: "\u{BD11}",
        nfkd: "\u{1107}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BD12}",
        nfc: "\u{BD12}",
        nfd: "\u{1107}\u{116A}\u{11A9}",
        nfkc: "\u{BD12}",
        nfkd: "\u{1107}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BD13}",
        nfc: "\u{BD13}",
        nfd: "\u{1107}\u{116A}\u{11AA}",
        nfkc: "\u{BD13}",
        nfkd: "\u{1107}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BD14}",
        nfc: "\u{BD14}",
        nfd: "\u{1107}\u{116A}\u{11AB}",
        nfkc: "\u{BD14}",
        nfkd: "\u{1107}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BD15}",
        nfc: "\u{BD15}",
        nfd: "\u{1107}\u{116A}\u{11AC}",
        nfkc: "\u{BD15}",
        nfkd: "\u{1107}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BD16}",
        nfc: "\u{BD16}",
        nfd: "\u{1107}\u{116A}\u{11AD}",
        nfkc: "\u{BD16}",
        nfkd: "\u{1107}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BD17}",
        nfc: "\u{BD17}",
        nfd: "\u{1107}\u{116A}\u{11AE}",
        nfkc: "\u{BD17}",
        nfkd: "\u{1107}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BD18}",
        nfc: "\u{BD18}",
        nfd: "\u{1107}\u{116A}\u{11AF}",
        nfkc: "\u{BD18}",
        nfkd: "\u{1107}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BD19}",
        nfc: "\u{BD19}",
        nfd: "\u{1107}\u{116A}\u{11B0}",
        nfkc: "\u{BD19}",
        nfkd: "\u{1107}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BD1A}",
        nfc: "\u{BD1A}",
        nfd: "\u{1107}\u{116A}\u{11B1}",
        nfkc: "\u{BD1A}",
        nfkd: "\u{1107}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BD1B}",
        nfc: "\u{BD1B}",
        nfd: "\u{1107}\u{116A}\u{11B2}",
        nfkc: "\u{BD1B}",
        nfkd: "\u{1107}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BD1C}",
        nfc: "\u{BD1C}",
        nfd: "\u{1107}\u{116A}\u{11B3}",
        nfkc: "\u{BD1C}",
        nfkd: "\u{1107}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BD1D}",
        nfc: "\u{BD1D}",
        nfd: "\u{1107}\u{116A}\u{11B4}",
        nfkc: "\u{BD1D}",
        nfkd: "\u{1107}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BD1E}",
        nfc: "\u{BD1E}",
        nfd: "\u{1107}\u{116A}\u{11B5}",
        nfkc: "\u{BD1E}",
        nfkd: "\u{1107}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BD1F}",
        nfc: "\u{BD1F}",
        nfd: "\u{1107}\u{116A}\u{11B6}",
        nfkc: "\u{BD1F}",
        nfkd: "\u{1107}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BD20}",
        nfc: "\u{BD20}",
        nfd: "\u{1107}\u{116A}\u{11B7}",
        nfkc: "\u{BD20}",
        nfkd: "\u{1107}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BD21}",
        nfc: "\u{BD21}",
        nfd: "\u{1107}\u{116A}\u{11B8}",
        nfkc: "\u{BD21}",
        nfkd: "\u{1107}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BD22}",
        nfc: "\u{BD22}",
        nfd: "\u{1107}\u{116A}\u{11B9}",
        nfkc: "\u{BD22}",
        nfkd: "\u{1107}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BD23}",
        nfc: "\u{BD23}",
        nfd: "\u{1107}\u{116A}\u{11BA}",
        nfkc: "\u{BD23}",
        nfkd: "\u{1107}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BD24}",
        nfc: "\u{BD24}",
        nfd: "\u{1107}\u{116A}\u{11BB}",
        nfkc: "\u{BD24}",
        nfkd: "\u{1107}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BD25}",
        nfc: "\u{BD25}",
        nfd: "\u{1107}\u{116A}\u{11BC}",
        nfkc: "\u{BD25}",
        nfkd: "\u{1107}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BD26}",
        nfc: "\u{BD26}",
        nfd: "\u{1107}\u{116A}\u{11BD}",
        nfkc: "\u{BD26}",
        nfkd: "\u{1107}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BD27}",
        nfc: "\u{BD27}",
        nfd: "\u{1107}\u{116A}\u{11BE}",
        nfkc: "\u{BD27}",
        nfkd: "\u{1107}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BD28}",
        nfc: "\u{BD28}",
        nfd: "\u{1107}\u{116A}\u{11BF}",
        nfkc: "\u{BD28}",
        nfkd: "\u{1107}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BD29}",
        nfc: "\u{BD29}",
        nfd: "\u{1107}\u{116A}\u{11C0}",
        nfkc: "\u{BD29}",
        nfkd: "\u{1107}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BD2A}",
        nfc: "\u{BD2A}",
        nfd: "\u{1107}\u{116A}\u{11C1}",
        nfkc: "\u{BD2A}",
        nfkd: "\u{1107}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BD2B}",
        nfc: "\u{BD2B}",
        nfd: "\u{1107}\u{116A}\u{11C2}",
        nfkc: "\u{BD2B}",
        nfkd: "\u{1107}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BD2C}",
        nfc: "\u{BD2C}",
        nfd: "\u{1107}\u{116B}",
        nfkc: "\u{BD2C}",
        nfkd: "\u{1107}\u{116B}",
    },
    NormalizationTest {
        source: "\u{BD2D}",
        nfc: "\u{BD2D}",
        nfd: "\u{1107}\u{116B}\u{11A8}",
        nfkc: "\u{BD2D}",
        nfkd: "\u{1107}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BD2E}",
        nfc: "\u{BD2E}",
        nfd: "\u{1107}\u{116B}\u{11A9}",
        nfkc: "\u{BD2E}",
        nfkd: "\u{1107}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BD2F}",
        nfc: "\u{BD2F}",
        nfd: "\u{1107}\u{116B}\u{11AA}",
        nfkc: "\u{BD2F}",
        nfkd: "\u{1107}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BD30}",
        nfc: "\u{BD30}",
        nfd: "\u{1107}\u{116B}\u{11AB}",
        nfkc: "\u{BD30}",
        nfkd: "\u{1107}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BD31}",
        nfc: "\u{BD31}",
        nfd: "\u{1107}\u{116B}\u{11AC}",
        nfkc: "\u{BD31}",
        nfkd: "\u{1107}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BD32}",
        nfc: "\u{BD32}",
        nfd: "\u{1107}\u{116B}\u{11AD}",
        nfkc: "\u{BD32}",
        nfkd: "\u{1107}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BD33}",
        nfc: "\u{BD33}",
        nfd: "\u{1107}\u{116B}\u{11AE}",
        nfkc: "\u{BD33}",
        nfkd: "\u{1107}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BD34}",
        nfc: "\u{BD34}",
        nfd: "\u{1107}\u{116B}\u{11AF}",
        nfkc: "\u{BD34}",
        nfkd: "\u{1107}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BD35}",
        nfc: "\u{BD35}",
        nfd: "\u{1107}\u{116B}\u{11B0}",
        nfkc: "\u{BD35}",
        nfkd: "\u{1107}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BD36}",
        nfc: "\u{BD36}",
        nfd: "\u{1107}\u{116B}\u{11B1}",
        nfkc: "\u{BD36}",
        nfkd: "\u{1107}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BD37}",
        nfc: "\u{BD37}",
        nfd: "\u{1107}\u{116B}\u{11B2}",
        nfkc: "\u{BD37}",
        nfkd: "\u{1107}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BD38}",
        nfc: "\u{BD38}",
        nfd: "\u{1107}\u{116B}\u{11B3}",
        nfkc: "\u{BD38}",
        nfkd: "\u{1107}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BD39}",
        nfc: "\u{BD39}",
        nfd: "\u{1107}\u{116B}\u{11B4}",
        nfkc: "\u{BD39}",
        nfkd: "\u{1107}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BD3A}",
        nfc: "\u{BD3A}",
        nfd: "\u{1107}\u{116B}\u{11B5}",
        nfkc: "\u{BD3A}",
        nfkd: "\u{1107}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BD3B}",
        nfc: "\u{BD3B}",
        nfd: "\u{1107}\u{116B}\u{11B6}",
        nfkc: "\u{BD3B}",
        nfkd: "\u{1107}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BD3C}",
        nfc: "\u{BD3C}",
        nfd: "\u{1107}\u{116B}\u{11B7}",
        nfkc: "\u{BD3C}",
        nfkd: "\u{1107}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BD3D}",
        nfc: "\u{BD3D}",
        nfd: "\u{1107}\u{116B}\u{11B8}",
        nfkc: "\u{BD3D}",
        nfkd: "\u{1107}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BD3E}",
        nfc: "\u{BD3E}",
        nfd: "\u{1107}\u{116B}\u{11B9}",
        nfkc: "\u{BD3E}",
        nfkd: "\u{1107}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BD3F}",
        nfc: "\u{BD3F}",
        nfd: "\u{1107}\u{116B}\u{11BA}",
        nfkc: "\u{BD3F}",
        nfkd: "\u{1107}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BD40}",
        nfc: "\u{BD40}",
        nfd: "\u{1107}\u{116B}\u{11BB}",
        nfkc: "\u{BD40}",
        nfkd: "\u{1107}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BD41}",
        nfc: "\u{BD41}",
        nfd: "\u{1107}\u{116B}\u{11BC}",
        nfkc: "\u{BD41}",
        nfkd: "\u{1107}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BD42}",
        nfc: "\u{BD42}",
        nfd: "\u{1107}\u{116B}\u{11BD}",
        nfkc: "\u{BD42}",
        nfkd: "\u{1107}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BD43}",
        nfc: "\u{BD43}",
        nfd: "\u{1107}\u{116B}\u{11BE}",
        nfkc: "\u{BD43}",
        nfkd: "\u{1107}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BD44}",
        nfc: "\u{BD44}",
        nfd: "\u{1107}\u{116B}\u{11BF}",
        nfkc: "\u{BD44}",
        nfkd: "\u{1107}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BD45}",
        nfc: "\u{BD45}",
        nfd: "\u{1107}\u{116B}\u{11C0}",
        nfkc: "\u{BD45}",
        nfkd: "\u{1107}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BD46}",
        nfc: "\u{BD46}",
        nfd: "\u{1107}\u{116B}\u{11C1}",
        nfkc: "\u{BD46}",
        nfkd: "\u{1107}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BD47}",
        nfc: "\u{BD47}",
        nfd: "\u{1107}\u{116B}\u{11C2}",
        nfkc: "\u{BD47}",
        nfkd: "\u{1107}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BD48}",
        nfc: "\u{BD48}",
        nfd: "\u{1107}\u{116C}",
        nfkc: "\u{BD48}",
        nfkd: "\u{1107}\u{116C}",
    },
    NormalizationTest {
        source: "\u{BD49}",
        nfc: "\u{BD49}",
        nfd: "\u{1107}\u{116C}\u{11A8}",
        nfkc: "\u{BD49}",
        nfkd: "\u{1107}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BD4A}",
        nfc: "\u{BD4A}",
        nfd: "\u{1107}\u{116C}\u{11A9}",
        nfkc: "\u{BD4A}",
        nfkd: "\u{1107}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BD4B}",
        nfc: "\u{BD4B}",
        nfd: "\u{1107}\u{116C}\u{11AA}",
        nfkc: "\u{BD4B}",
        nfkd: "\u{1107}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BD4C}",
        nfc: "\u{BD4C}",
        nfd: "\u{1107}\u{116C}\u{11AB}",
        nfkc: "\u{BD4C}",
        nfkd: "\u{1107}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BD4D}",
        nfc: "\u{BD4D}",
        nfd: "\u{1107}\u{116C}\u{11AC}",
        nfkc: "\u{BD4D}",
        nfkd: "\u{1107}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BD4E}",
        nfc: "\u{BD4E}",
        nfd: "\u{1107}\u{116C}\u{11AD}",
        nfkc: "\u{BD4E}",
        nfkd: "\u{1107}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BD4F}",
        nfc: "\u{BD4F}",
        nfd: "\u{1107}\u{116C}\u{11AE}",
        nfkc: "\u{BD4F}",
        nfkd: "\u{1107}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BD50}",
        nfc: "\u{BD50}",
        nfd: "\u{1107}\u{116C}\u{11AF}",
        nfkc: "\u{BD50}",
        nfkd: "\u{1107}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BD51}",
        nfc: "\u{BD51}",
        nfd: "\u{1107}\u{116C}\u{11B0}",
        nfkc: "\u{BD51}",
        nfkd: "\u{1107}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BD52}",
        nfc: "\u{BD52}",
        nfd: "\u{1107}\u{116C}\u{11B1}",
        nfkc: "\u{BD52}",
        nfkd: "\u{1107}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BD53}",
        nfc: "\u{BD53}",
        nfd: "\u{1107}\u{116C}\u{11B2}",
        nfkc: "\u{BD53}",
        nfkd: "\u{1107}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BD54}",
        nfc: "\u{BD54}",
        nfd: "\u{1107}\u{116C}\u{11B3}",
        nfkc: "\u{BD54}",
        nfkd: "\u{1107}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BD55}",
        nfc: "\u{BD55}",
        nfd: "\u{1107}\u{116C}\u{11B4}",
        nfkc: "\u{BD55}",
        nfkd: "\u{1107}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BD56}",
        nfc: "\u{BD56}",
        nfd: "\u{1107}\u{116C}\u{11B5}",
        nfkc: "\u{BD56}",
        nfkd: "\u{1107}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BD57}",
        nfc: "\u{BD57}",
        nfd: "\u{1107}\u{116C}\u{11B6}",
        nfkc: "\u{BD57}",
        nfkd: "\u{1107}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BD58}",
        nfc: "\u{BD58}",
        nfd: "\u{1107}\u{116C}\u{11B7}",
        nfkc: "\u{BD58}",
        nfkd: "\u{1107}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BD59}",
        nfc: "\u{BD59}",
        nfd: "\u{1107}\u{116C}\u{11B8}",
        nfkc: "\u{BD59}",
        nfkd: "\u{1107}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BD5A}",
        nfc: "\u{BD5A}",
        nfd: "\u{1107}\u{116C}\u{11B9}",
        nfkc: "\u{BD5A}",
        nfkd: "\u{1107}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BD5B}",
        nfc: "\u{BD5B}",
        nfd: "\u{1107}\u{116C}\u{11BA}",
        nfkc: "\u{BD5B}",
        nfkd: "\u{1107}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BD5C}",
        nfc: "\u{BD5C}",
        nfd: "\u{1107}\u{116C}\u{11BB}",
        nfkc: "\u{BD5C}",
        nfkd: "\u{1107}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BD5D}",
        nfc: "\u{BD5D}",
        nfd: "\u{1107}\u{116C}\u{11BC}",
        nfkc: "\u{BD5D}",
        nfkd: "\u{1107}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BD5E}",
        nfc: "\u{BD5E}",
        nfd: "\u{1107}\u{116C}\u{11BD}",
        nfkc: "\u{BD5E}",
        nfkd: "\u{1107}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BD5F}",
        nfc: "\u{BD5F}",
        nfd: "\u{1107}\u{116C}\u{11BE}",
        nfkc: "\u{BD5F}",
        nfkd: "\u{1107}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BD60}",
        nfc: "\u{BD60}",
        nfd: "\u{1107}\u{116C}\u{11BF}",
        nfkc: "\u{BD60}",
        nfkd: "\u{1107}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BD61}",
        nfc: "\u{BD61}",
        nfd: "\u{1107}\u{116C}\u{11C0}",
        nfkc: "\u{BD61}",
        nfkd: "\u{1107}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BD62}",
        nfc: "\u{BD62}",
        nfd: "\u{1107}\u{116C}\u{11C1}",
        nfkc: "\u{BD62}",
        nfkd: "\u{1107}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BD63}",
        nfc: "\u{BD63}",
        nfd: "\u{1107}\u{116C}\u{11C2}",
        nfkc: "\u{BD63}",
        nfkd: "\u{1107}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BD64}",
        nfc: "\u{BD64}",
        nfd: "\u{1107}\u{116D}",
        nfkc: "\u{BD64}",
        nfkd: "\u{1107}\u{116D}",
    },
    NormalizationTest {
        source: "\u{BD65}",
        nfc: "\u{BD65}",
        nfd: "\u{1107}\u{116D}\u{11A8}",
        nfkc: "\u{BD65}",
        nfkd: "\u{1107}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BD66}",
        nfc: "\u{BD66}",
        nfd: "\u{1107}\u{116D}\u{11A9}",
        nfkc: "\u{BD66}",
        nfkd: "\u{1107}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BD67}",
        nfc: "\u{BD67}",
        nfd: "\u{1107}\u{116D}\u{11AA}",
        nfkc: "\u{BD67}",
        nfkd: "\u{1107}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BD68}",
        nfc: "\u{BD68}",
        nfd: "\u{1107}\u{116D}\u{11AB}",
        nfkc: "\u{BD68}",
        nfkd: "\u{1107}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BD69}",
        nfc: "\u{BD69}",
        nfd: "\u{1107}\u{116D}\u{11AC}",
        nfkc: "\u{BD69}",
        nfkd: "\u{1107}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BD6A}",
        nfc: "\u{BD6A}",
        nfd: "\u{1107}\u{116D}\u{11AD}",
        nfkc: "\u{BD6A}",
        nfkd: "\u{1107}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BD6B}",
        nfc: "\u{BD6B}",
        nfd: "\u{1107}\u{116D}\u{11AE}",
        nfkc: "\u{BD6B}",
        nfkd: "\u{1107}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BD6C}",
        nfc: "\u{BD6C}",
        nfd: "\u{1107}\u{116D}\u{11AF}",
        nfkc: "\u{BD6C}",
        nfkd: "\u{1107}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BD6D}",
        nfc: "\u{BD6D}",
        nfd: "\u{1107}\u{116D}\u{11B0}",
        nfkc: "\u{BD6D}",
        nfkd: "\u{1107}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BD6E}",
        nfc: "\u{BD6E}",
        nfd: "\u{1107}\u{116D}\u{11B1}",
        nfkc: "\u{BD6E}",
        nfkd: "\u{1107}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BD6F}",
        nfc: "\u{BD6F}",
        nfd: "\u{1107}\u{116D}\u{11B2}",
        nfkc: "\u{BD6F}",
        nfkd: "\u{1107}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BD70}",
        nfc: "\u{BD70}",
        nfd: "\u{1107}\u{116D}\u{11B3}",
        nfkc: "\u{BD70}",
        nfkd: "\u{1107}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BD71}",
        nfc: "\u{BD71}",
        nfd: "\u{1107}\u{116D}\u{11B4}",
        nfkc: "\u{BD71}",
        nfkd: "\u{1107}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BD72}",
        nfc: "\u{BD72}",
        nfd: "\u{1107}\u{116D}\u{11B5}",
        nfkc: "\u{BD72}",
        nfkd: "\u{1107}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BD73}",
        nfc: "\u{BD73}",
        nfd: "\u{1107}\u{116D}\u{11B6}",
        nfkc: "\u{BD73}",
        nfkd: "\u{1107}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BD74}",
        nfc: "\u{BD74}",
        nfd: "\u{1107}\u{116D}\u{11B7}",
        nfkc: "\u{BD74}",
        nfkd: "\u{1107}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BD75}",
        nfc: "\u{BD75}",
        nfd: "\u{1107}\u{116D}\u{11B8}",
        nfkc: "\u{BD75}",
        nfkd: "\u{1107}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BD76}",
        nfc: "\u{BD76}",
        nfd: "\u{1107}\u{116D}\u{11B9}",
        nfkc: "\u{BD76}",
        nfkd: "\u{1107}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BD77}",
        nfc: "\u{BD77}",
        nfd: "\u{1107}\u{116D}\u{11BA}",
        nfkc: "\u{BD77}",
        nfkd: "\u{1107}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BD78}",
        nfc: "\u{BD78}",
        nfd: "\u{1107}\u{116D}\u{11BB}",
        nfkc: "\u{BD78}",
        nfkd: "\u{1107}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BD79}",
        nfc: "\u{BD79}",
        nfd: "\u{1107}\u{116D}\u{11BC}",
        nfkc: "\u{BD79}",
        nfkd: "\u{1107}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BD7A}",
        nfc: "\u{BD7A}",
        nfd: "\u{1107}\u{116D}\u{11BD}",
        nfkc: "\u{BD7A}",
        nfkd: "\u{1107}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BD7B}",
        nfc: "\u{BD7B}",
        nfd: "\u{1107}\u{116D}\u{11BE}",
        nfkc: "\u{BD7B}",
        nfkd: "\u{1107}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BD7C}",
        nfc: "\u{BD7C}",
        nfd: "\u{1107}\u{116D}\u{11BF}",
        nfkc: "\u{BD7C}",
        nfkd: "\u{1107}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BD7D}",
        nfc: "\u{BD7D}",
        nfd: "\u{1107}\u{116D}\u{11C0}",
        nfkc: "\u{BD7D}",
        nfkd: "\u{1107}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BD7E}",
        nfc: "\u{BD7E}",
        nfd: "\u{1107}\u{116D}\u{11C1}",
        nfkc: "\u{BD7E}",
        nfkd: "\u{1107}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BD7F}",
        nfc: "\u{BD7F}",
        nfd: "\u{1107}\u{116D}\u{11C2}",
        nfkc: "\u{BD7F}",
        nfkd: "\u{1107}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BD80}",
        nfc: "\u{BD80}",
        nfd: "\u{1107}\u{116E}",
        nfkc: "\u{BD80}",
        nfkd: "\u{1107}\u{116E}",
    },
    NormalizationTest {
        source: "\u{BD81}",
        nfc: "\u{BD81}",
        nfd: "\u{1107}\u{116E}\u{11A8}",
        nfkc: "\u{BD81}",
        nfkd: "\u{1107}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BD82}",
        nfc: "\u{BD82}",
        nfd: "\u{1107}\u{116E}\u{11A9}",
        nfkc: "\u{BD82}",
        nfkd: "\u{1107}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BD83}",
        nfc: "\u{BD83}",
        nfd: "\u{1107}\u{116E}\u{11AA}",
        nfkc: "\u{BD83}",
        nfkd: "\u{1107}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BD84}",
        nfc: "\u{BD84}",
        nfd: "\u{1107}\u{116E}\u{11AB}",
        nfkc: "\u{BD84}",
        nfkd: "\u{1107}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BD85}",
        nfc: "\u{BD85}",
        nfd: "\u{1107}\u{116E}\u{11AC}",
        nfkc: "\u{BD85}",
        nfkd: "\u{1107}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BD86}",
        nfc: "\u{BD86}",
        nfd: "\u{1107}\u{116E}\u{11AD}",
        nfkc: "\u{BD86}",
        nfkd: "\u{1107}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BD87}",
        nfc: "\u{BD87}",
        nfd: "\u{1107}\u{116E}\u{11AE}",
        nfkc: "\u{BD87}",
        nfkd: "\u{1107}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BD88}",
        nfc: "\u{BD88}",
        nfd: "\u{1107}\u{116E}\u{11AF}",
        nfkc: "\u{BD88}",
        nfkd: "\u{1107}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BD89}",
        nfc: "\u{BD89}",
        nfd: "\u{1107}\u{116E}\u{11B0}",
        nfkc: "\u{BD89}",
        nfkd: "\u{1107}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BD8A}",
        nfc: "\u{BD8A}",
        nfd: "\u{1107}\u{116E}\u{11B1}",
        nfkc: "\u{BD8A}",
        nfkd: "\u{1107}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BD8B}",
        nfc: "\u{BD8B}",
        nfd: "\u{1107}\u{116E}\u{11B2}",
        nfkc: "\u{BD8B}",
        nfkd: "\u{1107}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BD8C}",
        nfc: "\u{BD8C}",
        nfd: "\u{1107}\u{116E}\u{11B3}",
        nfkc: "\u{BD8C}",
        nfkd: "\u{1107}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BD8D}",
        nfc: "\u{BD8D}",
        nfd: "\u{1107}\u{116E}\u{11B4}",
        nfkc: "\u{BD8D}",
        nfkd: "\u{1107}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BD8E}",
        nfc: "\u{BD8E}",
        nfd: "\u{1107}\u{116E}\u{11B5}",
        nfkc: "\u{BD8E}",
        nfkd: "\u{1107}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BD8F}",
        nfc: "\u{BD8F}",
        nfd: "\u{1107}\u{116E}\u{11B6}",
        nfkc: "\u{BD8F}",
        nfkd: "\u{1107}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BD90}",
        nfc: "\u{BD90}",
        nfd: "\u{1107}\u{116E}\u{11B7}",
        nfkc: "\u{BD90}",
        nfkd: "\u{1107}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BD91}",
        nfc: "\u{BD91}",
        nfd: "\u{1107}\u{116E}\u{11B8}",
        nfkc: "\u{BD91}",
        nfkd: "\u{1107}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BD92}",
        nfc: "\u{BD92}",
        nfd: "\u{1107}\u{116E}\u{11B9}",
        nfkc: "\u{BD92}",
        nfkd: "\u{1107}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BD93}",
        nfc: "\u{BD93}",
        nfd: "\u{1107}\u{116E}\u{11BA}",
        nfkc: "\u{BD93}",
        nfkd: "\u{1107}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BD94}",
        nfc: "\u{BD94}",
        nfd: "\u{1107}\u{116E}\u{11BB}",
        nfkc: "\u{BD94}",
        nfkd: "\u{1107}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BD95}",
        nfc: "\u{BD95}",
        nfd: "\u{1107}\u{116E}\u{11BC}",
        nfkc: "\u{BD95}",
        nfkd: "\u{1107}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BD96}",
        nfc: "\u{BD96}",
        nfd: "\u{1107}\u{116E}\u{11BD}",
        nfkc: "\u{BD96}",
        nfkd: "\u{1107}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BD97}",
        nfc: "\u{BD97}",
        nfd: "\u{1107}\u{116E}\u{11BE}",
        nfkc: "\u{BD97}",
        nfkd: "\u{1107}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BD98}",
        nfc: "\u{BD98}",
        nfd: "\u{1107}\u{116E}\u{11BF}",
        nfkc: "\u{BD98}",
        nfkd: "\u{1107}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BD99}",
        nfc: "\u{BD99}",
        nfd: "\u{1107}\u{116E}\u{11C0}",
        nfkc: "\u{BD99}",
        nfkd: "\u{1107}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BD9A}",
        nfc: "\u{BD9A}",
        nfd: "\u{1107}\u{116E}\u{11C1}",
        nfkc: "\u{BD9A}",
        nfkd: "\u{1107}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BD9B}",
        nfc: "\u{BD9B}",
        nfd: "\u{1107}\u{116E}\u{11C2}",
        nfkc: "\u{BD9B}",
        nfkd: "\u{1107}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BD9C}",
        nfc: "\u{BD9C}",
        nfd: "\u{1107}\u{116F}",
        nfkc: "\u{BD9C}",
        nfkd: "\u{1107}\u{116F}",
    },
    NormalizationTest {
        source: "\u{BD9D}",
        nfc: "\u{BD9D}",
        nfd: "\u{1107}\u{116F}\u{11A8}",
        nfkc: "\u{BD9D}",
        nfkd: "\u{1107}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BD9E}",
        nfc: "\u{BD9E}",
        nfd: "\u{1107}\u{116F}\u{11A9}",
        nfkc: "\u{BD9E}",
        nfkd: "\u{1107}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BD9F}",
        nfc: "\u{BD9F}",
        nfd: "\u{1107}\u{116F}\u{11AA}",
        nfkc: "\u{BD9F}",
        nfkd: "\u{1107}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BDA0}",
        nfc: "\u{BDA0}",
        nfd: "\u{1107}\u{116F}\u{11AB}",
        nfkc: "\u{BDA0}",
        nfkd: "\u{1107}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BDA1}",
        nfc: "\u{BDA1}",
        nfd: "\u{1107}\u{116F}\u{11AC}",
        nfkc: "\u{BDA1}",
        nfkd: "\u{1107}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BDA2}",
        nfc: "\u{BDA2}",
        nfd: "\u{1107}\u{116F}\u{11AD}",
        nfkc: "\u{BDA2}",
        nfkd: "\u{1107}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BDA3}",
        nfc: "\u{BDA3}",
        nfd: "\u{1107}\u{116F}\u{11AE}",
        nfkc: "\u{BDA3}",
        nfkd: "\u{1107}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BDA4}",
        nfc: "\u{BDA4}",
        nfd: "\u{1107}\u{116F}\u{11AF}",
        nfkc: "\u{BDA4}",
        nfkd: "\u{1107}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BDA5}",
        nfc: "\u{BDA5}",
        nfd: "\u{1107}\u{116F}\u{11B0}",
        nfkc: "\u{BDA5}",
        nfkd: "\u{1107}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BDA6}",
        nfc: "\u{BDA6}",
        nfd: "\u{1107}\u{116F}\u{11B1}",
        nfkc: "\u{BDA6}",
        nfkd: "\u{1107}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BDA7}",
        nfc: "\u{BDA7}",
        nfd: "\u{1107}\u{116F}\u{11B2}",
        nfkc: "\u{BDA7}",
        nfkd: "\u{1107}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BDA8}",
        nfc: "\u{BDA8}",
        nfd: "\u{1107}\u{116F}\u{11B3}",
        nfkc: "\u{BDA8}",
        nfkd: "\u{1107}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BDA9}",
        nfc: "\u{BDA9}",
        nfd: "\u{1107}\u{116F}\u{11B4}",
        nfkc: "\u{BDA9}",
        nfkd: "\u{1107}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BDAA}",
        nfc: "\u{BDAA}",
        nfd: "\u{1107}\u{116F}\u{11B5}",
        nfkc: "\u{BDAA}",
        nfkd: "\u{1107}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BDAB}",
        nfc: "\u{BDAB}",
        nfd: "\u{1107}\u{116F}\u{11B6}",
        nfkc: "\u{BDAB}",
        nfkd: "\u{1107}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BDAC}",
        nfc: "\u{BDAC}",
        nfd: "\u{1107}\u{116F}\u{11B7}",
        nfkc: "\u{BDAC}",
        nfkd: "\u{1107}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BDAD}",
        nfc: "\u{BDAD}",
        nfd: "\u{1107}\u{116F}\u{11B8}",
        nfkc: "\u{BDAD}",
        nfkd: "\u{1107}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BDAE}",
        nfc: "\u{BDAE}",
        nfd: "\u{1107}\u{116F}\u{11B9}",
        nfkc: "\u{BDAE}",
        nfkd: "\u{1107}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BDAF}",
        nfc: "\u{BDAF}",
        nfd: "\u{1107}\u{116F}\u{11BA}",
        nfkc: "\u{BDAF}",
        nfkd: "\u{1107}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BDB0}",
        nfc: "\u{BDB0}",
        nfd: "\u{1107}\u{116F}\u{11BB}",
        nfkc: "\u{BDB0}",
        nfkd: "\u{1107}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BDB1}",
        nfc: "\u{BDB1}",
        nfd: "\u{1107}\u{116F}\u{11BC}",
        nfkc: "\u{BDB1}",
        nfkd: "\u{1107}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BDB2}",
        nfc: "\u{BDB2}",
        nfd: "\u{1107}\u{116F}\u{11BD}",
        nfkc: "\u{BDB2}",
        nfkd: "\u{1107}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BDB3}",
        nfc: "\u{BDB3}",
        nfd: "\u{1107}\u{116F}\u{11BE}",
        nfkc: "\u{BDB3}",
        nfkd: "\u{1107}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BDB4}",
        nfc: "\u{BDB4}",
        nfd: "\u{1107}\u{116F}\u{11BF}",
        nfkc: "\u{BDB4}",
        nfkd: "\u{1107}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BDB5}",
        nfc: "\u{BDB5}",
        nfd: "\u{1107}\u{116F}\u{11C0}",
        nfkc: "\u{BDB5}",
        nfkd: "\u{1107}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BDB6}",
        nfc: "\u{BDB6}",
        nfd: "\u{1107}\u{116F}\u{11C1}",
        nfkc: "\u{BDB6}",
        nfkd: "\u{1107}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BDB7}",
        nfc: "\u{BDB7}",
        nfd: "\u{1107}\u{116F}\u{11C2}",
        nfkc: "\u{BDB7}",
        nfkd: "\u{1107}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BDB8}",
        nfc: "\u{BDB8}",
        nfd: "\u{1107}\u{1170}",
        nfkc: "\u{BDB8}",
        nfkd: "\u{1107}\u{1170}",
    },
    NormalizationTest {
        source: "\u{BDB9}",
        nfc: "\u{BDB9}",
        nfd: "\u{1107}\u{1170}\u{11A8}",
        nfkc: "\u{BDB9}",
        nfkd: "\u{1107}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BDBA}",
        nfc: "\u{BDBA}",
        nfd: "\u{1107}\u{1170}\u{11A9}",
        nfkc: "\u{BDBA}",
        nfkd: "\u{1107}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BDBB}",
        nfc: "\u{BDBB}",
        nfd: "\u{1107}\u{1170}\u{11AA}",
        nfkc: "\u{BDBB}",
        nfkd: "\u{1107}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BDBC}",
        nfc: "\u{BDBC}",
        nfd: "\u{1107}\u{1170}\u{11AB}",
        nfkc: "\u{BDBC}",
        nfkd: "\u{1107}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BDBD}",
        nfc: "\u{BDBD}",
        nfd: "\u{1107}\u{1170}\u{11AC}",
        nfkc: "\u{BDBD}",
        nfkd: "\u{1107}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BDBE}",
        nfc: "\u{BDBE}",
        nfd: "\u{1107}\u{1170}\u{11AD}",
        nfkc: "\u{BDBE}",
        nfkd: "\u{1107}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BDBF}",
        nfc: "\u{BDBF}",
        nfd: "\u{1107}\u{1170}\u{11AE}",
        nfkc: "\u{BDBF}",
        nfkd: "\u{1107}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BDC0}",
        nfc: "\u{BDC0}",
        nfd: "\u{1107}\u{1170}\u{11AF}",
        nfkc: "\u{BDC0}",
        nfkd: "\u{1107}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BDC1}",
        nfc: "\u{BDC1}",
        nfd: "\u{1107}\u{1170}\u{11B0}",
        nfkc: "\u{BDC1}",
        nfkd: "\u{1107}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BDC2}",
        nfc: "\u{BDC2}",
        nfd: "\u{1107}\u{1170}\u{11B1}",
        nfkc: "\u{BDC2}",
        nfkd: "\u{1107}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BDC3}",
        nfc: "\u{BDC3}",
        nfd: "\u{1107}\u{1170}\u{11B2}",
        nfkc: "\u{BDC3}",
        nfkd: "\u{1107}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BDC4}",
        nfc: "\u{BDC4}",
        nfd: "\u{1107}\u{1170}\u{11B3}",
        nfkc: "\u{BDC4}",
        nfkd: "\u{1107}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BDC5}",
        nfc: "\u{BDC5}",
        nfd: "\u{1107}\u{1170}\u{11B4}",
        nfkc: "\u{BDC5}",
        nfkd: "\u{1107}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BDC6}",
        nfc: "\u{BDC6}",
        nfd: "\u{1107}\u{1170}\u{11B5}",
        nfkc: "\u{BDC6}",
        nfkd: "\u{1107}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BDC7}",
        nfc: "\u{BDC7}",
        nfd: "\u{1107}\u{1170}\u{11B6}",
        nfkc: "\u{BDC7}",
        nfkd: "\u{1107}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BDC8}",
        nfc: "\u{BDC8}",
        nfd: "\u{1107}\u{1170}\u{11B7}",
        nfkc: "\u{BDC8}",
        nfkd: "\u{1107}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BDC9}",
        nfc: "\u{BDC9}",
        nfd: "\u{1107}\u{1170}\u{11B8}",
        nfkc: "\u{BDC9}",
        nfkd: "\u{1107}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BDCA}",
        nfc: "\u{BDCA}",
        nfd: "\u{1107}\u{1170}\u{11B9}",
        nfkc: "\u{BDCA}",
        nfkd: "\u{1107}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BDCB}",
        nfc: "\u{BDCB}",
        nfd: "\u{1107}\u{1170}\u{11BA}",
        nfkc: "\u{BDCB}",
        nfkd: "\u{1107}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BDCC}",
        nfc: "\u{BDCC}",
        nfd: "\u{1107}\u{1170}\u{11BB}",
        nfkc: "\u{BDCC}",
        nfkd: "\u{1107}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BDCD}",
        nfc: "\u{BDCD}",
        nfd: "\u{1107}\u{1170}\u{11BC}",
        nfkc: "\u{BDCD}",
        nfkd: "\u{1107}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BDCE}",
        nfc: "\u{BDCE}",
        nfd: "\u{1107}\u{1170}\u{11BD}",
        nfkc: "\u{BDCE}",
        nfkd: "\u{1107}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BDCF}",
        nfc: "\u{BDCF}",
        nfd: "\u{1107}\u{1170}\u{11BE}",
        nfkc: "\u{BDCF}",
        nfkd: "\u{1107}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BDD0}",
        nfc: "\u{BDD0}",
        nfd: "\u{1107}\u{1170}\u{11BF}",
        nfkc: "\u{BDD0}",
        nfkd: "\u{1107}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BDD1}",
        nfc: "\u{BDD1}",
        nfd: "\u{1107}\u{1170}\u{11C0}",
        nfkc: "\u{BDD1}",
        nfkd: "\u{1107}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BDD2}",
        nfc: "\u{BDD2}",
        nfd: "\u{1107}\u{1170}\u{11C1}",
        nfkc: "\u{BDD2}",
        nfkd: "\u{1107}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BDD3}",
        nfc: "\u{BDD3}",
        nfd: "\u{1107}\u{1170}\u{11C2}",
        nfkc: "\u{BDD3}",
        nfkd: "\u{1107}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BDD4}",
        nfc: "\u{BDD4}",
        nfd: "\u{1107}\u{1171}",
        nfkc: "\u{BDD4}",
        nfkd: "\u{1107}\u{1171}",
    },
    NormalizationTest {
        source: "\u{BDD5}",
        nfc: "\u{BDD5}",
        nfd: "\u{1107}\u{1171}\u{11A8}",
        nfkc: "\u{BDD5}",
        nfkd: "\u{1107}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BDD6}",
        nfc: "\u{BDD6}",
        nfd: "\u{1107}\u{1171}\u{11A9}",
        nfkc: "\u{BDD6}",
        nfkd: "\u{1107}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BDD7}",
        nfc: "\u{BDD7}",
        nfd: "\u{1107}\u{1171}\u{11AA}",
        nfkc: "\u{BDD7}",
        nfkd: "\u{1107}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BDD8}",
        nfc: "\u{BDD8}",
        nfd: "\u{1107}\u{1171}\u{11AB}",
        nfkc: "\u{BDD8}",
        nfkd: "\u{1107}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BDD9}",
        nfc: "\u{BDD9}",
        nfd: "\u{1107}\u{1171}\u{11AC}",
        nfkc: "\u{BDD9}",
        nfkd: "\u{1107}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BDDA}",
        nfc: "\u{BDDA}",
        nfd: "\u{1107}\u{1171}\u{11AD}",
        nfkc: "\u{BDDA}",
        nfkd: "\u{1107}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BDDB}",
        nfc: "\u{BDDB}",
        nfd: "\u{1107}\u{1171}\u{11AE}",
        nfkc: "\u{BDDB}",
        nfkd: "\u{1107}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BDDC}",
        nfc: "\u{BDDC}",
        nfd: "\u{1107}\u{1171}\u{11AF}",
        nfkc: "\u{BDDC}",
        nfkd: "\u{1107}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BDDD}",
        nfc: "\u{BDDD}",
        nfd: "\u{1107}\u{1171}\u{11B0}",
        nfkc: "\u{BDDD}",
        nfkd: "\u{1107}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BDDE}",
        nfc: "\u{BDDE}",
        nfd: "\u{1107}\u{1171}\u{11B1}",
        nfkc: "\u{BDDE}",
        nfkd: "\u{1107}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BDDF}",
        nfc: "\u{BDDF}",
        nfd: "\u{1107}\u{1171}\u{11B2}",
        nfkc: "\u{BDDF}",
        nfkd: "\u{1107}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BDE0}",
        nfc: "\u{BDE0}",
        nfd: "\u{1107}\u{1171}\u{11B3}",
        nfkc: "\u{BDE0}",
        nfkd: "\u{1107}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BDE1}",
        nfc: "\u{BDE1}",
        nfd: "\u{1107}\u{1171}\u{11B4}",
        nfkc: "\u{BDE1}",
        nfkd: "\u{1107}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BDE2}",
        nfc: "\u{BDE2}",
        nfd: "\u{1107}\u{1171}\u{11B5}",
        nfkc: "\u{BDE2}",
        nfkd: "\u{1107}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BDE3}",
        nfc: "\u{BDE3}",
        nfd: "\u{1107}\u{1171}\u{11B6}",
        nfkc: "\u{BDE3}",
        nfkd: "\u{1107}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BDE4}",
        nfc: "\u{BDE4}",
        nfd: "\u{1107}\u{1171}\u{11B7}",
        nfkc: "\u{BDE4}",
        nfkd: "\u{1107}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BDE5}",
        nfc: "\u{BDE5}",
        nfd: "\u{1107}\u{1171}\u{11B8}",
        nfkc: "\u{BDE5}",
        nfkd: "\u{1107}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BDE6}",
        nfc: "\u{BDE6}",
        nfd: "\u{1107}\u{1171}\u{11B9}",
        nfkc: "\u{BDE6}",
        nfkd: "\u{1107}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BDE7}",
        nfc: "\u{BDE7}",
        nfd: "\u{1107}\u{1171}\u{11BA}",
        nfkc: "\u{BDE7}",
        nfkd: "\u{1107}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BDE8}",
        nfc: "\u{BDE8}",
        nfd: "\u{1107}\u{1171}\u{11BB}",
        nfkc: "\u{BDE8}",
        nfkd: "\u{1107}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BDE9}",
        nfc: "\u{BDE9}",
        nfd: "\u{1107}\u{1171}\u{11BC}",
        nfkc: "\u{BDE9}",
        nfkd: "\u{1107}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BDEA}",
        nfc: "\u{BDEA}",
        nfd: "\u{1107}\u{1171}\u{11BD}",
        nfkc: "\u{BDEA}",
        nfkd: "\u{1107}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BDEB}",
        nfc: "\u{BDEB}",
        nfd: "\u{1107}\u{1171}\u{11BE}",
        nfkc: "\u{BDEB}",
        nfkd: "\u{1107}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BDEC}",
        nfc: "\u{BDEC}",
        nfd: "\u{1107}\u{1171}\u{11BF}",
        nfkc: "\u{BDEC}",
        nfkd: "\u{1107}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BDED}",
        nfc: "\u{BDED}",
        nfd: "\u{1107}\u{1171}\u{11C0}",
        nfkc: "\u{BDED}",
        nfkd: "\u{1107}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BDEE}",
        nfc: "\u{BDEE}",
        nfd: "\u{1107}\u{1171}\u{11C1}",
        nfkc: "\u{BDEE}",
        nfkd: "\u{1107}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BDEF}",
        nfc: "\u{BDEF}",
        nfd: "\u{1107}\u{1171}\u{11C2}",
        nfkc: "\u{BDEF}",
        nfkd: "\u{1107}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BDF0}",
        nfc: "\u{BDF0}",
        nfd: "\u{1107}\u{1172}",
        nfkc: "\u{BDF0}",
        nfkd: "\u{1107}\u{1172}",
    },
    NormalizationTest {
        source: "\u{BDF1}",
        nfc: "\u{BDF1}",
        nfd: "\u{1107}\u{1172}\u{11A8}",
        nfkc: "\u{BDF1}",
        nfkd: "\u{1107}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BDF2}",
        nfc: "\u{BDF2}",
        nfd: "\u{1107}\u{1172}\u{11A9}",
        nfkc: "\u{BDF2}",
        nfkd: "\u{1107}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BDF3}",
        nfc: "\u{BDF3}",
        nfd: "\u{1107}\u{1172}\u{11AA}",
        nfkc: "\u{BDF3}",
        nfkd: "\u{1107}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BDF4}",
        nfc: "\u{BDF4}",
        nfd: "\u{1107}\u{1172}\u{11AB}",
        nfkc: "\u{BDF4}",
        nfkd: "\u{1107}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BDF5}",
        nfc: "\u{BDF5}",
        nfd: "\u{1107}\u{1172}\u{11AC}",
        nfkc: "\u{BDF5}",
        nfkd: "\u{1107}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BDF6}",
        nfc: "\u{BDF6}",
        nfd: "\u{1107}\u{1172}\u{11AD}",
        nfkc: "\u{BDF6}",
        nfkd: "\u{1107}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BDF7}",
        nfc: "\u{BDF7}",
        nfd: "\u{1107}\u{1172}\u{11AE}",
        nfkc: "\u{BDF7}",
        nfkd: "\u{1107}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BDF8}",
        nfc: "\u{BDF8}",
        nfd: "\u{1107}\u{1172}\u{11AF}",
        nfkc: "\u{BDF8}",
        nfkd: "\u{1107}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BDF9}",
        nfc: "\u{BDF9}",
        nfd: "\u{1107}\u{1172}\u{11B0}",
        nfkc: "\u{BDF9}",
        nfkd: "\u{1107}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BDFA}",
        nfc: "\u{BDFA}",
        nfd: "\u{1107}\u{1172}\u{11B1}",
        nfkc: "\u{BDFA}",
        nfkd: "\u{1107}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BDFB}",
        nfc: "\u{BDFB}",
        nfd: "\u{1107}\u{1172}\u{11B2}",
        nfkc: "\u{BDFB}",
        nfkd: "\u{1107}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BDFC}",
        nfc: "\u{BDFC}",
        nfd: "\u{1107}\u{1172}\u{11B3}",
        nfkc: "\u{BDFC}",
        nfkd: "\u{1107}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BDFD}",
        nfc: "\u{BDFD}",
        nfd: "\u{1107}\u{1172}\u{11B4}",
        nfkc: "\u{BDFD}",
        nfkd: "\u{1107}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BDFE}",
        nfc: "\u{BDFE}",
        nfd: "\u{1107}\u{1172}\u{11B5}",
        nfkc: "\u{BDFE}",
        nfkd: "\u{1107}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BDFF}",
        nfc: "\u{BDFF}",
        nfd: "\u{1107}\u{1172}\u{11B6}",
        nfkc: "\u{BDFF}",
        nfkd: "\u{1107}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BE00}",
        nfc: "\u{BE00}",
        nfd: "\u{1107}\u{1172}\u{11B7}",
        nfkc: "\u{BE00}",
        nfkd: "\u{1107}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BE01}",
        nfc: "\u{BE01}",
        nfd: "\u{1107}\u{1172}\u{11B8}",
        nfkc: "\u{BE01}",
        nfkd: "\u{1107}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BE02}",
        nfc: "\u{BE02}",
        nfd: "\u{1107}\u{1172}\u{11B9}",
        nfkc: "\u{BE02}",
        nfkd: "\u{1107}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BE03}",
        nfc: "\u{BE03}",
        nfd: "\u{1107}\u{1172}\u{11BA}",
        nfkc: "\u{BE03}",
        nfkd: "\u{1107}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BE04}",
        nfc: "\u{BE04}",
        nfd: "\u{1107}\u{1172}\u{11BB}",
        nfkc: "\u{BE04}",
        nfkd: "\u{1107}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BE05}",
        nfc: "\u{BE05}",
        nfd: "\u{1107}\u{1172}\u{11BC}",
        nfkc: "\u{BE05}",
        nfkd: "\u{1107}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BE06}",
        nfc: "\u{BE06}",
        nfd: "\u{1107}\u{1172}\u{11BD}",
        nfkc: "\u{BE06}",
        nfkd: "\u{1107}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BE07}",
        nfc: "\u{BE07}",
        nfd: "\u{1107}\u{1172}\u{11BE}",
        nfkc: "\u{BE07}",
        nfkd: "\u{1107}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BE08}",
        nfc: "\u{BE08}",
        nfd: "\u{1107}\u{1172}\u{11BF}",
        nfkc: "\u{BE08}",
        nfkd: "\u{1107}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BE09}",
        nfc: "\u{BE09}",
        nfd: "\u{1107}\u{1172}\u{11C0}",
        nfkc: "\u{BE09}",
        nfkd: "\u{1107}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BE0A}",
        nfc: "\u{BE0A}",
        nfd: "\u{1107}\u{1172}\u{11C1}",
        nfkc: "\u{BE0A}",
        nfkd: "\u{1107}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BE0B}",
        nfc: "\u{BE0B}",
        nfd: "\u{1107}\u{1172}\u{11C2}",
        nfkc: "\u{BE0B}",
        nfkd: "\u{1107}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BE0C}",
        nfc: "\u{BE0C}",
        nfd: "\u{1107}\u{1173}",
        nfkc: "\u{BE0C}",
        nfkd: "\u{1107}\u{1173}",
    },
    NormalizationTest {
        source: "\u{BE0D}",
        nfc: "\u{BE0D}",
        nfd: "\u{1107}\u{1173}\u{11A8}",
        nfkc: "\u{BE0D}",
        nfkd: "\u{1107}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BE0E}",
        nfc: "\u{BE0E}",
        nfd: "\u{1107}\u{1173}\u{11A9}",
        nfkc: "\u{BE0E}",
        nfkd: "\u{1107}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BE0F}",
        nfc: "\u{BE0F}",
        nfd: "\u{1107}\u{1173}\u{11AA}",
        nfkc: "\u{BE0F}",
        nfkd: "\u{1107}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BE10}",
        nfc: "\u{BE10}",
        nfd: "\u{1107}\u{1173}\u{11AB}",
        nfkc: "\u{BE10}",
        nfkd: "\u{1107}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BE11}",
        nfc: "\u{BE11}",
        nfd: "\u{1107}\u{1173}\u{11AC}",
        nfkc: "\u{BE11}",
        nfkd: "\u{1107}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BE12}",
        nfc: "\u{BE12}",
        nfd: "\u{1107}\u{1173}\u{11AD}",
        nfkc: "\u{BE12}",
        nfkd: "\u{1107}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BE13}",
        nfc: "\u{BE13}",
        nfd: "\u{1107}\u{1173}\u{11AE}",
        nfkc: "\u{BE13}",
        nfkd: "\u{1107}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BE14}",
        nfc: "\u{BE14}",
        nfd: "\u{1107}\u{1173}\u{11AF}",
        nfkc: "\u{BE14}",
        nfkd: "\u{1107}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BE15}",
        nfc: "\u{BE15}",
        nfd: "\u{1107}\u{1173}\u{11B0}",
        nfkc: "\u{BE15}",
        nfkd: "\u{1107}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BE16}",
        nfc: "\u{BE16}",
        nfd: "\u{1107}\u{1173}\u{11B1}",
        nfkc: "\u{BE16}",
        nfkd: "\u{1107}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BE17}",
        nfc: "\u{BE17}",
        nfd: "\u{1107}\u{1173}\u{11B2}",
        nfkc: "\u{BE17}",
        nfkd: "\u{1107}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BE18}",
        nfc: "\u{BE18}",
        nfd: "\u{1107}\u{1173}\u{11B3}",
        nfkc: "\u{BE18}",
        nfkd: "\u{1107}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BE19}",
        nfc: "\u{BE19}",
        nfd: "\u{1107}\u{1173}\u{11B4}",
        nfkc: "\u{BE19}",
        nfkd: "\u{1107}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BE1A}",
        nfc: "\u{BE1A}",
        nfd: "\u{1107}\u{1173}\u{11B5}",
        nfkc: "\u{BE1A}",
        nfkd: "\u{1107}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BE1B}",
        nfc: "\u{BE1B}",
        nfd: "\u{1107}\u{1173}\u{11B6}",
        nfkc: "\u{BE1B}",
        nfkd: "\u{1107}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BE1C}",
        nfc: "\u{BE1C}",
        nfd: "\u{1107}\u{1173}\u{11B7}",
        nfkc: "\u{BE1C}",
        nfkd: "\u{1107}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BE1D}",
        nfc: "\u{BE1D}",
        nfd: "\u{1107}\u{1173}\u{11B8}",
        nfkc: "\u{BE1D}",
        nfkd: "\u{1107}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BE1E}",
        nfc: "\u{BE1E}",
        nfd: "\u{1107}\u{1173}\u{11B9}",
        nfkc: "\u{BE1E}",
        nfkd: "\u{1107}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BE1F}",
        nfc: "\u{BE1F}",
        nfd: "\u{1107}\u{1173}\u{11BA}",
        nfkc: "\u{BE1F}",
        nfkd: "\u{1107}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BE20}",
        nfc: "\u{BE20}",
        nfd: "\u{1107}\u{1173}\u{11BB}",
        nfkc: "\u{BE20}",
        nfkd: "\u{1107}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BE21}",
        nfc: "\u{BE21}",
        nfd: "\u{1107}\u{1173}\u{11BC}",
        nfkc: "\u{BE21}",
        nfkd: "\u{1107}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BE22}",
        nfc: "\u{BE22}",
        nfd: "\u{1107}\u{1173}\u{11BD}",
        nfkc: "\u{BE22}",
        nfkd: "\u{1107}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BE23}",
        nfc: "\u{BE23}",
        nfd: "\u{1107}\u{1173}\u{11BE}",
        nfkc: "\u{BE23}",
        nfkd: "\u{1107}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BE24}",
        nfc: "\u{BE24}",
        nfd: "\u{1107}\u{1173}\u{11BF}",
        nfkc: "\u{BE24}",
        nfkd: "\u{1107}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BE25}",
        nfc: "\u{BE25}",
        nfd: "\u{1107}\u{1173}\u{11C0}",
        nfkc: "\u{BE25}",
        nfkd: "\u{1107}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BE26}",
        nfc: "\u{BE26}",
        nfd: "\u{1107}\u{1173}\u{11C1}",
        nfkc: "\u{BE26}",
        nfkd: "\u{1107}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BE27}",
        nfc: "\u{BE27}",
        nfd: "\u{1107}\u{1173}\u{11C2}",
        nfkc: "\u{BE27}",
        nfkd: "\u{1107}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BE28}",
        nfc: "\u{BE28}",
        nfd: "\u{1107}\u{1174}",
        nfkc: "\u{BE28}",
        nfkd: "\u{1107}\u{1174}",
    },
    NormalizationTest {
        source: "\u{BE29}",
        nfc: "\u{BE29}",
        nfd: "\u{1107}\u{1174}\u{11A8}",
        nfkc: "\u{BE29}",
        nfkd: "\u{1107}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BE2A}",
        nfc: "\u{BE2A}",
        nfd: "\u{1107}\u{1174}\u{11A9}",
        nfkc: "\u{BE2A}",
        nfkd: "\u{1107}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BE2B}",
        nfc: "\u{BE2B}",
        nfd: "\u{1107}\u{1174}\u{11AA}",
        nfkc: "\u{BE2B}",
        nfkd: "\u{1107}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BE2C}",
        nfc: "\u{BE2C}",
        nfd: "\u{1107}\u{1174}\u{11AB}",
        nfkc: "\u{BE2C}",
        nfkd: "\u{1107}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BE2D}",
        nfc: "\u{BE2D}",
        nfd: "\u{1107}\u{1174}\u{11AC}",
        nfkc: "\u{BE2D}",
        nfkd: "\u{1107}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BE2E}",
        nfc: "\u{BE2E}",
        nfd: "\u{1107}\u{1174}\u{11AD}",
        nfkc: "\u{BE2E}",
        nfkd: "\u{1107}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BE2F}",
        nfc: "\u{BE2F}",
        nfd: "\u{1107}\u{1174}\u{11AE}",
        nfkc: "\u{BE2F}",
        nfkd: "\u{1107}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BE30}",
        nfc: "\u{BE30}",
        nfd: "\u{1107}\u{1174}\u{11AF}",
        nfkc: "\u{BE30}",
        nfkd: "\u{1107}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BE31}",
        nfc: "\u{BE31}",
        nfd: "\u{1107}\u{1174}\u{11B0}",
        nfkc: "\u{BE31}",
        nfkd: "\u{1107}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BE32}",
        nfc: "\u{BE32}",
        nfd: "\u{1107}\u{1174}\u{11B1}",
        nfkc: "\u{BE32}",
        nfkd: "\u{1107}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BE33}",
        nfc: "\u{BE33}",
        nfd: "\u{1107}\u{1174}\u{11B2}",
        nfkc: "\u{BE33}",
        nfkd: "\u{1107}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BE34}",
        nfc: "\u{BE34}",
        nfd: "\u{1107}\u{1174}\u{11B3}",
        nfkc: "\u{BE34}",
        nfkd: "\u{1107}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BE35}",
        nfc: "\u{BE35}",
        nfd: "\u{1107}\u{1174}\u{11B4}",
        nfkc: "\u{BE35}",
        nfkd: "\u{1107}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BE36}",
        nfc: "\u{BE36}",
        nfd: "\u{1107}\u{1174}\u{11B5}",
        nfkc: "\u{BE36}",
        nfkd: "\u{1107}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BE37}",
        nfc: "\u{BE37}",
        nfd: "\u{1107}\u{1174}\u{11B6}",
        nfkc: "\u{BE37}",
        nfkd: "\u{1107}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BE38}",
        nfc: "\u{BE38}",
        nfd: "\u{1107}\u{1174}\u{11B7}",
        nfkc: "\u{BE38}",
        nfkd: "\u{1107}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BE39}",
        nfc: "\u{BE39}",
        nfd: "\u{1107}\u{1174}\u{11B8}",
        nfkc: "\u{BE39}",
        nfkd: "\u{1107}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BE3A}",
        nfc: "\u{BE3A}",
        nfd: "\u{1107}\u{1174}\u{11B9}",
        nfkc: "\u{BE3A}",
        nfkd: "\u{1107}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BE3B}",
        nfc: "\u{BE3B}",
        nfd: "\u{1107}\u{1174}\u{11BA}",
        nfkc: "\u{BE3B}",
        nfkd: "\u{1107}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BE3C}",
        nfc: "\u{BE3C}",
        nfd: "\u{1107}\u{1174}\u{11BB}",
        nfkc: "\u{BE3C}",
        nfkd: "\u{1107}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BE3D}",
        nfc: "\u{BE3D}",
        nfd: "\u{1107}\u{1174}\u{11BC}",
        nfkc: "\u{BE3D}",
        nfkd: "\u{1107}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BE3E}",
        nfc: "\u{BE3E}",
        nfd: "\u{1107}\u{1174}\u{11BD}",
        nfkc: "\u{BE3E}",
        nfkd: "\u{1107}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BE3F}",
        nfc: "\u{BE3F}",
        nfd: "\u{1107}\u{1174}\u{11BE}",
        nfkc: "\u{BE3F}",
        nfkd: "\u{1107}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BE40}",
        nfc: "\u{BE40}",
        nfd: "\u{1107}\u{1174}\u{11BF}",
        nfkc: "\u{BE40}",
        nfkd: "\u{1107}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BE41}",
        nfc: "\u{BE41}",
        nfd: "\u{1107}\u{1174}\u{11C0}",
        nfkc: "\u{BE41}",
        nfkd: "\u{1107}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BE42}",
        nfc: "\u{BE42}",
        nfd: "\u{1107}\u{1174}\u{11C1}",
        nfkc: "\u{BE42}",
        nfkd: "\u{1107}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BE43}",
        nfc: "\u{BE43}",
        nfd: "\u{1107}\u{1174}\u{11C2}",
        nfkc: "\u{BE43}",
        nfkd: "\u{1107}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BE44}",
        nfc: "\u{BE44}",
        nfd: "\u{1107}\u{1175}",
        nfkc: "\u{BE44}",
        nfkd: "\u{1107}\u{1175}",
    },
    NormalizationTest {
        source: "\u{BE45}",
        nfc: "\u{BE45}",
        nfd: "\u{1107}\u{1175}\u{11A8}",
        nfkc: "\u{BE45}",
        nfkd: "\u{1107}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BE46}",
        nfc: "\u{BE46}",
        nfd: "\u{1107}\u{1175}\u{11A9}",
        nfkc: "\u{BE46}",
        nfkd: "\u{1107}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BE47}",
        nfc: "\u{BE47}",
        nfd: "\u{1107}\u{1175}\u{11AA}",
        nfkc: "\u{BE47}",
        nfkd: "\u{1107}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BE48}",
        nfc: "\u{BE48}",
        nfd: "\u{1107}\u{1175}\u{11AB}",
        nfkc: "\u{BE48}",
        nfkd: "\u{1107}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BE49}",
        nfc: "\u{BE49}",
        nfd: "\u{1107}\u{1175}\u{11AC}",
        nfkc: "\u{BE49}",
        nfkd: "\u{1107}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BE4A}",
        nfc: "\u{BE4A}",
        nfd: "\u{1107}\u{1175}\u{11AD}",
        nfkc: "\u{BE4A}",
        nfkd: "\u{1107}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BE4B}",
        nfc: "\u{BE4B}",
        nfd: "\u{1107}\u{1175}\u{11AE}",
        nfkc: "\u{BE4B}",
        nfkd: "\u{1107}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BE4C}",
        nfc: "\u{BE4C}",
        nfd: "\u{1107}\u{1175}\u{11AF}",
        nfkc: "\u{BE4C}",
        nfkd: "\u{1107}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BE4D}",
        nfc: "\u{BE4D}",
        nfd: "\u{1107}\u{1175}\u{11B0}",
        nfkc: "\u{BE4D}",
        nfkd: "\u{1107}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BE4E}",
        nfc: "\u{BE4E}",
        nfd: "\u{1107}\u{1175}\u{11B1}",
        nfkc: "\u{BE4E}",
        nfkd: "\u{1107}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BE4F}",
        nfc: "\u{BE4F}",
        nfd: "\u{1107}\u{1175}\u{11B2}",
        nfkc: "\u{BE4F}",
        nfkd: "\u{1107}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BE50}",
        nfc: "\u{BE50}",
        nfd: "\u{1107}\u{1175}\u{11B3}",
        nfkc: "\u{BE50}",
        nfkd: "\u{1107}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BE51}",
        nfc: "\u{BE51}",
        nfd: "\u{1107}\u{1175}\u{11B4}",
        nfkc: "\u{BE51}",
        nfkd: "\u{1107}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BE52}",
        nfc: "\u{BE52}",
        nfd: "\u{1107}\u{1175}\u{11B5}",
        nfkc: "\u{BE52}",
        nfkd: "\u{1107}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BE53}",
        nfc: "\u{BE53}",
        nfd: "\u{1107}\u{1175}\u{11B6}",
        nfkc: "\u{BE53}",
        nfkd: "\u{1107}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BE54}",
        nfc: "\u{BE54}",
        nfd: "\u{1107}\u{1175}\u{11B7}",
        nfkc: "\u{BE54}",
        nfkd: "\u{1107}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BE55}",
        nfc: "\u{BE55}",
        nfd: "\u{1107}\u{1175}\u{11B8}",
        nfkc: "\u{BE55}",
        nfkd: "\u{1107}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BE56}",
        nfc: "\u{BE56}",
        nfd: "\u{1107}\u{1175}\u{11B9}",
        nfkc: "\u{BE56}",
        nfkd: "\u{1107}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BE57}",
        nfc: "\u{BE57}",
        nfd: "\u{1107}\u{1175}\u{11BA}",
        nfkc: "\u{BE57}",
        nfkd: "\u{1107}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BE58}",
        nfc: "\u{BE58}",
        nfd: "\u{1107}\u{1175}\u{11BB}",
        nfkc: "\u{BE58}",
        nfkd: "\u{1107}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BE59}",
        nfc: "\u{BE59}",
        nfd: "\u{1107}\u{1175}\u{11BC}",
        nfkc: "\u{BE59}",
        nfkd: "\u{1107}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BE5A}",
        nfc: "\u{BE5A}",
        nfd: "\u{1107}\u{1175}\u{11BD}",
        nfkc: "\u{BE5A}",
        nfkd: "\u{1107}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BE5B}",
        nfc: "\u{BE5B}",
        nfd: "\u{1107}\u{1175}\u{11BE}",
        nfkc: "\u{BE5B}",
        nfkd: "\u{1107}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BE5C}",
        nfc: "\u{BE5C}",
        nfd: "\u{1107}\u{1175}\u{11BF}",
        nfkc: "\u{BE5C}",
        nfkd: "\u{1107}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BE5D}",
        nfc: "\u{BE5D}",
        nfd: "\u{1107}\u{1175}\u{11C0}",
        nfkc: "\u{BE5D}",
        nfkd: "\u{1107}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BE5E}",
        nfc: "\u{BE5E}",
        nfd: "\u{1107}\u{1175}\u{11C1}",
        nfkc: "\u{BE5E}",
        nfkd: "\u{1107}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BE5F}",
        nfc: "\u{BE5F}",
        nfd: "\u{1107}\u{1175}\u{11C2}",
        nfkc: "\u{BE5F}",
        nfkd: "\u{1107}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BE60}",
        nfc: "\u{BE60}",
        nfd: "\u{1108}\u{1161}",
        nfkc: "\u{BE60}",
        nfkd: "\u{1108}\u{1161}",
    },
    NormalizationTest {
        source: "\u{BE61}",
        nfc: "\u{BE61}",
        nfd: "\u{1108}\u{1161}\u{11A8}",
        nfkc: "\u{BE61}",
        nfkd: "\u{1108}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BE62}",
        nfc: "\u{BE62}",
        nfd: "\u{1108}\u{1161}\u{11A9}",
        nfkc: "\u{BE62}",
        nfkd: "\u{1108}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BE63}",
        nfc: "\u{BE63}",
        nfd: "\u{1108}\u{1161}\u{11AA}",
        nfkc: "\u{BE63}",
        nfkd: "\u{1108}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BE64}",
        nfc: "\u{BE64}",
        nfd: "\u{1108}\u{1161}\u{11AB}",
        nfkc: "\u{BE64}",
        nfkd: "\u{1108}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BE65}",
        nfc: "\u{BE65}",
        nfd: "\u{1108}\u{1161}\u{11AC}",
        nfkc: "\u{BE65}",
        nfkd: "\u{1108}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BE66}",
        nfc: "\u{BE66}",
        nfd: "\u{1108}\u{1161}\u{11AD}",
        nfkc: "\u{BE66}",
        nfkd: "\u{1108}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BE67}",
        nfc: "\u{BE67}",
        nfd: "\u{1108}\u{1161}\u{11AE}",
        nfkc: "\u{BE67}",
        nfkd: "\u{1108}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BE68}",
        nfc: "\u{BE68}",
        nfd: "\u{1108}\u{1161}\u{11AF}",
        nfkc: "\u{BE68}",
        nfkd: "\u{1108}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BE69}",
        nfc: "\u{BE69}",
        nfd: "\u{1108}\u{1161}\u{11B0}",
        nfkc: "\u{BE69}",
        nfkd: "\u{1108}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BE6A}",
        nfc: "\u{BE6A}",
        nfd: "\u{1108}\u{1161}\u{11B1}",
        nfkc: "\u{BE6A}",
        nfkd: "\u{1108}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BE6B}",
        nfc: "\u{BE6B}",
        nfd: "\u{1108}\u{1161}\u{11B2}",
        nfkc: "\u{BE6B}",
        nfkd: "\u{1108}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BE6C}",
        nfc: "\u{BE6C}",
        nfd: "\u{1108}\u{1161}\u{11B3}",
        nfkc: "\u{BE6C}",
        nfkd: "\u{1108}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BE6D}",
        nfc: "\u{BE6D}",
        nfd: "\u{1108}\u{1161}\u{11B4}",
        nfkc: "\u{BE6D}",
        nfkd: "\u{1108}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BE6E}",
        nfc: "\u{BE6E}",
        nfd: "\u{1108}\u{1161}\u{11B5}",
        nfkc: "\u{BE6E}",
        nfkd: "\u{1108}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BE6F}",
        nfc: "\u{BE6F}",
        nfd: "\u{1108}\u{1161}\u{11B6}",
        nfkc: "\u{BE6F}",
        nfkd: "\u{1108}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BE70}",
        nfc: "\u{BE70}",
        nfd: "\u{1108}\u{1161}\u{11B7}",
        nfkc: "\u{BE70}",
        nfkd: "\u{1108}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BE71}",
        nfc: "\u{BE71}",
        nfd: "\u{1108}\u{1161}\u{11B8}",
        nfkc: "\u{BE71}",
        nfkd: "\u{1108}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BE72}",
        nfc: "\u{BE72}",
        nfd: "\u{1108}\u{1161}\u{11B9}",
        nfkc: "\u{BE72}",
        nfkd: "\u{1108}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BE73}",
        nfc: "\u{BE73}",
        nfd: "\u{1108}\u{1161}\u{11BA}",
        nfkc: "\u{BE73}",
        nfkd: "\u{1108}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BE74}",
        nfc: "\u{BE74}",
        nfd: "\u{1108}\u{1161}\u{11BB}",
        nfkc: "\u{BE74}",
        nfkd: "\u{1108}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BE75}",
        nfc: "\u{BE75}",
        nfd: "\u{1108}\u{1161}\u{11BC}",
        nfkc: "\u{BE75}",
        nfkd: "\u{1108}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BE76}",
        nfc: "\u{BE76}",
        nfd: "\u{1108}\u{1161}\u{11BD}",
        nfkc: "\u{BE76}",
        nfkd: "\u{1108}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BE77}",
        nfc: "\u{BE77}",
        nfd: "\u{1108}\u{1161}\u{11BE}",
        nfkc: "\u{BE77}",
        nfkd: "\u{1108}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BE78}",
        nfc: "\u{BE78}",
        nfd: "\u{1108}\u{1161}\u{11BF}",
        nfkc: "\u{BE78}",
        nfkd: "\u{1108}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BE79}",
        nfc: "\u{BE79}",
        nfd: "\u{1108}\u{1161}\u{11C0}",
        nfkc: "\u{BE79}",
        nfkd: "\u{1108}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BE7A}",
        nfc: "\u{BE7A}",
        nfd: "\u{1108}\u{1161}\u{11C1}",
        nfkc: "\u{BE7A}",
        nfkd: "\u{1108}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BE7B}",
        nfc: "\u{BE7B}",
        nfd: "\u{1108}\u{1161}\u{11C2}",
        nfkc: "\u{BE7B}",
        nfkd: "\u{1108}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BE7C}",
        nfc: "\u{BE7C}",
        nfd: "\u{1108}\u{1162}",
        nfkc: "\u{BE7C}",
        nfkd: "\u{1108}\u{1162}",
    },
    NormalizationTest {
        source: "\u{BE7D}",
        nfc: "\u{BE7D}",
        nfd: "\u{1108}\u{1162}\u{11A8}",
        nfkc: "\u{BE7D}",
        nfkd: "\u{1108}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BE7E}",
        nfc: "\u{BE7E}",
        nfd: "\u{1108}\u{1162}\u{11A9}",
        nfkc: "\u{BE7E}",
        nfkd: "\u{1108}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BE7F}",
        nfc: "\u{BE7F}",
        nfd: "\u{1108}\u{1162}\u{11AA}",
        nfkc: "\u{BE7F}",
        nfkd: "\u{1108}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BE80}",
        nfc: "\u{BE80}",
        nfd: "\u{1108}\u{1162}\u{11AB}",
        nfkc: "\u{BE80}",
        nfkd: "\u{1108}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BE81}",
        nfc: "\u{BE81}",
        nfd: "\u{1108}\u{1162}\u{11AC}",
        nfkc: "\u{BE81}",
        nfkd: "\u{1108}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BE82}",
        nfc: "\u{BE82}",
        nfd: "\u{1108}\u{1162}\u{11AD}",
        nfkc: "\u{BE82}",
        nfkd: "\u{1108}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BE83}",
        nfc: "\u{BE83}",
        nfd: "\u{1108}\u{1162}\u{11AE}",
        nfkc: "\u{BE83}",
        nfkd: "\u{1108}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BE84}",
        nfc: "\u{BE84}",
        nfd: "\u{1108}\u{1162}\u{11AF}",
        nfkc: "\u{BE84}",
        nfkd: "\u{1108}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BE85}",
        nfc: "\u{BE85}",
        nfd: "\u{1108}\u{1162}\u{11B0}",
        nfkc: "\u{BE85}",
        nfkd: "\u{1108}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BE86}",
        nfc: "\u{BE86}",
        nfd: "\u{1108}\u{1162}\u{11B1}",
        nfkc: "\u{BE86}",
        nfkd: "\u{1108}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BE87}",
        nfc: "\u{BE87}",
        nfd: "\u{1108}\u{1162}\u{11B2}",
        nfkc: "\u{BE87}",
        nfkd: "\u{1108}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BE88}",
        nfc: "\u{BE88}",
        nfd: "\u{1108}\u{1162}\u{11B3}",
        nfkc: "\u{BE88}",
        nfkd: "\u{1108}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BE89}",
        nfc: "\u{BE89}",
        nfd: "\u{1108}\u{1162}\u{11B4}",
        nfkc: "\u{BE89}",
        nfkd: "\u{1108}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BE8A}",
        nfc: "\u{BE8A}",
        nfd: "\u{1108}\u{1162}\u{11B5}",
        nfkc: "\u{BE8A}",
        nfkd: "\u{1108}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BE8B}",
        nfc: "\u{BE8B}",
        nfd: "\u{1108}\u{1162}\u{11B6}",
        nfkc: "\u{BE8B}",
        nfkd: "\u{1108}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BE8C}",
        nfc: "\u{BE8C}",
        nfd: "\u{1108}\u{1162}\u{11B7}",
        nfkc: "\u{BE8C}",
        nfkd: "\u{1108}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BE8D}",
        nfc: "\u{BE8D}",
        nfd: "\u{1108}\u{1162}\u{11B8}",
        nfkc: "\u{BE8D}",
        nfkd: "\u{1108}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BE8E}",
        nfc: "\u{BE8E}",
        nfd: "\u{1108}\u{1162}\u{11B9}",
        nfkc: "\u{BE8E}",
        nfkd: "\u{1108}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BE8F}",
        nfc: "\u{BE8F}",
        nfd: "\u{1108}\u{1162}\u{11BA}",
        nfkc: "\u{BE8F}",
        nfkd: "\u{1108}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BE90}",
        nfc: "\u{BE90}",
        nfd: "\u{1108}\u{1162}\u{11BB}",
        nfkc: "\u{BE90}",
        nfkd: "\u{1108}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BE91}",
        nfc: "\u{BE91}",
        nfd: "\u{1108}\u{1162}\u{11BC}",
        nfkc: "\u{BE91}",
        nfkd: "\u{1108}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BE92}",
        nfc: "\u{BE92}",
        nfd: "\u{1108}\u{1162}\u{11BD}",
        nfkc: "\u{BE92}",
        nfkd: "\u{1108}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BE93}",
        nfc: "\u{BE93}",
        nfd: "\u{1108}\u{1162}\u{11BE}",
        nfkc: "\u{BE93}",
        nfkd: "\u{1108}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BE94}",
        nfc: "\u{BE94}",
        nfd: "\u{1108}\u{1162}\u{11BF}",
        nfkc: "\u{BE94}",
        nfkd: "\u{1108}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BE95}",
        nfc: "\u{BE95}",
        nfd: "\u{1108}\u{1162}\u{11C0}",
        nfkc: "\u{BE95}",
        nfkd: "\u{1108}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BE96}",
        nfc: "\u{BE96}",
        nfd: "\u{1108}\u{1162}\u{11C1}",
        nfkc: "\u{BE96}",
        nfkd: "\u{1108}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BE97}",
        nfc: "\u{BE97}",
        nfd: "\u{1108}\u{1162}\u{11C2}",
        nfkc: "\u{BE97}",
        nfkd: "\u{1108}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BE98}",
        nfc: "\u{BE98}",
        nfd: "\u{1108}\u{1163}",
        nfkc: "\u{BE98}",
        nfkd: "\u{1108}\u{1163}",
    },
    NormalizationTest {
        source: "\u{BE99}",
        nfc: "\u{BE99}",
        nfd: "\u{1108}\u{1163}\u{11A8}",
        nfkc: "\u{BE99}",
        nfkd: "\u{1108}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BE9A}",
        nfc: "\u{BE9A}",
        nfd: "\u{1108}\u{1163}\u{11A9}",
        nfkc: "\u{BE9A}",
        nfkd: "\u{1108}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BE9B}",
        nfc: "\u{BE9B}",
        nfd: "\u{1108}\u{1163}\u{11AA}",
        nfkc: "\u{BE9B}",
        nfkd: "\u{1108}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BE9C}",
        nfc: "\u{BE9C}",
        nfd: "\u{1108}\u{1163}\u{11AB}",
        nfkc: "\u{BE9C}",
        nfkd: "\u{1108}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BE9D}",
        nfc: "\u{BE9D}",
        nfd: "\u{1108}\u{1163}\u{11AC}",
        nfkc: "\u{BE9D}",
        nfkd: "\u{1108}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BE9E}",
        nfc: "\u{BE9E}",
        nfd: "\u{1108}\u{1163}\u{11AD}",
        nfkc: "\u{BE9E}",
        nfkd: "\u{1108}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BE9F}",
        nfc: "\u{BE9F}",
        nfd: "\u{1108}\u{1163}\u{11AE}",
        nfkc: "\u{BE9F}",
        nfkd: "\u{1108}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BEA0}",
        nfc: "\u{BEA0}",
        nfd: "\u{1108}\u{1163}\u{11AF}",
        nfkc: "\u{BEA0}",
        nfkd: "\u{1108}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BEA1}",
        nfc: "\u{BEA1}",
        nfd: "\u{1108}\u{1163}\u{11B0}",
        nfkc: "\u{BEA1}",
        nfkd: "\u{1108}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BEA2}",
        nfc: "\u{BEA2}",
        nfd: "\u{1108}\u{1163}\u{11B1}",
        nfkc: "\u{BEA2}",
        nfkd: "\u{1108}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BEA3}",
        nfc: "\u{BEA3}",
        nfd: "\u{1108}\u{1163}\u{11B2}",
        nfkc: "\u{BEA3}",
        nfkd: "\u{1108}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BEA4}",
        nfc: "\u{BEA4}",
        nfd: "\u{1108}\u{1163}\u{11B3}",
        nfkc: "\u{BEA4}",
        nfkd: "\u{1108}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BEA5}",
        nfc: "\u{BEA5}",
        nfd: "\u{1108}\u{1163}\u{11B4}",
        nfkc: "\u{BEA5}",
        nfkd: "\u{1108}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BEA6}",
        nfc: "\u{BEA6}",
        nfd: "\u{1108}\u{1163}\u{11B5}",
        nfkc: "\u{BEA6}",
        nfkd: "\u{1108}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BEA7}",
        nfc: "\u{BEA7}",
        nfd: "\u{1108}\u{1163}\u{11B6}",
        nfkc: "\u{BEA7}",
        nfkd: "\u{1108}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BEA8}",
        nfc: "\u{BEA8}",
        nfd: "\u{1108}\u{1163}\u{11B7}",
        nfkc: "\u{BEA8}",
        nfkd: "\u{1108}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BEA9}",
        nfc: "\u{BEA9}",
        nfd: "\u{1108}\u{1163}\u{11B8}",
        nfkc: "\u{BEA9}",
        nfkd: "\u{1108}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BEAA}",
        nfc: "\u{BEAA}",
        nfd: "\u{1108}\u{1163}\u{11B9}",
        nfkc: "\u{BEAA}",
        nfkd: "\u{1108}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BEAB}",
        nfc: "\u{BEAB}",
        nfd: "\u{1108}\u{1163}\u{11BA}",
        nfkc: "\u{BEAB}",
        nfkd: "\u{1108}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BEAC}",
        nfc: "\u{BEAC}",
        nfd: "\u{1108}\u{1163}\u{11BB}",
        nfkc: "\u{BEAC}",
        nfkd: "\u{1108}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BEAD}",
        nfc: "\u{BEAD}",
        nfd: "\u{1108}\u{1163}\u{11BC}",
        nfkc: "\u{BEAD}",
        nfkd: "\u{1108}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BEAE}",
        nfc: "\u{BEAE}",
        nfd: "\u{1108}\u{1163}\u{11BD}",
        nfkc: "\u{BEAE}",
        nfkd: "\u{1108}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BEAF}",
        nfc: "\u{BEAF}",
        nfd: "\u{1108}\u{1163}\u{11BE}",
        nfkc: "\u{BEAF}",
        nfkd: "\u{1108}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BEB0}",
        nfc: "\u{BEB0}",
        nfd: "\u{1108}\u{1163}\u{11BF}",
        nfkc: "\u{BEB0}",
        nfkd: "\u{1108}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BEB1}",
        nfc: "\u{BEB1}",
        nfd: "\u{1108}\u{1163}\u{11C0}",
        nfkc: "\u{BEB1}",
        nfkd: "\u{1108}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BEB2}",
        nfc: "\u{BEB2}",
        nfd: "\u{1108}\u{1163}\u{11C1}",
        nfkc: "\u{BEB2}",
        nfkd: "\u{1108}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BEB3}",
        nfc: "\u{BEB3}",
        nfd: "\u{1108}\u{1163}\u{11C2}",
        nfkc: "\u{BEB3}",
        nfkd: "\u{1108}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BEB4}",
        nfc: "\u{BEB4}",
        nfd: "\u{1108}\u{1164}",
        nfkc: "\u{BEB4}",
        nfkd: "\u{1108}\u{1164}",
    },
    NormalizationTest {
        source: "\u{BEB5}",
        nfc: "\u{BEB5}",
        nfd: "\u{1108}\u{1164}\u{11A8}",
        nfkc: "\u{BEB5}",
        nfkd: "\u{1108}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BEB6}",
        nfc: "\u{BEB6}",
        nfd: "\u{1108}\u{1164}\u{11A9}",
        nfkc: "\u{BEB6}",
        nfkd: "\u{1108}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BEB7}",
        nfc: "\u{BEB7}",
        nfd: "\u{1108}\u{1164}\u{11AA}",
        nfkc: "\u{BEB7}",
        nfkd: "\u{1108}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BEB8}",
        nfc: "\u{BEB8}",
        nfd: "\u{1108}\u{1164}\u{11AB}",
        nfkc: "\u{BEB8}",
        nfkd: "\u{1108}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BEB9}",
        nfc: "\u{BEB9}",
        nfd: "\u{1108}\u{1164}\u{11AC}",
        nfkc: "\u{BEB9}",
        nfkd: "\u{1108}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BEBA}",
        nfc: "\u{BEBA}",
        nfd: "\u{1108}\u{1164}\u{11AD}",
        nfkc: "\u{BEBA}",
        nfkd: "\u{1108}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BEBB}",
        nfc: "\u{BEBB}",
        nfd: "\u{1108}\u{1164}\u{11AE}",
        nfkc: "\u{BEBB}",
        nfkd: "\u{1108}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BEBC}",
        nfc: "\u{BEBC}",
        nfd: "\u{1108}\u{1164}\u{11AF}",
        nfkc: "\u{BEBC}",
        nfkd: "\u{1108}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BEBD}",
        nfc: "\u{BEBD}",
        nfd: "\u{1108}\u{1164}\u{11B0}",
        nfkc: "\u{BEBD}",
        nfkd: "\u{1108}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BEBE}",
        nfc: "\u{BEBE}",
        nfd: "\u{1108}\u{1164}\u{11B1}",
        nfkc: "\u{BEBE}",
        nfkd: "\u{1108}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BEBF}",
        nfc: "\u{BEBF}",
        nfd: "\u{1108}\u{1164}\u{11B2}",
        nfkc: "\u{BEBF}",
        nfkd: "\u{1108}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BEC0}",
        nfc: "\u{BEC0}",
        nfd: "\u{1108}\u{1164}\u{11B3}",
        nfkc: "\u{BEC0}",
        nfkd: "\u{1108}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BEC1}",
        nfc: "\u{BEC1}",
        nfd: "\u{1108}\u{1164}\u{11B4}",
        nfkc: "\u{BEC1}",
        nfkd: "\u{1108}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BEC2}",
        nfc: "\u{BEC2}",
        nfd: "\u{1108}\u{1164}\u{11B5}",
        nfkc: "\u{BEC2}",
        nfkd: "\u{1108}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BEC3}",
        nfc: "\u{BEC3}",
        nfd: "\u{1108}\u{1164}\u{11B6}",
        nfkc: "\u{BEC3}",
        nfkd: "\u{1108}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BEC4}",
        nfc: "\u{BEC4}",
        nfd: "\u{1108}\u{1164}\u{11B7}",
        nfkc: "\u{BEC4}",
        nfkd: "\u{1108}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BEC5}",
        nfc: "\u{BEC5}",
        nfd: "\u{1108}\u{1164}\u{11B8}",
        nfkc: "\u{BEC5}",
        nfkd: "\u{1108}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BEC6}",
        nfc: "\u{BEC6}",
        nfd: "\u{1108}\u{1164}\u{11B9}",
        nfkc: "\u{BEC6}",
        nfkd: "\u{1108}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BEC7}",
        nfc: "\u{BEC7}",
        nfd: "\u{1108}\u{1164}\u{11BA}",
        nfkc: "\u{BEC7}",
        nfkd: "\u{1108}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BEC8}",
        nfc: "\u{BEC8}",
        nfd: "\u{1108}\u{1164}\u{11BB}",
        nfkc: "\u{BEC8}",
        nfkd: "\u{1108}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BEC9}",
        nfc: "\u{BEC9}",
        nfd: "\u{1108}\u{1164}\u{11BC}",
        nfkc: "\u{BEC9}",
        nfkd: "\u{1108}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BECA}",
        nfc: "\u{BECA}",
        nfd: "\u{1108}\u{1164}\u{11BD}",
        nfkc: "\u{BECA}",
        nfkd: "\u{1108}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BECB}",
        nfc: "\u{BECB}",
        nfd: "\u{1108}\u{1164}\u{11BE}",
        nfkc: "\u{BECB}",
        nfkd: "\u{1108}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BECC}",
        nfc: "\u{BECC}",
        nfd: "\u{1108}\u{1164}\u{11BF}",
        nfkc: "\u{BECC}",
        nfkd: "\u{1108}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BECD}",
        nfc: "\u{BECD}",
        nfd: "\u{1108}\u{1164}\u{11C0}",
        nfkc: "\u{BECD}",
        nfkd: "\u{1108}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BECE}",
        nfc: "\u{BECE}",
        nfd: "\u{1108}\u{1164}\u{11C1}",
        nfkc: "\u{BECE}",
        nfkd: "\u{1108}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BECF}",
        nfc: "\u{BECF}",
        nfd: "\u{1108}\u{1164}\u{11C2}",
        nfkc: "\u{BECF}",
        nfkd: "\u{1108}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BED0}",
        nfc: "\u{BED0}",
        nfd: "\u{1108}\u{1165}",
        nfkc: "\u{BED0}",
        nfkd: "\u{1108}\u{1165}",
    },
    NormalizationTest {
        source: "\u{BED1}",
        nfc: "\u{BED1}",
        nfd: "\u{1108}\u{1165}\u{11A8}",
        nfkc: "\u{BED1}",
        nfkd: "\u{1108}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BED2}",
        nfc: "\u{BED2}",
        nfd: "\u{1108}\u{1165}\u{11A9}",
        nfkc: "\u{BED2}",
        nfkd: "\u{1108}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BED3}",
        nfc: "\u{BED3}",
        nfd: "\u{1108}\u{1165}\u{11AA}",
        nfkc: "\u{BED3}",
        nfkd: "\u{1108}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BED4}",
        nfc: "\u{BED4}",
        nfd: "\u{1108}\u{1165}\u{11AB}",
        nfkc: "\u{BED4}",
        nfkd: "\u{1108}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BED5}",
        nfc: "\u{BED5}",
        nfd: "\u{1108}\u{1165}\u{11AC}",
        nfkc: "\u{BED5}",
        nfkd: "\u{1108}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BED6}",
        nfc: "\u{BED6}",
        nfd: "\u{1108}\u{1165}\u{11AD}",
        nfkc: "\u{BED6}",
        nfkd: "\u{1108}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BED7}",
        nfc: "\u{BED7}",
        nfd: "\u{1108}\u{1165}\u{11AE}",
        nfkc: "\u{BED7}",
        nfkd: "\u{1108}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BED8}",
        nfc: "\u{BED8}",
        nfd: "\u{1108}\u{1165}\u{11AF}",
        nfkc: "\u{BED8}",
        nfkd: "\u{1108}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BED9}",
        nfc: "\u{BED9}",
        nfd: "\u{1108}\u{1165}\u{11B0}",
        nfkc: "\u{BED9}",
        nfkd: "\u{1108}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BEDA}",
        nfc: "\u{BEDA}",
        nfd: "\u{1108}\u{1165}\u{11B1}",
        nfkc: "\u{BEDA}",
        nfkd: "\u{1108}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BEDB}",
        nfc: "\u{BEDB}",
        nfd: "\u{1108}\u{1165}\u{11B2}",
        nfkc: "\u{BEDB}",
        nfkd: "\u{1108}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BEDC}",
        nfc: "\u{BEDC}",
        nfd: "\u{1108}\u{1165}\u{11B3}",
        nfkc: "\u{BEDC}",
        nfkd: "\u{1108}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BEDD}",
        nfc: "\u{BEDD}",
        nfd: "\u{1108}\u{1165}\u{11B4}",
        nfkc: "\u{BEDD}",
        nfkd: "\u{1108}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BEDE}",
        nfc: "\u{BEDE}",
        nfd: "\u{1108}\u{1165}\u{11B5}",
        nfkc: "\u{BEDE}",
        nfkd: "\u{1108}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BEDF}",
        nfc: "\u{BEDF}",
        nfd: "\u{1108}\u{1165}\u{11B6}",
        nfkc: "\u{BEDF}",
        nfkd: "\u{1108}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BEE0}",
        nfc: "\u{BEE0}",
        nfd: "\u{1108}\u{1165}\u{11B7}",
        nfkc: "\u{BEE0}",
        nfkd: "\u{1108}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BEE1}",
        nfc: "\u{BEE1}",
        nfd: "\u{1108}\u{1165}\u{11B8}",
        nfkc: "\u{BEE1}",
        nfkd: "\u{1108}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BEE2}",
        nfc: "\u{BEE2}",
        nfd: "\u{1108}\u{1165}\u{11B9}",
        nfkc: "\u{BEE2}",
        nfkd: "\u{1108}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BEE3}",
        nfc: "\u{BEE3}",
        nfd: "\u{1108}\u{1165}\u{11BA}",
        nfkc: "\u{BEE3}",
        nfkd: "\u{1108}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BEE4}",
        nfc: "\u{BEE4}",
        nfd: "\u{1108}\u{1165}\u{11BB}",
        nfkc: "\u{BEE4}",
        nfkd: "\u{1108}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BEE5}",
        nfc: "\u{BEE5}",
        nfd: "\u{1108}\u{1165}\u{11BC}",
        nfkc: "\u{BEE5}",
        nfkd: "\u{1108}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BEE6}",
        nfc: "\u{BEE6}",
        nfd: "\u{1108}\u{1165}\u{11BD}",
        nfkc: "\u{BEE6}",
        nfkd: "\u{1108}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BEE7}",
        nfc: "\u{BEE7}",
        nfd: "\u{1108}\u{1165}\u{11BE}",
        nfkc: "\u{BEE7}",
        nfkd: "\u{1108}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BEE8}",
        nfc: "\u{BEE8}",
        nfd: "\u{1108}\u{1165}\u{11BF}",
        nfkc: "\u{BEE8}",
        nfkd: "\u{1108}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BEE9}",
        nfc: "\u{BEE9}",
        nfd: "\u{1108}\u{1165}\u{11C0}",
        nfkc: "\u{BEE9}",
        nfkd: "\u{1108}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BEEA}",
        nfc: "\u{BEEA}",
        nfd: "\u{1108}\u{1165}\u{11C1}",
        nfkc: "\u{BEEA}",
        nfkd: "\u{1108}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BEEB}",
        nfc: "\u{BEEB}",
        nfd: "\u{1108}\u{1165}\u{11C2}",
        nfkc: "\u{BEEB}",
        nfkd: "\u{1108}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BEEC}",
        nfc: "\u{BEEC}",
        nfd: "\u{1108}\u{1166}",
        nfkc: "\u{BEEC}",
        nfkd: "\u{1108}\u{1166}",
    },
    NormalizationTest {
        source: "\u{BEED}",
        nfc: "\u{BEED}",
        nfd: "\u{1108}\u{1166}\u{11A8}",
        nfkc: "\u{BEED}",
        nfkd: "\u{1108}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BEEE}",
        nfc: "\u{BEEE}",
        nfd: "\u{1108}\u{1166}\u{11A9}",
        nfkc: "\u{BEEE}",
        nfkd: "\u{1108}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BEEF}",
        nfc: "\u{BEEF}",
        nfd: "\u{1108}\u{1166}\u{11AA}",
        nfkc: "\u{BEEF}",
        nfkd: "\u{1108}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BEF0}",
        nfc: "\u{BEF0}",
        nfd: "\u{1108}\u{1166}\u{11AB}",
        nfkc: "\u{BEF0}",
        nfkd: "\u{1108}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BEF1}",
        nfc: "\u{BEF1}",
        nfd: "\u{1108}\u{1166}\u{11AC}",
        nfkc: "\u{BEF1}",
        nfkd: "\u{1108}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BEF2}",
        nfc: "\u{BEF2}",
        nfd: "\u{1108}\u{1166}\u{11AD}",
        nfkc: "\u{BEF2}",
        nfkd: "\u{1108}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BEF3}",
        nfc: "\u{BEF3}",
        nfd: "\u{1108}\u{1166}\u{11AE}",
        nfkc: "\u{BEF3}",
        nfkd: "\u{1108}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BEF4}",
        nfc: "\u{BEF4}",
        nfd: "\u{1108}\u{1166}\u{11AF}",
        nfkc: "\u{BEF4}",
        nfkd: "\u{1108}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BEF5}",
        nfc: "\u{BEF5}",
        nfd: "\u{1108}\u{1166}\u{11B0}",
        nfkc: "\u{BEF5}",
        nfkd: "\u{1108}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BEF6}",
        nfc: "\u{BEF6}",
        nfd: "\u{1108}\u{1166}\u{11B1}",
        nfkc: "\u{BEF6}",
        nfkd: "\u{1108}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BEF7}",
        nfc: "\u{BEF7}",
        nfd: "\u{1108}\u{1166}\u{11B2}",
        nfkc: "\u{BEF7}",
        nfkd: "\u{1108}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BEF8}",
        nfc: "\u{BEF8}",
        nfd: "\u{1108}\u{1166}\u{11B3}",
        nfkc: "\u{BEF8}",
        nfkd: "\u{1108}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BEF9}",
        nfc: "\u{BEF9}",
        nfd: "\u{1108}\u{1166}\u{11B4}",
        nfkc: "\u{BEF9}",
        nfkd: "\u{1108}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BEFA}",
        nfc: "\u{BEFA}",
        nfd: "\u{1108}\u{1166}\u{11B5}",
        nfkc: "\u{BEFA}",
        nfkd: "\u{1108}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BEFB}",
        nfc: "\u{BEFB}",
        nfd: "\u{1108}\u{1166}\u{11B6}",
        nfkc: "\u{BEFB}",
        nfkd: "\u{1108}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BEFC}",
        nfc: "\u{BEFC}",
        nfd: "\u{1108}\u{1166}\u{11B7}",
        nfkc: "\u{BEFC}",
        nfkd: "\u{1108}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BEFD}",
        nfc: "\u{BEFD}",
        nfd: "\u{1108}\u{1166}\u{11B8}",
        nfkc: "\u{BEFD}",
        nfkd: "\u{1108}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BEFE}",
        nfc: "\u{BEFE}",
        nfd: "\u{1108}\u{1166}\u{11B9}",
        nfkc: "\u{BEFE}",
        nfkd: "\u{1108}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BEFF}",
        nfc: "\u{BEFF}",
        nfd: "\u{1108}\u{1166}\u{11BA}",
        nfkc: "\u{BEFF}",
        nfkd: "\u{1108}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BF00}",
        nfc: "\u{BF00}",
        nfd: "\u{1108}\u{1166}\u{11BB}",
        nfkc: "\u{BF00}",
        nfkd: "\u{1108}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BF01}",
        nfc: "\u{BF01}",
        nfd: "\u{1108}\u{1166}\u{11BC}",
        nfkc: "\u{BF01}",
        nfkd: "\u{1108}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BF02}",
        nfc: "\u{BF02}",
        nfd: "\u{1108}\u{1166}\u{11BD}",
        nfkc: "\u{BF02}",
        nfkd: "\u{1108}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BF03}",
        nfc: "\u{BF03}",
        nfd: "\u{1108}\u{1166}\u{11BE}",
        nfkc: "\u{BF03}",
        nfkd: "\u{1108}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BF04}",
        nfc: "\u{BF04}",
        nfd: "\u{1108}\u{1166}\u{11BF}",
        nfkc: "\u{BF04}",
        nfkd: "\u{1108}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BF05}",
        nfc: "\u{BF05}",
        nfd: "\u{1108}\u{1166}\u{11C0}",
        nfkc: "\u{BF05}",
        nfkd: "\u{1108}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BF06}",
        nfc: "\u{BF06}",
        nfd: "\u{1108}\u{1166}\u{11C1}",
        nfkc: "\u{BF06}",
        nfkd: "\u{1108}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BF07}",
        nfc: "\u{BF07}",
        nfd: "\u{1108}\u{1166}\u{11C2}",
        nfkc: "\u{BF07}",
        nfkd: "\u{1108}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BF08}",
        nfc: "\u{BF08}",
        nfd: "\u{1108}\u{1167}",
        nfkc: "\u{BF08}",
        nfkd: "\u{1108}\u{1167}",
    },
    NormalizationTest {
        source: "\u{BF09}",
        nfc: "\u{BF09}",
        nfd: "\u{1108}\u{1167}\u{11A8}",
        nfkc: "\u{BF09}",
        nfkd: "\u{1108}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BF0A}",
        nfc: "\u{BF0A}",
        nfd: "\u{1108}\u{1167}\u{11A9}",
        nfkc: "\u{BF0A}",
        nfkd: "\u{1108}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BF0B}",
        nfc: "\u{BF0B}",
        nfd: "\u{1108}\u{1167}\u{11AA}",
        nfkc: "\u{BF0B}",
        nfkd: "\u{1108}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BF0C}",
        nfc: "\u{BF0C}",
        nfd: "\u{1108}\u{1167}\u{11AB}",
        nfkc: "\u{BF0C}",
        nfkd: "\u{1108}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BF0D}",
        nfc: "\u{BF0D}",
        nfd: "\u{1108}\u{1167}\u{11AC}",
        nfkc: "\u{BF0D}",
        nfkd: "\u{1108}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BF0E}",
        nfc: "\u{BF0E}",
        nfd: "\u{1108}\u{1167}\u{11AD}",
        nfkc: "\u{BF0E}",
        nfkd: "\u{1108}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BF0F}",
        nfc: "\u{BF0F}",
        nfd: "\u{1108}\u{1167}\u{11AE}",
        nfkc: "\u{BF0F}",
        nfkd: "\u{1108}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BF10}",
        nfc: "\u{BF10}",
        nfd: "\u{1108}\u{1167}\u{11AF}",
        nfkc: "\u{BF10}",
        nfkd: "\u{1108}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BF11}",
        nfc: "\u{BF11}",
        nfd: "\u{1108}\u{1167}\u{11B0}",
        nfkc: "\u{BF11}",
        nfkd: "\u{1108}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BF12}",
        nfc: "\u{BF12}",
        nfd: "\u{1108}\u{1167}\u{11B1}",
        nfkc: "\u{BF12}",
        nfkd: "\u{1108}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BF13}",
        nfc: "\u{BF13}",
        nfd: "\u{1108}\u{1167}\u{11B2}",
        nfkc: "\u{BF13}",
        nfkd: "\u{1108}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BF14}",
        nfc: "\u{BF14}",
        nfd: "\u{1108}\u{1167}\u{11B3}",
        nfkc: "\u{BF14}",
        nfkd: "\u{1108}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BF15}",
        nfc: "\u{BF15}",
        nfd: "\u{1108}\u{1167}\u{11B4}",
        nfkc: "\u{BF15}",
        nfkd: "\u{1108}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BF16}",
        nfc: "\u{BF16}",
        nfd: "\u{1108}\u{1167}\u{11B5}",
        nfkc: "\u{BF16}",
        nfkd: "\u{1108}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BF17}",
        nfc: "\u{BF17}",
        nfd: "\u{1108}\u{1167}\u{11B6}",
        nfkc: "\u{BF17}",
        nfkd: "\u{1108}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BF18}",
        nfc: "\u{BF18}",
        nfd: "\u{1108}\u{1167}\u{11B7}",
        nfkc: "\u{BF18}",
        nfkd: "\u{1108}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BF19}",
        nfc: "\u{BF19}",
        nfd: "\u{1108}\u{1167}\u{11B8}",
        nfkc: "\u{BF19}",
        nfkd: "\u{1108}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BF1A}",
        nfc: "\u{BF1A}",
        nfd: "\u{1108}\u{1167}\u{11B9}",
        nfkc: "\u{BF1A}",
        nfkd: "\u{1108}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BF1B}",
        nfc: "\u{BF1B}",
        nfd: "\u{1108}\u{1167}\u{11BA}",
        nfkc: "\u{BF1B}",
        nfkd: "\u{1108}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BF1C}",
        nfc: "\u{BF1C}",
        nfd: "\u{1108}\u{1167}\u{11BB}",
        nfkc: "\u{BF1C}",
        nfkd: "\u{1108}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BF1D}",
        nfc: "\u{BF1D}",
        nfd: "\u{1108}\u{1167}\u{11BC}",
        nfkc: "\u{BF1D}",
        nfkd: "\u{1108}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BF1E}",
        nfc: "\u{BF1E}",
        nfd: "\u{1108}\u{1167}\u{11BD}",
        nfkc: "\u{BF1E}",
        nfkd: "\u{1108}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BF1F}",
        nfc: "\u{BF1F}",
        nfd: "\u{1108}\u{1167}\u{11BE}",
        nfkc: "\u{BF1F}",
        nfkd: "\u{1108}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BF20}",
        nfc: "\u{BF20}",
        nfd: "\u{1108}\u{1167}\u{11BF}",
        nfkc: "\u{BF20}",
        nfkd: "\u{1108}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BF21}",
        nfc: "\u{BF21}",
        nfd: "\u{1108}\u{1167}\u{11C0}",
        nfkc: "\u{BF21}",
        nfkd: "\u{1108}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BF22}",
        nfc: "\u{BF22}",
        nfd: "\u{1108}\u{1167}\u{11C1}",
        nfkc: "\u{BF22}",
        nfkd: "\u{1108}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BF23}",
        nfc: "\u{BF23}",
        nfd: "\u{1108}\u{1167}\u{11C2}",
        nfkc: "\u{BF23}",
        nfkd: "\u{1108}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BF24}",
        nfc: "\u{BF24}",
        nfd: "\u{1108}\u{1168}",
        nfkc: "\u{BF24}",
        nfkd: "\u{1108}\u{1168}",
    },
    NormalizationTest {
        source: "\u{BF25}",
        nfc: "\u{BF25}",
        nfd: "\u{1108}\u{1168}\u{11A8}",
        nfkc: "\u{BF25}",
        nfkd: "\u{1108}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BF26}",
        nfc: "\u{BF26}",
        nfd: "\u{1108}\u{1168}\u{11A9}",
        nfkc: "\u{BF26}",
        nfkd: "\u{1108}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BF27}",
        nfc: "\u{BF27}",
        nfd: "\u{1108}\u{1168}\u{11AA}",
        nfkc: "\u{BF27}",
        nfkd: "\u{1108}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BF28}",
        nfc: "\u{BF28}",
        nfd: "\u{1108}\u{1168}\u{11AB}",
        nfkc: "\u{BF28}",
        nfkd: "\u{1108}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BF29}",
        nfc: "\u{BF29}",
        nfd: "\u{1108}\u{1168}\u{11AC}",
        nfkc: "\u{BF29}",
        nfkd: "\u{1108}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BF2A}",
        nfc: "\u{BF2A}",
        nfd: "\u{1108}\u{1168}\u{11AD}",
        nfkc: "\u{BF2A}",
        nfkd: "\u{1108}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BF2B}",
        nfc: "\u{BF2B}",
        nfd: "\u{1108}\u{1168}\u{11AE}",
        nfkc: "\u{BF2B}",
        nfkd: "\u{1108}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BF2C}",
        nfc: "\u{BF2C}",
        nfd: "\u{1108}\u{1168}\u{11AF}",
        nfkc: "\u{BF2C}",
        nfkd: "\u{1108}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BF2D}",
        nfc: "\u{BF2D}",
        nfd: "\u{1108}\u{1168}\u{11B0}",
        nfkc: "\u{BF2D}",
        nfkd: "\u{1108}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BF2E}",
        nfc: "\u{BF2E}",
        nfd: "\u{1108}\u{1168}\u{11B1}",
        nfkc: "\u{BF2E}",
        nfkd: "\u{1108}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BF2F}",
        nfc: "\u{BF2F}",
        nfd: "\u{1108}\u{1168}\u{11B2}",
        nfkc: "\u{BF2F}",
        nfkd: "\u{1108}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BF30}",
        nfc: "\u{BF30}",
        nfd: "\u{1108}\u{1168}\u{11B3}",
        nfkc: "\u{BF30}",
        nfkd: "\u{1108}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BF31}",
        nfc: "\u{BF31}",
        nfd: "\u{1108}\u{1168}\u{11B4}",
        nfkc: "\u{BF31}",
        nfkd: "\u{1108}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BF32}",
        nfc: "\u{BF32}",
        nfd: "\u{1108}\u{1168}\u{11B5}",
        nfkc: "\u{BF32}",
        nfkd: "\u{1108}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BF33}",
        nfc: "\u{BF33}",
        nfd: "\u{1108}\u{1168}\u{11B6}",
        nfkc: "\u{BF33}",
        nfkd: "\u{1108}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BF34}",
        nfc: "\u{BF34}",
        nfd: "\u{1108}\u{1168}\u{11B7}",
        nfkc: "\u{BF34}",
        nfkd: "\u{1108}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BF35}",
        nfc: "\u{BF35}",
        nfd: "\u{1108}\u{1168}\u{11B8}",
        nfkc: "\u{BF35}",
        nfkd: "\u{1108}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BF36}",
        nfc: "\u{BF36}",
        nfd: "\u{1108}\u{1168}\u{11B9}",
        nfkc: "\u{BF36}",
        nfkd: "\u{1108}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BF37}",
        nfc: "\u{BF37}",
        nfd: "\u{1108}\u{1168}\u{11BA}",
        nfkc: "\u{BF37}",
        nfkd: "\u{1108}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BF38}",
        nfc: "\u{BF38}",
        nfd: "\u{1108}\u{1168}\u{11BB}",
        nfkc: "\u{BF38}",
        nfkd: "\u{1108}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BF39}",
        nfc: "\u{BF39}",
        nfd: "\u{1108}\u{1168}\u{11BC}",
        nfkc: "\u{BF39}",
        nfkd: "\u{1108}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BF3A}",
        nfc: "\u{BF3A}",
        nfd: "\u{1108}\u{1168}\u{11BD}",
        nfkc: "\u{BF3A}",
        nfkd: "\u{1108}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BF3B}",
        nfc: "\u{BF3B}",
        nfd: "\u{1108}\u{1168}\u{11BE}",
        nfkc: "\u{BF3B}",
        nfkd: "\u{1108}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BF3C}",
        nfc: "\u{BF3C}",
        nfd: "\u{1108}\u{1168}\u{11BF}",
        nfkc: "\u{BF3C}",
        nfkd: "\u{1108}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BF3D}",
        nfc: "\u{BF3D}",
        nfd: "\u{1108}\u{1168}\u{11C0}",
        nfkc: "\u{BF3D}",
        nfkd: "\u{1108}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BF3E}",
        nfc: "\u{BF3E}",
        nfd: "\u{1108}\u{1168}\u{11C1}",
        nfkc: "\u{BF3E}",
        nfkd: "\u{1108}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BF3F}",
        nfc: "\u{BF3F}",
        nfd: "\u{1108}\u{1168}\u{11C2}",
        nfkc: "\u{BF3F}",
        nfkd: "\u{1108}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BF40}",
        nfc: "\u{BF40}",
        nfd: "\u{1108}\u{1169}",
        nfkc: "\u{BF40}",
        nfkd: "\u{1108}\u{1169}",
    },
    NormalizationTest {
        source: "\u{BF41}",
        nfc: "\u{BF41}",
        nfd: "\u{1108}\u{1169}\u{11A8}",
        nfkc: "\u{BF41}",
        nfkd: "\u{1108}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BF42}",
        nfc: "\u{BF42}",
        nfd: "\u{1108}\u{1169}\u{11A9}",
        nfkc: "\u{BF42}",
        nfkd: "\u{1108}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BF43}",
        nfc: "\u{BF43}",
        nfd: "\u{1108}\u{1169}\u{11AA}",
        nfkc: "\u{BF43}",
        nfkd: "\u{1108}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BF44}",
        nfc: "\u{BF44}",
        nfd: "\u{1108}\u{1169}\u{11AB}",
        nfkc: "\u{BF44}",
        nfkd: "\u{1108}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BF45}",
        nfc: "\u{BF45}",
        nfd: "\u{1108}\u{1169}\u{11AC}",
        nfkc: "\u{BF45}",
        nfkd: "\u{1108}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BF46}",
        nfc: "\u{BF46}",
        nfd: "\u{1108}\u{1169}\u{11AD}",
        nfkc: "\u{BF46}",
        nfkd: "\u{1108}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BF47}",
        nfc: "\u{BF47}",
        nfd: "\u{1108}\u{1169}\u{11AE}",
        nfkc: "\u{BF47}",
        nfkd: "\u{1108}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BF48}",
        nfc: "\u{BF48}",
        nfd: "\u{1108}\u{1169}\u{11AF}",
        nfkc: "\u{BF48}",
        nfkd: "\u{1108}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BF49}",
        nfc: "\u{BF49}",
        nfd: "\u{1108}\u{1169}\u{11B0}",
        nfkc: "\u{BF49}",
        nfkd: "\u{1108}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BF4A}",
        nfc: "\u{BF4A}",
        nfd: "\u{1108}\u{1169}\u{11B1}",
        nfkc: "\u{BF4A}",
        nfkd: "\u{1108}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BF4B}",
        nfc: "\u{BF4B}",
        nfd: "\u{1108}\u{1169}\u{11B2}",
        nfkc: "\u{BF4B}",
        nfkd: "\u{1108}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BF4C}",
        nfc: "\u{BF4C}",
        nfd: "\u{1108}\u{1169}\u{11B3}",
        nfkc: "\u{BF4C}",
        nfkd: "\u{1108}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BF4D}",
        nfc: "\u{BF4D}",
        nfd: "\u{1108}\u{1169}\u{11B4}",
        nfkc: "\u{BF4D}",
        nfkd: "\u{1108}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BF4E}",
        nfc: "\u{BF4E}",
        nfd: "\u{1108}\u{1169}\u{11B5}",
        nfkc: "\u{BF4E}",
        nfkd: "\u{1108}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BF4F}",
        nfc: "\u{BF4F}",
        nfd: "\u{1108}\u{1169}\u{11B6}",
        nfkc: "\u{BF4F}",
        nfkd: "\u{1108}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BF50}",
        nfc: "\u{BF50}",
        nfd: "\u{1108}\u{1169}\u{11B7}",
        nfkc: "\u{BF50}",
        nfkd: "\u{1108}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BF51}",
        nfc: "\u{BF51}",
        nfd: "\u{1108}\u{1169}\u{11B8}",
        nfkc: "\u{BF51}",
        nfkd: "\u{1108}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BF52}",
        nfc: "\u{BF52}",
        nfd: "\u{1108}\u{1169}\u{11B9}",
        nfkc: "\u{BF52}",
        nfkd: "\u{1108}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BF53}",
        nfc: "\u{BF53}",
        nfd: "\u{1108}\u{1169}\u{11BA}",
        nfkc: "\u{BF53}",
        nfkd: "\u{1108}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BF54}",
        nfc: "\u{BF54}",
        nfd: "\u{1108}\u{1169}\u{11BB}",
        nfkc: "\u{BF54}",
        nfkd: "\u{1108}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BF55}",
        nfc: "\u{BF55}",
        nfd: "\u{1108}\u{1169}\u{11BC}",
        nfkc: "\u{BF55}",
        nfkd: "\u{1108}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BF56}",
        nfc: "\u{BF56}",
        nfd: "\u{1108}\u{1169}\u{11BD}",
        nfkc: "\u{BF56}",
        nfkd: "\u{1108}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BF57}",
        nfc: "\u{BF57}",
        nfd: "\u{1108}\u{1169}\u{11BE}",
        nfkc: "\u{BF57}",
        nfkd: "\u{1108}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BF58}",
        nfc: "\u{BF58}",
        nfd: "\u{1108}\u{1169}\u{11BF}",
        nfkc: "\u{BF58}",
        nfkd: "\u{1108}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BF59}",
        nfc: "\u{BF59}",
        nfd: "\u{1108}\u{1169}\u{11C0}",
        nfkc: "\u{BF59}",
        nfkd: "\u{1108}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BF5A}",
        nfc: "\u{BF5A}",
        nfd: "\u{1108}\u{1169}\u{11C1}",
        nfkc: "\u{BF5A}",
        nfkd: "\u{1108}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BF5B}",
        nfc: "\u{BF5B}",
        nfd: "\u{1108}\u{1169}\u{11C2}",
        nfkc: "\u{BF5B}",
        nfkd: "\u{1108}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BF5C}",
        nfc: "\u{BF5C}",
        nfd: "\u{1108}\u{116A}",
        nfkc: "\u{BF5C}",
        nfkd: "\u{1108}\u{116A}",
    },
    NormalizationTest {
        source: "\u{BF5D}",
        nfc: "\u{BF5D}",
        nfd: "\u{1108}\u{116A}\u{11A8}",
        nfkc: "\u{BF5D}",
        nfkd: "\u{1108}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BF5E}",
        nfc: "\u{BF5E}",
        nfd: "\u{1108}\u{116A}\u{11A9}",
        nfkc: "\u{BF5E}",
        nfkd: "\u{1108}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BF5F}",
        nfc: "\u{BF5F}",
        nfd: "\u{1108}\u{116A}\u{11AA}",
        nfkc: "\u{BF5F}",
        nfkd: "\u{1108}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BF60}",
        nfc: "\u{BF60}",
        nfd: "\u{1108}\u{116A}\u{11AB}",
        nfkc: "\u{BF60}",
        nfkd: "\u{1108}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BF61}",
        nfc: "\u{BF61}",
        nfd: "\u{1108}\u{116A}\u{11AC}",
        nfkc: "\u{BF61}",
        nfkd: "\u{1108}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BF62}",
        nfc: "\u{BF62}",
        nfd: "\u{1108}\u{116A}\u{11AD}",
        nfkc: "\u{BF62}",
        nfkd: "\u{1108}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BF63}",
        nfc: "\u{BF63}",
        nfd: "\u{1108}\u{116A}\u{11AE}",
        nfkc: "\u{BF63}",
        nfkd: "\u{1108}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BF64}",
        nfc: "\u{BF64}",
        nfd: "\u{1108}\u{116A}\u{11AF}",
        nfkc: "\u{BF64}",
        nfkd: "\u{1108}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BF65}",
        nfc: "\u{BF65}",
        nfd: "\u{1108}\u{116A}\u{11B0}",
        nfkc: "\u{BF65}",
        nfkd: "\u{1108}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BF66}",
        nfc: "\u{BF66}",
        nfd: "\u{1108}\u{116A}\u{11B1}",
        nfkc: "\u{BF66}",
        nfkd: "\u{1108}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BF67}",
        nfc: "\u{BF67}",
        nfd: "\u{1108}\u{116A}\u{11B2}",
        nfkc: "\u{BF67}",
        nfkd: "\u{1108}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BF68}",
        nfc: "\u{BF68}",
        nfd: "\u{1108}\u{116A}\u{11B3}",
        nfkc: "\u{BF68}",
        nfkd: "\u{1108}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BF69}",
        nfc: "\u{BF69}",
        nfd: "\u{1108}\u{116A}\u{11B4}",
        nfkc: "\u{BF69}",
        nfkd: "\u{1108}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BF6A}",
        nfc: "\u{BF6A}",
        nfd: "\u{1108}\u{116A}\u{11B5}",
        nfkc: "\u{BF6A}",
        nfkd: "\u{1108}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BF6B}",
        nfc: "\u{BF6B}",
        nfd: "\u{1108}\u{116A}\u{11B6}",
        nfkc: "\u{BF6B}",
        nfkd: "\u{1108}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BF6C}",
        nfc: "\u{BF6C}",
        nfd: "\u{1108}\u{116A}\u{11B7}",
        nfkc: "\u{BF6C}",
        nfkd: "\u{1108}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BF6D}",
        nfc: "\u{BF6D}",
        nfd: "\u{1108}\u{116A}\u{11B8}",
        nfkc: "\u{BF6D}",
        nfkd: "\u{1108}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BF6E}",
        nfc: "\u{BF6E}",
        nfd: "\u{1108}\u{116A}\u{11B9}",
        nfkc: "\u{BF6E}",
        nfkd: "\u{1108}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BF6F}",
        nfc: "\u{BF6F}",
        nfd: "\u{1108}\u{116A}\u{11BA}",
        nfkc: "\u{BF6F}",
        nfkd: "\u{1108}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BF70}",
        nfc: "\u{BF70}",
        nfd: "\u{1108}\u{116A}\u{11BB}",
        nfkc: "\u{BF70}",
        nfkd: "\u{1108}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BF71}",
        nfc: "\u{BF71}",
        nfd: "\u{1108}\u{116A}\u{11BC}",
        nfkc: "\u{BF71}",
        nfkd: "\u{1108}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BF72}",
        nfc: "\u{BF72}",
        nfd: "\u{1108}\u{116A}\u{11BD}",
        nfkc: "\u{BF72}",
        nfkd: "\u{1108}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BF73}",
        nfc: "\u{BF73}",
        nfd: "\u{1108}\u{116A}\u{11BE}",
        nfkc: "\u{BF73}",
        nfkd: "\u{1108}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BF74}",
        nfc: "\u{BF74}",
        nfd: "\u{1108}\u{116A}\u{11BF}",
        nfkc: "\u{BF74}",
        nfkd: "\u{1108}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BF75}",
        nfc: "\u{BF75}",
        nfd: "\u{1108}\u{116A}\u{11C0}",
        nfkc: "\u{BF75}",
        nfkd: "\u{1108}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BF76}",
        nfc: "\u{BF76}",
        nfd: "\u{1108}\u{116A}\u{11C1}",
        nfkc: "\u{BF76}",
        nfkd: "\u{1108}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BF77}",
        nfc: "\u{BF77}",
        nfd: "\u{1108}\u{116A}\u{11C2}",
        nfkc: "\u{BF77}",
        nfkd: "\u{1108}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BF78}",
        nfc: "\u{BF78}",
        nfd: "\u{1108}\u{116B}",
        nfkc: "\u{BF78}",
        nfkd: "\u{1108}\u{116B}",
    },
    NormalizationTest {
        source: "\u{BF79}",
        nfc: "\u{BF79}",
        nfd: "\u{1108}\u{116B}\u{11A8}",
        nfkc: "\u{BF79}",
        nfkd: "\u{1108}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BF7A}",
        nfc: "\u{BF7A}",
        nfd: "\u{1108}\u{116B}\u{11A9}",
        nfkc: "\u{BF7A}",
        nfkd: "\u{1108}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BF7B}",
        nfc: "\u{BF7B}",
        nfd: "\u{1108}\u{116B}\u{11AA}",
        nfkc: "\u{BF7B}",
        nfkd: "\u{1108}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BF7C}",
        nfc: "\u{BF7C}",
        nfd: "\u{1108}\u{116B}\u{11AB}",
        nfkc: "\u{BF7C}",
        nfkd: "\u{1108}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BF7D}",
        nfc: "\u{BF7D}",
        nfd: "\u{1108}\u{116B}\u{11AC}",
        nfkc: "\u{BF7D}",
        nfkd: "\u{1108}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BF7E}",
        nfc: "\u{BF7E}",
        nfd: "\u{1108}\u{116B}\u{11AD}",
        nfkc: "\u{BF7E}",
        nfkd: "\u{1108}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BF7F}",
        nfc: "\u{BF7F}",
        nfd: "\u{1108}\u{116B}\u{11AE}",
        nfkc: "\u{BF7F}",
        nfkd: "\u{1108}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BF80}",
        nfc: "\u{BF80}",
        nfd: "\u{1108}\u{116B}\u{11AF}",
        nfkc: "\u{BF80}",
        nfkd: "\u{1108}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BF81}",
        nfc: "\u{BF81}",
        nfd: "\u{1108}\u{116B}\u{11B0}",
        nfkc: "\u{BF81}",
        nfkd: "\u{1108}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BF82}",
        nfc: "\u{BF82}",
        nfd: "\u{1108}\u{116B}\u{11B1}",
        nfkc: "\u{BF82}",
        nfkd: "\u{1108}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BF83}",
        nfc: "\u{BF83}",
        nfd: "\u{1108}\u{116B}\u{11B2}",
        nfkc: "\u{BF83}",
        nfkd: "\u{1108}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BF84}",
        nfc: "\u{BF84}",
        nfd: "\u{1108}\u{116B}\u{11B3}",
        nfkc: "\u{BF84}",
        nfkd: "\u{1108}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BF85}",
        nfc: "\u{BF85}",
        nfd: "\u{1108}\u{116B}\u{11B4}",
        nfkc: "\u{BF85}",
        nfkd: "\u{1108}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BF86}",
        nfc: "\u{BF86}",
        nfd: "\u{1108}\u{116B}\u{11B5}",
        nfkc: "\u{BF86}",
        nfkd: "\u{1108}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BF87}",
        nfc: "\u{BF87}",
        nfd: "\u{1108}\u{116B}\u{11B6}",
        nfkc: "\u{BF87}",
        nfkd: "\u{1108}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BF88}",
        nfc: "\u{BF88}",
        nfd: "\u{1108}\u{116B}\u{11B7}",
        nfkc: "\u{BF88}",
        nfkd: "\u{1108}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BF89}",
        nfc: "\u{BF89}",
        nfd: "\u{1108}\u{116B}\u{11B8}",
        nfkc: "\u{BF89}",
        nfkd: "\u{1108}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BF8A}",
        nfc: "\u{BF8A}",
        nfd: "\u{1108}\u{116B}\u{11B9}",
        nfkc: "\u{BF8A}",
        nfkd: "\u{1108}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BF8B}",
        nfc: "\u{BF8B}",
        nfd: "\u{1108}\u{116B}\u{11BA}",
        nfkc: "\u{BF8B}",
        nfkd: "\u{1108}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BF8C}",
        nfc: "\u{BF8C}",
        nfd: "\u{1108}\u{116B}\u{11BB}",
        nfkc: "\u{BF8C}",
        nfkd: "\u{1108}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BF8D}",
        nfc: "\u{BF8D}",
        nfd: "\u{1108}\u{116B}\u{11BC}",
        nfkc: "\u{BF8D}",
        nfkd: "\u{1108}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BF8E}",
        nfc: "\u{BF8E}",
        nfd: "\u{1108}\u{116B}\u{11BD}",
        nfkc: "\u{BF8E}",
        nfkd: "\u{1108}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BF8F}",
        nfc: "\u{BF8F}",
        nfd: "\u{1108}\u{116B}\u{11BE}",
        nfkc: "\u{BF8F}",
        nfkd: "\u{1108}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BF90}",
        nfc: "\u{BF90}",
        nfd: "\u{1108}\u{116B}\u{11BF}",
        nfkc: "\u{BF90}",
        nfkd: "\u{1108}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BF91}",
        nfc: "\u{BF91}",
        nfd: "\u{1108}\u{116B}\u{11C0}",
        nfkc: "\u{BF91}",
        nfkd: "\u{1108}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BF92}",
        nfc: "\u{BF92}",
        nfd: "\u{1108}\u{116B}\u{11C1}",
        nfkc: "\u{BF92}",
        nfkd: "\u{1108}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BF93}",
        nfc: "\u{BF93}",
        nfd: "\u{1108}\u{116B}\u{11C2}",
        nfkc: "\u{BF93}",
        nfkd: "\u{1108}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BF94}",
        nfc: "\u{BF94}",
        nfd: "\u{1108}\u{116C}",
        nfkc: "\u{BF94}",
        nfkd: "\u{1108}\u{116C}",
    },
    NormalizationTest {
        source: "\u{BF95}",
        nfc: "\u{BF95}",
        nfd: "\u{1108}\u{116C}\u{11A8}",
        nfkc: "\u{BF95}",
        nfkd: "\u{1108}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BF96}",
        nfc: "\u{BF96}",
        nfd: "\u{1108}\u{116C}\u{11A9}",
        nfkc: "\u{BF96}",
        nfkd: "\u{1108}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BF97}",
        nfc: "\u{BF97}",
        nfd: "\u{1108}\u{116C}\u{11AA}",
        nfkc: "\u{BF97}",
        nfkd: "\u{1108}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BF98}",
        nfc: "\u{BF98}",
        nfd: "\u{1108}\u{116C}\u{11AB}",
        nfkc: "\u{BF98}",
        nfkd: "\u{1108}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BF99}",
        nfc: "\u{BF99}",
        nfd: "\u{1108}\u{116C}\u{11AC}",
        nfkc: "\u{BF99}",
        nfkd: "\u{1108}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BF9A}",
        nfc: "\u{BF9A}",
        nfd: "\u{1108}\u{116C}\u{11AD}",
        nfkc: "\u{BF9A}",
        nfkd: "\u{1108}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BF9B}",
        nfc: "\u{BF9B}",
        nfd: "\u{1108}\u{116C}\u{11AE}",
        nfkc: "\u{BF9B}",
        nfkd: "\u{1108}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BF9C}",
        nfc: "\u{BF9C}",
        nfd: "\u{1108}\u{116C}\u{11AF}",
        nfkc: "\u{BF9C}",
        nfkd: "\u{1108}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BF9D}",
        nfc: "\u{BF9D}",
        nfd: "\u{1108}\u{116C}\u{11B0}",
        nfkc: "\u{BF9D}",
        nfkd: "\u{1108}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BF9E}",
        nfc: "\u{BF9E}",
        nfd: "\u{1108}\u{116C}\u{11B1}",
        nfkc: "\u{BF9E}",
        nfkd: "\u{1108}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BF9F}",
        nfc: "\u{BF9F}",
        nfd: "\u{1108}\u{116C}\u{11B2}",
        nfkc: "\u{BF9F}",
        nfkd: "\u{1108}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BFA0}",
        nfc: "\u{BFA0}",
        nfd: "\u{1108}\u{116C}\u{11B3}",
        nfkc: "\u{BFA0}",
        nfkd: "\u{1108}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BFA1}",
        nfc: "\u{BFA1}",
        nfd: "\u{1108}\u{116C}\u{11B4}",
        nfkc: "\u{BFA1}",
        nfkd: "\u{1108}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BFA2}",
        nfc: "\u{BFA2}",
        nfd: "\u{1108}\u{116C}\u{11B5}",
        nfkc: "\u{BFA2}",
        nfkd: "\u{1108}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BFA3}",
        nfc: "\u{BFA3}",
        nfd: "\u{1108}\u{116C}\u{11B6}",
        nfkc: "\u{BFA3}",
        nfkd: "\u{1108}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BFA4}",
        nfc: "\u{BFA4}",
        nfd: "\u{1108}\u{116C}\u{11B7}",
        nfkc: "\u{BFA4}",
        nfkd: "\u{1108}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BFA5}",
        nfc: "\u{BFA5}",
        nfd: "\u{1108}\u{116C}\u{11B8}",
        nfkc: "\u{BFA5}",
        nfkd: "\u{1108}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BFA6}",
        nfc: "\u{BFA6}",
        nfd: "\u{1108}\u{116C}\u{11B9}",
        nfkc: "\u{BFA6}",
        nfkd: "\u{1108}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BFA7}",
        nfc: "\u{BFA7}",
        nfd: "\u{1108}\u{116C}\u{11BA}",
        nfkc: "\u{BFA7}",
        nfkd: "\u{1108}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BFA8}",
        nfc: "\u{BFA8}",
        nfd: "\u{1108}\u{116C}\u{11BB}",
        nfkc: "\u{BFA8}",
        nfkd: "\u{1108}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BFA9}",
        nfc: "\u{BFA9}",
        nfd: "\u{1108}\u{116C}\u{11BC}",
        nfkc: "\u{BFA9}",
        nfkd: "\u{1108}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BFAA}",
        nfc: "\u{BFAA}",
        nfd: "\u{1108}\u{116C}\u{11BD}",
        nfkc: "\u{BFAA}",
        nfkd: "\u{1108}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BFAB}",
        nfc: "\u{BFAB}",
        nfd: "\u{1108}\u{116C}\u{11BE}",
        nfkc: "\u{BFAB}",
        nfkd: "\u{1108}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BFAC}",
        nfc: "\u{BFAC}",
        nfd: "\u{1108}\u{116C}\u{11BF}",
        nfkc: "\u{BFAC}",
        nfkd: "\u{1108}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BFAD}",
        nfc: "\u{BFAD}",
        nfd: "\u{1108}\u{116C}\u{11C0}",
        nfkc: "\u{BFAD}",
        nfkd: "\u{1108}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BFAE}",
        nfc: "\u{BFAE}",
        nfd: "\u{1108}\u{116C}\u{11C1}",
        nfkc: "\u{BFAE}",
        nfkd: "\u{1108}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BFAF}",
        nfc: "\u{BFAF}",
        nfd: "\u{1108}\u{116C}\u{11C2}",
        nfkc: "\u{BFAF}",
        nfkd: "\u{1108}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BFB0}",
        nfc: "\u{BFB0}",
        nfd: "\u{1108}\u{116D}",
        nfkc: "\u{BFB0}",
        nfkd: "\u{1108}\u{116D}",
    },
    NormalizationTest {
        source: "\u{BFB1}",
        nfc: "\u{BFB1}",
        nfd: "\u{1108}\u{116D}\u{11A8}",
        nfkc: "\u{BFB1}",
        nfkd: "\u{1108}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BFB2}",
        nfc: "\u{BFB2}",
        nfd: "\u{1108}\u{116D}\u{11A9}",
        nfkc: "\u{BFB2}",
        nfkd: "\u{1108}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BFB3}",
        nfc: "\u{BFB3}",
        nfd: "\u{1108}\u{116D}\u{11AA}",
        nfkc: "\u{BFB3}",
        nfkd: "\u{1108}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BFB4}",
        nfc: "\u{BFB4}",
        nfd: "\u{1108}\u{116D}\u{11AB}",
        nfkc: "\u{BFB4}",
        nfkd: "\u{1108}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BFB5}",
        nfc: "\u{BFB5}",
        nfd: "\u{1108}\u{116D}\u{11AC}",
        nfkc: "\u{BFB5}",
        nfkd: "\u{1108}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BFB6}",
        nfc: "\u{BFB6}",
        nfd: "\u{1108}\u{116D}\u{11AD}",
        nfkc: "\u{BFB6}",
        nfkd: "\u{1108}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BFB7}",
        nfc: "\u{BFB7}",
        nfd: "\u{1108}\u{116D}\u{11AE}",
        nfkc: "\u{BFB7}",
        nfkd: "\u{1108}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BFB8}",
        nfc: "\u{BFB8}",
        nfd: "\u{1108}\u{116D}\u{11AF}",
        nfkc: "\u{BFB8}",
        nfkd: "\u{1108}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BFB9}",
        nfc: "\u{BFB9}",
        nfd: "\u{1108}\u{116D}\u{11B0}",
        nfkc: "\u{BFB9}",
        nfkd: "\u{1108}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BFBA}",
        nfc: "\u{BFBA}",
        nfd: "\u{1108}\u{116D}\u{11B1}",
        nfkc: "\u{BFBA}",
        nfkd: "\u{1108}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BFBB}",
        nfc: "\u{BFBB}",
        nfd: "\u{1108}\u{116D}\u{11B2}",
        nfkc: "\u{BFBB}",
        nfkd: "\u{1108}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BFBC}",
        nfc: "\u{BFBC}",
        nfd: "\u{1108}\u{116D}\u{11B3}",
        nfkc: "\u{BFBC}",
        nfkd: "\u{1108}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BFBD}",
        nfc: "\u{BFBD}",
        nfd: "\u{1108}\u{116D}\u{11B4}",
        nfkc: "\u{BFBD}",
        nfkd: "\u{1108}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BFBE}",
        nfc: "\u{BFBE}",
        nfd: "\u{1108}\u{116D}\u{11B5}",
        nfkc: "\u{BFBE}",
        nfkd: "\u{1108}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BFBF}",
        nfc: "\u{BFBF}",
        nfd: "\u{1108}\u{116D}\u{11B6}",
        nfkc: "\u{BFBF}",
        nfkd: "\u{1108}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BFC0}",
        nfc: "\u{BFC0}",
        nfd: "\u{1108}\u{116D}\u{11B7}",
        nfkc: "\u{BFC0}",
        nfkd: "\u{1108}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BFC1}",
        nfc: "\u{BFC1}",
        nfd: "\u{1108}\u{116D}\u{11B8}",
        nfkc: "\u{BFC1}",
        nfkd: "\u{1108}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BFC2}",
        nfc: "\u{BFC2}",
        nfd: "\u{1108}\u{116D}\u{11B9}",
        nfkc: "\u{BFC2}",
        nfkd: "\u{1108}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BFC3}",
        nfc: "\u{BFC3}",
        nfd: "\u{1108}\u{116D}\u{11BA}",
        nfkc: "\u{BFC3}",
        nfkd: "\u{1108}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BFC4}",
        nfc: "\u{BFC4}",
        nfd: "\u{1108}\u{116D}\u{11BB}",
        nfkc: "\u{BFC4}",
        nfkd: "\u{1108}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BFC5}",
        nfc: "\u{BFC5}",
        nfd: "\u{1108}\u{116D}\u{11BC}",
        nfkc: "\u{BFC5}",
        nfkd: "\u{1108}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BFC6}",
        nfc: "\u{BFC6}",
        nfd: "\u{1108}\u{116D}\u{11BD}",
        nfkc: "\u{BFC6}",
        nfkd: "\u{1108}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BFC7}",
        nfc: "\u{BFC7}",
        nfd: "\u{1108}\u{116D}\u{11BE}",
        nfkc: "\u{BFC7}",
        nfkd: "\u{1108}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BFC8}",
        nfc: "\u{BFC8}",
        nfd: "\u{1108}\u{116D}\u{11BF}",
        nfkc: "\u{BFC8}",
        nfkd: "\u{1108}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BFC9}",
        nfc: "\u{BFC9}",
        nfd: "\u{1108}\u{116D}\u{11C0}",
        nfkc: "\u{BFC9}",
        nfkd: "\u{1108}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BFCA}",
        nfc: "\u{BFCA}",
        nfd: "\u{1108}\u{116D}\u{11C1}",
        nfkc: "\u{BFCA}",
        nfkd: "\u{1108}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BFCB}",
        nfc: "\u{BFCB}",
        nfd: "\u{1108}\u{116D}\u{11C2}",
        nfkc: "\u{BFCB}",
        nfkd: "\u{1108}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BFCC}",
        nfc: "\u{BFCC}",
        nfd: "\u{1108}\u{116E}",
        nfkc: "\u{BFCC}",
        nfkd: "\u{1108}\u{116E}",
    },
    NormalizationTest {
        source: "\u{BFCD}",
        nfc: "\u{BFCD}",
        nfd: "\u{1108}\u{116E}\u{11A8}",
        nfkc: "\u{BFCD}",
        nfkd: "\u{1108}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BFCE}",
        nfc: "\u{BFCE}",
        nfd: "\u{1108}\u{116E}\u{11A9}",
        nfkc: "\u{BFCE}",
        nfkd: "\u{1108}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BFCF}",
        nfc: "\u{BFCF}",
        nfd: "\u{1108}\u{116E}\u{11AA}",
        nfkc: "\u{BFCF}",
        nfkd: "\u{1108}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BFD0}",
        nfc: "\u{BFD0}",
        nfd: "\u{1108}\u{116E}\u{11AB}",
        nfkc: "\u{BFD0}",
        nfkd: "\u{1108}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BFD1}",
        nfc: "\u{BFD1}",
        nfd: "\u{1108}\u{116E}\u{11AC}",
        nfkc: "\u{BFD1}",
        nfkd: "\u{1108}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BFD2}",
        nfc: "\u{BFD2}",
        nfd: "\u{1108}\u{116E}\u{11AD}",
        nfkc: "\u{BFD2}",
        nfkd: "\u{1108}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BFD3}",
        nfc: "\u{BFD3}",
        nfd: "\u{1108}\u{116E}\u{11AE}",
        nfkc: "\u{BFD3}",
        nfkd: "\u{1108}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BFD4}",
        nfc: "\u{BFD4}",
        nfd: "\u{1108}\u{116E}\u{11AF}",
        nfkc: "\u{BFD4}",
        nfkd: "\u{1108}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BFD5}",
        nfc: "\u{BFD5}",
        nfd: "\u{1108}\u{116E}\u{11B0}",
        nfkc: "\u{BFD5}",
        nfkd: "\u{1108}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BFD6}",
        nfc: "\u{BFD6}",
        nfd: "\u{1108}\u{116E}\u{11B1}",
        nfkc: "\u{BFD6}",
        nfkd: "\u{1108}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BFD7}",
        nfc: "\u{BFD7}",
        nfd: "\u{1108}\u{116E}\u{11B2}",
        nfkc: "\u{BFD7}",
        nfkd: "\u{1108}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BFD8}",
        nfc: "\u{BFD8}",
        nfd: "\u{1108}\u{116E}\u{11B3}",
        nfkc: "\u{BFD8}",
        nfkd: "\u{1108}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BFD9}",
        nfc: "\u{BFD9}",
        nfd: "\u{1108}\u{116E}\u{11B4}",
        nfkc: "\u{BFD9}",
        nfkd: "\u{1108}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BFDA}",
        nfc: "\u{BFDA}",
        nfd: "\u{1108}\u{116E}\u{11B5}",
        nfkc: "\u{BFDA}",
        nfkd: "\u{1108}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BFDB}",
        nfc: "\u{BFDB}",
        nfd: "\u{1108}\u{116E}\u{11B6}",
        nfkc: "\u{BFDB}",
        nfkd: "\u{1108}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BFDC}",
        nfc: "\u{BFDC}",
        nfd: "\u{1108}\u{116E}\u{11B7}",
        nfkc: "\u{BFDC}",
        nfkd: "\u{1108}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BFDD}",
        nfc: "\u{BFDD}",
        nfd: "\u{1108}\u{116E}\u{11B8}",
        nfkc: "\u{BFDD}",
        nfkd: "\u{1108}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BFDE}",
        nfc: "\u{BFDE}",
        nfd: "\u{1108}\u{116E}\u{11B9}",
        nfkc: "\u{BFDE}",
        nfkd: "\u{1108}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BFDF}",
        nfc: "\u{BFDF}",
        nfd: "\u{1108}\u{116E}\u{11BA}",
        nfkc: "\u{BFDF}",
        nfkd: "\u{1108}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BFE0}",
        nfc: "\u{BFE0}",
        nfd: "\u{1108}\u{116E}\u{11BB}",
        nfkc: "\u{BFE0}",
        nfkd: "\u{1108}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BFE1}",
        nfc: "\u{BFE1}",
        nfd: "\u{1108}\u{116E}\u{11BC}",
        nfkc: "\u{BFE1}",
        nfkd: "\u{1108}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BFE2}",
        nfc: "\u{BFE2}",
        nfd: "\u{1108}\u{116E}\u{11BD}",
        nfkc: "\u{BFE2}",
        nfkd: "\u{1108}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BFE3}",
        nfc: "\u{BFE3}",
        nfd: "\u{1108}\u{116E}\u{11BE}",
        nfkc: "\u{BFE3}",
        nfkd: "\u{1108}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{BFE4}",
        nfc: "\u{BFE4}",
        nfd: "\u{1108}\u{116E}\u{11BF}",
        nfkc: "\u{BFE4}",
        nfkd: "\u{1108}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{BFE5}",
        nfc: "\u{BFE5}",
        nfd: "\u{1108}\u{116E}\u{11C0}",
        nfkc: "\u{BFE5}",
        nfkd: "\u{1108}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{BFE6}",
        nfc: "\u{BFE6}",
        nfd: "\u{1108}\u{116E}\u{11C1}",
        nfkc: "\u{BFE6}",
        nfkd: "\u{1108}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{BFE7}",
        nfc: "\u{BFE7}",
        nfd: "\u{1108}\u{116E}\u{11C2}",
        nfkc: "\u{BFE7}",
        nfkd: "\u{1108}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{BFE8}",
        nfc: "\u{BFE8}",
        nfd: "\u{1108}\u{116F}",
        nfkc: "\u{BFE8}",
        nfkd: "\u{1108}\u{116F}",
    },
    NormalizationTest {
        source: "\u{BFE9}",
        nfc: "\u{BFE9}",
        nfd: "\u{1108}\u{116F}\u{11A8}",
        nfkc: "\u{BFE9}",
        nfkd: "\u{1108}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{BFEA}",
        nfc: "\u{BFEA}",
        nfd: "\u{1108}\u{116F}\u{11A9}",
        nfkc: "\u{BFEA}",
        nfkd: "\u{1108}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{BFEB}",
        nfc: "\u{BFEB}",
        nfd: "\u{1108}\u{116F}\u{11AA}",
        nfkc: "\u{BFEB}",
        nfkd: "\u{1108}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{BFEC}",
        nfc: "\u{BFEC}",
        nfd: "\u{1108}\u{116F}\u{11AB}",
        nfkc: "\u{BFEC}",
        nfkd: "\u{1108}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{BFED}",
        nfc: "\u{BFED}",
        nfd: "\u{1108}\u{116F}\u{11AC}",
        nfkc: "\u{BFED}",
        nfkd: "\u{1108}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{BFEE}",
        nfc: "\u{BFEE}",
        nfd: "\u{1108}\u{116F}\u{11AD}",
        nfkc: "\u{BFEE}",
        nfkd: "\u{1108}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{BFEF}",
        nfc: "\u{BFEF}",
        nfd: "\u{1108}\u{116F}\u{11AE}",
        nfkc: "\u{BFEF}",
        nfkd: "\u{1108}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BFF0}",
        nfc: "\u{BFF0}",
        nfd: "\u{1108}\u{116F}\u{11AF}",
        nfkc: "\u{BFF0}",
        nfkd: "\u{1108}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{BFF1}",
        nfc: "\u{BFF1}",
        nfd: "\u{1108}\u{116F}\u{11B0}",
        nfkc: "\u{BFF1}",
        nfkd: "\u{1108}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{BFF2}",
        nfc: "\u{BFF2}",
        nfd: "\u{1108}\u{116F}\u{11B1}",
        nfkc: "\u{BFF2}",
        nfkd: "\u{1108}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{BFF3}",
        nfc: "\u{BFF3}",
        nfd: "\u{1108}\u{116F}\u{11B2}",
        nfkc: "\u{BFF3}",
        nfkd: "\u{1108}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{BFF4}",
        nfc: "\u{BFF4}",
        nfd: "\u{1108}\u{116F}\u{11B3}",
        nfkc: "\u{BFF4}",
        nfkd: "\u{1108}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{BFF5}",
        nfc: "\u{BFF5}",
        nfd: "\u{1108}\u{116F}\u{11B4}",
        nfkc: "\u{BFF5}",
        nfkd: "\u{1108}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{BFF6}",
        nfc: "\u{BFF6}",
        nfd: "\u{1108}\u{116F}\u{11B5}",
        nfkc: "\u{BFF6}",
        nfkd: "\u{1108}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BFF7}",
        nfc: "\u{BFF7}",
        nfd: "\u{1108}\u{116F}\u{11B6}",
        nfkc: "\u{BFF7}",
        nfkd: "\u{1108}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{BFF8}",
        nfc: "\u{BFF8}",
        nfd: "\u{1108}\u{116F}\u{11B7}",
        nfkc: "\u{BFF8}",
        nfkd: "\u{1108}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{BFF9}",
        nfc: "\u{BFF9}",
        nfd: "\u{1108}\u{116F}\u{11B8}",
        nfkc: "\u{BFF9}",
        nfkd: "\u{1108}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{BFFA}",
        nfc: "\u{BFFA}",
        nfd: "\u{1108}\u{116F}\u{11B9}",
        nfkc: "\u{BFFA}",
        nfkd: "\u{1108}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{BFFB}",
        nfc: "\u{BFFB}",
        nfd: "\u{1108}\u{116F}\u{11BA}",
        nfkc: "\u{BFFB}",
        nfkd: "\u{1108}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{BFFC}",
        nfc: "\u{BFFC}",
        nfd: "\u{1108}\u{116F}\u{11BB}",
        nfkc: "\u{BFFC}",
        nfkd: "\u{1108}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{BFFD}",
        nfc: "\u{BFFD}",
        nfd: "\u{1108}\u{116F}\u{11BC}",
        nfkc: "\u{BFFD}",
        nfkd: "\u{1108}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BFFE}",
        nfc: "\u{BFFE}",
        nfd: "\u{1108}\u{116F}\u{11BD}",
        nfkc: "\u{BFFE}",
        nfkd: "\u{1108}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{BFFF}",
        nfc: "\u{BFFF}",
        nfd: "\u{1108}\u{116F}\u{11BE}",
        nfkc: "\u{BFFF}",
        nfkd: "\u{1108}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C000}",
        nfc: "\u{C000}",
        nfd: "\u{1108}\u{116F}\u{11BF}",
        nfkc: "\u{C000}",
        nfkd: "\u{1108}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C001}",
        nfc: "\u{C001}",
        nfd: "\u{1108}\u{116F}\u{11C0}",
        nfkc: "\u{C001}",
        nfkd: "\u{1108}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C002}",
        nfc: "\u{C002}",
        nfd: "\u{1108}\u{116F}\u{11C1}",
        nfkc: "\u{C002}",
        nfkd: "\u{1108}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C003}",
        nfc: "\u{C003}",
        nfd: "\u{1108}\u{116F}\u{11C2}",
        nfkc: "\u{C003}",
        nfkd: "\u{1108}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C004}",
        nfc: "\u{C004}",
        nfd: "\u{1108}\u{1170}",
        nfkc: "\u{C004}",
        nfkd: "\u{1108}\u{1170}",
    },
    NormalizationTest {
        source: "\u{C005}",
        nfc: "\u{C005}",
        nfd: "\u{1108}\u{1170}\u{11A8}",
        nfkc: "\u{C005}",
        nfkd: "\u{1108}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C006}",
        nfc: "\u{C006}",
        nfd: "\u{1108}\u{1170}\u{11A9}",
        nfkc: "\u{C006}",
        nfkd: "\u{1108}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C007}",
        nfc: "\u{C007}",
        nfd: "\u{1108}\u{1170}\u{11AA}",
        nfkc: "\u{C007}",
        nfkd: "\u{1108}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C008}",
        nfc: "\u{C008}",
        nfd: "\u{1108}\u{1170}\u{11AB}",
        nfkc: "\u{C008}",
        nfkd: "\u{1108}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C009}",
        nfc: "\u{C009}",
        nfd: "\u{1108}\u{1170}\u{11AC}",
        nfkc: "\u{C009}",
        nfkd: "\u{1108}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C00A}",
        nfc: "\u{C00A}",
        nfd: "\u{1108}\u{1170}\u{11AD}",
        nfkc: "\u{C00A}",
        nfkd: "\u{1108}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C00B}",
        nfc: "\u{C00B}",
        nfd: "\u{1108}\u{1170}\u{11AE}",
        nfkc: "\u{C00B}",
        nfkd: "\u{1108}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C00C}",
        nfc: "\u{C00C}",
        nfd: "\u{1108}\u{1170}\u{11AF}",
        nfkc: "\u{C00C}",
        nfkd: "\u{1108}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C00D}",
        nfc: "\u{C00D}",
        nfd: "\u{1108}\u{1170}\u{11B0}",
        nfkc: "\u{C00D}",
        nfkd: "\u{1108}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C00E}",
        nfc: "\u{C00E}",
        nfd: "\u{1108}\u{1170}\u{11B1}",
        nfkc: "\u{C00E}",
        nfkd: "\u{1108}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C00F}",
        nfc: "\u{C00F}",
        nfd: "\u{1108}\u{1170}\u{11B2}",
        nfkc: "\u{C00F}",
        nfkd: "\u{1108}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C010}",
        nfc: "\u{C010}",
        nfd: "\u{1108}\u{1170}\u{11B3}",
        nfkc: "\u{C010}",
        nfkd: "\u{1108}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C011}",
        nfc: "\u{C011}",
        nfd: "\u{1108}\u{1170}\u{11B4}",
        nfkc: "\u{C011}",
        nfkd: "\u{1108}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C012}",
        nfc: "\u{C012}",
        nfd: "\u{1108}\u{1170}\u{11B5}",
        nfkc: "\u{C012}",
        nfkd: "\u{1108}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C013}",
        nfc: "\u{C013}",
        nfd: "\u{1108}\u{1170}\u{11B6}",
        nfkc: "\u{C013}",
        nfkd: "\u{1108}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C014}",
        nfc: "\u{C014}",
        nfd: "\u{1108}\u{1170}\u{11B7}",
        nfkc: "\u{C014}",
        nfkd: "\u{1108}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C015}",
        nfc: "\u{C015}",
        nfd: "\u{1108}\u{1170}\u{11B8}",
        nfkc: "\u{C015}",
        nfkd: "\u{1108}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C016}",
        nfc: "\u{C016}",
        nfd: "\u{1108}\u{1170}\u{11B9}",
        nfkc: "\u{C016}",
        nfkd: "\u{1108}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C017}",
        nfc: "\u{C017}",
        nfd: "\u{1108}\u{1170}\u{11BA}",
        nfkc: "\u{C017}",
        nfkd: "\u{1108}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C018}",
        nfc: "\u{C018}",
        nfd: "\u{1108}\u{1170}\u{11BB}",
        nfkc: "\u{C018}",
        nfkd: "\u{1108}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C019}",
        nfc: "\u{C019}",
        nfd: "\u{1108}\u{1170}\u{11BC}",
        nfkc: "\u{C019}",
        nfkd: "\u{1108}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C01A}",
        nfc: "\u{C01A}",
        nfd: "\u{1108}\u{1170}\u{11BD}",
        nfkc: "\u{C01A}",
        nfkd: "\u{1108}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C01B}",
        nfc: "\u{C01B}",
        nfd: "\u{1108}\u{1170}\u{11BE}",
        nfkc: "\u{C01B}",
        nfkd: "\u{1108}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C01C}",
        nfc: "\u{C01C}",
        nfd: "\u{1108}\u{1170}\u{11BF}",
        nfkc: "\u{C01C}",
        nfkd: "\u{1108}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C01D}",
        nfc: "\u{C01D}",
        nfd: "\u{1108}\u{1170}\u{11C0}",
        nfkc: "\u{C01D}",
        nfkd: "\u{1108}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C01E}",
        nfc: "\u{C01E}",
        nfd: "\u{1108}\u{1170}\u{11C1}",
        nfkc: "\u{C01E}",
        nfkd: "\u{1108}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C01F}",
        nfc: "\u{C01F}",
        nfd: "\u{1108}\u{1170}\u{11C2}",
        nfkc: "\u{C01F}",
        nfkd: "\u{1108}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C020}",
        nfc: "\u{C020}",
        nfd: "\u{1108}\u{1171}",
        nfkc: "\u{C020}",
        nfkd: "\u{1108}\u{1171}",
    },
    NormalizationTest {
        source: "\u{C021}",
        nfc: "\u{C021}",
        nfd: "\u{1108}\u{1171}\u{11A8}",
        nfkc: "\u{C021}",
        nfkd: "\u{1108}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C022}",
        nfc: "\u{C022}",
        nfd: "\u{1108}\u{1171}\u{11A9}",
        nfkc: "\u{C022}",
        nfkd: "\u{1108}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C023}",
        nfc: "\u{C023}",
        nfd: "\u{1108}\u{1171}\u{11AA}",
        nfkc: "\u{C023}",
        nfkd: "\u{1108}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C024}",
        nfc: "\u{C024}",
        nfd: "\u{1108}\u{1171}\u{11AB}",
        nfkc: "\u{C024}",
        nfkd: "\u{1108}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C025}",
        nfc: "\u{C025}",
        nfd: "\u{1108}\u{1171}\u{11AC}",
        nfkc: "\u{C025}",
        nfkd: "\u{1108}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C026}",
        nfc: "\u{C026}",
        nfd: "\u{1108}\u{1171}\u{11AD}",
        nfkc: "\u{C026}",
        nfkd: "\u{1108}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C027}",
        nfc: "\u{C027}",
        nfd: "\u{1108}\u{1171}\u{11AE}",
        nfkc: "\u{C027}",
        nfkd: "\u{1108}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C028}",
        nfc: "\u{C028}",
        nfd: "\u{1108}\u{1171}\u{11AF}",
        nfkc: "\u{C028}",
        nfkd: "\u{1108}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C029}",
        nfc: "\u{C029}",
        nfd: "\u{1108}\u{1171}\u{11B0}",
        nfkc: "\u{C029}",
        nfkd: "\u{1108}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C02A}",
        nfc: "\u{C02A}",
        nfd: "\u{1108}\u{1171}\u{11B1}",
        nfkc: "\u{C02A}",
        nfkd: "\u{1108}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C02B}",
        nfc: "\u{C02B}",
        nfd: "\u{1108}\u{1171}\u{11B2}",
        nfkc: "\u{C02B}",
        nfkd: "\u{1108}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C02C}",
        nfc: "\u{C02C}",
        nfd: "\u{1108}\u{1171}\u{11B3}",
        nfkc: "\u{C02C}",
        nfkd: "\u{1108}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C02D}",
        nfc: "\u{C02D}",
        nfd: "\u{1108}\u{1171}\u{11B4}",
        nfkc: "\u{C02D}",
        nfkd: "\u{1108}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C02E}",
        nfc: "\u{C02E}",
        nfd: "\u{1108}\u{1171}\u{11B5}",
        nfkc: "\u{C02E}",
        nfkd: "\u{1108}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C02F}",
        nfc: "\u{C02F}",
        nfd: "\u{1108}\u{1171}\u{11B6}",
        nfkc: "\u{C02F}",
        nfkd: "\u{1108}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C030}",
        nfc: "\u{C030}",
        nfd: "\u{1108}\u{1171}\u{11B7}",
        nfkc: "\u{C030}",
        nfkd: "\u{1108}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C031}",
        nfc: "\u{C031}",
        nfd: "\u{1108}\u{1171}\u{11B8}",
        nfkc: "\u{C031}",
        nfkd: "\u{1108}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C032}",
        nfc: "\u{C032}",
        nfd: "\u{1108}\u{1171}\u{11B9}",
        nfkc: "\u{C032}",
        nfkd: "\u{1108}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C033}",
        nfc: "\u{C033}",
        nfd: "\u{1108}\u{1171}\u{11BA}",
        nfkc: "\u{C033}",
        nfkd: "\u{1108}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C034}",
        nfc: "\u{C034}",
        nfd: "\u{1108}\u{1171}\u{11BB}",
        nfkc: "\u{C034}",
        nfkd: "\u{1108}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C035}",
        nfc: "\u{C035}",
        nfd: "\u{1108}\u{1171}\u{11BC}",
        nfkc: "\u{C035}",
        nfkd: "\u{1108}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C036}",
        nfc: "\u{C036}",
        nfd: "\u{1108}\u{1171}\u{11BD}",
        nfkc: "\u{C036}",
        nfkd: "\u{1108}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C037}",
        nfc: "\u{C037}",
        nfd: "\u{1108}\u{1171}\u{11BE}",
        nfkc: "\u{C037}",
        nfkd: "\u{1108}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C038}",
        nfc: "\u{C038}",
        nfd: "\u{1108}\u{1171}\u{11BF}",
        nfkc: "\u{C038}",
        nfkd: "\u{1108}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C039}",
        nfc: "\u{C039}",
        nfd: "\u{1108}\u{1171}\u{11C0}",
        nfkc: "\u{C039}",
        nfkd: "\u{1108}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C03A}",
        nfc: "\u{C03A}",
        nfd: "\u{1108}\u{1171}\u{11C1}",
        nfkc: "\u{C03A}",
        nfkd: "\u{1108}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C03B}",
        nfc: "\u{C03B}",
        nfd: "\u{1108}\u{1171}\u{11C2}",
        nfkc: "\u{C03B}",
        nfkd: "\u{1108}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C03C}",
        nfc: "\u{C03C}",
        nfd: "\u{1108}\u{1172}",
        nfkc: "\u{C03C}",
        nfkd: "\u{1108}\u{1172}",
    },
    NormalizationTest {
        source: "\u{C03D}",
        nfc: "\u{C03D}",
        nfd: "\u{1108}\u{1172}\u{11A8}",
        nfkc: "\u{C03D}",
        nfkd: "\u{1108}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C03E}",
        nfc: "\u{C03E}",
        nfd: "\u{1108}\u{1172}\u{11A9}",
        nfkc: "\u{C03E}",
        nfkd: "\u{1108}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C03F}",
        nfc: "\u{C03F}",
        nfd: "\u{1108}\u{1172}\u{11AA}",
        nfkc: "\u{C03F}",
        nfkd: "\u{1108}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C040}",
        nfc: "\u{C040}",
        nfd: "\u{1108}\u{1172}\u{11AB}",
        nfkc: "\u{C040}",
        nfkd: "\u{1108}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C041}",
        nfc: "\u{C041}",
        nfd: "\u{1108}\u{1172}\u{11AC}",
        nfkc: "\u{C041}",
        nfkd: "\u{1108}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C042}",
        nfc: "\u{C042}",
        nfd: "\u{1108}\u{1172}\u{11AD}",
        nfkc: "\u{C042}",
        nfkd: "\u{1108}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C043}",
        nfc: "\u{C043}",
        nfd: "\u{1108}\u{1172}\u{11AE}",
        nfkc: "\u{C043}",
        nfkd: "\u{1108}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C044}",
        nfc: "\u{C044}",
        nfd: "\u{1108}\u{1172}\u{11AF}",
        nfkc: "\u{C044}",
        nfkd: "\u{1108}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C045}",
        nfc: "\u{C045}",
        nfd: "\u{1108}\u{1172}\u{11B0}",
        nfkc: "\u{C045}",
        nfkd: "\u{1108}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C046}",
        nfc: "\u{C046}",
        nfd: "\u{1108}\u{1172}\u{11B1}",
        nfkc: "\u{C046}",
        nfkd: "\u{1108}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C047}",
        nfc: "\u{C047}",
        nfd: "\u{1108}\u{1172}\u{11B2}",
        nfkc: "\u{C047}",
        nfkd: "\u{1108}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C048}",
        nfc: "\u{C048}",
        nfd: "\u{1108}\u{1172}\u{11B3}",
        nfkc: "\u{C048}",
        nfkd: "\u{1108}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C049}",
        nfc: "\u{C049}",
        nfd: "\u{1108}\u{1172}\u{11B4}",
        nfkc: "\u{C049}",
        nfkd: "\u{1108}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C04A}",
        nfc: "\u{C04A}",
        nfd: "\u{1108}\u{1172}\u{11B5}",
        nfkc: "\u{C04A}",
        nfkd: "\u{1108}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C04B}",
        nfc: "\u{C04B}",
        nfd: "\u{1108}\u{1172}\u{11B6}",
        nfkc: "\u{C04B}",
        nfkd: "\u{1108}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C04C}",
        nfc: "\u{C04C}",
        nfd: "\u{1108}\u{1172}\u{11B7}",
        nfkc: "\u{C04C}",
        nfkd: "\u{1108}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C04D}",
        nfc: "\u{C04D}",
        nfd: "\u{1108}\u{1172}\u{11B8}",
        nfkc: "\u{C04D}",
        nfkd: "\u{1108}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C04E}",
        nfc: "\u{C04E}",
        nfd: "\u{1108}\u{1172}\u{11B9}",
        nfkc: "\u{C04E}",
        nfkd: "\u{1108}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C04F}",
        nfc: "\u{C04F}",
        nfd: "\u{1108}\u{1172}\u{11BA}",
        nfkc: "\u{C04F}",
        nfkd: "\u{1108}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C050}",
        nfc: "\u{C050}",
        nfd: "\u{1108}\u{1172}\u{11BB}",
        nfkc: "\u{C050}",
        nfkd: "\u{1108}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C051}",
        nfc: "\u{C051}",
        nfd: "\u{1108}\u{1172}\u{11BC}",
        nfkc: "\u{C051}",
        nfkd: "\u{1108}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C052}",
        nfc: "\u{C052}",
        nfd: "\u{1108}\u{1172}\u{11BD}",
        nfkc: "\u{C052}",
        nfkd: "\u{1108}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C053}",
        nfc: "\u{C053}",
        nfd: "\u{1108}\u{1172}\u{11BE}",
        nfkc: "\u{C053}",
        nfkd: "\u{1108}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C054}",
        nfc: "\u{C054}",
        nfd: "\u{1108}\u{1172}\u{11BF}",
        nfkc: "\u{C054}",
        nfkd: "\u{1108}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C055}",
        nfc: "\u{C055}",
        nfd: "\u{1108}\u{1172}\u{11C0}",
        nfkc: "\u{C055}",
        nfkd: "\u{1108}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C056}",
        nfc: "\u{C056}",
        nfd: "\u{1108}\u{1172}\u{11C1}",
        nfkc: "\u{C056}",
        nfkd: "\u{1108}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C057}",
        nfc: "\u{C057}",
        nfd: "\u{1108}\u{1172}\u{11C2}",
        nfkc: "\u{C057}",
        nfkd: "\u{1108}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C058}",
        nfc: "\u{C058}",
        nfd: "\u{1108}\u{1173}",
        nfkc: "\u{C058}",
        nfkd: "\u{1108}\u{1173}",
    },
    NormalizationTest {
        source: "\u{C059}",
        nfc: "\u{C059}",
        nfd: "\u{1108}\u{1173}\u{11A8}",
        nfkc: "\u{C059}",
        nfkd: "\u{1108}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C05A}",
        nfc: "\u{C05A}",
        nfd: "\u{1108}\u{1173}\u{11A9}",
        nfkc: "\u{C05A}",
        nfkd: "\u{1108}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C05B}",
        nfc: "\u{C05B}",
        nfd: "\u{1108}\u{1173}\u{11AA}",
        nfkc: "\u{C05B}",
        nfkd: "\u{1108}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C05C}",
        nfc: "\u{C05C}",
        nfd: "\u{1108}\u{1173}\u{11AB}",
        nfkc: "\u{C05C}",
        nfkd: "\u{1108}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C05D}",
        nfc: "\u{C05D}",
        nfd: "\u{1108}\u{1173}\u{11AC}",
        nfkc: "\u{C05D}",
        nfkd: "\u{1108}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C05E}",
        nfc: "\u{C05E}",
        nfd: "\u{1108}\u{1173}\u{11AD}",
        nfkc: "\u{C05E}",
        nfkd: "\u{1108}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C05F}",
        nfc: "\u{C05F}",
        nfd: "\u{1108}\u{1173}\u{11AE}",
        nfkc: "\u{C05F}",
        nfkd: "\u{1108}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C060}",
        nfc: "\u{C060}",
        nfd: "\u{1108}\u{1173}\u{11AF}",
        nfkc: "\u{C060}",
        nfkd: "\u{1108}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C061}",
        nfc: "\u{C061}",
        nfd: "\u{1108}\u{1173}\u{11B0}",
        nfkc: "\u{C061}",
        nfkd: "\u{1108}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C062}",
        nfc: "\u{C062}",
        nfd: "\u{1108}\u{1173}\u{11B1}",
        nfkc: "\u{C062}",
        nfkd: "\u{1108}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C063}",
        nfc: "\u{C063}",
        nfd: "\u{1108}\u{1173}\u{11B2}",
        nfkc: "\u{C063}",
        nfkd: "\u{1108}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C064}",
        nfc: "\u{C064}",
        nfd: "\u{1108}\u{1173}\u{11B3}",
        nfkc: "\u{C064}",
        nfkd: "\u{1108}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C065}",
        nfc: "\u{C065}",
        nfd: "\u{1108}\u{1173}\u{11B4}",
        nfkc: "\u{C065}",
        nfkd: "\u{1108}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C066}",
        nfc: "\u{C066}",
        nfd: "\u{1108}\u{1173}\u{11B5}",
        nfkc: "\u{C066}",
        nfkd: "\u{1108}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C067}",
        nfc: "\u{C067}",
        nfd: "\u{1108}\u{1173}\u{11B6}",
        nfkc: "\u{C067}",
        nfkd: "\u{1108}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C068}",
        nfc: "\u{C068}",
        nfd: "\u{1108}\u{1173}\u{11B7}",
        nfkc: "\u{C068}",
        nfkd: "\u{1108}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C069}",
        nfc: "\u{C069}",
        nfd: "\u{1108}\u{1173}\u{11B8}",
        nfkc: "\u{C069}",
        nfkd: "\u{1108}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C06A}",
        nfc: "\u{C06A}",
        nfd: "\u{1108}\u{1173}\u{11B9}",
        nfkc: "\u{C06A}",
        nfkd: "\u{1108}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C06B}",
        nfc: "\u{C06B}",
        nfd: "\u{1108}\u{1173}\u{11BA}",
        nfkc: "\u{C06B}",
        nfkd: "\u{1108}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C06C}",
        nfc: "\u{C06C}",
        nfd: "\u{1108}\u{1173}\u{11BB}",
        nfkc: "\u{C06C}",
        nfkd: "\u{1108}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C06D}",
        nfc: "\u{C06D}",
        nfd: "\u{1108}\u{1173}\u{11BC}",
        nfkc: "\u{C06D}",
        nfkd: "\u{1108}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C06E}",
        nfc: "\u{C06E}",
        nfd: "\u{1108}\u{1173}\u{11BD}",
        nfkc: "\u{C06E}",
        nfkd: "\u{1108}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C06F}",
        nfc: "\u{C06F}",
        nfd: "\u{1108}\u{1173}\u{11BE}",
        nfkc: "\u{C06F}",
        nfkd: "\u{1108}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C070}",
        nfc: "\u{C070}",
        nfd: "\u{1108}\u{1173}\u{11BF}",
        nfkc: "\u{C070}",
        nfkd: "\u{1108}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C071}",
        nfc: "\u{C071}",
        nfd: "\u{1108}\u{1173}\u{11C0}",
        nfkc: "\u{C071}",
        nfkd: "\u{1108}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C072}",
        nfc: "\u{C072}",
        nfd: "\u{1108}\u{1173}\u{11C1}",
        nfkc: "\u{C072}",
        nfkd: "\u{1108}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C073}",
        nfc: "\u{C073}",
        nfd: "\u{1108}\u{1173}\u{11C2}",
        nfkc: "\u{C073}",
        nfkd: "\u{1108}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C074}",
        nfc: "\u{C074}",
        nfd: "\u{1108}\u{1174}",
        nfkc: "\u{C074}",
        nfkd: "\u{1108}\u{1174}",
    },
    NormalizationTest {
        source: "\u{C075}",
        nfc: "\u{C075}",
        nfd: "\u{1108}\u{1174}\u{11A8}",
        nfkc: "\u{C075}",
        nfkd: "\u{1108}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C076}",
        nfc: "\u{C076}",
        nfd: "\u{1108}\u{1174}\u{11A9}",
        nfkc: "\u{C076}",
        nfkd: "\u{1108}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C077}",
        nfc: "\u{C077}",
        nfd: "\u{1108}\u{1174}\u{11AA}",
        nfkc: "\u{C077}",
        nfkd: "\u{1108}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C078}",
        nfc: "\u{C078}",
        nfd: "\u{1108}\u{1174}\u{11AB}",
        nfkc: "\u{C078}",
        nfkd: "\u{1108}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C079}",
        nfc: "\u{C079}",
        nfd: "\u{1108}\u{1174}\u{11AC}",
        nfkc: "\u{C079}",
        nfkd: "\u{1108}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C07A}",
        nfc: "\u{C07A}",
        nfd: "\u{1108}\u{1174}\u{11AD}",
        nfkc: "\u{C07A}",
        nfkd: "\u{1108}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C07B}",
        nfc: "\u{C07B}",
        nfd: "\u{1108}\u{1174}\u{11AE}",
        nfkc: "\u{C07B}",
        nfkd: "\u{1108}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C07C}",
        nfc: "\u{C07C}",
        nfd: "\u{1108}\u{1174}\u{11AF}",
        nfkc: "\u{C07C}",
        nfkd: "\u{1108}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C07D}",
        nfc: "\u{C07D}",
        nfd: "\u{1108}\u{1174}\u{11B0}",
        nfkc: "\u{C07D}",
        nfkd: "\u{1108}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C07E}",
        nfc: "\u{C07E}",
        nfd: "\u{1108}\u{1174}\u{11B1}",
        nfkc: "\u{C07E}",
        nfkd: "\u{1108}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C07F}",
        nfc: "\u{C07F}",
        nfd: "\u{1108}\u{1174}\u{11B2}",
        nfkc: "\u{C07F}",
        nfkd: "\u{1108}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C080}",
        nfc: "\u{C080}",
        nfd: "\u{1108}\u{1174}\u{11B3}",
        nfkc: "\u{C080}",
        nfkd: "\u{1108}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C081}",
        nfc: "\u{C081}",
        nfd: "\u{1108}\u{1174}\u{11B4}",
        nfkc: "\u{C081}",
        nfkd: "\u{1108}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C082}",
        nfc: "\u{C082}",
        nfd: "\u{1108}\u{1174}\u{11B5}",
        nfkc: "\u{C082}",
        nfkd: "\u{1108}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C083}",
        nfc: "\u{C083}",
        nfd: "\u{1108}\u{1174}\u{11B6}",
        nfkc: "\u{C083}",
        nfkd: "\u{1108}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C084}",
        nfc: "\u{C084}",
        nfd: "\u{1108}\u{1174}\u{11B7}",
        nfkc: "\u{C084}",
        nfkd: "\u{1108}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C085}",
        nfc: "\u{C085}",
        nfd: "\u{1108}\u{1174}\u{11B8}",
        nfkc: "\u{C085}",
        nfkd: "\u{1108}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C086}",
        nfc: "\u{C086}",
        nfd: "\u{1108}\u{1174}\u{11B9}",
        nfkc: "\u{C086}",
        nfkd: "\u{1108}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C087}",
        nfc: "\u{C087}",
        nfd: "\u{1108}\u{1174}\u{11BA}",
        nfkc: "\u{C087}",
        nfkd: "\u{1108}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C088}",
        nfc: "\u{C088}",
        nfd: "\u{1108}\u{1174}\u{11BB}",
        nfkc: "\u{C088}",
        nfkd: "\u{1108}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C089}",
        nfc: "\u{C089}",
        nfd: "\u{1108}\u{1174}\u{11BC}",
        nfkc: "\u{C089}",
        nfkd: "\u{1108}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C08A}",
        nfc: "\u{C08A}",
        nfd: "\u{1108}\u{1174}\u{11BD}",
        nfkc: "\u{C08A}",
        nfkd: "\u{1108}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C08B}",
        nfc: "\u{C08B}",
        nfd: "\u{1108}\u{1174}\u{11BE}",
        nfkc: "\u{C08B}",
        nfkd: "\u{1108}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C08C}",
        nfc: "\u{C08C}",
        nfd: "\u{1108}\u{1174}\u{11BF}",
        nfkc: "\u{C08C}",
        nfkd: "\u{1108}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C08D}",
        nfc: "\u{C08D}",
        nfd: "\u{1108}\u{1174}\u{11C0}",
        nfkc: "\u{C08D}",
        nfkd: "\u{1108}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C08E}",
        nfc: "\u{C08E}",
        nfd: "\u{1108}\u{1174}\u{11C1}",
        nfkc: "\u{C08E}",
        nfkd: "\u{1108}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C08F}",
        nfc: "\u{C08F}",
        nfd: "\u{1108}\u{1174}\u{11C2}",
        nfkc: "\u{C08F}",
        nfkd: "\u{1108}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C090}",
        nfc: "\u{C090}",
        nfd: "\u{1108}\u{1175}",
        nfkc: "\u{C090}",
        nfkd: "\u{1108}\u{1175}",
    },
    NormalizationTest {
        source: "\u{C091}",
        nfc: "\u{C091}",
        nfd: "\u{1108}\u{1175}\u{11A8}",
        nfkc: "\u{C091}",
        nfkd: "\u{1108}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C092}",
        nfc: "\u{C092}",
        nfd: "\u{1108}\u{1175}\u{11A9}",
        nfkc: "\u{C092}",
        nfkd: "\u{1108}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C093}",
        nfc: "\u{C093}",
        nfd: "\u{1108}\u{1175}\u{11AA}",
        nfkc: "\u{C093}",
        nfkd: "\u{1108}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C094}",
        nfc: "\u{C094}",
        nfd: "\u{1108}\u{1175}\u{11AB}",
        nfkc: "\u{C094}",
        nfkd: "\u{1108}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C095}",
        nfc: "\u{C095}",
        nfd: "\u{1108}\u{1175}\u{11AC}",
        nfkc: "\u{C095}",
        nfkd: "\u{1108}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C096}",
        nfc: "\u{C096}",
        nfd: "\u{1108}\u{1175}\u{11AD}",
        nfkc: "\u{C096}",
        nfkd: "\u{1108}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C097}",
        nfc: "\u{C097}",
        nfd: "\u{1108}\u{1175}\u{11AE}",
        nfkc: "\u{C097}",
        nfkd: "\u{1108}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C098}",
        nfc: "\u{C098}",
        nfd: "\u{1108}\u{1175}\u{11AF}",
        nfkc: "\u{C098}",
        nfkd: "\u{1108}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C099}",
        nfc: "\u{C099}",
        nfd: "\u{1108}\u{1175}\u{11B0}",
        nfkc: "\u{C099}",
        nfkd: "\u{1108}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C09A}",
        nfc: "\u{C09A}",
        nfd: "\u{1108}\u{1175}\u{11B1}",
        nfkc: "\u{C09A}",
        nfkd: "\u{1108}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C09B}",
        nfc: "\u{C09B}",
        nfd: "\u{1108}\u{1175}\u{11B2}",
        nfkc: "\u{C09B}",
        nfkd: "\u{1108}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C09C}",
        nfc: "\u{C09C}",
        nfd: "\u{1108}\u{1175}\u{11B3}",
        nfkc: "\u{C09C}",
        nfkd: "\u{1108}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C09D}",
        nfc: "\u{C09D}",
        nfd: "\u{1108}\u{1175}\u{11B4}",
        nfkc: "\u{C09D}",
        nfkd: "\u{1108}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C09E}",
        nfc: "\u{C09E}",
        nfd: "\u{1108}\u{1175}\u{11B5}",
        nfkc: "\u{C09E}",
        nfkd: "\u{1108}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C09F}",
        nfc: "\u{C09F}",
        nfd: "\u{1108}\u{1175}\u{11B6}",
        nfkc: "\u{C09F}",
        nfkd: "\u{1108}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C0A0}",
        nfc: "\u{C0A0}",
        nfd: "\u{1108}\u{1175}\u{11B7}",
        nfkc: "\u{C0A0}",
        nfkd: "\u{1108}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C0A1}",
        nfc: "\u{C0A1}",
        nfd: "\u{1108}\u{1175}\u{11B8}",
        nfkc: "\u{C0A1}",
        nfkd: "\u{1108}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C0A2}",
        nfc: "\u{C0A2}",
        nfd: "\u{1108}\u{1175}\u{11B9}",
        nfkc: "\u{C0A2}",
        nfkd: "\u{1108}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C0A3}",
        nfc: "\u{C0A3}",
        nfd: "\u{1108}\u{1175}\u{11BA}",
        nfkc: "\u{C0A3}",
        nfkd: "\u{1108}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C0A4}",
        nfc: "\u{C0A4}",
        nfd: "\u{1108}\u{1175}\u{11BB}",
        nfkc: "\u{C0A4}",
        nfkd: "\u{1108}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C0A5}",
        nfc: "\u{C0A5}",
        nfd: "\u{1108}\u{1175}\u{11BC}",
        nfkc: "\u{C0A5}",
        nfkd: "\u{1108}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C0A6}",
        nfc: "\u{C0A6}",
        nfd: "\u{1108}\u{1175}\u{11BD}",
        nfkc: "\u{C0A6}",
        nfkd: "\u{1108}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C0A7}",
        nfc: "\u{C0A7}",
        nfd: "\u{1108}\u{1175}\u{11BE}",
        nfkc: "\u{C0A7}",
        nfkd: "\u{1108}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C0A8}",
        nfc: "\u{C0A8}",
        nfd: "\u{1108}\u{1175}\u{11BF}",
        nfkc: "\u{C0A8}",
        nfkd: "\u{1108}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C0A9}",
        nfc: "\u{C0A9}",
        nfd: "\u{1108}\u{1175}\u{11C0}",
        nfkc: "\u{C0A9}",
        nfkd: "\u{1108}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C0AA}",
        nfc: "\u{C0AA}",
        nfd: "\u{1108}\u{1175}\u{11C1}",
        nfkc: "\u{C0AA}",
        nfkd: "\u{1108}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C0AB}",
        nfc: "\u{C0AB}",
        nfd: "\u{1108}\u{1175}\u{11C2}",
        nfkc: "\u{C0AB}",
        nfkd: "\u{1108}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C0AC}",
        nfc: "\u{C0AC}",
        nfd: "\u{1109}\u{1161}",
        nfkc: "\u{C0AC}",
        nfkd: "\u{1109}\u{1161}",
    },
    NormalizationTest {
        source: "\u{C0AD}",
        nfc: "\u{C0AD}",
        nfd: "\u{1109}\u{1161}\u{11A8}",
        nfkc: "\u{C0AD}",
        nfkd: "\u{1109}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C0AE}",
        nfc: "\u{C0AE}",
        nfd: "\u{1109}\u{1161}\u{11A9}",
        nfkc: "\u{C0AE}",
        nfkd: "\u{1109}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C0AF}",
        nfc: "\u{C0AF}",
        nfd: "\u{1109}\u{1161}\u{11AA}",
        nfkc: "\u{C0AF}",
        nfkd: "\u{1109}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C0B0}",
        nfc: "\u{C0B0}",
        nfd: "\u{1109}\u{1161}\u{11AB}",
        nfkc: "\u{C0B0}",
        nfkd: "\u{1109}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C0B1}",
        nfc: "\u{C0B1}",
        nfd: "\u{1109}\u{1161}\u{11AC}",
        nfkc: "\u{C0B1}",
        nfkd: "\u{1109}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C0B2}",
        nfc: "\u{C0B2}",
        nfd: "\u{1109}\u{1161}\u{11AD}",
        nfkc: "\u{C0B2}",
        nfkd: "\u{1109}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C0B3}",
        nfc: "\u{C0B3}",
        nfd: "\u{1109}\u{1161}\u{11AE}",
        nfkc: "\u{C0B3}",
        nfkd: "\u{1109}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C0B4}",
        nfc: "\u{C0B4}",
        nfd: "\u{1109}\u{1161}\u{11AF}",
        nfkc: "\u{C0B4}",
        nfkd: "\u{1109}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C0B5}",
        nfc: "\u{C0B5}",
        nfd: "\u{1109}\u{1161}\u{11B0}",
        nfkc: "\u{C0B5}",
        nfkd: "\u{1109}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C0B6}",
        nfc: "\u{C0B6}",
        nfd: "\u{1109}\u{1161}\u{11B1}",
        nfkc: "\u{C0B6}",
        nfkd: "\u{1109}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C0B7}",
        nfc: "\u{C0B7}",
        nfd: "\u{1109}\u{1161}\u{11B2}",
        nfkc: "\u{C0B7}",
        nfkd: "\u{1109}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C0B8}",
        nfc: "\u{C0B8}",
        nfd: "\u{1109}\u{1161}\u{11B3}",
        nfkc: "\u{C0B8}",
        nfkd: "\u{1109}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C0B9}",
        nfc: "\u{C0B9}",
        nfd: "\u{1109}\u{1161}\u{11B4}",
        nfkc: "\u{C0B9}",
        nfkd: "\u{1109}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C0BA}",
        nfc: "\u{C0BA}",
        nfd: "\u{1109}\u{1161}\u{11B5}",
        nfkc: "\u{C0BA}",
        nfkd: "\u{1109}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C0BB}",
        nfc: "\u{C0BB}",
        nfd: "\u{1109}\u{1161}\u{11B6}",
        nfkc: "\u{C0BB}",
        nfkd: "\u{1109}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C0BC}",
        nfc: "\u{C0BC}",
        nfd: "\u{1109}\u{1161}\u{11B7}",
        nfkc: "\u{C0BC}",
        nfkd: "\u{1109}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C0BD}",
        nfc: "\u{C0BD}",
        nfd: "\u{1109}\u{1161}\u{11B8}",
        nfkc: "\u{C0BD}",
        nfkd: "\u{1109}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C0BE}",
        nfc: "\u{C0BE}",
        nfd: "\u{1109}\u{1161}\u{11B9}",
        nfkc: "\u{C0BE}",
        nfkd: "\u{1109}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C0BF}",
        nfc: "\u{C0BF}",
        nfd: "\u{1109}\u{1161}\u{11BA}",
        nfkc: "\u{C0BF}",
        nfkd: "\u{1109}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C0C0}",
        nfc: "\u{C0C0}",
        nfd: "\u{1109}\u{1161}\u{11BB}",
        nfkc: "\u{C0C0}",
        nfkd: "\u{1109}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C0C1}",
        nfc: "\u{C0C1}",
        nfd: "\u{1109}\u{1161}\u{11BC}",
        nfkc: "\u{C0C1}",
        nfkd: "\u{1109}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C0C2}",
        nfc: "\u{C0C2}",
        nfd: "\u{1109}\u{1161}\u{11BD}",
        nfkc: "\u{C0C2}",
        nfkd: "\u{1109}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C0C3}",
        nfc: "\u{C0C3}",
        nfd: "\u{1109}\u{1161}\u{11BE}",
        nfkc: "\u{C0C3}",
        nfkd: "\u{1109}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C0C4}",
        nfc: "\u{C0C4}",
        nfd: "\u{1109}\u{1161}\u{11BF}",
        nfkc: "\u{C0C4}",
        nfkd: "\u{1109}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C0C5}",
        nfc: "\u{C0C5}",
        nfd: "\u{1109}\u{1161}\u{11C0}",
        nfkc: "\u{C0C5}",
        nfkd: "\u{1109}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C0C6}",
        nfc: "\u{C0C6}",
        nfd: "\u{1109}\u{1161}\u{11C1}",
        nfkc: "\u{C0C6}",
        nfkd: "\u{1109}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C0C7}",
        nfc: "\u{C0C7}",
        nfd: "\u{1109}\u{1161}\u{11C2}",
        nfkc: "\u{C0C7}",
        nfkd: "\u{1109}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C0C8}",
        nfc: "\u{C0C8}",
        nfd: "\u{1109}\u{1162}",
        nfkc: "\u{C0C8}",
        nfkd: "\u{1109}\u{1162}",
    },
    NormalizationTest {
        source: "\u{C0C9}",
        nfc: "\u{C0C9}",
        nfd: "\u{1109}\u{1162}\u{11A8}",
        nfkc: "\u{C0C9}",
        nfkd: "\u{1109}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C0CA}",
        nfc: "\u{C0CA}",
        nfd: "\u{1109}\u{1162}\u{11A9}",
        nfkc: "\u{C0CA}",
        nfkd: "\u{1109}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C0CB}",
        nfc: "\u{C0CB}",
        nfd: "\u{1109}\u{1162}\u{11AA}",
        nfkc: "\u{C0CB}",
        nfkd: "\u{1109}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C0CC}",
        nfc: "\u{C0CC}",
        nfd: "\u{1109}\u{1162}\u{11AB}",
        nfkc: "\u{C0CC}",
        nfkd: "\u{1109}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C0CD}",
        nfc: "\u{C0CD}",
        nfd: "\u{1109}\u{1162}\u{11AC}",
        nfkc: "\u{C0CD}",
        nfkd: "\u{1109}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C0CE}",
        nfc: "\u{C0CE}",
        nfd: "\u{1109}\u{1162}\u{11AD}",
        nfkc: "\u{C0CE}",
        nfkd: "\u{1109}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C0CF}",
        nfc: "\u{C0CF}",
        nfd: "\u{1109}\u{1162}\u{11AE}",
        nfkc: "\u{C0CF}",
        nfkd: "\u{1109}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C0D0}",
        nfc: "\u{C0D0}",
        nfd: "\u{1109}\u{1162}\u{11AF}",
        nfkc: "\u{C0D0}",
        nfkd: "\u{1109}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C0D1}",
        nfc: "\u{C0D1}",
        nfd: "\u{1109}\u{1162}\u{11B0}",
        nfkc: "\u{C0D1}",
        nfkd: "\u{1109}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C0D2}",
        nfc: "\u{C0D2}",
        nfd: "\u{1109}\u{1162}\u{11B1}",
        nfkc: "\u{C0D2}",
        nfkd: "\u{1109}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C0D3}",
        nfc: "\u{C0D3}",
        nfd: "\u{1109}\u{1162}\u{11B2}",
        nfkc: "\u{C0D3}",
        nfkd: "\u{1109}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C0D4}",
        nfc: "\u{C0D4}",
        nfd: "\u{1109}\u{1162}\u{11B3}",
        nfkc: "\u{C0D4}",
        nfkd: "\u{1109}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C0D5}",
        nfc: "\u{C0D5}",
        nfd: "\u{1109}\u{1162}\u{11B4}",
        nfkc: "\u{C0D5}",
        nfkd: "\u{1109}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C0D6}",
        nfc: "\u{C0D6}",
        nfd: "\u{1109}\u{1162}\u{11B5}",
        nfkc: "\u{C0D6}",
        nfkd: "\u{1109}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C0D7}",
        nfc: "\u{C0D7}",
        nfd: "\u{1109}\u{1162}\u{11B6}",
        nfkc: "\u{C0D7}",
        nfkd: "\u{1109}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C0D8}",
        nfc: "\u{C0D8}",
        nfd: "\u{1109}\u{1162}\u{11B7}",
        nfkc: "\u{C0D8}",
        nfkd: "\u{1109}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C0D9}",
        nfc: "\u{C0D9}",
        nfd: "\u{1109}\u{1162}\u{11B8}",
        nfkc: "\u{C0D9}",
        nfkd: "\u{1109}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C0DA}",
        nfc: "\u{C0DA}",
        nfd: "\u{1109}\u{1162}\u{11B9}",
        nfkc: "\u{C0DA}",
        nfkd: "\u{1109}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C0DB}",
        nfc: "\u{C0DB}",
        nfd: "\u{1109}\u{1162}\u{11BA}",
        nfkc: "\u{C0DB}",
        nfkd: "\u{1109}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C0DC}",
        nfc: "\u{C0DC}",
        nfd: "\u{1109}\u{1162}\u{11BB}",
        nfkc: "\u{C0DC}",
        nfkd: "\u{1109}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C0DD}",
        nfc: "\u{C0DD}",
        nfd: "\u{1109}\u{1162}\u{11BC}",
        nfkc: "\u{C0DD}",
        nfkd: "\u{1109}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C0DE}",
        nfc: "\u{C0DE}",
        nfd: "\u{1109}\u{1162}\u{11BD}",
        nfkc: "\u{C0DE}",
        nfkd: "\u{1109}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C0DF}",
        nfc: "\u{C0DF}",
        nfd: "\u{1109}\u{1162}\u{11BE}",
        nfkc: "\u{C0DF}",
        nfkd: "\u{1109}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C0E0}",
        nfc: "\u{C0E0}",
        nfd: "\u{1109}\u{1162}\u{11BF}",
        nfkc: "\u{C0E0}",
        nfkd: "\u{1109}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C0E1}",
        nfc: "\u{C0E1}",
        nfd: "\u{1109}\u{1162}\u{11C0}",
        nfkc: "\u{C0E1}",
        nfkd: "\u{1109}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C0E2}",
        nfc: "\u{C0E2}",
        nfd: "\u{1109}\u{1162}\u{11C1}",
        nfkc: "\u{C0E2}",
        nfkd: "\u{1109}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C0E3}",
        nfc: "\u{C0E3}",
        nfd: "\u{1109}\u{1162}\u{11C2}",
        nfkc: "\u{C0E3}",
        nfkd: "\u{1109}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C0E4}",
        nfc: "\u{C0E4}",
        nfd: "\u{1109}\u{1163}",
        nfkc: "\u{C0E4}",
        nfkd: "\u{1109}\u{1163}",
    },
    NormalizationTest {
        source: "\u{C0E5}",
        nfc: "\u{C0E5}",
        nfd: "\u{1109}\u{1163}\u{11A8}",
        nfkc: "\u{C0E5}",
        nfkd: "\u{1109}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C0E6}",
        nfc: "\u{C0E6}",
        nfd: "\u{1109}\u{1163}\u{11A9}",
        nfkc: "\u{C0E6}",
        nfkd: "\u{1109}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C0E7}",
        nfc: "\u{C0E7}",
        nfd: "\u{1109}\u{1163}\u{11AA}",
        nfkc: "\u{C0E7}",
        nfkd: "\u{1109}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C0E8}",
        nfc: "\u{C0E8}",
        nfd: "\u{1109}\u{1163}\u{11AB}",
        nfkc: "\u{C0E8}",
        nfkd: "\u{1109}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C0E9}",
        nfc: "\u{C0E9}",
        nfd: "\u{1109}\u{1163}\u{11AC}",
        nfkc: "\u{C0E9}",
        nfkd: "\u{1109}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C0EA}",
        nfc: "\u{C0EA}",
        nfd: "\u{1109}\u{1163}\u{11AD}",
        nfkc: "\u{C0EA}",
        nfkd: "\u{1109}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C0EB}",
        nfc: "\u{C0EB}",
        nfd: "\u{1109}\u{1163}\u{11AE}",
        nfkc: "\u{C0EB}",
        nfkd: "\u{1109}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C0EC}",
        nfc: "\u{C0EC}",
        nfd: "\u{1109}\u{1163}\u{11AF}",
        nfkc: "\u{C0EC}",
        nfkd: "\u{1109}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C0ED}",
        nfc: "\u{C0ED}",
        nfd: "\u{1109}\u{1163}\u{11B0}",
        nfkc: "\u{C0ED}",
        nfkd: "\u{1109}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C0EE}",
        nfc: "\u{C0EE}",
        nfd: "\u{1109}\u{1163}\u{11B1}",
        nfkc: "\u{C0EE}",
        nfkd: "\u{1109}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C0EF}",
        nfc: "\u{C0EF}",
        nfd: "\u{1109}\u{1163}\u{11B2}",
        nfkc: "\u{C0EF}",
        nfkd: "\u{1109}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C0F0}",
        nfc: "\u{C0F0}",
        nfd: "\u{1109}\u{1163}\u{11B3}",
        nfkc: "\u{C0F0}",
        nfkd: "\u{1109}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C0F1}",
        nfc: "\u{C0F1}",
        nfd: "\u{1109}\u{1163}\u{11B4}",
        nfkc: "\u{C0F1}",
        nfkd: "\u{1109}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C0F2}",
        nfc: "\u{C0F2}",
        nfd: "\u{1109}\u{1163}\u{11B5}",
        nfkc: "\u{C0F2}",
        nfkd: "\u{1109}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C0F3}",
        nfc: "\u{C0F3}",
        nfd: "\u{1109}\u{1163}\u{11B6}",
        nfkc: "\u{C0F3}",
        nfkd: "\u{1109}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C0F4}",
        nfc: "\u{C0F4}",
        nfd: "\u{1109}\u{1163}\u{11B7}",
        nfkc: "\u{C0F4}",
        nfkd: "\u{1109}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C0F5}",
        nfc: "\u{C0F5}",
        nfd: "\u{1109}\u{1163}\u{11B8}",
        nfkc: "\u{C0F5}",
        nfkd: "\u{1109}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C0F6}",
        nfc: "\u{C0F6}",
        nfd: "\u{1109}\u{1163}\u{11B9}",
        nfkc: "\u{C0F6}",
        nfkd: "\u{1109}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C0F7}",
        nfc: "\u{C0F7}",
        nfd: "\u{1109}\u{1163}\u{11BA}",
        nfkc: "\u{C0F7}",
        nfkd: "\u{1109}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C0F8}",
        nfc: "\u{C0F8}",
        nfd: "\u{1109}\u{1163}\u{11BB}",
        nfkc: "\u{C0F8}",
        nfkd: "\u{1109}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C0F9}",
        nfc: "\u{C0F9}",
        nfd: "\u{1109}\u{1163}\u{11BC}",
        nfkc: "\u{C0F9}",
        nfkd: "\u{1109}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C0FA}",
        nfc: "\u{C0FA}",
        nfd: "\u{1109}\u{1163}\u{11BD}",
        nfkc: "\u{C0FA}",
        nfkd: "\u{1109}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C0FB}",
        nfc: "\u{C0FB}",
        nfd: "\u{1109}\u{1163}\u{11BE}",
        nfkc: "\u{C0FB}",
        nfkd: "\u{1109}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C0FC}",
        nfc: "\u{C0FC}",
        nfd: "\u{1109}\u{1163}\u{11BF}",
        nfkc: "\u{C0FC}",
        nfkd: "\u{1109}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C0FD}",
        nfc: "\u{C0FD}",
        nfd: "\u{1109}\u{1163}\u{11C0}",
        nfkc: "\u{C0FD}",
        nfkd: "\u{1109}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C0FE}",
        nfc: "\u{C0FE}",
        nfd: "\u{1109}\u{1163}\u{11C1}",
        nfkc: "\u{C0FE}",
        nfkd: "\u{1109}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C0FF}",
        nfc: "\u{C0FF}",
        nfd: "\u{1109}\u{1163}\u{11C2}",
        nfkc: "\u{C0FF}",
        nfkd: "\u{1109}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C100}",
        nfc: "\u{C100}",
        nfd: "\u{1109}\u{1164}",
        nfkc: "\u{C100}",
        nfkd: "\u{1109}\u{1164}",
    },
    NormalizationTest {
        source: "\u{C101}",
        nfc: "\u{C101}",
        nfd: "\u{1109}\u{1164}\u{11A8}",
        nfkc: "\u{C101}",
        nfkd: "\u{1109}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C102}",
        nfc: "\u{C102}",
        nfd: "\u{1109}\u{1164}\u{11A9}",
        nfkc: "\u{C102}",
        nfkd: "\u{1109}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C103}",
        nfc: "\u{C103}",
        nfd: "\u{1109}\u{1164}\u{11AA}",
        nfkc: "\u{C103}",
        nfkd: "\u{1109}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C104}",
        nfc: "\u{C104}",
        nfd: "\u{1109}\u{1164}\u{11AB}",
        nfkc: "\u{C104}",
        nfkd: "\u{1109}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C105}",
        nfc: "\u{C105}",
        nfd: "\u{1109}\u{1164}\u{11AC}",
        nfkc: "\u{C105}",
        nfkd: "\u{1109}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C106}",
        nfc: "\u{C106}",
        nfd: "\u{1109}\u{1164}\u{11AD}",
        nfkc: "\u{C106}",
        nfkd: "\u{1109}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C107}",
        nfc: "\u{C107}",
        nfd: "\u{1109}\u{1164}\u{11AE}",
        nfkc: "\u{C107}",
        nfkd: "\u{1109}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C108}",
        nfc: "\u{C108}",
        nfd: "\u{1109}\u{1164}\u{11AF}",
        nfkc: "\u{C108}",
        nfkd: "\u{1109}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C109}",
        nfc: "\u{C109}",
        nfd: "\u{1109}\u{1164}\u{11B0}",
        nfkc: "\u{C109}",
        nfkd: "\u{1109}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C10A}",
        nfc: "\u{C10A}",
        nfd: "\u{1109}\u{1164}\u{11B1}",
        nfkc: "\u{C10A}",
        nfkd: "\u{1109}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C10B}",
        nfc: "\u{C10B}",
        nfd: "\u{1109}\u{1164}\u{11B2}",
        nfkc: "\u{C10B}",
        nfkd: "\u{1109}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C10C}",
        nfc: "\u{C10C}",
        nfd: "\u{1109}\u{1164}\u{11B3}",
        nfkc: "\u{C10C}",
        nfkd: "\u{1109}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C10D}",
        nfc: "\u{C10D}",
        nfd: "\u{1109}\u{1164}\u{11B4}",
        nfkc: "\u{C10D}",
        nfkd: "\u{1109}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C10E}",
        nfc: "\u{C10E}",
        nfd: "\u{1109}\u{1164}\u{11B5}",
        nfkc: "\u{C10E}",
        nfkd: "\u{1109}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C10F}",
        nfc: "\u{C10F}",
        nfd: "\u{1109}\u{1164}\u{11B6}",
        nfkc: "\u{C10F}",
        nfkd: "\u{1109}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C110}",
        nfc: "\u{C110}",
        nfd: "\u{1109}\u{1164}\u{11B7}",
        nfkc: "\u{C110}",
        nfkd: "\u{1109}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C111}",
        nfc: "\u{C111}",
        nfd: "\u{1109}\u{1164}\u{11B8}",
        nfkc: "\u{C111}",
        nfkd: "\u{1109}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C112}",
        nfc: "\u{C112}",
        nfd: "\u{1109}\u{1164}\u{11B9}",
        nfkc: "\u{C112}",
        nfkd: "\u{1109}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C113}",
        nfc: "\u{C113}",
        nfd: "\u{1109}\u{1164}\u{11BA}",
        nfkc: "\u{C113}",
        nfkd: "\u{1109}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C114}",
        nfc: "\u{C114}",
        nfd: "\u{1109}\u{1164}\u{11BB}",
        nfkc: "\u{C114}",
        nfkd: "\u{1109}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C115}",
        nfc: "\u{C115}",
        nfd: "\u{1109}\u{1164}\u{11BC}",
        nfkc: "\u{C115}",
        nfkd: "\u{1109}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C116}",
        nfc: "\u{C116}",
        nfd: "\u{1109}\u{1164}\u{11BD}",
        nfkc: "\u{C116}",
        nfkd: "\u{1109}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C117}",
        nfc: "\u{C117}",
        nfd: "\u{1109}\u{1164}\u{11BE}",
        nfkc: "\u{C117}",
        nfkd: "\u{1109}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C118}",
        nfc: "\u{C118}",
        nfd: "\u{1109}\u{1164}\u{11BF}",
        nfkc: "\u{C118}",
        nfkd: "\u{1109}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C119}",
        nfc: "\u{C119}",
        nfd: "\u{1109}\u{1164}\u{11C0}",
        nfkc: "\u{C119}",
        nfkd: "\u{1109}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C11A}",
        nfc: "\u{C11A}",
        nfd: "\u{1109}\u{1164}\u{11C1}",
        nfkc: "\u{C11A}",
        nfkd: "\u{1109}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C11B}",
        nfc: "\u{C11B}",
        nfd: "\u{1109}\u{1164}\u{11C2}",
        nfkc: "\u{C11B}",
        nfkd: "\u{1109}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C11C}",
        nfc: "\u{C11C}",
        nfd: "\u{1109}\u{1165}",
        nfkc: "\u{C11C}",
        nfkd: "\u{1109}\u{1165}",
    },
    NormalizationTest {
        source: "\u{C11D}",
        nfc: "\u{C11D}",
        nfd: "\u{1109}\u{1165}\u{11A8}",
        nfkc: "\u{C11D}",
        nfkd: "\u{1109}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C11E}",
        nfc: "\u{C11E}",
        nfd: "\u{1109}\u{1165}\u{11A9}",
        nfkc: "\u{C11E}",
        nfkd: "\u{1109}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C11F}",
        nfc: "\u{C11F}",
        nfd: "\u{1109}\u{1165}\u{11AA}",
        nfkc: "\u{C11F}",
        nfkd: "\u{1109}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C120}",
        nfc: "\u{C120}",
        nfd: "\u{1109}\u{1165}\u{11AB}",
        nfkc: "\u{C120}",
        nfkd: "\u{1109}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C121}",
        nfc: "\u{C121}",
        nfd: "\u{1109}\u{1165}\u{11AC}",
        nfkc: "\u{C121}",
        nfkd: "\u{1109}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C122}",
        nfc: "\u{C122}",
        nfd: "\u{1109}\u{1165}\u{11AD}",
        nfkc: "\u{C122}",
        nfkd: "\u{1109}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C123}",
        nfc: "\u{C123}",
        nfd: "\u{1109}\u{1165}\u{11AE}",
        nfkc: "\u{C123}",
        nfkd: "\u{1109}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C124}",
        nfc: "\u{C124}",
        nfd: "\u{1109}\u{1165}\u{11AF}",
        nfkc: "\u{C124}",
        nfkd: "\u{1109}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C125}",
        nfc: "\u{C125}",
        nfd: "\u{1109}\u{1165}\u{11B0}",
        nfkc: "\u{C125}",
        nfkd: "\u{1109}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C126}",
        nfc: "\u{C126}",
        nfd: "\u{1109}\u{1165}\u{11B1}",
        nfkc: "\u{C126}",
        nfkd: "\u{1109}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C127}",
        nfc: "\u{C127}",
        nfd: "\u{1109}\u{1165}\u{11B2}",
        nfkc: "\u{C127}",
        nfkd: "\u{1109}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C128}",
        nfc: "\u{C128}",
        nfd: "\u{1109}\u{1165}\u{11B3}",
        nfkc: "\u{C128}",
        nfkd: "\u{1109}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C129}",
        nfc: "\u{C129}",
        nfd: "\u{1109}\u{1165}\u{11B4}",
        nfkc: "\u{C129}",
        nfkd: "\u{1109}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C12A}",
        nfc: "\u{C12A}",
        nfd: "\u{1109}\u{1165}\u{11B5}",
        nfkc: "\u{C12A}",
        nfkd: "\u{1109}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C12B}",
        nfc: "\u{C12B}",
        nfd: "\u{1109}\u{1165}\u{11B6}",
        nfkc: "\u{C12B}",
        nfkd: "\u{1109}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C12C}",
        nfc: "\u{C12C}",
        nfd: "\u{1109}\u{1165}\u{11B7}",
        nfkc: "\u{C12C}",
        nfkd: "\u{1109}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C12D}",
        nfc: "\u{C12D}",
        nfd: "\u{1109}\u{1165}\u{11B8}",
        nfkc: "\u{C12D}",
        nfkd: "\u{1109}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C12E}",
        nfc: "\u{C12E}",
        nfd: "\u{1109}\u{1165}\u{11B9}",
        nfkc: "\u{C12E}",
        nfkd: "\u{1109}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C12F}",
        nfc: "\u{C12F}",
        nfd: "\u{1109}\u{1165}\u{11BA}",
        nfkc: "\u{C12F}",
        nfkd: "\u{1109}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C130}",
        nfc: "\u{C130}",
        nfd: "\u{1109}\u{1165}\u{11BB}",
        nfkc: "\u{C130}",
        nfkd: "\u{1109}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C131}",
        nfc: "\u{C131}",
        nfd: "\u{1109}\u{1165}\u{11BC}",
        nfkc: "\u{C131}",
        nfkd: "\u{1109}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C132}",
        nfc: "\u{C132}",
        nfd: "\u{1109}\u{1165}\u{11BD}",
        nfkc: "\u{C132}",
        nfkd: "\u{1109}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C133}",
        nfc: "\u{C133}",
        nfd: "\u{1109}\u{1165}\u{11BE}",
        nfkc: "\u{C133}",
        nfkd: "\u{1109}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C134}",
        nfc: "\u{C134}",
        nfd: "\u{1109}\u{1165}\u{11BF}",
        nfkc: "\u{C134}",
        nfkd: "\u{1109}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C135}",
        nfc: "\u{C135}",
        nfd: "\u{1109}\u{1165}\u{11C0}",
        nfkc: "\u{C135}",
        nfkd: "\u{1109}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C136}",
        nfc: "\u{C136}",
        nfd: "\u{1109}\u{1165}\u{11C1}",
        nfkc: "\u{C136}",
        nfkd: "\u{1109}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C137}",
        nfc: "\u{C137}",
        nfd: "\u{1109}\u{1165}\u{11C2}",
        nfkc: "\u{C137}",
        nfkd: "\u{1109}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C138}",
        nfc: "\u{C138}",
        nfd: "\u{1109}\u{1166}",
        nfkc: "\u{C138}",
        nfkd: "\u{1109}\u{1166}",
    },
    NormalizationTest {
        source: "\u{C139}",
        nfc: "\u{C139}",
        nfd: "\u{1109}\u{1166}\u{11A8}",
        nfkc: "\u{C139}",
        nfkd: "\u{1109}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C13A}",
        nfc: "\u{C13A}",
        nfd: "\u{1109}\u{1166}\u{11A9}",
        nfkc: "\u{C13A}",
        nfkd: "\u{1109}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C13B}",
        nfc: "\u{C13B}",
        nfd: "\u{1109}\u{1166}\u{11AA}",
        nfkc: "\u{C13B}",
        nfkd: "\u{1109}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C13C}",
        nfc: "\u{C13C}",
        nfd: "\u{1109}\u{1166}\u{11AB}",
        nfkc: "\u{C13C}",
        nfkd: "\u{1109}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C13D}",
        nfc: "\u{C13D}",
        nfd: "\u{1109}\u{1166}\u{11AC}",
        nfkc: "\u{C13D}",
        nfkd: "\u{1109}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C13E}",
        nfc: "\u{C13E}",
        nfd: "\u{1109}\u{1166}\u{11AD}",
        nfkc: "\u{C13E}",
        nfkd: "\u{1109}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C13F}",
        nfc: "\u{C13F}",
        nfd: "\u{1109}\u{1166}\u{11AE}",
        nfkc: "\u{C13F}",
        nfkd: "\u{1109}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C140}",
        nfc: "\u{C140}",
        nfd: "\u{1109}\u{1166}\u{11AF}",
        nfkc: "\u{C140}",
        nfkd: "\u{1109}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C141}",
        nfc: "\u{C141}",
        nfd: "\u{1109}\u{1166}\u{11B0}",
        nfkc: "\u{C141}",
        nfkd: "\u{1109}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C142}",
        nfc: "\u{C142}",
        nfd: "\u{1109}\u{1166}\u{11B1}",
        nfkc: "\u{C142}",
        nfkd: "\u{1109}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C143}",
        nfc: "\u{C143}",
        nfd: "\u{1109}\u{1166}\u{11B2}",
        nfkc: "\u{C143}",
        nfkd: "\u{1109}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C144}",
        nfc: "\u{C144}",
        nfd: "\u{1109}\u{1166}\u{11B3}",
        nfkc: "\u{C144}",
        nfkd: "\u{1109}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C145}",
        nfc: "\u{C145}",
        nfd: "\u{1109}\u{1166}\u{11B4}",
        nfkc: "\u{C145}",
        nfkd: "\u{1109}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C146}",
        nfc: "\u{C146}",
        nfd: "\u{1109}\u{1166}\u{11B5}",
        nfkc: "\u{C146}",
        nfkd: "\u{1109}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C147}",
        nfc: "\u{C147}",
        nfd: "\u{1109}\u{1166}\u{11B6}",
        nfkc: "\u{C147}",
        nfkd: "\u{1109}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C148}",
        nfc: "\u{C148}",
        nfd: "\u{1109}\u{1166}\u{11B7}",
        nfkc: "\u{C148}",
        nfkd: "\u{1109}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C149}",
        nfc: "\u{C149}",
        nfd: "\u{1109}\u{1166}\u{11B8}",
        nfkc: "\u{C149}",
        nfkd: "\u{1109}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C14A}",
        nfc: "\u{C14A}",
        nfd: "\u{1109}\u{1166}\u{11B9}",
        nfkc: "\u{C14A}",
        nfkd: "\u{1109}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C14B}",
        nfc: "\u{C14B}",
        nfd: "\u{1109}\u{1166}\u{11BA}",
        nfkc: "\u{C14B}",
        nfkd: "\u{1109}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C14C}",
        nfc: "\u{C14C}",
        nfd: "\u{1109}\u{1166}\u{11BB}",
        nfkc: "\u{C14C}",
        nfkd: "\u{1109}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C14D}",
        nfc: "\u{C14D}",
        nfd: "\u{1109}\u{1166}\u{11BC}",
        nfkc: "\u{C14D}",
        nfkd: "\u{1109}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C14E}",
        nfc: "\u{C14E}",
        nfd: "\u{1109}\u{1166}\u{11BD}",
        nfkc: "\u{C14E}",
        nfkd: "\u{1109}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C14F}",
        nfc: "\u{C14F}",
        nfd: "\u{1109}\u{1166}\u{11BE}",
        nfkc: "\u{C14F}",
        nfkd: "\u{1109}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C150}",
        nfc: "\u{C150}",
        nfd: "\u{1109}\u{1166}\u{11BF}",
        nfkc: "\u{C150}",
        nfkd: "\u{1109}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C151}",
        nfc: "\u{C151}",
        nfd: "\u{1109}\u{1166}\u{11C0}",
        nfkc: "\u{C151}",
        nfkd: "\u{1109}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C152}",
        nfc: "\u{C152}",
        nfd: "\u{1109}\u{1166}\u{11C1}",
        nfkc: "\u{C152}",
        nfkd: "\u{1109}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C153}",
        nfc: "\u{C153}",
        nfd: "\u{1109}\u{1166}\u{11C2}",
        nfkc: "\u{C153}",
        nfkd: "\u{1109}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C154}",
        nfc: "\u{C154}",
        nfd: "\u{1109}\u{1167}",
        nfkc: "\u{C154}",
        nfkd: "\u{1109}\u{1167}",
    },
    NormalizationTest {
        source: "\u{C155}",
        nfc: "\u{C155}",
        nfd: "\u{1109}\u{1167}\u{11A8}",
        nfkc: "\u{C155}",
        nfkd: "\u{1109}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C156}",
        nfc: "\u{C156}",
        nfd: "\u{1109}\u{1167}\u{11A9}",
        nfkc: "\u{C156}",
        nfkd: "\u{1109}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C157}",
        nfc: "\u{C157}",
        nfd: "\u{1109}\u{1167}\u{11AA}",
        nfkc: "\u{C157}",
        nfkd: "\u{1109}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C158}",
        nfc: "\u{C158}",
        nfd: "\u{1109}\u{1167}\u{11AB}",
        nfkc: "\u{C158}",
        nfkd: "\u{1109}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C159}",
        nfc: "\u{C159}",
        nfd: "\u{1109}\u{1167}\u{11AC}",
        nfkc: "\u{C159}",
        nfkd: "\u{1109}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C15A}",
        nfc: "\u{C15A}",
        nfd: "\u{1109}\u{1167}\u{11AD}",
        nfkc: "\u{C15A}",
        nfkd: "\u{1109}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C15B}",
        nfc: "\u{C15B}",
        nfd: "\u{1109}\u{1167}\u{11AE}",
        nfkc: "\u{C15B}",
        nfkd: "\u{1109}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C15C}",
        nfc: "\u{C15C}",
        nfd: "\u{1109}\u{1167}\u{11AF}",
        nfkc: "\u{C15C}",
        nfkd: "\u{1109}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C15D}",
        nfc: "\u{C15D}",
        nfd: "\u{1109}\u{1167}\u{11B0}",
        nfkc: "\u{C15D}",
        nfkd: "\u{1109}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C15E}",
        nfc: "\u{C15E}",
        nfd: "\u{1109}\u{1167}\u{11B1}",
        nfkc: "\u{C15E}",
        nfkd: "\u{1109}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C15F}",
        nfc: "\u{C15F}",
        nfd: "\u{1109}\u{1167}\u{11B2}",
        nfkc: "\u{C15F}",
        nfkd: "\u{1109}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C160}",
        nfc: "\u{C160}",
        nfd: "\u{1109}\u{1167}\u{11B3}",
        nfkc: "\u{C160}",
        nfkd: "\u{1109}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C161}",
        nfc: "\u{C161}",
        nfd: "\u{1109}\u{1167}\u{11B4}",
        nfkc: "\u{C161}",
        nfkd: "\u{1109}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C162}",
        nfc: "\u{C162}",
        nfd: "\u{1109}\u{1167}\u{11B5}",
        nfkc: "\u{C162}",
        nfkd: "\u{1109}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C163}",
        nfc: "\u{C163}",
        nfd: "\u{1109}\u{1167}\u{11B6}",
        nfkc: "\u{C163}",
        nfkd: "\u{1109}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C164}",
        nfc: "\u{C164}",
        nfd: "\u{1109}\u{1167}\u{11B7}",
        nfkc: "\u{C164}",
        nfkd: "\u{1109}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C165}",
        nfc: "\u{C165}",
        nfd: "\u{1109}\u{1167}\u{11B8}",
        nfkc: "\u{C165}",
        nfkd: "\u{1109}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C166}",
        nfc: "\u{C166}",
        nfd: "\u{1109}\u{1167}\u{11B9}",
        nfkc: "\u{C166}",
        nfkd: "\u{1109}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C167}",
        nfc: "\u{C167}",
        nfd: "\u{1109}\u{1167}\u{11BA}",
        nfkc: "\u{C167}",
        nfkd: "\u{1109}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C168}",
        nfc: "\u{C168}",
        nfd: "\u{1109}\u{1167}\u{11BB}",
        nfkc: "\u{C168}",
        nfkd: "\u{1109}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C169}",
        nfc: "\u{C169}",
        nfd: "\u{1109}\u{1167}\u{11BC}",
        nfkc: "\u{C169}",
        nfkd: "\u{1109}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C16A}",
        nfc: "\u{C16A}",
        nfd: "\u{1109}\u{1167}\u{11BD}",
        nfkc: "\u{C16A}",
        nfkd: "\u{1109}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C16B}",
        nfc: "\u{C16B}",
        nfd: "\u{1109}\u{1167}\u{11BE}",
        nfkc: "\u{C16B}",
        nfkd: "\u{1109}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C16C}",
        nfc: "\u{C16C}",
        nfd: "\u{1109}\u{1167}\u{11BF}",
        nfkc: "\u{C16C}",
        nfkd: "\u{1109}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C16D}",
        nfc: "\u{C16D}",
        nfd: "\u{1109}\u{1167}\u{11C0}",
        nfkc: "\u{C16D}",
        nfkd: "\u{1109}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C16E}",
        nfc: "\u{C16E}",
        nfd: "\u{1109}\u{1167}\u{11C1}",
        nfkc: "\u{C16E}",
        nfkd: "\u{1109}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C16F}",
        nfc: "\u{C16F}",
        nfd: "\u{1109}\u{1167}\u{11C2}",
        nfkc: "\u{C16F}",
        nfkd: "\u{1109}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C170}",
        nfc: "\u{C170}",
        nfd: "\u{1109}\u{1168}",
        nfkc: "\u{C170}",
        nfkd: "\u{1109}\u{1168}",
    },
    NormalizationTest {
        source: "\u{C171}",
        nfc: "\u{C171}",
        nfd: "\u{1109}\u{1168}\u{11A8}",
        nfkc: "\u{C171}",
        nfkd: "\u{1109}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C172}",
        nfc: "\u{C172}",
        nfd: "\u{1109}\u{1168}\u{11A9}",
        nfkc: "\u{C172}",
        nfkd: "\u{1109}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C173}",
        nfc: "\u{C173}",
        nfd: "\u{1109}\u{1168}\u{11AA}",
        nfkc: "\u{C173}",
        nfkd: "\u{1109}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C174}",
        nfc: "\u{C174}",
        nfd: "\u{1109}\u{1168}\u{11AB}",
        nfkc: "\u{C174}",
        nfkd: "\u{1109}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C175}",
        nfc: "\u{C175}",
        nfd: "\u{1109}\u{1168}\u{11AC}",
        nfkc: "\u{C175}",
        nfkd: "\u{1109}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C176}",
        nfc: "\u{C176}",
        nfd: "\u{1109}\u{1168}\u{11AD}",
        nfkc: "\u{C176}",
        nfkd: "\u{1109}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C177}",
        nfc: "\u{C177}",
        nfd: "\u{1109}\u{1168}\u{11AE}",
        nfkc: "\u{C177}",
        nfkd: "\u{1109}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C178}",
        nfc: "\u{C178}",
        nfd: "\u{1109}\u{1168}\u{11AF}",
        nfkc: "\u{C178}",
        nfkd: "\u{1109}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C179}",
        nfc: "\u{C179}",
        nfd: "\u{1109}\u{1168}\u{11B0}",
        nfkc: "\u{C179}",
        nfkd: "\u{1109}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C17A}",
        nfc: "\u{C17A}",
        nfd: "\u{1109}\u{1168}\u{11B1}",
        nfkc: "\u{C17A}",
        nfkd: "\u{1109}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C17B}",
        nfc: "\u{C17B}",
        nfd: "\u{1109}\u{1168}\u{11B2}",
        nfkc: "\u{C17B}",
        nfkd: "\u{1109}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C17C}",
        nfc: "\u{C17C}",
        nfd: "\u{1109}\u{1168}\u{11B3}",
        nfkc: "\u{C17C}",
        nfkd: "\u{1109}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C17D}",
        nfc: "\u{C17D}",
        nfd: "\u{1109}\u{1168}\u{11B4}",
        nfkc: "\u{C17D}",
        nfkd: "\u{1109}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C17E}",
        nfc: "\u{C17E}",
        nfd: "\u{1109}\u{1168}\u{11B5}",
        nfkc: "\u{C17E}",
        nfkd: "\u{1109}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C17F}",
        nfc: "\u{C17F}",
        nfd: "\u{1109}\u{1168}\u{11B6}",
        nfkc: "\u{C17F}",
        nfkd: "\u{1109}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C180}",
        nfc: "\u{C180}",
        nfd: "\u{1109}\u{1168}\u{11B7}",
        nfkc: "\u{C180}",
        nfkd: "\u{1109}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C181}",
        nfc: "\u{C181}",
        nfd: "\u{1109}\u{1168}\u{11B8}",
        nfkc: "\u{C181}",
        nfkd: "\u{1109}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C182}",
        nfc: "\u{C182}",
        nfd: "\u{1109}\u{1168}\u{11B9}",
        nfkc: "\u{C182}",
        nfkd: "\u{1109}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C183}",
        nfc: "\u{C183}",
        nfd: "\u{1109}\u{1168}\u{11BA}",
        nfkc: "\u{C183}",
        nfkd: "\u{1109}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C184}",
        nfc: "\u{C184}",
        nfd: "\u{1109}\u{1168}\u{11BB}",
        nfkc: "\u{C184}",
        nfkd: "\u{1109}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C185}",
        nfc: "\u{C185}",
        nfd: "\u{1109}\u{1168}\u{11BC}",
        nfkc: "\u{C185}",
        nfkd: "\u{1109}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C186}",
        nfc: "\u{C186}",
        nfd: "\u{1109}\u{1168}\u{11BD}",
        nfkc: "\u{C186}",
        nfkd: "\u{1109}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C187}",
        nfc: "\u{C187}",
        nfd: "\u{1109}\u{1168}\u{11BE}",
        nfkc: "\u{C187}",
        nfkd: "\u{1109}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C188}",
        nfc: "\u{C188}",
        nfd: "\u{1109}\u{1168}\u{11BF}",
        nfkc: "\u{C188}",
        nfkd: "\u{1109}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C189}",
        nfc: "\u{C189}",
        nfd: "\u{1109}\u{1168}\u{11C0}",
        nfkc: "\u{C189}",
        nfkd: "\u{1109}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C18A}",
        nfc: "\u{C18A}",
        nfd: "\u{1109}\u{1168}\u{11C1}",
        nfkc: "\u{C18A}",
        nfkd: "\u{1109}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C18B}",
        nfc: "\u{C18B}",
        nfd: "\u{1109}\u{1168}\u{11C2}",
        nfkc: "\u{C18B}",
        nfkd: "\u{1109}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C18C}",
        nfc: "\u{C18C}",
        nfd: "\u{1109}\u{1169}",
        nfkc: "\u{C18C}",
        nfkd: "\u{1109}\u{1169}",
    },
    NormalizationTest {
        source: "\u{C18D}",
        nfc: "\u{C18D}",
        nfd: "\u{1109}\u{1169}\u{11A8}",
        nfkc: "\u{C18D}",
        nfkd: "\u{1109}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C18E}",
        nfc: "\u{C18E}",
        nfd: "\u{1109}\u{1169}\u{11A9}",
        nfkc: "\u{C18E}",
        nfkd: "\u{1109}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C18F}",
        nfc: "\u{C18F}",
        nfd: "\u{1109}\u{1169}\u{11AA}",
        nfkc: "\u{C18F}",
        nfkd: "\u{1109}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C190}",
        nfc: "\u{C190}",
        nfd: "\u{1109}\u{1169}\u{11AB}",
        nfkc: "\u{C190}",
        nfkd: "\u{1109}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C191}",
        nfc: "\u{C191}",
        nfd: "\u{1109}\u{1169}\u{11AC}",
        nfkc: "\u{C191}",
        nfkd: "\u{1109}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C192}",
        nfc: "\u{C192}",
        nfd: "\u{1109}\u{1169}\u{11AD}",
        nfkc: "\u{C192}",
        nfkd: "\u{1109}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C193}",
        nfc: "\u{C193}",
        nfd: "\u{1109}\u{1169}\u{11AE}",
        nfkc: "\u{C193}",
        nfkd: "\u{1109}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C194}",
        nfc: "\u{C194}",
        nfd: "\u{1109}\u{1169}\u{11AF}",
        nfkc: "\u{C194}",
        nfkd: "\u{1109}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C195}",
        nfc: "\u{C195}",
        nfd: "\u{1109}\u{1169}\u{11B0}",
        nfkc: "\u{C195}",
        nfkd: "\u{1109}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C196}",
        nfc: "\u{C196}",
        nfd: "\u{1109}\u{1169}\u{11B1}",
        nfkc: "\u{C196}",
        nfkd: "\u{1109}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C197}",
        nfc: "\u{C197}",
        nfd: "\u{1109}\u{1169}\u{11B2}",
        nfkc: "\u{C197}",
        nfkd: "\u{1109}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C198}",
        nfc: "\u{C198}",
        nfd: "\u{1109}\u{1169}\u{11B3}",
        nfkc: "\u{C198}",
        nfkd: "\u{1109}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C199}",
        nfc: "\u{C199}",
        nfd: "\u{1109}\u{1169}\u{11B4}",
        nfkc: "\u{C199}",
        nfkd: "\u{1109}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C19A}",
        nfc: "\u{C19A}",
        nfd: "\u{1109}\u{1169}\u{11B5}",
        nfkc: "\u{C19A}",
        nfkd: "\u{1109}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C19B}",
        nfc: "\u{C19B}",
        nfd: "\u{1109}\u{1169}\u{11B6}",
        nfkc: "\u{C19B}",
        nfkd: "\u{1109}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C19C}",
        nfc: "\u{C19C}",
        nfd: "\u{1109}\u{1169}\u{11B7}",
        nfkc: "\u{C19C}",
        nfkd: "\u{1109}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C19D}",
        nfc: "\u{C19D}",
        nfd: "\u{1109}\u{1169}\u{11B8}",
        nfkc: "\u{C19D}",
        nfkd: "\u{1109}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C19E}",
        nfc: "\u{C19E}",
        nfd: "\u{1109}\u{1169}\u{11B9}",
        nfkc: "\u{C19E}",
        nfkd: "\u{1109}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C19F}",
        nfc: "\u{C19F}",
        nfd: "\u{1109}\u{1169}\u{11BA}",
        nfkc: "\u{C19F}",
        nfkd: "\u{1109}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C1A0}",
        nfc: "\u{C1A0}",
        nfd: "\u{1109}\u{1169}\u{11BB}",
        nfkc: "\u{C1A0}",
        nfkd: "\u{1109}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C1A1}",
        nfc: "\u{C1A1}",
        nfd: "\u{1109}\u{1169}\u{11BC}",
        nfkc: "\u{C1A1}",
        nfkd: "\u{1109}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C1A2}",
        nfc: "\u{C1A2}",
        nfd: "\u{1109}\u{1169}\u{11BD}",
        nfkc: "\u{C1A2}",
        nfkd: "\u{1109}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C1A3}",
        nfc: "\u{C1A3}",
        nfd: "\u{1109}\u{1169}\u{11BE}",
        nfkc: "\u{C1A3}",
        nfkd: "\u{1109}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C1A4}",
        nfc: "\u{C1A4}",
        nfd: "\u{1109}\u{1169}\u{11BF}",
        nfkc: "\u{C1A4}",
        nfkd: "\u{1109}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C1A5}",
        nfc: "\u{C1A5}",
        nfd: "\u{1109}\u{1169}\u{11C0}",
        nfkc: "\u{C1A5}",
        nfkd: "\u{1109}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C1A6}",
        nfc: "\u{C1A6}",
        nfd: "\u{1109}\u{1169}\u{11C1}",
        nfkc: "\u{C1A6}",
        nfkd: "\u{1109}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C1A7}",
        nfc: "\u{C1A7}",
        nfd: "\u{1109}\u{1169}\u{11C2}",
        nfkc: "\u{C1A7}",
        nfkd: "\u{1109}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C1A8}",
        nfc: "\u{C1A8}",
        nfd: "\u{1109}\u{116A}",
        nfkc: "\u{C1A8}",
        nfkd: "\u{1109}\u{116A}",
    },
    NormalizationTest {
        source: "\u{C1A9}",
        nfc: "\u{C1A9}",
        nfd: "\u{1109}\u{116A}\u{11A8}",
        nfkc: "\u{C1A9}",
        nfkd: "\u{1109}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C1AA}",
        nfc: "\u{C1AA}",
        nfd: "\u{1109}\u{116A}\u{11A9}",
        nfkc: "\u{C1AA}",
        nfkd: "\u{1109}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C1AB}",
        nfc: "\u{C1AB}",
        nfd: "\u{1109}\u{116A}\u{11AA}",
        nfkc: "\u{C1AB}",
        nfkd: "\u{1109}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C1AC}",
        nfc: "\u{C1AC}",
        nfd: "\u{1109}\u{116A}\u{11AB}",
        nfkc: "\u{C1AC}",
        nfkd: "\u{1109}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C1AD}",
        nfc: "\u{C1AD}",
        nfd: "\u{1109}\u{116A}\u{11AC}",
        nfkc: "\u{C1AD}",
        nfkd: "\u{1109}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C1AE}",
        nfc: "\u{C1AE}",
        nfd: "\u{1109}\u{116A}\u{11AD}",
        nfkc: "\u{C1AE}",
        nfkd: "\u{1109}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C1AF}",
        nfc: "\u{C1AF}",
        nfd: "\u{1109}\u{116A}\u{11AE}",
        nfkc: "\u{C1AF}",
        nfkd: "\u{1109}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C1B0}",
        nfc: "\u{C1B0}",
        nfd: "\u{1109}\u{116A}\u{11AF}",
        nfkc: "\u{C1B0}",
        nfkd: "\u{1109}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C1B1}",
        nfc: "\u{C1B1}",
        nfd: "\u{1109}\u{116A}\u{11B0}",
        nfkc: "\u{C1B1}",
        nfkd: "\u{1109}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C1B2}",
        nfc: "\u{C1B2}",
        nfd: "\u{1109}\u{116A}\u{11B1}",
        nfkc: "\u{C1B2}",
        nfkd: "\u{1109}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C1B3}",
        nfc: "\u{C1B3}",
        nfd: "\u{1109}\u{116A}\u{11B2}",
        nfkc: "\u{C1B3}",
        nfkd: "\u{1109}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C1B4}",
        nfc: "\u{C1B4}",
        nfd: "\u{1109}\u{116A}\u{11B3}",
        nfkc: "\u{C1B4}",
        nfkd: "\u{1109}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C1B5}",
        nfc: "\u{C1B5}",
        nfd: "\u{1109}\u{116A}\u{11B4}",
        nfkc: "\u{C1B5}",
        nfkd: "\u{1109}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C1B6}",
        nfc: "\u{C1B6}",
        nfd: "\u{1109}\u{116A}\u{11B5}",
        nfkc: "\u{C1B6}",
        nfkd: "\u{1109}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C1B7}",
        nfc: "\u{C1B7}",
        nfd: "\u{1109}\u{116A}\u{11B6}",
        nfkc: "\u{C1B7}",
        nfkd: "\u{1109}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C1B8}",
        nfc: "\u{C1B8}",
        nfd: "\u{1109}\u{116A}\u{11B7}",
        nfkc: "\u{C1B8}",
        nfkd: "\u{1109}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C1B9}",
        nfc: "\u{C1B9}",
        nfd: "\u{1109}\u{116A}\u{11B8}",
        nfkc: "\u{C1B9}",
        nfkd: "\u{1109}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C1BA}",
        nfc: "\u{C1BA}",
        nfd: "\u{1109}\u{116A}\u{11B9}",
        nfkc: "\u{C1BA}",
        nfkd: "\u{1109}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C1BB}",
        nfc: "\u{C1BB}",
        nfd: "\u{1109}\u{116A}\u{11BA}",
        nfkc: "\u{C1BB}",
        nfkd: "\u{1109}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C1BC}",
        nfc: "\u{C1BC}",
        nfd: "\u{1109}\u{116A}\u{11BB}",
        nfkc: "\u{C1BC}",
        nfkd: "\u{1109}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C1BD}",
        nfc: "\u{C1BD}",
        nfd: "\u{1109}\u{116A}\u{11BC}",
        nfkc: "\u{C1BD}",
        nfkd: "\u{1109}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C1BE}",
        nfc: "\u{C1BE}",
        nfd: "\u{1109}\u{116A}\u{11BD}",
        nfkc: "\u{C1BE}",
        nfkd: "\u{1109}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C1BF}",
        nfc: "\u{C1BF}",
        nfd: "\u{1109}\u{116A}\u{11BE}",
        nfkc: "\u{C1BF}",
        nfkd: "\u{1109}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C1C0}",
        nfc: "\u{C1C0}",
        nfd: "\u{1109}\u{116A}\u{11BF}",
        nfkc: "\u{C1C0}",
        nfkd: "\u{1109}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C1C1}",
        nfc: "\u{C1C1}",
        nfd: "\u{1109}\u{116A}\u{11C0}",
        nfkc: "\u{C1C1}",
        nfkd: "\u{1109}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C1C2}",
        nfc: "\u{C1C2}",
        nfd: "\u{1109}\u{116A}\u{11C1}",
        nfkc: "\u{C1C2}",
        nfkd: "\u{1109}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C1C3}",
        nfc: "\u{C1C3}",
        nfd: "\u{1109}\u{116A}\u{11C2}",
        nfkc: "\u{C1C3}",
        nfkd: "\u{1109}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C1C4}",
        nfc: "\u{C1C4}",
        nfd: "\u{1109}\u{116B}",
        nfkc: "\u{C1C4}",
        nfkd: "\u{1109}\u{116B}",
    },
    NormalizationTest {
        source: "\u{C1C5}",
        nfc: "\u{C1C5}",
        nfd: "\u{1109}\u{116B}\u{11A8}",
        nfkc: "\u{C1C5}",
        nfkd: "\u{1109}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C1C6}",
        nfc: "\u{C1C6}",
        nfd: "\u{1109}\u{116B}\u{11A9}",
        nfkc: "\u{C1C6}",
        nfkd: "\u{1109}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C1C7}",
        nfc: "\u{C1C7}",
        nfd: "\u{1109}\u{116B}\u{11AA}",
        nfkc: "\u{C1C7}",
        nfkd: "\u{1109}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C1C8}",
        nfc: "\u{C1C8}",
        nfd: "\u{1109}\u{116B}\u{11AB}",
        nfkc: "\u{C1C8}",
        nfkd: "\u{1109}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C1C9}",
        nfc: "\u{C1C9}",
        nfd: "\u{1109}\u{116B}\u{11AC}",
        nfkc: "\u{C1C9}",
        nfkd: "\u{1109}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C1CA}",
        nfc: "\u{C1CA}",
        nfd: "\u{1109}\u{116B}\u{11AD}",
        nfkc: "\u{C1CA}",
        nfkd: "\u{1109}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C1CB}",
        nfc: "\u{C1CB}",
        nfd: "\u{1109}\u{116B}\u{11AE}",
        nfkc: "\u{C1CB}",
        nfkd: "\u{1109}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C1CC}",
        nfc: "\u{C1CC}",
        nfd: "\u{1109}\u{116B}\u{11AF}",
        nfkc: "\u{C1CC}",
        nfkd: "\u{1109}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C1CD}",
        nfc: "\u{C1CD}",
        nfd: "\u{1109}\u{116B}\u{11B0}",
        nfkc: "\u{C1CD}",
        nfkd: "\u{1109}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C1CE}",
        nfc: "\u{C1CE}",
        nfd: "\u{1109}\u{116B}\u{11B1}",
        nfkc: "\u{C1CE}",
        nfkd: "\u{1109}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C1CF}",
        nfc: "\u{C1CF}",
        nfd: "\u{1109}\u{116B}\u{11B2}",
        nfkc: "\u{C1CF}",
        nfkd: "\u{1109}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C1D0}",
        nfc: "\u{C1D0}",
        nfd: "\u{1109}\u{116B}\u{11B3}",
        nfkc: "\u{C1D0}",
        nfkd: "\u{1109}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C1D1}",
        nfc: "\u{C1D1}",
        nfd: "\u{1109}\u{116B}\u{11B4}",
        nfkc: "\u{C1D1}",
        nfkd: "\u{1109}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C1D2}",
        nfc: "\u{C1D2}",
        nfd: "\u{1109}\u{116B}\u{11B5}",
        nfkc: "\u{C1D2}",
        nfkd: "\u{1109}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C1D3}",
        nfc: "\u{C1D3}",
        nfd: "\u{1109}\u{116B}\u{11B6}",
        nfkc: "\u{C1D3}",
        nfkd: "\u{1109}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C1D4}",
        nfc: "\u{C1D4}",
        nfd: "\u{1109}\u{116B}\u{11B7}",
        nfkc: "\u{C1D4}",
        nfkd: "\u{1109}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C1D5}",
        nfc: "\u{C1D5}",
        nfd: "\u{1109}\u{116B}\u{11B8}",
        nfkc: "\u{C1D5}",
        nfkd: "\u{1109}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C1D6}",
        nfc: "\u{C1D6}",
        nfd: "\u{1109}\u{116B}\u{11B9}",
        nfkc: "\u{C1D6}",
        nfkd: "\u{1109}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C1D7}",
        nfc: "\u{C1D7}",
        nfd: "\u{1109}\u{116B}\u{11BA}",
        nfkc: "\u{C1D7}",
        nfkd: "\u{1109}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C1D8}",
        nfc: "\u{C1D8}",
        nfd: "\u{1109}\u{116B}\u{11BB}",
        nfkc: "\u{C1D8}",
        nfkd: "\u{1109}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C1D9}",
        nfc: "\u{C1D9}",
        nfd: "\u{1109}\u{116B}\u{11BC}",
        nfkc: "\u{C1D9}",
        nfkd: "\u{1109}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C1DA}",
        nfc: "\u{C1DA}",
        nfd: "\u{1109}\u{116B}\u{11BD}",
        nfkc: "\u{C1DA}",
        nfkd: "\u{1109}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C1DB}",
        nfc: "\u{C1DB}",
        nfd: "\u{1109}\u{116B}\u{11BE}",
        nfkc: "\u{C1DB}",
        nfkd: "\u{1109}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C1DC}",
        nfc: "\u{C1DC}",
        nfd: "\u{1109}\u{116B}\u{11BF}",
        nfkc: "\u{C1DC}",
        nfkd: "\u{1109}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C1DD}",
        nfc: "\u{C1DD}",
        nfd: "\u{1109}\u{116B}\u{11C0}",
        nfkc: "\u{C1DD}",
        nfkd: "\u{1109}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C1DE}",
        nfc: "\u{C1DE}",
        nfd: "\u{1109}\u{116B}\u{11C1}",
        nfkc: "\u{C1DE}",
        nfkd: "\u{1109}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C1DF}",
        nfc: "\u{C1DF}",
        nfd: "\u{1109}\u{116B}\u{11C2}",
        nfkc: "\u{C1DF}",
        nfkd: "\u{1109}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C1E0}",
        nfc: "\u{C1E0}",
        nfd: "\u{1109}\u{116C}",
        nfkc: "\u{C1E0}",
        nfkd: "\u{1109}\u{116C}",
    },
    NormalizationTest {
        source: "\u{C1E1}",
        nfc: "\u{C1E1}",
        nfd: "\u{1109}\u{116C}\u{11A8}",
        nfkc: "\u{C1E1}",
        nfkd: "\u{1109}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C1E2}",
        nfc: "\u{C1E2}",
        nfd: "\u{1109}\u{116C}\u{11A9}",
        nfkc: "\u{C1E2}",
        nfkd: "\u{1109}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C1E3}",
        nfc: "\u{C1E3}",
        nfd: "\u{1109}\u{116C}\u{11AA}",
        nfkc: "\u{C1E3}",
        nfkd: "\u{1109}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C1E4}",
        nfc: "\u{C1E4}",
        nfd: "\u{1109}\u{116C}\u{11AB}",
        nfkc: "\u{C1E4}",
        nfkd: "\u{1109}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C1E5}",
        nfc: "\u{C1E5}",
        nfd: "\u{1109}\u{116C}\u{11AC}",
        nfkc: "\u{C1E5}",
        nfkd: "\u{1109}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C1E6}",
        nfc: "\u{C1E6}",
        nfd: "\u{1109}\u{116C}\u{11AD}",
        nfkc: "\u{C1E6}",
        nfkd: "\u{1109}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C1E7}",
        nfc: "\u{C1E7}",
        nfd: "\u{1109}\u{116C}\u{11AE}",
        nfkc: "\u{C1E7}",
        nfkd: "\u{1109}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C1E8}",
        nfc: "\u{C1E8}",
        nfd: "\u{1109}\u{116C}\u{11AF}",
        nfkc: "\u{C1E8}",
        nfkd: "\u{1109}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C1E9}",
        nfc: "\u{C1E9}",
        nfd: "\u{1109}\u{116C}\u{11B0}",
        nfkc: "\u{C1E9}",
        nfkd: "\u{1109}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C1EA}",
        nfc: "\u{C1EA}",
        nfd: "\u{1109}\u{116C}\u{11B1}",
        nfkc: "\u{C1EA}",
        nfkd: "\u{1109}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C1EB}",
        nfc: "\u{C1EB}",
        nfd: "\u{1109}\u{116C}\u{11B2}",
        nfkc: "\u{C1EB}",
        nfkd: "\u{1109}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C1EC}",
        nfc: "\u{C1EC}",
        nfd: "\u{1109}\u{116C}\u{11B3}",
        nfkc: "\u{C1EC}",
        nfkd: "\u{1109}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C1ED}",
        nfc: "\u{C1ED}",
        nfd: "\u{1109}\u{116C}\u{11B4}",
        nfkc: "\u{C1ED}",
        nfkd: "\u{1109}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C1EE}",
        nfc: "\u{C1EE}",
        nfd: "\u{1109}\u{116C}\u{11B5}",
        nfkc: "\u{C1EE}",
        nfkd: "\u{1109}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C1EF}",
        nfc: "\u{C1EF}",
        nfd: "\u{1109}\u{116C}\u{11B6}",
        nfkc: "\u{C1EF}",
        nfkd: "\u{1109}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C1F0}",
        nfc: "\u{C1F0}",
        nfd: "\u{1109}\u{116C}\u{11B7}",
        nfkc: "\u{C1F0}",
        nfkd: "\u{1109}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C1F1}",
        nfc: "\u{C1F1}",
        nfd: "\u{1109}\u{116C}\u{11B8}",
        nfkc: "\u{C1F1}",
        nfkd: "\u{1109}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C1F2}",
        nfc: "\u{C1F2}",
        nfd: "\u{1109}\u{116C}\u{11B9}",
        nfkc: "\u{C1F2}",
        nfkd: "\u{1109}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C1F3}",
        nfc: "\u{C1F3}",
        nfd: "\u{1109}\u{116C}\u{11BA}",
        nfkc: "\u{C1F3}",
        nfkd: "\u{1109}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C1F4}",
        nfc: "\u{C1F4}",
        nfd: "\u{1109}\u{116C}\u{11BB}",
        nfkc: "\u{C1F4}",
        nfkd: "\u{1109}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C1F5}",
        nfc: "\u{C1F5}",
        nfd: "\u{1109}\u{116C}\u{11BC}",
        nfkc: "\u{C1F5}",
        nfkd: "\u{1109}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C1F6}",
        nfc: "\u{C1F6}",
        nfd: "\u{1109}\u{116C}\u{11BD}",
        nfkc: "\u{C1F6}",
        nfkd: "\u{1109}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C1F7}",
        nfc: "\u{C1F7}",
        nfd: "\u{1109}\u{116C}\u{11BE}",
        nfkc: "\u{C1F7}",
        nfkd: "\u{1109}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C1F8}",
        nfc: "\u{C1F8}",
        nfd: "\u{1109}\u{116C}\u{11BF}",
        nfkc: "\u{C1F8}",
        nfkd: "\u{1109}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C1F9}",
        nfc: "\u{C1F9}",
        nfd: "\u{1109}\u{116C}\u{11C0}",
        nfkc: "\u{C1F9}",
        nfkd: "\u{1109}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C1FA}",
        nfc: "\u{C1FA}",
        nfd: "\u{1109}\u{116C}\u{11C1}",
        nfkc: "\u{C1FA}",
        nfkd: "\u{1109}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C1FB}",
        nfc: "\u{C1FB}",
        nfd: "\u{1109}\u{116C}\u{11C2}",
        nfkc: "\u{C1FB}",
        nfkd: "\u{1109}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C1FC}",
        nfc: "\u{C1FC}",
        nfd: "\u{1109}\u{116D}",
        nfkc: "\u{C1FC}",
        nfkd: "\u{1109}\u{116D}",
    },
    NormalizationTest {
        source: "\u{C1FD}",
        nfc: "\u{C1FD}",
        nfd: "\u{1109}\u{116D}\u{11A8}",
        nfkc: "\u{C1FD}",
        nfkd: "\u{1109}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C1FE}",
        nfc: "\u{C1FE}",
        nfd: "\u{1109}\u{116D}\u{11A9}",
        nfkc: "\u{C1FE}",
        nfkd: "\u{1109}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C1FF}",
        nfc: "\u{C1FF}",
        nfd: "\u{1109}\u{116D}\u{11AA}",
        nfkc: "\u{C1FF}",
        nfkd: "\u{1109}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C200}",
        nfc: "\u{C200}",
        nfd: "\u{1109}\u{116D}\u{11AB}",
        nfkc: "\u{C200}",
        nfkd: "\u{1109}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C201}",
        nfc: "\u{C201}",
        nfd: "\u{1109}\u{116D}\u{11AC}",
        nfkc: "\u{C201}",
        nfkd: "\u{1109}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C202}",
        nfc: "\u{C202}",
        nfd: "\u{1109}\u{116D}\u{11AD}",
        nfkc: "\u{C202}",
        nfkd: "\u{1109}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C203}",
        nfc: "\u{C203}",
        nfd: "\u{1109}\u{116D}\u{11AE}",
        nfkc: "\u{C203}",
        nfkd: "\u{1109}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C204}",
        nfc: "\u{C204}",
        nfd: "\u{1109}\u{116D}\u{11AF}",
        nfkc: "\u{C204}",
        nfkd: "\u{1109}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C205}",
        nfc: "\u{C205}",
        nfd: "\u{1109}\u{116D}\u{11B0}",
        nfkc: "\u{C205}",
        nfkd: "\u{1109}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C206}",
        nfc: "\u{C206}",
        nfd: "\u{1109}\u{116D}\u{11B1}",
        nfkc: "\u{C206}",
        nfkd: "\u{1109}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C207}",
        nfc: "\u{C207}",
        nfd: "\u{1109}\u{116D}\u{11B2}",
        nfkc: "\u{C207}",
        nfkd: "\u{1109}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C208}",
        nfc: "\u{C208}",
        nfd: "\u{1109}\u{116D}\u{11B3}",
        nfkc: "\u{C208}",
        nfkd: "\u{1109}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C209}",
        nfc: "\u{C209}",
        nfd: "\u{1109}\u{116D}\u{11B4}",
        nfkc: "\u{C209}",
        nfkd: "\u{1109}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C20A}",
        nfc: "\u{C20A}",
        nfd: "\u{1109}\u{116D}\u{11B5}",
        nfkc: "\u{C20A}",
        nfkd: "\u{1109}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C20B}",
        nfc: "\u{C20B}",
        nfd: "\u{1109}\u{116D}\u{11B6}",
        nfkc: "\u{C20B}",
        nfkd: "\u{1109}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C20C}",
        nfc: "\u{C20C}",
        nfd: "\u{1109}\u{116D}\u{11B7}",
        nfkc: "\u{C20C}",
        nfkd: "\u{1109}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C20D}",
        nfc: "\u{C20D}",
        nfd: "\u{1109}\u{116D}\u{11B8}",
        nfkc: "\u{C20D}",
        nfkd: "\u{1109}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C20E}",
        nfc: "\u{C20E}",
        nfd: "\u{1109}\u{116D}\u{11B9}",
        nfkc: "\u{C20E}",
        nfkd: "\u{1109}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C20F}",
        nfc: "\u{C20F}",
        nfd: "\u{1109}\u{116D}\u{11BA}",
        nfkc: "\u{C20F}",
        nfkd: "\u{1109}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C210}",
        nfc: "\u{C210}",
        nfd: "\u{1109}\u{116D}\u{11BB}",
        nfkc: "\u{C210}",
        nfkd: "\u{1109}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C211}",
        nfc: "\u{C211}",
        nfd: "\u{1109}\u{116D}\u{11BC}",
        nfkc: "\u{C211}",
        nfkd: "\u{1109}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C212}",
        nfc: "\u{C212}",
        nfd: "\u{1109}\u{116D}\u{11BD}",
        nfkc: "\u{C212}",
        nfkd: "\u{1109}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C213}",
        nfc: "\u{C213}",
        nfd: "\u{1109}\u{116D}\u{11BE}",
        nfkc: "\u{C213}",
        nfkd: "\u{1109}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C214}",
        nfc: "\u{C214}",
        nfd: "\u{1109}\u{116D}\u{11BF}",
        nfkc: "\u{C214}",
        nfkd: "\u{1109}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C215}",
        nfc: "\u{C215}",
        nfd: "\u{1109}\u{116D}\u{11C0}",
        nfkc: "\u{C215}",
        nfkd: "\u{1109}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C216}",
        nfc: "\u{C216}",
        nfd: "\u{1109}\u{116D}\u{11C1}",
        nfkc: "\u{C216}",
        nfkd: "\u{1109}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C217}",
        nfc: "\u{C217}",
        nfd: "\u{1109}\u{116D}\u{11C2}",
        nfkc: "\u{C217}",
        nfkd: "\u{1109}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C218}",
        nfc: "\u{C218}",
        nfd: "\u{1109}\u{116E}",
        nfkc: "\u{C218}",
        nfkd: "\u{1109}\u{116E}",
    },
    NormalizationTest {
        source: "\u{C219}",
        nfc: "\u{C219}",
        nfd: "\u{1109}\u{116E}\u{11A8}",
        nfkc: "\u{C219}",
        nfkd: "\u{1109}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C21A}",
        nfc: "\u{C21A}",
        nfd: "\u{1109}\u{116E}\u{11A9}",
        nfkc: "\u{C21A}",
        nfkd: "\u{1109}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C21B}",
        nfc: "\u{C21B}",
        nfd: "\u{1109}\u{116E}\u{11AA}",
        nfkc: "\u{C21B}",
        nfkd: "\u{1109}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C21C}",
        nfc: "\u{C21C}",
        nfd: "\u{1109}\u{116E}\u{11AB}",
        nfkc: "\u{C21C}",
        nfkd: "\u{1109}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C21D}",
        nfc: "\u{C21D}",
        nfd: "\u{1109}\u{116E}\u{11AC}",
        nfkc: "\u{C21D}",
        nfkd: "\u{1109}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C21E}",
        nfc: "\u{C21E}",
        nfd: "\u{1109}\u{116E}\u{11AD}",
        nfkc: "\u{C21E}",
        nfkd: "\u{1109}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C21F}",
        nfc: "\u{C21F}",
        nfd: "\u{1109}\u{116E}\u{11AE}",
        nfkc: "\u{C21F}",
        nfkd: "\u{1109}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C220}",
        nfc: "\u{C220}",
        nfd: "\u{1109}\u{116E}\u{11AF}",
        nfkc: "\u{C220}",
        nfkd: "\u{1109}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C221}",
        nfc: "\u{C221}",
        nfd: "\u{1109}\u{116E}\u{11B0}",
        nfkc: "\u{C221}",
        nfkd: "\u{1109}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C222}",
        nfc: "\u{C222}",
        nfd: "\u{1109}\u{116E}\u{11B1}",
        nfkc: "\u{C222}",
        nfkd: "\u{1109}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C223}",
        nfc: "\u{C223}",
        nfd: "\u{1109}\u{116E}\u{11B2}",
        nfkc: "\u{C223}",
        nfkd: "\u{1109}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C224}",
        nfc: "\u{C224}",
        nfd: "\u{1109}\u{116E}\u{11B3}",
        nfkc: "\u{C224}",
        nfkd: "\u{1109}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C225}",
        nfc: "\u{C225}",
        nfd: "\u{1109}\u{116E}\u{11B4}",
        nfkc: "\u{C225}",
        nfkd: "\u{1109}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C226}",
        nfc: "\u{C226}",
        nfd: "\u{1109}\u{116E}\u{11B5}",
        nfkc: "\u{C226}",
        nfkd: "\u{1109}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C227}",
        nfc: "\u{C227}",
        nfd: "\u{1109}\u{116E}\u{11B6}",
        nfkc: "\u{C227}",
        nfkd: "\u{1109}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C228}",
        nfc: "\u{C228}",
        nfd: "\u{1109}\u{116E}\u{11B7}",
        nfkc: "\u{C228}",
        nfkd: "\u{1109}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C229}",
        nfc: "\u{C229}",
        nfd: "\u{1109}\u{116E}\u{11B8}",
        nfkc: "\u{C229}",
        nfkd: "\u{1109}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C22A}",
        nfc: "\u{C22A}",
        nfd: "\u{1109}\u{116E}\u{11B9}",
        nfkc: "\u{C22A}",
        nfkd: "\u{1109}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C22B}",
        nfc: "\u{C22B}",
        nfd: "\u{1109}\u{116E}\u{11BA}",
        nfkc: "\u{C22B}",
        nfkd: "\u{1109}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C22C}",
        nfc: "\u{C22C}",
        nfd: "\u{1109}\u{116E}\u{11BB}",
        nfkc: "\u{C22C}",
        nfkd: "\u{1109}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C22D}",
        nfc: "\u{C22D}",
        nfd: "\u{1109}\u{116E}\u{11BC}",
        nfkc: "\u{C22D}",
        nfkd: "\u{1109}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C22E}",
        nfc: "\u{C22E}",
        nfd: "\u{1109}\u{116E}\u{11BD}",
        nfkc: "\u{C22E}",
        nfkd: "\u{1109}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C22F}",
        nfc: "\u{C22F}",
        nfd: "\u{1109}\u{116E}\u{11BE}",
        nfkc: "\u{C22F}",
        nfkd: "\u{1109}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C230}",
        nfc: "\u{C230}",
        nfd: "\u{1109}\u{116E}\u{11BF}",
        nfkc: "\u{C230}",
        nfkd: "\u{1109}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C231}",
        nfc: "\u{C231}",
        nfd: "\u{1109}\u{116E}\u{11C0}",
        nfkc: "\u{C231}",
        nfkd: "\u{1109}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C232}",
        nfc: "\u{C232}",
        nfd: "\u{1109}\u{116E}\u{11C1}",
        nfkc: "\u{C232}",
        nfkd: "\u{1109}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C233}",
        nfc: "\u{C233}",
        nfd: "\u{1109}\u{116E}\u{11C2}",
        nfkc: "\u{C233}",
        nfkd: "\u{1109}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C234}",
        nfc: "\u{C234}",
        nfd: "\u{1109}\u{116F}",
        nfkc: "\u{C234}",
        nfkd: "\u{1109}\u{116F}",
    },
    NormalizationTest {
        source: "\u{C235}",
        nfc: "\u{C235}",
        nfd: "\u{1109}\u{116F}\u{11A8}",
        nfkc: "\u{C235}",
        nfkd: "\u{1109}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C236}",
        nfc: "\u{C236}",
        nfd: "\u{1109}\u{116F}\u{11A9}",
        nfkc: "\u{C236}",
        nfkd: "\u{1109}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C237}",
        nfc: "\u{C237}",
        nfd: "\u{1109}\u{116F}\u{11AA}",
        nfkc: "\u{C237}",
        nfkd: "\u{1109}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C238}",
        nfc: "\u{C238}",
        nfd: "\u{1109}\u{116F}\u{11AB}",
        nfkc: "\u{C238}",
        nfkd: "\u{1109}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C239}",
        nfc: "\u{C239}",
        nfd: "\u{1109}\u{116F}\u{11AC}",
        nfkc: "\u{C239}",
        nfkd: "\u{1109}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C23A}",
        nfc: "\u{C23A}",
        nfd: "\u{1109}\u{116F}\u{11AD}",
        nfkc: "\u{C23A}",
        nfkd: "\u{1109}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C23B}",
        nfc: "\u{C23B}",
        nfd: "\u{1109}\u{116F}\u{11AE}",
        nfkc: "\u{C23B}",
        nfkd: "\u{1109}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C23C}",
        nfc: "\u{C23C}",
        nfd: "\u{1109}\u{116F}\u{11AF}",
        nfkc: "\u{C23C}",
        nfkd: "\u{1109}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C23D}",
        nfc: "\u{C23D}",
        nfd: "\u{1109}\u{116F}\u{11B0}",
        nfkc: "\u{C23D}",
        nfkd: "\u{1109}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C23E}",
        nfc: "\u{C23E}",
        nfd: "\u{1109}\u{116F}\u{11B1}",
        nfkc: "\u{C23E}",
        nfkd: "\u{1109}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C23F}",
        nfc: "\u{C23F}",
        nfd: "\u{1109}\u{116F}\u{11B2}",
        nfkc: "\u{C23F}",
        nfkd: "\u{1109}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C240}",
        nfc: "\u{C240}",
        nfd: "\u{1109}\u{116F}\u{11B3}",
        nfkc: "\u{C240}",
        nfkd: "\u{1109}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C241}",
        nfc: "\u{C241}",
        nfd: "\u{1109}\u{116F}\u{11B4}",
        nfkc: "\u{C241}",
        nfkd: "\u{1109}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C242}",
        nfc: "\u{C242}",
        nfd: "\u{1109}\u{116F}\u{11B5}",
        nfkc: "\u{C242}",
        nfkd: "\u{1109}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C243}",
        nfc: "\u{C243}",
        nfd: "\u{1109}\u{116F}\u{11B6}",
        nfkc: "\u{C243}",
        nfkd: "\u{1109}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C244}",
        nfc: "\u{C244}",
        nfd: "\u{1109}\u{116F}\u{11B7}",
        nfkc: "\u{C244}",
        nfkd: "\u{1109}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C245}",
        nfc: "\u{C245}",
        nfd: "\u{1109}\u{116F}\u{11B8}",
        nfkc: "\u{C245}",
        nfkd: "\u{1109}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C246}",
        nfc: "\u{C246}",
        nfd: "\u{1109}\u{116F}\u{11B9}",
        nfkc: "\u{C246}",
        nfkd: "\u{1109}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C247}",
        nfc: "\u{C247}",
        nfd: "\u{1109}\u{116F}\u{11BA}",
        nfkc: "\u{C247}",
        nfkd: "\u{1109}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C248}",
        nfc: "\u{C248}",
        nfd: "\u{1109}\u{116F}\u{11BB}",
        nfkc: "\u{C248}",
        nfkd: "\u{1109}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C249}",
        nfc: "\u{C249}",
        nfd: "\u{1109}\u{116F}\u{11BC}",
        nfkc: "\u{C249}",
        nfkd: "\u{1109}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C24A}",
        nfc: "\u{C24A}",
        nfd: "\u{1109}\u{116F}\u{11BD}",
        nfkc: "\u{C24A}",
        nfkd: "\u{1109}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C24B}",
        nfc: "\u{C24B}",
        nfd: "\u{1109}\u{116F}\u{11BE}",
        nfkc: "\u{C24B}",
        nfkd: "\u{1109}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C24C}",
        nfc: "\u{C24C}",
        nfd: "\u{1109}\u{116F}\u{11BF}",
        nfkc: "\u{C24C}",
        nfkd: "\u{1109}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C24D}",
        nfc: "\u{C24D}",
        nfd: "\u{1109}\u{116F}\u{11C0}",
        nfkc: "\u{C24D}",
        nfkd: "\u{1109}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C24E}",
        nfc: "\u{C24E}",
        nfd: "\u{1109}\u{116F}\u{11C1}",
        nfkc: "\u{C24E}",
        nfkd: "\u{1109}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C24F}",
        nfc: "\u{C24F}",
        nfd: "\u{1109}\u{116F}\u{11C2}",
        nfkc: "\u{C24F}",
        nfkd: "\u{1109}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C250}",
        nfc: "\u{C250}",
        nfd: "\u{1109}\u{1170}",
        nfkc: "\u{C250}",
        nfkd: "\u{1109}\u{1170}",
    },
    NormalizationTest {
        source: "\u{C251}",
        nfc: "\u{C251}",
        nfd: "\u{1109}\u{1170}\u{11A8}",
        nfkc: "\u{C251}",
        nfkd: "\u{1109}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C252}",
        nfc: "\u{C252}",
        nfd: "\u{1109}\u{1170}\u{11A9}",
        nfkc: "\u{C252}",
        nfkd: "\u{1109}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C253}",
        nfc: "\u{C253}",
        nfd: "\u{1109}\u{1170}\u{11AA}",
        nfkc: "\u{C253}",
        nfkd: "\u{1109}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C254}",
        nfc: "\u{C254}",
        nfd: "\u{1109}\u{1170}\u{11AB}",
        nfkc: "\u{C254}",
        nfkd: "\u{1109}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C255}",
        nfc: "\u{C255}",
        nfd: "\u{1109}\u{1170}\u{11AC}",
        nfkc: "\u{C255}",
        nfkd: "\u{1109}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C256}",
        nfc: "\u{C256}",
        nfd: "\u{1109}\u{1170}\u{11AD}",
        nfkc: "\u{C256}",
        nfkd: "\u{1109}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C257}",
        nfc: "\u{C257}",
        nfd: "\u{1109}\u{1170}\u{11AE}",
        nfkc: "\u{C257}",
        nfkd: "\u{1109}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C258}",
        nfc: "\u{C258}",
        nfd: "\u{1109}\u{1170}\u{11AF}",
        nfkc: "\u{C258}",
        nfkd: "\u{1109}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C259}",
        nfc: "\u{C259}",
        nfd: "\u{1109}\u{1170}\u{11B0}",
        nfkc: "\u{C259}",
        nfkd: "\u{1109}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C25A}",
        nfc: "\u{C25A}",
        nfd: "\u{1109}\u{1170}\u{11B1}",
        nfkc: "\u{C25A}",
        nfkd: "\u{1109}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C25B}",
        nfc: "\u{C25B}",
        nfd: "\u{1109}\u{1170}\u{11B2}",
        nfkc: "\u{C25B}",
        nfkd: "\u{1109}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C25C}",
        nfc: "\u{C25C}",
        nfd: "\u{1109}\u{1170}\u{11B3}",
        nfkc: "\u{C25C}",
        nfkd: "\u{1109}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C25D}",
        nfc: "\u{C25D}",
        nfd: "\u{1109}\u{1170}\u{11B4}",
        nfkc: "\u{C25D}",
        nfkd: "\u{1109}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C25E}",
        nfc: "\u{C25E}",
        nfd: "\u{1109}\u{1170}\u{11B5}",
        nfkc: "\u{C25E}",
        nfkd: "\u{1109}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C25F}",
        nfc: "\u{C25F}",
        nfd: "\u{1109}\u{1170}\u{11B6}",
        nfkc: "\u{C25F}",
        nfkd: "\u{1109}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C260}",
        nfc: "\u{C260}",
        nfd: "\u{1109}\u{1170}\u{11B7}",
        nfkc: "\u{C260}",
        nfkd: "\u{1109}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C261}",
        nfc: "\u{C261}",
        nfd: "\u{1109}\u{1170}\u{11B8}",
        nfkc: "\u{C261}",
        nfkd: "\u{1109}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C262}",
        nfc: "\u{C262}",
        nfd: "\u{1109}\u{1170}\u{11B9}",
        nfkc: "\u{C262}",
        nfkd: "\u{1109}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C263}",
        nfc: "\u{C263}",
        nfd: "\u{1109}\u{1170}\u{11BA}",
        nfkc: "\u{C263}",
        nfkd: "\u{1109}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C264}",
        nfc: "\u{C264}",
        nfd: "\u{1109}\u{1170}\u{11BB}",
        nfkc: "\u{C264}",
        nfkd: "\u{1109}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C265}",
        nfc: "\u{C265}",
        nfd: "\u{1109}\u{1170}\u{11BC}",
        nfkc: "\u{C265}",
        nfkd: "\u{1109}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C266}",
        nfc: "\u{C266}",
        nfd: "\u{1109}\u{1170}\u{11BD}",
        nfkc: "\u{C266}",
        nfkd: "\u{1109}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C267}",
        nfc: "\u{C267}",
        nfd: "\u{1109}\u{1170}\u{11BE}",
        nfkc: "\u{C267}",
        nfkd: "\u{1109}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C268}",
        nfc: "\u{C268}",
        nfd: "\u{1109}\u{1170}\u{11BF}",
        nfkc: "\u{C268}",
        nfkd: "\u{1109}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C269}",
        nfc: "\u{C269}",
        nfd: "\u{1109}\u{1170}\u{11C0}",
        nfkc: "\u{C269}",
        nfkd: "\u{1109}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C26A}",
        nfc: "\u{C26A}",
        nfd: "\u{1109}\u{1170}\u{11C1}",
        nfkc: "\u{C26A}",
        nfkd: "\u{1109}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C26B}",
        nfc: "\u{C26B}",
        nfd: "\u{1109}\u{1170}\u{11C2}",
        nfkc: "\u{C26B}",
        nfkd: "\u{1109}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C26C}",
        nfc: "\u{C26C}",
        nfd: "\u{1109}\u{1171}",
        nfkc: "\u{C26C}",
        nfkd: "\u{1109}\u{1171}",
    },
    NormalizationTest {
        source: "\u{C26D}",
        nfc: "\u{C26D}",
        nfd: "\u{1109}\u{1171}\u{11A8}",
        nfkc: "\u{C26D}",
        nfkd: "\u{1109}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C26E}",
        nfc: "\u{C26E}",
        nfd: "\u{1109}\u{1171}\u{11A9}",
        nfkc: "\u{C26E}",
        nfkd: "\u{1109}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C26F}",
        nfc: "\u{C26F}",
        nfd: "\u{1109}\u{1171}\u{11AA}",
        nfkc: "\u{C26F}",
        nfkd: "\u{1109}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C270}",
        nfc: "\u{C270}",
        nfd: "\u{1109}\u{1171}\u{11AB}",
        nfkc: "\u{C270}",
        nfkd: "\u{1109}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C271}",
        nfc: "\u{C271}",
        nfd: "\u{1109}\u{1171}\u{11AC}",
        nfkc: "\u{C271}",
        nfkd: "\u{1109}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C272}",
        nfc: "\u{C272}",
        nfd: "\u{1109}\u{1171}\u{11AD}",
        nfkc: "\u{C272}",
        nfkd: "\u{1109}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C273}",
        nfc: "\u{C273}",
        nfd: "\u{1109}\u{1171}\u{11AE}",
        nfkc: "\u{C273}",
        nfkd: "\u{1109}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C274}",
        nfc: "\u{C274}",
        nfd: "\u{1109}\u{1171}\u{11AF}",
        nfkc: "\u{C274}",
        nfkd: "\u{1109}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C275}",
        nfc: "\u{C275}",
        nfd: "\u{1109}\u{1171}\u{11B0}",
        nfkc: "\u{C275}",
        nfkd: "\u{1109}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C276}",
        nfc: "\u{C276}",
        nfd: "\u{1109}\u{1171}\u{11B1}",
        nfkc: "\u{C276}",
        nfkd: "\u{1109}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C277}",
        nfc: "\u{C277}",
        nfd: "\u{1109}\u{1171}\u{11B2}",
        nfkc: "\u{C277}",
        nfkd: "\u{1109}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C278}",
        nfc: "\u{C278}",
        nfd: "\u{1109}\u{1171}\u{11B3}",
        nfkc: "\u{C278}",
        nfkd: "\u{1109}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C279}",
        nfc: "\u{C279}",
        nfd: "\u{1109}\u{1171}\u{11B4}",
        nfkc: "\u{C279}",
        nfkd: "\u{1109}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C27A}",
        nfc: "\u{C27A}",
        nfd: "\u{1109}\u{1171}\u{11B5}",
        nfkc: "\u{C27A}",
        nfkd: "\u{1109}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C27B}",
        nfc: "\u{C27B}",
        nfd: "\u{1109}\u{1171}\u{11B6}",
        nfkc: "\u{C27B}",
        nfkd: "\u{1109}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C27C}",
        nfc: "\u{C27C}",
        nfd: "\u{1109}\u{1171}\u{11B7}",
        nfkc: "\u{C27C}",
        nfkd: "\u{1109}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C27D}",
        nfc: "\u{C27D}",
        nfd: "\u{1109}\u{1171}\u{11B8}",
        nfkc: "\u{C27D}",
        nfkd: "\u{1109}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C27E}",
        nfc: "\u{C27E}",
        nfd: "\u{1109}\u{1171}\u{11B9}",
        nfkc: "\u{C27E}",
        nfkd: "\u{1109}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C27F}",
        nfc: "\u{C27F}",
        nfd: "\u{1109}\u{1171}\u{11BA}",
        nfkc: "\u{C27F}",
        nfkd: "\u{1109}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C280}",
        nfc: "\u{C280}",
        nfd: "\u{1109}\u{1171}\u{11BB}",
        nfkc: "\u{C280}",
        nfkd: "\u{1109}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C281}",
        nfc: "\u{C281}",
        nfd: "\u{1109}\u{1171}\u{11BC}",
        nfkc: "\u{C281}",
        nfkd: "\u{1109}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C282}",
        nfc: "\u{C282}",
        nfd: "\u{1109}\u{1171}\u{11BD}",
        nfkc: "\u{C282}",
        nfkd: "\u{1109}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C283}",
        nfc: "\u{C283}",
        nfd: "\u{1109}\u{1171}\u{11BE}",
        nfkc: "\u{C283}",
        nfkd: "\u{1109}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C284}",
        nfc: "\u{C284}",
        nfd: "\u{1109}\u{1171}\u{11BF}",
        nfkc: "\u{C284}",
        nfkd: "\u{1109}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C285}",
        nfc: "\u{C285}",
        nfd: "\u{1109}\u{1171}\u{11C0}",
        nfkc: "\u{C285}",
        nfkd: "\u{1109}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C286}",
        nfc: "\u{C286}",
        nfd: "\u{1109}\u{1171}\u{11C1}",
        nfkc: "\u{C286}",
        nfkd: "\u{1109}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C287}",
        nfc: "\u{C287}",
        nfd: "\u{1109}\u{1171}\u{11C2}",
        nfkc: "\u{C287}",
        nfkd: "\u{1109}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C288}",
        nfc: "\u{C288}",
        nfd: "\u{1109}\u{1172}",
        nfkc: "\u{C288}",
        nfkd: "\u{1109}\u{1172}",
    },
    NormalizationTest {
        source: "\u{C289}",
        nfc: "\u{C289}",
        nfd: "\u{1109}\u{1172}\u{11A8}",
        nfkc: "\u{C289}",
        nfkd: "\u{1109}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C28A}",
        nfc: "\u{C28A}",
        nfd: "\u{1109}\u{1172}\u{11A9}",
        nfkc: "\u{C28A}",
        nfkd: "\u{1109}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C28B}",
        nfc: "\u{C28B}",
        nfd: "\u{1109}\u{1172}\u{11AA}",
        nfkc: "\u{C28B}",
        nfkd: "\u{1109}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C28C}",
        nfc: "\u{C28C}",
        nfd: "\u{1109}\u{1172}\u{11AB}",
        nfkc: "\u{C28C}",
        nfkd: "\u{1109}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C28D}",
        nfc: "\u{C28D}",
        nfd: "\u{1109}\u{1172}\u{11AC}",
        nfkc: "\u{C28D}",
        nfkd: "\u{1109}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C28E}",
        nfc: "\u{C28E}",
        nfd: "\u{1109}\u{1172}\u{11AD}",
        nfkc: "\u{C28E}",
        nfkd: "\u{1109}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C28F}",
        nfc: "\u{C28F}",
        nfd: "\u{1109}\u{1172}\u{11AE}",
        nfkc: "\u{C28F}",
        nfkd: "\u{1109}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C290}",
        nfc: "\u{C290}",
        nfd: "\u{1109}\u{1172}\u{11AF}",
        nfkc: "\u{C290}",
        nfkd: "\u{1109}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C291}",
        nfc: "\u{C291}",
        nfd: "\u{1109}\u{1172}\u{11B0}",
        nfkc: "\u{C291}",
        nfkd: "\u{1109}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C292}",
        nfc: "\u{C292}",
        nfd: "\u{1109}\u{1172}\u{11B1}",
        nfkc: "\u{C292}",
        nfkd: "\u{1109}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C293}",
        nfc: "\u{C293}",
        nfd: "\u{1109}\u{1172}\u{11B2}",
        nfkc: "\u{C293}",
        nfkd: "\u{1109}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C294}",
        nfc: "\u{C294}",
        nfd: "\u{1109}\u{1172}\u{11B3}",
        nfkc: "\u{C294}",
        nfkd: "\u{1109}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C295}",
        nfc: "\u{C295}",
        nfd: "\u{1109}\u{1172}\u{11B4}",
        nfkc: "\u{C295}",
        nfkd: "\u{1109}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C296}",
        nfc: "\u{C296}",
        nfd: "\u{1109}\u{1172}\u{11B5}",
        nfkc: "\u{C296}",
        nfkd: "\u{1109}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C297}",
        nfc: "\u{C297}",
        nfd: "\u{1109}\u{1172}\u{11B6}",
        nfkc: "\u{C297}",
        nfkd: "\u{1109}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C298}",
        nfc: "\u{C298}",
        nfd: "\u{1109}\u{1172}\u{11B7}",
        nfkc: "\u{C298}",
        nfkd: "\u{1109}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C299}",
        nfc: "\u{C299}",
        nfd: "\u{1109}\u{1172}\u{11B8}",
        nfkc: "\u{C299}",
        nfkd: "\u{1109}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C29A}",
        nfc: "\u{C29A}",
        nfd: "\u{1109}\u{1172}\u{11B9}",
        nfkc: "\u{C29A}",
        nfkd: "\u{1109}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C29B}",
        nfc: "\u{C29B}",
        nfd: "\u{1109}\u{1172}\u{11BA}",
        nfkc: "\u{C29B}",
        nfkd: "\u{1109}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C29C}",
        nfc: "\u{C29C}",
        nfd: "\u{1109}\u{1172}\u{11BB}",
        nfkc: "\u{C29C}",
        nfkd: "\u{1109}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C29D}",
        nfc: "\u{C29D}",
        nfd: "\u{1109}\u{1172}\u{11BC}",
        nfkc: "\u{C29D}",
        nfkd: "\u{1109}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C29E}",
        nfc: "\u{C29E}",
        nfd: "\u{1109}\u{1172}\u{11BD}",
        nfkc: "\u{C29E}",
        nfkd: "\u{1109}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C29F}",
        nfc: "\u{C29F}",
        nfd: "\u{1109}\u{1172}\u{11BE}",
        nfkc: "\u{C29F}",
        nfkd: "\u{1109}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C2A0}",
        nfc: "\u{C2A0}",
        nfd: "\u{1109}\u{1172}\u{11BF}",
        nfkc: "\u{C2A0}",
        nfkd: "\u{1109}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C2A1}",
        nfc: "\u{C2A1}",
        nfd: "\u{1109}\u{1172}\u{11C0}",
        nfkc: "\u{C2A1}",
        nfkd: "\u{1109}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C2A2}",
        nfc: "\u{C2A2}",
        nfd: "\u{1109}\u{1172}\u{11C1}",
        nfkc: "\u{C2A2}",
        nfkd: "\u{1109}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C2A3}",
        nfc: "\u{C2A3}",
        nfd: "\u{1109}\u{1172}\u{11C2}",
        nfkc: "\u{C2A3}",
        nfkd: "\u{1109}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C2A4}",
        nfc: "\u{C2A4}",
        nfd: "\u{1109}\u{1173}",
        nfkc: "\u{C2A4}",
        nfkd: "\u{1109}\u{1173}",
    },
    NormalizationTest {
        source: "\u{C2A5}",
        nfc: "\u{C2A5}",
        nfd: "\u{1109}\u{1173}\u{11A8}",
        nfkc: "\u{C2A5}",
        nfkd: "\u{1109}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C2A6}",
        nfc: "\u{C2A6}",
        nfd: "\u{1109}\u{1173}\u{11A9}",
        nfkc: "\u{C2A6}",
        nfkd: "\u{1109}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C2A7}",
        nfc: "\u{C2A7}",
        nfd: "\u{1109}\u{1173}\u{11AA}",
        nfkc: "\u{C2A7}",
        nfkd: "\u{1109}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C2A8}",
        nfc: "\u{C2A8}",
        nfd: "\u{1109}\u{1173}\u{11AB}",
        nfkc: "\u{C2A8}",
        nfkd: "\u{1109}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C2A9}",
        nfc: "\u{C2A9}",
        nfd: "\u{1109}\u{1173}\u{11AC}",
        nfkc: "\u{C2A9}",
        nfkd: "\u{1109}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C2AA}",
        nfc: "\u{C2AA}",
        nfd: "\u{1109}\u{1173}\u{11AD}",
        nfkc: "\u{C2AA}",
        nfkd: "\u{1109}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C2AB}",
        nfc: "\u{C2AB}",
        nfd: "\u{1109}\u{1173}\u{11AE}",
        nfkc: "\u{C2AB}",
        nfkd: "\u{1109}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C2AC}",
        nfc: "\u{C2AC}",
        nfd: "\u{1109}\u{1173}\u{11AF}",
        nfkc: "\u{C2AC}",
        nfkd: "\u{1109}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C2AD}",
        nfc: "\u{C2AD}",
        nfd: "\u{1109}\u{1173}\u{11B0}",
        nfkc: "\u{C2AD}",
        nfkd: "\u{1109}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C2AE}",
        nfc: "\u{C2AE}",
        nfd: "\u{1109}\u{1173}\u{11B1}",
        nfkc: "\u{C2AE}",
        nfkd: "\u{1109}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C2AF}",
        nfc: "\u{C2AF}",
        nfd: "\u{1109}\u{1173}\u{11B2}",
        nfkc: "\u{C2AF}",
        nfkd: "\u{1109}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C2B0}",
        nfc: "\u{C2B0}",
        nfd: "\u{1109}\u{1173}\u{11B3}",
        nfkc: "\u{C2B0}",
        nfkd: "\u{1109}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C2B1}",
        nfc: "\u{C2B1}",
        nfd: "\u{1109}\u{1173}\u{11B4}",
        nfkc: "\u{C2B1}",
        nfkd: "\u{1109}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C2B2}",
        nfc: "\u{C2B2}",
        nfd: "\u{1109}\u{1173}\u{11B5}",
        nfkc: "\u{C2B2}",
        nfkd: "\u{1109}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C2B3}",
        nfc: "\u{C2B3}",
        nfd: "\u{1109}\u{1173}\u{11B6}",
        nfkc: "\u{C2B3}",
        nfkd: "\u{1109}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C2B4}",
        nfc: "\u{C2B4}",
        nfd: "\u{1109}\u{1173}\u{11B7}",
        nfkc: "\u{C2B4}",
        nfkd: "\u{1109}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C2B5}",
        nfc: "\u{C2B5}",
        nfd: "\u{1109}\u{1173}\u{11B8}",
        nfkc: "\u{C2B5}",
        nfkd: "\u{1109}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C2B6}",
        nfc: "\u{C2B6}",
        nfd: "\u{1109}\u{1173}\u{11B9}",
        nfkc: "\u{C2B6}",
        nfkd: "\u{1109}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C2B7}",
        nfc: "\u{C2B7}",
        nfd: "\u{1109}\u{1173}\u{11BA}",
        nfkc: "\u{C2B7}",
        nfkd: "\u{1109}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C2B8}",
        nfc: "\u{C2B8}",
        nfd: "\u{1109}\u{1173}\u{11BB}",
        nfkc: "\u{C2B8}",
        nfkd: "\u{1109}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C2B9}",
        nfc: "\u{C2B9}",
        nfd: "\u{1109}\u{1173}\u{11BC}",
        nfkc: "\u{C2B9}",
        nfkd: "\u{1109}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C2BA}",
        nfc: "\u{C2BA}",
        nfd: "\u{1109}\u{1173}\u{11BD}",
        nfkc: "\u{C2BA}",
        nfkd: "\u{1109}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C2BB}",
        nfc: "\u{C2BB}",
        nfd: "\u{1109}\u{1173}\u{11BE}",
        nfkc: "\u{C2BB}",
        nfkd: "\u{1109}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C2BC}",
        nfc: "\u{C2BC}",
        nfd: "\u{1109}\u{1173}\u{11BF}",
        nfkc: "\u{C2BC}",
        nfkd: "\u{1109}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C2BD}",
        nfc: "\u{C2BD}",
        nfd: "\u{1109}\u{1173}\u{11C0}",
        nfkc: "\u{C2BD}",
        nfkd: "\u{1109}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C2BE}",
        nfc: "\u{C2BE}",
        nfd: "\u{1109}\u{1173}\u{11C1}",
        nfkc: "\u{C2BE}",
        nfkd: "\u{1109}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C2BF}",
        nfc: "\u{C2BF}",
        nfd: "\u{1109}\u{1173}\u{11C2}",
        nfkc: "\u{C2BF}",
        nfkd: "\u{1109}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C2C0}",
        nfc: "\u{C2C0}",
        nfd: "\u{1109}\u{1174}",
        nfkc: "\u{C2C0}",
        nfkd: "\u{1109}\u{1174}",
    },
    NormalizationTest {
        source: "\u{C2C1}",
        nfc: "\u{C2C1}",
        nfd: "\u{1109}\u{1174}\u{11A8}",
        nfkc: "\u{C2C1}",
        nfkd: "\u{1109}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C2C2}",
        nfc: "\u{C2C2}",
        nfd: "\u{1109}\u{1174}\u{11A9}",
        nfkc: "\u{C2C2}",
        nfkd: "\u{1109}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C2C3}",
        nfc: "\u{C2C3}",
        nfd: "\u{1109}\u{1174}\u{11AA}",
        nfkc: "\u{C2C3}",
        nfkd: "\u{1109}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C2C4}",
        nfc: "\u{C2C4}",
        nfd: "\u{1109}\u{1174}\u{11AB}",
        nfkc: "\u{C2C4}",
        nfkd: "\u{1109}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C2C5}",
        nfc: "\u{C2C5}",
        nfd: "\u{1109}\u{1174}\u{11AC}",
        nfkc: "\u{C2C5}",
        nfkd: "\u{1109}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C2C6}",
        nfc: "\u{C2C6}",
        nfd: "\u{1109}\u{1174}\u{11AD}",
        nfkc: "\u{C2C6}",
        nfkd: "\u{1109}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C2C7}",
        nfc: "\u{C2C7}",
        nfd: "\u{1109}\u{1174}\u{11AE}",
        nfkc: "\u{C2C7}",
        nfkd: "\u{1109}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C2C8}",
        nfc: "\u{C2C8}",
        nfd: "\u{1109}\u{1174}\u{11AF}",
        nfkc: "\u{C2C8}",
        nfkd: "\u{1109}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C2C9}",
        nfc: "\u{C2C9}",
        nfd: "\u{1109}\u{1174}\u{11B0}",
        nfkc: "\u{C2C9}",
        nfkd: "\u{1109}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C2CA}",
        nfc: "\u{C2CA}",
        nfd: "\u{1109}\u{1174}\u{11B1}",
        nfkc: "\u{C2CA}",
        nfkd: "\u{1109}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C2CB}",
        nfc: "\u{C2CB}",
        nfd: "\u{1109}\u{1174}\u{11B2}",
        nfkc: "\u{C2CB}",
        nfkd: "\u{1109}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C2CC}",
        nfc: "\u{C2CC}",
        nfd: "\u{1109}\u{1174}\u{11B3}",
        nfkc: "\u{C2CC}",
        nfkd: "\u{1109}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C2CD}",
        nfc: "\u{C2CD}",
        nfd: "\u{1109}\u{1174}\u{11B4}",
        nfkc: "\u{C2CD}",
        nfkd: "\u{1109}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C2CE}",
        nfc: "\u{C2CE}",
        nfd: "\u{1109}\u{1174}\u{11B5}",
        nfkc: "\u{C2CE}",
        nfkd: "\u{1109}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C2CF}",
        nfc: "\u{C2CF}",
        nfd: "\u{1109}\u{1174}\u{11B6}",
        nfkc: "\u{C2CF}",
        nfkd: "\u{1109}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C2D0}",
        nfc: "\u{C2D0}",
        nfd: "\u{1109}\u{1174}\u{11B7}",
        nfkc: "\u{C2D0}",
        nfkd: "\u{1109}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C2D1}",
        nfc: "\u{C2D1}",
        nfd: "\u{1109}\u{1174}\u{11B8}",
        nfkc: "\u{C2D1}",
        nfkd: "\u{1109}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C2D2}",
        nfc: "\u{C2D2}",
        nfd: "\u{1109}\u{1174}\u{11B9}",
        nfkc: "\u{C2D2}",
        nfkd: "\u{1109}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C2D3}",
        nfc: "\u{C2D3}",
        nfd: "\u{1109}\u{1174}\u{11BA}",
        nfkc: "\u{C2D3}",
        nfkd: "\u{1109}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C2D4}",
        nfc: "\u{C2D4}",
        nfd: "\u{1109}\u{1174}\u{11BB}",
        nfkc: "\u{C2D4}",
        nfkd: "\u{1109}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C2D5}",
        nfc: "\u{C2D5}",
        nfd: "\u{1109}\u{1174}\u{11BC}",
        nfkc: "\u{C2D5}",
        nfkd: "\u{1109}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C2D6}",
        nfc: "\u{C2D6}",
        nfd: "\u{1109}\u{1174}\u{11BD}",
        nfkc: "\u{C2D6}",
        nfkd: "\u{1109}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C2D7}",
        nfc: "\u{C2D7}",
        nfd: "\u{1109}\u{1174}\u{11BE}",
        nfkc: "\u{C2D7}",
        nfkd: "\u{1109}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C2D8}",
        nfc: "\u{C2D8}",
        nfd: "\u{1109}\u{1174}\u{11BF}",
        nfkc: "\u{C2D8}",
        nfkd: "\u{1109}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C2D9}",
        nfc: "\u{C2D9}",
        nfd: "\u{1109}\u{1174}\u{11C0}",
        nfkc: "\u{C2D9}",
        nfkd: "\u{1109}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C2DA}",
        nfc: "\u{C2DA}",
        nfd: "\u{1109}\u{1174}\u{11C1}",
        nfkc: "\u{C2DA}",
        nfkd: "\u{1109}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C2DB}",
        nfc: "\u{C2DB}",
        nfd: "\u{1109}\u{1174}\u{11C2}",
        nfkc: "\u{C2DB}",
        nfkd: "\u{1109}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C2DC}",
        nfc: "\u{C2DC}",
        nfd: "\u{1109}\u{1175}",
        nfkc: "\u{C2DC}",
        nfkd: "\u{1109}\u{1175}",
    },
    NormalizationTest {
        source: "\u{C2DD}",
        nfc: "\u{C2DD}",
        nfd: "\u{1109}\u{1175}\u{11A8}",
        nfkc: "\u{C2DD}",
        nfkd: "\u{1109}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C2DE}",
        nfc: "\u{C2DE}",
        nfd: "\u{1109}\u{1175}\u{11A9}",
        nfkc: "\u{C2DE}",
        nfkd: "\u{1109}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C2DF}",
        nfc: "\u{C2DF}",
        nfd: "\u{1109}\u{1175}\u{11AA}",
        nfkc: "\u{C2DF}",
        nfkd: "\u{1109}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C2E0}",
        nfc: "\u{C2E0}",
        nfd: "\u{1109}\u{1175}\u{11AB}",
        nfkc: "\u{C2E0}",
        nfkd: "\u{1109}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C2E1}",
        nfc: "\u{C2E1}",
        nfd: "\u{1109}\u{1175}\u{11AC}",
        nfkc: "\u{C2E1}",
        nfkd: "\u{1109}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C2E2}",
        nfc: "\u{C2E2}",
        nfd: "\u{1109}\u{1175}\u{11AD}",
        nfkc: "\u{C2E2}",
        nfkd: "\u{1109}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C2E3}",
        nfc: "\u{C2E3}",
        nfd: "\u{1109}\u{1175}\u{11AE}",
        nfkc: "\u{C2E3}",
        nfkd: "\u{1109}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C2E4}",
        nfc: "\u{C2E4}",
        nfd: "\u{1109}\u{1175}\u{11AF}",
        nfkc: "\u{C2E4}",
        nfkd: "\u{1109}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C2E5}",
        nfc: "\u{C2E5}",
        nfd: "\u{1109}\u{1175}\u{11B0}",
        nfkc: "\u{C2E5}",
        nfkd: "\u{1109}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C2E6}",
        nfc: "\u{C2E6}",
        nfd: "\u{1109}\u{1175}\u{11B1}",
        nfkc: "\u{C2E6}",
        nfkd: "\u{1109}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C2E7}",
        nfc: "\u{C2E7}",
        nfd: "\u{1109}\u{1175}\u{11B2}",
        nfkc: "\u{C2E7}",
        nfkd: "\u{1109}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C2E8}",
        nfc: "\u{C2E8}",
        nfd: "\u{1109}\u{1175}\u{11B3}",
        nfkc: "\u{C2E8}",
        nfkd: "\u{1109}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C2E9}",
        nfc: "\u{C2E9}",
        nfd: "\u{1109}\u{1175}\u{11B4}",
        nfkc: "\u{C2E9}",
        nfkd: "\u{1109}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C2EA}",
        nfc: "\u{C2EA}",
        nfd: "\u{1109}\u{1175}\u{11B5}",
        nfkc: "\u{C2EA}",
        nfkd: "\u{1109}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C2EB}",
        nfc: "\u{C2EB}",
        nfd: "\u{1109}\u{1175}\u{11B6}",
        nfkc: "\u{C2EB}",
        nfkd: "\u{1109}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C2EC}",
        nfc: "\u{C2EC}",
        nfd: "\u{1109}\u{1175}\u{11B7}",
        nfkc: "\u{C2EC}",
        nfkd: "\u{1109}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C2ED}",
        nfc: "\u{C2ED}",
        nfd: "\u{1109}\u{1175}\u{11B8}",
        nfkc: "\u{C2ED}",
        nfkd: "\u{1109}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C2EE}",
        nfc: "\u{C2EE}",
        nfd: "\u{1109}\u{1175}\u{11B9}",
        nfkc: "\u{C2EE}",
        nfkd: "\u{1109}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C2EF}",
        nfc: "\u{C2EF}",
        nfd: "\u{1109}\u{1175}\u{11BA}",
        nfkc: "\u{C2EF}",
        nfkd: "\u{1109}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C2F0}",
        nfc: "\u{C2F0}",
        nfd: "\u{1109}\u{1175}\u{11BB}",
        nfkc: "\u{C2F0}",
        nfkd: "\u{1109}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C2F1}",
        nfc: "\u{C2F1}",
        nfd: "\u{1109}\u{1175}\u{11BC}",
        nfkc: "\u{C2F1}",
        nfkd: "\u{1109}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C2F2}",
        nfc: "\u{C2F2}",
        nfd: "\u{1109}\u{1175}\u{11BD}",
        nfkc: "\u{C2F2}",
        nfkd: "\u{1109}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C2F3}",
        nfc: "\u{C2F3}",
        nfd: "\u{1109}\u{1175}\u{11BE}",
        nfkc: "\u{C2F3}",
        nfkd: "\u{1109}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C2F4}",
        nfc: "\u{C2F4}",
        nfd: "\u{1109}\u{1175}\u{11BF}",
        nfkc: "\u{C2F4}",
        nfkd: "\u{1109}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C2F5}",
        nfc: "\u{C2F5}",
        nfd: "\u{1109}\u{1175}\u{11C0}",
        nfkc: "\u{C2F5}",
        nfkd: "\u{1109}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C2F6}",
        nfc: "\u{C2F6}",
        nfd: "\u{1109}\u{1175}\u{11C1}",
        nfkc: "\u{C2F6}",
        nfkd: "\u{1109}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C2F7}",
        nfc: "\u{C2F7}",
        nfd: "\u{1109}\u{1175}\u{11C2}",
        nfkc: "\u{C2F7}",
        nfkd: "\u{1109}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C2F8}",
        nfc: "\u{C2F8}",
        nfd: "\u{110A}\u{1161}",
        nfkc: "\u{C2F8}",
        nfkd: "\u{110A}\u{1161}",
    },
    NormalizationTest {
        source: "\u{C2F9}",
        nfc: "\u{C2F9}",
        nfd: "\u{110A}\u{1161}\u{11A8}",
        nfkc: "\u{C2F9}",
        nfkd: "\u{110A}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C2FA}",
        nfc: "\u{C2FA}",
        nfd: "\u{110A}\u{1161}\u{11A9}",
        nfkc: "\u{C2FA}",
        nfkd: "\u{110A}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C2FB}",
        nfc: "\u{C2FB}",
        nfd: "\u{110A}\u{1161}\u{11AA}",
        nfkc: "\u{C2FB}",
        nfkd: "\u{110A}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C2FC}",
        nfc: "\u{C2FC}",
        nfd: "\u{110A}\u{1161}\u{11AB}",
        nfkc: "\u{C2FC}",
        nfkd: "\u{110A}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C2FD}",
        nfc: "\u{C2FD}",
        nfd: "\u{110A}\u{1161}\u{11AC}",
        nfkc: "\u{C2FD}",
        nfkd: "\u{110A}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C2FE}",
        nfc: "\u{C2FE}",
        nfd: "\u{110A}\u{1161}\u{11AD}",
        nfkc: "\u{C2FE}",
        nfkd: "\u{110A}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C2FF}",
        nfc: "\u{C2FF}",
        nfd: "\u{110A}\u{1161}\u{11AE}",
        nfkc: "\u{C2FF}",
        nfkd: "\u{110A}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C300}",
        nfc: "\u{C300}",
        nfd: "\u{110A}\u{1161}\u{11AF}",
        nfkc: "\u{C300}",
        nfkd: "\u{110A}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C301}",
        nfc: "\u{C301}",
        nfd: "\u{110A}\u{1161}\u{11B0}",
        nfkc: "\u{C301}",
        nfkd: "\u{110A}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C302}",
        nfc: "\u{C302}",
        nfd: "\u{110A}\u{1161}\u{11B1}",
        nfkc: "\u{C302}",
        nfkd: "\u{110A}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C303}",
        nfc: "\u{C303}",
        nfd: "\u{110A}\u{1161}\u{11B2}",
        nfkc: "\u{C303}",
        nfkd: "\u{110A}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C304}",
        nfc: "\u{C304}",
        nfd: "\u{110A}\u{1161}\u{11B3}",
        nfkc: "\u{C304}",
        nfkd: "\u{110A}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C305}",
        nfc: "\u{C305}",
        nfd: "\u{110A}\u{1161}\u{11B4}",
        nfkc: "\u{C305}",
        nfkd: "\u{110A}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C306}",
        nfc: "\u{C306}",
        nfd: "\u{110A}\u{1161}\u{11B5}",
        nfkc: "\u{C306}",
        nfkd: "\u{110A}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C307}",
        nfc: "\u{C307}",
        nfd: "\u{110A}\u{1161}\u{11B6}",
        nfkc: "\u{C307}",
        nfkd: "\u{110A}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C308}",
        nfc: "\u{C308}",
        nfd: "\u{110A}\u{1161}\u{11B7}",
        nfkc: "\u{C308}",
        nfkd: "\u{110A}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C309}",
        nfc: "\u{C309}",
        nfd: "\u{110A}\u{1161}\u{11B8}",
        nfkc: "\u{C309}",
        nfkd: "\u{110A}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C30A}",
        nfc: "\u{C30A}",
        nfd: "\u{110A}\u{1161}\u{11B9}",
        nfkc: "\u{C30A}",
        nfkd: "\u{110A}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C30B}",
        nfc: "\u{C30B}",
        nfd: "\u{110A}\u{1161}\u{11BA}",
        nfkc: "\u{C30B}",
        nfkd: "\u{110A}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C30C}",
        nfc: "\u{C30C}",
        nfd: "\u{110A}\u{1161}\u{11BB}",
        nfkc: "\u{C30C}",
        nfkd: "\u{110A}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C30D}",
        nfc: "\u{C30D}",
        nfd: "\u{110A}\u{1161}\u{11BC}",
        nfkc: "\u{C30D}",
        nfkd: "\u{110A}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C30E}",
        nfc: "\u{C30E}",
        nfd: "\u{110A}\u{1161}\u{11BD}",
        nfkc: "\u{C30E}",
        nfkd: "\u{110A}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C30F}",
        nfc: "\u{C30F}",
        nfd: "\u{110A}\u{1161}\u{11BE}",
        nfkc: "\u{C30F}",
        nfkd: "\u{110A}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C310}",
        nfc: "\u{C310}",
        nfd: "\u{110A}\u{1161}\u{11BF}",
        nfkc: "\u{C310}",
        nfkd: "\u{110A}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C311}",
        nfc: "\u{C311}",
        nfd: "\u{110A}\u{1161}\u{11C0}",
        nfkc: "\u{C311}",
        nfkd: "\u{110A}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C312}",
        nfc: "\u{C312}",
        nfd: "\u{110A}\u{1161}\u{11C1}",
        nfkc: "\u{C312}",
        nfkd: "\u{110A}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C313}",
        nfc: "\u{C313}",
        nfd: "\u{110A}\u{1161}\u{11C2}",
        nfkc: "\u{C313}",
        nfkd: "\u{110A}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C314}",
        nfc: "\u{C314}",
        nfd: "\u{110A}\u{1162}",
        nfkc: "\u{C314}",
        nfkd: "\u{110A}\u{1162}",
    },
    NormalizationTest {
        source: "\u{C315}",
        nfc: "\u{C315}",
        nfd: "\u{110A}\u{1162}\u{11A8}",
        nfkc: "\u{C315}",
        nfkd: "\u{110A}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C316}",
        nfc: "\u{C316}",
        nfd: "\u{110A}\u{1162}\u{11A9}",
        nfkc: "\u{C316}",
        nfkd: "\u{110A}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C317}",
        nfc: "\u{C317}",
        nfd: "\u{110A}\u{1162}\u{11AA}",
        nfkc: "\u{C317}",
        nfkd: "\u{110A}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C318}",
        nfc: "\u{C318}",
        nfd: "\u{110A}\u{1162}\u{11AB}",
        nfkc: "\u{C318}",
        nfkd: "\u{110A}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C319}",
        nfc: "\u{C319}",
        nfd: "\u{110A}\u{1162}\u{11AC}",
        nfkc: "\u{C319}",
        nfkd: "\u{110A}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C31A}",
        nfc: "\u{C31A}",
        nfd: "\u{110A}\u{1162}\u{11AD}",
        nfkc: "\u{C31A}",
        nfkd: "\u{110A}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C31B}",
        nfc: "\u{C31B}",
        nfd: "\u{110A}\u{1162}\u{11AE}",
        nfkc: "\u{C31B}",
        nfkd: "\u{110A}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C31C}",
        nfc: "\u{C31C}",
        nfd: "\u{110A}\u{1162}\u{11AF}",
        nfkc: "\u{C31C}",
        nfkd: "\u{110A}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C31D}",
        nfc: "\u{C31D}",
        nfd: "\u{110A}\u{1162}\u{11B0}",
        nfkc: "\u{C31D}",
        nfkd: "\u{110A}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C31E}",
        nfc: "\u{C31E}",
        nfd: "\u{110A}\u{1162}\u{11B1}",
        nfkc: "\u{C31E}",
        nfkd: "\u{110A}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C31F}",
        nfc: "\u{C31F}",
        nfd: "\u{110A}\u{1162}\u{11B2}",
        nfkc: "\u{C31F}",
        nfkd: "\u{110A}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C320}",
        nfc: "\u{C320}",
        nfd: "\u{110A}\u{1162}\u{11B3}",
        nfkc: "\u{C320}",
        nfkd: "\u{110A}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C321}",
        nfc: "\u{C321}",
        nfd: "\u{110A}\u{1162}\u{11B4}",
        nfkc: "\u{C321}",
        nfkd: "\u{110A}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C322}",
        nfc: "\u{C322}",
        nfd: "\u{110A}\u{1162}\u{11B5}",
        nfkc: "\u{C322}",
        nfkd: "\u{110A}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C323}",
        nfc: "\u{C323}",
        nfd: "\u{110A}\u{1162}\u{11B6}",
        nfkc: "\u{C323}",
        nfkd: "\u{110A}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C324}",
        nfc: "\u{C324}",
        nfd: "\u{110A}\u{1162}\u{11B7}",
        nfkc: "\u{C324}",
        nfkd: "\u{110A}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C325}",
        nfc: "\u{C325}",
        nfd: "\u{110A}\u{1162}\u{11B8}",
        nfkc: "\u{C325}",
        nfkd: "\u{110A}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C326}",
        nfc: "\u{C326}",
        nfd: "\u{110A}\u{1162}\u{11B9}",
        nfkc: "\u{C326}",
        nfkd: "\u{110A}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C327}",
        nfc: "\u{C327}",
        nfd: "\u{110A}\u{1162}\u{11BA}",
        nfkc: "\u{C327}",
        nfkd: "\u{110A}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C328}",
        nfc: "\u{C328}",
        nfd: "\u{110A}\u{1162}\u{11BB}",
        nfkc: "\u{C328}",
        nfkd: "\u{110A}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C329}",
        nfc: "\u{C329}",
        nfd: "\u{110A}\u{1162}\u{11BC}",
        nfkc: "\u{C329}",
        nfkd: "\u{110A}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C32A}",
        nfc: "\u{C32A}",
        nfd: "\u{110A}\u{1162}\u{11BD}",
        nfkc: "\u{C32A}",
        nfkd: "\u{110A}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C32B}",
        nfc: "\u{C32B}",
        nfd: "\u{110A}\u{1162}\u{11BE}",
        nfkc: "\u{C32B}",
        nfkd: "\u{110A}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C32C}",
        nfc: "\u{C32C}",
        nfd: "\u{110A}\u{1162}\u{11BF}",
        nfkc: "\u{C32C}",
        nfkd: "\u{110A}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C32D}",
        nfc: "\u{C32D}",
        nfd: "\u{110A}\u{1162}\u{11C0}",
        nfkc: "\u{C32D}",
        nfkd: "\u{110A}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C32E}",
        nfc: "\u{C32E}",
        nfd: "\u{110A}\u{1162}\u{11C1}",
        nfkc: "\u{C32E}",
        nfkd: "\u{110A}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C32F}",
        nfc: "\u{C32F}",
        nfd: "\u{110A}\u{1162}\u{11C2}",
        nfkc: "\u{C32F}",
        nfkd: "\u{110A}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C330}",
        nfc: "\u{C330}",
        nfd: "\u{110A}\u{1163}",
        nfkc: "\u{C330}",
        nfkd: "\u{110A}\u{1163}",
    },
    NormalizationTest {
        source: "\u{C331}",
        nfc: "\u{C331}",
        nfd: "\u{110A}\u{1163}\u{11A8}",
        nfkc: "\u{C331}",
        nfkd: "\u{110A}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C332}",
        nfc: "\u{C332}",
        nfd: "\u{110A}\u{1163}\u{11A9}",
        nfkc: "\u{C332}",
        nfkd: "\u{110A}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C333}",
        nfc: "\u{C333}",
        nfd: "\u{110A}\u{1163}\u{11AA}",
        nfkc: "\u{C333}",
        nfkd: "\u{110A}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C334}",
        nfc: "\u{C334}",
        nfd: "\u{110A}\u{1163}\u{11AB}",
        nfkc: "\u{C334}",
        nfkd: "\u{110A}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C335}",
        nfc: "\u{C335}",
        nfd: "\u{110A}\u{1163}\u{11AC}",
        nfkc: "\u{C335}",
        nfkd: "\u{110A}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C336}",
        nfc: "\u{C336}",
        nfd: "\u{110A}\u{1163}\u{11AD}",
        nfkc: "\u{C336}",
        nfkd: "\u{110A}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C337}",
        nfc: "\u{C337}",
        nfd: "\u{110A}\u{1163}\u{11AE}",
        nfkc: "\u{C337}",
        nfkd: "\u{110A}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C338}",
        nfc: "\u{C338}",
        nfd: "\u{110A}\u{1163}\u{11AF}",
        nfkc: "\u{C338}",
        nfkd: "\u{110A}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C339}",
        nfc: "\u{C339}",
        nfd: "\u{110A}\u{1163}\u{11B0}",
        nfkc: "\u{C339}",
        nfkd: "\u{110A}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C33A}",
        nfc: "\u{C33A}",
        nfd: "\u{110A}\u{1163}\u{11B1}",
        nfkc: "\u{C33A}",
        nfkd: "\u{110A}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C33B}",
        nfc: "\u{C33B}",
        nfd: "\u{110A}\u{1163}\u{11B2}",
        nfkc: "\u{C33B}",
        nfkd: "\u{110A}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C33C}",
        nfc: "\u{C33C}",
        nfd: "\u{110A}\u{1163}\u{11B3}",
        nfkc: "\u{C33C}",
        nfkd: "\u{110A}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C33D}",
        nfc: "\u{C33D}",
        nfd: "\u{110A}\u{1163}\u{11B4}",
        nfkc: "\u{C33D}",
        nfkd: "\u{110A}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C33E}",
        nfc: "\u{C33E}",
        nfd: "\u{110A}\u{1163}\u{11B5}",
        nfkc: "\u{C33E}",
        nfkd: "\u{110A}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C33F}",
        nfc: "\u{C33F}",
        nfd: "\u{110A}\u{1163}\u{11B6}",
        nfkc: "\u{C33F}",
        nfkd: "\u{110A}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C340}",
        nfc: "\u{C340}",
        nfd: "\u{110A}\u{1163}\u{11B7}",
        nfkc: "\u{C340}",
        nfkd: "\u{110A}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C341}",
        nfc: "\u{C341}",
        nfd: "\u{110A}\u{1163}\u{11B8}",
        nfkc: "\u{C341}",
        nfkd: "\u{110A}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C342}",
        nfc: "\u{C342}",
        nfd: "\u{110A}\u{1163}\u{11B9}",
        nfkc: "\u{C342}",
        nfkd: "\u{110A}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C343}",
        nfc: "\u{C343}",
        nfd: "\u{110A}\u{1163}\u{11BA}",
        nfkc: "\u{C343}",
        nfkd: "\u{110A}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C344}",
        nfc: "\u{C344}",
        nfd: "\u{110A}\u{1163}\u{11BB}",
        nfkc: "\u{C344}",
        nfkd: "\u{110A}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C345}",
        nfc: "\u{C345}",
        nfd: "\u{110A}\u{1163}\u{11BC}",
        nfkc: "\u{C345}",
        nfkd: "\u{110A}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C346}",
        nfc: "\u{C346}",
        nfd: "\u{110A}\u{1163}\u{11BD}",
        nfkc: "\u{C346}",
        nfkd: "\u{110A}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C347}",
        nfc: "\u{C347}",
        nfd: "\u{110A}\u{1163}\u{11BE}",
        nfkc: "\u{C347}",
        nfkd: "\u{110A}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C348}",
        nfc: "\u{C348}",
        nfd: "\u{110A}\u{1163}\u{11BF}",
        nfkc: "\u{C348}",
        nfkd: "\u{110A}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C349}",
        nfc: "\u{C349}",
        nfd: "\u{110A}\u{1163}\u{11C0}",
        nfkc: "\u{C349}",
        nfkd: "\u{110A}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C34A}",
        nfc: "\u{C34A}",
        nfd: "\u{110A}\u{1163}\u{11C1}",
        nfkc: "\u{C34A}",
        nfkd: "\u{110A}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C34B}",
        nfc: "\u{C34B}",
        nfd: "\u{110A}\u{1163}\u{11C2}",
        nfkc: "\u{C34B}",
        nfkd: "\u{110A}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C34C}",
        nfc: "\u{C34C}",
        nfd: "\u{110A}\u{1164}",
        nfkc: "\u{C34C}",
        nfkd: "\u{110A}\u{1164}",
    },
    NormalizationTest {
        source: "\u{C34D}",
        nfc: "\u{C34D}",
        nfd: "\u{110A}\u{1164}\u{11A8}",
        nfkc: "\u{C34D}",
        nfkd: "\u{110A}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C34E}",
        nfc: "\u{C34E}",
        nfd: "\u{110A}\u{1164}\u{11A9}",
        nfkc: "\u{C34E}",
        nfkd: "\u{110A}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C34F}",
        nfc: "\u{C34F}",
        nfd: "\u{110A}\u{1164}\u{11AA}",
        nfkc: "\u{C34F}",
        nfkd: "\u{110A}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C350}",
        nfc: "\u{C350}",
        nfd: "\u{110A}\u{1164}\u{11AB}",
        nfkc: "\u{C350}",
        nfkd: "\u{110A}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C351}",
        nfc: "\u{C351}",
        nfd: "\u{110A}\u{1164}\u{11AC}",
        nfkc: "\u{C351}",
        nfkd: "\u{110A}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C352}",
        nfc: "\u{C352}",
        nfd: "\u{110A}\u{1164}\u{11AD}",
        nfkc: "\u{C352}",
        nfkd: "\u{110A}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C353}",
        nfc: "\u{C353}",
        nfd: "\u{110A}\u{1164}\u{11AE}",
        nfkc: "\u{C353}",
        nfkd: "\u{110A}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C354}",
        nfc: "\u{C354}",
        nfd: "\u{110A}\u{1164}\u{11AF}",
        nfkc: "\u{C354}",
        nfkd: "\u{110A}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C355}",
        nfc: "\u{C355}",
        nfd: "\u{110A}\u{1164}\u{11B0}",
        nfkc: "\u{C355}",
        nfkd: "\u{110A}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C356}",
        nfc: "\u{C356}",
        nfd: "\u{110A}\u{1164}\u{11B1}",
        nfkc: "\u{C356}",
        nfkd: "\u{110A}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C357}",
        nfc: "\u{C357}",
        nfd: "\u{110A}\u{1164}\u{11B2}",
        nfkc: "\u{C357}",
        nfkd: "\u{110A}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C358}",
        nfc: "\u{C358}",
        nfd: "\u{110A}\u{1164}\u{11B3}",
        nfkc: "\u{C358}",
        nfkd: "\u{110A}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C359}",
        nfc: "\u{C359}",
        nfd: "\u{110A}\u{1164}\u{11B4}",
        nfkc: "\u{C359}",
        nfkd: "\u{110A}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C35A}",
        nfc: "\u{C35A}",
        nfd: "\u{110A}\u{1164}\u{11B5}",
        nfkc: "\u{C35A}",
        nfkd: "\u{110A}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C35B}",
        nfc: "\u{C35B}",
        nfd: "\u{110A}\u{1164}\u{11B6}",
        nfkc: "\u{C35B}",
        nfkd: "\u{110A}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C35C}",
        nfc: "\u{C35C}",
        nfd: "\u{110A}\u{1164}\u{11B7}",
        nfkc: "\u{C35C}",
        nfkd: "\u{110A}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C35D}",
        nfc: "\u{C35D}",
        nfd: "\u{110A}\u{1164}\u{11B8}",
        nfkc: "\u{C35D}",
        nfkd: "\u{110A}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C35E}",
        nfc: "\u{C35E}",
        nfd: "\u{110A}\u{1164}\u{11B9}",
        nfkc: "\u{C35E}",
        nfkd: "\u{110A}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C35F}",
        nfc: "\u{C35F}",
        nfd: "\u{110A}\u{1164}\u{11BA}",
        nfkc: "\u{C35F}",
        nfkd: "\u{110A}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C360}",
        nfc: "\u{C360}",
        nfd: "\u{110A}\u{1164}\u{11BB}",
        nfkc: "\u{C360}",
        nfkd: "\u{110A}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C361}",
        nfc: "\u{C361}",
        nfd: "\u{110A}\u{1164}\u{11BC}",
        nfkc: "\u{C361}",
        nfkd: "\u{110A}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C362}",
        nfc: "\u{C362}",
        nfd: "\u{110A}\u{1164}\u{11BD}",
        nfkc: "\u{C362}",
        nfkd: "\u{110A}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C363}",
        nfc: "\u{C363}",
        nfd: "\u{110A}\u{1164}\u{11BE}",
        nfkc: "\u{C363}",
        nfkd: "\u{110A}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C364}",
        nfc: "\u{C364}",
        nfd: "\u{110A}\u{1164}\u{11BF}",
        nfkc: "\u{C364}",
        nfkd: "\u{110A}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C365}",
        nfc: "\u{C365}",
        nfd: "\u{110A}\u{1164}\u{11C0}",
        nfkc: "\u{C365}",
        nfkd: "\u{110A}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C366}",
        nfc: "\u{C366}",
        nfd: "\u{110A}\u{1164}\u{11C1}",
        nfkc: "\u{C366}",
        nfkd: "\u{110A}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C367}",
        nfc: "\u{C367}",
        nfd: "\u{110A}\u{1164}\u{11C2}",
        nfkc: "\u{C367}",
        nfkd: "\u{110A}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C368}",
        nfc: "\u{C368}",
        nfd: "\u{110A}\u{1165}",
        nfkc: "\u{C368}",
        nfkd: "\u{110A}\u{1165}",
    },
    NormalizationTest {
        source: "\u{C369}",
        nfc: "\u{C369}",
        nfd: "\u{110A}\u{1165}\u{11A8}",
        nfkc: "\u{C369}",
        nfkd: "\u{110A}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C36A}",
        nfc: "\u{C36A}",
        nfd: "\u{110A}\u{1165}\u{11A9}",
        nfkc: "\u{C36A}",
        nfkd: "\u{110A}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C36B}",
        nfc: "\u{C36B}",
        nfd: "\u{110A}\u{1165}\u{11AA}",
        nfkc: "\u{C36B}",
        nfkd: "\u{110A}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C36C}",
        nfc: "\u{C36C}",
        nfd: "\u{110A}\u{1165}\u{11AB}",
        nfkc: "\u{C36C}",
        nfkd: "\u{110A}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C36D}",
        nfc: "\u{C36D}",
        nfd: "\u{110A}\u{1165}\u{11AC}",
        nfkc: "\u{C36D}",
        nfkd: "\u{110A}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C36E}",
        nfc: "\u{C36E}",
        nfd: "\u{110A}\u{1165}\u{11AD}",
        nfkc: "\u{C36E}",
        nfkd: "\u{110A}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C36F}",
        nfc: "\u{C36F}",
        nfd: "\u{110A}\u{1165}\u{11AE}",
        nfkc: "\u{C36F}",
        nfkd: "\u{110A}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C370}",
        nfc: "\u{C370}",
        nfd: "\u{110A}\u{1165}\u{11AF}",
        nfkc: "\u{C370}",
        nfkd: "\u{110A}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C371}",
        nfc: "\u{C371}",
        nfd: "\u{110A}\u{1165}\u{11B0}",
        nfkc: "\u{C371}",
        nfkd: "\u{110A}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C372}",
        nfc: "\u{C372}",
        nfd: "\u{110A}\u{1165}\u{11B1}",
        nfkc: "\u{C372}",
        nfkd: "\u{110A}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C373}",
        nfc: "\u{C373}",
        nfd: "\u{110A}\u{1165}\u{11B2}",
        nfkc: "\u{C373}",
        nfkd: "\u{110A}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C374}",
        nfc: "\u{C374}",
        nfd: "\u{110A}\u{1165}\u{11B3}",
        nfkc: "\u{C374}",
        nfkd: "\u{110A}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C375}",
        nfc: "\u{C375}",
        nfd: "\u{110A}\u{1165}\u{11B4}",
        nfkc: "\u{C375}",
        nfkd: "\u{110A}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C376}",
        nfc: "\u{C376}",
        nfd: "\u{110A}\u{1165}\u{11B5}",
        nfkc: "\u{C376}",
        nfkd: "\u{110A}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C377}",
        nfc: "\u{C377}",
        nfd: "\u{110A}\u{1165}\u{11B6}",
        nfkc: "\u{C377}",
        nfkd: "\u{110A}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C378}",
        nfc: "\u{C378}",
        nfd: "\u{110A}\u{1165}\u{11B7}",
        nfkc: "\u{C378}",
        nfkd: "\u{110A}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C379}",
        nfc: "\u{C379}",
        nfd: "\u{110A}\u{1165}\u{11B8}",
        nfkc: "\u{C379}",
        nfkd: "\u{110A}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C37A}",
        nfc: "\u{C37A}",
        nfd: "\u{110A}\u{1165}\u{11B9}",
        nfkc: "\u{C37A}",
        nfkd: "\u{110A}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C37B}",
        nfc: "\u{C37B}",
        nfd: "\u{110A}\u{1165}\u{11BA}",
        nfkc: "\u{C37B}",
        nfkd: "\u{110A}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C37C}",
        nfc: "\u{C37C}",
        nfd: "\u{110A}\u{1165}\u{11BB}",
        nfkc: "\u{C37C}",
        nfkd: "\u{110A}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C37D}",
        nfc: "\u{C37D}",
        nfd: "\u{110A}\u{1165}\u{11BC}",
        nfkc: "\u{C37D}",
        nfkd: "\u{110A}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C37E}",
        nfc: "\u{C37E}",
        nfd: "\u{110A}\u{1165}\u{11BD}",
        nfkc: "\u{C37E}",
        nfkd: "\u{110A}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C37F}",
        nfc: "\u{C37F}",
        nfd: "\u{110A}\u{1165}\u{11BE}",
        nfkc: "\u{C37F}",
        nfkd: "\u{110A}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C380}",
        nfc: "\u{C380}",
        nfd: "\u{110A}\u{1165}\u{11BF}",
        nfkc: "\u{C380}",
        nfkd: "\u{110A}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C381}",
        nfc: "\u{C381}",
        nfd: "\u{110A}\u{1165}\u{11C0}",
        nfkc: "\u{C381}",
        nfkd: "\u{110A}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C382}",
        nfc: "\u{C382}",
        nfd: "\u{110A}\u{1165}\u{11C1}",
        nfkc: "\u{C382}",
        nfkd: "\u{110A}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C383}",
        nfc: "\u{C383}",
        nfd: "\u{110A}\u{1165}\u{11C2}",
        nfkc: "\u{C383}",
        nfkd: "\u{110A}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C384}",
        nfc: "\u{C384}",
        nfd: "\u{110A}\u{1166}",
        nfkc: "\u{C384}",
        nfkd: "\u{110A}\u{1166}",
    },
    NormalizationTest {
        source: "\u{C385}",
        nfc: "\u{C385}",
        nfd: "\u{110A}\u{1166}\u{11A8}",
        nfkc: "\u{C385}",
        nfkd: "\u{110A}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C386}",
        nfc: "\u{C386}",
        nfd: "\u{110A}\u{1166}\u{11A9}",
        nfkc: "\u{C386}",
        nfkd: "\u{110A}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C387}",
        nfc: "\u{C387}",
        nfd: "\u{110A}\u{1166}\u{11AA}",
        nfkc: "\u{C387}",
        nfkd: "\u{110A}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C388}",
        nfc: "\u{C388}",
        nfd: "\u{110A}\u{1166}\u{11AB}",
        nfkc: "\u{C388}",
        nfkd: "\u{110A}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C389}",
        nfc: "\u{C389}",
        nfd: "\u{110A}\u{1166}\u{11AC}",
        nfkc: "\u{C389}",
        nfkd: "\u{110A}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C38A}",
        nfc: "\u{C38A}",
        nfd: "\u{110A}\u{1166}\u{11AD}",
        nfkc: "\u{C38A}",
        nfkd: "\u{110A}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C38B}",
        nfc: "\u{C38B}",
        nfd: "\u{110A}\u{1166}\u{11AE}",
        nfkc: "\u{C38B}",
        nfkd: "\u{110A}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C38C}",
        nfc: "\u{C38C}",
        nfd: "\u{110A}\u{1166}\u{11AF}",
        nfkc: "\u{C38C}",
        nfkd: "\u{110A}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C38D}",
        nfc: "\u{C38D}",
        nfd: "\u{110A}\u{1166}\u{11B0}",
        nfkc: "\u{C38D}",
        nfkd: "\u{110A}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C38E}",
        nfc: "\u{C38E}",
        nfd: "\u{110A}\u{1166}\u{11B1}",
        nfkc: "\u{C38E}",
        nfkd: "\u{110A}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C38F}",
        nfc: "\u{C38F}",
        nfd: "\u{110A}\u{1166}\u{11B2}",
        nfkc: "\u{C38F}",
        nfkd: "\u{110A}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C390}",
        nfc: "\u{C390}",
        nfd: "\u{110A}\u{1166}\u{11B3}",
        nfkc: "\u{C390}",
        nfkd: "\u{110A}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C391}",
        nfc: "\u{C391}",
        nfd: "\u{110A}\u{1166}\u{11B4}",
        nfkc: "\u{C391}",
        nfkd: "\u{110A}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C392}",
        nfc: "\u{C392}",
        nfd: "\u{110A}\u{1166}\u{11B5}",
        nfkc: "\u{C392}",
        nfkd: "\u{110A}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C393}",
        nfc: "\u{C393}",
        nfd: "\u{110A}\u{1166}\u{11B6}",
        nfkc: "\u{C393}",
        nfkd: "\u{110A}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C394}",
        nfc: "\u{C394}",
        nfd: "\u{110A}\u{1166}\u{11B7}",
        nfkc: "\u{C394}",
        nfkd: "\u{110A}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C395}",
        nfc: "\u{C395}",
        nfd: "\u{110A}\u{1166}\u{11B8}",
        nfkc: "\u{C395}",
        nfkd: "\u{110A}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C396}",
        nfc: "\u{C396}",
        nfd: "\u{110A}\u{1166}\u{11B9}",
        nfkc: "\u{C396}",
        nfkd: "\u{110A}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C397}",
        nfc: "\u{C397}",
        nfd: "\u{110A}\u{1166}\u{11BA}",
        nfkc: "\u{C397}",
        nfkd: "\u{110A}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C398}",
        nfc: "\u{C398}",
        nfd: "\u{110A}\u{1166}\u{11BB}",
        nfkc: "\u{C398}",
        nfkd: "\u{110A}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C399}",
        nfc: "\u{C399}",
        nfd: "\u{110A}\u{1166}\u{11BC}",
        nfkc: "\u{C399}",
        nfkd: "\u{110A}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C39A}",
        nfc: "\u{C39A}",
        nfd: "\u{110A}\u{1166}\u{11BD}",
        nfkc: "\u{C39A}",
        nfkd: "\u{110A}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C39B}",
        nfc: "\u{C39B}",
        nfd: "\u{110A}\u{1166}\u{11BE}",
        nfkc: "\u{C39B}",
        nfkd: "\u{110A}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C39C}",
        nfc: "\u{C39C}",
        nfd: "\u{110A}\u{1166}\u{11BF}",
        nfkc: "\u{C39C}",
        nfkd: "\u{110A}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C39D}",
        nfc: "\u{C39D}",
        nfd: "\u{110A}\u{1166}\u{11C0}",
        nfkc: "\u{C39D}",
        nfkd: "\u{110A}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C39E}",
        nfc: "\u{C39E}",
        nfd: "\u{110A}\u{1166}\u{11C1}",
        nfkc: "\u{C39E}",
        nfkd: "\u{110A}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C39F}",
        nfc: "\u{C39F}",
        nfd: "\u{110A}\u{1166}\u{11C2}",
        nfkc: "\u{C39F}",
        nfkd: "\u{110A}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C3A0}",
        nfc: "\u{C3A0}",
        nfd: "\u{110A}\u{1167}",
        nfkc: "\u{C3A0}",
        nfkd: "\u{110A}\u{1167}",
    },
    NormalizationTest {
        source: "\u{C3A1}",
        nfc: "\u{C3A1}",
        nfd: "\u{110A}\u{1167}\u{11A8}",
        nfkc: "\u{C3A1}",
        nfkd: "\u{110A}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C3A2}",
        nfc: "\u{C3A2}",
        nfd: "\u{110A}\u{1167}\u{11A9}",
        nfkc: "\u{C3A2}",
        nfkd: "\u{110A}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C3A3}",
        nfc: "\u{C3A3}",
        nfd: "\u{110A}\u{1167}\u{11AA}",
        nfkc: "\u{C3A3}",
        nfkd: "\u{110A}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C3A4}",
        nfc: "\u{C3A4}",
        nfd: "\u{110A}\u{1167}\u{11AB}",
        nfkc: "\u{C3A4}",
        nfkd: "\u{110A}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C3A5}",
        nfc: "\u{C3A5}",
        nfd: "\u{110A}\u{1167}\u{11AC}",
        nfkc: "\u{C3A5}",
        nfkd: "\u{110A}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C3A6}",
        nfc: "\u{C3A6}",
        nfd: "\u{110A}\u{1167}\u{11AD}",
        nfkc: "\u{C3A6}",
        nfkd: "\u{110A}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C3A7}",
        nfc: "\u{C3A7}",
        nfd: "\u{110A}\u{1167}\u{11AE}",
        nfkc: "\u{C3A7}",
        nfkd: "\u{110A}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C3A8}",
        nfc: "\u{C3A8}",
        nfd: "\u{110A}\u{1167}\u{11AF}",
        nfkc: "\u{C3A8}",
        nfkd: "\u{110A}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C3A9}",
        nfc: "\u{C3A9}",
        nfd: "\u{110A}\u{1167}\u{11B0}",
        nfkc: "\u{C3A9}",
        nfkd: "\u{110A}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C3AA}",
        nfc: "\u{C3AA}",
        nfd: "\u{110A}\u{1167}\u{11B1}",
        nfkc: "\u{C3AA}",
        nfkd: "\u{110A}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C3AB}",
        nfc: "\u{C3AB}",
        nfd: "\u{110A}\u{1167}\u{11B2}",
        nfkc: "\u{C3AB}",
        nfkd: "\u{110A}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C3AC}",
        nfc: "\u{C3AC}",
        nfd: "\u{110A}\u{1167}\u{11B3}",
        nfkc: "\u{C3AC}",
        nfkd: "\u{110A}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C3AD}",
        nfc: "\u{C3AD}",
        nfd: "\u{110A}\u{1167}\u{11B4}",
        nfkc: "\u{C3AD}",
        nfkd: "\u{110A}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C3AE}",
        nfc: "\u{C3AE}",
        nfd: "\u{110A}\u{1167}\u{11B5}",
        nfkc: "\u{C3AE}",
        nfkd: "\u{110A}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C3AF}",
        nfc: "\u{C3AF}",
        nfd: "\u{110A}\u{1167}\u{11B6}",
        nfkc: "\u{C3AF}",
        nfkd: "\u{110A}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C3B0}",
        nfc: "\u{C3B0}",
        nfd: "\u{110A}\u{1167}\u{11B7}",
        nfkc: "\u{C3B0}",
        nfkd: "\u{110A}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C3B1}",
        nfc: "\u{C3B1}",
        nfd: "\u{110A}\u{1167}\u{11B8}",
        nfkc: "\u{C3B1}",
        nfkd: "\u{110A}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C3B2}",
        nfc: "\u{C3B2}",
        nfd: "\u{110A}\u{1167}\u{11B9}",
        nfkc: "\u{C3B2}",
        nfkd: "\u{110A}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C3B3}",
        nfc: "\u{C3B3}",
        nfd: "\u{110A}\u{1167}\u{11BA}",
        nfkc: "\u{C3B3}",
        nfkd: "\u{110A}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C3B4}",
        nfc: "\u{C3B4}",
        nfd: "\u{110A}\u{1167}\u{11BB}",
        nfkc: "\u{C3B4}",
        nfkd: "\u{110A}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C3B5}",
        nfc: "\u{C3B5}",
        nfd: "\u{110A}\u{1167}\u{11BC}",
        nfkc: "\u{C3B5}",
        nfkd: "\u{110A}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C3B6}",
        nfc: "\u{C3B6}",
        nfd: "\u{110A}\u{1167}\u{11BD}",
        nfkc: "\u{C3B6}",
        nfkd: "\u{110A}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C3B7}",
        nfc: "\u{C3B7}",
        nfd: "\u{110A}\u{1167}\u{11BE}",
        nfkc: "\u{C3B7}",
        nfkd: "\u{110A}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C3B8}",
        nfc: "\u{C3B8}",
        nfd: "\u{110A}\u{1167}\u{11BF}",
        nfkc: "\u{C3B8}",
        nfkd: "\u{110A}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C3B9}",
        nfc: "\u{C3B9}",
        nfd: "\u{110A}\u{1167}\u{11C0}",
        nfkc: "\u{C3B9}",
        nfkd: "\u{110A}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C3BA}",
        nfc: "\u{C3BA}",
        nfd: "\u{110A}\u{1167}\u{11C1}",
        nfkc: "\u{C3BA}",
        nfkd: "\u{110A}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C3BB}",
        nfc: "\u{C3BB}",
        nfd: "\u{110A}\u{1167}\u{11C2}",
        nfkc: "\u{C3BB}",
        nfkd: "\u{110A}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C3BC}",
        nfc: "\u{C3BC}",
        nfd: "\u{110A}\u{1168}",
        nfkc: "\u{C3BC}",
        nfkd: "\u{110A}\u{1168}",
    },
    NormalizationTest {
        source: "\u{C3BD}",
        nfc: "\u{C3BD}",
        nfd: "\u{110A}\u{1168}\u{11A8}",
        nfkc: "\u{C3BD}",
        nfkd: "\u{110A}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C3BE}",
        nfc: "\u{C3BE}",
        nfd: "\u{110A}\u{1168}\u{11A9}",
        nfkc: "\u{C3BE}",
        nfkd: "\u{110A}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C3BF}",
        nfc: "\u{C3BF}",
        nfd: "\u{110A}\u{1168}\u{11AA}",
        nfkc: "\u{C3BF}",
        nfkd: "\u{110A}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C3C0}",
        nfc: "\u{C3C0}",
        nfd: "\u{110A}\u{1168}\u{11AB}",
        nfkc: "\u{C3C0}",
        nfkd: "\u{110A}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C3C1}",
        nfc: "\u{C3C1}",
        nfd: "\u{110A}\u{1168}\u{11AC}",
        nfkc: "\u{C3C1}",
        nfkd: "\u{110A}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C3C2}",
        nfc: "\u{C3C2}",
        nfd: "\u{110A}\u{1168}\u{11AD}",
        nfkc: "\u{C3C2}",
        nfkd: "\u{110A}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C3C3}",
        nfc: "\u{C3C3}",
        nfd: "\u{110A}\u{1168}\u{11AE}",
        nfkc: "\u{C3C3}",
        nfkd: "\u{110A}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C3C4}",
        nfc: "\u{C3C4}",
        nfd: "\u{110A}\u{1168}\u{11AF}",
        nfkc: "\u{C3C4}",
        nfkd: "\u{110A}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C3C5}",
        nfc: "\u{C3C5}",
        nfd: "\u{110A}\u{1168}\u{11B0}",
        nfkc: "\u{C3C5}",
        nfkd: "\u{110A}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C3C6}",
        nfc: "\u{C3C6}",
        nfd: "\u{110A}\u{1168}\u{11B1}",
        nfkc: "\u{C3C6}",
        nfkd: "\u{110A}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C3C7}",
        nfc: "\u{C3C7}",
        nfd: "\u{110A}\u{1168}\u{11B2}",
        nfkc: "\u{C3C7}",
        nfkd: "\u{110A}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C3C8}",
        nfc: "\u{C3C8}",
        nfd: "\u{110A}\u{1168}\u{11B3}",
        nfkc: "\u{C3C8}",
        nfkd: "\u{110A}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C3C9}",
        nfc: "\u{C3C9}",
        nfd: "\u{110A}\u{1168}\u{11B4}",
        nfkc: "\u{C3C9}",
        nfkd: "\u{110A}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C3CA}",
        nfc: "\u{C3CA}",
        nfd: "\u{110A}\u{1168}\u{11B5}",
        nfkc: "\u{C3CA}",
        nfkd: "\u{110A}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C3CB}",
        nfc: "\u{C3CB}",
        nfd: "\u{110A}\u{1168}\u{11B6}",
        nfkc: "\u{C3CB}",
        nfkd: "\u{110A}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C3CC}",
        nfc: "\u{C3CC}",
        nfd: "\u{110A}\u{1168}\u{11B7}",
        nfkc: "\u{C3CC}",
        nfkd: "\u{110A}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C3CD}",
        nfc: "\u{C3CD}",
        nfd: "\u{110A}\u{1168}\u{11B8}",
        nfkc: "\u{C3CD}",
        nfkd: "\u{110A}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C3CE}",
        nfc: "\u{C3CE}",
        nfd: "\u{110A}\u{1168}\u{11B9}",
        nfkc: "\u{C3CE}",
        nfkd: "\u{110A}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C3CF}",
        nfc: "\u{C3CF}",
        nfd: "\u{110A}\u{1168}\u{11BA}",
        nfkc: "\u{C3CF}",
        nfkd: "\u{110A}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C3D0}",
        nfc: "\u{C3D0}",
        nfd: "\u{110A}\u{1168}\u{11BB}",
        nfkc: "\u{C3D0}",
        nfkd: "\u{110A}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C3D1}",
        nfc: "\u{C3D1}",
        nfd: "\u{110A}\u{1168}\u{11BC}",
        nfkc: "\u{C3D1}",
        nfkd: "\u{110A}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C3D2}",
        nfc: "\u{C3D2}",
        nfd: "\u{110A}\u{1168}\u{11BD}",
        nfkc: "\u{C3D2}",
        nfkd: "\u{110A}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C3D3}",
        nfc: "\u{C3D3}",
        nfd: "\u{110A}\u{1168}\u{11BE}",
        nfkc: "\u{C3D3}",
        nfkd: "\u{110A}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C3D4}",
        nfc: "\u{C3D4}",
        nfd: "\u{110A}\u{1168}\u{11BF}",
        nfkc: "\u{C3D4}",
        nfkd: "\u{110A}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C3D5}",
        nfc: "\u{C3D5}",
        nfd: "\u{110A}\u{1168}\u{11C0}",
        nfkc: "\u{C3D5}",
        nfkd: "\u{110A}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C3D6}",
        nfc: "\u{C3D6}",
        nfd: "\u{110A}\u{1168}\u{11C1}",
        nfkc: "\u{C3D6}",
        nfkd: "\u{110A}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C3D7}",
        nfc: "\u{C3D7}",
        nfd: "\u{110A}\u{1168}\u{11C2}",
        nfkc: "\u{C3D7}",
        nfkd: "\u{110A}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C3D8}",
        nfc: "\u{C3D8}",
        nfd: "\u{110A}\u{1169}",
        nfkc: "\u{C3D8}",
        nfkd: "\u{110A}\u{1169}",
    },
    NormalizationTest {
        source: "\u{C3D9}",
        nfc: "\u{C3D9}",
        nfd: "\u{110A}\u{1169}\u{11A8}",
        nfkc: "\u{C3D9}",
        nfkd: "\u{110A}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C3DA}",
        nfc: "\u{C3DA}",
        nfd: "\u{110A}\u{1169}\u{11A9}",
        nfkc: "\u{C3DA}",
        nfkd: "\u{110A}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C3DB}",
        nfc: "\u{C3DB}",
        nfd: "\u{110A}\u{1169}\u{11AA}",
        nfkc: "\u{C3DB}",
        nfkd: "\u{110A}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C3DC}",
        nfc: "\u{C3DC}",
        nfd: "\u{110A}\u{1169}\u{11AB}",
        nfkc: "\u{C3DC}",
        nfkd: "\u{110A}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C3DD}",
        nfc: "\u{C3DD}",
        nfd: "\u{110A}\u{1169}\u{11AC}",
        nfkc: "\u{C3DD}",
        nfkd: "\u{110A}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C3DE}",
        nfc: "\u{C3DE}",
        nfd: "\u{110A}\u{1169}\u{11AD}",
        nfkc: "\u{C3DE}",
        nfkd: "\u{110A}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C3DF}",
        nfc: "\u{C3DF}",
        nfd: "\u{110A}\u{1169}\u{11AE}",
        nfkc: "\u{C3DF}",
        nfkd: "\u{110A}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C3E0}",
        nfc: "\u{C3E0}",
        nfd: "\u{110A}\u{1169}\u{11AF}",
        nfkc: "\u{C3E0}",
        nfkd: "\u{110A}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C3E1}",
        nfc: "\u{C3E1}",
        nfd: "\u{110A}\u{1169}\u{11B0}",
        nfkc: "\u{C3E1}",
        nfkd: "\u{110A}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C3E2}",
        nfc: "\u{C3E2}",
        nfd: "\u{110A}\u{1169}\u{11B1}",
        nfkc: "\u{C3E2}",
        nfkd: "\u{110A}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C3E3}",
        nfc: "\u{C3E3}",
        nfd: "\u{110A}\u{1169}\u{11B2}",
        nfkc: "\u{C3E3}",
        nfkd: "\u{110A}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C3E4}",
        nfc: "\u{C3E4}",
        nfd: "\u{110A}\u{1169}\u{11B3}",
        nfkc: "\u{C3E4}",
        nfkd: "\u{110A}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C3E5}",
        nfc: "\u{C3E5}",
        nfd: "\u{110A}\u{1169}\u{11B4}",
        nfkc: "\u{C3E5}",
        nfkd: "\u{110A}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C3E6}",
        nfc: "\u{C3E6}",
        nfd: "\u{110A}\u{1169}\u{11B5}",
        nfkc: "\u{C3E6}",
        nfkd: "\u{110A}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C3E7}",
        nfc: "\u{C3E7}",
        nfd: "\u{110A}\u{1169}\u{11B6}",
        nfkc: "\u{C3E7}",
        nfkd: "\u{110A}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C3E8}",
        nfc: "\u{C3E8}",
        nfd: "\u{110A}\u{1169}\u{11B7}",
        nfkc: "\u{C3E8}",
        nfkd: "\u{110A}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C3E9}",
        nfc: "\u{C3E9}",
        nfd: "\u{110A}\u{1169}\u{11B8}",
        nfkc: "\u{C3E9}",
        nfkd: "\u{110A}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C3EA}",
        nfc: "\u{C3EA}",
        nfd: "\u{110A}\u{1169}\u{11B9}",
        nfkc: "\u{C3EA}",
        nfkd: "\u{110A}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C3EB}",
        nfc: "\u{C3EB}",
        nfd: "\u{110A}\u{1169}\u{11BA}",
        nfkc: "\u{C3EB}",
        nfkd: "\u{110A}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C3EC}",
        nfc: "\u{C3EC}",
        nfd: "\u{110A}\u{1169}\u{11BB}",
        nfkc: "\u{C3EC}",
        nfkd: "\u{110A}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C3ED}",
        nfc: "\u{C3ED}",
        nfd: "\u{110A}\u{1169}\u{11BC}",
        nfkc: "\u{C3ED}",
        nfkd: "\u{110A}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C3EE}",
        nfc: "\u{C3EE}",
        nfd: "\u{110A}\u{1169}\u{11BD}",
        nfkc: "\u{C3EE}",
        nfkd: "\u{110A}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C3EF}",
        nfc: "\u{C3EF}",
        nfd: "\u{110A}\u{1169}\u{11BE}",
        nfkc: "\u{C3EF}",
        nfkd: "\u{110A}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C3F0}",
        nfc: "\u{C3F0}",
        nfd: "\u{110A}\u{1169}\u{11BF}",
        nfkc: "\u{C3F0}",
        nfkd: "\u{110A}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C3F1}",
        nfc: "\u{C3F1}",
        nfd: "\u{110A}\u{1169}\u{11C0}",
        nfkc: "\u{C3F1}",
        nfkd: "\u{110A}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C3F2}",
        nfc: "\u{C3F2}",
        nfd: "\u{110A}\u{1169}\u{11C1}",
        nfkc: "\u{C3F2}",
        nfkd: "\u{110A}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C3F3}",
        nfc: "\u{C3F3}",
        nfd: "\u{110A}\u{1169}\u{11C2}",
        nfkc: "\u{C3F3}",
        nfkd: "\u{110A}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C3F4}",
        nfc: "\u{C3F4}",
        nfd: "\u{110A}\u{116A}",
        nfkc: "\u{C3F4}",
        nfkd: "\u{110A}\u{116A}",
    },
    NormalizationTest {
        source: "\u{C3F5}",
        nfc: "\u{C3F5}",
        nfd: "\u{110A}\u{116A}\u{11A8}",
        nfkc: "\u{C3F5}",
        nfkd: "\u{110A}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C3F6}",
        nfc: "\u{C3F6}",
        nfd: "\u{110A}\u{116A}\u{11A9}",
        nfkc: "\u{C3F6}",
        nfkd: "\u{110A}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C3F7}",
        nfc: "\u{C3F7}",
        nfd: "\u{110A}\u{116A}\u{11AA}",
        nfkc: "\u{C3F7}",
        nfkd: "\u{110A}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C3F8}",
        nfc: "\u{C3F8}",
        nfd: "\u{110A}\u{116A}\u{11AB}",
        nfkc: "\u{C3F8}",
        nfkd: "\u{110A}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C3F9}",
        nfc: "\u{C3F9}",
        nfd: "\u{110A}\u{116A}\u{11AC}",
        nfkc: "\u{C3F9}",
        nfkd: "\u{110A}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C3FA}",
        nfc: "\u{C3FA}",
        nfd: "\u{110A}\u{116A}\u{11AD}",
        nfkc: "\u{C3FA}",
        nfkd: "\u{110A}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C3FB}",
        nfc: "\u{C3FB}",
        nfd: "\u{110A}\u{116A}\u{11AE}",
        nfkc: "\u{C3FB}",
        nfkd: "\u{110A}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C3FC}",
        nfc: "\u{C3FC}",
        nfd: "\u{110A}\u{116A}\u{11AF}",
        nfkc: "\u{C3FC}",
        nfkd: "\u{110A}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C3FD}",
        nfc: "\u{C3FD}",
        nfd: "\u{110A}\u{116A}\u{11B0}",
        nfkc: "\u{C3FD}",
        nfkd: "\u{110A}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C3FE}",
        nfc: "\u{C3FE}",
        nfd: "\u{110A}\u{116A}\u{11B1}",
        nfkc: "\u{C3FE}",
        nfkd: "\u{110A}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C3FF}",
        nfc: "\u{C3FF}",
        nfd: "\u{110A}\u{116A}\u{11B2}",
        nfkc: "\u{C3FF}",
        nfkd: "\u{110A}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C400}",
        nfc: "\u{C400}",
        nfd: "\u{110A}\u{116A}\u{11B3}",
        nfkc: "\u{C400}",
        nfkd: "\u{110A}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C401}",
        nfc: "\u{C401}",
        nfd: "\u{110A}\u{116A}\u{11B4}",
        nfkc: "\u{C401}",
        nfkd: "\u{110A}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C402}",
        nfc: "\u{C402}",
        nfd: "\u{110A}\u{116A}\u{11B5}",
        nfkc: "\u{C402}",
        nfkd: "\u{110A}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C403}",
        nfc: "\u{C403}",
        nfd: "\u{110A}\u{116A}\u{11B6}",
        nfkc: "\u{C403}",
        nfkd: "\u{110A}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C404}",
        nfc: "\u{C404}",
        nfd: "\u{110A}\u{116A}\u{11B7}",
        nfkc: "\u{C404}",
        nfkd: "\u{110A}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C405}",
        nfc: "\u{C405}",
        nfd: "\u{110A}\u{116A}\u{11B8}",
        nfkc: "\u{C405}",
        nfkd: "\u{110A}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C406}",
        nfc: "\u{C406}",
        nfd: "\u{110A}\u{116A}\u{11B9}",
        nfkc: "\u{C406}",
        nfkd: "\u{110A}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C407}",
        nfc: "\u{C407}",
        nfd: "\u{110A}\u{116A}\u{11BA}",
        nfkc: "\u{C407}",
        nfkd: "\u{110A}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C408}",
        nfc: "\u{C408}",
        nfd: "\u{110A}\u{116A}\u{11BB}",
        nfkc: "\u{C408}",
        nfkd: "\u{110A}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C409}",
        nfc: "\u{C409}",
        nfd: "\u{110A}\u{116A}\u{11BC}",
        nfkc: "\u{C409}",
        nfkd: "\u{110A}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C40A}",
        nfc: "\u{C40A}",
        nfd: "\u{110A}\u{116A}\u{11BD}",
        nfkc: "\u{C40A}",
        nfkd: "\u{110A}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C40B}",
        nfc: "\u{C40B}",
        nfd: "\u{110A}\u{116A}\u{11BE}",
        nfkc: "\u{C40B}",
        nfkd: "\u{110A}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C40C}",
        nfc: "\u{C40C}",
        nfd: "\u{110A}\u{116A}\u{11BF}",
        nfkc: "\u{C40C}",
        nfkd: "\u{110A}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C40D}",
        nfc: "\u{C40D}",
        nfd: "\u{110A}\u{116A}\u{11C0}",
        nfkc: "\u{C40D}",
        nfkd: "\u{110A}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C40E}",
        nfc: "\u{C40E}",
        nfd: "\u{110A}\u{116A}\u{11C1}",
        nfkc: "\u{C40E}",
        nfkd: "\u{110A}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C40F}",
        nfc: "\u{C40F}",
        nfd: "\u{110A}\u{116A}\u{11C2}",
        nfkc: "\u{C40F}",
        nfkd: "\u{110A}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C410}",
        nfc: "\u{C410}",
        nfd: "\u{110A}\u{116B}",
        nfkc: "\u{C410}",
        nfkd: "\u{110A}\u{116B}",
    },
    NormalizationTest {
        source: "\u{C411}",
        nfc: "\u{C411}",
        nfd: "\u{110A}\u{116B}\u{11A8}",
        nfkc: "\u{C411}",
        nfkd: "\u{110A}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C412}",
        nfc: "\u{C412}",
        nfd: "\u{110A}\u{116B}\u{11A9}",
        nfkc: "\u{C412}",
        nfkd: "\u{110A}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C413}",
        nfc: "\u{C413}",
        nfd: "\u{110A}\u{116B}\u{11AA}",
        nfkc: "\u{C413}",
        nfkd: "\u{110A}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C414}",
        nfc: "\u{C414}",
        nfd: "\u{110A}\u{116B}\u{11AB}",
        nfkc: "\u{C414}",
        nfkd: "\u{110A}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C415}",
        nfc: "\u{C415}",
        nfd: "\u{110A}\u{116B}\u{11AC}",
        nfkc: "\u{C415}",
        nfkd: "\u{110A}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C416}",
        nfc: "\u{C416}",
        nfd: "\u{110A}\u{116B}\u{11AD}",
        nfkc: "\u{C416}",
        nfkd: "\u{110A}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C417}",
        nfc: "\u{C417}",
        nfd: "\u{110A}\u{116B}\u{11AE}",
        nfkc: "\u{C417}",
        nfkd: "\u{110A}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C418}",
        nfc: "\u{C418}",
        nfd: "\u{110A}\u{116B}\u{11AF}",
        nfkc: "\u{C418}",
        nfkd: "\u{110A}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C419}",
        nfc: "\u{C419}",
        nfd: "\u{110A}\u{116B}\u{11B0}",
        nfkc: "\u{C419}",
        nfkd: "\u{110A}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C41A}",
        nfc: "\u{C41A}",
        nfd: "\u{110A}\u{116B}\u{11B1}",
        nfkc: "\u{C41A}",
        nfkd: "\u{110A}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C41B}",
        nfc: "\u{C41B}",
        nfd: "\u{110A}\u{116B}\u{11B2}",
        nfkc: "\u{C41B}",
        nfkd: "\u{110A}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C41C}",
        nfc: "\u{C41C}",
        nfd: "\u{110A}\u{116B}\u{11B3}",
        nfkc: "\u{C41C}",
        nfkd: "\u{110A}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C41D}",
        nfc: "\u{C41D}",
        nfd: "\u{110A}\u{116B}\u{11B4}",
        nfkc: "\u{C41D}",
        nfkd: "\u{110A}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C41E}",
        nfc: "\u{C41E}",
        nfd: "\u{110A}\u{116B}\u{11B5}",
        nfkc: "\u{C41E}",
        nfkd: "\u{110A}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C41F}",
        nfc: "\u{C41F}",
        nfd: "\u{110A}\u{116B}\u{11B6}",
        nfkc: "\u{C41F}",
        nfkd: "\u{110A}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C420}",
        nfc: "\u{C420}",
        nfd: "\u{110A}\u{116B}\u{11B7}",
        nfkc: "\u{C420}",
        nfkd: "\u{110A}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C421}",
        nfc: "\u{C421}",
        nfd: "\u{110A}\u{116B}\u{11B8}",
        nfkc: "\u{C421}",
        nfkd: "\u{110A}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C422}",
        nfc: "\u{C422}",
        nfd: "\u{110A}\u{116B}\u{11B9}",
        nfkc: "\u{C422}",
        nfkd: "\u{110A}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C423}",
        nfc: "\u{C423}",
        nfd: "\u{110A}\u{116B}\u{11BA}",
        nfkc: "\u{C423}",
        nfkd: "\u{110A}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C424}",
        nfc: "\u{C424}",
        nfd: "\u{110A}\u{116B}\u{11BB}",
        nfkc: "\u{C424}",
        nfkd: "\u{110A}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C425}",
        nfc: "\u{C425}",
        nfd: "\u{110A}\u{116B}\u{11BC}",
        nfkc: "\u{C425}",
        nfkd: "\u{110A}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C426}",
        nfc: "\u{C426}",
        nfd: "\u{110A}\u{116B}\u{11BD}",
        nfkc: "\u{C426}",
        nfkd: "\u{110A}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C427}",
        nfc: "\u{C427}",
        nfd: "\u{110A}\u{116B}\u{11BE}",
        nfkc: "\u{C427}",
        nfkd: "\u{110A}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C428}",
        nfc: "\u{C428}",
        nfd: "\u{110A}\u{116B}\u{11BF}",
        nfkc: "\u{C428}",
        nfkd: "\u{110A}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C429}",
        nfc: "\u{C429}",
        nfd: "\u{110A}\u{116B}\u{11C0}",
        nfkc: "\u{C429}",
        nfkd: "\u{110A}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C42A}",
        nfc: "\u{C42A}",
        nfd: "\u{110A}\u{116B}\u{11C1}",
        nfkc: "\u{C42A}",
        nfkd: "\u{110A}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C42B}",
        nfc: "\u{C42B}",
        nfd: "\u{110A}\u{116B}\u{11C2}",
        nfkc: "\u{C42B}",
        nfkd: "\u{110A}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C42C}",
        nfc: "\u{C42C}",
        nfd: "\u{110A}\u{116C}",
        nfkc: "\u{C42C}",
        nfkd: "\u{110A}\u{116C}",
    },
    NormalizationTest {
        source: "\u{C42D}",
        nfc: "\u{C42D}",
        nfd: "\u{110A}\u{116C}\u{11A8}",
        nfkc: "\u{C42D}",
        nfkd: "\u{110A}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C42E}",
        nfc: "\u{C42E}",
        nfd: "\u{110A}\u{116C}\u{11A9}",
        nfkc: "\u{C42E}",
        nfkd: "\u{110A}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C42F}",
        nfc: "\u{C42F}",
        nfd: "\u{110A}\u{116C}\u{11AA}",
        nfkc: "\u{C42F}",
        nfkd: "\u{110A}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C430}",
        nfc: "\u{C430}",
        nfd: "\u{110A}\u{116C}\u{11AB}",
        nfkc: "\u{C430}",
        nfkd: "\u{110A}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C431}",
        nfc: "\u{C431}",
        nfd: "\u{110A}\u{116C}\u{11AC}",
        nfkc: "\u{C431}",
        nfkd: "\u{110A}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C432}",
        nfc: "\u{C432}",
        nfd: "\u{110A}\u{116C}\u{11AD}",
        nfkc: "\u{C432}",
        nfkd: "\u{110A}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C433}",
        nfc: "\u{C433}",
        nfd: "\u{110A}\u{116C}\u{11AE}",
        nfkc: "\u{C433}",
        nfkd: "\u{110A}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C434}",
        nfc: "\u{C434}",
        nfd: "\u{110A}\u{116C}\u{11AF}",
        nfkc: "\u{C434}",
        nfkd: "\u{110A}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C435}",
        nfc: "\u{C435}",
        nfd: "\u{110A}\u{116C}\u{11B0}",
        nfkc: "\u{C435}",
        nfkd: "\u{110A}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C436}",
        nfc: "\u{C436}",
        nfd: "\u{110A}\u{116C}\u{11B1}",
        nfkc: "\u{C436}",
        nfkd: "\u{110A}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C437}",
        nfc: "\u{C437}",
        nfd: "\u{110A}\u{116C}\u{11B2}",
        nfkc: "\u{C437}",
        nfkd: "\u{110A}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C438}",
        nfc: "\u{C438}",
        nfd: "\u{110A}\u{116C}\u{11B3}",
        nfkc: "\u{C438}",
        nfkd: "\u{110A}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C439}",
        nfc: "\u{C439}",
        nfd: "\u{110A}\u{116C}\u{11B4}",
        nfkc: "\u{C439}",
        nfkd: "\u{110A}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C43A}",
        nfc: "\u{C43A}",
        nfd: "\u{110A}\u{116C}\u{11B5}",
        nfkc: "\u{C43A}",
        nfkd: "\u{110A}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C43B}",
        nfc: "\u{C43B}",
        nfd: "\u{110A}\u{116C}\u{11B6}",
        nfkc: "\u{C43B}",
        nfkd: "\u{110A}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C43C}",
        nfc: "\u{C43C}",
        nfd: "\u{110A}\u{116C}\u{11B7}",
        nfkc: "\u{C43C}",
        nfkd: "\u{110A}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C43D}",
        nfc: "\u{C43D}",
        nfd: "\u{110A}\u{116C}\u{11B8}",
        nfkc: "\u{C43D}",
        nfkd: "\u{110A}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C43E}",
        nfc: "\u{C43E}",
        nfd: "\u{110A}\u{116C}\u{11B9}",
        nfkc: "\u{C43E}",
        nfkd: "\u{110A}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C43F}",
        nfc: "\u{C43F}",
        nfd: "\u{110A}\u{116C}\u{11BA}",
        nfkc: "\u{C43F}",
        nfkd: "\u{110A}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C440}",
        nfc: "\u{C440}",
        nfd: "\u{110A}\u{116C}\u{11BB}",
        nfkc: "\u{C440}",
        nfkd: "\u{110A}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C441}",
        nfc: "\u{C441}",
        nfd: "\u{110A}\u{116C}\u{11BC}",
        nfkc: "\u{C441}",
        nfkd: "\u{110A}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C442}",
        nfc: "\u{C442}",
        nfd: "\u{110A}\u{116C}\u{11BD}",
        nfkc: "\u{C442}",
        nfkd: "\u{110A}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C443}",
        nfc: "\u{C443}",
        nfd: "\u{110A}\u{116C}\u{11BE}",
        nfkc: "\u{C443}",
        nfkd: "\u{110A}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C444}",
        nfc: "\u{C444}",
        nfd: "\u{110A}\u{116C}\u{11BF}",
        nfkc: "\u{C444}",
        nfkd: "\u{110A}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C445}",
        nfc: "\u{C445}",
        nfd: "\u{110A}\u{116C}\u{11C0}",
        nfkc: "\u{C445}",
        nfkd: "\u{110A}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C446}",
        nfc: "\u{C446}",
        nfd: "\u{110A}\u{116C}\u{11C1}",
        nfkc: "\u{C446}",
        nfkd: "\u{110A}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C447}",
        nfc: "\u{C447}",
        nfd: "\u{110A}\u{116C}\u{11C2}",
        nfkc: "\u{C447}",
        nfkd: "\u{110A}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C448}",
        nfc: "\u{C448}",
        nfd: "\u{110A}\u{116D}",
        nfkc: "\u{C448}",
        nfkd: "\u{110A}\u{116D}",
    },
    NormalizationTest {
        source: "\u{C449}",
        nfc: "\u{C449}",
        nfd: "\u{110A}\u{116D}\u{11A8}",
        nfkc: "\u{C449}",
        nfkd: "\u{110A}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C44A}",
        nfc: "\u{C44A}",
        nfd: "\u{110A}\u{116D}\u{11A9}",
        nfkc: "\u{C44A}",
        nfkd: "\u{110A}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C44B}",
        nfc: "\u{C44B}",
        nfd: "\u{110A}\u{116D}\u{11AA}",
        nfkc: "\u{C44B}",
        nfkd: "\u{110A}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C44C}",
        nfc: "\u{C44C}",
        nfd: "\u{110A}\u{116D}\u{11AB}",
        nfkc: "\u{C44C}",
        nfkd: "\u{110A}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C44D}",
        nfc: "\u{C44D}",
        nfd: "\u{110A}\u{116D}\u{11AC}",
        nfkc: "\u{C44D}",
        nfkd: "\u{110A}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C44E}",
        nfc: "\u{C44E}",
        nfd: "\u{110A}\u{116D}\u{11AD}",
        nfkc: "\u{C44E}",
        nfkd: "\u{110A}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C44F}",
        nfc: "\u{C44F}",
        nfd: "\u{110A}\u{116D}\u{11AE}",
        nfkc: "\u{C44F}",
        nfkd: "\u{110A}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C450}",
        nfc: "\u{C450}",
        nfd: "\u{110A}\u{116D}\u{11AF}",
        nfkc: "\u{C450}",
        nfkd: "\u{110A}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C451}",
        nfc: "\u{C451}",
        nfd: "\u{110A}\u{116D}\u{11B0}",
        nfkc: "\u{C451}",
        nfkd: "\u{110A}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C452}",
        nfc: "\u{C452}",
        nfd: "\u{110A}\u{116D}\u{11B1}",
        nfkc: "\u{C452}",
        nfkd: "\u{110A}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C453}",
        nfc: "\u{C453}",
        nfd: "\u{110A}\u{116D}\u{11B2}",
        nfkc: "\u{C453}",
        nfkd: "\u{110A}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C454}",
        nfc: "\u{C454}",
        nfd: "\u{110A}\u{116D}\u{11B3}",
        nfkc: "\u{C454}",
        nfkd: "\u{110A}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C455}",
        nfc: "\u{C455}",
        nfd: "\u{110A}\u{116D}\u{11B4}",
        nfkc: "\u{C455}",
        nfkd: "\u{110A}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C456}",
        nfc: "\u{C456}",
        nfd: "\u{110A}\u{116D}\u{11B5}",
        nfkc: "\u{C456}",
        nfkd: "\u{110A}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C457}",
        nfc: "\u{C457}",
        nfd: "\u{110A}\u{116D}\u{11B6}",
        nfkc: "\u{C457}",
        nfkd: "\u{110A}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C458}",
        nfc: "\u{C458}",
        nfd: "\u{110A}\u{116D}\u{11B7}",
        nfkc: "\u{C458}",
        nfkd: "\u{110A}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C459}",
        nfc: "\u{C459}",
        nfd: "\u{110A}\u{116D}\u{11B8}",
        nfkc: "\u{C459}",
        nfkd: "\u{110A}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C45A}",
        nfc: "\u{C45A}",
        nfd: "\u{110A}\u{116D}\u{11B9}",
        nfkc: "\u{C45A}",
        nfkd: "\u{110A}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C45B}",
        nfc: "\u{C45B}",
        nfd: "\u{110A}\u{116D}\u{11BA}",
        nfkc: "\u{C45B}",
        nfkd: "\u{110A}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C45C}",
        nfc: "\u{C45C}",
        nfd: "\u{110A}\u{116D}\u{11BB}",
        nfkc: "\u{C45C}",
        nfkd: "\u{110A}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C45D}",
        nfc: "\u{C45D}",
        nfd: "\u{110A}\u{116D}\u{11BC}",
        nfkc: "\u{C45D}",
        nfkd: "\u{110A}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C45E}",
        nfc: "\u{C45E}",
        nfd: "\u{110A}\u{116D}\u{11BD}",
        nfkc: "\u{C45E}",
        nfkd: "\u{110A}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C45F}",
        nfc: "\u{C45F}",
        nfd: "\u{110A}\u{116D}\u{11BE}",
        nfkc: "\u{C45F}",
        nfkd: "\u{110A}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C460}",
        nfc: "\u{C460}",
        nfd: "\u{110A}\u{116D}\u{11BF}",
        nfkc: "\u{C460}",
        nfkd: "\u{110A}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C461}",
        nfc: "\u{C461}",
        nfd: "\u{110A}\u{116D}\u{11C0}",
        nfkc: "\u{C461}",
        nfkd: "\u{110A}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C462}",
        nfc: "\u{C462}",
        nfd: "\u{110A}\u{116D}\u{11C1}",
        nfkc: "\u{C462}",
        nfkd: "\u{110A}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C463}",
        nfc: "\u{C463}",
        nfd: "\u{110A}\u{116D}\u{11C2}",
        nfkc: "\u{C463}",
        nfkd: "\u{110A}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C464}",
        nfc: "\u{C464}",
        nfd: "\u{110A}\u{116E}",
        nfkc: "\u{C464}",
        nfkd: "\u{110A}\u{116E}",
    },
    NormalizationTest {
        source: "\u{C465}",
        nfc: "\u{C465}",
        nfd: "\u{110A}\u{116E}\u{11A8}",
        nfkc: "\u{C465}",
        nfkd: "\u{110A}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C466}",
        nfc: "\u{C466}",
        nfd: "\u{110A}\u{116E}\u{11A9}",
        nfkc: "\u{C466}",
        nfkd: "\u{110A}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C467}",
        nfc: "\u{C467}",
        nfd: "\u{110A}\u{116E}\u{11AA}",
        nfkc: "\u{C467}",
        nfkd: "\u{110A}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C468}",
        nfc: "\u{C468}",
        nfd: "\u{110A}\u{116E}\u{11AB}",
        nfkc: "\u{C468}",
        nfkd: "\u{110A}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C469}",
        nfc: "\u{C469}",
        nfd: "\u{110A}\u{116E}\u{11AC}",
        nfkc: "\u{C469}",
        nfkd: "\u{110A}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C46A}",
        nfc: "\u{C46A}",
        nfd: "\u{110A}\u{116E}\u{11AD}",
        nfkc: "\u{C46A}",
        nfkd: "\u{110A}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C46B}",
        nfc: "\u{C46B}",
        nfd: "\u{110A}\u{116E}\u{11AE}",
        nfkc: "\u{C46B}",
        nfkd: "\u{110A}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C46C}",
        nfc: "\u{C46C}",
        nfd: "\u{110A}\u{116E}\u{11AF}",
        nfkc: "\u{C46C}",
        nfkd: "\u{110A}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C46D}",
        nfc: "\u{C46D}",
        nfd: "\u{110A}\u{116E}\u{11B0}",
        nfkc: "\u{C46D}",
        nfkd: "\u{110A}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C46E}",
        nfc: "\u{C46E}",
        nfd: "\u{110A}\u{116E}\u{11B1}",
        nfkc: "\u{C46E}",
        nfkd: "\u{110A}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C46F}",
        nfc: "\u{C46F}",
        nfd: "\u{110A}\u{116E}\u{11B2}",
        nfkc: "\u{C46F}",
        nfkd: "\u{110A}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C470}",
        nfc: "\u{C470}",
        nfd: "\u{110A}\u{116E}\u{11B3}",
        nfkc: "\u{C470}",
        nfkd: "\u{110A}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C471}",
        nfc: "\u{C471}",
        nfd: "\u{110A}\u{116E}\u{11B4}",
        nfkc: "\u{C471}",
        nfkd: "\u{110A}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C472}",
        nfc: "\u{C472}",
        nfd: "\u{110A}\u{116E}\u{11B5}",
        nfkc: "\u{C472}",
        nfkd: "\u{110A}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C473}",
        nfc: "\u{C473}",
        nfd: "\u{110A}\u{116E}\u{11B6}",
        nfkc: "\u{C473}",
        nfkd: "\u{110A}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C474}",
        nfc: "\u{C474}",
        nfd: "\u{110A}\u{116E}\u{11B7}",
        nfkc: "\u{C474}",
        nfkd: "\u{110A}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C475}",
        nfc: "\u{C475}",
        nfd: "\u{110A}\u{116E}\u{11B8}",
        nfkc: "\u{C475}",
        nfkd: "\u{110A}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C476}",
        nfc: "\u{C476}",
        nfd: "\u{110A}\u{116E}\u{11B9}",
        nfkc: "\u{C476}",
        nfkd: "\u{110A}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C477}",
        nfc: "\u{C477}",
        nfd: "\u{110A}\u{116E}\u{11BA}",
        nfkc: "\u{C477}",
        nfkd: "\u{110A}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C478}",
        nfc: "\u{C478}",
        nfd: "\u{110A}\u{116E}\u{11BB}",
        nfkc: "\u{C478}",
        nfkd: "\u{110A}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C479}",
        nfc: "\u{C479}",
        nfd: "\u{110A}\u{116E}\u{11BC}",
        nfkc: "\u{C479}",
        nfkd: "\u{110A}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C47A}",
        nfc: "\u{C47A}",
        nfd: "\u{110A}\u{116E}\u{11BD}",
        nfkc: "\u{C47A}",
        nfkd: "\u{110A}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C47B}",
        nfc: "\u{C47B}",
        nfd: "\u{110A}\u{116E}\u{11BE}",
        nfkc: "\u{C47B}",
        nfkd: "\u{110A}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C47C}",
        nfc: "\u{C47C}",
        nfd: "\u{110A}\u{116E}\u{11BF}",
        nfkc: "\u{C47C}",
        nfkd: "\u{110A}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C47D}",
        nfc: "\u{C47D}",
        nfd: "\u{110A}\u{116E}\u{11C0}",
        nfkc: "\u{C47D}",
        nfkd: "\u{110A}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C47E}",
        nfc: "\u{C47E}",
        nfd: "\u{110A}\u{116E}\u{11C1}",
        nfkc: "\u{C47E}",
        nfkd: "\u{110A}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C47F}",
        nfc: "\u{C47F}",
        nfd: "\u{110A}\u{116E}\u{11C2}",
        nfkc: "\u{C47F}",
        nfkd: "\u{110A}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C480}",
        nfc: "\u{C480}",
        nfd: "\u{110A}\u{116F}",
        nfkc: "\u{C480}",
        nfkd: "\u{110A}\u{116F}",
    },
    NormalizationTest {
        source: "\u{C481}",
        nfc: "\u{C481}",
        nfd: "\u{110A}\u{116F}\u{11A8}",
        nfkc: "\u{C481}",
        nfkd: "\u{110A}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C482}",
        nfc: "\u{C482}",
        nfd: "\u{110A}\u{116F}\u{11A9}",
        nfkc: "\u{C482}",
        nfkd: "\u{110A}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C483}",
        nfc: "\u{C483}",
        nfd: "\u{110A}\u{116F}\u{11AA}",
        nfkc: "\u{C483}",
        nfkd: "\u{110A}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C484}",
        nfc: "\u{C484}",
        nfd: "\u{110A}\u{116F}\u{11AB}",
        nfkc: "\u{C484}",
        nfkd: "\u{110A}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C485}",
        nfc: "\u{C485}",
        nfd: "\u{110A}\u{116F}\u{11AC}",
        nfkc: "\u{C485}",
        nfkd: "\u{110A}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C486}",
        nfc: "\u{C486}",
        nfd: "\u{110A}\u{116F}\u{11AD}",
        nfkc: "\u{C486}",
        nfkd: "\u{110A}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C487}",
        nfc: "\u{C487}",
        nfd: "\u{110A}\u{116F}\u{11AE}",
        nfkc: "\u{C487}",
        nfkd: "\u{110A}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C488}",
        nfc: "\u{C488}",
        nfd: "\u{110A}\u{116F}\u{11AF}",
        nfkc: "\u{C488}",
        nfkd: "\u{110A}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C489}",
        nfc: "\u{C489}",
        nfd: "\u{110A}\u{116F}\u{11B0}",
        nfkc: "\u{C489}",
        nfkd: "\u{110A}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C48A}",
        nfc: "\u{C48A}",
        nfd: "\u{110A}\u{116F}\u{11B1}",
        nfkc: "\u{C48A}",
        nfkd: "\u{110A}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C48B}",
        nfc: "\u{C48B}",
        nfd: "\u{110A}\u{116F}\u{11B2}",
        nfkc: "\u{C48B}",
        nfkd: "\u{110A}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C48C}",
        nfc: "\u{C48C}",
        nfd: "\u{110A}\u{116F}\u{11B3}",
        nfkc: "\u{C48C}",
        nfkd: "\u{110A}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C48D}",
        nfc: "\u{C48D}",
        nfd: "\u{110A}\u{116F}\u{11B4}",
        nfkc: "\u{C48D}",
        nfkd: "\u{110A}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C48E}",
        nfc: "\u{C48E}",
        nfd: "\u{110A}\u{116F}\u{11B5}",
        nfkc: "\u{C48E}",
        nfkd: "\u{110A}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C48F}",
        nfc: "\u{C48F}",
        nfd: "\u{110A}\u{116F}\u{11B6}",
        nfkc: "\u{C48F}",
        nfkd: "\u{110A}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C490}",
        nfc: "\u{C490}",
        nfd: "\u{110A}\u{116F}\u{11B7}",
        nfkc: "\u{C490}",
        nfkd: "\u{110A}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C491}",
        nfc: "\u{C491}",
        nfd: "\u{110A}\u{116F}\u{11B8}",
        nfkc: "\u{C491}",
        nfkd: "\u{110A}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C492}",
        nfc: "\u{C492}",
        nfd: "\u{110A}\u{116F}\u{11B9}",
        nfkc: "\u{C492}",
        nfkd: "\u{110A}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C493}",
        nfc: "\u{C493}",
        nfd: "\u{110A}\u{116F}\u{11BA}",
        nfkc: "\u{C493}",
        nfkd: "\u{110A}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C494}",
        nfc: "\u{C494}",
        nfd: "\u{110A}\u{116F}\u{11BB}",
        nfkc: "\u{C494}",
        nfkd: "\u{110A}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C495}",
        nfc: "\u{C495}",
        nfd: "\u{110A}\u{116F}\u{11BC}",
        nfkc: "\u{C495}",
        nfkd: "\u{110A}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C496}",
        nfc: "\u{C496}",
        nfd: "\u{110A}\u{116F}\u{11BD}",
        nfkc: "\u{C496}",
        nfkd: "\u{110A}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C497}",
        nfc: "\u{C497}",
        nfd: "\u{110A}\u{116F}\u{11BE}",
        nfkc: "\u{C497}",
        nfkd: "\u{110A}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C498}",
        nfc: "\u{C498}",
        nfd: "\u{110A}\u{116F}\u{11BF}",
        nfkc: "\u{C498}",
        nfkd: "\u{110A}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C499}",
        nfc: "\u{C499}",
        nfd: "\u{110A}\u{116F}\u{11C0}",
        nfkc: "\u{C499}",
        nfkd: "\u{110A}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C49A}",
        nfc: "\u{C49A}",
        nfd: "\u{110A}\u{116F}\u{11C1}",
        nfkc: "\u{C49A}",
        nfkd: "\u{110A}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C49B}",
        nfc: "\u{C49B}",
        nfd: "\u{110A}\u{116F}\u{11C2}",
        nfkc: "\u{C49B}",
        nfkd: "\u{110A}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C49C}",
        nfc: "\u{C49C}",
        nfd: "\u{110A}\u{1170}",
        nfkc: "\u{C49C}",
        nfkd: "\u{110A}\u{1170}",
    },
    NormalizationTest {
        source: "\u{C49D}",
        nfc: "\u{C49D}",
        nfd: "\u{110A}\u{1170}\u{11A8}",
        nfkc: "\u{C49D}",
        nfkd: "\u{110A}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C49E}",
        nfc: "\u{C49E}",
        nfd: "\u{110A}\u{1170}\u{11A9}",
        nfkc: "\u{C49E}",
        nfkd: "\u{110A}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C49F}",
        nfc: "\u{C49F}",
        nfd: "\u{110A}\u{1170}\u{11AA}",
        nfkc: "\u{C49F}",
        nfkd: "\u{110A}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C4A0}",
        nfc: "\u{C4A0}",
        nfd: "\u{110A}\u{1170}\u{11AB}",
        nfkc: "\u{C4A0}",
        nfkd: "\u{110A}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C4A1}",
        nfc: "\u{C4A1}",
        nfd: "\u{110A}\u{1170}\u{11AC}",
        nfkc: "\u{C4A1}",
        nfkd: "\u{110A}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C4A2}",
        nfc: "\u{C4A2}",
        nfd: "\u{110A}\u{1170}\u{11AD}",
        nfkc: "\u{C4A2}",
        nfkd: "\u{110A}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C4A3}",
        nfc: "\u{C4A3}",
        nfd: "\u{110A}\u{1170}\u{11AE}",
        nfkc: "\u{C4A3}",
        nfkd: "\u{110A}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C4A4}",
        nfc: "\u{C4A4}",
        nfd: "\u{110A}\u{1170}\u{11AF}",
        nfkc: "\u{C4A4}",
        nfkd: "\u{110A}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C4A5}",
        nfc: "\u{C4A5}",
        nfd: "\u{110A}\u{1170}\u{11B0}",
        nfkc: "\u{C4A5}",
        nfkd: "\u{110A}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C4A6}",
        nfc: "\u{C4A6}",
        nfd: "\u{110A}\u{1170}\u{11B1}",
        nfkc: "\u{C4A6}",
        nfkd: "\u{110A}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C4A7}",
        nfc: "\u{C4A7}",
        nfd: "\u{110A}\u{1170}\u{11B2}",
        nfkc: "\u{C4A7}",
        nfkd: "\u{110A}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C4A8}",
        nfc: "\u{C4A8}",
        nfd: "\u{110A}\u{1170}\u{11B3}",
        nfkc: "\u{C4A8}",
        nfkd: "\u{110A}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C4A9}",
        nfc: "\u{C4A9}",
        nfd: "\u{110A}\u{1170}\u{11B4}",
        nfkc: "\u{C4A9}",
        nfkd: "\u{110A}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C4AA}",
        nfc: "\u{C4AA}",
        nfd: "\u{110A}\u{1170}\u{11B5}",
        nfkc: "\u{C4AA}",
        nfkd: "\u{110A}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C4AB}",
        nfc: "\u{C4AB}",
        nfd: "\u{110A}\u{1170}\u{11B6}",
        nfkc: "\u{C4AB}",
        nfkd: "\u{110A}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C4AC}",
        nfc: "\u{C4AC}",
        nfd: "\u{110A}\u{1170}\u{11B7}",
        nfkc: "\u{C4AC}",
        nfkd: "\u{110A}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C4AD}",
        nfc: "\u{C4AD}",
        nfd: "\u{110A}\u{1170}\u{11B8}",
        nfkc: "\u{C4AD}",
        nfkd: "\u{110A}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C4AE}",
        nfc: "\u{C4AE}",
        nfd: "\u{110A}\u{1170}\u{11B9}",
        nfkc: "\u{C4AE}",
        nfkd: "\u{110A}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C4AF}",
        nfc: "\u{C4AF}",
        nfd: "\u{110A}\u{1170}\u{11BA}",
        nfkc: "\u{C4AF}",
        nfkd: "\u{110A}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C4B0}",
        nfc: "\u{C4B0}",
        nfd: "\u{110A}\u{1170}\u{11BB}",
        nfkc: "\u{C4B0}",
        nfkd: "\u{110A}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C4B1}",
        nfc: "\u{C4B1}",
        nfd: "\u{110A}\u{1170}\u{11BC}",
        nfkc: "\u{C4B1}",
        nfkd: "\u{110A}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C4B2}",
        nfc: "\u{C4B2}",
        nfd: "\u{110A}\u{1170}\u{11BD}",
        nfkc: "\u{C4B2}",
        nfkd: "\u{110A}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C4B3}",
        nfc: "\u{C4B3}",
        nfd: "\u{110A}\u{1170}\u{11BE}",
        nfkc: "\u{C4B3}",
        nfkd: "\u{110A}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C4B4}",
        nfc: "\u{C4B4}",
        nfd: "\u{110A}\u{1170}\u{11BF}",
        nfkc: "\u{C4B4}",
        nfkd: "\u{110A}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C4B5}",
        nfc: "\u{C4B5}",
        nfd: "\u{110A}\u{1170}\u{11C0}",
        nfkc: "\u{C4B5}",
        nfkd: "\u{110A}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C4B6}",
        nfc: "\u{C4B6}",
        nfd: "\u{110A}\u{1170}\u{11C1}",
        nfkc: "\u{C4B6}",
        nfkd: "\u{110A}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C4B7}",
        nfc: "\u{C4B7}",
        nfd: "\u{110A}\u{1170}\u{11C2}",
        nfkc: "\u{C4B7}",
        nfkd: "\u{110A}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C4B8}",
        nfc: "\u{C4B8}",
        nfd: "\u{110A}\u{1171}",
        nfkc: "\u{C4B8}",
        nfkd: "\u{110A}\u{1171}",
    },
    NormalizationTest {
        source: "\u{C4B9}",
        nfc: "\u{C4B9}",
        nfd: "\u{110A}\u{1171}\u{11A8}",
        nfkc: "\u{C4B9}",
        nfkd: "\u{110A}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C4BA}",
        nfc: "\u{C4BA}",
        nfd: "\u{110A}\u{1171}\u{11A9}",
        nfkc: "\u{C4BA}",
        nfkd: "\u{110A}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C4BB}",
        nfc: "\u{C4BB}",
        nfd: "\u{110A}\u{1171}\u{11AA}",
        nfkc: "\u{C4BB}",
        nfkd: "\u{110A}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C4BC}",
        nfc: "\u{C4BC}",
        nfd: "\u{110A}\u{1171}\u{11AB}",
        nfkc: "\u{C4BC}",
        nfkd: "\u{110A}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C4BD}",
        nfc: "\u{C4BD}",
        nfd: "\u{110A}\u{1171}\u{11AC}",
        nfkc: "\u{C4BD}",
        nfkd: "\u{110A}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C4BE}",
        nfc: "\u{C4BE}",
        nfd: "\u{110A}\u{1171}\u{11AD}",
        nfkc: "\u{C4BE}",
        nfkd: "\u{110A}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C4BF}",
        nfc: "\u{C4BF}",
        nfd: "\u{110A}\u{1171}\u{11AE}",
        nfkc: "\u{C4BF}",
        nfkd: "\u{110A}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C4C0}",
        nfc: "\u{C4C0}",
        nfd: "\u{110A}\u{1171}\u{11AF}",
        nfkc: "\u{C4C0}",
        nfkd: "\u{110A}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C4C1}",
        nfc: "\u{C4C1}",
        nfd: "\u{110A}\u{1171}\u{11B0}",
        nfkc: "\u{C4C1}",
        nfkd: "\u{110A}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C4C2}",
        nfc: "\u{C4C2}",
        nfd: "\u{110A}\u{1171}\u{11B1}",
        nfkc: "\u{C4C2}",
        nfkd: "\u{110A}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C4C3}",
        nfc: "\u{C4C3}",
        nfd: "\u{110A}\u{1171}\u{11B2}",
        nfkc: "\u{C4C3}",
        nfkd: "\u{110A}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C4C4}",
        nfc: "\u{C4C4}",
        nfd: "\u{110A}\u{1171}\u{11B3}",
        nfkc: "\u{C4C4}",
        nfkd: "\u{110A}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C4C5}",
        nfc: "\u{C4C5}",
        nfd: "\u{110A}\u{1171}\u{11B4}",
        nfkc: "\u{C4C5}",
        nfkd: "\u{110A}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C4C6}",
        nfc: "\u{C4C6}",
        nfd: "\u{110A}\u{1171}\u{11B5}",
        nfkc: "\u{C4C6}",
        nfkd: "\u{110A}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C4C7}",
        nfc: "\u{C4C7}",
        nfd: "\u{110A}\u{1171}\u{11B6}",
        nfkc: "\u{C4C7}",
        nfkd: "\u{110A}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C4C8}",
        nfc: "\u{C4C8}",
        nfd: "\u{110A}\u{1171}\u{11B7}",
        nfkc: "\u{C4C8}",
        nfkd: "\u{110A}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C4C9}",
        nfc: "\u{C4C9}",
        nfd: "\u{110A}\u{1171}\u{11B8}",
        nfkc: "\u{C4C9}",
        nfkd: "\u{110A}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C4CA}",
        nfc: "\u{C4CA}",
        nfd: "\u{110A}\u{1171}\u{11B9}",
        nfkc: "\u{C4CA}",
        nfkd: "\u{110A}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C4CB}",
        nfc: "\u{C4CB}",
        nfd: "\u{110A}\u{1171}\u{11BA}",
        nfkc: "\u{C4CB}",
        nfkd: "\u{110A}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C4CC}",
        nfc: "\u{C4CC}",
        nfd: "\u{110A}\u{1171}\u{11BB}",
        nfkc: "\u{C4CC}",
        nfkd: "\u{110A}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C4CD}",
        nfc: "\u{C4CD}",
        nfd: "\u{110A}\u{1171}\u{11BC}",
        nfkc: "\u{C4CD}",
        nfkd: "\u{110A}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C4CE}",
        nfc: "\u{C4CE}",
        nfd: "\u{110A}\u{1171}\u{11BD}",
        nfkc: "\u{C4CE}",
        nfkd: "\u{110A}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C4CF}",
        nfc: "\u{C4CF}",
        nfd: "\u{110A}\u{1171}\u{11BE}",
        nfkc: "\u{C4CF}",
        nfkd: "\u{110A}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C4D0}",
        nfc: "\u{C4D0}",
        nfd: "\u{110A}\u{1171}\u{11BF}",
        nfkc: "\u{C4D0}",
        nfkd: "\u{110A}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C4D1}",
        nfc: "\u{C4D1}",
        nfd: "\u{110A}\u{1171}\u{11C0}",
        nfkc: "\u{C4D1}",
        nfkd: "\u{110A}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C4D2}",
        nfc: "\u{C4D2}",
        nfd: "\u{110A}\u{1171}\u{11C1}",
        nfkc: "\u{C4D2}",
        nfkd: "\u{110A}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C4D3}",
        nfc: "\u{C4D3}",
        nfd: "\u{110A}\u{1171}\u{11C2}",
        nfkc: "\u{C4D3}",
        nfkd: "\u{110A}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C4D4}",
        nfc: "\u{C4D4}",
        nfd: "\u{110A}\u{1172}",
        nfkc: "\u{C4D4}",
        nfkd: "\u{110A}\u{1172}",
    },
    NormalizationTest {
        source: "\u{C4D5}",
        nfc: "\u{C4D5}",
        nfd: "\u{110A}\u{1172}\u{11A8}",
        nfkc: "\u{C4D5}",
        nfkd: "\u{110A}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C4D6}",
        nfc: "\u{C4D6}",
        nfd: "\u{110A}\u{1172}\u{11A9}",
        nfkc: "\u{C4D6}",
        nfkd: "\u{110A}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C4D7}",
        nfc: "\u{C4D7}",
        nfd: "\u{110A}\u{1172}\u{11AA}",
        nfkc: "\u{C4D7}",
        nfkd: "\u{110A}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C4D8}",
        nfc: "\u{C4D8}",
        nfd: "\u{110A}\u{1172}\u{11AB}",
        nfkc: "\u{C4D8}",
        nfkd: "\u{110A}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C4D9}",
        nfc: "\u{C4D9}",
        nfd: "\u{110A}\u{1172}\u{11AC}",
        nfkc: "\u{C4D9}",
        nfkd: "\u{110A}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C4DA}",
        nfc: "\u{C4DA}",
        nfd: "\u{110A}\u{1172}\u{11AD}",
        nfkc: "\u{C4DA}",
        nfkd: "\u{110A}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C4DB}",
        nfc: "\u{C4DB}",
        nfd: "\u{110A}\u{1172}\u{11AE}",
        nfkc: "\u{C4DB}",
        nfkd: "\u{110A}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C4DC}",
        nfc: "\u{C4DC}",
        nfd: "\u{110A}\u{1172}\u{11AF}",
        nfkc: "\u{C4DC}",
        nfkd: "\u{110A}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C4DD}",
        nfc: "\u{C4DD}",
        nfd: "\u{110A}\u{1172}\u{11B0}",
        nfkc: "\u{C4DD}",
        nfkd: "\u{110A}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C4DE}",
        nfc: "\u{C4DE}",
        nfd: "\u{110A}\u{1172}\u{11B1}",
        nfkc: "\u{C4DE}",
        nfkd: "\u{110A}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C4DF}",
        nfc: "\u{C4DF}",
        nfd: "\u{110A}\u{1172}\u{11B2}",
        nfkc: "\u{C4DF}",
        nfkd: "\u{110A}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C4E0}",
        nfc: "\u{C4E0}",
        nfd: "\u{110A}\u{1172}\u{11B3}",
        nfkc: "\u{C4E0}",
        nfkd: "\u{110A}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C4E1}",
        nfc: "\u{C4E1}",
        nfd: "\u{110A}\u{1172}\u{11B4}",
        nfkc: "\u{C4E1}",
        nfkd: "\u{110A}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C4E2}",
        nfc: "\u{C4E2}",
        nfd: "\u{110A}\u{1172}\u{11B5}",
        nfkc: "\u{C4E2}",
        nfkd: "\u{110A}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C4E3}",
        nfc: "\u{C4E3}",
        nfd: "\u{110A}\u{1172}\u{11B6}",
        nfkc: "\u{C4E3}",
        nfkd: "\u{110A}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C4E4}",
        nfc: "\u{C4E4}",
        nfd: "\u{110A}\u{1172}\u{11B7}",
        nfkc: "\u{C4E4}",
        nfkd: "\u{110A}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C4E5}",
        nfc: "\u{C4E5}",
        nfd: "\u{110A}\u{1172}\u{11B8}",
        nfkc: "\u{C4E5}",
        nfkd: "\u{110A}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C4E6}",
        nfc: "\u{C4E6}",
        nfd: "\u{110A}\u{1172}\u{11B9}",
        nfkc: "\u{C4E6}",
        nfkd: "\u{110A}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C4E7}",
        nfc: "\u{C4E7}",
        nfd: "\u{110A}\u{1172}\u{11BA}",
        nfkc: "\u{C4E7}",
        nfkd: "\u{110A}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C4E8}",
        nfc: "\u{C4E8}",
        nfd: "\u{110A}\u{1172}\u{11BB}",
        nfkc: "\u{C4E8}",
        nfkd: "\u{110A}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C4E9}",
        nfc: "\u{C4E9}",
        nfd: "\u{110A}\u{1172}\u{11BC}",
        nfkc: "\u{C4E9}",
        nfkd: "\u{110A}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C4EA}",
        nfc: "\u{C4EA}",
        nfd: "\u{110A}\u{1172}\u{11BD}",
        nfkc: "\u{C4EA}",
        nfkd: "\u{110A}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C4EB}",
        nfc: "\u{C4EB}",
        nfd: "\u{110A}\u{1172}\u{11BE}",
        nfkc: "\u{C4EB}",
        nfkd: "\u{110A}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C4EC}",
        nfc: "\u{C4EC}",
        nfd: "\u{110A}\u{1172}\u{11BF}",
        nfkc: "\u{C4EC}",
        nfkd: "\u{110A}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C4ED}",
        nfc: "\u{C4ED}",
        nfd: "\u{110A}\u{1172}\u{11C0}",
        nfkc: "\u{C4ED}",
        nfkd: "\u{110A}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C4EE}",
        nfc: "\u{C4EE}",
        nfd: "\u{110A}\u{1172}\u{11C1}",
        nfkc: "\u{C4EE}",
        nfkd: "\u{110A}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C4EF}",
        nfc: "\u{C4EF}",
        nfd: "\u{110A}\u{1172}\u{11C2}",
        nfkc: "\u{C4EF}",
        nfkd: "\u{110A}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C4F0}",
        nfc: "\u{C4F0}",
        nfd: "\u{110A}\u{1173}",
        nfkc: "\u{C4F0}",
        nfkd: "\u{110A}\u{1173}",
    },
    NormalizationTest {
        source: "\u{C4F1}",
        nfc: "\u{C4F1}",
        nfd: "\u{110A}\u{1173}\u{11A8}",
        nfkc: "\u{C4F1}",
        nfkd: "\u{110A}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C4F2}",
        nfc: "\u{C4F2}",
        nfd: "\u{110A}\u{1173}\u{11A9}",
        nfkc: "\u{C4F2}",
        nfkd: "\u{110A}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C4F3}",
        nfc: "\u{C4F3}",
        nfd: "\u{110A}\u{1173}\u{11AA}",
        nfkc: "\u{C4F3}",
        nfkd: "\u{110A}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C4F4}",
        nfc: "\u{C4F4}",
        nfd: "\u{110A}\u{1173}\u{11AB}",
        nfkc: "\u{C4F4}",
        nfkd: "\u{110A}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C4F5}",
        nfc: "\u{C4F5}",
        nfd: "\u{110A}\u{1173}\u{11AC}",
        nfkc: "\u{C4F5}",
        nfkd: "\u{110A}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C4F6}",
        nfc: "\u{C4F6}",
        nfd: "\u{110A}\u{1173}\u{11AD}",
        nfkc: "\u{C4F6}",
        nfkd: "\u{110A}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C4F7}",
        nfc: "\u{C4F7}",
        nfd: "\u{110A}\u{1173}\u{11AE}",
        nfkc: "\u{C4F7}",
        nfkd: "\u{110A}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C4F8}",
        nfc: "\u{C4F8}",
        nfd: "\u{110A}\u{1173}\u{11AF}",
        nfkc: "\u{C4F8}",
        nfkd: "\u{110A}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C4F9}",
        nfc: "\u{C4F9}",
        nfd: "\u{110A}\u{1173}\u{11B0}",
        nfkc: "\u{C4F9}",
        nfkd: "\u{110A}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C4FA}",
        nfc: "\u{C4FA}",
        nfd: "\u{110A}\u{1173}\u{11B1}",
        nfkc: "\u{C4FA}",
        nfkd: "\u{110A}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C4FB}",
        nfc: "\u{C4FB}",
        nfd: "\u{110A}\u{1173}\u{11B2}",
        nfkc: "\u{C4FB}",
        nfkd: "\u{110A}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C4FC}",
        nfc: "\u{C4FC}",
        nfd: "\u{110A}\u{1173}\u{11B3}",
        nfkc: "\u{C4FC}",
        nfkd: "\u{110A}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C4FD}",
        nfc: "\u{C4FD}",
        nfd: "\u{110A}\u{1173}\u{11B4}",
        nfkc: "\u{C4FD}",
        nfkd: "\u{110A}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C4FE}",
        nfc: "\u{C4FE}",
        nfd: "\u{110A}\u{1173}\u{11B5}",
        nfkc: "\u{C4FE}",
        nfkd: "\u{110A}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C4FF}",
        nfc: "\u{C4FF}",
        nfd: "\u{110A}\u{1173}\u{11B6}",
        nfkc: "\u{C4FF}",
        nfkd: "\u{110A}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C500}",
        nfc: "\u{C500}",
        nfd: "\u{110A}\u{1173}\u{11B7}",
        nfkc: "\u{C500}",
        nfkd: "\u{110A}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C501}",
        nfc: "\u{C501}",
        nfd: "\u{110A}\u{1173}\u{11B8}",
        nfkc: "\u{C501}",
        nfkd: "\u{110A}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C502}",
        nfc: "\u{C502}",
        nfd: "\u{110A}\u{1173}\u{11B9}",
        nfkc: "\u{C502}",
        nfkd: "\u{110A}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C503}",
        nfc: "\u{C503}",
        nfd: "\u{110A}\u{1173}\u{11BA}",
        nfkc: "\u{C503}",
        nfkd: "\u{110A}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C504}",
        nfc: "\u{C504}",
        nfd: "\u{110A}\u{1173}\u{11BB}",
        nfkc: "\u{C504}",
        nfkd: "\u{110A}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C505}",
        nfc: "\u{C505}",
        nfd: "\u{110A}\u{1173}\u{11BC}",
        nfkc: "\u{C505}",
        nfkd: "\u{110A}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C506}",
        nfc: "\u{C506}",
        nfd: "\u{110A}\u{1173}\u{11BD}",
        nfkc: "\u{C506}",
        nfkd: "\u{110A}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C507}",
        nfc: "\u{C507}",
        nfd: "\u{110A}\u{1173}\u{11BE}",
        nfkc: "\u{C507}",
        nfkd: "\u{110A}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C508}",
        nfc: "\u{C508}",
        nfd: "\u{110A}\u{1173}\u{11BF}",
        nfkc: "\u{C508}",
        nfkd: "\u{110A}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C509}",
        nfc: "\u{C509}",
        nfd: "\u{110A}\u{1173}\u{11C0}",
        nfkc: "\u{C509}",
        nfkd: "\u{110A}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C50A}",
        nfc: "\u{C50A}",
        nfd: "\u{110A}\u{1173}\u{11C1}",
        nfkc: "\u{C50A}",
        nfkd: "\u{110A}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C50B}",
        nfc: "\u{C50B}",
        nfd: "\u{110A}\u{1173}\u{11C2}",
        nfkc: "\u{C50B}",
        nfkd: "\u{110A}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C50C}",
        nfc: "\u{C50C}",
        nfd: "\u{110A}\u{1174}",
        nfkc: "\u{C50C}",
        nfkd: "\u{110A}\u{1174}",
    },
    NormalizationTest {
        source: "\u{C50D}",
        nfc: "\u{C50D}",
        nfd: "\u{110A}\u{1174}\u{11A8}",
        nfkc: "\u{C50D}",
        nfkd: "\u{110A}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C50E}",
        nfc: "\u{C50E}",
        nfd: "\u{110A}\u{1174}\u{11A9}",
        nfkc: "\u{C50E}",
        nfkd: "\u{110A}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C50F}",
        nfc: "\u{C50F}",
        nfd: "\u{110A}\u{1174}\u{11AA}",
        nfkc: "\u{C50F}",
        nfkd: "\u{110A}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C510}",
        nfc: "\u{C510}",
        nfd: "\u{110A}\u{1174}\u{11AB}",
        nfkc: "\u{C510}",
        nfkd: "\u{110A}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C511}",
        nfc: "\u{C511}",
        nfd: "\u{110A}\u{1174}\u{11AC}",
        nfkc: "\u{C511}",
        nfkd: "\u{110A}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C512}",
        nfc: "\u{C512}",
        nfd: "\u{110A}\u{1174}\u{11AD}",
        nfkc: "\u{C512}",
        nfkd: "\u{110A}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C513}",
        nfc: "\u{C513}",
        nfd: "\u{110A}\u{1174}\u{11AE}",
        nfkc: "\u{C513}",
        nfkd: "\u{110A}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C514}",
        nfc: "\u{C514}",
        nfd: "\u{110A}\u{1174}\u{11AF}",
        nfkc: "\u{C514}",
        nfkd: "\u{110A}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C515}",
        nfc: "\u{C515}",
        nfd: "\u{110A}\u{1174}\u{11B0}",
        nfkc: "\u{C515}",
        nfkd: "\u{110A}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C516}",
        nfc: "\u{C516}",
        nfd: "\u{110A}\u{1174}\u{11B1}",
        nfkc: "\u{C516}",
        nfkd: "\u{110A}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C517}",
        nfc: "\u{C517}",
        nfd: "\u{110A}\u{1174}\u{11B2}",
        nfkc: "\u{C517}",
        nfkd: "\u{110A}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C518}",
        nfc: "\u{C518}",
        nfd: "\u{110A}\u{1174}\u{11B3}",
        nfkc: "\u{C518}",
        nfkd: "\u{110A}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C519}",
        nfc: "\u{C519}",
        nfd: "\u{110A}\u{1174}\u{11B4}",
        nfkc: "\u{C519}",
        nfkd: "\u{110A}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C51A}",
        nfc: "\u{C51A}",
        nfd: "\u{110A}\u{1174}\u{11B5}",
        nfkc: "\u{C51A}",
        nfkd: "\u{110A}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C51B}",
        nfc: "\u{C51B}",
        nfd: "\u{110A}\u{1174}\u{11B6}",
        nfkc: "\u{C51B}",
        nfkd: "\u{110A}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C51C}",
        nfc: "\u{C51C}",
        nfd: "\u{110A}\u{1174}\u{11B7}",
        nfkc: "\u{C51C}",
        nfkd: "\u{110A}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C51D}",
        nfc: "\u{C51D}",
        nfd: "\u{110A}\u{1174}\u{11B8}",
        nfkc: "\u{C51D}",
        nfkd: "\u{110A}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C51E}",
        nfc: "\u{C51E}",
        nfd: "\u{110A}\u{1174}\u{11B9}",
        nfkc: "\u{C51E}",
        nfkd: "\u{110A}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C51F}",
        nfc: "\u{C51F}",
        nfd: "\u{110A}\u{1174}\u{11BA}",
        nfkc: "\u{C51F}",
        nfkd: "\u{110A}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C520}",
        nfc: "\u{C520}",
        nfd: "\u{110A}\u{1174}\u{11BB}",
        nfkc: "\u{C520}",
        nfkd: "\u{110A}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C521}",
        nfc: "\u{C521}",
        nfd: "\u{110A}\u{1174}\u{11BC}",
        nfkc: "\u{C521}",
        nfkd: "\u{110A}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C522}",
        nfc: "\u{C522}",
        nfd: "\u{110A}\u{1174}\u{11BD}",
        nfkc: "\u{C522}",
        nfkd: "\u{110A}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C523}",
        nfc: "\u{C523}",
        nfd: "\u{110A}\u{1174}\u{11BE}",
        nfkc: "\u{C523}",
        nfkd: "\u{110A}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C524}",
        nfc: "\u{C524}",
        nfd: "\u{110A}\u{1174}\u{11BF}",
        nfkc: "\u{C524}",
        nfkd: "\u{110A}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C525}",
        nfc: "\u{C525}",
        nfd: "\u{110A}\u{1174}\u{11C0}",
        nfkc: "\u{C525}",
        nfkd: "\u{110A}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C526}",
        nfc: "\u{C526}",
        nfd: "\u{110A}\u{1174}\u{11C1}",
        nfkc: "\u{C526}",
        nfkd: "\u{110A}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C527}",
        nfc: "\u{C527}",
        nfd: "\u{110A}\u{1174}\u{11C2}",
        nfkc: "\u{C527}",
        nfkd: "\u{110A}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C528}",
        nfc: "\u{C528}",
        nfd: "\u{110A}\u{1175}",
        nfkc: "\u{C528}",
        nfkd: "\u{110A}\u{1175}",
    },
    NormalizationTest {
        source: "\u{C529}",
        nfc: "\u{C529}",
        nfd: "\u{110A}\u{1175}\u{11A8}",
        nfkc: "\u{C529}",
        nfkd: "\u{110A}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C52A}",
        nfc: "\u{C52A}",
        nfd: "\u{110A}\u{1175}\u{11A9}",
        nfkc: "\u{C52A}",
        nfkd: "\u{110A}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C52B}",
        nfc: "\u{C52B}",
        nfd: "\u{110A}\u{1175}\u{11AA}",
        nfkc: "\u{C52B}",
        nfkd: "\u{110A}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C52C}",
        nfc: "\u{C52C}",
        nfd: "\u{110A}\u{1175}\u{11AB}",
        nfkc: "\u{C52C}",
        nfkd: "\u{110A}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C52D}",
        nfc: "\u{C52D}",
        nfd: "\u{110A}\u{1175}\u{11AC}",
        nfkc: "\u{C52D}",
        nfkd: "\u{110A}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C52E}",
        nfc: "\u{C52E}",
        nfd: "\u{110A}\u{1175}\u{11AD}",
        nfkc: "\u{C52E}",
        nfkd: "\u{110A}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C52F}",
        nfc: "\u{C52F}",
        nfd: "\u{110A}\u{1175}\u{11AE}",
        nfkc: "\u{C52F}",
        nfkd: "\u{110A}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C530}",
        nfc: "\u{C530}",
        nfd: "\u{110A}\u{1175}\u{11AF}",
        nfkc: "\u{C530}",
        nfkd: "\u{110A}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C531}",
        nfc: "\u{C531}",
        nfd: "\u{110A}\u{1175}\u{11B0}",
        nfkc: "\u{C531}",
        nfkd: "\u{110A}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C532}",
        nfc: "\u{C532}",
        nfd: "\u{110A}\u{1175}\u{11B1}",
        nfkc: "\u{C532}",
        nfkd: "\u{110A}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C533}",
        nfc: "\u{C533}",
        nfd: "\u{110A}\u{1175}\u{11B2}",
        nfkc: "\u{C533}",
        nfkd: "\u{110A}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C534}",
        nfc: "\u{C534}",
        nfd: "\u{110A}\u{1175}\u{11B3}",
        nfkc: "\u{C534}",
        nfkd: "\u{110A}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C535}",
        nfc: "\u{C535}",
        nfd: "\u{110A}\u{1175}\u{11B4}",
        nfkc: "\u{C535}",
        nfkd: "\u{110A}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C536}",
        nfc: "\u{C536}",
        nfd: "\u{110A}\u{1175}\u{11B5}",
        nfkc: "\u{C536}",
        nfkd: "\u{110A}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C537}",
        nfc: "\u{C537}",
        nfd: "\u{110A}\u{1175}\u{11B6}",
        nfkc: "\u{C537}",
        nfkd: "\u{110A}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C538}",
        nfc: "\u{C538}",
        nfd: "\u{110A}\u{1175}\u{11B7}",
        nfkc: "\u{C538}",
        nfkd: "\u{110A}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C539}",
        nfc: "\u{C539}",
        nfd: "\u{110A}\u{1175}\u{11B8}",
        nfkc: "\u{C539}",
        nfkd: "\u{110A}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C53A}",
        nfc: "\u{C53A}",
        nfd: "\u{110A}\u{1175}\u{11B9}",
        nfkc: "\u{C53A}",
        nfkd: "\u{110A}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C53B}",
        nfc: "\u{C53B}",
        nfd: "\u{110A}\u{1175}\u{11BA}",
        nfkc: "\u{C53B}",
        nfkd: "\u{110A}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C53C}",
        nfc: "\u{C53C}",
        nfd: "\u{110A}\u{1175}\u{11BB}",
        nfkc: "\u{C53C}",
        nfkd: "\u{110A}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C53D}",
        nfc: "\u{C53D}",
        nfd: "\u{110A}\u{1175}\u{11BC}",
        nfkc: "\u{C53D}",
        nfkd: "\u{110A}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C53E}",
        nfc: "\u{C53E}",
        nfd: "\u{110A}\u{1175}\u{11BD}",
        nfkc: "\u{C53E}",
        nfkd: "\u{110A}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C53F}",
        nfc: "\u{C53F}",
        nfd: "\u{110A}\u{1175}\u{11BE}",
        nfkc: "\u{C53F}",
        nfkd: "\u{110A}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C540}",
        nfc: "\u{C540}",
        nfd: "\u{110A}\u{1175}\u{11BF}",
        nfkc: "\u{C540}",
        nfkd: "\u{110A}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C541}",
        nfc: "\u{C541}",
        nfd: "\u{110A}\u{1175}\u{11C0}",
        nfkc: "\u{C541}",
        nfkd: "\u{110A}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C542}",
        nfc: "\u{C542}",
        nfd: "\u{110A}\u{1175}\u{11C1}",
        nfkc: "\u{C542}",
        nfkd: "\u{110A}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C543}",
        nfc: "\u{C543}",
        nfd: "\u{110A}\u{1175}\u{11C2}",
        nfkc: "\u{C543}",
        nfkd: "\u{110A}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C544}",
        nfc: "\u{C544}",
        nfd: "\u{110B}\u{1161}",
        nfkc: "\u{C544}",
        nfkd: "\u{110B}\u{1161}",
    },
    NormalizationTest {
        source: "\u{C545}",
        nfc: "\u{C545}",
        nfd: "\u{110B}\u{1161}\u{11A8}",
        nfkc: "\u{C545}",
        nfkd: "\u{110B}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C546}",
        nfc: "\u{C546}",
        nfd: "\u{110B}\u{1161}\u{11A9}",
        nfkc: "\u{C546}",
        nfkd: "\u{110B}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C547}",
        nfc: "\u{C547}",
        nfd: "\u{110B}\u{1161}\u{11AA}",
        nfkc: "\u{C547}",
        nfkd: "\u{110B}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C548}",
        nfc: "\u{C548}",
        nfd: "\u{110B}\u{1161}\u{11AB}",
        nfkc: "\u{C548}",
        nfkd: "\u{110B}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C549}",
        nfc: "\u{C549}",
        nfd: "\u{110B}\u{1161}\u{11AC}",
        nfkc: "\u{C549}",
        nfkd: "\u{110B}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C54A}",
        nfc: "\u{C54A}",
        nfd: "\u{110B}\u{1161}\u{11AD}",
        nfkc: "\u{C54A}",
        nfkd: "\u{110B}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C54B}",
        nfc: "\u{C54B}",
        nfd: "\u{110B}\u{1161}\u{11AE}",
        nfkc: "\u{C54B}",
        nfkd: "\u{110B}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C54C}",
        nfc: "\u{C54C}",
        nfd: "\u{110B}\u{1161}\u{11AF}",
        nfkc: "\u{C54C}",
        nfkd: "\u{110B}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C54D}",
        nfc: "\u{C54D}",
        nfd: "\u{110B}\u{1161}\u{11B0}",
        nfkc: "\u{C54D}",
        nfkd: "\u{110B}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C54E}",
        nfc: "\u{C54E}",
        nfd: "\u{110B}\u{1161}\u{11B1}",
        nfkc: "\u{C54E}",
        nfkd: "\u{110B}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C54F}",
        nfc: "\u{C54F}",
        nfd: "\u{110B}\u{1161}\u{11B2}",
        nfkc: "\u{C54F}",
        nfkd: "\u{110B}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C550}",
        nfc: "\u{C550}",
        nfd: "\u{110B}\u{1161}\u{11B3}",
        nfkc: "\u{C550}",
        nfkd: "\u{110B}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C551}",
        nfc: "\u{C551}",
        nfd: "\u{110B}\u{1161}\u{11B4}",
        nfkc: "\u{C551}",
        nfkd: "\u{110B}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C552}",
        nfc: "\u{C552}",
        nfd: "\u{110B}\u{1161}\u{11B5}",
        nfkc: "\u{C552}",
        nfkd: "\u{110B}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C553}",
        nfc: "\u{C553}",
        nfd: "\u{110B}\u{1161}\u{11B6}",
        nfkc: "\u{C553}",
        nfkd: "\u{110B}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C554}",
        nfc: "\u{C554}",
        nfd: "\u{110B}\u{1161}\u{11B7}",
        nfkc: "\u{C554}",
        nfkd: "\u{110B}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C555}",
        nfc: "\u{C555}",
        nfd: "\u{110B}\u{1161}\u{11B8}",
        nfkc: "\u{C555}",
        nfkd: "\u{110B}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C556}",
        nfc: "\u{C556}",
        nfd: "\u{110B}\u{1161}\u{11B9}",
        nfkc: "\u{C556}",
        nfkd: "\u{110B}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C557}",
        nfc: "\u{C557}",
        nfd: "\u{110B}\u{1161}\u{11BA}",
        nfkc: "\u{C557}",
        nfkd: "\u{110B}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C558}",
        nfc: "\u{C558}",
        nfd: "\u{110B}\u{1161}\u{11BB}",
        nfkc: "\u{C558}",
        nfkd: "\u{110B}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C559}",
        nfc: "\u{C559}",
        nfd: "\u{110B}\u{1161}\u{11BC}",
        nfkc: "\u{C559}",
        nfkd: "\u{110B}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C55A}",
        nfc: "\u{C55A}",
        nfd: "\u{110B}\u{1161}\u{11BD}",
        nfkc: "\u{C55A}",
        nfkd: "\u{110B}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C55B}",
        nfc: "\u{C55B}",
        nfd: "\u{110B}\u{1161}\u{11BE}",
        nfkc: "\u{C55B}",
        nfkd: "\u{110B}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C55C}",
        nfc: "\u{C55C}",
        nfd: "\u{110B}\u{1161}\u{11BF}",
        nfkc: "\u{C55C}",
        nfkd: "\u{110B}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C55D}",
        nfc: "\u{C55D}",
        nfd: "\u{110B}\u{1161}\u{11C0}",
        nfkc: "\u{C55D}",
        nfkd: "\u{110B}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C55E}",
        nfc: "\u{C55E}",
        nfd: "\u{110B}\u{1161}\u{11C1}",
        nfkc: "\u{C55E}",
        nfkd: "\u{110B}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C55F}",
        nfc: "\u{C55F}",
        nfd: "\u{110B}\u{1161}\u{11C2}",
        nfkc: "\u{C55F}",
        nfkd: "\u{110B}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C560}",
        nfc: "\u{C560}",
        nfd: "\u{110B}\u{1162}",
        nfkc: "\u{C560}",
        nfkd: "\u{110B}\u{1162}",
    },
    NormalizationTest {
        source: "\u{C561}",
        nfc: "\u{C561}",
        nfd: "\u{110B}\u{1162}\u{11A8}",
        nfkc: "\u{C561}",
        nfkd: "\u{110B}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C562}",
        nfc: "\u{C562}",
        nfd: "\u{110B}\u{1162}\u{11A9}",
        nfkc: "\u{C562}",
        nfkd: "\u{110B}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C563}",
        nfc: "\u{C563}",
        nfd: "\u{110B}\u{1162}\u{11AA}",
        nfkc: "\u{C563}",
        nfkd: "\u{110B}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C564}",
        nfc: "\u{C564}",
        nfd: "\u{110B}\u{1162}\u{11AB}",
        nfkc: "\u{C564}",
        nfkd: "\u{110B}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C565}",
        nfc: "\u{C565}",
        nfd: "\u{110B}\u{1162}\u{11AC}",
        nfkc: "\u{C565}",
        nfkd: "\u{110B}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C566}",
        nfc: "\u{C566}",
        nfd: "\u{110B}\u{1162}\u{11AD}",
        nfkc: "\u{C566}",
        nfkd: "\u{110B}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C567}",
        nfc: "\u{C567}",
        nfd: "\u{110B}\u{1162}\u{11AE}",
        nfkc: "\u{C567}",
        nfkd: "\u{110B}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C568}",
        nfc: "\u{C568}",
        nfd: "\u{110B}\u{1162}\u{11AF}",
        nfkc: "\u{C568}",
        nfkd: "\u{110B}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C569}",
        nfc: "\u{C569}",
        nfd: "\u{110B}\u{1162}\u{11B0}",
        nfkc: "\u{C569}",
        nfkd: "\u{110B}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C56A}",
        nfc: "\u{C56A}",
        nfd: "\u{110B}\u{1162}\u{11B1}",
        nfkc: "\u{C56A}",
        nfkd: "\u{110B}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C56B}",
        nfc: "\u{C56B}",
        nfd: "\u{110B}\u{1162}\u{11B2}",
        nfkc: "\u{C56B}",
        nfkd: "\u{110B}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C56C}",
        nfc: "\u{C56C}",
        nfd: "\u{110B}\u{1162}\u{11B3}",
        nfkc: "\u{C56C}",
        nfkd: "\u{110B}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C56D}",
        nfc: "\u{C56D}",
        nfd: "\u{110B}\u{1162}\u{11B4}",
        nfkc: "\u{C56D}",
        nfkd: "\u{110B}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C56E}",
        nfc: "\u{C56E}",
        nfd: "\u{110B}\u{1162}\u{11B5}",
        nfkc: "\u{C56E}",
        nfkd: "\u{110B}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C56F}",
        nfc: "\u{C56F}",
        nfd: "\u{110B}\u{1162}\u{11B6}",
        nfkc: "\u{C56F}",
        nfkd: "\u{110B}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C570}",
        nfc: "\u{C570}",
        nfd: "\u{110B}\u{1162}\u{11B7}",
        nfkc: "\u{C570}",
        nfkd: "\u{110B}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C571}",
        nfc: "\u{C571}",
        nfd: "\u{110B}\u{1162}\u{11B8}",
        nfkc: "\u{C571}",
        nfkd: "\u{110B}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C572}",
        nfc: "\u{C572}",
        nfd: "\u{110B}\u{1162}\u{11B9}",
        nfkc: "\u{C572}",
        nfkd: "\u{110B}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C573}",
        nfc: "\u{C573}",
        nfd: "\u{110B}\u{1162}\u{11BA}",
        nfkc: "\u{C573}",
        nfkd: "\u{110B}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C574}",
        nfc: "\u{C574}",
        nfd: "\u{110B}\u{1162}\u{11BB}",
        nfkc: "\u{C574}",
        nfkd: "\u{110B}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C575}",
        nfc: "\u{C575}",
        nfd: "\u{110B}\u{1162}\u{11BC}",
        nfkc: "\u{C575}",
        nfkd: "\u{110B}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C576}",
        nfc: "\u{C576}",
        nfd: "\u{110B}\u{1162}\u{11BD}",
        nfkc: "\u{C576}",
        nfkd: "\u{110B}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C577}",
        nfc: "\u{C577}",
        nfd: "\u{110B}\u{1162}\u{11BE}",
        nfkc: "\u{C577}",
        nfkd: "\u{110B}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C578}",
        nfc: "\u{C578}",
        nfd: "\u{110B}\u{1162}\u{11BF}",
        nfkc: "\u{C578}",
        nfkd: "\u{110B}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C579}",
        nfc: "\u{C579}",
        nfd: "\u{110B}\u{1162}\u{11C0}",
        nfkc: "\u{C579}",
        nfkd: "\u{110B}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C57A}",
        nfc: "\u{C57A}",
        nfd: "\u{110B}\u{1162}\u{11C1}",
        nfkc: "\u{C57A}",
        nfkd: "\u{110B}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C57B}",
        nfc: "\u{C57B}",
        nfd: "\u{110B}\u{1162}\u{11C2}",
        nfkc: "\u{C57B}",
        nfkd: "\u{110B}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C57C}",
        nfc: "\u{C57C}",
        nfd: "\u{110B}\u{1163}",
        nfkc: "\u{C57C}",
        nfkd: "\u{110B}\u{1163}",
    },
    NormalizationTest {
        source: "\u{C57D}",
        nfc: "\u{C57D}",
        nfd: "\u{110B}\u{1163}\u{11A8}",
        nfkc: "\u{C57D}",
        nfkd: "\u{110B}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C57E}",
        nfc: "\u{C57E}",
        nfd: "\u{110B}\u{1163}\u{11A9}",
        nfkc: "\u{C57E}",
        nfkd: "\u{110B}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C57F}",
        nfc: "\u{C57F}",
        nfd: "\u{110B}\u{1163}\u{11AA}",
        nfkc: "\u{C57F}",
        nfkd: "\u{110B}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C580}",
        nfc: "\u{C580}",
        nfd: "\u{110B}\u{1163}\u{11AB}",
        nfkc: "\u{C580}",
        nfkd: "\u{110B}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C581}",
        nfc: "\u{C581}",
        nfd: "\u{110B}\u{1163}\u{11AC}",
        nfkc: "\u{C581}",
        nfkd: "\u{110B}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C582}",
        nfc: "\u{C582}",
        nfd: "\u{110B}\u{1163}\u{11AD}",
        nfkc: "\u{C582}",
        nfkd: "\u{110B}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C583}",
        nfc: "\u{C583}",
        nfd: "\u{110B}\u{1163}\u{11AE}",
        nfkc: "\u{C583}",
        nfkd: "\u{110B}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C584}",
        nfc: "\u{C584}",
        nfd: "\u{110B}\u{1163}\u{11AF}",
        nfkc: "\u{C584}",
        nfkd: "\u{110B}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C585}",
        nfc: "\u{C585}",
        nfd: "\u{110B}\u{1163}\u{11B0}",
        nfkc: "\u{C585}",
        nfkd: "\u{110B}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C586}",
        nfc: "\u{C586}",
        nfd: "\u{110B}\u{1163}\u{11B1}",
        nfkc: "\u{C586}",
        nfkd: "\u{110B}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C587}",
        nfc: "\u{C587}",
        nfd: "\u{110B}\u{1163}\u{11B2}",
        nfkc: "\u{C587}",
        nfkd: "\u{110B}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C588}",
        nfc: "\u{C588}",
        nfd: "\u{110B}\u{1163}\u{11B3}",
        nfkc: "\u{C588}",
        nfkd: "\u{110B}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C589}",
        nfc: "\u{C589}",
        nfd: "\u{110B}\u{1163}\u{11B4}",
        nfkc: "\u{C589}",
        nfkd: "\u{110B}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C58A}",
        nfc: "\u{C58A}",
        nfd: "\u{110B}\u{1163}\u{11B5}",
        nfkc: "\u{C58A}",
        nfkd: "\u{110B}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C58B}",
        nfc: "\u{C58B}",
        nfd: "\u{110B}\u{1163}\u{11B6}",
        nfkc: "\u{C58B}",
        nfkd: "\u{110B}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C58C}",
        nfc: "\u{C58C}",
        nfd: "\u{110B}\u{1163}\u{11B7}",
        nfkc: "\u{C58C}",
        nfkd: "\u{110B}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C58D}",
        nfc: "\u{C58D}",
        nfd: "\u{110B}\u{1163}\u{11B8}",
        nfkc: "\u{C58D}",
        nfkd: "\u{110B}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C58E}",
        nfc: "\u{C58E}",
        nfd: "\u{110B}\u{1163}\u{11B9}",
        nfkc: "\u{C58E}",
        nfkd: "\u{110B}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C58F}",
        nfc: "\u{C58F}",
        nfd: "\u{110B}\u{1163}\u{11BA}",
        nfkc: "\u{C58F}",
        nfkd: "\u{110B}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C590}",
        nfc: "\u{C590}",
        nfd: "\u{110B}\u{1163}\u{11BB}",
        nfkc: "\u{C590}",
        nfkd: "\u{110B}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C591}",
        nfc: "\u{C591}",
        nfd: "\u{110B}\u{1163}\u{11BC}",
        nfkc: "\u{C591}",
        nfkd: "\u{110B}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C592}",
        nfc: "\u{C592}",
        nfd: "\u{110B}\u{1163}\u{11BD}",
        nfkc: "\u{C592}",
        nfkd: "\u{110B}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C593}",
        nfc: "\u{C593}",
        nfd: "\u{110B}\u{1163}\u{11BE}",
        nfkc: "\u{C593}",
        nfkd: "\u{110B}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C594}",
        nfc: "\u{C594}",
        nfd: "\u{110B}\u{1163}\u{11BF}",
        nfkc: "\u{C594}",
        nfkd: "\u{110B}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C595}",
        nfc: "\u{C595}",
        nfd: "\u{110B}\u{1163}\u{11C0}",
        nfkc: "\u{C595}",
        nfkd: "\u{110B}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C596}",
        nfc: "\u{C596}",
        nfd: "\u{110B}\u{1163}\u{11C1}",
        nfkc: "\u{C596}",
        nfkd: "\u{110B}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C597}",
        nfc: "\u{C597}",
        nfd: "\u{110B}\u{1163}\u{11C2}",
        nfkc: "\u{C597}",
        nfkd: "\u{110B}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C598}",
        nfc: "\u{C598}",
        nfd: "\u{110B}\u{1164}",
        nfkc: "\u{C598}",
        nfkd: "\u{110B}\u{1164}",
    },
    NormalizationTest {
        source: "\u{C599}",
        nfc: "\u{C599}",
        nfd: "\u{110B}\u{1164}\u{11A8}",
        nfkc: "\u{C599}",
        nfkd: "\u{110B}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C59A}",
        nfc: "\u{C59A}",
        nfd: "\u{110B}\u{1164}\u{11A9}",
        nfkc: "\u{C59A}",
        nfkd: "\u{110B}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C59B}",
        nfc: "\u{C59B}",
        nfd: "\u{110B}\u{1164}\u{11AA}",
        nfkc: "\u{C59B}",
        nfkd: "\u{110B}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C59C}",
        nfc: "\u{C59C}",
        nfd: "\u{110B}\u{1164}\u{11AB}",
        nfkc: "\u{C59C}",
        nfkd: "\u{110B}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C59D}",
        nfc: "\u{C59D}",
        nfd: "\u{110B}\u{1164}\u{11AC}",
        nfkc: "\u{C59D}",
        nfkd: "\u{110B}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C59E}",
        nfc: "\u{C59E}",
        nfd: "\u{110B}\u{1164}\u{11AD}",
        nfkc: "\u{C59E}",
        nfkd: "\u{110B}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C59F}",
        nfc: "\u{C59F}",
        nfd: "\u{110B}\u{1164}\u{11AE}",
        nfkc: "\u{C59F}",
        nfkd: "\u{110B}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C5A0}",
        nfc: "\u{C5A0}",
        nfd: "\u{110B}\u{1164}\u{11AF}",
        nfkc: "\u{C5A0}",
        nfkd: "\u{110B}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C5A1}",
        nfc: "\u{C5A1}",
        nfd: "\u{110B}\u{1164}\u{11B0}",
        nfkc: "\u{C5A1}",
        nfkd: "\u{110B}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C5A2}",
        nfc: "\u{C5A2}",
        nfd: "\u{110B}\u{1164}\u{11B1}",
        nfkc: "\u{C5A2}",
        nfkd: "\u{110B}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C5A3}",
        nfc: "\u{C5A3}",
        nfd: "\u{110B}\u{1164}\u{11B2}",
        nfkc: "\u{C5A3}",
        nfkd: "\u{110B}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C5A4}",
        nfc: "\u{C5A4}",
        nfd: "\u{110B}\u{1164}\u{11B3}",
        nfkc: "\u{C5A4}",
        nfkd: "\u{110B}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C5A5}",
        nfc: "\u{C5A5}",
        nfd: "\u{110B}\u{1164}\u{11B4}",
        nfkc: "\u{C5A5}",
        nfkd: "\u{110B}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C5A6}",
        nfc: "\u{C5A6}",
        nfd: "\u{110B}\u{1164}\u{11B5}",
        nfkc: "\u{C5A6}",
        nfkd: "\u{110B}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C5A7}",
        nfc: "\u{C5A7}",
        nfd: "\u{110B}\u{1164}\u{11B6}",
        nfkc: "\u{C5A7}",
        nfkd: "\u{110B}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C5A8}",
        nfc: "\u{C5A8}",
        nfd: "\u{110B}\u{1164}\u{11B7}",
        nfkc: "\u{C5A8}",
        nfkd: "\u{110B}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C5A9}",
        nfc: "\u{C5A9}",
        nfd: "\u{110B}\u{1164}\u{11B8}",
        nfkc: "\u{C5A9}",
        nfkd: "\u{110B}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C5AA}",
        nfc: "\u{C5AA}",
        nfd: "\u{110B}\u{1164}\u{11B9}",
        nfkc: "\u{C5AA}",
        nfkd: "\u{110B}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C5AB}",
        nfc: "\u{C5AB}",
        nfd: "\u{110B}\u{1164}\u{11BA}",
        nfkc: "\u{C5AB}",
        nfkd: "\u{110B}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C5AC}",
        nfc: "\u{C5AC}",
        nfd: "\u{110B}\u{1164}\u{11BB}",
        nfkc: "\u{C5AC}",
        nfkd: "\u{110B}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C5AD}",
        nfc: "\u{C5AD}",
        nfd: "\u{110B}\u{1164}\u{11BC}",
        nfkc: "\u{C5AD}",
        nfkd: "\u{110B}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C5AE}",
        nfc: "\u{C5AE}",
        nfd: "\u{110B}\u{1164}\u{11BD}",
        nfkc: "\u{C5AE}",
        nfkd: "\u{110B}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C5AF}",
        nfc: "\u{C5AF}",
        nfd: "\u{110B}\u{1164}\u{11BE}",
        nfkc: "\u{C5AF}",
        nfkd: "\u{110B}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C5B0}",
        nfc: "\u{C5B0}",
        nfd: "\u{110B}\u{1164}\u{11BF}",
        nfkc: "\u{C5B0}",
        nfkd: "\u{110B}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C5B1}",
        nfc: "\u{C5B1}",
        nfd: "\u{110B}\u{1164}\u{11C0}",
        nfkc: "\u{C5B1}",
        nfkd: "\u{110B}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C5B2}",
        nfc: "\u{C5B2}",
        nfd: "\u{110B}\u{1164}\u{11C1}",
        nfkc: "\u{C5B2}",
        nfkd: "\u{110B}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C5B3}",
        nfc: "\u{C5B3}",
        nfd: "\u{110B}\u{1164}\u{11C2}",
        nfkc: "\u{C5B3}",
        nfkd: "\u{110B}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C5B4}",
        nfc: "\u{C5B4}",
        nfd: "\u{110B}\u{1165}",
        nfkc: "\u{C5B4}",
        nfkd: "\u{110B}\u{1165}",
    },
    NormalizationTest {
        source: "\u{C5B5}",
        nfc: "\u{C5B5}",
        nfd: "\u{110B}\u{1165}\u{11A8}",
        nfkc: "\u{C5B5}",
        nfkd: "\u{110B}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C5B6}",
        nfc: "\u{C5B6}",
        nfd: "\u{110B}\u{1165}\u{11A9}",
        nfkc: "\u{C5B6}",
        nfkd: "\u{110B}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C5B7}",
        nfc: "\u{C5B7}",
        nfd: "\u{110B}\u{1165}\u{11AA}",
        nfkc: "\u{C5B7}",
        nfkd: "\u{110B}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C5B8}",
        nfc: "\u{C5B8}",
        nfd: "\u{110B}\u{1165}\u{11AB}",
        nfkc: "\u{C5B8}",
        nfkd: "\u{110B}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C5B9}",
        nfc: "\u{C5B9}",
        nfd: "\u{110B}\u{1165}\u{11AC}",
        nfkc: "\u{C5B9}",
        nfkd: "\u{110B}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C5BA}",
        nfc: "\u{C5BA}",
        nfd: "\u{110B}\u{1165}\u{11AD}",
        nfkc: "\u{C5BA}",
        nfkd: "\u{110B}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C5BB}",
        nfc: "\u{C5BB}",
        nfd: "\u{110B}\u{1165}\u{11AE}",
        nfkc: "\u{C5BB}",
        nfkd: "\u{110B}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C5BC}",
        nfc: "\u{C5BC}",
        nfd: "\u{110B}\u{1165}\u{11AF}",
        nfkc: "\u{C5BC}",
        nfkd: "\u{110B}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C5BD}",
        nfc: "\u{C5BD}",
        nfd: "\u{110B}\u{1165}\u{11B0}",
        nfkc: "\u{C5BD}",
        nfkd: "\u{110B}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C5BE}",
        nfc: "\u{C5BE}",
        nfd: "\u{110B}\u{1165}\u{11B1}",
        nfkc: "\u{C5BE}",
        nfkd: "\u{110B}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C5BF}",
        nfc: "\u{C5BF}",
        nfd: "\u{110B}\u{1165}\u{11B2}",
        nfkc: "\u{C5BF}",
        nfkd: "\u{110B}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C5C0}",
        nfc: "\u{C5C0}",
        nfd: "\u{110B}\u{1165}\u{11B3}",
        nfkc: "\u{C5C0}",
        nfkd: "\u{110B}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C5C1}",
        nfc: "\u{C5C1}",
        nfd: "\u{110B}\u{1165}\u{11B4}",
        nfkc: "\u{C5C1}",
        nfkd: "\u{110B}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C5C2}",
        nfc: "\u{C5C2}",
        nfd: "\u{110B}\u{1165}\u{11B5}",
        nfkc: "\u{C5C2}",
        nfkd: "\u{110B}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C5C3}",
        nfc: "\u{C5C3}",
        nfd: "\u{110B}\u{1165}\u{11B6}",
        nfkc: "\u{C5C3}",
        nfkd: "\u{110B}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C5C4}",
        nfc: "\u{C5C4}",
        nfd: "\u{110B}\u{1165}\u{11B7}",
        nfkc: "\u{C5C4}",
        nfkd: "\u{110B}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C5C5}",
        nfc: "\u{C5C5}",
        nfd: "\u{110B}\u{1165}\u{11B8}",
        nfkc: "\u{C5C5}",
        nfkd: "\u{110B}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C5C6}",
        nfc: "\u{C5C6}",
        nfd: "\u{110B}\u{1165}\u{11B9}",
        nfkc: "\u{C5C6}",
        nfkd: "\u{110B}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C5C7}",
        nfc: "\u{C5C7}",
        nfd: "\u{110B}\u{1165}\u{11BA}",
        nfkc: "\u{C5C7}",
        nfkd: "\u{110B}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C5C8}",
        nfc: "\u{C5C8}",
        nfd: "\u{110B}\u{1165}\u{11BB}",
        nfkc: "\u{C5C8}",
        nfkd: "\u{110B}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C5C9}",
        nfc: "\u{C5C9}",
        nfd: "\u{110B}\u{1165}\u{11BC}",
        nfkc: "\u{C5C9}",
        nfkd: "\u{110B}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C5CA}",
        nfc: "\u{C5CA}",
        nfd: "\u{110B}\u{1165}\u{11BD}",
        nfkc: "\u{C5CA}",
        nfkd: "\u{110B}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C5CB}",
        nfc: "\u{C5CB}",
        nfd: "\u{110B}\u{1165}\u{11BE}",
        nfkc: "\u{C5CB}",
        nfkd: "\u{110B}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C5CC}",
        nfc: "\u{C5CC}",
        nfd: "\u{110B}\u{1165}\u{11BF}",
        nfkc: "\u{C5CC}",
        nfkd: "\u{110B}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C5CD}",
        nfc: "\u{C5CD}",
        nfd: "\u{110B}\u{1165}\u{11C0}",
        nfkc: "\u{C5CD}",
        nfkd: "\u{110B}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C5CE}",
        nfc: "\u{C5CE}",
        nfd: "\u{110B}\u{1165}\u{11C1}",
        nfkc: "\u{C5CE}",
        nfkd: "\u{110B}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C5CF}",
        nfc: "\u{C5CF}",
        nfd: "\u{110B}\u{1165}\u{11C2}",
        nfkc: "\u{C5CF}",
        nfkd: "\u{110B}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C5D0}",
        nfc: "\u{C5D0}",
        nfd: "\u{110B}\u{1166}",
        nfkc: "\u{C5D0}",
        nfkd: "\u{110B}\u{1166}",
    },
    NormalizationTest {
        source: "\u{C5D1}",
        nfc: "\u{C5D1}",
        nfd: "\u{110B}\u{1166}\u{11A8}",
        nfkc: "\u{C5D1}",
        nfkd: "\u{110B}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C5D2}",
        nfc: "\u{C5D2}",
        nfd: "\u{110B}\u{1166}\u{11A9}",
        nfkc: "\u{C5D2}",
        nfkd: "\u{110B}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C5D3}",
        nfc: "\u{C5D3}",
        nfd: "\u{110B}\u{1166}\u{11AA}",
        nfkc: "\u{C5D3}",
        nfkd: "\u{110B}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C5D4}",
        nfc: "\u{C5D4}",
        nfd: "\u{110B}\u{1166}\u{11AB}",
        nfkc: "\u{C5D4}",
        nfkd: "\u{110B}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C5D5}",
        nfc: "\u{C5D5}",
        nfd: "\u{110B}\u{1166}\u{11AC}",
        nfkc: "\u{C5D5}",
        nfkd: "\u{110B}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C5D6}",
        nfc: "\u{C5D6}",
        nfd: "\u{110B}\u{1166}\u{11AD}",
        nfkc: "\u{C5D6}",
        nfkd: "\u{110B}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C5D7}",
        nfc: "\u{C5D7}",
        nfd: "\u{110B}\u{1166}\u{11AE}",
        nfkc: "\u{C5D7}",
        nfkd: "\u{110B}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C5D8}",
        nfc: "\u{C5D8}",
        nfd: "\u{110B}\u{1166}\u{11AF}",
        nfkc: "\u{C5D8}",
        nfkd: "\u{110B}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C5D9}",
        nfc: "\u{C5D9}",
        nfd: "\u{110B}\u{1166}\u{11B0}",
        nfkc: "\u{C5D9}",
        nfkd: "\u{110B}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C5DA}",
        nfc: "\u{C5DA}",
        nfd: "\u{110B}\u{1166}\u{11B1}",
        nfkc: "\u{C5DA}",
        nfkd: "\u{110B}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C5DB}",
        nfc: "\u{C5DB}",
        nfd: "\u{110B}\u{1166}\u{11B2}",
        nfkc: "\u{C5DB}",
        nfkd: "\u{110B}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C5DC}",
        nfc: "\u{C5DC}",
        nfd: "\u{110B}\u{1166}\u{11B3}",
        nfkc: "\u{C5DC}",
        nfkd: "\u{110B}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C5DD}",
        nfc: "\u{C5DD}",
        nfd: "\u{110B}\u{1166}\u{11B4}",
        nfkc: "\u{C5DD}",
        nfkd: "\u{110B}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C5DE}",
        nfc: "\u{C5DE}",
        nfd: "\u{110B}\u{1166}\u{11B5}",
        nfkc: "\u{C5DE}",
        nfkd: "\u{110B}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C5DF}",
        nfc: "\u{C5DF}",
        nfd: "\u{110B}\u{1166}\u{11B6}",
        nfkc: "\u{C5DF}",
        nfkd: "\u{110B}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C5E0}",
        nfc: "\u{C5E0}",
        nfd: "\u{110B}\u{1166}\u{11B7}",
        nfkc: "\u{C5E0}",
        nfkd: "\u{110B}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C5E1}",
        nfc: "\u{C5E1}",
        nfd: "\u{110B}\u{1166}\u{11B8}",
        nfkc: "\u{C5E1}",
        nfkd: "\u{110B}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C5E2}",
        nfc: "\u{C5E2}",
        nfd: "\u{110B}\u{1166}\u{11B9}",
        nfkc: "\u{C5E2}",
        nfkd: "\u{110B}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C5E3}",
        nfc: "\u{C5E3}",
        nfd: "\u{110B}\u{1166}\u{11BA}",
        nfkc: "\u{C5E3}",
        nfkd: "\u{110B}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C5E4}",
        nfc: "\u{C5E4}",
        nfd: "\u{110B}\u{1166}\u{11BB}",
        nfkc: "\u{C5E4}",
        nfkd: "\u{110B}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C5E5}",
        nfc: "\u{C5E5}",
        nfd: "\u{110B}\u{1166}\u{11BC}",
        nfkc: "\u{C5E5}",
        nfkd: "\u{110B}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C5E6}",
        nfc: "\u{C5E6}",
        nfd: "\u{110B}\u{1166}\u{11BD}",
        nfkc: "\u{C5E6}",
        nfkd: "\u{110B}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C5E7}",
        nfc: "\u{C5E7}",
        nfd: "\u{110B}\u{1166}\u{11BE}",
        nfkc: "\u{C5E7}",
        nfkd: "\u{110B}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C5E8}",
        nfc: "\u{C5E8}",
        nfd: "\u{110B}\u{1166}\u{11BF}",
        nfkc: "\u{C5E8}",
        nfkd: "\u{110B}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C5E9}",
        nfc: "\u{C5E9}",
        nfd: "\u{110B}\u{1166}\u{11C0}",
        nfkc: "\u{C5E9}",
        nfkd: "\u{110B}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C5EA}",
        nfc: "\u{C5EA}",
        nfd: "\u{110B}\u{1166}\u{11C1}",
        nfkc: "\u{C5EA}",
        nfkd: "\u{110B}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C5EB}",
        nfc: "\u{C5EB}",
        nfd: "\u{110B}\u{1166}\u{11C2}",
        nfkc: "\u{C5EB}",
        nfkd: "\u{110B}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C5EC}",
        nfc: "\u{C5EC}",
        nfd: "\u{110B}\u{1167}",
        nfkc: "\u{C5EC}",
        nfkd: "\u{110B}\u{1167}",
    },
    NormalizationTest {
        source: "\u{C5ED}",
        nfc: "\u{C5ED}",
        nfd: "\u{110B}\u{1167}\u{11A8}",
        nfkc: "\u{C5ED}",
        nfkd: "\u{110B}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C5EE}",
        nfc: "\u{C5EE}",
        nfd: "\u{110B}\u{1167}\u{11A9}",
        nfkc: "\u{C5EE}",
        nfkd: "\u{110B}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C5EF}",
        nfc: "\u{C5EF}",
        nfd: "\u{110B}\u{1167}\u{11AA}",
        nfkc: "\u{C5EF}",
        nfkd: "\u{110B}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C5F0}",
        nfc: "\u{C5F0}",
        nfd: "\u{110B}\u{1167}\u{11AB}",
        nfkc: "\u{C5F0}",
        nfkd: "\u{110B}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C5F1}",
        nfc: "\u{C5F1}",
        nfd: "\u{110B}\u{1167}\u{11AC}",
        nfkc: "\u{C5F1}",
        nfkd: "\u{110B}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C5F2}",
        nfc: "\u{C5F2}",
        nfd: "\u{110B}\u{1167}\u{11AD}",
        nfkc: "\u{C5F2}",
        nfkd: "\u{110B}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C5F3}",
        nfc: "\u{C5F3}",
        nfd: "\u{110B}\u{1167}\u{11AE}",
        nfkc: "\u{C5F3}",
        nfkd: "\u{110B}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C5F4}",
        nfc: "\u{C5F4}",
        nfd: "\u{110B}\u{1167}\u{11AF}",
        nfkc: "\u{C5F4}",
        nfkd: "\u{110B}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C5F5}",
        nfc: "\u{C5F5}",
        nfd: "\u{110B}\u{1167}\u{11B0}",
        nfkc: "\u{C5F5}",
        nfkd: "\u{110B}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C5F6}",
        nfc: "\u{C5F6}",
        nfd: "\u{110B}\u{1167}\u{11B1}",
        nfkc: "\u{C5F6}",
        nfkd: "\u{110B}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C5F7}",
        nfc: "\u{C5F7}",
        nfd: "\u{110B}\u{1167}\u{11B2}",
        nfkc: "\u{C5F7}",
        nfkd: "\u{110B}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C5F8}",
        nfc: "\u{C5F8}",
        nfd: "\u{110B}\u{1167}\u{11B3}",
        nfkc: "\u{C5F8}",
        nfkd: "\u{110B}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C5F9}",
        nfc: "\u{C5F9}",
        nfd: "\u{110B}\u{1167}\u{11B4}",
        nfkc: "\u{C5F9}",
        nfkd: "\u{110B}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C5FA}",
        nfc: "\u{C5FA}",
        nfd: "\u{110B}\u{1167}\u{11B5}",
        nfkc: "\u{C5FA}",
        nfkd: "\u{110B}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C5FB}",
        nfc: "\u{C5FB}",
        nfd: "\u{110B}\u{1167}\u{11B6}",
        nfkc: "\u{C5FB}",
        nfkd: "\u{110B}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C5FC}",
        nfc: "\u{C5FC}",
        nfd: "\u{110B}\u{1167}\u{11B7}",
        nfkc: "\u{C5FC}",
        nfkd: "\u{110B}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C5FD}",
        nfc: "\u{C5FD}",
        nfd: "\u{110B}\u{1167}\u{11B8}",
        nfkc: "\u{C5FD}",
        nfkd: "\u{110B}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C5FE}",
        nfc: "\u{C5FE}",
        nfd: "\u{110B}\u{1167}\u{11B9}",
        nfkc: "\u{C5FE}",
        nfkd: "\u{110B}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C5FF}",
        nfc: "\u{C5FF}",
        nfd: "\u{110B}\u{1167}\u{11BA}",
        nfkc: "\u{C5FF}",
        nfkd: "\u{110B}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C600}",
        nfc: "\u{C600}",
        nfd: "\u{110B}\u{1167}\u{11BB}",
        nfkc: "\u{C600}",
        nfkd: "\u{110B}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C601}",
        nfc: "\u{C601}",
        nfd: "\u{110B}\u{1167}\u{11BC}",
        nfkc: "\u{C601}",
        nfkd: "\u{110B}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C602}",
        nfc: "\u{C602}",
        nfd: "\u{110B}\u{1167}\u{11BD}",
        nfkc: "\u{C602}",
        nfkd: "\u{110B}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C603}",
        nfc: "\u{C603}",
        nfd: "\u{110B}\u{1167}\u{11BE}",
        nfkc: "\u{C603}",
        nfkd: "\u{110B}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C604}",
        nfc: "\u{C604}",
        nfd: "\u{110B}\u{1167}\u{11BF}",
        nfkc: "\u{C604}",
        nfkd: "\u{110B}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C605}",
        nfc: "\u{C605}",
        nfd: "\u{110B}\u{1167}\u{11C0}",
        nfkc: "\u{C605}",
        nfkd: "\u{110B}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C606}",
        nfc: "\u{C606}",
        nfd: "\u{110B}\u{1167}\u{11C1}",
        nfkc: "\u{C606}",
        nfkd: "\u{110B}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C607}",
        nfc: "\u{C607}",
        nfd: "\u{110B}\u{1167}\u{11C2}",
        nfkc: "\u{C607}",
        nfkd: "\u{110B}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C608}",
        nfc: "\u{C608}",
        nfd: "\u{110B}\u{1168}",
        nfkc: "\u{C608}",
        nfkd: "\u{110B}\u{1168}",
    },
    NormalizationTest {
        source: "\u{C609}",
        nfc: "\u{C609}",
        nfd: "\u{110B}\u{1168}\u{11A8}",
        nfkc: "\u{C609}",
        nfkd: "\u{110B}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C60A}",
        nfc: "\u{C60A}",
        nfd: "\u{110B}\u{1168}\u{11A9}",
        nfkc: "\u{C60A}",
        nfkd: "\u{110B}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C60B}",
        nfc: "\u{C60B}",
        nfd: "\u{110B}\u{1168}\u{11AA}",
        nfkc: "\u{C60B}",
        nfkd: "\u{110B}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C60C}",
        nfc: "\u{C60C}",
        nfd: "\u{110B}\u{1168}\u{11AB}",
        nfkc: "\u{C60C}",
        nfkd: "\u{110B}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C60D}",
        nfc: "\u{C60D}",
        nfd: "\u{110B}\u{1168}\u{11AC}",
        nfkc: "\u{C60D}",
        nfkd: "\u{110B}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C60E}",
        nfc: "\u{C60E}",
        nfd: "\u{110B}\u{1168}\u{11AD}",
        nfkc: "\u{C60E}",
        nfkd: "\u{110B}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C60F}",
        nfc: "\u{C60F}",
        nfd: "\u{110B}\u{1168}\u{11AE}",
        nfkc: "\u{C60F}",
        nfkd: "\u{110B}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C610}",
        nfc: "\u{C610}",
        nfd: "\u{110B}\u{1168}\u{11AF}",
        nfkc: "\u{C610}",
        nfkd: "\u{110B}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C611}",
        nfc: "\u{C611}",
        nfd: "\u{110B}\u{1168}\u{11B0}",
        nfkc: "\u{C611}",
        nfkd: "\u{110B}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C612}",
        nfc: "\u{C612}",
        nfd: "\u{110B}\u{1168}\u{11B1}",
        nfkc: "\u{C612}",
        nfkd: "\u{110B}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C613}",
        nfc: "\u{C613}",
        nfd: "\u{110B}\u{1168}\u{11B2}",
        nfkc: "\u{C613}",
        nfkd: "\u{110B}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C614}",
        nfc: "\u{C614}",
        nfd: "\u{110B}\u{1168}\u{11B3}",
        nfkc: "\u{C614}",
        nfkd: "\u{110B}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C615}",
        nfc: "\u{C615}",
        nfd: "\u{110B}\u{1168}\u{11B4}",
        nfkc: "\u{C615}",
        nfkd: "\u{110B}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C616}",
        nfc: "\u{C616}",
        nfd: "\u{110B}\u{1168}\u{11B5}",
        nfkc: "\u{C616}",
        nfkd: "\u{110B}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C617}",
        nfc: "\u{C617}",
        nfd: "\u{110B}\u{1168}\u{11B6}",
        nfkc: "\u{C617}",
        nfkd: "\u{110B}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C618}",
        nfc: "\u{C618}",
        nfd: "\u{110B}\u{1168}\u{11B7}",
        nfkc: "\u{C618}",
        nfkd: "\u{110B}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C619}",
        nfc: "\u{C619}",
        nfd: "\u{110B}\u{1168}\u{11B8}",
        nfkc: "\u{C619}",
        nfkd: "\u{110B}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C61A}",
        nfc: "\u{C61A}",
        nfd: "\u{110B}\u{1168}\u{11B9}",
        nfkc: "\u{C61A}",
        nfkd: "\u{110B}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C61B}",
        nfc: "\u{C61B}",
        nfd: "\u{110B}\u{1168}\u{11BA}",
        nfkc: "\u{C61B}",
        nfkd: "\u{110B}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C61C}",
        nfc: "\u{C61C}",
        nfd: "\u{110B}\u{1168}\u{11BB}",
        nfkc: "\u{C61C}",
        nfkd: "\u{110B}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C61D}",
        nfc: "\u{C61D}",
        nfd: "\u{110B}\u{1168}\u{11BC}",
        nfkc: "\u{C61D}",
        nfkd: "\u{110B}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C61E}",
        nfc: "\u{C61E}",
        nfd: "\u{110B}\u{1168}\u{11BD}",
        nfkc: "\u{C61E}",
        nfkd: "\u{110B}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C61F}",
        nfc: "\u{C61F}",
        nfd: "\u{110B}\u{1168}\u{11BE}",
        nfkc: "\u{C61F}",
        nfkd: "\u{110B}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C620}",
        nfc: "\u{C620}",
        nfd: "\u{110B}\u{1168}\u{11BF}",
        nfkc: "\u{C620}",
        nfkd: "\u{110B}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C621}",
        nfc: "\u{C621}",
        nfd: "\u{110B}\u{1168}\u{11C0}",
        nfkc: "\u{C621}",
        nfkd: "\u{110B}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C622}",
        nfc: "\u{C622}",
        nfd: "\u{110B}\u{1168}\u{11C1}",
        nfkc: "\u{C622}",
        nfkd: "\u{110B}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C623}",
        nfc: "\u{C623}",
        nfd: "\u{110B}\u{1168}\u{11C2}",
        nfkc: "\u{C623}",
        nfkd: "\u{110B}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C624}",
        nfc: "\u{C624}",
        nfd: "\u{110B}\u{1169}",
        nfkc: "\u{C624}",
        nfkd: "\u{110B}\u{1169}",
    },
    NormalizationTest {
        source: "\u{C625}",
        nfc: "\u{C625}",
        nfd: "\u{110B}\u{1169}\u{11A8}",
        nfkc: "\u{C625}",
        nfkd: "\u{110B}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C626}",
        nfc: "\u{C626}",
        nfd: "\u{110B}\u{1169}\u{11A9}",
        nfkc: "\u{C626}",
        nfkd: "\u{110B}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C627}",
        nfc: "\u{C627}",
        nfd: "\u{110B}\u{1169}\u{11AA}",
        nfkc: "\u{C627}",
        nfkd: "\u{110B}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C628}",
        nfc: "\u{C628}",
        nfd: "\u{110B}\u{1169}\u{11AB}",
        nfkc: "\u{C628}",
        nfkd: "\u{110B}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C629}",
        nfc: "\u{C629}",
        nfd: "\u{110B}\u{1169}\u{11AC}",
        nfkc: "\u{C629}",
        nfkd: "\u{110B}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C62A}",
        nfc: "\u{C62A}",
        nfd: "\u{110B}\u{1169}\u{11AD}",
        nfkc: "\u{C62A}",
        nfkd: "\u{110B}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C62B}",
        nfc: "\u{C62B}",
        nfd: "\u{110B}\u{1169}\u{11AE}",
        nfkc: "\u{C62B}",
        nfkd: "\u{110B}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C62C}",
        nfc: "\u{C62C}",
        nfd: "\u{110B}\u{1169}\u{11AF}",
        nfkc: "\u{C62C}",
        nfkd: "\u{110B}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C62D}",
        nfc: "\u{C62D}",
        nfd: "\u{110B}\u{1169}\u{11B0}",
        nfkc: "\u{C62D}",
        nfkd: "\u{110B}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C62E}",
        nfc: "\u{C62E}",
        nfd: "\u{110B}\u{1169}\u{11B1}",
        nfkc: "\u{C62E}",
        nfkd: "\u{110B}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C62F}",
        nfc: "\u{C62F}",
        nfd: "\u{110B}\u{1169}\u{11B2}",
        nfkc: "\u{C62F}",
        nfkd: "\u{110B}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C630}",
        nfc: "\u{C630}",
        nfd: "\u{110B}\u{1169}\u{11B3}",
        nfkc: "\u{C630}",
        nfkd: "\u{110B}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C631}",
        nfc: "\u{C631}",
        nfd: "\u{110B}\u{1169}\u{11B4}",
        nfkc: "\u{C631}",
        nfkd: "\u{110B}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C632}",
        nfc: "\u{C632}",
        nfd: "\u{110B}\u{1169}\u{11B5}",
        nfkc: "\u{C632}",
        nfkd: "\u{110B}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C633}",
        nfc: "\u{C633}",
        nfd: "\u{110B}\u{1169}\u{11B6}",
        nfkc: "\u{C633}",
        nfkd: "\u{110B}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C634}",
        nfc: "\u{C634}",
        nfd: "\u{110B}\u{1169}\u{11B7}",
        nfkc: "\u{C634}",
        nfkd: "\u{110B}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C635}",
        nfc: "\u{C635}",
        nfd: "\u{110B}\u{1169}\u{11B8}",
        nfkc: "\u{C635}",
        nfkd: "\u{110B}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C636}",
        nfc: "\u{C636}",
        nfd: "\u{110B}\u{1169}\u{11B9}",
        nfkc: "\u{C636}",
        nfkd: "\u{110B}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C637}",
        nfc: "\u{C637}",
        nfd: "\u{110B}\u{1169}\u{11BA}",
        nfkc: "\u{C637}",
        nfkd: "\u{110B}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C638}",
        nfc: "\u{C638}",
        nfd: "\u{110B}\u{1169}\u{11BB}",
        nfkc: "\u{C638}",
        nfkd: "\u{110B}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C639}",
        nfc: "\u{C639}",
        nfd: "\u{110B}\u{1169}\u{11BC}",
        nfkc: "\u{C639}",
        nfkd: "\u{110B}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C63A}",
        nfc: "\u{C63A}",
        nfd: "\u{110B}\u{1169}\u{11BD}",
        nfkc: "\u{C63A}",
        nfkd: "\u{110B}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C63B}",
        nfc: "\u{C63B}",
        nfd: "\u{110B}\u{1169}\u{11BE}",
        nfkc: "\u{C63B}",
        nfkd: "\u{110B}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C63C}",
        nfc: "\u{C63C}",
        nfd: "\u{110B}\u{1169}\u{11BF}",
        nfkc: "\u{C63C}",
        nfkd: "\u{110B}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C63D}",
        nfc: "\u{C63D}",
        nfd: "\u{110B}\u{1169}\u{11C0}",
        nfkc: "\u{C63D}",
        nfkd: "\u{110B}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C63E}",
        nfc: "\u{C63E}",
        nfd: "\u{110B}\u{1169}\u{11C1}",
        nfkc: "\u{C63E}",
        nfkd: "\u{110B}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C63F}",
        nfc: "\u{C63F}",
        nfd: "\u{110B}\u{1169}\u{11C2}",
        nfkc: "\u{C63F}",
        nfkd: "\u{110B}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C640}",
        nfc: "\u{C640}",
        nfd: "\u{110B}\u{116A}",
        nfkc: "\u{C640}",
        nfkd: "\u{110B}\u{116A}",
    },
    NormalizationTest {
        source: "\u{C641}",
        nfc: "\u{C641}",
        nfd: "\u{110B}\u{116A}\u{11A8}",
        nfkc: "\u{C641}",
        nfkd: "\u{110B}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C642}",
        nfc: "\u{C642}",
        nfd: "\u{110B}\u{116A}\u{11A9}",
        nfkc: "\u{C642}",
        nfkd: "\u{110B}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C643}",
        nfc: "\u{C643}",
        nfd: "\u{110B}\u{116A}\u{11AA}",
        nfkc: "\u{C643}",
        nfkd: "\u{110B}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C644}",
        nfc: "\u{C644}",
        nfd: "\u{110B}\u{116A}\u{11AB}",
        nfkc: "\u{C644}",
        nfkd: "\u{110B}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C645}",
        nfc: "\u{C645}",
        nfd: "\u{110B}\u{116A}\u{11AC}",
        nfkc: "\u{C645}",
        nfkd: "\u{110B}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C646}",
        nfc: "\u{C646}",
        nfd: "\u{110B}\u{116A}\u{11AD}",
        nfkc: "\u{C646}",
        nfkd: "\u{110B}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C647}",
        nfc: "\u{C647}",
        nfd: "\u{110B}\u{116A}\u{11AE}",
        nfkc: "\u{C647}",
        nfkd: "\u{110B}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C648}",
        nfc: "\u{C648}",
        nfd: "\u{110B}\u{116A}\u{11AF}",
        nfkc: "\u{C648}",
        nfkd: "\u{110B}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C649}",
        nfc: "\u{C649}",
        nfd: "\u{110B}\u{116A}\u{11B0}",
        nfkc: "\u{C649}",
        nfkd: "\u{110B}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C64A}",
        nfc: "\u{C64A}",
        nfd: "\u{110B}\u{116A}\u{11B1}",
        nfkc: "\u{C64A}",
        nfkd: "\u{110B}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C64B}",
        nfc: "\u{C64B}",
        nfd: "\u{110B}\u{116A}\u{11B2}",
        nfkc: "\u{C64B}",
        nfkd: "\u{110B}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C64C}",
        nfc: "\u{C64C}",
        nfd: "\u{110B}\u{116A}\u{11B3}",
        nfkc: "\u{C64C}",
        nfkd: "\u{110B}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C64D}",
        nfc: "\u{C64D}",
        nfd: "\u{110B}\u{116A}\u{11B4}",
        nfkc: "\u{C64D}",
        nfkd: "\u{110B}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C64E}",
        nfc: "\u{C64E}",
        nfd: "\u{110B}\u{116A}\u{11B5}",
        nfkc: "\u{C64E}",
        nfkd: "\u{110B}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C64F}",
        nfc: "\u{C64F}",
        nfd: "\u{110B}\u{116A}\u{11B6}",
        nfkc: "\u{C64F}",
        nfkd: "\u{110B}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C650}",
        nfc: "\u{C650}",
        nfd: "\u{110B}\u{116A}\u{11B7}",
        nfkc: "\u{C650}",
        nfkd: "\u{110B}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C651}",
        nfc: "\u{C651}",
        nfd: "\u{110B}\u{116A}\u{11B8}",
        nfkc: "\u{C651}",
        nfkd: "\u{110B}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C652}",
        nfc: "\u{C652}",
        nfd: "\u{110B}\u{116A}\u{11B9}",
        nfkc: "\u{C652}",
        nfkd: "\u{110B}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C653}",
        nfc: "\u{C653}",
        nfd: "\u{110B}\u{116A}\u{11BA}",
        nfkc: "\u{C653}",
        nfkd: "\u{110B}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C654}",
        nfc: "\u{C654}",
        nfd: "\u{110B}\u{116A}\u{11BB}",
        nfkc: "\u{C654}",
        nfkd: "\u{110B}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C655}",
        nfc: "\u{C655}",
        nfd: "\u{110B}\u{116A}\u{11BC}",
        nfkc: "\u{C655}",
        nfkd: "\u{110B}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C656}",
        nfc: "\u{C656}",
        nfd: "\u{110B}\u{116A}\u{11BD}",
        nfkc: "\u{C656}",
        nfkd: "\u{110B}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C657}",
        nfc: "\u{C657}",
        nfd: "\u{110B}\u{116A}\u{11BE}",
        nfkc: "\u{C657}",
        nfkd: "\u{110B}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C658}",
        nfc: "\u{C658}",
        nfd: "\u{110B}\u{116A}\u{11BF}",
        nfkc: "\u{C658}",
        nfkd: "\u{110B}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C659}",
        nfc: "\u{C659}",
        nfd: "\u{110B}\u{116A}\u{11C0}",
        nfkc: "\u{C659}",
        nfkd: "\u{110B}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C65A}",
        nfc: "\u{C65A}",
        nfd: "\u{110B}\u{116A}\u{11C1}",
        nfkc: "\u{C65A}",
        nfkd: "\u{110B}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C65B}",
        nfc: "\u{C65B}",
        nfd: "\u{110B}\u{116A}\u{11C2}",
        nfkc: "\u{C65B}",
        nfkd: "\u{110B}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C65C}",
        nfc: "\u{C65C}",
        nfd: "\u{110B}\u{116B}",
        nfkc: "\u{C65C}",
        nfkd: "\u{110B}\u{116B}",
    },
    NormalizationTest {
        source: "\u{C65D}",
        nfc: "\u{C65D}",
        nfd: "\u{110B}\u{116B}\u{11A8}",
        nfkc: "\u{C65D}",
        nfkd: "\u{110B}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C65E}",
        nfc: "\u{C65E}",
        nfd: "\u{110B}\u{116B}\u{11A9}",
        nfkc: "\u{C65E}",
        nfkd: "\u{110B}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C65F}",
        nfc: "\u{C65F}",
        nfd: "\u{110B}\u{116B}\u{11AA}",
        nfkc: "\u{C65F}",
        nfkd: "\u{110B}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C660}",
        nfc: "\u{C660}",
        nfd: "\u{110B}\u{116B}\u{11AB}",
        nfkc: "\u{C660}",
        nfkd: "\u{110B}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C661}",
        nfc: "\u{C661}",
        nfd: "\u{110B}\u{116B}\u{11AC}",
        nfkc: "\u{C661}",
        nfkd: "\u{110B}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C662}",
        nfc: "\u{C662}",
        nfd: "\u{110B}\u{116B}\u{11AD}",
        nfkc: "\u{C662}",
        nfkd: "\u{110B}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C663}",
        nfc: "\u{C663}",
        nfd: "\u{110B}\u{116B}\u{11AE}",
        nfkc: "\u{C663}",
        nfkd: "\u{110B}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C664}",
        nfc: "\u{C664}",
        nfd: "\u{110B}\u{116B}\u{11AF}",
        nfkc: "\u{C664}",
        nfkd: "\u{110B}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C665}",
        nfc: "\u{C665}",
        nfd: "\u{110B}\u{116B}\u{11B0}",
        nfkc: "\u{C665}",
        nfkd: "\u{110B}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C666}",
        nfc: "\u{C666}",
        nfd: "\u{110B}\u{116B}\u{11B1}",
        nfkc: "\u{C666}",
        nfkd: "\u{110B}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C667}",
        nfc: "\u{C667}",
        nfd: "\u{110B}\u{116B}\u{11B2}",
        nfkc: "\u{C667}",
        nfkd: "\u{110B}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C668}",
        nfc: "\u{C668}",
        nfd: "\u{110B}\u{116B}\u{11B3}",
        nfkc: "\u{C668}",
        nfkd: "\u{110B}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C669}",
        nfc: "\u{C669}",
        nfd: "\u{110B}\u{116B}\u{11B4}",
        nfkc: "\u{C669}",
        nfkd: "\u{110B}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C66A}",
        nfc: "\u{C66A}",
        nfd: "\u{110B}\u{116B}\u{11B5}",
        nfkc: "\u{C66A}",
        nfkd: "\u{110B}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C66B}",
        nfc: "\u{C66B}",
        nfd: "\u{110B}\u{116B}\u{11B6}",
        nfkc: "\u{C66B}",
        nfkd: "\u{110B}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C66C}",
        nfc: "\u{C66C}",
        nfd: "\u{110B}\u{116B}\u{11B7}",
        nfkc: "\u{C66C}",
        nfkd: "\u{110B}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C66D}",
        nfc: "\u{C66D}",
        nfd: "\u{110B}\u{116B}\u{11B8}",
        nfkc: "\u{C66D}",
        nfkd: "\u{110B}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C66E}",
        nfc: "\u{C66E}",
        nfd: "\u{110B}\u{116B}\u{11B9}",
        nfkc: "\u{C66E}",
        nfkd: "\u{110B}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C66F}",
        nfc: "\u{C66F}",
        nfd: "\u{110B}\u{116B}\u{11BA}",
        nfkc: "\u{C66F}",
        nfkd: "\u{110B}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C670}",
        nfc: "\u{C670}",
        nfd: "\u{110B}\u{116B}\u{11BB}",
        nfkc: "\u{C670}",
        nfkd: "\u{110B}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C671}",
        nfc: "\u{C671}",
        nfd: "\u{110B}\u{116B}\u{11BC}",
        nfkc: "\u{C671}",
        nfkd: "\u{110B}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C672}",
        nfc: "\u{C672}",
        nfd: "\u{110B}\u{116B}\u{11BD}",
        nfkc: "\u{C672}",
        nfkd: "\u{110B}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C673}",
        nfc: "\u{C673}",
        nfd: "\u{110B}\u{116B}\u{11BE}",
        nfkc: "\u{C673}",
        nfkd: "\u{110B}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C674}",
        nfc: "\u{C674}",
        nfd: "\u{110B}\u{116B}\u{11BF}",
        nfkc: "\u{C674}",
        nfkd: "\u{110B}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C675}",
        nfc: "\u{C675}",
        nfd: "\u{110B}\u{116B}\u{11C0}",
        nfkc: "\u{C675}",
        nfkd: "\u{110B}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C676}",
        nfc: "\u{C676}",
        nfd: "\u{110B}\u{116B}\u{11C1}",
        nfkc: "\u{C676}",
        nfkd: "\u{110B}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C677}",
        nfc: "\u{C677}",
        nfd: "\u{110B}\u{116B}\u{11C2}",
        nfkc: "\u{C677}",
        nfkd: "\u{110B}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C678}",
        nfc: "\u{C678}",
        nfd: "\u{110B}\u{116C}",
        nfkc: "\u{C678}",
        nfkd: "\u{110B}\u{116C}",
    },
    NormalizationTest {
        source: "\u{C679}",
        nfc: "\u{C679}",
        nfd: "\u{110B}\u{116C}\u{11A8}",
        nfkc: "\u{C679}",
        nfkd: "\u{110B}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C67A}",
        nfc: "\u{C67A}",
        nfd: "\u{110B}\u{116C}\u{11A9}",
        nfkc: "\u{C67A}",
        nfkd: "\u{110B}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C67B}",
        nfc: "\u{C67B}",
        nfd: "\u{110B}\u{116C}\u{11AA}",
        nfkc: "\u{C67B}",
        nfkd: "\u{110B}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C67C}",
        nfc: "\u{C67C}",
        nfd: "\u{110B}\u{116C}\u{11AB}",
        nfkc: "\u{C67C}",
        nfkd: "\u{110B}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C67D}",
        nfc: "\u{C67D}",
        nfd: "\u{110B}\u{116C}\u{11AC}",
        nfkc: "\u{C67D}",
        nfkd: "\u{110B}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C67E}",
        nfc: "\u{C67E}",
        nfd: "\u{110B}\u{116C}\u{11AD}",
        nfkc: "\u{C67E}",
        nfkd: "\u{110B}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C67F}",
        nfc: "\u{C67F}",
        nfd: "\u{110B}\u{116C}\u{11AE}",
        nfkc: "\u{C67F}",
        nfkd: "\u{110B}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C680}",
        nfc: "\u{C680}",
        nfd: "\u{110B}\u{116C}\u{11AF}",
        nfkc: "\u{C680}",
        nfkd: "\u{110B}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C681}",
        nfc: "\u{C681}",
        nfd: "\u{110B}\u{116C}\u{11B0}",
        nfkc: "\u{C681}",
        nfkd: "\u{110B}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C682}",
        nfc: "\u{C682}",
        nfd: "\u{110B}\u{116C}\u{11B1}",
        nfkc: "\u{C682}",
        nfkd: "\u{110B}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C683}",
        nfc: "\u{C683}",
        nfd: "\u{110B}\u{116C}\u{11B2}",
        nfkc: "\u{C683}",
        nfkd: "\u{110B}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C684}",
        nfc: "\u{C684}",
        nfd: "\u{110B}\u{116C}\u{11B3}",
        nfkc: "\u{C684}",
        nfkd: "\u{110B}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C685}",
        nfc: "\u{C685}",
        nfd: "\u{110B}\u{116C}\u{11B4}",
        nfkc: "\u{C685}",
        nfkd: "\u{110B}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C686}",
        nfc: "\u{C686}",
        nfd: "\u{110B}\u{116C}\u{11B5}",
        nfkc: "\u{C686}",
        nfkd: "\u{110B}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C687}",
        nfc: "\u{C687}",
        nfd: "\u{110B}\u{116C}\u{11B6}",
        nfkc: "\u{C687}",
        nfkd: "\u{110B}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C688}",
        nfc: "\u{C688}",
        nfd: "\u{110B}\u{116C}\u{11B7}",
        nfkc: "\u{C688}",
        nfkd: "\u{110B}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C689}",
        nfc: "\u{C689}",
        nfd: "\u{110B}\u{116C}\u{11B8}",
        nfkc: "\u{C689}",
        nfkd: "\u{110B}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C68A}",
        nfc: "\u{C68A}",
        nfd: "\u{110B}\u{116C}\u{11B9}",
        nfkc: "\u{C68A}",
        nfkd: "\u{110B}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C68B}",
        nfc: "\u{C68B}",
        nfd: "\u{110B}\u{116C}\u{11BA}",
        nfkc: "\u{C68B}",
        nfkd: "\u{110B}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C68C}",
        nfc: "\u{C68C}",
        nfd: "\u{110B}\u{116C}\u{11BB}",
        nfkc: "\u{C68C}",
        nfkd: "\u{110B}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C68D}",
        nfc: "\u{C68D}",
        nfd: "\u{110B}\u{116C}\u{11BC}",
        nfkc: "\u{C68D}",
        nfkd: "\u{110B}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C68E}",
        nfc: "\u{C68E}",
        nfd: "\u{110B}\u{116C}\u{11BD}",
        nfkc: "\u{C68E}",
        nfkd: "\u{110B}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C68F}",
        nfc: "\u{C68F}",
        nfd: "\u{110B}\u{116C}\u{11BE}",
        nfkc: "\u{C68F}",
        nfkd: "\u{110B}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C690}",
        nfc: "\u{C690}",
        nfd: "\u{110B}\u{116C}\u{11BF}",
        nfkc: "\u{C690}",
        nfkd: "\u{110B}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C691}",
        nfc: "\u{C691}",
        nfd: "\u{110B}\u{116C}\u{11C0}",
        nfkc: "\u{C691}",
        nfkd: "\u{110B}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C692}",
        nfc: "\u{C692}",
        nfd: "\u{110B}\u{116C}\u{11C1}",
        nfkc: "\u{C692}",
        nfkd: "\u{110B}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C693}",
        nfc: "\u{C693}",
        nfd: "\u{110B}\u{116C}\u{11C2}",
        nfkc: "\u{C693}",
        nfkd: "\u{110B}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C694}",
        nfc: "\u{C694}",
        nfd: "\u{110B}\u{116D}",
        nfkc: "\u{C694}",
        nfkd: "\u{110B}\u{116D}",
    },
    NormalizationTest {
        source: "\u{C695}",
        nfc: "\u{C695}",
        nfd: "\u{110B}\u{116D}\u{11A8}",
        nfkc: "\u{C695}",
        nfkd: "\u{110B}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C696}",
        nfc: "\u{C696}",
        nfd: "\u{110B}\u{116D}\u{11A9}",
        nfkc: "\u{C696}",
        nfkd: "\u{110B}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C697}",
        nfc: "\u{C697}",
        nfd: "\u{110B}\u{116D}\u{11AA}",
        nfkc: "\u{C697}",
        nfkd: "\u{110B}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C698}",
        nfc: "\u{C698}",
        nfd: "\u{110B}\u{116D}\u{11AB}",
        nfkc: "\u{C698}",
        nfkd: "\u{110B}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C699}",
        nfc: "\u{C699}",
        nfd: "\u{110B}\u{116D}\u{11AC}",
        nfkc: "\u{C699}",
        nfkd: "\u{110B}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C69A}",
        nfc: "\u{C69A}",
        nfd: "\u{110B}\u{116D}\u{11AD}",
        nfkc: "\u{C69A}",
        nfkd: "\u{110B}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C69B}",
        nfc: "\u{C69B}",
        nfd: "\u{110B}\u{116D}\u{11AE}",
        nfkc: "\u{C69B}",
        nfkd: "\u{110B}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C69C}",
        nfc: "\u{C69C}",
        nfd: "\u{110B}\u{116D}\u{11AF}",
        nfkc: "\u{C69C}",
        nfkd: "\u{110B}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C69D}",
        nfc: "\u{C69D}",
        nfd: "\u{110B}\u{116D}\u{11B0}",
        nfkc: "\u{C69D}",
        nfkd: "\u{110B}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C69E}",
        nfc: "\u{C69E}",
        nfd: "\u{110B}\u{116D}\u{11B1}",
        nfkc: "\u{C69E}",
        nfkd: "\u{110B}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C69F}",
        nfc: "\u{C69F}",
        nfd: "\u{110B}\u{116D}\u{11B2}",
        nfkc: "\u{C69F}",
        nfkd: "\u{110B}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C6A0}",
        nfc: "\u{C6A0}",
        nfd: "\u{110B}\u{116D}\u{11B3}",
        nfkc: "\u{C6A0}",
        nfkd: "\u{110B}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C6A1}",
        nfc: "\u{C6A1}",
        nfd: "\u{110B}\u{116D}\u{11B4}",
        nfkc: "\u{C6A1}",
        nfkd: "\u{110B}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C6A2}",
        nfc: "\u{C6A2}",
        nfd: "\u{110B}\u{116D}\u{11B5}",
        nfkc: "\u{C6A2}",
        nfkd: "\u{110B}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C6A3}",
        nfc: "\u{C6A3}",
        nfd: "\u{110B}\u{116D}\u{11B6}",
        nfkc: "\u{C6A3}",
        nfkd: "\u{110B}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C6A4}",
        nfc: "\u{C6A4}",
        nfd: "\u{110B}\u{116D}\u{11B7}",
        nfkc: "\u{C6A4}",
        nfkd: "\u{110B}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C6A5}",
        nfc: "\u{C6A5}",
        nfd: "\u{110B}\u{116D}\u{11B8}",
        nfkc: "\u{C6A5}",
        nfkd: "\u{110B}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C6A6}",
        nfc: "\u{C6A6}",
        nfd: "\u{110B}\u{116D}\u{11B9}",
        nfkc: "\u{C6A6}",
        nfkd: "\u{110B}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C6A7}",
        nfc: "\u{C6A7}",
        nfd: "\u{110B}\u{116D}\u{11BA}",
        nfkc: "\u{C6A7}",
        nfkd: "\u{110B}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C6A8}",
        nfc: "\u{C6A8}",
        nfd: "\u{110B}\u{116D}\u{11BB}",
        nfkc: "\u{C6A8}",
        nfkd: "\u{110B}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C6A9}",
        nfc: "\u{C6A9}",
        nfd: "\u{110B}\u{116D}\u{11BC}",
        nfkc: "\u{C6A9}",
        nfkd: "\u{110B}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C6AA}",
        nfc: "\u{C6AA}",
        nfd: "\u{110B}\u{116D}\u{11BD}",
        nfkc: "\u{C6AA}",
        nfkd: "\u{110B}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C6AB}",
        nfc: "\u{C6AB}",
        nfd: "\u{110B}\u{116D}\u{11BE}",
        nfkc: "\u{C6AB}",
        nfkd: "\u{110B}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C6AC}",
        nfc: "\u{C6AC}",
        nfd: "\u{110B}\u{116D}\u{11BF}",
        nfkc: "\u{C6AC}",
        nfkd: "\u{110B}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C6AD}",
        nfc: "\u{C6AD}",
        nfd: "\u{110B}\u{116D}\u{11C0}",
        nfkc: "\u{C6AD}",
        nfkd: "\u{110B}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C6AE}",
        nfc: "\u{C6AE}",
        nfd: "\u{110B}\u{116D}\u{11C1}",
        nfkc: "\u{C6AE}",
        nfkd: "\u{110B}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C6AF}",
        nfc: "\u{C6AF}",
        nfd: "\u{110B}\u{116D}\u{11C2}",
        nfkc: "\u{C6AF}",
        nfkd: "\u{110B}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C6B0}",
        nfc: "\u{C6B0}",
        nfd: "\u{110B}\u{116E}",
        nfkc: "\u{C6B0}",
        nfkd: "\u{110B}\u{116E}",
    },
    NormalizationTest {
        source: "\u{C6B1}",
        nfc: "\u{C6B1}",
        nfd: "\u{110B}\u{116E}\u{11A8}",
        nfkc: "\u{C6B1}",
        nfkd: "\u{110B}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C6B2}",
        nfc: "\u{C6B2}",
        nfd: "\u{110B}\u{116E}\u{11A9}",
        nfkc: "\u{C6B2}",
        nfkd: "\u{110B}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C6B3}",
        nfc: "\u{C6B3}",
        nfd: "\u{110B}\u{116E}\u{11AA}",
        nfkc: "\u{C6B3}",
        nfkd: "\u{110B}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C6B4}",
        nfc: "\u{C6B4}",
        nfd: "\u{110B}\u{116E}\u{11AB}",
        nfkc: "\u{C6B4}",
        nfkd: "\u{110B}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C6B5}",
        nfc: "\u{C6B5}",
        nfd: "\u{110B}\u{116E}\u{11AC}",
        nfkc: "\u{C6B5}",
        nfkd: "\u{110B}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C6B6}",
        nfc: "\u{C6B6}",
        nfd: "\u{110B}\u{116E}\u{11AD}",
        nfkc: "\u{C6B6}",
        nfkd: "\u{110B}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C6B7}",
        nfc: "\u{C6B7}",
        nfd: "\u{110B}\u{116E}\u{11AE}",
        nfkc: "\u{C6B7}",
        nfkd: "\u{110B}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C6B8}",
        nfc: "\u{C6B8}",
        nfd: "\u{110B}\u{116E}\u{11AF}",
        nfkc: "\u{C6B8}",
        nfkd: "\u{110B}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C6B9}",
        nfc: "\u{C6B9}",
        nfd: "\u{110B}\u{116E}\u{11B0}",
        nfkc: "\u{C6B9}",
        nfkd: "\u{110B}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C6BA}",
        nfc: "\u{C6BA}",
        nfd: "\u{110B}\u{116E}\u{11B1}",
        nfkc: "\u{C6BA}",
        nfkd: "\u{110B}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C6BB}",
        nfc: "\u{C6BB}",
        nfd: "\u{110B}\u{116E}\u{11B2}",
        nfkc: "\u{C6BB}",
        nfkd: "\u{110B}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C6BC}",
        nfc: "\u{C6BC}",
        nfd: "\u{110B}\u{116E}\u{11B3}",
        nfkc: "\u{C6BC}",
        nfkd: "\u{110B}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C6BD}",
        nfc: "\u{C6BD}",
        nfd: "\u{110B}\u{116E}\u{11B4}",
        nfkc: "\u{C6BD}",
        nfkd: "\u{110B}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C6BE}",
        nfc: "\u{C6BE}",
        nfd: "\u{110B}\u{116E}\u{11B5}",
        nfkc: "\u{C6BE}",
        nfkd: "\u{110B}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C6BF}",
        nfc: "\u{C6BF}",
        nfd: "\u{110B}\u{116E}\u{11B6}",
        nfkc: "\u{C6BF}",
        nfkd: "\u{110B}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C6C0}",
        nfc: "\u{C6C0}",
        nfd: "\u{110B}\u{116E}\u{11B7}",
        nfkc: "\u{C6C0}",
        nfkd: "\u{110B}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C6C1}",
        nfc: "\u{C6C1}",
        nfd: "\u{110B}\u{116E}\u{11B8}",
        nfkc: "\u{C6C1}",
        nfkd: "\u{110B}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C6C2}",
        nfc: "\u{C6C2}",
        nfd: "\u{110B}\u{116E}\u{11B9}",
        nfkc: "\u{C6C2}",
        nfkd: "\u{110B}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C6C3}",
        nfc: "\u{C6C3}",
        nfd: "\u{110B}\u{116E}\u{11BA}",
        nfkc: "\u{C6C3}",
        nfkd: "\u{110B}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C6C4}",
        nfc: "\u{C6C4}",
        nfd: "\u{110B}\u{116E}\u{11BB}",
        nfkc: "\u{C6C4}",
        nfkd: "\u{110B}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C6C5}",
        nfc: "\u{C6C5}",
        nfd: "\u{110B}\u{116E}\u{11BC}",
        nfkc: "\u{C6C5}",
        nfkd: "\u{110B}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C6C6}",
        nfc: "\u{C6C6}",
        nfd: "\u{110B}\u{116E}\u{11BD}",
        nfkc: "\u{C6C6}",
        nfkd: "\u{110B}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C6C7}",
        nfc: "\u{C6C7}",
        nfd: "\u{110B}\u{116E}\u{11BE}",
        nfkc: "\u{C6C7}",
        nfkd: "\u{110B}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C6C8}",
        nfc: "\u{C6C8}",
        nfd: "\u{110B}\u{116E}\u{11BF}",
        nfkc: "\u{C6C8}",
        nfkd: "\u{110B}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C6C9}",
        nfc: "\u{C6C9}",
        nfd: "\u{110B}\u{116E}\u{11C0}",
        nfkc: "\u{C6C9}",
        nfkd: "\u{110B}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C6CA}",
        nfc: "\u{C6CA}",
        nfd: "\u{110B}\u{116E}\u{11C1}",
        nfkc: "\u{C6CA}",
        nfkd: "\u{110B}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C6CB}",
        nfc: "\u{C6CB}",
        nfd: "\u{110B}\u{116E}\u{11C2}",
        nfkc: "\u{C6CB}",
        nfkd: "\u{110B}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C6CC}",
        nfc: "\u{C6CC}",
        nfd: "\u{110B}\u{116F}",
        nfkc: "\u{C6CC}",
        nfkd: "\u{110B}\u{116F}",
    },
    NormalizationTest {
        source: "\u{C6CD}",
        nfc: "\u{C6CD}",
        nfd: "\u{110B}\u{116F}\u{11A8}",
        nfkc: "\u{C6CD}",
        nfkd: "\u{110B}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C6CE}",
        nfc: "\u{C6CE}",
        nfd: "\u{110B}\u{116F}\u{11A9}",
        nfkc: "\u{C6CE}",
        nfkd: "\u{110B}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C6CF}",
        nfc: "\u{C6CF}",
        nfd: "\u{110B}\u{116F}\u{11AA}",
        nfkc: "\u{C6CF}",
        nfkd: "\u{110B}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C6D0}",
        nfc: "\u{C6D0}",
        nfd: "\u{110B}\u{116F}\u{11AB}",
        nfkc: "\u{C6D0}",
        nfkd: "\u{110B}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C6D1}",
        nfc: "\u{C6D1}",
        nfd: "\u{110B}\u{116F}\u{11AC}",
        nfkc: "\u{C6D1}",
        nfkd: "\u{110B}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C6D2}",
        nfc: "\u{C6D2}",
        nfd: "\u{110B}\u{116F}\u{11AD}",
        nfkc: "\u{C6D2}",
        nfkd: "\u{110B}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C6D3}",
        nfc: "\u{C6D3}",
        nfd: "\u{110B}\u{116F}\u{11AE}",
        nfkc: "\u{C6D3}",
        nfkd: "\u{110B}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C6D4}",
        nfc: "\u{C6D4}",
        nfd: "\u{110B}\u{116F}\u{11AF}",
        nfkc: "\u{C6D4}",
        nfkd: "\u{110B}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C6D5}",
        nfc: "\u{C6D5}",
        nfd: "\u{110B}\u{116F}\u{11B0}",
        nfkc: "\u{C6D5}",
        nfkd: "\u{110B}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C6D6}",
        nfc: "\u{C6D6}",
        nfd: "\u{110B}\u{116F}\u{11B1}",
        nfkc: "\u{C6D6}",
        nfkd: "\u{110B}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C6D7}",
        nfc: "\u{C6D7}",
        nfd: "\u{110B}\u{116F}\u{11B2}",
        nfkc: "\u{C6D7}",
        nfkd: "\u{110B}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C6D8}",
        nfc: "\u{C6D8}",
        nfd: "\u{110B}\u{116F}\u{11B3}",
        nfkc: "\u{C6D8}",
        nfkd: "\u{110B}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C6D9}",
        nfc: "\u{C6D9}",
        nfd: "\u{110B}\u{116F}\u{11B4}",
        nfkc: "\u{C6D9}",
        nfkd: "\u{110B}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C6DA}",
        nfc: "\u{C6DA}",
        nfd: "\u{110B}\u{116F}\u{11B5}",
        nfkc: "\u{C6DA}",
        nfkd: "\u{110B}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C6DB}",
        nfc: "\u{C6DB}",
        nfd: "\u{110B}\u{116F}\u{11B6}",
        nfkc: "\u{C6DB}",
        nfkd: "\u{110B}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C6DC}",
        nfc: "\u{C6DC}",
        nfd: "\u{110B}\u{116F}\u{11B7}",
        nfkc: "\u{C6DC}",
        nfkd: "\u{110B}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C6DD}",
        nfc: "\u{C6DD}",
        nfd: "\u{110B}\u{116F}\u{11B8}",
        nfkc: "\u{C6DD}",
        nfkd: "\u{110B}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C6DE}",
        nfc: "\u{C6DE}",
        nfd: "\u{110B}\u{116F}\u{11B9}",
        nfkc: "\u{C6DE}",
        nfkd: "\u{110B}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C6DF}",
        nfc: "\u{C6DF}",
        nfd: "\u{110B}\u{116F}\u{11BA}",
        nfkc: "\u{C6DF}",
        nfkd: "\u{110B}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C6E0}",
        nfc: "\u{C6E0}",
        nfd: "\u{110B}\u{116F}\u{11BB}",
        nfkc: "\u{C6E0}",
        nfkd: "\u{110B}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C6E1}",
        nfc: "\u{C6E1}",
        nfd: "\u{110B}\u{116F}\u{11BC}",
        nfkc: "\u{C6E1}",
        nfkd: "\u{110B}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C6E2}",
        nfc: "\u{C6E2}",
        nfd: "\u{110B}\u{116F}\u{11BD}",
        nfkc: "\u{C6E2}",
        nfkd: "\u{110B}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C6E3}",
        nfc: "\u{C6E3}",
        nfd: "\u{110B}\u{116F}\u{11BE}",
        nfkc: "\u{C6E3}",
        nfkd: "\u{110B}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C6E4}",
        nfc: "\u{C6E4}",
        nfd: "\u{110B}\u{116F}\u{11BF}",
        nfkc: "\u{C6E4}",
        nfkd: "\u{110B}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C6E5}",
        nfc: "\u{C6E5}",
        nfd: "\u{110B}\u{116F}\u{11C0}",
        nfkc: "\u{C6E5}",
        nfkd: "\u{110B}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C6E6}",
        nfc: "\u{C6E6}",
        nfd: "\u{110B}\u{116F}\u{11C1}",
        nfkc: "\u{C6E6}",
        nfkd: "\u{110B}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C6E7}",
        nfc: "\u{C6E7}",
        nfd: "\u{110B}\u{116F}\u{11C2}",
        nfkc: "\u{C6E7}",
        nfkd: "\u{110B}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C6E8}",
        nfc: "\u{C6E8}",
        nfd: "\u{110B}\u{1170}",
        nfkc: "\u{C6E8}",
        nfkd: "\u{110B}\u{1170}",
    },
    NormalizationTest {
        source: "\u{C6E9}",
        nfc: "\u{C6E9}",
        nfd: "\u{110B}\u{1170}\u{11A8}",
        nfkc: "\u{C6E9}",
        nfkd: "\u{110B}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C6EA}",
        nfc: "\u{C6EA}",
        nfd: "\u{110B}\u{1170}\u{11A9}",
        nfkc: "\u{C6EA}",
        nfkd: "\u{110B}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C6EB}",
        nfc: "\u{C6EB}",
        nfd: "\u{110B}\u{1170}\u{11AA}",
        nfkc: "\u{C6EB}",
        nfkd: "\u{110B}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C6EC}",
        nfc: "\u{C6EC}",
        nfd: "\u{110B}\u{1170}\u{11AB}",
        nfkc: "\u{C6EC}",
        nfkd: "\u{110B}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C6ED}",
        nfc: "\u{C6ED}",
        nfd: "\u{110B}\u{1170}\u{11AC}",
        nfkc: "\u{C6ED}",
        nfkd: "\u{110B}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C6EE}",
        nfc: "\u{C6EE}",
        nfd: "\u{110B}\u{1170}\u{11AD}",
        nfkc: "\u{C6EE}",
        nfkd: "\u{110B}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C6EF}",
        nfc: "\u{C6EF}",
        nfd: "\u{110B}\u{1170}\u{11AE}",
        nfkc: "\u{C6EF}",
        nfkd: "\u{110B}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C6F0}",
        nfc: "\u{C6F0}",
        nfd: "\u{110B}\u{1170}\u{11AF}",
        nfkc: "\u{C6F0}",
        nfkd: "\u{110B}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C6F1}",
        nfc: "\u{C6F1}",
        nfd: "\u{110B}\u{1170}\u{11B0}",
        nfkc: "\u{C6F1}",
        nfkd: "\u{110B}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C6F2}",
        nfc: "\u{C6F2}",
        nfd: "\u{110B}\u{1170}\u{11B1}",
        nfkc: "\u{C6F2}",
        nfkd: "\u{110B}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C6F3}",
        nfc: "\u{C6F3}",
        nfd: "\u{110B}\u{1170}\u{11B2}",
        nfkc: "\u{C6F3}",
        nfkd: "\u{110B}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C6F4}",
        nfc: "\u{C6F4}",
        nfd: "\u{110B}\u{1170}\u{11B3}",
        nfkc: "\u{C6F4}",
        nfkd: "\u{110B}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C6F5}",
        nfc: "\u{C6F5}",
        nfd: "\u{110B}\u{1170}\u{11B4}",
        nfkc: "\u{C6F5}",
        nfkd: "\u{110B}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C6F6}",
        nfc: "\u{C6F6}",
        nfd: "\u{110B}\u{1170}\u{11B5}",
        nfkc: "\u{C6F6}",
        nfkd: "\u{110B}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C6F7}",
        nfc: "\u{C6F7}",
        nfd: "\u{110B}\u{1170}\u{11B6}",
        nfkc: "\u{C6F7}",
        nfkd: "\u{110B}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C6F8}",
        nfc: "\u{C6F8}",
        nfd: "\u{110B}\u{1170}\u{11B7}",
        nfkc: "\u{C6F8}",
        nfkd: "\u{110B}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C6F9}",
        nfc: "\u{C6F9}",
        nfd: "\u{110B}\u{1170}\u{11B8}",
        nfkc: "\u{C6F9}",
        nfkd: "\u{110B}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C6FA}",
        nfc: "\u{C6FA}",
        nfd: "\u{110B}\u{1170}\u{11B9}",
        nfkc: "\u{C6FA}",
        nfkd: "\u{110B}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C6FB}",
        nfc: "\u{C6FB}",
        nfd: "\u{110B}\u{1170}\u{11BA}",
        nfkc: "\u{C6FB}",
        nfkd: "\u{110B}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C6FC}",
        nfc: "\u{C6FC}",
        nfd: "\u{110B}\u{1170}\u{11BB}",
        nfkc: "\u{C6FC}",
        nfkd: "\u{110B}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C6FD}",
        nfc: "\u{C6FD}",
        nfd: "\u{110B}\u{1170}\u{11BC}",
        nfkc: "\u{C6FD}",
        nfkd: "\u{110B}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C6FE}",
        nfc: "\u{C6FE}",
        nfd: "\u{110B}\u{1170}\u{11BD}",
        nfkc: "\u{C6FE}",
        nfkd: "\u{110B}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C6FF}",
        nfc: "\u{C6FF}",
        nfd: "\u{110B}\u{1170}\u{11BE}",
        nfkc: "\u{C6FF}",
        nfkd: "\u{110B}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C700}",
        nfc: "\u{C700}",
        nfd: "\u{110B}\u{1170}\u{11BF}",
        nfkc: "\u{C700}",
        nfkd: "\u{110B}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C701}",
        nfc: "\u{C701}",
        nfd: "\u{110B}\u{1170}\u{11C0}",
        nfkc: "\u{C701}",
        nfkd: "\u{110B}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C702}",
        nfc: "\u{C702}",
        nfd: "\u{110B}\u{1170}\u{11C1}",
        nfkc: "\u{C702}",
        nfkd: "\u{110B}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C703}",
        nfc: "\u{C703}",
        nfd: "\u{110B}\u{1170}\u{11C2}",
        nfkc: "\u{C703}",
        nfkd: "\u{110B}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C704}",
        nfc: "\u{C704}",
        nfd: "\u{110B}\u{1171}",
        nfkc: "\u{C704}",
        nfkd: "\u{110B}\u{1171}",
    },
    NormalizationTest {
        source: "\u{C705}",
        nfc: "\u{C705}",
        nfd: "\u{110B}\u{1171}\u{11A8}",
        nfkc: "\u{C705}",
        nfkd: "\u{110B}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C706}",
        nfc: "\u{C706}",
        nfd: "\u{110B}\u{1171}\u{11A9}",
        nfkc: "\u{C706}",
        nfkd: "\u{110B}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C707}",
        nfc: "\u{C707}",
        nfd: "\u{110B}\u{1171}\u{11AA}",
        nfkc: "\u{C707}",
        nfkd: "\u{110B}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C708}",
        nfc: "\u{C708}",
        nfd: "\u{110B}\u{1171}\u{11AB}",
        nfkc: "\u{C708}",
        nfkd: "\u{110B}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C709}",
        nfc: "\u{C709}",
        nfd: "\u{110B}\u{1171}\u{11AC}",
        nfkc: "\u{C709}",
        nfkd: "\u{110B}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C70A}",
        nfc: "\u{C70A}",
        nfd: "\u{110B}\u{1171}\u{11AD}",
        nfkc: "\u{C70A}",
        nfkd: "\u{110B}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C70B}",
        nfc: "\u{C70B}",
        nfd: "\u{110B}\u{1171}\u{11AE}",
        nfkc: "\u{C70B}",
        nfkd: "\u{110B}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C70C}",
        nfc: "\u{C70C}",
        nfd: "\u{110B}\u{1171}\u{11AF}",
        nfkc: "\u{C70C}",
        nfkd: "\u{110B}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C70D}",
        nfc: "\u{C70D}",
        nfd: "\u{110B}\u{1171}\u{11B0}",
        nfkc: "\u{C70D}",
        nfkd: "\u{110B}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C70E}",
        nfc: "\u{C70E}",
        nfd: "\u{110B}\u{1171}\u{11B1}",
        nfkc: "\u{C70E}",
        nfkd: "\u{110B}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C70F}",
        nfc: "\u{C70F}",
        nfd: "\u{110B}\u{1171}\u{11B2}",
        nfkc: "\u{C70F}",
        nfkd: "\u{110B}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C710}",
        nfc: "\u{C710}",
        nfd: "\u{110B}\u{1171}\u{11B3}",
        nfkc: "\u{C710}",
        nfkd: "\u{110B}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C711}",
        nfc: "\u{C711}",
        nfd: "\u{110B}\u{1171}\u{11B4}",
        nfkc: "\u{C711}",
        nfkd: "\u{110B}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C712}",
        nfc: "\u{C712}",
        nfd: "\u{110B}\u{1171}\u{11B5}",
        nfkc: "\u{C712}",
        nfkd: "\u{110B}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C713}",
        nfc: "\u{C713}",
        nfd: "\u{110B}\u{1171}\u{11B6}",
        nfkc: "\u{C713}",
        nfkd: "\u{110B}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C714}",
        nfc: "\u{C714}",
        nfd: "\u{110B}\u{1171}\u{11B7}",
        nfkc: "\u{C714}",
        nfkd: "\u{110B}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C715}",
        nfc: "\u{C715}",
        nfd: "\u{110B}\u{1171}\u{11B8}",
        nfkc: "\u{C715}",
        nfkd: "\u{110B}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C716}",
        nfc: "\u{C716}",
        nfd: "\u{110B}\u{1171}\u{11B9}",
        nfkc: "\u{C716}",
        nfkd: "\u{110B}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C717}",
        nfc: "\u{C717}",
        nfd: "\u{110B}\u{1171}\u{11BA}",
        nfkc: "\u{C717}",
        nfkd: "\u{110B}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C718}",
        nfc: "\u{C718}",
        nfd: "\u{110B}\u{1171}\u{11BB}",
        nfkc: "\u{C718}",
        nfkd: "\u{110B}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C719}",
        nfc: "\u{C719}",
        nfd: "\u{110B}\u{1171}\u{11BC}",
        nfkc: "\u{C719}",
        nfkd: "\u{110B}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C71A}",
        nfc: "\u{C71A}",
        nfd: "\u{110B}\u{1171}\u{11BD}",
        nfkc: "\u{C71A}",
        nfkd: "\u{110B}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C71B}",
        nfc: "\u{C71B}",
        nfd: "\u{110B}\u{1171}\u{11BE}",
        nfkc: "\u{C71B}",
        nfkd: "\u{110B}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C71C}",
        nfc: "\u{C71C}",
        nfd: "\u{110B}\u{1171}\u{11BF}",
        nfkc: "\u{C71C}",
        nfkd: "\u{110B}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C71D}",
        nfc: "\u{C71D}",
        nfd: "\u{110B}\u{1171}\u{11C0}",
        nfkc: "\u{C71D}",
        nfkd: "\u{110B}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C71E}",
        nfc: "\u{C71E}",
        nfd: "\u{110B}\u{1171}\u{11C1}",
        nfkc: "\u{C71E}",
        nfkd: "\u{110B}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C71F}",
        nfc: "\u{C71F}",
        nfd: "\u{110B}\u{1171}\u{11C2}",
        nfkc: "\u{C71F}",
        nfkd: "\u{110B}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C720}",
        nfc: "\u{C720}",
        nfd: "\u{110B}\u{1172}",
        nfkc: "\u{C720}",
        nfkd: "\u{110B}\u{1172}",
    },
    NormalizationTest {
        source: "\u{C721}",
        nfc: "\u{C721}",
        nfd: "\u{110B}\u{1172}\u{11A8}",
        nfkc: "\u{C721}",
        nfkd: "\u{110B}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C722}",
        nfc: "\u{C722}",
        nfd: "\u{110B}\u{1172}\u{11A9}",
        nfkc: "\u{C722}",
        nfkd: "\u{110B}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C723}",
        nfc: "\u{C723}",
        nfd: "\u{110B}\u{1172}\u{11AA}",
        nfkc: "\u{C723}",
        nfkd: "\u{110B}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C724}",
        nfc: "\u{C724}",
        nfd: "\u{110B}\u{1172}\u{11AB}",
        nfkc: "\u{C724}",
        nfkd: "\u{110B}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C725}",
        nfc: "\u{C725}",
        nfd: "\u{110B}\u{1172}\u{11AC}",
        nfkc: "\u{C725}",
        nfkd: "\u{110B}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C726}",
        nfc: "\u{C726}",
        nfd: "\u{110B}\u{1172}\u{11AD}",
        nfkc: "\u{C726}",
        nfkd: "\u{110B}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C727}",
        nfc: "\u{C727}",
        nfd: "\u{110B}\u{1172}\u{11AE}",
        nfkc: "\u{C727}",
        nfkd: "\u{110B}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C728}",
        nfc: "\u{C728}",
        nfd: "\u{110B}\u{1172}\u{11AF}",
        nfkc: "\u{C728}",
        nfkd: "\u{110B}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C729}",
        nfc: "\u{C729}",
        nfd: "\u{110B}\u{1172}\u{11B0}",
        nfkc: "\u{C729}",
        nfkd: "\u{110B}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C72A}",
        nfc: "\u{C72A}",
        nfd: "\u{110B}\u{1172}\u{11B1}",
        nfkc: "\u{C72A}",
        nfkd: "\u{110B}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C72B}",
        nfc: "\u{C72B}",
        nfd: "\u{110B}\u{1172}\u{11B2}",
        nfkc: "\u{C72B}",
        nfkd: "\u{110B}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C72C}",
        nfc: "\u{C72C}",
        nfd: "\u{110B}\u{1172}\u{11B3}",
        nfkc: "\u{C72C}",
        nfkd: "\u{110B}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C72D}",
        nfc: "\u{C72D}",
        nfd: "\u{110B}\u{1172}\u{11B4}",
        nfkc: "\u{C72D}",
        nfkd: "\u{110B}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C72E}",
        nfc: "\u{C72E}",
        nfd: "\u{110B}\u{1172}\u{11B5}",
        nfkc: "\u{C72E}",
        nfkd: "\u{110B}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C72F}",
        nfc: "\u{C72F}",
        nfd: "\u{110B}\u{1172}\u{11B6}",
        nfkc: "\u{C72F}",
        nfkd: "\u{110B}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C730}",
        nfc: "\u{C730}",
        nfd: "\u{110B}\u{1172}\u{11B7}",
        nfkc: "\u{C730}",
        nfkd: "\u{110B}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C731}",
        nfc: "\u{C731}",
        nfd: "\u{110B}\u{1172}\u{11B8}",
        nfkc: "\u{C731}",
        nfkd: "\u{110B}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C732}",
        nfc: "\u{C732}",
        nfd: "\u{110B}\u{1172}\u{11B9}",
        nfkc: "\u{C732}",
        nfkd: "\u{110B}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C733}",
        nfc: "\u{C733}",
        nfd: "\u{110B}\u{1172}\u{11BA}",
        nfkc: "\u{C733}",
        nfkd: "\u{110B}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C734}",
        nfc: "\u{C734}",
        nfd: "\u{110B}\u{1172}\u{11BB}",
        nfkc: "\u{C734}",
        nfkd: "\u{110B}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C735}",
        nfc: "\u{C735}",
        nfd: "\u{110B}\u{1172}\u{11BC}",
        nfkc: "\u{C735}",
        nfkd: "\u{110B}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C736}",
        nfc: "\u{C736}",
        nfd: "\u{110B}\u{1172}\u{11BD}",
        nfkc: "\u{C736}",
        nfkd: "\u{110B}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C737}",
        nfc: "\u{C737}",
        nfd: "\u{110B}\u{1172}\u{11BE}",
        nfkc: "\u{C737}",
        nfkd: "\u{110B}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C738}",
        nfc: "\u{C738}",
        nfd: "\u{110B}\u{1172}\u{11BF}",
        nfkc: "\u{C738}",
        nfkd: "\u{110B}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C739}",
        nfc: "\u{C739}",
        nfd: "\u{110B}\u{1172}\u{11C0}",
        nfkc: "\u{C739}",
        nfkd: "\u{110B}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C73A}",
        nfc: "\u{C73A}",
        nfd: "\u{110B}\u{1172}\u{11C1}",
        nfkc: "\u{C73A}",
        nfkd: "\u{110B}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C73B}",
        nfc: "\u{C73B}",
        nfd: "\u{110B}\u{1172}\u{11C2}",
        nfkc: "\u{C73B}",
        nfkd: "\u{110B}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C73C}",
        nfc: "\u{C73C}",
        nfd: "\u{110B}\u{1173}",
        nfkc: "\u{C73C}",
        nfkd: "\u{110B}\u{1173}",
    },
    NormalizationTest {
        source: "\u{C73D}",
        nfc: "\u{C73D}",
        nfd: "\u{110B}\u{1173}\u{11A8}",
        nfkc: "\u{C73D}",
        nfkd: "\u{110B}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C73E}",
        nfc: "\u{C73E}",
        nfd: "\u{110B}\u{1173}\u{11A9}",
        nfkc: "\u{C73E}",
        nfkd: "\u{110B}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C73F}",
        nfc: "\u{C73F}",
        nfd: "\u{110B}\u{1173}\u{11AA}",
        nfkc: "\u{C73F}",
        nfkd: "\u{110B}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C740}",
        nfc: "\u{C740}",
        nfd: "\u{110B}\u{1173}\u{11AB}",
        nfkc: "\u{C740}",
        nfkd: "\u{110B}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C741}",
        nfc: "\u{C741}",
        nfd: "\u{110B}\u{1173}\u{11AC}",
        nfkc: "\u{C741}",
        nfkd: "\u{110B}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C742}",
        nfc: "\u{C742}",
        nfd: "\u{110B}\u{1173}\u{11AD}",
        nfkc: "\u{C742}",
        nfkd: "\u{110B}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C743}",
        nfc: "\u{C743}",
        nfd: "\u{110B}\u{1173}\u{11AE}",
        nfkc: "\u{C743}",
        nfkd: "\u{110B}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C744}",
        nfc: "\u{C744}",
        nfd: "\u{110B}\u{1173}\u{11AF}",
        nfkc: "\u{C744}",
        nfkd: "\u{110B}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C745}",
        nfc: "\u{C745}",
        nfd: "\u{110B}\u{1173}\u{11B0}",
        nfkc: "\u{C745}",
        nfkd: "\u{110B}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C746}",
        nfc: "\u{C746}",
        nfd: "\u{110B}\u{1173}\u{11B1}",
        nfkc: "\u{C746}",
        nfkd: "\u{110B}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C747}",
        nfc: "\u{C747}",
        nfd: "\u{110B}\u{1173}\u{11B2}",
        nfkc: "\u{C747}",
        nfkd: "\u{110B}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C748}",
        nfc: "\u{C748}",
        nfd: "\u{110B}\u{1173}\u{11B3}",
        nfkc: "\u{C748}",
        nfkd: "\u{110B}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C749}",
        nfc: "\u{C749}",
        nfd: "\u{110B}\u{1173}\u{11B4}",
        nfkc: "\u{C749}",
        nfkd: "\u{110B}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C74A}",
        nfc: "\u{C74A}",
        nfd: "\u{110B}\u{1173}\u{11B5}",
        nfkc: "\u{C74A}",
        nfkd: "\u{110B}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C74B}",
        nfc: "\u{C74B}",
        nfd: "\u{110B}\u{1173}\u{11B6}",
        nfkc: "\u{C74B}",
        nfkd: "\u{110B}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C74C}",
        nfc: "\u{C74C}",
        nfd: "\u{110B}\u{1173}\u{11B7}",
        nfkc: "\u{C74C}",
        nfkd: "\u{110B}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C74D}",
        nfc: "\u{C74D}",
        nfd: "\u{110B}\u{1173}\u{11B8}",
        nfkc: "\u{C74D}",
        nfkd: "\u{110B}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C74E}",
        nfc: "\u{C74E}",
        nfd: "\u{110B}\u{1173}\u{11B9}",
        nfkc: "\u{C74E}",
        nfkd: "\u{110B}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C74F}",
        nfc: "\u{C74F}",
        nfd: "\u{110B}\u{1173}\u{11BA}",
        nfkc: "\u{C74F}",
        nfkd: "\u{110B}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C750}",
        nfc: "\u{C750}",
        nfd: "\u{110B}\u{1173}\u{11BB}",
        nfkc: "\u{C750}",
        nfkd: "\u{110B}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C751}",
        nfc: "\u{C751}",
        nfd: "\u{110B}\u{1173}\u{11BC}",
        nfkc: "\u{C751}",
        nfkd: "\u{110B}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C752}",
        nfc: "\u{C752}",
        nfd: "\u{110B}\u{1173}\u{11BD}",
        nfkc: "\u{C752}",
        nfkd: "\u{110B}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C753}",
        nfc: "\u{C753}",
        nfd: "\u{110B}\u{1173}\u{11BE}",
        nfkc: "\u{C753}",
        nfkd: "\u{110B}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C754}",
        nfc: "\u{C754}",
        nfd: "\u{110B}\u{1173}\u{11BF}",
        nfkc: "\u{C754}",
        nfkd: "\u{110B}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C755}",
        nfc: "\u{C755}",
        nfd: "\u{110B}\u{1173}\u{11C0}",
        nfkc: "\u{C755}",
        nfkd: "\u{110B}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C756}",
        nfc: "\u{C756}",
        nfd: "\u{110B}\u{1173}\u{11C1}",
        nfkc: "\u{C756}",
        nfkd: "\u{110B}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C757}",
        nfc: "\u{C757}",
        nfd: "\u{110B}\u{1173}\u{11C2}",
        nfkc: "\u{C757}",
        nfkd: "\u{110B}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C758}",
        nfc: "\u{C758}",
        nfd: "\u{110B}\u{1174}",
        nfkc: "\u{C758}",
        nfkd: "\u{110B}\u{1174}",
    },
    NormalizationTest {
        source: "\u{C759}",
        nfc: "\u{C759}",
        nfd: "\u{110B}\u{1174}\u{11A8}",
        nfkc: "\u{C759}",
        nfkd: "\u{110B}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C75A}",
        nfc: "\u{C75A}",
        nfd: "\u{110B}\u{1174}\u{11A9}",
        nfkc: "\u{C75A}",
        nfkd: "\u{110B}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C75B}",
        nfc: "\u{C75B}",
        nfd: "\u{110B}\u{1174}\u{11AA}",
        nfkc: "\u{C75B}",
        nfkd: "\u{110B}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C75C}",
        nfc: "\u{C75C}",
        nfd: "\u{110B}\u{1174}\u{11AB}",
        nfkc: "\u{C75C}",
        nfkd: "\u{110B}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C75D}",
        nfc: "\u{C75D}",
        nfd: "\u{110B}\u{1174}\u{11AC}",
        nfkc: "\u{C75D}",
        nfkd: "\u{110B}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C75E}",
        nfc: "\u{C75E}",
        nfd: "\u{110B}\u{1174}\u{11AD}",
        nfkc: "\u{C75E}",
        nfkd: "\u{110B}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C75F}",
        nfc: "\u{C75F}",
        nfd: "\u{110B}\u{1174}\u{11AE}",
        nfkc: "\u{C75F}",
        nfkd: "\u{110B}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C760}",
        nfc: "\u{C760}",
        nfd: "\u{110B}\u{1174}\u{11AF}",
        nfkc: "\u{C760}",
        nfkd: "\u{110B}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C761}",
        nfc: "\u{C761}",
        nfd: "\u{110B}\u{1174}\u{11B0}",
        nfkc: "\u{C761}",
        nfkd: "\u{110B}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C762}",
        nfc: "\u{C762}",
        nfd: "\u{110B}\u{1174}\u{11B1}",
        nfkc: "\u{C762}",
        nfkd: "\u{110B}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C763}",
        nfc: "\u{C763}",
        nfd: "\u{110B}\u{1174}\u{11B2}",
        nfkc: "\u{C763}",
        nfkd: "\u{110B}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C764}",
        nfc: "\u{C764}",
        nfd: "\u{110B}\u{1174}\u{11B3}",
        nfkc: "\u{C764}",
        nfkd: "\u{110B}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C765}",
        nfc: "\u{C765}",
        nfd: "\u{110B}\u{1174}\u{11B4}",
        nfkc: "\u{C765}",
        nfkd: "\u{110B}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C766}",
        nfc: "\u{C766}",
        nfd: "\u{110B}\u{1174}\u{11B5}",
        nfkc: "\u{C766}",
        nfkd: "\u{110B}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C767}",
        nfc: "\u{C767}",
        nfd: "\u{110B}\u{1174}\u{11B6}",
        nfkc: "\u{C767}",
        nfkd: "\u{110B}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C768}",
        nfc: "\u{C768}",
        nfd: "\u{110B}\u{1174}\u{11B7}",
        nfkc: "\u{C768}",
        nfkd: "\u{110B}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C769}",
        nfc: "\u{C769}",
        nfd: "\u{110B}\u{1174}\u{11B8}",
        nfkc: "\u{C769}",
        nfkd: "\u{110B}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C76A}",
        nfc: "\u{C76A}",
        nfd: "\u{110B}\u{1174}\u{11B9}",
        nfkc: "\u{C76A}",
        nfkd: "\u{110B}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C76B}",
        nfc: "\u{C76B}",
        nfd: "\u{110B}\u{1174}\u{11BA}",
        nfkc: "\u{C76B}",
        nfkd: "\u{110B}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C76C}",
        nfc: "\u{C76C}",
        nfd: "\u{110B}\u{1174}\u{11BB}",
        nfkc: "\u{C76C}",
        nfkd: "\u{110B}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C76D}",
        nfc: "\u{C76D}",
        nfd: "\u{110B}\u{1174}\u{11BC}",
        nfkc: "\u{C76D}",
        nfkd: "\u{110B}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C76E}",
        nfc: "\u{C76E}",
        nfd: "\u{110B}\u{1174}\u{11BD}",
        nfkc: "\u{C76E}",
        nfkd: "\u{110B}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C76F}",
        nfc: "\u{C76F}",
        nfd: "\u{110B}\u{1174}\u{11BE}",
        nfkc: "\u{C76F}",
        nfkd: "\u{110B}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C770}",
        nfc: "\u{C770}",
        nfd: "\u{110B}\u{1174}\u{11BF}",
        nfkc: "\u{C770}",
        nfkd: "\u{110B}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C771}",
        nfc: "\u{C771}",
        nfd: "\u{110B}\u{1174}\u{11C0}",
        nfkc: "\u{C771}",
        nfkd: "\u{110B}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C772}",
        nfc: "\u{C772}",
        nfd: "\u{110B}\u{1174}\u{11C1}",
        nfkc: "\u{C772}",
        nfkd: "\u{110B}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C773}",
        nfc: "\u{C773}",
        nfd: "\u{110B}\u{1174}\u{11C2}",
        nfkc: "\u{C773}",
        nfkd: "\u{110B}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C774}",
        nfc: "\u{C774}",
        nfd: "\u{110B}\u{1175}",
        nfkc: "\u{C774}",
        nfkd: "\u{110B}\u{1175}",
    },
    NormalizationTest {
        source: "\u{C775}",
        nfc: "\u{C775}",
        nfd: "\u{110B}\u{1175}\u{11A8}",
        nfkc: "\u{C775}",
        nfkd: "\u{110B}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C776}",
        nfc: "\u{C776}",
        nfd: "\u{110B}\u{1175}\u{11A9}",
        nfkc: "\u{C776}",
        nfkd: "\u{110B}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C777}",
        nfc: "\u{C777}",
        nfd: "\u{110B}\u{1175}\u{11AA}",
        nfkc: "\u{C777}",
        nfkd: "\u{110B}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C778}",
        nfc: "\u{C778}",
        nfd: "\u{110B}\u{1175}\u{11AB}",
        nfkc: "\u{C778}",
        nfkd: "\u{110B}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C779}",
        nfc: "\u{C779}",
        nfd: "\u{110B}\u{1175}\u{11AC}",
        nfkc: "\u{C779}",
        nfkd: "\u{110B}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C77A}",
        nfc: "\u{C77A}",
        nfd: "\u{110B}\u{1175}\u{11AD}",
        nfkc: "\u{C77A}",
        nfkd: "\u{110B}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C77B}",
        nfc: "\u{C77B}",
        nfd: "\u{110B}\u{1175}\u{11AE}",
        nfkc: "\u{C77B}",
        nfkd: "\u{110B}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C77C}",
        nfc: "\u{C77C}",
        nfd: "\u{110B}\u{1175}\u{11AF}",
        nfkc: "\u{C77C}",
        nfkd: "\u{110B}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C77D}",
        nfc: "\u{C77D}",
        nfd: "\u{110B}\u{1175}\u{11B0}",
        nfkc: "\u{C77D}",
        nfkd: "\u{110B}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C77E}",
        nfc: "\u{C77E}",
        nfd: "\u{110B}\u{1175}\u{11B1}",
        nfkc: "\u{C77E}",
        nfkd: "\u{110B}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C77F}",
        nfc: "\u{C77F}",
        nfd: "\u{110B}\u{1175}\u{11B2}",
        nfkc: "\u{C77F}",
        nfkd: "\u{110B}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C780}",
        nfc: "\u{C780}",
        nfd: "\u{110B}\u{1175}\u{11B3}",
        nfkc: "\u{C780}",
        nfkd: "\u{110B}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C781}",
        nfc: "\u{C781}",
        nfd: "\u{110B}\u{1175}\u{11B4}",
        nfkc: "\u{C781}",
        nfkd: "\u{110B}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C782}",
        nfc: "\u{C782}",
        nfd: "\u{110B}\u{1175}\u{11B5}",
        nfkc: "\u{C782}",
        nfkd: "\u{110B}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C783}",
        nfc: "\u{C783}",
        nfd: "\u{110B}\u{1175}\u{11B6}",
        nfkc: "\u{C783}",
        nfkd: "\u{110B}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C784}",
        nfc: "\u{C784}",
        nfd: "\u{110B}\u{1175}\u{11B7}",
        nfkc: "\u{C784}",
        nfkd: "\u{110B}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C785}",
        nfc: "\u{C785}",
        nfd: "\u{110B}\u{1175}\u{11B8}",
        nfkc: "\u{C785}",
        nfkd: "\u{110B}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C786}",
        nfc: "\u{C786}",
        nfd: "\u{110B}\u{1175}\u{11B9}",
        nfkc: "\u{C786}",
        nfkd: "\u{110B}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C787}",
        nfc: "\u{C787}",
        nfd: "\u{110B}\u{1175}\u{11BA}",
        nfkc: "\u{C787}",
        nfkd: "\u{110B}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C788}",
        nfc: "\u{C788}",
        nfd: "\u{110B}\u{1175}\u{11BB}",
        nfkc: "\u{C788}",
        nfkd: "\u{110B}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C789}",
        nfc: "\u{C789}",
        nfd: "\u{110B}\u{1175}\u{11BC}",
        nfkc: "\u{C789}",
        nfkd: "\u{110B}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C78A}",
        nfc: "\u{C78A}",
        nfd: "\u{110B}\u{1175}\u{11BD}",
        nfkc: "\u{C78A}",
        nfkd: "\u{110B}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C78B}",
        nfc: "\u{C78B}",
        nfd: "\u{110B}\u{1175}\u{11BE}",
        nfkc: "\u{C78B}",
        nfkd: "\u{110B}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C78C}",
        nfc: "\u{C78C}",
        nfd: "\u{110B}\u{1175}\u{11BF}",
        nfkc: "\u{C78C}",
        nfkd: "\u{110B}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C78D}",
        nfc: "\u{C78D}",
        nfd: "\u{110B}\u{1175}\u{11C0}",
        nfkc: "\u{C78D}",
        nfkd: "\u{110B}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C78E}",
        nfc: "\u{C78E}",
        nfd: "\u{110B}\u{1175}\u{11C1}",
        nfkc: "\u{C78E}",
        nfkd: "\u{110B}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C78F}",
        nfc: "\u{C78F}",
        nfd: "\u{110B}\u{1175}\u{11C2}",
        nfkc: "\u{C78F}",
        nfkd: "\u{110B}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C790}",
        nfc: "\u{C790}",
        nfd: "\u{110C}\u{1161}",
        nfkc: "\u{C790}",
        nfkd: "\u{110C}\u{1161}",
    },
    NormalizationTest {
        source: "\u{C791}",
        nfc: "\u{C791}",
        nfd: "\u{110C}\u{1161}\u{11A8}",
        nfkc: "\u{C791}",
        nfkd: "\u{110C}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C792}",
        nfc: "\u{C792}",
        nfd: "\u{110C}\u{1161}\u{11A9}",
        nfkc: "\u{C792}",
        nfkd: "\u{110C}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C793}",
        nfc: "\u{C793}",
        nfd: "\u{110C}\u{1161}\u{11AA}",
        nfkc: "\u{C793}",
        nfkd: "\u{110C}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C794}",
        nfc: "\u{C794}",
        nfd: "\u{110C}\u{1161}\u{11AB}",
        nfkc: "\u{C794}",
        nfkd: "\u{110C}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C795}",
        nfc: "\u{C795}",
        nfd: "\u{110C}\u{1161}\u{11AC}",
        nfkc: "\u{C795}",
        nfkd: "\u{110C}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C796}",
        nfc: "\u{C796}",
        nfd: "\u{110C}\u{1161}\u{11AD}",
        nfkc: "\u{C796}",
        nfkd: "\u{110C}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C797}",
        nfc: "\u{C797}",
        nfd: "\u{110C}\u{1161}\u{11AE}",
        nfkc: "\u{C797}",
        nfkd: "\u{110C}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C798}",
        nfc: "\u{C798}",
        nfd: "\u{110C}\u{1161}\u{11AF}",
        nfkc: "\u{C798}",
        nfkd: "\u{110C}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C799}",
        nfc: "\u{C799}",
        nfd: "\u{110C}\u{1161}\u{11B0}",
        nfkc: "\u{C799}",
        nfkd: "\u{110C}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C79A}",
        nfc: "\u{C79A}",
        nfd: "\u{110C}\u{1161}\u{11B1}",
        nfkc: "\u{C79A}",
        nfkd: "\u{110C}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C79B}",
        nfc: "\u{C79B}",
        nfd: "\u{110C}\u{1161}\u{11B2}",
        nfkc: "\u{C79B}",
        nfkd: "\u{110C}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C79C}",
        nfc: "\u{C79C}",
        nfd: "\u{110C}\u{1161}\u{11B3}",
        nfkc: "\u{C79C}",
        nfkd: "\u{110C}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C79D}",
        nfc: "\u{C79D}",
        nfd: "\u{110C}\u{1161}\u{11B4}",
        nfkc: "\u{C79D}",
        nfkd: "\u{110C}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C79E}",
        nfc: "\u{C79E}",
        nfd: "\u{110C}\u{1161}\u{11B5}",
        nfkc: "\u{C79E}",
        nfkd: "\u{110C}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C79F}",
        nfc: "\u{C79F}",
        nfd: "\u{110C}\u{1161}\u{11B6}",
        nfkc: "\u{C79F}",
        nfkd: "\u{110C}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C7A0}",
        nfc: "\u{C7A0}",
        nfd: "\u{110C}\u{1161}\u{11B7}",
        nfkc: "\u{C7A0}",
        nfkd: "\u{110C}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C7A1}",
        nfc: "\u{C7A1}",
        nfd: "\u{110C}\u{1161}\u{11B8}",
        nfkc: "\u{C7A1}",
        nfkd: "\u{110C}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C7A2}",
        nfc: "\u{C7A2}",
        nfd: "\u{110C}\u{1161}\u{11B9}",
        nfkc: "\u{C7A2}",
        nfkd: "\u{110C}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C7A3}",
        nfc: "\u{C7A3}",
        nfd: "\u{110C}\u{1161}\u{11BA}",
        nfkc: "\u{C7A3}",
        nfkd: "\u{110C}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C7A4}",
        nfc: "\u{C7A4}",
        nfd: "\u{110C}\u{1161}\u{11BB}",
        nfkc: "\u{C7A4}",
        nfkd: "\u{110C}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C7A5}",
        nfc: "\u{C7A5}",
        nfd: "\u{110C}\u{1161}\u{11BC}",
        nfkc: "\u{C7A5}",
        nfkd: "\u{110C}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C7A6}",
        nfc: "\u{C7A6}",
        nfd: "\u{110C}\u{1161}\u{11BD}",
        nfkc: "\u{C7A6}",
        nfkd: "\u{110C}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C7A7}",
        nfc: "\u{C7A7}",
        nfd: "\u{110C}\u{1161}\u{11BE}",
        nfkc: "\u{C7A7}",
        nfkd: "\u{110C}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C7A8}",
        nfc: "\u{C7A8}",
        nfd: "\u{110C}\u{1161}\u{11BF}",
        nfkc: "\u{C7A8}",
        nfkd: "\u{110C}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C7A9}",
        nfc: "\u{C7A9}",
        nfd: "\u{110C}\u{1161}\u{11C0}",
        nfkc: "\u{C7A9}",
        nfkd: "\u{110C}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C7AA}",
        nfc: "\u{C7AA}",
        nfd: "\u{110C}\u{1161}\u{11C1}",
        nfkc: "\u{C7AA}",
        nfkd: "\u{110C}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C7AB}",
        nfc: "\u{C7AB}",
        nfd: "\u{110C}\u{1161}\u{11C2}",
        nfkc: "\u{C7AB}",
        nfkd: "\u{110C}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C7AC}",
        nfc: "\u{C7AC}",
        nfd: "\u{110C}\u{1162}",
        nfkc: "\u{C7AC}",
        nfkd: "\u{110C}\u{1162}",
    },
    NormalizationTest {
        source: "\u{C7AD}",
        nfc: "\u{C7AD}",
        nfd: "\u{110C}\u{1162}\u{11A8}",
        nfkc: "\u{C7AD}",
        nfkd: "\u{110C}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C7AE}",
        nfc: "\u{C7AE}",
        nfd: "\u{110C}\u{1162}\u{11A9}",
        nfkc: "\u{C7AE}",
        nfkd: "\u{110C}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C7AF}",
        nfc: "\u{C7AF}",
        nfd: "\u{110C}\u{1162}\u{11AA}",
        nfkc: "\u{C7AF}",
        nfkd: "\u{110C}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C7B0}",
        nfc: "\u{C7B0}",
        nfd: "\u{110C}\u{1162}\u{11AB}",
        nfkc: "\u{C7B0}",
        nfkd: "\u{110C}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C7B1}",
        nfc: "\u{C7B1}",
        nfd: "\u{110C}\u{1162}\u{11AC}",
        nfkc: "\u{C7B1}",
        nfkd: "\u{110C}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C7B2}",
        nfc: "\u{C7B2}",
        nfd: "\u{110C}\u{1162}\u{11AD}",
        nfkc: "\u{C7B2}",
        nfkd: "\u{110C}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C7B3}",
        nfc: "\u{C7B3}",
        nfd: "\u{110C}\u{1162}\u{11AE}",
        nfkc: "\u{C7B3}",
        nfkd: "\u{110C}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C7B4}",
        nfc: "\u{C7B4}",
        nfd: "\u{110C}\u{1162}\u{11AF}",
        nfkc: "\u{C7B4}",
        nfkd: "\u{110C}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C7B5}",
        nfc: "\u{C7B5}",
        nfd: "\u{110C}\u{1162}\u{11B0}",
        nfkc: "\u{C7B5}",
        nfkd: "\u{110C}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C7B6}",
        nfc: "\u{C7B6}",
        nfd: "\u{110C}\u{1162}\u{11B1}",
        nfkc: "\u{C7B6}",
        nfkd: "\u{110C}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C7B7}",
        nfc: "\u{C7B7}",
        nfd: "\u{110C}\u{1162}\u{11B2}",
        nfkc: "\u{C7B7}",
        nfkd: "\u{110C}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C7B8}",
        nfc: "\u{C7B8}",
        nfd: "\u{110C}\u{1162}\u{11B3}",
        nfkc: "\u{C7B8}",
        nfkd: "\u{110C}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C7B9}",
        nfc: "\u{C7B9}",
        nfd: "\u{110C}\u{1162}\u{11B4}",
        nfkc: "\u{C7B9}",
        nfkd: "\u{110C}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C7BA}",
        nfc: "\u{C7BA}",
        nfd: "\u{110C}\u{1162}\u{11B5}",
        nfkc: "\u{C7BA}",
        nfkd: "\u{110C}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C7BB}",
        nfc: "\u{C7BB}",
        nfd: "\u{110C}\u{1162}\u{11B6}",
        nfkc: "\u{C7BB}",
        nfkd: "\u{110C}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C7BC}",
        nfc: "\u{C7BC}",
        nfd: "\u{110C}\u{1162}\u{11B7}",
        nfkc: "\u{C7BC}",
        nfkd: "\u{110C}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C7BD}",
        nfc: "\u{C7BD}",
        nfd: "\u{110C}\u{1162}\u{11B8}",
        nfkc: "\u{C7BD}",
        nfkd: "\u{110C}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C7BE}",
        nfc: "\u{C7BE}",
        nfd: "\u{110C}\u{1162}\u{11B9}",
        nfkc: "\u{C7BE}",
        nfkd: "\u{110C}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C7BF}",
        nfc: "\u{C7BF}",
        nfd: "\u{110C}\u{1162}\u{11BA}",
        nfkc: "\u{C7BF}",
        nfkd: "\u{110C}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C7C0}",
        nfc: "\u{C7C0}",
        nfd: "\u{110C}\u{1162}\u{11BB}",
        nfkc: "\u{C7C0}",
        nfkd: "\u{110C}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C7C1}",
        nfc: "\u{C7C1}",
        nfd: "\u{110C}\u{1162}\u{11BC}",
        nfkc: "\u{C7C1}",
        nfkd: "\u{110C}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C7C2}",
        nfc: "\u{C7C2}",
        nfd: "\u{110C}\u{1162}\u{11BD}",
        nfkc: "\u{C7C2}",
        nfkd: "\u{110C}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C7C3}",
        nfc: "\u{C7C3}",
        nfd: "\u{110C}\u{1162}\u{11BE}",
        nfkc: "\u{C7C3}",
        nfkd: "\u{110C}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C7C4}",
        nfc: "\u{C7C4}",
        nfd: "\u{110C}\u{1162}\u{11BF}",
        nfkc: "\u{C7C4}",
        nfkd: "\u{110C}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C7C5}",
        nfc: "\u{C7C5}",
        nfd: "\u{110C}\u{1162}\u{11C0}",
        nfkc: "\u{C7C5}",
        nfkd: "\u{110C}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C7C6}",
        nfc: "\u{C7C6}",
        nfd: "\u{110C}\u{1162}\u{11C1}",
        nfkc: "\u{C7C6}",
        nfkd: "\u{110C}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C7C7}",
        nfc: "\u{C7C7}",
        nfd: "\u{110C}\u{1162}\u{11C2}",
        nfkc: "\u{C7C7}",
        nfkd: "\u{110C}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C7C8}",
        nfc: "\u{C7C8}",
        nfd: "\u{110C}\u{1163}",
        nfkc: "\u{C7C8}",
        nfkd: "\u{110C}\u{1163}",
    },
    NormalizationTest {
        source: "\u{C7C9}",
        nfc: "\u{C7C9}",
        nfd: "\u{110C}\u{1163}\u{11A8}",
        nfkc: "\u{C7C9}",
        nfkd: "\u{110C}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C7CA}",
        nfc: "\u{C7CA}",
        nfd: "\u{110C}\u{1163}\u{11A9}",
        nfkc: "\u{C7CA}",
        nfkd: "\u{110C}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C7CB}",
        nfc: "\u{C7CB}",
        nfd: "\u{110C}\u{1163}\u{11AA}",
        nfkc: "\u{C7CB}",
        nfkd: "\u{110C}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C7CC}",
        nfc: "\u{C7CC}",
        nfd: "\u{110C}\u{1163}\u{11AB}",
        nfkc: "\u{C7CC}",
        nfkd: "\u{110C}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C7CD}",
        nfc: "\u{C7CD}",
        nfd: "\u{110C}\u{1163}\u{11AC}",
        nfkc: "\u{C7CD}",
        nfkd: "\u{110C}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C7CE}",
        nfc: "\u{C7CE}",
        nfd: "\u{110C}\u{1163}\u{11AD}",
        nfkc: "\u{C7CE}",
        nfkd: "\u{110C}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C7CF}",
        nfc: "\u{C7CF}",
        nfd: "\u{110C}\u{1163}\u{11AE}",
        nfkc: "\u{C7CF}",
        nfkd: "\u{110C}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C7D0}",
        nfc: "\u{C7D0}",
        nfd: "\u{110C}\u{1163}\u{11AF}",
        nfkc: "\u{C7D0}",
        nfkd: "\u{110C}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C7D1}",
        nfc: "\u{C7D1}",
        nfd: "\u{110C}\u{1163}\u{11B0}",
        nfkc: "\u{C7D1}",
        nfkd: "\u{110C}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C7D2}",
        nfc: "\u{C7D2}",
        nfd: "\u{110C}\u{1163}\u{11B1}",
        nfkc: "\u{C7D2}",
        nfkd: "\u{110C}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C7D3}",
        nfc: "\u{C7D3}",
        nfd: "\u{110C}\u{1163}\u{11B2}",
        nfkc: "\u{C7D3}",
        nfkd: "\u{110C}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C7D4}",
        nfc: "\u{C7D4}",
        nfd: "\u{110C}\u{1163}\u{11B3}",
        nfkc: "\u{C7D4}",
        nfkd: "\u{110C}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C7D5}",
        nfc: "\u{C7D5}",
        nfd: "\u{110C}\u{1163}\u{11B4}",
        nfkc: "\u{C7D5}",
        nfkd: "\u{110C}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C7D6}",
        nfc: "\u{C7D6}",
        nfd: "\u{110C}\u{1163}\u{11B5}",
        nfkc: "\u{C7D6}",
        nfkd: "\u{110C}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C7D7}",
        nfc: "\u{C7D7}",
        nfd: "\u{110C}\u{1163}\u{11B6}",
        nfkc: "\u{C7D7}",
        nfkd: "\u{110C}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C7D8}",
        nfc: "\u{C7D8}",
        nfd: "\u{110C}\u{1163}\u{11B7}",
        nfkc: "\u{C7D8}",
        nfkd: "\u{110C}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C7D9}",
        nfc: "\u{C7D9}",
        nfd: "\u{110C}\u{1163}\u{11B8}",
        nfkc: "\u{C7D9}",
        nfkd: "\u{110C}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C7DA}",
        nfc: "\u{C7DA}",
        nfd: "\u{110C}\u{1163}\u{11B9}",
        nfkc: "\u{C7DA}",
        nfkd: "\u{110C}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C7DB}",
        nfc: "\u{C7DB}",
        nfd: "\u{110C}\u{1163}\u{11BA}",
        nfkc: "\u{C7DB}",
        nfkd: "\u{110C}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C7DC}",
        nfc: "\u{C7DC}",
        nfd: "\u{110C}\u{1163}\u{11BB}",
        nfkc: "\u{C7DC}",
        nfkd: "\u{110C}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C7DD}",
        nfc: "\u{C7DD}",
        nfd: "\u{110C}\u{1163}\u{11BC}",
        nfkc: "\u{C7DD}",
        nfkd: "\u{110C}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C7DE}",
        nfc: "\u{C7DE}",
        nfd: "\u{110C}\u{1163}\u{11BD}",
        nfkc: "\u{C7DE}",
        nfkd: "\u{110C}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C7DF}",
        nfc: "\u{C7DF}",
        nfd: "\u{110C}\u{1163}\u{11BE}",
        nfkc: "\u{C7DF}",
        nfkd: "\u{110C}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C7E0}",
        nfc: "\u{C7E0}",
        nfd: "\u{110C}\u{1163}\u{11BF}",
        nfkc: "\u{C7E0}",
        nfkd: "\u{110C}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C7E1}",
        nfc: "\u{C7E1}",
        nfd: "\u{110C}\u{1163}\u{11C0}",
        nfkc: "\u{C7E1}",
        nfkd: "\u{110C}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C7E2}",
        nfc: "\u{C7E2}",
        nfd: "\u{110C}\u{1163}\u{11C1}",
        nfkc: "\u{C7E2}",
        nfkd: "\u{110C}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C7E3}",
        nfc: "\u{C7E3}",
        nfd: "\u{110C}\u{1163}\u{11C2}",
        nfkc: "\u{C7E3}",
        nfkd: "\u{110C}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C7E4}",
        nfc: "\u{C7E4}",
        nfd: "\u{110C}\u{1164}",
        nfkc: "\u{C7E4}",
        nfkd: "\u{110C}\u{1164}",
    },
    NormalizationTest {
        source: "\u{C7E5}",
        nfc: "\u{C7E5}",
        nfd: "\u{110C}\u{1164}\u{11A8}",
        nfkc: "\u{C7E5}",
        nfkd: "\u{110C}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C7E6}",
        nfc: "\u{C7E6}",
        nfd: "\u{110C}\u{1164}\u{11A9}",
        nfkc: "\u{C7E6}",
        nfkd: "\u{110C}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C7E7}",
        nfc: "\u{C7E7}",
        nfd: "\u{110C}\u{1164}\u{11AA}",
        nfkc: "\u{C7E7}",
        nfkd: "\u{110C}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C7E8}",
        nfc: "\u{C7E8}",
        nfd: "\u{110C}\u{1164}\u{11AB}",
        nfkc: "\u{C7E8}",
        nfkd: "\u{110C}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C7E9}",
        nfc: "\u{C7E9}",
        nfd: "\u{110C}\u{1164}\u{11AC}",
        nfkc: "\u{C7E9}",
        nfkd: "\u{110C}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C7EA}",
        nfc: "\u{C7EA}",
        nfd: "\u{110C}\u{1164}\u{11AD}",
        nfkc: "\u{C7EA}",
        nfkd: "\u{110C}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C7EB}",
        nfc: "\u{C7EB}",
        nfd: "\u{110C}\u{1164}\u{11AE}",
        nfkc: "\u{C7EB}",
        nfkd: "\u{110C}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C7EC}",
        nfc: "\u{C7EC}",
        nfd: "\u{110C}\u{1164}\u{11AF}",
        nfkc: "\u{C7EC}",
        nfkd: "\u{110C}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C7ED}",
        nfc: "\u{C7ED}",
        nfd: "\u{110C}\u{1164}\u{11B0}",
        nfkc: "\u{C7ED}",
        nfkd: "\u{110C}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C7EE}",
        nfc: "\u{C7EE}",
        nfd: "\u{110C}\u{1164}\u{11B1}",
        nfkc: "\u{C7EE}",
        nfkd: "\u{110C}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C7EF}",
        nfc: "\u{C7EF}",
        nfd: "\u{110C}\u{1164}\u{11B2}",
        nfkc: "\u{C7EF}",
        nfkd: "\u{110C}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C7F0}",
        nfc: "\u{C7F0}",
        nfd: "\u{110C}\u{1164}\u{11B3}",
        nfkc: "\u{C7F0}",
        nfkd: "\u{110C}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C7F1}",
        nfc: "\u{C7F1}",
        nfd: "\u{110C}\u{1164}\u{11B4}",
        nfkc: "\u{C7F1}",
        nfkd: "\u{110C}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C7F2}",
        nfc: "\u{C7F2}",
        nfd: "\u{110C}\u{1164}\u{11B5}",
        nfkc: "\u{C7F2}",
        nfkd: "\u{110C}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C7F3}",
        nfc: "\u{C7F3}",
        nfd: "\u{110C}\u{1164}\u{11B6}",
        nfkc: "\u{C7F3}",
        nfkd: "\u{110C}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C7F4}",
        nfc: "\u{C7F4}",
        nfd: "\u{110C}\u{1164}\u{11B7}",
        nfkc: "\u{C7F4}",
        nfkd: "\u{110C}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C7F5}",
        nfc: "\u{C7F5}",
        nfd: "\u{110C}\u{1164}\u{11B8}",
        nfkc: "\u{C7F5}",
        nfkd: "\u{110C}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C7F6}",
        nfc: "\u{C7F6}",
        nfd: "\u{110C}\u{1164}\u{11B9}",
        nfkc: "\u{C7F6}",
        nfkd: "\u{110C}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C7F7}",
        nfc: "\u{C7F7}",
        nfd: "\u{110C}\u{1164}\u{11BA}",
        nfkc: "\u{C7F7}",
        nfkd: "\u{110C}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C7F8}",
        nfc: "\u{C7F8}",
        nfd: "\u{110C}\u{1164}\u{11BB}",
        nfkc: "\u{C7F8}",
        nfkd: "\u{110C}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C7F9}",
        nfc: "\u{C7F9}",
        nfd: "\u{110C}\u{1164}\u{11BC}",
        nfkc: "\u{C7F9}",
        nfkd: "\u{110C}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C7FA}",
        nfc: "\u{C7FA}",
        nfd: "\u{110C}\u{1164}\u{11BD}",
        nfkc: "\u{C7FA}",
        nfkd: "\u{110C}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C7FB}",
        nfc: "\u{C7FB}",
        nfd: "\u{110C}\u{1164}\u{11BE}",
        nfkc: "\u{C7FB}",
        nfkd: "\u{110C}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C7FC}",
        nfc: "\u{C7FC}",
        nfd: "\u{110C}\u{1164}\u{11BF}",
        nfkc: "\u{C7FC}",
        nfkd: "\u{110C}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C7FD}",
        nfc: "\u{C7FD}",
        nfd: "\u{110C}\u{1164}\u{11C0}",
        nfkc: "\u{C7FD}",
        nfkd: "\u{110C}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C7FE}",
        nfc: "\u{C7FE}",
        nfd: "\u{110C}\u{1164}\u{11C1}",
        nfkc: "\u{C7FE}",
        nfkd: "\u{110C}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C7FF}",
        nfc: "\u{C7FF}",
        nfd: "\u{110C}\u{1164}\u{11C2}",
        nfkc: "\u{C7FF}",
        nfkd: "\u{110C}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C800}",
        nfc: "\u{C800}",
        nfd: "\u{110C}\u{1165}",
        nfkc: "\u{C800}",
        nfkd: "\u{110C}\u{1165}",
    },
    NormalizationTest {
        source: "\u{C801}",
        nfc: "\u{C801}",
        nfd: "\u{110C}\u{1165}\u{11A8}",
        nfkc: "\u{C801}",
        nfkd: "\u{110C}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C802}",
        nfc: "\u{C802}",
        nfd: "\u{110C}\u{1165}\u{11A9}",
        nfkc: "\u{C802}",
        nfkd: "\u{110C}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C803}",
        nfc: "\u{C803}",
        nfd: "\u{110C}\u{1165}\u{11AA}",
        nfkc: "\u{C803}",
        nfkd: "\u{110C}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C804}",
        nfc: "\u{C804}",
        nfd: "\u{110C}\u{1165}\u{11AB}",
        nfkc: "\u{C804}",
        nfkd: "\u{110C}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C805}",
        nfc: "\u{C805}",
        nfd: "\u{110C}\u{1165}\u{11AC}",
        nfkc: "\u{C805}",
        nfkd: "\u{110C}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C806}",
        nfc: "\u{C806}",
        nfd: "\u{110C}\u{1165}\u{11AD}",
        nfkc: "\u{C806}",
        nfkd: "\u{110C}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C807}",
        nfc: "\u{C807}",
        nfd: "\u{110C}\u{1165}\u{11AE}",
        nfkc: "\u{C807}",
        nfkd: "\u{110C}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C808}",
        nfc: "\u{C808}",
        nfd: "\u{110C}\u{1165}\u{11AF}",
        nfkc: "\u{C808}",
        nfkd: "\u{110C}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C809}",
        nfc: "\u{C809}",
        nfd: "\u{110C}\u{1165}\u{11B0}",
        nfkc: "\u{C809}",
        nfkd: "\u{110C}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C80A}",
        nfc: "\u{C80A}",
        nfd: "\u{110C}\u{1165}\u{11B1}",
        nfkc: "\u{C80A}",
        nfkd: "\u{110C}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C80B}",
        nfc: "\u{C80B}",
        nfd: "\u{110C}\u{1165}\u{11B2}",
        nfkc: "\u{C80B}",
        nfkd: "\u{110C}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C80C}",
        nfc: "\u{C80C}",
        nfd: "\u{110C}\u{1165}\u{11B3}",
        nfkc: "\u{C80C}",
        nfkd: "\u{110C}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C80D}",
        nfc: "\u{C80D}",
        nfd: "\u{110C}\u{1165}\u{11B4}",
        nfkc: "\u{C80D}",
        nfkd: "\u{110C}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C80E}",
        nfc: "\u{C80E}",
        nfd: "\u{110C}\u{1165}\u{11B5}",
        nfkc: "\u{C80E}",
        nfkd: "\u{110C}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C80F}",
        nfc: "\u{C80F}",
        nfd: "\u{110C}\u{1165}\u{11B6}",
        nfkc: "\u{C80F}",
        nfkd: "\u{110C}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C810}",
        nfc: "\u{C810}",
        nfd: "\u{110C}\u{1165}\u{11B7}",
        nfkc: "\u{C810}",
        nfkd: "\u{110C}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C811}",
        nfc: "\u{C811}",
        nfd: "\u{110C}\u{1165}\u{11B8}",
        nfkc: "\u{C811}",
        nfkd: "\u{110C}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C812}",
        nfc: "\u{C812}",
        nfd: "\u{110C}\u{1165}\u{11B9}",
        nfkc: "\u{C812}",
        nfkd: "\u{110C}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C813}",
        nfc: "\u{C813}",
        nfd: "\u{110C}\u{1165}\u{11BA}",
        nfkc: "\u{C813}",
        nfkd: "\u{110C}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C814}",
        nfc: "\u{C814}",
        nfd: "\u{110C}\u{1165}\u{11BB}",
        nfkc: "\u{C814}",
        nfkd: "\u{110C}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C815}",
        nfc: "\u{C815}",
        nfd: "\u{110C}\u{1165}\u{11BC}",
        nfkc: "\u{C815}",
        nfkd: "\u{110C}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C816}",
        nfc: "\u{C816}",
        nfd: "\u{110C}\u{1165}\u{11BD}",
        nfkc: "\u{C816}",
        nfkd: "\u{110C}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C817}",
        nfc: "\u{C817}",
        nfd: "\u{110C}\u{1165}\u{11BE}",
        nfkc: "\u{C817}",
        nfkd: "\u{110C}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C818}",
        nfc: "\u{C818}",
        nfd: "\u{110C}\u{1165}\u{11BF}",
        nfkc: "\u{C818}",
        nfkd: "\u{110C}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C819}",
        nfc: "\u{C819}",
        nfd: "\u{110C}\u{1165}\u{11C0}",
        nfkc: "\u{C819}",
        nfkd: "\u{110C}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C81A}",
        nfc: "\u{C81A}",
        nfd: "\u{110C}\u{1165}\u{11C1}",
        nfkc: "\u{C81A}",
        nfkd: "\u{110C}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C81B}",
        nfc: "\u{C81B}",
        nfd: "\u{110C}\u{1165}\u{11C2}",
        nfkc: "\u{C81B}",
        nfkd: "\u{110C}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C81C}",
        nfc: "\u{C81C}",
        nfd: "\u{110C}\u{1166}",
        nfkc: "\u{C81C}",
        nfkd: "\u{110C}\u{1166}",
    },
    NormalizationTest {
        source: "\u{C81D}",
        nfc: "\u{C81D}",
        nfd: "\u{110C}\u{1166}\u{11A8}",
        nfkc: "\u{C81D}",
        nfkd: "\u{110C}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C81E}",
        nfc: "\u{C81E}",
        nfd: "\u{110C}\u{1166}\u{11A9}",
        nfkc: "\u{C81E}",
        nfkd: "\u{110C}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C81F}",
        nfc: "\u{C81F}",
        nfd: "\u{110C}\u{1166}\u{11AA}",
        nfkc: "\u{C81F}",
        nfkd: "\u{110C}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C820}",
        nfc: "\u{C820}",
        nfd: "\u{110C}\u{1166}\u{11AB}",
        nfkc: "\u{C820}",
        nfkd: "\u{110C}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C821}",
        nfc: "\u{C821}",
        nfd: "\u{110C}\u{1166}\u{11AC}",
        nfkc: "\u{C821}",
        nfkd: "\u{110C}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C822}",
        nfc: "\u{C822}",
        nfd: "\u{110C}\u{1166}\u{11AD}",
        nfkc: "\u{C822}",
        nfkd: "\u{110C}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C823}",
        nfc: "\u{C823}",
        nfd: "\u{110C}\u{1166}\u{11AE}",
        nfkc: "\u{C823}",
        nfkd: "\u{110C}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C824}",
        nfc: "\u{C824}",
        nfd: "\u{110C}\u{1166}\u{11AF}",
        nfkc: "\u{C824}",
        nfkd: "\u{110C}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C825}",
        nfc: "\u{C825}",
        nfd: "\u{110C}\u{1166}\u{11B0}",
        nfkc: "\u{C825}",
        nfkd: "\u{110C}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C826}",
        nfc: "\u{C826}",
        nfd: "\u{110C}\u{1166}\u{11B1}",
        nfkc: "\u{C826}",
        nfkd: "\u{110C}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C827}",
        nfc: "\u{C827}",
        nfd: "\u{110C}\u{1166}\u{11B2}",
        nfkc: "\u{C827}",
        nfkd: "\u{110C}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C828}",
        nfc: "\u{C828}",
        nfd: "\u{110C}\u{1166}\u{11B3}",
        nfkc: "\u{C828}",
        nfkd: "\u{110C}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C829}",
        nfc: "\u{C829}",
        nfd: "\u{110C}\u{1166}\u{11B4}",
        nfkc: "\u{C829}",
        nfkd: "\u{110C}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C82A}",
        nfc: "\u{C82A}",
        nfd: "\u{110C}\u{1166}\u{11B5}",
        nfkc: "\u{C82A}",
        nfkd: "\u{110C}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C82B}",
        nfc: "\u{C82B}",
        nfd: "\u{110C}\u{1166}\u{11B6}",
        nfkc: "\u{C82B}",
        nfkd: "\u{110C}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C82C}",
        nfc: "\u{C82C}",
        nfd: "\u{110C}\u{1166}\u{11B7}",
        nfkc: "\u{C82C}",
        nfkd: "\u{110C}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C82D}",
        nfc: "\u{C82D}",
        nfd: "\u{110C}\u{1166}\u{11B8}",
        nfkc: "\u{C82D}",
        nfkd: "\u{110C}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C82E}",
        nfc: "\u{C82E}",
        nfd: "\u{110C}\u{1166}\u{11B9}",
        nfkc: "\u{C82E}",
        nfkd: "\u{110C}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C82F}",
        nfc: "\u{C82F}",
        nfd: "\u{110C}\u{1166}\u{11BA}",
        nfkc: "\u{C82F}",
        nfkd: "\u{110C}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C830}",
        nfc: "\u{C830}",
        nfd: "\u{110C}\u{1166}\u{11BB}",
        nfkc: "\u{C830}",
        nfkd: "\u{110C}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C831}",
        nfc: "\u{C831}",
        nfd: "\u{110C}\u{1166}\u{11BC}",
        nfkc: "\u{C831}",
        nfkd: "\u{110C}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C832}",
        nfc: "\u{C832}",
        nfd: "\u{110C}\u{1166}\u{11BD}",
        nfkc: "\u{C832}",
        nfkd: "\u{110C}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C833}",
        nfc: "\u{C833}",
        nfd: "\u{110C}\u{1166}\u{11BE}",
        nfkc: "\u{C833}",
        nfkd: "\u{110C}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C834}",
        nfc: "\u{C834}",
        nfd: "\u{110C}\u{1166}\u{11BF}",
        nfkc: "\u{C834}",
        nfkd: "\u{110C}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C835}",
        nfc: "\u{C835}",
        nfd: "\u{110C}\u{1166}\u{11C0}",
        nfkc: "\u{C835}",
        nfkd: "\u{110C}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C836}",
        nfc: "\u{C836}",
        nfd: "\u{110C}\u{1166}\u{11C1}",
        nfkc: "\u{C836}",
        nfkd: "\u{110C}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C837}",
        nfc: "\u{C837}",
        nfd: "\u{110C}\u{1166}\u{11C2}",
        nfkc: "\u{C837}",
        nfkd: "\u{110C}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C838}",
        nfc: "\u{C838}",
        nfd: "\u{110C}\u{1167}",
        nfkc: "\u{C838}",
        nfkd: "\u{110C}\u{1167}",
    },
    NormalizationTest {
        source: "\u{C839}",
        nfc: "\u{C839}",
        nfd: "\u{110C}\u{1167}\u{11A8}",
        nfkc: "\u{C839}",
        nfkd: "\u{110C}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C83A}",
        nfc: "\u{C83A}",
        nfd: "\u{110C}\u{1167}\u{11A9}",
        nfkc: "\u{C83A}",
        nfkd: "\u{110C}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C83B}",
        nfc: "\u{C83B}",
        nfd: "\u{110C}\u{1167}\u{11AA}",
        nfkc: "\u{C83B}",
        nfkd: "\u{110C}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C83C}",
        nfc: "\u{C83C}",
        nfd: "\u{110C}\u{1167}\u{11AB}",
        nfkc: "\u{C83C}",
        nfkd: "\u{110C}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C83D}",
        nfc: "\u{C83D}",
        nfd: "\u{110C}\u{1167}\u{11AC}",
        nfkc: "\u{C83D}",
        nfkd: "\u{110C}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C83E}",
        nfc: "\u{C83E}",
        nfd: "\u{110C}\u{1167}\u{11AD}",
        nfkc: "\u{C83E}",
        nfkd: "\u{110C}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C83F}",
        nfc: "\u{C83F}",
        nfd: "\u{110C}\u{1167}\u{11AE}",
        nfkc: "\u{C83F}",
        nfkd: "\u{110C}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C840}",
        nfc: "\u{C840}",
        nfd: "\u{110C}\u{1167}\u{11AF}",
        nfkc: "\u{C840}",
        nfkd: "\u{110C}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C841}",
        nfc: "\u{C841}",
        nfd: "\u{110C}\u{1167}\u{11B0}",
        nfkc: "\u{C841}",
        nfkd: "\u{110C}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C842}",
        nfc: "\u{C842}",
        nfd: "\u{110C}\u{1167}\u{11B1}",
        nfkc: "\u{C842}",
        nfkd: "\u{110C}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C843}",
        nfc: "\u{C843}",
        nfd: "\u{110C}\u{1167}\u{11B2}",
        nfkc: "\u{C843}",
        nfkd: "\u{110C}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C844}",
        nfc: "\u{C844}",
        nfd: "\u{110C}\u{1167}\u{11B3}",
        nfkc: "\u{C844}",
        nfkd: "\u{110C}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C845}",
        nfc: "\u{C845}",
        nfd: "\u{110C}\u{1167}\u{11B4}",
        nfkc: "\u{C845}",
        nfkd: "\u{110C}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C846}",
        nfc: "\u{C846}",
        nfd: "\u{110C}\u{1167}\u{11B5}",
        nfkc: "\u{C846}",
        nfkd: "\u{110C}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C847}",
        nfc: "\u{C847}",
        nfd: "\u{110C}\u{1167}\u{11B6}",
        nfkc: "\u{C847}",
        nfkd: "\u{110C}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C848}",
        nfc: "\u{C848}",
        nfd: "\u{110C}\u{1167}\u{11B7}",
        nfkc: "\u{C848}",
        nfkd: "\u{110C}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C849}",
        nfc: "\u{C849}",
        nfd: "\u{110C}\u{1167}\u{11B8}",
        nfkc: "\u{C849}",
        nfkd: "\u{110C}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C84A}",
        nfc: "\u{C84A}",
        nfd: "\u{110C}\u{1167}\u{11B9}",
        nfkc: "\u{C84A}",
        nfkd: "\u{110C}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C84B}",
        nfc: "\u{C84B}",
        nfd: "\u{110C}\u{1167}\u{11BA}",
        nfkc: "\u{C84B}",
        nfkd: "\u{110C}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C84C}",
        nfc: "\u{C84C}",
        nfd: "\u{110C}\u{1167}\u{11BB}",
        nfkc: "\u{C84C}",
        nfkd: "\u{110C}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C84D}",
        nfc: "\u{C84D}",
        nfd: "\u{110C}\u{1167}\u{11BC}",
        nfkc: "\u{C84D}",
        nfkd: "\u{110C}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C84E}",
        nfc: "\u{C84E}",
        nfd: "\u{110C}\u{1167}\u{11BD}",
        nfkc: "\u{C84E}",
        nfkd: "\u{110C}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C84F}",
        nfc: "\u{C84F}",
        nfd: "\u{110C}\u{1167}\u{11BE}",
        nfkc: "\u{C84F}",
        nfkd: "\u{110C}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C850}",
        nfc: "\u{C850}",
        nfd: "\u{110C}\u{1167}\u{11BF}",
        nfkc: "\u{C850}",
        nfkd: "\u{110C}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C851}",
        nfc: "\u{C851}",
        nfd: "\u{110C}\u{1167}\u{11C0}",
        nfkc: "\u{C851}",
        nfkd: "\u{110C}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C852}",
        nfc: "\u{C852}",
        nfd: "\u{110C}\u{1167}\u{11C1}",
        nfkc: "\u{C852}",
        nfkd: "\u{110C}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C853}",
        nfc: "\u{C853}",
        nfd: "\u{110C}\u{1167}\u{11C2}",
        nfkc: "\u{C853}",
        nfkd: "\u{110C}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C854}",
        nfc: "\u{C854}",
        nfd: "\u{110C}\u{1168}",
        nfkc: "\u{C854}",
        nfkd: "\u{110C}\u{1168}",
    },
    NormalizationTest {
        source: "\u{C855}",
        nfc: "\u{C855}",
        nfd: "\u{110C}\u{1168}\u{11A8}",
        nfkc: "\u{C855}",
        nfkd: "\u{110C}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C856}",
        nfc: "\u{C856}",
        nfd: "\u{110C}\u{1168}\u{11A9}",
        nfkc: "\u{C856}",
        nfkd: "\u{110C}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C857}",
        nfc: "\u{C857}",
        nfd: "\u{110C}\u{1168}\u{11AA}",
        nfkc: "\u{C857}",
        nfkd: "\u{110C}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C858}",
        nfc: "\u{C858}",
        nfd: "\u{110C}\u{1168}\u{11AB}",
        nfkc: "\u{C858}",
        nfkd: "\u{110C}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C859}",
        nfc: "\u{C859}",
        nfd: "\u{110C}\u{1168}\u{11AC}",
        nfkc: "\u{C859}",
        nfkd: "\u{110C}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C85A}",
        nfc: "\u{C85A}",
        nfd: "\u{110C}\u{1168}\u{11AD}",
        nfkc: "\u{C85A}",
        nfkd: "\u{110C}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C85B}",
        nfc: "\u{C85B}",
        nfd: "\u{110C}\u{1168}\u{11AE}",
        nfkc: "\u{C85B}",
        nfkd: "\u{110C}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C85C}",
        nfc: "\u{C85C}",
        nfd: "\u{110C}\u{1168}\u{11AF}",
        nfkc: "\u{C85C}",
        nfkd: "\u{110C}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C85D}",
        nfc: "\u{C85D}",
        nfd: "\u{110C}\u{1168}\u{11B0}",
        nfkc: "\u{C85D}",
        nfkd: "\u{110C}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C85E}",
        nfc: "\u{C85E}",
        nfd: "\u{110C}\u{1168}\u{11B1}",
        nfkc: "\u{C85E}",
        nfkd: "\u{110C}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C85F}",
        nfc: "\u{C85F}",
        nfd: "\u{110C}\u{1168}\u{11B2}",
        nfkc: "\u{C85F}",
        nfkd: "\u{110C}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C860}",
        nfc: "\u{C860}",
        nfd: "\u{110C}\u{1168}\u{11B3}",
        nfkc: "\u{C860}",
        nfkd: "\u{110C}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C861}",
        nfc: "\u{C861}",
        nfd: "\u{110C}\u{1168}\u{11B4}",
        nfkc: "\u{C861}",
        nfkd: "\u{110C}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C862}",
        nfc: "\u{C862}",
        nfd: "\u{110C}\u{1168}\u{11B5}",
        nfkc: "\u{C862}",
        nfkd: "\u{110C}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C863}",
        nfc: "\u{C863}",
        nfd: "\u{110C}\u{1168}\u{11B6}",
        nfkc: "\u{C863}",
        nfkd: "\u{110C}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C864}",
        nfc: "\u{C864}",
        nfd: "\u{110C}\u{1168}\u{11B7}",
        nfkc: "\u{C864}",
        nfkd: "\u{110C}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C865}",
        nfc: "\u{C865}",
        nfd: "\u{110C}\u{1168}\u{11B8}",
        nfkc: "\u{C865}",
        nfkd: "\u{110C}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C866}",
        nfc: "\u{C866}",
        nfd: "\u{110C}\u{1168}\u{11B9}",
        nfkc: "\u{C866}",
        nfkd: "\u{110C}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C867}",
        nfc: "\u{C867}",
        nfd: "\u{110C}\u{1168}\u{11BA}",
        nfkc: "\u{C867}",
        nfkd: "\u{110C}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C868}",
        nfc: "\u{C868}",
        nfd: "\u{110C}\u{1168}\u{11BB}",
        nfkc: "\u{C868}",
        nfkd: "\u{110C}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C869}",
        nfc: "\u{C869}",
        nfd: "\u{110C}\u{1168}\u{11BC}",
        nfkc: "\u{C869}",
        nfkd: "\u{110C}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C86A}",
        nfc: "\u{C86A}",
        nfd: "\u{110C}\u{1168}\u{11BD}",
        nfkc: "\u{C86A}",
        nfkd: "\u{110C}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C86B}",
        nfc: "\u{C86B}",
        nfd: "\u{110C}\u{1168}\u{11BE}",
        nfkc: "\u{C86B}",
        nfkd: "\u{110C}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C86C}",
        nfc: "\u{C86C}",
        nfd: "\u{110C}\u{1168}\u{11BF}",
        nfkc: "\u{C86C}",
        nfkd: "\u{110C}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C86D}",
        nfc: "\u{C86D}",
        nfd: "\u{110C}\u{1168}\u{11C0}",
        nfkc: "\u{C86D}",
        nfkd: "\u{110C}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C86E}",
        nfc: "\u{C86E}",
        nfd: "\u{110C}\u{1168}\u{11C1}",
        nfkc: "\u{C86E}",
        nfkd: "\u{110C}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C86F}",
        nfc: "\u{C86F}",
        nfd: "\u{110C}\u{1168}\u{11C2}",
        nfkc: "\u{C86F}",
        nfkd: "\u{110C}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C870}",
        nfc: "\u{C870}",
        nfd: "\u{110C}\u{1169}",
        nfkc: "\u{C870}",
        nfkd: "\u{110C}\u{1169}",
    },
    NormalizationTest {
        source: "\u{C871}",
        nfc: "\u{C871}",
        nfd: "\u{110C}\u{1169}\u{11A8}",
        nfkc: "\u{C871}",
        nfkd: "\u{110C}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C872}",
        nfc: "\u{C872}",
        nfd: "\u{110C}\u{1169}\u{11A9}",
        nfkc: "\u{C872}",
        nfkd: "\u{110C}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C873}",
        nfc: "\u{C873}",
        nfd: "\u{110C}\u{1169}\u{11AA}",
        nfkc: "\u{C873}",
        nfkd: "\u{110C}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C874}",
        nfc: "\u{C874}",
        nfd: "\u{110C}\u{1169}\u{11AB}",
        nfkc: "\u{C874}",
        nfkd: "\u{110C}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C875}",
        nfc: "\u{C875}",
        nfd: "\u{110C}\u{1169}\u{11AC}",
        nfkc: "\u{C875}",
        nfkd: "\u{110C}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C876}",
        nfc: "\u{C876}",
        nfd: "\u{110C}\u{1169}\u{11AD}",
        nfkc: "\u{C876}",
        nfkd: "\u{110C}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C877}",
        nfc: "\u{C877}",
        nfd: "\u{110C}\u{1169}\u{11AE}",
        nfkc: "\u{C877}",
        nfkd: "\u{110C}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C878}",
        nfc: "\u{C878}",
        nfd: "\u{110C}\u{1169}\u{11AF}",
        nfkc: "\u{C878}",
        nfkd: "\u{110C}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C879}",
        nfc: "\u{C879}",
        nfd: "\u{110C}\u{1169}\u{11B0}",
        nfkc: "\u{C879}",
        nfkd: "\u{110C}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C87A}",
        nfc: "\u{C87A}",
        nfd: "\u{110C}\u{1169}\u{11B1}",
        nfkc: "\u{C87A}",
        nfkd: "\u{110C}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C87B}",
        nfc: "\u{C87B}",
        nfd: "\u{110C}\u{1169}\u{11B2}",
        nfkc: "\u{C87B}",
        nfkd: "\u{110C}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C87C}",
        nfc: "\u{C87C}",
        nfd: "\u{110C}\u{1169}\u{11B3}",
        nfkc: "\u{C87C}",
        nfkd: "\u{110C}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C87D}",
        nfc: "\u{C87D}",
        nfd: "\u{110C}\u{1169}\u{11B4}",
        nfkc: "\u{C87D}",
        nfkd: "\u{110C}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C87E}",
        nfc: "\u{C87E}",
        nfd: "\u{110C}\u{1169}\u{11B5}",
        nfkc: "\u{C87E}",
        nfkd: "\u{110C}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C87F}",
        nfc: "\u{C87F}",
        nfd: "\u{110C}\u{1169}\u{11B6}",
        nfkc: "\u{C87F}",
        nfkd: "\u{110C}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C880}",
        nfc: "\u{C880}",
        nfd: "\u{110C}\u{1169}\u{11B7}",
        nfkc: "\u{C880}",
        nfkd: "\u{110C}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C881}",
        nfc: "\u{C881}",
        nfd: "\u{110C}\u{1169}\u{11B8}",
        nfkc: "\u{C881}",
        nfkd: "\u{110C}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C882}",
        nfc: "\u{C882}",
        nfd: "\u{110C}\u{1169}\u{11B9}",
        nfkc: "\u{C882}",
        nfkd: "\u{110C}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C883}",
        nfc: "\u{C883}",
        nfd: "\u{110C}\u{1169}\u{11BA}",
        nfkc: "\u{C883}",
        nfkd: "\u{110C}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C884}",
        nfc: "\u{C884}",
        nfd: "\u{110C}\u{1169}\u{11BB}",
        nfkc: "\u{C884}",
        nfkd: "\u{110C}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C885}",
        nfc: "\u{C885}",
        nfd: "\u{110C}\u{1169}\u{11BC}",
        nfkc: "\u{C885}",
        nfkd: "\u{110C}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C886}",
        nfc: "\u{C886}",
        nfd: "\u{110C}\u{1169}\u{11BD}",
        nfkc: "\u{C886}",
        nfkd: "\u{110C}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C887}",
        nfc: "\u{C887}",
        nfd: "\u{110C}\u{1169}\u{11BE}",
        nfkc: "\u{C887}",
        nfkd: "\u{110C}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C888}",
        nfc: "\u{C888}",
        nfd: "\u{110C}\u{1169}\u{11BF}",
        nfkc: "\u{C888}",
        nfkd: "\u{110C}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C889}",
        nfc: "\u{C889}",
        nfd: "\u{110C}\u{1169}\u{11C0}",
        nfkc: "\u{C889}",
        nfkd: "\u{110C}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C88A}",
        nfc: "\u{C88A}",
        nfd: "\u{110C}\u{1169}\u{11C1}",
        nfkc: "\u{C88A}",
        nfkd: "\u{110C}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C88B}",
        nfc: "\u{C88B}",
        nfd: "\u{110C}\u{1169}\u{11C2}",
        nfkc: "\u{C88B}",
        nfkd: "\u{110C}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C88C}",
        nfc: "\u{C88C}",
        nfd: "\u{110C}\u{116A}",
        nfkc: "\u{C88C}",
        nfkd: "\u{110C}\u{116A}",
    },
    NormalizationTest {
        source: "\u{C88D}",
        nfc: "\u{C88D}",
        nfd: "\u{110C}\u{116A}\u{11A8}",
        nfkc: "\u{C88D}",
        nfkd: "\u{110C}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C88E}",
        nfc: "\u{C88E}",
        nfd: "\u{110C}\u{116A}\u{11A9}",
        nfkc: "\u{C88E}",
        nfkd: "\u{110C}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C88F}",
        nfc: "\u{C88F}",
        nfd: "\u{110C}\u{116A}\u{11AA}",
        nfkc: "\u{C88F}",
        nfkd: "\u{110C}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C890}",
        nfc: "\u{C890}",
        nfd: "\u{110C}\u{116A}\u{11AB}",
        nfkc: "\u{C890}",
        nfkd: "\u{110C}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C891}",
        nfc: "\u{C891}",
        nfd: "\u{110C}\u{116A}\u{11AC}",
        nfkc: "\u{C891}",
        nfkd: "\u{110C}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C892}",
        nfc: "\u{C892}",
        nfd: "\u{110C}\u{116A}\u{11AD}",
        nfkc: "\u{C892}",
        nfkd: "\u{110C}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C893}",
        nfc: "\u{C893}",
        nfd: "\u{110C}\u{116A}\u{11AE}",
        nfkc: "\u{C893}",
        nfkd: "\u{110C}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C894}",
        nfc: "\u{C894}",
        nfd: "\u{110C}\u{116A}\u{11AF}",
        nfkc: "\u{C894}",
        nfkd: "\u{110C}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C895}",
        nfc: "\u{C895}",
        nfd: "\u{110C}\u{116A}\u{11B0}",
        nfkc: "\u{C895}",
        nfkd: "\u{110C}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C896}",
        nfc: "\u{C896}",
        nfd: "\u{110C}\u{116A}\u{11B1}",
        nfkc: "\u{C896}",
        nfkd: "\u{110C}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C897}",
        nfc: "\u{C897}",
        nfd: "\u{110C}\u{116A}\u{11B2}",
        nfkc: "\u{C897}",
        nfkd: "\u{110C}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C898}",
        nfc: "\u{C898}",
        nfd: "\u{110C}\u{116A}\u{11B3}",
        nfkc: "\u{C898}",
        nfkd: "\u{110C}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C899}",
        nfc: "\u{C899}",
        nfd: "\u{110C}\u{116A}\u{11B4}",
        nfkc: "\u{C899}",
        nfkd: "\u{110C}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C89A}",
        nfc: "\u{C89A}",
        nfd: "\u{110C}\u{116A}\u{11B5}",
        nfkc: "\u{C89A}",
        nfkd: "\u{110C}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C89B}",
        nfc: "\u{C89B}",
        nfd: "\u{110C}\u{116A}\u{11B6}",
        nfkc: "\u{C89B}",
        nfkd: "\u{110C}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C89C}",
        nfc: "\u{C89C}",
        nfd: "\u{110C}\u{116A}\u{11B7}",
        nfkc: "\u{C89C}",
        nfkd: "\u{110C}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C89D}",
        nfc: "\u{C89D}",
        nfd: "\u{110C}\u{116A}\u{11B8}",
        nfkc: "\u{C89D}",
        nfkd: "\u{110C}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C89E}",
        nfc: "\u{C89E}",
        nfd: "\u{110C}\u{116A}\u{11B9}",
        nfkc: "\u{C89E}",
        nfkd: "\u{110C}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C89F}",
        nfc: "\u{C89F}",
        nfd: "\u{110C}\u{116A}\u{11BA}",
        nfkc: "\u{C89F}",
        nfkd: "\u{110C}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C8A0}",
        nfc: "\u{C8A0}",
        nfd: "\u{110C}\u{116A}\u{11BB}",
        nfkc: "\u{C8A0}",
        nfkd: "\u{110C}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C8A1}",
        nfc: "\u{C8A1}",
        nfd: "\u{110C}\u{116A}\u{11BC}",
        nfkc: "\u{C8A1}",
        nfkd: "\u{110C}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C8A2}",
        nfc: "\u{C8A2}",
        nfd: "\u{110C}\u{116A}\u{11BD}",
        nfkc: "\u{C8A2}",
        nfkd: "\u{110C}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C8A3}",
        nfc: "\u{C8A3}",
        nfd: "\u{110C}\u{116A}\u{11BE}",
        nfkc: "\u{C8A3}",
        nfkd: "\u{110C}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C8A4}",
        nfc: "\u{C8A4}",
        nfd: "\u{110C}\u{116A}\u{11BF}",
        nfkc: "\u{C8A4}",
        nfkd: "\u{110C}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C8A5}",
        nfc: "\u{C8A5}",
        nfd: "\u{110C}\u{116A}\u{11C0}",
        nfkc: "\u{C8A5}",
        nfkd: "\u{110C}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C8A6}",
        nfc: "\u{C8A6}",
        nfd: "\u{110C}\u{116A}\u{11C1}",
        nfkc: "\u{C8A6}",
        nfkd: "\u{110C}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C8A7}",
        nfc: "\u{C8A7}",
        nfd: "\u{110C}\u{116A}\u{11C2}",
        nfkc: "\u{C8A7}",
        nfkd: "\u{110C}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C8A8}",
        nfc: "\u{C8A8}",
        nfd: "\u{110C}\u{116B}",
        nfkc: "\u{C8A8}",
        nfkd: "\u{110C}\u{116B}",
    },
    NormalizationTest {
        source: "\u{C8A9}",
        nfc: "\u{C8A9}",
        nfd: "\u{110C}\u{116B}\u{11A8}",
        nfkc: "\u{C8A9}",
        nfkd: "\u{110C}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C8AA}",
        nfc: "\u{C8AA}",
        nfd: "\u{110C}\u{116B}\u{11A9}",
        nfkc: "\u{C8AA}",
        nfkd: "\u{110C}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C8AB}",
        nfc: "\u{C8AB}",
        nfd: "\u{110C}\u{116B}\u{11AA}",
        nfkc: "\u{C8AB}",
        nfkd: "\u{110C}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C8AC}",
        nfc: "\u{C8AC}",
        nfd: "\u{110C}\u{116B}\u{11AB}",
        nfkc: "\u{C8AC}",
        nfkd: "\u{110C}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C8AD}",
        nfc: "\u{C8AD}",
        nfd: "\u{110C}\u{116B}\u{11AC}",
        nfkc: "\u{C8AD}",
        nfkd: "\u{110C}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C8AE}",
        nfc: "\u{C8AE}",
        nfd: "\u{110C}\u{116B}\u{11AD}",
        nfkc: "\u{C8AE}",
        nfkd: "\u{110C}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C8AF}",
        nfc: "\u{C8AF}",
        nfd: "\u{110C}\u{116B}\u{11AE}",
        nfkc: "\u{C8AF}",
        nfkd: "\u{110C}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C8B0}",
        nfc: "\u{C8B0}",
        nfd: "\u{110C}\u{116B}\u{11AF}",
        nfkc: "\u{C8B0}",
        nfkd: "\u{110C}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C8B1}",
        nfc: "\u{C8B1}",
        nfd: "\u{110C}\u{116B}\u{11B0}",
        nfkc: "\u{C8B1}",
        nfkd: "\u{110C}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C8B2}",
        nfc: "\u{C8B2}",
        nfd: "\u{110C}\u{116B}\u{11B1}",
        nfkc: "\u{C8B2}",
        nfkd: "\u{110C}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C8B3}",
        nfc: "\u{C8B3}",
        nfd: "\u{110C}\u{116B}\u{11B2}",
        nfkc: "\u{C8B3}",
        nfkd: "\u{110C}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C8B4}",
        nfc: "\u{C8B4}",
        nfd: "\u{110C}\u{116B}\u{11B3}",
        nfkc: "\u{C8B4}",
        nfkd: "\u{110C}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C8B5}",
        nfc: "\u{C8B5}",
        nfd: "\u{110C}\u{116B}\u{11B4}",
        nfkc: "\u{C8B5}",
        nfkd: "\u{110C}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C8B6}",
        nfc: "\u{C8B6}",
        nfd: "\u{110C}\u{116B}\u{11B5}",
        nfkc: "\u{C8B6}",
        nfkd: "\u{110C}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C8B7}",
        nfc: "\u{C8B7}",
        nfd: "\u{110C}\u{116B}\u{11B6}",
        nfkc: "\u{C8B7}",
        nfkd: "\u{110C}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C8B8}",
        nfc: "\u{C8B8}",
        nfd: "\u{110C}\u{116B}\u{11B7}",
        nfkc: "\u{C8B8}",
        nfkd: "\u{110C}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C8B9}",
        nfc: "\u{C8B9}",
        nfd: "\u{110C}\u{116B}\u{11B8}",
        nfkc: "\u{C8B9}",
        nfkd: "\u{110C}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C8BA}",
        nfc: "\u{C8BA}",
        nfd: "\u{110C}\u{116B}\u{11B9}",
        nfkc: "\u{C8BA}",
        nfkd: "\u{110C}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C8BB}",
        nfc: "\u{C8BB}",
        nfd: "\u{110C}\u{116B}\u{11BA}",
        nfkc: "\u{C8BB}",
        nfkd: "\u{110C}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C8BC}",
        nfc: "\u{C8BC}",
        nfd: "\u{110C}\u{116B}\u{11BB}",
        nfkc: "\u{C8BC}",
        nfkd: "\u{110C}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C8BD}",
        nfc: "\u{C8BD}",
        nfd: "\u{110C}\u{116B}\u{11BC}",
        nfkc: "\u{C8BD}",
        nfkd: "\u{110C}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C8BE}",
        nfc: "\u{C8BE}",
        nfd: "\u{110C}\u{116B}\u{11BD}",
        nfkc: "\u{C8BE}",
        nfkd: "\u{110C}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C8BF}",
        nfc: "\u{C8BF}",
        nfd: "\u{110C}\u{116B}\u{11BE}",
        nfkc: "\u{C8BF}",
        nfkd: "\u{110C}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C8C0}",
        nfc: "\u{C8C0}",
        nfd: "\u{110C}\u{116B}\u{11BF}",
        nfkc: "\u{C8C0}",
        nfkd: "\u{110C}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C8C1}",
        nfc: "\u{C8C1}",
        nfd: "\u{110C}\u{116B}\u{11C0}",
        nfkc: "\u{C8C1}",
        nfkd: "\u{110C}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C8C2}",
        nfc: "\u{C8C2}",
        nfd: "\u{110C}\u{116B}\u{11C1}",
        nfkc: "\u{C8C2}",
        nfkd: "\u{110C}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C8C3}",
        nfc: "\u{C8C3}",
        nfd: "\u{110C}\u{116B}\u{11C2}",
        nfkc: "\u{C8C3}",
        nfkd: "\u{110C}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C8C4}",
        nfc: "\u{C8C4}",
        nfd: "\u{110C}\u{116C}",
        nfkc: "\u{C8C4}",
        nfkd: "\u{110C}\u{116C}",
    },
    NormalizationTest {
        source: "\u{C8C5}",
        nfc: "\u{C8C5}",
        nfd: "\u{110C}\u{116C}\u{11A8}",
        nfkc: "\u{C8C5}",
        nfkd: "\u{110C}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C8C6}",
        nfc: "\u{C8C6}",
        nfd: "\u{110C}\u{116C}\u{11A9}",
        nfkc: "\u{C8C6}",
        nfkd: "\u{110C}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C8C7}",
        nfc: "\u{C8C7}",
        nfd: "\u{110C}\u{116C}\u{11AA}",
        nfkc: "\u{C8C7}",
        nfkd: "\u{110C}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C8C8}",
        nfc: "\u{C8C8}",
        nfd: "\u{110C}\u{116C}\u{11AB}",
        nfkc: "\u{C8C8}",
        nfkd: "\u{110C}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C8C9}",
        nfc: "\u{C8C9}",
        nfd: "\u{110C}\u{116C}\u{11AC}",
        nfkc: "\u{C8C9}",
        nfkd: "\u{110C}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C8CA}",
        nfc: "\u{C8CA}",
        nfd: "\u{110C}\u{116C}\u{11AD}",
        nfkc: "\u{C8CA}",
        nfkd: "\u{110C}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C8CB}",
        nfc: "\u{C8CB}",
        nfd: "\u{110C}\u{116C}\u{11AE}",
        nfkc: "\u{C8CB}",
        nfkd: "\u{110C}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C8CC}",
        nfc: "\u{C8CC}",
        nfd: "\u{110C}\u{116C}\u{11AF}",
        nfkc: "\u{C8CC}",
        nfkd: "\u{110C}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C8CD}",
        nfc: "\u{C8CD}",
        nfd: "\u{110C}\u{116C}\u{11B0}",
        nfkc: "\u{C8CD}",
        nfkd: "\u{110C}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C8CE}",
        nfc: "\u{C8CE}",
        nfd: "\u{110C}\u{116C}\u{11B1}",
        nfkc: "\u{C8CE}",
        nfkd: "\u{110C}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C8CF}",
        nfc: "\u{C8CF}",
        nfd: "\u{110C}\u{116C}\u{11B2}",
        nfkc: "\u{C8CF}",
        nfkd: "\u{110C}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C8D0}",
        nfc: "\u{C8D0}",
        nfd: "\u{110C}\u{116C}\u{11B3}",
        nfkc: "\u{C8D0}",
        nfkd: "\u{110C}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C8D1}",
        nfc: "\u{C8D1}",
        nfd: "\u{110C}\u{116C}\u{11B4}",
        nfkc: "\u{C8D1}",
        nfkd: "\u{110C}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C8D2}",
        nfc: "\u{C8D2}",
        nfd: "\u{110C}\u{116C}\u{11B5}",
        nfkc: "\u{C8D2}",
        nfkd: "\u{110C}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C8D3}",
        nfc: "\u{C8D3}",
        nfd: "\u{110C}\u{116C}\u{11B6}",
        nfkc: "\u{C8D3}",
        nfkd: "\u{110C}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C8D4}",
        nfc: "\u{C8D4}",
        nfd: "\u{110C}\u{116C}\u{11B7}",
        nfkc: "\u{C8D4}",
        nfkd: "\u{110C}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C8D5}",
        nfc: "\u{C8D5}",
        nfd: "\u{110C}\u{116C}\u{11B8}",
        nfkc: "\u{C8D5}",
        nfkd: "\u{110C}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C8D6}",
        nfc: "\u{C8D6}",
        nfd: "\u{110C}\u{116C}\u{11B9}",
        nfkc: "\u{C8D6}",
        nfkd: "\u{110C}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C8D7}",
        nfc: "\u{C8D7}",
        nfd: "\u{110C}\u{116C}\u{11BA}",
        nfkc: "\u{C8D7}",
        nfkd: "\u{110C}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C8D8}",
        nfc: "\u{C8D8}",
        nfd: "\u{110C}\u{116C}\u{11BB}",
        nfkc: "\u{C8D8}",
        nfkd: "\u{110C}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C8D9}",
        nfc: "\u{C8D9}",
        nfd: "\u{110C}\u{116C}\u{11BC}",
        nfkc: "\u{C8D9}",
        nfkd: "\u{110C}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C8DA}",
        nfc: "\u{C8DA}",
        nfd: "\u{110C}\u{116C}\u{11BD}",
        nfkc: "\u{C8DA}",
        nfkd: "\u{110C}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C8DB}",
        nfc: "\u{C8DB}",
        nfd: "\u{110C}\u{116C}\u{11BE}",
        nfkc: "\u{C8DB}",
        nfkd: "\u{110C}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C8DC}",
        nfc: "\u{C8DC}",
        nfd: "\u{110C}\u{116C}\u{11BF}",
        nfkc: "\u{C8DC}",
        nfkd: "\u{110C}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C8DD}",
        nfc: "\u{C8DD}",
        nfd: "\u{110C}\u{116C}\u{11C0}",
        nfkc: "\u{C8DD}",
        nfkd: "\u{110C}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C8DE}",
        nfc: "\u{C8DE}",
        nfd: "\u{110C}\u{116C}\u{11C1}",
        nfkc: "\u{C8DE}",
        nfkd: "\u{110C}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C8DF}",
        nfc: "\u{C8DF}",
        nfd: "\u{110C}\u{116C}\u{11C2}",
        nfkc: "\u{C8DF}",
        nfkd: "\u{110C}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C8E0}",
        nfc: "\u{C8E0}",
        nfd: "\u{110C}\u{116D}",
        nfkc: "\u{C8E0}",
        nfkd: "\u{110C}\u{116D}",
    },
    NormalizationTest {
        source: "\u{C8E1}",
        nfc: "\u{C8E1}",
        nfd: "\u{110C}\u{116D}\u{11A8}",
        nfkc: "\u{C8E1}",
        nfkd: "\u{110C}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C8E2}",
        nfc: "\u{C8E2}",
        nfd: "\u{110C}\u{116D}\u{11A9}",
        nfkc: "\u{C8E2}",
        nfkd: "\u{110C}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C8E3}",
        nfc: "\u{C8E3}",
        nfd: "\u{110C}\u{116D}\u{11AA}",
        nfkc: "\u{C8E3}",
        nfkd: "\u{110C}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C8E4}",
        nfc: "\u{C8E4}",
        nfd: "\u{110C}\u{116D}\u{11AB}",
        nfkc: "\u{C8E4}",
        nfkd: "\u{110C}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C8E5}",
        nfc: "\u{C8E5}",
        nfd: "\u{110C}\u{116D}\u{11AC}",
        nfkc: "\u{C8E5}",
        nfkd: "\u{110C}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C8E6}",
        nfc: "\u{C8E6}",
        nfd: "\u{110C}\u{116D}\u{11AD}",
        nfkc: "\u{C8E6}",
        nfkd: "\u{110C}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C8E7}",
        nfc: "\u{C8E7}",
        nfd: "\u{110C}\u{116D}\u{11AE}",
        nfkc: "\u{C8E7}",
        nfkd: "\u{110C}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C8E8}",
        nfc: "\u{C8E8}",
        nfd: "\u{110C}\u{116D}\u{11AF}",
        nfkc: "\u{C8E8}",
        nfkd: "\u{110C}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C8E9}",
        nfc: "\u{C8E9}",
        nfd: "\u{110C}\u{116D}\u{11B0}",
        nfkc: "\u{C8E9}",
        nfkd: "\u{110C}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C8EA}",
        nfc: "\u{C8EA}",
        nfd: "\u{110C}\u{116D}\u{11B1}",
        nfkc: "\u{C8EA}",
        nfkd: "\u{110C}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C8EB}",
        nfc: "\u{C8EB}",
        nfd: "\u{110C}\u{116D}\u{11B2}",
        nfkc: "\u{C8EB}",
        nfkd: "\u{110C}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C8EC}",
        nfc: "\u{C8EC}",
        nfd: "\u{110C}\u{116D}\u{11B3}",
        nfkc: "\u{C8EC}",
        nfkd: "\u{110C}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C8ED}",
        nfc: "\u{C8ED}",
        nfd: "\u{110C}\u{116D}\u{11B4}",
        nfkc: "\u{C8ED}",
        nfkd: "\u{110C}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C8EE}",
        nfc: "\u{C8EE}",
        nfd: "\u{110C}\u{116D}\u{11B5}",
        nfkc: "\u{C8EE}",
        nfkd: "\u{110C}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C8EF}",
        nfc: "\u{C8EF}",
        nfd: "\u{110C}\u{116D}\u{11B6}",
        nfkc: "\u{C8EF}",
        nfkd: "\u{110C}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C8F0}",
        nfc: "\u{C8F0}",
        nfd: "\u{110C}\u{116D}\u{11B7}",
        nfkc: "\u{C8F0}",
        nfkd: "\u{110C}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C8F1}",
        nfc: "\u{C8F1}",
        nfd: "\u{110C}\u{116D}\u{11B8}",
        nfkc: "\u{C8F1}",
        nfkd: "\u{110C}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C8F2}",
        nfc: "\u{C8F2}",
        nfd: "\u{110C}\u{116D}\u{11B9}",
        nfkc: "\u{C8F2}",
        nfkd: "\u{110C}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C8F3}",
        nfc: "\u{C8F3}",
        nfd: "\u{110C}\u{116D}\u{11BA}",
        nfkc: "\u{C8F3}",
        nfkd: "\u{110C}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C8F4}",
        nfc: "\u{C8F4}",
        nfd: "\u{110C}\u{116D}\u{11BB}",
        nfkc: "\u{C8F4}",
        nfkd: "\u{110C}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C8F5}",
        nfc: "\u{C8F5}",
        nfd: "\u{110C}\u{116D}\u{11BC}",
        nfkc: "\u{C8F5}",
        nfkd: "\u{110C}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C8F6}",
        nfc: "\u{C8F6}",
        nfd: "\u{110C}\u{116D}\u{11BD}",
        nfkc: "\u{C8F6}",
        nfkd: "\u{110C}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C8F7}",
        nfc: "\u{C8F7}",
        nfd: "\u{110C}\u{116D}\u{11BE}",
        nfkc: "\u{C8F7}",
        nfkd: "\u{110C}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C8F8}",
        nfc: "\u{C8F8}",
        nfd: "\u{110C}\u{116D}\u{11BF}",
        nfkc: "\u{C8F8}",
        nfkd: "\u{110C}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C8F9}",
        nfc: "\u{C8F9}",
        nfd: "\u{110C}\u{116D}\u{11C0}",
        nfkc: "\u{C8F9}",
        nfkd: "\u{110C}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C8FA}",
        nfc: "\u{C8FA}",
        nfd: "\u{110C}\u{116D}\u{11C1}",
        nfkc: "\u{C8FA}",
        nfkd: "\u{110C}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C8FB}",
        nfc: "\u{C8FB}",
        nfd: "\u{110C}\u{116D}\u{11C2}",
        nfkc: "\u{C8FB}",
        nfkd: "\u{110C}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C8FC}",
        nfc: "\u{C8FC}",
        nfd: "\u{110C}\u{116E}",
        nfkc: "\u{C8FC}",
        nfkd: "\u{110C}\u{116E}",
    },
    NormalizationTest {
        source: "\u{C8FD}",
        nfc: "\u{C8FD}",
        nfd: "\u{110C}\u{116E}\u{11A8}",
        nfkc: "\u{C8FD}",
        nfkd: "\u{110C}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C8FE}",
        nfc: "\u{C8FE}",
        nfd: "\u{110C}\u{116E}\u{11A9}",
        nfkc: "\u{C8FE}",
        nfkd: "\u{110C}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C8FF}",
        nfc: "\u{C8FF}",
        nfd: "\u{110C}\u{116E}\u{11AA}",
        nfkc: "\u{C8FF}",
        nfkd: "\u{110C}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C900}",
        nfc: "\u{C900}",
        nfd: "\u{110C}\u{116E}\u{11AB}",
        nfkc: "\u{C900}",
        nfkd: "\u{110C}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C901}",
        nfc: "\u{C901}",
        nfd: "\u{110C}\u{116E}\u{11AC}",
        nfkc: "\u{C901}",
        nfkd: "\u{110C}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C902}",
        nfc: "\u{C902}",
        nfd: "\u{110C}\u{116E}\u{11AD}",
        nfkc: "\u{C902}",
        nfkd: "\u{110C}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C903}",
        nfc: "\u{C903}",
        nfd: "\u{110C}\u{116E}\u{11AE}",
        nfkc: "\u{C903}",
        nfkd: "\u{110C}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C904}",
        nfc: "\u{C904}",
        nfd: "\u{110C}\u{116E}\u{11AF}",
        nfkc: "\u{C904}",
        nfkd: "\u{110C}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C905}",
        nfc: "\u{C905}",
        nfd: "\u{110C}\u{116E}\u{11B0}",
        nfkc: "\u{C905}",
        nfkd: "\u{110C}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C906}",
        nfc: "\u{C906}",
        nfd: "\u{110C}\u{116E}\u{11B1}",
        nfkc: "\u{C906}",
        nfkd: "\u{110C}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C907}",
        nfc: "\u{C907}",
        nfd: "\u{110C}\u{116E}\u{11B2}",
        nfkc: "\u{C907}",
        nfkd: "\u{110C}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C908}",
        nfc: "\u{C908}",
        nfd: "\u{110C}\u{116E}\u{11B3}",
        nfkc: "\u{C908}",
        nfkd: "\u{110C}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C909}",
        nfc: "\u{C909}",
        nfd: "\u{110C}\u{116E}\u{11B4}",
        nfkc: "\u{C909}",
        nfkd: "\u{110C}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C90A}",
        nfc: "\u{C90A}",
        nfd: "\u{110C}\u{116E}\u{11B5}",
        nfkc: "\u{C90A}",
        nfkd: "\u{110C}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C90B}",
        nfc: "\u{C90B}",
        nfd: "\u{110C}\u{116E}\u{11B6}",
        nfkc: "\u{C90B}",
        nfkd: "\u{110C}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C90C}",
        nfc: "\u{C90C}",
        nfd: "\u{110C}\u{116E}\u{11B7}",
        nfkc: "\u{C90C}",
        nfkd: "\u{110C}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C90D}",
        nfc: "\u{C90D}",
        nfd: "\u{110C}\u{116E}\u{11B8}",
        nfkc: "\u{C90D}",
        nfkd: "\u{110C}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C90E}",
        nfc: "\u{C90E}",
        nfd: "\u{110C}\u{116E}\u{11B9}",
        nfkc: "\u{C90E}",
        nfkd: "\u{110C}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C90F}",
        nfc: "\u{C90F}",
        nfd: "\u{110C}\u{116E}\u{11BA}",
        nfkc: "\u{C90F}",
        nfkd: "\u{110C}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C910}",
        nfc: "\u{C910}",
        nfd: "\u{110C}\u{116E}\u{11BB}",
        nfkc: "\u{C910}",
        nfkd: "\u{110C}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C911}",
        nfc: "\u{C911}",
        nfd: "\u{110C}\u{116E}\u{11BC}",
        nfkc: "\u{C911}",
        nfkd: "\u{110C}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C912}",
        nfc: "\u{C912}",
        nfd: "\u{110C}\u{116E}\u{11BD}",
        nfkc: "\u{C912}",
        nfkd: "\u{110C}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C913}",
        nfc: "\u{C913}",
        nfd: "\u{110C}\u{116E}\u{11BE}",
        nfkc: "\u{C913}",
        nfkd: "\u{110C}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C914}",
        nfc: "\u{C914}",
        nfd: "\u{110C}\u{116E}\u{11BF}",
        nfkc: "\u{C914}",
        nfkd: "\u{110C}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C915}",
        nfc: "\u{C915}",
        nfd: "\u{110C}\u{116E}\u{11C0}",
        nfkc: "\u{C915}",
        nfkd: "\u{110C}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C916}",
        nfc: "\u{C916}",
        nfd: "\u{110C}\u{116E}\u{11C1}",
        nfkc: "\u{C916}",
        nfkd: "\u{110C}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C917}",
        nfc: "\u{C917}",
        nfd: "\u{110C}\u{116E}\u{11C2}",
        nfkc: "\u{C917}",
        nfkd: "\u{110C}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C918}",
        nfc: "\u{C918}",
        nfd: "\u{110C}\u{116F}",
        nfkc: "\u{C918}",
        nfkd: "\u{110C}\u{116F}",
    },
    NormalizationTest {
        source: "\u{C919}",
        nfc: "\u{C919}",
        nfd: "\u{110C}\u{116F}\u{11A8}",
        nfkc: "\u{C919}",
        nfkd: "\u{110C}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C91A}",
        nfc: "\u{C91A}",
        nfd: "\u{110C}\u{116F}\u{11A9}",
        nfkc: "\u{C91A}",
        nfkd: "\u{110C}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C91B}",
        nfc: "\u{C91B}",
        nfd: "\u{110C}\u{116F}\u{11AA}",
        nfkc: "\u{C91B}",
        nfkd: "\u{110C}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C91C}",
        nfc: "\u{C91C}",
        nfd: "\u{110C}\u{116F}\u{11AB}",
        nfkc: "\u{C91C}",
        nfkd: "\u{110C}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C91D}",
        nfc: "\u{C91D}",
        nfd: "\u{110C}\u{116F}\u{11AC}",
        nfkc: "\u{C91D}",
        nfkd: "\u{110C}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C91E}",
        nfc: "\u{C91E}",
        nfd: "\u{110C}\u{116F}\u{11AD}",
        nfkc: "\u{C91E}",
        nfkd: "\u{110C}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C91F}",
        nfc: "\u{C91F}",
        nfd: "\u{110C}\u{116F}\u{11AE}",
        nfkc: "\u{C91F}",
        nfkd: "\u{110C}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C920}",
        nfc: "\u{C920}",
        nfd: "\u{110C}\u{116F}\u{11AF}",
        nfkc: "\u{C920}",
        nfkd: "\u{110C}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C921}",
        nfc: "\u{C921}",
        nfd: "\u{110C}\u{116F}\u{11B0}",
        nfkc: "\u{C921}",
        nfkd: "\u{110C}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C922}",
        nfc: "\u{C922}",
        nfd: "\u{110C}\u{116F}\u{11B1}",
        nfkc: "\u{C922}",
        nfkd: "\u{110C}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C923}",
        nfc: "\u{C923}",
        nfd: "\u{110C}\u{116F}\u{11B2}",
        nfkc: "\u{C923}",
        nfkd: "\u{110C}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C924}",
        nfc: "\u{C924}",
        nfd: "\u{110C}\u{116F}\u{11B3}",
        nfkc: "\u{C924}",
        nfkd: "\u{110C}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C925}",
        nfc: "\u{C925}",
        nfd: "\u{110C}\u{116F}\u{11B4}",
        nfkc: "\u{C925}",
        nfkd: "\u{110C}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C926}",
        nfc: "\u{C926}",
        nfd: "\u{110C}\u{116F}\u{11B5}",
        nfkc: "\u{C926}",
        nfkd: "\u{110C}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C927}",
        nfc: "\u{C927}",
        nfd: "\u{110C}\u{116F}\u{11B6}",
        nfkc: "\u{C927}",
        nfkd: "\u{110C}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C928}",
        nfc: "\u{C928}",
        nfd: "\u{110C}\u{116F}\u{11B7}",
        nfkc: "\u{C928}",
        nfkd: "\u{110C}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C929}",
        nfc: "\u{C929}",
        nfd: "\u{110C}\u{116F}\u{11B8}",
        nfkc: "\u{C929}",
        nfkd: "\u{110C}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C92A}",
        nfc: "\u{C92A}",
        nfd: "\u{110C}\u{116F}\u{11B9}",
        nfkc: "\u{C92A}",
        nfkd: "\u{110C}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C92B}",
        nfc: "\u{C92B}",
        nfd: "\u{110C}\u{116F}\u{11BA}",
        nfkc: "\u{C92B}",
        nfkd: "\u{110C}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C92C}",
        nfc: "\u{C92C}",
        nfd: "\u{110C}\u{116F}\u{11BB}",
        nfkc: "\u{C92C}",
        nfkd: "\u{110C}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C92D}",
        nfc: "\u{C92D}",
        nfd: "\u{110C}\u{116F}\u{11BC}",
        nfkc: "\u{C92D}",
        nfkd: "\u{110C}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C92E}",
        nfc: "\u{C92E}",
        nfd: "\u{110C}\u{116F}\u{11BD}",
        nfkc: "\u{C92E}",
        nfkd: "\u{110C}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C92F}",
        nfc: "\u{C92F}",
        nfd: "\u{110C}\u{116F}\u{11BE}",
        nfkc: "\u{C92F}",
        nfkd: "\u{110C}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C930}",
        nfc: "\u{C930}",
        nfd: "\u{110C}\u{116F}\u{11BF}",
        nfkc: "\u{C930}",
        nfkd: "\u{110C}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C931}",
        nfc: "\u{C931}",
        nfd: "\u{110C}\u{116F}\u{11C0}",
        nfkc: "\u{C931}",
        nfkd: "\u{110C}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C932}",
        nfc: "\u{C932}",
        nfd: "\u{110C}\u{116F}\u{11C1}",
        nfkc: "\u{C932}",
        nfkd: "\u{110C}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C933}",
        nfc: "\u{C933}",
        nfd: "\u{110C}\u{116F}\u{11C2}",
        nfkc: "\u{C933}",
        nfkd: "\u{110C}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C934}",
        nfc: "\u{C934}",
        nfd: "\u{110C}\u{1170}",
        nfkc: "\u{C934}",
        nfkd: "\u{110C}\u{1170}",
    },
    NormalizationTest {
        source: "\u{C935}",
        nfc: "\u{C935}",
        nfd: "\u{110C}\u{1170}\u{11A8}",
        nfkc: "\u{C935}",
        nfkd: "\u{110C}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C936}",
        nfc: "\u{C936}",
        nfd: "\u{110C}\u{1170}\u{11A9}",
        nfkc: "\u{C936}",
        nfkd: "\u{110C}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C937}",
        nfc: "\u{C937}",
        nfd: "\u{110C}\u{1170}\u{11AA}",
        nfkc: "\u{C937}",
        nfkd: "\u{110C}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C938}",
        nfc: "\u{C938}",
        nfd: "\u{110C}\u{1170}\u{11AB}",
        nfkc: "\u{C938}",
        nfkd: "\u{110C}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C939}",
        nfc: "\u{C939}",
        nfd: "\u{110C}\u{1170}\u{11AC}",
        nfkc: "\u{C939}",
        nfkd: "\u{110C}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C93A}",
        nfc: "\u{C93A}",
        nfd: "\u{110C}\u{1170}\u{11AD}",
        nfkc: "\u{C93A}",
        nfkd: "\u{110C}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C93B}",
        nfc: "\u{C93B}",
        nfd: "\u{110C}\u{1170}\u{11AE}",
        nfkc: "\u{C93B}",
        nfkd: "\u{110C}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C93C}",
        nfc: "\u{C93C}",
        nfd: "\u{110C}\u{1170}\u{11AF}",
        nfkc: "\u{C93C}",
        nfkd: "\u{110C}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C93D}",
        nfc: "\u{C93D}",
        nfd: "\u{110C}\u{1170}\u{11B0}",
        nfkc: "\u{C93D}",
        nfkd: "\u{110C}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C93E}",
        nfc: "\u{C93E}",
        nfd: "\u{110C}\u{1170}\u{11B1}",
        nfkc: "\u{C93E}",
        nfkd: "\u{110C}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C93F}",
        nfc: "\u{C93F}",
        nfd: "\u{110C}\u{1170}\u{11B2}",
        nfkc: "\u{C93F}",
        nfkd: "\u{110C}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C940}",
        nfc: "\u{C940}",
        nfd: "\u{110C}\u{1170}\u{11B3}",
        nfkc: "\u{C940}",
        nfkd: "\u{110C}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C941}",
        nfc: "\u{C941}",
        nfd: "\u{110C}\u{1170}\u{11B4}",
        nfkc: "\u{C941}",
        nfkd: "\u{110C}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C942}",
        nfc: "\u{C942}",
        nfd: "\u{110C}\u{1170}\u{11B5}",
        nfkc: "\u{C942}",
        nfkd: "\u{110C}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C943}",
        nfc: "\u{C943}",
        nfd: "\u{110C}\u{1170}\u{11B6}",
        nfkc: "\u{C943}",
        nfkd: "\u{110C}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C944}",
        nfc: "\u{C944}",
        nfd: "\u{110C}\u{1170}\u{11B7}",
        nfkc: "\u{C944}",
        nfkd: "\u{110C}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C945}",
        nfc: "\u{C945}",
        nfd: "\u{110C}\u{1170}\u{11B8}",
        nfkc: "\u{C945}",
        nfkd: "\u{110C}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C946}",
        nfc: "\u{C946}",
        nfd: "\u{110C}\u{1170}\u{11B9}",
        nfkc: "\u{C946}",
        nfkd: "\u{110C}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C947}",
        nfc: "\u{C947}",
        nfd: "\u{110C}\u{1170}\u{11BA}",
        nfkc: "\u{C947}",
        nfkd: "\u{110C}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C948}",
        nfc: "\u{C948}",
        nfd: "\u{110C}\u{1170}\u{11BB}",
        nfkc: "\u{C948}",
        nfkd: "\u{110C}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C949}",
        nfc: "\u{C949}",
        nfd: "\u{110C}\u{1170}\u{11BC}",
        nfkc: "\u{C949}",
        nfkd: "\u{110C}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C94A}",
        nfc: "\u{C94A}",
        nfd: "\u{110C}\u{1170}\u{11BD}",
        nfkc: "\u{C94A}",
        nfkd: "\u{110C}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C94B}",
        nfc: "\u{C94B}",
        nfd: "\u{110C}\u{1170}\u{11BE}",
        nfkc: "\u{C94B}",
        nfkd: "\u{110C}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C94C}",
        nfc: "\u{C94C}",
        nfd: "\u{110C}\u{1170}\u{11BF}",
        nfkc: "\u{C94C}",
        nfkd: "\u{110C}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C94D}",
        nfc: "\u{C94D}",
        nfd: "\u{110C}\u{1170}\u{11C0}",
        nfkc: "\u{C94D}",
        nfkd: "\u{110C}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C94E}",
        nfc: "\u{C94E}",
        nfd: "\u{110C}\u{1170}\u{11C1}",
        nfkc: "\u{C94E}",
        nfkd: "\u{110C}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C94F}",
        nfc: "\u{C94F}",
        nfd: "\u{110C}\u{1170}\u{11C2}",
        nfkc: "\u{C94F}",
        nfkd: "\u{110C}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C950}",
        nfc: "\u{C950}",
        nfd: "\u{110C}\u{1171}",
        nfkc: "\u{C950}",
        nfkd: "\u{110C}\u{1171}",
    },
    NormalizationTest {
        source: "\u{C951}",
        nfc: "\u{C951}",
        nfd: "\u{110C}\u{1171}\u{11A8}",
        nfkc: "\u{C951}",
        nfkd: "\u{110C}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C952}",
        nfc: "\u{C952}",
        nfd: "\u{110C}\u{1171}\u{11A9}",
        nfkc: "\u{C952}",
        nfkd: "\u{110C}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C953}",
        nfc: "\u{C953}",
        nfd: "\u{110C}\u{1171}\u{11AA}",
        nfkc: "\u{C953}",
        nfkd: "\u{110C}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C954}",
        nfc: "\u{C954}",
        nfd: "\u{110C}\u{1171}\u{11AB}",
        nfkc: "\u{C954}",
        nfkd: "\u{110C}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C955}",
        nfc: "\u{C955}",
        nfd: "\u{110C}\u{1171}\u{11AC}",
        nfkc: "\u{C955}",
        nfkd: "\u{110C}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C956}",
        nfc: "\u{C956}",
        nfd: "\u{110C}\u{1171}\u{11AD}",
        nfkc: "\u{C956}",
        nfkd: "\u{110C}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C957}",
        nfc: "\u{C957}",
        nfd: "\u{110C}\u{1171}\u{11AE}",
        nfkc: "\u{C957}",
        nfkd: "\u{110C}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C958}",
        nfc: "\u{C958}",
        nfd: "\u{110C}\u{1171}\u{11AF}",
        nfkc: "\u{C958}",
        nfkd: "\u{110C}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C959}",
        nfc: "\u{C959}",
        nfd: "\u{110C}\u{1171}\u{11B0}",
        nfkc: "\u{C959}",
        nfkd: "\u{110C}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C95A}",
        nfc: "\u{C95A}",
        nfd: "\u{110C}\u{1171}\u{11B1}",
        nfkc: "\u{C95A}",
        nfkd: "\u{110C}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C95B}",
        nfc: "\u{C95B}",
        nfd: "\u{110C}\u{1171}\u{11B2}",
        nfkc: "\u{C95B}",
        nfkd: "\u{110C}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C95C}",
        nfc: "\u{C95C}",
        nfd: "\u{110C}\u{1171}\u{11B3}",
        nfkc: "\u{C95C}",
        nfkd: "\u{110C}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C95D}",
        nfc: "\u{C95D}",
        nfd: "\u{110C}\u{1171}\u{11B4}",
        nfkc: "\u{C95D}",
        nfkd: "\u{110C}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C95E}",
        nfc: "\u{C95E}",
        nfd: "\u{110C}\u{1171}\u{11B5}",
        nfkc: "\u{C95E}",
        nfkd: "\u{110C}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C95F}",
        nfc: "\u{C95F}",
        nfd: "\u{110C}\u{1171}\u{11B6}",
        nfkc: "\u{C95F}",
        nfkd: "\u{110C}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C960}",
        nfc: "\u{C960}",
        nfd: "\u{110C}\u{1171}\u{11B7}",
        nfkc: "\u{C960}",
        nfkd: "\u{110C}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C961}",
        nfc: "\u{C961}",
        nfd: "\u{110C}\u{1171}\u{11B8}",
        nfkc: "\u{C961}",
        nfkd: "\u{110C}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C962}",
        nfc: "\u{C962}",
        nfd: "\u{110C}\u{1171}\u{11B9}",
        nfkc: "\u{C962}",
        nfkd: "\u{110C}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C963}",
        nfc: "\u{C963}",
        nfd: "\u{110C}\u{1171}\u{11BA}",
        nfkc: "\u{C963}",
        nfkd: "\u{110C}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C964}",
        nfc: "\u{C964}",
        nfd: "\u{110C}\u{1171}\u{11BB}",
        nfkc: "\u{C964}",
        nfkd: "\u{110C}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C965}",
        nfc: "\u{C965}",
        nfd: "\u{110C}\u{1171}\u{11BC}",
        nfkc: "\u{C965}",
        nfkd: "\u{110C}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C966}",
        nfc: "\u{C966}",
        nfd: "\u{110C}\u{1171}\u{11BD}",
        nfkc: "\u{C966}",
        nfkd: "\u{110C}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C967}",
        nfc: "\u{C967}",
        nfd: "\u{110C}\u{1171}\u{11BE}",
        nfkc: "\u{C967}",
        nfkd: "\u{110C}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C968}",
        nfc: "\u{C968}",
        nfd: "\u{110C}\u{1171}\u{11BF}",
        nfkc: "\u{C968}",
        nfkd: "\u{110C}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C969}",
        nfc: "\u{C969}",
        nfd: "\u{110C}\u{1171}\u{11C0}",
        nfkc: "\u{C969}",
        nfkd: "\u{110C}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C96A}",
        nfc: "\u{C96A}",
        nfd: "\u{110C}\u{1171}\u{11C1}",
        nfkc: "\u{C96A}",
        nfkd: "\u{110C}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C96B}",
        nfc: "\u{C96B}",
        nfd: "\u{110C}\u{1171}\u{11C2}",
        nfkc: "\u{C96B}",
        nfkd: "\u{110C}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C96C}",
        nfc: "\u{C96C}",
        nfd: "\u{110C}\u{1172}",
        nfkc: "\u{C96C}",
        nfkd: "\u{110C}\u{1172}",
    },
    NormalizationTest {
        source: "\u{C96D}",
        nfc: "\u{C96D}",
        nfd: "\u{110C}\u{1172}\u{11A8}",
        nfkc: "\u{C96D}",
        nfkd: "\u{110C}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C96E}",
        nfc: "\u{C96E}",
        nfd: "\u{110C}\u{1172}\u{11A9}",
        nfkc: "\u{C96E}",
        nfkd: "\u{110C}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C96F}",
        nfc: "\u{C96F}",
        nfd: "\u{110C}\u{1172}\u{11AA}",
        nfkc: "\u{C96F}",
        nfkd: "\u{110C}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C970}",
        nfc: "\u{C970}",
        nfd: "\u{110C}\u{1172}\u{11AB}",
        nfkc: "\u{C970}",
        nfkd: "\u{110C}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C971}",
        nfc: "\u{C971}",
        nfd: "\u{110C}\u{1172}\u{11AC}",
        nfkc: "\u{C971}",
        nfkd: "\u{110C}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C972}",
        nfc: "\u{C972}",
        nfd: "\u{110C}\u{1172}\u{11AD}",
        nfkc: "\u{C972}",
        nfkd: "\u{110C}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C973}",
        nfc: "\u{C973}",
        nfd: "\u{110C}\u{1172}\u{11AE}",
        nfkc: "\u{C973}",
        nfkd: "\u{110C}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C974}",
        nfc: "\u{C974}",
        nfd: "\u{110C}\u{1172}\u{11AF}",
        nfkc: "\u{C974}",
        nfkd: "\u{110C}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C975}",
        nfc: "\u{C975}",
        nfd: "\u{110C}\u{1172}\u{11B0}",
        nfkc: "\u{C975}",
        nfkd: "\u{110C}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C976}",
        nfc: "\u{C976}",
        nfd: "\u{110C}\u{1172}\u{11B1}",
        nfkc: "\u{C976}",
        nfkd: "\u{110C}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C977}",
        nfc: "\u{C977}",
        nfd: "\u{110C}\u{1172}\u{11B2}",
        nfkc: "\u{C977}",
        nfkd: "\u{110C}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C978}",
        nfc: "\u{C978}",
        nfd: "\u{110C}\u{1172}\u{11B3}",
        nfkc: "\u{C978}",
        nfkd: "\u{110C}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C979}",
        nfc: "\u{C979}",
        nfd: "\u{110C}\u{1172}\u{11B4}",
        nfkc: "\u{C979}",
        nfkd: "\u{110C}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C97A}",
        nfc: "\u{C97A}",
        nfd: "\u{110C}\u{1172}\u{11B5}",
        nfkc: "\u{C97A}",
        nfkd: "\u{110C}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C97B}",
        nfc: "\u{C97B}",
        nfd: "\u{110C}\u{1172}\u{11B6}",
        nfkc: "\u{C97B}",
        nfkd: "\u{110C}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C97C}",
        nfc: "\u{C97C}",
        nfd: "\u{110C}\u{1172}\u{11B7}",
        nfkc: "\u{C97C}",
        nfkd: "\u{110C}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C97D}",
        nfc: "\u{C97D}",
        nfd: "\u{110C}\u{1172}\u{11B8}",
        nfkc: "\u{C97D}",
        nfkd: "\u{110C}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C97E}",
        nfc: "\u{C97E}",
        nfd: "\u{110C}\u{1172}\u{11B9}",
        nfkc: "\u{C97E}",
        nfkd: "\u{110C}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C97F}",
        nfc: "\u{C97F}",
        nfd: "\u{110C}\u{1172}\u{11BA}",
        nfkc: "\u{C97F}",
        nfkd: "\u{110C}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C980}",
        nfc: "\u{C980}",
        nfd: "\u{110C}\u{1172}\u{11BB}",
        nfkc: "\u{C980}",
        nfkd: "\u{110C}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C981}",
        nfc: "\u{C981}",
        nfd: "\u{110C}\u{1172}\u{11BC}",
        nfkc: "\u{C981}",
        nfkd: "\u{110C}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C982}",
        nfc: "\u{C982}",
        nfd: "\u{110C}\u{1172}\u{11BD}",
        nfkc: "\u{C982}",
        nfkd: "\u{110C}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C983}",
        nfc: "\u{C983}",
        nfd: "\u{110C}\u{1172}\u{11BE}",
        nfkc: "\u{C983}",
        nfkd: "\u{110C}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C984}",
        nfc: "\u{C984}",
        nfd: "\u{110C}\u{1172}\u{11BF}",
        nfkc: "\u{C984}",
        nfkd: "\u{110C}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C985}",
        nfc: "\u{C985}",
        nfd: "\u{110C}\u{1172}\u{11C0}",
        nfkc: "\u{C985}",
        nfkd: "\u{110C}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C986}",
        nfc: "\u{C986}",
        nfd: "\u{110C}\u{1172}\u{11C1}",
        nfkc: "\u{C986}",
        nfkd: "\u{110C}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C987}",
        nfc: "\u{C987}",
        nfd: "\u{110C}\u{1172}\u{11C2}",
        nfkc: "\u{C987}",
        nfkd: "\u{110C}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C988}",
        nfc: "\u{C988}",
        nfd: "\u{110C}\u{1173}",
        nfkc: "\u{C988}",
        nfkd: "\u{110C}\u{1173}",
    },
    NormalizationTest {
        source: "\u{C989}",
        nfc: "\u{C989}",
        nfd: "\u{110C}\u{1173}\u{11A8}",
        nfkc: "\u{C989}",
        nfkd: "\u{110C}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C98A}",
        nfc: "\u{C98A}",
        nfd: "\u{110C}\u{1173}\u{11A9}",
        nfkc: "\u{C98A}",
        nfkd: "\u{110C}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C98B}",
        nfc: "\u{C98B}",
        nfd: "\u{110C}\u{1173}\u{11AA}",
        nfkc: "\u{C98B}",
        nfkd: "\u{110C}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C98C}",
        nfc: "\u{C98C}",
        nfd: "\u{110C}\u{1173}\u{11AB}",
        nfkc: "\u{C98C}",
        nfkd: "\u{110C}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C98D}",
        nfc: "\u{C98D}",
        nfd: "\u{110C}\u{1173}\u{11AC}",
        nfkc: "\u{C98D}",
        nfkd: "\u{110C}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C98E}",
        nfc: "\u{C98E}",
        nfd: "\u{110C}\u{1173}\u{11AD}",
        nfkc: "\u{C98E}",
        nfkd: "\u{110C}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C98F}",
        nfc: "\u{C98F}",
        nfd: "\u{110C}\u{1173}\u{11AE}",
        nfkc: "\u{C98F}",
        nfkd: "\u{110C}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C990}",
        nfc: "\u{C990}",
        nfd: "\u{110C}\u{1173}\u{11AF}",
        nfkc: "\u{C990}",
        nfkd: "\u{110C}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C991}",
        nfc: "\u{C991}",
        nfd: "\u{110C}\u{1173}\u{11B0}",
        nfkc: "\u{C991}",
        nfkd: "\u{110C}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C992}",
        nfc: "\u{C992}",
        nfd: "\u{110C}\u{1173}\u{11B1}",
        nfkc: "\u{C992}",
        nfkd: "\u{110C}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C993}",
        nfc: "\u{C993}",
        nfd: "\u{110C}\u{1173}\u{11B2}",
        nfkc: "\u{C993}",
        nfkd: "\u{110C}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C994}",
        nfc: "\u{C994}",
        nfd: "\u{110C}\u{1173}\u{11B3}",
        nfkc: "\u{C994}",
        nfkd: "\u{110C}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C995}",
        nfc: "\u{C995}",
        nfd: "\u{110C}\u{1173}\u{11B4}",
        nfkc: "\u{C995}",
        nfkd: "\u{110C}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C996}",
        nfc: "\u{C996}",
        nfd: "\u{110C}\u{1173}\u{11B5}",
        nfkc: "\u{C996}",
        nfkd: "\u{110C}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C997}",
        nfc: "\u{C997}",
        nfd: "\u{110C}\u{1173}\u{11B6}",
        nfkc: "\u{C997}",
        nfkd: "\u{110C}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C998}",
        nfc: "\u{C998}",
        nfd: "\u{110C}\u{1173}\u{11B7}",
        nfkc: "\u{C998}",
        nfkd: "\u{110C}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C999}",
        nfc: "\u{C999}",
        nfd: "\u{110C}\u{1173}\u{11B8}",
        nfkc: "\u{C999}",
        nfkd: "\u{110C}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C99A}",
        nfc: "\u{C99A}",
        nfd: "\u{110C}\u{1173}\u{11B9}",
        nfkc: "\u{C99A}",
        nfkd: "\u{110C}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C99B}",
        nfc: "\u{C99B}",
        nfd: "\u{110C}\u{1173}\u{11BA}",
        nfkc: "\u{C99B}",
        nfkd: "\u{110C}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C99C}",
        nfc: "\u{C99C}",
        nfd: "\u{110C}\u{1173}\u{11BB}",
        nfkc: "\u{C99C}",
        nfkd: "\u{110C}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C99D}",
        nfc: "\u{C99D}",
        nfd: "\u{110C}\u{1173}\u{11BC}",
        nfkc: "\u{C99D}",
        nfkd: "\u{110C}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C99E}",
        nfc: "\u{C99E}",
        nfd: "\u{110C}\u{1173}\u{11BD}",
        nfkc: "\u{C99E}",
        nfkd: "\u{110C}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C99F}",
        nfc: "\u{C99F}",
        nfd: "\u{110C}\u{1173}\u{11BE}",
        nfkc: "\u{C99F}",
        nfkd: "\u{110C}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C9A0}",
        nfc: "\u{C9A0}",
        nfd: "\u{110C}\u{1173}\u{11BF}",
        nfkc: "\u{C9A0}",
        nfkd: "\u{110C}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C9A1}",
        nfc: "\u{C9A1}",
        nfd: "\u{110C}\u{1173}\u{11C0}",
        nfkc: "\u{C9A1}",
        nfkd: "\u{110C}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C9A2}",
        nfc: "\u{C9A2}",
        nfd: "\u{110C}\u{1173}\u{11C1}",
        nfkc: "\u{C9A2}",
        nfkd: "\u{110C}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C9A3}",
        nfc: "\u{C9A3}",
        nfd: "\u{110C}\u{1173}\u{11C2}",
        nfkc: "\u{C9A3}",
        nfkd: "\u{110C}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C9A4}",
        nfc: "\u{C9A4}",
        nfd: "\u{110C}\u{1174}",
        nfkc: "\u{C9A4}",
        nfkd: "\u{110C}\u{1174}",
    },
    NormalizationTest {
        source: "\u{C9A5}",
        nfc: "\u{C9A5}",
        nfd: "\u{110C}\u{1174}\u{11A8}",
        nfkc: "\u{C9A5}",
        nfkd: "\u{110C}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C9A6}",
        nfc: "\u{C9A6}",
        nfd: "\u{110C}\u{1174}\u{11A9}",
        nfkc: "\u{C9A6}",
        nfkd: "\u{110C}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C9A7}",
        nfc: "\u{C9A7}",
        nfd: "\u{110C}\u{1174}\u{11AA}",
        nfkc: "\u{C9A7}",
        nfkd: "\u{110C}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C9A8}",
        nfc: "\u{C9A8}",
        nfd: "\u{110C}\u{1174}\u{11AB}",
        nfkc: "\u{C9A8}",
        nfkd: "\u{110C}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C9A9}",
        nfc: "\u{C9A9}",
        nfd: "\u{110C}\u{1174}\u{11AC}",
        nfkc: "\u{C9A9}",
        nfkd: "\u{110C}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C9AA}",
        nfc: "\u{C9AA}",
        nfd: "\u{110C}\u{1174}\u{11AD}",
        nfkc: "\u{C9AA}",
        nfkd: "\u{110C}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C9AB}",
        nfc: "\u{C9AB}",
        nfd: "\u{110C}\u{1174}\u{11AE}",
        nfkc: "\u{C9AB}",
        nfkd: "\u{110C}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C9AC}",
        nfc: "\u{C9AC}",
        nfd: "\u{110C}\u{1174}\u{11AF}",
        nfkc: "\u{C9AC}",
        nfkd: "\u{110C}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C9AD}",
        nfc: "\u{C9AD}",
        nfd: "\u{110C}\u{1174}\u{11B0}",
        nfkc: "\u{C9AD}",
        nfkd: "\u{110C}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C9AE}",
        nfc: "\u{C9AE}",
        nfd: "\u{110C}\u{1174}\u{11B1}",
        nfkc: "\u{C9AE}",
        nfkd: "\u{110C}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C9AF}",
        nfc: "\u{C9AF}",
        nfd: "\u{110C}\u{1174}\u{11B2}",
        nfkc: "\u{C9AF}",
        nfkd: "\u{110C}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C9B0}",
        nfc: "\u{C9B0}",
        nfd: "\u{110C}\u{1174}\u{11B3}",
        nfkc: "\u{C9B0}",
        nfkd: "\u{110C}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C9B1}",
        nfc: "\u{C9B1}",
        nfd: "\u{110C}\u{1174}\u{11B4}",
        nfkc: "\u{C9B1}",
        nfkd: "\u{110C}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C9B2}",
        nfc: "\u{C9B2}",
        nfd: "\u{110C}\u{1174}\u{11B5}",
        nfkc: "\u{C9B2}",
        nfkd: "\u{110C}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C9B3}",
        nfc: "\u{C9B3}",
        nfd: "\u{110C}\u{1174}\u{11B6}",
        nfkc: "\u{C9B3}",
        nfkd: "\u{110C}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C9B4}",
        nfc: "\u{C9B4}",
        nfd: "\u{110C}\u{1174}\u{11B7}",
        nfkc: "\u{C9B4}",
        nfkd: "\u{110C}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C9B5}",
        nfc: "\u{C9B5}",
        nfd: "\u{110C}\u{1174}\u{11B8}",
        nfkc: "\u{C9B5}",
        nfkd: "\u{110C}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C9B6}",
        nfc: "\u{C9B6}",
        nfd: "\u{110C}\u{1174}\u{11B9}",
        nfkc: "\u{C9B6}",
        nfkd: "\u{110C}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C9B7}",
        nfc: "\u{C9B7}",
        nfd: "\u{110C}\u{1174}\u{11BA}",
        nfkc: "\u{C9B7}",
        nfkd: "\u{110C}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C9B8}",
        nfc: "\u{C9B8}",
        nfd: "\u{110C}\u{1174}\u{11BB}",
        nfkc: "\u{C9B8}",
        nfkd: "\u{110C}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C9B9}",
        nfc: "\u{C9B9}",
        nfd: "\u{110C}\u{1174}\u{11BC}",
        nfkc: "\u{C9B9}",
        nfkd: "\u{110C}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C9BA}",
        nfc: "\u{C9BA}",
        nfd: "\u{110C}\u{1174}\u{11BD}",
        nfkc: "\u{C9BA}",
        nfkd: "\u{110C}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C9BB}",
        nfc: "\u{C9BB}",
        nfd: "\u{110C}\u{1174}\u{11BE}",
        nfkc: "\u{C9BB}",
        nfkd: "\u{110C}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C9BC}",
        nfc: "\u{C9BC}",
        nfd: "\u{110C}\u{1174}\u{11BF}",
        nfkc: "\u{C9BC}",
        nfkd: "\u{110C}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C9BD}",
        nfc: "\u{C9BD}",
        nfd: "\u{110C}\u{1174}\u{11C0}",
        nfkc: "\u{C9BD}",
        nfkd: "\u{110C}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C9BE}",
        nfc: "\u{C9BE}",
        nfd: "\u{110C}\u{1174}\u{11C1}",
        nfkc: "\u{C9BE}",
        nfkd: "\u{110C}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C9BF}",
        nfc: "\u{C9BF}",
        nfd: "\u{110C}\u{1174}\u{11C2}",
        nfkc: "\u{C9BF}",
        nfkd: "\u{110C}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C9C0}",
        nfc: "\u{C9C0}",
        nfd: "\u{110C}\u{1175}",
        nfkc: "\u{C9C0}",
        nfkd: "\u{110C}\u{1175}",
    },
    NormalizationTest {
        source: "\u{C9C1}",
        nfc: "\u{C9C1}",
        nfd: "\u{110C}\u{1175}\u{11A8}",
        nfkc: "\u{C9C1}",
        nfkd: "\u{110C}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C9C2}",
        nfc: "\u{C9C2}",
        nfd: "\u{110C}\u{1175}\u{11A9}",
        nfkc: "\u{C9C2}",
        nfkd: "\u{110C}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C9C3}",
        nfc: "\u{C9C3}",
        nfd: "\u{110C}\u{1175}\u{11AA}",
        nfkc: "\u{C9C3}",
        nfkd: "\u{110C}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C9C4}",
        nfc: "\u{C9C4}",
        nfd: "\u{110C}\u{1175}\u{11AB}",
        nfkc: "\u{C9C4}",
        nfkd: "\u{110C}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C9C5}",
        nfc: "\u{C9C5}",
        nfd: "\u{110C}\u{1175}\u{11AC}",
        nfkc: "\u{C9C5}",
        nfkd: "\u{110C}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C9C6}",
        nfc: "\u{C9C6}",
        nfd: "\u{110C}\u{1175}\u{11AD}",
        nfkc: "\u{C9C6}",
        nfkd: "\u{110C}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C9C7}",
        nfc: "\u{C9C7}",
        nfd: "\u{110C}\u{1175}\u{11AE}",
        nfkc: "\u{C9C7}",
        nfkd: "\u{110C}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C9C8}",
        nfc: "\u{C9C8}",
        nfd: "\u{110C}\u{1175}\u{11AF}",
        nfkc: "\u{C9C8}",
        nfkd: "\u{110C}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C9C9}",
        nfc: "\u{C9C9}",
        nfd: "\u{110C}\u{1175}\u{11B0}",
        nfkc: "\u{C9C9}",
        nfkd: "\u{110C}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C9CA}",
        nfc: "\u{C9CA}",
        nfd: "\u{110C}\u{1175}\u{11B1}",
        nfkc: "\u{C9CA}",
        nfkd: "\u{110C}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C9CB}",
        nfc: "\u{C9CB}",
        nfd: "\u{110C}\u{1175}\u{11B2}",
        nfkc: "\u{C9CB}",
        nfkd: "\u{110C}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C9CC}",
        nfc: "\u{C9CC}",
        nfd: "\u{110C}\u{1175}\u{11B3}",
        nfkc: "\u{C9CC}",
        nfkd: "\u{110C}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C9CD}",
        nfc: "\u{C9CD}",
        nfd: "\u{110C}\u{1175}\u{11B4}",
        nfkc: "\u{C9CD}",
        nfkd: "\u{110C}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C9CE}",
        nfc: "\u{C9CE}",
        nfd: "\u{110C}\u{1175}\u{11B5}",
        nfkc: "\u{C9CE}",
        nfkd: "\u{110C}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C9CF}",
        nfc: "\u{C9CF}",
        nfd: "\u{110C}\u{1175}\u{11B6}",
        nfkc: "\u{C9CF}",
        nfkd: "\u{110C}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C9D0}",
        nfc: "\u{C9D0}",
        nfd: "\u{110C}\u{1175}\u{11B7}",
        nfkc: "\u{C9D0}",
        nfkd: "\u{110C}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C9D1}",
        nfc: "\u{C9D1}",
        nfd: "\u{110C}\u{1175}\u{11B8}",
        nfkc: "\u{C9D1}",
        nfkd: "\u{110C}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C9D2}",
        nfc: "\u{C9D2}",
        nfd: "\u{110C}\u{1175}\u{11B9}",
        nfkc: "\u{C9D2}",
        nfkd: "\u{110C}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C9D3}",
        nfc: "\u{C9D3}",
        nfd: "\u{110C}\u{1175}\u{11BA}",
        nfkc: "\u{C9D3}",
        nfkd: "\u{110C}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C9D4}",
        nfc: "\u{C9D4}",
        nfd: "\u{110C}\u{1175}\u{11BB}",
        nfkc: "\u{C9D4}",
        nfkd: "\u{110C}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C9D5}",
        nfc: "\u{C9D5}",
        nfd: "\u{110C}\u{1175}\u{11BC}",
        nfkc: "\u{C9D5}",
        nfkd: "\u{110C}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C9D6}",
        nfc: "\u{C9D6}",
        nfd: "\u{110C}\u{1175}\u{11BD}",
        nfkc: "\u{C9D6}",
        nfkd: "\u{110C}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C9D7}",
        nfc: "\u{C9D7}",
        nfd: "\u{110C}\u{1175}\u{11BE}",
        nfkc: "\u{C9D7}",
        nfkd: "\u{110C}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C9D8}",
        nfc: "\u{C9D8}",
        nfd: "\u{110C}\u{1175}\u{11BF}",
        nfkc: "\u{C9D8}",
        nfkd: "\u{110C}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C9D9}",
        nfc: "\u{C9D9}",
        nfd: "\u{110C}\u{1175}\u{11C0}",
        nfkc: "\u{C9D9}",
        nfkd: "\u{110C}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C9DA}",
        nfc: "\u{C9DA}",
        nfd: "\u{110C}\u{1175}\u{11C1}",
        nfkc: "\u{C9DA}",
        nfkd: "\u{110C}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C9DB}",
        nfc: "\u{C9DB}",
        nfd: "\u{110C}\u{1175}\u{11C2}",
        nfkc: "\u{C9DB}",
        nfkd: "\u{110C}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C9DC}",
        nfc: "\u{C9DC}",
        nfd: "\u{110D}\u{1161}",
        nfkc: "\u{C9DC}",
        nfkd: "\u{110D}\u{1161}",
    },
    NormalizationTest {
        source: "\u{C9DD}",
        nfc: "\u{C9DD}",
        nfd: "\u{110D}\u{1161}\u{11A8}",
        nfkc: "\u{C9DD}",
        nfkd: "\u{110D}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C9DE}",
        nfc: "\u{C9DE}",
        nfd: "\u{110D}\u{1161}\u{11A9}",
        nfkc: "\u{C9DE}",
        nfkd: "\u{110D}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C9DF}",
        nfc: "\u{C9DF}",
        nfd: "\u{110D}\u{1161}\u{11AA}",
        nfkc: "\u{C9DF}",
        nfkd: "\u{110D}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C9E0}",
        nfc: "\u{C9E0}",
        nfd: "\u{110D}\u{1161}\u{11AB}",
        nfkc: "\u{C9E0}",
        nfkd: "\u{110D}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C9E1}",
        nfc: "\u{C9E1}",
        nfd: "\u{110D}\u{1161}\u{11AC}",
        nfkc: "\u{C9E1}",
        nfkd: "\u{110D}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C9E2}",
        nfc: "\u{C9E2}",
        nfd: "\u{110D}\u{1161}\u{11AD}",
        nfkc: "\u{C9E2}",
        nfkd: "\u{110D}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C9E3}",
        nfc: "\u{C9E3}",
        nfd: "\u{110D}\u{1161}\u{11AE}",
        nfkc: "\u{C9E3}",
        nfkd: "\u{110D}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C9E4}",
        nfc: "\u{C9E4}",
        nfd: "\u{110D}\u{1161}\u{11AF}",
        nfkc: "\u{C9E4}",
        nfkd: "\u{110D}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{C9E5}",
        nfc: "\u{C9E5}",
        nfd: "\u{110D}\u{1161}\u{11B0}",
        nfkc: "\u{C9E5}",
        nfkd: "\u{110D}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{C9E6}",
        nfc: "\u{C9E6}",
        nfd: "\u{110D}\u{1161}\u{11B1}",
        nfkc: "\u{C9E6}",
        nfkd: "\u{110D}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{C9E7}",
        nfc: "\u{C9E7}",
        nfd: "\u{110D}\u{1161}\u{11B2}",
        nfkc: "\u{C9E7}",
        nfkd: "\u{110D}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{C9E8}",
        nfc: "\u{C9E8}",
        nfd: "\u{110D}\u{1161}\u{11B3}",
        nfkc: "\u{C9E8}",
        nfkd: "\u{110D}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{C9E9}",
        nfc: "\u{C9E9}",
        nfd: "\u{110D}\u{1161}\u{11B4}",
        nfkc: "\u{C9E9}",
        nfkd: "\u{110D}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{C9EA}",
        nfc: "\u{C9EA}",
        nfd: "\u{110D}\u{1161}\u{11B5}",
        nfkc: "\u{C9EA}",
        nfkd: "\u{110D}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C9EB}",
        nfc: "\u{C9EB}",
        nfd: "\u{110D}\u{1161}\u{11B6}",
        nfkc: "\u{C9EB}",
        nfkd: "\u{110D}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{C9EC}",
        nfc: "\u{C9EC}",
        nfd: "\u{110D}\u{1161}\u{11B7}",
        nfkc: "\u{C9EC}",
        nfkd: "\u{110D}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{C9ED}",
        nfc: "\u{C9ED}",
        nfd: "\u{110D}\u{1161}\u{11B8}",
        nfkc: "\u{C9ED}",
        nfkd: "\u{110D}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{C9EE}",
        nfc: "\u{C9EE}",
        nfd: "\u{110D}\u{1161}\u{11B9}",
        nfkc: "\u{C9EE}",
        nfkd: "\u{110D}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{C9EF}",
        nfc: "\u{C9EF}",
        nfd: "\u{110D}\u{1161}\u{11BA}",
        nfkc: "\u{C9EF}",
        nfkd: "\u{110D}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{C9F0}",
        nfc: "\u{C9F0}",
        nfd: "\u{110D}\u{1161}\u{11BB}",
        nfkc: "\u{C9F0}",
        nfkd: "\u{110D}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{C9F1}",
        nfc: "\u{C9F1}",
        nfd: "\u{110D}\u{1161}\u{11BC}",
        nfkc: "\u{C9F1}",
        nfkd: "\u{110D}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C9F2}",
        nfc: "\u{C9F2}",
        nfd: "\u{110D}\u{1161}\u{11BD}",
        nfkc: "\u{C9F2}",
        nfkd: "\u{110D}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{C9F3}",
        nfc: "\u{C9F3}",
        nfd: "\u{110D}\u{1161}\u{11BE}",
        nfkc: "\u{C9F3}",
        nfkd: "\u{110D}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{C9F4}",
        nfc: "\u{C9F4}",
        nfd: "\u{110D}\u{1161}\u{11BF}",
        nfkc: "\u{C9F4}",
        nfkd: "\u{110D}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{C9F5}",
        nfc: "\u{C9F5}",
        nfd: "\u{110D}\u{1161}\u{11C0}",
        nfkc: "\u{C9F5}",
        nfkd: "\u{110D}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{C9F6}",
        nfc: "\u{C9F6}",
        nfd: "\u{110D}\u{1161}\u{11C1}",
        nfkc: "\u{C9F6}",
        nfkd: "\u{110D}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{C9F7}",
        nfc: "\u{C9F7}",
        nfd: "\u{110D}\u{1161}\u{11C2}",
        nfkc: "\u{C9F7}",
        nfkd: "\u{110D}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{C9F8}",
        nfc: "\u{C9F8}",
        nfd: "\u{110D}\u{1162}",
        nfkc: "\u{C9F8}",
        nfkd: "\u{110D}\u{1162}",
    },
    NormalizationTest {
        source: "\u{C9F9}",
        nfc: "\u{C9F9}",
        nfd: "\u{110D}\u{1162}\u{11A8}",
        nfkc: "\u{C9F9}",
        nfkd: "\u{110D}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{C9FA}",
        nfc: "\u{C9FA}",
        nfd: "\u{110D}\u{1162}\u{11A9}",
        nfkc: "\u{C9FA}",
        nfkd: "\u{110D}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{C9FB}",
        nfc: "\u{C9FB}",
        nfd: "\u{110D}\u{1162}\u{11AA}",
        nfkc: "\u{C9FB}",
        nfkd: "\u{110D}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{C9FC}",
        nfc: "\u{C9FC}",
        nfd: "\u{110D}\u{1162}\u{11AB}",
        nfkc: "\u{C9FC}",
        nfkd: "\u{110D}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{C9FD}",
        nfc: "\u{C9FD}",
        nfd: "\u{110D}\u{1162}\u{11AC}",
        nfkc: "\u{C9FD}",
        nfkd: "\u{110D}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{C9FE}",
        nfc: "\u{C9FE}",
        nfd: "\u{110D}\u{1162}\u{11AD}",
        nfkc: "\u{C9FE}",
        nfkd: "\u{110D}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{C9FF}",
        nfc: "\u{C9FF}",
        nfd: "\u{110D}\u{1162}\u{11AE}",
        nfkc: "\u{C9FF}",
        nfkd: "\u{110D}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CA00}",
        nfc: "\u{CA00}",
        nfd: "\u{110D}\u{1162}\u{11AF}",
        nfkc: "\u{CA00}",
        nfkd: "\u{110D}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CA01}",
        nfc: "\u{CA01}",
        nfd: "\u{110D}\u{1162}\u{11B0}",
        nfkc: "\u{CA01}",
        nfkd: "\u{110D}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CA02}",
        nfc: "\u{CA02}",
        nfd: "\u{110D}\u{1162}\u{11B1}",
        nfkc: "\u{CA02}",
        nfkd: "\u{110D}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CA03}",
        nfc: "\u{CA03}",
        nfd: "\u{110D}\u{1162}\u{11B2}",
        nfkc: "\u{CA03}",
        nfkd: "\u{110D}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CA04}",
        nfc: "\u{CA04}",
        nfd: "\u{110D}\u{1162}\u{11B3}",
        nfkc: "\u{CA04}",
        nfkd: "\u{110D}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CA05}",
        nfc: "\u{CA05}",
        nfd: "\u{110D}\u{1162}\u{11B4}",
        nfkc: "\u{CA05}",
        nfkd: "\u{110D}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CA06}",
        nfc: "\u{CA06}",
        nfd: "\u{110D}\u{1162}\u{11B5}",
        nfkc: "\u{CA06}",
        nfkd: "\u{110D}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CA07}",
        nfc: "\u{CA07}",
        nfd: "\u{110D}\u{1162}\u{11B6}",
        nfkc: "\u{CA07}",
        nfkd: "\u{110D}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CA08}",
        nfc: "\u{CA08}",
        nfd: "\u{110D}\u{1162}\u{11B7}",
        nfkc: "\u{CA08}",
        nfkd: "\u{110D}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CA09}",
        nfc: "\u{CA09}",
        nfd: "\u{110D}\u{1162}\u{11B8}",
        nfkc: "\u{CA09}",
        nfkd: "\u{110D}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CA0A}",
        nfc: "\u{CA0A}",
        nfd: "\u{110D}\u{1162}\u{11B9}",
        nfkc: "\u{CA0A}",
        nfkd: "\u{110D}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CA0B}",
        nfc: "\u{CA0B}",
        nfd: "\u{110D}\u{1162}\u{11BA}",
        nfkc: "\u{CA0B}",
        nfkd: "\u{110D}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CA0C}",
        nfc: "\u{CA0C}",
        nfd: "\u{110D}\u{1162}\u{11BB}",
        nfkc: "\u{CA0C}",
        nfkd: "\u{110D}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CA0D}",
        nfc: "\u{CA0D}",
        nfd: "\u{110D}\u{1162}\u{11BC}",
        nfkc: "\u{CA0D}",
        nfkd: "\u{110D}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CA0E}",
        nfc: "\u{CA0E}",
        nfd: "\u{110D}\u{1162}\u{11BD}",
        nfkc: "\u{CA0E}",
        nfkd: "\u{110D}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CA0F}",
        nfc: "\u{CA0F}",
        nfd: "\u{110D}\u{1162}\u{11BE}",
        nfkc: "\u{CA0F}",
        nfkd: "\u{110D}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CA10}",
        nfc: "\u{CA10}",
        nfd: "\u{110D}\u{1162}\u{11BF}",
        nfkc: "\u{CA10}",
        nfkd: "\u{110D}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CA11}",
        nfc: "\u{CA11}",
        nfd: "\u{110D}\u{1162}\u{11C0}",
        nfkc: "\u{CA11}",
        nfkd: "\u{110D}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CA12}",
        nfc: "\u{CA12}",
        nfd: "\u{110D}\u{1162}\u{11C1}",
        nfkc: "\u{CA12}",
        nfkd: "\u{110D}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CA13}",
        nfc: "\u{CA13}",
        nfd: "\u{110D}\u{1162}\u{11C2}",
        nfkc: "\u{CA13}",
        nfkd: "\u{110D}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CA14}",
        nfc: "\u{CA14}",
        nfd: "\u{110D}\u{1163}",
        nfkc: "\u{CA14}",
        nfkd: "\u{110D}\u{1163}",
    },
    NormalizationTest {
        source: "\u{CA15}",
        nfc: "\u{CA15}",
        nfd: "\u{110D}\u{1163}\u{11A8}",
        nfkc: "\u{CA15}",
        nfkd: "\u{110D}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CA16}",
        nfc: "\u{CA16}",
        nfd: "\u{110D}\u{1163}\u{11A9}",
        nfkc: "\u{CA16}",
        nfkd: "\u{110D}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CA17}",
        nfc: "\u{CA17}",
        nfd: "\u{110D}\u{1163}\u{11AA}",
        nfkc: "\u{CA17}",
        nfkd: "\u{110D}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CA18}",
        nfc: "\u{CA18}",
        nfd: "\u{110D}\u{1163}\u{11AB}",
        nfkc: "\u{CA18}",
        nfkd: "\u{110D}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CA19}",
        nfc: "\u{CA19}",
        nfd: "\u{110D}\u{1163}\u{11AC}",
        nfkc: "\u{CA19}",
        nfkd: "\u{110D}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CA1A}",
        nfc: "\u{CA1A}",
        nfd: "\u{110D}\u{1163}\u{11AD}",
        nfkc: "\u{CA1A}",
        nfkd: "\u{110D}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CA1B}",
        nfc: "\u{CA1B}",
        nfd: "\u{110D}\u{1163}\u{11AE}",
        nfkc: "\u{CA1B}",
        nfkd: "\u{110D}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CA1C}",
        nfc: "\u{CA1C}",
        nfd: "\u{110D}\u{1163}\u{11AF}",
        nfkc: "\u{CA1C}",
        nfkd: "\u{110D}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CA1D}",
        nfc: "\u{CA1D}",
        nfd: "\u{110D}\u{1163}\u{11B0}",
        nfkc: "\u{CA1D}",
        nfkd: "\u{110D}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CA1E}",
        nfc: "\u{CA1E}",
        nfd: "\u{110D}\u{1163}\u{11B1}",
        nfkc: "\u{CA1E}",
        nfkd: "\u{110D}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CA1F}",
        nfc: "\u{CA1F}",
        nfd: "\u{110D}\u{1163}\u{11B2}",
        nfkc: "\u{CA1F}",
        nfkd: "\u{110D}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CA20}",
        nfc: "\u{CA20}",
        nfd: "\u{110D}\u{1163}\u{11B3}",
        nfkc: "\u{CA20}",
        nfkd: "\u{110D}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CA21}",
        nfc: "\u{CA21}",
        nfd: "\u{110D}\u{1163}\u{11B4}",
        nfkc: "\u{CA21}",
        nfkd: "\u{110D}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CA22}",
        nfc: "\u{CA22}",
        nfd: "\u{110D}\u{1163}\u{11B5}",
        nfkc: "\u{CA22}",
        nfkd: "\u{110D}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CA23}",
        nfc: "\u{CA23}",
        nfd: "\u{110D}\u{1163}\u{11B6}",
        nfkc: "\u{CA23}",
        nfkd: "\u{110D}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CA24}",
        nfc: "\u{CA24}",
        nfd: "\u{110D}\u{1163}\u{11B7}",
        nfkc: "\u{CA24}",
        nfkd: "\u{110D}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CA25}",
        nfc: "\u{CA25}",
        nfd: "\u{110D}\u{1163}\u{11B8}",
        nfkc: "\u{CA25}",
        nfkd: "\u{110D}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CA26}",
        nfc: "\u{CA26}",
        nfd: "\u{110D}\u{1163}\u{11B9}",
        nfkc: "\u{CA26}",
        nfkd: "\u{110D}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CA27}",
        nfc: "\u{CA27}",
        nfd: "\u{110D}\u{1163}\u{11BA}",
        nfkc: "\u{CA27}",
        nfkd: "\u{110D}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CA28}",
        nfc: "\u{CA28}",
        nfd: "\u{110D}\u{1163}\u{11BB}",
        nfkc: "\u{CA28}",
        nfkd: "\u{110D}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CA29}",
        nfc: "\u{CA29}",
        nfd: "\u{110D}\u{1163}\u{11BC}",
        nfkc: "\u{CA29}",
        nfkd: "\u{110D}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CA2A}",
        nfc: "\u{CA2A}",
        nfd: "\u{110D}\u{1163}\u{11BD}",
        nfkc: "\u{CA2A}",
        nfkd: "\u{110D}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CA2B}",
        nfc: "\u{CA2B}",
        nfd: "\u{110D}\u{1163}\u{11BE}",
        nfkc: "\u{CA2B}",
        nfkd: "\u{110D}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CA2C}",
        nfc: "\u{CA2C}",
        nfd: "\u{110D}\u{1163}\u{11BF}",
        nfkc: "\u{CA2C}",
        nfkd: "\u{110D}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CA2D}",
        nfc: "\u{CA2D}",
        nfd: "\u{110D}\u{1163}\u{11C0}",
        nfkc: "\u{CA2D}",
        nfkd: "\u{110D}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CA2E}",
        nfc: "\u{CA2E}",
        nfd: "\u{110D}\u{1163}\u{11C1}",
        nfkc: "\u{CA2E}",
        nfkd: "\u{110D}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CA2F}",
        nfc: "\u{CA2F}",
        nfd: "\u{110D}\u{1163}\u{11C2}",
        nfkc: "\u{CA2F}",
        nfkd: "\u{110D}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CA30}",
        nfc: "\u{CA30}",
        nfd: "\u{110D}\u{1164}",
        nfkc: "\u{CA30}",
        nfkd: "\u{110D}\u{1164}",
    },
    NormalizationTest {
        source: "\u{CA31}",
        nfc: "\u{CA31}",
        nfd: "\u{110D}\u{1164}\u{11A8}",
        nfkc: "\u{CA31}",
        nfkd: "\u{110D}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CA32}",
        nfc: "\u{CA32}",
        nfd: "\u{110D}\u{1164}\u{11A9}",
        nfkc: "\u{CA32}",
        nfkd: "\u{110D}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CA33}",
        nfc: "\u{CA33}",
        nfd: "\u{110D}\u{1164}\u{11AA}",
        nfkc: "\u{CA33}",
        nfkd: "\u{110D}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CA34}",
        nfc: "\u{CA34}",
        nfd: "\u{110D}\u{1164}\u{11AB}",
        nfkc: "\u{CA34}",
        nfkd: "\u{110D}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CA35}",
        nfc: "\u{CA35}",
        nfd: "\u{110D}\u{1164}\u{11AC}",
        nfkc: "\u{CA35}",
        nfkd: "\u{110D}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CA36}",
        nfc: "\u{CA36}",
        nfd: "\u{110D}\u{1164}\u{11AD}",
        nfkc: "\u{CA36}",
        nfkd: "\u{110D}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CA37}",
        nfc: "\u{CA37}",
        nfd: "\u{110D}\u{1164}\u{11AE}",
        nfkc: "\u{CA37}",
        nfkd: "\u{110D}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CA38}",
        nfc: "\u{CA38}",
        nfd: "\u{110D}\u{1164}\u{11AF}",
        nfkc: "\u{CA38}",
        nfkd: "\u{110D}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CA39}",
        nfc: "\u{CA39}",
        nfd: "\u{110D}\u{1164}\u{11B0}",
        nfkc: "\u{CA39}",
        nfkd: "\u{110D}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CA3A}",
        nfc: "\u{CA3A}",
        nfd: "\u{110D}\u{1164}\u{11B1}",
        nfkc: "\u{CA3A}",
        nfkd: "\u{110D}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CA3B}",
        nfc: "\u{CA3B}",
        nfd: "\u{110D}\u{1164}\u{11B2}",
        nfkc: "\u{CA3B}",
        nfkd: "\u{110D}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CA3C}",
        nfc: "\u{CA3C}",
        nfd: "\u{110D}\u{1164}\u{11B3}",
        nfkc: "\u{CA3C}",
        nfkd: "\u{110D}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CA3D}",
        nfc: "\u{CA3D}",
        nfd: "\u{110D}\u{1164}\u{11B4}",
        nfkc: "\u{CA3D}",
        nfkd: "\u{110D}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CA3E}",
        nfc: "\u{CA3E}",
        nfd: "\u{110D}\u{1164}\u{11B5}",
        nfkc: "\u{CA3E}",
        nfkd: "\u{110D}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CA3F}",
        nfc: "\u{CA3F}",
        nfd: "\u{110D}\u{1164}\u{11B6}",
        nfkc: "\u{CA3F}",
        nfkd: "\u{110D}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CA40}",
        nfc: "\u{CA40}",
        nfd: "\u{110D}\u{1164}\u{11B7}",
        nfkc: "\u{CA40}",
        nfkd: "\u{110D}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CA41}",
        nfc: "\u{CA41}",
        nfd: "\u{110D}\u{1164}\u{11B8}",
        nfkc: "\u{CA41}",
        nfkd: "\u{110D}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CA42}",
        nfc: "\u{CA42}",
        nfd: "\u{110D}\u{1164}\u{11B9}",
        nfkc: "\u{CA42}",
        nfkd: "\u{110D}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CA43}",
        nfc: "\u{CA43}",
        nfd: "\u{110D}\u{1164}\u{11BA}",
        nfkc: "\u{CA43}",
        nfkd: "\u{110D}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CA44}",
        nfc: "\u{CA44}",
        nfd: "\u{110D}\u{1164}\u{11BB}",
        nfkc: "\u{CA44}",
        nfkd: "\u{110D}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CA45}",
        nfc: "\u{CA45}",
        nfd: "\u{110D}\u{1164}\u{11BC}",
        nfkc: "\u{CA45}",
        nfkd: "\u{110D}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CA46}",
        nfc: "\u{CA46}",
        nfd: "\u{110D}\u{1164}\u{11BD}",
        nfkc: "\u{CA46}",
        nfkd: "\u{110D}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CA47}",
        nfc: "\u{CA47}",
        nfd: "\u{110D}\u{1164}\u{11BE}",
        nfkc: "\u{CA47}",
        nfkd: "\u{110D}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CA48}",
        nfc: "\u{CA48}",
        nfd: "\u{110D}\u{1164}\u{11BF}",
        nfkc: "\u{CA48}",
        nfkd: "\u{110D}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CA49}",
        nfc: "\u{CA49}",
        nfd: "\u{110D}\u{1164}\u{11C0}",
        nfkc: "\u{CA49}",
        nfkd: "\u{110D}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CA4A}",
        nfc: "\u{CA4A}",
        nfd: "\u{110D}\u{1164}\u{11C1}",
        nfkc: "\u{CA4A}",
        nfkd: "\u{110D}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CA4B}",
        nfc: "\u{CA4B}",
        nfd: "\u{110D}\u{1164}\u{11C2}",
        nfkc: "\u{CA4B}",
        nfkd: "\u{110D}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CA4C}",
        nfc: "\u{CA4C}",
        nfd: "\u{110D}\u{1165}",
        nfkc: "\u{CA4C}",
        nfkd: "\u{110D}\u{1165}",
    },
    NormalizationTest {
        source: "\u{CA4D}",
        nfc: "\u{CA4D}",
        nfd: "\u{110D}\u{1165}\u{11A8}",
        nfkc: "\u{CA4D}",
        nfkd: "\u{110D}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CA4E}",
        nfc: "\u{CA4E}",
        nfd: "\u{110D}\u{1165}\u{11A9}",
        nfkc: "\u{CA4E}",
        nfkd: "\u{110D}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CA4F}",
        nfc: "\u{CA4F}",
        nfd: "\u{110D}\u{1165}\u{11AA}",
        nfkc: "\u{CA4F}",
        nfkd: "\u{110D}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CA50}",
        nfc: "\u{CA50}",
        nfd: "\u{110D}\u{1165}\u{11AB}",
        nfkc: "\u{CA50}",
        nfkd: "\u{110D}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CA51}",
        nfc: "\u{CA51}",
        nfd: "\u{110D}\u{1165}\u{11AC}",
        nfkc: "\u{CA51}",
        nfkd: "\u{110D}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CA52}",
        nfc: "\u{CA52}",
        nfd: "\u{110D}\u{1165}\u{11AD}",
        nfkc: "\u{CA52}",
        nfkd: "\u{110D}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CA53}",
        nfc: "\u{CA53}",
        nfd: "\u{110D}\u{1165}\u{11AE}",
        nfkc: "\u{CA53}",
        nfkd: "\u{110D}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CA54}",
        nfc: "\u{CA54}",
        nfd: "\u{110D}\u{1165}\u{11AF}",
        nfkc: "\u{CA54}",
        nfkd: "\u{110D}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CA55}",
        nfc: "\u{CA55}",
        nfd: "\u{110D}\u{1165}\u{11B0}",
        nfkc: "\u{CA55}",
        nfkd: "\u{110D}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CA56}",
        nfc: "\u{CA56}",
        nfd: "\u{110D}\u{1165}\u{11B1}",
        nfkc: "\u{CA56}",
        nfkd: "\u{110D}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CA57}",
        nfc: "\u{CA57}",
        nfd: "\u{110D}\u{1165}\u{11B2}",
        nfkc: "\u{CA57}",
        nfkd: "\u{110D}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CA58}",
        nfc: "\u{CA58}",
        nfd: "\u{110D}\u{1165}\u{11B3}",
        nfkc: "\u{CA58}",
        nfkd: "\u{110D}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CA59}",
        nfc: "\u{CA59}",
        nfd: "\u{110D}\u{1165}\u{11B4}",
        nfkc: "\u{CA59}",
        nfkd: "\u{110D}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CA5A}",
        nfc: "\u{CA5A}",
        nfd: "\u{110D}\u{1165}\u{11B5}",
        nfkc: "\u{CA5A}",
        nfkd: "\u{110D}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CA5B}",
        nfc: "\u{CA5B}",
        nfd: "\u{110D}\u{1165}\u{11B6}",
        nfkc: "\u{CA5B}",
        nfkd: "\u{110D}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CA5C}",
        nfc: "\u{CA5C}",
        nfd: "\u{110D}\u{1165}\u{11B7}",
        nfkc: "\u{CA5C}",
        nfkd: "\u{110D}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CA5D}",
        nfc: "\u{CA5D}",
        nfd: "\u{110D}\u{1165}\u{11B8}",
        nfkc: "\u{CA5D}",
        nfkd: "\u{110D}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CA5E}",
        nfc: "\u{CA5E}",
        nfd: "\u{110D}\u{1165}\u{11B9}",
        nfkc: "\u{CA5E}",
        nfkd: "\u{110D}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CA5F}",
        nfc: "\u{CA5F}",
        nfd: "\u{110D}\u{1165}\u{11BA}",
        nfkc: "\u{CA5F}",
        nfkd: "\u{110D}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CA60}",
        nfc: "\u{CA60}",
        nfd: "\u{110D}\u{1165}\u{11BB}",
        nfkc: "\u{CA60}",
        nfkd: "\u{110D}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CA61}",
        nfc: "\u{CA61}",
        nfd: "\u{110D}\u{1165}\u{11BC}",
        nfkc: "\u{CA61}",
        nfkd: "\u{110D}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CA62}",
        nfc: "\u{CA62}",
        nfd: "\u{110D}\u{1165}\u{11BD}",
        nfkc: "\u{CA62}",
        nfkd: "\u{110D}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CA63}",
        nfc: "\u{CA63}",
        nfd: "\u{110D}\u{1165}\u{11BE}",
        nfkc: "\u{CA63}",
        nfkd: "\u{110D}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CA64}",
        nfc: "\u{CA64}",
        nfd: "\u{110D}\u{1165}\u{11BF}",
        nfkc: "\u{CA64}",
        nfkd: "\u{110D}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CA65}",
        nfc: "\u{CA65}",
        nfd: "\u{110D}\u{1165}\u{11C0}",
        nfkc: "\u{CA65}",
        nfkd: "\u{110D}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CA66}",
        nfc: "\u{CA66}",
        nfd: "\u{110D}\u{1165}\u{11C1}",
        nfkc: "\u{CA66}",
        nfkd: "\u{110D}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CA67}",
        nfc: "\u{CA67}",
        nfd: "\u{110D}\u{1165}\u{11C2}",
        nfkc: "\u{CA67}",
        nfkd: "\u{110D}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CA68}",
        nfc: "\u{CA68}",
        nfd: "\u{110D}\u{1166}",
        nfkc: "\u{CA68}",
        nfkd: "\u{110D}\u{1166}",
    },
    NormalizationTest {
        source: "\u{CA69}",
        nfc: "\u{CA69}",
        nfd: "\u{110D}\u{1166}\u{11A8}",
        nfkc: "\u{CA69}",
        nfkd: "\u{110D}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CA6A}",
        nfc: "\u{CA6A}",
        nfd: "\u{110D}\u{1166}\u{11A9}",
        nfkc: "\u{CA6A}",
        nfkd: "\u{110D}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CA6B}",
        nfc: "\u{CA6B}",
        nfd: "\u{110D}\u{1166}\u{11AA}",
        nfkc: "\u{CA6B}",
        nfkd: "\u{110D}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CA6C}",
        nfc: "\u{CA6C}",
        nfd: "\u{110D}\u{1166}\u{11AB}",
        nfkc: "\u{CA6C}",
        nfkd: "\u{110D}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CA6D}",
        nfc: "\u{CA6D}",
        nfd: "\u{110D}\u{1166}\u{11AC}",
        nfkc: "\u{CA6D}",
        nfkd: "\u{110D}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CA6E}",
        nfc: "\u{CA6E}",
        nfd: "\u{110D}\u{1166}\u{11AD}",
        nfkc: "\u{CA6E}",
        nfkd: "\u{110D}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CA6F}",
        nfc: "\u{CA6F}",
        nfd: "\u{110D}\u{1166}\u{11AE}",
        nfkc: "\u{CA6F}",
        nfkd: "\u{110D}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CA70}",
        nfc: "\u{CA70}",
        nfd: "\u{110D}\u{1166}\u{11AF}",
        nfkc: "\u{CA70}",
        nfkd: "\u{110D}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CA71}",
        nfc: "\u{CA71}",
        nfd: "\u{110D}\u{1166}\u{11B0}",
        nfkc: "\u{CA71}",
        nfkd: "\u{110D}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CA72}",
        nfc: "\u{CA72}",
        nfd: "\u{110D}\u{1166}\u{11B1}",
        nfkc: "\u{CA72}",
        nfkd: "\u{110D}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CA73}",
        nfc: "\u{CA73}",
        nfd: "\u{110D}\u{1166}\u{11B2}",
        nfkc: "\u{CA73}",
        nfkd: "\u{110D}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CA74}",
        nfc: "\u{CA74}",
        nfd: "\u{110D}\u{1166}\u{11B3}",
        nfkc: "\u{CA74}",
        nfkd: "\u{110D}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CA75}",
        nfc: "\u{CA75}",
        nfd: "\u{110D}\u{1166}\u{11B4}",
        nfkc: "\u{CA75}",
        nfkd: "\u{110D}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CA76}",
        nfc: "\u{CA76}",
        nfd: "\u{110D}\u{1166}\u{11B5}",
        nfkc: "\u{CA76}",
        nfkd: "\u{110D}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CA77}",
        nfc: "\u{CA77}",
        nfd: "\u{110D}\u{1166}\u{11B6}",
        nfkc: "\u{CA77}",
        nfkd: "\u{110D}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CA78}",
        nfc: "\u{CA78}",
        nfd: "\u{110D}\u{1166}\u{11B7}",
        nfkc: "\u{CA78}",
        nfkd: "\u{110D}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CA79}",
        nfc: "\u{CA79}",
        nfd: "\u{110D}\u{1166}\u{11B8}",
        nfkc: "\u{CA79}",
        nfkd: "\u{110D}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CA7A}",
        nfc: "\u{CA7A}",
        nfd: "\u{110D}\u{1166}\u{11B9}",
        nfkc: "\u{CA7A}",
        nfkd: "\u{110D}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CA7B}",
        nfc: "\u{CA7B}",
        nfd: "\u{110D}\u{1166}\u{11BA}",
        nfkc: "\u{CA7B}",
        nfkd: "\u{110D}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CA7C}",
        nfc: "\u{CA7C}",
        nfd: "\u{110D}\u{1166}\u{11BB}",
        nfkc: "\u{CA7C}",
        nfkd: "\u{110D}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CA7D}",
        nfc: "\u{CA7D}",
        nfd: "\u{110D}\u{1166}\u{11BC}",
        nfkc: "\u{CA7D}",
        nfkd: "\u{110D}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CA7E}",
        nfc: "\u{CA7E}",
        nfd: "\u{110D}\u{1166}\u{11BD}",
        nfkc: "\u{CA7E}",
        nfkd: "\u{110D}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CA7F}",
        nfc: "\u{CA7F}",
        nfd: "\u{110D}\u{1166}\u{11BE}",
        nfkc: "\u{CA7F}",
        nfkd: "\u{110D}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CA80}",
        nfc: "\u{CA80}",
        nfd: "\u{110D}\u{1166}\u{11BF}",
        nfkc: "\u{CA80}",
        nfkd: "\u{110D}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CA81}",
        nfc: "\u{CA81}",
        nfd: "\u{110D}\u{1166}\u{11C0}",
        nfkc: "\u{CA81}",
        nfkd: "\u{110D}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CA82}",
        nfc: "\u{CA82}",
        nfd: "\u{110D}\u{1166}\u{11C1}",
        nfkc: "\u{CA82}",
        nfkd: "\u{110D}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CA83}",
        nfc: "\u{CA83}",
        nfd: "\u{110D}\u{1166}\u{11C2}",
        nfkc: "\u{CA83}",
        nfkd: "\u{110D}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CA84}",
        nfc: "\u{CA84}",
        nfd: "\u{110D}\u{1167}",
        nfkc: "\u{CA84}",
        nfkd: "\u{110D}\u{1167}",
    },
    NormalizationTest {
        source: "\u{CA85}",
        nfc: "\u{CA85}",
        nfd: "\u{110D}\u{1167}\u{11A8}",
        nfkc: "\u{CA85}",
        nfkd: "\u{110D}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CA86}",
        nfc: "\u{CA86}",
        nfd: "\u{110D}\u{1167}\u{11A9}",
        nfkc: "\u{CA86}",
        nfkd: "\u{110D}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CA87}",
        nfc: "\u{CA87}",
        nfd: "\u{110D}\u{1167}\u{11AA}",
        nfkc: "\u{CA87}",
        nfkd: "\u{110D}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CA88}",
        nfc: "\u{CA88}",
        nfd: "\u{110D}\u{1167}\u{11AB}",
        nfkc: "\u{CA88}",
        nfkd: "\u{110D}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CA89}",
        nfc: "\u{CA89}",
        nfd: "\u{110D}\u{1167}\u{11AC}",
        nfkc: "\u{CA89}",
        nfkd: "\u{110D}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CA8A}",
        nfc: "\u{CA8A}",
        nfd: "\u{110D}\u{1167}\u{11AD}",
        nfkc: "\u{CA8A}",
        nfkd: "\u{110D}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CA8B}",
        nfc: "\u{CA8B}",
        nfd: "\u{110D}\u{1167}\u{11AE}",
        nfkc: "\u{CA8B}",
        nfkd: "\u{110D}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CA8C}",
        nfc: "\u{CA8C}",
        nfd: "\u{110D}\u{1167}\u{11AF}",
        nfkc: "\u{CA8C}",
        nfkd: "\u{110D}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CA8D}",
        nfc: "\u{CA8D}",
        nfd: "\u{110D}\u{1167}\u{11B0}",
        nfkc: "\u{CA8D}",
        nfkd: "\u{110D}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CA8E}",
        nfc: "\u{CA8E}",
        nfd: "\u{110D}\u{1167}\u{11B1}",
        nfkc: "\u{CA8E}",
        nfkd: "\u{110D}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CA8F}",
        nfc: "\u{CA8F}",
        nfd: "\u{110D}\u{1167}\u{11B2}",
        nfkc: "\u{CA8F}",
        nfkd: "\u{110D}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CA90}",
        nfc: "\u{CA90}",
        nfd: "\u{110D}\u{1167}\u{11B3}",
        nfkc: "\u{CA90}",
        nfkd: "\u{110D}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CA91}",
        nfc: "\u{CA91}",
        nfd: "\u{110D}\u{1167}\u{11B4}",
        nfkc: "\u{CA91}",
        nfkd: "\u{110D}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CA92}",
        nfc: "\u{CA92}",
        nfd: "\u{110D}\u{1167}\u{11B5}",
        nfkc: "\u{CA92}",
        nfkd: "\u{110D}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CA93}",
        nfc: "\u{CA93}",
        nfd: "\u{110D}\u{1167}\u{11B6}",
        nfkc: "\u{CA93}",
        nfkd: "\u{110D}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CA94}",
        nfc: "\u{CA94}",
        nfd: "\u{110D}\u{1167}\u{11B7}",
        nfkc: "\u{CA94}",
        nfkd: "\u{110D}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CA95}",
        nfc: "\u{CA95}",
        nfd: "\u{110D}\u{1167}\u{11B8}",
        nfkc: "\u{CA95}",
        nfkd: "\u{110D}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CA96}",
        nfc: "\u{CA96}",
        nfd: "\u{110D}\u{1167}\u{11B9}",
        nfkc: "\u{CA96}",
        nfkd: "\u{110D}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CA97}",
        nfc: "\u{CA97}",
        nfd: "\u{110D}\u{1167}\u{11BA}",
        nfkc: "\u{CA97}",
        nfkd: "\u{110D}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CA98}",
        nfc: "\u{CA98}",
        nfd: "\u{110D}\u{1167}\u{11BB}",
        nfkc: "\u{CA98}",
        nfkd: "\u{110D}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CA99}",
        nfc: "\u{CA99}",
        nfd: "\u{110D}\u{1167}\u{11BC}",
        nfkc: "\u{CA99}",
        nfkd: "\u{110D}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CA9A}",
        nfc: "\u{CA9A}",
        nfd: "\u{110D}\u{1167}\u{11BD}",
        nfkc: "\u{CA9A}",
        nfkd: "\u{110D}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CA9B}",
        nfc: "\u{CA9B}",
        nfd: "\u{110D}\u{1167}\u{11BE}",
        nfkc: "\u{CA9B}",
        nfkd: "\u{110D}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CA9C}",
        nfc: "\u{CA9C}",
        nfd: "\u{110D}\u{1167}\u{11BF}",
        nfkc: "\u{CA9C}",
        nfkd: "\u{110D}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CA9D}",
        nfc: "\u{CA9D}",
        nfd: "\u{110D}\u{1167}\u{11C0}",
        nfkc: "\u{CA9D}",
        nfkd: "\u{110D}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CA9E}",
        nfc: "\u{CA9E}",
        nfd: "\u{110D}\u{1167}\u{11C1}",
        nfkc: "\u{CA9E}",
        nfkd: "\u{110D}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CA9F}",
        nfc: "\u{CA9F}",
        nfd: "\u{110D}\u{1167}\u{11C2}",
        nfkc: "\u{CA9F}",
        nfkd: "\u{110D}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CAA0}",
        nfc: "\u{CAA0}",
        nfd: "\u{110D}\u{1168}",
        nfkc: "\u{CAA0}",
        nfkd: "\u{110D}\u{1168}",
    },
    NormalizationTest {
        source: "\u{CAA1}",
        nfc: "\u{CAA1}",
        nfd: "\u{110D}\u{1168}\u{11A8}",
        nfkc: "\u{CAA1}",
        nfkd: "\u{110D}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CAA2}",
        nfc: "\u{CAA2}",
        nfd: "\u{110D}\u{1168}\u{11A9}",
        nfkc: "\u{CAA2}",
        nfkd: "\u{110D}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CAA3}",
        nfc: "\u{CAA3}",
        nfd: "\u{110D}\u{1168}\u{11AA}",
        nfkc: "\u{CAA3}",
        nfkd: "\u{110D}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CAA4}",
        nfc: "\u{CAA4}",
        nfd: "\u{110D}\u{1168}\u{11AB}",
        nfkc: "\u{CAA4}",
        nfkd: "\u{110D}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CAA5}",
        nfc: "\u{CAA5}",
        nfd: "\u{110D}\u{1168}\u{11AC}",
        nfkc: "\u{CAA5}",
        nfkd: "\u{110D}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CAA6}",
        nfc: "\u{CAA6}",
        nfd: "\u{110D}\u{1168}\u{11AD}",
        nfkc: "\u{CAA6}",
        nfkd: "\u{110D}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CAA7}",
        nfc: "\u{CAA7}",
        nfd: "\u{110D}\u{1168}\u{11AE}",
        nfkc: "\u{CAA7}",
        nfkd: "\u{110D}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CAA8}",
        nfc: "\u{CAA8}",
        nfd: "\u{110D}\u{1168}\u{11AF}",
        nfkc: "\u{CAA8}",
        nfkd: "\u{110D}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CAA9}",
        nfc: "\u{CAA9}",
        nfd: "\u{110D}\u{1168}\u{11B0}",
        nfkc: "\u{CAA9}",
        nfkd: "\u{110D}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CAAA}",
        nfc: "\u{CAAA}",
        nfd: "\u{110D}\u{1168}\u{11B1}",
        nfkc: "\u{CAAA}",
        nfkd: "\u{110D}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CAAB}",
        nfc: "\u{CAAB}",
        nfd: "\u{110D}\u{1168}\u{11B2}",
        nfkc: "\u{CAAB}",
        nfkd: "\u{110D}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CAAC}",
        nfc: "\u{CAAC}",
        nfd: "\u{110D}\u{1168}\u{11B3}",
        nfkc: "\u{CAAC}",
        nfkd: "\u{110D}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CAAD}",
        nfc: "\u{CAAD}",
        nfd: "\u{110D}\u{1168}\u{11B4}",
        nfkc: "\u{CAAD}",
        nfkd: "\u{110D}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CAAE}",
        nfc: "\u{CAAE}",
        nfd: "\u{110D}\u{1168}\u{11B5}",
        nfkc: "\u{CAAE}",
        nfkd: "\u{110D}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CAAF}",
        nfc: "\u{CAAF}",
        nfd: "\u{110D}\u{1168}\u{11B6}",
        nfkc: "\u{CAAF}",
        nfkd: "\u{110D}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CAB0}",
        nfc: "\u{CAB0}",
        nfd: "\u{110D}\u{1168}\u{11B7}",
        nfkc: "\u{CAB0}",
        nfkd: "\u{110D}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CAB1}",
        nfc: "\u{CAB1}",
        nfd: "\u{110D}\u{1168}\u{11B8}",
        nfkc: "\u{CAB1}",
        nfkd: "\u{110D}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CAB2}",
        nfc: "\u{CAB2}",
        nfd: "\u{110D}\u{1168}\u{11B9}",
        nfkc: "\u{CAB2}",
        nfkd: "\u{110D}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CAB3}",
        nfc: "\u{CAB3}",
        nfd: "\u{110D}\u{1168}\u{11BA}",
        nfkc: "\u{CAB3}",
        nfkd: "\u{110D}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CAB4}",
        nfc: "\u{CAB4}",
        nfd: "\u{110D}\u{1168}\u{11BB}",
        nfkc: "\u{CAB4}",
        nfkd: "\u{110D}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CAB5}",
        nfc: "\u{CAB5}",
        nfd: "\u{110D}\u{1168}\u{11BC}",
        nfkc: "\u{CAB5}",
        nfkd: "\u{110D}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CAB6}",
        nfc: "\u{CAB6}",
        nfd: "\u{110D}\u{1168}\u{11BD}",
        nfkc: "\u{CAB6}",
        nfkd: "\u{110D}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CAB7}",
        nfc: "\u{CAB7}",
        nfd: "\u{110D}\u{1168}\u{11BE}",
        nfkc: "\u{CAB7}",
        nfkd: "\u{110D}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CAB8}",
        nfc: "\u{CAB8}",
        nfd: "\u{110D}\u{1168}\u{11BF}",
        nfkc: "\u{CAB8}",
        nfkd: "\u{110D}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CAB9}",
        nfc: "\u{CAB9}",
        nfd: "\u{110D}\u{1168}\u{11C0}",
        nfkc: "\u{CAB9}",
        nfkd: "\u{110D}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CABA}",
        nfc: "\u{CABA}",
        nfd: "\u{110D}\u{1168}\u{11C1}",
        nfkc: "\u{CABA}",
        nfkd: "\u{110D}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CABB}",
        nfc: "\u{CABB}",
        nfd: "\u{110D}\u{1168}\u{11C2}",
        nfkc: "\u{CABB}",
        nfkd: "\u{110D}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CABC}",
        nfc: "\u{CABC}",
        nfd: "\u{110D}\u{1169}",
        nfkc: "\u{CABC}",
        nfkd: "\u{110D}\u{1169}",
    },
    NormalizationTest {
        source: "\u{CABD}",
        nfc: "\u{CABD}",
        nfd: "\u{110D}\u{1169}\u{11A8}",
        nfkc: "\u{CABD}",
        nfkd: "\u{110D}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CABE}",
        nfc: "\u{CABE}",
        nfd: "\u{110D}\u{1169}\u{11A9}",
        nfkc: "\u{CABE}",
        nfkd: "\u{110D}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CABF}",
        nfc: "\u{CABF}",
        nfd: "\u{110D}\u{1169}\u{11AA}",
        nfkc: "\u{CABF}",
        nfkd: "\u{110D}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CAC0}",
        nfc: "\u{CAC0}",
        nfd: "\u{110D}\u{1169}\u{11AB}",
        nfkc: "\u{CAC0}",
        nfkd: "\u{110D}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CAC1}",
        nfc: "\u{CAC1}",
        nfd: "\u{110D}\u{1169}\u{11AC}",
        nfkc: "\u{CAC1}",
        nfkd: "\u{110D}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CAC2}",
        nfc: "\u{CAC2}",
        nfd: "\u{110D}\u{1169}\u{11AD}",
        nfkc: "\u{CAC2}",
        nfkd: "\u{110D}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CAC3}",
        nfc: "\u{CAC3}",
        nfd: "\u{110D}\u{1169}\u{11AE}",
        nfkc: "\u{CAC3}",
        nfkd: "\u{110D}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CAC4}",
        nfc: "\u{CAC4}",
        nfd: "\u{110D}\u{1169}\u{11AF}",
        nfkc: "\u{CAC4}",
        nfkd: "\u{110D}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CAC5}",
        nfc: "\u{CAC5}",
        nfd: "\u{110D}\u{1169}\u{11B0}",
        nfkc: "\u{CAC5}",
        nfkd: "\u{110D}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CAC6}",
        nfc: "\u{CAC6}",
        nfd: "\u{110D}\u{1169}\u{11B1}",
        nfkc: "\u{CAC6}",
        nfkd: "\u{110D}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CAC7}",
        nfc: "\u{CAC7}",
        nfd: "\u{110D}\u{1169}\u{11B2}",
        nfkc: "\u{CAC7}",
        nfkd: "\u{110D}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CAC8}",
        nfc: "\u{CAC8}",
        nfd: "\u{110D}\u{1169}\u{11B3}",
        nfkc: "\u{CAC8}",
        nfkd: "\u{110D}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CAC9}",
        nfc: "\u{CAC9}",
        nfd: "\u{110D}\u{1169}\u{11B4}",
        nfkc: "\u{CAC9}",
        nfkd: "\u{110D}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CACA}",
        nfc: "\u{CACA}",
        nfd: "\u{110D}\u{1169}\u{11B5}",
        nfkc: "\u{CACA}",
        nfkd: "\u{110D}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CACB}",
        nfc: "\u{CACB}",
        nfd: "\u{110D}\u{1169}\u{11B6}",
        nfkc: "\u{CACB}",
        nfkd: "\u{110D}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CACC}",
        nfc: "\u{CACC}",
        nfd: "\u{110D}\u{1169}\u{11B7}",
        nfkc: "\u{CACC}",
        nfkd: "\u{110D}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CACD}",
        nfc: "\u{CACD}",
        nfd: "\u{110D}\u{1169}\u{11B8}",
        nfkc: "\u{CACD}",
        nfkd: "\u{110D}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CACE}",
        nfc: "\u{CACE}",
        nfd: "\u{110D}\u{1169}\u{11B9}",
        nfkc: "\u{CACE}",
        nfkd: "\u{110D}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CACF}",
        nfc: "\u{CACF}",
        nfd: "\u{110D}\u{1169}\u{11BA}",
        nfkc: "\u{CACF}",
        nfkd: "\u{110D}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CAD0}",
        nfc: "\u{CAD0}",
        nfd: "\u{110D}\u{1169}\u{11BB}",
        nfkc: "\u{CAD0}",
        nfkd: "\u{110D}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CAD1}",
        nfc: "\u{CAD1}",
        nfd: "\u{110D}\u{1169}\u{11BC}",
        nfkc: "\u{CAD1}",
        nfkd: "\u{110D}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CAD2}",
        nfc: "\u{CAD2}",
        nfd: "\u{110D}\u{1169}\u{11BD}",
        nfkc: "\u{CAD2}",
        nfkd: "\u{110D}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CAD3}",
        nfc: "\u{CAD3}",
        nfd: "\u{110D}\u{1169}\u{11BE}",
        nfkc: "\u{CAD3}",
        nfkd: "\u{110D}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CAD4}",
        nfc: "\u{CAD4}",
        nfd: "\u{110D}\u{1169}\u{11BF}",
        nfkc: "\u{CAD4}",
        nfkd: "\u{110D}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CAD5}",
        nfc: "\u{CAD5}",
        nfd: "\u{110D}\u{1169}\u{11C0}",
        nfkc: "\u{CAD5}",
        nfkd: "\u{110D}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CAD6}",
        nfc: "\u{CAD6}",
        nfd: "\u{110D}\u{1169}\u{11C1}",
        nfkc: "\u{CAD6}",
        nfkd: "\u{110D}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CAD7}",
        nfc: "\u{CAD7}",
        nfd: "\u{110D}\u{1169}\u{11C2}",
        nfkc: "\u{CAD7}",
        nfkd: "\u{110D}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CAD8}",
        nfc: "\u{CAD8}",
        nfd: "\u{110D}\u{116A}",
        nfkc: "\u{CAD8}",
        nfkd: "\u{110D}\u{116A}",
    },
    NormalizationTest {
        source: "\u{CAD9}",
        nfc: "\u{CAD9}",
        nfd: "\u{110D}\u{116A}\u{11A8}",
        nfkc: "\u{CAD9}",
        nfkd: "\u{110D}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CADA}",
        nfc: "\u{CADA}",
        nfd: "\u{110D}\u{116A}\u{11A9}",
        nfkc: "\u{CADA}",
        nfkd: "\u{110D}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CADB}",
        nfc: "\u{CADB}",
        nfd: "\u{110D}\u{116A}\u{11AA}",
        nfkc: "\u{CADB}",
        nfkd: "\u{110D}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CADC}",
        nfc: "\u{CADC}",
        nfd: "\u{110D}\u{116A}\u{11AB}",
        nfkc: "\u{CADC}",
        nfkd: "\u{110D}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CADD}",
        nfc: "\u{CADD}",
        nfd: "\u{110D}\u{116A}\u{11AC}",
        nfkc: "\u{CADD}",
        nfkd: "\u{110D}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CADE}",
        nfc: "\u{CADE}",
        nfd: "\u{110D}\u{116A}\u{11AD}",
        nfkc: "\u{CADE}",
        nfkd: "\u{110D}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CADF}",
        nfc: "\u{CADF}",
        nfd: "\u{110D}\u{116A}\u{11AE}",
        nfkc: "\u{CADF}",
        nfkd: "\u{110D}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CAE0}",
        nfc: "\u{CAE0}",
        nfd: "\u{110D}\u{116A}\u{11AF}",
        nfkc: "\u{CAE0}",
        nfkd: "\u{110D}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CAE1}",
        nfc: "\u{CAE1}",
        nfd: "\u{110D}\u{116A}\u{11B0}",
        nfkc: "\u{CAE1}",
        nfkd: "\u{110D}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CAE2}",
        nfc: "\u{CAE2}",
        nfd: "\u{110D}\u{116A}\u{11B1}",
        nfkc: "\u{CAE2}",
        nfkd: "\u{110D}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CAE3}",
        nfc: "\u{CAE3}",
        nfd: "\u{110D}\u{116A}\u{11B2}",
        nfkc: "\u{CAE3}",
        nfkd: "\u{110D}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CAE4}",
        nfc: "\u{CAE4}",
        nfd: "\u{110D}\u{116A}\u{11B3}",
        nfkc: "\u{CAE4}",
        nfkd: "\u{110D}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CAE5}",
        nfc: "\u{CAE5}",
        nfd: "\u{110D}\u{116A}\u{11B4}",
        nfkc: "\u{CAE5}",
        nfkd: "\u{110D}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CAE6}",
        nfc: "\u{CAE6}",
        nfd: "\u{110D}\u{116A}\u{11B5}",
        nfkc: "\u{CAE6}",
        nfkd: "\u{110D}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CAE7}",
        nfc: "\u{CAE7}",
        nfd: "\u{110D}\u{116A}\u{11B6}",
        nfkc: "\u{CAE7}",
        nfkd: "\u{110D}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CAE8}",
        nfc: "\u{CAE8}",
        nfd: "\u{110D}\u{116A}\u{11B7}",
        nfkc: "\u{CAE8}",
        nfkd: "\u{110D}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CAE9}",
        nfc: "\u{CAE9}",
        nfd: "\u{110D}\u{116A}\u{11B8}",
        nfkc: "\u{CAE9}",
        nfkd: "\u{110D}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CAEA}",
        nfc: "\u{CAEA}",
        nfd: "\u{110D}\u{116A}\u{11B9}",
        nfkc: "\u{CAEA}",
        nfkd: "\u{110D}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CAEB}",
        nfc: "\u{CAEB}",
        nfd: "\u{110D}\u{116A}\u{11BA}",
        nfkc: "\u{CAEB}",
        nfkd: "\u{110D}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CAEC}",
        nfc: "\u{CAEC}",
        nfd: "\u{110D}\u{116A}\u{11BB}",
        nfkc: "\u{CAEC}",
        nfkd: "\u{110D}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CAED}",
        nfc: "\u{CAED}",
        nfd: "\u{110D}\u{116A}\u{11BC}",
        nfkc: "\u{CAED}",
        nfkd: "\u{110D}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CAEE}",
        nfc: "\u{CAEE}",
        nfd: "\u{110D}\u{116A}\u{11BD}",
        nfkc: "\u{CAEE}",
        nfkd: "\u{110D}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CAEF}",
        nfc: "\u{CAEF}",
        nfd: "\u{110D}\u{116A}\u{11BE}",
        nfkc: "\u{CAEF}",
        nfkd: "\u{110D}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CAF0}",
        nfc: "\u{CAF0}",
        nfd: "\u{110D}\u{116A}\u{11BF}",
        nfkc: "\u{CAF0}",
        nfkd: "\u{110D}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CAF1}",
        nfc: "\u{CAF1}",
        nfd: "\u{110D}\u{116A}\u{11C0}",
        nfkc: "\u{CAF1}",
        nfkd: "\u{110D}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CAF2}",
        nfc: "\u{CAF2}",
        nfd: "\u{110D}\u{116A}\u{11C1}",
        nfkc: "\u{CAF2}",
        nfkd: "\u{110D}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CAF3}",
        nfc: "\u{CAF3}",
        nfd: "\u{110D}\u{116A}\u{11C2}",
        nfkc: "\u{CAF3}",
        nfkd: "\u{110D}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CAF4}",
        nfc: "\u{CAF4}",
        nfd: "\u{110D}\u{116B}",
        nfkc: "\u{CAF4}",
        nfkd: "\u{110D}\u{116B}",
    },
    NormalizationTest {
        source: "\u{CAF5}",
        nfc: "\u{CAF5}",
        nfd: "\u{110D}\u{116B}\u{11A8}",
        nfkc: "\u{CAF5}",
        nfkd: "\u{110D}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CAF6}",
        nfc: "\u{CAF6}",
        nfd: "\u{110D}\u{116B}\u{11A9}",
        nfkc: "\u{CAF6}",
        nfkd: "\u{110D}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CAF7}",
        nfc: "\u{CAF7}",
        nfd: "\u{110D}\u{116B}\u{11AA}",
        nfkc: "\u{CAF7}",
        nfkd: "\u{110D}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CAF8}",
        nfc: "\u{CAF8}",
        nfd: "\u{110D}\u{116B}\u{11AB}",
        nfkc: "\u{CAF8}",
        nfkd: "\u{110D}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CAF9}",
        nfc: "\u{CAF9}",
        nfd: "\u{110D}\u{116B}\u{11AC}",
        nfkc: "\u{CAF9}",
        nfkd: "\u{110D}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CAFA}",
        nfc: "\u{CAFA}",
        nfd: "\u{110D}\u{116B}\u{11AD}",
        nfkc: "\u{CAFA}",
        nfkd: "\u{110D}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CAFB}",
        nfc: "\u{CAFB}",
        nfd: "\u{110D}\u{116B}\u{11AE}",
        nfkc: "\u{CAFB}",
        nfkd: "\u{110D}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CAFC}",
        nfc: "\u{CAFC}",
        nfd: "\u{110D}\u{116B}\u{11AF}",
        nfkc: "\u{CAFC}",
        nfkd: "\u{110D}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CAFD}",
        nfc: "\u{CAFD}",
        nfd: "\u{110D}\u{116B}\u{11B0}",
        nfkc: "\u{CAFD}",
        nfkd: "\u{110D}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CAFE}",
        nfc: "\u{CAFE}",
        nfd: "\u{110D}\u{116B}\u{11B1}",
        nfkc: "\u{CAFE}",
        nfkd: "\u{110D}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CAFF}",
        nfc: "\u{CAFF}",
        nfd: "\u{110D}\u{116B}\u{11B2}",
        nfkc: "\u{CAFF}",
        nfkd: "\u{110D}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CB00}",
        nfc: "\u{CB00}",
        nfd: "\u{110D}\u{116B}\u{11B3}",
        nfkc: "\u{CB00}",
        nfkd: "\u{110D}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CB01}",
        nfc: "\u{CB01}",
        nfd: "\u{110D}\u{116B}\u{11B4}",
        nfkc: "\u{CB01}",
        nfkd: "\u{110D}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CB02}",
        nfc: "\u{CB02}",
        nfd: "\u{110D}\u{116B}\u{11B5}",
        nfkc: "\u{CB02}",
        nfkd: "\u{110D}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CB03}",
        nfc: "\u{CB03}",
        nfd: "\u{110D}\u{116B}\u{11B6}",
        nfkc: "\u{CB03}",
        nfkd: "\u{110D}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CB04}",
        nfc: "\u{CB04}",
        nfd: "\u{110D}\u{116B}\u{11B7}",
        nfkc: "\u{CB04}",
        nfkd: "\u{110D}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CB05}",
        nfc: "\u{CB05}",
        nfd: "\u{110D}\u{116B}\u{11B8}",
        nfkc: "\u{CB05}",
        nfkd: "\u{110D}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CB06}",
        nfc: "\u{CB06}",
        nfd: "\u{110D}\u{116B}\u{11B9}",
        nfkc: "\u{CB06}",
        nfkd: "\u{110D}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CB07}",
        nfc: "\u{CB07}",
        nfd: "\u{110D}\u{116B}\u{11BA}",
        nfkc: "\u{CB07}",
        nfkd: "\u{110D}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CB08}",
        nfc: "\u{CB08}",
        nfd: "\u{110D}\u{116B}\u{11BB}",
        nfkc: "\u{CB08}",
        nfkd: "\u{110D}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CB09}",
        nfc: "\u{CB09}",
        nfd: "\u{110D}\u{116B}\u{11BC}",
        nfkc: "\u{CB09}",
        nfkd: "\u{110D}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CB0A}",
        nfc: "\u{CB0A}",
        nfd: "\u{110D}\u{116B}\u{11BD}",
        nfkc: "\u{CB0A}",
        nfkd: "\u{110D}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CB0B}",
        nfc: "\u{CB0B}",
        nfd: "\u{110D}\u{116B}\u{11BE}",
        nfkc: "\u{CB0B}",
        nfkd: "\u{110D}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CB0C}",
        nfc: "\u{CB0C}",
        nfd: "\u{110D}\u{116B}\u{11BF}",
        nfkc: "\u{CB0C}",
        nfkd: "\u{110D}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CB0D}",
        nfc: "\u{CB0D}",
        nfd: "\u{110D}\u{116B}\u{11C0}",
        nfkc: "\u{CB0D}",
        nfkd: "\u{110D}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CB0E}",
        nfc: "\u{CB0E}",
        nfd: "\u{110D}\u{116B}\u{11C1}",
        nfkc: "\u{CB0E}",
        nfkd: "\u{110D}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CB0F}",
        nfc: "\u{CB0F}",
        nfd: "\u{110D}\u{116B}\u{11C2}",
        nfkc: "\u{CB0F}",
        nfkd: "\u{110D}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CB10}",
        nfc: "\u{CB10}",
        nfd: "\u{110D}\u{116C}",
        nfkc: "\u{CB10}",
        nfkd: "\u{110D}\u{116C}",
    },
    NormalizationTest {
        source: "\u{CB11}",
        nfc: "\u{CB11}",
        nfd: "\u{110D}\u{116C}\u{11A8}",
        nfkc: "\u{CB11}",
        nfkd: "\u{110D}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CB12}",
        nfc: "\u{CB12}",
        nfd: "\u{110D}\u{116C}\u{11A9}",
        nfkc: "\u{CB12}",
        nfkd: "\u{110D}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CB13}",
        nfc: "\u{CB13}",
        nfd: "\u{110D}\u{116C}\u{11AA}",
        nfkc: "\u{CB13}",
        nfkd: "\u{110D}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CB14}",
        nfc: "\u{CB14}",
        nfd: "\u{110D}\u{116C}\u{11AB}",
        nfkc: "\u{CB14}",
        nfkd: "\u{110D}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CB15}",
        nfc: "\u{CB15}",
        nfd: "\u{110D}\u{116C}\u{11AC}",
        nfkc: "\u{CB15}",
        nfkd: "\u{110D}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CB16}",
        nfc: "\u{CB16}",
        nfd: "\u{110D}\u{116C}\u{11AD}",
        nfkc: "\u{CB16}",
        nfkd: "\u{110D}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CB17}",
        nfc: "\u{CB17}",
        nfd: "\u{110D}\u{116C}\u{11AE}",
        nfkc: "\u{CB17}",
        nfkd: "\u{110D}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CB18}",
        nfc: "\u{CB18}",
        nfd: "\u{110D}\u{116C}\u{11AF}",
        nfkc: "\u{CB18}",
        nfkd: "\u{110D}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CB19}",
        nfc: "\u{CB19}",
        nfd: "\u{110D}\u{116C}\u{11B0}",
        nfkc: "\u{CB19}",
        nfkd: "\u{110D}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CB1A}",
        nfc: "\u{CB1A}",
        nfd: "\u{110D}\u{116C}\u{11B1}",
        nfkc: "\u{CB1A}",
        nfkd: "\u{110D}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CB1B}",
        nfc: "\u{CB1B}",
        nfd: "\u{110D}\u{116C}\u{11B2}",
        nfkc: "\u{CB1B}",
        nfkd: "\u{110D}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CB1C}",
        nfc: "\u{CB1C}",
        nfd: "\u{110D}\u{116C}\u{11B3}",
        nfkc: "\u{CB1C}",
        nfkd: "\u{110D}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CB1D}",
        nfc: "\u{CB1D}",
        nfd: "\u{110D}\u{116C}\u{11B4}",
        nfkc: "\u{CB1D}",
        nfkd: "\u{110D}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CB1E}",
        nfc: "\u{CB1E}",
        nfd: "\u{110D}\u{116C}\u{11B5}",
        nfkc: "\u{CB1E}",
        nfkd: "\u{110D}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CB1F}",
        nfc: "\u{CB1F}",
        nfd: "\u{110D}\u{116C}\u{11B6}",
        nfkc: "\u{CB1F}",
        nfkd: "\u{110D}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CB20}",
        nfc: "\u{CB20}",
        nfd: "\u{110D}\u{116C}\u{11B7}",
        nfkc: "\u{CB20}",
        nfkd: "\u{110D}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CB21}",
        nfc: "\u{CB21}",
        nfd: "\u{110D}\u{116C}\u{11B8}",
        nfkc: "\u{CB21}",
        nfkd: "\u{110D}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CB22}",
        nfc: "\u{CB22}",
        nfd: "\u{110D}\u{116C}\u{11B9}",
        nfkc: "\u{CB22}",
        nfkd: "\u{110D}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CB23}",
        nfc: "\u{CB23}",
        nfd: "\u{110D}\u{116C}\u{11BA}",
        nfkc: "\u{CB23}",
        nfkd: "\u{110D}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CB24}",
        nfc: "\u{CB24}",
        nfd: "\u{110D}\u{116C}\u{11BB}",
        nfkc: "\u{CB24}",
        nfkd: "\u{110D}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CB25}",
        nfc: "\u{CB25}",
        nfd: "\u{110D}\u{116C}\u{11BC}",
        nfkc: "\u{CB25}",
        nfkd: "\u{110D}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CB26}",
        nfc: "\u{CB26}",
        nfd: "\u{110D}\u{116C}\u{11BD}",
        nfkc: "\u{CB26}",
        nfkd: "\u{110D}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CB27}",
        nfc: "\u{CB27}",
        nfd: "\u{110D}\u{116C}\u{11BE}",
        nfkc: "\u{CB27}",
        nfkd: "\u{110D}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CB28}",
        nfc: "\u{CB28}",
        nfd: "\u{110D}\u{116C}\u{11BF}",
        nfkc: "\u{CB28}",
        nfkd: "\u{110D}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CB29}",
        nfc: "\u{CB29}",
        nfd: "\u{110D}\u{116C}\u{11C0}",
        nfkc: "\u{CB29}",
        nfkd: "\u{110D}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CB2A}",
        nfc: "\u{CB2A}",
        nfd: "\u{110D}\u{116C}\u{11C1}",
        nfkc: "\u{CB2A}",
        nfkd: "\u{110D}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CB2B}",
        nfc: "\u{CB2B}",
        nfd: "\u{110D}\u{116C}\u{11C2}",
        nfkc: "\u{CB2B}",
        nfkd: "\u{110D}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CB2C}",
        nfc: "\u{CB2C}",
        nfd: "\u{110D}\u{116D}",
        nfkc: "\u{CB2C}",
        nfkd: "\u{110D}\u{116D}",
    },
    NormalizationTest {
        source: "\u{CB2D}",
        nfc: "\u{CB2D}",
        nfd: "\u{110D}\u{116D}\u{11A8}",
        nfkc: "\u{CB2D}",
        nfkd: "\u{110D}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CB2E}",
        nfc: "\u{CB2E}",
        nfd: "\u{110D}\u{116D}\u{11A9}",
        nfkc: "\u{CB2E}",
        nfkd: "\u{110D}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CB2F}",
        nfc: "\u{CB2F}",
        nfd: "\u{110D}\u{116D}\u{11AA}",
        nfkc: "\u{CB2F}",
        nfkd: "\u{110D}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CB30}",
        nfc: "\u{CB30}",
        nfd: "\u{110D}\u{116D}\u{11AB}",
        nfkc: "\u{CB30}",
        nfkd: "\u{110D}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CB31}",
        nfc: "\u{CB31}",
        nfd: "\u{110D}\u{116D}\u{11AC}",
        nfkc: "\u{CB31}",
        nfkd: "\u{110D}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CB32}",
        nfc: "\u{CB32}",
        nfd: "\u{110D}\u{116D}\u{11AD}",
        nfkc: "\u{CB32}",
        nfkd: "\u{110D}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CB33}",
        nfc: "\u{CB33}",
        nfd: "\u{110D}\u{116D}\u{11AE}",
        nfkc: "\u{CB33}",
        nfkd: "\u{110D}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CB34}",
        nfc: "\u{CB34}",
        nfd: "\u{110D}\u{116D}\u{11AF}",
        nfkc: "\u{CB34}",
        nfkd: "\u{110D}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CB35}",
        nfc: "\u{CB35}",
        nfd: "\u{110D}\u{116D}\u{11B0}",
        nfkc: "\u{CB35}",
        nfkd: "\u{110D}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CB36}",
        nfc: "\u{CB36}",
        nfd: "\u{110D}\u{116D}\u{11B1}",
        nfkc: "\u{CB36}",
        nfkd: "\u{110D}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CB37}",
        nfc: "\u{CB37}",
        nfd: "\u{110D}\u{116D}\u{11B2}",
        nfkc: "\u{CB37}",
        nfkd: "\u{110D}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CB38}",
        nfc: "\u{CB38}",
        nfd: "\u{110D}\u{116D}\u{11B3}",
        nfkc: "\u{CB38}",
        nfkd: "\u{110D}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CB39}",
        nfc: "\u{CB39}",
        nfd: "\u{110D}\u{116D}\u{11B4}",
        nfkc: "\u{CB39}",
        nfkd: "\u{110D}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CB3A}",
        nfc: "\u{CB3A}",
        nfd: "\u{110D}\u{116D}\u{11B5}",
        nfkc: "\u{CB3A}",
        nfkd: "\u{110D}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CB3B}",
        nfc: "\u{CB3B}",
        nfd: "\u{110D}\u{116D}\u{11B6}",
        nfkc: "\u{CB3B}",
        nfkd: "\u{110D}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CB3C}",
        nfc: "\u{CB3C}",
        nfd: "\u{110D}\u{116D}\u{11B7}",
        nfkc: "\u{CB3C}",
        nfkd: "\u{110D}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CB3D}",
        nfc: "\u{CB3D}",
        nfd: "\u{110D}\u{116D}\u{11B8}",
        nfkc: "\u{CB3D}",
        nfkd: "\u{110D}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CB3E}",
        nfc: "\u{CB3E}",
        nfd: "\u{110D}\u{116D}\u{11B9}",
        nfkc: "\u{CB3E}",
        nfkd: "\u{110D}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CB3F}",
        nfc: "\u{CB3F}",
        nfd: "\u{110D}\u{116D}\u{11BA}",
        nfkc: "\u{CB3F}",
        nfkd: "\u{110D}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CB40}",
        nfc: "\u{CB40}",
        nfd: "\u{110D}\u{116D}\u{11BB}",
        nfkc: "\u{CB40}",
        nfkd: "\u{110D}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CB41}",
        nfc: "\u{CB41}",
        nfd: "\u{110D}\u{116D}\u{11BC}",
        nfkc: "\u{CB41}",
        nfkd: "\u{110D}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CB42}",
        nfc: "\u{CB42}",
        nfd: "\u{110D}\u{116D}\u{11BD}",
        nfkc: "\u{CB42}",
        nfkd: "\u{110D}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CB43}",
        nfc: "\u{CB43}",
        nfd: "\u{110D}\u{116D}\u{11BE}",
        nfkc: "\u{CB43}",
        nfkd: "\u{110D}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CB44}",
        nfc: "\u{CB44}",
        nfd: "\u{110D}\u{116D}\u{11BF}",
        nfkc: "\u{CB44}",
        nfkd: "\u{110D}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CB45}",
        nfc: "\u{CB45}",
        nfd: "\u{110D}\u{116D}\u{11C0}",
        nfkc: "\u{CB45}",
        nfkd: "\u{110D}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CB46}",
        nfc: "\u{CB46}",
        nfd: "\u{110D}\u{116D}\u{11C1}",
        nfkc: "\u{CB46}",
        nfkd: "\u{110D}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CB47}",
        nfc: "\u{CB47}",
        nfd: "\u{110D}\u{116D}\u{11C2}",
        nfkc: "\u{CB47}",
        nfkd: "\u{110D}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CB48}",
        nfc: "\u{CB48}",
        nfd: "\u{110D}\u{116E}",
        nfkc: "\u{CB48}",
        nfkd: "\u{110D}\u{116E}",
    },
    NormalizationTest {
        source: "\u{CB49}",
        nfc: "\u{CB49}",
        nfd: "\u{110D}\u{116E}\u{11A8}",
        nfkc: "\u{CB49}",
        nfkd: "\u{110D}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CB4A}",
        nfc: "\u{CB4A}",
        nfd: "\u{110D}\u{116E}\u{11A9}",
        nfkc: "\u{CB4A}",
        nfkd: "\u{110D}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CB4B}",
        nfc: "\u{CB4B}",
        nfd: "\u{110D}\u{116E}\u{11AA}",
        nfkc: "\u{CB4B}",
        nfkd: "\u{110D}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CB4C}",
        nfc: "\u{CB4C}",
        nfd: "\u{110D}\u{116E}\u{11AB}",
        nfkc: "\u{CB4C}",
        nfkd: "\u{110D}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CB4D}",
        nfc: "\u{CB4D}",
        nfd: "\u{110D}\u{116E}\u{11AC}",
        nfkc: "\u{CB4D}",
        nfkd: "\u{110D}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CB4E}",
        nfc: "\u{CB4E}",
        nfd: "\u{110D}\u{116E}\u{11AD}",
        nfkc: "\u{CB4E}",
        nfkd: "\u{110D}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CB4F}",
        nfc: "\u{CB4F}",
        nfd: "\u{110D}\u{116E}\u{11AE}",
        nfkc: "\u{CB4F}",
        nfkd: "\u{110D}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CB50}",
        nfc: "\u{CB50}",
        nfd: "\u{110D}\u{116E}\u{11AF}",
        nfkc: "\u{CB50}",
        nfkd: "\u{110D}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CB51}",
        nfc: "\u{CB51}",
        nfd: "\u{110D}\u{116E}\u{11B0}",
        nfkc: "\u{CB51}",
        nfkd: "\u{110D}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CB52}",
        nfc: "\u{CB52}",
        nfd: "\u{110D}\u{116E}\u{11B1}",
        nfkc: "\u{CB52}",
        nfkd: "\u{110D}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CB53}",
        nfc: "\u{CB53}",
        nfd: "\u{110D}\u{116E}\u{11B2}",
        nfkc: "\u{CB53}",
        nfkd: "\u{110D}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CB54}",
        nfc: "\u{CB54}",
        nfd: "\u{110D}\u{116E}\u{11B3}",
        nfkc: "\u{CB54}",
        nfkd: "\u{110D}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CB55}",
        nfc: "\u{CB55}",
        nfd: "\u{110D}\u{116E}\u{11B4}",
        nfkc: "\u{CB55}",
        nfkd: "\u{110D}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CB56}",
        nfc: "\u{CB56}",
        nfd: "\u{110D}\u{116E}\u{11B5}",
        nfkc: "\u{CB56}",
        nfkd: "\u{110D}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CB57}",
        nfc: "\u{CB57}",
        nfd: "\u{110D}\u{116E}\u{11B6}",
        nfkc: "\u{CB57}",
        nfkd: "\u{110D}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CB58}",
        nfc: "\u{CB58}",
        nfd: "\u{110D}\u{116E}\u{11B7}",
        nfkc: "\u{CB58}",
        nfkd: "\u{110D}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CB59}",
        nfc: "\u{CB59}",
        nfd: "\u{110D}\u{116E}\u{11B8}",
        nfkc: "\u{CB59}",
        nfkd: "\u{110D}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CB5A}",
        nfc: "\u{CB5A}",
        nfd: "\u{110D}\u{116E}\u{11B9}",
        nfkc: "\u{CB5A}",
        nfkd: "\u{110D}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CB5B}",
        nfc: "\u{CB5B}",
        nfd: "\u{110D}\u{116E}\u{11BA}",
        nfkc: "\u{CB5B}",
        nfkd: "\u{110D}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CB5C}",
        nfc: "\u{CB5C}",
        nfd: "\u{110D}\u{116E}\u{11BB}",
        nfkc: "\u{CB5C}",
        nfkd: "\u{110D}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CB5D}",
        nfc: "\u{CB5D}",
        nfd: "\u{110D}\u{116E}\u{11BC}",
        nfkc: "\u{CB5D}",
        nfkd: "\u{110D}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CB5E}",
        nfc: "\u{CB5E}",
        nfd: "\u{110D}\u{116E}\u{11BD}",
        nfkc: "\u{CB5E}",
        nfkd: "\u{110D}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CB5F}",
        nfc: "\u{CB5F}",
        nfd: "\u{110D}\u{116E}\u{11BE}",
        nfkc: "\u{CB5F}",
        nfkd: "\u{110D}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CB60}",
        nfc: "\u{CB60}",
        nfd: "\u{110D}\u{116E}\u{11BF}",
        nfkc: "\u{CB60}",
        nfkd: "\u{110D}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CB61}",
        nfc: "\u{CB61}",
        nfd: "\u{110D}\u{116E}\u{11C0}",
        nfkc: "\u{CB61}",
        nfkd: "\u{110D}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CB62}",
        nfc: "\u{CB62}",
        nfd: "\u{110D}\u{116E}\u{11C1}",
        nfkc: "\u{CB62}",
        nfkd: "\u{110D}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CB63}",
        nfc: "\u{CB63}",
        nfd: "\u{110D}\u{116E}\u{11C2}",
        nfkc: "\u{CB63}",
        nfkd: "\u{110D}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CB64}",
        nfc: "\u{CB64}",
        nfd: "\u{110D}\u{116F}",
        nfkc: "\u{CB64}",
        nfkd: "\u{110D}\u{116F}",
    },
    NormalizationTest {
        source: "\u{CB65}",
        nfc: "\u{CB65}",
        nfd: "\u{110D}\u{116F}\u{11A8}",
        nfkc: "\u{CB65}",
        nfkd: "\u{110D}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CB66}",
        nfc: "\u{CB66}",
        nfd: "\u{110D}\u{116F}\u{11A9}",
        nfkc: "\u{CB66}",
        nfkd: "\u{110D}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CB67}",
        nfc: "\u{CB67}",
        nfd: "\u{110D}\u{116F}\u{11AA}",
        nfkc: "\u{CB67}",
        nfkd: "\u{110D}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CB68}",
        nfc: "\u{CB68}",
        nfd: "\u{110D}\u{116F}\u{11AB}",
        nfkc: "\u{CB68}",
        nfkd: "\u{110D}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CB69}",
        nfc: "\u{CB69}",
        nfd: "\u{110D}\u{116F}\u{11AC}",
        nfkc: "\u{CB69}",
        nfkd: "\u{110D}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CB6A}",
        nfc: "\u{CB6A}",
        nfd: "\u{110D}\u{116F}\u{11AD}",
        nfkc: "\u{CB6A}",
        nfkd: "\u{110D}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CB6B}",
        nfc: "\u{CB6B}",
        nfd: "\u{110D}\u{116F}\u{11AE}",
        nfkc: "\u{CB6B}",
        nfkd: "\u{110D}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CB6C}",
        nfc: "\u{CB6C}",
        nfd: "\u{110D}\u{116F}\u{11AF}",
        nfkc: "\u{CB6C}",
        nfkd: "\u{110D}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CB6D}",
        nfc: "\u{CB6D}",
        nfd: "\u{110D}\u{116F}\u{11B0}",
        nfkc: "\u{CB6D}",
        nfkd: "\u{110D}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CB6E}",
        nfc: "\u{CB6E}",
        nfd: "\u{110D}\u{116F}\u{11B1}",
        nfkc: "\u{CB6E}",
        nfkd: "\u{110D}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CB6F}",
        nfc: "\u{CB6F}",
        nfd: "\u{110D}\u{116F}\u{11B2}",
        nfkc: "\u{CB6F}",
        nfkd: "\u{110D}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CB70}",
        nfc: "\u{CB70}",
        nfd: "\u{110D}\u{116F}\u{11B3}",
        nfkc: "\u{CB70}",
        nfkd: "\u{110D}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CB71}",
        nfc: "\u{CB71}",
        nfd: "\u{110D}\u{116F}\u{11B4}",
        nfkc: "\u{CB71}",
        nfkd: "\u{110D}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CB72}",
        nfc: "\u{CB72}",
        nfd: "\u{110D}\u{116F}\u{11B5}",
        nfkc: "\u{CB72}",
        nfkd: "\u{110D}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CB73}",
        nfc: "\u{CB73}",
        nfd: "\u{110D}\u{116F}\u{11B6}",
        nfkc: "\u{CB73}",
        nfkd: "\u{110D}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CB74}",
        nfc: "\u{CB74}",
        nfd: "\u{110D}\u{116F}\u{11B7}",
        nfkc: "\u{CB74}",
        nfkd: "\u{110D}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CB75}",
        nfc: "\u{CB75}",
        nfd: "\u{110D}\u{116F}\u{11B8}",
        nfkc: "\u{CB75}",
        nfkd: "\u{110D}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CB76}",
        nfc: "\u{CB76}",
        nfd: "\u{110D}\u{116F}\u{11B9}",
        nfkc: "\u{CB76}",
        nfkd: "\u{110D}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CB77}",
        nfc: "\u{CB77}",
        nfd: "\u{110D}\u{116F}\u{11BA}",
        nfkc: "\u{CB77}",
        nfkd: "\u{110D}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CB78}",
        nfc: "\u{CB78}",
        nfd: "\u{110D}\u{116F}\u{11BB}",
        nfkc: "\u{CB78}",
        nfkd: "\u{110D}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CB79}",
        nfc: "\u{CB79}",
        nfd: "\u{110D}\u{116F}\u{11BC}",
        nfkc: "\u{CB79}",
        nfkd: "\u{110D}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CB7A}",
        nfc: "\u{CB7A}",
        nfd: "\u{110D}\u{116F}\u{11BD}",
        nfkc: "\u{CB7A}",
        nfkd: "\u{110D}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CB7B}",
        nfc: "\u{CB7B}",
        nfd: "\u{110D}\u{116F}\u{11BE}",
        nfkc: "\u{CB7B}",
        nfkd: "\u{110D}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CB7C}",
        nfc: "\u{CB7C}",
        nfd: "\u{110D}\u{116F}\u{11BF}",
        nfkc: "\u{CB7C}",
        nfkd: "\u{110D}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CB7D}",
        nfc: "\u{CB7D}",
        nfd: "\u{110D}\u{116F}\u{11C0}",
        nfkc: "\u{CB7D}",
        nfkd: "\u{110D}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CB7E}",
        nfc: "\u{CB7E}",
        nfd: "\u{110D}\u{116F}\u{11C1}",
        nfkc: "\u{CB7E}",
        nfkd: "\u{110D}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CB7F}",
        nfc: "\u{CB7F}",
        nfd: "\u{110D}\u{116F}\u{11C2}",
        nfkc: "\u{CB7F}",
        nfkd: "\u{110D}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CB80}",
        nfc: "\u{CB80}",
        nfd: "\u{110D}\u{1170}",
        nfkc: "\u{CB80}",
        nfkd: "\u{110D}\u{1170}",
    },
    NormalizationTest {
        source: "\u{CB81}",
        nfc: "\u{CB81}",
        nfd: "\u{110D}\u{1170}\u{11A8}",
        nfkc: "\u{CB81}",
        nfkd: "\u{110D}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CB82}",
        nfc: "\u{CB82}",
        nfd: "\u{110D}\u{1170}\u{11A9}",
        nfkc: "\u{CB82}",
        nfkd: "\u{110D}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CB83}",
        nfc: "\u{CB83}",
        nfd: "\u{110D}\u{1170}\u{11AA}",
        nfkc: "\u{CB83}",
        nfkd: "\u{110D}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CB84}",
        nfc: "\u{CB84}",
        nfd: "\u{110D}\u{1170}\u{11AB}",
        nfkc: "\u{CB84}",
        nfkd: "\u{110D}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CB85}",
        nfc: "\u{CB85}",
        nfd: "\u{110D}\u{1170}\u{11AC}",
        nfkc: "\u{CB85}",
        nfkd: "\u{110D}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CB86}",
        nfc: "\u{CB86}",
        nfd: "\u{110D}\u{1170}\u{11AD}",
        nfkc: "\u{CB86}",
        nfkd: "\u{110D}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CB87}",
        nfc: "\u{CB87}",
        nfd: "\u{110D}\u{1170}\u{11AE}",
        nfkc: "\u{CB87}",
        nfkd: "\u{110D}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CB88}",
        nfc: "\u{CB88}",
        nfd: "\u{110D}\u{1170}\u{11AF}",
        nfkc: "\u{CB88}",
        nfkd: "\u{110D}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CB89}",
        nfc: "\u{CB89}",
        nfd: "\u{110D}\u{1170}\u{11B0}",
        nfkc: "\u{CB89}",
        nfkd: "\u{110D}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CB8A}",
        nfc: "\u{CB8A}",
        nfd: "\u{110D}\u{1170}\u{11B1}",
        nfkc: "\u{CB8A}",
        nfkd: "\u{110D}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CB8B}",
        nfc: "\u{CB8B}",
        nfd: "\u{110D}\u{1170}\u{11B2}",
        nfkc: "\u{CB8B}",
        nfkd: "\u{110D}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CB8C}",
        nfc: "\u{CB8C}",
        nfd: "\u{110D}\u{1170}\u{11B3}",
        nfkc: "\u{CB8C}",
        nfkd: "\u{110D}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CB8D}",
        nfc: "\u{CB8D}",
        nfd: "\u{110D}\u{1170}\u{11B4}",
        nfkc: "\u{CB8D}",
        nfkd: "\u{110D}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CB8E}",
        nfc: "\u{CB8E}",
        nfd: "\u{110D}\u{1170}\u{11B5}",
        nfkc: "\u{CB8E}",
        nfkd: "\u{110D}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CB8F}",
        nfc: "\u{CB8F}",
        nfd: "\u{110D}\u{1170}\u{11B6}",
        nfkc: "\u{CB8F}",
        nfkd: "\u{110D}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CB90}",
        nfc: "\u{CB90}",
        nfd: "\u{110D}\u{1170}\u{11B7}",
        nfkc: "\u{CB90}",
        nfkd: "\u{110D}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CB91}",
        nfc: "\u{CB91}",
        nfd: "\u{110D}\u{1170}\u{11B8}",
        nfkc: "\u{CB91}",
        nfkd: "\u{110D}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CB92}",
        nfc: "\u{CB92}",
        nfd: "\u{110D}\u{1170}\u{11B9}",
        nfkc: "\u{CB92}",
        nfkd: "\u{110D}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CB93}",
        nfc: "\u{CB93}",
        nfd: "\u{110D}\u{1170}\u{11BA}",
        nfkc: "\u{CB93}",
        nfkd: "\u{110D}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CB94}",
        nfc: "\u{CB94}",
        nfd: "\u{110D}\u{1170}\u{11BB}",
        nfkc: "\u{CB94}",
        nfkd: "\u{110D}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CB95}",
        nfc: "\u{CB95}",
        nfd: "\u{110D}\u{1170}\u{11BC}",
        nfkc: "\u{CB95}",
        nfkd: "\u{110D}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CB96}",
        nfc: "\u{CB96}",
        nfd: "\u{110D}\u{1170}\u{11BD}",
        nfkc: "\u{CB96}",
        nfkd: "\u{110D}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CB97}",
        nfc: "\u{CB97}",
        nfd: "\u{110D}\u{1170}\u{11BE}",
        nfkc: "\u{CB97}",
        nfkd: "\u{110D}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CB98}",
        nfc: "\u{CB98}",
        nfd: "\u{110D}\u{1170}\u{11BF}",
        nfkc: "\u{CB98}",
        nfkd: "\u{110D}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CB99}",
        nfc: "\u{CB99}",
        nfd: "\u{110D}\u{1170}\u{11C0}",
        nfkc: "\u{CB99}",
        nfkd: "\u{110D}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CB9A}",
        nfc: "\u{CB9A}",
        nfd: "\u{110D}\u{1170}\u{11C1}",
        nfkc: "\u{CB9A}",
        nfkd: "\u{110D}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CB9B}",
        nfc: "\u{CB9B}",
        nfd: "\u{110D}\u{1170}\u{11C2}",
        nfkc: "\u{CB9B}",
        nfkd: "\u{110D}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CB9C}",
        nfc: "\u{CB9C}",
        nfd: "\u{110D}\u{1171}",
        nfkc: "\u{CB9C}",
        nfkd: "\u{110D}\u{1171}",
    },
    NormalizationTest {
        source: "\u{CB9D}",
        nfc: "\u{CB9D}",
        nfd: "\u{110D}\u{1171}\u{11A8}",
        nfkc: "\u{CB9D}",
        nfkd: "\u{110D}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CB9E}",
        nfc: "\u{CB9E}",
        nfd: "\u{110D}\u{1171}\u{11A9}",
        nfkc: "\u{CB9E}",
        nfkd: "\u{110D}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CB9F}",
        nfc: "\u{CB9F}",
        nfd: "\u{110D}\u{1171}\u{11AA}",
        nfkc: "\u{CB9F}",
        nfkd: "\u{110D}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CBA0}",
        nfc: "\u{CBA0}",
        nfd: "\u{110D}\u{1171}\u{11AB}",
        nfkc: "\u{CBA0}",
        nfkd: "\u{110D}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CBA1}",
        nfc: "\u{CBA1}",
        nfd: "\u{110D}\u{1171}\u{11AC}",
        nfkc: "\u{CBA1}",
        nfkd: "\u{110D}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CBA2}",
        nfc: "\u{CBA2}",
        nfd: "\u{110D}\u{1171}\u{11AD}",
        nfkc: "\u{CBA2}",
        nfkd: "\u{110D}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CBA3}",
        nfc: "\u{CBA3}",
        nfd: "\u{110D}\u{1171}\u{11AE}",
        nfkc: "\u{CBA3}",
        nfkd: "\u{110D}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CBA4}",
        nfc: "\u{CBA4}",
        nfd: "\u{110D}\u{1171}\u{11AF}",
        nfkc: "\u{CBA4}",
        nfkd: "\u{110D}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CBA5}",
        nfc: "\u{CBA5}",
        nfd: "\u{110D}\u{1171}\u{11B0}",
        nfkc: "\u{CBA5}",
        nfkd: "\u{110D}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CBA6}",
        nfc: "\u{CBA6}",
        nfd: "\u{110D}\u{1171}\u{11B1}",
        nfkc: "\u{CBA6}",
        nfkd: "\u{110D}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CBA7}",
        nfc: "\u{CBA7}",
        nfd: "\u{110D}\u{1171}\u{11B2}",
        nfkc: "\u{CBA7}",
        nfkd: "\u{110D}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CBA8}",
        nfc: "\u{CBA8}",
        nfd: "\u{110D}\u{1171}\u{11B3}",
        nfkc: "\u{CBA8}",
        nfkd: "\u{110D}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CBA9}",
        nfc: "\u{CBA9}",
        nfd: "\u{110D}\u{1171}\u{11B4}",
        nfkc: "\u{CBA9}",
        nfkd: "\u{110D}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CBAA}",
        nfc: "\u{CBAA}",
        nfd: "\u{110D}\u{1171}\u{11B5}",
        nfkc: "\u{CBAA}",
        nfkd: "\u{110D}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CBAB}",
        nfc: "\u{CBAB}",
        nfd: "\u{110D}\u{1171}\u{11B6}",
        nfkc: "\u{CBAB}",
        nfkd: "\u{110D}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CBAC}",
        nfc: "\u{CBAC}",
        nfd: "\u{110D}\u{1171}\u{11B7}",
        nfkc: "\u{CBAC}",
        nfkd: "\u{110D}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CBAD}",
        nfc: "\u{CBAD}",
        nfd: "\u{110D}\u{1171}\u{11B8}",
        nfkc: "\u{CBAD}",
        nfkd: "\u{110D}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CBAE}",
        nfc: "\u{CBAE}",
        nfd: "\u{110D}\u{1171}\u{11B9}",
        nfkc: "\u{CBAE}",
        nfkd: "\u{110D}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CBAF}",
        nfc: "\u{CBAF}",
        nfd: "\u{110D}\u{1171}\u{11BA}",
        nfkc: "\u{CBAF}",
        nfkd: "\u{110D}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CBB0}",
        nfc: "\u{CBB0}",
        nfd: "\u{110D}\u{1171}\u{11BB}",
        nfkc: "\u{CBB0}",
        nfkd: "\u{110D}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CBB1}",
        nfc: "\u{CBB1}",
        nfd: "\u{110D}\u{1171}\u{11BC}",
        nfkc: "\u{CBB1}",
        nfkd: "\u{110D}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CBB2}",
        nfc: "\u{CBB2}",
        nfd: "\u{110D}\u{1171}\u{11BD}",
        nfkc: "\u{CBB2}",
        nfkd: "\u{110D}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CBB3}",
        nfc: "\u{CBB3}",
        nfd: "\u{110D}\u{1171}\u{11BE}",
        nfkc: "\u{CBB3}",
        nfkd: "\u{110D}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CBB4}",
        nfc: "\u{CBB4}",
        nfd: "\u{110D}\u{1171}\u{11BF}",
        nfkc: "\u{CBB4}",
        nfkd: "\u{110D}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CBB5}",
        nfc: "\u{CBB5}",
        nfd: "\u{110D}\u{1171}\u{11C0}",
        nfkc: "\u{CBB5}",
        nfkd: "\u{110D}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CBB6}",
        nfc: "\u{CBB6}",
        nfd: "\u{110D}\u{1171}\u{11C1}",
        nfkc: "\u{CBB6}",
        nfkd: "\u{110D}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CBB7}",
        nfc: "\u{CBB7}",
        nfd: "\u{110D}\u{1171}\u{11C2}",
        nfkc: "\u{CBB7}",
        nfkd: "\u{110D}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CBB8}",
        nfc: "\u{CBB8}",
        nfd: "\u{110D}\u{1172}",
        nfkc: "\u{CBB8}",
        nfkd: "\u{110D}\u{1172}",
    },
    NormalizationTest {
        source: "\u{CBB9}",
        nfc: "\u{CBB9}",
        nfd: "\u{110D}\u{1172}\u{11A8}",
        nfkc: "\u{CBB9}",
        nfkd: "\u{110D}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CBBA}",
        nfc: "\u{CBBA}",
        nfd: "\u{110D}\u{1172}\u{11A9}",
        nfkc: "\u{CBBA}",
        nfkd: "\u{110D}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CBBB}",
        nfc: "\u{CBBB}",
        nfd: "\u{110D}\u{1172}\u{11AA}",
        nfkc: "\u{CBBB}",
        nfkd: "\u{110D}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CBBC}",
        nfc: "\u{CBBC}",
        nfd: "\u{110D}\u{1172}\u{11AB}",
        nfkc: "\u{CBBC}",
        nfkd: "\u{110D}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CBBD}",
        nfc: "\u{CBBD}",
        nfd: "\u{110D}\u{1172}\u{11AC}",
        nfkc: "\u{CBBD}",
        nfkd: "\u{110D}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CBBE}",
        nfc: "\u{CBBE}",
        nfd: "\u{110D}\u{1172}\u{11AD}",
        nfkc: "\u{CBBE}",
        nfkd: "\u{110D}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CBBF}",
        nfc: "\u{CBBF}",
        nfd: "\u{110D}\u{1172}\u{11AE}",
        nfkc: "\u{CBBF}",
        nfkd: "\u{110D}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CBC0}",
        nfc: "\u{CBC0}",
        nfd: "\u{110D}\u{1172}\u{11AF}",
        nfkc: "\u{CBC0}",
        nfkd: "\u{110D}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CBC1}",
        nfc: "\u{CBC1}",
        nfd: "\u{110D}\u{1172}\u{11B0}",
        nfkc: "\u{CBC1}",
        nfkd: "\u{110D}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CBC2}",
        nfc: "\u{CBC2}",
        nfd: "\u{110D}\u{1172}\u{11B1}",
        nfkc: "\u{CBC2}",
        nfkd: "\u{110D}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CBC3}",
        nfc: "\u{CBC3}",
        nfd: "\u{110D}\u{1172}\u{11B2}",
        nfkc: "\u{CBC3}",
        nfkd: "\u{110D}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CBC4}",
        nfc: "\u{CBC4}",
        nfd: "\u{110D}\u{1172}\u{11B3}",
        nfkc: "\u{CBC4}",
        nfkd: "\u{110D}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CBC5}",
        nfc: "\u{CBC5}",
        nfd: "\u{110D}\u{1172}\u{11B4}",
        nfkc: "\u{CBC5}",
        nfkd: "\u{110D}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CBC6}",
        nfc: "\u{CBC6}",
        nfd: "\u{110D}\u{1172}\u{11B5}",
        nfkc: "\u{CBC6}",
        nfkd: "\u{110D}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CBC7}",
        nfc: "\u{CBC7}",
        nfd: "\u{110D}\u{1172}\u{11B6}",
        nfkc: "\u{CBC7}",
        nfkd: "\u{110D}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CBC8}",
        nfc: "\u{CBC8}",
        nfd: "\u{110D}\u{1172}\u{11B7}",
        nfkc: "\u{CBC8}",
        nfkd: "\u{110D}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CBC9}",
        nfc: "\u{CBC9}",
        nfd: "\u{110D}\u{1172}\u{11B8}",
        nfkc: "\u{CBC9}",
        nfkd: "\u{110D}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CBCA}",
        nfc: "\u{CBCA}",
        nfd: "\u{110D}\u{1172}\u{11B9}",
        nfkc: "\u{CBCA}",
        nfkd: "\u{110D}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CBCB}",
        nfc: "\u{CBCB}",
        nfd: "\u{110D}\u{1172}\u{11BA}",
        nfkc: "\u{CBCB}",
        nfkd: "\u{110D}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CBCC}",
        nfc: "\u{CBCC}",
        nfd: "\u{110D}\u{1172}\u{11BB}",
        nfkc: "\u{CBCC}",
        nfkd: "\u{110D}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CBCD}",
        nfc: "\u{CBCD}",
        nfd: "\u{110D}\u{1172}\u{11BC}",
        nfkc: "\u{CBCD}",
        nfkd: "\u{110D}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CBCE}",
        nfc: "\u{CBCE}",
        nfd: "\u{110D}\u{1172}\u{11BD}",
        nfkc: "\u{CBCE}",
        nfkd: "\u{110D}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CBCF}",
        nfc: "\u{CBCF}",
        nfd: "\u{110D}\u{1172}\u{11BE}",
        nfkc: "\u{CBCF}",
        nfkd: "\u{110D}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CBD0}",
        nfc: "\u{CBD0}",
        nfd: "\u{110D}\u{1172}\u{11BF}",
        nfkc: "\u{CBD0}",
        nfkd: "\u{110D}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CBD1}",
        nfc: "\u{CBD1}",
        nfd: "\u{110D}\u{1172}\u{11C0}",
        nfkc: "\u{CBD1}",
        nfkd: "\u{110D}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CBD2}",
        nfc: "\u{CBD2}",
        nfd: "\u{110D}\u{1172}\u{11C1}",
        nfkc: "\u{CBD2}",
        nfkd: "\u{110D}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CBD3}",
        nfc: "\u{CBD3}",
        nfd: "\u{110D}\u{1172}\u{11C2}",
        nfkc: "\u{CBD3}",
        nfkd: "\u{110D}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CBD4}",
        nfc: "\u{CBD4}",
        nfd: "\u{110D}\u{1173}",
        nfkc: "\u{CBD4}",
        nfkd: "\u{110D}\u{1173}",
    },
    NormalizationTest {
        source: "\u{CBD5}",
        nfc: "\u{CBD5}",
        nfd: "\u{110D}\u{1173}\u{11A8}",
        nfkc: "\u{CBD5}",
        nfkd: "\u{110D}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CBD6}",
        nfc: "\u{CBD6}",
        nfd: "\u{110D}\u{1173}\u{11A9}",
        nfkc: "\u{CBD6}",
        nfkd: "\u{110D}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CBD7}",
        nfc: "\u{CBD7}",
        nfd: "\u{110D}\u{1173}\u{11AA}",
        nfkc: "\u{CBD7}",
        nfkd: "\u{110D}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CBD8}",
        nfc: "\u{CBD8}",
        nfd: "\u{110D}\u{1173}\u{11AB}",
        nfkc: "\u{CBD8}",
        nfkd: "\u{110D}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CBD9}",
        nfc: "\u{CBD9}",
        nfd: "\u{110D}\u{1173}\u{11AC}",
        nfkc: "\u{CBD9}",
        nfkd: "\u{110D}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CBDA}",
        nfc: "\u{CBDA}",
        nfd: "\u{110D}\u{1173}\u{11AD}",
        nfkc: "\u{CBDA}",
        nfkd: "\u{110D}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CBDB}",
        nfc: "\u{CBDB}",
        nfd: "\u{110D}\u{1173}\u{11AE}",
        nfkc: "\u{CBDB}",
        nfkd: "\u{110D}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CBDC}",
        nfc: "\u{CBDC}",
        nfd: "\u{110D}\u{1173}\u{11AF}",
        nfkc: "\u{CBDC}",
        nfkd: "\u{110D}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CBDD}",
        nfc: "\u{CBDD}",
        nfd: "\u{110D}\u{1173}\u{11B0}",
        nfkc: "\u{CBDD}",
        nfkd: "\u{110D}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CBDE}",
        nfc: "\u{CBDE}",
        nfd: "\u{110D}\u{1173}\u{11B1}",
        nfkc: "\u{CBDE}",
        nfkd: "\u{110D}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CBDF}",
        nfc: "\u{CBDF}",
        nfd: "\u{110D}\u{1173}\u{11B2}",
        nfkc: "\u{CBDF}",
        nfkd: "\u{110D}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CBE0}",
        nfc: "\u{CBE0}",
        nfd: "\u{110D}\u{1173}\u{11B3}",
        nfkc: "\u{CBE0}",
        nfkd: "\u{110D}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CBE1}",
        nfc: "\u{CBE1}",
        nfd: "\u{110D}\u{1173}\u{11B4}",
        nfkc: "\u{CBE1}",
        nfkd: "\u{110D}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CBE2}",
        nfc: "\u{CBE2}",
        nfd: "\u{110D}\u{1173}\u{11B5}",
        nfkc: "\u{CBE2}",
        nfkd: "\u{110D}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CBE3}",
        nfc: "\u{CBE3}",
        nfd: "\u{110D}\u{1173}\u{11B6}",
        nfkc: "\u{CBE3}",
        nfkd: "\u{110D}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CBE4}",
        nfc: "\u{CBE4}",
        nfd: "\u{110D}\u{1173}\u{11B7}",
        nfkc: "\u{CBE4}",
        nfkd: "\u{110D}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CBE5}",
        nfc: "\u{CBE5}",
        nfd: "\u{110D}\u{1173}\u{11B8}",
        nfkc: "\u{CBE5}",
        nfkd: "\u{110D}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CBE6}",
        nfc: "\u{CBE6}",
        nfd: "\u{110D}\u{1173}\u{11B9}",
        nfkc: "\u{CBE6}",
        nfkd: "\u{110D}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CBE7}",
        nfc: "\u{CBE7}",
        nfd: "\u{110D}\u{1173}\u{11BA}",
        nfkc: "\u{CBE7}",
        nfkd: "\u{110D}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CBE8}",
        nfc: "\u{CBE8}",
        nfd: "\u{110D}\u{1173}\u{11BB}",
        nfkc: "\u{CBE8}",
        nfkd: "\u{110D}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CBE9}",
        nfc: "\u{CBE9}",
        nfd: "\u{110D}\u{1173}\u{11BC}",
        nfkc: "\u{CBE9}",
        nfkd: "\u{110D}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CBEA}",
        nfc: "\u{CBEA}",
        nfd: "\u{110D}\u{1173}\u{11BD}",
        nfkc: "\u{CBEA}",
        nfkd: "\u{110D}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CBEB}",
        nfc: "\u{CBEB}",
        nfd: "\u{110D}\u{1173}\u{11BE}",
        nfkc: "\u{CBEB}",
        nfkd: "\u{110D}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CBEC}",
        nfc: "\u{CBEC}",
        nfd: "\u{110D}\u{1173}\u{11BF}",
        nfkc: "\u{CBEC}",
        nfkd: "\u{110D}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CBED}",
        nfc: "\u{CBED}",
        nfd: "\u{110D}\u{1173}\u{11C0}",
        nfkc: "\u{CBED}",
        nfkd: "\u{110D}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CBEE}",
        nfc: "\u{CBEE}",
        nfd: "\u{110D}\u{1173}\u{11C1}",
        nfkc: "\u{CBEE}",
        nfkd: "\u{110D}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CBEF}",
        nfc: "\u{CBEF}",
        nfd: "\u{110D}\u{1173}\u{11C2}",
        nfkc: "\u{CBEF}",
        nfkd: "\u{110D}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CBF0}",
        nfc: "\u{CBF0}",
        nfd: "\u{110D}\u{1174}",
        nfkc: "\u{CBF0}",
        nfkd: "\u{110D}\u{1174}",
    },
    NormalizationTest {
        source: "\u{CBF1}",
        nfc: "\u{CBF1}",
        nfd: "\u{110D}\u{1174}\u{11A8}",
        nfkc: "\u{CBF1}",
        nfkd: "\u{110D}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CBF2}",
        nfc: "\u{CBF2}",
        nfd: "\u{110D}\u{1174}\u{11A9}",
        nfkc: "\u{CBF2}",
        nfkd: "\u{110D}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CBF3}",
        nfc: "\u{CBF3}",
        nfd: "\u{110D}\u{1174}\u{11AA}",
        nfkc: "\u{CBF3}",
        nfkd: "\u{110D}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CBF4}",
        nfc: "\u{CBF4}",
        nfd: "\u{110D}\u{1174}\u{11AB}",
        nfkc: "\u{CBF4}",
        nfkd: "\u{110D}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CBF5}",
        nfc: "\u{CBF5}",
        nfd: "\u{110D}\u{1174}\u{11AC}",
        nfkc: "\u{CBF5}",
        nfkd: "\u{110D}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CBF6}",
        nfc: "\u{CBF6}",
        nfd: "\u{110D}\u{1174}\u{11AD}",
        nfkc: "\u{CBF6}",
        nfkd: "\u{110D}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CBF7}",
        nfc: "\u{CBF7}",
        nfd: "\u{110D}\u{1174}\u{11AE}",
        nfkc: "\u{CBF7}",
        nfkd: "\u{110D}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CBF8}",
        nfc: "\u{CBF8}",
        nfd: "\u{110D}\u{1174}\u{11AF}",
        nfkc: "\u{CBF8}",
        nfkd: "\u{110D}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CBF9}",
        nfc: "\u{CBF9}",
        nfd: "\u{110D}\u{1174}\u{11B0}",
        nfkc: "\u{CBF9}",
        nfkd: "\u{110D}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CBFA}",
        nfc: "\u{CBFA}",
        nfd: "\u{110D}\u{1174}\u{11B1}",
        nfkc: "\u{CBFA}",
        nfkd: "\u{110D}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CBFB}",
        nfc: "\u{CBFB}",
        nfd: "\u{110D}\u{1174}\u{11B2}",
        nfkc: "\u{CBFB}",
        nfkd: "\u{110D}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CBFC}",
        nfc: "\u{CBFC}",
        nfd: "\u{110D}\u{1174}\u{11B3}",
        nfkc: "\u{CBFC}",
        nfkd: "\u{110D}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CBFD}",
        nfc: "\u{CBFD}",
        nfd: "\u{110D}\u{1174}\u{11B4}",
        nfkc: "\u{CBFD}",
        nfkd: "\u{110D}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CBFE}",
        nfc: "\u{CBFE}",
        nfd: "\u{110D}\u{1174}\u{11B5}",
        nfkc: "\u{CBFE}",
        nfkd: "\u{110D}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CBFF}",
        nfc: "\u{CBFF}",
        nfd: "\u{110D}\u{1174}\u{11B6}",
        nfkc: "\u{CBFF}",
        nfkd: "\u{110D}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CC00}",
        nfc: "\u{CC00}",
        nfd: "\u{110D}\u{1174}\u{11B7}",
        nfkc: "\u{CC00}",
        nfkd: "\u{110D}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CC01}",
        nfc: "\u{CC01}",
        nfd: "\u{110D}\u{1174}\u{11B8}",
        nfkc: "\u{CC01}",
        nfkd: "\u{110D}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CC02}",
        nfc: "\u{CC02}",
        nfd: "\u{110D}\u{1174}\u{11B9}",
        nfkc: "\u{CC02}",
        nfkd: "\u{110D}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CC03}",
        nfc: "\u{CC03}",
        nfd: "\u{110D}\u{1174}\u{11BA}",
        nfkc: "\u{CC03}",
        nfkd: "\u{110D}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CC04}",
        nfc: "\u{CC04}",
        nfd: "\u{110D}\u{1174}\u{11BB}",
        nfkc: "\u{CC04}",
        nfkd: "\u{110D}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CC05}",
        nfc: "\u{CC05}",
        nfd: "\u{110D}\u{1174}\u{11BC}",
        nfkc: "\u{CC05}",
        nfkd: "\u{110D}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CC06}",
        nfc: "\u{CC06}",
        nfd: "\u{110D}\u{1174}\u{11BD}",
        nfkc: "\u{CC06}",
        nfkd: "\u{110D}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CC07}",
        nfc: "\u{CC07}",
        nfd: "\u{110D}\u{1174}\u{11BE}",
        nfkc: "\u{CC07}",
        nfkd: "\u{110D}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CC08}",
        nfc: "\u{CC08}",
        nfd: "\u{110D}\u{1174}\u{11BF}",
        nfkc: "\u{CC08}",
        nfkd: "\u{110D}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CC09}",
        nfc: "\u{CC09}",
        nfd: "\u{110D}\u{1174}\u{11C0}",
        nfkc: "\u{CC09}",
        nfkd: "\u{110D}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CC0A}",
        nfc: "\u{CC0A}",
        nfd: "\u{110D}\u{1174}\u{11C1}",
        nfkc: "\u{CC0A}",
        nfkd: "\u{110D}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CC0B}",
        nfc: "\u{CC0B}",
        nfd: "\u{110D}\u{1174}\u{11C2}",
        nfkc: "\u{CC0B}",
        nfkd: "\u{110D}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CC0C}",
        nfc: "\u{CC0C}",
        nfd: "\u{110D}\u{1175}",
        nfkc: "\u{CC0C}",
        nfkd: "\u{110D}\u{1175}",
    },
    NormalizationTest {
        source: "\u{CC0D}",
        nfc: "\u{CC0D}",
        nfd: "\u{110D}\u{1175}\u{11A8}",
        nfkc: "\u{CC0D}",
        nfkd: "\u{110D}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CC0E}",
        nfc: "\u{CC0E}",
        nfd: "\u{110D}\u{1175}\u{11A9}",
        nfkc: "\u{CC0E}",
        nfkd: "\u{110D}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CC0F}",
        nfc: "\u{CC0F}",
        nfd: "\u{110D}\u{1175}\u{11AA}",
        nfkc: "\u{CC0F}",
        nfkd: "\u{110D}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CC10}",
        nfc: "\u{CC10}",
        nfd: "\u{110D}\u{1175}\u{11AB}",
        nfkc: "\u{CC10}",
        nfkd: "\u{110D}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CC11}",
        nfc: "\u{CC11}",
        nfd: "\u{110D}\u{1175}\u{11AC}",
        nfkc: "\u{CC11}",
        nfkd: "\u{110D}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CC12}",
        nfc: "\u{CC12}",
        nfd: "\u{110D}\u{1175}\u{11AD}",
        nfkc: "\u{CC12}",
        nfkd: "\u{110D}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CC13}",
        nfc: "\u{CC13}",
        nfd: "\u{110D}\u{1175}\u{11AE}",
        nfkc: "\u{CC13}",
        nfkd: "\u{110D}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CC14}",
        nfc: "\u{CC14}",
        nfd: "\u{110D}\u{1175}\u{11AF}",
        nfkc: "\u{CC14}",
        nfkd: "\u{110D}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CC15}",
        nfc: "\u{CC15}",
        nfd: "\u{110D}\u{1175}\u{11B0}",
        nfkc: "\u{CC15}",
        nfkd: "\u{110D}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CC16}",
        nfc: "\u{CC16}",
        nfd: "\u{110D}\u{1175}\u{11B1}",
        nfkc: "\u{CC16}",
        nfkd: "\u{110D}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CC17}",
        nfc: "\u{CC17}",
        nfd: "\u{110D}\u{1175}\u{11B2}",
        nfkc: "\u{CC17}",
        nfkd: "\u{110D}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CC18}",
        nfc: "\u{CC18}",
        nfd: "\u{110D}\u{1175}\u{11B3}",
        nfkc: "\u{CC18}",
        nfkd: "\u{110D}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CC19}",
        nfc: "\u{CC19}",
        nfd: "\u{110D}\u{1175}\u{11B4}",
        nfkc: "\u{CC19}",
        nfkd: "\u{110D}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CC1A}",
        nfc: "\u{CC1A}",
        nfd: "\u{110D}\u{1175}\u{11B5}",
        nfkc: "\u{CC1A}",
        nfkd: "\u{110D}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CC1B}",
        nfc: "\u{CC1B}",
        nfd: "\u{110D}\u{1175}\u{11B6}",
        nfkc: "\u{CC1B}",
        nfkd: "\u{110D}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CC1C}",
        nfc: "\u{CC1C}",
        nfd: "\u{110D}\u{1175}\u{11B7}",
        nfkc: "\u{CC1C}",
        nfkd: "\u{110D}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CC1D}",
        nfc: "\u{CC1D}",
        nfd: "\u{110D}\u{1175}\u{11B8}",
        nfkc: "\u{CC1D}",
        nfkd: "\u{110D}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CC1E}",
        nfc: "\u{CC1E}",
        nfd: "\u{110D}\u{1175}\u{11B9}",
        nfkc: "\u{CC1E}",
        nfkd: "\u{110D}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CC1F}",
        nfc: "\u{CC1F}",
        nfd: "\u{110D}\u{1175}\u{11BA}",
        nfkc: "\u{CC1F}",
        nfkd: "\u{110D}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CC20}",
        nfc: "\u{CC20}",
        nfd: "\u{110D}\u{1175}\u{11BB}",
        nfkc: "\u{CC20}",
        nfkd: "\u{110D}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CC21}",
        nfc: "\u{CC21}",
        nfd: "\u{110D}\u{1175}\u{11BC}",
        nfkc: "\u{CC21}",
        nfkd: "\u{110D}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CC22}",
        nfc: "\u{CC22}",
        nfd: "\u{110D}\u{1175}\u{11BD}",
        nfkc: "\u{CC22}",
        nfkd: "\u{110D}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CC23}",
        nfc: "\u{CC23}",
        nfd: "\u{110D}\u{1175}\u{11BE}",
        nfkc: "\u{CC23}",
        nfkd: "\u{110D}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CC24}",
        nfc: "\u{CC24}",
        nfd: "\u{110D}\u{1175}\u{11BF}",
        nfkc: "\u{CC24}",
        nfkd: "\u{110D}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CC25}",
        nfc: "\u{CC25}",
        nfd: "\u{110D}\u{1175}\u{11C0}",
        nfkc: "\u{CC25}",
        nfkd: "\u{110D}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CC26}",
        nfc: "\u{CC26}",
        nfd: "\u{110D}\u{1175}\u{11C1}",
        nfkc: "\u{CC26}",
        nfkd: "\u{110D}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CC27}",
        nfc: "\u{CC27}",
        nfd: "\u{110D}\u{1175}\u{11C2}",
        nfkc: "\u{CC27}",
        nfkd: "\u{110D}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CC28}",
        nfc: "\u{CC28}",
        nfd: "\u{110E}\u{1161}",
        nfkc: "\u{CC28}",
        nfkd: "\u{110E}\u{1161}",
    },
    NormalizationTest {
        source: "\u{CC29}",
        nfc: "\u{CC29}",
        nfd: "\u{110E}\u{1161}\u{11A8}",
        nfkc: "\u{CC29}",
        nfkd: "\u{110E}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CC2A}",
        nfc: "\u{CC2A}",
        nfd: "\u{110E}\u{1161}\u{11A9}",
        nfkc: "\u{CC2A}",
        nfkd: "\u{110E}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CC2B}",
        nfc: "\u{CC2B}",
        nfd: "\u{110E}\u{1161}\u{11AA}",
        nfkc: "\u{CC2B}",
        nfkd: "\u{110E}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CC2C}",
        nfc: "\u{CC2C}",
        nfd: "\u{110E}\u{1161}\u{11AB}",
        nfkc: "\u{CC2C}",
        nfkd: "\u{110E}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CC2D}",
        nfc: "\u{CC2D}",
        nfd: "\u{110E}\u{1161}\u{11AC}",
        nfkc: "\u{CC2D}",
        nfkd: "\u{110E}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CC2E}",
        nfc: "\u{CC2E}",
        nfd: "\u{110E}\u{1161}\u{11AD}",
        nfkc: "\u{CC2E}",
        nfkd: "\u{110E}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CC2F}",
        nfc: "\u{CC2F}",
        nfd: "\u{110E}\u{1161}\u{11AE}",
        nfkc: "\u{CC2F}",
        nfkd: "\u{110E}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CC30}",
        nfc: "\u{CC30}",
        nfd: "\u{110E}\u{1161}\u{11AF}",
        nfkc: "\u{CC30}",
        nfkd: "\u{110E}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CC31}",
        nfc: "\u{CC31}",
        nfd: "\u{110E}\u{1161}\u{11B0}",
        nfkc: "\u{CC31}",
        nfkd: "\u{110E}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CC32}",
        nfc: "\u{CC32}",
        nfd: "\u{110E}\u{1161}\u{11B1}",
        nfkc: "\u{CC32}",
        nfkd: "\u{110E}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CC33}",
        nfc: "\u{CC33}",
        nfd: "\u{110E}\u{1161}\u{11B2}",
        nfkc: "\u{CC33}",
        nfkd: "\u{110E}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CC34}",
        nfc: "\u{CC34}",
        nfd: "\u{110E}\u{1161}\u{11B3}",
        nfkc: "\u{CC34}",
        nfkd: "\u{110E}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CC35}",
        nfc: "\u{CC35}",
        nfd: "\u{110E}\u{1161}\u{11B4}",
        nfkc: "\u{CC35}",
        nfkd: "\u{110E}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CC36}",
        nfc: "\u{CC36}",
        nfd: "\u{110E}\u{1161}\u{11B5}",
        nfkc: "\u{CC36}",
        nfkd: "\u{110E}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CC37}",
        nfc: "\u{CC37}",
        nfd: "\u{110E}\u{1161}\u{11B6}",
        nfkc: "\u{CC37}",
        nfkd: "\u{110E}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CC38}",
        nfc: "\u{CC38}",
        nfd: "\u{110E}\u{1161}\u{11B7}",
        nfkc: "\u{CC38}",
        nfkd: "\u{110E}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CC39}",
        nfc: "\u{CC39}",
        nfd: "\u{110E}\u{1161}\u{11B8}",
        nfkc: "\u{CC39}",
        nfkd: "\u{110E}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CC3A}",
        nfc: "\u{CC3A}",
        nfd: "\u{110E}\u{1161}\u{11B9}",
        nfkc: "\u{CC3A}",
        nfkd: "\u{110E}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CC3B}",
        nfc: "\u{CC3B}",
        nfd: "\u{110E}\u{1161}\u{11BA}",
        nfkc: "\u{CC3B}",
        nfkd: "\u{110E}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CC3C}",
        nfc: "\u{CC3C}",
        nfd: "\u{110E}\u{1161}\u{11BB}",
        nfkc: "\u{CC3C}",
        nfkd: "\u{110E}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CC3D}",
        nfc: "\u{CC3D}",
        nfd: "\u{110E}\u{1161}\u{11BC}",
        nfkc: "\u{CC3D}",
        nfkd: "\u{110E}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CC3E}",
        nfc: "\u{CC3E}",
        nfd: "\u{110E}\u{1161}\u{11BD}",
        nfkc: "\u{CC3E}",
        nfkd: "\u{110E}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CC3F}",
        nfc: "\u{CC3F}",
        nfd: "\u{110E}\u{1161}\u{11BE}",
        nfkc: "\u{CC3F}",
        nfkd: "\u{110E}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CC40}",
        nfc: "\u{CC40}",
        nfd: "\u{110E}\u{1161}\u{11BF}",
        nfkc: "\u{CC40}",
        nfkd: "\u{110E}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CC41}",
        nfc: "\u{CC41}",
        nfd: "\u{110E}\u{1161}\u{11C0}",
        nfkc: "\u{CC41}",
        nfkd: "\u{110E}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CC42}",
        nfc: "\u{CC42}",
        nfd: "\u{110E}\u{1161}\u{11C1}",
        nfkc: "\u{CC42}",
        nfkd: "\u{110E}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CC43}",
        nfc: "\u{CC43}",
        nfd: "\u{110E}\u{1161}\u{11C2}",
        nfkc: "\u{CC43}",
        nfkd: "\u{110E}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CC44}",
        nfc: "\u{CC44}",
        nfd: "\u{110E}\u{1162}",
        nfkc: "\u{CC44}",
        nfkd: "\u{110E}\u{1162}",
    },
    NormalizationTest {
        source: "\u{CC45}",
        nfc: "\u{CC45}",
        nfd: "\u{110E}\u{1162}\u{11A8}",
        nfkc: "\u{CC45}",
        nfkd: "\u{110E}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CC46}",
        nfc: "\u{CC46}",
        nfd: "\u{110E}\u{1162}\u{11A9}",
        nfkc: "\u{CC46}",
        nfkd: "\u{110E}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CC47}",
        nfc: "\u{CC47}",
        nfd: "\u{110E}\u{1162}\u{11AA}",
        nfkc: "\u{CC47}",
        nfkd: "\u{110E}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CC48}",
        nfc: "\u{CC48}",
        nfd: "\u{110E}\u{1162}\u{11AB}",
        nfkc: "\u{CC48}",
        nfkd: "\u{110E}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CC49}",
        nfc: "\u{CC49}",
        nfd: "\u{110E}\u{1162}\u{11AC}",
        nfkc: "\u{CC49}",
        nfkd: "\u{110E}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CC4A}",
        nfc: "\u{CC4A}",
        nfd: "\u{110E}\u{1162}\u{11AD}",
        nfkc: "\u{CC4A}",
        nfkd: "\u{110E}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CC4B}",
        nfc: "\u{CC4B}",
        nfd: "\u{110E}\u{1162}\u{11AE}",
        nfkc: "\u{CC4B}",
        nfkd: "\u{110E}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CC4C}",
        nfc: "\u{CC4C}",
        nfd: "\u{110E}\u{1162}\u{11AF}",
        nfkc: "\u{CC4C}",
        nfkd: "\u{110E}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CC4D}",
        nfc: "\u{CC4D}",
        nfd: "\u{110E}\u{1162}\u{11B0}",
        nfkc: "\u{CC4D}",
        nfkd: "\u{110E}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CC4E}",
        nfc: "\u{CC4E}",
        nfd: "\u{110E}\u{1162}\u{11B1}",
        nfkc: "\u{CC4E}",
        nfkd: "\u{110E}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CC4F}",
        nfc: "\u{CC4F}",
        nfd: "\u{110E}\u{1162}\u{11B2}",
        nfkc: "\u{CC4F}",
        nfkd: "\u{110E}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CC50}",
        nfc: "\u{CC50}",
        nfd: "\u{110E}\u{1162}\u{11B3}",
        nfkc: "\u{CC50}",
        nfkd: "\u{110E}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CC51}",
        nfc: "\u{CC51}",
        nfd: "\u{110E}\u{1162}\u{11B4}",
        nfkc: "\u{CC51}",
        nfkd: "\u{110E}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CC52}",
        nfc: "\u{CC52}",
        nfd: "\u{110E}\u{1162}\u{11B5}",
        nfkc: "\u{CC52}",
        nfkd: "\u{110E}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CC53}",
        nfc: "\u{CC53}",
        nfd: "\u{110E}\u{1162}\u{11B6}",
        nfkc: "\u{CC53}",
        nfkd: "\u{110E}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CC54}",
        nfc: "\u{CC54}",
        nfd: "\u{110E}\u{1162}\u{11B7}",
        nfkc: "\u{CC54}",
        nfkd: "\u{110E}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CC55}",
        nfc: "\u{CC55}",
        nfd: "\u{110E}\u{1162}\u{11B8}",
        nfkc: "\u{CC55}",
        nfkd: "\u{110E}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CC56}",
        nfc: "\u{CC56}",
        nfd: "\u{110E}\u{1162}\u{11B9}",
        nfkc: "\u{CC56}",
        nfkd: "\u{110E}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CC57}",
        nfc: "\u{CC57}",
        nfd: "\u{110E}\u{1162}\u{11BA}",
        nfkc: "\u{CC57}",
        nfkd: "\u{110E}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CC58}",
        nfc: "\u{CC58}",
        nfd: "\u{110E}\u{1162}\u{11BB}",
        nfkc: "\u{CC58}",
        nfkd: "\u{110E}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CC59}",
        nfc: "\u{CC59}",
        nfd: "\u{110E}\u{1162}\u{11BC}",
        nfkc: "\u{CC59}",
        nfkd: "\u{110E}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CC5A}",
        nfc: "\u{CC5A}",
        nfd: "\u{110E}\u{1162}\u{11BD}",
        nfkc: "\u{CC5A}",
        nfkd: "\u{110E}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CC5B}",
        nfc: "\u{CC5B}",
        nfd: "\u{110E}\u{1162}\u{11BE}",
        nfkc: "\u{CC5B}",
        nfkd: "\u{110E}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CC5C}",
        nfc: "\u{CC5C}",
        nfd: "\u{110E}\u{1162}\u{11BF}",
        nfkc: "\u{CC5C}",
        nfkd: "\u{110E}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CC5D}",
        nfc: "\u{CC5D}",
        nfd: "\u{110E}\u{1162}\u{11C0}",
        nfkc: "\u{CC5D}",
        nfkd: "\u{110E}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CC5E}",
        nfc: "\u{CC5E}",
        nfd: "\u{110E}\u{1162}\u{11C1}",
        nfkc: "\u{CC5E}",
        nfkd: "\u{110E}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CC5F}",
        nfc: "\u{CC5F}",
        nfd: "\u{110E}\u{1162}\u{11C2}",
        nfkc: "\u{CC5F}",
        nfkd: "\u{110E}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CC60}",
        nfc: "\u{CC60}",
        nfd: "\u{110E}\u{1163}",
        nfkc: "\u{CC60}",
        nfkd: "\u{110E}\u{1163}",
    },
    NormalizationTest {
        source: "\u{CC61}",
        nfc: "\u{CC61}",
        nfd: "\u{110E}\u{1163}\u{11A8}",
        nfkc: "\u{CC61}",
        nfkd: "\u{110E}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CC62}",
        nfc: "\u{CC62}",
        nfd: "\u{110E}\u{1163}\u{11A9}",
        nfkc: "\u{CC62}",
        nfkd: "\u{110E}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CC63}",
        nfc: "\u{CC63}",
        nfd: "\u{110E}\u{1163}\u{11AA}",
        nfkc: "\u{CC63}",
        nfkd: "\u{110E}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CC64}",
        nfc: "\u{CC64}",
        nfd: "\u{110E}\u{1163}\u{11AB}",
        nfkc: "\u{CC64}",
        nfkd: "\u{110E}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CC65}",
        nfc: "\u{CC65}",
        nfd: "\u{110E}\u{1163}\u{11AC}",
        nfkc: "\u{CC65}",
        nfkd: "\u{110E}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CC66}",
        nfc: "\u{CC66}",
        nfd: "\u{110E}\u{1163}\u{11AD}",
        nfkc: "\u{CC66}",
        nfkd: "\u{110E}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CC67}",
        nfc: "\u{CC67}",
        nfd: "\u{110E}\u{1163}\u{11AE}",
        nfkc: "\u{CC67}",
        nfkd: "\u{110E}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CC68}",
        nfc: "\u{CC68}",
        nfd: "\u{110E}\u{1163}\u{11AF}",
        nfkc: "\u{CC68}",
        nfkd: "\u{110E}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CC69}",
        nfc: "\u{CC69}",
        nfd: "\u{110E}\u{1163}\u{11B0}",
        nfkc: "\u{CC69}",
        nfkd: "\u{110E}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CC6A}",
        nfc: "\u{CC6A}",
        nfd: "\u{110E}\u{1163}\u{11B1}",
        nfkc: "\u{CC6A}",
        nfkd: "\u{110E}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CC6B}",
        nfc: "\u{CC6B}",
        nfd: "\u{110E}\u{1163}\u{11B2}",
        nfkc: "\u{CC6B}",
        nfkd: "\u{110E}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CC6C}",
        nfc: "\u{CC6C}",
        nfd: "\u{110E}\u{1163}\u{11B3}",
        nfkc: "\u{CC6C}",
        nfkd: "\u{110E}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CC6D}",
        nfc: "\u{CC6D}",
        nfd: "\u{110E}\u{1163}\u{11B4}",
        nfkc: "\u{CC6D}",
        nfkd: "\u{110E}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CC6E}",
        nfc: "\u{CC6E}",
        nfd: "\u{110E}\u{1163}\u{11B5}",
        nfkc: "\u{CC6E}",
        nfkd: "\u{110E}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CC6F}",
        nfc: "\u{CC6F}",
        nfd: "\u{110E}\u{1163}\u{11B6}",
        nfkc: "\u{CC6F}",
        nfkd: "\u{110E}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CC70}",
        nfc: "\u{CC70}",
        nfd: "\u{110E}\u{1163}\u{11B7}",
        nfkc: "\u{CC70}",
        nfkd: "\u{110E}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CC71}",
        nfc: "\u{CC71}",
        nfd: "\u{110E}\u{1163}\u{11B8}",
        nfkc: "\u{CC71}",
        nfkd: "\u{110E}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CC72}",
        nfc: "\u{CC72}",
        nfd: "\u{110E}\u{1163}\u{11B9}",
        nfkc: "\u{CC72}",
        nfkd: "\u{110E}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CC73}",
        nfc: "\u{CC73}",
        nfd: "\u{110E}\u{1163}\u{11BA}",
        nfkc: "\u{CC73}",
        nfkd: "\u{110E}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CC74}",
        nfc: "\u{CC74}",
        nfd: "\u{110E}\u{1163}\u{11BB}",
        nfkc: "\u{CC74}",
        nfkd: "\u{110E}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CC75}",
        nfc: "\u{CC75}",
        nfd: "\u{110E}\u{1163}\u{11BC}",
        nfkc: "\u{CC75}",
        nfkd: "\u{110E}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CC76}",
        nfc: "\u{CC76}",
        nfd: "\u{110E}\u{1163}\u{11BD}",
        nfkc: "\u{CC76}",
        nfkd: "\u{110E}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CC77}",
        nfc: "\u{CC77}",
        nfd: "\u{110E}\u{1163}\u{11BE}",
        nfkc: "\u{CC77}",
        nfkd: "\u{110E}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CC78}",
        nfc: "\u{CC78}",
        nfd: "\u{110E}\u{1163}\u{11BF}",
        nfkc: "\u{CC78}",
        nfkd: "\u{110E}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CC79}",
        nfc: "\u{CC79}",
        nfd: "\u{110E}\u{1163}\u{11C0}",
        nfkc: "\u{CC79}",
        nfkd: "\u{110E}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CC7A}",
        nfc: "\u{CC7A}",
        nfd: "\u{110E}\u{1163}\u{11C1}",
        nfkc: "\u{CC7A}",
        nfkd: "\u{110E}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CC7B}",
        nfc: "\u{CC7B}",
        nfd: "\u{110E}\u{1163}\u{11C2}",
        nfkc: "\u{CC7B}",
        nfkd: "\u{110E}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CC7C}",
        nfc: "\u{CC7C}",
        nfd: "\u{110E}\u{1164}",
        nfkc: "\u{CC7C}",
        nfkd: "\u{110E}\u{1164}",
    },
    NormalizationTest {
        source: "\u{CC7D}",
        nfc: "\u{CC7D}",
        nfd: "\u{110E}\u{1164}\u{11A8}",
        nfkc: "\u{CC7D}",
        nfkd: "\u{110E}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CC7E}",
        nfc: "\u{CC7E}",
        nfd: "\u{110E}\u{1164}\u{11A9}",
        nfkc: "\u{CC7E}",
        nfkd: "\u{110E}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CC7F}",
        nfc: "\u{CC7F}",
        nfd: "\u{110E}\u{1164}\u{11AA}",
        nfkc: "\u{CC7F}",
        nfkd: "\u{110E}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CC80}",
        nfc: "\u{CC80}",
        nfd: "\u{110E}\u{1164}\u{11AB}",
        nfkc: "\u{CC80}",
        nfkd: "\u{110E}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CC81}",
        nfc: "\u{CC81}",
        nfd: "\u{110E}\u{1164}\u{11AC}",
        nfkc: "\u{CC81}",
        nfkd: "\u{110E}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CC82}",
        nfc: "\u{CC82}",
        nfd: "\u{110E}\u{1164}\u{11AD}",
        nfkc: "\u{CC82}",
        nfkd: "\u{110E}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CC83}",
        nfc: "\u{CC83}",
        nfd: "\u{110E}\u{1164}\u{11AE}",
        nfkc: "\u{CC83}",
        nfkd: "\u{110E}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CC84}",
        nfc: "\u{CC84}",
        nfd: "\u{110E}\u{1164}\u{11AF}",
        nfkc: "\u{CC84}",
        nfkd: "\u{110E}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CC85}",
        nfc: "\u{CC85}",
        nfd: "\u{110E}\u{1164}\u{11B0}",
        nfkc: "\u{CC85}",
        nfkd: "\u{110E}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CC86}",
        nfc: "\u{CC86}",
        nfd: "\u{110E}\u{1164}\u{11B1}",
        nfkc: "\u{CC86}",
        nfkd: "\u{110E}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CC87}",
        nfc: "\u{CC87}",
        nfd: "\u{110E}\u{1164}\u{11B2}",
        nfkc: "\u{CC87}",
        nfkd: "\u{110E}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CC88}",
        nfc: "\u{CC88}",
        nfd: "\u{110E}\u{1164}\u{11B3}",
        nfkc: "\u{CC88}",
        nfkd: "\u{110E}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CC89}",
        nfc: "\u{CC89}",
        nfd: "\u{110E}\u{1164}\u{11B4}",
        nfkc: "\u{CC89}",
        nfkd: "\u{110E}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CC8A}",
        nfc: "\u{CC8A}",
        nfd: "\u{110E}\u{1164}\u{11B5}",
        nfkc: "\u{CC8A}",
        nfkd: "\u{110E}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CC8B}",
        nfc: "\u{CC8B}",
        nfd: "\u{110E}\u{1164}\u{11B6}",
        nfkc: "\u{CC8B}",
        nfkd: "\u{110E}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CC8C}",
        nfc: "\u{CC8C}",
        nfd: "\u{110E}\u{1164}\u{11B7}",
        nfkc: "\u{CC8C}",
        nfkd: "\u{110E}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CC8D}",
        nfc: "\u{CC8D}",
        nfd: "\u{110E}\u{1164}\u{11B8}",
        nfkc: "\u{CC8D}",
        nfkd: "\u{110E}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CC8E}",
        nfc: "\u{CC8E}",
        nfd: "\u{110E}\u{1164}\u{11B9}",
        nfkc: "\u{CC8E}",
        nfkd: "\u{110E}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CC8F}",
        nfc: "\u{CC8F}",
        nfd: "\u{110E}\u{1164}\u{11BA}",
        nfkc: "\u{CC8F}",
        nfkd: "\u{110E}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CC90}",
        nfc: "\u{CC90}",
        nfd: "\u{110E}\u{1164}\u{11BB}",
        nfkc: "\u{CC90}",
        nfkd: "\u{110E}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CC91}",
        nfc: "\u{CC91}",
        nfd: "\u{110E}\u{1164}\u{11BC}",
        nfkc: "\u{CC91}",
        nfkd: "\u{110E}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CC92}",
        nfc: "\u{CC92}",
        nfd: "\u{110E}\u{1164}\u{11BD}",
        nfkc: "\u{CC92}",
        nfkd: "\u{110E}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CC93}",
        nfc: "\u{CC93}",
        nfd: "\u{110E}\u{1164}\u{11BE}",
        nfkc: "\u{CC93}",
        nfkd: "\u{110E}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CC94}",
        nfc: "\u{CC94}",
        nfd: "\u{110E}\u{1164}\u{11BF}",
        nfkc: "\u{CC94}",
        nfkd: "\u{110E}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CC95}",
        nfc: "\u{CC95}",
        nfd: "\u{110E}\u{1164}\u{11C0}",
        nfkc: "\u{CC95}",
        nfkd: "\u{110E}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CC96}",
        nfc: "\u{CC96}",
        nfd: "\u{110E}\u{1164}\u{11C1}",
        nfkc: "\u{CC96}",
        nfkd: "\u{110E}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CC97}",
        nfc: "\u{CC97}",
        nfd: "\u{110E}\u{1164}\u{11C2}",
        nfkc: "\u{CC97}",
        nfkd: "\u{110E}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CC98}",
        nfc: "\u{CC98}",
        nfd: "\u{110E}\u{1165}",
        nfkc: "\u{CC98}",
        nfkd: "\u{110E}\u{1165}",
    },
    NormalizationTest {
        source: "\u{CC99}",
        nfc: "\u{CC99}",
        nfd: "\u{110E}\u{1165}\u{11A8}",
        nfkc: "\u{CC99}",
        nfkd: "\u{110E}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CC9A}",
        nfc: "\u{CC9A}",
        nfd: "\u{110E}\u{1165}\u{11A9}",
        nfkc: "\u{CC9A}",
        nfkd: "\u{110E}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CC9B}",
        nfc: "\u{CC9B}",
        nfd: "\u{110E}\u{1165}\u{11AA}",
        nfkc: "\u{CC9B}",
        nfkd: "\u{110E}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CC9C}",
        nfc: "\u{CC9C}",
        nfd: "\u{110E}\u{1165}\u{11AB}",
        nfkc: "\u{CC9C}",
        nfkd: "\u{110E}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CC9D}",
        nfc: "\u{CC9D}",
        nfd: "\u{110E}\u{1165}\u{11AC}",
        nfkc: "\u{CC9D}",
        nfkd: "\u{110E}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CC9E}",
        nfc: "\u{CC9E}",
        nfd: "\u{110E}\u{1165}\u{11AD}",
        nfkc: "\u{CC9E}",
        nfkd: "\u{110E}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CC9F}",
        nfc: "\u{CC9F}",
        nfd: "\u{110E}\u{1165}\u{11AE}",
        nfkc: "\u{CC9F}",
        nfkd: "\u{110E}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CCA0}",
        nfc: "\u{CCA0}",
        nfd: "\u{110E}\u{1165}\u{11AF}",
        nfkc: "\u{CCA0}",
        nfkd: "\u{110E}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CCA1}",
        nfc: "\u{CCA1}",
        nfd: "\u{110E}\u{1165}\u{11B0}",
        nfkc: "\u{CCA1}",
        nfkd: "\u{110E}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CCA2}",
        nfc: "\u{CCA2}",
        nfd: "\u{110E}\u{1165}\u{11B1}",
        nfkc: "\u{CCA2}",
        nfkd: "\u{110E}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CCA3}",
        nfc: "\u{CCA3}",
        nfd: "\u{110E}\u{1165}\u{11B2}",
        nfkc: "\u{CCA3}",
        nfkd: "\u{110E}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CCA4}",
        nfc: "\u{CCA4}",
        nfd: "\u{110E}\u{1165}\u{11B3}",
        nfkc: "\u{CCA4}",
        nfkd: "\u{110E}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CCA5}",
        nfc: "\u{CCA5}",
        nfd: "\u{110E}\u{1165}\u{11B4}",
        nfkc: "\u{CCA5}",
        nfkd: "\u{110E}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CCA6}",
        nfc: "\u{CCA6}",
        nfd: "\u{110E}\u{1165}\u{11B5}",
        nfkc: "\u{CCA6}",
        nfkd: "\u{110E}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CCA7}",
        nfc: "\u{CCA7}",
        nfd: "\u{110E}\u{1165}\u{11B6}",
        nfkc: "\u{CCA7}",
        nfkd: "\u{110E}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CCA8}",
        nfc: "\u{CCA8}",
        nfd: "\u{110E}\u{1165}\u{11B7}",
        nfkc: "\u{CCA8}",
        nfkd: "\u{110E}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CCA9}",
        nfc: "\u{CCA9}",
        nfd: "\u{110E}\u{1165}\u{11B8}",
        nfkc: "\u{CCA9}",
        nfkd: "\u{110E}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CCAA}",
        nfc: "\u{CCAA}",
        nfd: "\u{110E}\u{1165}\u{11B9}",
        nfkc: "\u{CCAA}",
        nfkd: "\u{110E}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CCAB}",
        nfc: "\u{CCAB}",
        nfd: "\u{110E}\u{1165}\u{11BA}",
        nfkc: "\u{CCAB}",
        nfkd: "\u{110E}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CCAC}",
        nfc: "\u{CCAC}",
        nfd: "\u{110E}\u{1165}\u{11BB}",
        nfkc: "\u{CCAC}",
        nfkd: "\u{110E}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CCAD}",
        nfc: "\u{CCAD}",
        nfd: "\u{110E}\u{1165}\u{11BC}",
        nfkc: "\u{CCAD}",
        nfkd: "\u{110E}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CCAE}",
        nfc: "\u{CCAE}",
        nfd: "\u{110E}\u{1165}\u{11BD}",
        nfkc: "\u{CCAE}",
        nfkd: "\u{110E}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CCAF}",
        nfc: "\u{CCAF}",
        nfd: "\u{110E}\u{1165}\u{11BE}",
        nfkc: "\u{CCAF}",
        nfkd: "\u{110E}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CCB0}",
        nfc: "\u{CCB0}",
        nfd: "\u{110E}\u{1165}\u{11BF}",
        nfkc: "\u{CCB0}",
        nfkd: "\u{110E}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CCB1}",
        nfc: "\u{CCB1}",
        nfd: "\u{110E}\u{1165}\u{11C0}",
        nfkc: "\u{CCB1}",
        nfkd: "\u{110E}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CCB2}",
        nfc: "\u{CCB2}",
        nfd: "\u{110E}\u{1165}\u{11C1}",
        nfkc: "\u{CCB2}",
        nfkd: "\u{110E}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CCB3}",
        nfc: "\u{CCB3}",
        nfd: "\u{110E}\u{1165}\u{11C2}",
        nfkc: "\u{CCB3}",
        nfkd: "\u{110E}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CCB4}",
        nfc: "\u{CCB4}",
        nfd: "\u{110E}\u{1166}",
        nfkc: "\u{CCB4}",
        nfkd: "\u{110E}\u{1166}",
    },
    NormalizationTest {
        source: "\u{CCB5}",
        nfc: "\u{CCB5}",
        nfd: "\u{110E}\u{1166}\u{11A8}",
        nfkc: "\u{CCB5}",
        nfkd: "\u{110E}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CCB6}",
        nfc: "\u{CCB6}",
        nfd: "\u{110E}\u{1166}\u{11A9}",
        nfkc: "\u{CCB6}",
        nfkd: "\u{110E}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CCB7}",
        nfc: "\u{CCB7}",
        nfd: "\u{110E}\u{1166}\u{11AA}",
        nfkc: "\u{CCB7}",
        nfkd: "\u{110E}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CCB8}",
        nfc: "\u{CCB8}",
        nfd: "\u{110E}\u{1166}\u{11AB}",
        nfkc: "\u{CCB8}",
        nfkd: "\u{110E}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CCB9}",
        nfc: "\u{CCB9}",
        nfd: "\u{110E}\u{1166}\u{11AC}",
        nfkc: "\u{CCB9}",
        nfkd: "\u{110E}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CCBA}",
        nfc: "\u{CCBA}",
        nfd: "\u{110E}\u{1166}\u{11AD}",
        nfkc: "\u{CCBA}",
        nfkd: "\u{110E}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CCBB}",
        nfc: "\u{CCBB}",
        nfd: "\u{110E}\u{1166}\u{11AE}",
        nfkc: "\u{CCBB}",
        nfkd: "\u{110E}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CCBC}",
        nfc: "\u{CCBC}",
        nfd: "\u{110E}\u{1166}\u{11AF}",
        nfkc: "\u{CCBC}",
        nfkd: "\u{110E}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CCBD}",
        nfc: "\u{CCBD}",
        nfd: "\u{110E}\u{1166}\u{11B0}",
        nfkc: "\u{CCBD}",
        nfkd: "\u{110E}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CCBE}",
        nfc: "\u{CCBE}",
        nfd: "\u{110E}\u{1166}\u{11B1}",
        nfkc: "\u{CCBE}",
        nfkd: "\u{110E}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CCBF}",
        nfc: "\u{CCBF}",
        nfd: "\u{110E}\u{1166}\u{11B2}",
        nfkc: "\u{CCBF}",
        nfkd: "\u{110E}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CCC0}",
        nfc: "\u{CCC0}",
        nfd: "\u{110E}\u{1166}\u{11B3}",
        nfkc: "\u{CCC0}",
        nfkd: "\u{110E}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CCC1}",
        nfc: "\u{CCC1}",
        nfd: "\u{110E}\u{1166}\u{11B4}",
        nfkc: "\u{CCC1}",
        nfkd: "\u{110E}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CCC2}",
        nfc: "\u{CCC2}",
        nfd: "\u{110E}\u{1166}\u{11B5}",
        nfkc: "\u{CCC2}",
        nfkd: "\u{110E}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CCC3}",
        nfc: "\u{CCC3}",
        nfd: "\u{110E}\u{1166}\u{11B6}",
        nfkc: "\u{CCC3}",
        nfkd: "\u{110E}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CCC4}",
        nfc: "\u{CCC4}",
        nfd: "\u{110E}\u{1166}\u{11B7}",
        nfkc: "\u{CCC4}",
        nfkd: "\u{110E}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CCC5}",
        nfc: "\u{CCC5}",
        nfd: "\u{110E}\u{1166}\u{11B8}",
        nfkc: "\u{CCC5}",
        nfkd: "\u{110E}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CCC6}",
        nfc: "\u{CCC6}",
        nfd: "\u{110E}\u{1166}\u{11B9}",
        nfkc: "\u{CCC6}",
        nfkd: "\u{110E}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CCC7}",
        nfc: "\u{CCC7}",
        nfd: "\u{110E}\u{1166}\u{11BA}",
        nfkc: "\u{CCC7}",
        nfkd: "\u{110E}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CCC8}",
        nfc: "\u{CCC8}",
        nfd: "\u{110E}\u{1166}\u{11BB}",
        nfkc: "\u{CCC8}",
        nfkd: "\u{110E}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CCC9}",
        nfc: "\u{CCC9}",
        nfd: "\u{110E}\u{1166}\u{11BC}",
        nfkc: "\u{CCC9}",
        nfkd: "\u{110E}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CCCA}",
        nfc: "\u{CCCA}",
        nfd: "\u{110E}\u{1166}\u{11BD}",
        nfkc: "\u{CCCA}",
        nfkd: "\u{110E}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CCCB}",
        nfc: "\u{CCCB}",
        nfd: "\u{110E}\u{1166}\u{11BE}",
        nfkc: "\u{CCCB}",
        nfkd: "\u{110E}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CCCC}",
        nfc: "\u{CCCC}",
        nfd: "\u{110E}\u{1166}\u{11BF}",
        nfkc: "\u{CCCC}",
        nfkd: "\u{110E}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CCCD}",
        nfc: "\u{CCCD}",
        nfd: "\u{110E}\u{1166}\u{11C0}",
        nfkc: "\u{CCCD}",
        nfkd: "\u{110E}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CCCE}",
        nfc: "\u{CCCE}",
        nfd: "\u{110E}\u{1166}\u{11C1}",
        nfkc: "\u{CCCE}",
        nfkd: "\u{110E}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CCCF}",
        nfc: "\u{CCCF}",
        nfd: "\u{110E}\u{1166}\u{11C2}",
        nfkc: "\u{CCCF}",
        nfkd: "\u{110E}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CCD0}",
        nfc: "\u{CCD0}",
        nfd: "\u{110E}\u{1167}",
        nfkc: "\u{CCD0}",
        nfkd: "\u{110E}\u{1167}",
    },
    NormalizationTest {
        source: "\u{CCD1}",
        nfc: "\u{CCD1}",
        nfd: "\u{110E}\u{1167}\u{11A8}",
        nfkc: "\u{CCD1}",
        nfkd: "\u{110E}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CCD2}",
        nfc: "\u{CCD2}",
        nfd: "\u{110E}\u{1167}\u{11A9}",
        nfkc: "\u{CCD2}",
        nfkd: "\u{110E}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CCD3}",
        nfc: "\u{CCD3}",
        nfd: "\u{110E}\u{1167}\u{11AA}",
        nfkc: "\u{CCD3}",
        nfkd: "\u{110E}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CCD4}",
        nfc: "\u{CCD4}",
        nfd: "\u{110E}\u{1167}\u{11AB}",
        nfkc: "\u{CCD4}",
        nfkd: "\u{110E}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CCD5}",
        nfc: "\u{CCD5}",
        nfd: "\u{110E}\u{1167}\u{11AC}",
        nfkc: "\u{CCD5}",
        nfkd: "\u{110E}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CCD6}",
        nfc: "\u{CCD6}",
        nfd: "\u{110E}\u{1167}\u{11AD}",
        nfkc: "\u{CCD6}",
        nfkd: "\u{110E}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CCD7}",
        nfc: "\u{CCD7}",
        nfd: "\u{110E}\u{1167}\u{11AE}",
        nfkc: "\u{CCD7}",
        nfkd: "\u{110E}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CCD8}",
        nfc: "\u{CCD8}",
        nfd: "\u{110E}\u{1167}\u{11AF}",
        nfkc: "\u{CCD8}",
        nfkd: "\u{110E}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CCD9}",
        nfc: "\u{CCD9}",
        nfd: "\u{110E}\u{1167}\u{11B0}",
        nfkc: "\u{CCD9}",
        nfkd: "\u{110E}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CCDA}",
        nfc: "\u{CCDA}",
        nfd: "\u{110E}\u{1167}\u{11B1}",
        nfkc: "\u{CCDA}",
        nfkd: "\u{110E}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CCDB}",
        nfc: "\u{CCDB}",
        nfd: "\u{110E}\u{1167}\u{11B2}",
        nfkc: "\u{CCDB}",
        nfkd: "\u{110E}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CCDC}",
        nfc: "\u{CCDC}",
        nfd: "\u{110E}\u{1167}\u{11B3}",
        nfkc: "\u{CCDC}",
        nfkd: "\u{110E}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CCDD}",
        nfc: "\u{CCDD}",
        nfd: "\u{110E}\u{1167}\u{11B4}",
        nfkc: "\u{CCDD}",
        nfkd: "\u{110E}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CCDE}",
        nfc: "\u{CCDE}",
        nfd: "\u{110E}\u{1167}\u{11B5}",
        nfkc: "\u{CCDE}",
        nfkd: "\u{110E}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CCDF}",
        nfc: "\u{CCDF}",
        nfd: "\u{110E}\u{1167}\u{11B6}",
        nfkc: "\u{CCDF}",
        nfkd: "\u{110E}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CCE0}",
        nfc: "\u{CCE0}",
        nfd: "\u{110E}\u{1167}\u{11B7}",
        nfkc: "\u{CCE0}",
        nfkd: "\u{110E}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CCE1}",
        nfc: "\u{CCE1}",
        nfd: "\u{110E}\u{1167}\u{11B8}",
        nfkc: "\u{CCE1}",
        nfkd: "\u{110E}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CCE2}",
        nfc: "\u{CCE2}",
        nfd: "\u{110E}\u{1167}\u{11B9}",
        nfkc: "\u{CCE2}",
        nfkd: "\u{110E}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CCE3}",
        nfc: "\u{CCE3}",
        nfd: "\u{110E}\u{1167}\u{11BA}",
        nfkc: "\u{CCE3}",
        nfkd: "\u{110E}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CCE4}",
        nfc: "\u{CCE4}",
        nfd: "\u{110E}\u{1167}\u{11BB}",
        nfkc: "\u{CCE4}",
        nfkd: "\u{110E}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CCE5}",
        nfc: "\u{CCE5}",
        nfd: "\u{110E}\u{1167}\u{11BC}",
        nfkc: "\u{CCE5}",
        nfkd: "\u{110E}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CCE6}",
        nfc: "\u{CCE6}",
        nfd: "\u{110E}\u{1167}\u{11BD}",
        nfkc: "\u{CCE6}",
        nfkd: "\u{110E}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CCE7}",
        nfc: "\u{CCE7}",
        nfd: "\u{110E}\u{1167}\u{11BE}",
        nfkc: "\u{CCE7}",
        nfkd: "\u{110E}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CCE8}",
        nfc: "\u{CCE8}",
        nfd: "\u{110E}\u{1167}\u{11BF}",
        nfkc: "\u{CCE8}",
        nfkd: "\u{110E}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CCE9}",
        nfc: "\u{CCE9}",
        nfd: "\u{110E}\u{1167}\u{11C0}",
        nfkc: "\u{CCE9}",
        nfkd: "\u{110E}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CCEA}",
        nfc: "\u{CCEA}",
        nfd: "\u{110E}\u{1167}\u{11C1}",
        nfkc: "\u{CCEA}",
        nfkd: "\u{110E}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CCEB}",
        nfc: "\u{CCEB}",
        nfd: "\u{110E}\u{1167}\u{11C2}",
        nfkc: "\u{CCEB}",
        nfkd: "\u{110E}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CCEC}",
        nfc: "\u{CCEC}",
        nfd: "\u{110E}\u{1168}",
        nfkc: "\u{CCEC}",
        nfkd: "\u{110E}\u{1168}",
    },
    NormalizationTest {
        source: "\u{CCED}",
        nfc: "\u{CCED}",
        nfd: "\u{110E}\u{1168}\u{11A8}",
        nfkc: "\u{CCED}",
        nfkd: "\u{110E}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CCEE}",
        nfc: "\u{CCEE}",
        nfd: "\u{110E}\u{1168}\u{11A9}",
        nfkc: "\u{CCEE}",
        nfkd: "\u{110E}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CCEF}",
        nfc: "\u{CCEF}",
        nfd: "\u{110E}\u{1168}\u{11AA}",
        nfkc: "\u{CCEF}",
        nfkd: "\u{110E}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CCF0}",
        nfc: "\u{CCF0}",
        nfd: "\u{110E}\u{1168}\u{11AB}",
        nfkc: "\u{CCF0}",
        nfkd: "\u{110E}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CCF1}",
        nfc: "\u{CCF1}",
        nfd: "\u{110E}\u{1168}\u{11AC}",
        nfkc: "\u{CCF1}",
        nfkd: "\u{110E}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CCF2}",
        nfc: "\u{CCF2}",
        nfd: "\u{110E}\u{1168}\u{11AD}",
        nfkc: "\u{CCF2}",
        nfkd: "\u{110E}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CCF3}",
        nfc: "\u{CCF3}",
        nfd: "\u{110E}\u{1168}\u{11AE}",
        nfkc: "\u{CCF3}",
        nfkd: "\u{110E}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CCF4}",
        nfc: "\u{CCF4}",
        nfd: "\u{110E}\u{1168}\u{11AF}",
        nfkc: "\u{CCF4}",
        nfkd: "\u{110E}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CCF5}",
        nfc: "\u{CCF5}",
        nfd: "\u{110E}\u{1168}\u{11B0}",
        nfkc: "\u{CCF5}",
        nfkd: "\u{110E}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CCF6}",
        nfc: "\u{CCF6}",
        nfd: "\u{110E}\u{1168}\u{11B1}",
        nfkc: "\u{CCF6}",
        nfkd: "\u{110E}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CCF7}",
        nfc: "\u{CCF7}",
        nfd: "\u{110E}\u{1168}\u{11B2}",
        nfkc: "\u{CCF7}",
        nfkd: "\u{110E}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CCF8}",
        nfc: "\u{CCF8}",
        nfd: "\u{110E}\u{1168}\u{11B3}",
        nfkc: "\u{CCF8}",
        nfkd: "\u{110E}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CCF9}",
        nfc: "\u{CCF9}",
        nfd: "\u{110E}\u{1168}\u{11B4}",
        nfkc: "\u{CCF9}",
        nfkd: "\u{110E}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CCFA}",
        nfc: "\u{CCFA}",
        nfd: "\u{110E}\u{1168}\u{11B5}",
        nfkc: "\u{CCFA}",
        nfkd: "\u{110E}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CCFB}",
        nfc: "\u{CCFB}",
        nfd: "\u{110E}\u{1168}\u{11B6}",
        nfkc: "\u{CCFB}",
        nfkd: "\u{110E}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CCFC}",
        nfc: "\u{CCFC}",
        nfd: "\u{110E}\u{1168}\u{11B7}",
        nfkc: "\u{CCFC}",
        nfkd: "\u{110E}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CCFD}",
        nfc: "\u{CCFD}",
        nfd: "\u{110E}\u{1168}\u{11B8}",
        nfkc: "\u{CCFD}",
        nfkd: "\u{110E}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CCFE}",
        nfc: "\u{CCFE}",
        nfd: "\u{110E}\u{1168}\u{11B9}",
        nfkc: "\u{CCFE}",
        nfkd: "\u{110E}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CCFF}",
        nfc: "\u{CCFF}",
        nfd: "\u{110E}\u{1168}\u{11BA}",
        nfkc: "\u{CCFF}",
        nfkd: "\u{110E}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CD00}",
        nfc: "\u{CD00}",
        nfd: "\u{110E}\u{1168}\u{11BB}",
        nfkc: "\u{CD00}",
        nfkd: "\u{110E}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CD01}",
        nfc: "\u{CD01}",
        nfd: "\u{110E}\u{1168}\u{11BC}",
        nfkc: "\u{CD01}",
        nfkd: "\u{110E}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CD02}",
        nfc: "\u{CD02}",
        nfd: "\u{110E}\u{1168}\u{11BD}",
        nfkc: "\u{CD02}",
        nfkd: "\u{110E}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CD03}",
        nfc: "\u{CD03}",
        nfd: "\u{110E}\u{1168}\u{11BE}",
        nfkc: "\u{CD03}",
        nfkd: "\u{110E}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CD04}",
        nfc: "\u{CD04}",
        nfd: "\u{110E}\u{1168}\u{11BF}",
        nfkc: "\u{CD04}",
        nfkd: "\u{110E}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CD05}",
        nfc: "\u{CD05}",
        nfd: "\u{110E}\u{1168}\u{11C0}",
        nfkc: "\u{CD05}",
        nfkd: "\u{110E}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CD06}",
        nfc: "\u{CD06}",
        nfd: "\u{110E}\u{1168}\u{11C1}",
        nfkc: "\u{CD06}",
        nfkd: "\u{110E}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CD07}",
        nfc: "\u{CD07}",
        nfd: "\u{110E}\u{1168}\u{11C2}",
        nfkc: "\u{CD07}",
        nfkd: "\u{110E}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CD08}",
        nfc: "\u{CD08}",
        nfd: "\u{110E}\u{1169}",
        nfkc: "\u{CD08}",
        nfkd: "\u{110E}\u{1169}",
    },
    NormalizationTest {
        source: "\u{CD09}",
        nfc: "\u{CD09}",
        nfd: "\u{110E}\u{1169}\u{11A8}",
        nfkc: "\u{CD09}",
        nfkd: "\u{110E}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CD0A}",
        nfc: "\u{CD0A}",
        nfd: "\u{110E}\u{1169}\u{11A9}",
        nfkc: "\u{CD0A}",
        nfkd: "\u{110E}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CD0B}",
        nfc: "\u{CD0B}",
        nfd: "\u{110E}\u{1169}\u{11AA}",
        nfkc: "\u{CD0B}",
        nfkd: "\u{110E}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CD0C}",
        nfc: "\u{CD0C}",
        nfd: "\u{110E}\u{1169}\u{11AB}",
        nfkc: "\u{CD0C}",
        nfkd: "\u{110E}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CD0D}",
        nfc: "\u{CD0D}",
        nfd: "\u{110E}\u{1169}\u{11AC}",
        nfkc: "\u{CD0D}",
        nfkd: "\u{110E}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CD0E}",
        nfc: "\u{CD0E}",
        nfd: "\u{110E}\u{1169}\u{11AD}",
        nfkc: "\u{CD0E}",
        nfkd: "\u{110E}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CD0F}",
        nfc: "\u{CD0F}",
        nfd: "\u{110E}\u{1169}\u{11AE}",
        nfkc: "\u{CD0F}",
        nfkd: "\u{110E}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CD10}",
        nfc: "\u{CD10}",
        nfd: "\u{110E}\u{1169}\u{11AF}",
        nfkc: "\u{CD10}",
        nfkd: "\u{110E}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CD11}",
        nfc: "\u{CD11}",
        nfd: "\u{110E}\u{1169}\u{11B0}",
        nfkc: "\u{CD11}",
        nfkd: "\u{110E}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CD12}",
        nfc: "\u{CD12}",
        nfd: "\u{110E}\u{1169}\u{11B1}",
        nfkc: "\u{CD12}",
        nfkd: "\u{110E}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CD13}",
        nfc: "\u{CD13}",
        nfd: "\u{110E}\u{1169}\u{11B2}",
        nfkc: "\u{CD13}",
        nfkd: "\u{110E}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CD14}",
        nfc: "\u{CD14}",
        nfd: "\u{110E}\u{1169}\u{11B3}",
        nfkc: "\u{CD14}",
        nfkd: "\u{110E}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CD15}",
        nfc: "\u{CD15}",
        nfd: "\u{110E}\u{1169}\u{11B4}",
        nfkc: "\u{CD15}",
        nfkd: "\u{110E}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CD16}",
        nfc: "\u{CD16}",
        nfd: "\u{110E}\u{1169}\u{11B5}",
        nfkc: "\u{CD16}",
        nfkd: "\u{110E}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CD17}",
        nfc: "\u{CD17}",
        nfd: "\u{110E}\u{1169}\u{11B6}",
        nfkc: "\u{CD17}",
        nfkd: "\u{110E}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CD18}",
        nfc: "\u{CD18}",
        nfd: "\u{110E}\u{1169}\u{11B7}",
        nfkc: "\u{CD18}",
        nfkd: "\u{110E}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CD19}",
        nfc: "\u{CD19}",
        nfd: "\u{110E}\u{1169}\u{11B8}",
        nfkc: "\u{CD19}",
        nfkd: "\u{110E}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CD1A}",
        nfc: "\u{CD1A}",
        nfd: "\u{110E}\u{1169}\u{11B9}",
        nfkc: "\u{CD1A}",
        nfkd: "\u{110E}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CD1B}",
        nfc: "\u{CD1B}",
        nfd: "\u{110E}\u{1169}\u{11BA}",
        nfkc: "\u{CD1B}",
        nfkd: "\u{110E}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CD1C}",
        nfc: "\u{CD1C}",
        nfd: "\u{110E}\u{1169}\u{11BB}",
        nfkc: "\u{CD1C}",
        nfkd: "\u{110E}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CD1D}",
        nfc: "\u{CD1D}",
        nfd: "\u{110E}\u{1169}\u{11BC}",
        nfkc: "\u{CD1D}",
        nfkd: "\u{110E}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CD1E}",
        nfc: "\u{CD1E}",
        nfd: "\u{110E}\u{1169}\u{11BD}",
        nfkc: "\u{CD1E}",
        nfkd: "\u{110E}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CD1F}",
        nfc: "\u{CD1F}",
        nfd: "\u{110E}\u{1169}\u{11BE}",
        nfkc: "\u{CD1F}",
        nfkd: "\u{110E}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CD20}",
        nfc: "\u{CD20}",
        nfd: "\u{110E}\u{1169}\u{11BF}",
        nfkc: "\u{CD20}",
        nfkd: "\u{110E}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CD21}",
        nfc: "\u{CD21}",
        nfd: "\u{110E}\u{1169}\u{11C0}",
        nfkc: "\u{CD21}",
        nfkd: "\u{110E}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CD22}",
        nfc: "\u{CD22}",
        nfd: "\u{110E}\u{1169}\u{11C1}",
        nfkc: "\u{CD22}",
        nfkd: "\u{110E}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CD23}",
        nfc: "\u{CD23}",
        nfd: "\u{110E}\u{1169}\u{11C2}",
        nfkc: "\u{CD23}",
        nfkd: "\u{110E}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CD24}",
        nfc: "\u{CD24}",
        nfd: "\u{110E}\u{116A}",
        nfkc: "\u{CD24}",
        nfkd: "\u{110E}\u{116A}",
    },
    NormalizationTest {
        source: "\u{CD25}",
        nfc: "\u{CD25}",
        nfd: "\u{110E}\u{116A}\u{11A8}",
        nfkc: "\u{CD25}",
        nfkd: "\u{110E}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CD26}",
        nfc: "\u{CD26}",
        nfd: "\u{110E}\u{116A}\u{11A9}",
        nfkc: "\u{CD26}",
        nfkd: "\u{110E}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CD27}",
        nfc: "\u{CD27}",
        nfd: "\u{110E}\u{116A}\u{11AA}",
        nfkc: "\u{CD27}",
        nfkd: "\u{110E}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CD28}",
        nfc: "\u{CD28}",
        nfd: "\u{110E}\u{116A}\u{11AB}",
        nfkc: "\u{CD28}",
        nfkd: "\u{110E}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CD29}",
        nfc: "\u{CD29}",
        nfd: "\u{110E}\u{116A}\u{11AC}",
        nfkc: "\u{CD29}",
        nfkd: "\u{110E}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CD2A}",
        nfc: "\u{CD2A}",
        nfd: "\u{110E}\u{116A}\u{11AD}",
        nfkc: "\u{CD2A}",
        nfkd: "\u{110E}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CD2B}",
        nfc: "\u{CD2B}",
        nfd: "\u{110E}\u{116A}\u{11AE}",
        nfkc: "\u{CD2B}",
        nfkd: "\u{110E}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CD2C}",
        nfc: "\u{CD2C}",
        nfd: "\u{110E}\u{116A}\u{11AF}",
        nfkc: "\u{CD2C}",
        nfkd: "\u{110E}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CD2D}",
        nfc: "\u{CD2D}",
        nfd: "\u{110E}\u{116A}\u{11B0}",
        nfkc: "\u{CD2D}",
        nfkd: "\u{110E}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CD2E}",
        nfc: "\u{CD2E}",
        nfd: "\u{110E}\u{116A}\u{11B1}",
        nfkc: "\u{CD2E}",
        nfkd: "\u{110E}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CD2F}",
        nfc: "\u{CD2F}",
        nfd: "\u{110E}\u{116A}\u{11B2}",
        nfkc: "\u{CD2F}",
        nfkd: "\u{110E}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CD30}",
        nfc: "\u{CD30}",
        nfd: "\u{110E}\u{116A}\u{11B3}",
        nfkc: "\u{CD30}",
        nfkd: "\u{110E}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CD31}",
        nfc: "\u{CD31}",
        nfd: "\u{110E}\u{116A}\u{11B4}",
        nfkc: "\u{CD31}",
        nfkd: "\u{110E}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CD32}",
        nfc: "\u{CD32}",
        nfd: "\u{110E}\u{116A}\u{11B5}",
        nfkc: "\u{CD32}",
        nfkd: "\u{110E}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CD33}",
        nfc: "\u{CD33}",
        nfd: "\u{110E}\u{116A}\u{11B6}",
        nfkc: "\u{CD33}",
        nfkd: "\u{110E}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CD34}",
        nfc: "\u{CD34}",
        nfd: "\u{110E}\u{116A}\u{11B7}",
        nfkc: "\u{CD34}",
        nfkd: "\u{110E}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CD35}",
        nfc: "\u{CD35}",
        nfd: "\u{110E}\u{116A}\u{11B8}",
        nfkc: "\u{CD35}",
        nfkd: "\u{110E}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CD36}",
        nfc: "\u{CD36}",
        nfd: "\u{110E}\u{116A}\u{11B9}",
        nfkc: "\u{CD36}",
        nfkd: "\u{110E}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CD37}",
        nfc: "\u{CD37}",
        nfd: "\u{110E}\u{116A}\u{11BA}",
        nfkc: "\u{CD37}",
        nfkd: "\u{110E}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CD38}",
        nfc: "\u{CD38}",
        nfd: "\u{110E}\u{116A}\u{11BB}",
        nfkc: "\u{CD38}",
        nfkd: "\u{110E}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CD39}",
        nfc: "\u{CD39}",
        nfd: "\u{110E}\u{116A}\u{11BC}",
        nfkc: "\u{CD39}",
        nfkd: "\u{110E}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CD3A}",
        nfc: "\u{CD3A}",
        nfd: "\u{110E}\u{116A}\u{11BD}",
        nfkc: "\u{CD3A}",
        nfkd: "\u{110E}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CD3B}",
        nfc: "\u{CD3B}",
        nfd: "\u{110E}\u{116A}\u{11BE}",
        nfkc: "\u{CD3B}",
        nfkd: "\u{110E}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CD3C}",
        nfc: "\u{CD3C}",
        nfd: "\u{110E}\u{116A}\u{11BF}",
        nfkc: "\u{CD3C}",
        nfkd: "\u{110E}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CD3D}",
        nfc: "\u{CD3D}",
        nfd: "\u{110E}\u{116A}\u{11C0}",
        nfkc: "\u{CD3D}",
        nfkd: "\u{110E}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CD3E}",
        nfc: "\u{CD3E}",
        nfd: "\u{110E}\u{116A}\u{11C1}",
        nfkc: "\u{CD3E}",
        nfkd: "\u{110E}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CD3F}",
        nfc: "\u{CD3F}",
        nfd: "\u{110E}\u{116A}\u{11C2}",
        nfkc: "\u{CD3F}",
        nfkd: "\u{110E}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CD40}",
        nfc: "\u{CD40}",
        nfd: "\u{110E}\u{116B}",
        nfkc: "\u{CD40}",
        nfkd: "\u{110E}\u{116B}",
    },
    NormalizationTest {
        source: "\u{CD41}",
        nfc: "\u{CD41}",
        nfd: "\u{110E}\u{116B}\u{11A8}",
        nfkc: "\u{CD41}",
        nfkd: "\u{110E}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CD42}",
        nfc: "\u{CD42}",
        nfd: "\u{110E}\u{116B}\u{11A9}",
        nfkc: "\u{CD42}",
        nfkd: "\u{110E}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CD43}",
        nfc: "\u{CD43}",
        nfd: "\u{110E}\u{116B}\u{11AA}",
        nfkc: "\u{CD43}",
        nfkd: "\u{110E}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CD44}",
        nfc: "\u{CD44}",
        nfd: "\u{110E}\u{116B}\u{11AB}",
        nfkc: "\u{CD44}",
        nfkd: "\u{110E}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CD45}",
        nfc: "\u{CD45}",
        nfd: "\u{110E}\u{116B}\u{11AC}",
        nfkc: "\u{CD45}",
        nfkd: "\u{110E}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CD46}",
        nfc: "\u{CD46}",
        nfd: "\u{110E}\u{116B}\u{11AD}",
        nfkc: "\u{CD46}",
        nfkd: "\u{110E}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CD47}",
        nfc: "\u{CD47}",
        nfd: "\u{110E}\u{116B}\u{11AE}",
        nfkc: "\u{CD47}",
        nfkd: "\u{110E}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CD48}",
        nfc: "\u{CD48}",
        nfd: "\u{110E}\u{116B}\u{11AF}",
        nfkc: "\u{CD48}",
        nfkd: "\u{110E}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CD49}",
        nfc: "\u{CD49}",
        nfd: "\u{110E}\u{116B}\u{11B0}",
        nfkc: "\u{CD49}",
        nfkd: "\u{110E}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CD4A}",
        nfc: "\u{CD4A}",
        nfd: "\u{110E}\u{116B}\u{11B1}",
        nfkc: "\u{CD4A}",
        nfkd: "\u{110E}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CD4B}",
        nfc: "\u{CD4B}",
        nfd: "\u{110E}\u{116B}\u{11B2}",
        nfkc: "\u{CD4B}",
        nfkd: "\u{110E}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CD4C}",
        nfc: "\u{CD4C}",
        nfd: "\u{110E}\u{116B}\u{11B3}",
        nfkc: "\u{CD4C}",
        nfkd: "\u{110E}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CD4D}",
        nfc: "\u{CD4D}",
        nfd: "\u{110E}\u{116B}\u{11B4}",
        nfkc: "\u{CD4D}",
        nfkd: "\u{110E}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CD4E}",
        nfc: "\u{CD4E}",
        nfd: "\u{110E}\u{116B}\u{11B5}",
        nfkc: "\u{CD4E}",
        nfkd: "\u{110E}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CD4F}",
        nfc: "\u{CD4F}",
        nfd: "\u{110E}\u{116B}\u{11B6}",
        nfkc: "\u{CD4F}",
        nfkd: "\u{110E}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CD50}",
        nfc: "\u{CD50}",
        nfd: "\u{110E}\u{116B}\u{11B7}",
        nfkc: "\u{CD50}",
        nfkd: "\u{110E}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CD51}",
        nfc: "\u{CD51}",
        nfd: "\u{110E}\u{116B}\u{11B8}",
        nfkc: "\u{CD51}",
        nfkd: "\u{110E}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CD52}",
        nfc: "\u{CD52}",
        nfd: "\u{110E}\u{116B}\u{11B9}",
        nfkc: "\u{CD52}",
        nfkd: "\u{110E}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CD53}",
        nfc: "\u{CD53}",
        nfd: "\u{110E}\u{116B}\u{11BA}",
        nfkc: "\u{CD53}",
        nfkd: "\u{110E}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CD54}",
        nfc: "\u{CD54}",
        nfd: "\u{110E}\u{116B}\u{11BB}",
        nfkc: "\u{CD54}",
        nfkd: "\u{110E}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CD55}",
        nfc: "\u{CD55}",
        nfd: "\u{110E}\u{116B}\u{11BC}",
        nfkc: "\u{CD55}",
        nfkd: "\u{110E}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CD56}",
        nfc: "\u{CD56}",
        nfd: "\u{110E}\u{116B}\u{11BD}",
        nfkc: "\u{CD56}",
        nfkd: "\u{110E}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CD57}",
        nfc: "\u{CD57}",
        nfd: "\u{110E}\u{116B}\u{11BE}",
        nfkc: "\u{CD57}",
        nfkd: "\u{110E}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CD58}",
        nfc: "\u{CD58}",
        nfd: "\u{110E}\u{116B}\u{11BF}",
        nfkc: "\u{CD58}",
        nfkd: "\u{110E}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CD59}",
        nfc: "\u{CD59}",
        nfd: "\u{110E}\u{116B}\u{11C0}",
        nfkc: "\u{CD59}",
        nfkd: "\u{110E}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CD5A}",
        nfc: "\u{CD5A}",
        nfd: "\u{110E}\u{116B}\u{11C1}",
        nfkc: "\u{CD5A}",
        nfkd: "\u{110E}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CD5B}",
        nfc: "\u{CD5B}",
        nfd: "\u{110E}\u{116B}\u{11C2}",
        nfkc: "\u{CD5B}",
        nfkd: "\u{110E}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CD5C}",
        nfc: "\u{CD5C}",
        nfd: "\u{110E}\u{116C}",
        nfkc: "\u{CD5C}",
        nfkd: "\u{110E}\u{116C}",
    },
    NormalizationTest {
        source: "\u{CD5D}",
        nfc: "\u{CD5D}",
        nfd: "\u{110E}\u{116C}\u{11A8}",
        nfkc: "\u{CD5D}",
        nfkd: "\u{110E}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CD5E}",
        nfc: "\u{CD5E}",
        nfd: "\u{110E}\u{116C}\u{11A9}",
        nfkc: "\u{CD5E}",
        nfkd: "\u{110E}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CD5F}",
        nfc: "\u{CD5F}",
        nfd: "\u{110E}\u{116C}\u{11AA}",
        nfkc: "\u{CD5F}",
        nfkd: "\u{110E}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CD60}",
        nfc: "\u{CD60}",
        nfd: "\u{110E}\u{116C}\u{11AB}",
        nfkc: "\u{CD60}",
        nfkd: "\u{110E}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CD61}",
        nfc: "\u{CD61}",
        nfd: "\u{110E}\u{116C}\u{11AC}",
        nfkc: "\u{CD61}",
        nfkd: "\u{110E}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CD62}",
        nfc: "\u{CD62}",
        nfd: "\u{110E}\u{116C}\u{11AD}",
        nfkc: "\u{CD62}",
        nfkd: "\u{110E}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CD63}",
        nfc: "\u{CD63}",
        nfd: "\u{110E}\u{116C}\u{11AE}",
        nfkc: "\u{CD63}",
        nfkd: "\u{110E}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CD64}",
        nfc: "\u{CD64}",
        nfd: "\u{110E}\u{116C}\u{11AF}",
        nfkc: "\u{CD64}",
        nfkd: "\u{110E}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CD65}",
        nfc: "\u{CD65}",
        nfd: "\u{110E}\u{116C}\u{11B0}",
        nfkc: "\u{CD65}",
        nfkd: "\u{110E}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CD66}",
        nfc: "\u{CD66}",
        nfd: "\u{110E}\u{116C}\u{11B1}",
        nfkc: "\u{CD66}",
        nfkd: "\u{110E}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CD67}",
        nfc: "\u{CD67}",
        nfd: "\u{110E}\u{116C}\u{11B2}",
        nfkc: "\u{CD67}",
        nfkd: "\u{110E}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CD68}",
        nfc: "\u{CD68}",
        nfd: "\u{110E}\u{116C}\u{11B3}",
        nfkc: "\u{CD68}",
        nfkd: "\u{110E}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CD69}",
        nfc: "\u{CD69}",
        nfd: "\u{110E}\u{116C}\u{11B4}",
        nfkc: "\u{CD69}",
        nfkd: "\u{110E}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CD6A}",
        nfc: "\u{CD6A}",
        nfd: "\u{110E}\u{116C}\u{11B5}",
        nfkc: "\u{CD6A}",
        nfkd: "\u{110E}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CD6B}",
        nfc: "\u{CD6B}",
        nfd: "\u{110E}\u{116C}\u{11B6}",
        nfkc: "\u{CD6B}",
        nfkd: "\u{110E}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CD6C}",
        nfc: "\u{CD6C}",
        nfd: "\u{110E}\u{116C}\u{11B7}",
        nfkc: "\u{CD6C}",
        nfkd: "\u{110E}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CD6D}",
        nfc: "\u{CD6D}",
        nfd: "\u{110E}\u{116C}\u{11B8}",
        nfkc: "\u{CD6D}",
        nfkd: "\u{110E}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CD6E}",
        nfc: "\u{CD6E}",
        nfd: "\u{110E}\u{116C}\u{11B9}",
        nfkc: "\u{CD6E}",
        nfkd: "\u{110E}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CD6F}",
        nfc: "\u{CD6F}",
        nfd: "\u{110E}\u{116C}\u{11BA}",
        nfkc: "\u{CD6F}",
        nfkd: "\u{110E}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CD70}",
        nfc: "\u{CD70}",
        nfd: "\u{110E}\u{116C}\u{11BB}",
        nfkc: "\u{CD70}",
        nfkd: "\u{110E}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CD71}",
        nfc: "\u{CD71}",
        nfd: "\u{110E}\u{116C}\u{11BC}",
        nfkc: "\u{CD71}",
        nfkd: "\u{110E}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CD72}",
        nfc: "\u{CD72}",
        nfd: "\u{110E}\u{116C}\u{11BD}",
        nfkc: "\u{CD72}",
        nfkd: "\u{110E}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CD73}",
        nfc: "\u{CD73}",
        nfd: "\u{110E}\u{116C}\u{11BE}",
        nfkc: "\u{CD73}",
        nfkd: "\u{110E}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CD74}",
        nfc: "\u{CD74}",
        nfd: "\u{110E}\u{116C}\u{11BF}",
        nfkc: "\u{CD74}",
        nfkd: "\u{110E}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CD75}",
        nfc: "\u{CD75}",
        nfd: "\u{110E}\u{116C}\u{11C0}",
        nfkc: "\u{CD75}",
        nfkd: "\u{110E}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CD76}",
        nfc: "\u{CD76}",
        nfd: "\u{110E}\u{116C}\u{11C1}",
        nfkc: "\u{CD76}",
        nfkd: "\u{110E}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CD77}",
        nfc: "\u{CD77}",
        nfd: "\u{110E}\u{116C}\u{11C2}",
        nfkc: "\u{CD77}",
        nfkd: "\u{110E}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CD78}",
        nfc: "\u{CD78}",
        nfd: "\u{110E}\u{116D}",
        nfkc: "\u{CD78}",
        nfkd: "\u{110E}\u{116D}",
    },
    NormalizationTest {
        source: "\u{CD79}",
        nfc: "\u{CD79}",
        nfd: "\u{110E}\u{116D}\u{11A8}",
        nfkc: "\u{CD79}",
        nfkd: "\u{110E}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CD7A}",
        nfc: "\u{CD7A}",
        nfd: "\u{110E}\u{116D}\u{11A9}",
        nfkc: "\u{CD7A}",
        nfkd: "\u{110E}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CD7B}",
        nfc: "\u{CD7B}",
        nfd: "\u{110E}\u{116D}\u{11AA}",
        nfkc: "\u{CD7B}",
        nfkd: "\u{110E}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CD7C}",
        nfc: "\u{CD7C}",
        nfd: "\u{110E}\u{116D}\u{11AB}",
        nfkc: "\u{CD7C}",
        nfkd: "\u{110E}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CD7D}",
        nfc: "\u{CD7D}",
        nfd: "\u{110E}\u{116D}\u{11AC}",
        nfkc: "\u{CD7D}",
        nfkd: "\u{110E}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CD7E}",
        nfc: "\u{CD7E}",
        nfd: "\u{110E}\u{116D}\u{11AD}",
        nfkc: "\u{CD7E}",
        nfkd: "\u{110E}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CD7F}",
        nfc: "\u{CD7F}",
        nfd: "\u{110E}\u{116D}\u{11AE}",
        nfkc: "\u{CD7F}",
        nfkd: "\u{110E}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CD80}",
        nfc: "\u{CD80}",
        nfd: "\u{110E}\u{116D}\u{11AF}",
        nfkc: "\u{CD80}",
        nfkd: "\u{110E}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CD81}",
        nfc: "\u{CD81}",
        nfd: "\u{110E}\u{116D}\u{11B0}",
        nfkc: "\u{CD81}",
        nfkd: "\u{110E}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CD82}",
        nfc: "\u{CD82}",
        nfd: "\u{110E}\u{116D}\u{11B1}",
        nfkc: "\u{CD82}",
        nfkd: "\u{110E}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CD83}",
        nfc: "\u{CD83}",
        nfd: "\u{110E}\u{116D}\u{11B2}",
        nfkc: "\u{CD83}",
        nfkd: "\u{110E}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CD84}",
        nfc: "\u{CD84}",
        nfd: "\u{110E}\u{116D}\u{11B3}",
        nfkc: "\u{CD84}",
        nfkd: "\u{110E}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CD85}",
        nfc: "\u{CD85}",
        nfd: "\u{110E}\u{116D}\u{11B4}",
        nfkc: "\u{CD85}",
        nfkd: "\u{110E}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CD86}",
        nfc: "\u{CD86}",
        nfd: "\u{110E}\u{116D}\u{11B5}",
        nfkc: "\u{CD86}",
        nfkd: "\u{110E}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CD87}",
        nfc: "\u{CD87}",
        nfd: "\u{110E}\u{116D}\u{11B6}",
        nfkc: "\u{CD87}",
        nfkd: "\u{110E}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CD88}",
        nfc: "\u{CD88}",
        nfd: "\u{110E}\u{116D}\u{11B7}",
        nfkc: "\u{CD88}",
        nfkd: "\u{110E}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CD89}",
        nfc: "\u{CD89}",
        nfd: "\u{110E}\u{116D}\u{11B8}",
        nfkc: "\u{CD89}",
        nfkd: "\u{110E}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CD8A}",
        nfc: "\u{CD8A}",
        nfd: "\u{110E}\u{116D}\u{11B9}",
        nfkc: "\u{CD8A}",
        nfkd: "\u{110E}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CD8B}",
        nfc: "\u{CD8B}",
        nfd: "\u{110E}\u{116D}\u{11BA}",
        nfkc: "\u{CD8B}",
        nfkd: "\u{110E}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CD8C}",
        nfc: "\u{CD8C}",
        nfd: "\u{110E}\u{116D}\u{11BB}",
        nfkc: "\u{CD8C}",
        nfkd: "\u{110E}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CD8D}",
        nfc: "\u{CD8D}",
        nfd: "\u{110E}\u{116D}\u{11BC}",
        nfkc: "\u{CD8D}",
        nfkd: "\u{110E}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CD8E}",
        nfc: "\u{CD8E}",
        nfd: "\u{110E}\u{116D}\u{11BD}",
        nfkc: "\u{CD8E}",
        nfkd: "\u{110E}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CD8F}",
        nfc: "\u{CD8F}",
        nfd: "\u{110E}\u{116D}\u{11BE}",
        nfkc: "\u{CD8F}",
        nfkd: "\u{110E}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CD90}",
        nfc: "\u{CD90}",
        nfd: "\u{110E}\u{116D}\u{11BF}",
        nfkc: "\u{CD90}",
        nfkd: "\u{110E}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CD91}",
        nfc: "\u{CD91}",
        nfd: "\u{110E}\u{116D}\u{11C0}",
        nfkc: "\u{CD91}",
        nfkd: "\u{110E}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CD92}",
        nfc: "\u{CD92}",
        nfd: "\u{110E}\u{116D}\u{11C1}",
        nfkc: "\u{CD92}",
        nfkd: "\u{110E}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CD93}",
        nfc: "\u{CD93}",
        nfd: "\u{110E}\u{116D}\u{11C2}",
        nfkc: "\u{CD93}",
        nfkd: "\u{110E}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CD94}",
        nfc: "\u{CD94}",
        nfd: "\u{110E}\u{116E}",
        nfkc: "\u{CD94}",
        nfkd: "\u{110E}\u{116E}",
    },
    NormalizationTest {
        source: "\u{CD95}",
        nfc: "\u{CD95}",
        nfd: "\u{110E}\u{116E}\u{11A8}",
        nfkc: "\u{CD95}",
        nfkd: "\u{110E}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CD96}",
        nfc: "\u{CD96}",
        nfd: "\u{110E}\u{116E}\u{11A9}",
        nfkc: "\u{CD96}",
        nfkd: "\u{110E}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CD97}",
        nfc: "\u{CD97}",
        nfd: "\u{110E}\u{116E}\u{11AA}",
        nfkc: "\u{CD97}",
        nfkd: "\u{110E}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CD98}",
        nfc: "\u{CD98}",
        nfd: "\u{110E}\u{116E}\u{11AB}",
        nfkc: "\u{CD98}",
        nfkd: "\u{110E}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CD99}",
        nfc: "\u{CD99}",
        nfd: "\u{110E}\u{116E}\u{11AC}",
        nfkc: "\u{CD99}",
        nfkd: "\u{110E}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CD9A}",
        nfc: "\u{CD9A}",
        nfd: "\u{110E}\u{116E}\u{11AD}",
        nfkc: "\u{CD9A}",
        nfkd: "\u{110E}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CD9B}",
        nfc: "\u{CD9B}",
        nfd: "\u{110E}\u{116E}\u{11AE}",
        nfkc: "\u{CD9B}",
        nfkd: "\u{110E}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CD9C}",
        nfc: "\u{CD9C}",
        nfd: "\u{110E}\u{116E}\u{11AF}",
        nfkc: "\u{CD9C}",
        nfkd: "\u{110E}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CD9D}",
        nfc: "\u{CD9D}",
        nfd: "\u{110E}\u{116E}\u{11B0}",
        nfkc: "\u{CD9D}",
        nfkd: "\u{110E}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CD9E}",
        nfc: "\u{CD9E}",
        nfd: "\u{110E}\u{116E}\u{11B1}",
        nfkc: "\u{CD9E}",
        nfkd: "\u{110E}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CD9F}",
        nfc: "\u{CD9F}",
        nfd: "\u{110E}\u{116E}\u{11B2}",
        nfkc: "\u{CD9F}",
        nfkd: "\u{110E}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CDA0}",
        nfc: "\u{CDA0}",
        nfd: "\u{110E}\u{116E}\u{11B3}",
        nfkc: "\u{CDA0}",
        nfkd: "\u{110E}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CDA1}",
        nfc: "\u{CDA1}",
        nfd: "\u{110E}\u{116E}\u{11B4}",
        nfkc: "\u{CDA1}",
        nfkd: "\u{110E}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CDA2}",
        nfc: "\u{CDA2}",
        nfd: "\u{110E}\u{116E}\u{11B5}",
        nfkc: "\u{CDA2}",
        nfkd: "\u{110E}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CDA3}",
        nfc: "\u{CDA3}",
        nfd: "\u{110E}\u{116E}\u{11B6}",
        nfkc: "\u{CDA3}",
        nfkd: "\u{110E}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CDA4}",
        nfc: "\u{CDA4}",
        nfd: "\u{110E}\u{116E}\u{11B7}",
        nfkc: "\u{CDA4}",
        nfkd: "\u{110E}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CDA5}",
        nfc: "\u{CDA5}",
        nfd: "\u{110E}\u{116E}\u{11B8}",
        nfkc: "\u{CDA5}",
        nfkd: "\u{110E}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CDA6}",
        nfc: "\u{CDA6}",
        nfd: "\u{110E}\u{116E}\u{11B9}",
        nfkc: "\u{CDA6}",
        nfkd: "\u{110E}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CDA7}",
        nfc: "\u{CDA7}",
        nfd: "\u{110E}\u{116E}\u{11BA}",
        nfkc: "\u{CDA7}",
        nfkd: "\u{110E}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CDA8}",
        nfc: "\u{CDA8}",
        nfd: "\u{110E}\u{116E}\u{11BB}",
        nfkc: "\u{CDA8}",
        nfkd: "\u{110E}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CDA9}",
        nfc: "\u{CDA9}",
        nfd: "\u{110E}\u{116E}\u{11BC}",
        nfkc: "\u{CDA9}",
        nfkd: "\u{110E}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CDAA}",
        nfc: "\u{CDAA}",
        nfd: "\u{110E}\u{116E}\u{11BD}",
        nfkc: "\u{CDAA}",
        nfkd: "\u{110E}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CDAB}",
        nfc: "\u{CDAB}",
        nfd: "\u{110E}\u{116E}\u{11BE}",
        nfkc: "\u{CDAB}",
        nfkd: "\u{110E}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CDAC}",
        nfc: "\u{CDAC}",
        nfd: "\u{110E}\u{116E}\u{11BF}",
        nfkc: "\u{CDAC}",
        nfkd: "\u{110E}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CDAD}",
        nfc: "\u{CDAD}",
        nfd: "\u{110E}\u{116E}\u{11C0}",
        nfkc: "\u{CDAD}",
        nfkd: "\u{110E}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CDAE}",
        nfc: "\u{CDAE}",
        nfd: "\u{110E}\u{116E}\u{11C1}",
        nfkc: "\u{CDAE}",
        nfkd: "\u{110E}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CDAF}",
        nfc: "\u{CDAF}",
        nfd: "\u{110E}\u{116E}\u{11C2}",
        nfkc: "\u{CDAF}",
        nfkd: "\u{110E}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CDB0}",
        nfc: "\u{CDB0}",
        nfd: "\u{110E}\u{116F}",
        nfkc: "\u{CDB0}",
        nfkd: "\u{110E}\u{116F}",
    },
    NormalizationTest {
        source: "\u{CDB1}",
        nfc: "\u{CDB1}",
        nfd: "\u{110E}\u{116F}\u{11A8}",
        nfkc: "\u{CDB1}",
        nfkd: "\u{110E}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CDB2}",
        nfc: "\u{CDB2}",
        nfd: "\u{110E}\u{116F}\u{11A9}",
        nfkc: "\u{CDB2}",
        nfkd: "\u{110E}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CDB3}",
        nfc: "\u{CDB3}",
        nfd: "\u{110E}\u{116F}\u{11AA}",
        nfkc: "\u{CDB3}",
        nfkd: "\u{110E}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CDB4}",
        nfc: "\u{CDB4}",
        nfd: "\u{110E}\u{116F}\u{11AB}",
        nfkc: "\u{CDB4}",
        nfkd: "\u{110E}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CDB5}",
        nfc: "\u{CDB5}",
        nfd: "\u{110E}\u{116F}\u{11AC}",
        nfkc: "\u{CDB5}",
        nfkd: "\u{110E}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CDB6}",
        nfc: "\u{CDB6}",
        nfd: "\u{110E}\u{116F}\u{11AD}",
        nfkc: "\u{CDB6}",
        nfkd: "\u{110E}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CDB7}",
        nfc: "\u{CDB7}",
        nfd: "\u{110E}\u{116F}\u{11AE}",
        nfkc: "\u{CDB7}",
        nfkd: "\u{110E}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CDB8}",
        nfc: "\u{CDB8}",
        nfd: "\u{110E}\u{116F}\u{11AF}",
        nfkc: "\u{CDB8}",
        nfkd: "\u{110E}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CDB9}",
        nfc: "\u{CDB9}",
        nfd: "\u{110E}\u{116F}\u{11B0}",
        nfkc: "\u{CDB9}",
        nfkd: "\u{110E}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CDBA}",
        nfc: "\u{CDBA}",
        nfd: "\u{110E}\u{116F}\u{11B1}",
        nfkc: "\u{CDBA}",
        nfkd: "\u{110E}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CDBB}",
        nfc: "\u{CDBB}",
        nfd: "\u{110E}\u{116F}\u{11B2}",
        nfkc: "\u{CDBB}",
        nfkd: "\u{110E}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CDBC}",
        nfc: "\u{CDBC}",
        nfd: "\u{110E}\u{116F}\u{11B3}",
        nfkc: "\u{CDBC}",
        nfkd: "\u{110E}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CDBD}",
        nfc: "\u{CDBD}",
        nfd: "\u{110E}\u{116F}\u{11B4}",
        nfkc: "\u{CDBD}",
        nfkd: "\u{110E}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CDBE}",
        nfc: "\u{CDBE}",
        nfd: "\u{110E}\u{116F}\u{11B5}",
        nfkc: "\u{CDBE}",
        nfkd: "\u{110E}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CDBF}",
        nfc: "\u{CDBF}",
        nfd: "\u{110E}\u{116F}\u{11B6}",
        nfkc: "\u{CDBF}",
        nfkd: "\u{110E}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CDC0}",
        nfc: "\u{CDC0}",
        nfd: "\u{110E}\u{116F}\u{11B7}",
        nfkc: "\u{CDC0}",
        nfkd: "\u{110E}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CDC1}",
        nfc: "\u{CDC1}",
        nfd: "\u{110E}\u{116F}\u{11B8}",
        nfkc: "\u{CDC1}",
        nfkd: "\u{110E}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CDC2}",
        nfc: "\u{CDC2}",
        nfd: "\u{110E}\u{116F}\u{11B9}",
        nfkc: "\u{CDC2}",
        nfkd: "\u{110E}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CDC3}",
        nfc: "\u{CDC3}",
        nfd: "\u{110E}\u{116F}\u{11BA}",
        nfkc: "\u{CDC3}",
        nfkd: "\u{110E}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CDC4}",
        nfc: "\u{CDC4}",
        nfd: "\u{110E}\u{116F}\u{11BB}",
        nfkc: "\u{CDC4}",
        nfkd: "\u{110E}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CDC5}",
        nfc: "\u{CDC5}",
        nfd: "\u{110E}\u{116F}\u{11BC}",
        nfkc: "\u{CDC5}",
        nfkd: "\u{110E}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CDC6}",
        nfc: "\u{CDC6}",
        nfd: "\u{110E}\u{116F}\u{11BD}",
        nfkc: "\u{CDC6}",
        nfkd: "\u{110E}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CDC7}",
        nfc: "\u{CDC7}",
        nfd: "\u{110E}\u{116F}\u{11BE}",
        nfkc: "\u{CDC7}",
        nfkd: "\u{110E}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CDC8}",
        nfc: "\u{CDC8}",
        nfd: "\u{110E}\u{116F}\u{11BF}",
        nfkc: "\u{CDC8}",
        nfkd: "\u{110E}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CDC9}",
        nfc: "\u{CDC9}",
        nfd: "\u{110E}\u{116F}\u{11C0}",
        nfkc: "\u{CDC9}",
        nfkd: "\u{110E}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CDCA}",
        nfc: "\u{CDCA}",
        nfd: "\u{110E}\u{116F}\u{11C1}",
        nfkc: "\u{CDCA}",
        nfkd: "\u{110E}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CDCB}",
        nfc: "\u{CDCB}",
        nfd: "\u{110E}\u{116F}\u{11C2}",
        nfkc: "\u{CDCB}",
        nfkd: "\u{110E}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CDCC}",
        nfc: "\u{CDCC}",
        nfd: "\u{110E}\u{1170}",
        nfkc: "\u{CDCC}",
        nfkd: "\u{110E}\u{1170}",
    },
    NormalizationTest {
        source: "\u{CDCD}",
        nfc: "\u{CDCD}",
        nfd: "\u{110E}\u{1170}\u{11A8}",
        nfkc: "\u{CDCD}",
        nfkd: "\u{110E}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CDCE}",
        nfc: "\u{CDCE}",
        nfd: "\u{110E}\u{1170}\u{11A9}",
        nfkc: "\u{CDCE}",
        nfkd: "\u{110E}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CDCF}",
        nfc: "\u{CDCF}",
        nfd: "\u{110E}\u{1170}\u{11AA}",
        nfkc: "\u{CDCF}",
        nfkd: "\u{110E}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CDD0}",
        nfc: "\u{CDD0}",
        nfd: "\u{110E}\u{1170}\u{11AB}",
        nfkc: "\u{CDD0}",
        nfkd: "\u{110E}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CDD1}",
        nfc: "\u{CDD1}",
        nfd: "\u{110E}\u{1170}\u{11AC}",
        nfkc: "\u{CDD1}",
        nfkd: "\u{110E}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CDD2}",
        nfc: "\u{CDD2}",
        nfd: "\u{110E}\u{1170}\u{11AD}",
        nfkc: "\u{CDD2}",
        nfkd: "\u{110E}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CDD3}",
        nfc: "\u{CDD3}",
        nfd: "\u{110E}\u{1170}\u{11AE}",
        nfkc: "\u{CDD3}",
        nfkd: "\u{110E}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CDD4}",
        nfc: "\u{CDD4}",
        nfd: "\u{110E}\u{1170}\u{11AF}",
        nfkc: "\u{CDD4}",
        nfkd: "\u{110E}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CDD5}",
        nfc: "\u{CDD5}",
        nfd: "\u{110E}\u{1170}\u{11B0}",
        nfkc: "\u{CDD5}",
        nfkd: "\u{110E}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CDD6}",
        nfc: "\u{CDD6}",
        nfd: "\u{110E}\u{1170}\u{11B1}",
        nfkc: "\u{CDD6}",
        nfkd: "\u{110E}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CDD7}",
        nfc: "\u{CDD7}",
        nfd: "\u{110E}\u{1170}\u{11B2}",
        nfkc: "\u{CDD7}",
        nfkd: "\u{110E}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CDD8}",
        nfc: "\u{CDD8}",
        nfd: "\u{110E}\u{1170}\u{11B3}",
        nfkc: "\u{CDD8}",
        nfkd: "\u{110E}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CDD9}",
        nfc: "\u{CDD9}",
        nfd: "\u{110E}\u{1170}\u{11B4}",
        nfkc: "\u{CDD9}",
        nfkd: "\u{110E}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CDDA}",
        nfc: "\u{CDDA}",
        nfd: "\u{110E}\u{1170}\u{11B5}",
        nfkc: "\u{CDDA}",
        nfkd: "\u{110E}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CDDB}",
        nfc: "\u{CDDB}",
        nfd: "\u{110E}\u{1170}\u{11B6}",
        nfkc: "\u{CDDB}",
        nfkd: "\u{110E}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CDDC}",
        nfc: "\u{CDDC}",
        nfd: "\u{110E}\u{1170}\u{11B7}",
        nfkc: "\u{CDDC}",
        nfkd: "\u{110E}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CDDD}",
        nfc: "\u{CDDD}",
        nfd: "\u{110E}\u{1170}\u{11B8}",
        nfkc: "\u{CDDD}",
        nfkd: "\u{110E}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CDDE}",
        nfc: "\u{CDDE}",
        nfd: "\u{110E}\u{1170}\u{11B9}",
        nfkc: "\u{CDDE}",
        nfkd: "\u{110E}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CDDF}",
        nfc: "\u{CDDF}",
        nfd: "\u{110E}\u{1170}\u{11BA}",
        nfkc: "\u{CDDF}",
        nfkd: "\u{110E}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CDE0}",
        nfc: "\u{CDE0}",
        nfd: "\u{110E}\u{1170}\u{11BB}",
        nfkc: "\u{CDE0}",
        nfkd: "\u{110E}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CDE1}",
        nfc: "\u{CDE1}",
        nfd: "\u{110E}\u{1170}\u{11BC}",
        nfkc: "\u{CDE1}",
        nfkd: "\u{110E}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CDE2}",
        nfc: "\u{CDE2}",
        nfd: "\u{110E}\u{1170}\u{11BD}",
        nfkc: "\u{CDE2}",
        nfkd: "\u{110E}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CDE3}",
        nfc: "\u{CDE3}",
        nfd: "\u{110E}\u{1170}\u{11BE}",
        nfkc: "\u{CDE3}",
        nfkd: "\u{110E}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CDE4}",
        nfc: "\u{CDE4}",
        nfd: "\u{110E}\u{1170}\u{11BF}",
        nfkc: "\u{CDE4}",
        nfkd: "\u{110E}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CDE5}",
        nfc: "\u{CDE5}",
        nfd: "\u{110E}\u{1170}\u{11C0}",
        nfkc: "\u{CDE5}",
        nfkd: "\u{110E}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CDE6}",
        nfc: "\u{CDE6}",
        nfd: "\u{110E}\u{1170}\u{11C1}",
        nfkc: "\u{CDE6}",
        nfkd: "\u{110E}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CDE7}",
        nfc: "\u{CDE7}",
        nfd: "\u{110E}\u{1170}\u{11C2}",
        nfkc: "\u{CDE7}",
        nfkd: "\u{110E}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CDE8}",
        nfc: "\u{CDE8}",
        nfd: "\u{110E}\u{1171}",
        nfkc: "\u{CDE8}",
        nfkd: "\u{110E}\u{1171}",
    },
    NormalizationTest {
        source: "\u{CDE9}",
        nfc: "\u{CDE9}",
        nfd: "\u{110E}\u{1171}\u{11A8}",
        nfkc: "\u{CDE9}",
        nfkd: "\u{110E}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CDEA}",
        nfc: "\u{CDEA}",
        nfd: "\u{110E}\u{1171}\u{11A9}",
        nfkc: "\u{CDEA}",
        nfkd: "\u{110E}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CDEB}",
        nfc: "\u{CDEB}",
        nfd: "\u{110E}\u{1171}\u{11AA}",
        nfkc: "\u{CDEB}",
        nfkd: "\u{110E}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CDEC}",
        nfc: "\u{CDEC}",
        nfd: "\u{110E}\u{1171}\u{11AB}",
        nfkc: "\u{CDEC}",
        nfkd: "\u{110E}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CDED}",
        nfc: "\u{CDED}",
        nfd: "\u{110E}\u{1171}\u{11AC}",
        nfkc: "\u{CDED}",
        nfkd: "\u{110E}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CDEE}",
        nfc: "\u{CDEE}",
        nfd: "\u{110E}\u{1171}\u{11AD}",
        nfkc: "\u{CDEE}",
        nfkd: "\u{110E}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CDEF}",
        nfc: "\u{CDEF}",
        nfd: "\u{110E}\u{1171}\u{11AE}",
        nfkc: "\u{CDEF}",
        nfkd: "\u{110E}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CDF0}",
        nfc: "\u{CDF0}",
        nfd: "\u{110E}\u{1171}\u{11AF}",
        nfkc: "\u{CDF0}",
        nfkd: "\u{110E}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CDF1}",
        nfc: "\u{CDF1}",
        nfd: "\u{110E}\u{1171}\u{11B0}",
        nfkc: "\u{CDF1}",
        nfkd: "\u{110E}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CDF2}",
        nfc: "\u{CDF2}",
        nfd: "\u{110E}\u{1171}\u{11B1}",
        nfkc: "\u{CDF2}",
        nfkd: "\u{110E}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CDF3}",
        nfc: "\u{CDF3}",
        nfd: "\u{110E}\u{1171}\u{11B2}",
        nfkc: "\u{CDF3}",
        nfkd: "\u{110E}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CDF4}",
        nfc: "\u{CDF4}",
        nfd: "\u{110E}\u{1171}\u{11B3}",
        nfkc: "\u{CDF4}",
        nfkd: "\u{110E}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CDF5}",
        nfc: "\u{CDF5}",
        nfd: "\u{110E}\u{1171}\u{11B4}",
        nfkc: "\u{CDF5}",
        nfkd: "\u{110E}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CDF6}",
        nfc: "\u{CDF6}",
        nfd: "\u{110E}\u{1171}\u{11B5}",
        nfkc: "\u{CDF6}",
        nfkd: "\u{110E}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CDF7}",
        nfc: "\u{CDF7}",
        nfd: "\u{110E}\u{1171}\u{11B6}",
        nfkc: "\u{CDF7}",
        nfkd: "\u{110E}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CDF8}",
        nfc: "\u{CDF8}",
        nfd: "\u{110E}\u{1171}\u{11B7}",
        nfkc: "\u{CDF8}",
        nfkd: "\u{110E}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CDF9}",
        nfc: "\u{CDF9}",
        nfd: "\u{110E}\u{1171}\u{11B8}",
        nfkc: "\u{CDF9}",
        nfkd: "\u{110E}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CDFA}",
        nfc: "\u{CDFA}",
        nfd: "\u{110E}\u{1171}\u{11B9}",
        nfkc: "\u{CDFA}",
        nfkd: "\u{110E}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CDFB}",
        nfc: "\u{CDFB}",
        nfd: "\u{110E}\u{1171}\u{11BA}",
        nfkc: "\u{CDFB}",
        nfkd: "\u{110E}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CDFC}",
        nfc: "\u{CDFC}",
        nfd: "\u{110E}\u{1171}\u{11BB}",
        nfkc: "\u{CDFC}",
        nfkd: "\u{110E}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CDFD}",
        nfc: "\u{CDFD}",
        nfd: "\u{110E}\u{1171}\u{11BC}",
        nfkc: "\u{CDFD}",
        nfkd: "\u{110E}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CDFE}",
        nfc: "\u{CDFE}",
        nfd: "\u{110E}\u{1171}\u{11BD}",
        nfkc: "\u{CDFE}",
        nfkd: "\u{110E}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CDFF}",
        nfc: "\u{CDFF}",
        nfd: "\u{110E}\u{1171}\u{11BE}",
        nfkc: "\u{CDFF}",
        nfkd: "\u{110E}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CE00}",
        nfc: "\u{CE00}",
        nfd: "\u{110E}\u{1171}\u{11BF}",
        nfkc: "\u{CE00}",
        nfkd: "\u{110E}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CE01}",
        nfc: "\u{CE01}",
        nfd: "\u{110E}\u{1171}\u{11C0}",
        nfkc: "\u{CE01}",
        nfkd: "\u{110E}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CE02}",
        nfc: "\u{CE02}",
        nfd: "\u{110E}\u{1171}\u{11C1}",
        nfkc: "\u{CE02}",
        nfkd: "\u{110E}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CE03}",
        nfc: "\u{CE03}",
        nfd: "\u{110E}\u{1171}\u{11C2}",
        nfkc: "\u{CE03}",
        nfkd: "\u{110E}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CE04}",
        nfc: "\u{CE04}",
        nfd: "\u{110E}\u{1172}",
        nfkc: "\u{CE04}",
        nfkd: "\u{110E}\u{1172}",
    },
    NormalizationTest {
        source: "\u{CE05}",
        nfc: "\u{CE05}",
        nfd: "\u{110E}\u{1172}\u{11A8}",
        nfkc: "\u{CE05}",
        nfkd: "\u{110E}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CE06}",
        nfc: "\u{CE06}",
        nfd: "\u{110E}\u{1172}\u{11A9}",
        nfkc: "\u{CE06}",
        nfkd: "\u{110E}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CE07}",
        nfc: "\u{CE07}",
        nfd: "\u{110E}\u{1172}\u{11AA}",
        nfkc: "\u{CE07}",
        nfkd: "\u{110E}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CE08}",
        nfc: "\u{CE08}",
        nfd: "\u{110E}\u{1172}\u{11AB}",
        nfkc: "\u{CE08}",
        nfkd: "\u{110E}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CE09}",
        nfc: "\u{CE09}",
        nfd: "\u{110E}\u{1172}\u{11AC}",
        nfkc: "\u{CE09}",
        nfkd: "\u{110E}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CE0A}",
        nfc: "\u{CE0A}",
        nfd: "\u{110E}\u{1172}\u{11AD}",
        nfkc: "\u{CE0A}",
        nfkd: "\u{110E}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CE0B}",
        nfc: "\u{CE0B}",
        nfd: "\u{110E}\u{1172}\u{11AE}",
        nfkc: "\u{CE0B}",
        nfkd: "\u{110E}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CE0C}",
        nfc: "\u{CE0C}",
        nfd: "\u{110E}\u{1172}\u{11AF}",
        nfkc: "\u{CE0C}",
        nfkd: "\u{110E}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CE0D}",
        nfc: "\u{CE0D}",
        nfd: "\u{110E}\u{1172}\u{11B0}",
        nfkc: "\u{CE0D}",
        nfkd: "\u{110E}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CE0E}",
        nfc: "\u{CE0E}",
        nfd: "\u{110E}\u{1172}\u{11B1}",
        nfkc: "\u{CE0E}",
        nfkd: "\u{110E}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CE0F}",
        nfc: "\u{CE0F}",
        nfd: "\u{110E}\u{1172}\u{11B2}",
        nfkc: "\u{CE0F}",
        nfkd: "\u{110E}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CE10}",
        nfc: "\u{CE10}",
        nfd: "\u{110E}\u{1172}\u{11B3}",
        nfkc: "\u{CE10}",
        nfkd: "\u{110E}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CE11}",
        nfc: "\u{CE11}",
        nfd: "\u{110E}\u{1172}\u{11B4}",
        nfkc: "\u{CE11}",
        nfkd: "\u{110E}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CE12}",
        nfc: "\u{CE12}",
        nfd: "\u{110E}\u{1172}\u{11B5}",
        nfkc: "\u{CE12}",
        nfkd: "\u{110E}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CE13}",
        nfc: "\u{CE13}",
        nfd: "\u{110E}\u{1172}\u{11B6}",
        nfkc: "\u{CE13}",
        nfkd: "\u{110E}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CE14}",
        nfc: "\u{CE14}",
        nfd: "\u{110E}\u{1172}\u{11B7}",
        nfkc: "\u{CE14}",
        nfkd: "\u{110E}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CE15}",
        nfc: "\u{CE15}",
        nfd: "\u{110E}\u{1172}\u{11B8}",
        nfkc: "\u{CE15}",
        nfkd: "\u{110E}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CE16}",
        nfc: "\u{CE16}",
        nfd: "\u{110E}\u{1172}\u{11B9}",
        nfkc: "\u{CE16}",
        nfkd: "\u{110E}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CE17}",
        nfc: "\u{CE17}",
        nfd: "\u{110E}\u{1172}\u{11BA}",
        nfkc: "\u{CE17}",
        nfkd: "\u{110E}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CE18}",
        nfc: "\u{CE18}",
        nfd: "\u{110E}\u{1172}\u{11BB}",
        nfkc: "\u{CE18}",
        nfkd: "\u{110E}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CE19}",
        nfc: "\u{CE19}",
        nfd: "\u{110E}\u{1172}\u{11BC}",
        nfkc: "\u{CE19}",
        nfkd: "\u{110E}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CE1A}",
        nfc: "\u{CE1A}",
        nfd: "\u{110E}\u{1172}\u{11BD}",
        nfkc: "\u{CE1A}",
        nfkd: "\u{110E}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CE1B}",
        nfc: "\u{CE1B}",
        nfd: "\u{110E}\u{1172}\u{11BE}",
        nfkc: "\u{CE1B}",
        nfkd: "\u{110E}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CE1C}",
        nfc: "\u{CE1C}",
        nfd: "\u{110E}\u{1172}\u{11BF}",
        nfkc: "\u{CE1C}",
        nfkd: "\u{110E}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CE1D}",
        nfc: "\u{CE1D}",
        nfd: "\u{110E}\u{1172}\u{11C0}",
        nfkc: "\u{CE1D}",
        nfkd: "\u{110E}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CE1E}",
        nfc: "\u{CE1E}",
        nfd: "\u{110E}\u{1172}\u{11C1}",
        nfkc: "\u{CE1E}",
        nfkd: "\u{110E}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CE1F}",
        nfc: "\u{CE1F}",
        nfd: "\u{110E}\u{1172}\u{11C2}",
        nfkc: "\u{CE1F}",
        nfkd: "\u{110E}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CE20}",
        nfc: "\u{CE20}",
        nfd: "\u{110E}\u{1173}",
        nfkc: "\u{CE20}",
        nfkd: "\u{110E}\u{1173}",
    },
    NormalizationTest {
        source: "\u{CE21}",
        nfc: "\u{CE21}",
        nfd: "\u{110E}\u{1173}\u{11A8}",
        nfkc: "\u{CE21}",
        nfkd: "\u{110E}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CE22}",
        nfc: "\u{CE22}",
        nfd: "\u{110E}\u{1173}\u{11A9}",
        nfkc: "\u{CE22}",
        nfkd: "\u{110E}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CE23}",
        nfc: "\u{CE23}",
        nfd: "\u{110E}\u{1173}\u{11AA}",
        nfkc: "\u{CE23}",
        nfkd: "\u{110E}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CE24}",
        nfc: "\u{CE24}",
        nfd: "\u{110E}\u{1173}\u{11AB}",
        nfkc: "\u{CE24}",
        nfkd: "\u{110E}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CE25}",
        nfc: "\u{CE25}",
        nfd: "\u{110E}\u{1173}\u{11AC}",
        nfkc: "\u{CE25}",
        nfkd: "\u{110E}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CE26}",
        nfc: "\u{CE26}",
        nfd: "\u{110E}\u{1173}\u{11AD}",
        nfkc: "\u{CE26}",
        nfkd: "\u{110E}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CE27}",
        nfc: "\u{CE27}",
        nfd: "\u{110E}\u{1173}\u{11AE}",
        nfkc: "\u{CE27}",
        nfkd: "\u{110E}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CE28}",
        nfc: "\u{CE28}",
        nfd: "\u{110E}\u{1173}\u{11AF}",
        nfkc: "\u{CE28}",
        nfkd: "\u{110E}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CE29}",
        nfc: "\u{CE29}",
        nfd: "\u{110E}\u{1173}\u{11B0}",
        nfkc: "\u{CE29}",
        nfkd: "\u{110E}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CE2A}",
        nfc: "\u{CE2A}",
        nfd: "\u{110E}\u{1173}\u{11B1}",
        nfkc: "\u{CE2A}",
        nfkd: "\u{110E}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CE2B}",
        nfc: "\u{CE2B}",
        nfd: "\u{110E}\u{1173}\u{11B2}",
        nfkc: "\u{CE2B}",
        nfkd: "\u{110E}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CE2C}",
        nfc: "\u{CE2C}",
        nfd: "\u{110E}\u{1173}\u{11B3}",
        nfkc: "\u{CE2C}",
        nfkd: "\u{110E}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CE2D}",
        nfc: "\u{CE2D}",
        nfd: "\u{110E}\u{1173}\u{11B4}",
        nfkc: "\u{CE2D}",
        nfkd: "\u{110E}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CE2E}",
        nfc: "\u{CE2E}",
        nfd: "\u{110E}\u{1173}\u{11B5}",
        nfkc: "\u{CE2E}",
        nfkd: "\u{110E}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CE2F}",
        nfc: "\u{CE2F}",
        nfd: "\u{110E}\u{1173}\u{11B6}",
        nfkc: "\u{CE2F}",
        nfkd: "\u{110E}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CE30}",
        nfc: "\u{CE30}",
        nfd: "\u{110E}\u{1173}\u{11B7}",
        nfkc: "\u{CE30}",
        nfkd: "\u{110E}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CE31}",
        nfc: "\u{CE31}",
        nfd: "\u{110E}\u{1173}\u{11B8}",
        nfkc: "\u{CE31}",
        nfkd: "\u{110E}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CE32}",
        nfc: "\u{CE32}",
        nfd: "\u{110E}\u{1173}\u{11B9}",
        nfkc: "\u{CE32}",
        nfkd: "\u{110E}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CE33}",
        nfc: "\u{CE33}",
        nfd: "\u{110E}\u{1173}\u{11BA}",
        nfkc: "\u{CE33}",
        nfkd: "\u{110E}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CE34}",
        nfc: "\u{CE34}",
        nfd: "\u{110E}\u{1173}\u{11BB}",
        nfkc: "\u{CE34}",
        nfkd: "\u{110E}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CE35}",
        nfc: "\u{CE35}",
        nfd: "\u{110E}\u{1173}\u{11BC}",
        nfkc: "\u{CE35}",
        nfkd: "\u{110E}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CE36}",
        nfc: "\u{CE36}",
        nfd: "\u{110E}\u{1173}\u{11BD}",
        nfkc: "\u{CE36}",
        nfkd: "\u{110E}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CE37}",
        nfc: "\u{CE37}",
        nfd: "\u{110E}\u{1173}\u{11BE}",
        nfkc: "\u{CE37}",
        nfkd: "\u{110E}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CE38}",
        nfc: "\u{CE38}",
        nfd: "\u{110E}\u{1173}\u{11BF}",
        nfkc: "\u{CE38}",
        nfkd: "\u{110E}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CE39}",
        nfc: "\u{CE39}",
        nfd: "\u{110E}\u{1173}\u{11C0}",
        nfkc: "\u{CE39}",
        nfkd: "\u{110E}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CE3A}",
        nfc: "\u{CE3A}",
        nfd: "\u{110E}\u{1173}\u{11C1}",
        nfkc: "\u{CE3A}",
        nfkd: "\u{110E}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CE3B}",
        nfc: "\u{CE3B}",
        nfd: "\u{110E}\u{1173}\u{11C2}",
        nfkc: "\u{CE3B}",
        nfkd: "\u{110E}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CE3C}",
        nfc: "\u{CE3C}",
        nfd: "\u{110E}\u{1174}",
        nfkc: "\u{CE3C}",
        nfkd: "\u{110E}\u{1174}",
    },
    NormalizationTest {
        source: "\u{CE3D}",
        nfc: "\u{CE3D}",
        nfd: "\u{110E}\u{1174}\u{11A8}",
        nfkc: "\u{CE3D}",
        nfkd: "\u{110E}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CE3E}",
        nfc: "\u{CE3E}",
        nfd: "\u{110E}\u{1174}\u{11A9}",
        nfkc: "\u{CE3E}",
        nfkd: "\u{110E}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CE3F}",
        nfc: "\u{CE3F}",
        nfd: "\u{110E}\u{1174}\u{11AA}",
        nfkc: "\u{CE3F}",
        nfkd: "\u{110E}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CE40}",
        nfc: "\u{CE40}",
        nfd: "\u{110E}\u{1174}\u{11AB}",
        nfkc: "\u{CE40}",
        nfkd: "\u{110E}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CE41}",
        nfc: "\u{CE41}",
        nfd: "\u{110E}\u{1174}\u{11AC}",
        nfkc: "\u{CE41}",
        nfkd: "\u{110E}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CE42}",
        nfc: "\u{CE42}",
        nfd: "\u{110E}\u{1174}\u{11AD}",
        nfkc: "\u{CE42}",
        nfkd: "\u{110E}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CE43}",
        nfc: "\u{CE43}",
        nfd: "\u{110E}\u{1174}\u{11AE}",
        nfkc: "\u{CE43}",
        nfkd: "\u{110E}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CE44}",
        nfc: "\u{CE44}",
        nfd: "\u{110E}\u{1174}\u{11AF}",
        nfkc: "\u{CE44}",
        nfkd: "\u{110E}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CE45}",
        nfc: "\u{CE45}",
        nfd: "\u{110E}\u{1174}\u{11B0}",
        nfkc: "\u{CE45}",
        nfkd: "\u{110E}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CE46}",
        nfc: "\u{CE46}",
        nfd: "\u{110E}\u{1174}\u{11B1}",
        nfkc: "\u{CE46}",
        nfkd: "\u{110E}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CE47}",
        nfc: "\u{CE47}",
        nfd: "\u{110E}\u{1174}\u{11B2}",
        nfkc: "\u{CE47}",
        nfkd: "\u{110E}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CE48}",
        nfc: "\u{CE48}",
        nfd: "\u{110E}\u{1174}\u{11B3}",
        nfkc: "\u{CE48}",
        nfkd: "\u{110E}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CE49}",
        nfc: "\u{CE49}",
        nfd: "\u{110E}\u{1174}\u{11B4}",
        nfkc: "\u{CE49}",
        nfkd: "\u{110E}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CE4A}",
        nfc: "\u{CE4A}",
        nfd: "\u{110E}\u{1174}\u{11B5}",
        nfkc: "\u{CE4A}",
        nfkd: "\u{110E}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CE4B}",
        nfc: "\u{CE4B}",
        nfd: "\u{110E}\u{1174}\u{11B6}",
        nfkc: "\u{CE4B}",
        nfkd: "\u{110E}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CE4C}",
        nfc: "\u{CE4C}",
        nfd: "\u{110E}\u{1174}\u{11B7}",
        nfkc: "\u{CE4C}",
        nfkd: "\u{110E}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CE4D}",
        nfc: "\u{CE4D}",
        nfd: "\u{110E}\u{1174}\u{11B8}",
        nfkc: "\u{CE4D}",
        nfkd: "\u{110E}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CE4E}",
        nfc: "\u{CE4E}",
        nfd: "\u{110E}\u{1174}\u{11B9}",
        nfkc: "\u{CE4E}",
        nfkd: "\u{110E}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CE4F}",
        nfc: "\u{CE4F}",
        nfd: "\u{110E}\u{1174}\u{11BA}",
        nfkc: "\u{CE4F}",
        nfkd: "\u{110E}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CE50}",
        nfc: "\u{CE50}",
        nfd: "\u{110E}\u{1174}\u{11BB}",
        nfkc: "\u{CE50}",
        nfkd: "\u{110E}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CE51}",
        nfc: "\u{CE51}",
        nfd: "\u{110E}\u{1174}\u{11BC}",
        nfkc: "\u{CE51}",
        nfkd: "\u{110E}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CE52}",
        nfc: "\u{CE52}",
        nfd: "\u{110E}\u{1174}\u{11BD}",
        nfkc: "\u{CE52}",
        nfkd: "\u{110E}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CE53}",
        nfc: "\u{CE53}",
        nfd: "\u{110E}\u{1174}\u{11BE}",
        nfkc: "\u{CE53}",
        nfkd: "\u{110E}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CE54}",
        nfc: "\u{CE54}",
        nfd: "\u{110E}\u{1174}\u{11BF}",
        nfkc: "\u{CE54}",
        nfkd: "\u{110E}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CE55}",
        nfc: "\u{CE55}",
        nfd: "\u{110E}\u{1174}\u{11C0}",
        nfkc: "\u{CE55}",
        nfkd: "\u{110E}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CE56}",
        nfc: "\u{CE56}",
        nfd: "\u{110E}\u{1174}\u{11C1}",
        nfkc: "\u{CE56}",
        nfkd: "\u{110E}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CE57}",
        nfc: "\u{CE57}",
        nfd: "\u{110E}\u{1174}\u{11C2}",
        nfkc: "\u{CE57}",
        nfkd: "\u{110E}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CE58}",
        nfc: "\u{CE58}",
        nfd: "\u{110E}\u{1175}",
        nfkc: "\u{CE58}",
        nfkd: "\u{110E}\u{1175}",
    },
    NormalizationTest {
        source: "\u{CE59}",
        nfc: "\u{CE59}",
        nfd: "\u{110E}\u{1175}\u{11A8}",
        nfkc: "\u{CE59}",
        nfkd: "\u{110E}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CE5A}",
        nfc: "\u{CE5A}",
        nfd: "\u{110E}\u{1175}\u{11A9}",
        nfkc: "\u{CE5A}",
        nfkd: "\u{110E}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CE5B}",
        nfc: "\u{CE5B}",
        nfd: "\u{110E}\u{1175}\u{11AA}",
        nfkc: "\u{CE5B}",
        nfkd: "\u{110E}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CE5C}",
        nfc: "\u{CE5C}",
        nfd: "\u{110E}\u{1175}\u{11AB}",
        nfkc: "\u{CE5C}",
        nfkd: "\u{110E}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CE5D}",
        nfc: "\u{CE5D}",
        nfd: "\u{110E}\u{1175}\u{11AC}",
        nfkc: "\u{CE5D}",
        nfkd: "\u{110E}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CE5E}",
        nfc: "\u{CE5E}",
        nfd: "\u{110E}\u{1175}\u{11AD}",
        nfkc: "\u{CE5E}",
        nfkd: "\u{110E}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CE5F}",
        nfc: "\u{CE5F}",
        nfd: "\u{110E}\u{1175}\u{11AE}",
        nfkc: "\u{CE5F}",
        nfkd: "\u{110E}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CE60}",
        nfc: "\u{CE60}",
        nfd: "\u{110E}\u{1175}\u{11AF}",
        nfkc: "\u{CE60}",
        nfkd: "\u{110E}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CE61}",
        nfc: "\u{CE61}",
        nfd: "\u{110E}\u{1175}\u{11B0}",
        nfkc: "\u{CE61}",
        nfkd: "\u{110E}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CE62}",
        nfc: "\u{CE62}",
        nfd: "\u{110E}\u{1175}\u{11B1}",
        nfkc: "\u{CE62}",
        nfkd: "\u{110E}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CE63}",
        nfc: "\u{CE63}",
        nfd: "\u{110E}\u{1175}\u{11B2}",
        nfkc: "\u{CE63}",
        nfkd: "\u{110E}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CE64}",
        nfc: "\u{CE64}",
        nfd: "\u{110E}\u{1175}\u{11B3}",
        nfkc: "\u{CE64}",
        nfkd: "\u{110E}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CE65}",
        nfc: "\u{CE65}",
        nfd: "\u{110E}\u{1175}\u{11B4}",
        nfkc: "\u{CE65}",
        nfkd: "\u{110E}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CE66}",
        nfc: "\u{CE66}",
        nfd: "\u{110E}\u{1175}\u{11B5}",
        nfkc: "\u{CE66}",
        nfkd: "\u{110E}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CE67}",
        nfc: "\u{CE67}",
        nfd: "\u{110E}\u{1175}\u{11B6}",
        nfkc: "\u{CE67}",
        nfkd: "\u{110E}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CE68}",
        nfc: "\u{CE68}",
        nfd: "\u{110E}\u{1175}\u{11B7}",
        nfkc: "\u{CE68}",
        nfkd: "\u{110E}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CE69}",
        nfc: "\u{CE69}",
        nfd: "\u{110E}\u{1175}\u{11B8}",
        nfkc: "\u{CE69}",
        nfkd: "\u{110E}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CE6A}",
        nfc: "\u{CE6A}",
        nfd: "\u{110E}\u{1175}\u{11B9}",
        nfkc: "\u{CE6A}",
        nfkd: "\u{110E}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CE6B}",
        nfc: "\u{CE6B}",
        nfd: "\u{110E}\u{1175}\u{11BA}",
        nfkc: "\u{CE6B}",
        nfkd: "\u{110E}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CE6C}",
        nfc: "\u{CE6C}",
        nfd: "\u{110E}\u{1175}\u{11BB}",
        nfkc: "\u{CE6C}",
        nfkd: "\u{110E}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CE6D}",
        nfc: "\u{CE6D}",
        nfd: "\u{110E}\u{1175}\u{11BC}",
        nfkc: "\u{CE6D}",
        nfkd: "\u{110E}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CE6E}",
        nfc: "\u{CE6E}",
        nfd: "\u{110E}\u{1175}\u{11BD}",
        nfkc: "\u{CE6E}",
        nfkd: "\u{110E}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CE6F}",
        nfc: "\u{CE6F}",
        nfd: "\u{110E}\u{1175}\u{11BE}",
        nfkc: "\u{CE6F}",
        nfkd: "\u{110E}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CE70}",
        nfc: "\u{CE70}",
        nfd: "\u{110E}\u{1175}\u{11BF}",
        nfkc: "\u{CE70}",
        nfkd: "\u{110E}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CE71}",
        nfc: "\u{CE71}",
        nfd: "\u{110E}\u{1175}\u{11C0}",
        nfkc: "\u{CE71}",
        nfkd: "\u{110E}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CE72}",
        nfc: "\u{CE72}",
        nfd: "\u{110E}\u{1175}\u{11C1}",
        nfkc: "\u{CE72}",
        nfkd: "\u{110E}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CE73}",
        nfc: "\u{CE73}",
        nfd: "\u{110E}\u{1175}\u{11C2}",
        nfkc: "\u{CE73}",
        nfkd: "\u{110E}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CE74}",
        nfc: "\u{CE74}",
        nfd: "\u{110F}\u{1161}",
        nfkc: "\u{CE74}",
        nfkd: "\u{110F}\u{1161}",
    },
    NormalizationTest {
        source: "\u{CE75}",
        nfc: "\u{CE75}",
        nfd: "\u{110F}\u{1161}\u{11A8}",
        nfkc: "\u{CE75}",
        nfkd: "\u{110F}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CE76}",
        nfc: "\u{CE76}",
        nfd: "\u{110F}\u{1161}\u{11A9}",
        nfkc: "\u{CE76}",
        nfkd: "\u{110F}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CE77}",
        nfc: "\u{CE77}",
        nfd: "\u{110F}\u{1161}\u{11AA}",
        nfkc: "\u{CE77}",
        nfkd: "\u{110F}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CE78}",
        nfc: "\u{CE78}",
        nfd: "\u{110F}\u{1161}\u{11AB}",
        nfkc: "\u{CE78}",
        nfkd: "\u{110F}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CE79}",
        nfc: "\u{CE79}",
        nfd: "\u{110F}\u{1161}\u{11AC}",
        nfkc: "\u{CE79}",
        nfkd: "\u{110F}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CE7A}",
        nfc: "\u{CE7A}",
        nfd: "\u{110F}\u{1161}\u{11AD}",
        nfkc: "\u{CE7A}",
        nfkd: "\u{110F}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CE7B}",
        nfc: "\u{CE7B}",
        nfd: "\u{110F}\u{1161}\u{11AE}",
        nfkc: "\u{CE7B}",
        nfkd: "\u{110F}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CE7C}",
        nfc: "\u{CE7C}",
        nfd: "\u{110F}\u{1161}\u{11AF}",
        nfkc: "\u{CE7C}",
        nfkd: "\u{110F}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CE7D}",
        nfc: "\u{CE7D}",
        nfd: "\u{110F}\u{1161}\u{11B0}",
        nfkc: "\u{CE7D}",
        nfkd: "\u{110F}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CE7E}",
        nfc: "\u{CE7E}",
        nfd: "\u{110F}\u{1161}\u{11B1}",
        nfkc: "\u{CE7E}",
        nfkd: "\u{110F}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CE7F}",
        nfc: "\u{CE7F}",
        nfd: "\u{110F}\u{1161}\u{11B2}",
        nfkc: "\u{CE7F}",
        nfkd: "\u{110F}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CE80}",
        nfc: "\u{CE80}",
        nfd: "\u{110F}\u{1161}\u{11B3}",
        nfkc: "\u{CE80}",
        nfkd: "\u{110F}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CE81}",
        nfc: "\u{CE81}",
        nfd: "\u{110F}\u{1161}\u{11B4}",
        nfkc: "\u{CE81}",
        nfkd: "\u{110F}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CE82}",
        nfc: "\u{CE82}",
        nfd: "\u{110F}\u{1161}\u{11B5}",
        nfkc: "\u{CE82}",
        nfkd: "\u{110F}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CE83}",
        nfc: "\u{CE83}",
        nfd: "\u{110F}\u{1161}\u{11B6}",
        nfkc: "\u{CE83}",
        nfkd: "\u{110F}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CE84}",
        nfc: "\u{CE84}",
        nfd: "\u{110F}\u{1161}\u{11B7}",
        nfkc: "\u{CE84}",
        nfkd: "\u{110F}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CE85}",
        nfc: "\u{CE85}",
        nfd: "\u{110F}\u{1161}\u{11B8}",
        nfkc: "\u{CE85}",
        nfkd: "\u{110F}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CE86}",
        nfc: "\u{CE86}",
        nfd: "\u{110F}\u{1161}\u{11B9}",
        nfkc: "\u{CE86}",
        nfkd: "\u{110F}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CE87}",
        nfc: "\u{CE87}",
        nfd: "\u{110F}\u{1161}\u{11BA}",
        nfkc: "\u{CE87}",
        nfkd: "\u{110F}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CE88}",
        nfc: "\u{CE88}",
        nfd: "\u{110F}\u{1161}\u{11BB}",
        nfkc: "\u{CE88}",
        nfkd: "\u{110F}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CE89}",
        nfc: "\u{CE89}",
        nfd: "\u{110F}\u{1161}\u{11BC}",
        nfkc: "\u{CE89}",
        nfkd: "\u{110F}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CE8A}",
        nfc: "\u{CE8A}",
        nfd: "\u{110F}\u{1161}\u{11BD}",
        nfkc: "\u{CE8A}",
        nfkd: "\u{110F}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CE8B}",
        nfc: "\u{CE8B}",
        nfd: "\u{110F}\u{1161}\u{11BE}",
        nfkc: "\u{CE8B}",
        nfkd: "\u{110F}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CE8C}",
        nfc: "\u{CE8C}",
        nfd: "\u{110F}\u{1161}\u{11BF}",
        nfkc: "\u{CE8C}",
        nfkd: "\u{110F}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CE8D}",
        nfc: "\u{CE8D}",
        nfd: "\u{110F}\u{1161}\u{11C0}",
        nfkc: "\u{CE8D}",
        nfkd: "\u{110F}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CE8E}",
        nfc: "\u{CE8E}",
        nfd: "\u{110F}\u{1161}\u{11C1}",
        nfkc: "\u{CE8E}",
        nfkd: "\u{110F}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CE8F}",
        nfc: "\u{CE8F}",
        nfd: "\u{110F}\u{1161}\u{11C2}",
        nfkc: "\u{CE8F}",
        nfkd: "\u{110F}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CE90}",
        nfc: "\u{CE90}",
        nfd: "\u{110F}\u{1162}",
        nfkc: "\u{CE90}",
        nfkd: "\u{110F}\u{1162}",
    },
    NormalizationTest {
        source: "\u{CE91}",
        nfc: "\u{CE91}",
        nfd: "\u{110F}\u{1162}\u{11A8}",
        nfkc: "\u{CE91}",
        nfkd: "\u{110F}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CE92}",
        nfc: "\u{CE92}",
        nfd: "\u{110F}\u{1162}\u{11A9}",
        nfkc: "\u{CE92}",
        nfkd: "\u{110F}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CE93}",
        nfc: "\u{CE93}",
        nfd: "\u{110F}\u{1162}\u{11AA}",
        nfkc: "\u{CE93}",
        nfkd: "\u{110F}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CE94}",
        nfc: "\u{CE94}",
        nfd: "\u{110F}\u{1162}\u{11AB}",
        nfkc: "\u{CE94}",
        nfkd: "\u{110F}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CE95}",
        nfc: "\u{CE95}",
        nfd: "\u{110F}\u{1162}\u{11AC}",
        nfkc: "\u{CE95}",
        nfkd: "\u{110F}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CE96}",
        nfc: "\u{CE96}",
        nfd: "\u{110F}\u{1162}\u{11AD}",
        nfkc: "\u{CE96}",
        nfkd: "\u{110F}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CE97}",
        nfc: "\u{CE97}",
        nfd: "\u{110F}\u{1162}\u{11AE}",
        nfkc: "\u{CE97}",
        nfkd: "\u{110F}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CE98}",
        nfc: "\u{CE98}",
        nfd: "\u{110F}\u{1162}\u{11AF}",
        nfkc: "\u{CE98}",
        nfkd: "\u{110F}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CE99}",
        nfc: "\u{CE99}",
        nfd: "\u{110F}\u{1162}\u{11B0}",
        nfkc: "\u{CE99}",
        nfkd: "\u{110F}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CE9A}",
        nfc: "\u{CE9A}",
        nfd: "\u{110F}\u{1162}\u{11B1}",
        nfkc: "\u{CE9A}",
        nfkd: "\u{110F}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CE9B}",
        nfc: "\u{CE9B}",
        nfd: "\u{110F}\u{1162}\u{11B2}",
        nfkc: "\u{CE9B}",
        nfkd: "\u{110F}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CE9C}",
        nfc: "\u{CE9C}",
        nfd: "\u{110F}\u{1162}\u{11B3}",
        nfkc: "\u{CE9C}",
        nfkd: "\u{110F}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CE9D}",
        nfc: "\u{CE9D}",
        nfd: "\u{110F}\u{1162}\u{11B4}",
        nfkc: "\u{CE9D}",
        nfkd: "\u{110F}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CE9E}",
        nfc: "\u{CE9E}",
        nfd: "\u{110F}\u{1162}\u{11B5}",
        nfkc: "\u{CE9E}",
        nfkd: "\u{110F}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CE9F}",
        nfc: "\u{CE9F}",
        nfd: "\u{110F}\u{1162}\u{11B6}",
        nfkc: "\u{CE9F}",
        nfkd: "\u{110F}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CEA0}",
        nfc: "\u{CEA0}",
        nfd: "\u{110F}\u{1162}\u{11B7}",
        nfkc: "\u{CEA0}",
        nfkd: "\u{110F}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CEA1}",
        nfc: "\u{CEA1}",
        nfd: "\u{110F}\u{1162}\u{11B8}",
        nfkc: "\u{CEA1}",
        nfkd: "\u{110F}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CEA2}",
        nfc: "\u{CEA2}",
        nfd: "\u{110F}\u{1162}\u{11B9}",
        nfkc: "\u{CEA2}",
        nfkd: "\u{110F}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CEA3}",
        nfc: "\u{CEA3}",
        nfd: "\u{110F}\u{1162}\u{11BA}",
        nfkc: "\u{CEA3}",
        nfkd: "\u{110F}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CEA4}",
        nfc: "\u{CEA4}",
        nfd: "\u{110F}\u{1162}\u{11BB}",
        nfkc: "\u{CEA4}",
        nfkd: "\u{110F}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CEA5}",
        nfc: "\u{CEA5}",
        nfd: "\u{110F}\u{1162}\u{11BC}",
        nfkc: "\u{CEA5}",
        nfkd: "\u{110F}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CEA6}",
        nfc: "\u{CEA6}",
        nfd: "\u{110F}\u{1162}\u{11BD}",
        nfkc: "\u{CEA6}",
        nfkd: "\u{110F}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CEA7}",
        nfc: "\u{CEA7}",
        nfd: "\u{110F}\u{1162}\u{11BE}",
        nfkc: "\u{CEA7}",
        nfkd: "\u{110F}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CEA8}",
        nfc: "\u{CEA8}",
        nfd: "\u{110F}\u{1162}\u{11BF}",
        nfkc: "\u{CEA8}",
        nfkd: "\u{110F}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CEA9}",
        nfc: "\u{CEA9}",
        nfd: "\u{110F}\u{1162}\u{11C0}",
        nfkc: "\u{CEA9}",
        nfkd: "\u{110F}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CEAA}",
        nfc: "\u{CEAA}",
        nfd: "\u{110F}\u{1162}\u{11C1}",
        nfkc: "\u{CEAA}",
        nfkd: "\u{110F}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CEAB}",
        nfc: "\u{CEAB}",
        nfd: "\u{110F}\u{1162}\u{11C2}",
        nfkc: "\u{CEAB}",
        nfkd: "\u{110F}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CEAC}",
        nfc: "\u{CEAC}",
        nfd: "\u{110F}\u{1163}",
        nfkc: "\u{CEAC}",
        nfkd: "\u{110F}\u{1163}",
    },
    NormalizationTest {
        source: "\u{CEAD}",
        nfc: "\u{CEAD}",
        nfd: "\u{110F}\u{1163}\u{11A8}",
        nfkc: "\u{CEAD}",
        nfkd: "\u{110F}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CEAE}",
        nfc: "\u{CEAE}",
        nfd: "\u{110F}\u{1163}\u{11A9}",
        nfkc: "\u{CEAE}",
        nfkd: "\u{110F}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CEAF}",
        nfc: "\u{CEAF}",
        nfd: "\u{110F}\u{1163}\u{11AA}",
        nfkc: "\u{CEAF}",
        nfkd: "\u{110F}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CEB0}",
        nfc: "\u{CEB0}",
        nfd: "\u{110F}\u{1163}\u{11AB}",
        nfkc: "\u{CEB0}",
        nfkd: "\u{110F}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CEB1}",
        nfc: "\u{CEB1}",
        nfd: "\u{110F}\u{1163}\u{11AC}",
        nfkc: "\u{CEB1}",
        nfkd: "\u{110F}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CEB2}",
        nfc: "\u{CEB2}",
        nfd: "\u{110F}\u{1163}\u{11AD}",
        nfkc: "\u{CEB2}",
        nfkd: "\u{110F}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CEB3}",
        nfc: "\u{CEB3}",
        nfd: "\u{110F}\u{1163}\u{11AE}",
        nfkc: "\u{CEB3}",
        nfkd: "\u{110F}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CEB4}",
        nfc: "\u{CEB4}",
        nfd: "\u{110F}\u{1163}\u{11AF}",
        nfkc: "\u{CEB4}",
        nfkd: "\u{110F}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CEB5}",
        nfc: "\u{CEB5}",
        nfd: "\u{110F}\u{1163}\u{11B0}",
        nfkc: "\u{CEB5}",
        nfkd: "\u{110F}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CEB6}",
        nfc: "\u{CEB6}",
        nfd: "\u{110F}\u{1163}\u{11B1}",
        nfkc: "\u{CEB6}",
        nfkd: "\u{110F}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CEB7}",
        nfc: "\u{CEB7}",
        nfd: "\u{110F}\u{1163}\u{11B2}",
        nfkc: "\u{CEB7}",
        nfkd: "\u{110F}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CEB8}",
        nfc: "\u{CEB8}",
        nfd: "\u{110F}\u{1163}\u{11B3}",
        nfkc: "\u{CEB8}",
        nfkd: "\u{110F}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CEB9}",
        nfc: "\u{CEB9}",
        nfd: "\u{110F}\u{1163}\u{11B4}",
        nfkc: "\u{CEB9}",
        nfkd: "\u{110F}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CEBA}",
        nfc: "\u{CEBA}",
        nfd: "\u{110F}\u{1163}\u{11B5}",
        nfkc: "\u{CEBA}",
        nfkd: "\u{110F}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CEBB}",
        nfc: "\u{CEBB}",
        nfd: "\u{110F}\u{1163}\u{11B6}",
        nfkc: "\u{CEBB}",
        nfkd: "\u{110F}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CEBC}",
        nfc: "\u{CEBC}",
        nfd: "\u{110F}\u{1163}\u{11B7}",
        nfkc: "\u{CEBC}",
        nfkd: "\u{110F}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CEBD}",
        nfc: "\u{CEBD}",
        nfd: "\u{110F}\u{1163}\u{11B8}",
        nfkc: "\u{CEBD}",
        nfkd: "\u{110F}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CEBE}",
        nfc: "\u{CEBE}",
        nfd: "\u{110F}\u{1163}\u{11B9}",
        nfkc: "\u{CEBE}",
        nfkd: "\u{110F}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CEBF}",
        nfc: "\u{CEBF}",
        nfd: "\u{110F}\u{1163}\u{11BA}",
        nfkc: "\u{CEBF}",
        nfkd: "\u{110F}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CEC0}",
        nfc: "\u{CEC0}",
        nfd: "\u{110F}\u{1163}\u{11BB}",
        nfkc: "\u{CEC0}",
        nfkd: "\u{110F}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CEC1}",
        nfc: "\u{CEC1}",
        nfd: "\u{110F}\u{1163}\u{11BC}",
        nfkc: "\u{CEC1}",
        nfkd: "\u{110F}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CEC2}",
        nfc: "\u{CEC2}",
        nfd: "\u{110F}\u{1163}\u{11BD}",
        nfkc: "\u{CEC2}",
        nfkd: "\u{110F}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CEC3}",
        nfc: "\u{CEC3}",
        nfd: "\u{110F}\u{1163}\u{11BE}",
        nfkc: "\u{CEC3}",
        nfkd: "\u{110F}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CEC4}",
        nfc: "\u{CEC4}",
        nfd: "\u{110F}\u{1163}\u{11BF}",
        nfkc: "\u{CEC4}",
        nfkd: "\u{110F}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CEC5}",
        nfc: "\u{CEC5}",
        nfd: "\u{110F}\u{1163}\u{11C0}",
        nfkc: "\u{CEC5}",
        nfkd: "\u{110F}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CEC6}",
        nfc: "\u{CEC6}",
        nfd: "\u{110F}\u{1163}\u{11C1}",
        nfkc: "\u{CEC6}",
        nfkd: "\u{110F}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CEC7}",
        nfc: "\u{CEC7}",
        nfd: "\u{110F}\u{1163}\u{11C2}",
        nfkc: "\u{CEC7}",
        nfkd: "\u{110F}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CEC8}",
        nfc: "\u{CEC8}",
        nfd: "\u{110F}\u{1164}",
        nfkc: "\u{CEC8}",
        nfkd: "\u{110F}\u{1164}",
    },
    NormalizationTest {
        source: "\u{CEC9}",
        nfc: "\u{CEC9}",
        nfd: "\u{110F}\u{1164}\u{11A8}",
        nfkc: "\u{CEC9}",
        nfkd: "\u{110F}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CECA}",
        nfc: "\u{CECA}",
        nfd: "\u{110F}\u{1164}\u{11A9}",
        nfkc: "\u{CECA}",
        nfkd: "\u{110F}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CECB}",
        nfc: "\u{CECB}",
        nfd: "\u{110F}\u{1164}\u{11AA}",
        nfkc: "\u{CECB}",
        nfkd: "\u{110F}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CECC}",
        nfc: "\u{CECC}",
        nfd: "\u{110F}\u{1164}\u{11AB}",
        nfkc: "\u{CECC}",
        nfkd: "\u{110F}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CECD}",
        nfc: "\u{CECD}",
        nfd: "\u{110F}\u{1164}\u{11AC}",
        nfkc: "\u{CECD}",
        nfkd: "\u{110F}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CECE}",
        nfc: "\u{CECE}",
        nfd: "\u{110F}\u{1164}\u{11AD}",
        nfkc: "\u{CECE}",
        nfkd: "\u{110F}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CECF}",
        nfc: "\u{CECF}",
        nfd: "\u{110F}\u{1164}\u{11AE}",
        nfkc: "\u{CECF}",
        nfkd: "\u{110F}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CED0}",
        nfc: "\u{CED0}",
        nfd: "\u{110F}\u{1164}\u{11AF}",
        nfkc: "\u{CED0}",
        nfkd: "\u{110F}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CED1}",
        nfc: "\u{CED1}",
        nfd: "\u{110F}\u{1164}\u{11B0}",
        nfkc: "\u{CED1}",
        nfkd: "\u{110F}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CED2}",
        nfc: "\u{CED2}",
        nfd: "\u{110F}\u{1164}\u{11B1}",
        nfkc: "\u{CED2}",
        nfkd: "\u{110F}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CED3}",
        nfc: "\u{CED3}",
        nfd: "\u{110F}\u{1164}\u{11B2}",
        nfkc: "\u{CED3}",
        nfkd: "\u{110F}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CED4}",
        nfc: "\u{CED4}",
        nfd: "\u{110F}\u{1164}\u{11B3}",
        nfkc: "\u{CED4}",
        nfkd: "\u{110F}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CED5}",
        nfc: "\u{CED5}",
        nfd: "\u{110F}\u{1164}\u{11B4}",
        nfkc: "\u{CED5}",
        nfkd: "\u{110F}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CED6}",
        nfc: "\u{CED6}",
        nfd: "\u{110F}\u{1164}\u{11B5}",
        nfkc: "\u{CED6}",
        nfkd: "\u{110F}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CED7}",
        nfc: "\u{CED7}",
        nfd: "\u{110F}\u{1164}\u{11B6}",
        nfkc: "\u{CED7}",
        nfkd: "\u{110F}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CED8}",
        nfc: "\u{CED8}",
        nfd: "\u{110F}\u{1164}\u{11B7}",
        nfkc: "\u{CED8}",
        nfkd: "\u{110F}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CED9}",
        nfc: "\u{CED9}",
        nfd: "\u{110F}\u{1164}\u{11B8}",
        nfkc: "\u{CED9}",
        nfkd: "\u{110F}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CEDA}",
        nfc: "\u{CEDA}",
        nfd: "\u{110F}\u{1164}\u{11B9}",
        nfkc: "\u{CEDA}",
        nfkd: "\u{110F}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CEDB}",
        nfc: "\u{CEDB}",
        nfd: "\u{110F}\u{1164}\u{11BA}",
        nfkc: "\u{CEDB}",
        nfkd: "\u{110F}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CEDC}",
        nfc: "\u{CEDC}",
        nfd: "\u{110F}\u{1164}\u{11BB}",
        nfkc: "\u{CEDC}",
        nfkd: "\u{110F}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CEDD}",
        nfc: "\u{CEDD}",
        nfd: "\u{110F}\u{1164}\u{11BC}",
        nfkc: "\u{CEDD}",
        nfkd: "\u{110F}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CEDE}",
        nfc: "\u{CEDE}",
        nfd: "\u{110F}\u{1164}\u{11BD}",
        nfkc: "\u{CEDE}",
        nfkd: "\u{110F}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CEDF}",
        nfc: "\u{CEDF}",
        nfd: "\u{110F}\u{1164}\u{11BE}",
        nfkc: "\u{CEDF}",
        nfkd: "\u{110F}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CEE0}",
        nfc: "\u{CEE0}",
        nfd: "\u{110F}\u{1164}\u{11BF}",
        nfkc: "\u{CEE0}",
        nfkd: "\u{110F}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CEE1}",
        nfc: "\u{CEE1}",
        nfd: "\u{110F}\u{1164}\u{11C0}",
        nfkc: "\u{CEE1}",
        nfkd: "\u{110F}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CEE2}",
        nfc: "\u{CEE2}",
        nfd: "\u{110F}\u{1164}\u{11C1}",
        nfkc: "\u{CEE2}",
        nfkd: "\u{110F}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CEE3}",
        nfc: "\u{CEE3}",
        nfd: "\u{110F}\u{1164}\u{11C2}",
        nfkc: "\u{CEE3}",
        nfkd: "\u{110F}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CEE4}",
        nfc: "\u{CEE4}",
        nfd: "\u{110F}\u{1165}",
        nfkc: "\u{CEE4}",
        nfkd: "\u{110F}\u{1165}",
    },
    NormalizationTest {
        source: "\u{CEE5}",
        nfc: "\u{CEE5}",
        nfd: "\u{110F}\u{1165}\u{11A8}",
        nfkc: "\u{CEE5}",
        nfkd: "\u{110F}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CEE6}",
        nfc: "\u{CEE6}",
        nfd: "\u{110F}\u{1165}\u{11A9}",
        nfkc: "\u{CEE6}",
        nfkd: "\u{110F}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CEE7}",
        nfc: "\u{CEE7}",
        nfd: "\u{110F}\u{1165}\u{11AA}",
        nfkc: "\u{CEE7}",
        nfkd: "\u{110F}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CEE8}",
        nfc: "\u{CEE8}",
        nfd: "\u{110F}\u{1165}\u{11AB}",
        nfkc: "\u{CEE8}",
        nfkd: "\u{110F}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CEE9}",
        nfc: "\u{CEE9}",
        nfd: "\u{110F}\u{1165}\u{11AC}",
        nfkc: "\u{CEE9}",
        nfkd: "\u{110F}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CEEA}",
        nfc: "\u{CEEA}",
        nfd: "\u{110F}\u{1165}\u{11AD}",
        nfkc: "\u{CEEA}",
        nfkd: "\u{110F}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CEEB}",
        nfc: "\u{CEEB}",
        nfd: "\u{110F}\u{1165}\u{11AE}",
        nfkc: "\u{CEEB}",
        nfkd: "\u{110F}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CEEC}",
        nfc: "\u{CEEC}",
        nfd: "\u{110F}\u{1165}\u{11AF}",
        nfkc: "\u{CEEC}",
        nfkd: "\u{110F}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CEED}",
        nfc: "\u{CEED}",
        nfd: "\u{110F}\u{1165}\u{11B0}",
        nfkc: "\u{CEED}",
        nfkd: "\u{110F}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CEEE}",
        nfc: "\u{CEEE}",
        nfd: "\u{110F}\u{1165}\u{11B1}",
        nfkc: "\u{CEEE}",
        nfkd: "\u{110F}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CEEF}",
        nfc: "\u{CEEF}",
        nfd: "\u{110F}\u{1165}\u{11B2}",
        nfkc: "\u{CEEF}",
        nfkd: "\u{110F}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CEF0}",
        nfc: "\u{CEF0}",
        nfd: "\u{110F}\u{1165}\u{11B3}",
        nfkc: "\u{CEF0}",
        nfkd: "\u{110F}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CEF1}",
        nfc: "\u{CEF1}",
        nfd: "\u{110F}\u{1165}\u{11B4}",
        nfkc: "\u{CEF1}",
        nfkd: "\u{110F}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CEF2}",
        nfc: "\u{CEF2}",
        nfd: "\u{110F}\u{1165}\u{11B5}",
        nfkc: "\u{CEF2}",
        nfkd: "\u{110F}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CEF3}",
        nfc: "\u{CEF3}",
        nfd: "\u{110F}\u{1165}\u{11B6}",
        nfkc: "\u{CEF3}",
        nfkd: "\u{110F}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CEF4}",
        nfc: "\u{CEF4}",
        nfd: "\u{110F}\u{1165}\u{11B7}",
        nfkc: "\u{CEF4}",
        nfkd: "\u{110F}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CEF5}",
        nfc: "\u{CEF5}",
        nfd: "\u{110F}\u{1165}\u{11B8}",
        nfkc: "\u{CEF5}",
        nfkd: "\u{110F}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CEF6}",
        nfc: "\u{CEF6}",
        nfd: "\u{110F}\u{1165}\u{11B9}",
        nfkc: "\u{CEF6}",
        nfkd: "\u{110F}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CEF7}",
        nfc: "\u{CEF7}",
        nfd: "\u{110F}\u{1165}\u{11BA}",
        nfkc: "\u{CEF7}",
        nfkd: "\u{110F}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CEF8}",
        nfc: "\u{CEF8}",
        nfd: "\u{110F}\u{1165}\u{11BB}",
        nfkc: "\u{CEF8}",
        nfkd: "\u{110F}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CEF9}",
        nfc: "\u{CEF9}",
        nfd: "\u{110F}\u{1165}\u{11BC}",
        nfkc: "\u{CEF9}",
        nfkd: "\u{110F}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CEFA}",
        nfc: "\u{CEFA}",
        nfd: "\u{110F}\u{1165}\u{11BD}",
        nfkc: "\u{CEFA}",
        nfkd: "\u{110F}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CEFB}",
        nfc: "\u{CEFB}",
        nfd: "\u{110F}\u{1165}\u{11BE}",
        nfkc: "\u{CEFB}",
        nfkd: "\u{110F}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CEFC}",
        nfc: "\u{CEFC}",
        nfd: "\u{110F}\u{1165}\u{11BF}",
        nfkc: "\u{CEFC}",
        nfkd: "\u{110F}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CEFD}",
        nfc: "\u{CEFD}",
        nfd: "\u{110F}\u{1165}\u{11C0}",
        nfkc: "\u{CEFD}",
        nfkd: "\u{110F}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CEFE}",
        nfc: "\u{CEFE}",
        nfd: "\u{110F}\u{1165}\u{11C1}",
        nfkc: "\u{CEFE}",
        nfkd: "\u{110F}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CEFF}",
        nfc: "\u{CEFF}",
        nfd: "\u{110F}\u{1165}\u{11C2}",
        nfkc: "\u{CEFF}",
        nfkd: "\u{110F}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CF00}",
        nfc: "\u{CF00}",
        nfd: "\u{110F}\u{1166}",
        nfkc: "\u{CF00}",
        nfkd: "\u{110F}\u{1166}",
    },
    NormalizationTest {
        source: "\u{CF01}",
        nfc: "\u{CF01}",
        nfd: "\u{110F}\u{1166}\u{11A8}",
        nfkc: "\u{CF01}",
        nfkd: "\u{110F}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CF02}",
        nfc: "\u{CF02}",
        nfd: "\u{110F}\u{1166}\u{11A9}",
        nfkc: "\u{CF02}",
        nfkd: "\u{110F}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CF03}",
        nfc: "\u{CF03}",
        nfd: "\u{110F}\u{1166}\u{11AA}",
        nfkc: "\u{CF03}",
        nfkd: "\u{110F}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CF04}",
        nfc: "\u{CF04}",
        nfd: "\u{110F}\u{1166}\u{11AB}",
        nfkc: "\u{CF04}",
        nfkd: "\u{110F}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CF05}",
        nfc: "\u{CF05}",
        nfd: "\u{110F}\u{1166}\u{11AC}",
        nfkc: "\u{CF05}",
        nfkd: "\u{110F}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CF06}",
        nfc: "\u{CF06}",
        nfd: "\u{110F}\u{1166}\u{11AD}",
        nfkc: "\u{CF06}",
        nfkd: "\u{110F}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CF07}",
        nfc: "\u{CF07}",
        nfd: "\u{110F}\u{1166}\u{11AE}",
        nfkc: "\u{CF07}",
        nfkd: "\u{110F}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CF08}",
        nfc: "\u{CF08}",
        nfd: "\u{110F}\u{1166}\u{11AF}",
        nfkc: "\u{CF08}",
        nfkd: "\u{110F}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CF09}",
        nfc: "\u{CF09}",
        nfd: "\u{110F}\u{1166}\u{11B0}",
        nfkc: "\u{CF09}",
        nfkd: "\u{110F}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CF0A}",
        nfc: "\u{CF0A}",
        nfd: "\u{110F}\u{1166}\u{11B1}",
        nfkc: "\u{CF0A}",
        nfkd: "\u{110F}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CF0B}",
        nfc: "\u{CF0B}",
        nfd: "\u{110F}\u{1166}\u{11B2}",
        nfkc: "\u{CF0B}",
        nfkd: "\u{110F}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CF0C}",
        nfc: "\u{CF0C}",
        nfd: "\u{110F}\u{1166}\u{11B3}",
        nfkc: "\u{CF0C}",
        nfkd: "\u{110F}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CF0D}",
        nfc: "\u{CF0D}",
        nfd: "\u{110F}\u{1166}\u{11B4}",
        nfkc: "\u{CF0D}",
        nfkd: "\u{110F}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CF0E}",
        nfc: "\u{CF0E}",
        nfd: "\u{110F}\u{1166}\u{11B5}",
        nfkc: "\u{CF0E}",
        nfkd: "\u{110F}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CF0F}",
        nfc: "\u{CF0F}",
        nfd: "\u{110F}\u{1166}\u{11B6}",
        nfkc: "\u{CF0F}",
        nfkd: "\u{110F}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CF10}",
        nfc: "\u{CF10}",
        nfd: "\u{110F}\u{1166}\u{11B7}",
        nfkc: "\u{CF10}",
        nfkd: "\u{110F}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CF11}",
        nfc: "\u{CF11}",
        nfd: "\u{110F}\u{1166}\u{11B8}",
        nfkc: "\u{CF11}",
        nfkd: "\u{110F}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CF12}",
        nfc: "\u{CF12}",
        nfd: "\u{110F}\u{1166}\u{11B9}",
        nfkc: "\u{CF12}",
        nfkd: "\u{110F}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CF13}",
        nfc: "\u{CF13}",
        nfd: "\u{110F}\u{1166}\u{11BA}",
        nfkc: "\u{CF13}",
        nfkd: "\u{110F}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CF14}",
        nfc: "\u{CF14}",
        nfd: "\u{110F}\u{1166}\u{11BB}",
        nfkc: "\u{CF14}",
        nfkd: "\u{110F}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CF15}",
        nfc: "\u{CF15}",
        nfd: "\u{110F}\u{1166}\u{11BC}",
        nfkc: "\u{CF15}",
        nfkd: "\u{110F}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CF16}",
        nfc: "\u{CF16}",
        nfd: "\u{110F}\u{1166}\u{11BD}",
        nfkc: "\u{CF16}",
        nfkd: "\u{110F}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CF17}",
        nfc: "\u{CF17}",
        nfd: "\u{110F}\u{1166}\u{11BE}",
        nfkc: "\u{CF17}",
        nfkd: "\u{110F}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CF18}",
        nfc: "\u{CF18}",
        nfd: "\u{110F}\u{1166}\u{11BF}",
        nfkc: "\u{CF18}",
        nfkd: "\u{110F}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CF19}",
        nfc: "\u{CF19}",
        nfd: "\u{110F}\u{1166}\u{11C0}",
        nfkc: "\u{CF19}",
        nfkd: "\u{110F}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CF1A}",
        nfc: "\u{CF1A}",
        nfd: "\u{110F}\u{1166}\u{11C1}",
        nfkc: "\u{CF1A}",
        nfkd: "\u{110F}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CF1B}",
        nfc: "\u{CF1B}",
        nfd: "\u{110F}\u{1166}\u{11C2}",
        nfkc: "\u{CF1B}",
        nfkd: "\u{110F}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CF1C}",
        nfc: "\u{CF1C}",
        nfd: "\u{110F}\u{1167}",
        nfkc: "\u{CF1C}",
        nfkd: "\u{110F}\u{1167}",
    },
    NormalizationTest {
        source: "\u{CF1D}",
        nfc: "\u{CF1D}",
        nfd: "\u{110F}\u{1167}\u{11A8}",
        nfkc: "\u{CF1D}",
        nfkd: "\u{110F}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CF1E}",
        nfc: "\u{CF1E}",
        nfd: "\u{110F}\u{1167}\u{11A9}",
        nfkc: "\u{CF1E}",
        nfkd: "\u{110F}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CF1F}",
        nfc: "\u{CF1F}",
        nfd: "\u{110F}\u{1167}\u{11AA}",
        nfkc: "\u{CF1F}",
        nfkd: "\u{110F}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CF20}",
        nfc: "\u{CF20}",
        nfd: "\u{110F}\u{1167}\u{11AB}",
        nfkc: "\u{CF20}",
        nfkd: "\u{110F}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CF21}",
        nfc: "\u{CF21}",
        nfd: "\u{110F}\u{1167}\u{11AC}",
        nfkc: "\u{CF21}",
        nfkd: "\u{110F}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CF22}",
        nfc: "\u{CF22}",
        nfd: "\u{110F}\u{1167}\u{11AD}",
        nfkc: "\u{CF22}",
        nfkd: "\u{110F}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CF23}",
        nfc: "\u{CF23}",
        nfd: "\u{110F}\u{1167}\u{11AE}",
        nfkc: "\u{CF23}",
        nfkd: "\u{110F}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CF24}",
        nfc: "\u{CF24}",
        nfd: "\u{110F}\u{1167}\u{11AF}",
        nfkc: "\u{CF24}",
        nfkd: "\u{110F}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CF25}",
        nfc: "\u{CF25}",
        nfd: "\u{110F}\u{1167}\u{11B0}",
        nfkc: "\u{CF25}",
        nfkd: "\u{110F}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CF26}",
        nfc: "\u{CF26}",
        nfd: "\u{110F}\u{1167}\u{11B1}",
        nfkc: "\u{CF26}",
        nfkd: "\u{110F}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CF27}",
        nfc: "\u{CF27}",
        nfd: "\u{110F}\u{1167}\u{11B2}",
        nfkc: "\u{CF27}",
        nfkd: "\u{110F}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CF28}",
        nfc: "\u{CF28}",
        nfd: "\u{110F}\u{1167}\u{11B3}",
        nfkc: "\u{CF28}",
        nfkd: "\u{110F}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CF29}",
        nfc: "\u{CF29}",
        nfd: "\u{110F}\u{1167}\u{11B4}",
        nfkc: "\u{CF29}",
        nfkd: "\u{110F}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CF2A}",
        nfc: "\u{CF2A}",
        nfd: "\u{110F}\u{1167}\u{11B5}",
        nfkc: "\u{CF2A}",
        nfkd: "\u{110F}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CF2B}",
        nfc: "\u{CF2B}",
        nfd: "\u{110F}\u{1167}\u{11B6}",
        nfkc: "\u{CF2B}",
        nfkd: "\u{110F}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CF2C}",
        nfc: "\u{CF2C}",
        nfd: "\u{110F}\u{1167}\u{11B7}",
        nfkc: "\u{CF2C}",
        nfkd: "\u{110F}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CF2D}",
        nfc: "\u{CF2D}",
        nfd: "\u{110F}\u{1167}\u{11B8}",
        nfkc: "\u{CF2D}",
        nfkd: "\u{110F}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CF2E}",
        nfc: "\u{CF2E}",
        nfd: "\u{110F}\u{1167}\u{11B9}",
        nfkc: "\u{CF2E}",
        nfkd: "\u{110F}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CF2F}",
        nfc: "\u{CF2F}",
        nfd: "\u{110F}\u{1167}\u{11BA}",
        nfkc: "\u{CF2F}",
        nfkd: "\u{110F}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CF30}",
        nfc: "\u{CF30}",
        nfd: "\u{110F}\u{1167}\u{11BB}",
        nfkc: "\u{CF30}",
        nfkd: "\u{110F}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CF31}",
        nfc: "\u{CF31}",
        nfd: "\u{110F}\u{1167}\u{11BC}",
        nfkc: "\u{CF31}",
        nfkd: "\u{110F}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CF32}",
        nfc: "\u{CF32}",
        nfd: "\u{110F}\u{1167}\u{11BD}",
        nfkc: "\u{CF32}",
        nfkd: "\u{110F}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CF33}",
        nfc: "\u{CF33}",
        nfd: "\u{110F}\u{1167}\u{11BE}",
        nfkc: "\u{CF33}",
        nfkd: "\u{110F}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CF34}",
        nfc: "\u{CF34}",
        nfd: "\u{110F}\u{1167}\u{11BF}",
        nfkc: "\u{CF34}",
        nfkd: "\u{110F}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CF35}",
        nfc: "\u{CF35}",
        nfd: "\u{110F}\u{1167}\u{11C0}",
        nfkc: "\u{CF35}",
        nfkd: "\u{110F}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CF36}",
        nfc: "\u{CF36}",
        nfd: "\u{110F}\u{1167}\u{11C1}",
        nfkc: "\u{CF36}",
        nfkd: "\u{110F}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CF37}",
        nfc: "\u{CF37}",
        nfd: "\u{110F}\u{1167}\u{11C2}",
        nfkc: "\u{CF37}",
        nfkd: "\u{110F}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CF38}",
        nfc: "\u{CF38}",
        nfd: "\u{110F}\u{1168}",
        nfkc: "\u{CF38}",
        nfkd: "\u{110F}\u{1168}",
    },
    NormalizationTest {
        source: "\u{CF39}",
        nfc: "\u{CF39}",
        nfd: "\u{110F}\u{1168}\u{11A8}",
        nfkc: "\u{CF39}",
        nfkd: "\u{110F}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CF3A}",
        nfc: "\u{CF3A}",
        nfd: "\u{110F}\u{1168}\u{11A9}",
        nfkc: "\u{CF3A}",
        nfkd: "\u{110F}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CF3B}",
        nfc: "\u{CF3B}",
        nfd: "\u{110F}\u{1168}\u{11AA}",
        nfkc: "\u{CF3B}",
        nfkd: "\u{110F}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CF3C}",
        nfc: "\u{CF3C}",
        nfd: "\u{110F}\u{1168}\u{11AB}",
        nfkc: "\u{CF3C}",
        nfkd: "\u{110F}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CF3D}",
        nfc: "\u{CF3D}",
        nfd: "\u{110F}\u{1168}\u{11AC}",
        nfkc: "\u{CF3D}",
        nfkd: "\u{110F}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CF3E}",
        nfc: "\u{CF3E}",
        nfd: "\u{110F}\u{1168}\u{11AD}",
        nfkc: "\u{CF3E}",
        nfkd: "\u{110F}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CF3F}",
        nfc: "\u{CF3F}",
        nfd: "\u{110F}\u{1168}\u{11AE}",
        nfkc: "\u{CF3F}",
        nfkd: "\u{110F}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CF40}",
        nfc: "\u{CF40}",
        nfd: "\u{110F}\u{1168}\u{11AF}",
        nfkc: "\u{CF40}",
        nfkd: "\u{110F}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CF41}",
        nfc: "\u{CF41}",
        nfd: "\u{110F}\u{1168}\u{11B0}",
        nfkc: "\u{CF41}",
        nfkd: "\u{110F}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CF42}",
        nfc: "\u{CF42}",
        nfd: "\u{110F}\u{1168}\u{11B1}",
        nfkc: "\u{CF42}",
        nfkd: "\u{110F}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CF43}",
        nfc: "\u{CF43}",
        nfd: "\u{110F}\u{1168}\u{11B2}",
        nfkc: "\u{CF43}",
        nfkd: "\u{110F}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CF44}",
        nfc: "\u{CF44}",
        nfd: "\u{110F}\u{1168}\u{11B3}",
        nfkc: "\u{CF44}",
        nfkd: "\u{110F}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CF45}",
        nfc: "\u{CF45}",
        nfd: "\u{110F}\u{1168}\u{11B4}",
        nfkc: "\u{CF45}",
        nfkd: "\u{110F}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CF46}",
        nfc: "\u{CF46}",
        nfd: "\u{110F}\u{1168}\u{11B5}",
        nfkc: "\u{CF46}",
        nfkd: "\u{110F}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CF47}",
        nfc: "\u{CF47}",
        nfd: "\u{110F}\u{1168}\u{11B6}",
        nfkc: "\u{CF47}",
        nfkd: "\u{110F}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CF48}",
        nfc: "\u{CF48}",
        nfd: "\u{110F}\u{1168}\u{11B7}",
        nfkc: "\u{CF48}",
        nfkd: "\u{110F}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CF49}",
        nfc: "\u{CF49}",
        nfd: "\u{110F}\u{1168}\u{11B8}",
        nfkc: "\u{CF49}",
        nfkd: "\u{110F}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CF4A}",
        nfc: "\u{CF4A}",
        nfd: "\u{110F}\u{1168}\u{11B9}",
        nfkc: "\u{CF4A}",
        nfkd: "\u{110F}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CF4B}",
        nfc: "\u{CF4B}",
        nfd: "\u{110F}\u{1168}\u{11BA}",
        nfkc: "\u{CF4B}",
        nfkd: "\u{110F}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CF4C}",
        nfc: "\u{CF4C}",
        nfd: "\u{110F}\u{1168}\u{11BB}",
        nfkc: "\u{CF4C}",
        nfkd: "\u{110F}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CF4D}",
        nfc: "\u{CF4D}",
        nfd: "\u{110F}\u{1168}\u{11BC}",
        nfkc: "\u{CF4D}",
        nfkd: "\u{110F}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CF4E}",
        nfc: "\u{CF4E}",
        nfd: "\u{110F}\u{1168}\u{11BD}",
        nfkc: "\u{CF4E}",
        nfkd: "\u{110F}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CF4F}",
        nfc: "\u{CF4F}",
        nfd: "\u{110F}\u{1168}\u{11BE}",
        nfkc: "\u{CF4F}",
        nfkd: "\u{110F}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CF50}",
        nfc: "\u{CF50}",
        nfd: "\u{110F}\u{1168}\u{11BF}",
        nfkc: "\u{CF50}",
        nfkd: "\u{110F}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CF51}",
        nfc: "\u{CF51}",
        nfd: "\u{110F}\u{1168}\u{11C0}",
        nfkc: "\u{CF51}",
        nfkd: "\u{110F}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CF52}",
        nfc: "\u{CF52}",
        nfd: "\u{110F}\u{1168}\u{11C1}",
        nfkc: "\u{CF52}",
        nfkd: "\u{110F}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CF53}",
        nfc: "\u{CF53}",
        nfd: "\u{110F}\u{1168}\u{11C2}",
        nfkc: "\u{CF53}",
        nfkd: "\u{110F}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CF54}",
        nfc: "\u{CF54}",
        nfd: "\u{110F}\u{1169}",
        nfkc: "\u{CF54}",
        nfkd: "\u{110F}\u{1169}",
    },
    NormalizationTest {
        source: "\u{CF55}",
        nfc: "\u{CF55}",
        nfd: "\u{110F}\u{1169}\u{11A8}",
        nfkc: "\u{CF55}",
        nfkd: "\u{110F}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CF56}",
        nfc: "\u{CF56}",
        nfd: "\u{110F}\u{1169}\u{11A9}",
        nfkc: "\u{CF56}",
        nfkd: "\u{110F}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CF57}",
        nfc: "\u{CF57}",
        nfd: "\u{110F}\u{1169}\u{11AA}",
        nfkc: "\u{CF57}",
        nfkd: "\u{110F}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CF58}",
        nfc: "\u{CF58}",
        nfd: "\u{110F}\u{1169}\u{11AB}",
        nfkc: "\u{CF58}",
        nfkd: "\u{110F}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CF59}",
        nfc: "\u{CF59}",
        nfd: "\u{110F}\u{1169}\u{11AC}",
        nfkc: "\u{CF59}",
        nfkd: "\u{110F}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CF5A}",
        nfc: "\u{CF5A}",
        nfd: "\u{110F}\u{1169}\u{11AD}",
        nfkc: "\u{CF5A}",
        nfkd: "\u{110F}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CF5B}",
        nfc: "\u{CF5B}",
        nfd: "\u{110F}\u{1169}\u{11AE}",
        nfkc: "\u{CF5B}",
        nfkd: "\u{110F}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CF5C}",
        nfc: "\u{CF5C}",
        nfd: "\u{110F}\u{1169}\u{11AF}",
        nfkc: "\u{CF5C}",
        nfkd: "\u{110F}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CF5D}",
        nfc: "\u{CF5D}",
        nfd: "\u{110F}\u{1169}\u{11B0}",
        nfkc: "\u{CF5D}",
        nfkd: "\u{110F}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CF5E}",
        nfc: "\u{CF5E}",
        nfd: "\u{110F}\u{1169}\u{11B1}",
        nfkc: "\u{CF5E}",
        nfkd: "\u{110F}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CF5F}",
        nfc: "\u{CF5F}",
        nfd: "\u{110F}\u{1169}\u{11B2}",
        nfkc: "\u{CF5F}",
        nfkd: "\u{110F}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CF60}",
        nfc: "\u{CF60}",
        nfd: "\u{110F}\u{1169}\u{11B3}",
        nfkc: "\u{CF60}",
        nfkd: "\u{110F}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CF61}",
        nfc: "\u{CF61}",
        nfd: "\u{110F}\u{1169}\u{11B4}",
        nfkc: "\u{CF61}",
        nfkd: "\u{110F}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CF62}",
        nfc: "\u{CF62}",
        nfd: "\u{110F}\u{1169}\u{11B5}",
        nfkc: "\u{CF62}",
        nfkd: "\u{110F}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CF63}",
        nfc: "\u{CF63}",
        nfd: "\u{110F}\u{1169}\u{11B6}",
        nfkc: "\u{CF63}",
        nfkd: "\u{110F}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CF64}",
        nfc: "\u{CF64}",
        nfd: "\u{110F}\u{1169}\u{11B7}",
        nfkc: "\u{CF64}",
        nfkd: "\u{110F}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CF65}",
        nfc: "\u{CF65}",
        nfd: "\u{110F}\u{1169}\u{11B8}",
        nfkc: "\u{CF65}",
        nfkd: "\u{110F}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CF66}",
        nfc: "\u{CF66}",
        nfd: "\u{110F}\u{1169}\u{11B9}",
        nfkc: "\u{CF66}",
        nfkd: "\u{110F}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CF67}",
        nfc: "\u{CF67}",
        nfd: "\u{110F}\u{1169}\u{11BA}",
        nfkc: "\u{CF67}",
        nfkd: "\u{110F}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CF68}",
        nfc: "\u{CF68}",
        nfd: "\u{110F}\u{1169}\u{11BB}",
        nfkc: "\u{CF68}",
        nfkd: "\u{110F}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CF69}",
        nfc: "\u{CF69}",
        nfd: "\u{110F}\u{1169}\u{11BC}",
        nfkc: "\u{CF69}",
        nfkd: "\u{110F}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CF6A}",
        nfc: "\u{CF6A}",
        nfd: "\u{110F}\u{1169}\u{11BD}",
        nfkc: "\u{CF6A}",
        nfkd: "\u{110F}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CF6B}",
        nfc: "\u{CF6B}",
        nfd: "\u{110F}\u{1169}\u{11BE}",
        nfkc: "\u{CF6B}",
        nfkd: "\u{110F}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CF6C}",
        nfc: "\u{CF6C}",
        nfd: "\u{110F}\u{1169}\u{11BF}",
        nfkc: "\u{CF6C}",
        nfkd: "\u{110F}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CF6D}",
        nfc: "\u{CF6D}",
        nfd: "\u{110F}\u{1169}\u{11C0}",
        nfkc: "\u{CF6D}",
        nfkd: "\u{110F}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CF6E}",
        nfc: "\u{CF6E}",
        nfd: "\u{110F}\u{1169}\u{11C1}",
        nfkc: "\u{CF6E}",
        nfkd: "\u{110F}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CF6F}",
        nfc: "\u{CF6F}",
        nfd: "\u{110F}\u{1169}\u{11C2}",
        nfkc: "\u{CF6F}",
        nfkd: "\u{110F}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CF70}",
        nfc: "\u{CF70}",
        nfd: "\u{110F}\u{116A}",
        nfkc: "\u{CF70}",
        nfkd: "\u{110F}\u{116A}",
    },
    NormalizationTest {
        source: "\u{CF71}",
        nfc: "\u{CF71}",
        nfd: "\u{110F}\u{116A}\u{11A8}",
        nfkc: "\u{CF71}",
        nfkd: "\u{110F}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CF72}",
        nfc: "\u{CF72}",
        nfd: "\u{110F}\u{116A}\u{11A9}",
        nfkc: "\u{CF72}",
        nfkd: "\u{110F}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CF73}",
        nfc: "\u{CF73}",
        nfd: "\u{110F}\u{116A}\u{11AA}",
        nfkc: "\u{CF73}",
        nfkd: "\u{110F}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CF74}",
        nfc: "\u{CF74}",
        nfd: "\u{110F}\u{116A}\u{11AB}",
        nfkc: "\u{CF74}",
        nfkd: "\u{110F}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CF75}",
        nfc: "\u{CF75}",
        nfd: "\u{110F}\u{116A}\u{11AC}",
        nfkc: "\u{CF75}",
        nfkd: "\u{110F}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CF76}",
        nfc: "\u{CF76}",
        nfd: "\u{110F}\u{116A}\u{11AD}",
        nfkc: "\u{CF76}",
        nfkd: "\u{110F}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CF77}",
        nfc: "\u{CF77}",
        nfd: "\u{110F}\u{116A}\u{11AE}",
        nfkc: "\u{CF77}",
        nfkd: "\u{110F}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CF78}",
        nfc: "\u{CF78}",
        nfd: "\u{110F}\u{116A}\u{11AF}",
        nfkc: "\u{CF78}",
        nfkd: "\u{110F}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CF79}",
        nfc: "\u{CF79}",
        nfd: "\u{110F}\u{116A}\u{11B0}",
        nfkc: "\u{CF79}",
        nfkd: "\u{110F}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CF7A}",
        nfc: "\u{CF7A}",
        nfd: "\u{110F}\u{116A}\u{11B1}",
        nfkc: "\u{CF7A}",
        nfkd: "\u{110F}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CF7B}",
        nfc: "\u{CF7B}",
        nfd: "\u{110F}\u{116A}\u{11B2}",
        nfkc: "\u{CF7B}",
        nfkd: "\u{110F}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CF7C}",
        nfc: "\u{CF7C}",
        nfd: "\u{110F}\u{116A}\u{11B3}",
        nfkc: "\u{CF7C}",
        nfkd: "\u{110F}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CF7D}",
        nfc: "\u{CF7D}",
        nfd: "\u{110F}\u{116A}\u{11B4}",
        nfkc: "\u{CF7D}",
        nfkd: "\u{110F}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CF7E}",
        nfc: "\u{CF7E}",
        nfd: "\u{110F}\u{116A}\u{11B5}",
        nfkc: "\u{CF7E}",
        nfkd: "\u{110F}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CF7F}",
        nfc: "\u{CF7F}",
        nfd: "\u{110F}\u{116A}\u{11B6}",
        nfkc: "\u{CF7F}",
        nfkd: "\u{110F}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CF80}",
        nfc: "\u{CF80}",
        nfd: "\u{110F}\u{116A}\u{11B7}",
        nfkc: "\u{CF80}",
        nfkd: "\u{110F}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CF81}",
        nfc: "\u{CF81}",
        nfd: "\u{110F}\u{116A}\u{11B8}",
        nfkc: "\u{CF81}",
        nfkd: "\u{110F}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CF82}",
        nfc: "\u{CF82}",
        nfd: "\u{110F}\u{116A}\u{11B9}",
        nfkc: "\u{CF82}",
        nfkd: "\u{110F}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CF83}",
        nfc: "\u{CF83}",
        nfd: "\u{110F}\u{116A}\u{11BA}",
        nfkc: "\u{CF83}",
        nfkd: "\u{110F}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CF84}",
        nfc: "\u{CF84}",
        nfd: "\u{110F}\u{116A}\u{11BB}",
        nfkc: "\u{CF84}",
        nfkd: "\u{110F}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CF85}",
        nfc: "\u{CF85}",
        nfd: "\u{110F}\u{116A}\u{11BC}",
        nfkc: "\u{CF85}",
        nfkd: "\u{110F}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CF86}",
        nfc: "\u{CF86}",
        nfd: "\u{110F}\u{116A}\u{11BD}",
        nfkc: "\u{CF86}",
        nfkd: "\u{110F}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CF87}",
        nfc: "\u{CF87}",
        nfd: "\u{110F}\u{116A}\u{11BE}",
        nfkc: "\u{CF87}",
        nfkd: "\u{110F}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CF88}",
        nfc: "\u{CF88}",
        nfd: "\u{110F}\u{116A}\u{11BF}",
        nfkc: "\u{CF88}",
        nfkd: "\u{110F}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CF89}",
        nfc: "\u{CF89}",
        nfd: "\u{110F}\u{116A}\u{11C0}",
        nfkc: "\u{CF89}",
        nfkd: "\u{110F}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CF8A}",
        nfc: "\u{CF8A}",
        nfd: "\u{110F}\u{116A}\u{11C1}",
        nfkc: "\u{CF8A}",
        nfkd: "\u{110F}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CF8B}",
        nfc: "\u{CF8B}",
        nfd: "\u{110F}\u{116A}\u{11C2}",
        nfkc: "\u{CF8B}",
        nfkd: "\u{110F}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CF8C}",
        nfc: "\u{CF8C}",
        nfd: "\u{110F}\u{116B}",
        nfkc: "\u{CF8C}",
        nfkd: "\u{110F}\u{116B}",
    },
    NormalizationTest {
        source: "\u{CF8D}",
        nfc: "\u{CF8D}",
        nfd: "\u{110F}\u{116B}\u{11A8}",
        nfkc: "\u{CF8D}",
        nfkd: "\u{110F}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CF8E}",
        nfc: "\u{CF8E}",
        nfd: "\u{110F}\u{116B}\u{11A9}",
        nfkc: "\u{CF8E}",
        nfkd: "\u{110F}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CF8F}",
        nfc: "\u{CF8F}",
        nfd: "\u{110F}\u{116B}\u{11AA}",
        nfkc: "\u{CF8F}",
        nfkd: "\u{110F}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CF90}",
        nfc: "\u{CF90}",
        nfd: "\u{110F}\u{116B}\u{11AB}",
        nfkc: "\u{CF90}",
        nfkd: "\u{110F}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CF91}",
        nfc: "\u{CF91}",
        nfd: "\u{110F}\u{116B}\u{11AC}",
        nfkc: "\u{CF91}",
        nfkd: "\u{110F}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CF92}",
        nfc: "\u{CF92}",
        nfd: "\u{110F}\u{116B}\u{11AD}",
        nfkc: "\u{CF92}",
        nfkd: "\u{110F}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CF93}",
        nfc: "\u{CF93}",
        nfd: "\u{110F}\u{116B}\u{11AE}",
        nfkc: "\u{CF93}",
        nfkd: "\u{110F}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CF94}",
        nfc: "\u{CF94}",
        nfd: "\u{110F}\u{116B}\u{11AF}",
        nfkc: "\u{CF94}",
        nfkd: "\u{110F}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CF95}",
        nfc: "\u{CF95}",
        nfd: "\u{110F}\u{116B}\u{11B0}",
        nfkc: "\u{CF95}",
        nfkd: "\u{110F}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CF96}",
        nfc: "\u{CF96}",
        nfd: "\u{110F}\u{116B}\u{11B1}",
        nfkc: "\u{CF96}",
        nfkd: "\u{110F}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CF97}",
        nfc: "\u{CF97}",
        nfd: "\u{110F}\u{116B}\u{11B2}",
        nfkc: "\u{CF97}",
        nfkd: "\u{110F}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CF98}",
        nfc: "\u{CF98}",
        nfd: "\u{110F}\u{116B}\u{11B3}",
        nfkc: "\u{CF98}",
        nfkd: "\u{110F}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CF99}",
        nfc: "\u{CF99}",
        nfd: "\u{110F}\u{116B}\u{11B4}",
        nfkc: "\u{CF99}",
        nfkd: "\u{110F}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CF9A}",
        nfc: "\u{CF9A}",
        nfd: "\u{110F}\u{116B}\u{11B5}",
        nfkc: "\u{CF9A}",
        nfkd: "\u{110F}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CF9B}",
        nfc: "\u{CF9B}",
        nfd: "\u{110F}\u{116B}\u{11B6}",
        nfkc: "\u{CF9B}",
        nfkd: "\u{110F}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CF9C}",
        nfc: "\u{CF9C}",
        nfd: "\u{110F}\u{116B}\u{11B7}",
        nfkc: "\u{CF9C}",
        nfkd: "\u{110F}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CF9D}",
        nfc: "\u{CF9D}",
        nfd: "\u{110F}\u{116B}\u{11B8}",
        nfkc: "\u{CF9D}",
        nfkd: "\u{110F}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CF9E}",
        nfc: "\u{CF9E}",
        nfd: "\u{110F}\u{116B}\u{11B9}",
        nfkc: "\u{CF9E}",
        nfkd: "\u{110F}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CF9F}",
        nfc: "\u{CF9F}",
        nfd: "\u{110F}\u{116B}\u{11BA}",
        nfkc: "\u{CF9F}",
        nfkd: "\u{110F}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CFA0}",
        nfc: "\u{CFA0}",
        nfd: "\u{110F}\u{116B}\u{11BB}",
        nfkc: "\u{CFA0}",
        nfkd: "\u{110F}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CFA1}",
        nfc: "\u{CFA1}",
        nfd: "\u{110F}\u{116B}\u{11BC}",
        nfkc: "\u{CFA1}",
        nfkd: "\u{110F}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CFA2}",
        nfc: "\u{CFA2}",
        nfd: "\u{110F}\u{116B}\u{11BD}",
        nfkc: "\u{CFA2}",
        nfkd: "\u{110F}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CFA3}",
        nfc: "\u{CFA3}",
        nfd: "\u{110F}\u{116B}\u{11BE}",
        nfkc: "\u{CFA3}",
        nfkd: "\u{110F}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CFA4}",
        nfc: "\u{CFA4}",
        nfd: "\u{110F}\u{116B}\u{11BF}",
        nfkc: "\u{CFA4}",
        nfkd: "\u{110F}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CFA5}",
        nfc: "\u{CFA5}",
        nfd: "\u{110F}\u{116B}\u{11C0}",
        nfkc: "\u{CFA5}",
        nfkd: "\u{110F}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CFA6}",
        nfc: "\u{CFA6}",
        nfd: "\u{110F}\u{116B}\u{11C1}",
        nfkc: "\u{CFA6}",
        nfkd: "\u{110F}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CFA7}",
        nfc: "\u{CFA7}",
        nfd: "\u{110F}\u{116B}\u{11C2}",
        nfkc: "\u{CFA7}",
        nfkd: "\u{110F}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CFA8}",
        nfc: "\u{CFA8}",
        nfd: "\u{110F}\u{116C}",
        nfkc: "\u{CFA8}",
        nfkd: "\u{110F}\u{116C}",
    },
    NormalizationTest {
        source: "\u{CFA9}",
        nfc: "\u{CFA9}",
        nfd: "\u{110F}\u{116C}\u{11A8}",
        nfkc: "\u{CFA9}",
        nfkd: "\u{110F}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CFAA}",
        nfc: "\u{CFAA}",
        nfd: "\u{110F}\u{116C}\u{11A9}",
        nfkc: "\u{CFAA}",
        nfkd: "\u{110F}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CFAB}",
        nfc: "\u{CFAB}",
        nfd: "\u{110F}\u{116C}\u{11AA}",
        nfkc: "\u{CFAB}",
        nfkd: "\u{110F}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CFAC}",
        nfc: "\u{CFAC}",
        nfd: "\u{110F}\u{116C}\u{11AB}",
        nfkc: "\u{CFAC}",
        nfkd: "\u{110F}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CFAD}",
        nfc: "\u{CFAD}",
        nfd: "\u{110F}\u{116C}\u{11AC}",
        nfkc: "\u{CFAD}",
        nfkd: "\u{110F}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CFAE}",
        nfc: "\u{CFAE}",
        nfd: "\u{110F}\u{116C}\u{11AD}",
        nfkc: "\u{CFAE}",
        nfkd: "\u{110F}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CFAF}",
        nfc: "\u{CFAF}",
        nfd: "\u{110F}\u{116C}\u{11AE}",
        nfkc: "\u{CFAF}",
        nfkd: "\u{110F}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CFB0}",
        nfc: "\u{CFB0}",
        nfd: "\u{110F}\u{116C}\u{11AF}",
        nfkc: "\u{CFB0}",
        nfkd: "\u{110F}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CFB1}",
        nfc: "\u{CFB1}",
        nfd: "\u{110F}\u{116C}\u{11B0}",
        nfkc: "\u{CFB1}",
        nfkd: "\u{110F}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CFB2}",
        nfc: "\u{CFB2}",
        nfd: "\u{110F}\u{116C}\u{11B1}",
        nfkc: "\u{CFB2}",
        nfkd: "\u{110F}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CFB3}",
        nfc: "\u{CFB3}",
        nfd: "\u{110F}\u{116C}\u{11B2}",
        nfkc: "\u{CFB3}",
        nfkd: "\u{110F}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CFB4}",
        nfc: "\u{CFB4}",
        nfd: "\u{110F}\u{116C}\u{11B3}",
        nfkc: "\u{CFB4}",
        nfkd: "\u{110F}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CFB5}",
        nfc: "\u{CFB5}",
        nfd: "\u{110F}\u{116C}\u{11B4}",
        nfkc: "\u{CFB5}",
        nfkd: "\u{110F}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CFB6}",
        nfc: "\u{CFB6}",
        nfd: "\u{110F}\u{116C}\u{11B5}",
        nfkc: "\u{CFB6}",
        nfkd: "\u{110F}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CFB7}",
        nfc: "\u{CFB7}",
        nfd: "\u{110F}\u{116C}\u{11B6}",
        nfkc: "\u{CFB7}",
        nfkd: "\u{110F}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CFB8}",
        nfc: "\u{CFB8}",
        nfd: "\u{110F}\u{116C}\u{11B7}",
        nfkc: "\u{CFB8}",
        nfkd: "\u{110F}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CFB9}",
        nfc: "\u{CFB9}",
        nfd: "\u{110F}\u{116C}\u{11B8}",
        nfkc: "\u{CFB9}",
        nfkd: "\u{110F}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CFBA}",
        nfc: "\u{CFBA}",
        nfd: "\u{110F}\u{116C}\u{11B9}",
        nfkc: "\u{CFBA}",
        nfkd: "\u{110F}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CFBB}",
        nfc: "\u{CFBB}",
        nfd: "\u{110F}\u{116C}\u{11BA}",
        nfkc: "\u{CFBB}",
        nfkd: "\u{110F}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CFBC}",
        nfc: "\u{CFBC}",
        nfd: "\u{110F}\u{116C}\u{11BB}",
        nfkc: "\u{CFBC}",
        nfkd: "\u{110F}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CFBD}",
        nfc: "\u{CFBD}",
        nfd: "\u{110F}\u{116C}\u{11BC}",
        nfkc: "\u{CFBD}",
        nfkd: "\u{110F}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CFBE}",
        nfc: "\u{CFBE}",
        nfd: "\u{110F}\u{116C}\u{11BD}",
        nfkc: "\u{CFBE}",
        nfkd: "\u{110F}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CFBF}",
        nfc: "\u{CFBF}",
        nfd: "\u{110F}\u{116C}\u{11BE}",
        nfkc: "\u{CFBF}",
        nfkd: "\u{110F}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CFC0}",
        nfc: "\u{CFC0}",
        nfd: "\u{110F}\u{116C}\u{11BF}",
        nfkc: "\u{CFC0}",
        nfkd: "\u{110F}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CFC1}",
        nfc: "\u{CFC1}",
        nfd: "\u{110F}\u{116C}\u{11C0}",
        nfkc: "\u{CFC1}",
        nfkd: "\u{110F}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CFC2}",
        nfc: "\u{CFC2}",
        nfd: "\u{110F}\u{116C}\u{11C1}",
        nfkc: "\u{CFC2}",
        nfkd: "\u{110F}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CFC3}",
        nfc: "\u{CFC3}",
        nfd: "\u{110F}\u{116C}\u{11C2}",
        nfkc: "\u{CFC3}",
        nfkd: "\u{110F}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CFC4}",
        nfc: "\u{CFC4}",
        nfd: "\u{110F}\u{116D}",
        nfkc: "\u{CFC4}",
        nfkd: "\u{110F}\u{116D}",
    },
    NormalizationTest {
        source: "\u{CFC5}",
        nfc: "\u{CFC5}",
        nfd: "\u{110F}\u{116D}\u{11A8}",
        nfkc: "\u{CFC5}",
        nfkd: "\u{110F}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CFC6}",
        nfc: "\u{CFC6}",
        nfd: "\u{110F}\u{116D}\u{11A9}",
        nfkc: "\u{CFC6}",
        nfkd: "\u{110F}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CFC7}",
        nfc: "\u{CFC7}",
        nfd: "\u{110F}\u{116D}\u{11AA}",
        nfkc: "\u{CFC7}",
        nfkd: "\u{110F}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CFC8}",
        nfc: "\u{CFC8}",
        nfd: "\u{110F}\u{116D}\u{11AB}",
        nfkc: "\u{CFC8}",
        nfkd: "\u{110F}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CFC9}",
        nfc: "\u{CFC9}",
        nfd: "\u{110F}\u{116D}\u{11AC}",
        nfkc: "\u{CFC9}",
        nfkd: "\u{110F}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CFCA}",
        nfc: "\u{CFCA}",
        nfd: "\u{110F}\u{116D}\u{11AD}",
        nfkc: "\u{CFCA}",
        nfkd: "\u{110F}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CFCB}",
        nfc: "\u{CFCB}",
        nfd: "\u{110F}\u{116D}\u{11AE}",
        nfkc: "\u{CFCB}",
        nfkd: "\u{110F}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CFCC}",
        nfc: "\u{CFCC}",
        nfd: "\u{110F}\u{116D}\u{11AF}",
        nfkc: "\u{CFCC}",
        nfkd: "\u{110F}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CFCD}",
        nfc: "\u{CFCD}",
        nfd: "\u{110F}\u{116D}\u{11B0}",
        nfkc: "\u{CFCD}",
        nfkd: "\u{110F}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CFCE}",
        nfc: "\u{CFCE}",
        nfd: "\u{110F}\u{116D}\u{11B1}",
        nfkc: "\u{CFCE}",
        nfkd: "\u{110F}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CFCF}",
        nfc: "\u{CFCF}",
        nfd: "\u{110F}\u{116D}\u{11B2}",
        nfkc: "\u{CFCF}",
        nfkd: "\u{110F}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CFD0}",
        nfc: "\u{CFD0}",
        nfd: "\u{110F}\u{116D}\u{11B3}",
        nfkc: "\u{CFD0}",
        nfkd: "\u{110F}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CFD1}",
        nfc: "\u{CFD1}",
        nfd: "\u{110F}\u{116D}\u{11B4}",
        nfkc: "\u{CFD1}",
        nfkd: "\u{110F}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CFD2}",
        nfc: "\u{CFD2}",
        nfd: "\u{110F}\u{116D}\u{11B5}",
        nfkc: "\u{CFD2}",
        nfkd: "\u{110F}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CFD3}",
        nfc: "\u{CFD3}",
        nfd: "\u{110F}\u{116D}\u{11B6}",
        nfkc: "\u{CFD3}",
        nfkd: "\u{110F}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CFD4}",
        nfc: "\u{CFD4}",
        nfd: "\u{110F}\u{116D}\u{11B7}",
        nfkc: "\u{CFD4}",
        nfkd: "\u{110F}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CFD5}",
        nfc: "\u{CFD5}",
        nfd: "\u{110F}\u{116D}\u{11B8}",
        nfkc: "\u{CFD5}",
        nfkd: "\u{110F}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CFD6}",
        nfc: "\u{CFD6}",
        nfd: "\u{110F}\u{116D}\u{11B9}",
        nfkc: "\u{CFD6}",
        nfkd: "\u{110F}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CFD7}",
        nfc: "\u{CFD7}",
        nfd: "\u{110F}\u{116D}\u{11BA}",
        nfkc: "\u{CFD7}",
        nfkd: "\u{110F}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CFD8}",
        nfc: "\u{CFD8}",
        nfd: "\u{110F}\u{116D}\u{11BB}",
        nfkc: "\u{CFD8}",
        nfkd: "\u{110F}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CFD9}",
        nfc: "\u{CFD9}",
        nfd: "\u{110F}\u{116D}\u{11BC}",
        nfkc: "\u{CFD9}",
        nfkd: "\u{110F}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CFDA}",
        nfc: "\u{CFDA}",
        nfd: "\u{110F}\u{116D}\u{11BD}",
        nfkc: "\u{CFDA}",
        nfkd: "\u{110F}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CFDB}",
        nfc: "\u{CFDB}",
        nfd: "\u{110F}\u{116D}\u{11BE}",
        nfkc: "\u{CFDB}",
        nfkd: "\u{110F}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CFDC}",
        nfc: "\u{CFDC}",
        nfd: "\u{110F}\u{116D}\u{11BF}",
        nfkc: "\u{CFDC}",
        nfkd: "\u{110F}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CFDD}",
        nfc: "\u{CFDD}",
        nfd: "\u{110F}\u{116D}\u{11C0}",
        nfkc: "\u{CFDD}",
        nfkd: "\u{110F}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CFDE}",
        nfc: "\u{CFDE}",
        nfd: "\u{110F}\u{116D}\u{11C1}",
        nfkc: "\u{CFDE}",
        nfkd: "\u{110F}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CFDF}",
        nfc: "\u{CFDF}",
        nfd: "\u{110F}\u{116D}\u{11C2}",
        nfkc: "\u{CFDF}",
        nfkd: "\u{110F}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CFE0}",
        nfc: "\u{CFE0}",
        nfd: "\u{110F}\u{116E}",
        nfkc: "\u{CFE0}",
        nfkd: "\u{110F}\u{116E}",
    },
    NormalizationTest {
        source: "\u{CFE1}",
        nfc: "\u{CFE1}",
        nfd: "\u{110F}\u{116E}\u{11A8}",
        nfkc: "\u{CFE1}",
        nfkd: "\u{110F}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CFE2}",
        nfc: "\u{CFE2}",
        nfd: "\u{110F}\u{116E}\u{11A9}",
        nfkc: "\u{CFE2}",
        nfkd: "\u{110F}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CFE3}",
        nfc: "\u{CFE3}",
        nfd: "\u{110F}\u{116E}\u{11AA}",
        nfkc: "\u{CFE3}",
        nfkd: "\u{110F}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{CFE4}",
        nfc: "\u{CFE4}",
        nfd: "\u{110F}\u{116E}\u{11AB}",
        nfkc: "\u{CFE4}",
        nfkd: "\u{110F}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{CFE5}",
        nfc: "\u{CFE5}",
        nfd: "\u{110F}\u{116E}\u{11AC}",
        nfkc: "\u{CFE5}",
        nfkd: "\u{110F}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{CFE6}",
        nfc: "\u{CFE6}",
        nfd: "\u{110F}\u{116E}\u{11AD}",
        nfkc: "\u{CFE6}",
        nfkd: "\u{110F}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{CFE7}",
        nfc: "\u{CFE7}",
        nfd: "\u{110F}\u{116E}\u{11AE}",
        nfkc: "\u{CFE7}",
        nfkd: "\u{110F}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CFE8}",
        nfc: "\u{CFE8}",
        nfd: "\u{110F}\u{116E}\u{11AF}",
        nfkc: "\u{CFE8}",
        nfkd: "\u{110F}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{CFE9}",
        nfc: "\u{CFE9}",
        nfd: "\u{110F}\u{116E}\u{11B0}",
        nfkc: "\u{CFE9}",
        nfkd: "\u{110F}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{CFEA}",
        nfc: "\u{CFEA}",
        nfd: "\u{110F}\u{116E}\u{11B1}",
        nfkc: "\u{CFEA}",
        nfkd: "\u{110F}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{CFEB}",
        nfc: "\u{CFEB}",
        nfd: "\u{110F}\u{116E}\u{11B2}",
        nfkc: "\u{CFEB}",
        nfkd: "\u{110F}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{CFEC}",
        nfc: "\u{CFEC}",
        nfd: "\u{110F}\u{116E}\u{11B3}",
        nfkc: "\u{CFEC}",
        nfkd: "\u{110F}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{CFED}",
        nfc: "\u{CFED}",
        nfd: "\u{110F}\u{116E}\u{11B4}",
        nfkc: "\u{CFED}",
        nfkd: "\u{110F}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{CFEE}",
        nfc: "\u{CFEE}",
        nfd: "\u{110F}\u{116E}\u{11B5}",
        nfkc: "\u{CFEE}",
        nfkd: "\u{110F}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CFEF}",
        nfc: "\u{CFEF}",
        nfd: "\u{110F}\u{116E}\u{11B6}",
        nfkc: "\u{CFEF}",
        nfkd: "\u{110F}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{CFF0}",
        nfc: "\u{CFF0}",
        nfd: "\u{110F}\u{116E}\u{11B7}",
        nfkc: "\u{CFF0}",
        nfkd: "\u{110F}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{CFF1}",
        nfc: "\u{CFF1}",
        nfd: "\u{110F}\u{116E}\u{11B8}",
        nfkc: "\u{CFF1}",
        nfkd: "\u{110F}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{CFF2}",
        nfc: "\u{CFF2}",
        nfd: "\u{110F}\u{116E}\u{11B9}",
        nfkc: "\u{CFF2}",
        nfkd: "\u{110F}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{CFF3}",
        nfc: "\u{CFF3}",
        nfd: "\u{110F}\u{116E}\u{11BA}",
        nfkc: "\u{CFF3}",
        nfkd: "\u{110F}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{CFF4}",
        nfc: "\u{CFF4}",
        nfd: "\u{110F}\u{116E}\u{11BB}",
        nfkc: "\u{CFF4}",
        nfkd: "\u{110F}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{CFF5}",
        nfc: "\u{CFF5}",
        nfd: "\u{110F}\u{116E}\u{11BC}",
        nfkc: "\u{CFF5}",
        nfkd: "\u{110F}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CFF6}",
        nfc: "\u{CFF6}",
        nfd: "\u{110F}\u{116E}\u{11BD}",
        nfkc: "\u{CFF6}",
        nfkd: "\u{110F}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{CFF7}",
        nfc: "\u{CFF7}",
        nfd: "\u{110F}\u{116E}\u{11BE}",
        nfkc: "\u{CFF7}",
        nfkd: "\u{110F}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{CFF8}",
        nfc: "\u{CFF8}",
        nfd: "\u{110F}\u{116E}\u{11BF}",
        nfkc: "\u{CFF8}",
        nfkd: "\u{110F}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{CFF9}",
        nfc: "\u{CFF9}",
        nfd: "\u{110F}\u{116E}\u{11C0}",
        nfkc: "\u{CFF9}",
        nfkd: "\u{110F}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{CFFA}",
        nfc: "\u{CFFA}",
        nfd: "\u{110F}\u{116E}\u{11C1}",
        nfkc: "\u{CFFA}",
        nfkd: "\u{110F}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{CFFB}",
        nfc: "\u{CFFB}",
        nfd: "\u{110F}\u{116E}\u{11C2}",
        nfkc: "\u{CFFB}",
        nfkd: "\u{110F}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{CFFC}",
        nfc: "\u{CFFC}",
        nfd: "\u{110F}\u{116F}",
        nfkc: "\u{CFFC}",
        nfkd: "\u{110F}\u{116F}",
    },
    NormalizationTest {
        source: "\u{CFFD}",
        nfc: "\u{CFFD}",
        nfd: "\u{110F}\u{116F}\u{11A8}",
        nfkc: "\u{CFFD}",
        nfkd: "\u{110F}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{CFFE}",
        nfc: "\u{CFFE}",
        nfd: "\u{110F}\u{116F}\u{11A9}",
        nfkc: "\u{CFFE}",
        nfkd: "\u{110F}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{CFFF}",
        nfc: "\u{CFFF}",
        nfd: "\u{110F}\u{116F}\u{11AA}",
        nfkc: "\u{CFFF}",
        nfkd: "\u{110F}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D000}",
        nfc: "\u{D000}",
        nfd: "\u{110F}\u{116F}\u{11AB}",
        nfkc: "\u{D000}",
        nfkd: "\u{110F}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D001}",
        nfc: "\u{D001}",
        nfd: "\u{110F}\u{116F}\u{11AC}",
        nfkc: "\u{D001}",
        nfkd: "\u{110F}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D002}",
        nfc: "\u{D002}",
        nfd: "\u{110F}\u{116F}\u{11AD}",
        nfkc: "\u{D002}",
        nfkd: "\u{110F}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D003}",
        nfc: "\u{D003}",
        nfd: "\u{110F}\u{116F}\u{11AE}",
        nfkc: "\u{D003}",
        nfkd: "\u{110F}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D004}",
        nfc: "\u{D004}",
        nfd: "\u{110F}\u{116F}\u{11AF}",
        nfkc: "\u{D004}",
        nfkd: "\u{110F}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D005}",
        nfc: "\u{D005}",
        nfd: "\u{110F}\u{116F}\u{11B0}",
        nfkc: "\u{D005}",
        nfkd: "\u{110F}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D006}",
        nfc: "\u{D006}",
        nfd: "\u{110F}\u{116F}\u{11B1}",
        nfkc: "\u{D006}",
        nfkd: "\u{110F}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D007}",
        nfc: "\u{D007}",
        nfd: "\u{110F}\u{116F}\u{11B2}",
        nfkc: "\u{D007}",
        nfkd: "\u{110F}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D008}",
        nfc: "\u{D008}",
        nfd: "\u{110F}\u{116F}\u{11B3}",
        nfkc: "\u{D008}",
        nfkd: "\u{110F}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D009}",
        nfc: "\u{D009}",
        nfd: "\u{110F}\u{116F}\u{11B4}",
        nfkc: "\u{D009}",
        nfkd: "\u{110F}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D00A}",
        nfc: "\u{D00A}",
        nfd: "\u{110F}\u{116F}\u{11B5}",
        nfkc: "\u{D00A}",
        nfkd: "\u{110F}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D00B}",
        nfc: "\u{D00B}",
        nfd: "\u{110F}\u{116F}\u{11B6}",
        nfkc: "\u{D00B}",
        nfkd: "\u{110F}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D00C}",
        nfc: "\u{D00C}",
        nfd: "\u{110F}\u{116F}\u{11B7}",
        nfkc: "\u{D00C}",
        nfkd: "\u{110F}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D00D}",
        nfc: "\u{D00D}",
        nfd: "\u{110F}\u{116F}\u{11B8}",
        nfkc: "\u{D00D}",
        nfkd: "\u{110F}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D00E}",
        nfc: "\u{D00E}",
        nfd: "\u{110F}\u{116F}\u{11B9}",
        nfkc: "\u{D00E}",
        nfkd: "\u{110F}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D00F}",
        nfc: "\u{D00F}",
        nfd: "\u{110F}\u{116F}\u{11BA}",
        nfkc: "\u{D00F}",
        nfkd: "\u{110F}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D010}",
        nfc: "\u{D010}",
        nfd: "\u{110F}\u{116F}\u{11BB}",
        nfkc: "\u{D010}",
        nfkd: "\u{110F}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D011}",
        nfc: "\u{D011}",
        nfd: "\u{110F}\u{116F}\u{11BC}",
        nfkc: "\u{D011}",
        nfkd: "\u{110F}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D012}",
        nfc: "\u{D012}",
        nfd: "\u{110F}\u{116F}\u{11BD}",
        nfkc: "\u{D012}",
        nfkd: "\u{110F}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D013}",
        nfc: "\u{D013}",
        nfd: "\u{110F}\u{116F}\u{11BE}",
        nfkc: "\u{D013}",
        nfkd: "\u{110F}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D014}",
        nfc: "\u{D014}",
        nfd: "\u{110F}\u{116F}\u{11BF}",
        nfkc: "\u{D014}",
        nfkd: "\u{110F}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D015}",
        nfc: "\u{D015}",
        nfd: "\u{110F}\u{116F}\u{11C0}",
        nfkc: "\u{D015}",
        nfkd: "\u{110F}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D016}",
        nfc: "\u{D016}",
        nfd: "\u{110F}\u{116F}\u{11C1}",
        nfkc: "\u{D016}",
        nfkd: "\u{110F}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D017}",
        nfc: "\u{D017}",
        nfd: "\u{110F}\u{116F}\u{11C2}",
        nfkc: "\u{D017}",
        nfkd: "\u{110F}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D018}",
        nfc: "\u{D018}",
        nfd: "\u{110F}\u{1170}",
        nfkc: "\u{D018}",
        nfkd: "\u{110F}\u{1170}",
    },
    NormalizationTest {
        source: "\u{D019}",
        nfc: "\u{D019}",
        nfd: "\u{110F}\u{1170}\u{11A8}",
        nfkc: "\u{D019}",
        nfkd: "\u{110F}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D01A}",
        nfc: "\u{D01A}",
        nfd: "\u{110F}\u{1170}\u{11A9}",
        nfkc: "\u{D01A}",
        nfkd: "\u{110F}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D01B}",
        nfc: "\u{D01B}",
        nfd: "\u{110F}\u{1170}\u{11AA}",
        nfkc: "\u{D01B}",
        nfkd: "\u{110F}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D01C}",
        nfc: "\u{D01C}",
        nfd: "\u{110F}\u{1170}\u{11AB}",
        nfkc: "\u{D01C}",
        nfkd: "\u{110F}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D01D}",
        nfc: "\u{D01D}",
        nfd: "\u{110F}\u{1170}\u{11AC}",
        nfkc: "\u{D01D}",
        nfkd: "\u{110F}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D01E}",
        nfc: "\u{D01E}",
        nfd: "\u{110F}\u{1170}\u{11AD}",
        nfkc: "\u{D01E}",
        nfkd: "\u{110F}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D01F}",
        nfc: "\u{D01F}",
        nfd: "\u{110F}\u{1170}\u{11AE}",
        nfkc: "\u{D01F}",
        nfkd: "\u{110F}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D020}",
        nfc: "\u{D020}",
        nfd: "\u{110F}\u{1170}\u{11AF}",
        nfkc: "\u{D020}",
        nfkd: "\u{110F}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D021}",
        nfc: "\u{D021}",
        nfd: "\u{110F}\u{1170}\u{11B0}",
        nfkc: "\u{D021}",
        nfkd: "\u{110F}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D022}",
        nfc: "\u{D022}",
        nfd: "\u{110F}\u{1170}\u{11B1}",
        nfkc: "\u{D022}",
        nfkd: "\u{110F}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D023}",
        nfc: "\u{D023}",
        nfd: "\u{110F}\u{1170}\u{11B2}",
        nfkc: "\u{D023}",
        nfkd: "\u{110F}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D024}",
        nfc: "\u{D024}",
        nfd: "\u{110F}\u{1170}\u{11B3}",
        nfkc: "\u{D024}",
        nfkd: "\u{110F}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D025}",
        nfc: "\u{D025}",
        nfd: "\u{110F}\u{1170}\u{11B4}",
        nfkc: "\u{D025}",
        nfkd: "\u{110F}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D026}",
        nfc: "\u{D026}",
        nfd: "\u{110F}\u{1170}\u{11B5}",
        nfkc: "\u{D026}",
        nfkd: "\u{110F}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D027}",
        nfc: "\u{D027}",
        nfd: "\u{110F}\u{1170}\u{11B6}",
        nfkc: "\u{D027}",
        nfkd: "\u{110F}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D028}",
        nfc: "\u{D028}",
        nfd: "\u{110F}\u{1170}\u{11B7}",
        nfkc: "\u{D028}",
        nfkd: "\u{110F}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D029}",
        nfc: "\u{D029}",
        nfd: "\u{110F}\u{1170}\u{11B8}",
        nfkc: "\u{D029}",
        nfkd: "\u{110F}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D02A}",
        nfc: "\u{D02A}",
        nfd: "\u{110F}\u{1170}\u{11B9}",
        nfkc: "\u{D02A}",
        nfkd: "\u{110F}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D02B}",
        nfc: "\u{D02B}",
        nfd: "\u{110F}\u{1170}\u{11BA}",
        nfkc: "\u{D02B}",
        nfkd: "\u{110F}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D02C}",
        nfc: "\u{D02C}",
        nfd: "\u{110F}\u{1170}\u{11BB}",
        nfkc: "\u{D02C}",
        nfkd: "\u{110F}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D02D}",
        nfc: "\u{D02D}",
        nfd: "\u{110F}\u{1170}\u{11BC}",
        nfkc: "\u{D02D}",
        nfkd: "\u{110F}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D02E}",
        nfc: "\u{D02E}",
        nfd: "\u{110F}\u{1170}\u{11BD}",
        nfkc: "\u{D02E}",
        nfkd: "\u{110F}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D02F}",
        nfc: "\u{D02F}",
        nfd: "\u{110F}\u{1170}\u{11BE}",
        nfkc: "\u{D02F}",
        nfkd: "\u{110F}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D030}",
        nfc: "\u{D030}",
        nfd: "\u{110F}\u{1170}\u{11BF}",
        nfkc: "\u{D030}",
        nfkd: "\u{110F}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D031}",
        nfc: "\u{D031}",
        nfd: "\u{110F}\u{1170}\u{11C0}",
        nfkc: "\u{D031}",
        nfkd: "\u{110F}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D032}",
        nfc: "\u{D032}",
        nfd: "\u{110F}\u{1170}\u{11C1}",
        nfkc: "\u{D032}",
        nfkd: "\u{110F}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D033}",
        nfc: "\u{D033}",
        nfd: "\u{110F}\u{1170}\u{11C2}",
        nfkc: "\u{D033}",
        nfkd: "\u{110F}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D034}",
        nfc: "\u{D034}",
        nfd: "\u{110F}\u{1171}",
        nfkc: "\u{D034}",
        nfkd: "\u{110F}\u{1171}",
    },
    NormalizationTest {
        source: "\u{D035}",
        nfc: "\u{D035}",
        nfd: "\u{110F}\u{1171}\u{11A8}",
        nfkc: "\u{D035}",
        nfkd: "\u{110F}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D036}",
        nfc: "\u{D036}",
        nfd: "\u{110F}\u{1171}\u{11A9}",
        nfkc: "\u{D036}",
        nfkd: "\u{110F}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D037}",
        nfc: "\u{D037}",
        nfd: "\u{110F}\u{1171}\u{11AA}",
        nfkc: "\u{D037}",
        nfkd: "\u{110F}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D038}",
        nfc: "\u{D038}",
        nfd: "\u{110F}\u{1171}\u{11AB}",
        nfkc: "\u{D038}",
        nfkd: "\u{110F}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D039}",
        nfc: "\u{D039}",
        nfd: "\u{110F}\u{1171}\u{11AC}",
        nfkc: "\u{D039}",
        nfkd: "\u{110F}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D03A}",
        nfc: "\u{D03A}",
        nfd: "\u{110F}\u{1171}\u{11AD}",
        nfkc: "\u{D03A}",
        nfkd: "\u{110F}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D03B}",
        nfc: "\u{D03B}",
        nfd: "\u{110F}\u{1171}\u{11AE}",
        nfkc: "\u{D03B}",
        nfkd: "\u{110F}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D03C}",
        nfc: "\u{D03C}",
        nfd: "\u{110F}\u{1171}\u{11AF}",
        nfkc: "\u{D03C}",
        nfkd: "\u{110F}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D03D}",
        nfc: "\u{D03D}",
        nfd: "\u{110F}\u{1171}\u{11B0}",
        nfkc: "\u{D03D}",
        nfkd: "\u{110F}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D03E}",
        nfc: "\u{D03E}",
        nfd: "\u{110F}\u{1171}\u{11B1}",
        nfkc: "\u{D03E}",
        nfkd: "\u{110F}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D03F}",
        nfc: "\u{D03F}",
        nfd: "\u{110F}\u{1171}\u{11B2}",
        nfkc: "\u{D03F}",
        nfkd: "\u{110F}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D040}",
        nfc: "\u{D040}",
        nfd: "\u{110F}\u{1171}\u{11B3}",
        nfkc: "\u{D040}",
        nfkd: "\u{110F}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D041}",
        nfc: "\u{D041}",
        nfd: "\u{110F}\u{1171}\u{11B4}",
        nfkc: "\u{D041}",
        nfkd: "\u{110F}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D042}",
        nfc: "\u{D042}",
        nfd: "\u{110F}\u{1171}\u{11B5}",
        nfkc: "\u{D042}",
        nfkd: "\u{110F}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D043}",
        nfc: "\u{D043}",
        nfd: "\u{110F}\u{1171}\u{11B6}",
        nfkc: "\u{D043}",
        nfkd: "\u{110F}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D044}",
        nfc: "\u{D044}",
        nfd: "\u{110F}\u{1171}\u{11B7}",
        nfkc: "\u{D044}",
        nfkd: "\u{110F}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D045}",
        nfc: "\u{D045}",
        nfd: "\u{110F}\u{1171}\u{11B8}",
        nfkc: "\u{D045}",
        nfkd: "\u{110F}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D046}",
        nfc: "\u{D046}",
        nfd: "\u{110F}\u{1171}\u{11B9}",
        nfkc: "\u{D046}",
        nfkd: "\u{110F}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D047}",
        nfc: "\u{D047}",
        nfd: "\u{110F}\u{1171}\u{11BA}",
        nfkc: "\u{D047}",
        nfkd: "\u{110F}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D048}",
        nfc: "\u{D048}",
        nfd: "\u{110F}\u{1171}\u{11BB}",
        nfkc: "\u{D048}",
        nfkd: "\u{110F}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D049}",
        nfc: "\u{D049}",
        nfd: "\u{110F}\u{1171}\u{11BC}",
        nfkc: "\u{D049}",
        nfkd: "\u{110F}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D04A}",
        nfc: "\u{D04A}",
        nfd: "\u{110F}\u{1171}\u{11BD}",
        nfkc: "\u{D04A}",
        nfkd: "\u{110F}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D04B}",
        nfc: "\u{D04B}",
        nfd: "\u{110F}\u{1171}\u{11BE}",
        nfkc: "\u{D04B}",
        nfkd: "\u{110F}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D04C}",
        nfc: "\u{D04C}",
        nfd: "\u{110F}\u{1171}\u{11BF}",
        nfkc: "\u{D04C}",
        nfkd: "\u{110F}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D04D}",
        nfc: "\u{D04D}",
        nfd: "\u{110F}\u{1171}\u{11C0}",
        nfkc: "\u{D04D}",
        nfkd: "\u{110F}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D04E}",
        nfc: "\u{D04E}",
        nfd: "\u{110F}\u{1171}\u{11C1}",
        nfkc: "\u{D04E}",
        nfkd: "\u{110F}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D04F}",
        nfc: "\u{D04F}",
        nfd: "\u{110F}\u{1171}\u{11C2}",
        nfkc: "\u{D04F}",
        nfkd: "\u{110F}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D050}",
        nfc: "\u{D050}",
        nfd: "\u{110F}\u{1172}",
        nfkc: "\u{D050}",
        nfkd: "\u{110F}\u{1172}",
    },
    NormalizationTest {
        source: "\u{D051}",
        nfc: "\u{D051}",
        nfd: "\u{110F}\u{1172}\u{11A8}",
        nfkc: "\u{D051}",
        nfkd: "\u{110F}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D052}",
        nfc: "\u{D052}",
        nfd: "\u{110F}\u{1172}\u{11A9}",
        nfkc: "\u{D052}",
        nfkd: "\u{110F}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D053}",
        nfc: "\u{D053}",
        nfd: "\u{110F}\u{1172}\u{11AA}",
        nfkc: "\u{D053}",
        nfkd: "\u{110F}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D054}",
        nfc: "\u{D054}",
        nfd: "\u{110F}\u{1172}\u{11AB}",
        nfkc: "\u{D054}",
        nfkd: "\u{110F}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D055}",
        nfc: "\u{D055}",
        nfd: "\u{110F}\u{1172}\u{11AC}",
        nfkc: "\u{D055}",
        nfkd: "\u{110F}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D056}",
        nfc: "\u{D056}",
        nfd: "\u{110F}\u{1172}\u{11AD}",
        nfkc: "\u{D056}",
        nfkd: "\u{110F}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D057}",
        nfc: "\u{D057}",
        nfd: "\u{110F}\u{1172}\u{11AE}",
        nfkc: "\u{D057}",
        nfkd: "\u{110F}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D058}",
        nfc: "\u{D058}",
        nfd: "\u{110F}\u{1172}\u{11AF}",
        nfkc: "\u{D058}",
        nfkd: "\u{110F}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D059}",
        nfc: "\u{D059}",
        nfd: "\u{110F}\u{1172}\u{11B0}",
        nfkc: "\u{D059}",
        nfkd: "\u{110F}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D05A}",
        nfc: "\u{D05A}",
        nfd: "\u{110F}\u{1172}\u{11B1}",
        nfkc: "\u{D05A}",
        nfkd: "\u{110F}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D05B}",
        nfc: "\u{D05B}",
        nfd: "\u{110F}\u{1172}\u{11B2}",
        nfkc: "\u{D05B}",
        nfkd: "\u{110F}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D05C}",
        nfc: "\u{D05C}",
        nfd: "\u{110F}\u{1172}\u{11B3}",
        nfkc: "\u{D05C}",
        nfkd: "\u{110F}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D05D}",
        nfc: "\u{D05D}",
        nfd: "\u{110F}\u{1172}\u{11B4}",
        nfkc: "\u{D05D}",
        nfkd: "\u{110F}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D05E}",
        nfc: "\u{D05E}",
        nfd: "\u{110F}\u{1172}\u{11B5}",
        nfkc: "\u{D05E}",
        nfkd: "\u{110F}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D05F}",
        nfc: "\u{D05F}",
        nfd: "\u{110F}\u{1172}\u{11B6}",
        nfkc: "\u{D05F}",
        nfkd: "\u{110F}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D060}",
        nfc: "\u{D060}",
        nfd: "\u{110F}\u{1172}\u{11B7}",
        nfkc: "\u{D060}",
        nfkd: "\u{110F}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D061}",
        nfc: "\u{D061}",
        nfd: "\u{110F}\u{1172}\u{11B8}",
        nfkc: "\u{D061}",
        nfkd: "\u{110F}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D062}",
        nfc: "\u{D062}",
        nfd: "\u{110F}\u{1172}\u{11B9}",
        nfkc: "\u{D062}",
        nfkd: "\u{110F}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D063}",
        nfc: "\u{D063}",
        nfd: "\u{110F}\u{1172}\u{11BA}",
        nfkc: "\u{D063}",
        nfkd: "\u{110F}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D064}",
        nfc: "\u{D064}",
        nfd: "\u{110F}\u{1172}\u{11BB}",
        nfkc: "\u{D064}",
        nfkd: "\u{110F}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D065}",
        nfc: "\u{D065}",
        nfd: "\u{110F}\u{1172}\u{11BC}",
        nfkc: "\u{D065}",
        nfkd: "\u{110F}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D066}",
        nfc: "\u{D066}",
        nfd: "\u{110F}\u{1172}\u{11BD}",
        nfkc: "\u{D066}",
        nfkd: "\u{110F}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D067}",
        nfc: "\u{D067}",
        nfd: "\u{110F}\u{1172}\u{11BE}",
        nfkc: "\u{D067}",
        nfkd: "\u{110F}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D068}",
        nfc: "\u{D068}",
        nfd: "\u{110F}\u{1172}\u{11BF}",
        nfkc: "\u{D068}",
        nfkd: "\u{110F}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D069}",
        nfc: "\u{D069}",
        nfd: "\u{110F}\u{1172}\u{11C0}",
        nfkc: "\u{D069}",
        nfkd: "\u{110F}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D06A}",
        nfc: "\u{D06A}",
        nfd: "\u{110F}\u{1172}\u{11C1}",
        nfkc: "\u{D06A}",
        nfkd: "\u{110F}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D06B}",
        nfc: "\u{D06B}",
        nfd: "\u{110F}\u{1172}\u{11C2}",
        nfkc: "\u{D06B}",
        nfkd: "\u{110F}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D06C}",
        nfc: "\u{D06C}",
        nfd: "\u{110F}\u{1173}",
        nfkc: "\u{D06C}",
        nfkd: "\u{110F}\u{1173}",
    },
    NormalizationTest {
        source: "\u{D06D}",
        nfc: "\u{D06D}",
        nfd: "\u{110F}\u{1173}\u{11A8}",
        nfkc: "\u{D06D}",
        nfkd: "\u{110F}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D06E}",
        nfc: "\u{D06E}",
        nfd: "\u{110F}\u{1173}\u{11A9}",
        nfkc: "\u{D06E}",
        nfkd: "\u{110F}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D06F}",
        nfc: "\u{D06F}",
        nfd: "\u{110F}\u{1173}\u{11AA}",
        nfkc: "\u{D06F}",
        nfkd: "\u{110F}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D070}",
        nfc: "\u{D070}",
        nfd: "\u{110F}\u{1173}\u{11AB}",
        nfkc: "\u{D070}",
        nfkd: "\u{110F}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D071}",
        nfc: "\u{D071}",
        nfd: "\u{110F}\u{1173}\u{11AC}",
        nfkc: "\u{D071}",
        nfkd: "\u{110F}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D072}",
        nfc: "\u{D072}",
        nfd: "\u{110F}\u{1173}\u{11AD}",
        nfkc: "\u{D072}",
        nfkd: "\u{110F}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D073}",
        nfc: "\u{D073}",
        nfd: "\u{110F}\u{1173}\u{11AE}",
        nfkc: "\u{D073}",
        nfkd: "\u{110F}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D074}",
        nfc: "\u{D074}",
        nfd: "\u{110F}\u{1173}\u{11AF}",
        nfkc: "\u{D074}",
        nfkd: "\u{110F}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D075}",
        nfc: "\u{D075}",
        nfd: "\u{110F}\u{1173}\u{11B0}",
        nfkc: "\u{D075}",
        nfkd: "\u{110F}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D076}",
        nfc: "\u{D076}",
        nfd: "\u{110F}\u{1173}\u{11B1}",
        nfkc: "\u{D076}",
        nfkd: "\u{110F}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D077}",
        nfc: "\u{D077}",
        nfd: "\u{110F}\u{1173}\u{11B2}",
        nfkc: "\u{D077}",
        nfkd: "\u{110F}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D078}",
        nfc: "\u{D078}",
        nfd: "\u{110F}\u{1173}\u{11B3}",
        nfkc: "\u{D078}",
        nfkd: "\u{110F}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D079}",
        nfc: "\u{D079}",
        nfd: "\u{110F}\u{1173}\u{11B4}",
        nfkc: "\u{D079}",
        nfkd: "\u{110F}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D07A}",
        nfc: "\u{D07A}",
        nfd: "\u{110F}\u{1173}\u{11B5}",
        nfkc: "\u{D07A}",
        nfkd: "\u{110F}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D07B}",
        nfc: "\u{D07B}",
        nfd: "\u{110F}\u{1173}\u{11B6}",
        nfkc: "\u{D07B}",
        nfkd: "\u{110F}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D07C}",
        nfc: "\u{D07C}",
        nfd: "\u{110F}\u{1173}\u{11B7}",
        nfkc: "\u{D07C}",
        nfkd: "\u{110F}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D07D}",
        nfc: "\u{D07D}",
        nfd: "\u{110F}\u{1173}\u{11B8}",
        nfkc: "\u{D07D}",
        nfkd: "\u{110F}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D07E}",
        nfc: "\u{D07E}",
        nfd: "\u{110F}\u{1173}\u{11B9}",
        nfkc: "\u{D07E}",
        nfkd: "\u{110F}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D07F}",
        nfc: "\u{D07F}",
        nfd: "\u{110F}\u{1173}\u{11BA}",
        nfkc: "\u{D07F}",
        nfkd: "\u{110F}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D080}",
        nfc: "\u{D080}",
        nfd: "\u{110F}\u{1173}\u{11BB}",
        nfkc: "\u{D080}",
        nfkd: "\u{110F}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D081}",
        nfc: "\u{D081}",
        nfd: "\u{110F}\u{1173}\u{11BC}",
        nfkc: "\u{D081}",
        nfkd: "\u{110F}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D082}",
        nfc: "\u{D082}",
        nfd: "\u{110F}\u{1173}\u{11BD}",
        nfkc: "\u{D082}",
        nfkd: "\u{110F}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D083}",
        nfc: "\u{D083}",
        nfd: "\u{110F}\u{1173}\u{11BE}",
        nfkc: "\u{D083}",
        nfkd: "\u{110F}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D084}",
        nfc: "\u{D084}",
        nfd: "\u{110F}\u{1173}\u{11BF}",
        nfkc: "\u{D084}",
        nfkd: "\u{110F}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D085}",
        nfc: "\u{D085}",
        nfd: "\u{110F}\u{1173}\u{11C0}",
        nfkc: "\u{D085}",
        nfkd: "\u{110F}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D086}",
        nfc: "\u{D086}",
        nfd: "\u{110F}\u{1173}\u{11C1}",
        nfkc: "\u{D086}",
        nfkd: "\u{110F}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D087}",
        nfc: "\u{D087}",
        nfd: "\u{110F}\u{1173}\u{11C2}",
        nfkc: "\u{D087}",
        nfkd: "\u{110F}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D088}",
        nfc: "\u{D088}",
        nfd: "\u{110F}\u{1174}",
        nfkc: "\u{D088}",
        nfkd: "\u{110F}\u{1174}",
    },
    NormalizationTest {
        source: "\u{D089}",
        nfc: "\u{D089}",
        nfd: "\u{110F}\u{1174}\u{11A8}",
        nfkc: "\u{D089}",
        nfkd: "\u{110F}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D08A}",
        nfc: "\u{D08A}",
        nfd: "\u{110F}\u{1174}\u{11A9}",
        nfkc: "\u{D08A}",
        nfkd: "\u{110F}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D08B}",
        nfc: "\u{D08B}",
        nfd: "\u{110F}\u{1174}\u{11AA}",
        nfkc: "\u{D08B}",
        nfkd: "\u{110F}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D08C}",
        nfc: "\u{D08C}",
        nfd: "\u{110F}\u{1174}\u{11AB}",
        nfkc: "\u{D08C}",
        nfkd: "\u{110F}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D08D}",
        nfc: "\u{D08D}",
        nfd: "\u{110F}\u{1174}\u{11AC}",
        nfkc: "\u{D08D}",
        nfkd: "\u{110F}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D08E}",
        nfc: "\u{D08E}",
        nfd: "\u{110F}\u{1174}\u{11AD}",
        nfkc: "\u{D08E}",
        nfkd: "\u{110F}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D08F}",
        nfc: "\u{D08F}",
        nfd: "\u{110F}\u{1174}\u{11AE}",
        nfkc: "\u{D08F}",
        nfkd: "\u{110F}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D090}",
        nfc: "\u{D090}",
        nfd: "\u{110F}\u{1174}\u{11AF}",
        nfkc: "\u{D090}",
        nfkd: "\u{110F}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D091}",
        nfc: "\u{D091}",
        nfd: "\u{110F}\u{1174}\u{11B0}",
        nfkc: "\u{D091}",
        nfkd: "\u{110F}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D092}",
        nfc: "\u{D092}",
        nfd: "\u{110F}\u{1174}\u{11B1}",
        nfkc: "\u{D092}",
        nfkd: "\u{110F}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D093}",
        nfc: "\u{D093}",
        nfd: "\u{110F}\u{1174}\u{11B2}",
        nfkc: "\u{D093}",
        nfkd: "\u{110F}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D094}",
        nfc: "\u{D094}",
        nfd: "\u{110F}\u{1174}\u{11B3}",
        nfkc: "\u{D094}",
        nfkd: "\u{110F}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D095}",
        nfc: "\u{D095}",
        nfd: "\u{110F}\u{1174}\u{11B4}",
        nfkc: "\u{D095}",
        nfkd: "\u{110F}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D096}",
        nfc: "\u{D096}",
        nfd: "\u{110F}\u{1174}\u{11B5}",
        nfkc: "\u{D096}",
        nfkd: "\u{110F}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D097}",
        nfc: "\u{D097}",
        nfd: "\u{110F}\u{1174}\u{11B6}",
        nfkc: "\u{D097}",
        nfkd: "\u{110F}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D098}",
        nfc: "\u{D098}",
        nfd: "\u{110F}\u{1174}\u{11B7}",
        nfkc: "\u{D098}",
        nfkd: "\u{110F}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D099}",
        nfc: "\u{D099}",
        nfd: "\u{110F}\u{1174}\u{11B8}",
        nfkc: "\u{D099}",
        nfkd: "\u{110F}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D09A}",
        nfc: "\u{D09A}",
        nfd: "\u{110F}\u{1174}\u{11B9}",
        nfkc: "\u{D09A}",
        nfkd: "\u{110F}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D09B}",
        nfc: "\u{D09B}",
        nfd: "\u{110F}\u{1174}\u{11BA}",
        nfkc: "\u{D09B}",
        nfkd: "\u{110F}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D09C}",
        nfc: "\u{D09C}",
        nfd: "\u{110F}\u{1174}\u{11BB}",
        nfkc: "\u{D09C}",
        nfkd: "\u{110F}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D09D}",
        nfc: "\u{D09D}",
        nfd: "\u{110F}\u{1174}\u{11BC}",
        nfkc: "\u{D09D}",
        nfkd: "\u{110F}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D09E}",
        nfc: "\u{D09E}",
        nfd: "\u{110F}\u{1174}\u{11BD}",
        nfkc: "\u{D09E}",
        nfkd: "\u{110F}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D09F}",
        nfc: "\u{D09F}",
        nfd: "\u{110F}\u{1174}\u{11BE}",
        nfkc: "\u{D09F}",
        nfkd: "\u{110F}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D0A0}",
        nfc: "\u{D0A0}",
        nfd: "\u{110F}\u{1174}\u{11BF}",
        nfkc: "\u{D0A0}",
        nfkd: "\u{110F}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D0A1}",
        nfc: "\u{D0A1}",
        nfd: "\u{110F}\u{1174}\u{11C0}",
        nfkc: "\u{D0A1}",
        nfkd: "\u{110F}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D0A2}",
        nfc: "\u{D0A2}",
        nfd: "\u{110F}\u{1174}\u{11C1}",
        nfkc: "\u{D0A2}",
        nfkd: "\u{110F}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D0A3}",
        nfc: "\u{D0A3}",
        nfd: "\u{110F}\u{1174}\u{11C2}",
        nfkc: "\u{D0A3}",
        nfkd: "\u{110F}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D0A4}",
        nfc: "\u{D0A4}",
        nfd: "\u{110F}\u{1175}",
        nfkc: "\u{D0A4}",
        nfkd: "\u{110F}\u{1175}",
    },
    NormalizationTest {
        source: "\u{D0A5}",
        nfc: "\u{D0A5}",
        nfd: "\u{110F}\u{1175}\u{11A8}",
        nfkc: "\u{D0A5}",
        nfkd: "\u{110F}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D0A6}",
        nfc: "\u{D0A6}",
        nfd: "\u{110F}\u{1175}\u{11A9}",
        nfkc: "\u{D0A6}",
        nfkd: "\u{110F}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D0A7}",
        nfc: "\u{D0A7}",
        nfd: "\u{110F}\u{1175}\u{11AA}",
        nfkc: "\u{D0A7}",
        nfkd: "\u{110F}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D0A8}",
        nfc: "\u{D0A8}",
        nfd: "\u{110F}\u{1175}\u{11AB}",
        nfkc: "\u{D0A8}",
        nfkd: "\u{110F}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D0A9}",
        nfc: "\u{D0A9}",
        nfd: "\u{110F}\u{1175}\u{11AC}",
        nfkc: "\u{D0A9}",
        nfkd: "\u{110F}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D0AA}",
        nfc: "\u{D0AA}",
        nfd: "\u{110F}\u{1175}\u{11AD}",
        nfkc: "\u{D0AA}",
        nfkd: "\u{110F}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D0AB}",
        nfc: "\u{D0AB}",
        nfd: "\u{110F}\u{1175}\u{11AE}",
        nfkc: "\u{D0AB}",
        nfkd: "\u{110F}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D0AC}",
        nfc: "\u{D0AC}",
        nfd: "\u{110F}\u{1175}\u{11AF}",
        nfkc: "\u{D0AC}",
        nfkd: "\u{110F}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D0AD}",
        nfc: "\u{D0AD}",
        nfd: "\u{110F}\u{1175}\u{11B0}",
        nfkc: "\u{D0AD}",
        nfkd: "\u{110F}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D0AE}",
        nfc: "\u{D0AE}",
        nfd: "\u{110F}\u{1175}\u{11B1}",
        nfkc: "\u{D0AE}",
        nfkd: "\u{110F}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D0AF}",
        nfc: "\u{D0AF}",
        nfd: "\u{110F}\u{1175}\u{11B2}",
        nfkc: "\u{D0AF}",
        nfkd: "\u{110F}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D0B0}",
        nfc: "\u{D0B0}",
        nfd: "\u{110F}\u{1175}\u{11B3}",
        nfkc: "\u{D0B0}",
        nfkd: "\u{110F}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D0B1}",
        nfc: "\u{D0B1}",
        nfd: "\u{110F}\u{1175}\u{11B4}",
        nfkc: "\u{D0B1}",
        nfkd: "\u{110F}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D0B2}",
        nfc: "\u{D0B2}",
        nfd: "\u{110F}\u{1175}\u{11B5}",
        nfkc: "\u{D0B2}",
        nfkd: "\u{110F}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D0B3}",
        nfc: "\u{D0B3}",
        nfd: "\u{110F}\u{1175}\u{11B6}",
        nfkc: "\u{D0B3}",
        nfkd: "\u{110F}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D0B4}",
        nfc: "\u{D0B4}",
        nfd: "\u{110F}\u{1175}\u{11B7}",
        nfkc: "\u{D0B4}",
        nfkd: "\u{110F}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D0B5}",
        nfc: "\u{D0B5}",
        nfd: "\u{110F}\u{1175}\u{11B8}",
        nfkc: "\u{D0B5}",
        nfkd: "\u{110F}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D0B6}",
        nfc: "\u{D0B6}",
        nfd: "\u{110F}\u{1175}\u{11B9}",
        nfkc: "\u{D0B6}",
        nfkd: "\u{110F}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D0B7}",
        nfc: "\u{D0B7}",
        nfd: "\u{110F}\u{1175}\u{11BA}",
        nfkc: "\u{D0B7}",
        nfkd: "\u{110F}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D0B8}",
        nfc: "\u{D0B8}",
        nfd: "\u{110F}\u{1175}\u{11BB}",
        nfkc: "\u{D0B8}",
        nfkd: "\u{110F}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D0B9}",
        nfc: "\u{D0B9}",
        nfd: "\u{110F}\u{1175}\u{11BC}",
        nfkc: "\u{D0B9}",
        nfkd: "\u{110F}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D0BA}",
        nfc: "\u{D0BA}",
        nfd: "\u{110F}\u{1175}\u{11BD}",
        nfkc: "\u{D0BA}",
        nfkd: "\u{110F}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D0BB}",
        nfc: "\u{D0BB}",
        nfd: "\u{110F}\u{1175}\u{11BE}",
        nfkc: "\u{D0BB}",
        nfkd: "\u{110F}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D0BC}",
        nfc: "\u{D0BC}",
        nfd: "\u{110F}\u{1175}\u{11BF}",
        nfkc: "\u{D0BC}",
        nfkd: "\u{110F}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D0BD}",
        nfc: "\u{D0BD}",
        nfd: "\u{110F}\u{1175}\u{11C0}",
        nfkc: "\u{D0BD}",
        nfkd: "\u{110F}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D0BE}",
        nfc: "\u{D0BE}",
        nfd: "\u{110F}\u{1175}\u{11C1}",
        nfkc: "\u{D0BE}",
        nfkd: "\u{110F}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D0BF}",
        nfc: "\u{D0BF}",
        nfd: "\u{110F}\u{1175}\u{11C2}",
        nfkc: "\u{D0BF}",
        nfkd: "\u{110F}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D0C0}",
        nfc: "\u{D0C0}",
        nfd: "\u{1110}\u{1161}",
        nfkc: "\u{D0C0}",
        nfkd: "\u{1110}\u{1161}",
    },
    NormalizationTest {
        source: "\u{D0C1}",
        nfc: "\u{D0C1}",
        nfd: "\u{1110}\u{1161}\u{11A8}",
        nfkc: "\u{D0C1}",
        nfkd: "\u{1110}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D0C2}",
        nfc: "\u{D0C2}",
        nfd: "\u{1110}\u{1161}\u{11A9}",
        nfkc: "\u{D0C2}",
        nfkd: "\u{1110}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D0C3}",
        nfc: "\u{D0C3}",
        nfd: "\u{1110}\u{1161}\u{11AA}",
        nfkc: "\u{D0C3}",
        nfkd: "\u{1110}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D0C4}",
        nfc: "\u{D0C4}",
        nfd: "\u{1110}\u{1161}\u{11AB}",
        nfkc: "\u{D0C4}",
        nfkd: "\u{1110}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D0C5}",
        nfc: "\u{D0C5}",
        nfd: "\u{1110}\u{1161}\u{11AC}",
        nfkc: "\u{D0C5}",
        nfkd: "\u{1110}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D0C6}",
        nfc: "\u{D0C6}",
        nfd: "\u{1110}\u{1161}\u{11AD}",
        nfkc: "\u{D0C6}",
        nfkd: "\u{1110}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D0C7}",
        nfc: "\u{D0C7}",
        nfd: "\u{1110}\u{1161}\u{11AE}",
        nfkc: "\u{D0C7}",
        nfkd: "\u{1110}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D0C8}",
        nfc: "\u{D0C8}",
        nfd: "\u{1110}\u{1161}\u{11AF}",
        nfkc: "\u{D0C8}",
        nfkd: "\u{1110}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D0C9}",
        nfc: "\u{D0C9}",
        nfd: "\u{1110}\u{1161}\u{11B0}",
        nfkc: "\u{D0C9}",
        nfkd: "\u{1110}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D0CA}",
        nfc: "\u{D0CA}",
        nfd: "\u{1110}\u{1161}\u{11B1}",
        nfkc: "\u{D0CA}",
        nfkd: "\u{1110}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D0CB}",
        nfc: "\u{D0CB}",
        nfd: "\u{1110}\u{1161}\u{11B2}",
        nfkc: "\u{D0CB}",
        nfkd: "\u{1110}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D0CC}",
        nfc: "\u{D0CC}",
        nfd: "\u{1110}\u{1161}\u{11B3}",
        nfkc: "\u{D0CC}",
        nfkd: "\u{1110}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D0CD}",
        nfc: "\u{D0CD}",
        nfd: "\u{1110}\u{1161}\u{11B4}",
        nfkc: "\u{D0CD}",
        nfkd: "\u{1110}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D0CE}",
        nfc: "\u{D0CE}",
        nfd: "\u{1110}\u{1161}\u{11B5}",
        nfkc: "\u{D0CE}",
        nfkd: "\u{1110}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D0CF}",
        nfc: "\u{D0CF}",
        nfd: "\u{1110}\u{1161}\u{11B6}",
        nfkc: "\u{D0CF}",
        nfkd: "\u{1110}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D0D0}",
        nfc: "\u{D0D0}",
        nfd: "\u{1110}\u{1161}\u{11B7}",
        nfkc: "\u{D0D0}",
        nfkd: "\u{1110}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D0D1}",
        nfc: "\u{D0D1}",
        nfd: "\u{1110}\u{1161}\u{11B8}",
        nfkc: "\u{D0D1}",
        nfkd: "\u{1110}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D0D2}",
        nfc: "\u{D0D2}",
        nfd: "\u{1110}\u{1161}\u{11B9}",
        nfkc: "\u{D0D2}",
        nfkd: "\u{1110}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D0D3}",
        nfc: "\u{D0D3}",
        nfd: "\u{1110}\u{1161}\u{11BA}",
        nfkc: "\u{D0D3}",
        nfkd: "\u{1110}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D0D4}",
        nfc: "\u{D0D4}",
        nfd: "\u{1110}\u{1161}\u{11BB}",
        nfkc: "\u{D0D4}",
        nfkd: "\u{1110}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D0D5}",
        nfc: "\u{D0D5}",
        nfd: "\u{1110}\u{1161}\u{11BC}",
        nfkc: "\u{D0D5}",
        nfkd: "\u{1110}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D0D6}",
        nfc: "\u{D0D6}",
        nfd: "\u{1110}\u{1161}\u{11BD}",
        nfkc: "\u{D0D6}",
        nfkd: "\u{1110}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D0D7}",
        nfc: "\u{D0D7}",
        nfd: "\u{1110}\u{1161}\u{11BE}",
        nfkc: "\u{D0D7}",
        nfkd: "\u{1110}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D0D8}",
        nfc: "\u{D0D8}",
        nfd: "\u{1110}\u{1161}\u{11BF}",
        nfkc: "\u{D0D8}",
        nfkd: "\u{1110}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D0D9}",
        nfc: "\u{D0D9}",
        nfd: "\u{1110}\u{1161}\u{11C0}",
        nfkc: "\u{D0D9}",
        nfkd: "\u{1110}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D0DA}",
        nfc: "\u{D0DA}",
        nfd: "\u{1110}\u{1161}\u{11C1}",
        nfkc: "\u{D0DA}",
        nfkd: "\u{1110}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D0DB}",
        nfc: "\u{D0DB}",
        nfd: "\u{1110}\u{1161}\u{11C2}",
        nfkc: "\u{D0DB}",
        nfkd: "\u{1110}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D0DC}",
        nfc: "\u{D0DC}",
        nfd: "\u{1110}\u{1162}",
        nfkc: "\u{D0DC}",
        nfkd: "\u{1110}\u{1162}",
    },
    NormalizationTest {
        source: "\u{D0DD}",
        nfc: "\u{D0DD}",
        nfd: "\u{1110}\u{1162}\u{11A8}",
        nfkc: "\u{D0DD}",
        nfkd: "\u{1110}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D0DE}",
        nfc: "\u{D0DE}",
        nfd: "\u{1110}\u{1162}\u{11A9}",
        nfkc: "\u{D0DE}",
        nfkd: "\u{1110}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D0DF}",
        nfc: "\u{D0DF}",
        nfd: "\u{1110}\u{1162}\u{11AA}",
        nfkc: "\u{D0DF}",
        nfkd: "\u{1110}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D0E0}",
        nfc: "\u{D0E0}",
        nfd: "\u{1110}\u{1162}\u{11AB}",
        nfkc: "\u{D0E0}",
        nfkd: "\u{1110}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D0E1}",
        nfc: "\u{D0E1}",
        nfd: "\u{1110}\u{1162}\u{11AC}",
        nfkc: "\u{D0E1}",
        nfkd: "\u{1110}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D0E2}",
        nfc: "\u{D0E2}",
        nfd: "\u{1110}\u{1162}\u{11AD}",
        nfkc: "\u{D0E2}",
        nfkd: "\u{1110}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D0E3}",
        nfc: "\u{D0E3}",
        nfd: "\u{1110}\u{1162}\u{11AE}",
        nfkc: "\u{D0E3}",
        nfkd: "\u{1110}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D0E4}",
        nfc: "\u{D0E4}",
        nfd: "\u{1110}\u{1162}\u{11AF}",
        nfkc: "\u{D0E4}",
        nfkd: "\u{1110}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D0E5}",
        nfc: "\u{D0E5}",
        nfd: "\u{1110}\u{1162}\u{11B0}",
        nfkc: "\u{D0E5}",
        nfkd: "\u{1110}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D0E6}",
        nfc: "\u{D0E6}",
        nfd: "\u{1110}\u{1162}\u{11B1}",
        nfkc: "\u{D0E6}",
        nfkd: "\u{1110}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D0E7}",
        nfc: "\u{D0E7}",
        nfd: "\u{1110}\u{1162}\u{11B2}",
        nfkc: "\u{D0E7}",
        nfkd: "\u{1110}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D0E8}",
        nfc: "\u{D0E8}",
        nfd: "\u{1110}\u{1162}\u{11B3}",
        nfkc: "\u{D0E8}",
        nfkd: "\u{1110}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D0E9}",
        nfc: "\u{D0E9}",
        nfd: "\u{1110}\u{1162}\u{11B4}",
        nfkc: "\u{D0E9}",
        nfkd: "\u{1110}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D0EA}",
        nfc: "\u{D0EA}",
        nfd: "\u{1110}\u{1162}\u{11B5}",
        nfkc: "\u{D0EA}",
        nfkd: "\u{1110}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D0EB}",
        nfc: "\u{D0EB}",
        nfd: "\u{1110}\u{1162}\u{11B6}",
        nfkc: "\u{D0EB}",
        nfkd: "\u{1110}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D0EC}",
        nfc: "\u{D0EC}",
        nfd: "\u{1110}\u{1162}\u{11B7}",
        nfkc: "\u{D0EC}",
        nfkd: "\u{1110}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D0ED}",
        nfc: "\u{D0ED}",
        nfd: "\u{1110}\u{1162}\u{11B8}",
        nfkc: "\u{D0ED}",
        nfkd: "\u{1110}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D0EE}",
        nfc: "\u{D0EE}",
        nfd: "\u{1110}\u{1162}\u{11B9}",
        nfkc: "\u{D0EE}",
        nfkd: "\u{1110}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D0EF}",
        nfc: "\u{D0EF}",
        nfd: "\u{1110}\u{1162}\u{11BA}",
        nfkc: "\u{D0EF}",
        nfkd: "\u{1110}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D0F0}",
        nfc: "\u{D0F0}",
        nfd: "\u{1110}\u{1162}\u{11BB}",
        nfkc: "\u{D0F0}",
        nfkd: "\u{1110}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D0F1}",
        nfc: "\u{D0F1}",
        nfd: "\u{1110}\u{1162}\u{11BC}",
        nfkc: "\u{D0F1}",
        nfkd: "\u{1110}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D0F2}",
        nfc: "\u{D0F2}",
        nfd: "\u{1110}\u{1162}\u{11BD}",
        nfkc: "\u{D0F2}",
        nfkd: "\u{1110}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D0F3}",
        nfc: "\u{D0F3}",
        nfd: "\u{1110}\u{1162}\u{11BE}",
        nfkc: "\u{D0F3}",
        nfkd: "\u{1110}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D0F4}",
        nfc: "\u{D0F4}",
        nfd: "\u{1110}\u{1162}\u{11BF}",
        nfkc: "\u{D0F4}",
        nfkd: "\u{1110}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D0F5}",
        nfc: "\u{D0F5}",
        nfd: "\u{1110}\u{1162}\u{11C0}",
        nfkc: "\u{D0F5}",
        nfkd: "\u{1110}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D0F6}",
        nfc: "\u{D0F6}",
        nfd: "\u{1110}\u{1162}\u{11C1}",
        nfkc: "\u{D0F6}",
        nfkd: "\u{1110}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D0F7}",
        nfc: "\u{D0F7}",
        nfd: "\u{1110}\u{1162}\u{11C2}",
        nfkc: "\u{D0F7}",
        nfkd: "\u{1110}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D0F8}",
        nfc: "\u{D0F8}",
        nfd: "\u{1110}\u{1163}",
        nfkc: "\u{D0F8}",
        nfkd: "\u{1110}\u{1163}",
    },
    NormalizationTest {
        source: "\u{D0F9}",
        nfc: "\u{D0F9}",
        nfd: "\u{1110}\u{1163}\u{11A8}",
        nfkc: "\u{D0F9}",
        nfkd: "\u{1110}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D0FA}",
        nfc: "\u{D0FA}",
        nfd: "\u{1110}\u{1163}\u{11A9}",
        nfkc: "\u{D0FA}",
        nfkd: "\u{1110}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D0FB}",
        nfc: "\u{D0FB}",
        nfd: "\u{1110}\u{1163}\u{11AA}",
        nfkc: "\u{D0FB}",
        nfkd: "\u{1110}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D0FC}",
        nfc: "\u{D0FC}",
        nfd: "\u{1110}\u{1163}\u{11AB}",
        nfkc: "\u{D0FC}",
        nfkd: "\u{1110}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D0FD}",
        nfc: "\u{D0FD}",
        nfd: "\u{1110}\u{1163}\u{11AC}",
        nfkc: "\u{D0FD}",
        nfkd: "\u{1110}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D0FE}",
        nfc: "\u{D0FE}",
        nfd: "\u{1110}\u{1163}\u{11AD}",
        nfkc: "\u{D0FE}",
        nfkd: "\u{1110}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D0FF}",
        nfc: "\u{D0FF}",
        nfd: "\u{1110}\u{1163}\u{11AE}",
        nfkc: "\u{D0FF}",
        nfkd: "\u{1110}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D100}",
        nfc: "\u{D100}",
        nfd: "\u{1110}\u{1163}\u{11AF}",
        nfkc: "\u{D100}",
        nfkd: "\u{1110}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D101}",
        nfc: "\u{D101}",
        nfd: "\u{1110}\u{1163}\u{11B0}",
        nfkc: "\u{D101}",
        nfkd: "\u{1110}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D102}",
        nfc: "\u{D102}",
        nfd: "\u{1110}\u{1163}\u{11B1}",
        nfkc: "\u{D102}",
        nfkd: "\u{1110}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D103}",
        nfc: "\u{D103}",
        nfd: "\u{1110}\u{1163}\u{11B2}",
        nfkc: "\u{D103}",
        nfkd: "\u{1110}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D104}",
        nfc: "\u{D104}",
        nfd: "\u{1110}\u{1163}\u{11B3}",
        nfkc: "\u{D104}",
        nfkd: "\u{1110}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D105}",
        nfc: "\u{D105}",
        nfd: "\u{1110}\u{1163}\u{11B4}",
        nfkc: "\u{D105}",
        nfkd: "\u{1110}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D106}",
        nfc: "\u{D106}",
        nfd: "\u{1110}\u{1163}\u{11B5}",
        nfkc: "\u{D106}",
        nfkd: "\u{1110}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D107}",
        nfc: "\u{D107}",
        nfd: "\u{1110}\u{1163}\u{11B6}",
        nfkc: "\u{D107}",
        nfkd: "\u{1110}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D108}",
        nfc: "\u{D108}",
        nfd: "\u{1110}\u{1163}\u{11B7}",
        nfkc: "\u{D108}",
        nfkd: "\u{1110}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D109}",
        nfc: "\u{D109}",
        nfd: "\u{1110}\u{1163}\u{11B8}",
        nfkc: "\u{D109}",
        nfkd: "\u{1110}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D10A}",
        nfc: "\u{D10A}",
        nfd: "\u{1110}\u{1163}\u{11B9}",
        nfkc: "\u{D10A}",
        nfkd: "\u{1110}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D10B}",
        nfc: "\u{D10B}",
        nfd: "\u{1110}\u{1163}\u{11BA}",
        nfkc: "\u{D10B}",
        nfkd: "\u{1110}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D10C}",
        nfc: "\u{D10C}",
        nfd: "\u{1110}\u{1163}\u{11BB}",
        nfkc: "\u{D10C}",
        nfkd: "\u{1110}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D10D}",
        nfc: "\u{D10D}",
        nfd: "\u{1110}\u{1163}\u{11BC}",
        nfkc: "\u{D10D}",
        nfkd: "\u{1110}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D10E}",
        nfc: "\u{D10E}",
        nfd: "\u{1110}\u{1163}\u{11BD}",
        nfkc: "\u{D10E}",
        nfkd: "\u{1110}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D10F}",
        nfc: "\u{D10F}",
        nfd: "\u{1110}\u{1163}\u{11BE}",
        nfkc: "\u{D10F}",
        nfkd: "\u{1110}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D110}",
        nfc: "\u{D110}",
        nfd: "\u{1110}\u{1163}\u{11BF}",
        nfkc: "\u{D110}",
        nfkd: "\u{1110}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D111}",
        nfc: "\u{D111}",
        nfd: "\u{1110}\u{1163}\u{11C0}",
        nfkc: "\u{D111}",
        nfkd: "\u{1110}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D112}",
        nfc: "\u{D112}",
        nfd: "\u{1110}\u{1163}\u{11C1}",
        nfkc: "\u{D112}",
        nfkd: "\u{1110}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D113}",
        nfc: "\u{D113}",
        nfd: "\u{1110}\u{1163}\u{11C2}",
        nfkc: "\u{D113}",
        nfkd: "\u{1110}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D114}",
        nfc: "\u{D114}",
        nfd: "\u{1110}\u{1164}",
        nfkc: "\u{D114}",
        nfkd: "\u{1110}\u{1164}",
    },
    NormalizationTest {
        source: "\u{D115}",
        nfc: "\u{D115}",
        nfd: "\u{1110}\u{1164}\u{11A8}",
        nfkc: "\u{D115}",
        nfkd: "\u{1110}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D116}",
        nfc: "\u{D116}",
        nfd: "\u{1110}\u{1164}\u{11A9}",
        nfkc: "\u{D116}",
        nfkd: "\u{1110}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D117}",
        nfc: "\u{D117}",
        nfd: "\u{1110}\u{1164}\u{11AA}",
        nfkc: "\u{D117}",
        nfkd: "\u{1110}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D118}",
        nfc: "\u{D118}",
        nfd: "\u{1110}\u{1164}\u{11AB}",
        nfkc: "\u{D118}",
        nfkd: "\u{1110}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D119}",
        nfc: "\u{D119}",
        nfd: "\u{1110}\u{1164}\u{11AC}",
        nfkc: "\u{D119}",
        nfkd: "\u{1110}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D11A}",
        nfc: "\u{D11A}",
        nfd: "\u{1110}\u{1164}\u{11AD}",
        nfkc: "\u{D11A}",
        nfkd: "\u{1110}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D11B}",
        nfc: "\u{D11B}",
        nfd: "\u{1110}\u{1164}\u{11AE}",
        nfkc: "\u{D11B}",
        nfkd: "\u{1110}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D11C}",
        nfc: "\u{D11C}",
        nfd: "\u{1110}\u{1164}\u{11AF}",
        nfkc: "\u{D11C}",
        nfkd: "\u{1110}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D11D}",
        nfc: "\u{D11D}",
        nfd: "\u{1110}\u{1164}\u{11B0}",
        nfkc: "\u{D11D}",
        nfkd: "\u{1110}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D11E}",
        nfc: "\u{D11E}",
        nfd: "\u{1110}\u{1164}\u{11B1}",
        nfkc: "\u{D11E}",
        nfkd: "\u{1110}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D11F}",
        nfc: "\u{D11F}",
        nfd: "\u{1110}\u{1164}\u{11B2}",
        nfkc: "\u{D11F}",
        nfkd: "\u{1110}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D120}",
        nfc: "\u{D120}",
        nfd: "\u{1110}\u{1164}\u{11B3}",
        nfkc: "\u{D120}",
        nfkd: "\u{1110}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D121}",
        nfc: "\u{D121}",
        nfd: "\u{1110}\u{1164}\u{11B4}",
        nfkc: "\u{D121}",
        nfkd: "\u{1110}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D122}",
        nfc: "\u{D122}",
        nfd: "\u{1110}\u{1164}\u{11B5}",
        nfkc: "\u{D122}",
        nfkd: "\u{1110}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D123}",
        nfc: "\u{D123}",
        nfd: "\u{1110}\u{1164}\u{11B6}",
        nfkc: "\u{D123}",
        nfkd: "\u{1110}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D124}",
        nfc: "\u{D124}",
        nfd: "\u{1110}\u{1164}\u{11B7}",
        nfkc: "\u{D124}",
        nfkd: "\u{1110}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D125}",
        nfc: "\u{D125}",
        nfd: "\u{1110}\u{1164}\u{11B8}",
        nfkc: "\u{D125}",
        nfkd: "\u{1110}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D126}",
        nfc: "\u{D126}",
        nfd: "\u{1110}\u{1164}\u{11B9}",
        nfkc: "\u{D126}",
        nfkd: "\u{1110}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D127}",
        nfc: "\u{D127}",
        nfd: "\u{1110}\u{1164}\u{11BA}",
        nfkc: "\u{D127}",
        nfkd: "\u{1110}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D128}",
        nfc: "\u{D128}",
        nfd: "\u{1110}\u{1164}\u{11BB}",
        nfkc: "\u{D128}",
        nfkd: "\u{1110}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D129}",
        nfc: "\u{D129}",
        nfd: "\u{1110}\u{1164}\u{11BC}",
        nfkc: "\u{D129}",
        nfkd: "\u{1110}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D12A}",
        nfc: "\u{D12A}",
        nfd: "\u{1110}\u{1164}\u{11BD}",
        nfkc: "\u{D12A}",
        nfkd: "\u{1110}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D12B}",
        nfc: "\u{D12B}",
        nfd: "\u{1110}\u{1164}\u{11BE}",
        nfkc: "\u{D12B}",
        nfkd: "\u{1110}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D12C}",
        nfc: "\u{D12C}",
        nfd: "\u{1110}\u{1164}\u{11BF}",
        nfkc: "\u{D12C}",
        nfkd: "\u{1110}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D12D}",
        nfc: "\u{D12D}",
        nfd: "\u{1110}\u{1164}\u{11C0}",
        nfkc: "\u{D12D}",
        nfkd: "\u{1110}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D12E}",
        nfc: "\u{D12E}",
        nfd: "\u{1110}\u{1164}\u{11C1}",
        nfkc: "\u{D12E}",
        nfkd: "\u{1110}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D12F}",
        nfc: "\u{D12F}",
        nfd: "\u{1110}\u{1164}\u{11C2}",
        nfkc: "\u{D12F}",
        nfkd: "\u{1110}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D130}",
        nfc: "\u{D130}",
        nfd: "\u{1110}\u{1165}",
        nfkc: "\u{D130}",
        nfkd: "\u{1110}\u{1165}",
    },
    NormalizationTest {
        source: "\u{D131}",
        nfc: "\u{D131}",
        nfd: "\u{1110}\u{1165}\u{11A8}",
        nfkc: "\u{D131}",
        nfkd: "\u{1110}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D132}",
        nfc: "\u{D132}",
        nfd: "\u{1110}\u{1165}\u{11A9}",
        nfkc: "\u{D132}",
        nfkd: "\u{1110}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D133}",
        nfc: "\u{D133}",
        nfd: "\u{1110}\u{1165}\u{11AA}",
        nfkc: "\u{D133}",
        nfkd: "\u{1110}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D134}",
        nfc: "\u{D134}",
        nfd: "\u{1110}\u{1165}\u{11AB}",
        nfkc: "\u{D134}",
        nfkd: "\u{1110}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D135}",
        nfc: "\u{D135}",
        nfd: "\u{1110}\u{1165}\u{11AC}",
        nfkc: "\u{D135}",
        nfkd: "\u{1110}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D136}",
        nfc: "\u{D136}",
        nfd: "\u{1110}\u{1165}\u{11AD}",
        nfkc: "\u{D136}",
        nfkd: "\u{1110}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D137}",
        nfc: "\u{D137}",
        nfd: "\u{1110}\u{1165}\u{11AE}",
        nfkc: "\u{D137}",
        nfkd: "\u{1110}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D138}",
        nfc: "\u{D138}",
        nfd: "\u{1110}\u{1165}\u{11AF}",
        nfkc: "\u{D138}",
        nfkd: "\u{1110}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D139}",
        nfc: "\u{D139}",
        nfd: "\u{1110}\u{1165}\u{11B0}",
        nfkc: "\u{D139}",
        nfkd: "\u{1110}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D13A}",
        nfc: "\u{D13A}",
        nfd: "\u{1110}\u{1165}\u{11B1}",
        nfkc: "\u{D13A}",
        nfkd: "\u{1110}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D13B}",
        nfc: "\u{D13B}",
        nfd: "\u{1110}\u{1165}\u{11B2}",
        nfkc: "\u{D13B}",
        nfkd: "\u{1110}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D13C}",
        nfc: "\u{D13C}",
        nfd: "\u{1110}\u{1165}\u{11B3}",
        nfkc: "\u{D13C}",
        nfkd: "\u{1110}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D13D}",
        nfc: "\u{D13D}",
        nfd: "\u{1110}\u{1165}\u{11B4}",
        nfkc: "\u{D13D}",
        nfkd: "\u{1110}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D13E}",
        nfc: "\u{D13E}",
        nfd: "\u{1110}\u{1165}\u{11B5}",
        nfkc: "\u{D13E}",
        nfkd: "\u{1110}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D13F}",
        nfc: "\u{D13F}",
        nfd: "\u{1110}\u{1165}\u{11B6}",
        nfkc: "\u{D13F}",
        nfkd: "\u{1110}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D140}",
        nfc: "\u{D140}",
        nfd: "\u{1110}\u{1165}\u{11B7}",
        nfkc: "\u{D140}",
        nfkd: "\u{1110}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D141}",
        nfc: "\u{D141}",
        nfd: "\u{1110}\u{1165}\u{11B8}",
        nfkc: "\u{D141}",
        nfkd: "\u{1110}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D142}",
        nfc: "\u{D142}",
        nfd: "\u{1110}\u{1165}\u{11B9}",
        nfkc: "\u{D142}",
        nfkd: "\u{1110}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D143}",
        nfc: "\u{D143}",
        nfd: "\u{1110}\u{1165}\u{11BA}",
        nfkc: "\u{D143}",
        nfkd: "\u{1110}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D144}",
        nfc: "\u{D144}",
        nfd: "\u{1110}\u{1165}\u{11BB}",
        nfkc: "\u{D144}",
        nfkd: "\u{1110}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D145}",
        nfc: "\u{D145}",
        nfd: "\u{1110}\u{1165}\u{11BC}",
        nfkc: "\u{D145}",
        nfkd: "\u{1110}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D146}",
        nfc: "\u{D146}",
        nfd: "\u{1110}\u{1165}\u{11BD}",
        nfkc: "\u{D146}",
        nfkd: "\u{1110}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D147}",
        nfc: "\u{D147}",
        nfd: "\u{1110}\u{1165}\u{11BE}",
        nfkc: "\u{D147}",
        nfkd: "\u{1110}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D148}",
        nfc: "\u{D148}",
        nfd: "\u{1110}\u{1165}\u{11BF}",
        nfkc: "\u{D148}",
        nfkd: "\u{1110}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D149}",
        nfc: "\u{D149}",
        nfd: "\u{1110}\u{1165}\u{11C0}",
        nfkc: "\u{D149}",
        nfkd: "\u{1110}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D14A}",
        nfc: "\u{D14A}",
        nfd: "\u{1110}\u{1165}\u{11C1}",
        nfkc: "\u{D14A}",
        nfkd: "\u{1110}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D14B}",
        nfc: "\u{D14B}",
        nfd: "\u{1110}\u{1165}\u{11C2}",
        nfkc: "\u{D14B}",
        nfkd: "\u{1110}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D14C}",
        nfc: "\u{D14C}",
        nfd: "\u{1110}\u{1166}",
        nfkc: "\u{D14C}",
        nfkd: "\u{1110}\u{1166}",
    },
    NormalizationTest {
        source: "\u{D14D}",
        nfc: "\u{D14D}",
        nfd: "\u{1110}\u{1166}\u{11A8}",
        nfkc: "\u{D14D}",
        nfkd: "\u{1110}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D14E}",
        nfc: "\u{D14E}",
        nfd: "\u{1110}\u{1166}\u{11A9}",
        nfkc: "\u{D14E}",
        nfkd: "\u{1110}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D14F}",
        nfc: "\u{D14F}",
        nfd: "\u{1110}\u{1166}\u{11AA}",
        nfkc: "\u{D14F}",
        nfkd: "\u{1110}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D150}",
        nfc: "\u{D150}",
        nfd: "\u{1110}\u{1166}\u{11AB}",
        nfkc: "\u{D150}",
        nfkd: "\u{1110}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D151}",
        nfc: "\u{D151}",
        nfd: "\u{1110}\u{1166}\u{11AC}",
        nfkc: "\u{D151}",
        nfkd: "\u{1110}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D152}",
        nfc: "\u{D152}",
        nfd: "\u{1110}\u{1166}\u{11AD}",
        nfkc: "\u{D152}",
        nfkd: "\u{1110}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D153}",
        nfc: "\u{D153}",
        nfd: "\u{1110}\u{1166}\u{11AE}",
        nfkc: "\u{D153}",
        nfkd: "\u{1110}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D154}",
        nfc: "\u{D154}",
        nfd: "\u{1110}\u{1166}\u{11AF}",
        nfkc: "\u{D154}",
        nfkd: "\u{1110}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D155}",
        nfc: "\u{D155}",
        nfd: "\u{1110}\u{1166}\u{11B0}",
        nfkc: "\u{D155}",
        nfkd: "\u{1110}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D156}",
        nfc: "\u{D156}",
        nfd: "\u{1110}\u{1166}\u{11B1}",
        nfkc: "\u{D156}",
        nfkd: "\u{1110}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D157}",
        nfc: "\u{D157}",
        nfd: "\u{1110}\u{1166}\u{11B2}",
        nfkc: "\u{D157}",
        nfkd: "\u{1110}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D158}",
        nfc: "\u{D158}",
        nfd: "\u{1110}\u{1166}\u{11B3}",
        nfkc: "\u{D158}",
        nfkd: "\u{1110}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D159}",
        nfc: "\u{D159}",
        nfd: "\u{1110}\u{1166}\u{11B4}",
        nfkc: "\u{D159}",
        nfkd: "\u{1110}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D15A}",
        nfc: "\u{D15A}",
        nfd: "\u{1110}\u{1166}\u{11B5}",
        nfkc: "\u{D15A}",
        nfkd: "\u{1110}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D15B}",
        nfc: "\u{D15B}",
        nfd: "\u{1110}\u{1166}\u{11B6}",
        nfkc: "\u{D15B}",
        nfkd: "\u{1110}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D15C}",
        nfc: "\u{D15C}",
        nfd: "\u{1110}\u{1166}\u{11B7}",
        nfkc: "\u{D15C}",
        nfkd: "\u{1110}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D15D}",
        nfc: "\u{D15D}",
        nfd: "\u{1110}\u{1166}\u{11B8}",
        nfkc: "\u{D15D}",
        nfkd: "\u{1110}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D15E}",
        nfc: "\u{D15E}",
        nfd: "\u{1110}\u{1166}\u{11B9}",
        nfkc: "\u{D15E}",
        nfkd: "\u{1110}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D15F}",
        nfc: "\u{D15F}",
        nfd: "\u{1110}\u{1166}\u{11BA}",
        nfkc: "\u{D15F}",
        nfkd: "\u{1110}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D160}",
        nfc: "\u{D160}",
        nfd: "\u{1110}\u{1166}\u{11BB}",
        nfkc: "\u{D160}",
        nfkd: "\u{1110}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D161}",
        nfc: "\u{D161}",
        nfd: "\u{1110}\u{1166}\u{11BC}",
        nfkc: "\u{D161}",
        nfkd: "\u{1110}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D162}",
        nfc: "\u{D162}",
        nfd: "\u{1110}\u{1166}\u{11BD}",
        nfkc: "\u{D162}",
        nfkd: "\u{1110}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D163}",
        nfc: "\u{D163}",
        nfd: "\u{1110}\u{1166}\u{11BE}",
        nfkc: "\u{D163}",
        nfkd: "\u{1110}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D164}",
        nfc: "\u{D164}",
        nfd: "\u{1110}\u{1166}\u{11BF}",
        nfkc: "\u{D164}",
        nfkd: "\u{1110}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D165}",
        nfc: "\u{D165}",
        nfd: "\u{1110}\u{1166}\u{11C0}",
        nfkc: "\u{D165}",
        nfkd: "\u{1110}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D166}",
        nfc: "\u{D166}",
        nfd: "\u{1110}\u{1166}\u{11C1}",
        nfkc: "\u{D166}",
        nfkd: "\u{1110}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D167}",
        nfc: "\u{D167}",
        nfd: "\u{1110}\u{1166}\u{11C2}",
        nfkc: "\u{D167}",
        nfkd: "\u{1110}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D168}",
        nfc: "\u{D168}",
        nfd: "\u{1110}\u{1167}",
        nfkc: "\u{D168}",
        nfkd: "\u{1110}\u{1167}",
    },
    NormalizationTest {
        source: "\u{D169}",
        nfc: "\u{D169}",
        nfd: "\u{1110}\u{1167}\u{11A8}",
        nfkc: "\u{D169}",
        nfkd: "\u{1110}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D16A}",
        nfc: "\u{D16A}",
        nfd: "\u{1110}\u{1167}\u{11A9}",
        nfkc: "\u{D16A}",
        nfkd: "\u{1110}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D16B}",
        nfc: "\u{D16B}",
        nfd: "\u{1110}\u{1167}\u{11AA}",
        nfkc: "\u{D16B}",
        nfkd: "\u{1110}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D16C}",
        nfc: "\u{D16C}",
        nfd: "\u{1110}\u{1167}\u{11AB}",
        nfkc: "\u{D16C}",
        nfkd: "\u{1110}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D16D}",
        nfc: "\u{D16D}",
        nfd: "\u{1110}\u{1167}\u{11AC}",
        nfkc: "\u{D16D}",
        nfkd: "\u{1110}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D16E}",
        nfc: "\u{D16E}",
        nfd: "\u{1110}\u{1167}\u{11AD}",
        nfkc: "\u{D16E}",
        nfkd: "\u{1110}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D16F}",
        nfc: "\u{D16F}",
        nfd: "\u{1110}\u{1167}\u{11AE}",
        nfkc: "\u{D16F}",
        nfkd: "\u{1110}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D170}",
        nfc: "\u{D170}",
        nfd: "\u{1110}\u{1167}\u{11AF}",
        nfkc: "\u{D170}",
        nfkd: "\u{1110}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D171}",
        nfc: "\u{D171}",
        nfd: "\u{1110}\u{1167}\u{11B0}",
        nfkc: "\u{D171}",
        nfkd: "\u{1110}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D172}",
        nfc: "\u{D172}",
        nfd: "\u{1110}\u{1167}\u{11B1}",
        nfkc: "\u{D172}",
        nfkd: "\u{1110}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D173}",
        nfc: "\u{D173}",
        nfd: "\u{1110}\u{1167}\u{11B2}",
        nfkc: "\u{D173}",
        nfkd: "\u{1110}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D174}",
        nfc: "\u{D174}",
        nfd: "\u{1110}\u{1167}\u{11B3}",
        nfkc: "\u{D174}",
        nfkd: "\u{1110}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D175}",
        nfc: "\u{D175}",
        nfd: "\u{1110}\u{1167}\u{11B4}",
        nfkc: "\u{D175}",
        nfkd: "\u{1110}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D176}",
        nfc: "\u{D176}",
        nfd: "\u{1110}\u{1167}\u{11B5}",
        nfkc: "\u{D176}",
        nfkd: "\u{1110}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D177}",
        nfc: "\u{D177}",
        nfd: "\u{1110}\u{1167}\u{11B6}",
        nfkc: "\u{D177}",
        nfkd: "\u{1110}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D178}",
        nfc: "\u{D178}",
        nfd: "\u{1110}\u{1167}\u{11B7}",
        nfkc: "\u{D178}",
        nfkd: "\u{1110}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D179}",
        nfc: "\u{D179}",
        nfd: "\u{1110}\u{1167}\u{11B8}",
        nfkc: "\u{D179}",
        nfkd: "\u{1110}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D17A}",
        nfc: "\u{D17A}",
        nfd: "\u{1110}\u{1167}\u{11B9}",
        nfkc: "\u{D17A}",
        nfkd: "\u{1110}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D17B}",
        nfc: "\u{D17B}",
        nfd: "\u{1110}\u{1167}\u{11BA}",
        nfkc: "\u{D17B}",
        nfkd: "\u{1110}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D17C}",
        nfc: "\u{D17C}",
        nfd: "\u{1110}\u{1167}\u{11BB}",
        nfkc: "\u{D17C}",
        nfkd: "\u{1110}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D17D}",
        nfc: "\u{D17D}",
        nfd: "\u{1110}\u{1167}\u{11BC}",
        nfkc: "\u{D17D}",
        nfkd: "\u{1110}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D17E}",
        nfc: "\u{D17E}",
        nfd: "\u{1110}\u{1167}\u{11BD}",
        nfkc: "\u{D17E}",
        nfkd: "\u{1110}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D17F}",
        nfc: "\u{D17F}",
        nfd: "\u{1110}\u{1167}\u{11BE}",
        nfkc: "\u{D17F}",
        nfkd: "\u{1110}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D180}",
        nfc: "\u{D180}",
        nfd: "\u{1110}\u{1167}\u{11BF}",
        nfkc: "\u{D180}",
        nfkd: "\u{1110}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D181}",
        nfc: "\u{D181}",
        nfd: "\u{1110}\u{1167}\u{11C0}",
        nfkc: "\u{D181}",
        nfkd: "\u{1110}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D182}",
        nfc: "\u{D182}",
        nfd: "\u{1110}\u{1167}\u{11C1}",
        nfkc: "\u{D182}",
        nfkd: "\u{1110}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D183}",
        nfc: "\u{D183}",
        nfd: "\u{1110}\u{1167}\u{11C2}",
        nfkc: "\u{D183}",
        nfkd: "\u{1110}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D184}",
        nfc: "\u{D184}",
        nfd: "\u{1110}\u{1168}",
        nfkc: "\u{D184}",
        nfkd: "\u{1110}\u{1168}",
    },
    NormalizationTest {
        source: "\u{D185}",
        nfc: "\u{D185}",
        nfd: "\u{1110}\u{1168}\u{11A8}",
        nfkc: "\u{D185}",
        nfkd: "\u{1110}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D186}",
        nfc: "\u{D186}",
        nfd: "\u{1110}\u{1168}\u{11A9}",
        nfkc: "\u{D186}",
        nfkd: "\u{1110}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D187}",
        nfc: "\u{D187}",
        nfd: "\u{1110}\u{1168}\u{11AA}",
        nfkc: "\u{D187}",
        nfkd: "\u{1110}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D188}",
        nfc: "\u{D188}",
        nfd: "\u{1110}\u{1168}\u{11AB}",
        nfkc: "\u{D188}",
        nfkd: "\u{1110}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D189}",
        nfc: "\u{D189}",
        nfd: "\u{1110}\u{1168}\u{11AC}",
        nfkc: "\u{D189}",
        nfkd: "\u{1110}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D18A}",
        nfc: "\u{D18A}",
        nfd: "\u{1110}\u{1168}\u{11AD}",
        nfkc: "\u{D18A}",
        nfkd: "\u{1110}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D18B}",
        nfc: "\u{D18B}",
        nfd: "\u{1110}\u{1168}\u{11AE}",
        nfkc: "\u{D18B}",
        nfkd: "\u{1110}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D18C}",
        nfc: "\u{D18C}",
        nfd: "\u{1110}\u{1168}\u{11AF}",
        nfkc: "\u{D18C}",
        nfkd: "\u{1110}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D18D}",
        nfc: "\u{D18D}",
        nfd: "\u{1110}\u{1168}\u{11B0}",
        nfkc: "\u{D18D}",
        nfkd: "\u{1110}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D18E}",
        nfc: "\u{D18E}",
        nfd: "\u{1110}\u{1168}\u{11B1}",
        nfkc: "\u{D18E}",
        nfkd: "\u{1110}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D18F}",
        nfc: "\u{D18F}",
        nfd: "\u{1110}\u{1168}\u{11B2}",
        nfkc: "\u{D18F}",
        nfkd: "\u{1110}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D190}",
        nfc: "\u{D190}",
        nfd: "\u{1110}\u{1168}\u{11B3}",
        nfkc: "\u{D190}",
        nfkd: "\u{1110}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D191}",
        nfc: "\u{D191}",
        nfd: "\u{1110}\u{1168}\u{11B4}",
        nfkc: "\u{D191}",
        nfkd: "\u{1110}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D192}",
        nfc: "\u{D192}",
        nfd: "\u{1110}\u{1168}\u{11B5}",
        nfkc: "\u{D192}",
        nfkd: "\u{1110}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D193}",
        nfc: "\u{D193}",
        nfd: "\u{1110}\u{1168}\u{11B6}",
        nfkc: "\u{D193}",
        nfkd: "\u{1110}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D194}",
        nfc: "\u{D194}",
        nfd: "\u{1110}\u{1168}\u{11B7}",
        nfkc: "\u{D194}",
        nfkd: "\u{1110}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D195}",
        nfc: "\u{D195}",
        nfd: "\u{1110}\u{1168}\u{11B8}",
        nfkc: "\u{D195}",
        nfkd: "\u{1110}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D196}",
        nfc: "\u{D196}",
        nfd: "\u{1110}\u{1168}\u{11B9}",
        nfkc: "\u{D196}",
        nfkd: "\u{1110}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D197}",
        nfc: "\u{D197}",
        nfd: "\u{1110}\u{1168}\u{11BA}",
        nfkc: "\u{D197}",
        nfkd: "\u{1110}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D198}",
        nfc: "\u{D198}",
        nfd: "\u{1110}\u{1168}\u{11BB}",
        nfkc: "\u{D198}",
        nfkd: "\u{1110}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D199}",
        nfc: "\u{D199}",
        nfd: "\u{1110}\u{1168}\u{11BC}",
        nfkc: "\u{D199}",
        nfkd: "\u{1110}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D19A}",
        nfc: "\u{D19A}",
        nfd: "\u{1110}\u{1168}\u{11BD}",
        nfkc: "\u{D19A}",
        nfkd: "\u{1110}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D19B}",
        nfc: "\u{D19B}",
        nfd: "\u{1110}\u{1168}\u{11BE}",
        nfkc: "\u{D19B}",
        nfkd: "\u{1110}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D19C}",
        nfc: "\u{D19C}",
        nfd: "\u{1110}\u{1168}\u{11BF}",
        nfkc: "\u{D19C}",
        nfkd: "\u{1110}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D19D}",
        nfc: "\u{D19D}",
        nfd: "\u{1110}\u{1168}\u{11C0}",
        nfkc: "\u{D19D}",
        nfkd: "\u{1110}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D19E}",
        nfc: "\u{D19E}",
        nfd: "\u{1110}\u{1168}\u{11C1}",
        nfkc: "\u{D19E}",
        nfkd: "\u{1110}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D19F}",
        nfc: "\u{D19F}",
        nfd: "\u{1110}\u{1168}\u{11C2}",
        nfkc: "\u{D19F}",
        nfkd: "\u{1110}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D1A0}",
        nfc: "\u{D1A0}",
        nfd: "\u{1110}\u{1169}",
        nfkc: "\u{D1A0}",
        nfkd: "\u{1110}\u{1169}",
    },
    NormalizationTest {
        source: "\u{D1A1}",
        nfc: "\u{D1A1}",
        nfd: "\u{1110}\u{1169}\u{11A8}",
        nfkc: "\u{D1A1}",
        nfkd: "\u{1110}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D1A2}",
        nfc: "\u{D1A2}",
        nfd: "\u{1110}\u{1169}\u{11A9}",
        nfkc: "\u{D1A2}",
        nfkd: "\u{1110}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D1A3}",
        nfc: "\u{D1A3}",
        nfd: "\u{1110}\u{1169}\u{11AA}",
        nfkc: "\u{D1A3}",
        nfkd: "\u{1110}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D1A4}",
        nfc: "\u{D1A4}",
        nfd: "\u{1110}\u{1169}\u{11AB}",
        nfkc: "\u{D1A4}",
        nfkd: "\u{1110}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D1A5}",
        nfc: "\u{D1A5}",
        nfd: "\u{1110}\u{1169}\u{11AC}",
        nfkc: "\u{D1A5}",
        nfkd: "\u{1110}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D1A6}",
        nfc: "\u{D1A6}",
        nfd: "\u{1110}\u{1169}\u{11AD}",
        nfkc: "\u{D1A6}",
        nfkd: "\u{1110}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D1A7}",
        nfc: "\u{D1A7}",
        nfd: "\u{1110}\u{1169}\u{11AE}",
        nfkc: "\u{D1A7}",
        nfkd: "\u{1110}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D1A8}",
        nfc: "\u{D1A8}",
        nfd: "\u{1110}\u{1169}\u{11AF}",
        nfkc: "\u{D1A8}",
        nfkd: "\u{1110}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D1A9}",
        nfc: "\u{D1A9}",
        nfd: "\u{1110}\u{1169}\u{11B0}",
        nfkc: "\u{D1A9}",
        nfkd: "\u{1110}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D1AA}",
        nfc: "\u{D1AA}",
        nfd: "\u{1110}\u{1169}\u{11B1}",
        nfkc: "\u{D1AA}",
        nfkd: "\u{1110}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D1AB}",
        nfc: "\u{D1AB}",
        nfd: "\u{1110}\u{1169}\u{11B2}",
        nfkc: "\u{D1AB}",
        nfkd: "\u{1110}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D1AC}",
        nfc: "\u{D1AC}",
        nfd: "\u{1110}\u{1169}\u{11B3}",
        nfkc: "\u{D1AC}",
        nfkd: "\u{1110}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D1AD}",
        nfc: "\u{D1AD}",
        nfd: "\u{1110}\u{1169}\u{11B4}",
        nfkc: "\u{D1AD}",
        nfkd: "\u{1110}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D1AE}",
        nfc: "\u{D1AE}",
        nfd: "\u{1110}\u{1169}\u{11B5}",
        nfkc: "\u{D1AE}",
        nfkd: "\u{1110}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D1AF}",
        nfc: "\u{D1AF}",
        nfd: "\u{1110}\u{1169}\u{11B6}",
        nfkc: "\u{D1AF}",
        nfkd: "\u{1110}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D1B0}",
        nfc: "\u{D1B0}",
        nfd: "\u{1110}\u{1169}\u{11B7}",
        nfkc: "\u{D1B0}",
        nfkd: "\u{1110}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D1B1}",
        nfc: "\u{D1B1}",
        nfd: "\u{1110}\u{1169}\u{11B8}",
        nfkc: "\u{D1B1}",
        nfkd: "\u{1110}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D1B2}",
        nfc: "\u{D1B2}",
        nfd: "\u{1110}\u{1169}\u{11B9}",
        nfkc: "\u{D1B2}",
        nfkd: "\u{1110}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D1B3}",
        nfc: "\u{D1B3}",
        nfd: "\u{1110}\u{1169}\u{11BA}",
        nfkc: "\u{D1B3}",
        nfkd: "\u{1110}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D1B4}",
        nfc: "\u{D1B4}",
        nfd: "\u{1110}\u{1169}\u{11BB}",
        nfkc: "\u{D1B4}",
        nfkd: "\u{1110}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D1B5}",
        nfc: "\u{D1B5}",
        nfd: "\u{1110}\u{1169}\u{11BC}",
        nfkc: "\u{D1B5}",
        nfkd: "\u{1110}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D1B6}",
        nfc: "\u{D1B6}",
        nfd: "\u{1110}\u{1169}\u{11BD}",
        nfkc: "\u{D1B6}",
        nfkd: "\u{1110}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D1B7}",
        nfc: "\u{D1B7}",
        nfd: "\u{1110}\u{1169}\u{11BE}",
        nfkc: "\u{D1B7}",
        nfkd: "\u{1110}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D1B8}",
        nfc: "\u{D1B8}",
        nfd: "\u{1110}\u{1169}\u{11BF}",
        nfkc: "\u{D1B8}",
        nfkd: "\u{1110}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D1B9}",
        nfc: "\u{D1B9}",
        nfd: "\u{1110}\u{1169}\u{11C0}",
        nfkc: "\u{D1B9}",
        nfkd: "\u{1110}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D1BA}",
        nfc: "\u{D1BA}",
        nfd: "\u{1110}\u{1169}\u{11C1}",
        nfkc: "\u{D1BA}",
        nfkd: "\u{1110}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D1BB}",
        nfc: "\u{D1BB}",
        nfd: "\u{1110}\u{1169}\u{11C2}",
        nfkc: "\u{D1BB}",
        nfkd: "\u{1110}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D1BC}",
        nfc: "\u{D1BC}",
        nfd: "\u{1110}\u{116A}",
        nfkc: "\u{D1BC}",
        nfkd: "\u{1110}\u{116A}",
    },
    NormalizationTest {
        source: "\u{D1BD}",
        nfc: "\u{D1BD}",
        nfd: "\u{1110}\u{116A}\u{11A8}",
        nfkc: "\u{D1BD}",
        nfkd: "\u{1110}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D1BE}",
        nfc: "\u{D1BE}",
        nfd: "\u{1110}\u{116A}\u{11A9}",
        nfkc: "\u{D1BE}",
        nfkd: "\u{1110}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D1BF}",
        nfc: "\u{D1BF}",
        nfd: "\u{1110}\u{116A}\u{11AA}",
        nfkc: "\u{D1BF}",
        nfkd: "\u{1110}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D1C0}",
        nfc: "\u{D1C0}",
        nfd: "\u{1110}\u{116A}\u{11AB}",
        nfkc: "\u{D1C0}",
        nfkd: "\u{1110}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D1C1}",
        nfc: "\u{D1C1}",
        nfd: "\u{1110}\u{116A}\u{11AC}",
        nfkc: "\u{D1C1}",
        nfkd: "\u{1110}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D1C2}",
        nfc: "\u{D1C2}",
        nfd: "\u{1110}\u{116A}\u{11AD}",
        nfkc: "\u{D1C2}",
        nfkd: "\u{1110}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D1C3}",
        nfc: "\u{D1C3}",
        nfd: "\u{1110}\u{116A}\u{11AE}",
        nfkc: "\u{D1C3}",
        nfkd: "\u{1110}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D1C4}",
        nfc: "\u{D1C4}",
        nfd: "\u{1110}\u{116A}\u{11AF}",
        nfkc: "\u{D1C4}",
        nfkd: "\u{1110}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D1C5}",
        nfc: "\u{D1C5}",
        nfd: "\u{1110}\u{116A}\u{11B0}",
        nfkc: "\u{D1C5}",
        nfkd: "\u{1110}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D1C6}",
        nfc: "\u{D1C6}",
        nfd: "\u{1110}\u{116A}\u{11B1}",
        nfkc: "\u{D1C6}",
        nfkd: "\u{1110}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D1C7}",
        nfc: "\u{D1C7}",
        nfd: "\u{1110}\u{116A}\u{11B2}",
        nfkc: "\u{D1C7}",
        nfkd: "\u{1110}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D1C8}",
        nfc: "\u{D1C8}",
        nfd: "\u{1110}\u{116A}\u{11B3}",
        nfkc: "\u{D1C8}",
        nfkd: "\u{1110}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D1C9}",
        nfc: "\u{D1C9}",
        nfd: "\u{1110}\u{116A}\u{11B4}",
        nfkc: "\u{D1C9}",
        nfkd: "\u{1110}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D1CA}",
        nfc: "\u{D1CA}",
        nfd: "\u{1110}\u{116A}\u{11B5}",
        nfkc: "\u{D1CA}",
        nfkd: "\u{1110}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D1CB}",
        nfc: "\u{D1CB}",
        nfd: "\u{1110}\u{116A}\u{11B6}",
        nfkc: "\u{D1CB}",
        nfkd: "\u{1110}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D1CC}",
        nfc: "\u{D1CC}",
        nfd: "\u{1110}\u{116A}\u{11B7}",
        nfkc: "\u{D1CC}",
        nfkd: "\u{1110}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D1CD}",
        nfc: "\u{D1CD}",
        nfd: "\u{1110}\u{116A}\u{11B8}",
        nfkc: "\u{D1CD}",
        nfkd: "\u{1110}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D1CE}",
        nfc: "\u{D1CE}",
        nfd: "\u{1110}\u{116A}\u{11B9}",
        nfkc: "\u{D1CE}",
        nfkd: "\u{1110}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D1CF}",
        nfc: "\u{D1CF}",
        nfd: "\u{1110}\u{116A}\u{11BA}",
        nfkc: "\u{D1CF}",
        nfkd: "\u{1110}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D1D0}",
        nfc: "\u{D1D0}",
        nfd: "\u{1110}\u{116A}\u{11BB}",
        nfkc: "\u{D1D0}",
        nfkd: "\u{1110}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D1D1}",
        nfc: "\u{D1D1}",
        nfd: "\u{1110}\u{116A}\u{11BC}",
        nfkc: "\u{D1D1}",
        nfkd: "\u{1110}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D1D2}",
        nfc: "\u{D1D2}",
        nfd: "\u{1110}\u{116A}\u{11BD}",
        nfkc: "\u{D1D2}",
        nfkd: "\u{1110}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D1D3}",
        nfc: "\u{D1D3}",
        nfd: "\u{1110}\u{116A}\u{11BE}",
        nfkc: "\u{D1D3}",
        nfkd: "\u{1110}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D1D4}",
        nfc: "\u{D1D4}",
        nfd: "\u{1110}\u{116A}\u{11BF}",
        nfkc: "\u{D1D4}",
        nfkd: "\u{1110}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D1D5}",
        nfc: "\u{D1D5}",
        nfd: "\u{1110}\u{116A}\u{11C0}",
        nfkc: "\u{D1D5}",
        nfkd: "\u{1110}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D1D6}",
        nfc: "\u{D1D6}",
        nfd: "\u{1110}\u{116A}\u{11C1}",
        nfkc: "\u{D1D6}",
        nfkd: "\u{1110}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D1D7}",
        nfc: "\u{D1D7}",
        nfd: "\u{1110}\u{116A}\u{11C2}",
        nfkc: "\u{D1D7}",
        nfkd: "\u{1110}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D1D8}",
        nfc: "\u{D1D8}",
        nfd: "\u{1110}\u{116B}",
        nfkc: "\u{D1D8}",
        nfkd: "\u{1110}\u{116B}",
    },
    NormalizationTest {
        source: "\u{D1D9}",
        nfc: "\u{D1D9}",
        nfd: "\u{1110}\u{116B}\u{11A8}",
        nfkc: "\u{D1D9}",
        nfkd: "\u{1110}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D1DA}",
        nfc: "\u{D1DA}",
        nfd: "\u{1110}\u{116B}\u{11A9}",
        nfkc: "\u{D1DA}",
        nfkd: "\u{1110}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D1DB}",
        nfc: "\u{D1DB}",
        nfd: "\u{1110}\u{116B}\u{11AA}",
        nfkc: "\u{D1DB}",
        nfkd: "\u{1110}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D1DC}",
        nfc: "\u{D1DC}",
        nfd: "\u{1110}\u{116B}\u{11AB}",
        nfkc: "\u{D1DC}",
        nfkd: "\u{1110}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D1DD}",
        nfc: "\u{D1DD}",
        nfd: "\u{1110}\u{116B}\u{11AC}",
        nfkc: "\u{D1DD}",
        nfkd: "\u{1110}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D1DE}",
        nfc: "\u{D1DE}",
        nfd: "\u{1110}\u{116B}\u{11AD}",
        nfkc: "\u{D1DE}",
        nfkd: "\u{1110}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D1DF}",
        nfc: "\u{D1DF}",
        nfd: "\u{1110}\u{116B}\u{11AE}",
        nfkc: "\u{D1DF}",
        nfkd: "\u{1110}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D1E0}",
        nfc: "\u{D1E0}",
        nfd: "\u{1110}\u{116B}\u{11AF}",
        nfkc: "\u{D1E0}",
        nfkd: "\u{1110}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D1E1}",
        nfc: "\u{D1E1}",
        nfd: "\u{1110}\u{116B}\u{11B0}",
        nfkc: "\u{D1E1}",
        nfkd: "\u{1110}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D1E2}",
        nfc: "\u{D1E2}",
        nfd: "\u{1110}\u{116B}\u{11B1}",
        nfkc: "\u{D1E2}",
        nfkd: "\u{1110}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D1E3}",
        nfc: "\u{D1E3}",
        nfd: "\u{1110}\u{116B}\u{11B2}",
        nfkc: "\u{D1E3}",
        nfkd: "\u{1110}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D1E4}",
        nfc: "\u{D1E4}",
        nfd: "\u{1110}\u{116B}\u{11B3}",
        nfkc: "\u{D1E4}",
        nfkd: "\u{1110}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D1E5}",
        nfc: "\u{D1E5}",
        nfd: "\u{1110}\u{116B}\u{11B4}",
        nfkc: "\u{D1E5}",
        nfkd: "\u{1110}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D1E6}",
        nfc: "\u{D1E6}",
        nfd: "\u{1110}\u{116B}\u{11B5}",
        nfkc: "\u{D1E6}",
        nfkd: "\u{1110}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D1E7}",
        nfc: "\u{D1E7}",
        nfd: "\u{1110}\u{116B}\u{11B6}",
        nfkc: "\u{D1E7}",
        nfkd: "\u{1110}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D1E8}",
        nfc: "\u{D1E8}",
        nfd: "\u{1110}\u{116B}\u{11B7}",
        nfkc: "\u{D1E8}",
        nfkd: "\u{1110}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D1E9}",
        nfc: "\u{D1E9}",
        nfd: "\u{1110}\u{116B}\u{11B8}",
        nfkc: "\u{D1E9}",
        nfkd: "\u{1110}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D1EA}",
        nfc: "\u{D1EA}",
        nfd: "\u{1110}\u{116B}\u{11B9}",
        nfkc: "\u{D1EA}",
        nfkd: "\u{1110}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D1EB}",
        nfc: "\u{D1EB}",
        nfd: "\u{1110}\u{116B}\u{11BA}",
        nfkc: "\u{D1EB}",
        nfkd: "\u{1110}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D1EC}",
        nfc: "\u{D1EC}",
        nfd: "\u{1110}\u{116B}\u{11BB}",
        nfkc: "\u{D1EC}",
        nfkd: "\u{1110}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D1ED}",
        nfc: "\u{D1ED}",
        nfd: "\u{1110}\u{116B}\u{11BC}",
        nfkc: "\u{D1ED}",
        nfkd: "\u{1110}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D1EE}",
        nfc: "\u{D1EE}",
        nfd: "\u{1110}\u{116B}\u{11BD}",
        nfkc: "\u{D1EE}",
        nfkd: "\u{1110}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D1EF}",
        nfc: "\u{D1EF}",
        nfd: "\u{1110}\u{116B}\u{11BE}",
        nfkc: "\u{D1EF}",
        nfkd: "\u{1110}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D1F0}",
        nfc: "\u{D1F0}",
        nfd: "\u{1110}\u{116B}\u{11BF}",
        nfkc: "\u{D1F0}",
        nfkd: "\u{1110}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D1F1}",
        nfc: "\u{D1F1}",
        nfd: "\u{1110}\u{116B}\u{11C0}",
        nfkc: "\u{D1F1}",
        nfkd: "\u{1110}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D1F2}",
        nfc: "\u{D1F2}",
        nfd: "\u{1110}\u{116B}\u{11C1}",
        nfkc: "\u{D1F2}",
        nfkd: "\u{1110}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D1F3}",
        nfc: "\u{D1F3}",
        nfd: "\u{1110}\u{116B}\u{11C2}",
        nfkc: "\u{D1F3}",
        nfkd: "\u{1110}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D1F4}",
        nfc: "\u{D1F4}",
        nfd: "\u{1110}\u{116C}",
        nfkc: "\u{D1F4}",
        nfkd: "\u{1110}\u{116C}",
    },
    NormalizationTest {
        source: "\u{D1F5}",
        nfc: "\u{D1F5}",
        nfd: "\u{1110}\u{116C}\u{11A8}",
        nfkc: "\u{D1F5}",
        nfkd: "\u{1110}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D1F6}",
        nfc: "\u{D1F6}",
        nfd: "\u{1110}\u{116C}\u{11A9}",
        nfkc: "\u{D1F6}",
        nfkd: "\u{1110}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D1F7}",
        nfc: "\u{D1F7}",
        nfd: "\u{1110}\u{116C}\u{11AA}",
        nfkc: "\u{D1F7}",
        nfkd: "\u{1110}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D1F8}",
        nfc: "\u{D1F8}",
        nfd: "\u{1110}\u{116C}\u{11AB}",
        nfkc: "\u{D1F8}",
        nfkd: "\u{1110}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D1F9}",
        nfc: "\u{D1F9}",
        nfd: "\u{1110}\u{116C}\u{11AC}",
        nfkc: "\u{D1F9}",
        nfkd: "\u{1110}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D1FA}",
        nfc: "\u{D1FA}",
        nfd: "\u{1110}\u{116C}\u{11AD}",
        nfkc: "\u{D1FA}",
        nfkd: "\u{1110}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D1FB}",
        nfc: "\u{D1FB}",
        nfd: "\u{1110}\u{116C}\u{11AE}",
        nfkc: "\u{D1FB}",
        nfkd: "\u{1110}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D1FC}",
        nfc: "\u{D1FC}",
        nfd: "\u{1110}\u{116C}\u{11AF}",
        nfkc: "\u{D1FC}",
        nfkd: "\u{1110}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D1FD}",
        nfc: "\u{D1FD}",
        nfd: "\u{1110}\u{116C}\u{11B0}",
        nfkc: "\u{D1FD}",
        nfkd: "\u{1110}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D1FE}",
        nfc: "\u{D1FE}",
        nfd: "\u{1110}\u{116C}\u{11B1}",
        nfkc: "\u{D1FE}",
        nfkd: "\u{1110}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D1FF}",
        nfc: "\u{D1FF}",
        nfd: "\u{1110}\u{116C}\u{11B2}",
        nfkc: "\u{D1FF}",
        nfkd: "\u{1110}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D200}",
        nfc: "\u{D200}",
        nfd: "\u{1110}\u{116C}\u{11B3}",
        nfkc: "\u{D200}",
        nfkd: "\u{1110}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D201}",
        nfc: "\u{D201}",
        nfd: "\u{1110}\u{116C}\u{11B4}",
        nfkc: "\u{D201}",
        nfkd: "\u{1110}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D202}",
        nfc: "\u{D202}",
        nfd: "\u{1110}\u{116C}\u{11B5}",
        nfkc: "\u{D202}",
        nfkd: "\u{1110}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D203}",
        nfc: "\u{D203}",
        nfd: "\u{1110}\u{116C}\u{11B6}",
        nfkc: "\u{D203}",
        nfkd: "\u{1110}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D204}",
        nfc: "\u{D204}",
        nfd: "\u{1110}\u{116C}\u{11B7}",
        nfkc: "\u{D204}",
        nfkd: "\u{1110}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D205}",
        nfc: "\u{D205}",
        nfd: "\u{1110}\u{116C}\u{11B8}",
        nfkc: "\u{D205}",
        nfkd: "\u{1110}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D206}",
        nfc: "\u{D206}",
        nfd: "\u{1110}\u{116C}\u{11B9}",
        nfkc: "\u{D206}",
        nfkd: "\u{1110}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D207}",
        nfc: "\u{D207}",
        nfd: "\u{1110}\u{116C}\u{11BA}",
        nfkc: "\u{D207}",
        nfkd: "\u{1110}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D208}",
        nfc: "\u{D208}",
        nfd: "\u{1110}\u{116C}\u{11BB}",
        nfkc: "\u{D208}",
        nfkd: "\u{1110}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D209}",
        nfc: "\u{D209}",
        nfd: "\u{1110}\u{116C}\u{11BC}",
        nfkc: "\u{D209}",
        nfkd: "\u{1110}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D20A}",
        nfc: "\u{D20A}",
        nfd: "\u{1110}\u{116C}\u{11BD}",
        nfkc: "\u{D20A}",
        nfkd: "\u{1110}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D20B}",
        nfc: "\u{D20B}",
        nfd: "\u{1110}\u{116C}\u{11BE}",
        nfkc: "\u{D20B}",
        nfkd: "\u{1110}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D20C}",
        nfc: "\u{D20C}",
        nfd: "\u{1110}\u{116C}\u{11BF}",
        nfkc: "\u{D20C}",
        nfkd: "\u{1110}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D20D}",
        nfc: "\u{D20D}",
        nfd: "\u{1110}\u{116C}\u{11C0}",
        nfkc: "\u{D20D}",
        nfkd: "\u{1110}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D20E}",
        nfc: "\u{D20E}",
        nfd: "\u{1110}\u{116C}\u{11C1}",
        nfkc: "\u{D20E}",
        nfkd: "\u{1110}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D20F}",
        nfc: "\u{D20F}",
        nfd: "\u{1110}\u{116C}\u{11C2}",
        nfkc: "\u{D20F}",
        nfkd: "\u{1110}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D210}",
        nfc: "\u{D210}",
        nfd: "\u{1110}\u{116D}",
        nfkc: "\u{D210}",
        nfkd: "\u{1110}\u{116D}",
    },
    NormalizationTest {
        source: "\u{D211}",
        nfc: "\u{D211}",
        nfd: "\u{1110}\u{116D}\u{11A8}",
        nfkc: "\u{D211}",
        nfkd: "\u{1110}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D212}",
        nfc: "\u{D212}",
        nfd: "\u{1110}\u{116D}\u{11A9}",
        nfkc: "\u{D212}",
        nfkd: "\u{1110}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D213}",
        nfc: "\u{D213}",
        nfd: "\u{1110}\u{116D}\u{11AA}",
        nfkc: "\u{D213}",
        nfkd: "\u{1110}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D214}",
        nfc: "\u{D214}",
        nfd: "\u{1110}\u{116D}\u{11AB}",
        nfkc: "\u{D214}",
        nfkd: "\u{1110}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D215}",
        nfc: "\u{D215}",
        nfd: "\u{1110}\u{116D}\u{11AC}",
        nfkc: "\u{D215}",
        nfkd: "\u{1110}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D216}",
        nfc: "\u{D216}",
        nfd: "\u{1110}\u{116D}\u{11AD}",
        nfkc: "\u{D216}",
        nfkd: "\u{1110}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D217}",
        nfc: "\u{D217}",
        nfd: "\u{1110}\u{116D}\u{11AE}",
        nfkc: "\u{D217}",
        nfkd: "\u{1110}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D218}",
        nfc: "\u{D218}",
        nfd: "\u{1110}\u{116D}\u{11AF}",
        nfkc: "\u{D218}",
        nfkd: "\u{1110}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D219}",
        nfc: "\u{D219}",
        nfd: "\u{1110}\u{116D}\u{11B0}",
        nfkc: "\u{D219}",
        nfkd: "\u{1110}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D21A}",
        nfc: "\u{D21A}",
        nfd: "\u{1110}\u{116D}\u{11B1}",
        nfkc: "\u{D21A}",
        nfkd: "\u{1110}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D21B}",
        nfc: "\u{D21B}",
        nfd: "\u{1110}\u{116D}\u{11B2}",
        nfkc: "\u{D21B}",
        nfkd: "\u{1110}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D21C}",
        nfc: "\u{D21C}",
        nfd: "\u{1110}\u{116D}\u{11B3}",
        nfkc: "\u{D21C}",
        nfkd: "\u{1110}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D21D}",
        nfc: "\u{D21D}",
        nfd: "\u{1110}\u{116D}\u{11B4}",
        nfkc: "\u{D21D}",
        nfkd: "\u{1110}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D21E}",
        nfc: "\u{D21E}",
        nfd: "\u{1110}\u{116D}\u{11B5}",
        nfkc: "\u{D21E}",
        nfkd: "\u{1110}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D21F}",
        nfc: "\u{D21F}",
        nfd: "\u{1110}\u{116D}\u{11B6}",
        nfkc: "\u{D21F}",
        nfkd: "\u{1110}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D220}",
        nfc: "\u{D220}",
        nfd: "\u{1110}\u{116D}\u{11B7}",
        nfkc: "\u{D220}",
        nfkd: "\u{1110}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D221}",
        nfc: "\u{D221}",
        nfd: "\u{1110}\u{116D}\u{11B8}",
        nfkc: "\u{D221}",
        nfkd: "\u{1110}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D222}",
        nfc: "\u{D222}",
        nfd: "\u{1110}\u{116D}\u{11B9}",
        nfkc: "\u{D222}",
        nfkd: "\u{1110}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D223}",
        nfc: "\u{D223}",
        nfd: "\u{1110}\u{116D}\u{11BA}",
        nfkc: "\u{D223}",
        nfkd: "\u{1110}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D224}",
        nfc: "\u{D224}",
        nfd: "\u{1110}\u{116D}\u{11BB}",
        nfkc: "\u{D224}",
        nfkd: "\u{1110}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D225}",
        nfc: "\u{D225}",
        nfd: "\u{1110}\u{116D}\u{11BC}",
        nfkc: "\u{D225}",
        nfkd: "\u{1110}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D226}",
        nfc: "\u{D226}",
        nfd: "\u{1110}\u{116D}\u{11BD}",
        nfkc: "\u{D226}",
        nfkd: "\u{1110}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D227}",
        nfc: "\u{D227}",
        nfd: "\u{1110}\u{116D}\u{11BE}",
        nfkc: "\u{D227}",
        nfkd: "\u{1110}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D228}",
        nfc: "\u{D228}",
        nfd: "\u{1110}\u{116D}\u{11BF}",
        nfkc: "\u{D228}",
        nfkd: "\u{1110}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D229}",
        nfc: "\u{D229}",
        nfd: "\u{1110}\u{116D}\u{11C0}",
        nfkc: "\u{D229}",
        nfkd: "\u{1110}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D22A}",
        nfc: "\u{D22A}",
        nfd: "\u{1110}\u{116D}\u{11C1}",
        nfkc: "\u{D22A}",
        nfkd: "\u{1110}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D22B}",
        nfc: "\u{D22B}",
        nfd: "\u{1110}\u{116D}\u{11C2}",
        nfkc: "\u{D22B}",
        nfkd: "\u{1110}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D22C}",
        nfc: "\u{D22C}",
        nfd: "\u{1110}\u{116E}",
        nfkc: "\u{D22C}",
        nfkd: "\u{1110}\u{116E}",
    },
    NormalizationTest {
        source: "\u{D22D}",
        nfc: "\u{D22D}",
        nfd: "\u{1110}\u{116E}\u{11A8}",
        nfkc: "\u{D22D}",
        nfkd: "\u{1110}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D22E}",
        nfc: "\u{D22E}",
        nfd: "\u{1110}\u{116E}\u{11A9}",
        nfkc: "\u{D22E}",
        nfkd: "\u{1110}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D22F}",
        nfc: "\u{D22F}",
        nfd: "\u{1110}\u{116E}\u{11AA}",
        nfkc: "\u{D22F}",
        nfkd: "\u{1110}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D230}",
        nfc: "\u{D230}",
        nfd: "\u{1110}\u{116E}\u{11AB}",
        nfkc: "\u{D230}",
        nfkd: "\u{1110}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D231}",
        nfc: "\u{D231}",
        nfd: "\u{1110}\u{116E}\u{11AC}",
        nfkc: "\u{D231}",
        nfkd: "\u{1110}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D232}",
        nfc: "\u{D232}",
        nfd: "\u{1110}\u{116E}\u{11AD}",
        nfkc: "\u{D232}",
        nfkd: "\u{1110}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D233}",
        nfc: "\u{D233}",
        nfd: "\u{1110}\u{116E}\u{11AE}",
        nfkc: "\u{D233}",
        nfkd: "\u{1110}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D234}",
        nfc: "\u{D234}",
        nfd: "\u{1110}\u{116E}\u{11AF}",
        nfkc: "\u{D234}",
        nfkd: "\u{1110}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D235}",
        nfc: "\u{D235}",
        nfd: "\u{1110}\u{116E}\u{11B0}",
        nfkc: "\u{D235}",
        nfkd: "\u{1110}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D236}",
        nfc: "\u{D236}",
        nfd: "\u{1110}\u{116E}\u{11B1}",
        nfkc: "\u{D236}",
        nfkd: "\u{1110}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D237}",
        nfc: "\u{D237}",
        nfd: "\u{1110}\u{116E}\u{11B2}",
        nfkc: "\u{D237}",
        nfkd: "\u{1110}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D238}",
        nfc: "\u{D238}",
        nfd: "\u{1110}\u{116E}\u{11B3}",
        nfkc: "\u{D238}",
        nfkd: "\u{1110}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D239}",
        nfc: "\u{D239}",
        nfd: "\u{1110}\u{116E}\u{11B4}",
        nfkc: "\u{D239}",
        nfkd: "\u{1110}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D23A}",
        nfc: "\u{D23A}",
        nfd: "\u{1110}\u{116E}\u{11B5}",
        nfkc: "\u{D23A}",
        nfkd: "\u{1110}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D23B}",
        nfc: "\u{D23B}",
        nfd: "\u{1110}\u{116E}\u{11B6}",
        nfkc: "\u{D23B}",
        nfkd: "\u{1110}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D23C}",
        nfc: "\u{D23C}",
        nfd: "\u{1110}\u{116E}\u{11B7}",
        nfkc: "\u{D23C}",
        nfkd: "\u{1110}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D23D}",
        nfc: "\u{D23D}",
        nfd: "\u{1110}\u{116E}\u{11B8}",
        nfkc: "\u{D23D}",
        nfkd: "\u{1110}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D23E}",
        nfc: "\u{D23E}",
        nfd: "\u{1110}\u{116E}\u{11B9}",
        nfkc: "\u{D23E}",
        nfkd: "\u{1110}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D23F}",
        nfc: "\u{D23F}",
        nfd: "\u{1110}\u{116E}\u{11BA}",
        nfkc: "\u{D23F}",
        nfkd: "\u{1110}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D240}",
        nfc: "\u{D240}",
        nfd: "\u{1110}\u{116E}\u{11BB}",
        nfkc: "\u{D240}",
        nfkd: "\u{1110}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D241}",
        nfc: "\u{D241}",
        nfd: "\u{1110}\u{116E}\u{11BC}",
        nfkc: "\u{D241}",
        nfkd: "\u{1110}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D242}",
        nfc: "\u{D242}",
        nfd: "\u{1110}\u{116E}\u{11BD}",
        nfkc: "\u{D242}",
        nfkd: "\u{1110}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D243}",
        nfc: "\u{D243}",
        nfd: "\u{1110}\u{116E}\u{11BE}",
        nfkc: "\u{D243}",
        nfkd: "\u{1110}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D244}",
        nfc: "\u{D244}",
        nfd: "\u{1110}\u{116E}\u{11BF}",
        nfkc: "\u{D244}",
        nfkd: "\u{1110}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D245}",
        nfc: "\u{D245}",
        nfd: "\u{1110}\u{116E}\u{11C0}",
        nfkc: "\u{D245}",
        nfkd: "\u{1110}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D246}",
        nfc: "\u{D246}",
        nfd: "\u{1110}\u{116E}\u{11C1}",
        nfkc: "\u{D246}",
        nfkd: "\u{1110}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D247}",
        nfc: "\u{D247}",
        nfd: "\u{1110}\u{116E}\u{11C2}",
        nfkc: "\u{D247}",
        nfkd: "\u{1110}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D248}",
        nfc: "\u{D248}",
        nfd: "\u{1110}\u{116F}",
        nfkc: "\u{D248}",
        nfkd: "\u{1110}\u{116F}",
    },
    NormalizationTest {
        source: "\u{D249}",
        nfc: "\u{D249}",
        nfd: "\u{1110}\u{116F}\u{11A8}",
        nfkc: "\u{D249}",
        nfkd: "\u{1110}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D24A}",
        nfc: "\u{D24A}",
        nfd: "\u{1110}\u{116F}\u{11A9}",
        nfkc: "\u{D24A}",
        nfkd: "\u{1110}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D24B}",
        nfc: "\u{D24B}",
        nfd: "\u{1110}\u{116F}\u{11AA}",
        nfkc: "\u{D24B}",
        nfkd: "\u{1110}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D24C}",
        nfc: "\u{D24C}",
        nfd: "\u{1110}\u{116F}\u{11AB}",
        nfkc: "\u{D24C}",
        nfkd: "\u{1110}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D24D}",
        nfc: "\u{D24D}",
        nfd: "\u{1110}\u{116F}\u{11AC}",
        nfkc: "\u{D24D}",
        nfkd: "\u{1110}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D24E}",
        nfc: "\u{D24E}",
        nfd: "\u{1110}\u{116F}\u{11AD}",
        nfkc: "\u{D24E}",
        nfkd: "\u{1110}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D24F}",
        nfc: "\u{D24F}",
        nfd: "\u{1110}\u{116F}\u{11AE}",
        nfkc: "\u{D24F}",
        nfkd: "\u{1110}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D250}",
        nfc: "\u{D250}",
        nfd: "\u{1110}\u{116F}\u{11AF}",
        nfkc: "\u{D250}",
        nfkd: "\u{1110}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D251}",
        nfc: "\u{D251}",
        nfd: "\u{1110}\u{116F}\u{11B0}",
        nfkc: "\u{D251}",
        nfkd: "\u{1110}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D252}",
        nfc: "\u{D252}",
        nfd: "\u{1110}\u{116F}\u{11B1}",
        nfkc: "\u{D252}",
        nfkd: "\u{1110}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D253}",
        nfc: "\u{D253}",
        nfd: "\u{1110}\u{116F}\u{11B2}",
        nfkc: "\u{D253}",
        nfkd: "\u{1110}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D254}",
        nfc: "\u{D254}",
        nfd: "\u{1110}\u{116F}\u{11B3}",
        nfkc: "\u{D254}",
        nfkd: "\u{1110}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D255}",
        nfc: "\u{D255}",
        nfd: "\u{1110}\u{116F}\u{11B4}",
        nfkc: "\u{D255}",
        nfkd: "\u{1110}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D256}",
        nfc: "\u{D256}",
        nfd: "\u{1110}\u{116F}\u{11B5}",
        nfkc: "\u{D256}",
        nfkd: "\u{1110}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D257}",
        nfc: "\u{D257}",
        nfd: "\u{1110}\u{116F}\u{11B6}",
        nfkc: "\u{D257}",
        nfkd: "\u{1110}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D258}",
        nfc: "\u{D258}",
        nfd: "\u{1110}\u{116F}\u{11B7}",
        nfkc: "\u{D258}",
        nfkd: "\u{1110}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D259}",
        nfc: "\u{D259}",
        nfd: "\u{1110}\u{116F}\u{11B8}",
        nfkc: "\u{D259}",
        nfkd: "\u{1110}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D25A}",
        nfc: "\u{D25A}",
        nfd: "\u{1110}\u{116F}\u{11B9}",
        nfkc: "\u{D25A}",
        nfkd: "\u{1110}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D25B}",
        nfc: "\u{D25B}",
        nfd: "\u{1110}\u{116F}\u{11BA}",
        nfkc: "\u{D25B}",
        nfkd: "\u{1110}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D25C}",
        nfc: "\u{D25C}",
        nfd: "\u{1110}\u{116F}\u{11BB}",
        nfkc: "\u{D25C}",
        nfkd: "\u{1110}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D25D}",
        nfc: "\u{D25D}",
        nfd: "\u{1110}\u{116F}\u{11BC}",
        nfkc: "\u{D25D}",
        nfkd: "\u{1110}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D25E}",
        nfc: "\u{D25E}",
        nfd: "\u{1110}\u{116F}\u{11BD}",
        nfkc: "\u{D25E}",
        nfkd: "\u{1110}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D25F}",
        nfc: "\u{D25F}",
        nfd: "\u{1110}\u{116F}\u{11BE}",
        nfkc: "\u{D25F}",
        nfkd: "\u{1110}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D260}",
        nfc: "\u{D260}",
        nfd: "\u{1110}\u{116F}\u{11BF}",
        nfkc: "\u{D260}",
        nfkd: "\u{1110}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D261}",
        nfc: "\u{D261}",
        nfd: "\u{1110}\u{116F}\u{11C0}",
        nfkc: "\u{D261}",
        nfkd: "\u{1110}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D262}",
        nfc: "\u{D262}",
        nfd: "\u{1110}\u{116F}\u{11C1}",
        nfkc: "\u{D262}",
        nfkd: "\u{1110}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D263}",
        nfc: "\u{D263}",
        nfd: "\u{1110}\u{116F}\u{11C2}",
        nfkc: "\u{D263}",
        nfkd: "\u{1110}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D264}",
        nfc: "\u{D264}",
        nfd: "\u{1110}\u{1170}",
        nfkc: "\u{D264}",
        nfkd: "\u{1110}\u{1170}",
    },
    NormalizationTest {
        source: "\u{D265}",
        nfc: "\u{D265}",
        nfd: "\u{1110}\u{1170}\u{11A8}",
        nfkc: "\u{D265}",
        nfkd: "\u{1110}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D266}",
        nfc: "\u{D266}",
        nfd: "\u{1110}\u{1170}\u{11A9}",
        nfkc: "\u{D266}",
        nfkd: "\u{1110}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D267}",
        nfc: "\u{D267}",
        nfd: "\u{1110}\u{1170}\u{11AA}",
        nfkc: "\u{D267}",
        nfkd: "\u{1110}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D268}",
        nfc: "\u{D268}",
        nfd: "\u{1110}\u{1170}\u{11AB}",
        nfkc: "\u{D268}",
        nfkd: "\u{1110}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D269}",
        nfc: "\u{D269}",
        nfd: "\u{1110}\u{1170}\u{11AC}",
        nfkc: "\u{D269}",
        nfkd: "\u{1110}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D26A}",
        nfc: "\u{D26A}",
        nfd: "\u{1110}\u{1170}\u{11AD}",
        nfkc: "\u{D26A}",
        nfkd: "\u{1110}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D26B}",
        nfc: "\u{D26B}",
        nfd: "\u{1110}\u{1170}\u{11AE}",
        nfkc: "\u{D26B}",
        nfkd: "\u{1110}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D26C}",
        nfc: "\u{D26C}",
        nfd: "\u{1110}\u{1170}\u{11AF}",
        nfkc: "\u{D26C}",
        nfkd: "\u{1110}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D26D}",
        nfc: "\u{D26D}",
        nfd: "\u{1110}\u{1170}\u{11B0}",
        nfkc: "\u{D26D}",
        nfkd: "\u{1110}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D26E}",
        nfc: "\u{D26E}",
        nfd: "\u{1110}\u{1170}\u{11B1}",
        nfkc: "\u{D26E}",
        nfkd: "\u{1110}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D26F}",
        nfc: "\u{D26F}",
        nfd: "\u{1110}\u{1170}\u{11B2}",
        nfkc: "\u{D26F}",
        nfkd: "\u{1110}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D270}",
        nfc: "\u{D270}",
        nfd: "\u{1110}\u{1170}\u{11B3}",
        nfkc: "\u{D270}",
        nfkd: "\u{1110}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D271}",
        nfc: "\u{D271}",
        nfd: "\u{1110}\u{1170}\u{11B4}",
        nfkc: "\u{D271}",
        nfkd: "\u{1110}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D272}",
        nfc: "\u{D272}",
        nfd: "\u{1110}\u{1170}\u{11B5}",
        nfkc: "\u{D272}",
        nfkd: "\u{1110}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D273}",
        nfc: "\u{D273}",
        nfd: "\u{1110}\u{1170}\u{11B6}",
        nfkc: "\u{D273}",
        nfkd: "\u{1110}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D274}",
        nfc: "\u{D274}",
        nfd: "\u{1110}\u{1170}\u{11B7}",
        nfkc: "\u{D274}",
        nfkd: "\u{1110}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D275}",
        nfc: "\u{D275}",
        nfd: "\u{1110}\u{1170}\u{11B8}",
        nfkc: "\u{D275}",
        nfkd: "\u{1110}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D276}",
        nfc: "\u{D276}",
        nfd: "\u{1110}\u{1170}\u{11B9}",
        nfkc: "\u{D276}",
        nfkd: "\u{1110}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D277}",
        nfc: "\u{D277}",
        nfd: "\u{1110}\u{1170}\u{11BA}",
        nfkc: "\u{D277}",
        nfkd: "\u{1110}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D278}",
        nfc: "\u{D278}",
        nfd: "\u{1110}\u{1170}\u{11BB}",
        nfkc: "\u{D278}",
        nfkd: "\u{1110}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D279}",
        nfc: "\u{D279}",
        nfd: "\u{1110}\u{1170}\u{11BC}",
        nfkc: "\u{D279}",
        nfkd: "\u{1110}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D27A}",
        nfc: "\u{D27A}",
        nfd: "\u{1110}\u{1170}\u{11BD}",
        nfkc: "\u{D27A}",
        nfkd: "\u{1110}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D27B}",
        nfc: "\u{D27B}",
        nfd: "\u{1110}\u{1170}\u{11BE}",
        nfkc: "\u{D27B}",
        nfkd: "\u{1110}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D27C}",
        nfc: "\u{D27C}",
        nfd: "\u{1110}\u{1170}\u{11BF}",
        nfkc: "\u{D27C}",
        nfkd: "\u{1110}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D27D}",
        nfc: "\u{D27D}",
        nfd: "\u{1110}\u{1170}\u{11C0}",
        nfkc: "\u{D27D}",
        nfkd: "\u{1110}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D27E}",
        nfc: "\u{D27E}",
        nfd: "\u{1110}\u{1170}\u{11C1}",
        nfkc: "\u{D27E}",
        nfkd: "\u{1110}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D27F}",
        nfc: "\u{D27F}",
        nfd: "\u{1110}\u{1170}\u{11C2}",
        nfkc: "\u{D27F}",
        nfkd: "\u{1110}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D280}",
        nfc: "\u{D280}",
        nfd: "\u{1110}\u{1171}",
        nfkc: "\u{D280}",
        nfkd: "\u{1110}\u{1171}",
    },
    NormalizationTest {
        source: "\u{D281}",
        nfc: "\u{D281}",
        nfd: "\u{1110}\u{1171}\u{11A8}",
        nfkc: "\u{D281}",
        nfkd: "\u{1110}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D282}",
        nfc: "\u{D282}",
        nfd: "\u{1110}\u{1171}\u{11A9}",
        nfkc: "\u{D282}",
        nfkd: "\u{1110}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D283}",
        nfc: "\u{D283}",
        nfd: "\u{1110}\u{1171}\u{11AA}",
        nfkc: "\u{D283}",
        nfkd: "\u{1110}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D284}",
        nfc: "\u{D284}",
        nfd: "\u{1110}\u{1171}\u{11AB}",
        nfkc: "\u{D284}",
        nfkd: "\u{1110}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D285}",
        nfc: "\u{D285}",
        nfd: "\u{1110}\u{1171}\u{11AC}",
        nfkc: "\u{D285}",
        nfkd: "\u{1110}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D286}",
        nfc: "\u{D286}",
        nfd: "\u{1110}\u{1171}\u{11AD}",
        nfkc: "\u{D286}",
        nfkd: "\u{1110}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D287}",
        nfc: "\u{D287}",
        nfd: "\u{1110}\u{1171}\u{11AE}",
        nfkc: "\u{D287}",
        nfkd: "\u{1110}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D288}",
        nfc: "\u{D288}",
        nfd: "\u{1110}\u{1171}\u{11AF}",
        nfkc: "\u{D288}",
        nfkd: "\u{1110}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D289}",
        nfc: "\u{D289}",
        nfd: "\u{1110}\u{1171}\u{11B0}",
        nfkc: "\u{D289}",
        nfkd: "\u{1110}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D28A}",
        nfc: "\u{D28A}",
        nfd: "\u{1110}\u{1171}\u{11B1}",
        nfkc: "\u{D28A}",
        nfkd: "\u{1110}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D28B}",
        nfc: "\u{D28B}",
        nfd: "\u{1110}\u{1171}\u{11B2}",
        nfkc: "\u{D28B}",
        nfkd: "\u{1110}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D28C}",
        nfc: "\u{D28C}",
        nfd: "\u{1110}\u{1171}\u{11B3}",
        nfkc: "\u{D28C}",
        nfkd: "\u{1110}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D28D}",
        nfc: "\u{D28D}",
        nfd: "\u{1110}\u{1171}\u{11B4}",
        nfkc: "\u{D28D}",
        nfkd: "\u{1110}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D28E}",
        nfc: "\u{D28E}",
        nfd: "\u{1110}\u{1171}\u{11B5}",
        nfkc: "\u{D28E}",
        nfkd: "\u{1110}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D28F}",
        nfc: "\u{D28F}",
        nfd: "\u{1110}\u{1171}\u{11B6}",
        nfkc: "\u{D28F}",
        nfkd: "\u{1110}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D290}",
        nfc: "\u{D290}",
        nfd: "\u{1110}\u{1171}\u{11B7}",
        nfkc: "\u{D290}",
        nfkd: "\u{1110}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D291}",
        nfc: "\u{D291}",
        nfd: "\u{1110}\u{1171}\u{11B8}",
        nfkc: "\u{D291}",
        nfkd: "\u{1110}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D292}",
        nfc: "\u{D292}",
        nfd: "\u{1110}\u{1171}\u{11B9}",
        nfkc: "\u{D292}",
        nfkd: "\u{1110}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D293}",
        nfc: "\u{D293}",
        nfd: "\u{1110}\u{1171}\u{11BA}",
        nfkc: "\u{D293}",
        nfkd: "\u{1110}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D294}",
        nfc: "\u{D294}",
        nfd: "\u{1110}\u{1171}\u{11BB}",
        nfkc: "\u{D294}",
        nfkd: "\u{1110}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D295}",
        nfc: "\u{D295}",
        nfd: "\u{1110}\u{1171}\u{11BC}",
        nfkc: "\u{D295}",
        nfkd: "\u{1110}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D296}",
        nfc: "\u{D296}",
        nfd: "\u{1110}\u{1171}\u{11BD}",
        nfkc: "\u{D296}",
        nfkd: "\u{1110}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D297}",
        nfc: "\u{D297}",
        nfd: "\u{1110}\u{1171}\u{11BE}",
        nfkc: "\u{D297}",
        nfkd: "\u{1110}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D298}",
        nfc: "\u{D298}",
        nfd: "\u{1110}\u{1171}\u{11BF}",
        nfkc: "\u{D298}",
        nfkd: "\u{1110}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D299}",
        nfc: "\u{D299}",
        nfd: "\u{1110}\u{1171}\u{11C0}",
        nfkc: "\u{D299}",
        nfkd: "\u{1110}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D29A}",
        nfc: "\u{D29A}",
        nfd: "\u{1110}\u{1171}\u{11C1}",
        nfkc: "\u{D29A}",
        nfkd: "\u{1110}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D29B}",
        nfc: "\u{D29B}",
        nfd: "\u{1110}\u{1171}\u{11C2}",
        nfkc: "\u{D29B}",
        nfkd: "\u{1110}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D29C}",
        nfc: "\u{D29C}",
        nfd: "\u{1110}\u{1172}",
        nfkc: "\u{D29C}",
        nfkd: "\u{1110}\u{1172}",
    },
    NormalizationTest {
        source: "\u{D29D}",
        nfc: "\u{D29D}",
        nfd: "\u{1110}\u{1172}\u{11A8}",
        nfkc: "\u{D29D}",
        nfkd: "\u{1110}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D29E}",
        nfc: "\u{D29E}",
        nfd: "\u{1110}\u{1172}\u{11A9}",
        nfkc: "\u{D29E}",
        nfkd: "\u{1110}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D29F}",
        nfc: "\u{D29F}",
        nfd: "\u{1110}\u{1172}\u{11AA}",
        nfkc: "\u{D29F}",
        nfkd: "\u{1110}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D2A0}",
        nfc: "\u{D2A0}",
        nfd: "\u{1110}\u{1172}\u{11AB}",
        nfkc: "\u{D2A0}",
        nfkd: "\u{1110}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D2A1}",
        nfc: "\u{D2A1}",
        nfd: "\u{1110}\u{1172}\u{11AC}",
        nfkc: "\u{D2A1}",
        nfkd: "\u{1110}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D2A2}",
        nfc: "\u{D2A2}",
        nfd: "\u{1110}\u{1172}\u{11AD}",
        nfkc: "\u{D2A2}",
        nfkd: "\u{1110}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D2A3}",
        nfc: "\u{D2A3}",
        nfd: "\u{1110}\u{1172}\u{11AE}",
        nfkc: "\u{D2A3}",
        nfkd: "\u{1110}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D2A4}",
        nfc: "\u{D2A4}",
        nfd: "\u{1110}\u{1172}\u{11AF}",
        nfkc: "\u{D2A4}",
        nfkd: "\u{1110}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D2A5}",
        nfc: "\u{D2A5}",
        nfd: "\u{1110}\u{1172}\u{11B0}",
        nfkc: "\u{D2A5}",
        nfkd: "\u{1110}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D2A6}",
        nfc: "\u{D2A6}",
        nfd: "\u{1110}\u{1172}\u{11B1}",
        nfkc: "\u{D2A6}",
        nfkd: "\u{1110}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D2A7}",
        nfc: "\u{D2A7}",
        nfd: "\u{1110}\u{1172}\u{11B2}",
        nfkc: "\u{D2A7}",
        nfkd: "\u{1110}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D2A8}",
        nfc: "\u{D2A8}",
        nfd: "\u{1110}\u{1172}\u{11B3}",
        nfkc: "\u{D2A8}",
        nfkd: "\u{1110}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D2A9}",
        nfc: "\u{D2A9}",
        nfd: "\u{1110}\u{1172}\u{11B4}",
        nfkc: "\u{D2A9}",
        nfkd: "\u{1110}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D2AA}",
        nfc: "\u{D2AA}",
        nfd: "\u{1110}\u{1172}\u{11B5}",
        nfkc: "\u{D2AA}",
        nfkd: "\u{1110}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D2AB}",
        nfc: "\u{D2AB}",
        nfd: "\u{1110}\u{1172}\u{11B6}",
        nfkc: "\u{D2AB}",
        nfkd: "\u{1110}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D2AC}",
        nfc: "\u{D2AC}",
        nfd: "\u{1110}\u{1172}\u{11B7}",
        nfkc: "\u{D2AC}",
        nfkd: "\u{1110}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D2AD}",
        nfc: "\u{D2AD}",
        nfd: "\u{1110}\u{1172}\u{11B8}",
        nfkc: "\u{D2AD}",
        nfkd: "\u{1110}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D2AE}",
        nfc: "\u{D2AE}",
        nfd: "\u{1110}\u{1172}\u{11B9}",
        nfkc: "\u{D2AE}",
        nfkd: "\u{1110}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D2AF}",
        nfc: "\u{D2AF}",
        nfd: "\u{1110}\u{1172}\u{11BA}",
        nfkc: "\u{D2AF}",
        nfkd: "\u{1110}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D2B0}",
        nfc: "\u{D2B0}",
        nfd: "\u{1110}\u{1172}\u{11BB}",
        nfkc: "\u{D2B0}",
        nfkd: "\u{1110}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D2B1}",
        nfc: "\u{D2B1}",
        nfd: "\u{1110}\u{1172}\u{11BC}",
        nfkc: "\u{D2B1}",
        nfkd: "\u{1110}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D2B2}",
        nfc: "\u{D2B2}",
        nfd: "\u{1110}\u{1172}\u{11BD}",
        nfkc: "\u{D2B2}",
        nfkd: "\u{1110}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D2B3}",
        nfc: "\u{D2B3}",
        nfd: "\u{1110}\u{1172}\u{11BE}",
        nfkc: "\u{D2B3}",
        nfkd: "\u{1110}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D2B4}",
        nfc: "\u{D2B4}",
        nfd: "\u{1110}\u{1172}\u{11BF}",
        nfkc: "\u{D2B4}",
        nfkd: "\u{1110}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D2B5}",
        nfc: "\u{D2B5}",
        nfd: "\u{1110}\u{1172}\u{11C0}",
        nfkc: "\u{D2B5}",
        nfkd: "\u{1110}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D2B6}",
        nfc: "\u{D2B6}",
        nfd: "\u{1110}\u{1172}\u{11C1}",
        nfkc: "\u{D2B6}",
        nfkd: "\u{1110}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D2B7}",
        nfc: "\u{D2B7}",
        nfd: "\u{1110}\u{1172}\u{11C2}",
        nfkc: "\u{D2B7}",
        nfkd: "\u{1110}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D2B8}",
        nfc: "\u{D2B8}",
        nfd: "\u{1110}\u{1173}",
        nfkc: "\u{D2B8}",
        nfkd: "\u{1110}\u{1173}",
    },
    NormalizationTest {
        source: "\u{D2B9}",
        nfc: "\u{D2B9}",
        nfd: "\u{1110}\u{1173}\u{11A8}",
        nfkc: "\u{D2B9}",
        nfkd: "\u{1110}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D2BA}",
        nfc: "\u{D2BA}",
        nfd: "\u{1110}\u{1173}\u{11A9}",
        nfkc: "\u{D2BA}",
        nfkd: "\u{1110}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D2BB}",
        nfc: "\u{D2BB}",
        nfd: "\u{1110}\u{1173}\u{11AA}",
        nfkc: "\u{D2BB}",
        nfkd: "\u{1110}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D2BC}",
        nfc: "\u{D2BC}",
        nfd: "\u{1110}\u{1173}\u{11AB}",
        nfkc: "\u{D2BC}",
        nfkd: "\u{1110}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D2BD}",
        nfc: "\u{D2BD}",
        nfd: "\u{1110}\u{1173}\u{11AC}",
        nfkc: "\u{D2BD}",
        nfkd: "\u{1110}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D2BE}",
        nfc: "\u{D2BE}",
        nfd: "\u{1110}\u{1173}\u{11AD}",
        nfkc: "\u{D2BE}",
        nfkd: "\u{1110}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D2BF}",
        nfc: "\u{D2BF}",
        nfd: "\u{1110}\u{1173}\u{11AE}",
        nfkc: "\u{D2BF}",
        nfkd: "\u{1110}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D2C0}",
        nfc: "\u{D2C0}",
        nfd: "\u{1110}\u{1173}\u{11AF}",
        nfkc: "\u{D2C0}",
        nfkd: "\u{1110}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D2C1}",
        nfc: "\u{D2C1}",
        nfd: "\u{1110}\u{1173}\u{11B0}",
        nfkc: "\u{D2C1}",
        nfkd: "\u{1110}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D2C2}",
        nfc: "\u{D2C2}",
        nfd: "\u{1110}\u{1173}\u{11B1}",
        nfkc: "\u{D2C2}",
        nfkd: "\u{1110}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D2C3}",
        nfc: "\u{D2C3}",
        nfd: "\u{1110}\u{1173}\u{11B2}",
        nfkc: "\u{D2C3}",
        nfkd: "\u{1110}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D2C4}",
        nfc: "\u{D2C4}",
        nfd: "\u{1110}\u{1173}\u{11B3}",
        nfkc: "\u{D2C4}",
        nfkd: "\u{1110}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D2C5}",
        nfc: "\u{D2C5}",
        nfd: "\u{1110}\u{1173}\u{11B4}",
        nfkc: "\u{D2C5}",
        nfkd: "\u{1110}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D2C6}",
        nfc: "\u{D2C6}",
        nfd: "\u{1110}\u{1173}\u{11B5}",
        nfkc: "\u{D2C6}",
        nfkd: "\u{1110}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D2C7}",
        nfc: "\u{D2C7}",
        nfd: "\u{1110}\u{1173}\u{11B6}",
        nfkc: "\u{D2C7}",
        nfkd: "\u{1110}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D2C8}",
        nfc: "\u{D2C8}",
        nfd: "\u{1110}\u{1173}\u{11B7}",
        nfkc: "\u{D2C8}",
        nfkd: "\u{1110}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D2C9}",
        nfc: "\u{D2C9}",
        nfd: "\u{1110}\u{1173}\u{11B8}",
        nfkc: "\u{D2C9}",
        nfkd: "\u{1110}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D2CA}",
        nfc: "\u{D2CA}",
        nfd: "\u{1110}\u{1173}\u{11B9}",
        nfkc: "\u{D2CA}",
        nfkd: "\u{1110}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D2CB}",
        nfc: "\u{D2CB}",
        nfd: "\u{1110}\u{1173}\u{11BA}",
        nfkc: "\u{D2CB}",
        nfkd: "\u{1110}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D2CC}",
        nfc: "\u{D2CC}",
        nfd: "\u{1110}\u{1173}\u{11BB}",
        nfkc: "\u{D2CC}",
        nfkd: "\u{1110}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D2CD}",
        nfc: "\u{D2CD}",
        nfd: "\u{1110}\u{1173}\u{11BC}",
        nfkc: "\u{D2CD}",
        nfkd: "\u{1110}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D2CE}",
        nfc: "\u{D2CE}",
        nfd: "\u{1110}\u{1173}\u{11BD}",
        nfkc: "\u{D2CE}",
        nfkd: "\u{1110}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D2CF}",
        nfc: "\u{D2CF}",
        nfd: "\u{1110}\u{1173}\u{11BE}",
        nfkc: "\u{D2CF}",
        nfkd: "\u{1110}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D2D0}",
        nfc: "\u{D2D0}",
        nfd: "\u{1110}\u{1173}\u{11BF}",
        nfkc: "\u{D2D0}",
        nfkd: "\u{1110}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D2D1}",
        nfc: "\u{D2D1}",
        nfd: "\u{1110}\u{1173}\u{11C0}",
        nfkc: "\u{D2D1}",
        nfkd: "\u{1110}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D2D2}",
        nfc: "\u{D2D2}",
        nfd: "\u{1110}\u{1173}\u{11C1}",
        nfkc: "\u{D2D2}",
        nfkd: "\u{1110}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D2D3}",
        nfc: "\u{D2D3}",
        nfd: "\u{1110}\u{1173}\u{11C2}",
        nfkc: "\u{D2D3}",
        nfkd: "\u{1110}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D2D4}",
        nfc: "\u{D2D4}",
        nfd: "\u{1110}\u{1174}",
        nfkc: "\u{D2D4}",
        nfkd: "\u{1110}\u{1174}",
    },
    NormalizationTest {
        source: "\u{D2D5}",
        nfc: "\u{D2D5}",
        nfd: "\u{1110}\u{1174}\u{11A8}",
        nfkc: "\u{D2D5}",
        nfkd: "\u{1110}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D2D6}",
        nfc: "\u{D2D6}",
        nfd: "\u{1110}\u{1174}\u{11A9}",
        nfkc: "\u{D2D6}",
        nfkd: "\u{1110}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D2D7}",
        nfc: "\u{D2D7}",
        nfd: "\u{1110}\u{1174}\u{11AA}",
        nfkc: "\u{D2D7}",
        nfkd: "\u{1110}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D2D8}",
        nfc: "\u{D2D8}",
        nfd: "\u{1110}\u{1174}\u{11AB}",
        nfkc: "\u{D2D8}",
        nfkd: "\u{1110}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D2D9}",
        nfc: "\u{D2D9}",
        nfd: "\u{1110}\u{1174}\u{11AC}",
        nfkc: "\u{D2D9}",
        nfkd: "\u{1110}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D2DA}",
        nfc: "\u{D2DA}",
        nfd: "\u{1110}\u{1174}\u{11AD}",
        nfkc: "\u{D2DA}",
        nfkd: "\u{1110}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D2DB}",
        nfc: "\u{D2DB}",
        nfd: "\u{1110}\u{1174}\u{11AE}",
        nfkc: "\u{D2DB}",
        nfkd: "\u{1110}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D2DC}",
        nfc: "\u{D2DC}",
        nfd: "\u{1110}\u{1174}\u{11AF}",
        nfkc: "\u{D2DC}",
        nfkd: "\u{1110}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D2DD}",
        nfc: "\u{D2DD}",
        nfd: "\u{1110}\u{1174}\u{11B0}",
        nfkc: "\u{D2DD}",
        nfkd: "\u{1110}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D2DE}",
        nfc: "\u{D2DE}",
        nfd: "\u{1110}\u{1174}\u{11B1}",
        nfkc: "\u{D2DE}",
        nfkd: "\u{1110}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D2DF}",
        nfc: "\u{D2DF}",
        nfd: "\u{1110}\u{1174}\u{11B2}",
        nfkc: "\u{D2DF}",
        nfkd: "\u{1110}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D2E0}",
        nfc: "\u{D2E0}",
        nfd: "\u{1110}\u{1174}\u{11B3}",
        nfkc: "\u{D2E0}",
        nfkd: "\u{1110}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D2E1}",
        nfc: "\u{D2E1}",
        nfd: "\u{1110}\u{1174}\u{11B4}",
        nfkc: "\u{D2E1}",
        nfkd: "\u{1110}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D2E2}",
        nfc: "\u{D2E2}",
        nfd: "\u{1110}\u{1174}\u{11B5}",
        nfkc: "\u{D2E2}",
        nfkd: "\u{1110}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D2E3}",
        nfc: "\u{D2E3}",
        nfd: "\u{1110}\u{1174}\u{11B6}",
        nfkc: "\u{D2E3}",
        nfkd: "\u{1110}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D2E4}",
        nfc: "\u{D2E4}",
        nfd: "\u{1110}\u{1174}\u{11B7}",
        nfkc: "\u{D2E4}",
        nfkd: "\u{1110}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D2E5}",
        nfc: "\u{D2E5}",
        nfd: "\u{1110}\u{1174}\u{11B8}",
        nfkc: "\u{D2E5}",
        nfkd: "\u{1110}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D2E6}",
        nfc: "\u{D2E6}",
        nfd: "\u{1110}\u{1174}\u{11B9}",
        nfkc: "\u{D2E6}",
        nfkd: "\u{1110}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D2E7}",
        nfc: "\u{D2E7}",
        nfd: "\u{1110}\u{1174}\u{11BA}",
        nfkc: "\u{D2E7}",
        nfkd: "\u{1110}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D2E8}",
        nfc: "\u{D2E8}",
        nfd: "\u{1110}\u{1174}\u{11BB}",
        nfkc: "\u{D2E8}",
        nfkd: "\u{1110}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D2E9}",
        nfc: "\u{D2E9}",
        nfd: "\u{1110}\u{1174}\u{11BC}",
        nfkc: "\u{D2E9}",
        nfkd: "\u{1110}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D2EA}",
        nfc: "\u{D2EA}",
        nfd: "\u{1110}\u{1174}\u{11BD}",
        nfkc: "\u{D2EA}",
        nfkd: "\u{1110}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D2EB}",
        nfc: "\u{D2EB}",
        nfd: "\u{1110}\u{1174}\u{11BE}",
        nfkc: "\u{D2EB}",
        nfkd: "\u{1110}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D2EC}",
        nfc: "\u{D2EC}",
        nfd: "\u{1110}\u{1174}\u{11BF}",
        nfkc: "\u{D2EC}",
        nfkd: "\u{1110}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D2ED}",
        nfc: "\u{D2ED}",
        nfd: "\u{1110}\u{1174}\u{11C0}",
        nfkc: "\u{D2ED}",
        nfkd: "\u{1110}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D2EE}",
        nfc: "\u{D2EE}",
        nfd: "\u{1110}\u{1174}\u{11C1}",
        nfkc: "\u{D2EE}",
        nfkd: "\u{1110}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D2EF}",
        nfc: "\u{D2EF}",
        nfd: "\u{1110}\u{1174}\u{11C2}",
        nfkc: "\u{D2EF}",
        nfkd: "\u{1110}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D2F0}",
        nfc: "\u{D2F0}",
        nfd: "\u{1110}\u{1175}",
        nfkc: "\u{D2F0}",
        nfkd: "\u{1110}\u{1175}",
    },
    NormalizationTest {
        source: "\u{D2F1}",
        nfc: "\u{D2F1}",
        nfd: "\u{1110}\u{1175}\u{11A8}",
        nfkc: "\u{D2F1}",
        nfkd: "\u{1110}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D2F2}",
        nfc: "\u{D2F2}",
        nfd: "\u{1110}\u{1175}\u{11A9}",
        nfkc: "\u{D2F2}",
        nfkd: "\u{1110}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D2F3}",
        nfc: "\u{D2F3}",
        nfd: "\u{1110}\u{1175}\u{11AA}",
        nfkc: "\u{D2F3}",
        nfkd: "\u{1110}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D2F4}",
        nfc: "\u{D2F4}",
        nfd: "\u{1110}\u{1175}\u{11AB}",
        nfkc: "\u{D2F4}",
        nfkd: "\u{1110}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D2F5}",
        nfc: "\u{D2F5}",
        nfd: "\u{1110}\u{1175}\u{11AC}",
        nfkc: "\u{D2F5}",
        nfkd: "\u{1110}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D2F6}",
        nfc: "\u{D2F6}",
        nfd: "\u{1110}\u{1175}\u{11AD}",
        nfkc: "\u{D2F6}",
        nfkd: "\u{1110}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D2F7}",
        nfc: "\u{D2F7}",
        nfd: "\u{1110}\u{1175}\u{11AE}",
        nfkc: "\u{D2F7}",
        nfkd: "\u{1110}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D2F8}",
        nfc: "\u{D2F8}",
        nfd: "\u{1110}\u{1175}\u{11AF}",
        nfkc: "\u{D2F8}",
        nfkd: "\u{1110}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D2F9}",
        nfc: "\u{D2F9}",
        nfd: "\u{1110}\u{1175}\u{11B0}",
        nfkc: "\u{D2F9}",
        nfkd: "\u{1110}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D2FA}",
        nfc: "\u{D2FA}",
        nfd: "\u{1110}\u{1175}\u{11B1}",
        nfkc: "\u{D2FA}",
        nfkd: "\u{1110}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D2FB}",
        nfc: "\u{D2FB}",
        nfd: "\u{1110}\u{1175}\u{11B2}",
        nfkc: "\u{D2FB}",
        nfkd: "\u{1110}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D2FC}",
        nfc: "\u{D2FC}",
        nfd: "\u{1110}\u{1175}\u{11B3}",
        nfkc: "\u{D2FC}",
        nfkd: "\u{1110}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D2FD}",
        nfc: "\u{D2FD}",
        nfd: "\u{1110}\u{1175}\u{11B4}",
        nfkc: "\u{D2FD}",
        nfkd: "\u{1110}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D2FE}",
        nfc: "\u{D2FE}",
        nfd: "\u{1110}\u{1175}\u{11B5}",
        nfkc: "\u{D2FE}",
        nfkd: "\u{1110}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D2FF}",
        nfc: "\u{D2FF}",
        nfd: "\u{1110}\u{1175}\u{11B6}",
        nfkc: "\u{D2FF}",
        nfkd: "\u{1110}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D300}",
        nfc: "\u{D300}",
        nfd: "\u{1110}\u{1175}\u{11B7}",
        nfkc: "\u{D300}",
        nfkd: "\u{1110}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D301}",
        nfc: "\u{D301}",
        nfd: "\u{1110}\u{1175}\u{11B8}",
        nfkc: "\u{D301}",
        nfkd: "\u{1110}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D302}",
        nfc: "\u{D302}",
        nfd: "\u{1110}\u{1175}\u{11B9}",
        nfkc: "\u{D302}",
        nfkd: "\u{1110}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D303}",
        nfc: "\u{D303}",
        nfd: "\u{1110}\u{1175}\u{11BA}",
        nfkc: "\u{D303}",
        nfkd: "\u{1110}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D304}",
        nfc: "\u{D304}",
        nfd: "\u{1110}\u{1175}\u{11BB}",
        nfkc: "\u{D304}",
        nfkd: "\u{1110}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D305}",
        nfc: "\u{D305}",
        nfd: "\u{1110}\u{1175}\u{11BC}",
        nfkc: "\u{D305}",
        nfkd: "\u{1110}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D306}",
        nfc: "\u{D306}",
        nfd: "\u{1110}\u{1175}\u{11BD}",
        nfkc: "\u{D306}",
        nfkd: "\u{1110}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D307}",
        nfc: "\u{D307}",
        nfd: "\u{1110}\u{1175}\u{11BE}",
        nfkc: "\u{D307}",
        nfkd: "\u{1110}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D308}",
        nfc: "\u{D308}",
        nfd: "\u{1110}\u{1175}\u{11BF}",
        nfkc: "\u{D308}",
        nfkd: "\u{1110}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D309}",
        nfc: "\u{D309}",
        nfd: "\u{1110}\u{1175}\u{11C0}",
        nfkc: "\u{D309}",
        nfkd: "\u{1110}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D30A}",
        nfc: "\u{D30A}",
        nfd: "\u{1110}\u{1175}\u{11C1}",
        nfkc: "\u{D30A}",
        nfkd: "\u{1110}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D30B}",
        nfc: "\u{D30B}",
        nfd: "\u{1110}\u{1175}\u{11C2}",
        nfkc: "\u{D30B}",
        nfkd: "\u{1110}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D30C}",
        nfc: "\u{D30C}",
        nfd: "\u{1111}\u{1161}",
        nfkc: "\u{D30C}",
        nfkd: "\u{1111}\u{1161}",
    },
    NormalizationTest {
        source: "\u{D30D}",
        nfc: "\u{D30D}",
        nfd: "\u{1111}\u{1161}\u{11A8}",
        nfkc: "\u{D30D}",
        nfkd: "\u{1111}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D30E}",
        nfc: "\u{D30E}",
        nfd: "\u{1111}\u{1161}\u{11A9}",
        nfkc: "\u{D30E}",
        nfkd: "\u{1111}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D30F}",
        nfc: "\u{D30F}",
        nfd: "\u{1111}\u{1161}\u{11AA}",
        nfkc: "\u{D30F}",
        nfkd: "\u{1111}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D310}",
        nfc: "\u{D310}",
        nfd: "\u{1111}\u{1161}\u{11AB}",
        nfkc: "\u{D310}",
        nfkd: "\u{1111}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D311}",
        nfc: "\u{D311}",
        nfd: "\u{1111}\u{1161}\u{11AC}",
        nfkc: "\u{D311}",
        nfkd: "\u{1111}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D312}",
        nfc: "\u{D312}",
        nfd: "\u{1111}\u{1161}\u{11AD}",
        nfkc: "\u{D312}",
        nfkd: "\u{1111}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D313}",
        nfc: "\u{D313}",
        nfd: "\u{1111}\u{1161}\u{11AE}",
        nfkc: "\u{D313}",
        nfkd: "\u{1111}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D314}",
        nfc: "\u{D314}",
        nfd: "\u{1111}\u{1161}\u{11AF}",
        nfkc: "\u{D314}",
        nfkd: "\u{1111}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D315}",
        nfc: "\u{D315}",
        nfd: "\u{1111}\u{1161}\u{11B0}",
        nfkc: "\u{D315}",
        nfkd: "\u{1111}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D316}",
        nfc: "\u{D316}",
        nfd: "\u{1111}\u{1161}\u{11B1}",
        nfkc: "\u{D316}",
        nfkd: "\u{1111}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D317}",
        nfc: "\u{D317}",
        nfd: "\u{1111}\u{1161}\u{11B2}",
        nfkc: "\u{D317}",
        nfkd: "\u{1111}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D318}",
        nfc: "\u{D318}",
        nfd: "\u{1111}\u{1161}\u{11B3}",
        nfkc: "\u{D318}",
        nfkd: "\u{1111}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D319}",
        nfc: "\u{D319}",
        nfd: "\u{1111}\u{1161}\u{11B4}",
        nfkc: "\u{D319}",
        nfkd: "\u{1111}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D31A}",
        nfc: "\u{D31A}",
        nfd: "\u{1111}\u{1161}\u{11B5}",
        nfkc: "\u{D31A}",
        nfkd: "\u{1111}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D31B}",
        nfc: "\u{D31B}",
        nfd: "\u{1111}\u{1161}\u{11B6}",
        nfkc: "\u{D31B}",
        nfkd: "\u{1111}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D31C}",
        nfc: "\u{D31C}",
        nfd: "\u{1111}\u{1161}\u{11B7}",
        nfkc: "\u{D31C}",
        nfkd: "\u{1111}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D31D}",
        nfc: "\u{D31D}",
        nfd: "\u{1111}\u{1161}\u{11B8}",
        nfkc: "\u{D31D}",
        nfkd: "\u{1111}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D31E}",
        nfc: "\u{D31E}",
        nfd: "\u{1111}\u{1161}\u{11B9}",
        nfkc: "\u{D31E}",
        nfkd: "\u{1111}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D31F}",
        nfc: "\u{D31F}",
        nfd: "\u{1111}\u{1161}\u{11BA}",
        nfkc: "\u{D31F}",
        nfkd: "\u{1111}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D320}",
        nfc: "\u{D320}",
        nfd: "\u{1111}\u{1161}\u{11BB}",
        nfkc: "\u{D320}",
        nfkd: "\u{1111}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D321}",
        nfc: "\u{D321}",
        nfd: "\u{1111}\u{1161}\u{11BC}",
        nfkc: "\u{D321}",
        nfkd: "\u{1111}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D322}",
        nfc: "\u{D322}",
        nfd: "\u{1111}\u{1161}\u{11BD}",
        nfkc: "\u{D322}",
        nfkd: "\u{1111}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D323}",
        nfc: "\u{D323}",
        nfd: "\u{1111}\u{1161}\u{11BE}",
        nfkc: "\u{D323}",
        nfkd: "\u{1111}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D324}",
        nfc: "\u{D324}",
        nfd: "\u{1111}\u{1161}\u{11BF}",
        nfkc: "\u{D324}",
        nfkd: "\u{1111}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D325}",
        nfc: "\u{D325}",
        nfd: "\u{1111}\u{1161}\u{11C0}",
        nfkc: "\u{D325}",
        nfkd: "\u{1111}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D326}",
        nfc: "\u{D326}",
        nfd: "\u{1111}\u{1161}\u{11C1}",
        nfkc: "\u{D326}",
        nfkd: "\u{1111}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D327}",
        nfc: "\u{D327}",
        nfd: "\u{1111}\u{1161}\u{11C2}",
        nfkc: "\u{D327}",
        nfkd: "\u{1111}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D328}",
        nfc: "\u{D328}",
        nfd: "\u{1111}\u{1162}",
        nfkc: "\u{D328}",
        nfkd: "\u{1111}\u{1162}",
    },
    NormalizationTest {
        source: "\u{D329}",
        nfc: "\u{D329}",
        nfd: "\u{1111}\u{1162}\u{11A8}",
        nfkc: "\u{D329}",
        nfkd: "\u{1111}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D32A}",
        nfc: "\u{D32A}",
        nfd: "\u{1111}\u{1162}\u{11A9}",
        nfkc: "\u{D32A}",
        nfkd: "\u{1111}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D32B}",
        nfc: "\u{D32B}",
        nfd: "\u{1111}\u{1162}\u{11AA}",
        nfkc: "\u{D32B}",
        nfkd: "\u{1111}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D32C}",
        nfc: "\u{D32C}",
        nfd: "\u{1111}\u{1162}\u{11AB}",
        nfkc: "\u{D32C}",
        nfkd: "\u{1111}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D32D}",
        nfc: "\u{D32D}",
        nfd: "\u{1111}\u{1162}\u{11AC}",
        nfkc: "\u{D32D}",
        nfkd: "\u{1111}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D32E}",
        nfc: "\u{D32E}",
        nfd: "\u{1111}\u{1162}\u{11AD}",
        nfkc: "\u{D32E}",
        nfkd: "\u{1111}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D32F}",
        nfc: "\u{D32F}",
        nfd: "\u{1111}\u{1162}\u{11AE}",
        nfkc: "\u{D32F}",
        nfkd: "\u{1111}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D330}",
        nfc: "\u{D330}",
        nfd: "\u{1111}\u{1162}\u{11AF}",
        nfkc: "\u{D330}",
        nfkd: "\u{1111}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D331}",
        nfc: "\u{D331}",
        nfd: "\u{1111}\u{1162}\u{11B0}",
        nfkc: "\u{D331}",
        nfkd: "\u{1111}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D332}",
        nfc: "\u{D332}",
        nfd: "\u{1111}\u{1162}\u{11B1}",
        nfkc: "\u{D332}",
        nfkd: "\u{1111}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D333}",
        nfc: "\u{D333}",
        nfd: "\u{1111}\u{1162}\u{11B2}",
        nfkc: "\u{D333}",
        nfkd: "\u{1111}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D334}",
        nfc: "\u{D334}",
        nfd: "\u{1111}\u{1162}\u{11B3}",
        nfkc: "\u{D334}",
        nfkd: "\u{1111}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D335}",
        nfc: "\u{D335}",
        nfd: "\u{1111}\u{1162}\u{11B4}",
        nfkc: "\u{D335}",
        nfkd: "\u{1111}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D336}",
        nfc: "\u{D336}",
        nfd: "\u{1111}\u{1162}\u{11B5}",
        nfkc: "\u{D336}",
        nfkd: "\u{1111}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D337}",
        nfc: "\u{D337}",
        nfd: "\u{1111}\u{1162}\u{11B6}",
        nfkc: "\u{D337}",
        nfkd: "\u{1111}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D338}",
        nfc: "\u{D338}",
        nfd: "\u{1111}\u{1162}\u{11B7}",
        nfkc: "\u{D338}",
        nfkd: "\u{1111}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D339}",
        nfc: "\u{D339}",
        nfd: "\u{1111}\u{1162}\u{11B8}",
        nfkc: "\u{D339}",
        nfkd: "\u{1111}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D33A}",
        nfc: "\u{D33A}",
        nfd: "\u{1111}\u{1162}\u{11B9}",
        nfkc: "\u{D33A}",
        nfkd: "\u{1111}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D33B}",
        nfc: "\u{D33B}",
        nfd: "\u{1111}\u{1162}\u{11BA}",
        nfkc: "\u{D33B}",
        nfkd: "\u{1111}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D33C}",
        nfc: "\u{D33C}",
        nfd: "\u{1111}\u{1162}\u{11BB}",
        nfkc: "\u{D33C}",
        nfkd: "\u{1111}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D33D}",
        nfc: "\u{D33D}",
        nfd: "\u{1111}\u{1162}\u{11BC}",
        nfkc: "\u{D33D}",
        nfkd: "\u{1111}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D33E}",
        nfc: "\u{D33E}",
        nfd: "\u{1111}\u{1162}\u{11BD}",
        nfkc: "\u{D33E}",
        nfkd: "\u{1111}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D33F}",
        nfc: "\u{D33F}",
        nfd: "\u{1111}\u{1162}\u{11BE}",
        nfkc: "\u{D33F}",
        nfkd: "\u{1111}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D340}",
        nfc: "\u{D340}",
        nfd: "\u{1111}\u{1162}\u{11BF}",
        nfkc: "\u{D340}",
        nfkd: "\u{1111}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D341}",
        nfc: "\u{D341}",
        nfd: "\u{1111}\u{1162}\u{11C0}",
        nfkc: "\u{D341}",
        nfkd: "\u{1111}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D342}",
        nfc: "\u{D342}",
        nfd: "\u{1111}\u{1162}\u{11C1}",
        nfkc: "\u{D342}",
        nfkd: "\u{1111}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D343}",
        nfc: "\u{D343}",
        nfd: "\u{1111}\u{1162}\u{11C2}",
        nfkc: "\u{D343}",
        nfkd: "\u{1111}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D344}",
        nfc: "\u{D344}",
        nfd: "\u{1111}\u{1163}",
        nfkc: "\u{D344}",
        nfkd: "\u{1111}\u{1163}",
    },
    NormalizationTest {
        source: "\u{D345}",
        nfc: "\u{D345}",
        nfd: "\u{1111}\u{1163}\u{11A8}",
        nfkc: "\u{D345}",
        nfkd: "\u{1111}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D346}",
        nfc: "\u{D346}",
        nfd: "\u{1111}\u{1163}\u{11A9}",
        nfkc: "\u{D346}",
        nfkd: "\u{1111}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D347}",
        nfc: "\u{D347}",
        nfd: "\u{1111}\u{1163}\u{11AA}",
        nfkc: "\u{D347}",
        nfkd: "\u{1111}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D348}",
        nfc: "\u{D348}",
        nfd: "\u{1111}\u{1163}\u{11AB}",
        nfkc: "\u{D348}",
        nfkd: "\u{1111}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D349}",
        nfc: "\u{D349}",
        nfd: "\u{1111}\u{1163}\u{11AC}",
        nfkc: "\u{D349}",
        nfkd: "\u{1111}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D34A}",
        nfc: "\u{D34A}",
        nfd: "\u{1111}\u{1163}\u{11AD}",
        nfkc: "\u{D34A}",
        nfkd: "\u{1111}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D34B}",
        nfc: "\u{D34B}",
        nfd: "\u{1111}\u{1163}\u{11AE}",
        nfkc: "\u{D34B}",
        nfkd: "\u{1111}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D34C}",
        nfc: "\u{D34C}",
        nfd: "\u{1111}\u{1163}\u{11AF}",
        nfkc: "\u{D34C}",
        nfkd: "\u{1111}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D34D}",
        nfc: "\u{D34D}",
        nfd: "\u{1111}\u{1163}\u{11B0}",
        nfkc: "\u{D34D}",
        nfkd: "\u{1111}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D34E}",
        nfc: "\u{D34E}",
        nfd: "\u{1111}\u{1163}\u{11B1}",
        nfkc: "\u{D34E}",
        nfkd: "\u{1111}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D34F}",
        nfc: "\u{D34F}",
        nfd: "\u{1111}\u{1163}\u{11B2}",
        nfkc: "\u{D34F}",
        nfkd: "\u{1111}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D350}",
        nfc: "\u{D350}",
        nfd: "\u{1111}\u{1163}\u{11B3}",
        nfkc: "\u{D350}",
        nfkd: "\u{1111}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D351}",
        nfc: "\u{D351}",
        nfd: "\u{1111}\u{1163}\u{11B4}",
        nfkc: "\u{D351}",
        nfkd: "\u{1111}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D352}",
        nfc: "\u{D352}",
        nfd: "\u{1111}\u{1163}\u{11B5}",
        nfkc: "\u{D352}",
        nfkd: "\u{1111}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D353}",
        nfc: "\u{D353}",
        nfd: "\u{1111}\u{1163}\u{11B6}",
        nfkc: "\u{D353}",
        nfkd: "\u{1111}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D354}",
        nfc: "\u{D354}",
        nfd: "\u{1111}\u{1163}\u{11B7}",
        nfkc: "\u{D354}",
        nfkd: "\u{1111}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D355}",
        nfc: "\u{D355}",
        nfd: "\u{1111}\u{1163}\u{11B8}",
        nfkc: "\u{D355}",
        nfkd: "\u{1111}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D356}",
        nfc: "\u{D356}",
        nfd: "\u{1111}\u{1163}\u{11B9}",
        nfkc: "\u{D356}",
        nfkd: "\u{1111}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D357}",
        nfc: "\u{D357}",
        nfd: "\u{1111}\u{1163}\u{11BA}",
        nfkc: "\u{D357}",
        nfkd: "\u{1111}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D358}",
        nfc: "\u{D358}",
        nfd: "\u{1111}\u{1163}\u{11BB}",
        nfkc: "\u{D358}",
        nfkd: "\u{1111}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D359}",
        nfc: "\u{D359}",
        nfd: "\u{1111}\u{1163}\u{11BC}",
        nfkc: "\u{D359}",
        nfkd: "\u{1111}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D35A}",
        nfc: "\u{D35A}",
        nfd: "\u{1111}\u{1163}\u{11BD}",
        nfkc: "\u{D35A}",
        nfkd: "\u{1111}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D35B}",
        nfc: "\u{D35B}",
        nfd: "\u{1111}\u{1163}\u{11BE}",
        nfkc: "\u{D35B}",
        nfkd: "\u{1111}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D35C}",
        nfc: "\u{D35C}",
        nfd: "\u{1111}\u{1163}\u{11BF}",
        nfkc: "\u{D35C}",
        nfkd: "\u{1111}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D35D}",
        nfc: "\u{D35D}",
        nfd: "\u{1111}\u{1163}\u{11C0}",
        nfkc: "\u{D35D}",
        nfkd: "\u{1111}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D35E}",
        nfc: "\u{D35E}",
        nfd: "\u{1111}\u{1163}\u{11C1}",
        nfkc: "\u{D35E}",
        nfkd: "\u{1111}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D35F}",
        nfc: "\u{D35F}",
        nfd: "\u{1111}\u{1163}\u{11C2}",
        nfkc: "\u{D35F}",
        nfkd: "\u{1111}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D360}",
        nfc: "\u{D360}",
        nfd: "\u{1111}\u{1164}",
        nfkc: "\u{D360}",
        nfkd: "\u{1111}\u{1164}",
    },
    NormalizationTest {
        source: "\u{D361}",
        nfc: "\u{D361}",
        nfd: "\u{1111}\u{1164}\u{11A8}",
        nfkc: "\u{D361}",
        nfkd: "\u{1111}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D362}",
        nfc: "\u{D362}",
        nfd: "\u{1111}\u{1164}\u{11A9}",
        nfkc: "\u{D362}",
        nfkd: "\u{1111}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D363}",
        nfc: "\u{D363}",
        nfd: "\u{1111}\u{1164}\u{11AA}",
        nfkc: "\u{D363}",
        nfkd: "\u{1111}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D364}",
        nfc: "\u{D364}",
        nfd: "\u{1111}\u{1164}\u{11AB}",
        nfkc: "\u{D364}",
        nfkd: "\u{1111}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D365}",
        nfc: "\u{D365}",
        nfd: "\u{1111}\u{1164}\u{11AC}",
        nfkc: "\u{D365}",
        nfkd: "\u{1111}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D366}",
        nfc: "\u{D366}",
        nfd: "\u{1111}\u{1164}\u{11AD}",
        nfkc: "\u{D366}",
        nfkd: "\u{1111}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D367}",
        nfc: "\u{D367}",
        nfd: "\u{1111}\u{1164}\u{11AE}",
        nfkc: "\u{D367}",
        nfkd: "\u{1111}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D368}",
        nfc: "\u{D368}",
        nfd: "\u{1111}\u{1164}\u{11AF}",
        nfkc: "\u{D368}",
        nfkd: "\u{1111}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D369}",
        nfc: "\u{D369}",
        nfd: "\u{1111}\u{1164}\u{11B0}",
        nfkc: "\u{D369}",
        nfkd: "\u{1111}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D36A}",
        nfc: "\u{D36A}",
        nfd: "\u{1111}\u{1164}\u{11B1}",
        nfkc: "\u{D36A}",
        nfkd: "\u{1111}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D36B}",
        nfc: "\u{D36B}",
        nfd: "\u{1111}\u{1164}\u{11B2}",
        nfkc: "\u{D36B}",
        nfkd: "\u{1111}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D36C}",
        nfc: "\u{D36C}",
        nfd: "\u{1111}\u{1164}\u{11B3}",
        nfkc: "\u{D36C}",
        nfkd: "\u{1111}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D36D}",
        nfc: "\u{D36D}",
        nfd: "\u{1111}\u{1164}\u{11B4}",
        nfkc: "\u{D36D}",
        nfkd: "\u{1111}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D36E}",
        nfc: "\u{D36E}",
        nfd: "\u{1111}\u{1164}\u{11B5}",
        nfkc: "\u{D36E}",
        nfkd: "\u{1111}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D36F}",
        nfc: "\u{D36F}",
        nfd: "\u{1111}\u{1164}\u{11B6}",
        nfkc: "\u{D36F}",
        nfkd: "\u{1111}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D370}",
        nfc: "\u{D370}",
        nfd: "\u{1111}\u{1164}\u{11B7}",
        nfkc: "\u{D370}",
        nfkd: "\u{1111}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D371}",
        nfc: "\u{D371}",
        nfd: "\u{1111}\u{1164}\u{11B8}",
        nfkc: "\u{D371}",
        nfkd: "\u{1111}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D372}",
        nfc: "\u{D372}",
        nfd: "\u{1111}\u{1164}\u{11B9}",
        nfkc: "\u{D372}",
        nfkd: "\u{1111}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D373}",
        nfc: "\u{D373}",
        nfd: "\u{1111}\u{1164}\u{11BA}",
        nfkc: "\u{D373}",
        nfkd: "\u{1111}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D374}",
        nfc: "\u{D374}",
        nfd: "\u{1111}\u{1164}\u{11BB}",
        nfkc: "\u{D374}",
        nfkd: "\u{1111}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D375}",
        nfc: "\u{D375}",
        nfd: "\u{1111}\u{1164}\u{11BC}",
        nfkc: "\u{D375}",
        nfkd: "\u{1111}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D376}",
        nfc: "\u{D376}",
        nfd: "\u{1111}\u{1164}\u{11BD}",
        nfkc: "\u{D376}",
        nfkd: "\u{1111}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D377}",
        nfc: "\u{D377}",
        nfd: "\u{1111}\u{1164}\u{11BE}",
        nfkc: "\u{D377}",
        nfkd: "\u{1111}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D378}",
        nfc: "\u{D378}",
        nfd: "\u{1111}\u{1164}\u{11BF}",
        nfkc: "\u{D378}",
        nfkd: "\u{1111}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D379}",
        nfc: "\u{D379}",
        nfd: "\u{1111}\u{1164}\u{11C0}",
        nfkc: "\u{D379}",
        nfkd: "\u{1111}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D37A}",
        nfc: "\u{D37A}",
        nfd: "\u{1111}\u{1164}\u{11C1}",
        nfkc: "\u{D37A}",
        nfkd: "\u{1111}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D37B}",
        nfc: "\u{D37B}",
        nfd: "\u{1111}\u{1164}\u{11C2}",
        nfkc: "\u{D37B}",
        nfkd: "\u{1111}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D37C}",
        nfc: "\u{D37C}",
        nfd: "\u{1111}\u{1165}",
        nfkc: "\u{D37C}",
        nfkd: "\u{1111}\u{1165}",
    },
    NormalizationTest {
        source: "\u{D37D}",
        nfc: "\u{D37D}",
        nfd: "\u{1111}\u{1165}\u{11A8}",
        nfkc: "\u{D37D}",
        nfkd: "\u{1111}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D37E}",
        nfc: "\u{D37E}",
        nfd: "\u{1111}\u{1165}\u{11A9}",
        nfkc: "\u{D37E}",
        nfkd: "\u{1111}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D37F}",
        nfc: "\u{D37F}",
        nfd: "\u{1111}\u{1165}\u{11AA}",
        nfkc: "\u{D37F}",
        nfkd: "\u{1111}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D380}",
        nfc: "\u{D380}",
        nfd: "\u{1111}\u{1165}\u{11AB}",
        nfkc: "\u{D380}",
        nfkd: "\u{1111}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D381}",
        nfc: "\u{D381}",
        nfd: "\u{1111}\u{1165}\u{11AC}",
        nfkc: "\u{D381}",
        nfkd: "\u{1111}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D382}",
        nfc: "\u{D382}",
        nfd: "\u{1111}\u{1165}\u{11AD}",
        nfkc: "\u{D382}",
        nfkd: "\u{1111}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D383}",
        nfc: "\u{D383}",
        nfd: "\u{1111}\u{1165}\u{11AE}",
        nfkc: "\u{D383}",
        nfkd: "\u{1111}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D384}",
        nfc: "\u{D384}",
        nfd: "\u{1111}\u{1165}\u{11AF}",
        nfkc: "\u{D384}",
        nfkd: "\u{1111}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D385}",
        nfc: "\u{D385}",
        nfd: "\u{1111}\u{1165}\u{11B0}",
        nfkc: "\u{D385}",
        nfkd: "\u{1111}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D386}",
        nfc: "\u{D386}",
        nfd: "\u{1111}\u{1165}\u{11B1}",
        nfkc: "\u{D386}",
        nfkd: "\u{1111}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D387}",
        nfc: "\u{D387}",
        nfd: "\u{1111}\u{1165}\u{11B2}",
        nfkc: "\u{D387}",
        nfkd: "\u{1111}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D388}",
        nfc: "\u{D388}",
        nfd: "\u{1111}\u{1165}\u{11B3}",
        nfkc: "\u{D388}",
        nfkd: "\u{1111}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D389}",
        nfc: "\u{D389}",
        nfd: "\u{1111}\u{1165}\u{11B4}",
        nfkc: "\u{D389}",
        nfkd: "\u{1111}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D38A}",
        nfc: "\u{D38A}",
        nfd: "\u{1111}\u{1165}\u{11B5}",
        nfkc: "\u{D38A}",
        nfkd: "\u{1111}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D38B}",
        nfc: "\u{D38B}",
        nfd: "\u{1111}\u{1165}\u{11B6}",
        nfkc: "\u{D38B}",
        nfkd: "\u{1111}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D38C}",
        nfc: "\u{D38C}",
        nfd: "\u{1111}\u{1165}\u{11B7}",
        nfkc: "\u{D38C}",
        nfkd: "\u{1111}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D38D}",
        nfc: "\u{D38D}",
        nfd: "\u{1111}\u{1165}\u{11B8}",
        nfkc: "\u{D38D}",
        nfkd: "\u{1111}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D38E}",
        nfc: "\u{D38E}",
        nfd: "\u{1111}\u{1165}\u{11B9}",
        nfkc: "\u{D38E}",
        nfkd: "\u{1111}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D38F}",
        nfc: "\u{D38F}",
        nfd: "\u{1111}\u{1165}\u{11BA}",
        nfkc: "\u{D38F}",
        nfkd: "\u{1111}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D390}",
        nfc: "\u{D390}",
        nfd: "\u{1111}\u{1165}\u{11BB}",
        nfkc: "\u{D390}",
        nfkd: "\u{1111}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D391}",
        nfc: "\u{D391}",
        nfd: "\u{1111}\u{1165}\u{11BC}",
        nfkc: "\u{D391}",
        nfkd: "\u{1111}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D392}",
        nfc: "\u{D392}",
        nfd: "\u{1111}\u{1165}\u{11BD}",
        nfkc: "\u{D392}",
        nfkd: "\u{1111}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D393}",
        nfc: "\u{D393}",
        nfd: "\u{1111}\u{1165}\u{11BE}",
        nfkc: "\u{D393}",
        nfkd: "\u{1111}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D394}",
        nfc: "\u{D394}",
        nfd: "\u{1111}\u{1165}\u{11BF}",
        nfkc: "\u{D394}",
        nfkd: "\u{1111}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D395}",
        nfc: "\u{D395}",
        nfd: "\u{1111}\u{1165}\u{11C0}",
        nfkc: "\u{D395}",
        nfkd: "\u{1111}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D396}",
        nfc: "\u{D396}",
        nfd: "\u{1111}\u{1165}\u{11C1}",
        nfkc: "\u{D396}",
        nfkd: "\u{1111}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D397}",
        nfc: "\u{D397}",
        nfd: "\u{1111}\u{1165}\u{11C2}",
        nfkc: "\u{D397}",
        nfkd: "\u{1111}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D398}",
        nfc: "\u{D398}",
        nfd: "\u{1111}\u{1166}",
        nfkc: "\u{D398}",
        nfkd: "\u{1111}\u{1166}",
    },
    NormalizationTest {
        source: "\u{D399}",
        nfc: "\u{D399}",
        nfd: "\u{1111}\u{1166}\u{11A8}",
        nfkc: "\u{D399}",
        nfkd: "\u{1111}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D39A}",
        nfc: "\u{D39A}",
        nfd: "\u{1111}\u{1166}\u{11A9}",
        nfkc: "\u{D39A}",
        nfkd: "\u{1111}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D39B}",
        nfc: "\u{D39B}",
        nfd: "\u{1111}\u{1166}\u{11AA}",
        nfkc: "\u{D39B}",
        nfkd: "\u{1111}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D39C}",
        nfc: "\u{D39C}",
        nfd: "\u{1111}\u{1166}\u{11AB}",
        nfkc: "\u{D39C}",
        nfkd: "\u{1111}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D39D}",
        nfc: "\u{D39D}",
        nfd: "\u{1111}\u{1166}\u{11AC}",
        nfkc: "\u{D39D}",
        nfkd: "\u{1111}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D39E}",
        nfc: "\u{D39E}",
        nfd: "\u{1111}\u{1166}\u{11AD}",
        nfkc: "\u{D39E}",
        nfkd: "\u{1111}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D39F}",
        nfc: "\u{D39F}",
        nfd: "\u{1111}\u{1166}\u{11AE}",
        nfkc: "\u{D39F}",
        nfkd: "\u{1111}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D3A0}",
        nfc: "\u{D3A0}",
        nfd: "\u{1111}\u{1166}\u{11AF}",
        nfkc: "\u{D3A0}",
        nfkd: "\u{1111}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D3A1}",
        nfc: "\u{D3A1}",
        nfd: "\u{1111}\u{1166}\u{11B0}",
        nfkc: "\u{D3A1}",
        nfkd: "\u{1111}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D3A2}",
        nfc: "\u{D3A2}",
        nfd: "\u{1111}\u{1166}\u{11B1}",
        nfkc: "\u{D3A2}",
        nfkd: "\u{1111}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D3A3}",
        nfc: "\u{D3A3}",
        nfd: "\u{1111}\u{1166}\u{11B2}",
        nfkc: "\u{D3A3}",
        nfkd: "\u{1111}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D3A4}",
        nfc: "\u{D3A4}",
        nfd: "\u{1111}\u{1166}\u{11B3}",
        nfkc: "\u{D3A4}",
        nfkd: "\u{1111}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D3A5}",
        nfc: "\u{D3A5}",
        nfd: "\u{1111}\u{1166}\u{11B4}",
        nfkc: "\u{D3A5}",
        nfkd: "\u{1111}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D3A6}",
        nfc: "\u{D3A6}",
        nfd: "\u{1111}\u{1166}\u{11B5}",
        nfkc: "\u{D3A6}",
        nfkd: "\u{1111}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D3A7}",
        nfc: "\u{D3A7}",
        nfd: "\u{1111}\u{1166}\u{11B6}",
        nfkc: "\u{D3A7}",
        nfkd: "\u{1111}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D3A8}",
        nfc: "\u{D3A8}",
        nfd: "\u{1111}\u{1166}\u{11B7}",
        nfkc: "\u{D3A8}",
        nfkd: "\u{1111}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D3A9}",
        nfc: "\u{D3A9}",
        nfd: "\u{1111}\u{1166}\u{11B8}",
        nfkc: "\u{D3A9}",
        nfkd: "\u{1111}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D3AA}",
        nfc: "\u{D3AA}",
        nfd: "\u{1111}\u{1166}\u{11B9}",
        nfkc: "\u{D3AA}",
        nfkd: "\u{1111}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D3AB}",
        nfc: "\u{D3AB}",
        nfd: "\u{1111}\u{1166}\u{11BA}",
        nfkc: "\u{D3AB}",
        nfkd: "\u{1111}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D3AC}",
        nfc: "\u{D3AC}",
        nfd: "\u{1111}\u{1166}\u{11BB}",
        nfkc: "\u{D3AC}",
        nfkd: "\u{1111}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D3AD}",
        nfc: "\u{D3AD}",
        nfd: "\u{1111}\u{1166}\u{11BC}",
        nfkc: "\u{D3AD}",
        nfkd: "\u{1111}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D3AE}",
        nfc: "\u{D3AE}",
        nfd: "\u{1111}\u{1166}\u{11BD}",
        nfkc: "\u{D3AE}",
        nfkd: "\u{1111}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D3AF}",
        nfc: "\u{D3AF}",
        nfd: "\u{1111}\u{1166}\u{11BE}",
        nfkc: "\u{D3AF}",
        nfkd: "\u{1111}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D3B0}",
        nfc: "\u{D3B0}",
        nfd: "\u{1111}\u{1166}\u{11BF}",
        nfkc: "\u{D3B0}",
        nfkd: "\u{1111}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D3B1}",
        nfc: "\u{D3B1}",
        nfd: "\u{1111}\u{1166}\u{11C0}",
        nfkc: "\u{D3B1}",
        nfkd: "\u{1111}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D3B2}",
        nfc: "\u{D3B2}",
        nfd: "\u{1111}\u{1166}\u{11C1}",
        nfkc: "\u{D3B2}",
        nfkd: "\u{1111}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D3B3}",
        nfc: "\u{D3B3}",
        nfd: "\u{1111}\u{1166}\u{11C2}",
        nfkc: "\u{D3B3}",
        nfkd: "\u{1111}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D3B4}",
        nfc: "\u{D3B4}",
        nfd: "\u{1111}\u{1167}",
        nfkc: "\u{D3B4}",
        nfkd: "\u{1111}\u{1167}",
    },
    NormalizationTest {
        source: "\u{D3B5}",
        nfc: "\u{D3B5}",
        nfd: "\u{1111}\u{1167}\u{11A8}",
        nfkc: "\u{D3B5}",
        nfkd: "\u{1111}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D3B6}",
        nfc: "\u{D3B6}",
        nfd: "\u{1111}\u{1167}\u{11A9}",
        nfkc: "\u{D3B6}",
        nfkd: "\u{1111}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D3B7}",
        nfc: "\u{D3B7}",
        nfd: "\u{1111}\u{1167}\u{11AA}",
        nfkc: "\u{D3B7}",
        nfkd: "\u{1111}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D3B8}",
        nfc: "\u{D3B8}",
        nfd: "\u{1111}\u{1167}\u{11AB}",
        nfkc: "\u{D3B8}",
        nfkd: "\u{1111}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D3B9}",
        nfc: "\u{D3B9}",
        nfd: "\u{1111}\u{1167}\u{11AC}",
        nfkc: "\u{D3B9}",
        nfkd: "\u{1111}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D3BA}",
        nfc: "\u{D3BA}",
        nfd: "\u{1111}\u{1167}\u{11AD}",
        nfkc: "\u{D3BA}",
        nfkd: "\u{1111}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D3BB}",
        nfc: "\u{D3BB}",
        nfd: "\u{1111}\u{1167}\u{11AE}",
        nfkc: "\u{D3BB}",
        nfkd: "\u{1111}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D3BC}",
        nfc: "\u{D3BC}",
        nfd: "\u{1111}\u{1167}\u{11AF}",
        nfkc: "\u{D3BC}",
        nfkd: "\u{1111}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D3BD}",
        nfc: "\u{D3BD}",
        nfd: "\u{1111}\u{1167}\u{11B0}",
        nfkc: "\u{D3BD}",
        nfkd: "\u{1111}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D3BE}",
        nfc: "\u{D3BE}",
        nfd: "\u{1111}\u{1167}\u{11B1}",
        nfkc: "\u{D3BE}",
        nfkd: "\u{1111}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D3BF}",
        nfc: "\u{D3BF}",
        nfd: "\u{1111}\u{1167}\u{11B2}",
        nfkc: "\u{D3BF}",
        nfkd: "\u{1111}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D3C0}",
        nfc: "\u{D3C0}",
        nfd: "\u{1111}\u{1167}\u{11B3}",
        nfkc: "\u{D3C0}",
        nfkd: "\u{1111}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D3C1}",
        nfc: "\u{D3C1}",
        nfd: "\u{1111}\u{1167}\u{11B4}",
        nfkc: "\u{D3C1}",
        nfkd: "\u{1111}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D3C2}",
        nfc: "\u{D3C2}",
        nfd: "\u{1111}\u{1167}\u{11B5}",
        nfkc: "\u{D3C2}",
        nfkd: "\u{1111}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D3C3}",
        nfc: "\u{D3C3}",
        nfd: "\u{1111}\u{1167}\u{11B6}",
        nfkc: "\u{D3C3}",
        nfkd: "\u{1111}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D3C4}",
        nfc: "\u{D3C4}",
        nfd: "\u{1111}\u{1167}\u{11B7}",
        nfkc: "\u{D3C4}",
        nfkd: "\u{1111}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D3C5}",
        nfc: "\u{D3C5}",
        nfd: "\u{1111}\u{1167}\u{11B8}",
        nfkc: "\u{D3C5}",
        nfkd: "\u{1111}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D3C6}",
        nfc: "\u{D3C6}",
        nfd: "\u{1111}\u{1167}\u{11B9}",
        nfkc: "\u{D3C6}",
        nfkd: "\u{1111}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D3C7}",
        nfc: "\u{D3C7}",
        nfd: "\u{1111}\u{1167}\u{11BA}",
        nfkc: "\u{D3C7}",
        nfkd: "\u{1111}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D3C8}",
        nfc: "\u{D3C8}",
        nfd: "\u{1111}\u{1167}\u{11BB}",
        nfkc: "\u{D3C8}",
        nfkd: "\u{1111}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D3C9}",
        nfc: "\u{D3C9}",
        nfd: "\u{1111}\u{1167}\u{11BC}",
        nfkc: "\u{D3C9}",
        nfkd: "\u{1111}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D3CA}",
        nfc: "\u{D3CA}",
        nfd: "\u{1111}\u{1167}\u{11BD}",
        nfkc: "\u{D3CA}",
        nfkd: "\u{1111}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D3CB}",
        nfc: "\u{D3CB}",
        nfd: "\u{1111}\u{1167}\u{11BE}",
        nfkc: "\u{D3CB}",
        nfkd: "\u{1111}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D3CC}",
        nfc: "\u{D3CC}",
        nfd: "\u{1111}\u{1167}\u{11BF}",
        nfkc: "\u{D3CC}",
        nfkd: "\u{1111}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D3CD}",
        nfc: "\u{D3CD}",
        nfd: "\u{1111}\u{1167}\u{11C0}",
        nfkc: "\u{D3CD}",
        nfkd: "\u{1111}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D3CE}",
        nfc: "\u{D3CE}",
        nfd: "\u{1111}\u{1167}\u{11C1}",
        nfkc: "\u{D3CE}",
        nfkd: "\u{1111}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D3CF}",
        nfc: "\u{D3CF}",
        nfd: "\u{1111}\u{1167}\u{11C2}",
        nfkc: "\u{D3CF}",
        nfkd: "\u{1111}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D3D0}",
        nfc: "\u{D3D0}",
        nfd: "\u{1111}\u{1168}",
        nfkc: "\u{D3D0}",
        nfkd: "\u{1111}\u{1168}",
    },
    NormalizationTest {
        source: "\u{D3D1}",
        nfc: "\u{D3D1}",
        nfd: "\u{1111}\u{1168}\u{11A8}",
        nfkc: "\u{D3D1}",
        nfkd: "\u{1111}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D3D2}",
        nfc: "\u{D3D2}",
        nfd: "\u{1111}\u{1168}\u{11A9}",
        nfkc: "\u{D3D2}",
        nfkd: "\u{1111}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D3D3}",
        nfc: "\u{D3D3}",
        nfd: "\u{1111}\u{1168}\u{11AA}",
        nfkc: "\u{D3D3}",
        nfkd: "\u{1111}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D3D4}",
        nfc: "\u{D3D4}",
        nfd: "\u{1111}\u{1168}\u{11AB}",
        nfkc: "\u{D3D4}",
        nfkd: "\u{1111}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D3D5}",
        nfc: "\u{D3D5}",
        nfd: "\u{1111}\u{1168}\u{11AC}",
        nfkc: "\u{D3D5}",
        nfkd: "\u{1111}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D3D6}",
        nfc: "\u{D3D6}",
        nfd: "\u{1111}\u{1168}\u{11AD}",
        nfkc: "\u{D3D6}",
        nfkd: "\u{1111}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D3D7}",
        nfc: "\u{D3D7}",
        nfd: "\u{1111}\u{1168}\u{11AE}",
        nfkc: "\u{D3D7}",
        nfkd: "\u{1111}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D3D8}",
        nfc: "\u{D3D8}",
        nfd: "\u{1111}\u{1168}\u{11AF}",
        nfkc: "\u{D3D8}",
        nfkd: "\u{1111}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D3D9}",
        nfc: "\u{D3D9}",
        nfd: "\u{1111}\u{1168}\u{11B0}",
        nfkc: "\u{D3D9}",
        nfkd: "\u{1111}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D3DA}",
        nfc: "\u{D3DA}",
        nfd: "\u{1111}\u{1168}\u{11B1}",
        nfkc: "\u{D3DA}",
        nfkd: "\u{1111}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D3DB}",
        nfc: "\u{D3DB}",
        nfd: "\u{1111}\u{1168}\u{11B2}",
        nfkc: "\u{D3DB}",
        nfkd: "\u{1111}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D3DC}",
        nfc: "\u{D3DC}",
        nfd: "\u{1111}\u{1168}\u{11B3}",
        nfkc: "\u{D3DC}",
        nfkd: "\u{1111}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D3DD}",
        nfc: "\u{D3DD}",
        nfd: "\u{1111}\u{1168}\u{11B4}",
        nfkc: "\u{D3DD}",
        nfkd: "\u{1111}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D3DE}",
        nfc: "\u{D3DE}",
        nfd: "\u{1111}\u{1168}\u{11B5}",
        nfkc: "\u{D3DE}",
        nfkd: "\u{1111}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D3DF}",
        nfc: "\u{D3DF}",
        nfd: "\u{1111}\u{1168}\u{11B6}",
        nfkc: "\u{D3DF}",
        nfkd: "\u{1111}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D3E0}",
        nfc: "\u{D3E0}",
        nfd: "\u{1111}\u{1168}\u{11B7}",
        nfkc: "\u{D3E0}",
        nfkd: "\u{1111}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D3E1}",
        nfc: "\u{D3E1}",
        nfd: "\u{1111}\u{1168}\u{11B8}",
        nfkc: "\u{D3E1}",
        nfkd: "\u{1111}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D3E2}",
        nfc: "\u{D3E2}",
        nfd: "\u{1111}\u{1168}\u{11B9}",
        nfkc: "\u{D3E2}",
        nfkd: "\u{1111}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D3E3}",
        nfc: "\u{D3E3}",
        nfd: "\u{1111}\u{1168}\u{11BA}",
        nfkc: "\u{D3E3}",
        nfkd: "\u{1111}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D3E4}",
        nfc: "\u{D3E4}",
        nfd: "\u{1111}\u{1168}\u{11BB}",
        nfkc: "\u{D3E4}",
        nfkd: "\u{1111}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D3E5}",
        nfc: "\u{D3E5}",
        nfd: "\u{1111}\u{1168}\u{11BC}",
        nfkc: "\u{D3E5}",
        nfkd: "\u{1111}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D3E6}",
        nfc: "\u{D3E6}",
        nfd: "\u{1111}\u{1168}\u{11BD}",
        nfkc: "\u{D3E6}",
        nfkd: "\u{1111}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D3E7}",
        nfc: "\u{D3E7}",
        nfd: "\u{1111}\u{1168}\u{11BE}",
        nfkc: "\u{D3E7}",
        nfkd: "\u{1111}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D3E8}",
        nfc: "\u{D3E8}",
        nfd: "\u{1111}\u{1168}\u{11BF}",
        nfkc: "\u{D3E8}",
        nfkd: "\u{1111}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D3E9}",
        nfc: "\u{D3E9}",
        nfd: "\u{1111}\u{1168}\u{11C0}",
        nfkc: "\u{D3E9}",
        nfkd: "\u{1111}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D3EA}",
        nfc: "\u{D3EA}",
        nfd: "\u{1111}\u{1168}\u{11C1}",
        nfkc: "\u{D3EA}",
        nfkd: "\u{1111}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D3EB}",
        nfc: "\u{D3EB}",
        nfd: "\u{1111}\u{1168}\u{11C2}",
        nfkc: "\u{D3EB}",
        nfkd: "\u{1111}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D3EC}",
        nfc: "\u{D3EC}",
        nfd: "\u{1111}\u{1169}",
        nfkc: "\u{D3EC}",
        nfkd: "\u{1111}\u{1169}",
    },
    NormalizationTest {
        source: "\u{D3ED}",
        nfc: "\u{D3ED}",
        nfd: "\u{1111}\u{1169}\u{11A8}",
        nfkc: "\u{D3ED}",
        nfkd: "\u{1111}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D3EE}",
        nfc: "\u{D3EE}",
        nfd: "\u{1111}\u{1169}\u{11A9}",
        nfkc: "\u{D3EE}",
        nfkd: "\u{1111}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D3EF}",
        nfc: "\u{D3EF}",
        nfd: "\u{1111}\u{1169}\u{11AA}",
        nfkc: "\u{D3EF}",
        nfkd: "\u{1111}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D3F0}",
        nfc: "\u{D3F0}",
        nfd: "\u{1111}\u{1169}\u{11AB}",
        nfkc: "\u{D3F0}",
        nfkd: "\u{1111}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D3F1}",
        nfc: "\u{D3F1}",
        nfd: "\u{1111}\u{1169}\u{11AC}",
        nfkc: "\u{D3F1}",
        nfkd: "\u{1111}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D3F2}",
        nfc: "\u{D3F2}",
        nfd: "\u{1111}\u{1169}\u{11AD}",
        nfkc: "\u{D3F2}",
        nfkd: "\u{1111}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D3F3}",
        nfc: "\u{D3F3}",
        nfd: "\u{1111}\u{1169}\u{11AE}",
        nfkc: "\u{D3F3}",
        nfkd: "\u{1111}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D3F4}",
        nfc: "\u{D3F4}",
        nfd: "\u{1111}\u{1169}\u{11AF}",
        nfkc: "\u{D3F4}",
        nfkd: "\u{1111}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D3F5}",
        nfc: "\u{D3F5}",
        nfd: "\u{1111}\u{1169}\u{11B0}",
        nfkc: "\u{D3F5}",
        nfkd: "\u{1111}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D3F6}",
        nfc: "\u{D3F6}",
        nfd: "\u{1111}\u{1169}\u{11B1}",
        nfkc: "\u{D3F6}",
        nfkd: "\u{1111}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D3F7}",
        nfc: "\u{D3F7}",
        nfd: "\u{1111}\u{1169}\u{11B2}",
        nfkc: "\u{D3F7}",
        nfkd: "\u{1111}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D3F8}",
        nfc: "\u{D3F8}",
        nfd: "\u{1111}\u{1169}\u{11B3}",
        nfkc: "\u{D3F8}",
        nfkd: "\u{1111}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D3F9}",
        nfc: "\u{D3F9}",
        nfd: "\u{1111}\u{1169}\u{11B4}",
        nfkc: "\u{D3F9}",
        nfkd: "\u{1111}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D3FA}",
        nfc: "\u{D3FA}",
        nfd: "\u{1111}\u{1169}\u{11B5}",
        nfkc: "\u{D3FA}",
        nfkd: "\u{1111}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D3FB}",
        nfc: "\u{D3FB}",
        nfd: "\u{1111}\u{1169}\u{11B6}",
        nfkc: "\u{D3FB}",
        nfkd: "\u{1111}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D3FC}",
        nfc: "\u{D3FC}",
        nfd: "\u{1111}\u{1169}\u{11B7}",
        nfkc: "\u{D3FC}",
        nfkd: "\u{1111}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D3FD}",
        nfc: "\u{D3FD}",
        nfd: "\u{1111}\u{1169}\u{11B8}",
        nfkc: "\u{D3FD}",
        nfkd: "\u{1111}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D3FE}",
        nfc: "\u{D3FE}",
        nfd: "\u{1111}\u{1169}\u{11B9}",
        nfkc: "\u{D3FE}",
        nfkd: "\u{1111}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D3FF}",
        nfc: "\u{D3FF}",
        nfd: "\u{1111}\u{1169}\u{11BA}",
        nfkc: "\u{D3FF}",
        nfkd: "\u{1111}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D400}",
        nfc: "\u{D400}",
        nfd: "\u{1111}\u{1169}\u{11BB}",
        nfkc: "\u{D400}",
        nfkd: "\u{1111}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D401}",
        nfc: "\u{D401}",
        nfd: "\u{1111}\u{1169}\u{11BC}",
        nfkc: "\u{D401}",
        nfkd: "\u{1111}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D402}",
        nfc: "\u{D402}",
        nfd: "\u{1111}\u{1169}\u{11BD}",
        nfkc: "\u{D402}",
        nfkd: "\u{1111}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D403}",
        nfc: "\u{D403}",
        nfd: "\u{1111}\u{1169}\u{11BE}",
        nfkc: "\u{D403}",
        nfkd: "\u{1111}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D404}",
        nfc: "\u{D404}",
        nfd: "\u{1111}\u{1169}\u{11BF}",
        nfkc: "\u{D404}",
        nfkd: "\u{1111}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D405}",
        nfc: "\u{D405}",
        nfd: "\u{1111}\u{1169}\u{11C0}",
        nfkc: "\u{D405}",
        nfkd: "\u{1111}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D406}",
        nfc: "\u{D406}",
        nfd: "\u{1111}\u{1169}\u{11C1}",
        nfkc: "\u{D406}",
        nfkd: "\u{1111}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D407}",
        nfc: "\u{D407}",
        nfd: "\u{1111}\u{1169}\u{11C2}",
        nfkc: "\u{D407}",
        nfkd: "\u{1111}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D408}",
        nfc: "\u{D408}",
        nfd: "\u{1111}\u{116A}",
        nfkc: "\u{D408}",
        nfkd: "\u{1111}\u{116A}",
    },
    NormalizationTest {
        source: "\u{D409}",
        nfc: "\u{D409}",
        nfd: "\u{1111}\u{116A}\u{11A8}",
        nfkc: "\u{D409}",
        nfkd: "\u{1111}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D40A}",
        nfc: "\u{D40A}",
        nfd: "\u{1111}\u{116A}\u{11A9}",
        nfkc: "\u{D40A}",
        nfkd: "\u{1111}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D40B}",
        nfc: "\u{D40B}",
        nfd: "\u{1111}\u{116A}\u{11AA}",
        nfkc: "\u{D40B}",
        nfkd: "\u{1111}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D40C}",
        nfc: "\u{D40C}",
        nfd: "\u{1111}\u{116A}\u{11AB}",
        nfkc: "\u{D40C}",
        nfkd: "\u{1111}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D40D}",
        nfc: "\u{D40D}",
        nfd: "\u{1111}\u{116A}\u{11AC}",
        nfkc: "\u{D40D}",
        nfkd: "\u{1111}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D40E}",
        nfc: "\u{D40E}",
        nfd: "\u{1111}\u{116A}\u{11AD}",
        nfkc: "\u{D40E}",
        nfkd: "\u{1111}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D40F}",
        nfc: "\u{D40F}",
        nfd: "\u{1111}\u{116A}\u{11AE}",
        nfkc: "\u{D40F}",
        nfkd: "\u{1111}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D410}",
        nfc: "\u{D410}",
        nfd: "\u{1111}\u{116A}\u{11AF}",
        nfkc: "\u{D410}",
        nfkd: "\u{1111}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D411}",
        nfc: "\u{D411}",
        nfd: "\u{1111}\u{116A}\u{11B0}",
        nfkc: "\u{D411}",
        nfkd: "\u{1111}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D412}",
        nfc: "\u{D412}",
        nfd: "\u{1111}\u{116A}\u{11B1}",
        nfkc: "\u{D412}",
        nfkd: "\u{1111}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D413}",
        nfc: "\u{D413}",
        nfd: "\u{1111}\u{116A}\u{11B2}",
        nfkc: "\u{D413}",
        nfkd: "\u{1111}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D414}",
        nfc: "\u{D414}",
        nfd: "\u{1111}\u{116A}\u{11B3}",
        nfkc: "\u{D414}",
        nfkd: "\u{1111}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D415}",
        nfc: "\u{D415}",
        nfd: "\u{1111}\u{116A}\u{11B4}",
        nfkc: "\u{D415}",
        nfkd: "\u{1111}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D416}",
        nfc: "\u{D416}",
        nfd: "\u{1111}\u{116A}\u{11B5}",
        nfkc: "\u{D416}",
        nfkd: "\u{1111}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D417}",
        nfc: "\u{D417}",
        nfd: "\u{1111}\u{116A}\u{11B6}",
        nfkc: "\u{D417}",
        nfkd: "\u{1111}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D418}",
        nfc: "\u{D418}",
        nfd: "\u{1111}\u{116A}\u{11B7}",
        nfkc: "\u{D418}",
        nfkd: "\u{1111}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D419}",
        nfc: "\u{D419}",
        nfd: "\u{1111}\u{116A}\u{11B8}",
        nfkc: "\u{D419}",
        nfkd: "\u{1111}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D41A}",
        nfc: "\u{D41A}",
        nfd: "\u{1111}\u{116A}\u{11B9}",
        nfkc: "\u{D41A}",
        nfkd: "\u{1111}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D41B}",
        nfc: "\u{D41B}",
        nfd: "\u{1111}\u{116A}\u{11BA}",
        nfkc: "\u{D41B}",
        nfkd: "\u{1111}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D41C}",
        nfc: "\u{D41C}",
        nfd: "\u{1111}\u{116A}\u{11BB}",
        nfkc: "\u{D41C}",
        nfkd: "\u{1111}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D41D}",
        nfc: "\u{D41D}",
        nfd: "\u{1111}\u{116A}\u{11BC}",
        nfkc: "\u{D41D}",
        nfkd: "\u{1111}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D41E}",
        nfc: "\u{D41E}",
        nfd: "\u{1111}\u{116A}\u{11BD}",
        nfkc: "\u{D41E}",
        nfkd: "\u{1111}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D41F}",
        nfc: "\u{D41F}",
        nfd: "\u{1111}\u{116A}\u{11BE}",
        nfkc: "\u{D41F}",
        nfkd: "\u{1111}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D420}",
        nfc: "\u{D420}",
        nfd: "\u{1111}\u{116A}\u{11BF}",
        nfkc: "\u{D420}",
        nfkd: "\u{1111}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D421}",
        nfc: "\u{D421}",
        nfd: "\u{1111}\u{116A}\u{11C0}",
        nfkc: "\u{D421}",
        nfkd: "\u{1111}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D422}",
        nfc: "\u{D422}",
        nfd: "\u{1111}\u{116A}\u{11C1}",
        nfkc: "\u{D422}",
        nfkd: "\u{1111}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D423}",
        nfc: "\u{D423}",
        nfd: "\u{1111}\u{116A}\u{11C2}",
        nfkc: "\u{D423}",
        nfkd: "\u{1111}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D424}",
        nfc: "\u{D424}",
        nfd: "\u{1111}\u{116B}",
        nfkc: "\u{D424}",
        nfkd: "\u{1111}\u{116B}",
    },
    NormalizationTest {
        source: "\u{D425}",
        nfc: "\u{D425}",
        nfd: "\u{1111}\u{116B}\u{11A8}",
        nfkc: "\u{D425}",
        nfkd: "\u{1111}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D426}",
        nfc: "\u{D426}",
        nfd: "\u{1111}\u{116B}\u{11A9}",
        nfkc: "\u{D426}",
        nfkd: "\u{1111}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D427}",
        nfc: "\u{D427}",
        nfd: "\u{1111}\u{116B}\u{11AA}",
        nfkc: "\u{D427}",
        nfkd: "\u{1111}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D428}",
        nfc: "\u{D428}",
        nfd: "\u{1111}\u{116B}\u{11AB}",
        nfkc: "\u{D428}",
        nfkd: "\u{1111}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D429}",
        nfc: "\u{D429}",
        nfd: "\u{1111}\u{116B}\u{11AC}",
        nfkc: "\u{D429}",
        nfkd: "\u{1111}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D42A}",
        nfc: "\u{D42A}",
        nfd: "\u{1111}\u{116B}\u{11AD}",
        nfkc: "\u{D42A}",
        nfkd: "\u{1111}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D42B}",
        nfc: "\u{D42B}",
        nfd: "\u{1111}\u{116B}\u{11AE}",
        nfkc: "\u{D42B}",
        nfkd: "\u{1111}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D42C}",
        nfc: "\u{D42C}",
        nfd: "\u{1111}\u{116B}\u{11AF}",
        nfkc: "\u{D42C}",
        nfkd: "\u{1111}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D42D}",
        nfc: "\u{D42D}",
        nfd: "\u{1111}\u{116B}\u{11B0}",
        nfkc: "\u{D42D}",
        nfkd: "\u{1111}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D42E}",
        nfc: "\u{D42E}",
        nfd: "\u{1111}\u{116B}\u{11B1}",
        nfkc: "\u{D42E}",
        nfkd: "\u{1111}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D42F}",
        nfc: "\u{D42F}",
        nfd: "\u{1111}\u{116B}\u{11B2}",
        nfkc: "\u{D42F}",
        nfkd: "\u{1111}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D430}",
        nfc: "\u{D430}",
        nfd: "\u{1111}\u{116B}\u{11B3}",
        nfkc: "\u{D430}",
        nfkd: "\u{1111}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D431}",
        nfc: "\u{D431}",
        nfd: "\u{1111}\u{116B}\u{11B4}",
        nfkc: "\u{D431}",
        nfkd: "\u{1111}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D432}",
        nfc: "\u{D432}",
        nfd: "\u{1111}\u{116B}\u{11B5}",
        nfkc: "\u{D432}",
        nfkd: "\u{1111}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D433}",
        nfc: "\u{D433}",
        nfd: "\u{1111}\u{116B}\u{11B6}",
        nfkc: "\u{D433}",
        nfkd: "\u{1111}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D434}",
        nfc: "\u{D434}",
        nfd: "\u{1111}\u{116B}\u{11B7}",
        nfkc: "\u{D434}",
        nfkd: "\u{1111}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D435}",
        nfc: "\u{D435}",
        nfd: "\u{1111}\u{116B}\u{11B8}",
        nfkc: "\u{D435}",
        nfkd: "\u{1111}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D436}",
        nfc: "\u{D436}",
        nfd: "\u{1111}\u{116B}\u{11B9}",
        nfkc: "\u{D436}",
        nfkd: "\u{1111}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D437}",
        nfc: "\u{D437}",
        nfd: "\u{1111}\u{116B}\u{11BA}",
        nfkc: "\u{D437}",
        nfkd: "\u{1111}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D438}",
        nfc: "\u{D438}",
        nfd: "\u{1111}\u{116B}\u{11BB}",
        nfkc: "\u{D438}",
        nfkd: "\u{1111}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D439}",
        nfc: "\u{D439}",
        nfd: "\u{1111}\u{116B}\u{11BC}",
        nfkc: "\u{D439}",
        nfkd: "\u{1111}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D43A}",
        nfc: "\u{D43A}",
        nfd: "\u{1111}\u{116B}\u{11BD}",
        nfkc: "\u{D43A}",
        nfkd: "\u{1111}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D43B}",
        nfc: "\u{D43B}",
        nfd: "\u{1111}\u{116B}\u{11BE}",
        nfkc: "\u{D43B}",
        nfkd: "\u{1111}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D43C}",
        nfc: "\u{D43C}",
        nfd: "\u{1111}\u{116B}\u{11BF}",
        nfkc: "\u{D43C}",
        nfkd: "\u{1111}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D43D}",
        nfc: "\u{D43D}",
        nfd: "\u{1111}\u{116B}\u{11C0}",
        nfkc: "\u{D43D}",
        nfkd: "\u{1111}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D43E}",
        nfc: "\u{D43E}",
        nfd: "\u{1111}\u{116B}\u{11C1}",
        nfkc: "\u{D43E}",
        nfkd: "\u{1111}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D43F}",
        nfc: "\u{D43F}",
        nfd: "\u{1111}\u{116B}\u{11C2}",
        nfkc: "\u{D43F}",
        nfkd: "\u{1111}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D440}",
        nfc: "\u{D440}",
        nfd: "\u{1111}\u{116C}",
        nfkc: "\u{D440}",
        nfkd: "\u{1111}\u{116C}",
    },
    NormalizationTest {
        source: "\u{D441}",
        nfc: "\u{D441}",
        nfd: "\u{1111}\u{116C}\u{11A8}",
        nfkc: "\u{D441}",
        nfkd: "\u{1111}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D442}",
        nfc: "\u{D442}",
        nfd: "\u{1111}\u{116C}\u{11A9}",
        nfkc: "\u{D442}",
        nfkd: "\u{1111}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D443}",
        nfc: "\u{D443}",
        nfd: "\u{1111}\u{116C}\u{11AA}",
        nfkc: "\u{D443}",
        nfkd: "\u{1111}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D444}",
        nfc: "\u{D444}",
        nfd: "\u{1111}\u{116C}\u{11AB}",
        nfkc: "\u{D444}",
        nfkd: "\u{1111}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D445}",
        nfc: "\u{D445}",
        nfd: "\u{1111}\u{116C}\u{11AC}",
        nfkc: "\u{D445}",
        nfkd: "\u{1111}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D446}",
        nfc: "\u{D446}",
        nfd: "\u{1111}\u{116C}\u{11AD}",
        nfkc: "\u{D446}",
        nfkd: "\u{1111}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D447}",
        nfc: "\u{D447}",
        nfd: "\u{1111}\u{116C}\u{11AE}",
        nfkc: "\u{D447}",
        nfkd: "\u{1111}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D448}",
        nfc: "\u{D448}",
        nfd: "\u{1111}\u{116C}\u{11AF}",
        nfkc: "\u{D448}",
        nfkd: "\u{1111}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D449}",
        nfc: "\u{D449}",
        nfd: "\u{1111}\u{116C}\u{11B0}",
        nfkc: "\u{D449}",
        nfkd: "\u{1111}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D44A}",
        nfc: "\u{D44A}",
        nfd: "\u{1111}\u{116C}\u{11B1}",
        nfkc: "\u{D44A}",
        nfkd: "\u{1111}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D44B}",
        nfc: "\u{D44B}",
        nfd: "\u{1111}\u{116C}\u{11B2}",
        nfkc: "\u{D44B}",
        nfkd: "\u{1111}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D44C}",
        nfc: "\u{D44C}",
        nfd: "\u{1111}\u{116C}\u{11B3}",
        nfkc: "\u{D44C}",
        nfkd: "\u{1111}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D44D}",
        nfc: "\u{D44D}",
        nfd: "\u{1111}\u{116C}\u{11B4}",
        nfkc: "\u{D44D}",
        nfkd: "\u{1111}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D44E}",
        nfc: "\u{D44E}",
        nfd: "\u{1111}\u{116C}\u{11B5}",
        nfkc: "\u{D44E}",
        nfkd: "\u{1111}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D44F}",
        nfc: "\u{D44F}",
        nfd: "\u{1111}\u{116C}\u{11B6}",
        nfkc: "\u{D44F}",
        nfkd: "\u{1111}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D450}",
        nfc: "\u{D450}",
        nfd: "\u{1111}\u{116C}\u{11B7}",
        nfkc: "\u{D450}",
        nfkd: "\u{1111}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D451}",
        nfc: "\u{D451}",
        nfd: "\u{1111}\u{116C}\u{11B8}",
        nfkc: "\u{D451}",
        nfkd: "\u{1111}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D452}",
        nfc: "\u{D452}",
        nfd: "\u{1111}\u{116C}\u{11B9}",
        nfkc: "\u{D452}",
        nfkd: "\u{1111}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D453}",
        nfc: "\u{D453}",
        nfd: "\u{1111}\u{116C}\u{11BA}",
        nfkc: "\u{D453}",
        nfkd: "\u{1111}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D454}",
        nfc: "\u{D454}",
        nfd: "\u{1111}\u{116C}\u{11BB}",
        nfkc: "\u{D454}",
        nfkd: "\u{1111}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D455}",
        nfc: "\u{D455}",
        nfd: "\u{1111}\u{116C}\u{11BC}",
        nfkc: "\u{D455}",
        nfkd: "\u{1111}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D456}",
        nfc: "\u{D456}",
        nfd: "\u{1111}\u{116C}\u{11BD}",
        nfkc: "\u{D456}",
        nfkd: "\u{1111}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D457}",
        nfc: "\u{D457}",
        nfd: "\u{1111}\u{116C}\u{11BE}",
        nfkc: "\u{D457}",
        nfkd: "\u{1111}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D458}",
        nfc: "\u{D458}",
        nfd: "\u{1111}\u{116C}\u{11BF}",
        nfkc: "\u{D458}",
        nfkd: "\u{1111}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D459}",
        nfc: "\u{D459}",
        nfd: "\u{1111}\u{116C}\u{11C0}",
        nfkc: "\u{D459}",
        nfkd: "\u{1111}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D45A}",
        nfc: "\u{D45A}",
        nfd: "\u{1111}\u{116C}\u{11C1}",
        nfkc: "\u{D45A}",
        nfkd: "\u{1111}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D45B}",
        nfc: "\u{D45B}",
        nfd: "\u{1111}\u{116C}\u{11C2}",
        nfkc: "\u{D45B}",
        nfkd: "\u{1111}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D45C}",
        nfc: "\u{D45C}",
        nfd: "\u{1111}\u{116D}",
        nfkc: "\u{D45C}",
        nfkd: "\u{1111}\u{116D}",
    },
    NormalizationTest {
        source: "\u{D45D}",
        nfc: "\u{D45D}",
        nfd: "\u{1111}\u{116D}\u{11A8}",
        nfkc: "\u{D45D}",
        nfkd: "\u{1111}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D45E}",
        nfc: "\u{D45E}",
        nfd: "\u{1111}\u{116D}\u{11A9}",
        nfkc: "\u{D45E}",
        nfkd: "\u{1111}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D45F}",
        nfc: "\u{D45F}",
        nfd: "\u{1111}\u{116D}\u{11AA}",
        nfkc: "\u{D45F}",
        nfkd: "\u{1111}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D460}",
        nfc: "\u{D460}",
        nfd: "\u{1111}\u{116D}\u{11AB}",
        nfkc: "\u{D460}",
        nfkd: "\u{1111}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D461}",
        nfc: "\u{D461}",
        nfd: "\u{1111}\u{116D}\u{11AC}",
        nfkc: "\u{D461}",
        nfkd: "\u{1111}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D462}",
        nfc: "\u{D462}",
        nfd: "\u{1111}\u{116D}\u{11AD}",
        nfkc: "\u{D462}",
        nfkd: "\u{1111}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D463}",
        nfc: "\u{D463}",
        nfd: "\u{1111}\u{116D}\u{11AE}",
        nfkc: "\u{D463}",
        nfkd: "\u{1111}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D464}",
        nfc: "\u{D464}",
        nfd: "\u{1111}\u{116D}\u{11AF}",
        nfkc: "\u{D464}",
        nfkd: "\u{1111}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D465}",
        nfc: "\u{D465}",
        nfd: "\u{1111}\u{116D}\u{11B0}",
        nfkc: "\u{D465}",
        nfkd: "\u{1111}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D466}",
        nfc: "\u{D466}",
        nfd: "\u{1111}\u{116D}\u{11B1}",
        nfkc: "\u{D466}",
        nfkd: "\u{1111}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D467}",
        nfc: "\u{D467}",
        nfd: "\u{1111}\u{116D}\u{11B2}",
        nfkc: "\u{D467}",
        nfkd: "\u{1111}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D468}",
        nfc: "\u{D468}",
        nfd: "\u{1111}\u{116D}\u{11B3}",
        nfkc: "\u{D468}",
        nfkd: "\u{1111}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D469}",
        nfc: "\u{D469}",
        nfd: "\u{1111}\u{116D}\u{11B4}",
        nfkc: "\u{D469}",
        nfkd: "\u{1111}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D46A}",
        nfc: "\u{D46A}",
        nfd: "\u{1111}\u{116D}\u{11B5}",
        nfkc: "\u{D46A}",
        nfkd: "\u{1111}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D46B}",
        nfc: "\u{D46B}",
        nfd: "\u{1111}\u{116D}\u{11B6}",
        nfkc: "\u{D46B}",
        nfkd: "\u{1111}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D46C}",
        nfc: "\u{D46C}",
        nfd: "\u{1111}\u{116D}\u{11B7}",
        nfkc: "\u{D46C}",
        nfkd: "\u{1111}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D46D}",
        nfc: "\u{D46D}",
        nfd: "\u{1111}\u{116D}\u{11B8}",
        nfkc: "\u{D46D}",
        nfkd: "\u{1111}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D46E}",
        nfc: "\u{D46E}",
        nfd: "\u{1111}\u{116D}\u{11B9}",
        nfkc: "\u{D46E}",
        nfkd: "\u{1111}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D46F}",
        nfc: "\u{D46F}",
        nfd: "\u{1111}\u{116D}\u{11BA}",
        nfkc: "\u{D46F}",
        nfkd: "\u{1111}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D470}",
        nfc: "\u{D470}",
        nfd: "\u{1111}\u{116D}\u{11BB}",
        nfkc: "\u{D470}",
        nfkd: "\u{1111}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D471}",
        nfc: "\u{D471}",
        nfd: "\u{1111}\u{116D}\u{11BC}",
        nfkc: "\u{D471}",
        nfkd: "\u{1111}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D472}",
        nfc: "\u{D472}",
        nfd: "\u{1111}\u{116D}\u{11BD}",
        nfkc: "\u{D472}",
        nfkd: "\u{1111}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D473}",
        nfc: "\u{D473}",
        nfd: "\u{1111}\u{116D}\u{11BE}",
        nfkc: "\u{D473}",
        nfkd: "\u{1111}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D474}",
        nfc: "\u{D474}",
        nfd: "\u{1111}\u{116D}\u{11BF}",
        nfkc: "\u{D474}",
        nfkd: "\u{1111}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D475}",
        nfc: "\u{D475}",
        nfd: "\u{1111}\u{116D}\u{11C0}",
        nfkc: "\u{D475}",
        nfkd: "\u{1111}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D476}",
        nfc: "\u{D476}",
        nfd: "\u{1111}\u{116D}\u{11C1}",
        nfkc: "\u{D476}",
        nfkd: "\u{1111}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D477}",
        nfc: "\u{D477}",
        nfd: "\u{1111}\u{116D}\u{11C2}",
        nfkc: "\u{D477}",
        nfkd: "\u{1111}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D478}",
        nfc: "\u{D478}",
        nfd: "\u{1111}\u{116E}",
        nfkc: "\u{D478}",
        nfkd: "\u{1111}\u{116E}",
    },
    NormalizationTest {
        source: "\u{D479}",
        nfc: "\u{D479}",
        nfd: "\u{1111}\u{116E}\u{11A8}",
        nfkc: "\u{D479}",
        nfkd: "\u{1111}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D47A}",
        nfc: "\u{D47A}",
        nfd: "\u{1111}\u{116E}\u{11A9}",
        nfkc: "\u{D47A}",
        nfkd: "\u{1111}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D47B}",
        nfc: "\u{D47B}",
        nfd: "\u{1111}\u{116E}\u{11AA}",
        nfkc: "\u{D47B}",
        nfkd: "\u{1111}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D47C}",
        nfc: "\u{D47C}",
        nfd: "\u{1111}\u{116E}\u{11AB}",
        nfkc: "\u{D47C}",
        nfkd: "\u{1111}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D47D}",
        nfc: "\u{D47D}",
        nfd: "\u{1111}\u{116E}\u{11AC}",
        nfkc: "\u{D47D}",
        nfkd: "\u{1111}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D47E}",
        nfc: "\u{D47E}",
        nfd: "\u{1111}\u{116E}\u{11AD}",
        nfkc: "\u{D47E}",
        nfkd: "\u{1111}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D47F}",
        nfc: "\u{D47F}",
        nfd: "\u{1111}\u{116E}\u{11AE}",
        nfkc: "\u{D47F}",
        nfkd: "\u{1111}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D480}",
        nfc: "\u{D480}",
        nfd: "\u{1111}\u{116E}\u{11AF}",
        nfkc: "\u{D480}",
        nfkd: "\u{1111}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D481}",
        nfc: "\u{D481}",
        nfd: "\u{1111}\u{116E}\u{11B0}",
        nfkc: "\u{D481}",
        nfkd: "\u{1111}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D482}",
        nfc: "\u{D482}",
        nfd: "\u{1111}\u{116E}\u{11B1}",
        nfkc: "\u{D482}",
        nfkd: "\u{1111}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D483}",
        nfc: "\u{D483}",
        nfd: "\u{1111}\u{116E}\u{11B2}",
        nfkc: "\u{D483}",
        nfkd: "\u{1111}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D484}",
        nfc: "\u{D484}",
        nfd: "\u{1111}\u{116E}\u{11B3}",
        nfkc: "\u{D484}",
        nfkd: "\u{1111}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D485}",
        nfc: "\u{D485}",
        nfd: "\u{1111}\u{116E}\u{11B4}",
        nfkc: "\u{D485}",
        nfkd: "\u{1111}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D486}",
        nfc: "\u{D486}",
        nfd: "\u{1111}\u{116E}\u{11B5}",
        nfkc: "\u{D486}",
        nfkd: "\u{1111}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D487}",
        nfc: "\u{D487}",
        nfd: "\u{1111}\u{116E}\u{11B6}",
        nfkc: "\u{D487}",
        nfkd: "\u{1111}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D488}",
        nfc: "\u{D488}",
        nfd: "\u{1111}\u{116E}\u{11B7}",
        nfkc: "\u{D488}",
        nfkd: "\u{1111}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D489}",
        nfc: "\u{D489}",
        nfd: "\u{1111}\u{116E}\u{11B8}",
        nfkc: "\u{D489}",
        nfkd: "\u{1111}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D48A}",
        nfc: "\u{D48A}",
        nfd: "\u{1111}\u{116E}\u{11B9}",
        nfkc: "\u{D48A}",
        nfkd: "\u{1111}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D48B}",
        nfc: "\u{D48B}",
        nfd: "\u{1111}\u{116E}\u{11BA}",
        nfkc: "\u{D48B}",
        nfkd: "\u{1111}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D48C}",
        nfc: "\u{D48C}",
        nfd: "\u{1111}\u{116E}\u{11BB}",
        nfkc: "\u{D48C}",
        nfkd: "\u{1111}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D48D}",
        nfc: "\u{D48D}",
        nfd: "\u{1111}\u{116E}\u{11BC}",
        nfkc: "\u{D48D}",
        nfkd: "\u{1111}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D48E}",
        nfc: "\u{D48E}",
        nfd: "\u{1111}\u{116E}\u{11BD}",
        nfkc: "\u{D48E}",
        nfkd: "\u{1111}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D48F}",
        nfc: "\u{D48F}",
        nfd: "\u{1111}\u{116E}\u{11BE}",
        nfkc: "\u{D48F}",
        nfkd: "\u{1111}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D490}",
        nfc: "\u{D490}",
        nfd: "\u{1111}\u{116E}\u{11BF}",
        nfkc: "\u{D490}",
        nfkd: "\u{1111}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D491}",
        nfc: "\u{D491}",
        nfd: "\u{1111}\u{116E}\u{11C0}",
        nfkc: "\u{D491}",
        nfkd: "\u{1111}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D492}",
        nfc: "\u{D492}",
        nfd: "\u{1111}\u{116E}\u{11C1}",
        nfkc: "\u{D492}",
        nfkd: "\u{1111}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D493}",
        nfc: "\u{D493}",
        nfd: "\u{1111}\u{116E}\u{11C2}",
        nfkc: "\u{D493}",
        nfkd: "\u{1111}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D494}",
        nfc: "\u{D494}",
        nfd: "\u{1111}\u{116F}",
        nfkc: "\u{D494}",
        nfkd: "\u{1111}\u{116F}",
    },
    NormalizationTest {
        source: "\u{D495}",
        nfc: "\u{D495}",
        nfd: "\u{1111}\u{116F}\u{11A8}",
        nfkc: "\u{D495}",
        nfkd: "\u{1111}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D496}",
        nfc: "\u{D496}",
        nfd: "\u{1111}\u{116F}\u{11A9}",
        nfkc: "\u{D496}",
        nfkd: "\u{1111}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D497}",
        nfc: "\u{D497}",
        nfd: "\u{1111}\u{116F}\u{11AA}",
        nfkc: "\u{D497}",
        nfkd: "\u{1111}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D498}",
        nfc: "\u{D498}",
        nfd: "\u{1111}\u{116F}\u{11AB}",
        nfkc: "\u{D498}",
        nfkd: "\u{1111}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D499}",
        nfc: "\u{D499}",
        nfd: "\u{1111}\u{116F}\u{11AC}",
        nfkc: "\u{D499}",
        nfkd: "\u{1111}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D49A}",
        nfc: "\u{D49A}",
        nfd: "\u{1111}\u{116F}\u{11AD}",
        nfkc: "\u{D49A}",
        nfkd: "\u{1111}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D49B}",
        nfc: "\u{D49B}",
        nfd: "\u{1111}\u{116F}\u{11AE}",
        nfkc: "\u{D49B}",
        nfkd: "\u{1111}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D49C}",
        nfc: "\u{D49C}",
        nfd: "\u{1111}\u{116F}\u{11AF}",
        nfkc: "\u{D49C}",
        nfkd: "\u{1111}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D49D}",
        nfc: "\u{D49D}",
        nfd: "\u{1111}\u{116F}\u{11B0}",
        nfkc: "\u{D49D}",
        nfkd: "\u{1111}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D49E}",
        nfc: "\u{D49E}",
        nfd: "\u{1111}\u{116F}\u{11B1}",
        nfkc: "\u{D49E}",
        nfkd: "\u{1111}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D49F}",
        nfc: "\u{D49F}",
        nfd: "\u{1111}\u{116F}\u{11B2}",
        nfkc: "\u{D49F}",
        nfkd: "\u{1111}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D4A0}",
        nfc: "\u{D4A0}",
        nfd: "\u{1111}\u{116F}\u{11B3}",
        nfkc: "\u{D4A0}",
        nfkd: "\u{1111}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D4A1}",
        nfc: "\u{D4A1}",
        nfd: "\u{1111}\u{116F}\u{11B4}",
        nfkc: "\u{D4A1}",
        nfkd: "\u{1111}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D4A2}",
        nfc: "\u{D4A2}",
        nfd: "\u{1111}\u{116F}\u{11B5}",
        nfkc: "\u{D4A2}",
        nfkd: "\u{1111}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D4A3}",
        nfc: "\u{D4A3}",
        nfd: "\u{1111}\u{116F}\u{11B6}",
        nfkc: "\u{D4A3}",
        nfkd: "\u{1111}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D4A4}",
        nfc: "\u{D4A4}",
        nfd: "\u{1111}\u{116F}\u{11B7}",
        nfkc: "\u{D4A4}",
        nfkd: "\u{1111}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D4A5}",
        nfc: "\u{D4A5}",
        nfd: "\u{1111}\u{116F}\u{11B8}",
        nfkc: "\u{D4A5}",
        nfkd: "\u{1111}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D4A6}",
        nfc: "\u{D4A6}",
        nfd: "\u{1111}\u{116F}\u{11B9}",
        nfkc: "\u{D4A6}",
        nfkd: "\u{1111}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D4A7}",
        nfc: "\u{D4A7}",
        nfd: "\u{1111}\u{116F}\u{11BA}",
        nfkc: "\u{D4A7}",
        nfkd: "\u{1111}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D4A8}",
        nfc: "\u{D4A8}",
        nfd: "\u{1111}\u{116F}\u{11BB}",
        nfkc: "\u{D4A8}",
        nfkd: "\u{1111}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D4A9}",
        nfc: "\u{D4A9}",
        nfd: "\u{1111}\u{116F}\u{11BC}",
        nfkc: "\u{D4A9}",
        nfkd: "\u{1111}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D4AA}",
        nfc: "\u{D4AA}",
        nfd: "\u{1111}\u{116F}\u{11BD}",
        nfkc: "\u{D4AA}",
        nfkd: "\u{1111}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D4AB}",
        nfc: "\u{D4AB}",
        nfd: "\u{1111}\u{116F}\u{11BE}",
        nfkc: "\u{D4AB}",
        nfkd: "\u{1111}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D4AC}",
        nfc: "\u{D4AC}",
        nfd: "\u{1111}\u{116F}\u{11BF}",
        nfkc: "\u{D4AC}",
        nfkd: "\u{1111}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D4AD}",
        nfc: "\u{D4AD}",
        nfd: "\u{1111}\u{116F}\u{11C0}",
        nfkc: "\u{D4AD}",
        nfkd: "\u{1111}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D4AE}",
        nfc: "\u{D4AE}",
        nfd: "\u{1111}\u{116F}\u{11C1}",
        nfkc: "\u{D4AE}",
        nfkd: "\u{1111}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D4AF}",
        nfc: "\u{D4AF}",
        nfd: "\u{1111}\u{116F}\u{11C2}",
        nfkc: "\u{D4AF}",
        nfkd: "\u{1111}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D4B0}",
        nfc: "\u{D4B0}",
        nfd: "\u{1111}\u{1170}",
        nfkc: "\u{D4B0}",
        nfkd: "\u{1111}\u{1170}",
    },
    NormalizationTest {
        source: "\u{D4B1}",
        nfc: "\u{D4B1}",
        nfd: "\u{1111}\u{1170}\u{11A8}",
        nfkc: "\u{D4B1}",
        nfkd: "\u{1111}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D4B2}",
        nfc: "\u{D4B2}",
        nfd: "\u{1111}\u{1170}\u{11A9}",
        nfkc: "\u{D4B2}",
        nfkd: "\u{1111}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D4B3}",
        nfc: "\u{D4B3}",
        nfd: "\u{1111}\u{1170}\u{11AA}",
        nfkc: "\u{D4B3}",
        nfkd: "\u{1111}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D4B4}",
        nfc: "\u{D4B4}",
        nfd: "\u{1111}\u{1170}\u{11AB}",
        nfkc: "\u{D4B4}",
        nfkd: "\u{1111}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D4B5}",
        nfc: "\u{D4B5}",
        nfd: "\u{1111}\u{1170}\u{11AC}",
        nfkc: "\u{D4B5}",
        nfkd: "\u{1111}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D4B6}",
        nfc: "\u{D4B6}",
        nfd: "\u{1111}\u{1170}\u{11AD}",
        nfkc: "\u{D4B6}",
        nfkd: "\u{1111}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D4B7}",
        nfc: "\u{D4B7}",
        nfd: "\u{1111}\u{1170}\u{11AE}",
        nfkc: "\u{D4B7}",
        nfkd: "\u{1111}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D4B8}",
        nfc: "\u{D4B8}",
        nfd: "\u{1111}\u{1170}\u{11AF}",
        nfkc: "\u{D4B8}",
        nfkd: "\u{1111}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D4B9}",
        nfc: "\u{D4B9}",
        nfd: "\u{1111}\u{1170}\u{11B0}",
        nfkc: "\u{D4B9}",
        nfkd: "\u{1111}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D4BA}",
        nfc: "\u{D4BA}",
        nfd: "\u{1111}\u{1170}\u{11B1}",
        nfkc: "\u{D4BA}",
        nfkd: "\u{1111}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D4BB}",
        nfc: "\u{D4BB}",
        nfd: "\u{1111}\u{1170}\u{11B2}",
        nfkc: "\u{D4BB}",
        nfkd: "\u{1111}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D4BC}",
        nfc: "\u{D4BC}",
        nfd: "\u{1111}\u{1170}\u{11B3}",
        nfkc: "\u{D4BC}",
        nfkd: "\u{1111}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D4BD}",
        nfc: "\u{D4BD}",
        nfd: "\u{1111}\u{1170}\u{11B4}",
        nfkc: "\u{D4BD}",
        nfkd: "\u{1111}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D4BE}",
        nfc: "\u{D4BE}",
        nfd: "\u{1111}\u{1170}\u{11B5}",
        nfkc: "\u{D4BE}",
        nfkd: "\u{1111}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D4BF}",
        nfc: "\u{D4BF}",
        nfd: "\u{1111}\u{1170}\u{11B6}",
        nfkc: "\u{D4BF}",
        nfkd: "\u{1111}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D4C0}",
        nfc: "\u{D4C0}",
        nfd: "\u{1111}\u{1170}\u{11B7}",
        nfkc: "\u{D4C0}",
        nfkd: "\u{1111}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D4C1}",
        nfc: "\u{D4C1}",
        nfd: "\u{1111}\u{1170}\u{11B8}",
        nfkc: "\u{D4C1}",
        nfkd: "\u{1111}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D4C2}",
        nfc: "\u{D4C2}",
        nfd: "\u{1111}\u{1170}\u{11B9}",
        nfkc: "\u{D4C2}",
        nfkd: "\u{1111}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D4C3}",
        nfc: "\u{D4C3}",
        nfd: "\u{1111}\u{1170}\u{11BA}",
        nfkc: "\u{D4C3}",
        nfkd: "\u{1111}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D4C4}",
        nfc: "\u{D4C4}",
        nfd: "\u{1111}\u{1170}\u{11BB}",
        nfkc: "\u{D4C4}",
        nfkd: "\u{1111}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D4C5}",
        nfc: "\u{D4C5}",
        nfd: "\u{1111}\u{1170}\u{11BC}",
        nfkc: "\u{D4C5}",
        nfkd: "\u{1111}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D4C6}",
        nfc: "\u{D4C6}",
        nfd: "\u{1111}\u{1170}\u{11BD}",
        nfkc: "\u{D4C6}",
        nfkd: "\u{1111}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D4C7}",
        nfc: "\u{D4C7}",
        nfd: "\u{1111}\u{1170}\u{11BE}",
        nfkc: "\u{D4C7}",
        nfkd: "\u{1111}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D4C8}",
        nfc: "\u{D4C8}",
        nfd: "\u{1111}\u{1170}\u{11BF}",
        nfkc: "\u{D4C8}",
        nfkd: "\u{1111}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D4C9}",
        nfc: "\u{D4C9}",
        nfd: "\u{1111}\u{1170}\u{11C0}",
        nfkc: "\u{D4C9}",
        nfkd: "\u{1111}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D4CA}",
        nfc: "\u{D4CA}",
        nfd: "\u{1111}\u{1170}\u{11C1}",
        nfkc: "\u{D4CA}",
        nfkd: "\u{1111}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D4CB}",
        nfc: "\u{D4CB}",
        nfd: "\u{1111}\u{1170}\u{11C2}",
        nfkc: "\u{D4CB}",
        nfkd: "\u{1111}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D4CC}",
        nfc: "\u{D4CC}",
        nfd: "\u{1111}\u{1171}",
        nfkc: "\u{D4CC}",
        nfkd: "\u{1111}\u{1171}",
    },
    NormalizationTest {
        source: "\u{D4CD}",
        nfc: "\u{D4CD}",
        nfd: "\u{1111}\u{1171}\u{11A8}",
        nfkc: "\u{D4CD}",
        nfkd: "\u{1111}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D4CE}",
        nfc: "\u{D4CE}",
        nfd: "\u{1111}\u{1171}\u{11A9}",
        nfkc: "\u{D4CE}",
        nfkd: "\u{1111}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D4CF}",
        nfc: "\u{D4CF}",
        nfd: "\u{1111}\u{1171}\u{11AA}",
        nfkc: "\u{D4CF}",
        nfkd: "\u{1111}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D4D0}",
        nfc: "\u{D4D0}",
        nfd: "\u{1111}\u{1171}\u{11AB}",
        nfkc: "\u{D4D0}",
        nfkd: "\u{1111}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D4D1}",
        nfc: "\u{D4D1}",
        nfd: "\u{1111}\u{1171}\u{11AC}",
        nfkc: "\u{D4D1}",
        nfkd: "\u{1111}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D4D2}",
        nfc: "\u{D4D2}",
        nfd: "\u{1111}\u{1171}\u{11AD}",
        nfkc: "\u{D4D2}",
        nfkd: "\u{1111}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D4D3}",
        nfc: "\u{D4D3}",
        nfd: "\u{1111}\u{1171}\u{11AE}",
        nfkc: "\u{D4D3}",
        nfkd: "\u{1111}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D4D4}",
        nfc: "\u{D4D4}",
        nfd: "\u{1111}\u{1171}\u{11AF}",
        nfkc: "\u{D4D4}",
        nfkd: "\u{1111}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D4D5}",
        nfc: "\u{D4D5}",
        nfd: "\u{1111}\u{1171}\u{11B0}",
        nfkc: "\u{D4D5}",
        nfkd: "\u{1111}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D4D6}",
        nfc: "\u{D4D6}",
        nfd: "\u{1111}\u{1171}\u{11B1}",
        nfkc: "\u{D4D6}",
        nfkd: "\u{1111}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D4D7}",
        nfc: "\u{D4D7}",
        nfd: "\u{1111}\u{1171}\u{11B2}",
        nfkc: "\u{D4D7}",
        nfkd: "\u{1111}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D4D8}",
        nfc: "\u{D4D8}",
        nfd: "\u{1111}\u{1171}\u{11B3}",
        nfkc: "\u{D4D8}",
        nfkd: "\u{1111}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D4D9}",
        nfc: "\u{D4D9}",
        nfd: "\u{1111}\u{1171}\u{11B4}",
        nfkc: "\u{D4D9}",
        nfkd: "\u{1111}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D4DA}",
        nfc: "\u{D4DA}",
        nfd: "\u{1111}\u{1171}\u{11B5}",
        nfkc: "\u{D4DA}",
        nfkd: "\u{1111}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D4DB}",
        nfc: "\u{D4DB}",
        nfd: "\u{1111}\u{1171}\u{11B6}",
        nfkc: "\u{D4DB}",
        nfkd: "\u{1111}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D4DC}",
        nfc: "\u{D4DC}",
        nfd: "\u{1111}\u{1171}\u{11B7}",
        nfkc: "\u{D4DC}",
        nfkd: "\u{1111}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D4DD}",
        nfc: "\u{D4DD}",
        nfd: "\u{1111}\u{1171}\u{11B8}",
        nfkc: "\u{D4DD}",
        nfkd: "\u{1111}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D4DE}",
        nfc: "\u{D4DE}",
        nfd: "\u{1111}\u{1171}\u{11B9}",
        nfkc: "\u{D4DE}",
        nfkd: "\u{1111}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D4DF}",
        nfc: "\u{D4DF}",
        nfd: "\u{1111}\u{1171}\u{11BA}",
        nfkc: "\u{D4DF}",
        nfkd: "\u{1111}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D4E0}",
        nfc: "\u{D4E0}",
        nfd: "\u{1111}\u{1171}\u{11BB}",
        nfkc: "\u{D4E0}",
        nfkd: "\u{1111}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D4E1}",
        nfc: "\u{D4E1}",
        nfd: "\u{1111}\u{1171}\u{11BC}",
        nfkc: "\u{D4E1}",
        nfkd: "\u{1111}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D4E2}",
        nfc: "\u{D4E2}",
        nfd: "\u{1111}\u{1171}\u{11BD}",
        nfkc: "\u{D4E2}",
        nfkd: "\u{1111}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D4E3}",
        nfc: "\u{D4E3}",
        nfd: "\u{1111}\u{1171}\u{11BE}",
        nfkc: "\u{D4E3}",
        nfkd: "\u{1111}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D4E4}",
        nfc: "\u{D4E4}",
        nfd: "\u{1111}\u{1171}\u{11BF}",
        nfkc: "\u{D4E4}",
        nfkd: "\u{1111}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D4E5}",
        nfc: "\u{D4E5}",
        nfd: "\u{1111}\u{1171}\u{11C0}",
        nfkc: "\u{D4E5}",
        nfkd: "\u{1111}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D4E6}",
        nfc: "\u{D4E6}",
        nfd: "\u{1111}\u{1171}\u{11C1}",
        nfkc: "\u{D4E6}",
        nfkd: "\u{1111}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D4E7}",
        nfc: "\u{D4E7}",
        nfd: "\u{1111}\u{1171}\u{11C2}",
        nfkc: "\u{D4E7}",
        nfkd: "\u{1111}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D4E8}",
        nfc: "\u{D4E8}",
        nfd: "\u{1111}\u{1172}",
        nfkc: "\u{D4E8}",
        nfkd: "\u{1111}\u{1172}",
    },
    NormalizationTest {
        source: "\u{D4E9}",
        nfc: "\u{D4E9}",
        nfd: "\u{1111}\u{1172}\u{11A8}",
        nfkc: "\u{D4E9}",
        nfkd: "\u{1111}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D4EA}",
        nfc: "\u{D4EA}",
        nfd: "\u{1111}\u{1172}\u{11A9}",
        nfkc: "\u{D4EA}",
        nfkd: "\u{1111}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D4EB}",
        nfc: "\u{D4EB}",
        nfd: "\u{1111}\u{1172}\u{11AA}",
        nfkc: "\u{D4EB}",
        nfkd: "\u{1111}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D4EC}",
        nfc: "\u{D4EC}",
        nfd: "\u{1111}\u{1172}\u{11AB}",
        nfkc: "\u{D4EC}",
        nfkd: "\u{1111}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D4ED}",
        nfc: "\u{D4ED}",
        nfd: "\u{1111}\u{1172}\u{11AC}",
        nfkc: "\u{D4ED}",
        nfkd: "\u{1111}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D4EE}",
        nfc: "\u{D4EE}",
        nfd: "\u{1111}\u{1172}\u{11AD}",
        nfkc: "\u{D4EE}",
        nfkd: "\u{1111}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D4EF}",
        nfc: "\u{D4EF}",
        nfd: "\u{1111}\u{1172}\u{11AE}",
        nfkc: "\u{D4EF}",
        nfkd: "\u{1111}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D4F0}",
        nfc: "\u{D4F0}",
        nfd: "\u{1111}\u{1172}\u{11AF}",
        nfkc: "\u{D4F0}",
        nfkd: "\u{1111}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D4F1}",
        nfc: "\u{D4F1}",
        nfd: "\u{1111}\u{1172}\u{11B0}",
        nfkc: "\u{D4F1}",
        nfkd: "\u{1111}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D4F2}",
        nfc: "\u{D4F2}",
        nfd: "\u{1111}\u{1172}\u{11B1}",
        nfkc: "\u{D4F2}",
        nfkd: "\u{1111}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D4F3}",
        nfc: "\u{D4F3}",
        nfd: "\u{1111}\u{1172}\u{11B2}",
        nfkc: "\u{D4F3}",
        nfkd: "\u{1111}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D4F4}",
        nfc: "\u{D4F4}",
        nfd: "\u{1111}\u{1172}\u{11B3}",
        nfkc: "\u{D4F4}",
        nfkd: "\u{1111}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D4F5}",
        nfc: "\u{D4F5}",
        nfd: "\u{1111}\u{1172}\u{11B4}",
        nfkc: "\u{D4F5}",
        nfkd: "\u{1111}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D4F6}",
        nfc: "\u{D4F6}",
        nfd: "\u{1111}\u{1172}\u{11B5}",
        nfkc: "\u{D4F6}",
        nfkd: "\u{1111}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D4F7}",
        nfc: "\u{D4F7}",
        nfd: "\u{1111}\u{1172}\u{11B6}",
        nfkc: "\u{D4F7}",
        nfkd: "\u{1111}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D4F8}",
        nfc: "\u{D4F8}",
        nfd: "\u{1111}\u{1172}\u{11B7}",
        nfkc: "\u{D4F8}",
        nfkd: "\u{1111}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D4F9}",
        nfc: "\u{D4F9}",
        nfd: "\u{1111}\u{1172}\u{11B8}",
        nfkc: "\u{D4F9}",
        nfkd: "\u{1111}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D4FA}",
        nfc: "\u{D4FA}",
        nfd: "\u{1111}\u{1172}\u{11B9}",
        nfkc: "\u{D4FA}",
        nfkd: "\u{1111}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D4FB}",
        nfc: "\u{D4FB}",
        nfd: "\u{1111}\u{1172}\u{11BA}",
        nfkc: "\u{D4FB}",
        nfkd: "\u{1111}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D4FC}",
        nfc: "\u{D4FC}",
        nfd: "\u{1111}\u{1172}\u{11BB}",
        nfkc: "\u{D4FC}",
        nfkd: "\u{1111}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D4FD}",
        nfc: "\u{D4FD}",
        nfd: "\u{1111}\u{1172}\u{11BC}",
        nfkc: "\u{D4FD}",
        nfkd: "\u{1111}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D4FE}",
        nfc: "\u{D4FE}",
        nfd: "\u{1111}\u{1172}\u{11BD}",
        nfkc: "\u{D4FE}",
        nfkd: "\u{1111}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D4FF}",
        nfc: "\u{D4FF}",
        nfd: "\u{1111}\u{1172}\u{11BE}",
        nfkc: "\u{D4FF}",
        nfkd: "\u{1111}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D500}",
        nfc: "\u{D500}",
        nfd: "\u{1111}\u{1172}\u{11BF}",
        nfkc: "\u{D500}",
        nfkd: "\u{1111}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D501}",
        nfc: "\u{D501}",
        nfd: "\u{1111}\u{1172}\u{11C0}",
        nfkc: "\u{D501}",
        nfkd: "\u{1111}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D502}",
        nfc: "\u{D502}",
        nfd: "\u{1111}\u{1172}\u{11C1}",
        nfkc: "\u{D502}",
        nfkd: "\u{1111}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D503}",
        nfc: "\u{D503}",
        nfd: "\u{1111}\u{1172}\u{11C2}",
        nfkc: "\u{D503}",
        nfkd: "\u{1111}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D504}",
        nfc: "\u{D504}",
        nfd: "\u{1111}\u{1173}",
        nfkc: "\u{D504}",
        nfkd: "\u{1111}\u{1173}",
    },
    NormalizationTest {
        source: "\u{D505}",
        nfc: "\u{D505}",
        nfd: "\u{1111}\u{1173}\u{11A8}",
        nfkc: "\u{D505}",
        nfkd: "\u{1111}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D506}",
        nfc: "\u{D506}",
        nfd: "\u{1111}\u{1173}\u{11A9}",
        nfkc: "\u{D506}",
        nfkd: "\u{1111}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D507}",
        nfc: "\u{D507}",
        nfd: "\u{1111}\u{1173}\u{11AA}",
        nfkc: "\u{D507}",
        nfkd: "\u{1111}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D508}",
        nfc: "\u{D508}",
        nfd: "\u{1111}\u{1173}\u{11AB}",
        nfkc: "\u{D508}",
        nfkd: "\u{1111}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D509}",
        nfc: "\u{D509}",
        nfd: "\u{1111}\u{1173}\u{11AC}",
        nfkc: "\u{D509}",
        nfkd: "\u{1111}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D50A}",
        nfc: "\u{D50A}",
        nfd: "\u{1111}\u{1173}\u{11AD}",
        nfkc: "\u{D50A}",
        nfkd: "\u{1111}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D50B}",
        nfc: "\u{D50B}",
        nfd: "\u{1111}\u{1173}\u{11AE}",
        nfkc: "\u{D50B}",
        nfkd: "\u{1111}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D50C}",
        nfc: "\u{D50C}",
        nfd: "\u{1111}\u{1173}\u{11AF}",
        nfkc: "\u{D50C}",
        nfkd: "\u{1111}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D50D}",
        nfc: "\u{D50D}",
        nfd: "\u{1111}\u{1173}\u{11B0}",
        nfkc: "\u{D50D}",
        nfkd: "\u{1111}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D50E}",
        nfc: "\u{D50E}",
        nfd: "\u{1111}\u{1173}\u{11B1}",
        nfkc: "\u{D50E}",
        nfkd: "\u{1111}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D50F}",
        nfc: "\u{D50F}",
        nfd: "\u{1111}\u{1173}\u{11B2}",
        nfkc: "\u{D50F}",
        nfkd: "\u{1111}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D510}",
        nfc: "\u{D510}",
        nfd: "\u{1111}\u{1173}\u{11B3}",
        nfkc: "\u{D510}",
        nfkd: "\u{1111}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D511}",
        nfc: "\u{D511}",
        nfd: "\u{1111}\u{1173}\u{11B4}",
        nfkc: "\u{D511}",
        nfkd: "\u{1111}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D512}",
        nfc: "\u{D512}",
        nfd: "\u{1111}\u{1173}\u{11B5}",
        nfkc: "\u{D512}",
        nfkd: "\u{1111}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D513}",
        nfc: "\u{D513}",
        nfd: "\u{1111}\u{1173}\u{11B6}",
        nfkc: "\u{D513}",
        nfkd: "\u{1111}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D514}",
        nfc: "\u{D514}",
        nfd: "\u{1111}\u{1173}\u{11B7}",
        nfkc: "\u{D514}",
        nfkd: "\u{1111}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D515}",
        nfc: "\u{D515}",
        nfd: "\u{1111}\u{1173}\u{11B8}",
        nfkc: "\u{D515}",
        nfkd: "\u{1111}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D516}",
        nfc: "\u{D516}",
        nfd: "\u{1111}\u{1173}\u{11B9}",
        nfkc: "\u{D516}",
        nfkd: "\u{1111}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D517}",
        nfc: "\u{D517}",
        nfd: "\u{1111}\u{1173}\u{11BA}",
        nfkc: "\u{D517}",
        nfkd: "\u{1111}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D518}",
        nfc: "\u{D518}",
        nfd: "\u{1111}\u{1173}\u{11BB}",
        nfkc: "\u{D518}",
        nfkd: "\u{1111}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D519}",
        nfc: "\u{D519}",
        nfd: "\u{1111}\u{1173}\u{11BC}",
        nfkc: "\u{D519}",
        nfkd: "\u{1111}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D51A}",
        nfc: "\u{D51A}",
        nfd: "\u{1111}\u{1173}\u{11BD}",
        nfkc: "\u{D51A}",
        nfkd: "\u{1111}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D51B}",
        nfc: "\u{D51B}",
        nfd: "\u{1111}\u{1173}\u{11BE}",
        nfkc: "\u{D51B}",
        nfkd: "\u{1111}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D51C}",
        nfc: "\u{D51C}",
        nfd: "\u{1111}\u{1173}\u{11BF}",
        nfkc: "\u{D51C}",
        nfkd: "\u{1111}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D51D}",
        nfc: "\u{D51D}",
        nfd: "\u{1111}\u{1173}\u{11C0}",
        nfkc: "\u{D51D}",
        nfkd: "\u{1111}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D51E}",
        nfc: "\u{D51E}",
        nfd: "\u{1111}\u{1173}\u{11C1}",
        nfkc: "\u{D51E}",
        nfkd: "\u{1111}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D51F}",
        nfc: "\u{D51F}",
        nfd: "\u{1111}\u{1173}\u{11C2}",
        nfkc: "\u{D51F}",
        nfkd: "\u{1111}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D520}",
        nfc: "\u{D520}",
        nfd: "\u{1111}\u{1174}",
        nfkc: "\u{D520}",
        nfkd: "\u{1111}\u{1174}",
    },
    NormalizationTest {
        source: "\u{D521}",
        nfc: "\u{D521}",
        nfd: "\u{1111}\u{1174}\u{11A8}",
        nfkc: "\u{D521}",
        nfkd: "\u{1111}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D522}",
        nfc: "\u{D522}",
        nfd: "\u{1111}\u{1174}\u{11A9}",
        nfkc: "\u{D522}",
        nfkd: "\u{1111}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D523}",
        nfc: "\u{D523}",
        nfd: "\u{1111}\u{1174}\u{11AA}",
        nfkc: "\u{D523}",
        nfkd: "\u{1111}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D524}",
        nfc: "\u{D524}",
        nfd: "\u{1111}\u{1174}\u{11AB}",
        nfkc: "\u{D524}",
        nfkd: "\u{1111}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D525}",
        nfc: "\u{D525}",
        nfd: "\u{1111}\u{1174}\u{11AC}",
        nfkc: "\u{D525}",
        nfkd: "\u{1111}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D526}",
        nfc: "\u{D526}",
        nfd: "\u{1111}\u{1174}\u{11AD}",
        nfkc: "\u{D526}",
        nfkd: "\u{1111}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D527}",
        nfc: "\u{D527}",
        nfd: "\u{1111}\u{1174}\u{11AE}",
        nfkc: "\u{D527}",
        nfkd: "\u{1111}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D528}",
        nfc: "\u{D528}",
        nfd: "\u{1111}\u{1174}\u{11AF}",
        nfkc: "\u{D528}",
        nfkd: "\u{1111}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D529}",
        nfc: "\u{D529}",
        nfd: "\u{1111}\u{1174}\u{11B0}",
        nfkc: "\u{D529}",
        nfkd: "\u{1111}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D52A}",
        nfc: "\u{D52A}",
        nfd: "\u{1111}\u{1174}\u{11B1}",
        nfkc: "\u{D52A}",
        nfkd: "\u{1111}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D52B}",
        nfc: "\u{D52B}",
        nfd: "\u{1111}\u{1174}\u{11B2}",
        nfkc: "\u{D52B}",
        nfkd: "\u{1111}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D52C}",
        nfc: "\u{D52C}",
        nfd: "\u{1111}\u{1174}\u{11B3}",
        nfkc: "\u{D52C}",
        nfkd: "\u{1111}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D52D}",
        nfc: "\u{D52D}",
        nfd: "\u{1111}\u{1174}\u{11B4}",
        nfkc: "\u{D52D}",
        nfkd: "\u{1111}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D52E}",
        nfc: "\u{D52E}",
        nfd: "\u{1111}\u{1174}\u{11B5}",
        nfkc: "\u{D52E}",
        nfkd: "\u{1111}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D52F}",
        nfc: "\u{D52F}",
        nfd: "\u{1111}\u{1174}\u{11B6}",
        nfkc: "\u{D52F}",
        nfkd: "\u{1111}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D530}",
        nfc: "\u{D530}",
        nfd: "\u{1111}\u{1174}\u{11B7}",
        nfkc: "\u{D530}",
        nfkd: "\u{1111}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D531}",
        nfc: "\u{D531}",
        nfd: "\u{1111}\u{1174}\u{11B8}",
        nfkc: "\u{D531}",
        nfkd: "\u{1111}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D532}",
        nfc: "\u{D532}",
        nfd: "\u{1111}\u{1174}\u{11B9}",
        nfkc: "\u{D532}",
        nfkd: "\u{1111}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D533}",
        nfc: "\u{D533}",
        nfd: "\u{1111}\u{1174}\u{11BA}",
        nfkc: "\u{D533}",
        nfkd: "\u{1111}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D534}",
        nfc: "\u{D534}",
        nfd: "\u{1111}\u{1174}\u{11BB}",
        nfkc: "\u{D534}",
        nfkd: "\u{1111}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D535}",
        nfc: "\u{D535}",
        nfd: "\u{1111}\u{1174}\u{11BC}",
        nfkc: "\u{D535}",
        nfkd: "\u{1111}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D536}",
        nfc: "\u{D536}",
        nfd: "\u{1111}\u{1174}\u{11BD}",
        nfkc: "\u{D536}",
        nfkd: "\u{1111}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D537}",
        nfc: "\u{D537}",
        nfd: "\u{1111}\u{1174}\u{11BE}",
        nfkc: "\u{D537}",
        nfkd: "\u{1111}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D538}",
        nfc: "\u{D538}",
        nfd: "\u{1111}\u{1174}\u{11BF}",
        nfkc: "\u{D538}",
        nfkd: "\u{1111}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D539}",
        nfc: "\u{D539}",
        nfd: "\u{1111}\u{1174}\u{11C0}",
        nfkc: "\u{D539}",
        nfkd: "\u{1111}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D53A}",
        nfc: "\u{D53A}",
        nfd: "\u{1111}\u{1174}\u{11C1}",
        nfkc: "\u{D53A}",
        nfkd: "\u{1111}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D53B}",
        nfc: "\u{D53B}",
        nfd: "\u{1111}\u{1174}\u{11C2}",
        nfkc: "\u{D53B}",
        nfkd: "\u{1111}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D53C}",
        nfc: "\u{D53C}",
        nfd: "\u{1111}\u{1175}",
        nfkc: "\u{D53C}",
        nfkd: "\u{1111}\u{1175}",
    },
    NormalizationTest {
        source: "\u{D53D}",
        nfc: "\u{D53D}",
        nfd: "\u{1111}\u{1175}\u{11A8}",
        nfkc: "\u{D53D}",
        nfkd: "\u{1111}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D53E}",
        nfc: "\u{D53E}",
        nfd: "\u{1111}\u{1175}\u{11A9}",
        nfkc: "\u{D53E}",
        nfkd: "\u{1111}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D53F}",
        nfc: "\u{D53F}",
        nfd: "\u{1111}\u{1175}\u{11AA}",
        nfkc: "\u{D53F}",
        nfkd: "\u{1111}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D540}",
        nfc: "\u{D540}",
        nfd: "\u{1111}\u{1175}\u{11AB}",
        nfkc: "\u{D540}",
        nfkd: "\u{1111}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D541}",
        nfc: "\u{D541}",
        nfd: "\u{1111}\u{1175}\u{11AC}",
        nfkc: "\u{D541}",
        nfkd: "\u{1111}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D542}",
        nfc: "\u{D542}",
        nfd: "\u{1111}\u{1175}\u{11AD}",
        nfkc: "\u{D542}",
        nfkd: "\u{1111}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D543}",
        nfc: "\u{D543}",
        nfd: "\u{1111}\u{1175}\u{11AE}",
        nfkc: "\u{D543}",
        nfkd: "\u{1111}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D544}",
        nfc: "\u{D544}",
        nfd: "\u{1111}\u{1175}\u{11AF}",
        nfkc: "\u{D544}",
        nfkd: "\u{1111}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D545}",
        nfc: "\u{D545}",
        nfd: "\u{1111}\u{1175}\u{11B0}",
        nfkc: "\u{D545}",
        nfkd: "\u{1111}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D546}",
        nfc: "\u{D546}",
        nfd: "\u{1111}\u{1175}\u{11B1}",
        nfkc: "\u{D546}",
        nfkd: "\u{1111}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D547}",
        nfc: "\u{D547}",
        nfd: "\u{1111}\u{1175}\u{11B2}",
        nfkc: "\u{D547}",
        nfkd: "\u{1111}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D548}",
        nfc: "\u{D548}",
        nfd: "\u{1111}\u{1175}\u{11B3}",
        nfkc: "\u{D548}",
        nfkd: "\u{1111}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D549}",
        nfc: "\u{D549}",
        nfd: "\u{1111}\u{1175}\u{11B4}",
        nfkc: "\u{D549}",
        nfkd: "\u{1111}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D54A}",
        nfc: "\u{D54A}",
        nfd: "\u{1111}\u{1175}\u{11B5}",
        nfkc: "\u{D54A}",
        nfkd: "\u{1111}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D54B}",
        nfc: "\u{D54B}",
        nfd: "\u{1111}\u{1175}\u{11B6}",
        nfkc: "\u{D54B}",
        nfkd: "\u{1111}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D54C}",
        nfc: "\u{D54C}",
        nfd: "\u{1111}\u{1175}\u{11B7}",
        nfkc: "\u{D54C}",
        nfkd: "\u{1111}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D54D}",
        nfc: "\u{D54D}",
        nfd: "\u{1111}\u{1175}\u{11B8}",
        nfkc: "\u{D54D}",
        nfkd: "\u{1111}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D54E}",
        nfc: "\u{D54E}",
        nfd: "\u{1111}\u{1175}\u{11B9}",
        nfkc: "\u{D54E}",
        nfkd: "\u{1111}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D54F}",
        nfc: "\u{D54F}",
        nfd: "\u{1111}\u{1175}\u{11BA}",
        nfkc: "\u{D54F}",
        nfkd: "\u{1111}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D550}",
        nfc: "\u{D550}",
        nfd: "\u{1111}\u{1175}\u{11BB}",
        nfkc: "\u{D550}",
        nfkd: "\u{1111}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D551}",
        nfc: "\u{D551}",
        nfd: "\u{1111}\u{1175}\u{11BC}",
        nfkc: "\u{D551}",
        nfkd: "\u{1111}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D552}",
        nfc: "\u{D552}",
        nfd: "\u{1111}\u{1175}\u{11BD}",
        nfkc: "\u{D552}",
        nfkd: "\u{1111}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D553}",
        nfc: "\u{D553}",
        nfd: "\u{1111}\u{1175}\u{11BE}",
        nfkc: "\u{D553}",
        nfkd: "\u{1111}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D554}",
        nfc: "\u{D554}",
        nfd: "\u{1111}\u{1175}\u{11BF}",
        nfkc: "\u{D554}",
        nfkd: "\u{1111}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D555}",
        nfc: "\u{D555}",
        nfd: "\u{1111}\u{1175}\u{11C0}",
        nfkc: "\u{D555}",
        nfkd: "\u{1111}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D556}",
        nfc: "\u{D556}",
        nfd: "\u{1111}\u{1175}\u{11C1}",
        nfkc: "\u{D556}",
        nfkd: "\u{1111}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D557}",
        nfc: "\u{D557}",
        nfd: "\u{1111}\u{1175}\u{11C2}",
        nfkc: "\u{D557}",
        nfkd: "\u{1111}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D558}",
        nfc: "\u{D558}",
        nfd: "\u{1112}\u{1161}",
        nfkc: "\u{D558}",
        nfkd: "\u{1112}\u{1161}",
    },
    NormalizationTest {
        source: "\u{D559}",
        nfc: "\u{D559}",
        nfd: "\u{1112}\u{1161}\u{11A8}",
        nfkc: "\u{D559}",
        nfkd: "\u{1112}\u{1161}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D55A}",
        nfc: "\u{D55A}",
        nfd: "\u{1112}\u{1161}\u{11A9}",
        nfkc: "\u{D55A}",
        nfkd: "\u{1112}\u{1161}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D55B}",
        nfc: "\u{D55B}",
        nfd: "\u{1112}\u{1161}\u{11AA}",
        nfkc: "\u{D55B}",
        nfkd: "\u{1112}\u{1161}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D55C}",
        nfc: "\u{D55C}",
        nfd: "\u{1112}\u{1161}\u{11AB}",
        nfkc: "\u{D55C}",
        nfkd: "\u{1112}\u{1161}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D55D}",
        nfc: "\u{D55D}",
        nfd: "\u{1112}\u{1161}\u{11AC}",
        nfkc: "\u{D55D}",
        nfkd: "\u{1112}\u{1161}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D55E}",
        nfc: "\u{D55E}",
        nfd: "\u{1112}\u{1161}\u{11AD}",
        nfkc: "\u{D55E}",
        nfkd: "\u{1112}\u{1161}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D55F}",
        nfc: "\u{D55F}",
        nfd: "\u{1112}\u{1161}\u{11AE}",
        nfkc: "\u{D55F}",
        nfkd: "\u{1112}\u{1161}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D560}",
        nfc: "\u{D560}",
        nfd: "\u{1112}\u{1161}\u{11AF}",
        nfkc: "\u{D560}",
        nfkd: "\u{1112}\u{1161}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D561}",
        nfc: "\u{D561}",
        nfd: "\u{1112}\u{1161}\u{11B0}",
        nfkc: "\u{D561}",
        nfkd: "\u{1112}\u{1161}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D562}",
        nfc: "\u{D562}",
        nfd: "\u{1112}\u{1161}\u{11B1}",
        nfkc: "\u{D562}",
        nfkd: "\u{1112}\u{1161}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D563}",
        nfc: "\u{D563}",
        nfd: "\u{1112}\u{1161}\u{11B2}",
        nfkc: "\u{D563}",
        nfkd: "\u{1112}\u{1161}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D564}",
        nfc: "\u{D564}",
        nfd: "\u{1112}\u{1161}\u{11B3}",
        nfkc: "\u{D564}",
        nfkd: "\u{1112}\u{1161}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D565}",
        nfc: "\u{D565}",
        nfd: "\u{1112}\u{1161}\u{11B4}",
        nfkc: "\u{D565}",
        nfkd: "\u{1112}\u{1161}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D566}",
        nfc: "\u{D566}",
        nfd: "\u{1112}\u{1161}\u{11B5}",
        nfkc: "\u{D566}",
        nfkd: "\u{1112}\u{1161}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D567}",
        nfc: "\u{D567}",
        nfd: "\u{1112}\u{1161}\u{11B6}",
        nfkc: "\u{D567}",
        nfkd: "\u{1112}\u{1161}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D568}",
        nfc: "\u{D568}",
        nfd: "\u{1112}\u{1161}\u{11B7}",
        nfkc: "\u{D568}",
        nfkd: "\u{1112}\u{1161}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D569}",
        nfc: "\u{D569}",
        nfd: "\u{1112}\u{1161}\u{11B8}",
        nfkc: "\u{D569}",
        nfkd: "\u{1112}\u{1161}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D56A}",
        nfc: "\u{D56A}",
        nfd: "\u{1112}\u{1161}\u{11B9}",
        nfkc: "\u{D56A}",
        nfkd: "\u{1112}\u{1161}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D56B}",
        nfc: "\u{D56B}",
        nfd: "\u{1112}\u{1161}\u{11BA}",
        nfkc: "\u{D56B}",
        nfkd: "\u{1112}\u{1161}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D56C}",
        nfc: "\u{D56C}",
        nfd: "\u{1112}\u{1161}\u{11BB}",
        nfkc: "\u{D56C}",
        nfkd: "\u{1112}\u{1161}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D56D}",
        nfc: "\u{D56D}",
        nfd: "\u{1112}\u{1161}\u{11BC}",
        nfkc: "\u{D56D}",
        nfkd: "\u{1112}\u{1161}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D56E}",
        nfc: "\u{D56E}",
        nfd: "\u{1112}\u{1161}\u{11BD}",
        nfkc: "\u{D56E}",
        nfkd: "\u{1112}\u{1161}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D56F}",
        nfc: "\u{D56F}",
        nfd: "\u{1112}\u{1161}\u{11BE}",
        nfkc: "\u{D56F}",
        nfkd: "\u{1112}\u{1161}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D570}",
        nfc: "\u{D570}",
        nfd: "\u{1112}\u{1161}\u{11BF}",
        nfkc: "\u{D570}",
        nfkd: "\u{1112}\u{1161}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D571}",
        nfc: "\u{D571}",
        nfd: "\u{1112}\u{1161}\u{11C0}",
        nfkc: "\u{D571}",
        nfkd: "\u{1112}\u{1161}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D572}",
        nfc: "\u{D572}",
        nfd: "\u{1112}\u{1161}\u{11C1}",
        nfkc: "\u{D572}",
        nfkd: "\u{1112}\u{1161}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D573}",
        nfc: "\u{D573}",
        nfd: "\u{1112}\u{1161}\u{11C2}",
        nfkc: "\u{D573}",
        nfkd: "\u{1112}\u{1161}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D574}",
        nfc: "\u{D574}",
        nfd: "\u{1112}\u{1162}",
        nfkc: "\u{D574}",
        nfkd: "\u{1112}\u{1162}",
    },
    NormalizationTest {
        source: "\u{D575}",
        nfc: "\u{D575}",
        nfd: "\u{1112}\u{1162}\u{11A8}",
        nfkc: "\u{D575}",
        nfkd: "\u{1112}\u{1162}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D576}",
        nfc: "\u{D576}",
        nfd: "\u{1112}\u{1162}\u{11A9}",
        nfkc: "\u{D576}",
        nfkd: "\u{1112}\u{1162}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D577}",
        nfc: "\u{D577}",
        nfd: "\u{1112}\u{1162}\u{11AA}",
        nfkc: "\u{D577}",
        nfkd: "\u{1112}\u{1162}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D578}",
        nfc: "\u{D578}",
        nfd: "\u{1112}\u{1162}\u{11AB}",
        nfkc: "\u{D578}",
        nfkd: "\u{1112}\u{1162}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D579}",
        nfc: "\u{D579}",
        nfd: "\u{1112}\u{1162}\u{11AC}",
        nfkc: "\u{D579}",
        nfkd: "\u{1112}\u{1162}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D57A}",
        nfc: "\u{D57A}",
        nfd: "\u{1112}\u{1162}\u{11AD}",
        nfkc: "\u{D57A}",
        nfkd: "\u{1112}\u{1162}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D57B}",
        nfc: "\u{D57B}",
        nfd: "\u{1112}\u{1162}\u{11AE}",
        nfkc: "\u{D57B}",
        nfkd: "\u{1112}\u{1162}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D57C}",
        nfc: "\u{D57C}",
        nfd: "\u{1112}\u{1162}\u{11AF}",
        nfkc: "\u{D57C}",
        nfkd: "\u{1112}\u{1162}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D57D}",
        nfc: "\u{D57D}",
        nfd: "\u{1112}\u{1162}\u{11B0}",
        nfkc: "\u{D57D}",
        nfkd: "\u{1112}\u{1162}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D57E}",
        nfc: "\u{D57E}",
        nfd: "\u{1112}\u{1162}\u{11B1}",
        nfkc: "\u{D57E}",
        nfkd: "\u{1112}\u{1162}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D57F}",
        nfc: "\u{D57F}",
        nfd: "\u{1112}\u{1162}\u{11B2}",
        nfkc: "\u{D57F}",
        nfkd: "\u{1112}\u{1162}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D580}",
        nfc: "\u{D580}",
        nfd: "\u{1112}\u{1162}\u{11B3}",
        nfkc: "\u{D580}",
        nfkd: "\u{1112}\u{1162}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D581}",
        nfc: "\u{D581}",
        nfd: "\u{1112}\u{1162}\u{11B4}",
        nfkc: "\u{D581}",
        nfkd: "\u{1112}\u{1162}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D582}",
        nfc: "\u{D582}",
        nfd: "\u{1112}\u{1162}\u{11B5}",
        nfkc: "\u{D582}",
        nfkd: "\u{1112}\u{1162}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D583}",
        nfc: "\u{D583}",
        nfd: "\u{1112}\u{1162}\u{11B6}",
        nfkc: "\u{D583}",
        nfkd: "\u{1112}\u{1162}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D584}",
        nfc: "\u{D584}",
        nfd: "\u{1112}\u{1162}\u{11B7}",
        nfkc: "\u{D584}",
        nfkd: "\u{1112}\u{1162}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D585}",
        nfc: "\u{D585}",
        nfd: "\u{1112}\u{1162}\u{11B8}",
        nfkc: "\u{D585}",
        nfkd: "\u{1112}\u{1162}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D586}",
        nfc: "\u{D586}",
        nfd: "\u{1112}\u{1162}\u{11B9}",
        nfkc: "\u{D586}",
        nfkd: "\u{1112}\u{1162}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D587}",
        nfc: "\u{D587}",
        nfd: "\u{1112}\u{1162}\u{11BA}",
        nfkc: "\u{D587}",
        nfkd: "\u{1112}\u{1162}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D588}",
        nfc: "\u{D588}",
        nfd: "\u{1112}\u{1162}\u{11BB}",
        nfkc: "\u{D588}",
        nfkd: "\u{1112}\u{1162}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D589}",
        nfc: "\u{D589}",
        nfd: "\u{1112}\u{1162}\u{11BC}",
        nfkc: "\u{D589}",
        nfkd: "\u{1112}\u{1162}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D58A}",
        nfc: "\u{D58A}",
        nfd: "\u{1112}\u{1162}\u{11BD}",
        nfkc: "\u{D58A}",
        nfkd: "\u{1112}\u{1162}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D58B}",
        nfc: "\u{D58B}",
        nfd: "\u{1112}\u{1162}\u{11BE}",
        nfkc: "\u{D58B}",
        nfkd: "\u{1112}\u{1162}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D58C}",
        nfc: "\u{D58C}",
        nfd: "\u{1112}\u{1162}\u{11BF}",
        nfkc: "\u{D58C}",
        nfkd: "\u{1112}\u{1162}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D58D}",
        nfc: "\u{D58D}",
        nfd: "\u{1112}\u{1162}\u{11C0}",
        nfkc: "\u{D58D}",
        nfkd: "\u{1112}\u{1162}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D58E}",
        nfc: "\u{D58E}",
        nfd: "\u{1112}\u{1162}\u{11C1}",
        nfkc: "\u{D58E}",
        nfkd: "\u{1112}\u{1162}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D58F}",
        nfc: "\u{D58F}",
        nfd: "\u{1112}\u{1162}\u{11C2}",
        nfkc: "\u{D58F}",
        nfkd: "\u{1112}\u{1162}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D590}",
        nfc: "\u{D590}",
        nfd: "\u{1112}\u{1163}",
        nfkc: "\u{D590}",
        nfkd: "\u{1112}\u{1163}",
    },
    NormalizationTest {
        source: "\u{D591}",
        nfc: "\u{D591}",
        nfd: "\u{1112}\u{1163}\u{11A8}",
        nfkc: "\u{D591}",
        nfkd: "\u{1112}\u{1163}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D592}",
        nfc: "\u{D592}",
        nfd: "\u{1112}\u{1163}\u{11A9}",
        nfkc: "\u{D592}",
        nfkd: "\u{1112}\u{1163}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D593}",
        nfc: "\u{D593}",
        nfd: "\u{1112}\u{1163}\u{11AA}",
        nfkc: "\u{D593}",
        nfkd: "\u{1112}\u{1163}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D594}",
        nfc: "\u{D594}",
        nfd: "\u{1112}\u{1163}\u{11AB}",
        nfkc: "\u{D594}",
        nfkd: "\u{1112}\u{1163}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D595}",
        nfc: "\u{D595}",
        nfd: "\u{1112}\u{1163}\u{11AC}",
        nfkc: "\u{D595}",
        nfkd: "\u{1112}\u{1163}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D596}",
        nfc: "\u{D596}",
        nfd: "\u{1112}\u{1163}\u{11AD}",
        nfkc: "\u{D596}",
        nfkd: "\u{1112}\u{1163}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D597}",
        nfc: "\u{D597}",
        nfd: "\u{1112}\u{1163}\u{11AE}",
        nfkc: "\u{D597}",
        nfkd: "\u{1112}\u{1163}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D598}",
        nfc: "\u{D598}",
        nfd: "\u{1112}\u{1163}\u{11AF}",
        nfkc: "\u{D598}",
        nfkd: "\u{1112}\u{1163}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D599}",
        nfc: "\u{D599}",
        nfd: "\u{1112}\u{1163}\u{11B0}",
        nfkc: "\u{D599}",
        nfkd: "\u{1112}\u{1163}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D59A}",
        nfc: "\u{D59A}",
        nfd: "\u{1112}\u{1163}\u{11B1}",
        nfkc: "\u{D59A}",
        nfkd: "\u{1112}\u{1163}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D59B}",
        nfc: "\u{D59B}",
        nfd: "\u{1112}\u{1163}\u{11B2}",
        nfkc: "\u{D59B}",
        nfkd: "\u{1112}\u{1163}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D59C}",
        nfc: "\u{D59C}",
        nfd: "\u{1112}\u{1163}\u{11B3}",
        nfkc: "\u{D59C}",
        nfkd: "\u{1112}\u{1163}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D59D}",
        nfc: "\u{D59D}",
        nfd: "\u{1112}\u{1163}\u{11B4}",
        nfkc: "\u{D59D}",
        nfkd: "\u{1112}\u{1163}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D59E}",
        nfc: "\u{D59E}",
        nfd: "\u{1112}\u{1163}\u{11B5}",
        nfkc: "\u{D59E}",
        nfkd: "\u{1112}\u{1163}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D59F}",
        nfc: "\u{D59F}",
        nfd: "\u{1112}\u{1163}\u{11B6}",
        nfkc: "\u{D59F}",
        nfkd: "\u{1112}\u{1163}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D5A0}",
        nfc: "\u{D5A0}",
        nfd: "\u{1112}\u{1163}\u{11B7}",
        nfkc: "\u{D5A0}",
        nfkd: "\u{1112}\u{1163}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D5A1}",
        nfc: "\u{D5A1}",
        nfd: "\u{1112}\u{1163}\u{11B8}",
        nfkc: "\u{D5A1}",
        nfkd: "\u{1112}\u{1163}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D5A2}",
        nfc: "\u{D5A2}",
        nfd: "\u{1112}\u{1163}\u{11B9}",
        nfkc: "\u{D5A2}",
        nfkd: "\u{1112}\u{1163}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D5A3}",
        nfc: "\u{D5A3}",
        nfd: "\u{1112}\u{1163}\u{11BA}",
        nfkc: "\u{D5A3}",
        nfkd: "\u{1112}\u{1163}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D5A4}",
        nfc: "\u{D5A4}",
        nfd: "\u{1112}\u{1163}\u{11BB}",
        nfkc: "\u{D5A4}",
        nfkd: "\u{1112}\u{1163}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D5A5}",
        nfc: "\u{D5A5}",
        nfd: "\u{1112}\u{1163}\u{11BC}",
        nfkc: "\u{D5A5}",
        nfkd: "\u{1112}\u{1163}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D5A6}",
        nfc: "\u{D5A6}",
        nfd: "\u{1112}\u{1163}\u{11BD}",
        nfkc: "\u{D5A6}",
        nfkd: "\u{1112}\u{1163}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D5A7}",
        nfc: "\u{D5A7}",
        nfd: "\u{1112}\u{1163}\u{11BE}",
        nfkc: "\u{D5A7}",
        nfkd: "\u{1112}\u{1163}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D5A8}",
        nfc: "\u{D5A8}",
        nfd: "\u{1112}\u{1163}\u{11BF}",
        nfkc: "\u{D5A8}",
        nfkd: "\u{1112}\u{1163}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D5A9}",
        nfc: "\u{D5A9}",
        nfd: "\u{1112}\u{1163}\u{11C0}",
        nfkc: "\u{D5A9}",
        nfkd: "\u{1112}\u{1163}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D5AA}",
        nfc: "\u{D5AA}",
        nfd: "\u{1112}\u{1163}\u{11C1}",
        nfkc: "\u{D5AA}",
        nfkd: "\u{1112}\u{1163}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D5AB}",
        nfc: "\u{D5AB}",
        nfd: "\u{1112}\u{1163}\u{11C2}",
        nfkc: "\u{D5AB}",
        nfkd: "\u{1112}\u{1163}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D5AC}",
        nfc: "\u{D5AC}",
        nfd: "\u{1112}\u{1164}",
        nfkc: "\u{D5AC}",
        nfkd: "\u{1112}\u{1164}",
    },
    NormalizationTest {
        source: "\u{D5AD}",
        nfc: "\u{D5AD}",
        nfd: "\u{1112}\u{1164}\u{11A8}",
        nfkc: "\u{D5AD}",
        nfkd: "\u{1112}\u{1164}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D5AE}",
        nfc: "\u{D5AE}",
        nfd: "\u{1112}\u{1164}\u{11A9}",
        nfkc: "\u{D5AE}",
        nfkd: "\u{1112}\u{1164}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D5AF}",
        nfc: "\u{D5AF}",
        nfd: "\u{1112}\u{1164}\u{11AA}",
        nfkc: "\u{D5AF}",
        nfkd: "\u{1112}\u{1164}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D5B0}",
        nfc: "\u{D5B0}",
        nfd: "\u{1112}\u{1164}\u{11AB}",
        nfkc: "\u{D5B0}",
        nfkd: "\u{1112}\u{1164}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D5B1}",
        nfc: "\u{D5B1}",
        nfd: "\u{1112}\u{1164}\u{11AC}",
        nfkc: "\u{D5B1}",
        nfkd: "\u{1112}\u{1164}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D5B2}",
        nfc: "\u{D5B2}",
        nfd: "\u{1112}\u{1164}\u{11AD}",
        nfkc: "\u{D5B2}",
        nfkd: "\u{1112}\u{1164}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D5B3}",
        nfc: "\u{D5B3}",
        nfd: "\u{1112}\u{1164}\u{11AE}",
        nfkc: "\u{D5B3}",
        nfkd: "\u{1112}\u{1164}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D5B4}",
        nfc: "\u{D5B4}",
        nfd: "\u{1112}\u{1164}\u{11AF}",
        nfkc: "\u{D5B4}",
        nfkd: "\u{1112}\u{1164}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D5B5}",
        nfc: "\u{D5B5}",
        nfd: "\u{1112}\u{1164}\u{11B0}",
        nfkc: "\u{D5B5}",
        nfkd: "\u{1112}\u{1164}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D5B6}",
        nfc: "\u{D5B6}",
        nfd: "\u{1112}\u{1164}\u{11B1}",
        nfkc: "\u{D5B6}",
        nfkd: "\u{1112}\u{1164}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D5B7}",
        nfc: "\u{D5B7}",
        nfd: "\u{1112}\u{1164}\u{11B2}",
        nfkc: "\u{D5B7}",
        nfkd: "\u{1112}\u{1164}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D5B8}",
        nfc: "\u{D5B8}",
        nfd: "\u{1112}\u{1164}\u{11B3}",
        nfkc: "\u{D5B8}",
        nfkd: "\u{1112}\u{1164}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D5B9}",
        nfc: "\u{D5B9}",
        nfd: "\u{1112}\u{1164}\u{11B4}",
        nfkc: "\u{D5B9}",
        nfkd: "\u{1112}\u{1164}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D5BA}",
        nfc: "\u{D5BA}",
        nfd: "\u{1112}\u{1164}\u{11B5}",
        nfkc: "\u{D5BA}",
        nfkd: "\u{1112}\u{1164}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D5BB}",
        nfc: "\u{D5BB}",
        nfd: "\u{1112}\u{1164}\u{11B6}",
        nfkc: "\u{D5BB}",
        nfkd: "\u{1112}\u{1164}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D5BC}",
        nfc: "\u{D5BC}",
        nfd: "\u{1112}\u{1164}\u{11B7}",
        nfkc: "\u{D5BC}",
        nfkd: "\u{1112}\u{1164}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D5BD}",
        nfc: "\u{D5BD}",
        nfd: "\u{1112}\u{1164}\u{11B8}",
        nfkc: "\u{D5BD}",
        nfkd: "\u{1112}\u{1164}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D5BE}",
        nfc: "\u{D5BE}",
        nfd: "\u{1112}\u{1164}\u{11B9}",
        nfkc: "\u{D5BE}",
        nfkd: "\u{1112}\u{1164}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D5BF}",
        nfc: "\u{D5BF}",
        nfd: "\u{1112}\u{1164}\u{11BA}",
        nfkc: "\u{D5BF}",
        nfkd: "\u{1112}\u{1164}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D5C0}",
        nfc: "\u{D5C0}",
        nfd: "\u{1112}\u{1164}\u{11BB}",
        nfkc: "\u{D5C0}",
        nfkd: "\u{1112}\u{1164}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D5C1}",
        nfc: "\u{D5C1}",
        nfd: "\u{1112}\u{1164}\u{11BC}",
        nfkc: "\u{D5C1}",
        nfkd: "\u{1112}\u{1164}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D5C2}",
        nfc: "\u{D5C2}",
        nfd: "\u{1112}\u{1164}\u{11BD}",
        nfkc: "\u{D5C2}",
        nfkd: "\u{1112}\u{1164}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D5C3}",
        nfc: "\u{D5C3}",
        nfd: "\u{1112}\u{1164}\u{11BE}",
        nfkc: "\u{D5C3}",
        nfkd: "\u{1112}\u{1164}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D5C4}",
        nfc: "\u{D5C4}",
        nfd: "\u{1112}\u{1164}\u{11BF}",
        nfkc: "\u{D5C4}",
        nfkd: "\u{1112}\u{1164}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D5C5}",
        nfc: "\u{D5C5}",
        nfd: "\u{1112}\u{1164}\u{11C0}",
        nfkc: "\u{D5C5}",
        nfkd: "\u{1112}\u{1164}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D5C6}",
        nfc: "\u{D5C6}",
        nfd: "\u{1112}\u{1164}\u{11C1}",
        nfkc: "\u{D5C6}",
        nfkd: "\u{1112}\u{1164}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D5C7}",
        nfc: "\u{D5C7}",
        nfd: "\u{1112}\u{1164}\u{11C2}",
        nfkc: "\u{D5C7}",
        nfkd: "\u{1112}\u{1164}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D5C8}",
        nfc: "\u{D5C8}",
        nfd: "\u{1112}\u{1165}",
        nfkc: "\u{D5C8}",
        nfkd: "\u{1112}\u{1165}",
    },
    NormalizationTest {
        source: "\u{D5C9}",
        nfc: "\u{D5C9}",
        nfd: "\u{1112}\u{1165}\u{11A8}",
        nfkc: "\u{D5C9}",
        nfkd: "\u{1112}\u{1165}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D5CA}",
        nfc: "\u{D5CA}",
        nfd: "\u{1112}\u{1165}\u{11A9}",
        nfkc: "\u{D5CA}",
        nfkd: "\u{1112}\u{1165}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D5CB}",
        nfc: "\u{D5CB}",
        nfd: "\u{1112}\u{1165}\u{11AA}",
        nfkc: "\u{D5CB}",
        nfkd: "\u{1112}\u{1165}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D5CC}",
        nfc: "\u{D5CC}",
        nfd: "\u{1112}\u{1165}\u{11AB}",
        nfkc: "\u{D5CC}",
        nfkd: "\u{1112}\u{1165}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D5CD}",
        nfc: "\u{D5CD}",
        nfd: "\u{1112}\u{1165}\u{11AC}",
        nfkc: "\u{D5CD}",
        nfkd: "\u{1112}\u{1165}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D5CE}",
        nfc: "\u{D5CE}",
        nfd: "\u{1112}\u{1165}\u{11AD}",
        nfkc: "\u{D5CE}",
        nfkd: "\u{1112}\u{1165}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D5CF}",
        nfc: "\u{D5CF}",
        nfd: "\u{1112}\u{1165}\u{11AE}",
        nfkc: "\u{D5CF}",
        nfkd: "\u{1112}\u{1165}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D5D0}",
        nfc: "\u{D5D0}",
        nfd: "\u{1112}\u{1165}\u{11AF}",
        nfkc: "\u{D5D0}",
        nfkd: "\u{1112}\u{1165}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D5D1}",
        nfc: "\u{D5D1}",
        nfd: "\u{1112}\u{1165}\u{11B0}",
        nfkc: "\u{D5D1}",
        nfkd: "\u{1112}\u{1165}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D5D2}",
        nfc: "\u{D5D2}",
        nfd: "\u{1112}\u{1165}\u{11B1}",
        nfkc: "\u{D5D2}",
        nfkd: "\u{1112}\u{1165}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D5D3}",
        nfc: "\u{D5D3}",
        nfd: "\u{1112}\u{1165}\u{11B2}",
        nfkc: "\u{D5D3}",
        nfkd: "\u{1112}\u{1165}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D5D4}",
        nfc: "\u{D5D4}",
        nfd: "\u{1112}\u{1165}\u{11B3}",
        nfkc: "\u{D5D4}",
        nfkd: "\u{1112}\u{1165}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D5D5}",
        nfc: "\u{D5D5}",
        nfd: "\u{1112}\u{1165}\u{11B4}",
        nfkc: "\u{D5D5}",
        nfkd: "\u{1112}\u{1165}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D5D6}",
        nfc: "\u{D5D6}",
        nfd: "\u{1112}\u{1165}\u{11B5}",
        nfkc: "\u{D5D6}",
        nfkd: "\u{1112}\u{1165}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D5D7}",
        nfc: "\u{D5D7}",
        nfd: "\u{1112}\u{1165}\u{11B6}",
        nfkc: "\u{D5D7}",
        nfkd: "\u{1112}\u{1165}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D5D8}",
        nfc: "\u{D5D8}",
        nfd: "\u{1112}\u{1165}\u{11B7}",
        nfkc: "\u{D5D8}",
        nfkd: "\u{1112}\u{1165}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D5D9}",
        nfc: "\u{D5D9}",
        nfd: "\u{1112}\u{1165}\u{11B8}",
        nfkc: "\u{D5D9}",
        nfkd: "\u{1112}\u{1165}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D5DA}",
        nfc: "\u{D5DA}",
        nfd: "\u{1112}\u{1165}\u{11B9}",
        nfkc: "\u{D5DA}",
        nfkd: "\u{1112}\u{1165}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D5DB}",
        nfc: "\u{D5DB}",
        nfd: "\u{1112}\u{1165}\u{11BA}",
        nfkc: "\u{D5DB}",
        nfkd: "\u{1112}\u{1165}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D5DC}",
        nfc: "\u{D5DC}",
        nfd: "\u{1112}\u{1165}\u{11BB}",
        nfkc: "\u{D5DC}",
        nfkd: "\u{1112}\u{1165}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D5DD}",
        nfc: "\u{D5DD}",
        nfd: "\u{1112}\u{1165}\u{11BC}",
        nfkc: "\u{D5DD}",
        nfkd: "\u{1112}\u{1165}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D5DE}",
        nfc: "\u{D5DE}",
        nfd: "\u{1112}\u{1165}\u{11BD}",
        nfkc: "\u{D5DE}",
        nfkd: "\u{1112}\u{1165}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D5DF}",
        nfc: "\u{D5DF}",
        nfd: "\u{1112}\u{1165}\u{11BE}",
        nfkc: "\u{D5DF}",
        nfkd: "\u{1112}\u{1165}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D5E0}",
        nfc: "\u{D5E0}",
        nfd: "\u{1112}\u{1165}\u{11BF}",
        nfkc: "\u{D5E0}",
        nfkd: "\u{1112}\u{1165}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D5E1}",
        nfc: "\u{D5E1}",
        nfd: "\u{1112}\u{1165}\u{11C0}",
        nfkc: "\u{D5E1}",
        nfkd: "\u{1112}\u{1165}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D5E2}",
        nfc: "\u{D5E2}",
        nfd: "\u{1112}\u{1165}\u{11C1}",
        nfkc: "\u{D5E2}",
        nfkd: "\u{1112}\u{1165}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D5E3}",
        nfc: "\u{D5E3}",
        nfd: "\u{1112}\u{1165}\u{11C2}",
        nfkc: "\u{D5E3}",
        nfkd: "\u{1112}\u{1165}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D5E4}",
        nfc: "\u{D5E4}",
        nfd: "\u{1112}\u{1166}",
        nfkc: "\u{D5E4}",
        nfkd: "\u{1112}\u{1166}",
    },
    NormalizationTest {
        source: "\u{D5E5}",
        nfc: "\u{D5E5}",
        nfd: "\u{1112}\u{1166}\u{11A8}",
        nfkc: "\u{D5E5}",
        nfkd: "\u{1112}\u{1166}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D5E6}",
        nfc: "\u{D5E6}",
        nfd: "\u{1112}\u{1166}\u{11A9}",
        nfkc: "\u{D5E6}",
        nfkd: "\u{1112}\u{1166}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D5E7}",
        nfc: "\u{D5E7}",
        nfd: "\u{1112}\u{1166}\u{11AA}",
        nfkc: "\u{D5E7}",
        nfkd: "\u{1112}\u{1166}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D5E8}",
        nfc: "\u{D5E8}",
        nfd: "\u{1112}\u{1166}\u{11AB}",
        nfkc: "\u{D5E8}",
        nfkd: "\u{1112}\u{1166}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D5E9}",
        nfc: "\u{D5E9}",
        nfd: "\u{1112}\u{1166}\u{11AC}",
        nfkc: "\u{D5E9}",
        nfkd: "\u{1112}\u{1166}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D5EA}",
        nfc: "\u{D5EA}",
        nfd: "\u{1112}\u{1166}\u{11AD}",
        nfkc: "\u{D5EA}",
        nfkd: "\u{1112}\u{1166}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D5EB}",
        nfc: "\u{D5EB}",
        nfd: "\u{1112}\u{1166}\u{11AE}",
        nfkc: "\u{D5EB}",
        nfkd: "\u{1112}\u{1166}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D5EC}",
        nfc: "\u{D5EC}",
        nfd: "\u{1112}\u{1166}\u{11AF}",
        nfkc: "\u{D5EC}",
        nfkd: "\u{1112}\u{1166}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D5ED}",
        nfc: "\u{D5ED}",
        nfd: "\u{1112}\u{1166}\u{11B0}",
        nfkc: "\u{D5ED}",
        nfkd: "\u{1112}\u{1166}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D5EE}",
        nfc: "\u{D5EE}",
        nfd: "\u{1112}\u{1166}\u{11B1}",
        nfkc: "\u{D5EE}",
        nfkd: "\u{1112}\u{1166}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D5EF}",
        nfc: "\u{D5EF}",
        nfd: "\u{1112}\u{1166}\u{11B2}",
        nfkc: "\u{D5EF}",
        nfkd: "\u{1112}\u{1166}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D5F0}",
        nfc: "\u{D5F0}",
        nfd: "\u{1112}\u{1166}\u{11B3}",
        nfkc: "\u{D5F0}",
        nfkd: "\u{1112}\u{1166}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D5F1}",
        nfc: "\u{D5F1}",
        nfd: "\u{1112}\u{1166}\u{11B4}",
        nfkc: "\u{D5F1}",
        nfkd: "\u{1112}\u{1166}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D5F2}",
        nfc: "\u{D5F2}",
        nfd: "\u{1112}\u{1166}\u{11B5}",
        nfkc: "\u{D5F2}",
        nfkd: "\u{1112}\u{1166}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D5F3}",
        nfc: "\u{D5F3}",
        nfd: "\u{1112}\u{1166}\u{11B6}",
        nfkc: "\u{D5F3}",
        nfkd: "\u{1112}\u{1166}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D5F4}",
        nfc: "\u{D5F4}",
        nfd: "\u{1112}\u{1166}\u{11B7}",
        nfkc: "\u{D5F4}",
        nfkd: "\u{1112}\u{1166}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D5F5}",
        nfc: "\u{D5F5}",
        nfd: "\u{1112}\u{1166}\u{11B8}",
        nfkc: "\u{D5F5}",
        nfkd: "\u{1112}\u{1166}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D5F6}",
        nfc: "\u{D5F6}",
        nfd: "\u{1112}\u{1166}\u{11B9}",
        nfkc: "\u{D5F6}",
        nfkd: "\u{1112}\u{1166}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D5F7}",
        nfc: "\u{D5F7}",
        nfd: "\u{1112}\u{1166}\u{11BA}",
        nfkc: "\u{D5F7}",
        nfkd: "\u{1112}\u{1166}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D5F8}",
        nfc: "\u{D5F8}",
        nfd: "\u{1112}\u{1166}\u{11BB}",
        nfkc: "\u{D5F8}",
        nfkd: "\u{1112}\u{1166}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D5F9}",
        nfc: "\u{D5F9}",
        nfd: "\u{1112}\u{1166}\u{11BC}",
        nfkc: "\u{D5F9}",
        nfkd: "\u{1112}\u{1166}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D5FA}",
        nfc: "\u{D5FA}",
        nfd: "\u{1112}\u{1166}\u{11BD}",
        nfkc: "\u{D5FA}",
        nfkd: "\u{1112}\u{1166}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D5FB}",
        nfc: "\u{D5FB}",
        nfd: "\u{1112}\u{1166}\u{11BE}",
        nfkc: "\u{D5FB}",
        nfkd: "\u{1112}\u{1166}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D5FC}",
        nfc: "\u{D5FC}",
        nfd: "\u{1112}\u{1166}\u{11BF}",
        nfkc: "\u{D5FC}",
        nfkd: "\u{1112}\u{1166}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D5FD}",
        nfc: "\u{D5FD}",
        nfd: "\u{1112}\u{1166}\u{11C0}",
        nfkc: "\u{D5FD}",
        nfkd: "\u{1112}\u{1166}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D5FE}",
        nfc: "\u{D5FE}",
        nfd: "\u{1112}\u{1166}\u{11C1}",
        nfkc: "\u{D5FE}",
        nfkd: "\u{1112}\u{1166}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D5FF}",
        nfc: "\u{D5FF}",
        nfd: "\u{1112}\u{1166}\u{11C2}",
        nfkc: "\u{D5FF}",
        nfkd: "\u{1112}\u{1166}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D600}",
        nfc: "\u{D600}",
        nfd: "\u{1112}\u{1167}",
        nfkc: "\u{D600}",
        nfkd: "\u{1112}\u{1167}",
    },
    NormalizationTest {
        source: "\u{D601}",
        nfc: "\u{D601}",
        nfd: "\u{1112}\u{1167}\u{11A8}",
        nfkc: "\u{D601}",
        nfkd: "\u{1112}\u{1167}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D602}",
        nfc: "\u{D602}",
        nfd: "\u{1112}\u{1167}\u{11A9}",
        nfkc: "\u{D602}",
        nfkd: "\u{1112}\u{1167}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D603}",
        nfc: "\u{D603}",
        nfd: "\u{1112}\u{1167}\u{11AA}",
        nfkc: "\u{D603}",
        nfkd: "\u{1112}\u{1167}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D604}",
        nfc: "\u{D604}",
        nfd: "\u{1112}\u{1167}\u{11AB}",
        nfkc: "\u{D604}",
        nfkd: "\u{1112}\u{1167}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D605}",
        nfc: "\u{D605}",
        nfd: "\u{1112}\u{1167}\u{11AC}",
        nfkc: "\u{D605}",
        nfkd: "\u{1112}\u{1167}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D606}",
        nfc: "\u{D606}",
        nfd: "\u{1112}\u{1167}\u{11AD}",
        nfkc: "\u{D606}",
        nfkd: "\u{1112}\u{1167}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D607}",
        nfc: "\u{D607}",
        nfd: "\u{1112}\u{1167}\u{11AE}",
        nfkc: "\u{D607}",
        nfkd: "\u{1112}\u{1167}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D608}",
        nfc: "\u{D608}",
        nfd: "\u{1112}\u{1167}\u{11AF}",
        nfkc: "\u{D608}",
        nfkd: "\u{1112}\u{1167}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D609}",
        nfc: "\u{D609}",
        nfd: "\u{1112}\u{1167}\u{11B0}",
        nfkc: "\u{D609}",
        nfkd: "\u{1112}\u{1167}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D60A}",
        nfc: "\u{D60A}",
        nfd: "\u{1112}\u{1167}\u{11B1}",
        nfkc: "\u{D60A}",
        nfkd: "\u{1112}\u{1167}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D60B}",
        nfc: "\u{D60B}",
        nfd: "\u{1112}\u{1167}\u{11B2}",
        nfkc: "\u{D60B}",
        nfkd: "\u{1112}\u{1167}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D60C}",
        nfc: "\u{D60C}",
        nfd: "\u{1112}\u{1167}\u{11B3}",
        nfkc: "\u{D60C}",
        nfkd: "\u{1112}\u{1167}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D60D}",
        nfc: "\u{D60D}",
        nfd: "\u{1112}\u{1167}\u{11B4}",
        nfkc: "\u{D60D}",
        nfkd: "\u{1112}\u{1167}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D60E}",
        nfc: "\u{D60E}",
        nfd: "\u{1112}\u{1167}\u{11B5}",
        nfkc: "\u{D60E}",
        nfkd: "\u{1112}\u{1167}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D60F}",
        nfc: "\u{D60F}",
        nfd: "\u{1112}\u{1167}\u{11B6}",
        nfkc: "\u{D60F}",
        nfkd: "\u{1112}\u{1167}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D610}",
        nfc: "\u{D610}",
        nfd: "\u{1112}\u{1167}\u{11B7}",
        nfkc: "\u{D610}",
        nfkd: "\u{1112}\u{1167}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D611}",
        nfc: "\u{D611}",
        nfd: "\u{1112}\u{1167}\u{11B8}",
        nfkc: "\u{D611}",
        nfkd: "\u{1112}\u{1167}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D612}",
        nfc: "\u{D612}",
        nfd: "\u{1112}\u{1167}\u{11B9}",
        nfkc: "\u{D612}",
        nfkd: "\u{1112}\u{1167}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D613}",
        nfc: "\u{D613}",
        nfd: "\u{1112}\u{1167}\u{11BA}",
        nfkc: "\u{D613}",
        nfkd: "\u{1112}\u{1167}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D614}",
        nfc: "\u{D614}",
        nfd: "\u{1112}\u{1167}\u{11BB}",
        nfkc: "\u{D614}",
        nfkd: "\u{1112}\u{1167}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D615}",
        nfc: "\u{D615}",
        nfd: "\u{1112}\u{1167}\u{11BC}",
        nfkc: "\u{D615}",
        nfkd: "\u{1112}\u{1167}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D616}",
        nfc: "\u{D616}",
        nfd: "\u{1112}\u{1167}\u{11BD}",
        nfkc: "\u{D616}",
        nfkd: "\u{1112}\u{1167}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D617}",
        nfc: "\u{D617}",
        nfd: "\u{1112}\u{1167}\u{11BE}",
        nfkc: "\u{D617}",
        nfkd: "\u{1112}\u{1167}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D618}",
        nfc: "\u{D618}",
        nfd: "\u{1112}\u{1167}\u{11BF}",
        nfkc: "\u{D618}",
        nfkd: "\u{1112}\u{1167}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D619}",
        nfc: "\u{D619}",
        nfd: "\u{1112}\u{1167}\u{11C0}",
        nfkc: "\u{D619}",
        nfkd: "\u{1112}\u{1167}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D61A}",
        nfc: "\u{D61A}",
        nfd: "\u{1112}\u{1167}\u{11C1}",
        nfkc: "\u{D61A}",
        nfkd: "\u{1112}\u{1167}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D61B}",
        nfc: "\u{D61B}",
        nfd: "\u{1112}\u{1167}\u{11C2}",
        nfkc: "\u{D61B}",
        nfkd: "\u{1112}\u{1167}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D61C}",
        nfc: "\u{D61C}",
        nfd: "\u{1112}\u{1168}",
        nfkc: "\u{D61C}",
        nfkd: "\u{1112}\u{1168}",
    },
    NormalizationTest {
        source: "\u{D61D}",
        nfc: "\u{D61D}",
        nfd: "\u{1112}\u{1168}\u{11A8}",
        nfkc: "\u{D61D}",
        nfkd: "\u{1112}\u{1168}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D61E}",
        nfc: "\u{D61E}",
        nfd: "\u{1112}\u{1168}\u{11A9}",
        nfkc: "\u{D61E}",
        nfkd: "\u{1112}\u{1168}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D61F}",
        nfc: "\u{D61F}",
        nfd: "\u{1112}\u{1168}\u{11AA}",
        nfkc: "\u{D61F}",
        nfkd: "\u{1112}\u{1168}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D620}",
        nfc: "\u{D620}",
        nfd: "\u{1112}\u{1168}\u{11AB}",
        nfkc: "\u{D620}",
        nfkd: "\u{1112}\u{1168}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D621}",
        nfc: "\u{D621}",
        nfd: "\u{1112}\u{1168}\u{11AC}",
        nfkc: "\u{D621}",
        nfkd: "\u{1112}\u{1168}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D622}",
        nfc: "\u{D622}",
        nfd: "\u{1112}\u{1168}\u{11AD}",
        nfkc: "\u{D622}",
        nfkd: "\u{1112}\u{1168}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D623}",
        nfc: "\u{D623}",
        nfd: "\u{1112}\u{1168}\u{11AE}",
        nfkc: "\u{D623}",
        nfkd: "\u{1112}\u{1168}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D624}",
        nfc: "\u{D624}",
        nfd: "\u{1112}\u{1168}\u{11AF}",
        nfkc: "\u{D624}",
        nfkd: "\u{1112}\u{1168}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D625}",
        nfc: "\u{D625}",
        nfd: "\u{1112}\u{1168}\u{11B0}",
        nfkc: "\u{D625}",
        nfkd: "\u{1112}\u{1168}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D626}",
        nfc: "\u{D626}",
        nfd: "\u{1112}\u{1168}\u{11B1}",
        nfkc: "\u{D626}",
        nfkd: "\u{1112}\u{1168}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D627}",
        nfc: "\u{D627}",
        nfd: "\u{1112}\u{1168}\u{11B2}",
        nfkc: "\u{D627}",
        nfkd: "\u{1112}\u{1168}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D628}",
        nfc: "\u{D628}",
        nfd: "\u{1112}\u{1168}\u{11B3}",
        nfkc: "\u{D628}",
        nfkd: "\u{1112}\u{1168}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D629}",
        nfc: "\u{D629}",
        nfd: "\u{1112}\u{1168}\u{11B4}",
        nfkc: "\u{D629}",
        nfkd: "\u{1112}\u{1168}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D62A}",
        nfc: "\u{D62A}",
        nfd: "\u{1112}\u{1168}\u{11B5}",
        nfkc: "\u{D62A}",
        nfkd: "\u{1112}\u{1168}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D62B}",
        nfc: "\u{D62B}",
        nfd: "\u{1112}\u{1168}\u{11B6}",
        nfkc: "\u{D62B}",
        nfkd: "\u{1112}\u{1168}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D62C}",
        nfc: "\u{D62C}",
        nfd: "\u{1112}\u{1168}\u{11B7}",
        nfkc: "\u{D62C}",
        nfkd: "\u{1112}\u{1168}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D62D}",
        nfc: "\u{D62D}",
        nfd: "\u{1112}\u{1168}\u{11B8}",
        nfkc: "\u{D62D}",
        nfkd: "\u{1112}\u{1168}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D62E}",
        nfc: "\u{D62E}",
        nfd: "\u{1112}\u{1168}\u{11B9}",
        nfkc: "\u{D62E}",
        nfkd: "\u{1112}\u{1168}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D62F}",
        nfc: "\u{D62F}",
        nfd: "\u{1112}\u{1168}\u{11BA}",
        nfkc: "\u{D62F}",
        nfkd: "\u{1112}\u{1168}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D630}",
        nfc: "\u{D630}",
        nfd: "\u{1112}\u{1168}\u{11BB}",
        nfkc: "\u{D630}",
        nfkd: "\u{1112}\u{1168}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D631}",
        nfc: "\u{D631}",
        nfd: "\u{1112}\u{1168}\u{11BC}",
        nfkc: "\u{D631}",
        nfkd: "\u{1112}\u{1168}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D632}",
        nfc: "\u{D632}",
        nfd: "\u{1112}\u{1168}\u{11BD}",
        nfkc: "\u{D632}",
        nfkd: "\u{1112}\u{1168}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D633}",
        nfc: "\u{D633}",
        nfd: "\u{1112}\u{1168}\u{11BE}",
        nfkc: "\u{D633}",
        nfkd: "\u{1112}\u{1168}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D634}",
        nfc: "\u{D634}",
        nfd: "\u{1112}\u{1168}\u{11BF}",
        nfkc: "\u{D634}",
        nfkd: "\u{1112}\u{1168}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D635}",
        nfc: "\u{D635}",
        nfd: "\u{1112}\u{1168}\u{11C0}",
        nfkc: "\u{D635}",
        nfkd: "\u{1112}\u{1168}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D636}",
        nfc: "\u{D636}",
        nfd: "\u{1112}\u{1168}\u{11C1}",
        nfkc: "\u{D636}",
        nfkd: "\u{1112}\u{1168}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D637}",
        nfc: "\u{D637}",
        nfd: "\u{1112}\u{1168}\u{11C2}",
        nfkc: "\u{D637}",
        nfkd: "\u{1112}\u{1168}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D638}",
        nfc: "\u{D638}",
        nfd: "\u{1112}\u{1169}",
        nfkc: "\u{D638}",
        nfkd: "\u{1112}\u{1169}",
    },
    NormalizationTest {
        source: "\u{D639}",
        nfc: "\u{D639}",
        nfd: "\u{1112}\u{1169}\u{11A8}",
        nfkc: "\u{D639}",
        nfkd: "\u{1112}\u{1169}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D63A}",
        nfc: "\u{D63A}",
        nfd: "\u{1112}\u{1169}\u{11A9}",
        nfkc: "\u{D63A}",
        nfkd: "\u{1112}\u{1169}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D63B}",
        nfc: "\u{D63B}",
        nfd: "\u{1112}\u{1169}\u{11AA}",
        nfkc: "\u{D63B}",
        nfkd: "\u{1112}\u{1169}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D63C}",
        nfc: "\u{D63C}",
        nfd: "\u{1112}\u{1169}\u{11AB}",
        nfkc: "\u{D63C}",
        nfkd: "\u{1112}\u{1169}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D63D}",
        nfc: "\u{D63D}",
        nfd: "\u{1112}\u{1169}\u{11AC}",
        nfkc: "\u{D63D}",
        nfkd: "\u{1112}\u{1169}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D63E}",
        nfc: "\u{D63E}",
        nfd: "\u{1112}\u{1169}\u{11AD}",
        nfkc: "\u{D63E}",
        nfkd: "\u{1112}\u{1169}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D63F}",
        nfc: "\u{D63F}",
        nfd: "\u{1112}\u{1169}\u{11AE}",
        nfkc: "\u{D63F}",
        nfkd: "\u{1112}\u{1169}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D640}",
        nfc: "\u{D640}",
        nfd: "\u{1112}\u{1169}\u{11AF}",
        nfkc: "\u{D640}",
        nfkd: "\u{1112}\u{1169}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D641}",
        nfc: "\u{D641}",
        nfd: "\u{1112}\u{1169}\u{11B0}",
        nfkc: "\u{D641}",
        nfkd: "\u{1112}\u{1169}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D642}",
        nfc: "\u{D642}",
        nfd: "\u{1112}\u{1169}\u{11B1}",
        nfkc: "\u{D642}",
        nfkd: "\u{1112}\u{1169}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D643}",
        nfc: "\u{D643}",
        nfd: "\u{1112}\u{1169}\u{11B2}",
        nfkc: "\u{D643}",
        nfkd: "\u{1112}\u{1169}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D644}",
        nfc: "\u{D644}",
        nfd: "\u{1112}\u{1169}\u{11B3}",
        nfkc: "\u{D644}",
        nfkd: "\u{1112}\u{1169}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D645}",
        nfc: "\u{D645}",
        nfd: "\u{1112}\u{1169}\u{11B4}",
        nfkc: "\u{D645}",
        nfkd: "\u{1112}\u{1169}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D646}",
        nfc: "\u{D646}",
        nfd: "\u{1112}\u{1169}\u{11B5}",
        nfkc: "\u{D646}",
        nfkd: "\u{1112}\u{1169}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D647}",
        nfc: "\u{D647}",
        nfd: "\u{1112}\u{1169}\u{11B6}",
        nfkc: "\u{D647}",
        nfkd: "\u{1112}\u{1169}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D648}",
        nfc: "\u{D648}",
        nfd: "\u{1112}\u{1169}\u{11B7}",
        nfkc: "\u{D648}",
        nfkd: "\u{1112}\u{1169}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D649}",
        nfc: "\u{D649}",
        nfd: "\u{1112}\u{1169}\u{11B8}",
        nfkc: "\u{D649}",
        nfkd: "\u{1112}\u{1169}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D64A}",
        nfc: "\u{D64A}",
        nfd: "\u{1112}\u{1169}\u{11B9}",
        nfkc: "\u{D64A}",
        nfkd: "\u{1112}\u{1169}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D64B}",
        nfc: "\u{D64B}",
        nfd: "\u{1112}\u{1169}\u{11BA}",
        nfkc: "\u{D64B}",
        nfkd: "\u{1112}\u{1169}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D64C}",
        nfc: "\u{D64C}",
        nfd: "\u{1112}\u{1169}\u{11BB}",
        nfkc: "\u{D64C}",
        nfkd: "\u{1112}\u{1169}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D64D}",
        nfc: "\u{D64D}",
        nfd: "\u{1112}\u{1169}\u{11BC}",
        nfkc: "\u{D64D}",
        nfkd: "\u{1112}\u{1169}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D64E}",
        nfc: "\u{D64E}",
        nfd: "\u{1112}\u{1169}\u{11BD}",
        nfkc: "\u{D64E}",
        nfkd: "\u{1112}\u{1169}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D64F}",
        nfc: "\u{D64F}",
        nfd: "\u{1112}\u{1169}\u{11BE}",
        nfkc: "\u{D64F}",
        nfkd: "\u{1112}\u{1169}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D650}",
        nfc: "\u{D650}",
        nfd: "\u{1112}\u{1169}\u{11BF}",
        nfkc: "\u{D650}",
        nfkd: "\u{1112}\u{1169}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D651}",
        nfc: "\u{D651}",
        nfd: "\u{1112}\u{1169}\u{11C0}",
        nfkc: "\u{D651}",
        nfkd: "\u{1112}\u{1169}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D652}",
        nfc: "\u{D652}",
        nfd: "\u{1112}\u{1169}\u{11C1}",
        nfkc: "\u{D652}",
        nfkd: "\u{1112}\u{1169}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D653}",
        nfc: "\u{D653}",
        nfd: "\u{1112}\u{1169}\u{11C2}",
        nfkc: "\u{D653}",
        nfkd: "\u{1112}\u{1169}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D654}",
        nfc: "\u{D654}",
        nfd: "\u{1112}\u{116A}",
        nfkc: "\u{D654}",
        nfkd: "\u{1112}\u{116A}",
    },
    NormalizationTest {
        source: "\u{D655}",
        nfc: "\u{D655}",
        nfd: "\u{1112}\u{116A}\u{11A8}",
        nfkc: "\u{D655}",
        nfkd: "\u{1112}\u{116A}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D656}",
        nfc: "\u{D656}",
        nfd: "\u{1112}\u{116A}\u{11A9}",
        nfkc: "\u{D656}",
        nfkd: "\u{1112}\u{116A}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D657}",
        nfc: "\u{D657}",
        nfd: "\u{1112}\u{116A}\u{11AA}",
        nfkc: "\u{D657}",
        nfkd: "\u{1112}\u{116A}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D658}",
        nfc: "\u{D658}",
        nfd: "\u{1112}\u{116A}\u{11AB}",
        nfkc: "\u{D658}",
        nfkd: "\u{1112}\u{116A}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D659}",
        nfc: "\u{D659}",
        nfd: "\u{1112}\u{116A}\u{11AC}",
        nfkc: "\u{D659}",
        nfkd: "\u{1112}\u{116A}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D65A}",
        nfc: "\u{D65A}",
        nfd: "\u{1112}\u{116A}\u{11AD}",
        nfkc: "\u{D65A}",
        nfkd: "\u{1112}\u{116A}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D65B}",
        nfc: "\u{D65B}",
        nfd: "\u{1112}\u{116A}\u{11AE}",
        nfkc: "\u{D65B}",
        nfkd: "\u{1112}\u{116A}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D65C}",
        nfc: "\u{D65C}",
        nfd: "\u{1112}\u{116A}\u{11AF}",
        nfkc: "\u{D65C}",
        nfkd: "\u{1112}\u{116A}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D65D}",
        nfc: "\u{D65D}",
        nfd: "\u{1112}\u{116A}\u{11B0}",
        nfkc: "\u{D65D}",
        nfkd: "\u{1112}\u{116A}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D65E}",
        nfc: "\u{D65E}",
        nfd: "\u{1112}\u{116A}\u{11B1}",
        nfkc: "\u{D65E}",
        nfkd: "\u{1112}\u{116A}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D65F}",
        nfc: "\u{D65F}",
        nfd: "\u{1112}\u{116A}\u{11B2}",
        nfkc: "\u{D65F}",
        nfkd: "\u{1112}\u{116A}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D660}",
        nfc: "\u{D660}",
        nfd: "\u{1112}\u{116A}\u{11B3}",
        nfkc: "\u{D660}",
        nfkd: "\u{1112}\u{116A}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D661}",
        nfc: "\u{D661}",
        nfd: "\u{1112}\u{116A}\u{11B4}",
        nfkc: "\u{D661}",
        nfkd: "\u{1112}\u{116A}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D662}",
        nfc: "\u{D662}",
        nfd: "\u{1112}\u{116A}\u{11B5}",
        nfkc: "\u{D662}",
        nfkd: "\u{1112}\u{116A}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D663}",
        nfc: "\u{D663}",
        nfd: "\u{1112}\u{116A}\u{11B6}",
        nfkc: "\u{D663}",
        nfkd: "\u{1112}\u{116A}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D664}",
        nfc: "\u{D664}",
        nfd: "\u{1112}\u{116A}\u{11B7}",
        nfkc: "\u{D664}",
        nfkd: "\u{1112}\u{116A}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D665}",
        nfc: "\u{D665}",
        nfd: "\u{1112}\u{116A}\u{11B8}",
        nfkc: "\u{D665}",
        nfkd: "\u{1112}\u{116A}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D666}",
        nfc: "\u{D666}",
        nfd: "\u{1112}\u{116A}\u{11B9}",
        nfkc: "\u{D666}",
        nfkd: "\u{1112}\u{116A}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D667}",
        nfc: "\u{D667}",
        nfd: "\u{1112}\u{116A}\u{11BA}",
        nfkc: "\u{D667}",
        nfkd: "\u{1112}\u{116A}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D668}",
        nfc: "\u{D668}",
        nfd: "\u{1112}\u{116A}\u{11BB}",
        nfkc: "\u{D668}",
        nfkd: "\u{1112}\u{116A}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D669}",
        nfc: "\u{D669}",
        nfd: "\u{1112}\u{116A}\u{11BC}",
        nfkc: "\u{D669}",
        nfkd: "\u{1112}\u{116A}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D66A}",
        nfc: "\u{D66A}",
        nfd: "\u{1112}\u{116A}\u{11BD}",
        nfkc: "\u{D66A}",
        nfkd: "\u{1112}\u{116A}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D66B}",
        nfc: "\u{D66B}",
        nfd: "\u{1112}\u{116A}\u{11BE}",
        nfkc: "\u{D66B}",
        nfkd: "\u{1112}\u{116A}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D66C}",
        nfc: "\u{D66C}",
        nfd: "\u{1112}\u{116A}\u{11BF}",
        nfkc: "\u{D66C}",
        nfkd: "\u{1112}\u{116A}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D66D}",
        nfc: "\u{D66D}",
        nfd: "\u{1112}\u{116A}\u{11C0}",
        nfkc: "\u{D66D}",
        nfkd: "\u{1112}\u{116A}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D66E}",
        nfc: "\u{D66E}",
        nfd: "\u{1112}\u{116A}\u{11C1}",
        nfkc: "\u{D66E}",
        nfkd: "\u{1112}\u{116A}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D66F}",
        nfc: "\u{D66F}",
        nfd: "\u{1112}\u{116A}\u{11C2}",
        nfkc: "\u{D66F}",
        nfkd: "\u{1112}\u{116A}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D670}",
        nfc: "\u{D670}",
        nfd: "\u{1112}\u{116B}",
        nfkc: "\u{D670}",
        nfkd: "\u{1112}\u{116B}",
    },
    NormalizationTest {
        source: "\u{D671}",
        nfc: "\u{D671}",
        nfd: "\u{1112}\u{116B}\u{11A8}",
        nfkc: "\u{D671}",
        nfkd: "\u{1112}\u{116B}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D672}",
        nfc: "\u{D672}",
        nfd: "\u{1112}\u{116B}\u{11A9}",
        nfkc: "\u{D672}",
        nfkd: "\u{1112}\u{116B}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D673}",
        nfc: "\u{D673}",
        nfd: "\u{1112}\u{116B}\u{11AA}",
        nfkc: "\u{D673}",
        nfkd: "\u{1112}\u{116B}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D674}",
        nfc: "\u{D674}",
        nfd: "\u{1112}\u{116B}\u{11AB}",
        nfkc: "\u{D674}",
        nfkd: "\u{1112}\u{116B}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D675}",
        nfc: "\u{D675}",
        nfd: "\u{1112}\u{116B}\u{11AC}",
        nfkc: "\u{D675}",
        nfkd: "\u{1112}\u{116B}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D676}",
        nfc: "\u{D676}",
        nfd: "\u{1112}\u{116B}\u{11AD}",
        nfkc: "\u{D676}",
        nfkd: "\u{1112}\u{116B}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D677}",
        nfc: "\u{D677}",
        nfd: "\u{1112}\u{116B}\u{11AE}",
        nfkc: "\u{D677}",
        nfkd: "\u{1112}\u{116B}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D678}",
        nfc: "\u{D678}",
        nfd: "\u{1112}\u{116B}\u{11AF}",
        nfkc: "\u{D678}",
        nfkd: "\u{1112}\u{116B}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D679}",
        nfc: "\u{D679}",
        nfd: "\u{1112}\u{116B}\u{11B0}",
        nfkc: "\u{D679}",
        nfkd: "\u{1112}\u{116B}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D67A}",
        nfc: "\u{D67A}",
        nfd: "\u{1112}\u{116B}\u{11B1}",
        nfkc: "\u{D67A}",
        nfkd: "\u{1112}\u{116B}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D67B}",
        nfc: "\u{D67B}",
        nfd: "\u{1112}\u{116B}\u{11B2}",
        nfkc: "\u{D67B}",
        nfkd: "\u{1112}\u{116B}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D67C}",
        nfc: "\u{D67C}",
        nfd: "\u{1112}\u{116B}\u{11B3}",
        nfkc: "\u{D67C}",
        nfkd: "\u{1112}\u{116B}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D67D}",
        nfc: "\u{D67D}",
        nfd: "\u{1112}\u{116B}\u{11B4}",
        nfkc: "\u{D67D}",
        nfkd: "\u{1112}\u{116B}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D67E}",
        nfc: "\u{D67E}",
        nfd: "\u{1112}\u{116B}\u{11B5}",
        nfkc: "\u{D67E}",
        nfkd: "\u{1112}\u{116B}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D67F}",
        nfc: "\u{D67F}",
        nfd: "\u{1112}\u{116B}\u{11B6}",
        nfkc: "\u{D67F}",
        nfkd: "\u{1112}\u{116B}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D680}",
        nfc: "\u{D680}",
        nfd: "\u{1112}\u{116B}\u{11B7}",
        nfkc: "\u{D680}",
        nfkd: "\u{1112}\u{116B}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D681}",
        nfc: "\u{D681}",
        nfd: "\u{1112}\u{116B}\u{11B8}",
        nfkc: "\u{D681}",
        nfkd: "\u{1112}\u{116B}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D682}",
        nfc: "\u{D682}",
        nfd: "\u{1112}\u{116B}\u{11B9}",
        nfkc: "\u{D682}",
        nfkd: "\u{1112}\u{116B}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D683}",
        nfc: "\u{D683}",
        nfd: "\u{1112}\u{116B}\u{11BA}",
        nfkc: "\u{D683}",
        nfkd: "\u{1112}\u{116B}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D684}",
        nfc: "\u{D684}",
        nfd: "\u{1112}\u{116B}\u{11BB}",
        nfkc: "\u{D684}",
        nfkd: "\u{1112}\u{116B}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D685}",
        nfc: "\u{D685}",
        nfd: "\u{1112}\u{116B}\u{11BC}",
        nfkc: "\u{D685}",
        nfkd: "\u{1112}\u{116B}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D686}",
        nfc: "\u{D686}",
        nfd: "\u{1112}\u{116B}\u{11BD}",
        nfkc: "\u{D686}",
        nfkd: "\u{1112}\u{116B}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D687}",
        nfc: "\u{D687}",
        nfd: "\u{1112}\u{116B}\u{11BE}",
        nfkc: "\u{D687}",
        nfkd: "\u{1112}\u{116B}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D688}",
        nfc: "\u{D688}",
        nfd: "\u{1112}\u{116B}\u{11BF}",
        nfkc: "\u{D688}",
        nfkd: "\u{1112}\u{116B}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D689}",
        nfc: "\u{D689}",
        nfd: "\u{1112}\u{116B}\u{11C0}",
        nfkc: "\u{D689}",
        nfkd: "\u{1112}\u{116B}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D68A}",
        nfc: "\u{D68A}",
        nfd: "\u{1112}\u{116B}\u{11C1}",
        nfkc: "\u{D68A}",
        nfkd: "\u{1112}\u{116B}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D68B}",
        nfc: "\u{D68B}",
        nfd: "\u{1112}\u{116B}\u{11C2}",
        nfkc: "\u{D68B}",
        nfkd: "\u{1112}\u{116B}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D68C}",
        nfc: "\u{D68C}",
        nfd: "\u{1112}\u{116C}",
        nfkc: "\u{D68C}",
        nfkd: "\u{1112}\u{116C}",
    },
    NormalizationTest {
        source: "\u{D68D}",
        nfc: "\u{D68D}",
        nfd: "\u{1112}\u{116C}\u{11A8}",
        nfkc: "\u{D68D}",
        nfkd: "\u{1112}\u{116C}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D68E}",
        nfc: "\u{D68E}",
        nfd: "\u{1112}\u{116C}\u{11A9}",
        nfkc: "\u{D68E}",
        nfkd: "\u{1112}\u{116C}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D68F}",
        nfc: "\u{D68F}",
        nfd: "\u{1112}\u{116C}\u{11AA}",
        nfkc: "\u{D68F}",
        nfkd: "\u{1112}\u{116C}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D690}",
        nfc: "\u{D690}",
        nfd: "\u{1112}\u{116C}\u{11AB}",
        nfkc: "\u{D690}",
        nfkd: "\u{1112}\u{116C}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D691}",
        nfc: "\u{D691}",
        nfd: "\u{1112}\u{116C}\u{11AC}",
        nfkc: "\u{D691}",
        nfkd: "\u{1112}\u{116C}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D692}",
        nfc: "\u{D692}",
        nfd: "\u{1112}\u{116C}\u{11AD}",
        nfkc: "\u{D692}",
        nfkd: "\u{1112}\u{116C}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D693}",
        nfc: "\u{D693}",
        nfd: "\u{1112}\u{116C}\u{11AE}",
        nfkc: "\u{D693}",
        nfkd: "\u{1112}\u{116C}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D694}",
        nfc: "\u{D694}",
        nfd: "\u{1112}\u{116C}\u{11AF}",
        nfkc: "\u{D694}",
        nfkd: "\u{1112}\u{116C}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D695}",
        nfc: "\u{D695}",
        nfd: "\u{1112}\u{116C}\u{11B0}",
        nfkc: "\u{D695}",
        nfkd: "\u{1112}\u{116C}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D696}",
        nfc: "\u{D696}",
        nfd: "\u{1112}\u{116C}\u{11B1}",
        nfkc: "\u{D696}",
        nfkd: "\u{1112}\u{116C}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D697}",
        nfc: "\u{D697}",
        nfd: "\u{1112}\u{116C}\u{11B2}",
        nfkc: "\u{D697}",
        nfkd: "\u{1112}\u{116C}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D698}",
        nfc: "\u{D698}",
        nfd: "\u{1112}\u{116C}\u{11B3}",
        nfkc: "\u{D698}",
        nfkd: "\u{1112}\u{116C}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D699}",
        nfc: "\u{D699}",
        nfd: "\u{1112}\u{116C}\u{11B4}",
        nfkc: "\u{D699}",
        nfkd: "\u{1112}\u{116C}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D69A}",
        nfc: "\u{D69A}",
        nfd: "\u{1112}\u{116C}\u{11B5}",
        nfkc: "\u{D69A}",
        nfkd: "\u{1112}\u{116C}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D69B}",
        nfc: "\u{D69B}",
        nfd: "\u{1112}\u{116C}\u{11B6}",
        nfkc: "\u{D69B}",
        nfkd: "\u{1112}\u{116C}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D69C}",
        nfc: "\u{D69C}",
        nfd: "\u{1112}\u{116C}\u{11B7}",
        nfkc: "\u{D69C}",
        nfkd: "\u{1112}\u{116C}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D69D}",
        nfc: "\u{D69D}",
        nfd: "\u{1112}\u{116C}\u{11B8}",
        nfkc: "\u{D69D}",
        nfkd: "\u{1112}\u{116C}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D69E}",
        nfc: "\u{D69E}",
        nfd: "\u{1112}\u{116C}\u{11B9}",
        nfkc: "\u{D69E}",
        nfkd: "\u{1112}\u{116C}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D69F}",
        nfc: "\u{D69F}",
        nfd: "\u{1112}\u{116C}\u{11BA}",
        nfkc: "\u{D69F}",
        nfkd: "\u{1112}\u{116C}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D6A0}",
        nfc: "\u{D6A0}",
        nfd: "\u{1112}\u{116C}\u{11BB}",
        nfkc: "\u{D6A0}",
        nfkd: "\u{1112}\u{116C}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D6A1}",
        nfc: "\u{D6A1}",
        nfd: "\u{1112}\u{116C}\u{11BC}",
        nfkc: "\u{D6A1}",
        nfkd: "\u{1112}\u{116C}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D6A2}",
        nfc: "\u{D6A2}",
        nfd: "\u{1112}\u{116C}\u{11BD}",
        nfkc: "\u{D6A2}",
        nfkd: "\u{1112}\u{116C}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D6A3}",
        nfc: "\u{D6A3}",
        nfd: "\u{1112}\u{116C}\u{11BE}",
        nfkc: "\u{D6A3}",
        nfkd: "\u{1112}\u{116C}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D6A4}",
        nfc: "\u{D6A4}",
        nfd: "\u{1112}\u{116C}\u{11BF}",
        nfkc: "\u{D6A4}",
        nfkd: "\u{1112}\u{116C}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D6A5}",
        nfc: "\u{D6A5}",
        nfd: "\u{1112}\u{116C}\u{11C0}",
        nfkc: "\u{D6A5}",
        nfkd: "\u{1112}\u{116C}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D6A6}",
        nfc: "\u{D6A6}",
        nfd: "\u{1112}\u{116C}\u{11C1}",
        nfkc: "\u{D6A6}",
        nfkd: "\u{1112}\u{116C}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D6A7}",
        nfc: "\u{D6A7}",
        nfd: "\u{1112}\u{116C}\u{11C2}",
        nfkc: "\u{D6A7}",
        nfkd: "\u{1112}\u{116C}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D6A8}",
        nfc: "\u{D6A8}",
        nfd: "\u{1112}\u{116D}",
        nfkc: "\u{D6A8}",
        nfkd: "\u{1112}\u{116D}",
    },
    NormalizationTest {
        source: "\u{D6A9}",
        nfc: "\u{D6A9}",
        nfd: "\u{1112}\u{116D}\u{11A8}",
        nfkc: "\u{D6A9}",
        nfkd: "\u{1112}\u{116D}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D6AA}",
        nfc: "\u{D6AA}",
        nfd: "\u{1112}\u{116D}\u{11A9}",
        nfkc: "\u{D6AA}",
        nfkd: "\u{1112}\u{116D}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D6AB}",
        nfc: "\u{D6AB}",
        nfd: "\u{1112}\u{116D}\u{11AA}",
        nfkc: "\u{D6AB}",
        nfkd: "\u{1112}\u{116D}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D6AC}",
        nfc: "\u{D6AC}",
        nfd: "\u{1112}\u{116D}\u{11AB}",
        nfkc: "\u{D6AC}",
        nfkd: "\u{1112}\u{116D}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D6AD}",
        nfc: "\u{D6AD}",
        nfd: "\u{1112}\u{116D}\u{11AC}",
        nfkc: "\u{D6AD}",
        nfkd: "\u{1112}\u{116D}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D6AE}",
        nfc: "\u{D6AE}",
        nfd: "\u{1112}\u{116D}\u{11AD}",
        nfkc: "\u{D6AE}",
        nfkd: "\u{1112}\u{116D}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D6AF}",
        nfc: "\u{D6AF}",
        nfd: "\u{1112}\u{116D}\u{11AE}",
        nfkc: "\u{D6AF}",
        nfkd: "\u{1112}\u{116D}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D6B0}",
        nfc: "\u{D6B0}",
        nfd: "\u{1112}\u{116D}\u{11AF}",
        nfkc: "\u{D6B0}",
        nfkd: "\u{1112}\u{116D}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D6B1}",
        nfc: "\u{D6B1}",
        nfd: "\u{1112}\u{116D}\u{11B0}",
        nfkc: "\u{D6B1}",
        nfkd: "\u{1112}\u{116D}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D6B2}",
        nfc: "\u{D6B2}",
        nfd: "\u{1112}\u{116D}\u{11B1}",
        nfkc: "\u{D6B2}",
        nfkd: "\u{1112}\u{116D}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D6B3}",
        nfc: "\u{D6B3}",
        nfd: "\u{1112}\u{116D}\u{11B2}",
        nfkc: "\u{D6B3}",
        nfkd: "\u{1112}\u{116D}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D6B4}",
        nfc: "\u{D6B4}",
        nfd: "\u{1112}\u{116D}\u{11B3}",
        nfkc: "\u{D6B4}",
        nfkd: "\u{1112}\u{116D}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D6B5}",
        nfc: "\u{D6B5}",
        nfd: "\u{1112}\u{116D}\u{11B4}",
        nfkc: "\u{D6B5}",
        nfkd: "\u{1112}\u{116D}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D6B6}",
        nfc: "\u{D6B6}",
        nfd: "\u{1112}\u{116D}\u{11B5}",
        nfkc: "\u{D6B6}",
        nfkd: "\u{1112}\u{116D}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D6B7}",
        nfc: "\u{D6B7}",
        nfd: "\u{1112}\u{116D}\u{11B6}",
        nfkc: "\u{D6B7}",
        nfkd: "\u{1112}\u{116D}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D6B8}",
        nfc: "\u{D6B8}",
        nfd: "\u{1112}\u{116D}\u{11B7}",
        nfkc: "\u{D6B8}",
        nfkd: "\u{1112}\u{116D}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D6B9}",
        nfc: "\u{D6B9}",
        nfd: "\u{1112}\u{116D}\u{11B8}",
        nfkc: "\u{D6B9}",
        nfkd: "\u{1112}\u{116D}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D6BA}",
        nfc: "\u{D6BA}",
        nfd: "\u{1112}\u{116D}\u{11B9}",
        nfkc: "\u{D6BA}",
        nfkd: "\u{1112}\u{116D}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D6BB}",
        nfc: "\u{D6BB}",
        nfd: "\u{1112}\u{116D}\u{11BA}",
        nfkc: "\u{D6BB}",
        nfkd: "\u{1112}\u{116D}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D6BC}",
        nfc: "\u{D6BC}",
        nfd: "\u{1112}\u{116D}\u{11BB}",
        nfkc: "\u{D6BC}",
        nfkd: "\u{1112}\u{116D}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D6BD}",
        nfc: "\u{D6BD}",
        nfd: "\u{1112}\u{116D}\u{11BC}",
        nfkc: "\u{D6BD}",
        nfkd: "\u{1112}\u{116D}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D6BE}",
        nfc: "\u{D6BE}",
        nfd: "\u{1112}\u{116D}\u{11BD}",
        nfkc: "\u{D6BE}",
        nfkd: "\u{1112}\u{116D}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D6BF}",
        nfc: "\u{D6BF}",
        nfd: "\u{1112}\u{116D}\u{11BE}",
        nfkc: "\u{D6BF}",
        nfkd: "\u{1112}\u{116D}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D6C0}",
        nfc: "\u{D6C0}",
        nfd: "\u{1112}\u{116D}\u{11BF}",
        nfkc: "\u{D6C0}",
        nfkd: "\u{1112}\u{116D}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D6C1}",
        nfc: "\u{D6C1}",
        nfd: "\u{1112}\u{116D}\u{11C0}",
        nfkc: "\u{D6C1}",
        nfkd: "\u{1112}\u{116D}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D6C2}",
        nfc: "\u{D6C2}",
        nfd: "\u{1112}\u{116D}\u{11C1}",
        nfkc: "\u{D6C2}",
        nfkd: "\u{1112}\u{116D}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D6C3}",
        nfc: "\u{D6C3}",
        nfd: "\u{1112}\u{116D}\u{11C2}",
        nfkc: "\u{D6C3}",
        nfkd: "\u{1112}\u{116D}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D6C4}",
        nfc: "\u{D6C4}",
        nfd: "\u{1112}\u{116E}",
        nfkc: "\u{D6C4}",
        nfkd: "\u{1112}\u{116E}",
    },
    NormalizationTest {
        source: "\u{D6C5}",
        nfc: "\u{D6C5}",
        nfd: "\u{1112}\u{116E}\u{11A8}",
        nfkc: "\u{D6C5}",
        nfkd: "\u{1112}\u{116E}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D6C6}",
        nfc: "\u{D6C6}",
        nfd: "\u{1112}\u{116E}\u{11A9}",
        nfkc: "\u{D6C6}",
        nfkd: "\u{1112}\u{116E}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D6C7}",
        nfc: "\u{D6C7}",
        nfd: "\u{1112}\u{116E}\u{11AA}",
        nfkc: "\u{D6C7}",
        nfkd: "\u{1112}\u{116E}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D6C8}",
        nfc: "\u{D6C8}",
        nfd: "\u{1112}\u{116E}\u{11AB}",
        nfkc: "\u{D6C8}",
        nfkd: "\u{1112}\u{116E}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D6C9}",
        nfc: "\u{D6C9}",
        nfd: "\u{1112}\u{116E}\u{11AC}",
        nfkc: "\u{D6C9}",
        nfkd: "\u{1112}\u{116E}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D6CA}",
        nfc: "\u{D6CA}",
        nfd: "\u{1112}\u{116E}\u{11AD}",
        nfkc: "\u{D6CA}",
        nfkd: "\u{1112}\u{116E}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D6CB}",
        nfc: "\u{D6CB}",
        nfd: "\u{1112}\u{116E}\u{11AE}",
        nfkc: "\u{D6CB}",
        nfkd: "\u{1112}\u{116E}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D6CC}",
        nfc: "\u{D6CC}",
        nfd: "\u{1112}\u{116E}\u{11AF}",
        nfkc: "\u{D6CC}",
        nfkd: "\u{1112}\u{116E}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D6CD}",
        nfc: "\u{D6CD}",
        nfd: "\u{1112}\u{116E}\u{11B0}",
        nfkc: "\u{D6CD}",
        nfkd: "\u{1112}\u{116E}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D6CE}",
        nfc: "\u{D6CE}",
        nfd: "\u{1112}\u{116E}\u{11B1}",
        nfkc: "\u{D6CE}",
        nfkd: "\u{1112}\u{116E}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D6CF}",
        nfc: "\u{D6CF}",
        nfd: "\u{1112}\u{116E}\u{11B2}",
        nfkc: "\u{D6CF}",
        nfkd: "\u{1112}\u{116E}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D6D0}",
        nfc: "\u{D6D0}",
        nfd: "\u{1112}\u{116E}\u{11B3}",
        nfkc: "\u{D6D0}",
        nfkd: "\u{1112}\u{116E}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D6D1}",
        nfc: "\u{D6D1}",
        nfd: "\u{1112}\u{116E}\u{11B4}",
        nfkc: "\u{D6D1}",
        nfkd: "\u{1112}\u{116E}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D6D2}",
        nfc: "\u{D6D2}",
        nfd: "\u{1112}\u{116E}\u{11B5}",
        nfkc: "\u{D6D2}",
        nfkd: "\u{1112}\u{116E}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D6D3}",
        nfc: "\u{D6D3}",
        nfd: "\u{1112}\u{116E}\u{11B6}",
        nfkc: "\u{D6D3}",
        nfkd: "\u{1112}\u{116E}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D6D4}",
        nfc: "\u{D6D4}",
        nfd: "\u{1112}\u{116E}\u{11B7}",
        nfkc: "\u{D6D4}",
        nfkd: "\u{1112}\u{116E}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D6D5}",
        nfc: "\u{D6D5}",
        nfd: "\u{1112}\u{116E}\u{11B8}",
        nfkc: "\u{D6D5}",
        nfkd: "\u{1112}\u{116E}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D6D6}",
        nfc: "\u{D6D6}",
        nfd: "\u{1112}\u{116E}\u{11B9}",
        nfkc: "\u{D6D6}",
        nfkd: "\u{1112}\u{116E}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D6D7}",
        nfc: "\u{D6D7}",
        nfd: "\u{1112}\u{116E}\u{11BA}",
        nfkc: "\u{D6D7}",
        nfkd: "\u{1112}\u{116E}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D6D8}",
        nfc: "\u{D6D8}",
        nfd: "\u{1112}\u{116E}\u{11BB}",
        nfkc: "\u{D6D8}",
        nfkd: "\u{1112}\u{116E}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D6D9}",
        nfc: "\u{D6D9}",
        nfd: "\u{1112}\u{116E}\u{11BC}",
        nfkc: "\u{D6D9}",
        nfkd: "\u{1112}\u{116E}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D6DA}",
        nfc: "\u{D6DA}",
        nfd: "\u{1112}\u{116E}\u{11BD}",
        nfkc: "\u{D6DA}",
        nfkd: "\u{1112}\u{116E}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D6DB}",
        nfc: "\u{D6DB}",
        nfd: "\u{1112}\u{116E}\u{11BE}",
        nfkc: "\u{D6DB}",
        nfkd: "\u{1112}\u{116E}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D6DC}",
        nfc: "\u{D6DC}",
        nfd: "\u{1112}\u{116E}\u{11BF}",
        nfkc: "\u{D6DC}",
        nfkd: "\u{1112}\u{116E}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D6DD}",
        nfc: "\u{D6DD}",
        nfd: "\u{1112}\u{116E}\u{11C0}",
        nfkc: "\u{D6DD}",
        nfkd: "\u{1112}\u{116E}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D6DE}",
        nfc: "\u{D6DE}",
        nfd: "\u{1112}\u{116E}\u{11C1}",
        nfkc: "\u{D6DE}",
        nfkd: "\u{1112}\u{116E}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D6DF}",
        nfc: "\u{D6DF}",
        nfd: "\u{1112}\u{116E}\u{11C2}",
        nfkc: "\u{D6DF}",
        nfkd: "\u{1112}\u{116E}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D6E0}",
        nfc: "\u{D6E0}",
        nfd: "\u{1112}\u{116F}",
        nfkc: "\u{D6E0}",
        nfkd: "\u{1112}\u{116F}",
    },
    NormalizationTest {
        source: "\u{D6E1}",
        nfc: "\u{D6E1}",
        nfd: "\u{1112}\u{116F}\u{11A8}",
        nfkc: "\u{D6E1}",
        nfkd: "\u{1112}\u{116F}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D6E2}",
        nfc: "\u{D6E2}",
        nfd: "\u{1112}\u{116F}\u{11A9}",
        nfkc: "\u{D6E2}",
        nfkd: "\u{1112}\u{116F}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D6E3}",
        nfc: "\u{D6E3}",
        nfd: "\u{1112}\u{116F}\u{11AA}",
        nfkc: "\u{D6E3}",
        nfkd: "\u{1112}\u{116F}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D6E4}",
        nfc: "\u{D6E4}",
        nfd: "\u{1112}\u{116F}\u{11AB}",
        nfkc: "\u{D6E4}",
        nfkd: "\u{1112}\u{116F}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D6E5}",
        nfc: "\u{D6E5}",
        nfd: "\u{1112}\u{116F}\u{11AC}",
        nfkc: "\u{D6E5}",
        nfkd: "\u{1112}\u{116F}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D6E6}",
        nfc: "\u{D6E6}",
        nfd: "\u{1112}\u{116F}\u{11AD}",
        nfkc: "\u{D6E6}",
        nfkd: "\u{1112}\u{116F}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D6E7}",
        nfc: "\u{D6E7}",
        nfd: "\u{1112}\u{116F}\u{11AE}",
        nfkc: "\u{D6E7}",
        nfkd: "\u{1112}\u{116F}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D6E8}",
        nfc: "\u{D6E8}",
        nfd: "\u{1112}\u{116F}\u{11AF}",
        nfkc: "\u{D6E8}",
        nfkd: "\u{1112}\u{116F}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D6E9}",
        nfc: "\u{D6E9}",
        nfd: "\u{1112}\u{116F}\u{11B0}",
        nfkc: "\u{D6E9}",
        nfkd: "\u{1112}\u{116F}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D6EA}",
        nfc: "\u{D6EA}",
        nfd: "\u{1112}\u{116F}\u{11B1}",
        nfkc: "\u{D6EA}",
        nfkd: "\u{1112}\u{116F}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D6EB}",
        nfc: "\u{D6EB}",
        nfd: "\u{1112}\u{116F}\u{11B2}",
        nfkc: "\u{D6EB}",
        nfkd: "\u{1112}\u{116F}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D6EC}",
        nfc: "\u{D6EC}",
        nfd: "\u{1112}\u{116F}\u{11B3}",
        nfkc: "\u{D6EC}",
        nfkd: "\u{1112}\u{116F}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D6ED}",
        nfc: "\u{D6ED}",
        nfd: "\u{1112}\u{116F}\u{11B4}",
        nfkc: "\u{D6ED}",
        nfkd: "\u{1112}\u{116F}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D6EE}",
        nfc: "\u{D6EE}",
        nfd: "\u{1112}\u{116F}\u{11B5}",
        nfkc: "\u{D6EE}",
        nfkd: "\u{1112}\u{116F}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D6EF}",
        nfc: "\u{D6EF}",
        nfd: "\u{1112}\u{116F}\u{11B6}",
        nfkc: "\u{D6EF}",
        nfkd: "\u{1112}\u{116F}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D6F0}",
        nfc: "\u{D6F0}",
        nfd: "\u{1112}\u{116F}\u{11B7}",
        nfkc: "\u{D6F0}",
        nfkd: "\u{1112}\u{116F}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D6F1}",
        nfc: "\u{D6F1}",
        nfd: "\u{1112}\u{116F}\u{11B8}",
        nfkc: "\u{D6F1}",
        nfkd: "\u{1112}\u{116F}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D6F2}",
        nfc: "\u{D6F2}",
        nfd: "\u{1112}\u{116F}\u{11B9}",
        nfkc: "\u{D6F2}",
        nfkd: "\u{1112}\u{116F}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D6F3}",
        nfc: "\u{D6F3}",
        nfd: "\u{1112}\u{116F}\u{11BA}",
        nfkc: "\u{D6F3}",
        nfkd: "\u{1112}\u{116F}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D6F4}",
        nfc: "\u{D6F4}",
        nfd: "\u{1112}\u{116F}\u{11BB}",
        nfkc: "\u{D6F4}",
        nfkd: "\u{1112}\u{116F}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D6F5}",
        nfc: "\u{D6F5}",
        nfd: "\u{1112}\u{116F}\u{11BC}",
        nfkc: "\u{D6F5}",
        nfkd: "\u{1112}\u{116F}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D6F6}",
        nfc: "\u{D6F6}",
        nfd: "\u{1112}\u{116F}\u{11BD}",
        nfkc: "\u{D6F6}",
        nfkd: "\u{1112}\u{116F}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D6F7}",
        nfc: "\u{D6F7}",
        nfd: "\u{1112}\u{116F}\u{11BE}",
        nfkc: "\u{D6F7}",
        nfkd: "\u{1112}\u{116F}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D6F8}",
        nfc: "\u{D6F8}",
        nfd: "\u{1112}\u{116F}\u{11BF}",
        nfkc: "\u{D6F8}",
        nfkd: "\u{1112}\u{116F}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D6F9}",
        nfc: "\u{D6F9}",
        nfd: "\u{1112}\u{116F}\u{11C0}",
        nfkc: "\u{D6F9}",
        nfkd: "\u{1112}\u{116F}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D6FA}",
        nfc: "\u{D6FA}",
        nfd: "\u{1112}\u{116F}\u{11C1}",
        nfkc: "\u{D6FA}",
        nfkd: "\u{1112}\u{116F}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D6FB}",
        nfc: "\u{D6FB}",
        nfd: "\u{1112}\u{116F}\u{11C2}",
        nfkc: "\u{D6FB}",
        nfkd: "\u{1112}\u{116F}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D6FC}",
        nfc: "\u{D6FC}",
        nfd: "\u{1112}\u{1170}",
        nfkc: "\u{D6FC}",
        nfkd: "\u{1112}\u{1170}",
    },
    NormalizationTest {
        source: "\u{D6FD}",
        nfc: "\u{D6FD}",
        nfd: "\u{1112}\u{1170}\u{11A8}",
        nfkc: "\u{D6FD}",
        nfkd: "\u{1112}\u{1170}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D6FE}",
        nfc: "\u{D6FE}",
        nfd: "\u{1112}\u{1170}\u{11A9}",
        nfkc: "\u{D6FE}",
        nfkd: "\u{1112}\u{1170}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D6FF}",
        nfc: "\u{D6FF}",
        nfd: "\u{1112}\u{1170}\u{11AA}",
        nfkc: "\u{D6FF}",
        nfkd: "\u{1112}\u{1170}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D700}",
        nfc: "\u{D700}",
        nfd: "\u{1112}\u{1170}\u{11AB}",
        nfkc: "\u{D700}",
        nfkd: "\u{1112}\u{1170}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D701}",
        nfc: "\u{D701}",
        nfd: "\u{1112}\u{1170}\u{11AC}",
        nfkc: "\u{D701}",
        nfkd: "\u{1112}\u{1170}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D702}",
        nfc: "\u{D702}",
        nfd: "\u{1112}\u{1170}\u{11AD}",
        nfkc: "\u{D702}",
        nfkd: "\u{1112}\u{1170}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D703}",
        nfc: "\u{D703}",
        nfd: "\u{1112}\u{1170}\u{11AE}",
        nfkc: "\u{D703}",
        nfkd: "\u{1112}\u{1170}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D704}",
        nfc: "\u{D704}",
        nfd: "\u{1112}\u{1170}\u{11AF}",
        nfkc: "\u{D704}",
        nfkd: "\u{1112}\u{1170}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D705}",
        nfc: "\u{D705}",
        nfd: "\u{1112}\u{1170}\u{11B0}",
        nfkc: "\u{D705}",
        nfkd: "\u{1112}\u{1170}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D706}",
        nfc: "\u{D706}",
        nfd: "\u{1112}\u{1170}\u{11B1}",
        nfkc: "\u{D706}",
        nfkd: "\u{1112}\u{1170}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D707}",
        nfc: "\u{D707}",
        nfd: "\u{1112}\u{1170}\u{11B2}",
        nfkc: "\u{D707}",
        nfkd: "\u{1112}\u{1170}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D708}",
        nfc: "\u{D708}",
        nfd: "\u{1112}\u{1170}\u{11B3}",
        nfkc: "\u{D708}",
        nfkd: "\u{1112}\u{1170}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D709}",
        nfc: "\u{D709}",
        nfd: "\u{1112}\u{1170}\u{11B4}",
        nfkc: "\u{D709}",
        nfkd: "\u{1112}\u{1170}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D70A}",
        nfc: "\u{D70A}",
        nfd: "\u{1112}\u{1170}\u{11B5}",
        nfkc: "\u{D70A}",
        nfkd: "\u{1112}\u{1170}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D70B}",
        nfc: "\u{D70B}",
        nfd: "\u{1112}\u{1170}\u{11B6}",
        nfkc: "\u{D70B}",
        nfkd: "\u{1112}\u{1170}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D70C}",
        nfc: "\u{D70C}",
        nfd: "\u{1112}\u{1170}\u{11B7}",
        nfkc: "\u{D70C}",
        nfkd: "\u{1112}\u{1170}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D70D}",
        nfc: "\u{D70D}",
        nfd: "\u{1112}\u{1170}\u{11B8}",
        nfkc: "\u{D70D}",
        nfkd: "\u{1112}\u{1170}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D70E}",
        nfc: "\u{D70E}",
        nfd: "\u{1112}\u{1170}\u{11B9}",
        nfkc: "\u{D70E}",
        nfkd: "\u{1112}\u{1170}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D70F}",
        nfc: "\u{D70F}",
        nfd: "\u{1112}\u{1170}\u{11BA}",
        nfkc: "\u{D70F}",
        nfkd: "\u{1112}\u{1170}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D710}",
        nfc: "\u{D710}",
        nfd: "\u{1112}\u{1170}\u{11BB}",
        nfkc: "\u{D710}",
        nfkd: "\u{1112}\u{1170}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D711}",
        nfc: "\u{D711}",
        nfd: "\u{1112}\u{1170}\u{11BC}",
        nfkc: "\u{D711}",
        nfkd: "\u{1112}\u{1170}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D712}",
        nfc: "\u{D712}",
        nfd: "\u{1112}\u{1170}\u{11BD}",
        nfkc: "\u{D712}",
        nfkd: "\u{1112}\u{1170}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D713}",
        nfc: "\u{D713}",
        nfd: "\u{1112}\u{1170}\u{11BE}",
        nfkc: "\u{D713}",
        nfkd: "\u{1112}\u{1170}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D714}",
        nfc: "\u{D714}",
        nfd: "\u{1112}\u{1170}\u{11BF}",
        nfkc: "\u{D714}",
        nfkd: "\u{1112}\u{1170}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D715}",
        nfc: "\u{D715}",
        nfd: "\u{1112}\u{1170}\u{11C0}",
        nfkc: "\u{D715}",
        nfkd: "\u{1112}\u{1170}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D716}",
        nfc: "\u{D716}",
        nfd: "\u{1112}\u{1170}\u{11C1}",
        nfkc: "\u{D716}",
        nfkd: "\u{1112}\u{1170}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D717}",
        nfc: "\u{D717}",
        nfd: "\u{1112}\u{1170}\u{11C2}",
        nfkc: "\u{D717}",
        nfkd: "\u{1112}\u{1170}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D718}",
        nfc: "\u{D718}",
        nfd: "\u{1112}\u{1171}",
        nfkc: "\u{D718}",
        nfkd: "\u{1112}\u{1171}",
    },
    NormalizationTest {
        source: "\u{D719}",
        nfc: "\u{D719}",
        nfd: "\u{1112}\u{1171}\u{11A8}",
        nfkc: "\u{D719}",
        nfkd: "\u{1112}\u{1171}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D71A}",
        nfc: "\u{D71A}",
        nfd: "\u{1112}\u{1171}\u{11A9}",
        nfkc: "\u{D71A}",
        nfkd: "\u{1112}\u{1171}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D71B}",
        nfc: "\u{D71B}",
        nfd: "\u{1112}\u{1171}\u{11AA}",
        nfkc: "\u{D71B}",
        nfkd: "\u{1112}\u{1171}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D71C}",
        nfc: "\u{D71C}",
        nfd: "\u{1112}\u{1171}\u{11AB}",
        nfkc: "\u{D71C}",
        nfkd: "\u{1112}\u{1171}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D71D}",
        nfc: "\u{D71D}",
        nfd: "\u{1112}\u{1171}\u{11AC}",
        nfkc: "\u{D71D}",
        nfkd: "\u{1112}\u{1171}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D71E}",
        nfc: "\u{D71E}",
        nfd: "\u{1112}\u{1171}\u{11AD}",
        nfkc: "\u{D71E}",
        nfkd: "\u{1112}\u{1171}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D71F}",
        nfc: "\u{D71F}",
        nfd: "\u{1112}\u{1171}\u{11AE}",
        nfkc: "\u{D71F}",
        nfkd: "\u{1112}\u{1171}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D720}",
        nfc: "\u{D720}",
        nfd: "\u{1112}\u{1171}\u{11AF}",
        nfkc: "\u{D720}",
        nfkd: "\u{1112}\u{1171}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D721}",
        nfc: "\u{D721}",
        nfd: "\u{1112}\u{1171}\u{11B0}",
        nfkc: "\u{D721}",
        nfkd: "\u{1112}\u{1171}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D722}",
        nfc: "\u{D722}",
        nfd: "\u{1112}\u{1171}\u{11B1}",
        nfkc: "\u{D722}",
        nfkd: "\u{1112}\u{1171}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D723}",
        nfc: "\u{D723}",
        nfd: "\u{1112}\u{1171}\u{11B2}",
        nfkc: "\u{D723}",
        nfkd: "\u{1112}\u{1171}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D724}",
        nfc: "\u{D724}",
        nfd: "\u{1112}\u{1171}\u{11B3}",
        nfkc: "\u{D724}",
        nfkd: "\u{1112}\u{1171}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D725}",
        nfc: "\u{D725}",
        nfd: "\u{1112}\u{1171}\u{11B4}",
        nfkc: "\u{D725}",
        nfkd: "\u{1112}\u{1171}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D726}",
        nfc: "\u{D726}",
        nfd: "\u{1112}\u{1171}\u{11B5}",
        nfkc: "\u{D726}",
        nfkd: "\u{1112}\u{1171}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D727}",
        nfc: "\u{D727}",
        nfd: "\u{1112}\u{1171}\u{11B6}",
        nfkc: "\u{D727}",
        nfkd: "\u{1112}\u{1171}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D728}",
        nfc: "\u{D728}",
        nfd: "\u{1112}\u{1171}\u{11B7}",
        nfkc: "\u{D728}",
        nfkd: "\u{1112}\u{1171}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D729}",
        nfc: "\u{D729}",
        nfd: "\u{1112}\u{1171}\u{11B8}",
        nfkc: "\u{D729}",
        nfkd: "\u{1112}\u{1171}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D72A}",
        nfc: "\u{D72A}",
        nfd: "\u{1112}\u{1171}\u{11B9}",
        nfkc: "\u{D72A}",
        nfkd: "\u{1112}\u{1171}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D72B}",
        nfc: "\u{D72B}",
        nfd: "\u{1112}\u{1171}\u{11BA}",
        nfkc: "\u{D72B}",
        nfkd: "\u{1112}\u{1171}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D72C}",
        nfc: "\u{D72C}",
        nfd: "\u{1112}\u{1171}\u{11BB}",
        nfkc: "\u{D72C}",
        nfkd: "\u{1112}\u{1171}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D72D}",
        nfc: "\u{D72D}",
        nfd: "\u{1112}\u{1171}\u{11BC}",
        nfkc: "\u{D72D}",
        nfkd: "\u{1112}\u{1171}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D72E}",
        nfc: "\u{D72E}",
        nfd: "\u{1112}\u{1171}\u{11BD}",
        nfkc: "\u{D72E}",
        nfkd: "\u{1112}\u{1171}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D72F}",
        nfc: "\u{D72F}",
        nfd: "\u{1112}\u{1171}\u{11BE}",
        nfkc: "\u{D72F}",
        nfkd: "\u{1112}\u{1171}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D730}",
        nfc: "\u{D730}",
        nfd: "\u{1112}\u{1171}\u{11BF}",
        nfkc: "\u{D730}",
        nfkd: "\u{1112}\u{1171}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D731}",
        nfc: "\u{D731}",
        nfd: "\u{1112}\u{1171}\u{11C0}",
        nfkc: "\u{D731}",
        nfkd: "\u{1112}\u{1171}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D732}",
        nfc: "\u{D732}",
        nfd: "\u{1112}\u{1171}\u{11C1}",
        nfkc: "\u{D732}",
        nfkd: "\u{1112}\u{1171}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D733}",
        nfc: "\u{D733}",
        nfd: "\u{1112}\u{1171}\u{11C2}",
        nfkc: "\u{D733}",
        nfkd: "\u{1112}\u{1171}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D734}",
        nfc: "\u{D734}",
        nfd: "\u{1112}\u{1172}",
        nfkc: "\u{D734}",
        nfkd: "\u{1112}\u{1172}",
    },
    NormalizationTest {
        source: "\u{D735}",
        nfc: "\u{D735}",
        nfd: "\u{1112}\u{1172}\u{11A8}",
        nfkc: "\u{D735}",
        nfkd: "\u{1112}\u{1172}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D736}",
        nfc: "\u{D736}",
        nfd: "\u{1112}\u{1172}\u{11A9}",
        nfkc: "\u{D736}",
        nfkd: "\u{1112}\u{1172}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D737}",
        nfc: "\u{D737}",
        nfd: "\u{1112}\u{1172}\u{11AA}",
        nfkc: "\u{D737}",
        nfkd: "\u{1112}\u{1172}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D738}",
        nfc: "\u{D738}",
        nfd: "\u{1112}\u{1172}\u{11AB}",
        nfkc: "\u{D738}",
        nfkd: "\u{1112}\u{1172}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D739}",
        nfc: "\u{D739}",
        nfd: "\u{1112}\u{1172}\u{11AC}",
        nfkc: "\u{D739}",
        nfkd: "\u{1112}\u{1172}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D73A}",
        nfc: "\u{D73A}",
        nfd: "\u{1112}\u{1172}\u{11AD}",
        nfkc: "\u{D73A}",
        nfkd: "\u{1112}\u{1172}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D73B}",
        nfc: "\u{D73B}",
        nfd: "\u{1112}\u{1172}\u{11AE}",
        nfkc: "\u{D73B}",
        nfkd: "\u{1112}\u{1172}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D73C}",
        nfc: "\u{D73C}",
        nfd: "\u{1112}\u{1172}\u{11AF}",
        nfkc: "\u{D73C}",
        nfkd: "\u{1112}\u{1172}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D73D}",
        nfc: "\u{D73D}",
        nfd: "\u{1112}\u{1172}\u{11B0}",
        nfkc: "\u{D73D}",
        nfkd: "\u{1112}\u{1172}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D73E}",
        nfc: "\u{D73E}",
        nfd: "\u{1112}\u{1172}\u{11B1}",
        nfkc: "\u{D73E}",
        nfkd: "\u{1112}\u{1172}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D73F}",
        nfc: "\u{D73F}",
        nfd: "\u{1112}\u{1172}\u{11B2}",
        nfkc: "\u{D73F}",
        nfkd: "\u{1112}\u{1172}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D740}",
        nfc: "\u{D740}",
        nfd: "\u{1112}\u{1172}\u{11B3}",
        nfkc: "\u{D740}",
        nfkd: "\u{1112}\u{1172}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D741}",
        nfc: "\u{D741}",
        nfd: "\u{1112}\u{1172}\u{11B4}",
        nfkc: "\u{D741}",
        nfkd: "\u{1112}\u{1172}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D742}",
        nfc: "\u{D742}",
        nfd: "\u{1112}\u{1172}\u{11B5}",
        nfkc: "\u{D742}",
        nfkd: "\u{1112}\u{1172}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D743}",
        nfc: "\u{D743}",
        nfd: "\u{1112}\u{1172}\u{11B6}",
        nfkc: "\u{D743}",
        nfkd: "\u{1112}\u{1172}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D744}",
        nfc: "\u{D744}",
        nfd: "\u{1112}\u{1172}\u{11B7}",
        nfkc: "\u{D744}",
        nfkd: "\u{1112}\u{1172}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D745}",
        nfc: "\u{D745}",
        nfd: "\u{1112}\u{1172}\u{11B8}",
        nfkc: "\u{D745}",
        nfkd: "\u{1112}\u{1172}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D746}",
        nfc: "\u{D746}",
        nfd: "\u{1112}\u{1172}\u{11B9}",
        nfkc: "\u{D746}",
        nfkd: "\u{1112}\u{1172}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D747}",
        nfc: "\u{D747}",
        nfd: "\u{1112}\u{1172}\u{11BA}",
        nfkc: "\u{D747}",
        nfkd: "\u{1112}\u{1172}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D748}",
        nfc: "\u{D748}",
        nfd: "\u{1112}\u{1172}\u{11BB}",
        nfkc: "\u{D748}",
        nfkd: "\u{1112}\u{1172}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D749}",
        nfc: "\u{D749}",
        nfd: "\u{1112}\u{1172}\u{11BC}",
        nfkc: "\u{D749}",
        nfkd: "\u{1112}\u{1172}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D74A}",
        nfc: "\u{D74A}",
        nfd: "\u{1112}\u{1172}\u{11BD}",
        nfkc: "\u{D74A}",
        nfkd: "\u{1112}\u{1172}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D74B}",
        nfc: "\u{D74B}",
        nfd: "\u{1112}\u{1172}\u{11BE}",
        nfkc: "\u{D74B}",
        nfkd: "\u{1112}\u{1172}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D74C}",
        nfc: "\u{D74C}",
        nfd: "\u{1112}\u{1172}\u{11BF}",
        nfkc: "\u{D74C}",
        nfkd: "\u{1112}\u{1172}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D74D}",
        nfc: "\u{D74D}",
        nfd: "\u{1112}\u{1172}\u{11C0}",
        nfkc: "\u{D74D}",
        nfkd: "\u{1112}\u{1172}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D74E}",
        nfc: "\u{D74E}",
        nfd: "\u{1112}\u{1172}\u{11C1}",
        nfkc: "\u{D74E}",
        nfkd: "\u{1112}\u{1172}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D74F}",
        nfc: "\u{D74F}",
        nfd: "\u{1112}\u{1172}\u{11C2}",
        nfkc: "\u{D74F}",
        nfkd: "\u{1112}\u{1172}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D750}",
        nfc: "\u{D750}",
        nfd: "\u{1112}\u{1173}",
        nfkc: "\u{D750}",
        nfkd: "\u{1112}\u{1173}",
    },
    NormalizationTest {
        source: "\u{D751}",
        nfc: "\u{D751}",
        nfd: "\u{1112}\u{1173}\u{11A8}",
        nfkc: "\u{D751}",
        nfkd: "\u{1112}\u{1173}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D752}",
        nfc: "\u{D752}",
        nfd: "\u{1112}\u{1173}\u{11A9}",
        nfkc: "\u{D752}",
        nfkd: "\u{1112}\u{1173}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D753}",
        nfc: "\u{D753}",
        nfd: "\u{1112}\u{1173}\u{11AA}",
        nfkc: "\u{D753}",
        nfkd: "\u{1112}\u{1173}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D754}",
        nfc: "\u{D754}",
        nfd: "\u{1112}\u{1173}\u{11AB}",
        nfkc: "\u{D754}",
        nfkd: "\u{1112}\u{1173}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D755}",
        nfc: "\u{D755}",
        nfd: "\u{1112}\u{1173}\u{11AC}",
        nfkc: "\u{D755}",
        nfkd: "\u{1112}\u{1173}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D756}",
        nfc: "\u{D756}",
        nfd: "\u{1112}\u{1173}\u{11AD}",
        nfkc: "\u{D756}",
        nfkd: "\u{1112}\u{1173}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D757}",
        nfc: "\u{D757}",
        nfd: "\u{1112}\u{1173}\u{11AE}",
        nfkc: "\u{D757}",
        nfkd: "\u{1112}\u{1173}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D758}",
        nfc: "\u{D758}",
        nfd: "\u{1112}\u{1173}\u{11AF}",
        nfkc: "\u{D758}",
        nfkd: "\u{1112}\u{1173}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D759}",
        nfc: "\u{D759}",
        nfd: "\u{1112}\u{1173}\u{11B0}",
        nfkc: "\u{D759}",
        nfkd: "\u{1112}\u{1173}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D75A}",
        nfc: "\u{D75A}",
        nfd: "\u{1112}\u{1173}\u{11B1}",
        nfkc: "\u{D75A}",
        nfkd: "\u{1112}\u{1173}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D75B}",
        nfc: "\u{D75B}",
        nfd: "\u{1112}\u{1173}\u{11B2}",
        nfkc: "\u{D75B}",
        nfkd: "\u{1112}\u{1173}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D75C}",
        nfc: "\u{D75C}",
        nfd: "\u{1112}\u{1173}\u{11B3}",
        nfkc: "\u{D75C}",
        nfkd: "\u{1112}\u{1173}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D75D}",
        nfc: "\u{D75D}",
        nfd: "\u{1112}\u{1173}\u{11B4}",
        nfkc: "\u{D75D}",
        nfkd: "\u{1112}\u{1173}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D75E}",
        nfc: "\u{D75E}",
        nfd: "\u{1112}\u{1173}\u{11B5}",
        nfkc: "\u{D75E}",
        nfkd: "\u{1112}\u{1173}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D75F}",
        nfc: "\u{D75F}",
        nfd: "\u{1112}\u{1173}\u{11B6}",
        nfkc: "\u{D75F}",
        nfkd: "\u{1112}\u{1173}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D760}",
        nfc: "\u{D760}",
        nfd: "\u{1112}\u{1173}\u{11B7}",
        nfkc: "\u{D760}",
        nfkd: "\u{1112}\u{1173}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D761}",
        nfc: "\u{D761}",
        nfd: "\u{1112}\u{1173}\u{11B8}",
        nfkc: "\u{D761}",
        nfkd: "\u{1112}\u{1173}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D762}",
        nfc: "\u{D762}",
        nfd: "\u{1112}\u{1173}\u{11B9}",
        nfkc: "\u{D762}",
        nfkd: "\u{1112}\u{1173}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D763}",
        nfc: "\u{D763}",
        nfd: "\u{1112}\u{1173}\u{11BA}",
        nfkc: "\u{D763}",
        nfkd: "\u{1112}\u{1173}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D764}",
        nfc: "\u{D764}",
        nfd: "\u{1112}\u{1173}\u{11BB}",
        nfkc: "\u{D764}",
        nfkd: "\u{1112}\u{1173}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D765}",
        nfc: "\u{D765}",
        nfd: "\u{1112}\u{1173}\u{11BC}",
        nfkc: "\u{D765}",
        nfkd: "\u{1112}\u{1173}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D766}",
        nfc: "\u{D766}",
        nfd: "\u{1112}\u{1173}\u{11BD}",
        nfkc: "\u{D766}",
        nfkd: "\u{1112}\u{1173}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D767}",
        nfc: "\u{D767}",
        nfd: "\u{1112}\u{1173}\u{11BE}",
        nfkc: "\u{D767}",
        nfkd: "\u{1112}\u{1173}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D768}",
        nfc: "\u{D768}",
        nfd: "\u{1112}\u{1173}\u{11BF}",
        nfkc: "\u{D768}",
        nfkd: "\u{1112}\u{1173}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D769}",
        nfc: "\u{D769}",
        nfd: "\u{1112}\u{1173}\u{11C0}",
        nfkc: "\u{D769}",
        nfkd: "\u{1112}\u{1173}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D76A}",
        nfc: "\u{D76A}",
        nfd: "\u{1112}\u{1173}\u{11C1}",
        nfkc: "\u{D76A}",
        nfkd: "\u{1112}\u{1173}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D76B}",
        nfc: "\u{D76B}",
        nfd: "\u{1112}\u{1173}\u{11C2}",
        nfkc: "\u{D76B}",
        nfkd: "\u{1112}\u{1173}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D76C}",
        nfc: "\u{D76C}",
        nfd: "\u{1112}\u{1174}",
        nfkc: "\u{D76C}",
        nfkd: "\u{1112}\u{1174}",
    },
    NormalizationTest {
        source: "\u{D76D}",
        nfc: "\u{D76D}",
        nfd: "\u{1112}\u{1174}\u{11A8}",
        nfkc: "\u{D76D}",
        nfkd: "\u{1112}\u{1174}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D76E}",
        nfc: "\u{D76E}",
        nfd: "\u{1112}\u{1174}\u{11A9}",
        nfkc: "\u{D76E}",
        nfkd: "\u{1112}\u{1174}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D76F}",
        nfc: "\u{D76F}",
        nfd: "\u{1112}\u{1174}\u{11AA}",
        nfkc: "\u{D76F}",
        nfkd: "\u{1112}\u{1174}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D770}",
        nfc: "\u{D770}",
        nfd: "\u{1112}\u{1174}\u{11AB}",
        nfkc: "\u{D770}",
        nfkd: "\u{1112}\u{1174}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D771}",
        nfc: "\u{D771}",
        nfd: "\u{1112}\u{1174}\u{11AC}",
        nfkc: "\u{D771}",
        nfkd: "\u{1112}\u{1174}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D772}",
        nfc: "\u{D772}",
        nfd: "\u{1112}\u{1174}\u{11AD}",
        nfkc: "\u{D772}",
        nfkd: "\u{1112}\u{1174}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D773}",
        nfc: "\u{D773}",
        nfd: "\u{1112}\u{1174}\u{11AE}",
        nfkc: "\u{D773}",
        nfkd: "\u{1112}\u{1174}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D774}",
        nfc: "\u{D774}",
        nfd: "\u{1112}\u{1174}\u{11AF}",
        nfkc: "\u{D774}",
        nfkd: "\u{1112}\u{1174}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D775}",
        nfc: "\u{D775}",
        nfd: "\u{1112}\u{1174}\u{11B0}",
        nfkc: "\u{D775}",
        nfkd: "\u{1112}\u{1174}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D776}",
        nfc: "\u{D776}",
        nfd: "\u{1112}\u{1174}\u{11B1}",
        nfkc: "\u{D776}",
        nfkd: "\u{1112}\u{1174}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D777}",
        nfc: "\u{D777}",
        nfd: "\u{1112}\u{1174}\u{11B2}",
        nfkc: "\u{D777}",
        nfkd: "\u{1112}\u{1174}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D778}",
        nfc: "\u{D778}",
        nfd: "\u{1112}\u{1174}\u{11B3}",
        nfkc: "\u{D778}",
        nfkd: "\u{1112}\u{1174}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D779}",
        nfc: "\u{D779}",
        nfd: "\u{1112}\u{1174}\u{11B4}",
        nfkc: "\u{D779}",
        nfkd: "\u{1112}\u{1174}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D77A}",
        nfc: "\u{D77A}",
        nfd: "\u{1112}\u{1174}\u{11B5}",
        nfkc: "\u{D77A}",
        nfkd: "\u{1112}\u{1174}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D77B}",
        nfc: "\u{D77B}",
        nfd: "\u{1112}\u{1174}\u{11B6}",
        nfkc: "\u{D77B}",
        nfkd: "\u{1112}\u{1174}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D77C}",
        nfc: "\u{D77C}",
        nfd: "\u{1112}\u{1174}\u{11B7}",
        nfkc: "\u{D77C}",
        nfkd: "\u{1112}\u{1174}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D77D}",
        nfc: "\u{D77D}",
        nfd: "\u{1112}\u{1174}\u{11B8}",
        nfkc: "\u{D77D}",
        nfkd: "\u{1112}\u{1174}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D77E}",
        nfc: "\u{D77E}",
        nfd: "\u{1112}\u{1174}\u{11B9}",
        nfkc: "\u{D77E}",
        nfkd: "\u{1112}\u{1174}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D77F}",
        nfc: "\u{D77F}",
        nfd: "\u{1112}\u{1174}\u{11BA}",
        nfkc: "\u{D77F}",
        nfkd: "\u{1112}\u{1174}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D780}",
        nfc: "\u{D780}",
        nfd: "\u{1112}\u{1174}\u{11BB}",
        nfkc: "\u{D780}",
        nfkd: "\u{1112}\u{1174}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D781}",
        nfc: "\u{D781}",
        nfd: "\u{1112}\u{1174}\u{11BC}",
        nfkc: "\u{D781}",
        nfkd: "\u{1112}\u{1174}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D782}",
        nfc: "\u{D782}",
        nfd: "\u{1112}\u{1174}\u{11BD}",
        nfkc: "\u{D782}",
        nfkd: "\u{1112}\u{1174}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D783}",
        nfc: "\u{D783}",
        nfd: "\u{1112}\u{1174}\u{11BE}",
        nfkc: "\u{D783}",
        nfkd: "\u{1112}\u{1174}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D784}",
        nfc: "\u{D784}",
        nfd: "\u{1112}\u{1174}\u{11BF}",
        nfkc: "\u{D784}",
        nfkd: "\u{1112}\u{1174}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D785}",
        nfc: "\u{D785}",
        nfd: "\u{1112}\u{1174}\u{11C0}",
        nfkc: "\u{D785}",
        nfkd: "\u{1112}\u{1174}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D786}",
        nfc: "\u{D786}",
        nfd: "\u{1112}\u{1174}\u{11C1}",
        nfkc: "\u{D786}",
        nfkd: "\u{1112}\u{1174}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D787}",
        nfc: "\u{D787}",
        nfd: "\u{1112}\u{1174}\u{11C2}",
        nfkc: "\u{D787}",
        nfkd: "\u{1112}\u{1174}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{D788}",
        nfc: "\u{D788}",
        nfd: "\u{1112}\u{1175}",
        nfkc: "\u{D788}",
        nfkd: "\u{1112}\u{1175}",
    },
    NormalizationTest {
        source: "\u{D789}",
        nfc: "\u{D789}",
        nfd: "\u{1112}\u{1175}\u{11A8}",
        nfkc: "\u{D789}",
        nfkd: "\u{1112}\u{1175}\u{11A8}",
    },
    NormalizationTest {
        source: "\u{D78A}",
        nfc: "\u{D78A}",
        nfd: "\u{1112}\u{1175}\u{11A9}",
        nfkc: "\u{D78A}",
        nfkd: "\u{1112}\u{1175}\u{11A9}",
    },
    NormalizationTest {
        source: "\u{D78B}",
        nfc: "\u{D78B}",
        nfd: "\u{1112}\u{1175}\u{11AA}",
        nfkc: "\u{D78B}",
        nfkd: "\u{1112}\u{1175}\u{11AA}",
    },
    NormalizationTest {
        source: "\u{D78C}",
        nfc: "\u{D78C}",
        nfd: "\u{1112}\u{1175}\u{11AB}",
        nfkc: "\u{D78C}",
        nfkd: "\u{1112}\u{1175}\u{11AB}",
    },
    NormalizationTest {
        source: "\u{D78D}",
        nfc: "\u{D78D}",
        nfd: "\u{1112}\u{1175}\u{11AC}",
        nfkc: "\u{D78D}",
        nfkd: "\u{1112}\u{1175}\u{11AC}",
    },
    NormalizationTest {
        source: "\u{D78E}",
        nfc: "\u{D78E}",
        nfd: "\u{1112}\u{1175}\u{11AD}",
        nfkc: "\u{D78E}",
        nfkd: "\u{1112}\u{1175}\u{11AD}",
    },
    NormalizationTest {
        source: "\u{D78F}",
        nfc: "\u{D78F}",
        nfd: "\u{1112}\u{1175}\u{11AE}",
        nfkc: "\u{D78F}",
        nfkd: "\u{1112}\u{1175}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D790}",
        nfc: "\u{D790}",
        nfd: "\u{1112}\u{1175}\u{11AF}",
        nfkc: "\u{D790}",
        nfkd: "\u{1112}\u{1175}\u{11AF}",
    },
    NormalizationTest {
        source: "\u{D791}",
        nfc: "\u{D791}",
        nfd: "\u{1112}\u{1175}\u{11B0}",
        nfkc: "\u{D791}",
        nfkd: "\u{1112}\u{1175}\u{11B0}",
    },
    NormalizationTest {
        source: "\u{D792}",
        nfc: "\u{D792}",
        nfd: "\u{1112}\u{1175}\u{11B1}",
        nfkc: "\u{D792}",
        nfkd: "\u{1112}\u{1175}\u{11B1}",
    },
    NormalizationTest {
        source: "\u{D793}",
        nfc: "\u{D793}",
        nfd: "\u{1112}\u{1175}\u{11B2}",
        nfkc: "\u{D793}",
        nfkd: "\u{1112}\u{1175}\u{11B2}",
    },
    NormalizationTest {
        source: "\u{D794}",
        nfc: "\u{D794}",
        nfd: "\u{1112}\u{1175}\u{11B3}",
        nfkc: "\u{D794}",
        nfkd: "\u{1112}\u{1175}\u{11B3}",
    },
    NormalizationTest {
        source: "\u{D795}",
        nfc: "\u{D795}",
        nfd: "\u{1112}\u{1175}\u{11B4}",
        nfkc: "\u{D795}",
        nfkd: "\u{1112}\u{1175}\u{11B4}",
    },
    NormalizationTest {
        source: "\u{D796}",
        nfc: "\u{D796}",
        nfd: "\u{1112}\u{1175}\u{11B5}",
        nfkc: "\u{D796}",
        nfkd: "\u{1112}\u{1175}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D797}",
        nfc: "\u{D797}",
        nfd: "\u{1112}\u{1175}\u{11B6}",
        nfkc: "\u{D797}",
        nfkd: "\u{1112}\u{1175}\u{11B6}",
    },
    NormalizationTest {
        source: "\u{D798}",
        nfc: "\u{D798}",
        nfd: "\u{1112}\u{1175}\u{11B7}",
        nfkc: "\u{D798}",
        nfkd: "\u{1112}\u{1175}\u{11B7}",
    },
    NormalizationTest {
        source: "\u{D799}",
        nfc: "\u{D799}",
        nfd: "\u{1112}\u{1175}\u{11B8}",
        nfkc: "\u{D799}",
        nfkd: "\u{1112}\u{1175}\u{11B8}",
    },
    NormalizationTest {
        source: "\u{D79A}",
        nfc: "\u{D79A}",
        nfd: "\u{1112}\u{1175}\u{11B9}",
        nfkc: "\u{D79A}",
        nfkd: "\u{1112}\u{1175}\u{11B9}",
    },
    NormalizationTest {
        source: "\u{D79B}",
        nfc: "\u{D79B}",
        nfd: "\u{1112}\u{1175}\u{11BA}",
        nfkc: "\u{D79B}",
        nfkd: "\u{1112}\u{1175}\u{11BA}",
    },
    NormalizationTest {
        source: "\u{D79C}",
        nfc: "\u{D79C}",
        nfd: "\u{1112}\u{1175}\u{11BB}",
        nfkc: "\u{D79C}",
        nfkd: "\u{1112}\u{1175}\u{11BB}",
    },
    NormalizationTest {
        source: "\u{D79D}",
        nfc: "\u{D79D}",
        nfd: "\u{1112}\u{1175}\u{11BC}",
        nfkc: "\u{D79D}",
        nfkd: "\u{1112}\u{1175}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D79E}",
        nfc: "\u{D79E}",
        nfd: "\u{1112}\u{1175}\u{11BD}",
        nfkc: "\u{D79E}",
        nfkd: "\u{1112}\u{1175}\u{11BD}",
    },
    NormalizationTest {
        source: "\u{D79F}",
        nfc: "\u{D79F}",
        nfd: "\u{1112}\u{1175}\u{11BE}",
        nfkc: "\u{D79F}",
        nfkd: "\u{1112}\u{1175}\u{11BE}",
    },
    NormalizationTest {
        source: "\u{D7A0}",
        nfc: "\u{D7A0}",
        nfd: "\u{1112}\u{1175}\u{11BF}",
        nfkc: "\u{D7A0}",
        nfkd: "\u{1112}\u{1175}\u{11BF}",
    },
    NormalizationTest {
        source: "\u{D7A1}",
        nfc: "\u{D7A1}",
        nfd: "\u{1112}\u{1175}\u{11C0}",
        nfkc: "\u{D7A1}",
        nfkd: "\u{1112}\u{1175}\u{11C0}",
    },
    NormalizationTest {
        source: "\u{D7A2}",
        nfc: "\u{D7A2}",
        nfd: "\u{1112}\u{1175}\u{11C1}",
        nfkc: "\u{D7A2}",
        nfkd: "\u{1112}\u{1175}\u{11C1}",
    },
    NormalizationTest {
        source: "\u{D7A3}",
        nfc: "\u{D7A3}",
        nfd: "\u{1112}\u{1175}\u{11C2}",
        nfkc: "\u{D7A3}",
        nfkd: "\u{1112}\u{1175}\u{11C2}",
    },
    NormalizationTest {
        source: "\u{F900}",
        nfc: "\u{8C48}",
        nfd: "\u{8C48}",
        nfkc: "\u{8C48}",
        nfkd: "\u{8C48}",
    },
    NormalizationTest {
        source: "\u{F901}",
        nfc: "\u{66F4}",
        nfd: "\u{66F4}",
        nfkc: "\u{66F4}",
        nfkd: "\u{66F4}",
    },
    NormalizationTest {
        source: "\u{F902}",
        nfc: "\u{8ECA}",
        nfd: "\u{8ECA}",
        nfkc: "\u{8ECA}",
        nfkd: "\u{8ECA}",
    },
    NormalizationTest {
        source: "\u{F903}",
        nfc: "\u{8CC8}",
        nfd: "\u{8CC8}",
        nfkc: "\u{8CC8}",
        nfkd: "\u{8CC8}",
    },
    NormalizationTest {
        source: "\u{F904}",
        nfc: "\u{6ED1}",
        nfd: "\u{6ED1}",
        nfkc: "\u{6ED1}",
        nfkd: "\u{6ED1}",
    },
    NormalizationTest {
        source: "\u{F905}",
        nfc: "\u{4E32}",
        nfd: "\u{4E32}",
        nfkc: "\u{4E32}",
        nfkd: "\u{4E32}",
    },
    NormalizationTest {
        source: "\u{F906}",
        nfc: "\u{53E5}",
        nfd: "\u{53E5}",
        nfkc: "\u{53E5}",
        nfkd: "\u{53E5}",
    },
    NormalizationTest {
        source: "\u{F907}",
        nfc: "\u{9F9C}",
        nfd: "\u{9F9C}",
        nfkc: "\u{9F9C}",
        nfkd: "\u{9F9C}",
    },
    NormalizationTest {
        source: "\u{F908}",
        nfc: "\u{9F9C}",
        nfd: "\u{9F9C}",
        nfkc: "\u{9F9C}",
        nfkd: "\u{9F9C}",
    },
    NormalizationTest {
        source: "\u{F909}",
        nfc: "\u{5951}",
        nfd: "\u{5951}",
        nfkc: "\u{5951}",
        nfkd: "\u{5951}",
    },
    NormalizationTest {
        source: "\u{F90A}",
        nfc: "\u{91D1}",
        nfd: "\u{91D1}",
        nfkc: "\u{91D1}",
        nfkd: "\u{91D1}",
    },
    NormalizationTest {
        source: "\u{F90B}",
        nfc: "\u{5587}",
        nfd: "\u{5587}",
        nfkc: "\u{5587}",
        nfkd: "\u{5587}",
    },
    NormalizationTest {
        source: "\u{F90C}",
        nfc: "\u{5948}",
        nfd: "\u{5948}",
        nfkc: "\u{5948}",
        nfkd: "\u{5948}",
    },
    NormalizationTest {
        source: "\u{F90D}",
        nfc: "\u{61F6}",
        nfd: "\u{61F6}",
        nfkc: "\u{61F6}",
        nfkd: "\u{61F6}",
    },
    NormalizationTest {
        source: "\u{F90E}",
        nfc: "\u{7669}",
        nfd: "\u{7669}",
        nfkc: "\u{7669}",
        nfkd: "\u{7669}",
    },
    NormalizationTest {
        source: "\u{F90F}",
        nfc: "\u{7F85}",
        nfd: "\u{7F85}",
        nfkc: "\u{7F85}",
        nfkd: "\u{7F85}",
    },
    NormalizationTest {
        source: "\u{F910}",
        nfc: "\u{863F}",
        nfd: "\u{863F}",
        nfkc: "\u{863F}",
        nfkd: "\u{863F}",
    },
    NormalizationTest {
        source: "\u{F911}",
        nfc: "\u{87BA}",
        nfd: "\u{87BA}",
        nfkc: "\u{87BA}",
        nfkd: "\u{87BA}",
    },
    NormalizationTest {
        source: "\u{F912}",
        nfc: "\u{88F8}",
        nfd: "\u{88F8}",
        nfkc: "\u{88F8}",
        nfkd: "\u{88F8}",
    },
    NormalizationTest {
        source: "\u{F913}",
        nfc: "\u{908F}",
        nfd: "\u{908F}",
        nfkc: "\u{908F}",
        nfkd: "\u{908F}",
    },
    NormalizationTest {
        source: "\u{F914}",
        nfc: "\u{6A02}",
        nfd: "\u{6A02}",
        nfkc: "\u{6A02}",
        nfkd: "\u{6A02}",
    },
    NormalizationTest {
        source: "\u{F915}",
        nfc: "\u{6D1B}",
        nfd: "\u{6D1B}",
        nfkc: "\u{6D1B}",
        nfkd: "\u{6D1B}",
    },
    NormalizationTest {
        source: "\u{F916}",
        nfc: "\u{70D9}",
        nfd: "\u{70D9}",
        nfkc: "\u{70D9}",
        nfkd: "\u{70D9}",
    },
    NormalizationTest {
        source: "\u{F917}",
        nfc: "\u{73DE}",
        nfd: "\u{73DE}",
        nfkc: "\u{73DE}",
        nfkd: "\u{73DE}",
    },
    NormalizationTest {
        source: "\u{F918}",
        nfc: "\u{843D}",
        nfd: "\u{843D}",
        nfkc: "\u{843D}",
        nfkd: "\u{843D}",
    },
    NormalizationTest {
        source: "\u{F919}",
        nfc: "\u{916A}",
        nfd: "\u{916A}",
        nfkc: "\u{916A}",
        nfkd: "\u{916A}",
    },
    NormalizationTest {
        source: "\u{F91A}",
        nfc: "\u{99F1}",
        nfd: "\u{99F1}",
        nfkc: "\u{99F1}",
        nfkd: "\u{99F1}",
    },
    NormalizationTest {
        source: "\u{F91B}",
        nfc: "\u{4E82}",
        nfd: "\u{4E82}",
        nfkc: "\u{4E82}",
        nfkd: "\u{4E82}",
    },
    NormalizationTest {
        source: "\u{F91C}",
        nfc: "\u{5375}",
        nfd: "\u{5375}",
        nfkc: "\u{5375}",
        nfkd: "\u{5375}",
    },
    NormalizationTest {
        source: "\u{F91D}",
        nfc: "\u{6B04}",
        nfd: "\u{6B04}",
        nfkc: "\u{6B04}",
        nfkd: "\u{6B04}",
    },
    NormalizationTest {
        source: "\u{F91E}",
        nfc: "\u{721B}",
        nfd: "\u{721B}",
        nfkc: "\u{721B}",
        nfkd: "\u{721B}",
    },
    NormalizationTest {
        source: "\u{F91F}",
        nfc: "\u{862D}",
        nfd: "\u{862D}",
        nfkc: "\u{862D}",
        nfkd: "\u{862D}",
    },
    NormalizationTest {
        source: "\u{F920}",
        nfc: "\u{9E1E}",
        nfd: "\u{9E1E}",
        nfkc: "\u{9E1E}",
        nfkd: "\u{9E1E}",
    },
    NormalizationTest {
        source: "\u{F921}",
        nfc: "\u{5D50}",
        nfd: "\u{5D50}",
        nfkc: "\u{5D50}",
        nfkd: "\u{5D50}",
    },
    NormalizationTest {
        source: "\u{F922}",
        nfc: "\u{6FEB}",
        nfd: "\u{6FEB}",
        nfkc: "\u{6FEB}",
        nfkd: "\u{6FEB}",
    },
    NormalizationTest {
        source: "\u{F923}",
        nfc: "\u{85CD}",
        nfd: "\u{85CD}",
        nfkc: "\u{85CD}",
        nfkd: "\u{85CD}",
    },
    NormalizationTest {
        source: "\u{F924}",
        nfc: "\u{8964}",
        nfd: "\u{8964}",
        nfkc: "\u{8964}",
        nfkd: "\u{8964}",
    },
    NormalizationTest {
        source: "\u{F925}",
        nfc: "\u{62C9}",
        nfd: "\u{62C9}",
        nfkc: "\u{62C9}",
        nfkd: "\u{62C9}",
    },
    NormalizationTest {
        source: "\u{F926}",
        nfc: "\u{81D8}",
        nfd: "\u{81D8}",
        nfkc: "\u{81D8}",
        nfkd: "\u{81D8}",
    },
    NormalizationTest {
        source: "\u{F927}",
        nfc: "\u{881F}",
        nfd: "\u{881F}",
        nfkc: "\u{881F}",
        nfkd: "\u{881F}",
    },
    NormalizationTest {
        source: "\u{F928}",
        nfc: "\u{5ECA}",
        nfd: "\u{5ECA}",
        nfkc: "\u{5ECA}",
        nfkd: "\u{5ECA}",
    },
    NormalizationTest {
        source: "\u{F929}",
        nfc: "\u{6717}",
        nfd: "\u{6717}",
        nfkc: "\u{6717}",
        nfkd: "\u{6717}",
    },
    NormalizationTest {
        source: "\u{F92A}",
        nfc: "\u{6D6A}",
        nfd: "\u{6D6A}",
        nfkc: "\u{6D6A}",
        nfkd: "\u{6D6A}",
    },
    NormalizationTest {
        source: "\u{F92B}",
        nfc: "\u{72FC}",
        nfd: "\u{72FC}",
        nfkc: "\u{72FC}",
        nfkd: "\u{72FC}",
    },
    NormalizationTest {
        source: "\u{F92C}",
        nfc: "\u{90CE}",
        nfd: "\u{90CE}",
        nfkc: "\u{90CE}",
        nfkd: "\u{90CE}",
    },
    NormalizationTest {
        source: "\u{F92D}",
        nfc: "\u{4F86}",
        nfd: "\u{4F86}",
        nfkc: "\u{4F86}",
        nfkd: "\u{4F86}",
    },
    NormalizationTest {
        source: "\u{F92E}",
        nfc: "\u{51B7}",
        nfd: "\u{51B7}",
        nfkc: "\u{51B7}",
        nfkd: "\u{51B7}",
    },
    NormalizationTest {
        source: "\u{F92F}",
        nfc: "\u{52DE}",
        nfd: "\u{52DE}",
        nfkc: "\u{52DE}",
        nfkd: "\u{52DE}",
    },
    NormalizationTest {
        source: "\u{F930}",
        nfc: "\u{64C4}",
        nfd: "\u{64C4}",
        nfkc: "\u{64C4}",
        nfkd: "\u{64C4}",
    },
    NormalizationTest {
        source: "\u{F931}",
        nfc: "\u{6AD3}",
        nfd: "\u{6AD3}",
        nfkc: "\u{6AD3}",
        nfkd: "\u{6AD3}",
    },
    NormalizationTest {
        source: "\u{F932}",
        nfc: "\u{7210}",
        nfd: "\u{7210}",
        nfkc: "\u{7210}",
        nfkd: "\u{7210}",
    },
    NormalizationTest {
        source: "\u{F933}",
        nfc: "\u{76E7}",
        nfd: "\u{76E7}",
        nfkc: "\u{76E7}",
        nfkd: "\u{76E7}",
    },
    NormalizationTest {
        source: "\u{F934}",
        nfc: "\u{8001}",
        nfd: "\u{8001}",
        nfkc: "\u{8001}",
        nfkd: "\u{8001}",
    },
    NormalizationTest {
        source: "\u{F935}",
        nfc: "\u{8606}",
        nfd: "\u{8606}",
        nfkc: "\u{8606}",
        nfkd: "\u{8606}",
    },
    NormalizationTest {
        source: "\u{F936}",
        nfc: "\u{865C}",
        nfd: "\u{865C}",
        nfkc: "\u{865C}",
        nfkd: "\u{865C}",
    },
    NormalizationTest {
        source: "\u{F937}",
        nfc: "\u{8DEF}",
        nfd: "\u{8DEF}",
        nfkc: "\u{8DEF}",
        nfkd: "\u{8DEF}",
    },
    NormalizationTest {
        source: "\u{F938}",
        nfc: "\u{9732}",
        nfd: "\u{9732}",
        nfkc: "\u{9732}",
        nfkd: "\u{9732}",
    },
    NormalizationTest {
        source: "\u{F939}",
        nfc: "\u{9B6F}",
        nfd: "\u{9B6F}",
        nfkc: "\u{9B6F}",
        nfkd: "\u{9B6F}",
    },
    NormalizationTest {
        source: "\u{F93A}",
        nfc: "\u{9DFA}",
        nfd: "\u{9DFA}",
        nfkc: "\u{9DFA}",
        nfkd: "\u{9DFA}",
    },
    NormalizationTest {
        source: "\u{F93B}",
        nfc: "\u{788C}",
        nfd: "\u{788C}",
        nfkc: "\u{788C}",
        nfkd: "\u{788C}",
    },
    NormalizationTest {
        source: "\u{F93C}",
        nfc: "\u{797F}",
        nfd: "\u{797F}",
        nfkc: "\u{797F}",
        nfkd: "\u{797F}",
    },
    NormalizationTest {
        source: "\u{F93D}",
        nfc: "\u{7DA0}",
        nfd: "\u{7DA0}",
        nfkc: "\u{7DA0}",
        nfkd: "\u{7DA0}",
    },
    NormalizationTest {
        source: "\u{F93E}",
        nfc: "\u{83C9}",
        nfd: "\u{83C9}",
        nfkc: "\u{83C9}",
        nfkd: "\u{83C9}",
    },
    NormalizationTest {
        source: "\u{F93F}",
        nfc: "\u{9304}",
        nfd: "\u{9304}",
        nfkc: "\u{9304}",
        nfkd: "\u{9304}",
    },
    NormalizationTest {
        source: "\u{F940}",
        nfc: "\u{9E7F}",
        nfd: "\u{9E7F}",
        nfkc: "\u{9E7F}",
        nfkd: "\u{9E7F}",
    },
    NormalizationTest {
        source: "\u{F941}",
        nfc: "\u{8AD6}",
        nfd: "\u{8AD6}",
        nfkc: "\u{8AD6}",
        nfkd: "\u{8AD6}",
    },
    NormalizationTest {
        source: "\u{F942}",
        nfc: "\u{58DF}",
        nfd: "\u{58DF}",
        nfkc: "\u{58DF}",
        nfkd: "\u{58DF}",
    },
    NormalizationTest {
        source: "\u{F943}",
        nfc: "\u{5F04}",
        nfd: "\u{5F04}",
        nfkc: "\u{5F04}",
        nfkd: "\u{5F04}",
    },
    NormalizationTest {
        source: "\u{F944}",
        nfc: "\u{7C60}",
        nfd: "\u{7C60}",
        nfkc: "\u{7C60}",
        nfkd: "\u{7C60}",
    },
    NormalizationTest {
        source: "\u{F945}",
        nfc: "\u{807E}",
        nfd: "\u{807E}",
        nfkc: "\u{807E}",
        nfkd: "\u{807E}",
    },
    NormalizationTest {
        source: "\u{F946}",
        nfc: "\u{7262}",
        nfd: "\u{7262}",
        nfkc: "\u{7262}",
        nfkd: "\u{7262}",
    },
    NormalizationTest {
        source: "\u{F947}",
        nfc: "\u{78CA}",
        nfd: "\u{78CA}",
        nfkc: "\u{78CA}",
        nfkd: "\u{78CA}",
    },
    NormalizationTest {
        source: "\u{F948}",
        nfc: "\u{8CC2}",
        nfd: "\u{8CC2}",
        nfkc: "\u{8CC2}",
        nfkd: "\u{8CC2}",
    },
    NormalizationTest {
        source: "\u{F949}",
        nfc: "\u{96F7}",
        nfd: "\u{96F7}",
        nfkc: "\u{96F7}",
        nfkd: "\u{96F7}",
    },
    NormalizationTest {
        source: "\u{F94A}",
        nfc: "\u{58D8}",
        nfd: "\u{58D8}",
        nfkc: "\u{58D8}",
        nfkd: "\u{58D8}",
    },
    NormalizationTest {
        source: "\u{F94B}",
        nfc: "\u{5C62}",
        nfd: "\u{5C62}",
        nfkc: "\u{5C62}",
        nfkd: "\u{5C62}",
    },
    NormalizationTest {
        source: "\u{F94C}",
        nfc: "\u{6A13}",
        nfd: "\u{6A13}",
        nfkc: "\u{6A13}",
        nfkd: "\u{6A13}",
    },
    NormalizationTest {
        source: "\u{F94D}",
        nfc: "\u{6DDA}",
        nfd: "\u{6DDA}",
        nfkc: "\u{6DDA}",
        nfkd: "\u{6DDA}",
    },
    NormalizationTest {
        source: "\u{F94E}",
        nfc: "\u{6F0F}",
        nfd: "\u{6F0F}",
        nfkc: "\u{6F0F}",
        nfkd: "\u{6F0F}",
    },
    NormalizationTest {
        source: "\u{F94F}",
        nfc: "\u{7D2F}",
        nfd: "\u{7D2F}",
        nfkc: "\u{7D2F}",
        nfkd: "\u{7D2F}",
    },
    NormalizationTest {
        source: "\u{F950}",
        nfc: "\u{7E37}",
        nfd: "\u{7E37}",
        nfkc: "\u{7E37}",
        nfkd: "\u{7E37}",
    },
    NormalizationTest {
        source: "\u{F951}",
        nfc: "\u{964B}",
        nfd: "\u{964B}",
        nfkc: "\u{964B}",
        nfkd: "\u{964B}",
    },
    NormalizationTest {
        source: "\u{F952}",
        nfc: "\u{52D2}",
        nfd: "\u{52D2}",
        nfkc: "\u{52D2}",
        nfkd: "\u{52D2}",
    },
    NormalizationTest {
        source: "\u{F953}",
        nfc: "\u{808B}",
        nfd: "\u{808B}",
        nfkc: "\u{808B}",
        nfkd: "\u{808B}",
    },
    NormalizationTest {
        source: "\u{F954}",
        nfc: "\u{51DC}",
        nfd: "\u{51DC}",
        nfkc: "\u{51DC}",
        nfkd: "\u{51DC}",
    },
    NormalizationTest {
        source: "\u{F955}",
        nfc: "\u{51CC}",
        nfd: "\u{51CC}",
        nfkc: "\u{51CC}",
        nfkd: "\u{51CC}",
    },
    NormalizationTest {
        source: "\u{F956}",
        nfc: "\u{7A1C}",
        nfd: "\u{7A1C}",
        nfkc: "\u{7A1C}",
        nfkd: "\u{7A1C}",
    },
    NormalizationTest {
        source: "\u{F957}",
        nfc: "\u{7DBE}",
        nfd: "\u{7DBE}",
        nfkc: "\u{7DBE}",
        nfkd: "\u{7DBE}",
    },
    NormalizationTest {
        source: "\u{F958}",
        nfc: "\u{83F1}",
        nfd: "\u{83F1}",
        nfkc: "\u{83F1}",
        nfkd: "\u{83F1}",
    },
    NormalizationTest {
        source: "\u{F959}",
        nfc: "\u{9675}",
        nfd: "\u{9675}",
        nfkc: "\u{9675}",
        nfkd: "\u{9675}",
    },
    NormalizationTest {
        source: "\u{F95A}",
        nfc: "\u{8B80}",
        nfd: "\u{8B80}",
        nfkc: "\u{8B80}",
        nfkd: "\u{8B80}",
    },
    NormalizationTest {
        source: "\u{F95B}",
        nfc: "\u{62CF}",
        nfd: "\u{62CF}",
        nfkc: "\u{62CF}",
        nfkd: "\u{62CF}",
    },
    NormalizationTest {
        source: "\u{F95C}",
        nfc: "\u{6A02}",
        nfd: "\u{6A02}",
        nfkc: "\u{6A02}",
        nfkd: "\u{6A02}",
    },
    NormalizationTest {
        source: "\u{F95D}",
        nfc: "\u{8AFE}",
        nfd: "\u{8AFE}",
        nfkc: "\u{8AFE}",
        nfkd: "\u{8AFE}",
    },
    NormalizationTest {
        source: "\u{F95E}",
        nfc: "\u{4E39}",
        nfd: "\u{4E39}",
        nfkc: "\u{4E39}",
        nfkd: "\u{4E39}",
    },
    NormalizationTest {
        source: "\u{F95F}",
        nfc: "\u{5BE7}",
        nfd: "\u{5BE7}",
        nfkc: "\u{5BE7}",
        nfkd: "\u{5BE7}",
    },
    NormalizationTest {
        source: "\u{F960}",
        nfc: "\u{6012}",
        nfd: "\u{6012}",
        nfkc: "\u{6012}",
        nfkd: "\u{6012}",
    },
    NormalizationTest {
        source: "\u{F961}",
        nfc: "\u{7387}",
        nfd: "\u{7387}",
        nfkc: "\u{7387}",
        nfkd: "\u{7387}",
    },
    NormalizationTest {
        source: "\u{F962}",
        nfc: "\u{7570}",
        nfd: "\u{7570}",
        nfkc: "\u{7570}",
        nfkd: "\u{7570}",
    },
    NormalizationTest {
        source: "\u{F963}",
        nfc: "\u{5317}",
        nfd: "\u{5317}",
        nfkc: "\u{5317}",
        nfkd: "\u{5317}",
    },
    NormalizationTest {
        source: "\u{F964}",
        nfc: "\u{78FB}",
        nfd: "\u{78FB}",
        nfkc: "\u{78FB}",
        nfkd: "\u{78FB}",
    },
    NormalizationTest {
        source: "\u{F965}",
        nfc: "\u{4FBF}",
        nfd: "\u{4FBF}",
        nfkc: "\u{4FBF}",
        nfkd: "\u{4FBF}",
    },
    NormalizationTest {
        source: "\u{F966}",
        nfc: "\u{5FA9}",
        nfd: "\u{5FA9}",
        nfkc: "\u{5FA9}",
        nfkd: "\u{5FA9}",
    },
    NormalizationTest {
        source: "\u{F967}",
        nfc: "\u{4E0D}",
        nfd: "\u{4E0D}",
        nfkc: "\u{4E0D}",
        nfkd: "\u{4E0D}",
    },
    NormalizationTest {
        source: "\u{F968}",
        nfc: "\u{6CCC}",
        nfd: "\u{6CCC}",
        nfkc: "\u{6CCC}",
        nfkd: "\u{6CCC}",
    },
    NormalizationTest {
        source: "\u{F969}",
        nfc: "\u{6578}",
        nfd: "\u{6578}",
        nfkc: "\u{6578}",
        nfkd: "\u{6578}",
    },
    NormalizationTest {
        source: "\u{F96A}",
        nfc: "\u{7D22}",
        nfd: "\u{7D22}",
        nfkc: "\u{7D22}",
        nfkd: "\u{7D22}",
    },
    NormalizationTest {
        source: "\u{F96B}",
        nfc: "\u{53C3}",
        nfd: "\u{53C3}",
        nfkc: "\u{53C3}",
        nfkd: "\u{53C3}",
    },
    NormalizationTest {
        source: "\u{F96C}",
        nfc: "\u{585E}",
        nfd: "\u{585E}",
        nfkc: "\u{585E}",
        nfkd: "\u{585E}",
    },
    NormalizationTest {
        source: "\u{F96D}",
        nfc: "\u{7701}",
        nfd: "\u{7701}",
        nfkc: "\u{7701}",
        nfkd: "\u{7701}",
    },
    NormalizationTest {
        source: "\u{F96E}",
        nfc: "\u{8449}",
        nfd: "\u{8449}",
        nfkc: "\u{8449}",
        nfkd: "\u{8449}",
    },
    NormalizationTest {
        source: "\u{F96F}",
        nfc: "\u{8AAA}",
        nfd: "\u{8AAA}",
        nfkc: "\u{8AAA}",
        nfkd: "\u{8AAA}",
    },
    NormalizationTest {
        source: "\u{F970}",
        nfc: "\u{6BBA}",
        nfd: "\u{6BBA}",
        nfkc: "\u{6BBA}",
        nfkd: "\u{6BBA}",
    },
    NormalizationTest {
        source: "\u{F971}",
        nfc: "\u{8FB0}",
        nfd: "\u{8FB0}",
        nfkc: "\u{8FB0}",
        nfkd: "\u{8FB0}",
    },
    NormalizationTest {
        source: "\u{F972}",
        nfc: "\u{6C88}",
        nfd: "\u{6C88}",
        nfkc: "\u{6C88}",
        nfkd: "\u{6C88}",
    },
    NormalizationTest {
        source: "\u{F973}",
        nfc: "\u{62FE}",
        nfd: "\u{62FE}",
        nfkc: "\u{62FE}",
        nfkd: "\u{62FE}",
    },
    NormalizationTest {
        source: "\u{F974}",
        nfc: "\u{82E5}",
        nfd: "\u{82E5}",
        nfkc: "\u{82E5}",
        nfkd: "\u{82E5}",
    },
    NormalizationTest {
        source: "\u{F975}",
        nfc: "\u{63A0}",
        nfd: "\u{63A0}",
        nfkc: "\u{63A0}",
        nfkd: "\u{63A0}",
    },
    NormalizationTest {
        source: "\u{F976}",
        nfc: "\u{7565}",
        nfd: "\u{7565}",
        nfkc: "\u{7565}",
        nfkd: "\u{7565}",
    },
    NormalizationTest {
        source: "\u{F977}",
        nfc: "\u{4EAE}",
        nfd: "\u{4EAE}",
        nfkc: "\u{4EAE}",
        nfkd: "\u{4EAE}",
    },
    NormalizationTest {
        source: "\u{F978}",
        nfc: "\u{5169}",
        nfd: "\u{5169}",
        nfkc: "\u{5169}",
        nfkd: "\u{5169}",
    },
    NormalizationTest {
        source: "\u{F979}",
        nfc: "\u{51C9}",
        nfd: "\u{51C9}",
        nfkc: "\u{51C9}",
        nfkd: "\u{51C9}",
    },
    NormalizationTest {
        source: "\u{F97A}",
        nfc: "\u{6881}",
        nfd: "\u{6881}",
        nfkc: "\u{6881}",
        nfkd: "\u{6881}",
    },
    NormalizationTest {
        source: "\u{F97B}",
        nfc: "\u{7CE7}",
        nfd: "\u{7CE7}",
        nfkc: "\u{7CE7}",
        nfkd: "\u{7CE7}",
    },
    NormalizationTest {
        source: "\u{F97C}",
        nfc: "\u{826F}",
        nfd: "\u{826F}",
        nfkc: "\u{826F}",
        nfkd: "\u{826F}",
    },
    NormalizationTest {
        source: "\u{F97D}",
        nfc: "\u{8AD2}",
        nfd: "\u{8AD2}",
        nfkc: "\u{8AD2}",
        nfkd: "\u{8AD2}",
    },
    NormalizationTest {
        source: "\u{F97E}",
        nfc: "\u{91CF}",
        nfd: "\u{91CF}",
        nfkc: "\u{91CF}",
        nfkd: "\u{91CF}",
    },
    NormalizationTest {
        source: "\u{F97F}",
        nfc: "\u{52F5}",
        nfd: "\u{52F5}",
        nfkc: "\u{52F5}",
        nfkd: "\u{52F5}",
    },
    NormalizationTest {
        source: "\u{F980}",
        nfc: "\u{5442}",
        nfd: "\u{5442}",
        nfkc: "\u{5442}",
        nfkd: "\u{5442}",
    },
    NormalizationTest {
        source: "\u{F981}",
        nfc: "\u{5973}",
        nfd: "\u{5973}",
        nfkc: "\u{5973}",
        nfkd: "\u{5973}",
    },
    NormalizationTest {
        source: "\u{F982}",
        nfc: "\u{5EEC}",
        nfd: "\u{5EEC}",
        nfkc: "\u{5EEC}",
        nfkd: "\u{5EEC}",
    },
    NormalizationTest {
        source: "\u{F983}",
        nfc: "\u{65C5}",
        nfd: "\u{65C5}",
        nfkc: "\u{65C5}",
        nfkd: "\u{65C5}",
    },
    NormalizationTest {
        source: "\u{F984}",
        nfc: "\u{6FFE}",
        nfd: "\u{6FFE}",
        nfkc: "\u{6FFE}",
        nfkd: "\u{6FFE}",
    },
    NormalizationTest {
        source: "\u{F985}",
        nfc: "\u{792A}",
        nfd: "\u{792A}",
        nfkc: "\u{792A}",
        nfkd: "\u{792A}",
    },
    NormalizationTest {
        source: "\u{F986}",
        nfc: "\u{95AD}",
        nfd: "\u{95AD}",
        nfkc: "\u{95AD}",
        nfkd: "\u{95AD}",
    },
    NormalizationTest {
        source: "\u{F987}",
        nfc: "\u{9A6A}",
        nfd: "\u{9A6A}",
        nfkc: "\u{9A6A}",
        nfkd: "\u{9A6A}",
    },
    NormalizationTest {
        source: "\u{F988}",
        nfc: "\u{9E97}",
        nfd: "\u{9E97}",
        nfkc: "\u{9E97}",
        nfkd: "\u{9E97}",
    },
    NormalizationTest {
        source: "\u{F989}",
        nfc: "\u{9ECE}",
        nfd: "\u{9ECE}",
        nfkc: "\u{9ECE}",
        nfkd: "\u{9ECE}",
    },
    NormalizationTest {
        source: "\u{F98A}",
        nfc: "\u{529B}",
        nfd: "\u{529B}",
        nfkc: "\u{529B}",
        nfkd: "\u{529B}",
    },
    NormalizationTest {
        source: "\u{F98B}",
        nfc: "\u{66C6}",
        nfd: "\u{66C6}",
        nfkc: "\u{66C6}",
        nfkd: "\u{66C6}",
    },
    NormalizationTest {
        source: "\u{F98C}",
        nfc: "\u{6B77}",
        nfd: "\u{6B77}",
        nfkc: "\u{6B77}",
        nfkd: "\u{6B77}",
    },
    NormalizationTest {
        source: "\u{F98D}",
        nfc: "\u{8F62}",
        nfd: "\u{8F62}",
        nfkc: "\u{8F62}",
        nfkd: "\u{8F62}",
    },
    NormalizationTest {
        source: "\u{F98E}",
        nfc: "\u{5E74}",
        nfd: "\u{5E74}",
        nfkc: "\u{5E74}",
        nfkd: "\u{5E74}",
    },
    NormalizationTest {
        source: "\u{F98F}",
        nfc: "\u{6190}",
        nfd: "\u{6190}",
        nfkc: "\u{6190}",
        nfkd: "\u{6190}",
    },
    NormalizationTest {
        source: "\u{F990}",
        nfc: "\u{6200}",
        nfd: "\u{6200}",
        nfkc: "\u{6200}",
        nfkd: "\u{6200}",
    },
    NormalizationTest {
        source: "\u{F991}",
        nfc: "\u{649A}",
        nfd: "\u{649A}",
        nfkc: "\u{649A}",
        nfkd: "\u{649A}",
    },
    NormalizationTest {
        source: "\u{F992}",
        nfc: "\u{6F23}",
        nfd: "\u{6F23}",
        nfkc: "\u{6F23}",
        nfkd: "\u{6F23}",
    },
    NormalizationTest {
        source: "\u{F993}",
        nfc: "\u{7149}",
        nfd: "\u{7149}",
        nfkc: "\u{7149}",
        nfkd: "\u{7149}",
    },
    NormalizationTest {
        source: "\u{F994}",
        nfc: "\u{7489}",
        nfd: "\u{7489}",
        nfkc: "\u{7489}",
        nfkd: "\u{7489}",
    },
    NormalizationTest {
        source: "\u{F995}",
        nfc: "\u{79CA}",
        nfd: "\u{79CA}",
        nfkc: "\u{79CA}",
        nfkd: "\u{79CA}",
    },
    NormalizationTest {
        source: "\u{F996}",
        nfc: "\u{7DF4}",
        nfd: "\u{7DF4}",
        nfkc: "\u{7DF4}",
        nfkd: "\u{7DF4}",
    },
    NormalizationTest {
        source: "\u{F997}",
        nfc: "\u{806F}",
        nfd: "\u{806F}",
        nfkc: "\u{806F}",
        nfkd: "\u{806F}",
    },
    NormalizationTest {
        source: "\u{F998}",
        nfc: "\u{8F26}",
        nfd: "\u{8F26}",
        nfkc: "\u{8F26}",
        nfkd: "\u{8F26}",
    },
    NormalizationTest {
        source: "\u{F999}",
        nfc: "\u{84EE}",
        nfd: "\u{84EE}",
        nfkc: "\u{84EE}",
        nfkd: "\u{84EE}",
    },
    NormalizationTest {
        source: "\u{F99A}",
        nfc: "\u{9023}",
        nfd: "\u{9023}",
        nfkc: "\u{9023}",
        nfkd: "\u{9023}",
    },
    NormalizationTest {
        source: "\u{F99B}",
        nfc: "\u{934A}",
        nfd: "\u{934A}",
        nfkc: "\u{934A}",
        nfkd: "\u{934A}",
    },
    NormalizationTest {
        source: "\u{F99C}",
        nfc: "\u{5217}",
        nfd: "\u{5217}",
        nfkc: "\u{5217}",
        nfkd: "\u{5217}",
    },
    NormalizationTest {
        source: "\u{F99D}",
        nfc: "\u{52A3}",
        nfd: "\u{52A3}",
        nfkc: "\u{52A3}",
        nfkd: "\u{52A3}",
    },
    NormalizationTest {
        source: "\u{F99E}",
        nfc: "\u{54BD}",
        nfd: "\u{54BD}",
        nfkc: "\u{54BD}",
        nfkd: "\u{54BD}",
    },
    NormalizationTest {
        source: "\u{F99F}",
        nfc: "\u{70C8}",
        nfd: "\u{70C8}",
        nfkc: "\u{70C8}",
        nfkd: "\u{70C8}",
    },
    NormalizationTest {
        source: "\u{F9A0}",
        nfc: "\u{88C2}",
        nfd: "\u{88C2}",
        nfkc: "\u{88C2}",
        nfkd: "\u{88C2}",
    },
    NormalizationTest {
        source: "\u{F9A1}",
        nfc: "\u{8AAA}",
        nfd: "\u{8AAA}",
        nfkc: "\u{8AAA}",
        nfkd: "\u{8AAA}",
    },
    NormalizationTest {
        source: "\u{F9A2}",
        nfc: "\u{5EC9}",
        nfd: "\u{5EC9}",
        nfkc: "\u{5EC9}",
        nfkd: "\u{5EC9}",
    },
    NormalizationTest {
        source: "\u{F9A3}",
        nfc: "\u{5FF5}",
        nfd: "\u{5FF5}",
        nfkc: "\u{5FF5}",
        nfkd: "\u{5FF5}",
    },
    NormalizationTest {
        source: "\u{F9A4}",
        nfc: "\u{637B}",
        nfd: "\u{637B}",
        nfkc: "\u{637B}",
        nfkd: "\u{637B}",
    },
    NormalizationTest {
        source: "\u{F9A5}",
        nfc: "\u{6BAE}",
        nfd: "\u{6BAE}",
        nfkc: "\u{6BAE}",
        nfkd: "\u{6BAE}",
    },
    NormalizationTest {
        source: "\u{F9A6}",
        nfc: "\u{7C3E}",
        nfd: "\u{7C3E}",
        nfkc: "\u{7C3E}",
        nfkd: "\u{7C3E}",
    },
    NormalizationTest {
        source: "\u{F9A7}",
        nfc: "\u{7375}",
        nfd: "\u{7375}",
        nfkc: "\u{7375}",
        nfkd: "\u{7375}",
    },
    NormalizationTest {
        source: "\u{F9A8}",
        nfc: "\u{4EE4}",
        nfd: "\u{4EE4}",
        nfkc: "\u{4EE4}",
        nfkd: "\u{4EE4}",
    },
    NormalizationTest {
        source: "\u{F9A9}",
        nfc: "\u{56F9}",
        nfd: "\u{56F9}",
        nfkc: "\u{56F9}",
        nfkd: "\u{56F9}",
    },
    NormalizationTest {
        source: "\u{F9AA}",
        nfc: "\u{5BE7}",
        nfd: "\u{5BE7}",
        nfkc: "\u{5BE7}",
        nfkd: "\u{5BE7}",
    },
    NormalizationTest {
        source: "\u{F9AB}",
        nfc: "\u{5DBA}",
        nfd: "\u{5DBA}",
        nfkc: "\u{5DBA}",
        nfkd: "\u{5DBA}",
    },
    NormalizationTest {
        source: "\u{F9AC}",
        nfc: "\u{601C}",
        nfd: "\u{601C}",
        nfkc: "\u{601C}",
        nfkd: "\u{601C}",
    },
    NormalizationTest {
        source: "\u{F9AD}",
        nfc: "\u{73B2}",
        nfd: "\u{73B2}",
        nfkc: "\u{73B2}",
        nfkd: "\u{73B2}",
    },
    NormalizationTest {
        source: "\u{F9AE}",
        nfc: "\u{7469}",
        nfd: "\u{7469}",
        nfkc: "\u{7469}",
        nfkd: "\u{7469}",
    },
    NormalizationTest {
        source: "\u{F9AF}",
        nfc: "\u{7F9A}",
        nfd: "\u{7F9A}",
        nfkc: "\u{7F9A}",
        nfkd: "\u{7F9A}",
    },
    NormalizationTest {
        source: "\u{F9B0}",
        nfc: "\u{8046}",
        nfd: "\u{8046}",
        nfkc: "\u{8046}",
        nfkd: "\u{8046}",
    },
    NormalizationTest {
        source: "\u{F9B1}",
        nfc: "\u{9234}",
        nfd: "\u{9234}",
        nfkc: "\u{9234}",
        nfkd: "\u{9234}",
    },
    NormalizationTest {
        source: "\u{F9B2}",
        nfc: "\u{96F6}",
        nfd: "\u{96F6}",
        nfkc: "\u{96F6}",
        nfkd: "\u{96F6}",
    },
    NormalizationTest {
        source: "\u{F9B3}",
        nfc: "\u{9748}",
        nfd: "\u{9748}",
        nfkc: "\u{9748}",
        nfkd: "\u{9748}",
    },
    NormalizationTest {
        source: "\u{F9B4}",
        nfc: "\u{9818}",
        nfd: "\u{9818}",
        nfkc: "\u{9818}",
        nfkd: "\u{9818}",
    },
    NormalizationTest {
        source: "\u{F9B5}",
        nfc: "\u{4F8B}",
        nfd: "\u{4F8B}",
        nfkc: "\u{4F8B}",
        nfkd: "\u{4F8B}",
    },
    NormalizationTest {
        source: "\u{F9B6}",
        nfc: "\u{79AE}",
        nfd: "\u{79AE}",
        nfkc: "\u{79AE}",
        nfkd: "\u{79AE}",
    },
    NormalizationTest {
        source: "\u{F9B7}",
        nfc: "\u{91B4}",
        nfd: "\u{91B4}",
        nfkc: "\u{91B4}",
        nfkd: "\u{91B4}",
    },
    NormalizationTest {
        source: "\u{F9B8}",
        nfc: "\u{96B8}",
        nfd: "\u{96B8}",
        nfkc: "\u{96B8}",
        nfkd: "\u{96B8}",
    },
    NormalizationTest {
        source: "\u{F9B9}",
        nfc: "\u{60E1}",
        nfd: "\u{60E1}",
        nfkc: "\u{60E1}",
        nfkd: "\u{60E1}",
    },
    NormalizationTest {
        source: "\u{F9BA}",
        nfc: "\u{4E86}",
        nfd: "\u{4E86}",
        nfkc: "\u{4E86}",
        nfkd: "\u{4E86}",
    },
    NormalizationTest {
        source: "\u{F9BB}",
        nfc: "\u{50DA}",
        nfd: "\u{50DA}",
        nfkc: "\u{50DA}",
        nfkd: "\u{50DA}",
    },
    NormalizationTest {
        source: "\u{F9BC}",
        nfc: "\u{5BEE}",
        nfd: "\u{5BEE}",
        nfkc: "\u{5BEE}",
        nfkd: "\u{5BEE}",
    },
    NormalizationTest {
        source: "\u{F9BD}",
        nfc: "\u{5C3F}",
        nfd: "\u{5C3F}",
        nfkc: "\u{5C3F}",
        nfkd: "\u{5C3F}",
    },
    NormalizationTest {
        source: "\u{F9BE}",
        nfc: "\u{6599}",
        nfd: "\u{6599}",
        nfkc: "\u{6599}",
        nfkd: "\u{6599}",
    },
    NormalizationTest {
        source: "\u{F9BF}",
        nfc: "\u{6A02}",
        nfd: "\u{6A02}",
        nfkc: "\u{6A02}",
        nfkd: "\u{6A02}",
    },
    NormalizationTest {
        source: "\u{F9C0}",
        nfc: "\u{71CE}",
        nfd: "\u{71CE}",
        nfkc: "\u{71CE}",
        nfkd: "\u{71CE}",
    },
    NormalizationTest {
        source: "\u{F9C1}",
        nfc: "\u{7642}",
        nfd: "\u{7642}",
        nfkc: "\u{7642}",
        nfkd: "\u{7642}",
    },
    NormalizationTest {
        source: "\u{F9C2}",
        nfc: "\u{84FC}",
        nfd: "\u{84FC}",
        nfkc: "\u{84FC}",
        nfkd: "\u{84FC}",
    },
    NormalizationTest {
        source: "\u{F9C3}",
        nfc: "\u{907C}",
        nfd: "\u{907C}",
        nfkc: "\u{907C}",
        nfkd: "\u{907C}",
    },
    NormalizationTest {
        source: "\u{F9C4}",
        nfc: "\u{9F8D}",
        nfd: "\u{9F8D}",
        nfkc: "\u{9F8D}",
        nfkd: "\u{9F8D}",
    },
    NormalizationTest {
        source: "\u{F9C5}",
        nfc: "\u{6688}",
        nfd: "\u{6688}",
        nfkc: "\u{6688}",
        nfkd: "\u{6688}",
    },
    NormalizationTest {
        source: "\u{F9C6}",
        nfc: "\u{962E}",
        nfd: "\u{962E}",
        nfkc: "\u{962E}",
        nfkd: "\u{962E}",
    },
    NormalizationTest {
        source: "\u{F9C7}",
        nfc: "\u{5289}",
        nfd: "\u{5289}",
        nfkc: "\u{5289}",
        nfkd: "\u{5289}",
    },
    NormalizationTest {
        source: "\u{F9C8}",
        nfc: "\u{677B}",
        nfd: "\u{677B}",
        nfkc: "\u{677B}",
        nfkd: "\u{677B}",
    },
    NormalizationTest {
        source: "\u{F9C9}",
        nfc: "\u{67F3}",
        nfd: "\u{67F3}",
        nfkc: "\u{67F3}",
        nfkd: "\u{67F3}",
    },
    NormalizationTest {
        source: "\u{F9CA}",
        nfc: "\u{6D41}",
        nfd: "\u{6D41}",
        nfkc: "\u{6D41}",
        nfkd: "\u{6D41}",
    },
    NormalizationTest {
        source: "\u{F9CB}",
        nfc: "\u{6E9C}",
        nfd: "\u{6E9C}",
        nfkc: "\u{6E9C}",
        nfkd: "\u{6E9C}",
    },
    NormalizationTest {
        source: "\u{F9CC}",
        nfc: "\u{7409}",
        nfd: "\u{7409}",
        nfkc: "\u{7409}",
        nfkd: "\u{7409}",
    },
    NormalizationTest {
        source: "\u{F9CD}",
        nfc: "\u{7559}",
        nfd: "\u{7559}",
        nfkc: "\u{7559}",
        nfkd: "\u{7559}",
    },
    NormalizationTest {
        source: "\u{F9CE}",
        nfc: "\u{786B}",
        nfd: "\u{786B}",
        nfkc: "\u{786B}",
        nfkd: "\u{786B}",
    },
    NormalizationTest {
        source: "\u{F9CF}",
        nfc: "\u{7D10}",
        nfd: "\u{7D10}",
        nfkc: "\u{7D10}",
        nfkd: "\u{7D10}",
    },
    NormalizationTest {
        source: "\u{F9D0}",
        nfc: "\u{985E}",
        nfd: "\u{985E}",
        nfkc: "\u{985E}",
        nfkd: "\u{985E}",
    },
    NormalizationTest {
        source: "\u{F9D1}",
        nfc: "\u{516D}",
        nfd: "\u{516D}",
        nfkc: "\u{516D}",
        nfkd: "\u{516D}",
    },
    NormalizationTest {
        source: "\u{F9D2}",
        nfc: "\u{622E}",
        nfd: "\u{622E}",
        nfkc: "\u{622E}",
        nfkd: "\u{622E}",
    },
    NormalizationTest {
        source: "\u{F9D3}",
        nfc: "\u{9678}",
        nfd: "\u{9678}",
        nfkc: "\u{9678}",
        nfkd: "\u{9678}",
    },
    NormalizationTest {
        source: "\u{F9D4}",
        nfc: "\u{502B}",
        nfd: "\u{502B}",
        nfkc: "\u{502B}",
        nfkd: "\u{502B}",
    },
    NormalizationTest {
        source: "\u{F9D5}",
        nfc: "\u{5D19}",
        nfd: "\u{5D19}",
        nfkc: "\u{5D19}",
        nfkd: "\u{5D19}",
    },
    NormalizationTest {
        source: "\u{F9D6}",
        nfc: "\u{6DEA}",
        nfd: "\u{6DEA}",
        nfkc: "\u{6DEA}",
        nfkd: "\u{6DEA}",
    },
    NormalizationTest {
        source: "\u{F9D7}",
        nfc: "\u{8F2A}",
        nfd: "\u{8F2A}",
        nfkc: "\u{8F2A}",
        nfkd: "\u{8F2A}",
    },
    NormalizationTest {
        source: "\u{F9D8}",
        nfc: "\u{5F8B}",
        nfd: "\u{5F8B}",
        nfkc: "\u{5F8B}",
        nfkd: "\u{5F8B}",
    },
    NormalizationTest {
        source: "\u{F9D9}",
        nfc: "\u{6144}",
        nfd: "\u{6144}",
        nfkc: "\u{6144}",
        nfkd: "\u{6144}",
    },
    NormalizationTest {
        source: "\u{F9DA}",
        nfc: "\u{6817}",
        nfd: "\u{6817}",
        nfkc: "\u{6817}",
        nfkd: "\u{6817}",
    },
    NormalizationTest {
        source: "\u{F9DB}",
        nfc: "\u{7387}",
        nfd: "\u{7387}",
        nfkc: "\u{7387}",
        nfkd: "\u{7387}",
    },
    NormalizationTest {
        source: "\u{F9DC}",
        nfc: "\u{9686}",
        nfd: "\u{9686}",
        nfkc: "\u{9686}",
        nfkd: "\u{9686}",
    },
    NormalizationTest {
        source: "\u{F9DD}",
        nfc: "\u{5229}",
        nfd: "\u{5229}",
        nfkc: "\u{5229}",
        nfkd: "\u{5229}",
    },
    NormalizationTest {
        source: "\u{F9DE}",
        nfc: "\u{540F}",
        nfd: "\u{540F}",
        nfkc: "\u{540F}",
        nfkd: "\u{540F}",
    },
    NormalizationTest {
        source: "\u{F9DF}",
        nfc: "\u{5C65}",
        nfd: "\u{5C65}",
        nfkc: "\u{5C65}",
        nfkd: "\u{5C65}",
    },
    NormalizationTest {
        source: "\u{F9E0}",
        nfc: "\u{6613}",
        nfd: "\u{6613}",
        nfkc: "\u{6613}",
        nfkd: "\u{6613}",
    },
    NormalizationTest {
        source: "\u{F9E1}",
        nfc: "\u{674E}",
        nfd: "\u{674E}",
        nfkc: "\u{674E}",
        nfkd: "\u{674E}",
    },
    NormalizationTest {
        source: "\u{F9E2}",
        nfc: "\u{68A8}",
        nfd: "\u{68A8}",
        nfkc: "\u{68A8}",
        nfkd: "\u{68A8}",
    },
    NormalizationTest {
        source: "\u{F9E3}",
        nfc: "\u{6CE5}",
        nfd: "\u{6CE5}",
        nfkc: "\u{6CE5}",
        nfkd: "\u{6CE5}",
    },
    NormalizationTest {
        source: "\u{F9E4}",
        nfc: "\u{7406}",
        nfd: "\u{7406}",
        nfkc: "\u{7406}",
        nfkd: "\u{7406}",
    },
    NormalizationTest {
        source: "\u{F9E5}",
        nfc: "\u{75E2}",
        nfd: "\u{75E2}",
        nfkc: "\u{75E2}",
        nfkd: "\u{75E2}",
    },
    NormalizationTest {
        source: "\u{F9E6}",
        nfc: "\u{7F79}",
        nfd: "\u{7F79}",
        nfkc: "\u{7F79}",
        nfkd: "\u{7F79}",
    },
    NormalizationTest {
        source: "\u{F9E7}",
        nfc: "\u{88CF}",
        nfd: "\u{88CF}",
        nfkc: "\u{88CF}",
        nfkd: "\u{88CF}",
    },
    NormalizationTest {
        source: "\u{F9E8}",
        nfc: "\u{88E1}",
        nfd: "\u{88E1}",
        nfkc: "\u{88E1}",
        nfkd: "\u{88E1}",
    },
    NormalizationTest {
        source: "\u{F9E9}",
        nfc: "\u{91CC}",
        nfd: "\u{91CC}",
        nfkc: "\u{91CC}",
        nfkd: "\u{91CC}",
    },
    NormalizationTest {
        source: "\u{F9EA}",
        nfc: "\u{96E2}",
        nfd: "\u{96E2}",
        nfkc: "\u{96E2}",
        nfkd: "\u{96E2}",
    },
    NormalizationTest {
        source: "\u{F9EB}",
        nfc: "\u{533F}",
        nfd: "\u{533F}",
        nfkc: "\u{533F}",
        nfkd: "\u{533F}",
    },
    NormalizationTest {
        source: "\u{F9EC}",
        nfc: "\u{6EBA}",
        nfd: "\u{6EBA}",
        nfkc: "\u{6EBA}",
        nfkd: "\u{6EBA}",
    },
    NormalizationTest {
        source: "\u{F9ED}",
        nfc: "\u{541D}",
        nfd: "\u{541D}",
        nfkc: "\u{541D}",
        nfkd: "\u{541D}",
    },
    NormalizationTest {
        source: "\u{F9EE}",
        nfc: "\u{71D0}",
        nfd: "\u{71D0}",
        nfkc: "\u{71D0}",
        nfkd: "\u{71D0}",
    },
    NormalizationTest {
        source: "\u{F9EF}",
        nfc: "\u{7498}",
        nfd: "\u{7498}",
        nfkc: "\u{7498}",
        nfkd: "\u{7498}",
    },
    NormalizationTest {
        source: "\u{F9F0}",
        nfc: "\u{85FA}",
        nfd: "\u{85FA}",
        nfkc: "\u{85FA}",
        nfkd: "\u{85FA}",
    },
    NormalizationTest {
        source: "\u{F9F1}",
        nfc: "\u{96A3}",
        nfd: "\u{96A3}",
        nfkc: "\u{96A3}",
        nfkd: "\u{96A3}",
    },
    NormalizationTest {
        source: "\u{F9F2}",
        nfc: "\u{9C57}",
        nfd: "\u{9C57}",
        nfkc: "\u{9C57}",
        nfkd: "\u{9C57}",
    },
    NormalizationTest {
        source: "\u{F9F3}",
        nfc: "\u{9E9F}",
        nfd: "\u{9E9F}",
        nfkc: "\u{9E9F}",
        nfkd: "\u{9E9F}",
    },
    NormalizationTest {
        source: "\u{F9F4}",
        nfc: "\u{6797}",
        nfd: "\u{6797}",
        nfkc: "\u{6797}",
        nfkd: "\u{6797}",
    },
    NormalizationTest {
        source: "\u{F9F5}",
        nfc: "\u{6DCB}",
        nfd: "\u{6DCB}",
        nfkc: "\u{6DCB}",
        nfkd: "\u{6DCB}",
    },
    NormalizationTest {
        source: "\u{F9F6}",
        nfc: "\u{81E8}",
        nfd: "\u{81E8}",
        nfkc: "\u{81E8}",
        nfkd: "\u{81E8}",
    },
    NormalizationTest {
        source: "\u{F9F7}",
        nfc: "\u{7ACB}",
        nfd: "\u{7ACB}",
        nfkc: "\u{7ACB}",
        nfkd: "\u{7ACB}",
    },
    NormalizationTest {
        source: "\u{F9F8}",
        nfc: "\u{7B20}",
        nfd: "\u{7B20}",
        nfkc: "\u{7B20}",
        nfkd: "\u{7B20}",
    },
    NormalizationTest {
        source: "\u{F9F9}",
        nfc: "\u{7C92}",
        nfd: "\u{7C92}",
        nfkc: "\u{7C92}",
        nfkd: "\u{7C92}",
    },
    NormalizationTest {
        source: "\u{F9FA}",
        nfc: "\u{72C0}",
        nfd: "\u{72C0}",
        nfkc: "\u{72C0}",
        nfkd: "\u{72C0}",
    },
    NormalizationTest {
        source: "\u{F9FB}",
        nfc: "\u{7099}",
        nfd: "\u{7099}",
        nfkc: "\u{7099}",
        nfkd: "\u{7099}",
    },
    NormalizationTest {
        source: "\u{F9FC}",
        nfc: "\u{8B58}",
        nfd: "\u{8B58}",
        nfkc: "\u{8B58}",
        nfkd: "\u{8B58}",
    },
    NormalizationTest {
        source: "\u{F9FD}",
        nfc: "\u{4EC0}",
        nfd: "\u{4EC0}",
        nfkc: "\u{4EC0}",
        nfkd: "\u{4EC0}",
    },
    NormalizationTest {
        source: "\u{F9FE}",
        nfc: "\u{8336}",
        nfd: "\u{8336}",
        nfkc: "\u{8336}",
        nfkd: "\u{8336}",
    },
    NormalizationTest {
        source: "\u{F9FF}",
        nfc: "\u{523A}",
        nfd: "\u{523A}",
        nfkc: "\u{523A}",
        nfkd: "\u{523A}",
    },
    NormalizationTest {
        source: "\u{FA00}",
        nfc: "\u{5207}",
        nfd: "\u{5207}",
        nfkc: "\u{5207}",
        nfkd: "\u{5207}",
    },
    NormalizationTest {
        source: "\u{FA01}",
        nfc: "\u{5EA6}",
        nfd: "\u{5EA6}",
        nfkc: "\u{5EA6}",
        nfkd: "\u{5EA6}",
    },
    NormalizationTest {
        source: "\u{FA02}",
        nfc: "\u{62D3}",
        nfd: "\u{62D3}",
        nfkc: "\u{62D3}",
        nfkd: "\u{62D3}",
    },
    NormalizationTest {
        source: "\u{FA03}",
        nfc: "\u{7CD6}",
        nfd: "\u{7CD6}",
        nfkc: "\u{7CD6}",
        nfkd: "\u{7CD6}",
    },
    NormalizationTest {
        source: "\u{FA04}",
        nfc: "\u{5B85}",
        nfd: "\u{5B85}",
        nfkc: "\u{5B85}",
        nfkd: "\u{5B85}",
    },
    NormalizationTest {
        source: "\u{FA05}",
        nfc: "\u{6D1E}",
        nfd: "\u{6D1E}",
        nfkc: "\u{6D1E}",
        nfkd: "\u{6D1E}",
    },
    NormalizationTest {
        source: "\u{FA06}",
        nfc: "\u{66B4}",
        nfd: "\u{66B4}",
        nfkc: "\u{66B4}",
        nfkd: "\u{66B4}",
    },
    NormalizationTest {
        source: "\u{FA07}",
        nfc: "\u{8F3B}",
        nfd: "\u{8F3B}",
        nfkc: "\u{8F3B}",
        nfkd: "\u{8F3B}",
    },
    NormalizationTest {
        source: "\u{FA08}",
        nfc: "\u{884C}",
        nfd: "\u{884C}",
        nfkc: "\u{884C}",
        nfkd: "\u{884C}",
    },
    NormalizationTest {
        source: "\u{FA09}",
        nfc: "\u{964D}",
        nfd: "\u{964D}",
        nfkc: "\u{964D}",
        nfkd: "\u{964D}",
    },
    NormalizationTest {
        source: "\u{FA0A}",
        nfc: "\u{898B}",
        nfd: "\u{898B}",
        nfkc: "\u{898B}",
        nfkd: "\u{898B}",
    },
    NormalizationTest {
        source: "\u{FA0B}",
        nfc: "\u{5ED3}",
        nfd: "\u{5ED3}",
        nfkc: "\u{5ED3}",
        nfkd: "\u{5ED3}",
    },
    NormalizationTest {
        source: "\u{FA0C}",
        nfc: "\u{5140}",
        nfd: "\u{5140}",
        nfkc: "\u{5140}",
        nfkd: "\u{5140}",
    },
    NormalizationTest {
        source: "\u{FA0D}",
        nfc: "\u{55C0}",
        nfd: "\u{55C0}",
        nfkc: "\u{55C0}",
        nfkd: "\u{55C0}",
    },
    NormalizationTest {
        source: "\u{FA10}",
        nfc: "\u{585A}",
        nfd: "\u{585A}",
        nfkc: "\u{585A}",
        nfkd: "\u{585A}",
    },
    NormalizationTest {
        source: "\u{FA12}",
        nfc: "\u{6674}",
        nfd: "\u{6674}",
        nfkc: "\u{6674}",
        nfkd: "\u{6674}",
    },
    NormalizationTest {
        source: "\u{FA15}",
        nfc: "\u{51DE}",
        nfd: "\u{51DE}",
        nfkc: "\u{51DE}",
        nfkd: "\u{51DE}",
    },
    NormalizationTest {
        source: "\u{FA16}",
        nfc: "\u{732A}",
        nfd: "\u{732A}",
        nfkc: "\u{732A}",
        nfkd: "\u{732A}",
    },
    NormalizationTest {
        source: "\u{FA17}",
        nfc: "\u{76CA}",
        nfd: "\u{76CA}",
        nfkc: "\u{76CA}",
        nfkd: "\u{76CA}",
    },
    NormalizationTest {
        source: "\u{FA18}",
        nfc: "\u{793C}",
        nfd: "\u{793C}",
        nfkc: "\u{793C}",
        nfkd: "\u{793C}",
    },
    NormalizationTest {
        source: "\u{FA19}",
        nfc: "\u{795E}",
        nfd: "\u{795E}",
        nfkc: "\u{795E}",
        nfkd: "\u{795E}",
    },
    NormalizationTest {
        source: "\u{FA1A}",
        nfc: "\u{7965}",
        nfd: "\u{7965}",
        nfkc: "\u{7965}",
        nfkd: "\u{7965}",
    },
    NormalizationTest {
        source: "\u{FA1B}",
        nfc: "\u{798F}",
        nfd: "\u{798F}",
        nfkc: "\u{798F}",
        nfkd: "\u{798F}",
    },
    NormalizationTest {
        source: "\u{FA1C}",
        nfc: "\u{9756}",
        nfd: "\u{9756}",
        nfkc: "\u{9756}",
        nfkd: "\u{9756}",
    },
    NormalizationTest {
        source: "\u{FA1D}",
        nfc: "\u{7CBE}",
        nfd: "\u{7CBE}",
        nfkc: "\u{7CBE}",
        nfkd: "\u{7CBE}",
    },
    NormalizationTest {
        source: "\u{FA1E}",
        nfc: "\u{7FBD}",
        nfd: "\u{7FBD}",
        nfkc: "\u{7FBD}",
        nfkd: "\u{7FBD}",
    },
    NormalizationTest {
        source: "\u{FA20}",
        nfc: "\u{8612}",
        nfd: "\u{8612}",
        nfkc: "\u{8612}",
        nfkd: "\u{8612}",
    },
    NormalizationTest {
        source: "\u{FA22}",
        nfc: "\u{8AF8}",
        nfd: "\u{8AF8}",
        nfkc: "\u{8AF8}",
        nfkd: "\u{8AF8}",
    },
    NormalizationTest {
        source: "\u{FA25}",
        nfc: "\u{9038}",
        nfd: "\u{9038}",
        nfkc: "\u{9038}",
        nfkd: "\u{9038}",
    },
    NormalizationTest {
        source: "\u{FA26}",
        nfc: "\u{90FD}",
        nfd: "\u{90FD}",
        nfkc: "\u{90FD}",
        nfkd: "\u{90FD}",
    },
    NormalizationTest {
        source: "\u{FA2A}",
        nfc: "\u{98EF}",
        nfd: "\u{98EF}",
        nfkc: "\u{98EF}",
        nfkd: "\u{98EF}",
    },
    NormalizationTest {
        source: "\u{FA2B}",
        nfc: "\u{98FC}",
        nfd: "\u{98FC}",
        nfkc: "\u{98FC}",
        nfkd: "\u{98FC}",
    },
    NormalizationTest {
        source: "\u{FA2C}",
        nfc: "\u{9928}",
        nfd: "\u{9928}",
        nfkc: "\u{9928}",
        nfkd: "\u{9928}",
    },
    NormalizationTest {
        source: "\u{FA2D}",
        nfc: "\u{9DB4}",
        nfd: "\u{9DB4}",
        nfkc: "\u{9DB4}",
        nfkd: "\u{9DB4}",
    },
    NormalizationTest {
        source: "\u{FA2E}",
        nfc: "\u{90DE}",
        nfd: "\u{90DE}",
        nfkc: "\u{90DE}",
        nfkd: "\u{90DE}",
    },
    NormalizationTest {
        source: "\u{FA2F}",
        nfc: "\u{96B7}",
        nfd: "\u{96B7}",
        nfkc: "\u{96B7}",
        nfkd: "\u{96B7}",
    },
    NormalizationTest {
        source: "\u{FA30}",
        nfc: "\u{4FAE}",
        nfd: "\u{4FAE}",
        nfkc: "\u{4FAE}",
        nfkd: "\u{4FAE}",
    },
    NormalizationTest {
        source: "\u{FA31}",
        nfc: "\u{50E7}",
        nfd: "\u{50E7}",
        nfkc: "\u{50E7}",
        nfkd: "\u{50E7}",
    },
    NormalizationTest {
        source: "\u{FA32}",
        nfc: "\u{514D}",
        nfd: "\u{514D}",
        nfkc: "\u{514D}",
        nfkd: "\u{514D}",
    },
    NormalizationTest {
        source: "\u{FA33}",
        nfc: "\u{52C9}",
        nfd: "\u{52C9}",
        nfkc: "\u{52C9}",
        nfkd: "\u{52C9}",
    },
    NormalizationTest {
        source: "\u{FA34}",
        nfc: "\u{52E4}",
        nfd: "\u{52E4}",
        nfkc: "\u{52E4}",
        nfkd: "\u{52E4}",
    },
    NormalizationTest {
        source: "\u{FA35}",
        nfc: "\u{5351}",
        nfd: "\u{5351}",
        nfkc: "\u{5351}",
        nfkd: "\u{5351}",
    },
    NormalizationTest {
        source: "\u{FA36}",
        nfc: "\u{559D}",
        nfd: "\u{559D}",
        nfkc: "\u{559D}",
        nfkd: "\u{559D}",
    },
    NormalizationTest {
        source: "\u{FA37}",
        nfc: "\u{5606}",
        nfd: "\u{5606}",
        nfkc: "\u{5606}",
        nfkd: "\u{5606}",
    },
    NormalizationTest {
        source: "\u{FA38}",
        nfc: "\u{5668}",
        nfd: "\u{5668}",
        nfkc: "\u{5668}",
        nfkd: "\u{5668}",
    },
    NormalizationTest {
        source: "\u{FA39}",
        nfc: "\u{5840}",
        nfd: "\u{5840}",
        nfkc: "\u{5840}",
        nfkd: "\u{5840}",
    },
    NormalizationTest {
        source: "\u{FA3A}",
        nfc: "\u{58A8}",
        nfd: "\u{58A8}",
        nfkc: "\u{58A8}",
        nfkd: "\u{58A8}",
    },
    NormalizationTest {
        source: "\u{FA3B}",
        nfc: "\u{5C64}",
        nfd: "\u{5C64}",
        nfkc: "\u{5C64}",
        nfkd: "\u{5C64}",
    },
    NormalizationTest {
        source: "\u{FA3C}",
        nfc: "\u{5C6E}",
        nfd: "\u{5C6E}",
        nfkc: "\u{5C6E}",
        nfkd: "\u{5C6E}",
    },
    NormalizationTest {
        source: "\u{FA3D}",
        nfc: "\u{6094}",
        nfd: "\u{6094}",
        nfkc: "\u{6094}",
        nfkd: "\u{6094}",
    },
    NormalizationTest {
        source: "\u{FA3E}",
        nfc: "\u{6168}",
        nfd: "\u{6168}",
        nfkc: "\u{6168}",
        nfkd: "\u{6168}",
    },
    NormalizationTest {
        source: "\u{FA3F}",
        nfc: "\u{618E}",
        nfd: "\u{618E}",
        nfkc: "\u{618E}",
        nfkd: "\u{618E}",
    },
    NormalizationTest {
        source: "\u{FA40}",
        nfc: "\u{61F2}",
        nfd: "\u{61F2}",
        nfkc: "\u{61F2}",
        nfkd: "\u{61F2}",
    },
    NormalizationTest {
        source: "\u{FA41}",
        nfc: "\u{654F}",
        nfd: "\u{654F}",
        nfkc: "\u{654F}",
        nfkd: "\u{654F}",
    },
    NormalizationTest {
        source: "\u{FA42}",
        nfc: "\u{65E2}",
        nfd: "\u{65E2}",
        nfkc: "\u{65E2}",
        nfkd: "\u{65E2}",
    },
    NormalizationTest {
        source: "\u{FA43}",
        nfc: "\u{6691}",
        nfd: "\u{6691}",
        nfkc: "\u{6691}",
        nfkd: "\u{6691}",
    },
    NormalizationTest {
        source: "\u{FA44}",
        nfc: "\u{6885}",
        nfd: "\u{6885}",
        nfkc: "\u{6885}",
        nfkd: "\u{6885}",
    },
    NormalizationTest {
        source: "\u{FA45}",
        nfc: "\u{6D77}",
        nfd: "\u{6D77}",
        nfkc: "\u{6D77}",
        nfkd: "\u{6D77}",
    },
    NormalizationTest {
        source: "\u{FA46}",
        nfc: "\u{6E1A}",
        nfd: "\u{6E1A}",
        nfkc: "\u{6E1A}",
        nfkd: "\u{6E1A}",
    },
    NormalizationTest {
        source: "\u{FA47}",
        nfc: "\u{6F22}",
        nfd: "\u{6F22}",
        nfkc: "\u{6F22}",
        nfkd: "\u{6F22}",
    },
    NormalizationTest {
        source: "\u{FA48}",
        nfc: "\u{716E}",
        nfd: "\u{716E}",
        nfkc: "\u{716E}",
        nfkd: "\u{716E}",
    },
    NormalizationTest {
        source: "\u{FA49}",
        nfc: "\u{722B}",
        nfd: "\u{722B}",
        nfkc: "\u{722B}",
        nfkd: "\u{722B}",
    },
    NormalizationTest {
        source: "\u{FA4A}",
        nfc: "\u{7422}",
        nfd: "\u{7422}",
        nfkc: "\u{7422}",
        nfkd: "\u{7422}",
    },
    NormalizationTest {
        source: "\u{FA4B}",
        nfc: "\u{7891}",
        nfd: "\u{7891}",
        nfkc: "\u{7891}",
        nfkd: "\u{7891}",
    },
    NormalizationTest {
        source: "\u{FA4C}",
        nfc: "\u{793E}",
        nfd: "\u{793E}",
        nfkc: "\u{793E}",
        nfkd: "\u{793E}",
    },
    NormalizationTest {
        source: "\u{FA4D}",
        nfc: "\u{7949}",
        nfd: "\u{7949}",
        nfkc: "\u{7949}",
        nfkd: "\u{7949}",
    },
    NormalizationTest {
        source: "\u{FA4E}",
        nfc: "\u{7948}",
        nfd: "\u{7948}",
        nfkc: "\u{7948}",
        nfkd: "\u{7948}",
    },
    NormalizationTest {
        source: "\u{FA4F}",
        nfc: "\u{7950}",
        nfd: "\u{7950}",
        nfkc: "\u{7950}",
        nfkd: "\u{7950}",
    },
    NormalizationTest {
        source: "\u{FA50}",
        nfc: "\u{7956}",
        nfd: "\u{7956}",
        nfkc: "\u{7956}",
        nfkd: "\u{7956}",
    },
    NormalizationTest {
        source: "\u{FA51}",
        nfc: "\u{795D}",
        nfd: "\u{795D}",
        nfkc: "\u{795D}",
        nfkd: "\u{795D}",
    },
    NormalizationTest {
        source: "\u{FA52}",
        nfc: "\u{798D}",
        nfd: "\u{798D}",
        nfkc: "\u{798D}",
        nfkd: "\u{798D}",
    },
    NormalizationTest {
        source: "\u{FA53}",
        nfc: "\u{798E}",
        nfd: "\u{798E}",
        nfkc: "\u{798E}",
        nfkd: "\u{798E}",
    },
    NormalizationTest {
        source: "\u{FA54}",
        nfc: "\u{7A40}",
        nfd: "\u{7A40}",
        nfkc: "\u{7A40}",
        nfkd: "\u{7A40}",
    },
    NormalizationTest {
        source: "\u{FA55}",
        nfc: "\u{7A81}",
        nfd: "\u{7A81}",
        nfkc: "\u{7A81}",
        nfkd: "\u{7A81}",
    },
    NormalizationTest {
        source: "\u{FA56}",
        nfc: "\u{7BC0}",
        nfd: "\u{7BC0}",
        nfkc: "\u{7BC0}",
        nfkd: "\u{7BC0}",
    },
    NormalizationTest {
        source: "\u{FA57}",
        nfc: "\u{7DF4}",
        nfd: "\u{7DF4}",
        nfkc: "\u{7DF4}",
        nfkd: "\u{7DF4}",
    },
    NormalizationTest {
        source: "\u{FA58}",
        nfc: "\u{7E09}",
        nfd: "\u{7E09}",
        nfkc: "\u{7E09}",
        nfkd: "\u{7E09}",
    },
    NormalizationTest {
        source: "\u{FA59}",
        nfc: "\u{7E41}",
        nfd: "\u{7E41}",
        nfkc: "\u{7E41}",
        nfkd: "\u{7E41}",
    },
    NormalizationTest {
        source: "\u{FA5A}",
        nfc: "\u{7F72}",
        nfd: "\u{7F72}",
        nfkc: "\u{7F72}",
        nfkd: "\u{7F72}",
    },
    NormalizationTest {
        source: "\u{FA5B}",
        nfc: "\u{8005}",
        nfd: "\u{8005}",
        nfkc: "\u{8005}",
        nfkd: "\u{8005}",
    },
    NormalizationTest {
        source: "\u{FA5C}",
        nfc: "\u{81ED}",
        nfd: "\u{81ED}",
        nfkc: "\u{81ED}",
        nfkd: "\u{81ED}",
    },
    NormalizationTest {
        source: "\u{FA5D}",
        nfc: "\u{8279}",
        nfd: "\u{8279}",
        nfkc: "\u{8279}",
        nfkd: "\u{8279}",
    },
    NormalizationTest {
        source: "\u{FA5E}",
        nfc: "\u{8279}",
        nfd: "\u{8279}",
        nfkc: "\u{8279}",
        nfkd: "\u{8279}",
    },
    NormalizationTest {
        source: "\u{FA5F}",
        nfc: "\u{8457}",
        nfd: "\u{8457}",
        nfkc: "\u{8457}",
        nfkd: "\u{8457}",
    },
    NormalizationTest {
        source: "\u{FA60}",
        nfc: "\u{8910}",
        nfd: "\u{8910}",
        nfkc: "\u{8910}",
        nfkd: "\u{8910}",
    },
    NormalizationTest {
        source: "\u{FA61}",
        nfc: "\u{8996}",
        nfd: "\u{8996}",
        nfkc: "\u{8996}",
        nfkd: "\u{8996}",
    },
    NormalizationTest {
        source: "\u{FA62}",
        nfc: "\u{8B01}",
        nfd: "\u{8B01}",
        nfkc: "\u{8B01}",
        nfkd: "\u{8B01}",
    },
    NormalizationTest {
        source: "\u{FA63}",
        nfc: "\u{8B39}",
        nfd: "\u{8B39}",
        nfkc: "\u{8B39}",
        nfkd: "\u{8B39}",
    },
    NormalizationTest {
        source: "\u{FA64}",
        nfc: "\u{8CD3}",
        nfd: "\u{8CD3}",
        nfkc: "\u{8CD3}",
        nfkd: "\u{8CD3}",
    },
    NormalizationTest {
        source: "\u{FA65}",
        nfc: "\u{8D08}",
        nfd: "\u{8D08}",
        nfkc: "\u{8D08}",
        nfkd: "\u{8D08}",
    },
    NormalizationTest {
        source: "\u{FA66}",
        nfc: "\u{8FB6}",
        nfd: "\u{8FB6}",
        nfkc: "\u{8FB6}",
        nfkd: "\u{8FB6}",
    },
    NormalizationTest {
        source: "\u{FA67}",
        nfc: "\u{9038}",
        nfd: "\u{9038}",
        nfkc: "\u{9038}",
        nfkd: "\u{9038}",
    },
    NormalizationTest {
        source: "\u{FA68}",
        nfc: "\u{96E3}",
        nfd: "\u{96E3}",
        nfkc: "\u{96E3}",
        nfkd: "\u{96E3}",
    },
    NormalizationTest {
        source: "\u{FA69}",
        nfc: "\u{97FF}",
        nfd: "\u{97FF}",
        nfkc: "\u{97FF}",
        nfkd: "\u{97FF}",
    },
    NormalizationTest {
        source: "\u{FA6A}",
        nfc: "\u{983B}",
        nfd: "\u{983B}",
        nfkc: "\u{983B}",
        nfkd: "\u{983B}",
    },
    NormalizationTest {
        source: "\u{FA6B}",
        nfc: "\u{6075}",
        nfd: "\u{6075}",
        nfkc: "\u{6075}",
        nfkd: "\u{6075}",
    },
    NormalizationTest {
        source: "\u{FA6C}",
        nfc: "\u{242EE}",
        nfd: "\u{242EE}",
        nfkc: "\u{242EE}",
        nfkd: "\u{242EE}",
    },
    NormalizationTest {
        source: "\u{FA6D}",
        nfc: "\u{8218}",
        nfd: "\u{8218}",
        nfkc: "\u{8218}",
        nfkd: "\u{8218}",
    },
    NormalizationTest {
        source: "\u{FA70}",
        nfc: "\u{4E26}",
        nfd: "\u{4E26}",
        nfkc: "\u{4E26}",
        nfkd: "\u{4E26}",
    },
    NormalizationTest {
        source: "\u{FA71}",
        nfc: "\u{51B5}",
        nfd: "\u{51B5}",
        nfkc: "\u{51B5}",
        nfkd: "\u{51B5}",
    },
    NormalizationTest {
        source: "\u{FA72}",
        nfc: "\u{5168}",
        nfd: "\u{5168}",
        nfkc: "\u{5168}",
        nfkd: "\u{5168}",
    },
    NormalizationTest {
        source: "\u{FA73}",
        nfc: "\u{4F80}",
        nfd: "\u{4F80}",
        nfkc: "\u{4F80}",
        nfkd: "\u{4F80}",
    },
    NormalizationTest {
        source: "\u{FA74}",
        nfc: "\u{5145}",
        nfd: "\u{5145}",
        nfkc: "\u{5145}",
        nfkd: "\u{5145}",
    },
    NormalizationTest {
        source: "\u{FA75}",
        nfc: "\u{5180}",
        nfd: "\u{5180}",
        nfkc: "\u{5180}",
        nfkd: "\u{5180}",
    },
    NormalizationTest {
        source: "\u{FA76}",
        nfc: "\u{52C7}",
        nfd: "\u{52C7}",
        nfkc: "\u{52C7}",
        nfkd: "\u{52C7}",
    },
    NormalizationTest {
        source: "\u{FA77}",
        nfc: "\u{52FA}",
        nfd: "\u{52FA}",
        nfkc: "\u{52FA}",
        nfkd: "\u{52FA}",
    },
    NormalizationTest {
        source: "\u{FA78}",
        nfc: "\u{559D}",
        nfd: "\u{559D}",
        nfkc: "\u{559D}",
        nfkd: "\u{559D}",
    },
    NormalizationTest {
        source: "\u{FA79}",
        nfc: "\u{5555}",
        nfd: "\u{5555}",
        nfkc: "\u{5555}",
        nfkd: "\u{5555}",
    },
    NormalizationTest {
        source: "\u{FA7A}",
        nfc: "\u{5599}",
        nfd: "\u{5599}",
        nfkc: "\u{5599}",
        nfkd: "\u{5599}",
    },
    NormalizationTest {
        source: "\u{FA7B}",
        nfc: "\u{55E2}",
        nfd: "\u{55E2}",
        nfkc: "\u{55E2}",
        nfkd: "\u{55E2}",
    },
    NormalizationTest {
        source: "\u{FA7C}",
        nfc: "\u{585A}",
        nfd: "\u{585A}",
        nfkc: "\u{585A}",
        nfkd: "\u{585A}",
    },
    NormalizationTest {
        source: "\u{FA7D}",
        nfc: "\u{58B3}",
        nfd: "\u{58B3}",
        nfkc: "\u{58B3}",
        nfkd: "\u{58B3}",
    },
    NormalizationTest {
        source: "\u{FA7E}",
        nfc: "\u{5944}",
        nfd: "\u{5944}",
        nfkc: "\u{5944}",
        nfkd: "\u{5944}",
    },
    NormalizationTest {
        source: "\u{FA7F}",
        nfc: "\u{5954}",
        nfd: "\u{5954}",
        nfkc: "\u{5954}",
        nfkd: "\u{5954}",
    },
    NormalizationTest {
        source: "\u{FA80}",
        nfc: "\u{5A62}",
        nfd: "\u{5A62}",
        nfkc: "\u{5A62}",
        nfkd: "\u{5A62}",
    },
    NormalizationTest {
        source: "\u{FA81}",
        nfc: "\u{5B28}",
        nfd: "\u{5B28}",
        nfkc: "\u{5B28}",
        nfkd: "\u{5B28}",
    },
    NormalizationTest {
        source: "\u{FA82}",
        nfc: "\u{5ED2}",
        nfd: "\u{5ED2}",
        nfkc: "\u{5ED2}",
        nfkd: "\u{5ED2}",
    },
    NormalizationTest {
        source: "\u{FA83}",
        nfc: "\u{5ED9}",
        nfd: "\u{5ED9}",
        nfkc: "\u{5ED9}",
        nfkd: "\u{5ED9}",
    },
    NormalizationTest {
        source: "\u{FA84}",
        nfc: "\u{5F69}",
        nfd: "\u{5F69}",
        nfkc: "\u{5F69}",
        nfkd: "\u{5F69}",
    },
    NormalizationTest {
        source: "\u{FA85}",
        nfc: "\u{5FAD}",
        nfd: "\u{5FAD}",
        nfkc: "\u{5FAD}",
        nfkd: "\u{5FAD}",
    },
    NormalizationTest {
        source: "\u{FA86}",
        nfc: "\u{60D8}",
        nfd: "\u{60D8}",
        nfkc: "\u{60D8}",
        nfkd: "\u{60D8}",
    },
    NormalizationTest {
        source: "\u{FA87}",
        nfc: "\u{614E}",
        nfd: "\u{614E}",
        nfkc: "\u{614E}",
        nfkd: "\u{614E}",
    },
    NormalizationTest {
        source: "\u{FA88}",
        nfc: "\u{6108}",
        nfd: "\u{6108}",
        nfkc: "\u{6108}",
        nfkd: "\u{6108}",
    },
    NormalizationTest {
        source: "\u{FA89}",
        nfc: "\u{618E}",
        nfd: "\u{618E}",
        nfkc: "\u{618E}",
        nfkd: "\u{618E}",
    },
    NormalizationTest {
        source: "\u{FA8A}",
        nfc: "\u{6160}",
        nfd: "\u{6160}",
        nfkc: "\u{6160}",
        nfkd: "\u{6160}",
    },
    NormalizationTest {
        source: "\u{FA8B}",
        nfc: "\u{61F2}",
        nfd: "\u{61F2}",
        nfkc: "\u{61F2}",
        nfkd: "\u{61F2}",
    },
    NormalizationTest {
        source: "\u{FA8C}",
        nfc: "\u{6234}",
        nfd: "\u{6234}",
        nfkc: "\u{6234}",
        nfkd: "\u{6234}",
    },
    NormalizationTest {
        source: "\u{FA8D}",
        nfc: "\u{63C4}",
        nfd: "\u{63C4}",
        nfkc: "\u{63C4}",
        nfkd: "\u{63C4}",
    },
    NormalizationTest {
        source: "\u{FA8E}",
        nfc: "\u{641C}",
        nfd: "\u{641C}",
        nfkc: "\u{641C}",
        nfkd: "\u{641C}",
    },
    NormalizationTest {
        source: "\u{FA8F}",
        nfc: "\u{6452}",
        nfd: "\u{6452}",
        nfkc: "\u{6452}",
        nfkd: "\u{6452}",
    },
    NormalizationTest {
        source: "\u{FA90}",
        nfc: "\u{6556}",
        nfd: "\u{6556}",
        nfkc: "\u{6556}",
        nfkd: "\u{6556}",
    },
    NormalizationTest {
        source: "\u{FA91}",
        nfc: "\u{6674}",
        nfd: "\u{6674}",
        nfkc: "\u{6674}",
        nfkd: "\u{6674}",
    },
    NormalizationTest {
        source: "\u{FA92}",
        nfc: "\u{6717}",
        nfd: "\u{6717}",
        nfkc: "\u{6717}",
        nfkd: "\u{6717}",
    },
    NormalizationTest {
        source: "\u{FA93}",
        nfc: "\u{671B}",
        nfd: "\u{671B}",
        nfkc: "\u{671B}",
        nfkd: "\u{671B}",
    },
    NormalizationTest {
        source: "\u{FA94}",
        nfc: "\u{6756}",
        nfd: "\u{6756}",
        nfkc: "\u{6756}",
        nfkd: "\u{6756}",
    },
    NormalizationTest {
        source: "\u{FA95}",
        nfc: "\u{6B79}",
        nfd: "\u{6B79}",
        nfkc: "\u{6B79}",
        nfkd: "\u{6B79}",
    },
    NormalizationTest {
        source: "\u{FA96}",
        nfc: "\u{6BBA}",
        nfd: "\u{6BBA}",
        nfkc: "\u{6BBA}",
        nfkd: "\u{6BBA}",
    },
    NormalizationTest {
        source: "\u{FA97}",
        nfc: "\u{6D41}",
        nfd: "\u{6D41}",
        nfkc: "\u{6D41}",
        nfkd: "\u{6D41}",
    },
    NormalizationTest {
        source: "\u{FA98}",
        nfc: "\u{6EDB}",
        nfd: "\u{6EDB}",
        nfkc: "\u{6EDB}",
        nfkd: "\u{6EDB}",
    },
    NormalizationTest {
        source: "\u{FA99}",
        nfc: "\u{6ECB}",
        nfd: "\u{6ECB}",
        nfkc: "\u{6ECB}",
        nfkd: "\u{6ECB}",
    },
    NormalizationTest {
        source: "\u{FA9A}",
        nfc: "\u{6F22}",
        nfd: "\u{6F22}",
        nfkc: "\u{6F22}",
        nfkd: "\u{6F22}",
    },
    NormalizationTest {
        source: "\u{FA9B}",
        nfc: "\u{701E}",
        nfd: "\u{701E}",
        nfkc: "\u{701E}",
        nfkd: "\u{701E}",
    },
    NormalizationTest {
        source: "\u{FA9C}",
        nfc: "\u{716E}",
        nfd: "\u{716E}",
        nfkc: "\u{716E}",
        nfkd: "\u{716E}",
    },
    NormalizationTest {
        source: "\u{FA9D}",
        nfc: "\u{77A7}",
        nfd: "\u{77A7}",
        nfkc: "\u{77A7}",
        nfkd: "\u{77A7}",
    },
    NormalizationTest {
        source: "\u{FA9E}",
        nfc: "\u{7235}",
        nfd: "\u{7235}",
        nfkc: "\u{7235}",
        nfkd: "\u{7235}",
    },
    NormalizationTest {
        source: "\u{FA9F}",
        nfc: "\u{72AF}",
        nfd: "\u{72AF}",
        nfkc: "\u{72AF}",
        nfkd: "\u{72AF}",
    },
    NormalizationTest {
        source: "\u{FAA0}",
        nfc: "\u{732A}",
        nfd: "\u{732A}",
        nfkc: "\u{732A}",
        nfkd: "\u{732A}",
    },
    NormalizationTest {
        source: "\u{FAA1}",
        nfc: "\u{7471}",
        nfd: "\u{7471}",
        nfkc: "\u{7471}",
        nfkd: "\u{7471}",
    },
    NormalizationTest {
        source: "\u{FAA2}",
        nfc: "\u{7506}",
        nfd: "\u{7506}",
        nfkc: "\u{7506}",
        nfkd: "\u{7506}",
    },
    NormalizationTest {
        source: "\u{FAA3}",
        nfc: "\u{753B}",
        nfd: "\u{753B}",
        nfkc: "\u{753B}",
        nfkd: "\u{753B}",
    },
    NormalizationTest {
        source: "\u{FAA4}",
        nfc: "\u{761D}",
        nfd: "\u{761D}",
        nfkc: "\u{761D}",
        nfkd: "\u{761D}",
    },
    NormalizationTest {
        source: "\u{FAA5}",
        nfc: "\u{761F}",
        nfd: "\u{761F}",
        nfkc: "\u{761F}",
        nfkd: "\u{761F}",
    },
    NormalizationTest {
        source: "\u{FAA6}",
        nfc: "\u{76CA}",
        nfd: "\u{76CA}",
        nfkc: "\u{76CA}",
        nfkd: "\u{76CA}",
    },
    NormalizationTest {
        source: "\u{FAA7}",
        nfc: "\u{76DB}",
        nfd: "\u{76DB}",
        nfkc: "\u{76DB}",
        nfkd: "\u{76DB}",
    },
    NormalizationTest {
        source: "\u{FAA8}",
        nfc: "\u{76F4}",
        nfd: "\u{76F4}",
        nfkc: "\u{76F4}",
        nfkd: "\u{76F4}",
    },
    NormalizationTest {
        source: "\u{FAA9}",
        nfc: "\u{774A}",
        nfd: "\u{774A}",
        nfkc: "\u{774A}",
        nfkd: "\u{774A}",
    },
    NormalizationTest {
        source: "\u{FAAA}",
        nfc: "\u{7740}",
        nfd: "\u{7740}",
        nfkc: "\u{7740}",
        nfkd: "\u{7740}",
    },
    NormalizationTest {
        source: "\u{FAAB}",
        nfc: "\u{78CC}",
        nfd: "\u{78CC}",
        nfkc: "\u{78CC}",
        nfkd: "\u{78CC}",
    },
    NormalizationTest {
        source: "\u{FAAC}",
        nfc: "\u{7AB1}",
        nfd: "\u{7AB1}",
        nfkc: "\u{7AB1}",
        nfkd: "\u{7AB1}",
    },
    NormalizationTest {
        source: "\u{FAAD}",
        nfc: "\u{7BC0}",
        nfd: "\u{7BC0}",
        nfkc: "\u{7BC0}",
        nfkd: "\u{7BC0}",
    },
    NormalizationTest {
        source: "\u{FAAE}",
        nfc: "\u{7C7B}",
        nfd: "\u{7C7B}",
        nfkc: "\u{7C7B}",
        nfkd: "\u{7C7B}",
    },
    NormalizationTest {
        source: "\u{FAAF}",
        nfc: "\u{7D5B}",
        nfd: "\u{7D5B}",
        nfkc: "\u{7D5B}",
        nfkd: "\u{7D5B}",
    },
    NormalizationTest {
        source: "\u{FAB0}",
        nfc: "\u{7DF4}",
        nfd: "\u{7DF4}",
        nfkc: "\u{7DF4}",
        nfkd: "\u{7DF4}",
    },
    NormalizationTest {
        source: "\u{FAB1}",
        nfc: "\u{7F3E}",
        nfd: "\u{7F3E}",
        nfkc: "\u{7F3E}",
        nfkd: "\u{7F3E}",
    },
    NormalizationTest {
        source: "\u{FAB2}",
        nfc: "\u{8005}",
        nfd: "\u{8005}",
        nfkc: "\u{8005}",
        nfkd: "\u{8005}",
    },
    NormalizationTest {
        source: "\u{FAB3}",
        nfc: "\u{8352}",
        nfd: "\u{8352}",
        nfkc: "\u{8352}",
        nfkd: "\u{8352}",
    },
    NormalizationTest {
        source: "\u{FAB4}",
        nfc: "\u{83EF}",
        nfd: "\u{83EF}",
        nfkc: "\u{83EF}",
        nfkd: "\u{83EF}",
    },
    NormalizationTest {
        source: "\u{FAB5}",
        nfc: "\u{8779}",
        nfd: "\u{8779}",
        nfkc: "\u{8779}",
        nfkd: "\u{8779}",
    },
    NormalizationTest {
        source: "\u{FAB6}",
        nfc: "\u{8941}",
        nfd: "\u{8941}",
        nfkc: "\u{8941}",
        nfkd: "\u{8941}",
    },
    NormalizationTest {
        source: "\u{FAB7}",
        nfc: "\u{8986}",
        nfd: "\u{8986}",
        nfkc: "\u{8986}",
        nfkd: "\u{8986}",
    },
    NormalizationTest {
        source: "\u{FAB8}",
        nfc: "\u{8996}",
        nfd: "\u{8996}",
        nfkc: "\u{8996}",
        nfkd: "\u{8996}",
    },
    NormalizationTest {
        source: "\u{FAB9}",
        nfc: "\u{8ABF}",
        nfd: "\u{8ABF}",
        nfkc: "\u{8ABF}",
        nfkd: "\u{8ABF}",
    },
    NormalizationTest {
        source: "\u{FABA}",
        nfc: "\u{8AF8}",
        nfd: "\u{8AF8}",
        nfkc: "\u{8AF8}",
        nfkd: "\u{8AF8}",
    },
    NormalizationTest {
        source: "\u{FABB}",
        nfc: "\u{8ACB}",
        nfd: "\u{8ACB}",
        nfkc: "\u{8ACB}",
        nfkd: "\u{8ACB}",
    },
    NormalizationTest {
        source: "\u{FABC}",
        nfc: "\u{8B01}",
        nfd: "\u{8B01}",
        nfkc: "\u{8B01}",
        nfkd: "\u{8B01}",
    },
    NormalizationTest {
        source: "\u{FABD}",
        nfc: "\u{8AFE}",
        nfd: "\u{8AFE}",
        nfkc: "\u{8AFE}",
        nfkd: "\u{8AFE}",
    },
    NormalizationTest {
        source: "\u{FABE}",
        nfc: "\u{8AED}",
        nfd: "\u{8AED}",
        nfkc: "\u{8AED}",
        nfkd: "\u{8AED}",
    },
    NormalizationTest {
        source: "\u{FABF}",
        nfc: "\u{8B39}",
        nfd: "\u{8B39}",
        nfkc: "\u{8B39}",
        nfkd: "\u{8B39}",
    },
    NormalizationTest {
        source: "\u{FAC0}",
        nfc: "\u{8B8A}",
        nfd: "\u{8B8A}",
        nfkc: "\u{8B8A}",
        nfkd: "\u{8B8A}",
    },
    NormalizationTest {
        source: "\u{FAC1}",
        nfc: "\u{8D08}",
        nfd: "\u{8D08}",
        nfkc: "\u{8D08}",
        nfkd: "\u{8D08}",
    },
    NormalizationTest {
        source: "\u{FAC2}",
        nfc: "\u{8F38}",
        nfd: "\u{8F38}",
        nfkc: "\u{8F38}",
        nfkd: "\u{8F38}",
    },
    NormalizationTest {
        source: "\u{FAC3}",
        nfc: "\u{9072}",
        nfd: "\u{9072}",
        nfkc: "\u{9072}",
        nfkd: "\u{9072}",
    },
    NormalizationTest {
        source: "\u{FAC4}",
        nfc: "\u{9199}",
        nfd: "\u{9199}",
        nfkc: "\u{9199}",
        nfkd: "\u{9199}",
    },
    NormalizationTest {
        source: "\u{FAC5}",
        nfc: "\u{9276}",
        nfd: "\u{9276}",
        nfkc: "\u{9276}",
        nfkd: "\u{9276}",
    },
    NormalizationTest {
        source: "\u{FAC6}",
        nfc: "\u{967C}",
        nfd: "\u{967C}",
        nfkc: "\u{967C}",
        nfkd: "\u{967C}",
    },
    NormalizationTest {
        source: "\u{FAC7}",
        nfc: "\u{96E3}",
        nfd: "\u{96E3}",
        nfkc: "\u{96E3}",
        nfkd: "\u{96E3}",
    },
    NormalizationTest {
        source: "\u{FAC8}",
        nfc: "\u{9756}",
        nfd: "\u{9756}",
        nfkc: "\u{9756}",
        nfkd: "\u{9756}",
    },
    NormalizationTest {
        source: "\u{FAC9}",
        nfc: "\u{97DB}",
        nfd: "\u{97DB}",
        nfkc: "\u{97DB}",
        nfkd: "\u{97DB}",
    },
    NormalizationTest {
        source: "\u{FACA}",
        nfc: "\u{97FF}",
        nfd: "\u{97FF}",
        nfkc: "\u{97FF}",
        nfkd: "\u{97FF}",
    },
    NormalizationTest {
        source: "\u{FACB}",
        nfc: "\u{980B}",
        nfd: "\u{980B}",
        nfkc: "\u{980B}",
        nfkd: "\u{980B}",
    },
    NormalizationTest {
        source: "\u{FACC}",
        nfc: "\u{983B}",
        nfd: "\u{983B}",
        nfkc: "\u{983B}",
        nfkd: "\u{983B}",
    },
    NormalizationTest {
        source: "\u{FACD}",
        nfc: "\u{9B12}",
        nfd: "\u{9B12}",
        nfkc: "\u{9B12}",
        nfkd: "\u{9B12}",
    },
    NormalizationTest {
        source: "\u{FACE}",
        nfc: "\u{9F9C}",
        nfd: "\u{9F9C}",
        nfkc: "\u{9F9C}",
        nfkd: "\u{9F9C}",
    },
    NormalizationTest {
        source: "\u{FACF}",
        nfc: "\u{2284A}",
        nfd: "\u{2284A}",
        nfkc: "\u{2284A}",
        nfkd: "\u{2284A}",
    },
    NormalizationTest {
        source: "\u{FAD0}",
        nfc: "\u{22844}",
        nfd: "\u{22844}",
        nfkc: "\u{22844}",
        nfkd: "\u{22844}",
    },
    NormalizationTest {
        source: "\u{FAD1}",
        nfc: "\u{233D5}",
        nfd: "\u{233D5}",
        nfkc: "\u{233D5}",
        nfkd: "\u{233D5}",
    },
    NormalizationTest {
        source: "\u{FAD2}",
        nfc: "\u{3B9D}",
        nfd: "\u{3B9D}",
        nfkc: "\u{3B9D}",
        nfkd: "\u{3B9D}",
    },
    NormalizationTest {
        source: "\u{FAD3}",
        nfc: "\u{4018}",
        nfd: "\u{4018}",
        nfkc: "\u{4018}",
        nfkd: "\u{4018}",
    },
    NormalizationTest {
        source: "\u{FAD4}",
        nfc: "\u{4039}",
        nfd: "\u{4039}",
        nfkc: "\u{4039}",
        nfkd: "\u{4039}",
    },
    NormalizationTest {
        source: "\u{FAD5}",
        nfc: "\u{25249}",
        nfd: "\u{25249}",
        nfkc: "\u{25249}",
        nfkd: "\u{25249}",
    },
    NormalizationTest {
        source: "\u{FAD6}",
        nfc: "\u{25CD0}",
        nfd: "\u{25CD0}",
        nfkc: "\u{25CD0}",
        nfkd: "\u{25CD0}",
    },
    NormalizationTest {
        source: "\u{FAD7}",
        nfc: "\u{27ED3}",
        nfd: "\u{27ED3}",
        nfkc: "\u{27ED3}",
        nfkd: "\u{27ED3}",
    },
    NormalizationTest {
        source: "\u{FAD8}",
        nfc: "\u{9F43}",
        nfd: "\u{9F43}",
        nfkc: "\u{9F43}",
        nfkd: "\u{9F43}",
    },
    NormalizationTest {
        source: "\u{FAD9}",
        nfc: "\u{9F8E}",
        nfd: "\u{9F8E}",
        nfkc: "\u{9F8E}",
        nfkd: "\u{9F8E}",
    },
    NormalizationTest {
        source: "\u{FB00}",
        nfc: "\u{FB00}",
        nfd: "\u{FB00}",
        nfkc: "\u{0066}\u{0066}",
        nfkd: "\u{0066}\u{0066}",
    },
    NormalizationTest {
        source: "\u{FB01}",
        nfc: "\u{FB01}",
        nfd: "\u{FB01}",
        nfkc: "\u{0066}\u{0069}",
        nfkd: "\u{0066}\u{0069}",
    },
    NormalizationTest {
        source: "\u{FB02}",
        nfc: "\u{FB02}",
        nfd: "\u{FB02}",
        nfkc: "\u{0066}\u{006C}",
        nfkd: "\u{0066}\u{006C}",
    },
    NormalizationTest {
        source: "\u{FB03}",
        nfc: "\u{FB03}",
        nfd: "\u{FB03}",
        nfkc: "\u{0066}\u{0066}\u{0069}",
        nfkd: "\u{0066}\u{0066}\u{0069}",
    },
    NormalizationTest {
        source: "\u{FB04}",
        nfc: "\u{FB04}",
        nfd: "\u{FB04}",
        nfkc: "\u{0066}\u{0066}\u{006C}",
        nfkd: "\u{0066}\u{0066}\u{006C}",
    },
    NormalizationTest {
        source: "\u{FB05}",
        nfc: "\u{FB05}",
        nfd: "\u{FB05}",
        nfkc: "\u{0073}\u{0074}",
        nfkd: "\u{0073}\u{0074}",
    },
    NormalizationTest {
        source: "\u{FB06}",
        nfc: "\u{FB06}",
        nfd: "\u{FB06}",
        nfkc: "\u{0073}\u{0074}",
        nfkd: "\u{0073}\u{0074}",
    },
    NormalizationTest {
        source: "\u{FB13}",
        nfc: "\u{FB13}",
        nfd: "\u{FB13}",
        nfkc: "\u{0574}\u{0576}",
        nfkd: "\u{0574}\u{0576}",
    },
    NormalizationTest {
        source: "\u{FB14}",
        nfc: "\u{FB14}",
        nfd: "\u{FB14}",
        nfkc: "\u{0574}\u{0565}",
        nfkd: "\u{0574}\u{0565}",
    },
    NormalizationTest {
        source: "\u{FB15}",
        nfc: "\u{FB15}",
        nfd: "\u{FB15}",
        nfkc: "\u{0574}\u{056B}",
        nfkd: "\u{0574}\u{056B}",
    },
    NormalizationTest {
        source: "\u{FB16}",
        nfc: "\u{FB16}",
        nfd: "\u{FB16}",
        nfkc: "\u{057E}\u{0576}",
        nfkd: "\u{057E}\u{0576}",
    },
    NormalizationTest {
        source: "\u{FB17}",
        nfc: "\u{FB17}",
        nfd: "\u{FB17}",
        nfkc: "\u{0574}\u{056D}",
        nfkd: "\u{0574}\u{056D}",
    },
    NormalizationTest {
        source: "\u{FB1D}",
        nfc: "\u{05D9}\u{05B4}",
        nfd: "\u{05D9}\u{05B4}",
        nfkc: "\u{05D9}\u{05B4}",
        nfkd: "\u{05D9}\u{05B4}",
    },
    NormalizationTest {
        source: "\u{FB1F}",
        nfc: "\u{05F2}\u{05B7}",
        nfd: "\u{05F2}\u{05B7}",
        nfkc: "\u{05F2}\u{05B7}",
        nfkd: "\u{05F2}\u{05B7}",
    },
    NormalizationTest {
        source: "\u{FB20}",
        nfc: "\u{FB20}",
        nfd: "\u{FB20}",
        nfkc: "\u{05E2}",
        nfkd: "\u{05E2}",
    },
    NormalizationTest {
        source: "\u{FB21}",
        nfc: "\u{FB21}",
        nfd: "\u{FB21}",
        nfkc: "\u{05D0}",
        nfkd: "\u{05D0}",
    },
    NormalizationTest {
        source: "\u{FB22}",
        nfc: "\u{FB22}",
        nfd: "\u{FB22}",
        nfkc: "\u{05D3}",
        nfkd: "\u{05D3}",
    },
    NormalizationTest {
        source: "\u{FB23}",
        nfc: "\u{FB23}",
        nfd: "\u{FB23}",
        nfkc: "\u{05D4}",
        nfkd: "\u{05D4}",
    },
    NormalizationTest {
        source: "\u{FB24}",
        nfc: "\u{FB24}",
        nfd: "\u{FB24}",
        nfkc: "\u{05DB}",
        nfkd: "\u{05DB}",
    },
    NormalizationTest {
        source: "\u{FB25}",
        nfc: "\u{FB25}",
        nfd: "\u{FB25}",
        nfkc: "\u{05DC}",
        nfkd: "\u{05DC}",
    },
    NormalizationTest {
        source: "\u{FB26}",
        nfc: "\u{FB26}",
        nfd: "\u{FB26}",
        nfkc: "\u{05DD}",
        nfkd: "\u{05DD}",
    },
    NormalizationTest {
        source: "\u{FB27}",
        nfc: "\u{FB27}",
        nfd: "\u{FB27}",
        nfkc: "\u{05E8}",
        nfkd: "\u{05E8}",
    },
    NormalizationTest {
        source: "\u{FB28}",
        nfc: "\u{FB28}",
        nfd: "\u{FB28}",
        nfkc: "\u{05EA}",
        nfkd: "\u{05EA}",
    },
    NormalizationTest {
        source: "\u{FB29}",
        nfc: "\u{FB29}",
        nfd: "\u{FB29}",
        nfkc: "\u{002B}",
        nfkd: "\u{002B}",
    },
    NormalizationTest {
        source: "\u{FB2A}",
        nfc: "\u{05E9}\u{05C1}",
        nfd: "\u{05E9}\u{05C1}",
        nfkc: "\u{05E9}\u{05C1}",
        nfkd: "\u{05E9}\u{05C1}",
    },
    NormalizationTest {
        source: "\u{FB2B}",
        nfc: "\u{05E9}\u{05C2}",
        nfd: "\u{05E9}\u{05C2}",
        nfkc: "\u{05E9}\u{05C2}",
        nfkd: "\u{05E9}\u{05C2}",
    },
    NormalizationTest {
        source: "\u{FB2C}",
        nfc: "\u{05E9}\u{05BC}\u{05C1}",
        nfd: "\u{05E9}\u{05BC}\u{05C1}",
        nfkc: "\u{05E9}\u{05BC}\u{05C1}",
        nfkd: "\u{05E9}\u{05BC}\u{05C1}",
    },
    NormalizationTest {
        source: "\u{FB2D}",
        nfc: "\u{05E9}\u{05BC}\u{05C2}",
        nfd: "\u{05E9}\u{05BC}\u{05C2}",
        nfkc: "\u{05E9}\u{05BC}\u{05C2}",
        nfkd: "\u{05E9}\u{05BC}\u{05C2}",
    },
    NormalizationTest {
        source: "\u{FB2E}",
        nfc: "\u{05D0}\u{05B7}",
        nfd: "\u{05D0}\u{05B7}",
        nfkc: "\u{05D0}\u{05B7}",
        nfkd: "\u{05D0}\u{05B7}",
    },
    NormalizationTest {
        source: "\u{FB2F}",
        nfc: "\u{05D0}\u{05B8}",
        nfd: "\u{05D0}\u{05B8}",
        nfkc: "\u{05D0}\u{05B8}",
        nfkd: "\u{05D0}\u{05B8}",
    },
    NormalizationTest {
        source: "\u{FB30}",
        nfc: "\u{05D0}\u{05BC}",
        nfd: "\u{05D0}\u{05BC}",
        nfkc: "\u{05D0}\u{05BC}",
        nfkd: "\u{05D0}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB31}",
        nfc: "\u{05D1}\u{05BC}",
        nfd: "\u{05D1}\u{05BC}",
        nfkc: "\u{05D1}\u{05BC}",
        nfkd: "\u{05D1}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB32}",
        nfc: "\u{05D2}\u{05BC}",
        nfd: "\u{05D2}\u{05BC}",
        nfkc: "\u{05D2}\u{05BC}",
        nfkd: "\u{05D2}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB33}",
        nfc: "\u{05D3}\u{05BC}",
        nfd: "\u{05D3}\u{05BC}",
        nfkc: "\u{05D3}\u{05BC}",
        nfkd: "\u{05D3}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB34}",
        nfc: "\u{05D4}\u{05BC}",
        nfd: "\u{05D4}\u{05BC}",
        nfkc: "\u{05D4}\u{05BC}",
        nfkd: "\u{05D4}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB35}",
        nfc: "\u{05D5}\u{05BC}",
        nfd: "\u{05D5}\u{05BC}",
        nfkc: "\u{05D5}\u{05BC}",
        nfkd: "\u{05D5}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB36}",
        nfc: "\u{05D6}\u{05BC}",
        nfd: "\u{05D6}\u{05BC}",
        nfkc: "\u{05D6}\u{05BC}",
        nfkd: "\u{05D6}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB38}",
        nfc: "\u{05D8}\u{05BC}",
        nfd: "\u{05D8}\u{05BC}",
        nfkc: "\u{05D8}\u{05BC}",
        nfkd: "\u{05D8}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB39}",
        nfc: "\u{05D9}\u{05BC}",
        nfd: "\u{05D9}\u{05BC}",
        nfkc: "\u{05D9}\u{05BC}",
        nfkd: "\u{05D9}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB3A}",
        nfc: "\u{05DA}\u{05BC}",
        nfd: "\u{05DA}\u{05BC}",
        nfkc: "\u{05DA}\u{05BC}",
        nfkd: "\u{05DA}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB3B}",
        nfc: "\u{05DB}\u{05BC}",
        nfd: "\u{05DB}\u{05BC}",
        nfkc: "\u{05DB}\u{05BC}",
        nfkd: "\u{05DB}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB3C}",
        nfc: "\u{05DC}\u{05BC}",
        nfd: "\u{05DC}\u{05BC}",
        nfkc: "\u{05DC}\u{05BC}",
        nfkd: "\u{05DC}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB3E}",
        nfc: "\u{05DE}\u{05BC}",
        nfd: "\u{05DE}\u{05BC}",
        nfkc: "\u{05DE}\u{05BC}",
        nfkd: "\u{05DE}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB40}",
        nfc: "\u{05E0}\u{05BC}",
        nfd: "\u{05E0}\u{05BC}",
        nfkc: "\u{05E0}\u{05BC}",
        nfkd: "\u{05E0}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB41}",
        nfc: "\u{05E1}\u{05BC}",
        nfd: "\u{05E1}\u{05BC}",
        nfkc: "\u{05E1}\u{05BC}",
        nfkd: "\u{05E1}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB43}",
        nfc: "\u{05E3}\u{05BC}",
        nfd: "\u{05E3}\u{05BC}",
        nfkc: "\u{05E3}\u{05BC}",
        nfkd: "\u{05E3}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB44}",
        nfc: "\u{05E4}\u{05BC}",
        nfd: "\u{05E4}\u{05BC}",
        nfkc: "\u{05E4}\u{05BC}",
        nfkd: "\u{05E4}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB46}",
        nfc: "\u{05E6}\u{05BC}",
        nfd: "\u{05E6}\u{05BC}",
        nfkc: "\u{05E6}\u{05BC}",
        nfkd: "\u{05E6}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB47}",
        nfc: "\u{05E7}\u{05BC}",
        nfd: "\u{05E7}\u{05BC}",
        nfkc: "\u{05E7}\u{05BC}",
        nfkd: "\u{05E7}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB48}",
        nfc: "\u{05E8}\u{05BC}",
        nfd: "\u{05E8}\u{05BC}",
        nfkc: "\u{05E8}\u{05BC}",
        nfkd: "\u{05E8}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB49}",
        nfc: "\u{05E9}\u{05BC}",
        nfd: "\u{05E9}\u{05BC}",
        nfkc: "\u{05E9}\u{05BC}",
        nfkd: "\u{05E9}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB4A}",
        nfc: "\u{05EA}\u{05BC}",
        nfd: "\u{05EA}\u{05BC}",
        nfkc: "\u{05EA}\u{05BC}",
        nfkd: "\u{05EA}\u{05BC}",
    },
    NormalizationTest {
        source: "\u{FB4B}",
        nfc: "\u{05D5}\u{05B9}",
        nfd: "\u{05D5}\u{05B9}",
        nfkc: "\u{05D5}\u{05B9}",
        nfkd: "\u{05D5}\u{05B9}",
    },
    NormalizationTest {
        source: "\u{FB4C}",
        nfc: "\u{05D1}\u{05BF}",
        nfd: "\u{05D1}\u{05BF}",
        nfkc: "\u{05D1}\u{05BF}",
        nfkd: "\u{05D1}\u{05BF}",
    },
    NormalizationTest {
        source: "\u{FB4D}",
        nfc: "\u{05DB}\u{05BF}",
        nfd: "\u{05DB}\u{05BF}",
        nfkc: "\u{05DB}\u{05BF}",
        nfkd: "\u{05DB}\u{05BF}",
    },
    NormalizationTest {
        source: "\u{FB4E}",
        nfc: "\u{05E4}\u{05BF}",
        nfd: "\u{05E4}\u{05BF}",
        nfkc: "\u{05E4}\u{05BF}",
        nfkd: "\u{05E4}\u{05BF}",
    },
    NormalizationTest {
        source: "\u{FB4F}",
        nfc: "\u{FB4F}",
        nfd: "\u{FB4F}",
        nfkc: "\u{05D0}\u{05DC}",
        nfkd: "\u{05D0}\u{05DC}",
    },
    NormalizationTest {
        source: "\u{FB50}",
        nfc: "\u{FB50}",
        nfd: "\u{FB50}",
        nfkc: "\u{0671}",
        nfkd: "\u{0671}",
    },
    NormalizationTest {
        source: "\u{FB51}",
        nfc: "\u{FB51}",
        nfd: "\u{FB51}",
        nfkc: "\u{0671}",
        nfkd: "\u{0671}",
    },
    NormalizationTest {
        source: "\u{FB52}",
        nfc: "\u{FB52}",
        nfd: "\u{FB52}",
        nfkc: "\u{067B}",
        nfkd: "\u{067B}",
    },
    NormalizationTest {
        source: "\u{FB53}",
        nfc: "\u{FB53}",
        nfd: "\u{FB53}",
        nfkc: "\u{067B}",
        nfkd: "\u{067B}",
    },
    NormalizationTest {
        source: "\u{FB54}",
        nfc: "\u{FB54}",
        nfd: "\u{FB54}",
        nfkc: "\u{067B}",
        nfkd: "\u{067B}",
    },
    NormalizationTest {
        source: "\u{FB55}",
        nfc: "\u{FB55}",
        nfd: "\u{FB55}",
        nfkc: "\u{067B}",
        nfkd: "\u{067B}",
    },
    NormalizationTest {
        source: "\u{FB56}",
        nfc: "\u{FB56}",
        nfd: "\u{FB56}",
        nfkc: "\u{067E}",
        nfkd: "\u{067E}",
    },
    NormalizationTest {
        source: "\u{FB57}",
        nfc: "\u{FB57}",
        nfd: "\u{FB57}",
        nfkc: "\u{067E}",
        nfkd: "\u{067E}",
    },
    NormalizationTest {
        source: "\u{FB58}",
        nfc: "\u{FB58}",
        nfd: "\u{FB58}",
        nfkc: "\u{067E}",
        nfkd: "\u{067E}",
    },
    NormalizationTest {
        source: "\u{FB59}",
        nfc: "\u{FB59}",
        nfd: "\u{FB59}",
        nfkc: "\u{067E}",
        nfkd: "\u{067E}",
    },
    NormalizationTest {
        source: "\u{FB5A}",
        nfc: "\u{FB5A}",
        nfd: "\u{FB5A}",
        nfkc: "\u{0680}",
        nfkd: "\u{0680}",
    },
    NormalizationTest {
        source: "\u{FB5B}",
        nfc: "\u{FB5B}",
        nfd: "\u{FB5B}",
        nfkc: "\u{0680}",
        nfkd: "\u{0680}",
    },
    NormalizationTest {
        source: "\u{FB5C}",
        nfc: "\u{FB5C}",
        nfd: "\u{FB5C}",
        nfkc: "\u{0680}",
        nfkd: "\u{0680}",
    },
    NormalizationTest {
        source: "\u{FB5D}",
        nfc: "\u{FB5D}",
        nfd: "\u{FB5D}",
        nfkc: "\u{0680}",
        nfkd: "\u{0680}",
    },
    NormalizationTest {
        source: "\u{FB5E}",
        nfc: "\u{FB5E}",
        nfd: "\u{FB5E}",
        nfkc: "\u{067A}",
        nfkd: "\u{067A}",
    },
    NormalizationTest {
        source: "\u{FB5F}",
        nfc: "\u{FB5F}",
        nfd: "\u{FB5F}",
        nfkc: "\u{067A}",
        nfkd: "\u{067A}",
    },
    NormalizationTest {
        source: "\u{FB60}",
        nfc: "\u{FB60}",
        nfd: "\u{FB60}",
        nfkc: "\u{067A}",
        nfkd: "\u{067A}",
    },
    NormalizationTest {
        source: "\u{FB61}",
        nfc: "\u{FB61}",
        nfd: "\u{FB61}",
        nfkc: "\u{067A}",
        nfkd: "\u{067A}",
    },
    NormalizationTest {
        source: "\u{FB62}",
        nfc: "\u{FB62}",
        nfd: "\u{FB62}",
        nfkc: "\u{067F}",
        nfkd: "\u{067F}",
    },
    NormalizationTest {
        source: "\u{FB63}",
        nfc: "\u{FB63}",
        nfd: "\u{FB63}",
        nfkc: "\u{067F}",
        nfkd: "\u{067F}",
    },
    NormalizationTest {
        source: "\u{FB64}",
        nfc: "\u{FB64}",
        nfd: "\u{FB64}",
        nfkc: "\u{067F}",
        nfkd: "\u{067F}",
    },
    NormalizationTest {
        source: "\u{FB65}",
        nfc: "\u{FB65}",
        nfd: "\u{FB65}",
        nfkc: "\u{067F}",
        nfkd: "\u{067F}",
    },
    NormalizationTest {
        source: "\u{FB66}",
        nfc: "\u{FB66}",
        nfd: "\u{FB66}",
        nfkc: "\u{0679}",
        nfkd: "\u{0679}",
    },
    NormalizationTest {
        source: "\u{FB67}",
        nfc: "\u{FB67}",
        nfd: "\u{FB67}",
        nfkc: "\u{0679}",
        nfkd: "\u{0679}",
    },
    NormalizationTest {
        source: "\u{FB68}",
        nfc: "\u{FB68}",
        nfd: "\u{FB68}",
        nfkc: "\u{0679}",
        nfkd: "\u{0679}",
    },
    NormalizationTest {
        source: "\u{FB69}",
        nfc: "\u{FB69}",
        nfd: "\u{FB69}",
        nfkc: "\u{0679}",
        nfkd: "\u{0679}",
    },
    NormalizationTest {
        source: "\u{FB6A}",
        nfc: "\u{FB6A}",
        nfd: "\u{FB6A}",
        nfkc: "\u{06A4}",
        nfkd: "\u{06A4}",
    },
    NormalizationTest {
        source: "\u{FB6B}",
        nfc: "\u{FB6B}",
        nfd: "\u{FB6B}",
        nfkc: "\u{06A4}",
        nfkd: "\u{06A4}",
    },
    NormalizationTest {
        source: "\u{FB6C}",
        nfc: "\u{FB6C}",
        nfd: "\u{FB6C}",
        nfkc: "\u{06A4}",
        nfkd: "\u{06A4}",
    },
    NormalizationTest {
        source: "\u{FB6D}",
        nfc: "\u{FB6D}",
        nfd: "\u{FB6D}",
        nfkc: "\u{06A4}",
        nfkd: "\u{06A4}",
    },
    NormalizationTest {
        source: "\u{FB6E}",
        nfc: "\u{FB6E}",
        nfd: "\u{FB6E}",
        nfkc: "\u{06A6}",
        nfkd: "\u{06A6}",
    },
    NormalizationTest {
        source: "\u{FB6F}",
        nfc: "\u{FB6F}",
        nfd: "\u{FB6F}",
        nfkc: "\u{06A6}",
        nfkd: "\u{06A6}",
    },
    NormalizationTest {
        source: "\u{FB70}",
        nfc: "\u{FB70}",
        nfd: "\u{FB70}",
        nfkc: "\u{06A6}",
        nfkd: "\u{06A6}",
    },
    NormalizationTest {
        source: "\u{FB71}",
        nfc: "\u{FB71}",
        nfd: "\u{FB71}",
        nfkc: "\u{06A6}",
        nfkd: "\u{06A6}",
    },
    NormalizationTest {
        source: "\u{FB72}",
        nfc: "\u{FB72}",
        nfd: "\u{FB72}",
        nfkc: "\u{0684}",
        nfkd: "\u{0684}",
    },
    NormalizationTest {
        source: "\u{FB73}",
        nfc: "\u{FB73}",
        nfd: "\u{FB73}",
        nfkc: "\u{0684}",
        nfkd: "\u{0684}",
    },
    NormalizationTest {
        source: "\u{FB74}",
        nfc: "\u{FB74}",
        nfd: "\u{FB74}",
        nfkc: "\u{0684}",
        nfkd: "\u{0684}",
    },
    NormalizationTest {
        source: "\u{FB75}",
        nfc: "\u{FB75}",
        nfd: "\u{FB75}",
        nfkc: "\u{0684}",
        nfkd: "\u{0684}",
    },
    NormalizationTest {
        source: "\u{FB76}",
        nfc: "\u{FB76}",
        nfd: "\u{FB76}",
        nfkc: "\u{0683}",
        nfkd: "\u{0683}",
    },
    NormalizationTest {
        source: "\u{FB77}",
        nfc: "\u{FB77}",
        nfd: "\u{FB77}",
        nfkc: "\u{0683}",
        nfkd: "\u{0683}",
    },
    NormalizationTest {
        source: "\u{FB78}",
        nfc: "\u{FB78}",
        nfd: "\u{FB78}",
        nfkc: "\u{0683}",
        nfkd: "\u{0683}",
    },
    NormalizationTest {
        source: "\u{FB79}",
        nfc: "\u{FB79}",
        nfd: "\u{FB79}",
        nfkc: "\u{0683}",
        nfkd: "\u{0683}",
    },
    NormalizationTest {
        source: "\u{FB7A}",
        nfc: "\u{FB7A}",
        nfd: "\u{FB7A}",
        nfkc: "\u{0686}",
        nfkd: "\u{0686}",
    },
    NormalizationTest {
        source: "\u{FB7B}",
        nfc: "\u{FB7B}",
        nfd: "\u{FB7B}",
        nfkc: "\u{0686}",
        nfkd: "\u{0686}",
    },
    NormalizationTest {
        source: "\u{FB7C}",
        nfc: "\u{FB7C}",
        nfd: "\u{FB7C}",
        nfkc: "\u{0686}",
        nfkd: "\u{0686}",
    },
    NormalizationTest {
        source: "\u{FB7D}",
        nfc: "\u{FB7D}",
        nfd: "\u{FB7D}",
        nfkc: "\u{0686}",
        nfkd: "\u{0686}",
    },
    NormalizationTest {
        source: "\u{FB7E}",
        nfc: "\u{FB7E}",
        nfd: "\u{FB7E}",
        nfkc: "\u{0687}",
        nfkd: "\u{0687}",
    },
    NormalizationTest {
        source: "\u{FB7F}",
        nfc: "\u{FB7F}",
        nfd: "\u{FB7F}",
        nfkc: "\u{0687}",
        nfkd: "\u{0687}",
    },
    NormalizationTest {
        source: "\u{FB80}",
        nfc: "\u{FB80}",
        nfd: "\u{FB80}",
        nfkc: "\u{0687}",
        nfkd: "\u{0687}",
    },
    NormalizationTest {
        source: "\u{FB81}",
        nfc: "\u{FB81}",
        nfd: "\u{FB81}",
        nfkc: "\u{0687}",
        nfkd: "\u{0687}",
    },
    NormalizationTest {
        source: "\u{FB82}",
        nfc: "\u{FB82}",
        nfd: "\u{FB82}",
        nfkc: "\u{068D}",
        nfkd: "\u{068D}",
    },
    NormalizationTest {
        source: "\u{FB83}",
        nfc: "\u{FB83}",
        nfd: "\u{FB83}",
        nfkc: "\u{068D}",
        nfkd: "\u{068D}",
    },
    NormalizationTest {
        source: "\u{FB84}",
        nfc: "\u{FB84}",
        nfd: "\u{FB84}",
        nfkc: "\u{068C}",
        nfkd: "\u{068C}",
    },
    NormalizationTest {
        source: "\u{FB85}",
        nfc: "\u{FB85}",
        nfd: "\u{FB85}",
        nfkc: "\u{068C}",
        nfkd: "\u{068C}",
    },
    NormalizationTest {
        source: "\u{FB86}",
        nfc: "\u{FB86}",
        nfd: "\u{FB86}",
        nfkc: "\u{068E}",
        nfkd: "\u{068E}",
    },
    NormalizationTest {
        source: "\u{FB87}",
        nfc: "\u{FB87}",
        nfd: "\u{FB87}",
        nfkc: "\u{068E}",
        nfkd: "\u{068E}",
    },
    NormalizationTest {
        source: "\u{FB88}",
        nfc: "\u{FB88}",
        nfd: "\u{FB88}",
        nfkc: "\u{0688}",
        nfkd: "\u{0688}",
    },
    NormalizationTest {
        source: "\u{FB89}",
        nfc: "\u{FB89}",
        nfd: "\u{FB89}",
        nfkc: "\u{0688}",
        nfkd: "\u{0688}",
    },
    NormalizationTest {
        source: "\u{FB8A}",
        nfc: "\u{FB8A}",
        nfd: "\u{FB8A}",
        nfkc: "\u{0698}",
        nfkd: "\u{0698}",
    },
    NormalizationTest {
        source: "\u{FB8B}",
        nfc: "\u{FB8B}",
        nfd: "\u{FB8B}",
        nfkc: "\u{0698}",
        nfkd: "\u{0698}",
    },
    NormalizationTest {
        source: "\u{FB8C}",
        nfc: "\u{FB8C}",
        nfd: "\u{FB8C}",
        nfkc: "\u{0691}",
        nfkd: "\u{0691}",
    },
    NormalizationTest {
        source: "\u{FB8D}",
        nfc: "\u{FB8D}",
        nfd: "\u{FB8D}",
        nfkc: "\u{0691}",
        nfkd: "\u{0691}",
    },
    NormalizationTest {
        source: "\u{FB8E}",
        nfc: "\u{FB8E}",
        nfd: "\u{FB8E}",
        nfkc: "\u{06A9}",
        nfkd: "\u{06A9}",
    },
    NormalizationTest {
        source: "\u{FB8F}",
        nfc: "\u{FB8F}",
        nfd: "\u{FB8F}",
        nfkc: "\u{06A9}",
        nfkd: "\u{06A9}",
    },
    NormalizationTest {
        source: "\u{FB90}",
        nfc: "\u{FB90}",
        nfd: "\u{FB90}",
        nfkc: "\u{06A9}",
        nfkd: "\u{06A9}",
    },
    NormalizationTest {
        source: "\u{FB91}",
        nfc: "\u{FB91}",
        nfd: "\u{FB91}",
        nfkc: "\u{06A9}",
        nfkd: "\u{06A9}",
    },
    NormalizationTest {
        source: "\u{FB92}",
        nfc: "\u{FB92}",
        nfd: "\u{FB92}",
        nfkc: "\u{06AF}",
        nfkd: "\u{06AF}",
    },
    NormalizationTest {
        source: "\u{FB93}",
        nfc: "\u{FB93}",
        nfd: "\u{FB93}",
        nfkc: "\u{06AF}",
        nfkd: "\u{06AF}",
    },
    NormalizationTest {
        source: "\u{FB94}",
        nfc: "\u{FB94}",
        nfd: "\u{FB94}",
        nfkc: "\u{06AF}",
        nfkd: "\u{06AF}",
    },
    NormalizationTest {
        source: "\u{FB95}",
        nfc: "\u{FB95}",
        nfd: "\u{FB95}",
        nfkc: "\u{06AF}",
        nfkd: "\u{06AF}",
    },
    NormalizationTest {
        source: "\u{FB96}",
        nfc: "\u{FB96}",
        nfd: "\u{FB96}",
        nfkc: "\u{06B3}",
        nfkd: "\u{06B3}",
    },
    NormalizationTest {
        source: "\u{FB97}",
        nfc: "\u{FB97}",
        nfd: "\u{FB97}",
        nfkc: "\u{06B3}",
        nfkd: "\u{06B3}",
    },
    NormalizationTest {
        source: "\u{FB98}",
        nfc: "\u{FB98}",
        nfd: "\u{FB98}",
        nfkc: "\u{06B3}",
        nfkd: "\u{06B3}",
    },
    NormalizationTest {
        source: "\u{FB99}",
        nfc: "\u{FB99}",
        nfd: "\u{FB99}",
        nfkc: "\u{06B3}",
        nfkd: "\u{06B3}",
    },
    NormalizationTest {
        source: "\u{FB9A}",
        nfc: "\u{FB9A}",
        nfd: "\u{FB9A}",
        nfkc: "\u{06B1}",
        nfkd: "\u{06B1}",
    },
    NormalizationTest {
        source: "\u{FB9B}",
        nfc: "\u{FB9B}",
        nfd: "\u{FB9B}",
        nfkc: "\u{06B1}",
        nfkd: "\u{06B1}",
    },
    NormalizationTest {
        source: "\u{FB9C}",
        nfc: "\u{FB9C}",
        nfd: "\u{FB9C}",
        nfkc: "\u{06B1}",
        nfkd: "\u{06B1}",
    },
    NormalizationTest {
        source: "\u{FB9D}",
        nfc: "\u{FB9D}",
        nfd: "\u{FB9D}",
        nfkc: "\u{06B1}",
        nfkd: "\u{06B1}",
    },
    NormalizationTest {
        source: "\u{FB9E}",
        nfc: "\u{FB9E}",
        nfd: "\u{FB9E}",
        nfkc: "\u{06BA}",
        nfkd: "\u{06BA}",
    },
    NormalizationTest {
        source: "\u{FB9F}",
        nfc: "\u{FB9F}",
        nfd: "\u{FB9F}",
        nfkc: "\u{06BA}",
        nfkd: "\u{06BA}",
    },
    NormalizationTest {
        source: "\u{FBA0}",
        nfc: "\u{FBA0}",
        nfd: "\u{FBA0}",
        nfkc: "\u{06BB}",
        nfkd: "\u{06BB}",
    },
    NormalizationTest {
        source: "\u{FBA1}",
        nfc: "\u{FBA1}",
        nfd: "\u{FBA1}",
        nfkc: "\u{06BB}",
        nfkd: "\u{06BB}",
    },
    NormalizationTest {
        source: "\u{FBA2}",
        nfc: "\u{FBA2}",
        nfd: "\u{FBA2}",
        nfkc: "\u{06BB}",
        nfkd: "\u{06BB}",
    },
    NormalizationTest {
        source: "\u{FBA3}",
        nfc: "\u{FBA3}",
        nfd: "\u{FBA3}",
        nfkc: "\u{06BB}",
        nfkd: "\u{06BB}",
    },
    NormalizationTest {
        source: "\u{FBA4}",
        nfc: "\u{FBA4}",
        nfd: "\u{FBA4}",
        nfkc: "\u{06C0}",
        nfkd: "\u{06D5}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FBA5}",
        nfc: "\u{FBA5}",
        nfd: "\u{FBA5}",
        nfkc: "\u{06C0}",
        nfkd: "\u{06D5}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FBA6}",
        nfc: "\u{FBA6}",
        nfd: "\u{FBA6}",
        nfkc: "\u{06C1}",
        nfkd: "\u{06C1}",
    },
    NormalizationTest {
        source: "\u{FBA7}",
        nfc: "\u{FBA7}",
        nfd: "\u{FBA7}",
        nfkc: "\u{06C1}",
        nfkd: "\u{06C1}",
    },
    NormalizationTest {
        source: "\u{FBA8}",
        nfc: "\u{FBA8}",
        nfd: "\u{FBA8}",
        nfkc: "\u{06C1}",
        nfkd: "\u{06C1}",
    },
    NormalizationTest {
        source: "\u{FBA9}",
        nfc: "\u{FBA9}",
        nfd: "\u{FBA9}",
        nfkc: "\u{06C1}",
        nfkd: "\u{06C1}",
    },
    NormalizationTest {
        source: "\u{FBAA}",
        nfc: "\u{FBAA}",
        nfd: "\u{FBAA}",
        nfkc: "\u{06BE}",
        nfkd: "\u{06BE}",
    },
    NormalizationTest {
        source: "\u{FBAB}",
        nfc: "\u{FBAB}",
        nfd: "\u{FBAB}",
        nfkc: "\u{06BE}",
        nfkd: "\u{06BE}",
    },
    NormalizationTest {
        source: "\u{FBAC}",
        nfc: "\u{FBAC}",
        nfd: "\u{FBAC}",
        nfkc: "\u{06BE}",
        nfkd: "\u{06BE}",
    },
    NormalizationTest {
        source: "\u{FBAD}",
        nfc: "\u{FBAD}",
        nfd: "\u{FBAD}",
        nfkc: "\u{06BE}",
        nfkd: "\u{06BE}",
    },
    NormalizationTest {
        source: "\u{FBAE}",
        nfc: "\u{FBAE}",
        nfd: "\u{FBAE}",
        nfkc: "\u{06D2}",
        nfkd: "\u{06D2}",
    },
    NormalizationTest {
        source: "\u{FBAF}",
        nfc: "\u{FBAF}",
        nfd: "\u{FBAF}",
        nfkc: "\u{06D2}",
        nfkd: "\u{06D2}",
    },
    NormalizationTest {
        source: "\u{FBB0}",
        nfc: "\u{FBB0}",
        nfd: "\u{FBB0}",
        nfkc: "\u{06D3}",
        nfkd: "\u{06D2}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FBB1}",
        nfc: "\u{FBB1}",
        nfd: "\u{FBB1}",
        nfkc: "\u{06D3}",
        nfkd: "\u{06D2}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FBD3}",
        nfc: "\u{FBD3}",
        nfd: "\u{FBD3}",
        nfkc: "\u{06AD}",
        nfkd: "\u{06AD}",
    },
    NormalizationTest {
        source: "\u{FBD4}",
        nfc: "\u{FBD4}",
        nfd: "\u{FBD4}",
        nfkc: "\u{06AD}",
        nfkd: "\u{06AD}",
    },
    NormalizationTest {
        source: "\u{FBD5}",
        nfc: "\u{FBD5}",
        nfd: "\u{FBD5}",
        nfkc: "\u{06AD}",
        nfkd: "\u{06AD}",
    },
    NormalizationTest {
        source: "\u{FBD6}",
        nfc: "\u{FBD6}",
        nfd: "\u{FBD6}",
        nfkc: "\u{06AD}",
        nfkd: "\u{06AD}",
    },
    NormalizationTest {
        source: "\u{FBD7}",
        nfc: "\u{FBD7}",
        nfd: "\u{FBD7}",
        nfkc: "\u{06C7}",
        nfkd: "\u{06C7}",
    },
    NormalizationTest {
        source: "\u{FBD8}",
        nfc: "\u{FBD8}",
        nfd: "\u{FBD8}",
        nfkc: "\u{06C7}",
        nfkd: "\u{06C7}",
    },
    NormalizationTest {
        source: "\u{FBD9}",
        nfc: "\u{FBD9}",
        nfd: "\u{FBD9}",
        nfkc: "\u{06C6}",
        nfkd: "\u{06C6}",
    },
    NormalizationTest {
        source: "\u{FBDA}",
        nfc: "\u{FBDA}",
        nfd: "\u{FBDA}",
        nfkc: "\u{06C6}",
        nfkd: "\u{06C6}",
    },
    NormalizationTest {
        source: "\u{FBDB}",
        nfc: "\u{FBDB}",
        nfd: "\u{FBDB}",
        nfkc: "\u{06C8}",
        nfkd: "\u{06C8}",
    },
    NormalizationTest {
        source: "\u{FBDC}",
        nfc: "\u{FBDC}",
        nfd: "\u{FBDC}",
        nfkc: "\u{06C8}",
        nfkd: "\u{06C8}",
    },
    NormalizationTest {
        source: "\u{FBDD}",
        nfc: "\u{FBDD}",
        nfd: "\u{FBDD}",
        nfkc: "\u{06C7}\u{0674}",
        nfkd: "\u{06C7}\u{0674}",
    },
    NormalizationTest {
        source: "\u{FBDE}",
        nfc: "\u{FBDE}",
        nfd: "\u{FBDE}",
        nfkc: "\u{06CB}",
        nfkd: "\u{06CB}",
    },
    NormalizationTest {
        source: "\u{FBDF}",
        nfc: "\u{FBDF}",
        nfd: "\u{FBDF}",
        nfkc: "\u{06CB}",
        nfkd: "\u{06CB}",
    },
    NormalizationTest {
        source: "\u{FBE0}",
        nfc: "\u{FBE0}",
        nfd: "\u{FBE0}",
        nfkc: "\u{06C5}",
        nfkd: "\u{06C5}",
    },
    NormalizationTest {
        source: "\u{FBE1}",
        nfc: "\u{FBE1}",
        nfd: "\u{FBE1}",
        nfkc: "\u{06C5}",
        nfkd: "\u{06C5}",
    },
    NormalizationTest {
        source: "\u{FBE2}",
        nfc: "\u{FBE2}",
        nfd: "\u{FBE2}",
        nfkc: "\u{06C9}",
        nfkd: "\u{06C9}",
    },
    NormalizationTest {
        source: "\u{FBE3}",
        nfc: "\u{FBE3}",
        nfd: "\u{FBE3}",
        nfkc: "\u{06C9}",
        nfkd: "\u{06C9}",
    },
    NormalizationTest {
        source: "\u{FBE4}",
        nfc: "\u{FBE4}",
        nfd: "\u{FBE4}",
        nfkc: "\u{06D0}",
        nfkd: "\u{06D0}",
    },
    NormalizationTest {
        source: "\u{FBE5}",
        nfc: "\u{FBE5}",
        nfd: "\u{FBE5}",
        nfkc: "\u{06D0}",
        nfkd: "\u{06D0}",
    },
    NormalizationTest {
        source: "\u{FBE6}",
        nfc: "\u{FBE6}",
        nfd: "\u{FBE6}",
        nfkc: "\u{06D0}",
        nfkd: "\u{06D0}",
    },
    NormalizationTest {
        source: "\u{FBE7}",
        nfc: "\u{FBE7}",
        nfd: "\u{FBE7}",
        nfkc: "\u{06D0}",
        nfkd: "\u{06D0}",
    },
    NormalizationTest {
        source: "\u{FBE8}",
        nfc: "\u{FBE8}",
        nfd: "\u{FBE8}",
        nfkc: "\u{0649}",
        nfkd: "\u{0649}",
    },
    NormalizationTest {
        source: "\u{FBE9}",
        nfc: "\u{FBE9}",
        nfd: "\u{FBE9}",
        nfkc: "\u{0649}",
        nfkd: "\u{0649}",
    },
    NormalizationTest {
        source: "\u{FBEA}",
        nfc: "\u{FBEA}",
        nfd: "\u{FBEA}",
        nfkc: "\u{0626}\u{0627}",
        nfkd: "\u{064A}\u{0654}\u{0627}",
    },
    NormalizationTest {
        source: "\u{FBEB}",
        nfc: "\u{FBEB}",
        nfd: "\u{FBEB}",
        nfkc: "\u{0626}\u{0627}",
        nfkd: "\u{064A}\u{0654}\u{0627}",
    },
    NormalizationTest {
        source: "\u{FBEC}",
        nfc: "\u{FBEC}",
        nfd: "\u{FBEC}",
        nfkc: "\u{0626}\u{06D5}",
        nfkd: "\u{064A}\u{0654}\u{06D5}",
    },
    NormalizationTest {
        source: "\u{FBED}",
        nfc: "\u{FBED}",
        nfd: "\u{FBED}",
        nfkc: "\u{0626}\u{06D5}",
        nfkd: "\u{064A}\u{0654}\u{06D5}",
    },
    NormalizationTest {
        source: "\u{FBEE}",
        nfc: "\u{FBEE}",
        nfd: "\u{FBEE}",
        nfkc: "\u{0626}\u{0648}",
        nfkd: "\u{064A}\u{0654}\u{0648}",
    },
    NormalizationTest {
        source: "\u{FBEF}",
        nfc: "\u{FBEF}",
        nfd: "\u{FBEF}",
        nfkc: "\u{0626}\u{0648}",
        nfkd: "\u{064A}\u{0654}\u{0648}",
    },
    NormalizationTest {
        source: "\u{FBF0}",
        nfc: "\u{FBF0}",
        nfd: "\u{FBF0}",
        nfkc: "\u{0626}\u{06C7}",
        nfkd: "\u{064A}\u{0654}\u{06C7}",
    },
    NormalizationTest {
        source: "\u{FBF1}",
        nfc: "\u{FBF1}",
        nfd: "\u{FBF1}",
        nfkc: "\u{0626}\u{06C7}",
        nfkd: "\u{064A}\u{0654}\u{06C7}",
    },
    NormalizationTest {
        source: "\u{FBF2}",
        nfc: "\u{FBF2}",
        nfd: "\u{FBF2}",
        nfkc: "\u{0626}\u{06C6}",
        nfkd: "\u{064A}\u{0654}\u{06C6}",
    },
    NormalizationTest {
        source: "\u{FBF3}",
        nfc: "\u{FBF3}",
        nfd: "\u{FBF3}",
        nfkc: "\u{0626}\u{06C6}",
        nfkd: "\u{064A}\u{0654}\u{06C6}",
    },
    NormalizationTest {
        source: "\u{FBF4}",
        nfc: "\u{FBF4}",
        nfd: "\u{FBF4}",
        nfkc: "\u{0626}\u{06C8}",
        nfkd: "\u{064A}\u{0654}\u{06C8}",
    },
    NormalizationTest {
        source: "\u{FBF5}",
        nfc: "\u{FBF5}",
        nfd: "\u{FBF5}",
        nfkc: "\u{0626}\u{06C8}",
        nfkd: "\u{064A}\u{0654}\u{06C8}",
    },
    NormalizationTest {
        source: "\u{FBF6}",
        nfc: "\u{FBF6}",
        nfd: "\u{FBF6}",
        nfkc: "\u{0626}\u{06D0}",
        nfkd: "\u{064A}\u{0654}\u{06D0}",
    },
    NormalizationTest {
        source: "\u{FBF7}",
        nfc: "\u{FBF7}",
        nfd: "\u{FBF7}",
        nfkc: "\u{0626}\u{06D0}",
        nfkd: "\u{064A}\u{0654}\u{06D0}",
    },
    NormalizationTest {
        source: "\u{FBF8}",
        nfc: "\u{FBF8}",
        nfd: "\u{FBF8}",
        nfkc: "\u{0626}\u{06D0}",
        nfkd: "\u{064A}\u{0654}\u{06D0}",
    },
    NormalizationTest {
        source: "\u{FBF9}",
        nfc: "\u{FBF9}",
        nfd: "\u{FBF9}",
        nfkc: "\u{0626}\u{0649}",
        nfkd: "\u{064A}\u{0654}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FBFA}",
        nfc: "\u{FBFA}",
        nfd: "\u{FBFA}",
        nfkc: "\u{0626}\u{0649}",
        nfkd: "\u{064A}\u{0654}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FBFB}",
        nfc: "\u{FBFB}",
        nfd: "\u{FBFB}",
        nfkc: "\u{0626}\u{0649}",
        nfkd: "\u{064A}\u{0654}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FBFC}",
        nfc: "\u{FBFC}",
        nfd: "\u{FBFC}",
        nfkc: "\u{06CC}",
        nfkd: "\u{06CC}",
    },
    NormalizationTest {
        source: "\u{FBFD}",
        nfc: "\u{FBFD}",
        nfd: "\u{FBFD}",
        nfkc: "\u{06CC}",
        nfkd: "\u{06CC}",
    },
    NormalizationTest {
        source: "\u{FBFE}",
        nfc: "\u{FBFE}",
        nfd: "\u{FBFE}",
        nfkc: "\u{06CC}",
        nfkd: "\u{06CC}",
    },
    NormalizationTest {
        source: "\u{FBFF}",
        nfc: "\u{FBFF}",
        nfd: "\u{FBFF}",
        nfkc: "\u{06CC}",
        nfkd: "\u{06CC}",
    },
    NormalizationTest {
        source: "\u{FC00}",
        nfc: "\u{FC00}",
        nfd: "\u{FC00}",
        nfkc: "\u{0626}\u{062C}",
        nfkd: "\u{064A}\u{0654}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC01}",
        nfc: "\u{FC01}",
        nfd: "\u{FC01}",
        nfkc: "\u{0626}\u{062D}",
        nfkd: "\u{064A}\u{0654}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC02}",
        nfc: "\u{FC02}",
        nfd: "\u{FC02}",
        nfkc: "\u{0626}\u{0645}",
        nfkd: "\u{064A}\u{0654}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC03}",
        nfc: "\u{FC03}",
        nfd: "\u{FC03}",
        nfkc: "\u{0626}\u{0649}",
        nfkd: "\u{064A}\u{0654}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC04}",
        nfc: "\u{FC04}",
        nfd: "\u{FC04}",
        nfkc: "\u{0626}\u{064A}",
        nfkd: "\u{064A}\u{0654}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC05}",
        nfc: "\u{FC05}",
        nfd: "\u{FC05}",
        nfkc: "\u{0628}\u{062C}",
        nfkd: "\u{0628}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC06}",
        nfc: "\u{FC06}",
        nfd: "\u{FC06}",
        nfkc: "\u{0628}\u{062D}",
        nfkd: "\u{0628}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC07}",
        nfc: "\u{FC07}",
        nfd: "\u{FC07}",
        nfkc: "\u{0628}\u{062E}",
        nfkd: "\u{0628}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FC08}",
        nfc: "\u{FC08}",
        nfd: "\u{FC08}",
        nfkc: "\u{0628}\u{0645}",
        nfkd: "\u{0628}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC09}",
        nfc: "\u{FC09}",
        nfd: "\u{FC09}",
        nfkc: "\u{0628}\u{0649}",
        nfkd: "\u{0628}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC0A}",
        nfc: "\u{FC0A}",
        nfd: "\u{FC0A}",
        nfkc: "\u{0628}\u{064A}",
        nfkd: "\u{0628}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC0B}",
        nfc: "\u{FC0B}",
        nfd: "\u{FC0B}",
        nfkc: "\u{062A}\u{062C}",
        nfkd: "\u{062A}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC0C}",
        nfc: "\u{FC0C}",
        nfd: "\u{FC0C}",
        nfkc: "\u{062A}\u{062D}",
        nfkd: "\u{062A}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC0D}",
        nfc: "\u{FC0D}",
        nfd: "\u{FC0D}",
        nfkc: "\u{062A}\u{062E}",
        nfkd: "\u{062A}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FC0E}",
        nfc: "\u{FC0E}",
        nfd: "\u{FC0E}",
        nfkc: "\u{062A}\u{0645}",
        nfkd: "\u{062A}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC0F}",
        nfc: "\u{FC0F}",
        nfd: "\u{FC0F}",
        nfkc: "\u{062A}\u{0649}",
        nfkd: "\u{062A}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC10}",
        nfc: "\u{FC10}",
        nfd: "\u{FC10}",
        nfkc: "\u{062A}\u{064A}",
        nfkd: "\u{062A}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC11}",
        nfc: "\u{FC11}",
        nfd: "\u{FC11}",
        nfkc: "\u{062B}\u{062C}",
        nfkd: "\u{062B}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC12}",
        nfc: "\u{FC12}",
        nfd: "\u{FC12}",
        nfkc: "\u{062B}\u{0645}",
        nfkd: "\u{062B}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC13}",
        nfc: "\u{FC13}",
        nfd: "\u{FC13}",
        nfkc: "\u{062B}\u{0649}",
        nfkd: "\u{062B}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC14}",
        nfc: "\u{FC14}",
        nfd: "\u{FC14}",
        nfkc: "\u{062B}\u{064A}",
        nfkd: "\u{062B}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC15}",
        nfc: "\u{FC15}",
        nfd: "\u{FC15}",
        nfkc: "\u{062C}\u{062D}",
        nfkd: "\u{062C}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC16}",
        nfc: "\u{FC16}",
        nfd: "\u{FC16}",
        nfkc: "\u{062C}\u{0645}",
        nfkd: "\u{062C}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC17}",
        nfc: "\u{FC17}",
        nfd: "\u{FC17}",
        nfkc: "\u{062D}\u{062C}",
        nfkd: "\u{062D}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC18}",
        nfc: "\u{FC18}",
        nfd: "\u{FC18}",
        nfkc: "\u{062D}\u{0645}",
        nfkd: "\u{062D}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC19}",
        nfc: "\u{FC19}",
        nfd: "\u{FC19}",
        nfkc: "\u{062E}\u{062C}",
        nfkd: "\u{062E}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC1A}",
        nfc: "\u{FC1A}",
        nfd: "\u{FC1A}",
        nfkc: "\u{062E}\u{062D}",
        nfkd: "\u{062E}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC1B}",
        nfc: "\u{FC1B}",
        nfd: "\u{FC1B}",
        nfkc: "\u{062E}\u{0645}",
        nfkd: "\u{062E}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC1C}",
        nfc: "\u{FC1C}",
        nfd: "\u{FC1C}",
        nfkc: "\u{0633}\u{062C}",
        nfkd: "\u{0633}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC1D}",
        nfc: "\u{FC1D}",
        nfd: "\u{FC1D}",
        nfkc: "\u{0633}\u{062D}",
        nfkd: "\u{0633}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC1E}",
        nfc: "\u{FC1E}",
        nfd: "\u{FC1E}",
        nfkc: "\u{0633}\u{062E}",
        nfkd: "\u{0633}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FC1F}",
        nfc: "\u{FC1F}",
        nfd: "\u{FC1F}",
        nfkc: "\u{0633}\u{0645}",
        nfkd: "\u{0633}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC20}",
        nfc: "\u{FC20}",
        nfd: "\u{FC20}",
        nfkc: "\u{0635}\u{062D}",
        nfkd: "\u{0635}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC21}",
        nfc: "\u{FC21}",
        nfd: "\u{FC21}",
        nfkc: "\u{0635}\u{0645}",
        nfkd: "\u{0635}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC22}",
        nfc: "\u{FC22}",
        nfd: "\u{FC22}",
        nfkc: "\u{0636}\u{062C}",
        nfkd: "\u{0636}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC23}",
        nfc: "\u{FC23}",
        nfd: "\u{FC23}",
        nfkc: "\u{0636}\u{062D}",
        nfkd: "\u{0636}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC24}",
        nfc: "\u{FC24}",
        nfd: "\u{FC24}",
        nfkc: "\u{0636}\u{062E}",
        nfkd: "\u{0636}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FC25}",
        nfc: "\u{FC25}",
        nfd: "\u{FC25}",
        nfkc: "\u{0636}\u{0645}",
        nfkd: "\u{0636}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC26}",
        nfc: "\u{FC26}",
        nfd: "\u{FC26}",
        nfkc: "\u{0637}\u{062D}",
        nfkd: "\u{0637}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC27}",
        nfc: "\u{FC27}",
        nfd: "\u{FC27}",
        nfkc: "\u{0637}\u{0645}",
        nfkd: "\u{0637}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC28}",
        nfc: "\u{FC28}",
        nfd: "\u{FC28}",
        nfkc: "\u{0638}\u{0645}",
        nfkd: "\u{0638}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC29}",
        nfc: "\u{FC29}",
        nfd: "\u{FC29}",
        nfkc: "\u{0639}\u{062C}",
        nfkd: "\u{0639}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC2A}",
        nfc: "\u{FC2A}",
        nfd: "\u{FC2A}",
        nfkc: "\u{0639}\u{0645}",
        nfkd: "\u{0639}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC2B}",
        nfc: "\u{FC2B}",
        nfd: "\u{FC2B}",
        nfkc: "\u{063A}\u{062C}",
        nfkd: "\u{063A}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC2C}",
        nfc: "\u{FC2C}",
        nfd: "\u{FC2C}",
        nfkc: "\u{063A}\u{0645}",
        nfkd: "\u{063A}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC2D}",
        nfc: "\u{FC2D}",
        nfd: "\u{FC2D}",
        nfkc: "\u{0641}\u{062C}",
        nfkd: "\u{0641}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC2E}",
        nfc: "\u{FC2E}",
        nfd: "\u{FC2E}",
        nfkc: "\u{0641}\u{062D}",
        nfkd: "\u{0641}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC2F}",
        nfc: "\u{FC2F}",
        nfd: "\u{FC2F}",
        nfkc: "\u{0641}\u{062E}",
        nfkd: "\u{0641}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FC30}",
        nfc: "\u{FC30}",
        nfd: "\u{FC30}",
        nfkc: "\u{0641}\u{0645}",
        nfkd: "\u{0641}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC31}",
        nfc: "\u{FC31}",
        nfd: "\u{FC31}",
        nfkc: "\u{0641}\u{0649}",
        nfkd: "\u{0641}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC32}",
        nfc: "\u{FC32}",
        nfd: "\u{FC32}",
        nfkc: "\u{0641}\u{064A}",
        nfkd: "\u{0641}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC33}",
        nfc: "\u{FC33}",
        nfd: "\u{FC33}",
        nfkc: "\u{0642}\u{062D}",
        nfkd: "\u{0642}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC34}",
        nfc: "\u{FC34}",
        nfd: "\u{FC34}",
        nfkc: "\u{0642}\u{0645}",
        nfkd: "\u{0642}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC35}",
        nfc: "\u{FC35}",
        nfd: "\u{FC35}",
        nfkc: "\u{0642}\u{0649}",
        nfkd: "\u{0642}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC36}",
        nfc: "\u{FC36}",
        nfd: "\u{FC36}",
        nfkc: "\u{0642}\u{064A}",
        nfkd: "\u{0642}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC37}",
        nfc: "\u{FC37}",
        nfd: "\u{FC37}",
        nfkc: "\u{0643}\u{0627}",
        nfkd: "\u{0643}\u{0627}",
    },
    NormalizationTest {
        source: "\u{FC38}",
        nfc: "\u{FC38}",
        nfd: "\u{FC38}",
        nfkc: "\u{0643}\u{062C}",
        nfkd: "\u{0643}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC39}",
        nfc: "\u{FC39}",
        nfd: "\u{FC39}",
        nfkc: "\u{0643}\u{062D}",
        nfkd: "\u{0643}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC3A}",
        nfc: "\u{FC3A}",
        nfd: "\u{FC3A}",
        nfkc: "\u{0643}\u{062E}",
        nfkd: "\u{0643}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FC3B}",
        nfc: "\u{FC3B}",
        nfd: "\u{FC3B}",
        nfkc: "\u{0643}\u{0644}",
        nfkd: "\u{0643}\u{0644}",
    },
    NormalizationTest {
        source: "\u{FC3C}",
        nfc: "\u{FC3C}",
        nfd: "\u{FC3C}",
        nfkc: "\u{0643}\u{0645}",
        nfkd: "\u{0643}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC3D}",
        nfc: "\u{FC3D}",
        nfd: "\u{FC3D}",
        nfkc: "\u{0643}\u{0649}",
        nfkd: "\u{0643}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC3E}",
        nfc: "\u{FC3E}",
        nfd: "\u{FC3E}",
        nfkc: "\u{0643}\u{064A}",
        nfkd: "\u{0643}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC3F}",
        nfc: "\u{FC3F}",
        nfd: "\u{FC3F}",
        nfkc: "\u{0644}\u{062C}",
        nfkd: "\u{0644}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC40}",
        nfc: "\u{FC40}",
        nfd: "\u{FC40}",
        nfkc: "\u{0644}\u{062D}",
        nfkd: "\u{0644}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC41}",
        nfc: "\u{FC41}",
        nfd: "\u{FC41}",
        nfkc: "\u{0644}\u{062E}",
        nfkd: "\u{0644}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FC42}",
        nfc: "\u{FC42}",
        nfd: "\u{FC42}",
        nfkc: "\u{0644}\u{0645}",
        nfkd: "\u{0644}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC43}",
        nfc: "\u{FC43}",
        nfd: "\u{FC43}",
        nfkc: "\u{0644}\u{0649}",
        nfkd: "\u{0644}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC44}",
        nfc: "\u{FC44}",
        nfd: "\u{FC44}",
        nfkc: "\u{0644}\u{064A}",
        nfkd: "\u{0644}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC45}",
        nfc: "\u{FC45}",
        nfd: "\u{FC45}",
        nfkc: "\u{0645}\u{062C}",
        nfkd: "\u{0645}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC46}",
        nfc: "\u{FC46}",
        nfd: "\u{FC46}",
        nfkc: "\u{0645}\u{062D}",
        nfkd: "\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC47}",
        nfc: "\u{FC47}",
        nfd: "\u{FC47}",
        nfkc: "\u{0645}\u{062E}",
        nfkd: "\u{0645}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FC48}",
        nfc: "\u{FC48}",
        nfd: "\u{FC48}",
        nfkc: "\u{0645}\u{0645}",
        nfkd: "\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC49}",
        nfc: "\u{FC49}",
        nfd: "\u{FC49}",
        nfkc: "\u{0645}\u{0649}",
        nfkd: "\u{0645}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC4A}",
        nfc: "\u{FC4A}",
        nfd: "\u{FC4A}",
        nfkc: "\u{0645}\u{064A}",
        nfkd: "\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC4B}",
        nfc: "\u{FC4B}",
        nfd: "\u{FC4B}",
        nfkc: "\u{0646}\u{062C}",
        nfkd: "\u{0646}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC4C}",
        nfc: "\u{FC4C}",
        nfd: "\u{FC4C}",
        nfkc: "\u{0646}\u{062D}",
        nfkd: "\u{0646}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC4D}",
        nfc: "\u{FC4D}",
        nfd: "\u{FC4D}",
        nfkc: "\u{0646}\u{062E}",
        nfkd: "\u{0646}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FC4E}",
        nfc: "\u{FC4E}",
        nfd: "\u{FC4E}",
        nfkc: "\u{0646}\u{0645}",
        nfkd: "\u{0646}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC4F}",
        nfc: "\u{FC4F}",
        nfd: "\u{FC4F}",
        nfkc: "\u{0646}\u{0649}",
        nfkd: "\u{0646}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC50}",
        nfc: "\u{FC50}",
        nfd: "\u{FC50}",
        nfkc: "\u{0646}\u{064A}",
        nfkd: "\u{0646}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC51}",
        nfc: "\u{FC51}",
        nfd: "\u{FC51}",
        nfkc: "\u{0647}\u{062C}",
        nfkd: "\u{0647}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC52}",
        nfc: "\u{FC52}",
        nfd: "\u{FC52}",
        nfkc: "\u{0647}\u{0645}",
        nfkd: "\u{0647}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC53}",
        nfc: "\u{FC53}",
        nfd: "\u{FC53}",
        nfkc: "\u{0647}\u{0649}",
        nfkd: "\u{0647}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC54}",
        nfc: "\u{FC54}",
        nfd: "\u{FC54}",
        nfkc: "\u{0647}\u{064A}",
        nfkd: "\u{0647}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC55}",
        nfc: "\u{FC55}",
        nfd: "\u{FC55}",
        nfkc: "\u{064A}\u{062C}",
        nfkd: "\u{064A}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC56}",
        nfc: "\u{FC56}",
        nfd: "\u{FC56}",
        nfkc: "\u{064A}\u{062D}",
        nfkd: "\u{064A}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC57}",
        nfc: "\u{FC57}",
        nfd: "\u{FC57}",
        nfkc: "\u{064A}\u{062E}",
        nfkd: "\u{064A}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FC58}",
        nfc: "\u{FC58}",
        nfd: "\u{FC58}",
        nfkc: "\u{064A}\u{0645}",
        nfkd: "\u{064A}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC59}",
        nfc: "\u{FC59}",
        nfd: "\u{FC59}",
        nfkc: "\u{064A}\u{0649}",
        nfkd: "\u{064A}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC5A}",
        nfc: "\u{FC5A}",
        nfd: "\u{FC5A}",
        nfkc: "\u{064A}\u{064A}",
        nfkd: "\u{064A}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC5B}",
        nfc: "\u{FC5B}",
        nfd: "\u{FC5B}",
        nfkc: "\u{0630}\u{0670}",
        nfkd: "\u{0630}\u{0670}",
    },
    NormalizationTest {
        source: "\u{FC5C}",
        nfc: "\u{FC5C}",
        nfd: "\u{FC5C}",
        nfkc: "\u{0631}\u{0670}",
        nfkd: "\u{0631}\u{0670}",
    },
    NormalizationTest {
        source: "\u{FC5D}",
        nfc: "\u{FC5D}",
        nfd: "\u{FC5D}",
        nfkc: "\u{0649}\u{0670}",
        nfkd: "\u{0649}\u{0670}",
    },
    NormalizationTest {
        source: "\u{FC5E}",
        nfc: "\u{FC5E}",
        nfd: "\u{FC5E}",
        nfkc: "\u{0020}\u{064C}\u{0651}",
        nfkd: "\u{0020}\u{064C}\u{0651}",
    },
    NormalizationTest {
        source: "\u{FC5F}",
        nfc: "\u{FC5F}",
        nfd: "\u{FC5F}",
        nfkc: "\u{0020}\u{064D}\u{0651}",
        nfkd: "\u{0020}\u{064D}\u{0651}",
    },
    NormalizationTest {
        source: "\u{FC60}",
        nfc: "\u{FC60}",
        nfd: "\u{FC60}",
        nfkc: "\u{0020}\u{064E}\u{0651}",
        nfkd: "\u{0020}\u{064E}\u{0651}",
    },
    NormalizationTest {
        source: "\u{FC61}",
        nfc: "\u{FC61}",
        nfd: "\u{FC61}",
        nfkc: "\u{0020}\u{064F}\u{0651}",
        nfkd: "\u{0020}\u{064F}\u{0651}",
    },
    NormalizationTest {
        source: "\u{FC62}",
        nfc: "\u{FC62}",
        nfd: "\u{FC62}",
        nfkc: "\u{0020}\u{0650}\u{0651}",
        nfkd: "\u{0020}\u{0650}\u{0651}",
    },
    NormalizationTest {
        source: "\u{FC63}",
        nfc: "\u{FC63}",
        nfd: "\u{FC63}",
        nfkc: "\u{0020}\u{0651}\u{0670}",
        nfkd: "\u{0020}\u{0651}\u{0670}",
    },
    NormalizationTest {
        source: "\u{FC64}",
        nfc: "\u{FC64}",
        nfd: "\u{FC64}",
        nfkc: "\u{0626}\u{0631}",
        nfkd: "\u{064A}\u{0654}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FC65}",
        nfc: "\u{FC65}",
        nfd: "\u{FC65}",
        nfkc: "\u{0626}\u{0632}",
        nfkd: "\u{064A}\u{0654}\u{0632}",
    },
    NormalizationTest {
        source: "\u{FC66}",
        nfc: "\u{FC66}",
        nfd: "\u{FC66}",
        nfkc: "\u{0626}\u{0645}",
        nfkd: "\u{064A}\u{0654}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC67}",
        nfc: "\u{FC67}",
        nfd: "\u{FC67}",
        nfkc: "\u{0626}\u{0646}",
        nfkd: "\u{064A}\u{0654}\u{0646}",
    },
    NormalizationTest {
        source: "\u{FC68}",
        nfc: "\u{FC68}",
        nfd: "\u{FC68}",
        nfkc: "\u{0626}\u{0649}",
        nfkd: "\u{064A}\u{0654}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC69}",
        nfc: "\u{FC69}",
        nfd: "\u{FC69}",
        nfkc: "\u{0626}\u{064A}",
        nfkd: "\u{064A}\u{0654}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC6A}",
        nfc: "\u{FC6A}",
        nfd: "\u{FC6A}",
        nfkc: "\u{0628}\u{0631}",
        nfkd: "\u{0628}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FC6B}",
        nfc: "\u{FC6B}",
        nfd: "\u{FC6B}",
        nfkc: "\u{0628}\u{0632}",
        nfkd: "\u{0628}\u{0632}",
    },
    NormalizationTest {
        source: "\u{FC6C}",
        nfc: "\u{FC6C}",
        nfd: "\u{FC6C}",
        nfkc: "\u{0628}\u{0645}",
        nfkd: "\u{0628}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC6D}",
        nfc: "\u{FC6D}",
        nfd: "\u{FC6D}",
        nfkc: "\u{0628}\u{0646}",
        nfkd: "\u{0628}\u{0646}",
    },
    NormalizationTest {
        source: "\u{FC6E}",
        nfc: "\u{FC6E}",
        nfd: "\u{FC6E}",
        nfkc: "\u{0628}\u{0649}",
        nfkd: "\u{0628}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC6F}",
        nfc: "\u{FC6F}",
        nfd: "\u{FC6F}",
        nfkc: "\u{0628}\u{064A}",
        nfkd: "\u{0628}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC70}",
        nfc: "\u{FC70}",
        nfd: "\u{FC70}",
        nfkc: "\u{062A}\u{0631}",
        nfkd: "\u{062A}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FC71}",
        nfc: "\u{FC71}",
        nfd: "\u{FC71}",
        nfkc: "\u{062A}\u{0632}",
        nfkd: "\u{062A}\u{0632}",
    },
    NormalizationTest {
        source: "\u{FC72}",
        nfc: "\u{FC72}",
        nfd: "\u{FC72}",
        nfkc: "\u{062A}\u{0645}",
        nfkd: "\u{062A}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC73}",
        nfc: "\u{FC73}",
        nfd: "\u{FC73}",
        nfkc: "\u{062A}\u{0646}",
        nfkd: "\u{062A}\u{0646}",
    },
    NormalizationTest {
        source: "\u{FC74}",
        nfc: "\u{FC74}",
        nfd: "\u{FC74}",
        nfkc: "\u{062A}\u{0649}",
        nfkd: "\u{062A}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC75}",
        nfc: "\u{FC75}",
        nfd: "\u{FC75}",
        nfkc: "\u{062A}\u{064A}",
        nfkd: "\u{062A}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC76}",
        nfc: "\u{FC76}",
        nfd: "\u{FC76}",
        nfkc: "\u{062B}\u{0631}",
        nfkd: "\u{062B}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FC77}",
        nfc: "\u{FC77}",
        nfd: "\u{FC77}",
        nfkc: "\u{062B}\u{0632}",
        nfkd: "\u{062B}\u{0632}",
    },
    NormalizationTest {
        source: "\u{FC78}",
        nfc: "\u{FC78}",
        nfd: "\u{FC78}",
        nfkc: "\u{062B}\u{0645}",
        nfkd: "\u{062B}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC79}",
        nfc: "\u{FC79}",
        nfd: "\u{FC79}",
        nfkc: "\u{062B}\u{0646}",
        nfkd: "\u{062B}\u{0646}",
    },
    NormalizationTest {
        source: "\u{FC7A}",
        nfc: "\u{FC7A}",
        nfd: "\u{FC7A}",
        nfkc: "\u{062B}\u{0649}",
        nfkd: "\u{062B}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC7B}",
        nfc: "\u{FC7B}",
        nfd: "\u{FC7B}",
        nfkc: "\u{062B}\u{064A}",
        nfkd: "\u{062B}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC7C}",
        nfc: "\u{FC7C}",
        nfd: "\u{FC7C}",
        nfkc: "\u{0641}\u{0649}",
        nfkd: "\u{0641}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC7D}",
        nfc: "\u{FC7D}",
        nfd: "\u{FC7D}",
        nfkc: "\u{0641}\u{064A}",
        nfkd: "\u{0641}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC7E}",
        nfc: "\u{FC7E}",
        nfd: "\u{FC7E}",
        nfkc: "\u{0642}\u{0649}",
        nfkd: "\u{0642}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC7F}",
        nfc: "\u{FC7F}",
        nfd: "\u{FC7F}",
        nfkc: "\u{0642}\u{064A}",
        nfkd: "\u{0642}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC80}",
        nfc: "\u{FC80}",
        nfd: "\u{FC80}",
        nfkc: "\u{0643}\u{0627}",
        nfkd: "\u{0643}\u{0627}",
    },
    NormalizationTest {
        source: "\u{FC81}",
        nfc: "\u{FC81}",
        nfd: "\u{FC81}",
        nfkc: "\u{0643}\u{0644}",
        nfkd: "\u{0643}\u{0644}",
    },
    NormalizationTest {
        source: "\u{FC82}",
        nfc: "\u{FC82}",
        nfd: "\u{FC82}",
        nfkc: "\u{0643}\u{0645}",
        nfkd: "\u{0643}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC83}",
        nfc: "\u{FC83}",
        nfd: "\u{FC83}",
        nfkc: "\u{0643}\u{0649}",
        nfkd: "\u{0643}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC84}",
        nfc: "\u{FC84}",
        nfd: "\u{FC84}",
        nfkc: "\u{0643}\u{064A}",
        nfkd: "\u{0643}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC85}",
        nfc: "\u{FC85}",
        nfd: "\u{FC85}",
        nfkc: "\u{0644}\u{0645}",
        nfkd: "\u{0644}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC86}",
        nfc: "\u{FC86}",
        nfd: "\u{FC86}",
        nfkc: "\u{0644}\u{0649}",
        nfkd: "\u{0644}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC87}",
        nfc: "\u{FC87}",
        nfd: "\u{FC87}",
        nfkc: "\u{0644}\u{064A}",
        nfkd: "\u{0644}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC88}",
        nfc: "\u{FC88}",
        nfd: "\u{FC88}",
        nfkc: "\u{0645}\u{0627}",
        nfkd: "\u{0645}\u{0627}",
    },
    NormalizationTest {
        source: "\u{FC89}",
        nfc: "\u{FC89}",
        nfd: "\u{FC89}",
        nfkc: "\u{0645}\u{0645}",
        nfkd: "\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC8A}",
        nfc: "\u{FC8A}",
        nfd: "\u{FC8A}",
        nfkc: "\u{0646}\u{0631}",
        nfkd: "\u{0646}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FC8B}",
        nfc: "\u{FC8B}",
        nfd: "\u{FC8B}",
        nfkc: "\u{0646}\u{0632}",
        nfkd: "\u{0646}\u{0632}",
    },
    NormalizationTest {
        source: "\u{FC8C}",
        nfc: "\u{FC8C}",
        nfd: "\u{FC8C}",
        nfkc: "\u{0646}\u{0645}",
        nfkd: "\u{0646}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC8D}",
        nfc: "\u{FC8D}",
        nfd: "\u{FC8D}",
        nfkc: "\u{0646}\u{0646}",
        nfkd: "\u{0646}\u{0646}",
    },
    NormalizationTest {
        source: "\u{FC8E}",
        nfc: "\u{FC8E}",
        nfd: "\u{FC8E}",
        nfkc: "\u{0646}\u{0649}",
        nfkd: "\u{0646}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC8F}",
        nfc: "\u{FC8F}",
        nfd: "\u{FC8F}",
        nfkc: "\u{0646}\u{064A}",
        nfkd: "\u{0646}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC90}",
        nfc: "\u{FC90}",
        nfd: "\u{FC90}",
        nfkc: "\u{0649}\u{0670}",
        nfkd: "\u{0649}\u{0670}",
    },
    NormalizationTest {
        source: "\u{FC91}",
        nfc: "\u{FC91}",
        nfd: "\u{FC91}",
        nfkc: "\u{064A}\u{0631}",
        nfkd: "\u{064A}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FC92}",
        nfc: "\u{FC92}",
        nfd: "\u{FC92}",
        nfkc: "\u{064A}\u{0632}",
        nfkd: "\u{064A}\u{0632}",
    },
    NormalizationTest {
        source: "\u{FC93}",
        nfc: "\u{FC93}",
        nfd: "\u{FC93}",
        nfkc: "\u{064A}\u{0645}",
        nfkd: "\u{064A}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC94}",
        nfc: "\u{FC94}",
        nfd: "\u{FC94}",
        nfkc: "\u{064A}\u{0646}",
        nfkd: "\u{064A}\u{0646}",
    },
    NormalizationTest {
        source: "\u{FC95}",
        nfc: "\u{FC95}",
        nfd: "\u{FC95}",
        nfkc: "\u{064A}\u{0649}",
        nfkd: "\u{064A}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FC96}",
        nfc: "\u{FC96}",
        nfd: "\u{FC96}",
        nfkc: "\u{064A}\u{064A}",
        nfkd: "\u{064A}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FC97}",
        nfc: "\u{FC97}",
        nfd: "\u{FC97}",
        nfkc: "\u{0626}\u{062C}",
        nfkd: "\u{064A}\u{0654}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC98}",
        nfc: "\u{FC98}",
        nfd: "\u{FC98}",
        nfkc: "\u{0626}\u{062D}",
        nfkd: "\u{064A}\u{0654}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC99}",
        nfc: "\u{FC99}",
        nfd: "\u{FC99}",
        nfkc: "\u{0626}\u{062E}",
        nfkd: "\u{064A}\u{0654}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FC9A}",
        nfc: "\u{FC9A}",
        nfd: "\u{FC9A}",
        nfkc: "\u{0626}\u{0645}",
        nfkd: "\u{064A}\u{0654}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FC9B}",
        nfc: "\u{FC9B}",
        nfd: "\u{FC9B}",
        nfkc: "\u{0626}\u{0647}",
        nfkd: "\u{064A}\u{0654}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FC9C}",
        nfc: "\u{FC9C}",
        nfd: "\u{FC9C}",
        nfkc: "\u{0628}\u{062C}",
        nfkd: "\u{0628}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FC9D}",
        nfc: "\u{FC9D}",
        nfd: "\u{FC9D}",
        nfkc: "\u{0628}\u{062D}",
        nfkd: "\u{0628}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FC9E}",
        nfc: "\u{FC9E}",
        nfd: "\u{FC9E}",
        nfkc: "\u{0628}\u{062E}",
        nfkd: "\u{0628}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FC9F}",
        nfc: "\u{FC9F}",
        nfd: "\u{FC9F}",
        nfkc: "\u{0628}\u{0645}",
        nfkd: "\u{0628}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCA0}",
        nfc: "\u{FCA0}",
        nfd: "\u{FCA0}",
        nfkc: "\u{0628}\u{0647}",
        nfkd: "\u{0628}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCA1}",
        nfc: "\u{FCA1}",
        nfd: "\u{FCA1}",
        nfkc: "\u{062A}\u{062C}",
        nfkd: "\u{062A}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCA2}",
        nfc: "\u{FCA2}",
        nfd: "\u{FCA2}",
        nfkc: "\u{062A}\u{062D}",
        nfkd: "\u{062A}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCA3}",
        nfc: "\u{FCA3}",
        nfd: "\u{FCA3}",
        nfkc: "\u{062A}\u{062E}",
        nfkd: "\u{062A}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FCA4}",
        nfc: "\u{FCA4}",
        nfd: "\u{FCA4}",
        nfkc: "\u{062A}\u{0645}",
        nfkd: "\u{062A}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCA5}",
        nfc: "\u{FCA5}",
        nfd: "\u{FCA5}",
        nfkc: "\u{062A}\u{0647}",
        nfkd: "\u{062A}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCA6}",
        nfc: "\u{FCA6}",
        nfd: "\u{FCA6}",
        nfkc: "\u{062B}\u{0645}",
        nfkd: "\u{062B}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCA7}",
        nfc: "\u{FCA7}",
        nfd: "\u{FCA7}",
        nfkc: "\u{062C}\u{062D}",
        nfkd: "\u{062C}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCA8}",
        nfc: "\u{FCA8}",
        nfd: "\u{FCA8}",
        nfkc: "\u{062C}\u{0645}",
        nfkd: "\u{062C}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCA9}",
        nfc: "\u{FCA9}",
        nfd: "\u{FCA9}",
        nfkc: "\u{062D}\u{062C}",
        nfkd: "\u{062D}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCAA}",
        nfc: "\u{FCAA}",
        nfd: "\u{FCAA}",
        nfkc: "\u{062D}\u{0645}",
        nfkd: "\u{062D}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCAB}",
        nfc: "\u{FCAB}",
        nfd: "\u{FCAB}",
        nfkc: "\u{062E}\u{062C}",
        nfkd: "\u{062E}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCAC}",
        nfc: "\u{FCAC}",
        nfd: "\u{FCAC}",
        nfkc: "\u{062E}\u{0645}",
        nfkd: "\u{062E}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCAD}",
        nfc: "\u{FCAD}",
        nfd: "\u{FCAD}",
        nfkc: "\u{0633}\u{062C}",
        nfkd: "\u{0633}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCAE}",
        nfc: "\u{FCAE}",
        nfd: "\u{FCAE}",
        nfkc: "\u{0633}\u{062D}",
        nfkd: "\u{0633}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCAF}",
        nfc: "\u{FCAF}",
        nfd: "\u{FCAF}",
        nfkc: "\u{0633}\u{062E}",
        nfkd: "\u{0633}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FCB0}",
        nfc: "\u{FCB0}",
        nfd: "\u{FCB0}",
        nfkc: "\u{0633}\u{0645}",
        nfkd: "\u{0633}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCB1}",
        nfc: "\u{FCB1}",
        nfd: "\u{FCB1}",
        nfkc: "\u{0635}\u{062D}",
        nfkd: "\u{0635}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCB2}",
        nfc: "\u{FCB2}",
        nfd: "\u{FCB2}",
        nfkc: "\u{0635}\u{062E}",
        nfkd: "\u{0635}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FCB3}",
        nfc: "\u{FCB3}",
        nfd: "\u{FCB3}",
        nfkc: "\u{0635}\u{0645}",
        nfkd: "\u{0635}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCB4}",
        nfc: "\u{FCB4}",
        nfd: "\u{FCB4}",
        nfkc: "\u{0636}\u{062C}",
        nfkd: "\u{0636}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCB5}",
        nfc: "\u{FCB5}",
        nfd: "\u{FCB5}",
        nfkc: "\u{0636}\u{062D}",
        nfkd: "\u{0636}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCB6}",
        nfc: "\u{FCB6}",
        nfd: "\u{FCB6}",
        nfkc: "\u{0636}\u{062E}",
        nfkd: "\u{0636}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FCB7}",
        nfc: "\u{FCB7}",
        nfd: "\u{FCB7}",
        nfkc: "\u{0636}\u{0645}",
        nfkd: "\u{0636}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCB8}",
        nfc: "\u{FCB8}",
        nfd: "\u{FCB8}",
        nfkc: "\u{0637}\u{062D}",
        nfkd: "\u{0637}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCB9}",
        nfc: "\u{FCB9}",
        nfd: "\u{FCB9}",
        nfkc: "\u{0638}\u{0645}",
        nfkd: "\u{0638}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCBA}",
        nfc: "\u{FCBA}",
        nfd: "\u{FCBA}",
        nfkc: "\u{0639}\u{062C}",
        nfkd: "\u{0639}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCBB}",
        nfc: "\u{FCBB}",
        nfd: "\u{FCBB}",
        nfkc: "\u{0639}\u{0645}",
        nfkd: "\u{0639}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCBC}",
        nfc: "\u{FCBC}",
        nfd: "\u{FCBC}",
        nfkc: "\u{063A}\u{062C}",
        nfkd: "\u{063A}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCBD}",
        nfc: "\u{FCBD}",
        nfd: "\u{FCBD}",
        nfkc: "\u{063A}\u{0645}",
        nfkd: "\u{063A}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCBE}",
        nfc: "\u{FCBE}",
        nfd: "\u{FCBE}",
        nfkc: "\u{0641}\u{062C}",
        nfkd: "\u{0641}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCBF}",
        nfc: "\u{FCBF}",
        nfd: "\u{FCBF}",
        nfkc: "\u{0641}\u{062D}",
        nfkd: "\u{0641}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCC0}",
        nfc: "\u{FCC0}",
        nfd: "\u{FCC0}",
        nfkc: "\u{0641}\u{062E}",
        nfkd: "\u{0641}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FCC1}",
        nfc: "\u{FCC1}",
        nfd: "\u{FCC1}",
        nfkc: "\u{0641}\u{0645}",
        nfkd: "\u{0641}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCC2}",
        nfc: "\u{FCC2}",
        nfd: "\u{FCC2}",
        nfkc: "\u{0642}\u{062D}",
        nfkd: "\u{0642}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCC3}",
        nfc: "\u{FCC3}",
        nfd: "\u{FCC3}",
        nfkc: "\u{0642}\u{0645}",
        nfkd: "\u{0642}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCC4}",
        nfc: "\u{FCC4}",
        nfd: "\u{FCC4}",
        nfkc: "\u{0643}\u{062C}",
        nfkd: "\u{0643}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCC5}",
        nfc: "\u{FCC5}",
        nfd: "\u{FCC5}",
        nfkc: "\u{0643}\u{062D}",
        nfkd: "\u{0643}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCC6}",
        nfc: "\u{FCC6}",
        nfd: "\u{FCC6}",
        nfkc: "\u{0643}\u{062E}",
        nfkd: "\u{0643}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FCC7}",
        nfc: "\u{FCC7}",
        nfd: "\u{FCC7}",
        nfkc: "\u{0643}\u{0644}",
        nfkd: "\u{0643}\u{0644}",
    },
    NormalizationTest {
        source: "\u{FCC8}",
        nfc: "\u{FCC8}",
        nfd: "\u{FCC8}",
        nfkc: "\u{0643}\u{0645}",
        nfkd: "\u{0643}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCC9}",
        nfc: "\u{FCC9}",
        nfd: "\u{FCC9}",
        nfkc: "\u{0644}\u{062C}",
        nfkd: "\u{0644}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCCA}",
        nfc: "\u{FCCA}",
        nfd: "\u{FCCA}",
        nfkc: "\u{0644}\u{062D}",
        nfkd: "\u{0644}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCCB}",
        nfc: "\u{FCCB}",
        nfd: "\u{FCCB}",
        nfkc: "\u{0644}\u{062E}",
        nfkd: "\u{0644}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FCCC}",
        nfc: "\u{FCCC}",
        nfd: "\u{FCCC}",
        nfkc: "\u{0644}\u{0645}",
        nfkd: "\u{0644}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCCD}",
        nfc: "\u{FCCD}",
        nfd: "\u{FCCD}",
        nfkc: "\u{0644}\u{0647}",
        nfkd: "\u{0644}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCCE}",
        nfc: "\u{FCCE}",
        nfd: "\u{FCCE}",
        nfkc: "\u{0645}\u{062C}",
        nfkd: "\u{0645}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCCF}",
        nfc: "\u{FCCF}",
        nfd: "\u{FCCF}",
        nfkc: "\u{0645}\u{062D}",
        nfkd: "\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCD0}",
        nfc: "\u{FCD0}",
        nfd: "\u{FCD0}",
        nfkc: "\u{0645}\u{062E}",
        nfkd: "\u{0645}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FCD1}",
        nfc: "\u{FCD1}",
        nfd: "\u{FCD1}",
        nfkc: "\u{0645}\u{0645}",
        nfkd: "\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCD2}",
        nfc: "\u{FCD2}",
        nfd: "\u{FCD2}",
        nfkc: "\u{0646}\u{062C}",
        nfkd: "\u{0646}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCD3}",
        nfc: "\u{FCD3}",
        nfd: "\u{FCD3}",
        nfkc: "\u{0646}\u{062D}",
        nfkd: "\u{0646}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCD4}",
        nfc: "\u{FCD4}",
        nfd: "\u{FCD4}",
        nfkc: "\u{0646}\u{062E}",
        nfkd: "\u{0646}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FCD5}",
        nfc: "\u{FCD5}",
        nfd: "\u{FCD5}",
        nfkc: "\u{0646}\u{0645}",
        nfkd: "\u{0646}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCD6}",
        nfc: "\u{FCD6}",
        nfd: "\u{FCD6}",
        nfkc: "\u{0646}\u{0647}",
        nfkd: "\u{0646}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCD7}",
        nfc: "\u{FCD7}",
        nfd: "\u{FCD7}",
        nfkc: "\u{0647}\u{062C}",
        nfkd: "\u{0647}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCD8}",
        nfc: "\u{FCD8}",
        nfd: "\u{FCD8}",
        nfkc: "\u{0647}\u{0645}",
        nfkd: "\u{0647}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCD9}",
        nfc: "\u{FCD9}",
        nfd: "\u{FCD9}",
        nfkc: "\u{0647}\u{0670}",
        nfkd: "\u{0647}\u{0670}",
    },
    NormalizationTest {
        source: "\u{FCDA}",
        nfc: "\u{FCDA}",
        nfd: "\u{FCDA}",
        nfkc: "\u{064A}\u{062C}",
        nfkd: "\u{064A}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FCDB}",
        nfc: "\u{FCDB}",
        nfd: "\u{FCDB}",
        nfkc: "\u{064A}\u{062D}",
        nfkd: "\u{064A}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FCDC}",
        nfc: "\u{FCDC}",
        nfd: "\u{FCDC}",
        nfkc: "\u{064A}\u{062E}",
        nfkd: "\u{064A}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FCDD}",
        nfc: "\u{FCDD}",
        nfd: "\u{FCDD}",
        nfkc: "\u{064A}\u{0645}",
        nfkd: "\u{064A}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCDE}",
        nfc: "\u{FCDE}",
        nfd: "\u{FCDE}",
        nfkc: "\u{064A}\u{0647}",
        nfkd: "\u{064A}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCDF}",
        nfc: "\u{FCDF}",
        nfd: "\u{FCDF}",
        nfkc: "\u{0626}\u{0645}",
        nfkd: "\u{064A}\u{0654}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCE0}",
        nfc: "\u{FCE0}",
        nfd: "\u{FCE0}",
        nfkc: "\u{0626}\u{0647}",
        nfkd: "\u{064A}\u{0654}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCE1}",
        nfc: "\u{FCE1}",
        nfd: "\u{FCE1}",
        nfkc: "\u{0628}\u{0645}",
        nfkd: "\u{0628}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCE2}",
        nfc: "\u{FCE2}",
        nfd: "\u{FCE2}",
        nfkc: "\u{0628}\u{0647}",
        nfkd: "\u{0628}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCE3}",
        nfc: "\u{FCE3}",
        nfd: "\u{FCE3}",
        nfkc: "\u{062A}\u{0645}",
        nfkd: "\u{062A}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCE4}",
        nfc: "\u{FCE4}",
        nfd: "\u{FCE4}",
        nfkc: "\u{062A}\u{0647}",
        nfkd: "\u{062A}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCE5}",
        nfc: "\u{FCE5}",
        nfd: "\u{FCE5}",
        nfkc: "\u{062B}\u{0645}",
        nfkd: "\u{062B}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCE6}",
        nfc: "\u{FCE6}",
        nfd: "\u{FCE6}",
        nfkc: "\u{062B}\u{0647}",
        nfkd: "\u{062B}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCE7}",
        nfc: "\u{FCE7}",
        nfd: "\u{FCE7}",
        nfkc: "\u{0633}\u{0645}",
        nfkd: "\u{0633}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCE8}",
        nfc: "\u{FCE8}",
        nfd: "\u{FCE8}",
        nfkc: "\u{0633}\u{0647}",
        nfkd: "\u{0633}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCE9}",
        nfc: "\u{FCE9}",
        nfd: "\u{FCE9}",
        nfkc: "\u{0634}\u{0645}",
        nfkd: "\u{0634}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCEA}",
        nfc: "\u{FCEA}",
        nfd: "\u{FCEA}",
        nfkc: "\u{0634}\u{0647}",
        nfkd: "\u{0634}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCEB}",
        nfc: "\u{FCEB}",
        nfd: "\u{FCEB}",
        nfkc: "\u{0643}\u{0644}",
        nfkd: "\u{0643}\u{0644}",
    },
    NormalizationTest {
        source: "\u{FCEC}",
        nfc: "\u{FCEC}",
        nfd: "\u{FCEC}",
        nfkc: "\u{0643}\u{0645}",
        nfkd: "\u{0643}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCED}",
        nfc: "\u{FCED}",
        nfd: "\u{FCED}",
        nfkc: "\u{0644}\u{0645}",
        nfkd: "\u{0644}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCEE}",
        nfc: "\u{FCEE}",
        nfd: "\u{FCEE}",
        nfkc: "\u{0646}\u{0645}",
        nfkd: "\u{0646}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCEF}",
        nfc: "\u{FCEF}",
        nfd: "\u{FCEF}",
        nfkc: "\u{0646}\u{0647}",
        nfkd: "\u{0646}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCF0}",
        nfc: "\u{FCF0}",
        nfd: "\u{FCF0}",
        nfkc: "\u{064A}\u{0645}",
        nfkd: "\u{064A}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FCF1}",
        nfc: "\u{FCF1}",
        nfd: "\u{FCF1}",
        nfkc: "\u{064A}\u{0647}",
        nfkd: "\u{064A}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FCF2}",
        nfc: "\u{FCF2}",
        nfd: "\u{FCF2}",
        nfkc: "\u{0640}\u{064E}\u{0651}",
        nfkd: "\u{0640}\u{064E}\u{0651}",
    },
    NormalizationTest {
        source: "\u{FCF3}",
        nfc: "\u{FCF3}",
        nfd: "\u{FCF3}",
        nfkc: "\u{0640}\u{064F}\u{0651}",
        nfkd: "\u{0640}\u{064F}\u{0651}",
    },
    NormalizationTest {
        source: "\u{FCF4}",
        nfc: "\u{FCF4}",
        nfd: "\u{FCF4}",
        nfkc: "\u{0640}\u{0650}\u{0651}",
        nfkd: "\u{0640}\u{0650}\u{0651}",
    },
    NormalizationTest {
        source: "\u{FCF5}",
        nfc: "\u{FCF5}",
        nfd: "\u{FCF5}",
        nfkc: "\u{0637}\u{0649}",
        nfkd: "\u{0637}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FCF6}",
        nfc: "\u{FCF6}",
        nfd: "\u{FCF6}",
        nfkc: "\u{0637}\u{064A}",
        nfkd: "\u{0637}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FCF7}",
        nfc: "\u{FCF7}",
        nfd: "\u{FCF7}",
        nfkc: "\u{0639}\u{0649}",
        nfkd: "\u{0639}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FCF8}",
        nfc: "\u{FCF8}",
        nfd: "\u{FCF8}",
        nfkc: "\u{0639}\u{064A}",
        nfkd: "\u{0639}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FCF9}",
        nfc: "\u{FCF9}",
        nfd: "\u{FCF9}",
        nfkc: "\u{063A}\u{0649}",
        nfkd: "\u{063A}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FCFA}",
        nfc: "\u{FCFA}",
        nfd: "\u{FCFA}",
        nfkc: "\u{063A}\u{064A}",
        nfkd: "\u{063A}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FCFB}",
        nfc: "\u{FCFB}",
        nfd: "\u{FCFB}",
        nfkc: "\u{0633}\u{0649}",
        nfkd: "\u{0633}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FCFC}",
        nfc: "\u{FCFC}",
        nfd: "\u{FCFC}",
        nfkc: "\u{0633}\u{064A}",
        nfkd: "\u{0633}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FCFD}",
        nfc: "\u{FCFD}",
        nfd: "\u{FCFD}",
        nfkc: "\u{0634}\u{0649}",
        nfkd: "\u{0634}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FCFE}",
        nfc: "\u{FCFE}",
        nfd: "\u{FCFE}",
        nfkc: "\u{0634}\u{064A}",
        nfkd: "\u{0634}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FCFF}",
        nfc: "\u{FCFF}",
        nfd: "\u{FCFF}",
        nfkc: "\u{062D}\u{0649}",
        nfkd: "\u{062D}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD00}",
        nfc: "\u{FD00}",
        nfd: "\u{FD00}",
        nfkc: "\u{062D}\u{064A}",
        nfkd: "\u{062D}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD01}",
        nfc: "\u{FD01}",
        nfd: "\u{FD01}",
        nfkc: "\u{062C}\u{0649}",
        nfkd: "\u{062C}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD02}",
        nfc: "\u{FD02}",
        nfd: "\u{FD02}",
        nfkc: "\u{062C}\u{064A}",
        nfkd: "\u{062C}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD03}",
        nfc: "\u{FD03}",
        nfd: "\u{FD03}",
        nfkc: "\u{062E}\u{0649}",
        nfkd: "\u{062E}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD04}",
        nfc: "\u{FD04}",
        nfd: "\u{FD04}",
        nfkc: "\u{062E}\u{064A}",
        nfkd: "\u{062E}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD05}",
        nfc: "\u{FD05}",
        nfd: "\u{FD05}",
        nfkc: "\u{0635}\u{0649}",
        nfkd: "\u{0635}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD06}",
        nfc: "\u{FD06}",
        nfd: "\u{FD06}",
        nfkc: "\u{0635}\u{064A}",
        nfkd: "\u{0635}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD07}",
        nfc: "\u{FD07}",
        nfd: "\u{FD07}",
        nfkc: "\u{0636}\u{0649}",
        nfkd: "\u{0636}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD08}",
        nfc: "\u{FD08}",
        nfd: "\u{FD08}",
        nfkc: "\u{0636}\u{064A}",
        nfkd: "\u{0636}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD09}",
        nfc: "\u{FD09}",
        nfd: "\u{FD09}",
        nfkc: "\u{0634}\u{062C}",
        nfkd: "\u{0634}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD0A}",
        nfc: "\u{FD0A}",
        nfd: "\u{FD0A}",
        nfkc: "\u{0634}\u{062D}",
        nfkd: "\u{0634}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD0B}",
        nfc: "\u{FD0B}",
        nfd: "\u{FD0B}",
        nfkc: "\u{0634}\u{062E}",
        nfkd: "\u{0634}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FD0C}",
        nfc: "\u{FD0C}",
        nfd: "\u{FD0C}",
        nfkc: "\u{0634}\u{0645}",
        nfkd: "\u{0634}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD0D}",
        nfc: "\u{FD0D}",
        nfd: "\u{FD0D}",
        nfkc: "\u{0634}\u{0631}",
        nfkd: "\u{0634}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FD0E}",
        nfc: "\u{FD0E}",
        nfd: "\u{FD0E}",
        nfkc: "\u{0633}\u{0631}",
        nfkd: "\u{0633}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FD0F}",
        nfc: "\u{FD0F}",
        nfd: "\u{FD0F}",
        nfkc: "\u{0635}\u{0631}",
        nfkd: "\u{0635}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FD10}",
        nfc: "\u{FD10}",
        nfd: "\u{FD10}",
        nfkc: "\u{0636}\u{0631}",
        nfkd: "\u{0636}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FD11}",
        nfc: "\u{FD11}",
        nfd: "\u{FD11}",
        nfkc: "\u{0637}\u{0649}",
        nfkd: "\u{0637}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD12}",
        nfc: "\u{FD12}",
        nfd: "\u{FD12}",
        nfkc: "\u{0637}\u{064A}",
        nfkd: "\u{0637}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD13}",
        nfc: "\u{FD13}",
        nfd: "\u{FD13}",
        nfkc: "\u{0639}\u{0649}",
        nfkd: "\u{0639}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD14}",
        nfc: "\u{FD14}",
        nfd: "\u{FD14}",
        nfkc: "\u{0639}\u{064A}",
        nfkd: "\u{0639}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD15}",
        nfc: "\u{FD15}",
        nfd: "\u{FD15}",
        nfkc: "\u{063A}\u{0649}",
        nfkd: "\u{063A}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD16}",
        nfc: "\u{FD16}",
        nfd: "\u{FD16}",
        nfkc: "\u{063A}\u{064A}",
        nfkd: "\u{063A}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD17}",
        nfc: "\u{FD17}",
        nfd: "\u{FD17}",
        nfkc: "\u{0633}\u{0649}",
        nfkd: "\u{0633}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD18}",
        nfc: "\u{FD18}",
        nfd: "\u{FD18}",
        nfkc: "\u{0633}\u{064A}",
        nfkd: "\u{0633}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD19}",
        nfc: "\u{FD19}",
        nfd: "\u{FD19}",
        nfkc: "\u{0634}\u{0649}",
        nfkd: "\u{0634}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD1A}",
        nfc: "\u{FD1A}",
        nfd: "\u{FD1A}",
        nfkc: "\u{0634}\u{064A}",
        nfkd: "\u{0634}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD1B}",
        nfc: "\u{FD1B}",
        nfd: "\u{FD1B}",
        nfkc: "\u{062D}\u{0649}",
        nfkd: "\u{062D}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD1C}",
        nfc: "\u{FD1C}",
        nfd: "\u{FD1C}",
        nfkc: "\u{062D}\u{064A}",
        nfkd: "\u{062D}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD1D}",
        nfc: "\u{FD1D}",
        nfd: "\u{FD1D}",
        nfkc: "\u{062C}\u{0649}",
        nfkd: "\u{062C}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD1E}",
        nfc: "\u{FD1E}",
        nfd: "\u{FD1E}",
        nfkc: "\u{062C}\u{064A}",
        nfkd: "\u{062C}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD1F}",
        nfc: "\u{FD1F}",
        nfd: "\u{FD1F}",
        nfkc: "\u{062E}\u{0649}",
        nfkd: "\u{062E}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD20}",
        nfc: "\u{FD20}",
        nfd: "\u{FD20}",
        nfkc: "\u{062E}\u{064A}",
        nfkd: "\u{062E}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD21}",
        nfc: "\u{FD21}",
        nfd: "\u{FD21}",
        nfkc: "\u{0635}\u{0649}",
        nfkd: "\u{0635}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD22}",
        nfc: "\u{FD22}",
        nfd: "\u{FD22}",
        nfkc: "\u{0635}\u{064A}",
        nfkd: "\u{0635}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD23}",
        nfc: "\u{FD23}",
        nfd: "\u{FD23}",
        nfkc: "\u{0636}\u{0649}",
        nfkd: "\u{0636}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD24}",
        nfc: "\u{FD24}",
        nfd: "\u{FD24}",
        nfkc: "\u{0636}\u{064A}",
        nfkd: "\u{0636}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD25}",
        nfc: "\u{FD25}",
        nfd: "\u{FD25}",
        nfkc: "\u{0634}\u{062C}",
        nfkd: "\u{0634}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD26}",
        nfc: "\u{FD26}",
        nfd: "\u{FD26}",
        nfkc: "\u{0634}\u{062D}",
        nfkd: "\u{0634}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD27}",
        nfc: "\u{FD27}",
        nfd: "\u{FD27}",
        nfkc: "\u{0634}\u{062E}",
        nfkd: "\u{0634}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FD28}",
        nfc: "\u{FD28}",
        nfd: "\u{FD28}",
        nfkc: "\u{0634}\u{0645}",
        nfkd: "\u{0634}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD29}",
        nfc: "\u{FD29}",
        nfd: "\u{FD29}",
        nfkc: "\u{0634}\u{0631}",
        nfkd: "\u{0634}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FD2A}",
        nfc: "\u{FD2A}",
        nfd: "\u{FD2A}",
        nfkc: "\u{0633}\u{0631}",
        nfkd: "\u{0633}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FD2B}",
        nfc: "\u{FD2B}",
        nfd: "\u{FD2B}",
        nfkc: "\u{0635}\u{0631}",
        nfkd: "\u{0635}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FD2C}",
        nfc: "\u{FD2C}",
        nfd: "\u{FD2C}",
        nfkc: "\u{0636}\u{0631}",
        nfkd: "\u{0636}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FD2D}",
        nfc: "\u{FD2D}",
        nfd: "\u{FD2D}",
        nfkc: "\u{0634}\u{062C}",
        nfkd: "\u{0634}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD2E}",
        nfc: "\u{FD2E}",
        nfd: "\u{FD2E}",
        nfkc: "\u{0634}\u{062D}",
        nfkd: "\u{0634}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD2F}",
        nfc: "\u{FD2F}",
        nfd: "\u{FD2F}",
        nfkc: "\u{0634}\u{062E}",
        nfkd: "\u{0634}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FD30}",
        nfc: "\u{FD30}",
        nfd: "\u{FD30}",
        nfkc: "\u{0634}\u{0645}",
        nfkd: "\u{0634}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD31}",
        nfc: "\u{FD31}",
        nfd: "\u{FD31}",
        nfkc: "\u{0633}\u{0647}",
        nfkd: "\u{0633}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FD32}",
        nfc: "\u{FD32}",
        nfd: "\u{FD32}",
        nfkc: "\u{0634}\u{0647}",
        nfkd: "\u{0634}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FD33}",
        nfc: "\u{FD33}",
        nfd: "\u{FD33}",
        nfkc: "\u{0637}\u{0645}",
        nfkd: "\u{0637}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD34}",
        nfc: "\u{FD34}",
        nfd: "\u{FD34}",
        nfkc: "\u{0633}\u{062C}",
        nfkd: "\u{0633}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD35}",
        nfc: "\u{FD35}",
        nfd: "\u{FD35}",
        nfkc: "\u{0633}\u{062D}",
        nfkd: "\u{0633}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD36}",
        nfc: "\u{FD36}",
        nfd: "\u{FD36}",
        nfkc: "\u{0633}\u{062E}",
        nfkd: "\u{0633}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FD37}",
        nfc: "\u{FD37}",
        nfd: "\u{FD37}",
        nfkc: "\u{0634}\u{062C}",
        nfkd: "\u{0634}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD38}",
        nfc: "\u{FD38}",
        nfd: "\u{FD38}",
        nfkc: "\u{0634}\u{062D}",
        nfkd: "\u{0634}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD39}",
        nfc: "\u{FD39}",
        nfd: "\u{FD39}",
        nfkc: "\u{0634}\u{062E}",
        nfkd: "\u{0634}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FD3A}",
        nfc: "\u{FD3A}",
        nfd: "\u{FD3A}",
        nfkc: "\u{0637}\u{0645}",
        nfkd: "\u{0637}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD3B}",
        nfc: "\u{FD3B}",
        nfd: "\u{FD3B}",
        nfkc: "\u{0638}\u{0645}",
        nfkd: "\u{0638}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD3C}",
        nfc: "\u{FD3C}",
        nfd: "\u{FD3C}",
        nfkc: "\u{0627}\u{064B}",
        nfkd: "\u{0627}\u{064B}",
    },
    NormalizationTest {
        source: "\u{FD3D}",
        nfc: "\u{FD3D}",
        nfd: "\u{FD3D}",
        nfkc: "\u{0627}\u{064B}",
        nfkd: "\u{0627}\u{064B}",
    },
    NormalizationTest {
        source: "\u{FD50}",
        nfc: "\u{FD50}",
        nfd: "\u{FD50}",
        nfkc: "\u{062A}\u{062C}\u{0645}",
        nfkd: "\u{062A}\u{062C}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD51}",
        nfc: "\u{FD51}",
        nfd: "\u{FD51}",
        nfkc: "\u{062A}\u{062D}\u{062C}",
        nfkd: "\u{062A}\u{062D}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD52}",
        nfc: "\u{FD52}",
        nfd: "\u{FD52}",
        nfkc: "\u{062A}\u{062D}\u{062C}",
        nfkd: "\u{062A}\u{062D}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD53}",
        nfc: "\u{FD53}",
        nfd: "\u{FD53}",
        nfkc: "\u{062A}\u{062D}\u{0645}",
        nfkd: "\u{062A}\u{062D}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD54}",
        nfc: "\u{FD54}",
        nfd: "\u{FD54}",
        nfkc: "\u{062A}\u{062E}\u{0645}",
        nfkd: "\u{062A}\u{062E}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD55}",
        nfc: "\u{FD55}",
        nfd: "\u{FD55}",
        nfkc: "\u{062A}\u{0645}\u{062C}",
        nfkd: "\u{062A}\u{0645}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD56}",
        nfc: "\u{FD56}",
        nfd: "\u{FD56}",
        nfkc: "\u{062A}\u{0645}\u{062D}",
        nfkd: "\u{062A}\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD57}",
        nfc: "\u{FD57}",
        nfd: "\u{FD57}",
        nfkc: "\u{062A}\u{0645}\u{062E}",
        nfkd: "\u{062A}\u{0645}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FD58}",
        nfc: "\u{FD58}",
        nfd: "\u{FD58}",
        nfkc: "\u{062C}\u{0645}\u{062D}",
        nfkd: "\u{062C}\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD59}",
        nfc: "\u{FD59}",
        nfd: "\u{FD59}",
        nfkc: "\u{062C}\u{0645}\u{062D}",
        nfkd: "\u{062C}\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD5A}",
        nfc: "\u{FD5A}",
        nfd: "\u{FD5A}",
        nfkc: "\u{062D}\u{0645}\u{064A}",
        nfkd: "\u{062D}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD5B}",
        nfc: "\u{FD5B}",
        nfd: "\u{FD5B}",
        nfkc: "\u{062D}\u{0645}\u{0649}",
        nfkd: "\u{062D}\u{0645}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD5C}",
        nfc: "\u{FD5C}",
        nfd: "\u{FD5C}",
        nfkc: "\u{0633}\u{062D}\u{062C}",
        nfkd: "\u{0633}\u{062D}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD5D}",
        nfc: "\u{FD5D}",
        nfd: "\u{FD5D}",
        nfkc: "\u{0633}\u{062C}\u{062D}",
        nfkd: "\u{0633}\u{062C}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD5E}",
        nfc: "\u{FD5E}",
        nfd: "\u{FD5E}",
        nfkc: "\u{0633}\u{062C}\u{0649}",
        nfkd: "\u{0633}\u{062C}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD5F}",
        nfc: "\u{FD5F}",
        nfd: "\u{FD5F}",
        nfkc: "\u{0633}\u{0645}\u{062D}",
        nfkd: "\u{0633}\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD60}",
        nfc: "\u{FD60}",
        nfd: "\u{FD60}",
        nfkc: "\u{0633}\u{0645}\u{062D}",
        nfkd: "\u{0633}\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD61}",
        nfc: "\u{FD61}",
        nfd: "\u{FD61}",
        nfkc: "\u{0633}\u{0645}\u{062C}",
        nfkd: "\u{0633}\u{0645}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD62}",
        nfc: "\u{FD62}",
        nfd: "\u{FD62}",
        nfkc: "\u{0633}\u{0645}\u{0645}",
        nfkd: "\u{0633}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD63}",
        nfc: "\u{FD63}",
        nfd: "\u{FD63}",
        nfkc: "\u{0633}\u{0645}\u{0645}",
        nfkd: "\u{0633}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD64}",
        nfc: "\u{FD64}",
        nfd: "\u{FD64}",
        nfkc: "\u{0635}\u{062D}\u{062D}",
        nfkd: "\u{0635}\u{062D}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD65}",
        nfc: "\u{FD65}",
        nfd: "\u{FD65}",
        nfkc: "\u{0635}\u{062D}\u{062D}",
        nfkd: "\u{0635}\u{062D}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD66}",
        nfc: "\u{FD66}",
        nfd: "\u{FD66}",
        nfkc: "\u{0635}\u{0645}\u{0645}",
        nfkd: "\u{0635}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD67}",
        nfc: "\u{FD67}",
        nfd: "\u{FD67}",
        nfkc: "\u{0634}\u{062D}\u{0645}",
        nfkd: "\u{0634}\u{062D}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD68}",
        nfc: "\u{FD68}",
        nfd: "\u{FD68}",
        nfkc: "\u{0634}\u{062D}\u{0645}",
        nfkd: "\u{0634}\u{062D}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD69}",
        nfc: "\u{FD69}",
        nfd: "\u{FD69}",
        nfkc: "\u{0634}\u{062C}\u{064A}",
        nfkd: "\u{0634}\u{062C}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD6A}",
        nfc: "\u{FD6A}",
        nfd: "\u{FD6A}",
        nfkc: "\u{0634}\u{0645}\u{062E}",
        nfkd: "\u{0634}\u{0645}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FD6B}",
        nfc: "\u{FD6B}",
        nfd: "\u{FD6B}",
        nfkc: "\u{0634}\u{0645}\u{062E}",
        nfkd: "\u{0634}\u{0645}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FD6C}",
        nfc: "\u{FD6C}",
        nfd: "\u{FD6C}",
        nfkc: "\u{0634}\u{0645}\u{0645}",
        nfkd: "\u{0634}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD6D}",
        nfc: "\u{FD6D}",
        nfd: "\u{FD6D}",
        nfkc: "\u{0634}\u{0645}\u{0645}",
        nfkd: "\u{0634}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD6E}",
        nfc: "\u{FD6E}",
        nfd: "\u{FD6E}",
        nfkc: "\u{0636}\u{062D}\u{0649}",
        nfkd: "\u{0636}\u{062D}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD6F}",
        nfc: "\u{FD6F}",
        nfd: "\u{FD6F}",
        nfkc: "\u{0636}\u{062E}\u{0645}",
        nfkd: "\u{0636}\u{062E}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD70}",
        nfc: "\u{FD70}",
        nfd: "\u{FD70}",
        nfkc: "\u{0636}\u{062E}\u{0645}",
        nfkd: "\u{0636}\u{062E}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD71}",
        nfc: "\u{FD71}",
        nfd: "\u{FD71}",
        nfkc: "\u{0637}\u{0645}\u{062D}",
        nfkd: "\u{0637}\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD72}",
        nfc: "\u{FD72}",
        nfd: "\u{FD72}",
        nfkc: "\u{0637}\u{0645}\u{062D}",
        nfkd: "\u{0637}\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD73}",
        nfc: "\u{FD73}",
        nfd: "\u{FD73}",
        nfkc: "\u{0637}\u{0645}\u{0645}",
        nfkd: "\u{0637}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD74}",
        nfc: "\u{FD74}",
        nfd: "\u{FD74}",
        nfkc: "\u{0637}\u{0645}\u{064A}",
        nfkd: "\u{0637}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD75}",
        nfc: "\u{FD75}",
        nfd: "\u{FD75}",
        nfkc: "\u{0639}\u{062C}\u{0645}",
        nfkd: "\u{0639}\u{062C}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD76}",
        nfc: "\u{FD76}",
        nfd: "\u{FD76}",
        nfkc: "\u{0639}\u{0645}\u{0645}",
        nfkd: "\u{0639}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD77}",
        nfc: "\u{FD77}",
        nfd: "\u{FD77}",
        nfkc: "\u{0639}\u{0645}\u{0645}",
        nfkd: "\u{0639}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD78}",
        nfc: "\u{FD78}",
        nfd: "\u{FD78}",
        nfkc: "\u{0639}\u{0645}\u{0649}",
        nfkd: "\u{0639}\u{0645}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD79}",
        nfc: "\u{FD79}",
        nfd: "\u{FD79}",
        nfkc: "\u{063A}\u{0645}\u{0645}",
        nfkd: "\u{063A}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD7A}",
        nfc: "\u{FD7A}",
        nfd: "\u{FD7A}",
        nfkc: "\u{063A}\u{0645}\u{064A}",
        nfkd: "\u{063A}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD7B}",
        nfc: "\u{FD7B}",
        nfd: "\u{FD7B}",
        nfkc: "\u{063A}\u{0645}\u{0649}",
        nfkd: "\u{063A}\u{0645}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD7C}",
        nfc: "\u{FD7C}",
        nfd: "\u{FD7C}",
        nfkc: "\u{0641}\u{062E}\u{0645}",
        nfkd: "\u{0641}\u{062E}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD7D}",
        nfc: "\u{FD7D}",
        nfd: "\u{FD7D}",
        nfkc: "\u{0641}\u{062E}\u{0645}",
        nfkd: "\u{0641}\u{062E}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD7E}",
        nfc: "\u{FD7E}",
        nfd: "\u{FD7E}",
        nfkc: "\u{0642}\u{0645}\u{062D}",
        nfkd: "\u{0642}\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD7F}",
        nfc: "\u{FD7F}",
        nfd: "\u{FD7F}",
        nfkc: "\u{0642}\u{0645}\u{0645}",
        nfkd: "\u{0642}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD80}",
        nfc: "\u{FD80}",
        nfd: "\u{FD80}",
        nfkc: "\u{0644}\u{062D}\u{0645}",
        nfkd: "\u{0644}\u{062D}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD81}",
        nfc: "\u{FD81}",
        nfd: "\u{FD81}",
        nfkc: "\u{0644}\u{062D}\u{064A}",
        nfkd: "\u{0644}\u{062D}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD82}",
        nfc: "\u{FD82}",
        nfd: "\u{FD82}",
        nfkc: "\u{0644}\u{062D}\u{0649}",
        nfkd: "\u{0644}\u{062D}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD83}",
        nfc: "\u{FD83}",
        nfd: "\u{FD83}",
        nfkc: "\u{0644}\u{062C}\u{062C}",
        nfkd: "\u{0644}\u{062C}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD84}",
        nfc: "\u{FD84}",
        nfd: "\u{FD84}",
        nfkc: "\u{0644}\u{062C}\u{062C}",
        nfkd: "\u{0644}\u{062C}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD85}",
        nfc: "\u{FD85}",
        nfd: "\u{FD85}",
        nfkc: "\u{0644}\u{062E}\u{0645}",
        nfkd: "\u{0644}\u{062E}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD86}",
        nfc: "\u{FD86}",
        nfd: "\u{FD86}",
        nfkc: "\u{0644}\u{062E}\u{0645}",
        nfkd: "\u{0644}\u{062E}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD87}",
        nfc: "\u{FD87}",
        nfd: "\u{FD87}",
        nfkc: "\u{0644}\u{0645}\u{062D}",
        nfkd: "\u{0644}\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD88}",
        nfc: "\u{FD88}",
        nfd: "\u{FD88}",
        nfkc: "\u{0644}\u{0645}\u{062D}",
        nfkd: "\u{0644}\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD89}",
        nfc: "\u{FD89}",
        nfd: "\u{FD89}",
        nfkc: "\u{0645}\u{062D}\u{062C}",
        nfkd: "\u{0645}\u{062D}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD8A}",
        nfc: "\u{FD8A}",
        nfd: "\u{FD8A}",
        nfkc: "\u{0645}\u{062D}\u{0645}",
        nfkd: "\u{0645}\u{062D}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD8B}",
        nfc: "\u{FD8B}",
        nfd: "\u{FD8B}",
        nfkc: "\u{0645}\u{062D}\u{064A}",
        nfkd: "\u{0645}\u{062D}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD8C}",
        nfc: "\u{FD8C}",
        nfd: "\u{FD8C}",
        nfkc: "\u{0645}\u{062C}\u{062D}",
        nfkd: "\u{0645}\u{062C}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FD8D}",
        nfc: "\u{FD8D}",
        nfd: "\u{FD8D}",
        nfkc: "\u{0645}\u{062C}\u{0645}",
        nfkd: "\u{0645}\u{062C}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD8E}",
        nfc: "\u{FD8E}",
        nfd: "\u{FD8E}",
        nfkc: "\u{0645}\u{062E}\u{062C}",
        nfkd: "\u{0645}\u{062E}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD8F}",
        nfc: "\u{FD8F}",
        nfd: "\u{FD8F}",
        nfkc: "\u{0645}\u{062E}\u{0645}",
        nfkd: "\u{0645}\u{062E}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD92}",
        nfc: "\u{FD92}",
        nfd: "\u{FD92}",
        nfkc: "\u{0645}\u{062C}\u{062E}",
        nfkd: "\u{0645}\u{062C}\u{062E}",
    },
    NormalizationTest {
        source: "\u{FD93}",
        nfc: "\u{FD93}",
        nfd: "\u{FD93}",
        nfkc: "\u{0647}\u{0645}\u{062C}",
        nfkd: "\u{0647}\u{0645}\u{062C}",
    },
    NormalizationTest {
        source: "\u{FD94}",
        nfc: "\u{FD94}",
        nfd: "\u{FD94}",
        nfkc: "\u{0647}\u{0645}\u{0645}",
        nfkd: "\u{0647}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD95}",
        nfc: "\u{FD95}",
        nfd: "\u{FD95}",
        nfkc: "\u{0646}\u{062D}\u{0645}",
        nfkd: "\u{0646}\u{062D}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD96}",
        nfc: "\u{FD96}",
        nfd: "\u{FD96}",
        nfkc: "\u{0646}\u{062D}\u{0649}",
        nfkd: "\u{0646}\u{062D}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD97}",
        nfc: "\u{FD97}",
        nfd: "\u{FD97}",
        nfkc: "\u{0646}\u{062C}\u{0645}",
        nfkd: "\u{0646}\u{062C}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD98}",
        nfc: "\u{FD98}",
        nfd: "\u{FD98}",
        nfkc: "\u{0646}\u{062C}\u{0645}",
        nfkd: "\u{0646}\u{062C}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD99}",
        nfc: "\u{FD99}",
        nfd: "\u{FD99}",
        nfkc: "\u{0646}\u{062C}\u{0649}",
        nfkd: "\u{0646}\u{062C}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD9A}",
        nfc: "\u{FD9A}",
        nfd: "\u{FD9A}",
        nfkc: "\u{0646}\u{0645}\u{064A}",
        nfkd: "\u{0646}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD9B}",
        nfc: "\u{FD9B}",
        nfd: "\u{FD9B}",
        nfkc: "\u{0646}\u{0645}\u{0649}",
        nfkd: "\u{0646}\u{0645}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FD9C}",
        nfc: "\u{FD9C}",
        nfd: "\u{FD9C}",
        nfkc: "\u{064A}\u{0645}\u{0645}",
        nfkd: "\u{064A}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD9D}",
        nfc: "\u{FD9D}",
        nfd: "\u{FD9D}",
        nfkc: "\u{064A}\u{0645}\u{0645}",
        nfkd: "\u{064A}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FD9E}",
        nfc: "\u{FD9E}",
        nfd: "\u{FD9E}",
        nfkc: "\u{0628}\u{062E}\u{064A}",
        nfkd: "\u{0628}\u{062E}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FD9F}",
        nfc: "\u{FD9F}",
        nfd: "\u{FD9F}",
        nfkc: "\u{062A}\u{062C}\u{064A}",
        nfkd: "\u{062A}\u{062C}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDA0}",
        nfc: "\u{FDA0}",
        nfd: "\u{FDA0}",
        nfkc: "\u{062A}\u{062C}\u{0649}",
        nfkd: "\u{062A}\u{062C}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FDA1}",
        nfc: "\u{FDA1}",
        nfd: "\u{FDA1}",
        nfkc: "\u{062A}\u{062E}\u{064A}",
        nfkd: "\u{062A}\u{062E}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDA2}",
        nfc: "\u{FDA2}",
        nfd: "\u{FDA2}",
        nfkc: "\u{062A}\u{062E}\u{0649}",
        nfkd: "\u{062A}\u{062E}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FDA3}",
        nfc: "\u{FDA3}",
        nfd: "\u{FDA3}",
        nfkc: "\u{062A}\u{0645}\u{064A}",
        nfkd: "\u{062A}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDA4}",
        nfc: "\u{FDA4}",
        nfd: "\u{FDA4}",
        nfkc: "\u{062A}\u{0645}\u{0649}",
        nfkd: "\u{062A}\u{0645}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FDA5}",
        nfc: "\u{FDA5}",
        nfd: "\u{FDA5}",
        nfkc: "\u{062C}\u{0645}\u{064A}",
        nfkd: "\u{062C}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDA6}",
        nfc: "\u{FDA6}",
        nfd: "\u{FDA6}",
        nfkc: "\u{062C}\u{062D}\u{0649}",
        nfkd: "\u{062C}\u{062D}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FDA7}",
        nfc: "\u{FDA7}",
        nfd: "\u{FDA7}",
        nfkc: "\u{062C}\u{0645}\u{0649}",
        nfkd: "\u{062C}\u{0645}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FDA8}",
        nfc: "\u{FDA8}",
        nfd: "\u{FDA8}",
        nfkc: "\u{0633}\u{062E}\u{0649}",
        nfkd: "\u{0633}\u{062E}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FDA9}",
        nfc: "\u{FDA9}",
        nfd: "\u{FDA9}",
        nfkc: "\u{0635}\u{062D}\u{064A}",
        nfkd: "\u{0635}\u{062D}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDAA}",
        nfc: "\u{FDAA}",
        nfd: "\u{FDAA}",
        nfkc: "\u{0634}\u{062D}\u{064A}",
        nfkd: "\u{0634}\u{062D}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDAB}",
        nfc: "\u{FDAB}",
        nfd: "\u{FDAB}",
        nfkc: "\u{0636}\u{062D}\u{064A}",
        nfkd: "\u{0636}\u{062D}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDAC}",
        nfc: "\u{FDAC}",
        nfd: "\u{FDAC}",
        nfkc: "\u{0644}\u{062C}\u{064A}",
        nfkd: "\u{0644}\u{062C}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDAD}",
        nfc: "\u{FDAD}",
        nfd: "\u{FDAD}",
        nfkc: "\u{0644}\u{0645}\u{064A}",
        nfkd: "\u{0644}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDAE}",
        nfc: "\u{FDAE}",
        nfd: "\u{FDAE}",
        nfkc: "\u{064A}\u{062D}\u{064A}",
        nfkd: "\u{064A}\u{062D}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDAF}",
        nfc: "\u{FDAF}",
        nfd: "\u{FDAF}",
        nfkc: "\u{064A}\u{062C}\u{064A}",
        nfkd: "\u{064A}\u{062C}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDB0}",
        nfc: "\u{FDB0}",
        nfd: "\u{FDB0}",
        nfkc: "\u{064A}\u{0645}\u{064A}",
        nfkd: "\u{064A}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDB1}",
        nfc: "\u{FDB1}",
        nfd: "\u{FDB1}",
        nfkc: "\u{0645}\u{0645}\u{064A}",
        nfkd: "\u{0645}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDB2}",
        nfc: "\u{FDB2}",
        nfd: "\u{FDB2}",
        nfkc: "\u{0642}\u{0645}\u{064A}",
        nfkd: "\u{0642}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDB3}",
        nfc: "\u{FDB3}",
        nfd: "\u{FDB3}",
        nfkc: "\u{0646}\u{062D}\u{064A}",
        nfkd: "\u{0646}\u{062D}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDB4}",
        nfc: "\u{FDB4}",
        nfd: "\u{FDB4}",
        nfkc: "\u{0642}\u{0645}\u{062D}",
        nfkd: "\u{0642}\u{0645}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FDB5}",
        nfc: "\u{FDB5}",
        nfd: "\u{FDB5}",
        nfkc: "\u{0644}\u{062D}\u{0645}",
        nfkd: "\u{0644}\u{062D}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FDB6}",
        nfc: "\u{FDB6}",
        nfd: "\u{FDB6}",
        nfkc: "\u{0639}\u{0645}\u{064A}",
        nfkd: "\u{0639}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDB7}",
        nfc: "\u{FDB7}",
        nfd: "\u{FDB7}",
        nfkc: "\u{0643}\u{0645}\u{064A}",
        nfkd: "\u{0643}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDB8}",
        nfc: "\u{FDB8}",
        nfd: "\u{FDB8}",
        nfkc: "\u{0646}\u{062C}\u{062D}",
        nfkd: "\u{0646}\u{062C}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FDB9}",
        nfc: "\u{FDB9}",
        nfd: "\u{FDB9}",
        nfkc: "\u{0645}\u{062E}\u{064A}",
        nfkd: "\u{0645}\u{062E}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDBA}",
        nfc: "\u{FDBA}",
        nfd: "\u{FDBA}",
        nfkc: "\u{0644}\u{062C}\u{0645}",
        nfkd: "\u{0644}\u{062C}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FDBB}",
        nfc: "\u{FDBB}",
        nfd: "\u{FDBB}",
        nfkc: "\u{0643}\u{0645}\u{0645}",
        nfkd: "\u{0643}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FDBC}",
        nfc: "\u{FDBC}",
        nfd: "\u{FDBC}",
        nfkc: "\u{0644}\u{062C}\u{0645}",
        nfkd: "\u{0644}\u{062C}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FDBD}",
        nfc: "\u{FDBD}",
        nfd: "\u{FDBD}",
        nfkc: "\u{0646}\u{062C}\u{062D}",
        nfkd: "\u{0646}\u{062C}\u{062D}",
    },
    NormalizationTest {
        source: "\u{FDBE}",
        nfc: "\u{FDBE}",
        nfd: "\u{FDBE}",
        nfkc: "\u{062C}\u{062D}\u{064A}",
        nfkd: "\u{062C}\u{062D}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDBF}",
        nfc: "\u{FDBF}",
        nfd: "\u{FDBF}",
        nfkc: "\u{062D}\u{062C}\u{064A}",
        nfkd: "\u{062D}\u{062C}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDC0}",
        nfc: "\u{FDC0}",
        nfd: "\u{FDC0}",
        nfkc: "\u{0645}\u{062C}\u{064A}",
        nfkd: "\u{0645}\u{062C}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDC1}",
        nfc: "\u{FDC1}",
        nfd: "\u{FDC1}",
        nfkc: "\u{0641}\u{0645}\u{064A}",
        nfkd: "\u{0641}\u{0645}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDC2}",
        nfc: "\u{FDC2}",
        nfd: "\u{FDC2}",
        nfkc: "\u{0628}\u{062D}\u{064A}",
        nfkd: "\u{0628}\u{062D}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDC3}",
        nfc: "\u{FDC3}",
        nfd: "\u{FDC3}",
        nfkc: "\u{0643}\u{0645}\u{0645}",
        nfkd: "\u{0643}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FDC4}",
        nfc: "\u{FDC4}",
        nfd: "\u{FDC4}",
        nfkc: "\u{0639}\u{062C}\u{0645}",
        nfkd: "\u{0639}\u{062C}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FDC5}",
        nfc: "\u{FDC5}",
        nfd: "\u{FDC5}",
        nfkc: "\u{0635}\u{0645}\u{0645}",
        nfkd: "\u{0635}\u{0645}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FDC6}",
        nfc: "\u{FDC6}",
        nfd: "\u{FDC6}",
        nfkc: "\u{0633}\u{062E}\u{064A}",
        nfkd: "\u{0633}\u{062E}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDC7}",
        nfc: "\u{FDC7}",
        nfd: "\u{FDC7}",
        nfkc: "\u{0646}\u{062C}\u{064A}",
        nfkd: "\u{0646}\u{062C}\u{064A}",
    },
    NormalizationTest {
        source: "\u{FDF0}",
        nfc: "\u{FDF0}",
        nfd: "\u{FDF0}",
        nfkc: "\u{0635}\u{0644}\u{06D2}",
        nfkd: "\u{0635}\u{0644}\u{06D2}",
    },
    NormalizationTest {
        source: "\u{FDF1}",
        nfc: "\u{FDF1}",
        nfd: "\u{FDF1}",
        nfkc: "\u{0642}\u{0644}\u{06D2}",
        nfkd: "\u{0642}\u{0644}\u{06D2}",
    },
    NormalizationTest {
        source: "\u{FDF2}",
        nfc: "\u{FDF2}",
        nfd: "\u{FDF2}",
        nfkc: "\u{0627}\u{0644}\u{0644}\u{0647}",
        nfkd: "\u{0627}\u{0644}\u{0644}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FDF3}",
        nfc: "\u{FDF3}",
        nfd: "\u{FDF3}",
        nfkc: "\u{0627}\u{0643}\u{0628}\u{0631}",
        nfkd: "\u{0627}\u{0643}\u{0628}\u{0631}",
    },
    NormalizationTest {
        source: "\u{FDF4}",
        nfc: "\u{FDF4}",
        nfd: "\u{FDF4}",
        nfkc: "\u{0645}\u{062D}\u{0645}\u{062F}",
        nfkd: "\u{0645}\u{062D}\u{0645}\u{062F}",
    },
    NormalizationTest {
        source: "\u{FDF5}",
        nfc: "\u{FDF5}",
        nfd: "\u{FDF5}",
        nfkc: "\u{0635}\u{0644}\u{0639}\u{0645}",
        nfkd: "\u{0635}\u{0644}\u{0639}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FDF6}",
        nfc: "\u{FDF6}",
        nfd: "\u{FDF6}",
        nfkc: "\u{0631}\u{0633}\u{0648}\u{0644}",
        nfkd: "\u{0631}\u{0633}\u{0648}\u{0644}",
    },
    NormalizationTest {
        source: "\u{FDF7}",
        nfc: "\u{FDF7}",
        nfd: "\u{FDF7}",
        nfkc: "\u{0639}\u{0644}\u{064A}\u{0647}",
        nfkd: "\u{0639}\u{0644}\u{064A}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FDF8}",
        nfc: "\u{FDF8}",
        nfd: "\u{FDF8}",
        nfkc: "\u{0648}\u{0633}\u{0644}\u{0645}",
        nfkd: "\u{0648}\u{0633}\u{0644}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FDF9}",
        nfc: "\u{FDF9}",
        nfd: "\u{FDF9}",
        nfkc: "\u{0635}\u{0644}\u{0649}",
        nfkd: "\u{0635}\u{0644}\u{0649}",
    },
    NormalizationTest {
        source: "\u{FDFA}",
        nfc: "\u{FDFA}",
        nfd: "\u{FDFA}",
        nfkc: "\u{0635}\u{0644}\u{0649}\u{0020}\u{0627}\u{0644}\u{0644}\u{0647}\u{0020}\u{0639}\u{0644}\u{064A}\u{0647}\u{0020}\u{0648}\u{0633}\u{0644}\u{0645}",
        nfkd: "\u{0635}\u{0644}\u{0649}\u{0020}\u{0627}\u{0644}\u{0644}\u{0647}\u{0020}\u{0639}\u{0644}\u{064A}\u{0647}\u{0020}\u{0648}\u{0633}\u{0644}\u{0645}",
    },
    NormalizationTest {
        source: "\u{FDFB}",
        nfc: "\u{FDFB}",
        nfd: "\u{FDFB}",
        nfkc: "\u{062C}\u{0644}\u{0020}\u{062C}\u{0644}\u{0627}\u{0644}\u{0647}",
        nfkd: "\u{062C}\u{0644}\u{0020}\u{062C}\u{0644}\u{0627}\u{0644}\u{0647}",
    },
    NormalizationTest {
        source: "\u{FDFC}",
        nfc: "\u{FDFC}",
        nfd: "\u{FDFC}",
        nfkc: "\u{0631}\u{06CC}\u{0627}\u{0644}",
        nfkd: "\u{0631}\u{06CC}\u{0627}\u{0644}",
    },
    NormalizationTest {
        source: "\u{FE10}",
        nfc: "\u{FE10}",
        nfd: "\u{FE10}",
        nfkc: "\u{002C}",
        nfkd: "\u{002C}",
    },
    NormalizationTest {
        source: "\u{FE11}",
        nfc: "\u{FE11}",
        nfd: "\u{FE11}",
        nfkc: "\u{3001}",
        nfkd: "\u{3001}",
    },
    NormalizationTest {
        source: "\u{FE12}",
        nfc: "\u{FE12}",
        nfd: "\u{FE12}",
        nfkc: "\u{3002}",
        nfkd: "\u{3002}",
    },
    NormalizationTest {
        source: "\u{FE13}",
        nfc: "\u{FE13}",
        nfd: "\u{FE13}",
        nfkc: "\u{003A}",
        nfkd: "\u{003A}",
    },
    NormalizationTest {
        source: "\u{FE14}",
        nfc: "\u{FE14}",
        nfd: "\u{FE14}",
        nfkc: "\u{003B}",
        nfkd: "\u{003B}",
    },
    NormalizationTest {
        source: "\u{FE15}",
        nfc: "\u{FE15}",
        nfd: "\u{FE15}",
        nfkc: "\u{0021}",
        nfkd: "\u{0021}",
    },
    NormalizationTest {
        source: "\u{FE16}",
        nfc: "\u{FE16}",
        nfd: "\u{FE16}",
        nfkc: "\u{003F}",
        nfkd: "\u{003F}",
    },
    NormalizationTest {
        source: "\u{FE17}",
        nfc: "\u{FE17}",
        nfd: "\u{FE17}",
        nfkc: "\u{3016}",
        nfkd: "\u{3016}",
    },
    NormalizationTest {
        source: "\u{FE18}",
        nfc: "\u{FE18}",
        nfd: "\u{FE18}",
        nfkc: "\u{3017}",
        nfkd: "\u{3017}",
    },
    NormalizationTest {
        source: "\u{FE19}",
        nfc: "\u{FE19}",
        nfd: "\u{FE19}",
        nfkc: "\u{002E}\u{002E}\u{002E}",
        nfkd: "\u{002E}\u{002E}\u{002E}",
    },
    NormalizationTest {
        source: "\u{FE30}",
        nfc: "\u{FE30}",
        nfd: "\u{FE30}",
        nfkc: "\u{002E}\u{002E}",
        nfkd: "\u{002E}\u{002E}",
    },
    NormalizationTest {
        source: "\u{FE31}",
        nfc: "\u{FE31}",
        nfd: "\u{FE31}",
        nfkc: "\u{2014}",
        nfkd: "\u{2014}",
    },
    NormalizationTest {
        source: "\u{FE32}",
        nfc: "\u{FE32}",
        nfd: "\u{FE32}",
        nfkc: "\u{2013}",
        nfkd: "\u{2013}",
    },
    NormalizationTest {
        source: "\u{FE33}",
        nfc: "\u{FE33}",
        nfd: "\u{FE33}",
        nfkc: "\u{005F}",
        nfkd: "\u{005F}",
    },
    NormalizationTest {
        source: "\u{FE34}",
        nfc: "\u{FE34}",
        nfd: "\u{FE34}",
        nfkc: "\u{005F}",
        nfkd: "\u{005F}",
    },
    NormalizationTest {
        source: "\u{FE35}",
        nfc: "\u{FE35}",
        nfd: "\u{FE35}",
        nfkc: "\u{0028}",
        nfkd: "\u{0028}",
    },
    NormalizationTest {
        source: "\u{FE36}",
        nfc: "\u{FE36}",
        nfd: "\u{FE36}",
        nfkc: "\u{0029}",
        nfkd: "\u{0029}",
    },
    NormalizationTest {
        source: "\u{FE37}",
        nfc: "\u{FE37}",
        nfd: "\u{FE37}",
        nfkc: "\u{007B}",
        nfkd: "\u{007B}",
    },
    NormalizationTest {
        source: "\u{FE38}",
        nfc: "\u{FE38}",
        nfd: "\u{FE38}",
        nfkc: "\u{007D}",
        nfkd: "\u{007D}",
    },
    NormalizationTest {
        source: "\u{FE39}",
        nfc: "\u{FE39}",
        nfd: "\u{FE39}",
        nfkc: "\u{3014}",
        nfkd: "\u{3014}",
    },
    NormalizationTest {
        source: "\u{FE3A}",
        nfc: "\u{FE3A}",
        nfd: "\u{FE3A}",
        nfkc: "\u{3015}",
        nfkd: "\u{3015}",
    },
    NormalizationTest {
        source: "\u{FE3B}",
        nfc: "\u{FE3B}",
        nfd: "\u{FE3B}",
        nfkc: "\u{3010}",
        nfkd: "\u{3010}",
    },
    NormalizationTest {
        source: "\u{FE3C}",
        nfc: "\u{FE3C}",
        nfd: "\u{FE3C}",
        nfkc: "\u{3011}",
        nfkd: "\u{3011}",
    },
    NormalizationTest {
        source: "\u{FE3D}",
        nfc: "\u{FE3D}",
        nfd: "\u{FE3D}",
        nfkc: "\u{300A}",
        nfkd: "\u{300A}",
    },
    NormalizationTest {
        source: "\u{FE3E}",
        nfc: "\u{FE3E}",
        nfd: "\u{FE3E}",
        nfkc: "\u{300B}",
        nfkd: "\u{300B}",
    },
    NormalizationTest {
        source: "\u{FE3F}",
        nfc: "\u{FE3F}",
        nfd: "\u{FE3F}",
        nfkc: "\u{3008}",
        nfkd: "\u{3008}",
    },
    NormalizationTest {
        source: "\u{FE40}",
        nfc: "\u{FE40}",
        nfd: "\u{FE40}",
        nfkc: "\u{3009}",
        nfkd: "\u{3009}",
    },
    NormalizationTest {
        source: "\u{FE41}",
        nfc: "\u{FE41}",
        nfd: "\u{FE41}",
        nfkc: "\u{300C}",
        nfkd: "\u{300C}",
    },
    NormalizationTest {
        source: "\u{FE42}",
        nfc: "\u{FE42}",
        nfd: "\u{FE42}",
        nfkc: "\u{300D}",
        nfkd: "\u{300D}",
    },
    NormalizationTest {
        source: "\u{FE43}",
        nfc: "\u{FE43}",
        nfd: "\u{FE43}",
        nfkc: "\u{300E}",
        nfkd: "\u{300E}",
    },
    NormalizationTest {
        source: "\u{FE44}",
        nfc: "\u{FE44}",
        nfd: "\u{FE44}",
        nfkc: "\u{300F}",
        nfkd: "\u{300F}",
    },
    NormalizationTest {
        source: "\u{FE47}",
        nfc: "\u{FE47}",
        nfd: "\u{FE47}",
        nfkc: "\u{005B}",
        nfkd: "\u{005B}",
    },
    NormalizationTest {
        source: "\u{FE48}",
        nfc: "\u{FE48}",
        nfd: "\u{FE48}",
        nfkc: "\u{005D}",
        nfkd: "\u{005D}",
    },
    NormalizationTest {
        source: "\u{FE49}",
        nfc: "\u{FE49}",
        nfd: "\u{FE49}",
        nfkc: "\u{0020}\u{0305}",
        nfkd: "\u{0020}\u{0305}",
    },
    NormalizationTest {
        source: "\u{FE4A}",
        nfc: "\u{FE4A}",
        nfd: "\u{FE4A}",
        nfkc: "\u{0020}\u{0305}",
        nfkd: "\u{0020}\u{0305}",
    },
    NormalizationTest {
        source: "\u{FE4B}",
        nfc: "\u{FE4B}",
        nfd: "\u{FE4B}",
        nfkc: "\u{0020}\u{0305}",
        nfkd: "\u{0020}\u{0305}",
    },
    NormalizationTest {
        source: "\u{FE4C}",
        nfc: "\u{FE4C}",
        nfd: "\u{FE4C}",
        nfkc: "\u{0020}\u{0305}",
        nfkd: "\u{0020}\u{0305}",
    },
    NormalizationTest {
        source: "\u{FE4D}",
        nfc: "\u{FE4D}",
        nfd: "\u{FE4D}",
        nfkc: "\u{005F}",
        nfkd: "\u{005F}",
    },
    NormalizationTest {
        source: "\u{FE4E}",
        nfc: "\u{FE4E}",
        nfd: "\u{FE4E}",
        nfkc: "\u{005F}",
        nfkd: "\u{005F}",
    },
    NormalizationTest {
        source: "\u{FE4F}",
        nfc: "\u{FE4F}",
        nfd: "\u{FE4F}",
        nfkc: "\u{005F}",
        nfkd: "\u{005F}",
    },
    NormalizationTest {
        source: "\u{FE50}",
        nfc: "\u{FE50}",
        nfd: "\u{FE50}",
        nfkc: "\u{002C}",
        nfkd: "\u{002C}",
    },
    NormalizationTest {
        source: "\u{FE51}",
        nfc: "\u{FE51}",
        nfd: "\u{FE51}",
        nfkc: "\u{3001}",
        nfkd: "\u{3001}",
    },
    NormalizationTest {
        source: "\u{FE52}",
        nfc: "\u{FE52}",
        nfd: "\u{FE52}",
        nfkc: "\u{002E}",
        nfkd: "\u{002E}",
    },
    NormalizationTest {
        source: "\u{FE54}",
        nfc: "\u{FE54}",
        nfd: "\u{FE54}",
        nfkc: "\u{003B}",
        nfkd: "\u{003B}",
    },
    NormalizationTest {
        source: "\u{FE55}",
        nfc: "\u{FE55}",
        nfd: "\u{FE55}",
        nfkc: "\u{003A}",
        nfkd: "\u{003A}",
    },
    NormalizationTest {
        source: "\u{FE56}",
        nfc: "\u{FE56}",
        nfd: "\u{FE56}",
        nfkc: "\u{003F}",
        nfkd: "\u{003F}",
    },
    NormalizationTest {
        source: "\u{FE57}",
        nfc: "\u{FE57}",
        nfd: "\u{FE57}",
        nfkc: "\u{0021}",
        nfkd: "\u{0021}",
    },
    NormalizationTest {
        source: "\u{FE58}",
        nfc: "\u{FE58}",
        nfd: "\u{FE58}",
        nfkc: "\u{2014}",
        nfkd: "\u{2014}",
    },
    NormalizationTest {
        source: "\u{FE59}",
        nfc: "\u{FE59}",
        nfd: "\u{FE59}",
        nfkc: "\u{0028}",
        nfkd: "\u{0028}",
    },
    NormalizationTest {
        source: "\u{FE5A}",
        nfc: "\u{FE5A}",
        nfd: "\u{FE5A}",
        nfkc: "\u{0029}",
        nfkd: "\u{0029}",
    },
    NormalizationTest {
        source: "\u{FE5B}",
        nfc: "\u{FE5B}",
        nfd: "\u{FE5B}",
        nfkc: "\u{007B}",
        nfkd: "\u{007B}",
    },
    NormalizationTest {
        source: "\u{FE5C}",
        nfc: "\u{FE5C}",
        nfd: "\u{FE5C}",
        nfkc: "\u{007D}",
        nfkd: "\u{007D}",
    },
    NormalizationTest {
        source: "\u{FE5D}",
        nfc: "\u{FE5D}",
        nfd: "\u{FE5D}",
        nfkc: "\u{3014}",
        nfkd: "\u{3014}",
    },
    NormalizationTest {
        source: "\u{FE5E}",
        nfc: "\u{FE5E}",
        nfd: "\u{FE5E}",
        nfkc: "\u{3015}",
        nfkd: "\u{3015}",
    },
    NormalizationTest {
        source: "\u{FE5F}",
        nfc: "\u{FE5F}",
        nfd: "\u{FE5F}",
        nfkc: "\u{0023}",
        nfkd: "\u{0023}",
    },
    NormalizationTest {
        source: "\u{FE60}",
        nfc: "\u{FE60}",
        nfd: "\u{FE60}",
        nfkc: "\u{0026}",
        nfkd: "\u{0026}",
    },
    NormalizationTest {
        source: "\u{FE61}",
        nfc: "\u{FE61}",
        nfd: "\u{FE61}",
        nfkc: "\u{002A}",
        nfkd: "\u{002A}",
    },
    NormalizationTest {
        source: "\u{FE62}",
        nfc: "\u{FE62}",
        nfd: "\u{FE62}",
        nfkc: "\u{002B}",
        nfkd: "\u{002B}",
    },
    NormalizationTest {
        source: "\u{FE63}",
        nfc: "\u{FE63}",
        nfd: "\u{FE63}",
        nfkc: "\u{002D}",
        nfkd: "\u{002D}",
    },
    NormalizationTest {
        source: "\u{FE64}",
        nfc: "\u{FE64}",
        nfd: "\u{FE64}",
        nfkc: "\u{003C}",
        nfkd: "\u{003C}",
    },
    NormalizationTest {
        source: "\u{FE65}",
        nfc: "\u{FE65}",
        nfd: "\u{FE65}",
        nfkc: "\u{003E}",
        nfkd: "\u{003E}",
    },
    NormalizationTest {
        source: "\u{FE66}",
        nfc: "\u{FE66}",
        nfd: "\u{FE66}",
        nfkc: "\u{003D}",
        nfkd: "\u{003D}",
    },
    NormalizationTest {
        source: "\u{FE68}",
        nfc: "\u{FE68}",
        nfd: "\u{FE68}",
        nfkc: "\u{005C}",
        nfkd: "\u{005C}",
    },
    NormalizationTest {
        source: "\u{FE69}",
        nfc: "\u{FE69}",
        nfd: "\u{FE69}",
        nfkc: "\u{0024}",
        nfkd: "\u{0024}",
    },
    NormalizationTest {
        source: "\u{FE6A}",
        nfc: "\u{FE6A}",
        nfd: "\u{FE6A}",
        nfkc: "\u{0025}",
        nfkd: "\u{0025}",
    },
    NormalizationTest {
        source: "\u{FE6B}",
        nfc: "\u{FE6B}",
        nfd: "\u{FE6B}",
        nfkc: "\u{0040}",
        nfkd: "\u{0040}",
    },
    NormalizationTest {
        source: "\u{FE70}",
        nfc: "\u{FE70}",
        nfd: "\u{FE70}",
        nfkc: "\u{0020}\u{064B}",
        nfkd: "\u{0020}\u{064B}",
    },
    NormalizationTest {
        source: "\u{FE71}",
        nfc: "\u{FE71}",
        nfd: "\u{FE71}",
        nfkc: "\u{0640}\u{064B}",
        nfkd: "\u{0640}\u{064B}",
    },
    NormalizationTest {
        source: "\u{FE72}",
        nfc: "\u{FE72}",
        nfd: "\u{FE72}",
        nfkc: "\u{0020}\u{064C}",
        nfkd: "\u{0020}\u{064C}",
    },
    NormalizationTest {
        source: "\u{FE74}",
        nfc: "\u{FE74}",
        nfd: "\u{FE74}",
        nfkc: "\u{0020}\u{064D}",
        nfkd: "\u{0020}\u{064D}",
    },
    NormalizationTest {
        source: "\u{FE76}",
        nfc: "\u{FE76}",
        nfd: "\u{FE76}",
        nfkc: "\u{0020}\u{064E}",
        nfkd: "\u{0020}\u{064E}",
    },
    NormalizationTest {
        source: "\u{FE77}",
        nfc: "\u{FE77}",
        nfd: "\u{FE77}",
        nfkc: "\u{0640}\u{064E}",
        nfkd: "\u{0640}\u{064E}",
    },
    NormalizationTest {
        source: "\u{FE78}",
        nfc: "\u{FE78}",
        nfd: "\u{FE78}",
        nfkc: "\u{0020}\u{064F}",
        nfkd: "\u{0020}\u{064F}",
    },
    NormalizationTest {
        source: "\u{FE79}",
        nfc: "\u{FE79}",
        nfd: "\u{FE79}",
        nfkc: "\u{0640}\u{064F}",
        nfkd: "\u{0640}\u{064F}",
    },
    NormalizationTest {
        source: "\u{FE7A}",
        nfc: "\u{FE7A}",
        nfd: "\u{FE7A}",
        nfkc: "\u{0020}\u{0650}",
        nfkd: "\u{0020}\u{0650}",
    },
    NormalizationTest {
        source: "\u{FE7B}",
        nfc: "\u{FE7B}",
        nfd: "\u{FE7B}",
        nfkc: "\u{0640}\u{0650}",
        nfkd: "\u{0640}\u{0650}",
    },
    NormalizationTest {
        source: "\u{FE7C}",
        nfc: "\u{FE7C}",
        nfd: "\u{FE7C}",
        nfkc: "\u{0020}\u{0651}",
        nfkd: "\u{0020}\u{0651}",
    },
    NormalizationTest {
        source: "\u{FE7D}",
        nfc: "\u{FE7D}",
        nfd: "\u{FE7D}",
        nfkc: "\u{0640}\u{0651}",
        nfkd: "\u{0640}\u{0651}",
    },
    NormalizationTest {
        source: "\u{FE7E}",
        nfc: "\u{FE7E}",
        nfd: "\u{FE7E}",
        nfkc: "\u{0020}\u{0652}",
        nfkd: "\u{0020}\u{0652}",
    },
    NormalizationTest {
        source: "\u{FE7F}",
        nfc: "\u{FE7F}",
        nfd: "\u{FE7F}",
        nfkc: "\u{0640}\u{0652}",
        nfkd: "\u{0640}\u{0652}",
    },
    NormalizationTest {
        source: "\u{FE80}",
        nfc: "\u{FE80}",
        nfd: "\u{FE80}",
        nfkc: "\u{0621}",
        nfkd: "\u{0621}",
    },
    NormalizationTest {
        source: "\u{FE81}",
        nfc: "\u{FE81}",
        nfd: "\u{FE81}",
        nfkc: "\u{0622}",
        nfkd: "\u{0627}\u{0653}",
    },
    NormalizationTest {
        source: "\u{FE82}",
        nfc: "\u{FE82}",
        nfd: "\u{FE82}",
        nfkc: "\u{0622}",
        nfkd: "\u{0627}\u{0653}",
    },
    NormalizationTest {
        source: "\u{FE83}",
        nfc: "\u{FE83}",
        nfd: "\u{FE83}",
        nfkc: "\u{0623}",
        nfkd: "\u{0627}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FE84}",
        nfc: "\u{FE84}",
        nfd: "\u{FE84}",
        nfkc: "\u{0623}",
        nfkd: "\u{0627}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FE85}",
        nfc: "\u{FE85}",
        nfd: "\u{FE85}",
        nfkc: "\u{0624}",
        nfkd: "\u{0648}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FE86}",
        nfc: "\u{FE86}",
        nfd: "\u{FE86}",
        nfkc: "\u{0624}",
        nfkd: "\u{0648}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FE87}",
        nfc: "\u{FE87}",
        nfd: "\u{FE87}",
        nfkc: "\u{0625}",
        nfkd: "\u{0627}\u{0655}",
    },
    NormalizationTest {
        source: "\u{FE88}",
        nfc: "\u{FE88}",
        nfd: "\u{FE88}",
        nfkc: "\u{0625}",
        nfkd: "\u{0627}\u{0655}",
    },
    NormalizationTest {
        source: "\u{FE89}",
        nfc: "\u{FE89}",
        nfd: "\u{FE89}",
        nfkc: "\u{0626}",
        nfkd: "\u{064A}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FE8A}",
        nfc: "\u{FE8A}",
        nfd: "\u{FE8A}",
        nfkc: "\u{0626}",
        nfkd: "\u{064A}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FE8B}",
        nfc: "\u{FE8B}",
        nfd: "\u{FE8B}",
        nfkc: "\u{0626}",
        nfkd: "\u{064A}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FE8C}",
        nfc: "\u{FE8C}",
        nfd: "\u{FE8C}",
        nfkc: "\u{0626}",
        nfkd: "\u{064A}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FE8D}",
        nfc: "\u{FE8D}",
        nfd: "\u{FE8D}",
        nfkc: "\u{0627}",
        nfkd: "\u{0627}",
    },
    NormalizationTest {
        source: "\u{FE8E}",
        nfc: "\u{FE8E}",
        nfd: "\u{FE8E}",
        nfkc: "\u{0627}",
        nfkd: "\u{0627}",
    },
    NormalizationTest {
        source: "\u{FE8F}",
        nfc: "\u{FE8F}",
        nfd: "\u{FE8F}",
        nfkc: "\u{0628}",
        nfkd: "\u{0628}",
    },
    NormalizationTest {
        source: "\u{FE90}",
        nfc: "\u{FE90}",
        nfd: "\u{FE90}",
        nfkc: "\u{0628}",
        nfkd: "\u{0628}",
    },
    NormalizationTest {
        source: "\u{FE91}",
        nfc: "\u{FE91}",
        nfd: "\u{FE91}",
        nfkc: "\u{0628}",
        nfkd: "\u{0628}",
    },
    NormalizationTest {
        source: "\u{FE92}",
        nfc: "\u{FE92}",
        nfd: "\u{FE92}",
        nfkc: "\u{0628}",
        nfkd: "\u{0628}",
    },
    NormalizationTest {
        source: "\u{FE93}",
        nfc: "\u{FE93}",
        nfd: "\u{FE93}",
        nfkc: "\u{0629}",
        nfkd: "\u{0629}",
    },
    NormalizationTest {
        source: "\u{FE94}",
        nfc: "\u{FE94}",
        nfd: "\u{FE94}",
        nfkc: "\u{0629}",
        nfkd: "\u{0629}",
    },
    NormalizationTest {
        source: "\u{FE95}",
        nfc: "\u{FE95}",
        nfd: "\u{FE95}",
        nfkc: "\u{062A}",
        nfkd: "\u{062A}",
    },
    NormalizationTest {
        source: "\u{FE96}",
        nfc: "\u{FE96}",
        nfd: "\u{FE96}",
        nfkc: "\u{062A}",
        nfkd: "\u{062A}",
    },
    NormalizationTest {
        source: "\u{FE97}",
        nfc: "\u{FE97}",
        nfd: "\u{FE97}",
        nfkc: "\u{062A}",
        nfkd: "\u{062A}",
    },
    NormalizationTest {
        source: "\u{FE98}",
        nfc: "\u{FE98}",
        nfd: "\u{FE98}",
        nfkc: "\u{062A}",
        nfkd: "\u{062A}",
    },
    NormalizationTest {
        source: "\u{FE99}",
        nfc: "\u{FE99}",
        nfd: "\u{FE99}",
        nfkc: "\u{062B}",
        nfkd: "\u{062B}",
    },
    NormalizationTest {
        source: "\u{FE9A}",
        nfc: "\u{FE9A}",
        nfd: "\u{FE9A}",
        nfkc: "\u{062B}",
        nfkd: "\u{062B}",
    },
    NormalizationTest {
        source: "\u{FE9B}",
        nfc: "\u{FE9B}",
        nfd: "\u{FE9B}",
        nfkc: "\u{062B}",
        nfkd: "\u{062B}",
    },
    NormalizationTest {
        source: "\u{FE9C}",
        nfc: "\u{FE9C}",
        nfd: "\u{FE9C}",
        nfkc: "\u{062B}",
        nfkd: "\u{062B}",
    },
    NormalizationTest {
        source: "\u{FE9D}",
        nfc: "\u{FE9D}",
        nfd: "\u{FE9D}",
        nfkc: "\u{062C}",
        nfkd: "\u{062C}",
    },
    NormalizationTest {
        source: "\u{FE9E}",
        nfc: "\u{FE9E}",
        nfd: "\u{FE9E}",
        nfkc: "\u{062C}",
        nfkd: "\u{062C}",
    },
    NormalizationTest {
        source: "\u{FE9F}",
        nfc: "\u{FE9F}",
        nfd: "\u{FE9F}",
        nfkc: "\u{062C}",
        nfkd: "\u{062C}",
    },
    NormalizationTest {
        source: "\u{FEA0}",
        nfc: "\u{FEA0}",
        nfd: "\u{FEA0}",
        nfkc: "\u{062C}",
        nfkd: "\u{062C}",
    },
    NormalizationTest {
        source: "\u{FEA1}",
        nfc: "\u{FEA1}",
        nfd: "\u{FEA1}",
        nfkc: "\u{062D}",
        nfkd: "\u{062D}",
    },
    NormalizationTest {
        source: "\u{FEA2}",
        nfc: "\u{FEA2}",
        nfd: "\u{FEA2}",
        nfkc: "\u{062D}",
        nfkd: "\u{062D}",
    },
    NormalizationTest {
        source: "\u{FEA3}",
        nfc: "\u{FEA3}",
        nfd: "\u{FEA3}",
        nfkc: "\u{062D}",
        nfkd: "\u{062D}",
    },
    NormalizationTest {
        source: "\u{FEA4}",
        nfc: "\u{FEA4}",
        nfd: "\u{FEA4}",
        nfkc: "\u{062D}",
        nfkd: "\u{062D}",
    },
    NormalizationTest {
        source: "\u{FEA5}",
        nfc: "\u{FEA5}",
        nfd: "\u{FEA5}",
        nfkc: "\u{062E}",
        nfkd: "\u{062E}",
    },
    NormalizationTest {
        source: "\u{FEA6}",
        nfc: "\u{FEA6}",
        nfd: "\u{FEA6}",
        nfkc: "\u{062E}",
        nfkd: "\u{062E}",
    },
    NormalizationTest {
        source: "\u{FEA7}",
        nfc: "\u{FEA7}",
        nfd: "\u{FEA7}",
        nfkc: "\u{062E}",
        nfkd: "\u{062E}",
    },
    NormalizationTest {
        source: "\u{FEA8}",
        nfc: "\u{FEA8}",
        nfd: "\u{FEA8}",
        nfkc: "\u{062E}",
        nfkd: "\u{062E}",
    },
    NormalizationTest {
        source: "\u{FEA9}",
        nfc: "\u{FEA9}",
        nfd: "\u{FEA9}",
        nfkc: "\u{062F}",
        nfkd: "\u{062F}",
    },
    NormalizationTest {
        source: "\u{FEAA}",
        nfc: "\u{FEAA}",
        nfd: "\u{FEAA}",
        nfkc: "\u{062F}",
        nfkd: "\u{062F}",
    },
    NormalizationTest {
        source: "\u{FEAB}",
        nfc: "\u{FEAB}",
        nfd: "\u{FEAB}",
        nfkc: "\u{0630}",
        nfkd: "\u{0630}",
    },
    NormalizationTest {
        source: "\u{FEAC}",
        nfc: "\u{FEAC}",
        nfd: "\u{FEAC}",
        nfkc: "\u{0630}",
        nfkd: "\u{0630}",
    },
    NormalizationTest {
        source: "\u{FEAD}",
        nfc: "\u{FEAD}",
        nfd: "\u{FEAD}",
        nfkc: "\u{0631}",
        nfkd: "\u{0631}",
    },
    NormalizationTest {
        source: "\u{FEAE}",
        nfc: "\u{FEAE}",
        nfd: "\u{FEAE}",
        nfkc: "\u{0631}",
        nfkd: "\u{0631}",
    },
    NormalizationTest {
        source: "\u{FEAF}",
        nfc: "\u{FEAF}",
        nfd: "\u{FEAF}",
        nfkc: "\u{0632}",
        nfkd: "\u{0632}",
    },
    NormalizationTest {
        source: "\u{FEB0}",
        nfc: "\u{FEB0}",
        nfd: "\u{FEB0}",
        nfkc: "\u{0632}",
        nfkd: "\u{0632}",
    },
    NormalizationTest {
        source: "\u{FEB1}",
        nfc: "\u{FEB1}",
        nfd: "\u{FEB1}",
        nfkc: "\u{0633}",
        nfkd: "\u{0633}",
    },
    NormalizationTest {
        source: "\u{FEB2}",
        nfc: "\u{FEB2}",
        nfd: "\u{FEB2}",
        nfkc: "\u{0633}",
        nfkd: "\u{0633}",
    },
    NormalizationTest {
        source: "\u{FEB3}",
        nfc: "\u{FEB3}",
        nfd: "\u{FEB3}",
        nfkc: "\u{0633}",
        nfkd: "\u{0633}",
    },
    NormalizationTest {
        source: "\u{FEB4}",
        nfc: "\u{FEB4}",
        nfd: "\u{FEB4}",
        nfkc: "\u{0633}",
        nfkd: "\u{0633}",
    },
    NormalizationTest {
        source: "\u{FEB5}",
        nfc: "\u{FEB5}",
        nfd: "\u{FEB5}",
        nfkc: "\u{0634}",
        nfkd: "\u{0634}",
    },
    NormalizationTest {
        source: "\u{FEB6}",
        nfc: "\u{FEB6}",
        nfd: "\u{FEB6}",
        nfkc: "\u{0634}",
        nfkd: "\u{0634}",
    },
    NormalizationTest {
        source: "\u{FEB7}",
        nfc: "\u{FEB7}",
        nfd: "\u{FEB7}",
        nfkc: "\u{0634}",
        nfkd: "\u{0634}",
    },
    NormalizationTest {
        source: "\u{FEB8}",
        nfc: "\u{FEB8}",
        nfd: "\u{FEB8}",
        nfkc: "\u{0634}",
        nfkd: "\u{0634}",
    },
    NormalizationTest {
        source: "\u{FEB9}",
        nfc: "\u{FEB9}",
        nfd: "\u{FEB9}",
        nfkc: "\u{0635}",
        nfkd: "\u{0635}",
    },
    NormalizationTest {
        source: "\u{FEBA}",
        nfc: "\u{FEBA}",
        nfd: "\u{FEBA}",
        nfkc: "\u{0635}",
        nfkd: "\u{0635}",
    },
    NormalizationTest {
        source: "\u{FEBB}",
        nfc: "\u{FEBB}",
        nfd: "\u{FEBB}",
        nfkc: "\u{0635}",
        nfkd: "\u{0635}",
    },
    NormalizationTest {
        source: "\u{FEBC}",
        nfc: "\u{FEBC}",
        nfd: "\u{FEBC}",
        nfkc: "\u{0635}",
        nfkd: "\u{0635}",
    },
    NormalizationTest {
        source: "\u{FEBD}",
        nfc: "\u{FEBD}",
        nfd: "\u{FEBD}",
        nfkc: "\u{0636}",
        nfkd: "\u{0636}",
    },
    NormalizationTest {
        source: "\u{FEBE}",
        nfc: "\u{FEBE}",
        nfd: "\u{FEBE}",
        nfkc: "\u{0636}",
        nfkd: "\u{0636}",
    },
    NormalizationTest {
        source: "\u{FEBF}",
        nfc: "\u{FEBF}",
        nfd: "\u{FEBF}",
        nfkc: "\u{0636}",
        nfkd: "\u{0636}",
    },
    NormalizationTest {
        source: "\u{FEC0}",
        nfc: "\u{FEC0}",
        nfd: "\u{FEC0}",
        nfkc: "\u{0636}",
        nfkd: "\u{0636}",
    },
    NormalizationTest {
        source: "\u{FEC1}",
        nfc: "\u{FEC1}",
        nfd: "\u{FEC1}",
        nfkc: "\u{0637}",
        nfkd: "\u{0637}",
    },
    NormalizationTest {
        source: "\u{FEC2}",
        nfc: "\u{FEC2}",
        nfd: "\u{FEC2}",
        nfkc: "\u{0637}",
        nfkd: "\u{0637}",
    },
    NormalizationTest {
        source: "\u{FEC3}",
        nfc: "\u{FEC3}",
        nfd: "\u{FEC3}",
        nfkc: "\u{0637}",
        nfkd: "\u{0637}",
    },
    NormalizationTest {
        source: "\u{FEC4}",
        nfc: "\u{FEC4}",
        nfd: "\u{FEC4}",
        nfkc: "\u{0637}",
        nfkd: "\u{0637}",
    },
    NormalizationTest {
        source: "\u{FEC5}",
        nfc: "\u{FEC5}",
        nfd: "\u{FEC5}",
        nfkc: "\u{0638}",
        nfkd: "\u{0638}",
    },
    NormalizationTest {
        source: "\u{FEC6}",
        nfc: "\u{FEC6}",
        nfd: "\u{FEC6}",
        nfkc: "\u{0638}",
        nfkd: "\u{0638}",
    },
    NormalizationTest {
        source: "\u{FEC7}",
        nfc: "\u{FEC7}",
        nfd: "\u{FEC7}",
        nfkc: "\u{0638}",
        nfkd: "\u{0638}",
    },
    NormalizationTest {
        source: "\u{FEC8}",
        nfc: "\u{FEC8}",
        nfd: "\u{FEC8}",
        nfkc: "\u{0638}",
        nfkd: "\u{0638}",
    },
    NormalizationTest {
        source: "\u{FEC9}",
        nfc: "\u{FEC9}",
        nfd: "\u{FEC9}",
        nfkc: "\u{0639}",
        nfkd: "\u{0639}",
    },
    NormalizationTest {
        source: "\u{FECA}",
        nfc: "\u{FECA}",
        nfd: "\u{FECA}",
        nfkc: "\u{0639}",
        nfkd: "\u{0639}",
    },
    NormalizationTest {
        source: "\u{FECB}",
        nfc: "\u{FECB}",
        nfd: "\u{FECB}",
        nfkc: "\u{0639}",
        nfkd: "\u{0639}",
    },
    NormalizationTest {
        source: "\u{FECC}",
        nfc: "\u{FECC}",
        nfd: "\u{FECC}",
        nfkc: "\u{0639}",
        nfkd: "\u{0639}",
    },
    NormalizationTest {
        source: "\u{FECD}",
        nfc: "\u{FECD}",
        nfd: "\u{FECD}",
        nfkc: "\u{063A}",
        nfkd: "\u{063A}",
    },
    NormalizationTest {
        source: "\u{FECE}",
        nfc: "\u{FECE}",
        nfd: "\u{FECE}",
        nfkc: "\u{063A}",
        nfkd: "\u{063A}",
    },
    NormalizationTest {
        source: "\u{FECF}",
        nfc: "\u{FECF}",
        nfd: "\u{FECF}",
        nfkc: "\u{063A}",
        nfkd: "\u{063A}",
    },
    NormalizationTest {
        source: "\u{FED0}",
        nfc: "\u{FED0}",
        nfd: "\u{FED0}",
        nfkc: "\u{063A}",
        nfkd: "\u{063A}",
    },
    NormalizationTest {
        source: "\u{FED1}",
        nfc: "\u{FED1}",
        nfd: "\u{FED1}",
        nfkc: "\u{0641}",
        nfkd: "\u{0641}",
    },
    NormalizationTest {
        source: "\u{FED2}",
        nfc: "\u{FED2}",
        nfd: "\u{FED2}",
        nfkc: "\u{0641}",
        nfkd: "\u{0641}",
    },
    NormalizationTest {
        source: "\u{FED3}",
        nfc: "\u{FED3}",
        nfd: "\u{FED3}",
        nfkc: "\u{0641}",
        nfkd: "\u{0641}",
    },
    NormalizationTest {
        source: "\u{FED4}",
        nfc: "\u{FED4}",
        nfd: "\u{FED4}",
        nfkc: "\u{0641}",
        nfkd: "\u{0641}",
    },
    NormalizationTest {
        source: "\u{FED5}",
        nfc: "\u{FED5}",
        nfd: "\u{FED5}",
        nfkc: "\u{0642}",
        nfkd: "\u{0642}",
    },
    NormalizationTest {
        source: "\u{FED6}",
        nfc: "\u{FED6}",
        nfd: "\u{FED6}",
        nfkc: "\u{0642}",
        nfkd: "\u{0642}",
    },
    NormalizationTest {
        source: "\u{FED7}",
        nfc: "\u{FED7}",
        nfd: "\u{FED7}",
        nfkc: "\u{0642}",
        nfkd: "\u{0642}",
    },
    NormalizationTest {
        source: "\u{FED8}",
        nfc: "\u{FED8}",
        nfd: "\u{FED8}",
        nfkc: "\u{0642}",
        nfkd: "\u{0642}",
    },
    NormalizationTest {
        source: "\u{FED9}",
        nfc: "\u{FED9}",
        nfd: "\u{FED9}",
        nfkc: "\u{0643}",
        nfkd: "\u{0643}",
    },
    NormalizationTest {
        source: "\u{FEDA}",
        nfc: "\u{FEDA}",
        nfd: "\u{FEDA}",
        nfkc: "\u{0643}",
        nfkd: "\u{0643}",
    },
    NormalizationTest {
        source: "\u{FEDB}",
        nfc: "\u{FEDB}",
        nfd: "\u{FEDB}",
        nfkc: "\u{0643}",
        nfkd: "\u{0643}",
    },
    NormalizationTest {
        source: "\u{FEDC}",
        nfc: "\u{FEDC}",
        nfd: "\u{FEDC}",
        nfkc: "\u{0643}",
        nfkd: "\u{0643}",
    },
    NormalizationTest {
        source: "\u{FEDD}",
        nfc: "\u{FEDD}",
        nfd: "\u{FEDD}",
        nfkc: "\u{0644}",
        nfkd: "\u{0644}",
    },
    NormalizationTest {
        source: "\u{FEDE}",
        nfc: "\u{FEDE}",
        nfd: "\u{FEDE}",
        nfkc: "\u{0644}",
        nfkd: "\u{0644}",
    },
    NormalizationTest {
        source: "\u{FEDF}",
        nfc: "\u{FEDF}",
        nfd: "\u{FEDF}",
        nfkc: "\u{0644}",
        nfkd: "\u{0644}",
    },
    NormalizationTest {
        source: "\u{FEE0}",
        nfc: "\u{FEE0}",
        nfd: "\u{FEE0}",
        nfkc: "\u{0644}",
        nfkd: "\u{0644}",
    },
    NormalizationTest {
        source: "\u{FEE1}",
        nfc: "\u{FEE1}",
        nfd: "\u{FEE1}",
        nfkc: "\u{0645}",
        nfkd: "\u{0645}",
    },
    NormalizationTest {
        source: "\u{FEE2}",
        nfc: "\u{FEE2}",
        nfd: "\u{FEE2}",
        nfkc: "\u{0645}",
        nfkd: "\u{0645}",
    },
    NormalizationTest {
        source: "\u{FEE3}",
        nfc: "\u{FEE3}",
        nfd: "\u{FEE3}",
        nfkc: "\u{0645}",
        nfkd: "\u{0645}",
    },
    NormalizationTest {
        source: "\u{FEE4}",
        nfc: "\u{FEE4}",
        nfd: "\u{FEE4}",
        nfkc: "\u{0645}",
        nfkd: "\u{0645}",
    },
    NormalizationTest {
        source: "\u{FEE5}",
        nfc: "\u{FEE5}",
        nfd: "\u{FEE5}",
        nfkc: "\u{0646}",
        nfkd: "\u{0646}",
    },
    NormalizationTest {
        source: "\u{FEE6}",
        nfc: "\u{FEE6}",
        nfd: "\u{FEE6}",
        nfkc: "\u{0646}",
        nfkd: "\u{0646}",
    },
    NormalizationTest {
        source: "\u{FEE7}",
        nfc: "\u{FEE7}",
        nfd: "\u{FEE7}",
        nfkc: "\u{0646}",
        nfkd: "\u{0646}",
    },
    NormalizationTest {
        source: "\u{FEE8}",
        nfc: "\u{FEE8}",
        nfd: "\u{FEE8}",
        nfkc: "\u{0646}",
        nfkd: "\u{0646}",
    },
    NormalizationTest {
        source: "\u{FEE9}",
        nfc: "\u{FEE9}",
        nfd: "\u{FEE9}",
        nfkc: "\u{0647}",
        nfkd: "\u{0647}",
    },
    NormalizationTest {
        source: "\u{FEEA}",
        nfc: "\u{FEEA}",
        nfd: "\u{FEEA}",
        nfkc: "\u{0647}",
        nfkd: "\u{0647}",
    },
    NormalizationTest {
        source: "\u{FEEB}",
        nfc: "\u{FEEB}",
        nfd: "\u{FEEB}",
        nfkc: "\u{0647}",
        nfkd: "\u{0647}",
    },
    NormalizationTest {
        source: "\u{FEEC}",
        nfc: "\u{FEEC}",
        nfd: "\u{FEEC}",
        nfkc: "\u{0647}",
        nfkd: "\u{0647}",
    },
    NormalizationTest {
        source: "\u{FEED}",
        nfc: "\u{FEED}",
        nfd: "\u{FEED}",
        nfkc: "\u{0648}",
        nfkd: "\u{0648}",
    },
    NormalizationTest {
        source: "\u{FEEE}",
        nfc: "\u{FEEE}",
        nfd: "\u{FEEE}",
        nfkc: "\u{0648}",
        nfkd: "\u{0648}",
    },
    NormalizationTest {
        source: "\u{FEEF}",
        nfc: "\u{FEEF}",
        nfd: "\u{FEEF}",
        nfkc: "\u{0649}",
        nfkd: "\u{0649}",
    },
    NormalizationTest {
        source: "\u{FEF0}",
        nfc: "\u{FEF0}",
        nfd: "\u{FEF0}",
        nfkc: "\u{0649}",
        nfkd: "\u{0649}",
    },
    NormalizationTest {
        source: "\u{FEF1}",
        nfc: "\u{FEF1}",
        nfd: "\u{FEF1}",
        nfkc: "\u{064A}",
        nfkd: "\u{064A}",
    },
    NormalizationTest {
        source: "\u{FEF2}",
        nfc: "\u{FEF2}",
        nfd: "\u{FEF2}",
        nfkc: "\u{064A}",
        nfkd: "\u{064A}",
    },
    NormalizationTest {
        source: "\u{FEF3}",
        nfc: "\u{FEF3}",
        nfd: "\u{FEF3}",
        nfkc: "\u{064A}",
        nfkd: "\u{064A}",
    },
    NormalizationTest {
        source: "\u{FEF4}",
        nfc: "\u{FEF4}",
        nfd: "\u{FEF4}",
        nfkc: "\u{064A}",
        nfkd: "\u{064A}",
    },
    NormalizationTest {
        source: "\u{FEF5}",
        nfc: "\u{FEF5}",
        nfd: "\u{FEF5}",
        nfkc: "\u{0644}\u{0622}",
        nfkd: "\u{0644}\u{0627}\u{0653}",
    },
    NormalizationTest {
        source: "\u{FEF6}",
        nfc: "\u{FEF6}",
        nfd: "\u{FEF6}",
        nfkc: "\u{0644}\u{0622}",
        nfkd: "\u{0644}\u{0627}\u{0653}",
    },
    NormalizationTest {
        source: "\u{FEF7}",
        nfc: "\u{FEF7}",
        nfd: "\u{FEF7}",
        nfkc: "\u{0644}\u{0623}",
        nfkd: "\u{0644}\u{0627}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FEF8}",
        nfc: "\u{FEF8}",
        nfd: "\u{FEF8}",
        nfkc: "\u{0644}\u{0623}",
        nfkd: "\u{0644}\u{0627}\u{0654}",
    },
    NormalizationTest {
        source: "\u{FEF9}",
        nfc: "\u{FEF9}",
        nfd: "\u{FEF9}",
        nfkc: "\u{0644}\u{0625}",
        nfkd: "\u{0644}\u{0627}\u{0655}",
    },
    NormalizationTest {
        source: "\u{FEFA}",
        nfc: "\u{FEFA}",
        nfd: "\u{FEFA}",
        nfkc: "\u{0644}\u{0625}",
        nfkd: "\u{0644}\u{0627}\u{0655}",
    },
    NormalizationTest {
        source: "\u{FEFB}",
        nfc: "\u{FEFB}",
        nfd: "\u{FEFB}",
        nfkc: "\u{0644}\u{0627}",
        nfkd: "\u{0644}\u{0627}",
    },
    NormalizationTest {
        source: "\u{FEFC}",
        nfc: "\u{FEFC}",
        nfd: "\u{FEFC}",
        nfkc: "\u{0644}\u{0627}",
        nfkd: "\u{0644}\u{0627}",
    },
    NormalizationTest {
        source: "\u{FF01}",
        nfc: "\u{FF01}",
        nfd: "\u{FF01}",
        nfkc: "\u{0021}",
        nfkd: "\u{0021}",
    },
    NormalizationTest {
        source: "\u{FF02}",
        nfc: "\u{FF02}",
        nfd: "\u{FF02}",
        nfkc: "\u{0022}",
        nfkd: "\u{0022}",
    },
    NormalizationTest {
        source: "\u{FF03}",
        nfc: "\u{FF03}",
        nfd: "\u{FF03}",
        nfkc: "\u{0023}",
        nfkd: "\u{0023}",
    },
    NormalizationTest {
        source: "\u{FF04}",
        nfc: "\u{FF04}",
        nfd: "\u{FF04}",
        nfkc: "\u{0024}",
        nfkd: "\u{0024}",
    },
    NormalizationTest {
        source: "\u{FF05}",
        nfc: "\u{FF05}",
        nfd: "\u{FF05}",
        nfkc: "\u{0025}",
        nfkd: "\u{0025}",
    },
    NormalizationTest {
        source: "\u{FF06}",
        nfc: "\u{FF06}",
        nfd: "\u{FF06}",
        nfkc: "\u{0026}",
        nfkd: "\u{0026}",
    },
    NormalizationTest {
        source: "\u{FF07}",
        nfc: "\u{FF07}",
        nfd: "\u{FF07}",
        nfkc: "\u{0027}",
        nfkd: "\u{0027}",
    },
    NormalizationTest {
        source: "\u{FF08}",
        nfc: "\u{FF08}",
        nfd: "\u{FF08}",
        nfkc: "\u{0028}",
        nfkd: "\u{0028}",
    },
    NormalizationTest {
        source: "\u{FF09}",
        nfc: "\u{FF09}",
        nfd: "\u{FF09}",
        nfkc: "\u{0029}",
        nfkd: "\u{0029}",
    },
    NormalizationTest {
        source: "\u{FF0A}",
        nfc: "\u{FF0A}",
        nfd: "\u{FF0A}",
        nfkc: "\u{002A}",
        nfkd: "\u{002A}",
    },
    NormalizationTest {
        source: "\u{FF0B}",
        nfc: "\u{FF0B}",
        nfd: "\u{FF0B}",
        nfkc: "\u{002B}",
        nfkd: "\u{002B}",
    },
    NormalizationTest {
        source: "\u{FF0C}",
        nfc: "\u{FF0C}",
        nfd: "\u{FF0C}",
        nfkc: "\u{002C}",
        nfkd: "\u{002C}",
    },
    NormalizationTest {
        source: "\u{FF0D}",
        nfc: "\u{FF0D}",
        nfd: "\u{FF0D}",
        nfkc: "\u{002D}",
        nfkd: "\u{002D}",
    },
    NormalizationTest {
        source: "\u{FF0E}",
        nfc: "\u{FF0E}",
        nfd: "\u{FF0E}",
        nfkc: "\u{002E}",
        nfkd: "\u{002E}",
    },
    NormalizationTest {
        source: "\u{FF0F}",
        nfc: "\u{FF0F}",
        nfd: "\u{FF0F}",
        nfkc: "\u{002F}",
        nfkd: "\u{002F}",
    },
    NormalizationTest {
        source: "\u{FF10}",
        nfc: "\u{FF10}",
        nfd: "\u{FF10}",
        nfkc: "\u{0030}",
        nfkd: "\u{0030}",
    },
    NormalizationTest {
        source: "\u{FF11}",
        nfc: "\u{FF11}",
        nfd: "\u{FF11}",
        nfkc: "\u{0031}",
        nfkd: "\u{0031}",
    },
    NormalizationTest {
        source: "\u{FF12}",
        nfc: "\u{FF12}",
        nfd: "\u{FF12}",
        nfkc: "\u{0032}",
        nfkd: "\u{0032}",
    },
    NormalizationTest {
        source: "\u{FF13}",
        nfc: "\u{FF13}",
        nfd: "\u{FF13}",
        nfkc: "\u{0033}",
        nfkd: "\u{0033}",
    },
    NormalizationTest {
        source: "\u{FF14}",
        nfc: "\u{FF14}",
        nfd: "\u{FF14}",
        nfkc: "\u{0034}",
        nfkd: "\u{0034}",
    },
    NormalizationTest {
        source: "\u{FF15}",
        nfc: "\u{FF15}",
        nfd: "\u{FF15}",
        nfkc: "\u{0035}",
        nfkd: "\u{0035}",
    },
    NormalizationTest {
        source: "\u{FF16}",
        nfc: "\u{FF16}",
        nfd: "\u{FF16}",
        nfkc: "\u{0036}",
        nfkd: "\u{0036}",
    },
    NormalizationTest {
        source: "\u{FF17}",
        nfc: "\u{FF17}",
        nfd: "\u{FF17}",
        nfkc: "\u{0037}",
        nfkd: "\u{0037}",
    },
    NormalizationTest {
        source: "\u{FF18}",
        nfc: "\u{FF18}",
        nfd: "\u{FF18}",
        nfkc: "\u{0038}",
        nfkd: "\u{0038}",
    },
    NormalizationTest {
        source: "\u{FF19}",
        nfc: "\u{FF19}",
        nfd: "\u{FF19}",
        nfkc: "\u{0039}",
        nfkd: "\u{0039}",
    },
    NormalizationTest {
        source: "\u{FF1A}",
        nfc: "\u{FF1A}",
        nfd: "\u{FF1A}",
        nfkc: "\u{003A}",
        nfkd: "\u{003A}",
    },
    NormalizationTest {
        source: "\u{FF1B}",
        nfc: "\u{FF1B}",
        nfd: "\u{FF1B}",
        nfkc: "\u{003B}",
        nfkd: "\u{003B}",
    },
    NormalizationTest {
        source: "\u{FF1C}",
        nfc: "\u{FF1C}",
        nfd: "\u{FF1C}",
        nfkc: "\u{003C}",
        nfkd: "\u{003C}",
    },
    NormalizationTest {
        source: "\u{FF1D}",
        nfc: "\u{FF1D}",
        nfd: "\u{FF1D}",
        nfkc: "\u{003D}",
        nfkd: "\u{003D}",
    },
    NormalizationTest {
        source: "\u{FF1E}",
        nfc: "\u{FF1E}",
        nfd: "\u{FF1E}",
        nfkc: "\u{003E}",
        nfkd: "\u{003E}",
    },
    NormalizationTest {
        source: "\u{FF1F}",
        nfc: "\u{FF1F}",
        nfd: "\u{FF1F}",
        nfkc: "\u{003F}",
        nfkd: "\u{003F}",
    },
    NormalizationTest {
        source: "\u{FF20}",
        nfc: "\u{FF20}",
        nfd: "\u{FF20}",
        nfkc: "\u{0040}",
        nfkd: "\u{0040}",
    },
    NormalizationTest {
        source: "\u{FF21}",
        nfc: "\u{FF21}",
        nfd: "\u{FF21}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{FF22}",
        nfc: "\u{FF22}",
        nfd: "\u{FF22}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{FF23}",
        nfc: "\u{FF23}",
        nfd: "\u{FF23}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{FF24}",
        nfc: "\u{FF24}",
        nfd: "\u{FF24}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{FF25}",
        nfc: "\u{FF25}",
        nfd: "\u{FF25}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{FF26}",
        nfc: "\u{FF26}",
        nfd: "\u{FF26}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{FF27}",
        nfc: "\u{FF27}",
        nfd: "\u{FF27}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{FF28}",
        nfc: "\u{FF28}",
        nfd: "\u{FF28}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{FF29}",
        nfc: "\u{FF29}",
        nfd: "\u{FF29}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{FF2A}",
        nfc: "\u{FF2A}",
        nfd: "\u{FF2A}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{FF2B}",
        nfc: "\u{FF2B}",
        nfd: "\u{FF2B}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{FF2C}",
        nfc: "\u{FF2C}",
        nfd: "\u{FF2C}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{FF2D}",
        nfc: "\u{FF2D}",
        nfd: "\u{FF2D}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{FF2E}",
        nfc: "\u{FF2E}",
        nfd: "\u{FF2E}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{FF2F}",
        nfc: "\u{FF2F}",
        nfd: "\u{FF2F}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{FF30}",
        nfc: "\u{FF30}",
        nfd: "\u{FF30}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{FF31}",
        nfc: "\u{FF31}",
        nfd: "\u{FF31}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{FF32}",
        nfc: "\u{FF32}",
        nfd: "\u{FF32}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{FF33}",
        nfc: "\u{FF33}",
        nfd: "\u{FF33}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{FF34}",
        nfc: "\u{FF34}",
        nfd: "\u{FF34}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{FF35}",
        nfc: "\u{FF35}",
        nfd: "\u{FF35}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{FF36}",
        nfc: "\u{FF36}",
        nfd: "\u{FF36}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{FF37}",
        nfc: "\u{FF37}",
        nfd: "\u{FF37}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{FF38}",
        nfc: "\u{FF38}",
        nfd: "\u{FF38}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{FF39}",
        nfc: "\u{FF39}",
        nfd: "\u{FF39}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{FF3A}",
        nfc: "\u{FF3A}",
        nfd: "\u{FF3A}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{FF3B}",
        nfc: "\u{FF3B}",
        nfd: "\u{FF3B}",
        nfkc: "\u{005B}",
        nfkd: "\u{005B}",
    },
    NormalizationTest {
        source: "\u{FF3C}",
        nfc: "\u{FF3C}",
        nfd: "\u{FF3C}",
        nfkc: "\u{005C}",
        nfkd: "\u{005C}",
    },
    NormalizationTest {
        source: "\u{FF3D}",
        nfc: "\u{FF3D}",
        nfd: "\u{FF3D}",
        nfkc: "\u{005D}",
        nfkd: "\u{005D}",
    },
    NormalizationTest {
        source: "\u{FF3E}",
        nfc: "\u{FF3E}",
        nfd: "\u{FF3E}",
        nfkc: "\u{005E}",
        nfkd: "\u{005E}",
    },
    NormalizationTest {
        source: "\u{FF3F}",
        nfc: "\u{FF3F}",
        nfd: "\u{FF3F}",
        nfkc: "\u{005F}",
        nfkd: "\u{005F}",
    },
    NormalizationTest {
        source: "\u{FF40}",
        nfc: "\u{FF40}",
        nfd: "\u{FF40}",
        nfkc: "\u{0060}",
        nfkd: "\u{0060}",
    },
    NormalizationTest {
        source: "\u{FF41}",
        nfc: "\u{FF41}",
        nfd: "\u{FF41}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{FF42}",
        nfc: "\u{FF42}",
        nfd: "\u{FF42}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{FF43}",
        nfc: "\u{FF43}",
        nfd: "\u{FF43}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{FF44}",
        nfc: "\u{FF44}",
        nfd: "\u{FF44}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{FF45}",
        nfc: "\u{FF45}",
        nfd: "\u{FF45}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{FF46}",
        nfc: "\u{FF46}",
        nfd: "\u{FF46}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{FF47}",
        nfc: "\u{FF47}",
        nfd: "\u{FF47}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{FF48}",
        nfc: "\u{FF48}",
        nfd: "\u{FF48}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{FF49}",
        nfc: "\u{FF49}",
        nfd: "\u{FF49}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{FF4A}",
        nfc: "\u{FF4A}",
        nfd: "\u{FF4A}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{FF4B}",
        nfc: "\u{FF4B}",
        nfd: "\u{FF4B}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{FF4C}",
        nfc: "\u{FF4C}",
        nfd: "\u{FF4C}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{FF4D}",
        nfc: "\u{FF4D}",
        nfd: "\u{FF4D}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{FF4E}",
        nfc: "\u{FF4E}",
        nfd: "\u{FF4E}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{FF4F}",
        nfc: "\u{FF4F}",
        nfd: "\u{FF4F}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{FF50}",
        nfc: "\u{FF50}",
        nfd: "\u{FF50}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{FF51}",
        nfc: "\u{FF51}",
        nfd: "\u{FF51}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{FF52}",
        nfc: "\u{FF52}",
        nfd: "\u{FF52}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{FF53}",
        nfc: "\u{FF53}",
        nfd: "\u{FF53}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{FF54}",
        nfc: "\u{FF54}",
        nfd: "\u{FF54}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{FF55}",
        nfc: "\u{FF55}",
        nfd: "\u{FF55}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{FF56}",
        nfc: "\u{FF56}",
        nfd: "\u{FF56}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{FF57}",
        nfc: "\u{FF57}",
        nfd: "\u{FF57}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{FF58}",
        nfc: "\u{FF58}",
        nfd: "\u{FF58}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{FF59}",
        nfc: "\u{FF59}",
        nfd: "\u{FF59}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{FF5A}",
        nfc: "\u{FF5A}",
        nfd: "\u{FF5A}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{FF5B}",
        nfc: "\u{FF5B}",
        nfd: "\u{FF5B}",
        nfkc: "\u{007B}",
        nfkd: "\u{007B}",
    },
    NormalizationTest {
        source: "\u{FF5C}",
        nfc: "\u{FF5C}",
        nfd: "\u{FF5C}",
        nfkc: "\u{007C}",
        nfkd: "\u{007C}",
    },
    NormalizationTest {
        source: "\u{FF5D}",
        nfc: "\u{FF5D}",
        nfd: "\u{FF5D}",
        nfkc: "\u{007D}",
        nfkd: "\u{007D}",
    },
    NormalizationTest {
        source: "\u{FF5E}",
        nfc: "\u{FF5E}",
        nfd: "\u{FF5E}",
        nfkc: "\u{007E}",
        nfkd: "\u{007E}",
    },
    NormalizationTest {
        source: "\u{FF5F}",
        nfc: "\u{FF5F}",
        nfd: "\u{FF5F}",
        nfkc: "\u{2985}",
        nfkd: "\u{2985}",
    },
    NormalizationTest {
        source: "\u{FF60}",
        nfc: "\u{FF60}",
        nfd: "\u{FF60}",
        nfkc: "\u{2986}",
        nfkd: "\u{2986}",
    },
    NormalizationTest {
        source: "\u{FF61}",
        nfc: "\u{FF61}",
        nfd: "\u{FF61}",
        nfkc: "\u{3002}",
        nfkd: "\u{3002}",
    },
    NormalizationTest {
        source: "\u{FF62}",
        nfc: "\u{FF62}",
        nfd: "\u{FF62}",
        nfkc: "\u{300C}",
        nfkd: "\u{300C}",
    },
    NormalizationTest {
        source: "\u{FF63}",
        nfc: "\u{FF63}",
        nfd: "\u{FF63}",
        nfkc: "\u{300D}",
        nfkd: "\u{300D}",
    },
    NormalizationTest {
        source: "\u{FF64}",
        nfc: "\u{FF64}",
        nfd: "\u{FF64}",
        nfkc: "\u{3001}",
        nfkd: "\u{3001}",
    },
    NormalizationTest {
        source: "\u{FF65}",
        nfc: "\u{FF65}",
        nfd: "\u{FF65}",
        nfkc: "\u{30FB}",
        nfkd: "\u{30FB}",
    },
    NormalizationTest {
        source: "\u{FF66}",
        nfc: "\u{FF66}",
        nfd: "\u{FF66}",
        nfkc: "\u{30F2}",
        nfkd: "\u{30F2}",
    },
    NormalizationTest {
        source: "\u{FF67}",
        nfc: "\u{FF67}",
        nfd: "\u{FF67}",
        nfkc: "\u{30A1}",
        nfkd: "\u{30A1}",
    },
    NormalizationTest {
        source: "\u{FF68}",
        nfc: "\u{FF68}",
        nfd: "\u{FF68}",
        nfkc: "\u{30A3}",
        nfkd: "\u{30A3}",
    },
    NormalizationTest {
        source: "\u{FF69}",
        nfc: "\u{FF69}",
        nfd: "\u{FF69}",
        nfkc: "\u{30A5}",
        nfkd: "\u{30A5}",
    },
    NormalizationTest {
        source: "\u{FF6A}",
        nfc: "\u{FF6A}",
        nfd: "\u{FF6A}",
        nfkc: "\u{30A7}",
        nfkd: "\u{30A7}",
    },
    NormalizationTest {
        source: "\u{FF6B}",
        nfc: "\u{FF6B}",
        nfd: "\u{FF6B}",
        nfkc: "\u{30A9}",
        nfkd: "\u{30A9}",
    },
    NormalizationTest {
        source: "\u{FF6C}",
        nfc: "\u{FF6C}",
        nfd: "\u{FF6C}",
        nfkc: "\u{30E3}",
        nfkd: "\u{30E3}",
    },
    NormalizationTest {
        source: "\u{FF6D}",
        nfc: "\u{FF6D}",
        nfd: "\u{FF6D}",
        nfkc: "\u{30E5}",
        nfkd: "\u{30E5}",
    },
    NormalizationTest {
        source: "\u{FF6E}",
        nfc: "\u{FF6E}",
        nfd: "\u{FF6E}",
        nfkc: "\u{30E7}",
        nfkd: "\u{30E7}",
    },
    NormalizationTest {
        source: "\u{FF6F}",
        nfc: "\u{FF6F}",
        nfd: "\u{FF6F}",
        nfkc: "\u{30C3}",
        nfkd: "\u{30C3}",
    },
    NormalizationTest {
        source: "\u{FF70}",
        nfc: "\u{FF70}",
        nfd: "\u{FF70}",
        nfkc: "\u{30FC}",
        nfkd: "\u{30FC}",
    },
    NormalizationTest {
        source: "\u{FF71}",
        nfc: "\u{FF71}",
        nfd: "\u{FF71}",
        nfkc: "\u{30A2}",
        nfkd: "\u{30A2}",
    },
    NormalizationTest {
        source: "\u{FF72}",
        nfc: "\u{FF72}",
        nfd: "\u{FF72}",
        nfkc: "\u{30A4}",
        nfkd: "\u{30A4}",
    },
    NormalizationTest {
        source: "\u{FF73}",
        nfc: "\u{FF73}",
        nfd: "\u{FF73}",
        nfkc: "\u{30A6}",
        nfkd: "\u{30A6}",
    },
    NormalizationTest {
        source: "\u{FF74}",
        nfc: "\u{FF74}",
        nfd: "\u{FF74}",
        nfkc: "\u{30A8}",
        nfkd: "\u{30A8}",
    },
    NormalizationTest {
        source: "\u{FF75}",
        nfc: "\u{FF75}",
        nfd: "\u{FF75}",
        nfkc: "\u{30AA}",
        nfkd: "\u{30AA}",
    },
    NormalizationTest {
        source: "\u{FF76}",
        nfc: "\u{FF76}",
        nfd: "\u{FF76}",
        nfkc: "\u{30AB}",
        nfkd: "\u{30AB}",
    },
    NormalizationTest {
        source: "\u{FF77}",
        nfc: "\u{FF77}",
        nfd: "\u{FF77}",
        nfkc: "\u{30AD}",
        nfkd: "\u{30AD}",
    },
    NormalizationTest {
        source: "\u{FF78}",
        nfc: "\u{FF78}",
        nfd: "\u{FF78}",
        nfkc: "\u{30AF}",
        nfkd: "\u{30AF}",
    },
    NormalizationTest {
        source: "\u{FF79}",
        nfc: "\u{FF79}",
        nfd: "\u{FF79}",
        nfkc: "\u{30B1}",
        nfkd: "\u{30B1}",
    },
    NormalizationTest {
        source: "\u{FF7A}",
        nfc: "\u{FF7A}",
        nfd: "\u{FF7A}",
        nfkc: "\u{30B3}",
        nfkd: "\u{30B3}",
    },
    NormalizationTest {
        source: "\u{FF7B}",
        nfc: "\u{FF7B}",
        nfd: "\u{FF7B}",
        nfkc: "\u{30B5}",
        nfkd: "\u{30B5}",
    },
    NormalizationTest {
        source: "\u{FF7C}",
        nfc: "\u{FF7C}",
        nfd: "\u{FF7C}",
        nfkc: "\u{30B7}",
        nfkd: "\u{30B7}",
    },
    NormalizationTest {
        source: "\u{FF7D}",
        nfc: "\u{FF7D}",
        nfd: "\u{FF7D}",
        nfkc: "\u{30B9}",
        nfkd: "\u{30B9}",
    },
    NormalizationTest {
        source: "\u{FF7E}",
        nfc: "\u{FF7E}",
        nfd: "\u{FF7E}",
        nfkc: "\u{30BB}",
        nfkd: "\u{30BB}",
    },
    NormalizationTest {
        source: "\u{FF7F}",
        nfc: "\u{FF7F}",
        nfd: "\u{FF7F}",
        nfkc: "\u{30BD}",
        nfkd: "\u{30BD}",
    },
    NormalizationTest {
        source: "\u{FF80}",
        nfc: "\u{FF80}",
        nfd: "\u{FF80}",
        nfkc: "\u{30BF}",
        nfkd: "\u{30BF}",
    },
    NormalizationTest {
        source: "\u{FF81}",
        nfc: "\u{FF81}",
        nfd: "\u{FF81}",
        nfkc: "\u{30C1}",
        nfkd: "\u{30C1}",
    },
    NormalizationTest {
        source: "\u{FF82}",
        nfc: "\u{FF82}",
        nfd: "\u{FF82}",
        nfkc: "\u{30C4}",
        nfkd: "\u{30C4}",
    },
    NormalizationTest {
        source: "\u{FF83}",
        nfc: "\u{FF83}",
        nfd: "\u{FF83}",
        nfkc: "\u{30C6}",
        nfkd: "\u{30C6}",
    },
    NormalizationTest {
        source: "\u{FF84}",
        nfc: "\u{FF84}",
        nfd: "\u{FF84}",
        nfkc: "\u{30C8}",
        nfkd: "\u{30C8}",
    },
    NormalizationTest {
        source: "\u{FF85}",
        nfc: "\u{FF85}",
        nfd: "\u{FF85}",
        nfkc: "\u{30CA}",
        nfkd: "\u{30CA}",
    },
    NormalizationTest {
        source: "\u{FF86}",
        nfc: "\u{FF86}",
        nfd: "\u{FF86}",
        nfkc: "\u{30CB}",
        nfkd: "\u{30CB}",
    },
    NormalizationTest {
        source: "\u{FF87}",
        nfc: "\u{FF87}",
        nfd: "\u{FF87}",
        nfkc: "\u{30CC}",
        nfkd: "\u{30CC}",
    },
    NormalizationTest {
        source: "\u{FF88}",
        nfc: "\u{FF88}",
        nfd: "\u{FF88}",
        nfkc: "\u{30CD}",
        nfkd: "\u{30CD}",
    },
    NormalizationTest {
        source: "\u{FF89}",
        nfc: "\u{FF89}",
        nfd: "\u{FF89}",
        nfkc: "\u{30CE}",
        nfkd: "\u{30CE}",
    },
    NormalizationTest {
        source: "\u{FF8A}",
        nfc: "\u{FF8A}",
        nfd: "\u{FF8A}",
        nfkc: "\u{30CF}",
        nfkd: "\u{30CF}",
    },
    NormalizationTest {
        source: "\u{FF8B}",
        nfc: "\u{FF8B}",
        nfd: "\u{FF8B}",
        nfkc: "\u{30D2}",
        nfkd: "\u{30D2}",
    },
    NormalizationTest {
        source: "\u{FF8C}",
        nfc: "\u{FF8C}",
        nfd: "\u{FF8C}",
        nfkc: "\u{30D5}",
        nfkd: "\u{30D5}",
    },
    NormalizationTest {
        source: "\u{FF8D}",
        nfc: "\u{FF8D}",
        nfd: "\u{FF8D}",
        nfkc: "\u{30D8}",
        nfkd: "\u{30D8}",
    },
    NormalizationTest {
        source: "\u{FF8E}",
        nfc: "\u{FF8E}",
        nfd: "\u{FF8E}",
        nfkc: "\u{30DB}",
        nfkd: "\u{30DB}",
    },
    NormalizationTest {
        source: "\u{FF8F}",
        nfc: "\u{FF8F}",
        nfd: "\u{FF8F}",
        nfkc: "\u{30DE}",
        nfkd: "\u{30DE}",
    },
    NormalizationTest {
        source: "\u{FF90}",
        nfc: "\u{FF90}",
        nfd: "\u{FF90}",
        nfkc: "\u{30DF}",
        nfkd: "\u{30DF}",
    },
    NormalizationTest {
        source: "\u{FF91}",
        nfc: "\u{FF91}",
        nfd: "\u{FF91}",
        nfkc: "\u{30E0}",
        nfkd: "\u{30E0}",
    },
    NormalizationTest {
        source: "\u{FF92}",
        nfc: "\u{FF92}",
        nfd: "\u{FF92}",
        nfkc: "\u{30E1}",
        nfkd: "\u{30E1}",
    },
    NormalizationTest {
        source: "\u{FF93}",
        nfc: "\u{FF93}",
        nfd: "\u{FF93}",
        nfkc: "\u{30E2}",
        nfkd: "\u{30E2}",
    },
    NormalizationTest {
        source: "\u{FF94}",
        nfc: "\u{FF94}",
        nfd: "\u{FF94}",
        nfkc: "\u{30E4}",
        nfkd: "\u{30E4}",
    },
    NormalizationTest {
        source: "\u{FF95}",
        nfc: "\u{FF95}",
        nfd: "\u{FF95}",
        nfkc: "\u{30E6}",
        nfkd: "\u{30E6}",
    },
    NormalizationTest {
        source: "\u{FF96}",
        nfc: "\u{FF96}",
        nfd: "\u{FF96}",
        nfkc: "\u{30E8}",
        nfkd: "\u{30E8}",
    },
    NormalizationTest {
        source: "\u{FF97}",
        nfc: "\u{FF97}",
        nfd: "\u{FF97}",
        nfkc: "\u{30E9}",
        nfkd: "\u{30E9}",
    },
    NormalizationTest {
        source: "\u{FF98}",
        nfc: "\u{FF98}",
        nfd: "\u{FF98}",
        nfkc: "\u{30EA}",
        nfkd: "\u{30EA}",
    },
    NormalizationTest {
        source: "\u{FF99}",
        nfc: "\u{FF99}",
        nfd: "\u{FF99}",
        nfkc: "\u{30EB}",
        nfkd: "\u{30EB}",
    },
    NormalizationTest {
        source: "\u{FF9A}",
        nfc: "\u{FF9A}",
        nfd: "\u{FF9A}",
        nfkc: "\u{30EC}",
        nfkd: "\u{30EC}",
    },
    NormalizationTest {
        source: "\u{FF9B}",
        nfc: "\u{FF9B}",
        nfd: "\u{FF9B}",
        nfkc: "\u{30ED}",
        nfkd: "\u{30ED}",
    },
    NormalizationTest {
        source: "\u{FF9C}",
        nfc: "\u{FF9C}",
        nfd: "\u{FF9C}",
        nfkc: "\u{30EF}",
        nfkd: "\u{30EF}",
    },
    NormalizationTest {
        source: "\u{FF9D}",
        nfc: "\u{FF9D}",
        nfd: "\u{FF9D}",
        nfkc: "\u{30F3}",
        nfkd: "\u{30F3}",
    },
    NormalizationTest {
        source: "\u{FF9E}",
        nfc: "\u{FF9E}",
        nfd: "\u{FF9E}",
        nfkc: "\u{3099}",
        nfkd: "\u{3099}",
    },
    NormalizationTest {
        source: "\u{FF9F}",
        nfc: "\u{FF9F}",
        nfd: "\u{FF9F}",
        nfkc: "\u{309A}",
        nfkd: "\u{309A}",
    },
    NormalizationTest {
        source: "\u{FFA0}",
        nfc: "\u{FFA0}",
        nfd: "\u{FFA0}",
        nfkc: "\u{1160}",
        nfkd: "\u{1160}",
    },
    NormalizationTest {
        source: "\u{FFA1}",
        nfc: "\u{FFA1}",
        nfd: "\u{FFA1}",
        nfkc: "\u{1100}",
        nfkd: "\u{1100}",
    },
    NormalizationTest {
        source: "\u{FFA2}",
        nfc: "\u{FFA2}",
        nfd: "\u{FFA2}",
        nfkc: "\u{1101}",
        nfkd: "\u{1101}",
    },
    NormalizationTest {
        source: "\u{FFA3}",
        nfc: "\u{FFA3}",
        nfd: "\u{FFA3}",
        nfkc: "\u{11AA}",
        nfkd: "\u{11AA}",
    },
    NormalizationTest {
        source: "\u{FFA4}",
        nfc: "\u{FFA4}",
        nfd: "\u{FFA4}",
        nfkc: "\u{1102}",
        nfkd: "\u{1102}",
    },
    NormalizationTest {
        source: "\u{FFA5}",
        nfc: "\u{FFA5}",
        nfd: "\u{FFA5}",
        nfkc: "\u{11AC}",
        nfkd: "\u{11AC}",
    },
    NormalizationTest {
        source: "\u{FFA6}",
        nfc: "\u{FFA6}",
        nfd: "\u{FFA6}",
        nfkc: "\u{11AD}",
        nfkd: "\u{11AD}",
    },
    NormalizationTest {
        source: "\u{FFA7}",
        nfc: "\u{FFA7}",
        nfd: "\u{FFA7}",
        nfkc: "\u{1103}",
        nfkd: "\u{1103}",
    },
    NormalizationTest {
        source: "\u{FFA8}",
        nfc: "\u{FFA8}",
        nfd: "\u{FFA8}",
        nfkc: "\u{1104}",
        nfkd: "\u{1104}",
    },
    NormalizationTest {
        source: "\u{FFA9}",
        nfc: "\u{FFA9}",
        nfd: "\u{FFA9}",
        nfkc: "\u{1105}",
        nfkd: "\u{1105}",
    },
    NormalizationTest {
        source: "\u{FFAA}",
        nfc: "\u{FFAA}",
        nfd: "\u{FFAA}",
        nfkc: "\u{11B0}",
        nfkd: "\u{11B0}",
    },
    NormalizationTest {
        source: "\u{FFAB}",
        nfc: "\u{FFAB}",
        nfd: "\u{FFAB}",
        nfkc: "\u{11B1}",
        nfkd: "\u{11B1}",
    },
    NormalizationTest {
        source: "\u{FFAC}",
        nfc: "\u{FFAC}",
        nfd: "\u{FFAC}",
        nfkc: "\u{11B2}",
        nfkd: "\u{11B2}",
    },
    NormalizationTest {
        source: "\u{FFAD}",
        nfc: "\u{FFAD}",
        nfd: "\u{FFAD}",
        nfkc: "\u{11B3}",
        nfkd: "\u{11B3}",
    },
    NormalizationTest {
        source: "\u{FFAE}",
        nfc: "\u{FFAE}",
        nfd: "\u{FFAE}",
        nfkc: "\u{11B4}",
        nfkd: "\u{11B4}",
    },
    NormalizationTest {
        source: "\u{FFAF}",
        nfc: "\u{FFAF}",
        nfd: "\u{FFAF}",
        nfkc: "\u{11B5}",
        nfkd: "\u{11B5}",
    },
    NormalizationTest {
        source: "\u{FFB0}",
        nfc: "\u{FFB0}",
        nfd: "\u{FFB0}",
        nfkc: "\u{111A}",
        nfkd: "\u{111A}",
    },
    NormalizationTest {
        source: "\u{FFB1}",
        nfc: "\u{FFB1}",
        nfd: "\u{FFB1}",
        nfkc: "\u{1106}",
        nfkd: "\u{1106}",
    },
    NormalizationTest {
        source: "\u{FFB2}",
        nfc: "\u{FFB2}",
        nfd: "\u{FFB2}",
        nfkc: "\u{1107}",
        nfkd: "\u{1107}",
    },
    NormalizationTest {
        source: "\u{FFB3}",
        nfc: "\u{FFB3}",
        nfd: "\u{FFB3}",
        nfkc: "\u{1108}",
        nfkd: "\u{1108}",
    },
    NormalizationTest {
        source: "\u{FFB4}",
        nfc: "\u{FFB4}",
        nfd: "\u{FFB4}",
        nfkc: "\u{1121}",
        nfkd: "\u{1121}",
    },
    NormalizationTest {
        source: "\u{FFB5}",
        nfc: "\u{FFB5}",
        nfd: "\u{FFB5}",
        nfkc: "\u{1109}",
        nfkd: "\u{1109}",
    },
    NormalizationTest {
        source: "\u{FFB6}",
        nfc: "\u{FFB6}",
        nfd: "\u{FFB6}",
        nfkc: "\u{110A}",
        nfkd: "\u{110A}",
    },
    NormalizationTest {
        source: "\u{FFB7}",
        nfc: "\u{FFB7}",
        nfd: "\u{FFB7}",
        nfkc: "\u{110B}",
        nfkd: "\u{110B}",
    },
    NormalizationTest {
        source: "\u{FFB8}",
        nfc: "\u{FFB8}",
        nfd: "\u{FFB8}",
        nfkc: "\u{110C}",
        nfkd: "\u{110C}",
    },
    NormalizationTest {
        source: "\u{FFB9}",
        nfc: "\u{FFB9}",
        nfd: "\u{FFB9}",
        nfkc: "\u{110D}",
        nfkd: "\u{110D}",
    },
    NormalizationTest {
        source: "\u{FFBA}",
        nfc: "\u{FFBA}",
        nfd: "\u{FFBA}",
        nfkc: "\u{110E}",
        nfkd: "\u{110E}",
    },
    NormalizationTest {
        source: "\u{FFBB}",
        nfc: "\u{FFBB}",
        nfd: "\u{FFBB}",
        nfkc: "\u{110F}",
        nfkd: "\u{110F}",
    },
    NormalizationTest {
        source: "\u{FFBC}",
        nfc: "\u{FFBC}",
        nfd: "\u{FFBC}",
        nfkc: "\u{1110}",
        nfkd: "\u{1110}",
    },
    NormalizationTest {
        source: "\u{FFBD}",
        nfc: "\u{FFBD}",
        nfd: "\u{FFBD}",
        nfkc: "\u{1111}",
        nfkd: "\u{1111}",
    },
    NormalizationTest {
        source: "\u{FFBE}",
        nfc: "\u{FFBE}",
        nfd: "\u{FFBE}",
        nfkc: "\u{1112}",
        nfkd: "\u{1112}",
    },
    NormalizationTest {
        source: "\u{FFC2}",
        nfc: "\u{FFC2}",
        nfd: "\u{FFC2}",
        nfkc: "\u{1161}",
        nfkd: "\u{1161}",
    },
    NormalizationTest {
        source: "\u{FFC3}",
        nfc: "\u{FFC3}",
        nfd: "\u{FFC3}",
        nfkc: "\u{1162}",
        nfkd: "\u{1162}",
    },
    NormalizationTest {
        source: "\u{FFC4}",
        nfc: "\u{FFC4}",
        nfd: "\u{FFC4}",
        nfkc: "\u{1163}",
        nfkd: "\u{1163}",
    },
    NormalizationTest {
        source: "\u{FFC5}",
        nfc: "\u{FFC5}",
        nfd: "\u{FFC5}",
        nfkc: "\u{1164}",
        nfkd: "\u{1164}",
    },
    NormalizationTest {
        source: "\u{FFC6}",
        nfc: "\u{FFC6}",
        nfd: "\u{FFC6}",
        nfkc: "\u{1165}",
        nfkd: "\u{1165}",
    },
    NormalizationTest {
        source: "\u{FFC7}",
        nfc: "\u{FFC7}",
        nfd: "\u{FFC7}",
        nfkc: "\u{1166}",
        nfkd: "\u{1166}",
    },
    NormalizationTest {
        source: "\u{FFCA}",
        nfc: "\u{FFCA}",
        nfd: "\u{FFCA}",
        nfkc: "\u{1167}",
        nfkd: "\u{1167}",
    },
    NormalizationTest {
        source: "\u{FFCB}",
        nfc: "\u{FFCB}",
        nfd: "\u{FFCB}",
        nfkc: "\u{1168}",
        nfkd: "\u{1168}",
    },
    NormalizationTest {
        source: "\u{FFCC}",
        nfc: "\u{FFCC}",
        nfd: "\u{FFCC}",
        nfkc: "\u{1169}",
        nfkd: "\u{1169}",
    },
    NormalizationTest {
        source: "\u{FFCD}",
        nfc: "\u{FFCD}",
        nfd: "\u{FFCD}",
        nfkc: "\u{116A}",
        nfkd: "\u{116A}",
    },
    NormalizationTest {
        source: "\u{FFCE}",
        nfc: "\u{FFCE}",
        nfd: "\u{FFCE}",
        nfkc: "\u{116B}",
        nfkd: "\u{116B}",
    },
    NormalizationTest {
        source: "\u{FFCF}",
        nfc: "\u{FFCF}",
        nfd: "\u{FFCF}",
        nfkc: "\u{116C}",
        nfkd: "\u{116C}",
    },
    NormalizationTest {
        source: "\u{FFD2}",
        nfc: "\u{FFD2}",
        nfd: "\u{FFD2}",
        nfkc: "\u{116D}",
        nfkd: "\u{116D}",
    },
    NormalizationTest {
        source: "\u{FFD3}",
        nfc: "\u{FFD3}",
        nfd: "\u{FFD3}",
        nfkc: "\u{116E}",
        nfkd: "\u{116E}",
    },
    NormalizationTest {
        source: "\u{FFD4}",
        nfc: "\u{FFD4}",
        nfd: "\u{FFD4}",
        nfkc: "\u{116F}",
        nfkd: "\u{116F}",
    },
    NormalizationTest {
        source: "\u{FFD5}",
        nfc: "\u{FFD5}",
        nfd: "\u{FFD5}",
        nfkc: "\u{1170}",
        nfkd: "\u{1170}",
    },
    NormalizationTest {
        source: "\u{FFD6}",
        nfc: "\u{FFD6}",
        nfd: "\u{FFD6}",
        nfkc: "\u{1171}",
        nfkd: "\u{1171}",
    },
    NormalizationTest {
        source: "\u{FFD7}",
        nfc: "\u{FFD7}",
        nfd: "\u{FFD7}",
        nfkc: "\u{1172}",
        nfkd: "\u{1172}",
    },
    NormalizationTest {
        source: "\u{FFDA}",
        nfc: "\u{FFDA}",
        nfd: "\u{FFDA}",
        nfkc: "\u{1173}",
        nfkd: "\u{1173}",
    },
    NormalizationTest {
        source: "\u{FFDB}",
        nfc: "\u{FFDB}",
        nfd: "\u{FFDB}",
        nfkc: "\u{1174}",
        nfkd: "\u{1174}",
    },
    NormalizationTest {
        source: "\u{FFDC}",
        nfc: "\u{FFDC}",
        nfd: "\u{FFDC}",
        nfkc: "\u{1175}",
        nfkd: "\u{1175}",
    },
    NormalizationTest {
        source: "\u{FFE0}",
        nfc: "\u{FFE0}",
        nfd: "\u{FFE0}",
        nfkc: "\u{00A2}",
        nfkd: "\u{00A2}",
    },
    NormalizationTest {
        source: "\u{FFE1}",
        nfc: "\u{FFE1}",
        nfd: "\u{FFE1}",
        nfkc: "\u{00A3}",
        nfkd: "\u{00A3}",
    },
    NormalizationTest {
        source: "\u{FFE2}",
        nfc: "\u{FFE2}",
        nfd: "\u{FFE2}",
        nfkc: "\u{00AC}",
        nfkd: "\u{00AC}",
    },
    NormalizationTest {
        source: "\u{FFE3}",
        nfc: "\u{FFE3}",
        nfd: "\u{FFE3}",
        nfkc: "\u{0020}\u{0304}",
        nfkd: "\u{0020}\u{0304}",
    },
    NormalizationTest {
        source: "\u{FFE4}",
        nfc: "\u{FFE4}",
        nfd: "\u{FFE4}",
        nfkc: "\u{00A6}",
        nfkd: "\u{00A6}",
    },
    NormalizationTest {
        source: "\u{FFE5}",
        nfc: "\u{FFE5}",
        nfd: "\u{FFE5}",
        nfkc: "\u{00A5}",
        nfkd: "\u{00A5}",
    },
    NormalizationTest {
        source: "\u{FFE6}",
        nfc: "\u{FFE6}",
        nfd: "\u{FFE6}",
        nfkc: "\u{20A9}",
        nfkd: "\u{20A9}",
    },
    NormalizationTest {
        source: "\u{FFE8}",
        nfc: "\u{FFE8}",
        nfd: "\u{FFE8}",
        nfkc: "\u{2502}",
        nfkd: "\u{2502}",
    },
    NormalizationTest {
        source: "\u{FFE9}",
        nfc: "\u{FFE9}",
        nfd: "\u{FFE9}",
        nfkc: "\u{2190}",
        nfkd: "\u{2190}",
    },
    NormalizationTest {
        source: "\u{FFEA}",
        nfc: "\u{FFEA}",
        nfd: "\u{FFEA}",
        nfkc: "\u{2191}",
        nfkd: "\u{2191}",
    },
    NormalizationTest {
        source: "\u{FFEB}",
        nfc: "\u{FFEB}",
        nfd: "\u{FFEB}",
        nfkc: "\u{2192}",
        nfkd: "\u{2192}",
    },
    NormalizationTest {
        source: "\u{FFEC}",
        nfc: "\u{FFEC}",
        nfd: "\u{FFEC}",
        nfkc: "\u{2193}",
        nfkd: "\u{2193}",
    },
    NormalizationTest {
        source: "\u{FFED}",
        nfc: "\u{FFED}",
        nfd: "\u{FFED}",
        nfkc: "\u{25A0}",
        nfkd: "\u{25A0}",
    },
    NormalizationTest {
        source: "\u{FFEE}",
        nfc: "\u{FFEE}",
        nfd: "\u{FFEE}",
        nfkc: "\u{25CB}",
        nfkd: "\u{25CB}",
    },
    NormalizationTest {
        source: "\u{1109A}",
        nfc: "\u{1109A}",
        nfd: "\u{11099}\u{110BA}",
        nfkc: "\u{1109A}",
        nfkd: "\u{11099}\u{110BA}",
    },
    NormalizationTest {
        source: "\u{1109C}",
        nfc: "\u{1109C}",
        nfd: "\u{1109B}\u{110BA}",
        nfkc: "\u{1109C}",
        nfkd: "\u{1109B}\u{110BA}",
    },
    NormalizationTest {
        source: "\u{110AB}",
        nfc: "\u{110AB}",
        nfd: "\u{110A5}\u{110BA}",
        nfkc: "\u{110AB}",
        nfkd: "\u{110A5}\u{110BA}",
    },
    NormalizationTest {
        source: "\u{1112E}",
        nfc: "\u{1112E}",
        nfd: "\u{11131}\u{11127}",
        nfkc: "\u{1112E}",
        nfkd: "\u{11131}\u{11127}",
    },
    NormalizationTest {
        source: "\u{1112F}",
        nfc: "\u{1112F}",
        nfd: "\u{11132}\u{11127}",
        nfkc: "\u{1112F}",
        nfkd: "\u{11132}\u{11127}",
    },
    NormalizationTest {
        source: "\u{1134B}",
        nfc: "\u{1134B}",
        nfd: "\u{11347}\u{1133E}",
        nfkc: "\u{1134B}",
        nfkd: "\u{11347}\u{1133E}",
    },
    NormalizationTest {
        source: "\u{1134C}",
        nfc: "\u{1134C}",
        nfd: "\u{11347}\u{11357}",
        nfkc: "\u{1134C}",
        nfkd: "\u{11347}\u{11357}",
    },
    NormalizationTest {
        source: "\u{114BB}",
        nfc: "\u{114BB}",
        nfd: "\u{114B9}\u{114BA}",
        nfkc: "\u{114BB}",
        nfkd: "\u{114B9}\u{114BA}",
    },
    NormalizationTest {
        source: "\u{114BC}",
        nfc: "\u{114BC}",
        nfd: "\u{114B9}\u{114B0}",
        nfkc: "\u{114BC}",
        nfkd: "\u{114B9}\u{114B0}",
    },
    NormalizationTest {
        source: "\u{114BE}",
        nfc: "\u{114BE}",
        nfd: "\u{114B9}\u{114BD}",
        nfkc: "\u{114BE}",
        nfkd: "\u{114B9}\u{114BD}",
    },
    NormalizationTest {
        source: "\u{115BA}",
        nfc: "\u{115BA}",
        nfd: "\u{115B8}\u{115AF}",
        nfkc: "\u{115BA}",
        nfkd: "\u{115B8}\u{115AF}",
    },
    NormalizationTest {
        source: "\u{115BB}",
        nfc: "\u{115BB}",
        nfd: "\u{115B9}\u{115AF}",
        nfkc: "\u{115BB}",
        nfkd: "\u{115B9}\u{115AF}",
    },
    NormalizationTest {
        source: "\u{1D15E}",
        nfc: "\u{1D157}\u{1D165}",
        nfd: "\u{1D157}\u{1D165}",
        nfkc: "\u{1D157}\u{1D165}",
        nfkd: "\u{1D157}\u{1D165}",
    },
    NormalizationTest {
        source: "\u{1D15F}",
        nfc: "\u{1D158}\u{1D165}",
        nfd: "\u{1D158}\u{1D165}",
        nfkc: "\u{1D158}\u{1D165}",
        nfkd: "\u{1D158}\u{1D165}",
    },
    NormalizationTest {
        source: "\u{1D160}",
        nfc: "\u{1D158}\u{1D165}\u{1D16E}",
        nfd: "\u{1D158}\u{1D165}\u{1D16E}",
        nfkc: "\u{1D158}\u{1D165}\u{1D16E}",
        nfkd: "\u{1D158}\u{1D165}\u{1D16E}",
    },
    NormalizationTest {
        source: "\u{1D161}",
        nfc: "\u{1D158}\u{1D165}\u{1D16F}",
        nfd: "\u{1D158}\u{1D165}\u{1D16F}",
        nfkc: "\u{1D158}\u{1D165}\u{1D16F}",
        nfkd: "\u{1D158}\u{1D165}\u{1D16F}",
    },
    NormalizationTest {
        source: "\u{1D162}",
        nfc: "\u{1D158}\u{1D165}\u{1D170}",
        nfd: "\u{1D158}\u{1D165}\u{1D170}",
        nfkc: "\u{1D158}\u{1D165}\u{1D170}",
        nfkd: "\u{1D158}\u{1D165}\u{1D170}",
    },
    NormalizationTest {
        source: "\u{1D163}",
        nfc: "\u{1D158}\u{1D165}\u{1D171}",
        nfd: "\u{1D158}\u{1D165}\u{1D171}",
        nfkc: "\u{1D158}\u{1D165}\u{1D171}",
        nfkd: "\u{1D158}\u{1D165}\u{1D171}",
    },
    NormalizationTest {
        source: "\u{1D164}",
        nfc: "\u{1D158}\u{1D165}\u{1D172}",
        nfd: "\u{1D158}\u{1D165}\u{1D172}",
        nfkc: "\u{1D158}\u{1D165}\u{1D172}",
        nfkd: "\u{1D158}\u{1D165}\u{1D172}",
    },
    NormalizationTest {
        source: "\u{1D1BB}",
        nfc: "\u{1D1B9}\u{1D165}",
        nfd: "\u{1D1B9}\u{1D165}",
        nfkc: "\u{1D1B9}\u{1D165}",
        nfkd: "\u{1D1B9}\u{1D165}",
    },
    NormalizationTest {
        source: "\u{1D1BC}",
        nfc: "\u{1D1BA}\u{1D165}",
        nfd: "\u{1D1BA}\u{1D165}",
        nfkc: "\u{1D1BA}\u{1D165}",
        nfkd: "\u{1D1BA}\u{1D165}",
    },
    NormalizationTest {
        source: "\u{1D1BD}",
        nfc: "\u{1D1B9}\u{1D165}\u{1D16E}",
        nfd: "\u{1D1B9}\u{1D165}\u{1D16E}",
        nfkc: "\u{1D1B9}\u{1D165}\u{1D16E}",
        nfkd: "\u{1D1B9}\u{1D165}\u{1D16E}",
    },
    NormalizationTest {
        source: "\u{1D1BE}",
        nfc: "\u{1D1BA}\u{1D165}\u{1D16E}",
        nfd: "\u{1D1BA}\u{1D165}\u{1D16E}",
        nfkc: "\u{1D1BA}\u{1D165}\u{1D16E}",
        nfkd: "\u{1D1BA}\u{1D165}\u{1D16E}",
    },
    NormalizationTest {
        source: "\u{1D1BF}",
        nfc: "\u{1D1B9}\u{1D165}\u{1D16F}",
        nfd: "\u{1D1B9}\u{1D165}\u{1D16F}",
        nfkc: "\u{1D1B9}\u{1D165}\u{1D16F}",
        nfkd: "\u{1D1B9}\u{1D165}\u{1D16F}",
    },
    NormalizationTest {
        source: "\u{1D1C0}",
        nfc: "\u{1D1BA}\u{1D165}\u{1D16F}",
        nfd: "\u{1D1BA}\u{1D165}\u{1D16F}",
        nfkc: "\u{1D1BA}\u{1D165}\u{1D16F}",
        nfkd: "\u{1D1BA}\u{1D165}\u{1D16F}",
    },
    NormalizationTest {
        source: "\u{1D400}",
        nfc: "\u{1D400}",
        nfd: "\u{1D400}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D401}",
        nfc: "\u{1D401}",
        nfd: "\u{1D401}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D402}",
        nfc: "\u{1D402}",
        nfd: "\u{1D402}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1D403}",
        nfc: "\u{1D403}",
        nfd: "\u{1D403}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D404}",
        nfc: "\u{1D404}",
        nfd: "\u{1D404}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D405}",
        nfc: "\u{1D405}",
        nfd: "\u{1D405}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1D406}",
        nfc: "\u{1D406}",
        nfd: "\u{1D406}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D407}",
        nfc: "\u{1D407}",
        nfd: "\u{1D407}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{1D408}",
        nfc: "\u{1D408}",
        nfd: "\u{1D408}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1D409}",
        nfc: "\u{1D409}",
        nfd: "\u{1D409}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D40A}",
        nfc: "\u{1D40A}",
        nfd: "\u{1D40A}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D40B}",
        nfc: "\u{1D40B}",
        nfd: "\u{1D40B}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D40C}",
        nfc: "\u{1D40C}",
        nfd: "\u{1D40C}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D40D}",
        nfc: "\u{1D40D}",
        nfd: "\u{1D40D}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D40E}",
        nfc: "\u{1D40E}",
        nfd: "\u{1D40E}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D40F}",
        nfc: "\u{1D40F}",
        nfd: "\u{1D40F}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D410}",
        nfc: "\u{1D410}",
        nfd: "\u{1D410}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1D411}",
        nfc: "\u{1D411}",
        nfd: "\u{1D411}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1D412}",
        nfc: "\u{1D412}",
        nfd: "\u{1D412}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D413}",
        nfc: "\u{1D413}",
        nfd: "\u{1D413}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D414}",
        nfc: "\u{1D414}",
        nfd: "\u{1D414}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D415}",
        nfc: "\u{1D415}",
        nfd: "\u{1D415}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D416}",
        nfc: "\u{1D416}",
        nfd: "\u{1D416}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D417}",
        nfc: "\u{1D417}",
        nfd: "\u{1D417}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D418}",
        nfc: "\u{1D418}",
        nfd: "\u{1D418}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D419}",
        nfc: "\u{1D419}",
        nfd: "\u{1D419}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{1D41A}",
        nfc: "\u{1D41A}",
        nfd: "\u{1D41A}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D41B}",
        nfc: "\u{1D41B}",
        nfd: "\u{1D41B}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D41C}",
        nfc: "\u{1D41C}",
        nfd: "\u{1D41C}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D41D}",
        nfc: "\u{1D41D}",
        nfd: "\u{1D41D}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D41E}",
        nfc: "\u{1D41E}",
        nfd: "\u{1D41E}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D41F}",
        nfc: "\u{1D41F}",
        nfd: "\u{1D41F}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D420}",
        nfc: "\u{1D420}",
        nfd: "\u{1D420}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D421}",
        nfc: "\u{1D421}",
        nfd: "\u{1D421}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{1D422}",
        nfc: "\u{1D422}",
        nfd: "\u{1D422}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D423}",
        nfc: "\u{1D423}",
        nfd: "\u{1D423}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D424}",
        nfc: "\u{1D424}",
        nfd: "\u{1D424}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D425}",
        nfc: "\u{1D425}",
        nfd: "\u{1D425}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D426}",
        nfc: "\u{1D426}",
        nfd: "\u{1D426}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D427}",
        nfc: "\u{1D427}",
        nfd: "\u{1D427}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D428}",
        nfc: "\u{1D428}",
        nfd: "\u{1D428}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D429}",
        nfc: "\u{1D429}",
        nfd: "\u{1D429}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D42A}",
        nfc: "\u{1D42A}",
        nfd: "\u{1D42A}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D42B}",
        nfc: "\u{1D42B}",
        nfd: "\u{1D42B}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D42C}",
        nfc: "\u{1D42C}",
        nfd: "\u{1D42C}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D42D}",
        nfc: "\u{1D42D}",
        nfd: "\u{1D42D}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D42E}",
        nfc: "\u{1D42E}",
        nfd: "\u{1D42E}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D42F}",
        nfc: "\u{1D42F}",
        nfd: "\u{1D42F}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D430}",
        nfc: "\u{1D430}",
        nfd: "\u{1D430}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D431}",
        nfc: "\u{1D431}",
        nfd: "\u{1D431}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D432}",
        nfc: "\u{1D432}",
        nfd: "\u{1D432}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D433}",
        nfc: "\u{1D433}",
        nfd: "\u{1D433}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D434}",
        nfc: "\u{1D434}",
        nfd: "\u{1D434}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D435}",
        nfc: "\u{1D435}",
        nfd: "\u{1D435}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D436}",
        nfc: "\u{1D436}",
        nfd: "\u{1D436}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1D437}",
        nfc: "\u{1D437}",
        nfd: "\u{1D437}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D438}",
        nfc: "\u{1D438}",
        nfd: "\u{1D438}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D439}",
        nfc: "\u{1D439}",
        nfd: "\u{1D439}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1D43A}",
        nfc: "\u{1D43A}",
        nfd: "\u{1D43A}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D43B}",
        nfc: "\u{1D43B}",
        nfd: "\u{1D43B}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{1D43C}",
        nfc: "\u{1D43C}",
        nfd: "\u{1D43C}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1D43D}",
        nfc: "\u{1D43D}",
        nfd: "\u{1D43D}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D43E}",
        nfc: "\u{1D43E}",
        nfd: "\u{1D43E}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D43F}",
        nfc: "\u{1D43F}",
        nfd: "\u{1D43F}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D440}",
        nfc: "\u{1D440}",
        nfd: "\u{1D440}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D441}",
        nfc: "\u{1D441}",
        nfd: "\u{1D441}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D442}",
        nfc: "\u{1D442}",
        nfd: "\u{1D442}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D443}",
        nfc: "\u{1D443}",
        nfd: "\u{1D443}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D444}",
        nfc: "\u{1D444}",
        nfd: "\u{1D444}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1D445}",
        nfc: "\u{1D445}",
        nfd: "\u{1D445}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1D446}",
        nfc: "\u{1D446}",
        nfd: "\u{1D446}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D447}",
        nfc: "\u{1D447}",
        nfd: "\u{1D447}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D448}",
        nfc: "\u{1D448}",
        nfd: "\u{1D448}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D449}",
        nfc: "\u{1D449}",
        nfd: "\u{1D449}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D44A}",
        nfc: "\u{1D44A}",
        nfd: "\u{1D44A}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D44B}",
        nfc: "\u{1D44B}",
        nfd: "\u{1D44B}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D44C}",
        nfc: "\u{1D44C}",
        nfd: "\u{1D44C}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D44D}",
        nfc: "\u{1D44D}",
        nfd: "\u{1D44D}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{1D44E}",
        nfc: "\u{1D44E}",
        nfd: "\u{1D44E}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D44F}",
        nfc: "\u{1D44F}",
        nfd: "\u{1D44F}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D450}",
        nfc: "\u{1D450}",
        nfd: "\u{1D450}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D451}",
        nfc: "\u{1D451}",
        nfd: "\u{1D451}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D452}",
        nfc: "\u{1D452}",
        nfd: "\u{1D452}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D453}",
        nfc: "\u{1D453}",
        nfd: "\u{1D453}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D454}",
        nfc: "\u{1D454}",
        nfd: "\u{1D454}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D456}",
        nfc: "\u{1D456}",
        nfd: "\u{1D456}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D457}",
        nfc: "\u{1D457}",
        nfd: "\u{1D457}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D458}",
        nfc: "\u{1D458}",
        nfd: "\u{1D458}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D459}",
        nfc: "\u{1D459}",
        nfd: "\u{1D459}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D45A}",
        nfc: "\u{1D45A}",
        nfd: "\u{1D45A}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D45B}",
        nfc: "\u{1D45B}",
        nfd: "\u{1D45B}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D45C}",
        nfc: "\u{1D45C}",
        nfd: "\u{1D45C}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D45D}",
        nfc: "\u{1D45D}",
        nfd: "\u{1D45D}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D45E}",
        nfc: "\u{1D45E}",
        nfd: "\u{1D45E}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D45F}",
        nfc: "\u{1D45F}",
        nfd: "\u{1D45F}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D460}",
        nfc: "\u{1D460}",
        nfd: "\u{1D460}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D461}",
        nfc: "\u{1D461}",
        nfd: "\u{1D461}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D462}",
        nfc: "\u{1D462}",
        nfd: "\u{1D462}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D463}",
        nfc: "\u{1D463}",
        nfd: "\u{1D463}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D464}",
        nfc: "\u{1D464}",
        nfd: "\u{1D464}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D465}",
        nfc: "\u{1D465}",
        nfd: "\u{1D465}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D466}",
        nfc: "\u{1D466}",
        nfd: "\u{1D466}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D467}",
        nfc: "\u{1D467}",
        nfd: "\u{1D467}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D468}",
        nfc: "\u{1D468}",
        nfd: "\u{1D468}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D469}",
        nfc: "\u{1D469}",
        nfd: "\u{1D469}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D46A}",
        nfc: "\u{1D46A}",
        nfd: "\u{1D46A}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1D46B}",
        nfc: "\u{1D46B}",
        nfd: "\u{1D46B}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D46C}",
        nfc: "\u{1D46C}",
        nfd: "\u{1D46C}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D46D}",
        nfc: "\u{1D46D}",
        nfd: "\u{1D46D}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1D46E}",
        nfc: "\u{1D46E}",
        nfd: "\u{1D46E}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D46F}",
        nfc: "\u{1D46F}",
        nfd: "\u{1D46F}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{1D470}",
        nfc: "\u{1D470}",
        nfd: "\u{1D470}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1D471}",
        nfc: "\u{1D471}",
        nfd: "\u{1D471}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D472}",
        nfc: "\u{1D472}",
        nfd: "\u{1D472}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D473}",
        nfc: "\u{1D473}",
        nfd: "\u{1D473}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D474}",
        nfc: "\u{1D474}",
        nfd: "\u{1D474}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D475}",
        nfc: "\u{1D475}",
        nfd: "\u{1D475}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D476}",
        nfc: "\u{1D476}",
        nfd: "\u{1D476}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D477}",
        nfc: "\u{1D477}",
        nfd: "\u{1D477}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D478}",
        nfc: "\u{1D478}",
        nfd: "\u{1D478}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1D479}",
        nfc: "\u{1D479}",
        nfd: "\u{1D479}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1D47A}",
        nfc: "\u{1D47A}",
        nfd: "\u{1D47A}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D47B}",
        nfc: "\u{1D47B}",
        nfd: "\u{1D47B}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D47C}",
        nfc: "\u{1D47C}",
        nfd: "\u{1D47C}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D47D}",
        nfc: "\u{1D47D}",
        nfd: "\u{1D47D}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D47E}",
        nfc: "\u{1D47E}",
        nfd: "\u{1D47E}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D47F}",
        nfc: "\u{1D47F}",
        nfd: "\u{1D47F}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D480}",
        nfc: "\u{1D480}",
        nfd: "\u{1D480}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D481}",
        nfc: "\u{1D481}",
        nfd: "\u{1D481}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{1D482}",
        nfc: "\u{1D482}",
        nfd: "\u{1D482}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D483}",
        nfc: "\u{1D483}",
        nfd: "\u{1D483}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D484}",
        nfc: "\u{1D484}",
        nfd: "\u{1D484}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D485}",
        nfc: "\u{1D485}",
        nfd: "\u{1D485}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D486}",
        nfc: "\u{1D486}",
        nfd: "\u{1D486}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D487}",
        nfc: "\u{1D487}",
        nfd: "\u{1D487}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D488}",
        nfc: "\u{1D488}",
        nfd: "\u{1D488}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D489}",
        nfc: "\u{1D489}",
        nfd: "\u{1D489}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{1D48A}",
        nfc: "\u{1D48A}",
        nfd: "\u{1D48A}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D48B}",
        nfc: "\u{1D48B}",
        nfd: "\u{1D48B}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D48C}",
        nfc: "\u{1D48C}",
        nfd: "\u{1D48C}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D48D}",
        nfc: "\u{1D48D}",
        nfd: "\u{1D48D}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D48E}",
        nfc: "\u{1D48E}",
        nfd: "\u{1D48E}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D48F}",
        nfc: "\u{1D48F}",
        nfd: "\u{1D48F}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D490}",
        nfc: "\u{1D490}",
        nfd: "\u{1D490}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D491}",
        nfc: "\u{1D491}",
        nfd: "\u{1D491}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D492}",
        nfc: "\u{1D492}",
        nfd: "\u{1D492}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D493}",
        nfc: "\u{1D493}",
        nfd: "\u{1D493}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D494}",
        nfc: "\u{1D494}",
        nfd: "\u{1D494}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D495}",
        nfc: "\u{1D495}",
        nfd: "\u{1D495}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D496}",
        nfc: "\u{1D496}",
        nfd: "\u{1D496}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D497}",
        nfc: "\u{1D497}",
        nfd: "\u{1D497}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D498}",
        nfc: "\u{1D498}",
        nfd: "\u{1D498}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D499}",
        nfc: "\u{1D499}",
        nfd: "\u{1D499}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D49A}",
        nfc: "\u{1D49A}",
        nfd: "\u{1D49A}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D49B}",
        nfc: "\u{1D49B}",
        nfd: "\u{1D49B}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D49C}",
        nfc: "\u{1D49C}",
        nfd: "\u{1D49C}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D49E}",
        nfc: "\u{1D49E}",
        nfd: "\u{1D49E}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1D49F}",
        nfc: "\u{1D49F}",
        nfd: "\u{1D49F}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D4A2}",
        nfc: "\u{1D4A2}",
        nfd: "\u{1D4A2}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D4A5}",
        nfc: "\u{1D4A5}",
        nfd: "\u{1D4A5}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D4A6}",
        nfc: "\u{1D4A6}",
        nfd: "\u{1D4A6}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D4A9}",
        nfc: "\u{1D4A9}",
        nfd: "\u{1D4A9}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D4AA}",
        nfc: "\u{1D4AA}",
        nfd: "\u{1D4AA}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D4AB}",
        nfc: "\u{1D4AB}",
        nfd: "\u{1D4AB}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D4AC}",
        nfc: "\u{1D4AC}",
        nfd: "\u{1D4AC}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1D4AE}",
        nfc: "\u{1D4AE}",
        nfd: "\u{1D4AE}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D4AF}",
        nfc: "\u{1D4AF}",
        nfd: "\u{1D4AF}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D4B0}",
        nfc: "\u{1D4B0}",
        nfd: "\u{1D4B0}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D4B1}",
        nfc: "\u{1D4B1}",
        nfd: "\u{1D4B1}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D4B2}",
        nfc: "\u{1D4B2}",
        nfd: "\u{1D4B2}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D4B3}",
        nfc: "\u{1D4B3}",
        nfd: "\u{1D4B3}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D4B4}",
        nfc: "\u{1D4B4}",
        nfd: "\u{1D4B4}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D4B5}",
        nfc: "\u{1D4B5}",
        nfd: "\u{1D4B5}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{1D4B6}",
        nfc: "\u{1D4B6}",
        nfd: "\u{1D4B6}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D4B7}",
        nfc: "\u{1D4B7}",
        nfd: "\u{1D4B7}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D4B8}",
        nfc: "\u{1D4B8}",
        nfd: "\u{1D4B8}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D4B9}",
        nfc: "\u{1D4B9}",
        nfd: "\u{1D4B9}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D4BB}",
        nfc: "\u{1D4BB}",
        nfd: "\u{1D4BB}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D4BD}",
        nfc: "\u{1D4BD}",
        nfd: "\u{1D4BD}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{1D4BE}",
        nfc: "\u{1D4BE}",
        nfd: "\u{1D4BE}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D4BF}",
        nfc: "\u{1D4BF}",
        nfd: "\u{1D4BF}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D4C0}",
        nfc: "\u{1D4C0}",
        nfd: "\u{1D4C0}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D4C1}",
        nfc: "\u{1D4C1}",
        nfd: "\u{1D4C1}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D4C2}",
        nfc: "\u{1D4C2}",
        nfd: "\u{1D4C2}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D4C3}",
        nfc: "\u{1D4C3}",
        nfd: "\u{1D4C3}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D4C5}",
        nfc: "\u{1D4C5}",
        nfd: "\u{1D4C5}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D4C6}",
        nfc: "\u{1D4C6}",
        nfd: "\u{1D4C6}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D4C7}",
        nfc: "\u{1D4C7}",
        nfd: "\u{1D4C7}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D4C8}",
        nfc: "\u{1D4C8}",
        nfd: "\u{1D4C8}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D4C9}",
        nfc: "\u{1D4C9}",
        nfd: "\u{1D4C9}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D4CA}",
        nfc: "\u{1D4CA}",
        nfd: "\u{1D4CA}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D4CB}",
        nfc: "\u{1D4CB}",
        nfd: "\u{1D4CB}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D4CC}",
        nfc: "\u{1D4CC}",
        nfd: "\u{1D4CC}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D4CD}",
        nfc: "\u{1D4CD}",
        nfd: "\u{1D4CD}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D4CE}",
        nfc: "\u{1D4CE}",
        nfd: "\u{1D4CE}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D4CF}",
        nfc: "\u{1D4CF}",
        nfd: "\u{1D4CF}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D4D0}",
        nfc: "\u{1D4D0}",
        nfd: "\u{1D4D0}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D4D1}",
        nfc: "\u{1D4D1}",
        nfd: "\u{1D4D1}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D4D2}",
        nfc: "\u{1D4D2}",
        nfd: "\u{1D4D2}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1D4D3}",
        nfc: "\u{1D4D3}",
        nfd: "\u{1D4D3}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D4D4}",
        nfc: "\u{1D4D4}",
        nfd: "\u{1D4D4}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D4D5}",
        nfc: "\u{1D4D5}",
        nfd: "\u{1D4D5}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1D4D6}",
        nfc: "\u{1D4D6}",
        nfd: "\u{1D4D6}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D4D7}",
        nfc: "\u{1D4D7}",
        nfd: "\u{1D4D7}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{1D4D8}",
        nfc: "\u{1D4D8}",
        nfd: "\u{1D4D8}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1D4D9}",
        nfc: "\u{1D4D9}",
        nfd: "\u{1D4D9}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D4DA}",
        nfc: "\u{1D4DA}",
        nfd: "\u{1D4DA}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D4DB}",
        nfc: "\u{1D4DB}",
        nfd: "\u{1D4DB}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D4DC}",
        nfc: "\u{1D4DC}",
        nfd: "\u{1D4DC}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D4DD}",
        nfc: "\u{1D4DD}",
        nfd: "\u{1D4DD}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D4DE}",
        nfc: "\u{1D4DE}",
        nfd: "\u{1D4DE}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D4DF}",
        nfc: "\u{1D4DF}",
        nfd: "\u{1D4DF}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D4E0}",
        nfc: "\u{1D4E0}",
        nfd: "\u{1D4E0}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1D4E1}",
        nfc: "\u{1D4E1}",
        nfd: "\u{1D4E1}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1D4E2}",
        nfc: "\u{1D4E2}",
        nfd: "\u{1D4E2}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D4E3}",
        nfc: "\u{1D4E3}",
        nfd: "\u{1D4E3}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D4E4}",
        nfc: "\u{1D4E4}",
        nfd: "\u{1D4E4}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D4E5}",
        nfc: "\u{1D4E5}",
        nfd: "\u{1D4E5}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D4E6}",
        nfc: "\u{1D4E6}",
        nfd: "\u{1D4E6}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D4E7}",
        nfc: "\u{1D4E7}",
        nfd: "\u{1D4E7}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D4E8}",
        nfc: "\u{1D4E8}",
        nfd: "\u{1D4E8}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D4E9}",
        nfc: "\u{1D4E9}",
        nfd: "\u{1D4E9}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{1D4EA}",
        nfc: "\u{1D4EA}",
        nfd: "\u{1D4EA}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D4EB}",
        nfc: "\u{1D4EB}",
        nfd: "\u{1D4EB}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D4EC}",
        nfc: "\u{1D4EC}",
        nfd: "\u{1D4EC}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D4ED}",
        nfc: "\u{1D4ED}",
        nfd: "\u{1D4ED}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D4EE}",
        nfc: "\u{1D4EE}",
        nfd: "\u{1D4EE}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D4EF}",
        nfc: "\u{1D4EF}",
        nfd: "\u{1D4EF}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D4F0}",
        nfc: "\u{1D4F0}",
        nfd: "\u{1D4F0}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D4F1}",
        nfc: "\u{1D4F1}",
        nfd: "\u{1D4F1}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{1D4F2}",
        nfc: "\u{1D4F2}",
        nfd: "\u{1D4F2}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D4F3}",
        nfc: "\u{1D4F3}",
        nfd: "\u{1D4F3}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D4F4}",
        nfc: "\u{1D4F4}",
        nfd: "\u{1D4F4}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D4F5}",
        nfc: "\u{1D4F5}",
        nfd: "\u{1D4F5}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D4F6}",
        nfc: "\u{1D4F6}",
        nfd: "\u{1D4F6}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D4F7}",
        nfc: "\u{1D4F7}",
        nfd: "\u{1D4F7}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D4F8}",
        nfc: "\u{1D4F8}",
        nfd: "\u{1D4F8}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D4F9}",
        nfc: "\u{1D4F9}",
        nfd: "\u{1D4F9}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D4FA}",
        nfc: "\u{1D4FA}",
        nfd: "\u{1D4FA}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D4FB}",
        nfc: "\u{1D4FB}",
        nfd: "\u{1D4FB}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D4FC}",
        nfc: "\u{1D4FC}",
        nfd: "\u{1D4FC}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D4FD}",
        nfc: "\u{1D4FD}",
        nfd: "\u{1D4FD}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D4FE}",
        nfc: "\u{1D4FE}",
        nfd: "\u{1D4FE}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D4FF}",
        nfc: "\u{1D4FF}",
        nfd: "\u{1D4FF}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D500}",
        nfc: "\u{1D500}",
        nfd: "\u{1D500}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D501}",
        nfc: "\u{1D501}",
        nfd: "\u{1D501}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D502}",
        nfc: "\u{1D502}",
        nfd: "\u{1D502}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D503}",
        nfc: "\u{1D503}",
        nfd: "\u{1D503}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D504}",
        nfc: "\u{1D504}",
        nfd: "\u{1D504}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D505}",
        nfc: "\u{1D505}",
        nfd: "\u{1D505}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D507}",
        nfc: "\u{1D507}",
        nfd: "\u{1D507}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D508}",
        nfc: "\u{1D508}",
        nfd: "\u{1D508}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D509}",
        nfc: "\u{1D509}",
        nfd: "\u{1D509}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1D50A}",
        nfc: "\u{1D50A}",
        nfd: "\u{1D50A}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D50D}",
        nfc: "\u{1D50D}",
        nfd: "\u{1D50D}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D50E}",
        nfc: "\u{1D50E}",
        nfd: "\u{1D50E}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D50F}",
        nfc: "\u{1D50F}",
        nfd: "\u{1D50F}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D510}",
        nfc: "\u{1D510}",
        nfd: "\u{1D510}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D511}",
        nfc: "\u{1D511}",
        nfd: "\u{1D511}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D512}",
        nfc: "\u{1D512}",
        nfd: "\u{1D512}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D513}",
        nfc: "\u{1D513}",
        nfd: "\u{1D513}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D514}",
        nfc: "\u{1D514}",
        nfd: "\u{1D514}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1D516}",
        nfc: "\u{1D516}",
        nfd: "\u{1D516}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D517}",
        nfc: "\u{1D517}",
        nfd: "\u{1D517}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D518}",
        nfc: "\u{1D518}",
        nfd: "\u{1D518}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D519}",
        nfc: "\u{1D519}",
        nfd: "\u{1D519}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D51A}",
        nfc: "\u{1D51A}",
        nfd: "\u{1D51A}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D51B}",
        nfc: "\u{1D51B}",
        nfd: "\u{1D51B}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D51C}",
        nfc: "\u{1D51C}",
        nfd: "\u{1D51C}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D51E}",
        nfc: "\u{1D51E}",
        nfd: "\u{1D51E}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D51F}",
        nfc: "\u{1D51F}",
        nfd: "\u{1D51F}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D520}",
        nfc: "\u{1D520}",
        nfd: "\u{1D520}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D521}",
        nfc: "\u{1D521}",
        nfd: "\u{1D521}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D522}",
        nfc: "\u{1D522}",
        nfd: "\u{1D522}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D523}",
        nfc: "\u{1D523}",
        nfd: "\u{1D523}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D524}",
        nfc: "\u{1D524}",
        nfd: "\u{1D524}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D525}",
        nfc: "\u{1D525}",
        nfd: "\u{1D525}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{1D526}",
        nfc: "\u{1D526}",
        nfd: "\u{1D526}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D527}",
        nfc: "\u{1D527}",
        nfd: "\u{1D527}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D528}",
        nfc: "\u{1D528}",
        nfd: "\u{1D528}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D529}",
        nfc: "\u{1D529}",
        nfd: "\u{1D529}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D52A}",
        nfc: "\u{1D52A}",
        nfd: "\u{1D52A}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D52B}",
        nfc: "\u{1D52B}",
        nfd: "\u{1D52B}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D52C}",
        nfc: "\u{1D52C}",
        nfd: "\u{1D52C}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D52D}",
        nfc: "\u{1D52D}",
        nfd: "\u{1D52D}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D52E}",
        nfc: "\u{1D52E}",
        nfd: "\u{1D52E}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D52F}",
        nfc: "\u{1D52F}",
        nfd: "\u{1D52F}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D530}",
        nfc: "\u{1D530}",
        nfd: "\u{1D530}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D531}",
        nfc: "\u{1D531}",
        nfd: "\u{1D531}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D532}",
        nfc: "\u{1D532}",
        nfd: "\u{1D532}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D533}",
        nfc: "\u{1D533}",
        nfd: "\u{1D533}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D534}",
        nfc: "\u{1D534}",
        nfd: "\u{1D534}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D535}",
        nfc: "\u{1D535}",
        nfd: "\u{1D535}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D536}",
        nfc: "\u{1D536}",
        nfd: "\u{1D536}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D537}",
        nfc: "\u{1D537}",
        nfd: "\u{1D537}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D538}",
        nfc: "\u{1D538}",
        nfd: "\u{1D538}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D539}",
        nfc: "\u{1D539}",
        nfd: "\u{1D539}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D53B}",
        nfc: "\u{1D53B}",
        nfd: "\u{1D53B}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D53C}",
        nfc: "\u{1D53C}",
        nfd: "\u{1D53C}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D53D}",
        nfc: "\u{1D53D}",
        nfd: "\u{1D53D}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1D53E}",
        nfc: "\u{1D53E}",
        nfd: "\u{1D53E}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D540}",
        nfc: "\u{1D540}",
        nfd: "\u{1D540}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1D541}",
        nfc: "\u{1D541}",
        nfd: "\u{1D541}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D542}",
        nfc: "\u{1D542}",
        nfd: "\u{1D542}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D543}",
        nfc: "\u{1D543}",
        nfd: "\u{1D543}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D544}",
        nfc: "\u{1D544}",
        nfd: "\u{1D544}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D546}",
        nfc: "\u{1D546}",
        nfd: "\u{1D546}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D54A}",
        nfc: "\u{1D54A}",
        nfd: "\u{1D54A}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D54B}",
        nfc: "\u{1D54B}",
        nfd: "\u{1D54B}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D54C}",
        nfc: "\u{1D54C}",
        nfd: "\u{1D54C}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D54D}",
        nfc: "\u{1D54D}",
        nfd: "\u{1D54D}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D54E}",
        nfc: "\u{1D54E}",
        nfd: "\u{1D54E}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D54F}",
        nfc: "\u{1D54F}",
        nfd: "\u{1D54F}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D550}",
        nfc: "\u{1D550}",
        nfd: "\u{1D550}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D552}",
        nfc: "\u{1D552}",
        nfd: "\u{1D552}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D553}",
        nfc: "\u{1D553}",
        nfd: "\u{1D553}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D554}",
        nfc: "\u{1D554}",
        nfd: "\u{1D554}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D555}",
        nfc: "\u{1D555}",
        nfd: "\u{1D555}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D556}",
        nfc: "\u{1D556}",
        nfd: "\u{1D556}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D557}",
        nfc: "\u{1D557}",
        nfd: "\u{1D557}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D558}",
        nfc: "\u{1D558}",
        nfd: "\u{1D558}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D559}",
        nfc: "\u{1D559}",
        nfd: "\u{1D559}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{1D55A}",
        nfc: "\u{1D55A}",
        nfd: "\u{1D55A}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D55B}",
        nfc: "\u{1D55B}",
        nfd: "\u{1D55B}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D55C}",
        nfc: "\u{1D55C}",
        nfd: "\u{1D55C}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D55D}",
        nfc: "\u{1D55D}",
        nfd: "\u{1D55D}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D55E}",
        nfc: "\u{1D55E}",
        nfd: "\u{1D55E}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D55F}",
        nfc: "\u{1D55F}",
        nfd: "\u{1D55F}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D560}",
        nfc: "\u{1D560}",
        nfd: "\u{1D560}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D561}",
        nfc: "\u{1D561}",
        nfd: "\u{1D561}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D562}",
        nfc: "\u{1D562}",
        nfd: "\u{1D562}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D563}",
        nfc: "\u{1D563}",
        nfd: "\u{1D563}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D564}",
        nfc: "\u{1D564}",
        nfd: "\u{1D564}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D565}",
        nfc: "\u{1D565}",
        nfd: "\u{1D565}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D566}",
        nfc: "\u{1D566}",
        nfd: "\u{1D566}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D567}",
        nfc: "\u{1D567}",
        nfd: "\u{1D567}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D568}",
        nfc: "\u{1D568}",
        nfd: "\u{1D568}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D569}",
        nfc: "\u{1D569}",
        nfd: "\u{1D569}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D56A}",
        nfc: "\u{1D56A}",
        nfd: "\u{1D56A}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D56B}",
        nfc: "\u{1D56B}",
        nfd: "\u{1D56B}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D56C}",
        nfc: "\u{1D56C}",
        nfd: "\u{1D56C}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D56D}",
        nfc: "\u{1D56D}",
        nfd: "\u{1D56D}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D56E}",
        nfc: "\u{1D56E}",
        nfd: "\u{1D56E}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1D56F}",
        nfc: "\u{1D56F}",
        nfd: "\u{1D56F}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D570}",
        nfc: "\u{1D570}",
        nfd: "\u{1D570}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D571}",
        nfc: "\u{1D571}",
        nfd: "\u{1D571}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1D572}",
        nfc: "\u{1D572}",
        nfd: "\u{1D572}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D573}",
        nfc: "\u{1D573}",
        nfd: "\u{1D573}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{1D574}",
        nfc: "\u{1D574}",
        nfd: "\u{1D574}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1D575}",
        nfc: "\u{1D575}",
        nfd: "\u{1D575}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D576}",
        nfc: "\u{1D576}",
        nfd: "\u{1D576}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D577}",
        nfc: "\u{1D577}",
        nfd: "\u{1D577}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D578}",
        nfc: "\u{1D578}",
        nfd: "\u{1D578}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D579}",
        nfc: "\u{1D579}",
        nfd: "\u{1D579}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D57A}",
        nfc: "\u{1D57A}",
        nfd: "\u{1D57A}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D57B}",
        nfc: "\u{1D57B}",
        nfd: "\u{1D57B}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D57C}",
        nfc: "\u{1D57C}",
        nfd: "\u{1D57C}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1D57D}",
        nfc: "\u{1D57D}",
        nfd: "\u{1D57D}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1D57E}",
        nfc: "\u{1D57E}",
        nfd: "\u{1D57E}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D57F}",
        nfc: "\u{1D57F}",
        nfd: "\u{1D57F}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D580}",
        nfc: "\u{1D580}",
        nfd: "\u{1D580}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D581}",
        nfc: "\u{1D581}",
        nfd: "\u{1D581}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D582}",
        nfc: "\u{1D582}",
        nfd: "\u{1D582}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D583}",
        nfc: "\u{1D583}",
        nfd: "\u{1D583}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D584}",
        nfc: "\u{1D584}",
        nfd: "\u{1D584}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D585}",
        nfc: "\u{1D585}",
        nfd: "\u{1D585}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{1D586}",
        nfc: "\u{1D586}",
        nfd: "\u{1D586}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D587}",
        nfc: "\u{1D587}",
        nfd: "\u{1D587}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D588}",
        nfc: "\u{1D588}",
        nfd: "\u{1D588}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D589}",
        nfc: "\u{1D589}",
        nfd: "\u{1D589}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D58A}",
        nfc: "\u{1D58A}",
        nfd: "\u{1D58A}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D58B}",
        nfc: "\u{1D58B}",
        nfd: "\u{1D58B}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D58C}",
        nfc: "\u{1D58C}",
        nfd: "\u{1D58C}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D58D}",
        nfc: "\u{1D58D}",
        nfd: "\u{1D58D}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{1D58E}",
        nfc: "\u{1D58E}",
        nfd: "\u{1D58E}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D58F}",
        nfc: "\u{1D58F}",
        nfd: "\u{1D58F}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D590}",
        nfc: "\u{1D590}",
        nfd: "\u{1D590}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D591}",
        nfc: "\u{1D591}",
        nfd: "\u{1D591}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D592}",
        nfc: "\u{1D592}",
        nfd: "\u{1D592}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D593}",
        nfc: "\u{1D593}",
        nfd: "\u{1D593}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D594}",
        nfc: "\u{1D594}",
        nfd: "\u{1D594}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D595}",
        nfc: "\u{1D595}",
        nfd: "\u{1D595}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D596}",
        nfc: "\u{1D596}",
        nfd: "\u{1D596}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D597}",
        nfc: "\u{1D597}",
        nfd: "\u{1D597}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D598}",
        nfc: "\u{1D598}",
        nfd: "\u{1D598}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D599}",
        nfc: "\u{1D599}",
        nfd: "\u{1D599}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D59A}",
        nfc: "\u{1D59A}",
        nfd: "\u{1D59A}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D59B}",
        nfc: "\u{1D59B}",
        nfd: "\u{1D59B}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D59C}",
        nfc: "\u{1D59C}",
        nfd: "\u{1D59C}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D59D}",
        nfc: "\u{1D59D}",
        nfd: "\u{1D59D}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D59E}",
        nfc: "\u{1D59E}",
        nfd: "\u{1D59E}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D59F}",
        nfc: "\u{1D59F}",
        nfd: "\u{1D59F}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D5A0}",
        nfc: "\u{1D5A0}",
        nfd: "\u{1D5A0}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D5A1}",
        nfc: "\u{1D5A1}",
        nfd: "\u{1D5A1}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D5A2}",
        nfc: "\u{1D5A2}",
        nfd: "\u{1D5A2}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1D5A3}",
        nfc: "\u{1D5A3}",
        nfd: "\u{1D5A3}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D5A4}",
        nfc: "\u{1D5A4}",
        nfd: "\u{1D5A4}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D5A5}",
        nfc: "\u{1D5A5}",
        nfd: "\u{1D5A5}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1D5A6}",
        nfc: "\u{1D5A6}",
        nfd: "\u{1D5A6}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D5A7}",
        nfc: "\u{1D5A7}",
        nfd: "\u{1D5A7}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{1D5A8}",
        nfc: "\u{1D5A8}",
        nfd: "\u{1D5A8}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1D5A9}",
        nfc: "\u{1D5A9}",
        nfd: "\u{1D5A9}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D5AA}",
        nfc: "\u{1D5AA}",
        nfd: "\u{1D5AA}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D5AB}",
        nfc: "\u{1D5AB}",
        nfd: "\u{1D5AB}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D5AC}",
        nfc: "\u{1D5AC}",
        nfd: "\u{1D5AC}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D5AD}",
        nfc: "\u{1D5AD}",
        nfd: "\u{1D5AD}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D5AE}",
        nfc: "\u{1D5AE}",
        nfd: "\u{1D5AE}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D5AF}",
        nfc: "\u{1D5AF}",
        nfd: "\u{1D5AF}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D5B0}",
        nfc: "\u{1D5B0}",
        nfd: "\u{1D5B0}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1D5B1}",
        nfc: "\u{1D5B1}",
        nfd: "\u{1D5B1}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1D5B2}",
        nfc: "\u{1D5B2}",
        nfd: "\u{1D5B2}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D5B3}",
        nfc: "\u{1D5B3}",
        nfd: "\u{1D5B3}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D5B4}",
        nfc: "\u{1D5B4}",
        nfd: "\u{1D5B4}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D5B5}",
        nfc: "\u{1D5B5}",
        nfd: "\u{1D5B5}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D5B6}",
        nfc: "\u{1D5B6}",
        nfd: "\u{1D5B6}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D5B7}",
        nfc: "\u{1D5B7}",
        nfd: "\u{1D5B7}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D5B8}",
        nfc: "\u{1D5B8}",
        nfd: "\u{1D5B8}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D5B9}",
        nfc: "\u{1D5B9}",
        nfd: "\u{1D5B9}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{1D5BA}",
        nfc: "\u{1D5BA}",
        nfd: "\u{1D5BA}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D5BB}",
        nfc: "\u{1D5BB}",
        nfd: "\u{1D5BB}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D5BC}",
        nfc: "\u{1D5BC}",
        nfd: "\u{1D5BC}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D5BD}",
        nfc: "\u{1D5BD}",
        nfd: "\u{1D5BD}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D5BE}",
        nfc: "\u{1D5BE}",
        nfd: "\u{1D5BE}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D5BF}",
        nfc: "\u{1D5BF}",
        nfd: "\u{1D5BF}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D5C0}",
        nfc: "\u{1D5C0}",
        nfd: "\u{1D5C0}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D5C1}",
        nfc: "\u{1D5C1}",
        nfd: "\u{1D5C1}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{1D5C2}",
        nfc: "\u{1D5C2}",
        nfd: "\u{1D5C2}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D5C3}",
        nfc: "\u{1D5C3}",
        nfd: "\u{1D5C3}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D5C4}",
        nfc: "\u{1D5C4}",
        nfd: "\u{1D5C4}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D5C5}",
        nfc: "\u{1D5C5}",
        nfd: "\u{1D5C5}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D5C6}",
        nfc: "\u{1D5C6}",
        nfd: "\u{1D5C6}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D5C7}",
        nfc: "\u{1D5C7}",
        nfd: "\u{1D5C7}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D5C8}",
        nfc: "\u{1D5C8}",
        nfd: "\u{1D5C8}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D5C9}",
        nfc: "\u{1D5C9}",
        nfd: "\u{1D5C9}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D5CA}",
        nfc: "\u{1D5CA}",
        nfd: "\u{1D5CA}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D5CB}",
        nfc: "\u{1D5CB}",
        nfd: "\u{1D5CB}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D5CC}",
        nfc: "\u{1D5CC}",
        nfd: "\u{1D5CC}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D5CD}",
        nfc: "\u{1D5CD}",
        nfd: "\u{1D5CD}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D5CE}",
        nfc: "\u{1D5CE}",
        nfd: "\u{1D5CE}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D5CF}",
        nfc: "\u{1D5CF}",
        nfd: "\u{1D5CF}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D5D0}",
        nfc: "\u{1D5D0}",
        nfd: "\u{1D5D0}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D5D1}",
        nfc: "\u{1D5D1}",
        nfd: "\u{1D5D1}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D5D2}",
        nfc: "\u{1D5D2}",
        nfd: "\u{1D5D2}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D5D3}",
        nfc: "\u{1D5D3}",
        nfd: "\u{1D5D3}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D5D4}",
        nfc: "\u{1D5D4}",
        nfd: "\u{1D5D4}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D5D5}",
        nfc: "\u{1D5D5}",
        nfd: "\u{1D5D5}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D5D6}",
        nfc: "\u{1D5D6}",
        nfd: "\u{1D5D6}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1D5D7}",
        nfc: "\u{1D5D7}",
        nfd: "\u{1D5D7}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D5D8}",
        nfc: "\u{1D5D8}",
        nfd: "\u{1D5D8}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D5D9}",
        nfc: "\u{1D5D9}",
        nfd: "\u{1D5D9}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1D5DA}",
        nfc: "\u{1D5DA}",
        nfd: "\u{1D5DA}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D5DB}",
        nfc: "\u{1D5DB}",
        nfd: "\u{1D5DB}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{1D5DC}",
        nfc: "\u{1D5DC}",
        nfd: "\u{1D5DC}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1D5DD}",
        nfc: "\u{1D5DD}",
        nfd: "\u{1D5DD}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D5DE}",
        nfc: "\u{1D5DE}",
        nfd: "\u{1D5DE}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D5DF}",
        nfc: "\u{1D5DF}",
        nfd: "\u{1D5DF}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D5E0}",
        nfc: "\u{1D5E0}",
        nfd: "\u{1D5E0}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D5E1}",
        nfc: "\u{1D5E1}",
        nfd: "\u{1D5E1}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D5E2}",
        nfc: "\u{1D5E2}",
        nfd: "\u{1D5E2}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D5E3}",
        nfc: "\u{1D5E3}",
        nfd: "\u{1D5E3}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D5E4}",
        nfc: "\u{1D5E4}",
        nfd: "\u{1D5E4}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1D5E5}",
        nfc: "\u{1D5E5}",
        nfd: "\u{1D5E5}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1D5E6}",
        nfc: "\u{1D5E6}",
        nfd: "\u{1D5E6}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D5E7}",
        nfc: "\u{1D5E7}",
        nfd: "\u{1D5E7}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D5E8}",
        nfc: "\u{1D5E8}",
        nfd: "\u{1D5E8}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D5E9}",
        nfc: "\u{1D5E9}",
        nfd: "\u{1D5E9}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D5EA}",
        nfc: "\u{1D5EA}",
        nfd: "\u{1D5EA}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D5EB}",
        nfc: "\u{1D5EB}",
        nfd: "\u{1D5EB}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D5EC}",
        nfc: "\u{1D5EC}",
        nfd: "\u{1D5EC}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D5ED}",
        nfc: "\u{1D5ED}",
        nfd: "\u{1D5ED}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{1D5EE}",
        nfc: "\u{1D5EE}",
        nfd: "\u{1D5EE}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D5EF}",
        nfc: "\u{1D5EF}",
        nfd: "\u{1D5EF}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D5F0}",
        nfc: "\u{1D5F0}",
        nfd: "\u{1D5F0}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D5F1}",
        nfc: "\u{1D5F1}",
        nfd: "\u{1D5F1}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D5F2}",
        nfc: "\u{1D5F2}",
        nfd: "\u{1D5F2}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D5F3}",
        nfc: "\u{1D5F3}",
        nfd: "\u{1D5F3}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D5F4}",
        nfc: "\u{1D5F4}",
        nfd: "\u{1D5F4}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D5F5}",
        nfc: "\u{1D5F5}",
        nfd: "\u{1D5F5}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{1D5F6}",
        nfc: "\u{1D5F6}",
        nfd: "\u{1D5F6}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D5F7}",
        nfc: "\u{1D5F7}",
        nfd: "\u{1D5F7}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D5F8}",
        nfc: "\u{1D5F8}",
        nfd: "\u{1D5F8}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D5F9}",
        nfc: "\u{1D5F9}",
        nfd: "\u{1D5F9}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D5FA}",
        nfc: "\u{1D5FA}",
        nfd: "\u{1D5FA}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D5FB}",
        nfc: "\u{1D5FB}",
        nfd: "\u{1D5FB}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D5FC}",
        nfc: "\u{1D5FC}",
        nfd: "\u{1D5FC}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D5FD}",
        nfc: "\u{1D5FD}",
        nfd: "\u{1D5FD}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D5FE}",
        nfc: "\u{1D5FE}",
        nfd: "\u{1D5FE}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D5FF}",
        nfc: "\u{1D5FF}",
        nfd: "\u{1D5FF}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D600}",
        nfc: "\u{1D600}",
        nfd: "\u{1D600}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D601}",
        nfc: "\u{1D601}",
        nfd: "\u{1D601}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D602}",
        nfc: "\u{1D602}",
        nfd: "\u{1D602}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D603}",
        nfc: "\u{1D603}",
        nfd: "\u{1D603}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D604}",
        nfc: "\u{1D604}",
        nfd: "\u{1D604}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D605}",
        nfc: "\u{1D605}",
        nfd: "\u{1D605}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D606}",
        nfc: "\u{1D606}",
        nfd: "\u{1D606}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D607}",
        nfc: "\u{1D607}",
        nfd: "\u{1D607}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D608}",
        nfc: "\u{1D608}",
        nfd: "\u{1D608}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D609}",
        nfc: "\u{1D609}",
        nfd: "\u{1D609}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D60A}",
        nfc: "\u{1D60A}",
        nfd: "\u{1D60A}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1D60B}",
        nfc: "\u{1D60B}",
        nfd: "\u{1D60B}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D60C}",
        nfc: "\u{1D60C}",
        nfd: "\u{1D60C}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D60D}",
        nfc: "\u{1D60D}",
        nfd: "\u{1D60D}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1D60E}",
        nfc: "\u{1D60E}",
        nfd: "\u{1D60E}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D60F}",
        nfc: "\u{1D60F}",
        nfd: "\u{1D60F}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{1D610}",
        nfc: "\u{1D610}",
        nfd: "\u{1D610}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1D611}",
        nfc: "\u{1D611}",
        nfd: "\u{1D611}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D612}",
        nfc: "\u{1D612}",
        nfd: "\u{1D612}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D613}",
        nfc: "\u{1D613}",
        nfd: "\u{1D613}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D614}",
        nfc: "\u{1D614}",
        nfd: "\u{1D614}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D615}",
        nfc: "\u{1D615}",
        nfd: "\u{1D615}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D616}",
        nfc: "\u{1D616}",
        nfd: "\u{1D616}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D617}",
        nfc: "\u{1D617}",
        nfd: "\u{1D617}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D618}",
        nfc: "\u{1D618}",
        nfd: "\u{1D618}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1D619}",
        nfc: "\u{1D619}",
        nfd: "\u{1D619}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1D61A}",
        nfc: "\u{1D61A}",
        nfd: "\u{1D61A}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D61B}",
        nfc: "\u{1D61B}",
        nfd: "\u{1D61B}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D61C}",
        nfc: "\u{1D61C}",
        nfd: "\u{1D61C}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D61D}",
        nfc: "\u{1D61D}",
        nfd: "\u{1D61D}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D61E}",
        nfc: "\u{1D61E}",
        nfd: "\u{1D61E}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D61F}",
        nfc: "\u{1D61F}",
        nfd: "\u{1D61F}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D620}",
        nfc: "\u{1D620}",
        nfd: "\u{1D620}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D621}",
        nfc: "\u{1D621}",
        nfd: "\u{1D621}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{1D622}",
        nfc: "\u{1D622}",
        nfd: "\u{1D622}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D623}",
        nfc: "\u{1D623}",
        nfd: "\u{1D623}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D624}",
        nfc: "\u{1D624}",
        nfd: "\u{1D624}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D625}",
        nfc: "\u{1D625}",
        nfd: "\u{1D625}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D626}",
        nfc: "\u{1D626}",
        nfd: "\u{1D626}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D627}",
        nfc: "\u{1D627}",
        nfd: "\u{1D627}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D628}",
        nfc: "\u{1D628}",
        nfd: "\u{1D628}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D629}",
        nfc: "\u{1D629}",
        nfd: "\u{1D629}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{1D62A}",
        nfc: "\u{1D62A}",
        nfd: "\u{1D62A}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D62B}",
        nfc: "\u{1D62B}",
        nfd: "\u{1D62B}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D62C}",
        nfc: "\u{1D62C}",
        nfd: "\u{1D62C}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D62D}",
        nfc: "\u{1D62D}",
        nfd: "\u{1D62D}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D62E}",
        nfc: "\u{1D62E}",
        nfd: "\u{1D62E}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D62F}",
        nfc: "\u{1D62F}",
        nfd: "\u{1D62F}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D630}",
        nfc: "\u{1D630}",
        nfd: "\u{1D630}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D631}",
        nfc: "\u{1D631}",
        nfd: "\u{1D631}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D632}",
        nfc: "\u{1D632}",
        nfd: "\u{1D632}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D633}",
        nfc: "\u{1D633}",
        nfd: "\u{1D633}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D634}",
        nfc: "\u{1D634}",
        nfd: "\u{1D634}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D635}",
        nfc: "\u{1D635}",
        nfd: "\u{1D635}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D636}",
        nfc: "\u{1D636}",
        nfd: "\u{1D636}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D637}",
        nfc: "\u{1D637}",
        nfd: "\u{1D637}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D638}",
        nfc: "\u{1D638}",
        nfd: "\u{1D638}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D639}",
        nfc: "\u{1D639}",
        nfd: "\u{1D639}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D63A}",
        nfc: "\u{1D63A}",
        nfd: "\u{1D63A}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D63B}",
        nfc: "\u{1D63B}",
        nfd: "\u{1D63B}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D63C}",
        nfc: "\u{1D63C}",
        nfd: "\u{1D63C}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D63D}",
        nfc: "\u{1D63D}",
        nfd: "\u{1D63D}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D63E}",
        nfc: "\u{1D63E}",
        nfd: "\u{1D63E}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1D63F}",
        nfc: "\u{1D63F}",
        nfd: "\u{1D63F}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D640}",
        nfc: "\u{1D640}",
        nfd: "\u{1D640}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D641}",
        nfc: "\u{1D641}",
        nfd: "\u{1D641}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1D642}",
        nfc: "\u{1D642}",
        nfd: "\u{1D642}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D643}",
        nfc: "\u{1D643}",
        nfd: "\u{1D643}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{1D644}",
        nfc: "\u{1D644}",
        nfd: "\u{1D644}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1D645}",
        nfc: "\u{1D645}",
        nfd: "\u{1D645}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D646}",
        nfc: "\u{1D646}",
        nfd: "\u{1D646}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D647}",
        nfc: "\u{1D647}",
        nfd: "\u{1D647}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D648}",
        nfc: "\u{1D648}",
        nfd: "\u{1D648}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D649}",
        nfc: "\u{1D649}",
        nfd: "\u{1D649}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D64A}",
        nfc: "\u{1D64A}",
        nfd: "\u{1D64A}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D64B}",
        nfc: "\u{1D64B}",
        nfd: "\u{1D64B}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D64C}",
        nfc: "\u{1D64C}",
        nfd: "\u{1D64C}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1D64D}",
        nfc: "\u{1D64D}",
        nfd: "\u{1D64D}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1D64E}",
        nfc: "\u{1D64E}",
        nfd: "\u{1D64E}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D64F}",
        nfc: "\u{1D64F}",
        nfd: "\u{1D64F}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D650}",
        nfc: "\u{1D650}",
        nfd: "\u{1D650}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D651}",
        nfc: "\u{1D651}",
        nfd: "\u{1D651}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D652}",
        nfc: "\u{1D652}",
        nfd: "\u{1D652}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D653}",
        nfc: "\u{1D653}",
        nfd: "\u{1D653}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D654}",
        nfc: "\u{1D654}",
        nfd: "\u{1D654}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D655}",
        nfc: "\u{1D655}",
        nfd: "\u{1D655}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{1D656}",
        nfc: "\u{1D656}",
        nfd: "\u{1D656}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D657}",
        nfc: "\u{1D657}",
        nfd: "\u{1D657}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D658}",
        nfc: "\u{1D658}",
        nfd: "\u{1D658}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D659}",
        nfc: "\u{1D659}",
        nfd: "\u{1D659}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D65A}",
        nfc: "\u{1D65A}",
        nfd: "\u{1D65A}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D65B}",
        nfc: "\u{1D65B}",
        nfd: "\u{1D65B}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D65C}",
        nfc: "\u{1D65C}",
        nfd: "\u{1D65C}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D65D}",
        nfc: "\u{1D65D}",
        nfd: "\u{1D65D}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{1D65E}",
        nfc: "\u{1D65E}",
        nfd: "\u{1D65E}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D65F}",
        nfc: "\u{1D65F}",
        nfd: "\u{1D65F}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D660}",
        nfc: "\u{1D660}",
        nfd: "\u{1D660}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D661}",
        nfc: "\u{1D661}",
        nfd: "\u{1D661}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D662}",
        nfc: "\u{1D662}",
        nfd: "\u{1D662}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D663}",
        nfc: "\u{1D663}",
        nfd: "\u{1D663}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D664}",
        nfc: "\u{1D664}",
        nfd: "\u{1D664}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D665}",
        nfc: "\u{1D665}",
        nfd: "\u{1D665}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D666}",
        nfc: "\u{1D666}",
        nfd: "\u{1D666}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D667}",
        nfc: "\u{1D667}",
        nfd: "\u{1D667}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D668}",
        nfc: "\u{1D668}",
        nfd: "\u{1D668}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D669}",
        nfc: "\u{1D669}",
        nfd: "\u{1D669}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D66A}",
        nfc: "\u{1D66A}",
        nfd: "\u{1D66A}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D66B}",
        nfc: "\u{1D66B}",
        nfd: "\u{1D66B}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D66C}",
        nfc: "\u{1D66C}",
        nfd: "\u{1D66C}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D66D}",
        nfc: "\u{1D66D}",
        nfd: "\u{1D66D}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D66E}",
        nfc: "\u{1D66E}",
        nfd: "\u{1D66E}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D66F}",
        nfc: "\u{1D66F}",
        nfd: "\u{1D66F}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D670}",
        nfc: "\u{1D670}",
        nfd: "\u{1D670}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1D671}",
        nfc: "\u{1D671}",
        nfd: "\u{1D671}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1D672}",
        nfc: "\u{1D672}",
        nfd: "\u{1D672}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1D673}",
        nfc: "\u{1D673}",
        nfd: "\u{1D673}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1D674}",
        nfc: "\u{1D674}",
        nfd: "\u{1D674}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1D675}",
        nfc: "\u{1D675}",
        nfd: "\u{1D675}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1D676}",
        nfc: "\u{1D676}",
        nfd: "\u{1D676}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1D677}",
        nfc: "\u{1D677}",
        nfd: "\u{1D677}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{1D678}",
        nfc: "\u{1D678}",
        nfd: "\u{1D678}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1D679}",
        nfc: "\u{1D679}",
        nfd: "\u{1D679}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1D67A}",
        nfc: "\u{1D67A}",
        nfd: "\u{1D67A}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1D67B}",
        nfc: "\u{1D67B}",
        nfd: "\u{1D67B}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1D67C}",
        nfc: "\u{1D67C}",
        nfd: "\u{1D67C}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1D67D}",
        nfc: "\u{1D67D}",
        nfd: "\u{1D67D}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1D67E}",
        nfc: "\u{1D67E}",
        nfd: "\u{1D67E}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1D67F}",
        nfc: "\u{1D67F}",
        nfd: "\u{1D67F}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1D680}",
        nfc: "\u{1D680}",
        nfd: "\u{1D680}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1D681}",
        nfc: "\u{1D681}",
        nfd: "\u{1D681}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1D682}",
        nfc: "\u{1D682}",
        nfd: "\u{1D682}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1D683}",
        nfc: "\u{1D683}",
        nfd: "\u{1D683}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1D684}",
        nfc: "\u{1D684}",
        nfd: "\u{1D684}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1D685}",
        nfc: "\u{1D685}",
        nfd: "\u{1D685}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1D686}",
        nfc: "\u{1D686}",
        nfd: "\u{1D686}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1D687}",
        nfc: "\u{1D687}",
        nfd: "\u{1D687}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1D688}",
        nfc: "\u{1D688}",
        nfd: "\u{1D688}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1D689}",
        nfc: "\u{1D689}",
        nfd: "\u{1D689}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{1D68A}",
        nfc: "\u{1D68A}",
        nfd: "\u{1D68A}",
        nfkc: "\u{0061}",
        nfkd: "\u{0061}",
    },
    NormalizationTest {
        source: "\u{1D68B}",
        nfc: "\u{1D68B}",
        nfd: "\u{1D68B}",
        nfkc: "\u{0062}",
        nfkd: "\u{0062}",
    },
    NormalizationTest {
        source: "\u{1D68C}",
        nfc: "\u{1D68C}",
        nfd: "\u{1D68C}",
        nfkc: "\u{0063}",
        nfkd: "\u{0063}",
    },
    NormalizationTest {
        source: "\u{1D68D}",
        nfc: "\u{1D68D}",
        nfd: "\u{1D68D}",
        nfkc: "\u{0064}",
        nfkd: "\u{0064}",
    },
    NormalizationTest {
        source: "\u{1D68E}",
        nfc: "\u{1D68E}",
        nfd: "\u{1D68E}",
        nfkc: "\u{0065}",
        nfkd: "\u{0065}",
    },
    NormalizationTest {
        source: "\u{1D68F}",
        nfc: "\u{1D68F}",
        nfd: "\u{1D68F}",
        nfkc: "\u{0066}",
        nfkd: "\u{0066}",
    },
    NormalizationTest {
        source: "\u{1D690}",
        nfc: "\u{1D690}",
        nfd: "\u{1D690}",
        nfkc: "\u{0067}",
        nfkd: "\u{0067}",
    },
    NormalizationTest {
        source: "\u{1D691}",
        nfc: "\u{1D691}",
        nfd: "\u{1D691}",
        nfkc: "\u{0068}",
        nfkd: "\u{0068}",
    },
    NormalizationTest {
        source: "\u{1D692}",
        nfc: "\u{1D692}",
        nfd: "\u{1D692}",
        nfkc: "\u{0069}",
        nfkd: "\u{0069}",
    },
    NormalizationTest {
        source: "\u{1D693}",
        nfc: "\u{1D693}",
        nfd: "\u{1D693}",
        nfkc: "\u{006A}",
        nfkd: "\u{006A}",
    },
    NormalizationTest {
        source: "\u{1D694}",
        nfc: "\u{1D694}",
        nfd: "\u{1D694}",
        nfkc: "\u{006B}",
        nfkd: "\u{006B}",
    },
    NormalizationTest {
        source: "\u{1D695}",
        nfc: "\u{1D695}",
        nfd: "\u{1D695}",
        nfkc: "\u{006C}",
        nfkd: "\u{006C}",
    },
    NormalizationTest {
        source: "\u{1D696}",
        nfc: "\u{1D696}",
        nfd: "\u{1D696}",
        nfkc: "\u{006D}",
        nfkd: "\u{006D}",
    },
    NormalizationTest {
        source: "\u{1D697}",
        nfc: "\u{1D697}",
        nfd: "\u{1D697}",
        nfkc: "\u{006E}",
        nfkd: "\u{006E}",
    },
    NormalizationTest {
        source: "\u{1D698}",
        nfc: "\u{1D698}",
        nfd: "\u{1D698}",
        nfkc: "\u{006F}",
        nfkd: "\u{006F}",
    },
    NormalizationTest {
        source: "\u{1D699}",
        nfc: "\u{1D699}",
        nfd: "\u{1D699}",
        nfkc: "\u{0070}",
        nfkd: "\u{0070}",
    },
    NormalizationTest {
        source: "\u{1D69A}",
        nfc: "\u{1D69A}",
        nfd: "\u{1D69A}",
        nfkc: "\u{0071}",
        nfkd: "\u{0071}",
    },
    NormalizationTest {
        source: "\u{1D69B}",
        nfc: "\u{1D69B}",
        nfd: "\u{1D69B}",
        nfkc: "\u{0072}",
        nfkd: "\u{0072}",
    },
    NormalizationTest {
        source: "\u{1D69C}",
        nfc: "\u{1D69C}",
        nfd: "\u{1D69C}",
        nfkc: "\u{0073}",
        nfkd: "\u{0073}",
    },
    NormalizationTest {
        source: "\u{1D69D}",
        nfc: "\u{1D69D}",
        nfd: "\u{1D69D}",
        nfkc: "\u{0074}",
        nfkd: "\u{0074}",
    },
    NormalizationTest {
        source: "\u{1D69E}",
        nfc: "\u{1D69E}",
        nfd: "\u{1D69E}",
        nfkc: "\u{0075}",
        nfkd: "\u{0075}",
    },
    NormalizationTest {
        source: "\u{1D69F}",
        nfc: "\u{1D69F}",
        nfd: "\u{1D69F}",
        nfkc: "\u{0076}",
        nfkd: "\u{0076}",
    },
    NormalizationTest {
        source: "\u{1D6A0}",
        nfc: "\u{1D6A0}",
        nfd: "\u{1D6A0}",
        nfkc: "\u{0077}",
        nfkd: "\u{0077}",
    },
    NormalizationTest {
        source: "\u{1D6A1}",
        nfc: "\u{1D6A1}",
        nfd: "\u{1D6A1}",
        nfkc: "\u{0078}",
        nfkd: "\u{0078}",
    },
    NormalizationTest {
        source: "\u{1D6A2}",
        nfc: "\u{1D6A2}",
        nfd: "\u{1D6A2}",
        nfkc: "\u{0079}",
        nfkd: "\u{0079}",
    },
    NormalizationTest {
        source: "\u{1D6A3}",
        nfc: "\u{1D6A3}",
        nfd: "\u{1D6A3}",
        nfkc: "\u{007A}",
        nfkd: "\u{007A}",
    },
    NormalizationTest {
        source: "\u{1D6A4}",
        nfc: "\u{1D6A4}",
        nfd: "\u{1D6A4}",
        nfkc: "\u{0131}",
        nfkd: "\u{0131}",
    },
    NormalizationTest {
        source: "\u{1D6A5}",
        nfc: "\u{1D6A5}",
        nfd: "\u{1D6A5}",
        nfkc: "\u{0237}",
        nfkd: "\u{0237}",
    },
    NormalizationTest {
        source: "\u{1D6A8}",
        nfc: "\u{1D6A8}",
        nfd: "\u{1D6A8}",
        nfkc: "\u{0391}",
        nfkd: "\u{0391}",
    },
    NormalizationTest {
        source: "\u{1D6A9}",
        nfc: "\u{1D6A9}",
        nfd: "\u{1D6A9}",
        nfkc: "\u{0392}",
        nfkd: "\u{0392}",
    },
    NormalizationTest {
        source: "\u{1D6AA}",
        nfc: "\u{1D6AA}",
        nfd: "\u{1D6AA}",
        nfkc: "\u{0393}",
        nfkd: "\u{0393}",
    },
    NormalizationTest {
        source: "\u{1D6AB}",
        nfc: "\u{1D6AB}",
        nfd: "\u{1D6AB}",
        nfkc: "\u{0394}",
        nfkd: "\u{0394}",
    },
    NormalizationTest {
        source: "\u{1D6AC}",
        nfc: "\u{1D6AC}",
        nfd: "\u{1D6AC}",
        nfkc: "\u{0395}",
        nfkd: "\u{0395}",
    },
    NormalizationTest {
        source: "\u{1D6AD}",
        nfc: "\u{1D6AD}",
        nfd: "\u{1D6AD}",
        nfkc: "\u{0396}",
        nfkd: "\u{0396}",
    },
    NormalizationTest {
        source: "\u{1D6AE}",
        nfc: "\u{1D6AE}",
        nfd: "\u{1D6AE}",
        nfkc: "\u{0397}",
        nfkd: "\u{0397}",
    },
    NormalizationTest {
        source: "\u{1D6AF}",
        nfc: "\u{1D6AF}",
        nfd: "\u{1D6AF}",
        nfkc: "\u{0398}",
        nfkd: "\u{0398}",
    },
    NormalizationTest {
        source: "\u{1D6B0}",
        nfc: "\u{1D6B0}",
        nfd: "\u{1D6B0}",
        nfkc: "\u{0399}",
        nfkd: "\u{0399}",
    },
    NormalizationTest {
        source: "\u{1D6B1}",
        nfc: "\u{1D6B1}",
        nfd: "\u{1D6B1}",
        nfkc: "\u{039A}",
        nfkd: "\u{039A}",
    },
    NormalizationTest {
        source: "\u{1D6B2}",
        nfc: "\u{1D6B2}",
        nfd: "\u{1D6B2}",
        nfkc: "\u{039B}",
        nfkd: "\u{039B}",
    },
    NormalizationTest {
        source: "\u{1D6B3}",
        nfc: "\u{1D6B3}",
        nfd: "\u{1D6B3}",
        nfkc: "\u{039C}",
        nfkd: "\u{039C}",
    },
    NormalizationTest {
        source: "\u{1D6B4}",
        nfc: "\u{1D6B4}",
        nfd: "\u{1D6B4}",
        nfkc: "\u{039D}",
        nfkd: "\u{039D}",
    },
    NormalizationTest {
        source: "\u{1D6B5}",
        nfc: "\u{1D6B5}",
        nfd: "\u{1D6B5}",
        nfkc: "\u{039E}",
        nfkd: "\u{039E}",
    },
    NormalizationTest {
        source: "\u{1D6B6}",
        nfc: "\u{1D6B6}",
        nfd: "\u{1D6B6}",
        nfkc: "\u{039F}",
        nfkd: "\u{039F}",
    },
    NormalizationTest {
        source: "\u{1D6B7}",
        nfc: "\u{1D6B7}",
        nfd: "\u{1D6B7}",
        nfkc: "\u{03A0}",
        nfkd: "\u{03A0}",
    },
    NormalizationTest {
        source: "\u{1D6B8}",
        nfc: "\u{1D6B8}",
        nfd: "\u{1D6B8}",
        nfkc: "\u{03A1}",
        nfkd: "\u{03A1}",
    },
    NormalizationTest {
        source: "\u{1D6B9}",
        nfc: "\u{1D6B9}",
        nfd: "\u{1D6B9}",
        nfkc: "\u{0398}",
        nfkd: "\u{0398}",
    },
    NormalizationTest {
        source: "\u{1D6BA}",
        nfc: "\u{1D6BA}",
        nfd: "\u{1D6BA}",
        nfkc: "\u{03A3}",
        nfkd: "\u{03A3}",
    },
    NormalizationTest {
        source: "\u{1D6BB}",
        nfc: "\u{1D6BB}",
        nfd: "\u{1D6BB}",
        nfkc: "\u{03A4}",
        nfkd: "\u{03A4}",
    },
    NormalizationTest {
        source: "\u{1D6BC}",
        nfc: "\u{1D6BC}",
        nfd: "\u{1D6BC}",
        nfkc: "\u{03A5}",
        nfkd: "\u{03A5}",
    },
    NormalizationTest {
        source: "\u{1D6BD}",
        nfc: "\u{1D6BD}",
        nfd: "\u{1D6BD}",
        nfkc: "\u{03A6}",
        nfkd: "\u{03A6}",
    },
    NormalizationTest {
        source: "\u{1D6BE}",
        nfc: "\u{1D6BE}",
        nfd: "\u{1D6BE}",
        nfkc: "\u{03A7}",
        nfkd: "\u{03A7}",
    },
    NormalizationTest {
        source: "\u{1D6BF}",
        nfc: "\u{1D6BF}",
        nfd: "\u{1D6BF}",
        nfkc: "\u{03A8}",
        nfkd: "\u{03A8}",
    },
    NormalizationTest {
        source: "\u{1D6C0}",
        nfc: "\u{1D6C0}",
        nfd: "\u{1D6C0}",
        nfkc: "\u{03A9}",
        nfkd: "\u{03A9}",
    },
    NormalizationTest {
        source: "\u{1D6C1}",
        nfc: "\u{1D6C1}",
        nfd: "\u{1D6C1}",
        nfkc: "\u{2207}",
        nfkd: "\u{2207}",
    },
    NormalizationTest {
        source: "\u{1D6C2}",
        nfc: "\u{1D6C2}",
        nfd: "\u{1D6C2}",
        nfkc: "\u{03B1}",
        nfkd: "\u{03B1}",
    },
    NormalizationTest {
        source: "\u{1D6C3}",
        nfc: "\u{1D6C3}",
        nfd: "\u{1D6C3}",
        nfkc: "\u{03B2}",
        nfkd: "\u{03B2}",
    },
    NormalizationTest {
        source: "\u{1D6C4}",
        nfc: "\u{1D6C4}",
        nfd: "\u{1D6C4}",
        nfkc: "\u{03B3}",
        nfkd: "\u{03B3}",
    },
    NormalizationTest {
        source: "\u{1D6C5}",
        nfc: "\u{1D6C5}",
        nfd: "\u{1D6C5}",
        nfkc: "\u{03B4}",
        nfkd: "\u{03B4}",
    },
    NormalizationTest {
        source: "\u{1D6C6}",
        nfc: "\u{1D6C6}",
        nfd: "\u{1D6C6}",
        nfkc: "\u{03B5}",
        nfkd: "\u{03B5}",
    },
    NormalizationTest {
        source: "\u{1D6C7}",
        nfc: "\u{1D6C7}",
        nfd: "\u{1D6C7}",
        nfkc: "\u{03B6}",
        nfkd: "\u{03B6}",
    },
    NormalizationTest {
        source: "\u{1D6C8}",
        nfc: "\u{1D6C8}",
        nfd: "\u{1D6C8}",
        nfkc: "\u{03B7}",
        nfkd: "\u{03B7}",
    },
    NormalizationTest {
        source: "\u{1D6C9}",
        nfc: "\u{1D6C9}",
        nfd: "\u{1D6C9}",
        nfkc: "\u{03B8}",
        nfkd: "\u{03B8}",
    },
    NormalizationTest {
        source: "\u{1D6CA}",
        nfc: "\u{1D6CA}",
        nfd: "\u{1D6CA}",
        nfkc: "\u{03B9}",
        nfkd: "\u{03B9}",
    },
    NormalizationTest {
        source: "\u{1D6CB}",
        nfc: "\u{1D6CB}",
        nfd: "\u{1D6CB}",
        nfkc: "\u{03BA}",
        nfkd: "\u{03BA}",
    },
    NormalizationTest {
        source: "\u{1D6CC}",
        nfc: "\u{1D6CC}",
        nfd: "\u{1D6CC}",
        nfkc: "\u{03BB}",
        nfkd: "\u{03BB}",
    },
    NormalizationTest {
        source: "\u{1D6CD}",
        nfc: "\u{1D6CD}",
        nfd: "\u{1D6CD}",
        nfkc: "\u{03BC}",
        nfkd: "\u{03BC}",
    },
    NormalizationTest {
        source: "\u{1D6CE}",
        nfc: "\u{1D6CE}",
        nfd: "\u{1D6CE}",
        nfkc: "\u{03BD}",
        nfkd: "\u{03BD}",
    },
    NormalizationTest {
        source: "\u{1D6CF}",
        nfc: "\u{1D6CF}",
        nfd: "\u{1D6CF}",
        nfkc: "\u{03BE}",
        nfkd: "\u{03BE}",
    },
    NormalizationTest {
        source: "\u{1D6D0}",
        nfc: "\u{1D6D0}",
        nfd: "\u{1D6D0}",
        nfkc: "\u{03BF}",
        nfkd: "\u{03BF}",
    },
    NormalizationTest {
        source: "\u{1D6D1}",
        nfc: "\u{1D6D1}",
        nfd: "\u{1D6D1}",
        nfkc: "\u{03C0}",
        nfkd: "\u{03C0}",
    },
    NormalizationTest {
        source: "\u{1D6D2}",
        nfc: "\u{1D6D2}",
        nfd: "\u{1D6D2}",
        nfkc: "\u{03C1}",
        nfkd: "\u{03C1}",
    },
    NormalizationTest {
        source: "\u{1D6D3}",
        nfc: "\u{1D6D3}",
        nfd: "\u{1D6D3}",
        nfkc: "\u{03C2}",
        nfkd: "\u{03C2}",
    },
    NormalizationTest {
        source: "\u{1D6D4}",
        nfc: "\u{1D6D4}",
        nfd: "\u{1D6D4}",
        nfkc: "\u{03C3}",
        nfkd: "\u{03C3}",
    },
    NormalizationTest {
        source: "\u{1D6D5}",
        nfc: "\u{1D6D5}",
        nfd: "\u{1D6D5}",
        nfkc: "\u{03C4}",
        nfkd: "\u{03C4}",
    },
    NormalizationTest {
        source: "\u{1D6D6}",
        nfc: "\u{1D6D6}",
        nfd: "\u{1D6D6}",
        nfkc: "\u{03C5}",
        nfkd: "\u{03C5}",
    },
    NormalizationTest {
        source: "\u{1D6D7}",
        nfc: "\u{1D6D7}",
        nfd: "\u{1D6D7}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{1D6D8}",
        nfc: "\u{1D6D8}",
        nfd: "\u{1D6D8}",
        nfkc: "\u{03C7}",
        nfkd: "\u{03C7}",
    },
    NormalizationTest {
        source: "\u{1D6D9}",
        nfc: "\u{1D6D9}",
        nfd: "\u{1D6D9}",
        nfkc: "\u{03C8}",
        nfkd: "\u{03C8}",
    },
    NormalizationTest {
        source: "\u{1D6DA}",
        nfc: "\u{1D6DA}",
        nfd: "\u{1D6DA}",
        nfkc: "\u{03C9}",
        nfkd: "\u{03C9}",
    },
    NormalizationTest {
        source: "\u{1D6DB}",
        nfc: "\u{1D6DB}",
        nfd: "\u{1D6DB}",
        nfkc: "\u{2202}",
        nfkd: "\u{2202}",
    },
    NormalizationTest {
        source: "\u{1D6DC}",
        nfc: "\u{1D6DC}",
        nfd: "\u{1D6DC}",
        nfkc: "\u{03B5}",
        nfkd: "\u{03B5}",
    },
    NormalizationTest {
        source: "\u{1D6DD}",
        nfc: "\u{1D6DD}",
        nfd: "\u{1D6DD}",
        nfkc: "\u{03B8}",
        nfkd: "\u{03B8}",
    },
    NormalizationTest {
        source: "\u{1D6DE}",
        nfc: "\u{1D6DE}",
        nfd: "\u{1D6DE}",
        nfkc: "\u{03BA}",
        nfkd: "\u{03BA}",
    },
    NormalizationTest {
        source: "\u{1D6DF}",
        nfc: "\u{1D6DF}",
        nfd: "\u{1D6DF}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{1D6E0}",
        nfc: "\u{1D6E0}",
        nfd: "\u{1D6E0}",
        nfkc: "\u{03C1}",
        nfkd: "\u{03C1}",
    },
    NormalizationTest {
        source: "\u{1D6E1}",
        nfc: "\u{1D6E1}",
        nfd: "\u{1D6E1}",
        nfkc: "\u{03C0}",
        nfkd: "\u{03C0}",
    },
    NormalizationTest {
        source: "\u{1D6E2}",
        nfc: "\u{1D6E2}",
        nfd: "\u{1D6E2}",
        nfkc: "\u{0391}",
        nfkd: "\u{0391}",
    },
    NormalizationTest {
        source: "\u{1D6E3}",
        nfc: "\u{1D6E3}",
        nfd: "\u{1D6E3}",
        nfkc: "\u{0392}",
        nfkd: "\u{0392}",
    },
    NormalizationTest {
        source: "\u{1D6E4}",
        nfc: "\u{1D6E4}",
        nfd: "\u{1D6E4}",
        nfkc: "\u{0393}",
        nfkd: "\u{0393}",
    },
    NormalizationTest {
        source: "\u{1D6E5}",
        nfc: "\u{1D6E5}",
        nfd: "\u{1D6E5}",
        nfkc: "\u{0394}",
        nfkd: "\u{0394}",
    },
    NormalizationTest {
        source: "\u{1D6E6}",
        nfc: "\u{1D6E6}",
        nfd: "\u{1D6E6}",
        nfkc: "\u{0395}",
        nfkd: "\u{0395}",
    },
    NormalizationTest {
        source: "\u{1D6E7}",
        nfc: "\u{1D6E7}",
        nfd: "\u{1D6E7}",
        nfkc: "\u{0396}",
        nfkd: "\u{0396}",
    },
    NormalizationTest {
        source: "\u{1D6E8}",
        nfc: "\u{1D6E8}",
        nfd: "\u{1D6E8}",
        nfkc: "\u{0397}",
        nfkd: "\u{0397}",
    },
    NormalizationTest {
        source: "\u{1D6E9}",
        nfc: "\u{1D6E9}",
        nfd: "\u{1D6E9}",
        nfkc: "\u{0398}",
        nfkd: "\u{0398}",
    },
    NormalizationTest {
        source: "\u{1D6EA}",
        nfc: "\u{1D6EA}",
        nfd: "\u{1D6EA}",
        nfkc: "\u{0399}",
        nfkd: "\u{0399}",
    },
    NormalizationTest {
        source: "\u{1D6EB}",
        nfc: "\u{1D6EB}",
        nfd: "\u{1D6EB}",
        nfkc: "\u{039A}",
        nfkd: "\u{039A}",
    },
    NormalizationTest {
        source: "\u{1D6EC}",
        nfc: "\u{1D6EC}",
        nfd: "\u{1D6EC}",
        nfkc: "\u{039B}",
        nfkd: "\u{039B}",
    },
    NormalizationTest {
        source: "\u{1D6ED}",
        nfc: "\u{1D6ED}",
        nfd: "\u{1D6ED}",
        nfkc: "\u{039C}",
        nfkd: "\u{039C}",
    },
    NormalizationTest {
        source: "\u{1D6EE}",
        nfc: "\u{1D6EE}",
        nfd: "\u{1D6EE}",
        nfkc: "\u{039D}",
        nfkd: "\u{039D}",
    },
    NormalizationTest {
        source: "\u{1D6EF}",
        nfc: "\u{1D6EF}",
        nfd: "\u{1D6EF}",
        nfkc: "\u{039E}",
        nfkd: "\u{039E}",
    },
    NormalizationTest {
        source: "\u{1D6F0}",
        nfc: "\u{1D6F0}",
        nfd: "\u{1D6F0}",
        nfkc: "\u{039F}",
        nfkd: "\u{039F}",
    },
    NormalizationTest {
        source: "\u{1D6F1}",
        nfc: "\u{1D6F1}",
        nfd: "\u{1D6F1}",
        nfkc: "\u{03A0}",
        nfkd: "\u{03A0}",
    },
    NormalizationTest {
        source: "\u{1D6F2}",
        nfc: "\u{1D6F2}",
        nfd: "\u{1D6F2}",
        nfkc: "\u{03A1}",
        nfkd: "\u{03A1}",
    },
    NormalizationTest {
        source: "\u{1D6F3}",
        nfc: "\u{1D6F3}",
        nfd: "\u{1D6F3}",
        nfkc: "\u{0398}",
        nfkd: "\u{0398}",
    },
    NormalizationTest {
        source: "\u{1D6F4}",
        nfc: "\u{1D6F4}",
        nfd: "\u{1D6F4}",
        nfkc: "\u{03A3}",
        nfkd: "\u{03A3}",
    },
    NormalizationTest {
        source: "\u{1D6F5}",
        nfc: "\u{1D6F5}",
        nfd: "\u{1D6F5}",
        nfkc: "\u{03A4}",
        nfkd: "\u{03A4}",
    },
    NormalizationTest {
        source: "\u{1D6F6}",
        nfc: "\u{1D6F6}",
        nfd: "\u{1D6F6}",
        nfkc: "\u{03A5}",
        nfkd: "\u{03A5}",
    },
    NormalizationTest {
        source: "\u{1D6F7}",
        nfc: "\u{1D6F7}",
        nfd: "\u{1D6F7}",
        nfkc: "\u{03A6}",
        nfkd: "\u{03A6}",
    },
    NormalizationTest {
        source: "\u{1D6F8}",
        nfc: "\u{1D6F8}",
        nfd: "\u{1D6F8}",
        nfkc: "\u{03A7}",
        nfkd: "\u{03A7}",
    },
    NormalizationTest {
        source: "\u{1D6F9}",
        nfc: "\u{1D6F9}",
        nfd: "\u{1D6F9}",
        nfkc: "\u{03A8}",
        nfkd: "\u{03A8}",
    },
    NormalizationTest {
        source: "\u{1D6FA}",
        nfc: "\u{1D6FA}",
        nfd: "\u{1D6FA}",
        nfkc: "\u{03A9}",
        nfkd: "\u{03A9}",
    },
    NormalizationTest {
        source: "\u{1D6FB}",
        nfc: "\u{1D6FB}",
        nfd: "\u{1D6FB}",
        nfkc: "\u{2207}",
        nfkd: "\u{2207}",
    },
    NormalizationTest {
        source: "\u{1D6FC}",
        nfc: "\u{1D6FC}",
        nfd: "\u{1D6FC}",
        nfkc: "\u{03B1}",
        nfkd: "\u{03B1}",
    },
    NormalizationTest {
        source: "\u{1D6FD}",
        nfc: "\u{1D6FD}",
        nfd: "\u{1D6FD}",
        nfkc: "\u{03B2}",
        nfkd: "\u{03B2}",
    },
    NormalizationTest {
        source: "\u{1D6FE}",
        nfc: "\u{1D6FE}",
        nfd: "\u{1D6FE}",
        nfkc: "\u{03B3}",
        nfkd: "\u{03B3}",
    },
    NormalizationTest {
        source: "\u{1D6FF}",
        nfc: "\u{1D6FF}",
        nfd: "\u{1D6FF}",
        nfkc: "\u{03B4}",
        nfkd: "\u{03B4}",
    },
    NormalizationTest {
        source: "\u{1D700}",
        nfc: "\u{1D700}",
        nfd: "\u{1D700}",
        nfkc: "\u{03B5}",
        nfkd: "\u{03B5}",
    },
    NormalizationTest {
        source: "\u{1D701}",
        nfc: "\u{1D701}",
        nfd: "\u{1D701}",
        nfkc: "\u{03B6}",
        nfkd: "\u{03B6}",
    },
    NormalizationTest {
        source: "\u{1D702}",
        nfc: "\u{1D702}",
        nfd: "\u{1D702}",
        nfkc: "\u{03B7}",
        nfkd: "\u{03B7}",
    },
    NormalizationTest {
        source: "\u{1D703}",
        nfc: "\u{1D703}",
        nfd: "\u{1D703}",
        nfkc: "\u{03B8}",
        nfkd: "\u{03B8}",
    },
    NormalizationTest {
        source: "\u{1D704}",
        nfc: "\u{1D704}",
        nfd: "\u{1D704}",
        nfkc: "\u{03B9}",
        nfkd: "\u{03B9}",
    },
    NormalizationTest {
        source: "\u{1D705}",
        nfc: "\u{1D705}",
        nfd: "\u{1D705}",
        nfkc: "\u{03BA}",
        nfkd: "\u{03BA}",
    },
    NormalizationTest {
        source: "\u{1D706}",
        nfc: "\u{1D706}",
        nfd: "\u{1D706}",
        nfkc: "\u{03BB}",
        nfkd: "\u{03BB}",
    },
    NormalizationTest {
        source: "\u{1D707}",
        nfc: "\u{1D707}",
        nfd: "\u{1D707}",
        nfkc: "\u{03BC}",
        nfkd: "\u{03BC}",
    },
    NormalizationTest {
        source: "\u{1D708}",
        nfc: "\u{1D708}",
        nfd: "\u{1D708}",
        nfkc: "\u{03BD}",
        nfkd: "\u{03BD}",
    },
    NormalizationTest {
        source: "\u{1D709}",
        nfc: "\u{1D709}",
        nfd: "\u{1D709}",
        nfkc: "\u{03BE}",
        nfkd: "\u{03BE}",
    },
    NormalizationTest {
        source: "\u{1D70A}",
        nfc: "\u{1D70A}",
        nfd: "\u{1D70A}",
        nfkc: "\u{03BF}",
        nfkd: "\u{03BF}",
    },
    NormalizationTest {
        source: "\u{1D70B}",
        nfc: "\u{1D70B}",
        nfd: "\u{1D70B}",
        nfkc: "\u{03C0}",
        nfkd: "\u{03C0}",
    },
    NormalizationTest {
        source: "\u{1D70C}",
        nfc: "\u{1D70C}",
        nfd: "\u{1D70C}",
        nfkc: "\u{03C1}",
        nfkd: "\u{03C1}",
    },
    NormalizationTest {
        source: "\u{1D70D}",
        nfc: "\u{1D70D}",
        nfd: "\u{1D70D}",
        nfkc: "\u{03C2}",
        nfkd: "\u{03C2}",
    },
    NormalizationTest {
        source: "\u{1D70E}",
        nfc: "\u{1D70E}",
        nfd: "\u{1D70E}",
        nfkc: "\u{03C3}",
        nfkd: "\u{03C3}",
    },
    NormalizationTest {
        source: "\u{1D70F}",
        nfc: "\u{1D70F}",
        nfd: "\u{1D70F}",
        nfkc: "\u{03C4}",
        nfkd: "\u{03C4}",
    },
    NormalizationTest {
        source: "\u{1D710}",
        nfc: "\u{1D710}",
        nfd: "\u{1D710}",
        nfkc: "\u{03C5}",
        nfkd: "\u{03C5}",
    },
    NormalizationTest {
        source: "\u{1D711}",
        nfc: "\u{1D711}",
        nfd: "\u{1D711}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{1D712}",
        nfc: "\u{1D712}",
        nfd: "\u{1D712}",
        nfkc: "\u{03C7}",
        nfkd: "\u{03C7}",
    },
    NormalizationTest {
        source: "\u{1D713}",
        nfc: "\u{1D713}",
        nfd: "\u{1D713}",
        nfkc: "\u{03C8}",
        nfkd: "\u{03C8}",
    },
    NormalizationTest {
        source: "\u{1D714}",
        nfc: "\u{1D714}",
        nfd: "\u{1D714}",
        nfkc: "\u{03C9}",
        nfkd: "\u{03C9}",
    },
    NormalizationTest {
        source: "\u{1D715}",
        nfc: "\u{1D715}",
        nfd: "\u{1D715}",
        nfkc: "\u{2202}",
        nfkd: "\u{2202}",
    },
    NormalizationTest {
        source: "\u{1D716}",
        nfc: "\u{1D716}",
        nfd: "\u{1D716}",
        nfkc: "\u{03B5}",
        nfkd: "\u{03B5}",
    },
    NormalizationTest {
        source: "\u{1D717}",
        nfc: "\u{1D717}",
        nfd: "\u{1D717}",
        nfkc: "\u{03B8}",
        nfkd: "\u{03B8}",
    },
    NormalizationTest {
        source: "\u{1D718}",
        nfc: "\u{1D718}",
        nfd: "\u{1D718}",
        nfkc: "\u{03BA}",
        nfkd: "\u{03BA}",
    },
    NormalizationTest {
        source: "\u{1D719}",
        nfc: "\u{1D719}",
        nfd: "\u{1D719}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{1D71A}",
        nfc: "\u{1D71A}",
        nfd: "\u{1D71A}",
        nfkc: "\u{03C1}",
        nfkd: "\u{03C1}",
    },
    NormalizationTest {
        source: "\u{1D71B}",
        nfc: "\u{1D71B}",
        nfd: "\u{1D71B}",
        nfkc: "\u{03C0}",
        nfkd: "\u{03C0}",
    },
    NormalizationTest {
        source: "\u{1D71C}",
        nfc: "\u{1D71C}",
        nfd: "\u{1D71C}",
        nfkc: "\u{0391}",
        nfkd: "\u{0391}",
    },
    NormalizationTest {
        source: "\u{1D71D}",
        nfc: "\u{1D71D}",
        nfd: "\u{1D71D}",
        nfkc: "\u{0392}",
        nfkd: "\u{0392}",
    },
    NormalizationTest {
        source: "\u{1D71E}",
        nfc: "\u{1D71E}",
        nfd: "\u{1D71E}",
        nfkc: "\u{0393}",
        nfkd: "\u{0393}",
    },
    NormalizationTest {
        source: "\u{1D71F}",
        nfc: "\u{1D71F}",
        nfd: "\u{1D71F}",
        nfkc: "\u{0394}",
        nfkd: "\u{0394}",
    },
    NormalizationTest {
        source: "\u{1D720}",
        nfc: "\u{1D720}",
        nfd: "\u{1D720}",
        nfkc: "\u{0395}",
        nfkd: "\u{0395}",
    },
    NormalizationTest {
        source: "\u{1D721}",
        nfc: "\u{1D721}",
        nfd: "\u{1D721}",
        nfkc: "\u{0396}",
        nfkd: "\u{0396}",
    },
    NormalizationTest {
        source: "\u{1D722}",
        nfc: "\u{1D722}",
        nfd: "\u{1D722}",
        nfkc: "\u{0397}",
        nfkd: "\u{0397}",
    },
    NormalizationTest {
        source: "\u{1D723}",
        nfc: "\u{1D723}",
        nfd: "\u{1D723}",
        nfkc: "\u{0398}",
        nfkd: "\u{0398}",
    },
    NormalizationTest {
        source: "\u{1D724}",
        nfc: "\u{1D724}",
        nfd: "\u{1D724}",
        nfkc: "\u{0399}",
        nfkd: "\u{0399}",
    },
    NormalizationTest {
        source: "\u{1D725}",
        nfc: "\u{1D725}",
        nfd: "\u{1D725}",
        nfkc: "\u{039A}",
        nfkd: "\u{039A}",
    },
    NormalizationTest {
        source: "\u{1D726}",
        nfc: "\u{1D726}",
        nfd: "\u{1D726}",
        nfkc: "\u{039B}",
        nfkd: "\u{039B}",
    },
    NormalizationTest {
        source: "\u{1D727}",
        nfc: "\u{1D727}",
        nfd: "\u{1D727}",
        nfkc: "\u{039C}",
        nfkd: "\u{039C}",
    },
    NormalizationTest {
        source: "\u{1D728}",
        nfc: "\u{1D728}",
        nfd: "\u{1D728}",
        nfkc: "\u{039D}",
        nfkd: "\u{039D}",
    },
    NormalizationTest {
        source: "\u{1D729}",
        nfc: "\u{1D729}",
        nfd: "\u{1D729}",
        nfkc: "\u{039E}",
        nfkd: "\u{039E}",
    },
    NormalizationTest {
        source: "\u{1D72A}",
        nfc: "\u{1D72A}",
        nfd: "\u{1D72A}",
        nfkc: "\u{039F}",
        nfkd: "\u{039F}",
    },
    NormalizationTest {
        source: "\u{1D72B}",
        nfc: "\u{1D72B}",
        nfd: "\u{1D72B}",
        nfkc: "\u{03A0}",
        nfkd: "\u{03A0}",
    },
    NormalizationTest {
        source: "\u{1D72C}",
        nfc: "\u{1D72C}",
        nfd: "\u{1D72C}",
        nfkc: "\u{03A1}",
        nfkd: "\u{03A1}",
    },
    NormalizationTest {
        source: "\u{1D72D}",
        nfc: "\u{1D72D}",
        nfd: "\u{1D72D}",
        nfkc: "\u{0398}",
        nfkd: "\u{0398}",
    },
    NormalizationTest {
        source: "\u{1D72E}",
        nfc: "\u{1D72E}",
        nfd: "\u{1D72E}",
        nfkc: "\u{03A3}",
        nfkd: "\u{03A3}",
    },
    NormalizationTest {
        source: "\u{1D72F}",
        nfc: "\u{1D72F}",
        nfd: "\u{1D72F}",
        nfkc: "\u{03A4}",
        nfkd: "\u{03A4}",
    },
    NormalizationTest {
        source: "\u{1D730}",
        nfc: "\u{1D730}",
        nfd: "\u{1D730}",
        nfkc: "\u{03A5}",
        nfkd: "\u{03A5}",
    },
    NormalizationTest {
        source: "\u{1D731}",
        nfc: "\u{1D731}",
        nfd: "\u{1D731}",
        nfkc: "\u{03A6}",
        nfkd: "\u{03A6}",
    },
    NormalizationTest {
        source: "\u{1D732}",
        nfc: "\u{1D732}",
        nfd: "\u{1D732}",
        nfkc: "\u{03A7}",
        nfkd: "\u{03A7}",
    },
    NormalizationTest {
        source: "\u{1D733}",
        nfc: "\u{1D733}",
        nfd: "\u{1D733}",
        nfkc: "\u{03A8}",
        nfkd: "\u{03A8}",
    },
    NormalizationTest {
        source: "\u{1D734}",
        nfc: "\u{1D734}",
        nfd: "\u{1D734}",
        nfkc: "\u{03A9}",
        nfkd: "\u{03A9}",
    },
    NormalizationTest {
        source: "\u{1D735}",
        nfc: "\u{1D735}",
        nfd: "\u{1D735}",
        nfkc: "\u{2207}",
        nfkd: "\u{2207}",
    },
    NormalizationTest {
        source: "\u{1D736}",
        nfc: "\u{1D736}",
        nfd: "\u{1D736}",
        nfkc: "\u{03B1}",
        nfkd: "\u{03B1}",
    },
    NormalizationTest {
        source: "\u{1D737}",
        nfc: "\u{1D737}",
        nfd: "\u{1D737}",
        nfkc: "\u{03B2}",
        nfkd: "\u{03B2}",
    },
    NormalizationTest {
        source: "\u{1D738}",
        nfc: "\u{1D738}",
        nfd: "\u{1D738}",
        nfkc: "\u{03B3}",
        nfkd: "\u{03B3}",
    },
    NormalizationTest {
        source: "\u{1D739}",
        nfc: "\u{1D739}",
        nfd: "\u{1D739}",
        nfkc: "\u{03B4}",
        nfkd: "\u{03B4}",
    },
    NormalizationTest {
        source: "\u{1D73A}",
        nfc: "\u{1D73A}",
        nfd: "\u{1D73A}",
        nfkc: "\u{03B5}",
        nfkd: "\u{03B5}",
    },
    NormalizationTest {
        source: "\u{1D73B}",
        nfc: "\u{1D73B}",
        nfd: "\u{1D73B}",
        nfkc: "\u{03B6}",
        nfkd: "\u{03B6}",
    },
    NormalizationTest {
        source: "\u{1D73C}",
        nfc: "\u{1D73C}",
        nfd: "\u{1D73C}",
        nfkc: "\u{03B7}",
        nfkd: "\u{03B7}",
    },
    NormalizationTest {
        source: "\u{1D73D}",
        nfc: "\u{1D73D}",
        nfd: "\u{1D73D}",
        nfkc: "\u{03B8}",
        nfkd: "\u{03B8}",
    },
    NormalizationTest {
        source: "\u{1D73E}",
        nfc: "\u{1D73E}",
        nfd: "\u{1D73E}",
        nfkc: "\u{03B9}",
        nfkd: "\u{03B9}",
    },
    NormalizationTest {
        source: "\u{1D73F}",
        nfc: "\u{1D73F}",
        nfd: "\u{1D73F}",
        nfkc: "\u{03BA}",
        nfkd: "\u{03BA}",
    },
    NormalizationTest {
        source: "\u{1D740}",
        nfc: "\u{1D740}",
        nfd: "\u{1D740}",
        nfkc: "\u{03BB}",
        nfkd: "\u{03BB}",
    },
    NormalizationTest {
        source: "\u{1D741}",
        nfc: "\u{1D741}",
        nfd: "\u{1D741}",
        nfkc: "\u{03BC}",
        nfkd: "\u{03BC}",
    },
    NormalizationTest {
        source: "\u{1D742}",
        nfc: "\u{1D742}",
        nfd: "\u{1D742}",
        nfkc: "\u{03BD}",
        nfkd: "\u{03BD}",
    },
    NormalizationTest {
        source: "\u{1D743}",
        nfc: "\u{1D743}",
        nfd: "\u{1D743}",
        nfkc: "\u{03BE}",
        nfkd: "\u{03BE}",
    },
    NormalizationTest {
        source: "\u{1D744}",
        nfc: "\u{1D744}",
        nfd: "\u{1D744}",
        nfkc: "\u{03BF}",
        nfkd: "\u{03BF}",
    },
    NormalizationTest {
        source: "\u{1D745}",
        nfc: "\u{1D745}",
        nfd: "\u{1D745}",
        nfkc: "\u{03C0}",
        nfkd: "\u{03C0}",
    },
    NormalizationTest {
        source: "\u{1D746}",
        nfc: "\u{1D746}",
        nfd: "\u{1D746}",
        nfkc: "\u{03C1}",
        nfkd: "\u{03C1}",
    },
    NormalizationTest {
        source: "\u{1D747}",
        nfc: "\u{1D747}",
        nfd: "\u{1D747}",
        nfkc: "\u{03C2}",
        nfkd: "\u{03C2}",
    },
    NormalizationTest {
        source: "\u{1D748}",
        nfc: "\u{1D748}",
        nfd: "\u{1D748}",
        nfkc: "\u{03C3}",
        nfkd: "\u{03C3}",
    },
    NormalizationTest {
        source: "\u{1D749}",
        nfc: "\u{1D749}",
        nfd: "\u{1D749}",
        nfkc: "\u{03C4}",
        nfkd: "\u{03C4}",
    },
    NormalizationTest {
        source: "\u{1D74A}",
        nfc: "\u{1D74A}",
        nfd: "\u{1D74A}",
        nfkc: "\u{03C5}",
        nfkd: "\u{03C5}",
    },
    NormalizationTest {
        source: "\u{1D74B}",
        nfc: "\u{1D74B}",
        nfd: "\u{1D74B}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{1D74C}",
        nfc: "\u{1D74C}",
        nfd: "\u{1D74C}",
        nfkc: "\u{03C7}",
        nfkd: "\u{03C7}",
    },
    NormalizationTest {
        source: "\u{1D74D}",
        nfc: "\u{1D74D}",
        nfd: "\u{1D74D}",
        nfkc: "\u{03C8}",
        nfkd: "\u{03C8}",
    },
    NormalizationTest {
        source: "\u{1D74E}",
        nfc: "\u{1D74E}",
        nfd: "\u{1D74E}",
        nfkc: "\u{03C9}",
        nfkd: "\u{03C9}",
    },
    NormalizationTest {
        source: "\u{1D74F}",
        nfc: "\u{1D74F}",
        nfd: "\u{1D74F}",
        nfkc: "\u{2202}",
        nfkd: "\u{2202}",
    },
    NormalizationTest {
        source: "\u{1D750}",
        nfc: "\u{1D750}",
        nfd: "\u{1D750}",
        nfkc: "\u{03B5}",
        nfkd: "\u{03B5}",
    },
    NormalizationTest {
        source: "\u{1D751}",
        nfc: "\u{1D751}",
        nfd: "\u{1D751}",
        nfkc: "\u{03B8}",
        nfkd: "\u{03B8}",
    },
    NormalizationTest {
        source: "\u{1D752}",
        nfc: "\u{1D752}",
        nfd: "\u{1D752}",
        nfkc: "\u{03BA}",
        nfkd: "\u{03BA}",
    },
    NormalizationTest {
        source: "\u{1D753}",
        nfc: "\u{1D753}",
        nfd: "\u{1D753}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{1D754}",
        nfc: "\u{1D754}",
        nfd: "\u{1D754}",
        nfkc: "\u{03C1}",
        nfkd: "\u{03C1}",
    },
    NormalizationTest {
        source: "\u{1D755}",
        nfc: "\u{1D755}",
        nfd: "\u{1D755}",
        nfkc: "\u{03C0}",
        nfkd: "\u{03C0}",
    },
    NormalizationTest {
        source: "\u{1D756}",
        nfc: "\u{1D756}",
        nfd: "\u{1D756}",
        nfkc: "\u{0391}",
        nfkd: "\u{0391}",
    },
    NormalizationTest {
        source: "\u{1D757}",
        nfc: "\u{1D757}",
        nfd: "\u{1D757}",
        nfkc: "\u{0392}",
        nfkd: "\u{0392}",
    },
    NormalizationTest {
        source: "\u{1D758}",
        nfc: "\u{1D758}",
        nfd: "\u{1D758}",
        nfkc: "\u{0393}",
        nfkd: "\u{0393}",
    },
    NormalizationTest {
        source: "\u{1D759}",
        nfc: "\u{1D759}",
        nfd: "\u{1D759}",
        nfkc: "\u{0394}",
        nfkd: "\u{0394}",
    },
    NormalizationTest {
        source: "\u{1D75A}",
        nfc: "\u{1D75A}",
        nfd: "\u{1D75A}",
        nfkc: "\u{0395}",
        nfkd: "\u{0395}",
    },
    NormalizationTest {
        source: "\u{1D75B}",
        nfc: "\u{1D75B}",
        nfd: "\u{1D75B}",
        nfkc: "\u{0396}",
        nfkd: "\u{0396}",
    },
    NormalizationTest {
        source: "\u{1D75C}",
        nfc: "\u{1D75C}",
        nfd: "\u{1D75C}",
        nfkc: "\u{0397}",
        nfkd: "\u{0397}",
    },
    NormalizationTest {
        source: "\u{1D75D}",
        nfc: "\u{1D75D}",
        nfd: "\u{1D75D}",
        nfkc: "\u{0398}",
        nfkd: "\u{0398}",
    },
    NormalizationTest {
        source: "\u{1D75E}",
        nfc: "\u{1D75E}",
        nfd: "\u{1D75E}",
        nfkc: "\u{0399}",
        nfkd: "\u{0399}",
    },
    NormalizationTest {
        source: "\u{1D75F}",
        nfc: "\u{1D75F}",
        nfd: "\u{1D75F}",
        nfkc: "\u{039A}",
        nfkd: "\u{039A}",
    },
    NormalizationTest {
        source: "\u{1D760}",
        nfc: "\u{1D760}",
        nfd: "\u{1D760}",
        nfkc: "\u{039B}",
        nfkd: "\u{039B}",
    },
    NormalizationTest {
        source: "\u{1D761}",
        nfc: "\u{1D761}",
        nfd: "\u{1D761}",
        nfkc: "\u{039C}",
        nfkd: "\u{039C}",
    },
    NormalizationTest {
        source: "\u{1D762}",
        nfc: "\u{1D762}",
        nfd: "\u{1D762}",
        nfkc: "\u{039D}",
        nfkd: "\u{039D}",
    },
    NormalizationTest {
        source: "\u{1D763}",
        nfc: "\u{1D763}",
        nfd: "\u{1D763}",
        nfkc: "\u{039E}",
        nfkd: "\u{039E}",
    },
    NormalizationTest {
        source: "\u{1D764}",
        nfc: "\u{1D764}",
        nfd: "\u{1D764}",
        nfkc: "\u{039F}",
        nfkd: "\u{039F}",
    },
    NormalizationTest {
        source: "\u{1D765}",
        nfc: "\u{1D765}",
        nfd: "\u{1D765}",
        nfkc: "\u{03A0}",
        nfkd: "\u{03A0}",
    },
    NormalizationTest {
        source: "\u{1D766}",
        nfc: "\u{1D766}",
        nfd: "\u{1D766}",
        nfkc: "\u{03A1}",
        nfkd: "\u{03A1}",
    },
    NormalizationTest {
        source: "\u{1D767}",
        nfc: "\u{1D767}",
        nfd: "\u{1D767}",
        nfkc: "\u{0398}",
        nfkd: "\u{0398}",
    },
    NormalizationTest {
        source: "\u{1D768}",
        nfc: "\u{1D768}",
        nfd: "\u{1D768}",
        nfkc: "\u{03A3}",
        nfkd: "\u{03A3}",
    },
    NormalizationTest {
        source: "\u{1D769}",
        nfc: "\u{1D769}",
        nfd: "\u{1D769}",
        nfkc: "\u{03A4}",
        nfkd: "\u{03A4}",
    },
    NormalizationTest {
        source: "\u{1D76A}",
        nfc: "\u{1D76A}",
        nfd: "\u{1D76A}",
        nfkc: "\u{03A5}",
        nfkd: "\u{03A5}",
    },
    NormalizationTest {
        source: "\u{1D76B}",
        nfc: "\u{1D76B}",
        nfd: "\u{1D76B}",
        nfkc: "\u{03A6}",
        nfkd: "\u{03A6}",
    },
    NormalizationTest {
        source: "\u{1D76C}",
        nfc: "\u{1D76C}",
        nfd: "\u{1D76C}",
        nfkc: "\u{03A7}",
        nfkd: "\u{03A7}",
    },
    NormalizationTest {
        source: "\u{1D76D}",
        nfc: "\u{1D76D}",
        nfd: "\u{1D76D}",
        nfkc: "\u{03A8}",
        nfkd: "\u{03A8}",
    },
    NormalizationTest {
        source: "\u{1D76E}",
        nfc: "\u{1D76E}",
        nfd: "\u{1D76E}",
        nfkc: "\u{03A9}",
        nfkd: "\u{03A9}",
    },
    NormalizationTest {
        source: "\u{1D76F}",
        nfc: "\u{1D76F}",
        nfd: "\u{1D76F}",
        nfkc: "\u{2207}",
        nfkd: "\u{2207}",
    },
    NormalizationTest {
        source: "\u{1D770}",
        nfc: "\u{1D770}",
        nfd: "\u{1D770}",
        nfkc: "\u{03B1}",
        nfkd: "\u{03B1}",
    },
    NormalizationTest {
        source: "\u{1D771}",
        nfc: "\u{1D771}",
        nfd: "\u{1D771}",
        nfkc: "\u{03B2}",
        nfkd: "\u{03B2}",
    },
    NormalizationTest {
        source: "\u{1D772}",
        nfc: "\u{1D772}",
        nfd: "\u{1D772}",
        nfkc: "\u{03B3}",
        nfkd: "\u{03B3}",
    },
    NormalizationTest {
        source: "\u{1D773}",
        nfc: "\u{1D773}",
        nfd: "\u{1D773}",
        nfkc: "\u{03B4}",
        nfkd: "\u{03B4}",
    },
    NormalizationTest {
        source: "\u{1D774}",
        nfc: "\u{1D774}",
        nfd: "\u{1D774}",
        nfkc: "\u{03B5}",
        nfkd: "\u{03B5}",
    },
    NormalizationTest {
        source: "\u{1D775}",
        nfc: "\u{1D775}",
        nfd: "\u{1D775}",
        nfkc: "\u{03B6}",
        nfkd: "\u{03B6}",
    },
    NormalizationTest {
        source: "\u{1D776}",
        nfc: "\u{1D776}",
        nfd: "\u{1D776}",
        nfkc: "\u{03B7}",
        nfkd: "\u{03B7}",
    },
    NormalizationTest {
        source: "\u{1D777}",
        nfc: "\u{1D777}",
        nfd: "\u{1D777}",
        nfkc: "\u{03B8}",
        nfkd: "\u{03B8}",
    },
    NormalizationTest {
        source: "\u{1D778}",
        nfc: "\u{1D778}",
        nfd: "\u{1D778}",
        nfkc: "\u{03B9}",
        nfkd: "\u{03B9}",
    },
    NormalizationTest {
        source: "\u{1D779}",
        nfc: "\u{1D779}",
        nfd: "\u{1D779}",
        nfkc: "\u{03BA}",
        nfkd: "\u{03BA}",
    },
    NormalizationTest {
        source: "\u{1D77A}",
        nfc: "\u{1D77A}",
        nfd: "\u{1D77A}",
        nfkc: "\u{03BB}",
        nfkd: "\u{03BB}",
    },
    NormalizationTest {
        source: "\u{1D77B}",
        nfc: "\u{1D77B}",
        nfd: "\u{1D77B}",
        nfkc: "\u{03BC}",
        nfkd: "\u{03BC}",
    },
    NormalizationTest {
        source: "\u{1D77C}",
        nfc: "\u{1D77C}",
        nfd: "\u{1D77C}",
        nfkc: "\u{03BD}",
        nfkd: "\u{03BD}",
    },
    NormalizationTest {
        source: "\u{1D77D}",
        nfc: "\u{1D77D}",
        nfd: "\u{1D77D}",
        nfkc: "\u{03BE}",
        nfkd: "\u{03BE}",
    },
    NormalizationTest {
        source: "\u{1D77E}",
        nfc: "\u{1D77E}",
        nfd: "\u{1D77E}",
        nfkc: "\u{03BF}",
        nfkd: "\u{03BF}",
    },
    NormalizationTest {
        source: "\u{1D77F}",
        nfc: "\u{1D77F}",
        nfd: "\u{1D77F}",
        nfkc: "\u{03C0}",
        nfkd: "\u{03C0}",
    },
    NormalizationTest {
        source: "\u{1D780}",
        nfc: "\u{1D780}",
        nfd: "\u{1D780}",
        nfkc: "\u{03C1}",
        nfkd: "\u{03C1}",
    },
    NormalizationTest {
        source: "\u{1D781}",
        nfc: "\u{1D781}",
        nfd: "\u{1D781}",
        nfkc: "\u{03C2}",
        nfkd: "\u{03C2}",
    },
    NormalizationTest {
        source: "\u{1D782}",
        nfc: "\u{1D782}",
        nfd: "\u{1D782}",
        nfkc: "\u{03C3}",
        nfkd: "\u{03C3}",
    },
    NormalizationTest {
        source: "\u{1D783}",
        nfc: "\u{1D783}",
        nfd: "\u{1D783}",
        nfkc: "\u{03C4}",
        nfkd: "\u{03C4}",
    },
    NormalizationTest {
        source: "\u{1D784}",
        nfc: "\u{1D784}",
        nfd: "\u{1D784}",
        nfkc: "\u{03C5}",
        nfkd: "\u{03C5}",
    },
    NormalizationTest {
        source: "\u{1D785}",
        nfc: "\u{1D785}",
        nfd: "\u{1D785}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{1D786}",
        nfc: "\u{1D786}",
        nfd: "\u{1D786}",
        nfkc: "\u{03C7}",
        nfkd: "\u{03C7}",
    },
    NormalizationTest {
        source: "\u{1D787}",
        nfc: "\u{1D787}",
        nfd: "\u{1D787}",
        nfkc: "\u{03C8}",
        nfkd: "\u{03C8}",
    },
    NormalizationTest {
        source: "\u{1D788}",
        nfc: "\u{1D788}",
        nfd: "\u{1D788}",
        nfkc: "\u{03C9}",
        nfkd: "\u{03C9}",
    },
    NormalizationTest {
        source: "\u{1D789}",
        nfc: "\u{1D789}",
        nfd: "\u{1D789}",
        nfkc: "\u{2202}",
        nfkd: "\u{2202}",
    },
    NormalizationTest {
        source: "\u{1D78A}",
        nfc: "\u{1D78A}",
        nfd: "\u{1D78A}",
        nfkc: "\u{03B5}",
        nfkd: "\u{03B5}",
    },
    NormalizationTest {
        source: "\u{1D78B}",
        nfc: "\u{1D78B}",
        nfd: "\u{1D78B}",
        nfkc: "\u{03B8}",
        nfkd: "\u{03B8}",
    },
    NormalizationTest {
        source: "\u{1D78C}",
        nfc: "\u{1D78C}",
        nfd: "\u{1D78C}",
        nfkc: "\u{03BA}",
        nfkd: "\u{03BA}",
    },
    NormalizationTest {
        source: "\u{1D78D}",
        nfc: "\u{1D78D}",
        nfd: "\u{1D78D}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{1D78E}",
        nfc: "\u{1D78E}",
        nfd: "\u{1D78E}",
        nfkc: "\u{03C1}",
        nfkd: "\u{03C1}",
    },
    NormalizationTest {
        source: "\u{1D78F}",
        nfc: "\u{1D78F}",
        nfd: "\u{1D78F}",
        nfkc: "\u{03C0}",
        nfkd: "\u{03C0}",
    },
    NormalizationTest {
        source: "\u{1D790}",
        nfc: "\u{1D790}",
        nfd: "\u{1D790}",
        nfkc: "\u{0391}",
        nfkd: "\u{0391}",
    },
    NormalizationTest {
        source: "\u{1D791}",
        nfc: "\u{1D791}",
        nfd: "\u{1D791}",
        nfkc: "\u{0392}",
        nfkd: "\u{0392}",
    },
    NormalizationTest {
        source: "\u{1D792}",
        nfc: "\u{1D792}",
        nfd: "\u{1D792}",
        nfkc: "\u{0393}",
        nfkd: "\u{0393}",
    },
    NormalizationTest {
        source: "\u{1D793}",
        nfc: "\u{1D793}",
        nfd: "\u{1D793}",
        nfkc: "\u{0394}",
        nfkd: "\u{0394}",
    },
    NormalizationTest {
        source: "\u{1D794}",
        nfc: "\u{1D794}",
        nfd: "\u{1D794}",
        nfkc: "\u{0395}",
        nfkd: "\u{0395}",
    },
    NormalizationTest {
        source: "\u{1D795}",
        nfc: "\u{1D795}",
        nfd: "\u{1D795}",
        nfkc: "\u{0396}",
        nfkd: "\u{0396}",
    },
    NormalizationTest {
        source: "\u{1D796}",
        nfc: "\u{1D796}",
        nfd: "\u{1D796}",
        nfkc: "\u{0397}",
        nfkd: "\u{0397}",
    },
    NormalizationTest {
        source: "\u{1D797}",
        nfc: "\u{1D797}",
        nfd: "\u{1D797}",
        nfkc: "\u{0398}",
        nfkd: "\u{0398}",
    },
    NormalizationTest {
        source: "\u{1D798}",
        nfc: "\u{1D798}",
        nfd: "\u{1D798}",
        nfkc: "\u{0399}",
        nfkd: "\u{0399}",
    },
    NormalizationTest {
        source: "\u{1D799}",
        nfc: "\u{1D799}",
        nfd: "\u{1D799}",
        nfkc: "\u{039A}",
        nfkd: "\u{039A}",
    },
    NormalizationTest {
        source: "\u{1D79A}",
        nfc: "\u{1D79A}",
        nfd: "\u{1D79A}",
        nfkc: "\u{039B}",
        nfkd: "\u{039B}",
    },
    NormalizationTest {
        source: "\u{1D79B}",
        nfc: "\u{1D79B}",
        nfd: "\u{1D79B}",
        nfkc: "\u{039C}",
        nfkd: "\u{039C}",
    },
    NormalizationTest {
        source: "\u{1D79C}",
        nfc: "\u{1D79C}",
        nfd: "\u{1D79C}",
        nfkc: "\u{039D}",
        nfkd: "\u{039D}",
    },
    NormalizationTest {
        source: "\u{1D79D}",
        nfc: "\u{1D79D}",
        nfd: "\u{1D79D}",
        nfkc: "\u{039E}",
        nfkd: "\u{039E}",
    },
    NormalizationTest {
        source: "\u{1D79E}",
        nfc: "\u{1D79E}",
        nfd: "\u{1D79E}",
        nfkc: "\u{039F}",
        nfkd: "\u{039F}",
    },
    NormalizationTest {
        source: "\u{1D79F}",
        nfc: "\u{1D79F}",
        nfd: "\u{1D79F}",
        nfkc: "\u{03A0}",
        nfkd: "\u{03A0}",
    },
    NormalizationTest {
        source: "\u{1D7A0}",
        nfc: "\u{1D7A0}",
        nfd: "\u{1D7A0}",
        nfkc: "\u{03A1}",
        nfkd: "\u{03A1}",
    },
    NormalizationTest {
        source: "\u{1D7A1}",
        nfc: "\u{1D7A1}",
        nfd: "\u{1D7A1}",
        nfkc: "\u{0398}",
        nfkd: "\u{0398}",
    },
    NormalizationTest {
        source: "\u{1D7A2}",
        nfc: "\u{1D7A2}",
        nfd: "\u{1D7A2}",
        nfkc: "\u{03A3}",
        nfkd: "\u{03A3}",
    },
    NormalizationTest {
        source: "\u{1D7A3}",
        nfc: "\u{1D7A3}",
        nfd: "\u{1D7A3}",
        nfkc: "\u{03A4}",
        nfkd: "\u{03A4}",
    },
    NormalizationTest {
        source: "\u{1D7A4}",
        nfc: "\u{1D7A4}",
        nfd: "\u{1D7A4}",
        nfkc: "\u{03A5}",
        nfkd: "\u{03A5}",
    },
    NormalizationTest {
        source: "\u{1D7A5}",
        nfc: "\u{1D7A5}",
        nfd: "\u{1D7A5}",
        nfkc: "\u{03A6}",
        nfkd: "\u{03A6}",
    },
    NormalizationTest {
        source: "\u{1D7A6}",
        nfc: "\u{1D7A6}",
        nfd: "\u{1D7A6}",
        nfkc: "\u{03A7}",
        nfkd: "\u{03A7}",
    },
    NormalizationTest {
        source: "\u{1D7A7}",
        nfc: "\u{1D7A7}",
        nfd: "\u{1D7A7}",
        nfkc: "\u{03A8}",
        nfkd: "\u{03A8}",
    },
    NormalizationTest {
        source: "\u{1D7A8}",
        nfc: "\u{1D7A8}",
        nfd: "\u{1D7A8}",
        nfkc: "\u{03A9}",
        nfkd: "\u{03A9}",
    },
    NormalizationTest {
        source: "\u{1D7A9}",
        nfc: "\u{1D7A9}",
        nfd: "\u{1D7A9}",
        nfkc: "\u{2207}",
        nfkd: "\u{2207}",
    },
    NormalizationTest {
        source: "\u{1D7AA}",
        nfc: "\u{1D7AA}",
        nfd: "\u{1D7AA}",
        nfkc: "\u{03B1}",
        nfkd: "\u{03B1}",
    },
    NormalizationTest {
        source: "\u{1D7AB}",
        nfc: "\u{1D7AB}",
        nfd: "\u{1D7AB}",
        nfkc: "\u{03B2}",
        nfkd: "\u{03B2}",
    },
    NormalizationTest {
        source: "\u{1D7AC}",
        nfc: "\u{1D7AC}",
        nfd: "\u{1D7AC}",
        nfkc: "\u{03B3}",
        nfkd: "\u{03B3}",
    },
    NormalizationTest {
        source: "\u{1D7AD}",
        nfc: "\u{1D7AD}",
        nfd: "\u{1D7AD}",
        nfkc: "\u{03B4}",
        nfkd: "\u{03B4}",
    },
    NormalizationTest {
        source: "\u{1D7AE}",
        nfc: "\u{1D7AE}",
        nfd: "\u{1D7AE}",
        nfkc: "\u{03B5}",
        nfkd: "\u{03B5}",
    },
    NormalizationTest {
        source: "\u{1D7AF}",
        nfc: "\u{1D7AF}",
        nfd: "\u{1D7AF}",
        nfkc: "\u{03B6}",
        nfkd: "\u{03B6}",
    },
    NormalizationTest {
        source: "\u{1D7B0}",
        nfc: "\u{1D7B0}",
        nfd: "\u{1D7B0}",
        nfkc: "\u{03B7}",
        nfkd: "\u{03B7}",
    },
    NormalizationTest {
        source: "\u{1D7B1}",
        nfc: "\u{1D7B1}",
        nfd: "\u{1D7B1}",
        nfkc: "\u{03B8}",
        nfkd: "\u{03B8}",
    },
    NormalizationTest {
        source: "\u{1D7B2}",
        nfc: "\u{1D7B2}",
        nfd: "\u{1D7B2}",
        nfkc: "\u{03B9}",
        nfkd: "\u{03B9}",
    },
    NormalizationTest {
        source: "\u{1D7B3}",
        nfc: "\u{1D7B3}",
        nfd: "\u{1D7B3}",
        nfkc: "\u{03BA}",
        nfkd: "\u{03BA}",
    },
    NormalizationTest {
        source: "\u{1D7B4}",
        nfc: "\u{1D7B4}",
        nfd: "\u{1D7B4}",
        nfkc: "\u{03BB}",
        nfkd: "\u{03BB}",
    },
    NormalizationTest {
        source: "\u{1D7B5}",
        nfc: "\u{1D7B5}",
        nfd: "\u{1D7B5}",
        nfkc: "\u{03BC}",
        nfkd: "\u{03BC}",
    },
    NormalizationTest {
        source: "\u{1D7B6}",
        nfc: "\u{1D7B6}",
        nfd: "\u{1D7B6}",
        nfkc: "\u{03BD}",
        nfkd: "\u{03BD}",
    },
    NormalizationTest {
        source: "\u{1D7B7}",
        nfc: "\u{1D7B7}",
        nfd: "\u{1D7B7}",
        nfkc: "\u{03BE}",
        nfkd: "\u{03BE}",
    },
    NormalizationTest {
        source: "\u{1D7B8}",
        nfc: "\u{1D7B8}",
        nfd: "\u{1D7B8}",
        nfkc: "\u{03BF}",
        nfkd: "\u{03BF}",
    },
    NormalizationTest {
        source: "\u{1D7B9}",
        nfc: "\u{1D7B9}",
        nfd: "\u{1D7B9}",
        nfkc: "\u{03C0}",
        nfkd: "\u{03C0}",
    },
    NormalizationTest {
        source: "\u{1D7BA}",
        nfc: "\u{1D7BA}",
        nfd: "\u{1D7BA}",
        nfkc: "\u{03C1}",
        nfkd: "\u{03C1}",
    },
    NormalizationTest {
        source: "\u{1D7BB}",
        nfc: "\u{1D7BB}",
        nfd: "\u{1D7BB}",
        nfkc: "\u{03C2}",
        nfkd: "\u{03C2}",
    },
    NormalizationTest {
        source: "\u{1D7BC}",
        nfc: "\u{1D7BC}",
        nfd: "\u{1D7BC}",
        nfkc: "\u{03C3}",
        nfkd: "\u{03C3}",
    },
    NormalizationTest {
        source: "\u{1D7BD}",
        nfc: "\u{1D7BD}",
        nfd: "\u{1D7BD}",
        nfkc: "\u{03C4}",
        nfkd: "\u{03C4}",
    },
    NormalizationTest {
        source: "\u{1D7BE}",
        nfc: "\u{1D7BE}",
        nfd: "\u{1D7BE}",
        nfkc: "\u{03C5}",
        nfkd: "\u{03C5}",
    },
    NormalizationTest {
        source: "\u{1D7BF}",
        nfc: "\u{1D7BF}",
        nfd: "\u{1D7BF}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{1D7C0}",
        nfc: "\u{1D7C0}",
        nfd: "\u{1D7C0}",
        nfkc: "\u{03C7}",
        nfkd: "\u{03C7}",
    },
    NormalizationTest {
        source: "\u{1D7C1}",
        nfc: "\u{1D7C1}",
        nfd: "\u{1D7C1}",
        nfkc: "\u{03C8}",
        nfkd: "\u{03C8}",
    },
    NormalizationTest {
        source: "\u{1D7C2}",
        nfc: "\u{1D7C2}",
        nfd: "\u{1D7C2}",
        nfkc: "\u{03C9}",
        nfkd: "\u{03C9}",
    },
    NormalizationTest {
        source: "\u{1D7C3}",
        nfc: "\u{1D7C3}",
        nfd: "\u{1D7C3}",
        nfkc: "\u{2202}",
        nfkd: "\u{2202}",
    },
    NormalizationTest {
        source: "\u{1D7C4}",
        nfc: "\u{1D7C4}",
        nfd: "\u{1D7C4}",
        nfkc: "\u{03B5}",
        nfkd: "\u{03B5}",
    },
    NormalizationTest {
        source: "\u{1D7C5}",
        nfc: "\u{1D7C5}",
        nfd: "\u{1D7C5}",
        nfkc: "\u{03B8}",
        nfkd: "\u{03B8}",
    },
    NormalizationTest {
        source: "\u{1D7C6}",
        nfc: "\u{1D7C6}",
        nfd: "\u{1D7C6}",
        nfkc: "\u{03BA}",
        nfkd: "\u{03BA}",
    },
    NormalizationTest {
        source: "\u{1D7C7}",
        nfc: "\u{1D7C7}",
        nfd: "\u{1D7C7}",
        nfkc: "\u{03C6}",
        nfkd: "\u{03C6}",
    },
    NormalizationTest {
        source: "\u{1D7C8}",
        nfc: "\u{1D7C8}",
        nfd: "\u{1D7C8}",
        nfkc: "\u{03C1}",
        nfkd: "\u{03C1}",
    },
    NormalizationTest {
        source: "\u{1D7C9}",
        nfc: "\u{1D7C9}",
        nfd: "\u{1D7C9}",
        nfkc: "\u{03C0}",
        nfkd: "\u{03C0}",
    },
    NormalizationTest {
        source: "\u{1D7CA}",
        nfc: "\u{1D7CA}",
        nfd: "\u{1D7CA}",
        nfkc: "\u{03DC}",
        nfkd: "\u{03DC}",
    },
    NormalizationTest {
        source: "\u{1D7CB}",
        nfc: "\u{1D7CB}",
        nfd: "\u{1D7CB}",
        nfkc: "\u{03DD}",
        nfkd: "\u{03DD}",
    },
    NormalizationTest {
        source: "\u{1D7CE}",
        nfc: "\u{1D7CE}",
        nfd: "\u{1D7CE}",
        nfkc: "\u{0030}",
        nfkd: "\u{0030}",
    },
    NormalizationTest {
        source: "\u{1D7CF}",
        nfc: "\u{1D7CF}",
        nfd: "\u{1D7CF}",
        nfkc: "\u{0031}",
        nfkd: "\u{0031}",
    },
    NormalizationTest {
        source: "\u{1D7D0}",
        nfc: "\u{1D7D0}",
        nfd: "\u{1D7D0}",
        nfkc: "\u{0032}",
        nfkd: "\u{0032}",
    },
    NormalizationTest {
        source: "\u{1D7D1}",
        nfc: "\u{1D7D1}",
        nfd: "\u{1D7D1}",
        nfkc: "\u{0033}",
        nfkd: "\u{0033}",
    },
    NormalizationTest {
        source: "\u{1D7D2}",
        nfc: "\u{1D7D2}",
        nfd: "\u{1D7D2}",
        nfkc: "\u{0034}",
        nfkd: "\u{0034}",
    },
    NormalizationTest {
        source: "\u{1D7D3}",
        nfc: "\u{1D7D3}",
        nfd: "\u{1D7D3}",
        nfkc: "\u{0035}",
        nfkd: "\u{0035}",
    },
    NormalizationTest {
        source: "\u{1D7D4}",
        nfc: "\u{1D7D4}",
        nfd: "\u{1D7D4}",
        nfkc: "\u{0036}",
        nfkd: "\u{0036}",
    },
    NormalizationTest {
        source: "\u{1D7D5}",
        nfc: "\u{1D7D5}",
        nfd: "\u{1D7D5}",
        nfkc: "\u{0037}",
        nfkd: "\u{0037}",
    },
    NormalizationTest {
        source: "\u{1D7D6}",
        nfc: "\u{1D7D6}",
        nfd: "\u{1D7D6}",
        nfkc: "\u{0038}",
        nfkd: "\u{0038}",
    },
    NormalizationTest {
        source: "\u{1D7D7}",
        nfc: "\u{1D7D7}",
        nfd: "\u{1D7D7}",
        nfkc: "\u{0039}",
        nfkd: "\u{0039}",
    },
    NormalizationTest {
        source: "\u{1D7D8}",
        nfc: "\u{1D7D8}",
        nfd: "\u{1D7D8}",
        nfkc: "\u{0030}",
        nfkd: "\u{0030}",
    },
    NormalizationTest {
        source: "\u{1D7D9}",
        nfc: "\u{1D7D9}",
        nfd: "\u{1D7D9}",
        nfkc: "\u{0031}",
        nfkd: "\u{0031}",
    },
    NormalizationTest {
        source: "\u{1D7DA}",
        nfc: "\u{1D7DA}",
        nfd: "\u{1D7DA}",
        nfkc: "\u{0032}",
        nfkd: "\u{0032}",
    },
    NormalizationTest {
        source: "\u{1D7DB}",
        nfc: "\u{1D7DB}",
        nfd: "\u{1D7DB}",
        nfkc: "\u{0033}",
        nfkd: "\u{0033}",
    },
    NormalizationTest {
        source: "\u{1D7DC}",
        nfc: "\u{1D7DC}",
        nfd: "\u{1D7DC}",
        nfkc: "\u{0034}",
        nfkd: "\u{0034}",
    },
    NormalizationTest {
        source: "\u{1D7DD}",
        nfc: "\u{1D7DD}",
        nfd: "\u{1D7DD}",
        nfkc: "\u{0035}",
        nfkd: "\u{0035}",
    },
    NormalizationTest {
        source: "\u{1D7DE}",
        nfc: "\u{1D7DE}",
        nfd: "\u{1D7DE}",
        nfkc: "\u{0036}",
        nfkd: "\u{0036}",
    },
    NormalizationTest {
        source: "\u{1D7DF}",
        nfc: "\u{1D7DF}",
        nfd: "\u{1D7DF}",
        nfkc: "\u{0037}",
        nfkd: "\u{0037}",
    },
    NormalizationTest {
        source: "\u{1D7E0}",
        nfc: "\u{1D7E0}",
        nfd: "\u{1D7E0}",
        nfkc: "\u{0038}",
        nfkd: "\u{0038}",
    },
    NormalizationTest {
        source: "\u{1D7E1}",
        nfc: "\u{1D7E1}",
        nfd: "\u{1D7E1}",
        nfkc: "\u{0039}",
        nfkd: "\u{0039}",
    },
    NormalizationTest {
        source: "\u{1D7E2}",
        nfc: "\u{1D7E2}",
        nfd: "\u{1D7E2}",
        nfkc: "\u{0030}",
        nfkd: "\u{0030}",
    },
    NormalizationTest {
        source: "\u{1D7E3}",
        nfc: "\u{1D7E3}",
        nfd: "\u{1D7E3}",
        nfkc: "\u{0031}",
        nfkd: "\u{0031}",
    },
    NormalizationTest {
        source: "\u{1D7E4}",
        nfc: "\u{1D7E4}",
        nfd: "\u{1D7E4}",
        nfkc: "\u{0032}",
        nfkd: "\u{0032}",
    },
    NormalizationTest {
        source: "\u{1D7E5}",
        nfc: "\u{1D7E5}",
        nfd: "\u{1D7E5}",
        nfkc: "\u{0033}",
        nfkd: "\u{0033}",
    },
    NormalizationTest {
        source: "\u{1D7E6}",
        nfc: "\u{1D7E6}",
        nfd: "\u{1D7E6}",
        nfkc: "\u{0034}",
        nfkd: "\u{0034}",
    },
    NormalizationTest {
        source: "\u{1D7E7}",
        nfc: "\u{1D7E7}",
        nfd: "\u{1D7E7}",
        nfkc: "\u{0035}",
        nfkd: "\u{0035}",
    },
    NormalizationTest {
        source: "\u{1D7E8}",
        nfc: "\u{1D7E8}",
        nfd: "\u{1D7E8}",
        nfkc: "\u{0036}",
        nfkd: "\u{0036}",
    },
    NormalizationTest {
        source: "\u{1D7E9}",
        nfc: "\u{1D7E9}",
        nfd: "\u{1D7E9}",
        nfkc: "\u{0037}",
        nfkd: "\u{0037}",
    },
    NormalizationTest {
        source: "\u{1D7EA}",
        nfc: "\u{1D7EA}",
        nfd: "\u{1D7EA}",
        nfkc: "\u{0038}",
        nfkd: "\u{0038}",
    },
    NormalizationTest {
        source: "\u{1D7EB}",
        nfc: "\u{1D7EB}",
        nfd: "\u{1D7EB}",
        nfkc: "\u{0039}",
        nfkd: "\u{0039}",
    },
    NormalizationTest {
        source: "\u{1D7EC}",
        nfc: "\u{1D7EC}",
        nfd: "\u{1D7EC}",
        nfkc: "\u{0030}",
        nfkd: "\u{0030}",
    },
    NormalizationTest {
        source: "\u{1D7ED}",
        nfc: "\u{1D7ED}",
        nfd: "\u{1D7ED}",
        nfkc: "\u{0031}",
        nfkd: "\u{0031}",
    },
    NormalizationTest {
        source: "\u{1D7EE}",
        nfc: "\u{1D7EE}",
        nfd: "\u{1D7EE}",
        nfkc: "\u{0032}",
        nfkd: "\u{0032}",
    },
    NormalizationTest {
        source: "\u{1D7EF}",
        nfc: "\u{1D7EF}",
        nfd: "\u{1D7EF}",
        nfkc: "\u{0033}",
        nfkd: "\u{0033}",
    },
    NormalizationTest {
        source: "\u{1D7F0}",
        nfc: "\u{1D7F0}",
        nfd: "\u{1D7F0}",
        nfkc: "\u{0034}",
        nfkd: "\u{0034}",
    },
    NormalizationTest {
        source: "\u{1D7F1}",
        nfc: "\u{1D7F1}",
        nfd: "\u{1D7F1}",
        nfkc: "\u{0035}",
        nfkd: "\u{0035}",
    },
    NormalizationTest {
        source: "\u{1D7F2}",
        nfc: "\u{1D7F2}",
        nfd: "\u{1D7F2}",
        nfkc: "\u{0036}",
        nfkd: "\u{0036}",
    },
    NormalizationTest {
        source: "\u{1D7F3}",
        nfc: "\u{1D7F3}",
        nfd: "\u{1D7F3}",
        nfkc: "\u{0037}",
        nfkd: "\u{0037}",
    },
    NormalizationTest {
        source: "\u{1D7F4}",
        nfc: "\u{1D7F4}",
        nfd: "\u{1D7F4}",
        nfkc: "\u{0038}",
        nfkd: "\u{0038}",
    },
    NormalizationTest {
        source: "\u{1D7F5}",
        nfc: "\u{1D7F5}",
        nfd: "\u{1D7F5}",
        nfkc: "\u{0039}",
        nfkd: "\u{0039}",
    },
    NormalizationTest {
        source: "\u{1D7F6}",
        nfc: "\u{1D7F6}",
        nfd: "\u{1D7F6}",
        nfkc: "\u{0030}",
        nfkd: "\u{0030}",
    },
    NormalizationTest {
        source: "\u{1D7F7}",
        nfc: "\u{1D7F7}",
        nfd: "\u{1D7F7}",
        nfkc: "\u{0031}",
        nfkd: "\u{0031}",
    },
    NormalizationTest {
        source: "\u{1D7F8}",
        nfc: "\u{1D7F8}",
        nfd: "\u{1D7F8}",
        nfkc: "\u{0032}",
        nfkd: "\u{0032}",
    },
    NormalizationTest {
        source: "\u{1D7F9}",
        nfc: "\u{1D7F9}",
        nfd: "\u{1D7F9}",
        nfkc: "\u{0033}",
        nfkd: "\u{0033}",
    },
    NormalizationTest {
        source: "\u{1D7FA}",
        nfc: "\u{1D7FA}",
        nfd: "\u{1D7FA}",
        nfkc: "\u{0034}",
        nfkd: "\u{0034}",
    },
    NormalizationTest {
        source: "\u{1D7FB}",
        nfc: "\u{1D7FB}",
        nfd: "\u{1D7FB}",
        nfkc: "\u{0035}",
        nfkd: "\u{0035}",
    },
    NormalizationTest {
        source: "\u{1D7FC}",
        nfc: "\u{1D7FC}",
        nfd: "\u{1D7FC}",
        nfkc: "\u{0036}",
        nfkd: "\u{0036}",
    },
    NormalizationTest {
        source: "\u{1D7FD}",
        nfc: "\u{1D7FD}",
        nfd: "\u{1D7FD}",
        nfkc: "\u{0037}",
        nfkd: "\u{0037}",
    },
    NormalizationTest {
        source: "\u{1D7FE}",
        nfc: "\u{1D7FE}",
        nfd: "\u{1D7FE}",
        nfkc: "\u{0038}",
        nfkd: "\u{0038}",
    },
    NormalizationTest {
        source: "\u{1D7FF}",
        nfc: "\u{1D7FF}",
        nfd: "\u{1D7FF}",
        nfkc: "\u{0039}",
        nfkd: "\u{0039}",
    },
    NormalizationTest {
        source: "\u{1EE00}",
        nfc: "\u{1EE00}",
        nfd: "\u{1EE00}",
        nfkc: "\u{0627}",
        nfkd: "\u{0627}",
    },
    NormalizationTest {
        source: "\u{1EE01}",
        nfc: "\u{1EE01}",
        nfd: "\u{1EE01}",
        nfkc: "\u{0628}",
        nfkd: "\u{0628}",
    },
    NormalizationTest {
        source: "\u{1EE02}",
        nfc: "\u{1EE02}",
        nfd: "\u{1EE02}",
        nfkc: "\u{062C}",
        nfkd: "\u{062C}",
    },
    NormalizationTest {
        source: "\u{1EE03}",
        nfc: "\u{1EE03}",
        nfd: "\u{1EE03}",
        nfkc: "\u{062F}",
        nfkd: "\u{062F}",
    },
    NormalizationTest {
        source: "\u{1EE05}",
        nfc: "\u{1EE05}",
        nfd: "\u{1EE05}",
        nfkc: "\u{0648}",
        nfkd: "\u{0648}",
    },
    NormalizationTest {
        source: "\u{1EE06}",
        nfc: "\u{1EE06}",
        nfd: "\u{1EE06}",
        nfkc: "\u{0632}",
        nfkd: "\u{0632}",
    },
    NormalizationTest {
        source: "\u{1EE07}",
        nfc: "\u{1EE07}",
        nfd: "\u{1EE07}",
        nfkc: "\u{062D}",
        nfkd: "\u{062D}",
    },
    NormalizationTest {
        source: "\u{1EE08}",
        nfc: "\u{1EE08}",
        nfd: "\u{1EE08}",
        nfkc: "\u{0637}",
        nfkd: "\u{0637}",
    },
    NormalizationTest {
        source: "\u{1EE09}",
        nfc: "\u{1EE09}",
        nfd: "\u{1EE09}",
        nfkc: "\u{064A}",
        nfkd: "\u{064A}",
    },
    NormalizationTest {
        source: "\u{1EE0A}",
        nfc: "\u{1EE0A}",
        nfd: "\u{1EE0A}",
        nfkc: "\u{0643}",
        nfkd: "\u{0643}",
    },
    NormalizationTest {
        source: "\u{1EE0B}",
        nfc: "\u{1EE0B}",
        nfd: "\u{1EE0B}",
        nfkc: "\u{0644}",
        nfkd: "\u{0644}",
    },
    NormalizationTest {
        source: "\u{1EE0C}",
        nfc: "\u{1EE0C}",
        nfd: "\u{1EE0C}",
        nfkc: "\u{0645}",
        nfkd: "\u{0645}",
    },
    NormalizationTest {
        source: "\u{1EE0D}",
        nfc: "\u{1EE0D}",
        nfd: "\u{1EE0D}",
        nfkc: "\u{0646}",
        nfkd: "\u{0646}",
    },
    NormalizationTest {
        source: "\u{1EE0E}",
        nfc: "\u{1EE0E}",
        nfd: "\u{1EE0E}",
        nfkc: "\u{0633}",
        nfkd: "\u{0633}",
    },
    NormalizationTest {
        source: "\u{1EE0F}",
        nfc: "\u{1EE0F}",
        nfd: "\u{1EE0F}",
        nfkc: "\u{0639}",
        nfkd: "\u{0639}",
    },
    NormalizationTest {
        source: "\u{1EE10}",
        nfc: "\u{1EE10}",
        nfd: "\u{1EE10}",
        nfkc: "\u{0641}",
        nfkd: "\u{0641}",
    },
    NormalizationTest {
        source: "\u{1EE11}",
        nfc: "\u{1EE11}",
        nfd: "\u{1EE11}",
        nfkc: "\u{0635}",
        nfkd: "\u{0635}",
    },
    NormalizationTest {
        source: "\u{1EE12}",
        nfc: "\u{1EE12}",
        nfd: "\u{1EE12}",
        nfkc: "\u{0642}",
        nfkd: "\u{0642}",
    },
    NormalizationTest {
        source: "\u{1EE13}",
        nfc: "\u{1EE13}",
        nfd: "\u{1EE13}",
        nfkc: "\u{0631}",
        nfkd: "\u{0631}",
    },
    NormalizationTest {
        source: "\u{1EE14}",
        nfc: "\u{1EE14}",
        nfd: "\u{1EE14}",
        nfkc: "\u{0634}",
        nfkd: "\u{0634}",
    },
    NormalizationTest {
        source: "\u{1EE15}",
        nfc: "\u{1EE15}",
        nfd: "\u{1EE15}",
        nfkc: "\u{062A}",
        nfkd: "\u{062A}",
    },
    NormalizationTest {
        source: "\u{1EE16}",
        nfc: "\u{1EE16}",
        nfd: "\u{1EE16}",
        nfkc: "\u{062B}",
        nfkd: "\u{062B}",
    },
    NormalizationTest {
        source: "\u{1EE17}",
        nfc: "\u{1EE17}",
        nfd: "\u{1EE17}",
        nfkc: "\u{062E}",
        nfkd: "\u{062E}",
    },
    NormalizationTest {
        source: "\u{1EE18}",
        nfc: "\u{1EE18}",
        nfd: "\u{1EE18}",
        nfkc: "\u{0630}",
        nfkd: "\u{0630}",
    },
    NormalizationTest {
        source: "\u{1EE19}",
        nfc: "\u{1EE19}",
        nfd: "\u{1EE19}",
        nfkc: "\u{0636}",
        nfkd: "\u{0636}",
    },
    NormalizationTest {
        source: "\u{1EE1A}",
        nfc: "\u{1EE1A}",
        nfd: "\u{1EE1A}",
        nfkc: "\u{0638}",
        nfkd: "\u{0638}",
    },
    NormalizationTest {
        source: "\u{1EE1B}",
        nfc: "\u{1EE1B}",
        nfd: "\u{1EE1B}",
        nfkc: "\u{063A}",
        nfkd: "\u{063A}",
    },
    NormalizationTest {
        source: "\u{1EE1C}",
        nfc: "\u{1EE1C}",
        nfd: "\u{1EE1C}",
        nfkc: "\u{066E}",
        nfkd: "\u{066E}",
    },
    NormalizationTest {
        source: "\u{1EE1D}",
        nfc: "\u{1EE1D}",
        nfd: "\u{1EE1D}",
        nfkc: "\u{06BA}",
        nfkd: "\u{06BA}",
    },
    NormalizationTest {
        source: "\u{1EE1E}",
        nfc: "\u{1EE1E}",
        nfd: "\u{1EE1E}",
        nfkc: "\u{06A1}",
        nfkd: "\u{06A1}",
    },
    NormalizationTest {
        source: "\u{1EE1F}",
        nfc: "\u{1EE1F}",
        nfd: "\u{1EE1F}",
        nfkc: "\u{066F}",
        nfkd: "\u{066F}",
    },
    NormalizationTest {
        source: "\u{1EE21}",
        nfc: "\u{1EE21}",
        nfd: "\u{1EE21}",
        nfkc: "\u{0628}",
        nfkd: "\u{0628}",
    },
    NormalizationTest {
        source: "\u{1EE22}",
        nfc: "\u{1EE22}",
        nfd: "\u{1EE22}",
        nfkc: "\u{062C}",
        nfkd: "\u{062C}",
    },
    NormalizationTest {
        source: "\u{1EE24}",
        nfc: "\u{1EE24}",
        nfd: "\u{1EE24}",
        nfkc: "\u{0647}",
        nfkd: "\u{0647}",
    },
    NormalizationTest {
        source: "\u{1EE27}",
        nfc: "\u{1EE27}",
        nfd: "\u{1EE27}",
        nfkc: "\u{062D}",
        nfkd: "\u{062D}",
    },
    NormalizationTest {
        source: "\u{1EE29}",
        nfc: "\u{1EE29}",
        nfd: "\u{1EE29}",
        nfkc: "\u{064A}",
        nfkd: "\u{064A}",
    },
    NormalizationTest {
        source: "\u{1EE2A}",
        nfc: "\u{1EE2A}",
        nfd: "\u{1EE2A}",
        nfkc: "\u{0643}",
        nfkd: "\u{0643}",
    },
    NormalizationTest {
        source: "\u{1EE2B}",
        nfc: "\u{1EE2B}",
        nfd: "\u{1EE2B}",
        nfkc: "\u{0644}",
        nfkd: "\u{0644}",
    },
    NormalizationTest {
        source: "\u{1EE2C}",
        nfc: "\u{1EE2C}",
        nfd: "\u{1EE2C}",
        nfkc: "\u{0645}",
        nfkd: "\u{0645}",
    },
    NormalizationTest {
        source: "\u{1EE2D}",
        nfc: "\u{1EE2D}",
        nfd: "\u{1EE2D}",
        nfkc: "\u{0646}",
        nfkd: "\u{0646}",
    },
    NormalizationTest {
        source: "\u{1EE2E}",
        nfc: "\u{1EE2E}",
        nfd: "\u{1EE2E}",
        nfkc: "\u{0633}",
        nfkd: "\u{0633}",
    },
    NormalizationTest {
        source: "\u{1EE2F}",
        nfc: "\u{1EE2F}",
        nfd: "\u{1EE2F}",
        nfkc: "\u{0639}",
        nfkd: "\u{0639}",
    },
    NormalizationTest {
        source: "\u{1EE30}",
        nfc: "\u{1EE30}",
        nfd: "\u{1EE30}",
        nfkc: "\u{0641}",
        nfkd: "\u{0641}",
    },
    NormalizationTest {
        source: "\u{1EE31}",
        nfc: "\u{1EE31}",
        nfd: "\u{1EE31}",
        nfkc: "\u{0635}",
        nfkd: "\u{0635}",
    },
    NormalizationTest {
        source: "\u{1EE32}",
        nfc: "\u{1EE32}",
        nfd: "\u{1EE32}",
        nfkc: "\u{0642}",
        nfkd: "\u{0642}",
    },
    NormalizationTest {
        source: "\u{1EE34}",
        nfc: "\u{1EE34}",
        nfd: "\u{1EE34}",
        nfkc: "\u{0634}",
        nfkd: "\u{0634}",
    },
    NormalizationTest {
        source: "\u{1EE35}",
        nfc: "\u{1EE35}",
        nfd: "\u{1EE35}",
        nfkc: "\u{062A}",
        nfkd: "\u{062A}",
    },
    NormalizationTest {
        source: "\u{1EE36}",
        nfc: "\u{1EE36}",
        nfd: "\u{1EE36}",
        nfkc: "\u{062B}",
        nfkd: "\u{062B}",
    },
    NormalizationTest {
        source: "\u{1EE37}",
        nfc: "\u{1EE37}",
        nfd: "\u{1EE37}",
        nfkc: "\u{062E}",
        nfkd: "\u{062E}",
    },
    NormalizationTest {
        source: "\u{1EE39}",
        nfc: "\u{1EE39}",
        nfd: "\u{1EE39}",
        nfkc: "\u{0636}",
        nfkd: "\u{0636}",
    },
    NormalizationTest {
        source: "\u{1EE3B}",
        nfc: "\u{1EE3B}",
        nfd: "\u{1EE3B}",
        nfkc: "\u{063A}",
        nfkd: "\u{063A}",
    },
    NormalizationTest {
        source: "\u{1EE42}",
        nfc: "\u{1EE42}",
        nfd: "\u{1EE42}",
        nfkc: "\u{062C}",
        nfkd: "\u{062C}",
    },
    NormalizationTest {
        source: "\u{1EE47}",
        nfc: "\u{1EE47}",
        nfd: "\u{1EE47}",
        nfkc: "\u{062D}",
        nfkd: "\u{062D}",
    },
    NormalizationTest {
        source: "\u{1EE49}",
        nfc: "\u{1EE49}",
        nfd: "\u{1EE49}",
        nfkc: "\u{064A}",
        nfkd: "\u{064A}",
    },
    NormalizationTest {
        source: "\u{1EE4B}",
        nfc: "\u{1EE4B}",
        nfd: "\u{1EE4B}",
        nfkc: "\u{0644}",
        nfkd: "\u{0644}",
    },
    NormalizationTest {
        source: "\u{1EE4D}",
        nfc: "\u{1EE4D}",
        nfd: "\u{1EE4D}",
        nfkc: "\u{0646}",
        nfkd: "\u{0646}",
    },
    NormalizationTest {
        source: "\u{1EE4E}",
        nfc: "\u{1EE4E}",
        nfd: "\u{1EE4E}",
        nfkc: "\u{0633}",
        nfkd: "\u{0633}",
    },
    NormalizationTest {
        source: "\u{1EE4F}",
        nfc: "\u{1EE4F}",
        nfd: "\u{1EE4F}",
        nfkc: "\u{0639}",
        nfkd: "\u{0639}",
    },
    NormalizationTest {
        source: "\u{1EE51}",
        nfc: "\u{1EE51}",
        nfd: "\u{1EE51}",
        nfkc: "\u{0635}",
        nfkd: "\u{0635}",
    },
    NormalizationTest {
        source: "\u{1EE52}",
        nfc: "\u{1EE52}",
        nfd: "\u{1EE52}",
        nfkc: "\u{0642}",
        nfkd: "\u{0642}",
    },
    NormalizationTest {
        source: "\u{1EE54}",
        nfc: "\u{1EE54}",
        nfd: "\u{1EE54}",
        nfkc: "\u{0634}",
        nfkd: "\u{0634}",
    },
    NormalizationTest {
        source: "\u{1EE57}",
        nfc: "\u{1EE57}",
        nfd: "\u{1EE57}",
        nfkc: "\u{062E}",
        nfkd: "\u{062E}",
    },
    NormalizationTest {
        source: "\u{1EE59}",
        nfc: "\u{1EE59}",
        nfd: "\u{1EE59}",
        nfkc: "\u{0636}",
        nfkd: "\u{0636}",
    },
    NormalizationTest {
        source: "\u{1EE5B}",
        nfc: "\u{1EE5B}",
        nfd: "\u{1EE5B}",
        nfkc: "\u{063A}",
        nfkd: "\u{063A}",
    },
    NormalizationTest {
        source: "\u{1EE5D}",
        nfc: "\u{1EE5D}",
        nfd: "\u{1EE5D}",
        nfkc: "\u{06BA}",
        nfkd: "\u{06BA}",
    },
    NormalizationTest {
        source: "\u{1EE5F}",
        nfc: "\u{1EE5F}",
        nfd: "\u{1EE5F}",
        nfkc: "\u{066F}",
        nfkd: "\u{066F}",
    },
    NormalizationTest {
        source: "\u{1EE61}",
        nfc: "\u{1EE61}",
        nfd: "\u{1EE61}",
        nfkc: "\u{0628}",
        nfkd: "\u{0628}",
    },
    NormalizationTest {
        source: "\u{1EE62}",
        nfc: "\u{1EE62}",
        nfd: "\u{1EE62}",
        nfkc: "\u{062C}",
        nfkd: "\u{062C}",
    },
    NormalizationTest {
        source: "\u{1EE64}",
        nfc: "\u{1EE64}",
        nfd: "\u{1EE64}",
        nfkc: "\u{0647}",
        nfkd: "\u{0647}",
    },
    NormalizationTest {
        source: "\u{1EE67}",
        nfc: "\u{1EE67}",
        nfd: "\u{1EE67}",
        nfkc: "\u{062D}",
        nfkd: "\u{062D}",
    },
    NormalizationTest {
        source: "\u{1EE68}",
        nfc: "\u{1EE68}",
        nfd: "\u{1EE68}",
        nfkc: "\u{0637}",
        nfkd: "\u{0637}",
    },
    NormalizationTest {
        source: "\u{1EE69}",
        nfc: "\u{1EE69}",
        nfd: "\u{1EE69}",
        nfkc: "\u{064A}",
        nfkd: "\u{064A}",
    },
    NormalizationTest {
        source: "\u{1EE6A}",
        nfc: "\u{1EE6A}",
        nfd: "\u{1EE6A}",
        nfkc: "\u{0643}",
        nfkd: "\u{0643}",
    },
    NormalizationTest {
        source: "\u{1EE6C}",
        nfc: "\u{1EE6C}",
        nfd: "\u{1EE6C}",
        nfkc: "\u{0645}",
        nfkd: "\u{0645}",
    },
    NormalizationTest {
        source: "\u{1EE6D}",
        nfc: "\u{1EE6D}",
        nfd: "\u{1EE6D}",
        nfkc: "\u{0646}",
        nfkd: "\u{0646}",
    },
    NormalizationTest {
        source: "\u{1EE6E}",
        nfc: "\u{1EE6E}",
        nfd: "\u{1EE6E}",
        nfkc: "\u{0633}",
        nfkd: "\u{0633}",
    },
    NormalizationTest {
        source: "\u{1EE6F}",
        nfc: "\u{1EE6F}",
        nfd: "\u{1EE6F}",
        nfkc: "\u{0639}",
        nfkd: "\u{0639}",
    },
    NormalizationTest {
        source: "\u{1EE70}",
        nfc: "\u{1EE70}",
        nfd: "\u{1EE70}",
        nfkc: "\u{0641}",
        nfkd: "\u{0641}",
    },
    NormalizationTest {
        source: "\u{1EE71}",
        nfc: "\u{1EE71}",
        nfd: "\u{1EE71}",
        nfkc: "\u{0635}",
        nfkd: "\u{0635}",
    },
    NormalizationTest {
        source: "\u{1EE72}",
        nfc: "\u{1EE72}",
        nfd: "\u{1EE72}",
        nfkc: "\u{0642}",
        nfkd: "\u{0642}",
    },
    NormalizationTest {
        source: "\u{1EE74}",
        nfc: "\u{1EE74}",
        nfd: "\u{1EE74}",
        nfkc: "\u{0634}",
        nfkd: "\u{0634}",
    },
    NormalizationTest {
        source: "\u{1EE75}",
        nfc: "\u{1EE75}",
        nfd: "\u{1EE75}",
        nfkc: "\u{062A}",
        nfkd: "\u{062A}",
    },
    NormalizationTest {
        source: "\u{1EE76}",
        nfc: "\u{1EE76}",
        nfd: "\u{1EE76}",
        nfkc: "\u{062B}",
        nfkd: "\u{062B}",
    },
    NormalizationTest {
        source: "\u{1EE77}",
        nfc: "\u{1EE77}",
        nfd: "\u{1EE77}",
        nfkc: "\u{062E}",
        nfkd: "\u{062E}",
    },
    NormalizationTest {
        source: "\u{1EE79}",
        nfc: "\u{1EE79}",
        nfd: "\u{1EE79}",
        nfkc: "\u{0636}",
        nfkd: "\u{0636}",
    },
    NormalizationTest {
        source: "\u{1EE7A}",
        nfc: "\u{1EE7A}",
        nfd: "\u{1EE7A}",
        nfkc: "\u{0638}",
        nfkd: "\u{0638}",
    },
    NormalizationTest {
        source: "\u{1EE7B}",
        nfc: "\u{1EE7B}",
        nfd: "\u{1EE7B}",
        nfkc: "\u{063A}",
        nfkd: "\u{063A}",
    },
    NormalizationTest {
        source: "\u{1EE7C}",
        nfc: "\u{1EE7C}",
        nfd: "\u{1EE7C}",
        nfkc: "\u{066E}",
        nfkd: "\u{066E}",
    },
    NormalizationTest {
        source: "\u{1EE7E}",
        nfc: "\u{1EE7E}",
        nfd: "\u{1EE7E}",
        nfkc: "\u{06A1}",
        nfkd: "\u{06A1}",
    },
    NormalizationTest {
        source: "\u{1EE80}",
        nfc: "\u{1EE80}",
        nfd: "\u{1EE80}",
        nfkc: "\u{0627}",
        nfkd: "\u{0627}",
    },
    NormalizationTest {
        source: "\u{1EE81}",
        nfc: "\u{1EE81}",
        nfd: "\u{1EE81}",
        nfkc: "\u{0628}",
        nfkd: "\u{0628}",
    },
    NormalizationTest {
        source: "\u{1EE82}",
        nfc: "\u{1EE82}",
        nfd: "\u{1EE82}",
        nfkc: "\u{062C}",
        nfkd: "\u{062C}",
    },
    NormalizationTest {
        source: "\u{1EE83}",
        nfc: "\u{1EE83}",
        nfd: "\u{1EE83}",
        nfkc: "\u{062F}",
        nfkd: "\u{062F}",
    },
    NormalizationTest {
        source: "\u{1EE84}",
        nfc: "\u{1EE84}",
        nfd: "\u{1EE84}",
        nfkc: "\u{0647}",
        nfkd: "\u{0647}",
    },
    NormalizationTest {
        source: "\u{1EE85}",
        nfc: "\u{1EE85}",
        nfd: "\u{1EE85}",
        nfkc: "\u{0648}",
        nfkd: "\u{0648}",
    },
    NormalizationTest {
        source: "\u{1EE86}",
        nfc: "\u{1EE86}",
        nfd: "\u{1EE86}",
        nfkc: "\u{0632}",
        nfkd: "\u{0632}",
    },
    NormalizationTest {
        source: "\u{1EE87}",
        nfc: "\u{1EE87}",
        nfd: "\u{1EE87}",
        nfkc: "\u{062D}",
        nfkd: "\u{062D}",
    },
    NormalizationTest {
        source: "\u{1EE88}",
        nfc: "\u{1EE88}",
        nfd: "\u{1EE88}",
        nfkc: "\u{0637}",
        nfkd: "\u{0637}",
    },
    NormalizationTest {
        source: "\u{1EE89}",
        nfc: "\u{1EE89}",
        nfd: "\u{1EE89}",
        nfkc: "\u{064A}",
        nfkd: "\u{064A}",
    },
    NormalizationTest {
        source: "\u{1EE8B}",
        nfc: "\u{1EE8B}",
        nfd: "\u{1EE8B}",
        nfkc: "\u{0644}",
        nfkd: "\u{0644}",
    },
    NormalizationTest {
        source: "\u{1EE8C}",
        nfc: "\u{1EE8C}",
        nfd: "\u{1EE8C}",
        nfkc: "\u{0645}",
        nfkd: "\u{0645}",
    },
    NormalizationTest {
        source: "\u{1EE8D}",
        nfc: "\u{1EE8D}",
        nfd: "\u{1EE8D}",
        nfkc: "\u{0646}",
        nfkd: "\u{0646}",
    },
    NormalizationTest {
        source: "\u{1EE8E}",
        nfc: "\u{1EE8E}",
        nfd: "\u{1EE8E}",
        nfkc: "\u{0633}",
        nfkd: "\u{0633}",
    },
    NormalizationTest {
        source: "\u{1EE8F}",
        nfc: "\u{1EE8F}",
        nfd: "\u{1EE8F}",
        nfkc: "\u{0639}",
        nfkd: "\u{0639}",
    },
    NormalizationTest {
        source: "\u{1EE90}",
        nfc: "\u{1EE90}",
        nfd: "\u{1EE90}",
        nfkc: "\u{0641}",
        nfkd: "\u{0641}",
    },
    NormalizationTest {
        source: "\u{1EE91}",
        nfc: "\u{1EE91}",
        nfd: "\u{1EE91}",
        nfkc: "\u{0635}",
        nfkd: "\u{0635}",
    },
    NormalizationTest {
        source: "\u{1EE92}",
        nfc: "\u{1EE92}",
        nfd: "\u{1EE92}",
        nfkc: "\u{0642}",
        nfkd: "\u{0642}",
    },
    NormalizationTest {
        source: "\u{1EE93}",
        nfc: "\u{1EE93}",
        nfd: "\u{1EE93}",
        nfkc: "\u{0631}",
        nfkd: "\u{0631}",
    },
    NormalizationTest {
        source: "\u{1EE94}",
        nfc: "\u{1EE94}",
        nfd: "\u{1EE94}",
        nfkc: "\u{0634}",
        nfkd: "\u{0634}",
    },
    NormalizationTest {
        source: "\u{1EE95}",
        nfc: "\u{1EE95}",
        nfd: "\u{1EE95}",
        nfkc: "\u{062A}",
        nfkd: "\u{062A}",
    },
    NormalizationTest {
        source: "\u{1EE96}",
        nfc: "\u{1EE96}",
        nfd: "\u{1EE96}",
        nfkc: "\u{062B}",
        nfkd: "\u{062B}",
    },
    NormalizationTest {
        source: "\u{1EE97}",
        nfc: "\u{1EE97}",
        nfd: "\u{1EE97}",
        nfkc: "\u{062E}",
        nfkd: "\u{062E}",
    },
    NormalizationTest {
        source: "\u{1EE98}",
        nfc: "\u{1EE98}",
        nfd: "\u{1EE98}",
        nfkc: "\u{0630}",
        nfkd: "\u{0630}",
    },
    NormalizationTest {
        source: "\u{1EE99}",
        nfc: "\u{1EE99}",
        nfd: "\u{1EE99}",
        nfkc: "\u{0636}",
        nfkd: "\u{0636}",
    },
    NormalizationTest {
        source: "\u{1EE9A}",
        nfc: "\u{1EE9A}",
        nfd: "\u{1EE9A}",
        nfkc: "\u{0638}",
        nfkd: "\u{0638}",
    },
    NormalizationTest {
        source: "\u{1EE9B}",
        nfc: "\u{1EE9B}",
        nfd: "\u{1EE9B}",
        nfkc: "\u{063A}",
        nfkd: "\u{063A}",
    },
    NormalizationTest {
        source: "\u{1EEA1}",
        nfc: "\u{1EEA1}",
        nfd: "\u{1EEA1}",
        nfkc: "\u{0628}",
        nfkd: "\u{0628}",
    },
    NormalizationTest {
        source: "\u{1EEA2}",
        nfc: "\u{1EEA2}",
        nfd: "\u{1EEA2}",
        nfkc: "\u{062C}",
        nfkd: "\u{062C}",
    },
    NormalizationTest {
        source: "\u{1EEA3}",
        nfc: "\u{1EEA3}",
        nfd: "\u{1EEA3}",
        nfkc: "\u{062F}",
        nfkd: "\u{062F}",
    },
    NormalizationTest {
        source: "\u{1EEA5}",
        nfc: "\u{1EEA5}",
        nfd: "\u{1EEA5}",
        nfkc: "\u{0648}",
        nfkd: "\u{0648}",
    },
    NormalizationTest {
        source: "\u{1EEA6}",
        nfc: "\u{1EEA6}",
        nfd: "\u{1EEA6}",
        nfkc: "\u{0632}",
        nfkd: "\u{0632}",
    },
    NormalizationTest {
        source: "\u{1EEA7}",
        nfc: "\u{1EEA7}",
        nfd: "\u{1EEA7}",
        nfkc: "\u{062D}",
        nfkd: "\u{062D}",
    },
    NormalizationTest {
        source: "\u{1EEA8}",
        nfc: "\u{1EEA8}",
        nfd: "\u{1EEA8}",
        nfkc: "\u{0637}",
        nfkd: "\u{0637}",
    },
    NormalizationTest {
        source: "\u{1EEA9}",
        nfc: "\u{1EEA9}",
        nfd: "\u{1EEA9}",
        nfkc: "\u{064A}",
        nfkd: "\u{064A}",
    },
    NormalizationTest {
        source: "\u{1EEAB}",
        nfc: "\u{1EEAB}",
        nfd: "\u{1EEAB}",
        nfkc: "\u{0644}",
        nfkd: "\u{0644}",
    },
    NormalizationTest {
        source: "\u{1EEAC}",
        nfc: "\u{1EEAC}",
        nfd: "\u{1EEAC}",
        nfkc: "\u{0645}",
        nfkd: "\u{0645}",
    },
    NormalizationTest {
        source: "\u{1EEAD}",
        nfc: "\u{1EEAD}",
        nfd: "\u{1EEAD}",
        nfkc: "\u{0646}",
        nfkd: "\u{0646}",
    },
    NormalizationTest {
        source: "\u{1EEAE}",
        nfc: "\u{1EEAE}",
        nfd: "\u{1EEAE}",
        nfkc: "\u{0633}",
        nfkd: "\u{0633}",
    },
    NormalizationTest {
        source: "\u{1EEAF}",
        nfc: "\u{1EEAF}",
        nfd: "\u{1EEAF}",
        nfkc: "\u{0639}",
        nfkd: "\u{0639}",
    },
    NormalizationTest {
        source: "\u{1EEB0}",
        nfc: "\u{1EEB0}",
        nfd: "\u{1EEB0}",
        nfkc: "\u{0641}",
        nfkd: "\u{0641}",
    },
    NormalizationTest {
        source: "\u{1EEB1}",
        nfc: "\u{1EEB1}",
        nfd: "\u{1EEB1}",
        nfkc: "\u{0635}",
        nfkd: "\u{0635}",
    },
    NormalizationTest {
        source: "\u{1EEB2}",
        nfc: "\u{1EEB2}",
        nfd: "\u{1EEB2}",
        nfkc: "\u{0642}",
        nfkd: "\u{0642}",
    },
    NormalizationTest {
        source: "\u{1EEB3}",
        nfc: "\u{1EEB3}",
        nfd: "\u{1EEB3}",
        nfkc: "\u{0631}",
        nfkd: "\u{0631}",
    },
    NormalizationTest {
        source: "\u{1EEB4}",
        nfc: "\u{1EEB4}",
        nfd: "\u{1EEB4}",
        nfkc: "\u{0634}",
        nfkd: "\u{0634}",
    },
    NormalizationTest {
        source: "\u{1EEB5}",
        nfc: "\u{1EEB5}",
        nfd: "\u{1EEB5}",
        nfkc: "\u{062A}",
        nfkd: "\u{062A}",
    },
    NormalizationTest {
        source: "\u{1EEB6}",
        nfc: "\u{1EEB6}",
        nfd: "\u{1EEB6}",
        nfkc: "\u{062B}",
        nfkd: "\u{062B}",
    },
    NormalizationTest {
        source: "\u{1EEB7}",
        nfc: "\u{1EEB7}",
        nfd: "\u{1EEB7}",
        nfkc: "\u{062E}",
        nfkd: "\u{062E}",
    },
    NormalizationTest {
        source: "\u{1EEB8}",
        nfc: "\u{1EEB8}",
        nfd: "\u{1EEB8}",
        nfkc: "\u{0630}",
        nfkd: "\u{0630}",
    },
    NormalizationTest {
        source: "\u{1EEB9}",
        nfc: "\u{1EEB9}",
        nfd: "\u{1EEB9}",
        nfkc: "\u{0636}",
        nfkd: "\u{0636}",
    },
    NormalizationTest {
        source: "\u{1EEBA}",
        nfc: "\u{1EEBA}",
        nfd: "\u{1EEBA}",
        nfkc: "\u{0638}",
        nfkd: "\u{0638}",
    },
    NormalizationTest {
        source: "\u{1EEBB}",
        nfc: "\u{1EEBB}",
        nfd: "\u{1EEBB}",
        nfkc: "\u{063A}",
        nfkd: "\u{063A}",
    },
    NormalizationTest {
        source: "\u{1F100}",
        nfc: "\u{1F100}",
        nfd: "\u{1F100}",
        nfkc: "\u{0030}\u{002E}",
        nfkd: "\u{0030}\u{002E}",
    },
    NormalizationTest {
        source: "\u{1F101}",
        nfc: "\u{1F101}",
        nfd: "\u{1F101}",
        nfkc: "\u{0030}\u{002C}",
        nfkd: "\u{0030}\u{002C}",
    },
    NormalizationTest {
        source: "\u{1F102}",
        nfc: "\u{1F102}",
        nfd: "\u{1F102}",
        nfkc: "\u{0031}\u{002C}",
        nfkd: "\u{0031}\u{002C}",
    },
    NormalizationTest {
        source: "\u{1F103}",
        nfc: "\u{1F103}",
        nfd: "\u{1F103}",
        nfkc: "\u{0032}\u{002C}",
        nfkd: "\u{0032}\u{002C}",
    },
    NormalizationTest {
        source: "\u{1F104}",
        nfc: "\u{1F104}",
        nfd: "\u{1F104}",
        nfkc: "\u{0033}\u{002C}",
        nfkd: "\u{0033}\u{002C}",
    },
    NormalizationTest {
        source: "\u{1F105}",
        nfc: "\u{1F105}",
        nfd: "\u{1F105}",
        nfkc: "\u{0034}\u{002C}",
        nfkd: "\u{0034}\u{002C}",
    },
    NormalizationTest {
        source: "\u{1F106}",
        nfc: "\u{1F106}",
        nfd: "\u{1F106}",
        nfkc: "\u{0035}\u{002C}",
        nfkd: "\u{0035}\u{002C}",
    },
    NormalizationTest {
        source: "\u{1F107}",
        nfc: "\u{1F107}",
        nfd: "\u{1F107}",
        nfkc: "\u{0036}\u{002C}",
        nfkd: "\u{0036}\u{002C}",
    },
    NormalizationTest {
        source: "\u{1F108}",
        nfc: "\u{1F108}",
        nfd: "\u{1F108}",
        nfkc: "\u{0037}\u{002C}",
        nfkd: "\u{0037}\u{002C}",
    },
    NormalizationTest {
        source: "\u{1F109}",
        nfc: "\u{1F109}",
        nfd: "\u{1F109}",
        nfkc: "\u{0038}\u{002C}",
        nfkd: "\u{0038}\u{002C}",
    },
    NormalizationTest {
        source: "\u{1F10A}",
        nfc: "\u{1F10A}",
        nfd: "\u{1F10A}",
        nfkc: "\u{0039}\u{002C}",
        nfkd: "\u{0039}\u{002C}",
    },
    NormalizationTest {
        source: "\u{1F110}",
        nfc: "\u{1F110}",
        nfd: "\u{1F110}",
        nfkc: "\u{0028}\u{0041}\u{0029}",
        nfkd: "\u{0028}\u{0041}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F111}",
        nfc: "\u{1F111}",
        nfd: "\u{1F111}",
        nfkc: "\u{0028}\u{0042}\u{0029}",
        nfkd: "\u{0028}\u{0042}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F112}",
        nfc: "\u{1F112}",
        nfd: "\u{1F112}",
        nfkc: "\u{0028}\u{0043}\u{0029}",
        nfkd: "\u{0028}\u{0043}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F113}",
        nfc: "\u{1F113}",
        nfd: "\u{1F113}",
        nfkc: "\u{0028}\u{0044}\u{0029}",
        nfkd: "\u{0028}\u{0044}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F114}",
        nfc: "\u{1F114}",
        nfd: "\u{1F114}",
        nfkc: "\u{0028}\u{0045}\u{0029}",
        nfkd: "\u{0028}\u{0045}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F115}",
        nfc: "\u{1F115}",
        nfd: "\u{1F115}",
        nfkc: "\u{0028}\u{0046}\u{0029}",
        nfkd: "\u{0028}\u{0046}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F116}",
        nfc: "\u{1F116}",
        nfd: "\u{1F116}",
        nfkc: "\u{0028}\u{0047}\u{0029}",
        nfkd: "\u{0028}\u{0047}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F117}",
        nfc: "\u{1F117}",
        nfd: "\u{1F117}",
        nfkc: "\u{0028}\u{0048}\u{0029}",
        nfkd: "\u{0028}\u{0048}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F118}",
        nfc: "\u{1F118}",
        nfd: "\u{1F118}",
        nfkc: "\u{0028}\u{0049}\u{0029}",
        nfkd: "\u{0028}\u{0049}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F119}",
        nfc: "\u{1F119}",
        nfd: "\u{1F119}",
        nfkc: "\u{0028}\u{004A}\u{0029}",
        nfkd: "\u{0028}\u{004A}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F11A}",
        nfc: "\u{1F11A}",
        nfd: "\u{1F11A}",
        nfkc: "\u{0028}\u{004B}\u{0029}",
        nfkd: "\u{0028}\u{004B}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F11B}",
        nfc: "\u{1F11B}",
        nfd: "\u{1F11B}",
        nfkc: "\u{0028}\u{004C}\u{0029}",
        nfkd: "\u{0028}\u{004C}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F11C}",
        nfc: "\u{1F11C}",
        nfd: "\u{1F11C}",
        nfkc: "\u{0028}\u{004D}\u{0029}",
        nfkd: "\u{0028}\u{004D}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F11D}",
        nfc: "\u{1F11D}",
        nfd: "\u{1F11D}",
        nfkc: "\u{0028}\u{004E}\u{0029}",
        nfkd: "\u{0028}\u{004E}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F11E}",
        nfc: "\u{1F11E}",
        nfd: "\u{1F11E}",
        nfkc: "\u{0028}\u{004F}\u{0029}",
        nfkd: "\u{0028}\u{004F}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F11F}",
        nfc: "\u{1F11F}",
        nfd: "\u{1F11F}",
        nfkc: "\u{0028}\u{0050}\u{0029}",
        nfkd: "\u{0028}\u{0050}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F120}",
        nfc: "\u{1F120}",
        nfd: "\u{1F120}",
        nfkc: "\u{0028}\u{0051}\u{0029}",
        nfkd: "\u{0028}\u{0051}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F121}",
        nfc: "\u{1F121}",
        nfd: "\u{1F121}",
        nfkc: "\u{0028}\u{0052}\u{0029}",
        nfkd: "\u{0028}\u{0052}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F122}",
        nfc: "\u{1F122}",
        nfd: "\u{1F122}",
        nfkc: "\u{0028}\u{0053}\u{0029}",
        nfkd: "\u{0028}\u{0053}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F123}",
        nfc: "\u{1F123}",
        nfd: "\u{1F123}",
        nfkc: "\u{0028}\u{0054}\u{0029}",
        nfkd: "\u{0028}\u{0054}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F124}",
        nfc: "\u{1F124}",
        nfd: "\u{1F124}",
        nfkc: "\u{0028}\u{0055}\u{0029}",
        nfkd: "\u{0028}\u{0055}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F125}",
        nfc: "\u{1F125}",
        nfd: "\u{1F125}",
        nfkc: "\u{0028}\u{0056}\u{0029}",
        nfkd: "\u{0028}\u{0056}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F126}",
        nfc: "\u{1F126}",
        nfd: "\u{1F126}",
        nfkc: "\u{0028}\u{0057}\u{0029}",
        nfkd: "\u{0028}\u{0057}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F127}",
        nfc: "\u{1F127}",
        nfd: "\u{1F127}",
        nfkc: "\u{0028}\u{0058}\u{0029}",
        nfkd: "\u{0028}\u{0058}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F128}",
        nfc: "\u{1F128}",
        nfd: "\u{1F128}",
        nfkc: "\u{0028}\u{0059}\u{0029}",
        nfkd: "\u{0028}\u{0059}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F129}",
        nfc: "\u{1F129}",
        nfd: "\u{1F129}",
        nfkc: "\u{0028}\u{005A}\u{0029}",
        nfkd: "\u{0028}\u{005A}\u{0029}",
    },
    NormalizationTest {
        source: "\u{1F12A}",
        nfc: "\u{1F12A}",
        nfd: "\u{1F12A}",
        nfkc: "\u{3014}\u{0053}\u{3015}",
        nfkd: "\u{3014}\u{0053}\u{3015}",
    },
    NormalizationTest {
        source: "\u{1F12B}",
        nfc: "\u{1F12B}",
        nfd: "\u{1F12B}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1F12C}",
        nfc: "\u{1F12C}",
        nfd: "\u{1F12C}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1F12D}",
        nfc: "\u{1F12D}",
        nfd: "\u{1F12D}",
        nfkc: "\u{0043}\u{0044}",
        nfkd: "\u{0043}\u{0044}",
    },
    NormalizationTest {
        source: "\u{1F12E}",
        nfc: "\u{1F12E}",
        nfd: "\u{1F12E}",
        nfkc: "\u{0057}\u{005A}",
        nfkd: "\u{0057}\u{005A}",
    },
    NormalizationTest {
        source: "\u{1F130}",
        nfc: "\u{1F130}",
        nfd: "\u{1F130}",
        nfkc: "\u{0041}",
        nfkd: "\u{0041}",
    },
    NormalizationTest {
        source: "\u{1F131}",
        nfc: "\u{1F131}",
        nfd: "\u{1F131}",
        nfkc: "\u{0042}",
        nfkd: "\u{0042}",
    },
    NormalizationTest {
        source: "\u{1F132}",
        nfc: "\u{1F132}",
        nfd: "\u{1F132}",
        nfkc: "\u{0043}",
        nfkd: "\u{0043}",
    },
    NormalizationTest {
        source: "\u{1F133}",
        nfc: "\u{1F133}",
        nfd: "\u{1F133}",
        nfkc: "\u{0044}",
        nfkd: "\u{0044}",
    },
    NormalizationTest {
        source: "\u{1F134}",
        nfc: "\u{1F134}",
        nfd: "\u{1F134}",
        nfkc: "\u{0045}",
        nfkd: "\u{0045}",
    },
    NormalizationTest {
        source: "\u{1F135}",
        nfc: "\u{1F135}",
        nfd: "\u{1F135}",
        nfkc: "\u{0046}",
        nfkd: "\u{0046}",
    },
    NormalizationTest {
        source: "\u{1F136}",
        nfc: "\u{1F136}",
        nfd: "\u{1F136}",
        nfkc: "\u{0047}",
        nfkd: "\u{0047}",
    },
    NormalizationTest {
        source: "\u{1F137}",
        nfc: "\u{1F137}",
        nfd: "\u{1F137}",
        nfkc: "\u{0048}",
        nfkd: "\u{0048}",
    },
    NormalizationTest {
        source: "\u{1F138}",
        nfc: "\u{1F138}",
        nfd: "\u{1F138}",
        nfkc: "\u{0049}",
        nfkd: "\u{0049}",
    },
    NormalizationTest {
        source: "\u{1F139}",
        nfc: "\u{1F139}",
        nfd: "\u{1F139}",
        nfkc: "\u{004A}",
        nfkd: "\u{004A}",
    },
    NormalizationTest {
        source: "\u{1F13A}",
        nfc: "\u{1F13A}",
        nfd: "\u{1F13A}",
        nfkc: "\u{004B}",
        nfkd: "\u{004B}",
    },
    NormalizationTest {
        source: "\u{1F13B}",
        nfc: "\u{1F13B}",
        nfd: "\u{1F13B}",
        nfkc: "\u{004C}",
        nfkd: "\u{004C}",
    },
    NormalizationTest {
        source: "\u{1F13C}",
        nfc: "\u{1F13C}",
        nfd: "\u{1F13C}",
        nfkc: "\u{004D}",
        nfkd: "\u{004D}",
    },
    NormalizationTest {
        source: "\u{1F13D}",
        nfc: "\u{1F13D}",
        nfd: "\u{1F13D}",
        nfkc: "\u{004E}",
        nfkd: "\u{004E}",
    },
    NormalizationTest {
        source: "\u{1F13E}",
        nfc: "\u{1F13E}",
        nfd: "\u{1F13E}",
        nfkc: "\u{004F}",
        nfkd: "\u{004F}",
    },
    NormalizationTest {
        source: "\u{1F13F}",
        nfc: "\u{1F13F}",
        nfd: "\u{1F13F}",
        nfkc: "\u{0050}",
        nfkd: "\u{0050}",
    },
    NormalizationTest {
        source: "\u{1F140}",
        nfc: "\u{1F140}",
        nfd: "\u{1F140}",
        nfkc: "\u{0051}",
        nfkd: "\u{0051}",
    },
    NormalizationTest {
        source: "\u{1F141}",
        nfc: "\u{1F141}",
        nfd: "\u{1F141}",
        nfkc: "\u{0052}",
        nfkd: "\u{0052}",
    },
    NormalizationTest {
        source: "\u{1F142}",
        nfc: "\u{1F142}",
        nfd: "\u{1F142}",
        nfkc: "\u{0053}",
        nfkd: "\u{0053}",
    },
    NormalizationTest {
        source: "\u{1F143}",
        nfc: "\u{1F143}",
        nfd: "\u{1F143}",
        nfkc: "\u{0054}",
        nfkd: "\u{0054}",
    },
    NormalizationTest {
        source: "\u{1F144}",
        nfc: "\u{1F144}",
        nfd: "\u{1F144}",
        nfkc: "\u{0055}",
        nfkd: "\u{0055}",
    },
    NormalizationTest {
        source: "\u{1F145}",
        nfc: "\u{1F145}",
        nfd: "\u{1F145}",
        nfkc: "\u{0056}",
        nfkd: "\u{0056}",
    },
    NormalizationTest {
        source: "\u{1F146}",
        nfc: "\u{1F146}",
        nfd: "\u{1F146}",
        nfkc: "\u{0057}",
        nfkd: "\u{0057}",
    },
    NormalizationTest {
        source: "\u{1F147}",
        nfc: "\u{1F147}",
        nfd: "\u{1F147}",
        nfkc: "\u{0058}",
        nfkd: "\u{0058}",
    },
    NormalizationTest {
        source: "\u{1F148}",
        nfc: "\u{1F148}",
        nfd: "\u{1F148}",
        nfkc: "\u{0059}",
        nfkd: "\u{0059}",
    },
    NormalizationTest {
        source: "\u{1F149}",
        nfc: "\u{1F149}",
        nfd: "\u{1F149}",
        nfkc: "\u{005A}",
        nfkd: "\u{005A}",
    },
    NormalizationTest {
        source: "\u{1F14A}",
        nfc: "\u{1F14A}",
        nfd: "\u{1F14A}",
        nfkc: "\u{0048}\u{0056}",
        nfkd: "\u{0048}\u{0056}",
    },
    NormalizationTest {
        source: "\u{1F14B}",
        nfc: "\u{1F14B}",
        nfd: "\u{1F14B}",
        nfkc: "\u{004D}\u{0056}",
        nfkd: "\u{004D}\u{0056}",
    },
    NormalizationTest {
        source: "\u{1F14C}",
        nfc: "\u{1F14C}",
        nfd: "\u{1F14C}",
        nfkc: "\u{0053}\u{0044}",
        nfkd: "\u{0053}\u{0044}",
    },
    NormalizationTest {
        source: "\u{1F14D}",
        nfc: "\u{1F14D}",
        nfd: "\u{1F14D}",
        nfkc: "\u{0053}\u{0053}",
        nfkd: "\u{0053}\u{0053}",
    },
    NormalizationTest {
        source: "\u{1F14E}",
        nfc: "\u{1F14E}",
        nfd: "\u{1F14E}",
        nfkc: "\u{0050}\u{0050}\u{0056}",
        nfkd: "\u{0050}\u{0050}\u{0056}",
    },
    NormalizationTest {
        source: "\u{1F14F}",
        nfc: "\u{1F14F}",
        nfd: "\u{1F14F}",
        nfkc: "\u{0057}\u{0043}",
        nfkd: "\u{0057}\u{0043}",
    },
    NormalizationTest {
        source: "\u{1F16A}",
        nfc: "\u{1F16A}",
        nfd: "\u{1F16A}",
        nfkc: "\u{004D}\u{0043}",
        nfkd: "\u{004D}\u{0043}",
    },
    NormalizationTest {
        source: "\u{1F16B}",
        nfc: "\u{1F16B}",
        nfd: "\u{1F16B}",
        nfkc: "\u{004D}\u{0044}",
        nfkd: "\u{004D}\u{0044}",
    },
    NormalizationTest {
        source: "\u{1F190}",
        nfc: "\u{1F190}",
        nfd: "\u{1F190}",
        nfkc: "\u{0044}\u{004A}",
        nfkd: "\u{0044}\u{004A}",
    },
    NormalizationTest {
        source: "\u{1F200}",
        nfc: "\u{1F200}",
        nfd: "\u{1F200}",
        nfkc: "\u{307B}\u{304B}",
        nfkd: "\u{307B}\u{304B}",
    },
    NormalizationTest {
        source: "\u{1F201}",
        nfc: "\u{1F201}",
        nfd: "\u{1F201}",
        nfkc: "\u{30B3}\u{30B3}",
        nfkd: "\u{30B3}\u{30B3}",
    },
    NormalizationTest {
        source: "\u{1F202}",
        nfc: "\u{1F202}",
        nfd: "\u{1F202}",
        nfkc: "\u{30B5}",
        nfkd: "\u{30B5}",
    },
    NormalizationTest {
        source: "\u{1F210}",
        nfc: "\u{1F210}",
        nfd: "\u{1F210}",
        nfkc: "\u{624B}",
        nfkd: "\u{624B}",
    },
    NormalizationTest {
        source: "\u{1F211}",
        nfc: "\u{1F211}",
        nfd: "\u{1F211}",
        nfkc: "\u{5B57}",
        nfkd: "\u{5B57}",
    },
    NormalizationTest {
        source: "\u{1F212}",
        nfc: "\u{1F212}",
        nfd: "\u{1F212}",
        nfkc: "\u{53CC}",
        nfkd: "\u{53CC}",
    },
    NormalizationTest {
        source: "\u{1F213}",
        nfc: "\u{1F213}",
        nfd: "\u{1F213}",
        nfkc: "\u{30C7}",
        nfkd: "\u{30C6}\u{3099}",
    },
    NormalizationTest {
        source: "\u{1F214}",
        nfc: "\u{1F214}",
        nfd: "\u{1F214}",
        nfkc: "\u{4E8C}",
        nfkd: "\u{4E8C}",
    },
    NormalizationTest {
        source: "\u{1F215}",
        nfc: "\u{1F215}",
        nfd: "\u{1F215}",
        nfkc: "\u{591A}",
        nfkd: "\u{591A}",
    },
    NormalizationTest {
        source: "\u{1F216}",
        nfc: "\u{1F216}",
        nfd: "\u{1F216}",
        nfkc: "\u{89E3}",
        nfkd: "\u{89E3}",
    },
    NormalizationTest {
        source: "\u{1F217}",
        nfc: "\u{1F217}",
        nfd: "\u{1F217}",
        nfkc: "\u{5929}",
        nfkd: "\u{5929}",
    },
    NormalizationTest {
        source: "\u{1F218}",
        nfc: "\u{1F218}",
        nfd: "\u{1F218}",
        nfkc: "\u{4EA4}",
        nfkd: "\u{4EA4}",
    },
    NormalizationTest {
        source: "\u{1F219}",
        nfc: "\u{1F219}",
        nfd: "\u{1F219}",
        nfkc: "\u{6620}",
        nfkd: "\u{6620}",
    },
    NormalizationTest {
        source: "\u{1F21A}",
        nfc: "\u{1F21A}",
        nfd: "\u{1F21A}",
        nfkc: "\u{7121}",
        nfkd: "\u{7121}",
    },
    NormalizationTest {
        source: "\u{1F21B}",
        nfc: "\u{1F21B}",
        nfd: "\u{1F21B}",
        nfkc: "\u{6599}",
        nfkd: "\u{6599}",
    },
    NormalizationTest {
        source: "\u{1F21C}",
        nfc: "\u{1F21C}",
        nfd: "\u{1F21C}",
        nfkc: "\u{524D}",
        nfkd: "\u{524D}",
    },
    NormalizationTest {
        source: "\u{1F21D}",
        nfc: "\u{1F21D}",
        nfd: "\u{1F21D}",
        nfkc: "\u{5F8C}",
        nfkd: "\u{5F8C}",
    },
    NormalizationTest {
        source: "\u{1F21E}",
        nfc: "\u{1F21E}",
        nfd: "\u{1F21E}",
        nfkc: "\u{518D}",
        nfkd: "\u{518D}",
    },
    NormalizationTest {
        source: "\u{1F21F}",
        nfc: "\u{1F21F}",
        nfd: "\u{1F21F}",
        nfkc: "\u{65B0}",
        nfkd: "\u{65B0}",
    },
    NormalizationTest {
        source: "\u{1F220}",
        nfc: "\u{1F220}",
        nfd: "\u{1F220}",
        nfkc: "\u{521D}",
        nfkd: "\u{521D}",
    },
    NormalizationTest {
        source: "\u{1F221}",
        nfc: "\u{1F221}",
        nfd: "\u{1F221}",
        nfkc: "\u{7D42}",
        nfkd: "\u{7D42}",
    },
    NormalizationTest {
        source: "\u{1F222}",
        nfc: "\u{1F222}",
        nfd: "\u{1F222}",
        nfkc: "\u{751F}",
        nfkd: "\u{751F}",
    },
    NormalizationTest {
        source: "\u{1F223}",
        nfc: "\u{1F223}",
        nfd: "\u{1F223}",
        nfkc: "\u{8CA9}",
        nfkd: "\u{8CA9}",
    },
    NormalizationTest {
        source: "\u{1F224}",
        nfc: "\u{1F224}",
        nfd: "\u{1F224}",
        nfkc: "\u{58F0}",
        nfkd: "\u{58F0}",
    },
    NormalizationTest {
        source: "\u{1F225}",
        nfc: "\u{1F225}",
        nfd: "\u{1F225}",
        nfkc: "\u{5439}",
        nfkd: "\u{5439}",
    },
    NormalizationTest {
        source: "\u{1F226}",
        nfc: "\u{1F226}",
        nfd: "\u{1F226}",
        nfkc: "\u{6F14}",
        nfkd: "\u{6F14}",
    },
    NormalizationTest {
        source: "\u{1F227}",
        nfc: "\u{1F227}",
        nfd: "\u{1F227}",
        nfkc: "\u{6295}",
        nfkd: "\u{6295}",
    },
    NormalizationTest {
        source: "\u{1F228}",
        nfc: "\u{1F228}",
        nfd: "\u{1F228}",
        nfkc: "\u{6355}",
        nfkd: "\u{6355}",
    },
    NormalizationTest {
        source: "\u{1F229}",
        nfc: "\u{1F229}",
        nfd: "\u{1F229}",
        nfkc: "\u{4E00}",
        nfkd: "\u{4E00}",
    },
    NormalizationTest {
        source: "\u{1F22A}",
        nfc: "\u{1F22A}",
        nfd: "\u{1F22A}",
        nfkc: "\u{4E09}",
        nfkd: "\u{4E09}",
    },
    NormalizationTest {
        source: "\u{1F22B}",
        nfc: "\u{1F22B}",
        nfd: "\u{1F22B}",
        nfkc: "\u{904A}",
        nfkd: "\u{904A}",
    },
    NormalizationTest {
        source: "\u{1F22C}",
        nfc: "\u{1F22C}",
        nfd: "\u{1F22C}",
        nfkc: "\u{5DE6}",
        nfkd: "\u{5DE6}",
    },
    NormalizationTest {
        source: "\u{1F22D}",
        nfc: "\u{1F22D}",
        nfd: "\u{1F22D}",
        nfkc: "\u{4E2D}",
        nfkd: "\u{4E2D}",
    },
    NormalizationTest {
        source: "\u{1F22E}",
        nfc: "\u{1F22E}",
        nfd: "\u{1F22E}",
        nfkc: "\u{53F3}",
        nfkd: "\u{53F3}",
    },
    NormalizationTest {
        source: "\u{1F22F}",
        nfc: "\u{1F22F}",
        nfd: "\u{1F22F}",
        nfkc: "\u{6307}",
        nfkd: "\u{6307}",
    },
    NormalizationTest {
        source: "\u{1F230}",
        nfc: "\u{1F230}",
        nfd: "\u{1F230}",
        nfkc: "\u{8D70}",
        nfkd: "\u{8D70}",
    },
    NormalizationTest {
        source: "\u{1F231}",
        nfc: "\u{1F231}",
        nfd: "\u{1F231}",
        nfkc: "\u{6253}",
        nfkd: "\u{6253}",
    },
    NormalizationTest {
        source: "\u{1F232}",
        nfc: "\u{1F232}",
        nfd: "\u{1F232}",
        nfkc: "\u{7981}",
        nfkd: "\u{7981}",
    },
    NormalizationTest {
        source: "\u{1F233}",
        nfc: "\u{1F233}",
        nfd: "\u{1F233}",
        nfkc: "\u{7A7A}",
        nfkd: "\u{7A7A}",
    },
    NormalizationTest {
        source: "\u{1F234}",
        nfc: "\u{1F234}",
        nfd: "\u{1F234}",
        nfkc: "\u{5408}",
        nfkd: "\u{5408}",
    },
    NormalizationTest {
        source: "\u{1F235}",
        nfc: "\u{1F235}",
        nfd: "\u{1F235}",
        nfkc: "\u{6E80}",
        nfkd: "\u{6E80}",
    },
    NormalizationTest {
        source: "\u{1F236}",
        nfc: "\u{1F236}",
        nfd: "\u{1F236}",
        nfkc: "\u{6709}",
        nfkd: "\u{6709}",
    },
    NormalizationTest {
        source: "\u{1F237}",
        nfc: "\u{1F237}",
        nfd: "\u{1F237}",
        nfkc: "\u{6708}",
        nfkd: "\u{6708}",
    },
    NormalizationTest {
        source: "\u{1F238}",
        nfc: "\u{1F238}",
        nfd: "\u{1F238}",
        nfkc: "\u{7533}",
        nfkd: "\u{7533}",
    },
    NormalizationTest {
        source: "\u{1F239}",
        nfc: "\u{1F239}",
        nfd: "\u{1F239}",
        nfkc: "\u{5272}",
        nfkd: "\u{5272}",
    },
    NormalizationTest {
        source: "\u{1F23A}",
        nfc: "\u{1F23A}",
        nfd: "\u{1F23A}",
        nfkc: "\u{55B6}",
        nfkd: "\u{55B6}",
    },
    NormalizationTest {
        source: "\u{1F23B}",
        nfc: "\u{1F23B}",
        nfd: "\u{1F23B}",
        nfkc: "\u{914D}",
        nfkd: "\u{914D}",
    },
    NormalizationTest {
        source: "\u{1F240}",
        nfc: "\u{1F240}",
        nfd: "\u{1F240}",
        nfkc: "\u{3014}\u{672C}\u{3015}",
        nfkd: "\u{3014}\u{672C}\u{3015}",
    },
    NormalizationTest {
        source: "\u{1F241}",
        nfc: "\u{1F241}",
        nfd: "\u{1F241}",
        nfkc: "\u{3014}\u{4E09}\u{3015}",
        nfkd: "\u{3014}\u{4E09}\u{3015}",
    },
    NormalizationTest {
        source: "\u{1F242}",
        nfc: "\u{1F242}",
        nfd: "\u{1F242}",
        nfkc: "\u{3014}\u{4E8C}\u{3015}",
        nfkd: "\u{3014}\u{4E8C}\u{3015}",
    },
    NormalizationTest {
        source: "\u{1F243}",
        nfc: "\u{1F243}",
        nfd: "\u{1F243}",
        nfkc: "\u{3014}\u{5B89}\u{3015}",
        nfkd: "\u{3014}\u{5B89}\u{3015}",
    },
    NormalizationTest {
        source: "\u{1F244}",
        nfc: "\u{1F244}",
        nfd: "\u{1F244}",
        nfkc: "\u{3014}\u{70B9}\u{3015}",
        nfkd: "\u{3014}\u{70B9}\u{3015}",
    },
    NormalizationTest {
        source: "\u{1F245}",
        nfc: "\u{1F245}",
        nfd: "\u{1F245}",
        nfkc: "\u{3014}\u{6253}\u{3015}",
        nfkd: "\u{3014}\u{6253}\u{3015}",
    },
    NormalizationTest {
        source: "\u{1F246}",
        nfc: "\u{1F246}",
        nfd: "\u{1F246}",
        nfkc: "\u{3014}\u{76D7}\u{3015}",
        nfkd: "\u{3014}\u{76D7}\u{3015}",
    },
    NormalizationTest {
        source: "\u{1F247}",
        nfc: "\u{1F247}",
        nfd: "\u{1F247}",
        nfkc: "\u{3014}\u{52DD}\u{3015}",
        nfkd: "\u{3014}\u{52DD}\u{3015}",
    },
    NormalizationTest {
        source: "\u{1F248}",
        nfc: "\u{1F248}",
        nfd: "\u{1F248}",
        nfkc: "\u{3014}\u{6557}\u{3015}",
        nfkd: "\u{3014}\u{6557}\u{3015}",
    },
    NormalizationTest {
        source: "\u{1F250}",
        nfc: "\u{1F250}",
        nfd: "\u{1F250}",
        nfkc: "\u{5F97}",
        nfkd: "\u{5F97}",
    },
    NormalizationTest {
        source: "\u{1F251}",
        nfc: "\u{1F251}",
        nfd: "\u{1F251}",
        nfkc: "\u{53EF}",
        nfkd: "\u{53EF}",
    },
    NormalizationTest {
        source: "\u{2F800}",
        nfc: "\u{4E3D}",
        nfd: "\u{4E3D}",
        nfkc: "\u{4E3D}",
        nfkd: "\u{4E3D}",
    },
    NormalizationTest {
        source: "\u{2F801}",
        nfc: "\u{4E38}",
        nfd: "\u{4E38}",
        nfkc: "\u{4E38}",
        nfkd: "\u{4E38}",
    },
    NormalizationTest {
        source: "\u{2F802}",
        nfc: "\u{4E41}",
        nfd: "\u{4E41}",
        nfkc: "\u{4E41}",
        nfkd: "\u{4E41}",
    },
    NormalizationTest {
        source: "\u{2F803}",
        nfc: "\u{20122}",
        nfd: "\u{20122}",
        nfkc: "\u{20122}",
        nfkd: "\u{20122}",
    },
    NormalizationTest {
        source: "\u{2F804}",
        nfc: "\u{4F60}",
        nfd: "\u{4F60}",
        nfkc: "\u{4F60}",
        nfkd: "\u{4F60}",
    },
    NormalizationTest {
        source: "\u{2F805}",
        nfc: "\u{4FAE}",
        nfd: "\u{4FAE}",
        nfkc: "\u{4FAE}",
        nfkd: "\u{4FAE}",
    },
    NormalizationTest {
        source: "\u{2F806}",
        nfc: "\u{4FBB}",
        nfd: "\u{4FBB}",
        nfkc: "\u{4FBB}",
        nfkd: "\u{4FBB}",
    },
    NormalizationTest {
        source: "\u{2F807}",
        nfc: "\u{5002}",
        nfd: "\u{5002}",
        nfkc: "\u{5002}",
        nfkd: "\u{5002}",
    },
    NormalizationTest {
        source: "\u{2F808}",
        nfc: "\u{507A}",
        nfd: "\u{507A}",
        nfkc: "\u{507A}",
        nfkd: "\u{507A}",
    },
    NormalizationTest {
        source: "\u{2F809}",
        nfc: "\u{5099}",
        nfd: "\u{5099}",
        nfkc: "\u{5099}",
        nfkd: "\u{5099}",
    },
    NormalizationTest {
        source: "\u{2F80A}",
        nfc: "\u{50E7}",
        nfd: "\u{50E7}",
        nfkc: "\u{50E7}",
        nfkd: "\u{50E7}",
    },
    NormalizationTest {
        source: "\u{2F80B}",
        nfc: "\u{50CF}",
        nfd: "\u{50CF}",
        nfkc: "\u{50CF}",
        nfkd: "\u{50CF}",
    },
    NormalizationTest {
        source: "\u{2F80C}",
        nfc: "\u{349E}",
        nfd: "\u{349E}",
        nfkc: "\u{349E}",
        nfkd: "\u{349E}",
    },
    NormalizationTest {
        source: "\u{2F80D}",
        nfc: "\u{2063A}",
        nfd: "\u{2063A}",
        nfkc: "\u{2063A}",
        nfkd: "\u{2063A}",
    },
    NormalizationTest {
        source: "\u{2F80E}",
        nfc: "\u{514D}",
        nfd: "\u{514D}",
        nfkc: "\u{514D}",
        nfkd: "\u{514D}",
    },
    NormalizationTest {
        source: "\u{2F80F}",
        nfc: "\u{5154}",
        nfd: "\u{5154}",
        nfkc: "\u{5154}",
        nfkd: "\u{5154}",
    },
    NormalizationTest {
        source: "\u{2F810}",
        nfc: "\u{5164}",
        nfd: "\u{5164}",
        nfkc: "\u{5164}",
        nfkd: "\u{5164}",
    },
    NormalizationTest {
        source: "\u{2F811}",
        nfc: "\u{5177}",
        nfd: "\u{5177}",
        nfkc: "\u{5177}",
        nfkd: "\u{5177}",
    },
    NormalizationTest {
        source: "\u{2F812}",
        nfc: "\u{2051C}",
        nfd: "\u{2051C}",
        nfkc: "\u{2051C}",
        nfkd: "\u{2051C}",
    },
    NormalizationTest {
        source: "\u{2F813}",
        nfc: "\u{34B9}",
        nfd: "\u{34B9}",
        nfkc: "\u{34B9}",
        nfkd: "\u{34B9}",
    },
    NormalizationTest {
        source: "\u{2F814}",
        nfc: "\u{5167}",
        nfd: "\u{5167}",
        nfkc: "\u{5167}",
        nfkd: "\u{5167}",
    },
    NormalizationTest {
        source: "\u{2F815}",
        nfc: "\u{518D}",
        nfd: "\u{518D}",
        nfkc: "\u{518D}",
        nfkd: "\u{518D}",
    },
    NormalizationTest {
        source: "\u{2F816}",
        nfc: "\u{2054B}",
        nfd: "\u{2054B}",
        nfkc: "\u{2054B}",
        nfkd: "\u{2054B}",
    },
    NormalizationTest {
        source: "\u{2F817}",
        nfc: "\u{5197}",
        nfd: "\u{5197}",
        nfkc: "\u{5197}",
        nfkd: "\u{5197}",
    },
    NormalizationTest {
        source: "\u{2F818}",
        nfc: "\u{51A4}",
        nfd: "\u{51A4}",
        nfkc: "\u{51A4}",
        nfkd: "\u{51A4}",
    },
    NormalizationTest {
        source: "\u{2F819}",
        nfc: "\u{4ECC}",
        nfd: "\u{4ECC}",
        nfkc: "\u{4ECC}",
        nfkd: "\u{4ECC}",
    },
    NormalizationTest {
        source: "\u{2F81A}",
        nfc: "\u{51AC}",
        nfd: "\u{51AC}",
        nfkc: "\u{51AC}",
        nfkd: "\u{51AC}",
    },
    NormalizationTest {
        source: "\u{2F81B}",
        nfc: "\u{51B5}",
        nfd: "\u{51B5}",
        nfkc: "\u{51B5}",
        nfkd: "\u{51B5}",
    },
    NormalizationTest {
        source: "\u{2F81C}",
        nfc: "\u{291DF}",
        nfd: "\u{291DF}",
        nfkc: "\u{291DF}",
        nfkd: "\u{291DF}",
    },
    NormalizationTest {
        source: "\u{2F81D}",
        nfc: "\u{51F5}",
        nfd: "\u{51F5}",
        nfkc: "\u{51F5}",
        nfkd: "\u{51F5}",
    },
    NormalizationTest {
        source: "\u{2F81E}",
        nfc: "\u{5203}",
        nfd: "\u{5203}",
        nfkc: "\u{5203}",
        nfkd: "\u{5203}",
    },
    NormalizationTest {
        source: "\u{2F81F}",
        nfc: "\u{34DF}",
        nfd: "\u{34DF}",
        nfkc: "\u{34DF}",
        nfkd: "\u{34DF}",
    },
    NormalizationTest {
        source: "\u{2F820}",
        nfc: "\u{523B}",
        nfd: "\u{523B}",
        nfkc: "\u{523B}",
        nfkd: "\u{523B}",
    },
    NormalizationTest {
        source: "\u{2F821}",
        nfc: "\u{5246}",
        nfd: "\u{5246}",
        nfkc: "\u{5246}",
        nfkd: "\u{5246}",
    },
    NormalizationTest {
        source: "\u{2F822}",
        nfc: "\u{5272}",
        nfd: "\u{5272}",
        nfkc: "\u{5272}",
        nfkd: "\u{5272}",
    },
    NormalizationTest {
        source: "\u{2F823}",
        nfc: "\u{5277}",
        nfd: "\u{5277}",
        nfkc: "\u{5277}",
        nfkd: "\u{5277}",
    },
    NormalizationTest {
        source: "\u{2F824}",
        nfc: "\u{3515}",
        nfd: "\u{3515}",
        nfkc: "\u{3515}",
        nfkd: "\u{3515}",
    },
    NormalizationTest {
        source: "\u{2F825}",
        nfc: "\u{52C7}",
        nfd: "\u{52C7}",
        nfkc: "\u{52C7}",
        nfkd: "\u{52C7}",
    },
    NormalizationTest {
        source: "\u{2F826}",
        nfc: "\u{52C9}",
        nfd: "\u{52C9}",
        nfkc: "\u{52C9}",
        nfkd: "\u{52C9}",
    },
    NormalizationTest {
        source: "\u{2F827}",
        nfc: "\u{52E4}",
        nfd: "\u{52E4}",
        nfkc: "\u{52E4}",
        nfkd: "\u{52E4}",
    },
    NormalizationTest {
        source: "\u{2F828}",
        nfc: "\u{52FA}",
        nfd: "\u{52FA}",
        nfkc: "\u{52FA}",
        nfkd: "\u{52FA}",
    },
    NormalizationTest {
        source: "\u{2F829}",
        nfc: "\u{5305}",
        nfd: "\u{5305}",
        nfkc: "\u{5305}",
        nfkd: "\u{5305}",
    },
    NormalizationTest {
        source: "\u{2F82A}",
        nfc: "\u{5306}",
        nfd: "\u{5306}",
        nfkc: "\u{5306}",
        nfkd: "\u{5306}",
    },
    NormalizationTest {
        source: "\u{2F82B}",
        nfc: "\u{5317}",
        nfd: "\u{5317}",
        nfkc: "\u{5317}",
        nfkd: "\u{5317}",
    },
    NormalizationTest {
        source: "\u{2F82C}",
        nfc: "\u{5349}",
        nfd: "\u{5349}",
        nfkc: "\u{5349}",
        nfkd: "\u{5349}",
    },
    NormalizationTest {
        source: "\u{2F82D}",
        nfc: "\u{5351}",
        nfd: "\u{5351}",
        nfkc: "\u{5351}",
        nfkd: "\u{5351}",
    },
    NormalizationTest {
        source: "\u{2F82E}",
        nfc: "\u{535A}",
        nfd: "\u{535A}",
        nfkc: "\u{535A}",
        nfkd: "\u{535A}",
    },
    NormalizationTest {
        source: "\u{2F82F}",
        nfc: "\u{5373}",
        nfd: "\u{5373}",
        nfkc: "\u{5373}",
        nfkd: "\u{5373}",
    },
    NormalizationTest {
        source: "\u{2F830}",
        nfc: "\u{537D}",
        nfd: "\u{537D}",
        nfkc: "\u{537D}",
        nfkd: "\u{537D}",
    },
    NormalizationTest {
        source: "\u{2F831}",
        nfc: "\u{537F}",
        nfd: "\u{537F}",
        nfkc: "\u{537F}",
        nfkd: "\u{537F}",
    },
    NormalizationTest {
        source: "\u{2F832}",
        nfc: "\u{537F}",
        nfd: "\u{537F}",
        nfkc: "\u{537F}",
        nfkd: "\u{537F}",
    },
    NormalizationTest {
        source: "\u{2F833}",
        nfc: "\u{537F}",
        nfd: "\u{537F}",
        nfkc: "\u{537F}",
        nfkd: "\u{537F}",
    },
    NormalizationTest {
        source: "\u{2F834}",
        nfc: "\u{20A2C}",
        nfd: "\u{20A2C}",
        nfkc: "\u{20A2C}",
        nfkd: "\u{20A2C}",
    },
    NormalizationTest {
        source: "\u{2F835}",
        nfc: "\u{7070}",
        nfd: "\u{7070}",
        nfkc: "\u{7070}",
        nfkd: "\u{7070}",
    },
    NormalizationTest {
        source: "\u{2F836}",
        nfc: "\u{53CA}",
        nfd: "\u{53CA}",
        nfkc: "\u{53CA}",
        nfkd: "\u{53CA}",
    },
    NormalizationTest {
        source: "\u{2F837}",
        nfc: "\u{53DF}",
        nfd: "\u{53DF}",
        nfkc: "\u{53DF}",
        nfkd: "\u{53DF}",
    },
    NormalizationTest {
        source: "\u{2F838}",
        nfc: "\u{20B63}",
        nfd: "\u{20B63}",
        nfkc: "\u{20B63}",
        nfkd: "\u{20B63}",
    },
    NormalizationTest {
        source: "\u{2F839}",
        nfc: "\u{53EB}",
        nfd: "\u{53EB}",
        nfkc: "\u{53EB}",
        nfkd: "\u{53EB}",
    },
    NormalizationTest {
        source: "\u{2F83A}",
        nfc: "\u{53F1}",
        nfd: "\u{53F1}",
        nfkc: "\u{53F1}",
        nfkd: "\u{53F1}",
    },
    NormalizationTest {
        source: "\u{2F83B}",
        nfc: "\u{5406}",
        nfd: "\u{5406}",
        nfkc: "\u{5406}",
        nfkd: "\u{5406}",
    },
    NormalizationTest {
        source: "\u{2F83C}",
        nfc: "\u{549E}",
        nfd: "\u{549E}",
        nfkc: "\u{549E}",
        nfkd: "\u{549E}",
    },
    NormalizationTest {
        source: "\u{2F83D}",
        nfc: "\u{5438}",
        nfd: "\u{5438}",
        nfkc: "\u{5438}",
        nfkd: "\u{5438}",
    },
    NormalizationTest {
        source: "\u{2F83E}",
        nfc: "\u{5448}",
        nfd: "\u{5448}",
        nfkc: "\u{5448}",
        nfkd: "\u{5448}",
    },
    NormalizationTest {
        source: "\u{2F83F}",
        nfc: "\u{5468}",
        nfd: "\u{5468}",
        nfkc: "\u{5468}",
        nfkd: "\u{5468}",
    },
    NormalizationTest {
        source: "\u{2F840}",
        nfc: "\u{54A2}",
        nfd: "\u{54A2}",
        nfkc: "\u{54A2}",
        nfkd: "\u{54A2}",
    },
    NormalizationTest {
        source: "\u{2F841}",
        nfc: "\u{54F6}",
        nfd: "\u{54F6}",
        nfkc: "\u{54F6}",
        nfkd: "\u{54F6}",
    },
    NormalizationTest {
        source: "\u{2F842}",
        nfc: "\u{5510}",
        nfd: "\u{5510}",
        nfkc: "\u{5510}",
        nfkd: "\u{5510}",
    },
    NormalizationTest {
        source: "\u{2F843}",
        nfc: "\u{5553}",
        nfd: "\u{5553}",
        nfkc: "\u{5553}",
        nfkd: "\u{5553}",
    },
    NormalizationTest {
        source: "\u{2F844}",
        nfc: "\u{5563}",
        nfd: "\u{5563}",
        nfkc: "\u{5563}",
        nfkd: "\u{5563}",
    },
    NormalizationTest {
        source: "\u{2F845}",
        nfc: "\u{5584}",
        nfd: "\u{5584}",
        nfkc: "\u{5584}",
        nfkd: "\u{5584}",
    },
    NormalizationTest {
        source: "\u{2F846}",
        nfc: "\u{5584}",
        nfd: "\u{5584}",
        nfkc: "\u{5584}",
        nfkd: "\u{5584}",
    },
    NormalizationTest {
        source: "\u{2F847}",
        nfc: "\u{5599}",
        nfd: "\u{5599}",
        nfkc: "\u{5599}",
        nfkd: "\u{5599}",
    },
    NormalizationTest {
        source: "\u{2F848}",
        nfc: "\u{55AB}",
        nfd: "\u{55AB}",
        nfkc: "\u{55AB}",
        nfkd: "\u{55AB}",
    },
    NormalizationTest {
        source: "\u{2F849}",
        nfc: "\u{55B3}",
        nfd: "\u{55B3}",
        nfkc: "\u{55B3}",
        nfkd: "\u{55B3}",
    },
    NormalizationTest {
        source: "\u{2F84A}",
        nfc: "\u{55C2}",
        nfd: "\u{55C2}",
        nfkc: "\u{55C2}",
        nfkd: "\u{55C2}",
    },
    NormalizationTest {
        source: "\u{2F84B}",
        nfc: "\u{5716}",
        nfd: "\u{5716}",
        nfkc: "\u{5716}",
        nfkd: "\u{5716}",
    },
    NormalizationTest {
        source: "\u{2F84C}",
        nfc: "\u{5606}",
        nfd: "\u{5606}",
        nfkc: "\u{5606}",
        nfkd: "\u{5606}",
    },
    NormalizationTest {
        source: "\u{2F84D}",
        nfc: "\u{5717}",
        nfd: "\u{5717}",
        nfkc: "\u{5717}",
        nfkd: "\u{5717}",
    },
    NormalizationTest {
        source: "\u{2F84E}",
        nfc: "\u{5651}",
        nfd: "\u{5651}",
        nfkc: "\u{5651}",
        nfkd: "\u{5651}",
    },
    NormalizationTest {
        source: "\u{2F84F}",
        nfc: "\u{5674}",
        nfd: "\u{5674}",
        nfkc: "\u{5674}",
        nfkd: "\u{5674}",
    },
    NormalizationTest {
        source: "\u{2F850}",
        nfc: "\u{5207}",
        nfd: "\u{5207}",
        nfkc: "\u{5207}",
        nfkd: "\u{5207}",
    },
    NormalizationTest {
        source: "\u{2F851}",
        nfc: "\u{58EE}",
        nfd: "\u{58EE}",
        nfkc: "\u{58EE}",
        nfkd: "\u{58EE}",
    },
    NormalizationTest {
        source: "\u{2F852}",
        nfc: "\u{57CE}",
        nfd: "\u{57CE}",
        nfkc: "\u{57CE}",
        nfkd: "\u{57CE}",
    },
    NormalizationTest {
        source: "\u{2F853}",
        nfc: "\u{57F4}",
        nfd: "\u{57F4}",
        nfkc: "\u{57F4}",
        nfkd: "\u{57F4}",
    },
    NormalizationTest {
        source: "\u{2F854}",
        nfc: "\u{580D}",
        nfd: "\u{580D}",
        nfkc: "\u{580D}",
        nfkd: "\u{580D}",
    },
    NormalizationTest {
        source: "\u{2F855}",
        nfc: "\u{578B}",
        nfd: "\u{578B}",
        nfkc: "\u{578B}",
        nfkd: "\u{578B}",
    },
    NormalizationTest {
        source: "\u{2F856}",
        nfc: "\u{5832}",
        nfd: "\u{5832}",
        nfkc: "\u{5832}",
        nfkd: "\u{5832}",
    },
    NormalizationTest {
        source: "\u{2F857}",
        nfc: "\u{5831}",
        nfd: "\u{5831}",
        nfkc: "\u{5831}",
        nfkd: "\u{5831}",
    },
    NormalizationTest {
        source: "\u{2F858}",
        nfc: "\u{58AC}",
        nfd: "\u{58AC}",
        nfkc: "\u{58AC}",
        nfkd: "\u{58AC}",
    },
    NormalizationTest {
        source: "\u{2F859}",
        nfc: "\u{214E4}",
        nfd: "\u{214E4}",
        nfkc: "\u{214E4}",
        nfkd: "\u{214E4}",
    },
    NormalizationTest {
        source: "\u{2F85A}",
        nfc: "\u{58F2}",
        nfd: "\u{58F2}",
        nfkc: "\u{58F2}",
        nfkd: "\u{58F2}",
    },
    NormalizationTest {
        source: "\u{2F85B}",
        nfc: "\u{58F7}",
        nfd: "\u{58F7}",
        nfkc: "\u{58F7}",
        nfkd: "\u{58F7}",
    },
    NormalizationTest {
        source: "\u{2F85C}",
        nfc: "\u{5906}",
        nfd: "\u{5906}",
        nfkc: "\u{5906}",
        nfkd: "\u{5906}",
    },
    NormalizationTest {
        source: "\u{2F85D}",
        nfc: "\u{591A}",
        nfd: "\u{591A}",
        nfkc: "\u{591A}",
        nfkd: "\u{591A}",
    },
    NormalizationTest {
        source: "\u{2F85E}",
        nfc: "\u{5922}",
        nfd: "\u{5922}",
        nfkc: "\u{5922}",
        nfkd: "\u{5922}",
    },
    NormalizationTest {
        source: "\u{2F85F}",
        nfc: "\u{5962}",
        nfd: "\u{5962}",
        nfkc: "\u{5962}",
        nfkd: "\u{5962}",
    },
    NormalizationTest {
        source: "\u{2F860}",
        nfc: "\u{216A8}",
        nfd: "\u{216A8}",
        nfkc: "\u{216A8}",
        nfkd: "\u{216A8}",
    },
    NormalizationTest {
        source: "\u{2F861}",
        nfc: "\u{216EA}",
        nfd: "\u{216EA}",
        nfkc: "\u{216EA}",
        nfkd: "\u{216EA}",
    },
    NormalizationTest {
        source: "\u{2F862}",
        nfc: "\u{59EC}",
        nfd: "\u{59EC}",
        nfkc: "\u{59EC}",
        nfkd: "\u{59EC}",
    },
    NormalizationTest {
        source: "\u{2F863}",
        nfc: "\u{5A1B}",
        nfd: "\u{5A1B}",
        nfkc: "\u{5A1B}",
        nfkd: "\u{5A1B}",
    },
    NormalizationTest {
        source: "\u{2F864}",
        nfc: "\u{5A27}",
        nfd: "\u{5A27}",
        nfkc: "\u{5A27}",
        nfkd: "\u{5A27}",
    },
    NormalizationTest {
        source: "\u{2F865}",
        nfc: "\u{59D8}",
        nfd: "\u{59D8}",
        nfkc: "\u{59D8}",
        nfkd: "\u{59D8}",
    },
    NormalizationTest {
        source: "\u{2F866}",
        nfc: "\u{5A66}",
        nfd: "\u{5A66}",
        nfkc: "\u{5A66}",
        nfkd: "\u{5A66}",
    },
    NormalizationTest {
        source: "\u{2F867}",
        nfc: "\u{36EE}",
        nfd: "\u{36EE}",
        nfkc: "\u{36EE}",
        nfkd: "\u{36EE}",
    },
    NormalizationTest {
        source: "\u{2F868}",
        nfc: "\u{36FC}",
        nfd: "\u{36FC}",
        nfkc: "\u{36FC}",
        nfkd: "\u{36FC}",
    },
    NormalizationTest {
        source: "\u{2F869}",
        nfc: "\u{5B08}",
        nfd: "\u{5B08}",
        nfkc: "\u{5B08}",
        nfkd: "\u{5B08}",
    },
    NormalizationTest {
        source: "\u{2F86A}",
        nfc: "\u{5B3E}",
        nfd: "\u{5B3E}",
        nfkc: "\u{5B3E}",
        nfkd: "\u{5B3E}",
    },
    NormalizationTest {
        source: "\u{2F86B}",
        nfc: "\u{5B3E}",
        nfd: "\u{5B3E}",
        nfkc: "\u{5B3E}",
        nfkd: "\u{5B3E}",
    },
    NormalizationTest {
        source: "\u{2F86C}",
        nfc: "\u{219C8}",
        nfd: "\u{219C8}",
        nfkc: "\u{219C8}",
        nfkd: "\u{219C8}",
    },
    NormalizationTest {
        source: "\u{2F86D}",
        nfc: "\u{5BC3}",
        nfd: "\u{5BC3}",
        nfkc: "\u{5BC3}",
        nfkd: "\u{5BC3}",
    },
    NormalizationTest {
        source: "\u{2F86E}",
        nfc: "\u{5BD8}",
        nfd: "\u{5BD8}",
        nfkc: "\u{5BD8}",
        nfkd: "\u{5BD8}",
    },
    NormalizationTest {
        source: "\u{2F86F}",
        nfc: "\u{5BE7}",
        nfd: "\u{5BE7}",
        nfkc: "\u{5BE7}",
        nfkd: "\u{5BE7}",
    },
    NormalizationTest {
        source: "\u{2F870}",
        nfc: "\u{5BF3}",
        nfd: "\u{5BF3}",
        nfkc: "\u{5BF3}",
        nfkd: "\u{5BF3}",
    },
    NormalizationTest {
        source: "\u{2F871}",
        nfc: "\u{21B18}",
        nfd: "\u{21B18}",
        nfkc: "\u{21B18}",
        nfkd: "\u{21B18}",
    },
    NormalizationTest {
        source: "\u{2F872}",
        nfc: "\u{5BFF}",
        nfd: "\u{5BFF}",
        nfkc: "\u{5BFF}",
        nfkd: "\u{5BFF}",
    },
    NormalizationTest {
        source: "\u{2F873}",
        nfc: "\u{5C06}",
        nfd: "\u{5C06}",
        nfkc: "\u{5C06}",
        nfkd: "\u{5C06}",
    },
    NormalizationTest {
        source: "\u{2F874}",
        nfc: "\u{5F53}",
        nfd: "\u{5F53}",
        nfkc: "\u{5F53}",
        nfkd: "\u{5F53}",
    },
    NormalizationTest {
        source: "\u{2F875}",
        nfc: "\u{5C22}",
        nfd: "\u{5C22}",
        nfkc: "\u{5C22}",
        nfkd: "\u{5C22}",
    },
    NormalizationTest {
        source: "\u{2F876}",
        nfc: "\u{3781}",
        nfd: "\u{3781}",
        nfkc: "\u{3781}",
        nfkd: "\u{3781}",
    },
    NormalizationTest {
        source: "\u{2F877}",
        nfc: "\u{5C60}",
        nfd: "\u{5C60}",
        nfkc: "\u{5C60}",
        nfkd: "\u{5C60}",
    },
    NormalizationTest {
        source: "\u{2F878}",
        nfc: "\u{5C6E}",
        nfd: "\u{5C6E}",
        nfkc: "\u{5C6E}",
        nfkd: "\u{5C6E}",
    },
    NormalizationTest {
        source: "\u{2F879}",
        nfc: "\u{5CC0}",
        nfd: "\u{5CC0}",
        nfkc: "\u{5CC0}",
        nfkd: "\u{5CC0}",
    },
    NormalizationTest {
        source: "\u{2F87A}",
        nfc: "\u{5C8D}",
        nfd: "\u{5C8D}",
        nfkc: "\u{5C8D}",
        nfkd: "\u{5C8D}",
    },
    NormalizationTest {
        source: "\u{2F87B}",
        nfc: "\u{21DE4}",
        nfd: "\u{21DE4}",
        nfkc: "\u{21DE4}",
        nfkd: "\u{21DE4}",
    },
    NormalizationTest {
        source: "\u{2F87C}",
        nfc: "\u{5D43}",
        nfd: "\u{5D43}",
        nfkc: "\u{5D43}",
        nfkd: "\u{5D43}",
    },
    NormalizationTest {
        source: "\u{2F87D}",
        nfc: "\u{21DE6}",
        nfd: "\u{21DE6}",
        nfkc: "\u{21DE6}",
        nfkd: "\u{21DE6}",
    },
    NormalizationTest {
        source: "\u{2F87E}",
        nfc: "\u{5D6E}",
        nfd: "\u{5D6E}",
        nfkc: "\u{5D6E}",
        nfkd: "\u{5D6E}",
    },
    NormalizationTest {
        source: "\u{2F87F}",
        nfc: "\u{5D6B}",
        nfd: "\u{5D6B}",
        nfkc: "\u{5D6B}",
        nfkd: "\u{5D6B}",
    },
    NormalizationTest {
        source: "\u{2F880}",
        nfc: "\u{5D7C}",
        nfd: "\u{5D7C}",
        nfkc: "\u{5D7C}",
        nfkd: "\u{5D7C}",
    },
    NormalizationTest {
        source: "\u{2F881}",
        nfc: "\u{5DE1}",
        nfd: "\u{5DE1}",
        nfkc: "\u{5DE1}",
        nfkd: "\u{5DE1}",
    },
    NormalizationTest {
        source: "\u{2F882}",
        nfc: "\u{5DE2}",
        nfd: "\u{5DE2}",
        nfkc: "\u{5DE2}",
        nfkd: "\u{5DE2}",
    },
    NormalizationTest {
        source: "\u{2F883}",
        nfc: "\u{382F}",
        nfd: "\u{382F}",
        nfkc: "\u{382F}",
        nfkd: "\u{382F}",
    },
    NormalizationTest {
        source: "\u{2F884}",
        nfc: "\u{5DFD}",
        nfd: "\u{5DFD}",
        nfkc: "\u{5DFD}",
        nfkd: "\u{5DFD}",
    },
    NormalizationTest {
        source: "\u{2F885}",
        nfc: "\u{5E28}",
        nfd: "\u{5E28}",
        nfkc: "\u{5E28}",
        nfkd: "\u{5E28}",
    },
    NormalizationTest {
        source: "\u{2F886}",
        nfc: "\u{5E3D}",
        nfd: "\u{5E3D}",
        nfkc: "\u{5E3D}",
        nfkd: "\u{5E3D}",
    },
    NormalizationTest {
        source: "\u{2F887}",
        nfc: "\u{5E69}",
        nfd: "\u{5E69}",
        nfkc: "\u{5E69}",
        nfkd: "\u{5E69}",
    },
    NormalizationTest {
        source: "\u{2F888}",
        nfc: "\u{3862}",
        nfd: "\u{3862}",
        nfkc: "\u{3862}",
        nfkd: "\u{3862}",
    },
    NormalizationTest {
        source: "\u{2F889}",
        nfc: "\u{22183}",
        nfd: "\u{22183}",
        nfkc: "\u{22183}",
        nfkd: "\u{22183}",
    },
    NormalizationTest {
        source: "\u{2F88A}",
        nfc: "\u{387C}",
        nfd: "\u{387C}",
        nfkc: "\u{387C}",
        nfkd: "\u{387C}",
    },
    NormalizationTest {
        source: "\u{2F88B}",
        nfc: "\u{5EB0}",
        nfd: "\u{5EB0}",
        nfkc: "\u{5EB0}",
        nfkd: "\u{5EB0}",
    },
    NormalizationTest {
        source: "\u{2F88C}",
        nfc: "\u{5EB3}",
        nfd: "\u{5EB3}",
        nfkc: "\u{5EB3}",
        nfkd: "\u{5EB3}",
    },
    NormalizationTest {
        source: "\u{2F88D}",
        nfc: "\u{5EB6}",
        nfd: "\u{5EB6}",
        nfkc: "\u{5EB6}",
        nfkd: "\u{5EB6}",
    },
    NormalizationTest {
        source: "\u{2F88E}",
        nfc: "\u{5ECA}",
        nfd: "\u{5ECA}",
        nfkc: "\u{5ECA}",
        nfkd: "\u{5ECA}",
    },
    NormalizationTest {
        source: "\u{2F88F}",
        nfc: "\u{2A392}",
        nfd: "\u{2A392}",
        nfkc: "\u{2A392}",
        nfkd: "\u{2A392}",
    },
    NormalizationTest {
        source: "\u{2F890}",
        nfc: "\u{5EFE}",
        nfd: "\u{5EFE}",
        nfkc: "\u{5EFE}",
        nfkd: "\u{5EFE}",
    },
    NormalizationTest {
        source: "\u{2F891}",
        nfc: "\u{22331}",
        nfd: "\u{22331}",
        nfkc: "\u{22331}",
        nfkd: "\u{22331}",
    },
    NormalizationTest {
        source: "\u{2F892}",
        nfc: "\u{22331}",
        nfd: "\u{22331}",
        nfkc: "\u{22331}",
        nfkd: "\u{22331}",
    },
    NormalizationTest {
        source: "\u{2F893}",
        nfc: "\u{8201}",
        nfd: "\u{8201}",
        nfkc: "\u{8201}",
        nfkd: "\u{8201}",
    },
    NormalizationTest {
        source: "\u{2F894}",
        nfc: "\u{5F22}",
        nfd: "\u{5F22}",
        nfkc: "\u{5F22}",
        nfkd: "\u{5F22}",
    },
    NormalizationTest {
        source: "\u{2F895}",
        nfc: "\u{5F22}",
        nfd: "\u{5F22}",
        nfkc: "\u{5F22}",
        nfkd: "\u{5F22}",
    },
    NormalizationTest {
        source: "\u{2F896}",
        nfc: "\u{38C7}",
        nfd: "\u{38C7}",
        nfkc: "\u{38C7}",
        nfkd: "\u{38C7}",
    },
    NormalizationTest {
        source: "\u{2F897}",
        nfc: "\u{232B8}",
        nfd: "\u{232B8}",
        nfkc: "\u{232B8}",
        nfkd: "\u{232B8}",
    },
    NormalizationTest {
        source: "\u{2F898}",
        nfc: "\u{261DA}",
        nfd: "\u{261DA}",
        nfkc: "\u{261DA}",
        nfkd: "\u{261DA}",
    },
    NormalizationTest {
        source: "\u{2F899}",
        nfc: "\u{5F62}",
        nfd: "\u{5F62}",
        nfkc: "\u{5F62}",
        nfkd: "\u{5F62}",
    },
    NormalizationTest {
        source: "\u{2F89A}",
        nfc: "\u{5F6B}",
        nfd: "\u{5F6B}",
        nfkc: "\u{5F6B}",
        nfkd: "\u{5F6B}",
    },
    NormalizationTest {
        source: "\u{2F89B}",
        nfc: "\u{38E3}",
        nfd: "\u{38E3}",
        nfkc: "\u{38E3}",
        nfkd: "\u{38E3}",
    },
    NormalizationTest {
        source: "\u{2F89C}",
        nfc: "\u{5F9A}",
        nfd: "\u{5F9A}",
        nfkc: "\u{5F9A}",
        nfkd: "\u{5F9A}",
    },
    NormalizationTest {
        source: "\u{2F89D}",
        nfc: "\u{5FCD}",
        nfd: "\u{5FCD}",
        nfkc: "\u{5FCD}",
        nfkd: "\u{5FCD}",
    },
    NormalizationTest {
        source: "\u{2F89E}",
        nfc: "\u{5FD7}",
        nfd: "\u{5FD7}",
        nfkc: "\u{5FD7}",
        nfkd: "\u{5FD7}",
    },
    NormalizationTest {
        source: "\u{2F89F}",
        nfc: "\u{5FF9}",
        nfd: "\u{5FF9}",
        nfkc: "\u{5FF9}",
        nfkd: "\u{5FF9}",
    },
    NormalizationTest {
        source: "\u{2F8A0}",
        nfc: "\u{6081}",
        nfd: "\u{6081}",
        nfkc: "\u{6081}",
        nfkd: "\u{6081}",
    },
    NormalizationTest {
        source: "\u{2F8A1}",
        nfc: "\u{393A}",
        nfd: "\u{393A}",
        nfkc: "\u{393A}",
        nfkd: "\u{393A}",
    },
    NormalizationTest {
        source: "\u{2F8A2}",
        nfc: "\u{391C}",
        nfd: "\u{391C}",
        nfkc: "\u{391C}",
        nfkd: "\u{391C}",
    },
    NormalizationTest {
        source: "\u{2F8A3}",
        nfc: "\u{6094}",
        nfd: "\u{6094}",
        nfkc: "\u{6094}",
        nfkd: "\u{6094}",
    },
    NormalizationTest {
        source: "\u{2F8A4}",
        nfc: "\u{226D4}",
        nfd: "\u{226D4}",
        nfkc: "\u{226D4}",
        nfkd: "\u{226D4}",
    },
    NormalizationTest {
        source: "\u{2F8A5}",
        nfc: "\u{60C7}",
        nfd: "\u{60C7}",
        nfkc: "\u{60C7}",
        nfkd: "\u{60C7}",
    },
    NormalizationTest {
        source: "\u{2F8A6}",
        nfc: "\u{6148}",
        nfd: "\u{6148}",
        nfkc: "\u{6148}",
        nfkd: "\u{6148}",
    },
    NormalizationTest {
        source: "\u{2F8A7}",
        nfc: "\u{614C}",
        nfd: "\u{614C}",
        nfkc: "\u{614C}",
        nfkd: "\u{614C}",
    },
    NormalizationTest {
        source: "\u{2F8A8}",
        nfc: "\u{614E}",
        nfd: "\u{614E}",
        nfkc: "\u{614E}",
        nfkd: "\u{614E}",
    },
    NormalizationTest {
        source: "\u{2F8A9}",
        nfc: "\u{614C}",
        nfd: "\u{614C}",
        nfkc: "\u{614C}",
        nfkd: "\u{614C}",
    },
    NormalizationTest {
        source: "\u{2F8AA}",
        nfc: "\u{617A}",
        nfd: "\u{617A}",
        nfkc: "\u{617A}",
        nfkd: "\u{617A}",
    },
    NormalizationTest {
        source: "\u{2F8AB}",
        nfc: "\u{618E}",
        nfd: "\u{618E}",
        nfkc: "\u{618E}",
        nfkd: "\u{618E}",
    },
    NormalizationTest {
        source: "\u{2F8AC}",
        nfc: "\u{61B2}",
        nfd: "\u{61B2}",
        nfkc: "\u{61B2}",
        nfkd: "\u{61B2}",
    },
    NormalizationTest {
        source: "\u{2F8AD}",
        nfc: "\u{61A4}",
        nfd: "\u{61A4}",
        nfkc: "\u{61A4}",
        nfkd: "\u{61A4}",
    },
    NormalizationTest {
        source: "\u{2F8AE}",
        nfc: "\u{61AF}",
        nfd: "\u{61AF}",
        nfkc: "\u{61AF}",
        nfkd: "\u{61AF}",
    },
    NormalizationTest {
        source: "\u{2F8AF}",
        nfc: "\u{61DE}",
        nfd: "\u{61DE}",
        nfkc: "\u{61DE}",
        nfkd: "\u{61DE}",
    },
    NormalizationTest {
        source: "\u{2F8B0}",
        nfc: "\u{61F2}",
        nfd: "\u{61F2}",
        nfkc: "\u{61F2}",
        nfkd: "\u{61F2}",
    },
    NormalizationTest {
        source: "\u{2F8B1}",
        nfc: "\u{61F6}",
        nfd: "\u{61F6}",
        nfkc: "\u{61F6}",
        nfkd: "\u{61F6}",
    },
    NormalizationTest {
        source: "\u{2F8B2}",
        nfc: "\u{6210}",
        nfd: "\u{6210}",
        nfkc: "\u{6210}",
        nfkd: "\u{6210}",
    },
    NormalizationTest {
        source: "\u{2F8B3}",
        nfc: "\u{621B}",
        nfd: "\u{621B}",
        nfkc: "\u{621B}",
        nfkd: "\u{621B}",
    },
    NormalizationTest {
        source: "\u{2F8B4}",
        nfc: "\u{625D}",
        nfd: "\u{625D}",
        nfkc: "\u{625D}",
        nfkd: "\u{625D}",
    },
    NormalizationTest {
        source: "\u{2F8B5}",
        nfc: "\u{62B1}",
        nfd: "\u{62B1}",
        nfkc: "\u{62B1}",
        nfkd: "\u{62B1}",
    },
    NormalizationTest {
        source: "\u{2F8B6}",
        nfc: "\u{62D4}",
        nfd: "\u{62D4}",
        nfkc: "\u{62D4}",
        nfkd: "\u{62D4}",
    },
    NormalizationTest {
        source: "\u{2F8B7}",
        nfc: "\u{6350}",
        nfd: "\u{6350}",
        nfkc: "\u{6350}",
        nfkd: "\u{6350}",
    },
    NormalizationTest {
        source: "\u{2F8B8}",
        nfc: "\u{22B0C}",
        nfd: "\u{22B0C}",
        nfkc: "\u{22B0C}",
        nfkd: "\u{22B0C}",
    },
    NormalizationTest {
        source: "\u{2F8B9}",
        nfc: "\u{633D}",
        nfd: "\u{633D}",
        nfkc: "\u{633D}",
        nfkd: "\u{633D}",
    },
    NormalizationTest {
        source: "\u{2F8BA}",
        nfc: "\u{62FC}",
        nfd: "\u{62FC}",
        nfkc: "\u{62FC}",
        nfkd: "\u{62FC}",
    },
    NormalizationTest {
        source: "\u{2F8BB}",
        nfc: "\u{6368}",
        nfd: "\u{6368}",
        nfkc: "\u{6368}",
        nfkd: "\u{6368}",
    },
    NormalizationTest {
        source: "\u{2F8BC}",
        nfc: "\u{6383}",
        nfd: "\u{6383}",
        nfkc: "\u{6383}",
        nfkd: "\u{6383}",
    },
    NormalizationTest {
        source: "\u{2F8BD}",
        nfc: "\u{63E4}",
        nfd: "\u{63E4}",
        nfkc: "\u{63E4}",
        nfkd: "\u{63E4}",
    },
    NormalizationTest {
        source: "\u{2F8BE}",
        nfc: "\u{22BF1}",
        nfd: "\u{22BF1}",
        nfkc: "\u{22BF1}",
        nfkd: "\u{22BF1}",
    },
    NormalizationTest {
        source: "\u{2F8BF}",
        nfc: "\u{6422}",
        nfd: "\u{6422}",
        nfkc: "\u{6422}",
        nfkd: "\u{6422}",
    },
    NormalizationTest {
        source: "\u{2F8C0}",
        nfc: "\u{63C5}",
        nfd: "\u{63C5}",
        nfkc: "\u{63C5}",
        nfkd: "\u{63C5}",
    },
    NormalizationTest {
        source: "\u{2F8C1}",
        nfc: "\u{63A9}",
        nfd: "\u{63A9}",
        nfkc: "\u{63A9}",
        nfkd: "\u{63A9}",
    },
    NormalizationTest {
        source: "\u{2F8C2}",
        nfc: "\u{3A2E}",
        nfd: "\u{3A2E}",
        nfkc: "\u{3A2E}",
        nfkd: "\u{3A2E}",
    },
    NormalizationTest {
        source: "\u{2F8C3}",
        nfc: "\u{6469}",
        nfd: "\u{6469}",
        nfkc: "\u{6469}",
        nfkd: "\u{6469}",
    },
    NormalizationTest {
        source: "\u{2F8C4}",
        nfc: "\u{647E}",
        nfd: "\u{647E}",
        nfkc: "\u{647E}",
        nfkd: "\u{647E}",
    },
    NormalizationTest {
        source: "\u{2F8C5}",
        nfc: "\u{649D}",
        nfd: "\u{649D}",
        nfkc: "\u{649D}",
        nfkd: "\u{649D}",
    },
    NormalizationTest {
        source: "\u{2F8C6}",
        nfc: "\u{6477}",
        nfd: "\u{6477}",
        nfkc: "\u{6477}",
        nfkd: "\u{6477}",
    },
    NormalizationTest {
        source: "\u{2F8C7}",
        nfc: "\u{3A6C}",
        nfd: "\u{3A6C}",
        nfkc: "\u{3A6C}",
        nfkd: "\u{3A6C}",
    },
    NormalizationTest {
        source: "\u{2F8C8}",
        nfc: "\u{654F}",
        nfd: "\u{654F}",
        nfkc: "\u{654F}",
        nfkd: "\u{654F}",
    },
    NormalizationTest {
        source: "\u{2F8C9}",
        nfc: "\u{656C}",
        nfd: "\u{656C}",
        nfkc: "\u{656C}",
        nfkd: "\u{656C}",
    },
    NormalizationTest {
        source: "\u{2F8CA}",
        nfc: "\u{2300A}",
        nfd: "\u{2300A}",
        nfkc: "\u{2300A}",
        nfkd: "\u{2300A}",
    },
    NormalizationTest {
        source: "\u{2F8CB}",
        nfc: "\u{65E3}",
        nfd: "\u{65E3}",
        nfkc: "\u{65E3}",
        nfkd: "\u{65E3}",
    },
    NormalizationTest {
        source: "\u{2F8CC}",
        nfc: "\u{66F8}",
        nfd: "\u{66F8}",
        nfkc: "\u{66F8}",
        nfkd: "\u{66F8}",
    },
    NormalizationTest {
        source: "\u{2F8CD}",
        nfc: "\u{6649}",
        nfd: "\u{6649}",
        nfkc: "\u{6649}",
        nfkd: "\u{6649}",
    },
    NormalizationTest {
        source: "\u{2F8CE}",
        nfc: "\u{3B19}",
        nfd: "\u{3B19}",
        nfkc: "\u{3B19}",
        nfkd: "\u{3B19}",
    },
    NormalizationTest {
        source: "\u{2F8CF}",
        nfc: "\u{6691}",
        nfd: "\u{6691}",
        nfkc: "\u{6691}",
        nfkd: "\u{6691}",
    },
    NormalizationTest {
        source: "\u{2F8D0}",
        nfc: "\u{3B08}",
        nfd: "\u{3B08}",
        nfkc: "\u{3B08}",
        nfkd: "\u{3B08}",
    },
    NormalizationTest {
        source: "\u{2F8D1}",
        nfc: "\u{3AE4}",
        nfd: "\u{3AE4}",
        nfkc: "\u{3AE4}",
        nfkd: "\u{3AE4}",
    },
    NormalizationTest {
        source: "\u{2F8D2}",
        nfc: "\u{5192}",
        nfd: "\u{5192}",
        nfkc: "\u{5192}",
        nfkd: "\u{5192}",
    },
    NormalizationTest {
        source: "\u{2F8D3}",
        nfc: "\u{5195}",
        nfd: "\u{5195}",
        nfkc: "\u{5195}",
        nfkd: "\u{5195}",
    },
    NormalizationTest {
        source: "\u{2F8D4}",
        nfc: "\u{6700}",
        nfd: "\u{6700}",
        nfkc: "\u{6700}",
        nfkd: "\u{6700}",
    },
    NormalizationTest {
        source: "\u{2F8D5}",
        nfc: "\u{669C}",
        nfd: "\u{669C}",
        nfkc: "\u{669C}",
        nfkd: "\u{669C}",
    },
    NormalizationTest {
        source: "\u{2F8D6}",
        nfc: "\u{80AD}",
        nfd: "\u{80AD}",
        nfkc: "\u{80AD}",
        nfkd: "\u{80AD}",
    },
    NormalizationTest {
        source: "\u{2F8D7}",
        nfc: "\u{43D9}",
        nfd: "\u{43D9}",
        nfkc: "\u{43D9}",
        nfkd: "\u{43D9}",
    },
    NormalizationTest {
        source: "\u{2F8D8}",
        nfc: "\u{6717}",
        nfd: "\u{6717}",
        nfkc: "\u{6717}",
        nfkd: "\u{6717}",
    },
    NormalizationTest {
        source: "\u{2F8D9}",
        nfc: "\u{671B}",
        nfd: "\u{671B}",
        nfkc: "\u{671B}",
        nfkd: "\u{671B}",
    },
    NormalizationTest {
        source: "\u{2F8DA}",
        nfc: "\u{6721}",
        nfd: "\u{6721}",
        nfkc: "\u{6721}",
        nfkd: "\u{6721}",
    },
    NormalizationTest {
        source: "\u{2F8DB}",
        nfc: "\u{675E}",
        nfd: "\u{675E}",
        nfkc: "\u{675E}",
        nfkd: "\u{675E}",
    },
    NormalizationTest {
        source: "\u{2F8DC}",
        nfc: "\u{6753}",
        nfd: "\u{6753}",
        nfkc: "\u{6753}",
        nfkd: "\u{6753}",
    },
    NormalizationTest {
        source: "\u{2F8DD}",
        nfc: "\u{233C3}",
        nfd: "\u{233C3}",
        nfkc: "\u{233C3}",
        nfkd: "\u{233C3}",
    },
    NormalizationTest {
        source: "\u{2F8DE}",
        nfc: "\u{3B49}",
        nfd: "\u{3B49}",
        nfkc: "\u{3B49}",
        nfkd: "\u{3B49}",
    },
    NormalizationTest {
        source: "\u{2F8DF}",
        nfc: "\u{67FA}",
        nfd: "\u{67FA}",
        nfkc: "\u{67FA}",
        nfkd: "\u{67FA}",
    },
    NormalizationTest {
        source: "\u{2F8E0}",
        nfc: "\u{6785}",
        nfd: "\u{6785}",
        nfkc: "\u{6785}",
        nfkd: "\u{6785}",
    },
    NormalizationTest {
        source: "\u{2F8E1}",
        nfc: "\u{6852}",
        nfd: "\u{6852}",
        nfkc: "\u{6852}",
        nfkd: "\u{6852}",
    },
    NormalizationTest {
        source: "\u{2F8E2}",
        nfc: "\u{6885}",
        nfd: "\u{6885}",
        nfkc: "\u{6885}",
        nfkd: "\u{6885}",
    },
    NormalizationTest {
        source: "\u{2F8E3}",
        nfc: "\u{2346D}",
        nfd: "\u{2346D}",
        nfkc: "\u{2346D}",
        nfkd: "\u{2346D}",
    },
    NormalizationTest {
        source: "\u{2F8E4}",
        nfc: "\u{688E}",
        nfd: "\u{688E}",
        nfkc: "\u{688E}",
        nfkd: "\u{688E}",
    },
    NormalizationTest {
        source: "\u{2F8E5}",
        nfc: "\u{681F}",
        nfd: "\u{681F}",
        nfkc: "\u{681F}",
        nfkd: "\u{681F}",
    },
    NormalizationTest {
        source: "\u{2F8E6}",
        nfc: "\u{6914}",
        nfd: "\u{6914}",
        nfkc: "\u{6914}",
        nfkd: "\u{6914}",
    },
    NormalizationTest {
        source: "\u{2F8E7}",
        nfc: "\u{3B9D}",
        nfd: "\u{3B9D}",
        nfkc: "\u{3B9D}",
        nfkd: "\u{3B9D}",
    },
    NormalizationTest {
        source: "\u{2F8E8}",
        nfc: "\u{6942}",
        nfd: "\u{6942}",
        nfkc: "\u{6942}",
        nfkd: "\u{6942}",
    },
    NormalizationTest {
        source: "\u{2F8E9}",
        nfc: "\u{69A3}",
        nfd: "\u{69A3}",
        nfkc: "\u{69A3}",
        nfkd: "\u{69A3}",
    },
    NormalizationTest {
        source: "\u{2F8EA}",
        nfc: "\u{69EA}",
        nfd: "\u{69EA}",
        nfkc: "\u{69EA}",
        nfkd: "\u{69EA}",
    },
    NormalizationTest {
        source: "\u{2F8EB}",
        nfc: "\u{6AA8}",
        nfd: "\u{6AA8}",
        nfkc: "\u{6AA8}",
        nfkd: "\u{6AA8}",
    },
    NormalizationTest {
        source: "\u{2F8EC}",
        nfc: "\u{236A3}",
        nfd: "\u{236A3}",
        nfkc: "\u{236A3}",
        nfkd: "\u{236A3}",
    },
    NormalizationTest {
        source: "\u{2F8ED}",
        nfc: "\u{6ADB}",
        nfd: "\u{6ADB}",
        nfkc: "\u{6ADB}",
        nfkd: "\u{6ADB}",
    },
    NormalizationTest {
        source: "\u{2F8EE}",
        nfc: "\u{3C18}",
        nfd: "\u{3C18}",
        nfkc: "\u{3C18}",
        nfkd: "\u{3C18}",
    },
    NormalizationTest {
        source: "\u{2F8EF}",
        nfc: "\u{6B21}",
        nfd: "\u{6B21}",
        nfkc: "\u{6B21}",
        nfkd: "\u{6B21}",
    },
    NormalizationTest {
        source: "\u{2F8F0}",
        nfc: "\u{238A7}",
        nfd: "\u{238A7}",
        nfkc: "\u{238A7}",
        nfkd: "\u{238A7}",
    },
    NormalizationTest {
        source: "\u{2F8F1}",
        nfc: "\u{6B54}",
        nfd: "\u{6B54}",
        nfkc: "\u{6B54}",
        nfkd: "\u{6B54}",
    },
    NormalizationTest {
        source: "\u{2F8F2}",
        nfc: "\u{3C4E}",
        nfd: "\u{3C4E}",
        nfkc: "\u{3C4E}",
        nfkd: "\u{3C4E}",
    },
    NormalizationTest {
        source: "\u{2F8F3}",
        nfc: "\u{6B72}",
        nfd: "\u{6B72}",
        nfkc: "\u{6B72}",
        nfkd: "\u{6B72}",
    },
    NormalizationTest {
        source: "\u{2F8F4}",
        nfc: "\u{6B9F}",
        nfd: "\u{6B9F}",
        nfkc: "\u{6B9F}",
        nfkd: "\u{6B9F}",
    },
    NormalizationTest {
        source: "\u{2F8F5}",
        nfc: "\u{6BBA}",
        nfd: "\u{6BBA}",
        nfkc: "\u{6BBA}",
        nfkd: "\u{6BBA}",
    },
    NormalizationTest {
        source: "\u{2F8F6}",
        nfc: "\u{6BBB}",
        nfd: "\u{6BBB}",
        nfkc: "\u{6BBB}",
        nfkd: "\u{6BBB}",
    },
    NormalizationTest {
        source: "\u{2F8F7}",
        nfc: "\u{23A8D}",
        nfd: "\u{23A8D}",
        nfkc: "\u{23A8D}",
        nfkd: "\u{23A8D}",
    },
    NormalizationTest {
        source: "\u{2F8F8}",
        nfc: "\u{21D0B}",
        nfd: "\u{21D0B}",
        nfkc: "\u{21D0B}",
        nfkd: "\u{21D0B}",
    },
    NormalizationTest {
        source: "\u{2F8F9}",
        nfc: "\u{23AFA}",
        nfd: "\u{23AFA}",
        nfkc: "\u{23AFA}",
        nfkd: "\u{23AFA}",
    },
    NormalizationTest {
        source: "\u{2F8FA}",
        nfc: "\u{6C4E}",
        nfd: "\u{6C4E}",
        nfkc: "\u{6C4E}",
        nfkd: "\u{6C4E}",
    },
    NormalizationTest {
        source: "\u{2F8FB}",
        nfc: "\u{23CBC}",
        nfd: "\u{23CBC}",
        nfkc: "\u{23CBC}",
        nfkd: "\u{23CBC}",
    },
    NormalizationTest {
        source: "\u{2F8FC}",
        nfc: "\u{6CBF}",
        nfd: "\u{6CBF}",
        nfkc: "\u{6CBF}",
        nfkd: "\u{6CBF}",
    },
    NormalizationTest {
        source: "\u{2F8FD}",
        nfc: "\u{6CCD}",
        nfd: "\u{6CCD}",
        nfkc: "\u{6CCD}",
        nfkd: "\u{6CCD}",
    },
    NormalizationTest {
        source: "\u{2F8FE}",
        nfc: "\u{6C67}",
        nfd: "\u{6C67}",
        nfkc: "\u{6C67}",
        nfkd: "\u{6C67}",
    },
    NormalizationTest {
        source: "\u{2F8FF}",
        nfc: "\u{6D16}",
        nfd: "\u{6D16}",
        nfkc: "\u{6D16}",
        nfkd: "\u{6D16}",
    },
    NormalizationTest {
        source: "\u{2F900}",
        nfc: "\u{6D3E}",
        nfd: "\u{6D3E}",
        nfkc: "\u{6D3E}",
        nfkd: "\u{6D3E}",
    },
    NormalizationTest {
        source: "\u{2F901}",
        nfc: "\u{6D77}",
        nfd: "\u{6D77}",
        nfkc: "\u{6D77}",
        nfkd: "\u{6D77}",
    },
    NormalizationTest {
        source: "\u{2F902}",
        nfc: "\u{6D41}",
        nfd: "\u{6D41}",
        nfkc: "\u{6D41}",
        nfkd: "\u{6D41}",
    },
    NormalizationTest {
        source: "\u{2F903}",
        nfc: "\u{6D69}",
        nfd: "\u{6D69}",
        nfkc: "\u{6D69}",
        nfkd: "\u{6D69}",
    },
    NormalizationTest {
        source: "\u{2F904}",
        nfc: "\u{6D78}",
        nfd: "\u{6D78}",
        nfkc: "\u{6D78}",
        nfkd: "\u{6D78}",
    },
    NormalizationTest {
        source: "\u{2F905}",
        nfc: "\u{6D85}",
        nfd: "\u{6D85}",
        nfkc: "\u{6D85}",
        nfkd: "\u{6D85}",
    },
    NormalizationTest {
        source: "\u{2F906}",
        nfc: "\u{23D1E}",
        nfd: "\u{23D1E}",
        nfkc: "\u{23D1E}",
        nfkd: "\u{23D1E}",
    },
    NormalizationTest {
        source: "\u{2F907}",
        nfc: "\u{6D34}",
        nfd: "\u{6D34}",
        nfkc: "\u{6D34}",
        nfkd: "\u{6D34}",
    },
    NormalizationTest {
        source: "\u{2F908}",
        nfc: "\u{6E2F}",
        nfd: "\u{6E2F}",
        nfkc: "\u{6E2F}",
        nfkd: "\u{6E2F}",
    },
    NormalizationTest {
        source: "\u{2F909}",
        nfc: "\u{6E6E}",
        nfd: "\u{6E6E}",
        nfkc: "\u{6E6E}",
        nfkd: "\u{6E6E}",
    },
    NormalizationTest {
        source: "\u{2F90A}",
        nfc: "\u{3D33}",
        nfd: "\u{3D33}",
        nfkc: "\u{3D33}",
        nfkd: "\u{3D33}",
    },
    NormalizationTest {
        source: "\u{2F90B}",
        nfc: "\u{6ECB}",
        nfd: "\u{6ECB}",
        nfkc: "\u{6ECB}",
        nfkd: "\u{6ECB}",
    },
    NormalizationTest {
        source: "\u{2F90C}",
        nfc: "\u{6EC7}",
        nfd: "\u{6EC7}",
        nfkc: "\u{6EC7}",
        nfkd: "\u{6EC7}",
    },
    NormalizationTest {
        source: "\u{2F90D}",
        nfc: "\u{23ED1}",
        nfd: "\u{23ED1}",
        nfkc: "\u{23ED1}",
        nfkd: "\u{23ED1}",
    },
    NormalizationTest {
        source: "\u{2F90E}",
        nfc: "\u{6DF9}",
        nfd: "\u{6DF9}",
        nfkc: "\u{6DF9}",
        nfkd: "\u{6DF9}",
    },
    NormalizationTest {
        source: "\u{2F90F}",
        nfc: "\u{6F6E}",
        nfd: "\u{6F6E}",
        nfkc: "\u{6F6E}",
        nfkd: "\u{6F6E}",
    },
    NormalizationTest {
        source: "\u{2F910}",
        nfc: "\u{23F5E}",
        nfd: "\u{23F5E}",
        nfkc: "\u{23F5E}",
        nfkd: "\u{23F5E}",
    },
    NormalizationTest {
        source: "\u{2F911}",
        nfc: "\u{23F8E}",
        nfd: "\u{23F8E}",
        nfkc: "\u{23F8E}",
        nfkd: "\u{23F8E}",
    },
    NormalizationTest {
        source: "\u{2F912}",
        nfc: "\u{6FC6}",
        nfd: "\u{6FC6}",
        nfkc: "\u{6FC6}",
        nfkd: "\u{6FC6}",
    },
    NormalizationTest {
        source: "\u{2F913}",
        nfc: "\u{7039}",
        nfd: "\u{7039}",
        nfkc: "\u{7039}",
        nfkd: "\u{7039}",
    },
    NormalizationTest {
        source: "\u{2F914}",
        nfc: "\u{701E}",
        nfd: "\u{701E}",
        nfkc: "\u{701E}",
        nfkd: "\u{701E}",
    },
    NormalizationTest {
        source: "\u{2F915}",
        nfc: "\u{701B}",
        nfd: "\u{701B}",
        nfkc: "\u{701B}",
        nfkd: "\u{701B}",
    },
    NormalizationTest {
        source: "\u{2F916}",
        nfc: "\u{3D96}",
        nfd: "\u{3D96}",
        nfkc: "\u{3D96}",
        nfkd: "\u{3D96}",
    },
    NormalizationTest {
        source: "\u{2F917}",
        nfc: "\u{704A}",
        nfd: "\u{704A}",
        nfkc: "\u{704A}",
        nfkd: "\u{704A}",
    },
    NormalizationTest {
        source: "\u{2F918}",
        nfc: "\u{707D}",
        nfd: "\u{707D}",
        nfkc: "\u{707D}",
        nfkd: "\u{707D}",
    },
    NormalizationTest {
        source: "\u{2F919}",
        nfc: "\u{7077}",
        nfd: "\u{7077}",
        nfkc: "\u{7077}",
        nfkd: "\u{7077}",
    },
    NormalizationTest {
        source: "\u{2F91A}",
        nfc: "\u{70AD}",
        nfd: "\u{70AD}",
        nfkc: "\u{70AD}",
        nfkd: "\u{70AD}",
    },
    NormalizationTest {
        source: "\u{2F91B}",
        nfc: "\u{20525}",
        nfd: "\u{20525}",
        nfkc: "\u{20525}",
        nfkd: "\u{20525}",
    },
    NormalizationTest {
        source: "\u{2F91C}",
        nfc: "\u{7145}",
        nfd: "\u{7145}",
        nfkc: "\u{7145}",
        nfkd: "\u{7145}",
    },
    NormalizationTest {
        source: "\u{2F91D}",
        nfc: "\u{24263}",
        nfd: "\u{24263}",
        nfkc: "\u{24263}",
        nfkd: "\u{24263}",
    },
    NormalizationTest {
        source: "\u{2F91E}",
        nfc: "\u{719C}",
        nfd: "\u{719C}",
        nfkc: "\u{719C}",
        nfkd: "\u{719C}",
    },
    NormalizationTest {
        source: "\u{2F91F}",
        nfc: "\u{243AB}",
        nfd: "\u{243AB}",
        nfkc: "\u{243AB}",
        nfkd: "\u{243AB}",
    },
    NormalizationTest {
        source: "\u{2F920}",
        nfc: "\u{7228}",
        nfd: "\u{7228}",
        nfkc: "\u{7228}",
        nfkd: "\u{7228}",
    },
    NormalizationTest {
        source: "\u{2F921}",
        nfc: "\u{7235}",
        nfd: "\u{7235}",
        nfkc: "\u{7235}",
        nfkd: "\u{7235}",
    },
    NormalizationTest {
        source: "\u{2F922}",
        nfc: "\u{7250}",
        nfd: "\u{7250}",
        nfkc: "\u{7250}",
        nfkd: "\u{7250}",
    },
    NormalizationTest {
        source: "\u{2F923}",
        nfc: "\u{24608}",
        nfd: "\u{24608}",
        nfkc: "\u{24608}",
        nfkd: "\u{24608}",
    },
    NormalizationTest {
        source: "\u{2F924}",
        nfc: "\u{7280}",
        nfd: "\u{7280}",
        nfkc: "\u{7280}",
        nfkd: "\u{7280}",
    },
    NormalizationTest {
        source: "\u{2F925}",
        nfc: "\u{7295}",
        nfd: "\u{7295}",
        nfkc: "\u{7295}",
        nfkd: "\u{7295}",
    },
    NormalizationTest {
        source: "\u{2F926}",
        nfc: "\u{24735}",
        nfd: "\u{24735}",
        nfkc: "\u{24735}",
        nfkd: "\u{24735}",
    },
    NormalizationTest {
        source: "\u{2F927}",
        nfc: "\u{24814}",
        nfd: "\u{24814}",
        nfkc: "\u{24814}",
        nfkd: "\u{24814}",
    },
    NormalizationTest {
        source: "\u{2F928}",
        nfc: "\u{737A}",
        nfd: "\u{737A}",
        nfkc: "\u{737A}",
        nfkd: "\u{737A}",
    },
    NormalizationTest {
        source: "\u{2F929}",
        nfc: "\u{738B}",
        nfd: "\u{738B}",
        nfkc: "\u{738B}",
        nfkd: "\u{738B}",
    },
    NormalizationTest {
        source: "\u{2F92A}",
        nfc: "\u{3EAC}",
        nfd: "\u{3EAC}",
        nfkc: "\u{3EAC}",
        nfkd: "\u{3EAC}",
    },
    NormalizationTest {
        source: "\u{2F92B}",
        nfc: "\u{73A5}",
        nfd: "\u{73A5}",
        nfkc: "\u{73A5}",
        nfkd: "\u{73A5}",
    },
    NormalizationTest {
        source: "\u{2F92C}",
        nfc: "\u{3EB8}",
        nfd: "\u{3EB8}",
        nfkc: "\u{3EB8}",
        nfkd: "\u{3EB8}",
    },
    NormalizationTest {
        source: "\u{2F92D}",
        nfc: "\u{3EB8}",
        nfd: "\u{3EB8}",
        nfkc: "\u{3EB8}",
        nfkd: "\u{3EB8}",
    },
    NormalizationTest {
        source: "\u{2F92E}",
        nfc: "\u{7447}",
        nfd: "\u{7447}",
        nfkc: "\u{7447}",
        nfkd: "\u{7447}",
    },
    NormalizationTest {
        source: "\u{2F92F}",
        nfc: "\u{745C}",
        nfd: "\u{745C}",
        nfkc: "\u{745C}",
        nfkd: "\u{745C}",
    },
    NormalizationTest {
        source: "\u{2F930}",
        nfc: "\u{7471}",
        nfd: "\u{7471}",
        nfkc: "\u{7471}",
        nfkd: "\u{7471}",
    },
    NormalizationTest {
        source: "\u{2F931}",
        nfc: "\u{7485}",
        nfd: "\u{7485}",
        nfkc: "\u{7485}",
        nfkd: "\u{7485}",
    },
    NormalizationTest {
        source: "\u{2F932}",
        nfc: "\u{74CA}",
        nfd: "\u{74CA}",
        nfkc: "\u{74CA}",
        nfkd: "\u{74CA}",
    },
    NormalizationTest {
        source: "\u{2F933}",
        nfc: "\u{3F1B}",
        nfd: "\u{3F1B}",
        nfkc: "\u{3F1B}",
        nfkd: "\u{3F1B}",
    },
    NormalizationTest {
        source: "\u{2F934}",
        nfc: "\u{7524}",
        nfd: "\u{7524}",
        nfkc: "\u{7524}",
        nfkd: "\u{7524}",
    },
    NormalizationTest {
        source: "\u{2F935}",
        nfc: "\u{24C36}",
        nfd: "\u{24C36}",
        nfkc: "\u{24C36}",
        nfkd: "\u{24C36}",
    },
    NormalizationTest {
        source: "\u{2F936}",
        nfc: "\u{753E}",
        nfd: "\u{753E}",
        nfkc: "\u{753E}",
        nfkd: "\u{753E}",
    },
    NormalizationTest {
        source: "\u{2F937}",
        nfc: "\u{24C92}",
        nfd: "\u{24C92}",
        nfkc: "\u{24C92}",
        nfkd: "\u{24C92}",
    },
    NormalizationTest {
        source: "\u{2F938}",
        nfc: "\u{7570}",
        nfd: "\u{7570}",
        nfkc: "\u{7570}",
        nfkd: "\u{7570}",
    },
    NormalizationTest {
        source: "\u{2F939}",
        nfc: "\u{2219F}",
        nfd: "\u{2219F}",
        nfkc: "\u{2219F}",
        nfkd: "\u{2219F}",
    },
    NormalizationTest {
        source: "\u{2F93A}",
        nfc: "\u{7610}",
        nfd: "\u{7610}",
        nfkc: "\u{7610}",
        nfkd: "\u{7610}",
    },
    NormalizationTest {
        source: "\u{2F93B}",
        nfc: "\u{24FA1}",
        nfd: "\u{24FA1}",
        nfkc: "\u{24FA1}",
        nfkd: "\u{24FA1}",
    },
    NormalizationTest {
        source: "\u{2F93C}",
        nfc: "\u{24FB8}",
        nfd: "\u{24FB8}",
        nfkc: "\u{24FB8}",
        nfkd: "\u{24FB8}",
    },
    NormalizationTest {
        source: "\u{2F93D}",
        nfc: "\u{25044}",
        nfd: "\u{25044}",
        nfkc: "\u{25044}",
        nfkd: "\u{25044}",
    },
    NormalizationTest {
        source: "\u{2F93E}",
        nfc: "\u{3FFC}",
        nfd: "\u{3FFC}",
        nfkc: "\u{3FFC}",
        nfkd: "\u{3FFC}",
    },
    NormalizationTest {
        source: "\u{2F93F}",
        nfc: "\u{4008}",
        nfd: "\u{4008}",
        nfkc: "\u{4008}",
        nfkd: "\u{4008}",
    },
    NormalizationTest {
        source: "\u{2F940}",
        nfc: "\u{76F4}",
        nfd: "\u{76F4}",
        nfkc: "\u{76F4}",
        nfkd: "\u{76F4}",
    },
    NormalizationTest {
        source: "\u{2F941}",
        nfc: "\u{250F3}",
        nfd: "\u{250F3}",
        nfkc: "\u{250F3}",
        nfkd: "\u{250F3}",
    },
    NormalizationTest {
        source: "\u{2F942}",
        nfc: "\u{250F2}",
        nfd: "\u{250F2}",
        nfkc: "\u{250F2}",
        nfkd: "\u{250F2}",
    },
    NormalizationTest {
        source: "\u{2F943}",
        nfc: "\u{25119}",
        nfd: "\u{25119}",
        nfkc: "\u{25119}",
        nfkd: "\u{25119}",
    },
    NormalizationTest {
        source: "\u{2F944}",
        nfc: "\u{25133}",
        nfd: "\u{25133}",
        nfkc: "\u{25133}",
        nfkd: "\u{25133}",
    },
    NormalizationTest {
        source: "\u{2F945}",
        nfc: "\u{771E}",
        nfd: "\u{771E}",
        nfkc: "\u{771E}",
        nfkd: "\u{771E}",
    },
    NormalizationTest {
        source: "\u{2F946}",
        nfc: "\u{771F}",
        nfd: "\u{771F}",
        nfkc: "\u{771F}",
        nfkd: "\u{771F}",
    },
    NormalizationTest {
        source: "\u{2F947}",
        nfc: "\u{771F}",
        nfd: "\u{771F}",
        nfkc: "\u{771F}",
        nfkd: "\u{771F}",
    },
    NormalizationTest {
        source: "\u{2F948}",
        nfc: "\u{774A}",
        nfd: "\u{774A}",
        nfkc: "\u{774A}",
        nfkd: "\u{774A}",
    },
    NormalizationTest {
        source: "\u{2F949}",
        nfc: "\u{4039}",
        nfd: "\u{4039}",
        nfkc: "\u{4039}",
        nfkd: "\u{4039}",
    },
    NormalizationTest {
        source: "\u{2F94A}",
        nfc: "\u{778B}",
        nfd: "\u{778B}",
        nfkc: "\u{778B}",
        nfkd: "\u{778B}",
    },
    NormalizationTest {
        source: "\u{2F94B}",
        nfc: "\u{4046}",
        nfd: "\u{4046}",
        nfkc: "\u{4046}",
        nfkd: "\u{4046}",
    },
    NormalizationTest {
        source: "\u{2F94C}",
        nfc: "\u{4096}",
        nfd: "\u{4096}",
        nfkc: "\u{4096}",
        nfkd: "\u{4096}",
    },
    NormalizationTest {
        source: "\u{2F94D}",
        nfc: "\u{2541D}",
        nfd: "\u{2541D}",
        nfkc: "\u{2541D}",
        nfkd: "\u{2541D}",
    },
    NormalizationTest {
        source: "\u{2F94E}",
        nfc: "\u{784E}",
        nfd: "\u{784E}",
        nfkc: "\u{784E}",
        nfkd: "\u{784E}",
    },
    NormalizationTest {
        source: "\u{2F94F}",
        nfc: "\u{788C}",
        nfd: "\u{788C}",
        nfkc: "\u{788C}",
        nfkd: "\u{788C}",
    },
    NormalizationTest {
        source: "\u{2F950}",
        nfc: "\u{78CC}",
        nfd: "\u{78CC}",
        nfkc: "\u{78CC}",
        nfkd: "\u{78CC}",
    },
    NormalizationTest {
        source: "\u{2F951}",
        nfc: "\u{40E3}",
        nfd: "\u{40E3}",
        nfkc: "\u{40E3}",
        nfkd: "\u{40E3}",
    },
    NormalizationTest {
        source: "\u{2F952}",
        nfc: "\u{25626}",
        nfd: "\u{25626}",
        nfkc: "\u{25626}",
        nfkd: "\u{25626}",
    },
    NormalizationTest {
        source: "\u{2F953}",
        nfc: "\u{7956}",
        nfd: "\u{7956}",
        nfkc: "\u{7956}",
        nfkd: "\u{7956}",
    },
    NormalizationTest {
        source: "\u{2F954}",
        nfc: "\u{2569A}",
        nfd: "\u{2569A}",
        nfkc: "\u{2569A}",
        nfkd: "\u{2569A}",
    },
    NormalizationTest {
        source: "\u{2F955}",
        nfc: "\u{256C5}",
        nfd: "\u{256C5}",
        nfkc: "\u{256C5}",
        nfkd: "\u{256C5}",
    },
    NormalizationTest {
        source: "\u{2F956}",
        nfc: "\u{798F}",
        nfd: "\u{798F}",
        nfkc: "\u{798F}",
        nfkd: "\u{798F}",
    },
    NormalizationTest {
        source: "\u{2F957}",
        nfc: "\u{79EB}",
        nfd: "\u{79EB}",
        nfkc: "\u{79EB}",
        nfkd: "\u{79EB}",
    },
    NormalizationTest {
        source: "\u{2F958}",
        nfc: "\u{412F}",
        nfd: "\u{412F}",
        nfkc: "\u{412F}",
        nfkd: "\u{412F}",
    },
    NormalizationTest {
        source: "\u{2F959}",
        nfc: "\u{7A40}",
        nfd: "\u{7A40}",
        nfkc: "\u{7A40}",
        nfkd: "\u{7A40}",
    },
    NormalizationTest {
        source: "\u{2F95A}",
        nfc: "\u{7A4A}",
        nfd: "\u{7A4A}",
        nfkc: "\u{7A4A}",
        nfkd: "\u{7A4A}",
    },
    NormalizationTest {
        source: "\u{2F95B}",
        nfc: "\u{7A4F}",
        nfd: "\u{7A4F}",
        nfkc: "\u{7A4F}",
        nfkd: "\u{7A4F}",
    },
    NormalizationTest {
        source: "\u{2F95C}",
        nfc: "\u{2597C}",
        nfd: "\u{2597C}",
        nfkc: "\u{2597C}",
        nfkd: "\u{2597C}",
    },
    NormalizationTest {
        source: "\u{2F95D}",
        nfc: "\u{25AA7}",
        nfd: "\u{25AA7}",
        nfkc: "\u{25AA7}",
        nfkd: "\u{25AA7}",
    },
    NormalizationTest {
        source: "\u{2F95E}",
        nfc: "\u{25AA7}",
        nfd: "\u{25AA7}",
        nfkc: "\u{25AA7}",
        nfkd: "\u{25AA7}",
    },
    NormalizationTest {
        source: "\u{2F95F}",
        nfc: "\u{7AEE}",
        nfd: "\u{7AEE}",
        nfkc: "\u{7AEE}",
        nfkd: "\u{7AEE}",
    },
    NormalizationTest {
        source: "\u{2F960}",
        nfc: "\u{4202}",
        nfd: "\u{4202}",
        nfkc: "\u{4202}",
        nfkd: "\u{4202}",
    },
    NormalizationTest {
        source: "\u{2F961}",
        nfc: "\u{25BAB}",
        nfd: "\u{25BAB}",
        nfkc: "\u{25BAB}",
        nfkd: "\u{25BAB}",
    },
    NormalizationTest {
        source: "\u{2F962}",
        nfc: "\u{7BC6}",
        nfd: "\u{7BC6}",
        nfkc: "\u{7BC6}",
        nfkd: "\u{7BC6}",
    },
    NormalizationTest {
        source: "\u{2F963}",
        nfc: "\u{7BC9}",
        nfd: "\u{7BC9}",
        nfkc: "\u{7BC9}",
        nfkd: "\u{7BC9}",
    },
    NormalizationTest {
        source: "\u{2F964}",
        nfc: "\u{4227}",
        nfd: "\u{4227}",
        nfkc: "\u{4227}",
        nfkd: "\u{4227}",
    },
    NormalizationTest {
        source: "\u{2F965}",
        nfc: "\u{25C80}",
        nfd: "\u{25C80}",
        nfkc: "\u{25C80}",
        nfkd: "\u{25C80}",
    },
    NormalizationTest {
        source: "\u{2F966}",
        nfc: "\u{7CD2}",
        nfd: "\u{7CD2}",
        nfkc: "\u{7CD2}",
        nfkd: "\u{7CD2}",
    },
    NormalizationTest {
        source: "\u{2F967}",
        nfc: "\u{42A0}",
        nfd: "\u{42A0}",
        nfkc: "\u{42A0}",
        nfkd: "\u{42A0}",
    },
    NormalizationTest {
        source: "\u{2F968}",
        nfc: "\u{7CE8}",
        nfd: "\u{7CE8}",
        nfkc: "\u{7CE8}",
        nfkd: "\u{7CE8}",
    },
    NormalizationTest {
        source: "\u{2F969}",
        nfc: "\u{7CE3}",
        nfd: "\u{7CE3}",
        nfkc: "\u{7CE3}",
        nfkd: "\u{7CE3}",
    },
    NormalizationTest {
        source: "\u{2F96A}",
        nfc: "\u{7D00}",
        nfd: "\u{7D00}",
        nfkc: "\u{7D00}",
        nfkd: "\u{7D00}",
    },
    NormalizationTest {
        source: "\u{2F96B}",
        nfc: "\u{25F86}",
        nfd: "\u{25F86}",
        nfkc: "\u{25F86}",
        nfkd: "\u{25F86}",
    },
    NormalizationTest {
        source: "\u{2F96C}",
        nfc: "\u{7D63}",
        nfd: "\u{7D63}",
        nfkc: "\u{7D63}",
        nfkd: "\u{7D63}",
    },
    NormalizationTest {
        source: "\u{2F96D}",
        nfc: "\u{4301}",
        nfd: "\u{4301}",
        nfkc: "\u{4301}",
        nfkd: "\u{4301}",
    },
    NormalizationTest {
        source: "\u{2F96E}",
        nfc: "\u{7DC7}",
        nfd: "\u{7DC7}",
        nfkc: "\u{7DC7}",
        nfkd: "\u{7DC7}",
    },
    NormalizationTest {
        source: "\u{2F96F}",
        nfc: "\u{7E02}",
        nfd: "\u{7E02}",
        nfkc: "\u{7E02}",
        nfkd: "\u{7E02}",
    },
    NormalizationTest {
        source: "\u{2F970}",
        nfc: "\u{7E45}",
        nfd: "\u{7E45}",
        nfkc: "\u{7E45}",
        nfkd: "\u{7E45}",
    },
    NormalizationTest {
        source: "\u{2F971}",
        nfc: "\u{4334}",
        nfd: "\u{4334}",
        nfkc: "\u{4334}",
        nfkd: "\u{4334}",
    },
    NormalizationTest {
        source: "\u{2F972}",
        nfc: "\u{26228}",
        nfd: "\u{26228}",
        nfkc: "\u{26228}",
        nfkd: "\u{26228}",
    },
    NormalizationTest {
        source: "\u{2F973}",
        nfc: "\u{26247}",
        nfd: "\u{26247}",
        nfkc: "\u{26247}",
        nfkd: "\u{26247}",
    },
    NormalizationTest {
        source: "\u{2F974}",
        nfc: "\u{4359}",
        nfd: "\u{4359}",
        nfkc: "\u{4359}",
        nfkd: "\u{4359}",
    },
    NormalizationTest {
        source: "\u{2F975}",
        nfc: "\u{262D9}",
        nfd: "\u{262D9}",
        nfkc: "\u{262D9}",
        nfkd: "\u{262D9}",
    },
    NormalizationTest {
        source: "\u{2F976}",
        nfc: "\u{7F7A}",
        nfd: "\u{7F7A}",
        nfkc: "\u{7F7A}",
        nfkd: "\u{7F7A}",
    },
    NormalizationTest {
        source: "\u{2F977}",
        nfc: "\u{2633E}",
        nfd: "\u{2633E}",
        nfkc: "\u{2633E}",
        nfkd: "\u{2633E}",
    },
    NormalizationTest {
        source: "\u{2F978}",
        nfc: "\u{7F95}",
        nfd: "\u{7F95}",
        nfkc: "\u{7F95}",
        nfkd: "\u{7F95}",
    },
    NormalizationTest {
        source: "\u{2F979}",
        nfc: "\u{7FFA}",
        nfd: "\u{7FFA}",
        nfkc: "\u{7FFA}",
        nfkd: "\u{7FFA}",
    },
    NormalizationTest {
        source: "\u{2F97A}",
        nfc: "\u{8005}",
        nfd: "\u{8005}",
        nfkc: "\u{8005}",
        nfkd: "\u{8005}",
    },
    NormalizationTest {
        source: "\u{2F97B}",
        nfc: "\u{264DA}",
        nfd: "\u{264DA}",
        nfkc: "\u{264DA}",
        nfkd: "\u{264DA}",
    },
    NormalizationTest {
        source: "\u{2F97C}",
        nfc: "\u{26523}",
        nfd: "\u{26523}",
        nfkc: "\u{26523}",
        nfkd: "\u{26523}",
    },
    NormalizationTest {
        source: "\u{2F97D}",
        nfc: "\u{8060}",
        nfd: "\u{8060}",
        nfkc: "\u{8060}",
        nfkd: "\u{8060}",
    },
    NormalizationTest {
        source: "\u{2F97E}",
        nfc: "\u{265A8}",
        nfd: "\u{265A8}",
        nfkc: "\u{265A8}",
        nfkd: "\u{265A8}",
    },
    NormalizationTest {
        source: "\u{2F97F}",
        nfc: "\u{8070}",
        nfd: "\u{8070}",
        nfkc: "\u{8070}",
        nfkd: "\u{8070}",
    },
    NormalizationTest {
        source: "\u{2F980}",
        nfc: "\u{2335F}",
        nfd: "\u{2335F}",
        nfkc: "\u{2335F}",
        nfkd: "\u{2335F}",
    },
    NormalizationTest {
        source: "\u{2F981}",
        nfc: "\u{43D5}",
        nfd: "\u{43D5}",
        nfkc: "\u{43D5}",
        nfkd: "\u{43D5}",
    },
    NormalizationTest {
        source: "\u{2F982}",
        nfc: "\u{80B2}",
        nfd: "\u{80B2}",
        nfkc: "\u{80B2}",
        nfkd: "\u{80B2}",
    },
    NormalizationTest {
        source: "\u{2F983}",
        nfc: "\u{8103}",
        nfd: "\u{8103}",
        nfkc: "\u{8103}",
        nfkd: "\u{8103}",
    },
    NormalizationTest {
        source: "\u{2F984}",
        nfc: "\u{440B}",
        nfd: "\u{440B}",
        nfkc: "\u{440B}",
        nfkd: "\u{440B}",
    },
    NormalizationTest {
        source: "\u{2F985}",
        nfc: "\u{813E}",
        nfd: "\u{813E}",
        nfkc: "\u{813E}",
        nfkd: "\u{813E}",
    },
    NormalizationTest {
        source: "\u{2F986}",
        nfc: "\u{5AB5}",
        nfd: "\u{5AB5}",
        nfkc: "\u{5AB5}",
        nfkd: "\u{5AB5}",
    },
    NormalizationTest {
        source: "\u{2F987}",
        nfc: "\u{267A7}",
        nfd: "\u{267A7}",
        nfkc: "\u{267A7}",
        nfkd: "\u{267A7}",
    },
    NormalizationTest {
        source: "\u{2F988}",
        nfc: "\u{267B5}",
        nfd: "\u{267B5}",
        nfkc: "\u{267B5}",
        nfkd: "\u{267B5}",
    },
    NormalizationTest {
        source: "\u{2F989}",
        nfc: "\u{23393}",
        nfd: "\u{23393}",
        nfkc: "\u{23393}",
        nfkd: "\u{23393}",
    },
    NormalizationTest {
        source: "\u{2F98A}",
        nfc: "\u{2339C}",
        nfd: "\u{2339C}",
        nfkc: "\u{2339C}",
        nfkd: "\u{2339C}",
    },
    NormalizationTest {
        source: "\u{2F98B}",
        nfc: "\u{8201}",
        nfd: "\u{8201}",
        nfkc: "\u{8201}",
        nfkd: "\u{8201}",
    },
    NormalizationTest {
        source: "\u{2F98C}",
        nfc: "\u{8204}",
        nfd: "\u{8204}",
        nfkc: "\u{8204}",
        nfkd: "\u{8204}",
    },
    NormalizationTest {
        source: "\u{2F98D}",
        nfc: "\u{8F9E}",
        nfd: "\u{8F9E}",
        nfkc: "\u{8F9E}",
        nfkd: "\u{8F9E}",
    },
    NormalizationTest {
        source: "\u{2F98E}",
        nfc: "\u{446B}",
        nfd: "\u{446B}",
        nfkc: "\u{446B}",
        nfkd: "\u{446B}",
    },
    NormalizationTest {
        source: "\u{2F98F}",
        nfc: "\u{8291}",
        nfd: "\u{8291}",
        nfkc: "\u{8291}",
        nfkd: "\u{8291}",
    },
    NormalizationTest {
        source: "\u{2F990}",
        nfc: "\u{828B}",
        nfd: "\u{828B}",
        nfkc: "\u{828B}",
        nfkd: "\u{828B}",
    },
    NormalizationTest {
        source: "\u{2F991}",
        nfc: "\u{829D}",
        nfd: "\u{829D}",
        nfkc: "\u{829D}",
        nfkd: "\u{829D}",
    },
    NormalizationTest {
        source: "\u{2F992}",
        nfc: "\u{52B3}",
        nfd: "\u{52B3}",
        nfkc: "\u{52B3}",
        nfkd: "\u{52B3}",
    },
    NormalizationTest {
        source: "\u{2F993}",
        nfc: "\u{82B1}",
        nfd: "\u{82B1}",
        nfkc: "\u{82B1}",
        nfkd: "\u{82B1}",
    },
    NormalizationTest {
        source: "\u{2F994}",
        nfc: "\u{82B3}",
        nfd: "\u{82B3}",
        nfkc: "\u{82B3}",
        nfkd: "\u{82B3}",
    },
    NormalizationTest {
        source: "\u{2F995}",
        nfc: "\u{82BD}",
        nfd: "\u{82BD}",
        nfkc: "\u{82BD}",
        nfkd: "\u{82BD}",
    },
    NormalizationTest {
        source: "\u{2F996}",
        nfc: "\u{82E6}",
        nfd: "\u{82E6}",
        nfkc: "\u{82E6}",
        nfkd: "\u{82E6}",
    },
    NormalizationTest {
        source: "\u{2F997}",
        nfc: "\u{26B3C}",
        nfd: "\u{26B3C}",
        nfkc: "\u{26B3C}",
        nfkd: "\u{26B3C}",
    },
    NormalizationTest {
        source: "\u{2F998}",
        nfc: "\u{82E5}",
        nfd: "\u{82E5}",
        nfkc: "\u{82E5}",
        nfkd: "\u{82E5}",
    },
    NormalizationTest {
        source: "\u{2F999}",
        nfc: "\u{831D}",
        nfd: "\u{831D}",
        nfkc: "\u{831D}",
        nfkd: "\u{831D}",
    },
    NormalizationTest {
        source: "\u{2F99A}",
        nfc: "\u{8363}",
        nfd: "\u{8363}",
        nfkc: "\u{8363}",
        nfkd: "\u{8363}",
    },
    NormalizationTest {
        source: "\u{2F99B}",
        nfc: "\u{83AD}",
        nfd: "\u{83AD}",
        nfkc: "\u{83AD}",
        nfkd: "\u{83AD}",
    },
    NormalizationTest {
        source: "\u{2F99C}",
        nfc: "\u{8323}",
        nfd: "\u{8323}",
        nfkc: "\u{8323}",
        nfkd: "\u{8323}",
    },
    NormalizationTest {
        source: "\u{2F99D}",
        nfc: "\u{83BD}",
        nfd: "\u{83BD}",
        nfkc: "\u{83BD}",
        nfkd: "\u{83BD}",
    },
    NormalizationTest {
        source: "\u{2F99E}",
        nfc: "\u{83E7}",
        nfd: "\u{83E7}",
        nfkc: "\u{83E7}",
        nfkd: "\u{83E7}",
    },
    NormalizationTest {
        source: "\u{2F99F}",
        nfc: "\u{8457}",
        nfd: "\u{8457}",
        nfkc: "\u{8457}",
        nfkd: "\u{8457}",
    },
    NormalizationTest {
        source: "\u{2F9A0}",
        nfc: "\u{8353}",
        nfd: "\u{8353}",
        nfkc: "\u{8353}",
        nfkd: "\u{8353}",
    },
    NormalizationTest {
        source: "\u{2F9A1}",
        nfc: "\u{83CA}",
        nfd: "\u{83CA}",
        nfkc: "\u{83CA}",
        nfkd: "\u{83CA}",
    },
    NormalizationTest {
        source: "\u{2F9A2}",
        nfc: "\u{83CC}",
        nfd: "\u{83CC}",
        nfkc: "\u{83CC}",
        nfkd: "\u{83CC}",
    },
    NormalizationTest {
        source: "\u{2F9A3}",
        nfc: "\u{83DC}",
        nfd: "\u{83DC}",
        nfkc: "\u{83DC}",
        nfkd: "\u{83DC}",
    },
    NormalizationTest {
        source: "\u{2F9A4}",
        nfc: "\u{26C36}",
        nfd: "\u{26C36}",
        nfkc: "\u{26C36}",
        nfkd: "\u{26C36}",
    },
    NormalizationTest {
        source: "\u{2F9A5}",
        nfc: "\u{26D6B}",
        nfd: "\u{26D6B}",
        nfkc: "\u{26D6B}",
        nfkd: "\u{26D6B}",
    },
    NormalizationTest {
        source: "\u{2F9A6}",
        nfc: "\u{26CD5}",
        nfd: "\u{26CD5}",
        nfkc: "\u{26CD5}",
        nfkd: "\u{26CD5}",
    },
    NormalizationTest {
        source: "\u{2F9A7}",
        nfc: "\u{452B}",
        nfd: "\u{452B}",
        nfkc: "\u{452B}",
        nfkd: "\u{452B}",
    },
    NormalizationTest {
        source: "\u{2F9A8}",
        nfc: "\u{84F1}",
        nfd: "\u{84F1}",
        nfkc: "\u{84F1}",
        nfkd: "\u{84F1}",
    },
    NormalizationTest {
        source: "\u{2F9A9}",
        nfc: "\u{84F3}",
        nfd: "\u{84F3}",
        nfkc: "\u{84F3}",
        nfkd: "\u{84F3}",
    },
    NormalizationTest {
        source: "\u{2F9AA}",
        nfc: "\u{8516}",
        nfd: "\u{8516}",
        nfkc: "\u{8516}",
        nfkd: "\u{8516}",
    },
    NormalizationTest {
        source: "\u{2F9AB}",
        nfc: "\u{273CA}",
        nfd: "\u{273CA}",
        nfkc: "\u{273CA}",
        nfkd: "\u{273CA}",
    },
    NormalizationTest {
        source: "\u{2F9AC}",
        nfc: "\u{8564}",
        nfd: "\u{8564}",
        nfkc: "\u{8564}",
        nfkd: "\u{8564}",
    },
    NormalizationTest {
        source: "\u{2F9AD}",
        nfc: "\u{26F2C}",
        nfd: "\u{26F2C}",
        nfkc: "\u{26F2C}",
        nfkd: "\u{26F2C}",
    },
    NormalizationTest {
        source: "\u{2F9AE}",
        nfc: "\u{455D}",
        nfd: "\u{455D}",
        nfkc: "\u{455D}",
        nfkd: "\u{455D}",
    },
    NormalizationTest {
        source: "\u{2F9AF}",
        nfc: "\u{4561}",
        nfd: "\u{4561}",
        nfkc: "\u{4561}",
        nfkd: "\u{4561}",
    },
    NormalizationTest {
        source: "\u{2F9B0}",
        nfc: "\u{26FB1}",
        nfd: "\u{26FB1}",
        nfkc: "\u{26FB1}",
        nfkd: "\u{26FB1}",
    },
    NormalizationTest {
        source: "\u{2F9B1}",
        nfc: "\u{270D2}",
        nfd: "\u{270D2}",
        nfkc: "\u{270D2}",
        nfkd: "\u{270D2}",
    },
    NormalizationTest {
        source: "\u{2F9B2}",
        nfc: "\u{456B}",
        nfd: "\u{456B}",
        nfkc: "\u{456B}",
        nfkd: "\u{456B}",
    },
    NormalizationTest {
        source: "\u{2F9B3}",
        nfc: "\u{8650}",
        nfd: "\u{8650}",
        nfkc: "\u{8650}",
        nfkd: "\u{8650}",
    },
    NormalizationTest {
        source: "\u{2F9B4}",
        nfc: "\u{865C}",
        nfd: "\u{865C}",
        nfkc: "\u{865C}",
        nfkd: "\u{865C}",
    },
    NormalizationTest {
        source: "\u{2F9B5}",
        nfc: "\u{8667}",
        nfd: "\u{8667}",
        nfkc: "\u{8667}",
        nfkd: "\u{8667}",
    },
    NormalizationTest {
        source: "\u{2F9B6}",
        nfc: "\u{8669}",
        nfd: "\u{8669}",
        nfkc: "\u{8669}",
        nfkd: "\u{8669}",
    },
    NormalizationTest {
        source: "\u{2F9B7}",
        nfc: "\u{86A9}",
        nfd: "\u{86A9}",
        nfkc: "\u{86A9}",
        nfkd: "\u{86A9}",
    },
    NormalizationTest {
        source: "\u{2F9B8}",
        nfc: "\u{8688}",
        nfd: "\u{8688}",
        nfkc: "\u{8688}",
        nfkd: "\u{8688}",
    },
    NormalizationTest {
        source: "\u{2F9B9}",
        nfc: "\u{870E}",
        nfd: "\u{870E}",
        nfkc: "\u{870E}",
        nfkd: "\u{870E}",
    },
    NormalizationTest {
        source: "\u{2F9BA}",
        nfc: "\u{86E2}",
        nfd: "\u{86E2}",
        nfkc: "\u{86E2}",
        nfkd: "\u{86E2}",
    },
    NormalizationTest {
        source: "\u{2F9BB}",
        nfc: "\u{8779}",
        nfd: "\u{8779}",
        nfkc: "\u{8779}",
        nfkd: "\u{8779}",
    },
    NormalizationTest {
        source: "\u{2F9BC}",
        nfc: "\u{8728}",
        nfd: "\u{8728}",
        nfkc: "\u{8728}",
        nfkd: "\u{8728}",
    },
    NormalizationTest {
        source: "\u{2F9BD}",
        nfc: "\u{876B}",
        nfd: "\u{876B}",
        nfkc: "\u{876B}",
        nfkd: "\u{876B}",
    },
    NormalizationTest {
        source: "\u{2F9BE}",
        nfc: "\u{8786}",
        nfd: "\u{8786}",
        nfkc: "\u{8786}",
        nfkd: "\u{8786}",
    },
    NormalizationTest {
        source: "\u{2F9BF}",
        nfc: "\u{45D7}",
        nfd: "\u{45D7}",
        nfkc: "\u{45D7}",
        nfkd: "\u{45D7}",
    },
    NormalizationTest {
        source: "\u{2F9C0}",
        nfc: "\u{87E1}",
        nfd: "\u{87E1}",
        nfkc: "\u{87E1}",
        nfkd: "\u{87E1}",
    },
    NormalizationTest {
        source: "\u{2F9C1}",
        nfc: "\u{8801}",
        nfd: "\u{8801}",
        nfkc: "\u{8801}",
        nfkd: "\u{8801}",
    },
    NormalizationTest {
        source: "\u{2F9C2}",
        nfc: "\u{45F9}",
        nfd: "\u{45F9}",
        nfkc: "\u{45F9}",
        nfkd: "\u{45F9}",
    },
    NormalizationTest {
        source: "\u{2F9C3}",
        nfc: "\u{8860}",
        nfd: "\u{8860}",
        nfkc: "\u{8860}",
        nfkd: "\u{8860}",
    },
    NormalizationTest {
        source: "\u{2F9C4}",
        nfc: "\u{8863}",
        nfd: "\u{8863}",
        nfkc: "\u{8863}",
        nfkd: "\u{8863}",
    },
    NormalizationTest {
        source: "\u{2F9C5}",
        nfc: "\u{27667}",
        nfd: "\u{27667}",
        nfkc: "\u{27667}",
        nfkd: "\u{27667}",
    },
    NormalizationTest {
        source: "\u{2F9C6}",
        nfc: "\u{88D7}",
        nfd: "\u{88D7}",
        nfkc: "\u{88D7}",
        nfkd: "\u{88D7}",
    },
    NormalizationTest {
        source: "\u{2F9C7}",
        nfc: "\u{88DE}",
        nfd: "\u{88DE}",
        nfkc: "\u{88DE}",
        nfkd: "\u{88DE}",
    },
    NormalizationTest {
        source: "\u{2F9C8}",
        nfc: "\u{4635}",
        nfd: "\u{4635}",
        nfkc: "\u{4635}",
        nfkd: "\u{4635}",
    },
    NormalizationTest {
        source: "\u{2F9C9}",
        nfc: "\u{88FA}",
        nfd: "\u{88FA}",
        nfkc: "\u{88FA}",
        nfkd: "\u{88FA}",
    },
    NormalizationTest {
        source: "\u{2F9CA}",
        nfc: "\u{34BB}",
        nfd: "\u{34BB}",
        nfkc: "\u{34BB}",
        nfkd: "\u{34BB}",
    },
    NormalizationTest {
        source: "\u{2F9CB}",
        nfc: "\u{278AE}",
        nfd: "\u{278AE}",
        nfkc: "\u{278AE}",
        nfkd: "\u{278AE}",
    },
    NormalizationTest {
        source: "\u{2F9CC}",
        nfc: "\u{27966}",
        nfd: "\u{27966}",
        nfkc: "\u{27966}",
        nfkd: "\u{27966}",
    },
    NormalizationTest {
        source: "\u{2F9CD}",
        nfc: "\u{46BE}",
        nfd: "\u{46BE}",
        nfkc: "\u{46BE}",
        nfkd: "\u{46BE}",
    },
    NormalizationTest {
        source: "\u{2F9CE}",
        nfc: "\u{46C7}",
        nfd: "\u{46C7}",
        nfkc: "\u{46C7}",
        nfkd: "\u{46C7}",
    },
    NormalizationTest {
        source: "\u{2F9CF}",
        nfc: "\u{8AA0}",
        nfd: "\u{8AA0}",
        nfkc: "\u{8AA0}",
        nfkd: "\u{8AA0}",
    },
    NormalizationTest {
        source: "\u{2F9D0}",
        nfc: "\u{8AED}",
        nfd: "\u{8AED}",
        nfkc: "\u{8AED}",
        nfkd: "\u{8AED}",
    },
    NormalizationTest {
        source: "\u{2F9D1}",
        nfc: "\u{8B8A}",
        nfd: "\u{8B8A}",
        nfkc: "\u{8B8A}",
        nfkd: "\u{8B8A}",
    },
    NormalizationTest {
        source: "\u{2F9D2}",
        nfc: "\u{8C55}",
        nfd: "\u{8C55}",
        nfkc: "\u{8C55}",
        nfkd: "\u{8C55}",
    },
    NormalizationTest {
        source: "\u{2F9D3}",
        nfc: "\u{27CA8}",
        nfd: "\u{27CA8}",
        nfkc: "\u{27CA8}",
        nfkd: "\u{27CA8}",
    },
    NormalizationTest {
        source: "\u{2F9D4}",
        nfc: "\u{8CAB}",
        nfd: "\u{8CAB}",
        nfkc: "\u{8CAB}",
        nfkd: "\u{8CAB}",
    },
    NormalizationTest {
        source: "\u{2F9D5}",
        nfc: "\u{8CC1}",
        nfd: "\u{8CC1}",
        nfkc: "\u{8CC1}",
        nfkd: "\u{8CC1}",
    },
    NormalizationTest {
        source: "\u{2F9D6}",
        nfc: "\u{8D1B}",
        nfd: "\u{8D1B}",
        nfkc: "\u{8D1B}",
        nfkd: "\u{8D1B}",
    },
    NormalizationTest {
        source: "\u{2F9D7}",
        nfc: "\u{8D77}",
        nfd: "\u{8D77}",
        nfkc: "\u{8D77}",
        nfkd: "\u{8D77}",
    },
    NormalizationTest {
        source: "\u{2F9D8}",
        nfc: "\u{27F2F}",
        nfd: "\u{27F2F}",
        nfkc: "\u{27F2F}",
        nfkd: "\u{27F2F}",
    },
    NormalizationTest {
        source: "\u{2F9D9}",
        nfc: "\u{20804}",
        nfd: "\u{20804}",
        nfkc: "\u{20804}",
        nfkd: "\u{20804}",
    },
    NormalizationTest {
        source: "\u{2F9DA}",
        nfc: "\u{8DCB}",
        nfd: "\u{8DCB}",
        nfkc: "\u{8DCB}",
        nfkd: "\u{8DCB}",
    },
    NormalizationTest {
        source: "\u{2F9DB}",
        nfc: "\u{8DBC}",
        nfd: "\u{8DBC}",
        nfkc: "\u{8DBC}",
        nfkd: "\u{8DBC}",
    },
    NormalizationTest {
        source: "\u{2F9DC}",
        nfc: "\u{8DF0}",
        nfd: "\u{8DF0}",
        nfkc: "\u{8DF0}",
        nfkd: "\u{8DF0}",
    },
    NormalizationTest {
        source: "\u{2F9DD}",
        nfc: "\u{208DE}",
        nfd: "\u{208DE}",
        nfkc: "\u{208DE}",
        nfkd: "\u{208DE}",
    },
    NormalizationTest {
        source: "\u{2F9DE}",
        nfc: "\u{8ED4}",
        nfd: "\u{8ED4}",
        nfkc: "\u{8ED4}",
        nfkd: "\u{8ED4}",
    },
    NormalizationTest {
        source: "\u{2F9DF}",
        nfc: "\u{8F38}",
        nfd: "\u{8F38}",
        nfkc: "\u{8F38}",
        nfkd: "\u{8F38}",
    },
    NormalizationTest {
        source: "\u{2F9E0}",
        nfc: "\u{285D2}",
        nfd: "\u{285D2}",
        nfkc: "\u{285D2}",
        nfkd: "\u{285D2}",
    },
    NormalizationTest {
        source: "\u{2F9E1}",
        nfc: "\u{285ED}",
        nfd: "\u{285ED}",
        nfkc: "\u{285ED}",
        nfkd: "\u{285ED}",
    },
    NormalizationTest {
        source: "\u{2F9E2}",
        nfc: "\u{9094}",
        nfd: "\u{9094}",
        nfkc: "\u{9094}",
        nfkd: "\u{9094}",
    },
    NormalizationTest {
        source: "\u{2F9E3}",
        nfc: "\u{90F1}",
        nfd: "\u{90F1}",
        nfkc: "\u{90F1}",
        nfkd: "\u{90F1}",
    },
    NormalizationTest {
        source: "\u{2F9E4}",
        nfc: "\u{9111}",
        nfd: "\u{9111}",
        nfkc: "\u{9111}",
        nfkd: "\u{9111}",
    },
    NormalizationTest {
        source: "\u{2F9E5}",
        nfc: "\u{2872E}",
        nfd: "\u{2872E}",
        nfkc: "\u{2872E}",
        nfkd: "\u{2872E}",
    },
    NormalizationTest {
        source: "\u{2F9E6}",
        nfc: "\u{911B}",
        nfd: "\u{911B}",
        nfkc: "\u{911B}",
        nfkd: "\u{911B}",
    },
    NormalizationTest {
        source: "\u{2F9E7}",
        nfc: "\u{9238}",
        nfd: "\u{9238}",
        nfkc: "\u{9238}",
        nfkd: "\u{9238}",
    },
    NormalizationTest {
        source: "\u{2F9E8}",
        nfc: "\u{92D7}",
        nfd: "\u{92D7}",
        nfkc: "\u{92D7}",
        nfkd: "\u{92D7}",
    },
    NormalizationTest {
        source: "\u{2F9E9}",
        nfc: "\u{92D8}",
        nfd: "\u{92D8}",
        nfkc: "\u{92D8}",
        nfkd: "\u{92D8}",
    },
    NormalizationTest {
        source: "\u{2F9EA}",
        nfc: "\u{927C}",
        nfd: "\u{927C}",
        nfkc: "\u{927C}",
        nfkd: "\u{927C}",
    },
    NormalizationTest {
        source: "\u{2F9EB}",
        nfc: "\u{93F9}",
        nfd: "\u{93F9}",
        nfkc: "\u{93F9}",
        nfkd: "\u{93F9}",
    },
    NormalizationTest {
        source: "\u{2F9EC}",
        nfc: "\u{9415}",
        nfd: "\u{9415}",
        nfkc: "\u{9415}",
        nfkd: "\u{9415}",
    },
    NormalizationTest {
        source: "\u{2F9ED}",
        nfc: "\u{28BFA}",
        nfd: "\u{28BFA}",
        nfkc: "\u{28BFA}",
        nfkd: "\u{28BFA}",
    },
    NormalizationTest {
        source: "\u{2F9EE}",
        nfc: "\u{958B}",
        nfd: "\u{958B}",
        nfkc: "\u{958B}",
        nfkd: "\u{958B}",
    },
    NormalizationTest {
        source: "\u{2F9EF}",
        nfc: "\u{4995}",
        nfd: "\u{4995}",
        nfkc: "\u{4995}",
        nfkd: "\u{4995}",
    },
    NormalizationTest {
        source: "\u{2F9F0}",
        nfc: "\u{95B7}",
        nfd: "\u{95B7}",
        nfkc: "\u{95B7}",
        nfkd: "\u{95B7}",
    },
    NormalizationTest {
        source: "\u{2F9F1}",
        nfc: "\u{28D77}",
        nfd: "\u{28D77}",
        nfkc: "\u{28D77}",
        nfkd: "\u{28D77}",
    },
    NormalizationTest {
        source: "\u{2F9F2}",
        nfc: "\u{49E6}",
        nfd: "\u{49E6}",
        nfkc: "\u{49E6}",
        nfkd: "\u{49E6}",
    },
    NormalizationTest {
        source: "\u{2F9F3}",
        nfc: "\u{96C3}",
        nfd: "\u{96C3}",
        nfkc: "\u{96C3}",
        nfkd: "\u{96C3}",
    },
    NormalizationTest {
        source: "\u{2F9F4}",
        nfc: "\u{5DB2}",
        nfd: "\u{5DB2}",
        nfkc: "\u{5DB2}",
        nfkd: "\u{5DB2}",
    },
    NormalizationTest {
        source: "\u{2F9F5}",
        nfc: "\u{9723}",
        nfd: "\u{9723}",
        nfkc: "\u{9723}",
        nfkd: "\u{9723}",
    },
    NormalizationTest {
        source: "\u{2F9F6}",
        nfc: "\u{29145}",
        nfd: "\u{29145}",
        nfkc: "\u{29145}",
        nfkd: "\u{29145}",
    },
    NormalizationTest {
        source: "\u{2F9F7}",
        nfc: "\u{2921A}",
        nfd: "\u{2921A}",
        nfkc: "\u{2921A}",
        nfkd: "\u{2921A}",
    },
    NormalizationTest {
        source: "\u{2F9F8}",
        nfc: "\u{4A6E}",
        nfd: "\u{4A6E}",
        nfkc: "\u{4A6E}",
        nfkd: "\u{4A6E}",
    },
    NormalizationTest {
        source: "\u{2F9F9}",
        nfc: "\u{4A76}",
        nfd: "\u{4A76}",
        nfkc: "\u{4A76}",
        nfkd: "\u{4A76}",
    },
    NormalizationTest {
        source: "\u{2F9FA}",
        nfc: "\u{97E0}",
        nfd: "\u{97E0}",
        nfkc: "\u{97E0}",
        nfkd: "\u{97E0}",
    },
    NormalizationTest {
        source: "\u{2F9FB}",
        nfc: "\u{2940A}",
        nfd: "\u{2940A}",
        nfkc: "\u{2940A}",
        nfkd: "\u{2940A}",
    },
    NormalizationTest {
        source: "\u{2F9FC}",
        nfc: "\u{4AB2}",
        nfd: "\u{4AB2}",
        nfkc: "\u{4AB2}",
        nfkd: "\u{4AB2}",
    },
    NormalizationTest {
        source: "\u{2F9FD}",
        nfc: "\u{29496}",
        nfd: "\u{29496}",
        nfkc: "\u{29496}",
        nfkd: "\u{29496}",
    },
    NormalizationTest {
        source: "\u{2F9FE}",
        nfc: "\u{980B}",
        nfd: "\u{980B}",
        nfkc: "\u{980B}",
        nfkd: "\u{980B}",
    },
    NormalizationTest {
        source: "\u{2F9FF}",
        nfc: "\u{980B}",
        nfd: "\u{980B}",
        nfkc: "\u{980B}",
        nfkd: "\u{980B}",
    },
    NormalizationTest {
        source: "\u{2FA00}",
        nfc: "\u{9829}",
        nfd: "\u{9829}",
        nfkc: "\u{9829}",
        nfkd: "\u{9829}",
    },
    NormalizationTest {
        source: "\u{2FA01}",
        nfc: "\u{295B6}",
        nfd: "\u{295B6}",
        nfkc: "\u{295B6}",
        nfkd: "\u{295B6}",
    },
    NormalizationTest {
        source: "\u{2FA02}",
        nfc: "\u{98E2}",
        nfd: "\u{98E2}",
        nfkc: "\u{98E2}",
        nfkd: "\u{98E2}",
    },
    NormalizationTest {
        source: "\u{2FA03}",
        nfc: "\u{4B33}",
        nfd: "\u{4B33}",
        nfkc: "\u{4B33}",
        nfkd: "\u{4B33}",
    },
    NormalizationTest {
        source: "\u{2FA04}",
        nfc: "\u{9929}",
        nfd: "\u{9929}",
        nfkc: "\u{9929}",
        nfkd: "\u{9929}",
    },
    NormalizationTest {
        source: "\u{2FA05}",
        nfc: "\u{99A7}",
        nfd: "\u{99A7}",
        nfkc: "\u{99A7}",
        nfkd: "\u{99A7}",
    },
    NormalizationTest {
        source: "\u{2FA06}",
        nfc: "\u{99C2}",
        nfd: "\u{99C2}",
        nfkc: "\u{99C2}",
        nfkd: "\u{99C2}",
    },
    NormalizationTest {
        source: "\u{2FA07}",
        nfc: "\u{99FE}",
        nfd: "\u{99FE}",
        nfkc: "\u{99FE}",
        nfkd: "\u{99FE}",
    },
    NormalizationTest {
        source: "\u{2FA08}",
        nfc: "\u{4BCE}",
        nfd: "\u{4BCE}",
        nfkc: "\u{4BCE}",
        nfkd: "\u{4BCE}",
    },
    NormalizationTest {
        source: "\u{2FA09}",
        nfc: "\u{29B30}",
        nfd: "\u{29B30}",
        nfkc: "\u{29B30}",
        nfkd: "\u{29B30}",
    },
    NormalizationTest {
        source: "\u{2FA0A}",
        nfc: "\u{9B12}",
        nfd: "\u{9B12}",
        nfkc: "\u{9B12}",
        nfkd: "\u{9B12}",
    },
    NormalizationTest {
        source: "\u{2FA0B}",
        nfc: "\u{9C40}",
        nfd: "\u{9C40}",
        nfkc: "\u{9C40}",
        nfkd: "\u{9C40}",
    },
    NormalizationTest {
        source: "\u{2FA0C}",
        nfc: "\u{9CFD}",
        nfd: "\u{9CFD}",
        nfkc: "\u{9CFD}",
        nfkd: "\u{9CFD}",
    },
    NormalizationTest {
        source: "\u{2FA0D}",
        nfc: "\u{4CCE}",
        nfd: "\u{4CCE}",
        nfkc: "\u{4CCE}",
        nfkd: "\u{4CCE}",
    },
    NormalizationTest {
        source: "\u{2FA0E}",
        nfc: "\u{4CED}",
        nfd: "\u{4CED}",
        nfkc: "\u{4CED}",
        nfkd: "\u{4CED}",
    },
    NormalizationTest {
        source: "\u{2FA0F}",
        nfc: "\u{9D67}",
        nfd: "\u{9D67}",
        nfkc: "\u{9D67}",
        nfkd: "\u{9D67}",
    },
    NormalizationTest {
        source: "\u{2FA10}",
        nfc: "\u{2A0CE}",
        nfd: "\u{2A0CE}",
        nfkc: "\u{2A0CE}",
        nfkd: "\u{2A0CE}",
    },
    NormalizationTest {
        source: "\u{2FA11}",
        nfc: "\u{4CF8}",
        nfd: "\u{4CF8}",
        nfkc: "\u{4CF8}",
        nfkd: "\u{4CF8}",
    },
    NormalizationTest {
        source: "\u{2FA12}",
        nfc: "\u{2A105}",
        nfd: "\u{2A105}",
        nfkc: "\u{2A105}",
        nfkd: "\u{2A105}",
    },
    NormalizationTest {
        source: "\u{2FA13}",
        nfc: "\u{2A20E}",
        nfd: "\u{2A20E}",
        nfkc: "\u{2A20E}",
        nfkd: "\u{2A20E}",
    },
    NormalizationTest {
        source: "\u{2FA14}",
        nfc: "\u{2A291}",
        nfd: "\u{2A291}",
        nfkc: "\u{2A291}",
        nfkd: "\u{2A291}",
    },
    NormalizationTest {
        source: "\u{2FA15}",
        nfc: "\u{9EBB}",
        nfd: "\u{9EBB}",
        nfkc: "\u{9EBB}",
        nfkd: "\u{9EBB}",
    },
    NormalizationTest {
        source: "\u{2FA16}",
        nfc: "\u{4D56}",
        nfd: "\u{4D56}",
        nfkc: "\u{4D56}",
        nfkd: "\u{4D56}",
    },
    NormalizationTest {
        source: "\u{2FA17}",
        nfc: "\u{9EF9}",
        nfd: "\u{9EF9}",
        nfkc: "\u{9EF9}",
        nfkd: "\u{9EF9}",
    },
    NormalizationTest {
        source: "\u{2FA18}",
        nfc: "\u{9EFE}",
        nfd: "\u{9EFE}",
        nfkc: "\u{9EFE}",
        nfkd: "\u{9EFE}",
    },
    NormalizationTest {
        source: "\u{2FA19}",
        nfc: "\u{9F05}",
        nfd: "\u{9F05}",
        nfkc: "\u{9F05}",
        nfkd: "\u{9F05}",
    },
    NormalizationTest {
        source: "\u{2FA1A}",
        nfc: "\u{9F0F}",
        nfd: "\u{9F0F}",
        nfkc: "\u{9F0F}",
        nfkd: "\u{9F0F}",
    },
    NormalizationTest {
        source: "\u{2FA1B}",
        nfc: "\u{9F16}",
        nfd: "\u{9F16}",
        nfkc: "\u{9F16}",
        nfkd: "\u{9F16}",
    },
    NormalizationTest {
        source: "\u{2FA1C}",
        nfc: "\u{9F3B}",
        nfd: "\u{9F3B}",
        nfkc: "\u{9F3B}",
        nfkd: "\u{9F3B}",
    },
    NormalizationTest {
        source: "\u{2FA1D}",
        nfc: "\u{2A600}",
        nfd: "\u{2A600}",
        nfkc: "\u{2A600}",
        nfkd: "\u{2A600}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0300}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0300}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0301}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0301}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0301}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0301}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0301}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0301}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{00E1}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0301}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{00E1}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0301}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0302}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0302}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0302}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0302}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0302}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0302}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{1EA7}\u{05AE}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0302}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{1EA7}\u{05AE}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0302}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0303}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0303}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0303}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0303}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0303}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0303}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{00E3}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0303}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{00E3}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0303}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0304}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0304}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0304}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0304}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0304}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0304}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0101}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0304}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0101}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0304}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0305}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0305}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0305}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0305}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0305}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0305}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0305}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0305}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0305}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0305}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0306}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0306}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0306}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0306}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0306}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0306}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{1EB1}\u{05AE}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0306}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{1EB1}\u{05AE}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0306}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0307}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0307}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0307}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0307}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0307}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0307}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0227}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0307}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0227}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0307}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0308}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0308}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0308}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0308}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0308}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0308}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{00E4}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0308}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{00E4}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0308}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0309}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0309}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0309}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0309}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0309}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0309}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{1EA3}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0309}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{1EA3}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0309}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{030A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{030A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{030A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{030A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{030A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{030A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{00E5}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{030A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{00E5}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{030A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{030B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{030B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{030B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{030B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{030B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{030B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{030B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{030B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{030B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{030B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{030C}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{030C}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{030C}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{030C}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{030C}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{030C}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{01CE}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{030C}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{01CE}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{030C}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{030D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{030D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{030D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{030D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{030D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{030D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{030D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{030D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{030D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{030D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{030E}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{030E}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{030E}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{030E}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{030E}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{030E}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{030E}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{030E}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{030E}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{030E}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{030F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{030F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{030F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{030F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{030F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{030F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0201}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{030F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0201}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{030F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0310}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0310}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0310}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0310}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0310}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0310}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0310}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0310}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0310}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0310}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0311}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0311}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0311}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0311}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0311}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0311}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0203}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0311}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0203}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0311}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0312}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0312}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0312}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0312}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0312}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0312}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0312}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0312}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0312}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0312}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0313}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0313}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0313}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0313}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0313}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0313}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0313}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0313}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0313}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0313}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0314}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0314}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0314}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0314}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0314}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0314}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0314}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0314}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0314}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0314}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035C}\u{0315}\u{0300}\u{0315}\u{0062}",
        nfc: "\u{00E0}\u{0315}\u{0315}\u{035C}\u{0062}",
        nfd: "\u{0061}\u{0300}\u{0315}\u{0315}\u{035C}\u{0062}",
        nfkc: "\u{00E0}\u{0315}\u{0315}\u{035C}\u{0062}",
        nfkd: "\u{0061}\u{0300}\u{0315}\u{0315}\u{035C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{035C}\u{0315}\u{0300}\u{0062}",
        nfc: "\u{00E0}\u{0315}\u{0315}\u{035C}\u{0062}",
        nfd: "\u{0061}\u{0300}\u{0315}\u{0315}\u{035C}\u{0062}",
        nfkc: "\u{00E0}\u{0315}\u{0315}\u{035C}\u{0062}",
        nfkd: "\u{0061}\u{0300}\u{0315}\u{0315}\u{035C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0316}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0316}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0317}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0317}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0317}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0317}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0317}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0317}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0317}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0317}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0317}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0317}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0318}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0318}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0318}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0318}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0318}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0318}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0318}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0318}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0318}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0318}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0319}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0319}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0319}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0319}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0319}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0319}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0319}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0319}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0319}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0319}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035C}\u{0315}\u{0300}\u{031A}\u{0062}",
        nfc: "\u{00E0}\u{0315}\u{031A}\u{035C}\u{0062}",
        nfd: "\u{0061}\u{0300}\u{0315}\u{031A}\u{035C}\u{0062}",
        nfkc: "\u{00E0}\u{0315}\u{031A}\u{035C}\u{0062}",
        nfkd: "\u{0061}\u{0300}\u{0315}\u{031A}\u{035C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{031A}\u{035C}\u{0315}\u{0300}\u{0062}",
        nfc: "\u{00E0}\u{031A}\u{0315}\u{035C}\u{0062}",
        nfd: "\u{0061}\u{0300}\u{031A}\u{0315}\u{035C}\u{0062}",
        nfkc: "\u{00E0}\u{031A}\u{0315}\u{035C}\u{0062}",
        nfkd: "\u{0061}\u{0300}\u{031A}\u{0315}\u{035C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302A}\u{031B}\u{1DCE}\u{031B}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{031B}\u{031B}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{031B}\u{031B}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{031B}\u{031B}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{031B}\u{031B}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{031B}\u{302A}\u{031B}\u{1DCE}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{031B}\u{031B}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{031B}\u{031B}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{031B}\u{031B}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{031B}\u{031B}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{031C}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{031C}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{031C}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{031C}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{031C}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{031C}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{031C}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{031C}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{031C}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{031C}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{031D}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{031D}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{031D}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{031D}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{031D}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{031D}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{031D}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{031D}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{031D}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{031D}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{031E}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{031E}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{031E}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{031E}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{031E}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{031E}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{031E}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{031E}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{031E}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{031E}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{031F}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{031F}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{031F}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{031F}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{031F}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{031F}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{031F}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{031F}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{031F}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{031F}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0320}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0320}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0320}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0320}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0320}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0320}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0320}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0320}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0320}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0320}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DCE}\u{0321}\u{0F74}\u{0321}\u{0062}",
        nfc: "\u{0061}\u{0F74}\u{0321}\u{0321}\u{1DCE}\u{0062}",
        nfd: "\u{0061}\u{0F74}\u{0321}\u{0321}\u{1DCE}\u{0062}",
        nfkc: "\u{0061}\u{0F74}\u{0321}\u{0321}\u{1DCE}\u{0062}",
        nfkd: "\u{0061}\u{0F74}\u{0321}\u{0321}\u{1DCE}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0321}\u{1DCE}\u{0321}\u{0F74}\u{0062}",
        nfc: "\u{0061}\u{0F74}\u{0321}\u{0321}\u{1DCE}\u{0062}",
        nfd: "\u{0061}\u{0F74}\u{0321}\u{0321}\u{1DCE}\u{0062}",
        nfkc: "\u{0061}\u{0F74}\u{0321}\u{0321}\u{1DCE}\u{0062}",
        nfkd: "\u{0061}\u{0F74}\u{0321}\u{0321}\u{1DCE}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DCE}\u{0321}\u{0F74}\u{0322}\u{0062}",
        nfc: "\u{0061}\u{0F74}\u{0321}\u{0322}\u{1DCE}\u{0062}",
        nfd: "\u{0061}\u{0F74}\u{0321}\u{0322}\u{1DCE}\u{0062}",
        nfkc: "\u{0061}\u{0F74}\u{0321}\u{0322}\u{1DCE}\u{0062}",
        nfkd: "\u{0061}\u{0F74}\u{0321}\u{0322}\u{1DCE}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0322}\u{1DCE}\u{0321}\u{0F74}\u{0062}",
        nfc: "\u{0061}\u{0F74}\u{0322}\u{0321}\u{1DCE}\u{0062}",
        nfd: "\u{0061}\u{0F74}\u{0322}\u{0321}\u{1DCE}\u{0062}",
        nfkc: "\u{0061}\u{0F74}\u{0322}\u{0321}\u{1DCE}\u{0062}",
        nfkd: "\u{0061}\u{0F74}\u{0322}\u{0321}\u{1DCE}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0323}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0323}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0323}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0323}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0323}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0323}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{1EA1}\u{302A}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0323}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{1EA1}\u{302A}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0323}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0324}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0324}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0324}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0324}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0324}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0324}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0324}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0324}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0324}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0324}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0325}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0325}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0325}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0325}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0325}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0325}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{1E01}\u{302A}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0325}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{1E01}\u{302A}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0325}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0326}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0326}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0326}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0326}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0326}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0326}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0326}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0326}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0326}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0326}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DCE}\u{0321}\u{0F74}\u{0327}\u{0062}",
        nfc: "\u{0061}\u{0F74}\u{0321}\u{0327}\u{1DCE}\u{0062}",
        nfd: "\u{0061}\u{0F74}\u{0321}\u{0327}\u{1DCE}\u{0062}",
        nfkc: "\u{0061}\u{0F74}\u{0321}\u{0327}\u{1DCE}\u{0062}",
        nfkd: "\u{0061}\u{0F74}\u{0321}\u{0327}\u{1DCE}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0327}\u{1DCE}\u{0321}\u{0F74}\u{0062}",
        nfc: "\u{0061}\u{0F74}\u{0327}\u{0321}\u{1DCE}\u{0062}",
        nfd: "\u{0061}\u{0F74}\u{0327}\u{0321}\u{1DCE}\u{0062}",
        nfkc: "\u{0061}\u{0F74}\u{0327}\u{0321}\u{1DCE}\u{0062}",
        nfkd: "\u{0061}\u{0F74}\u{0327}\u{0321}\u{1DCE}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DCE}\u{0321}\u{0F74}\u{0328}\u{0062}",
        nfc: "\u{0061}\u{0F74}\u{0321}\u{0328}\u{1DCE}\u{0062}",
        nfd: "\u{0061}\u{0F74}\u{0321}\u{0328}\u{1DCE}\u{0062}",
        nfkc: "\u{0061}\u{0F74}\u{0321}\u{0328}\u{1DCE}\u{0062}",
        nfkd: "\u{0061}\u{0F74}\u{0321}\u{0328}\u{1DCE}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0328}\u{1DCE}\u{0321}\u{0F74}\u{0062}",
        nfc: "\u{0105}\u{0F74}\u{0321}\u{1DCE}\u{0062}",
        nfd: "\u{0061}\u{0F74}\u{0328}\u{0321}\u{1DCE}\u{0062}",
        nfkc: "\u{0105}\u{0F74}\u{0321}\u{1DCE}\u{0062}",
        nfkd: "\u{0061}\u{0F74}\u{0328}\u{0321}\u{1DCE}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0329}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0329}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0329}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0329}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0329}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0329}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0329}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0329}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0329}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0329}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{032A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{032A}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{032A}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{032A}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{032A}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{032A}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{032A}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{032A}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{032A}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{032A}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{032B}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{032B}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{032B}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{032B}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{032B}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{032B}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{032B}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{032B}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{032B}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{032B}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{032C}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{032C}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{032C}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{032C}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{032C}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{032C}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{032C}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{032C}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{032C}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{032C}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{032D}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{032D}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{032D}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{032D}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{032D}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{032D}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{032D}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{032D}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{032D}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{032D}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{032E}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{032E}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{032E}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{032E}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{032E}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{032E}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{032E}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{032E}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{032E}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{032E}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{032F}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{032F}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{032F}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{032F}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{032F}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{032F}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{032F}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{032F}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{032F}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{032F}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0330}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0330}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0330}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0330}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0330}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0330}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0330}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0330}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0330}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0330}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0331}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0331}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0331}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0331}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0331}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0331}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0331}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0331}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0331}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0331}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0332}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0332}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0332}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0332}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0332}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0332}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0332}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0332}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0332}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0332}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0333}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0333}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0333}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0333}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0333}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0333}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0333}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0333}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0333}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0333}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0334}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{0335}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{0335}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{0335}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{0335}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{0335}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0335}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0335}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0335}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0335}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0335}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{0336}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{0336}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{0336}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{0336}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{0336}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0336}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0336}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0336}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0336}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0336}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{0337}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{0337}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{0337}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{0337}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{0337}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0337}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0337}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0337}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0337}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0337}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{0338}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{0338}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{0338}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{0338}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{0338}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0338}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0338}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0338}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0338}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0338}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0339}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0339}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0339}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0339}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0339}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0339}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0339}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0339}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0339}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0339}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{033A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{033A}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{033A}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{033A}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{033A}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{033A}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{033A}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{033A}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{033A}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{033A}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{033B}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{033B}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{033B}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{033B}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{033B}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{033B}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{033B}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{033B}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{033B}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{033B}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{033C}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{033C}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{033C}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{033C}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{033C}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{033C}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{033C}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{033C}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{033C}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{033C}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{033D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{033D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{033D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{033D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{033D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{033D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{033D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{033D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{033D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{033D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{033E}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{033E}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{033E}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{033E}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{033E}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{033E}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{033E}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{033E}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{033E}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{033E}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{033F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{033F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{033F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{033F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{033F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{033F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{033F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{033F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{033F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{033F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0340}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0340}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0341}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0301}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0301}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0301}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0301}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0341}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{00E1}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0301}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{00E1}\u{05AE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0301}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0342}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0342}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0342}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0342}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0342}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0342}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0342}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0342}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0342}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0342}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0343}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0313}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0313}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0313}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0313}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0343}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0313}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0313}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0313}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0313}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0344}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0308}\u{0301}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0308}\u{0301}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0308}\u{0301}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0308}\u{0301}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0344}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{00E4}\u{05AE}\u{0301}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0308}\u{0301}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{00E4}\u{05AE}\u{0301}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0308}\u{0301}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0345}\u{035D}\u{0345}\u{0062}",
        nfc: "\u{0061}\u{035D}\u{0345}\u{0345}\u{0062}",
        nfd: "\u{0061}\u{035D}\u{0345}\u{0345}\u{0062}",
        nfkc: "\u{0061}\u{035D}\u{0345}\u{0345}\u{0062}",
        nfkd: "\u{0061}\u{035D}\u{0345}\u{0345}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0345}\u{0345}\u{035D}\u{0062}",
        nfc: "\u{0061}\u{035D}\u{0345}\u{0345}\u{0062}",
        nfd: "\u{0061}\u{035D}\u{0345}\u{0345}\u{0062}",
        nfkc: "\u{0061}\u{035D}\u{0345}\u{0345}\u{0062}",
        nfkd: "\u{0061}\u{035D}\u{0345}\u{0345}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0346}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0346}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0346}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0346}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0346}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0346}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0346}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0346}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0346}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0346}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0347}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0347}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0347}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0347}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0347}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0347}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0347}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0347}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0347}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0347}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0348}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0348}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0348}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0348}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0348}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0348}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0348}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0348}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0348}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0348}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0349}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0349}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0349}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0349}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0349}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0349}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0349}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0349}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0349}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0349}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{034A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{034A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{034A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{034A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{034A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{034A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{034A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{034A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{034A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{034A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{034B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{034B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{034B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{034B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{034B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{034B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{034B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{034B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{034B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{034B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{034C}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{034C}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{034C}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{034C}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{034C}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{034C}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{034C}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{034C}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{034C}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{034C}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{034D}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{034D}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{034D}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{034D}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{034D}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{034D}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{034D}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{034D}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{034D}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{034D}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{034E}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{034E}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{034E}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{034E}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{034E}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{034E}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{034E}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{034E}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{034E}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{034E}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0350}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0350}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0350}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0350}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0350}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0350}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0350}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0350}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0350}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0350}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0351}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0351}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0351}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0351}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0351}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0351}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0351}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0351}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0351}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0351}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0352}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0352}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0352}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0352}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0352}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0352}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0352}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0352}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0352}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0352}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0353}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0353}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0353}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0353}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0353}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0353}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0353}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0353}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0353}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0353}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0354}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0354}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0354}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0354}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0354}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0354}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0354}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0354}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0354}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0354}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0355}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0355}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0355}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0355}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0355}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0355}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0355}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0355}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0355}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0355}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0356}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0356}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0356}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0356}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0356}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0356}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0356}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0356}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0356}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0356}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0357}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0357}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0357}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0357}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0357}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0357}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0357}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0357}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0357}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0357}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035C}\u{0315}\u{0300}\u{0358}\u{0062}",
        nfc: "\u{00E0}\u{0315}\u{0358}\u{035C}\u{0062}",
        nfd: "\u{0061}\u{0300}\u{0315}\u{0358}\u{035C}\u{0062}",
        nfkc: "\u{00E0}\u{0315}\u{0358}\u{035C}\u{0062}",
        nfkd: "\u{0061}\u{0300}\u{0315}\u{0358}\u{035C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0358}\u{035C}\u{0315}\u{0300}\u{0062}",
        nfc: "\u{00E0}\u{0358}\u{0315}\u{035C}\u{0062}",
        nfd: "\u{0061}\u{0300}\u{0358}\u{0315}\u{035C}\u{0062}",
        nfkc: "\u{00E0}\u{0358}\u{0315}\u{035C}\u{0062}",
        nfkd: "\u{0061}\u{0300}\u{0358}\u{0315}\u{035C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0359}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0359}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0359}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0359}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0359}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0359}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0359}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0359}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0359}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0359}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{035A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{035A}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{035A}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{035A}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{035A}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035A}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{035A}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{035A}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{035A}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{035A}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{035B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{035B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{035B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{035B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{035B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{035B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{035B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{035B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{035B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035D}\u{035C}\u{0315}\u{035C}\u{0062}",
        nfc: "\u{0061}\u{0315}\u{035C}\u{035C}\u{035D}\u{0062}",
        nfd: "\u{0061}\u{0315}\u{035C}\u{035C}\u{035D}\u{0062}",
        nfkc: "\u{0061}\u{0315}\u{035C}\u{035C}\u{035D}\u{0062}",
        nfkd: "\u{0061}\u{0315}\u{035C}\u{035C}\u{035D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035C}\u{035D}\u{035C}\u{0315}\u{0062}",
        nfc: "\u{0061}\u{0315}\u{035C}\u{035C}\u{035D}\u{0062}",
        nfd: "\u{0061}\u{0315}\u{035C}\u{035C}\u{035D}\u{0062}",
        nfkc: "\u{0061}\u{0315}\u{035C}\u{035C}\u{035D}\u{0062}",
        nfkd: "\u{0061}\u{0315}\u{035C}\u{035C}\u{035D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0345}\u{035D}\u{035C}\u{035D}\u{0062}",
        nfc: "\u{0061}\u{035C}\u{035D}\u{035D}\u{0345}\u{0062}",
        nfd: "\u{0061}\u{035C}\u{035D}\u{035D}\u{0345}\u{0062}",
        nfkc: "\u{0061}\u{035C}\u{035D}\u{035D}\u{0345}\u{0062}",
        nfkd: "\u{0061}\u{035C}\u{035D}\u{035D}\u{0345}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035D}\u{0345}\u{035D}\u{035C}\u{0062}",
        nfc: "\u{0061}\u{035C}\u{035D}\u{035D}\u{0345}\u{0062}",
        nfd: "\u{0061}\u{035C}\u{035D}\u{035D}\u{0345}\u{0062}",
        nfkc: "\u{0061}\u{035C}\u{035D}\u{035D}\u{0345}\u{0062}",
        nfkd: "\u{0061}\u{035C}\u{035D}\u{035D}\u{0345}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0345}\u{035D}\u{035C}\u{035E}\u{0062}",
        nfc: "\u{0061}\u{035C}\u{035D}\u{035E}\u{0345}\u{0062}",
        nfd: "\u{0061}\u{035C}\u{035D}\u{035E}\u{0345}\u{0062}",
        nfkc: "\u{0061}\u{035C}\u{035D}\u{035E}\u{0345}\u{0062}",
        nfkd: "\u{0061}\u{035C}\u{035D}\u{035E}\u{0345}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035E}\u{0345}\u{035D}\u{035C}\u{0062}",
        nfc: "\u{0061}\u{035C}\u{035E}\u{035D}\u{0345}\u{0062}",
        nfd: "\u{0061}\u{035C}\u{035E}\u{035D}\u{0345}\u{0062}",
        nfkc: "\u{0061}\u{035C}\u{035E}\u{035D}\u{0345}\u{0062}",
        nfkd: "\u{0061}\u{035C}\u{035E}\u{035D}\u{0345}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035D}\u{035C}\u{0315}\u{035F}\u{0062}",
        nfc: "\u{0061}\u{0315}\u{035C}\u{035F}\u{035D}\u{0062}",
        nfd: "\u{0061}\u{0315}\u{035C}\u{035F}\u{035D}\u{0062}",
        nfkc: "\u{0061}\u{0315}\u{035C}\u{035F}\u{035D}\u{0062}",
        nfkd: "\u{0061}\u{0315}\u{035C}\u{035F}\u{035D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035F}\u{035D}\u{035C}\u{0315}\u{0062}",
        nfc: "\u{0061}\u{0315}\u{035F}\u{035C}\u{035D}\u{0062}",
        nfd: "\u{0061}\u{0315}\u{035F}\u{035C}\u{035D}\u{0062}",
        nfkc: "\u{0061}\u{0315}\u{035F}\u{035C}\u{035D}\u{0062}",
        nfkd: "\u{0061}\u{0315}\u{035F}\u{035C}\u{035D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0345}\u{035D}\u{035C}\u{0360}\u{0062}",
        nfc: "\u{0061}\u{035C}\u{035D}\u{0360}\u{0345}\u{0062}",
        nfd: "\u{0061}\u{035C}\u{035D}\u{0360}\u{0345}\u{0062}",
        nfkc: "\u{0061}\u{035C}\u{035D}\u{0360}\u{0345}\u{0062}",
        nfkd: "\u{0061}\u{035C}\u{035D}\u{0360}\u{0345}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0360}\u{0345}\u{035D}\u{035C}\u{0062}",
        nfc: "\u{0061}\u{035C}\u{0360}\u{035D}\u{0345}\u{0062}",
        nfd: "\u{0061}\u{035C}\u{0360}\u{035D}\u{0345}\u{0062}",
        nfkc: "\u{0061}\u{035C}\u{0360}\u{035D}\u{0345}\u{0062}",
        nfkd: "\u{0061}\u{035C}\u{0360}\u{035D}\u{0345}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0345}\u{035D}\u{035C}\u{0361}\u{0062}",
        nfc: "\u{0061}\u{035C}\u{035D}\u{0361}\u{0345}\u{0062}",
        nfd: "\u{0061}\u{035C}\u{035D}\u{0361}\u{0345}\u{0062}",
        nfkc: "\u{0061}\u{035C}\u{035D}\u{0361}\u{0345}\u{0062}",
        nfkd: "\u{0061}\u{035C}\u{035D}\u{0361}\u{0345}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0361}\u{0345}\u{035D}\u{035C}\u{0062}",
        nfc: "\u{0061}\u{035C}\u{0361}\u{035D}\u{0345}\u{0062}",
        nfd: "\u{0061}\u{035C}\u{0361}\u{035D}\u{0345}\u{0062}",
        nfkc: "\u{0061}\u{035C}\u{0361}\u{035D}\u{0345}\u{0062}",
        nfkd: "\u{0061}\u{035C}\u{0361}\u{035D}\u{0345}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035D}\u{035C}\u{0315}\u{0362}\u{0062}",
        nfc: "\u{0061}\u{0315}\u{035C}\u{0362}\u{035D}\u{0062}",
        nfd: "\u{0061}\u{0315}\u{035C}\u{0362}\u{035D}\u{0062}",
        nfkc: "\u{0061}\u{0315}\u{035C}\u{0362}\u{035D}\u{0062}",
        nfkd: "\u{0061}\u{0315}\u{035C}\u{0362}\u{035D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0362}\u{035D}\u{035C}\u{0315}\u{0062}",
        nfc: "\u{0061}\u{0315}\u{0362}\u{035C}\u{035D}\u{0062}",
        nfd: "\u{0061}\u{0315}\u{0362}\u{035C}\u{035D}\u{0062}",
        nfkc: "\u{0061}\u{0315}\u{0362}\u{035C}\u{035D}\u{0062}",
        nfkd: "\u{0061}\u{0315}\u{0362}\u{035C}\u{035D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0363}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0363}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0363}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0363}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0363}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0363}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0363}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0363}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0363}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0363}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0364}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0364}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0364}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0364}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0364}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0364}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0364}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0364}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0364}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0364}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0365}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0365}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0365}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0365}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0365}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0365}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0365}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0365}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0365}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0365}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0366}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0366}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0366}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0366}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0366}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0366}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0366}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0366}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0366}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0366}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0367}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0367}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0367}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0367}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0367}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0367}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0367}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0367}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0367}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0367}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0368}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0368}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0368}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0368}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0368}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0368}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0368}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0368}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0368}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0368}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0369}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0369}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0369}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0369}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0369}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0369}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0369}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0369}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0369}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0369}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{036A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{036A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{036A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{036A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{036A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{036A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{036A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{036A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{036A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{036A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{036B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{036B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{036B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{036B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{036B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{036B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{036B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{036B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{036B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{036B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{036C}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{036C}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{036C}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{036C}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{036C}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{036C}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{036C}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{036C}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{036C}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{036C}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{036D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{036D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{036D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{036D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{036D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{036D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{036D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{036D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{036D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{036D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{036E}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{036E}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{036E}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{036E}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{036E}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{036E}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{036E}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{036E}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{036E}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{036E}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{036F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{036F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{036F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{036F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{036F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{036F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{036F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{036F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{036F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{036F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0483}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0483}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0483}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0483}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0483}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0483}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0483}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0483}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0483}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0483}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0484}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0484}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0484}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0484}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0484}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0484}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0484}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0484}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0484}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0484}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0485}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0485}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0485}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0485}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0485}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0485}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0485}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0485}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0485}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0485}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0486}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0486}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0486}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0486}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0486}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0486}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0486}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0486}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0486}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0486}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0487}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0487}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0487}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0487}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0487}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0487}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0487}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0487}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0487}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0487}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0591}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0591}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0591}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0591}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0591}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0591}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0591}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0591}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0591}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0591}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0592}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0592}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0592}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0592}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0592}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0592}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0592}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0592}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0592}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0592}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0593}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0593}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0593}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0593}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0593}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0593}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0593}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0593}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0593}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0593}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0594}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0594}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0594}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0594}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0594}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0594}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0594}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0594}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0594}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0594}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0595}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0595}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0595}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0595}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0595}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0595}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0595}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0595}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0595}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0595}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0596}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0596}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0596}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0596}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0596}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0596}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0596}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0596}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0596}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0596}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0597}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0597}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0597}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0597}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0597}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0597}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0597}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0597}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0597}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0597}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0598}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0598}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0598}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0598}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0598}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0598}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0598}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0598}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0598}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0598}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0599}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0599}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0599}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0599}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0599}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0599}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0599}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0599}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0599}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0599}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302E}\u{059A}\u{0316}\u{059A}\u{0062}",
        nfc: "\u{0061}\u{0316}\u{059A}\u{059A}\u{302E}\u{0062}",
        nfd: "\u{0061}\u{0316}\u{059A}\u{059A}\u{302E}\u{0062}",
        nfkc: "\u{0061}\u{0316}\u{059A}\u{059A}\u{302E}\u{0062}",
        nfkd: "\u{0061}\u{0316}\u{059A}\u{059A}\u{302E}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{302E}\u{059A}\u{0316}\u{0062}",
        nfc: "\u{0061}\u{0316}\u{059A}\u{059A}\u{302E}\u{0062}",
        nfd: "\u{0061}\u{0316}\u{059A}\u{059A}\u{302E}\u{0062}",
        nfkc: "\u{0061}\u{0316}\u{059A}\u{059A}\u{302E}\u{0062}",
        nfkd: "\u{0061}\u{0316}\u{059A}\u{059A}\u{302E}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{059B}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{059B}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{059B}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{059B}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{059B}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059B}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{059B}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{059B}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{059B}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{059B}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{059C}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{059C}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{059C}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{059C}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{059C}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059C}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{059C}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{059C}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{059C}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{059C}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{059D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{059D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{059D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{059D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{059D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{059D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{059D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{059D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{059D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{059E}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{059E}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{059E}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{059E}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{059E}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059E}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{059E}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{059E}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{059E}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{059E}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{059F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{059F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{059F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{059F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{059F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{059F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{059F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{059F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{059F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{05A0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{05A0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{05A0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{05A0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{05A0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05A0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{05A0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{05A0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{05A0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{05A0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{05A1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{05A1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{05A1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{05A1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{05A1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05A1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{05A1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{05A1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{05A1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{05A1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{05A2}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{05A2}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{05A2}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{05A2}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{05A2}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05A2}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{05A2}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{05A2}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{05A2}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{05A2}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{05A3}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{05A3}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{05A3}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{05A3}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{05A3}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05A3}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{05A3}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{05A3}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{05A3}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{05A3}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{05A4}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{05A4}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{05A4}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{05A4}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{05A4}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05A4}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{05A4}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{05A4}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{05A4}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{05A4}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{05A5}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{05A5}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{05A5}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{05A5}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{05A5}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05A5}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{05A5}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{05A5}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{05A5}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{05A5}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{05A6}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{05A6}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{05A6}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{05A6}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{05A6}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05A6}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{05A6}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{05A6}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{05A6}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{05A6}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{05A7}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{05A7}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{05A7}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{05A7}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{05A7}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05A7}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{05A7}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{05A7}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{05A7}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{05A7}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{05A8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{05A8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{05A8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{05A8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{05A8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05A8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{05A8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{05A8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{05A8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{05A8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{05A9}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{05A9}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{05A9}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{05A9}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{05A9}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05A9}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{05A9}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{05A9}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{05A9}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{05A9}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{05AA}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{05AA}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{05AA}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{05AA}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{05AA}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05AA}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{05AA}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{05AA}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{05AA}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{05AA}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{05AB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{05AB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{05AB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{05AB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{05AB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05AB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{05AB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{05AB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{05AB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{05AB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{05AC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{05AC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{05AC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{05AC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{05AC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05AC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{05AC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{05AC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{05AC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{05AC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302E}\u{059A}\u{0316}\u{05AD}\u{0062}",
        nfc: "\u{0061}\u{0316}\u{059A}\u{05AD}\u{302E}\u{0062}",
        nfd: "\u{0061}\u{0316}\u{059A}\u{05AD}\u{302E}\u{0062}",
        nfkc: "\u{0061}\u{0316}\u{059A}\u{05AD}\u{302E}\u{0062}",
        nfkd: "\u{0061}\u{0316}\u{059A}\u{05AD}\u{302E}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05AD}\u{302E}\u{059A}\u{0316}\u{0062}",
        nfc: "\u{0061}\u{0316}\u{05AD}\u{059A}\u{302E}\u{0062}",
        nfd: "\u{0061}\u{0316}\u{05AD}\u{059A}\u{302E}\u{0062}",
        nfkc: "\u{0061}\u{0316}\u{05AD}\u{059A}\u{302E}\u{0062}",
        nfkd: "\u{0061}\u{0316}\u{05AD}\u{059A}\u{302E}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0300}\u{05AE}\u{1D16D}\u{05AE}\u{0062}",
        nfc: "\u{00E0}\u{1D16D}\u{05AE}\u{05AE}\u{0062}",
        nfd: "\u{0061}\u{1D16D}\u{05AE}\u{05AE}\u{0300}\u{0062}",
        nfkc: "\u{00E0}\u{1D16D}\u{05AE}\u{05AE}\u{0062}",
        nfkd: "\u{0061}\u{1D16D}\u{05AE}\u{05AE}\u{0300}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05AE}\u{0300}\u{05AE}\u{1D16D}\u{0062}",
        nfc: "\u{00E0}\u{1D16D}\u{05AE}\u{05AE}\u{0062}",
        nfd: "\u{0061}\u{1D16D}\u{05AE}\u{05AE}\u{0300}\u{0062}",
        nfkc: "\u{00E0}\u{1D16D}\u{05AE}\u{05AE}\u{0062}",
        nfkd: "\u{0061}\u{1D16D}\u{05AE}\u{05AE}\u{0300}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{05AF}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{05AF}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{05AF}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{05AF}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{05AF}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05AF}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{05AF}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{05AF}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{05AF}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{05AF}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B1}\u{05B0}\u{094D}\u{05B0}\u{0062}",
        nfc: "\u{0061}\u{094D}\u{05B0}\u{05B0}\u{05B1}\u{0062}",
        nfd: "\u{0061}\u{094D}\u{05B0}\u{05B0}\u{05B1}\u{0062}",
        nfkc: "\u{0061}\u{094D}\u{05B0}\u{05B0}\u{05B1}\u{0062}",
        nfkd: "\u{0061}\u{094D}\u{05B0}\u{05B0}\u{05B1}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{05B1}\u{05B0}\u{094D}\u{0062}",
        nfc: "\u{0061}\u{094D}\u{05B0}\u{05B0}\u{05B1}\u{0062}",
        nfd: "\u{0061}\u{094D}\u{05B0}\u{05B0}\u{05B1}\u{0062}",
        nfkc: "\u{0061}\u{094D}\u{05B0}\u{05B0}\u{05B1}\u{0062}",
        nfkd: "\u{0061}\u{094D}\u{05B0}\u{05B0}\u{05B1}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B2}\u{05B1}\u{05B0}\u{05B1}\u{0062}",
        nfc: "\u{0061}\u{05B0}\u{05B1}\u{05B1}\u{05B2}\u{0062}",
        nfd: "\u{0061}\u{05B0}\u{05B1}\u{05B1}\u{05B2}\u{0062}",
        nfkc: "\u{0061}\u{05B0}\u{05B1}\u{05B1}\u{05B2}\u{0062}",
        nfkd: "\u{0061}\u{05B0}\u{05B1}\u{05B1}\u{05B2}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B1}\u{05B2}\u{05B1}\u{05B0}\u{0062}",
        nfc: "\u{0061}\u{05B0}\u{05B1}\u{05B1}\u{05B2}\u{0062}",
        nfd: "\u{0061}\u{05B0}\u{05B1}\u{05B1}\u{05B2}\u{0062}",
        nfkc: "\u{0061}\u{05B0}\u{05B1}\u{05B1}\u{05B2}\u{0062}",
        nfkd: "\u{0061}\u{05B0}\u{05B1}\u{05B1}\u{05B2}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B3}\u{05B2}\u{05B1}\u{05B2}\u{0062}",
        nfc: "\u{0061}\u{05B1}\u{05B2}\u{05B2}\u{05B3}\u{0062}",
        nfd: "\u{0061}\u{05B1}\u{05B2}\u{05B2}\u{05B3}\u{0062}",
        nfkc: "\u{0061}\u{05B1}\u{05B2}\u{05B2}\u{05B3}\u{0062}",
        nfkd: "\u{0061}\u{05B1}\u{05B2}\u{05B2}\u{05B3}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B2}\u{05B3}\u{05B2}\u{05B1}\u{0062}",
        nfc: "\u{0061}\u{05B1}\u{05B2}\u{05B2}\u{05B3}\u{0062}",
        nfd: "\u{0061}\u{05B1}\u{05B2}\u{05B2}\u{05B3}\u{0062}",
        nfkc: "\u{0061}\u{05B1}\u{05B2}\u{05B2}\u{05B3}\u{0062}",
        nfkd: "\u{0061}\u{05B1}\u{05B2}\u{05B2}\u{05B3}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B4}\u{05B3}\u{05B2}\u{05B3}\u{0062}",
        nfc: "\u{0061}\u{05B2}\u{05B3}\u{05B3}\u{05B4}\u{0062}",
        nfd: "\u{0061}\u{05B2}\u{05B3}\u{05B3}\u{05B4}\u{0062}",
        nfkc: "\u{0061}\u{05B2}\u{05B3}\u{05B3}\u{05B4}\u{0062}",
        nfkd: "\u{0061}\u{05B2}\u{05B3}\u{05B3}\u{05B4}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B3}\u{05B4}\u{05B3}\u{05B2}\u{0062}",
        nfc: "\u{0061}\u{05B2}\u{05B3}\u{05B3}\u{05B4}\u{0062}",
        nfd: "\u{0061}\u{05B2}\u{05B3}\u{05B3}\u{05B4}\u{0062}",
        nfkc: "\u{0061}\u{05B2}\u{05B3}\u{05B3}\u{05B4}\u{0062}",
        nfkd: "\u{0061}\u{05B2}\u{05B3}\u{05B3}\u{05B4}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B5}\u{05B4}\u{05B3}\u{05B4}\u{0062}",
        nfc: "\u{0061}\u{05B3}\u{05B4}\u{05B4}\u{05B5}\u{0062}",
        nfd: "\u{0061}\u{05B3}\u{05B4}\u{05B4}\u{05B5}\u{0062}",
        nfkc: "\u{0061}\u{05B3}\u{05B4}\u{05B4}\u{05B5}\u{0062}",
        nfkd: "\u{0061}\u{05B3}\u{05B4}\u{05B4}\u{05B5}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B4}\u{05B5}\u{05B4}\u{05B3}\u{0062}",
        nfc: "\u{0061}\u{05B3}\u{05B4}\u{05B4}\u{05B5}\u{0062}",
        nfd: "\u{0061}\u{05B3}\u{05B4}\u{05B4}\u{05B5}\u{0062}",
        nfkc: "\u{0061}\u{05B3}\u{05B4}\u{05B4}\u{05B5}\u{0062}",
        nfkd: "\u{0061}\u{05B3}\u{05B4}\u{05B4}\u{05B5}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B6}\u{05B5}\u{05B4}\u{05B5}\u{0062}",
        nfc: "\u{0061}\u{05B4}\u{05B5}\u{05B5}\u{05B6}\u{0062}",
        nfd: "\u{0061}\u{05B4}\u{05B5}\u{05B5}\u{05B6}\u{0062}",
        nfkc: "\u{0061}\u{05B4}\u{05B5}\u{05B5}\u{05B6}\u{0062}",
        nfkd: "\u{0061}\u{05B4}\u{05B5}\u{05B5}\u{05B6}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B5}\u{05B6}\u{05B5}\u{05B4}\u{0062}",
        nfc: "\u{0061}\u{05B4}\u{05B5}\u{05B5}\u{05B6}\u{0062}",
        nfd: "\u{0061}\u{05B4}\u{05B5}\u{05B5}\u{05B6}\u{0062}",
        nfkc: "\u{0061}\u{05B4}\u{05B5}\u{05B5}\u{05B6}\u{0062}",
        nfkd: "\u{0061}\u{05B4}\u{05B5}\u{05B5}\u{05B6}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B7}\u{05B6}\u{05B5}\u{05B6}\u{0062}",
        nfc: "\u{0061}\u{05B5}\u{05B6}\u{05B6}\u{05B7}\u{0062}",
        nfd: "\u{0061}\u{05B5}\u{05B6}\u{05B6}\u{05B7}\u{0062}",
        nfkc: "\u{0061}\u{05B5}\u{05B6}\u{05B6}\u{05B7}\u{0062}",
        nfkd: "\u{0061}\u{05B5}\u{05B6}\u{05B6}\u{05B7}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B6}\u{05B7}\u{05B6}\u{05B5}\u{0062}",
        nfc: "\u{0061}\u{05B5}\u{05B6}\u{05B6}\u{05B7}\u{0062}",
        nfd: "\u{0061}\u{05B5}\u{05B6}\u{05B6}\u{05B7}\u{0062}",
        nfkc: "\u{0061}\u{05B5}\u{05B6}\u{05B6}\u{05B7}\u{0062}",
        nfkd: "\u{0061}\u{05B5}\u{05B6}\u{05B6}\u{05B7}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B8}\u{05B7}\u{05B6}\u{05B7}\u{0062}",
        nfc: "\u{0061}\u{05B6}\u{05B7}\u{05B7}\u{05B8}\u{0062}",
        nfd: "\u{0061}\u{05B6}\u{05B7}\u{05B7}\u{05B8}\u{0062}",
        nfkc: "\u{0061}\u{05B6}\u{05B7}\u{05B7}\u{05B8}\u{0062}",
        nfkd: "\u{0061}\u{05B6}\u{05B7}\u{05B7}\u{05B8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B7}\u{05B8}\u{05B7}\u{05B6}\u{0062}",
        nfc: "\u{0061}\u{05B6}\u{05B7}\u{05B7}\u{05B8}\u{0062}",
        nfd: "\u{0061}\u{05B6}\u{05B7}\u{05B7}\u{05B8}\u{0062}",
        nfkc: "\u{0061}\u{05B6}\u{05B7}\u{05B7}\u{05B8}\u{0062}",
        nfkd: "\u{0061}\u{05B6}\u{05B7}\u{05B7}\u{05B8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B9}\u{05B8}\u{05B7}\u{05B8}\u{0062}",
        nfc: "\u{0061}\u{05B7}\u{05B8}\u{05B8}\u{05B9}\u{0062}",
        nfd: "\u{0061}\u{05B7}\u{05B8}\u{05B8}\u{05B9}\u{0062}",
        nfkc: "\u{0061}\u{05B7}\u{05B8}\u{05B8}\u{05B9}\u{0062}",
        nfkd: "\u{0061}\u{05B7}\u{05B8}\u{05B8}\u{05B9}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B8}\u{05B9}\u{05B8}\u{05B7}\u{0062}",
        nfc: "\u{0061}\u{05B7}\u{05B8}\u{05B8}\u{05B9}\u{0062}",
        nfd: "\u{0061}\u{05B7}\u{05B8}\u{05B8}\u{05B9}\u{0062}",
        nfkc: "\u{0061}\u{05B7}\u{05B8}\u{05B8}\u{05B9}\u{0062}",
        nfkd: "\u{0061}\u{05B7}\u{05B8}\u{05B8}\u{05B9}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05BB}\u{05B9}\u{05B8}\u{05B9}\u{0062}",
        nfc: "\u{0061}\u{05B8}\u{05B9}\u{05B9}\u{05BB}\u{0062}",
        nfd: "\u{0061}\u{05B8}\u{05B9}\u{05B9}\u{05BB}\u{0062}",
        nfkc: "\u{0061}\u{05B8}\u{05B9}\u{05B9}\u{05BB}\u{0062}",
        nfkd: "\u{0061}\u{05B8}\u{05B9}\u{05B9}\u{05BB}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B9}\u{05BB}\u{05B9}\u{05B8}\u{0062}",
        nfc: "\u{0061}\u{05B8}\u{05B9}\u{05B9}\u{05BB}\u{0062}",
        nfd: "\u{0061}\u{05B8}\u{05B9}\u{05B9}\u{05BB}\u{0062}",
        nfkc: "\u{0061}\u{05B8}\u{05B9}\u{05B9}\u{05BB}\u{0062}",
        nfkd: "\u{0061}\u{05B8}\u{05B9}\u{05B9}\u{05BB}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05BB}\u{05B9}\u{05B8}\u{05BA}\u{0062}",
        nfc: "\u{0061}\u{05B8}\u{05B9}\u{05BA}\u{05BB}\u{0062}",
        nfd: "\u{0061}\u{05B8}\u{05B9}\u{05BA}\u{05BB}\u{0062}",
        nfkc: "\u{0061}\u{05B8}\u{05B9}\u{05BA}\u{05BB}\u{0062}",
        nfkd: "\u{0061}\u{05B8}\u{05B9}\u{05BA}\u{05BB}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05BA}\u{05BB}\u{05B9}\u{05B8}\u{0062}",
        nfc: "\u{0061}\u{05B8}\u{05BA}\u{05B9}\u{05BB}\u{0062}",
        nfd: "\u{0061}\u{05B8}\u{05BA}\u{05B9}\u{05BB}\u{0062}",
        nfkc: "\u{0061}\u{05B8}\u{05BA}\u{05B9}\u{05BB}\u{0062}",
        nfkd: "\u{0061}\u{05B8}\u{05BA}\u{05B9}\u{05BB}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05BC}\u{05BB}\u{05B9}\u{05BB}\u{0062}",
        nfc: "\u{0061}\u{05B9}\u{05BB}\u{05BB}\u{05BC}\u{0062}",
        nfd: "\u{0061}\u{05B9}\u{05BB}\u{05BB}\u{05BC}\u{0062}",
        nfkc: "\u{0061}\u{05B9}\u{05BB}\u{05BB}\u{05BC}\u{0062}",
        nfkd: "\u{0061}\u{05B9}\u{05BB}\u{05BB}\u{05BC}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05BB}\u{05BC}\u{05BB}\u{05B9}\u{0062}",
        nfc: "\u{0061}\u{05B9}\u{05BB}\u{05BB}\u{05BC}\u{0062}",
        nfd: "\u{0061}\u{05B9}\u{05BB}\u{05BB}\u{05BC}\u{0062}",
        nfkc: "\u{0061}\u{05B9}\u{05BB}\u{05BB}\u{05BC}\u{0062}",
        nfkd: "\u{0061}\u{05B9}\u{05BB}\u{05BB}\u{05BC}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05BD}\u{05BC}\u{05BB}\u{05BC}\u{0062}",
        nfc: "\u{0061}\u{05BB}\u{05BC}\u{05BC}\u{05BD}\u{0062}",
        nfd: "\u{0061}\u{05BB}\u{05BC}\u{05BC}\u{05BD}\u{0062}",
        nfkc: "\u{0061}\u{05BB}\u{05BC}\u{05BC}\u{05BD}\u{0062}",
        nfkd: "\u{0061}\u{05BB}\u{05BC}\u{05BC}\u{05BD}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05BC}\u{05BD}\u{05BC}\u{05BB}\u{0062}",
        nfc: "\u{0061}\u{05BB}\u{05BC}\u{05BC}\u{05BD}\u{0062}",
        nfd: "\u{0061}\u{05BB}\u{05BC}\u{05BC}\u{05BD}\u{0062}",
        nfkc: "\u{0061}\u{05BB}\u{05BC}\u{05BC}\u{05BD}\u{0062}",
        nfkd: "\u{0061}\u{05BB}\u{05BC}\u{05BC}\u{05BD}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05BF}\u{05BD}\u{05BC}\u{05BD}\u{0062}",
        nfc: "\u{0061}\u{05BC}\u{05BD}\u{05BD}\u{05BF}\u{0062}",
        nfd: "\u{0061}\u{05BC}\u{05BD}\u{05BD}\u{05BF}\u{0062}",
        nfkc: "\u{0061}\u{05BC}\u{05BD}\u{05BD}\u{05BF}\u{0062}",
        nfkd: "\u{0061}\u{05BC}\u{05BD}\u{05BD}\u{05BF}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05BD}\u{05BF}\u{05BD}\u{05BC}\u{0062}",
        nfc: "\u{0061}\u{05BC}\u{05BD}\u{05BD}\u{05BF}\u{0062}",
        nfd: "\u{0061}\u{05BC}\u{05BD}\u{05BD}\u{05BF}\u{0062}",
        nfkc: "\u{0061}\u{05BC}\u{05BD}\u{05BD}\u{05BF}\u{0062}",
        nfkd: "\u{0061}\u{05BC}\u{05BD}\u{05BD}\u{05BF}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05C1}\u{05BF}\u{05BD}\u{05BF}\u{0062}",
        nfc: "\u{0061}\u{05BD}\u{05BF}\u{05BF}\u{05C1}\u{0062}",
        nfd: "\u{0061}\u{05BD}\u{05BF}\u{05BF}\u{05C1}\u{0062}",
        nfkc: "\u{0061}\u{05BD}\u{05BF}\u{05BF}\u{05C1}\u{0062}",
        nfkd: "\u{0061}\u{05BD}\u{05BF}\u{05BF}\u{05C1}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05BF}\u{05C1}\u{05BF}\u{05BD}\u{0062}",
        nfc: "\u{0061}\u{05BD}\u{05BF}\u{05BF}\u{05C1}\u{0062}",
        nfd: "\u{0061}\u{05BD}\u{05BF}\u{05BF}\u{05C1}\u{0062}",
        nfkc: "\u{0061}\u{05BD}\u{05BF}\u{05BF}\u{05C1}\u{0062}",
        nfkd: "\u{0061}\u{05BD}\u{05BF}\u{05BF}\u{05C1}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05C2}\u{05C1}\u{05BF}\u{05C1}\u{0062}",
        nfc: "\u{0061}\u{05BF}\u{05C1}\u{05C1}\u{05C2}\u{0062}",
        nfd: "\u{0061}\u{05BF}\u{05C1}\u{05C1}\u{05C2}\u{0062}",
        nfkc: "\u{0061}\u{05BF}\u{05C1}\u{05C1}\u{05C2}\u{0062}",
        nfkd: "\u{0061}\u{05BF}\u{05C1}\u{05C1}\u{05C2}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05C1}\u{05C2}\u{05C1}\u{05BF}\u{0062}",
        nfc: "\u{0061}\u{05BF}\u{05C1}\u{05C1}\u{05C2}\u{0062}",
        nfd: "\u{0061}\u{05BF}\u{05C1}\u{05C1}\u{05C2}\u{0062}",
        nfkc: "\u{0061}\u{05BF}\u{05C1}\u{05C1}\u{05C2}\u{0062}",
        nfkd: "\u{0061}\u{05BF}\u{05C1}\u{05C1}\u{05C2}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FB1E}\u{05C2}\u{05C1}\u{05C2}\u{0062}",
        nfc: "\u{0061}\u{05C1}\u{05C2}\u{05C2}\u{FB1E}\u{0062}",
        nfd: "\u{0061}\u{05C1}\u{05C2}\u{05C2}\u{FB1E}\u{0062}",
        nfkc: "\u{0061}\u{05C1}\u{05C2}\u{05C2}\u{FB1E}\u{0062}",
        nfkd: "\u{0061}\u{05C1}\u{05C2}\u{05C2}\u{FB1E}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05C2}\u{FB1E}\u{05C2}\u{05C1}\u{0062}",
        nfc: "\u{0061}\u{05C1}\u{05C2}\u{05C2}\u{FB1E}\u{0062}",
        nfd: "\u{0061}\u{05C1}\u{05C2}\u{05C2}\u{FB1E}\u{0062}",
        nfkc: "\u{0061}\u{05C1}\u{05C2}\u{05C2}\u{FB1E}\u{0062}",
        nfkd: "\u{0061}\u{05C1}\u{05C2}\u{05C2}\u{FB1E}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{05C4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{05C4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{05C4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{05C4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{05C4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05C4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{05C4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{05C4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{05C4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{05C4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{05C5}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{05C5}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{05C5}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{05C5}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{05C5}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05C5}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{05C5}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{05C5}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{05C5}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{05C5}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B9}\u{05B8}\u{05B7}\u{05C7}\u{0062}",
        nfc: "\u{0061}\u{05B7}\u{05B8}\u{05C7}\u{05B9}\u{0062}",
        nfd: "\u{0061}\u{05B7}\u{05B8}\u{05C7}\u{05B9}\u{0062}",
        nfkc: "\u{0061}\u{05B7}\u{05B8}\u{05C7}\u{05B9}\u{0062}",
        nfkd: "\u{0061}\u{05B7}\u{05B8}\u{05C7}\u{05B9}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05C7}\u{05B9}\u{05B8}\u{05B7}\u{0062}",
        nfc: "\u{0061}\u{05B7}\u{05C7}\u{05B8}\u{05B9}\u{0062}",
        nfd: "\u{0061}\u{05B7}\u{05C7}\u{05B8}\u{05B9}\u{0062}",
        nfkc: "\u{0061}\u{05B7}\u{05C7}\u{05B8}\u{05B9}\u{0062}",
        nfkd: "\u{0061}\u{05B7}\u{05C7}\u{05B8}\u{05B9}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0610}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0610}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0610}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0610}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0610}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0610}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0610}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0610}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0610}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0610}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0611}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0611}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0611}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0611}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0611}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0611}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0611}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0611}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0611}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0611}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0612}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0612}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0612}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0612}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0612}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0612}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0612}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0612}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0612}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0612}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0613}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0613}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0613}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0613}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0613}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0613}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0613}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0613}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0613}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0613}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0614}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0614}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0614}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0614}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0614}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0614}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0614}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0614}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0614}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0614}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0615}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0615}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0615}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0615}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0615}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0615}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0615}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0615}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0615}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0615}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0616}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0616}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0616}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0616}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0616}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0616}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0616}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0616}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0616}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0616}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0617}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0617}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0617}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0617}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0617}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0617}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0617}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0617}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0617}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0617}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0619}\u{0618}\u{064D}\u{0618}\u{0062}",
        nfc: "\u{0061}\u{064D}\u{0618}\u{0618}\u{0619}\u{0062}",
        nfd: "\u{0061}\u{064D}\u{0618}\u{0618}\u{0619}\u{0062}",
        nfkc: "\u{0061}\u{064D}\u{0618}\u{0618}\u{0619}\u{0062}",
        nfkd: "\u{0061}\u{064D}\u{0618}\u{0618}\u{0619}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0618}\u{0619}\u{0618}\u{064D}\u{0062}",
        nfc: "\u{0061}\u{064D}\u{0618}\u{0618}\u{0619}\u{0062}",
        nfd: "\u{0061}\u{064D}\u{0618}\u{0618}\u{0619}\u{0062}",
        nfkc: "\u{0061}\u{064D}\u{0618}\u{0618}\u{0619}\u{0062}",
        nfkd: "\u{0061}\u{064D}\u{0618}\u{0618}\u{0619}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{061A}\u{0619}\u{0618}\u{0619}\u{0062}",
        nfc: "\u{0061}\u{0618}\u{0619}\u{0619}\u{061A}\u{0062}",
        nfd: "\u{0061}\u{0618}\u{0619}\u{0619}\u{061A}\u{0062}",
        nfkc: "\u{0061}\u{0618}\u{0619}\u{0619}\u{061A}\u{0062}",
        nfkd: "\u{0061}\u{0618}\u{0619}\u{0619}\u{061A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0619}\u{061A}\u{0619}\u{0618}\u{0062}",
        nfc: "\u{0061}\u{0618}\u{0619}\u{0619}\u{061A}\u{0062}",
        nfd: "\u{0061}\u{0618}\u{0619}\u{0619}\u{061A}\u{0062}",
        nfkc: "\u{0061}\u{0618}\u{0619}\u{0619}\u{061A}\u{0062}",
        nfkd: "\u{0061}\u{0618}\u{0619}\u{0619}\u{061A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0651}\u{061A}\u{0619}\u{061A}\u{0062}",
        nfc: "\u{0061}\u{0619}\u{061A}\u{061A}\u{0651}\u{0062}",
        nfd: "\u{0061}\u{0619}\u{061A}\u{061A}\u{0651}\u{0062}",
        nfkc: "\u{0061}\u{0619}\u{061A}\u{061A}\u{0651}\u{0062}",
        nfkd: "\u{0061}\u{0619}\u{061A}\u{061A}\u{0651}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{061A}\u{0651}\u{061A}\u{0619}\u{0062}",
        nfc: "\u{0061}\u{0619}\u{061A}\u{061A}\u{0651}\u{0062}",
        nfd: "\u{0061}\u{0619}\u{061A}\u{061A}\u{0651}\u{0062}",
        nfkc: "\u{0061}\u{0619}\u{061A}\u{061A}\u{0651}\u{0062}",
        nfkd: "\u{0061}\u{0619}\u{061A}\u{061A}\u{0651}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{064C}\u{064B}\u{FB1E}\u{064B}\u{0062}",
        nfc: "\u{0061}\u{FB1E}\u{064B}\u{064B}\u{064C}\u{0062}",
        nfd: "\u{0061}\u{FB1E}\u{064B}\u{064B}\u{064C}\u{0062}",
        nfkc: "\u{0061}\u{FB1E}\u{064B}\u{064B}\u{064C}\u{0062}",
        nfkd: "\u{0061}\u{FB1E}\u{064B}\u{064B}\u{064C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{064B}\u{064C}\u{064B}\u{FB1E}\u{0062}",
        nfc: "\u{0061}\u{FB1E}\u{064B}\u{064B}\u{064C}\u{0062}",
        nfd: "\u{0061}\u{FB1E}\u{064B}\u{064B}\u{064C}\u{0062}",
        nfkc: "\u{0061}\u{FB1E}\u{064B}\u{064B}\u{064C}\u{0062}",
        nfkd: "\u{0061}\u{FB1E}\u{064B}\u{064B}\u{064C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{064D}\u{064C}\u{064B}\u{064C}\u{0062}",
        nfc: "\u{0061}\u{064B}\u{064C}\u{064C}\u{064D}\u{0062}",
        nfd: "\u{0061}\u{064B}\u{064C}\u{064C}\u{064D}\u{0062}",
        nfkc: "\u{0061}\u{064B}\u{064C}\u{064C}\u{064D}\u{0062}",
        nfkd: "\u{0061}\u{064B}\u{064C}\u{064C}\u{064D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{064C}\u{064D}\u{064C}\u{064B}\u{0062}",
        nfc: "\u{0061}\u{064B}\u{064C}\u{064C}\u{064D}\u{0062}",
        nfd: "\u{0061}\u{064B}\u{064C}\u{064C}\u{064D}\u{0062}",
        nfkc: "\u{0061}\u{064B}\u{064C}\u{064C}\u{064D}\u{0062}",
        nfkd: "\u{0061}\u{064B}\u{064C}\u{064C}\u{064D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0618}\u{064D}\u{064C}\u{064D}\u{0062}",
        nfc: "\u{0061}\u{064C}\u{064D}\u{064D}\u{0618}\u{0062}",
        nfd: "\u{0061}\u{064C}\u{064D}\u{064D}\u{0618}\u{0062}",
        nfkc: "\u{0061}\u{064C}\u{064D}\u{064D}\u{0618}\u{0062}",
        nfkd: "\u{0061}\u{064C}\u{064D}\u{064D}\u{0618}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{064D}\u{0618}\u{064D}\u{064C}\u{0062}",
        nfc: "\u{0061}\u{064C}\u{064D}\u{064D}\u{0618}\u{0062}",
        nfd: "\u{0061}\u{064C}\u{064D}\u{064D}\u{0618}\u{0062}",
        nfkc: "\u{0061}\u{064C}\u{064D}\u{064D}\u{0618}\u{0062}",
        nfkd: "\u{0061}\u{064C}\u{064D}\u{064D}\u{0618}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0619}\u{0618}\u{064D}\u{064E}\u{0062}",
        nfc: "\u{0061}\u{064D}\u{0618}\u{064E}\u{0619}\u{0062}",
        nfd: "\u{0061}\u{064D}\u{0618}\u{064E}\u{0619}\u{0062}",
        nfkc: "\u{0061}\u{064D}\u{0618}\u{064E}\u{0619}\u{0062}",
        nfkd: "\u{0061}\u{064D}\u{0618}\u{064E}\u{0619}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{064E}\u{0619}\u{0618}\u{064D}\u{0062}",
        nfc: "\u{0061}\u{064D}\u{064E}\u{0618}\u{0619}\u{0062}",
        nfd: "\u{0061}\u{064D}\u{064E}\u{0618}\u{0619}\u{0062}",
        nfkc: "\u{0061}\u{064D}\u{064E}\u{0618}\u{0619}\u{0062}",
        nfkd: "\u{0061}\u{064D}\u{064E}\u{0618}\u{0619}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{061A}\u{0619}\u{0618}\u{064F}\u{0062}",
        nfc: "\u{0061}\u{0618}\u{0619}\u{064F}\u{061A}\u{0062}",
        nfd: "\u{0061}\u{0618}\u{0619}\u{064F}\u{061A}\u{0062}",
        nfkc: "\u{0061}\u{0618}\u{0619}\u{064F}\u{061A}\u{0062}",
        nfkd: "\u{0061}\u{0618}\u{0619}\u{064F}\u{061A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{064F}\u{061A}\u{0619}\u{0618}\u{0062}",
        nfc: "\u{0061}\u{0618}\u{064F}\u{0619}\u{061A}\u{0062}",
        nfd: "\u{0061}\u{0618}\u{064F}\u{0619}\u{061A}\u{0062}",
        nfkc: "\u{0061}\u{0618}\u{064F}\u{0619}\u{061A}\u{0062}",
        nfkd: "\u{0061}\u{0618}\u{064F}\u{0619}\u{061A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0651}\u{061A}\u{0619}\u{0650}\u{0062}",
        nfc: "\u{0061}\u{0619}\u{061A}\u{0650}\u{0651}\u{0062}",
        nfd: "\u{0061}\u{0619}\u{061A}\u{0650}\u{0651}\u{0062}",
        nfkc: "\u{0061}\u{0619}\u{061A}\u{0650}\u{0651}\u{0062}",
        nfkd: "\u{0061}\u{0619}\u{061A}\u{0650}\u{0651}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0650}\u{0651}\u{061A}\u{0619}\u{0062}",
        nfc: "\u{0061}\u{0619}\u{0650}\u{061A}\u{0651}\u{0062}",
        nfd: "\u{0061}\u{0619}\u{0650}\u{061A}\u{0651}\u{0062}",
        nfkc: "\u{0061}\u{0619}\u{0650}\u{061A}\u{0651}\u{0062}",
        nfkd: "\u{0061}\u{0619}\u{0650}\u{061A}\u{0651}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0652}\u{0651}\u{061A}\u{0651}\u{0062}",
        nfc: "\u{0061}\u{061A}\u{0651}\u{0651}\u{0652}\u{0062}",
        nfd: "\u{0061}\u{061A}\u{0651}\u{0651}\u{0652}\u{0062}",
        nfkc: "\u{0061}\u{061A}\u{0651}\u{0651}\u{0652}\u{0062}",
        nfkd: "\u{0061}\u{061A}\u{0651}\u{0651}\u{0652}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0651}\u{0652}\u{0651}\u{061A}\u{0062}",
        nfc: "\u{0061}\u{061A}\u{0651}\u{0651}\u{0652}\u{0062}",
        nfd: "\u{0061}\u{061A}\u{0651}\u{0651}\u{0652}\u{0062}",
        nfkc: "\u{0061}\u{061A}\u{0651}\u{0651}\u{0652}\u{0062}",
        nfkd: "\u{0061}\u{061A}\u{0651}\u{0651}\u{0652}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0670}\u{0652}\u{0651}\u{0652}\u{0062}",
        nfc: "\u{0061}\u{0651}\u{0652}\u{0652}\u{0670}\u{0062}",
        nfd: "\u{0061}\u{0651}\u{0652}\u{0652}\u{0670}\u{0062}",
        nfkc: "\u{0061}\u{0651}\u{0652}\u{0652}\u{0670}\u{0062}",
        nfkd: "\u{0061}\u{0651}\u{0652}\u{0652}\u{0670}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0652}\u{0670}\u{0652}\u{0651}\u{0062}",
        nfc: "\u{0061}\u{0651}\u{0652}\u{0652}\u{0670}\u{0062}",
        nfd: "\u{0061}\u{0651}\u{0652}\u{0652}\u{0670}\u{0062}",
        nfkc: "\u{0061}\u{0651}\u{0652}\u{0652}\u{0670}\u{0062}",
        nfkd: "\u{0061}\u{0651}\u{0652}\u{0652}\u{0670}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0653}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0653}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0653}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0653}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0653}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0653}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0653}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0653}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0653}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0653}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0654}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0654}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0654}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0654}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0654}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0654}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0654}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0654}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0654}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0654}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0655}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0655}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0655}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0655}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0655}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0655}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0655}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0655}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0655}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0655}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0656}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0656}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0656}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0656}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0656}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0656}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0656}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0656}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0656}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0656}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0657}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0657}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0657}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0657}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0657}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0657}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0657}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0657}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0657}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0657}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0658}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0658}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0658}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0658}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0658}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0658}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0658}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0658}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0658}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0658}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0659}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0659}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0659}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0659}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0659}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0659}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0659}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0659}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0659}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0659}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{065A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{065A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{065A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{065A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{065A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{065A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{065A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{065A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{065A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{065A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{065B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{065B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{065B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{065B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{065B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{065B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{065B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{065B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{065B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{065B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{065C}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{065C}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{065C}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{065C}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{065C}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{065C}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{065C}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{065C}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{065C}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{065C}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{065D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{065D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{065D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{065D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{065D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{065D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{065D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{065D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{065D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{065D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{065E}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{065E}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{065E}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{065E}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{065E}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{065E}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{065E}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{065E}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{065E}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{065E}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{065F}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{065F}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{065F}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{065F}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{065F}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{065F}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{065F}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{065F}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{065F}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{065F}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0711}\u{0670}\u{0652}\u{0670}\u{0062}",
        nfc: "\u{0061}\u{0652}\u{0670}\u{0670}\u{0711}\u{0062}",
        nfd: "\u{0061}\u{0652}\u{0670}\u{0670}\u{0711}\u{0062}",
        nfkc: "\u{0061}\u{0652}\u{0670}\u{0670}\u{0711}\u{0062}",
        nfkd: "\u{0061}\u{0652}\u{0670}\u{0670}\u{0711}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0670}\u{0711}\u{0670}\u{0652}\u{0062}",
        nfc: "\u{0061}\u{0652}\u{0670}\u{0670}\u{0711}\u{0062}",
        nfd: "\u{0061}\u{0652}\u{0670}\u{0670}\u{0711}\u{0062}",
        nfkc: "\u{0061}\u{0652}\u{0670}\u{0670}\u{0711}\u{0062}",
        nfkd: "\u{0061}\u{0652}\u{0670}\u{0670}\u{0711}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06D6}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06D6}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06D6}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06D6}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06D6}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06D6}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06D6}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06D6}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06D6}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06D6}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06D7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06D7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06D7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06D7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06D7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06D7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06D7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06D7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06D7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06D7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06D8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06D8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06D8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06D8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06D8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06D8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06D8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06D8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06D8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06D8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06D9}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06D9}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06D9}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06D9}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06D9}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06D9}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06D9}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06D9}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06D9}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06D9}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06DA}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06DA}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06DA}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06DA}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06DA}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06DA}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06DA}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06DA}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06DA}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06DA}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06DB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06DB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06DB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06DB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06DB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06DB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06DB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06DB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06DB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06DB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06DC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06DC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06DC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06DC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06DC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06DC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06DC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06DC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06DC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06DC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06DF}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06DF}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06DF}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06DF}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06DF}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06DF}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06DF}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06DF}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06DF}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06DF}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06E0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06E0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06E0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06E0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06E0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06E0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06E0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06E0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06E0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06E0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06E1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06E1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06E1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06E1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06E1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06E1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06E1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06E1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06E1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06E1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06E2}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06E2}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06E2}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06E2}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06E2}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06E2}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06E2}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06E2}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06E2}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06E2}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{06E3}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{06E3}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{06E3}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{06E3}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{06E3}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06E3}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{06E3}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{06E3}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{06E3}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{06E3}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06E4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06E4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06E4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06E4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06E4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06E4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06E4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06E4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06E4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06E4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06E7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06E7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06E7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06E7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06E7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06E7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06E7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06E7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06E7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06E7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06E8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06E8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06E8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06E8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06E8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06E8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06E8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06E8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06E8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06E8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{06EA}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{06EA}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{06EA}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{06EA}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{06EA}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06EA}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{06EA}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{06EA}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{06EA}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{06EA}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06EB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06EB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06EB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06EB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06EB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06EB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06EB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06EB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06EB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06EB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{06EC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{06EC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{06EC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{06EC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{06EC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06EC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{06EC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{06EC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{06EC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{06EC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{06ED}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{06ED}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{06ED}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{06ED}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{06ED}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{06ED}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{06ED}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{06ED}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{06ED}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{06ED}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0C55}\u{0711}\u{0670}\u{0711}\u{0062}",
        nfc: "\u{0061}\u{0670}\u{0711}\u{0711}\u{0C55}\u{0062}",
        nfd: "\u{0061}\u{0670}\u{0711}\u{0711}\u{0C55}\u{0062}",
        nfkc: "\u{0061}\u{0670}\u{0711}\u{0711}\u{0C55}\u{0062}",
        nfkd: "\u{0061}\u{0670}\u{0711}\u{0711}\u{0C55}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0711}\u{0C55}\u{0711}\u{0670}\u{0062}",
        nfc: "\u{0061}\u{0670}\u{0711}\u{0711}\u{0C55}\u{0062}",
        nfd: "\u{0061}\u{0670}\u{0711}\u{0711}\u{0C55}\u{0062}",
        nfkc: "\u{0061}\u{0670}\u{0711}\u{0711}\u{0C55}\u{0062}",
        nfkd: "\u{0061}\u{0670}\u{0711}\u{0711}\u{0C55}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0730}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0730}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0730}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0730}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0730}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0730}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0730}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0730}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0730}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0730}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0731}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0731}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0731}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0731}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0731}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0731}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0731}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0731}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0731}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0731}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0732}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0732}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0732}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0732}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0732}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0732}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0732}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0732}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0732}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0732}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0733}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0733}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0733}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0733}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0733}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0733}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0733}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0733}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0733}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0733}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0734}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0734}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0734}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0734}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0734}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0734}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0734}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0734}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0734}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0734}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0735}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0735}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0735}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0735}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0735}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0735}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0735}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0735}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0735}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0735}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0736}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0736}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0736}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0736}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0736}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0736}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0736}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0736}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0736}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0736}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0737}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0737}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0737}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0737}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0737}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0737}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0737}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0737}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0737}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0737}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0738}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0738}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0738}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0738}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0738}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0738}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0738}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0738}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0738}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0738}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0739}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0739}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0739}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0739}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0739}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0739}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0739}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0739}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0739}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0739}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{073A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{073A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{073A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{073A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{073A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{073A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{073A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{073A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{073A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{073A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{073B}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{073B}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{073B}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{073B}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{073B}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{073B}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{073B}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{073B}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{073B}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{073B}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{073C}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{073C}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{073C}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{073C}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{073C}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{073C}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{073C}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{073C}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{073C}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{073C}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{073D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{073D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{073D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{073D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{073D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{073D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{073D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{073D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{073D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{073D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{073E}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{073E}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{073E}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{073E}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{073E}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{073E}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{073E}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{073E}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{073E}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{073E}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{073F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{073F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{073F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{073F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{073F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{073F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{073F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{073F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{073F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{073F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0740}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0740}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0740}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0740}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0740}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0740}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0740}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0740}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0740}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0740}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0741}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0741}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0741}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0741}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0741}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0741}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0741}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0741}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0741}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0741}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0742}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0742}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0742}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0742}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0742}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0742}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0742}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0742}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0742}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0742}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0743}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0743}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0743}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0743}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0743}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0743}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0743}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0743}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0743}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0743}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0744}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0744}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0744}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0744}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0744}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0744}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0744}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0744}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0744}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0744}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0745}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0745}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0745}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0745}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0745}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0745}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0745}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0745}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0745}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0745}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0746}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0746}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0746}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0746}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0746}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0746}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0746}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0746}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0746}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0746}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0747}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0747}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0747}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0747}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0747}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0747}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0747}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0747}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0747}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0747}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0748}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0748}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0748}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0748}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0748}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0748}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0748}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0748}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0748}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0748}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0749}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0749}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0749}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0749}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0749}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0749}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0749}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0749}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0749}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0749}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{074A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{074A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{074A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{074A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{074A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{074A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{074A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{074A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{074A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{074A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{07EB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{07EB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{07EB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{07EB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{07EB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{07EB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{07EB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{07EB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{07EB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{07EB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{07EC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{07EC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{07EC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{07EC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{07EC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{07EC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{07EC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{07EC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{07EC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{07EC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{07ED}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{07ED}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{07ED}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{07ED}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{07ED}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{07ED}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{07ED}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{07ED}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{07ED}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{07ED}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{07EE}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{07EE}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{07EE}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{07EE}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{07EE}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{07EE}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{07EE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{07EE}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{07EE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{07EE}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{07EF}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{07EF}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{07EF}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{07EF}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{07EF}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{07EF}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{07EF}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{07EF}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{07EF}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{07EF}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{07F0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{07F0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{07F0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{07F0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{07F0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{07F0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{07F0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{07F0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{07F0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{07F0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{07F1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{07F1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{07F1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{07F1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{07F1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{07F1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{07F1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{07F1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{07F1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{07F1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{07F2}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{07F2}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{07F2}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{07F2}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{07F2}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{07F2}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{07F2}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{07F2}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{07F2}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{07F2}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{07F3}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{07F3}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{07F3}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{07F3}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{07F3}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{07F3}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{07F3}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{07F3}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{07F3}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{07F3}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0816}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0816}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0816}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0816}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0816}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0816}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0816}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0816}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0816}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0816}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0817}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0817}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0817}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0817}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0817}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0817}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0817}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0817}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0817}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0817}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0818}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0818}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0818}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0818}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0818}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0818}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0818}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0818}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0818}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0818}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0819}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0819}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0819}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0819}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0819}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0819}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0819}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0819}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0819}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0819}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{081B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{081B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{081B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{081B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{081B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{081B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{081B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{081B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{081B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{081B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{081C}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{081C}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{081C}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{081C}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{081C}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{081C}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{081C}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{081C}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{081C}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{081C}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{081D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{081D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{081D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{081D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{081D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{081D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{081D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{081D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{081D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{081D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{081E}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{081E}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{081E}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{081E}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{081E}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{081E}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{081E}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{081E}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{081E}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{081E}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{081F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{081F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{081F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{081F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{081F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{081F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{081F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{081F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{081F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{081F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0820}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0820}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0820}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0820}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0820}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0820}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0820}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0820}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0820}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0820}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0821}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0821}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0821}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0821}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0821}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0821}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0821}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0821}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0821}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0821}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0822}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0822}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0822}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0822}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0822}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0822}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0822}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0822}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0822}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0822}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0823}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0823}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0823}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0823}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0823}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0823}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0823}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0823}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0823}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0823}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0825}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0825}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0825}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0825}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0825}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0825}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0825}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0825}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0825}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0825}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0826}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0826}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0826}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0826}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0826}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0826}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0826}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0826}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0826}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0826}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0827}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0827}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0827}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0827}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0827}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0827}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0827}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0827}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0827}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0827}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0829}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0829}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0829}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0829}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0829}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0829}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0829}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0829}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0829}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0829}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{082A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{082A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{082A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{082A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{082A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{082A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{082A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{082A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{082A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{082A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{082B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{082B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{082B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{082B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{082B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{082B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{082B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{082B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{082B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{082B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{082C}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{082C}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{082C}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{082C}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{082C}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{082C}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{082C}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{082C}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{082C}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{082C}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{082D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{082D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{082D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{082D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{082D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{082D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{082D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{082D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{082D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{082D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0859}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0859}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0859}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0859}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0859}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0859}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0859}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0859}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0859}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0859}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{085A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{085A}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{085A}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{085A}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{085A}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{085A}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{085A}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{085A}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{085A}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{085A}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{085B}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{085B}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{085B}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{085B}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{085B}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{085B}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{085B}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{085B}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{085B}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{085B}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08D4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08D4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08D4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08D4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08D4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08D4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08D4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08D4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08D4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08D4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08D5}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08D5}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08D5}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08D5}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08D5}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08D5}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08D5}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08D5}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08D5}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08D5}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08D6}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08D6}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08D6}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08D6}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08D6}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08D6}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08D6}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08D6}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08D6}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08D6}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08D7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08D7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08D7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08D7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08D7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08D7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08D7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08D7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08D7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08D7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08D8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08D8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08D8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08D8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08D8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08D8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08D8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08D8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08D8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08D8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08D9}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08D9}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08D9}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08D9}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08D9}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08D9}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08D9}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08D9}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08D9}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08D9}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08DA}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08DA}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08DA}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08DA}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08DA}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08DA}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08DA}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08DA}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08DA}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08DA}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08DB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08DB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08DB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08DB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08DB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08DB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08DB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08DB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08DB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08DB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08DC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08DC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08DC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08DC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08DC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08DC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08DC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08DC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08DC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08DC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08DD}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08DD}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08DD}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08DD}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08DD}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08DD}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08DD}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08DD}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08DD}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08DD}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08DE}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08DE}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08DE}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08DE}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08DE}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08DE}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08DE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08DE}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08DE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08DE}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08DF}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08DF}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08DF}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08DF}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08DF}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08DF}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08DF}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08DF}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08DF}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08DF}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08E0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08E0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08E0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08E0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08E0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08E0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08E0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08E0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08E0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08E0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08E1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08E1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08E1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08E1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08E1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08E1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08E1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08E1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08E1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08E1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{08E3}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{08E3}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{08E3}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{08E3}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{08E3}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08E3}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{08E3}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{08E3}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{08E3}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{08E3}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08E4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08E4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08E4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08E4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08E4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08E4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08E4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08E4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08E4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08E4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08E5}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08E5}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08E5}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08E5}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08E5}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08E5}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08E5}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08E5}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08E5}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08E5}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{08E6}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{08E6}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{08E6}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{08E6}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{08E6}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08E6}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{08E6}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{08E6}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{08E6}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{08E6}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08E7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08E7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08E7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08E7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08E7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08E7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08E7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08E7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08E7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08E7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08E8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08E8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08E8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08E8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08E8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08E8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08E8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08E8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08E8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08E8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{08E9}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{08E9}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{08E9}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{08E9}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{08E9}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08E9}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{08E9}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{08E9}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{08E9}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{08E9}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08EA}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08EA}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08EA}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08EA}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08EA}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08EA}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08EA}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08EA}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08EA}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08EA}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08EB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08EB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08EB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08EB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08EB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08EB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08EB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08EB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08EB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08EB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08EC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08EC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08EC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08EC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08EC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08EC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08EC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08EC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08EC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08EC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{08ED}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{08ED}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{08ED}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{08ED}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{08ED}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08ED}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{08ED}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{08ED}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{08ED}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{08ED}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{08EE}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{08EE}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{08EE}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{08EE}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{08EE}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08EE}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{08EE}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{08EE}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{08EE}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{08EE}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{08EF}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{08EF}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{08EF}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{08EF}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{08EF}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08EF}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{08EF}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{08EF}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{08EF}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{08EF}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{064C}\u{064B}\u{FB1E}\u{08F0}\u{0062}",
        nfc: "\u{0061}\u{FB1E}\u{064B}\u{08F0}\u{064C}\u{0062}",
        nfd: "\u{0061}\u{FB1E}\u{064B}\u{08F0}\u{064C}\u{0062}",
        nfkc: "\u{0061}\u{FB1E}\u{064B}\u{08F0}\u{064C}\u{0062}",
        nfkd: "\u{0061}\u{FB1E}\u{064B}\u{08F0}\u{064C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08F0}\u{064C}\u{064B}\u{FB1E}\u{0062}",
        nfc: "\u{0061}\u{FB1E}\u{08F0}\u{064B}\u{064C}\u{0062}",
        nfd: "\u{0061}\u{FB1E}\u{08F0}\u{064B}\u{064C}\u{0062}",
        nfkc: "\u{0061}\u{FB1E}\u{08F0}\u{064B}\u{064C}\u{0062}",
        nfkd: "\u{0061}\u{FB1E}\u{08F0}\u{064B}\u{064C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{064D}\u{064C}\u{064B}\u{08F1}\u{0062}",
        nfc: "\u{0061}\u{064B}\u{064C}\u{08F1}\u{064D}\u{0062}",
        nfd: "\u{0061}\u{064B}\u{064C}\u{08F1}\u{064D}\u{0062}",
        nfkc: "\u{0061}\u{064B}\u{064C}\u{08F1}\u{064D}\u{0062}",
        nfkd: "\u{0061}\u{064B}\u{064C}\u{08F1}\u{064D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08F1}\u{064D}\u{064C}\u{064B}\u{0062}",
        nfc: "\u{0061}\u{064B}\u{08F1}\u{064C}\u{064D}\u{0062}",
        nfd: "\u{0061}\u{064B}\u{08F1}\u{064C}\u{064D}\u{0062}",
        nfkc: "\u{0061}\u{064B}\u{08F1}\u{064C}\u{064D}\u{0062}",
        nfkd: "\u{0061}\u{064B}\u{08F1}\u{064C}\u{064D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0618}\u{064D}\u{064C}\u{08F2}\u{0062}",
        nfc: "\u{0061}\u{064C}\u{064D}\u{08F2}\u{0618}\u{0062}",
        nfd: "\u{0061}\u{064C}\u{064D}\u{08F2}\u{0618}\u{0062}",
        nfkc: "\u{0061}\u{064C}\u{064D}\u{08F2}\u{0618}\u{0062}",
        nfkd: "\u{0061}\u{064C}\u{064D}\u{08F2}\u{0618}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08F2}\u{0618}\u{064D}\u{064C}\u{0062}",
        nfc: "\u{0061}\u{064C}\u{08F2}\u{064D}\u{0618}\u{0062}",
        nfd: "\u{0061}\u{064C}\u{08F2}\u{064D}\u{0618}\u{0062}",
        nfkc: "\u{0061}\u{064C}\u{08F2}\u{064D}\u{0618}\u{0062}",
        nfkd: "\u{0061}\u{064C}\u{08F2}\u{064D}\u{0618}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08F3}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08F3}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08F3}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08F3}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08F3}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08F3}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08F3}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08F3}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08F3}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08F3}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08F4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08F4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08F4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08F4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08F4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08F4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08F4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08F4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08F4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08F4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08F5}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08F5}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08F5}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08F5}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08F5}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08F5}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08F5}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08F5}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08F5}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08F5}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{08F6}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{08F6}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{08F6}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{08F6}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{08F6}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08F6}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{08F6}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{08F6}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{08F6}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{08F6}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08F7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08F7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08F7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08F7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08F7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08F7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08F7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08F7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08F7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08F7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08F8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08F8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08F8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08F8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08F8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08F8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08F8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08F8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08F8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08F8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{08F9}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{08F9}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{08F9}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{08F9}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{08F9}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08F9}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{08F9}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{08F9}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{08F9}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{08F9}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{08FA}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{08FA}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{08FA}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{08FA}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{08FA}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08FA}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{08FA}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{08FA}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{08FA}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{08FA}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08FB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08FB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08FB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08FB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08FB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08FB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08FB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08FB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08FB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08FB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08FC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08FC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08FC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08FC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08FC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08FC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08FC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08FC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08FC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08FC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08FD}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08FD}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08FD}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08FD}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08FD}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08FD}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08FD}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08FD}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08FD}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08FD}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08FE}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08FE}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08FE}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08FE}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08FE}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08FE}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08FE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08FE}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08FE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08FE}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{08FF}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{08FF}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{08FF}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{08FF}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{08FF}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{08FF}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{08FF}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{08FF}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{08FF}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{08FF}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{093C}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{094D}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{094D}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0951}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0951}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0951}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0951}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0951}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0951}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0951}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0951}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0951}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0951}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0952}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0952}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0952}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0952}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0952}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0952}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0952}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0952}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0952}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0952}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0953}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0953}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0953}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0953}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0953}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0953}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0953}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0953}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0953}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0953}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0954}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0954}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0954}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0954}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0954}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0954}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0954}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0954}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0954}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0954}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{09BC}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{09BC}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{09BC}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{09BC}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{09BC}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{09BC}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{09BC}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{09BC}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{09BC}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{09BC}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{09CD}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{09CD}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{09CD}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{09CD}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{09CD}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{09CD}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{09CD}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{09CD}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{09CD}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{09CD}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{0A3C}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{0A3C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{0A3C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{0A3C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{0A3C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0A3C}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{0A3C}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{0A3C}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{0A3C}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{0A3C}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{0A4D}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{0A4D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{0A4D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{0A4D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{0A4D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0A4D}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{0A4D}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{0A4D}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{0A4D}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{0A4D}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{0ABC}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{0ABC}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{0ABC}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{0ABC}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{0ABC}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0ABC}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{0ABC}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{0ABC}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{0ABC}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{0ABC}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{0ACD}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{0ACD}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{0ACD}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{0ACD}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{0ACD}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0ACD}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{0ACD}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{0ACD}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{0ACD}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{0ACD}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{0B3C}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{0B3C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{0B3C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{0B3C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{0B3C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0B3C}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{0B3C}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{0B3C}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{0B3C}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{0B3C}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{0B4D}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{0B4D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{0B4D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{0B4D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{0B4D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0B4D}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{0B4D}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{0B4D}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{0B4D}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{0B4D}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{0BCD}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{0BCD}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{0BCD}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{0BCD}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{0BCD}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0BCD}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{0BCD}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{0BCD}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{0BCD}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{0BCD}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{0C4D}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{0C4D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{0C4D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{0C4D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{0C4D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0C4D}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{0C4D}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{0C4D}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{0C4D}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{0C4D}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0C56}\u{0C55}\u{0711}\u{0C55}\u{0062}",
        nfc: "\u{0061}\u{0711}\u{0C55}\u{0C55}\u{0C56}\u{0062}",
        nfd: "\u{0061}\u{0711}\u{0C55}\u{0C55}\u{0C56}\u{0062}",
        nfkc: "\u{0061}\u{0711}\u{0C55}\u{0C55}\u{0C56}\u{0062}",
        nfkd: "\u{0061}\u{0711}\u{0C55}\u{0C55}\u{0C56}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0C55}\u{0C56}\u{0C55}\u{0711}\u{0062}",
        nfc: "\u{0061}\u{0711}\u{0C55}\u{0C55}\u{0C56}\u{0062}",
        nfd: "\u{0061}\u{0711}\u{0C55}\u{0C55}\u{0C56}\u{0062}",
        nfkc: "\u{0061}\u{0711}\u{0C55}\u{0C55}\u{0C56}\u{0062}",
        nfkd: "\u{0061}\u{0711}\u{0C55}\u{0C55}\u{0C56}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0E38}\u{0C56}\u{0C55}\u{0C56}\u{0062}",
        nfc: "\u{0061}\u{0C55}\u{0C56}\u{0C56}\u{0E38}\u{0062}",
        nfd: "\u{0061}\u{0C55}\u{0C56}\u{0C56}\u{0E38}\u{0062}",
        nfkc: "\u{0061}\u{0C55}\u{0C56}\u{0C56}\u{0E38}\u{0062}",
        nfkd: "\u{0061}\u{0C55}\u{0C56}\u{0C56}\u{0E38}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0C56}\u{0E38}\u{0C56}\u{0C55}\u{0062}",
        nfc: "\u{0061}\u{0C55}\u{0C56}\u{0C56}\u{0E38}\u{0062}",
        nfd: "\u{0061}\u{0C55}\u{0C56}\u{0C56}\u{0E38}\u{0062}",
        nfkc: "\u{0061}\u{0C55}\u{0C56}\u{0C56}\u{0E38}\u{0062}",
        nfkd: "\u{0061}\u{0C55}\u{0C56}\u{0C56}\u{0E38}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{0CBC}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{0CBC}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{0CBC}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{0CBC}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{0CBC}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0CBC}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{0CBC}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{0CBC}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{0CBC}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{0CBC}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{0CCD}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{0CCD}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{0CCD}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{0CCD}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{0CCD}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0CCD}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{0CCD}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{0CCD}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{0CCD}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{0CCD}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{0D4D}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{0D4D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{0D4D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{0D4D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{0D4D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0D4D}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{0D4D}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{0D4D}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{0D4D}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{0D4D}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{0DCA}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{0DCA}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{0DCA}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{0DCA}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{0DCA}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0DCA}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{0DCA}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{0DCA}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{0DCA}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{0DCA}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0E48}\u{0E38}\u{0C56}\u{0E38}\u{0062}",
        nfc: "\u{0061}\u{0C56}\u{0E38}\u{0E38}\u{0E48}\u{0062}",
        nfd: "\u{0061}\u{0C56}\u{0E38}\u{0E38}\u{0E48}\u{0062}",
        nfkc: "\u{0061}\u{0C56}\u{0E38}\u{0E38}\u{0E48}\u{0062}",
        nfkd: "\u{0061}\u{0C56}\u{0E38}\u{0E38}\u{0E48}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0E38}\u{0E48}\u{0E38}\u{0C56}\u{0062}",
        nfc: "\u{0061}\u{0C56}\u{0E38}\u{0E38}\u{0E48}\u{0062}",
        nfd: "\u{0061}\u{0C56}\u{0E38}\u{0E38}\u{0E48}\u{0062}",
        nfkc: "\u{0061}\u{0C56}\u{0E38}\u{0E38}\u{0E48}\u{0062}",
        nfkd: "\u{0061}\u{0C56}\u{0E38}\u{0E38}\u{0E48}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0E48}\u{0E38}\u{0C56}\u{0E39}\u{0062}",
        nfc: "\u{0061}\u{0C56}\u{0E38}\u{0E39}\u{0E48}\u{0062}",
        nfd: "\u{0061}\u{0C56}\u{0E38}\u{0E39}\u{0E48}\u{0062}",
        nfkc: "\u{0061}\u{0C56}\u{0E38}\u{0E39}\u{0E48}\u{0062}",
        nfkd: "\u{0061}\u{0C56}\u{0E38}\u{0E39}\u{0E48}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0E39}\u{0E48}\u{0E38}\u{0C56}\u{0062}",
        nfc: "\u{0061}\u{0C56}\u{0E39}\u{0E38}\u{0E48}\u{0062}",
        nfd: "\u{0061}\u{0C56}\u{0E39}\u{0E38}\u{0E48}\u{0062}",
        nfkc: "\u{0061}\u{0C56}\u{0E39}\u{0E38}\u{0E48}\u{0062}",
        nfkd: "\u{0061}\u{0C56}\u{0E39}\u{0E38}\u{0E48}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{0E3A}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{0E3A}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{0E3A}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{0E3A}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{0E3A}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0E3A}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{0E3A}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{0E3A}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{0E3A}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{0E3A}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0EB8}\u{0E48}\u{0E38}\u{0E48}\u{0062}",
        nfc: "\u{0061}\u{0E38}\u{0E48}\u{0E48}\u{0EB8}\u{0062}",
        nfd: "\u{0061}\u{0E38}\u{0E48}\u{0E48}\u{0EB8}\u{0062}",
        nfkc: "\u{0061}\u{0E38}\u{0E48}\u{0E48}\u{0EB8}\u{0062}",
        nfkd: "\u{0061}\u{0E38}\u{0E48}\u{0E48}\u{0EB8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0E48}\u{0EB8}\u{0E48}\u{0E38}\u{0062}",
        nfc: "\u{0061}\u{0E38}\u{0E48}\u{0E48}\u{0EB8}\u{0062}",
        nfd: "\u{0061}\u{0E38}\u{0E48}\u{0E48}\u{0EB8}\u{0062}",
        nfkc: "\u{0061}\u{0E38}\u{0E48}\u{0E48}\u{0EB8}\u{0062}",
        nfkd: "\u{0061}\u{0E38}\u{0E48}\u{0E48}\u{0EB8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0EB8}\u{0E48}\u{0E38}\u{0E49}\u{0062}",
        nfc: "\u{0061}\u{0E38}\u{0E48}\u{0E49}\u{0EB8}\u{0062}",
        nfd: "\u{0061}\u{0E38}\u{0E48}\u{0E49}\u{0EB8}\u{0062}",
        nfkc: "\u{0061}\u{0E38}\u{0E48}\u{0E49}\u{0EB8}\u{0062}",
        nfkd: "\u{0061}\u{0E38}\u{0E48}\u{0E49}\u{0EB8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0E49}\u{0EB8}\u{0E48}\u{0E38}\u{0062}",
        nfc: "\u{0061}\u{0E38}\u{0E49}\u{0E48}\u{0EB8}\u{0062}",
        nfd: "\u{0061}\u{0E38}\u{0E49}\u{0E48}\u{0EB8}\u{0062}",
        nfkc: "\u{0061}\u{0E38}\u{0E49}\u{0E48}\u{0EB8}\u{0062}",
        nfkd: "\u{0061}\u{0E38}\u{0E49}\u{0E48}\u{0EB8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0EB8}\u{0E48}\u{0E38}\u{0E4A}\u{0062}",
        nfc: "\u{0061}\u{0E38}\u{0E48}\u{0E4A}\u{0EB8}\u{0062}",
        nfd: "\u{0061}\u{0E38}\u{0E48}\u{0E4A}\u{0EB8}\u{0062}",
        nfkc: "\u{0061}\u{0E38}\u{0E48}\u{0E4A}\u{0EB8}\u{0062}",
        nfkd: "\u{0061}\u{0E38}\u{0E48}\u{0E4A}\u{0EB8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0E4A}\u{0EB8}\u{0E48}\u{0E38}\u{0062}",
        nfc: "\u{0061}\u{0E38}\u{0E4A}\u{0E48}\u{0EB8}\u{0062}",
        nfd: "\u{0061}\u{0E38}\u{0E4A}\u{0E48}\u{0EB8}\u{0062}",
        nfkc: "\u{0061}\u{0E38}\u{0E4A}\u{0E48}\u{0EB8}\u{0062}",
        nfkd: "\u{0061}\u{0E38}\u{0E4A}\u{0E48}\u{0EB8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0EB8}\u{0E48}\u{0E38}\u{0E4B}\u{0062}",
        nfc: "\u{0061}\u{0E38}\u{0E48}\u{0E4B}\u{0EB8}\u{0062}",
        nfd: "\u{0061}\u{0E38}\u{0E48}\u{0E4B}\u{0EB8}\u{0062}",
        nfkc: "\u{0061}\u{0E38}\u{0E48}\u{0E4B}\u{0EB8}\u{0062}",
        nfkd: "\u{0061}\u{0E38}\u{0E48}\u{0E4B}\u{0EB8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0E4B}\u{0EB8}\u{0E48}\u{0E38}\u{0062}",
        nfc: "\u{0061}\u{0E38}\u{0E4B}\u{0E48}\u{0EB8}\u{0062}",
        nfd: "\u{0061}\u{0E38}\u{0E4B}\u{0E48}\u{0EB8}\u{0062}",
        nfkc: "\u{0061}\u{0E38}\u{0E4B}\u{0E48}\u{0EB8}\u{0062}",
        nfkd: "\u{0061}\u{0E38}\u{0E4B}\u{0E48}\u{0EB8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0EC8}\u{0EB8}\u{0E48}\u{0EB8}\u{0062}",
        nfc: "\u{0061}\u{0E48}\u{0EB8}\u{0EB8}\u{0EC8}\u{0062}",
        nfd: "\u{0061}\u{0E48}\u{0EB8}\u{0EB8}\u{0EC8}\u{0062}",
        nfkc: "\u{0061}\u{0E48}\u{0EB8}\u{0EB8}\u{0EC8}\u{0062}",
        nfkd: "\u{0061}\u{0E48}\u{0EB8}\u{0EB8}\u{0EC8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0EB8}\u{0EC8}\u{0EB8}\u{0E48}\u{0062}",
        nfc: "\u{0061}\u{0E48}\u{0EB8}\u{0EB8}\u{0EC8}\u{0062}",
        nfd: "\u{0061}\u{0E48}\u{0EB8}\u{0EB8}\u{0EC8}\u{0062}",
        nfkc: "\u{0061}\u{0E48}\u{0EB8}\u{0EB8}\u{0EC8}\u{0062}",
        nfkd: "\u{0061}\u{0E48}\u{0EB8}\u{0EB8}\u{0EC8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0EC8}\u{0EB8}\u{0E48}\u{0EB9}\u{0062}",
        nfc: "\u{0061}\u{0E48}\u{0EB8}\u{0EB9}\u{0EC8}\u{0062}",
        nfd: "\u{0061}\u{0E48}\u{0EB8}\u{0EB9}\u{0EC8}\u{0062}",
        nfkc: "\u{0061}\u{0E48}\u{0EB8}\u{0EB9}\u{0EC8}\u{0062}",
        nfkd: "\u{0061}\u{0E48}\u{0EB8}\u{0EB9}\u{0EC8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0EB9}\u{0EC8}\u{0EB8}\u{0E48}\u{0062}",
        nfc: "\u{0061}\u{0E48}\u{0EB9}\u{0EB8}\u{0EC8}\u{0062}",
        nfd: "\u{0061}\u{0E48}\u{0EB9}\u{0EB8}\u{0EC8}\u{0062}",
        nfkc: "\u{0061}\u{0E48}\u{0EB9}\u{0EB8}\u{0EC8}\u{0062}",
        nfkd: "\u{0061}\u{0E48}\u{0EB9}\u{0EB8}\u{0EC8}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F71}\u{0EC8}\u{0EB8}\u{0EC8}\u{0062}",
        nfc: "\u{0061}\u{0EB8}\u{0EC8}\u{0EC8}\u{0F71}\u{0062}",
        nfd: "\u{0061}\u{0EB8}\u{0EC8}\u{0EC8}\u{0F71}\u{0062}",
        nfkc: "\u{0061}\u{0EB8}\u{0EC8}\u{0EC8}\u{0F71}\u{0062}",
        nfkd: "\u{0061}\u{0EB8}\u{0EC8}\u{0EC8}\u{0F71}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0EC8}\u{0F71}\u{0EC8}\u{0EB8}\u{0062}",
        nfc: "\u{0061}\u{0EB8}\u{0EC8}\u{0EC8}\u{0F71}\u{0062}",
        nfd: "\u{0061}\u{0EB8}\u{0EC8}\u{0EC8}\u{0F71}\u{0062}",
        nfkc: "\u{0061}\u{0EB8}\u{0EC8}\u{0EC8}\u{0F71}\u{0062}",
        nfkd: "\u{0061}\u{0EB8}\u{0EC8}\u{0EC8}\u{0F71}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F71}\u{0EC8}\u{0EB8}\u{0EC9}\u{0062}",
        nfc: "\u{0061}\u{0EB8}\u{0EC8}\u{0EC9}\u{0F71}\u{0062}",
        nfd: "\u{0061}\u{0EB8}\u{0EC8}\u{0EC9}\u{0F71}\u{0062}",
        nfkc: "\u{0061}\u{0EB8}\u{0EC8}\u{0EC9}\u{0F71}\u{0062}",
        nfkd: "\u{0061}\u{0EB8}\u{0EC8}\u{0EC9}\u{0F71}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0EC9}\u{0F71}\u{0EC8}\u{0EB8}\u{0062}",
        nfc: "\u{0061}\u{0EB8}\u{0EC9}\u{0EC8}\u{0F71}\u{0062}",
        nfd: "\u{0061}\u{0EB8}\u{0EC9}\u{0EC8}\u{0F71}\u{0062}",
        nfkc: "\u{0061}\u{0EB8}\u{0EC9}\u{0EC8}\u{0F71}\u{0062}",
        nfkd: "\u{0061}\u{0EB8}\u{0EC9}\u{0EC8}\u{0F71}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F71}\u{0EC8}\u{0EB8}\u{0ECA}\u{0062}",
        nfc: "\u{0061}\u{0EB8}\u{0EC8}\u{0ECA}\u{0F71}\u{0062}",
        nfd: "\u{0061}\u{0EB8}\u{0EC8}\u{0ECA}\u{0F71}\u{0062}",
        nfkc: "\u{0061}\u{0EB8}\u{0EC8}\u{0ECA}\u{0F71}\u{0062}",
        nfkd: "\u{0061}\u{0EB8}\u{0EC8}\u{0ECA}\u{0F71}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0ECA}\u{0F71}\u{0EC8}\u{0EB8}\u{0062}",
        nfc: "\u{0061}\u{0EB8}\u{0ECA}\u{0EC8}\u{0F71}\u{0062}",
        nfd: "\u{0061}\u{0EB8}\u{0ECA}\u{0EC8}\u{0F71}\u{0062}",
        nfkc: "\u{0061}\u{0EB8}\u{0ECA}\u{0EC8}\u{0F71}\u{0062}",
        nfkd: "\u{0061}\u{0EB8}\u{0ECA}\u{0EC8}\u{0F71}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F71}\u{0EC8}\u{0EB8}\u{0ECB}\u{0062}",
        nfc: "\u{0061}\u{0EB8}\u{0EC8}\u{0ECB}\u{0F71}\u{0062}",
        nfd: "\u{0061}\u{0EB8}\u{0EC8}\u{0ECB}\u{0F71}\u{0062}",
        nfkc: "\u{0061}\u{0EB8}\u{0EC8}\u{0ECB}\u{0F71}\u{0062}",
        nfkd: "\u{0061}\u{0EB8}\u{0EC8}\u{0ECB}\u{0F71}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0ECB}\u{0F71}\u{0EC8}\u{0EB8}\u{0062}",
        nfc: "\u{0061}\u{0EB8}\u{0ECB}\u{0EC8}\u{0F71}\u{0062}",
        nfd: "\u{0061}\u{0EB8}\u{0ECB}\u{0EC8}\u{0F71}\u{0062}",
        nfkc: "\u{0061}\u{0EB8}\u{0ECB}\u{0EC8}\u{0F71}\u{0062}",
        nfkd: "\u{0061}\u{0EB8}\u{0ECB}\u{0EC8}\u{0F71}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0F18}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0F18}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0F18}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0F18}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0F18}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F18}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0F18}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0F18}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0F18}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0F18}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0F19}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0F19}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0F19}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0F19}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0F19}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F19}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0F19}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0F19}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0F19}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0F19}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0F35}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0F35}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0F35}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0F35}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0F35}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F35}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0F35}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0F35}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0F35}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0F35}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0F37}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0F37}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0F37}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0F37}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0F37}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F37}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0F37}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0F37}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0F37}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0F37}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302A}\u{031B}\u{1DCE}\u{0F39}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{031B}\u{0F39}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{031B}\u{0F39}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{031B}\u{0F39}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{031B}\u{0F39}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F39}\u{302A}\u{031B}\u{1DCE}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{0F39}\u{031B}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{0F39}\u{031B}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{0F39}\u{031B}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{0F39}\u{031B}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F72}\u{0F71}\u{0EC8}\u{0F71}\u{0062}",
        nfc: "\u{0061}\u{0EC8}\u{0F71}\u{0F71}\u{0F72}\u{0062}",
        nfd: "\u{0061}\u{0EC8}\u{0F71}\u{0F71}\u{0F72}\u{0062}",
        nfkc: "\u{0061}\u{0EC8}\u{0F71}\u{0F71}\u{0F72}\u{0062}",
        nfkd: "\u{0061}\u{0EC8}\u{0F71}\u{0F71}\u{0F72}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F71}\u{0F72}\u{0F71}\u{0EC8}\u{0062}",
        nfc: "\u{0061}\u{0EC8}\u{0F71}\u{0F71}\u{0F72}\u{0062}",
        nfd: "\u{0061}\u{0EC8}\u{0F71}\u{0F71}\u{0F72}\u{0062}",
        nfkc: "\u{0061}\u{0EC8}\u{0F71}\u{0F71}\u{0F72}\u{0062}",
        nfkd: "\u{0061}\u{0EC8}\u{0F71}\u{0F71}\u{0F72}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F74}\u{0F72}\u{0F71}\u{0F72}\u{0062}",
        nfc: "\u{0061}\u{0F71}\u{0F72}\u{0F72}\u{0F74}\u{0062}",
        nfd: "\u{0061}\u{0F71}\u{0F72}\u{0F72}\u{0F74}\u{0062}",
        nfkc: "\u{0061}\u{0F71}\u{0F72}\u{0F72}\u{0F74}\u{0062}",
        nfkd: "\u{0061}\u{0F71}\u{0F72}\u{0F72}\u{0F74}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F72}\u{0F74}\u{0F72}\u{0F71}\u{0062}",
        nfc: "\u{0061}\u{0F71}\u{0F72}\u{0F72}\u{0F74}\u{0062}",
        nfd: "\u{0061}\u{0F71}\u{0F72}\u{0F72}\u{0F74}\u{0062}",
        nfkc: "\u{0061}\u{0F71}\u{0F72}\u{0F72}\u{0F74}\u{0062}",
        nfkd: "\u{0061}\u{0F71}\u{0F72}\u{0F72}\u{0F74}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0321}\u{0F74}\u{0F72}\u{0F74}\u{0062}",
        nfc: "\u{0061}\u{0F72}\u{0F74}\u{0F74}\u{0321}\u{0062}",
        nfd: "\u{0061}\u{0F72}\u{0F74}\u{0F74}\u{0321}\u{0062}",
        nfkc: "\u{0061}\u{0F72}\u{0F74}\u{0F74}\u{0321}\u{0062}",
        nfkd: "\u{0061}\u{0F72}\u{0F74}\u{0F74}\u{0321}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F74}\u{0321}\u{0F74}\u{0F72}\u{0062}",
        nfc: "\u{0061}\u{0F72}\u{0F74}\u{0F74}\u{0321}\u{0062}",
        nfd: "\u{0061}\u{0F72}\u{0F74}\u{0F74}\u{0321}\u{0062}",
        nfkc: "\u{0061}\u{0F72}\u{0F74}\u{0F74}\u{0321}\u{0062}",
        nfkd: "\u{0061}\u{0F72}\u{0F74}\u{0F74}\u{0321}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F74}\u{0F72}\u{0F71}\u{0F7A}\u{0062}",
        nfc: "\u{0061}\u{0F71}\u{0F72}\u{0F7A}\u{0F74}\u{0062}",
        nfd: "\u{0061}\u{0F71}\u{0F72}\u{0F7A}\u{0F74}\u{0062}",
        nfkc: "\u{0061}\u{0F71}\u{0F72}\u{0F7A}\u{0F74}\u{0062}",
        nfkd: "\u{0061}\u{0F71}\u{0F72}\u{0F7A}\u{0F74}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F7A}\u{0F74}\u{0F72}\u{0F71}\u{0062}",
        nfc: "\u{0061}\u{0F71}\u{0F7A}\u{0F72}\u{0F74}\u{0062}",
        nfd: "\u{0061}\u{0F71}\u{0F7A}\u{0F72}\u{0F74}\u{0062}",
        nfkc: "\u{0061}\u{0F71}\u{0F7A}\u{0F72}\u{0F74}\u{0062}",
        nfkd: "\u{0061}\u{0F71}\u{0F7A}\u{0F72}\u{0F74}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F74}\u{0F72}\u{0F71}\u{0F7B}\u{0062}",
        nfc: "\u{0061}\u{0F71}\u{0F72}\u{0F7B}\u{0F74}\u{0062}",
        nfd: "\u{0061}\u{0F71}\u{0F72}\u{0F7B}\u{0F74}\u{0062}",
        nfkc: "\u{0061}\u{0F71}\u{0F72}\u{0F7B}\u{0F74}\u{0062}",
        nfkd: "\u{0061}\u{0F71}\u{0F72}\u{0F7B}\u{0F74}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F7B}\u{0F74}\u{0F72}\u{0F71}\u{0062}",
        nfc: "\u{0061}\u{0F71}\u{0F7B}\u{0F72}\u{0F74}\u{0062}",
        nfd: "\u{0061}\u{0F71}\u{0F7B}\u{0F72}\u{0F74}\u{0062}",
        nfkc: "\u{0061}\u{0F71}\u{0F7B}\u{0F72}\u{0F74}\u{0062}",
        nfkd: "\u{0061}\u{0F71}\u{0F7B}\u{0F72}\u{0F74}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F74}\u{0F72}\u{0F71}\u{0F7C}\u{0062}",
        nfc: "\u{0061}\u{0F71}\u{0F72}\u{0F7C}\u{0F74}\u{0062}",
        nfd: "\u{0061}\u{0F71}\u{0F72}\u{0F7C}\u{0F74}\u{0062}",
        nfkc: "\u{0061}\u{0F71}\u{0F72}\u{0F7C}\u{0F74}\u{0062}",
        nfkd: "\u{0061}\u{0F71}\u{0F72}\u{0F7C}\u{0F74}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F7C}\u{0F74}\u{0F72}\u{0F71}\u{0062}",
        nfc: "\u{0061}\u{0F71}\u{0F7C}\u{0F72}\u{0F74}\u{0062}",
        nfd: "\u{0061}\u{0F71}\u{0F7C}\u{0F72}\u{0F74}\u{0062}",
        nfkc: "\u{0061}\u{0F71}\u{0F7C}\u{0F72}\u{0F74}\u{0062}",
        nfkd: "\u{0061}\u{0F71}\u{0F7C}\u{0F72}\u{0F74}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F74}\u{0F72}\u{0F71}\u{0F7D}\u{0062}",
        nfc: "\u{0061}\u{0F71}\u{0F72}\u{0F7D}\u{0F74}\u{0062}",
        nfd: "\u{0061}\u{0F71}\u{0F72}\u{0F7D}\u{0F74}\u{0062}",
        nfkc: "\u{0061}\u{0F71}\u{0F72}\u{0F7D}\u{0F74}\u{0062}",
        nfkd: "\u{0061}\u{0F71}\u{0F72}\u{0F7D}\u{0F74}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F7D}\u{0F74}\u{0F72}\u{0F71}\u{0062}",
        nfc: "\u{0061}\u{0F71}\u{0F7D}\u{0F72}\u{0F74}\u{0062}",
        nfd: "\u{0061}\u{0F71}\u{0F7D}\u{0F72}\u{0F74}\u{0062}",
        nfkc: "\u{0061}\u{0F71}\u{0F7D}\u{0F72}\u{0F74}\u{0062}",
        nfkd: "\u{0061}\u{0F71}\u{0F7D}\u{0F72}\u{0F74}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F74}\u{0F72}\u{0F71}\u{0F80}\u{0062}",
        nfc: "\u{0061}\u{0F71}\u{0F72}\u{0F80}\u{0F74}\u{0062}",
        nfd: "\u{0061}\u{0F71}\u{0F72}\u{0F80}\u{0F74}\u{0062}",
        nfkc: "\u{0061}\u{0F71}\u{0F72}\u{0F80}\u{0F74}\u{0062}",
        nfkd: "\u{0061}\u{0F71}\u{0F72}\u{0F80}\u{0F74}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F80}\u{0F74}\u{0F72}\u{0F71}\u{0062}",
        nfc: "\u{0061}\u{0F71}\u{0F80}\u{0F72}\u{0F74}\u{0062}",
        nfd: "\u{0061}\u{0F71}\u{0F80}\u{0F72}\u{0F74}\u{0062}",
        nfkc: "\u{0061}\u{0F71}\u{0F80}\u{0F72}\u{0F74}\u{0062}",
        nfkd: "\u{0061}\u{0F71}\u{0F80}\u{0F72}\u{0F74}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0F82}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0F82}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0F82}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0F82}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0F82}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F82}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0F82}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0F82}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0F82}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0F82}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0F83}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0F83}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0F83}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0F83}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0F83}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F83}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0F83}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0F83}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0F83}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0F83}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{0F84}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{0F84}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{0F84}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{0F84}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{0F84}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F84}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{0F84}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{0F84}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{0F84}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{0F84}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0F86}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0F86}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0F86}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0F86}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0F86}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F86}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0F86}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0F86}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0F86}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0F86}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{0F87}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{0F87}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{0F87}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{0F87}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{0F87}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0F87}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{0F87}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0F87}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{0F87}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0F87}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{0FC6}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{0FC6}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{0FC6}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{0FC6}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{0FC6}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0FC6}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0FC6}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0FC6}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0FC6}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0FC6}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{1037}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{1037}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{1037}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{1037}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{1037}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1037}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1037}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1037}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1037}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1037}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1039}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1039}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1039}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1039}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1039}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1039}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1039}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1039}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1039}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1039}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{103A}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{103A}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{103A}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{103A}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{103A}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{103A}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{103A}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{103A}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{103A}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{103A}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{108D}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{108D}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{108D}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{108D}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{108D}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{108D}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{108D}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{108D}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{108D}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{108D}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{135D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{135D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{135D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{135D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{135D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{135D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{135D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{135D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{135D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{135D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{135E}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{135E}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{135E}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{135E}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{135E}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{135E}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{135E}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{135E}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{135E}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{135E}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{135F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{135F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{135F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{135F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{135F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{135F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{135F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{135F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{135F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{135F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1714}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1714}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1714}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1714}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1714}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1714}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1714}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1714}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1714}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1714}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1734}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1734}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1734}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1734}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1734}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1734}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1734}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1734}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1734}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1734}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{17D2}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{17D2}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{17D2}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{17D2}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{17D2}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{17D2}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{17D2}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{17D2}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{17D2}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{17D2}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{17DD}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{17DD}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{17DD}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{17DD}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{17DD}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{17DD}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{17DD}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{17DD}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{17DD}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{17DD}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0300}\u{05AE}\u{1D16D}\u{18A9}\u{0062}",
        nfc: "\u{00E0}\u{1D16D}\u{05AE}\u{18A9}\u{0062}",
        nfd: "\u{0061}\u{1D16D}\u{05AE}\u{18A9}\u{0300}\u{0062}",
        nfkc: "\u{00E0}\u{1D16D}\u{05AE}\u{18A9}\u{0062}",
        nfkd: "\u{0061}\u{1D16D}\u{05AE}\u{18A9}\u{0300}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{18A9}\u{0300}\u{05AE}\u{1D16D}\u{0062}",
        nfc: "\u{00E0}\u{1D16D}\u{18A9}\u{05AE}\u{0062}",
        nfd: "\u{0061}\u{1D16D}\u{18A9}\u{05AE}\u{0300}\u{0062}",
        nfkc: "\u{00E0}\u{1D16D}\u{18A9}\u{05AE}\u{0062}",
        nfkd: "\u{0061}\u{1D16D}\u{18A9}\u{05AE}\u{0300}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302E}\u{059A}\u{0316}\u{1939}\u{0062}",
        nfc: "\u{0061}\u{0316}\u{059A}\u{1939}\u{302E}\u{0062}",
        nfd: "\u{0061}\u{0316}\u{059A}\u{1939}\u{302E}\u{0062}",
        nfkc: "\u{0061}\u{0316}\u{059A}\u{1939}\u{302E}\u{0062}",
        nfkd: "\u{0061}\u{0316}\u{059A}\u{1939}\u{302E}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1939}\u{302E}\u{059A}\u{0316}\u{0062}",
        nfc: "\u{0061}\u{0316}\u{1939}\u{059A}\u{302E}\u{0062}",
        nfd: "\u{0061}\u{0316}\u{1939}\u{059A}\u{302E}\u{0062}",
        nfkc: "\u{0061}\u{0316}\u{1939}\u{059A}\u{302E}\u{0062}",
        nfkd: "\u{0061}\u{0316}\u{1939}\u{059A}\u{302E}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{193A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{193A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{193A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{193A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{193A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{193A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{193A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{193A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{193A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{193A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{193B}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{193B}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{193B}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{193B}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{193B}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{193B}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{193B}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{193B}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{193B}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{193B}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1A17}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1A17}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1A17}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1A17}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1A17}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1A17}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1A17}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1A17}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1A17}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1A17}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1A18}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1A18}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1A18}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1A18}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1A18}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1A18}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1A18}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1A18}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1A18}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1A18}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1A60}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1A60}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1A60}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1A60}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1A60}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1A60}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1A60}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1A60}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1A60}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1A60}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1A75}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1A75}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1A75}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1A75}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1A75}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1A75}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1A75}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1A75}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1A75}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1A75}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1A76}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1A76}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1A76}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1A76}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1A76}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1A76}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1A76}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1A76}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1A76}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1A76}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1A77}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1A77}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1A77}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1A77}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1A77}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1A77}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1A77}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1A77}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1A77}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1A77}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1A78}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1A78}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1A78}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1A78}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1A78}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1A78}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1A78}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1A78}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1A78}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1A78}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1A79}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1A79}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1A79}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1A79}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1A79}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1A79}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1A79}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1A79}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1A79}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1A79}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1A7A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1A7A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1A7A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1A7A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1A7A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1A7A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1A7A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1A7A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1A7A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1A7A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1A7B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1A7B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1A7B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1A7B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1A7B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1A7B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1A7B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1A7B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1A7B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1A7B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1A7C}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1A7C}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1A7C}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1A7C}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1A7C}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1A7C}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1A7C}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1A7C}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1A7C}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1A7C}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1A7F}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1A7F}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1A7F}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1A7F}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1A7F}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1A7F}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1A7F}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1A7F}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1A7F}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1A7F}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1AB0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1AB0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1AB0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1AB0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1AB0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1AB0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1AB0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1AB0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1AB0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1AB0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1AB1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1AB1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1AB1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1AB1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1AB1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1AB1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1AB1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1AB1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1AB1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1AB1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1AB2}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1AB2}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1AB2}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1AB2}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1AB2}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1AB2}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1AB2}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1AB2}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1AB2}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1AB2}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1AB3}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1AB3}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1AB3}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1AB3}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1AB3}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1AB3}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1AB3}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1AB3}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1AB3}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1AB3}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1AB4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1AB4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1AB4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1AB4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1AB4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1AB4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1AB4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1AB4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1AB4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1AB4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1AB5}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1AB5}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1AB5}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1AB5}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1AB5}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1AB5}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1AB5}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1AB5}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1AB5}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1AB5}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1AB6}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1AB6}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1AB6}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1AB6}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1AB6}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1AB6}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1AB6}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1AB6}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1AB6}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1AB6}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1AB7}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1AB7}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1AB7}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1AB7}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1AB7}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1AB7}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1AB7}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1AB7}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1AB7}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1AB7}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1AB8}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1AB8}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1AB8}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1AB8}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1AB8}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1AB8}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1AB8}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1AB8}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1AB8}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1AB8}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1AB9}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1AB9}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1AB9}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1AB9}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1AB9}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1AB9}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1AB9}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1AB9}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1AB9}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1AB9}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1ABA}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1ABA}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1ABA}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1ABA}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1ABA}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1ABA}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1ABA}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1ABA}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1ABA}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1ABA}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1ABB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1ABB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1ABB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1ABB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1ABB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1ABB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1ABB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1ABB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1ABB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1ABB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1ABC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1ABC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1ABC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1ABC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1ABC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1ABC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1ABC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1ABC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1ABC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1ABC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1ABD}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1ABD}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1ABD}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1ABD}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1ABD}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1ABD}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1ABD}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1ABD}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1ABD}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1ABD}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{1B34}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{1B34}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{1B34}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{1B34}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{1B34}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1B34}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1B34}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1B34}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1B34}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1B34}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1B44}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1B44}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1B44}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1B44}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1B44}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1B44}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1B44}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1B44}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1B44}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1B44}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1B6B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1B6B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1B6B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1B6B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1B6B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1B6B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1B6B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1B6B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1B6B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1B6B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1B6C}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1B6C}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1B6C}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1B6C}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1B6C}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1B6C}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1B6C}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1B6C}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1B6C}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1B6C}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1B6D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1B6D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1B6D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1B6D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1B6D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1B6D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1B6D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1B6D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1B6D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1B6D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1B6E}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1B6E}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1B6E}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1B6E}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1B6E}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1B6E}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1B6E}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1B6E}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1B6E}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1B6E}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1B6F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1B6F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1B6F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1B6F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1B6F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1B6F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1B6F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1B6F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1B6F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1B6F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1B70}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1B70}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1B70}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1B70}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1B70}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1B70}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1B70}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1B70}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1B70}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1B70}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1B71}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1B71}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1B71}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1B71}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1B71}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1B71}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1B71}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1B71}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1B71}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1B71}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1B72}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1B72}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1B72}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1B72}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1B72}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1B72}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1B72}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1B72}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1B72}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1B72}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1B73}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1B73}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1B73}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1B73}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1B73}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1B73}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1B73}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1B73}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1B73}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1B73}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1BAA}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1BAA}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1BAA}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1BAA}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1BAA}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1BAA}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1BAA}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1BAA}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1BAA}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1BAA}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1BAB}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1BAB}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1BAB}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1BAB}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1BAB}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1BAB}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1BAB}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1BAB}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1BAB}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1BAB}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{1BE6}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{1BE6}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{1BE6}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{1BE6}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{1BE6}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1BE6}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1BE6}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1BE6}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1BE6}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1BE6}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1BF2}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1BF2}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1BF2}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1BF2}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1BF2}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1BF2}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1BF2}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1BF2}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1BF2}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1BF2}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1BF3}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1BF3}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1BF3}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1BF3}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1BF3}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1BF3}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1BF3}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1BF3}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1BF3}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1BF3}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{1C37}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{1C37}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{1C37}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{1C37}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{1C37}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1C37}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1C37}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1C37}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1C37}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1C37}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1CD0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1CD0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1CD0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1CD0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1CD0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CD0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1CD0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1CD0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1CD0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1CD0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1CD1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1CD1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1CD1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1CD1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1CD1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CD1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1CD1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1CD1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1CD1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1CD1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1CD2}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1CD2}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1CD2}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1CD2}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1CD2}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CD2}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1CD2}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1CD2}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1CD2}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1CD2}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{1CD4}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1CD4}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1CD4}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1CD4}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1CD4}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CD4}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{1CD4}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{1CD4}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{1CD4}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{1CD4}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1CD5}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1CD5}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1CD5}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1CD5}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1CD5}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CD5}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1CD5}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1CD5}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1CD5}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1CD5}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1CD6}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1CD6}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1CD6}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1CD6}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1CD6}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CD6}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1CD6}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1CD6}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1CD6}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1CD6}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1CD7}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1CD7}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1CD7}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1CD7}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1CD7}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CD7}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1CD7}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1CD7}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1CD7}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1CD7}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1CD8}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1CD8}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1CD8}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1CD8}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1CD8}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CD8}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1CD8}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1CD8}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1CD8}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1CD8}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1CD9}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1CD9}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1CD9}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1CD9}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1CD9}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CD9}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1CD9}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1CD9}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1CD9}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1CD9}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1CDA}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1CDA}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1CDA}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1CDA}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1CDA}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CDA}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1CDA}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1CDA}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1CDA}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1CDA}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1CDB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1CDB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1CDB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1CDB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1CDB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CDB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1CDB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1CDB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1CDB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1CDB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1CDC}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1CDC}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1CDC}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1CDC}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1CDC}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CDC}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1CDC}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1CDC}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1CDC}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1CDC}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1CDD}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1CDD}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1CDD}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1CDD}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1CDD}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CDD}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1CDD}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1CDD}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1CDD}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1CDD}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1CDE}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1CDE}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1CDE}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1CDE}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1CDE}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CDE}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1CDE}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1CDE}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1CDE}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1CDE}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1CDF}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1CDF}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1CDF}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1CDF}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1CDF}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CDF}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1CDF}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1CDF}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1CDF}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1CDF}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1CE0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1CE0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1CE0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1CE0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1CE0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CE0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1CE0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1CE0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1CE0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1CE0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{1CE2}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1CE2}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1CE2}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1CE2}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1CE2}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CE2}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{1CE2}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{1CE2}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{1CE2}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{1CE2}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{1CE3}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1CE3}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1CE3}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1CE3}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1CE3}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CE3}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{1CE3}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{1CE3}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{1CE3}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{1CE3}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{1CE4}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1CE4}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1CE4}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1CE4}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1CE4}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CE4}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{1CE4}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{1CE4}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{1CE4}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{1CE4}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{1CE5}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1CE5}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1CE5}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1CE5}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1CE5}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CE5}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{1CE5}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{1CE5}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{1CE5}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{1CE5}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{1CE6}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1CE6}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1CE6}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1CE6}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1CE6}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CE6}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{1CE6}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{1CE6}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{1CE6}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{1CE6}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{1CE7}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1CE7}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1CE7}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1CE7}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1CE7}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CE7}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{1CE7}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{1CE7}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{1CE7}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{1CE7}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{1CE8}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1CE8}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1CE8}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1CE8}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1CE8}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CE8}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{1CE8}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{1CE8}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{1CE8}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{1CE8}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1CED}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1CED}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1CED}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1CED}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1CED}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CED}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1CED}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1CED}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1CED}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1CED}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1CF4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1CF4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1CF4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1CF4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1CF4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CF4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1CF4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1CF4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1CF4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1CF4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1CF8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1CF8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1CF8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1CF8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1CF8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CF8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1CF8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1CF8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1CF8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1CF8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1CF9}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1CF9}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1CF9}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1CF9}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1CF9}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1CF9}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1CF9}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1CF9}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1CF9}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1CF9}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DC0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DC0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DC0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DC0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DC0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DC0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DC0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DC0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DC0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DC0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DC1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DC1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DC1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DC1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DC1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DC1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DC1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DC1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DC1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DC1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1DC2}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1DC2}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1DC2}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1DC2}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1DC2}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DC2}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1DC2}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1DC2}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1DC2}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1DC2}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DC3}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DC3}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DC3}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DC3}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DC3}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DC3}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DC3}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DC3}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DC3}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DC3}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DC4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DC4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DC4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DC4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DC4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DC4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DC4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DC4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DC4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DC4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DC5}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DC5}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DC5}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DC5}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DC5}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DC5}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DC5}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DC5}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DC5}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DC5}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DC6}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DC6}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DC6}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DC6}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DC6}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DC6}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DC6}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DC6}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DC6}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DC6}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DC7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DC7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DC7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DC7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DC7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DC7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DC7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DC7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DC7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DC7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DC8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DC8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DC8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DC8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DC8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DC8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DC8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DC8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DC8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DC8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DC9}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DC9}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DC9}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DC9}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DC9}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DC9}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DC9}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DC9}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DC9}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DC9}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1DCA}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1DCA}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1DCA}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1DCA}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1DCA}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DCA}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1DCA}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1DCA}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1DCA}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1DCA}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DCB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DCB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DCB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DCB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DCB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DCB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DCB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DCB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DCB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DCB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DCC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DCC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DCC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DCC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DCC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DCC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DCC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DCC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DCC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DCC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0345}\u{035D}\u{035C}\u{1DCD}\u{0062}",
        nfc: "\u{0061}\u{035C}\u{035D}\u{1DCD}\u{0345}\u{0062}",
        nfd: "\u{0061}\u{035C}\u{035D}\u{1DCD}\u{0345}\u{0062}",
        nfkc: "\u{0061}\u{035C}\u{035D}\u{1DCD}\u{0345}\u{0062}",
        nfkd: "\u{0061}\u{035C}\u{035D}\u{1DCD}\u{0345}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DCD}\u{0345}\u{035D}\u{035C}\u{0062}",
        nfc: "\u{0061}\u{035C}\u{1DCD}\u{035D}\u{0345}\u{0062}",
        nfd: "\u{0061}\u{035C}\u{1DCD}\u{035D}\u{0345}\u{0062}",
        nfkc: "\u{0061}\u{035C}\u{1DCD}\u{035D}\u{0345}\u{0062}",
        nfkd: "\u{0061}\u{035C}\u{1DCD}\u{035D}\u{0345}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{031B}\u{1DCE}\u{0321}\u{1DCE}\u{0062}",
        nfc: "\u{0061}\u{0321}\u{1DCE}\u{1DCE}\u{031B}\u{0062}",
        nfd: "\u{0061}\u{0321}\u{1DCE}\u{1DCE}\u{031B}\u{0062}",
        nfkc: "\u{0061}\u{0321}\u{1DCE}\u{1DCE}\u{031B}\u{0062}",
        nfkd: "\u{0061}\u{0321}\u{1DCE}\u{1DCE}\u{031B}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DCE}\u{031B}\u{1DCE}\u{0321}\u{0062}",
        nfc: "\u{0061}\u{0321}\u{1DCE}\u{1DCE}\u{031B}\u{0062}",
        nfd: "\u{0061}\u{0321}\u{1DCE}\u{1DCE}\u{031B}\u{0062}",
        nfkc: "\u{0061}\u{0321}\u{1DCE}\u{1DCE}\u{031B}\u{0062}",
        nfkd: "\u{0061}\u{0321}\u{1DCE}\u{1DCE}\u{031B}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1DCF}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1DCF}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1DCF}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1DCF}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1DCF}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DCF}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1DCF}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1DCF}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1DCF}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1DCF}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DCE}\u{0321}\u{0F74}\u{1DD0}\u{0062}",
        nfc: "\u{0061}\u{0F74}\u{0321}\u{1DD0}\u{1DCE}\u{0062}",
        nfd: "\u{0061}\u{0F74}\u{0321}\u{1DD0}\u{1DCE}\u{0062}",
        nfkc: "\u{0061}\u{0F74}\u{0321}\u{1DD0}\u{1DCE}\u{0062}",
        nfkd: "\u{0061}\u{0F74}\u{0321}\u{1DD0}\u{1DCE}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DD0}\u{1DCE}\u{0321}\u{0F74}\u{0062}",
        nfc: "\u{0061}\u{0F74}\u{1DD0}\u{0321}\u{1DCE}\u{0062}",
        nfd: "\u{0061}\u{0F74}\u{1DD0}\u{0321}\u{1DCE}\u{0062}",
        nfkc: "\u{0061}\u{0F74}\u{1DD0}\u{0321}\u{1DCE}\u{0062}",
        nfkd: "\u{0061}\u{0F74}\u{1DD0}\u{0321}\u{1DCE}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DD1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DD1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DD1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DD1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DD1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DD1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DD1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DD1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DD1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DD1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DD2}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DD2}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DD2}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DD2}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DD2}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DD2}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DD2}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DD2}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DD2}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DD2}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DD3}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DD3}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DD3}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DD3}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DD3}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DD3}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DD3}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DD3}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DD3}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DD3}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DD4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DD4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DD4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DD4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DD4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DD4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DD4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DD4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DD4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DD4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DD5}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DD5}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DD5}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DD5}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DD5}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DD5}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DD5}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DD5}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DD5}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DD5}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DD6}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DD6}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DD6}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DD6}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DD6}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DD6}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DD6}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DD6}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DD6}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DD6}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DD7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DD7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DD7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DD7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DD7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DD7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DD7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DD7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DD7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DD7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DD8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DD8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DD8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DD8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DD8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DD8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DD8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DD8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DD8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DD8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DD9}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DD9}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DD9}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DD9}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DD9}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DD9}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DD9}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DD9}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DD9}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DD9}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DDA}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DDA}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DDA}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DDA}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DDA}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DDA}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DDA}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DDA}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DDA}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DDA}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DDB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DDB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DDB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DDB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DDB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DDB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DDB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DDB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DDB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DDB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DDC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DDC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DDC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DDC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DDC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DDC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DDC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DDC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DDC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DDC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DDD}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DDD}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DDD}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DDD}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DDD}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DDD}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DDD}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DDD}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DDD}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DDD}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DDE}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DDE}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DDE}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DDE}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DDE}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DDE}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DDE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DDE}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DDE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DDE}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DDF}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DDF}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DDF}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DDF}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DDF}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DDF}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DDF}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DDF}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DDF}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DDF}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DE0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DE0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DE0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DE0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DE0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DE0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DE0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DE0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DE0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DE0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DE1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DE1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DE1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DE1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DE1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DE1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DE1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DE1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DE1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DE1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DE2}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DE2}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DE2}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DE2}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DE2}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DE2}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DE2}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DE2}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DE2}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DE2}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DE3}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DE3}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DE3}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DE3}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DE3}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DE3}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DE3}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DE3}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DE3}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DE3}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DE4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DE4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DE4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DE4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DE4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DE4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DE4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DE4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DE4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DE4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DE5}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DE5}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DE5}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DE5}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DE5}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DE5}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DE5}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DE5}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DE5}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DE5}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DE6}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DE6}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DE6}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DE6}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DE6}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DE6}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DE6}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DE6}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DE6}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DE6}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DE7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DE7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DE7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DE7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DE7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DE7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DE7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DE7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DE7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DE7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DE8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DE8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DE8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DE8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DE8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DE8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DE8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DE8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DE8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DE8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DE9}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DE9}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DE9}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DE9}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DE9}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DE9}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DE9}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DE9}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DE9}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DE9}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DEA}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DEA}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DEA}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DEA}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DEA}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DEA}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DEA}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DEA}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DEA}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DEA}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DEB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DEB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DEB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DEB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DEB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DEB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DEB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DEB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DEB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DEB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DEC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DEC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DEC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DEC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DEC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DEC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DEC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DEC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DEC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DEC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DED}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DED}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DED}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DED}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DED}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DED}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DED}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DED}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DED}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DED}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DEE}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DEE}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DEE}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DEE}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DEE}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DEE}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DEE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DEE}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DEE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DEE}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DEF}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DEF}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DEF}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DEF}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DEF}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DEF}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DEF}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DEF}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DEF}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DEF}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DF0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DF0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DF0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DF0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DF0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DF0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DF0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DF0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DF0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DF0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DF1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DF1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DF1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DF1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DF1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DF1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DF1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DF1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DF1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DF1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DF2}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DF2}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DF2}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DF2}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DF2}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DF2}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DF2}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DF2}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DF2}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DF2}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DF3}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DF3}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DF3}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DF3}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DF3}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DF3}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DF3}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DF3}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DF3}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DF3}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DF4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DF4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DF4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DF4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DF4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DF4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DF4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DF4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DF4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DF4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DF5}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DF5}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DF5}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DF5}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DF5}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DF5}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DF5}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DF5}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DF5}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DF5}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DFB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DFB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DFB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DFB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DFB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DFB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DFB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DFB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DFB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DFB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035D}\u{035C}\u{0315}\u{1DFC}\u{0062}",
        nfc: "\u{0061}\u{0315}\u{035C}\u{1DFC}\u{035D}\u{0062}",
        nfd: "\u{0061}\u{0315}\u{035C}\u{1DFC}\u{035D}\u{0062}",
        nfkc: "\u{0061}\u{0315}\u{035C}\u{1DFC}\u{035D}\u{0062}",
        nfkd: "\u{0061}\u{0315}\u{035C}\u{1DFC}\u{035D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DFC}\u{035D}\u{035C}\u{0315}\u{0062}",
        nfc: "\u{0061}\u{0315}\u{1DFC}\u{035C}\u{035D}\u{0062}",
        nfd: "\u{0061}\u{0315}\u{1DFC}\u{035C}\u{035D}\u{0062}",
        nfkc: "\u{0061}\u{0315}\u{1DFC}\u{035C}\u{035D}\u{0062}",
        nfkd: "\u{0061}\u{0315}\u{1DFC}\u{035C}\u{035D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1DFD}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1DFD}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1DFD}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1DFD}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1DFD}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DFD}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1DFD}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1DFD}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1DFD}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1DFD}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1DFE}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1DFE}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1DFE}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1DFE}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1DFE}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DFE}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1DFE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1DFE}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1DFE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1DFE}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1DFF}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1DFF}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1DFF}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1DFF}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1DFF}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1DFF}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1DFF}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1DFF}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1DFF}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1DFF}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{20D0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{20D0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{20D0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{20D0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{20D0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20D0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{20D0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{20D0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{20D0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{20D0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{20D1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{20D1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{20D1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{20D1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{20D1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20D1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{20D1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{20D1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{20D1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{20D1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{20D2}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{20D2}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{20D2}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{20D2}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{20D2}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20D2}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{20D2}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{20D2}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{20D2}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{20D2}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{20D3}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{20D3}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{20D3}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{20D3}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{20D3}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20D3}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{20D3}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{20D3}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{20D3}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{20D3}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{20D4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{20D4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{20D4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{20D4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{20D4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20D4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{20D4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{20D4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{20D4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{20D4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{20D5}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{20D5}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{20D5}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{20D5}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{20D5}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20D5}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{20D5}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{20D5}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{20D5}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{20D5}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{20D6}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{20D6}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{20D6}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{20D6}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{20D6}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20D6}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{20D6}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{20D6}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{20D6}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{20D6}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{20D7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{20D7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{20D7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{20D7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{20D7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20D7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{20D7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{20D7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{20D7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{20D7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{20D8}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{20D8}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{20D8}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{20D8}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{20D8}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20D8}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{20D8}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{20D8}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{20D8}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{20D8}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{20D9}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{20D9}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{20D9}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{20D9}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{20D9}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20D9}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{20D9}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{20D9}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{20D9}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{20D9}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{20DA}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{20DA}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{20DA}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{20DA}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{20DA}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20DA}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{20DA}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{20DA}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{20DA}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{20DA}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{20DB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{20DB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{20DB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{20DB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{20DB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20DB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{20DB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{20DB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{20DB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{20DB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{20DC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{20DC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{20DC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{20DC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{20DC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20DC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{20DC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{20DC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{20DC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{20DC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{20E1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{20E1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{20E1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{20E1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{20E1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20E1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{20E1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{20E1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{20E1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{20E1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{20E5}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{20E5}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{20E5}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{20E5}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{20E5}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20E5}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{20E5}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{20E5}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{20E5}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{20E5}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{20E6}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{20E6}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{20E6}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{20E6}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{20E6}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20E6}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{20E6}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{20E6}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{20E6}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{20E6}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{20E7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{20E7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{20E7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{20E7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{20E7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20E7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{20E7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{20E7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{20E7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{20E7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{20E8}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{20E8}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{20E8}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{20E8}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{20E8}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20E8}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{20E8}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{20E8}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{20E8}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{20E8}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{20E9}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{20E9}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{20E9}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{20E9}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{20E9}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20E9}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{20E9}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{20E9}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{20E9}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{20E9}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{20EA}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{20EA}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{20EA}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{20EA}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{20EA}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20EA}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{20EA}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{20EA}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{20EA}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{20EA}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{20EB}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{20EB}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{20EB}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{20EB}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{20EB}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20EB}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{20EB}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{20EB}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{20EB}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{20EB}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{20EC}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{20EC}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{20EC}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{20EC}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{20EC}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20EC}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{20EC}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{20EC}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{20EC}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{20EC}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{20ED}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{20ED}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{20ED}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{20ED}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{20ED}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20ED}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{20ED}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{20ED}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{20ED}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{20ED}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{20EE}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{20EE}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{20EE}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{20EE}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{20EE}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20EE}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{20EE}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{20EE}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{20EE}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{20EE}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{20EF}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{20EF}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{20EF}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{20EF}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{20EF}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20EF}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{20EF}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{20EF}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{20EF}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{20EF}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{20F0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{20F0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{20F0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{20F0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{20F0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{20F0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{20F0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{20F0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{20F0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{20F0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2CEF}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2CEF}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2CEF}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2CEF}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2CEF}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2CEF}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2CEF}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2CEF}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2CEF}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2CEF}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2CF0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2CF0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2CF0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2CF0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2CF0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2CF0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2CF0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2CF0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2CF0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2CF0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2CF1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2CF1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2CF1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2CF1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2CF1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2CF1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2CF1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2CF1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2CF1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2CF1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{2D7F}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{2D7F}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{2D7F}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{2D7F}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{2D7F}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2D7F}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{2D7F}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{2D7F}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{2D7F}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{2D7F}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DE0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DE0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DE0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DE0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DE0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DE0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DE0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DE0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DE0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DE0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DE1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DE1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DE1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DE1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DE1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DE1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DE1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DE1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DE1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DE1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DE2}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DE2}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DE2}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DE2}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DE2}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DE2}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DE2}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DE2}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DE2}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DE2}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DE3}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DE3}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DE3}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DE3}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DE3}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DE3}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DE3}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DE3}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DE3}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DE3}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DE4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DE4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DE4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DE4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DE4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DE4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DE4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DE4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DE4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DE4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DE5}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DE5}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DE5}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DE5}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DE5}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DE5}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DE5}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DE5}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DE5}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DE5}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DE6}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DE6}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DE6}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DE6}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DE6}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DE6}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DE6}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DE6}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DE6}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DE6}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DE7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DE7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DE7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DE7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DE7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DE7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DE7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DE7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DE7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DE7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DE8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DE8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DE8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DE8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DE8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DE8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DE8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DE8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DE8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DE8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DE9}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DE9}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DE9}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DE9}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DE9}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DE9}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DE9}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DE9}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DE9}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DE9}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DEA}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DEA}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DEA}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DEA}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DEA}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DEA}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DEA}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DEA}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DEA}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DEA}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DEB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DEB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DEB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DEB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DEB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DEB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DEB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DEB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DEB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DEB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DEC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DEC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DEC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DEC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DEC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DEC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DEC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DEC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DEC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DEC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DED}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DED}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DED}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DED}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DED}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DED}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DED}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DED}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DED}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DED}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DEE}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DEE}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DEE}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DEE}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DEE}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DEE}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DEE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DEE}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DEE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DEE}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DEF}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DEF}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DEF}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DEF}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DEF}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DEF}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DEF}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DEF}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DEF}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DEF}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DF0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DF0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DF0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DF0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DF0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DF0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DF0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DF0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DF0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DF0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DF1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DF1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DF1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DF1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DF1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DF1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DF1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DF1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DF1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DF1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DF2}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DF2}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DF2}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DF2}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DF2}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DF2}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DF2}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DF2}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DF2}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DF2}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DF3}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DF3}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DF3}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DF3}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DF3}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DF3}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DF3}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DF3}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DF3}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DF3}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DF4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DF4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DF4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DF4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DF4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DF4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DF4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DF4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DF4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DF4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DF5}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DF5}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DF5}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DF5}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DF5}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DF5}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DF5}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DF5}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DF5}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DF5}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DF6}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DF6}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DF6}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DF6}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DF6}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DF6}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DF6}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DF6}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DF6}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DF6}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DF7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DF7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DF7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DF7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DF7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DF7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DF7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DF7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DF7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DF7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DF8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DF8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DF8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DF8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DF8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DF8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DF8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DF8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DF8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DF8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DF9}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DF9}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DF9}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DF9}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DF9}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DF9}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DF9}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DF9}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DF9}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DF9}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DFA}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DFA}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DFA}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DFA}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DFA}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DFA}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DFA}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DFA}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DFA}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DFA}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DFB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DFB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DFB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DFB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DFB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DFB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DFB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DFB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DFB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DFB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DFC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DFC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DFC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DFC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DFC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DFC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DFC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DFC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DFC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DFC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DFD}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DFD}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DFD}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DFD}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DFD}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DFD}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DFD}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DFD}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DFD}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DFD}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DFE}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DFE}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DFE}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DFE}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DFE}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DFE}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DFE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DFE}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DFE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DFE}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{2DFF}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{2DFF}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{2DFF}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{2DFF}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{2DFF}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{2DFF}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{2DFF}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{2DFF}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{2DFF}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{2DFF}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0316}\u{302A}\u{031B}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{031B}\u{302A}\u{302A}\u{0316}\u{0062}",
        nfd: "\u{0061}\u{031B}\u{302A}\u{302A}\u{0316}\u{0062}",
        nfkc: "\u{0061}\u{031B}\u{302A}\u{302A}\u{0316}\u{0062}",
        nfkd: "\u{0061}\u{031B}\u{302A}\u{302A}\u{0316}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302A}\u{0316}\u{302A}\u{031B}\u{0062}",
        nfc: "\u{0061}\u{031B}\u{302A}\u{302A}\u{0316}\u{0062}",
        nfd: "\u{0061}\u{031B}\u{302A}\u{302A}\u{0316}\u{0062}",
        nfkc: "\u{0061}\u{031B}\u{302A}\u{302A}\u{0316}\u{0062}",
        nfkd: "\u{0061}\u{031B}\u{302A}\u{302A}\u{0316}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0300}\u{05AE}\u{1D16D}\u{302B}\u{0062}",
        nfc: "\u{00E0}\u{1D16D}\u{05AE}\u{302B}\u{0062}",
        nfd: "\u{0061}\u{1D16D}\u{05AE}\u{302B}\u{0300}\u{0062}",
        nfkc: "\u{00E0}\u{1D16D}\u{05AE}\u{302B}\u{0062}",
        nfkd: "\u{0061}\u{1D16D}\u{05AE}\u{302B}\u{0300}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302B}\u{0300}\u{05AE}\u{1D16D}\u{0062}",
        nfc: "\u{00E0}\u{1D16D}\u{302B}\u{05AE}\u{0062}",
        nfd: "\u{0061}\u{1D16D}\u{302B}\u{05AE}\u{0300}\u{0062}",
        nfkc: "\u{00E0}\u{1D16D}\u{302B}\u{05AE}\u{0062}",
        nfkd: "\u{0061}\u{1D16D}\u{302B}\u{05AE}\u{0300}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{035C}\u{0315}\u{0300}\u{302C}\u{0062}",
        nfc: "\u{00E0}\u{0315}\u{302C}\u{035C}\u{0062}",
        nfd: "\u{0061}\u{0300}\u{0315}\u{302C}\u{035C}\u{0062}",
        nfkc: "\u{00E0}\u{0315}\u{302C}\u{035C}\u{0062}",
        nfkd: "\u{0061}\u{0300}\u{0315}\u{302C}\u{035C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302C}\u{035C}\u{0315}\u{0300}\u{0062}",
        nfc: "\u{00E0}\u{302C}\u{0315}\u{035C}\u{0062}",
        nfd: "\u{0061}\u{0300}\u{302C}\u{0315}\u{035C}\u{0062}",
        nfkc: "\u{00E0}\u{302C}\u{0315}\u{035C}\u{0062}",
        nfkd: "\u{0061}\u{0300}\u{302C}\u{0315}\u{035C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302E}\u{059A}\u{0316}\u{302D}\u{0062}",
        nfc: "\u{0061}\u{0316}\u{059A}\u{302D}\u{302E}\u{0062}",
        nfd: "\u{0061}\u{0316}\u{059A}\u{302D}\u{302E}\u{0062}",
        nfkc: "\u{0061}\u{0316}\u{059A}\u{302D}\u{302E}\u{0062}",
        nfkd: "\u{0061}\u{0316}\u{059A}\u{302D}\u{302E}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302D}\u{302E}\u{059A}\u{0316}\u{0062}",
        nfc: "\u{0061}\u{0316}\u{302D}\u{059A}\u{302E}\u{0062}",
        nfd: "\u{0061}\u{0316}\u{302D}\u{059A}\u{302E}\u{0062}",
        nfkc: "\u{0061}\u{0316}\u{302D}\u{059A}\u{302E}\u{0062}",
        nfkd: "\u{0061}\u{0316}\u{302D}\u{059A}\u{302E}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D16D}\u{302E}\u{059A}\u{302E}\u{0062}",
        nfc: "\u{0061}\u{059A}\u{302E}\u{302E}\u{1D16D}\u{0062}",
        nfd: "\u{0061}\u{059A}\u{302E}\u{302E}\u{1D16D}\u{0062}",
        nfkc: "\u{0061}\u{059A}\u{302E}\u{302E}\u{1D16D}\u{0062}",
        nfkd: "\u{0061}\u{059A}\u{302E}\u{302E}\u{1D16D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302E}\u{1D16D}\u{302E}\u{059A}\u{0062}",
        nfc: "\u{0061}\u{059A}\u{302E}\u{302E}\u{1D16D}\u{0062}",
        nfd: "\u{0061}\u{059A}\u{302E}\u{302E}\u{1D16D}\u{0062}",
        nfkc: "\u{0061}\u{059A}\u{302E}\u{302E}\u{1D16D}\u{0062}",
        nfkd: "\u{0061}\u{059A}\u{302E}\u{302E}\u{1D16D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D16D}\u{302E}\u{059A}\u{302F}\u{0062}",
        nfc: "\u{0061}\u{059A}\u{302E}\u{302F}\u{1D16D}\u{0062}",
        nfd: "\u{0061}\u{059A}\u{302E}\u{302F}\u{1D16D}\u{0062}",
        nfkc: "\u{0061}\u{059A}\u{302E}\u{302F}\u{1D16D}\u{0062}",
        nfkd: "\u{0061}\u{059A}\u{302E}\u{302F}\u{1D16D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302F}\u{1D16D}\u{302E}\u{059A}\u{0062}",
        nfc: "\u{0061}\u{059A}\u{302F}\u{302E}\u{1D16D}\u{0062}",
        nfd: "\u{0061}\u{059A}\u{302F}\u{302E}\u{1D16D}\u{0062}",
        nfkc: "\u{0061}\u{059A}\u{302F}\u{302E}\u{1D16D}\u{0062}",
        nfkd: "\u{0061}\u{059A}\u{302F}\u{302E}\u{1D16D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{094D}\u{3099}\u{093C}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{093C}\u{3099}\u{3099}\u{094D}\u{0062}",
        nfd: "\u{0061}\u{093C}\u{3099}\u{3099}\u{094D}\u{0062}",
        nfkc: "\u{0061}\u{093C}\u{3099}\u{3099}\u{094D}\u{0062}",
        nfkd: "\u{0061}\u{093C}\u{3099}\u{3099}\u{094D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{094D}\u{3099}\u{093C}\u{0062}",
        nfc: "\u{0061}\u{093C}\u{3099}\u{3099}\u{094D}\u{0062}",
        nfd: "\u{0061}\u{093C}\u{3099}\u{3099}\u{094D}\u{0062}",
        nfkc: "\u{0061}\u{093C}\u{3099}\u{3099}\u{094D}\u{0062}",
        nfkd: "\u{0061}\u{093C}\u{3099}\u{3099}\u{094D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{094D}\u{3099}\u{093C}\u{309A}\u{0062}",
        nfc: "\u{0061}\u{093C}\u{3099}\u{309A}\u{094D}\u{0062}",
        nfd: "\u{0061}\u{093C}\u{3099}\u{309A}\u{094D}\u{0062}",
        nfkc: "\u{0061}\u{093C}\u{3099}\u{309A}\u{094D}\u{0062}",
        nfkd: "\u{0061}\u{093C}\u{3099}\u{309A}\u{094D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{309A}\u{094D}\u{3099}\u{093C}\u{0062}",
        nfc: "\u{0061}\u{093C}\u{309A}\u{3099}\u{094D}\u{0062}",
        nfd: "\u{0061}\u{093C}\u{309A}\u{3099}\u{094D}\u{0062}",
        nfkc: "\u{0061}\u{093C}\u{309A}\u{3099}\u{094D}\u{0062}",
        nfkd: "\u{0061}\u{093C}\u{309A}\u{3099}\u{094D}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A66F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A66F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A66F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A66F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A66F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A66F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A66F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A66F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A66F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A66F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A674}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A674}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A674}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A674}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A674}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A674}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A674}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A674}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A674}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A674}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A675}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A675}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A675}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A675}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A675}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A675}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A675}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A675}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A675}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A675}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A676}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A676}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A676}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A676}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A676}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A676}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A676}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A676}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A676}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A676}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A677}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A677}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A677}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A677}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A677}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A677}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A677}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A677}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A677}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A677}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A678}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A678}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A678}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A678}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A678}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A678}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A678}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A678}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A678}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A678}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A679}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A679}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A679}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A679}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A679}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A679}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A679}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A679}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A679}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A679}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A67A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A67A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A67A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A67A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A67A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A67A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A67A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A67A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A67A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A67A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A67B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A67B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A67B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A67B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A67B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A67B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A67B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A67B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A67B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A67B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A67C}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A67C}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A67C}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A67C}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A67C}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A67C}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A67C}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A67C}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A67C}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A67C}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A67D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A67D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A67D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A67D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A67D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A67D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A67D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A67D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A67D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A67D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A69E}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A69E}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A69E}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A69E}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A69E}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A69E}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A69E}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A69E}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A69E}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A69E}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A69F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A69F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A69F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A69F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A69F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A69F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A69F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A69F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A69F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A69F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A6F0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A6F0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A6F0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A6F0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A6F0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A6F0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A6F0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A6F0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A6F0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A6F0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A6F1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A6F1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A6F1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A6F1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A6F1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A6F1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A6F1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A6F1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A6F1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A6F1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{A806}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{A806}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{A806}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{A806}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{A806}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A806}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{A806}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{A806}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{A806}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{A806}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{A8C4}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{A8C4}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{A8C4}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{A8C4}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{A8C4}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8C4}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{A8C4}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{A8C4}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{A8C4}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{A8C4}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8E0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8E0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8E0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8E0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8E0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8E0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8E0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8E0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8E0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8E0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8E1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8E1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8E1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8E1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8E1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8E1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8E1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8E1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8E1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8E1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8E2}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8E2}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8E2}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8E2}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8E2}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8E2}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8E2}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8E2}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8E2}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8E2}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8E3}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8E3}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8E3}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8E3}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8E3}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8E3}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8E3}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8E3}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8E3}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8E3}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8E4}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8E4}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8E4}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8E4}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8E4}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8E4}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8E4}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8E4}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8E4}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8E4}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8E5}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8E5}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8E5}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8E5}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8E5}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8E5}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8E5}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8E5}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8E5}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8E5}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8E6}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8E6}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8E6}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8E6}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8E6}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8E6}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8E6}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8E6}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8E6}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8E6}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8E7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8E7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8E7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8E7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8E7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8E7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8E7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8E7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8E7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8E7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8E8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8E8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8E8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8E8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8E8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8E8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8E8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8E8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8E8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8E8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8E9}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8E9}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8E9}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8E9}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8E9}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8E9}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8E9}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8E9}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8E9}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8E9}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8EA}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8EA}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8EA}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8EA}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8EA}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8EA}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8EA}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8EA}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8EA}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8EA}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8EB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8EB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8EB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8EB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8EB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8EB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8EB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8EB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8EB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8EB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8EC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8EC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8EC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8EC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8EC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8EC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8EC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8EC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8EC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8EC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8ED}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8ED}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8ED}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8ED}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8ED}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8ED}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8ED}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8ED}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8ED}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8ED}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8EE}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8EE}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8EE}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8EE}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8EE}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8EE}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8EE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8EE}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8EE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8EE}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8EF}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8EF}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8EF}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8EF}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8EF}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8EF}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8EF}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8EF}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8EF}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8EF}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8F0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8F0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8F0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8F0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8F0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8F0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8F0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8F0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8F0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8F0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{A8F1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{A8F1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{A8F1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{A8F1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{A8F1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A8F1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{A8F1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{A8F1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{A8F1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{A8F1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{A92B}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{A92B}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{A92B}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{A92B}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{A92B}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A92B}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{A92B}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{A92B}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{A92B}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{A92B}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{A92C}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{A92C}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{A92C}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{A92C}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{A92C}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A92C}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{A92C}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{A92C}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{A92C}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{A92C}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{A92D}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{A92D}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{A92D}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{A92D}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{A92D}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A92D}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{A92D}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{A92D}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{A92D}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{A92D}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{A953}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{A953}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{A953}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{A953}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{A953}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A953}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{A953}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{A953}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{A953}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{A953}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{A9B3}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{A9B3}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{A9B3}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{A9B3}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{A9B3}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A9B3}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{A9B3}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{A9B3}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{A9B3}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{A9B3}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{A9C0}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{A9C0}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{A9C0}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{A9C0}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{A9C0}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{A9C0}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{A9C0}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{A9C0}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{A9C0}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{A9C0}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{AAB0}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{AAB0}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{AAB0}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{AAB0}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{AAB0}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{AAB0}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{AAB0}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{AAB0}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{AAB0}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{AAB0}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{AAB2}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{AAB2}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{AAB2}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{AAB2}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{AAB2}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{AAB2}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{AAB2}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{AAB2}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{AAB2}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{AAB2}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{AAB3}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{AAB3}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{AAB3}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{AAB3}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{AAB3}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{AAB3}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{AAB3}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{AAB3}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{AAB3}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{AAB3}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{AAB4}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{AAB4}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{AAB4}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{AAB4}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{AAB4}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{AAB4}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{AAB4}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{AAB4}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{AAB4}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{AAB4}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{AAB7}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{AAB7}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{AAB7}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{AAB7}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{AAB7}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{AAB7}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{AAB7}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{AAB7}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{AAB7}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{AAB7}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{AAB8}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{AAB8}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{AAB8}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{AAB8}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{AAB8}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{AAB8}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{AAB8}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{AAB8}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{AAB8}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{AAB8}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{AABE}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{AABE}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{AABE}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{AABE}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{AABE}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{AABE}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{AABE}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{AABE}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{AABE}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{AABE}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{AABF}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{AABF}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{AABF}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{AABF}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{AABF}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{AABF}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{AABF}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{AABF}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{AABF}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{AABF}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{AAC1}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{AAC1}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{AAC1}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{AAC1}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{AAC1}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{AAC1}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{AAC1}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{AAC1}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{AAC1}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{AAC1}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{AAF6}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{AAF6}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{AAF6}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{AAF6}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{AAF6}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{AAF6}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{AAF6}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{AAF6}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{AAF6}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{AAF6}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{ABED}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{ABED}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{ABED}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{ABED}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{ABED}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{ABED}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{ABED}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{ABED}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{ABED}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{ABED}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{064B}\u{FB1E}\u{05C2}\u{FB1E}\u{0062}",
        nfc: "\u{0061}\u{05C2}\u{FB1E}\u{FB1E}\u{064B}\u{0062}",
        nfd: "\u{0061}\u{05C2}\u{FB1E}\u{FB1E}\u{064B}\u{0062}",
        nfkc: "\u{0061}\u{05C2}\u{FB1E}\u{FB1E}\u{064B}\u{0062}",
        nfkd: "\u{0061}\u{05C2}\u{FB1E}\u{FB1E}\u{064B}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FB1E}\u{064B}\u{FB1E}\u{05C2}\u{0062}",
        nfc: "\u{0061}\u{05C2}\u{FB1E}\u{FB1E}\u{064B}\u{0062}",
        nfd: "\u{0061}\u{05C2}\u{FB1E}\u{FB1E}\u{064B}\u{0062}",
        nfkc: "\u{0061}\u{05C2}\u{FB1E}\u{FB1E}\u{064B}\u{0062}",
        nfkd: "\u{0061}\u{05C2}\u{FB1E}\u{FB1E}\u{064B}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{FE20}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{FE20}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{FE20}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{FE20}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{FE20}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE20}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{FE20}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{FE20}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{FE20}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{FE20}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{FE21}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{FE21}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{FE21}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{FE21}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{FE21}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE21}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{FE21}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{FE21}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{FE21}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{FE21}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{FE22}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{FE22}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{FE22}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{FE22}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{FE22}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE22}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{FE22}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{FE22}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{FE22}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{FE22}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{FE23}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{FE23}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{FE23}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{FE23}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{FE23}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE23}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{FE23}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{FE23}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{FE23}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{FE23}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{FE24}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{FE24}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{FE24}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{FE24}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{FE24}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE24}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{FE24}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{FE24}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{FE24}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{FE24}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{FE25}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{FE25}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{FE25}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{FE25}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{FE25}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE25}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{FE25}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{FE25}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{FE25}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{FE25}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{FE26}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{FE26}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{FE26}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{FE26}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{FE26}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE26}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{FE26}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{FE26}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{FE26}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{FE26}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{FE27}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{FE27}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{FE27}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{FE27}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{FE27}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE27}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{FE27}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{FE27}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{FE27}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{FE27}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{FE28}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{FE28}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{FE28}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{FE28}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{FE28}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE28}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{FE28}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{FE28}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{FE28}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{FE28}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{FE29}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{FE29}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{FE29}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{FE29}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{FE29}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE29}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{FE29}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{FE29}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{FE29}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{FE29}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{FE2A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{FE2A}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{FE2A}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{FE2A}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{FE2A}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE2A}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{FE2A}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{FE2A}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{FE2A}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{FE2A}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{FE2B}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{FE2B}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{FE2B}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{FE2B}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{FE2B}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE2B}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{FE2B}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{FE2B}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{FE2B}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{FE2B}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{FE2C}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{FE2C}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{FE2C}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{FE2C}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{FE2C}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE2C}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{FE2C}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{FE2C}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{FE2C}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{FE2C}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{FE2D}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{FE2D}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{FE2D}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{FE2D}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{FE2D}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE2D}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{FE2D}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{FE2D}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{FE2D}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{FE2D}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{FE2E}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{FE2E}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{FE2E}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{FE2E}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{FE2E}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE2E}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{FE2E}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{FE2E}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{FE2E}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{FE2E}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{FE2F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{FE2F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{FE2F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{FE2F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{FE2F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{FE2F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{FE2F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{FE2F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{FE2F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{FE2F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{101FD}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{101FD}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{101FD}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{101FD}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{101FD}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{101FD}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{101FD}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{101FD}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{101FD}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{101FD}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{102E0}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{102E0}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{102E0}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{102E0}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{102E0}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{102E0}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{102E0}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{102E0}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{102E0}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{102E0}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{10376}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{10376}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{10376}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{10376}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{10376}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{10376}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{10376}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{10376}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{10376}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{10376}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{10377}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{10377}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{10377}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{10377}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{10377}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{10377}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{10377}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{10377}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{10377}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{10377}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{10378}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{10378}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{10378}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{10378}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{10378}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{10378}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{10378}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{10378}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{10378}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{10378}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{10379}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{10379}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{10379}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{10379}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{10379}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{10379}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{10379}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{10379}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{10379}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{10379}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1037A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1037A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1037A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1037A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1037A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1037A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1037A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1037A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1037A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1037A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{10A0D}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{10A0D}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{10A0D}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{10A0D}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{10A0D}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{10A0D}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{10A0D}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{10A0D}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{10A0D}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{10A0D}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{10A0F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{10A0F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{10A0F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{10A0F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{10A0F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{10A0F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{10A0F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{10A0F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{10A0F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{10A0F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{10A38}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{10A38}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{10A38}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{10A38}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{10A38}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{10A38}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{10A38}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{10A38}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{10A38}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{10A38}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{10A39}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{10A39}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{10A39}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{10A39}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{10A39}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{10A39}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{10A39}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{10A39}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{10A39}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{10A39}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{10A3A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{10A3A}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{10A3A}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{10A3A}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{10A3A}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{10A3A}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{10A3A}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{10A3A}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{10A3A}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{10A3A}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{10A3F}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{10A3F}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{10A3F}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{10A3F}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{10A3F}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{10A3F}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{10A3F}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{10A3F}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{10A3F}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{10A3F}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{10AE5}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{10AE5}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{10AE5}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{10AE5}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{10AE5}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{10AE5}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{10AE5}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{10AE5}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{10AE5}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{10AE5}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{10AE6}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{10AE6}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{10AE6}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{10AE6}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{10AE6}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{10AE6}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{10AE6}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{10AE6}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{10AE6}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{10AE6}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{11046}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{11046}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{11046}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{11046}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{11046}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11046}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{11046}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{11046}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{11046}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{11046}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1107F}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1107F}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1107F}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1107F}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1107F}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1107F}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1107F}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1107F}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1107F}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1107F}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{110B9}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{110B9}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{110B9}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{110B9}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{110B9}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{110B9}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{110B9}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{110B9}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{110B9}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{110B9}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{110BA}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{110BA}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{110BA}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{110BA}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{110BA}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{110BA}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{110BA}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{110BA}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{110BA}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{110BA}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{11100}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{11100}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{11100}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{11100}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{11100}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11100}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{11100}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{11100}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{11100}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{11100}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{11101}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{11101}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{11101}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{11101}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{11101}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11101}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{11101}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{11101}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{11101}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{11101}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{11102}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{11102}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{11102}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{11102}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{11102}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11102}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{11102}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{11102}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{11102}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{11102}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{11133}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{11133}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{11133}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{11133}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{11133}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11133}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{11133}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{11133}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{11133}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{11133}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{11134}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{11134}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{11134}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{11134}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{11134}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11134}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{11134}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{11134}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{11134}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{11134}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{11173}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{11173}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{11173}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{11173}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{11173}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11173}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{11173}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{11173}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{11173}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{11173}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{111C0}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{111C0}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{111C0}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{111C0}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{111C0}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{111C0}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{111C0}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{111C0}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{111C0}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{111C0}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{111CA}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{111CA}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{111CA}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{111CA}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{111CA}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{111CA}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{111CA}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{111CA}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{111CA}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{111CA}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{11235}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{11235}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{11235}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{11235}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{11235}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11235}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{11235}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{11235}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{11235}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{11235}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{11236}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{11236}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{11236}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{11236}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{11236}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11236}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{11236}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{11236}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{11236}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{11236}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{112E9}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{112E9}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{112E9}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{112E9}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{112E9}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{112E9}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{112E9}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{112E9}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{112E9}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{112E9}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{112EA}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{112EA}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{112EA}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{112EA}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{112EA}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{112EA}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{112EA}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{112EA}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{112EA}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{112EA}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{1133C}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{1133C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{1133C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{1133C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{1133C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1133C}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1133C}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1133C}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1133C}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1133C}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1134D}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1134D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1134D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1134D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1134D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1134D}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1134D}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1134D}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1134D}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1134D}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{11366}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{11366}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{11366}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{11366}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{11366}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11366}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{11366}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{11366}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{11366}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{11366}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{11367}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{11367}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{11367}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{11367}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{11367}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11367}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{11367}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{11367}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{11367}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{11367}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{11368}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{11368}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{11368}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{11368}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{11368}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11368}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{11368}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{11368}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{11368}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{11368}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{11369}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{11369}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{11369}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{11369}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{11369}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11369}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{11369}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{11369}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{11369}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{11369}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1136A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1136A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1136A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1136A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1136A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1136A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1136A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1136A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1136A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1136A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1136B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1136B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1136B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1136B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1136B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1136B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1136B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1136B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1136B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1136B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1136C}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1136C}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1136C}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1136C}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1136C}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1136C}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1136C}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1136C}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1136C}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1136C}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{11370}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{11370}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{11370}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{11370}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{11370}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11370}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{11370}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{11370}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{11370}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{11370}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{11371}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{11371}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{11371}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{11371}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{11371}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11371}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{11371}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{11371}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{11371}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{11371}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{11372}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{11372}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{11372}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{11372}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{11372}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11372}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{11372}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{11372}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{11372}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{11372}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{11373}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{11373}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{11373}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{11373}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{11373}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11373}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{11373}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{11373}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{11373}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{11373}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{11374}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{11374}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{11374}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{11374}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{11374}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11374}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{11374}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{11374}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{11374}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{11374}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{11442}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{11442}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{11442}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{11442}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{11442}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11442}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{11442}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{11442}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{11442}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{11442}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{11446}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{11446}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{11446}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{11446}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{11446}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11446}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{11446}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{11446}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{11446}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{11446}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{114C2}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{114C2}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{114C2}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{114C2}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{114C2}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{114C2}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{114C2}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{114C2}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{114C2}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{114C2}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{114C3}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{114C3}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{114C3}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{114C3}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{114C3}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{114C3}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{114C3}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{114C3}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{114C3}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{114C3}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{115BF}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{115BF}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{115BF}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{115BF}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{115BF}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{115BF}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{115BF}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{115BF}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{115BF}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{115BF}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{115C0}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{115C0}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{115C0}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{115C0}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{115C0}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{115C0}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{115C0}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{115C0}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{115C0}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{115C0}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1163F}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1163F}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1163F}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1163F}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1163F}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1163F}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1163F}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1163F}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1163F}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1163F}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{116B6}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{116B6}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{116B6}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{116B6}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{116B6}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{116B6}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{116B6}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{116B6}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{116B6}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{116B6}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{116B7}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{116B7}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{116B7}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{116B7}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{116B7}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{116B7}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{116B7}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{116B7}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{116B7}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{116B7}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{1172B}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{1172B}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{1172B}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{1172B}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{1172B}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1172B}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{1172B}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{1172B}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{1172B}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{1172B}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05B0}\u{094D}\u{3099}\u{11C3F}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{094D}\u{11C3F}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{094D}\u{11C3F}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{094D}\u{11C3F}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{094D}\u{11C3F}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{11C3F}\u{05B0}\u{094D}\u{3099}\u{0062}",
        nfc: "\u{0061}\u{3099}\u{11C3F}\u{094D}\u{05B0}\u{0062}",
        nfd: "\u{0061}\u{3099}\u{11C3F}\u{094D}\u{05B0}\u{0062}",
        nfkc: "\u{0061}\u{3099}\u{11C3F}\u{094D}\u{05B0}\u{0062}",
        nfkd: "\u{0061}\u{3099}\u{11C3F}\u{094D}\u{05B0}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{16AF0}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{16AF0}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{16AF0}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{16AF0}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{16AF0}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{16AF0}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{16AF0}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{16AF0}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{16AF0}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{16AF0}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{16AF1}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{16AF1}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{16AF1}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{16AF1}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{16AF1}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{16AF1}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{16AF1}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{16AF1}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{16AF1}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{16AF1}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{16AF2}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{16AF2}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{16AF2}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{16AF2}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{16AF2}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{16AF2}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{16AF2}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{16AF2}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{16AF2}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{16AF2}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{16AF3}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{16AF3}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{16AF3}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{16AF3}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{16AF3}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{16AF3}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{16AF3}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{16AF3}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{16AF3}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{16AF3}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{16AF4}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{16AF4}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{16AF4}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{16AF4}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{16AF4}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{16AF4}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{16AF4}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{16AF4}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{16AF4}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{16AF4}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{16B30}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{16B30}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{16B30}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{16B30}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{16B30}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{16B30}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{16B30}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{16B30}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{16B30}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{16B30}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{16B31}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{16B31}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{16B31}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{16B31}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{16B31}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{16B31}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{16B31}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{16B31}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{16B31}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{16B31}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{16B32}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{16B32}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{16B32}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{16B32}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{16B32}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{16B32}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{16B32}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{16B32}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{16B32}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{16B32}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{16B33}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{16B33}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{16B33}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{16B33}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{16B33}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{16B33}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{16B33}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{16B33}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{16B33}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{16B33}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{16B34}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{16B34}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{16B34}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{16B34}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{16B34}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{16B34}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{16B34}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{16B34}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{16B34}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{16B34}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{16B35}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{16B35}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{16B35}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{16B35}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{16B35}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{16B35}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{16B35}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{16B35}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{16B35}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{16B35}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{16B36}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{16B36}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{16B36}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{16B36}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{16B36}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{16B36}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{16B36}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{16B36}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{16B36}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{16B36}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{1BC9E}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1BC9E}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1BC9E}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1BC9E}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1BC9E}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1BC9E}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{1BC9E}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{1BC9E}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{1BC9E}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{1BC9E}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302A}\u{031B}\u{1DCE}\u{1D165}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{031B}\u{1D165}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{031B}\u{1D165}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{031B}\u{1D165}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{031B}\u{1D165}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D165}\u{302A}\u{031B}\u{1DCE}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{1D165}\u{031B}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{1D165}\u{031B}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{1D165}\u{031B}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{1D165}\u{031B}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302A}\u{031B}\u{1DCE}\u{1D166}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{031B}\u{1D166}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{031B}\u{1D166}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{031B}\u{1D166}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{031B}\u{1D166}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D166}\u{302A}\u{031B}\u{1DCE}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{1D166}\u{031B}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{1D166}\u{031B}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{1D166}\u{031B}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{1D166}\u{031B}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{1D167}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1D167}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1D167}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1D167}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1D167}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D167}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{1D167}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{1D167}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{1D167}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{1D167}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{1D168}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1D168}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1D168}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1D168}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1D168}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D168}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{1D168}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{1D168}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{1D168}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{1D168}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{093C}\u{0334}\u{1D169}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1D169}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1D169}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1D169}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1D169}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D169}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{1D169}\u{0334}\u{093C}\u{0062}",
        nfd: "\u{0061}\u{1D169}\u{0334}\u{093C}\u{0062}",
        nfkc: "\u{0061}\u{1D169}\u{0334}\u{093C}\u{0062}",
        nfkd: "\u{0061}\u{1D169}\u{0334}\u{093C}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{05AE}\u{1D16D}\u{302E}\u{1D16D}\u{0062}",
        nfc: "\u{0061}\u{302E}\u{1D16D}\u{1D16D}\u{05AE}\u{0062}",
        nfd: "\u{0061}\u{302E}\u{1D16D}\u{1D16D}\u{05AE}\u{0062}",
        nfkc: "\u{0061}\u{302E}\u{1D16D}\u{1D16D}\u{05AE}\u{0062}",
        nfkd: "\u{0061}\u{302E}\u{1D16D}\u{1D16D}\u{05AE}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D16D}\u{05AE}\u{1D16D}\u{302E}\u{0062}",
        nfc: "\u{0061}\u{302E}\u{1D16D}\u{1D16D}\u{05AE}\u{0062}",
        nfd: "\u{0061}\u{302E}\u{1D16D}\u{1D16D}\u{05AE}\u{0062}",
        nfkc: "\u{0061}\u{302E}\u{1D16D}\u{1D16D}\u{05AE}\u{0062}",
        nfkd: "\u{0061}\u{302E}\u{1D16D}\u{1D16D}\u{05AE}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302A}\u{031B}\u{1DCE}\u{1D16E}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{031B}\u{1D16E}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{031B}\u{1D16E}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{031B}\u{1D16E}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{031B}\u{1D16E}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D16E}\u{302A}\u{031B}\u{1DCE}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{1D16E}\u{031B}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{1D16E}\u{031B}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{1D16E}\u{031B}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{1D16E}\u{031B}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302A}\u{031B}\u{1DCE}\u{1D16F}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{031B}\u{1D16F}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{031B}\u{1D16F}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{031B}\u{1D16F}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{031B}\u{1D16F}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D16F}\u{302A}\u{031B}\u{1DCE}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{1D16F}\u{031B}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{1D16F}\u{031B}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{1D16F}\u{031B}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{1D16F}\u{031B}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302A}\u{031B}\u{1DCE}\u{1D170}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{031B}\u{1D170}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{031B}\u{1D170}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{031B}\u{1D170}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{031B}\u{1D170}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D170}\u{302A}\u{031B}\u{1DCE}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{1D170}\u{031B}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{1D170}\u{031B}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{1D170}\u{031B}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{1D170}\u{031B}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302A}\u{031B}\u{1DCE}\u{1D171}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{031B}\u{1D171}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{031B}\u{1D171}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{031B}\u{1D171}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{031B}\u{1D171}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D171}\u{302A}\u{031B}\u{1DCE}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{1D171}\u{031B}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{1D171}\u{031B}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{1D171}\u{031B}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{1D171}\u{031B}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{302A}\u{031B}\u{1DCE}\u{1D172}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{031B}\u{1D172}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{031B}\u{1D172}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{031B}\u{1D172}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{031B}\u{1D172}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D172}\u{302A}\u{031B}\u{1DCE}\u{0062}",
        nfc: "\u{0061}\u{1DCE}\u{1D172}\u{031B}\u{302A}\u{0062}",
        nfd: "\u{0061}\u{1DCE}\u{1D172}\u{031B}\u{302A}\u{0062}",
        nfkc: "\u{0061}\u{1DCE}\u{1D172}\u{031B}\u{302A}\u{0062}",
        nfkd: "\u{0061}\u{1DCE}\u{1D172}\u{031B}\u{302A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1D17B}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1D17B}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1D17B}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1D17B}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1D17B}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D17B}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1D17B}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1D17B}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1D17B}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1D17B}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1D17C}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1D17C}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1D17C}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1D17C}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1D17C}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D17C}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1D17C}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1D17C}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1D17C}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1D17C}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1D17D}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1D17D}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1D17D}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1D17D}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1D17D}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D17D}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1D17D}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1D17D}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1D17D}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1D17D}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1D17E}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1D17E}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1D17E}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1D17E}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1D17E}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D17E}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1D17E}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1D17E}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1D17E}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1D17E}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1D17F}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1D17F}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1D17F}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1D17F}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1D17F}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D17F}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1D17F}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1D17F}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1D17F}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1D17F}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1D180}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1D180}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1D180}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1D180}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1D180}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D180}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1D180}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1D180}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1D180}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1D180}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1D181}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1D181}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1D181}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1D181}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1D181}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D181}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1D181}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1D181}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1D181}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1D181}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1D182}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1D182}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1D182}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1D182}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1D182}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D182}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1D182}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1D182}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1D182}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1D182}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1D185}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1D185}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1D185}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1D185}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1D185}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D185}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1D185}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1D185}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1D185}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1D185}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1D186}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1D186}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1D186}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1D186}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1D186}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D186}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1D186}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1D186}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1D186}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1D186}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1D187}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1D187}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1D187}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1D187}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1D187}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D187}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1D187}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1D187}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1D187}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1D187}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1D188}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1D188}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1D188}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1D188}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1D188}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D188}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1D188}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1D188}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1D188}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1D188}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1D189}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1D189}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1D189}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1D189}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1D189}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D189}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1D189}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1D189}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1D189}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1D189}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1D18A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1D18A}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1D18A}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1D18A}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1D18A}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D18A}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1D18A}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1D18A}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1D18A}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1D18A}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1D18B}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1D18B}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1D18B}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1D18B}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1D18B}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D18B}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1D18B}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1D18B}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1D18B}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1D18B}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1D1AA}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1D1AA}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1D1AA}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1D1AA}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1D1AA}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D1AA}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1D1AA}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1D1AA}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1D1AA}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1D1AA}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1D1AB}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1D1AB}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1D1AB}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1D1AB}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1D1AB}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D1AB}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1D1AB}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1D1AB}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1D1AB}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1D1AB}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1D1AC}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1D1AC}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1D1AC}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1D1AC}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1D1AC}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D1AC}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1D1AC}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1D1AC}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1D1AC}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1D1AC}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1D1AD}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1D1AD}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1D1AD}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1D1AD}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1D1AD}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D1AD}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1D1AD}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1D1AD}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1D1AD}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1D1AD}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1D242}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1D242}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1D242}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1D242}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1D242}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D242}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1D242}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1D242}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1D242}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1D242}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1D243}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1D243}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1D243}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1D243}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1D243}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D243}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1D243}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1D243}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1D243}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1D243}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1D244}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1D244}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1D244}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1D244}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1D244}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1D244}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1D244}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1D244}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1D244}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1D244}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E000}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E000}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E000}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E000}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E000}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E000}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E000}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E000}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E000}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E000}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E001}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E001}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E001}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E001}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E001}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E001}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E001}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E001}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E001}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E001}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E002}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E002}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E002}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E002}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E002}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E002}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E002}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E002}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E002}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E002}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E003}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E003}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E003}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E003}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E003}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E003}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E003}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E003}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E003}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E003}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E004}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E004}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E004}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E004}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E004}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E004}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E004}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E004}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E004}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E004}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E005}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E005}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E005}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E005}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E005}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E005}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E005}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E005}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E005}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E005}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E006}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E006}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E006}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E006}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E006}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E006}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E006}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E006}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E006}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E006}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E008}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E008}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E008}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E008}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E008}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E008}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E008}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E008}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E008}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E008}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E009}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E009}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E009}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E009}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E009}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E009}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E009}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E009}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E009}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E009}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E00A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E00A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E00A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E00A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E00A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E00A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E00A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E00A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E00A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E00A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E00B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E00B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E00B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E00B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E00B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E00B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E00B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E00B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E00B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E00B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E00C}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E00C}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E00C}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E00C}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E00C}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E00C}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E00C}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E00C}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E00C}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E00C}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E00D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E00D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E00D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E00D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E00D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E00D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E00D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E00D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E00D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E00D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E00E}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E00E}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E00E}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E00E}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E00E}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E00E}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E00E}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E00E}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E00E}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E00E}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E00F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E00F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E00F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E00F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E00F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E00F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E00F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E00F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E00F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E00F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E010}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E010}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E010}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E010}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E010}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E010}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E010}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E010}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E010}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E010}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E011}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E011}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E011}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E011}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E011}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E011}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E011}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E011}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E011}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E011}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E012}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E012}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E012}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E012}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E012}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E012}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E012}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E012}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E012}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E012}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E013}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E013}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E013}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E013}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E013}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E013}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E013}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E013}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E013}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E013}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E014}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E014}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E014}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E014}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E014}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E014}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E014}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E014}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E014}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E014}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E015}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E015}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E015}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E015}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E015}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E015}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E015}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E015}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E015}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E015}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E016}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E016}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E016}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E016}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E016}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E016}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E016}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E016}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E016}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E016}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E017}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E017}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E017}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E017}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E017}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E017}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E017}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E017}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E017}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E017}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E018}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E018}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E018}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E018}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E018}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E018}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E018}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E018}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E018}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E018}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E01B}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E01B}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E01B}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E01B}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E01B}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E01B}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E01B}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E01B}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E01B}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E01B}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E01C}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E01C}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E01C}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E01C}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E01C}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E01C}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E01C}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E01C}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E01C}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E01C}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E01D}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E01D}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E01D}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E01D}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E01D}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E01D}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E01D}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E01D}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E01D}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E01D}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E01E}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E01E}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E01E}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E01E}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E01E}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E01E}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E01E}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E01E}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E01E}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E01E}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E01F}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E01F}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E01F}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E01F}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E01F}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E01F}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E01F}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E01F}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E01F}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E01F}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E020}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E020}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E020}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E020}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E020}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E020}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E020}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E020}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E020}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E020}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E021}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E021}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E021}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E021}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E021}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E021}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E021}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E021}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E021}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E021}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E023}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E023}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E023}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E023}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E023}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E023}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E023}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E023}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E023}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E023}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E024}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E024}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E024}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E024}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E024}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E024}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E024}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E024}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E024}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E024}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E026}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E026}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E026}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E026}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E026}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E026}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E026}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E026}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E026}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E026}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E027}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E027}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E027}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E027}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E027}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E027}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E027}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E027}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E027}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E027}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E028}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E028}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E028}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E028}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E028}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E028}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E028}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E028}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E028}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E028}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E029}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E029}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E029}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E029}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E029}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E029}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E029}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E029}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E029}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E029}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E02A}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E02A}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E02A}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E02A}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E02A}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E02A}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E02A}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E02A}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E02A}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E02A}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1E8D0}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1E8D0}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1E8D0}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1E8D0}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1E8D0}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E8D0}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1E8D0}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1E8D0}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1E8D0}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1E8D0}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1E8D1}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1E8D1}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1E8D1}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1E8D1}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1E8D1}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E8D1}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1E8D1}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1E8D1}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1E8D1}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1E8D1}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1E8D2}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1E8D2}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1E8D2}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1E8D2}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1E8D2}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E8D2}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1E8D2}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1E8D2}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1E8D2}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1E8D2}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1E8D3}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1E8D3}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1E8D3}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1E8D3}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1E8D3}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E8D3}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1E8D3}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1E8D3}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1E8D3}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1E8D3}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1E8D4}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1E8D4}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1E8D4}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1E8D4}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1E8D4}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E8D4}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1E8D4}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1E8D4}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1E8D4}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1E8D4}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1E8D5}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1E8D5}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1E8D5}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1E8D5}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1E8D5}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E8D5}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1E8D5}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1E8D5}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1E8D5}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1E8D5}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{059A}\u{0316}\u{302A}\u{1E8D6}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{0316}\u{1E8D6}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{0316}\u{1E8D6}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{0316}\u{1E8D6}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{0316}\u{1E8D6}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E8D6}\u{059A}\u{0316}\u{302A}\u{0062}",
        nfc: "\u{0061}\u{302A}\u{1E8D6}\u{0316}\u{059A}\u{0062}",
        nfd: "\u{0061}\u{302A}\u{1E8D6}\u{0316}\u{059A}\u{0062}",
        nfkc: "\u{0061}\u{302A}\u{1E8D6}\u{0316}\u{059A}\u{0062}",
        nfkd: "\u{0061}\u{302A}\u{1E8D6}\u{0316}\u{059A}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E944}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E944}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E944}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E944}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E944}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E944}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E944}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E944}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E944}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E944}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E945}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E945}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E945}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E945}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E945}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E945}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E945}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E945}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E945}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E945}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E946}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E946}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E946}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E946}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E946}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E946}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E946}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E946}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E946}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E946}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E947}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E947}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E947}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E947}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E947}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E947}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E947}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E947}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E947}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E947}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E948}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E948}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E948}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E948}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E948}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E948}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E948}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E948}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E948}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E948}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{0315}\u{0300}\u{05AE}\u{1E949}\u{0062}",
        nfc: "\u{00E0}\u{05AE}\u{1E949}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{0300}\u{1E949}\u{0315}\u{0062}",
        nfkc: "\u{00E0}\u{05AE}\u{1E949}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{0300}\u{1E949}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E949}\u{0315}\u{0300}\u{05AE}\u{0062}",
        nfc: "\u{0061}\u{05AE}\u{1E949}\u{0300}\u{0315}\u{0062}",
        nfd: "\u{0061}\u{05AE}\u{1E949}\u{0300}\u{0315}\u{0062}",
        nfkc: "\u{0061}\u{05AE}\u{1E949}\u{0300}\u{0315}\u{0062}",
        nfkd: "\u{0061}\u{05AE}\u{1E949}\u{0300}\u{0315}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{3099}\u{093C}\u{0334}\u{1E94A}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{093C}\u{1E94A}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{093C}\u{1E94A}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{093C}\u{1E94A}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{093C}\u{1E94A}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{0061}\u{1E94A}\u{3099}\u{093C}\u{0334}\u{0062}",
        nfc: "\u{0061}\u{0334}\u{1E94A}\u{093C}\u{3099}\u{0062}",
        nfd: "\u{0061}\u{0334}\u{1E94A}\u{093C}\u{3099}\u{0062}",
        nfkc: "\u{0061}\u{0334}\u{1E94A}\u{093C}\u{3099}\u{0062}",
        nfkd: "\u{0061}\u{0334}\u{1E94A}\u{093C}\u{3099}\u{0062}",
    },
    NormalizationTest {
        source: "\u{09C7}\u{0334}\u{09BE}",
        nfc: "\u{09C7}\u{0334}\u{09BE}",
        nfd: "\u{09C7}\u{0334}\u{09BE}",
        nfkc: "\u{09C7}\u{0334}\u{09BE}",
        nfkd: "\u{09C7}\u{0334}\u{09BE}",
    },
    NormalizationTest {
        source: "\u{09C7}\u{0334}\u{09D7}",
        nfc: "\u{09C7}\u{0334}\u{09D7}",
        nfd: "\u{09C7}\u{0334}\u{09D7}",
        nfkc: "\u{09C7}\u{0334}\u{09D7}",
        nfkd: "\u{09C7}\u{0334}\u{09D7}",
    },
    NormalizationTest {
        source: "\u{0B47}\u{0334}\u{0B3E}",
        nfc: "\u{0B47}\u{0334}\u{0B3E}",
        nfd: "\u{0B47}\u{0334}\u{0B3E}",
        nfkc: "\u{0B47}\u{0334}\u{0B3E}",
        nfkd: "\u{0B47}\u{0334}\u{0B3E}",
    },
    NormalizationTest {
        source: "\u{0B47}\u{0334}\u{0B56}",
        nfc: "\u{0B47}\u{0334}\u{0B56}",
        nfd: "\u{0B47}\u{0334}\u{0B56}",
        nfkc: "\u{0B47}\u{0334}\u{0B56}",
        nfkd: "\u{0B47}\u{0334}\u{0B56}",
    },
    NormalizationTest {
        source: "\u{0B47}\u{0334}\u{0B57}",
        nfc: "\u{0B47}\u{0334}\u{0B57}",
        nfd: "\u{0B47}\u{0334}\u{0B57}",
        nfkc: "\u{0B47}\u{0334}\u{0B57}",
        nfkd: "\u{0B47}\u{0334}\u{0B57}",
    },
    NormalizationTest {
        source: "\u{0B92}\u{0334}\u{0BD7}",
        nfc: "\u{0B92}\u{0334}\u{0BD7}",
        nfd: "\u{0B92}\u{0334}\u{0BD7}",
        nfkc: "\u{0B92}\u{0334}\u{0BD7}",
        nfkd: "\u{0B92}\u{0334}\u{0BD7}",
    },
    NormalizationTest {
        source: "\u{0BC6}\u{0334}\u{0BBE}",
        nfc: "\u{0BC6}\u{0334}\u{0BBE}",
        nfd: "\u{0BC6}\u{0334}\u{0BBE}",
        nfkc: "\u{0BC6}\u{0334}\u{0BBE}",
        nfkd: "\u{0BC6}\u{0334}\u{0BBE}",
    },
    NormalizationTest {
        source: "\u{0BC6}\u{0334}\u{0BD7}",
        nfc: "\u{0BC6}\u{0334}\u{0BD7}",
        nfd: "\u{0BC6}\u{0334}\u{0BD7}",
        nfkc: "\u{0BC6}\u{0334}\u{0BD7}",
        nfkd: "\u{0BC6}\u{0334}\u{0BD7}",
    },
    NormalizationTest {
        source: "\u{0BC7}\u{0334}\u{0BBE}",
        nfc: "\u{0BC7}\u{0334}\u{0BBE}",
        nfd: "\u{0BC7}\u{0334}\u{0BBE}",
        nfkc: "\u{0BC7}\u{0334}\u{0BBE}",
        nfkd: "\u{0BC7}\u{0334}\u{0BBE}",
    },
    NormalizationTest {
        source: "\u{0CBF}\u{0334}\u{0CD5}",
        nfc: "\u{0CBF}\u{0334}\u{0CD5}",
        nfd: "\u{0CBF}\u{0334}\u{0CD5}",
        nfkc: "\u{0CBF}\u{0334}\u{0CD5}",
        nfkd: "\u{0CBF}\u{0334}\u{0CD5}",
    },
    NormalizationTest {
        source: "\u{0CC6}\u{0334}\u{0CC2}",
        nfc: "\u{0CC6}\u{0334}\u{0CC2}",
        nfd: "\u{0CC6}\u{0334}\u{0CC2}",
        nfkc: "\u{0CC6}\u{0334}\u{0CC2}",
        nfkd: "\u{0CC6}\u{0334}\u{0CC2}",
    },
    NormalizationTest {
        source: "\u{0CC6}\u{0334}\u{0CD5}",
        nfc: "\u{0CC6}\u{0334}\u{0CD5}",
        nfd: "\u{0CC6}\u{0334}\u{0CD5}",
        nfkc: "\u{0CC6}\u{0334}\u{0CD5}",
        nfkd: "\u{0CC6}\u{0334}\u{0CD5}",
    },
    NormalizationTest {
        source: "\u{0CC6}\u{0334}\u{0CD6}",
        nfc: "\u{0CC6}\u{0334}\u{0CD6}",
        nfd: "\u{0CC6}\u{0334}\u{0CD6}",
        nfkc: "\u{0CC6}\u{0334}\u{0CD6}",
        nfkd: "\u{0CC6}\u{0334}\u{0CD6}",
    },
    NormalizationTest {
        source: "\u{0CCA}\u{0334}\u{0CD5}",
        nfc: "\u{0CCA}\u{0334}\u{0CD5}",
        nfd: "\u{0CC6}\u{0CC2}\u{0334}\u{0CD5}",
        nfkc: "\u{0CCA}\u{0334}\u{0CD5}",
        nfkd: "\u{0CC6}\u{0CC2}\u{0334}\u{0CD5}",
    },
    NormalizationTest {
        source: "\u{0D46}\u{0334}\u{0D3E}",
        nfc: "\u{0D46}\u{0334}\u{0D3E}",
        nfd: "\u{0D46}\u{0334}\u{0D3E}",
        nfkc: "\u{0D46}\u{0334}\u{0D3E}",
        nfkd: "\u{0D46}\u{0334}\u{0D3E}",
    },
    NormalizationTest {
        source: "\u{0D46}\u{0334}\u{0D57}",
        nfc: "\u{0D46}\u{0334}\u{0D57}",
        nfd: "\u{0D46}\u{0334}\u{0D57}",
        nfkc: "\u{0D46}\u{0334}\u{0D57}",
        nfkd: "\u{0D46}\u{0334}\u{0D57}",
    },
    NormalizationTest {
        source: "\u{0D47}\u{0334}\u{0D3E}",
        nfc: "\u{0D47}\u{0334}\u{0D3E}",
        nfd: "\u{0D47}\u{0334}\u{0D3E}",
        nfkc: "\u{0D47}\u{0334}\u{0D3E}",
        nfkd: "\u{0D47}\u{0334}\u{0D3E}",
    },
    NormalizationTest {
        source: "\u{0DD9}\u{0334}\u{0DCF}",
        nfc: "\u{0DD9}\u{0334}\u{0DCF}",
        nfd: "\u{0DD9}\u{0334}\u{0DCF}",
        nfkc: "\u{0DD9}\u{0334}\u{0DCF}",
        nfkd: "\u{0DD9}\u{0334}\u{0DCF}",
    },
    NormalizationTest {
        source: "\u{0DD9}\u{0334}\u{0DDF}",
        nfc: "\u{0DD9}\u{0334}\u{0DDF}",
        nfd: "\u{0DD9}\u{0334}\u{0DDF}",
        nfkc: "\u{0DD9}\u{0334}\u{0DDF}",
        nfkd: "\u{0DD9}\u{0334}\u{0DDF}",
    },
    NormalizationTest {
        source: "\u{0F40}\u{0334}\u{0FB5}",
        nfc: "\u{0F40}\u{0334}\u{0FB5}",
        nfd: "\u{0F40}\u{0334}\u{0FB5}",
        nfkc: "\u{0F40}\u{0334}\u{0FB5}",
        nfkd: "\u{0F40}\u{0334}\u{0FB5}",
    },
    NormalizationTest {
        source: "\u{0F42}\u{0334}\u{0FB7}",
        nfc: "\u{0F42}\u{0334}\u{0FB7}",
        nfd: "\u{0F42}\u{0334}\u{0FB7}",
        nfkc: "\u{0F42}\u{0334}\u{0FB7}",
        nfkd: "\u{0F42}\u{0334}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0F4C}\u{0334}\u{0FB7}",
        nfc: "\u{0F4C}\u{0334}\u{0FB7}",
        nfd: "\u{0F4C}\u{0334}\u{0FB7}",
        nfkc: "\u{0F4C}\u{0334}\u{0FB7}",
        nfkd: "\u{0F4C}\u{0334}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0F51}\u{0334}\u{0FB7}",
        nfc: "\u{0F51}\u{0334}\u{0FB7}",
        nfd: "\u{0F51}\u{0334}\u{0FB7}",
        nfkc: "\u{0F51}\u{0334}\u{0FB7}",
        nfkd: "\u{0F51}\u{0334}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0F56}\u{0334}\u{0FB7}",
        nfc: "\u{0F56}\u{0334}\u{0FB7}",
        nfd: "\u{0F56}\u{0334}\u{0FB7}",
        nfkc: "\u{0F56}\u{0334}\u{0FB7}",
        nfkd: "\u{0F56}\u{0334}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0F5B}\u{0334}\u{0FB7}",
        nfc: "\u{0F5B}\u{0334}\u{0FB7}",
        nfd: "\u{0F5B}\u{0334}\u{0FB7}",
        nfkc: "\u{0F5B}\u{0334}\u{0FB7}",
        nfkd: "\u{0F5B}\u{0334}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0F90}\u{0334}\u{0FB5}",
        nfc: "\u{0F90}\u{0334}\u{0FB5}",
        nfd: "\u{0F90}\u{0334}\u{0FB5}",
        nfkc: "\u{0F90}\u{0334}\u{0FB5}",
        nfkd: "\u{0F90}\u{0334}\u{0FB5}",
    },
    NormalizationTest {
        source: "\u{0F92}\u{0334}\u{0FB7}",
        nfc: "\u{0F92}\u{0334}\u{0FB7}",
        nfd: "\u{0F92}\u{0334}\u{0FB7}",
        nfkc: "\u{0F92}\u{0334}\u{0FB7}",
        nfkd: "\u{0F92}\u{0334}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0F9C}\u{0334}\u{0FB7}",
        nfc: "\u{0F9C}\u{0334}\u{0FB7}",
        nfd: "\u{0F9C}\u{0334}\u{0FB7}",
        nfkc: "\u{0F9C}\u{0334}\u{0FB7}",
        nfkd: "\u{0F9C}\u{0334}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0FA1}\u{0334}\u{0FB7}",
        nfc: "\u{0FA1}\u{0334}\u{0FB7}",
        nfd: "\u{0FA1}\u{0334}\u{0FB7}",
        nfkc: "\u{0FA1}\u{0334}\u{0FB7}",
        nfkd: "\u{0FA1}\u{0334}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0FA6}\u{0334}\u{0FB7}",
        nfc: "\u{0FA6}\u{0334}\u{0FB7}",
        nfd: "\u{0FA6}\u{0334}\u{0FB7}",
        nfkc: "\u{0FA6}\u{0334}\u{0FB7}",
        nfkd: "\u{0FA6}\u{0334}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{0FAB}\u{0334}\u{0FB7}",
        nfc: "\u{0FAB}\u{0334}\u{0FB7}",
        nfd: "\u{0FAB}\u{0334}\u{0FB7}",
        nfkc: "\u{0FAB}\u{0334}\u{0FB7}",
        nfkd: "\u{0FAB}\u{0334}\u{0FB7}",
    },
    NormalizationTest {
        source: "\u{1025}\u{0334}\u{102E}",
        nfc: "\u{1025}\u{0334}\u{102E}",
        nfd: "\u{1025}\u{0334}\u{102E}",
        nfkc: "\u{1025}\u{0334}\u{102E}",
        nfkd: "\u{1025}\u{0334}\u{102E}",
    },
    NormalizationTest {
        source: "\u{1100}\u{0334}\u{1161}",
        nfc: "\u{1100}\u{0334}\u{1161}",
        nfd: "\u{1100}\u{0334}\u{1161}",
        nfkc: "\u{1100}\u{0334}\u{1161}",
        nfkd: "\u{1100}\u{0334}\u{1161}",
    },
    NormalizationTest {
        source: "\u{1100}\u{0334}\u{116E}",
        nfc: "\u{1100}\u{0334}\u{116E}",
        nfd: "\u{1100}\u{0334}\u{116E}",
        nfkc: "\u{1100}\u{0334}\u{116E}",
        nfkd: "\u{1100}\u{0334}\u{116E}",
    },
    NormalizationTest {
        source: "\u{1101}\u{0334}\u{1166}",
        nfc: "\u{1101}\u{0334}\u{1166}",
        nfd: "\u{1101}\u{0334}\u{1166}",
        nfkc: "\u{1101}\u{0334}\u{1166}",
        nfkd: "\u{1101}\u{0334}\u{1166}",
    },
    NormalizationTest {
        source: "\u{1101}\u{0334}\u{1173}",
        nfc: "\u{1101}\u{0334}\u{1173}",
        nfd: "\u{1101}\u{0334}\u{1173}",
        nfkc: "\u{1101}\u{0334}\u{1173}",
        nfkd: "\u{1101}\u{0334}\u{1173}",
    },
    NormalizationTest {
        source: "\u{1102}\u{0334}\u{116B}",
        nfc: "\u{1102}\u{0334}\u{116B}",
        nfd: "\u{1102}\u{0334}\u{116B}",
        nfkc: "\u{1102}\u{0334}\u{116B}",
        nfkd: "\u{1102}\u{0334}\u{116B}",
    },
    NormalizationTest {
        source: "\u{1103}\u{0334}\u{1163}",
        nfc: "\u{1103}\u{0334}\u{1163}",
        nfd: "\u{1103}\u{0334}\u{1163}",
        nfkc: "\u{1103}\u{0334}\u{1163}",
        nfkd: "\u{1103}\u{0334}\u{1163}",
    },
    NormalizationTest {
        source: "\u{1103}\u{0334}\u{1170}",
        nfc: "\u{1103}\u{0334}\u{1170}",
        nfd: "\u{1103}\u{0334}\u{1170}",
        nfkc: "\u{1103}\u{0334}\u{1170}",
        nfkd: "\u{1103}\u{0334}\u{1170}",
    },
    NormalizationTest {
        source: "\u{1104}\u{0334}\u{1168}",
        nfc: "\u{1104}\u{0334}\u{1168}",
        nfd: "\u{1104}\u{0334}\u{1168}",
        nfkc: "\u{1104}\u{0334}\u{1168}",
        nfkd: "\u{1104}\u{0334}\u{1168}",
    },
    NormalizationTest {
        source: "\u{1104}\u{0334}\u{1175}",
        nfc: "\u{1104}\u{0334}\u{1175}",
        nfd: "\u{1104}\u{0334}\u{1175}",
        nfkc: "\u{1104}\u{0334}\u{1175}",
        nfkd: "\u{1104}\u{0334}\u{1175}",
    },
    NormalizationTest {
        source: "\u{1105}\u{0334}\u{116D}",
        nfc: "\u{1105}\u{0334}\u{116D}",
        nfd: "\u{1105}\u{0334}\u{116D}",
        nfkc: "\u{1105}\u{0334}\u{116D}",
        nfkd: "\u{1105}\u{0334}\u{116D}",
    },
    NormalizationTest {
        source: "\u{1106}\u{0334}\u{1165}",
        nfc: "\u{1106}\u{0334}\u{1165}",
        nfd: "\u{1106}\u{0334}\u{1165}",
        nfkc: "\u{1106}\u{0334}\u{1165}",
        nfkd: "\u{1106}\u{0334}\u{1165}",
    },
    NormalizationTest {
        source: "\u{1106}\u{0334}\u{1172}",
        nfc: "\u{1106}\u{0334}\u{1172}",
        nfd: "\u{1106}\u{0334}\u{1172}",
        nfkc: "\u{1106}\u{0334}\u{1172}",
        nfkd: "\u{1106}\u{0334}\u{1172}",
    },
    NormalizationTest {
        source: "\u{1107}\u{0334}\u{116A}",
        nfc: "\u{1107}\u{0334}\u{116A}",
        nfd: "\u{1107}\u{0334}\u{116A}",
        nfkc: "\u{1107}\u{0334}\u{116A}",
        nfkd: "\u{1107}\u{0334}\u{116A}",
    },
    NormalizationTest {
        source: "\u{1108}\u{0334}\u{1162}",
        nfc: "\u{1108}\u{0334}\u{1162}",
        nfd: "\u{1108}\u{0334}\u{1162}",
        nfkc: "\u{1108}\u{0334}\u{1162}",
        nfkd: "\u{1108}\u{0334}\u{1162}",
    },
    NormalizationTest {
        source: "\u{1108}\u{0334}\u{116F}",
        nfc: "\u{1108}\u{0334}\u{116F}",
        nfd: "\u{1108}\u{0334}\u{116F}",
        nfkc: "\u{1108}\u{0334}\u{116F}",
        nfkd: "\u{1108}\u{0334}\u{116F}",
    },
    NormalizationTest {
        source: "\u{1109}\u{0334}\u{1167}",
        nfc: "\u{1109}\u{0334}\u{1167}",
        nfd: "\u{1109}\u{0334}\u{1167}",
        nfkc: "\u{1109}\u{0334}\u{1167}",
        nfkd: "\u{1109}\u{0334}\u{1167}",
    },
    NormalizationTest {
        source: "\u{1109}\u{0334}\u{1174}",
        nfc: "\u{1109}\u{0334}\u{1174}",
        nfd: "\u{1109}\u{0334}\u{1174}",
        nfkc: "\u{1109}\u{0334}\u{1174}",
        nfkd: "\u{1109}\u{0334}\u{1174}",
    },
    NormalizationTest {
        source: "\u{110A}\u{0334}\u{116C}",
        nfc: "\u{110A}\u{0334}\u{116C}",
        nfd: "\u{110A}\u{0334}\u{116C}",
        nfkc: "\u{110A}\u{0334}\u{116C}",
        nfkd: "\u{110A}\u{0334}\u{116C}",
    },
    NormalizationTest {
        source: "\u{110B}\u{0334}\u{1164}",
        nfc: "\u{110B}\u{0334}\u{1164}",
        nfd: "\u{110B}\u{0334}\u{1164}",
        nfkc: "\u{110B}\u{0334}\u{1164}",
        nfkd: "\u{110B}\u{0334}\u{1164}",
    },
    NormalizationTest {
        source: "\u{110B}\u{0334}\u{1171}",
        nfc: "\u{110B}\u{0334}\u{1171}",
        nfd: "\u{110B}\u{0334}\u{1171}",
        nfkc: "\u{110B}\u{0334}\u{1171}",
        nfkd: "\u{110B}\u{0334}\u{1171}",
    },
    NormalizationTest {
        source: "\u{110C}\u{0334}\u{1169}",
        nfc: "\u{110C}\u{0334}\u{1169}",
        nfd: "\u{110C}\u{0334}\u{1169}",
        nfkc: "\u{110C}\u{0334}\u{1169}",
        nfkd: "\u{110C}\u{0334}\u{1169}",
    },
    NormalizationTest {
        source: "\u{110D}\u{0334}\u{1161}",
        nfc: "\u{110D}\u{0334}\u{1161}",
        nfd: "\u{110D}\u{0334}\u{1161}",
        nfkc: "\u{110D}\u{0334}\u{1161}",
        nfkd: "\u{110D}\u{0334}\u{1161}",
    },
    NormalizationTest {
        source: "\u{110D}\u{0334}\u{116E}",
        nfc: "\u{110D}\u{0334}\u{116E}",
        nfd: "\u{110D}\u{0334}\u{116E}",
        nfkc: "\u{110D}\u{0334}\u{116E}",
        nfkd: "\u{110D}\u{0334}\u{116E}",
    },
    NormalizationTest {
        source: "\u{110E}\u{0334}\u{1166}",
        nfc: "\u{110E}\u{0334}\u{1166}",
        nfd: "\u{110E}\u{0334}\u{1166}",
        nfkc: "\u{110E}\u{0334}\u{1166}",
        nfkd: "\u{110E}\u{0334}\u{1166}",
    },
    NormalizationTest {
        source: "\u{110E}\u{0334}\u{1173}",
        nfc: "\u{110E}\u{0334}\u{1173}",
        nfd: "\u{110E}\u{0334}\u{1173}",
        nfkc: "\u{110E}\u{0334}\u{1173}",
        nfkd: "\u{110E}\u{0334}\u{1173}",
    },
    NormalizationTest {
        source: "\u{110F}\u{0334}\u{116B}",
        nfc: "\u{110F}\u{0334}\u{116B}",
        nfd: "\u{110F}\u{0334}\u{116B}",
        nfkc: "\u{110F}\u{0334}\u{116B}",
        nfkd: "\u{110F}\u{0334}\u{116B}",
    },
    NormalizationTest {
        source: "\u{1110}\u{0334}\u{1163}",
        nfc: "\u{1110}\u{0334}\u{1163}",
        nfd: "\u{1110}\u{0334}\u{1163}",
        nfkc: "\u{1110}\u{0334}\u{1163}",
        nfkd: "\u{1110}\u{0334}\u{1163}",
    },
    NormalizationTest {
        source: "\u{1110}\u{0334}\u{1170}",
        nfc: "\u{1110}\u{0334}\u{1170}",
        nfd: "\u{1110}\u{0334}\u{1170}",
        nfkc: "\u{1110}\u{0334}\u{1170}",
        nfkd: "\u{1110}\u{0334}\u{1170}",
    },
    NormalizationTest {
        source: "\u{1111}\u{0334}\u{1168}",
        nfc: "\u{1111}\u{0334}\u{1168}",
        nfd: "\u{1111}\u{0334}\u{1168}",
        nfkc: "\u{1111}\u{0334}\u{1168}",
        nfkd: "\u{1111}\u{0334}\u{1168}",
    },
    NormalizationTest {
        source: "\u{1111}\u{0334}\u{1175}",
        nfc: "\u{1111}\u{0334}\u{1175}",
        nfd: "\u{1111}\u{0334}\u{1175}",
        nfkc: "\u{1111}\u{0334}\u{1175}",
        nfkd: "\u{1111}\u{0334}\u{1175}",
    },
    NormalizationTest {
        source: "\u{1112}\u{0334}\u{116D}",
        nfc: "\u{1112}\u{0334}\u{116D}",
        nfd: "\u{1112}\u{0334}\u{116D}",
        nfkc: "\u{1112}\u{0334}\u{116D}",
        nfkd: "\u{1112}\u{0334}\u{116D}",
    },
    NormalizationTest {
        source: "\u{1B05}\u{0334}\u{1B35}",
        nfc: "\u{1B05}\u{0334}\u{1B35}",
        nfd: "\u{1B05}\u{0334}\u{1B35}",
        nfkc: "\u{1B05}\u{0334}\u{1B35}",
        nfkd: "\u{1B05}\u{0334}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B07}\u{0334}\u{1B35}",
        nfc: "\u{1B07}\u{0334}\u{1B35}",
        nfd: "\u{1B07}\u{0334}\u{1B35}",
        nfkc: "\u{1B07}\u{0334}\u{1B35}",
        nfkd: "\u{1B07}\u{0334}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B09}\u{0334}\u{1B35}",
        nfc: "\u{1B09}\u{0334}\u{1B35}",
        nfd: "\u{1B09}\u{0334}\u{1B35}",
        nfkc: "\u{1B09}\u{0334}\u{1B35}",
        nfkd: "\u{1B09}\u{0334}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B0B}\u{0334}\u{1B35}",
        nfc: "\u{1B0B}\u{0334}\u{1B35}",
        nfd: "\u{1B0B}\u{0334}\u{1B35}",
        nfkc: "\u{1B0B}\u{0334}\u{1B35}",
        nfkd: "\u{1B0B}\u{0334}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B0D}\u{0334}\u{1B35}",
        nfc: "\u{1B0D}\u{0334}\u{1B35}",
        nfd: "\u{1B0D}\u{0334}\u{1B35}",
        nfkc: "\u{1B0D}\u{0334}\u{1B35}",
        nfkd: "\u{1B0D}\u{0334}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B11}\u{0334}\u{1B35}",
        nfc: "\u{1B11}\u{0334}\u{1B35}",
        nfd: "\u{1B11}\u{0334}\u{1B35}",
        nfkc: "\u{1B11}\u{0334}\u{1B35}",
        nfkd: "\u{1B11}\u{0334}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B3A}\u{0334}\u{1B35}",
        nfc: "\u{1B3A}\u{0334}\u{1B35}",
        nfd: "\u{1B3A}\u{0334}\u{1B35}",
        nfkc: "\u{1B3A}\u{0334}\u{1B35}",
        nfkd: "\u{1B3A}\u{0334}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B3C}\u{0334}\u{1B35}",
        nfc: "\u{1B3C}\u{0334}\u{1B35}",
        nfd: "\u{1B3C}\u{0334}\u{1B35}",
        nfkc: "\u{1B3C}\u{0334}\u{1B35}",
        nfkd: "\u{1B3C}\u{0334}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B3E}\u{0334}\u{1B35}",
        nfc: "\u{1B3E}\u{0334}\u{1B35}",
        nfd: "\u{1B3E}\u{0334}\u{1B35}",
        nfkc: "\u{1B3E}\u{0334}\u{1B35}",
        nfkd: "\u{1B3E}\u{0334}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B3F}\u{0334}\u{1B35}",
        nfc: "\u{1B3F}\u{0334}\u{1B35}",
        nfd: "\u{1B3F}\u{0334}\u{1B35}",
        nfkc: "\u{1B3F}\u{0334}\u{1B35}",
        nfkd: "\u{1B3F}\u{0334}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{1B42}\u{0334}\u{1B35}",
        nfc: "\u{1B42}\u{0334}\u{1B35}",
        nfd: "\u{1B42}\u{0334}\u{1B35}",
        nfkc: "\u{1B42}\u{0334}\u{1B35}",
        nfkd: "\u{1B42}\u{0334}\u{1B35}",
    },
    NormalizationTest {
        source: "\u{AC54}\u{0334}\u{11AE}",
        nfc: "\u{AC54}\u{0334}\u{11AE}",
        nfd: "\u{1100}\u{1164}\u{0334}\u{11AE}",
        nfkc: "\u{AC54}\u{0334}\u{11AE}",
        nfkd: "\u{1100}\u{1164}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{ACA8}\u{0334}\u{11B5}",
        nfc: "\u{ACA8}\u{0334}\u{11B5}",
        nfd: "\u{1100}\u{1167}\u{0334}\u{11B5}",
        nfkc: "\u{ACA8}\u{0334}\u{11B5}",
        nfkd: "\u{1100}\u{1167}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{ACFC}\u{0334}\u{11BC}",
        nfc: "\u{ACFC}\u{0334}\u{11BC}",
        nfd: "\u{1100}\u{116A}\u{0334}\u{11BC}",
        nfkc: "\u{ACFC}\u{0334}\u{11BC}",
        nfkd: "\u{1100}\u{116A}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{ADC0}\u{0334}\u{11AE}",
        nfc: "\u{ADC0}\u{0334}\u{11AE}",
        nfd: "\u{1100}\u{1171}\u{0334}\u{11AE}",
        nfkc: "\u{ADC0}\u{0334}\u{11AE}",
        nfkd: "\u{1100}\u{1171}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AE14}\u{0334}\u{11B5}",
        nfc: "\u{AE14}\u{0334}\u{11B5}",
        nfd: "\u{1100}\u{1174}\u{0334}\u{11B5}",
        nfkc: "\u{AE14}\u{0334}\u{11B5}",
        nfkd: "\u{1100}\u{1174}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AE68}\u{0334}\u{11BC}",
        nfc: "\u{AE68}\u{0334}\u{11BC}",
        nfd: "\u{1101}\u{1162}\u{0334}\u{11BC}",
        nfkc: "\u{AE68}\u{0334}\u{11BC}",
        nfkd: "\u{1101}\u{1162}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{AF2C}\u{0334}\u{11AE}",
        nfc: "\u{AF2C}\u{0334}\u{11AE}",
        nfd: "\u{1101}\u{1169}\u{0334}\u{11AE}",
        nfkc: "\u{AF2C}\u{0334}\u{11AE}",
        nfkd: "\u{1101}\u{1169}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{AF80}\u{0334}\u{11B5}",
        nfc: "\u{AF80}\u{0334}\u{11B5}",
        nfd: "\u{1101}\u{116C}\u{0334}\u{11B5}",
        nfkc: "\u{AF80}\u{0334}\u{11B5}",
        nfkd: "\u{1101}\u{116C}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{AFD4}\u{0334}\u{11BC}",
        nfc: "\u{AFD4}\u{0334}\u{11BC}",
        nfd: "\u{1101}\u{116F}\u{0334}\u{11BC}",
        nfkc: "\u{AFD4}\u{0334}\u{11BC}",
        nfkd: "\u{1101}\u{116F}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B098}\u{0334}\u{11AE}",
        nfc: "\u{B098}\u{0334}\u{11AE}",
        nfd: "\u{1102}\u{1161}\u{0334}\u{11AE}",
        nfkc: "\u{B098}\u{0334}\u{11AE}",
        nfkd: "\u{1102}\u{1161}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B0EC}\u{0334}\u{11B5}",
        nfc: "\u{B0EC}\u{0334}\u{11B5}",
        nfd: "\u{1102}\u{1164}\u{0334}\u{11B5}",
        nfkc: "\u{B0EC}\u{0334}\u{11B5}",
        nfkd: "\u{1102}\u{1164}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B140}\u{0334}\u{11BC}",
        nfc: "\u{B140}\u{0334}\u{11BC}",
        nfd: "\u{1102}\u{1167}\u{0334}\u{11BC}",
        nfkc: "\u{B140}\u{0334}\u{11BC}",
        nfkd: "\u{1102}\u{1167}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B204}\u{0334}\u{11AE}",
        nfc: "\u{B204}\u{0334}\u{11AE}",
        nfd: "\u{1102}\u{116E}\u{0334}\u{11AE}",
        nfkc: "\u{B204}\u{0334}\u{11AE}",
        nfkd: "\u{1102}\u{116E}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B258}\u{0334}\u{11B5}",
        nfc: "\u{B258}\u{0334}\u{11B5}",
        nfd: "\u{1102}\u{1171}\u{0334}\u{11B5}",
        nfkc: "\u{B258}\u{0334}\u{11B5}",
        nfkd: "\u{1102}\u{1171}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B2AC}\u{0334}\u{11BC}",
        nfc: "\u{B2AC}\u{0334}\u{11BC}",
        nfd: "\u{1102}\u{1174}\u{0334}\u{11BC}",
        nfkc: "\u{B2AC}\u{0334}\u{11BC}",
        nfkd: "\u{1102}\u{1174}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B370}\u{0334}\u{11AE}",
        nfc: "\u{B370}\u{0334}\u{11AE}",
        nfd: "\u{1103}\u{1166}\u{0334}\u{11AE}",
        nfkc: "\u{B370}\u{0334}\u{11AE}",
        nfkd: "\u{1103}\u{1166}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B3C4}\u{0334}\u{11B5}",
        nfc: "\u{B3C4}\u{0334}\u{11B5}",
        nfd: "\u{1103}\u{1169}\u{0334}\u{11B5}",
        nfkc: "\u{B3C4}\u{0334}\u{11B5}",
        nfkd: "\u{1103}\u{1169}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B418}\u{0334}\u{11BC}",
        nfc: "\u{B418}\u{0334}\u{11BC}",
        nfd: "\u{1103}\u{116C}\u{0334}\u{11BC}",
        nfkc: "\u{B418}\u{0334}\u{11BC}",
        nfkd: "\u{1103}\u{116C}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B4DC}\u{0334}\u{11AE}",
        nfc: "\u{B4DC}\u{0334}\u{11AE}",
        nfd: "\u{1103}\u{1173}\u{0334}\u{11AE}",
        nfkc: "\u{B4DC}\u{0334}\u{11AE}",
        nfkd: "\u{1103}\u{1173}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B530}\u{0334}\u{11B5}",
        nfc: "\u{B530}\u{0334}\u{11B5}",
        nfd: "\u{1104}\u{1161}\u{0334}\u{11B5}",
        nfkc: "\u{B530}\u{0334}\u{11B5}",
        nfkd: "\u{1104}\u{1161}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B584}\u{0334}\u{11BC}",
        nfc: "\u{B584}\u{0334}\u{11BC}",
        nfd: "\u{1104}\u{1164}\u{0334}\u{11BC}",
        nfkc: "\u{B584}\u{0334}\u{11BC}",
        nfkd: "\u{1104}\u{1164}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B648}\u{0334}\u{11AE}",
        nfc: "\u{B648}\u{0334}\u{11AE}",
        nfd: "\u{1104}\u{116B}\u{0334}\u{11AE}",
        nfkc: "\u{B648}\u{0334}\u{11AE}",
        nfkd: "\u{1104}\u{116B}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B69C}\u{0334}\u{11B5}",
        nfc: "\u{B69C}\u{0334}\u{11B5}",
        nfd: "\u{1104}\u{116E}\u{0334}\u{11B5}",
        nfkc: "\u{B69C}\u{0334}\u{11B5}",
        nfkd: "\u{1104}\u{116E}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B6F0}\u{0334}\u{11BC}",
        nfc: "\u{B6F0}\u{0334}\u{11BC}",
        nfd: "\u{1104}\u{1171}\u{0334}\u{11BC}",
        nfkc: "\u{B6F0}\u{0334}\u{11BC}",
        nfkd: "\u{1104}\u{1171}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B7B4}\u{0334}\u{11AE}",
        nfc: "\u{B7B4}\u{0334}\u{11AE}",
        nfd: "\u{1105}\u{1163}\u{0334}\u{11AE}",
        nfkc: "\u{B7B4}\u{0334}\u{11AE}",
        nfkd: "\u{1105}\u{1163}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B808}\u{0334}\u{11B5}",
        nfc: "\u{B808}\u{0334}\u{11B5}",
        nfd: "\u{1105}\u{1166}\u{0334}\u{11B5}",
        nfkc: "\u{B808}\u{0334}\u{11B5}",
        nfkd: "\u{1105}\u{1166}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B85C}\u{0334}\u{11BC}",
        nfc: "\u{B85C}\u{0334}\u{11BC}",
        nfd: "\u{1105}\u{1169}\u{0334}\u{11BC}",
        nfkc: "\u{B85C}\u{0334}\u{11BC}",
        nfkd: "\u{1105}\u{1169}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{B920}\u{0334}\u{11AE}",
        nfc: "\u{B920}\u{0334}\u{11AE}",
        nfd: "\u{1105}\u{1170}\u{0334}\u{11AE}",
        nfkc: "\u{B920}\u{0334}\u{11AE}",
        nfkd: "\u{1105}\u{1170}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{B974}\u{0334}\u{11B5}",
        nfc: "\u{B974}\u{0334}\u{11B5}",
        nfd: "\u{1105}\u{1173}\u{0334}\u{11B5}",
        nfkc: "\u{B974}\u{0334}\u{11B5}",
        nfkd: "\u{1105}\u{1173}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{B9C8}\u{0334}\u{11BC}",
        nfc: "\u{B9C8}\u{0334}\u{11BC}",
        nfd: "\u{1106}\u{1161}\u{0334}\u{11BC}",
        nfkc: "\u{B9C8}\u{0334}\u{11BC}",
        nfkd: "\u{1106}\u{1161}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BA8C}\u{0334}\u{11AE}",
        nfc: "\u{BA8C}\u{0334}\u{11AE}",
        nfd: "\u{1106}\u{1168}\u{0334}\u{11AE}",
        nfkc: "\u{BA8C}\u{0334}\u{11AE}",
        nfkd: "\u{1106}\u{1168}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BAE0}\u{0334}\u{11B5}",
        nfc: "\u{BAE0}\u{0334}\u{11B5}",
        nfd: "\u{1106}\u{116B}\u{0334}\u{11B5}",
        nfkc: "\u{BAE0}\u{0334}\u{11B5}",
        nfkd: "\u{1106}\u{116B}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BB34}\u{0334}\u{11BC}",
        nfc: "\u{BB34}\u{0334}\u{11BC}",
        nfd: "\u{1106}\u{116E}\u{0334}\u{11BC}",
        nfkc: "\u{BB34}\u{0334}\u{11BC}",
        nfkd: "\u{1106}\u{116E}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BBF8}\u{0334}\u{11AE}",
        nfc: "\u{BBF8}\u{0334}\u{11AE}",
        nfd: "\u{1106}\u{1175}\u{0334}\u{11AE}",
        nfkc: "\u{BBF8}\u{0334}\u{11AE}",
        nfkd: "\u{1106}\u{1175}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BC4C}\u{0334}\u{11B5}",
        nfc: "\u{BC4C}\u{0334}\u{11B5}",
        nfd: "\u{1107}\u{1163}\u{0334}\u{11B5}",
        nfkc: "\u{BC4C}\u{0334}\u{11B5}",
        nfkd: "\u{1107}\u{1163}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BCA0}\u{0334}\u{11BC}",
        nfc: "\u{BCA0}\u{0334}\u{11BC}",
        nfd: "\u{1107}\u{1166}\u{0334}\u{11BC}",
        nfkc: "\u{BCA0}\u{0334}\u{11BC}",
        nfkd: "\u{1107}\u{1166}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BD64}\u{0334}\u{11AE}",
        nfc: "\u{BD64}\u{0334}\u{11AE}",
        nfd: "\u{1107}\u{116D}\u{0334}\u{11AE}",
        nfkc: "\u{BD64}\u{0334}\u{11AE}",
        nfkd: "\u{1107}\u{116D}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BDB8}\u{0334}\u{11B5}",
        nfc: "\u{BDB8}\u{0334}\u{11B5}",
        nfd: "\u{1107}\u{1170}\u{0334}\u{11B5}",
        nfkc: "\u{BDB8}\u{0334}\u{11B5}",
        nfkd: "\u{1107}\u{1170}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BE0C}\u{0334}\u{11BC}",
        nfc: "\u{BE0C}\u{0334}\u{11BC}",
        nfd: "\u{1107}\u{1173}\u{0334}\u{11BC}",
        nfkc: "\u{BE0C}\u{0334}\u{11BC}",
        nfkd: "\u{1107}\u{1173}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{BED0}\u{0334}\u{11AE}",
        nfc: "\u{BED0}\u{0334}\u{11AE}",
        nfd: "\u{1108}\u{1165}\u{0334}\u{11AE}",
        nfkc: "\u{BED0}\u{0334}\u{11AE}",
        nfkd: "\u{1108}\u{1165}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{BF24}\u{0334}\u{11B5}",
        nfc: "\u{BF24}\u{0334}\u{11B5}",
        nfd: "\u{1108}\u{1168}\u{0334}\u{11B5}",
        nfkc: "\u{BF24}\u{0334}\u{11B5}",
        nfkd: "\u{1108}\u{1168}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{BF78}\u{0334}\u{11BC}",
        nfc: "\u{BF78}\u{0334}\u{11BC}",
        nfd: "\u{1108}\u{116B}\u{0334}\u{11BC}",
        nfkc: "\u{BF78}\u{0334}\u{11BC}",
        nfkd: "\u{1108}\u{116B}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C03C}\u{0334}\u{11AE}",
        nfc: "\u{C03C}\u{0334}\u{11AE}",
        nfd: "\u{1108}\u{1172}\u{0334}\u{11AE}",
        nfkc: "\u{C03C}\u{0334}\u{11AE}",
        nfkd: "\u{1108}\u{1172}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C090}\u{0334}\u{11B5}",
        nfc: "\u{C090}\u{0334}\u{11B5}",
        nfd: "\u{1108}\u{1175}\u{0334}\u{11B5}",
        nfkc: "\u{C090}\u{0334}\u{11B5}",
        nfkd: "\u{1108}\u{1175}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C0E4}\u{0334}\u{11BC}",
        nfc: "\u{C0E4}\u{0334}\u{11BC}",
        nfd: "\u{1109}\u{1163}\u{0334}\u{11BC}",
        nfkc: "\u{C0E4}\u{0334}\u{11BC}",
        nfkd: "\u{1109}\u{1163}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C1A8}\u{0334}\u{11AE}",
        nfc: "\u{C1A8}\u{0334}\u{11AE}",
        nfd: "\u{1109}\u{116A}\u{0334}\u{11AE}",
        nfkc: "\u{C1A8}\u{0334}\u{11AE}",
        nfkd: "\u{1109}\u{116A}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C1FC}\u{0334}\u{11B5}",
        nfc: "\u{C1FC}\u{0334}\u{11B5}",
        nfd: "\u{1109}\u{116D}\u{0334}\u{11B5}",
        nfkc: "\u{C1FC}\u{0334}\u{11B5}",
        nfkd: "\u{1109}\u{116D}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C250}\u{0334}\u{11BC}",
        nfc: "\u{C250}\u{0334}\u{11BC}",
        nfd: "\u{1109}\u{1170}\u{0334}\u{11BC}",
        nfkc: "\u{C250}\u{0334}\u{11BC}",
        nfkd: "\u{1109}\u{1170}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C314}\u{0334}\u{11AE}",
        nfc: "\u{C314}\u{0334}\u{11AE}",
        nfd: "\u{110A}\u{1162}\u{0334}\u{11AE}",
        nfkc: "\u{C314}\u{0334}\u{11AE}",
        nfkd: "\u{110A}\u{1162}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C368}\u{0334}\u{11B5}",
        nfc: "\u{C368}\u{0334}\u{11B5}",
        nfd: "\u{110A}\u{1165}\u{0334}\u{11B5}",
        nfkc: "\u{C368}\u{0334}\u{11B5}",
        nfkd: "\u{110A}\u{1165}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C3BC}\u{0334}\u{11BC}",
        nfc: "\u{C3BC}\u{0334}\u{11BC}",
        nfd: "\u{110A}\u{1168}\u{0334}\u{11BC}",
        nfkc: "\u{C3BC}\u{0334}\u{11BC}",
        nfkd: "\u{110A}\u{1168}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C480}\u{0334}\u{11AE}",
        nfc: "\u{C480}\u{0334}\u{11AE}",
        nfd: "\u{110A}\u{116F}\u{0334}\u{11AE}",
        nfkc: "\u{C480}\u{0334}\u{11AE}",
        nfkd: "\u{110A}\u{116F}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C4D4}\u{0334}\u{11B5}",
        nfc: "\u{C4D4}\u{0334}\u{11B5}",
        nfd: "\u{110A}\u{1172}\u{0334}\u{11B5}",
        nfkc: "\u{C4D4}\u{0334}\u{11B5}",
        nfkd: "\u{110A}\u{1172}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C528}\u{0334}\u{11BC}",
        nfc: "\u{C528}\u{0334}\u{11BC}",
        nfd: "\u{110A}\u{1175}\u{0334}\u{11BC}",
        nfkc: "\u{C528}\u{0334}\u{11BC}",
        nfkd: "\u{110A}\u{1175}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C5EC}\u{0334}\u{11AE}",
        nfc: "\u{C5EC}\u{0334}\u{11AE}",
        nfd: "\u{110B}\u{1167}\u{0334}\u{11AE}",
        nfkc: "\u{C5EC}\u{0334}\u{11AE}",
        nfkd: "\u{110B}\u{1167}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C640}\u{0334}\u{11B5}",
        nfc: "\u{C640}\u{0334}\u{11B5}",
        nfd: "\u{110B}\u{116A}\u{0334}\u{11B5}",
        nfkc: "\u{C640}\u{0334}\u{11B5}",
        nfkd: "\u{110B}\u{116A}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C694}\u{0334}\u{11BC}",
        nfc: "\u{C694}\u{0334}\u{11BC}",
        nfd: "\u{110B}\u{116D}\u{0334}\u{11BC}",
        nfkc: "\u{C694}\u{0334}\u{11BC}",
        nfkd: "\u{110B}\u{116D}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C758}\u{0334}\u{11AE}",
        nfc: "\u{C758}\u{0334}\u{11AE}",
        nfd: "\u{110B}\u{1174}\u{0334}\u{11AE}",
        nfkc: "\u{C758}\u{0334}\u{11AE}",
        nfkd: "\u{110B}\u{1174}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C7AC}\u{0334}\u{11B5}",
        nfc: "\u{C7AC}\u{0334}\u{11B5}",
        nfd: "\u{110C}\u{1162}\u{0334}\u{11B5}",
        nfkc: "\u{C7AC}\u{0334}\u{11B5}",
        nfkd: "\u{110C}\u{1162}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C800}\u{0334}\u{11BC}",
        nfc: "\u{C800}\u{0334}\u{11BC}",
        nfd: "\u{110C}\u{1165}\u{0334}\u{11BC}",
        nfkc: "\u{C800}\u{0334}\u{11BC}",
        nfkd: "\u{110C}\u{1165}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{C8C4}\u{0334}\u{11AE}",
        nfc: "\u{C8C4}\u{0334}\u{11AE}",
        nfd: "\u{110C}\u{116C}\u{0334}\u{11AE}",
        nfkc: "\u{C8C4}\u{0334}\u{11AE}",
        nfkd: "\u{110C}\u{116C}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{C918}\u{0334}\u{11B5}",
        nfc: "\u{C918}\u{0334}\u{11B5}",
        nfd: "\u{110C}\u{116F}\u{0334}\u{11B5}",
        nfkc: "\u{C918}\u{0334}\u{11B5}",
        nfkd: "\u{110C}\u{116F}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{C96C}\u{0334}\u{11BC}",
        nfc: "\u{C96C}\u{0334}\u{11BC}",
        nfd: "\u{110C}\u{1172}\u{0334}\u{11BC}",
        nfkc: "\u{C96C}\u{0334}\u{11BC}",
        nfkd: "\u{110C}\u{1172}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CA30}\u{0334}\u{11AE}",
        nfc: "\u{CA30}\u{0334}\u{11AE}",
        nfd: "\u{110D}\u{1164}\u{0334}\u{11AE}",
        nfkc: "\u{CA30}\u{0334}\u{11AE}",
        nfkd: "\u{110D}\u{1164}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CA84}\u{0334}\u{11B5}",
        nfc: "\u{CA84}\u{0334}\u{11B5}",
        nfd: "\u{110D}\u{1167}\u{0334}\u{11B5}",
        nfkc: "\u{CA84}\u{0334}\u{11B5}",
        nfkd: "\u{110D}\u{1167}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CAD8}\u{0334}\u{11BC}",
        nfc: "\u{CAD8}\u{0334}\u{11BC}",
        nfd: "\u{110D}\u{116A}\u{0334}\u{11BC}",
        nfkc: "\u{CAD8}\u{0334}\u{11BC}",
        nfkd: "\u{110D}\u{116A}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CB9C}\u{0334}\u{11AE}",
        nfc: "\u{CB9C}\u{0334}\u{11AE}",
        nfd: "\u{110D}\u{1171}\u{0334}\u{11AE}",
        nfkc: "\u{CB9C}\u{0334}\u{11AE}",
        nfkd: "\u{110D}\u{1171}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CBF0}\u{0334}\u{11B5}",
        nfc: "\u{CBF0}\u{0334}\u{11B5}",
        nfd: "\u{110D}\u{1174}\u{0334}\u{11B5}",
        nfkc: "\u{CBF0}\u{0334}\u{11B5}",
        nfkd: "\u{110D}\u{1174}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CC44}\u{0334}\u{11BC}",
        nfc: "\u{CC44}\u{0334}\u{11BC}",
        nfd: "\u{110E}\u{1162}\u{0334}\u{11BC}",
        nfkc: "\u{CC44}\u{0334}\u{11BC}",
        nfkd: "\u{110E}\u{1162}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CD08}\u{0334}\u{11AE}",
        nfc: "\u{CD08}\u{0334}\u{11AE}",
        nfd: "\u{110E}\u{1169}\u{0334}\u{11AE}",
        nfkc: "\u{CD08}\u{0334}\u{11AE}",
        nfkd: "\u{110E}\u{1169}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CD5C}\u{0334}\u{11B5}",
        nfc: "\u{CD5C}\u{0334}\u{11B5}",
        nfd: "\u{110E}\u{116C}\u{0334}\u{11B5}",
        nfkc: "\u{CD5C}\u{0334}\u{11B5}",
        nfkd: "\u{110E}\u{116C}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CDB0}\u{0334}\u{11BC}",
        nfc: "\u{CDB0}\u{0334}\u{11BC}",
        nfd: "\u{110E}\u{116F}\u{0334}\u{11BC}",
        nfkc: "\u{CDB0}\u{0334}\u{11BC}",
        nfkd: "\u{110E}\u{116F}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CE74}\u{0334}\u{11AE}",
        nfc: "\u{CE74}\u{0334}\u{11AE}",
        nfd: "\u{110F}\u{1161}\u{0334}\u{11AE}",
        nfkc: "\u{CE74}\u{0334}\u{11AE}",
        nfkd: "\u{110F}\u{1161}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{CEC8}\u{0334}\u{11B5}",
        nfc: "\u{CEC8}\u{0334}\u{11B5}",
        nfd: "\u{110F}\u{1164}\u{0334}\u{11B5}",
        nfkc: "\u{CEC8}\u{0334}\u{11B5}",
        nfkd: "\u{110F}\u{1164}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{CF1C}\u{0334}\u{11BC}",
        nfc: "\u{CF1C}\u{0334}\u{11BC}",
        nfd: "\u{110F}\u{1167}\u{0334}\u{11BC}",
        nfkc: "\u{CF1C}\u{0334}\u{11BC}",
        nfkd: "\u{110F}\u{1167}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{CFE0}\u{0334}\u{11AE}",
        nfc: "\u{CFE0}\u{0334}\u{11AE}",
        nfd: "\u{110F}\u{116E}\u{0334}\u{11AE}",
        nfkc: "\u{CFE0}\u{0334}\u{11AE}",
        nfkd: "\u{110F}\u{116E}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D034}\u{0334}\u{11B5}",
        nfc: "\u{D034}\u{0334}\u{11B5}",
        nfd: "\u{110F}\u{1171}\u{0334}\u{11B5}",
        nfkc: "\u{D034}\u{0334}\u{11B5}",
        nfkd: "\u{110F}\u{1171}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D088}\u{0334}\u{11BC}",
        nfc: "\u{D088}\u{0334}\u{11BC}",
        nfd: "\u{110F}\u{1174}\u{0334}\u{11BC}",
        nfkc: "\u{D088}\u{0334}\u{11BC}",
        nfkd: "\u{110F}\u{1174}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D14C}\u{0334}\u{11AE}",
        nfc: "\u{D14C}\u{0334}\u{11AE}",
        nfd: "\u{1110}\u{1166}\u{0334}\u{11AE}",
        nfkc: "\u{D14C}\u{0334}\u{11AE}",
        nfkd: "\u{1110}\u{1166}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D1A0}\u{0334}\u{11B5}",
        nfc: "\u{D1A0}\u{0334}\u{11B5}",
        nfd: "\u{1110}\u{1169}\u{0334}\u{11B5}",
        nfkc: "\u{D1A0}\u{0334}\u{11B5}",
        nfkd: "\u{1110}\u{1169}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D1F4}\u{0334}\u{11BC}",
        nfc: "\u{D1F4}\u{0334}\u{11BC}",
        nfd: "\u{1110}\u{116C}\u{0334}\u{11BC}",
        nfkc: "\u{D1F4}\u{0334}\u{11BC}",
        nfkd: "\u{1110}\u{116C}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D2B8}\u{0334}\u{11AE}",
        nfc: "\u{D2B8}\u{0334}\u{11AE}",
        nfd: "\u{1110}\u{1173}\u{0334}\u{11AE}",
        nfkc: "\u{D2B8}\u{0334}\u{11AE}",
        nfkd: "\u{1110}\u{1173}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D30C}\u{0334}\u{11B5}",
        nfc: "\u{D30C}\u{0334}\u{11B5}",
        nfd: "\u{1111}\u{1161}\u{0334}\u{11B5}",
        nfkc: "\u{D30C}\u{0334}\u{11B5}",
        nfkd: "\u{1111}\u{1161}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D360}\u{0334}\u{11BC}",
        nfc: "\u{D360}\u{0334}\u{11BC}",
        nfd: "\u{1111}\u{1164}\u{0334}\u{11BC}",
        nfkc: "\u{D360}\u{0334}\u{11BC}",
        nfkd: "\u{1111}\u{1164}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D424}\u{0334}\u{11AE}",
        nfc: "\u{D424}\u{0334}\u{11AE}",
        nfd: "\u{1111}\u{116B}\u{0334}\u{11AE}",
        nfkc: "\u{D424}\u{0334}\u{11AE}",
        nfkd: "\u{1111}\u{116B}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D478}\u{0334}\u{11B5}",
        nfc: "\u{D478}\u{0334}\u{11B5}",
        nfd: "\u{1111}\u{116E}\u{0334}\u{11B5}",
        nfkc: "\u{D478}\u{0334}\u{11B5}",
        nfkd: "\u{1111}\u{116E}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D4CC}\u{0334}\u{11BC}",
        nfc: "\u{D4CC}\u{0334}\u{11BC}",
        nfd: "\u{1111}\u{1171}\u{0334}\u{11BC}",
        nfkc: "\u{D4CC}\u{0334}\u{11BC}",
        nfkd: "\u{1111}\u{1171}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D590}\u{0334}\u{11AE}",
        nfc: "\u{D590}\u{0334}\u{11AE}",
        nfd: "\u{1112}\u{1163}\u{0334}\u{11AE}",
        nfkc: "\u{D590}\u{0334}\u{11AE}",
        nfkd: "\u{1112}\u{1163}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D5E4}\u{0334}\u{11B5}",
        nfc: "\u{D5E4}\u{0334}\u{11B5}",
        nfd: "\u{1112}\u{1166}\u{0334}\u{11B5}",
        nfkc: "\u{D5E4}\u{0334}\u{11B5}",
        nfkd: "\u{1112}\u{1166}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{D638}\u{0334}\u{11BC}",
        nfc: "\u{D638}\u{0334}\u{11BC}",
        nfd: "\u{1112}\u{1169}\u{0334}\u{11BC}",
        nfkc: "\u{D638}\u{0334}\u{11BC}",
        nfkd: "\u{1112}\u{1169}\u{0334}\u{11BC}",
    },
    NormalizationTest {
        source: "\u{D6FC}\u{0334}\u{11AE}",
        nfc: "\u{D6FC}\u{0334}\u{11AE}",
        nfd: "\u{1112}\u{1170}\u{0334}\u{11AE}",
        nfkc: "\u{D6FC}\u{0334}\u{11AE}",
        nfkd: "\u{1112}\u{1170}\u{0334}\u{11AE}",
    },
    NormalizationTest {
        source: "\u{D750}\u{0334}\u{11B5}",
        nfc: "\u{D750}\u{0334}\u{11B5}",
        nfd: "\u{1112}\u{1173}\u{0334}\u{11B5}",
        nfkc: "\u{D750}\u{0334}\u{11B5}",
        nfkd: "\u{1112}\u{1173}\u{0334}\u{11B5}",
    },
    NormalizationTest {
        source: "\u{11131}\u{0334}\u{11127}",
        nfc: "\u{11131}\u{0334}\u{11127}",
        nfd: "\u{11131}\u{0334}\u{11127}",
        nfkc: "\u{11131}\u{0334}\u{11127}",
        nfkd: "\u{11131}\u{0334}\u{11127}",
    },
    NormalizationTest {
        source: "\u{11132}\u{0334}\u{11127}",
        nfc: "\u{11132}\u{0334}\u{11127}",
        nfd: "\u{11132}\u{0334}\u{11127}",
        nfkc: "\u{11132}\u{0334}\u{11127}",
        nfkd: "\u{11132}\u{0334}\u{11127}",
    },
    NormalizationTest {
        source: "\u{11347}\u{0334}\u{1133E}",
        nfc: "\u{11347}\u{0334}\u{1133E}",
        nfd: "\u{11347}\u{0334}\u{1133E}",
        nfkc: "\u{11347}\u{0334}\u{1133E}",
        nfkd: "\u{11347}\u{0334}\u{1133E}",
    },
    NormalizationTest {
        source: "\u{11347}\u{0334}\u{11357}",
        nfc: "\u{11347}\u{0334}\u{11357}",
        nfd: "\u{11347}\u{0334}\u{11357}",
        nfkc: "\u{11347}\u{0334}\u{11357}",
        nfkd: "\u{11347}\u{0334}\u{11357}",
    },
    NormalizationTest {
        source: "\u{114B9}\u{0334}\u{114B0}",
        nfc: "\u{114B9}\u{0334}\u{114B0}",
        nfd: "\u{114B9}\u{0334}\u{114B0}",
        nfkc: "\u{114B9}\u{0334}\u{114B0}",
        nfkd: "\u{114B9}\u{0334}\u{114B0}",
    },
    NormalizationTest {
        source: "\u{114B9}\u{0334}\u{114BA}",
        nfc: "\u{114B9}\u{0334}\u{114BA}",
        nfd: "\u{114B9}\u{0334}\u{114BA}",
        nfkc: "\u{114B9}\u{0334}\u{114BA}",
        nfkd: "\u{114B9}\u{0334}\u{114BA}",
    },
    NormalizationTest {
        source: "\u{114B9}\u{0334}\u{114BD}",
        nfc: "\u{114B9}\u{0334}\u{114BD}",
        nfd: "\u{114B9}\u{0334}\u{114BD}",
        nfkc: "\u{114B9}\u{0334}\u{114BD}",
        nfkd: "\u{114B9}\u{0334}\u{114BD}",
    },
    NormalizationTest {
        source: "\u{115B8}\u{0334}\u{115AF}",
        nfc: "\u{115B8}\u{0334}\u{115AF}",
        nfd: "\u{115B8}\u{0334}\u{115AF}",
        nfkc: "\u{115B8}\u{0334}\u{115AF}",
        nfkd: "\u{115B8}\u{0334}\u{115AF}",
    },
    NormalizationTest {
        source: "\u{115B9}\u{0334}\u{115AF}",
        nfc: "\u{115B9}\u{0334}\u{115AF}",
        nfd: "\u{115B9}\u{0334}\u{115AF}",
        nfkc: "\u{115B9}\u{0334}\u{115AF}",
        nfkd: "\u{115B9}\u{0334}\u{115AF}",
    },
];
